#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 13
#define STATE_COUNT 6979
#define LARGE_STATE_COUNT 2632
#define SYMBOL_COUNT 482
#define ALIAS_COUNT 2
#define TOKEN_COUNT 206
#define EXTERNAL_TOKEN_COUNT 1
#define FIELD_COUNT 25
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 216

enum {
  sym__identifier_token = 1,
  anon_sym_extern = 2,
  anon_sym_alias = 3,
  anon_sym_SEMI = 4,
  anon_sym_global = 5,
  anon_sym_using = 6,
  anon_sym_static = 7,
  anon_sym_EQ = 8,
  anon_sym_COLON_COLON = 9,
  anon_sym_LT = 10,
  anon_sym_COMMA = 11,
  anon_sym_GT = 12,
  anon_sym_DOT = 13,
  anon_sym_LBRACK = 14,
  anon_sym_RBRACK = 15,
  anon_sym_field = 16,
  anon_sym_event = 17,
  anon_sym_method = 18,
  anon_sym_param = 19,
  anon_sym_property = 20,
  anon_sym_return = 21,
  anon_sym_type = 22,
  anon_sym_COLON = 23,
  anon_sym_LPAREN = 24,
  anon_sym_RPAREN = 25,
  anon_sym_assembly = 26,
  anon_sym_module = 27,
  anon_sym_abstract = 28,
  anon_sym_async = 29,
  anon_sym_const = 30,
  anon_sym_fixed = 31,
  anon_sym_internal = 32,
  anon_sym_new = 33,
  anon_sym_override = 34,
  anon_sym_partial = 35,
  anon_sym_private = 36,
  anon_sym_protected = 37,
  anon_sym_public = 38,
  anon_sym_readonly = 39,
  anon_sym_ref = 40,
  anon_sym_sealed = 41,
  anon_sym_unsafe = 42,
  anon_sym_virtual = 43,
  anon_sym_volatile = 44,
  anon_sym_out = 45,
  anon_sym_in = 46,
  anon_sym_this = 47,
  anon_sym_params = 48,
  anon_sym_base = 49,
  anon_sym_LBRACE = 50,
  anon_sym_RBRACE = 51,
  anon_sym_EQ_GT = 52,
  anon_sym_implicit = 53,
  anon_sym_explicit = 54,
  anon_sym_operator = 55,
  anon_sym_TILDE = 56,
  anon_sym_where = 57,
  anon_sym_class = 58,
  anon_sym_QMARK = 59,
  anon_sym_struct = 60,
  anon_sym_notnull = 61,
  anon_sym_unmanaged = 62,
  anon_sym_BANG = 63,
  anon_sym_PLUS_PLUS = 64,
  anon_sym_DASH_DASH = 65,
  anon_sym_true = 66,
  anon_sym_false = 67,
  anon_sym_PLUS = 68,
  anon_sym_DASH = 69,
  anon_sym_STAR = 70,
  anon_sym_SLASH = 71,
  anon_sym_PERCENT = 72,
  anon_sym_CARET = 73,
  anon_sym_PIPE = 74,
  anon_sym_AMP = 75,
  anon_sym_LT_LT = 76,
  anon_sym_GT_GT = 77,
  anon_sym_EQ_EQ = 78,
  anon_sym_BANG_EQ = 79,
  anon_sym_GT_EQ = 80,
  anon_sym_LT_EQ = 81,
  anon_sym_get = 82,
  anon_sym_set = 83,
  anon_sym_add = 84,
  anon_sym_remove = 85,
  anon_sym_init = 86,
  anon_sym_enum = 87,
  anon_sym_interface = 88,
  anon_sym_delegate = 89,
  anon_sym_record = 90,
  anon_sym_namespace = 91,
  anon_sym_var = 92,
  anon_sym_managed = 93,
  anon_sym_Cdecl = 94,
  anon_sym_Stdcall = 95,
  anon_sym_Thiscall = 96,
  anon_sym_Fastcall = 97,
  sym_predefined_type = 98,
  anon_sym_break = 99,
  anon_sym_checked = 100,
  anon_sym_unchecked = 101,
  anon_sym_continue = 102,
  anon_sym_do = 103,
  anon_sym_while = 104,
  anon_sym_for = 105,
  anon_sym_await = 106,
  anon_sym_foreach = 107,
  anon_sym_goto = 108,
  anon_sym_case = 109,
  anon_sym_default = 110,
  anon_sym_if = 111,
  anon_sym_else = 112,
  anon_sym_lock = 113,
  anon_sym_switch = 114,
  anon_sym_not = 115,
  anon_sym_and = 116,
  anon_sym_or = 117,
  sym_discard = 118,
  anon_sym_when = 119,
  anon_sym_throw = 120,
  anon_sym_try = 121,
  anon_sym_catch = 122,
  anon_sym_finally = 123,
  anon_sym_yield = 124,
  anon_sym_PLUS_EQ = 125,
  anon_sym_DASH_EQ = 126,
  anon_sym_STAR_EQ = 127,
  anon_sym_SLASH_EQ = 128,
  anon_sym_PERCENT_EQ = 129,
  anon_sym_AMP_EQ = 130,
  anon_sym_CARET_EQ = 131,
  anon_sym_PIPE_EQ = 132,
  anon_sym_LT_LT_EQ = 133,
  anon_sym_GT_GT_EQ = 134,
  anon_sym_QMARK_QMARK_EQ = 135,
  anon_sym_stackalloc = 136,
  anon_sym_DOLLAR_DQUOTE = 137,
  anon_sym_DQUOTE = 138,
  anon_sym_DOLLAR_AT_DQUOTE = 139,
  anon_sym_AT_DOLLAR_DQUOTE = 140,
  anon_sym_LBRACE_LBRACE = 141,
  sym__interpolated_string_text_fragment = 142,
  anon_sym_DQUOTE_DQUOTE = 143,
  sym__interpolated_verbatim_string_text_fragment = 144,
  aux_sym_interpolation_format_clause_token1 = 145,
  anon_sym_is = 146,
  anon_sym___makeref = 147,
  anon_sym_DASH_GT = 148,
  anon_sym_from = 149,
  anon_sym_join = 150,
  anon_sym_on = 151,
  anon_sym_equals = 152,
  anon_sym_into = 153,
  anon_sym_let = 154,
  anon_sym_orderby = 155,
  anon_sym_ascending = 156,
  anon_sym_descending = 157,
  anon_sym_group = 158,
  anon_sym_by = 159,
  anon_sym_select = 160,
  anon_sym_DOT_DOT = 161,
  anon_sym___reftype = 162,
  anon_sym___refvalue = 163,
  anon_sym_sizeof = 164,
  anon_sym_typeof = 165,
  anon_sym_with = 166,
  anon_sym_AMP_AMP = 167,
  anon_sym_PIPE_PIPE = 168,
  anon_sym_QMARK_QMARK = 169,
  anon_sym_as = 170,
  anon_sym_SQUOTE = 171,
  aux_sym_character_literal_token1 = 172,
  sym_escape_sequence = 173,
  sym_integer_literal = 174,
  sym_null_literal = 175,
  sym_real_literal = 176,
  sym__string_literal_fragment = 177,
  sym_verbatim_string_literal = 178,
  sym_comment = 179,
  anon_sym_dynamic = 180,
  anon_sym_nameof = 181,
  sym_void_keyword = 182,
  sym__preproc_directive_start = 183,
  anon_sym_nullable = 184,
  anon_sym_disable = 185,
  anon_sym_enable = 186,
  anon_sym_restore = 187,
  anon_sym_annotations = 188,
  anon_sym_warnings = 189,
  anon_sym_define = 190,
  anon_sym_undef = 191,
  anon_sym_elif = 192,
  sym_endif_directive = 193,
  anon_sym_region = 194,
  anon_sym_endregion = 195,
  anon_sym_error = 196,
  anon_sym_warning = 197,
  anon_sym_line = 198,
  anon_sym_hidden = 199,
  anon_sym_pragma = 200,
  anon_sym_checksum = 201,
  sym_preproc_message = 202,
  sym_preproc_integer_literal = 203,
  sym_preproc_string_literal = 204,
  sym__preproc_directive_end = 205,
  sym_compilation_unit = 206,
  sym_global_statement = 207,
  sym__declaration = 208,
  sym__namespace_member_declaration = 209,
  sym__type_declaration = 210,
  sym_extern_alias_directive = 211,
  sym_using_directive = 212,
  sym_name_equals = 213,
  sym__name = 214,
  sym_alias_qualified_name = 215,
  sym__simple_name = 216,
  sym_generic_name = 217,
  sym_type_argument_list = 218,
  sym_qualified_name = 219,
  sym_attribute_list = 220,
  sym_attribute_target_specifier = 221,
  sym_attribute = 222,
  sym_attribute_argument_list = 223,
  sym_attribute_argument = 224,
  sym_global_attribute_list = 225,
  sym_name_colon = 226,
  sym_event_field_declaration = 227,
  sym_modifier = 228,
  sym_variable_declaration = 229,
  sym_variable_declarator = 230,
  sym_bracketed_argument_list = 231,
  sym_tuple_pattern = 232,
  sym_argument = 233,
  sym_equals_value_clause = 234,
  sym_field_declaration = 235,
  sym_constructor_declaration = 236,
  sym_parameter_list = 237,
  sym__formal_parameter_list = 238,
  sym_parameter = 239,
  sym__parameter_array = 240,
  sym_constructor_initializer = 241,
  sym_argument_list = 242,
  sym_block = 243,
  sym_arrow_expression_clause = 244,
  sym_conversion_operator_declaration = 245,
  sym__function_body = 246,
  sym_destructor_declaration = 247,
  sym_method_declaration = 248,
  sym_explicit_interface_specifier = 249,
  sym_type_parameter_list = 250,
  sym_type_parameter = 251,
  sym_type_parameter_constraints_clause = 252,
  sym_type_parameter_constraint = 253,
  sym_constructor_constraint = 254,
  sym_type_constraint = 255,
  sym_operator_declaration = 256,
  sym__overloadable_operator = 257,
  sym_event_declaration = 258,
  sym_accessor_list = 259,
  sym_accessor_declaration = 260,
  sym_indexer_declaration = 261,
  sym_bracketed_parameter_list = 262,
  sym_property_declaration = 263,
  sym_enum_declaration = 264,
  sym_base_list = 265,
  sym_enum_member_declaration_list = 266,
  sym_enum_member_declaration = 267,
  sym_class_declaration = 268,
  sym_declaration_list = 269,
  sym_interface_declaration = 270,
  sym_struct_declaration = 271,
  sym_delegate_declaration = 272,
  sym_record_declaration = 273,
  sym_record_struct_declaration = 274,
  sym_record_base = 275,
  sym_primary_constructor_base_type = 276,
  sym__record_body = 277,
  sym_namespace_declaration = 278,
  sym_file_scoped_namespace_declaration = 279,
  sym__type = 280,
  sym_implicit_type = 281,
  sym_array_type = 282,
  sym_array_rank_specifier = 283,
  sym_nullable_type = 284,
  sym__nullable_base_type = 285,
  sym_pointer_type = 286,
  sym_function_pointer_type = 287,
  sym_function_pointer_calling_convention = 288,
  sym_function_pointer_unmanaged_calling_convention_list = 289,
  sym_function_pointer_unmanaged_calling_convention = 290,
  sym_function_pointer_parameter = 291,
  sym_tuple_type = 292,
  sym_tuple_element = 293,
  sym__statement = 294,
  sym_break_statement = 295,
  sym_checked_statement = 296,
  sym_continue_statement = 297,
  sym_do_statement = 298,
  sym_empty_statement = 299,
  sym_expression_statement = 300,
  sym_fixed_statement = 301,
  sym_for_statement = 302,
  sym_for_each_statement = 303,
  sym_goto_statement = 304,
  sym_if_statement = 305,
  sym_labeled_statement = 306,
  sym_local_declaration_statement = 307,
  sym_local_function_statement = 308,
  sym_lock_statement = 309,
  sym_return_statement = 310,
  sym_switch_statement = 311,
  sym_switch_body = 312,
  sym_switch_section = 313,
  sym_case_pattern_switch_label = 314,
  sym__pattern = 315,
  sym_type_pattern = 316,
  sym_parenthesized_pattern = 317,
  sym_relational_pattern = 318,
  sym_negated_pattern = 319,
  sym_binary_pattern = 320,
  sym_constant_pattern = 321,
  sym_declaration_pattern = 322,
  sym__variable_designation = 323,
  sym_parenthesized_variable_designation = 324,
  sym_recursive_pattern = 325,
  sym_positional_pattern_clause = 326,
  sym_expression_colon = 327,
  sym_subpattern = 328,
  sym_property_pattern_clause = 329,
  sym_var_pattern = 330,
  sym_when_clause = 331,
  sym_case_switch_label = 332,
  sym_default_switch_label = 333,
  sym_throw_statement = 334,
  sym_try_statement = 335,
  sym_catch_clause = 336,
  sym_catch_declaration = 337,
  sym_catch_filter_clause = 338,
  sym_finally_clause = 339,
  sym_unsafe_statement = 340,
  sym_using_statement = 341,
  sym_while_statement = 342,
  sym_yield_statement = 343,
  sym_anonymous_method_expression = 344,
  sym_lambda_expression = 345,
  sym_anonymous_object_creation_expression = 346,
  sym_implicit_object_creation_expression = 347,
  sym__anonymous_object_member_declarator = 348,
  sym_array_creation_expression = 349,
  sym_initializer_expression = 350,
  sym_assignment_expression = 351,
  sym_assignment_operator = 352,
  sym_await_expression = 353,
  sym_cast_expression = 354,
  sym_checked_expression = 355,
  sym_conditional_access_expression = 356,
  sym_conditional_expression = 357,
  sym_declaration_expression = 358,
  sym_default_expression = 359,
  sym_element_access_expression = 360,
  sym_element_binding_expression = 361,
  sym_implicit_array_creation_expression = 362,
  sym_implicit_stack_alloc_array_creation_expression = 363,
  sym_base_expression = 364,
  sym_this_expression = 365,
  sym_interpolated_string_expression = 366,
  sym__interpolated_string_content = 367,
  sym__interpolated_verbatim_string_content = 368,
  sym_interpolated_string_text = 369,
  sym_interpolated_verbatim_string_text = 370,
  sym_interpolation = 371,
  sym_interpolation_alignment_clause = 372,
  sym_interpolation_format_clause = 373,
  sym_invocation_expression = 374,
  sym_is_pattern_expression = 375,
  sym_make_ref_expression = 376,
  sym_member_access_expression = 377,
  sym_member_binding_expression = 378,
  sym_object_creation_expression = 379,
  sym_parenthesized_expression = 380,
  sym_postfix_unary_expression = 381,
  sym_prefix_unary_expression = 382,
  sym_query_expression = 383,
  sym_from_clause = 384,
  sym__query_body = 385,
  sym__query_clause = 386,
  sym_join_clause = 387,
  sym_join_into_clause = 388,
  sym_let_clause = 389,
  sym_order_by_clause = 390,
  sym__ordering = 391,
  sym_where_clause = 392,
  sym__select_or_group_clause = 393,
  sym_group_clause = 394,
  sym_select_clause = 395,
  sym_query_continuation = 396,
  sym_range_expression = 397,
  sym_ref_expression = 398,
  sym_ref_type_expression = 399,
  sym_ref_value_expression = 400,
  sym_size_of_expression = 401,
  sym_stack_alloc_array_creation_expression = 402,
  sym_switch_expression = 403,
  sym_switch_expression_arm = 404,
  sym_throw_expression = 405,
  sym_tuple_expression = 406,
  sym_type_of_expression = 407,
  sym_with_expression = 408,
  sym_with_initializer_expression = 409,
  sym_simple_assignment_expression = 410,
  sym__expression = 411,
  sym_binary_expression = 412,
  sym_as_expression = 413,
  sym_is_expression = 414,
  sym_identifier = 415,
  sym_global = 416,
  sym__literal = 417,
  sym_boolean_literal = 418,
  sym_character_literal = 419,
  sym_string_literal = 420,
  sym__contextual_keywords = 421,
  sym__preprocessor_call = 422,
  sym_nullable_directive = 423,
  sym_define_directive = 424,
  sym_undef_directive = 425,
  sym_if_directive = 426,
  sym_else_directive = 427,
  sym_elif_directive = 428,
  sym_region_directive = 429,
  sym_endregion_directive = 430,
  sym_error_directive = 431,
  sym_warning_directive = 432,
  sym_line_directive = 433,
  sym_pragma_directive = 434,
  sym__preproc_expression = 435,
  sym_preproc_parenthesized_expression = 436,
  sym_preproc_unary_expression = 437,
  sym_preproc_binary_expression = 438,
  aux_sym_compilation_unit_repeat1 = 439,
  aux_sym_compilation_unit_repeat2 = 440,
  aux_sym_compilation_unit_repeat3 = 441,
  aux_sym_compilation_unit_repeat4 = 442,
  aux_sym_compilation_unit_repeat5 = 443,
  aux_sym_type_argument_list_repeat1 = 444,
  aux_sym_type_argument_list_repeat2 = 445,
  aux_sym_attribute_list_repeat1 = 446,
  aux_sym_attribute_argument_list_repeat1 = 447,
  aux_sym_event_field_declaration_repeat1 = 448,
  aux_sym_event_field_declaration_repeat2 = 449,
  aux_sym_variable_declaration_repeat1 = 450,
  aux_sym_bracketed_argument_list_repeat1 = 451,
  aux_sym_tuple_pattern_repeat1 = 452,
  aux_sym__formal_parameter_list_repeat1 = 453,
  aux_sym_block_repeat1 = 454,
  aux_sym_method_declaration_repeat1 = 455,
  aux_sym_type_parameter_list_repeat1 = 456,
  aux_sym_type_parameter_constraints_clause_repeat1 = 457,
  aux_sym_accessor_list_repeat1 = 458,
  aux_sym_enum_member_declaration_list_repeat1 = 459,
  aux_sym_declaration_list_repeat1 = 460,
  aux_sym_record_base_repeat1 = 461,
  aux_sym_file_scoped_namespace_declaration_repeat1 = 462,
  aux_sym_array_rank_specifier_repeat1 = 463,
  aux_sym_function_pointer_type_repeat1 = 464,
  aux_sym_function_pointer_unmanaged_calling_convention_list_repeat1 = 465,
  aux_sym_tuple_type_repeat1 = 466,
  aux_sym_for_statement_repeat1 = 467,
  aux_sym_switch_body_repeat1 = 468,
  aux_sym_switch_section_repeat1 = 469,
  aux_sym_parenthesized_variable_designation_repeat1 = 470,
  aux_sym_positional_pattern_clause_repeat1 = 471,
  aux_sym_try_statement_repeat1 = 472,
  aux_sym_anonymous_object_creation_expression_repeat1 = 473,
  aux_sym_interpolated_string_expression_repeat1 = 474,
  aux_sym_interpolated_string_expression_repeat2 = 475,
  aux_sym__query_body_repeat1 = 476,
  aux_sym_order_by_clause_repeat1 = 477,
  aux_sym_switch_expression_repeat1 = 478,
  aux_sym_with_initializer_expression_repeat1 = 479,
  aux_sym_string_literal_repeat1 = 480,
  aux_sym_pragma_directive_repeat1 = 481,
  alias_sym_label_name = 482,
  alias_sym_parameter_modifier = 483,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [sym__identifier_token] = "_identifier_token",
  [anon_sym_extern] = "extern",
  [anon_sym_alias] = "alias",
  [anon_sym_SEMI] = ";",
  [anon_sym_global] = "global",
  [anon_sym_using] = "using",
  [anon_sym_static] = "static",
  [anon_sym_EQ] = "=",
  [anon_sym_COLON_COLON] = "::",
  [anon_sym_LT] = "<",
  [anon_sym_COMMA] = ",",
  [anon_sym_GT] = ">",
  [anon_sym_DOT] = ".",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_field] = "field",
  [anon_sym_event] = "event",
  [anon_sym_method] = "method",
  [anon_sym_param] = "param",
  [anon_sym_property] = "property",
  [anon_sym_return] = "return",
  [anon_sym_type] = "type",
  [anon_sym_COLON] = ":",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_assembly] = "assembly",
  [anon_sym_module] = "module",
  [anon_sym_abstract] = "abstract",
  [anon_sym_async] = "async",
  [anon_sym_const] = "const",
  [anon_sym_fixed] = "fixed",
  [anon_sym_internal] = "internal",
  [anon_sym_new] = "new",
  [anon_sym_override] = "override",
  [anon_sym_partial] = "partial",
  [anon_sym_private] = "private",
  [anon_sym_protected] = "protected",
  [anon_sym_public] = "public",
  [anon_sym_readonly] = "readonly",
  [anon_sym_ref] = "ref",
  [anon_sym_sealed] = "sealed",
  [anon_sym_unsafe] = "unsafe",
  [anon_sym_virtual] = "virtual",
  [anon_sym_volatile] = "volatile",
  [anon_sym_out] = "out",
  [anon_sym_in] = "in",
  [anon_sym_this] = "this",
  [anon_sym_params] = "params",
  [anon_sym_base] = "base",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym_EQ_GT] = "=>",
  [anon_sym_implicit] = "implicit",
  [anon_sym_explicit] = "explicit",
  [anon_sym_operator] = "operator",
  [anon_sym_TILDE] = "~",
  [anon_sym_where] = "where",
  [anon_sym_class] = "class",
  [anon_sym_QMARK] = "\?",
  [anon_sym_struct] = "struct",
  [anon_sym_notnull] = "notnull",
  [anon_sym_unmanaged] = "unmanaged",
  [anon_sym_BANG] = "!",
  [anon_sym_PLUS_PLUS] = "++",
  [anon_sym_DASH_DASH] = "--",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_STAR] = "*",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_CARET] = "^",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_get] = "get",
  [anon_sym_set] = "set",
  [anon_sym_add] = "add",
  [anon_sym_remove] = "remove",
  [anon_sym_init] = "init",
  [anon_sym_enum] = "enum",
  [anon_sym_interface] = "interface",
  [anon_sym_delegate] = "delegate",
  [anon_sym_record] = "record",
  [anon_sym_namespace] = "namespace",
  [anon_sym_var] = "var",
  [anon_sym_managed] = "managed",
  [anon_sym_Cdecl] = "Cdecl",
  [anon_sym_Stdcall] = "Stdcall",
  [anon_sym_Thiscall] = "Thiscall",
  [anon_sym_Fastcall] = "Fastcall",
  [sym_predefined_type] = "predefined_type",
  [anon_sym_break] = "break",
  [anon_sym_checked] = "checked",
  [anon_sym_unchecked] = "unchecked",
  [anon_sym_continue] = "continue",
  [anon_sym_do] = "do",
  [anon_sym_while] = "while",
  [anon_sym_for] = "for",
  [anon_sym_await] = "await",
  [anon_sym_foreach] = "foreach",
  [anon_sym_goto] = "goto",
  [anon_sym_case] = "case",
  [anon_sym_default] = "default",
  [anon_sym_if] = "if",
  [anon_sym_else] = "else",
  [anon_sym_lock] = "lock",
  [anon_sym_switch] = "switch",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [sym_discard] = "discard",
  [anon_sym_when] = "when",
  [anon_sym_throw] = "throw",
  [anon_sym_try] = "try",
  [anon_sym_catch] = "catch",
  [anon_sym_finally] = "finally",
  [anon_sym_yield] = "yield",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_QMARK_QMARK_EQ] = "\?\?=",
  [anon_sym_stackalloc] = "stackalloc",
  [anon_sym_DOLLAR_DQUOTE] = "$\"",
  [anon_sym_DQUOTE] = "\"",
  [anon_sym_DOLLAR_AT_DQUOTE] = "$@\"",
  [anon_sym_AT_DOLLAR_DQUOTE] = "@$\"",
  [anon_sym_LBRACE_LBRACE] = "{{",
  [sym__interpolated_string_text_fragment] = "_interpolated_string_text_fragment",
  [anon_sym_DQUOTE_DQUOTE] = "\"\"",
  [sym__interpolated_verbatim_string_text_fragment] = "_interpolated_verbatim_string_text_fragment",
  [aux_sym_interpolation_format_clause_token1] = "interpolation_format_clause_token1",
  [anon_sym_is] = "is",
  [anon_sym___makeref] = "__makeref",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_from] = "from",
  [anon_sym_join] = "join",
  [anon_sym_on] = "on",
  [anon_sym_equals] = "equals",
  [anon_sym_into] = "into",
  [anon_sym_let] = "let",
  [anon_sym_orderby] = "orderby",
  [anon_sym_ascending] = "ascending",
  [anon_sym_descending] = "descending",
  [anon_sym_group] = "group",
  [anon_sym_by] = "by",
  [anon_sym_select] = "select",
  [anon_sym_DOT_DOT] = "..",
  [anon_sym___reftype] = "__reftype",
  [anon_sym___refvalue] = "__refvalue",
  [anon_sym_sizeof] = "sizeof",
  [anon_sym_typeof] = "typeof",
  [anon_sym_with] = "with",
  [anon_sym_AMP_AMP] = "&&",
  [anon_sym_PIPE_PIPE] = "||",
  [anon_sym_QMARK_QMARK] = "\?\?",
  [anon_sym_as] = "as",
  [anon_sym_SQUOTE] = "'",
  [aux_sym_character_literal_token1] = "character_literal_token1",
  [sym_escape_sequence] = "escape_sequence",
  [sym_integer_literal] = "integer_literal",
  [sym_null_literal] = "null_literal",
  [sym_real_literal] = "real_literal",
  [sym__string_literal_fragment] = "_string_literal_fragment",
  [sym_verbatim_string_literal] = "verbatim_string_literal",
  [sym_comment] = "comment",
  [anon_sym_dynamic] = "dynamic",
  [anon_sym_nameof] = "nameof",
  [sym_void_keyword] = "void_keyword",
  [sym__preproc_directive_start] = "_preproc_directive_start",
  [anon_sym_nullable] = "nullable",
  [anon_sym_disable] = "disable",
  [anon_sym_enable] = "enable",
  [anon_sym_restore] = "restore",
  [anon_sym_annotations] = "annotations",
  [anon_sym_warnings] = "warnings",
  [anon_sym_define] = "define",
  [anon_sym_undef] = "undef",
  [anon_sym_elif] = "elif",
  [sym_endif_directive] = "endif_directive",
  [anon_sym_region] = "region",
  [anon_sym_endregion] = "endregion",
  [anon_sym_error] = "error",
  [anon_sym_warning] = "warning",
  [anon_sym_line] = "line",
  [anon_sym_hidden] = "hidden",
  [anon_sym_pragma] = "pragma",
  [anon_sym_checksum] = "checksum",
  [sym_preproc_message] = "preproc_message",
  [sym_preproc_integer_literal] = "preproc_integer_literal",
  [sym_preproc_string_literal] = "preproc_string_literal",
  [sym__preproc_directive_end] = "_preproc_directive_end",
  [sym_compilation_unit] = "compilation_unit",
  [sym_global_statement] = "global_statement",
  [sym__declaration] = "_declaration",
  [sym__namespace_member_declaration] = "_namespace_member_declaration",
  [sym__type_declaration] = "_type_declaration",
  [sym_extern_alias_directive] = "extern_alias_directive",
  [sym_using_directive] = "using_directive",
  [sym_name_equals] = "name_equals",
  [sym__name] = "_name",
  [sym_alias_qualified_name] = "alias_qualified_name",
  [sym__simple_name] = "_simple_name",
  [sym_generic_name] = "generic_name",
  [sym_type_argument_list] = "type_argument_list",
  [sym_qualified_name] = "qualified_name",
  [sym_attribute_list] = "attribute_list",
  [sym_attribute_target_specifier] = "attribute_target_specifier",
  [sym_attribute] = "attribute",
  [sym_attribute_argument_list] = "attribute_argument_list",
  [sym_attribute_argument] = "attribute_argument",
  [sym_global_attribute_list] = "global_attribute_list",
  [sym_name_colon] = "name_colon",
  [sym_event_field_declaration] = "event_field_declaration",
  [sym_modifier] = "modifier",
  [sym_variable_declaration] = "variable_declaration",
  [sym_variable_declarator] = "variable_declarator",
  [sym_bracketed_argument_list] = "bracketed_argument_list",
  [sym_tuple_pattern] = "tuple_pattern",
  [sym_argument] = "argument",
  [sym_equals_value_clause] = "equals_value_clause",
  [sym_field_declaration] = "field_declaration",
  [sym_constructor_declaration] = "constructor_declaration",
  [sym_parameter_list] = "parameter_list",
  [sym__formal_parameter_list] = "_formal_parameter_list",
  [sym_parameter] = "parameter",
  [sym__parameter_array] = "_parameter_array",
  [sym_constructor_initializer] = "constructor_initializer",
  [sym_argument_list] = "argument_list",
  [sym_block] = "block",
  [sym_arrow_expression_clause] = "arrow_expression_clause",
  [sym_conversion_operator_declaration] = "conversion_operator_declaration",
  [sym__function_body] = "_function_body",
  [sym_destructor_declaration] = "destructor_declaration",
  [sym_method_declaration] = "method_declaration",
  [sym_explicit_interface_specifier] = "explicit_interface_specifier",
  [sym_type_parameter_list] = "type_parameter_list",
  [sym_type_parameter] = "type_parameter",
  [sym_type_parameter_constraints_clause] = "type_parameter_constraints_clause",
  [sym_type_parameter_constraint] = "type_parameter_constraint",
  [sym_constructor_constraint] = "constructor_constraint",
  [sym_type_constraint] = "type_constraint",
  [sym_operator_declaration] = "operator_declaration",
  [sym__overloadable_operator] = "_overloadable_operator",
  [sym_event_declaration] = "event_declaration",
  [sym_accessor_list] = "accessor_list",
  [sym_accessor_declaration] = "accessor_declaration",
  [sym_indexer_declaration] = "indexer_declaration",
  [sym_bracketed_parameter_list] = "bracketed_parameter_list",
  [sym_property_declaration] = "property_declaration",
  [sym_enum_declaration] = "enum_declaration",
  [sym_base_list] = "base_list",
  [sym_enum_member_declaration_list] = "enum_member_declaration_list",
  [sym_enum_member_declaration] = "enum_member_declaration",
  [sym_class_declaration] = "class_declaration",
  [sym_declaration_list] = "declaration_list",
  [sym_interface_declaration] = "interface_declaration",
  [sym_struct_declaration] = "struct_declaration",
  [sym_delegate_declaration] = "delegate_declaration",
  [sym_record_declaration] = "record_declaration",
  [sym_record_struct_declaration] = "record_struct_declaration",
  [sym_record_base] = "base_list",
  [sym_primary_constructor_base_type] = "primary_constructor_base_type",
  [sym__record_body] = "_record_body",
  [sym_namespace_declaration] = "namespace_declaration",
  [sym_file_scoped_namespace_declaration] = "file_scoped_namespace_declaration",
  [sym__type] = "_type",
  [sym_implicit_type] = "implicit_type",
  [sym_array_type] = "array_type",
  [sym_array_rank_specifier] = "array_rank_specifier",
  [sym_nullable_type] = "nullable_type",
  [sym__nullable_base_type] = "_nullable_base_type",
  [sym_pointer_type] = "pointer_type",
  [sym_function_pointer_type] = "function_pointer_type",
  [sym_function_pointer_calling_convention] = "function_pointer_calling_convention",
  [sym_function_pointer_unmanaged_calling_convention_list] = "function_pointer_unmanaged_calling_convention_list",
  [sym_function_pointer_unmanaged_calling_convention] = "function_pointer_unmanaged_calling_convention",
  [sym_function_pointer_parameter] = "function_pointer_parameter",
  [sym_tuple_type] = "tuple_type",
  [sym_tuple_element] = "tuple_element",
  [sym__statement] = "_statement",
  [sym_break_statement] = "break_statement",
  [sym_checked_statement] = "checked_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_do_statement] = "do_statement",
  [sym_empty_statement] = "empty_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_fixed_statement] = "fixed_statement",
  [sym_for_statement] = "for_statement",
  [sym_for_each_statement] = "for_each_statement",
  [sym_goto_statement] = "goto_statement",
  [sym_if_statement] = "if_statement",
  [sym_labeled_statement] = "labeled_statement",
  [sym_local_declaration_statement] = "local_declaration_statement",
  [sym_local_function_statement] = "local_function_statement",
  [sym_lock_statement] = "lock_statement",
  [sym_return_statement] = "return_statement",
  [sym_switch_statement] = "switch_statement",
  [sym_switch_body] = "switch_body",
  [sym_switch_section] = "switch_section",
  [sym_case_pattern_switch_label] = "case_pattern_switch_label",
  [sym__pattern] = "_pattern",
  [sym_type_pattern] = "type_pattern",
  [sym_parenthesized_pattern] = "parenthesized_pattern",
  [sym_relational_pattern] = "relational_pattern",
  [sym_negated_pattern] = "negated_pattern",
  [sym_binary_pattern] = "binary_pattern",
  [sym_constant_pattern] = "constant_pattern",
  [sym_declaration_pattern] = "declaration_pattern",
  [sym__variable_designation] = "_variable_designation",
  [sym_parenthesized_variable_designation] = "parenthesized_variable_designation",
  [sym_recursive_pattern] = "recursive_pattern",
  [sym_positional_pattern_clause] = "positional_pattern_clause",
  [sym_expression_colon] = "expression_colon",
  [sym_subpattern] = "subpattern",
  [sym_property_pattern_clause] = "property_pattern_clause",
  [sym_var_pattern] = "var_pattern",
  [sym_when_clause] = "when_clause",
  [sym_case_switch_label] = "case_switch_label",
  [sym_default_switch_label] = "default_switch_label",
  [sym_throw_statement] = "throw_statement",
  [sym_try_statement] = "try_statement",
  [sym_catch_clause] = "catch_clause",
  [sym_catch_declaration] = "catch_declaration",
  [sym_catch_filter_clause] = "catch_filter_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_unsafe_statement] = "unsafe_statement",
  [sym_using_statement] = "using_statement",
  [sym_while_statement] = "while_statement",
  [sym_yield_statement] = "yield_statement",
  [sym_anonymous_method_expression] = "anonymous_method_expression",
  [sym_lambda_expression] = "lambda_expression",
  [sym_anonymous_object_creation_expression] = "anonymous_object_creation_expression",
  [sym_implicit_object_creation_expression] = "implicit_object_creation_expression",
  [sym__anonymous_object_member_declarator] = "_anonymous_object_member_declarator",
  [sym_array_creation_expression] = "array_creation_expression",
  [sym_initializer_expression] = "initializer_expression",
  [sym_assignment_expression] = "assignment_expression",
  [sym_assignment_operator] = "assignment_operator",
  [sym_await_expression] = "await_expression",
  [sym_cast_expression] = "cast_expression",
  [sym_checked_expression] = "checked_expression",
  [sym_conditional_access_expression] = "conditional_access_expression",
  [sym_conditional_expression] = "conditional_expression",
  [sym_declaration_expression] = "declaration_expression",
  [sym_default_expression] = "default_expression",
  [sym_element_access_expression] = "element_access_expression",
  [sym_element_binding_expression] = "element_binding_expression",
  [sym_implicit_array_creation_expression] = "implicit_array_creation_expression",
  [sym_implicit_stack_alloc_array_creation_expression] = "implicit_stack_alloc_array_creation_expression",
  [sym_base_expression] = "base_expression",
  [sym_this_expression] = "this_expression",
  [sym_interpolated_string_expression] = "interpolated_string_expression",
  [sym__interpolated_string_content] = "_interpolated_string_content",
  [sym__interpolated_verbatim_string_content] = "_interpolated_verbatim_string_content",
  [sym_interpolated_string_text] = "interpolated_string_text",
  [sym_interpolated_verbatim_string_text] = "interpolated_verbatim_string_text",
  [sym_interpolation] = "interpolation",
  [sym_interpolation_alignment_clause] = "interpolation_alignment_clause",
  [sym_interpolation_format_clause] = "interpolation_format_clause",
  [sym_invocation_expression] = "invocation_expression",
  [sym_is_pattern_expression] = "is_pattern_expression",
  [sym_make_ref_expression] = "make_ref_expression",
  [sym_member_access_expression] = "member_access_expression",
  [sym_member_binding_expression] = "member_binding_expression",
  [sym_object_creation_expression] = "object_creation_expression",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_postfix_unary_expression] = "postfix_unary_expression",
  [sym_prefix_unary_expression] = "prefix_unary_expression",
  [sym_query_expression] = "query_expression",
  [sym_from_clause] = "from_clause",
  [sym__query_body] = "_query_body",
  [sym__query_clause] = "_query_clause",
  [sym_join_clause] = "join_clause",
  [sym_join_into_clause] = "join_into_clause",
  [sym_let_clause] = "let_clause",
  [sym_order_by_clause] = "order_by_clause",
  [sym__ordering] = "_ordering",
  [sym_where_clause] = "where_clause",
  [sym__select_or_group_clause] = "_select_or_group_clause",
  [sym_group_clause] = "group_clause",
  [sym_select_clause] = "select_clause",
  [sym_query_continuation] = "query_continuation",
  [sym_range_expression] = "range_expression",
  [sym_ref_expression] = "ref_expression",
  [sym_ref_type_expression] = "ref_type_expression",
  [sym_ref_value_expression] = "ref_value_expression",
  [sym_size_of_expression] = "size_of_expression",
  [sym_stack_alloc_array_creation_expression] = "stack_alloc_array_creation_expression",
  [sym_switch_expression] = "switch_expression",
  [sym_switch_expression_arm] = "switch_expression_arm",
  [sym_throw_expression] = "throw_expression",
  [sym_tuple_expression] = "tuple_expression",
  [sym_type_of_expression] = "type_of_expression",
  [sym_with_expression] = "with_expression",
  [sym_with_initializer_expression] = "with_initializer_expression",
  [sym_simple_assignment_expression] = "simple_assignment_expression",
  [sym__expression] = "_expression",
  [sym_binary_expression] = "binary_expression",
  [sym_as_expression] = "as_expression",
  [sym_is_expression] = "is_expression",
  [sym_identifier] = "identifier",
  [sym_global] = "global",
  [sym__literal] = "_literal",
  [sym_boolean_literal] = "boolean_literal",
  [sym_character_literal] = "character_literal",
  [sym_string_literal] = "string_literal",
  [sym__contextual_keywords] = "_contextual_keywords",
  [sym__preprocessor_call] = "_preprocessor_call",
  [sym_nullable_directive] = "nullable_directive",
  [sym_define_directive] = "define_directive",
  [sym_undef_directive] = "undef_directive",
  [sym_if_directive] = "if_directive",
  [sym_else_directive] = "else_directive",
  [sym_elif_directive] = "elif_directive",
  [sym_region_directive] = "region_directive",
  [sym_endregion_directive] = "endregion_directive",
  [sym_error_directive] = "error_directive",
  [sym_warning_directive] = "warning_directive",
  [sym_line_directive] = "line_directive",
  [sym_pragma_directive] = "pragma_directive",
  [sym__preproc_expression] = "_preproc_expression",
  [sym_preproc_parenthesized_expression] = "parenthesized_expression",
  [sym_preproc_unary_expression] = "prefix_unary_expression",
  [sym_preproc_binary_expression] = "binary_expression",
  [aux_sym_compilation_unit_repeat1] = "compilation_unit_repeat1",
  [aux_sym_compilation_unit_repeat2] = "compilation_unit_repeat2",
  [aux_sym_compilation_unit_repeat3] = "compilation_unit_repeat3",
  [aux_sym_compilation_unit_repeat4] = "compilation_unit_repeat4",
  [aux_sym_compilation_unit_repeat5] = "compilation_unit_repeat5",
  [aux_sym_type_argument_list_repeat1] = "type_argument_list_repeat1",
  [aux_sym_type_argument_list_repeat2] = "type_argument_list_repeat2",
  [aux_sym_attribute_list_repeat1] = "attribute_list_repeat1",
  [aux_sym_attribute_argument_list_repeat1] = "attribute_argument_list_repeat1",
  [aux_sym_event_field_declaration_repeat1] = "event_field_declaration_repeat1",
  [aux_sym_event_field_declaration_repeat2] = "event_field_declaration_repeat2",
  [aux_sym_variable_declaration_repeat1] = "variable_declaration_repeat1",
  [aux_sym_bracketed_argument_list_repeat1] = "bracketed_argument_list_repeat1",
  [aux_sym_tuple_pattern_repeat1] = "tuple_pattern_repeat1",
  [aux_sym__formal_parameter_list_repeat1] = "_formal_parameter_list_repeat1",
  [aux_sym_block_repeat1] = "block_repeat1",
  [aux_sym_method_declaration_repeat1] = "method_declaration_repeat1",
  [aux_sym_type_parameter_list_repeat1] = "type_parameter_list_repeat1",
  [aux_sym_type_parameter_constraints_clause_repeat1] = "type_parameter_constraints_clause_repeat1",
  [aux_sym_accessor_list_repeat1] = "accessor_list_repeat1",
  [aux_sym_enum_member_declaration_list_repeat1] = "enum_member_declaration_list_repeat1",
  [aux_sym_declaration_list_repeat1] = "declaration_list_repeat1",
  [aux_sym_record_base_repeat1] = "record_base_repeat1",
  [aux_sym_file_scoped_namespace_declaration_repeat1] = "file_scoped_namespace_declaration_repeat1",
  [aux_sym_array_rank_specifier_repeat1] = "array_rank_specifier_repeat1",
  [aux_sym_function_pointer_type_repeat1] = "function_pointer_type_repeat1",
  [aux_sym_function_pointer_unmanaged_calling_convention_list_repeat1] = "function_pointer_unmanaged_calling_convention_list_repeat1",
  [aux_sym_tuple_type_repeat1] = "tuple_type_repeat1",
  [aux_sym_for_statement_repeat1] = "for_statement_repeat1",
  [aux_sym_switch_body_repeat1] = "switch_body_repeat1",
  [aux_sym_switch_section_repeat1] = "switch_section_repeat1",
  [aux_sym_parenthesized_variable_designation_repeat1] = "parenthesized_variable_designation_repeat1",
  [aux_sym_positional_pattern_clause_repeat1] = "positional_pattern_clause_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_anonymous_object_creation_expression_repeat1] = "anonymous_object_creation_expression_repeat1",
  [aux_sym_interpolated_string_expression_repeat1] = "interpolated_string_expression_repeat1",
  [aux_sym_interpolated_string_expression_repeat2] = "interpolated_string_expression_repeat2",
  [aux_sym__query_body_repeat1] = "_query_body_repeat1",
  [aux_sym_order_by_clause_repeat1] = "order_by_clause_repeat1",
  [aux_sym_switch_expression_repeat1] = "switch_expression_repeat1",
  [aux_sym_with_initializer_expression_repeat1] = "with_initializer_expression_repeat1",
  [aux_sym_string_literal_repeat1] = "string_literal_repeat1",
  [aux_sym_pragma_directive_repeat1] = "pragma_directive_repeat1",
  [alias_sym_label_name] = "label_name",
  [alias_sym_parameter_modifier] = "parameter_modifier",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [sym__identifier_token] = sym__identifier_token,
  [anon_sym_extern] = anon_sym_extern,
  [anon_sym_alias] = anon_sym_alias,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_global] = anon_sym_global,
  [anon_sym_using] = anon_sym_using,
  [anon_sym_static] = anon_sym_static,
  [anon_sym_EQ] = anon_sym_EQ,
  [anon_sym_COLON_COLON] = anon_sym_COLON_COLON,
  [anon_sym_LT] = anon_sym_LT,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_GT] = anon_sym_GT,
  [anon_sym_DOT] = anon_sym_DOT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_field] = anon_sym_field,
  [anon_sym_event] = anon_sym_event,
  [anon_sym_method] = anon_sym_method,
  [anon_sym_param] = anon_sym_param,
  [anon_sym_property] = anon_sym_property,
  [anon_sym_return] = anon_sym_return,
  [anon_sym_type] = anon_sym_type,
  [anon_sym_COLON] = anon_sym_COLON,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_assembly] = anon_sym_assembly,
  [anon_sym_module] = anon_sym_module,
  [anon_sym_abstract] = anon_sym_abstract,
  [anon_sym_async] = anon_sym_async,
  [anon_sym_const] = anon_sym_const,
  [anon_sym_fixed] = anon_sym_fixed,
  [anon_sym_internal] = anon_sym_internal,
  [anon_sym_new] = anon_sym_new,
  [anon_sym_override] = anon_sym_override,
  [anon_sym_partial] = anon_sym_partial,
  [anon_sym_private] = anon_sym_private,
  [anon_sym_protected] = anon_sym_protected,
  [anon_sym_public] = anon_sym_public,
  [anon_sym_readonly] = anon_sym_readonly,
  [anon_sym_ref] = anon_sym_ref,
  [anon_sym_sealed] = anon_sym_sealed,
  [anon_sym_unsafe] = anon_sym_unsafe,
  [anon_sym_virtual] = anon_sym_virtual,
  [anon_sym_volatile] = anon_sym_volatile,
  [anon_sym_out] = anon_sym_out,
  [anon_sym_in] = anon_sym_in,
  [anon_sym_this] = anon_sym_this,
  [anon_sym_params] = anon_sym_params,
  [anon_sym_base] = anon_sym_base,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym_EQ_GT] = anon_sym_EQ_GT,
  [anon_sym_implicit] = anon_sym_implicit,
  [anon_sym_explicit] = anon_sym_explicit,
  [anon_sym_operator] = anon_sym_operator,
  [anon_sym_TILDE] = anon_sym_TILDE,
  [anon_sym_where] = anon_sym_where,
  [anon_sym_class] = anon_sym_class,
  [anon_sym_QMARK] = anon_sym_QMARK,
  [anon_sym_struct] = anon_sym_struct,
  [anon_sym_notnull] = anon_sym_notnull,
  [anon_sym_unmanaged] = anon_sym_unmanaged,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_DASH_DASH] = anon_sym_DASH_DASH,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [anon_sym_PLUS] = anon_sym_PLUS,
  [anon_sym_DASH] = anon_sym_DASH,
  [anon_sym_STAR] = anon_sym_STAR,
  [anon_sym_SLASH] = anon_sym_SLASH,
  [anon_sym_PERCENT] = anon_sym_PERCENT,
  [anon_sym_CARET] = anon_sym_CARET,
  [anon_sym_PIPE] = anon_sym_PIPE,
  [anon_sym_AMP] = anon_sym_AMP,
  [anon_sym_LT_LT] = anon_sym_LT_LT,
  [anon_sym_GT_GT] = anon_sym_GT_GT,
  [anon_sym_EQ_EQ] = anon_sym_EQ_EQ,
  [anon_sym_BANG_EQ] = anon_sym_BANG_EQ,
  [anon_sym_GT_EQ] = anon_sym_GT_EQ,
  [anon_sym_LT_EQ] = anon_sym_LT_EQ,
  [anon_sym_get] = anon_sym_get,
  [anon_sym_set] = anon_sym_set,
  [anon_sym_add] = anon_sym_add,
  [anon_sym_remove] = anon_sym_remove,
  [anon_sym_init] = anon_sym_init,
  [anon_sym_enum] = anon_sym_enum,
  [anon_sym_interface] = anon_sym_interface,
  [anon_sym_delegate] = anon_sym_delegate,
  [anon_sym_record] = anon_sym_record,
  [anon_sym_namespace] = anon_sym_namespace,
  [anon_sym_var] = anon_sym_var,
  [anon_sym_managed] = anon_sym_managed,
  [anon_sym_Cdecl] = anon_sym_Cdecl,
  [anon_sym_Stdcall] = anon_sym_Stdcall,
  [anon_sym_Thiscall] = anon_sym_Thiscall,
  [anon_sym_Fastcall] = anon_sym_Fastcall,
  [sym_predefined_type] = sym_predefined_type,
  [anon_sym_break] = anon_sym_break,
  [anon_sym_checked] = anon_sym_checked,
  [anon_sym_unchecked] = anon_sym_unchecked,
  [anon_sym_continue] = anon_sym_continue,
  [anon_sym_do] = anon_sym_do,
  [anon_sym_while] = anon_sym_while,
  [anon_sym_for] = anon_sym_for,
  [anon_sym_await] = anon_sym_await,
  [anon_sym_foreach] = anon_sym_foreach,
  [anon_sym_goto] = anon_sym_goto,
  [anon_sym_case] = anon_sym_case,
  [anon_sym_default] = anon_sym_default,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_lock] = anon_sym_lock,
  [anon_sym_switch] = anon_sym_switch,
  [anon_sym_not] = anon_sym_not,
  [anon_sym_and] = anon_sym_and,
  [anon_sym_or] = anon_sym_or,
  [sym_discard] = sym_discard,
  [anon_sym_when] = anon_sym_when,
  [anon_sym_throw] = anon_sym_throw,
  [anon_sym_try] = anon_sym_try,
  [anon_sym_catch] = anon_sym_catch,
  [anon_sym_finally] = anon_sym_finally,
  [anon_sym_yield] = anon_sym_yield,
  [anon_sym_PLUS_EQ] = anon_sym_PLUS_EQ,
  [anon_sym_DASH_EQ] = anon_sym_DASH_EQ,
  [anon_sym_STAR_EQ] = anon_sym_STAR_EQ,
  [anon_sym_SLASH_EQ] = anon_sym_SLASH_EQ,
  [anon_sym_PERCENT_EQ] = anon_sym_PERCENT_EQ,
  [anon_sym_AMP_EQ] = anon_sym_AMP_EQ,
  [anon_sym_CARET_EQ] = anon_sym_CARET_EQ,
  [anon_sym_PIPE_EQ] = anon_sym_PIPE_EQ,
  [anon_sym_LT_LT_EQ] = anon_sym_LT_LT_EQ,
  [anon_sym_GT_GT_EQ] = anon_sym_GT_GT_EQ,
  [anon_sym_QMARK_QMARK_EQ] = anon_sym_QMARK_QMARK_EQ,
  [anon_sym_stackalloc] = anon_sym_stackalloc,
  [anon_sym_DOLLAR_DQUOTE] = anon_sym_DOLLAR_DQUOTE,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [anon_sym_DOLLAR_AT_DQUOTE] = anon_sym_DOLLAR_AT_DQUOTE,
  [anon_sym_AT_DOLLAR_DQUOTE] = anon_sym_AT_DOLLAR_DQUOTE,
  [anon_sym_LBRACE_LBRACE] = anon_sym_LBRACE_LBRACE,
  [sym__interpolated_string_text_fragment] = sym__interpolated_string_text_fragment,
  [anon_sym_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE,
  [sym__interpolated_verbatim_string_text_fragment] = sym__interpolated_verbatim_string_text_fragment,
  [aux_sym_interpolation_format_clause_token1] = aux_sym_interpolation_format_clause_token1,
  [anon_sym_is] = anon_sym_is,
  [anon_sym___makeref] = anon_sym___makeref,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_from] = anon_sym_from,
  [anon_sym_join] = anon_sym_join,
  [anon_sym_on] = anon_sym_on,
  [anon_sym_equals] = anon_sym_equals,
  [anon_sym_into] = anon_sym_into,
  [anon_sym_let] = anon_sym_let,
  [anon_sym_orderby] = anon_sym_orderby,
  [anon_sym_ascending] = anon_sym_ascending,
  [anon_sym_descending] = anon_sym_descending,
  [anon_sym_group] = anon_sym_group,
  [anon_sym_by] = anon_sym_by,
  [anon_sym_select] = anon_sym_select,
  [anon_sym_DOT_DOT] = anon_sym_DOT_DOT,
  [anon_sym___reftype] = anon_sym___reftype,
  [anon_sym___refvalue] = anon_sym___refvalue,
  [anon_sym_sizeof] = anon_sym_sizeof,
  [anon_sym_typeof] = anon_sym_typeof,
  [anon_sym_with] = anon_sym_with,
  [anon_sym_AMP_AMP] = anon_sym_AMP_AMP,
  [anon_sym_PIPE_PIPE] = anon_sym_PIPE_PIPE,
  [anon_sym_QMARK_QMARK] = anon_sym_QMARK_QMARK,
  [anon_sym_as] = anon_sym_as,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [aux_sym_character_literal_token1] = aux_sym_character_literal_token1,
  [sym_escape_sequence] = sym_escape_sequence,
  [sym_integer_literal] = sym_integer_literal,
  [sym_null_literal] = sym_null_literal,
  [sym_real_literal] = sym_real_literal,
  [sym__string_literal_fragment] = sym__string_literal_fragment,
  [sym_verbatim_string_literal] = sym_verbatim_string_literal,
  [sym_comment] = sym_comment,
  [anon_sym_dynamic] = anon_sym_dynamic,
  [anon_sym_nameof] = anon_sym_nameof,
  [sym_void_keyword] = sym_void_keyword,
  [sym__preproc_directive_start] = sym__preproc_directive_start,
  [anon_sym_nullable] = anon_sym_nullable,
  [anon_sym_disable] = anon_sym_disable,
  [anon_sym_enable] = anon_sym_enable,
  [anon_sym_restore] = anon_sym_restore,
  [anon_sym_annotations] = anon_sym_annotations,
  [anon_sym_warnings] = anon_sym_warnings,
  [anon_sym_define] = anon_sym_define,
  [anon_sym_undef] = anon_sym_undef,
  [anon_sym_elif] = anon_sym_elif,
  [sym_endif_directive] = sym_endif_directive,
  [anon_sym_region] = anon_sym_region,
  [anon_sym_endregion] = anon_sym_endregion,
  [anon_sym_error] = anon_sym_error,
  [anon_sym_warning] = anon_sym_warning,
  [anon_sym_line] = anon_sym_line,
  [anon_sym_hidden] = anon_sym_hidden,
  [anon_sym_pragma] = anon_sym_pragma,
  [anon_sym_checksum] = anon_sym_checksum,
  [sym_preproc_message] = sym_preproc_message,
  [sym_preproc_integer_literal] = sym_preproc_integer_literal,
  [sym_preproc_string_literal] = sym_preproc_string_literal,
  [sym__preproc_directive_end] = sym__preproc_directive_end,
  [sym_compilation_unit] = sym_compilation_unit,
  [sym_global_statement] = sym_global_statement,
  [sym__declaration] = sym__declaration,
  [sym__namespace_member_declaration] = sym__namespace_member_declaration,
  [sym__type_declaration] = sym__type_declaration,
  [sym_extern_alias_directive] = sym_extern_alias_directive,
  [sym_using_directive] = sym_using_directive,
  [sym_name_equals] = sym_name_equals,
  [sym__name] = sym__name,
  [sym_alias_qualified_name] = sym_alias_qualified_name,
  [sym__simple_name] = sym__simple_name,
  [sym_generic_name] = sym_generic_name,
  [sym_type_argument_list] = sym_type_argument_list,
  [sym_qualified_name] = sym_qualified_name,
  [sym_attribute_list] = sym_attribute_list,
  [sym_attribute_target_specifier] = sym_attribute_target_specifier,
  [sym_attribute] = sym_attribute,
  [sym_attribute_argument_list] = sym_attribute_argument_list,
  [sym_attribute_argument] = sym_attribute_argument,
  [sym_global_attribute_list] = sym_global_attribute_list,
  [sym_name_colon] = sym_name_colon,
  [sym_event_field_declaration] = sym_event_field_declaration,
  [sym_modifier] = sym_modifier,
  [sym_variable_declaration] = sym_variable_declaration,
  [sym_variable_declarator] = sym_variable_declarator,
  [sym_bracketed_argument_list] = sym_bracketed_argument_list,
  [sym_tuple_pattern] = sym_tuple_pattern,
  [sym_argument] = sym_argument,
  [sym_equals_value_clause] = sym_equals_value_clause,
  [sym_field_declaration] = sym_field_declaration,
  [sym_constructor_declaration] = sym_constructor_declaration,
  [sym_parameter_list] = sym_parameter_list,
  [sym__formal_parameter_list] = sym__formal_parameter_list,
  [sym_parameter] = sym_parameter,
  [sym__parameter_array] = sym__parameter_array,
  [sym_constructor_initializer] = sym_constructor_initializer,
  [sym_argument_list] = sym_argument_list,
  [sym_block] = sym_block,
  [sym_arrow_expression_clause] = sym_arrow_expression_clause,
  [sym_conversion_operator_declaration] = sym_conversion_operator_declaration,
  [sym__function_body] = sym__function_body,
  [sym_destructor_declaration] = sym_destructor_declaration,
  [sym_method_declaration] = sym_method_declaration,
  [sym_explicit_interface_specifier] = sym_explicit_interface_specifier,
  [sym_type_parameter_list] = sym_type_parameter_list,
  [sym_type_parameter] = sym_type_parameter,
  [sym_type_parameter_constraints_clause] = sym_type_parameter_constraints_clause,
  [sym_type_parameter_constraint] = sym_type_parameter_constraint,
  [sym_constructor_constraint] = sym_constructor_constraint,
  [sym_type_constraint] = sym_type_constraint,
  [sym_operator_declaration] = sym_operator_declaration,
  [sym__overloadable_operator] = sym__overloadable_operator,
  [sym_event_declaration] = sym_event_declaration,
  [sym_accessor_list] = sym_accessor_list,
  [sym_accessor_declaration] = sym_accessor_declaration,
  [sym_indexer_declaration] = sym_indexer_declaration,
  [sym_bracketed_parameter_list] = sym_bracketed_parameter_list,
  [sym_property_declaration] = sym_property_declaration,
  [sym_enum_declaration] = sym_enum_declaration,
  [sym_base_list] = sym_base_list,
  [sym_enum_member_declaration_list] = sym_enum_member_declaration_list,
  [sym_enum_member_declaration] = sym_enum_member_declaration,
  [sym_class_declaration] = sym_class_declaration,
  [sym_declaration_list] = sym_declaration_list,
  [sym_interface_declaration] = sym_interface_declaration,
  [sym_struct_declaration] = sym_struct_declaration,
  [sym_delegate_declaration] = sym_delegate_declaration,
  [sym_record_declaration] = sym_record_declaration,
  [sym_record_struct_declaration] = sym_record_struct_declaration,
  [sym_record_base] = sym_base_list,
  [sym_primary_constructor_base_type] = sym_primary_constructor_base_type,
  [sym__record_body] = sym__record_body,
  [sym_namespace_declaration] = sym_namespace_declaration,
  [sym_file_scoped_namespace_declaration] = sym_file_scoped_namespace_declaration,
  [sym__type] = sym__type,
  [sym_implicit_type] = sym_implicit_type,
  [sym_array_type] = sym_array_type,
  [sym_array_rank_specifier] = sym_array_rank_specifier,
  [sym_nullable_type] = sym_nullable_type,
  [sym__nullable_base_type] = sym__nullable_base_type,
  [sym_pointer_type] = sym_pointer_type,
  [sym_function_pointer_type] = sym_function_pointer_type,
  [sym_function_pointer_calling_convention] = sym_function_pointer_calling_convention,
  [sym_function_pointer_unmanaged_calling_convention_list] = sym_function_pointer_unmanaged_calling_convention_list,
  [sym_function_pointer_unmanaged_calling_convention] = sym_function_pointer_unmanaged_calling_convention,
  [sym_function_pointer_parameter] = sym_function_pointer_parameter,
  [sym_tuple_type] = sym_tuple_type,
  [sym_tuple_element] = sym_tuple_element,
  [sym__statement] = sym__statement,
  [sym_break_statement] = sym_break_statement,
  [sym_checked_statement] = sym_checked_statement,
  [sym_continue_statement] = sym_continue_statement,
  [sym_do_statement] = sym_do_statement,
  [sym_empty_statement] = sym_empty_statement,
  [sym_expression_statement] = sym_expression_statement,
  [sym_fixed_statement] = sym_fixed_statement,
  [sym_for_statement] = sym_for_statement,
  [sym_for_each_statement] = sym_for_each_statement,
  [sym_goto_statement] = sym_goto_statement,
  [sym_if_statement] = sym_if_statement,
  [sym_labeled_statement] = sym_labeled_statement,
  [sym_local_declaration_statement] = sym_local_declaration_statement,
  [sym_local_function_statement] = sym_local_function_statement,
  [sym_lock_statement] = sym_lock_statement,
  [sym_return_statement] = sym_return_statement,
  [sym_switch_statement] = sym_switch_statement,
  [sym_switch_body] = sym_switch_body,
  [sym_switch_section] = sym_switch_section,
  [sym_case_pattern_switch_label] = sym_case_pattern_switch_label,
  [sym__pattern] = sym__pattern,
  [sym_type_pattern] = sym_type_pattern,
  [sym_parenthesized_pattern] = sym_parenthesized_pattern,
  [sym_relational_pattern] = sym_relational_pattern,
  [sym_negated_pattern] = sym_negated_pattern,
  [sym_binary_pattern] = sym_binary_pattern,
  [sym_constant_pattern] = sym_constant_pattern,
  [sym_declaration_pattern] = sym_declaration_pattern,
  [sym__variable_designation] = sym__variable_designation,
  [sym_parenthesized_variable_designation] = sym_parenthesized_variable_designation,
  [sym_recursive_pattern] = sym_recursive_pattern,
  [sym_positional_pattern_clause] = sym_positional_pattern_clause,
  [sym_expression_colon] = sym_expression_colon,
  [sym_subpattern] = sym_subpattern,
  [sym_property_pattern_clause] = sym_property_pattern_clause,
  [sym_var_pattern] = sym_var_pattern,
  [sym_when_clause] = sym_when_clause,
  [sym_case_switch_label] = sym_case_switch_label,
  [sym_default_switch_label] = sym_default_switch_label,
  [sym_throw_statement] = sym_throw_statement,
  [sym_try_statement] = sym_try_statement,
  [sym_catch_clause] = sym_catch_clause,
  [sym_catch_declaration] = sym_catch_declaration,
  [sym_catch_filter_clause] = sym_catch_filter_clause,
  [sym_finally_clause] = sym_finally_clause,
  [sym_unsafe_statement] = sym_unsafe_statement,
  [sym_using_statement] = sym_using_statement,
  [sym_while_statement] = sym_while_statement,
  [sym_yield_statement] = sym_yield_statement,
  [sym_anonymous_method_expression] = sym_anonymous_method_expression,
  [sym_lambda_expression] = sym_lambda_expression,
  [sym_anonymous_object_creation_expression] = sym_anonymous_object_creation_expression,
  [sym_implicit_object_creation_expression] = sym_implicit_object_creation_expression,
  [sym__anonymous_object_member_declarator] = sym__anonymous_object_member_declarator,
  [sym_array_creation_expression] = sym_array_creation_expression,
  [sym_initializer_expression] = sym_initializer_expression,
  [sym_assignment_expression] = sym_assignment_expression,
  [sym_assignment_operator] = sym_assignment_operator,
  [sym_await_expression] = sym_await_expression,
  [sym_cast_expression] = sym_cast_expression,
  [sym_checked_expression] = sym_checked_expression,
  [sym_conditional_access_expression] = sym_conditional_access_expression,
  [sym_conditional_expression] = sym_conditional_expression,
  [sym_declaration_expression] = sym_declaration_expression,
  [sym_default_expression] = sym_default_expression,
  [sym_element_access_expression] = sym_element_access_expression,
  [sym_element_binding_expression] = sym_element_binding_expression,
  [sym_implicit_array_creation_expression] = sym_implicit_array_creation_expression,
  [sym_implicit_stack_alloc_array_creation_expression] = sym_implicit_stack_alloc_array_creation_expression,
  [sym_base_expression] = sym_base_expression,
  [sym_this_expression] = sym_this_expression,
  [sym_interpolated_string_expression] = sym_interpolated_string_expression,
  [sym__interpolated_string_content] = sym__interpolated_string_content,
  [sym__interpolated_verbatim_string_content] = sym__interpolated_verbatim_string_content,
  [sym_interpolated_string_text] = sym_interpolated_string_text,
  [sym_interpolated_verbatim_string_text] = sym_interpolated_verbatim_string_text,
  [sym_interpolation] = sym_interpolation,
  [sym_interpolation_alignment_clause] = sym_interpolation_alignment_clause,
  [sym_interpolation_format_clause] = sym_interpolation_format_clause,
  [sym_invocation_expression] = sym_invocation_expression,
  [sym_is_pattern_expression] = sym_is_pattern_expression,
  [sym_make_ref_expression] = sym_make_ref_expression,
  [sym_member_access_expression] = sym_member_access_expression,
  [sym_member_binding_expression] = sym_member_binding_expression,
  [sym_object_creation_expression] = sym_object_creation_expression,
  [sym_parenthesized_expression] = sym_parenthesized_expression,
  [sym_postfix_unary_expression] = sym_postfix_unary_expression,
  [sym_prefix_unary_expression] = sym_prefix_unary_expression,
  [sym_query_expression] = sym_query_expression,
  [sym_from_clause] = sym_from_clause,
  [sym__query_body] = sym__query_body,
  [sym__query_clause] = sym__query_clause,
  [sym_join_clause] = sym_join_clause,
  [sym_join_into_clause] = sym_join_into_clause,
  [sym_let_clause] = sym_let_clause,
  [sym_order_by_clause] = sym_order_by_clause,
  [sym__ordering] = sym__ordering,
  [sym_where_clause] = sym_where_clause,
  [sym__select_or_group_clause] = sym__select_or_group_clause,
  [sym_group_clause] = sym_group_clause,
  [sym_select_clause] = sym_select_clause,
  [sym_query_continuation] = sym_query_continuation,
  [sym_range_expression] = sym_range_expression,
  [sym_ref_expression] = sym_ref_expression,
  [sym_ref_type_expression] = sym_ref_type_expression,
  [sym_ref_value_expression] = sym_ref_value_expression,
  [sym_size_of_expression] = sym_size_of_expression,
  [sym_stack_alloc_array_creation_expression] = sym_stack_alloc_array_creation_expression,
  [sym_switch_expression] = sym_switch_expression,
  [sym_switch_expression_arm] = sym_switch_expression_arm,
  [sym_throw_expression] = sym_throw_expression,
  [sym_tuple_expression] = sym_tuple_expression,
  [sym_type_of_expression] = sym_type_of_expression,
  [sym_with_expression] = sym_with_expression,
  [sym_with_initializer_expression] = sym_with_initializer_expression,
  [sym_simple_assignment_expression] = sym_simple_assignment_expression,
  [sym__expression] = sym__expression,
  [sym_binary_expression] = sym_binary_expression,
  [sym_as_expression] = sym_as_expression,
  [sym_is_expression] = sym_is_expression,
  [sym_identifier] = sym_identifier,
  [sym_global] = sym_global,
  [sym__literal] = sym__literal,
  [sym_boolean_literal] = sym_boolean_literal,
  [sym_character_literal] = sym_character_literal,
  [sym_string_literal] = sym_string_literal,
  [sym__contextual_keywords] = sym__contextual_keywords,
  [sym__preprocessor_call] = sym__preprocessor_call,
  [sym_nullable_directive] = sym_nullable_directive,
  [sym_define_directive] = sym_define_directive,
  [sym_undef_directive] = sym_undef_directive,
  [sym_if_directive] = sym_if_directive,
  [sym_else_directive] = sym_else_directive,
  [sym_elif_directive] = sym_elif_directive,
  [sym_region_directive] = sym_region_directive,
  [sym_endregion_directive] = sym_endregion_directive,
  [sym_error_directive] = sym_error_directive,
  [sym_warning_directive] = sym_warning_directive,
  [sym_line_directive] = sym_line_directive,
  [sym_pragma_directive] = sym_pragma_directive,
  [sym__preproc_expression] = sym__preproc_expression,
  [sym_preproc_parenthesized_expression] = sym_parenthesized_expression,
  [sym_preproc_unary_expression] = sym_prefix_unary_expression,
  [sym_preproc_binary_expression] = sym_binary_expression,
  [aux_sym_compilation_unit_repeat1] = aux_sym_compilation_unit_repeat1,
  [aux_sym_compilation_unit_repeat2] = aux_sym_compilation_unit_repeat2,
  [aux_sym_compilation_unit_repeat3] = aux_sym_compilation_unit_repeat3,
  [aux_sym_compilation_unit_repeat4] = aux_sym_compilation_unit_repeat4,
  [aux_sym_compilation_unit_repeat5] = aux_sym_compilation_unit_repeat5,
  [aux_sym_type_argument_list_repeat1] = aux_sym_type_argument_list_repeat1,
  [aux_sym_type_argument_list_repeat2] = aux_sym_type_argument_list_repeat2,
  [aux_sym_attribute_list_repeat1] = aux_sym_attribute_list_repeat1,
  [aux_sym_attribute_argument_list_repeat1] = aux_sym_attribute_argument_list_repeat1,
  [aux_sym_event_field_declaration_repeat1] = aux_sym_event_field_declaration_repeat1,
  [aux_sym_event_field_declaration_repeat2] = aux_sym_event_field_declaration_repeat2,
  [aux_sym_variable_declaration_repeat1] = aux_sym_variable_declaration_repeat1,
  [aux_sym_bracketed_argument_list_repeat1] = aux_sym_bracketed_argument_list_repeat1,
  [aux_sym_tuple_pattern_repeat1] = aux_sym_tuple_pattern_repeat1,
  [aux_sym__formal_parameter_list_repeat1] = aux_sym__formal_parameter_list_repeat1,
  [aux_sym_block_repeat1] = aux_sym_block_repeat1,
  [aux_sym_method_declaration_repeat1] = aux_sym_method_declaration_repeat1,
  [aux_sym_type_parameter_list_repeat1] = aux_sym_type_parameter_list_repeat1,
  [aux_sym_type_parameter_constraints_clause_repeat1] = aux_sym_type_parameter_constraints_clause_repeat1,
  [aux_sym_accessor_list_repeat1] = aux_sym_accessor_list_repeat1,
  [aux_sym_enum_member_declaration_list_repeat1] = aux_sym_enum_member_declaration_list_repeat1,
  [aux_sym_declaration_list_repeat1] = aux_sym_declaration_list_repeat1,
  [aux_sym_record_base_repeat1] = aux_sym_record_base_repeat1,
  [aux_sym_file_scoped_namespace_declaration_repeat1] = aux_sym_file_scoped_namespace_declaration_repeat1,
  [aux_sym_array_rank_specifier_repeat1] = aux_sym_array_rank_specifier_repeat1,
  [aux_sym_function_pointer_type_repeat1] = aux_sym_function_pointer_type_repeat1,
  [aux_sym_function_pointer_unmanaged_calling_convention_list_repeat1] = aux_sym_function_pointer_unmanaged_calling_convention_list_repeat1,
  [aux_sym_tuple_type_repeat1] = aux_sym_tuple_type_repeat1,
  [aux_sym_for_statement_repeat1] = aux_sym_for_statement_repeat1,
  [aux_sym_switch_body_repeat1] = aux_sym_switch_body_repeat1,
  [aux_sym_switch_section_repeat1] = aux_sym_switch_section_repeat1,
  [aux_sym_parenthesized_variable_designation_repeat1] = aux_sym_parenthesized_variable_designation_repeat1,
  [aux_sym_positional_pattern_clause_repeat1] = aux_sym_positional_pattern_clause_repeat1,
  [aux_sym_try_statement_repeat1] = aux_sym_try_statement_repeat1,
  [aux_sym_anonymous_object_creation_expression_repeat1] = aux_sym_anonymous_object_creation_expression_repeat1,
  [aux_sym_interpolated_string_expression_repeat1] = aux_sym_interpolated_string_expression_repeat1,
  [aux_sym_interpolated_string_expression_repeat2] = aux_sym_interpolated_string_expression_repeat2,
  [aux_sym__query_body_repeat1] = aux_sym__query_body_repeat1,
  [aux_sym_order_by_clause_repeat1] = aux_sym_order_by_clause_repeat1,
  [aux_sym_switch_expression_repeat1] = aux_sym_switch_expression_repeat1,
  [aux_sym_with_initializer_expression_repeat1] = aux_sym_with_initializer_expression_repeat1,
  [aux_sym_string_literal_repeat1] = aux_sym_string_literal_repeat1,
  [aux_sym_pragma_directive_repeat1] = aux_sym_pragma_directive_repeat1,
  [alias_sym_label_name] = alias_sym_label_name,
  [alias_sym_parameter_modifier] = alias_sym_parameter_modifier,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [sym__identifier_token] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_extern] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_alias] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_using] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_static] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_field] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_event] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_method] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_param] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_property] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_type] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assembly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_module] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_abstract] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_const] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_fixed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_internal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_new] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_override] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_partial] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_private] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_protected] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_public] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_readonly] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sealed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unsafe] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_virtual] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_volatile] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_out] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_this] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_params] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_base] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_implicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_explicit] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_operator] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_where] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_struct] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_notnull] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unmanaged] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_get] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_set] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_add] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_remove] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_init] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enum] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_interface] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_delegate] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_record] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_namespace] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_var] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_managed] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Cdecl] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Stdcall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Thiscall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_Fastcall] = {
    .visible = true,
    .named = false,
  },
  [sym_predefined_type] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_checked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_unchecked] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_do] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_foreach] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_goto] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_case] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_default] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lock] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_switch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [sym_discard] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_when] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_throw] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_catch] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_stackalloc] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOLLAR_AT_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_DOLLAR_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym__interpolated_string_text_fragment] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [sym__interpolated_verbatim_string_text_fragment] = {
    .visible = false,
    .named = true,
  },
  [aux_sym_interpolation_format_clause_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___makeref] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_join] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_on] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_equals] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_into] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_let] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_orderby] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_ascending] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_descending] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_group] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_by] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_select] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___reftype] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___refvalue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_sizeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_typeof] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_character_literal_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_null_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_real_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__string_literal_fragment] = {
    .visible = false,
    .named = true,
  },
  [sym_verbatim_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_dynamic] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nameof] = {
    .visible = true,
    .named = false,
  },
  [sym_void_keyword] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_directive_start] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_nullable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_disable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_enable] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_restore] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_annotations] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_warnings] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_define] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_undef] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [sym_endif_directive] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_region] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_endregion] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_error] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_warning] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_line] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_hidden] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pragma] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_checksum] = {
    .visible = true,
    .named = false,
  },
  [sym_preproc_message] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_integer_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_directive_end] = {
    .visible = false,
    .named = true,
  },
  [sym_compilation_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__declaration] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym__namespace_member_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym__type_declaration] = {
    .visible = false,
    .named = true,
  },
  [sym_extern_alias_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_using_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_name_equals] = {
    .visible = true,
    .named = true,
  },
  [sym__name] = {
    .visible = false,
    .named = true,
  },
  [sym_alias_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym__simple_name] = {
    .visible = false,
    .named = true,
  },
  [sym_generic_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_qualified_name] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_target_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_global_attribute_list] = {
    .visible = true,
    .named = true,
  },
  [sym_name_colon] = {
    .visible = true,
    .named = true,
  },
  [sym_event_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_modifier] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_variable_declarator] = {
    .visible = true,
    .named = true,
  },
  [sym_bracketed_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_equals_value_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_field_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym__formal_parameter_list] = {
    .visible = false,
    .named = true,
  },
  [sym_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym__parameter_array] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor_initializer] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_block] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_expression_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conversion_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__function_body] = {
    .visible = false,
    .named = true,
  },
  [sym_destructor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_method_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_explicit_interface_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_constraints_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_type_parameter_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_constructor_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_type_constraint] = {
    .visible = true,
    .named = true,
  },
  [sym_operator_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__overloadable_operator] = {
    .visible = false,
    .named = true,
  },
  [sym_event_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_accessor_list] = {
    .visible = true,
    .named = true,
  },
  [sym_accessor_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_indexer_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_bracketed_parameter_list] = {
    .visible = true,
    .named = true,
  },
  [sym_property_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_base_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_member_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_enum_member_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_class_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_list] = {
    .visible = true,
    .named = true,
  },
  [sym_interface_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_delegate_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_record_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_record_struct_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_record_base] = {
    .visible = true,
    .named = true,
  },
  [sym_primary_constructor_base_type] = {
    .visible = true,
    .named = true,
  },
  [sym__record_body] = {
    .visible = false,
    .named = true,
  },
  [sym_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_file_scoped_namespace_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym__type] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_implicit_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_type] = {
    .visible = true,
    .named = true,
  },
  [sym_array_rank_specifier] = {
    .visible = true,
    .named = true,
  },
  [sym_nullable_type] = {
    .visible = true,
    .named = true,
  },
  [sym__nullable_base_type] = {
    .visible = false,
    .named = true,
  },
  [sym_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_pointer_type] = {
    .visible = true,
    .named = true,
  },
  [sym_function_pointer_calling_convention] = {
    .visible = true,
    .named = true,
  },
  [sym_function_pointer_unmanaged_calling_convention_list] = {
    .visible = true,
    .named = true,
  },
  [sym_function_pointer_unmanaged_calling_convention] = {
    .visible = true,
    .named = true,
  },
  [sym_function_pointer_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_type] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_element] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_checked_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_do_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_empty_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_fixed_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_for_each_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_goto_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_labeled_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_local_declaration_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_local_function_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_lock_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_body] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_section] = {
    .visible = true,
    .named = true,
  },
  [sym_case_pattern_switch_label] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_type_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_relational_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_negated_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_constant_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__variable_designation] = {
    .visible = false,
    .named = true,
  },
  [sym_parenthesized_variable_designation] = {
    .visible = true,
    .named = true,
  },
  [sym_recursive_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_positional_pattern_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_colon] = {
    .visible = true,
    .named = true,
  },
  [sym_subpattern] = {
    .visible = true,
    .named = true,
  },
  [sym_property_pattern_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_var_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_when_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_case_switch_label] = {
    .visible = true,
    .named = true,
  },
  [sym_default_switch_label] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_catch_filter_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_unsafe_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_using_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_yield_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_method_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__anonymous_object_member_declarator] = {
    .visible = false,
    .named = true,
  },
  [sym_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_initializer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_await_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_cast_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_checked_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_declaration_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_default_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_element_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_element_binding_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_implicit_stack_alloc_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_base_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_this_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolated_string_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__interpolated_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__interpolated_verbatim_string_content] = {
    .visible = false,
    .named = true,
  },
  [sym_interpolated_string_text] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolated_verbatim_string_text] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_alignment_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation_format_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_invocation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_is_pattern_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_make_ref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_access_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_member_binding_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_object_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_postfix_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_prefix_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_query_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_from_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__query_body] = {
    .visible = false,
    .named = true,
  },
  [sym__query_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_join_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_join_into_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_let_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_order_by_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__ordering] = {
    .visible = false,
    .named = true,
  },
  [sym_where_clause] = {
    .visible = true,
    .named = true,
  },
  [sym__select_or_group_clause] = {
    .visible = false,
    .named = true,
  },
  [sym_group_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_select_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_query_continuation] = {
    .visible = true,
    .named = true,
  },
  [sym_range_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_type_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_ref_value_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_size_of_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_stack_alloc_array_creation_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_switch_expression_arm] = {
    .visible = true,
    .named = true,
  },
  [sym_throw_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_type_of_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_with_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_with_initializer_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_simple_assignment_expression] = {
    .visible = true,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
    .supertype = true,
  },
  [sym_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_as_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_is_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_global] = {
    .visible = true,
    .named = true,
  },
  [sym__literal] = {
    .visible = false,
    .named = true,
  },
  [sym_boolean_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_character_literal] = {
    .visible = true,
    .named = true,
  },
  [sym_string_literal] = {
    .visible = true,
    .named = true,
  },
  [sym__contextual_keywords] = {
    .visible = false,
    .named = true,
  },
  [sym__preprocessor_call] = {
    .visible = false,
    .named = true,
  },
  [sym_nullable_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_define_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_undef_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_if_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_else_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_region_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_endregion_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_error_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_warning_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_line_directive] = {
    .visible = true,
    .named = true,
  },
  [sym_pragma_directive] = {
    .visible = true,
    .named = true,
  },
  [sym__preproc_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_preproc_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_unary_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_preproc_binary_expression] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_compilation_unit_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_compilation_unit_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_compilation_unit_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_compilation_unit_repeat4] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_compilation_unit_repeat5] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_argument_list_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_attribute_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_event_field_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_event_field_declaration_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variable_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_bracketed_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__formal_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_method_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_parameter_constraints_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_accessor_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_enum_member_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_declaration_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_record_base_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_file_scoped_namespace_declaration_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_array_rank_specifier_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_pointer_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_function_pointer_unmanaged_calling_convention_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_section_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_variable_designation_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_positional_pattern_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_anonymous_object_creation_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_interpolated_string_expression_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__query_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_order_by_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_switch_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_initializer_expression_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_literal_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_pragma_directive_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_label_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_parameter_modifier] = {
    .visible = true,
    .named = true,
  },
};

enum {
  field_accessors = 1,
  field_alternative = 2,
  field_argument = 3,
  field_arguments = 4,
  field_bases = 5,
  field_body = 6,
  field_condition = 7,
  field_consequence = 8,
  field_constraints = 9,
  field_expression = 10,
  field_function = 11,
  field_initializer = 12,
  field_left = 13,
  field_name = 14,
  field_operator = 15,
  field_parameters = 16,
  field_pattern = 17,
  field_rank = 18,
  field_right = 19,
  field_subscript = 20,
  field_target = 21,
  field_type = 22,
  field_type_parameters = 23,
  field_update = 24,
  field_value = 25,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_accessors] = "accessors",
  [field_alternative] = "alternative",
  [field_argument] = "argument",
  [field_arguments] = "arguments",
  [field_bases] = "bases",
  [field_body] = "body",
  [field_condition] = "condition",
  [field_consequence] = "consequence",
  [field_constraints] = "constraints",
  [field_expression] = "expression",
  [field_function] = "function",
  [field_initializer] = "initializer",
  [field_left] = "left",
  [field_name] = "name",
  [field_operator] = "operator",
  [field_parameters] = "parameters",
  [field_pattern] = "pattern",
  [field_rank] = "rank",
  [field_right] = "right",
  [field_subscript] = "subscript",
  [field_target] = "target",
  [field_type] = "type",
  [field_type_parameters] = "type_parameters",
  [field_update] = "update",
  [field_value] = "value",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 1},
  [2] = {.index = 1, .length = 1},
  [3] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 2},
  [6] = {.index = 6, .length = 2},
  [7] = {.index = 8, .length = 2},
  [10] = {.index = 10, .length = 2},
  [11] = {.index = 12, .length = 1},
  [12] = {.index = 12, .length = 1},
  [13] = {.index = 13, .length = 2},
  [14] = {.index = 15, .length = 2},
  [15] = {.index = 17, .length = 2},
  [16] = {.index = 19, .length = 2},
  [18] = {.index = 21, .length = 2},
  [19] = {.index = 23, .length = 1},
  [20] = {.index = 24, .length = 3},
  [21] = {.index = 27, .length = 1},
  [22] = {.index = 28, .length = 2},
  [23] = {.index = 30, .length = 2},
  [25] = {.index = 32, .length = 2},
  [26] = {.index = 34, .length = 1},
  [27] = {.index = 35, .length = 2},
  [28] = {.index = 37, .length = 2},
  [29] = {.index = 39, .length = 1},
  [30] = {.index = 35, .length = 2},
  [31] = {.index = 40, .length = 3},
  [32] = {.index = 43, .length = 3},
  [33] = {.index = 46, .length = 3},
  [34] = {.index = 49, .length = 2},
  [35] = {.index = 51, .length = 2},
  [36] = {.index = 53, .length = 3},
  [37] = {.index = 56, .length = 1},
  [38] = {.index = 57, .length = 1},
  [39] = {.index = 58, .length = 4},
  [41] = {.index = 62, .length = 1},
  [42] = {.index = 63, .length = 2},
  [43] = {.index = 65, .length = 4},
  [44] = {.index = 69, .length = 3},
  [45] = {.index = 72, .length = 3},
  [46] = {.index = 75, .length = 3},
  [47] = {.index = 78, .length = 3},
  [48] = {.index = 81, .length = 3},
  [49] = {.index = 84, .length = 3},
  [50] = {.index = 87, .length = 2},
  [51] = {.index = 89, .length = 4},
  [52] = {.index = 93, .length = 3},
  [53] = {.index = 96, .length = 4},
  [54] = {.index = 100, .length = 2},
  [55] = {.index = 102, .length = 2},
  [56] = {.index = 104, .length = 4},
  [57] = {.index = 108, .length = 5},
  [58] = {.index = 113, .length = 3},
  [59] = {.index = 116, .length = 2},
  [60] = {.index = 118, .length = 4},
  [61] = {.index = 122, .length = 3},
  [62] = {.index = 125, .length = 3},
  [63] = {.index = 128, .length = 2},
  [64] = {.index = 130, .length = 4},
  [65] = {.index = 134, .length = 2},
  [66] = {.index = 136, .length = 4},
  [67] = {.index = 140, .length = 4},
  [68] = {.index = 144, .length = 3},
  [69] = {.index = 147, .length = 4},
  [70] = {.index = 151, .length = 4},
  [71] = {.index = 155, .length = 3},
  [72] = {.index = 158, .length = 3},
  [73] = {.index = 161, .length = 4},
  [74] = {.index = 165, .length = 5},
  [75] = {.index = 170, .length = 4},
  [76] = {.index = 174, .length = 1},
  [77] = {.index = 175, .length = 2},
  [78] = {.index = 177, .length = 5},
  [79] = {.index = 182, .length = 3},
  [80] = {.index = 185, .length = 3},
  [81] = {.index = 188, .length = 3},
  [82] = {.index = 191, .length = 3},
  [83] = {.index = 194, .length = 2},
  [84] = {.index = 196, .length = 4},
  [85] = {.index = 200, .length = 5},
  [86] = {.index = 205, .length = 2},
  [87] = {.index = 207, .length = 4},
  [89] = {.index = 211, .length = 3},
  [90] = {.index = 214, .length = 1},
  [91] = {.index = 215, .length = 3},
  [92] = {.index = 218, .length = 3},
  [93] = {.index = 221, .length = 3},
  [94] = {.index = 224, .length = 3},
  [95] = {.index = 227, .length = 3},
  [96] = {.index = 230, .length = 3},
  [97] = {.index = 233, .length = 2},
  [98] = {.index = 235, .length = 4},
  [99] = {.index = 239, .length = 5},
  [100] = {.index = 244, .length = 4},
  [101] = {.index = 248, .length = 4},
  [102] = {.index = 252, .length = 5},
  [103] = {.index = 257, .length = 2},
  [104] = {.index = 259, .length = 2},
  [105] = {.index = 261, .length = 2},
  [106] = {.index = 263, .length = 3},
  [107] = {.index = 266, .length = 3},
  [108] = {.index = 269, .length = 4},
  [109] = {.index = 273, .length = 4},
  [110] = {.index = 277, .length = 3},
  [111] = {.index = 280, .length = 4},
  [112] = {.index = 284, .length = 4},
  [113] = {.index = 288, .length = 3},
  [114] = {.index = 291, .length = 3},
  [115] = {.index = 294, .length = 5},
  [116] = {.index = 299, .length = 3},
  [117] = {.index = 302, .length = 3},
  [118] = {.index = 305, .length = 3},
  [119] = {.index = 308, .length = 3},
  [120] = {.index = 311, .length = 2},
  [121] = {.index = 313, .length = 4},
  [122] = {.index = 317, .length = 5},
  [123] = {.index = 322, .length = 1},
  [124] = {.index = 323, .length = 2},
  [125] = {.index = 325, .length = 3},
  [126] = {.index = 328, .length = 3},
  [127] = {.index = 331, .length = 4},
  [128] = {.index = 335, .length = 3},
  [129] = {.index = 338, .length = 4},
  [130] = {.index = 342, .length = 3},
  [131] = {.index = 345, .length = 3},
  [132] = {.index = 348, .length = 1},
  [133] = {.index = 63, .length = 2},
  [134] = {.index = 349, .length = 3},
  [135] = {.index = 352, .length = 3},
  [136] = {.index = 355, .length = 3},
  [137] = {.index = 358, .length = 3},
  [138] = {.index = 361, .length = 3},
  [139] = {.index = 364, .length = 5},
  [140] = {.index = 369, .length = 3},
  [141] = {.index = 372, .length = 3},
  [142] = {.index = 375, .length = 3},
  [143] = {.index = 378, .length = 3},
  [144] = {.index = 381, .length = 3},
  [145] = {.index = 384, .length = 3},
  [146] = {.index = 387, .length = 4},
  [147] = {.index = 391, .length = 4},
  [148] = {.index = 395, .length = 5},
  [149] = {.index = 400, .length = 4},
  [150] = {.index = 404, .length = 4},
  [151] = {.index = 408, .length = 4},
  [152] = {.index = 412, .length = 4},
  [153] = {.index = 416, .length = 3},
  [154] = {.index = 419, .length = 4},
  [155] = {.index = 423, .length = 4},
  [156] = {.index = 427, .length = 3},
  [157] = {.index = 430, .length = 3},
  [158] = {.index = 433, .length = 5},
  [159] = {.index = 438, .length = 4},
  [160] = {.index = 442, .length = 5},
  [161] = {.index = 447, .length = 3},
  [162] = {.index = 450, .length = 1},
  [163] = {.index = 451, .length = 4},
  [164] = {.index = 455, .length = 1},
  [165] = {.index = 456, .length = 2},
  [166] = {.index = 458, .length = 3},
  [167] = {.index = 461, .length = 3},
  [168] = {.index = 464, .length = 4},
  [169] = {.index = 468, .length = 3},
  [170] = {.index = 471, .length = 4},
  [171] = {.index = 475, .length = 3},
  [172] = {.index = 478, .length = 3},
  [173] = {.index = 481, .length = 2},
  [174] = {.index = 483, .length = 3},
  [175] = {.index = 486, .length = 3},
  [176] = {.index = 489, .length = 3},
  [177] = {.index = 492, .length = 3},
  [178] = {.index = 495, .length = 4},
  [179] = {.index = 499, .length = 4},
  [180] = {.index = 503, .length = 4},
  [181] = {.index = 507, .length = 4},
  [182] = {.index = 511, .length = 4},
  [183] = {.index = 515, .length = 4},
  [184] = {.index = 519, .length = 5},
  [185] = {.index = 524, .length = 4},
  [186] = {.index = 528, .length = 5},
  [187] = {.index = 533, .length = 4},
  [188] = {.index = 537, .length = 4},
  [189] = {.index = 541, .length = 5},
  [190] = {.index = 546, .length = 4},
  [191] = {.index = 550, .length = 4},
  [192] = {.index = 554, .length = 5},
  [193] = {.index = 559, .length = 3},
  [194] = {.index = 562, .length = 4},
  [195] = {.index = 566, .length = 2},
  [196] = {.index = 568, .length = 3},
  [197] = {.index = 571, .length = 3},
  [198] = {.index = 574, .length = 4},
  [199] = {.index = 578, .length = 3},
  [200] = {.index = 581, .length = 4},
  [201] = {.index = 585, .length = 3},
  [202] = {.index = 588, .length = 3},
  [203] = {.index = 591, .length = 5},
  [204] = {.index = 596, .length = 5},
  [205] = {.index = 601, .length = 5},
  [206] = {.index = 606, .length = 5},
  [207] = {.index = 611, .length = 5},
  [208] = {.index = 616, .length = 4},
  [209] = {.index = 620, .length = 4},
  [210] = {.index = 624, .length = 5},
  [211] = {.index = 629, .length = 3},
  [212] = {.index = 632, .length = 4},
  [213] = {.index = 636, .length = 6},
  [214] = {.index = 642, .length = 5},
  [215] = {.index = 647, .length = 4},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0},
  [1] =
    {field_type, 0},
  [2] =
    {field_type, 1},
  [3] =
    {field_body, 1},
  [4] =
    {field_rank, 1},
    {field_type, 0},
  [6] =
    {field_expression, 0},
    {field_subscript, 1},
  [8] =
    {field_arguments, 1},
    {field_function, 0},
  [10] =
    {field_name, 1},
    {field_type, 0},
  [12] =
    {field_name, 1},
  [13] =
    {field_arguments, 2},
    {field_type, 1},
  [15] =
    {field_initializer, 2},
    {field_type, 1},
  [17] =
    {field_body, 2},
    {field_name, 1},
  [19] =
    {field_expression, 0},
    {field_name, 2},
  [21] =
    {field_body, 2},
    {field_value, 1},
  [23] =
    {field_body, 2},
  [24] =
    {field_left, 0},
    {field_operator, 1},
    {field_right, 2},
  [27] =
    {field_condition, 0},
  [28] =
    {field_expression, 0},
    {field_pattern, 2},
  [30] =
    {field_left, 0},
    {field_right, 2},
  [32] =
    {field_argument, 1},
    {field_operator, 0},
  [34] =
    {field_body, 3},
  [35] =
    {field_name, 2},
    {field_type, 1},
  [37] =
    {field_type, 1},
    {field_value, 3},
  [39] =
    {field_name, 2},
  [40] =
    {field_arguments, 2},
    {field_initializer, 3},
    {field_type, 1},
  [43] =
    {field_body, 3},
    {field_name, 1},
    {field_type_parameters, 2},
  [46] =
    {field_bases, 2},
    {field_body, 3},
    {field_name, 1},
  [49] =
    {field_body, 3},
    {field_name, 1},
  [51] =
    {field_body, 3},
    {field_name, 2},
  [53] =
    {field_body, 3},
    {field_name, 1},
    {field_parameters, 2},
  [56] =
    {field_type, 2},
  [57] =
    {field_body, 0},
  [58] =
    {field_body, 3, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_type, 0},
  [62] =
    {field_body, 4},
  [63] =
    {field_name, 3},
    {field_type, 2},
  [65] =
    {field_bases, 3},
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [69] =
    {field_body, 4},
    {field_name, 1},
    {field_type_parameters, 2},
  [72] =
    {field_bases, 2},
    {field_body, 4},
    {field_name, 1},
  [75] =
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 1},
  [78] =
    {field_body, 4},
    {field_name, 2},
    {field_parameters, 3},
  [81] =
    {field_body, 4},
    {field_name, 2},
    {field_type_parameters, 3},
  [84] =
    {field_bases, 3},
    {field_body, 4},
    {field_name, 2},
  [87] =
    {field_body, 4},
    {field_name, 2},
  [89] =
    {field_bases, 3},
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [93] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 2},
  [96] =
    {field_body, 4},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [100] =
    {field_condition, 2},
    {field_consequence, 4},
  [102] =
    {field_body, 4},
    {field_value, 2},
  [104] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
    {field_type, 0},
  [108] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_type, 0},
    {field_type_parameters, 2},
  [113] =
    {field_alternative, 4},
    {field_condition, 0},
    {field_consequence, 2},
  [116] =
    {field_body, 4},
    {field_name, 3},
  [118] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 1},
  [122] =
    {field_accessors, 2},
    {field_name, 1},
    {field_type, 0},
  [125] =
    {field_body, 2, .inherited = true},
    {field_name, 0},
    {field_parameters, 1},
  [128] =
    {field_constraints, 3},
    {field_target, 1},
  [130] =
    {field_bases, 3},
    {field_body, 5},
    {field_name, 1},
    {field_type_parameters, 2},
  [134] =
    {field_name, 0},
    {field_value, 2},
  [136] =
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 1},
    {field_type_parameters, 3},
  [140] =
    {field_bases, 4},
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [144] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 3},
  [147] =
    {field_body, 5},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [151] =
    {field_bases, 4},
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [155] =
    {field_body, 5},
    {field_name, 2},
    {field_type_parameters, 3},
  [158] =
    {field_bases, 3},
    {field_body, 5},
    {field_name, 2},
  [161] =
    {field_bases, 3},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 2},
  [165] =
    {field_bases, 4},
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [170] =
    {field_body, 5},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [174] =
    {field_body, 5},
  [175] =
    {field_type, 4},
    {field_value, 2},
  [177] =
    {field_body, 5, .inherited = true},
    {field_name, 1},
    {field_parameters, 3},
    {field_type, 0},
    {field_type_parameters, 2},
  [182] =
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 2},
  [185] =
    {field_body, 5},
    {field_name, 3},
    {field_parameters, 4},
  [188] =
    {field_body, 5},
    {field_name, 3},
    {field_type_parameters, 4},
  [191] =
    {field_bases, 4},
    {field_body, 5},
    {field_name, 3},
  [194] =
    {field_body, 5},
    {field_name, 3},
  [196] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 1},
  [200] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 1},
    {field_type_parameters, 3},
  [205] =
    {field_body, 5},
    {field_name, 4},
  [207] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 2},
  [211] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 1},
  [214] =
    {field_body, 3, .inherited = true},
  [215] =
    {field_accessors, 3},
    {field_parameters, 2},
    {field_type, 0},
  [218] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 0},
  [221] =
    {field_name, 1},
    {field_type, 0},
    {field_value, 2},
  [224] =
    {field_body, 3, .inherited = true},
    {field_name, 0},
    {field_parameters, 1},
  [227] =
    {field_body, 3, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
  [230] =
    {field_constraints, 3},
    {field_constraints, 4},
    {field_target, 1},
  [233] =
    {field_name, 1},
    {field_value, 3},
  [235] =
    {field_bases, 4},
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 3},
  [239] =
    {field_bases, 5},
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [244] =
    {field_body, 6},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [248] =
    {field_bases, 4},
    {field_body, 6},
    {field_name, 2},
    {field_type_parameters, 3},
  [252] =
    {field_bases, 4},
    {field_body, 6},
    {field_name, 1},
    {field_parameters, 3},
    {field_type_parameters, 2},
  [257] =
    {field_body, 6},
    {field_update, 4},
  [259] =
    {field_body, 6},
    {field_condition, 3},
  [261] =
    {field_body, 6},
    {field_initializer, 2},
  [263] =
    {field_body, 6},
    {field_left, 2},
    {field_right, 4},
  [266] =
    {field_alternative, 6},
    {field_condition, 2},
    {field_consequence, 4},
  [269] =
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 2},
    {field_type_parameters, 4},
  [273] =
    {field_bases, 5},
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 4},
  [277] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 4},
  [280] =
    {field_body, 6},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [284] =
    {field_bases, 5},
    {field_body, 6},
    {field_name, 3},
    {field_type_parameters, 4},
  [288] =
    {field_body, 6},
    {field_name, 3},
    {field_type_parameters, 4},
  [291] =
    {field_bases, 4},
    {field_body, 6},
    {field_name, 3},
  [294] =
    {field_body, 6, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 1},
    {field_type_parameters, 3},
  [299] =
    {field_name, 4},
    {field_parameters, 5},
    {field_type, 3},
  [302] =
    {field_body, 6},
    {field_name, 4},
    {field_parameters, 5},
  [305] =
    {field_body, 6},
    {field_name, 4},
    {field_type_parameters, 5},
  [308] =
    {field_bases, 5},
    {field_body, 6},
    {field_name, 4},
  [311] =
    {field_body, 6},
    {field_name, 4},
  [313] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 2},
  [317] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 2},
    {field_type_parameters, 4},
  [322] =
    {field_body, 4, .inherited = true},
  [323] =
    {field_name, 3},
    {field_type, 1},
  [325] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 1},
  [328] =
    {field_body, 4, .inherited = true},
    {field_parameters, 3},
    {field_type, 2},
  [331] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 0},
  [335] =
    {field_parameters, 2},
    {field_type, 0},
    {field_value, 3},
  [338] =
    {field_body, 4, .inherited = true},
    {field_operator, 2},
    {field_parameters, 3},
    {field_type, 0},
  [342] =
    {field_accessors, 4},
    {field_parameters, 3},
    {field_type, 0},
  [345] =
    {field_name, 2},
    {field_type, 0},
    {field_value, 3},
  [348] =
    {field_body, 1, .inherited = true},
  [349] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 2},
  [352] =
    {field_accessors, 4},
    {field_parameters, 3},
    {field_type, 1},
  [355] =
    {field_name, 2},
    {field_type, 1},
    {field_value, 3},
  [358] =
    {field_body, 4, .inherited = true},
    {field_name, 1},
    {field_parameters, 2},
  [361] =
    {field_body, 4, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
  [364] =
    {field_bases, 5},
    {field_body, 7},
    {field_name, 2},
    {field_parameters, 4},
    {field_type_parameters, 3},
  [369] =
    {field_body, 7},
    {field_update, 4},
    {field_update, 5},
  [372] =
    {field_body, 7},
    {field_condition, 3},
    {field_update, 5},
  [375] =
    {field_body, 7},
    {field_initializer, 2},
    {field_update, 5},
  [378] =
    {field_body, 7},
    {field_condition, 4},
    {field_initializer, 2},
  [381] =
    {field_body, 7},
    {field_initializer, 2},
    {field_initializer, 3},
  [384] =
    {field_body, 7},
    {field_left, 3},
    {field_right, 5},
  [387] =
    {field_body, 7},
    {field_left, 3},
    {field_right, 5},
    {field_type, 2},
  [391] =
    {field_bases, 5},
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 4},
  [395] =
    {field_bases, 6},
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [400] =
    {field_body, 7},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [404] =
    {field_bases, 5},
    {field_body, 7},
    {field_name, 3},
    {field_type_parameters, 4},
  [408] =
    {field_name, 4},
    {field_parameters, 6},
    {field_type, 3},
    {field_type_parameters, 5},
  [412] =
    {field_bases, 6},
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 5},
  [416] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 5},
  [419] =
    {field_body, 7},
    {field_name, 4},
    {field_parameters, 6},
    {field_type_parameters, 5},
  [423] =
    {field_bases, 6},
    {field_body, 7},
    {field_name, 4},
    {field_type_parameters, 5},
  [427] =
    {field_body, 7},
    {field_name, 4},
    {field_type_parameters, 5},
  [430] =
    {field_bases, 5},
    {field_body, 7},
    {field_name, 4},
  [433] =
    {field_body, 7, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 2},
    {field_type_parameters, 4},
  [438] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
    {field_type, 0},
  [442] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 0},
    {field_type_parameters, 3},
  [447] =
    {field_parameters, 3},
    {field_type, 0},
    {field_value, 4},
  [450] =
    {field_body, 2, .inherited = true},
  [451] =
    {field_accessors, 2},
    {field_name, 1},
    {field_type, 0},
    {field_value, 4},
  [455] =
    {field_body, 5, .inherited = true},
  [456] =
    {field_name, 4},
    {field_type, 2},
  [458] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 2},
  [461] =
    {field_body, 5, .inherited = true},
    {field_parameters, 4},
    {field_type, 3},
  [464] =
    {field_body, 5, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 1},
  [468] =
    {field_parameters, 3},
    {field_type, 1},
    {field_value, 4},
  [471] =
    {field_body, 5, .inherited = true},
    {field_operator, 3},
    {field_parameters, 4},
    {field_type, 1},
  [475] =
    {field_accessors, 5},
    {field_parameters, 4},
    {field_type, 1},
  [478] =
    {field_name, 3},
    {field_type, 1},
    {field_value, 4},
  [481] =
    {field_name, 4},
    {field_type, 3},
  [483] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 3},
  [486] =
    {field_accessors, 5},
    {field_parameters, 4},
    {field_type, 2},
  [489] =
    {field_name, 3},
    {field_type, 2},
    {field_value, 4},
  [492] =
    {field_body, 5, .inherited = true},
    {field_name, 2},
    {field_parameters, 3},
  [495] =
    {field_body, 8},
    {field_condition, 3},
    {field_update, 5},
    {field_update, 6},
  [499] =
    {field_body, 8},
    {field_initializer, 2},
    {field_update, 5},
    {field_update, 6},
  [503] =
    {field_body, 8},
    {field_condition, 4},
    {field_initializer, 2},
    {field_update, 6},
  [507] =
    {field_body, 8},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 6},
  [511] =
    {field_body, 8},
    {field_condition, 5},
    {field_initializer, 2},
    {field_initializer, 3},
  [515] =
    {field_body, 8},
    {field_left, 4},
    {field_right, 6},
    {field_type, 3},
  [519] =
    {field_bases, 6},
    {field_body, 8},
    {field_name, 3},
    {field_parameters, 5},
    {field_type_parameters, 4},
  [524] =
    {field_bases, 6},
    {field_body, 8},
    {field_name, 4},
    {field_parameters, 5},
  [528] =
    {field_bases, 7},
    {field_body, 8},
    {field_name, 4},
    {field_parameters, 6},
    {field_type_parameters, 5},
  [533] =
    {field_body, 8},
    {field_name, 4},
    {field_parameters, 6},
    {field_type_parameters, 5},
  [537] =
    {field_bases, 6},
    {field_body, 8},
    {field_name, 4},
    {field_type_parameters, 5},
  [541] =
    {field_body, 6, .inherited = true},
    {field_name, 2},
    {field_parameters, 4},
    {field_type, 0},
    {field_type_parameters, 3},
  [546] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 0},
    {field_value, 5},
  [550] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 4},
    {field_type, 1},
  [554] =
    {field_body, 6, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 1},
    {field_type_parameters, 4},
  [559] =
    {field_parameters, 4},
    {field_type, 1},
    {field_value, 5},
  [562] =
    {field_accessors, 3},
    {field_name, 2},
    {field_type, 1},
    {field_value, 5},
  [566] =
    {field_name, 5},
    {field_type, 3},
  [568] =
    {field_accessors, 6},
    {field_name, 5},
    {field_type, 3},
  [571] =
    {field_body, 6, .inherited = true},
    {field_parameters, 5},
    {field_type, 4},
  [574] =
    {field_body, 6, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
    {field_type, 2},
  [578] =
    {field_parameters, 4},
    {field_type, 2},
    {field_value, 5},
  [581] =
    {field_body, 6, .inherited = true},
    {field_operator, 4},
    {field_parameters, 5},
    {field_type, 2},
  [585] =
    {field_accessors, 6},
    {field_parameters, 5},
    {field_type, 2},
  [588] =
    {field_name, 4},
    {field_type, 2},
    {field_value, 5},
  [591] =
    {field_body, 9},
    {field_condition, 4},
    {field_initializer, 2},
    {field_update, 6},
    {field_update, 7},
  [596] =
    {field_body, 9},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 6},
    {field_update, 7},
  [601] =
    {field_body, 9},
    {field_condition, 5},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 7},
  [606] =
    {field_bases, 7},
    {field_body, 9},
    {field_name, 4},
    {field_parameters, 6},
    {field_type_parameters, 5},
  [611] =
    {field_body, 7, .inherited = true},
    {field_name, 3},
    {field_parameters, 5},
    {field_type, 1},
    {field_type_parameters, 4},
  [616] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 1},
    {field_value, 6},
  [620] =
    {field_body, 7, .inherited = true},
    {field_name, 4},
    {field_parameters, 5},
    {field_type, 2},
  [624] =
    {field_body, 7, .inherited = true},
    {field_name, 4},
    {field_parameters, 6},
    {field_type, 2},
    {field_type_parameters, 5},
  [629] =
    {field_parameters, 5},
    {field_type, 2},
    {field_value, 6},
  [632] =
    {field_accessors, 4},
    {field_name, 3},
    {field_type, 2},
    {field_value, 6},
  [636] =
    {field_body, 10},
    {field_condition, 5},
    {field_initializer, 2},
    {field_initializer, 3},
    {field_update, 7},
    {field_update, 8},
  [642] =
    {field_body, 8, .inherited = true},
    {field_name, 4},
    {field_parameters, 6},
    {field_type, 2},
    {field_type_parameters, 5},
  [647] =
    {field_accessors, 5},
    {field_name, 4},
    {field_type, 2},
    {field_value, 7},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [8] = {
    [0] = sym_integer_literal,
  },
  [9] = {
    [0] = sym_verbatim_string_literal,
  },
  [11] = {
    [0] = alias_sym_parameter_modifier,
  },
  [17] = {
    [1] = alias_sym_label_name,
  },
  [24] = {
    [0] = alias_sym_label_name,
  },
  [27] = {
    [0] = alias_sym_parameter_modifier,
  },
  [29] = {
    [1] = alias_sym_parameter_modifier,
  },
  [40] = {
    [3] = sym_integer_literal,
  },
  [42] = {
    [1] = alias_sym_parameter_modifier,
  },
  [88] = {
    [1] = sym_integer_literal,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym_identifier, 2,
    sym_identifier,
    alias_sym_label_name,
  0,
};

static inline bool sym__identifier_token_character_set_1(int32_t c) {
  return (c < 6823
    ? (c < 2990
      ? (c < 2384
        ? (c < 1488
          ? (c < 886
            ? (c < 216
              ? (c < 181
                ? (c < 'a'
                  ? (c >= 'A' && c <= '_')
                  : (c <= 'z' || c == 170))
                : (c <= 181 || (c < 192
                  ? c == 186
                  : c <= 214)))
              : (c <= 246 || (c < 748
                ? (c < 710
                  ? (c >= 248 && c <= 705)
                  : (c <= 721 || (c >= 736 && c <= 740)))
                : (c <= 748 || (c < 880
                  ? c == 750
                  : c <= 884)))))
            : (c <= 887 || (c < 931
              ? (c < 904
                ? (c < 895
                  ? (c >= 890 && c <= 893)
                  : (c <= 895 || c == 902))
                : (c <= 906 || (c < 910
                  ? c == 908
                  : c <= 929)))
              : (c <= 1013 || (c < 1329
                ? (c < 1162
                  ? (c >= 1015 && c <= 1153)
                  : c <= 1327)
                : (c <= 1366 || (c < 1376
                  ? c == 1369
                  : c <= 1416)))))))
          : (c <= 1514 || (c < 1994
            ? (c < 1774
              ? (c < 1649
                ? (c < 1568
                  ? (c >= 1519 && c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))
                : (c <= 1747 || (c < 1765
                  ? c == 1749
                  : c <= 1766)))
              : (c <= 1775 || (c < 1810
                ? (c < 1791
                  ? (c >= 1786 && c <= 1788)
                  : (c <= 1791 || c == 1808))
                : (c <= 1839 || (c < 1969
                  ? (c >= 1869 && c <= 1957)
                  : c <= 1969)))))
            : (c <= 2026 || (c < 2112
              ? (c < 2074
                ? (c < 2042
                  ? (c >= 2036 && c <= 2037)
                  : (c <= 2042 || (c >= 2048 && c <= 2069)))
                : (c <= 2074 || (c < 2088
                  ? c == 2084
                  : c <= 2088)))
              : (c <= 2136 || (c < 2230
                ? (c < 2208
                  ? (c >= 2144 && c <= 2154)
                  : c <= 2228)
                : (c <= 2247 || (c < 2365
                  ? (c >= 2308 && c <= 2361)
                  : c <= 2365)))))))))
        : (c <= 2384 || (c < 2707
          ? (c < 2556
            ? (c < 2482
              ? (c < 2447
                ? (c < 2417
                  ? (c >= 2392 && c <= 2401)
                  : (c <= 2432 || (c >= 2437 && c <= 2444)))
                : (c <= 2448 || (c < 2474
                  ? (c >= 2451 && c <= 2472)
                  : c <= 2480)))
              : (c <= 2482 || (c < 2524
                ? (c < 2493
                  ? (c >= 2486 && c <= 2489)
                  : (c <= 2493 || c == 2510))
                : (c <= 2525 || (c < 2544
                  ? (c >= 2527 && c <= 2529)
                  : c <= 2545)))))
            : (c <= 2556 || (c < 2616
              ? (c < 2602
                ? (c < 2575
                  ? (c >= 2565 && c <= 2570)
                  : (c <= 2576 || (c >= 2579 && c <= 2600)))
                : (c <= 2608 || (c < 2613
                  ? (c >= 2610 && c <= 2611)
                  : c <= 2614)))
              : (c <= 2617 || (c < 2674
                ? (c < 2654
                  ? (c >= 2649 && c <= 2652)
                  : c <= 2654)
                : (c <= 2676 || (c < 2703
                  ? (c >= 2693 && c <= 2701)
                  : c <= 2705)))))))
          : (c <= 2728 || (c < 2877
            ? (c < 2809
              ? (c < 2749
                ? (c < 2738
                  ? (c >= 2730 && c <= 2736)
                  : (c <= 2739 || (c >= 2741 && c <= 2745)))
                : (c <= 2749 || (c < 2784
                  ? c == 2768
                  : c <= 2785)))
              : (c <= 2809 || (c < 2858
                ? (c < 2831
                  ? (c >= 2821 && c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))
                : (c <= 2864 || (c < 2869
                  ? (c >= 2866 && c <= 2867)
                  : c <= 2873)))))
            : (c <= 2877 || (c < 2962
              ? (c < 2947
                ? (c < 2911
                  ? (c >= 2908 && c <= 2909)
                  : (c <= 2913 || c == 2929))
                : (c <= 2947 || (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : c <= 2960)))
              : (c <= 2965 || (c < 2974
                ? (c < 2972
                  ? (c >= 2969 && c <= 2970)
                  : c <= 2972)
                : (c <= 2975 || (c < 2984
                  ? (c >= 2979 && c <= 2980)
                  : c <= 2986)))))))))))
      : (c <= 3001 || (c < 4193
        ? (c < 3461
          ? (c < 3253
            ? (c < 3160
              ? (c < 3090
                ? (c < 3077
                  ? c == 3024
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))
                : (c <= 3112 || (c < 3133
                  ? (c >= 3114 && c <= 3129)
                  : c <= 3133)))
              : (c <= 3162 || (c < 3214
                ? (c < 3200
                  ? (c >= 3168 && c <= 3169)
                  : (c <= 3200 || (c >= 3205 && c <= 3212)))
                : (c <= 3216 || (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : c <= 3251)))))
            : (c <= 3257 || (c < 3346
              ? (c < 3313
                ? (c < 3294
                  ? c == 3261
                  : (c <= 3294 || (c >= 3296 && c <= 3297)))
                : (c <= 3314 || (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)))
              : (c <= 3386 || (c < 3412
                ? (c < 3406
                  ? c == 3389
                  : c <= 3406)
                : (c <= 3414 || (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : c <= 3455)))))))
          : (c <= 3478 || (c < 3762
            ? (c < 3648
              ? (c < 3520
                ? (c < 3507
                  ? (c >= 3482 && c <= 3505)
                  : (c <= 3515 || c == 3517))
                : (c <= 3526 || (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : c <= 3635)))
              : (c <= 3654 || (c < 3724
                ? (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3751
                  ? c == 3749
                  : c <= 3760)))))
            : (c <= 3763 || (c < 3913
              ? (c < 3804
                ? (c < 3776
                  ? c == 3773
                  : (c <= 3780 || c == 3782))
                : (c <= 3807 || (c < 3904
                  ? c == 3840
                  : c <= 3911)))
              : (c <= 3948 || (c < 4159
                ? (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)
                : (c <= 4159 || (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : c <= 4189)))))))))
        : (c <= 4193 || (c < 5112
          ? (c < 4704
            ? (c < 4301
              ? (c < 4238
                ? (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : (c <= 4208 || (c >= 4213 && c <= 4225)))
                : (c <= 4238 || (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : c <= 4295)))
              : (c <= 4301 || (c < 4688
                ? (c < 4348
                  ? (c >= 4304 && c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))
                : (c <= 4694 || (c < 4698
                  ? c == 4696
                  : c <= 4701)))))
            : (c <= 4744 || (c < 4808
              ? (c < 4792
                ? (c < 4752
                  ? (c >= 4746 && c <= 4749)
                  : (c <= 4784 || (c >= 4786 && c <= 4789)))
                : (c <= 4798 || (c < 4802
                  ? c == 4800
                  : c <= 4805)))
              : (c <= 4822 || (c < 4888
                ? (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)
                : (c <= 4954 || (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : c <= 5109)))))))
          : (c <= 5117 || (c < 6108
            ? (c < 5902
              ? (c < 5792
                ? (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))
                : (c <= 5866 || (c < 5888
                  ? (c >= 5870 && c <= 5880)
                  : c <= 5900)))
              : (c <= 5905 || (c < 5998
                ? (c < 5952
                  ? (c >= 5920 && c <= 5937)
                  : (c <= 5969 || (c >= 5984 && c <= 5996)))
                : (c <= 6000 || (c < 6103
                  ? (c >= 6016 && c <= 6067)
                  : c <= 6103)))))
            : (c <= 6108 || (c < 6480
              ? (c < 6314
                ? (c < 6272
                  ? (c >= 6176 && c <= 6264)
                  : (c <= 6276 || (c >= 6279 && c <= 6312)))
                : (c <= 6314 || (c < 6400
                  ? (c >= 6320 && c <= 6389)
                  : c <= 6430)))
              : (c <= 6509 || (c < 6576
                ? (c < 6528
                  ? (c >= 6512 && c <= 6516)
                  : c <= 6571)
                : (c <= 6601 || (c < 6688
                  ? (c >= 6656 && c <= 6678)
                  : c <= 6740)))))))))))))
    : (c <= 6823 || (c < 43259
      ? (c < 11312
        ? (c < 8118
          ? (c < 7413
            ? (c < 7245
              ? (c < 7086
                ? (c < 6981
                  ? (c >= 6917 && c <= 6963)
                  : (c <= 6987 || (c >= 7043 && c <= 7072)))
                : (c <= 7087 || (c < 7168
                  ? (c >= 7098 && c <= 7141)
                  : c <= 7203)))
              : (c <= 7247 || (c < 7357
                ? (c < 7296
                  ? (c >= 7258 && c <= 7293)
                  : (c <= 7304 || (c >= 7312 && c <= 7354)))
                : (c <= 7359 || (c < 7406
                  ? (c >= 7401 && c <= 7404)
                  : c <= 7411)))))
            : (c <= 7414 || (c < 8016
              ? (c < 7960
                ? (c < 7424
                  ? c == 7418
                  : (c <= 7615 || (c >= 7680 && c <= 7957)))
                : (c <= 7965 || (c < 8008
                  ? (c >= 7968 && c <= 8005)
                  : c <= 8013)))
              : (c <= 8023 || (c < 8029
                ? (c < 8027
                  ? c == 8025
                  : c <= 8027)
                : (c <= 8029 || (c < 8064
                  ? (c >= 8031 && c <= 8061)
                  : c <= 8116)))))))
          : (c <= 8124 || (c < 8458
            ? (c < 8178
              ? (c < 8144
                ? (c < 8130
                  ? c == 8126
                  : (c <= 8132 || (c >= 8134 && c <= 8140)))
                : (c <= 8147 || (c < 8160
                  ? (c >= 8150 && c <= 8155)
                  : c <= 8172)))
              : (c <= 8180 || (c < 8336
                ? (c < 8305
                  ? (c >= 8182 && c <= 8188)
                  : (c <= 8305 || c == 8319))
                : (c <= 8348 || (c < 8455
                  ? c == 8450
                  : c <= 8455)))))
            : (c <= 8467 || (c < 8495
              ? (c < 8486
                ? (c < 8473
                  ? c == 8469
                  : (c <= 8477 || c == 8484))
                : (c <= 8486 || (c < 8490
                  ? c == 8488
                  : c <= 8493)))
              : (c <= 8505 || (c < 8526
                ? (c < 8517
                  ? (c >= 8508 && c <= 8511)
                  : c <= 8521)
                : (c <= 8526 || (c < 11264
                  ? (c >= 8544 && c <= 8584)
                  : c <= 11310)))))))))
        : (c <= 11358 || (c < 12549
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11360 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12337
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12321
                  ? (c >= 12293 && c <= 12295)
                  : c <= 12329)))
              : (c <= 12341 || (c < 12445
                ? (c < 12353
                  ? (c >= 12344 && c <= 12348)
                  : c <= 12438)
                : (c <= 12447 || (c < 12540
                  ? (c >= 12449 && c <= 12538)
                  : c <= 12543)))))))
          : (c <= 12591 || (c < 42623
            ? (c < 40956
              ? (c < 13312
                ? (c < 12704
                  ? (c >= 12593 && c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))
                : (c <= 13312 || (c < 19968
                  ? c == 19903
                  : c <= 19968)))
              : (c <= 40956 || (c < 42512
                ? (c < 42192
                  ? (c >= 40960 && c <= 42124)
                  : (c <= 42237 || (c >= 42240 && c <= 42508)))
                : (c <= 42527 || (c < 42560
                  ? (c >= 42538 && c <= 42539)
                  : c <= 42606)))))
            : (c <= 42653 || (c < 43011
              ? (c < 42891
                ? (c < 42775
                  ? (c >= 42656 && c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))
                : (c <= 42943 || (c < 42997
                  ? (c >= 42946 && c <= 42954)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66816
          ? (c < 65856
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 65908 || (c < 66464
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66378 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66560
                ? (c < 66513
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66517)
                : (c <= 66717 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67828
            ? (c < 67594
              ? (c < 67424
                ? (c < 67072
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : c <= 67592)))
              : (c <= 67637 || (c < 67680
                ? (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : (c <= 67644 || (c >= 67647 && c <= 67669)))
                : (c <= 67702 || (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)))))
            : (c <= 67829 || (c < 68117
              ? (c < 68030
                ? (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : (c <= 67897 || (c >= 67968 && c <= 68023)))
                : (c <= 68031 || (c < 68112
                  ? c == 68096
                  : c <= 68115)))
              : (c <= 68119 || (c < 68224
                ? (c < 68192
                  ? (c >= 68121 && c <= 68149)
                  : c <= 68220)
                : (c <= 68252 || (c < 68297
                  ? (c >= 68288 && c <= 68295)
                  : c <= 68309)))))))))))))));
}

static inline bool sym__identifier_token_character_set_2(int32_t c) {
  return (c < 6823
    ? (c < 2990
      ? (c < 2384
        ? (c < 1488
          ? (c < 880
            ? (c < 192
              ? (c < 170
                ? (c < '_'
                  ? (c >= 'A' && c <= 'Z')
                  : (c <= '_' || (c >= 'a' && c <= 'z')))
                : (c <= 170 || (c < 186
                  ? c == 181
                  : c <= 186)))
              : (c <= 214 || (c < 736
                ? (c < 248
                  ? (c >= 216 && c <= 246)
                  : (c <= 705 || (c >= 710 && c <= 721)))
                : (c <= 740 || (c < 750
                  ? c == 748
                  : c <= 750)))))
            : (c <= 884 || (c < 910
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : c <= 908)))
              : (c <= 929 || (c < 1329
                ? (c < 1015
                  ? (c >= 931 && c <= 1013)
                  : (c <= 1153 || (c >= 1162 && c <= 1327)))
                : (c <= 1366 || (c < 1376
                  ? c == 1369
                  : c <= 1416)))))))
          : (c <= 1514 || (c < 1994
            ? (c < 1774
              ? (c < 1649
                ? (c < 1568
                  ? (c >= 1519 && c <= 1522)
                  : (c <= 1610 || (c >= 1646 && c <= 1647)))
                : (c <= 1747 || (c < 1765
                  ? c == 1749
                  : c <= 1766)))
              : (c <= 1775 || (c < 1810
                ? (c < 1791
                  ? (c >= 1786 && c <= 1788)
                  : (c <= 1791 || c == 1808))
                : (c <= 1839 || (c < 1969
                  ? (c >= 1869 && c <= 1957)
                  : c <= 1969)))))
            : (c <= 2026 || (c < 2112
              ? (c < 2074
                ? (c < 2042
                  ? (c >= 2036 && c <= 2037)
                  : (c <= 2042 || (c >= 2048 && c <= 2069)))
                : (c <= 2074 || (c < 2088
                  ? c == 2084
                  : c <= 2088)))
              : (c <= 2136 || (c < 2230
                ? (c < 2208
                  ? (c >= 2144 && c <= 2154)
                  : c <= 2228)
                : (c <= 2247 || (c < 2365
                  ? (c >= 2308 && c <= 2361)
                  : c <= 2365)))))))))
        : (c <= 2384 || (c < 2707
          ? (c < 2556
            ? (c < 2482
              ? (c < 2447
                ? (c < 2417
                  ? (c >= 2392 && c <= 2401)
                  : (c <= 2432 || (c >= 2437 && c <= 2444)))
                : (c <= 2448 || (c < 2474
                  ? (c >= 2451 && c <= 2472)
                  : c <= 2480)))
              : (c <= 2482 || (c < 2524
                ? (c < 2493
                  ? (c >= 2486 && c <= 2489)
                  : (c <= 2493 || c == 2510))
                : (c <= 2525 || (c < 2544
                  ? (c >= 2527 && c <= 2529)
                  : c <= 2545)))))
            : (c <= 2556 || (c < 2616
              ? (c < 2602
                ? (c < 2575
                  ? (c >= 2565 && c <= 2570)
                  : (c <= 2576 || (c >= 2579 && c <= 2600)))
                : (c <= 2608 || (c < 2613
                  ? (c >= 2610 && c <= 2611)
                  : c <= 2614)))
              : (c <= 2617 || (c < 2674
                ? (c < 2654
                  ? (c >= 2649 && c <= 2652)
                  : c <= 2654)
                : (c <= 2676 || (c < 2703
                  ? (c >= 2693 && c <= 2701)
                  : c <= 2705)))))))
          : (c <= 2728 || (c < 2877
            ? (c < 2809
              ? (c < 2749
                ? (c < 2738
                  ? (c >= 2730 && c <= 2736)
                  : (c <= 2739 || (c >= 2741 && c <= 2745)))
                : (c <= 2749 || (c < 2784
                  ? c == 2768
                  : c <= 2785)))
              : (c <= 2809 || (c < 2858
                ? (c < 2831
                  ? (c >= 2821 && c <= 2828)
                  : (c <= 2832 || (c >= 2835 && c <= 2856)))
                : (c <= 2864 || (c < 2869
                  ? (c >= 2866 && c <= 2867)
                  : c <= 2873)))))
            : (c <= 2877 || (c < 2962
              ? (c < 2947
                ? (c < 2911
                  ? (c >= 2908 && c <= 2909)
                  : (c <= 2913 || c == 2929))
                : (c <= 2947 || (c < 2958
                  ? (c >= 2949 && c <= 2954)
                  : c <= 2960)))
              : (c <= 2965 || (c < 2974
                ? (c < 2972
                  ? (c >= 2969 && c <= 2970)
                  : c <= 2972)
                : (c <= 2975 || (c < 2984
                  ? (c >= 2979 && c <= 2980)
                  : c <= 2986)))))))))))
      : (c <= 3001 || (c < 4193
        ? (c < 3461
          ? (c < 3253
            ? (c < 3160
              ? (c < 3090
                ? (c < 3077
                  ? c == 3024
                  : (c <= 3084 || (c >= 3086 && c <= 3088)))
                : (c <= 3112 || (c < 3133
                  ? (c >= 3114 && c <= 3129)
                  : c <= 3133)))
              : (c <= 3162 || (c < 3214
                ? (c < 3200
                  ? (c >= 3168 && c <= 3169)
                  : (c <= 3200 || (c >= 3205 && c <= 3212)))
                : (c <= 3216 || (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : c <= 3251)))))
            : (c <= 3257 || (c < 3346
              ? (c < 3313
                ? (c < 3294
                  ? c == 3261
                  : (c <= 3294 || (c >= 3296 && c <= 3297)))
                : (c <= 3314 || (c < 3342
                  ? (c >= 3332 && c <= 3340)
                  : c <= 3344)))
              : (c <= 3386 || (c < 3412
                ? (c < 3406
                  ? c == 3389
                  : c <= 3406)
                : (c <= 3414 || (c < 3450
                  ? (c >= 3423 && c <= 3425)
                  : c <= 3455)))))))
          : (c <= 3478 || (c < 3762
            ? (c < 3648
              ? (c < 3520
                ? (c < 3507
                  ? (c >= 3482 && c <= 3505)
                  : (c <= 3515 || c == 3517))
                : (c <= 3526 || (c < 3634
                  ? (c >= 3585 && c <= 3632)
                  : c <= 3635)))
              : (c <= 3654 || (c < 3724
                ? (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : (c <= 3716 || (c >= 3718 && c <= 3722)))
                : (c <= 3747 || (c < 3751
                  ? c == 3749
                  : c <= 3760)))))
            : (c <= 3763 || (c < 3913
              ? (c < 3804
                ? (c < 3776
                  ? c == 3773
                  : (c <= 3780 || c == 3782))
                : (c <= 3807 || (c < 3904
                  ? c == 3840
                  : c <= 3911)))
              : (c <= 3948 || (c < 4159
                ? (c < 4096
                  ? (c >= 3976 && c <= 3980)
                  : c <= 4138)
                : (c <= 4159 || (c < 4186
                  ? (c >= 4176 && c <= 4181)
                  : c <= 4189)))))))))
        : (c <= 4193 || (c < 5112
          ? (c < 4704
            ? (c < 4301
              ? (c < 4238
                ? (c < 4206
                  ? (c >= 4197 && c <= 4198)
                  : (c <= 4208 || (c >= 4213 && c <= 4225)))
                : (c <= 4238 || (c < 4295
                  ? (c >= 4256 && c <= 4293)
                  : c <= 4295)))
              : (c <= 4301 || (c < 4688
                ? (c < 4348
                  ? (c >= 4304 && c <= 4346)
                  : (c <= 4680 || (c >= 4682 && c <= 4685)))
                : (c <= 4694 || (c < 4698
                  ? c == 4696
                  : c <= 4701)))))
            : (c <= 4744 || (c < 4808
              ? (c < 4792
                ? (c < 4752
                  ? (c >= 4746 && c <= 4749)
                  : (c <= 4784 || (c >= 4786 && c <= 4789)))
                : (c <= 4798 || (c < 4802
                  ? c == 4800
                  : c <= 4805)))
              : (c <= 4822 || (c < 4888
                ? (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : c <= 4885)
                : (c <= 4954 || (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : c <= 5109)))))))
          : (c <= 5117 || (c < 6108
            ? (c < 5902
              ? (c < 5792
                ? (c < 5743
                  ? (c >= 5121 && c <= 5740)
                  : (c <= 5759 || (c >= 5761 && c <= 5786)))
                : (c <= 5866 || (c < 5888
                  ? (c >= 5870 && c <= 5880)
                  : c <= 5900)))
              : (c <= 5905 || (c < 5998
                ? (c < 5952
                  ? (c >= 5920 && c <= 5937)
                  : (c <= 5969 || (c >= 5984 && c <= 5996)))
                : (c <= 6000 || (c < 6103
                  ? (c >= 6016 && c <= 6067)
                  : c <= 6103)))))
            : (c <= 6108 || (c < 6480
              ? (c < 6314
                ? (c < 6272
                  ? (c >= 6176 && c <= 6264)
                  : (c <= 6276 || (c >= 6279 && c <= 6312)))
                : (c <= 6314 || (c < 6400
                  ? (c >= 6320 && c <= 6389)
                  : c <= 6430)))
              : (c <= 6509 || (c < 6576
                ? (c < 6528
                  ? (c >= 6512 && c <= 6516)
                  : c <= 6571)
                : (c <= 6601 || (c < 6688
                  ? (c >= 6656 && c <= 6678)
                  : c <= 6740)))))))))))))
    : (c <= 6823 || (c < 43259
      ? (c < 11312
        ? (c < 8118
          ? (c < 7413
            ? (c < 7245
              ? (c < 7086
                ? (c < 6981
                  ? (c >= 6917 && c <= 6963)
                  : (c <= 6987 || (c >= 7043 && c <= 7072)))
                : (c <= 7087 || (c < 7168
                  ? (c >= 7098 && c <= 7141)
                  : c <= 7203)))
              : (c <= 7247 || (c < 7357
                ? (c < 7296
                  ? (c >= 7258 && c <= 7293)
                  : (c <= 7304 || (c >= 7312 && c <= 7354)))
                : (c <= 7359 || (c < 7406
                  ? (c >= 7401 && c <= 7404)
                  : c <= 7411)))))
            : (c <= 7414 || (c < 8016
              ? (c < 7960
                ? (c < 7424
                  ? c == 7418
                  : (c <= 7615 || (c >= 7680 && c <= 7957)))
                : (c <= 7965 || (c < 8008
                  ? (c >= 7968 && c <= 8005)
                  : c <= 8013)))
              : (c <= 8023 || (c < 8029
                ? (c < 8027
                  ? c == 8025
                  : c <= 8027)
                : (c <= 8029 || (c < 8064
                  ? (c >= 8031 && c <= 8061)
                  : c <= 8116)))))))
          : (c <= 8124 || (c < 8458
            ? (c < 8178
              ? (c < 8144
                ? (c < 8130
                  ? c == 8126
                  : (c <= 8132 || (c >= 8134 && c <= 8140)))
                : (c <= 8147 || (c < 8160
                  ? (c >= 8150 && c <= 8155)
                  : c <= 8172)))
              : (c <= 8180 || (c < 8336
                ? (c < 8305
                  ? (c >= 8182 && c <= 8188)
                  : (c <= 8305 || c == 8319))
                : (c <= 8348 || (c < 8455
                  ? c == 8450
                  : c <= 8455)))))
            : (c <= 8467 || (c < 8495
              ? (c < 8486
                ? (c < 8473
                  ? c == 8469
                  : (c <= 8477 || c == 8484))
                : (c <= 8486 || (c < 8490
                  ? c == 8488
                  : c <= 8493)))
              : (c <= 8505 || (c < 8526
                ? (c < 8517
                  ? (c >= 8508 && c <= 8511)
                  : c <= 8521)
                : (c <= 8526 || (c < 11264
                  ? (c >= 8544 && c <= 8584)
                  : c <= 11310)))))))))
        : (c <= 11358 || (c < 12549
          ? (c < 11712
            ? (c < 11568
              ? (c < 11520
                ? (c < 11499
                  ? (c >= 11360 && c <= 11492)
                  : (c <= 11502 || (c >= 11506 && c <= 11507)))
                : (c <= 11557 || (c < 11565
                  ? c == 11559
                  : c <= 11565)))
              : (c <= 11623 || (c < 11688
                ? (c < 11648
                  ? c == 11631
                  : (c <= 11670 || (c >= 11680 && c <= 11686)))
                : (c <= 11694 || (c < 11704
                  ? (c >= 11696 && c <= 11702)
                  : c <= 11710)))))
            : (c <= 11718 || (c < 12337
              ? (c < 11823
                ? (c < 11728
                  ? (c >= 11720 && c <= 11726)
                  : (c <= 11734 || (c >= 11736 && c <= 11742)))
                : (c <= 11823 || (c < 12321
                  ? (c >= 12293 && c <= 12295)
                  : c <= 12329)))
              : (c <= 12341 || (c < 12445
                ? (c < 12353
                  ? (c >= 12344 && c <= 12348)
                  : c <= 12438)
                : (c <= 12447 || (c < 12540
                  ? (c >= 12449 && c <= 12538)
                  : c <= 12543)))))))
          : (c <= 12591 || (c < 42623
            ? (c < 40956
              ? (c < 13312
                ? (c < 12704
                  ? (c >= 12593 && c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))
                : (c <= 13312 || (c < 19968
                  ? c == 19903
                  : c <= 19968)))
              : (c <= 40956 || (c < 42512
                ? (c < 42192
                  ? (c >= 40960 && c <= 42124)
                  : (c <= 42237 || (c >= 42240 && c <= 42508)))
                : (c <= 42527 || (c < 42560
                  ? (c >= 42538 && c <= 42539)
                  : c <= 42606)))))
            : (c <= 42653 || (c < 43011
              ? (c < 42891
                ? (c < 42775
                  ? (c >= 42656 && c <= 42735)
                  : (c <= 42783 || (c >= 42786 && c <= 42888)))
                : (c <= 42943 || (c < 42997
                  ? (c >= 42946 && c <= 42954)
                  : c <= 43009)))
              : (c <= 43013 || (c < 43072
                ? (c < 43020
                  ? (c >= 43015 && c <= 43018)
                  : c <= 43042)
                : (c <= 43123 || (c < 43250
                  ? (c >= 43138 && c <= 43187)
                  : c <= 43255)))))))))))
      : (c <= 43259 || (c < 65313
        ? (c < 43808
          ? (c < 43642
            ? (c < 43488
              ? (c < 43360
                ? (c < 43274
                  ? (c >= 43261 && c <= 43262)
                  : (c <= 43301 || (c >= 43312 && c <= 43334)))
                : (c <= 43388 || (c < 43471
                  ? (c >= 43396 && c <= 43442)
                  : c <= 43471)))
              : (c <= 43492 || (c < 43584
                ? (c < 43514
                  ? (c >= 43494 && c <= 43503)
                  : (c <= 43518 || (c >= 43520 && c <= 43560)))
                : (c <= 43586 || (c < 43616
                  ? (c >= 43588 && c <= 43595)
                  : c <= 43638)))))
            : (c <= 43642 || (c < 43739
              ? (c < 43705
                ? (c < 43697
                  ? (c >= 43646 && c <= 43695)
                  : (c <= 43697 || (c >= 43701 && c <= 43702)))
                : (c <= 43709 || (c < 43714
                  ? c == 43712
                  : c <= 43714)))
              : (c <= 43741 || (c < 43777
                ? (c < 43762
                  ? (c >= 43744 && c <= 43754)
                  : c <= 43764)
                : (c <= 43782 || (c < 43793
                  ? (c >= 43785 && c <= 43790)
                  : c <= 43798)))))))
          : (c <= 43814 || (c < 64287
            ? (c < 55216
              ? (c < 43888
                ? (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : (c <= 43866 || (c >= 43868 && c <= 43881)))
                : (c <= 44002 || (c < 55203
                  ? c == 44032
                  : c <= 55203)))
              : (c <= 55238 || (c < 64256
                ? (c < 63744
                  ? (c >= 55243 && c <= 55291)
                  : (c <= 64109 || (c >= 64112 && c <= 64217)))
                : (c <= 64262 || (c < 64285
                  ? (c >= 64275 && c <= 64279)
                  : c <= 64285)))))
            : (c <= 64296 || (c < 64467
              ? (c < 64320
                ? (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))
                : (c <= 64321 || (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : c <= 64433)))
              : (c <= 64829 || (c < 65008
                ? (c < 64914
                  ? (c >= 64848 && c <= 64911)
                  : c <= 64967)
                : (c <= 65019 || (c < 65142
                  ? (c >= 65136 && c <= 65140)
                  : c <= 65276)))))))))
        : (c <= 65338 || (c < 66816
          ? (c < 65856
            ? (c < 65536
              ? (c < 65482
                ? (c < 65382
                  ? (c >= 65345 && c <= 65370)
                  : (c <= 65470 || (c >= 65474 && c <= 65479)))
                : (c <= 65487 || (c < 65498
                  ? (c >= 65490 && c <= 65495)
                  : c <= 65500)))
              : (c <= 65547 || (c < 65599
                ? (c < 65576
                  ? (c >= 65549 && c <= 65574)
                  : (c <= 65594 || (c >= 65596 && c <= 65597)))
                : (c <= 65613 || (c < 65664
                  ? (c >= 65616 && c <= 65629)
                  : c <= 65786)))))
            : (c <= 65908 || (c < 66464
              ? (c < 66349
                ? (c < 66208
                  ? (c >= 66176 && c <= 66204)
                  : (c <= 66256 || (c >= 66304 && c <= 66335)))
                : (c <= 66378 || (c < 66432
                  ? (c >= 66384 && c <= 66421)
                  : c <= 66461)))
              : (c <= 66499 || (c < 66560
                ? (c < 66513
                  ? (c >= 66504 && c <= 66511)
                  : c <= 66517)
                : (c <= 66717 || (c < 66776
                  ? (c >= 66736 && c <= 66771)
                  : c <= 66811)))))))
          : (c <= 66855 || (c < 67828
            ? (c < 67594
              ? (c < 67424
                ? (c < 67072
                  ? (c >= 66864 && c <= 66915)
                  : (c <= 67382 || (c >= 67392 && c <= 67413)))
                : (c <= 67431 || (c < 67592
                  ? (c >= 67584 && c <= 67589)
                  : c <= 67592)))
              : (c <= 67637 || (c < 67680
                ? (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : (c <= 67644 || (c >= 67647 && c <= 67669)))
                : (c <= 67702 || (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : c <= 67826)))))
            : (c <= 67829 || (c < 68117
              ? (c < 68030
                ? (c < 67872
                  ? (c >= 67840 && c <= 67861)
                  : (c <= 67897 || (c >= 67968 && c <= 68023)))
                : (c <= 68031 || (c < 68112
                  ? c == 68096
                  : c <= 68115)))
              : (c <= 68119 || (c < 68224
                ? (c < 68192
                  ? (c >= 68121 && c <= 68149)
                  : c <= 68220)
                : (c <= 68252 || (c < 68297
                  ? (c >= 68288 && c <= 68295)
                  : c <= 68309)))))))))))))));
}

static inline bool sym__identifier_token_character_set_3(int32_t c) {
  return (c < 6112
    ? (c < 2972
      ? (c < 2474
        ? (c < 1471
          ? (c < 768
            ? (c < 186
              ? (c < 'a'
                ? (c < 'A'
                  ? (c >= '0' && c <= '9')
                  : (c <= 'Z' || c == '_'))
                : (c <= 'z' || (c < 173
                  ? c == 170
                  : (c <= 173 || c == 181))))
              : (c <= 186 || (c < 710
                ? (c < 216
                  ? (c >= 192 && c <= 214)
                  : (c <= 246 || (c >= 248 && c <= 705)))
                : (c <= 721 || (c < 748
                  ? (c >= 736 && c <= 740)
                  : (c <= 748 || c == 750))))))
            : (c <= 884 || (c < 931
              ? (c < 902
                ? (c < 890
                  ? (c >= 886 && c <= 887)
                  : (c <= 893 || c == 895))
                : (c <= 902 || (c < 908
                  ? (c >= 904 && c <= 906)
                  : (c <= 908 || (c >= 910 && c <= 929)))))
              : (c <= 1013 || (c < 1329
                ? (c < 1155
                  ? (c >= 1015 && c <= 1153)
                  : (c <= 1159 || (c >= 1162 && c <= 1327)))
                : (c <= 1366 || (c < 1376
                  ? c == 1369
                  : (c <= 1416 || (c >= 1425 && c <= 1469)))))))))
          : (c <= 1471 || (c < 1869
            ? (c < 1564
              ? (c < 1488
                ? (c < 1476
                  ? (c >= 1473 && c <= 1474)
                  : (c <= 1477 || c == 1479))
                : (c <= 1514 || (c < 1536
                  ? (c >= 1519 && c <= 1522)
                  : (c <= 1541 || (c >= 1552 && c <= 1562)))))
              : (c <= 1564 || (c < 1759
                ? (c < 1646
                  ? (c >= 1568 && c <= 1641)
                  : (c <= 1747 || (c >= 1749 && c <= 1757)))
                : (c <= 1768 || (c < 1791
                  ? (c >= 1770 && c <= 1788)
                  : (c <= 1791 || (c >= 1807 && c <= 1866)))))))
            : (c <= 1969 || (c < 2230
              ? (c < 2048
                ? (c < 2042
                  ? (c >= 1984 && c <= 2037)
                  : (c <= 2042 || c == 2045))
                : (c <= 2093 || (c < 2144
                  ? (c >= 2112 && c <= 2139)
                  : (c <= 2154 || (c >= 2208 && c <= 2228)))))
              : (c <= 2247 || (c < 2437
                ? (c < 2406
                  ? (c >= 2259 && c <= 2403)
                  : (c <= 2415 || (c >= 2417 && c <= 2435)))
                : (c <= 2444 || (c < 2451
                  ? (c >= 2447 && c <= 2448)
                  : c <= 2472)))))))))
        : (c <= 2480 || (c < 2707
          ? (c < 2602
            ? (c < 2527
              ? (c < 2503
                ? (c < 2486
                  ? c == 2482
                  : (c <= 2489 || (c >= 2492 && c <= 2500)))
                : (c <= 2504 || (c < 2519
                  ? (c >= 2507 && c <= 2510)
                  : (c <= 2519 || (c >= 2524 && c <= 2525)))))
              : (c <= 2531 || (c < 2561
                ? (c < 2556
                  ? (c >= 2534 && c <= 2545)
                  : (c <= 2556 || c == 2558))
                : (c <= 2563 || (c < 2575
                  ? (c >= 2565 && c <= 2570)
                  : (c <= 2576 || (c >= 2579 && c <= 2600)))))))
            : (c <= 2608 || (c < 2641
              ? (c < 2620
                ? (c < 2613
                  ? (c >= 2610 && c <= 2611)
                  : (c <= 2614 || (c >= 2616 && c <= 2617)))
                : (c <= 2620 || (c < 2631
                  ? (c >= 2622 && c <= 2626)
                  : (c <= 2632 || (c >= 2635 && c <= 2637)))))
              : (c <= 2641 || (c < 2689
                ? (c < 2654
                  ? (c >= 2649 && c <= 2652)
                  : (c <= 2654 || (c >= 2662 && c <= 2677)))
                : (c <= 2691 || (c < 2703
                  ? (c >= 2693 && c <= 2701)
                  : c <= 2705)))))))
          : (c <= 2728 || (c < 2866
            ? (c < 2784
              ? (c < 2748
                ? (c < 2738
                  ? (c >= 2730 && c <= 2736)
                  : (c <= 2739 || (c >= 2741 && c <= 2745)))
                : (c <= 2757 || (c < 2763
                  ? (c >= 2759 && c <= 2761)
                  : (c <= 2765 || c == 2768))))
              : (c <= 2787 || (c < 2821
                ? (c < 2809
                  ? (c >= 2790 && c <= 2799)
                  : (c <= 2815 || (c >= 2817 && c <= 2819)))
                : (c <= 2828 || (c < 2835
                  ? (c >= 2831 && c <= 2832)
                  : (c <= 2856 || (c >= 2858 && c <= 2864)))))))
            : (c <= 2867 || (c < 2918
              ? (c < 2891
                ? (c < 2876
                  ? (c >= 2869 && c <= 2873)
                  : (c <= 2884 || (c >= 2887 && c <= 2888)))
                : (c <= 2893 || (c < 2908
                  ? (c >= 2901 && c <= 2903)
                  : (c <= 2909 || (c >= 2911 && c <= 2915)))))
              : (c <= 2927 || (c < 2958
                ? (c < 2946
                  ? c == 2929
                  : (c <= 2947 || (c >= 2949 && c <= 2954)))
                : (c <= 2960 || (c < 2969
                  ? (c >= 2962 && c <= 2965)
                  : c <= 2970)))))))))))
      : (c <= 2972 || (c < 3718
        ? (c < 3285
          ? (c < 3142
            ? (c < 3024
              ? (c < 2990
                ? (c < 2979
                  ? (c >= 2974 && c <= 2975)
                  : (c <= 2980 || (c >= 2984 && c <= 2986)))
                : (c <= 3001 || (c < 3014
                  ? (c >= 3006 && c <= 3010)
                  : (c <= 3016 || (c >= 3018 && c <= 3021)))))
              : (c <= 3024 || (c < 3086
                ? (c < 3046
                  ? c == 3031
                  : (c <= 3055 || (c >= 3072 && c <= 3084)))
                : (c <= 3088 || (c < 3114
                  ? (c >= 3090 && c <= 3112)
                  : (c <= 3129 || (c >= 3133 && c <= 3140)))))))
            : (c <= 3144 || (c < 3214
              ? (c < 3168
                ? (c < 3157
                  ? (c >= 3146 && c <= 3149)
                  : (c <= 3158 || (c >= 3160 && c <= 3162)))
                : (c <= 3171 || (c < 3200
                  ? (c >= 3174 && c <= 3183)
                  : (c <= 3203 || (c >= 3205 && c <= 3212)))))
              : (c <= 3216 || (c < 3260
                ? (c < 3242
                  ? (c >= 3218 && c <= 3240)
                  : (c <= 3251 || (c >= 3253 && c <= 3257)))
                : (c <= 3268 || (c < 3274
                  ? (c >= 3270 && c <= 3272)
                  : c <= 3277)))))))
          : (c <= 3286 || (c < 3482
            ? (c < 3398
              ? (c < 3313
                ? (c < 3296
                  ? c == 3294
                  : (c <= 3299 || (c >= 3302 && c <= 3311)))
                : (c <= 3314 || (c < 3342
                  ? (c >= 3328 && c <= 3340)
                  : (c <= 3344 || (c >= 3346 && c <= 3396)))))
              : (c <= 3400 || (c < 3430
                ? (c < 3412
                  ? (c >= 3402 && c <= 3406)
                  : (c <= 3415 || (c >= 3423 && c <= 3427)))
                : (c <= 3439 || (c < 3457
                  ? (c >= 3450 && c <= 3455)
                  : (c <= 3459 || (c >= 3461 && c <= 3478)))))))
            : (c <= 3505 || (c < 3558
              ? (c < 3530
                ? (c < 3517
                  ? (c >= 3507 && c <= 3515)
                  : (c <= 3517 || (c >= 3520 && c <= 3526)))
                : (c <= 3530 || (c < 3542
                  ? (c >= 3535 && c <= 3540)
                  : (c <= 3542 || (c >= 3544 && c <= 3551)))))
              : (c <= 3567 || (c < 3664
                ? (c < 3585
                  ? (c >= 3570 && c <= 3571)
                  : (c <= 3642 || (c >= 3648 && c <= 3662)))
                : (c <= 3673 || (c < 3716
                  ? (c >= 3713 && c <= 3714)
                  : c <= 3716)))))))))
        : (c <= 3722 || (c < 4698
          ? (c < 3913
            ? (c < 3804
              ? (c < 3776
                ? (c < 3749
                  ? (c >= 3724 && c <= 3747)
                  : (c <= 3749 || (c >= 3751 && c <= 3773)))
                : (c <= 3780 || (c < 3784
                  ? c == 3782
                  : (c <= 3789 || (c >= 3792 && c <= 3801)))))
              : (c <= 3807 || (c < 3893
                ? (c < 3864
                  ? c == 3840
                  : (c <= 3865 || (c >= 3872 && c <= 3881)))
                : (c <= 3893 || (c < 3897
                  ? c == 3895
                  : (c <= 3897 || (c >= 3902 && c <= 3911)))))))
            : (c <= 3948 || (c < 4295
              ? (c < 4038
                ? (c < 3974
                  ? (c >= 3953 && c <= 3972)
                  : (c <= 3991 || (c >= 3993 && c <= 4028)))
                : (c <= 4038 || (c < 4176
                  ? (c >= 4096 && c <= 4169)
                  : (c <= 4253 || (c >= 4256 && c <= 4293)))))
              : (c <= 4295 || (c < 4682
                ? (c < 4304
                  ? c == 4301
                  : (c <= 4346 || (c >= 4348 && c <= 4680)))
                : (c <= 4685 || (c < 4696
                  ? (c >= 4688 && c <= 4694)
                  : c <= 4696)))))))
          : (c <= 4701 || (c < 5121
            ? (c < 4808
              ? (c < 4786
                ? (c < 4746
                  ? (c >= 4704 && c <= 4744)
                  : (c <= 4749 || (c >= 4752 && c <= 4784)))
                : (c <= 4789 || (c < 4800
                  ? (c >= 4792 && c <= 4798)
                  : (c <= 4800 || (c >= 4802 && c <= 4805)))))
              : (c <= 4822 || (c < 4957
                ? (c < 4882
                  ? (c >= 4824 && c <= 4880)
                  : (c <= 4885 || (c >= 4888 && c <= 4954)))
                : (c <= 4959 || (c < 5024
                  ? (c >= 4992 && c <= 5007)
                  : (c <= 5109 || (c >= 5112 && c <= 5117)))))))
            : (c <= 5740 || (c < 5952
              ? (c < 5870
                ? (c < 5761
                  ? (c >= 5743 && c <= 5759)
                  : (c <= 5786 || (c >= 5792 && c <= 5866)))
                : (c <= 5880 || (c < 5902
                  ? (c >= 5888 && c <= 5900)
                  : (c <= 5908 || (c >= 5920 && c <= 5940)))))
              : (c <= 5971 || (c < 6016
                ? (c < 5998
                  ? (c >= 5984 && c <= 5996)
                  : (c <= 6000 || (c >= 6002 && c <= 6003)))
                : (c <= 6099 || (c < 6108
                  ? c == 6103
                  : c <= 6109)))))))))))))
    : (c <= 6121 || (c < 42775
      ? (c < 8336
        ? (c < 7357
          ? (c < 6752
            ? (c < 6448
              ? (c < 6272
                ? (c < 6160
                  ? (c >= 6155 && c <= 6158)
                  : (c <= 6169 || (c >= 6176 && c <= 6264)))
                : (c <= 6314 || (c < 6400
                  ? (c >= 6320 && c <= 6389)
                  : (c <= 6430 || (c >= 6432 && c <= 6443)))))
              : (c <= 6459 || (c < 6576
                ? (c < 6512
                  ? (c >= 6470 && c <= 6509)
                  : (c <= 6516 || (c >= 6528 && c <= 6571)))
                : (c <= 6601 || (c < 6656
                  ? (c >= 6608 && c <= 6617)
                  : (c <= 6683 || (c >= 6688 && c <= 6750)))))))
            : (c <= 6780 || (c < 7019
              ? (c < 6832
                ? (c < 6800
                  ? (c >= 6783 && c <= 6793)
                  : (c <= 6809 || c == 6823))
                : (c <= 6845 || (c < 6912
                  ? (c >= 6847 && c <= 6848)
                  : (c <= 6987 || (c >= 6992 && c <= 7001)))))
              : (c <= 7027 || (c < 7245
                ? (c < 7168
                  ? (c >= 7040 && c <= 7155)
                  : (c <= 7223 || (c >= 7232 && c <= 7241)))
                : (c <= 7293 || (c < 7312
                  ? (c >= 7296 && c <= 7304)
                  : c <= 7354)))))))
          : (c <= 7359 || (c < 8130
            ? (c < 8016
              ? (c < 7675
                ? (c < 7380
                  ? (c >= 7376 && c <= 7378)
                  : (c <= 7418 || (c >= 7424 && c <= 7673)))
                : (c <= 7957 || (c < 7968
                  ? (c >= 7960 && c <= 7965)
                  : (c <= 8005 || (c >= 8008 && c <= 8013)))))
              : (c <= 8023 || (c < 8031
                ? (c < 8027
                  ? c == 8025
                  : (c <= 8027 || c == 8029))
                : (c <= 8061 || (c < 8118
                  ? (c >= 8064 && c <= 8116)
                  : (c <= 8124 || c == 8126))))))
            : (c <= 8132 || (c < 8234
              ? (c < 8160
                ? (c < 8144
                  ? (c >= 8134 && c <= 8140)
                  : (c <= 8147 || (c >= 8150 && c <= 8155)))
                : (c <= 8172 || (c < 8182
                  ? (c >= 8178 && c <= 8180)
                  : (c <= 8188 || (c >= 8203 && c <= 8207)))))
              : (c <= 8238 || (c < 8294
                ? (c < 8276
                  ? (c >= 8255 && c <= 8256)
                  : (c <= 8276 || (c >= 8288 && c <= 8292)))
                : (c <= 8303 || (c < 8319
                  ? c == 8305
                  : c <= 8319)))))))))
        : (c <= 8348 || (c < 11704
          ? (c < 8526
            ? (c < 8473
              ? (c < 8450
                ? (c < 8417
                  ? (c >= 8400 && c <= 8412)
                  : (c <= 8417 || (c >= 8421 && c <= 8432)))
                : (c <= 8450 || (c < 8458
                  ? c == 8455
                  : (c <= 8467 || c == 8469))))
              : (c <= 8477 || (c < 8490
                ? (c < 8486
                  ? c == 8484
                  : (c <= 8486 || c == 8488))
                : (c <= 8493 || (c < 8508
                  ? (c >= 8495 && c <= 8505)
                  : (c <= 8511 || (c >= 8517 && c <= 8521)))))))
            : (c <= 8526 || (c < 11565
              ? (c < 11360
                ? (c < 11264
                  ? (c >= 8544 && c <= 8584)
                  : (c <= 11310 || (c >= 11312 && c <= 11358)))
                : (c <= 11492 || (c < 11520
                  ? (c >= 11499 && c <= 11507)
                  : (c <= 11557 || c == 11559))))
              : (c <= 11565 || (c < 11680
                ? (c < 11631
                  ? (c >= 11568 && c <= 11623)
                  : (c <= 11631 || (c >= 11647 && c <= 11670)))
                : (c <= 11686 || (c < 11696
                  ? (c >= 11688 && c <= 11694)
                  : c <= 11702)))))))
          : (c <= 11710 || (c < 12549
            ? (c < 12321
              ? (c < 11736
                ? (c < 11720
                  ? (c >= 11712 && c <= 11718)
                  : (c <= 11726 || (c >= 11728 && c <= 11734)))
                : (c <= 11742 || (c < 11823
                  ? (c >= 11744 && c <= 11775)
                  : (c <= 11823 || (c >= 12293 && c <= 12295)))))
              : (c <= 12335 || (c < 12441
                ? (c < 12344
                  ? (c >= 12337 && c <= 12341)
                  : (c <= 12348 || (c >= 12353 && c <= 12438)))
                : (c <= 12442 || (c < 12449
                  ? (c >= 12445 && c <= 12447)
                  : (c <= 12538 || (c >= 12540 && c <= 12543)))))))
            : (c <= 12591 || (c < 40960
              ? (c < 13312
                ? (c < 12704
                  ? (c >= 12593 && c <= 12686)
                  : (c <= 12735 || (c >= 12784 && c <= 12799)))
                : (c <= 13312 || (c < 19968
                  ? c == 19903
                  : (c <= 19968 || c == 40956))))
              : (c <= 42124 || (c < 42560
                ? (c < 42240
                  ? (c >= 42192 && c <= 42237)
                  : (c <= 42508 || (c >= 42512 && c <= 42539)))
                : (c <= 42607 || (c < 42623
                  ? (c >= 42612 && c <= 42621)
                  : c <= 42737)))))))))))
      : (c <= 42783 || (c < 65313
        ? (c < 43868
          ? (c < 43488
            ? (c < 43216
              ? (c < 42997
                ? (c < 42891
                  ? (c >= 42786 && c <= 42888)
                  : (c <= 42943 || (c >= 42946 && c <= 42954)))
                : (c <= 43047 || (c < 43072
                  ? c == 43052
                  : (c <= 43123 || (c >= 43136 && c <= 43205)))))
              : (c <= 43225 || (c < 43312
                ? (c < 43259
                  ? (c >= 43232 && c <= 43255)
                  : (c <= 43259 || (c >= 43261 && c <= 43309)))
                : (c <= 43347 || (c < 43392
                  ? (c >= 43360 && c <= 43388)
                  : (c <= 43456 || (c >= 43471 && c <= 43481)))))))
            : (c <= 43518 || (c < 43762
              ? (c < 43616
                ? (c < 43584
                  ? (c >= 43520 && c <= 43574)
                  : (c <= 43597 || (c >= 43600 && c <= 43609)))
                : (c <= 43638 || (c < 43739
                  ? (c >= 43642 && c <= 43714)
                  : (c <= 43741 || (c >= 43744 && c <= 43759)))))
              : (c <= 43766 || (c < 43808
                ? (c < 43785
                  ? (c >= 43777 && c <= 43782)
                  : (c <= 43790 || (c >= 43793 && c <= 43798)))
                : (c <= 43814 || (c < 43824
                  ? (c >= 43816 && c <= 43822)
                  : c <= 43866)))))))
          : (c <= 43881 || (c < 64320
            ? (c < 63744
              ? (c < 44032
                ? (c < 44012
                  ? (c >= 43888 && c <= 44010)
                  : (c <= 44013 || (c >= 44016 && c <= 44025)))
                : (c <= 44032 || (c < 55216
                  ? c == 55203
                  : (c <= 55238 || (c >= 55243 && c <= 55291)))))
              : (c <= 64109 || (c < 64285
                ? (c < 64256
                  ? (c >= 64112 && c <= 64217)
                  : (c <= 64262 || (c >= 64275 && c <= 64279)))
                : (c <= 64296 || (c < 64312
                  ? (c >= 64298 && c <= 64310)
                  : (c <= 64316 || c == 64318))))))
            : (c <= 64321 || (c < 65056
              ? (c < 64848
                ? (c < 64326
                  ? (c >= 64323 && c <= 64324)
                  : (c <= 64433 || (c >= 64467 && c <= 64829)))
                : (c <= 64911 || (c < 65008
                  ? (c >= 64914 && c <= 64967)
                  : (c <= 65019 || (c >= 65024 && c <= 65039)))))
              : (c <= 65071 || (c < 65142
                ? (c < 65101
                  ? (c >= 65075 && c <= 65076)
                  : (c <= 65103 || (c >= 65136 && c <= 65140)))
                : (c <= 65276 || (c < 65296
                  ? c == 65279
                  : c <= 65305)))))))))
        : (c <= 65338 || (c < 66776
          ? (c < 65856
            ? (c < 65529
              ? (c < 65474
                ? (c < 65345
                  ? c == 65343
                  : (c <= 65370 || (c >= 65382 && c <= 65470)))
                : (c <= 65479 || (c < 65490
                  ? (c >= 65482 && c <= 65487)
                  : (c <= 65495 || (c >= 65498 && c <= 65500)))))
              : (c <= 65531 || (c < 65596
                ? (c < 65549
                  ? (c >= 65536 && c <= 65547)
                  : (c <= 65574 || (c >= 65576 && c <= 65594)))
                : (c <= 65597 || (c < 65616
                  ? (c >= 65599 && c <= 65613)
                  : (c <= 65629 || (c >= 65664 && c <= 65786)))))))
            : (c <= 65908 || (c < 66432
              ? (c < 66272
                ? (c < 66176
                  ? c == 66045
                  : (c <= 66204 || (c >= 66208 && c <= 66256)))
                : (c <= 66272 || (c < 66349
                  ? (c >= 66304 && c <= 66335)
                  : (c <= 66378 || (c >= 66384 && c <= 66426)))))
              : (c <= 66461 || (c < 66560
                ? (c < 66504
                  ? (c >= 66464 && c <= 66499)
                  : (c <= 66511 || (c >= 66513 && c <= 66517)))
                : (c <= 66717 || (c < 66736
                  ? (c >= 66720 && c <= 66729)
                  : c <= 66771)))))))
          : (c <= 66811 || (c < 67840
            ? (c < 67594
              ? (c < 67392
                ? (c < 66864
                  ? (c >= 66816 && c <= 66855)
                  : (c <= 66915 || (c >= 67072 && c <= 67382)))
                : (c <= 67413 || (c < 67584
                  ? (c >= 67424 && c <= 67431)
                  : (c <= 67589 || c == 67592))))
              : (c <= 67637 || (c < 67680
                ? (c < 67644
                  ? (c >= 67639 && c <= 67640)
                  : (c <= 67644 || (c >= 67647 && c <= 67669)))
                : (c <= 67702 || (c < 67808
                  ? (c >= 67712 && c <= 67742)
                  : (c <= 67826 || (c >= 67828 && c <= 67829)))))))
            : (c <= 67861 || (c < 68121
              ? (c < 68096
                ? (c < 67968
                  ? (c >= 67872 && c <= 67897)
                  : (c <= 68023 || (c >= 68030 && c <= 68031)))
                : (c <= 68099 || (c < 68108
                  ? (c >= 68101 && c <= 68102)
                  : (c <= 68115 || (c >= 68117 && c <= 68119)))))
              : (c <= 68149 || (c < 68224
                ? (c < 68159
                  ? (c >= 68152 && c <= 68154)
                  : (c <= 68159 || (c >= 68192 && c <= 68220)))
                : (c <= 68252 || (c < 68297
                  ? (c >= 68288 && c <= 68295)
                  : c <= 68309)))))))))))))));
}

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(46);
      if (lookahead == '!') ADVANCE(77);
      if (lookahead == '"') ADVANCE(118);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(7);
      if (lookahead == '%') ADVANCE(90);
      if (lookahead == '&') ADVANCE(96);
      if (lookahead == '\'') ADVANCE(150);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(86);
      if (lookahead == '+') ADVANCE(81);
      if (lookahead == ',') ADVANCE(55);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(62);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(159);
      if (lookahead == ':') ADVANCE(66);
      if (lookahead == ';') ADVANCE(47);
      if (lookahead == '<') ADVANCE(52);
      if (lookahead == '=') ADVANCE(48);
      if (lookahead == '>') ADVANCE(58);
      if (lookahead == '?') ADVANCE(75);
      if (lookahead == '@') ADVANCE(8);
      if (lookahead == '[') ADVANCE(63);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '{') ADVANCE(70);
      if (lookahead == '|') ADVANCE(94);
      if (lookahead == '}') ADVANCE(71);
      if (lookahead == '~') ADVANCE(73);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(0)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(160);
      if (sym__identifier_token_character_set_1(lookahead)) ADVANCE(149);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(12)
      if (lookahead == '"') ADVANCE(117);
      if (lookahead == '#') ADVANCE(127);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '{') ADVANCE(70);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(123);
      if (lookahead != 0) ADVANCE(128);
      END_STATE();
    case 2:
      if (lookahead == '\n') SKIP(13)
      if (lookahead == '"') ADVANCE(117);
      if (lookahead == '#') ADVANCE(173);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(169);
      if (lookahead != 0) ADVANCE(174);
      END_STATE();
    case 3:
      if (lookahead == '!') ADVANCE(77);
      if (lookahead == '"') ADVANCE(14);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '%') ADVANCE(90);
      if (lookahead == '&') ADVANCE(96);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(86);
      if (lookahead == '+') ADVANCE(81);
      if (lookahead == ',') ADVANCE(55);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(61);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == ':') ADVANCE(66);
      if (lookahead == ';') ADVANCE(47);
      if (lookahead == '<') ADVANCE(52);
      if (lookahead == '=') ADVANCE(48);
      if (lookahead == '>') ADVANCE(58);
      if (lookahead == '?') ADVANCE(75);
      if (lookahead == '@') ADVANCE(43);
      if (lookahead == '[') ADVANCE(63);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(94);
      if (lookahead == '}') ADVANCE(71);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(3)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(186);
      if (sym__identifier_token_character_set_2(lookahead)) ADVANCE(149);
      END_STATE();
    case 4:
      if (lookahead == '!') ADVANCE(77);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '%') ADVANCE(89);
      if (lookahead == '&') ADVANCE(95);
      if (lookahead == '*') ADVANCE(85);
      if (lookahead == '+') ADVANCE(80);
      if (lookahead == '-') ADVANCE(82);
      if (lookahead == '/') ADVANCE(87);
      if (lookahead == '<') ADVANCE(53);
      if (lookahead == '=') ADVANCE(23);
      if (lookahead == '>') ADVANCE(59);
      if (lookahead == '@') ADVANCE(43);
      if (lookahead == '^') ADVANCE(91);
      if (lookahead == '|') ADVANCE(93);
      if (lookahead == '~') ADVANCE(73);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(4)
      if (sym__identifier_token_character_set_2(lookahead)) ADVANCE(149);
      END_STATE();
    case 5:
      if (lookahead == '!') ADVANCE(76);
      if (lookahead == '"') ADVANCE(14);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(85);
      if (lookahead == ',') ADVANCE(55);
      if (lookahead == '-') ADVANCE(24);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == '/') ADVANCE(19);
      if (lookahead == ':') ADVANCE(22);
      if (lookahead == ';') ADVANCE(47);
      if (lookahead == '<') ADVANCE(51);
      if (lookahead == '=') ADVANCE(49);
      if (lookahead == '>') ADVANCE(56);
      if (lookahead == '?') ADVANCE(74);
      if (lookahead == '@') ADVANCE(43);
      if (lookahead == '[') ADVANCE(63);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '}') ADVANCE(71);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(5)
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(186);
      if (sym__identifier_token_character_set_2(lookahead)) ADVANCE(149);
      END_STATE();
    case 6:
      if (lookahead == '"') ADVANCE(118);
      if (lookahead == '#') ADVANCE(134);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '{') ADVANCE(70);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(130);
      if (lookahead != 0) ADVANCE(136);
      END_STATE();
    case 7:
      if (lookahead == '"') ADVANCE(116);
      if (lookahead == '@') ADVANCE(9);
      END_STATE();
    case 8:
      if (lookahead == '"') ADVANCE(10);
      if (lookahead == '$') ADVANCE(11);
      if (sym__identifier_token_character_set_2(lookahead)) ADVANCE(149);
      END_STATE();
    case 9:
      if (lookahead == '"') ADVANCE(119);
      END_STATE();
    case 10:
      if (lookahead == '"') ADVANCE(175);
      if (lookahead != 0) ADVANCE(10);
      END_STATE();
    case 11:
      if (lookahead == '"') ADVANCE(120);
      END_STATE();
    case 12:
      if (lookahead == '"') ADVANCE(117);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '/') ADVANCE(19);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '{') ADVANCE(70);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(12)
      END_STATE();
    case 13:
      if (lookahead == '"') ADVANCE(117);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '/') ADVANCE(19);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(13)
      END_STATE();
    case 14:
      if (lookahead == '"') ADVANCE(187);
      if (lookahead != 0) ADVANCE(14);
      END_STATE();
    case 15:
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(85);
      if (lookahead == ',') ADVANCE(55);
      if (lookahead == '-') ADVANCE(24);
      if (lookahead == '.') ADVANCE(60);
      if (lookahead == '/') ADVANCE(19);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == ';') ADVANCE(47);
      if (lookahead == '<') ADVANCE(51);
      if (lookahead == '=') ADVANCE(25);
      if (lookahead == '>') ADVANCE(56);
      if (lookahead == '?') ADVANCE(74);
      if (lookahead == '@') ADVANCE(43);
      if (lookahead == '[') ADVANCE(63);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '}') ADVANCE(71);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(15)
      if (sym__identifier_token_character_set_2(lookahead)) ADVANCE(149);
      END_STATE();
    case 16:
      if (lookahead == '#') ADVANCE(153);
      if (lookahead == '/') ADVANCE(152);
      if (lookahead == '\\') ADVANCE(26);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(151);
      if (lookahead != 0 &&
          lookahead != '\'') ADVANCE(151);
      END_STATE();
    case 17:
      if (lookahead == '#') ADVANCE(180);
      if (lookahead == '/') ADVANCE(182);
      if (lookahead == '\n' ||
          lookahead == '\r') SKIP(17)
      if (lookahead == '\t' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(181);
      if (lookahead != 0) ADVANCE(185);
      END_STATE();
    case 18:
      if (lookahead == '#') ADVANCE(141);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(143);
      END_STATE();
    case 19:
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '/') ADVANCE(177);
      END_STATE();
    case 20:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead == '/') ADVANCE(176);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 21:
      if (lookahead == '*') ADVANCE(20);
      if (lookahead != 0) ADVANCE(21);
      END_STATE();
    case 22:
      if (lookahead == ':') ADVANCE(50);
      END_STATE();
    case 23:
      if (lookahead == '=') ADVANCE(101);
      END_STATE();
    case 24:
      if (lookahead == '>') ADVANCE(144);
      END_STATE();
    case 25:
      if (lookahead == '>') ADVANCE(72);
      END_STATE();
    case 26:
      if (lookahead == 'U') ADVANCE(42);
      if (lookahead == 'u') ADVANCE(38);
      if (lookahead == 'x') ADVANCE(35);
      if (lookahead != 0) ADVANCE(154);
      END_STATE();
    case 27:
      if (lookahead == '_') ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(160);
      END_STATE();
    case 28:
      if (lookahead == '_') ADVANCE(28);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(161);
      END_STATE();
    case 29:
      if (lookahead == '_') ADVANCE(29);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 30:
      if (lookahead == '_') ADVANCE(30);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(166);
      END_STATE();
    case 31:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(167);
      END_STATE();
    case 32:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(166);
      END_STATE();
    case 33:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(167);
      END_STATE();
    case 34:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(154);
      END_STATE();
    case 35:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(157);
      END_STATE();
    case 36:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(34);
      END_STATE();
    case 37:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(36);
      END_STATE();
    case 38:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(37);
      END_STATE();
    case 39:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(38);
      END_STATE();
    case 40:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(39);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(40);
      END_STATE();
    case 42:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(41);
      END_STATE();
    case 43:
      if (sym__identifier_token_character_set_2(lookahead)) ADVANCE(149);
      END_STATE();
    case 44:
      if (eof) ADVANCE(46);
      if (lookahead == '!') ADVANCE(77);
      if (lookahead == '"') ADVANCE(117);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(7);
      if (lookahead == '%') ADVANCE(90);
      if (lookahead == '&') ADVANCE(96);
      if (lookahead == '\'') ADVANCE(150);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(86);
      if (lookahead == '+') ADVANCE(81);
      if (lookahead == ',') ADVANCE(55);
      if (lookahead == '-') ADVANCE(83);
      if (lookahead == '.') ADVANCE(62);
      if (lookahead == '/') ADVANCE(88);
      if (lookahead == '0') ADVANCE(159);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == ';') ADVANCE(47);
      if (lookahead == '<') ADVANCE(52);
      if (lookahead == '=') ADVANCE(48);
      if (lookahead == '>') ADVANCE(58);
      if (lookahead == '?') ADVANCE(75);
      if (lookahead == '@') ADVANCE(8);
      if (lookahead == '[') ADVANCE(63);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead == '^') ADVANCE(92);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '|') ADVANCE(94);
      if (lookahead == '}') ADVANCE(71);
      if (lookahead == '~') ADVANCE(73);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(44)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(160);
      if (sym__identifier_token_character_set_2(lookahead)) ADVANCE(149);
      END_STATE();
    case 45:
      if (eof) ADVANCE(46);
      if (lookahead == '!') ADVANCE(76);
      if (lookahead == '"') ADVANCE(117);
      if (lookahead == '#') ADVANCE(179);
      if (lookahead == '$') ADVANCE(7);
      if (lookahead == '&') ADVANCE(95);
      if (lookahead == '\'') ADVANCE(150);
      if (lookahead == '(') ADVANCE(67);
      if (lookahead == ')') ADVANCE(68);
      if (lookahead == '*') ADVANCE(85);
      if (lookahead == '+') ADVANCE(80);
      if (lookahead == ',') ADVANCE(55);
      if (lookahead == '-') ADVANCE(84);
      if (lookahead == '.') ADVANCE(62);
      if (lookahead == '/') ADVANCE(19);
      if (lookahead == '0') ADVANCE(159);
      if (lookahead == ':') ADVANCE(65);
      if (lookahead == ';') ADVANCE(47);
      if (lookahead == '<') ADVANCE(54);
      if (lookahead == '=') ADVANCE(25);
      if (lookahead == '>') ADVANCE(57);
      if (lookahead == '?') ADVANCE(74);
      if (lookahead == '@') ADVANCE(8);
      if (lookahead == '[') ADVANCE(63);
      if (lookahead == ']') ADVANCE(64);
      if (lookahead == '^') ADVANCE(91);
      if (lookahead == '{') ADVANCE(69);
      if (lookahead == '}') ADVANCE(71);
      if (lookahead == '~') ADVANCE(73);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(45)
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(160);
      if (sym__identifier_token_character_set_2(lookahead)) ADVANCE(149);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=') ADVANCE(101);
      if (lookahead == '>') ADVANCE(72);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '>') ADVANCE(72);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_COLON_COLON);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(anon_sym_LT);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(98);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<') ADVANCE(97);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=') ADVANCE(104);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(103);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(100);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=') ADVANCE(103);
      if (lookahead == '>') ADVANCE(99);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(145);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.') ADVANCE(145);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(166);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 66:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == ':') ADVANCE(50);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      if (lookahead == '{') ADVANCE(121);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_EQ_GT);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_QMARK);
      if (lookahead == '?') ADVANCE(148);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '=') ADVANCE(102);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_DASH_DASH);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(78);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '+') ADVANCE(78);
      if (lookahead == '=') ADVANCE(105);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(79);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(79);
      if (lookahead == '=') ADVANCE(106);
      if (lookahead == '>') ADVANCE(144);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '-') ADVANCE(79);
      if (lookahead == '>') ADVANCE(144);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '=') ADVANCE(107);
      END_STATE();
    case 87:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '/') ADVANCE(177);
      END_STATE();
    case 88:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead == '=') ADVANCE(108);
      END_STATE();
    case 89:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=') ADVANCE(109);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=') ADVANCE(111);
      END_STATE();
    case 93:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 94:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=') ADVANCE(112);
      if (lookahead == '|') ADVANCE(147);
      END_STATE();
    case 95:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 96:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '&') ADVANCE(146);
      if (lookahead == '=') ADVANCE(110);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=') ADVANCE(113);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 100:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=') ADVANCE(114);
      END_STATE();
    case 101:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 102:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 103:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 106:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 107:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 108:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 109:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 110:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 111:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 115:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK_EQ);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_DOLLAR_DQUOTE);
      END_STATE();
    case 117:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 118:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(129);
      END_STATE();
    case 119:
      ACCEPT_TOKEN(anon_sym_DOLLAR_AT_DQUOTE);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_AT_DOLLAR_DQUOTE);
      END_STATE();
    case 121:
      ACCEPT_TOKEN(anon_sym_LBRACE_LBRACE);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(sym__interpolated_string_text_fragment);
      if (lookahead == '\r') ADVANCE(128);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{') ADVANCE(122);
      END_STATE();
    case 123:
      ACCEPT_TOKEN(sym__interpolated_string_text_fragment);
      if (lookahead == '#') ADVANCE(127);
      if (lookahead == '/') ADVANCE(124);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(123);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{') ADVANCE(128);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(sym__interpolated_string_text_fragment);
      if (lookahead == '*') ADVANCE(126);
      if (lookahead == '/') ADVANCE(122);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{') ADVANCE(128);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(sym__interpolated_string_text_fragment);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead == '/') ADVANCE(128);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{') ADVANCE(126);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(sym__interpolated_string_text_fragment);
      if (lookahead == '*') ADVANCE(125);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{') ADVANCE(126);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(sym__interpolated_string_text_fragment);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(127);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{') ADVANCE(128);
      END_STATE();
    case 128:
      ACCEPT_TOKEN(sym__interpolated_string_text_fragment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\' &&
          lookahead != '{') ADVANCE(128);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE);
      END_STATE();
    case 130:
      ACCEPT_TOKEN(sym__interpolated_verbatim_string_text_fragment);
      if (lookahead == '#') ADVANCE(134);
      if (lookahead == '/') ADVANCE(131);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(130);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '{') ADVANCE(136);
      END_STATE();
    case 131:
      ACCEPT_TOKEN(sym__interpolated_verbatim_string_text_fragment);
      if (lookahead == '*') ADVANCE(133);
      if (lookahead == '/') ADVANCE(135);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '{') ADVANCE(136);
      END_STATE();
    case 132:
      ACCEPT_TOKEN(sym__interpolated_verbatim_string_text_fragment);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead == '/') ADVANCE(136);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '{') ADVANCE(133);
      END_STATE();
    case 133:
      ACCEPT_TOKEN(sym__interpolated_verbatim_string_text_fragment);
      if (lookahead == '*') ADVANCE(132);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '{') ADVANCE(133);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(sym__interpolated_verbatim_string_text_fragment);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(134);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '{') ADVANCE(136);
      END_STATE();
    case 135:
      ACCEPT_TOKEN(sym__interpolated_verbatim_string_text_fragment);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(136);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '{') ADVANCE(135);
      END_STATE();
    case 136:
      ACCEPT_TOKEN(sym__interpolated_verbatim_string_text_fragment);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '{') ADVANCE(136);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '#') ADVANCE(141);
      if (lookahead == '/') ADVANCE(138);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(137);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(143);
      END_STATE();
    case 138:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(140);
      if (lookahead == '/') ADVANCE(142);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(143);
      END_STATE();
    case 139:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == '/') ADVANCE(143);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(21);
      if (lookahead != 0) ADVANCE(140);
      END_STATE();
    case 140:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '*') ADVANCE(139);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(21);
      if (lookahead != 0) ADVANCE(140);
      END_STATE();
    case 141:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(141);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(143);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(143);
      if (lookahead == '"' ||
          lookahead == '}') ADVANCE(177);
      if (lookahead != 0) ADVANCE(142);
      END_STATE();
    case 143:
      ACCEPT_TOKEN(aux_sym_interpolation_format_clause_token1);
      if (lookahead != 0 &&
          lookahead != '"' &&
          lookahead != '}') ADVANCE(143);
      END_STATE();
    case 144:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_DOT_DOT);
      END_STATE();
    case 146:
      ACCEPT_TOKEN(anon_sym_AMP_AMP);
      END_STATE();
    case 147:
      ACCEPT_TOKEN(anon_sym_PIPE_PIPE);
      END_STATE();
    case 148:
      ACCEPT_TOKEN(anon_sym_QMARK_QMARK);
      if (lookahead == '=') ADVANCE(115);
      END_STATE();
    case 149:
      ACCEPT_TOKEN(sym__identifier_token);
      if (sym__identifier_token_character_set_3(lookahead)) ADVANCE(149);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 151:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      END_STATE();
    case 152:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '*') ADVANCE(21);
      if (lookahead == '/') ADVANCE(177);
      END_STATE();
    case 153:
      ACCEPT_TOKEN(aux_sym_character_literal_token1);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(179);
      END_STATE();
    case 154:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 155:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(154);
      END_STATE();
    case 156:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(155);
      END_STATE();
    case 157:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(156);
      END_STATE();
    case 158:
      ACCEPT_TOKEN(sym_integer_literal);
      END_STATE();
    case 159:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == 'L') ADVANCE(164);
      if (lookahead == 'U') ADVANCE(163);
      if (lookahead == '_') ADVANCE(27);
      if (lookahead == 'l') ADVANCE(164);
      if (lookahead == 'u') ADVANCE(163);
      if (lookahead == 'B' ||
          lookahead == 'b') ADVANCE(28);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(31);
      if (lookahead == 'X' ||
          lookahead == 'x') ADVANCE(29);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'M' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'm') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(160);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == '.') ADVANCE(32);
      if (lookahead == 'L') ADVANCE(164);
      if (lookahead == 'U') ADVANCE(163);
      if (lookahead == '_') ADVANCE(27);
      if (lookahead == 'l') ADVANCE(164);
      if (lookahead == 'u') ADVANCE(163);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(31);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'M' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'm') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(160);
      END_STATE();
    case 161:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'L') ADVANCE(164);
      if (lookahead == 'U') ADVANCE(163);
      if (lookahead == '_') ADVANCE(28);
      if (lookahead == 'l') ADVANCE(164);
      if (lookahead == 'u') ADVANCE(163);
      if (lookahead == '0' ||
          lookahead == '1') ADVANCE(161);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'L') ADVANCE(164);
      if (lookahead == 'U') ADVANCE(163);
      if (lookahead == '_') ADVANCE(29);
      if (lookahead == 'l') ADVANCE(164);
      if (lookahead == 'u') ADVANCE(163);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(162);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'L' ||
          lookahead == 'l') ADVANCE(158);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(sym_integer_literal);
      if (lookahead == 'U' ||
          lookahead == 'u') ADVANCE(158);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(sym_real_literal);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == '_') ADVANCE(30);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(31);
      if (('D' <= lookahead && lookahead <= 'F') ||
          lookahead == 'M' ||
          ('d' <= lookahead && lookahead <= 'f') ||
          lookahead == 'm') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(166);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(sym_real_literal);
      if (lookahead == 'D' ||
          lookahead == 'F' ||
          lookahead == 'M' ||
          lookahead == 'd' ||
          lookahead == 'f' ||
          lookahead == 'm') ADVANCE(165);
      if (('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_') ADVANCE(167);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(sym__string_literal_fragment);
      if (lookahead == '\r') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(168);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym__string_literal_fragment);
      if (lookahead == '#') ADVANCE(173);
      if (lookahead == '/') ADVANCE(170);
      if (lookahead == '\t' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(169);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(174);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(sym__string_literal_fragment);
      if (lookahead == '*') ADVANCE(172);
      if (lookahead == '/') ADVANCE(168);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(174);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(sym__string_literal_fragment);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead == '/') ADVANCE(174);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(172);
      END_STATE();
    case 172:
      ACCEPT_TOKEN(sym__string_literal_fragment);
      if (lookahead == '*') ADVANCE(171);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(172);
      END_STATE();
    case 173:
      ACCEPT_TOKEN(sym__string_literal_fragment);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(173);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(174);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(sym__string_literal_fragment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '"' &&
          lookahead != '\\') ADVANCE(174);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(sym_verbatim_string_literal);
      if (lookahead == '"') ADVANCE(10);
      END_STATE();
    case 176:
      ACCEPT_TOKEN(sym_comment);
      END_STATE();
    case 177:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(177);
      END_STATE();
    case 178:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(185);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(sym__preproc_directive_start);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(179);
      END_STATE();
    case 180:
      ACCEPT_TOKEN(sym__preproc_directive_start);
      if (lookahead == '\t' ||
          lookahead == ' ') ADVANCE(180);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(185);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(sym_preproc_message);
      if (lookahead == '#') ADVANCE(180);
      if (lookahead == '/') ADVANCE(182);
      if (lookahead == '\t' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) ADVANCE(181);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(185);
      END_STATE();
    case 182:
      ACCEPT_TOKEN(sym_preproc_message);
      if (lookahead == '*') ADVANCE(184);
      if (lookahead == '/') ADVANCE(177);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(185);
      END_STATE();
    case 183:
      ACCEPT_TOKEN(sym_preproc_message);
      if (lookahead == '*') ADVANCE(183);
      if (lookahead == '/') ADVANCE(178);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(21);
      if (lookahead != 0) ADVANCE(184);
      END_STATE();
    case 184:
      ACCEPT_TOKEN(sym_preproc_message);
      if (lookahead == '*') ADVANCE(183);
      if (lookahead == '\n' ||
          lookahead == '\r') ADVANCE(21);
      if (lookahead != 0) ADVANCE(184);
      END_STATE();
    case 185:
      ACCEPT_TOKEN(sym_preproc_message);
      if (lookahead != 0 &&
          lookahead != '\n' &&
          lookahead != '\r') ADVANCE(185);
      END_STATE();
    case 186:
      ACCEPT_TOKEN(sym_preproc_integer_literal);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(186);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(sym_preproc_string_literal);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (lookahead == 'C') ADVANCE(1);
      if (lookahead == 'F') ADVANCE(2);
      if (lookahead == 'S') ADVANCE(3);
      if (lookahead == 'T') ADVANCE(4);
      if (lookahead == '_') ADVANCE(5);
      if (lookahead == 'a') ADVANCE(6);
      if (lookahead == 'b') ADVANCE(7);
      if (lookahead == 'c') ADVANCE(8);
      if (lookahead == 'd') ADVANCE(9);
      if (lookahead == 'e') ADVANCE(10);
      if (lookahead == 'f') ADVANCE(11);
      if (lookahead == 'g') ADVANCE(12);
      if (lookahead == 'h') ADVANCE(13);
      if (lookahead == 'i') ADVANCE(14);
      if (lookahead == 'j') ADVANCE(15);
      if (lookahead == 'l') ADVANCE(16);
      if (lookahead == 'm') ADVANCE(17);
      if (lookahead == 'n') ADVANCE(18);
      if (lookahead == 'o') ADVANCE(19);
      if (lookahead == 'p') ADVANCE(20);
      if (lookahead == 'r') ADVANCE(21);
      if (lookahead == 's') ADVANCE(22);
      if (lookahead == 't') ADVANCE(23);
      if (lookahead == 'u') ADVANCE(24);
      if (lookahead == 'v') ADVANCE(25);
      if (lookahead == 'w') ADVANCE(26);
      if (lookahead == 'y') ADVANCE(27);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 160 ||
          lookahead == 12288 ||
          lookahead == 65279) SKIP(0)
      END_STATE();
    case 1:
      if (lookahead == 'd') ADVANCE(28);
      END_STATE();
    case 2:
      if (lookahead == 'a') ADVANCE(29);
      END_STATE();
    case 3:
      if (lookahead == 't') ADVANCE(30);
      END_STATE();
    case 4:
      if (lookahead == 'h') ADVANCE(31);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_discard);
      if (lookahead == '_') ADVANCE(32);
      END_STATE();
    case 6:
      if (lookahead == 'b') ADVANCE(33);
      if (lookahead == 'd') ADVANCE(34);
      if (lookahead == 'l') ADVANCE(35);
      if (lookahead == 'n') ADVANCE(36);
      if (lookahead == 's') ADVANCE(37);
      if (lookahead == 'w') ADVANCE(38);
      END_STATE();
    case 7:
      if (lookahead == 'a') ADVANCE(39);
      if (lookahead == 'o') ADVANCE(40);
      if (lookahead == 'r') ADVANCE(41);
      if (lookahead == 'y') ADVANCE(42);
      END_STATE();
    case 8:
      if (lookahead == 'a') ADVANCE(43);
      if (lookahead == 'h') ADVANCE(44);
      if (lookahead == 'l') ADVANCE(45);
      if (lookahead == 'o') ADVANCE(46);
      END_STATE();
    case 9:
      if (lookahead == 'e') ADVANCE(47);
      if (lookahead == 'i') ADVANCE(48);
      if (lookahead == 'o') ADVANCE(49);
      if (lookahead == 'y') ADVANCE(50);
      END_STATE();
    case 10:
      if (lookahead == 'l') ADVANCE(51);
      if (lookahead == 'n') ADVANCE(52);
      if (lookahead == 'q') ADVANCE(53);
      if (lookahead == 'r') ADVANCE(54);
      if (lookahead == 'v') ADVANCE(55);
      if (lookahead == 'x') ADVANCE(56);
      END_STATE();
    case 11:
      if (lookahead == 'a') ADVANCE(57);
      if (lookahead == 'i') ADVANCE(58);
      if (lookahead == 'l') ADVANCE(59);
      if (lookahead == 'o') ADVANCE(60);
      if (lookahead == 'r') ADVANCE(61);
      END_STATE();
    case 12:
      if (lookahead == 'e') ADVANCE(62);
      if (lookahead == 'l') ADVANCE(63);
      if (lookahead == 'o') ADVANCE(64);
      if (lookahead == 'r') ADVANCE(65);
      END_STATE();
    case 13:
      if (lookahead == 'i') ADVANCE(66);
      END_STATE();
    case 14:
      if (lookahead == 'f') ADVANCE(67);
      if (lookahead == 'm') ADVANCE(68);
      if (lookahead == 'n') ADVANCE(69);
      if (lookahead == 's') ADVANCE(70);
      END_STATE();
    case 15:
      if (lookahead == 'o') ADVANCE(71);
      END_STATE();
    case 16:
      if (lookahead == 'e') ADVANCE(72);
      if (lookahead == 'i') ADVANCE(73);
      if (lookahead == 'o') ADVANCE(74);
      END_STATE();
    case 17:
      if (lookahead == 'a') ADVANCE(75);
      if (lookahead == 'e') ADVANCE(76);
      if (lookahead == 'o') ADVANCE(77);
      END_STATE();
    case 18:
      if (lookahead == 'a') ADVANCE(78);
      if (lookahead == 'e') ADVANCE(79);
      if (lookahead == 'i') ADVANCE(80);
      if (lookahead == 'o') ADVANCE(81);
      if (lookahead == 'u') ADVANCE(82);
      END_STATE();
    case 19:
      if (lookahead == 'b') ADVANCE(83);
      if (lookahead == 'n') ADVANCE(84);
      if (lookahead == 'p') ADVANCE(85);
      if (lookahead == 'r') ADVANCE(86);
      if (lookahead == 'u') ADVANCE(87);
      if (lookahead == 'v') ADVANCE(88);
      END_STATE();
    case 20:
      if (lookahead == 'a') ADVANCE(89);
      if (lookahead == 'r') ADVANCE(90);
      if (lookahead == 'u') ADVANCE(91);
      END_STATE();
    case 21:
      if (lookahead == 'e') ADVANCE(92);
      END_STATE();
    case 22:
      if (lookahead == 'b') ADVANCE(93);
      if (lookahead == 'e') ADVANCE(94);
      if (lookahead == 'h') ADVANCE(95);
      if (lookahead == 'i') ADVANCE(96);
      if (lookahead == 't') ADVANCE(97);
      if (lookahead == 'w') ADVANCE(98);
      END_STATE();
    case 23:
      if (lookahead == 'h') ADVANCE(99);
      if (lookahead == 'r') ADVANCE(100);
      if (lookahead == 'y') ADVANCE(101);
      END_STATE();
    case 24:
      if (lookahead == 'i') ADVANCE(102);
      if (lookahead == 'l') ADVANCE(103);
      if (lookahead == 'n') ADVANCE(104);
      if (lookahead == 's') ADVANCE(105);
      END_STATE();
    case 25:
      if (lookahead == 'a') ADVANCE(106);
      if (lookahead == 'i') ADVANCE(107);
      if (lookahead == 'o') ADVANCE(108);
      END_STATE();
    case 26:
      if (lookahead == 'a') ADVANCE(109);
      if (lookahead == 'h') ADVANCE(110);
      if (lookahead == 'i') ADVANCE(111);
      END_STATE();
    case 27:
      if (lookahead == 'i') ADVANCE(112);
      END_STATE();
    case 28:
      if (lookahead == 'e') ADVANCE(113);
      END_STATE();
    case 29:
      if (lookahead == 's') ADVANCE(114);
      END_STATE();
    case 30:
      if (lookahead == 'd') ADVANCE(115);
      END_STATE();
    case 31:
      if (lookahead == 'i') ADVANCE(116);
      END_STATE();
    case 32:
      if (lookahead == 'm') ADVANCE(117);
      if (lookahead == 'r') ADVANCE(118);
      END_STATE();
    case 33:
      if (lookahead == 's') ADVANCE(119);
      END_STATE();
    case 34:
      if (lookahead == 'd') ADVANCE(120);
      END_STATE();
    case 35:
      if (lookahead == 'i') ADVANCE(121);
      END_STATE();
    case 36:
      if (lookahead == 'd') ADVANCE(122);
      if (lookahead == 'n') ADVANCE(123);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 'c') ADVANCE(124);
      if (lookahead == 's') ADVANCE(125);
      if (lookahead == 'y') ADVANCE(126);
      END_STATE();
    case 38:
      if (lookahead == 'a') ADVANCE(127);
      END_STATE();
    case 39:
      if (lookahead == 's') ADVANCE(128);
      END_STATE();
    case 40:
      if (lookahead == 'o') ADVANCE(129);
      END_STATE();
    case 41:
      if (lookahead == 'e') ADVANCE(130);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(anon_sym_by);
      if (lookahead == 't') ADVANCE(131);
      END_STATE();
    case 43:
      if (lookahead == 's') ADVANCE(132);
      if (lookahead == 't') ADVANCE(133);
      END_STATE();
    case 44:
      if (lookahead == 'a') ADVANCE(134);
      if (lookahead == 'e') ADVANCE(135);
      END_STATE();
    case 45:
      if (lookahead == 'a') ADVANCE(136);
      END_STATE();
    case 46:
      if (lookahead == 'n') ADVANCE(137);
      END_STATE();
    case 47:
      if (lookahead == 'c') ADVANCE(138);
      if (lookahead == 'f') ADVANCE(139);
      if (lookahead == 'l') ADVANCE(140);
      if (lookahead == 's') ADVANCE(141);
      END_STATE();
    case 48:
      if (lookahead == 's') ADVANCE(142);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(anon_sym_do);
      if (lookahead == 'u') ADVANCE(143);
      END_STATE();
    case 50:
      if (lookahead == 'n') ADVANCE(144);
      END_STATE();
    case 51:
      if (lookahead == 'i') ADVANCE(145);
      if (lookahead == 's') ADVANCE(146);
      END_STATE();
    case 52:
      if (lookahead == 'a') ADVANCE(147);
      if (lookahead == 'd') ADVANCE(148);
      if (lookahead == 'u') ADVANCE(149);
      END_STATE();
    case 53:
      if (lookahead == 'u') ADVANCE(150);
      END_STATE();
    case 54:
      if (lookahead == 'r') ADVANCE(151);
      END_STATE();
    case 55:
      if (lookahead == 'e') ADVANCE(152);
      END_STATE();
    case 56:
      if (lookahead == 'p') ADVANCE(153);
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 57:
      if (lookahead == 'l') ADVANCE(155);
      END_STATE();
    case 58:
      if (lookahead == 'e') ADVANCE(156);
      if (lookahead == 'n') ADVANCE(157);
      if (lookahead == 'x') ADVANCE(158);
      END_STATE();
    case 59:
      if (lookahead == 'o') ADVANCE(159);
      END_STATE();
    case 60:
      if (lookahead == 'r') ADVANCE(160);
      END_STATE();
    case 61:
      if (lookahead == 'o') ADVANCE(161);
      END_STATE();
    case 62:
      if (lookahead == 't') ADVANCE(162);
      END_STATE();
    case 63:
      if (lookahead == 'o') ADVANCE(163);
      END_STATE();
    case 64:
      if (lookahead == 't') ADVANCE(164);
      END_STATE();
    case 65:
      if (lookahead == 'o') ADVANCE(165);
      END_STATE();
    case 66:
      if (lookahead == 'd') ADVANCE(166);
      END_STATE();
    case 67:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 68:
      if (lookahead == 'p') ADVANCE(167);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_in);
      if (lookahead == 'i') ADVANCE(168);
      if (lookahead == 't') ADVANCE(169);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 71:
      if (lookahead == 'i') ADVANCE(170);
      END_STATE();
    case 72:
      if (lookahead == 't') ADVANCE(171);
      END_STATE();
    case 73:
      if (lookahead == 'n') ADVANCE(172);
      END_STATE();
    case 74:
      if (lookahead == 'c') ADVANCE(173);
      if (lookahead == 'n') ADVANCE(174);
      END_STATE();
    case 75:
      if (lookahead == 'n') ADVANCE(175);
      END_STATE();
    case 76:
      if (lookahead == 't') ADVANCE(176);
      END_STATE();
    case 77:
      if (lookahead == 'd') ADVANCE(177);
      END_STATE();
    case 78:
      if (lookahead == 'm') ADVANCE(178);
      END_STATE();
    case 79:
      if (lookahead == 'w') ADVANCE(179);
      END_STATE();
    case 80:
      if (lookahead == 'n') ADVANCE(180);
      END_STATE();
    case 81:
      if (lookahead == 't') ADVANCE(181);
      END_STATE();
    case 82:
      if (lookahead == 'i') ADVANCE(182);
      if (lookahead == 'l') ADVANCE(183);
      END_STATE();
    case 83:
      if (lookahead == 'j') ADVANCE(184);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_on);
      END_STATE();
    case 85:
      if (lookahead == 'e') ADVANCE(185);
      END_STATE();
    case 86:
      ACCEPT_TOKEN(anon_sym_or);
      if (lookahead == 'd') ADVANCE(186);
      END_STATE();
    case 87:
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 88:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 89:
      if (lookahead == 'r') ADVANCE(189);
      END_STATE();
    case 90:
      if (lookahead == 'a') ADVANCE(190);
      if (lookahead == 'i') ADVANCE(191);
      if (lookahead == 'o') ADVANCE(192);
      END_STATE();
    case 91:
      if (lookahead == 'b') ADVANCE(193);
      END_STATE();
    case 92:
      if (lookahead == 'a') ADVANCE(194);
      if (lookahead == 'c') ADVANCE(195);
      if (lookahead == 'f') ADVANCE(196);
      if (lookahead == 'g') ADVANCE(197);
      if (lookahead == 'm') ADVANCE(198);
      if (lookahead == 's') ADVANCE(199);
      if (lookahead == 't') ADVANCE(200);
      END_STATE();
    case 93:
      if (lookahead == 'y') ADVANCE(201);
      END_STATE();
    case 94:
      if (lookahead == 'a') ADVANCE(202);
      if (lookahead == 'l') ADVANCE(203);
      if (lookahead == 't') ADVANCE(204);
      END_STATE();
    case 95:
      if (lookahead == 'o') ADVANCE(205);
      END_STATE();
    case 96:
      if (lookahead == 'z') ADVANCE(206);
      END_STATE();
    case 97:
      if (lookahead == 'a') ADVANCE(207);
      if (lookahead == 'r') ADVANCE(208);
      END_STATE();
    case 98:
      if (lookahead == 'i') ADVANCE(209);
      END_STATE();
    case 99:
      if (lookahead == 'i') ADVANCE(210);
      if (lookahead == 'r') ADVANCE(211);
      END_STATE();
    case 100:
      if (lookahead == 'u') ADVANCE(212);
      if (lookahead == 'y') ADVANCE(213);
      END_STATE();
    case 101:
      if (lookahead == 'p') ADVANCE(214);
      END_STATE();
    case 102:
      if (lookahead == 'n') ADVANCE(215);
      END_STATE();
    case 103:
      if (lookahead == 'o') ADVANCE(216);
      END_STATE();
    case 104:
      if (lookahead == 'c') ADVANCE(217);
      if (lookahead == 'd') ADVANCE(218);
      if (lookahead == 'm') ADVANCE(219);
      if (lookahead == 's') ADVANCE(220);
      END_STATE();
    case 105:
      if (lookahead == 'h') ADVANCE(221);
      if (lookahead == 'i') ADVANCE(222);
      END_STATE();
    case 106:
      if (lookahead == 'r') ADVANCE(223);
      END_STATE();
    case 107:
      if (lookahead == 'r') ADVANCE(224);
      END_STATE();
    case 108:
      if (lookahead == 'i') ADVANCE(225);
      if (lookahead == 'l') ADVANCE(226);
      END_STATE();
    case 109:
      if (lookahead == 'r') ADVANCE(227);
      END_STATE();
    case 110:
      if (lookahead == 'e') ADVANCE(228);
      if (lookahead == 'i') ADVANCE(229);
      END_STATE();
    case 111:
      if (lookahead == 't') ADVANCE(230);
      END_STATE();
    case 112:
      if (lookahead == 'e') ADVANCE(231);
      END_STATE();
    case 113:
      if (lookahead == 'c') ADVANCE(232);
      END_STATE();
    case 114:
      if (lookahead == 't') ADVANCE(233);
      END_STATE();
    case 115:
      if (lookahead == 'c') ADVANCE(234);
      END_STATE();
    case 116:
      if (lookahead == 's') ADVANCE(235);
      END_STATE();
    case 117:
      if (lookahead == 'a') ADVANCE(236);
      END_STATE();
    case 118:
      if (lookahead == 'e') ADVANCE(237);
      END_STATE();
    case 119:
      if (lookahead == 't') ADVANCE(238);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_add);
      END_STATE();
    case 121:
      if (lookahead == 'a') ADVANCE(239);
      END_STATE();
    case 122:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 123:
      if (lookahead == 'o') ADVANCE(240);
      END_STATE();
    case 124:
      if (lookahead == 'e') ADVANCE(241);
      END_STATE();
    case 125:
      if (lookahead == 'e') ADVANCE(242);
      END_STATE();
    case 126:
      if (lookahead == 'n') ADVANCE(243);
      END_STATE();
    case 127:
      if (lookahead == 'i') ADVANCE(244);
      END_STATE();
    case 128:
      if (lookahead == 'e') ADVANCE(245);
      END_STATE();
    case 129:
      if (lookahead == 'l') ADVANCE(246);
      END_STATE();
    case 130:
      if (lookahead == 'a') ADVANCE(247);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(246);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(248);
      END_STATE();
    case 133:
      if (lookahead == 'c') ADVANCE(249);
      END_STATE();
    case 134:
      if (lookahead == 'r') ADVANCE(246);
      END_STATE();
    case 135:
      if (lookahead == 'c') ADVANCE(250);
      END_STATE();
    case 136:
      if (lookahead == 's') ADVANCE(251);
      END_STATE();
    case 137:
      if (lookahead == 's') ADVANCE(252);
      if (lookahead == 't') ADVANCE(253);
      END_STATE();
    case 138:
      if (lookahead == 'i') ADVANCE(254);
      END_STATE();
    case 139:
      if (lookahead == 'a') ADVANCE(255);
      if (lookahead == 'i') ADVANCE(256);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(257);
      END_STATE();
    case 141:
      if (lookahead == 'c') ADVANCE(258);
      END_STATE();
    case 142:
      if (lookahead == 'a') ADVANCE(259);
      END_STATE();
    case 143:
      if (lookahead == 'b') ADVANCE(260);
      END_STATE();
    case 144:
      if (lookahead == 'a') ADVANCE(261);
      END_STATE();
    case 145:
      if (lookahead == 'f') ADVANCE(262);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(263);
      END_STATE();
    case 147:
      if (lookahead == 'b') ADVANCE(264);
      END_STATE();
    case 148:
      if (lookahead == 'i') ADVANCE(265);
      if (lookahead == 'r') ADVANCE(266);
      END_STATE();
    case 149:
      if (lookahead == 'm') ADVANCE(267);
      END_STATE();
    case 150:
      if (lookahead == 'a') ADVANCE(268);
      END_STATE();
    case 151:
      if (lookahead == 'o') ADVANCE(269);
      END_STATE();
    case 152:
      if (lookahead == 'n') ADVANCE(270);
      END_STATE();
    case 153:
      if (lookahead == 'l') ADVANCE(271);
      END_STATE();
    case 154:
      if (lookahead == 'e') ADVANCE(272);
      END_STATE();
    case 155:
      if (lookahead == 's') ADVANCE(273);
      END_STATE();
    case 156:
      if (lookahead == 'l') ADVANCE(274);
      END_STATE();
    case 157:
      if (lookahead == 'a') ADVANCE(275);
      END_STATE();
    case 158:
      if (lookahead == 'e') ADVANCE(276);
      END_STATE();
    case 159:
      if (lookahead == 'a') ADVANCE(277);
      END_STATE();
    case 160:
      ACCEPT_TOKEN(anon_sym_for);
      if (lookahead == 'e') ADVANCE(278);
      END_STATE();
    case 161:
      if (lookahead == 'm') ADVANCE(279);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_get);
      END_STATE();
    case 163:
      if (lookahead == 'b') ADVANCE(280);
      END_STATE();
    case 164:
      if (lookahead == 'o') ADVANCE(281);
      END_STATE();
    case 165:
      if (lookahead == 'u') ADVANCE(282);
      END_STATE();
    case 166:
      if (lookahead == 'd') ADVANCE(283);
      END_STATE();
    case 167:
      if (lookahead == 'l') ADVANCE(284);
      END_STATE();
    case 168:
      if (lookahead == 't') ADVANCE(285);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(sym_predefined_type);
      if (lookahead == 'e') ADVANCE(286);
      if (lookahead == 'o') ADVANCE(287);
      END_STATE();
    case 170:
      if (lookahead == 'n') ADVANCE(288);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_let);
      END_STATE();
    case 172:
      if (lookahead == 'e') ADVANCE(289);
      END_STATE();
    case 173:
      if (lookahead == 'k') ADVANCE(290);
      END_STATE();
    case 174:
      if (lookahead == 'g') ADVANCE(246);
      END_STATE();
    case 175:
      if (lookahead == 'a') ADVANCE(291);
      END_STATE();
    case 176:
      if (lookahead == 'h') ADVANCE(292);
      END_STATE();
    case 177:
      if (lookahead == 'u') ADVANCE(293);
      END_STATE();
    case 178:
      if (lookahead == 'e') ADVANCE(294);
      END_STATE();
    case 179:
      ACCEPT_TOKEN(anon_sym_new);
      END_STATE();
    case 180:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 181:
      ACCEPT_TOKEN(anon_sym_not);
      if (lookahead == 'n') ADVANCE(295);
      END_STATE();
    case 182:
      if (lookahead == 'n') ADVANCE(296);
      END_STATE();
    case 183:
      if (lookahead == 'l') ADVANCE(297);
      END_STATE();
    case 184:
      if (lookahead == 'e') ADVANCE(298);
      END_STATE();
    case 185:
      if (lookahead == 'r') ADVANCE(299);
      END_STATE();
    case 186:
      if (lookahead == 'e') ADVANCE(300);
      END_STATE();
    case 187:
      ACCEPT_TOKEN(anon_sym_out);
      END_STATE();
    case 188:
      if (lookahead == 'r') ADVANCE(301);
      END_STATE();
    case 189:
      if (lookahead == 'a') ADVANCE(302);
      if (lookahead == 't') ADVANCE(303);
      END_STATE();
    case 190:
      if (lookahead == 'g') ADVANCE(304);
      END_STATE();
    case 191:
      if (lookahead == 'v') ADVANCE(305);
      END_STATE();
    case 192:
      if (lookahead == 'p') ADVANCE(306);
      if (lookahead == 't') ADVANCE(307);
      END_STATE();
    case 193:
      if (lookahead == 'l') ADVANCE(308);
      END_STATE();
    case 194:
      if (lookahead == 'd') ADVANCE(309);
      END_STATE();
    case 195:
      if (lookahead == 'o') ADVANCE(310);
      END_STATE();
    case 196:
      ACCEPT_TOKEN(anon_sym_ref);
      END_STATE();
    case 197:
      if (lookahead == 'i') ADVANCE(311);
      END_STATE();
    case 198:
      if (lookahead == 'o') ADVANCE(312);
      END_STATE();
    case 199:
      if (lookahead == 't') ADVANCE(313);
      END_STATE();
    case 200:
      if (lookahead == 'u') ADVANCE(314);
      END_STATE();
    case 201:
      if (lookahead == 't') ADVANCE(315);
      END_STATE();
    case 202:
      if (lookahead == 'l') ADVANCE(316);
      END_STATE();
    case 203:
      if (lookahead == 'e') ADVANCE(317);
      END_STATE();
    case 204:
      ACCEPT_TOKEN(anon_sym_set);
      END_STATE();
    case 205:
      if (lookahead == 'r') ADVANCE(318);
      END_STATE();
    case 206:
      if (lookahead == 'e') ADVANCE(319);
      END_STATE();
    case 207:
      if (lookahead == 'c') ADVANCE(320);
      if (lookahead == 't') ADVANCE(321);
      END_STATE();
    case 208:
      if (lookahead == 'i') ADVANCE(322);
      if (lookahead == 'u') ADVANCE(323);
      END_STATE();
    case 209:
      if (lookahead == 't') ADVANCE(324);
      END_STATE();
    case 210:
      if (lookahead == 's') ADVANCE(325);
      END_STATE();
    case 211:
      if (lookahead == 'o') ADVANCE(326);
      END_STATE();
    case 212:
      if (lookahead == 'e') ADVANCE(327);
      END_STATE();
    case 213:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 214:
      if (lookahead == 'e') ADVANCE(328);
      END_STATE();
    case 215:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 216:
      if (lookahead == 'n') ADVANCE(329);
      END_STATE();
    case 217:
      if (lookahead == 'h') ADVANCE(330);
      END_STATE();
    case 218:
      if (lookahead == 'e') ADVANCE(331);
      END_STATE();
    case 219:
      if (lookahead == 'a') ADVANCE(332);
      END_STATE();
    case 220:
      if (lookahead == 'a') ADVANCE(333);
      END_STATE();
    case 221:
      if (lookahead == 'o') ADVANCE(334);
      END_STATE();
    case 222:
      if (lookahead == 'n') ADVANCE(335);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_var);
      END_STATE();
    case 224:
      if (lookahead == 't') ADVANCE(336);
      END_STATE();
    case 225:
      if (lookahead == 'd') ADVANCE(337);
      END_STATE();
    case 226:
      if (lookahead == 'a') ADVANCE(338);
      END_STATE();
    case 227:
      if (lookahead == 'n') ADVANCE(339);
      END_STATE();
    case 228:
      if (lookahead == 'n') ADVANCE(340);
      if (lookahead == 'r') ADVANCE(341);
      END_STATE();
    case 229:
      if (lookahead == 'l') ADVANCE(342);
      END_STATE();
    case 230:
      if (lookahead == 'h') ADVANCE(343);
      END_STATE();
    case 231:
      if (lookahead == 'l') ADVANCE(344);
      END_STATE();
    case 232:
      if (lookahead == 'l') ADVANCE(345);
      END_STATE();
    case 233:
      if (lookahead == 'c') ADVANCE(346);
      END_STATE();
    case 234:
      if (lookahead == 'a') ADVANCE(347);
      END_STATE();
    case 235:
      if (lookahead == 'c') ADVANCE(348);
      END_STATE();
    case 236:
      if (lookahead == 'k') ADVANCE(349);
      END_STATE();
    case 237:
      if (lookahead == 'f') ADVANCE(350);
      END_STATE();
    case 238:
      if (lookahead == 'r') ADVANCE(351);
      END_STATE();
    case 239:
      if (lookahead == 's') ADVANCE(352);
      END_STATE();
    case 240:
      if (lookahead == 't') ADVANCE(353);
      END_STATE();
    case 241:
      if (lookahead == 'n') ADVANCE(354);
      END_STATE();
    case 242:
      if (lookahead == 'm') ADVANCE(355);
      END_STATE();
    case 243:
      if (lookahead == 'c') ADVANCE(356);
      END_STATE();
    case 244:
      if (lookahead == 't') ADVANCE(357);
      END_STATE();
    case 245:
      ACCEPT_TOKEN(anon_sym_base);
      END_STATE();
    case 246:
      ACCEPT_TOKEN(sym_predefined_type);
      END_STATE();
    case 247:
      if (lookahead == 'k') ADVANCE(358);
      END_STATE();
    case 248:
      ACCEPT_TOKEN(anon_sym_case);
      END_STATE();
    case 249:
      if (lookahead == 'h') ADVANCE(359);
      END_STATE();
    case 250:
      if (lookahead == 'k') ADVANCE(360);
      END_STATE();
    case 251:
      if (lookahead == 's') ADVANCE(361);
      END_STATE();
    case 252:
      if (lookahead == 't') ADVANCE(362);
      END_STATE();
    case 253:
      if (lookahead == 'i') ADVANCE(363);
      END_STATE();
    case 254:
      if (lookahead == 'm') ADVANCE(364);
      END_STATE();
    case 255:
      if (lookahead == 'u') ADVANCE(365);
      END_STATE();
    case 256:
      if (lookahead == 'n') ADVANCE(366);
      END_STATE();
    case 257:
      if (lookahead == 'g') ADVANCE(367);
      END_STATE();
    case 258:
      if (lookahead == 'e') ADVANCE(368);
      END_STATE();
    case 259:
      if (lookahead == 'b') ADVANCE(369);
      END_STATE();
    case 260:
      if (lookahead == 'l') ADVANCE(370);
      END_STATE();
    case 261:
      if (lookahead == 'm') ADVANCE(371);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 264:
      if (lookahead == 'l') ADVANCE(372);
      END_STATE();
    case 265:
      if (lookahead == 'f') ADVANCE(373);
      END_STATE();
    case 266:
      if (lookahead == 'e') ADVANCE(374);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(anon_sym_enum);
      END_STATE();
    case 268:
      if (lookahead == 'l') ADVANCE(375);
      END_STATE();
    case 269:
      if (lookahead == 'r') ADVANCE(376);
      END_STATE();
    case 270:
      if (lookahead == 't') ADVANCE(377);
      END_STATE();
    case 271:
      if (lookahead == 'i') ADVANCE(378);
      END_STATE();
    case 272:
      if (lookahead == 'r') ADVANCE(379);
      END_STATE();
    case 273:
      if (lookahead == 'e') ADVANCE(380);
      END_STATE();
    case 274:
      if (lookahead == 'd') ADVANCE(381);
      END_STATE();
    case 275:
      if (lookahead == 'l') ADVANCE(382);
      END_STATE();
    case 276:
      if (lookahead == 'd') ADVANCE(383);
      END_STATE();
    case 277:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 278:
      if (lookahead == 'a') ADVANCE(384);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 280:
      if (lookahead == 'a') ADVANCE(385);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(anon_sym_goto);
      END_STATE();
    case 282:
      if (lookahead == 'p') ADVANCE(386);
      END_STATE();
    case 283:
      if (lookahead == 'e') ADVANCE(387);
      END_STATE();
    case 284:
      if (lookahead == 'i') ADVANCE(388);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(anon_sym_init);
      END_STATE();
    case 286:
      if (lookahead == 'r') ADVANCE(389);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_into);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_join);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_line);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_lock);
      END_STATE();
    case 291:
      if (lookahead == 'g') ADVANCE(390);
      END_STATE();
    case 292:
      if (lookahead == 'o') ADVANCE(391);
      END_STATE();
    case 293:
      if (lookahead == 'l') ADVANCE(392);
      END_STATE();
    case 294:
      if (lookahead == 'o') ADVANCE(393);
      if (lookahead == 's') ADVANCE(394);
      END_STATE();
    case 295:
      if (lookahead == 'u') ADVANCE(395);
      END_STATE();
    case 296:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(sym_null_literal);
      if (lookahead == 'a') ADVANCE(396);
      END_STATE();
    case 298:
      if (lookahead == 'c') ADVANCE(397);
      END_STATE();
    case 299:
      if (lookahead == 'a') ADVANCE(398);
      END_STATE();
    case 300:
      if (lookahead == 'r') ADVANCE(399);
      END_STATE();
    case 301:
      if (lookahead == 'r') ADVANCE(400);
      END_STATE();
    case 302:
      if (lookahead == 'm') ADVANCE(401);
      END_STATE();
    case 303:
      if (lookahead == 'i') ADVANCE(402);
      END_STATE();
    case 304:
      if (lookahead == 'm') ADVANCE(403);
      END_STATE();
    case 305:
      if (lookahead == 'a') ADVANCE(404);
      END_STATE();
    case 306:
      if (lookahead == 'e') ADVANCE(405);
      END_STATE();
    case 307:
      if (lookahead == 'e') ADVANCE(406);
      END_STATE();
    case 308:
      if (lookahead == 'i') ADVANCE(407);
      END_STATE();
    case 309:
      if (lookahead == 'o') ADVANCE(408);
      END_STATE();
    case 310:
      if (lookahead == 'r') ADVANCE(409);
      END_STATE();
    case 311:
      if (lookahead == 'o') ADVANCE(410);
      END_STATE();
    case 312:
      if (lookahead == 'v') ADVANCE(411);
      END_STATE();
    case 313:
      if (lookahead == 'o') ADVANCE(412);
      END_STATE();
    case 314:
      if (lookahead == 'r') ADVANCE(413);
      END_STATE();
    case 315:
      if (lookahead == 'e') ADVANCE(246);
      END_STATE();
    case 316:
      if (lookahead == 'e') ADVANCE(414);
      END_STATE();
    case 317:
      if (lookahead == 'c') ADVANCE(415);
      END_STATE();
    case 318:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 319:
      if (lookahead == 'o') ADVANCE(416);
      END_STATE();
    case 320:
      if (lookahead == 'k') ADVANCE(417);
      END_STATE();
    case 321:
      if (lookahead == 'i') ADVANCE(418);
      END_STATE();
    case 322:
      if (lookahead == 'n') ADVANCE(419);
      END_STATE();
    case 323:
      if (lookahead == 'c') ADVANCE(420);
      END_STATE();
    case 324:
      if (lookahead == 'c') ADVANCE(421);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_this);
      END_STATE();
    case 326:
      if (lookahead == 'w') ADVANCE(422);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_type);
      if (lookahead == 'o') ADVANCE(423);
      END_STATE();
    case 329:
      if (lookahead == 'g') ADVANCE(246);
      END_STATE();
    case 330:
      if (lookahead == 'e') ADVANCE(424);
      END_STATE();
    case 331:
      if (lookahead == 'f') ADVANCE(425);
      END_STATE();
    case 332:
      if (lookahead == 'n') ADVANCE(426);
      END_STATE();
    case 333:
      if (lookahead == 'f') ADVANCE(427);
      END_STATE();
    case 334:
      if (lookahead == 'r') ADVANCE(428);
      END_STATE();
    case 335:
      if (lookahead == 'g') ADVANCE(429);
      END_STATE();
    case 336:
      if (lookahead == 'u') ADVANCE(430);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_void_keyword);
      END_STATE();
    case 338:
      if (lookahead == 't') ADVANCE(431);
      END_STATE();
    case 339:
      if (lookahead == 'i') ADVANCE(432);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(anon_sym_when);
      END_STATE();
    case 341:
      if (lookahead == 'e') ADVANCE(433);
      END_STATE();
    case 342:
      if (lookahead == 'e') ADVANCE(434);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 344:
      if (lookahead == 'd') ADVANCE(435);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(anon_sym_Cdecl);
      END_STATE();
    case 346:
      if (lookahead == 'a') ADVANCE(436);
      END_STATE();
    case 347:
      if (lookahead == 'l') ADVANCE(437);
      END_STATE();
    case 348:
      if (lookahead == 'a') ADVANCE(438);
      END_STATE();
    case 349:
      if (lookahead == 'e') ADVANCE(439);
      END_STATE();
    case 350:
      if (lookahead == 't') ADVANCE(440);
      if (lookahead == 'v') ADVANCE(441);
      END_STATE();
    case 351:
      if (lookahead == 'a') ADVANCE(442);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(anon_sym_alias);
      END_STATE();
    case 353:
      if (lookahead == 'a') ADVANCE(443);
      END_STATE();
    case 354:
      if (lookahead == 'd') ADVANCE(444);
      END_STATE();
    case 355:
      if (lookahead == 'b') ADVANCE(445);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(anon_sym_catch);
      END_STATE();
    case 360:
      if (lookahead == 'e') ADVANCE(446);
      if (lookahead == 's') ADVANCE(447);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(anon_sym_const);
      END_STATE();
    case 363:
      if (lookahead == 'n') ADVANCE(448);
      END_STATE();
    case 364:
      if (lookahead == 'a') ADVANCE(449);
      END_STATE();
    case 365:
      if (lookahead == 'l') ADVANCE(450);
      END_STATE();
    case 366:
      if (lookahead == 'e') ADVANCE(451);
      END_STATE();
    case 367:
      if (lookahead == 'a') ADVANCE(452);
      END_STATE();
    case 368:
      if (lookahead == 'n') ADVANCE(453);
      END_STATE();
    case 369:
      if (lookahead == 'l') ADVANCE(454);
      END_STATE();
    case 370:
      if (lookahead == 'e') ADVANCE(246);
      END_STATE();
    case 371:
      if (lookahead == 'i') ADVANCE(455);
      END_STATE();
    case 372:
      if (lookahead == 'e') ADVANCE(456);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_endif_directive);
      END_STATE();
    case 374:
      if (lookahead == 'g') ADVANCE(457);
      END_STATE();
    case 375:
      if (lookahead == 's') ADVANCE(458);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(anon_sym_error);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(anon_sym_event);
      END_STATE();
    case 378:
      if (lookahead == 'c') ADVANCE(459);
      END_STATE();
    case 379:
      if (lookahead == 'n') ADVANCE(460);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(anon_sym_field);
      END_STATE();
    case 382:
      if (lookahead == 'l') ADVANCE(461);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(anon_sym_fixed);
      END_STATE();
    case 384:
      if (lookahead == 'c') ADVANCE(462);
      END_STATE();
    case 385:
      if (lookahead == 'l') ADVANCE(463);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(anon_sym_group);
      END_STATE();
    case 387:
      if (lookahead == 'n') ADVANCE(464);
      END_STATE();
    case 388:
      if (lookahead == 'c') ADVANCE(465);
      END_STATE();
    case 389:
      if (lookahead == 'f') ADVANCE(466);
      if (lookahead == 'n') ADVANCE(467);
      END_STATE();
    case 390:
      if (lookahead == 'e') ADVANCE(468);
      END_STATE();
    case 391:
      if (lookahead == 'd') ADVANCE(469);
      END_STATE();
    case 392:
      if (lookahead == 'e') ADVANCE(470);
      END_STATE();
    case 393:
      if (lookahead == 'f') ADVANCE(471);
      END_STATE();
    case 394:
      if (lookahead == 'p') ADVANCE(472);
      END_STATE();
    case 395:
      if (lookahead == 'l') ADVANCE(473);
      END_STATE();
    case 396:
      if (lookahead == 'b') ADVANCE(474);
      END_STATE();
    case 397:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 398:
      if (lookahead == 't') ADVANCE(475);
      END_STATE();
    case 399:
      if (lookahead == 'b') ADVANCE(476);
      END_STATE();
    case 400:
      if (lookahead == 'i') ADVANCE(477);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(anon_sym_param);
      if (lookahead == 's') ADVANCE(478);
      END_STATE();
    case 402:
      if (lookahead == 'a') ADVANCE(479);
      END_STATE();
    case 403:
      if (lookahead == 'a') ADVANCE(480);
      END_STATE();
    case 404:
      if (lookahead == 't') ADVANCE(481);
      END_STATE();
    case 405:
      if (lookahead == 'r') ADVANCE(482);
      END_STATE();
    case 406:
      if (lookahead == 'c') ADVANCE(483);
      END_STATE();
    case 407:
      if (lookahead == 'c') ADVANCE(484);
      END_STATE();
    case 408:
      if (lookahead == 'n') ADVANCE(485);
      END_STATE();
    case 409:
      if (lookahead == 'd') ADVANCE(486);
      END_STATE();
    case 410:
      if (lookahead == 'n') ADVANCE(487);
      END_STATE();
    case 411:
      if (lookahead == 'e') ADVANCE(488);
      END_STATE();
    case 412:
      if (lookahead == 'r') ADVANCE(489);
      END_STATE();
    case 413:
      if (lookahead == 'n') ADVANCE(490);
      END_STATE();
    case 414:
      if (lookahead == 'd') ADVANCE(491);
      END_STATE();
    case 415:
      if (lookahead == 't') ADVANCE(492);
      END_STATE();
    case 416:
      if (lookahead == 'f') ADVANCE(493);
      END_STATE();
    case 417:
      if (lookahead == 'a') ADVANCE(494);
      END_STATE();
    case 418:
      if (lookahead == 'c') ADVANCE(495);
      END_STATE();
    case 419:
      if (lookahead == 'g') ADVANCE(246);
      END_STATE();
    case 420:
      if (lookahead == 't') ADVANCE(496);
      END_STATE();
    case 421:
      if (lookahead == 'h') ADVANCE(497);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(anon_sym_throw);
      END_STATE();
    case 423:
      if (lookahead == 'f') ADVANCE(498);
      END_STATE();
    case 424:
      if (lookahead == 'c') ADVANCE(499);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(anon_sym_undef);
      END_STATE();
    case 426:
      if (lookahead == 'a') ADVANCE(500);
      END_STATE();
    case 427:
      if (lookahead == 'e') ADVANCE(501);
      END_STATE();
    case 428:
      if (lookahead == 't') ADVANCE(246);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(anon_sym_using);
      END_STATE();
    case 430:
      if (lookahead == 'a') ADVANCE(502);
      END_STATE();
    case 431:
      if (lookahead == 'i') ADVANCE(503);
      END_STATE();
    case 432:
      if (lookahead == 'n') ADVANCE(504);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(anon_sym_where);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    case 436:
      if (lookahead == 'l') ADVANCE(505);
      END_STATE();
    case 437:
      if (lookahead == 'l') ADVANCE(506);
      END_STATE();
    case 438:
      if (lookahead == 'l') ADVANCE(507);
      END_STATE();
    case 439:
      if (lookahead == 'r') ADVANCE(508);
      END_STATE();
    case 440:
      if (lookahead == 'y') ADVANCE(509);
      END_STATE();
    case 441:
      if (lookahead == 'a') ADVANCE(510);
      END_STATE();
    case 442:
      if (lookahead == 'c') ADVANCE(511);
      END_STATE();
    case 443:
      if (lookahead == 't') ADVANCE(512);
      END_STATE();
    case 444:
      if (lookahead == 'i') ADVANCE(513);
      END_STATE();
    case 445:
      if (lookahead == 'l') ADVANCE(514);
      END_STATE();
    case 446:
      if (lookahead == 'd') ADVANCE(515);
      END_STATE();
    case 447:
      if (lookahead == 'u') ADVANCE(516);
      END_STATE();
    case 448:
      if (lookahead == 'u') ADVANCE(517);
      END_STATE();
    case 449:
      if (lookahead == 'l') ADVANCE(246);
      END_STATE();
    case 450:
      if (lookahead == 't') ADVANCE(518);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(anon_sym_define);
      END_STATE();
    case 452:
      if (lookahead == 't') ADVANCE(519);
      END_STATE();
    case 453:
      if (lookahead == 'd') ADVANCE(520);
      END_STATE();
    case 454:
      if (lookahead == 'e') ADVANCE(521);
      END_STATE();
    case 455:
      if (lookahead == 'c') ADVANCE(522);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(anon_sym_enable);
      END_STATE();
    case 457:
      if (lookahead == 'i') ADVANCE(523);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(anon_sym_equals);
      END_STATE();
    case 459:
      if (lookahead == 'i') ADVANCE(524);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(anon_sym_extern);
      END_STATE();
    case 461:
      if (lookahead == 'y') ADVANCE(525);
      END_STATE();
    case 462:
      if (lookahead == 'h') ADVANCE(526);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(anon_sym_hidden);
      END_STATE();
    case 465:
      if (lookahead == 'i') ADVANCE(527);
      END_STATE();
    case 466:
      if (lookahead == 'a') ADVANCE(528);
      END_STATE();
    case 467:
      if (lookahead == 'a') ADVANCE(529);
      END_STATE();
    case 468:
      if (lookahead == 'd') ADVANCE(530);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(anon_sym_method);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(anon_sym_module);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(anon_sym_nameof);
      END_STATE();
    case 472:
      if (lookahead == 'a') ADVANCE(531);
      END_STATE();
    case 473:
      if (lookahead == 'l') ADVANCE(532);
      END_STATE();
    case 474:
      if (lookahead == 'l') ADVANCE(533);
      END_STATE();
    case 475:
      if (lookahead == 'o') ADVANCE(534);
      END_STATE();
    case 476:
      if (lookahead == 'y') ADVANCE(535);
      END_STATE();
    case 477:
      if (lookahead == 'd') ADVANCE(536);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(anon_sym_params);
      END_STATE();
    case 479:
      if (lookahead == 'l') ADVANCE(537);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(anon_sym_pragma);
      END_STATE();
    case 481:
      if (lookahead == 'e') ADVANCE(538);
      END_STATE();
    case 482:
      if (lookahead == 't') ADVANCE(539);
      END_STATE();
    case 483:
      if (lookahead == 't') ADVANCE(540);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(anon_sym_public);
      END_STATE();
    case 485:
      if (lookahead == 'l') ADVANCE(541);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(anon_sym_record);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(anon_sym_region);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(anon_sym_remove);
      END_STATE();
    case 489:
      if (lookahead == 'e') ADVANCE(542);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(anon_sym_sealed);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(anon_sym_select);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(anon_sym_sizeof);
      END_STATE();
    case 494:
      if (lookahead == 'l') ADVANCE(543);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(anon_sym_static);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(anon_sym_struct);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(anon_sym_switch);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(anon_sym_typeof);
      END_STATE();
    case 499:
      if (lookahead == 'k') ADVANCE(544);
      END_STATE();
    case 500:
      if (lookahead == 'g') ADVANCE(545);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(anon_sym_unsafe);
      END_STATE();
    case 502:
      if (lookahead == 'l') ADVANCE(546);
      END_STATE();
    case 503:
      if (lookahead == 'l') ADVANCE(547);
      END_STATE();
    case 504:
      if (lookahead == 'g') ADVANCE(548);
      END_STATE();
    case 505:
      if (lookahead == 'l') ADVANCE(549);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(anon_sym_Stdcall);
      END_STATE();
    case 507:
      if (lookahead == 'l') ADVANCE(550);
      END_STATE();
    case 508:
      if (lookahead == 'e') ADVANCE(551);
      END_STATE();
    case 509:
      if (lookahead == 'p') ADVANCE(552);
      END_STATE();
    case 510:
      if (lookahead == 'l') ADVANCE(553);
      END_STATE();
    case 511:
      if (lookahead == 't') ADVANCE(554);
      END_STATE();
    case 512:
      if (lookahead == 'i') ADVANCE(555);
      END_STATE();
    case 513:
      if (lookahead == 'n') ADVANCE(556);
      END_STATE();
    case 514:
      if (lookahead == 'y') ADVANCE(557);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_checked);
      END_STATE();
    case 516:
      if (lookahead == 'm') ADVANCE(558);
      END_STATE();
    case 517:
      if (lookahead == 'e') ADVANCE(559);
      END_STATE();
    case 518:
      ACCEPT_TOKEN(anon_sym_default);
      END_STATE();
    case 519:
      if (lookahead == 'e') ADVANCE(560);
      END_STATE();
    case 520:
      if (lookahead == 'i') ADVANCE(561);
      END_STATE();
    case 521:
      ACCEPT_TOKEN(anon_sym_disable);
      END_STATE();
    case 522:
      ACCEPT_TOKEN(anon_sym_dynamic);
      END_STATE();
    case 523:
      if (lookahead == 'o') ADVANCE(562);
      END_STATE();
    case 524:
      if (lookahead == 't') ADVANCE(563);
      END_STATE();
    case 525:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 526:
      ACCEPT_TOKEN(anon_sym_foreach);
      END_STATE();
    case 527:
      if (lookahead == 't') ADVANCE(564);
      END_STATE();
    case 528:
      if (lookahead == 'c') ADVANCE(565);
      END_STATE();
    case 529:
      if (lookahead == 'l') ADVANCE(566);
      END_STATE();
    case 530:
      ACCEPT_TOKEN(anon_sym_managed);
      END_STATE();
    case 531:
      if (lookahead == 'c') ADVANCE(567);
      END_STATE();
    case 532:
      ACCEPT_TOKEN(anon_sym_notnull);
      END_STATE();
    case 533:
      if (lookahead == 'e') ADVANCE(568);
      END_STATE();
    case 534:
      if (lookahead == 'r') ADVANCE(569);
      END_STATE();
    case 535:
      ACCEPT_TOKEN(anon_sym_orderby);
      END_STATE();
    case 536:
      if (lookahead == 'e') ADVANCE(570);
      END_STATE();
    case 537:
      ACCEPT_TOKEN(anon_sym_partial);
      END_STATE();
    case 538:
      ACCEPT_TOKEN(anon_sym_private);
      END_STATE();
    case 539:
      if (lookahead == 'y') ADVANCE(571);
      END_STATE();
    case 540:
      if (lookahead == 'e') ADVANCE(572);
      END_STATE();
    case 541:
      if (lookahead == 'y') ADVANCE(573);
      END_STATE();
    case 542:
      ACCEPT_TOKEN(anon_sym_restore);
      END_STATE();
    case 543:
      if (lookahead == 'l') ADVANCE(574);
      END_STATE();
    case 544:
      if (lookahead == 'e') ADVANCE(575);
      END_STATE();
    case 545:
      if (lookahead == 'e') ADVANCE(576);
      END_STATE();
    case 546:
      ACCEPT_TOKEN(anon_sym_virtual);
      END_STATE();
    case 547:
      if (lookahead == 'e') ADVANCE(577);
      END_STATE();
    case 548:
      ACCEPT_TOKEN(anon_sym_warning);
      if (lookahead == 's') ADVANCE(578);
      END_STATE();
    case 549:
      ACCEPT_TOKEN(anon_sym_Fastcall);
      END_STATE();
    case 550:
      ACCEPT_TOKEN(anon_sym_Thiscall);
      END_STATE();
    case 551:
      if (lookahead == 'f') ADVANCE(579);
      END_STATE();
    case 552:
      if (lookahead == 'e') ADVANCE(580);
      END_STATE();
    case 553:
      if (lookahead == 'u') ADVANCE(581);
      END_STATE();
    case 554:
      ACCEPT_TOKEN(anon_sym_abstract);
      END_STATE();
    case 555:
      if (lookahead == 'o') ADVANCE(582);
      END_STATE();
    case 556:
      if (lookahead == 'g') ADVANCE(583);
      END_STATE();
    case 557:
      ACCEPT_TOKEN(anon_sym_assembly);
      END_STATE();
    case 558:
      ACCEPT_TOKEN(anon_sym_checksum);
      END_STATE();
    case 559:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 560:
      ACCEPT_TOKEN(anon_sym_delegate);
      END_STATE();
    case 561:
      if (lookahead == 'n') ADVANCE(584);
      END_STATE();
    case 562:
      if (lookahead == 'n') ADVANCE(585);
      END_STATE();
    case 563:
      ACCEPT_TOKEN(anon_sym_explicit);
      END_STATE();
    case 564:
      ACCEPT_TOKEN(anon_sym_implicit);
      END_STATE();
    case 565:
      if (lookahead == 'e') ADVANCE(586);
      END_STATE();
    case 566:
      ACCEPT_TOKEN(anon_sym_internal);
      END_STATE();
    case 567:
      if (lookahead == 'e') ADVANCE(587);
      END_STATE();
    case 568:
      ACCEPT_TOKEN(anon_sym_nullable);
      END_STATE();
    case 569:
      ACCEPT_TOKEN(anon_sym_operator);
      END_STATE();
    case 570:
      ACCEPT_TOKEN(anon_sym_override);
      END_STATE();
    case 571:
      ACCEPT_TOKEN(anon_sym_property);
      END_STATE();
    case 572:
      if (lookahead == 'd') ADVANCE(588);
      END_STATE();
    case 573:
      ACCEPT_TOKEN(anon_sym_readonly);
      END_STATE();
    case 574:
      if (lookahead == 'o') ADVANCE(589);
      END_STATE();
    case 575:
      if (lookahead == 'd') ADVANCE(590);
      END_STATE();
    case 576:
      if (lookahead == 'd') ADVANCE(591);
      END_STATE();
    case 577:
      ACCEPT_TOKEN(anon_sym_volatile);
      END_STATE();
    case 578:
      ACCEPT_TOKEN(anon_sym_warnings);
      END_STATE();
    case 579:
      ACCEPT_TOKEN(anon_sym___makeref);
      END_STATE();
    case 580:
      ACCEPT_TOKEN(anon_sym___reftype);
      END_STATE();
    case 581:
      if (lookahead == 'e') ADVANCE(592);
      END_STATE();
    case 582:
      if (lookahead == 'n') ADVANCE(593);
      END_STATE();
    case 583:
      ACCEPT_TOKEN(anon_sym_ascending);
      END_STATE();
    case 584:
      if (lookahead == 'g') ADVANCE(594);
      END_STATE();
    case 585:
      ACCEPT_TOKEN(anon_sym_endregion);
      END_STATE();
    case 586:
      ACCEPT_TOKEN(anon_sym_interface);
      END_STATE();
    case 587:
      ACCEPT_TOKEN(anon_sym_namespace);
      END_STATE();
    case 588:
      ACCEPT_TOKEN(anon_sym_protected);
      END_STATE();
    case 589:
      if (lookahead == 'c') ADVANCE(595);
      END_STATE();
    case 590:
      ACCEPT_TOKEN(anon_sym_unchecked);
      END_STATE();
    case 591:
      ACCEPT_TOKEN(anon_sym_unmanaged);
      END_STATE();
    case 592:
      ACCEPT_TOKEN(anon_sym___refvalue);
      END_STATE();
    case 593:
      if (lookahead == 's') ADVANCE(596);
      END_STATE();
    case 594:
      ACCEPT_TOKEN(anon_sym_descending);
      END_STATE();
    case 595:
      ACCEPT_TOKEN(anon_sym_stackalloc);
      END_STATE();
    case 596:
      ACCEPT_TOKEN(anon_sym_annotations);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 45},
  [2] = {.lex_state = 45},
  [3] = {.lex_state = 45},
  [4] = {.lex_state = 45},
  [5] = {.lex_state = 45},
  [6] = {.lex_state = 45},
  [7] = {.lex_state = 45},
  [8] = {.lex_state = 45},
  [9] = {.lex_state = 45},
  [10] = {.lex_state = 45},
  [11] = {.lex_state = 45},
  [12] = {.lex_state = 45},
  [13] = {.lex_state = 45},
  [14] = {.lex_state = 45},
  [15] = {.lex_state = 45},
  [16] = {.lex_state = 45},
  [17] = {.lex_state = 45},
  [18] = {.lex_state = 45},
  [19] = {.lex_state = 45},
  [20] = {.lex_state = 45},
  [21] = {.lex_state = 45},
  [22] = {.lex_state = 45},
  [23] = {.lex_state = 45},
  [24] = {.lex_state = 45},
  [25] = {.lex_state = 45},
  [26] = {.lex_state = 45},
  [27] = {.lex_state = 45},
  [28] = {.lex_state = 45},
  [29] = {.lex_state = 45},
  [30] = {.lex_state = 45},
  [31] = {.lex_state = 45},
  [32] = {.lex_state = 45},
  [33] = {.lex_state = 45},
  [34] = {.lex_state = 45},
  [35] = {.lex_state = 45},
  [36] = {.lex_state = 45},
  [37] = {.lex_state = 45},
  [38] = {.lex_state = 45},
  [39] = {.lex_state = 45},
  [40] = {.lex_state = 45},
  [41] = {.lex_state = 45},
  [42] = {.lex_state = 45},
  [43] = {.lex_state = 45},
  [44] = {.lex_state = 45},
  [45] = {.lex_state = 45},
  [46] = {.lex_state = 45},
  [47] = {.lex_state = 45},
  [48] = {.lex_state = 45},
  [49] = {.lex_state = 45},
  [50] = {.lex_state = 45},
  [51] = {.lex_state = 45},
  [52] = {.lex_state = 45},
  [53] = {.lex_state = 45},
  [54] = {.lex_state = 45},
  [55] = {.lex_state = 45},
  [56] = {.lex_state = 45},
  [57] = {.lex_state = 45},
  [58] = {.lex_state = 45},
  [59] = {.lex_state = 45},
  [60] = {.lex_state = 45},
  [61] = {.lex_state = 45},
  [62] = {.lex_state = 45},
  [63] = {.lex_state = 45},
  [64] = {.lex_state = 45},
  [65] = {.lex_state = 45},
  [66] = {.lex_state = 45},
  [67] = {.lex_state = 45},
  [68] = {.lex_state = 45},
  [69] = {.lex_state = 45},
  [70] = {.lex_state = 45},
  [71] = {.lex_state = 45},
  [72] = {.lex_state = 45},
  [73] = {.lex_state = 45},
  [74] = {.lex_state = 45},
  [75] = {.lex_state = 45},
  [76] = {.lex_state = 45},
  [77] = {.lex_state = 45},
  [78] = {.lex_state = 45},
  [79] = {.lex_state = 45},
  [80] = {.lex_state = 45},
  [81] = {.lex_state = 45},
  [82] = {.lex_state = 45},
  [83] = {.lex_state = 45},
  [84] = {.lex_state = 45},
  [85] = {.lex_state = 45},
  [86] = {.lex_state = 45},
  [87] = {.lex_state = 45},
  [88] = {.lex_state = 45},
  [89] = {.lex_state = 45},
  [90] = {.lex_state = 45},
  [91] = {.lex_state = 45},
  [92] = {.lex_state = 45},
  [93] = {.lex_state = 45},
  [94] = {.lex_state = 45},
  [95] = {.lex_state = 45},
  [96] = {.lex_state = 45},
  [97] = {.lex_state = 45},
  [98] = {.lex_state = 45},
  [99] = {.lex_state = 45},
  [100] = {.lex_state = 45},
  [101] = {.lex_state = 45},
  [102] = {.lex_state = 45},
  [103] = {.lex_state = 45},
  [104] = {.lex_state = 45},
  [105] = {.lex_state = 45},
  [106] = {.lex_state = 45},
  [107] = {.lex_state = 45},
  [108] = {.lex_state = 45},
  [109] = {.lex_state = 45},
  [110] = {.lex_state = 45},
  [111] = {.lex_state = 45},
  [112] = {.lex_state = 45},
  [113] = {.lex_state = 45},
  [114] = {.lex_state = 45},
  [115] = {.lex_state = 45},
  [116] = {.lex_state = 45},
  [117] = {.lex_state = 45},
  [118] = {.lex_state = 45},
  [119] = {.lex_state = 45},
  [120] = {.lex_state = 45},
  [121] = {.lex_state = 45},
  [122] = {.lex_state = 45},
  [123] = {.lex_state = 45},
  [124] = {.lex_state = 45},
  [125] = {.lex_state = 45},
  [126] = {.lex_state = 45},
  [127] = {.lex_state = 45},
  [128] = {.lex_state = 45},
  [129] = {.lex_state = 45},
  [130] = {.lex_state = 45},
  [131] = {.lex_state = 45},
  [132] = {.lex_state = 45},
  [133] = {.lex_state = 45},
  [134] = {.lex_state = 45},
  [135] = {.lex_state = 45},
  [136] = {.lex_state = 45},
  [137] = {.lex_state = 45},
  [138] = {.lex_state = 45},
  [139] = {.lex_state = 45},
  [140] = {.lex_state = 45},
  [141] = {.lex_state = 45},
  [142] = {.lex_state = 45},
  [143] = {.lex_state = 45},
  [144] = {.lex_state = 45},
  [145] = {.lex_state = 45},
  [146] = {.lex_state = 45},
  [147] = {.lex_state = 45},
  [148] = {.lex_state = 45},
  [149] = {.lex_state = 45},
  [150] = {.lex_state = 45},
  [151] = {.lex_state = 45},
  [152] = {.lex_state = 45},
  [153] = {.lex_state = 45},
  [154] = {.lex_state = 45},
  [155] = {.lex_state = 45},
  [156] = {.lex_state = 45},
  [157] = {.lex_state = 45},
  [158] = {.lex_state = 45},
  [159] = {.lex_state = 45},
  [160] = {.lex_state = 45},
  [161] = {.lex_state = 45},
  [162] = {.lex_state = 44},
  [163] = {.lex_state = 44},
  [164] = {.lex_state = 44},
  [165] = {.lex_state = 44},
  [166] = {.lex_state = 44},
  [167] = {.lex_state = 44},
  [168] = {.lex_state = 44},
  [169] = {.lex_state = 44},
  [170] = {.lex_state = 44},
  [171] = {.lex_state = 44},
  [172] = {.lex_state = 44},
  [173] = {.lex_state = 44},
  [174] = {.lex_state = 44},
  [175] = {.lex_state = 44},
  [176] = {.lex_state = 44},
  [177] = {.lex_state = 44},
  [178] = {.lex_state = 44},
  [179] = {.lex_state = 44},
  [180] = {.lex_state = 44},
  [181] = {.lex_state = 44},
  [182] = {.lex_state = 44},
  [183] = {.lex_state = 44},
  [184] = {.lex_state = 44},
  [185] = {.lex_state = 44},
  [186] = {.lex_state = 44},
  [187] = {.lex_state = 44},
  [188] = {.lex_state = 44},
  [189] = {.lex_state = 44},
  [190] = {.lex_state = 44},
  [191] = {.lex_state = 44},
  [192] = {.lex_state = 44},
  [193] = {.lex_state = 44},
  [194] = {.lex_state = 44},
  [195] = {.lex_state = 44},
  [196] = {.lex_state = 44},
  [197] = {.lex_state = 44},
  [198] = {.lex_state = 44},
  [199] = {.lex_state = 44},
  [200] = {.lex_state = 44},
  [201] = {.lex_state = 44},
  [202] = {.lex_state = 44},
  [203] = {.lex_state = 44},
  [204] = {.lex_state = 44},
  [205] = {.lex_state = 44},
  [206] = {.lex_state = 44},
  [207] = {.lex_state = 44},
  [208] = {.lex_state = 44},
  [209] = {.lex_state = 44},
  [210] = {.lex_state = 44},
  [211] = {.lex_state = 44},
  [212] = {.lex_state = 44},
  [213] = {.lex_state = 44},
  [214] = {.lex_state = 44},
  [215] = {.lex_state = 44},
  [216] = {.lex_state = 44},
  [217] = {.lex_state = 44},
  [218] = {.lex_state = 44},
  [219] = {.lex_state = 44},
  [220] = {.lex_state = 44},
  [221] = {.lex_state = 44},
  [222] = {.lex_state = 44},
  [223] = {.lex_state = 44},
  [224] = {.lex_state = 44},
  [225] = {.lex_state = 44},
  [226] = {.lex_state = 44},
  [227] = {.lex_state = 44},
  [228] = {.lex_state = 44},
  [229] = {.lex_state = 44},
  [230] = {.lex_state = 44},
  [231] = {.lex_state = 44},
  [232] = {.lex_state = 44},
  [233] = {.lex_state = 44},
  [234] = {.lex_state = 44},
  [235] = {.lex_state = 44},
  [236] = {.lex_state = 44},
  [237] = {.lex_state = 44},
  [238] = {.lex_state = 45},
  [239] = {.lex_state = 45},
  [240] = {.lex_state = 45},
  [241] = {.lex_state = 45},
  [242] = {.lex_state = 45},
  [243] = {.lex_state = 45},
  [244] = {.lex_state = 45},
  [245] = {.lex_state = 45},
  [246] = {.lex_state = 45},
  [247] = {.lex_state = 45},
  [248] = {.lex_state = 45},
  [249] = {.lex_state = 45},
  [250] = {.lex_state = 45},
  [251] = {.lex_state = 45},
  [252] = {.lex_state = 45},
  [253] = {.lex_state = 45},
  [254] = {.lex_state = 45},
  [255] = {.lex_state = 45},
  [256] = {.lex_state = 45},
  [257] = {.lex_state = 45},
  [258] = {.lex_state = 45},
  [259] = {.lex_state = 45},
  [260] = {.lex_state = 45},
  [261] = {.lex_state = 45},
  [262] = {.lex_state = 45},
  [263] = {.lex_state = 45},
  [264] = {.lex_state = 45},
  [265] = {.lex_state = 45},
  [266] = {.lex_state = 45},
  [267] = {.lex_state = 45},
  [268] = {.lex_state = 45},
  [269] = {.lex_state = 45},
  [270] = {.lex_state = 45},
  [271] = {.lex_state = 45},
  [272] = {.lex_state = 45},
  [273] = {.lex_state = 45},
  [274] = {.lex_state = 45},
  [275] = {.lex_state = 45},
  [276] = {.lex_state = 45},
  [277] = {.lex_state = 45},
  [278] = {.lex_state = 45},
  [279] = {.lex_state = 45},
  [280] = {.lex_state = 45},
  [281] = {.lex_state = 45},
  [282] = {.lex_state = 45},
  [283] = {.lex_state = 45},
  [284] = {.lex_state = 45},
  [285] = {.lex_state = 45},
  [286] = {.lex_state = 45},
  [287] = {.lex_state = 45},
  [288] = {.lex_state = 45},
  [289] = {.lex_state = 45},
  [290] = {.lex_state = 45},
  [291] = {.lex_state = 45},
  [292] = {.lex_state = 45},
  [293] = {.lex_state = 45},
  [294] = {.lex_state = 45},
  [295] = {.lex_state = 45},
  [296] = {.lex_state = 45},
  [297] = {.lex_state = 45},
  [298] = {.lex_state = 45},
  [299] = {.lex_state = 45},
  [300] = {.lex_state = 45},
  [301] = {.lex_state = 45},
  [302] = {.lex_state = 45},
  [303] = {.lex_state = 45},
  [304] = {.lex_state = 45},
  [305] = {.lex_state = 45},
  [306] = {.lex_state = 45},
  [307] = {.lex_state = 45},
  [308] = {.lex_state = 45},
  [309] = {.lex_state = 45},
  [310] = {.lex_state = 45},
  [311] = {.lex_state = 45},
  [312] = {.lex_state = 45},
  [313] = {.lex_state = 45},
  [314] = {.lex_state = 45},
  [315] = {.lex_state = 45},
  [316] = {.lex_state = 45},
  [317] = {.lex_state = 45},
  [318] = {.lex_state = 45},
  [319] = {.lex_state = 45},
  [320] = {.lex_state = 45},
  [321] = {.lex_state = 45},
  [322] = {.lex_state = 45},
  [323] = {.lex_state = 45},
  [324] = {.lex_state = 45},
  [325] = {.lex_state = 45},
  [326] = {.lex_state = 45},
  [327] = {.lex_state = 45},
  [328] = {.lex_state = 45},
  [329] = {.lex_state = 45},
  [330] = {.lex_state = 45},
  [331] = {.lex_state = 45},
  [332] = {.lex_state = 45},
  [333] = {.lex_state = 45},
  [334] = {.lex_state = 45},
  [335] = {.lex_state = 45},
  [336] = {.lex_state = 45},
  [337] = {.lex_state = 45},
  [338] = {.lex_state = 45},
  [339] = {.lex_state = 45},
  [340] = {.lex_state = 45},
  [341] = {.lex_state = 45},
  [342] = {.lex_state = 45},
  [343] = {.lex_state = 45},
  [344] = {.lex_state = 45},
  [345] = {.lex_state = 45},
  [346] = {.lex_state = 45},
  [347] = {.lex_state = 45},
  [348] = {.lex_state = 45},
  [349] = {.lex_state = 45},
  [350] = {.lex_state = 45},
  [351] = {.lex_state = 45},
  [352] = {.lex_state = 45},
  [353] = {.lex_state = 45},
  [354] = {.lex_state = 45},
  [355] = {.lex_state = 45},
  [356] = {.lex_state = 45},
  [357] = {.lex_state = 45},
  [358] = {.lex_state = 45},
  [359] = {.lex_state = 45},
  [360] = {.lex_state = 45},
  [361] = {.lex_state = 45},
  [362] = {.lex_state = 45},
  [363] = {.lex_state = 45},
  [364] = {.lex_state = 45},
  [365] = {.lex_state = 45},
  [366] = {.lex_state = 45},
  [367] = {.lex_state = 45},
  [368] = {.lex_state = 45},
  [369] = {.lex_state = 45},
  [370] = {.lex_state = 45},
  [371] = {.lex_state = 45},
  [372] = {.lex_state = 45},
  [373] = {.lex_state = 45},
  [374] = {.lex_state = 45},
  [375] = {.lex_state = 45},
  [376] = {.lex_state = 45},
  [377] = {.lex_state = 45},
  [378] = {.lex_state = 45},
  [379] = {.lex_state = 45},
  [380] = {.lex_state = 45},
  [381] = {.lex_state = 45},
  [382] = {.lex_state = 45},
  [383] = {.lex_state = 45},
  [384] = {.lex_state = 45},
  [385] = {.lex_state = 45},
  [386] = {.lex_state = 45},
  [387] = {.lex_state = 45},
  [388] = {.lex_state = 45},
  [389] = {.lex_state = 45},
  [390] = {.lex_state = 45},
  [391] = {.lex_state = 45},
  [392] = {.lex_state = 45},
  [393] = {.lex_state = 45},
  [394] = {.lex_state = 45},
  [395] = {.lex_state = 45},
  [396] = {.lex_state = 45},
  [397] = {.lex_state = 45},
  [398] = {.lex_state = 45},
  [399] = {.lex_state = 45},
  [400] = {.lex_state = 45},
  [401] = {.lex_state = 45},
  [402] = {.lex_state = 45},
  [403] = {.lex_state = 45},
  [404] = {.lex_state = 45},
  [405] = {.lex_state = 45},
  [406] = {.lex_state = 45},
  [407] = {.lex_state = 45},
  [408] = {.lex_state = 45},
  [409] = {.lex_state = 45},
  [410] = {.lex_state = 45},
  [411] = {.lex_state = 45},
  [412] = {.lex_state = 45},
  [413] = {.lex_state = 45},
  [414] = {.lex_state = 45},
  [415] = {.lex_state = 45},
  [416] = {.lex_state = 45},
  [417] = {.lex_state = 45},
  [418] = {.lex_state = 45},
  [419] = {.lex_state = 45},
  [420] = {.lex_state = 45},
  [421] = {.lex_state = 45},
  [422] = {.lex_state = 45},
  [423] = {.lex_state = 45},
  [424] = {.lex_state = 45},
  [425] = {.lex_state = 45},
  [426] = {.lex_state = 45},
  [427] = {.lex_state = 45},
  [428] = {.lex_state = 45},
  [429] = {.lex_state = 45},
  [430] = {.lex_state = 45},
  [431] = {.lex_state = 45},
  [432] = {.lex_state = 45},
  [433] = {.lex_state = 45},
  [434] = {.lex_state = 45},
  [435] = {.lex_state = 45},
  [436] = {.lex_state = 45},
  [437] = {.lex_state = 45},
  [438] = {.lex_state = 45},
  [439] = {.lex_state = 45},
  [440] = {.lex_state = 45},
  [441] = {.lex_state = 45},
  [442] = {.lex_state = 45},
  [443] = {.lex_state = 45},
  [444] = {.lex_state = 45},
  [445] = {.lex_state = 45},
  [446] = {.lex_state = 45},
  [447] = {.lex_state = 45},
  [448] = {.lex_state = 45},
  [449] = {.lex_state = 45},
  [450] = {.lex_state = 44},
  [451] = {.lex_state = 45},
  [452] = {.lex_state = 45},
  [453] = {.lex_state = 45},
  [454] = {.lex_state = 45},
  [455] = {.lex_state = 45},
  [456] = {.lex_state = 45},
  [457] = {.lex_state = 45},
  [458] = {.lex_state = 45},
  [459] = {.lex_state = 45},
  [460] = {.lex_state = 45},
  [461] = {.lex_state = 45},
  [462] = {.lex_state = 45},
  [463] = {.lex_state = 45},
  [464] = {.lex_state = 45},
  [465] = {.lex_state = 45},
  [466] = {.lex_state = 45},
  [467] = {.lex_state = 45},
  [468] = {.lex_state = 45},
  [469] = {.lex_state = 45},
  [470] = {.lex_state = 45},
  [471] = {.lex_state = 45},
  [472] = {.lex_state = 45},
  [473] = {.lex_state = 45},
  [474] = {.lex_state = 45},
  [475] = {.lex_state = 45},
  [476] = {.lex_state = 45},
  [477] = {.lex_state = 45},
  [478] = {.lex_state = 44},
  [479] = {.lex_state = 44},
  [480] = {.lex_state = 45},
  [481] = {.lex_state = 45},
  [482] = {.lex_state = 45},
  [483] = {.lex_state = 45},
  [484] = {.lex_state = 45},
  [485] = {.lex_state = 45},
  [486] = {.lex_state = 45},
  [487] = {.lex_state = 45},
  [488] = {.lex_state = 45},
  [489] = {.lex_state = 45},
  [490] = {.lex_state = 45},
  [491] = {.lex_state = 45},
  [492] = {.lex_state = 45},
  [493] = {.lex_state = 45},
  [494] = {.lex_state = 45},
  [495] = {.lex_state = 45},
  [496] = {.lex_state = 45},
  [497] = {.lex_state = 45},
  [498] = {.lex_state = 45},
  [499] = {.lex_state = 45},
  [500] = {.lex_state = 45},
  [501] = {.lex_state = 45},
  [502] = {.lex_state = 45},
  [503] = {.lex_state = 45},
  [504] = {.lex_state = 45},
  [505] = {.lex_state = 45},
  [506] = {.lex_state = 45},
  [507] = {.lex_state = 45},
  [508] = {.lex_state = 45},
  [509] = {.lex_state = 45},
  [510] = {.lex_state = 45},
  [511] = {.lex_state = 45},
  [512] = {.lex_state = 45},
  [513] = {.lex_state = 45},
  [514] = {.lex_state = 45},
  [515] = {.lex_state = 45},
  [516] = {.lex_state = 45},
  [517] = {.lex_state = 45},
  [518] = {.lex_state = 45},
  [519] = {.lex_state = 45},
  [520] = {.lex_state = 45},
  [521] = {.lex_state = 45},
  [522] = {.lex_state = 45},
  [523] = {.lex_state = 45},
  [524] = {.lex_state = 45},
  [525] = {.lex_state = 45},
  [526] = {.lex_state = 45},
  [527] = {.lex_state = 45},
  [528] = {.lex_state = 45},
  [529] = {.lex_state = 45},
  [530] = {.lex_state = 45},
  [531] = {.lex_state = 45},
  [532] = {.lex_state = 45},
  [533] = {.lex_state = 45},
  [534] = {.lex_state = 45},
  [535] = {.lex_state = 45},
  [536] = {.lex_state = 45},
  [537] = {.lex_state = 45},
  [538] = {.lex_state = 45},
  [539] = {.lex_state = 45},
  [540] = {.lex_state = 45},
  [541] = {.lex_state = 45},
  [542] = {.lex_state = 45},
  [543] = {.lex_state = 45},
  [544] = {.lex_state = 45},
  [545] = {.lex_state = 45},
  [546] = {.lex_state = 45},
  [547] = {.lex_state = 45},
  [548] = {.lex_state = 45},
  [549] = {.lex_state = 45},
  [550] = {.lex_state = 45},
  [551] = {.lex_state = 45},
  [552] = {.lex_state = 45},
  [553] = {.lex_state = 45},
  [554] = {.lex_state = 45},
  [555] = {.lex_state = 45},
  [556] = {.lex_state = 45},
  [557] = {.lex_state = 45},
  [558] = {.lex_state = 45},
  [559] = {.lex_state = 45},
  [560] = {.lex_state = 45},
  [561] = {.lex_state = 45},
  [562] = {.lex_state = 45},
  [563] = {.lex_state = 45},
  [564] = {.lex_state = 45},
  [565] = {.lex_state = 45},
  [566] = {.lex_state = 45},
  [567] = {.lex_state = 45},
  [568] = {.lex_state = 45},
  [569] = {.lex_state = 45},
  [570] = {.lex_state = 45},
  [571] = {.lex_state = 45},
  [572] = {.lex_state = 45},
  [573] = {.lex_state = 45},
  [574] = {.lex_state = 45},
  [575] = {.lex_state = 45},
  [576] = {.lex_state = 45},
  [577] = {.lex_state = 45},
  [578] = {.lex_state = 45},
  [579] = {.lex_state = 45},
  [580] = {.lex_state = 45},
  [581] = {.lex_state = 45},
  [582] = {.lex_state = 45},
  [583] = {.lex_state = 45},
  [584] = {.lex_state = 45},
  [585] = {.lex_state = 45},
  [586] = {.lex_state = 45},
  [587] = {.lex_state = 45},
  [588] = {.lex_state = 45},
  [589] = {.lex_state = 45},
  [590] = {.lex_state = 45},
  [591] = {.lex_state = 45},
  [592] = {.lex_state = 45},
  [593] = {.lex_state = 45},
  [594] = {.lex_state = 45},
  [595] = {.lex_state = 45},
  [596] = {.lex_state = 45},
  [597] = {.lex_state = 45},
  [598] = {.lex_state = 45},
  [599] = {.lex_state = 45},
  [600] = {.lex_state = 45},
  [601] = {.lex_state = 45},
  [602] = {.lex_state = 45},
  [603] = {.lex_state = 45},
  [604] = {.lex_state = 45},
  [605] = {.lex_state = 45},
  [606] = {.lex_state = 45},
  [607] = {.lex_state = 45},
  [608] = {.lex_state = 45},
  [609] = {.lex_state = 45},
  [610] = {.lex_state = 45},
  [611] = {.lex_state = 45},
  [612] = {.lex_state = 45},
  [613] = {.lex_state = 45},
  [614] = {.lex_state = 45},
  [615] = {.lex_state = 45},
  [616] = {.lex_state = 45},
  [617] = {.lex_state = 45},
  [618] = {.lex_state = 45},
  [619] = {.lex_state = 45},
  [620] = {.lex_state = 45},
  [621] = {.lex_state = 45},
  [622] = {.lex_state = 45},
  [623] = {.lex_state = 45},
  [624] = {.lex_state = 45},
  [625] = {.lex_state = 45},
  [626] = {.lex_state = 45},
  [627] = {.lex_state = 45},
  [628] = {.lex_state = 45},
  [629] = {.lex_state = 45},
  [630] = {.lex_state = 45},
  [631] = {.lex_state = 45},
  [632] = {.lex_state = 45},
  [633] = {.lex_state = 45},
  [634] = {.lex_state = 45},
  [635] = {.lex_state = 45},
  [636] = {.lex_state = 45},
  [637] = {.lex_state = 45},
  [638] = {.lex_state = 45},
  [639] = {.lex_state = 45},
  [640] = {.lex_state = 45},
  [641] = {.lex_state = 45},
  [642] = {.lex_state = 45},
  [643] = {.lex_state = 45},
  [644] = {.lex_state = 45},
  [645] = {.lex_state = 45},
  [646] = {.lex_state = 45},
  [647] = {.lex_state = 45},
  [648] = {.lex_state = 45},
  [649] = {.lex_state = 45},
  [650] = {.lex_state = 45},
  [651] = {.lex_state = 45},
  [652] = {.lex_state = 45},
  [653] = {.lex_state = 45},
  [654] = {.lex_state = 45},
  [655] = {.lex_state = 45},
  [656] = {.lex_state = 45},
  [657] = {.lex_state = 45},
  [658] = {.lex_state = 45},
  [659] = {.lex_state = 45},
  [660] = {.lex_state = 45},
  [661] = {.lex_state = 45},
  [662] = {.lex_state = 45},
  [663] = {.lex_state = 45},
  [664] = {.lex_state = 45},
  [665] = {.lex_state = 45},
  [666] = {.lex_state = 45},
  [667] = {.lex_state = 45},
  [668] = {.lex_state = 45},
  [669] = {.lex_state = 45},
  [670] = {.lex_state = 45},
  [671] = {.lex_state = 45},
  [672] = {.lex_state = 45},
  [673] = {.lex_state = 45},
  [674] = {.lex_state = 45},
  [675] = {.lex_state = 45},
  [676] = {.lex_state = 45},
  [677] = {.lex_state = 45},
  [678] = {.lex_state = 45},
  [679] = {.lex_state = 45},
  [680] = {.lex_state = 45},
  [681] = {.lex_state = 45},
  [682] = {.lex_state = 45},
  [683] = {.lex_state = 45},
  [684] = {.lex_state = 45},
  [685] = {.lex_state = 45},
  [686] = {.lex_state = 45},
  [687] = {.lex_state = 45},
  [688] = {.lex_state = 45},
  [689] = {.lex_state = 45},
  [690] = {.lex_state = 45},
  [691] = {.lex_state = 45},
  [692] = {.lex_state = 45},
  [693] = {.lex_state = 45},
  [694] = {.lex_state = 45},
  [695] = {.lex_state = 45},
  [696] = {.lex_state = 45},
  [697] = {.lex_state = 45},
  [698] = {.lex_state = 45},
  [699] = {.lex_state = 45},
  [700] = {.lex_state = 45},
  [701] = {.lex_state = 45},
  [702] = {.lex_state = 45},
  [703] = {.lex_state = 45},
  [704] = {.lex_state = 45},
  [705] = {.lex_state = 45},
  [706] = {.lex_state = 45},
  [707] = {.lex_state = 45},
  [708] = {.lex_state = 45},
  [709] = {.lex_state = 45},
  [710] = {.lex_state = 45},
  [711] = {.lex_state = 45},
  [712] = {.lex_state = 45},
  [713] = {.lex_state = 45},
  [714] = {.lex_state = 45},
  [715] = {.lex_state = 45},
  [716] = {.lex_state = 45},
  [717] = {.lex_state = 45},
  [718] = {.lex_state = 45},
  [719] = {.lex_state = 45},
  [720] = {.lex_state = 45},
  [721] = {.lex_state = 45},
  [722] = {.lex_state = 45},
  [723] = {.lex_state = 45},
  [724] = {.lex_state = 45},
  [725] = {.lex_state = 45},
  [726] = {.lex_state = 45},
  [727] = {.lex_state = 45},
  [728] = {.lex_state = 45},
  [729] = {.lex_state = 45},
  [730] = {.lex_state = 45},
  [731] = {.lex_state = 45},
  [732] = {.lex_state = 45},
  [733] = {.lex_state = 45},
  [734] = {.lex_state = 45},
  [735] = {.lex_state = 45},
  [736] = {.lex_state = 45},
  [737] = {.lex_state = 45},
  [738] = {.lex_state = 45},
  [739] = {.lex_state = 45},
  [740] = {.lex_state = 45},
  [741] = {.lex_state = 45},
  [742] = {.lex_state = 45},
  [743] = {.lex_state = 45},
  [744] = {.lex_state = 45},
  [745] = {.lex_state = 45},
  [746] = {.lex_state = 45},
  [747] = {.lex_state = 45},
  [748] = {.lex_state = 45},
  [749] = {.lex_state = 45},
  [750] = {.lex_state = 45},
  [751] = {.lex_state = 45},
  [752] = {.lex_state = 45},
  [753] = {.lex_state = 45},
  [754] = {.lex_state = 45},
  [755] = {.lex_state = 45},
  [756] = {.lex_state = 45},
  [757] = {.lex_state = 45},
  [758] = {.lex_state = 45},
  [759] = {.lex_state = 45},
  [760] = {.lex_state = 45},
  [761] = {.lex_state = 45},
  [762] = {.lex_state = 45},
  [763] = {.lex_state = 45},
  [764] = {.lex_state = 45},
  [765] = {.lex_state = 45},
  [766] = {.lex_state = 45},
  [767] = {.lex_state = 45},
  [768] = {.lex_state = 45},
  [769] = {.lex_state = 45},
  [770] = {.lex_state = 45},
  [771] = {.lex_state = 45},
  [772] = {.lex_state = 45},
  [773] = {.lex_state = 45},
  [774] = {.lex_state = 45},
  [775] = {.lex_state = 45},
  [776] = {.lex_state = 45},
  [777] = {.lex_state = 45},
  [778] = {.lex_state = 45},
  [779] = {.lex_state = 45},
  [780] = {.lex_state = 45},
  [781] = {.lex_state = 45},
  [782] = {.lex_state = 45},
  [783] = {.lex_state = 45},
  [784] = {.lex_state = 45},
  [785] = {.lex_state = 45},
  [786] = {.lex_state = 45},
  [787] = {.lex_state = 45},
  [788] = {.lex_state = 45},
  [789] = {.lex_state = 45},
  [790] = {.lex_state = 45},
  [791] = {.lex_state = 45},
  [792] = {.lex_state = 45},
  [793] = {.lex_state = 45},
  [794] = {.lex_state = 45},
  [795] = {.lex_state = 45},
  [796] = {.lex_state = 45},
  [797] = {.lex_state = 45},
  [798] = {.lex_state = 45},
  [799] = {.lex_state = 45},
  [800] = {.lex_state = 45},
  [801] = {.lex_state = 45},
  [802] = {.lex_state = 45},
  [803] = {.lex_state = 45},
  [804] = {.lex_state = 45},
  [805] = {.lex_state = 45},
  [806] = {.lex_state = 45},
  [807] = {.lex_state = 45},
  [808] = {.lex_state = 45},
  [809] = {.lex_state = 45},
  [810] = {.lex_state = 45},
  [811] = {.lex_state = 45},
  [812] = {.lex_state = 45},
  [813] = {.lex_state = 45},
  [814] = {.lex_state = 45},
  [815] = {.lex_state = 45},
  [816] = {.lex_state = 45},
  [817] = {.lex_state = 45},
  [818] = {.lex_state = 45},
  [819] = {.lex_state = 45},
  [820] = {.lex_state = 45},
  [821] = {.lex_state = 45},
  [822] = {.lex_state = 45},
  [823] = {.lex_state = 45},
  [824] = {.lex_state = 45},
  [825] = {.lex_state = 45},
  [826] = {.lex_state = 45},
  [827] = {.lex_state = 45},
  [828] = {.lex_state = 45},
  [829] = {.lex_state = 45},
  [830] = {.lex_state = 45},
  [831] = {.lex_state = 45},
  [832] = {.lex_state = 45},
  [833] = {.lex_state = 45},
  [834] = {.lex_state = 45},
  [835] = {.lex_state = 45},
  [836] = {.lex_state = 45},
  [837] = {.lex_state = 45},
  [838] = {.lex_state = 45},
  [839] = {.lex_state = 45},
  [840] = {.lex_state = 45},
  [841] = {.lex_state = 45},
  [842] = {.lex_state = 45},
  [843] = {.lex_state = 45},
  [844] = {.lex_state = 45},
  [845] = {.lex_state = 45},
  [846] = {.lex_state = 45},
  [847] = {.lex_state = 45},
  [848] = {.lex_state = 45},
  [849] = {.lex_state = 45},
  [850] = {.lex_state = 45},
  [851] = {.lex_state = 45},
  [852] = {.lex_state = 45},
  [853] = {.lex_state = 45},
  [854] = {.lex_state = 45},
  [855] = {.lex_state = 45},
  [856] = {.lex_state = 45},
  [857] = {.lex_state = 45},
  [858] = {.lex_state = 45},
  [859] = {.lex_state = 45},
  [860] = {.lex_state = 45},
  [861] = {.lex_state = 45},
  [862] = {.lex_state = 45},
  [863] = {.lex_state = 45},
  [864] = {.lex_state = 45},
  [865] = {.lex_state = 45},
  [866] = {.lex_state = 45},
  [867] = {.lex_state = 45},
  [868] = {.lex_state = 45},
  [869] = {.lex_state = 45},
  [870] = {.lex_state = 45},
  [871] = {.lex_state = 45},
  [872] = {.lex_state = 45},
  [873] = {.lex_state = 45},
  [874] = {.lex_state = 45},
  [875] = {.lex_state = 45},
  [876] = {.lex_state = 45},
  [877] = {.lex_state = 45},
  [878] = {.lex_state = 45},
  [879] = {.lex_state = 45},
  [880] = {.lex_state = 45},
  [881] = {.lex_state = 45},
  [882] = {.lex_state = 45},
  [883] = {.lex_state = 45},
  [884] = {.lex_state = 45},
  [885] = {.lex_state = 45},
  [886] = {.lex_state = 45},
  [887] = {.lex_state = 45},
  [888] = {.lex_state = 45},
  [889] = {.lex_state = 45},
  [890] = {.lex_state = 45},
  [891] = {.lex_state = 45},
  [892] = {.lex_state = 45},
  [893] = {.lex_state = 45},
  [894] = {.lex_state = 45},
  [895] = {.lex_state = 45},
  [896] = {.lex_state = 45},
  [897] = {.lex_state = 45},
  [898] = {.lex_state = 45},
  [899] = {.lex_state = 45},
  [900] = {.lex_state = 45},
  [901] = {.lex_state = 45},
  [902] = {.lex_state = 45},
  [903] = {.lex_state = 45},
  [904] = {.lex_state = 45},
  [905] = {.lex_state = 45},
  [906] = {.lex_state = 45},
  [907] = {.lex_state = 45},
  [908] = {.lex_state = 45},
  [909] = {.lex_state = 45},
  [910] = {.lex_state = 45},
  [911] = {.lex_state = 45},
  [912] = {.lex_state = 45},
  [913] = {.lex_state = 45},
  [914] = {.lex_state = 45},
  [915] = {.lex_state = 45},
  [916] = {.lex_state = 45},
  [917] = {.lex_state = 45},
  [918] = {.lex_state = 45},
  [919] = {.lex_state = 45},
  [920] = {.lex_state = 45},
  [921] = {.lex_state = 45},
  [922] = {.lex_state = 45},
  [923] = {.lex_state = 45},
  [924] = {.lex_state = 45},
  [925] = {.lex_state = 45},
  [926] = {.lex_state = 45},
  [927] = {.lex_state = 45},
  [928] = {.lex_state = 45},
  [929] = {.lex_state = 45},
  [930] = {.lex_state = 45},
  [931] = {.lex_state = 45},
  [932] = {.lex_state = 45},
  [933] = {.lex_state = 45},
  [934] = {.lex_state = 45},
  [935] = {.lex_state = 45},
  [936] = {.lex_state = 45},
  [937] = {.lex_state = 45},
  [938] = {.lex_state = 45},
  [939] = {.lex_state = 45},
  [940] = {.lex_state = 45},
  [941] = {.lex_state = 45},
  [942] = {.lex_state = 45},
  [943] = {.lex_state = 45},
  [944] = {.lex_state = 45},
  [945] = {.lex_state = 45},
  [946] = {.lex_state = 45},
  [947] = {.lex_state = 45},
  [948] = {.lex_state = 45},
  [949] = {.lex_state = 45},
  [950] = {.lex_state = 45},
  [951] = {.lex_state = 45},
  [952] = {.lex_state = 45},
  [953] = {.lex_state = 45},
  [954] = {.lex_state = 45},
  [955] = {.lex_state = 45},
  [956] = {.lex_state = 45},
  [957] = {.lex_state = 45},
  [958] = {.lex_state = 45},
  [959] = {.lex_state = 45},
  [960] = {.lex_state = 45},
  [961] = {.lex_state = 45},
  [962] = {.lex_state = 45},
  [963] = {.lex_state = 45},
  [964] = {.lex_state = 45},
  [965] = {.lex_state = 45},
  [966] = {.lex_state = 45},
  [967] = {.lex_state = 45},
  [968] = {.lex_state = 45},
  [969] = {.lex_state = 45},
  [970] = {.lex_state = 45},
  [971] = {.lex_state = 45},
  [972] = {.lex_state = 45},
  [973] = {.lex_state = 45},
  [974] = {.lex_state = 45},
  [975] = {.lex_state = 45},
  [976] = {.lex_state = 45},
  [977] = {.lex_state = 45},
  [978] = {.lex_state = 45},
  [979] = {.lex_state = 45},
  [980] = {.lex_state = 45},
  [981] = {.lex_state = 45},
  [982] = {.lex_state = 45},
  [983] = {.lex_state = 45},
  [984] = {.lex_state = 45},
  [985] = {.lex_state = 45},
  [986] = {.lex_state = 45},
  [987] = {.lex_state = 45},
  [988] = {.lex_state = 45},
  [989] = {.lex_state = 45},
  [990] = {.lex_state = 45},
  [991] = {.lex_state = 45},
  [992] = {.lex_state = 45},
  [993] = {.lex_state = 45},
  [994] = {.lex_state = 45},
  [995] = {.lex_state = 45},
  [996] = {.lex_state = 45},
  [997] = {.lex_state = 45},
  [998] = {.lex_state = 45},
  [999] = {.lex_state = 45},
  [1000] = {.lex_state = 45},
  [1001] = {.lex_state = 45},
  [1002] = {.lex_state = 45},
  [1003] = {.lex_state = 45},
  [1004] = {.lex_state = 45},
  [1005] = {.lex_state = 45},
  [1006] = {.lex_state = 45},
  [1007] = {.lex_state = 45},
  [1008] = {.lex_state = 45},
  [1009] = {.lex_state = 45},
  [1010] = {.lex_state = 45},
  [1011] = {.lex_state = 45},
  [1012] = {.lex_state = 45},
  [1013] = {.lex_state = 45},
  [1014] = {.lex_state = 45},
  [1015] = {.lex_state = 45},
  [1016] = {.lex_state = 45},
  [1017] = {.lex_state = 45},
  [1018] = {.lex_state = 45},
  [1019] = {.lex_state = 45},
  [1020] = {.lex_state = 45},
  [1021] = {.lex_state = 45},
  [1022] = {.lex_state = 45},
  [1023] = {.lex_state = 45},
  [1024] = {.lex_state = 45},
  [1025] = {.lex_state = 45},
  [1026] = {.lex_state = 45},
  [1027] = {.lex_state = 45},
  [1028] = {.lex_state = 45},
  [1029] = {.lex_state = 45},
  [1030] = {.lex_state = 45},
  [1031] = {.lex_state = 45},
  [1032] = {.lex_state = 45},
  [1033] = {.lex_state = 45},
  [1034] = {.lex_state = 45},
  [1035] = {.lex_state = 45},
  [1036] = {.lex_state = 45},
  [1037] = {.lex_state = 45},
  [1038] = {.lex_state = 45},
  [1039] = {.lex_state = 45},
  [1040] = {.lex_state = 45},
  [1041] = {.lex_state = 45},
  [1042] = {.lex_state = 45},
  [1043] = {.lex_state = 45},
  [1044] = {.lex_state = 45},
  [1045] = {.lex_state = 45},
  [1046] = {.lex_state = 45},
  [1047] = {.lex_state = 45},
  [1048] = {.lex_state = 45},
  [1049] = {.lex_state = 45},
  [1050] = {.lex_state = 45},
  [1051] = {.lex_state = 45},
  [1052] = {.lex_state = 45},
  [1053] = {.lex_state = 45},
  [1054] = {.lex_state = 45},
  [1055] = {.lex_state = 45},
  [1056] = {.lex_state = 45},
  [1057] = {.lex_state = 45},
  [1058] = {.lex_state = 45},
  [1059] = {.lex_state = 45},
  [1060] = {.lex_state = 45},
  [1061] = {.lex_state = 45},
  [1062] = {.lex_state = 45},
  [1063] = {.lex_state = 45},
  [1064] = {.lex_state = 45},
  [1065] = {.lex_state = 45},
  [1066] = {.lex_state = 45},
  [1067] = {.lex_state = 45},
  [1068] = {.lex_state = 45},
  [1069] = {.lex_state = 45},
  [1070] = {.lex_state = 45},
  [1071] = {.lex_state = 45},
  [1072] = {.lex_state = 45},
  [1073] = {.lex_state = 45},
  [1074] = {.lex_state = 45},
  [1075] = {.lex_state = 45},
  [1076] = {.lex_state = 45},
  [1077] = {.lex_state = 45},
  [1078] = {.lex_state = 45},
  [1079] = {.lex_state = 45},
  [1080] = {.lex_state = 45},
  [1081] = {.lex_state = 45},
  [1082] = {.lex_state = 45},
  [1083] = {.lex_state = 45},
  [1084] = {.lex_state = 45},
  [1085] = {.lex_state = 45},
  [1086] = {.lex_state = 45},
  [1087] = {.lex_state = 45},
  [1088] = {.lex_state = 45},
  [1089] = {.lex_state = 45},
  [1090] = {.lex_state = 45},
  [1091] = {.lex_state = 45},
  [1092] = {.lex_state = 45},
  [1093] = {.lex_state = 45},
  [1094] = {.lex_state = 45},
  [1095] = {.lex_state = 45},
  [1096] = {.lex_state = 45},
  [1097] = {.lex_state = 45},
  [1098] = {.lex_state = 45},
  [1099] = {.lex_state = 45},
  [1100] = {.lex_state = 45},
  [1101] = {.lex_state = 45},
  [1102] = {.lex_state = 45},
  [1103] = {.lex_state = 45},
  [1104] = {.lex_state = 45},
  [1105] = {.lex_state = 45},
  [1106] = {.lex_state = 45},
  [1107] = {.lex_state = 45},
  [1108] = {.lex_state = 45},
  [1109] = {.lex_state = 45},
  [1110] = {.lex_state = 45},
  [1111] = {.lex_state = 45},
  [1112] = {.lex_state = 45},
  [1113] = {.lex_state = 45},
  [1114] = {.lex_state = 45},
  [1115] = {.lex_state = 45},
  [1116] = {.lex_state = 45},
  [1117] = {.lex_state = 45},
  [1118] = {.lex_state = 45},
  [1119] = {.lex_state = 45},
  [1120] = {.lex_state = 45},
  [1121] = {.lex_state = 45},
  [1122] = {.lex_state = 45},
  [1123] = {.lex_state = 45},
  [1124] = {.lex_state = 45},
  [1125] = {.lex_state = 45},
  [1126] = {.lex_state = 45},
  [1127] = {.lex_state = 45},
  [1128] = {.lex_state = 45},
  [1129] = {.lex_state = 45},
  [1130] = {.lex_state = 45},
  [1131] = {.lex_state = 45},
  [1132] = {.lex_state = 45},
  [1133] = {.lex_state = 45},
  [1134] = {.lex_state = 45},
  [1135] = {.lex_state = 45},
  [1136] = {.lex_state = 45},
  [1137] = {.lex_state = 45},
  [1138] = {.lex_state = 45},
  [1139] = {.lex_state = 45},
  [1140] = {.lex_state = 45},
  [1141] = {.lex_state = 45},
  [1142] = {.lex_state = 45},
  [1143] = {.lex_state = 45},
  [1144] = {.lex_state = 45},
  [1145] = {.lex_state = 45},
  [1146] = {.lex_state = 45},
  [1147] = {.lex_state = 45},
  [1148] = {.lex_state = 45},
  [1149] = {.lex_state = 45},
  [1150] = {.lex_state = 45},
  [1151] = {.lex_state = 45},
  [1152] = {.lex_state = 45},
  [1153] = {.lex_state = 45},
  [1154] = {.lex_state = 45},
  [1155] = {.lex_state = 45},
  [1156] = {.lex_state = 45},
  [1157] = {.lex_state = 45},
  [1158] = {.lex_state = 45},
  [1159] = {.lex_state = 45},
  [1160] = {.lex_state = 45},
  [1161] = {.lex_state = 45},
  [1162] = {.lex_state = 45},
  [1163] = {.lex_state = 45},
  [1164] = {.lex_state = 45},
  [1165] = {.lex_state = 45},
  [1166] = {.lex_state = 45},
  [1167] = {.lex_state = 45},
  [1168] = {.lex_state = 45},
  [1169] = {.lex_state = 45},
  [1170] = {.lex_state = 45},
  [1171] = {.lex_state = 45},
  [1172] = {.lex_state = 45},
  [1173] = {.lex_state = 45},
  [1174] = {.lex_state = 45},
  [1175] = {.lex_state = 45},
  [1176] = {.lex_state = 45},
  [1177] = {.lex_state = 45},
  [1178] = {.lex_state = 45},
  [1179] = {.lex_state = 45},
  [1180] = {.lex_state = 45},
  [1181] = {.lex_state = 45},
  [1182] = {.lex_state = 45},
  [1183] = {.lex_state = 45},
  [1184] = {.lex_state = 45},
  [1185] = {.lex_state = 45},
  [1186] = {.lex_state = 45},
  [1187] = {.lex_state = 45},
  [1188] = {.lex_state = 45},
  [1189] = {.lex_state = 45},
  [1190] = {.lex_state = 45},
  [1191] = {.lex_state = 45},
  [1192] = {.lex_state = 45},
  [1193] = {.lex_state = 45},
  [1194] = {.lex_state = 45},
  [1195] = {.lex_state = 45},
  [1196] = {.lex_state = 45},
  [1197] = {.lex_state = 45},
  [1198] = {.lex_state = 45},
  [1199] = {.lex_state = 45},
  [1200] = {.lex_state = 45},
  [1201] = {.lex_state = 45},
  [1202] = {.lex_state = 45},
  [1203] = {.lex_state = 45},
  [1204] = {.lex_state = 45},
  [1205] = {.lex_state = 45},
  [1206] = {.lex_state = 45},
  [1207] = {.lex_state = 45},
  [1208] = {.lex_state = 45},
  [1209] = {.lex_state = 45},
  [1210] = {.lex_state = 45},
  [1211] = {.lex_state = 45},
  [1212] = {.lex_state = 45},
  [1213] = {.lex_state = 45},
  [1214] = {.lex_state = 45},
  [1215] = {.lex_state = 45},
  [1216] = {.lex_state = 45},
  [1217] = {.lex_state = 45},
  [1218] = {.lex_state = 45},
  [1219] = {.lex_state = 45},
  [1220] = {.lex_state = 45},
  [1221] = {.lex_state = 45},
  [1222] = {.lex_state = 45},
  [1223] = {.lex_state = 45},
  [1224] = {.lex_state = 45},
  [1225] = {.lex_state = 45},
  [1226] = {.lex_state = 45},
  [1227] = {.lex_state = 45},
  [1228] = {.lex_state = 45},
  [1229] = {.lex_state = 45},
  [1230] = {.lex_state = 45},
  [1231] = {.lex_state = 45},
  [1232] = {.lex_state = 45},
  [1233] = {.lex_state = 45},
  [1234] = {.lex_state = 45},
  [1235] = {.lex_state = 45},
  [1236] = {.lex_state = 45},
  [1237] = {.lex_state = 45},
  [1238] = {.lex_state = 45},
  [1239] = {.lex_state = 45},
  [1240] = {.lex_state = 45},
  [1241] = {.lex_state = 45},
  [1242] = {.lex_state = 45},
  [1243] = {.lex_state = 45},
  [1244] = {.lex_state = 45},
  [1245] = {.lex_state = 45},
  [1246] = {.lex_state = 45},
  [1247] = {.lex_state = 45},
  [1248] = {.lex_state = 45},
  [1249] = {.lex_state = 45},
  [1250] = {.lex_state = 45},
  [1251] = {.lex_state = 45},
  [1252] = {.lex_state = 45},
  [1253] = {.lex_state = 45},
  [1254] = {.lex_state = 45},
  [1255] = {.lex_state = 45},
  [1256] = {.lex_state = 45},
  [1257] = {.lex_state = 45},
  [1258] = {.lex_state = 45},
  [1259] = {.lex_state = 45},
  [1260] = {.lex_state = 45},
  [1261] = {.lex_state = 45},
  [1262] = {.lex_state = 45},
  [1263] = {.lex_state = 45},
  [1264] = {.lex_state = 45},
  [1265] = {.lex_state = 45},
  [1266] = {.lex_state = 45},
  [1267] = {.lex_state = 45},
  [1268] = {.lex_state = 45},
  [1269] = {.lex_state = 45},
  [1270] = {.lex_state = 45},
  [1271] = {.lex_state = 45},
  [1272] = {.lex_state = 45},
  [1273] = {.lex_state = 45},
  [1274] = {.lex_state = 45},
  [1275] = {.lex_state = 45},
  [1276] = {.lex_state = 45},
  [1277] = {.lex_state = 45},
  [1278] = {.lex_state = 45},
  [1279] = {.lex_state = 45},
  [1280] = {.lex_state = 45},
  [1281] = {.lex_state = 45},
  [1282] = {.lex_state = 45},
  [1283] = {.lex_state = 45},
  [1284] = {.lex_state = 45},
  [1285] = {.lex_state = 45},
  [1286] = {.lex_state = 45},
  [1287] = {.lex_state = 45},
  [1288] = {.lex_state = 45},
  [1289] = {.lex_state = 45},
  [1290] = {.lex_state = 45},
  [1291] = {.lex_state = 45},
  [1292] = {.lex_state = 45},
  [1293] = {.lex_state = 45},
  [1294] = {.lex_state = 45},
  [1295] = {.lex_state = 45},
  [1296] = {.lex_state = 45},
  [1297] = {.lex_state = 45},
  [1298] = {.lex_state = 45},
  [1299] = {.lex_state = 45},
  [1300] = {.lex_state = 45},
  [1301] = {.lex_state = 45},
  [1302] = {.lex_state = 45},
  [1303] = {.lex_state = 45},
  [1304] = {.lex_state = 45},
  [1305] = {.lex_state = 45},
  [1306] = {.lex_state = 45},
  [1307] = {.lex_state = 45},
  [1308] = {.lex_state = 45},
  [1309] = {.lex_state = 45},
  [1310] = {.lex_state = 45},
  [1311] = {.lex_state = 45},
  [1312] = {.lex_state = 45},
  [1313] = {.lex_state = 45},
  [1314] = {.lex_state = 45},
  [1315] = {.lex_state = 45},
  [1316] = {.lex_state = 45},
  [1317] = {.lex_state = 45},
  [1318] = {.lex_state = 45},
  [1319] = {.lex_state = 45},
  [1320] = {.lex_state = 45},
  [1321] = {.lex_state = 45},
  [1322] = {.lex_state = 45},
  [1323] = {.lex_state = 45},
  [1324] = {.lex_state = 45},
  [1325] = {.lex_state = 45},
  [1326] = {.lex_state = 45},
  [1327] = {.lex_state = 45},
  [1328] = {.lex_state = 45},
  [1329] = {.lex_state = 45},
  [1330] = {.lex_state = 45},
  [1331] = {.lex_state = 45},
  [1332] = {.lex_state = 45},
  [1333] = {.lex_state = 45},
  [1334] = {.lex_state = 45},
  [1335] = {.lex_state = 45},
  [1336] = {.lex_state = 45},
  [1337] = {.lex_state = 45},
  [1338] = {.lex_state = 45},
  [1339] = {.lex_state = 45},
  [1340] = {.lex_state = 45},
  [1341] = {.lex_state = 45},
  [1342] = {.lex_state = 45},
  [1343] = {.lex_state = 45},
  [1344] = {.lex_state = 45},
  [1345] = {.lex_state = 45},
  [1346] = {.lex_state = 45},
  [1347] = {.lex_state = 45},
  [1348] = {.lex_state = 45},
  [1349] = {.lex_state = 45},
  [1350] = {.lex_state = 45},
  [1351] = {.lex_state = 45},
  [1352] = {.lex_state = 45},
  [1353] = {.lex_state = 45},
  [1354] = {.lex_state = 45},
  [1355] = {.lex_state = 45},
  [1356] = {.lex_state = 45},
  [1357] = {.lex_state = 45},
  [1358] = {.lex_state = 45},
  [1359] = {.lex_state = 45},
  [1360] = {.lex_state = 45},
  [1361] = {.lex_state = 45},
  [1362] = {.lex_state = 45},
  [1363] = {.lex_state = 45},
  [1364] = {.lex_state = 45},
  [1365] = {.lex_state = 45},
  [1366] = {.lex_state = 45},
  [1367] = {.lex_state = 45},
  [1368] = {.lex_state = 45},
  [1369] = {.lex_state = 45},
  [1370] = {.lex_state = 45},
  [1371] = {.lex_state = 45},
  [1372] = {.lex_state = 45},
  [1373] = {.lex_state = 45},
  [1374] = {.lex_state = 45},
  [1375] = {.lex_state = 45},
  [1376] = {.lex_state = 45},
  [1377] = {.lex_state = 45},
  [1378] = {.lex_state = 45},
  [1379] = {.lex_state = 45},
  [1380] = {.lex_state = 45},
  [1381] = {.lex_state = 45},
  [1382] = {.lex_state = 45},
  [1383] = {.lex_state = 45},
  [1384] = {.lex_state = 45},
  [1385] = {.lex_state = 45},
  [1386] = {.lex_state = 45},
  [1387] = {.lex_state = 45},
  [1388] = {.lex_state = 45},
  [1389] = {.lex_state = 45},
  [1390] = {.lex_state = 45},
  [1391] = {.lex_state = 45},
  [1392] = {.lex_state = 45},
  [1393] = {.lex_state = 45},
  [1394] = {.lex_state = 45},
  [1395] = {.lex_state = 45},
  [1396] = {.lex_state = 45},
  [1397] = {.lex_state = 45},
  [1398] = {.lex_state = 45},
  [1399] = {.lex_state = 45},
  [1400] = {.lex_state = 45},
  [1401] = {.lex_state = 45},
  [1402] = {.lex_state = 45},
  [1403] = {.lex_state = 45},
  [1404] = {.lex_state = 45},
  [1405] = {.lex_state = 45},
  [1406] = {.lex_state = 45},
  [1407] = {.lex_state = 45},
  [1408] = {.lex_state = 45},
  [1409] = {.lex_state = 45},
  [1410] = {.lex_state = 45},
  [1411] = {.lex_state = 45},
  [1412] = {.lex_state = 45},
  [1413] = {.lex_state = 45},
  [1414] = {.lex_state = 45},
  [1415] = {.lex_state = 45},
  [1416] = {.lex_state = 45},
  [1417] = {.lex_state = 45},
  [1418] = {.lex_state = 45},
  [1419] = {.lex_state = 45},
  [1420] = {.lex_state = 45},
  [1421] = {.lex_state = 45},
  [1422] = {.lex_state = 45},
  [1423] = {.lex_state = 45},
  [1424] = {.lex_state = 45},
  [1425] = {.lex_state = 45},
  [1426] = {.lex_state = 45},
  [1427] = {.lex_state = 45},
  [1428] = {.lex_state = 45},
  [1429] = {.lex_state = 45},
  [1430] = {.lex_state = 45},
  [1431] = {.lex_state = 45},
  [1432] = {.lex_state = 45},
  [1433] = {.lex_state = 45},
  [1434] = {.lex_state = 45},
  [1435] = {.lex_state = 45},
  [1436] = {.lex_state = 45},
  [1437] = {.lex_state = 45},
  [1438] = {.lex_state = 45},
  [1439] = {.lex_state = 45},
  [1440] = {.lex_state = 45},
  [1441] = {.lex_state = 45},
  [1442] = {.lex_state = 45},
  [1443] = {.lex_state = 45},
  [1444] = {.lex_state = 45},
  [1445] = {.lex_state = 45},
  [1446] = {.lex_state = 45},
  [1447] = {.lex_state = 45},
  [1448] = {.lex_state = 45},
  [1449] = {.lex_state = 45},
  [1450] = {.lex_state = 45},
  [1451] = {.lex_state = 45},
  [1452] = {.lex_state = 45},
  [1453] = {.lex_state = 45},
  [1454] = {.lex_state = 45},
  [1455] = {.lex_state = 45},
  [1456] = {.lex_state = 45},
  [1457] = {.lex_state = 45},
  [1458] = {.lex_state = 45},
  [1459] = {.lex_state = 45},
  [1460] = {.lex_state = 45},
  [1461] = {.lex_state = 45},
  [1462] = {.lex_state = 45},
  [1463] = {.lex_state = 45},
  [1464] = {.lex_state = 45},
  [1465] = {.lex_state = 45},
  [1466] = {.lex_state = 45},
  [1467] = {.lex_state = 45},
  [1468] = {.lex_state = 45},
  [1469] = {.lex_state = 45},
  [1470] = {.lex_state = 45},
  [1471] = {.lex_state = 45},
  [1472] = {.lex_state = 45},
  [1473] = {.lex_state = 45},
  [1474] = {.lex_state = 45},
  [1475] = {.lex_state = 45},
  [1476] = {.lex_state = 45},
  [1477] = {.lex_state = 45},
  [1478] = {.lex_state = 45},
  [1479] = {.lex_state = 45},
  [1480] = {.lex_state = 45},
  [1481] = {.lex_state = 45},
  [1482] = {.lex_state = 45},
  [1483] = {.lex_state = 45},
  [1484] = {.lex_state = 45},
  [1485] = {.lex_state = 45},
  [1486] = {.lex_state = 45},
  [1487] = {.lex_state = 45},
  [1488] = {.lex_state = 45},
  [1489] = {.lex_state = 45},
  [1490] = {.lex_state = 45},
  [1491] = {.lex_state = 45},
  [1492] = {.lex_state = 45},
  [1493] = {.lex_state = 45},
  [1494] = {.lex_state = 45},
  [1495] = {.lex_state = 45},
  [1496] = {.lex_state = 45},
  [1497] = {.lex_state = 45},
  [1498] = {.lex_state = 45},
  [1499] = {.lex_state = 45},
  [1500] = {.lex_state = 45},
  [1501] = {.lex_state = 45},
  [1502] = {.lex_state = 45},
  [1503] = {.lex_state = 45},
  [1504] = {.lex_state = 45},
  [1505] = {.lex_state = 45},
  [1506] = {.lex_state = 45},
  [1507] = {.lex_state = 45},
  [1508] = {.lex_state = 45},
  [1509] = {.lex_state = 45},
  [1510] = {.lex_state = 45},
  [1511] = {.lex_state = 45},
  [1512] = {.lex_state = 45},
  [1513] = {.lex_state = 45},
  [1514] = {.lex_state = 45},
  [1515] = {.lex_state = 45},
  [1516] = {.lex_state = 45},
  [1517] = {.lex_state = 45},
  [1518] = {.lex_state = 45},
  [1519] = {.lex_state = 45},
  [1520] = {.lex_state = 45},
  [1521] = {.lex_state = 45},
  [1522] = {.lex_state = 45},
  [1523] = {.lex_state = 45},
  [1524] = {.lex_state = 45},
  [1525] = {.lex_state = 45},
  [1526] = {.lex_state = 45},
  [1527] = {.lex_state = 45},
  [1528] = {.lex_state = 45},
  [1529] = {.lex_state = 45},
  [1530] = {.lex_state = 45},
  [1531] = {.lex_state = 45},
  [1532] = {.lex_state = 45},
  [1533] = {.lex_state = 45},
  [1534] = {.lex_state = 45},
  [1535] = {.lex_state = 45},
  [1536] = {.lex_state = 45},
  [1537] = {.lex_state = 45},
  [1538] = {.lex_state = 45},
  [1539] = {.lex_state = 45},
  [1540] = {.lex_state = 45},
  [1541] = {.lex_state = 45},
  [1542] = {.lex_state = 45},
  [1543] = {.lex_state = 45},
  [1544] = {.lex_state = 45},
  [1545] = {.lex_state = 45},
  [1546] = {.lex_state = 45},
  [1547] = {.lex_state = 45},
  [1548] = {.lex_state = 45},
  [1549] = {.lex_state = 45},
  [1550] = {.lex_state = 45},
  [1551] = {.lex_state = 45},
  [1552] = {.lex_state = 45},
  [1553] = {.lex_state = 45},
  [1554] = {.lex_state = 45},
  [1555] = {.lex_state = 45},
  [1556] = {.lex_state = 45},
  [1557] = {.lex_state = 45},
  [1558] = {.lex_state = 45},
  [1559] = {.lex_state = 45},
  [1560] = {.lex_state = 45},
  [1561] = {.lex_state = 45},
  [1562] = {.lex_state = 45},
  [1563] = {.lex_state = 45},
  [1564] = {.lex_state = 45},
  [1565] = {.lex_state = 45},
  [1566] = {.lex_state = 45},
  [1567] = {.lex_state = 45},
  [1568] = {.lex_state = 45},
  [1569] = {.lex_state = 45},
  [1570] = {.lex_state = 45},
  [1571] = {.lex_state = 45},
  [1572] = {.lex_state = 45},
  [1573] = {.lex_state = 45},
  [1574] = {.lex_state = 45},
  [1575] = {.lex_state = 45},
  [1576] = {.lex_state = 45},
  [1577] = {.lex_state = 45},
  [1578] = {.lex_state = 45},
  [1579] = {.lex_state = 45},
  [1580] = {.lex_state = 45},
  [1581] = {.lex_state = 45},
  [1582] = {.lex_state = 45},
  [1583] = {.lex_state = 45},
  [1584] = {.lex_state = 45},
  [1585] = {.lex_state = 45},
  [1586] = {.lex_state = 45},
  [1587] = {.lex_state = 45},
  [1588] = {.lex_state = 45},
  [1589] = {.lex_state = 45},
  [1590] = {.lex_state = 45},
  [1591] = {.lex_state = 45},
  [1592] = {.lex_state = 45},
  [1593] = {.lex_state = 45},
  [1594] = {.lex_state = 45},
  [1595] = {.lex_state = 45},
  [1596] = {.lex_state = 45},
  [1597] = {.lex_state = 45},
  [1598] = {.lex_state = 45},
  [1599] = {.lex_state = 45},
  [1600] = {.lex_state = 45},
  [1601] = {.lex_state = 45},
  [1602] = {.lex_state = 45},
  [1603] = {.lex_state = 45},
  [1604] = {.lex_state = 45},
  [1605] = {.lex_state = 45},
  [1606] = {.lex_state = 45},
  [1607] = {.lex_state = 45},
  [1608] = {.lex_state = 45},
  [1609] = {.lex_state = 45},
  [1610] = {.lex_state = 45},
  [1611] = {.lex_state = 45},
  [1612] = {.lex_state = 45},
  [1613] = {.lex_state = 45},
  [1614] = {.lex_state = 45},
  [1615] = {.lex_state = 45},
  [1616] = {.lex_state = 45},
  [1617] = {.lex_state = 45},
  [1618] = {.lex_state = 45},
  [1619] = {.lex_state = 45},
  [1620] = {.lex_state = 45},
  [1621] = {.lex_state = 45},
  [1622] = {.lex_state = 45},
  [1623] = {.lex_state = 45},
  [1624] = {.lex_state = 45},
  [1625] = {.lex_state = 45},
  [1626] = {.lex_state = 45},
  [1627] = {.lex_state = 45},
  [1628] = {.lex_state = 45},
  [1629] = {.lex_state = 45},
  [1630] = {.lex_state = 45},
  [1631] = {.lex_state = 45},
  [1632] = {.lex_state = 45},
  [1633] = {.lex_state = 45},
  [1634] = {.lex_state = 45},
  [1635] = {.lex_state = 45},
  [1636] = {.lex_state = 45},
  [1637] = {.lex_state = 45},
  [1638] = {.lex_state = 45},
  [1639] = {.lex_state = 45},
  [1640] = {.lex_state = 45},
  [1641] = {.lex_state = 45},
  [1642] = {.lex_state = 45},
  [1643] = {.lex_state = 45},
  [1644] = {.lex_state = 45},
  [1645] = {.lex_state = 45},
  [1646] = {.lex_state = 45},
  [1647] = {.lex_state = 45},
  [1648] = {.lex_state = 0},
  [1649] = {.lex_state = 45},
  [1650] = {.lex_state = 0},
  [1651] = {.lex_state = 45},
  [1652] = {.lex_state = 45},
  [1653] = {.lex_state = 45},
  [1654] = {.lex_state = 0},
  [1655] = {.lex_state = 45},
  [1656] = {.lex_state = 0},
  [1657] = {.lex_state = 0},
  [1658] = {.lex_state = 45},
  [1659] = {.lex_state = 45},
  [1660] = {.lex_state = 45},
  [1661] = {.lex_state = 45},
  [1662] = {.lex_state = 45},
  [1663] = {.lex_state = 45},
  [1664] = {.lex_state = 45},
  [1665] = {.lex_state = 45},
  [1666] = {.lex_state = 45},
  [1667] = {.lex_state = 45},
  [1668] = {.lex_state = 45},
  [1669] = {.lex_state = 45},
  [1670] = {.lex_state = 45},
  [1671] = {.lex_state = 45},
  [1672] = {.lex_state = 45},
  [1673] = {.lex_state = 45},
  [1674] = {.lex_state = 45},
  [1675] = {.lex_state = 45},
  [1676] = {.lex_state = 45},
  [1677] = {.lex_state = 45},
  [1678] = {.lex_state = 45},
  [1679] = {.lex_state = 45},
  [1680] = {.lex_state = 45},
  [1681] = {.lex_state = 45},
  [1682] = {.lex_state = 45},
  [1683] = {.lex_state = 45},
  [1684] = {.lex_state = 45},
  [1685] = {.lex_state = 45},
  [1686] = {.lex_state = 45},
  [1687] = {.lex_state = 45},
  [1688] = {.lex_state = 45},
  [1689] = {.lex_state = 45},
  [1690] = {.lex_state = 45},
  [1691] = {.lex_state = 45},
  [1692] = {.lex_state = 45},
  [1693] = {.lex_state = 45},
  [1694] = {.lex_state = 45},
  [1695] = {.lex_state = 45},
  [1696] = {.lex_state = 45},
  [1697] = {.lex_state = 45},
  [1698] = {.lex_state = 45},
  [1699] = {.lex_state = 45},
  [1700] = {.lex_state = 45},
  [1701] = {.lex_state = 45},
  [1702] = {.lex_state = 45},
  [1703] = {.lex_state = 45},
  [1704] = {.lex_state = 45},
  [1705] = {.lex_state = 45},
  [1706] = {.lex_state = 45},
  [1707] = {.lex_state = 45},
  [1708] = {.lex_state = 45},
  [1709] = {.lex_state = 45},
  [1710] = {.lex_state = 45},
  [1711] = {.lex_state = 45},
  [1712] = {.lex_state = 45},
  [1713] = {.lex_state = 45},
  [1714] = {.lex_state = 45},
  [1715] = {.lex_state = 45},
  [1716] = {.lex_state = 45},
  [1717] = {.lex_state = 45},
  [1718] = {.lex_state = 45},
  [1719] = {.lex_state = 45},
  [1720] = {.lex_state = 45},
  [1721] = {.lex_state = 45},
  [1722] = {.lex_state = 45},
  [1723] = {.lex_state = 45},
  [1724] = {.lex_state = 45},
  [1725] = {.lex_state = 45},
  [1726] = {.lex_state = 45},
  [1727] = {.lex_state = 45},
  [1728] = {.lex_state = 45},
  [1729] = {.lex_state = 45},
  [1730] = {.lex_state = 45},
  [1731] = {.lex_state = 3},
  [1732] = {.lex_state = 45},
  [1733] = {.lex_state = 45},
  [1734] = {.lex_state = 45},
  [1735] = {.lex_state = 45},
  [1736] = {.lex_state = 45},
  [1737] = {.lex_state = 45},
  [1738] = {.lex_state = 0},
  [1739] = {.lex_state = 0},
  [1740] = {.lex_state = 0},
  [1741] = {.lex_state = 0},
  [1742] = {.lex_state = 0},
  [1743] = {.lex_state = 0},
  [1744] = {.lex_state = 0},
  [1745] = {.lex_state = 0},
  [1746] = {.lex_state = 0},
  [1747] = {.lex_state = 0},
  [1748] = {.lex_state = 0},
  [1749] = {.lex_state = 0},
  [1750] = {.lex_state = 0},
  [1751] = {.lex_state = 0},
  [1752] = {.lex_state = 44},
  [1753] = {.lex_state = 44},
  [1754] = {.lex_state = 44},
  [1755] = {.lex_state = 44},
  [1756] = {.lex_state = 44},
  [1757] = {.lex_state = 44},
  [1758] = {.lex_state = 44},
  [1759] = {.lex_state = 44},
  [1760] = {.lex_state = 44},
  [1761] = {.lex_state = 44},
  [1762] = {.lex_state = 44},
  [1763] = {.lex_state = 44},
  [1764] = {.lex_state = 44},
  [1765] = {.lex_state = 44},
  [1766] = {.lex_state = 44},
  [1767] = {.lex_state = 44},
  [1768] = {.lex_state = 44},
  [1769] = {.lex_state = 44},
  [1770] = {.lex_state = 44},
  [1771] = {.lex_state = 3},
  [1772] = {.lex_state = 44},
  [1773] = {.lex_state = 44},
  [1774] = {.lex_state = 3},
  [1775] = {.lex_state = 3},
  [1776] = {.lex_state = 44},
  [1777] = {.lex_state = 44},
  [1778] = {.lex_state = 3},
  [1779] = {.lex_state = 44},
  [1780] = {.lex_state = 3},
  [1781] = {.lex_state = 44},
  [1782] = {.lex_state = 44},
  [1783] = {.lex_state = 44},
  [1784] = {.lex_state = 44},
  [1785] = {.lex_state = 44},
  [1786] = {.lex_state = 3},
  [1787] = {.lex_state = 44},
  [1788] = {.lex_state = 44},
  [1789] = {.lex_state = 44},
  [1790] = {.lex_state = 44},
  [1791] = {.lex_state = 44},
  [1792] = {.lex_state = 44},
  [1793] = {.lex_state = 44},
  [1794] = {.lex_state = 44},
  [1795] = {.lex_state = 44},
  [1796] = {.lex_state = 44},
  [1797] = {.lex_state = 44},
  [1798] = {.lex_state = 44},
  [1799] = {.lex_state = 44},
  [1800] = {.lex_state = 44},
  [1801] = {.lex_state = 44},
  [1802] = {.lex_state = 44},
  [1803] = {.lex_state = 44},
  [1804] = {.lex_state = 44},
  [1805] = {.lex_state = 44},
  [1806] = {.lex_state = 44},
  [1807] = {.lex_state = 44},
  [1808] = {.lex_state = 44},
  [1809] = {.lex_state = 44},
  [1810] = {.lex_state = 44},
  [1811] = {.lex_state = 44},
  [1812] = {.lex_state = 44},
  [1813] = {.lex_state = 44},
  [1814] = {.lex_state = 44},
  [1815] = {.lex_state = 44},
  [1816] = {.lex_state = 44},
  [1817] = {.lex_state = 44},
  [1818] = {.lex_state = 44},
  [1819] = {.lex_state = 44},
  [1820] = {.lex_state = 44},
  [1821] = {.lex_state = 44},
  [1822] = {.lex_state = 44},
  [1823] = {.lex_state = 44},
  [1824] = {.lex_state = 44},
  [1825] = {.lex_state = 3},
  [1826] = {.lex_state = 44},
  [1827] = {.lex_state = 44},
  [1828] = {.lex_state = 44},
  [1829] = {.lex_state = 44},
  [1830] = {.lex_state = 44},
  [1831] = {.lex_state = 44},
  [1832] = {.lex_state = 44},
  [1833] = {.lex_state = 44},
  [1834] = {.lex_state = 44},
  [1835] = {.lex_state = 44},
  [1836] = {.lex_state = 44},
  [1837] = {.lex_state = 44},
  [1838] = {.lex_state = 44},
  [1839] = {.lex_state = 44},
  [1840] = {.lex_state = 44},
  [1841] = {.lex_state = 44},
  [1842] = {.lex_state = 44},
  [1843] = {.lex_state = 3},
  [1844] = {.lex_state = 44},
  [1845] = {.lex_state = 44},
  [1846] = {.lex_state = 3},
  [1847] = {.lex_state = 44},
  [1848] = {.lex_state = 44},
  [1849] = {.lex_state = 44},
  [1850] = {.lex_state = 44},
  [1851] = {.lex_state = 44},
  [1852] = {.lex_state = 3},
  [1853] = {.lex_state = 44},
  [1854] = {.lex_state = 44},
  [1855] = {.lex_state = 44},
  [1856] = {.lex_state = 44},
  [1857] = {.lex_state = 0},
  [1858] = {.lex_state = 44},
  [1859] = {.lex_state = 44},
  [1860] = {.lex_state = 44},
  [1861] = {.lex_state = 3},
  [1862] = {.lex_state = 44},
  [1863] = {.lex_state = 44},
  [1864] = {.lex_state = 44},
  [1865] = {.lex_state = 44},
  [1866] = {.lex_state = 44},
  [1867] = {.lex_state = 44},
  [1868] = {.lex_state = 44},
  [1869] = {.lex_state = 3},
  [1870] = {.lex_state = 44},
  [1871] = {.lex_state = 44},
  [1872] = {.lex_state = 44},
  [1873] = {.lex_state = 3},
  [1874] = {.lex_state = 44},
  [1875] = {.lex_state = 44},
  [1876] = {.lex_state = 44},
  [1877] = {.lex_state = 44},
  [1878] = {.lex_state = 44},
  [1879] = {.lex_state = 44},
  [1880] = {.lex_state = 44},
  [1881] = {.lex_state = 44},
  [1882] = {.lex_state = 44},
  [1883] = {.lex_state = 44},
  [1884] = {.lex_state = 44},
  [1885] = {.lex_state = 44},
  [1886] = {.lex_state = 44},
  [1887] = {.lex_state = 44},
  [1888] = {.lex_state = 44},
  [1889] = {.lex_state = 44},
  [1890] = {.lex_state = 44},
  [1891] = {.lex_state = 44},
  [1892] = {.lex_state = 44},
  [1893] = {.lex_state = 44},
  [1894] = {.lex_state = 44},
  [1895] = {.lex_state = 44},
  [1896] = {.lex_state = 3},
  [1897] = {.lex_state = 0},
  [1898] = {.lex_state = 0},
  [1899] = {.lex_state = 44},
  [1900] = {.lex_state = 0},
  [1901] = {.lex_state = 44},
  [1902] = {.lex_state = 0},
  [1903] = {.lex_state = 0},
  [1904] = {.lex_state = 0},
  [1905] = {.lex_state = 0},
  [1906] = {.lex_state = 3},
  [1907] = {.lex_state = 3},
  [1908] = {.lex_state = 0},
  [1909] = {.lex_state = 3},
  [1910] = {.lex_state = 44},
  [1911] = {.lex_state = 44},
  [1912] = {.lex_state = 44},
  [1913] = {.lex_state = 44},
  [1914] = {.lex_state = 44},
  [1915] = {.lex_state = 44},
  [1916] = {.lex_state = 0},
  [1917] = {.lex_state = 44},
  [1918] = {.lex_state = 44},
  [1919] = {.lex_state = 44},
  [1920] = {.lex_state = 0},
  [1921] = {.lex_state = 0},
  [1922] = {.lex_state = 0},
  [1923] = {.lex_state = 0},
  [1924] = {.lex_state = 0},
  [1925] = {.lex_state = 0},
  [1926] = {.lex_state = 3},
  [1927] = {.lex_state = 0},
  [1928] = {.lex_state = 0},
  [1929] = {.lex_state = 0},
  [1930] = {.lex_state = 0},
  [1931] = {.lex_state = 0},
  [1932] = {.lex_state = 0},
  [1933] = {.lex_state = 0},
  [1934] = {.lex_state = 0},
  [1935] = {.lex_state = 0},
  [1936] = {.lex_state = 0},
  [1937] = {.lex_state = 0},
  [1938] = {.lex_state = 3},
  [1939] = {.lex_state = 0},
  [1940] = {.lex_state = 0},
  [1941] = {.lex_state = 0},
  [1942] = {.lex_state = 0},
  [1943] = {.lex_state = 0},
  [1944] = {.lex_state = 0},
  [1945] = {.lex_state = 0},
  [1946] = {.lex_state = 0},
  [1947] = {.lex_state = 0},
  [1948] = {.lex_state = 0},
  [1949] = {.lex_state = 0},
  [1950] = {.lex_state = 0},
  [1951] = {.lex_state = 0},
  [1952] = {.lex_state = 0},
  [1953] = {.lex_state = 0},
  [1954] = {.lex_state = 3},
  [1955] = {.lex_state = 0},
  [1956] = {.lex_state = 44},
  [1957] = {.lex_state = 45},
  [1958] = {.lex_state = 0},
  [1959] = {.lex_state = 44},
  [1960] = {.lex_state = 0},
  [1961] = {.lex_state = 44},
  [1962] = {.lex_state = 44},
  [1963] = {.lex_state = 44},
  [1964] = {.lex_state = 3},
  [1965] = {.lex_state = 0},
  [1966] = {.lex_state = 44},
  [1967] = {.lex_state = 3},
  [1968] = {.lex_state = 44},
  [1969] = {.lex_state = 44},
  [1970] = {.lex_state = 44},
  [1971] = {.lex_state = 44},
  [1972] = {.lex_state = 44},
  [1973] = {.lex_state = 44},
  [1974] = {.lex_state = 44},
  [1975] = {.lex_state = 44},
  [1976] = {.lex_state = 0},
  [1977] = {.lex_state = 44},
  [1978] = {.lex_state = 0},
  [1979] = {.lex_state = 44},
  [1980] = {.lex_state = 44},
  [1981] = {.lex_state = 0},
  [1982] = {.lex_state = 44},
  [1983] = {.lex_state = 44},
  [1984] = {.lex_state = 44},
  [1985] = {.lex_state = 44},
  [1986] = {.lex_state = 44},
  [1987] = {.lex_state = 44},
  [1988] = {.lex_state = 0},
  [1989] = {.lex_state = 44},
  [1990] = {.lex_state = 44},
  [1991] = {.lex_state = 44},
  [1992] = {.lex_state = 0},
  [1993] = {.lex_state = 44},
  [1994] = {.lex_state = 44},
  [1995] = {.lex_state = 0},
  [1996] = {.lex_state = 44},
  [1997] = {.lex_state = 44},
  [1998] = {.lex_state = 44},
  [1999] = {.lex_state = 45},
  [2000] = {.lex_state = 44},
  [2001] = {.lex_state = 44},
  [2002] = {.lex_state = 44},
  [2003] = {.lex_state = 44},
  [2004] = {.lex_state = 44},
  [2005] = {.lex_state = 44},
  [2006] = {.lex_state = 44},
  [2007] = {.lex_state = 44},
  [2008] = {.lex_state = 44},
  [2009] = {.lex_state = 44},
  [2010] = {.lex_state = 44},
  [2011] = {.lex_state = 44},
  [2012] = {.lex_state = 44},
  [2013] = {.lex_state = 44},
  [2014] = {.lex_state = 44},
  [2015] = {.lex_state = 44},
  [2016] = {.lex_state = 44},
  [2017] = {.lex_state = 44},
  [2018] = {.lex_state = 44},
  [2019] = {.lex_state = 44},
  [2020] = {.lex_state = 0},
  [2021] = {.lex_state = 0},
  [2022] = {.lex_state = 0},
  [2023] = {.lex_state = 0},
  [2024] = {.lex_state = 0},
  [2025] = {.lex_state = 44},
  [2026] = {.lex_state = 44},
  [2027] = {.lex_state = 0},
  [2028] = {.lex_state = 0},
  [2029] = {.lex_state = 0},
  [2030] = {.lex_state = 45},
  [2031] = {.lex_state = 0},
  [2032] = {.lex_state = 0},
  [2033] = {.lex_state = 0},
  [2034] = {.lex_state = 0},
  [2035] = {.lex_state = 0},
  [2036] = {.lex_state = 0},
  [2037] = {.lex_state = 45},
  [2038] = {.lex_state = 0},
  [2039] = {.lex_state = 0},
  [2040] = {.lex_state = 45},
  [2041] = {.lex_state = 0},
  [2042] = {.lex_state = 45},
  [2043] = {.lex_state = 44},
  [2044] = {.lex_state = 0},
  [2045] = {.lex_state = 0},
  [2046] = {.lex_state = 0},
  [2047] = {.lex_state = 0},
  [2048] = {.lex_state = 0},
  [2049] = {.lex_state = 0},
  [2050] = {.lex_state = 0},
  [2051] = {.lex_state = 44},
  [2052] = {.lex_state = 0},
  [2053] = {.lex_state = 0},
  [2054] = {.lex_state = 0},
  [2055] = {.lex_state = 0},
  [2056] = {.lex_state = 0},
  [2057] = {.lex_state = 44},
  [2058] = {.lex_state = 3},
  [2059] = {.lex_state = 3},
  [2060] = {.lex_state = 44},
  [2061] = {.lex_state = 44},
  [2062] = {.lex_state = 44},
  [2063] = {.lex_state = 3},
  [2064] = {.lex_state = 44},
  [2065] = {.lex_state = 44},
  [2066] = {.lex_state = 3},
  [2067] = {.lex_state = 44},
  [2068] = {.lex_state = 44},
  [2069] = {.lex_state = 44},
  [2070] = {.lex_state = 44},
  [2071] = {.lex_state = 44},
  [2072] = {.lex_state = 44},
  [2073] = {.lex_state = 44},
  [2074] = {.lex_state = 44},
  [2075] = {.lex_state = 44},
  [2076] = {.lex_state = 44},
  [2077] = {.lex_state = 44},
  [2078] = {.lex_state = 44},
  [2079] = {.lex_state = 44},
  [2080] = {.lex_state = 44},
  [2081] = {.lex_state = 44},
  [2082] = {.lex_state = 44},
  [2083] = {.lex_state = 44},
  [2084] = {.lex_state = 44},
  [2085] = {.lex_state = 44},
  [2086] = {.lex_state = 44},
  [2087] = {.lex_state = 44},
  [2088] = {.lex_state = 44},
  [2089] = {.lex_state = 44},
  [2090] = {.lex_state = 44},
  [2091] = {.lex_state = 3},
  [2092] = {.lex_state = 44},
  [2093] = {.lex_state = 0},
  [2094] = {.lex_state = 44},
  [2095] = {.lex_state = 44},
  [2096] = {.lex_state = 44},
  [2097] = {.lex_state = 44},
  [2098] = {.lex_state = 44},
  [2099] = {.lex_state = 44},
  [2100] = {.lex_state = 44},
  [2101] = {.lex_state = 44},
  [2102] = {.lex_state = 44},
  [2103] = {.lex_state = 44},
  [2104] = {.lex_state = 44},
  [2105] = {.lex_state = 44},
  [2106] = {.lex_state = 44},
  [2107] = {.lex_state = 44},
  [2108] = {.lex_state = 44},
  [2109] = {.lex_state = 44},
  [2110] = {.lex_state = 44},
  [2111] = {.lex_state = 44},
  [2112] = {.lex_state = 44},
  [2113] = {.lex_state = 44},
  [2114] = {.lex_state = 44},
  [2115] = {.lex_state = 44},
  [2116] = {.lex_state = 44},
  [2117] = {.lex_state = 44},
  [2118] = {.lex_state = 44},
  [2119] = {.lex_state = 44},
  [2120] = {.lex_state = 44},
  [2121] = {.lex_state = 44},
  [2122] = {.lex_state = 44},
  [2123] = {.lex_state = 44},
  [2124] = {.lex_state = 44},
  [2125] = {.lex_state = 44},
  [2126] = {.lex_state = 44},
  [2127] = {.lex_state = 44},
  [2128] = {.lex_state = 44},
  [2129] = {.lex_state = 44},
  [2130] = {.lex_state = 44},
  [2131] = {.lex_state = 44},
  [2132] = {.lex_state = 44},
  [2133] = {.lex_state = 44},
  [2134] = {.lex_state = 44},
  [2135] = {.lex_state = 44},
  [2136] = {.lex_state = 44},
  [2137] = {.lex_state = 44},
  [2138] = {.lex_state = 44},
  [2139] = {.lex_state = 44},
  [2140] = {.lex_state = 44},
  [2141] = {.lex_state = 44},
  [2142] = {.lex_state = 44},
  [2143] = {.lex_state = 44},
  [2144] = {.lex_state = 44},
  [2145] = {.lex_state = 44},
  [2146] = {.lex_state = 44},
  [2147] = {.lex_state = 44},
  [2148] = {.lex_state = 44},
  [2149] = {.lex_state = 44},
  [2150] = {.lex_state = 44},
  [2151] = {.lex_state = 44},
  [2152] = {.lex_state = 44},
  [2153] = {.lex_state = 44},
  [2154] = {.lex_state = 44},
  [2155] = {.lex_state = 44},
  [2156] = {.lex_state = 44},
  [2157] = {.lex_state = 44},
  [2158] = {.lex_state = 44},
  [2159] = {.lex_state = 44},
  [2160] = {.lex_state = 44},
  [2161] = {.lex_state = 44},
  [2162] = {.lex_state = 44},
  [2163] = {.lex_state = 44},
  [2164] = {.lex_state = 44},
  [2165] = {.lex_state = 44},
  [2166] = {.lex_state = 44},
  [2167] = {.lex_state = 44},
  [2168] = {.lex_state = 44},
  [2169] = {.lex_state = 44},
  [2170] = {.lex_state = 44},
  [2171] = {.lex_state = 44},
  [2172] = {.lex_state = 44},
  [2173] = {.lex_state = 44},
  [2174] = {.lex_state = 44},
  [2175] = {.lex_state = 44},
  [2176] = {.lex_state = 44},
  [2177] = {.lex_state = 44},
  [2178] = {.lex_state = 44},
  [2179] = {.lex_state = 44},
  [2180] = {.lex_state = 44},
  [2181] = {.lex_state = 44},
  [2182] = {.lex_state = 44},
  [2183] = {.lex_state = 44},
  [2184] = {.lex_state = 44},
  [2185] = {.lex_state = 44},
  [2186] = {.lex_state = 44},
  [2187] = {.lex_state = 44},
  [2188] = {.lex_state = 44},
  [2189] = {.lex_state = 0},
  [2190] = {.lex_state = 0},
  [2191] = {.lex_state = 44},
  [2192] = {.lex_state = 44},
  [2193] = {.lex_state = 44},
  [2194] = {.lex_state = 0},
  [2195] = {.lex_state = 44},
  [2196] = {.lex_state = 44},
  [2197] = {.lex_state = 0},
  [2198] = {.lex_state = 0},
  [2199] = {.lex_state = 0},
  [2200] = {.lex_state = 0},
  [2201] = {.lex_state = 44},
  [2202] = {.lex_state = 0},
  [2203] = {.lex_state = 44},
  [2204] = {.lex_state = 0},
  [2205] = {.lex_state = 0},
  [2206] = {.lex_state = 44},
  [2207] = {.lex_state = 0},
  [2208] = {.lex_state = 44},
  [2209] = {.lex_state = 44},
  [2210] = {.lex_state = 44},
  [2211] = {.lex_state = 44},
  [2212] = {.lex_state = 44},
  [2213] = {.lex_state = 44},
  [2214] = {.lex_state = 44},
  [2215] = {.lex_state = 0},
  [2216] = {.lex_state = 0},
  [2217] = {.lex_state = 44},
  [2218] = {.lex_state = 0},
  [2219] = {.lex_state = 44},
  [2220] = {.lex_state = 0},
  [2221] = {.lex_state = 0},
  [2222] = {.lex_state = 0},
  [2223] = {.lex_state = 44},
  [2224] = {.lex_state = 44},
  [2225] = {.lex_state = 44},
  [2226] = {.lex_state = 44},
  [2227] = {.lex_state = 44},
  [2228] = {.lex_state = 44},
  [2229] = {.lex_state = 44},
  [2230] = {.lex_state = 44},
  [2231] = {.lex_state = 0},
  [2232] = {.lex_state = 0},
  [2233] = {.lex_state = 44},
  [2234] = {.lex_state = 0},
  [2235] = {.lex_state = 0},
  [2236] = {.lex_state = 0},
  [2237] = {.lex_state = 0},
  [2238] = {.lex_state = 0},
  [2239] = {.lex_state = 0},
  [2240] = {.lex_state = 0},
  [2241] = {.lex_state = 0},
  [2242] = {.lex_state = 0},
  [2243] = {.lex_state = 0},
  [2244] = {.lex_state = 0},
  [2245] = {.lex_state = 0},
  [2246] = {.lex_state = 0},
  [2247] = {.lex_state = 0},
  [2248] = {.lex_state = 0},
  [2249] = {.lex_state = 0},
  [2250] = {.lex_state = 0},
  [2251] = {.lex_state = 0},
  [2252] = {.lex_state = 0},
  [2253] = {.lex_state = 0},
  [2254] = {.lex_state = 0},
  [2255] = {.lex_state = 0},
  [2256] = {.lex_state = 0},
  [2257] = {.lex_state = 0},
  [2258] = {.lex_state = 0},
  [2259] = {.lex_state = 44},
  [2260] = {.lex_state = 44},
  [2261] = {.lex_state = 44},
  [2262] = {.lex_state = 44},
  [2263] = {.lex_state = 0},
  [2264] = {.lex_state = 0},
  [2265] = {.lex_state = 0},
  [2266] = {.lex_state = 44},
  [2267] = {.lex_state = 44},
  [2268] = {.lex_state = 44},
  [2269] = {.lex_state = 44},
  [2270] = {.lex_state = 3},
  [2271] = {.lex_state = 0},
  [2272] = {.lex_state = 0},
  [2273] = {.lex_state = 0},
  [2274] = {.lex_state = 0},
  [2275] = {.lex_state = 0},
  [2276] = {.lex_state = 44},
  [2277] = {.lex_state = 0},
  [2278] = {.lex_state = 0},
  [2279] = {.lex_state = 0},
  [2280] = {.lex_state = 44},
  [2281] = {.lex_state = 0},
  [2282] = {.lex_state = 0},
  [2283] = {.lex_state = 0},
  [2284] = {.lex_state = 44},
  [2285] = {.lex_state = 0},
  [2286] = {.lex_state = 44},
  [2287] = {.lex_state = 0},
  [2288] = {.lex_state = 0},
  [2289] = {.lex_state = 0},
  [2290] = {.lex_state = 0},
  [2291] = {.lex_state = 0},
  [2292] = {.lex_state = 0},
  [2293] = {.lex_state = 0},
  [2294] = {.lex_state = 0},
  [2295] = {.lex_state = 44},
  [2296] = {.lex_state = 44},
  [2297] = {.lex_state = 44},
  [2298] = {.lex_state = 0},
  [2299] = {.lex_state = 44},
  [2300] = {.lex_state = 0},
  [2301] = {.lex_state = 44},
  [2302] = {.lex_state = 0},
  [2303] = {.lex_state = 0},
  [2304] = {.lex_state = 0},
  [2305] = {.lex_state = 0},
  [2306] = {.lex_state = 0},
  [2307] = {.lex_state = 0},
  [2308] = {.lex_state = 0},
  [2309] = {.lex_state = 0},
  [2310] = {.lex_state = 0},
  [2311] = {.lex_state = 0},
  [2312] = {.lex_state = 0},
  [2313] = {.lex_state = 0},
  [2314] = {.lex_state = 44},
  [2315] = {.lex_state = 0},
  [2316] = {.lex_state = 0},
  [2317] = {.lex_state = 44},
  [2318] = {.lex_state = 44},
  [2319] = {.lex_state = 44},
  [2320] = {.lex_state = 44},
  [2321] = {.lex_state = 44},
  [2322] = {.lex_state = 44},
  [2323] = {.lex_state = 44},
  [2324] = {.lex_state = 44},
  [2325] = {.lex_state = 44},
  [2326] = {.lex_state = 0},
  [2327] = {.lex_state = 44},
  [2328] = {.lex_state = 44},
  [2329] = {.lex_state = 44},
  [2330] = {.lex_state = 44},
  [2331] = {.lex_state = 0},
  [2332] = {.lex_state = 0},
  [2333] = {.lex_state = 0},
  [2334] = {.lex_state = 0},
  [2335] = {.lex_state = 44},
  [2336] = {.lex_state = 44},
  [2337] = {.lex_state = 44},
  [2338] = {.lex_state = 44},
  [2339] = {.lex_state = 44},
  [2340] = {.lex_state = 44},
  [2341] = {.lex_state = 0},
  [2342] = {.lex_state = 0},
  [2343] = {.lex_state = 44},
  [2344] = {.lex_state = 0},
  [2345] = {.lex_state = 0},
  [2346] = {.lex_state = 0},
  [2347] = {.lex_state = 0},
  [2348] = {.lex_state = 0},
  [2349] = {.lex_state = 0},
  [2350] = {.lex_state = 0},
  [2351] = {.lex_state = 0},
  [2352] = {.lex_state = 0},
  [2353] = {.lex_state = 0},
  [2354] = {.lex_state = 0},
  [2355] = {.lex_state = 0},
  [2356] = {.lex_state = 0},
  [2357] = {.lex_state = 0},
  [2358] = {.lex_state = 0},
  [2359] = {.lex_state = 0},
  [2360] = {.lex_state = 0},
  [2361] = {.lex_state = 0},
  [2362] = {.lex_state = 0},
  [2363] = {.lex_state = 0},
  [2364] = {.lex_state = 0},
  [2365] = {.lex_state = 0},
  [2366] = {.lex_state = 0},
  [2367] = {.lex_state = 0},
  [2368] = {.lex_state = 0},
  [2369] = {.lex_state = 0},
  [2370] = {.lex_state = 0},
  [2371] = {.lex_state = 0},
  [2372] = {.lex_state = 0},
  [2373] = {.lex_state = 0},
  [2374] = {.lex_state = 0},
  [2375] = {.lex_state = 0},
  [2376] = {.lex_state = 0},
  [2377] = {.lex_state = 0},
  [2378] = {.lex_state = 0},
  [2379] = {.lex_state = 0},
  [2380] = {.lex_state = 0},
  [2381] = {.lex_state = 0},
  [2382] = {.lex_state = 0},
  [2383] = {.lex_state = 0},
  [2384] = {.lex_state = 0},
  [2385] = {.lex_state = 0},
  [2386] = {.lex_state = 0},
  [2387] = {.lex_state = 0},
  [2388] = {.lex_state = 0},
  [2389] = {.lex_state = 0},
  [2390] = {.lex_state = 0},
  [2391] = {.lex_state = 0},
  [2392] = {.lex_state = 0},
  [2393] = {.lex_state = 0},
  [2394] = {.lex_state = 0},
  [2395] = {.lex_state = 0},
  [2396] = {.lex_state = 0},
  [2397] = {.lex_state = 0},
  [2398] = {.lex_state = 0},
  [2399] = {.lex_state = 0},
  [2400] = {.lex_state = 0},
  [2401] = {.lex_state = 0},
  [2402] = {.lex_state = 0},
  [2403] = {.lex_state = 0},
  [2404] = {.lex_state = 0},
  [2405] = {.lex_state = 0},
  [2406] = {.lex_state = 0},
  [2407] = {.lex_state = 0},
  [2408] = {.lex_state = 0},
  [2409] = {.lex_state = 0},
  [2410] = {.lex_state = 0},
  [2411] = {.lex_state = 0},
  [2412] = {.lex_state = 0},
  [2413] = {.lex_state = 0},
  [2414] = {.lex_state = 0},
  [2415] = {.lex_state = 0},
  [2416] = {.lex_state = 0},
  [2417] = {.lex_state = 0},
  [2418] = {.lex_state = 0},
  [2419] = {.lex_state = 0},
  [2420] = {.lex_state = 0},
  [2421] = {.lex_state = 0},
  [2422] = {.lex_state = 0},
  [2423] = {.lex_state = 0},
  [2424] = {.lex_state = 0},
  [2425] = {.lex_state = 0},
  [2426] = {.lex_state = 0},
  [2427] = {.lex_state = 0},
  [2428] = {.lex_state = 0},
  [2429] = {.lex_state = 0},
  [2430] = {.lex_state = 0},
  [2431] = {.lex_state = 0},
  [2432] = {.lex_state = 0},
  [2433] = {.lex_state = 0},
  [2434] = {.lex_state = 0},
  [2435] = {.lex_state = 0},
  [2436] = {.lex_state = 0},
  [2437] = {.lex_state = 0},
  [2438] = {.lex_state = 0},
  [2439] = {.lex_state = 0},
  [2440] = {.lex_state = 0},
  [2441] = {.lex_state = 0},
  [2442] = {.lex_state = 0},
  [2443] = {.lex_state = 0},
  [2444] = {.lex_state = 0},
  [2445] = {.lex_state = 0},
  [2446] = {.lex_state = 0},
  [2447] = {.lex_state = 0},
  [2448] = {.lex_state = 0},
  [2449] = {.lex_state = 0},
  [2450] = {.lex_state = 0},
  [2451] = {.lex_state = 0},
  [2452] = {.lex_state = 0},
  [2453] = {.lex_state = 0},
  [2454] = {.lex_state = 0},
  [2455] = {.lex_state = 0},
  [2456] = {.lex_state = 0},
  [2457] = {.lex_state = 0},
  [2458] = {.lex_state = 44},
  [2459] = {.lex_state = 0},
  [2460] = {.lex_state = 0},
  [2461] = {.lex_state = 0},
  [2462] = {.lex_state = 0},
  [2463] = {.lex_state = 0},
  [2464] = {.lex_state = 0},
  [2465] = {.lex_state = 0},
  [2466] = {.lex_state = 0},
  [2467] = {.lex_state = 0},
  [2468] = {.lex_state = 0},
  [2469] = {.lex_state = 0},
  [2470] = {.lex_state = 0},
  [2471] = {.lex_state = 0},
  [2472] = {.lex_state = 0},
  [2473] = {.lex_state = 0},
  [2474] = {.lex_state = 0},
  [2475] = {.lex_state = 0},
  [2476] = {.lex_state = 0},
  [2477] = {.lex_state = 0},
  [2478] = {.lex_state = 0},
  [2479] = {.lex_state = 0},
  [2480] = {.lex_state = 0},
  [2481] = {.lex_state = 0},
  [2482] = {.lex_state = 0},
  [2483] = {.lex_state = 0},
  [2484] = {.lex_state = 0},
  [2485] = {.lex_state = 0},
  [2486] = {.lex_state = 0},
  [2487] = {.lex_state = 0},
  [2488] = {.lex_state = 0},
  [2489] = {.lex_state = 0},
  [2490] = {.lex_state = 0},
  [2491] = {.lex_state = 0},
  [2492] = {.lex_state = 0},
  [2493] = {.lex_state = 0},
  [2494] = {.lex_state = 0},
  [2495] = {.lex_state = 0},
  [2496] = {.lex_state = 0},
  [2497] = {.lex_state = 0},
  [2498] = {.lex_state = 0},
  [2499] = {.lex_state = 0},
  [2500] = {.lex_state = 0},
  [2501] = {.lex_state = 0},
  [2502] = {.lex_state = 0},
  [2503] = {.lex_state = 0},
  [2504] = {.lex_state = 0},
  [2505] = {.lex_state = 0},
  [2506] = {.lex_state = 0},
  [2507] = {.lex_state = 0},
  [2508] = {.lex_state = 0},
  [2509] = {.lex_state = 0},
  [2510] = {.lex_state = 0},
  [2511] = {.lex_state = 0},
  [2512] = {.lex_state = 0},
  [2513] = {.lex_state = 0},
  [2514] = {.lex_state = 0},
  [2515] = {.lex_state = 0},
  [2516] = {.lex_state = 0},
  [2517] = {.lex_state = 0},
  [2518] = {.lex_state = 0},
  [2519] = {.lex_state = 0},
  [2520] = {.lex_state = 0},
  [2521] = {.lex_state = 0},
  [2522] = {.lex_state = 0},
  [2523] = {.lex_state = 0},
  [2524] = {.lex_state = 0},
  [2525] = {.lex_state = 3},
  [2526] = {.lex_state = 0},
  [2527] = {.lex_state = 0},
  [2528] = {.lex_state = 0},
  [2529] = {.lex_state = 0},
  [2530] = {.lex_state = 0},
  [2531] = {.lex_state = 0},
  [2532] = {.lex_state = 0},
  [2533] = {.lex_state = 0},
  [2534] = {.lex_state = 0},
  [2535] = {.lex_state = 0},
  [2536] = {.lex_state = 0},
  [2537] = {.lex_state = 0},
  [2538] = {.lex_state = 0},
  [2539] = {.lex_state = 0},
  [2540] = {.lex_state = 0},
  [2541] = {.lex_state = 0},
  [2542] = {.lex_state = 0},
  [2543] = {.lex_state = 0},
  [2544] = {.lex_state = 0},
  [2545] = {.lex_state = 0},
  [2546] = {.lex_state = 0},
  [2547] = {.lex_state = 0},
  [2548] = {.lex_state = 0},
  [2549] = {.lex_state = 0},
  [2550] = {.lex_state = 0},
  [2551] = {.lex_state = 0},
  [2552] = {.lex_state = 0},
  [2553] = {.lex_state = 0},
  [2554] = {.lex_state = 0},
  [2555] = {.lex_state = 0},
  [2556] = {.lex_state = 0},
  [2557] = {.lex_state = 0},
  [2558] = {.lex_state = 0},
  [2559] = {.lex_state = 0},
  [2560] = {.lex_state = 0},
  [2561] = {.lex_state = 0},
  [2562] = {.lex_state = 0},
  [2563] = {.lex_state = 0},
  [2564] = {.lex_state = 0},
  [2565] = {.lex_state = 0},
  [2566] = {.lex_state = 0},
  [2567] = {.lex_state = 0},
  [2568] = {.lex_state = 0},
  [2569] = {.lex_state = 0},
  [2570] = {.lex_state = 0},
  [2571] = {.lex_state = 0},
  [2572] = {.lex_state = 0},
  [2573] = {.lex_state = 0},
  [2574] = {.lex_state = 0},
  [2575] = {.lex_state = 0},
  [2576] = {.lex_state = 0},
  [2577] = {.lex_state = 0},
  [2578] = {.lex_state = 0},
  [2579] = {.lex_state = 0},
  [2580] = {.lex_state = 0},
  [2581] = {.lex_state = 0},
  [2582] = {.lex_state = 0},
  [2583] = {.lex_state = 0},
  [2584] = {.lex_state = 0},
  [2585] = {.lex_state = 0},
  [2586] = {.lex_state = 0},
  [2587] = {.lex_state = 0},
  [2588] = {.lex_state = 0},
  [2589] = {.lex_state = 0},
  [2590] = {.lex_state = 0},
  [2591] = {.lex_state = 0},
  [2592] = {.lex_state = 0},
  [2593] = {.lex_state = 0},
  [2594] = {.lex_state = 0},
  [2595] = {.lex_state = 0},
  [2596] = {.lex_state = 0},
  [2597] = {.lex_state = 0},
  [2598] = {.lex_state = 0},
  [2599] = {.lex_state = 0},
  [2600] = {.lex_state = 0},
  [2601] = {.lex_state = 0},
  [2602] = {.lex_state = 0},
  [2603] = {.lex_state = 0},
  [2604] = {.lex_state = 0},
  [2605] = {.lex_state = 0},
  [2606] = {.lex_state = 0},
  [2607] = {.lex_state = 0},
  [2608] = {.lex_state = 0},
  [2609] = {.lex_state = 0},
  [2610] = {.lex_state = 0},
  [2611] = {.lex_state = 0},
  [2612] = {.lex_state = 0},
  [2613] = {.lex_state = 0},
  [2614] = {.lex_state = 0},
  [2615] = {.lex_state = 0},
  [2616] = {.lex_state = 0},
  [2617] = {.lex_state = 0},
  [2618] = {.lex_state = 0},
  [2619] = {.lex_state = 0},
  [2620] = {.lex_state = 0},
  [2621] = {.lex_state = 0},
  [2622] = {.lex_state = 0},
  [2623] = {.lex_state = 0},
  [2624] = {.lex_state = 0},
  [2625] = {.lex_state = 0},
  [2626] = {.lex_state = 0},
  [2627] = {.lex_state = 0},
  [2628] = {.lex_state = 0},
  [2629] = {.lex_state = 44},
  [2630] = {.lex_state = 3},
  [2631] = {.lex_state = 44},
  [2632] = {.lex_state = 3},
  [2633] = {.lex_state = 3},
  [2634] = {.lex_state = 3},
  [2635] = {.lex_state = 44},
  [2636] = {.lex_state = 3},
  [2637] = {.lex_state = 44},
  [2638] = {.lex_state = 44},
  [2639] = {.lex_state = 44},
  [2640] = {.lex_state = 44},
  [2641] = {.lex_state = 3},
  [2642] = {.lex_state = 44},
  [2643] = {.lex_state = 44},
  [2644] = {.lex_state = 44},
  [2645] = {.lex_state = 3},
  [2646] = {.lex_state = 0},
  [2647] = {.lex_state = 0},
  [2648] = {.lex_state = 3},
  [2649] = {.lex_state = 0},
  [2650] = {.lex_state = 0},
  [2651] = {.lex_state = 0},
  [2652] = {.lex_state = 0},
  [2653] = {.lex_state = 0},
  [2654] = {.lex_state = 0},
  [2655] = {.lex_state = 44},
  [2656] = {.lex_state = 0},
  [2657] = {.lex_state = 0},
  [2658] = {.lex_state = 0},
  [2659] = {.lex_state = 0},
  [2660] = {.lex_state = 0},
  [2661] = {.lex_state = 0},
  [2662] = {.lex_state = 0},
  [2663] = {.lex_state = 0},
  [2664] = {.lex_state = 0},
  [2665] = {.lex_state = 0},
  [2666] = {.lex_state = 44},
  [2667] = {.lex_state = 3},
  [2668] = {.lex_state = 44},
  [2669] = {.lex_state = 0},
  [2670] = {.lex_state = 44},
  [2671] = {.lex_state = 0},
  [2672] = {.lex_state = 3},
  [2673] = {.lex_state = 44},
  [2674] = {.lex_state = 44},
  [2675] = {.lex_state = 44},
  [2676] = {.lex_state = 44},
  [2677] = {.lex_state = 44},
  [2678] = {.lex_state = 44},
  [2679] = {.lex_state = 44},
  [2680] = {.lex_state = 44},
  [2681] = {.lex_state = 44},
  [2682] = {.lex_state = 44},
  [2683] = {.lex_state = 44},
  [2684] = {.lex_state = 44},
  [2685] = {.lex_state = 44},
  [2686] = {.lex_state = 44},
  [2687] = {.lex_state = 0},
  [2688] = {.lex_state = 44},
  [2689] = {.lex_state = 44},
  [2690] = {.lex_state = 44},
  [2691] = {.lex_state = 0},
  [2692] = {.lex_state = 0},
  [2693] = {.lex_state = 0},
  [2694] = {.lex_state = 0},
  [2695] = {.lex_state = 44},
  [2696] = {.lex_state = 44},
  [2697] = {.lex_state = 44},
  [2698] = {.lex_state = 0},
  [2699] = {.lex_state = 0},
  [2700] = {.lex_state = 44},
  [2701] = {.lex_state = 0},
  [2702] = {.lex_state = 44},
  [2703] = {.lex_state = 44},
  [2704] = {.lex_state = 0},
  [2705] = {.lex_state = 44},
  [2706] = {.lex_state = 0},
  [2707] = {.lex_state = 0},
  [2708] = {.lex_state = 3},
  [2709] = {.lex_state = 44},
  [2710] = {.lex_state = 0},
  [2711] = {.lex_state = 44},
  [2712] = {.lex_state = 0},
  [2713] = {.lex_state = 44},
  [2714] = {.lex_state = 44},
  [2715] = {.lex_state = 0},
  [2716] = {.lex_state = 44},
  [2717] = {.lex_state = 0},
  [2718] = {.lex_state = 44},
  [2719] = {.lex_state = 0},
  [2720] = {.lex_state = 44},
  [2721] = {.lex_state = 44},
  [2722] = {.lex_state = 44},
  [2723] = {.lex_state = 44},
  [2724] = {.lex_state = 44},
  [2725] = {.lex_state = 44},
  [2726] = {.lex_state = 0},
  [2727] = {.lex_state = 44},
  [2728] = {.lex_state = 0},
  [2729] = {.lex_state = 0},
  [2730] = {.lex_state = 0},
  [2731] = {.lex_state = 44},
  [2732] = {.lex_state = 44},
  [2733] = {.lex_state = 44},
  [2734] = {.lex_state = 44},
  [2735] = {.lex_state = 44},
  [2736] = {.lex_state = 44},
  [2737] = {.lex_state = 44},
  [2738] = {.lex_state = 44},
  [2739] = {.lex_state = 44},
  [2740] = {.lex_state = 44},
  [2741] = {.lex_state = 44},
  [2742] = {.lex_state = 44},
  [2743] = {.lex_state = 44},
  [2744] = {.lex_state = 44},
  [2745] = {.lex_state = 44},
  [2746] = {.lex_state = 44},
  [2747] = {.lex_state = 44},
  [2748] = {.lex_state = 44},
  [2749] = {.lex_state = 44},
  [2750] = {.lex_state = 44},
  [2751] = {.lex_state = 44},
  [2752] = {.lex_state = 44},
  [2753] = {.lex_state = 44},
  [2754] = {.lex_state = 44},
  [2755] = {.lex_state = 44},
  [2756] = {.lex_state = 44},
  [2757] = {.lex_state = 44},
  [2758] = {.lex_state = 44},
  [2759] = {.lex_state = 44},
  [2760] = {.lex_state = 44},
  [2761] = {.lex_state = 44},
  [2762] = {.lex_state = 3},
  [2763] = {.lex_state = 44},
  [2764] = {.lex_state = 44},
  [2765] = {.lex_state = 44},
  [2766] = {.lex_state = 44},
  [2767] = {.lex_state = 44},
  [2768] = {.lex_state = 44},
  [2769] = {.lex_state = 44},
  [2770] = {.lex_state = 44},
  [2771] = {.lex_state = 44},
  [2772] = {.lex_state = 44},
  [2773] = {.lex_state = 44},
  [2774] = {.lex_state = 44},
  [2775] = {.lex_state = 44},
  [2776] = {.lex_state = 44},
  [2777] = {.lex_state = 44},
  [2778] = {.lex_state = 44},
  [2779] = {.lex_state = 44},
  [2780] = {.lex_state = 44},
  [2781] = {.lex_state = 44},
  [2782] = {.lex_state = 44},
  [2783] = {.lex_state = 0},
  [2784] = {.lex_state = 44},
  [2785] = {.lex_state = 0},
  [2786] = {.lex_state = 44},
  [2787] = {.lex_state = 44},
  [2788] = {.lex_state = 0},
  [2789] = {.lex_state = 44},
  [2790] = {.lex_state = 0},
  [2791] = {.lex_state = 0},
  [2792] = {.lex_state = 0},
  [2793] = {.lex_state = 0},
  [2794] = {.lex_state = 44},
  [2795] = {.lex_state = 44},
  [2796] = {.lex_state = 44},
  [2797] = {.lex_state = 0},
  [2798] = {.lex_state = 44},
  [2799] = {.lex_state = 44},
  [2800] = {.lex_state = 44},
  [2801] = {.lex_state = 44},
  [2802] = {.lex_state = 44},
  [2803] = {.lex_state = 44},
  [2804] = {.lex_state = 0},
  [2805] = {.lex_state = 44},
  [2806] = {.lex_state = 44},
  [2807] = {.lex_state = 44},
  [2808] = {.lex_state = 44},
  [2809] = {.lex_state = 44},
  [2810] = {.lex_state = 44},
  [2811] = {.lex_state = 44},
  [2812] = {.lex_state = 0},
  [2813] = {.lex_state = 44},
  [2814] = {.lex_state = 44},
  [2815] = {.lex_state = 0},
  [2816] = {.lex_state = 44},
  [2817] = {.lex_state = 0},
  [2818] = {.lex_state = 44},
  [2819] = {.lex_state = 44},
  [2820] = {.lex_state = 44},
  [2821] = {.lex_state = 44},
  [2822] = {.lex_state = 44},
  [2823] = {.lex_state = 44},
  [2824] = {.lex_state = 44},
  [2825] = {.lex_state = 44},
  [2826] = {.lex_state = 44},
  [2827] = {.lex_state = 44},
  [2828] = {.lex_state = 0},
  [2829] = {.lex_state = 44},
  [2830] = {.lex_state = 44},
  [2831] = {.lex_state = 44},
  [2832] = {.lex_state = 44},
  [2833] = {.lex_state = 44},
  [2834] = {.lex_state = 44},
  [2835] = {.lex_state = 44},
  [2836] = {.lex_state = 44},
  [2837] = {.lex_state = 44},
  [2838] = {.lex_state = 44},
  [2839] = {.lex_state = 44},
  [2840] = {.lex_state = 0},
  [2841] = {.lex_state = 0},
  [2842] = {.lex_state = 44},
  [2843] = {.lex_state = 44},
  [2844] = {.lex_state = 0},
  [2845] = {.lex_state = 0},
  [2846] = {.lex_state = 44},
  [2847] = {.lex_state = 0},
  [2848] = {.lex_state = 44},
  [2849] = {.lex_state = 0},
  [2850] = {.lex_state = 44},
  [2851] = {.lex_state = 0},
  [2852] = {.lex_state = 44},
  [2853] = {.lex_state = 0},
  [2854] = {.lex_state = 0},
  [2855] = {.lex_state = 0},
  [2856] = {.lex_state = 44},
  [2857] = {.lex_state = 44},
  [2858] = {.lex_state = 0},
  [2859] = {.lex_state = 44},
  [2860] = {.lex_state = 44},
  [2861] = {.lex_state = 44},
  [2862] = {.lex_state = 44},
  [2863] = {.lex_state = 44},
  [2864] = {.lex_state = 44},
  [2865] = {.lex_state = 44},
  [2866] = {.lex_state = 0},
  [2867] = {.lex_state = 0},
  [2868] = {.lex_state = 0},
  [2869] = {.lex_state = 0},
  [2870] = {.lex_state = 44},
  [2871] = {.lex_state = 0},
  [2872] = {.lex_state = 44},
  [2873] = {.lex_state = 44},
  [2874] = {.lex_state = 0},
  [2875] = {.lex_state = 44},
  [2876] = {.lex_state = 0},
  [2877] = {.lex_state = 0},
  [2878] = {.lex_state = 44},
  [2879] = {.lex_state = 44},
  [2880] = {.lex_state = 44},
  [2881] = {.lex_state = 44},
  [2882] = {.lex_state = 0},
  [2883] = {.lex_state = 0},
  [2884] = {.lex_state = 44},
  [2885] = {.lex_state = 44},
  [2886] = {.lex_state = 0},
  [2887] = {.lex_state = 44},
  [2888] = {.lex_state = 0},
  [2889] = {.lex_state = 0},
  [2890] = {.lex_state = 0},
  [2891] = {.lex_state = 0},
  [2892] = {.lex_state = 44},
  [2893] = {.lex_state = 44},
  [2894] = {.lex_state = 44},
  [2895] = {.lex_state = 44},
  [2896] = {.lex_state = 44},
  [2897] = {.lex_state = 44},
  [2898] = {.lex_state = 0},
  [2899] = {.lex_state = 44},
  [2900] = {.lex_state = 0},
  [2901] = {.lex_state = 44},
  [2902] = {.lex_state = 0},
  [2903] = {.lex_state = 44},
  [2904] = {.lex_state = 0},
  [2905] = {.lex_state = 44},
  [2906] = {.lex_state = 0},
  [2907] = {.lex_state = 44},
  [2908] = {.lex_state = 0},
  [2909] = {.lex_state = 0},
  [2910] = {.lex_state = 0},
  [2911] = {.lex_state = 44},
  [2912] = {.lex_state = 44},
  [2913] = {.lex_state = 44},
  [2914] = {.lex_state = 44},
  [2915] = {.lex_state = 44},
  [2916] = {.lex_state = 44},
  [2917] = {.lex_state = 44},
  [2918] = {.lex_state = 44},
  [2919] = {.lex_state = 0},
  [2920] = {.lex_state = 0},
  [2921] = {.lex_state = 44},
  [2922] = {.lex_state = 44},
  [2923] = {.lex_state = 44},
  [2924] = {.lex_state = 44},
  [2925] = {.lex_state = 44},
  [2926] = {.lex_state = 44},
  [2927] = {.lex_state = 44},
  [2928] = {.lex_state = 44},
  [2929] = {.lex_state = 44},
  [2930] = {.lex_state = 44},
  [2931] = {.lex_state = 44},
  [2932] = {.lex_state = 44},
  [2933] = {.lex_state = 44},
  [2934] = {.lex_state = 44},
  [2935] = {.lex_state = 44},
  [2936] = {.lex_state = 44},
  [2937] = {.lex_state = 44},
  [2938] = {.lex_state = 0},
  [2939] = {.lex_state = 44},
  [2940] = {.lex_state = 44},
  [2941] = {.lex_state = 44},
  [2942] = {.lex_state = 44},
  [2943] = {.lex_state = 44},
  [2944] = {.lex_state = 44},
  [2945] = {.lex_state = 44},
  [2946] = {.lex_state = 44},
  [2947] = {.lex_state = 44},
  [2948] = {.lex_state = 44},
  [2949] = {.lex_state = 44},
  [2950] = {.lex_state = 44},
  [2951] = {.lex_state = 44},
  [2952] = {.lex_state = 44},
  [2953] = {.lex_state = 0},
  [2954] = {.lex_state = 44},
  [2955] = {.lex_state = 0},
  [2956] = {.lex_state = 44},
  [2957] = {.lex_state = 44},
  [2958] = {.lex_state = 44},
  [2959] = {.lex_state = 0},
  [2960] = {.lex_state = 44},
  [2961] = {.lex_state = 0},
  [2962] = {.lex_state = 44},
  [2963] = {.lex_state = 44},
  [2964] = {.lex_state = 44},
  [2965] = {.lex_state = 0},
  [2966] = {.lex_state = 44},
  [2967] = {.lex_state = 0},
  [2968] = {.lex_state = 44},
  [2969] = {.lex_state = 44},
  [2970] = {.lex_state = 44},
  [2971] = {.lex_state = 44},
  [2972] = {.lex_state = 44},
  [2973] = {.lex_state = 44},
  [2974] = {.lex_state = 44},
  [2975] = {.lex_state = 44},
  [2976] = {.lex_state = 0},
  [2977] = {.lex_state = 44},
  [2978] = {.lex_state = 44},
  [2979] = {.lex_state = 44},
  [2980] = {.lex_state = 44},
  [2981] = {.lex_state = 44},
  [2982] = {.lex_state = 0},
  [2983] = {.lex_state = 0},
  [2984] = {.lex_state = 44},
  [2985] = {.lex_state = 44},
  [2986] = {.lex_state = 44},
  [2987] = {.lex_state = 0},
  [2988] = {.lex_state = 0},
  [2989] = {.lex_state = 0},
  [2990] = {.lex_state = 0},
  [2991] = {.lex_state = 0},
  [2992] = {.lex_state = 0},
  [2993] = {.lex_state = 0},
  [2994] = {.lex_state = 0},
  [2995] = {.lex_state = 0},
  [2996] = {.lex_state = 0},
  [2997] = {.lex_state = 0},
  [2998] = {.lex_state = 0},
  [2999] = {.lex_state = 0},
  [3000] = {.lex_state = 0},
  [3001] = {.lex_state = 0},
  [3002] = {.lex_state = 0},
  [3003] = {.lex_state = 0},
  [3004] = {.lex_state = 0},
  [3005] = {.lex_state = 0},
  [3006] = {.lex_state = 0},
  [3007] = {.lex_state = 0},
  [3008] = {.lex_state = 0},
  [3009] = {.lex_state = 0},
  [3010] = {.lex_state = 0},
  [3011] = {.lex_state = 0},
  [3012] = {.lex_state = 0},
  [3013] = {.lex_state = 0},
  [3014] = {.lex_state = 0},
  [3015] = {.lex_state = 0},
  [3016] = {.lex_state = 0},
  [3017] = {.lex_state = 0},
  [3018] = {.lex_state = 0},
  [3019] = {.lex_state = 0},
  [3020] = {.lex_state = 0},
  [3021] = {.lex_state = 0},
  [3022] = {.lex_state = 0},
  [3023] = {.lex_state = 0},
  [3024] = {.lex_state = 0},
  [3025] = {.lex_state = 0},
  [3026] = {.lex_state = 0},
  [3027] = {.lex_state = 0},
  [3028] = {.lex_state = 0},
  [3029] = {.lex_state = 0},
  [3030] = {.lex_state = 0},
  [3031] = {.lex_state = 0},
  [3032] = {.lex_state = 0},
  [3033] = {.lex_state = 0},
  [3034] = {.lex_state = 0},
  [3035] = {.lex_state = 0},
  [3036] = {.lex_state = 0},
  [3037] = {.lex_state = 0},
  [3038] = {.lex_state = 0},
  [3039] = {.lex_state = 0},
  [3040] = {.lex_state = 0},
  [3041] = {.lex_state = 0},
  [3042] = {.lex_state = 0},
  [3043] = {.lex_state = 0},
  [3044] = {.lex_state = 0},
  [3045] = {.lex_state = 0},
  [3046] = {.lex_state = 0},
  [3047] = {.lex_state = 0},
  [3048] = {.lex_state = 0},
  [3049] = {.lex_state = 0},
  [3050] = {.lex_state = 0},
  [3051] = {.lex_state = 0},
  [3052] = {.lex_state = 0},
  [3053] = {.lex_state = 0},
  [3054] = {.lex_state = 0},
  [3055] = {.lex_state = 0},
  [3056] = {.lex_state = 0},
  [3057] = {.lex_state = 0},
  [3058] = {.lex_state = 0},
  [3059] = {.lex_state = 0},
  [3060] = {.lex_state = 0},
  [3061] = {.lex_state = 0},
  [3062] = {.lex_state = 0},
  [3063] = {.lex_state = 0},
  [3064] = {.lex_state = 0},
  [3065] = {.lex_state = 0},
  [3066] = {.lex_state = 0},
  [3067] = {.lex_state = 0},
  [3068] = {.lex_state = 0},
  [3069] = {.lex_state = 0},
  [3070] = {.lex_state = 0},
  [3071] = {.lex_state = 0},
  [3072] = {.lex_state = 0},
  [3073] = {.lex_state = 0},
  [3074] = {.lex_state = 0},
  [3075] = {.lex_state = 0},
  [3076] = {.lex_state = 0},
  [3077] = {.lex_state = 0},
  [3078] = {.lex_state = 3},
  [3079] = {.lex_state = 0},
  [3080] = {.lex_state = 0},
  [3081] = {.lex_state = 0},
  [3082] = {.lex_state = 0},
  [3083] = {.lex_state = 0},
  [3084] = {.lex_state = 0},
  [3085] = {.lex_state = 0},
  [3086] = {.lex_state = 0},
  [3087] = {.lex_state = 0},
  [3088] = {.lex_state = 0},
  [3089] = {.lex_state = 0},
  [3090] = {.lex_state = 0},
  [3091] = {.lex_state = 0},
  [3092] = {.lex_state = 0},
  [3093] = {.lex_state = 0},
  [3094] = {.lex_state = 0},
  [3095] = {.lex_state = 0},
  [3096] = {.lex_state = 0},
  [3097] = {.lex_state = 0},
  [3098] = {.lex_state = 0},
  [3099] = {.lex_state = 0},
  [3100] = {.lex_state = 0},
  [3101] = {.lex_state = 0},
  [3102] = {.lex_state = 0},
  [3103] = {.lex_state = 0},
  [3104] = {.lex_state = 0},
  [3105] = {.lex_state = 0},
  [3106] = {.lex_state = 0},
  [3107] = {.lex_state = 0},
  [3108] = {.lex_state = 0},
  [3109] = {.lex_state = 0},
  [3110] = {.lex_state = 0},
  [3111] = {.lex_state = 0},
  [3112] = {.lex_state = 0},
  [3113] = {.lex_state = 0},
  [3114] = {.lex_state = 0},
  [3115] = {.lex_state = 0},
  [3116] = {.lex_state = 0},
  [3117] = {.lex_state = 0},
  [3118] = {.lex_state = 0},
  [3119] = {.lex_state = 0},
  [3120] = {.lex_state = 3},
  [3121] = {.lex_state = 0},
  [3122] = {.lex_state = 45},
  [3123] = {.lex_state = 0},
  [3124] = {.lex_state = 0},
  [3125] = {.lex_state = 0},
  [3126] = {.lex_state = 3},
  [3127] = {.lex_state = 0},
  [3128] = {.lex_state = 0},
  [3129] = {.lex_state = 0},
  [3130] = {.lex_state = 0},
  [3131] = {.lex_state = 0},
  [3132] = {.lex_state = 0},
  [3133] = {.lex_state = 0},
  [3134] = {.lex_state = 0},
  [3135] = {.lex_state = 0},
  [3136] = {.lex_state = 0},
  [3137] = {.lex_state = 0},
  [3138] = {.lex_state = 0},
  [3139] = {.lex_state = 0},
  [3140] = {.lex_state = 0},
  [3141] = {.lex_state = 0},
  [3142] = {.lex_state = 0},
  [3143] = {.lex_state = 0},
  [3144] = {.lex_state = 0},
  [3145] = {.lex_state = 0},
  [3146] = {.lex_state = 0},
  [3147] = {.lex_state = 0},
  [3148] = {.lex_state = 0},
  [3149] = {.lex_state = 0},
  [3150] = {.lex_state = 0},
  [3151] = {.lex_state = 0},
  [3152] = {.lex_state = 0},
  [3153] = {.lex_state = 0},
  [3154] = {.lex_state = 0},
  [3155] = {.lex_state = 0},
  [3156] = {.lex_state = 0},
  [3157] = {.lex_state = 0},
  [3158] = {.lex_state = 0},
  [3159] = {.lex_state = 0},
  [3160] = {.lex_state = 0},
  [3161] = {.lex_state = 0},
  [3162] = {.lex_state = 0},
  [3163] = {.lex_state = 0},
  [3164] = {.lex_state = 0},
  [3165] = {.lex_state = 0},
  [3166] = {.lex_state = 0},
  [3167] = {.lex_state = 0},
  [3168] = {.lex_state = 0},
  [3169] = {.lex_state = 0},
  [3170] = {.lex_state = 0},
  [3171] = {.lex_state = 0},
  [3172] = {.lex_state = 0},
  [3173] = {.lex_state = 0},
  [3174] = {.lex_state = 0},
  [3175] = {.lex_state = 0},
  [3176] = {.lex_state = 0},
  [3177] = {.lex_state = 0},
  [3178] = {.lex_state = 0},
  [3179] = {.lex_state = 0},
  [3180] = {.lex_state = 0},
  [3181] = {.lex_state = 0},
  [3182] = {.lex_state = 0},
  [3183] = {.lex_state = 0},
  [3184] = {.lex_state = 0},
  [3185] = {.lex_state = 0},
  [3186] = {.lex_state = 0},
  [3187] = {.lex_state = 3},
  [3188] = {.lex_state = 0},
  [3189] = {.lex_state = 0},
  [3190] = {.lex_state = 0},
  [3191] = {.lex_state = 0},
  [3192] = {.lex_state = 0},
  [3193] = {.lex_state = 0},
  [3194] = {.lex_state = 0},
  [3195] = {.lex_state = 0},
  [3196] = {.lex_state = 0},
  [3197] = {.lex_state = 0},
  [3198] = {.lex_state = 0},
  [3199] = {.lex_state = 0},
  [3200] = {.lex_state = 0},
  [3201] = {.lex_state = 0},
  [3202] = {.lex_state = 44},
  [3203] = {.lex_state = 0},
  [3204] = {.lex_state = 5},
  [3205] = {.lex_state = 0},
  [3206] = {.lex_state = 0},
  [3207] = {.lex_state = 0},
  [3208] = {.lex_state = 0},
  [3209] = {.lex_state = 0},
  [3210] = {.lex_state = 0},
  [3211] = {.lex_state = 0},
  [3212] = {.lex_state = 0},
  [3213] = {.lex_state = 0},
  [3214] = {.lex_state = 0},
  [3215] = {.lex_state = 0},
  [3216] = {.lex_state = 0},
  [3217] = {.lex_state = 44},
  [3218] = {.lex_state = 0},
  [3219] = {.lex_state = 0},
  [3220] = {.lex_state = 0},
  [3221] = {.lex_state = 0},
  [3222] = {.lex_state = 0},
  [3223] = {.lex_state = 0},
  [3224] = {.lex_state = 0},
  [3225] = {.lex_state = 0},
  [3226] = {.lex_state = 0},
  [3227] = {.lex_state = 0},
  [3228] = {.lex_state = 0},
  [3229] = {.lex_state = 0},
  [3230] = {.lex_state = 0},
  [3231] = {.lex_state = 0},
  [3232] = {.lex_state = 0},
  [3233] = {.lex_state = 0},
  [3234] = {.lex_state = 0},
  [3235] = {.lex_state = 0},
  [3236] = {.lex_state = 0},
  [3237] = {.lex_state = 0},
  [3238] = {.lex_state = 0},
  [3239] = {.lex_state = 0},
  [3240] = {.lex_state = 0},
  [3241] = {.lex_state = 0},
  [3242] = {.lex_state = 44},
  [3243] = {.lex_state = 44},
  [3244] = {.lex_state = 0},
  [3245] = {.lex_state = 44},
  [3246] = {.lex_state = 0},
  [3247] = {.lex_state = 0},
  [3248] = {.lex_state = 0},
  [3249] = {.lex_state = 44},
  [3250] = {.lex_state = 0},
  [3251] = {.lex_state = 0},
  [3252] = {.lex_state = 0},
  [3253] = {.lex_state = 0},
  [3254] = {.lex_state = 44},
  [3255] = {.lex_state = 0},
  [3256] = {.lex_state = 0},
  [3257] = {.lex_state = 0},
  [3258] = {.lex_state = 0},
  [3259] = {.lex_state = 0},
  [3260] = {.lex_state = 0},
  [3261] = {.lex_state = 0},
  [3262] = {.lex_state = 0},
  [3263] = {.lex_state = 44},
  [3264] = {.lex_state = 44},
  [3265] = {.lex_state = 0},
  [3266] = {.lex_state = 0},
  [3267] = {.lex_state = 0},
  [3268] = {.lex_state = 0},
  [3269] = {.lex_state = 0},
  [3270] = {.lex_state = 44},
  [3271] = {.lex_state = 0},
  [3272] = {.lex_state = 0},
  [3273] = {.lex_state = 0},
  [3274] = {.lex_state = 0},
  [3275] = {.lex_state = 0},
  [3276] = {.lex_state = 0},
  [3277] = {.lex_state = 44},
  [3278] = {.lex_state = 44},
  [3279] = {.lex_state = 44},
  [3280] = {.lex_state = 44},
  [3281] = {.lex_state = 0},
  [3282] = {.lex_state = 44},
  [3283] = {.lex_state = 44},
  [3284] = {.lex_state = 0},
  [3285] = {.lex_state = 0},
  [3286] = {.lex_state = 0},
  [3287] = {.lex_state = 0},
  [3288] = {.lex_state = 0},
  [3289] = {.lex_state = 0},
  [3290] = {.lex_state = 44},
  [3291] = {.lex_state = 44},
  [3292] = {.lex_state = 0},
  [3293] = {.lex_state = 0},
  [3294] = {.lex_state = 0},
  [3295] = {.lex_state = 0},
  [3296] = {.lex_state = 0},
  [3297] = {.lex_state = 0},
  [3298] = {.lex_state = 0},
  [3299] = {.lex_state = 0},
  [3300] = {.lex_state = 0},
  [3301] = {.lex_state = 0},
  [3302] = {.lex_state = 0},
  [3303] = {.lex_state = 0},
  [3304] = {.lex_state = 0},
  [3305] = {.lex_state = 0},
  [3306] = {.lex_state = 0},
  [3307] = {.lex_state = 0},
  [3308] = {.lex_state = 0},
  [3309] = {.lex_state = 0},
  [3310] = {.lex_state = 0},
  [3311] = {.lex_state = 0},
  [3312] = {.lex_state = 0},
  [3313] = {.lex_state = 44},
  [3314] = {.lex_state = 44},
  [3315] = {.lex_state = 44},
  [3316] = {.lex_state = 0},
  [3317] = {.lex_state = 0},
  [3318] = {.lex_state = 0},
  [3319] = {.lex_state = 44},
  [3320] = {.lex_state = 44},
  [3321] = {.lex_state = 44},
  [3322] = {.lex_state = 44},
  [3323] = {.lex_state = 0},
  [3324] = {.lex_state = 0},
  [3325] = {.lex_state = 0},
  [3326] = {.lex_state = 44},
  [3327] = {.lex_state = 0},
  [3328] = {.lex_state = 44},
  [3329] = {.lex_state = 0},
  [3330] = {.lex_state = 0},
  [3331] = {.lex_state = 0},
  [3332] = {.lex_state = 0},
  [3333] = {.lex_state = 0},
  [3334] = {.lex_state = 0},
  [3335] = {.lex_state = 0},
  [3336] = {.lex_state = 0},
  [3337] = {.lex_state = 44},
  [3338] = {.lex_state = 0},
  [3339] = {.lex_state = 0},
  [3340] = {.lex_state = 0},
  [3341] = {.lex_state = 0},
  [3342] = {.lex_state = 0},
  [3343] = {.lex_state = 0},
  [3344] = {.lex_state = 0},
  [3345] = {.lex_state = 0},
  [3346] = {.lex_state = 0},
  [3347] = {.lex_state = 0},
  [3348] = {.lex_state = 0},
  [3349] = {.lex_state = 0},
  [3350] = {.lex_state = 0},
  [3351] = {.lex_state = 0},
  [3352] = {.lex_state = 0},
  [3353] = {.lex_state = 44},
  [3354] = {.lex_state = 44},
  [3355] = {.lex_state = 0},
  [3356] = {.lex_state = 44},
  [3357] = {.lex_state = 0},
  [3358] = {.lex_state = 44},
  [3359] = {.lex_state = 0},
  [3360] = {.lex_state = 44},
  [3361] = {.lex_state = 44},
  [3362] = {.lex_state = 44},
  [3363] = {.lex_state = 0},
  [3364] = {.lex_state = 44},
  [3365] = {.lex_state = 44},
  [3366] = {.lex_state = 0},
  [3367] = {.lex_state = 44},
  [3368] = {.lex_state = 0},
  [3369] = {.lex_state = 44},
  [3370] = {.lex_state = 0},
  [3371] = {.lex_state = 44},
  [3372] = {.lex_state = 44},
  [3373] = {.lex_state = 44},
  [3374] = {.lex_state = 44},
  [3375] = {.lex_state = 44},
  [3376] = {.lex_state = 0},
  [3377] = {.lex_state = 44},
  [3378] = {.lex_state = 0},
  [3379] = {.lex_state = 44},
  [3380] = {.lex_state = 0},
  [3381] = {.lex_state = 0},
  [3382] = {.lex_state = 44},
  [3383] = {.lex_state = 44},
  [3384] = {.lex_state = 44},
  [3385] = {.lex_state = 44},
  [3386] = {.lex_state = 0},
  [3387] = {.lex_state = 3},
  [3388] = {.lex_state = 0},
  [3389] = {.lex_state = 0},
  [3390] = {.lex_state = 44},
  [3391] = {.lex_state = 44},
  [3392] = {.lex_state = 0},
  [3393] = {.lex_state = 0},
  [3394] = {.lex_state = 44},
  [3395] = {.lex_state = 44},
  [3396] = {.lex_state = 44},
  [3397] = {.lex_state = 44},
  [3398] = {.lex_state = 44},
  [3399] = {.lex_state = 0},
  [3400] = {.lex_state = 0},
  [3401] = {.lex_state = 44},
  [3402] = {.lex_state = 0},
  [3403] = {.lex_state = 0},
  [3404] = {.lex_state = 44},
  [3405] = {.lex_state = 44},
  [3406] = {.lex_state = 44},
  [3407] = {.lex_state = 44},
  [3408] = {.lex_state = 44},
  [3409] = {.lex_state = 0},
  [3410] = {.lex_state = 44},
  [3411] = {.lex_state = 0},
  [3412] = {.lex_state = 44},
  [3413] = {.lex_state = 0},
  [3414] = {.lex_state = 0},
  [3415] = {.lex_state = 3},
  [3416] = {.lex_state = 44},
  [3417] = {.lex_state = 44},
  [3418] = {.lex_state = 44},
  [3419] = {.lex_state = 44},
  [3420] = {.lex_state = 44},
  [3421] = {.lex_state = 0},
  [3422] = {.lex_state = 0},
  [3423] = {.lex_state = 44},
  [3424] = {.lex_state = 0},
  [3425] = {.lex_state = 44},
  [3426] = {.lex_state = 0},
  [3427] = {.lex_state = 0},
  [3428] = {.lex_state = 0},
  [3429] = {.lex_state = 0},
  [3430] = {.lex_state = 44},
  [3431] = {.lex_state = 0},
  [3432] = {.lex_state = 0},
  [3433] = {.lex_state = 0},
  [3434] = {.lex_state = 0},
  [3435] = {.lex_state = 0},
  [3436] = {.lex_state = 0},
  [3437] = {.lex_state = 0},
  [3438] = {.lex_state = 44},
  [3439] = {.lex_state = 0},
  [3440] = {.lex_state = 0},
  [3441] = {.lex_state = 0},
  [3442] = {.lex_state = 0},
  [3443] = {.lex_state = 44},
  [3444] = {.lex_state = 44},
  [3445] = {.lex_state = 45},
  [3446] = {.lex_state = 44},
  [3447] = {.lex_state = 0},
  [3448] = {.lex_state = 0},
  [3449] = {.lex_state = 44},
  [3450] = {.lex_state = 44},
  [3451] = {.lex_state = 44},
  [3452] = {.lex_state = 44},
  [3453] = {.lex_state = 0},
  [3454] = {.lex_state = 45},
  [3455] = {.lex_state = 0},
  [3456] = {.lex_state = 44},
  [3457] = {.lex_state = 0},
  [3458] = {.lex_state = 44},
  [3459] = {.lex_state = 44},
  [3460] = {.lex_state = 44},
  [3461] = {.lex_state = 0},
  [3462] = {.lex_state = 0},
  [3463] = {.lex_state = 0},
  [3464] = {.lex_state = 44},
  [3465] = {.lex_state = 44},
  [3466] = {.lex_state = 0},
  [3467] = {.lex_state = 44},
  [3468] = {.lex_state = 0},
  [3469] = {.lex_state = 44},
  [3470] = {.lex_state = 0},
  [3471] = {.lex_state = 0},
  [3472] = {.lex_state = 44},
  [3473] = {.lex_state = 0},
  [3474] = {.lex_state = 0},
  [3475] = {.lex_state = 0},
  [3476] = {.lex_state = 0},
  [3477] = {.lex_state = 0},
  [3478] = {.lex_state = 44},
  [3479] = {.lex_state = 44},
  [3480] = {.lex_state = 0},
  [3481] = {.lex_state = 0},
  [3482] = {.lex_state = 0},
  [3483] = {.lex_state = 0},
  [3484] = {.lex_state = 0},
  [3485] = {.lex_state = 44},
  [3486] = {.lex_state = 44},
  [3487] = {.lex_state = 44},
  [3488] = {.lex_state = 0},
  [3489] = {.lex_state = 0},
  [3490] = {.lex_state = 0},
  [3491] = {.lex_state = 44},
  [3492] = {.lex_state = 0},
  [3493] = {.lex_state = 0},
  [3494] = {.lex_state = 44},
  [3495] = {.lex_state = 44},
  [3496] = {.lex_state = 44},
  [3497] = {.lex_state = 0},
  [3498] = {.lex_state = 44},
  [3499] = {.lex_state = 44},
  [3500] = {.lex_state = 44},
  [3501] = {.lex_state = 44},
  [3502] = {.lex_state = 0},
  [3503] = {.lex_state = 0},
  [3504] = {.lex_state = 44},
  [3505] = {.lex_state = 44},
  [3506] = {.lex_state = 44},
  [3507] = {.lex_state = 44},
  [3508] = {.lex_state = 0},
  [3509] = {.lex_state = 44},
  [3510] = {.lex_state = 44},
  [3511] = {.lex_state = 44},
  [3512] = {.lex_state = 44},
  [3513] = {.lex_state = 0},
  [3514] = {.lex_state = 0},
  [3515] = {.lex_state = 0},
  [3516] = {.lex_state = 0},
  [3517] = {.lex_state = 0},
  [3518] = {.lex_state = 0},
  [3519] = {.lex_state = 0},
  [3520] = {.lex_state = 0},
  [3521] = {.lex_state = 0},
  [3522] = {.lex_state = 44},
  [3523] = {.lex_state = 0},
  [3524] = {.lex_state = 44},
  [3525] = {.lex_state = 0},
  [3526] = {.lex_state = 0},
  [3527] = {.lex_state = 0},
  [3528] = {.lex_state = 0},
  [3529] = {.lex_state = 0},
  [3530] = {.lex_state = 0},
  [3531] = {.lex_state = 44},
  [3532] = {.lex_state = 0},
  [3533] = {.lex_state = 0},
  [3534] = {.lex_state = 0},
  [3535] = {.lex_state = 0},
  [3536] = {.lex_state = 0},
  [3537] = {.lex_state = 0},
  [3538] = {.lex_state = 0},
  [3539] = {.lex_state = 44},
  [3540] = {.lex_state = 44},
  [3541] = {.lex_state = 0},
  [3542] = {.lex_state = 0},
  [3543] = {.lex_state = 44},
  [3544] = {.lex_state = 44},
  [3545] = {.lex_state = 0},
  [3546] = {.lex_state = 0},
  [3547] = {.lex_state = 0},
  [3548] = {.lex_state = 0},
  [3549] = {.lex_state = 0},
  [3550] = {.lex_state = 0},
  [3551] = {.lex_state = 0},
  [3552] = {.lex_state = 0},
  [3553] = {.lex_state = 0},
  [3554] = {.lex_state = 0},
  [3555] = {.lex_state = 0},
  [3556] = {.lex_state = 0},
  [3557] = {.lex_state = 0},
  [3558] = {.lex_state = 0},
  [3559] = {.lex_state = 0},
  [3560] = {.lex_state = 0},
  [3561] = {.lex_state = 44},
  [3562] = {.lex_state = 0},
  [3563] = {.lex_state = 0},
  [3564] = {.lex_state = 0},
  [3565] = {.lex_state = 0},
  [3566] = {.lex_state = 0},
  [3567] = {.lex_state = 0},
  [3568] = {.lex_state = 0},
  [3569] = {.lex_state = 0},
  [3570] = {.lex_state = 0},
  [3571] = {.lex_state = 0},
  [3572] = {.lex_state = 0},
  [3573] = {.lex_state = 0},
  [3574] = {.lex_state = 0},
  [3575] = {.lex_state = 0},
  [3576] = {.lex_state = 0},
  [3577] = {.lex_state = 0},
  [3578] = {.lex_state = 0},
  [3579] = {.lex_state = 0},
  [3580] = {.lex_state = 0},
  [3581] = {.lex_state = 0},
  [3582] = {.lex_state = 0},
  [3583] = {.lex_state = 44},
  [3584] = {.lex_state = 0},
  [3585] = {.lex_state = 0},
  [3586] = {.lex_state = 0},
  [3587] = {.lex_state = 0},
  [3588] = {.lex_state = 0},
  [3589] = {.lex_state = 0},
  [3590] = {.lex_state = 0},
  [3591] = {.lex_state = 0},
  [3592] = {.lex_state = 0},
  [3593] = {.lex_state = 0},
  [3594] = {.lex_state = 0},
  [3595] = {.lex_state = 0},
  [3596] = {.lex_state = 0},
  [3597] = {.lex_state = 0},
  [3598] = {.lex_state = 0},
  [3599] = {.lex_state = 0},
  [3600] = {.lex_state = 0},
  [3601] = {.lex_state = 0},
  [3602] = {.lex_state = 0},
  [3603] = {.lex_state = 0},
  [3604] = {.lex_state = 45},
  [3605] = {.lex_state = 0},
  [3606] = {.lex_state = 0},
  [3607] = {.lex_state = 44},
  [3608] = {.lex_state = 0},
  [3609] = {.lex_state = 44},
  [3610] = {.lex_state = 0},
  [3611] = {.lex_state = 0},
  [3612] = {.lex_state = 0},
  [3613] = {.lex_state = 0},
  [3614] = {.lex_state = 0},
  [3615] = {.lex_state = 0},
  [3616] = {.lex_state = 0},
  [3617] = {.lex_state = 0},
  [3618] = {.lex_state = 0},
  [3619] = {.lex_state = 0},
  [3620] = {.lex_state = 3},
  [3621] = {.lex_state = 0},
  [3622] = {.lex_state = 0},
  [3623] = {.lex_state = 0},
  [3624] = {.lex_state = 44},
  [3625] = {.lex_state = 0},
  [3626] = {.lex_state = 0},
  [3627] = {.lex_state = 44},
  [3628] = {.lex_state = 0},
  [3629] = {.lex_state = 44},
  [3630] = {.lex_state = 0},
  [3631] = {.lex_state = 0},
  [3632] = {.lex_state = 0},
  [3633] = {.lex_state = 0},
  [3634] = {.lex_state = 0},
  [3635] = {.lex_state = 44},
  [3636] = {.lex_state = 0},
  [3637] = {.lex_state = 0},
  [3638] = {.lex_state = 0},
  [3639] = {.lex_state = 0},
  [3640] = {.lex_state = 0},
  [3641] = {.lex_state = 0},
  [3642] = {.lex_state = 0},
  [3643] = {.lex_state = 44},
  [3644] = {.lex_state = 0},
  [3645] = {.lex_state = 0},
  [3646] = {.lex_state = 0},
  [3647] = {.lex_state = 0},
  [3648] = {.lex_state = 44},
  [3649] = {.lex_state = 44},
  [3650] = {.lex_state = 0},
  [3651] = {.lex_state = 44},
  [3652] = {.lex_state = 0},
  [3653] = {.lex_state = 0},
  [3654] = {.lex_state = 44},
  [3655] = {.lex_state = 0},
  [3656] = {.lex_state = 0},
  [3657] = {.lex_state = 44},
  [3658] = {.lex_state = 0},
  [3659] = {.lex_state = 0},
  [3660] = {.lex_state = 0},
  [3661] = {.lex_state = 0},
  [3662] = {.lex_state = 44},
  [3663] = {.lex_state = 0},
  [3664] = {.lex_state = 44},
  [3665] = {.lex_state = 0},
  [3666] = {.lex_state = 0},
  [3667] = {.lex_state = 0},
  [3668] = {.lex_state = 44},
  [3669] = {.lex_state = 44},
  [3670] = {.lex_state = 0},
  [3671] = {.lex_state = 0},
  [3672] = {.lex_state = 0},
  [3673] = {.lex_state = 0},
  [3674] = {.lex_state = 0},
  [3675] = {.lex_state = 0},
  [3676] = {.lex_state = 0},
  [3677] = {.lex_state = 0},
  [3678] = {.lex_state = 0},
  [3679] = {.lex_state = 0},
  [3680] = {.lex_state = 44},
  [3681] = {.lex_state = 44},
  [3682] = {.lex_state = 44},
  [3683] = {.lex_state = 0},
  [3684] = {.lex_state = 0},
  [3685] = {.lex_state = 0},
  [3686] = {.lex_state = 0},
  [3687] = {.lex_state = 0},
  [3688] = {.lex_state = 0},
  [3689] = {.lex_state = 44},
  [3690] = {.lex_state = 0},
  [3691] = {.lex_state = 44},
  [3692] = {.lex_state = 0},
  [3693] = {.lex_state = 0},
  [3694] = {.lex_state = 44},
  [3695] = {.lex_state = 44},
  [3696] = {.lex_state = 44},
  [3697] = {.lex_state = 0},
  [3698] = {.lex_state = 44},
  [3699] = {.lex_state = 44},
  [3700] = {.lex_state = 44},
  [3701] = {.lex_state = 44},
  [3702] = {.lex_state = 44},
  [3703] = {.lex_state = 0},
  [3704] = {.lex_state = 44},
  [3705] = {.lex_state = 44},
  [3706] = {.lex_state = 0},
  [3707] = {.lex_state = 0},
  [3708] = {.lex_state = 0},
  [3709] = {.lex_state = 44},
  [3710] = {.lex_state = 44},
  [3711] = {.lex_state = 44},
  [3712] = {.lex_state = 44},
  [3713] = {.lex_state = 44},
  [3714] = {.lex_state = 0},
  [3715] = {.lex_state = 0},
  [3716] = {.lex_state = 0},
  [3717] = {.lex_state = 0},
  [3718] = {.lex_state = 0},
  [3719] = {.lex_state = 44},
  [3720] = {.lex_state = 0},
  [3721] = {.lex_state = 44},
  [3722] = {.lex_state = 44},
  [3723] = {.lex_state = 44},
  [3724] = {.lex_state = 0},
  [3725] = {.lex_state = 0},
  [3726] = {.lex_state = 0},
  [3727] = {.lex_state = 44},
  [3728] = {.lex_state = 44},
  [3729] = {.lex_state = 0},
  [3730] = {.lex_state = 44},
  [3731] = {.lex_state = 0},
  [3732] = {.lex_state = 44},
  [3733] = {.lex_state = 44},
  [3734] = {.lex_state = 0},
  [3735] = {.lex_state = 0},
  [3736] = {.lex_state = 44},
  [3737] = {.lex_state = 0},
  [3738] = {.lex_state = 0},
  [3739] = {.lex_state = 44},
  [3740] = {.lex_state = 0},
  [3741] = {.lex_state = 0},
  [3742] = {.lex_state = 0},
  [3743] = {.lex_state = 0},
  [3744] = {.lex_state = 0},
  [3745] = {.lex_state = 0},
  [3746] = {.lex_state = 3},
  [3747] = {.lex_state = 0},
  [3748] = {.lex_state = 0},
  [3749] = {.lex_state = 0},
  [3750] = {.lex_state = 0},
  [3751] = {.lex_state = 0},
  [3752] = {.lex_state = 0},
  [3753] = {.lex_state = 0},
  [3754] = {.lex_state = 0},
  [3755] = {.lex_state = 0},
  [3756] = {.lex_state = 0},
  [3757] = {.lex_state = 0},
  [3758] = {.lex_state = 0},
  [3759] = {.lex_state = 0},
  [3760] = {.lex_state = 0},
  [3761] = {.lex_state = 0},
  [3762] = {.lex_state = 0},
  [3763] = {.lex_state = 0},
  [3764] = {.lex_state = 0},
  [3765] = {.lex_state = 0},
  [3766] = {.lex_state = 0},
  [3767] = {.lex_state = 0},
  [3768] = {.lex_state = 0},
  [3769] = {.lex_state = 0},
  [3770] = {.lex_state = 0},
  [3771] = {.lex_state = 0},
  [3772] = {.lex_state = 44},
  [3773] = {.lex_state = 0},
  [3774] = {.lex_state = 0},
  [3775] = {.lex_state = 0},
  [3776] = {.lex_state = 0},
  [3777] = {.lex_state = 0},
  [3778] = {.lex_state = 0},
  [3779] = {.lex_state = 0},
  [3780] = {.lex_state = 0},
  [3781] = {.lex_state = 0},
  [3782] = {.lex_state = 0},
  [3783] = {.lex_state = 0},
  [3784] = {.lex_state = 0},
  [3785] = {.lex_state = 0},
  [3786] = {.lex_state = 0},
  [3787] = {.lex_state = 0},
  [3788] = {.lex_state = 0},
  [3789] = {.lex_state = 0},
  [3790] = {.lex_state = 0},
  [3791] = {.lex_state = 0},
  [3792] = {.lex_state = 0},
  [3793] = {.lex_state = 0},
  [3794] = {.lex_state = 0},
  [3795] = {.lex_state = 44},
  [3796] = {.lex_state = 44},
  [3797] = {.lex_state = 44},
  [3798] = {.lex_state = 3},
  [3799] = {.lex_state = 0},
  [3800] = {.lex_state = 44},
  [3801] = {.lex_state = 0},
  [3802] = {.lex_state = 0},
  [3803] = {.lex_state = 0},
  [3804] = {.lex_state = 0},
  [3805] = {.lex_state = 0},
  [3806] = {.lex_state = 0},
  [3807] = {.lex_state = 0},
  [3808] = {.lex_state = 44},
  [3809] = {.lex_state = 44},
  [3810] = {.lex_state = 44},
  [3811] = {.lex_state = 44},
  [3812] = {.lex_state = 0},
  [3813] = {.lex_state = 0},
  [3814] = {.lex_state = 0},
  [3815] = {.lex_state = 0},
  [3816] = {.lex_state = 0},
  [3817] = {.lex_state = 0},
  [3818] = {.lex_state = 0},
  [3819] = {.lex_state = 0},
  [3820] = {.lex_state = 0},
  [3821] = {.lex_state = 0},
  [3822] = {.lex_state = 0},
  [3823] = {.lex_state = 0},
  [3824] = {.lex_state = 0},
  [3825] = {.lex_state = 0},
  [3826] = {.lex_state = 0},
  [3827] = {.lex_state = 0},
  [3828] = {.lex_state = 0},
  [3829] = {.lex_state = 0},
  [3830] = {.lex_state = 0},
  [3831] = {.lex_state = 0},
  [3832] = {.lex_state = 0},
  [3833] = {.lex_state = 44},
  [3834] = {.lex_state = 0},
  [3835] = {.lex_state = 0},
  [3836] = {.lex_state = 0},
  [3837] = {.lex_state = 0},
  [3838] = {.lex_state = 0},
  [3839] = {.lex_state = 0},
  [3840] = {.lex_state = 0},
  [3841] = {.lex_state = 0},
  [3842] = {.lex_state = 0},
  [3843] = {.lex_state = 0},
  [3844] = {.lex_state = 0},
  [3845] = {.lex_state = 0},
  [3846] = {.lex_state = 0},
  [3847] = {.lex_state = 0},
  [3848] = {.lex_state = 0},
  [3849] = {.lex_state = 0},
  [3850] = {.lex_state = 0},
  [3851] = {.lex_state = 0},
  [3852] = {.lex_state = 0},
  [3853] = {.lex_state = 0},
  [3854] = {.lex_state = 0},
  [3855] = {.lex_state = 0},
  [3856] = {.lex_state = 0},
  [3857] = {.lex_state = 0},
  [3858] = {.lex_state = 0},
  [3859] = {.lex_state = 0},
  [3860] = {.lex_state = 0},
  [3861] = {.lex_state = 0},
  [3862] = {.lex_state = 0},
  [3863] = {.lex_state = 0},
  [3864] = {.lex_state = 0},
  [3865] = {.lex_state = 0},
  [3866] = {.lex_state = 0},
  [3867] = {.lex_state = 0},
  [3868] = {.lex_state = 0},
  [3869] = {.lex_state = 0},
  [3870] = {.lex_state = 0},
  [3871] = {.lex_state = 0},
  [3872] = {.lex_state = 0},
  [3873] = {.lex_state = 0},
  [3874] = {.lex_state = 0},
  [3875] = {.lex_state = 0},
  [3876] = {.lex_state = 0},
  [3877] = {.lex_state = 0},
  [3878] = {.lex_state = 0},
  [3879] = {.lex_state = 0},
  [3880] = {.lex_state = 0},
  [3881] = {.lex_state = 0},
  [3882] = {.lex_state = 0},
  [3883] = {.lex_state = 0},
  [3884] = {.lex_state = 0},
  [3885] = {.lex_state = 44},
  [3886] = {.lex_state = 0},
  [3887] = {.lex_state = 0},
  [3888] = {.lex_state = 0},
  [3889] = {.lex_state = 0},
  [3890] = {.lex_state = 44},
  [3891] = {.lex_state = 0},
  [3892] = {.lex_state = 0},
  [3893] = {.lex_state = 0},
  [3894] = {.lex_state = 0},
  [3895] = {.lex_state = 0},
  [3896] = {.lex_state = 0},
  [3897] = {.lex_state = 0},
  [3898] = {.lex_state = 0},
  [3899] = {.lex_state = 0},
  [3900] = {.lex_state = 0},
  [3901] = {.lex_state = 0},
  [3902] = {.lex_state = 44},
  [3903] = {.lex_state = 0},
  [3904] = {.lex_state = 0},
  [3905] = {.lex_state = 44},
  [3906] = {.lex_state = 0},
  [3907] = {.lex_state = 0},
  [3908] = {.lex_state = 44},
  [3909] = {.lex_state = 44},
  [3910] = {.lex_state = 0},
  [3911] = {.lex_state = 0},
  [3912] = {.lex_state = 0},
  [3913] = {.lex_state = 0},
  [3914] = {.lex_state = 0},
  [3915] = {.lex_state = 0},
  [3916] = {.lex_state = 0},
  [3917] = {.lex_state = 0},
  [3918] = {.lex_state = 0},
  [3919] = {.lex_state = 0},
  [3920] = {.lex_state = 0},
  [3921] = {.lex_state = 0},
  [3922] = {.lex_state = 0},
  [3923] = {.lex_state = 0},
  [3924] = {.lex_state = 0},
  [3925] = {.lex_state = 0},
  [3926] = {.lex_state = 0},
  [3927] = {.lex_state = 0},
  [3928] = {.lex_state = 0},
  [3929] = {.lex_state = 0},
  [3930] = {.lex_state = 45},
  [3931] = {.lex_state = 5},
  [3932] = {.lex_state = 45},
  [3933] = {.lex_state = 0},
  [3934] = {.lex_state = 0},
  [3935] = {.lex_state = 0},
  [3936] = {.lex_state = 5},
  [3937] = {.lex_state = 45},
  [3938] = {.lex_state = 0},
  [3939] = {.lex_state = 45},
  [3940] = {.lex_state = 0},
  [3941] = {.lex_state = 0},
  [3942] = {.lex_state = 5},
  [3943] = {.lex_state = 5},
  [3944] = {.lex_state = 0},
  [3945] = {.lex_state = 0},
  [3946] = {.lex_state = 0},
  [3947] = {.lex_state = 0},
  [3948] = {.lex_state = 0},
  [3949] = {.lex_state = 0},
  [3950] = {.lex_state = 45},
  [3951] = {.lex_state = 0},
  [3952] = {.lex_state = 0},
  [3953] = {.lex_state = 0},
  [3954] = {.lex_state = 0},
  [3955] = {.lex_state = 0},
  [3956] = {.lex_state = 0},
  [3957] = {.lex_state = 0},
  [3958] = {.lex_state = 0},
  [3959] = {.lex_state = 0},
  [3960] = {.lex_state = 0},
  [3961] = {.lex_state = 0},
  [3962] = {.lex_state = 0},
  [3963] = {.lex_state = 0},
  [3964] = {.lex_state = 0},
  [3965] = {.lex_state = 0},
  [3966] = {.lex_state = 0},
  [3967] = {.lex_state = 0},
  [3968] = {.lex_state = 0},
  [3969] = {.lex_state = 0},
  [3970] = {.lex_state = 0},
  [3971] = {.lex_state = 0},
  [3972] = {.lex_state = 0},
  [3973] = {.lex_state = 0},
  [3974] = {.lex_state = 0},
  [3975] = {.lex_state = 0},
  [3976] = {.lex_state = 45},
  [3977] = {.lex_state = 0},
  [3978] = {.lex_state = 0},
  [3979] = {.lex_state = 0},
  [3980] = {.lex_state = 0},
  [3981] = {.lex_state = 0},
  [3982] = {.lex_state = 0},
  [3983] = {.lex_state = 0},
  [3984] = {.lex_state = 0},
  [3985] = {.lex_state = 0},
  [3986] = {.lex_state = 0},
  [3987] = {.lex_state = 0},
  [3988] = {.lex_state = 0},
  [3989] = {.lex_state = 44},
  [3990] = {.lex_state = 0},
  [3991] = {.lex_state = 0},
  [3992] = {.lex_state = 45},
  [3993] = {.lex_state = 0},
  [3994] = {.lex_state = 0},
  [3995] = {.lex_state = 0},
  [3996] = {.lex_state = 0},
  [3997] = {.lex_state = 0},
  [3998] = {.lex_state = 0},
  [3999] = {.lex_state = 5},
  [4000] = {.lex_state = 0},
  [4001] = {.lex_state = 0},
  [4002] = {.lex_state = 0},
  [4003] = {.lex_state = 0},
  [4004] = {.lex_state = 0},
  [4005] = {.lex_state = 0},
  [4006] = {.lex_state = 0},
  [4007] = {.lex_state = 0},
  [4008] = {.lex_state = 0},
  [4009] = {.lex_state = 0},
  [4010] = {.lex_state = 0},
  [4011] = {.lex_state = 0},
  [4012] = {.lex_state = 0},
  [4013] = {.lex_state = 0},
  [4014] = {.lex_state = 0},
  [4015] = {.lex_state = 0},
  [4016] = {.lex_state = 45},
  [4017] = {.lex_state = 0},
  [4018] = {.lex_state = 0},
  [4019] = {.lex_state = 0},
  [4020] = {.lex_state = 45},
  [4021] = {.lex_state = 0},
  [4022] = {.lex_state = 0},
  [4023] = {.lex_state = 0},
  [4024] = {.lex_state = 0},
  [4025] = {.lex_state = 0},
  [4026] = {.lex_state = 0},
  [4027] = {.lex_state = 0},
  [4028] = {.lex_state = 45},
  [4029] = {.lex_state = 0},
  [4030] = {.lex_state = 5},
  [4031] = {.lex_state = 0},
  [4032] = {.lex_state = 0},
  [4033] = {.lex_state = 45},
  [4034] = {.lex_state = 0},
  [4035] = {.lex_state = 0},
  [4036] = {.lex_state = 0},
  [4037] = {.lex_state = 0},
  [4038] = {.lex_state = 0},
  [4039] = {.lex_state = 0},
  [4040] = {.lex_state = 0},
  [4041] = {.lex_state = 44},
  [4042] = {.lex_state = 0},
  [4043] = {.lex_state = 0},
  [4044] = {.lex_state = 0},
  [4045] = {.lex_state = 0},
  [4046] = {.lex_state = 0},
  [4047] = {.lex_state = 5},
  [4048] = {.lex_state = 0},
  [4049] = {.lex_state = 0},
  [4050] = {.lex_state = 0},
  [4051] = {.lex_state = 0},
  [4052] = {.lex_state = 0},
  [4053] = {.lex_state = 44},
  [4054] = {.lex_state = 0},
  [4055] = {.lex_state = 0},
  [4056] = {.lex_state = 0},
  [4057] = {.lex_state = 0},
  [4058] = {.lex_state = 0},
  [4059] = {.lex_state = 0},
  [4060] = {.lex_state = 0},
  [4061] = {.lex_state = 0},
  [4062] = {.lex_state = 0},
  [4063] = {.lex_state = 0},
  [4064] = {.lex_state = 0},
  [4065] = {.lex_state = 0},
  [4066] = {.lex_state = 44},
  [4067] = {.lex_state = 3},
  [4068] = {.lex_state = 0},
  [4069] = {.lex_state = 0},
  [4070] = {.lex_state = 0},
  [4071] = {.lex_state = 0},
  [4072] = {.lex_state = 0},
  [4073] = {.lex_state = 0},
  [4074] = {.lex_state = 0},
  [4075] = {.lex_state = 0},
  [4076] = {.lex_state = 0},
  [4077] = {.lex_state = 0},
  [4078] = {.lex_state = 5},
  [4079] = {.lex_state = 0},
  [4080] = {.lex_state = 0},
  [4081] = {.lex_state = 0},
  [4082] = {.lex_state = 45},
  [4083] = {.lex_state = 0},
  [4084] = {.lex_state = 0},
  [4085] = {.lex_state = 0},
  [4086] = {.lex_state = 0},
  [4087] = {.lex_state = 0},
  [4088] = {.lex_state = 0},
  [4089] = {.lex_state = 0},
  [4090] = {.lex_state = 0},
  [4091] = {.lex_state = 0},
  [4092] = {.lex_state = 0},
  [4093] = {.lex_state = 0},
  [4094] = {.lex_state = 0},
  [4095] = {.lex_state = 0},
  [4096] = {.lex_state = 0},
  [4097] = {.lex_state = 0},
  [4098] = {.lex_state = 0},
  [4099] = {.lex_state = 0},
  [4100] = {.lex_state = 0},
  [4101] = {.lex_state = 44},
  [4102] = {.lex_state = 0},
  [4103] = {.lex_state = 0},
  [4104] = {.lex_state = 44},
  [4105] = {.lex_state = 0},
  [4106] = {.lex_state = 0},
  [4107] = {.lex_state = 0},
  [4108] = {.lex_state = 0},
  [4109] = {.lex_state = 0},
  [4110] = {.lex_state = 0},
  [4111] = {.lex_state = 0},
  [4112] = {.lex_state = 0},
  [4113] = {.lex_state = 0},
  [4114] = {.lex_state = 0},
  [4115] = {.lex_state = 0},
  [4116] = {.lex_state = 0},
  [4117] = {.lex_state = 0},
  [4118] = {.lex_state = 0},
  [4119] = {.lex_state = 0},
  [4120] = {.lex_state = 0},
  [4121] = {.lex_state = 0},
  [4122] = {.lex_state = 44},
  [4123] = {.lex_state = 0},
  [4124] = {.lex_state = 0},
  [4125] = {.lex_state = 0},
  [4126] = {.lex_state = 44},
  [4127] = {.lex_state = 0},
  [4128] = {.lex_state = 0},
  [4129] = {.lex_state = 0},
  [4130] = {.lex_state = 44},
  [4131] = {.lex_state = 44},
  [4132] = {.lex_state = 44},
  [4133] = {.lex_state = 44},
  [4134] = {.lex_state = 0},
  [4135] = {.lex_state = 0},
  [4136] = {.lex_state = 3},
  [4137] = {.lex_state = 0},
  [4138] = {.lex_state = 0},
  [4139] = {.lex_state = 0},
  [4140] = {.lex_state = 0},
  [4141] = {.lex_state = 0},
  [4142] = {.lex_state = 44},
  [4143] = {.lex_state = 0},
  [4144] = {.lex_state = 0},
  [4145] = {.lex_state = 0},
  [4146] = {.lex_state = 0},
  [4147] = {.lex_state = 0},
  [4148] = {.lex_state = 44},
  [4149] = {.lex_state = 0},
  [4150] = {.lex_state = 45},
  [4151] = {.lex_state = 0},
  [4152] = {.lex_state = 0},
  [4153] = {.lex_state = 0},
  [4154] = {.lex_state = 0},
  [4155] = {.lex_state = 0},
  [4156] = {.lex_state = 0},
  [4157] = {.lex_state = 0},
  [4158] = {.lex_state = 0},
  [4159] = {.lex_state = 0},
  [4160] = {.lex_state = 0},
  [4161] = {.lex_state = 0},
  [4162] = {.lex_state = 0},
  [4163] = {.lex_state = 0},
  [4164] = {.lex_state = 45},
  [4165] = {.lex_state = 0},
  [4166] = {.lex_state = 0},
  [4167] = {.lex_state = 0},
  [4168] = {.lex_state = 0},
  [4169] = {.lex_state = 0},
  [4170] = {.lex_state = 44},
  [4171] = {.lex_state = 0},
  [4172] = {.lex_state = 0},
  [4173] = {.lex_state = 0},
  [4174] = {.lex_state = 0},
  [4175] = {.lex_state = 0},
  [4176] = {.lex_state = 0},
  [4177] = {.lex_state = 0},
  [4178] = {.lex_state = 0},
  [4179] = {.lex_state = 0},
  [4180] = {.lex_state = 0},
  [4181] = {.lex_state = 0},
  [4182] = {.lex_state = 0},
  [4183] = {.lex_state = 0},
  [4184] = {.lex_state = 0},
  [4185] = {.lex_state = 0},
  [4186] = {.lex_state = 0},
  [4187] = {.lex_state = 0},
  [4188] = {.lex_state = 0},
  [4189] = {.lex_state = 0},
  [4190] = {.lex_state = 0},
  [4191] = {.lex_state = 0},
  [4192] = {.lex_state = 0},
  [4193] = {.lex_state = 0},
  [4194] = {.lex_state = 0},
  [4195] = {.lex_state = 0},
  [4196] = {.lex_state = 0},
  [4197] = {.lex_state = 0},
  [4198] = {.lex_state = 15},
  [4199] = {.lex_state = 0},
  [4200] = {.lex_state = 0},
  [4201] = {.lex_state = 0},
  [4202] = {.lex_state = 0},
  [4203] = {.lex_state = 0},
  [4204] = {.lex_state = 0},
  [4205] = {.lex_state = 3},
  [4206] = {.lex_state = 0},
  [4207] = {.lex_state = 45},
  [4208] = {.lex_state = 0},
  [4209] = {.lex_state = 0},
  [4210] = {.lex_state = 0},
  [4211] = {.lex_state = 0},
  [4212] = {.lex_state = 0},
  [4213] = {.lex_state = 0},
  [4214] = {.lex_state = 0},
  [4215] = {.lex_state = 44},
  [4216] = {.lex_state = 0},
  [4217] = {.lex_state = 44},
  [4218] = {.lex_state = 0},
  [4219] = {.lex_state = 0},
  [4220] = {.lex_state = 0},
  [4221] = {.lex_state = 0},
  [4222] = {.lex_state = 0},
  [4223] = {.lex_state = 44},
  [4224] = {.lex_state = 0},
  [4225] = {.lex_state = 0},
  [4226] = {.lex_state = 0},
  [4227] = {.lex_state = 44},
  [4228] = {.lex_state = 0},
  [4229] = {.lex_state = 0},
  [4230] = {.lex_state = 0},
  [4231] = {.lex_state = 0},
  [4232] = {.lex_state = 0},
  [4233] = {.lex_state = 0},
  [4234] = {.lex_state = 0},
  [4235] = {.lex_state = 0},
  [4236] = {.lex_state = 0},
  [4237] = {.lex_state = 44},
  [4238] = {.lex_state = 0},
  [4239] = {.lex_state = 0},
  [4240] = {.lex_state = 0},
  [4241] = {.lex_state = 0},
  [4242] = {.lex_state = 0},
  [4243] = {.lex_state = 0},
  [4244] = {.lex_state = 0},
  [4245] = {.lex_state = 0},
  [4246] = {.lex_state = 44},
  [4247] = {.lex_state = 0},
  [4248] = {.lex_state = 0},
  [4249] = {.lex_state = 0},
  [4250] = {.lex_state = 0},
  [4251] = {.lex_state = 0},
  [4252] = {.lex_state = 0},
  [4253] = {.lex_state = 0},
  [4254] = {.lex_state = 0},
  [4255] = {.lex_state = 0},
  [4256] = {.lex_state = 0},
  [4257] = {.lex_state = 0},
  [4258] = {.lex_state = 0},
  [4259] = {.lex_state = 0},
  [4260] = {.lex_state = 0},
  [4261] = {.lex_state = 0},
  [4262] = {.lex_state = 0},
  [4263] = {.lex_state = 0},
  [4264] = {.lex_state = 0},
  [4265] = {.lex_state = 44},
  [4266] = {.lex_state = 0},
  [4267] = {.lex_state = 0},
  [4268] = {.lex_state = 0},
  [4269] = {.lex_state = 44},
  [4270] = {.lex_state = 44},
  [4271] = {.lex_state = 0},
  [4272] = {.lex_state = 0},
  [4273] = {.lex_state = 0},
  [4274] = {.lex_state = 44},
  [4275] = {.lex_state = 0},
  [4276] = {.lex_state = 0},
  [4277] = {.lex_state = 44},
  [4278] = {.lex_state = 0},
  [4279] = {.lex_state = 44},
  [4280] = {.lex_state = 0},
  [4281] = {.lex_state = 0},
  [4282] = {.lex_state = 0},
  [4283] = {.lex_state = 0},
  [4284] = {.lex_state = 0},
  [4285] = {.lex_state = 0},
  [4286] = {.lex_state = 44},
  [4287] = {.lex_state = 0},
  [4288] = {.lex_state = 0},
  [4289] = {.lex_state = 0},
  [4290] = {.lex_state = 0},
  [4291] = {.lex_state = 0},
  [4292] = {.lex_state = 0},
  [4293] = {.lex_state = 0},
  [4294] = {.lex_state = 44},
  [4295] = {.lex_state = 0},
  [4296] = {.lex_state = 0},
  [4297] = {.lex_state = 44},
  [4298] = {.lex_state = 44},
  [4299] = {.lex_state = 0},
  [4300] = {.lex_state = 44},
  [4301] = {.lex_state = 0},
  [4302] = {.lex_state = 0},
  [4303] = {.lex_state = 0},
  [4304] = {.lex_state = 44},
  [4305] = {.lex_state = 44},
  [4306] = {.lex_state = 0},
  [4307] = {.lex_state = 0},
  [4308] = {.lex_state = 0},
  [4309] = {.lex_state = 0},
  [4310] = {.lex_state = 0},
  [4311] = {.lex_state = 0},
  [4312] = {.lex_state = 0},
  [4313] = {.lex_state = 0},
  [4314] = {.lex_state = 0},
  [4315] = {.lex_state = 0},
  [4316] = {.lex_state = 0},
  [4317] = {.lex_state = 0},
  [4318] = {.lex_state = 0},
  [4319] = {.lex_state = 0},
  [4320] = {.lex_state = 0},
  [4321] = {.lex_state = 44},
  [4322] = {.lex_state = 0},
  [4323] = {.lex_state = 44},
  [4324] = {.lex_state = 44},
  [4325] = {.lex_state = 0},
  [4326] = {.lex_state = 0},
  [4327] = {.lex_state = 0},
  [4328] = {.lex_state = 45},
  [4329] = {.lex_state = 0},
  [4330] = {.lex_state = 44},
  [4331] = {.lex_state = 44},
  [4332] = {.lex_state = 0},
  [4333] = {.lex_state = 0},
  [4334] = {.lex_state = 0},
  [4335] = {.lex_state = 44},
  [4336] = {.lex_state = 0},
  [4337] = {.lex_state = 0},
  [4338] = {.lex_state = 44},
  [4339] = {.lex_state = 0},
  [4340] = {.lex_state = 44},
  [4341] = {.lex_state = 0},
  [4342] = {.lex_state = 0},
  [4343] = {.lex_state = 0},
  [4344] = {.lex_state = 0},
  [4345] = {.lex_state = 0},
  [4346] = {.lex_state = 0},
  [4347] = {.lex_state = 0},
  [4348] = {.lex_state = 44},
  [4349] = {.lex_state = 0},
  [4350] = {.lex_state = 0},
  [4351] = {.lex_state = 44},
  [4352] = {.lex_state = 0},
  [4353] = {.lex_state = 0},
  [4354] = {.lex_state = 0},
  [4355] = {.lex_state = 0},
  [4356] = {.lex_state = 44},
  [4357] = {.lex_state = 0},
  [4358] = {.lex_state = 0},
  [4359] = {.lex_state = 0},
  [4360] = {.lex_state = 0},
  [4361] = {.lex_state = 0},
  [4362] = {.lex_state = 45},
  [4363] = {.lex_state = 0},
  [4364] = {.lex_state = 0},
  [4365] = {.lex_state = 0},
  [4366] = {.lex_state = 0},
  [4367] = {.lex_state = 0},
  [4368] = {.lex_state = 44},
  [4369] = {.lex_state = 0},
  [4370] = {.lex_state = 0},
  [4371] = {.lex_state = 0},
  [4372] = {.lex_state = 0},
  [4373] = {.lex_state = 0},
  [4374] = {.lex_state = 0},
  [4375] = {.lex_state = 0},
  [4376] = {.lex_state = 0},
  [4377] = {.lex_state = 0},
  [4378] = {.lex_state = 0},
  [4379] = {.lex_state = 0},
  [4380] = {.lex_state = 0},
  [4381] = {.lex_state = 0},
  [4382] = {.lex_state = 44},
  [4383] = {.lex_state = 0},
  [4384] = {.lex_state = 0},
  [4385] = {.lex_state = 0},
  [4386] = {.lex_state = 0},
  [4387] = {.lex_state = 0},
  [4388] = {.lex_state = 0},
  [4389] = {.lex_state = 0},
  [4390] = {.lex_state = 0},
  [4391] = {.lex_state = 44},
  [4392] = {.lex_state = 0},
  [4393] = {.lex_state = 0},
  [4394] = {.lex_state = 0},
  [4395] = {.lex_state = 0},
  [4396] = {.lex_state = 0},
  [4397] = {.lex_state = 0},
  [4398] = {.lex_state = 0},
  [4399] = {.lex_state = 44},
  [4400] = {.lex_state = 0},
  [4401] = {.lex_state = 0},
  [4402] = {.lex_state = 0},
  [4403] = {.lex_state = 0},
  [4404] = {.lex_state = 0},
  [4405] = {.lex_state = 0},
  [4406] = {.lex_state = 0},
  [4407] = {.lex_state = 0},
  [4408] = {.lex_state = 0},
  [4409] = {.lex_state = 0},
  [4410] = {.lex_state = 0},
  [4411] = {.lex_state = 0},
  [4412] = {.lex_state = 0},
  [4413] = {.lex_state = 0},
  [4414] = {.lex_state = 0},
  [4415] = {.lex_state = 0},
  [4416] = {.lex_state = 0},
  [4417] = {.lex_state = 0},
  [4418] = {.lex_state = 3},
  [4419] = {.lex_state = 0},
  [4420] = {.lex_state = 0},
  [4421] = {.lex_state = 0},
  [4422] = {.lex_state = 0},
  [4423] = {.lex_state = 0},
  [4424] = {.lex_state = 0},
  [4425] = {.lex_state = 0},
  [4426] = {.lex_state = 0},
  [4427] = {.lex_state = 0},
  [4428] = {.lex_state = 0},
  [4429] = {.lex_state = 0},
  [4430] = {.lex_state = 0},
  [4431] = {.lex_state = 0},
  [4432] = {.lex_state = 3},
  [4433] = {.lex_state = 0},
  [4434] = {.lex_state = 0},
  [4435] = {.lex_state = 0},
  [4436] = {.lex_state = 0},
  [4437] = {.lex_state = 0},
  [4438] = {.lex_state = 0},
  [4439] = {.lex_state = 0},
  [4440] = {.lex_state = 0},
  [4441] = {.lex_state = 0},
  [4442] = {.lex_state = 0},
  [4443] = {.lex_state = 0},
  [4444] = {.lex_state = 0},
  [4445] = {.lex_state = 0},
  [4446] = {.lex_state = 0},
  [4447] = {.lex_state = 0},
  [4448] = {.lex_state = 0},
  [4449] = {.lex_state = 0},
  [4450] = {.lex_state = 0},
  [4451] = {.lex_state = 0},
  [4452] = {.lex_state = 0},
  [4453] = {.lex_state = 0},
  [4454] = {.lex_state = 0},
  [4455] = {.lex_state = 0},
  [4456] = {.lex_state = 0},
  [4457] = {.lex_state = 0},
  [4458] = {.lex_state = 0},
  [4459] = {.lex_state = 0},
  [4460] = {.lex_state = 0},
  [4461] = {.lex_state = 0},
  [4462] = {.lex_state = 0},
  [4463] = {.lex_state = 44},
  [4464] = {.lex_state = 0},
  [4465] = {.lex_state = 0},
  [4466] = {.lex_state = 0},
  [4467] = {.lex_state = 0},
  [4468] = {.lex_state = 0},
  [4469] = {.lex_state = 0},
  [4470] = {.lex_state = 0},
  [4471] = {.lex_state = 0},
  [4472] = {.lex_state = 0},
  [4473] = {.lex_state = 0},
  [4474] = {.lex_state = 0},
  [4475] = {.lex_state = 0},
  [4476] = {.lex_state = 0},
  [4477] = {.lex_state = 0},
  [4478] = {.lex_state = 0},
  [4479] = {.lex_state = 0},
  [4480] = {.lex_state = 0},
  [4481] = {.lex_state = 0},
  [4482] = {.lex_state = 0},
  [4483] = {.lex_state = 0},
  [4484] = {.lex_state = 0},
  [4485] = {.lex_state = 0},
  [4486] = {.lex_state = 0},
  [4487] = {.lex_state = 0},
  [4488] = {.lex_state = 0},
  [4489] = {.lex_state = 0},
  [4490] = {.lex_state = 0},
  [4491] = {.lex_state = 0},
  [4492] = {.lex_state = 0},
  [4493] = {.lex_state = 0},
  [4494] = {.lex_state = 0},
  [4495] = {.lex_state = 0},
  [4496] = {.lex_state = 0},
  [4497] = {.lex_state = 0},
  [4498] = {.lex_state = 15},
  [4499] = {.lex_state = 0},
  [4500] = {.lex_state = 0},
  [4501] = {.lex_state = 0},
  [4502] = {.lex_state = 44},
  [4503] = {.lex_state = 0},
  [4504] = {.lex_state = 0},
  [4505] = {.lex_state = 0},
  [4506] = {.lex_state = 0},
  [4507] = {.lex_state = 0},
  [4508] = {.lex_state = 0},
  [4509] = {.lex_state = 0},
  [4510] = {.lex_state = 0},
  [4511] = {.lex_state = 0},
  [4512] = {.lex_state = 15},
  [4513] = {.lex_state = 15},
  [4514] = {.lex_state = 0},
  [4515] = {.lex_state = 0},
  [4516] = {.lex_state = 0},
  [4517] = {.lex_state = 0},
  [4518] = {.lex_state = 0},
  [4519] = {.lex_state = 0},
  [4520] = {.lex_state = 0},
  [4521] = {.lex_state = 0},
  [4522] = {.lex_state = 0},
  [4523] = {.lex_state = 0},
  [4524] = {.lex_state = 0},
  [4525] = {.lex_state = 0},
  [4526] = {.lex_state = 0},
  [4527] = {.lex_state = 0},
  [4528] = {.lex_state = 0},
  [4529] = {.lex_state = 44},
  [4530] = {.lex_state = 0},
  [4531] = {.lex_state = 0},
  [4532] = {.lex_state = 0},
  [4533] = {.lex_state = 15},
  [4534] = {.lex_state = 0},
  [4535] = {.lex_state = 0},
  [4536] = {.lex_state = 0},
  [4537] = {.lex_state = 15},
  [4538] = {.lex_state = 0},
  [4539] = {.lex_state = 0},
  [4540] = {.lex_state = 0},
  [4541] = {.lex_state = 0},
  [4542] = {.lex_state = 15},
  [4543] = {.lex_state = 0},
  [4544] = {.lex_state = 15},
  [4545] = {.lex_state = 0},
  [4546] = {.lex_state = 0},
  [4547] = {.lex_state = 0},
  [4548] = {.lex_state = 44},
  [4549] = {.lex_state = 0},
  [4550] = {.lex_state = 0},
  [4551] = {.lex_state = 0},
  [4552] = {.lex_state = 0},
  [4553] = {.lex_state = 0},
  [4554] = {.lex_state = 15},
  [4555] = {.lex_state = 0},
  [4556] = {.lex_state = 15},
  [4557] = {.lex_state = 0},
  [4558] = {.lex_state = 15},
  [4559] = {.lex_state = 0},
  [4560] = {.lex_state = 45},
  [4561] = {.lex_state = 15},
  [4562] = {.lex_state = 15},
  [4563] = {.lex_state = 0},
  [4564] = {.lex_state = 45},
  [4565] = {.lex_state = 15},
  [4566] = {.lex_state = 15},
  [4567] = {.lex_state = 0},
  [4568] = {.lex_state = 0},
  [4569] = {.lex_state = 0},
  [4570] = {.lex_state = 15},
  [4571] = {.lex_state = 45},
  [4572] = {.lex_state = 0},
  [4573] = {.lex_state = 15},
  [4574] = {.lex_state = 45},
  [4575] = {.lex_state = 0},
  [4576] = {.lex_state = 15},
  [4577] = {.lex_state = 15},
  [4578] = {.lex_state = 0},
  [4579] = {.lex_state = 0},
  [4580] = {.lex_state = 45},
  [4581] = {.lex_state = 45},
  [4582] = {.lex_state = 45},
  [4583] = {.lex_state = 15},
  [4584] = {.lex_state = 45},
  [4585] = {.lex_state = 45},
  [4586] = {.lex_state = 45},
  [4587] = {.lex_state = 45},
  [4588] = {.lex_state = 45},
  [4589] = {.lex_state = 45},
  [4590] = {.lex_state = 45},
  [4591] = {.lex_state = 45},
  [4592] = {.lex_state = 45},
  [4593] = {.lex_state = 45},
  [4594] = {.lex_state = 15},
  [4595] = {.lex_state = 45},
  [4596] = {.lex_state = 45},
  [4597] = {.lex_state = 45},
  [4598] = {.lex_state = 45},
  [4599] = {.lex_state = 45},
  [4600] = {.lex_state = 45},
  [4601] = {.lex_state = 45},
  [4602] = {.lex_state = 45},
  [4603] = {.lex_state = 45},
  [4604] = {.lex_state = 45},
  [4605] = {.lex_state = 45},
  [4606] = {.lex_state = 45},
  [4607] = {.lex_state = 45},
  [4608] = {.lex_state = 45},
  [4609] = {.lex_state = 0},
  [4610] = {.lex_state = 5},
  [4611] = {.lex_state = 0},
  [4612] = {.lex_state = 0},
  [4613] = {.lex_state = 5},
  [4614] = {.lex_state = 5},
  [4615] = {.lex_state = 0},
  [4616] = {.lex_state = 5},
  [4617] = {.lex_state = 45},
  [4618] = {.lex_state = 45},
  [4619] = {.lex_state = 5},
  [4620] = {.lex_state = 5},
  [4621] = {.lex_state = 5},
  [4622] = {.lex_state = 5},
  [4623] = {.lex_state = 5},
  [4624] = {.lex_state = 5},
  [4625] = {.lex_state = 45},
  [4626] = {.lex_state = 5},
  [4627] = {.lex_state = 5},
  [4628] = {.lex_state = 5},
  [4629] = {.lex_state = 5},
  [4630] = {.lex_state = 5},
  [4631] = {.lex_state = 5},
  [4632] = {.lex_state = 45},
  [4633] = {.lex_state = 45},
  [4634] = {.lex_state = 5},
  [4635] = {.lex_state = 5},
  [4636] = {.lex_state = 45},
  [4637] = {.lex_state = 5},
  [4638] = {.lex_state = 5},
  [4639] = {.lex_state = 45},
  [4640] = {.lex_state = 0},
  [4641] = {.lex_state = 45},
  [4642] = {.lex_state = 45},
  [4643] = {.lex_state = 5},
  [4644] = {.lex_state = 0},
  [4645] = {.lex_state = 0},
  [4646] = {.lex_state = 5},
  [4647] = {.lex_state = 5},
  [4648] = {.lex_state = 45},
  [4649] = {.lex_state = 5},
  [4650] = {.lex_state = 5},
  [4651] = {.lex_state = 45},
  [4652] = {.lex_state = 0},
  [4653] = {.lex_state = 5},
  [4654] = {.lex_state = 0},
  [4655] = {.lex_state = 0},
  [4656] = {.lex_state = 0},
  [4657] = {.lex_state = 0},
  [4658] = {.lex_state = 0},
  [4659] = {.lex_state = 0},
  [4660] = {.lex_state = 0},
  [4661] = {.lex_state = 0},
  [4662] = {.lex_state = 0},
  [4663] = {.lex_state = 45},
  [4664] = {.lex_state = 0},
  [4665] = {.lex_state = 0},
  [4666] = {.lex_state = 45},
  [4667] = {.lex_state = 0},
  [4668] = {.lex_state = 0},
  [4669] = {.lex_state = 0},
  [4670] = {.lex_state = 0},
  [4671] = {.lex_state = 0},
  [4672] = {.lex_state = 0},
  [4673] = {.lex_state = 5},
  [4674] = {.lex_state = 0},
  [4675] = {.lex_state = 0},
  [4676] = {.lex_state = 0},
  [4677] = {.lex_state = 0},
  [4678] = {.lex_state = 0},
  [4679] = {.lex_state = 0},
  [4680] = {.lex_state = 0},
  [4681] = {.lex_state = 5},
  [4682] = {.lex_state = 45},
  [4683] = {.lex_state = 0},
  [4684] = {.lex_state = 0},
  [4685] = {.lex_state = 5},
  [4686] = {.lex_state = 0},
  [4687] = {.lex_state = 0},
  [4688] = {.lex_state = 0},
  [4689] = {.lex_state = 45},
  [4690] = {.lex_state = 0},
  [4691] = {.lex_state = 0},
  [4692] = {.lex_state = 0},
  [4693] = {.lex_state = 0},
  [4694] = {.lex_state = 0},
  [4695] = {.lex_state = 45},
  [4696] = {.lex_state = 0},
  [4697] = {.lex_state = 0},
  [4698] = {.lex_state = 45},
  [4699] = {.lex_state = 0},
  [4700] = {.lex_state = 0},
  [4701] = {.lex_state = 0},
  [4702] = {.lex_state = 45},
  [4703] = {.lex_state = 0},
  [4704] = {.lex_state = 45},
  [4705] = {.lex_state = 0},
  [4706] = {.lex_state = 45},
  [4707] = {.lex_state = 45},
  [4708] = {.lex_state = 5},
  [4709] = {.lex_state = 0},
  [4710] = {.lex_state = 0},
  [4711] = {.lex_state = 45},
  [4712] = {.lex_state = 5},
  [4713] = {.lex_state = 0},
  [4714] = {.lex_state = 45},
  [4715] = {.lex_state = 5},
  [4716] = {.lex_state = 0},
  [4717] = {.lex_state = 45},
  [4718] = {.lex_state = 45},
  [4719] = {.lex_state = 0},
  [4720] = {.lex_state = 45},
  [4721] = {.lex_state = 0},
  [4722] = {.lex_state = 45},
  [4723] = {.lex_state = 0},
  [4724] = {.lex_state = 45},
  [4725] = {.lex_state = 0},
  [4726] = {.lex_state = 0},
  [4727] = {.lex_state = 45},
  [4728] = {.lex_state = 0},
  [4729] = {.lex_state = 45},
  [4730] = {.lex_state = 0},
  [4731] = {.lex_state = 0},
  [4732] = {.lex_state = 45},
  [4733] = {.lex_state = 45},
  [4734] = {.lex_state = 0},
  [4735] = {.lex_state = 0},
  [4736] = {.lex_state = 45},
  [4737] = {.lex_state = 45},
  [4738] = {.lex_state = 0},
  [4739] = {.lex_state = 45},
  [4740] = {.lex_state = 45},
  [4741] = {.lex_state = 45},
  [4742] = {.lex_state = 0},
  [4743] = {.lex_state = 45},
  [4744] = {.lex_state = 45},
  [4745] = {.lex_state = 45},
  [4746] = {.lex_state = 45},
  [4747] = {.lex_state = 0},
  [4748] = {.lex_state = 0},
  [4749] = {.lex_state = 45},
  [4750] = {.lex_state = 45},
  [4751] = {.lex_state = 45},
  [4752] = {.lex_state = 0},
  [4753] = {.lex_state = 0},
  [4754] = {.lex_state = 45},
  [4755] = {.lex_state = 0},
  [4756] = {.lex_state = 0},
  [4757] = {.lex_state = 0},
  [4758] = {.lex_state = 0},
  [4759] = {.lex_state = 0},
  [4760] = {.lex_state = 45},
  [4761] = {.lex_state = 0},
  [4762] = {.lex_state = 0},
  [4763] = {.lex_state = 0},
  [4764] = {.lex_state = 45},
  [4765] = {.lex_state = 45},
  [4766] = {.lex_state = 45},
  [4767] = {.lex_state = 0},
  [4768] = {.lex_state = 0},
  [4769] = {.lex_state = 45},
  [4770] = {.lex_state = 45},
  [4771] = {.lex_state = 45},
  [4772] = {.lex_state = 0},
  [4773] = {.lex_state = 0},
  [4774] = {.lex_state = 45},
  [4775] = {.lex_state = 0},
  [4776] = {.lex_state = 0},
  [4777] = {.lex_state = 45},
  [4778] = {.lex_state = 0},
  [4779] = {.lex_state = 0},
  [4780] = {.lex_state = 45},
  [4781] = {.lex_state = 45},
  [4782] = {.lex_state = 0},
  [4783] = {.lex_state = 45},
  [4784] = {.lex_state = 45},
  [4785] = {.lex_state = 45},
  [4786] = {.lex_state = 0},
  [4787] = {.lex_state = 45},
  [4788] = {.lex_state = 0},
  [4789] = {.lex_state = 45},
  [4790] = {.lex_state = 0},
  [4791] = {.lex_state = 45},
  [4792] = {.lex_state = 0},
  [4793] = {.lex_state = 45},
  [4794] = {.lex_state = 45},
  [4795] = {.lex_state = 45},
  [4796] = {.lex_state = 45},
  [4797] = {.lex_state = 45},
  [4798] = {.lex_state = 45},
  [4799] = {.lex_state = 0},
  [4800] = {.lex_state = 45},
  [4801] = {.lex_state = 45},
  [4802] = {.lex_state = 0},
  [4803] = {.lex_state = 0},
  [4804] = {.lex_state = 0},
  [4805] = {.lex_state = 45},
  [4806] = {.lex_state = 0},
  [4807] = {.lex_state = 0},
  [4808] = {.lex_state = 45},
  [4809] = {.lex_state = 45},
  [4810] = {.lex_state = 45},
  [4811] = {.lex_state = 45},
  [4812] = {.lex_state = 45},
  [4813] = {.lex_state = 0},
  [4814] = {.lex_state = 45},
  [4815] = {.lex_state = 0},
  [4816] = {.lex_state = 0},
  [4817] = {.lex_state = 0},
  [4818] = {.lex_state = 0},
  [4819] = {.lex_state = 45},
  [4820] = {.lex_state = 45},
  [4821] = {.lex_state = 45},
  [4822] = {.lex_state = 0},
  [4823] = {.lex_state = 45},
  [4824] = {.lex_state = 0},
  [4825] = {.lex_state = 45},
  [4826] = {.lex_state = 45},
  [4827] = {.lex_state = 45},
  [4828] = {.lex_state = 0},
  [4829] = {.lex_state = 0},
  [4830] = {.lex_state = 0},
  [4831] = {.lex_state = 0},
  [4832] = {.lex_state = 0},
  [4833] = {.lex_state = 0},
  [4834] = {.lex_state = 0},
  [4835] = {.lex_state = 0},
  [4836] = {.lex_state = 0},
  [4837] = {.lex_state = 0},
  [4838] = {.lex_state = 0},
  [4839] = {.lex_state = 0},
  [4840] = {.lex_state = 45},
  [4841] = {.lex_state = 0},
  [4842] = {.lex_state = 45},
  [4843] = {.lex_state = 0},
  [4844] = {.lex_state = 0},
  [4845] = {.lex_state = 0},
  [4846] = {.lex_state = 0},
  [4847] = {.lex_state = 0},
  [4848] = {.lex_state = 0},
  [4849] = {.lex_state = 45},
  [4850] = {.lex_state = 45},
  [4851] = {.lex_state = 45},
  [4852] = {.lex_state = 0},
  [4853] = {.lex_state = 0},
  [4854] = {.lex_state = 0},
  [4855] = {.lex_state = 0},
  [4856] = {.lex_state = 0},
  [4857] = {.lex_state = 0},
  [4858] = {.lex_state = 0},
  [4859] = {.lex_state = 0},
  [4860] = {.lex_state = 45},
  [4861] = {.lex_state = 45},
  [4862] = {.lex_state = 0},
  [4863] = {.lex_state = 0},
  [4864] = {.lex_state = 45},
  [4865] = {.lex_state = 45},
  [4866] = {.lex_state = 0},
  [4867] = {.lex_state = 45},
  [4868] = {.lex_state = 0},
  [4869] = {.lex_state = 0},
  [4870] = {.lex_state = 45},
  [4871] = {.lex_state = 0},
  [4872] = {.lex_state = 0},
  [4873] = {.lex_state = 0},
  [4874] = {.lex_state = 0},
  [4875] = {.lex_state = 45},
  [4876] = {.lex_state = 0},
  [4877] = {.lex_state = 0},
  [4878] = {.lex_state = 45},
  [4879] = {.lex_state = 0},
  [4880] = {.lex_state = 0},
  [4881] = {.lex_state = 0},
  [4882] = {.lex_state = 0},
  [4883] = {.lex_state = 0},
  [4884] = {.lex_state = 0},
  [4885] = {.lex_state = 0},
  [4886] = {.lex_state = 0},
  [4887] = {.lex_state = 0},
  [4888] = {.lex_state = 0},
  [4889] = {.lex_state = 0},
  [4890] = {.lex_state = 0},
  [4891] = {.lex_state = 0},
  [4892] = {.lex_state = 0},
  [4893] = {.lex_state = 0},
  [4894] = {.lex_state = 0},
  [4895] = {.lex_state = 0},
  [4896] = {.lex_state = 0},
  [4897] = {.lex_state = 0},
  [4898] = {.lex_state = 0},
  [4899] = {.lex_state = 45},
  [4900] = {.lex_state = 0},
  [4901] = {.lex_state = 45},
  [4902] = {.lex_state = 45},
  [4903] = {.lex_state = 0},
  [4904] = {.lex_state = 0},
  [4905] = {.lex_state = 0},
  [4906] = {.lex_state = 0},
  [4907] = {.lex_state = 0},
  [4908] = {.lex_state = 0},
  [4909] = {.lex_state = 0},
  [4910] = {.lex_state = 0},
  [4911] = {.lex_state = 0},
  [4912] = {.lex_state = 0},
  [4913] = {.lex_state = 0},
  [4914] = {.lex_state = 0},
  [4915] = {.lex_state = 0},
  [4916] = {.lex_state = 0},
  [4917] = {.lex_state = 0},
  [4918] = {.lex_state = 0},
  [4919] = {.lex_state = 0},
  [4920] = {.lex_state = 0},
  [4921] = {.lex_state = 0},
  [4922] = {.lex_state = 0},
  [4923] = {.lex_state = 0},
  [4924] = {.lex_state = 0},
  [4925] = {.lex_state = 45},
  [4926] = {.lex_state = 0},
  [4927] = {.lex_state = 0},
  [4928] = {.lex_state = 45},
  [4929] = {.lex_state = 0},
  [4930] = {.lex_state = 45},
  [4931] = {.lex_state = 0},
  [4932] = {.lex_state = 45},
  [4933] = {.lex_state = 0},
  [4934] = {.lex_state = 0},
  [4935] = {.lex_state = 0},
  [4936] = {.lex_state = 45},
  [4937] = {.lex_state = 0},
  [4938] = {.lex_state = 0},
  [4939] = {.lex_state = 0},
  [4940] = {.lex_state = 0},
  [4941] = {.lex_state = 0},
  [4942] = {.lex_state = 0},
  [4943] = {.lex_state = 0},
  [4944] = {.lex_state = 0},
  [4945] = {.lex_state = 45},
  [4946] = {.lex_state = 45},
  [4947] = {.lex_state = 0},
  [4948] = {.lex_state = 0},
  [4949] = {.lex_state = 0},
  [4950] = {.lex_state = 0},
  [4951] = {.lex_state = 0},
  [4952] = {.lex_state = 0},
  [4953] = {.lex_state = 0},
  [4954] = {.lex_state = 0},
  [4955] = {.lex_state = 0},
  [4956] = {.lex_state = 0},
  [4957] = {.lex_state = 0},
  [4958] = {.lex_state = 0},
  [4959] = {.lex_state = 0},
  [4960] = {.lex_state = 0},
  [4961] = {.lex_state = 0},
  [4962] = {.lex_state = 0},
  [4963] = {.lex_state = 0},
  [4964] = {.lex_state = 0},
  [4965] = {.lex_state = 0},
  [4966] = {.lex_state = 0},
  [4967] = {.lex_state = 0},
  [4968] = {.lex_state = 45},
  [4969] = {.lex_state = 0},
  [4970] = {.lex_state = 0},
  [4971] = {.lex_state = 0},
  [4972] = {.lex_state = 0},
  [4973] = {.lex_state = 0},
  [4974] = {.lex_state = 0},
  [4975] = {.lex_state = 0},
  [4976] = {.lex_state = 0},
  [4977] = {.lex_state = 0},
  [4978] = {.lex_state = 0},
  [4979] = {.lex_state = 0},
  [4980] = {.lex_state = 0},
  [4981] = {.lex_state = 0},
  [4982] = {.lex_state = 0},
  [4983] = {.lex_state = 0},
  [4984] = {.lex_state = 0},
  [4985] = {.lex_state = 0},
  [4986] = {.lex_state = 0},
  [4987] = {.lex_state = 0},
  [4988] = {.lex_state = 0},
  [4989] = {.lex_state = 0},
  [4990] = {.lex_state = 0},
  [4991] = {.lex_state = 0},
  [4992] = {.lex_state = 0},
  [4993] = {.lex_state = 0},
  [4994] = {.lex_state = 3, .external_lex_state = 1},
  [4995] = {.lex_state = 0},
  [4996] = {.lex_state = 0},
  [4997] = {.lex_state = 0},
  [4998] = {.lex_state = 0},
  [4999] = {.lex_state = 0},
  [5000] = {.lex_state = 0},
  [5001] = {.lex_state = 0},
  [5002] = {.lex_state = 0},
  [5003] = {.lex_state = 0},
  [5004] = {.lex_state = 0},
  [5005] = {.lex_state = 0},
  [5006] = {.lex_state = 0},
  [5007] = {.lex_state = 0},
  [5008] = {.lex_state = 0},
  [5009] = {.lex_state = 0},
  [5010] = {.lex_state = 0},
  [5011] = {.lex_state = 0},
  [5012] = {.lex_state = 0},
  [5013] = {.lex_state = 0},
  [5014] = {.lex_state = 0},
  [5015] = {.lex_state = 0},
  [5016] = {.lex_state = 0},
  [5017] = {.lex_state = 0},
  [5018] = {.lex_state = 0},
  [5019] = {.lex_state = 0},
  [5020] = {.lex_state = 0},
  [5021] = {.lex_state = 0},
  [5022] = {.lex_state = 0},
  [5023] = {.lex_state = 45},
  [5024] = {.lex_state = 0},
  [5025] = {.lex_state = 0},
  [5026] = {.lex_state = 0},
  [5027] = {.lex_state = 0},
  [5028] = {.lex_state = 0},
  [5029] = {.lex_state = 0},
  [5030] = {.lex_state = 0},
  [5031] = {.lex_state = 0},
  [5032] = {.lex_state = 0},
  [5033] = {.lex_state = 0},
  [5034] = {.lex_state = 0},
  [5035] = {.lex_state = 0},
  [5036] = {.lex_state = 0},
  [5037] = {.lex_state = 0},
  [5038] = {.lex_state = 0},
  [5039] = {.lex_state = 0},
  [5040] = {.lex_state = 0},
  [5041] = {.lex_state = 0},
  [5042] = {.lex_state = 0},
  [5043] = {.lex_state = 0},
  [5044] = {.lex_state = 0},
  [5045] = {.lex_state = 0},
  [5046] = {.lex_state = 0},
  [5047] = {.lex_state = 0},
  [5048] = {.lex_state = 0},
  [5049] = {.lex_state = 0},
  [5050] = {.lex_state = 0},
  [5051] = {.lex_state = 0},
  [5052] = {.lex_state = 0},
  [5053] = {.lex_state = 0},
  [5054] = {.lex_state = 0},
  [5055] = {.lex_state = 0},
  [5056] = {.lex_state = 0},
  [5057] = {.lex_state = 0},
  [5058] = {.lex_state = 0},
  [5059] = {.lex_state = 0},
  [5060] = {.lex_state = 0},
  [5061] = {.lex_state = 0},
  [5062] = {.lex_state = 0},
  [5063] = {.lex_state = 0},
  [5064] = {.lex_state = 0},
  [5065] = {.lex_state = 0},
  [5066] = {.lex_state = 0},
  [5067] = {.lex_state = 0},
  [5068] = {.lex_state = 0},
  [5069] = {.lex_state = 0},
  [5070] = {.lex_state = 0},
  [5071] = {.lex_state = 0},
  [5072] = {.lex_state = 0},
  [5073] = {.lex_state = 0},
  [5074] = {.lex_state = 0},
  [5075] = {.lex_state = 0},
  [5076] = {.lex_state = 0},
  [5077] = {.lex_state = 0},
  [5078] = {.lex_state = 0},
  [5079] = {.lex_state = 0},
  [5080] = {.lex_state = 0},
  [5081] = {.lex_state = 0},
  [5082] = {.lex_state = 0},
  [5083] = {.lex_state = 0},
  [5084] = {.lex_state = 0},
  [5085] = {.lex_state = 0},
  [5086] = {.lex_state = 0},
  [5087] = {.lex_state = 0},
  [5088] = {.lex_state = 0},
  [5089] = {.lex_state = 0},
  [5090] = {.lex_state = 0},
  [5091] = {.lex_state = 0},
  [5092] = {.lex_state = 0},
  [5093] = {.lex_state = 0},
  [5094] = {.lex_state = 0},
  [5095] = {.lex_state = 0},
  [5096] = {.lex_state = 0},
  [5097] = {.lex_state = 0},
  [5098] = {.lex_state = 0},
  [5099] = {.lex_state = 3},
  [5100] = {.lex_state = 0},
  [5101] = {.lex_state = 0},
  [5102] = {.lex_state = 0},
  [5103] = {.lex_state = 0},
  [5104] = {.lex_state = 0},
  [5105] = {.lex_state = 0},
  [5106] = {.lex_state = 0},
  [5107] = {.lex_state = 0},
  [5108] = {.lex_state = 0},
  [5109] = {.lex_state = 0},
  [5110] = {.lex_state = 0},
  [5111] = {.lex_state = 0},
  [5112] = {.lex_state = 0},
  [5113] = {.lex_state = 0},
  [5114] = {.lex_state = 0},
  [5115] = {.lex_state = 0},
  [5116] = {.lex_state = 0},
  [5117] = {.lex_state = 0},
  [5118] = {.lex_state = 0},
  [5119] = {.lex_state = 0},
  [5120] = {.lex_state = 0},
  [5121] = {.lex_state = 0},
  [5122] = {.lex_state = 0},
  [5123] = {.lex_state = 0},
  [5124] = {.lex_state = 0},
  [5125] = {.lex_state = 0},
  [5126] = {.lex_state = 0},
  [5127] = {.lex_state = 0},
  [5128] = {.lex_state = 0},
  [5129] = {.lex_state = 0},
  [5130] = {.lex_state = 0},
  [5131] = {.lex_state = 0},
  [5132] = {.lex_state = 0},
  [5133] = {.lex_state = 0},
  [5134] = {.lex_state = 0},
  [5135] = {.lex_state = 0},
  [5136] = {.lex_state = 0},
  [5137] = {.lex_state = 0},
  [5138] = {.lex_state = 0},
  [5139] = {.lex_state = 0},
  [5140] = {.lex_state = 0},
  [5141] = {.lex_state = 0},
  [5142] = {.lex_state = 0},
  [5143] = {.lex_state = 0},
  [5144] = {.lex_state = 0},
  [5145] = {.lex_state = 0},
  [5146] = {.lex_state = 0},
  [5147] = {.lex_state = 0},
  [5148] = {.lex_state = 0},
  [5149] = {.lex_state = 0},
  [5150] = {.lex_state = 0},
  [5151] = {.lex_state = 0},
  [5152] = {.lex_state = 0},
  [5153] = {.lex_state = 0},
  [5154] = {.lex_state = 0},
  [5155] = {.lex_state = 0},
  [5156] = {.lex_state = 0},
  [5157] = {.lex_state = 0},
  [5158] = {.lex_state = 0},
  [5159] = {.lex_state = 0},
  [5160] = {.lex_state = 0},
  [5161] = {.lex_state = 0},
  [5162] = {.lex_state = 0},
  [5163] = {.lex_state = 0},
  [5164] = {.lex_state = 0},
  [5165] = {.lex_state = 0},
  [5166] = {.lex_state = 0},
  [5167] = {.lex_state = 0},
  [5168] = {.lex_state = 0},
  [5169] = {.lex_state = 0},
  [5170] = {.lex_state = 0},
  [5171] = {.lex_state = 0},
  [5172] = {.lex_state = 0},
  [5173] = {.lex_state = 0},
  [5174] = {.lex_state = 0},
  [5175] = {.lex_state = 0},
  [5176] = {.lex_state = 0},
  [5177] = {.lex_state = 0},
  [5178] = {.lex_state = 0},
  [5179] = {.lex_state = 0},
  [5180] = {.lex_state = 0},
  [5181] = {.lex_state = 0},
  [5182] = {.lex_state = 0},
  [5183] = {.lex_state = 0},
  [5184] = {.lex_state = 0},
  [5185] = {.lex_state = 0},
  [5186] = {.lex_state = 0},
  [5187] = {.lex_state = 0},
  [5188] = {.lex_state = 0},
  [5189] = {.lex_state = 0},
  [5190] = {.lex_state = 0},
  [5191] = {.lex_state = 0},
  [5192] = {.lex_state = 0},
  [5193] = {.lex_state = 0},
  [5194] = {.lex_state = 0},
  [5195] = {.lex_state = 0},
  [5196] = {.lex_state = 0},
  [5197] = {.lex_state = 0},
  [5198] = {.lex_state = 0},
  [5199] = {.lex_state = 0},
  [5200] = {.lex_state = 0},
  [5201] = {.lex_state = 0},
  [5202] = {.lex_state = 0},
  [5203] = {.lex_state = 0},
  [5204] = {.lex_state = 0},
  [5205] = {.lex_state = 0},
  [5206] = {.lex_state = 0},
  [5207] = {.lex_state = 0},
  [5208] = {.lex_state = 0},
  [5209] = {.lex_state = 0},
  [5210] = {.lex_state = 0},
  [5211] = {.lex_state = 0},
  [5212] = {.lex_state = 0},
  [5213] = {.lex_state = 0},
  [5214] = {.lex_state = 0},
  [5215] = {.lex_state = 0},
  [5216] = {.lex_state = 0},
  [5217] = {.lex_state = 0},
  [5218] = {.lex_state = 0},
  [5219] = {.lex_state = 0},
  [5220] = {.lex_state = 0},
  [5221] = {.lex_state = 0},
  [5222] = {.lex_state = 0},
  [5223] = {.lex_state = 0},
  [5224] = {.lex_state = 0},
  [5225] = {.lex_state = 0},
  [5226] = {.lex_state = 0},
  [5227] = {.lex_state = 0},
  [5228] = {.lex_state = 0},
  [5229] = {.lex_state = 0},
  [5230] = {.lex_state = 0},
  [5231] = {.lex_state = 0},
  [5232] = {.lex_state = 0},
  [5233] = {.lex_state = 0},
  [5234] = {.lex_state = 0},
  [5235] = {.lex_state = 0},
  [5236] = {.lex_state = 0},
  [5237] = {.lex_state = 0},
  [5238] = {.lex_state = 0},
  [5239] = {.lex_state = 0},
  [5240] = {.lex_state = 0},
  [5241] = {.lex_state = 0},
  [5242] = {.lex_state = 0},
  [5243] = {.lex_state = 0},
  [5244] = {.lex_state = 0},
  [5245] = {.lex_state = 0},
  [5246] = {.lex_state = 0},
  [5247] = {.lex_state = 0},
  [5248] = {.lex_state = 0},
  [5249] = {.lex_state = 0},
  [5250] = {.lex_state = 0},
  [5251] = {.lex_state = 0},
  [5252] = {.lex_state = 0},
  [5253] = {.lex_state = 0},
  [5254] = {.lex_state = 0},
  [5255] = {.lex_state = 0},
  [5256] = {.lex_state = 0},
  [5257] = {.lex_state = 0},
  [5258] = {.lex_state = 0},
  [5259] = {.lex_state = 0},
  [5260] = {.lex_state = 0},
  [5261] = {.lex_state = 0},
  [5262] = {.lex_state = 0},
  [5263] = {.lex_state = 0},
  [5264] = {.lex_state = 0},
  [5265] = {.lex_state = 0},
  [5266] = {.lex_state = 0},
  [5267] = {.lex_state = 0},
  [5268] = {.lex_state = 0},
  [5269] = {.lex_state = 0},
  [5270] = {.lex_state = 0},
  [5271] = {.lex_state = 0},
  [5272] = {.lex_state = 0},
  [5273] = {.lex_state = 0},
  [5274] = {.lex_state = 0},
  [5275] = {.lex_state = 0},
  [5276] = {.lex_state = 0},
  [5277] = {.lex_state = 0},
  [5278] = {.lex_state = 0},
  [5279] = {.lex_state = 0},
  [5280] = {.lex_state = 0},
  [5281] = {.lex_state = 0},
  [5282] = {.lex_state = 0},
  [5283] = {.lex_state = 0},
  [5284] = {.lex_state = 0},
  [5285] = {.lex_state = 0},
  [5286] = {.lex_state = 0},
  [5287] = {.lex_state = 0},
  [5288] = {.lex_state = 0},
  [5289] = {.lex_state = 0},
  [5290] = {.lex_state = 0},
  [5291] = {.lex_state = 0},
  [5292] = {.lex_state = 0},
  [5293] = {.lex_state = 0},
  [5294] = {.lex_state = 0},
  [5295] = {.lex_state = 0},
  [5296] = {.lex_state = 0},
  [5297] = {.lex_state = 0},
  [5298] = {.lex_state = 0},
  [5299] = {.lex_state = 0},
  [5300] = {.lex_state = 0},
  [5301] = {.lex_state = 0},
  [5302] = {.lex_state = 0},
  [5303] = {.lex_state = 0},
  [5304] = {.lex_state = 0},
  [5305] = {.lex_state = 0},
  [5306] = {.lex_state = 0},
  [5307] = {.lex_state = 0},
  [5308] = {.lex_state = 0},
  [5309] = {.lex_state = 0},
  [5310] = {.lex_state = 0},
  [5311] = {.lex_state = 0},
  [5312] = {.lex_state = 0},
  [5313] = {.lex_state = 0},
  [5314] = {.lex_state = 0},
  [5315] = {.lex_state = 0},
  [5316] = {.lex_state = 0},
  [5317] = {.lex_state = 0},
  [5318] = {.lex_state = 0},
  [5319] = {.lex_state = 0},
  [5320] = {.lex_state = 0},
  [5321] = {.lex_state = 0},
  [5322] = {.lex_state = 0},
  [5323] = {.lex_state = 0},
  [5324] = {.lex_state = 0},
  [5325] = {.lex_state = 0},
  [5326] = {.lex_state = 0},
  [5327] = {.lex_state = 0},
  [5328] = {.lex_state = 0},
  [5329] = {.lex_state = 0},
  [5330] = {.lex_state = 0},
  [5331] = {.lex_state = 0},
  [5332] = {.lex_state = 0},
  [5333] = {.lex_state = 0},
  [5334] = {.lex_state = 0},
  [5335] = {.lex_state = 0},
  [5336] = {.lex_state = 0},
  [5337] = {.lex_state = 0},
  [5338] = {.lex_state = 0},
  [5339] = {.lex_state = 0},
  [5340] = {.lex_state = 0},
  [5341] = {.lex_state = 0},
  [5342] = {.lex_state = 0},
  [5343] = {.lex_state = 0},
  [5344] = {.lex_state = 0},
  [5345] = {.lex_state = 0},
  [5346] = {.lex_state = 0},
  [5347] = {.lex_state = 0},
  [5348] = {.lex_state = 0},
  [5349] = {.lex_state = 0},
  [5350] = {.lex_state = 0},
  [5351] = {.lex_state = 0},
  [5352] = {.lex_state = 0},
  [5353] = {.lex_state = 0},
  [5354] = {.lex_state = 0},
  [5355] = {.lex_state = 0},
  [5356] = {.lex_state = 0},
  [5357] = {.lex_state = 0},
  [5358] = {.lex_state = 0},
  [5359] = {.lex_state = 0},
  [5360] = {.lex_state = 0},
  [5361] = {.lex_state = 0},
  [5362] = {.lex_state = 0},
  [5363] = {.lex_state = 0},
  [5364] = {.lex_state = 0},
  [5365] = {.lex_state = 0},
  [5366] = {.lex_state = 0},
  [5367] = {.lex_state = 0},
  [5368] = {.lex_state = 0},
  [5369] = {.lex_state = 0},
  [5370] = {.lex_state = 0},
  [5371] = {.lex_state = 0},
  [5372] = {.lex_state = 0},
  [5373] = {.lex_state = 0},
  [5374] = {.lex_state = 0},
  [5375] = {.lex_state = 0},
  [5376] = {.lex_state = 0},
  [5377] = {.lex_state = 0},
  [5378] = {.lex_state = 0},
  [5379] = {.lex_state = 0},
  [5380] = {.lex_state = 0},
  [5381] = {.lex_state = 0},
  [5382] = {.lex_state = 0},
  [5383] = {.lex_state = 0},
  [5384] = {.lex_state = 0},
  [5385] = {.lex_state = 0},
  [5386] = {.lex_state = 0},
  [5387] = {.lex_state = 0},
  [5388] = {.lex_state = 0},
  [5389] = {.lex_state = 0},
  [5390] = {.lex_state = 0},
  [5391] = {.lex_state = 0},
  [5392] = {.lex_state = 0},
  [5393] = {.lex_state = 0},
  [5394] = {.lex_state = 0},
  [5395] = {.lex_state = 0},
  [5396] = {.lex_state = 0},
  [5397] = {.lex_state = 0},
  [5398] = {.lex_state = 0},
  [5399] = {.lex_state = 0},
  [5400] = {.lex_state = 0},
  [5401] = {.lex_state = 0},
  [5402] = {.lex_state = 0},
  [5403] = {.lex_state = 0},
  [5404] = {.lex_state = 0},
  [5405] = {.lex_state = 0},
  [5406] = {.lex_state = 0},
  [5407] = {.lex_state = 0},
  [5408] = {.lex_state = 0},
  [5409] = {.lex_state = 0},
  [5410] = {.lex_state = 0},
  [5411] = {.lex_state = 0},
  [5412] = {.lex_state = 0},
  [5413] = {.lex_state = 0},
  [5414] = {.lex_state = 0},
  [5415] = {.lex_state = 0},
  [5416] = {.lex_state = 0},
  [5417] = {.lex_state = 0},
  [5418] = {.lex_state = 0},
  [5419] = {.lex_state = 0},
  [5420] = {.lex_state = 0},
  [5421] = {.lex_state = 0},
  [5422] = {.lex_state = 0},
  [5423] = {.lex_state = 0},
  [5424] = {.lex_state = 0},
  [5425] = {.lex_state = 0},
  [5426] = {.lex_state = 0},
  [5427] = {.lex_state = 0},
  [5428] = {.lex_state = 0},
  [5429] = {.lex_state = 0},
  [5430] = {.lex_state = 0},
  [5431] = {.lex_state = 0},
  [5432] = {.lex_state = 4},
  [5433] = {.lex_state = 4},
  [5434] = {.lex_state = 4},
  [5435] = {.lex_state = 0},
  [5436] = {.lex_state = 0},
  [5437] = {.lex_state = 0},
  [5438] = {.lex_state = 0},
  [5439] = {.lex_state = 0},
  [5440] = {.lex_state = 0},
  [5441] = {.lex_state = 0},
  [5442] = {.lex_state = 0},
  [5443] = {.lex_state = 0},
  [5444] = {.lex_state = 0},
  [5445] = {.lex_state = 0},
  [5446] = {.lex_state = 0},
  [5447] = {.lex_state = 0},
  [5448] = {.lex_state = 0},
  [5449] = {.lex_state = 0},
  [5450] = {.lex_state = 0},
  [5451] = {.lex_state = 0},
  [5452] = {.lex_state = 0},
  [5453] = {.lex_state = 0},
  [5454] = {.lex_state = 0},
  [5455] = {.lex_state = 0},
  [5456] = {.lex_state = 0},
  [5457] = {.lex_state = 0},
  [5458] = {.lex_state = 0},
  [5459] = {.lex_state = 0},
  [5460] = {.lex_state = 0},
  [5461] = {.lex_state = 0},
  [5462] = {.lex_state = 0},
  [5463] = {.lex_state = 0},
  [5464] = {.lex_state = 0},
  [5465] = {.lex_state = 0},
  [5466] = {.lex_state = 0},
  [5467] = {.lex_state = 0},
  [5468] = {.lex_state = 0},
  [5469] = {.lex_state = 0},
  [5470] = {.lex_state = 0},
  [5471] = {.lex_state = 0},
  [5472] = {.lex_state = 0},
  [5473] = {.lex_state = 0},
  [5474] = {.lex_state = 0},
  [5475] = {.lex_state = 0},
  [5476] = {.lex_state = 0},
  [5477] = {.lex_state = 0},
  [5478] = {.lex_state = 0},
  [5479] = {.lex_state = 0},
  [5480] = {.lex_state = 0},
  [5481] = {.lex_state = 0},
  [5482] = {.lex_state = 0},
  [5483] = {.lex_state = 0},
  [5484] = {.lex_state = 0},
  [5485] = {.lex_state = 0},
  [5486] = {.lex_state = 0},
  [5487] = {.lex_state = 0},
  [5488] = {.lex_state = 0},
  [5489] = {.lex_state = 0},
  [5490] = {.lex_state = 0},
  [5491] = {.lex_state = 0},
  [5492] = {.lex_state = 0},
  [5493] = {.lex_state = 0},
  [5494] = {.lex_state = 0},
  [5495] = {.lex_state = 0},
  [5496] = {.lex_state = 0},
  [5497] = {.lex_state = 0},
  [5498] = {.lex_state = 0},
  [5499] = {.lex_state = 0},
  [5500] = {.lex_state = 0},
  [5501] = {.lex_state = 0},
  [5502] = {.lex_state = 0},
  [5503] = {.lex_state = 0},
  [5504] = {.lex_state = 3},
  [5505] = {.lex_state = 0},
  [5506] = {.lex_state = 0},
  [5507] = {.lex_state = 0},
  [5508] = {.lex_state = 0},
  [5509] = {.lex_state = 0},
  [5510] = {.lex_state = 0},
  [5511] = {.lex_state = 0},
  [5512] = {.lex_state = 0},
  [5513] = {.lex_state = 0},
  [5514] = {.lex_state = 0},
  [5515] = {.lex_state = 0},
  [5516] = {.lex_state = 0},
  [5517] = {.lex_state = 3},
  [5518] = {.lex_state = 3},
  [5519] = {.lex_state = 0},
  [5520] = {.lex_state = 0},
  [5521] = {.lex_state = 0},
  [5522] = {.lex_state = 0},
  [5523] = {.lex_state = 0},
  [5524] = {.lex_state = 0},
  [5525] = {.lex_state = 0},
  [5526] = {.lex_state = 0},
  [5527] = {.lex_state = 0},
  [5528] = {.lex_state = 0},
  [5529] = {.lex_state = 0},
  [5530] = {.lex_state = 0},
  [5531] = {.lex_state = 0},
  [5532] = {.lex_state = 0},
  [5533] = {.lex_state = 0},
  [5534] = {.lex_state = 0},
  [5535] = {.lex_state = 0},
  [5536] = {.lex_state = 0},
  [5537] = {.lex_state = 0},
  [5538] = {.lex_state = 0},
  [5539] = {.lex_state = 0},
  [5540] = {.lex_state = 0},
  [5541] = {.lex_state = 45},
  [5542] = {.lex_state = 45},
  [5543] = {.lex_state = 45},
  [5544] = {.lex_state = 45},
  [5545] = {.lex_state = 45},
  [5546] = {.lex_state = 45},
  [5547] = {.lex_state = 45},
  [5548] = {.lex_state = 45},
  [5549] = {.lex_state = 45},
  [5550] = {.lex_state = 45},
  [5551] = {.lex_state = 45},
  [5552] = {.lex_state = 45},
  [5553] = {.lex_state = 3},
  [5554] = {.lex_state = 3},
  [5555] = {.lex_state = 3},
  [5556] = {.lex_state = 45},
  [5557] = {.lex_state = 45},
  [5558] = {.lex_state = 45},
  [5559] = {.lex_state = 45},
  [5560] = {.lex_state = 45},
  [5561] = {.lex_state = 45},
  [5562] = {.lex_state = 45},
  [5563] = {.lex_state = 45},
  [5564] = {.lex_state = 45},
  [5565] = {.lex_state = 45},
  [5566] = {.lex_state = 45},
  [5567] = {.lex_state = 45},
  [5568] = {.lex_state = 5},
  [5569] = {.lex_state = 0},
  [5570] = {.lex_state = 0},
  [5571] = {.lex_state = 0},
  [5572] = {.lex_state = 3},
  [5573] = {.lex_state = 0},
  [5574] = {.lex_state = 6},
  [5575] = {.lex_state = 45},
  [5576] = {.lex_state = 1},
  [5577] = {.lex_state = 6},
  [5578] = {.lex_state = 45},
  [5579] = {.lex_state = 6},
  [5580] = {.lex_state = 45},
  [5581] = {.lex_state = 1},
  [5582] = {.lex_state = 45},
  [5583] = {.lex_state = 45},
  [5584] = {.lex_state = 1},
  [5585] = {.lex_state = 1},
  [5586] = {.lex_state = 6},
  [5587] = {.lex_state = 6},
  [5588] = {.lex_state = 45},
  [5589] = {.lex_state = 45},
  [5590] = {.lex_state = 45},
  [5591] = {.lex_state = 45},
  [5592] = {.lex_state = 45},
  [5593] = {.lex_state = 45},
  [5594] = {.lex_state = 6},
  [5595] = {.lex_state = 45},
  [5596] = {.lex_state = 45},
  [5597] = {.lex_state = 45},
  [5598] = {.lex_state = 45},
  [5599] = {.lex_state = 1},
  [5600] = {.lex_state = 45},
  [5601] = {.lex_state = 45},
  [5602] = {.lex_state = 45},
  [5603] = {.lex_state = 45},
  [5604] = {.lex_state = 0},
  [5605] = {.lex_state = 0},
  [5606] = {.lex_state = 45},
  [5607] = {.lex_state = 45},
  [5608] = {.lex_state = 45},
  [5609] = {.lex_state = 45},
  [5610] = {.lex_state = 45},
  [5611] = {.lex_state = 45},
  [5612] = {.lex_state = 6},
  [5613] = {.lex_state = 6},
  [5614] = {.lex_state = 45},
  [5615] = {.lex_state = 1},
  [5616] = {.lex_state = 45},
  [5617] = {.lex_state = 45},
  [5618] = {.lex_state = 45},
  [5619] = {.lex_state = 45},
  [5620] = {.lex_state = 45},
  [5621] = {.lex_state = 45},
  [5622] = {.lex_state = 45},
  [5623] = {.lex_state = 45},
  [5624] = {.lex_state = 0},
  [5625] = {.lex_state = 45},
  [5626] = {.lex_state = 3},
  [5627] = {.lex_state = 45},
  [5628] = {.lex_state = 45},
  [5629] = {.lex_state = 45},
  [5630] = {.lex_state = 0},
  [5631] = {.lex_state = 45},
  [5632] = {.lex_state = 45},
  [5633] = {.lex_state = 45},
  [5634] = {.lex_state = 45},
  [5635] = {.lex_state = 45},
  [5636] = {.lex_state = 45},
  [5637] = {.lex_state = 0},
  [5638] = {.lex_state = 45},
  [5639] = {.lex_state = 45},
  [5640] = {.lex_state = 45},
  [5641] = {.lex_state = 45},
  [5642] = {.lex_state = 45},
  [5643] = {.lex_state = 45},
  [5644] = {.lex_state = 45},
  [5645] = {.lex_state = 45},
  [5646] = {.lex_state = 45},
  [5647] = {.lex_state = 6},
  [5648] = {.lex_state = 45},
  [5649] = {.lex_state = 5},
  [5650] = {.lex_state = 45},
  [5651] = {.lex_state = 1},
  [5652] = {.lex_state = 45},
  [5653] = {.lex_state = 1},
  [5654] = {.lex_state = 45},
  [5655] = {.lex_state = 45},
  [5656] = {.lex_state = 1},
  [5657] = {.lex_state = 45},
  [5658] = {.lex_state = 45},
  [5659] = {.lex_state = 45},
  [5660] = {.lex_state = 45},
  [5661] = {.lex_state = 45},
  [5662] = {.lex_state = 45},
  [5663] = {.lex_state = 1},
  [5664] = {.lex_state = 45},
  [5665] = {.lex_state = 0},
  [5666] = {.lex_state = 45},
  [5667] = {.lex_state = 45},
  [5668] = {.lex_state = 45},
  [5669] = {.lex_state = 45},
  [5670] = {.lex_state = 45},
  [5671] = {.lex_state = 6},
  [5672] = {.lex_state = 45},
  [5673] = {.lex_state = 45},
  [5674] = {.lex_state = 45},
  [5675] = {.lex_state = 45},
  [5676] = {.lex_state = 45},
  [5677] = {.lex_state = 1},
  [5678] = {.lex_state = 45},
  [5679] = {.lex_state = 45},
  [5680] = {.lex_state = 45},
  [5681] = {.lex_state = 45},
  [5682] = {.lex_state = 45},
  [5683] = {.lex_state = 45},
  [5684] = {.lex_state = 45},
  [5685] = {.lex_state = 45},
  [5686] = {.lex_state = 45},
  [5687] = {.lex_state = 0},
  [5688] = {.lex_state = 45},
  [5689] = {.lex_state = 0},
  [5690] = {.lex_state = 45},
  [5691] = {.lex_state = 45},
  [5692] = {.lex_state = 45},
  [5693] = {.lex_state = 45},
  [5694] = {.lex_state = 45},
  [5695] = {.lex_state = 45},
  [5696] = {.lex_state = 6},
  [5697] = {.lex_state = 0},
  [5698] = {.lex_state = 45},
  [5699] = {.lex_state = 45},
  [5700] = {.lex_state = 45},
  [5701] = {.lex_state = 0},
  [5702] = {.lex_state = 45},
  [5703] = {.lex_state = 45},
  [5704] = {.lex_state = 45},
  [5705] = {.lex_state = 45},
  [5706] = {.lex_state = 45},
  [5707] = {.lex_state = 45},
  [5708] = {.lex_state = 45},
  [5709] = {.lex_state = 45},
  [5710] = {.lex_state = 45},
  [5711] = {.lex_state = 45},
  [5712] = {.lex_state = 45},
  [5713] = {.lex_state = 45},
  [5714] = {.lex_state = 45},
  [5715] = {.lex_state = 45},
  [5716] = {.lex_state = 45},
  [5717] = {.lex_state = 45},
  [5718] = {.lex_state = 45},
  [5719] = {.lex_state = 45},
  [5720] = {.lex_state = 45},
  [5721] = {.lex_state = 45},
  [5722] = {.lex_state = 45},
  [5723] = {.lex_state = 45},
  [5724] = {.lex_state = 45},
  [5725] = {.lex_state = 45},
  [5726] = {.lex_state = 45},
  [5727] = {.lex_state = 45},
  [5728] = {.lex_state = 45},
  [5729] = {.lex_state = 45},
  [5730] = {.lex_state = 45},
  [5731] = {.lex_state = 45},
  [5732] = {.lex_state = 45},
  [5733] = {.lex_state = 45},
  [5734] = {.lex_state = 45},
  [5735] = {.lex_state = 45},
  [5736] = {.lex_state = 45},
  [5737] = {.lex_state = 45},
  [5738] = {.lex_state = 45},
  [5739] = {.lex_state = 45},
  [5740] = {.lex_state = 45},
  [5741] = {.lex_state = 45},
  [5742] = {.lex_state = 45},
  [5743] = {.lex_state = 45},
  [5744] = {.lex_state = 45},
  [5745] = {.lex_state = 45},
  [5746] = {.lex_state = 45},
  [5747] = {.lex_state = 45},
  [5748] = {.lex_state = 45},
  [5749] = {.lex_state = 45},
  [5750] = {.lex_state = 45},
  [5751] = {.lex_state = 45},
  [5752] = {.lex_state = 45},
  [5753] = {.lex_state = 45},
  [5754] = {.lex_state = 45},
  [5755] = {.lex_state = 45},
  [5756] = {.lex_state = 45},
  [5757] = {.lex_state = 45},
  [5758] = {.lex_state = 45},
  [5759] = {.lex_state = 45},
  [5760] = {.lex_state = 45},
  [5761] = {.lex_state = 45},
  [5762] = {.lex_state = 45},
  [5763] = {.lex_state = 45},
  [5764] = {.lex_state = 0},
  [5765] = {.lex_state = 45},
  [5766] = {.lex_state = 45},
  [5767] = {.lex_state = 0},
  [5768] = {.lex_state = 45},
  [5769] = {.lex_state = 45},
  [5770] = {.lex_state = 45},
  [5771] = {.lex_state = 45},
  [5772] = {.lex_state = 45},
  [5773] = {.lex_state = 45},
  [5774] = {.lex_state = 45},
  [5775] = {.lex_state = 45},
  [5776] = {.lex_state = 45},
  [5777] = {.lex_state = 45},
  [5778] = {.lex_state = 45},
  [5779] = {.lex_state = 45},
  [5780] = {.lex_state = 5},
  [5781] = {.lex_state = 45},
  [5782] = {.lex_state = 45},
  [5783] = {.lex_state = 45},
  [5784] = {.lex_state = 45},
  [5785] = {.lex_state = 45},
  [5786] = {.lex_state = 45},
  [5787] = {.lex_state = 45},
  [5788] = {.lex_state = 45},
  [5789] = {.lex_state = 45},
  [5790] = {.lex_state = 45},
  [5791] = {.lex_state = 45},
  [5792] = {.lex_state = 45},
  [5793] = {.lex_state = 45},
  [5794] = {.lex_state = 45},
  [5795] = {.lex_state = 45},
  [5796] = {.lex_state = 45},
  [5797] = {.lex_state = 45},
  [5798] = {.lex_state = 45},
  [5799] = {.lex_state = 45},
  [5800] = {.lex_state = 45},
  [5801] = {.lex_state = 45},
  [5802] = {.lex_state = 45},
  [5803] = {.lex_state = 45},
  [5804] = {.lex_state = 45},
  [5805] = {.lex_state = 45},
  [5806] = {.lex_state = 45},
  [5807] = {.lex_state = 45},
  [5808] = {.lex_state = 45},
  [5809] = {.lex_state = 45},
  [5810] = {.lex_state = 45},
  [5811] = {.lex_state = 45},
  [5812] = {.lex_state = 45},
  [5813] = {.lex_state = 45},
  [5814] = {.lex_state = 45},
  [5815] = {.lex_state = 45},
  [5816] = {.lex_state = 45},
  [5817] = {.lex_state = 45},
  [5818] = {.lex_state = 45},
  [5819] = {.lex_state = 45},
  [5820] = {.lex_state = 45},
  [5821] = {.lex_state = 45},
  [5822] = {.lex_state = 45},
  [5823] = {.lex_state = 45},
  [5824] = {.lex_state = 45},
  [5825] = {.lex_state = 45},
  [5826] = {.lex_state = 45},
  [5827] = {.lex_state = 45},
  [5828] = {.lex_state = 45},
  [5829] = {.lex_state = 45},
  [5830] = {.lex_state = 45},
  [5831] = {.lex_state = 45},
  [5832] = {.lex_state = 45},
  [5833] = {.lex_state = 45},
  [5834] = {.lex_state = 45},
  [5835] = {.lex_state = 45},
  [5836] = {.lex_state = 45},
  [5837] = {.lex_state = 45},
  [5838] = {.lex_state = 45},
  [5839] = {.lex_state = 45},
  [5840] = {.lex_state = 45},
  [5841] = {.lex_state = 45},
  [5842] = {.lex_state = 45},
  [5843] = {.lex_state = 0},
  [5844] = {.lex_state = 45},
  [5845] = {.lex_state = 45},
  [5846] = {.lex_state = 45},
  [5847] = {.lex_state = 0},
  [5848] = {.lex_state = 45},
  [5849] = {.lex_state = 45},
  [5850] = {.lex_state = 45},
  [5851] = {.lex_state = 0},
  [5852] = {.lex_state = 45},
  [5853] = {.lex_state = 45},
  [5854] = {.lex_state = 45},
  [5855] = {.lex_state = 45},
  [5856] = {.lex_state = 45},
  [5857] = {.lex_state = 45},
  [5858] = {.lex_state = 45},
  [5859] = {.lex_state = 45},
  [5860] = {.lex_state = 45},
  [5861] = {.lex_state = 45},
  [5862] = {.lex_state = 45},
  [5863] = {.lex_state = 0},
  [5864] = {.lex_state = 45},
  [5865] = {.lex_state = 45},
  [5866] = {.lex_state = 45},
  [5867] = {.lex_state = 45},
  [5868] = {.lex_state = 45},
  [5869] = {.lex_state = 45},
  [5870] = {.lex_state = 45},
  [5871] = {.lex_state = 45},
  [5872] = {.lex_state = 45},
  [5873] = {.lex_state = 0},
  [5874] = {.lex_state = 45},
  [5875] = {.lex_state = 0},
  [5876] = {.lex_state = 45},
  [5877] = {.lex_state = 45},
  [5878] = {.lex_state = 0},
  [5879] = {.lex_state = 45},
  [5880] = {.lex_state = 45},
  [5881] = {.lex_state = 45},
  [5882] = {.lex_state = 45},
  [5883] = {.lex_state = 5},
  [5884] = {.lex_state = 0, .external_lex_state = 1},
  [5885] = {.lex_state = 45},
  [5886] = {.lex_state = 45},
  [5887] = {.lex_state = 45},
  [5888] = {.lex_state = 45},
  [5889] = {.lex_state = 45},
  [5890] = {.lex_state = 0, .external_lex_state = 1},
  [5891] = {.lex_state = 45},
  [5892] = {.lex_state = 5},
  [5893] = {.lex_state = 45},
  [5894] = {.lex_state = 45},
  [5895] = {.lex_state = 45},
  [5896] = {.lex_state = 45},
  [5897] = {.lex_state = 5},
  [5898] = {.lex_state = 45},
  [5899] = {.lex_state = 0},
  [5900] = {.lex_state = 45},
  [5901] = {.lex_state = 45},
  [5902] = {.lex_state = 5},
  [5903] = {.lex_state = 45},
  [5904] = {.lex_state = 45},
  [5905] = {.lex_state = 0},
  [5906] = {.lex_state = 45},
  [5907] = {.lex_state = 45},
  [5908] = {.lex_state = 45},
  [5909] = {.lex_state = 45},
  [5910] = {.lex_state = 45},
  [5911] = {.lex_state = 45},
  [5912] = {.lex_state = 45},
  [5913] = {.lex_state = 0},
  [5914] = {.lex_state = 0},
  [5915] = {.lex_state = 5},
  [5916] = {.lex_state = 0},
  [5917] = {.lex_state = 45},
  [5918] = {.lex_state = 0, .external_lex_state = 1},
  [5919] = {.lex_state = 45},
  [5920] = {.lex_state = 45},
  [5921] = {.lex_state = 45},
  [5922] = {.lex_state = 45},
  [5923] = {.lex_state = 45},
  [5924] = {.lex_state = 45},
  [5925] = {.lex_state = 45},
  [5926] = {.lex_state = 45},
  [5927] = {.lex_state = 45},
  [5928] = {.lex_state = 45},
  [5929] = {.lex_state = 45},
  [5930] = {.lex_state = 45},
  [5931] = {.lex_state = 1},
  [5932] = {.lex_state = 45},
  [5933] = {.lex_state = 45},
  [5934] = {.lex_state = 45},
  [5935] = {.lex_state = 45},
  [5936] = {.lex_state = 45},
  [5937] = {.lex_state = 45},
  [5938] = {.lex_state = 45},
  [5939] = {.lex_state = 45},
  [5940] = {.lex_state = 45},
  [5941] = {.lex_state = 45},
  [5942] = {.lex_state = 45},
  [5943] = {.lex_state = 45},
  [5944] = {.lex_state = 45},
  [5945] = {.lex_state = 45},
  [5946] = {.lex_state = 45},
  [5947] = {.lex_state = 45},
  [5948] = {.lex_state = 45},
  [5949] = {.lex_state = 45},
  [5950] = {.lex_state = 45},
  [5951] = {.lex_state = 45},
  [5952] = {.lex_state = 45},
  [5953] = {.lex_state = 45},
  [5954] = {.lex_state = 0},
  [5955] = {.lex_state = 5},
  [5956] = {.lex_state = 6},
  [5957] = {.lex_state = 45},
  [5958] = {.lex_state = 0},
  [5959] = {.lex_state = 0},
  [5960] = {.lex_state = 45},
  [5961] = {.lex_state = 45},
  [5962] = {.lex_state = 0},
  [5963] = {.lex_state = 45},
  [5964] = {.lex_state = 45},
  [5965] = {.lex_state = 45},
  [5966] = {.lex_state = 45},
  [5967] = {.lex_state = 45},
  [5968] = {.lex_state = 45},
  [5969] = {.lex_state = 45},
  [5970] = {.lex_state = 45},
  [5971] = {.lex_state = 0},
  [5972] = {.lex_state = 0},
  [5973] = {.lex_state = 0},
  [5974] = {.lex_state = 45},
  [5975] = {.lex_state = 6},
  [5976] = {.lex_state = 45},
  [5977] = {.lex_state = 45},
  [5978] = {.lex_state = 45},
  [5979] = {.lex_state = 45},
  [5980] = {.lex_state = 0},
  [5981] = {.lex_state = 45},
  [5982] = {.lex_state = 45},
  [5983] = {.lex_state = 45},
  [5984] = {.lex_state = 45},
  [5985] = {.lex_state = 45},
  [5986] = {.lex_state = 5},
  [5987] = {.lex_state = 0, .external_lex_state = 1},
  [5988] = {.lex_state = 45},
  [5989] = {.lex_state = 0, .external_lex_state = 1},
  [5990] = {.lex_state = 45},
  [5991] = {.lex_state = 45},
  [5992] = {.lex_state = 45},
  [5993] = {.lex_state = 45},
  [5994] = {.lex_state = 0, .external_lex_state = 1},
  [5995] = {.lex_state = 1},
  [5996] = {.lex_state = 0, .external_lex_state = 1},
  [5997] = {.lex_state = 0, .external_lex_state = 1},
  [5998] = {.lex_state = 0, .external_lex_state = 1},
  [5999] = {.lex_state = 0, .external_lex_state = 1},
  [6000] = {.lex_state = 0},
  [6001] = {.lex_state = 45},
  [6002] = {.lex_state = 6},
  [6003] = {.lex_state = 45},
  [6004] = {.lex_state = 0, .external_lex_state = 1},
  [6005] = {.lex_state = 1},
  [6006] = {.lex_state = 0, .external_lex_state = 1},
  [6007] = {.lex_state = 0},
  [6008] = {.lex_state = 0},
  [6009] = {.lex_state = 45},
  [6010] = {.lex_state = 45},
  [6011] = {.lex_state = 6},
  [6012] = {.lex_state = 45},
  [6013] = {.lex_state = 45},
  [6014] = {.lex_state = 0, .external_lex_state = 1},
  [6015] = {.lex_state = 5},
  [6016] = {.lex_state = 45},
  [6017] = {.lex_state = 45},
  [6018] = {.lex_state = 45},
  [6019] = {.lex_state = 1},
  [6020] = {.lex_state = 0},
  [6021] = {.lex_state = 45},
  [6022] = {.lex_state = 45},
  [6023] = {.lex_state = 45},
  [6024] = {.lex_state = 45},
  [6025] = {.lex_state = 0},
  [6026] = {.lex_state = 45},
  [6027] = {.lex_state = 45},
  [6028] = {.lex_state = 45},
  [6029] = {.lex_state = 0},
  [6030] = {.lex_state = 45},
  [6031] = {.lex_state = 45},
  [6032] = {.lex_state = 6},
  [6033] = {.lex_state = 45},
  [6034] = {.lex_state = 45},
  [6035] = {.lex_state = 45},
  [6036] = {.lex_state = 45},
  [6037] = {.lex_state = 45},
  [6038] = {.lex_state = 45},
  [6039] = {.lex_state = 45},
  [6040] = {.lex_state = 45},
  [6041] = {.lex_state = 45},
  [6042] = {.lex_state = 45},
  [6043] = {.lex_state = 45},
  [6044] = {.lex_state = 45},
  [6045] = {.lex_state = 45},
  [6046] = {.lex_state = 0},
  [6047] = {.lex_state = 6},
  [6048] = {.lex_state = 1},
  [6049] = {.lex_state = 0},
  [6050] = {.lex_state = 45},
  [6051] = {.lex_state = 45},
  [6052] = {.lex_state = 0},
  [6053] = {.lex_state = 45},
  [6054] = {.lex_state = 45},
  [6055] = {.lex_state = 45},
  [6056] = {.lex_state = 45},
  [6057] = {.lex_state = 0},
  [6058] = {.lex_state = 1},
  [6059] = {.lex_state = 45},
  [6060] = {.lex_state = 45},
  [6061] = {.lex_state = 45},
  [6062] = {.lex_state = 45},
  [6063] = {.lex_state = 45},
  [6064] = {.lex_state = 45},
  [6065] = {.lex_state = 45},
  [6066] = {.lex_state = 0},
  [6067] = {.lex_state = 45},
  [6068] = {.lex_state = 45},
  [6069] = {.lex_state = 45},
  [6070] = {.lex_state = 45},
  [6071] = {.lex_state = 45},
  [6072] = {.lex_state = 0},
  [6073] = {.lex_state = 45},
  [6074] = {.lex_state = 45},
  [6075] = {.lex_state = 45},
  [6076] = {.lex_state = 5},
  [6077] = {.lex_state = 45},
  [6078] = {.lex_state = 45},
  [6079] = {.lex_state = 45},
  [6080] = {.lex_state = 45},
  [6081] = {.lex_state = 0},
  [6082] = {.lex_state = 45},
  [6083] = {.lex_state = 45},
  [6084] = {.lex_state = 45},
  [6085] = {.lex_state = 45},
  [6086] = {.lex_state = 45},
  [6087] = {.lex_state = 45},
  [6088] = {.lex_state = 45},
  [6089] = {.lex_state = 45},
  [6090] = {.lex_state = 0},
  [6091] = {.lex_state = 45},
  [6092] = {.lex_state = 0},
  [6093] = {.lex_state = 5},
  [6094] = {.lex_state = 0},
  [6095] = {.lex_state = 0},
  [6096] = {.lex_state = 0},
  [6097] = {.lex_state = 45},
  [6098] = {.lex_state = 45},
  [6099] = {.lex_state = 45},
  [6100] = {.lex_state = 45},
  [6101] = {.lex_state = 45},
  [6102] = {.lex_state = 45},
  [6103] = {.lex_state = 0},
  [6104] = {.lex_state = 2},
  [6105] = {.lex_state = 2},
  [6106] = {.lex_state = 45},
  [6107] = {.lex_state = 45},
  [6108] = {.lex_state = 0},
  [6109] = {.lex_state = 0},
  [6110] = {.lex_state = 0},
  [6111] = {.lex_state = 0},
  [6112] = {.lex_state = 0},
  [6113] = {.lex_state = 45},
  [6114] = {.lex_state = 45},
  [6115] = {.lex_state = 0},
  [6116] = {.lex_state = 0},
  [6117] = {.lex_state = 45},
  [6118] = {.lex_state = 0},
  [6119] = {.lex_state = 0},
  [6120] = {.lex_state = 0},
  [6121] = {.lex_state = 45},
  [6122] = {.lex_state = 0},
  [6123] = {.lex_state = 45},
  [6124] = {.lex_state = 45},
  [6125] = {.lex_state = 45},
  [6126] = {.lex_state = 0},
  [6127] = {.lex_state = 0},
  [6128] = {.lex_state = 0},
  [6129] = {.lex_state = 45},
  [6130] = {.lex_state = 0},
  [6131] = {.lex_state = 0},
  [6132] = {.lex_state = 2},
  [6133] = {.lex_state = 2},
  [6134] = {.lex_state = 0},
  [6135] = {.lex_state = 0},
  [6136] = {.lex_state = 45},
  [6137] = {.lex_state = 45},
  [6138] = {.lex_state = 45},
  [6139] = {.lex_state = 0},
  [6140] = {.lex_state = 0},
  [6141] = {.lex_state = 0},
  [6142] = {.lex_state = 45},
  [6143] = {.lex_state = 2},
  [6144] = {.lex_state = 45},
  [6145] = {.lex_state = 45},
  [6146] = {.lex_state = 45},
  [6147] = {.lex_state = 0},
  [6148] = {.lex_state = 45},
  [6149] = {.lex_state = 0},
  [6150] = {.lex_state = 0},
  [6151] = {.lex_state = 2},
  [6152] = {.lex_state = 45},
  [6153] = {.lex_state = 0},
  [6154] = {.lex_state = 2},
  [6155] = {.lex_state = 45},
  [6156] = {.lex_state = 0},
  [6157] = {.lex_state = 0},
  [6158] = {.lex_state = 45},
  [6159] = {.lex_state = 0},
  [6160] = {.lex_state = 0},
  [6161] = {.lex_state = 0},
  [6162] = {.lex_state = 0},
  [6163] = {.lex_state = 45},
  [6164] = {.lex_state = 45},
  [6165] = {.lex_state = 45},
  [6166] = {.lex_state = 0},
  [6167] = {.lex_state = 0},
  [6168] = {.lex_state = 45},
  [6169] = {.lex_state = 0},
  [6170] = {.lex_state = 0},
  [6171] = {.lex_state = 0},
  [6172] = {.lex_state = 0},
  [6173] = {.lex_state = 0},
  [6174] = {.lex_state = 45},
  [6175] = {.lex_state = 0},
  [6176] = {.lex_state = 45},
  [6177] = {.lex_state = 0},
  [6178] = {.lex_state = 45},
  [6179] = {.lex_state = 45},
  [6180] = {.lex_state = 45},
  [6181] = {.lex_state = 45},
  [6182] = {.lex_state = 45},
  [6183] = {.lex_state = 2},
  [6184] = {.lex_state = 0},
  [6185] = {.lex_state = 45},
  [6186] = {.lex_state = 0},
  [6187] = {.lex_state = 0},
  [6188] = {.lex_state = 0},
  [6189] = {.lex_state = 0},
  [6190] = {.lex_state = 0},
  [6191] = {.lex_state = 0},
  [6192] = {.lex_state = 0},
  [6193] = {.lex_state = 2},
  [6194] = {.lex_state = 45},
  [6195] = {.lex_state = 45},
  [6196] = {.lex_state = 45},
  [6197] = {.lex_state = 45},
  [6198] = {.lex_state = 0},
  [6199] = {.lex_state = 0},
  [6200] = {.lex_state = 2},
  [6201] = {.lex_state = 45},
  [6202] = {.lex_state = 45},
  [6203] = {.lex_state = 45},
  [6204] = {.lex_state = 0},
  [6205] = {.lex_state = 0},
  [6206] = {.lex_state = 0},
  [6207] = {.lex_state = 45},
  [6208] = {.lex_state = 45},
  [6209] = {.lex_state = 0},
  [6210] = {.lex_state = 2},
  [6211] = {.lex_state = 45},
  [6212] = {.lex_state = 45},
  [6213] = {.lex_state = 0},
  [6214] = {.lex_state = 0},
  [6215] = {.lex_state = 45},
  [6216] = {.lex_state = 45},
  [6217] = {.lex_state = 0},
  [6218] = {.lex_state = 0},
  [6219] = {.lex_state = 0},
  [6220] = {.lex_state = 5},
  [6221] = {.lex_state = 5},
  [6222] = {.lex_state = 0},
  [6223] = {.lex_state = 0},
  [6224] = {.lex_state = 0},
  [6225] = {.lex_state = 45},
  [6226] = {.lex_state = 0},
  [6227] = {.lex_state = 0},
  [6228] = {.lex_state = 0},
  [6229] = {.lex_state = 0},
  [6230] = {.lex_state = 5},
  [6231] = {.lex_state = 5},
  [6232] = {.lex_state = 0},
  [6233] = {.lex_state = 5},
  [6234] = {.lex_state = 5},
  [6235] = {.lex_state = 0},
  [6236] = {.lex_state = 0},
  [6237] = {.lex_state = 5},
  [6238] = {.lex_state = 5},
  [6239] = {.lex_state = 0},
  [6240] = {.lex_state = 5},
  [6241] = {.lex_state = 0},
  [6242] = {.lex_state = 0},
  [6243] = {.lex_state = 5},
  [6244] = {.lex_state = 0},
  [6245] = {.lex_state = 0},
  [6246] = {.lex_state = 0},
  [6247] = {.lex_state = 0},
  [6248] = {.lex_state = 0},
  [6249] = {.lex_state = 0},
  [6250] = {.lex_state = 5},
  [6251] = {.lex_state = 0},
  [6252] = {.lex_state = 0},
  [6253] = {.lex_state = 0},
  [6254] = {.lex_state = 0},
  [6255] = {.lex_state = 0},
  [6256] = {.lex_state = 0},
  [6257] = {.lex_state = 0},
  [6258] = {.lex_state = 0},
  [6259] = {.lex_state = 0},
  [6260] = {.lex_state = 0},
  [6261] = {.lex_state = 0},
  [6262] = {.lex_state = 0},
  [6263] = {.lex_state = 45},
  [6264] = {.lex_state = 0},
  [6265] = {.lex_state = 0},
  [6266] = {.lex_state = 0},
  [6267] = {.lex_state = 0},
  [6268] = {.lex_state = 0},
  [6269] = {.lex_state = 0},
  [6270] = {.lex_state = 0},
  [6271] = {.lex_state = 0},
  [6272] = {.lex_state = 0},
  [6273] = {.lex_state = 0},
  [6274] = {.lex_state = 0},
  [6275] = {.lex_state = 0},
  [6276] = {.lex_state = 0},
  [6277] = {.lex_state = 0},
  [6278] = {.lex_state = 0},
  [6279] = {.lex_state = 0},
  [6280] = {.lex_state = 0},
  [6281] = {.lex_state = 0},
  [6282] = {.lex_state = 45},
  [6283] = {.lex_state = 45},
  [6284] = {.lex_state = 0},
  [6285] = {.lex_state = 0},
  [6286] = {.lex_state = 0},
  [6287] = {.lex_state = 5},
  [6288] = {.lex_state = 0},
  [6289] = {.lex_state = 0},
  [6290] = {.lex_state = 0},
  [6291] = {.lex_state = 0},
  [6292] = {.lex_state = 0},
  [6293] = {.lex_state = 0},
  [6294] = {.lex_state = 5},
  [6295] = {.lex_state = 5},
  [6296] = {.lex_state = 5},
  [6297] = {.lex_state = 45},
  [6298] = {.lex_state = 0},
  [6299] = {.lex_state = 45},
  [6300] = {.lex_state = 0},
  [6301] = {.lex_state = 45},
  [6302] = {.lex_state = 0},
  [6303] = {.lex_state = 45},
  [6304] = {.lex_state = 5},
  [6305] = {.lex_state = 0},
  [6306] = {.lex_state = 0},
  [6307] = {.lex_state = 0},
  [6308] = {.lex_state = 0},
  [6309] = {.lex_state = 5},
  [6310] = {.lex_state = 0},
  [6311] = {.lex_state = 5},
  [6312] = {.lex_state = 0},
  [6313] = {.lex_state = 0},
  [6314] = {.lex_state = 0},
  [6315] = {.lex_state = 5},
  [6316] = {.lex_state = 0},
  [6317] = {.lex_state = 5},
  [6318] = {.lex_state = 0},
  [6319] = {.lex_state = 0},
  [6320] = {.lex_state = 0},
  [6321] = {.lex_state = 0},
  [6322] = {.lex_state = 0},
  [6323] = {.lex_state = 5},
  [6324] = {.lex_state = 0},
  [6325] = {.lex_state = 0},
  [6326] = {.lex_state = 0},
  [6327] = {.lex_state = 0},
  [6328] = {.lex_state = 0},
  [6329] = {.lex_state = 0},
  [6330] = {.lex_state = 0},
  [6331] = {.lex_state = 0},
  [6332] = {.lex_state = 5},
  [6333] = {.lex_state = 0},
  [6334] = {.lex_state = 0},
  [6335] = {.lex_state = 0},
  [6336] = {.lex_state = 0},
  [6337] = {.lex_state = 0},
  [6338] = {.lex_state = 0},
  [6339] = {.lex_state = 0},
  [6340] = {.lex_state = 5},
  [6341] = {.lex_state = 0},
  [6342] = {.lex_state = 0},
  [6343] = {.lex_state = 0},
  [6344] = {.lex_state = 0},
  [6345] = {.lex_state = 45},
  [6346] = {.lex_state = 0},
  [6347] = {.lex_state = 0},
  [6348] = {.lex_state = 0},
  [6349] = {.lex_state = 5},
  [6350] = {.lex_state = 0},
  [6351] = {.lex_state = 0},
  [6352] = {.lex_state = 0},
  [6353] = {.lex_state = 45},
  [6354] = {.lex_state = 0},
  [6355] = {.lex_state = 0},
  [6356] = {.lex_state = 0},
  [6357] = {.lex_state = 0},
  [6358] = {.lex_state = 45},
  [6359] = {.lex_state = 0},
  [6360] = {.lex_state = 0},
  [6361] = {.lex_state = 0},
  [6362] = {.lex_state = 0},
  [6363] = {.lex_state = 5},
  [6364] = {.lex_state = 0},
  [6365] = {.lex_state = 45},
  [6366] = {.lex_state = 0},
  [6367] = {.lex_state = 0},
  [6368] = {.lex_state = 5},
  [6369] = {.lex_state = 3},
  [6370] = {.lex_state = 45},
  [6371] = {.lex_state = 0},
  [6372] = {.lex_state = 0},
  [6373] = {.lex_state = 0},
  [6374] = {.lex_state = 0},
  [6375] = {.lex_state = 0},
  [6376] = {.lex_state = 0, .external_lex_state = 1},
  [6377] = {.lex_state = 0, .external_lex_state = 1},
  [6378] = {.lex_state = 0, .external_lex_state = 1},
  [6379] = {.lex_state = 0},
  [6380] = {.lex_state = 0},
  [6381] = {.lex_state = 0},
  [6382] = {.lex_state = 0},
  [6383] = {.lex_state = 0, .external_lex_state = 1},
  [6384] = {.lex_state = 0, .external_lex_state = 1},
  [6385] = {.lex_state = 0},
  [6386] = {.lex_state = 5},
  [6387] = {.lex_state = 0},
  [6388] = {.lex_state = 0},
  [6389] = {.lex_state = 0},
  [6390] = {.lex_state = 0},
  [6391] = {.lex_state = 0},
  [6392] = {.lex_state = 5},
  [6393] = {.lex_state = 0},
  [6394] = {.lex_state = 0},
  [6395] = {.lex_state = 5},
  [6396] = {.lex_state = 5},
  [6397] = {.lex_state = 0, .external_lex_state = 1},
  [6398] = {.lex_state = 0},
  [6399] = {.lex_state = 45},
  [6400] = {.lex_state = 0},
  [6401] = {.lex_state = 0},
  [6402] = {.lex_state = 5},
  [6403] = {.lex_state = 5},
  [6404] = {.lex_state = 0},
  [6405] = {.lex_state = 0},
  [6406] = {.lex_state = 0},
  [6407] = {.lex_state = 5},
  [6408] = {.lex_state = 5},
  [6409] = {.lex_state = 0},
  [6410] = {.lex_state = 0},
  [6411] = {.lex_state = 5},
  [6412] = {.lex_state = 0},
  [6413] = {.lex_state = 2},
  [6414] = {.lex_state = 0},
  [6415] = {.lex_state = 0},
  [6416] = {.lex_state = 0},
  [6417] = {.lex_state = 5},
  [6418] = {.lex_state = 0},
  [6419] = {.lex_state = 0},
  [6420] = {.lex_state = 0},
  [6421] = {.lex_state = 0},
  [6422] = {.lex_state = 0},
  [6423] = {.lex_state = 0},
  [6424] = {.lex_state = 0},
  [6425] = {.lex_state = 0},
  [6426] = {.lex_state = 0},
  [6427] = {.lex_state = 0},
  [6428] = {.lex_state = 0},
  [6429] = {.lex_state = 0},
  [6430] = {.lex_state = 0},
  [6431] = {.lex_state = 0},
  [6432] = {.lex_state = 0},
  [6433] = {.lex_state = 0},
  [6434] = {.lex_state = 0},
  [6435] = {.lex_state = 5},
  [6436] = {.lex_state = 0},
  [6437] = {.lex_state = 0},
  [6438] = {.lex_state = 45},
  [6439] = {.lex_state = 0},
  [6440] = {.lex_state = 0},
  [6441] = {.lex_state = 0},
  [6442] = {.lex_state = 0},
  [6443] = {.lex_state = 5},
  [6444] = {.lex_state = 0},
  [6445] = {.lex_state = 0},
  [6446] = {.lex_state = 0},
  [6447] = {.lex_state = 0},
  [6448] = {.lex_state = 5},
  [6449] = {.lex_state = 0},
  [6450] = {.lex_state = 0},
  [6451] = {.lex_state = 0},
  [6452] = {.lex_state = 0},
  [6453] = {.lex_state = 0},
  [6454] = {.lex_state = 0},
  [6455] = {.lex_state = 0},
  [6456] = {.lex_state = 0},
  [6457] = {.lex_state = 0},
  [6458] = {.lex_state = 0},
  [6459] = {.lex_state = 0},
  [6460] = {.lex_state = 0},
  [6461] = {.lex_state = 0},
  [6462] = {.lex_state = 0},
  [6463] = {.lex_state = 0},
  [6464] = {.lex_state = 0},
  [6465] = {.lex_state = 0},
  [6466] = {.lex_state = 0},
  [6467] = {.lex_state = 0},
  [6468] = {.lex_state = 0},
  [6469] = {.lex_state = 0},
  [6470] = {.lex_state = 45},
  [6471] = {.lex_state = 0},
  [6472] = {.lex_state = 0},
  [6473] = {.lex_state = 45},
  [6474] = {.lex_state = 0},
  [6475] = {.lex_state = 45},
  [6476] = {.lex_state = 16},
  [6477] = {.lex_state = 0},
  [6478] = {.lex_state = 5},
  [6479] = {.lex_state = 0},
  [6480] = {.lex_state = 45},
  [6481] = {.lex_state = 45},
  [6482] = {.lex_state = 5},
  [6483] = {.lex_state = 0},
  [6484] = {.lex_state = 45},
  [6485] = {.lex_state = 5},
  [6486] = {.lex_state = 5},
  [6487] = {.lex_state = 0},
  [6488] = {.lex_state = 45},
  [6489] = {.lex_state = 0},
  [6490] = {.lex_state = 0},
  [6491] = {.lex_state = 0},
  [6492] = {.lex_state = 0},
  [6493] = {.lex_state = 0},
  [6494] = {.lex_state = 45},
  [6495] = {.lex_state = 0},
  [6496] = {.lex_state = 0},
  [6497] = {.lex_state = 0},
  [6498] = {.lex_state = 0},
  [6499] = {.lex_state = 16},
  [6500] = {.lex_state = 0},
  [6501] = {.lex_state = 0},
  [6502] = {.lex_state = 0},
  [6503] = {.lex_state = 0},
  [6504] = {.lex_state = 45},
  [6505] = {.lex_state = 0},
  [6506] = {.lex_state = 16},
  [6507] = {.lex_state = 0},
  [6508] = {.lex_state = 0},
  [6509] = {.lex_state = 0},
  [6510] = {.lex_state = 0},
  [6511] = {.lex_state = 0},
  [6512] = {.lex_state = 45},
  [6513] = {.lex_state = 0},
  [6514] = {.lex_state = 45},
  [6515] = {.lex_state = 0},
  [6516] = {.lex_state = 45},
  [6517] = {.lex_state = 0},
  [6518] = {.lex_state = 45},
  [6519] = {.lex_state = 45},
  [6520] = {.lex_state = 0},
  [6521] = {.lex_state = 0},
  [6522] = {.lex_state = 45},
  [6523] = {.lex_state = 45},
  [6524] = {.lex_state = 0},
  [6525] = {.lex_state = 5},
  [6526] = {.lex_state = 0},
  [6527] = {.lex_state = 45},
  [6528] = {.lex_state = 0},
  [6529] = {.lex_state = 0},
  [6530] = {.lex_state = 45},
  [6531] = {.lex_state = 45},
  [6532] = {.lex_state = 0},
  [6533] = {.lex_state = 45},
  [6534] = {.lex_state = 5},
  [6535] = {.lex_state = 45},
  [6536] = {.lex_state = 0},
  [6537] = {.lex_state = 16},
  [6538] = {.lex_state = 0},
  [6539] = {.lex_state = 0},
  [6540] = {.lex_state = 0},
  [6541] = {.lex_state = 0},
  [6542] = {.lex_state = 0},
  [6543] = {.lex_state = 0},
  [6544] = {.lex_state = 0},
  [6545] = {.lex_state = 0},
  [6546] = {.lex_state = 0},
  [6547] = {.lex_state = 0},
  [6548] = {.lex_state = 45},
  [6549] = {.lex_state = 45},
  [6550] = {.lex_state = 16},
  [6551] = {.lex_state = 45},
  [6552] = {.lex_state = 0},
  [6553] = {.lex_state = 45},
  [6554] = {.lex_state = 45},
  [6555] = {.lex_state = 45},
  [6556] = {.lex_state = 45},
  [6557] = {.lex_state = 0},
  [6558] = {.lex_state = 0},
  [6559] = {.lex_state = 0},
  [6560] = {.lex_state = 0},
  [6561] = {.lex_state = 0},
  [6562] = {.lex_state = 0},
  [6563] = {.lex_state = 0},
  [6564] = {.lex_state = 45},
  [6565] = {.lex_state = 45},
  [6566] = {.lex_state = 0},
  [6567] = {.lex_state = 0},
  [6568] = {.lex_state = 5},
  [6569] = {.lex_state = 45},
  [6570] = {.lex_state = 45},
  [6571] = {.lex_state = 45},
  [6572] = {.lex_state = 0},
  [6573] = {.lex_state = 45},
  [6574] = {.lex_state = 45},
  [6575] = {.lex_state = 0},
  [6576] = {.lex_state = 0},
  [6577] = {.lex_state = 0},
  [6578] = {.lex_state = 0},
  [6579] = {.lex_state = 0},
  [6580] = {.lex_state = 45},
  [6581] = {.lex_state = 0},
  [6582] = {.lex_state = 45},
  [6583] = {.lex_state = 17, .external_lex_state = 1},
  [6584] = {.lex_state = 17, .external_lex_state = 1},
  [6585] = {.lex_state = 0},
  [6586] = {.lex_state = 45},
  [6587] = {.lex_state = 45},
  [6588] = {.lex_state = 45},
  [6589] = {.lex_state = 0},
  [6590] = {.lex_state = 0},
  [6591] = {.lex_state = 0},
  [6592] = {.lex_state = 0},
  [6593] = {.lex_state = 0},
  [6594] = {.lex_state = 0},
  [6595] = {.lex_state = 0},
  [6596] = {.lex_state = 45},
  [6597] = {.lex_state = 0},
  [6598] = {.lex_state = 0},
  [6599] = {.lex_state = 0},
  [6600] = {.lex_state = 45},
  [6601] = {.lex_state = 45},
  [6602] = {.lex_state = 45},
  [6603] = {.lex_state = 5},
  [6604] = {.lex_state = 0, .external_lex_state = 1},
  [6605] = {.lex_state = 0, .external_lex_state = 1},
  [6606] = {.lex_state = 0},
  [6607] = {.lex_state = 0},
  [6608] = {.lex_state = 3, .external_lex_state = 1},
  [6609] = {.lex_state = 0},
  [6610] = {.lex_state = 0},
  [6611] = {.lex_state = 0},
  [6612] = {.lex_state = 45},
  [6613] = {.lex_state = 0},
  [6614] = {.lex_state = 45},
  [6615] = {.lex_state = 0},
  [6616] = {.lex_state = 0},
  [6617] = {.lex_state = 0},
  [6618] = {.lex_state = 0},
  [6619] = {.lex_state = 0},
  [6620] = {.lex_state = 0},
  [6621] = {.lex_state = 0},
  [6622] = {.lex_state = 45},
  [6623] = {.lex_state = 0},
  [6624] = {.lex_state = 0},
  [6625] = {.lex_state = 0},
  [6626] = {.lex_state = 0},
  [6627] = {.lex_state = 0},
  [6628] = {.lex_state = 0},
  [6629] = {.lex_state = 0},
  [6630] = {.lex_state = 0},
  [6631] = {.lex_state = 0},
  [6632] = {.lex_state = 0},
  [6633] = {.lex_state = 0},
  [6634] = {.lex_state = 0},
  [6635] = {.lex_state = 0},
  [6636] = {.lex_state = 0},
  [6637] = {.lex_state = 0},
  [6638] = {.lex_state = 0},
  [6639] = {.lex_state = 0},
  [6640] = {.lex_state = 0},
  [6641] = {.lex_state = 0},
  [6642] = {.lex_state = 3},
  [6643] = {.lex_state = 0},
  [6644] = {.lex_state = 0},
  [6645] = {.lex_state = 0},
  [6646] = {.lex_state = 0, .external_lex_state = 1},
  [6647] = {.lex_state = 0, .external_lex_state = 1},
  [6648] = {.lex_state = 0},
  [6649] = {.lex_state = 0},
  [6650] = {.lex_state = 0},
  [6651] = {.lex_state = 0},
  [6652] = {.lex_state = 0, .external_lex_state = 1},
  [6653] = {.lex_state = 45},
  [6654] = {.lex_state = 0},
  [6655] = {.lex_state = 0, .external_lex_state = 1},
  [6656] = {.lex_state = 0},
  [6657] = {.lex_state = 0},
  [6658] = {.lex_state = 0},
  [6659] = {.lex_state = 0},
  [6660] = {.lex_state = 0},
  [6661] = {.lex_state = 0},
  [6662] = {.lex_state = 0},
  [6663] = {.lex_state = 0, .external_lex_state = 1},
  [6664] = {.lex_state = 0},
  [6665] = {.lex_state = 0},
  [6666] = {.lex_state = 0},
  [6667] = {.lex_state = 0, .external_lex_state = 1},
  [6668] = {.lex_state = 0, .external_lex_state = 1},
  [6669] = {.lex_state = 0},
  [6670] = {.lex_state = 0},
  [6671] = {.lex_state = 0},
  [6672] = {.lex_state = 0},
  [6673] = {.lex_state = 0},
  [6674] = {.lex_state = 45},
  [6675] = {.lex_state = 0},
  [6676] = {.lex_state = 0},
  [6677] = {.lex_state = 0},
  [6678] = {.lex_state = 3},
  [6679] = {.lex_state = 0},
  [6680] = {.lex_state = 0},
  [6681] = {.lex_state = 0},
  [6682] = {.lex_state = 0},
  [6683] = {.lex_state = 0},
  [6684] = {.lex_state = 0},
  [6685] = {.lex_state = 0},
  [6686] = {.lex_state = 0},
  [6687] = {.lex_state = 0},
  [6688] = {.lex_state = 0},
  [6689] = {.lex_state = 0},
  [6690] = {.lex_state = 0, .external_lex_state = 1},
  [6691] = {.lex_state = 45},
  [6692] = {.lex_state = 0},
  [6693] = {.lex_state = 0},
  [6694] = {.lex_state = 0},
  [6695] = {.lex_state = 0},
  [6696] = {.lex_state = 0},
  [6697] = {.lex_state = 0},
  [6698] = {.lex_state = 0},
  [6699] = {.lex_state = 17},
  [6700] = {.lex_state = 17},
  [6701] = {.lex_state = 0},
  [6702] = {.lex_state = 0},
  [6703] = {.lex_state = 0, .external_lex_state = 1},
  [6704] = {.lex_state = 0},
  [6705] = {.lex_state = 0},
  [6706] = {.lex_state = 0},
  [6707] = {.lex_state = 0},
  [6708] = {.lex_state = 0, .external_lex_state = 1},
  [6709] = {.lex_state = 0},
  [6710] = {.lex_state = 0},
  [6711] = {.lex_state = 0},
  [6712] = {.lex_state = 45},
  [6713] = {.lex_state = 0},
  [6714] = {.lex_state = 0},
  [6715] = {.lex_state = 0},
  [6716] = {.lex_state = 0},
  [6717] = {.lex_state = 0},
  [6718] = {.lex_state = 0},
  [6719] = {.lex_state = 0},
  [6720] = {.lex_state = 0},
  [6721] = {.lex_state = 0},
  [6722] = {.lex_state = 0},
  [6723] = {.lex_state = 0},
  [6724] = {.lex_state = 0},
  [6725] = {.lex_state = 0},
  [6726] = {.lex_state = 0},
  [6727] = {.lex_state = 45},
  [6728] = {.lex_state = 0},
  [6729] = {.lex_state = 0},
  [6730] = {.lex_state = 0},
  [6731] = {.lex_state = 0},
  [6732] = {.lex_state = 0},
  [6733] = {.lex_state = 0},
  [6734] = {.lex_state = 0},
  [6735] = {.lex_state = 45},
  [6736] = {.lex_state = 0},
  [6737] = {.lex_state = 0},
  [6738] = {.lex_state = 45},
  [6739] = {.lex_state = 0},
  [6740] = {.lex_state = 0},
  [6741] = {.lex_state = 0},
  [6742] = {.lex_state = 0},
  [6743] = {.lex_state = 0},
  [6744] = {.lex_state = 0},
  [6745] = {.lex_state = 0},
  [6746] = {.lex_state = 0},
  [6747] = {.lex_state = 0},
  [6748] = {.lex_state = 0},
  [6749] = {.lex_state = 0},
  [6750] = {.lex_state = 45},
  [6751] = {.lex_state = 0},
  [6752] = {.lex_state = 0},
  [6753] = {.lex_state = 0},
  [6754] = {.lex_state = 0},
  [6755] = {.lex_state = 0},
  [6756] = {.lex_state = 0},
  [6757] = {.lex_state = 0},
  [6758] = {.lex_state = 0},
  [6759] = {.lex_state = 0},
  [6760] = {.lex_state = 45},
  [6761] = {.lex_state = 0},
  [6762] = {.lex_state = 0},
  [6763] = {.lex_state = 0},
  [6764] = {.lex_state = 0},
  [6765] = {.lex_state = 0},
  [6766] = {.lex_state = 0},
  [6767] = {.lex_state = 0},
  [6768] = {.lex_state = 0},
  [6769] = {.lex_state = 0},
  [6770] = {.lex_state = 0},
  [6771] = {.lex_state = 0},
  [6772] = {.lex_state = 0},
  [6773] = {.lex_state = 0},
  [6774] = {.lex_state = 0},
  [6775] = {.lex_state = 0},
  [6776] = {.lex_state = 0},
  [6777] = {.lex_state = 0},
  [6778] = {.lex_state = 0},
  [6779] = {.lex_state = 0},
  [6780] = {.lex_state = 0},
  [6781] = {.lex_state = 0},
  [6782] = {.lex_state = 0},
  [6783] = {.lex_state = 0},
  [6784] = {.lex_state = 0},
  [6785] = {.lex_state = 0},
  [6786] = {.lex_state = 0},
  [6787] = {.lex_state = 0},
  [6788] = {.lex_state = 0},
  [6789] = {.lex_state = 0},
  [6790] = {.lex_state = 0},
  [6791] = {.lex_state = 0},
  [6792] = {.lex_state = 0},
  [6793] = {.lex_state = 0},
  [6794] = {.lex_state = 0},
  [6795] = {.lex_state = 0},
  [6796] = {.lex_state = 0},
  [6797] = {.lex_state = 0},
  [6798] = {.lex_state = 0},
  [6799] = {.lex_state = 0},
  [6800] = {.lex_state = 0},
  [6801] = {.lex_state = 0},
  [6802] = {.lex_state = 0},
  [6803] = {.lex_state = 0},
  [6804] = {.lex_state = 0},
  [6805] = {.lex_state = 0},
  [6806] = {.lex_state = 0},
  [6807] = {.lex_state = 0},
  [6808] = {.lex_state = 0},
  [6809] = {.lex_state = 0},
  [6810] = {.lex_state = 0},
  [6811] = {.lex_state = 0},
  [6812] = {.lex_state = 0},
  [6813] = {.lex_state = 0},
  [6814] = {.lex_state = 0},
  [6815] = {.lex_state = 18},
  [6816] = {.lex_state = 0},
  [6817] = {.lex_state = 0},
  [6818] = {.lex_state = 0},
  [6819] = {.lex_state = 0},
  [6820] = {.lex_state = 0},
  [6821] = {.lex_state = 0},
  [6822] = {.lex_state = 45},
  [6823] = {.lex_state = 0},
  [6824] = {.lex_state = 0},
  [6825] = {.lex_state = 0},
  [6826] = {.lex_state = 0},
  [6827] = {.lex_state = 0},
  [6828] = {.lex_state = 0},
  [6829] = {.lex_state = 0},
  [6830] = {.lex_state = 0},
  [6831] = {.lex_state = 0},
  [6832] = {.lex_state = 0},
  [6833] = {.lex_state = 0},
  [6834] = {.lex_state = 0},
  [6835] = {.lex_state = 0},
  [6836] = {.lex_state = 0},
  [6837] = {.lex_state = 0},
  [6838] = {.lex_state = 0},
  [6839] = {.lex_state = 0},
  [6840] = {.lex_state = 0},
  [6841] = {.lex_state = 0},
  [6842] = {.lex_state = 0},
  [6843] = {.lex_state = 0},
  [6844] = {.lex_state = 0},
  [6845] = {.lex_state = 0},
  [6846] = {.lex_state = 0},
  [6847] = {.lex_state = 0},
  [6848] = {.lex_state = 0},
  [6849] = {.lex_state = 0},
  [6850] = {.lex_state = 0},
  [6851] = {.lex_state = 0},
  [6852] = {.lex_state = 0},
  [6853] = {.lex_state = 0},
  [6854] = {.lex_state = 0},
  [6855] = {.lex_state = 0},
  [6856] = {.lex_state = 0},
  [6857] = {.lex_state = 45},
  [6858] = {.lex_state = 0},
  [6859] = {.lex_state = 0},
  [6860] = {.lex_state = 0},
  [6861] = {.lex_state = 45},
  [6862] = {.lex_state = 0},
  [6863] = {.lex_state = 0},
  [6864] = {.lex_state = 45},
  [6865] = {.lex_state = 0},
  [6866] = {.lex_state = 0, .external_lex_state = 1},
  [6867] = {.lex_state = 0, .external_lex_state = 1},
  [6868] = {.lex_state = 3},
  [6869] = {.lex_state = 0},
  [6870] = {.lex_state = 0},
  [6871] = {.lex_state = 0},
  [6872] = {.lex_state = 0},
  [6873] = {.lex_state = 0},
  [6874] = {.lex_state = 0},
  [6875] = {.lex_state = 0},
  [6876] = {.lex_state = 0},
  [6877] = {.lex_state = 0},
  [6878] = {.lex_state = 0},
  [6879] = {.lex_state = 0},
  [6880] = {.lex_state = 0},
  [6881] = {.lex_state = 0},
  [6882] = {.lex_state = 0},
  [6883] = {.lex_state = 45},
  [6884] = {.lex_state = 0},
  [6885] = {.lex_state = 0},
  [6886] = {.lex_state = 0},
  [6887] = {.lex_state = 0},
  [6888] = {.lex_state = 0},
  [6889] = {.lex_state = 0},
  [6890] = {.lex_state = 0},
  [6891] = {.lex_state = 0},
  [6892] = {.lex_state = 0},
  [6893] = {.lex_state = 0},
  [6894] = {.lex_state = 0},
  [6895] = {.lex_state = 0},
  [6896] = {.lex_state = 0},
  [6897] = {.lex_state = 0},
  [6898] = {.lex_state = 0},
  [6899] = {.lex_state = 0},
  [6900] = {.lex_state = 0},
  [6901] = {.lex_state = 0},
  [6902] = {.lex_state = 0},
  [6903] = {.lex_state = 0},
  [6904] = {.lex_state = 0},
  [6905] = {.lex_state = 45},
  [6906] = {.lex_state = 0},
  [6907] = {.lex_state = 0},
  [6908] = {.lex_state = 0},
  [6909] = {.lex_state = 0},
  [6910] = {.lex_state = 0},
  [6911] = {.lex_state = 0},
  [6912] = {.lex_state = 0},
  [6913] = {.lex_state = 0},
  [6914] = {.lex_state = 45},
  [6915] = {.lex_state = 45},
  [6916] = {.lex_state = 0},
  [6917] = {.lex_state = 0},
  [6918] = {.lex_state = 0},
  [6919] = {.lex_state = 0},
  [6920] = {.lex_state = 0},
  [6921] = {.lex_state = 0},
  [6922] = {.lex_state = 45},
  [6923] = {.lex_state = 0},
  [6924] = {.lex_state = 0},
  [6925] = {.lex_state = 0},
  [6926] = {.lex_state = 0},
  [6927] = {.lex_state = 0},
  [6928] = {.lex_state = 0},
  [6929] = {.lex_state = 0},
  [6930] = {.lex_state = 0},
  [6931] = {.lex_state = 0},
  [6932] = {.lex_state = 0},
  [6933] = {.lex_state = 0},
  [6934] = {.lex_state = 0},
  [6935] = {.lex_state = 0},
  [6936] = {.lex_state = 0},
  [6937] = {.lex_state = 0},
  [6938] = {.lex_state = 45},
  [6939] = {.lex_state = 0},
  [6940] = {.lex_state = 0},
  [6941] = {.lex_state = 0},
  [6942] = {.lex_state = 0},
  [6943] = {.lex_state = 0},
  [6944] = {.lex_state = 0},
  [6945] = {.lex_state = 45},
  [6946] = {.lex_state = 0},
  [6947] = {.lex_state = 0},
  [6948] = {.lex_state = 0},
  [6949] = {.lex_state = 45},
  [6950] = {.lex_state = 45},
  [6951] = {.lex_state = 0},
  [6952] = {.lex_state = 0},
  [6953] = {.lex_state = 45},
  [6954] = {.lex_state = 0},
  [6955] = {.lex_state = 45},
  [6956] = {.lex_state = 0},
  [6957] = {.lex_state = 45},
  [6958] = {.lex_state = 0},
  [6959] = {.lex_state = 45},
  [6960] = {.lex_state = 45},
  [6961] = {.lex_state = 45},
  [6962] = {.lex_state = 0},
  [6963] = {.lex_state = 0},
  [6964] = {.lex_state = 0},
  [6965] = {.lex_state = 0},
  [6966] = {.lex_state = 0},
  [6967] = {.lex_state = 0},
  [6968] = {.lex_state = 0},
  [6969] = {.lex_state = 0},
  [6970] = {.lex_state = 0},
  [6971] = {.lex_state = 0},
  [6972] = {.lex_state = 0},
  [6973] = {.lex_state = 0},
  [6974] = {.lex_state = 0},
  [6975] = {.lex_state = 0},
  [6976] = {.lex_state = 0},
  [6977] = {.lex_state = 0},
  [6978] = {(TSStateId)(-1)},
};

enum {
  ts_external_token__preproc_directive_end = 0,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__preproc_directive_end] = sym__preproc_directive_end,
};

static const bool ts_external_scanner_states[2][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__preproc_directive_end] = true,
  },
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__preprocessor_call] = STATE(0),
    [ts_builtin_sym_end] = ACTIONS(1),
    [sym__identifier_token] = ACTIONS(1),
    [anon_sym_extern] = ACTIONS(1),
    [anon_sym_alias] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_global] = ACTIONS(1),
    [anon_sym_using] = ACTIONS(1),
    [anon_sym_static] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_COLON_COLON] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_field] = ACTIONS(1),
    [anon_sym_event] = ACTIONS(1),
    [anon_sym_method] = ACTIONS(1),
    [anon_sym_param] = ACTIONS(1),
    [anon_sym_property] = ACTIONS(1),
    [anon_sym_return] = ACTIONS(1),
    [anon_sym_type] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_assembly] = ACTIONS(1),
    [anon_sym_module] = ACTIONS(1),
    [anon_sym_abstract] = ACTIONS(1),
    [anon_sym_async] = ACTIONS(1),
    [anon_sym_const] = ACTIONS(1),
    [anon_sym_fixed] = ACTIONS(1),
    [anon_sym_internal] = ACTIONS(1),
    [anon_sym_new] = ACTIONS(1),
    [anon_sym_override] = ACTIONS(1),
    [anon_sym_partial] = ACTIONS(1),
    [anon_sym_private] = ACTIONS(1),
    [anon_sym_protected] = ACTIONS(1),
    [anon_sym_public] = ACTIONS(1),
    [anon_sym_readonly] = ACTIONS(1),
    [anon_sym_ref] = ACTIONS(1),
    [anon_sym_sealed] = ACTIONS(1),
    [anon_sym_unsafe] = ACTIONS(1),
    [anon_sym_virtual] = ACTIONS(1),
    [anon_sym_volatile] = ACTIONS(1),
    [anon_sym_out] = ACTIONS(1),
    [anon_sym_in] = ACTIONS(1),
    [anon_sym_this] = ACTIONS(1),
    [anon_sym_params] = ACTIONS(1),
    [anon_sym_base] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_EQ_GT] = ACTIONS(1),
    [anon_sym_implicit] = ACTIONS(1),
    [anon_sym_explicit] = ACTIONS(1),
    [anon_sym_operator] = ACTIONS(1),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_where] = ACTIONS(1),
    [anon_sym_class] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_struct] = ACTIONS(1),
    [anon_sym_notnull] = ACTIONS(1),
    [anon_sym_unmanaged] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_DASH_DASH] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_SLASH] = ACTIONS(1),
    [anon_sym_PERCENT] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_AMP] = ACTIONS(1),
    [anon_sym_LT_LT] = ACTIONS(1),
    [anon_sym_GT_GT] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_get] = ACTIONS(1),
    [anon_sym_set] = ACTIONS(1),
    [anon_sym_add] = ACTIONS(1),
    [anon_sym_remove] = ACTIONS(1),
    [anon_sym_init] = ACTIONS(1),
    [anon_sym_enum] = ACTIONS(1),
    [anon_sym_interface] = ACTIONS(1),
    [anon_sym_delegate] = ACTIONS(1),
    [anon_sym_record] = ACTIONS(1),
    [anon_sym_namespace] = ACTIONS(1),
    [anon_sym_var] = ACTIONS(1),
    [anon_sym_managed] = ACTIONS(1),
    [anon_sym_Cdecl] = ACTIONS(1),
    [anon_sym_Stdcall] = ACTIONS(1),
    [anon_sym_Thiscall] = ACTIONS(1),
    [anon_sym_Fastcall] = ACTIONS(1),
    [sym_predefined_type] = ACTIONS(1),
    [anon_sym_break] = ACTIONS(1),
    [anon_sym_checked] = ACTIONS(1),
    [anon_sym_unchecked] = ACTIONS(1),
    [anon_sym_continue] = ACTIONS(1),
    [anon_sym_do] = ACTIONS(1),
    [anon_sym_while] = ACTIONS(1),
    [anon_sym_for] = ACTIONS(1),
    [anon_sym_await] = ACTIONS(1),
    [anon_sym_foreach] = ACTIONS(1),
    [anon_sym_goto] = ACTIONS(1),
    [anon_sym_case] = ACTIONS(1),
    [anon_sym_default] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_lock] = ACTIONS(1),
    [anon_sym_switch] = ACTIONS(1),
    [anon_sym_not] = ACTIONS(1),
    [anon_sym_and] = ACTIONS(1),
    [anon_sym_or] = ACTIONS(1),
    [sym_discard] = ACTIONS(1),
    [anon_sym_when] = ACTIONS(1),
    [anon_sym_throw] = ACTIONS(1),
    [anon_sym_try] = ACTIONS(1),
    [anon_sym_catch] = ACTIONS(1),
    [anon_sym_finally] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(1),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1),
    [anon_sym_stackalloc] = ACTIONS(1),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1),
    [anon_sym_LBRACE_LBRACE] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(1),
    [anon_sym___makeref] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_from] = ACTIONS(1),
    [anon_sym_join] = ACTIONS(1),
    [anon_sym_on] = ACTIONS(1),
    [anon_sym_equals] = ACTIONS(1),
    [anon_sym_into] = ACTIONS(1),
    [anon_sym_let] = ACTIONS(1),
    [anon_sym_orderby] = ACTIONS(1),
    [anon_sym_ascending] = ACTIONS(1),
    [anon_sym_descending] = ACTIONS(1),
    [anon_sym_group] = ACTIONS(1),
    [anon_sym_by] = ACTIONS(1),
    [anon_sym_select] = ACTIONS(1),
    [anon_sym_DOT_DOT] = ACTIONS(1),
    [anon_sym___reftype] = ACTIONS(1),
    [anon_sym___refvalue] = ACTIONS(1),
    [anon_sym_sizeof] = ACTIONS(1),
    [anon_sym_typeof] = ACTIONS(1),
    [anon_sym_with] = ACTIONS(1),
    [anon_sym_AMP_AMP] = ACTIONS(1),
    [anon_sym_PIPE_PIPE] = ACTIONS(1),
    [anon_sym_QMARK_QMARK] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [sym_escape_sequence] = ACTIONS(1),
    [sym_integer_literal] = ACTIONS(1),
    [sym_null_literal] = ACTIONS(1),
    [sym_real_literal] = ACTIONS(1),
    [sym_verbatim_string_literal] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(1),
    [anon_sym_nameof] = ACTIONS(1),
    [sym_void_keyword] = ACTIONS(1),
    [sym__preproc_directive_start] = ACTIONS(5),
    [anon_sym_nullable] = ACTIONS(1),
    [anon_sym_disable] = ACTIONS(1),
    [anon_sym_enable] = ACTIONS(1),
    [anon_sym_restore] = ACTIONS(1),
    [anon_sym_annotations] = ACTIONS(1),
    [anon_sym_warnings] = ACTIONS(1),
    [anon_sym_define] = ACTIONS(1),
    [anon_sym_undef] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(1),
    [sym_endif_directive] = ACTIONS(1),
    [anon_sym_region] = ACTIONS(1),
    [anon_sym_endregion] = ACTIONS(1),
    [anon_sym_error] = ACTIONS(1),
    [anon_sym_warning] = ACTIONS(1),
    [anon_sym_line] = ACTIONS(1),
    [anon_sym_hidden] = ACTIONS(1),
    [anon_sym_pragma] = ACTIONS(1),
    [anon_sym_checksum] = ACTIONS(1),
    [sym_preproc_integer_literal] = ACTIONS(1),
    [sym__preproc_directive_end] = ACTIONS(1),
  },
  [1] = {
    [sym_compilation_unit] = STATE(6799),
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym_extern_alias_directive] = STATE(1637),
    [sym_using_directive] = STATE(1635),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_global_attribute_list] = STATE(1641),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym_file_scoped_namespace_declaration] = STATE(6731),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1),
    [aux_sym_compilation_unit_repeat1] = STATE(2),
    [aux_sym_compilation_unit_repeat2] = STATE(3),
    [aux_sym_compilation_unit_repeat3] = STATE(5),
    [aux_sym_compilation_unit_repeat4] = STATE(8),
    [aux_sym_compilation_unit_repeat5] = STATE(4567),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(7),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(11),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(17),
    [anon_sym_using] = ACTIONS(19),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(65),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2] = {
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym_extern_alias_directive] = STATE(1637),
    [sym_using_directive] = STATE(1635),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_global_attribute_list] = STATE(1641),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym_file_scoped_namespace_declaration] = STATE(6745),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(2),
    [aux_sym_compilation_unit_repeat1] = STATE(1555),
    [aux_sym_compilation_unit_repeat2] = STATE(4),
    [aux_sym_compilation_unit_repeat3] = STATE(6),
    [aux_sym_compilation_unit_repeat4] = STATE(9),
    [aux_sym_compilation_unit_repeat5] = STATE(4575),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(11),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(17),
    [anon_sym_using] = ACTIONS(19),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(65),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [3] = {
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym_using_directive] = STATE(1635),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_global_attribute_list] = STATE(1641),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym_file_scoped_namespace_declaration] = STATE(6745),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(3),
    [aux_sym_compilation_unit_repeat2] = STATE(1556),
    [aux_sym_compilation_unit_repeat3] = STATE(6),
    [aux_sym_compilation_unit_repeat4] = STATE(9),
    [aux_sym_compilation_unit_repeat5] = STATE(4575),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(17),
    [anon_sym_using] = ACTIONS(19),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(65),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [4] = {
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym_using_directive] = STATE(1635),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_global_attribute_list] = STATE(1641),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym_file_scoped_namespace_declaration] = STATE(6790),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(4),
    [aux_sym_compilation_unit_repeat2] = STATE(1556),
    [aux_sym_compilation_unit_repeat3] = STATE(7),
    [aux_sym_compilation_unit_repeat4] = STATE(11),
    [aux_sym_compilation_unit_repeat5] = STATE(4559),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(17),
    [anon_sym_using] = ACTIONS(19),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(65),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [5] = {
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_global_attribute_list] = STATE(1641),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym_file_scoped_namespace_declaration] = STATE(6745),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(5),
    [aux_sym_compilation_unit_repeat3] = STATE(1557),
    [aux_sym_compilation_unit_repeat4] = STATE(9),
    [aux_sym_compilation_unit_repeat5] = STATE(4575),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(65),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [6] = {
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_global_attribute_list] = STATE(1641),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym_file_scoped_namespace_declaration] = STATE(6790),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(6),
    [aux_sym_compilation_unit_repeat3] = STATE(1557),
    [aux_sym_compilation_unit_repeat4] = STATE(11),
    [aux_sym_compilation_unit_repeat5] = STATE(4559),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(65),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [7] = {
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_global_attribute_list] = STATE(1641),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym_file_scoped_namespace_declaration] = STATE(6696),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(7),
    [aux_sym_compilation_unit_repeat3] = STATE(1557),
    [aux_sym_compilation_unit_repeat4] = STATE(10),
    [aux_sym_compilation_unit_repeat5] = STATE(4555),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(141),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(23),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(65),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [8] = {
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(8),
    [aux_sym_compilation_unit_repeat4] = STATE(12),
    [aux_sym_compilation_unit_repeat5] = STATE(4575),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(133),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [9] = {
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(9),
    [aux_sym_compilation_unit_repeat4] = STATE(12),
    [aux_sym_compilation_unit_repeat5] = STATE(4559),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [10] = {
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(10),
    [aux_sym_compilation_unit_repeat4] = STATE(12),
    [aux_sym_compilation_unit_repeat5] = STATE(4579),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [11] = {
    [sym_global_statement] = STATE(1636),
    [sym__namespace_member_declaration] = STATE(5345),
    [sym__type_declaration] = STATE(5349),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym_enum_declaration] = STATE(5402),
    [sym_class_declaration] = STATE(5402),
    [sym_interface_declaration] = STATE(5402),
    [sym_struct_declaration] = STATE(5402),
    [sym_delegate_declaration] = STATE(5402),
    [sym_record_declaration] = STATE(5402),
    [sym_record_struct_declaration] = STATE(5402),
    [sym_namespace_declaration] = STATE(5349),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(11),
    [aux_sym_compilation_unit_repeat4] = STATE(12),
    [aux_sym_compilation_unit_repeat5] = STATE(4555),
    [aux_sym_event_field_declaration_repeat1] = STATE(1965),
    [aux_sym_event_field_declaration_repeat2] = STATE(1995),
    [ts_builtin_sym_end] = ACTIONS(141),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(21),
    [anon_sym_LBRACK] = ACTIONS(143),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(31),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(33),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(35),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(37),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(39),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_class] = ACTIONS(49),
    [anon_sym_struct] = ACTIONS(51),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_enum] = ACTIONS(57),
    [anon_sym_interface] = ACTIONS(59),
    [anon_sym_delegate] = ACTIONS(61),
    [anon_sym_record] = ACTIONS(63),
    [anon_sym_namespace] = ACTIONS(145),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [12] = {
    [sym_global_statement] = STATE(1636),
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1643),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(12),
    [aux_sym_compilation_unit_repeat4] = STATE(12),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [ts_builtin_sym_end] = ACTIONS(149),
    [sym__identifier_token] = ACTIONS(151),
    [anon_sym_extern] = ACTIONS(154),
    [anon_sym_alias] = ACTIONS(157),
    [anon_sym_SEMI] = ACTIONS(160),
    [anon_sym_global] = ACTIONS(163),
    [anon_sym_using] = ACTIONS(166),
    [anon_sym_static] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(172),
    [anon_sym_return] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(178),
    [anon_sym_abstract] = ACTIONS(154),
    [anon_sym_async] = ACTIONS(181),
    [anon_sym_const] = ACTIONS(154),
    [anon_sym_fixed] = ACTIONS(184),
    [anon_sym_internal] = ACTIONS(154),
    [anon_sym_new] = ACTIONS(187),
    [anon_sym_override] = ACTIONS(154),
    [anon_sym_partial] = ACTIONS(154),
    [anon_sym_private] = ACTIONS(154),
    [anon_sym_protected] = ACTIONS(154),
    [anon_sym_public] = ACTIONS(154),
    [anon_sym_readonly] = ACTIONS(154),
    [anon_sym_ref] = ACTIONS(190),
    [anon_sym_sealed] = ACTIONS(154),
    [anon_sym_unsafe] = ACTIONS(193),
    [anon_sym_virtual] = ACTIONS(154),
    [anon_sym_volatile] = ACTIONS(154),
    [anon_sym_this] = ACTIONS(196),
    [anon_sym_base] = ACTIONS(199),
    [anon_sym_LBRACE] = ACTIONS(202),
    [anon_sym_TILDE] = ACTIONS(205),
    [anon_sym_where] = ACTIONS(157),
    [anon_sym_class] = ACTIONS(208),
    [anon_sym_struct] = ACTIONS(208),
    [anon_sym_notnull] = ACTIONS(157),
    [anon_sym_unmanaged] = ACTIONS(157),
    [anon_sym_BANG] = ACTIONS(205),
    [anon_sym_PLUS_PLUS] = ACTIONS(205),
    [anon_sym_DASH_DASH] = ACTIONS(205),
    [anon_sym_true] = ACTIONS(210),
    [anon_sym_false] = ACTIONS(210),
    [anon_sym_PLUS] = ACTIONS(213),
    [anon_sym_DASH] = ACTIONS(213),
    [anon_sym_STAR] = ACTIONS(205),
    [anon_sym_CARET] = ACTIONS(205),
    [anon_sym_AMP] = ACTIONS(205),
    [anon_sym_get] = ACTIONS(157),
    [anon_sym_set] = ACTIONS(157),
    [anon_sym_add] = ACTIONS(157),
    [anon_sym_remove] = ACTIONS(157),
    [anon_sym_enum] = ACTIONS(208),
    [anon_sym_interface] = ACTIONS(208),
    [anon_sym_delegate] = ACTIONS(216),
    [anon_sym_record] = ACTIONS(208),
    [anon_sym_namespace] = ACTIONS(208),
    [anon_sym_var] = ACTIONS(219),
    [sym_predefined_type] = ACTIONS(222),
    [anon_sym_break] = ACTIONS(225),
    [anon_sym_checked] = ACTIONS(228),
    [anon_sym_unchecked] = ACTIONS(228),
    [anon_sym_continue] = ACTIONS(231),
    [anon_sym_do] = ACTIONS(234),
    [anon_sym_while] = ACTIONS(237),
    [anon_sym_for] = ACTIONS(240),
    [anon_sym_await] = ACTIONS(243),
    [anon_sym_foreach] = ACTIONS(246),
    [anon_sym_goto] = ACTIONS(249),
    [anon_sym_default] = ACTIONS(252),
    [anon_sym_if] = ACTIONS(255),
    [anon_sym_lock] = ACTIONS(258),
    [anon_sym_switch] = ACTIONS(261),
    [anon_sym_when] = ACTIONS(157),
    [anon_sym_throw] = ACTIONS(264),
    [anon_sym_try] = ACTIONS(267),
    [anon_sym_yield] = ACTIONS(270),
    [anon_sym_stackalloc] = ACTIONS(273),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(276),
    [anon_sym_DQUOTE] = ACTIONS(279),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(282),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(282),
    [anon_sym___makeref] = ACTIONS(285),
    [anon_sym_from] = ACTIONS(288),
    [anon_sym_join] = ACTIONS(157),
    [anon_sym_on] = ACTIONS(157),
    [anon_sym_equals] = ACTIONS(157),
    [anon_sym_into] = ACTIONS(157),
    [anon_sym_let] = ACTIONS(157),
    [anon_sym_orderby] = ACTIONS(157),
    [anon_sym_ascending] = ACTIONS(157),
    [anon_sym_descending] = ACTIONS(157),
    [anon_sym_group] = ACTIONS(157),
    [anon_sym_by] = ACTIONS(157),
    [anon_sym_select] = ACTIONS(157),
    [anon_sym_DOT_DOT] = ACTIONS(291),
    [anon_sym___reftype] = ACTIONS(294),
    [anon_sym___refvalue] = ACTIONS(297),
    [anon_sym_sizeof] = ACTIONS(300),
    [anon_sym_typeof] = ACTIONS(303),
    [anon_sym_SQUOTE] = ACTIONS(306),
    [sym_integer_literal] = ACTIONS(309),
    [sym_null_literal] = ACTIONS(309),
    [sym_real_literal] = ACTIONS(312),
    [sym_verbatim_string_literal] = ACTIONS(312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(157),
    [anon_sym_nameof] = ACTIONS(157),
    [sym_void_keyword] = ACTIONS(315),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [13] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_case_pattern_switch_label] = STATE(1735),
    [sym_case_switch_label] = STATE(1735),
    [sym_default_switch_label] = STATE(1735),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(13),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(15),
    [aux_sym_switch_section_repeat1] = STATE(1653),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_case] = ACTIONS(362),
    [anon_sym_default] = ACTIONS(364),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [14] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3641),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(14),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(37),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_COMMA] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(382),
    [anon_sym_RBRACE] = ACTIONS(384),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(386),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [15] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(15),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(388),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_case] = ACTIONS(390),
    [anon_sym_default] = ACTIONS(390),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [16] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3679),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(16),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(40),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_COMMA] = ACTIONS(392),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(382),
    [anon_sym_RBRACE] = ACTIONS(394),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(386),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [17] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3641),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(17),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(34),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_COMMA] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(382),
    [anon_sym_RBRACE] = ACTIONS(396),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(386),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [18] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3641),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(18),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(34),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_COMMA] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(382),
    [anon_sym_RBRACE] = ACTIONS(398),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(386),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [19] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3552),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(19),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(33),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_COMMA] = ACTIONS(400),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(382),
    [anon_sym_RBRACE] = ACTIONS(402),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(386),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [20] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3625),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(20),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(41),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_COMMA] = ACTIONS(404),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(382),
    [anon_sym_RBRACE] = ACTIONS(406),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(386),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [21] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3641),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(21),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(25),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_COMMA] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(382),
    [anon_sym_RBRACE] = ACTIONS(408),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(386),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [22] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3577),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(22),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(30),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_COMMA] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(382),
    [anon_sym_RBRACE] = ACTIONS(412),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(386),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [23] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(23),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(414),
    [anon_sym_extern] = ACTIONS(417),
    [anon_sym_alias] = ACTIONS(420),
    [anon_sym_SEMI] = ACTIONS(423),
    [anon_sym_global] = ACTIONS(426),
    [anon_sym_using] = ACTIONS(429),
    [anon_sym_static] = ACTIONS(432),
    [anon_sym_LBRACK] = ACTIONS(435),
    [anon_sym_return] = ACTIONS(438),
    [anon_sym_LPAREN] = ACTIONS(441),
    [anon_sym_abstract] = ACTIONS(417),
    [anon_sym_async] = ACTIONS(444),
    [anon_sym_const] = ACTIONS(417),
    [anon_sym_fixed] = ACTIONS(447),
    [anon_sym_internal] = ACTIONS(417),
    [anon_sym_new] = ACTIONS(450),
    [anon_sym_override] = ACTIONS(417),
    [anon_sym_partial] = ACTIONS(417),
    [anon_sym_private] = ACTIONS(417),
    [anon_sym_protected] = ACTIONS(417),
    [anon_sym_public] = ACTIONS(417),
    [anon_sym_readonly] = ACTIONS(417),
    [anon_sym_ref] = ACTIONS(453),
    [anon_sym_sealed] = ACTIONS(417),
    [anon_sym_unsafe] = ACTIONS(456),
    [anon_sym_virtual] = ACTIONS(417),
    [anon_sym_volatile] = ACTIONS(417),
    [anon_sym_this] = ACTIONS(459),
    [anon_sym_base] = ACTIONS(462),
    [anon_sym_LBRACE] = ACTIONS(465),
    [anon_sym_RBRACE] = ACTIONS(468),
    [anon_sym_TILDE] = ACTIONS(470),
    [anon_sym_where] = ACTIONS(420),
    [anon_sym_notnull] = ACTIONS(420),
    [anon_sym_unmanaged] = ACTIONS(420),
    [anon_sym_BANG] = ACTIONS(470),
    [anon_sym_PLUS_PLUS] = ACTIONS(470),
    [anon_sym_DASH_DASH] = ACTIONS(470),
    [anon_sym_true] = ACTIONS(473),
    [anon_sym_false] = ACTIONS(473),
    [anon_sym_PLUS] = ACTIONS(476),
    [anon_sym_DASH] = ACTIONS(476),
    [anon_sym_STAR] = ACTIONS(470),
    [anon_sym_CARET] = ACTIONS(470),
    [anon_sym_AMP] = ACTIONS(470),
    [anon_sym_get] = ACTIONS(420),
    [anon_sym_set] = ACTIONS(420),
    [anon_sym_add] = ACTIONS(420),
    [anon_sym_remove] = ACTIONS(420),
    [anon_sym_delegate] = ACTIONS(479),
    [anon_sym_var] = ACTIONS(482),
    [sym_predefined_type] = ACTIONS(485),
    [anon_sym_break] = ACTIONS(488),
    [anon_sym_checked] = ACTIONS(491),
    [anon_sym_unchecked] = ACTIONS(491),
    [anon_sym_continue] = ACTIONS(494),
    [anon_sym_do] = ACTIONS(497),
    [anon_sym_while] = ACTIONS(500),
    [anon_sym_for] = ACTIONS(503),
    [anon_sym_await] = ACTIONS(506),
    [anon_sym_foreach] = ACTIONS(509),
    [anon_sym_goto] = ACTIONS(512),
    [anon_sym_case] = ACTIONS(515),
    [anon_sym_default] = ACTIONS(517),
    [anon_sym_if] = ACTIONS(520),
    [anon_sym_lock] = ACTIONS(523),
    [anon_sym_switch] = ACTIONS(526),
    [anon_sym_when] = ACTIONS(420),
    [anon_sym_throw] = ACTIONS(529),
    [anon_sym_try] = ACTIONS(532),
    [anon_sym_yield] = ACTIONS(535),
    [anon_sym_stackalloc] = ACTIONS(538),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(541),
    [anon_sym_DQUOTE] = ACTIONS(544),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(547),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(547),
    [anon_sym___makeref] = ACTIONS(550),
    [anon_sym_from] = ACTIONS(553),
    [anon_sym_join] = ACTIONS(420),
    [anon_sym_on] = ACTIONS(420),
    [anon_sym_equals] = ACTIONS(420),
    [anon_sym_into] = ACTIONS(420),
    [anon_sym_let] = ACTIONS(420),
    [anon_sym_orderby] = ACTIONS(420),
    [anon_sym_ascending] = ACTIONS(420),
    [anon_sym_descending] = ACTIONS(420),
    [anon_sym_group] = ACTIONS(420),
    [anon_sym_by] = ACTIONS(420),
    [anon_sym_select] = ACTIONS(420),
    [anon_sym_DOT_DOT] = ACTIONS(556),
    [anon_sym___reftype] = ACTIONS(559),
    [anon_sym___refvalue] = ACTIONS(562),
    [anon_sym_sizeof] = ACTIONS(565),
    [anon_sym_typeof] = ACTIONS(568),
    [anon_sym_SQUOTE] = ACTIONS(571),
    [sym_integer_literal] = ACTIONS(574),
    [sym_null_literal] = ACTIONS(574),
    [sym_real_literal] = ACTIONS(577),
    [sym_verbatim_string_literal] = ACTIONS(577),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(420),
    [anon_sym_nameof] = ACTIONS(420),
    [sym_void_keyword] = ACTIONS(580),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [24] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3641),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(24),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(37),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_COMMA] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(382),
    [anon_sym_RBRACE] = ACTIONS(583),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(386),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [25] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(25),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(585),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [26] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(26),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(34),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(587),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [27] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(27),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(589),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [28] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(28),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(27),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(591),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [29] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(29),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(593),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [30] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(30),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(595),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [31] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(31),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(29),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(597),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [32] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(32),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(30),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(599),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [33] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(33),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(601),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [34] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(34),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(603),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [35] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(35),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(25),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(605),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [36] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(36),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(40),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(607),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [37] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(37),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(609),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [38] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(38),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(37),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(611),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [39] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(39),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(33),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(613),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [40] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(40),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(615),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [41] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(41),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(23),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(617),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [42] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1732),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(42),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [aux_sym_block_repeat1] = STATE(41),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_RBRACE] = ACTIONS(619),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [43] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1587),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(43),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [44] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1569),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(44),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [45] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1576),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(45),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [46] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1573),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(46),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [47] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1595),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(47),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [48] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1586),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(48),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [49] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1587),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(49),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [50] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1590),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(50),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [51] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1626),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(51),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [52] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(6904),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(52),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [53] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1613),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(53),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [54] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1625),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(54),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [55] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1568),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(55),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [56] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1603),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(56),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [57] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1598),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(57),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [58] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(6561),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(58),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [59] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1613),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(59),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [60] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1593),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(60),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [61] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1589),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(61),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [62] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1609),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(62),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [63] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1606),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(63),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [64] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1591),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(64),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [65] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1609),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(65),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [66] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1606),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(66),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [67] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1566),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(67),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [68] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1567),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(68),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [69] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(6966),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(69),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [70] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1588),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(70),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [71] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1558),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(71),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [72] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1568),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(72),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [73] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1566),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(73),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [74] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1662),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(74),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [75] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1567),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(75),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [76] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1569),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(76),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [77] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1574),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(77),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [78] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1578),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(78),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [79] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1708),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(79),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [80] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1575),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(80),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [81] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1730),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(81),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [82] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1632),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(82),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [83] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1727),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(83),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [84] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1718),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(84),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [85] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1695),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(85),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [86] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1574),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(86),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [87] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1575),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(87),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [88] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1674),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(88),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [89] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1677),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(89),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [90] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1688),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(90),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [91] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1632),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(91),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [92] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1693),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(92),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [93] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1699),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(93),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [94] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1700),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(94),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [95] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1631),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(95),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [96] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1701),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(96),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [97] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1603),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(97),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [98] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1709),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(98),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [99] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1711),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(99),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [100] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1719),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(100),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [101] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1721),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(101),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [102] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1629),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(102),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [103] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1722),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(103),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [104] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1724),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(104),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [105] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1725),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(105),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [106] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1715),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(106),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [107] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1717),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(107),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [108] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1720),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(108),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [109] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1706),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(109),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [110] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1714),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(110),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [111] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1626),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(111),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [112] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1702),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(112),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [113] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1689),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(113),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [114] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1685),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(114),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [115] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1625),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(115),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [116] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1558),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(116),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [117] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1678),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(117),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [118] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6948),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1659),
    [sym__type] = STATE(4717),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1673),
    [sym_break_statement] = STATE(1659),
    [sym_checked_statement] = STATE(1659),
    [sym_continue_statement] = STATE(1659),
    [sym_do_statement] = STATE(1659),
    [sym_empty_statement] = STATE(1659),
    [sym_expression_statement] = STATE(1659),
    [sym_fixed_statement] = STATE(1659),
    [sym_for_statement] = STATE(1659),
    [sym_for_each_statement] = STATE(1659),
    [sym_goto_statement] = STATE(1659),
    [sym_if_statement] = STATE(1659),
    [sym_labeled_statement] = STATE(1659),
    [sym_local_declaration_statement] = STATE(1659),
    [sym_local_function_statement] = STATE(1659),
    [sym_lock_statement] = STATE(1659),
    [sym_return_statement] = STATE(1659),
    [sym_switch_statement] = STATE(1659),
    [sym_throw_statement] = STATE(1659),
    [sym_try_statement] = STATE(1659),
    [sym_unsafe_statement] = STATE(1659),
    [sym_using_statement] = STATE(1659),
    [sym_while_statement] = STATE(1659),
    [sym_yield_statement] = STATE(1659),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1932),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(118),
    [aux_sym_event_field_declaration_repeat1] = STATE(2035),
    [aux_sym_event_field_declaration_repeat2] = STATE(2041),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(320),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(322),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(328),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(332),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(338),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(340),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(344),
    [anon_sym_checked] = ACTIONS(346),
    [anon_sym_unchecked] = ACTIONS(346),
    [anon_sym_continue] = ACTIONS(348),
    [anon_sym_do] = ACTIONS(350),
    [anon_sym_while] = ACTIONS(352),
    [anon_sym_for] = ACTIONS(354),
    [anon_sym_await] = ACTIONS(356),
    [anon_sym_foreach] = ACTIONS(358),
    [anon_sym_goto] = ACTIONS(360),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(366),
    [anon_sym_lock] = ACTIONS(368),
    [anon_sym_switch] = ACTIONS(370),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(372),
    [anon_sym_try] = ACTIONS(374),
    [anon_sym_yield] = ACTIONS(376),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(378),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [119] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1623),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(119),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [120] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1591),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(120),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [121] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1590),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(121),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [122] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1593),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(122),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [123] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1589),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(123),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [124] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1588),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(124),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [125] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1594),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(125),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [126] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1629),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(126),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [127] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1598),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(127),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [128] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1586),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(128),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [129] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1623),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(129),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [130] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1578),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(130),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [131] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1576),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(131),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [132] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1631),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1988),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(132),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(139),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(641),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(45),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(79),
    [anon_sym_for] = ACTIONS(81),
    [anon_sym_await] = ACTIONS(83),
    [anon_sym_foreach] = ACTIONS(85),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(91),
    [anon_sym_lock] = ACTIONS(93),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [133] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1573),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(133),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [134] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6736),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(1604),
    [sym__type] = STATE(4706),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__statement] = STATE(1595),
    [sym_break_statement] = STATE(1604),
    [sym_checked_statement] = STATE(1604),
    [sym_continue_statement] = STATE(1604),
    [sym_do_statement] = STATE(1604),
    [sym_empty_statement] = STATE(1604),
    [sym_expression_statement] = STATE(1604),
    [sym_fixed_statement] = STATE(1604),
    [sym_for_statement] = STATE(1604),
    [sym_for_each_statement] = STATE(1604),
    [sym_goto_statement] = STATE(1604),
    [sym_if_statement] = STATE(1604),
    [sym_labeled_statement] = STATE(1604),
    [sym_local_declaration_statement] = STATE(1604),
    [sym_local_function_statement] = STATE(1604),
    [sym_lock_statement] = STATE(1604),
    [sym_return_statement] = STATE(1604),
    [sym_switch_statement] = STATE(1604),
    [sym_throw_statement] = STATE(1604),
    [sym_try_statement] = STATE(1604),
    [sym_unsafe_statement] = STATE(1604),
    [sym_using_statement] = STATE(1604),
    [sym_while_statement] = STATE(1604),
    [sym_yield_statement] = STATE(1604),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4134),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1981),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(134),
    [aux_sym_event_field_declaration_repeat1] = STATE(2036),
    [aux_sym_event_field_declaration_repeat2] = STATE(2038),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(15),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_using] = ACTIONS(621),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_return] = ACTIONS(25),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(623),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(625),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(627),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_break] = ACTIONS(71),
    [anon_sym_checked] = ACTIONS(73),
    [anon_sym_unchecked] = ACTIONS(73),
    [anon_sym_continue] = ACTIONS(75),
    [anon_sym_do] = ACTIONS(77),
    [anon_sym_while] = ACTIONS(629),
    [anon_sym_for] = ACTIONS(631),
    [anon_sym_await] = ACTIONS(633),
    [anon_sym_foreach] = ACTIONS(635),
    [anon_sym_goto] = ACTIONS(87),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_if] = ACTIONS(637),
    [anon_sym_lock] = ACTIONS(639),
    [anon_sym_switch] = ACTIONS(95),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(97),
    [anon_sym_try] = ACTIONS(99),
    [anon_sym_yield] = ACTIONS(101),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym_void_keyword] = ACTIONS(131),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [135] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4584),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym__variable_designation] = STATE(6459),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1843),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(135),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(653),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(689),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [136] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4584),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym__variable_designation] = STATE(6459),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1843),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(136),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(651),
    [anon_sym_RPAREN] = ACTIONS(711),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(689),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [137] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6491),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4590),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6127),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3890),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(137),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [138] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4587),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(138),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [139] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4584),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(139),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [140] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4593),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6173),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3795),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(140),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [141] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4591),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6173),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3795),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(141),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [142] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4595),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(142),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [143] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4584),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(143),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [144] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4585),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(144),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [145] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4596),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(145),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [146] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6489),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4586),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6135),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3885),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(146),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [147] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4602),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6173),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3795),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(147),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [148] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4601),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6173),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3795),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(148),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [149] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4582),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(149),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [150] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4597),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6173),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3795),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(150),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [151] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4581),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(151),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [152] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4600),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(152),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [153] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4580),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6173),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3795),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(153),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [154] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4598),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6173),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3795),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(154),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [155] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6489),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4588),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6135),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3885),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(155),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [156] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4599),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6173),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3795),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(156),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [157] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4600),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(157),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [158] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4585),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(158),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [159] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4589),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(159),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [160] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4592),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6127),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3796),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(160),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(715),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [161] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6796),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4589),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym__pattern] = STATE(6219),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3909),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1861),
    [sym_global] = STATE(1907),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(161),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_RPAREN] = ACTIONS(719),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(659),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [162] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3186),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(162),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(731),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [163] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3129),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(163),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_SEMI] = ACTIONS(795),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_RBRACK] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_in] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(751),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(751),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(751),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(751),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [164] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3257),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(164),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(795),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_RBRACK] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(825),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [165] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3275),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(165),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(825),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(825),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(825),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(825),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [166] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3315),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(166),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [167] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3314),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(167),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(859),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(859),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(859),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [168] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3234),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(168),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_SEMI] = ACTIONS(795),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_RBRACK] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_in] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [169] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3371),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(169),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [170] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3272),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(170),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_in] = ACTIONS(731),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(893),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(893),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(893),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(893),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [171] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3364),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(171),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(673),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(673),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(673),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(673),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [172] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3402),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(172),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(725),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [173] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3457),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(173),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(795),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(55),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(55),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(55),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(55),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [174] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3705),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(174),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [175] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3446),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(175),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [176] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3629),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(176),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(981),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(981),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(981),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(981),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [177] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3396),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(177),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(795),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(997),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [178] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2710),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(178),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [179] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3713),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(179),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [180] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3464),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(180),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [181] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3863),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(181),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_in] = ACTIONS(731),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [182] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3658),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(182),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_EQ_GT] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [183] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3726),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(183),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_EQ_GT] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1145),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [184] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3760),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(184),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_EQ_GT] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [185] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3423),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(185),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1101),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1101),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1101),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1101),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [186] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3575),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(186),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_EQ_GT] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1181),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [187] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3922),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(187),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_EQ_GT] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1163),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1163),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1163),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1163),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [188] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2665),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(188),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1027),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1027),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1027),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1027),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [189] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3427),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(189),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_EQ_GT] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [190] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3743),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(190),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_in] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1123),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1123),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1123),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1123),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [191] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3632),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(191),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_EQ_GT] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1181),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1181),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1181),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1181),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [192] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3543),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(192),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_COLON] = ACTIONS(795),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1081),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1081),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1081),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1081),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [193] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3399),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(193),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_EQ_GT] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1199),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1199),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1199),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1199),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [194] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2849),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(194),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1217),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1217),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1217),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [195] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2728),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(195),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1217),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1217),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1217),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1217),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [196] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3647),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(196),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [197] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3754),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(197),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [198] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3072),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(198),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1279),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [199] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3843),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(199),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1257),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1257),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1257),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1257),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [200] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3849),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(200),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1301),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1301),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [201] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3535),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(201),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1237),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1237),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1237),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1237),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [202] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3877),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(202),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1321),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1321),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [203] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3638),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(203),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1341),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [204] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3152),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(204),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1361),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [205] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3603),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(205),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [206] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3826),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(206),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1321),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1321),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1321),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1321),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [207] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3593),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(207),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1341),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1341),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1341),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1341),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [208] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3555),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(208),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1381),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1381),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1381),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1381),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [209] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3767),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(209),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1301),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1301),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1301),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1301),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_and] = ACTIONS(731),
    [anon_sym_or] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [210] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3033),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(210),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1279),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1279),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1279),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1279),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [211] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3146),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(211),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1361),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1361),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1361),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1361),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_and] = ACTIONS(797),
    [anon_sym_or] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [212] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2938),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(212),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1401),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1401),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [213] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4183),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(213),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_EQ_GT] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [214] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3051),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(214),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1441),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1441),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1441),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [215] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4374),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(215),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_in] = ACTIONS(731),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1461),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1461),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [216] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2874),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(216),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_COMMA] = ACTIONS(795),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1401),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1401),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1401),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1401),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [217] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4117),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(217),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_in] = ACTIONS(797),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1461),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1461),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1461),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1461),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [218] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3111),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(218),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1441),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1441),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1441),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1441),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [219] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4121),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(219),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_EQ_GT] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1421),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1421),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1421),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1421),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [220] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4094),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(220),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_EQ_GT] = ACTIONS(795),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [221] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3947),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(221),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_EQ_GT] = ACTIONS(725),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1483),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1483),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1483),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1483),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [222] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4363),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(222),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1501),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1501),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1501),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [223] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3302),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(223),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1519),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [224] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4253),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(224),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1537),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1537),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [225] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4037),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(225),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1555),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1555),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [226] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4201),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(226),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1573),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1573),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [227] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4341),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(227),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1573),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1573),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1573),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1573),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [228] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4259),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(228),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1537),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1537),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1537),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1537),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [229] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4009),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(229),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1591),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1591),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1591),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [230] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4043),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(230),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1609),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1609),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [231] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4325),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(231),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1501),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1501),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1501),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1501),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [232] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3968),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(232),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1609),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1609),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1609),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1609),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [233] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4075),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(233),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1555),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1555),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1555),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1555),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [234] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3220),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(234),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1627),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [235] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3200),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(235),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1627),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1627),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1627),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1627),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [236] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4083),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(236),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_EQ] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(797),
    [anon_sym_GT] = ACTIONS(797),
    [anon_sym_DOT] = ACTIONS(797),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(797),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1591),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1591),
    [anon_sym_SLASH] = ACTIONS(797),
    [anon_sym_PERCENT] = ACTIONS(797),
    [anon_sym_CARET] = ACTIONS(1591),
    [anon_sym_PIPE] = ACTIONS(797),
    [anon_sym_AMP] = ACTIONS(1591),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_EQ_EQ] = ACTIONS(795),
    [anon_sym_BANG_EQ] = ACTIONS(795),
    [anon_sym_GT_EQ] = ACTIONS(795),
    [anon_sym_LT_EQ] = ACTIONS(795),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_switch] = ACTIONS(797),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(795),
    [anon_sym_DASH_EQ] = ACTIONS(795),
    [anon_sym_STAR_EQ] = ACTIONS(795),
    [anon_sym_SLASH_EQ] = ACTIONS(795),
    [anon_sym_PERCENT_EQ] = ACTIONS(795),
    [anon_sym_AMP_EQ] = ACTIONS(795),
    [anon_sym_CARET_EQ] = ACTIONS(795),
    [anon_sym_PIPE_EQ] = ACTIONS(795),
    [anon_sym_LT_LT_EQ] = ACTIONS(795),
    [anon_sym_GT_GT_EQ] = ACTIONS(795),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(795),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym_is] = ACTIONS(797),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_DASH_GT] = ACTIONS(795),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_with] = ACTIONS(797),
    [anon_sym_AMP_AMP] = ACTIONS(795),
    [anon_sym_PIPE_PIPE] = ACTIONS(795),
    [anon_sym_QMARK_QMARK] = ACTIONS(797),
    [anon_sym_as] = ACTIONS(797),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [237] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3327),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(237),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_EQ] = ACTIONS(731),
    [anon_sym_LT] = ACTIONS(731),
    [anon_sym_GT] = ACTIONS(731),
    [anon_sym_DOT] = ACTIONS(731),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(731),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1519),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1519),
    [anon_sym_SLASH] = ACTIONS(731),
    [anon_sym_PERCENT] = ACTIONS(731),
    [anon_sym_CARET] = ACTIONS(1519),
    [anon_sym_PIPE] = ACTIONS(731),
    [anon_sym_AMP] = ACTIONS(1519),
    [anon_sym_LT_LT] = ACTIONS(731),
    [anon_sym_GT_GT] = ACTIONS(731),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_switch] = ACTIONS(731),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(725),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym_is] = ACTIONS(731),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_DASH_GT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_with] = ACTIONS(731),
    [anon_sym_AMP_AMP] = ACTIONS(725),
    [anon_sym_PIPE_PIPE] = ACTIONS(725),
    [anon_sym_QMARK_QMARK] = ACTIONS(731),
    [anon_sym_as] = ACTIONS(731),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [238] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym__variable_designation] = STATE(6393),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3833),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3833),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3833),
    [sym_invocation_expression] = STATE(3833),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3833),
    [sym_postfix_unary_expression] = STATE(3833),
    [sym_prefix_unary_expression] = STATE(3833),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3833),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3833),
    [sym_type_of_expression] = STATE(3833),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4126),
    [sym_binary_expression] = STATE(3833),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1869),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3833),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(238),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(689),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [239] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym__variable_designation] = STATE(6422),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3833),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3833),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3833),
    [sym_invocation_expression] = STATE(3833),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3833),
    [sym_postfix_unary_expression] = STATE(3833),
    [sym_prefix_unary_expression] = STATE(3833),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3833),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3833),
    [sym_type_of_expression] = STATE(3833),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4126),
    [sym_binary_expression] = STATE(3833),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1869),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3833),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(239),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(689),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [240] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym__variable_designation] = STATE(6459),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3833),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3833),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3833),
    [sym_invocation_expression] = STATE(3833),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3833),
    [sym_postfix_unary_expression] = STATE(3833),
    [sym_prefix_unary_expression] = STATE(3833),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3833),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3833),
    [sym_type_of_expression] = STATE(3833),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4126),
    [sym_binary_expression] = STATE(3833),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1869),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3833),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(240),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(689),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [241] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym__variable_designation] = STATE(6305),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6730),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3833),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3833),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3833),
    [sym_invocation_expression] = STATE(3833),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3833),
    [sym_postfix_unary_expression] = STATE(3833),
    [sym_prefix_unary_expression] = STATE(3833),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3833),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3833),
    [sym_type_of_expression] = STATE(3833),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4126),
    [sym_binary_expression] = STATE(3833),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1869),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3833),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(241),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1635),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1637),
    [anon_sym_RPAREN] = ACTIONS(1639),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(689),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [242] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6350),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3682),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1825),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(242),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(1641),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1643),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [243] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6350),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3833),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3833),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3833),
    [sym_invocation_expression] = STATE(3833),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3833),
    [sym_postfix_unary_expression] = STATE(3833),
    [sym_prefix_unary_expression] = STATE(3833),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3833),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3833),
    [sym_type_of_expression] = STATE(3833),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4126),
    [sym_binary_expression] = STATE(3833),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1825),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3833),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(243),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(1645),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1647),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [244] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6350),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3682),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1825),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(244),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(1649),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1651),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [245] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1914),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6350),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3682),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1825),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(245),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_COMMA] = ACTIONS(1653),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1655),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [246] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6320),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(246),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1661),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1665),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [247] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6356),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(247),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1671),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1673),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [248] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6409),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(248),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1675),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1677),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [249] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6272),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3833),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3833),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3833),
    [sym_invocation_expression] = STATE(3833),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3833),
    [sym_postfix_unary_expression] = STATE(3833),
    [sym_prefix_unary_expression] = STATE(3833),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3833),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3833),
    [sym_type_of_expression] = STATE(3833),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4126),
    [sym_binary_expression] = STATE(3833),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1825),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3833),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(249),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1679),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [250] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6379),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(250),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1681),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1683),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [251] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6272),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3833),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3833),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3833),
    [sym_invocation_expression] = STATE(3833),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3833),
    [sym_postfix_unary_expression] = STATE(3833),
    [sym_prefix_unary_expression] = STATE(3833),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3833),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3833),
    [sym_type_of_expression] = STATE(3833),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4126),
    [sym_binary_expression] = STATE(3833),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1825),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3833),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(251),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1685),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [252] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6241),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(252),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_COMMA] = ACTIONS(1687),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1689),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [253] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(253),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1691),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [254] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(254),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1693),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [255] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6941),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3414),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(255),
    [aux_sym_event_field_declaration_repeat2] = STATE(2046),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_using] = ACTIONS(1695),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_foreach] = ACTIONS(1697),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [256] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6679),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3414),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(256),
    [aux_sym_event_field_declaration_repeat2] = STATE(2049),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_using] = ACTIONS(1699),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_foreach] = ACTIONS(1701),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [257] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6270),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3833),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3833),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3833),
    [sym_invocation_expression] = STATE(3833),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3833),
    [sym_postfix_unary_expression] = STATE(3833),
    [sym_prefix_unary_expression] = STATE(3833),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3833),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3833),
    [sym_type_of_expression] = STATE(3833),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4126),
    [sym_binary_expression] = STATE(3833),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1825),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3833),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(257),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [258] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(258),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1703),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [259] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(259),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1705),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [260] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(260),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1707),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [261] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(261),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1709),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [262] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(262),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1711),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [263] = {
    [sym__name] = STATE(4617),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5962),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_expression_colon] = STATE(288),
    [sym_subpattern] = STATE(6272),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3833),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3833),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3833),
    [sym_invocation_expression] = STATE(3833),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3833),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3833),
    [sym_postfix_unary_expression] = STATE(3833),
    [sym_prefix_unary_expression] = STATE(3833),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3833),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3833),
    [sym_type_of_expression] = STATE(3833),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4126),
    [sym_binary_expression] = STATE(3833),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1825),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3833),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(263),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(713),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [264] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6941),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3414),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(264),
    [aux_sym_event_field_declaration_repeat2] = STATE(2046),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_using] = ACTIONS(1695),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_foreach] = ACTIONS(1697),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [265] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(265),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1713),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [266] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(266),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1715),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [267] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(267),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_RBRACE] = ACTIONS(1717),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [268] = {
    [sym__name] = STATE(4827),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6679),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3414),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(268),
    [aux_sym_event_field_declaration_repeat2] = STATE(2049),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_using] = ACTIONS(1719),
    [anon_sym_static] = ACTIONS(324),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(330),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(334),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(336),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_foreach] = ACTIONS(1721),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [269] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5959),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_switch_expression_arm] = STATE(6509),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(269),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [270] = {
    [sym__name] = STATE(1985),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1962),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1773),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1828),
    [sym_property_pattern_clause] = STATE(1881),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4405),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(270),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1723),
    [anon_sym_GT] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1725),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_GT_EQ] = ACTIONS(1729),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1737),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [271] = {
    [sym__name] = STATE(2013),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2016),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1830),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3255),
    [sym_type_pattern] = STATE(3336),
    [sym_parenthesized_pattern] = STATE(3336),
    [sym_relational_pattern] = STATE(3336),
    [sym_negated_pattern] = STATE(3336),
    [sym_binary_pattern] = STATE(3336),
    [sym_constant_pattern] = STATE(3336),
    [sym_declaration_pattern] = STATE(3336),
    [sym_recursive_pattern] = STATE(3336),
    [sym_positional_pattern_clause] = STATE(1875),
    [sym_property_pattern_clause] = STATE(1947),
    [sym_var_pattern] = STATE(3336),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3262),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3262),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3262),
    [sym_invocation_expression] = STATE(3262),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3262),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3262),
    [sym_postfix_unary_expression] = STATE(3262),
    [sym_prefix_unary_expression] = STATE(3262),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3262),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3262),
    [sym_type_of_expression] = STATE(3262),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4408),
    [sym_binary_expression] = STATE(3262),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(3262),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(271),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_GT] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1743),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1745),
    [sym_predefined_type] = ACTIONS(1747),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_not] = ACTIONS(1749),
    [sym_discard] = ACTIONS(1751),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [272] = {
    [sym__name] = STATE(1977),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1962),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1772),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2964),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1828),
    [sym_property_pattern_clause] = STATE(1881),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(272),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_GT] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1755),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1757),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1759),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [273] = {
    [sym__name] = STATE(1979),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1757),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4481),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4419),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(273),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1763),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_GT_EQ] = ACTIONS(1765),
    [anon_sym_LT_EQ] = ACTIONS(1765),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1767),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [274] = {
    [sym__name] = STATE(2007),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1991),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1858),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1895),
    [sym_property_pattern_clause] = STATE(1953),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4477),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(274),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1775),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [275] = {
    [sym__name] = STATE(2000),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2004),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1836),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4460),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1886),
    [sym_property_pattern_clause] = STATE(1930),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4462),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(275),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [anon_sym_LT_EQ] = ACTIONS(1781),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1783),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [276] = {
    [sym__name] = STATE(1985),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1962),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1773),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4323),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1828),
    [sym_property_pattern_clause] = STATE(1881),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4405),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(276),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1723),
    [anon_sym_GT] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1725),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_GT_EQ] = ACTIONS(1729),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1737),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [277] = {
    [sym__name] = STATE(1915),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1758),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2964),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4441),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(277),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1785),
    [anon_sym_GT] = ACTIONS(1785),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(1789),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1791),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [278] = {
    [sym__name] = STATE(1993),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2017),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1826),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2798),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1882),
    [sym_property_pattern_clause] = STATE(1944),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4413),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(278),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1797),
    [anon_sym_LT_EQ] = ACTIONS(1797),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1803),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [279] = {
    [sym__name] = STATE(2015),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1990),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1860),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4149),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1892),
    [sym_property_pattern_clause] = STATE(1933),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4426),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(279),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_GT] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1811),
    [anon_sym_LT_EQ] = ACTIONS(1811),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1813),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [280] = {
    [sym__name] = STATE(1982),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1814),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2964),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1866),
    [sym_property_pattern_clause] = STATE(1905),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4403),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(280),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_GT] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_GT_EQ] = ACTIONS(1819),
    [anon_sym_LT_EQ] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1821),
    [sym_predefined_type] = ACTIONS(1823),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1825),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [281] = {
    [sym__name] = STATE(2012),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2019),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1839),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4457),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1890),
    [sym_property_pattern_clause] = STATE(1937),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4484),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(281),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1831),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1833),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [282] = {
    [sym__name] = STATE(1985),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1962),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1772),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2964),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1828),
    [sym_property_pattern_clause] = STATE(1881),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4405),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(282),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1723),
    [anon_sym_GT] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1725),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_GT_EQ] = ACTIONS(1729),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1737),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [283] = {
    [sym__name] = STATE(1969),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1956),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1779),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3938),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1827),
    [sym_property_pattern_clause] = STATE(1889),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4486),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(283),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1835),
    [anon_sym_GT] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1837),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_GT_EQ] = ACTIONS(1839),
    [anon_sym_LT_EQ] = ACTIONS(1839),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1841),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [284] = {
    [sym__name] = STATE(1969),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1956),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1779),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4068),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1827),
    [sym_property_pattern_clause] = STATE(1889),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4486),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(284),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1835),
    [anon_sym_GT] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1837),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_GT_EQ] = ACTIONS(1839),
    [anon_sym_LT_EQ] = ACTIONS(1839),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1841),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [285] = {
    [sym__name] = STATE(1968),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1980),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1789),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3000),
    [sym_type_pattern] = STATE(3067),
    [sym_parenthesized_pattern] = STATE(3067),
    [sym_relational_pattern] = STATE(3067),
    [sym_negated_pattern] = STATE(3067),
    [sym_binary_pattern] = STATE(3067),
    [sym_constant_pattern] = STATE(3067),
    [sym_declaration_pattern] = STATE(3067),
    [sym_recursive_pattern] = STATE(3067),
    [sym_positional_pattern_clause] = STATE(1863),
    [sym_property_pattern_clause] = STATE(1900),
    [sym_var_pattern] = STATE(3067),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2997),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2997),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2997),
    [sym_invocation_expression] = STATE(2997),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2997),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2997),
    [sym_postfix_unary_expression] = STATE(2997),
    [sym_prefix_unary_expression] = STATE(2997),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2997),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2997),
    [sym_type_of_expression] = STATE(2997),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4415),
    [sym_binary_expression] = STATE(2997),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2997),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(285),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_GT] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_GT_EQ] = ACTIONS(1847),
    [anon_sym_LT_EQ] = ACTIONS(1847),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1849),
    [sym_predefined_type] = ACTIONS(1851),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_not] = ACTIONS(1853),
    [sym_discard] = ACTIONS(1855),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [286] = {
    [sym__name] = STATE(1972),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1956),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1779),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4041),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1827),
    [sym_property_pattern_clause] = STATE(1889),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4470),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(286),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_EQ] = ACTIONS(1861),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1863),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [287] = {
    [sym__name] = STATE(1993),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2017),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1826),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4313),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1882),
    [sym_property_pattern_clause] = STATE(1944),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4413),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(287),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1797),
    [anon_sym_LT_EQ] = ACTIONS(1797),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1803),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [288] = {
    [sym__name] = STATE(4618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(6000),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3681),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3681),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3681),
    [sym_invocation_expression] = STATE(3681),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3681),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3681),
    [sym_postfix_unary_expression] = STATE(3681),
    [sym_prefix_unary_expression] = STATE(3681),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3681),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3681),
    [sym_type_of_expression] = STATE(3681),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4424),
    [sym_binary_expression] = STATE(3681),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3681),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(288),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [289] = {
    [sym__name] = STATE(2000),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2004),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1841),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2964),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1886),
    [sym_property_pattern_clause] = STATE(1930),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4462),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(289),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [anon_sym_LT_EQ] = ACTIONS(1781),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1783),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [290] = {
    [sym__name] = STATE(1987),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1754),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4266),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4434),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(290),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_GT_EQ] = ACTIONS(1871),
    [anon_sym_LT_EQ] = ACTIONS(1871),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1873),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [291] = {
    [sym__name] = STATE(1868),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1755),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2769),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4439),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(291),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_GT] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_LT_EQ] = ACTIONS(1879),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1881),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [292] = {
    [sym__name] = STATE(1987),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1754),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4337),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4434),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(292),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_GT_EQ] = ACTIONS(1871),
    [anon_sym_LT_EQ] = ACTIONS(1871),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1873),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [293] = {
    [sym__name] = STATE(1915),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1756),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3739),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4441),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(293),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1785),
    [anon_sym_GT] = ACTIONS(1785),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(1789),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1791),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [294] = {
    [sym__name] = STATE(1993),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2017),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1826),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4291),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1882),
    [sym_property_pattern_clause] = STATE(1944),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4413),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(294),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1797),
    [anon_sym_LT_EQ] = ACTIONS(1797),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1803),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [295] = {
    [sym__name] = STATE(1979),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1756),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4433),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4419),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(295),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1763),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_GT_EQ] = ACTIONS(1765),
    [anon_sym_LT_EQ] = ACTIONS(1765),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1767),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [296] = {
    [sym__name] = STATE(1969),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1956),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1779),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2798),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1827),
    [sym_property_pattern_clause] = STATE(1889),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4486),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(296),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1835),
    [anon_sym_GT] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1837),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_GT_EQ] = ACTIONS(1839),
    [anon_sym_LT_EQ] = ACTIONS(1839),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1841),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [297] = {
    [sym__name] = STATE(2015),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1990),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1854),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4370),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1892),
    [sym_property_pattern_clause] = STATE(1933),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4426),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(297),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_GT] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1811),
    [anon_sym_LT_EQ] = ACTIONS(1811),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1813),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [298] = {
    [sym__name] = STATE(2012),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2019),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1850),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4476),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1890),
    [sym_property_pattern_clause] = STATE(1937),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4484),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(298),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1831),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1833),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [299] = {
    [sym__name] = STATE(1969),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1956),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1777),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2769),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1827),
    [sym_property_pattern_clause] = STATE(1889),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4486),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(299),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1835),
    [anon_sym_GT] = ACTIONS(1835),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1837),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_GT_EQ] = ACTIONS(1839),
    [anon_sym_LT_EQ] = ACTIONS(1839),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1841),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [300] = {
    [sym__name] = STATE(1913),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1755),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2769),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4487),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(300),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(1887),
    [anon_sym_LT_EQ] = ACTIONS(1887),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1889),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [301] = {
    [sym__name] = STATE(1972),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1956),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1777),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2769),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1827),
    [sym_property_pattern_clause] = STATE(1889),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4470),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(301),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_EQ] = ACTIONS(1861),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1863),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [302] = {
    [sym__name] = STATE(2013),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2016),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1845),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3338),
    [sym_type_pattern] = STATE(3336),
    [sym_parenthesized_pattern] = STATE(3336),
    [sym_relational_pattern] = STATE(3336),
    [sym_negated_pattern] = STATE(3336),
    [sym_binary_pattern] = STATE(3336),
    [sym_constant_pattern] = STATE(3336),
    [sym_declaration_pattern] = STATE(3336),
    [sym_recursive_pattern] = STATE(3336),
    [sym_positional_pattern_clause] = STATE(1875),
    [sym_property_pattern_clause] = STATE(1947),
    [sym_var_pattern] = STATE(3336),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3262),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3262),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3262),
    [sym_invocation_expression] = STATE(3262),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3262),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3262),
    [sym_postfix_unary_expression] = STATE(3262),
    [sym_prefix_unary_expression] = STATE(3262),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3262),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3262),
    [sym_type_of_expression] = STATE(3262),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4408),
    [sym_binary_expression] = STATE(3262),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(3262),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(302),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_GT] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1743),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1745),
    [sym_predefined_type] = ACTIONS(1747),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_not] = ACTIONS(1749),
    [sym_discard] = ACTIONS(1751),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [303] = {
    [sym__name] = STATE(2007),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1991),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1832),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2964),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1895),
    [sym_property_pattern_clause] = STATE(1953),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4477),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(303),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1775),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [304] = {
    [sym__name] = STATE(2000),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2004),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1849),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4485),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1886),
    [sym_property_pattern_clause] = STATE(1930),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4462),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(304),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [anon_sym_LT_EQ] = ACTIONS(1781),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1783),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [305] = {
    [sym__name] = STATE(1973),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1984),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1815),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3000),
    [sym_type_pattern] = STATE(3067),
    [sym_parenthesized_pattern] = STATE(3067),
    [sym_relational_pattern] = STATE(3067),
    [sym_negated_pattern] = STATE(3067),
    [sym_binary_pattern] = STATE(3067),
    [sym_constant_pattern] = STATE(3067),
    [sym_declaration_pattern] = STATE(3067),
    [sym_recursive_pattern] = STATE(3067),
    [sym_positional_pattern_clause] = STATE(1865),
    [sym_property_pattern_clause] = STATE(1897),
    [sym_var_pattern] = STATE(3067),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2997),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2997),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2997),
    [sym_invocation_expression] = STATE(2997),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2997),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2997),
    [sym_postfix_unary_expression] = STATE(2997),
    [sym_prefix_unary_expression] = STATE(2997),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2997),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2997),
    [sym_type_of_expression] = STATE(2997),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4478),
    [sym_binary_expression] = STATE(2997),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2997),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(305),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_GT] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1895),
    [anon_sym_LT_EQ] = ACTIONS(1895),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1849),
    [sym_predefined_type] = ACTIONS(1851),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_not] = ACTIONS(1897),
    [sym_discard] = ACTIONS(1855),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [306] = {
    [sym__name] = STATE(1870),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1756),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3665),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4424),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(306),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_GT_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1903),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1905),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [307] = {
    [sym__name] = STATE(2005),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1994),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1842),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2769),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1874),
    [sym_property_pattern_clause] = STATE(1925),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4427),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(307),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_GT] = ACTIONS(1907),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1911),
    [anon_sym_LT_EQ] = ACTIONS(1911),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1913),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [308] = {
    [sym__name] = STATE(1982),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1816),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4417),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1866),
    [sym_property_pattern_clause] = STATE(1905),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4403),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(308),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_GT] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_GT_EQ] = ACTIONS(1819),
    [anon_sym_LT_EQ] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1821),
    [sym_predefined_type] = ACTIONS(1823),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1825),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [309] = {
    [sym__name] = STATE(1987),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1753),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4146),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4434),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(309),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_GT_EQ] = ACTIONS(1871),
    [anon_sym_LT_EQ] = ACTIONS(1871),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1873),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [310] = {
    [sym__name] = STATE(1993),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2017),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1840),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4236),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1882),
    [sym_property_pattern_clause] = STATE(1944),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4413),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(310),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1797),
    [anon_sym_LT_EQ] = ACTIONS(1797),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1803),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [311] = {
    [sym__name] = STATE(1979),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1758),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2964),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4419),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(311),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1763),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_GT_EQ] = ACTIONS(1765),
    [anon_sym_LT_EQ] = ACTIONS(1765),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1767),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [312] = {
    [sym__name] = STATE(2015),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1990),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1821),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2769),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1892),
    [sym_property_pattern_clause] = STATE(1933),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4426),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(312),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_GT] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1811),
    [anon_sym_LT_EQ] = ACTIONS(1811),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1813),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [313] = {
    [sym__name] = STATE(2012),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2019),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1837),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2964),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1890),
    [sym_property_pattern_clause] = STATE(1937),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4484),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(313),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1831),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1833),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [314] = {
    [sym__name] = STATE(1870),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1757),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4424),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(314),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_GT_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1903),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1905),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [315] = {
    [sym__name] = STATE(1987),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1755),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2769),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4434),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(315),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_GT_EQ] = ACTIONS(1871),
    [anon_sym_LT_EQ] = ACTIONS(1871),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1873),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [316] = {
    [sym__name] = STATE(2007),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1991),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1858),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4474),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1895),
    [sym_property_pattern_clause] = STATE(1953),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4477),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(316),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1775),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [317] = {
    [sym__name] = STATE(1987),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1754),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2798),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4434),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(317),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1867),
    [anon_sym_GT] = ACTIONS(1867),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1869),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_GT_EQ] = ACTIONS(1871),
    [anon_sym_LT_EQ] = ACTIONS(1871),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1873),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [318] = {
    [sym__name] = STATE(1993),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2017),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1838),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2769),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1882),
    [sym_property_pattern_clause] = STATE(1944),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4413),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(318),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1793),
    [anon_sym_GT] = ACTIONS(1793),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1795),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_GT_EQ] = ACTIONS(1797),
    [anon_sym_LT_EQ] = ACTIONS(1797),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1803),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [319] = {
    [sym__name] = STATE(1982),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1816),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1866),
    [sym_property_pattern_clause] = STATE(1905),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4403),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(319),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_GT] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_GT_EQ] = ACTIONS(1819),
    [anon_sym_LT_EQ] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1821),
    [sym_predefined_type] = ACTIONS(1823),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1825),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [320] = {
    [sym__name] = STATE(1982),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1816),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4404),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1866),
    [sym_property_pattern_clause] = STATE(1905),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4403),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(320),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_GT] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_GT_EQ] = ACTIONS(1819),
    [anon_sym_LT_EQ] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1821),
    [sym_predefined_type] = ACTIONS(1823),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1825),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [321] = {
    [sym__name] = STATE(1913),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1754),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3561),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4487),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(321),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(1887),
    [anon_sym_LT_EQ] = ACTIONS(1887),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1889),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [322] = {
    [sym__name] = STATE(1968),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1980),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1792),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3136),
    [sym_type_pattern] = STATE(3067),
    [sym_parenthesized_pattern] = STATE(3067),
    [sym_relational_pattern] = STATE(3067),
    [sym_negated_pattern] = STATE(3067),
    [sym_binary_pattern] = STATE(3067),
    [sym_constant_pattern] = STATE(3067),
    [sym_declaration_pattern] = STATE(3067),
    [sym_recursive_pattern] = STATE(3067),
    [sym_positional_pattern_clause] = STATE(1863),
    [sym_property_pattern_clause] = STATE(1900),
    [sym_var_pattern] = STATE(3067),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2997),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2997),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2997),
    [sym_invocation_expression] = STATE(2997),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2997),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2997),
    [sym_postfix_unary_expression] = STATE(2997),
    [sym_prefix_unary_expression] = STATE(2997),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2997),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2997),
    [sym_type_of_expression] = STATE(2997),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4415),
    [sym_binary_expression] = STATE(2997),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2997),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(322),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_GT] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_GT_EQ] = ACTIONS(1847),
    [anon_sym_LT_EQ] = ACTIONS(1847),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1849),
    [sym_predefined_type] = ACTIONS(1851),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_not] = ACTIONS(1853),
    [sym_discard] = ACTIONS(1855),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [323] = {
    [sym__name] = STATE(2005),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1994),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1856),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4192),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1874),
    [sym_property_pattern_clause] = STATE(1925),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4427),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_GT] = ACTIONS(1907),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1911),
    [anon_sym_LT_EQ] = ACTIONS(1911),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1913),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [324] = {
    [sym__name] = STATE(1870),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1757),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3549),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4424),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(324),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_GT_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1903),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1905),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [325] = {
    [sym__name] = STATE(1870),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1758),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2964),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4424),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(325),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_GT_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1903),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1905),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [326] = {
    [sym__name] = STATE(1913),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1753),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3583),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4487),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(326),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(1887),
    [anon_sym_LT_EQ] = ACTIONS(1887),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1889),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [327] = {
    [sym__name] = STATE(1977),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1962),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1773),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4287),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1828),
    [sym_property_pattern_clause] = STATE(1881),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(327),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_GT] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1755),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1757),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1759),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [328] = {
    [sym__name] = STATE(1973),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1984),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1783),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3042),
    [sym_type_pattern] = STATE(3067),
    [sym_parenthesized_pattern] = STATE(3067),
    [sym_relational_pattern] = STATE(3067),
    [sym_negated_pattern] = STATE(3067),
    [sym_binary_pattern] = STATE(3067),
    [sym_constant_pattern] = STATE(3067),
    [sym_declaration_pattern] = STATE(3067),
    [sym_recursive_pattern] = STATE(3067),
    [sym_positional_pattern_clause] = STATE(1865),
    [sym_property_pattern_clause] = STATE(1897),
    [sym_var_pattern] = STATE(3067),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2997),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2997),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2997),
    [sym_invocation_expression] = STATE(2997),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2997),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2997),
    [sym_postfix_unary_expression] = STATE(2997),
    [sym_prefix_unary_expression] = STATE(2997),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2997),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2997),
    [sym_type_of_expression] = STATE(2997),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4478),
    [sym_binary_expression] = STATE(2997),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2997),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(328),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_GT] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1895),
    [anon_sym_LT_EQ] = ACTIONS(1895),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1849),
    [sym_predefined_type] = ACTIONS(1851),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_not] = ACTIONS(1897),
    [sym_discard] = ACTIONS(1855),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [329] = {
    [sym__name] = STATE(2013),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2016),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1847),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3276),
    [sym_type_pattern] = STATE(3336),
    [sym_parenthesized_pattern] = STATE(3336),
    [sym_relational_pattern] = STATE(3336),
    [sym_negated_pattern] = STATE(3336),
    [sym_binary_pattern] = STATE(3336),
    [sym_constant_pattern] = STATE(3336),
    [sym_declaration_pattern] = STATE(3336),
    [sym_recursive_pattern] = STATE(3336),
    [sym_positional_pattern_clause] = STATE(1875),
    [sym_property_pattern_clause] = STATE(1947),
    [sym_var_pattern] = STATE(3336),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3262),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3262),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3262),
    [sym_invocation_expression] = STATE(3262),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3262),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3262),
    [sym_postfix_unary_expression] = STATE(3262),
    [sym_prefix_unary_expression] = STATE(3262),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3262),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3262),
    [sym_type_of_expression] = STATE(3262),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4408),
    [sym_binary_expression] = STATE(3262),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(3262),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(329),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_GT] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1743),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1745),
    [sym_predefined_type] = ACTIONS(1747),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_not] = ACTIONS(1749),
    [sym_discard] = ACTIONS(1751),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [330] = {
    [sym__name] = STATE(2000),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2004),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1849),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1886),
    [sym_property_pattern_clause] = STATE(1930),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4462),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(330),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [anon_sym_LT_EQ] = ACTIONS(1781),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1783),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [331] = {
    [sym__name] = STATE(2000),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2004),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1849),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4451),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1886),
    [sym_property_pattern_clause] = STATE(1930),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4462),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(331),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1777),
    [anon_sym_GT] = ACTIONS(1777),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1779),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_GT_EQ] = ACTIONS(1781),
    [anon_sym_LT_EQ] = ACTIONS(1781),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1783),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [332] = {
    [sym__name] = STATE(2015),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1990),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1860),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2798),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1892),
    [sym_property_pattern_clause] = STATE(1933),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4426),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(332),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_GT] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1811),
    [anon_sym_LT_EQ] = ACTIONS(1811),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1813),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [333] = {
    [sym__name] = STATE(2013),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2016),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1847),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3247),
    [sym_type_pattern] = STATE(3336),
    [sym_parenthesized_pattern] = STATE(3336),
    [sym_relational_pattern] = STATE(3336),
    [sym_negated_pattern] = STATE(3336),
    [sym_binary_pattern] = STATE(3336),
    [sym_constant_pattern] = STATE(3336),
    [sym_declaration_pattern] = STATE(3336),
    [sym_recursive_pattern] = STATE(3336),
    [sym_positional_pattern_clause] = STATE(1875),
    [sym_property_pattern_clause] = STATE(1947),
    [sym_var_pattern] = STATE(3336),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3262),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3262),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3262),
    [sym_invocation_expression] = STATE(3262),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3262),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3262),
    [sym_postfix_unary_expression] = STATE(3262),
    [sym_prefix_unary_expression] = STATE(3262),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3262),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3262),
    [sym_type_of_expression] = STATE(3262),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4408),
    [sym_binary_expression] = STATE(3262),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(3262),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(333),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_GT] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1743),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1745),
    [sym_predefined_type] = ACTIONS(1747),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_not] = ACTIONS(1749),
    [sym_discard] = ACTIONS(1751),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [334] = {
    [sym__name] = STATE(1913),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1754),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3624),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4487),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(334),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(1887),
    [anon_sym_LT_EQ] = ACTIONS(1887),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1889),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [335] = {
    [sym__name] = STATE(2013),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2016),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1847),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3239),
    [sym_type_pattern] = STATE(3336),
    [sym_parenthesized_pattern] = STATE(3336),
    [sym_relational_pattern] = STATE(3336),
    [sym_negated_pattern] = STATE(3336),
    [sym_binary_pattern] = STATE(3336),
    [sym_constant_pattern] = STATE(3336),
    [sym_declaration_pattern] = STATE(3336),
    [sym_recursive_pattern] = STATE(3336),
    [sym_positional_pattern_clause] = STATE(1875),
    [sym_property_pattern_clause] = STATE(1947),
    [sym_var_pattern] = STATE(3336),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3262),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3262),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3262),
    [sym_invocation_expression] = STATE(3262),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3262),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3262),
    [sym_postfix_unary_expression] = STATE(3262),
    [sym_prefix_unary_expression] = STATE(3262),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3262),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3262),
    [sym_type_of_expression] = STATE(3262),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4408),
    [sym_binary_expression] = STATE(3262),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(3262),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(335),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1739),
    [anon_sym_GT] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1741),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_GT_EQ] = ACTIONS(1743),
    [anon_sym_LT_EQ] = ACTIONS(1743),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1745),
    [sym_predefined_type] = ACTIONS(1747),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_not] = ACTIONS(1749),
    [sym_discard] = ACTIONS(1751),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [336] = {
    [sym__name] = STATE(1913),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1754),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2798),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4487),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(336),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1883),
    [anon_sym_GT] = ACTIONS(1883),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1885),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_GT_EQ] = ACTIONS(1887),
    [anon_sym_LT_EQ] = ACTIONS(1887),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1889),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [337] = {
    [sym__name] = STATE(1973),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1984),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1788),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3010),
    [sym_type_pattern] = STATE(3067),
    [sym_parenthesized_pattern] = STATE(3067),
    [sym_relational_pattern] = STATE(3067),
    [sym_negated_pattern] = STATE(3067),
    [sym_binary_pattern] = STATE(3067),
    [sym_constant_pattern] = STATE(3067),
    [sym_declaration_pattern] = STATE(3067),
    [sym_recursive_pattern] = STATE(3067),
    [sym_positional_pattern_clause] = STATE(1865),
    [sym_property_pattern_clause] = STATE(1897),
    [sym_var_pattern] = STATE(3067),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2997),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2997),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2997),
    [sym_invocation_expression] = STATE(2997),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2997),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2997),
    [sym_postfix_unary_expression] = STATE(2997),
    [sym_prefix_unary_expression] = STATE(2997),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2997),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2997),
    [sym_type_of_expression] = STATE(2997),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4478),
    [sym_binary_expression] = STATE(2997),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2997),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(337),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_GT] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1895),
    [anon_sym_LT_EQ] = ACTIONS(1895),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1849),
    [sym_predefined_type] = ACTIONS(1851),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_not] = ACTIONS(1897),
    [sym_discard] = ACTIONS(1855),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [338] = {
    [sym__name] = STATE(1968),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1980),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1813),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3161),
    [sym_type_pattern] = STATE(3067),
    [sym_parenthesized_pattern] = STATE(3067),
    [sym_relational_pattern] = STATE(3067),
    [sym_negated_pattern] = STATE(3067),
    [sym_binary_pattern] = STATE(3067),
    [sym_constant_pattern] = STATE(3067),
    [sym_declaration_pattern] = STATE(3067),
    [sym_recursive_pattern] = STATE(3067),
    [sym_positional_pattern_clause] = STATE(1863),
    [sym_property_pattern_clause] = STATE(1900),
    [sym_var_pattern] = STATE(3067),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2997),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2997),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2997),
    [sym_invocation_expression] = STATE(2997),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2997),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2997),
    [sym_postfix_unary_expression] = STATE(2997),
    [sym_prefix_unary_expression] = STATE(2997),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2997),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2997),
    [sym_type_of_expression] = STATE(2997),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4415),
    [sym_binary_expression] = STATE(2997),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2997),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(338),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_GT] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_GT_EQ] = ACTIONS(1847),
    [anon_sym_LT_EQ] = ACTIONS(1847),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1849),
    [sym_predefined_type] = ACTIONS(1851),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_not] = ACTIONS(1853),
    [sym_discard] = ACTIONS(1855),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [339] = {
    [sym__name] = STATE(1868),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1754),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3366),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4439),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(339),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_GT] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_LT_EQ] = ACTIONS(1879),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1881),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [340] = {
    [sym__name] = STATE(1868),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1754),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2798),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4439),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(340),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_GT] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_LT_EQ] = ACTIONS(1879),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1881),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [341] = {
    [sym__name] = STATE(2010),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2002),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1822),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3392),
    [sym_type_pattern] = STATE(3336),
    [sym_parenthesized_pattern] = STATE(3336),
    [sym_relational_pattern] = STATE(3336),
    [sym_negated_pattern] = STATE(3336),
    [sym_binary_pattern] = STATE(3336),
    [sym_constant_pattern] = STATE(3336),
    [sym_declaration_pattern] = STATE(3336),
    [sym_recursive_pattern] = STATE(3336),
    [sym_positional_pattern_clause] = STATE(1880),
    [sym_property_pattern_clause] = STATE(1945),
    [sym_var_pattern] = STATE(3336),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3262),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3262),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3262),
    [sym_invocation_expression] = STATE(3262),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3262),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3262),
    [sym_postfix_unary_expression] = STATE(3262),
    [sym_prefix_unary_expression] = STATE(3262),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3262),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3262),
    [sym_type_of_expression] = STATE(3262),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4430),
    [sym_binary_expression] = STATE(3262),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(3262),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(341),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1917),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_GT_EQ] = ACTIONS(1919),
    [anon_sym_LT_EQ] = ACTIONS(1919),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1921),
    [sym_predefined_type] = ACTIONS(1923),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_not] = ACTIONS(1925),
    [sym_discard] = ACTIONS(1751),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [342] = {
    [sym__name] = STATE(4651),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(6041),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3681),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3681),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3681),
    [sym_invocation_expression] = STATE(3681),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3681),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3681),
    [sym_postfix_unary_expression] = STATE(3681),
    [sym_prefix_unary_expression] = STATE(3681),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3681),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3681),
    [sym_type_of_expression] = STATE(3681),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4215),
    [sym_binary_expression] = STATE(3681),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1909),
    [sym_global] = STATE(1967),
    [sym__literal] = STATE(3681),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(342),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LT] = ACTIONS(1927),
    [anon_sym_GT] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1929),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1931),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_GT_EQ] = ACTIONS(1933),
    [anon_sym_LT_EQ] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1935),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [343] = {
    [sym__name] = STATE(1870),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1757),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3525),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4424),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(343),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1899),
    [anon_sym_GT] = ACTIONS(1899),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1901),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_GT_EQ] = ACTIONS(1903),
    [anon_sym_LT_EQ] = ACTIONS(1903),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1905),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [344] = {
    [sym__name] = STATE(2012),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2019),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1839),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4450),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1890),
    [sym_property_pattern_clause] = STATE(1937),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4484),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(344),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1831),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1833),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [345] = {
    [sym__name] = STATE(1973),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1984),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1788),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3124),
    [sym_type_pattern] = STATE(3067),
    [sym_parenthesized_pattern] = STATE(3067),
    [sym_relational_pattern] = STATE(3067),
    [sym_negated_pattern] = STATE(3067),
    [sym_binary_pattern] = STATE(3067),
    [sym_constant_pattern] = STATE(3067),
    [sym_declaration_pattern] = STATE(3067),
    [sym_recursive_pattern] = STATE(3067),
    [sym_positional_pattern_clause] = STATE(1865),
    [sym_property_pattern_clause] = STATE(1897),
    [sym_var_pattern] = STATE(3067),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2997),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2997),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2997),
    [sym_invocation_expression] = STATE(2997),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2997),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2997),
    [sym_postfix_unary_expression] = STATE(2997),
    [sym_prefix_unary_expression] = STATE(2997),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2997),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2997),
    [sym_type_of_expression] = STATE(2997),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4478),
    [sym_binary_expression] = STATE(2997),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2997),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(345),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_GT] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1895),
    [anon_sym_LT_EQ] = ACTIONS(1895),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1849),
    [sym_predefined_type] = ACTIONS(1851),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_not] = ACTIONS(1897),
    [sym_discard] = ACTIONS(1855),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [346] = {
    [sym__name] = STATE(2012),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2019),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1839),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1890),
    [sym_property_pattern_clause] = STATE(1937),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4484),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(346),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1827),
    [anon_sym_GT] = ACTIONS(1827),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1829),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_GT_EQ] = ACTIONS(1831),
    [anon_sym_LT_EQ] = ACTIONS(1831),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1833),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [347] = {
    [sym__name] = STATE(1915),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1757),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3902),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4441),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(347),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1785),
    [anon_sym_GT] = ACTIONS(1785),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(1789),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1791),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [348] = {
    [sym__name] = STATE(1977),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1962),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1773),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1828),
    [sym_property_pattern_clause] = STATE(1881),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(348),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_GT] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1755),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1757),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1759),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [349] = {
    [sym__name] = STATE(2005),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1994),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1855),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4157),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1874),
    [sym_property_pattern_clause] = STATE(1925),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4427),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(349),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_GT] = ACTIONS(1907),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1911),
    [anon_sym_LT_EQ] = ACTIONS(1911),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1913),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [350] = {
    [sym__name] = STATE(4651),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1983),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(6168),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(4142),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(4142),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(4142),
    [sym_invocation_expression] = STATE(4142),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(4142),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(4142),
    [sym_postfix_unary_expression] = STATE(4142),
    [sym_prefix_unary_expression] = STATE(4142),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(4142),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(4142),
    [sym_type_of_expression] = STATE(4142),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4405),
    [sym_binary_expression] = STATE(4142),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1906),
    [sym_global] = STATE(1967),
    [sym__literal] = STATE(4142),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(350),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1927),
    [anon_sym_GT] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1929),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1931),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_GT_EQ] = ACTIONS(1933),
    [anon_sym_LT_EQ] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1935),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [351] = {
    [sym__name] = STATE(1968),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1980),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1813),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3141),
    [sym_type_pattern] = STATE(3067),
    [sym_parenthesized_pattern] = STATE(3067),
    [sym_relational_pattern] = STATE(3067),
    [sym_negated_pattern] = STATE(3067),
    [sym_binary_pattern] = STATE(3067),
    [sym_constant_pattern] = STATE(3067),
    [sym_declaration_pattern] = STATE(3067),
    [sym_recursive_pattern] = STATE(3067),
    [sym_positional_pattern_clause] = STATE(1863),
    [sym_property_pattern_clause] = STATE(1900),
    [sym_var_pattern] = STATE(3067),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2997),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2997),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2997),
    [sym_invocation_expression] = STATE(2997),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2997),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2997),
    [sym_postfix_unary_expression] = STATE(2997),
    [sym_prefix_unary_expression] = STATE(2997),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2997),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2997),
    [sym_type_of_expression] = STATE(2997),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4415),
    [sym_binary_expression] = STATE(2997),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2997),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(351),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_GT] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_GT_EQ] = ACTIONS(1847),
    [anon_sym_LT_EQ] = ACTIONS(1847),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1849),
    [sym_predefined_type] = ACTIONS(1851),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_not] = ACTIONS(1853),
    [sym_discard] = ACTIONS(1855),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [352] = {
    [sym__name] = STATE(1968),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1980),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1813),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3124),
    [sym_type_pattern] = STATE(3067),
    [sym_parenthesized_pattern] = STATE(3067),
    [sym_relational_pattern] = STATE(3067),
    [sym_negated_pattern] = STATE(3067),
    [sym_binary_pattern] = STATE(3067),
    [sym_constant_pattern] = STATE(3067),
    [sym_declaration_pattern] = STATE(3067),
    [sym_recursive_pattern] = STATE(3067),
    [sym_positional_pattern_clause] = STATE(1863),
    [sym_property_pattern_clause] = STATE(1900),
    [sym_var_pattern] = STATE(3067),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2997),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2997),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2997),
    [sym_invocation_expression] = STATE(2997),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2997),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2997),
    [sym_postfix_unary_expression] = STATE(2997),
    [sym_prefix_unary_expression] = STATE(2997),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2997),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2997),
    [sym_type_of_expression] = STATE(2997),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4415),
    [sym_binary_expression] = STATE(2997),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2997),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(352),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1843),
    [anon_sym_GT] = ACTIONS(1843),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1845),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_GT_EQ] = ACTIONS(1847),
    [anon_sym_LT_EQ] = ACTIONS(1847),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1849),
    [sym_predefined_type] = ACTIONS(1851),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_not] = ACTIONS(1853),
    [sym_discard] = ACTIONS(1855),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [353] = {
    [sym__name] = STATE(2007),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1991),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1820),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4407),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1895),
    [sym_property_pattern_clause] = STATE(1953),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4477),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(353),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1775),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [354] = {
    [sym__name] = STATE(1973),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1984),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1788),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3049),
    [sym_type_pattern] = STATE(3067),
    [sym_parenthesized_pattern] = STATE(3067),
    [sym_relational_pattern] = STATE(3067),
    [sym_negated_pattern] = STATE(3067),
    [sym_binary_pattern] = STATE(3067),
    [sym_constant_pattern] = STATE(3067),
    [sym_declaration_pattern] = STATE(3067),
    [sym_recursive_pattern] = STATE(3067),
    [sym_positional_pattern_clause] = STATE(1865),
    [sym_property_pattern_clause] = STATE(1897),
    [sym_var_pattern] = STATE(3067),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2997),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2997),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2997),
    [sym_invocation_expression] = STATE(2997),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2997),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2997),
    [sym_postfix_unary_expression] = STATE(2997),
    [sym_prefix_unary_expression] = STATE(2997),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2997),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2997),
    [sym_type_of_expression] = STATE(2997),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4478),
    [sym_binary_expression] = STATE(2997),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2997),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(354),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1891),
    [anon_sym_GT] = ACTIONS(1891),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1893),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_GT_EQ] = ACTIONS(1895),
    [anon_sym_LT_EQ] = ACTIONS(1895),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1849),
    [sym_predefined_type] = ACTIONS(1851),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_not] = ACTIONS(1897),
    [sym_discard] = ACTIONS(1855),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [355] = {
    [sym__name] = STATE(1982),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1787),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4440),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1866),
    [sym_property_pattern_clause] = STATE(1905),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4403),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(355),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1815),
    [anon_sym_GT] = ACTIONS(1815),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1817),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_GT_EQ] = ACTIONS(1819),
    [anon_sym_LT_EQ] = ACTIONS(1819),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1821),
    [sym_predefined_type] = ACTIONS(1823),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1825),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [356] = {
    [sym__name] = STATE(2010),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2002),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1829),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3388),
    [sym_type_pattern] = STATE(3336),
    [sym_parenthesized_pattern] = STATE(3336),
    [sym_relational_pattern] = STATE(3336),
    [sym_negated_pattern] = STATE(3336),
    [sym_binary_pattern] = STATE(3336),
    [sym_constant_pattern] = STATE(3336),
    [sym_declaration_pattern] = STATE(3336),
    [sym_recursive_pattern] = STATE(3336),
    [sym_positional_pattern_clause] = STATE(1880),
    [sym_property_pattern_clause] = STATE(1945),
    [sym_var_pattern] = STATE(3336),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3262),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3262),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3262),
    [sym_invocation_expression] = STATE(3262),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3262),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3262),
    [sym_postfix_unary_expression] = STATE(3262),
    [sym_prefix_unary_expression] = STATE(3262),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3262),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3262),
    [sym_type_of_expression] = STATE(3262),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4430),
    [sym_binary_expression] = STATE(3262),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(3262),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(356),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1917),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_GT_EQ] = ACTIONS(1919),
    [anon_sym_LT_EQ] = ACTIONS(1919),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1921),
    [sym_predefined_type] = ACTIONS(1923),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_not] = ACTIONS(1925),
    [sym_discard] = ACTIONS(1751),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [357] = {
    [sym__name] = STATE(2015),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1990),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1860),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4373),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1892),
    [sym_property_pattern_clause] = STATE(1933),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4426),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(357),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1807),
    [anon_sym_GT] = ACTIONS(1807),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1809),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_GT_EQ] = ACTIONS(1811),
    [anon_sym_LT_EQ] = ACTIONS(1811),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1813),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [358] = {
    [sym__name] = STATE(2010),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2002),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1829),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3247),
    [sym_type_pattern] = STATE(3336),
    [sym_parenthesized_pattern] = STATE(3336),
    [sym_relational_pattern] = STATE(3336),
    [sym_negated_pattern] = STATE(3336),
    [sym_binary_pattern] = STATE(3336),
    [sym_constant_pattern] = STATE(3336),
    [sym_declaration_pattern] = STATE(3336),
    [sym_recursive_pattern] = STATE(3336),
    [sym_positional_pattern_clause] = STATE(1880),
    [sym_property_pattern_clause] = STATE(1945),
    [sym_var_pattern] = STATE(3336),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3262),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3262),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3262),
    [sym_invocation_expression] = STATE(3262),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3262),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3262),
    [sym_postfix_unary_expression] = STATE(3262),
    [sym_prefix_unary_expression] = STATE(3262),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3262),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3262),
    [sym_type_of_expression] = STATE(3262),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4430),
    [sym_binary_expression] = STATE(3262),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(3262),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(358),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1917),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_GT_EQ] = ACTIONS(1919),
    [anon_sym_LT_EQ] = ACTIONS(1919),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1921),
    [sym_predefined_type] = ACTIONS(1923),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_not] = ACTIONS(1925),
    [sym_discard] = ACTIONS(1751),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [359] = {
    [sym__name] = STATE(2010),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2002),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1829),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3370),
    [sym_type_pattern] = STATE(3336),
    [sym_parenthesized_pattern] = STATE(3336),
    [sym_relational_pattern] = STATE(3336),
    [sym_negated_pattern] = STATE(3336),
    [sym_binary_pattern] = STATE(3336),
    [sym_constant_pattern] = STATE(3336),
    [sym_declaration_pattern] = STATE(3336),
    [sym_recursive_pattern] = STATE(3336),
    [sym_positional_pattern_clause] = STATE(1880),
    [sym_property_pattern_clause] = STATE(1945),
    [sym_var_pattern] = STATE(3336),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3262),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3262),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3262),
    [sym_invocation_expression] = STATE(3262),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3262),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3262),
    [sym_postfix_unary_expression] = STATE(3262),
    [sym_prefix_unary_expression] = STATE(3262),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3262),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3262),
    [sym_type_of_expression] = STATE(3262),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4430),
    [sym_binary_expression] = STATE(3262),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(3262),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(359),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1917),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_GT_EQ] = ACTIONS(1919),
    [anon_sym_LT_EQ] = ACTIONS(1919),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1921),
    [sym_predefined_type] = ACTIONS(1923),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_not] = ACTIONS(1925),
    [sym_discard] = ACTIONS(1751),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [360] = {
    [sym__name] = STATE(1868),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1754),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3380),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4439),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(360),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_GT] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_LT_EQ] = ACTIONS(1879),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1881),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [361] = {
    [sym__name] = STATE(1979),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1757),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4412),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4419),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(361),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1763),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_GT_EQ] = ACTIONS(1765),
    [anon_sym_LT_EQ] = ACTIONS(1765),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1767),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [362] = {
    [sym__name] = STATE(1868),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1802),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1753),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3359),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1759),
    [sym_property_pattern_clause] = STATE(1764),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4439),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(362),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1875),
    [anon_sym_GT] = ACTIONS(1875),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1877),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_GT_EQ] = ACTIONS(1879),
    [anon_sym_LT_EQ] = ACTIONS(1879),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1881),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [363] = {
    [sym__name] = STATE(2010),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(2002),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1859),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3338),
    [sym_type_pattern] = STATE(3336),
    [sym_parenthesized_pattern] = STATE(3336),
    [sym_relational_pattern] = STATE(3336),
    [sym_negated_pattern] = STATE(3336),
    [sym_binary_pattern] = STATE(3336),
    [sym_constant_pattern] = STATE(3336),
    [sym_declaration_pattern] = STATE(3336),
    [sym_recursive_pattern] = STATE(3336),
    [sym_positional_pattern_clause] = STATE(1880),
    [sym_property_pattern_clause] = STATE(1945),
    [sym_var_pattern] = STATE(3336),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3262),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3262),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3262),
    [sym_invocation_expression] = STATE(3262),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3262),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3262),
    [sym_postfix_unary_expression] = STATE(3262),
    [sym_prefix_unary_expression] = STATE(3262),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3262),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3262),
    [sym_type_of_expression] = STATE(3262),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4430),
    [sym_binary_expression] = STATE(3262),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(3262),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(363),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1915),
    [anon_sym_GT] = ACTIONS(1915),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1917),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_GT_EQ] = ACTIONS(1919),
    [anon_sym_LT_EQ] = ACTIONS(1919),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1921),
    [sym_predefined_type] = ACTIONS(1923),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_not] = ACTIONS(1925),
    [sym_discard] = ACTIONS(1751),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [364] = {
    [sym__name] = STATE(1979),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1757),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4419),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(364),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1761),
    [anon_sym_GT] = ACTIONS(1761),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1763),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_GT_EQ] = ACTIONS(1765),
    [anon_sym_LT_EQ] = ACTIONS(1765),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1767),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [365] = {
    [sym__name] = STATE(1985),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1962),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1773),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4101),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1828),
    [sym_property_pattern_clause] = STATE(1881),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4405),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(365),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1723),
    [anon_sym_GT] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1725),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_GT_EQ] = ACTIONS(1729),
    [anon_sym_LT_EQ] = ACTIONS(1729),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1737),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [366] = {
    [sym__name] = STATE(2005),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1994),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1855),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4193),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1874),
    [sym_property_pattern_clause] = STATE(1925),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4427),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(366),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_GT] = ACTIONS(1907),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1911),
    [anon_sym_LT_EQ] = ACTIONS(1911),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1913),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [367] = {
    [sym__name] = STATE(1915),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1757),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4441),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(367),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1785),
    [anon_sym_GT] = ACTIONS(1785),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(1789),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1791),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [368] = {
    [sym__name] = STATE(2007),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1991),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1858),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4410),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1895),
    [sym_property_pattern_clause] = STATE(1953),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4477),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(368),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1769),
    [anon_sym_GT] = ACTIONS(1769),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1771),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_GT_EQ] = ACTIONS(1773),
    [anon_sym_LT_EQ] = ACTIONS(1773),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1775),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [369] = {
    [sym__name] = STATE(2005),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1994),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1855),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2798),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1874),
    [sym_property_pattern_clause] = STATE(1925),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4427),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1778),
    [sym_global] = STATE(1852),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(369),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_GT] = ACTIONS(1907),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1909),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_GT_EQ] = ACTIONS(1911),
    [anon_sym_LT_EQ] = ACTIONS(1911),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1913),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [370] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(6128),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(370),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [371] = {
    [sym__name] = STATE(4618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3681),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3681),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3681),
    [sym_invocation_expression] = STATE(3681),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3681),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3681),
    [sym_postfix_unary_expression] = STATE(3681),
    [sym_prefix_unary_expression] = STATE(3681),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3681),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3681),
    [sym_type_of_expression] = STATE(3681),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4424),
    [sym_binary_expression] = STATE(3681),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3681),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(371),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [372] = {
    [sym__name] = STATE(1915),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1819),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1757),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(3797),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1761),
    [sym_property_pattern_clause] = STATE(1769),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4441),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(372),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1785),
    [anon_sym_GT] = ACTIONS(1785),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1787),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_GT_EQ] = ACTIONS(1789),
    [anon_sym_LT_EQ] = ACTIONS(1789),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1791),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [373] = {
    [sym__name] = STATE(4618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(6066),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3681),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3681),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3681),
    [sym_invocation_expression] = STATE(3681),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3681),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3681),
    [sym_postfix_unary_expression] = STATE(3681),
    [sym_prefix_unary_expression] = STATE(3681),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3681),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3681),
    [sym_type_of_expression] = STATE(3681),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4424),
    [sym_binary_expression] = STATE(3681),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3681),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(373),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [374] = {
    [sym__name] = STATE(1972),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1956),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1779),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4053),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1827),
    [sym_property_pattern_clause] = STATE(1889),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4470),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(374),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_EQ] = ACTIONS(1861),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1863),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [375] = {
    [sym__name] = STATE(1972),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1956),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1779),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(2798),
    [sym_type_pattern] = STATE(2821),
    [sym_parenthesized_pattern] = STATE(2821),
    [sym_relational_pattern] = STATE(2821),
    [sym_negated_pattern] = STATE(2821),
    [sym_binary_pattern] = STATE(2821),
    [sym_constant_pattern] = STATE(2821),
    [sym_declaration_pattern] = STATE(2821),
    [sym_recursive_pattern] = STATE(2821),
    [sym_positional_pattern_clause] = STATE(1827),
    [sym_property_pattern_clause] = STATE(1889),
    [sym_var_pattern] = STATE(2821),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2819),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2819),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2819),
    [sym_invocation_expression] = STATE(2819),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2819),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2819),
    [sym_postfix_unary_expression] = STATE(2819),
    [sym_prefix_unary_expression] = STATE(2819),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2819),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2819),
    [sym_type_of_expression] = STATE(2819),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4470),
    [sym_binary_expression] = STATE(2819),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1846),
    [sym_global] = STATE(1896),
    [sym__literal] = STATE(2819),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(375),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1857),
    [anon_sym_GT] = ACTIONS(1857),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1859),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_GT_EQ] = ACTIONS(1861),
    [anon_sym_LT_EQ] = ACTIONS(1861),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1799),
    [sym_predefined_type] = ACTIONS(1801),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_not] = ACTIONS(1863),
    [sym_discard] = ACTIONS(1805),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [376] = {
    [sym__name] = STATE(4618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1918),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4574),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(5972),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4625),
    [sym_property_pattern_clause] = STATE(4645),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3681),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3681),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3681),
    [sym_invocation_expression] = STATE(3681),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3681),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3681),
    [sym_postfix_unary_expression] = STATE(3681),
    [sym_prefix_unary_expression] = STATE(3681),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3681),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3681),
    [sym_type_of_expression] = STATE(3681),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4424),
    [sym_binary_expression] = STATE(3681),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3681),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(376),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(647),
    [anon_sym_GT] = ACTIONS(647),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1865),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_GT_EQ] = ACTIONS(675),
    [anon_sym_LT_EQ] = ACTIONS(675),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(687),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [377] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(377),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [378] = {
    [sym__name] = STATE(4648),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1966),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(6209),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(3417),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(3417),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(3417),
    [sym_invocation_expression] = STATE(3417),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(3417),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(3417),
    [sym_postfix_unary_expression] = STATE(3417),
    [sym_prefix_unary_expression] = STATE(3417),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(3417),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(3417),
    [sym_type_of_expression] = STATE(3417),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(3417),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1938),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(3417),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(378),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1659),
    [anon_sym_GT] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1663),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(667),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1667),
    [anon_sym_LT_EQ] = ACTIONS(1667),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1669),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [379] = {
    [sym__name] = STATE(1977),
    [sym_alias_qualified_name] = STATE(1794),
    [sym__simple_name] = STATE(1962),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(1794),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(1773),
    [sym_implicit_type] = STATE(1795),
    [sym_array_type] = STATE(1796),
    [sym_nullable_type] = STATE(1795),
    [sym__nullable_base_type] = STATE(6760),
    [sym_pointer_type] = STATE(1796),
    [sym_function_pointer_type] = STATE(1796),
    [sym_tuple_type] = STATE(1796),
    [sym__pattern] = STATE(4393),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(1828),
    [sym_property_pattern_clause] = STATE(1881),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2887),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2887),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2887),
    [sym_invocation_expression] = STATE(2887),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2887),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2887),
    [sym_postfix_unary_expression] = STATE(2887),
    [sym_prefix_unary_expression] = STATE(2887),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2887),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2887),
    [sym_type_of_expression] = STATE(2887),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4420),
    [sym_binary_expression] = STATE(2887),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1926),
    [sym_global] = STATE(1954),
    [sym__literal] = STATE(2887),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(379),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(1657),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1753),
    [anon_sym_GT] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1755),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1727),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_GT_EQ] = ACTIONS(1757),
    [anon_sym_LT_EQ] = ACTIONS(1757),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1731),
    [anon_sym_var] = ACTIONS(1733),
    [sym_predefined_type] = ACTIONS(1735),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1759),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [380] = {
    [sym__name] = STATE(4651),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1983),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(2963),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(4142),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(4142),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(4142),
    [sym_invocation_expression] = STATE(4142),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(4142),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(4142),
    [sym_postfix_unary_expression] = STATE(4142),
    [sym_prefix_unary_expression] = STATE(4142),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(4142),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(4142),
    [sym_type_of_expression] = STATE(4142),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4405),
    [sym_binary_expression] = STATE(4142),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1906),
    [sym_global] = STATE(1967),
    [sym__literal] = STATE(4142),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(380),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1927),
    [anon_sym_GT] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1929),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1931),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_GT_EQ] = ACTIONS(1933),
    [anon_sym_LT_EQ] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1935),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [381] = {
    [sym__name] = STATE(4651),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(1983),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4604),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym__pattern] = STATE(6197),
    [sym_type_pattern] = STATE(2899),
    [sym_parenthesized_pattern] = STATE(2899),
    [sym_relational_pattern] = STATE(2899),
    [sym_negated_pattern] = STATE(2899),
    [sym_binary_pattern] = STATE(2899),
    [sym_constant_pattern] = STATE(2899),
    [sym_declaration_pattern] = STATE(2899),
    [sym_recursive_pattern] = STATE(2899),
    [sym_positional_pattern_clause] = STATE(4633),
    [sym_property_pattern_clause] = STATE(4666),
    [sym_var_pattern] = STATE(2899),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(4142),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(4142),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(4142),
    [sym_invocation_expression] = STATE(4142),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(4142),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(4142),
    [sym_postfix_unary_expression] = STATE(4142),
    [sym_prefix_unary_expression] = STATE(4142),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(4142),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(4142),
    [sym_type_of_expression] = STATE(4142),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4405),
    [sym_binary_expression] = STATE(4142),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1906),
    [sym_global] = STATE(1967),
    [sym__literal] = STATE(4142),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(381),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LT] = ACTIONS(1927),
    [anon_sym_GT] = ACTIONS(1927),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1929),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(1931),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_GT_EQ] = ACTIONS(1933),
    [anon_sym_LT_EQ] = ACTIONS(1933),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(677),
    [sym_predefined_type] = ACTIONS(679),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_not] = ACTIONS(1935),
    [sym_discard] = ACTIONS(717),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [382] = {
    [sym__name] = STATE(4689),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_target_specifier] = STATE(4687),
    [sym_attribute] = STATE(6404),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6405),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(382),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_field] = ACTIONS(1937),
    [anon_sym_event] = ACTIONS(1937),
    [anon_sym_method] = ACTIONS(1937),
    [anon_sym_param] = ACTIONS(1937),
    [anon_sym_property] = ACTIONS(1937),
    [anon_sym_return] = ACTIONS(1937),
    [anon_sym_type] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_assembly] = ACTIONS(1939),
    [anon_sym_module] = ACTIONS(1939),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1941),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [383] = {
    [sym__name] = STATE(4689),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_target_specifier] = STATE(4692),
    [sym_attribute] = STATE(6441),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6405),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(383),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_field] = ACTIONS(1937),
    [anon_sym_event] = ACTIONS(1937),
    [anon_sym_method] = ACTIONS(1937),
    [anon_sym_param] = ACTIONS(1937),
    [anon_sym_property] = ACTIONS(1937),
    [anon_sym_return] = ACTIONS(1937),
    [anon_sym_type] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1941),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [384] = {
    [sym__name] = STATE(4689),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_target_specifier] = STATE(4687),
    [sym_attribute] = STATE(6404),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6405),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(384),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_field] = ACTIONS(1937),
    [anon_sym_event] = ACTIONS(1937),
    [anon_sym_method] = ACTIONS(1937),
    [anon_sym_param] = ACTIONS(1937),
    [anon_sym_property] = ACTIONS(1937),
    [anon_sym_return] = ACTIONS(1937),
    [anon_sym_type] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1941),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [385] = {
    [sym__name] = STATE(4689),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_target_specifier] = STATE(4688),
    [sym_attribute] = STATE(6251),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6405),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(385),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_field] = ACTIONS(1937),
    [anon_sym_event] = ACTIONS(1937),
    [anon_sym_method] = ACTIONS(1937),
    [anon_sym_param] = ACTIONS(1937),
    [anon_sym_property] = ACTIONS(1937),
    [anon_sym_return] = ACTIONS(1937),
    [anon_sym_type] = ACTIONS(1937),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1941),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [386] = {
    [sym__name] = STATE(4720),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2034),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4737),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(386),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [387] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3476),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(387),
    [sym__identifier_token] = ACTIONS(1949),
    [anon_sym_extern] = ACTIONS(1949),
    [anon_sym_alias] = ACTIONS(1949),
    [anon_sym_global] = ACTIONS(1949),
    [anon_sym_static] = ACTIONS(1949),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1951),
    [anon_sym_abstract] = ACTIONS(1949),
    [anon_sym_async] = ACTIONS(1949),
    [anon_sym_const] = ACTIONS(1949),
    [anon_sym_fixed] = ACTIONS(1949),
    [anon_sym_internal] = ACTIONS(1949),
    [anon_sym_new] = ACTIONS(1949),
    [anon_sym_override] = ACTIONS(1949),
    [anon_sym_partial] = ACTIONS(1949),
    [anon_sym_private] = ACTIONS(1949),
    [anon_sym_protected] = ACTIONS(1949),
    [anon_sym_public] = ACTIONS(1949),
    [anon_sym_readonly] = ACTIONS(1949),
    [anon_sym_ref] = ACTIONS(1949),
    [anon_sym_sealed] = ACTIONS(1949),
    [anon_sym_unsafe] = ACTIONS(1949),
    [anon_sym_virtual] = ACTIONS(1949),
    [anon_sym_volatile] = ACTIONS(1949),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(1949),
    [anon_sym_class] = ACTIONS(1949),
    [anon_sym_struct] = ACTIONS(1949),
    [anon_sym_notnull] = ACTIONS(1949),
    [anon_sym_unmanaged] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(1949),
    [anon_sym_set] = ACTIONS(1949),
    [anon_sym_add] = ACTIONS(1949),
    [anon_sym_remove] = ACTIONS(1949),
    [anon_sym_enum] = ACTIONS(1949),
    [anon_sym_interface] = ACTIONS(1949),
    [anon_sym_delegate] = ACTIONS(1949),
    [anon_sym_record] = ACTIONS(1949),
    [anon_sym_var] = ACTIONS(1949),
    [sym_predefined_type] = ACTIONS(1949),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(1949),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1949),
    [anon_sym_join] = ACTIONS(1949),
    [anon_sym_on] = ACTIONS(1949),
    [anon_sym_equals] = ACTIONS(1949),
    [anon_sym_into] = ACTIONS(1949),
    [anon_sym_let] = ACTIONS(1949),
    [anon_sym_orderby] = ACTIONS(1949),
    [anon_sym_ascending] = ACTIONS(1949),
    [anon_sym_descending] = ACTIONS(1949),
    [anon_sym_group] = ACTIONS(1949),
    [anon_sym_by] = ACTIONS(1949),
    [anon_sym_select] = ACTIONS(1949),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(1949),
    [anon_sym_nameof] = ACTIONS(1949),
    [sym_void_keyword] = ACTIONS(1949),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [388] = {
    [sym__name] = STATE(4720),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2034),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4732),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(388),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [389] = {
    [sym__name] = STATE(4720),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2034),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4722),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(389),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [390] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4810),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(390),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [391] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4771),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3935),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(391),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [392] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4745),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3935),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(392),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [393] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6491),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4811),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4032),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(393),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [394] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4795),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4022),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(394),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [395] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6491),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4794),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4032),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(395),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [396] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6491),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4785),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4032),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(396),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [397] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4798),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4022),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(397),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [398] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4800),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3935),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(398),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [399] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4784),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4022),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(399),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [400] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4766),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(400),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [401] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6491),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4780),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4032),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(401),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [402] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4765),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4022),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(402),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [403] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6491),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4796),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4032),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(403),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [404] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6491),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4741),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4032),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(404),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [405] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6491),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4777),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4032),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(405),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [406] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4791),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3935),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(406),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [407] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4754),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3935),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(407),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [408] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4743),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(408),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [409] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6489),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4751),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4050),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(409),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [410] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4808),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3935),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(410),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [411] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4774),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4022),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(411),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [412] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6491),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4826),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4032),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(412),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [413] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6489),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4823),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4050),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(413),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [414] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4764),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3935),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(414),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [415] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4812),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(415),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [416] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4809),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(416),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [417] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4789),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4022),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(417),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [418] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4787),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4022),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(418),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [419] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6560),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4793),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4022),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(419),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [420] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4825),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(420),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [421] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4770),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3935),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(421),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [422] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4797),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(422),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [423] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6489),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4746),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4050),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(423),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [424] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4814),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(424),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [425] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6520),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4820),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3935),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(425),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [426] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4750),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3940),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(426),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [427] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(4670),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6489),
    [sym_parameter_list] = STATE(6734),
    [sym__formal_parameter_list] = STATE(6629),
    [sym_parameter] = STATE(6103),
    [sym__parameter_array] = STATE(6103),
    [sym__type] = STATE(4760),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4050),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1942),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(427),
    [aux_sym_event_field_declaration_repeat1] = STATE(3323),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(649),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1945),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1947),
    [anon_sym_out] = ACTIONS(661),
    [anon_sym_in] = ACTIONS(661),
    [anon_sym_this] = ACTIONS(663),
    [anon_sym_params] = ACTIONS(665),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [428] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3476),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(428),
    [sym__identifier_token] = ACTIONS(1949),
    [anon_sym_extern] = ACTIONS(1949),
    [anon_sym_alias] = ACTIONS(1949),
    [anon_sym_global] = ACTIONS(1949),
    [anon_sym_static] = ACTIONS(1949),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1951),
    [anon_sym_abstract] = ACTIONS(1949),
    [anon_sym_async] = ACTIONS(1949),
    [anon_sym_const] = ACTIONS(1949),
    [anon_sym_fixed] = ACTIONS(1949),
    [anon_sym_internal] = ACTIONS(1949),
    [anon_sym_new] = ACTIONS(1949),
    [anon_sym_override] = ACTIONS(1949),
    [anon_sym_partial] = ACTIONS(1949),
    [anon_sym_private] = ACTIONS(1949),
    [anon_sym_protected] = ACTIONS(1949),
    [anon_sym_public] = ACTIONS(1949),
    [anon_sym_readonly] = ACTIONS(1949),
    [anon_sym_ref] = ACTIONS(1949),
    [anon_sym_sealed] = ACTIONS(1949),
    [anon_sym_unsafe] = ACTIONS(1949),
    [anon_sym_virtual] = ACTIONS(1949),
    [anon_sym_volatile] = ACTIONS(1949),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(1949),
    [anon_sym_notnull] = ACTIONS(1949),
    [anon_sym_unmanaged] = ACTIONS(1949),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(1949),
    [anon_sym_set] = ACTIONS(1949),
    [anon_sym_add] = ACTIONS(1949),
    [anon_sym_remove] = ACTIONS(1949),
    [anon_sym_delegate] = ACTIONS(1949),
    [anon_sym_var] = ACTIONS(1949),
    [sym_predefined_type] = ACTIONS(1949),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(1949),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(1949),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1949),
    [anon_sym_join] = ACTIONS(1949),
    [anon_sym_on] = ACTIONS(1949),
    [anon_sym_equals] = ACTIONS(1949),
    [anon_sym_into] = ACTIONS(1949),
    [anon_sym_let] = ACTIONS(1949),
    [anon_sym_orderby] = ACTIONS(1949),
    [anon_sym_ascending] = ACTIONS(1949),
    [anon_sym_descending] = ACTIONS(1949),
    [anon_sym_group] = ACTIONS(1949),
    [anon_sym_by] = ACTIONS(1949),
    [anon_sym_select] = ACTIONS(1949),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(1949),
    [anon_sym_nameof] = ACTIONS(1949),
    [sym_void_keyword] = ACTIONS(1949),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [429] = {
    [sym__name] = STATE(4781),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2033),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6268),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4805),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6869),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(429),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [430] = {
    [sym__name] = STATE(4781),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2033),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6468),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4805),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6764),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(430),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1959),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [431] = {
    [sym__name] = STATE(4781),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2033),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6431),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4805),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6832),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(431),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1961),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [432] = {
    [sym__name] = STATE(4781),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2033),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6319),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4805),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6810),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(432),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1963),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [433] = {
    [sym__name] = STATE(4781),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2033),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6341),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4805),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6853),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(433),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1965),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [434] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6468),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(434),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1959),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [435] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6431),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(435),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1961),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [436] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6341),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(436),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1965),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [437] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6268),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(437),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1953),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [438] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6319),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(438),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_RPAREN] = ACTIONS(1963),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [439] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(449),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6261),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(439),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1955),
    [anon_sym_out] = ACTIONS(1957),
    [anon_sym_in] = ACTIONS(1957),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [440] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4007),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(440),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1967),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [441] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6359),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(441),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1941),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [442] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6261),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(442),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1941),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [443] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6620),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4026),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(443),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1967),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [444] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6284),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(444),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1941),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [445] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6252),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(445),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1941),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [446] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6405),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(446),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1941),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [447] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_name_colon] = STATE(448),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_argument] = STATE(6439),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6406),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3925),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1950),
    [sym_global] = STATE(1976),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(447),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1941),
    [anon_sym_out] = ACTIONS(1943),
    [anon_sym_in] = ACTIONS(1943),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [448] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6428),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3860),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(448),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1969),
    [anon_sym_out] = ACTIONS(1971),
    [anon_sym_in] = ACTIONS(1971),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [449] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6428),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3860),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(449),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1973),
    [anon_sym_out] = ACTIONS(1975),
    [anon_sym_in] = ACTIONS(1975),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [450] = {
    [sym__preprocessor_call] = STATE(450),
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym__identifier_token] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym_alias] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_global] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_fixed] = ACTIONS(1979),
    [anon_sym_internal] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_partial] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_readonly] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_sealed] = ACTIONS(1979),
    [anon_sym_unsafe] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_this] = ACTIONS(1979),
    [anon_sym_base] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_where] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1984),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_notnull] = ACTIONS(1979),
    [anon_sym_unmanaged] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_true] = ACTIONS(1979),
    [anon_sym_false] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1986),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1989),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_add] = ACTIONS(1979),
    [anon_sym_remove] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_interface] = ACTIONS(1979),
    [anon_sym_delegate] = ACTIONS(1979),
    [anon_sym_record] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [sym_predefined_type] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_checked] = ACTIONS(1979),
    [anon_sym_unchecked] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_foreach] = ACTIONS(1979),
    [anon_sym_goto] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_lock] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1986),
    [anon_sym_when] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1989),
    [anon_sym_stackalloc] = ACTIONS(1979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1977),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1977),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym___makeref] = ACTIONS(1979),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(1979),
    [anon_sym_join] = ACTIONS(1979),
    [anon_sym_on] = ACTIONS(1979),
    [anon_sym_equals] = ACTIONS(1979),
    [anon_sym_into] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_orderby] = ACTIONS(1979),
    [anon_sym_ascending] = ACTIONS(1979),
    [anon_sym_descending] = ACTIONS(1979),
    [anon_sym_group] = ACTIONS(1979),
    [anon_sym_by] = ACTIONS(1979),
    [anon_sym_select] = ACTIONS(1979),
    [anon_sym_DOT_DOT] = ACTIONS(1981),
    [anon_sym___reftype] = ACTIONS(1979),
    [anon_sym___refvalue] = ACTIONS(1979),
    [anon_sym_sizeof] = ACTIONS(1979),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_with] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_integer_literal] = ACTIONS(1979),
    [sym_null_literal] = ACTIONS(1979),
    [sym_real_literal] = ACTIONS(1977),
    [sym_verbatim_string_literal] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(1979),
    [anon_sym_nameof] = ACTIONS(1979),
    [sym_void_keyword] = ACTIONS(1979),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [451] = {
    [sym__name] = STATE(4740),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2028),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_variable_declaration] = STATE(6634),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4695),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4160),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(451),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [452] = {
    [sym__name] = STATE(4740),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2028),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_variable_declaration] = STATE(6834),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4695),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4395),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(452),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [453] = {
    [sym__name] = STATE(4740),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2028),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_variable_declaration] = STATE(6858),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4695),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4263),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(453),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [454] = {
    [sym__name] = STATE(4740),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2028),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_variable_declaration] = STATE(6684),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4695),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4369),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(454),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [455] = {
    [sym__name] = STATE(4740),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2028),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_variable_declaration] = STATE(6628),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4695),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4125),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(455),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [456] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_variable_declaration] = STATE(6723),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3792),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(456),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(1991),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [457] = {
    [sym__name] = STATE(4740),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2028),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_variable_declaration] = STATE(6787),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4695),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_tuple_element] = STATE(6632),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4102),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(457),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [458] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_variable_declaration] = STATE(6926),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3771),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(458),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(1993),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [459] = {
    [sym__name] = STATE(4783),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2027),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_variable_declaration] = STATE(6724),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3789),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(459),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_SEMI] = ACTIONS(1995),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [460] = {
    [sym__name] = STATE(4946),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym__type] = STATE(4860),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6428),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3736),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1931),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(460),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1997),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(1999),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [461] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6428),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3860),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(461),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [462] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6428),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3864),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(462),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [463] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6428),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3860),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(463),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [464] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6264),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3776),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(464),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [465] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6264),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3776),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(465),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [466] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6264),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3777),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(466),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [467] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6264),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3777),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(467),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [468] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6428),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3977),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(468),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [469] = {
    [sym__name] = STATE(4801),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2021),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4860),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6428),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3860),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1958),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(469),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(137),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [470] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4860),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6428),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3864),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1955),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(470),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [471] = {
    [sym__name] = STATE(4850),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2025),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym__type] = STATE(4930),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_declaration_expression] = STATE(6428),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3864),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1786),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(471),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(27),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(69),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [472] = {
    [sym__name] = STATE(4769),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym__type] = STATE(4718),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4152),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1992),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(472),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2003),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [473] = {
    [sym__name] = STATE(4769),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym__type] = STATE(4727),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4396),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1992),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(473),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2003),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [474] = {
    [sym__name] = STATE(4769),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym__type] = STATE(4733),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4333),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1992),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(474),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2003),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [475] = {
    [sym__name] = STATE(4769),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym__type] = STATE(4729),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4394),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1992),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(475),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2003),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [476] = {
    [sym__name] = STATE(4769),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym__type] = STATE(4736),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4177),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1992),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(476),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2003),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [477] = {
    [sym__name] = STATE(4769),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2020),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym__type] = STATE(4724),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4296),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(1992),
    [sym_global] = STATE(1771),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(477),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(2001),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(342),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2003),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(113),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [478] = {
    [sym__preprocessor_call] = STATE(478),
    [sym__identifier_token] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym_alias] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_global] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_fixed] = ACTIONS(1979),
    [anon_sym_internal] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_partial] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_readonly] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_sealed] = ACTIONS(1979),
    [anon_sym_unsafe] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_this] = ACTIONS(1979),
    [anon_sym_base] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_where] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1984),
    [anon_sym_notnull] = ACTIONS(1979),
    [anon_sym_unmanaged] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_true] = ACTIONS(1979),
    [anon_sym_false] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1986),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1989),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_add] = ACTIONS(1979),
    [anon_sym_remove] = ACTIONS(1979),
    [anon_sym_delegate] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [sym_predefined_type] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_checked] = ACTIONS(1979),
    [anon_sym_unchecked] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_foreach] = ACTIONS(1979),
    [anon_sym_goto] = ACTIONS(1979),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_lock] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1986),
    [anon_sym_when] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1989),
    [anon_sym_stackalloc] = ACTIONS(1979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1977),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1977),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym___makeref] = ACTIONS(1979),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(1979),
    [anon_sym_join] = ACTIONS(1979),
    [anon_sym_on] = ACTIONS(1979),
    [anon_sym_equals] = ACTIONS(1979),
    [anon_sym_into] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_orderby] = ACTIONS(1979),
    [anon_sym_ascending] = ACTIONS(1979),
    [anon_sym_descending] = ACTIONS(1979),
    [anon_sym_group] = ACTIONS(1979),
    [anon_sym_by] = ACTIONS(1979),
    [anon_sym_select] = ACTIONS(1979),
    [anon_sym_DOT_DOT] = ACTIONS(1981),
    [anon_sym___reftype] = ACTIONS(1979),
    [anon_sym___refvalue] = ACTIONS(1979),
    [anon_sym_sizeof] = ACTIONS(1979),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_with] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_integer_literal] = ACTIONS(1979),
    [sym_null_literal] = ACTIONS(1979),
    [sym_real_literal] = ACTIONS(1977),
    [sym_verbatim_string_literal] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(1979),
    [anon_sym_nameof] = ACTIONS(1979),
    [sym_void_keyword] = ACTIONS(1979),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [479] = {
    [sym__preprocessor_call] = STATE(479),
    [sym__identifier_token] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym_alias] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_global] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_fixed] = ACTIONS(1979),
    [anon_sym_internal] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_partial] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_readonly] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_sealed] = ACTIONS(1979),
    [anon_sym_unsafe] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_this] = ACTIONS(1979),
    [anon_sym_base] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_where] = ACTIONS(1979),
    [anon_sym_QMARK] = ACTIONS(1984),
    [anon_sym_notnull] = ACTIONS(1979),
    [anon_sym_unmanaged] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_true] = ACTIONS(1979),
    [anon_sym_false] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1986),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1989),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_add] = ACTIONS(1979),
    [anon_sym_remove] = ACTIONS(1979),
    [anon_sym_delegate] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [sym_predefined_type] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_checked] = ACTIONS(1979),
    [anon_sym_unchecked] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_foreach] = ACTIONS(1979),
    [anon_sym_goto] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_lock] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1986),
    [anon_sym_when] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1989),
    [anon_sym_stackalloc] = ACTIONS(1979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1977),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1977),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym___makeref] = ACTIONS(1979),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(1979),
    [anon_sym_join] = ACTIONS(1979),
    [anon_sym_on] = ACTIONS(1979),
    [anon_sym_equals] = ACTIONS(1979),
    [anon_sym_into] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_orderby] = ACTIONS(1979),
    [anon_sym_ascending] = ACTIONS(1979),
    [anon_sym_descending] = ACTIONS(1979),
    [anon_sym_group] = ACTIONS(1979),
    [anon_sym_by] = ACTIONS(1979),
    [anon_sym_select] = ACTIONS(1979),
    [anon_sym_DOT_DOT] = ACTIONS(1981),
    [anon_sym___reftype] = ACTIONS(1979),
    [anon_sym___refvalue] = ACTIONS(1979),
    [anon_sym_sizeof] = ACTIONS(1979),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_with] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_integer_literal] = ACTIONS(1979),
    [sym_null_literal] = ACTIONS(1979),
    [sym_real_literal] = ACTIONS(1977),
    [sym_verbatim_string_literal] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(1979),
    [anon_sym_nameof] = ACTIONS(1979),
    [sym_void_keyword] = ACTIONS(1979),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [480] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6321),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(480),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2005),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2007),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [481] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6339),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(481),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2009),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2011),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [482] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6267),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(482),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2013),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2015),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [483] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6426),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(483),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2017),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2019),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [484] = {
    [sym_name_equals] = STATE(804),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_argument] = STATE(6280),
    [sym_name_colon] = STATE(804),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4031),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3787),
    [sym_global] = STATE(4284),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(484),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2021),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [485] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6464),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(485),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2023),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2025),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [486] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(486),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2027),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [487] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(487),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2029),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [488] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3899),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(488),
    [aux_sym_array_rank_specifier_repeat1] = STATE(6335),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(2033),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [489] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(489),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2035),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [490] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3773),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(490),
    [aux_sym_array_rank_specifier_repeat1] = STATE(6254),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(2037),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [491] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(491),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2039),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [492] = {
    [sym_name_equals] = STATE(804),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_argument] = STATE(6579),
    [sym_name_colon] = STATE(804),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4031),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3787),
    [sym_global] = STATE(4284),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(492),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [493] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3788),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(493),
    [aux_sym_array_rank_specifier_repeat1] = STATE(6334),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(2041),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [494] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3920),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(494),
    [aux_sym_array_rank_specifier_repeat1] = STATE(6374),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(2043),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [495] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(495),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2045),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [496] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(496),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2047),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [497] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(497),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2049),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [498] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3807),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(498),
    [aux_sym_array_rank_specifier_repeat1] = STATE(6286),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(2051),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [499] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(499),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2053),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [500] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3791),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(500),
    [aux_sym_array_rank_specifier_repeat1] = STATE(6419),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2031),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(2055),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [501] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(501),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2057),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [502] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(502),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2059),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [503] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2972),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2952),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4170),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(503),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [504] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2124),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2172),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4223),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(504),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2063),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [505] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2339),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2299),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4338),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(505),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [506] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2124),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2172),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4331),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(506),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2063),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [507] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(3496),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2952),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4246),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(507),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [508] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2124),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2172),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4340),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(508),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2063),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [509] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2896),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(3029),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4294),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(509),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [510] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2339),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2299),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4265),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(510),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [511] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2339),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2299),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4217),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(511),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [512] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2339),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2299),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4122),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(512),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [513] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(3496),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2952),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4269),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(513),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [514] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2896),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(3029),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4298),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(514),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [515] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2124),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2172),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4297),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(515),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2069),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [516] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2972),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2952),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4133),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(516),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [517] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2896),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(3029),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4104),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(517),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [518] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3781),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(518),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(410),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2071),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [519] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3844),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(519),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(380),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2073),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [520] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3790),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(520),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(404),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2075),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [521] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2972),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2952),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4305),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(521),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [522] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(3496),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2172),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4132),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(522),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [523] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2339),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2299),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4270),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(523),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2079),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [524] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2820),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2771),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4399),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(524),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [525] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2339),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2299),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4335),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(525),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [526] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2972),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2952),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4286),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(526),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [527] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2972),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2952),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4324),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(527),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [528] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2972),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2952),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4382),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(528),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2061),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [529] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3738),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(529),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(392),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2083),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [530] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2820),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2771),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4274),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(530),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [531] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2339),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2299),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4321),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(531),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2085),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [532] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2820),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2771),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4368),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(532),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [533] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3949),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(533),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(2087),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_RBRACK] = ACTIONS(2087),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [534] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(3496),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2771),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4391),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(534),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [535] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(3496),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2771),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4277),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(535),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [536] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2339),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2299),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4131),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(536),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2065),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [537] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(3496),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2299),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4304),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(537),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2089),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [538] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2124),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2172),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4348),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(538),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2063),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [539] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2896),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(3029),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4351),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(539),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2067),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [540] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2820),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2771),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4330),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(540),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [541] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2820),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2771),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4300),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(541),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [542] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2972),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2952),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4148),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(542),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2091),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [543] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2124),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2172),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4356),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(543),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2077),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [544] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3903),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(544),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_COMMA] = ACTIONS(400),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2093),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [545] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2124),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2172),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4227),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(545),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2069),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [546] = {
    [sym_name_equals] = STATE(1039),
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym__anonymous_object_member_declarator] = STATE(6597),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4090),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4095),
    [sym_global] = STATE(4458),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(546),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [547] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2820),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_member_binding_expression] = STATE(2771),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4279),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(547),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_DOT] = ACTIONS(2081),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [548] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(548),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2095),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [549] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_block] = STATE(2940),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3680),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(549),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [550] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_block] = STATE(2318),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3664),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(550),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [551] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_block] = STATE(2261),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4099),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(551),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [552] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_block] = STATE(2946),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3764),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(552),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [553] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4267),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(553),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2101),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [554] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_block] = STATE(2261),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3669),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(554),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [555] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_block] = STATE(2318),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4106),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(555),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [556] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3839),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(556),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2103),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [557] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4238),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(557),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2105),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [558] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3856),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(558),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2107),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [559] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3858),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(559),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2109),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [560] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4208),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(560),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2111),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [561] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_block] = STATE(2175),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4002),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(561),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [562] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3868),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(562),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2115),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [563] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_block] = STATE(2166),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3990),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(563),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [564] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_block] = STATE(2116),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3988),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(564),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [565] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3869),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(565),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2117),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [566] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_block] = STATE(2946),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3847),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(566),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [567] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_block] = STATE(2116),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3193),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(567),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [568] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_block] = STATE(2977),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3904),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(568),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [569] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_block] = STATE(2280),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4232),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(569),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [570] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_block] = STATE(2825),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3249),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(570),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [571] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_block] = STATE(3108),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2785),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(571),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [572] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_block] = STATE(2940),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3910),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(572),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [573] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_block] = STATE(2166),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3203),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(573),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [574] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_block] = STATE(2175),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3218),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(574),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [575] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_block] = STATE(2175),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3500),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(575),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [576] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_block] = STATE(3108),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2953),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(576),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [577] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_block] = STATE(3101),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2906),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(577),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [578] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_block] = STATE(3114),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2886),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(578),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [579] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_block] = STATE(2166),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3460),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(579),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [580] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_block] = STATE(2116),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3452),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(580),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [581] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_block] = STATE(2756),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3623),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(581),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [582] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_block] = STATE(2946),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3929),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(582),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [583] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3793),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(583),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2123),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [584] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_block] = STATE(2261),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4386),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(584),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [585] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3803),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(585),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2125),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [586] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_block] = STATE(2825),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3706),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(586),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [587] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3804),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(587),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2127),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [588] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_block] = STATE(2318),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4376),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(588),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [589] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_block] = STATE(2816),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3634),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(589),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [590] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_block] = STATE(2940),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3889),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(590),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [591] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_block] = STATE(2756),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3290),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(591),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [592] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3846),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(592),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2129),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [593] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3848),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(593),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2131),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [594] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3926),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(594),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2133),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [595] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(595),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2135),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [596] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3737),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(596),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2137),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [597] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_block] = STATE(2261),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4140),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(597),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [598] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3874),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(598),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2139),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [599] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_block] = STATE(2280),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4119),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(599),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [600] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_block] = STATE(2280),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4309),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(600),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [601] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_block] = STATE(2318),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4346),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(601),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [602] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_block] = STATE(2816),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3245),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(602),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [603] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_block] = STATE(2280),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3349),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(603),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [604] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4163),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(604),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2141),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [605] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_block] = STATE(2280),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4387),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(605),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [606] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym__ordering] = STATE(5689),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3063),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(606),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [607] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_block] = STATE(2977),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3784),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(607),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [608] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_block] = STATE(2940),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3734),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(608),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [609] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(2280),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3492),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(609),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [610] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_block] = STATE(2946),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3730),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(610),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [611] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3755),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(611),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2143),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [612] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_block] = STATE(2318),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4191),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(612),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [613] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(613),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2145),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [614] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_block] = STATE(2261),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3144),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(614),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [615] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4278),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(615),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2147),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [616] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_block] = STATE(2116),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3964),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(616),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [617] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym__ordering] = STATE(5697),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3063),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(617),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [618] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_block] = STATE(2318),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3145),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(618),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [619] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_block] = STATE(2166),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3963),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(619),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [620] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_block] = STATE(2175),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3952),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(620),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [621] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_block] = STATE(2261),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4272),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(621),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [622] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_block] = STATE(2977),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3727),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(622),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [623] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_block] = STATE(2816),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3488),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(623),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [624] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_block] = STATE(2825),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3483),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(624),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [625] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(625),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2149),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [626] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_block] = STATE(2756),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3475),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(626),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [627] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(627),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2151),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [628] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4306),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(628),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2153),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [629] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4301),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(629),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2155),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [630] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_block] = STATE(2816),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3151),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(630),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [631] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4281),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(631),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2157),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [632] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_block] = STATE(2261),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3301),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(632),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [633] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_block] = STATE(2825),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3153),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(633),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [634] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_block] = STATE(2175),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3972),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(634),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [635] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4276),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(635),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2159),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [636] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3799),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(636),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2161),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [637] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_block] = STATE(2280),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3170),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(637),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [638] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4372),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(638),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2163),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [639] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_block] = STATE(3114),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2844),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(639),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [640] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_block] = STATE(2166),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3983),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(640),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [641] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_block] = STATE(2116),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3984),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(641),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [642] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3883),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(642),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2165),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [643] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3741),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(643),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2167),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [644] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_block] = STATE(2756),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3177),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(644),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [645] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_block] = STATE(2940),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3886),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(645),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [646] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_block] = STATE(2977),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3879),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(646),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [647] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_block] = STATE(2946),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3824),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(647),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [648] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_block] = STATE(2816),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3579),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(648),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [649] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_block] = STATE(2946),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3805),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(649),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [650] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_block] = STATE(2825),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3580),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(650),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [651] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_block] = STATE(3101),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2788),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(651),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [652] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_block] = STATE(2940),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3672),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(652),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [653] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4241),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(653),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2169),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [654] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3785),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(654),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2171),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [655] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_block] = STATE(2977),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3673),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(655),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [656] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_block] = STATE(2946),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3384),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(656),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [657] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_block] = STATE(2946),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3687),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(657),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [658] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_block] = STATE(2977),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3815),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(658),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [659] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_block] = STATE(2280),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4234),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(659),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [660] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(660),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2173),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [661] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3801),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(661),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_RPAREN] = ACTIONS(2175),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [662] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_block] = STATE(2261),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4139),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(662),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [663] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_block] = STATE(2940),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3341),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(663),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [664] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_block] = STATE(2756),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3590),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(664),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [665] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_block] = STATE(2977),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3292),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(665),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [666] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_block] = STATE(2946),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3344),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(666),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [667] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_block] = STATE(2280),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3651),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(667),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [668] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(2318),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3448),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(668),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [669] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_block] = STATE(2977),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3372),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(669),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [670] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_block] = STATE(2116),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3253),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(670),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [671] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(671),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2177),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [672] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_block] = STATE(2940),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3356),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(672),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [673] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_block] = STATE(2318),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4185),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(673),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [674] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_block] = STATE(2116),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4055),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(674),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [675] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_block] = STATE(2166),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3269),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(675),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [676] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_block] = STATE(2166),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4057),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(676),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [677] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_block] = STATE(2261),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3422),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(677),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [678] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_block] = STATE(2175),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3312),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(678),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [679] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_block] = STATE(3114),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2692),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(679),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [680] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_block] = STATE(2940),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3813),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(680),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [681] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_block] = STATE(3101),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2650),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(681),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [682] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_block] = STATE(3108),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2653),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(682),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [683] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_block] = STATE(2175),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3053),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(683),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [684] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_block] = STATE(3108),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3003),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(684),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [685] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_block] = STATE(2756),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3559),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(685),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [686] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_block] = STATE(2756),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3547),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(686),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [687] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_block] = STATE(2166),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3014),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(687),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [688] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_block] = STATE(2825),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3571),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(688),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [689] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_block] = STATE(3101),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3052),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(689),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [690] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_block] = STATE(2116),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3022),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(690),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [691] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_block] = STATE(2816),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3572),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(691),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [692] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_block] = STATE(2816),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3573),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(692),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [693] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(693),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2179),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [694] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_block] = STATE(2175),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4071),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(694),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(2113),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [695] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_block] = STATE(2756),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3443),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(695),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [696] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_block] = STATE(2977),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3894),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(696),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(2097),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [697] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(697),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2181),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [698] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_block] = STATE(2318),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3228),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(698),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(2099),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [699] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_block] = STATE(2825),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3569),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(699),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [700] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_block] = STATE(3114),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3095),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(700),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(2121),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [701] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_block] = STATE(2816),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3412),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(701),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [702] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(702),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(2183),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [703] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_block] = STATE(2825),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3416),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(703),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(2119),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [704] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4392),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(704),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_SEMI] = ACTIONS(2185),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [705] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3818),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(705),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [706] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4230),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(706),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [707] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3589),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(707),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [708] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3670),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(708),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [709] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3526),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(709),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [710] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3597),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(710),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [711] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3636),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(711),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [712] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3591),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(712),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [713] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3637),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(713),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [714] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3652),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(714),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [715] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3853),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(715),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [716] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4054),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(716),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [717] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3987),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(717),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [718] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4059),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(718),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [719] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4060),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(719),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [720] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4061),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(720),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [721] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4062),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(721),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [722] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4063),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(722),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [723] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4077),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(723),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [724] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4064),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(724),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [725] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4069),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(725),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [726] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4070),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(726),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [727] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4080),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(727),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [728] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4081),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(728),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [729] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4088),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(729),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [730] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4034),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(730),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [731] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4072),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(731),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [732] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4038),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(732),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [733] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4092),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(733),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [734] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4128),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(734),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [735] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4058),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(735),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [736] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3882),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(736),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [737] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3135),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(737),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [738] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4189),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(738),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [739] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3149),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(739),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [740] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3155),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(740),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [741] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3125),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(741),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [742] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3159),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(742),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [743] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3137),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(743),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [744] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3163),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(744),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [745] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3164),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(745),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [746] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3143),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(746),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [747] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3127),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(747),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [748] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3132),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(748),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [749] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3139),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(749),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [750] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4065),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(750),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [751] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4176),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(751),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [752] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4273),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(752),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [753] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4166),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(753),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [754] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4317),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(754),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [755] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3574),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(755),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [756] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3653),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(756),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [757] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3568),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(757),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [758] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3567),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(758),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [759] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3566),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(759),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [760] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3565),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(760),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [761] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3564),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(761),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [762] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3546),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(762),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [763] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3563),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(763),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [764] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3562),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(764),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [765] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3560),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(765),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [766] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3640),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(766),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [767] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3545),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(767),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [768] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3542),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(768),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [769] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3606),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(769),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [770] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3558),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(770),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [771] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3605),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(771),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [772] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3511),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(772),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [773] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3812),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(773),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [774] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3906),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(774),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [775] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3582),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(775),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [776] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3816),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(776),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [777] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3817),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(777),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [778] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3587),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(778),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [779] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4262),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(779),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [780] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3595),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(780),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [781] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3586),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(781),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [782] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3819),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(782),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [783] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3585),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(783),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [784] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3655),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(784),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [785] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3584),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(785),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [786] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3820),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(786),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [787] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3827),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(787),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [788] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3821),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(788),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [789] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3822),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(789),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [790] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3823),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(790),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [791] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3829),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(791),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [792] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4231),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(792),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [793] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3830),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(793),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [794] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3831),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(794),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [795] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3578),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(795),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [796] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3581),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(796),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [797] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3659),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(797),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [798] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3834),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(798),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [799] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4316),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(799),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [800] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3825),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(800),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [801] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3854),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(801),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [802] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4261),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(802),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [803] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3751),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(803),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [804] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4029),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(804),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [805] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3986),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(805),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [806] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4129),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(806),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [807] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4377),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(807),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [808] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3969),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(808),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [809] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3172),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(809),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [810] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3982),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(810),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [811] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3981),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(811),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [812] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4097),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(812),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [813] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3980),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(813),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [814] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3979),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(814),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [815] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3188),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(815),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [816] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4066),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(816),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [817] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3978),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(817),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [818] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3967),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(818),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [819] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3975),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(819),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [820] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3974),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(820),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [821] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3973),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(821),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [822] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3348),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(822),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [823] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3966),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(823),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [824] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3962),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(824),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [825] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3955),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(825),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [826] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3514),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(826),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [827] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4056),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(827),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [828] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3971),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(828),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [829] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4196),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(829),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [830] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4044),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(830),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [831] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4229),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(831),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [832] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6627),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5500),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4052),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4021),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(832),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1599),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1601),
    [anon_sym_async] = ACTIONS(1603),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1605),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1607),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1607),
    [anon_sym_PLUS_PLUS] = ACTIONS(1607),
    [anon_sym_DASH_DASH] = ACTIONS(1607),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1609),
    [anon_sym_DASH] = ACTIONS(1609),
    [anon_sym_STAR] = ACTIONS(1607),
    [anon_sym_CARET] = ACTIONS(1607),
    [anon_sym_AMP] = ACTIONS(1607),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1611),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1613),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1615),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [833] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4096),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(833),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [834] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4211),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(834),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [835] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4224),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(835),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [836] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4218),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(836),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [837] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4216),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(837),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [838] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4289),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(838),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [839] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3175),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(839),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [840] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4187),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(840),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [841] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4210),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(841),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [842] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4200),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(842),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [843] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4199),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(843),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [844] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4190),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(844),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [845] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3635),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(845),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [846] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4165),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(846),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [847] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3347),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(847),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [848] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3147),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(848),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [849] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4105),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(849),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [850] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3174),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(850),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [851] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3232),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(851),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [852] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4180),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(852),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [853] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3480),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(853),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [854] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4186),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(854),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [855] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3393),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(855),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [856] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4182),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(856),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [857] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4181),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(857),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [858] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4178),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(858),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [859] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3142),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(859),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [860] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4039),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(860),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [861] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4155),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(861),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [862] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4212),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(862),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [863] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4153),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(863),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [864] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4151),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(864),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [865] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3628),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(865),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [866] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4147),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(866),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [867] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4225),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(867),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [868] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4226),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(868),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [869] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4342),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(869),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [870] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4258),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(870),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [871] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4228),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(871),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [872] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3134),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(872),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [873] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4308),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(873),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [874] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4256),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(874),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [875] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3456),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(875),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [876] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4159),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(876),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [877] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4172),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(877),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [878] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4173),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(878),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [879] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4357),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(879),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [880] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4358),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(880),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [881] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4174),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(881),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [882] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4359),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(882),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [883] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4175),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(883),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [884] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4103),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(884),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [885] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4345),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(885),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [886] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4361),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(886),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [887] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4364),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(887),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [888] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4179),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(888),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [889] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4365),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(889),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [890] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3731),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(890),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [891] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4366),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(891),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [892] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3498),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(892),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [893] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4367),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(893),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [894] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4184),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(894),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [895] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3678),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(895),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [896] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3459),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(896),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [897] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3397),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(897),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [898] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3512),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(898),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [899] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3116),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(899),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [900] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3418),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(900),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [901] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3478),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(901),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [902] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3449),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(902),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [903] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3430),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(903),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [904] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3407),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(904),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [905] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3469),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(905),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [906] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3479),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(906),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [907] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3486),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(907),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [908] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3451),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(908),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [909] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3548),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(909),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [910] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3633),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(910),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [911] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3530),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(911),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [912] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4390),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(912),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [913] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3258),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(913),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [914] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3660),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(914),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [915] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3439),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(915),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [916] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3914),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(916),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [917] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4244),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(917),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [918] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3768),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(918),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [919] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3934),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(919),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [920] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3900),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(920),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [921] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3897),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(921),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [922] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3880),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(922),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [923] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3870),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(923),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [924] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3599),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(924),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [925] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3867),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(925),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [926] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3841),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(926),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [927] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3865),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(927),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [928] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3862),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(928),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [929] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3861),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(929),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [930] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3840),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(930),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [931] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3838),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(931),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [932] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3836),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(932),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [933] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4245),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(933),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [934] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3750),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(934),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [935] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3845),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(935),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [936] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3753),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(936),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [937] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4248),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(937),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [938] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3851),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(938),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [939] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3985),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(939),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [940] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4249),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(940),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [941] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4008),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(941),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [942] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4197),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(942),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [943] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4194),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(943),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [944] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3991),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(944),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [945] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3993),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(945),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [946] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3994),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(946),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [947] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3995),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(947),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [948] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4188),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(948),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [949] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3996),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(949),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [950] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4010),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(950),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [951] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3997),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(951),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [952] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3998),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(952),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [953] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4000),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(953),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [954] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4012),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(954),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [955] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4013),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(955),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [956] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4014),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(956),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [957] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4250),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(957),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [958] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4086),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(958),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [959] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4003),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(959),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [960] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4084),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(960),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [961] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4167),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(961),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [962] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4116),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(962),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [963] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4085),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(963),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [964] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4115),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(964),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [965] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4111),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(965),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [966] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4109),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(966),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [967] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4260),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(967),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [968] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6710),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5485),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3794),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3752),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(968),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1247),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1249),
    [anon_sym_async] = ACTIONS(1251),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1253),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1255),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1255),
    [anon_sym_PLUS_PLUS] = ACTIONS(1255),
    [anon_sym_DASH_DASH] = ACTIONS(1255),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1257),
    [anon_sym_DASH] = ACTIONS(1257),
    [anon_sym_STAR] = ACTIONS(1255),
    [anon_sym_CARET] = ACTIONS(1255),
    [anon_sym_AMP] = ACTIONS(1255),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1259),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1261),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1265),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [969] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3316),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(969),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [970] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4087),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(970),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [971] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3598),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(971),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [972] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4100),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(972),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [973] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4027),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(973),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [974] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3725),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(974),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [975] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3259),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(975),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [976] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4168),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(976),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [977] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3497),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(977),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [978] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4036),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(978),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [979] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3644),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(979),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [980] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3334),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(980),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [981] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6765),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5441),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4035),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4025),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(981),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1545),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1547),
    [anon_sym_async] = ACTIONS(1549),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1551),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1553),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1553),
    [anon_sym_PLUS_PLUS] = ACTIONS(1553),
    [anon_sym_DASH_DASH] = ACTIONS(1553),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1555),
    [anon_sym_DASH] = ACTIONS(1555),
    [anon_sym_STAR] = ACTIONS(1553),
    [anon_sym_CARET] = ACTIONS(1553),
    [anon_sym_AMP] = ACTIONS(1553),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1557),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1559),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1561),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [982] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3325),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(982),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [983] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3346),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(983),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [984] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3267),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(984),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [985] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3350),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(985),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [986] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3692),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(986),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [987] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3609),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(987),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [988] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3324),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(988),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [989] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3300),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(989),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [990] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3226),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(990),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [991] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3305),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(991),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [992] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3294),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(992),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [993] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3298),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(993),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [994] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3285),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(994),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [995] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3032),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(995),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [996] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3031),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(996),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [997] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3284),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(997),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [998] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6812),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5481),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4005),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3933),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(998),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1581),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_async] = ACTIONS(1585),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(1587),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1589),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_PLUS_PLUS] = ACTIONS(1589),
    [anon_sym_DASH_DASH] = ACTIONS(1589),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1591),
    [anon_sym_DASH] = ACTIONS(1591),
    [anon_sym_STAR] = ACTIONS(1589),
    [anon_sym_CARET] = ACTIONS(1589),
    [anon_sym_AMP] = ACTIONS(1589),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1593),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1595),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1597),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [999] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3621),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(999),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1000] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3594),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1000),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1001] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3740),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1001),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1002] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3600),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1002),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1003] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3517),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1003),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1004] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6824),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5437),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3693),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3642),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1004),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1371),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1373),
    [anon_sym_async] = ACTIONS(1375),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1377),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1379),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1379),
    [anon_sym_PLUS_PLUS] = ACTIONS(1379),
    [anon_sym_DASH_DASH] = ACTIONS(1379),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1381),
    [anon_sym_DASH] = ACTIONS(1381),
    [anon_sym_STAR] = ACTIONS(1379),
    [anon_sym_CARET] = ACTIONS(1379),
    [anon_sym_AMP] = ACTIONS(1379),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1383),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1385),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1387),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1389),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1005] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3289),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1005),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1006] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3352),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1006),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1007] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3287),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1007),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1008] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3550),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1008),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1009] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6873),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5470),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3757),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3884),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1009),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1311),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1313),
    [anon_sym_async] = ACTIONS(1315),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1317),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1319),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1319),
    [anon_sym_PLUS_PLUS] = ACTIONS(1319),
    [anon_sym_DASH_DASH] = ACTIONS(1319),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1321),
    [anon_sym_DASH] = ACTIONS(1321),
    [anon_sym_STAR] = ACTIONS(1319),
    [anon_sym_CARET] = ACTIONS(1319),
    [anon_sym_AMP] = ACTIONS(1319),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1323),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1325),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1329),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1010] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3508),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1010),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1011] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3251),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1011),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1012] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3419),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1012),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1013] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3941),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1013),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1014] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3639),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1014),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1015] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3690),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1015),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1016] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3410),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1016),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1017] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3373),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1017),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1018] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3493),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1018),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1019] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3481),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1019),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1020] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3420),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1020),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1021] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3431),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1021),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1022] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3433),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1022),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1023] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3435),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1023),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1024] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3627),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1024),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1025] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3436),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1025),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1026] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3442),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1026),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1027] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3437),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1027),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1028] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3440),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1028),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1029] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3441),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1029),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1030] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3474),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1030),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1031] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3463),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1031),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1032] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3462),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1032),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1033] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3643),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1033),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1034] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3458),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1034),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1035] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3444),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1035),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1036] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6781),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5496),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3408),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3461),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1036),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1091),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1093),
    [anon_sym_async] = ACTIONS(1095),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1097),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1099),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1099),
    [anon_sym_PLUS_PLUS] = ACTIONS(1099),
    [anon_sym_DASH_DASH] = ACTIONS(1099),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1101),
    [anon_sym_DASH] = ACTIONS(1101),
    [anon_sym_STAR] = ACTIONS(1099),
    [anon_sym_CARET] = ACTIONS(1099),
    [anon_sym_AMP] = ACTIONS(1099),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1103),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1105),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1109),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1037] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3649),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1037),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1038] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3596),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1038),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1039] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4079),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1039),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1040] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3650),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1040),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1041] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4162),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1041),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1042] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3570),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1042),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1043] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3556),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1043),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1044] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3554),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1044),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1045] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3515),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1045),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1046] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3835),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1046),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1047] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3538),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1047),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1048] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3592),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1048),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1049] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3523),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1049),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1050] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3518),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1050),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1051] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3528),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1051),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1052] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3532),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1052),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1053] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3611),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1053),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1054] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3617),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1054),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1055] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4171),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1055),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1056] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3618),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1056),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1057] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3551),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1057),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1058] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6891),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5448),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3630),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1058),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1171),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1173),
    [anon_sym_async] = ACTIONS(1175),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1177),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1179),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1179),
    [anon_sym_PLUS_PLUS] = ACTIONS(1179),
    [anon_sym_DASH_DASH] = ACTIONS(1179),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1181),
    [anon_sym_DASH] = ACTIONS(1181),
    [anon_sym_STAR] = ACTIONS(1179),
    [anon_sym_CARET] = ACTIONS(1179),
    [anon_sym_AMP] = ACTIONS(1179),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1183),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1185),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1187),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1059] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4209),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1059),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1060] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4233),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1060),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1061] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4255),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1061),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1062] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3615),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1062),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1063] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3467),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1063),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1064] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4257),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1064),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1065] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4275),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1065),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1066] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4288),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1066),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1067] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3450),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1067),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1068] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3701),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1068),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1069] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3657),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1069),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1070] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3691),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1070),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1071] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3694),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1071),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1072] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3695),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1072),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1073] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4389),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1073),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1074] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4388),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1074),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1075] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3544),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1075),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1076] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3601),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1076),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1077] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3723),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1077),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1078] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3709),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1078),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1079] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3607),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1079),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1080] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3704),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1080),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1081] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3696),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1081),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1082] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3733),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1082),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1083] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3711),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1083),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1084] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3719),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1084),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1085] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3698),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1085),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1086] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3539),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1086),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1087] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3732),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1087),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1088] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4320),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1088),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1089] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3374),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1089),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1090] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3702),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1090),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1091] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3662),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1091),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1092] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3654),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1092),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1093] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3699),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1093),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1094] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3531),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1094),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1095] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3728),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1095),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1096] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3540),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1096),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1097] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3428),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1097),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1098] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6688),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5464),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3522),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3536),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1098),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1071),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1073),
    [anon_sym_async] = ACTIONS(1075),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1077),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1079),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1079),
    [anon_sym_PLUS_PLUS] = ACTIONS(1079),
    [anon_sym_DASH_DASH] = ACTIONS(1079),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1081),
    [anon_sym_DASH] = ACTIONS(1081),
    [anon_sym_STAR] = ACTIONS(1079),
    [anon_sym_CARET] = ACTIONS(1079),
    [anon_sym_AMP] = ACTIONS(1079),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1083),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1085),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1089),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1099] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3786),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1099),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1100] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3700),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1100),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1101] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3881),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1101),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1102] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3710),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1102),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1103] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3783),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1103),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1104] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3782),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1104),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1105] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3780),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1105),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1106] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6770),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5467),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4240),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4195),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1106),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1491),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1493),
    [anon_sym_async] = ACTIONS(1495),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1497),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1499),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1499),
    [anon_sym_PLUS_PLUS] = ACTIONS(1499),
    [anon_sym_DASH_DASH] = ACTIONS(1499),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1501),
    [anon_sym_DASH] = ACTIONS(1501),
    [anon_sym_STAR] = ACTIONS(1499),
    [anon_sym_CARET] = ACTIONS(1499),
    [anon_sym_AMP] = ACTIONS(1499),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1503),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1505),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1263),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1507),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1107] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3779),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1107),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1108] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3712),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1108),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1109] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3778),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1109),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1110] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3759),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1110),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1111] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3774),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1111),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1112] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3770),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1112),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1113] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3769),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1113),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1114] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3756),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1114),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1115] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4048),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1115),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1116] = {
    [sym__name] = STATE(6487),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6640),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5497),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4235),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1116),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1409),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1411),
    [anon_sym_async] = ACTIONS(1413),
    [anon_sym_new] = ACTIONS(1415),
    [anon_sym_ref] = ACTIONS(1417),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1419),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1419),
    [anon_sym_PLUS_PLUS] = ACTIONS(1419),
    [anon_sym_DASH_DASH] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1421),
    [anon_sym_DASH] = ACTIONS(1421),
    [anon_sym_STAR] = ACTIONS(1419),
    [anon_sym_CARET] = ACTIONS(1419),
    [anon_sym_AMP] = ACTIONS(1419),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1423),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1425),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1427),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1429),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1117] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3749),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1117),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1118] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3721),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1118),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1119] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3748),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1119),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1120] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3722),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1120),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1121] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3742),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1121),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1122] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3761),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1122),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1123] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3689),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1123),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1124] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3921),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1124),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1125] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3504),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1125),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1126] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4161),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1126),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1127] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6791),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5477),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3919),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1127),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1153),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1155),
    [anon_sym_async] = ACTIONS(1157),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1159),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1161),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1161),
    [anon_sym_PLUS_PLUS] = ACTIONS(1161),
    [anon_sym_DASH_DASH] = ACTIONS(1161),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1163),
    [anon_sym_DASH] = ACTIONS(1163),
    [anon_sym_STAR] = ACTIONS(1161),
    [anon_sym_CARET] = ACTIONS(1161),
    [anon_sym_AMP] = ACTIONS(1161),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1165),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1167),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1169),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1128] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3425),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1128),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1129] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3668),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1129),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1130] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3192),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1130),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1131] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4219),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1131),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1132] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6895),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5460),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3588),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3667),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1132),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1331),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1333),
    [anon_sym_async] = ACTIONS(1335),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1337),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1339),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1339),
    [anon_sym_PLUS_PLUS] = ACTIONS(1339),
    [anon_sym_DASH_DASH] = ACTIONS(1339),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1341),
    [anon_sym_DASH] = ACTIONS(1341),
    [anon_sym_STAR] = ACTIONS(1339),
    [anon_sym_CARET] = ACTIONS(1339),
    [anon_sym_AMP] = ACTIONS(1339),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1343),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1345),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1347),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1349),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1133] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4280),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1133),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1134] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2701),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1134),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1135] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3191),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1135),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1136] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3394),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1136),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1137] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3205),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1137),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1138] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3206),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1138),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1139] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3207),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1139),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1140] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3212),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1140),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1141] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3395),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1141),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1142] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3213),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1142),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1143] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3224),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1143),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1144] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3214),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1144),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1145] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4074),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1145),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1146] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3215),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1146),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1147] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3216),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1147),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1148] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3223),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1148),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1149] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3222),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1149),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1150] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3221),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1150),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1151] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3499),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1151),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1152] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3196),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1152),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1153] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3219),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1153),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1154] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3199),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1154),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1155] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3401),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1155),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1156] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3198),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1156),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1157] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2965),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1157),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1158] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3404),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1158),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1159] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2910),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1159),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1160] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3405),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1160),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1161] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2904),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1161),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1162] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2902),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1162),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1163] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2900),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1163),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1164] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2898),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1164),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1165] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3406),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1165),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1166] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3501),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1166),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1167] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2891),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1167),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1168] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2955),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1168),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1169] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2890),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1169),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1170] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2889),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1170),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1171] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2888),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1171),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1172] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2967),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1172),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1173] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2983),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1173),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1174] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2982),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1174),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1175] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4401),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1175),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1176] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2882),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1176),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1177] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2883),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1177),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1178] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2876),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1178),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1179] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3505),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1179),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1180] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2877),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1180),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1181] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3438),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1181),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1182] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3506),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1182),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1183] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3507),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1183),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1184] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3509),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1184),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1185] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3510),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1185),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1186] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3472),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1186),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1187] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3465),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1187),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1188] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6837),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5499),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3398),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3503),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1188),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(985),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(989),
    [anon_sym_new] = ACTIONS(991),
    [anon_sym_ref] = ACTIONS(993),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(995),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(995),
    [anon_sym_PLUS_PLUS] = ACTIONS(995),
    [anon_sym_DASH_DASH] = ACTIONS(995),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_STAR] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1001),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1003),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1005),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1189] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3747),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1189),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1190] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3744),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1190),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1191] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3924),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1191),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1192] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3758),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1192),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1193] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3873),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1193),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1194] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3872),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1194),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1195] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3871),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1195),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1196] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3918),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1196),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1197] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3915),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1197),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1198] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3913),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1198),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1199] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3866),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1199),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1200] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3912),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1200),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1201] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3911),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1201),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1202] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3907),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1202),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1203] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3898),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1203),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1204] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3896),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1204),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1205] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3857),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1205),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1206] = {
    [sym__name] = STATE(6566),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6856),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3888),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3775),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1206),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1111),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1113),
    [anon_sym_async] = ACTIONS(1115),
    [anon_sym_new] = ACTIONS(1117),
    [anon_sym_ref] = ACTIONS(1119),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1121),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1121),
    [anon_sym_PLUS_PLUS] = ACTIONS(1121),
    [anon_sym_DASH_DASH] = ACTIONS(1121),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1123),
    [anon_sym_DASH] = ACTIONS(1123),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_CARET] = ACTIONS(1121),
    [anon_sym_AMP] = ACTIONS(1121),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(1125),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1127),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1129),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1131),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1207] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3242),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1207),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1208] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3322),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1208),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1209] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4237),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1209),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1210] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3321),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1210),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1211] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3320),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1211),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1212] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3282),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1212),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1213] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2729),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1213),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1214] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2730),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1214),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1215] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3280),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1215),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1216] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4310),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1216),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1217] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4268),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1217),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1218] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3190),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1218),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1219] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3278),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1219),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1220] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3319),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1220),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1221] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3277),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1221),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1222] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3421),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1222),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1223] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3270),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1223),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1224] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3264),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1224),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1225] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3263),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1225),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1226] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3424),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1226),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1227] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3432),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1227),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1228] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3434),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1228),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1229] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3254),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1229),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1230] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3502),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1230),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1231] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3477),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1231),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1232] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3602),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1232),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1233] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3471),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1233),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1234] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3468),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1234),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1235] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4344),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1235),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1236] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3453),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1236),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1237] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3447),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1237),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1238] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3409),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1238),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1239] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3313),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1239),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1240] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3411),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1240),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1241] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4384),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1241),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1242] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4380),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1242),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1243] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4379),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1243),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1244] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4378),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1244),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1245] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3243),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1245),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1246] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3181),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1246),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1247] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4327),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1247),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1248] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4318),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1248),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1249] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4315),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1249),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1250] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4314),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1250),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1251] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4302),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1251),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1252] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4299),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1252),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1253] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4295),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1253),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1254] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3189),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1254),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1255] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3283),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1255),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1256] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4293),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1256),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1257] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3210),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1257),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1258] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3279),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1258),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1259] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3343),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1259),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1260] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4156),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1260),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1261] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3337),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1261),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1262] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6927),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5472),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3261),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3329),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1262),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1511),
    [anon_sym_async] = ACTIONS(1513),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1515),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1517),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1517),
    [anon_sym_PLUS_PLUS] = ACTIONS(1517),
    [anon_sym_DASH_DASH] = ACTIONS(1517),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1519),
    [anon_sym_DASH] = ACTIONS(1519),
    [anon_sym_STAR] = ACTIONS(1517),
    [anon_sym_CARET] = ACTIONS(1517),
    [anon_sym_AMP] = ACTIONS(1517),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1521),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1523),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1525),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1263] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4398),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1263),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1264] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4400),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1264),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1265] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4397),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1265),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1266] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4141),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1266),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1267] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4108),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1267),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1268] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4221),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1268),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1269] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4137),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1269),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1270] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4112),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1270),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1271] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4114),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1271),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1272] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4251),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1272),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1273] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4282),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1273),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1274] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4292),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1274),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1275] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4252),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1275),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1276] = {
    [sym__name] = STATE(6515),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6917),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4169),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4329),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1276),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1451),
    [anon_sym_async] = ACTIONS(1453),
    [anon_sym_new] = ACTIONS(1455),
    [anon_sym_ref] = ACTIONS(1457),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1459),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1459),
    [anon_sym_PLUS_PLUS] = ACTIONS(1459),
    [anon_sym_DASH_DASH] = ACTIONS(1459),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1461),
    [anon_sym_DASH] = ACTIONS(1461),
    [anon_sym_STAR] = ACTIONS(1459),
    [anon_sym_CARET] = ACTIONS(1459),
    [anon_sym_AMP] = ACTIONS(1459),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(1463),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1465),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1467),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1469),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1277] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4243),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1277),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1278] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4239),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1278),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1279] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3970),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1279),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1280] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3491),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1280),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1281] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4073),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1281),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1282] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4334),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1282),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1283] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3961),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1283),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1284] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3960),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1284),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1285] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3959),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1285),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1286] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3958),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1286),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1287] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4158),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1287),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1288] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3957),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1288),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1289] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3965),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1289),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1290] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3956),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1290),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1291] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3954),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1291),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1292] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3953),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1292),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1293] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3946),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1293),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1294] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3945),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1294),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1295] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3951),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1295),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1296] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3944),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1296),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1297] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4353),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1297),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1298] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4091),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1298),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1299] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3948),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1299),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1300] = {
    [sym__name] = STATE(6593),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6755),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5463),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(4093),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(4247),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1300),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1471),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1473),
    [anon_sym_async] = ACTIONS(1475),
    [anon_sym_new] = ACTIONS(1477),
    [anon_sym_ref] = ACTIONS(1479),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1481),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1481),
    [anon_sym_PLUS_PLUS] = ACTIONS(1481),
    [anon_sym_DASH_DASH] = ACTIONS(1481),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1483),
    [anon_sym_DASH] = ACTIONS(1483),
    [anon_sym_STAR] = ACTIONS(1481),
    [anon_sym_CARET] = ACTIONS(1481),
    [anon_sym_AMP] = ACTIONS(1481),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(999),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1485),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1487),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1489),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1301] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4326),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1301),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1302] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3414),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1302),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1303] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3489),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1303),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1304] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4385),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1304),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1305] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3716),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1305),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1306] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4381),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1306),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1307] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3482),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1307),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1308] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3521),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1308),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1309] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3520),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1309),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1310] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3519),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1310),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1311] = {
    [sym__name] = STATE(6492),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6796),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5493),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3648),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3703),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1311),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(645),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(975),
    [anon_sym_async] = ACTIONS(655),
    [anon_sym_new] = ACTIONS(657),
    [anon_sym_ref] = ACTIONS(977),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(979),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(979),
    [anon_sym_PLUS_PLUS] = ACTIONS(979),
    [anon_sym_DASH_DASH] = ACTIONS(979),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(981),
    [anon_sym_DASH] = ACTIONS(981),
    [anon_sym_STAR] = ACTIONS(979),
    [anon_sym_CARET] = ACTIONS(979),
    [anon_sym_AMP] = ACTIONS(979),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(983),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(683),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(691),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(699),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1312] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3527),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1312),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1313] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3608),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1313),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1314] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3516),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1314),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1315] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3534),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1315),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1316] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3533),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1316),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1317] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3613),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1317),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1318] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3614),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1318),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1319] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6747),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5486),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3616),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3697),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1319),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(1227),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1229),
    [anon_sym_async] = ACTIONS(1231),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1233),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1235),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1235),
    [anon_sym_PLUS_PLUS] = ACTIONS(1235),
    [anon_sym_DASH_DASH] = ACTIONS(1235),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1237),
    [anon_sym_DASH] = ACTIONS(1237),
    [anon_sym_STAR] = ACTIONS(1235),
    [anon_sym_CARET] = ACTIONS(1235),
    [anon_sym_AMP] = ACTIONS(1235),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1239),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1241),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1243),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1245),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1320] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4290),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1320),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1321] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3413),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1321),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1322] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3470),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1322),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1323] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6643),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5466),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3400),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3708),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1323),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1189),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1191),
    [anon_sym_async] = ACTIONS(1193),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(1195),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(1197),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(1197),
    [anon_sym_PLUS_PLUS] = ACTIONS(1197),
    [anon_sym_DASH_DASH] = ACTIONS(1197),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(1199),
    [anon_sym_DASH] = ACTIONS(1199),
    [anon_sym_STAR] = ACTIONS(1197),
    [anon_sym_CARET] = ACTIONS(1197),
    [anon_sym_AMP] = ACTIONS(1197),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(1201),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(1203),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(1107),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(1205),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1324] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4285),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1324),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1325] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4283),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1325),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1326] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4271),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1326),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1327] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3150),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1327),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1328] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3353),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1328),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1329] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3167),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1329),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1330] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4242),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1330),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1331] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3154),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1331),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1332] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3156),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1332),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1333] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4214),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1333),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1334] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3157),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1334),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1335] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4206),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1335),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1336] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3160),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1336),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1337] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4204),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1337),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1338] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4203),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1338),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1339] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2845),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1339),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1340] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2791),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1340),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1341] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3168),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1341),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1342] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3185),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1342),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1343] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4107),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1343),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1344] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3169),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1344),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1345] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3171),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1345),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1346] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2712),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1346),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1347] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2853),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1347),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1348] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3173),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1348),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1349] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3184),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1349),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1350] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3183),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1350),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1351] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3182),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1351),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1352] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2840),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1352),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1353] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3128),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1353),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1354] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4127),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1354),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1355] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3165),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1355),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1356] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3131),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1356),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1357] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2828),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1357),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1358] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2817),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1358),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1359] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6697),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5480),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4113),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4254),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1359),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1527),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_async] = ACTIONS(1531),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1533),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1535),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_PLUS_PLUS] = ACTIONS(1535),
    [anon_sym_DASH_DASH] = ACTIONS(1535),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1537),
    [anon_sym_DASH] = ACTIONS(1537),
    [anon_sym_STAR] = ACTIONS(1535),
    [anon_sym_CARET] = ACTIONS(1535),
    [anon_sym_AMP] = ACTIONS(1535),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1539),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1541),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1327),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1543),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1360] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2815),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1360),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1361] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3887),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1361),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1362] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4076),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1362),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1363] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2804),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1363),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1364] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3837),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1364),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1365] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2854),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1365),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1366] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2797),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1366),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1367] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3876),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1367),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1368] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3859),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1368),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1369] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3855),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1369),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1370] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2793),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1370),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1371] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3842),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1371),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1372] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2792),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1372),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1373] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3895),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1373),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1374] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3766),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1374),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1375] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3828),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1375),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1376] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3832),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1376),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1377] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3806),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1377),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1378] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3765),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1378),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1379] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3763),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1379),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1380] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3762),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1380),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1381] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2790),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1381),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1382] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3852),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1382),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1383] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3802),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1383),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1384] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6670),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5498),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3850),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3891),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1384),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(1291),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1293),
    [anon_sym_async] = ACTIONS(1295),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1297),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1299),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1299),
    [anon_sym_PLUS_PLUS] = ACTIONS(1299),
    [anon_sym_DASH_DASH] = ACTIONS(1299),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1301),
    [anon_sym_DASH] = ACTIONS(1301),
    [anon_sym_STAR] = ACTIONS(1299),
    [anon_sym_CARET] = ACTIONS(1299),
    [anon_sym_AMP] = ACTIONS(1299),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1303),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1305),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1309),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1385] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2719),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1385),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1386] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6650),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5471),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3140),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3130),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1386),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(729),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(735),
    [anon_sym_async] = ACTIONS(737),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(741),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(749),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(749),
    [anon_sym_PLUS_PLUS] = ACTIONS(749),
    [anon_sym_DASH_DASH] = ACTIONS(749),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(751),
    [anon_sym_DASH] = ACTIONS(751),
    [anon_sym_STAR] = ACTIONS(749),
    [anon_sym_CARET] = ACTIONS(749),
    [anon_sym_AMP] = ACTIONS(749),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(761),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(765),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(779),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1387] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2841),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1387),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1388] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2656),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1388),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1389] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3671),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1389),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1390] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2783),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1390),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1391] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3476),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1391),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1392] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3576),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1392),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1393] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3385),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1393),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1394] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3674),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1394),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1395] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3675),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1395),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1396] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3676),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1396),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1397] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3677),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1397),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1398] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3377),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1398),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1399] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3683),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1399),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1400] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3718),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1400),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1401] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3684),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1401),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1402] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3685),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1402),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1403] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3686),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1403),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1404] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3717),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1404),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1405] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3715),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1405),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1406] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3714),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1406),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1407] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3365),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1407),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1408] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3666),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1408),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1409] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3688),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1409),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1410] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3661),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1410),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1411] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3379),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1411),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1412] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6733),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5495),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3663),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3745),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1412),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(1133),
    [anon_sym_static] = ACTIONS(1135),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(1137),
    [anon_sym_async] = ACTIONS(1139),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(1141),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(1143),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(1143),
    [anon_sym_PLUS_PLUS] = ACTIONS(1143),
    [anon_sym_DASH_DASH] = ACTIONS(1143),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1143),
    [anon_sym_CARET] = ACTIONS(1143),
    [anon_sym_AMP] = ACTIONS(1143),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(1147),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(1149),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(1087),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(1151),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1413] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3391),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1413),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1414] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3383),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1414),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1415] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3246),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1415),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1416] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3382),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1416),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1417] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3369),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1417),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1418] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3268),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1418),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1419] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3390),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1419),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1420] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3335),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1420),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1421] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3330),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1421),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1422] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3256),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1422),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1423] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3331),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1423),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1424] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3429),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1424),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1425] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3310),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1425),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1426] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3295),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1426),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1427] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3252),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1427),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1428] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3233),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1428),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1429] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3250),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1429),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1430] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3304),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1430),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1431] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3306),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1431),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1432] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3307),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1432),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1433] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3354),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1433),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1434] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4332),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1434),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1435] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3266),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1435),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1436] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3227),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1436),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1437] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3260),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1437),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1438] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3362),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1438),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1439] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6711),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5436),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3265),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3244),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1439),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(805),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(809),
    [anon_sym_async] = ACTIONS(811),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(815),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(823),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(823),
    [anon_sym_PLUS_PLUS] = ACTIONS(823),
    [anon_sym_DASH_DASH] = ACTIONS(823),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_STAR] = ACTIONS(823),
    [anon_sym_CARET] = ACTIONS(823),
    [anon_sym_AMP] = ACTIONS(823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(835),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(843),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1440] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3375),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1440),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1441] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3358),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1441),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1442] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3248),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1442),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1443] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3367),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1443),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1444] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3360),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1444),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1445] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6673),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2812),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2851),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1445),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1207),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1209),
    [anon_sym_async] = ACTIONS(1211),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1213),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1215),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1215),
    [anon_sym_PLUS_PLUS] = ACTIONS(1215),
    [anon_sym_DASH_DASH] = ACTIONS(1215),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1217),
    [anon_sym_DASH] = ACTIONS(1217),
    [anon_sym_STAR] = ACTIONS(1215),
    [anon_sym_CARET] = ACTIONS(1215),
    [anon_sym_AMP] = ACTIONS(1215),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1219),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1221),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1225),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1446] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3288),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1446),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1447] = {
    [sym__name] = STATE(6559),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2913),
    [sym_generic_name] = STATE(2856),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2881),
    [sym_parameter_list] = STATE(6751),
    [sym_anonymous_method_expression] = STATE(2884),
    [sym_lambda_expression] = STATE(2884),
    [sym_anonymous_object_creation_expression] = STATE(2884),
    [sym_implicit_object_creation_expression] = STATE(2884),
    [sym_array_creation_expression] = STATE(2884),
    [sym_initializer_expression] = STATE(2884),
    [sym_assignment_expression] = STATE(2884),
    [sym_await_expression] = STATE(2884),
    [sym_cast_expression] = STATE(2884),
    [sym_checked_expression] = STATE(2884),
    [sym_conditional_access_expression] = STATE(2884),
    [sym_conditional_expression] = STATE(2884),
    [sym_default_expression] = STATE(2884),
    [sym_element_access_expression] = STATE(2884),
    [sym_element_binding_expression] = STATE(2884),
    [sym_implicit_array_creation_expression] = STATE(2884),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_base_expression] = STATE(2884),
    [sym_this_expression] = STATE(2884),
    [sym_interpolated_string_expression] = STATE(2884),
    [sym_invocation_expression] = STATE(2884),
    [sym_is_pattern_expression] = STATE(2884),
    [sym_make_ref_expression] = STATE(2884),
    [sym_member_access_expression] = STATE(2884),
    [sym_object_creation_expression] = STATE(2884),
    [sym_parenthesized_expression] = STATE(2884),
    [sym_postfix_unary_expression] = STATE(2884),
    [sym_prefix_unary_expression] = STATE(2884),
    [sym_query_expression] = STATE(2884),
    [sym_from_clause] = STATE(5449),
    [sym_range_expression] = STATE(2884),
    [sym_ref_expression] = STATE(2884),
    [sym_ref_type_expression] = STATE(2884),
    [sym_ref_value_expression] = STATE(2884),
    [sym_size_of_expression] = STATE(2884),
    [sym_stack_alloc_array_creation_expression] = STATE(2884),
    [sym_switch_expression] = STATE(2884),
    [sym_throw_expression] = STATE(2884),
    [sym_tuple_expression] = STATE(2884),
    [sym_type_of_expression] = STATE(2884),
    [sym_with_expression] = STATE(2884),
    [sym__expression] = STATE(3361),
    [sym_binary_expression] = STATE(2884),
    [sym_as_expression] = STATE(2884),
    [sym_is_expression] = STATE(2884),
    [sym_identifier] = STATE(3378),
    [sym_global] = STATE(2847),
    [sym__literal] = STATE(2884),
    [sym_boolean_literal] = STATE(2878),
    [sym_character_literal] = STATE(2878),
    [sym_string_literal] = STATE(2878),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1447),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(803),
    [anon_sym_static] = ACTIONS(935),
    [anon_sym_LBRACK] = ACTIONS(807),
    [anon_sym_LPAREN] = ACTIONS(937),
    [anon_sym_async] = ACTIONS(939),
    [anon_sym_new] = ACTIONS(813),
    [anon_sym_ref] = ACTIONS(941),
    [anon_sym_this] = ACTIONS(817),
    [anon_sym_base] = ACTIONS(819),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_TILDE] = ACTIONS(669),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(669),
    [anon_sym_PLUS_PLUS] = ACTIONS(669),
    [anon_sym_DASH_DASH] = ACTIONS(669),
    [anon_sym_true] = ACTIONS(671),
    [anon_sym_false] = ACTIONS(671),
    [anon_sym_PLUS] = ACTIONS(673),
    [anon_sym_DASH] = ACTIONS(673),
    [anon_sym_STAR] = ACTIONS(669),
    [anon_sym_CARET] = ACTIONS(669),
    [anon_sym_AMP] = ACTIONS(669),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_delegate] = ACTIONS(827),
    [sym_predefined_type] = ACTIONS(829),
    [anon_sym_checked] = ACTIONS(831),
    [anon_sym_unchecked] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(943),
    [anon_sym_default] = ACTIONS(685),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_throw] = ACTIONS(945),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_stackalloc] = ACTIONS(837),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(693),
    [anon_sym_DQUOTE] = ACTIONS(695),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(697),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(697),
    [anon_sym___makeref] = ACTIONS(839),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(947),
    [anon_sym___reftype] = ACTIONS(845),
    [anon_sym___refvalue] = ACTIONS(847),
    [anon_sym_sizeof] = ACTIONS(701),
    [anon_sym_typeof] = ACTIONS(703),
    [anon_sym_SQUOTE] = ACTIONS(705),
    [sym_integer_literal] = ACTIONS(707),
    [sym_null_literal] = ACTIONS(707),
    [sym_real_literal] = ACTIONS(709),
    [sym_verbatim_string_literal] = ACTIONS(709),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1448] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3271),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1448),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1449] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3225),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1449),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1450] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3273),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1450),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1451] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3274),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1451),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1452] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3326),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1452),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1453] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3293),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1453),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1454] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3240),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1454),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1455] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3296),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1455),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1456] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3297),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1456),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1457] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3299),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1457),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1458] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3238),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1458),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1459] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3237),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1459),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1460] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3236),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1460),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1461] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3328),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1461),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1462] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3342),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1462),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1463] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3318),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1463),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1464] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3351),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1464),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1465] = {
    [sym__name] = STATE(6502),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2743),
    [sym_generic_name] = STATE(2702),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2766),
    [sym_parameter_list] = STATE(6885),
    [sym_anonymous_method_expression] = STATE(2763),
    [sym_lambda_expression] = STATE(2763),
    [sym_anonymous_object_creation_expression] = STATE(2763),
    [sym_implicit_object_creation_expression] = STATE(2763),
    [sym_array_creation_expression] = STATE(2763),
    [sym_initializer_expression] = STATE(2763),
    [sym_assignment_expression] = STATE(2763),
    [sym_await_expression] = STATE(2763),
    [sym_cast_expression] = STATE(2763),
    [sym_checked_expression] = STATE(2763),
    [sym_conditional_access_expression] = STATE(2763),
    [sym_conditional_expression] = STATE(2763),
    [sym_default_expression] = STATE(2763),
    [sym_element_access_expression] = STATE(2763),
    [sym_element_binding_expression] = STATE(2763),
    [sym_implicit_array_creation_expression] = STATE(2763),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_base_expression] = STATE(2763),
    [sym_this_expression] = STATE(2763),
    [sym_interpolated_string_expression] = STATE(2763),
    [sym_invocation_expression] = STATE(2763),
    [sym_is_pattern_expression] = STATE(2763),
    [sym_make_ref_expression] = STATE(2763),
    [sym_member_access_expression] = STATE(2763),
    [sym_object_creation_expression] = STATE(2763),
    [sym_parenthesized_expression] = STATE(2763),
    [sym_postfix_unary_expression] = STATE(2763),
    [sym_prefix_unary_expression] = STATE(2763),
    [sym_query_expression] = STATE(2763),
    [sym_from_clause] = STATE(5479),
    [sym_range_expression] = STATE(2763),
    [sym_ref_expression] = STATE(2763),
    [sym_ref_type_expression] = STATE(2763),
    [sym_ref_value_expression] = STATE(2763),
    [sym_size_of_expression] = STATE(2763),
    [sym_stack_alloc_array_creation_expression] = STATE(2763),
    [sym_switch_expression] = STATE(2763),
    [sym_throw_expression] = STATE(2763),
    [sym_tuple_expression] = STATE(2763),
    [sym_type_of_expression] = STATE(2763),
    [sym_with_expression] = STATE(2763),
    [sym__expression] = STATE(3291),
    [sym_binary_expression] = STATE(2763),
    [sym_as_expression] = STATE(2763),
    [sym_is_expression] = STATE(2763),
    [sym_identifier] = STATE(3241),
    [sym_global] = STATE(2698),
    [sym__literal] = STATE(2763),
    [sym_boolean_literal] = STATE(2770),
    [sym_character_literal] = STATE(2770),
    [sym_string_literal] = STATE(2770),
    [sym__contextual_keywords] = STATE(2633),
    [sym__preprocessor_call] = STATE(1465),
    [sym__identifier_token] = ACTIONS(721),
    [anon_sym_alias] = ACTIONS(723),
    [anon_sym_global] = ACTIONS(727),
    [anon_sym_static] = ACTIONS(849),
    [anon_sym_LBRACK] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(851),
    [anon_sym_async] = ACTIONS(853),
    [anon_sym_new] = ACTIONS(739),
    [anon_sym_ref] = ACTIONS(855),
    [anon_sym_this] = ACTIONS(743),
    [anon_sym_base] = ACTIONS(745),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_TILDE] = ACTIONS(857),
    [anon_sym_where] = ACTIONS(723),
    [anon_sym_notnull] = ACTIONS(723),
    [anon_sym_unmanaged] = ACTIONS(723),
    [anon_sym_BANG] = ACTIONS(857),
    [anon_sym_PLUS_PLUS] = ACTIONS(857),
    [anon_sym_DASH_DASH] = ACTIONS(857),
    [anon_sym_true] = ACTIONS(753),
    [anon_sym_false] = ACTIONS(753),
    [anon_sym_PLUS] = ACTIONS(859),
    [anon_sym_DASH] = ACTIONS(859),
    [anon_sym_STAR] = ACTIONS(857),
    [anon_sym_CARET] = ACTIONS(857),
    [anon_sym_AMP] = ACTIONS(857),
    [anon_sym_get] = ACTIONS(723),
    [anon_sym_set] = ACTIONS(723),
    [anon_sym_add] = ACTIONS(723),
    [anon_sym_remove] = ACTIONS(723),
    [anon_sym_delegate] = ACTIONS(755),
    [sym_predefined_type] = ACTIONS(757),
    [anon_sym_checked] = ACTIONS(759),
    [anon_sym_unchecked] = ACTIONS(759),
    [anon_sym_await] = ACTIONS(861),
    [anon_sym_default] = ACTIONS(763),
    [anon_sym_when] = ACTIONS(723),
    [anon_sym_throw] = ACTIONS(863),
    [anon_sym_yield] = ACTIONS(723),
    [anon_sym_stackalloc] = ACTIONS(767),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(769),
    [anon_sym_DQUOTE] = ACTIONS(771),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(773),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(773),
    [anon_sym___makeref] = ACTIONS(775),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(723),
    [anon_sym_on] = ACTIONS(723),
    [anon_sym_equals] = ACTIONS(723),
    [anon_sym_into] = ACTIONS(723),
    [anon_sym_let] = ACTIONS(723),
    [anon_sym_orderby] = ACTIONS(723),
    [anon_sym_ascending] = ACTIONS(723),
    [anon_sym_descending] = ACTIONS(723),
    [anon_sym_group] = ACTIONS(723),
    [anon_sym_by] = ACTIONS(723),
    [anon_sym_select] = ACTIONS(723),
    [anon_sym_DOT_DOT] = ACTIONS(865),
    [anon_sym___reftype] = ACTIONS(781),
    [anon_sym___refvalue] = ACTIONS(783),
    [anon_sym_sizeof] = ACTIONS(785),
    [anon_sym_typeof] = ACTIONS(787),
    [anon_sym_SQUOTE] = ACTIONS(789),
    [sym_integer_literal] = ACTIONS(791),
    [sym_null_literal] = ACTIONS(791),
    [sym_real_literal] = ACTIONS(793),
    [sym_verbatim_string_literal] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(723),
    [anon_sym_nameof] = ACTIONS(723),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1466] = {
    [sym__name] = STATE(6495),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6763),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5478),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3345),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3317),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1466),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(873),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(877),
    [anon_sym_async] = ACTIONS(879),
    [anon_sym_new] = ACTIONS(881),
    [anon_sym_ref] = ACTIONS(883),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(891),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(891),
    [anon_sym_PLUS_PLUS] = ACTIONS(891),
    [anon_sym_DASH_DASH] = ACTIONS(891),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(893),
    [anon_sym_DASH] = ACTIONS(893),
    [anon_sym_STAR] = ACTIONS(891),
    [anon_sym_CARET] = ACTIONS(891),
    [anon_sym_AMP] = ACTIONS(891),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(899),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(907),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(777),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(919),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1467] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3094),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1467),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1468] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3121),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1468),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1469] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2660),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1469),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1470] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2664),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1470),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1471] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2693),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1471),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1472] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2699),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1472),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1473] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2694),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1473),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1474] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2691),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1474),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1475] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2654),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1475),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1476] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2663),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1476),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1477] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2662),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1477),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1478] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2661),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1478),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1479] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2651),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1479),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1480] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2659),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1480),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1481] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2652),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1481),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1482] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2715),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1482),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1483] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2647),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1483),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1484] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2649),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1484),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1485] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2706),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1485),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1486] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6768),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5492),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2657),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2671),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1486),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1007),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1011),
    [anon_sym_async] = ACTIONS(1013),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1017),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1025),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1025),
    [anon_sym_PLUS_PLUS] = ACTIONS(1025),
    [anon_sym_DASH_DASH] = ACTIONS(1025),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1027),
    [anon_sym_DASH] = ACTIONS(1027),
    [anon_sym_STAR] = ACTIONS(1025),
    [anon_sym_CARET] = ACTIONS(1025),
    [anon_sym_AMP] = ACTIONS(1025),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1037),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1041),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1055),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1487] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3054),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1487),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1488] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3118),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1488),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1489] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3064),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1489),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1490] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3066),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1490),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1491] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3069),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1491),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1492] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3023),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1492),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1493] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3028),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1493),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1494] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2976),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1494),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1495] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3055),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1495),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1496] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(2995),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1496),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1497] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3047),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1497),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1498] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(2990),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1498),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1499] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3056),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1499),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1500] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3004),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1500),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1501] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3009),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1501),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1502] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4352),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1502),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1503] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6693),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5461),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(3158),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3180),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1503),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1351),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1353),
    [anon_sym_async] = ACTIONS(1355),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1357),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1359),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1359),
    [anon_sym_PLUS_PLUS] = ACTIONS(1359),
    [anon_sym_DASH_DASH] = ACTIONS(1359),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1361),
    [anon_sym_DASH] = ACTIONS(1361),
    [anon_sym_STAR] = ACTIONS(1359),
    [anon_sym_CARET] = ACTIONS(1359),
    [anon_sym_AMP] = ACTIONS(1359),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1363),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1365),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1367),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1369),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1504] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3086),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1504),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1505] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3011),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1505),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1506] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3090),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1506),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1507] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3019),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1507),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1508] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3058),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1508),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1509] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3059),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1509),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1510] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3060),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1510),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1511] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6759),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5452),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3026),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3091),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1511),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1267),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1269),
    [anon_sym_async] = ACTIONS(1271),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1275),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1277),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1277),
    [anon_sym_PLUS_PLUS] = ACTIONS(1277),
    [anon_sym_DASH_DASH] = ACTIONS(1277),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1279),
    [anon_sym_DASH] = ACTIONS(1279),
    [anon_sym_STAR] = ACTIONS(1277),
    [anon_sym_CARET] = ACTIONS(1277),
    [anon_sym_AMP] = ACTIONS(1277),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1283),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1285),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1289),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1512] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4110),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1512),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1513] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3080),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1513),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1514] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3036),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1514),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1515] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3083),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1515),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1516] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3084),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1516),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1517] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3085),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1517),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1518] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3035),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1518),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1519] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3034),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1519),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1520] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3005),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1520),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1521] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6884),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(2869),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2868),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1521),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1391),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1393),
    [anon_sym_async] = ACTIONS(1395),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1397),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1399),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1399),
    [anon_sym_PLUS_PLUS] = ACTIONS(1399),
    [anon_sym_DASH_DASH] = ACTIONS(1399),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1401),
    [anon_sym_DASH] = ACTIONS(1401),
    [anon_sym_STAR] = ACTIONS(1399),
    [anon_sym_CARET] = ACTIONS(1399),
    [anon_sym_AMP] = ACTIONS(1399),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1403),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1405),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1053),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1407),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1522] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4339),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1522),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1523] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4098),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1523),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1524] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3119),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1524),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1525] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3112),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1525),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1526] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3068),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1526),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1527] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4213),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1527),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1528] = {
    [sym__name] = STATE(6503),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(3075),
    [sym_generic_name] = STATE(1784),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2862),
    [sym_parameter_list] = STATE(6946),
    [sym_anonymous_method_expression] = STATE(3016),
    [sym_lambda_expression] = STATE(3016),
    [sym_anonymous_object_creation_expression] = STATE(3016),
    [sym_implicit_object_creation_expression] = STATE(3016),
    [sym_array_creation_expression] = STATE(3016),
    [sym_initializer_expression] = STATE(3016),
    [sym_assignment_expression] = STATE(3016),
    [sym_await_expression] = STATE(3016),
    [sym_cast_expression] = STATE(3016),
    [sym_checked_expression] = STATE(3016),
    [sym_conditional_access_expression] = STATE(3016),
    [sym_conditional_expression] = STATE(3016),
    [sym_default_expression] = STATE(3016),
    [sym_element_access_expression] = STATE(3016),
    [sym_element_binding_expression] = STATE(3016),
    [sym_implicit_array_creation_expression] = STATE(3016),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_base_expression] = STATE(3016),
    [sym_this_expression] = STATE(3016),
    [sym_interpolated_string_expression] = STATE(3016),
    [sym_invocation_expression] = STATE(3016),
    [sym_is_pattern_expression] = STATE(3016),
    [sym_make_ref_expression] = STATE(3016),
    [sym_member_access_expression] = STATE(3016),
    [sym_object_creation_expression] = STATE(3016),
    [sym_parenthesized_expression] = STATE(3016),
    [sym_postfix_unary_expression] = STATE(3016),
    [sym_prefix_unary_expression] = STATE(3016),
    [sym_query_expression] = STATE(3016),
    [sym_from_clause] = STATE(5451),
    [sym_range_expression] = STATE(3016),
    [sym_ref_expression] = STATE(3016),
    [sym_ref_type_expression] = STATE(3016),
    [sym_ref_value_expression] = STATE(3016),
    [sym_size_of_expression] = STATE(3016),
    [sym_stack_alloc_array_creation_expression] = STATE(3016),
    [sym_switch_expression] = STATE(3016),
    [sym_throw_expression] = STATE(3016),
    [sym_tuple_expression] = STATE(3016),
    [sym_type_of_expression] = STATE(3016),
    [sym_with_expression] = STATE(3016),
    [sym__expression] = STATE(3104),
    [sym_binary_expression] = STATE(3016),
    [sym_as_expression] = STATE(3016),
    [sym_is_expression] = STATE(3016),
    [sym_identifier] = STATE(2994),
    [sym_global] = STATE(2641),
    [sym__literal] = STATE(3016),
    [sym_boolean_literal] = STATE(3027),
    [sym_character_literal] = STATE(3027),
    [sym_string_literal] = STATE(3027),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1528),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(643),
    [anon_sym_static] = ACTIONS(1431),
    [anon_sym_LBRACK] = ACTIONS(1009),
    [anon_sym_LPAREN] = ACTIONS(1433),
    [anon_sym_async] = ACTIONS(1435),
    [anon_sym_new] = ACTIONS(1015),
    [anon_sym_ref] = ACTIONS(1437),
    [anon_sym_this] = ACTIONS(1019),
    [anon_sym_base] = ACTIONS(1021),
    [anon_sym_LBRACE] = ACTIONS(1023),
    [anon_sym_TILDE] = ACTIONS(1439),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(1439),
    [anon_sym_PLUS_PLUS] = ACTIONS(1439),
    [anon_sym_DASH_DASH] = ACTIONS(1439),
    [anon_sym_true] = ACTIONS(1029),
    [anon_sym_false] = ACTIONS(1029),
    [anon_sym_PLUS] = ACTIONS(1441),
    [anon_sym_DASH] = ACTIONS(1441),
    [anon_sym_STAR] = ACTIONS(1439),
    [anon_sym_CARET] = ACTIONS(1439),
    [anon_sym_AMP] = ACTIONS(1439),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_delegate] = ACTIONS(1031),
    [sym_predefined_type] = ACTIONS(1033),
    [anon_sym_checked] = ACTIONS(1035),
    [anon_sym_unchecked] = ACTIONS(1035),
    [anon_sym_await] = ACTIONS(1443),
    [anon_sym_default] = ACTIONS(1039),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_throw] = ACTIONS(1445),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_stackalloc] = ACTIONS(1043),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1045),
    [anon_sym_DQUOTE] = ACTIONS(1047),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1049),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1049),
    [anon_sym___makeref] = ACTIONS(1051),
    [anon_sym_from] = ACTIONS(1223),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(1447),
    [anon_sym___reftype] = ACTIONS(1057),
    [anon_sym___refvalue] = ACTIONS(1059),
    [anon_sym_sizeof] = ACTIONS(1061),
    [anon_sym_typeof] = ACTIONS(1063),
    [anon_sym_SQUOTE] = ACTIONS(1065),
    [sym_integer_literal] = ACTIONS(1067),
    [sym_null_literal] = ACTIONS(1067),
    [sym_real_literal] = ACTIONS(1069),
    [sym_verbatim_string_literal] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1529] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4264),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1529),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1530] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4319),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1530),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1531] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4135),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1531),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1532] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3138),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1532),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1533] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4336),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1533),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1534] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4322),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1534),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1535] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4343),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1535),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1536] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4124),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1536),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1537] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4123),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1537),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1538] = {
    [sym__name] = STATE(6618),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2143),
    [sym_parameter_list] = STATE(6863),
    [sym_anonymous_method_expression] = STATE(2123),
    [sym_lambda_expression] = STATE(2123),
    [sym_anonymous_object_creation_expression] = STATE(2123),
    [sym_implicit_object_creation_expression] = STATE(2123),
    [sym_array_creation_expression] = STATE(2123),
    [sym_initializer_expression] = STATE(2123),
    [sym_assignment_expression] = STATE(2123),
    [sym_await_expression] = STATE(2123),
    [sym_cast_expression] = STATE(2123),
    [sym_checked_expression] = STATE(2123),
    [sym_conditional_access_expression] = STATE(2123),
    [sym_conditional_expression] = STATE(2123),
    [sym_default_expression] = STATE(2123),
    [sym_element_access_expression] = STATE(2123),
    [sym_element_binding_expression] = STATE(2123),
    [sym_implicit_array_creation_expression] = STATE(2123),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_base_expression] = STATE(2123),
    [sym_this_expression] = STATE(2123),
    [sym_interpolated_string_expression] = STATE(2123),
    [sym_invocation_expression] = STATE(2123),
    [sym_is_pattern_expression] = STATE(2123),
    [sym_make_ref_expression] = STATE(2123),
    [sym_member_access_expression] = STATE(2123),
    [sym_object_creation_expression] = STATE(2123),
    [sym_parenthesized_expression] = STATE(2123),
    [sym_postfix_unary_expression] = STATE(2123),
    [sym_prefix_unary_expression] = STATE(2123),
    [sym_query_expression] = STATE(2123),
    [sym_from_clause] = STATE(5444),
    [sym_range_expression] = STATE(2123),
    [sym_ref_expression] = STATE(2123),
    [sym_ref_type_expression] = STATE(2123),
    [sym_ref_value_expression] = STATE(2123),
    [sym_size_of_expression] = STATE(2123),
    [sym_stack_alloc_array_creation_expression] = STATE(2123),
    [sym_switch_expression] = STATE(2123),
    [sym_throw_expression] = STATE(2123),
    [sym_tuple_expression] = STATE(2123),
    [sym_type_of_expression] = STATE(2123),
    [sym_with_expression] = STATE(2123),
    [sym__expression] = STATE(3166),
    [sym_binary_expression] = STATE(2123),
    [sym_as_expression] = STATE(2123),
    [sym_is_expression] = STATE(2123),
    [sym_identifier] = STATE(3208),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2123),
    [sym_boolean_literal] = STATE(2106),
    [sym_character_literal] = STATE(2106),
    [sym_string_literal] = STATE(2106),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1538),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1617),
    [anon_sym_LBRACK] = ACTIONS(875),
    [anon_sym_LPAREN] = ACTIONS(1619),
    [anon_sym_async] = ACTIONS(1621),
    [anon_sym_new] = ACTIONS(1273),
    [anon_sym_ref] = ACTIONS(1623),
    [anon_sym_this] = ACTIONS(885),
    [anon_sym_base] = ACTIONS(887),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_TILDE] = ACTIONS(1625),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(1625),
    [anon_sym_PLUS_PLUS] = ACTIONS(1625),
    [anon_sym_DASH_DASH] = ACTIONS(1625),
    [anon_sym_true] = ACTIONS(895),
    [anon_sym_false] = ACTIONS(895),
    [anon_sym_PLUS] = ACTIONS(1627),
    [anon_sym_DASH] = ACTIONS(1627),
    [anon_sym_STAR] = ACTIONS(1625),
    [anon_sym_CARET] = ACTIONS(1625),
    [anon_sym_AMP] = ACTIONS(1625),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_delegate] = ACTIONS(897),
    [sym_predefined_type] = ACTIONS(1281),
    [anon_sym_checked] = ACTIONS(901),
    [anon_sym_unchecked] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(1629),
    [anon_sym_default] = ACTIONS(905),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_throw] = ACTIONS(1631),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_stackalloc] = ACTIONS(909),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(911),
    [anon_sym_DQUOTE] = ACTIONS(913),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(915),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(915),
    [anon_sym___makeref] = ACTIONS(917),
    [anon_sym_from] = ACTIONS(1287),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(1633),
    [anon_sym___reftype] = ACTIONS(921),
    [anon_sym___refvalue] = ACTIONS(923),
    [anon_sym_sizeof] = ACTIONS(925),
    [anon_sym_typeof] = ACTIONS(927),
    [anon_sym_SQUOTE] = ACTIONS(929),
    [sym_integer_literal] = ACTIONS(931),
    [sym_null_literal] = ACTIONS(931),
    [sym_real_literal] = ACTIONS(933),
    [sym_verbatim_string_literal] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1539] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4347),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1539),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1540] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4350),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1540),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1541] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4371),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1541),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1542] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4375),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1542),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1543] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4383),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1543),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1544] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6734),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5438),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4311),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(3455),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1544),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(953),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(957),
    [anon_sym_async] = ACTIONS(959),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(963),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(47),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(47),
    [anon_sym_PLUS_PLUS] = ACTIONS(47),
    [anon_sym_DASH_DASH] = ACTIONS(47),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(55),
    [anon_sym_DASH] = ACTIONS(55),
    [anon_sym_STAR] = ACTIONS(47),
    [anon_sym_CARET] = ACTIONS(47),
    [anon_sym_AMP] = ACTIONS(47),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(971),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(973),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(841),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(115),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1545] = {
    [sym__name] = STATE(6616),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(2112),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(4513),
    [sym_bracketed_argument_list] = STATE(2213),
    [sym_parameter_list] = STATE(6921),
    [sym_anonymous_method_expression] = STATE(2203),
    [sym_lambda_expression] = STATE(2203),
    [sym_anonymous_object_creation_expression] = STATE(2203),
    [sym_implicit_object_creation_expression] = STATE(2203),
    [sym_array_creation_expression] = STATE(2203),
    [sym_initializer_expression] = STATE(2203),
    [sym_assignment_expression] = STATE(2203),
    [sym_await_expression] = STATE(2203),
    [sym_cast_expression] = STATE(2203),
    [sym_checked_expression] = STATE(2203),
    [sym_conditional_access_expression] = STATE(2203),
    [sym_conditional_expression] = STATE(2203),
    [sym_default_expression] = STATE(2203),
    [sym_element_access_expression] = STATE(2203),
    [sym_element_binding_expression] = STATE(2203),
    [sym_implicit_array_creation_expression] = STATE(2203),
    [sym_implicit_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_base_expression] = STATE(2203),
    [sym_this_expression] = STATE(2203),
    [sym_interpolated_string_expression] = STATE(2203),
    [sym_invocation_expression] = STATE(2203),
    [sym_is_pattern_expression] = STATE(2203),
    [sym_make_ref_expression] = STATE(2203),
    [sym_member_access_expression] = STATE(2203),
    [sym_object_creation_expression] = STATE(2203),
    [sym_parenthesized_expression] = STATE(2203),
    [sym_postfix_unary_expression] = STATE(2203),
    [sym_prefix_unary_expression] = STATE(2203),
    [sym_query_expression] = STATE(2203),
    [sym_from_clause] = STATE(5462),
    [sym_range_expression] = STATE(2203),
    [sym_ref_expression] = STATE(2203),
    [sym_ref_type_expression] = STATE(2203),
    [sym_ref_value_expression] = STATE(2203),
    [sym_size_of_expression] = STATE(2203),
    [sym_stack_alloc_array_creation_expression] = STATE(2203),
    [sym_switch_expression] = STATE(2203),
    [sym_throw_expression] = STATE(2203),
    [sym_tuple_expression] = STATE(2203),
    [sym_type_of_expression] = STATE(2203),
    [sym_with_expression] = STATE(2203),
    [sym__expression] = STATE(4307),
    [sym_binary_expression] = STATE(2203),
    [sym_as_expression] = STATE(2203),
    [sym_is_expression] = STATE(2203),
    [sym_identifier] = STATE(4354),
    [sym_global] = STATE(2093),
    [sym__literal] = STATE(2203),
    [sym_boolean_literal] = STATE(2267),
    [sym_character_literal] = STATE(2267),
    [sym_string_literal] = STATE(2267),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1545),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1563),
    [anon_sym_LBRACK] = ACTIONS(955),
    [anon_sym_LPAREN] = ACTIONS(1565),
    [anon_sym_async] = ACTIONS(1567),
    [anon_sym_new] = ACTIONS(961),
    [anon_sym_ref] = ACTIONS(1569),
    [anon_sym_this] = ACTIONS(41),
    [anon_sym_base] = ACTIONS(43),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_TILDE] = ACTIONS(1571),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(1571),
    [anon_sym_PLUS_PLUS] = ACTIONS(1571),
    [anon_sym_DASH_DASH] = ACTIONS(1571),
    [anon_sym_true] = ACTIONS(53),
    [anon_sym_false] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(1573),
    [anon_sym_DASH] = ACTIONS(1573),
    [anon_sym_STAR] = ACTIONS(1571),
    [anon_sym_CARET] = ACTIONS(1571),
    [anon_sym_AMP] = ACTIONS(1571),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(967),
    [sym_predefined_type] = ACTIONS(969),
    [anon_sym_checked] = ACTIONS(681),
    [anon_sym_unchecked] = ACTIONS(681),
    [anon_sym_await] = ACTIONS(1575),
    [anon_sym_default] = ACTIONS(89),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_throw] = ACTIONS(1577),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_stackalloc] = ACTIONS(103),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(105),
    [anon_sym_DQUOTE] = ACTIONS(107),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(109),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(109),
    [anon_sym___makeref] = ACTIONS(111),
    [anon_sym_from] = ACTIONS(1307),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(1579),
    [anon_sym___reftype] = ACTIONS(117),
    [anon_sym___refvalue] = ACTIONS(119),
    [anon_sym_sizeof] = ACTIONS(121),
    [anon_sym_typeof] = ACTIONS(123),
    [anon_sym_SQUOTE] = ACTIONS(125),
    [sym_integer_literal] = ACTIONS(127),
    [sym_null_literal] = ACTIONS(127),
    [sym_real_literal] = ACTIONS(129),
    [sym_verbatim_string_literal] = ACTIONS(129),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1546] = {
    [sym_catch_clause] = STATE(1553),
    [sym_finally_clause] = STATE(1621),
    [sym__preprocessor_call] = STATE(1546),
    [aux_sym_try_statement_repeat1] = STATE(1547),
    [ts_builtin_sym_end] = ACTIONS(2187),
    [sym__identifier_token] = ACTIONS(2189),
    [anon_sym_extern] = ACTIONS(2189),
    [anon_sym_alias] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_global] = ACTIONS(2189),
    [anon_sym_using] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_fixed] = ACTIONS(2189),
    [anon_sym_internal] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_partial] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_ref] = ACTIONS(2189),
    [anon_sym_sealed] = ACTIONS(2189),
    [anon_sym_unsafe] = ACTIONS(2189),
    [anon_sym_virtual] = ACTIONS(2189),
    [anon_sym_volatile] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(2189),
    [anon_sym_base] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_where] = ACTIONS(2189),
    [anon_sym_class] = ACTIONS(2189),
    [anon_sym_struct] = ACTIONS(2189),
    [anon_sym_notnull] = ACTIONS(2189),
    [anon_sym_unmanaged] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(2189),
    [anon_sym_false] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_add] = ACTIONS(2189),
    [anon_sym_remove] = ACTIONS(2189),
    [anon_sym_enum] = ACTIONS(2189),
    [anon_sym_interface] = ACTIONS(2189),
    [anon_sym_delegate] = ACTIONS(2189),
    [anon_sym_record] = ACTIONS(2189),
    [anon_sym_namespace] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [sym_predefined_type] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_checked] = ACTIONS(2189),
    [anon_sym_unchecked] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_foreach] = ACTIONS(2189),
    [anon_sym_goto] = ACTIONS(2189),
    [anon_sym_default] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_else] = ACTIONS(2189),
    [anon_sym_lock] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_when] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_catch] = ACTIONS(2191),
    [anon_sym_finally] = ACTIONS(2193),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_stackalloc] = ACTIONS(2189),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2187),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2187),
    [anon_sym___makeref] = ACTIONS(2189),
    [anon_sym_from] = ACTIONS(2189),
    [anon_sym_join] = ACTIONS(2189),
    [anon_sym_on] = ACTIONS(2189),
    [anon_sym_equals] = ACTIONS(2189),
    [anon_sym_into] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_orderby] = ACTIONS(2189),
    [anon_sym_ascending] = ACTIONS(2189),
    [anon_sym_descending] = ACTIONS(2189),
    [anon_sym_group] = ACTIONS(2189),
    [anon_sym_by] = ACTIONS(2189),
    [anon_sym_select] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2187),
    [anon_sym___reftype] = ACTIONS(2189),
    [anon_sym___refvalue] = ACTIONS(2189),
    [anon_sym_sizeof] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [sym_integer_literal] = ACTIONS(2189),
    [sym_null_literal] = ACTIONS(2189),
    [sym_real_literal] = ACTIONS(2187),
    [sym_verbatim_string_literal] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2189),
    [anon_sym_nameof] = ACTIONS(2189),
    [sym_void_keyword] = ACTIONS(2189),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1547] = {
    [sym_catch_clause] = STATE(1553),
    [sym_finally_clause] = STATE(1630),
    [sym__preprocessor_call] = STATE(1547),
    [aux_sym_try_statement_repeat1] = STATE(1548),
    [ts_builtin_sym_end] = ACTIONS(2195),
    [sym__identifier_token] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym_alias] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2195),
    [anon_sym_global] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_fixed] = ACTIONS(2197),
    [anon_sym_internal] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_partial] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2197),
    [anon_sym_sealed] = ACTIONS(2197),
    [anon_sym_unsafe] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2197),
    [anon_sym_base] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2195),
    [anon_sym_TILDE] = ACTIONS(2195),
    [anon_sym_where] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_notnull] = ACTIONS(2197),
    [anon_sym_unmanaged] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2195),
    [anon_sym_PLUS_PLUS] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2195),
    [anon_sym_true] = ACTIONS(2197),
    [anon_sym_false] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2195),
    [anon_sym_CARET] = ACTIONS(2195),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_add] = ACTIONS(2197),
    [anon_sym_remove] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_delegate] = ACTIONS(2197),
    [anon_sym_record] = ACTIONS(2197),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [sym_predefined_type] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_checked] = ACTIONS(2197),
    [anon_sym_unchecked] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_foreach] = ACTIONS(2197),
    [anon_sym_goto] = ACTIONS(2197),
    [anon_sym_default] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_lock] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_when] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_catch] = ACTIONS(2191),
    [anon_sym_finally] = ACTIONS(2193),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_stackalloc] = ACTIONS(2197),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2195),
    [anon_sym_DQUOTE] = ACTIONS(2195),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2195),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2195),
    [anon_sym___makeref] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(2197),
    [anon_sym_join] = ACTIONS(2197),
    [anon_sym_on] = ACTIONS(2197),
    [anon_sym_equals] = ACTIONS(2197),
    [anon_sym_into] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_orderby] = ACTIONS(2197),
    [anon_sym_ascending] = ACTIONS(2197),
    [anon_sym_descending] = ACTIONS(2197),
    [anon_sym_group] = ACTIONS(2197),
    [anon_sym_by] = ACTIONS(2197),
    [anon_sym_select] = ACTIONS(2197),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym___reftype] = ACTIONS(2197),
    [anon_sym___refvalue] = ACTIONS(2197),
    [anon_sym_sizeof] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2195),
    [sym_integer_literal] = ACTIONS(2197),
    [sym_null_literal] = ACTIONS(2197),
    [sym_real_literal] = ACTIONS(2195),
    [sym_verbatim_string_literal] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2197),
    [anon_sym_nameof] = ACTIONS(2197),
    [sym_void_keyword] = ACTIONS(2197),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1548] = {
    [sym_catch_clause] = STATE(1553),
    [sym__preprocessor_call] = STATE(1548),
    [aux_sym_try_statement_repeat1] = STATE(1548),
    [ts_builtin_sym_end] = ACTIONS(2199),
    [sym__identifier_token] = ACTIONS(2201),
    [anon_sym_extern] = ACTIONS(2201),
    [anon_sym_alias] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_global] = ACTIONS(2201),
    [anon_sym_using] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [anon_sym_fixed] = ACTIONS(2201),
    [anon_sym_internal] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_override] = ACTIONS(2201),
    [anon_sym_partial] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_readonly] = ACTIONS(2201),
    [anon_sym_ref] = ACTIONS(2201),
    [anon_sym_sealed] = ACTIONS(2201),
    [anon_sym_unsafe] = ACTIONS(2201),
    [anon_sym_virtual] = ACTIONS(2201),
    [anon_sym_volatile] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(2201),
    [anon_sym_base] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_where] = ACTIONS(2201),
    [anon_sym_class] = ACTIONS(2201),
    [anon_sym_struct] = ACTIONS(2201),
    [anon_sym_notnull] = ACTIONS(2201),
    [anon_sym_unmanaged] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [anon_sym_true] = ACTIONS(2201),
    [anon_sym_false] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2199),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_add] = ACTIONS(2201),
    [anon_sym_remove] = ACTIONS(2201),
    [anon_sym_enum] = ACTIONS(2201),
    [anon_sym_interface] = ACTIONS(2201),
    [anon_sym_delegate] = ACTIONS(2201),
    [anon_sym_record] = ACTIONS(2201),
    [anon_sym_namespace] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [sym_predefined_type] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_checked] = ACTIONS(2201),
    [anon_sym_unchecked] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_await] = ACTIONS(2201),
    [anon_sym_foreach] = ACTIONS(2201),
    [anon_sym_goto] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_lock] = ACTIONS(2201),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_when] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_catch] = ACTIONS(2203),
    [anon_sym_finally] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [anon_sym_stackalloc] = ACTIONS(2201),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2199),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2199),
    [anon_sym___makeref] = ACTIONS(2201),
    [anon_sym_from] = ACTIONS(2201),
    [anon_sym_join] = ACTIONS(2201),
    [anon_sym_on] = ACTIONS(2201),
    [anon_sym_equals] = ACTIONS(2201),
    [anon_sym_into] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_orderby] = ACTIONS(2201),
    [anon_sym_ascending] = ACTIONS(2201),
    [anon_sym_descending] = ACTIONS(2201),
    [anon_sym_group] = ACTIONS(2201),
    [anon_sym_by] = ACTIONS(2201),
    [anon_sym_select] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2199),
    [anon_sym___reftype] = ACTIONS(2201),
    [anon_sym___refvalue] = ACTIONS(2201),
    [anon_sym_sizeof] = ACTIONS(2201),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [sym_integer_literal] = ACTIONS(2201),
    [sym_null_literal] = ACTIONS(2201),
    [sym_real_literal] = ACTIONS(2199),
    [sym_verbatim_string_literal] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2201),
    [anon_sym_nameof] = ACTIONS(2201),
    [sym_void_keyword] = ACTIONS(2201),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1549] = {
    [sym__preprocessor_call] = STATE(1549),
    [ts_builtin_sym_end] = ACTIONS(2206),
    [sym__identifier_token] = ACTIONS(2208),
    [anon_sym_extern] = ACTIONS(2208),
    [anon_sym_alias] = ACTIONS(2208),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_global] = ACTIONS(2208),
    [anon_sym_using] = ACTIONS(2208),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2208),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_abstract] = ACTIONS(2208),
    [anon_sym_async] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_fixed] = ACTIONS(2208),
    [anon_sym_internal] = ACTIONS(2208),
    [anon_sym_new] = ACTIONS(2208),
    [anon_sym_override] = ACTIONS(2208),
    [anon_sym_partial] = ACTIONS(2208),
    [anon_sym_private] = ACTIONS(2208),
    [anon_sym_protected] = ACTIONS(2208),
    [anon_sym_public] = ACTIONS(2208),
    [anon_sym_readonly] = ACTIONS(2208),
    [anon_sym_ref] = ACTIONS(2208),
    [anon_sym_sealed] = ACTIONS(2208),
    [anon_sym_unsafe] = ACTIONS(2208),
    [anon_sym_virtual] = ACTIONS(2208),
    [anon_sym_volatile] = ACTIONS(2208),
    [anon_sym_this] = ACTIONS(2208),
    [anon_sym_base] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_where] = ACTIONS(2208),
    [anon_sym_class] = ACTIONS(2208),
    [anon_sym_struct] = ACTIONS(2208),
    [anon_sym_notnull] = ACTIONS(2208),
    [anon_sym_unmanaged] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_PLUS_PLUS] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2206),
    [anon_sym_true] = ACTIONS(2208),
    [anon_sym_false] = ACTIONS(2208),
    [anon_sym_PLUS] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2208),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_get] = ACTIONS(2208),
    [anon_sym_set] = ACTIONS(2208),
    [anon_sym_add] = ACTIONS(2208),
    [anon_sym_remove] = ACTIONS(2208),
    [anon_sym_enum] = ACTIONS(2208),
    [anon_sym_interface] = ACTIONS(2208),
    [anon_sym_delegate] = ACTIONS(2208),
    [anon_sym_record] = ACTIONS(2208),
    [anon_sym_namespace] = ACTIONS(2208),
    [anon_sym_var] = ACTIONS(2208),
    [sym_predefined_type] = ACTIONS(2208),
    [anon_sym_break] = ACTIONS(2208),
    [anon_sym_checked] = ACTIONS(2208),
    [anon_sym_unchecked] = ACTIONS(2208),
    [anon_sym_continue] = ACTIONS(2208),
    [anon_sym_do] = ACTIONS(2208),
    [anon_sym_while] = ACTIONS(2208),
    [anon_sym_for] = ACTIONS(2208),
    [anon_sym_await] = ACTIONS(2208),
    [anon_sym_foreach] = ACTIONS(2208),
    [anon_sym_goto] = ACTIONS(2208),
    [anon_sym_default] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(2208),
    [anon_sym_else] = ACTIONS(2208),
    [anon_sym_lock] = ACTIONS(2208),
    [anon_sym_switch] = ACTIONS(2208),
    [anon_sym_when] = ACTIONS(2208),
    [anon_sym_throw] = ACTIONS(2208),
    [anon_sym_try] = ACTIONS(2208),
    [anon_sym_catch] = ACTIONS(2208),
    [anon_sym_finally] = ACTIONS(2208),
    [anon_sym_yield] = ACTIONS(2208),
    [anon_sym_stackalloc] = ACTIONS(2208),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2206),
    [anon_sym_DQUOTE] = ACTIONS(2206),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2206),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2206),
    [anon_sym___makeref] = ACTIONS(2208),
    [anon_sym_from] = ACTIONS(2208),
    [anon_sym_join] = ACTIONS(2208),
    [anon_sym_on] = ACTIONS(2208),
    [anon_sym_equals] = ACTIONS(2208),
    [anon_sym_into] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_orderby] = ACTIONS(2208),
    [anon_sym_ascending] = ACTIONS(2208),
    [anon_sym_descending] = ACTIONS(2208),
    [anon_sym_group] = ACTIONS(2208),
    [anon_sym_by] = ACTIONS(2208),
    [anon_sym_select] = ACTIONS(2208),
    [anon_sym_DOT_DOT] = ACTIONS(2206),
    [anon_sym___reftype] = ACTIONS(2208),
    [anon_sym___refvalue] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2208),
    [anon_sym_typeof] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2206),
    [sym_integer_literal] = ACTIONS(2208),
    [sym_null_literal] = ACTIONS(2208),
    [sym_real_literal] = ACTIONS(2206),
    [sym_verbatim_string_literal] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2208),
    [anon_sym_nameof] = ACTIONS(2208),
    [sym_void_keyword] = ACTIONS(2208),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1550] = {
    [sym__preprocessor_call] = STATE(1550),
    [ts_builtin_sym_end] = ACTIONS(2210),
    [sym__identifier_token] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym_alias] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2210),
    [anon_sym_global] = ACTIONS(2212),
    [anon_sym_using] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2210),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_fixed] = ACTIONS(2212),
    [anon_sym_internal] = ACTIONS(2212),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_partial] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_ref] = ACTIONS(2212),
    [anon_sym_sealed] = ACTIONS(2212),
    [anon_sym_unsafe] = ACTIONS(2212),
    [anon_sym_virtual] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_this] = ACTIONS(2212),
    [anon_sym_base] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [anon_sym_where] = ACTIONS(2212),
    [anon_sym_class] = ACTIONS(2212),
    [anon_sym_struct] = ACTIONS(2212),
    [anon_sym_notnull] = ACTIONS(2212),
    [anon_sym_unmanaged] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_PLUS_PLUS] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2210),
    [anon_sym_true] = ACTIONS(2212),
    [anon_sym_false] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2210),
    [anon_sym_CARET] = ACTIONS(2210),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_add] = ACTIONS(2212),
    [anon_sym_remove] = ACTIONS(2212),
    [anon_sym_enum] = ACTIONS(2212),
    [anon_sym_interface] = ACTIONS(2212),
    [anon_sym_delegate] = ACTIONS(2212),
    [anon_sym_record] = ACTIONS(2212),
    [anon_sym_namespace] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [sym_predefined_type] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_checked] = ACTIONS(2212),
    [anon_sym_unchecked] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_foreach] = ACTIONS(2212),
    [anon_sym_goto] = ACTIONS(2212),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_else] = ACTIONS(2212),
    [anon_sym_lock] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_when] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_catch] = ACTIONS(2212),
    [anon_sym_finally] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_stackalloc] = ACTIONS(2212),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2210),
    [anon_sym_DQUOTE] = ACTIONS(2210),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2210),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2210),
    [anon_sym___makeref] = ACTIONS(2212),
    [anon_sym_from] = ACTIONS(2212),
    [anon_sym_join] = ACTIONS(2212),
    [anon_sym_on] = ACTIONS(2212),
    [anon_sym_equals] = ACTIONS(2212),
    [anon_sym_into] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_orderby] = ACTIONS(2212),
    [anon_sym_ascending] = ACTIONS(2212),
    [anon_sym_descending] = ACTIONS(2212),
    [anon_sym_group] = ACTIONS(2212),
    [anon_sym_by] = ACTIONS(2212),
    [anon_sym_select] = ACTIONS(2212),
    [anon_sym_DOT_DOT] = ACTIONS(2210),
    [anon_sym___reftype] = ACTIONS(2212),
    [anon_sym___refvalue] = ACTIONS(2212),
    [anon_sym_sizeof] = ACTIONS(2212),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2210),
    [sym_integer_literal] = ACTIONS(2212),
    [sym_null_literal] = ACTIONS(2212),
    [sym_real_literal] = ACTIONS(2210),
    [sym_verbatim_string_literal] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2212),
    [anon_sym_nameof] = ACTIONS(2212),
    [sym_void_keyword] = ACTIONS(2212),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1551] = {
    [sym__preprocessor_call] = STATE(1551),
    [ts_builtin_sym_end] = ACTIONS(1977),
    [sym__identifier_token] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym_alias] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_global] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_fixed] = ACTIONS(1979),
    [anon_sym_internal] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_partial] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_readonly] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_sealed] = ACTIONS(1979),
    [anon_sym_unsafe] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_this] = ACTIONS(1979),
    [anon_sym_base] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_where] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_notnull] = ACTIONS(1979),
    [anon_sym_unmanaged] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_true] = ACTIONS(1979),
    [anon_sym_false] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_CARET] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1977),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_add] = ACTIONS(1979),
    [anon_sym_remove] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_interface] = ACTIONS(1979),
    [anon_sym_delegate] = ACTIONS(1979),
    [anon_sym_record] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [sym_predefined_type] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_checked] = ACTIONS(1979),
    [anon_sym_unchecked] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_foreach] = ACTIONS(1979),
    [anon_sym_goto] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_lock] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_when] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_catch] = ACTIONS(1979),
    [anon_sym_finally] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_stackalloc] = ACTIONS(1979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1977),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1977),
    [anon_sym___makeref] = ACTIONS(1979),
    [anon_sym_from] = ACTIONS(1979),
    [anon_sym_join] = ACTIONS(1979),
    [anon_sym_on] = ACTIONS(1979),
    [anon_sym_equals] = ACTIONS(1979),
    [anon_sym_into] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_orderby] = ACTIONS(1979),
    [anon_sym_ascending] = ACTIONS(1979),
    [anon_sym_descending] = ACTIONS(1979),
    [anon_sym_group] = ACTIONS(1979),
    [anon_sym_by] = ACTIONS(1979),
    [anon_sym_select] = ACTIONS(1979),
    [anon_sym_DOT_DOT] = ACTIONS(1977),
    [anon_sym___reftype] = ACTIONS(1979),
    [anon_sym___refvalue] = ACTIONS(1979),
    [anon_sym_sizeof] = ACTIONS(1979),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_integer_literal] = ACTIONS(1979),
    [sym_null_literal] = ACTIONS(1979),
    [sym_real_literal] = ACTIONS(1977),
    [sym_verbatim_string_literal] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(1979),
    [anon_sym_nameof] = ACTIONS(1979),
    [sym_void_keyword] = ACTIONS(1979),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1552] = {
    [sym__preprocessor_call] = STATE(1552),
    [ts_builtin_sym_end] = ACTIONS(2214),
    [sym__identifier_token] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(2216),
    [anon_sym_alias] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_global] = ACTIONS(2216),
    [anon_sym_using] = ACTIONS(2216),
    [anon_sym_static] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_abstract] = ACTIONS(2216),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_const] = ACTIONS(2216),
    [anon_sym_fixed] = ACTIONS(2216),
    [anon_sym_internal] = ACTIONS(2216),
    [anon_sym_new] = ACTIONS(2216),
    [anon_sym_override] = ACTIONS(2216),
    [anon_sym_partial] = ACTIONS(2216),
    [anon_sym_private] = ACTIONS(2216),
    [anon_sym_protected] = ACTIONS(2216),
    [anon_sym_public] = ACTIONS(2216),
    [anon_sym_readonly] = ACTIONS(2216),
    [anon_sym_ref] = ACTIONS(2216),
    [anon_sym_sealed] = ACTIONS(2216),
    [anon_sym_unsafe] = ACTIONS(2216),
    [anon_sym_virtual] = ACTIONS(2216),
    [anon_sym_volatile] = ACTIONS(2216),
    [anon_sym_this] = ACTIONS(2216),
    [anon_sym_base] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2214),
    [anon_sym_where] = ACTIONS(2216),
    [anon_sym_class] = ACTIONS(2216),
    [anon_sym_struct] = ACTIONS(2216),
    [anon_sym_notnull] = ACTIONS(2216),
    [anon_sym_unmanaged] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_true] = ACTIONS(2216),
    [anon_sym_false] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_CARET] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_get] = ACTIONS(2216),
    [anon_sym_set] = ACTIONS(2216),
    [anon_sym_add] = ACTIONS(2216),
    [anon_sym_remove] = ACTIONS(2216),
    [anon_sym_enum] = ACTIONS(2216),
    [anon_sym_interface] = ACTIONS(2216),
    [anon_sym_delegate] = ACTIONS(2216),
    [anon_sym_record] = ACTIONS(2216),
    [anon_sym_namespace] = ACTIONS(2216),
    [anon_sym_var] = ACTIONS(2216),
    [sym_predefined_type] = ACTIONS(2216),
    [anon_sym_break] = ACTIONS(2216),
    [anon_sym_checked] = ACTIONS(2216),
    [anon_sym_unchecked] = ACTIONS(2216),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_do] = ACTIONS(2216),
    [anon_sym_while] = ACTIONS(2216),
    [anon_sym_for] = ACTIONS(2216),
    [anon_sym_await] = ACTIONS(2216),
    [anon_sym_foreach] = ACTIONS(2216),
    [anon_sym_goto] = ACTIONS(2216),
    [anon_sym_default] = ACTIONS(2216),
    [anon_sym_if] = ACTIONS(2216),
    [anon_sym_else] = ACTIONS(2216),
    [anon_sym_lock] = ACTIONS(2216),
    [anon_sym_switch] = ACTIONS(2216),
    [anon_sym_when] = ACTIONS(2216),
    [anon_sym_throw] = ACTIONS(2216),
    [anon_sym_try] = ACTIONS(2216),
    [anon_sym_catch] = ACTIONS(2216),
    [anon_sym_finally] = ACTIONS(2216),
    [anon_sym_yield] = ACTIONS(2216),
    [anon_sym_stackalloc] = ACTIONS(2216),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2214),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2214),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2214),
    [anon_sym___makeref] = ACTIONS(2216),
    [anon_sym_from] = ACTIONS(2216),
    [anon_sym_join] = ACTIONS(2216),
    [anon_sym_on] = ACTIONS(2216),
    [anon_sym_equals] = ACTIONS(2216),
    [anon_sym_into] = ACTIONS(2216),
    [anon_sym_let] = ACTIONS(2216),
    [anon_sym_orderby] = ACTIONS(2216),
    [anon_sym_ascending] = ACTIONS(2216),
    [anon_sym_descending] = ACTIONS(2216),
    [anon_sym_group] = ACTIONS(2216),
    [anon_sym_by] = ACTIONS(2216),
    [anon_sym_select] = ACTIONS(2216),
    [anon_sym_DOT_DOT] = ACTIONS(2214),
    [anon_sym___reftype] = ACTIONS(2216),
    [anon_sym___refvalue] = ACTIONS(2216),
    [anon_sym_sizeof] = ACTIONS(2216),
    [anon_sym_typeof] = ACTIONS(2216),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [sym_integer_literal] = ACTIONS(2216),
    [sym_null_literal] = ACTIONS(2216),
    [sym_real_literal] = ACTIONS(2214),
    [sym_verbatim_string_literal] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2216),
    [anon_sym_nameof] = ACTIONS(2216),
    [sym_void_keyword] = ACTIONS(2216),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1553] = {
    [sym__preprocessor_call] = STATE(1553),
    [ts_builtin_sym_end] = ACTIONS(2218),
    [sym__identifier_token] = ACTIONS(2220),
    [anon_sym_extern] = ACTIONS(2220),
    [anon_sym_alias] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_global] = ACTIONS(2220),
    [anon_sym_using] = ACTIONS(2220),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_return] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_abstract] = ACTIONS(2220),
    [anon_sym_async] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_fixed] = ACTIONS(2220),
    [anon_sym_internal] = ACTIONS(2220),
    [anon_sym_new] = ACTIONS(2220),
    [anon_sym_override] = ACTIONS(2220),
    [anon_sym_partial] = ACTIONS(2220),
    [anon_sym_private] = ACTIONS(2220),
    [anon_sym_protected] = ACTIONS(2220),
    [anon_sym_public] = ACTIONS(2220),
    [anon_sym_readonly] = ACTIONS(2220),
    [anon_sym_ref] = ACTIONS(2220),
    [anon_sym_sealed] = ACTIONS(2220),
    [anon_sym_unsafe] = ACTIONS(2220),
    [anon_sym_virtual] = ACTIONS(2220),
    [anon_sym_volatile] = ACTIONS(2220),
    [anon_sym_this] = ACTIONS(2220),
    [anon_sym_base] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_where] = ACTIONS(2220),
    [anon_sym_class] = ACTIONS(2220),
    [anon_sym_struct] = ACTIONS(2220),
    [anon_sym_notnull] = ACTIONS(2220),
    [anon_sym_unmanaged] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_PLUS_PLUS] = ACTIONS(2218),
    [anon_sym_DASH_DASH] = ACTIONS(2218),
    [anon_sym_true] = ACTIONS(2220),
    [anon_sym_false] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2218),
    [anon_sym_CARET] = ACTIONS(2218),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_get] = ACTIONS(2220),
    [anon_sym_set] = ACTIONS(2220),
    [anon_sym_add] = ACTIONS(2220),
    [anon_sym_remove] = ACTIONS(2220),
    [anon_sym_enum] = ACTIONS(2220),
    [anon_sym_interface] = ACTIONS(2220),
    [anon_sym_delegate] = ACTIONS(2220),
    [anon_sym_record] = ACTIONS(2220),
    [anon_sym_namespace] = ACTIONS(2220),
    [anon_sym_var] = ACTIONS(2220),
    [sym_predefined_type] = ACTIONS(2220),
    [anon_sym_break] = ACTIONS(2220),
    [anon_sym_checked] = ACTIONS(2220),
    [anon_sym_unchecked] = ACTIONS(2220),
    [anon_sym_continue] = ACTIONS(2220),
    [anon_sym_do] = ACTIONS(2220),
    [anon_sym_while] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2220),
    [anon_sym_await] = ACTIONS(2220),
    [anon_sym_foreach] = ACTIONS(2220),
    [anon_sym_goto] = ACTIONS(2220),
    [anon_sym_default] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_else] = ACTIONS(2220),
    [anon_sym_lock] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2220),
    [anon_sym_when] = ACTIONS(2220),
    [anon_sym_throw] = ACTIONS(2220),
    [anon_sym_try] = ACTIONS(2220),
    [anon_sym_catch] = ACTIONS(2220),
    [anon_sym_finally] = ACTIONS(2220),
    [anon_sym_yield] = ACTIONS(2220),
    [anon_sym_stackalloc] = ACTIONS(2220),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2218),
    [anon_sym_DQUOTE] = ACTIONS(2218),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2218),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2218),
    [anon_sym___makeref] = ACTIONS(2220),
    [anon_sym_from] = ACTIONS(2220),
    [anon_sym_join] = ACTIONS(2220),
    [anon_sym_on] = ACTIONS(2220),
    [anon_sym_equals] = ACTIONS(2220),
    [anon_sym_into] = ACTIONS(2220),
    [anon_sym_let] = ACTIONS(2220),
    [anon_sym_orderby] = ACTIONS(2220),
    [anon_sym_ascending] = ACTIONS(2220),
    [anon_sym_descending] = ACTIONS(2220),
    [anon_sym_group] = ACTIONS(2220),
    [anon_sym_by] = ACTIONS(2220),
    [anon_sym_select] = ACTIONS(2220),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym___reftype] = ACTIONS(2220),
    [anon_sym___refvalue] = ACTIONS(2220),
    [anon_sym_sizeof] = ACTIONS(2220),
    [anon_sym_typeof] = ACTIONS(2220),
    [anon_sym_SQUOTE] = ACTIONS(2218),
    [sym_integer_literal] = ACTIONS(2220),
    [sym_null_literal] = ACTIONS(2220),
    [sym_real_literal] = ACTIONS(2218),
    [sym_verbatim_string_literal] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2220),
    [anon_sym_nameof] = ACTIONS(2220),
    [sym_void_keyword] = ACTIONS(2220),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1554] = {
    [sym__preprocessor_call] = STATE(1554),
    [ts_builtin_sym_end] = ACTIONS(2222),
    [sym__identifier_token] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym_alias] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_global] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_abstract] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_fixed] = ACTIONS(2224),
    [anon_sym_internal] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [anon_sym_partial] = ACTIONS(2224),
    [anon_sym_private] = ACTIONS(2224),
    [anon_sym_protected] = ACTIONS(2224),
    [anon_sym_public] = ACTIONS(2224),
    [anon_sym_readonly] = ACTIONS(2224),
    [anon_sym_ref] = ACTIONS(2224),
    [anon_sym_sealed] = ACTIONS(2224),
    [anon_sym_unsafe] = ACTIONS(2224),
    [anon_sym_virtual] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_this] = ACTIONS(2224),
    [anon_sym_base] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [anon_sym_where] = ACTIONS(2224),
    [anon_sym_class] = ACTIONS(2224),
    [anon_sym_struct] = ACTIONS(2224),
    [anon_sym_notnull] = ACTIONS(2224),
    [anon_sym_unmanaged] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_PLUS_PLUS] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2222),
    [anon_sym_true] = ACTIONS(2224),
    [anon_sym_false] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_add] = ACTIONS(2224),
    [anon_sym_remove] = ACTIONS(2224),
    [anon_sym_enum] = ACTIONS(2224),
    [anon_sym_interface] = ACTIONS(2224),
    [anon_sym_delegate] = ACTIONS(2224),
    [anon_sym_record] = ACTIONS(2224),
    [anon_sym_namespace] = ACTIONS(2224),
    [anon_sym_var] = ACTIONS(2224),
    [sym_predefined_type] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_checked] = ACTIONS(2224),
    [anon_sym_unchecked] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_await] = ACTIONS(2224),
    [anon_sym_foreach] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_lock] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_when] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_catch] = ACTIONS(2224),
    [anon_sym_finally] = ACTIONS(2224),
    [anon_sym_yield] = ACTIONS(2224),
    [anon_sym_stackalloc] = ACTIONS(2224),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2222),
    [anon_sym_DQUOTE] = ACTIONS(2222),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2222),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2222),
    [anon_sym___makeref] = ACTIONS(2224),
    [anon_sym_from] = ACTIONS(2224),
    [anon_sym_join] = ACTIONS(2224),
    [anon_sym_on] = ACTIONS(2224),
    [anon_sym_equals] = ACTIONS(2224),
    [anon_sym_into] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_orderby] = ACTIONS(2224),
    [anon_sym_ascending] = ACTIONS(2224),
    [anon_sym_descending] = ACTIONS(2224),
    [anon_sym_group] = ACTIONS(2224),
    [anon_sym_by] = ACTIONS(2224),
    [anon_sym_select] = ACTIONS(2224),
    [anon_sym_DOT_DOT] = ACTIONS(2222),
    [anon_sym___reftype] = ACTIONS(2224),
    [anon_sym___refvalue] = ACTIONS(2224),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym_typeof] = ACTIONS(2224),
    [anon_sym_SQUOTE] = ACTIONS(2222),
    [sym_integer_literal] = ACTIONS(2224),
    [sym_null_literal] = ACTIONS(2224),
    [sym_real_literal] = ACTIONS(2222),
    [sym_verbatim_string_literal] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2224),
    [anon_sym_nameof] = ACTIONS(2224),
    [sym_void_keyword] = ACTIONS(2224),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1555] = {
    [sym_extern_alias_directive] = STATE(1637),
    [sym__preprocessor_call] = STATE(1555),
    [aux_sym_compilation_unit_repeat1] = STATE(1555),
    [ts_builtin_sym_end] = ACTIONS(2226),
    [sym__identifier_token] = ACTIONS(2228),
    [anon_sym_extern] = ACTIONS(2230),
    [anon_sym_alias] = ACTIONS(2228),
    [anon_sym_SEMI] = ACTIONS(2226),
    [anon_sym_global] = ACTIONS(2228),
    [anon_sym_using] = ACTIONS(2228),
    [anon_sym_static] = ACTIONS(2228),
    [anon_sym_LBRACK] = ACTIONS(2226),
    [anon_sym_return] = ACTIONS(2228),
    [anon_sym_LPAREN] = ACTIONS(2226),
    [anon_sym_abstract] = ACTIONS(2228),
    [anon_sym_async] = ACTIONS(2228),
    [anon_sym_const] = ACTIONS(2228),
    [anon_sym_fixed] = ACTIONS(2228),
    [anon_sym_internal] = ACTIONS(2228),
    [anon_sym_new] = ACTIONS(2228),
    [anon_sym_override] = ACTIONS(2228),
    [anon_sym_partial] = ACTIONS(2228),
    [anon_sym_private] = ACTIONS(2228),
    [anon_sym_protected] = ACTIONS(2228),
    [anon_sym_public] = ACTIONS(2228),
    [anon_sym_readonly] = ACTIONS(2228),
    [anon_sym_ref] = ACTIONS(2228),
    [anon_sym_sealed] = ACTIONS(2228),
    [anon_sym_unsafe] = ACTIONS(2228),
    [anon_sym_virtual] = ACTIONS(2228),
    [anon_sym_volatile] = ACTIONS(2228),
    [anon_sym_this] = ACTIONS(2228),
    [anon_sym_base] = ACTIONS(2228),
    [anon_sym_LBRACE] = ACTIONS(2226),
    [anon_sym_TILDE] = ACTIONS(2226),
    [anon_sym_where] = ACTIONS(2228),
    [anon_sym_class] = ACTIONS(2228),
    [anon_sym_struct] = ACTIONS(2228),
    [anon_sym_notnull] = ACTIONS(2228),
    [anon_sym_unmanaged] = ACTIONS(2228),
    [anon_sym_BANG] = ACTIONS(2226),
    [anon_sym_PLUS_PLUS] = ACTIONS(2226),
    [anon_sym_DASH_DASH] = ACTIONS(2226),
    [anon_sym_true] = ACTIONS(2228),
    [anon_sym_false] = ACTIONS(2228),
    [anon_sym_PLUS] = ACTIONS(2228),
    [anon_sym_DASH] = ACTIONS(2228),
    [anon_sym_STAR] = ACTIONS(2226),
    [anon_sym_CARET] = ACTIONS(2226),
    [anon_sym_AMP] = ACTIONS(2226),
    [anon_sym_get] = ACTIONS(2228),
    [anon_sym_set] = ACTIONS(2228),
    [anon_sym_add] = ACTIONS(2228),
    [anon_sym_remove] = ACTIONS(2228),
    [anon_sym_enum] = ACTIONS(2228),
    [anon_sym_interface] = ACTIONS(2228),
    [anon_sym_delegate] = ACTIONS(2228),
    [anon_sym_record] = ACTIONS(2228),
    [anon_sym_namespace] = ACTIONS(2228),
    [anon_sym_var] = ACTIONS(2228),
    [sym_predefined_type] = ACTIONS(2228),
    [anon_sym_break] = ACTIONS(2228),
    [anon_sym_checked] = ACTIONS(2228),
    [anon_sym_unchecked] = ACTIONS(2228),
    [anon_sym_continue] = ACTIONS(2228),
    [anon_sym_do] = ACTIONS(2228),
    [anon_sym_while] = ACTIONS(2228),
    [anon_sym_for] = ACTIONS(2228),
    [anon_sym_await] = ACTIONS(2228),
    [anon_sym_foreach] = ACTIONS(2228),
    [anon_sym_goto] = ACTIONS(2228),
    [anon_sym_default] = ACTIONS(2228),
    [anon_sym_if] = ACTIONS(2228),
    [anon_sym_lock] = ACTIONS(2228),
    [anon_sym_switch] = ACTIONS(2228),
    [anon_sym_when] = ACTIONS(2228),
    [anon_sym_throw] = ACTIONS(2228),
    [anon_sym_try] = ACTIONS(2228),
    [anon_sym_yield] = ACTIONS(2228),
    [anon_sym_stackalloc] = ACTIONS(2228),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2226),
    [anon_sym_DQUOTE] = ACTIONS(2226),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2226),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2226),
    [anon_sym___makeref] = ACTIONS(2228),
    [anon_sym_from] = ACTIONS(2228),
    [anon_sym_join] = ACTIONS(2228),
    [anon_sym_on] = ACTIONS(2228),
    [anon_sym_equals] = ACTIONS(2228),
    [anon_sym_into] = ACTIONS(2228),
    [anon_sym_let] = ACTIONS(2228),
    [anon_sym_orderby] = ACTIONS(2228),
    [anon_sym_ascending] = ACTIONS(2228),
    [anon_sym_descending] = ACTIONS(2228),
    [anon_sym_group] = ACTIONS(2228),
    [anon_sym_by] = ACTIONS(2228),
    [anon_sym_select] = ACTIONS(2228),
    [anon_sym_DOT_DOT] = ACTIONS(2226),
    [anon_sym___reftype] = ACTIONS(2228),
    [anon_sym___refvalue] = ACTIONS(2228),
    [anon_sym_sizeof] = ACTIONS(2228),
    [anon_sym_typeof] = ACTIONS(2228),
    [anon_sym_SQUOTE] = ACTIONS(2226),
    [sym_integer_literal] = ACTIONS(2228),
    [sym_null_literal] = ACTIONS(2228),
    [sym_real_literal] = ACTIONS(2226),
    [sym_verbatim_string_literal] = ACTIONS(2226),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2228),
    [anon_sym_nameof] = ACTIONS(2228),
    [sym_void_keyword] = ACTIONS(2228),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1556] = {
    [sym_using_directive] = STATE(1635),
    [sym__preprocessor_call] = STATE(1556),
    [aux_sym_compilation_unit_repeat2] = STATE(1556),
    [ts_builtin_sym_end] = ACTIONS(2233),
    [sym__identifier_token] = ACTIONS(2235),
    [anon_sym_extern] = ACTIONS(2235),
    [anon_sym_alias] = ACTIONS(2235),
    [anon_sym_SEMI] = ACTIONS(2233),
    [anon_sym_global] = ACTIONS(2237),
    [anon_sym_using] = ACTIONS(2240),
    [anon_sym_static] = ACTIONS(2235),
    [anon_sym_LBRACK] = ACTIONS(2233),
    [anon_sym_return] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(2233),
    [anon_sym_abstract] = ACTIONS(2235),
    [anon_sym_async] = ACTIONS(2235),
    [anon_sym_const] = ACTIONS(2235),
    [anon_sym_fixed] = ACTIONS(2235),
    [anon_sym_internal] = ACTIONS(2235),
    [anon_sym_new] = ACTIONS(2235),
    [anon_sym_override] = ACTIONS(2235),
    [anon_sym_partial] = ACTIONS(2235),
    [anon_sym_private] = ACTIONS(2235),
    [anon_sym_protected] = ACTIONS(2235),
    [anon_sym_public] = ACTIONS(2235),
    [anon_sym_readonly] = ACTIONS(2235),
    [anon_sym_ref] = ACTIONS(2235),
    [anon_sym_sealed] = ACTIONS(2235),
    [anon_sym_unsafe] = ACTIONS(2235),
    [anon_sym_virtual] = ACTIONS(2235),
    [anon_sym_volatile] = ACTIONS(2235),
    [anon_sym_this] = ACTIONS(2235),
    [anon_sym_base] = ACTIONS(2235),
    [anon_sym_LBRACE] = ACTIONS(2233),
    [anon_sym_TILDE] = ACTIONS(2233),
    [anon_sym_where] = ACTIONS(2235),
    [anon_sym_class] = ACTIONS(2235),
    [anon_sym_struct] = ACTIONS(2235),
    [anon_sym_notnull] = ACTIONS(2235),
    [anon_sym_unmanaged] = ACTIONS(2235),
    [anon_sym_BANG] = ACTIONS(2233),
    [anon_sym_PLUS_PLUS] = ACTIONS(2233),
    [anon_sym_DASH_DASH] = ACTIONS(2233),
    [anon_sym_true] = ACTIONS(2235),
    [anon_sym_false] = ACTIONS(2235),
    [anon_sym_PLUS] = ACTIONS(2235),
    [anon_sym_DASH] = ACTIONS(2235),
    [anon_sym_STAR] = ACTIONS(2233),
    [anon_sym_CARET] = ACTIONS(2233),
    [anon_sym_AMP] = ACTIONS(2233),
    [anon_sym_get] = ACTIONS(2235),
    [anon_sym_set] = ACTIONS(2235),
    [anon_sym_add] = ACTIONS(2235),
    [anon_sym_remove] = ACTIONS(2235),
    [anon_sym_enum] = ACTIONS(2235),
    [anon_sym_interface] = ACTIONS(2235),
    [anon_sym_delegate] = ACTIONS(2235),
    [anon_sym_record] = ACTIONS(2235),
    [anon_sym_namespace] = ACTIONS(2235),
    [anon_sym_var] = ACTIONS(2235),
    [sym_predefined_type] = ACTIONS(2235),
    [anon_sym_break] = ACTIONS(2235),
    [anon_sym_checked] = ACTIONS(2235),
    [anon_sym_unchecked] = ACTIONS(2235),
    [anon_sym_continue] = ACTIONS(2235),
    [anon_sym_do] = ACTIONS(2235),
    [anon_sym_while] = ACTIONS(2235),
    [anon_sym_for] = ACTIONS(2235),
    [anon_sym_await] = ACTIONS(2235),
    [anon_sym_foreach] = ACTIONS(2235),
    [anon_sym_goto] = ACTIONS(2235),
    [anon_sym_default] = ACTIONS(2235),
    [anon_sym_if] = ACTIONS(2235),
    [anon_sym_lock] = ACTIONS(2235),
    [anon_sym_switch] = ACTIONS(2235),
    [anon_sym_when] = ACTIONS(2235),
    [anon_sym_throw] = ACTIONS(2235),
    [anon_sym_try] = ACTIONS(2235),
    [anon_sym_yield] = ACTIONS(2235),
    [anon_sym_stackalloc] = ACTIONS(2235),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2233),
    [anon_sym_DQUOTE] = ACTIONS(2233),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2233),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2233),
    [anon_sym___makeref] = ACTIONS(2235),
    [anon_sym_from] = ACTIONS(2235),
    [anon_sym_join] = ACTIONS(2235),
    [anon_sym_on] = ACTIONS(2235),
    [anon_sym_equals] = ACTIONS(2235),
    [anon_sym_into] = ACTIONS(2235),
    [anon_sym_let] = ACTIONS(2235),
    [anon_sym_orderby] = ACTIONS(2235),
    [anon_sym_ascending] = ACTIONS(2235),
    [anon_sym_descending] = ACTIONS(2235),
    [anon_sym_group] = ACTIONS(2235),
    [anon_sym_by] = ACTIONS(2235),
    [anon_sym_select] = ACTIONS(2235),
    [anon_sym_DOT_DOT] = ACTIONS(2233),
    [anon_sym___reftype] = ACTIONS(2235),
    [anon_sym___refvalue] = ACTIONS(2235),
    [anon_sym_sizeof] = ACTIONS(2235),
    [anon_sym_typeof] = ACTIONS(2235),
    [anon_sym_SQUOTE] = ACTIONS(2233),
    [sym_integer_literal] = ACTIONS(2235),
    [sym_null_literal] = ACTIONS(2235),
    [sym_real_literal] = ACTIONS(2233),
    [sym_verbatim_string_literal] = ACTIONS(2233),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2235),
    [anon_sym_nameof] = ACTIONS(2235),
    [sym_void_keyword] = ACTIONS(2235),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1557] = {
    [sym_global_attribute_list] = STATE(1641),
    [sym__preprocessor_call] = STATE(1557),
    [aux_sym_compilation_unit_repeat3] = STATE(1557),
    [ts_builtin_sym_end] = ACTIONS(2243),
    [sym__identifier_token] = ACTIONS(2245),
    [anon_sym_extern] = ACTIONS(2245),
    [anon_sym_alias] = ACTIONS(2245),
    [anon_sym_SEMI] = ACTIONS(2243),
    [anon_sym_global] = ACTIONS(2245),
    [anon_sym_using] = ACTIONS(2245),
    [anon_sym_static] = ACTIONS(2245),
    [anon_sym_LBRACK] = ACTIONS(2247),
    [anon_sym_return] = ACTIONS(2245),
    [anon_sym_LPAREN] = ACTIONS(2243),
    [anon_sym_abstract] = ACTIONS(2245),
    [anon_sym_async] = ACTIONS(2245),
    [anon_sym_const] = ACTIONS(2245),
    [anon_sym_fixed] = ACTIONS(2245),
    [anon_sym_internal] = ACTIONS(2245),
    [anon_sym_new] = ACTIONS(2245),
    [anon_sym_override] = ACTIONS(2245),
    [anon_sym_partial] = ACTIONS(2245),
    [anon_sym_private] = ACTIONS(2245),
    [anon_sym_protected] = ACTIONS(2245),
    [anon_sym_public] = ACTIONS(2245),
    [anon_sym_readonly] = ACTIONS(2245),
    [anon_sym_ref] = ACTIONS(2245),
    [anon_sym_sealed] = ACTIONS(2245),
    [anon_sym_unsafe] = ACTIONS(2245),
    [anon_sym_virtual] = ACTIONS(2245),
    [anon_sym_volatile] = ACTIONS(2245),
    [anon_sym_this] = ACTIONS(2245),
    [anon_sym_base] = ACTIONS(2245),
    [anon_sym_LBRACE] = ACTIONS(2243),
    [anon_sym_TILDE] = ACTIONS(2243),
    [anon_sym_where] = ACTIONS(2245),
    [anon_sym_class] = ACTIONS(2245),
    [anon_sym_struct] = ACTIONS(2245),
    [anon_sym_notnull] = ACTIONS(2245),
    [anon_sym_unmanaged] = ACTIONS(2245),
    [anon_sym_BANG] = ACTIONS(2243),
    [anon_sym_PLUS_PLUS] = ACTIONS(2243),
    [anon_sym_DASH_DASH] = ACTIONS(2243),
    [anon_sym_true] = ACTIONS(2245),
    [anon_sym_false] = ACTIONS(2245),
    [anon_sym_PLUS] = ACTIONS(2245),
    [anon_sym_DASH] = ACTIONS(2245),
    [anon_sym_STAR] = ACTIONS(2243),
    [anon_sym_CARET] = ACTIONS(2243),
    [anon_sym_AMP] = ACTIONS(2243),
    [anon_sym_get] = ACTIONS(2245),
    [anon_sym_set] = ACTIONS(2245),
    [anon_sym_add] = ACTIONS(2245),
    [anon_sym_remove] = ACTIONS(2245),
    [anon_sym_enum] = ACTIONS(2245),
    [anon_sym_interface] = ACTIONS(2245),
    [anon_sym_delegate] = ACTIONS(2245),
    [anon_sym_record] = ACTIONS(2245),
    [anon_sym_namespace] = ACTIONS(2245),
    [anon_sym_var] = ACTIONS(2245),
    [sym_predefined_type] = ACTIONS(2245),
    [anon_sym_break] = ACTIONS(2245),
    [anon_sym_checked] = ACTIONS(2245),
    [anon_sym_unchecked] = ACTIONS(2245),
    [anon_sym_continue] = ACTIONS(2245),
    [anon_sym_do] = ACTIONS(2245),
    [anon_sym_while] = ACTIONS(2245),
    [anon_sym_for] = ACTIONS(2245),
    [anon_sym_await] = ACTIONS(2245),
    [anon_sym_foreach] = ACTIONS(2245),
    [anon_sym_goto] = ACTIONS(2245),
    [anon_sym_default] = ACTIONS(2245),
    [anon_sym_if] = ACTIONS(2245),
    [anon_sym_lock] = ACTIONS(2245),
    [anon_sym_switch] = ACTIONS(2245),
    [anon_sym_when] = ACTIONS(2245),
    [anon_sym_throw] = ACTIONS(2245),
    [anon_sym_try] = ACTIONS(2245),
    [anon_sym_yield] = ACTIONS(2245),
    [anon_sym_stackalloc] = ACTIONS(2245),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2243),
    [anon_sym_DQUOTE] = ACTIONS(2243),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2243),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2243),
    [anon_sym___makeref] = ACTIONS(2245),
    [anon_sym_from] = ACTIONS(2245),
    [anon_sym_join] = ACTIONS(2245),
    [anon_sym_on] = ACTIONS(2245),
    [anon_sym_equals] = ACTIONS(2245),
    [anon_sym_into] = ACTIONS(2245),
    [anon_sym_let] = ACTIONS(2245),
    [anon_sym_orderby] = ACTIONS(2245),
    [anon_sym_ascending] = ACTIONS(2245),
    [anon_sym_descending] = ACTIONS(2245),
    [anon_sym_group] = ACTIONS(2245),
    [anon_sym_by] = ACTIONS(2245),
    [anon_sym_select] = ACTIONS(2245),
    [anon_sym_DOT_DOT] = ACTIONS(2243),
    [anon_sym___reftype] = ACTIONS(2245),
    [anon_sym___refvalue] = ACTIONS(2245),
    [anon_sym_sizeof] = ACTIONS(2245),
    [anon_sym_typeof] = ACTIONS(2245),
    [anon_sym_SQUOTE] = ACTIONS(2243),
    [sym_integer_literal] = ACTIONS(2245),
    [sym_null_literal] = ACTIONS(2245),
    [sym_real_literal] = ACTIONS(2243),
    [sym_verbatim_string_literal] = ACTIONS(2243),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2245),
    [anon_sym_nameof] = ACTIONS(2245),
    [sym_void_keyword] = ACTIONS(2245),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1558] = {
    [sym__preprocessor_call] = STATE(1558),
    [ts_builtin_sym_end] = ACTIONS(2250),
    [sym__identifier_token] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym_alias] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_global] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2252),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_fixed] = ACTIONS(2252),
    [anon_sym_internal] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [anon_sym_partial] = ACTIONS(2252),
    [anon_sym_private] = ACTIONS(2252),
    [anon_sym_protected] = ACTIONS(2252),
    [anon_sym_public] = ACTIONS(2252),
    [anon_sym_readonly] = ACTIONS(2252),
    [anon_sym_ref] = ACTIONS(2252),
    [anon_sym_sealed] = ACTIONS(2252),
    [anon_sym_unsafe] = ACTIONS(2252),
    [anon_sym_virtual] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_this] = ACTIONS(2252),
    [anon_sym_base] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_where] = ACTIONS(2252),
    [anon_sym_class] = ACTIONS(2252),
    [anon_sym_struct] = ACTIONS(2252),
    [anon_sym_notnull] = ACTIONS(2252),
    [anon_sym_unmanaged] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_true] = ACTIONS(2252),
    [anon_sym_false] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_get] = ACTIONS(2252),
    [anon_sym_set] = ACTIONS(2252),
    [anon_sym_add] = ACTIONS(2252),
    [anon_sym_remove] = ACTIONS(2252),
    [anon_sym_enum] = ACTIONS(2252),
    [anon_sym_interface] = ACTIONS(2252),
    [anon_sym_delegate] = ACTIONS(2252),
    [anon_sym_record] = ACTIONS(2252),
    [anon_sym_namespace] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2252),
    [sym_predefined_type] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_checked] = ACTIONS(2252),
    [anon_sym_unchecked] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_await] = ACTIONS(2252),
    [anon_sym_foreach] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_lock] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_when] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_stackalloc] = ACTIONS(2252),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym___makeref] = ACTIONS(2252),
    [anon_sym_from] = ACTIONS(2252),
    [anon_sym_join] = ACTIONS(2252),
    [anon_sym_on] = ACTIONS(2252),
    [anon_sym_equals] = ACTIONS(2252),
    [anon_sym_into] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_orderby] = ACTIONS(2252),
    [anon_sym_ascending] = ACTIONS(2252),
    [anon_sym_descending] = ACTIONS(2252),
    [anon_sym_group] = ACTIONS(2252),
    [anon_sym_by] = ACTIONS(2252),
    [anon_sym_select] = ACTIONS(2252),
    [anon_sym_DOT_DOT] = ACTIONS(2250),
    [anon_sym___reftype] = ACTIONS(2252),
    [anon_sym___refvalue] = ACTIONS(2252),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym_typeof] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [sym_integer_literal] = ACTIONS(2252),
    [sym_null_literal] = ACTIONS(2252),
    [sym_real_literal] = ACTIONS(2250),
    [sym_verbatim_string_literal] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2252),
    [anon_sym_nameof] = ACTIONS(2252),
    [sym_void_keyword] = ACTIONS(2252),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1559] = {
    [sym__preprocessor_call] = STATE(1559),
    [ts_builtin_sym_end] = ACTIONS(2254),
    [sym__identifier_token] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym_alias] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_global] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_abstract] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_fixed] = ACTIONS(2256),
    [anon_sym_internal] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [anon_sym_partial] = ACTIONS(2256),
    [anon_sym_private] = ACTIONS(2256),
    [anon_sym_protected] = ACTIONS(2256),
    [anon_sym_public] = ACTIONS(2256),
    [anon_sym_readonly] = ACTIONS(2256),
    [anon_sym_ref] = ACTIONS(2256),
    [anon_sym_sealed] = ACTIONS(2256),
    [anon_sym_unsafe] = ACTIONS(2256),
    [anon_sym_virtual] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_this] = ACTIONS(2256),
    [anon_sym_base] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_where] = ACTIONS(2256),
    [anon_sym_class] = ACTIONS(2256),
    [anon_sym_struct] = ACTIONS(2256),
    [anon_sym_notnull] = ACTIONS(2256),
    [anon_sym_unmanaged] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_true] = ACTIONS(2256),
    [anon_sym_false] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_get] = ACTIONS(2256),
    [anon_sym_set] = ACTIONS(2256),
    [anon_sym_add] = ACTIONS(2256),
    [anon_sym_remove] = ACTIONS(2256),
    [anon_sym_enum] = ACTIONS(2256),
    [anon_sym_interface] = ACTIONS(2256),
    [anon_sym_delegate] = ACTIONS(2256),
    [anon_sym_record] = ACTIONS(2256),
    [anon_sym_namespace] = ACTIONS(2256),
    [anon_sym_var] = ACTIONS(2256),
    [sym_predefined_type] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_checked] = ACTIONS(2256),
    [anon_sym_unchecked] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_await] = ACTIONS(2256),
    [anon_sym_foreach] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_lock] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_when] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_stackalloc] = ACTIONS(2256),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2254),
    [anon_sym___makeref] = ACTIONS(2256),
    [anon_sym_from] = ACTIONS(2256),
    [anon_sym_join] = ACTIONS(2256),
    [anon_sym_on] = ACTIONS(2256),
    [anon_sym_equals] = ACTIONS(2256),
    [anon_sym_into] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_orderby] = ACTIONS(2256),
    [anon_sym_ascending] = ACTIONS(2256),
    [anon_sym_descending] = ACTIONS(2256),
    [anon_sym_group] = ACTIONS(2256),
    [anon_sym_by] = ACTIONS(2256),
    [anon_sym_select] = ACTIONS(2256),
    [anon_sym_DOT_DOT] = ACTIONS(2254),
    [anon_sym___reftype] = ACTIONS(2256),
    [anon_sym___refvalue] = ACTIONS(2256),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym_typeof] = ACTIONS(2256),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [sym_integer_literal] = ACTIONS(2256),
    [sym_null_literal] = ACTIONS(2256),
    [sym_real_literal] = ACTIONS(2254),
    [sym_verbatim_string_literal] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2256),
    [anon_sym_nameof] = ACTIONS(2256),
    [sym_void_keyword] = ACTIONS(2256),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1560] = {
    [sym__preprocessor_call] = STATE(1560),
    [ts_builtin_sym_end] = ACTIONS(2258),
    [sym__identifier_token] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym_alias] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_global] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2258),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_fixed] = ACTIONS(2260),
    [anon_sym_internal] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_partial] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_ref] = ACTIONS(2260),
    [anon_sym_sealed] = ACTIONS(2260),
    [anon_sym_unsafe] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_this] = ACTIONS(2260),
    [anon_sym_base] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_where] = ACTIONS(2260),
    [anon_sym_class] = ACTIONS(2260),
    [anon_sym_struct] = ACTIONS(2260),
    [anon_sym_notnull] = ACTIONS(2260),
    [anon_sym_unmanaged] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_true] = ACTIONS(2260),
    [anon_sym_false] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_CARET] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2258),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_add] = ACTIONS(2260),
    [anon_sym_remove] = ACTIONS(2260),
    [anon_sym_enum] = ACTIONS(2260),
    [anon_sym_interface] = ACTIONS(2260),
    [anon_sym_delegate] = ACTIONS(2260),
    [anon_sym_record] = ACTIONS(2260),
    [anon_sym_namespace] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [sym_predefined_type] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_checked] = ACTIONS(2260),
    [anon_sym_unchecked] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_foreach] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_lock] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_when] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_stackalloc] = ACTIONS(2260),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2258),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2258),
    [anon_sym___makeref] = ACTIONS(2260),
    [anon_sym_from] = ACTIONS(2260),
    [anon_sym_join] = ACTIONS(2260),
    [anon_sym_on] = ACTIONS(2260),
    [anon_sym_equals] = ACTIONS(2260),
    [anon_sym_into] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_orderby] = ACTIONS(2260),
    [anon_sym_ascending] = ACTIONS(2260),
    [anon_sym_descending] = ACTIONS(2260),
    [anon_sym_group] = ACTIONS(2260),
    [anon_sym_by] = ACTIONS(2260),
    [anon_sym_select] = ACTIONS(2260),
    [anon_sym_DOT_DOT] = ACTIONS(2258),
    [anon_sym___reftype] = ACTIONS(2260),
    [anon_sym___refvalue] = ACTIONS(2260),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [sym_integer_literal] = ACTIONS(2260),
    [sym_null_literal] = ACTIONS(2260),
    [sym_real_literal] = ACTIONS(2258),
    [sym_verbatim_string_literal] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2260),
    [anon_sym_nameof] = ACTIONS(2260),
    [sym_void_keyword] = ACTIONS(2260),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1561] = {
    [sym__preprocessor_call] = STATE(1561),
    [ts_builtin_sym_end] = ACTIONS(2262),
    [sym__identifier_token] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym_alias] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_global] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_fixed] = ACTIONS(2264),
    [anon_sym_internal] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_partial] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_ref] = ACTIONS(2264),
    [anon_sym_sealed] = ACTIONS(2264),
    [anon_sym_unsafe] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_this] = ACTIONS(2264),
    [anon_sym_base] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_where] = ACTIONS(2264),
    [anon_sym_class] = ACTIONS(2264),
    [anon_sym_struct] = ACTIONS(2264),
    [anon_sym_notnull] = ACTIONS(2264),
    [anon_sym_unmanaged] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_true] = ACTIONS(2264),
    [anon_sym_false] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_CARET] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_add] = ACTIONS(2264),
    [anon_sym_remove] = ACTIONS(2264),
    [anon_sym_enum] = ACTIONS(2264),
    [anon_sym_interface] = ACTIONS(2264),
    [anon_sym_delegate] = ACTIONS(2264),
    [anon_sym_record] = ACTIONS(2264),
    [anon_sym_namespace] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [sym_predefined_type] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_checked] = ACTIONS(2264),
    [anon_sym_unchecked] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_foreach] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_lock] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_when] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_stackalloc] = ACTIONS(2264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2262),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2262),
    [anon_sym___makeref] = ACTIONS(2264),
    [anon_sym_from] = ACTIONS(2264),
    [anon_sym_join] = ACTIONS(2264),
    [anon_sym_on] = ACTIONS(2264),
    [anon_sym_equals] = ACTIONS(2264),
    [anon_sym_into] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_orderby] = ACTIONS(2264),
    [anon_sym_ascending] = ACTIONS(2264),
    [anon_sym_descending] = ACTIONS(2264),
    [anon_sym_group] = ACTIONS(2264),
    [anon_sym_by] = ACTIONS(2264),
    [anon_sym_select] = ACTIONS(2264),
    [anon_sym_DOT_DOT] = ACTIONS(2262),
    [anon_sym___reftype] = ACTIONS(2264),
    [anon_sym___refvalue] = ACTIONS(2264),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [sym_integer_literal] = ACTIONS(2264),
    [sym_null_literal] = ACTIONS(2264),
    [sym_real_literal] = ACTIONS(2262),
    [sym_verbatim_string_literal] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2264),
    [anon_sym_nameof] = ACTIONS(2264),
    [sym_void_keyword] = ACTIONS(2264),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1562] = {
    [sym__preprocessor_call] = STATE(1562),
    [ts_builtin_sym_end] = ACTIONS(2266),
    [sym__identifier_token] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym_alias] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym_global] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_LPAREN] = ACTIONS(2266),
    [anon_sym_abstract] = ACTIONS(2268),
    [anon_sym_async] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_fixed] = ACTIONS(2268),
    [anon_sym_internal] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_partial] = ACTIONS(2268),
    [anon_sym_private] = ACTIONS(2268),
    [anon_sym_protected] = ACTIONS(2268),
    [anon_sym_public] = ACTIONS(2268),
    [anon_sym_readonly] = ACTIONS(2268),
    [anon_sym_ref] = ACTIONS(2268),
    [anon_sym_sealed] = ACTIONS(2268),
    [anon_sym_unsafe] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_this] = ACTIONS(2268),
    [anon_sym_base] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_where] = ACTIONS(2268),
    [anon_sym_class] = ACTIONS(2268),
    [anon_sym_struct] = ACTIONS(2268),
    [anon_sym_notnull] = ACTIONS(2268),
    [anon_sym_unmanaged] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_true] = ACTIONS(2268),
    [anon_sym_false] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_get] = ACTIONS(2268),
    [anon_sym_set] = ACTIONS(2268),
    [anon_sym_add] = ACTIONS(2268),
    [anon_sym_remove] = ACTIONS(2268),
    [anon_sym_enum] = ACTIONS(2268),
    [anon_sym_interface] = ACTIONS(2268),
    [anon_sym_delegate] = ACTIONS(2268),
    [anon_sym_record] = ACTIONS(2268),
    [anon_sym_namespace] = ACTIONS(2268),
    [anon_sym_var] = ACTIONS(2268),
    [sym_predefined_type] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_checked] = ACTIONS(2268),
    [anon_sym_unchecked] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_await] = ACTIONS(2268),
    [anon_sym_foreach] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_lock] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_when] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_yield] = ACTIONS(2268),
    [anon_sym_stackalloc] = ACTIONS(2268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2266),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2266),
    [anon_sym___makeref] = ACTIONS(2268),
    [anon_sym_from] = ACTIONS(2268),
    [anon_sym_join] = ACTIONS(2268),
    [anon_sym_on] = ACTIONS(2268),
    [anon_sym_equals] = ACTIONS(2268),
    [anon_sym_into] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_orderby] = ACTIONS(2268),
    [anon_sym_ascending] = ACTIONS(2268),
    [anon_sym_descending] = ACTIONS(2268),
    [anon_sym_group] = ACTIONS(2268),
    [anon_sym_by] = ACTIONS(2268),
    [anon_sym_select] = ACTIONS(2268),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym___reftype] = ACTIONS(2268),
    [anon_sym___refvalue] = ACTIONS(2268),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym_typeof] = ACTIONS(2268),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [sym_integer_literal] = ACTIONS(2268),
    [sym_null_literal] = ACTIONS(2268),
    [sym_real_literal] = ACTIONS(2266),
    [sym_verbatim_string_literal] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2268),
    [anon_sym_nameof] = ACTIONS(2268),
    [sym_void_keyword] = ACTIONS(2268),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1563] = {
    [sym__preprocessor_call] = STATE(1563),
    [ts_builtin_sym_end] = ACTIONS(2270),
    [sym__identifier_token] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym_alias] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_global] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_fixed] = ACTIONS(2272),
    [anon_sym_internal] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_partial] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_ref] = ACTIONS(2272),
    [anon_sym_sealed] = ACTIONS(2272),
    [anon_sym_unsafe] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_this] = ACTIONS(2272),
    [anon_sym_base] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_where] = ACTIONS(2272),
    [anon_sym_class] = ACTIONS(2272),
    [anon_sym_struct] = ACTIONS(2272),
    [anon_sym_notnull] = ACTIONS(2272),
    [anon_sym_unmanaged] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_true] = ACTIONS(2272),
    [anon_sym_false] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_CARET] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_add] = ACTIONS(2272),
    [anon_sym_remove] = ACTIONS(2272),
    [anon_sym_enum] = ACTIONS(2272),
    [anon_sym_interface] = ACTIONS(2272),
    [anon_sym_delegate] = ACTIONS(2272),
    [anon_sym_record] = ACTIONS(2272),
    [anon_sym_namespace] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [sym_predefined_type] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_checked] = ACTIONS(2272),
    [anon_sym_unchecked] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_foreach] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_lock] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_when] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_stackalloc] = ACTIONS(2272),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2270),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2270),
    [anon_sym___makeref] = ACTIONS(2272),
    [anon_sym_from] = ACTIONS(2272),
    [anon_sym_join] = ACTIONS(2272),
    [anon_sym_on] = ACTIONS(2272),
    [anon_sym_equals] = ACTIONS(2272),
    [anon_sym_into] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_orderby] = ACTIONS(2272),
    [anon_sym_ascending] = ACTIONS(2272),
    [anon_sym_descending] = ACTIONS(2272),
    [anon_sym_group] = ACTIONS(2272),
    [anon_sym_by] = ACTIONS(2272),
    [anon_sym_select] = ACTIONS(2272),
    [anon_sym_DOT_DOT] = ACTIONS(2270),
    [anon_sym___reftype] = ACTIONS(2272),
    [anon_sym___refvalue] = ACTIONS(2272),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [sym_integer_literal] = ACTIONS(2272),
    [sym_null_literal] = ACTIONS(2272),
    [sym_real_literal] = ACTIONS(2270),
    [sym_verbatim_string_literal] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2272),
    [anon_sym_nameof] = ACTIONS(2272),
    [sym_void_keyword] = ACTIONS(2272),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1564] = {
    [sym__preprocessor_call] = STATE(1564),
    [ts_builtin_sym_end] = ACTIONS(2274),
    [sym__identifier_token] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym_alias] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_global] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [anon_sym_abstract] = ACTIONS(2276),
    [anon_sym_async] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_fixed] = ACTIONS(2276),
    [anon_sym_internal] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_partial] = ACTIONS(2276),
    [anon_sym_private] = ACTIONS(2276),
    [anon_sym_protected] = ACTIONS(2276),
    [anon_sym_public] = ACTIONS(2276),
    [anon_sym_readonly] = ACTIONS(2276),
    [anon_sym_ref] = ACTIONS(2276),
    [anon_sym_sealed] = ACTIONS(2276),
    [anon_sym_unsafe] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_this] = ACTIONS(2276),
    [anon_sym_base] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_where] = ACTIONS(2276),
    [anon_sym_class] = ACTIONS(2276),
    [anon_sym_struct] = ACTIONS(2276),
    [anon_sym_notnull] = ACTIONS(2276),
    [anon_sym_unmanaged] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_true] = ACTIONS(2276),
    [anon_sym_false] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_get] = ACTIONS(2276),
    [anon_sym_set] = ACTIONS(2276),
    [anon_sym_add] = ACTIONS(2276),
    [anon_sym_remove] = ACTIONS(2276),
    [anon_sym_enum] = ACTIONS(2276),
    [anon_sym_interface] = ACTIONS(2276),
    [anon_sym_delegate] = ACTIONS(2276),
    [anon_sym_record] = ACTIONS(2276),
    [anon_sym_namespace] = ACTIONS(2276),
    [anon_sym_var] = ACTIONS(2276),
    [sym_predefined_type] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_checked] = ACTIONS(2276),
    [anon_sym_unchecked] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_await] = ACTIONS(2276),
    [anon_sym_foreach] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_lock] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_when] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_yield] = ACTIONS(2276),
    [anon_sym_stackalloc] = ACTIONS(2276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2274),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2274),
    [anon_sym___makeref] = ACTIONS(2276),
    [anon_sym_from] = ACTIONS(2276),
    [anon_sym_join] = ACTIONS(2276),
    [anon_sym_on] = ACTIONS(2276),
    [anon_sym_equals] = ACTIONS(2276),
    [anon_sym_into] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_orderby] = ACTIONS(2276),
    [anon_sym_ascending] = ACTIONS(2276),
    [anon_sym_descending] = ACTIONS(2276),
    [anon_sym_group] = ACTIONS(2276),
    [anon_sym_by] = ACTIONS(2276),
    [anon_sym_select] = ACTIONS(2276),
    [anon_sym_DOT_DOT] = ACTIONS(2274),
    [anon_sym___reftype] = ACTIONS(2276),
    [anon_sym___refvalue] = ACTIONS(2276),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym_typeof] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [sym_integer_literal] = ACTIONS(2276),
    [sym_null_literal] = ACTIONS(2276),
    [sym_real_literal] = ACTIONS(2274),
    [sym_verbatim_string_literal] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2276),
    [anon_sym_nameof] = ACTIONS(2276),
    [sym_void_keyword] = ACTIONS(2276),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1565] = {
    [sym__preprocessor_call] = STATE(1565),
    [ts_builtin_sym_end] = ACTIONS(2278),
    [sym__identifier_token] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym_alias] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_global] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_fixed] = ACTIONS(2280),
    [anon_sym_internal] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_partial] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_ref] = ACTIONS(2280),
    [anon_sym_sealed] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_this] = ACTIONS(2280),
    [anon_sym_base] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_where] = ACTIONS(2280),
    [anon_sym_class] = ACTIONS(2280),
    [anon_sym_struct] = ACTIONS(2280),
    [anon_sym_notnull] = ACTIONS(2280),
    [anon_sym_unmanaged] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_true] = ACTIONS(2280),
    [anon_sym_false] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_CARET] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2278),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_add] = ACTIONS(2280),
    [anon_sym_remove] = ACTIONS(2280),
    [anon_sym_enum] = ACTIONS(2280),
    [anon_sym_interface] = ACTIONS(2280),
    [anon_sym_delegate] = ACTIONS(2280),
    [anon_sym_record] = ACTIONS(2280),
    [anon_sym_namespace] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [sym_predefined_type] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_checked] = ACTIONS(2280),
    [anon_sym_unchecked] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_foreach] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_lock] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_when] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_stackalloc] = ACTIONS(2280),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2278),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2278),
    [anon_sym___makeref] = ACTIONS(2280),
    [anon_sym_from] = ACTIONS(2280),
    [anon_sym_join] = ACTIONS(2280),
    [anon_sym_on] = ACTIONS(2280),
    [anon_sym_equals] = ACTIONS(2280),
    [anon_sym_into] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_orderby] = ACTIONS(2280),
    [anon_sym_ascending] = ACTIONS(2280),
    [anon_sym_descending] = ACTIONS(2280),
    [anon_sym_group] = ACTIONS(2280),
    [anon_sym_by] = ACTIONS(2280),
    [anon_sym_select] = ACTIONS(2280),
    [anon_sym_DOT_DOT] = ACTIONS(2278),
    [anon_sym___reftype] = ACTIONS(2280),
    [anon_sym___refvalue] = ACTIONS(2280),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_integer_literal] = ACTIONS(2280),
    [sym_null_literal] = ACTIONS(2280),
    [sym_real_literal] = ACTIONS(2278),
    [sym_verbatim_string_literal] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2280),
    [anon_sym_nameof] = ACTIONS(2280),
    [sym_void_keyword] = ACTIONS(2280),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1566] = {
    [sym__preprocessor_call] = STATE(1566),
    [ts_builtin_sym_end] = ACTIONS(2282),
    [sym__identifier_token] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym_alias] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_global] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_LPAREN] = ACTIONS(2282),
    [anon_sym_abstract] = ACTIONS(2284),
    [anon_sym_async] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_fixed] = ACTIONS(2284),
    [anon_sym_internal] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_partial] = ACTIONS(2284),
    [anon_sym_private] = ACTIONS(2284),
    [anon_sym_protected] = ACTIONS(2284),
    [anon_sym_public] = ACTIONS(2284),
    [anon_sym_readonly] = ACTIONS(2284),
    [anon_sym_ref] = ACTIONS(2284),
    [anon_sym_sealed] = ACTIONS(2284),
    [anon_sym_unsafe] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_this] = ACTIONS(2284),
    [anon_sym_base] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_where] = ACTIONS(2284),
    [anon_sym_class] = ACTIONS(2284),
    [anon_sym_struct] = ACTIONS(2284),
    [anon_sym_notnull] = ACTIONS(2284),
    [anon_sym_unmanaged] = ACTIONS(2284),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_true] = ACTIONS(2284),
    [anon_sym_false] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym_get] = ACTIONS(2284),
    [anon_sym_set] = ACTIONS(2284),
    [anon_sym_add] = ACTIONS(2284),
    [anon_sym_remove] = ACTIONS(2284),
    [anon_sym_enum] = ACTIONS(2284),
    [anon_sym_interface] = ACTIONS(2284),
    [anon_sym_delegate] = ACTIONS(2284),
    [anon_sym_record] = ACTIONS(2284),
    [anon_sym_namespace] = ACTIONS(2284),
    [anon_sym_var] = ACTIONS(2284),
    [sym_predefined_type] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_checked] = ACTIONS(2284),
    [anon_sym_unchecked] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_await] = ACTIONS(2284),
    [anon_sym_foreach] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_lock] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_when] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_yield] = ACTIONS(2284),
    [anon_sym_stackalloc] = ACTIONS(2284),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2282),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2282),
    [anon_sym___makeref] = ACTIONS(2284),
    [anon_sym_from] = ACTIONS(2284),
    [anon_sym_join] = ACTIONS(2284),
    [anon_sym_on] = ACTIONS(2284),
    [anon_sym_equals] = ACTIONS(2284),
    [anon_sym_into] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_orderby] = ACTIONS(2284),
    [anon_sym_ascending] = ACTIONS(2284),
    [anon_sym_descending] = ACTIONS(2284),
    [anon_sym_group] = ACTIONS(2284),
    [anon_sym_by] = ACTIONS(2284),
    [anon_sym_select] = ACTIONS(2284),
    [anon_sym_DOT_DOT] = ACTIONS(2282),
    [anon_sym___reftype] = ACTIONS(2284),
    [anon_sym___refvalue] = ACTIONS(2284),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym_typeof] = ACTIONS(2284),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [sym_integer_literal] = ACTIONS(2284),
    [sym_null_literal] = ACTIONS(2284),
    [sym_real_literal] = ACTIONS(2282),
    [sym_verbatim_string_literal] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2284),
    [anon_sym_nameof] = ACTIONS(2284),
    [sym_void_keyword] = ACTIONS(2284),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1567] = {
    [sym__preprocessor_call] = STATE(1567),
    [ts_builtin_sym_end] = ACTIONS(2286),
    [sym__identifier_token] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_alias] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_global] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_fixed] = ACTIONS(2288),
    [anon_sym_internal] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_partial] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_ref] = ACTIONS(2288),
    [anon_sym_sealed] = ACTIONS(2288),
    [anon_sym_unsafe] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_this] = ACTIONS(2288),
    [anon_sym_base] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_where] = ACTIONS(2288),
    [anon_sym_class] = ACTIONS(2288),
    [anon_sym_struct] = ACTIONS(2288),
    [anon_sym_notnull] = ACTIONS(2288),
    [anon_sym_unmanaged] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_true] = ACTIONS(2288),
    [anon_sym_false] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_CARET] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_add] = ACTIONS(2288),
    [anon_sym_remove] = ACTIONS(2288),
    [anon_sym_enum] = ACTIONS(2288),
    [anon_sym_interface] = ACTIONS(2288),
    [anon_sym_delegate] = ACTIONS(2288),
    [anon_sym_record] = ACTIONS(2288),
    [anon_sym_namespace] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [sym_predefined_type] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_checked] = ACTIONS(2288),
    [anon_sym_unchecked] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_foreach] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_lock] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_when] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_stackalloc] = ACTIONS(2288),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2286),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2286),
    [anon_sym___makeref] = ACTIONS(2288),
    [anon_sym_from] = ACTIONS(2288),
    [anon_sym_join] = ACTIONS(2288),
    [anon_sym_on] = ACTIONS(2288),
    [anon_sym_equals] = ACTIONS(2288),
    [anon_sym_into] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_orderby] = ACTIONS(2288),
    [anon_sym_ascending] = ACTIONS(2288),
    [anon_sym_descending] = ACTIONS(2288),
    [anon_sym_group] = ACTIONS(2288),
    [anon_sym_by] = ACTIONS(2288),
    [anon_sym_select] = ACTIONS(2288),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym___reftype] = ACTIONS(2288),
    [anon_sym___refvalue] = ACTIONS(2288),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [sym_integer_literal] = ACTIONS(2288),
    [sym_null_literal] = ACTIONS(2288),
    [sym_real_literal] = ACTIONS(2286),
    [sym_verbatim_string_literal] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2288),
    [anon_sym_nameof] = ACTIONS(2288),
    [sym_void_keyword] = ACTIONS(2288),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1568] = {
    [sym__preprocessor_call] = STATE(1568),
    [ts_builtin_sym_end] = ACTIONS(2290),
    [sym__identifier_token] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym_alias] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_global] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_fixed] = ACTIONS(2292),
    [anon_sym_internal] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_partial] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_ref] = ACTIONS(2292),
    [anon_sym_sealed] = ACTIONS(2292),
    [anon_sym_unsafe] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_this] = ACTIONS(2292),
    [anon_sym_base] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_where] = ACTIONS(2292),
    [anon_sym_class] = ACTIONS(2292),
    [anon_sym_struct] = ACTIONS(2292),
    [anon_sym_notnull] = ACTIONS(2292),
    [anon_sym_unmanaged] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_true] = ACTIONS(2292),
    [anon_sym_false] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_CARET] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_add] = ACTIONS(2292),
    [anon_sym_remove] = ACTIONS(2292),
    [anon_sym_enum] = ACTIONS(2292),
    [anon_sym_interface] = ACTIONS(2292),
    [anon_sym_delegate] = ACTIONS(2292),
    [anon_sym_record] = ACTIONS(2292),
    [anon_sym_namespace] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [sym_predefined_type] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_checked] = ACTIONS(2292),
    [anon_sym_unchecked] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_foreach] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_lock] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_when] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_stackalloc] = ACTIONS(2292),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2290),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2290),
    [anon_sym___makeref] = ACTIONS(2292),
    [anon_sym_from] = ACTIONS(2292),
    [anon_sym_join] = ACTIONS(2292),
    [anon_sym_on] = ACTIONS(2292),
    [anon_sym_equals] = ACTIONS(2292),
    [anon_sym_into] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_orderby] = ACTIONS(2292),
    [anon_sym_ascending] = ACTIONS(2292),
    [anon_sym_descending] = ACTIONS(2292),
    [anon_sym_group] = ACTIONS(2292),
    [anon_sym_by] = ACTIONS(2292),
    [anon_sym_select] = ACTIONS(2292),
    [anon_sym_DOT_DOT] = ACTIONS(2290),
    [anon_sym___reftype] = ACTIONS(2292),
    [anon_sym___refvalue] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [sym_integer_literal] = ACTIONS(2292),
    [sym_null_literal] = ACTIONS(2292),
    [sym_real_literal] = ACTIONS(2290),
    [sym_verbatim_string_literal] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2292),
    [anon_sym_nameof] = ACTIONS(2292),
    [sym_void_keyword] = ACTIONS(2292),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1569] = {
    [sym__preprocessor_call] = STATE(1569),
    [ts_builtin_sym_end] = ACTIONS(2294),
    [sym__identifier_token] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym_alias] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_global] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_abstract] = ACTIONS(2296),
    [anon_sym_async] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_fixed] = ACTIONS(2296),
    [anon_sym_internal] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_partial] = ACTIONS(2296),
    [anon_sym_private] = ACTIONS(2296),
    [anon_sym_protected] = ACTIONS(2296),
    [anon_sym_public] = ACTIONS(2296),
    [anon_sym_readonly] = ACTIONS(2296),
    [anon_sym_ref] = ACTIONS(2296),
    [anon_sym_sealed] = ACTIONS(2296),
    [anon_sym_unsafe] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_this] = ACTIONS(2296),
    [anon_sym_base] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_where] = ACTIONS(2296),
    [anon_sym_class] = ACTIONS(2296),
    [anon_sym_struct] = ACTIONS(2296),
    [anon_sym_notnull] = ACTIONS(2296),
    [anon_sym_unmanaged] = ACTIONS(2296),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_true] = ACTIONS(2296),
    [anon_sym_false] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2294),
    [anon_sym_get] = ACTIONS(2296),
    [anon_sym_set] = ACTIONS(2296),
    [anon_sym_add] = ACTIONS(2296),
    [anon_sym_remove] = ACTIONS(2296),
    [anon_sym_enum] = ACTIONS(2296),
    [anon_sym_interface] = ACTIONS(2296),
    [anon_sym_delegate] = ACTIONS(2296),
    [anon_sym_record] = ACTIONS(2296),
    [anon_sym_namespace] = ACTIONS(2296),
    [anon_sym_var] = ACTIONS(2296),
    [sym_predefined_type] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_checked] = ACTIONS(2296),
    [anon_sym_unchecked] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_await] = ACTIONS(2296),
    [anon_sym_foreach] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_lock] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_when] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_yield] = ACTIONS(2296),
    [anon_sym_stackalloc] = ACTIONS(2296),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2294),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2294),
    [anon_sym___makeref] = ACTIONS(2296),
    [anon_sym_from] = ACTIONS(2296),
    [anon_sym_join] = ACTIONS(2296),
    [anon_sym_on] = ACTIONS(2296),
    [anon_sym_equals] = ACTIONS(2296),
    [anon_sym_into] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_orderby] = ACTIONS(2296),
    [anon_sym_ascending] = ACTIONS(2296),
    [anon_sym_descending] = ACTIONS(2296),
    [anon_sym_group] = ACTIONS(2296),
    [anon_sym_by] = ACTIONS(2296),
    [anon_sym_select] = ACTIONS(2296),
    [anon_sym_DOT_DOT] = ACTIONS(2294),
    [anon_sym___reftype] = ACTIONS(2296),
    [anon_sym___refvalue] = ACTIONS(2296),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym_typeof] = ACTIONS(2296),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [sym_integer_literal] = ACTIONS(2296),
    [sym_null_literal] = ACTIONS(2296),
    [sym_real_literal] = ACTIONS(2294),
    [sym_verbatim_string_literal] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2296),
    [anon_sym_nameof] = ACTIONS(2296),
    [sym_void_keyword] = ACTIONS(2296),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1570] = {
    [sym__preprocessor_call] = STATE(1570),
    [ts_builtin_sym_end] = ACTIONS(2298),
    [sym__identifier_token] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym_alias] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym_global] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2298),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_fixed] = ACTIONS(2300),
    [anon_sym_internal] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_partial] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_ref] = ACTIONS(2300),
    [anon_sym_sealed] = ACTIONS(2300),
    [anon_sym_unsafe] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_this] = ACTIONS(2300),
    [anon_sym_base] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_where] = ACTIONS(2300),
    [anon_sym_class] = ACTIONS(2300),
    [anon_sym_struct] = ACTIONS(2300),
    [anon_sym_notnull] = ACTIONS(2300),
    [anon_sym_unmanaged] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_true] = ACTIONS(2300),
    [anon_sym_false] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_CARET] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_add] = ACTIONS(2300),
    [anon_sym_remove] = ACTIONS(2300),
    [anon_sym_enum] = ACTIONS(2300),
    [anon_sym_interface] = ACTIONS(2300),
    [anon_sym_delegate] = ACTIONS(2300),
    [anon_sym_record] = ACTIONS(2300),
    [anon_sym_namespace] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [sym_predefined_type] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_checked] = ACTIONS(2300),
    [anon_sym_unchecked] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_foreach] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_lock] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_when] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_stackalloc] = ACTIONS(2300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2298),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2298),
    [anon_sym___makeref] = ACTIONS(2300),
    [anon_sym_from] = ACTIONS(2300),
    [anon_sym_join] = ACTIONS(2300),
    [anon_sym_on] = ACTIONS(2300),
    [anon_sym_equals] = ACTIONS(2300),
    [anon_sym_into] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_orderby] = ACTIONS(2300),
    [anon_sym_ascending] = ACTIONS(2300),
    [anon_sym_descending] = ACTIONS(2300),
    [anon_sym_group] = ACTIONS(2300),
    [anon_sym_by] = ACTIONS(2300),
    [anon_sym_select] = ACTIONS(2300),
    [anon_sym_DOT_DOT] = ACTIONS(2298),
    [anon_sym___reftype] = ACTIONS(2300),
    [anon_sym___refvalue] = ACTIONS(2300),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [sym_integer_literal] = ACTIONS(2300),
    [sym_null_literal] = ACTIONS(2300),
    [sym_real_literal] = ACTIONS(2298),
    [sym_verbatim_string_literal] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2300),
    [anon_sym_nameof] = ACTIONS(2300),
    [sym_void_keyword] = ACTIONS(2300),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1571] = {
    [sym__preprocessor_call] = STATE(1571),
    [ts_builtin_sym_end] = ACTIONS(2302),
    [sym__identifier_token] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym_alias] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym_global] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2302),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_fixed] = ACTIONS(2304),
    [anon_sym_internal] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_partial] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_ref] = ACTIONS(2304),
    [anon_sym_sealed] = ACTIONS(2304),
    [anon_sym_unsafe] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_this] = ACTIONS(2304),
    [anon_sym_base] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_where] = ACTIONS(2304),
    [anon_sym_class] = ACTIONS(2304),
    [anon_sym_struct] = ACTIONS(2304),
    [anon_sym_notnull] = ACTIONS(2304),
    [anon_sym_unmanaged] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_true] = ACTIONS(2304),
    [anon_sym_false] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_CARET] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2302),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_add] = ACTIONS(2304),
    [anon_sym_remove] = ACTIONS(2304),
    [anon_sym_enum] = ACTIONS(2304),
    [anon_sym_interface] = ACTIONS(2304),
    [anon_sym_delegate] = ACTIONS(2304),
    [anon_sym_record] = ACTIONS(2304),
    [anon_sym_namespace] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [sym_predefined_type] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_checked] = ACTIONS(2304),
    [anon_sym_unchecked] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_foreach] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_lock] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_when] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_stackalloc] = ACTIONS(2304),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2302),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2302),
    [anon_sym___makeref] = ACTIONS(2304),
    [anon_sym_from] = ACTIONS(2304),
    [anon_sym_join] = ACTIONS(2304),
    [anon_sym_on] = ACTIONS(2304),
    [anon_sym_equals] = ACTIONS(2304),
    [anon_sym_into] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_orderby] = ACTIONS(2304),
    [anon_sym_ascending] = ACTIONS(2304),
    [anon_sym_descending] = ACTIONS(2304),
    [anon_sym_group] = ACTIONS(2304),
    [anon_sym_by] = ACTIONS(2304),
    [anon_sym_select] = ACTIONS(2304),
    [anon_sym_DOT_DOT] = ACTIONS(2302),
    [anon_sym___reftype] = ACTIONS(2304),
    [anon_sym___refvalue] = ACTIONS(2304),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [sym_integer_literal] = ACTIONS(2304),
    [sym_null_literal] = ACTIONS(2304),
    [sym_real_literal] = ACTIONS(2302),
    [sym_verbatim_string_literal] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2304),
    [anon_sym_nameof] = ACTIONS(2304),
    [sym_void_keyword] = ACTIONS(2304),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1572] = {
    [sym__preprocessor_call] = STATE(1572),
    [ts_builtin_sym_end] = ACTIONS(2306),
    [sym__identifier_token] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym_alias] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym_global] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2306),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_fixed] = ACTIONS(2308),
    [anon_sym_internal] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_partial] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_ref] = ACTIONS(2308),
    [anon_sym_sealed] = ACTIONS(2308),
    [anon_sym_unsafe] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_this] = ACTIONS(2308),
    [anon_sym_base] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_where] = ACTIONS(2308),
    [anon_sym_class] = ACTIONS(2308),
    [anon_sym_struct] = ACTIONS(2308),
    [anon_sym_notnull] = ACTIONS(2308),
    [anon_sym_unmanaged] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_true] = ACTIONS(2308),
    [anon_sym_false] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_CARET] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2306),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_add] = ACTIONS(2308),
    [anon_sym_remove] = ACTIONS(2308),
    [anon_sym_enum] = ACTIONS(2308),
    [anon_sym_interface] = ACTIONS(2308),
    [anon_sym_delegate] = ACTIONS(2308),
    [anon_sym_record] = ACTIONS(2308),
    [anon_sym_namespace] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [sym_predefined_type] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_checked] = ACTIONS(2308),
    [anon_sym_unchecked] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_foreach] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_lock] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_when] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_stackalloc] = ACTIONS(2308),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2306),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2306),
    [anon_sym___makeref] = ACTIONS(2308),
    [anon_sym_from] = ACTIONS(2308),
    [anon_sym_join] = ACTIONS(2308),
    [anon_sym_on] = ACTIONS(2308),
    [anon_sym_equals] = ACTIONS(2308),
    [anon_sym_into] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_orderby] = ACTIONS(2308),
    [anon_sym_ascending] = ACTIONS(2308),
    [anon_sym_descending] = ACTIONS(2308),
    [anon_sym_group] = ACTIONS(2308),
    [anon_sym_by] = ACTIONS(2308),
    [anon_sym_select] = ACTIONS(2308),
    [anon_sym_DOT_DOT] = ACTIONS(2306),
    [anon_sym___reftype] = ACTIONS(2308),
    [anon_sym___refvalue] = ACTIONS(2308),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [sym_integer_literal] = ACTIONS(2308),
    [sym_null_literal] = ACTIONS(2308),
    [sym_real_literal] = ACTIONS(2306),
    [sym_verbatim_string_literal] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2308),
    [anon_sym_nameof] = ACTIONS(2308),
    [sym_void_keyword] = ACTIONS(2308),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1573] = {
    [sym__preprocessor_call] = STATE(1573),
    [ts_builtin_sym_end] = ACTIONS(2310),
    [sym__identifier_token] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym_alias] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_global] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2310),
    [anon_sym_abstract] = ACTIONS(2312),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_fixed] = ACTIONS(2312),
    [anon_sym_internal] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_partial] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_readonly] = ACTIONS(2312),
    [anon_sym_ref] = ACTIONS(2312),
    [anon_sym_sealed] = ACTIONS(2312),
    [anon_sym_unsafe] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_this] = ACTIONS(2312),
    [anon_sym_base] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_where] = ACTIONS(2312),
    [anon_sym_class] = ACTIONS(2312),
    [anon_sym_struct] = ACTIONS(2312),
    [anon_sym_notnull] = ACTIONS(2312),
    [anon_sym_unmanaged] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_true] = ACTIONS(2312),
    [anon_sym_false] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_get] = ACTIONS(2312),
    [anon_sym_set] = ACTIONS(2312),
    [anon_sym_add] = ACTIONS(2312),
    [anon_sym_remove] = ACTIONS(2312),
    [anon_sym_enum] = ACTIONS(2312),
    [anon_sym_interface] = ACTIONS(2312),
    [anon_sym_delegate] = ACTIONS(2312),
    [anon_sym_record] = ACTIONS(2312),
    [anon_sym_namespace] = ACTIONS(2312),
    [anon_sym_var] = ACTIONS(2312),
    [sym_predefined_type] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_checked] = ACTIONS(2312),
    [anon_sym_unchecked] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_await] = ACTIONS(2312),
    [anon_sym_foreach] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_lock] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_when] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_stackalloc] = ACTIONS(2312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2310),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2310),
    [anon_sym___makeref] = ACTIONS(2312),
    [anon_sym_from] = ACTIONS(2312),
    [anon_sym_join] = ACTIONS(2312),
    [anon_sym_on] = ACTIONS(2312),
    [anon_sym_equals] = ACTIONS(2312),
    [anon_sym_into] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_orderby] = ACTIONS(2312),
    [anon_sym_ascending] = ACTIONS(2312),
    [anon_sym_descending] = ACTIONS(2312),
    [anon_sym_group] = ACTIONS(2312),
    [anon_sym_by] = ACTIONS(2312),
    [anon_sym_select] = ACTIONS(2312),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym___reftype] = ACTIONS(2312),
    [anon_sym___refvalue] = ACTIONS(2312),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym_typeof] = ACTIONS(2312),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [sym_integer_literal] = ACTIONS(2312),
    [sym_null_literal] = ACTIONS(2312),
    [sym_real_literal] = ACTIONS(2310),
    [sym_verbatim_string_literal] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2312),
    [anon_sym_nameof] = ACTIONS(2312),
    [sym_void_keyword] = ACTIONS(2312),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1574] = {
    [sym__preprocessor_call] = STATE(1574),
    [ts_builtin_sym_end] = ACTIONS(2314),
    [sym__identifier_token] = ACTIONS(2316),
    [anon_sym_extern] = ACTIONS(2316),
    [anon_sym_alias] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym_global] = ACTIONS(2316),
    [anon_sym_using] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_LPAREN] = ACTIONS(2314),
    [anon_sym_abstract] = ACTIONS(2316),
    [anon_sym_async] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_fixed] = ACTIONS(2316),
    [anon_sym_internal] = ACTIONS(2316),
    [anon_sym_new] = ACTIONS(2316),
    [anon_sym_override] = ACTIONS(2316),
    [anon_sym_partial] = ACTIONS(2316),
    [anon_sym_private] = ACTIONS(2316),
    [anon_sym_protected] = ACTIONS(2316),
    [anon_sym_public] = ACTIONS(2316),
    [anon_sym_readonly] = ACTIONS(2316),
    [anon_sym_ref] = ACTIONS(2316),
    [anon_sym_sealed] = ACTIONS(2316),
    [anon_sym_unsafe] = ACTIONS(2316),
    [anon_sym_virtual] = ACTIONS(2316),
    [anon_sym_volatile] = ACTIONS(2316),
    [anon_sym_this] = ACTIONS(2316),
    [anon_sym_base] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_where] = ACTIONS(2316),
    [anon_sym_class] = ACTIONS(2316),
    [anon_sym_struct] = ACTIONS(2316),
    [anon_sym_notnull] = ACTIONS(2316),
    [anon_sym_unmanaged] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_true] = ACTIONS(2316),
    [anon_sym_false] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_get] = ACTIONS(2316),
    [anon_sym_set] = ACTIONS(2316),
    [anon_sym_add] = ACTIONS(2316),
    [anon_sym_remove] = ACTIONS(2316),
    [anon_sym_enum] = ACTIONS(2316),
    [anon_sym_interface] = ACTIONS(2316),
    [anon_sym_delegate] = ACTIONS(2316),
    [anon_sym_record] = ACTIONS(2316),
    [anon_sym_namespace] = ACTIONS(2316),
    [anon_sym_var] = ACTIONS(2316),
    [sym_predefined_type] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_checked] = ACTIONS(2316),
    [anon_sym_unchecked] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_await] = ACTIONS(2316),
    [anon_sym_foreach] = ACTIONS(2316),
    [anon_sym_goto] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_else] = ACTIONS(2316),
    [anon_sym_lock] = ACTIONS(2316),
    [anon_sym_switch] = ACTIONS(2316),
    [anon_sym_when] = ACTIONS(2316),
    [anon_sym_throw] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [anon_sym_yield] = ACTIONS(2316),
    [anon_sym_stackalloc] = ACTIONS(2316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2314),
    [anon_sym___makeref] = ACTIONS(2316),
    [anon_sym_from] = ACTIONS(2316),
    [anon_sym_join] = ACTIONS(2316),
    [anon_sym_on] = ACTIONS(2316),
    [anon_sym_equals] = ACTIONS(2316),
    [anon_sym_into] = ACTIONS(2316),
    [anon_sym_let] = ACTIONS(2316),
    [anon_sym_orderby] = ACTIONS(2316),
    [anon_sym_ascending] = ACTIONS(2316),
    [anon_sym_descending] = ACTIONS(2316),
    [anon_sym_group] = ACTIONS(2316),
    [anon_sym_by] = ACTIONS(2316),
    [anon_sym_select] = ACTIONS(2316),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym___reftype] = ACTIONS(2316),
    [anon_sym___refvalue] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2316),
    [anon_sym_typeof] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [sym_integer_literal] = ACTIONS(2316),
    [sym_null_literal] = ACTIONS(2316),
    [sym_real_literal] = ACTIONS(2314),
    [sym_verbatim_string_literal] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2316),
    [anon_sym_nameof] = ACTIONS(2316),
    [sym_void_keyword] = ACTIONS(2316),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1575] = {
    [sym__preprocessor_call] = STATE(1575),
    [ts_builtin_sym_end] = ACTIONS(2318),
    [sym__identifier_token] = ACTIONS(2320),
    [anon_sym_extern] = ACTIONS(2320),
    [anon_sym_alias] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_global] = ACTIONS(2320),
    [anon_sym_using] = ACTIONS(2320),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_abstract] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_fixed] = ACTIONS(2320),
    [anon_sym_internal] = ACTIONS(2320),
    [anon_sym_new] = ACTIONS(2320),
    [anon_sym_override] = ACTIONS(2320),
    [anon_sym_partial] = ACTIONS(2320),
    [anon_sym_private] = ACTIONS(2320),
    [anon_sym_protected] = ACTIONS(2320),
    [anon_sym_public] = ACTIONS(2320),
    [anon_sym_readonly] = ACTIONS(2320),
    [anon_sym_ref] = ACTIONS(2320),
    [anon_sym_sealed] = ACTIONS(2320),
    [anon_sym_unsafe] = ACTIONS(2320),
    [anon_sym_virtual] = ACTIONS(2320),
    [anon_sym_volatile] = ACTIONS(2320),
    [anon_sym_this] = ACTIONS(2320),
    [anon_sym_base] = ACTIONS(2320),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_where] = ACTIONS(2320),
    [anon_sym_class] = ACTIONS(2320),
    [anon_sym_struct] = ACTIONS(2320),
    [anon_sym_notnull] = ACTIONS(2320),
    [anon_sym_unmanaged] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_true] = ACTIONS(2320),
    [anon_sym_false] = ACTIONS(2320),
    [anon_sym_PLUS] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2320),
    [anon_sym_STAR] = ACTIONS(2318),
    [anon_sym_CARET] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2318),
    [anon_sym_get] = ACTIONS(2320),
    [anon_sym_set] = ACTIONS(2320),
    [anon_sym_add] = ACTIONS(2320),
    [anon_sym_remove] = ACTIONS(2320),
    [anon_sym_enum] = ACTIONS(2320),
    [anon_sym_interface] = ACTIONS(2320),
    [anon_sym_delegate] = ACTIONS(2320),
    [anon_sym_record] = ACTIONS(2320),
    [anon_sym_namespace] = ACTIONS(2320),
    [anon_sym_var] = ACTIONS(2320),
    [sym_predefined_type] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_checked] = ACTIONS(2320),
    [anon_sym_unchecked] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_do] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_await] = ACTIONS(2320),
    [anon_sym_foreach] = ACTIONS(2320),
    [anon_sym_goto] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_else] = ACTIONS(2320),
    [anon_sym_lock] = ACTIONS(2320),
    [anon_sym_switch] = ACTIONS(2320),
    [anon_sym_when] = ACTIONS(2320),
    [anon_sym_throw] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_stackalloc] = ACTIONS(2320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2318),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2318),
    [anon_sym___makeref] = ACTIONS(2320),
    [anon_sym_from] = ACTIONS(2320),
    [anon_sym_join] = ACTIONS(2320),
    [anon_sym_on] = ACTIONS(2320),
    [anon_sym_equals] = ACTIONS(2320),
    [anon_sym_into] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_orderby] = ACTIONS(2320),
    [anon_sym_ascending] = ACTIONS(2320),
    [anon_sym_descending] = ACTIONS(2320),
    [anon_sym_group] = ACTIONS(2320),
    [anon_sym_by] = ACTIONS(2320),
    [anon_sym_select] = ACTIONS(2320),
    [anon_sym_DOT_DOT] = ACTIONS(2318),
    [anon_sym___reftype] = ACTIONS(2320),
    [anon_sym___refvalue] = ACTIONS(2320),
    [anon_sym_sizeof] = ACTIONS(2320),
    [anon_sym_typeof] = ACTIONS(2320),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [sym_integer_literal] = ACTIONS(2320),
    [sym_null_literal] = ACTIONS(2320),
    [sym_real_literal] = ACTIONS(2318),
    [sym_verbatim_string_literal] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2320),
    [anon_sym_nameof] = ACTIONS(2320),
    [sym_void_keyword] = ACTIONS(2320),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1576] = {
    [sym__preprocessor_call] = STATE(1576),
    [ts_builtin_sym_end] = ACTIONS(2322),
    [sym__identifier_token] = ACTIONS(2324),
    [anon_sym_extern] = ACTIONS(2324),
    [anon_sym_alias] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_global] = ACTIONS(2324),
    [anon_sym_using] = ACTIONS(2324),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_abstract] = ACTIONS(2324),
    [anon_sym_async] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_fixed] = ACTIONS(2324),
    [anon_sym_internal] = ACTIONS(2324),
    [anon_sym_new] = ACTIONS(2324),
    [anon_sym_override] = ACTIONS(2324),
    [anon_sym_partial] = ACTIONS(2324),
    [anon_sym_private] = ACTIONS(2324),
    [anon_sym_protected] = ACTIONS(2324),
    [anon_sym_public] = ACTIONS(2324),
    [anon_sym_readonly] = ACTIONS(2324),
    [anon_sym_ref] = ACTIONS(2324),
    [anon_sym_sealed] = ACTIONS(2324),
    [anon_sym_unsafe] = ACTIONS(2324),
    [anon_sym_virtual] = ACTIONS(2324),
    [anon_sym_volatile] = ACTIONS(2324),
    [anon_sym_this] = ACTIONS(2324),
    [anon_sym_base] = ACTIONS(2324),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_TILDE] = ACTIONS(2322),
    [anon_sym_where] = ACTIONS(2324),
    [anon_sym_class] = ACTIONS(2324),
    [anon_sym_struct] = ACTIONS(2324),
    [anon_sym_notnull] = ACTIONS(2324),
    [anon_sym_unmanaged] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_PLUS_PLUS] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2322),
    [anon_sym_true] = ACTIONS(2324),
    [anon_sym_false] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(2322),
    [anon_sym_CARET] = ACTIONS(2322),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_get] = ACTIONS(2324),
    [anon_sym_set] = ACTIONS(2324),
    [anon_sym_add] = ACTIONS(2324),
    [anon_sym_remove] = ACTIONS(2324),
    [anon_sym_enum] = ACTIONS(2324),
    [anon_sym_interface] = ACTIONS(2324),
    [anon_sym_delegate] = ACTIONS(2324),
    [anon_sym_record] = ACTIONS(2324),
    [anon_sym_namespace] = ACTIONS(2324),
    [anon_sym_var] = ACTIONS(2324),
    [sym_predefined_type] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_checked] = ACTIONS(2324),
    [anon_sym_unchecked] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_do] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_await] = ACTIONS(2324),
    [anon_sym_foreach] = ACTIONS(2324),
    [anon_sym_goto] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_else] = ACTIONS(2324),
    [anon_sym_lock] = ACTIONS(2324),
    [anon_sym_switch] = ACTIONS(2324),
    [anon_sym_when] = ACTIONS(2324),
    [anon_sym_throw] = ACTIONS(2324),
    [anon_sym_try] = ACTIONS(2324),
    [anon_sym_yield] = ACTIONS(2324),
    [anon_sym_stackalloc] = ACTIONS(2324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2322),
    [anon_sym_DQUOTE] = ACTIONS(2322),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2322),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2322),
    [anon_sym___makeref] = ACTIONS(2324),
    [anon_sym_from] = ACTIONS(2324),
    [anon_sym_join] = ACTIONS(2324),
    [anon_sym_on] = ACTIONS(2324),
    [anon_sym_equals] = ACTIONS(2324),
    [anon_sym_into] = ACTIONS(2324),
    [anon_sym_let] = ACTIONS(2324),
    [anon_sym_orderby] = ACTIONS(2324),
    [anon_sym_ascending] = ACTIONS(2324),
    [anon_sym_descending] = ACTIONS(2324),
    [anon_sym_group] = ACTIONS(2324),
    [anon_sym_by] = ACTIONS(2324),
    [anon_sym_select] = ACTIONS(2324),
    [anon_sym_DOT_DOT] = ACTIONS(2322),
    [anon_sym___reftype] = ACTIONS(2324),
    [anon_sym___refvalue] = ACTIONS(2324),
    [anon_sym_sizeof] = ACTIONS(2324),
    [anon_sym_typeof] = ACTIONS(2324),
    [anon_sym_SQUOTE] = ACTIONS(2322),
    [sym_integer_literal] = ACTIONS(2324),
    [sym_null_literal] = ACTIONS(2324),
    [sym_real_literal] = ACTIONS(2322),
    [sym_verbatim_string_literal] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2324),
    [anon_sym_nameof] = ACTIONS(2324),
    [sym_void_keyword] = ACTIONS(2324),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1577] = {
    [sym_catch_clause] = STATE(1651),
    [sym_finally_clause] = STATE(1698),
    [sym__preprocessor_call] = STATE(1577),
    [aux_sym_try_statement_repeat1] = STATE(1639),
    [sym__identifier_token] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym_alias] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2195),
    [anon_sym_global] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_fixed] = ACTIONS(2197),
    [anon_sym_internal] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_partial] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2197),
    [anon_sym_sealed] = ACTIONS(2197),
    [anon_sym_unsafe] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2197),
    [anon_sym_base] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2195),
    [anon_sym_RBRACE] = ACTIONS(2195),
    [anon_sym_TILDE] = ACTIONS(2195),
    [anon_sym_where] = ACTIONS(2197),
    [anon_sym_notnull] = ACTIONS(2197),
    [anon_sym_unmanaged] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2195),
    [anon_sym_PLUS_PLUS] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2195),
    [anon_sym_true] = ACTIONS(2197),
    [anon_sym_false] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2195),
    [anon_sym_CARET] = ACTIONS(2195),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_add] = ACTIONS(2197),
    [anon_sym_remove] = ACTIONS(2197),
    [anon_sym_delegate] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [sym_predefined_type] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_checked] = ACTIONS(2197),
    [anon_sym_unchecked] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_foreach] = ACTIONS(2197),
    [anon_sym_goto] = ACTIONS(2197),
    [anon_sym_case] = ACTIONS(2197),
    [anon_sym_default] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_lock] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_when] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_catch] = ACTIONS(2326),
    [anon_sym_finally] = ACTIONS(2328),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_stackalloc] = ACTIONS(2197),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2195),
    [anon_sym_DQUOTE] = ACTIONS(2195),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2195),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2195),
    [anon_sym___makeref] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(2197),
    [anon_sym_join] = ACTIONS(2197),
    [anon_sym_on] = ACTIONS(2197),
    [anon_sym_equals] = ACTIONS(2197),
    [anon_sym_into] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_orderby] = ACTIONS(2197),
    [anon_sym_ascending] = ACTIONS(2197),
    [anon_sym_descending] = ACTIONS(2197),
    [anon_sym_group] = ACTIONS(2197),
    [anon_sym_by] = ACTIONS(2197),
    [anon_sym_select] = ACTIONS(2197),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym___reftype] = ACTIONS(2197),
    [anon_sym___refvalue] = ACTIONS(2197),
    [anon_sym_sizeof] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2195),
    [sym_integer_literal] = ACTIONS(2197),
    [sym_null_literal] = ACTIONS(2197),
    [sym_real_literal] = ACTIONS(2195),
    [sym_verbatim_string_literal] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2197),
    [anon_sym_nameof] = ACTIONS(2197),
    [sym_void_keyword] = ACTIONS(2197),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1578] = {
    [sym__preprocessor_call] = STATE(1578),
    [ts_builtin_sym_end] = ACTIONS(2330),
    [sym__identifier_token] = ACTIONS(2332),
    [anon_sym_extern] = ACTIONS(2332),
    [anon_sym_alias] = ACTIONS(2332),
    [anon_sym_SEMI] = ACTIONS(2330),
    [anon_sym_global] = ACTIONS(2332),
    [anon_sym_using] = ACTIONS(2332),
    [anon_sym_static] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2330),
    [anon_sym_abstract] = ACTIONS(2332),
    [anon_sym_async] = ACTIONS(2332),
    [anon_sym_const] = ACTIONS(2332),
    [anon_sym_fixed] = ACTIONS(2332),
    [anon_sym_internal] = ACTIONS(2332),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_override] = ACTIONS(2332),
    [anon_sym_partial] = ACTIONS(2332),
    [anon_sym_private] = ACTIONS(2332),
    [anon_sym_protected] = ACTIONS(2332),
    [anon_sym_public] = ACTIONS(2332),
    [anon_sym_readonly] = ACTIONS(2332),
    [anon_sym_ref] = ACTIONS(2332),
    [anon_sym_sealed] = ACTIONS(2332),
    [anon_sym_unsafe] = ACTIONS(2332),
    [anon_sym_virtual] = ACTIONS(2332),
    [anon_sym_volatile] = ACTIONS(2332),
    [anon_sym_this] = ACTIONS(2332),
    [anon_sym_base] = ACTIONS(2332),
    [anon_sym_LBRACE] = ACTIONS(2330),
    [anon_sym_TILDE] = ACTIONS(2330),
    [anon_sym_where] = ACTIONS(2332),
    [anon_sym_class] = ACTIONS(2332),
    [anon_sym_struct] = ACTIONS(2332),
    [anon_sym_notnull] = ACTIONS(2332),
    [anon_sym_unmanaged] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2330),
    [anon_sym_PLUS_PLUS] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2330),
    [anon_sym_true] = ACTIONS(2332),
    [anon_sym_false] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2330),
    [anon_sym_CARET] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_get] = ACTIONS(2332),
    [anon_sym_set] = ACTIONS(2332),
    [anon_sym_add] = ACTIONS(2332),
    [anon_sym_remove] = ACTIONS(2332),
    [anon_sym_enum] = ACTIONS(2332),
    [anon_sym_interface] = ACTIONS(2332),
    [anon_sym_delegate] = ACTIONS(2332),
    [anon_sym_record] = ACTIONS(2332),
    [anon_sym_namespace] = ACTIONS(2332),
    [anon_sym_var] = ACTIONS(2332),
    [sym_predefined_type] = ACTIONS(2332),
    [anon_sym_break] = ACTIONS(2332),
    [anon_sym_checked] = ACTIONS(2332),
    [anon_sym_unchecked] = ACTIONS(2332),
    [anon_sym_continue] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_await] = ACTIONS(2332),
    [anon_sym_foreach] = ACTIONS(2332),
    [anon_sym_goto] = ACTIONS(2332),
    [anon_sym_default] = ACTIONS(2332),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(2332),
    [anon_sym_lock] = ACTIONS(2332),
    [anon_sym_switch] = ACTIONS(2332),
    [anon_sym_when] = ACTIONS(2332),
    [anon_sym_throw] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_stackalloc] = ACTIONS(2332),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2330),
    [anon_sym___makeref] = ACTIONS(2332),
    [anon_sym_from] = ACTIONS(2332),
    [anon_sym_join] = ACTIONS(2332),
    [anon_sym_on] = ACTIONS(2332),
    [anon_sym_equals] = ACTIONS(2332),
    [anon_sym_into] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_orderby] = ACTIONS(2332),
    [anon_sym_ascending] = ACTIONS(2332),
    [anon_sym_descending] = ACTIONS(2332),
    [anon_sym_group] = ACTIONS(2332),
    [anon_sym_by] = ACTIONS(2332),
    [anon_sym_select] = ACTIONS(2332),
    [anon_sym_DOT_DOT] = ACTIONS(2330),
    [anon_sym___reftype] = ACTIONS(2332),
    [anon_sym___refvalue] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2332),
    [anon_sym_typeof] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2330),
    [sym_integer_literal] = ACTIONS(2332),
    [sym_null_literal] = ACTIONS(2332),
    [sym_real_literal] = ACTIONS(2330),
    [sym_verbatim_string_literal] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2332),
    [anon_sym_nameof] = ACTIONS(2332),
    [sym_void_keyword] = ACTIONS(2332),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1579] = {
    [sym__preprocessor_call] = STATE(1579),
    [ts_builtin_sym_end] = ACTIONS(2334),
    [sym__identifier_token] = ACTIONS(2336),
    [anon_sym_extern] = ACTIONS(2336),
    [anon_sym_alias] = ACTIONS(2336),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_global] = ACTIONS(2336),
    [anon_sym_using] = ACTIONS(2336),
    [anon_sym_static] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_abstract] = ACTIONS(2336),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_const] = ACTIONS(2336),
    [anon_sym_fixed] = ACTIONS(2336),
    [anon_sym_internal] = ACTIONS(2336),
    [anon_sym_new] = ACTIONS(2336),
    [anon_sym_override] = ACTIONS(2336),
    [anon_sym_partial] = ACTIONS(2336),
    [anon_sym_private] = ACTIONS(2336),
    [anon_sym_protected] = ACTIONS(2336),
    [anon_sym_public] = ACTIONS(2336),
    [anon_sym_readonly] = ACTIONS(2336),
    [anon_sym_ref] = ACTIONS(2336),
    [anon_sym_sealed] = ACTIONS(2336),
    [anon_sym_unsafe] = ACTIONS(2336),
    [anon_sym_virtual] = ACTIONS(2336),
    [anon_sym_volatile] = ACTIONS(2336),
    [anon_sym_this] = ACTIONS(2336),
    [anon_sym_base] = ACTIONS(2336),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_where] = ACTIONS(2336),
    [anon_sym_class] = ACTIONS(2336),
    [anon_sym_struct] = ACTIONS(2336),
    [anon_sym_notnull] = ACTIONS(2336),
    [anon_sym_unmanaged] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2334),
    [anon_sym_PLUS_PLUS] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2334),
    [anon_sym_true] = ACTIONS(2336),
    [anon_sym_false] = ACTIONS(2336),
    [anon_sym_PLUS] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2336),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_CARET] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_get] = ACTIONS(2336),
    [anon_sym_set] = ACTIONS(2336),
    [anon_sym_add] = ACTIONS(2336),
    [anon_sym_remove] = ACTIONS(2336),
    [anon_sym_enum] = ACTIONS(2336),
    [anon_sym_interface] = ACTIONS(2336),
    [anon_sym_delegate] = ACTIONS(2336),
    [anon_sym_record] = ACTIONS(2336),
    [anon_sym_namespace] = ACTIONS(2336),
    [anon_sym_var] = ACTIONS(2336),
    [sym_predefined_type] = ACTIONS(2336),
    [anon_sym_break] = ACTIONS(2336),
    [anon_sym_checked] = ACTIONS(2336),
    [anon_sym_unchecked] = ACTIONS(2336),
    [anon_sym_continue] = ACTIONS(2336),
    [anon_sym_do] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_await] = ACTIONS(2336),
    [anon_sym_foreach] = ACTIONS(2336),
    [anon_sym_goto] = ACTIONS(2336),
    [anon_sym_default] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_else] = ACTIONS(2336),
    [anon_sym_lock] = ACTIONS(2336),
    [anon_sym_switch] = ACTIONS(2336),
    [anon_sym_when] = ACTIONS(2336),
    [anon_sym_throw] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_stackalloc] = ACTIONS(2336),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2334),
    [anon_sym___makeref] = ACTIONS(2336),
    [anon_sym_from] = ACTIONS(2336),
    [anon_sym_join] = ACTIONS(2336),
    [anon_sym_on] = ACTIONS(2336),
    [anon_sym_equals] = ACTIONS(2336),
    [anon_sym_into] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(2336),
    [anon_sym_orderby] = ACTIONS(2336),
    [anon_sym_ascending] = ACTIONS(2336),
    [anon_sym_descending] = ACTIONS(2336),
    [anon_sym_group] = ACTIONS(2336),
    [anon_sym_by] = ACTIONS(2336),
    [anon_sym_select] = ACTIONS(2336),
    [anon_sym_DOT_DOT] = ACTIONS(2334),
    [anon_sym___reftype] = ACTIONS(2336),
    [anon_sym___refvalue] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2336),
    [anon_sym_typeof] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2334),
    [sym_integer_literal] = ACTIONS(2336),
    [sym_null_literal] = ACTIONS(2336),
    [sym_real_literal] = ACTIONS(2334),
    [sym_verbatim_string_literal] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2336),
    [anon_sym_nameof] = ACTIONS(2336),
    [sym_void_keyword] = ACTIONS(2336),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1580] = {
    [sym__preprocessor_call] = STATE(1580),
    [ts_builtin_sym_end] = ACTIONS(2338),
    [sym__identifier_token] = ACTIONS(2340),
    [anon_sym_extern] = ACTIONS(2340),
    [anon_sym_alias] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_global] = ACTIONS(2340),
    [anon_sym_using] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_abstract] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_fixed] = ACTIONS(2340),
    [anon_sym_internal] = ACTIONS(2340),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_override] = ACTIONS(2340),
    [anon_sym_partial] = ACTIONS(2340),
    [anon_sym_private] = ACTIONS(2340),
    [anon_sym_protected] = ACTIONS(2340),
    [anon_sym_public] = ACTIONS(2340),
    [anon_sym_readonly] = ACTIONS(2340),
    [anon_sym_ref] = ACTIONS(2340),
    [anon_sym_sealed] = ACTIONS(2340),
    [anon_sym_unsafe] = ACTIONS(2340),
    [anon_sym_virtual] = ACTIONS(2340),
    [anon_sym_volatile] = ACTIONS(2340),
    [anon_sym_this] = ACTIONS(2340),
    [anon_sym_base] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_TILDE] = ACTIONS(2338),
    [anon_sym_where] = ACTIONS(2340),
    [anon_sym_class] = ACTIONS(2340),
    [anon_sym_struct] = ACTIONS(2340),
    [anon_sym_notnull] = ACTIONS(2340),
    [anon_sym_unmanaged] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2338),
    [anon_sym_PLUS_PLUS] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2338),
    [anon_sym_true] = ACTIONS(2340),
    [anon_sym_false] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2338),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_get] = ACTIONS(2340),
    [anon_sym_set] = ACTIONS(2340),
    [anon_sym_add] = ACTIONS(2340),
    [anon_sym_remove] = ACTIONS(2340),
    [anon_sym_enum] = ACTIONS(2340),
    [anon_sym_interface] = ACTIONS(2340),
    [anon_sym_delegate] = ACTIONS(2340),
    [anon_sym_record] = ACTIONS(2340),
    [anon_sym_namespace] = ACTIONS(2340),
    [anon_sym_var] = ACTIONS(2340),
    [sym_predefined_type] = ACTIONS(2340),
    [anon_sym_break] = ACTIONS(2340),
    [anon_sym_checked] = ACTIONS(2340),
    [anon_sym_unchecked] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_await] = ACTIONS(2340),
    [anon_sym_foreach] = ACTIONS(2340),
    [anon_sym_goto] = ACTIONS(2340),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_lock] = ACTIONS(2340),
    [anon_sym_switch] = ACTIONS(2340),
    [anon_sym_when] = ACTIONS(2340),
    [anon_sym_throw] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_stackalloc] = ACTIONS(2340),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2338),
    [anon_sym_DQUOTE] = ACTIONS(2338),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2338),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2338),
    [anon_sym___makeref] = ACTIONS(2340),
    [anon_sym_from] = ACTIONS(2340),
    [anon_sym_join] = ACTIONS(2340),
    [anon_sym_on] = ACTIONS(2340),
    [anon_sym_equals] = ACTIONS(2340),
    [anon_sym_into] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_orderby] = ACTIONS(2340),
    [anon_sym_ascending] = ACTIONS(2340),
    [anon_sym_descending] = ACTIONS(2340),
    [anon_sym_group] = ACTIONS(2340),
    [anon_sym_by] = ACTIONS(2340),
    [anon_sym_select] = ACTIONS(2340),
    [anon_sym_DOT_DOT] = ACTIONS(2338),
    [anon_sym___reftype] = ACTIONS(2340),
    [anon_sym___refvalue] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2340),
    [anon_sym_typeof] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2338),
    [sym_integer_literal] = ACTIONS(2340),
    [sym_null_literal] = ACTIONS(2340),
    [sym_real_literal] = ACTIONS(2338),
    [sym_verbatim_string_literal] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2340),
    [anon_sym_nameof] = ACTIONS(2340),
    [sym_void_keyword] = ACTIONS(2340),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1581] = {
    [sym__preprocessor_call] = STATE(1581),
    [ts_builtin_sym_end] = ACTIONS(2342),
    [sym__identifier_token] = ACTIONS(2344),
    [anon_sym_extern] = ACTIONS(2344),
    [anon_sym_alias] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_global] = ACTIONS(2344),
    [anon_sym_using] = ACTIONS(2344),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_abstract] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_fixed] = ACTIONS(2344),
    [anon_sym_internal] = ACTIONS(2344),
    [anon_sym_new] = ACTIONS(2344),
    [anon_sym_override] = ACTIONS(2344),
    [anon_sym_partial] = ACTIONS(2344),
    [anon_sym_private] = ACTIONS(2344),
    [anon_sym_protected] = ACTIONS(2344),
    [anon_sym_public] = ACTIONS(2344),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_ref] = ACTIONS(2344),
    [anon_sym_sealed] = ACTIONS(2344),
    [anon_sym_unsafe] = ACTIONS(2344),
    [anon_sym_virtual] = ACTIONS(2344),
    [anon_sym_volatile] = ACTIONS(2344),
    [anon_sym_this] = ACTIONS(2344),
    [anon_sym_base] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_TILDE] = ACTIONS(2342),
    [anon_sym_where] = ACTIONS(2344),
    [anon_sym_class] = ACTIONS(2344),
    [anon_sym_struct] = ACTIONS(2344),
    [anon_sym_notnull] = ACTIONS(2344),
    [anon_sym_unmanaged] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [anon_sym_true] = ACTIONS(2344),
    [anon_sym_false] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_STAR] = ACTIONS(2342),
    [anon_sym_CARET] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_get] = ACTIONS(2344),
    [anon_sym_set] = ACTIONS(2344),
    [anon_sym_add] = ACTIONS(2344),
    [anon_sym_remove] = ACTIONS(2344),
    [anon_sym_enum] = ACTIONS(2344),
    [anon_sym_interface] = ACTIONS(2344),
    [anon_sym_delegate] = ACTIONS(2344),
    [anon_sym_record] = ACTIONS(2344),
    [anon_sym_namespace] = ACTIONS(2344),
    [anon_sym_var] = ACTIONS(2344),
    [sym_predefined_type] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_checked] = ACTIONS(2344),
    [anon_sym_unchecked] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_do] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_await] = ACTIONS(2344),
    [anon_sym_foreach] = ACTIONS(2344),
    [anon_sym_goto] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_else] = ACTIONS(2344),
    [anon_sym_lock] = ACTIONS(2344),
    [anon_sym_switch] = ACTIONS(2344),
    [anon_sym_when] = ACTIONS(2344),
    [anon_sym_throw] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_stackalloc] = ACTIONS(2344),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2342),
    [anon_sym___makeref] = ACTIONS(2344),
    [anon_sym_from] = ACTIONS(2344),
    [anon_sym_join] = ACTIONS(2344),
    [anon_sym_on] = ACTIONS(2344),
    [anon_sym_equals] = ACTIONS(2344),
    [anon_sym_into] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_orderby] = ACTIONS(2344),
    [anon_sym_ascending] = ACTIONS(2344),
    [anon_sym_descending] = ACTIONS(2344),
    [anon_sym_group] = ACTIONS(2344),
    [anon_sym_by] = ACTIONS(2344),
    [anon_sym_select] = ACTIONS(2344),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym___reftype] = ACTIONS(2344),
    [anon_sym___refvalue] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2344),
    [anon_sym_typeof] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2342),
    [sym_integer_literal] = ACTIONS(2344),
    [sym_null_literal] = ACTIONS(2344),
    [sym_real_literal] = ACTIONS(2342),
    [sym_verbatim_string_literal] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2344),
    [anon_sym_nameof] = ACTIONS(2344),
    [sym_void_keyword] = ACTIONS(2344),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1582] = {
    [sym__preprocessor_call] = STATE(1582),
    [ts_builtin_sym_end] = ACTIONS(2346),
    [sym__identifier_token] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(2348),
    [anon_sym_alias] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_global] = ACTIONS(2348),
    [anon_sym_using] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_abstract] = ACTIONS(2348),
    [anon_sym_async] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_fixed] = ACTIONS(2348),
    [anon_sym_internal] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [anon_sym_override] = ACTIONS(2348),
    [anon_sym_partial] = ACTIONS(2348),
    [anon_sym_private] = ACTIONS(2348),
    [anon_sym_protected] = ACTIONS(2348),
    [anon_sym_public] = ACTIONS(2348),
    [anon_sym_readonly] = ACTIONS(2348),
    [anon_sym_ref] = ACTIONS(2348),
    [anon_sym_sealed] = ACTIONS(2348),
    [anon_sym_unsafe] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_volatile] = ACTIONS(2348),
    [anon_sym_this] = ACTIONS(2348),
    [anon_sym_base] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_TILDE] = ACTIONS(2346),
    [anon_sym_where] = ACTIONS(2348),
    [anon_sym_class] = ACTIONS(2348),
    [anon_sym_struct] = ACTIONS(2348),
    [anon_sym_notnull] = ACTIONS(2348),
    [anon_sym_unmanaged] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_PLUS_PLUS] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2346),
    [anon_sym_true] = ACTIONS(2348),
    [anon_sym_false] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_STAR] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(2346),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_get] = ACTIONS(2348),
    [anon_sym_set] = ACTIONS(2348),
    [anon_sym_add] = ACTIONS(2348),
    [anon_sym_remove] = ACTIONS(2348),
    [anon_sym_enum] = ACTIONS(2348),
    [anon_sym_interface] = ACTIONS(2348),
    [anon_sym_delegate] = ACTIONS(2348),
    [anon_sym_record] = ACTIONS(2348),
    [anon_sym_namespace] = ACTIONS(2348),
    [anon_sym_var] = ACTIONS(2348),
    [sym_predefined_type] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_checked] = ACTIONS(2348),
    [anon_sym_unchecked] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_await] = ACTIONS(2348),
    [anon_sym_foreach] = ACTIONS(2348),
    [anon_sym_goto] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_else] = ACTIONS(2348),
    [anon_sym_lock] = ACTIONS(2348),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_when] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_yield] = ACTIONS(2348),
    [anon_sym_stackalloc] = ACTIONS(2348),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2346),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2346),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2346),
    [anon_sym___makeref] = ACTIONS(2348),
    [anon_sym_from] = ACTIONS(2348),
    [anon_sym_join] = ACTIONS(2348),
    [anon_sym_on] = ACTIONS(2348),
    [anon_sym_equals] = ACTIONS(2348),
    [anon_sym_into] = ACTIONS(2348),
    [anon_sym_let] = ACTIONS(2348),
    [anon_sym_orderby] = ACTIONS(2348),
    [anon_sym_ascending] = ACTIONS(2348),
    [anon_sym_descending] = ACTIONS(2348),
    [anon_sym_group] = ACTIONS(2348),
    [anon_sym_by] = ACTIONS(2348),
    [anon_sym_select] = ACTIONS(2348),
    [anon_sym_DOT_DOT] = ACTIONS(2346),
    [anon_sym___reftype] = ACTIONS(2348),
    [anon_sym___refvalue] = ACTIONS(2348),
    [anon_sym_sizeof] = ACTIONS(2348),
    [anon_sym_typeof] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2346),
    [sym_integer_literal] = ACTIONS(2348),
    [sym_null_literal] = ACTIONS(2348),
    [sym_real_literal] = ACTIONS(2346),
    [sym_verbatim_string_literal] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2348),
    [anon_sym_nameof] = ACTIONS(2348),
    [sym_void_keyword] = ACTIONS(2348),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1583] = {
    [sym__preprocessor_call] = STATE(1583),
    [ts_builtin_sym_end] = ACTIONS(2350),
    [sym__identifier_token] = ACTIONS(2352),
    [anon_sym_extern] = ACTIONS(2352),
    [anon_sym_alias] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_global] = ACTIONS(2352),
    [anon_sym_using] = ACTIONS(2352),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_LPAREN] = ACTIONS(2350),
    [anon_sym_abstract] = ACTIONS(2352),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_fixed] = ACTIONS(2352),
    [anon_sym_internal] = ACTIONS(2352),
    [anon_sym_new] = ACTIONS(2352),
    [anon_sym_override] = ACTIONS(2352),
    [anon_sym_partial] = ACTIONS(2352),
    [anon_sym_private] = ACTIONS(2352),
    [anon_sym_protected] = ACTIONS(2352),
    [anon_sym_public] = ACTIONS(2352),
    [anon_sym_readonly] = ACTIONS(2352),
    [anon_sym_ref] = ACTIONS(2352),
    [anon_sym_sealed] = ACTIONS(2352),
    [anon_sym_unsafe] = ACTIONS(2352),
    [anon_sym_virtual] = ACTIONS(2352),
    [anon_sym_volatile] = ACTIONS(2352),
    [anon_sym_this] = ACTIONS(2352),
    [anon_sym_base] = ACTIONS(2352),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_TILDE] = ACTIONS(2350),
    [anon_sym_where] = ACTIONS(2352),
    [anon_sym_class] = ACTIONS(2352),
    [anon_sym_struct] = ACTIONS(2352),
    [anon_sym_notnull] = ACTIONS(2352),
    [anon_sym_unmanaged] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2350),
    [anon_sym_DASH_DASH] = ACTIONS(2350),
    [anon_sym_true] = ACTIONS(2352),
    [anon_sym_false] = ACTIONS(2352),
    [anon_sym_PLUS] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_CARET] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_get] = ACTIONS(2352),
    [anon_sym_set] = ACTIONS(2352),
    [anon_sym_add] = ACTIONS(2352),
    [anon_sym_remove] = ACTIONS(2352),
    [anon_sym_enum] = ACTIONS(2352),
    [anon_sym_interface] = ACTIONS(2352),
    [anon_sym_delegate] = ACTIONS(2352),
    [anon_sym_record] = ACTIONS(2352),
    [anon_sym_namespace] = ACTIONS(2352),
    [anon_sym_var] = ACTIONS(2352),
    [sym_predefined_type] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_checked] = ACTIONS(2352),
    [anon_sym_unchecked] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_await] = ACTIONS(2352),
    [anon_sym_foreach] = ACTIONS(2352),
    [anon_sym_goto] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_lock] = ACTIONS(2352),
    [anon_sym_switch] = ACTIONS(2352),
    [anon_sym_when] = ACTIONS(2352),
    [anon_sym_throw] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [anon_sym_yield] = ACTIONS(2352),
    [anon_sym_stackalloc] = ACTIONS(2352),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(2350),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2350),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2350),
    [anon_sym___makeref] = ACTIONS(2352),
    [anon_sym_from] = ACTIONS(2352),
    [anon_sym_join] = ACTIONS(2352),
    [anon_sym_on] = ACTIONS(2352),
    [anon_sym_equals] = ACTIONS(2352),
    [anon_sym_into] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2352),
    [anon_sym_orderby] = ACTIONS(2352),
    [anon_sym_ascending] = ACTIONS(2352),
    [anon_sym_descending] = ACTIONS(2352),
    [anon_sym_group] = ACTIONS(2352),
    [anon_sym_by] = ACTIONS(2352),
    [anon_sym_select] = ACTIONS(2352),
    [anon_sym_DOT_DOT] = ACTIONS(2350),
    [anon_sym___reftype] = ACTIONS(2352),
    [anon_sym___refvalue] = ACTIONS(2352),
    [anon_sym_sizeof] = ACTIONS(2352),
    [anon_sym_typeof] = ACTIONS(2352),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [sym_integer_literal] = ACTIONS(2352),
    [sym_null_literal] = ACTIONS(2352),
    [sym_real_literal] = ACTIONS(2350),
    [sym_verbatim_string_literal] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2352),
    [anon_sym_nameof] = ACTIONS(2352),
    [sym_void_keyword] = ACTIONS(2352),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1584] = {
    [sym__preprocessor_call] = STATE(1584),
    [ts_builtin_sym_end] = ACTIONS(2354),
    [sym__identifier_token] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym_alias] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_global] = ACTIONS(2356),
    [anon_sym_using] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2356),
    [anon_sym_async] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_fixed] = ACTIONS(2356),
    [anon_sym_internal] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_override] = ACTIONS(2356),
    [anon_sym_partial] = ACTIONS(2356),
    [anon_sym_private] = ACTIONS(2356),
    [anon_sym_protected] = ACTIONS(2356),
    [anon_sym_public] = ACTIONS(2356),
    [anon_sym_readonly] = ACTIONS(2356),
    [anon_sym_ref] = ACTIONS(2356),
    [anon_sym_sealed] = ACTIONS(2356),
    [anon_sym_unsafe] = ACTIONS(2356),
    [anon_sym_virtual] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym_this] = ACTIONS(2356),
    [anon_sym_base] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [anon_sym_where] = ACTIONS(2356),
    [anon_sym_class] = ACTIONS(2356),
    [anon_sym_struct] = ACTIONS(2356),
    [anon_sym_notnull] = ACTIONS(2356),
    [anon_sym_unmanaged] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_true] = ACTIONS(2356),
    [anon_sym_false] = ACTIONS(2356),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_CARET] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2356),
    [anon_sym_set] = ACTIONS(2356),
    [anon_sym_add] = ACTIONS(2356),
    [anon_sym_remove] = ACTIONS(2356),
    [anon_sym_enum] = ACTIONS(2356),
    [anon_sym_interface] = ACTIONS(2356),
    [anon_sym_delegate] = ACTIONS(2356),
    [anon_sym_record] = ACTIONS(2356),
    [anon_sym_namespace] = ACTIONS(2356),
    [anon_sym_var] = ACTIONS(2356),
    [sym_predefined_type] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_checked] = ACTIONS(2356),
    [anon_sym_unchecked] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2356),
    [anon_sym_foreach] = ACTIONS(2356),
    [anon_sym_goto] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2356),
    [anon_sym_lock] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_when] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_yield] = ACTIONS(2356),
    [anon_sym_stackalloc] = ACTIONS(2356),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2354),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2354),
    [anon_sym___makeref] = ACTIONS(2356),
    [anon_sym_from] = ACTIONS(2356),
    [anon_sym_join] = ACTIONS(2356),
    [anon_sym_on] = ACTIONS(2356),
    [anon_sym_equals] = ACTIONS(2356),
    [anon_sym_into] = ACTIONS(2356),
    [anon_sym_let] = ACTIONS(2356),
    [anon_sym_orderby] = ACTIONS(2356),
    [anon_sym_ascending] = ACTIONS(2356),
    [anon_sym_descending] = ACTIONS(2356),
    [anon_sym_group] = ACTIONS(2356),
    [anon_sym_by] = ACTIONS(2356),
    [anon_sym_select] = ACTIONS(2356),
    [anon_sym_DOT_DOT] = ACTIONS(2354),
    [anon_sym___reftype] = ACTIONS(2356),
    [anon_sym___refvalue] = ACTIONS(2356),
    [anon_sym_sizeof] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [sym_integer_literal] = ACTIONS(2356),
    [sym_null_literal] = ACTIONS(2356),
    [sym_real_literal] = ACTIONS(2354),
    [sym_verbatim_string_literal] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2356),
    [anon_sym_nameof] = ACTIONS(2356),
    [sym_void_keyword] = ACTIONS(2356),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1585] = {
    [sym__preprocessor_call] = STATE(1585),
    [ts_builtin_sym_end] = ACTIONS(2358),
    [sym__identifier_token] = ACTIONS(2360),
    [anon_sym_extern] = ACTIONS(2360),
    [anon_sym_alias] = ACTIONS(2360),
    [anon_sym_SEMI] = ACTIONS(2358),
    [anon_sym_global] = ACTIONS(2360),
    [anon_sym_using] = ACTIONS(2360),
    [anon_sym_static] = ACTIONS(2360),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_return] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(2358),
    [anon_sym_abstract] = ACTIONS(2360),
    [anon_sym_async] = ACTIONS(2360),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_fixed] = ACTIONS(2360),
    [anon_sym_internal] = ACTIONS(2360),
    [anon_sym_new] = ACTIONS(2360),
    [anon_sym_override] = ACTIONS(2360),
    [anon_sym_partial] = ACTIONS(2360),
    [anon_sym_private] = ACTIONS(2360),
    [anon_sym_protected] = ACTIONS(2360),
    [anon_sym_public] = ACTIONS(2360),
    [anon_sym_readonly] = ACTIONS(2360),
    [anon_sym_ref] = ACTIONS(2360),
    [anon_sym_sealed] = ACTIONS(2360),
    [anon_sym_unsafe] = ACTIONS(2360),
    [anon_sym_virtual] = ACTIONS(2360),
    [anon_sym_volatile] = ACTIONS(2360),
    [anon_sym_this] = ACTIONS(2360),
    [anon_sym_base] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_where] = ACTIONS(2360),
    [anon_sym_class] = ACTIONS(2360),
    [anon_sym_struct] = ACTIONS(2360),
    [anon_sym_notnull] = ACTIONS(2360),
    [anon_sym_unmanaged] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_PLUS_PLUS] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2358),
    [anon_sym_true] = ACTIONS(2360),
    [anon_sym_false] = ACTIONS(2360),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2360),
    [anon_sym_STAR] = ACTIONS(2358),
    [anon_sym_CARET] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2358),
    [anon_sym_get] = ACTIONS(2360),
    [anon_sym_set] = ACTIONS(2360),
    [anon_sym_add] = ACTIONS(2360),
    [anon_sym_remove] = ACTIONS(2360),
    [anon_sym_enum] = ACTIONS(2360),
    [anon_sym_interface] = ACTIONS(2360),
    [anon_sym_delegate] = ACTIONS(2360),
    [anon_sym_record] = ACTIONS(2360),
    [anon_sym_namespace] = ACTIONS(2360),
    [anon_sym_var] = ACTIONS(2360),
    [sym_predefined_type] = ACTIONS(2360),
    [anon_sym_break] = ACTIONS(2360),
    [anon_sym_checked] = ACTIONS(2360),
    [anon_sym_unchecked] = ACTIONS(2360),
    [anon_sym_continue] = ACTIONS(2360),
    [anon_sym_do] = ACTIONS(2360),
    [anon_sym_while] = ACTIONS(2360),
    [anon_sym_for] = ACTIONS(2360),
    [anon_sym_await] = ACTIONS(2360),
    [anon_sym_foreach] = ACTIONS(2360),
    [anon_sym_goto] = ACTIONS(2360),
    [anon_sym_default] = ACTIONS(2360),
    [anon_sym_if] = ACTIONS(2360),
    [anon_sym_else] = ACTIONS(2360),
    [anon_sym_lock] = ACTIONS(2360),
    [anon_sym_switch] = ACTIONS(2360),
    [anon_sym_when] = ACTIONS(2360),
    [anon_sym_throw] = ACTIONS(2360),
    [anon_sym_try] = ACTIONS(2360),
    [anon_sym_yield] = ACTIONS(2360),
    [anon_sym_stackalloc] = ACTIONS(2360),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2358),
    [anon_sym_DQUOTE] = ACTIONS(2358),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2358),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2358),
    [anon_sym___makeref] = ACTIONS(2360),
    [anon_sym_from] = ACTIONS(2360),
    [anon_sym_join] = ACTIONS(2360),
    [anon_sym_on] = ACTIONS(2360),
    [anon_sym_equals] = ACTIONS(2360),
    [anon_sym_into] = ACTIONS(2360),
    [anon_sym_let] = ACTIONS(2360),
    [anon_sym_orderby] = ACTIONS(2360),
    [anon_sym_ascending] = ACTIONS(2360),
    [anon_sym_descending] = ACTIONS(2360),
    [anon_sym_group] = ACTIONS(2360),
    [anon_sym_by] = ACTIONS(2360),
    [anon_sym_select] = ACTIONS(2360),
    [anon_sym_DOT_DOT] = ACTIONS(2358),
    [anon_sym___reftype] = ACTIONS(2360),
    [anon_sym___refvalue] = ACTIONS(2360),
    [anon_sym_sizeof] = ACTIONS(2360),
    [anon_sym_typeof] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [sym_integer_literal] = ACTIONS(2360),
    [sym_null_literal] = ACTIONS(2360),
    [sym_real_literal] = ACTIONS(2358),
    [sym_verbatim_string_literal] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2360),
    [anon_sym_nameof] = ACTIONS(2360),
    [sym_void_keyword] = ACTIONS(2360),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1586] = {
    [sym__preprocessor_call] = STATE(1586),
    [ts_builtin_sym_end] = ACTIONS(2362),
    [sym__identifier_token] = ACTIONS(2364),
    [anon_sym_extern] = ACTIONS(2364),
    [anon_sym_alias] = ACTIONS(2364),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_global] = ACTIONS(2364),
    [anon_sym_using] = ACTIONS(2364),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2364),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_abstract] = ACTIONS(2364),
    [anon_sym_async] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_fixed] = ACTIONS(2364),
    [anon_sym_internal] = ACTIONS(2364),
    [anon_sym_new] = ACTIONS(2364),
    [anon_sym_override] = ACTIONS(2364),
    [anon_sym_partial] = ACTIONS(2364),
    [anon_sym_private] = ACTIONS(2364),
    [anon_sym_protected] = ACTIONS(2364),
    [anon_sym_public] = ACTIONS(2364),
    [anon_sym_readonly] = ACTIONS(2364),
    [anon_sym_ref] = ACTIONS(2364),
    [anon_sym_sealed] = ACTIONS(2364),
    [anon_sym_unsafe] = ACTIONS(2364),
    [anon_sym_virtual] = ACTIONS(2364),
    [anon_sym_volatile] = ACTIONS(2364),
    [anon_sym_this] = ACTIONS(2364),
    [anon_sym_base] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_where] = ACTIONS(2364),
    [anon_sym_class] = ACTIONS(2364),
    [anon_sym_struct] = ACTIONS(2364),
    [anon_sym_notnull] = ACTIONS(2364),
    [anon_sym_unmanaged] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_true] = ACTIONS(2364),
    [anon_sym_false] = ACTIONS(2364),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_STAR] = ACTIONS(2362),
    [anon_sym_CARET] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_get] = ACTIONS(2364),
    [anon_sym_set] = ACTIONS(2364),
    [anon_sym_add] = ACTIONS(2364),
    [anon_sym_remove] = ACTIONS(2364),
    [anon_sym_enum] = ACTIONS(2364),
    [anon_sym_interface] = ACTIONS(2364),
    [anon_sym_delegate] = ACTIONS(2364),
    [anon_sym_record] = ACTIONS(2364),
    [anon_sym_namespace] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2364),
    [sym_predefined_type] = ACTIONS(2364),
    [anon_sym_break] = ACTIONS(2364),
    [anon_sym_checked] = ACTIONS(2364),
    [anon_sym_unchecked] = ACTIONS(2364),
    [anon_sym_continue] = ACTIONS(2364),
    [anon_sym_do] = ACTIONS(2364),
    [anon_sym_while] = ACTIONS(2364),
    [anon_sym_for] = ACTIONS(2364),
    [anon_sym_await] = ACTIONS(2364),
    [anon_sym_foreach] = ACTIONS(2364),
    [anon_sym_goto] = ACTIONS(2364),
    [anon_sym_default] = ACTIONS(2364),
    [anon_sym_if] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_lock] = ACTIONS(2364),
    [anon_sym_switch] = ACTIONS(2364),
    [anon_sym_when] = ACTIONS(2364),
    [anon_sym_throw] = ACTIONS(2364),
    [anon_sym_try] = ACTIONS(2364),
    [anon_sym_yield] = ACTIONS(2364),
    [anon_sym_stackalloc] = ACTIONS(2364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2362),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2362),
    [anon_sym___makeref] = ACTIONS(2364),
    [anon_sym_from] = ACTIONS(2364),
    [anon_sym_join] = ACTIONS(2364),
    [anon_sym_on] = ACTIONS(2364),
    [anon_sym_equals] = ACTIONS(2364),
    [anon_sym_into] = ACTIONS(2364),
    [anon_sym_let] = ACTIONS(2364),
    [anon_sym_orderby] = ACTIONS(2364),
    [anon_sym_ascending] = ACTIONS(2364),
    [anon_sym_descending] = ACTIONS(2364),
    [anon_sym_group] = ACTIONS(2364),
    [anon_sym_by] = ACTIONS(2364),
    [anon_sym_select] = ACTIONS(2364),
    [anon_sym_DOT_DOT] = ACTIONS(2362),
    [anon_sym___reftype] = ACTIONS(2364),
    [anon_sym___refvalue] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym_typeof] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2362),
    [sym_integer_literal] = ACTIONS(2364),
    [sym_null_literal] = ACTIONS(2364),
    [sym_real_literal] = ACTIONS(2362),
    [sym_verbatim_string_literal] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2364),
    [anon_sym_nameof] = ACTIONS(2364),
    [sym_void_keyword] = ACTIONS(2364),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1587] = {
    [sym__preprocessor_call] = STATE(1587),
    [ts_builtin_sym_end] = ACTIONS(2366),
    [sym__identifier_token] = ACTIONS(2368),
    [anon_sym_extern] = ACTIONS(2368),
    [anon_sym_alias] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_global] = ACTIONS(2368),
    [anon_sym_using] = ACTIONS(2368),
    [anon_sym_static] = ACTIONS(2368),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2368),
    [anon_sym_LPAREN] = ACTIONS(2366),
    [anon_sym_abstract] = ACTIONS(2368),
    [anon_sym_async] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2368),
    [anon_sym_fixed] = ACTIONS(2368),
    [anon_sym_internal] = ACTIONS(2368),
    [anon_sym_new] = ACTIONS(2368),
    [anon_sym_override] = ACTIONS(2368),
    [anon_sym_partial] = ACTIONS(2368),
    [anon_sym_private] = ACTIONS(2368),
    [anon_sym_protected] = ACTIONS(2368),
    [anon_sym_public] = ACTIONS(2368),
    [anon_sym_readonly] = ACTIONS(2368),
    [anon_sym_ref] = ACTIONS(2368),
    [anon_sym_sealed] = ACTIONS(2368),
    [anon_sym_unsafe] = ACTIONS(2368),
    [anon_sym_virtual] = ACTIONS(2368),
    [anon_sym_volatile] = ACTIONS(2368),
    [anon_sym_this] = ACTIONS(2368),
    [anon_sym_base] = ACTIONS(2368),
    [anon_sym_LBRACE] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [anon_sym_where] = ACTIONS(2368),
    [anon_sym_class] = ACTIONS(2368),
    [anon_sym_struct] = ACTIONS(2368),
    [anon_sym_notnull] = ACTIONS(2368),
    [anon_sym_unmanaged] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_PLUS_PLUS] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2366),
    [anon_sym_true] = ACTIONS(2368),
    [anon_sym_false] = ACTIONS(2368),
    [anon_sym_PLUS] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2368),
    [anon_sym_STAR] = ACTIONS(2366),
    [anon_sym_CARET] = ACTIONS(2366),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_get] = ACTIONS(2368),
    [anon_sym_set] = ACTIONS(2368),
    [anon_sym_add] = ACTIONS(2368),
    [anon_sym_remove] = ACTIONS(2368),
    [anon_sym_enum] = ACTIONS(2368),
    [anon_sym_interface] = ACTIONS(2368),
    [anon_sym_delegate] = ACTIONS(2368),
    [anon_sym_record] = ACTIONS(2368),
    [anon_sym_namespace] = ACTIONS(2368),
    [anon_sym_var] = ACTIONS(2368),
    [sym_predefined_type] = ACTIONS(2368),
    [anon_sym_break] = ACTIONS(2368),
    [anon_sym_checked] = ACTIONS(2368),
    [anon_sym_unchecked] = ACTIONS(2368),
    [anon_sym_continue] = ACTIONS(2368),
    [anon_sym_do] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_await] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_goto] = ACTIONS(2368),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_lock] = ACTIONS(2368),
    [anon_sym_switch] = ACTIONS(2368),
    [anon_sym_when] = ACTIONS(2368),
    [anon_sym_throw] = ACTIONS(2368),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_yield] = ACTIONS(2368),
    [anon_sym_stackalloc] = ACTIONS(2368),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2366),
    [anon_sym_DQUOTE] = ACTIONS(2366),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2366),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2366),
    [anon_sym___makeref] = ACTIONS(2368),
    [anon_sym_from] = ACTIONS(2368),
    [anon_sym_join] = ACTIONS(2368),
    [anon_sym_on] = ACTIONS(2368),
    [anon_sym_equals] = ACTIONS(2368),
    [anon_sym_into] = ACTIONS(2368),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_orderby] = ACTIONS(2368),
    [anon_sym_ascending] = ACTIONS(2368),
    [anon_sym_descending] = ACTIONS(2368),
    [anon_sym_group] = ACTIONS(2368),
    [anon_sym_by] = ACTIONS(2368),
    [anon_sym_select] = ACTIONS(2368),
    [anon_sym_DOT_DOT] = ACTIONS(2366),
    [anon_sym___reftype] = ACTIONS(2368),
    [anon_sym___refvalue] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2368),
    [anon_sym_typeof] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2366),
    [sym_integer_literal] = ACTIONS(2368),
    [sym_null_literal] = ACTIONS(2368),
    [sym_real_literal] = ACTIONS(2366),
    [sym_verbatim_string_literal] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2368),
    [anon_sym_nameof] = ACTIONS(2368),
    [sym_void_keyword] = ACTIONS(2368),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1588] = {
    [sym__preprocessor_call] = STATE(1588),
    [ts_builtin_sym_end] = ACTIONS(2370),
    [sym__identifier_token] = ACTIONS(2372),
    [anon_sym_extern] = ACTIONS(2372),
    [anon_sym_alias] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2370),
    [anon_sym_global] = ACTIONS(2372),
    [anon_sym_using] = ACTIONS(2372),
    [anon_sym_static] = ACTIONS(2372),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(2370),
    [anon_sym_abstract] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2372),
    [anon_sym_const] = ACTIONS(2372),
    [anon_sym_fixed] = ACTIONS(2372),
    [anon_sym_internal] = ACTIONS(2372),
    [anon_sym_new] = ACTIONS(2372),
    [anon_sym_override] = ACTIONS(2372),
    [anon_sym_partial] = ACTIONS(2372),
    [anon_sym_private] = ACTIONS(2372),
    [anon_sym_protected] = ACTIONS(2372),
    [anon_sym_public] = ACTIONS(2372),
    [anon_sym_readonly] = ACTIONS(2372),
    [anon_sym_ref] = ACTIONS(2372),
    [anon_sym_sealed] = ACTIONS(2372),
    [anon_sym_unsafe] = ACTIONS(2372),
    [anon_sym_virtual] = ACTIONS(2372),
    [anon_sym_volatile] = ACTIONS(2372),
    [anon_sym_this] = ACTIONS(2372),
    [anon_sym_base] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2370),
    [anon_sym_TILDE] = ACTIONS(2370),
    [anon_sym_where] = ACTIONS(2372),
    [anon_sym_class] = ACTIONS(2372),
    [anon_sym_struct] = ACTIONS(2372),
    [anon_sym_notnull] = ACTIONS(2372),
    [anon_sym_unmanaged] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2370),
    [anon_sym_PLUS_PLUS] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2370),
    [anon_sym_true] = ACTIONS(2372),
    [anon_sym_false] = ACTIONS(2372),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2372),
    [anon_sym_STAR] = ACTIONS(2370),
    [anon_sym_CARET] = ACTIONS(2370),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_get] = ACTIONS(2372),
    [anon_sym_set] = ACTIONS(2372),
    [anon_sym_add] = ACTIONS(2372),
    [anon_sym_remove] = ACTIONS(2372),
    [anon_sym_enum] = ACTIONS(2372),
    [anon_sym_interface] = ACTIONS(2372),
    [anon_sym_delegate] = ACTIONS(2372),
    [anon_sym_record] = ACTIONS(2372),
    [anon_sym_namespace] = ACTIONS(2372),
    [anon_sym_var] = ACTIONS(2372),
    [sym_predefined_type] = ACTIONS(2372),
    [anon_sym_break] = ACTIONS(2372),
    [anon_sym_checked] = ACTIONS(2372),
    [anon_sym_unchecked] = ACTIONS(2372),
    [anon_sym_continue] = ACTIONS(2372),
    [anon_sym_do] = ACTIONS(2372),
    [anon_sym_while] = ACTIONS(2372),
    [anon_sym_for] = ACTIONS(2372),
    [anon_sym_await] = ACTIONS(2372),
    [anon_sym_foreach] = ACTIONS(2372),
    [anon_sym_goto] = ACTIONS(2372),
    [anon_sym_default] = ACTIONS(2372),
    [anon_sym_if] = ACTIONS(2372),
    [anon_sym_else] = ACTIONS(2372),
    [anon_sym_lock] = ACTIONS(2372),
    [anon_sym_switch] = ACTIONS(2372),
    [anon_sym_when] = ACTIONS(2372),
    [anon_sym_throw] = ACTIONS(2372),
    [anon_sym_try] = ACTIONS(2372),
    [anon_sym_yield] = ACTIONS(2372),
    [anon_sym_stackalloc] = ACTIONS(2372),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2370),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2370),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2370),
    [anon_sym___makeref] = ACTIONS(2372),
    [anon_sym_from] = ACTIONS(2372),
    [anon_sym_join] = ACTIONS(2372),
    [anon_sym_on] = ACTIONS(2372),
    [anon_sym_equals] = ACTIONS(2372),
    [anon_sym_into] = ACTIONS(2372),
    [anon_sym_let] = ACTIONS(2372),
    [anon_sym_orderby] = ACTIONS(2372),
    [anon_sym_ascending] = ACTIONS(2372),
    [anon_sym_descending] = ACTIONS(2372),
    [anon_sym_group] = ACTIONS(2372),
    [anon_sym_by] = ACTIONS(2372),
    [anon_sym_select] = ACTIONS(2372),
    [anon_sym_DOT_DOT] = ACTIONS(2370),
    [anon_sym___reftype] = ACTIONS(2372),
    [anon_sym___refvalue] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2372),
    [anon_sym_typeof] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [sym_integer_literal] = ACTIONS(2372),
    [sym_null_literal] = ACTIONS(2372),
    [sym_real_literal] = ACTIONS(2370),
    [sym_verbatim_string_literal] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2372),
    [anon_sym_nameof] = ACTIONS(2372),
    [sym_void_keyword] = ACTIONS(2372),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1589] = {
    [sym__preprocessor_call] = STATE(1589),
    [ts_builtin_sym_end] = ACTIONS(2374),
    [sym__identifier_token] = ACTIONS(2376),
    [anon_sym_extern] = ACTIONS(2376),
    [anon_sym_alias] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2374),
    [anon_sym_global] = ACTIONS(2376),
    [anon_sym_using] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2374),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_async] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_fixed] = ACTIONS(2376),
    [anon_sym_internal] = ACTIONS(2376),
    [anon_sym_new] = ACTIONS(2376),
    [anon_sym_override] = ACTIONS(2376),
    [anon_sym_partial] = ACTIONS(2376),
    [anon_sym_private] = ACTIONS(2376),
    [anon_sym_protected] = ACTIONS(2376),
    [anon_sym_public] = ACTIONS(2376),
    [anon_sym_readonly] = ACTIONS(2376),
    [anon_sym_ref] = ACTIONS(2376),
    [anon_sym_sealed] = ACTIONS(2376),
    [anon_sym_unsafe] = ACTIONS(2376),
    [anon_sym_virtual] = ACTIONS(2376),
    [anon_sym_volatile] = ACTIONS(2376),
    [anon_sym_this] = ACTIONS(2376),
    [anon_sym_base] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2374),
    [anon_sym_TILDE] = ACTIONS(2374),
    [anon_sym_where] = ACTIONS(2376),
    [anon_sym_class] = ACTIONS(2376),
    [anon_sym_struct] = ACTIONS(2376),
    [anon_sym_notnull] = ACTIONS(2376),
    [anon_sym_unmanaged] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2374),
    [anon_sym_PLUS_PLUS] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2374),
    [anon_sym_true] = ACTIONS(2376),
    [anon_sym_false] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(2374),
    [anon_sym_CARET] = ACTIONS(2374),
    [anon_sym_AMP] = ACTIONS(2374),
    [anon_sym_get] = ACTIONS(2376),
    [anon_sym_set] = ACTIONS(2376),
    [anon_sym_add] = ACTIONS(2376),
    [anon_sym_remove] = ACTIONS(2376),
    [anon_sym_enum] = ACTIONS(2376),
    [anon_sym_interface] = ACTIONS(2376),
    [anon_sym_delegate] = ACTIONS(2376),
    [anon_sym_record] = ACTIONS(2376),
    [anon_sym_namespace] = ACTIONS(2376),
    [anon_sym_var] = ACTIONS(2376),
    [sym_predefined_type] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_checked] = ACTIONS(2376),
    [anon_sym_unchecked] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_do] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_await] = ACTIONS(2376),
    [anon_sym_foreach] = ACTIONS(2376),
    [anon_sym_goto] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_else] = ACTIONS(2376),
    [anon_sym_lock] = ACTIONS(2376),
    [anon_sym_switch] = ACTIONS(2376),
    [anon_sym_when] = ACTIONS(2376),
    [anon_sym_throw] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_yield] = ACTIONS(2376),
    [anon_sym_stackalloc] = ACTIONS(2376),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2374),
    [anon_sym_DQUOTE] = ACTIONS(2374),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2374),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2374),
    [anon_sym___makeref] = ACTIONS(2376),
    [anon_sym_from] = ACTIONS(2376),
    [anon_sym_join] = ACTIONS(2376),
    [anon_sym_on] = ACTIONS(2376),
    [anon_sym_equals] = ACTIONS(2376),
    [anon_sym_into] = ACTIONS(2376),
    [anon_sym_let] = ACTIONS(2376),
    [anon_sym_orderby] = ACTIONS(2376),
    [anon_sym_ascending] = ACTIONS(2376),
    [anon_sym_descending] = ACTIONS(2376),
    [anon_sym_group] = ACTIONS(2376),
    [anon_sym_by] = ACTIONS(2376),
    [anon_sym_select] = ACTIONS(2376),
    [anon_sym_DOT_DOT] = ACTIONS(2374),
    [anon_sym___reftype] = ACTIONS(2376),
    [anon_sym___refvalue] = ACTIONS(2376),
    [anon_sym_sizeof] = ACTIONS(2376),
    [anon_sym_typeof] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_integer_literal] = ACTIONS(2376),
    [sym_null_literal] = ACTIONS(2376),
    [sym_real_literal] = ACTIONS(2374),
    [sym_verbatim_string_literal] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2376),
    [anon_sym_nameof] = ACTIONS(2376),
    [sym_void_keyword] = ACTIONS(2376),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1590] = {
    [sym__preprocessor_call] = STATE(1590),
    [ts_builtin_sym_end] = ACTIONS(2378),
    [sym__identifier_token] = ACTIONS(2380),
    [anon_sym_extern] = ACTIONS(2380),
    [anon_sym_alias] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_global] = ACTIONS(2380),
    [anon_sym_using] = ACTIONS(2380),
    [anon_sym_static] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_abstract] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2380),
    [anon_sym_const] = ACTIONS(2380),
    [anon_sym_fixed] = ACTIONS(2380),
    [anon_sym_internal] = ACTIONS(2380),
    [anon_sym_new] = ACTIONS(2380),
    [anon_sym_override] = ACTIONS(2380),
    [anon_sym_partial] = ACTIONS(2380),
    [anon_sym_private] = ACTIONS(2380),
    [anon_sym_protected] = ACTIONS(2380),
    [anon_sym_public] = ACTIONS(2380),
    [anon_sym_readonly] = ACTIONS(2380),
    [anon_sym_ref] = ACTIONS(2380),
    [anon_sym_sealed] = ACTIONS(2380),
    [anon_sym_unsafe] = ACTIONS(2380),
    [anon_sym_virtual] = ACTIONS(2380),
    [anon_sym_volatile] = ACTIONS(2380),
    [anon_sym_this] = ACTIONS(2380),
    [anon_sym_base] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [anon_sym_where] = ACTIONS(2380),
    [anon_sym_class] = ACTIONS(2380),
    [anon_sym_struct] = ACTIONS(2380),
    [anon_sym_notnull] = ACTIONS(2380),
    [anon_sym_unmanaged] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [anon_sym_true] = ACTIONS(2380),
    [anon_sym_false] = ACTIONS(2380),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_STAR] = ACTIONS(2378),
    [anon_sym_CARET] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_get] = ACTIONS(2380),
    [anon_sym_set] = ACTIONS(2380),
    [anon_sym_add] = ACTIONS(2380),
    [anon_sym_remove] = ACTIONS(2380),
    [anon_sym_enum] = ACTIONS(2380),
    [anon_sym_interface] = ACTIONS(2380),
    [anon_sym_delegate] = ACTIONS(2380),
    [anon_sym_record] = ACTIONS(2380),
    [anon_sym_namespace] = ACTIONS(2380),
    [anon_sym_var] = ACTIONS(2380),
    [sym_predefined_type] = ACTIONS(2380),
    [anon_sym_break] = ACTIONS(2380),
    [anon_sym_checked] = ACTIONS(2380),
    [anon_sym_unchecked] = ACTIONS(2380),
    [anon_sym_continue] = ACTIONS(2380),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_while] = ACTIONS(2380),
    [anon_sym_for] = ACTIONS(2380),
    [anon_sym_await] = ACTIONS(2380),
    [anon_sym_foreach] = ACTIONS(2380),
    [anon_sym_goto] = ACTIONS(2380),
    [anon_sym_default] = ACTIONS(2380),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_lock] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2380),
    [anon_sym_when] = ACTIONS(2380),
    [anon_sym_throw] = ACTIONS(2380),
    [anon_sym_try] = ACTIONS(2380),
    [anon_sym_yield] = ACTIONS(2380),
    [anon_sym_stackalloc] = ACTIONS(2380),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2378),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2378),
    [anon_sym___makeref] = ACTIONS(2380),
    [anon_sym_from] = ACTIONS(2380),
    [anon_sym_join] = ACTIONS(2380),
    [anon_sym_on] = ACTIONS(2380),
    [anon_sym_equals] = ACTIONS(2380),
    [anon_sym_into] = ACTIONS(2380),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_orderby] = ACTIONS(2380),
    [anon_sym_ascending] = ACTIONS(2380),
    [anon_sym_descending] = ACTIONS(2380),
    [anon_sym_group] = ACTIONS(2380),
    [anon_sym_by] = ACTIONS(2380),
    [anon_sym_select] = ACTIONS(2380),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym___reftype] = ACTIONS(2380),
    [anon_sym___refvalue] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2380),
    [anon_sym_typeof] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [sym_integer_literal] = ACTIONS(2380),
    [sym_null_literal] = ACTIONS(2380),
    [sym_real_literal] = ACTIONS(2378),
    [sym_verbatim_string_literal] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2380),
    [anon_sym_nameof] = ACTIONS(2380),
    [sym_void_keyword] = ACTIONS(2380),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1591] = {
    [sym__preprocessor_call] = STATE(1591),
    [ts_builtin_sym_end] = ACTIONS(2382),
    [sym__identifier_token] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym_alias] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2382),
    [anon_sym_global] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_abstract] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_fixed] = ACTIONS(2384),
    [anon_sym_internal] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_override] = ACTIONS(2384),
    [anon_sym_partial] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_readonly] = ACTIONS(2384),
    [anon_sym_ref] = ACTIONS(2384),
    [anon_sym_sealed] = ACTIONS(2384),
    [anon_sym_unsafe] = ACTIONS(2384),
    [anon_sym_virtual] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_this] = ACTIONS(2384),
    [anon_sym_base] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_TILDE] = ACTIONS(2382),
    [anon_sym_where] = ACTIONS(2384),
    [anon_sym_class] = ACTIONS(2384),
    [anon_sym_struct] = ACTIONS(2384),
    [anon_sym_notnull] = ACTIONS(2384),
    [anon_sym_unmanaged] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_PLUS_PLUS] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2382),
    [anon_sym_true] = ACTIONS(2384),
    [anon_sym_false] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2382),
    [anon_sym_CARET] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_get] = ACTIONS(2384),
    [anon_sym_set] = ACTIONS(2384),
    [anon_sym_add] = ACTIONS(2384),
    [anon_sym_remove] = ACTIONS(2384),
    [anon_sym_enum] = ACTIONS(2384),
    [anon_sym_interface] = ACTIONS(2384),
    [anon_sym_delegate] = ACTIONS(2384),
    [anon_sym_record] = ACTIONS(2384),
    [anon_sym_namespace] = ACTIONS(2384),
    [anon_sym_var] = ACTIONS(2384),
    [sym_predefined_type] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_checked] = ACTIONS(2384),
    [anon_sym_unchecked] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_await] = ACTIONS(2384),
    [anon_sym_foreach] = ACTIONS(2384),
    [anon_sym_goto] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_else] = ACTIONS(2384),
    [anon_sym_lock] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_when] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_yield] = ACTIONS(2384),
    [anon_sym_stackalloc] = ACTIONS(2384),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2382),
    [anon_sym_DQUOTE] = ACTIONS(2382),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2382),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2382),
    [anon_sym___makeref] = ACTIONS(2384),
    [anon_sym_from] = ACTIONS(2384),
    [anon_sym_join] = ACTIONS(2384),
    [anon_sym_on] = ACTIONS(2384),
    [anon_sym_equals] = ACTIONS(2384),
    [anon_sym_into] = ACTIONS(2384),
    [anon_sym_let] = ACTIONS(2384),
    [anon_sym_orderby] = ACTIONS(2384),
    [anon_sym_ascending] = ACTIONS(2384),
    [anon_sym_descending] = ACTIONS(2384),
    [anon_sym_group] = ACTIONS(2384),
    [anon_sym_by] = ACTIONS(2384),
    [anon_sym_select] = ACTIONS(2384),
    [anon_sym_DOT_DOT] = ACTIONS(2382),
    [anon_sym___reftype] = ACTIONS(2384),
    [anon_sym___refvalue] = ACTIONS(2384),
    [anon_sym_sizeof] = ACTIONS(2384),
    [anon_sym_typeof] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2382),
    [sym_integer_literal] = ACTIONS(2384),
    [sym_null_literal] = ACTIONS(2384),
    [sym_real_literal] = ACTIONS(2382),
    [sym_verbatim_string_literal] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2384),
    [anon_sym_nameof] = ACTIONS(2384),
    [sym_void_keyword] = ACTIONS(2384),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1592] = {
    [sym__preprocessor_call] = STATE(1592),
    [ts_builtin_sym_end] = ACTIONS(2386),
    [sym__identifier_token] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym_alias] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym_global] = ACTIONS(2388),
    [anon_sym_using] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2386),
    [anon_sym_abstract] = ACTIONS(2388),
    [anon_sym_async] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_fixed] = ACTIONS(2388),
    [anon_sym_internal] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2388),
    [anon_sym_override] = ACTIONS(2388),
    [anon_sym_partial] = ACTIONS(2388),
    [anon_sym_private] = ACTIONS(2388),
    [anon_sym_protected] = ACTIONS(2388),
    [anon_sym_public] = ACTIONS(2388),
    [anon_sym_readonly] = ACTIONS(2388),
    [anon_sym_ref] = ACTIONS(2388),
    [anon_sym_sealed] = ACTIONS(2388),
    [anon_sym_unsafe] = ACTIONS(2388),
    [anon_sym_virtual] = ACTIONS(2388),
    [anon_sym_volatile] = ACTIONS(2388),
    [anon_sym_this] = ACTIONS(2388),
    [anon_sym_base] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_where] = ACTIONS(2388),
    [anon_sym_class] = ACTIONS(2388),
    [anon_sym_struct] = ACTIONS(2388),
    [anon_sym_notnull] = ACTIONS(2388),
    [anon_sym_unmanaged] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_true] = ACTIONS(2388),
    [anon_sym_false] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_CARET] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_get] = ACTIONS(2388),
    [anon_sym_set] = ACTIONS(2388),
    [anon_sym_add] = ACTIONS(2388),
    [anon_sym_remove] = ACTIONS(2388),
    [anon_sym_enum] = ACTIONS(2388),
    [anon_sym_interface] = ACTIONS(2388),
    [anon_sym_delegate] = ACTIONS(2388),
    [anon_sym_record] = ACTIONS(2388),
    [anon_sym_namespace] = ACTIONS(2388),
    [anon_sym_var] = ACTIONS(2388),
    [sym_predefined_type] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_checked] = ACTIONS(2388),
    [anon_sym_unchecked] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_await] = ACTIONS(2388),
    [anon_sym_foreach] = ACTIONS(2388),
    [anon_sym_goto] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_else] = ACTIONS(2388),
    [anon_sym_lock] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2388),
    [anon_sym_when] = ACTIONS(2388),
    [anon_sym_throw] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [anon_sym_yield] = ACTIONS(2388),
    [anon_sym_stackalloc] = ACTIONS(2388),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2386),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2386),
    [anon_sym___makeref] = ACTIONS(2388),
    [anon_sym_from] = ACTIONS(2388),
    [anon_sym_join] = ACTIONS(2388),
    [anon_sym_on] = ACTIONS(2388),
    [anon_sym_equals] = ACTIONS(2388),
    [anon_sym_into] = ACTIONS(2388),
    [anon_sym_let] = ACTIONS(2388),
    [anon_sym_orderby] = ACTIONS(2388),
    [anon_sym_ascending] = ACTIONS(2388),
    [anon_sym_descending] = ACTIONS(2388),
    [anon_sym_group] = ACTIONS(2388),
    [anon_sym_by] = ACTIONS(2388),
    [anon_sym_select] = ACTIONS(2388),
    [anon_sym_DOT_DOT] = ACTIONS(2386),
    [anon_sym___reftype] = ACTIONS(2388),
    [anon_sym___refvalue] = ACTIONS(2388),
    [anon_sym_sizeof] = ACTIONS(2388),
    [anon_sym_typeof] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [sym_integer_literal] = ACTIONS(2388),
    [sym_null_literal] = ACTIONS(2388),
    [sym_real_literal] = ACTIONS(2386),
    [sym_verbatim_string_literal] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2388),
    [anon_sym_nameof] = ACTIONS(2388),
    [sym_void_keyword] = ACTIONS(2388),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1593] = {
    [sym__preprocessor_call] = STATE(1593),
    [ts_builtin_sym_end] = ACTIONS(2390),
    [sym__identifier_token] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym_alias] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2392),
    [anon_sym_using] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2390),
    [anon_sym_abstract] = ACTIONS(2392),
    [anon_sym_async] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_fixed] = ACTIONS(2392),
    [anon_sym_internal] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_override] = ACTIONS(2392),
    [anon_sym_partial] = ACTIONS(2392),
    [anon_sym_private] = ACTIONS(2392),
    [anon_sym_protected] = ACTIONS(2392),
    [anon_sym_public] = ACTIONS(2392),
    [anon_sym_readonly] = ACTIONS(2392),
    [anon_sym_ref] = ACTIONS(2392),
    [anon_sym_sealed] = ACTIONS(2392),
    [anon_sym_unsafe] = ACTIONS(2392),
    [anon_sym_virtual] = ACTIONS(2392),
    [anon_sym_volatile] = ACTIONS(2392),
    [anon_sym_this] = ACTIONS(2392),
    [anon_sym_base] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_where] = ACTIONS(2392),
    [anon_sym_class] = ACTIONS(2392),
    [anon_sym_struct] = ACTIONS(2392),
    [anon_sym_notnull] = ACTIONS(2392),
    [anon_sym_unmanaged] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2390),
    [anon_sym_true] = ACTIONS(2392),
    [anon_sym_false] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_CARET] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_get] = ACTIONS(2392),
    [anon_sym_set] = ACTIONS(2392),
    [anon_sym_add] = ACTIONS(2392),
    [anon_sym_remove] = ACTIONS(2392),
    [anon_sym_enum] = ACTIONS(2392),
    [anon_sym_interface] = ACTIONS(2392),
    [anon_sym_delegate] = ACTIONS(2392),
    [anon_sym_record] = ACTIONS(2392),
    [anon_sym_namespace] = ACTIONS(2392),
    [anon_sym_var] = ACTIONS(2392),
    [sym_predefined_type] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_checked] = ACTIONS(2392),
    [anon_sym_unchecked] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_do] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_await] = ACTIONS(2392),
    [anon_sym_foreach] = ACTIONS(2392),
    [anon_sym_goto] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_else] = ACTIONS(2392),
    [anon_sym_lock] = ACTIONS(2392),
    [anon_sym_switch] = ACTIONS(2392),
    [anon_sym_when] = ACTIONS(2392),
    [anon_sym_throw] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [anon_sym_yield] = ACTIONS(2392),
    [anon_sym_stackalloc] = ACTIONS(2392),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2390),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2390),
    [anon_sym___makeref] = ACTIONS(2392),
    [anon_sym_from] = ACTIONS(2392),
    [anon_sym_join] = ACTIONS(2392),
    [anon_sym_on] = ACTIONS(2392),
    [anon_sym_equals] = ACTIONS(2392),
    [anon_sym_into] = ACTIONS(2392),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_orderby] = ACTIONS(2392),
    [anon_sym_ascending] = ACTIONS(2392),
    [anon_sym_descending] = ACTIONS(2392),
    [anon_sym_group] = ACTIONS(2392),
    [anon_sym_by] = ACTIONS(2392),
    [anon_sym_select] = ACTIONS(2392),
    [anon_sym_DOT_DOT] = ACTIONS(2390),
    [anon_sym___reftype] = ACTIONS(2392),
    [anon_sym___refvalue] = ACTIONS(2392),
    [anon_sym_sizeof] = ACTIONS(2392),
    [anon_sym_typeof] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [sym_integer_literal] = ACTIONS(2392),
    [sym_null_literal] = ACTIONS(2392),
    [sym_real_literal] = ACTIONS(2390),
    [sym_verbatim_string_literal] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2392),
    [anon_sym_nameof] = ACTIONS(2392),
    [sym_void_keyword] = ACTIONS(2392),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1594] = {
    [sym__preprocessor_call] = STATE(1594),
    [ts_builtin_sym_end] = ACTIONS(2394),
    [sym__identifier_token] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym_alias] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_global] = ACTIONS(2396),
    [anon_sym_using] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_abstract] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_fixed] = ACTIONS(2396),
    [anon_sym_internal] = ACTIONS(2396),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_override] = ACTIONS(2396),
    [anon_sym_partial] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_readonly] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_sealed] = ACTIONS(2396),
    [anon_sym_unsafe] = ACTIONS(2396),
    [anon_sym_virtual] = ACTIONS(2396),
    [anon_sym_volatile] = ACTIONS(2396),
    [anon_sym_this] = ACTIONS(2396),
    [anon_sym_base] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_where] = ACTIONS(2396),
    [anon_sym_class] = ACTIONS(2396),
    [anon_sym_struct] = ACTIONS(2396),
    [anon_sym_notnull] = ACTIONS(2396),
    [anon_sym_unmanaged] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_true] = ACTIONS(2396),
    [anon_sym_false] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_CARET] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_get] = ACTIONS(2396),
    [anon_sym_set] = ACTIONS(2396),
    [anon_sym_add] = ACTIONS(2396),
    [anon_sym_remove] = ACTIONS(2396),
    [anon_sym_enum] = ACTIONS(2396),
    [anon_sym_interface] = ACTIONS(2396),
    [anon_sym_delegate] = ACTIONS(2396),
    [anon_sym_record] = ACTIONS(2396),
    [anon_sym_namespace] = ACTIONS(2396),
    [anon_sym_var] = ACTIONS(2396),
    [sym_predefined_type] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_checked] = ACTIONS(2396),
    [anon_sym_unchecked] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_await] = ACTIONS(2396),
    [anon_sym_foreach] = ACTIONS(2396),
    [anon_sym_goto] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_else] = ACTIONS(2398),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_when] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_yield] = ACTIONS(2396),
    [anon_sym_stackalloc] = ACTIONS(2396),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2394),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2394),
    [anon_sym___makeref] = ACTIONS(2396),
    [anon_sym_from] = ACTIONS(2396),
    [anon_sym_join] = ACTIONS(2396),
    [anon_sym_on] = ACTIONS(2396),
    [anon_sym_equals] = ACTIONS(2396),
    [anon_sym_into] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_orderby] = ACTIONS(2396),
    [anon_sym_ascending] = ACTIONS(2396),
    [anon_sym_descending] = ACTIONS(2396),
    [anon_sym_group] = ACTIONS(2396),
    [anon_sym_by] = ACTIONS(2396),
    [anon_sym_select] = ACTIONS(2396),
    [anon_sym_DOT_DOT] = ACTIONS(2394),
    [anon_sym___reftype] = ACTIONS(2396),
    [anon_sym___refvalue] = ACTIONS(2396),
    [anon_sym_sizeof] = ACTIONS(2396),
    [anon_sym_typeof] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [sym_integer_literal] = ACTIONS(2396),
    [sym_null_literal] = ACTIONS(2396),
    [sym_real_literal] = ACTIONS(2394),
    [sym_verbatim_string_literal] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2396),
    [anon_sym_nameof] = ACTIONS(2396),
    [sym_void_keyword] = ACTIONS(2396),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1595] = {
    [sym__preprocessor_call] = STATE(1595),
    [ts_builtin_sym_end] = ACTIONS(2400),
    [sym__identifier_token] = ACTIONS(2402),
    [anon_sym_extern] = ACTIONS(2402),
    [anon_sym_alias] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_global] = ACTIONS(2402),
    [anon_sym_using] = ACTIONS(2402),
    [anon_sym_static] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_abstract] = ACTIONS(2402),
    [anon_sym_async] = ACTIONS(2402),
    [anon_sym_const] = ACTIONS(2402),
    [anon_sym_fixed] = ACTIONS(2402),
    [anon_sym_internal] = ACTIONS(2402),
    [anon_sym_new] = ACTIONS(2402),
    [anon_sym_override] = ACTIONS(2402),
    [anon_sym_partial] = ACTIONS(2402),
    [anon_sym_private] = ACTIONS(2402),
    [anon_sym_protected] = ACTIONS(2402),
    [anon_sym_public] = ACTIONS(2402),
    [anon_sym_readonly] = ACTIONS(2402),
    [anon_sym_ref] = ACTIONS(2402),
    [anon_sym_sealed] = ACTIONS(2402),
    [anon_sym_unsafe] = ACTIONS(2402),
    [anon_sym_virtual] = ACTIONS(2402),
    [anon_sym_volatile] = ACTIONS(2402),
    [anon_sym_this] = ACTIONS(2402),
    [anon_sym_base] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2400),
    [anon_sym_where] = ACTIONS(2402),
    [anon_sym_class] = ACTIONS(2402),
    [anon_sym_struct] = ACTIONS(2402),
    [anon_sym_notnull] = ACTIONS(2402),
    [anon_sym_unmanaged] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_true] = ACTIONS(2402),
    [anon_sym_false] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_CARET] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_get] = ACTIONS(2402),
    [anon_sym_set] = ACTIONS(2402),
    [anon_sym_add] = ACTIONS(2402),
    [anon_sym_remove] = ACTIONS(2402),
    [anon_sym_enum] = ACTIONS(2402),
    [anon_sym_interface] = ACTIONS(2402),
    [anon_sym_delegate] = ACTIONS(2402),
    [anon_sym_record] = ACTIONS(2402),
    [anon_sym_namespace] = ACTIONS(2402),
    [anon_sym_var] = ACTIONS(2402),
    [sym_predefined_type] = ACTIONS(2402),
    [anon_sym_break] = ACTIONS(2402),
    [anon_sym_checked] = ACTIONS(2402),
    [anon_sym_unchecked] = ACTIONS(2402),
    [anon_sym_continue] = ACTIONS(2402),
    [anon_sym_do] = ACTIONS(2402),
    [anon_sym_while] = ACTIONS(2402),
    [anon_sym_for] = ACTIONS(2402),
    [anon_sym_await] = ACTIONS(2402),
    [anon_sym_foreach] = ACTIONS(2402),
    [anon_sym_goto] = ACTIONS(2402),
    [anon_sym_default] = ACTIONS(2402),
    [anon_sym_if] = ACTIONS(2402),
    [anon_sym_else] = ACTIONS(2402),
    [anon_sym_lock] = ACTIONS(2402),
    [anon_sym_switch] = ACTIONS(2402),
    [anon_sym_when] = ACTIONS(2402),
    [anon_sym_throw] = ACTIONS(2402),
    [anon_sym_try] = ACTIONS(2402),
    [anon_sym_yield] = ACTIONS(2402),
    [anon_sym_stackalloc] = ACTIONS(2402),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2400),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2400),
    [anon_sym___makeref] = ACTIONS(2402),
    [anon_sym_from] = ACTIONS(2402),
    [anon_sym_join] = ACTIONS(2402),
    [anon_sym_on] = ACTIONS(2402),
    [anon_sym_equals] = ACTIONS(2402),
    [anon_sym_into] = ACTIONS(2402),
    [anon_sym_let] = ACTIONS(2402),
    [anon_sym_orderby] = ACTIONS(2402),
    [anon_sym_ascending] = ACTIONS(2402),
    [anon_sym_descending] = ACTIONS(2402),
    [anon_sym_group] = ACTIONS(2402),
    [anon_sym_by] = ACTIONS(2402),
    [anon_sym_select] = ACTIONS(2402),
    [anon_sym_DOT_DOT] = ACTIONS(2400),
    [anon_sym___reftype] = ACTIONS(2402),
    [anon_sym___refvalue] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2402),
    [anon_sym_typeof] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [sym_integer_literal] = ACTIONS(2402),
    [sym_null_literal] = ACTIONS(2402),
    [sym_real_literal] = ACTIONS(2400),
    [sym_verbatim_string_literal] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2402),
    [anon_sym_nameof] = ACTIONS(2402),
    [sym_void_keyword] = ACTIONS(2402),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1596] = {
    [sym__preprocessor_call] = STATE(1596),
    [ts_builtin_sym_end] = ACTIONS(2404),
    [sym__identifier_token] = ACTIONS(2406),
    [anon_sym_extern] = ACTIONS(2406),
    [anon_sym_alias] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_global] = ACTIONS(2406),
    [anon_sym_using] = ACTIONS(2406),
    [anon_sym_static] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2406),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_abstract] = ACTIONS(2406),
    [anon_sym_async] = ACTIONS(2406),
    [anon_sym_const] = ACTIONS(2406),
    [anon_sym_fixed] = ACTIONS(2406),
    [anon_sym_internal] = ACTIONS(2406),
    [anon_sym_new] = ACTIONS(2406),
    [anon_sym_override] = ACTIONS(2406),
    [anon_sym_partial] = ACTIONS(2406),
    [anon_sym_private] = ACTIONS(2406),
    [anon_sym_protected] = ACTIONS(2406),
    [anon_sym_public] = ACTIONS(2406),
    [anon_sym_readonly] = ACTIONS(2406),
    [anon_sym_ref] = ACTIONS(2406),
    [anon_sym_sealed] = ACTIONS(2406),
    [anon_sym_unsafe] = ACTIONS(2406),
    [anon_sym_virtual] = ACTIONS(2406),
    [anon_sym_volatile] = ACTIONS(2406),
    [anon_sym_this] = ACTIONS(2406),
    [anon_sym_base] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_TILDE] = ACTIONS(2404),
    [anon_sym_where] = ACTIONS(2406),
    [anon_sym_class] = ACTIONS(2406),
    [anon_sym_struct] = ACTIONS(2406),
    [anon_sym_notnull] = ACTIONS(2406),
    [anon_sym_unmanaged] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2404),
    [anon_sym_true] = ACTIONS(2406),
    [anon_sym_false] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_STAR] = ACTIONS(2404),
    [anon_sym_CARET] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2406),
    [anon_sym_set] = ACTIONS(2406),
    [anon_sym_add] = ACTIONS(2406),
    [anon_sym_remove] = ACTIONS(2406),
    [anon_sym_enum] = ACTIONS(2406),
    [anon_sym_interface] = ACTIONS(2406),
    [anon_sym_delegate] = ACTIONS(2406),
    [anon_sym_record] = ACTIONS(2406),
    [anon_sym_namespace] = ACTIONS(2406),
    [anon_sym_var] = ACTIONS(2406),
    [sym_predefined_type] = ACTIONS(2406),
    [anon_sym_break] = ACTIONS(2406),
    [anon_sym_checked] = ACTIONS(2406),
    [anon_sym_unchecked] = ACTIONS(2406),
    [anon_sym_continue] = ACTIONS(2406),
    [anon_sym_do] = ACTIONS(2406),
    [anon_sym_while] = ACTIONS(2406),
    [anon_sym_for] = ACTIONS(2406),
    [anon_sym_await] = ACTIONS(2406),
    [anon_sym_foreach] = ACTIONS(2406),
    [anon_sym_goto] = ACTIONS(2406),
    [anon_sym_default] = ACTIONS(2406),
    [anon_sym_if] = ACTIONS(2406),
    [anon_sym_else] = ACTIONS(2406),
    [anon_sym_lock] = ACTIONS(2406),
    [anon_sym_switch] = ACTIONS(2406),
    [anon_sym_when] = ACTIONS(2406),
    [anon_sym_throw] = ACTIONS(2406),
    [anon_sym_try] = ACTIONS(2406),
    [anon_sym_yield] = ACTIONS(2406),
    [anon_sym_stackalloc] = ACTIONS(2406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2404),
    [anon_sym_DQUOTE] = ACTIONS(2404),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2404),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2404),
    [anon_sym___makeref] = ACTIONS(2406),
    [anon_sym_from] = ACTIONS(2406),
    [anon_sym_join] = ACTIONS(2406),
    [anon_sym_on] = ACTIONS(2406),
    [anon_sym_equals] = ACTIONS(2406),
    [anon_sym_into] = ACTIONS(2406),
    [anon_sym_let] = ACTIONS(2406),
    [anon_sym_orderby] = ACTIONS(2406),
    [anon_sym_ascending] = ACTIONS(2406),
    [anon_sym_descending] = ACTIONS(2406),
    [anon_sym_group] = ACTIONS(2406),
    [anon_sym_by] = ACTIONS(2406),
    [anon_sym_select] = ACTIONS(2406),
    [anon_sym_DOT_DOT] = ACTIONS(2404),
    [anon_sym___reftype] = ACTIONS(2406),
    [anon_sym___refvalue] = ACTIONS(2406),
    [anon_sym_sizeof] = ACTIONS(2406),
    [anon_sym_typeof] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2404),
    [sym_integer_literal] = ACTIONS(2406),
    [sym_null_literal] = ACTIONS(2406),
    [sym_real_literal] = ACTIONS(2404),
    [sym_verbatim_string_literal] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2406),
    [anon_sym_nameof] = ACTIONS(2406),
    [sym_void_keyword] = ACTIONS(2406),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1597] = {
    [sym__preprocessor_call] = STATE(1597),
    [ts_builtin_sym_end] = ACTIONS(2408),
    [sym__identifier_token] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym_alias] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_global] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_LPAREN] = ACTIONS(2408),
    [anon_sym_abstract] = ACTIONS(2410),
    [anon_sym_async] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_fixed] = ACTIONS(2410),
    [anon_sym_internal] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_partial] = ACTIONS(2410),
    [anon_sym_private] = ACTIONS(2410),
    [anon_sym_protected] = ACTIONS(2410),
    [anon_sym_public] = ACTIONS(2410),
    [anon_sym_readonly] = ACTIONS(2410),
    [anon_sym_ref] = ACTIONS(2410),
    [anon_sym_sealed] = ACTIONS(2410),
    [anon_sym_unsafe] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_this] = ACTIONS(2410),
    [anon_sym_base] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_where] = ACTIONS(2410),
    [anon_sym_class] = ACTIONS(2410),
    [anon_sym_struct] = ACTIONS(2410),
    [anon_sym_notnull] = ACTIONS(2410),
    [anon_sym_unmanaged] = ACTIONS(2410),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_true] = ACTIONS(2410),
    [anon_sym_false] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_CARET] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2408),
    [anon_sym_get] = ACTIONS(2410),
    [anon_sym_set] = ACTIONS(2410),
    [anon_sym_add] = ACTIONS(2410),
    [anon_sym_remove] = ACTIONS(2410),
    [anon_sym_enum] = ACTIONS(2410),
    [anon_sym_interface] = ACTIONS(2410),
    [anon_sym_delegate] = ACTIONS(2410),
    [anon_sym_record] = ACTIONS(2410),
    [anon_sym_namespace] = ACTIONS(2410),
    [anon_sym_var] = ACTIONS(2410),
    [sym_predefined_type] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_checked] = ACTIONS(2410),
    [anon_sym_unchecked] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_await] = ACTIONS(2410),
    [anon_sym_foreach] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_lock] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_when] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_yield] = ACTIONS(2410),
    [anon_sym_stackalloc] = ACTIONS(2410),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2408),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2408),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2408),
    [anon_sym___makeref] = ACTIONS(2410),
    [anon_sym_from] = ACTIONS(2410),
    [anon_sym_join] = ACTIONS(2410),
    [anon_sym_on] = ACTIONS(2410),
    [anon_sym_equals] = ACTIONS(2410),
    [anon_sym_into] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_orderby] = ACTIONS(2410),
    [anon_sym_ascending] = ACTIONS(2410),
    [anon_sym_descending] = ACTIONS(2410),
    [anon_sym_group] = ACTIONS(2410),
    [anon_sym_by] = ACTIONS(2410),
    [anon_sym_select] = ACTIONS(2410),
    [anon_sym_DOT_DOT] = ACTIONS(2408),
    [anon_sym___reftype] = ACTIONS(2410),
    [anon_sym___refvalue] = ACTIONS(2410),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym_typeof] = ACTIONS(2410),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [sym_integer_literal] = ACTIONS(2410),
    [sym_null_literal] = ACTIONS(2410),
    [sym_real_literal] = ACTIONS(2408),
    [sym_verbatim_string_literal] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2410),
    [anon_sym_nameof] = ACTIONS(2410),
    [sym_void_keyword] = ACTIONS(2410),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1598] = {
    [sym__preprocessor_call] = STATE(1598),
    [ts_builtin_sym_end] = ACTIONS(2412),
    [sym__identifier_token] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym_alias] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_global] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_abstract] = ACTIONS(2414),
    [anon_sym_async] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_fixed] = ACTIONS(2414),
    [anon_sym_internal] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_override] = ACTIONS(2414),
    [anon_sym_partial] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_readonly] = ACTIONS(2414),
    [anon_sym_ref] = ACTIONS(2414),
    [anon_sym_sealed] = ACTIONS(2414),
    [anon_sym_unsafe] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_this] = ACTIONS(2414),
    [anon_sym_base] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_where] = ACTIONS(2414),
    [anon_sym_class] = ACTIONS(2414),
    [anon_sym_struct] = ACTIONS(2414),
    [anon_sym_notnull] = ACTIONS(2414),
    [anon_sym_unmanaged] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_true] = ACTIONS(2414),
    [anon_sym_false] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_CARET] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_get] = ACTIONS(2414),
    [anon_sym_set] = ACTIONS(2414),
    [anon_sym_add] = ACTIONS(2414),
    [anon_sym_remove] = ACTIONS(2414),
    [anon_sym_enum] = ACTIONS(2414),
    [anon_sym_interface] = ACTIONS(2414),
    [anon_sym_delegate] = ACTIONS(2414),
    [anon_sym_record] = ACTIONS(2414),
    [anon_sym_namespace] = ACTIONS(2414),
    [anon_sym_var] = ACTIONS(2414),
    [sym_predefined_type] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_checked] = ACTIONS(2414),
    [anon_sym_unchecked] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_await] = ACTIONS(2414),
    [anon_sym_foreach] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_lock] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_when] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_yield] = ACTIONS(2414),
    [anon_sym_stackalloc] = ACTIONS(2414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2412),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2412),
    [anon_sym___makeref] = ACTIONS(2414),
    [anon_sym_from] = ACTIONS(2414),
    [anon_sym_join] = ACTIONS(2414),
    [anon_sym_on] = ACTIONS(2414),
    [anon_sym_equals] = ACTIONS(2414),
    [anon_sym_into] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_orderby] = ACTIONS(2414),
    [anon_sym_ascending] = ACTIONS(2414),
    [anon_sym_descending] = ACTIONS(2414),
    [anon_sym_group] = ACTIONS(2414),
    [anon_sym_by] = ACTIONS(2414),
    [anon_sym_select] = ACTIONS(2414),
    [anon_sym_DOT_DOT] = ACTIONS(2412),
    [anon_sym___reftype] = ACTIONS(2414),
    [anon_sym___refvalue] = ACTIONS(2414),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym_typeof] = ACTIONS(2414),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [sym_integer_literal] = ACTIONS(2414),
    [sym_null_literal] = ACTIONS(2414),
    [sym_real_literal] = ACTIONS(2412),
    [sym_verbatim_string_literal] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2414),
    [anon_sym_nameof] = ACTIONS(2414),
    [sym_void_keyword] = ACTIONS(2414),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1599] = {
    [sym__preprocessor_call] = STATE(1599),
    [ts_builtin_sym_end] = ACTIONS(2416),
    [sym__identifier_token] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym_alias] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_global] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_abstract] = ACTIONS(2418),
    [anon_sym_async] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_fixed] = ACTIONS(2418),
    [anon_sym_internal] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [anon_sym_partial] = ACTIONS(2418),
    [anon_sym_private] = ACTIONS(2418),
    [anon_sym_protected] = ACTIONS(2418),
    [anon_sym_public] = ACTIONS(2418),
    [anon_sym_readonly] = ACTIONS(2418),
    [anon_sym_ref] = ACTIONS(2418),
    [anon_sym_sealed] = ACTIONS(2418),
    [anon_sym_unsafe] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_this] = ACTIONS(2418),
    [anon_sym_base] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_where] = ACTIONS(2418),
    [anon_sym_class] = ACTIONS(2418),
    [anon_sym_struct] = ACTIONS(2418),
    [anon_sym_notnull] = ACTIONS(2418),
    [anon_sym_unmanaged] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_true] = ACTIONS(2418),
    [anon_sym_false] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_get] = ACTIONS(2418),
    [anon_sym_set] = ACTIONS(2418),
    [anon_sym_add] = ACTIONS(2418),
    [anon_sym_remove] = ACTIONS(2418),
    [anon_sym_enum] = ACTIONS(2418),
    [anon_sym_interface] = ACTIONS(2418),
    [anon_sym_delegate] = ACTIONS(2418),
    [anon_sym_record] = ACTIONS(2418),
    [anon_sym_namespace] = ACTIONS(2418),
    [anon_sym_var] = ACTIONS(2418),
    [sym_predefined_type] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_checked] = ACTIONS(2418),
    [anon_sym_unchecked] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_await] = ACTIONS(2418),
    [anon_sym_foreach] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2418),
    [anon_sym_lock] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_when] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_stackalloc] = ACTIONS(2418),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2416),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2416),
    [anon_sym___makeref] = ACTIONS(2418),
    [anon_sym_from] = ACTIONS(2418),
    [anon_sym_join] = ACTIONS(2418),
    [anon_sym_on] = ACTIONS(2418),
    [anon_sym_equals] = ACTIONS(2418),
    [anon_sym_into] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_orderby] = ACTIONS(2418),
    [anon_sym_ascending] = ACTIONS(2418),
    [anon_sym_descending] = ACTIONS(2418),
    [anon_sym_group] = ACTIONS(2418),
    [anon_sym_by] = ACTIONS(2418),
    [anon_sym_select] = ACTIONS(2418),
    [anon_sym_DOT_DOT] = ACTIONS(2416),
    [anon_sym___reftype] = ACTIONS(2418),
    [anon_sym___refvalue] = ACTIONS(2418),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym_typeof] = ACTIONS(2418),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [sym_integer_literal] = ACTIONS(2418),
    [sym_null_literal] = ACTIONS(2418),
    [sym_real_literal] = ACTIONS(2416),
    [sym_verbatim_string_literal] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2418),
    [anon_sym_nameof] = ACTIONS(2418),
    [sym_void_keyword] = ACTIONS(2418),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1600] = {
    [sym__preprocessor_call] = STATE(1600),
    [ts_builtin_sym_end] = ACTIONS(2420),
    [sym__identifier_token] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym_alias] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_global] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_abstract] = ACTIONS(2422),
    [anon_sym_async] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_fixed] = ACTIONS(2422),
    [anon_sym_internal] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_partial] = ACTIONS(2422),
    [anon_sym_private] = ACTIONS(2422),
    [anon_sym_protected] = ACTIONS(2422),
    [anon_sym_public] = ACTIONS(2422),
    [anon_sym_readonly] = ACTIONS(2422),
    [anon_sym_ref] = ACTIONS(2422),
    [anon_sym_sealed] = ACTIONS(2422),
    [anon_sym_unsafe] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_this] = ACTIONS(2422),
    [anon_sym_base] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_where] = ACTIONS(2422),
    [anon_sym_class] = ACTIONS(2422),
    [anon_sym_struct] = ACTIONS(2422),
    [anon_sym_notnull] = ACTIONS(2422),
    [anon_sym_unmanaged] = ACTIONS(2422),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_true] = ACTIONS(2422),
    [anon_sym_false] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_get] = ACTIONS(2422),
    [anon_sym_set] = ACTIONS(2422),
    [anon_sym_add] = ACTIONS(2422),
    [anon_sym_remove] = ACTIONS(2422),
    [anon_sym_enum] = ACTIONS(2422),
    [anon_sym_interface] = ACTIONS(2422),
    [anon_sym_delegate] = ACTIONS(2422),
    [anon_sym_record] = ACTIONS(2422),
    [anon_sym_namespace] = ACTIONS(2422),
    [anon_sym_var] = ACTIONS(2422),
    [sym_predefined_type] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_checked] = ACTIONS(2422),
    [anon_sym_unchecked] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_await] = ACTIONS(2422),
    [anon_sym_foreach] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_lock] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_when] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_stackalloc] = ACTIONS(2422),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2420),
    [anon_sym___makeref] = ACTIONS(2422),
    [anon_sym_from] = ACTIONS(2422),
    [anon_sym_join] = ACTIONS(2422),
    [anon_sym_on] = ACTIONS(2422),
    [anon_sym_equals] = ACTIONS(2422),
    [anon_sym_into] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_orderby] = ACTIONS(2422),
    [anon_sym_ascending] = ACTIONS(2422),
    [anon_sym_descending] = ACTIONS(2422),
    [anon_sym_group] = ACTIONS(2422),
    [anon_sym_by] = ACTIONS(2422),
    [anon_sym_select] = ACTIONS(2422),
    [anon_sym_DOT_DOT] = ACTIONS(2420),
    [anon_sym___reftype] = ACTIONS(2422),
    [anon_sym___refvalue] = ACTIONS(2422),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym_typeof] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [sym_integer_literal] = ACTIONS(2422),
    [sym_null_literal] = ACTIONS(2422),
    [sym_real_literal] = ACTIONS(2420),
    [sym_verbatim_string_literal] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2422),
    [anon_sym_nameof] = ACTIONS(2422),
    [sym_void_keyword] = ACTIONS(2422),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1601] = {
    [sym__preprocessor_call] = STATE(1601),
    [ts_builtin_sym_end] = ACTIONS(2424),
    [sym__identifier_token] = ACTIONS(2426),
    [anon_sym_extern] = ACTIONS(2426),
    [anon_sym_alias] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_global] = ACTIONS(2426),
    [anon_sym_using] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_abstract] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_const] = ACTIONS(2426),
    [anon_sym_fixed] = ACTIONS(2426),
    [anon_sym_internal] = ACTIONS(2426),
    [anon_sym_new] = ACTIONS(2426),
    [anon_sym_override] = ACTIONS(2426),
    [anon_sym_partial] = ACTIONS(2426),
    [anon_sym_private] = ACTIONS(2426),
    [anon_sym_protected] = ACTIONS(2426),
    [anon_sym_public] = ACTIONS(2426),
    [anon_sym_readonly] = ACTIONS(2426),
    [anon_sym_ref] = ACTIONS(2426),
    [anon_sym_sealed] = ACTIONS(2426),
    [anon_sym_unsafe] = ACTIONS(2426),
    [anon_sym_virtual] = ACTIONS(2426),
    [anon_sym_volatile] = ACTIONS(2426),
    [anon_sym_this] = ACTIONS(2426),
    [anon_sym_base] = ACTIONS(2426),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_where] = ACTIONS(2426),
    [anon_sym_class] = ACTIONS(2426),
    [anon_sym_struct] = ACTIONS(2426),
    [anon_sym_notnull] = ACTIONS(2426),
    [anon_sym_unmanaged] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2424),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_true] = ACTIONS(2426),
    [anon_sym_false] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_STAR] = ACTIONS(2424),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2424),
    [anon_sym_get] = ACTIONS(2426),
    [anon_sym_set] = ACTIONS(2426),
    [anon_sym_add] = ACTIONS(2426),
    [anon_sym_remove] = ACTIONS(2426),
    [anon_sym_enum] = ACTIONS(2426),
    [anon_sym_interface] = ACTIONS(2426),
    [anon_sym_delegate] = ACTIONS(2426),
    [anon_sym_record] = ACTIONS(2426),
    [anon_sym_namespace] = ACTIONS(2426),
    [anon_sym_var] = ACTIONS(2426),
    [sym_predefined_type] = ACTIONS(2426),
    [anon_sym_break] = ACTIONS(2426),
    [anon_sym_checked] = ACTIONS(2426),
    [anon_sym_unchecked] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(2426),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_await] = ACTIONS(2426),
    [anon_sym_foreach] = ACTIONS(2426),
    [anon_sym_goto] = ACTIONS(2426),
    [anon_sym_default] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(2426),
    [anon_sym_lock] = ACTIONS(2426),
    [anon_sym_switch] = ACTIONS(2426),
    [anon_sym_when] = ACTIONS(2426),
    [anon_sym_throw] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_stackalloc] = ACTIONS(2426),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2424),
    [anon_sym___makeref] = ACTIONS(2426),
    [anon_sym_from] = ACTIONS(2426),
    [anon_sym_join] = ACTIONS(2426),
    [anon_sym_on] = ACTIONS(2426),
    [anon_sym_equals] = ACTIONS(2426),
    [anon_sym_into] = ACTIONS(2426),
    [anon_sym_let] = ACTIONS(2426),
    [anon_sym_orderby] = ACTIONS(2426),
    [anon_sym_ascending] = ACTIONS(2426),
    [anon_sym_descending] = ACTIONS(2426),
    [anon_sym_group] = ACTIONS(2426),
    [anon_sym_by] = ACTIONS(2426),
    [anon_sym_select] = ACTIONS(2426),
    [anon_sym_DOT_DOT] = ACTIONS(2424),
    [anon_sym___reftype] = ACTIONS(2426),
    [anon_sym___refvalue] = ACTIONS(2426),
    [anon_sym_sizeof] = ACTIONS(2426),
    [anon_sym_typeof] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_integer_literal] = ACTIONS(2426),
    [sym_null_literal] = ACTIONS(2426),
    [sym_real_literal] = ACTIONS(2424),
    [sym_verbatim_string_literal] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2426),
    [anon_sym_nameof] = ACTIONS(2426),
    [sym_void_keyword] = ACTIONS(2426),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1602] = {
    [sym__preprocessor_call] = STATE(1602),
    [ts_builtin_sym_end] = ACTIONS(2428),
    [sym__identifier_token] = ACTIONS(2430),
    [anon_sym_extern] = ACTIONS(2430),
    [anon_sym_alias] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_global] = ACTIONS(2430),
    [anon_sym_using] = ACTIONS(2430),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_abstract] = ACTIONS(2430),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_const] = ACTIONS(2430),
    [anon_sym_fixed] = ACTIONS(2430),
    [anon_sym_internal] = ACTIONS(2430),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_partial] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_ref] = ACTIONS(2430),
    [anon_sym_sealed] = ACTIONS(2430),
    [anon_sym_unsafe] = ACTIONS(2430),
    [anon_sym_virtual] = ACTIONS(2430),
    [anon_sym_volatile] = ACTIONS(2430),
    [anon_sym_this] = ACTIONS(2430),
    [anon_sym_base] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2428),
    [anon_sym_where] = ACTIONS(2430),
    [anon_sym_class] = ACTIONS(2430),
    [anon_sym_struct] = ACTIONS(2430),
    [anon_sym_notnull] = ACTIONS(2430),
    [anon_sym_unmanaged] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_true] = ACTIONS(2430),
    [anon_sym_false] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_add] = ACTIONS(2430),
    [anon_sym_remove] = ACTIONS(2430),
    [anon_sym_enum] = ACTIONS(2430),
    [anon_sym_interface] = ACTIONS(2430),
    [anon_sym_delegate] = ACTIONS(2430),
    [anon_sym_record] = ACTIONS(2430),
    [anon_sym_namespace] = ACTIONS(2430),
    [anon_sym_var] = ACTIONS(2430),
    [sym_predefined_type] = ACTIONS(2430),
    [anon_sym_break] = ACTIONS(2430),
    [anon_sym_checked] = ACTIONS(2430),
    [anon_sym_unchecked] = ACTIONS(2430),
    [anon_sym_continue] = ACTIONS(2430),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_while] = ACTIONS(2430),
    [anon_sym_for] = ACTIONS(2430),
    [anon_sym_await] = ACTIONS(2430),
    [anon_sym_foreach] = ACTIONS(2430),
    [anon_sym_goto] = ACTIONS(2430),
    [anon_sym_default] = ACTIONS(2430),
    [anon_sym_if] = ACTIONS(2430),
    [anon_sym_else] = ACTIONS(2430),
    [anon_sym_lock] = ACTIONS(2430),
    [anon_sym_switch] = ACTIONS(2430),
    [anon_sym_when] = ACTIONS(2430),
    [anon_sym_throw] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2430),
    [anon_sym_yield] = ACTIONS(2430),
    [anon_sym_stackalloc] = ACTIONS(2430),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2428),
    [anon_sym_DQUOTE] = ACTIONS(2428),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2428),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2428),
    [anon_sym___makeref] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_join] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_equals] = ACTIONS(2430),
    [anon_sym_into] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_orderby] = ACTIONS(2430),
    [anon_sym_ascending] = ACTIONS(2430),
    [anon_sym_descending] = ACTIONS(2430),
    [anon_sym_group] = ACTIONS(2430),
    [anon_sym_by] = ACTIONS(2430),
    [anon_sym_select] = ACTIONS(2430),
    [anon_sym_DOT_DOT] = ACTIONS(2428),
    [anon_sym___reftype] = ACTIONS(2430),
    [anon_sym___refvalue] = ACTIONS(2430),
    [anon_sym_sizeof] = ACTIONS(2430),
    [anon_sym_typeof] = ACTIONS(2430),
    [anon_sym_SQUOTE] = ACTIONS(2428),
    [sym_integer_literal] = ACTIONS(2430),
    [sym_null_literal] = ACTIONS(2430),
    [sym_real_literal] = ACTIONS(2428),
    [sym_verbatim_string_literal] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2430),
    [anon_sym_nameof] = ACTIONS(2430),
    [sym_void_keyword] = ACTIONS(2430),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1603] = {
    [sym__preprocessor_call] = STATE(1603),
    [ts_builtin_sym_end] = ACTIONS(2432),
    [sym__identifier_token] = ACTIONS(2434),
    [anon_sym_extern] = ACTIONS(2434),
    [anon_sym_alias] = ACTIONS(2434),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_global] = ACTIONS(2434),
    [anon_sym_using] = ACTIONS(2434),
    [anon_sym_static] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_return] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_abstract] = ACTIONS(2434),
    [anon_sym_async] = ACTIONS(2434),
    [anon_sym_const] = ACTIONS(2434),
    [anon_sym_fixed] = ACTIONS(2434),
    [anon_sym_internal] = ACTIONS(2434),
    [anon_sym_new] = ACTIONS(2434),
    [anon_sym_override] = ACTIONS(2434),
    [anon_sym_partial] = ACTIONS(2434),
    [anon_sym_private] = ACTIONS(2434),
    [anon_sym_protected] = ACTIONS(2434),
    [anon_sym_public] = ACTIONS(2434),
    [anon_sym_readonly] = ACTIONS(2434),
    [anon_sym_ref] = ACTIONS(2434),
    [anon_sym_sealed] = ACTIONS(2434),
    [anon_sym_unsafe] = ACTIONS(2434),
    [anon_sym_virtual] = ACTIONS(2434),
    [anon_sym_volatile] = ACTIONS(2434),
    [anon_sym_this] = ACTIONS(2434),
    [anon_sym_base] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_TILDE] = ACTIONS(2432),
    [anon_sym_where] = ACTIONS(2434),
    [anon_sym_class] = ACTIONS(2434),
    [anon_sym_struct] = ACTIONS(2434),
    [anon_sym_notnull] = ACTIONS(2434),
    [anon_sym_unmanaged] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [anon_sym_true] = ACTIONS(2434),
    [anon_sym_false] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(2432),
    [anon_sym_CARET] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_get] = ACTIONS(2434),
    [anon_sym_set] = ACTIONS(2434),
    [anon_sym_add] = ACTIONS(2434),
    [anon_sym_remove] = ACTIONS(2434),
    [anon_sym_enum] = ACTIONS(2434),
    [anon_sym_interface] = ACTIONS(2434),
    [anon_sym_delegate] = ACTIONS(2434),
    [anon_sym_record] = ACTIONS(2434),
    [anon_sym_namespace] = ACTIONS(2434),
    [anon_sym_var] = ACTIONS(2434),
    [sym_predefined_type] = ACTIONS(2434),
    [anon_sym_break] = ACTIONS(2434),
    [anon_sym_checked] = ACTIONS(2434),
    [anon_sym_unchecked] = ACTIONS(2434),
    [anon_sym_continue] = ACTIONS(2434),
    [anon_sym_do] = ACTIONS(2434),
    [anon_sym_while] = ACTIONS(2434),
    [anon_sym_for] = ACTIONS(2434),
    [anon_sym_await] = ACTIONS(2434),
    [anon_sym_foreach] = ACTIONS(2434),
    [anon_sym_goto] = ACTIONS(2434),
    [anon_sym_default] = ACTIONS(2434),
    [anon_sym_if] = ACTIONS(2434),
    [anon_sym_else] = ACTIONS(2434),
    [anon_sym_lock] = ACTIONS(2434),
    [anon_sym_switch] = ACTIONS(2434),
    [anon_sym_when] = ACTIONS(2434),
    [anon_sym_throw] = ACTIONS(2434),
    [anon_sym_try] = ACTIONS(2434),
    [anon_sym_yield] = ACTIONS(2434),
    [anon_sym_stackalloc] = ACTIONS(2434),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2432),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2432),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2432),
    [anon_sym___makeref] = ACTIONS(2434),
    [anon_sym_from] = ACTIONS(2434),
    [anon_sym_join] = ACTIONS(2434),
    [anon_sym_on] = ACTIONS(2434),
    [anon_sym_equals] = ACTIONS(2434),
    [anon_sym_into] = ACTIONS(2434),
    [anon_sym_let] = ACTIONS(2434),
    [anon_sym_orderby] = ACTIONS(2434),
    [anon_sym_ascending] = ACTIONS(2434),
    [anon_sym_descending] = ACTIONS(2434),
    [anon_sym_group] = ACTIONS(2434),
    [anon_sym_by] = ACTIONS(2434),
    [anon_sym_select] = ACTIONS(2434),
    [anon_sym_DOT_DOT] = ACTIONS(2432),
    [anon_sym___reftype] = ACTIONS(2434),
    [anon_sym___refvalue] = ACTIONS(2434),
    [anon_sym_sizeof] = ACTIONS(2434),
    [anon_sym_typeof] = ACTIONS(2434),
    [anon_sym_SQUOTE] = ACTIONS(2432),
    [sym_integer_literal] = ACTIONS(2434),
    [sym_null_literal] = ACTIONS(2434),
    [sym_real_literal] = ACTIONS(2432),
    [sym_verbatim_string_literal] = ACTIONS(2432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2434),
    [anon_sym_nameof] = ACTIONS(2434),
    [sym_void_keyword] = ACTIONS(2434),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1604] = {
    [sym__preprocessor_call] = STATE(1604),
    [ts_builtin_sym_end] = ACTIONS(2436),
    [sym__identifier_token] = ACTIONS(2438),
    [anon_sym_extern] = ACTIONS(2438),
    [anon_sym_alias] = ACTIONS(2438),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_global] = ACTIONS(2438),
    [anon_sym_using] = ACTIONS(2438),
    [anon_sym_static] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_abstract] = ACTIONS(2438),
    [anon_sym_async] = ACTIONS(2438),
    [anon_sym_const] = ACTIONS(2438),
    [anon_sym_fixed] = ACTIONS(2438),
    [anon_sym_internal] = ACTIONS(2438),
    [anon_sym_new] = ACTIONS(2438),
    [anon_sym_override] = ACTIONS(2438),
    [anon_sym_partial] = ACTIONS(2438),
    [anon_sym_private] = ACTIONS(2438),
    [anon_sym_protected] = ACTIONS(2438),
    [anon_sym_public] = ACTIONS(2438),
    [anon_sym_readonly] = ACTIONS(2438),
    [anon_sym_ref] = ACTIONS(2438),
    [anon_sym_sealed] = ACTIONS(2438),
    [anon_sym_unsafe] = ACTIONS(2438),
    [anon_sym_virtual] = ACTIONS(2438),
    [anon_sym_volatile] = ACTIONS(2438),
    [anon_sym_this] = ACTIONS(2438),
    [anon_sym_base] = ACTIONS(2438),
    [anon_sym_LBRACE] = ACTIONS(2436),
    [anon_sym_TILDE] = ACTIONS(2436),
    [anon_sym_where] = ACTIONS(2438),
    [anon_sym_class] = ACTIONS(2438),
    [anon_sym_struct] = ACTIONS(2438),
    [anon_sym_notnull] = ACTIONS(2438),
    [anon_sym_unmanaged] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [anon_sym_true] = ACTIONS(2438),
    [anon_sym_false] = ACTIONS(2438),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2436),
    [anon_sym_CARET] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_get] = ACTIONS(2438),
    [anon_sym_set] = ACTIONS(2438),
    [anon_sym_add] = ACTIONS(2438),
    [anon_sym_remove] = ACTIONS(2438),
    [anon_sym_enum] = ACTIONS(2438),
    [anon_sym_interface] = ACTIONS(2438),
    [anon_sym_delegate] = ACTIONS(2438),
    [anon_sym_record] = ACTIONS(2438),
    [anon_sym_namespace] = ACTIONS(2438),
    [anon_sym_var] = ACTIONS(2438),
    [sym_predefined_type] = ACTIONS(2438),
    [anon_sym_break] = ACTIONS(2438),
    [anon_sym_checked] = ACTIONS(2438),
    [anon_sym_unchecked] = ACTIONS(2438),
    [anon_sym_continue] = ACTIONS(2438),
    [anon_sym_do] = ACTIONS(2438),
    [anon_sym_while] = ACTIONS(2438),
    [anon_sym_for] = ACTIONS(2438),
    [anon_sym_await] = ACTIONS(2438),
    [anon_sym_foreach] = ACTIONS(2438),
    [anon_sym_goto] = ACTIONS(2438),
    [anon_sym_default] = ACTIONS(2438),
    [anon_sym_if] = ACTIONS(2438),
    [anon_sym_else] = ACTIONS(2438),
    [anon_sym_lock] = ACTIONS(2438),
    [anon_sym_switch] = ACTIONS(2438),
    [anon_sym_when] = ACTIONS(2438),
    [anon_sym_throw] = ACTIONS(2438),
    [anon_sym_try] = ACTIONS(2438),
    [anon_sym_yield] = ACTIONS(2438),
    [anon_sym_stackalloc] = ACTIONS(2438),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2436),
    [anon_sym_DQUOTE] = ACTIONS(2436),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2436),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2436),
    [anon_sym___makeref] = ACTIONS(2438),
    [anon_sym_from] = ACTIONS(2438),
    [anon_sym_join] = ACTIONS(2438),
    [anon_sym_on] = ACTIONS(2438),
    [anon_sym_equals] = ACTIONS(2438),
    [anon_sym_into] = ACTIONS(2438),
    [anon_sym_let] = ACTIONS(2438),
    [anon_sym_orderby] = ACTIONS(2438),
    [anon_sym_ascending] = ACTIONS(2438),
    [anon_sym_descending] = ACTIONS(2438),
    [anon_sym_group] = ACTIONS(2438),
    [anon_sym_by] = ACTIONS(2438),
    [anon_sym_select] = ACTIONS(2438),
    [anon_sym_DOT_DOT] = ACTIONS(2436),
    [anon_sym___reftype] = ACTIONS(2438),
    [anon_sym___refvalue] = ACTIONS(2438),
    [anon_sym_sizeof] = ACTIONS(2438),
    [anon_sym_typeof] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2436),
    [sym_integer_literal] = ACTIONS(2438),
    [sym_null_literal] = ACTIONS(2438),
    [sym_real_literal] = ACTIONS(2436),
    [sym_verbatim_string_literal] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2438),
    [anon_sym_nameof] = ACTIONS(2438),
    [sym_void_keyword] = ACTIONS(2438),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1605] = {
    [sym__preprocessor_call] = STATE(1605),
    [ts_builtin_sym_end] = ACTIONS(2440),
    [sym__identifier_token] = ACTIONS(2442),
    [anon_sym_extern] = ACTIONS(2442),
    [anon_sym_alias] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_global] = ACTIONS(2442),
    [anon_sym_using] = ACTIONS(2442),
    [anon_sym_static] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_return] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_abstract] = ACTIONS(2442),
    [anon_sym_async] = ACTIONS(2442),
    [anon_sym_const] = ACTIONS(2442),
    [anon_sym_fixed] = ACTIONS(2442),
    [anon_sym_internal] = ACTIONS(2442),
    [anon_sym_new] = ACTIONS(2442),
    [anon_sym_override] = ACTIONS(2442),
    [anon_sym_partial] = ACTIONS(2442),
    [anon_sym_private] = ACTIONS(2442),
    [anon_sym_protected] = ACTIONS(2442),
    [anon_sym_public] = ACTIONS(2442),
    [anon_sym_readonly] = ACTIONS(2442),
    [anon_sym_ref] = ACTIONS(2442),
    [anon_sym_sealed] = ACTIONS(2442),
    [anon_sym_unsafe] = ACTIONS(2442),
    [anon_sym_virtual] = ACTIONS(2442),
    [anon_sym_volatile] = ACTIONS(2442),
    [anon_sym_this] = ACTIONS(2442),
    [anon_sym_base] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_TILDE] = ACTIONS(2440),
    [anon_sym_where] = ACTIONS(2442),
    [anon_sym_class] = ACTIONS(2442),
    [anon_sym_struct] = ACTIONS(2442),
    [anon_sym_notnull] = ACTIONS(2442),
    [anon_sym_unmanaged] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(2440),
    [anon_sym_DASH_DASH] = ACTIONS(2440),
    [anon_sym_true] = ACTIONS(2442),
    [anon_sym_false] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_CARET] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_get] = ACTIONS(2442),
    [anon_sym_set] = ACTIONS(2442),
    [anon_sym_add] = ACTIONS(2442),
    [anon_sym_remove] = ACTIONS(2442),
    [anon_sym_enum] = ACTIONS(2442),
    [anon_sym_interface] = ACTIONS(2442),
    [anon_sym_delegate] = ACTIONS(2442),
    [anon_sym_record] = ACTIONS(2442),
    [anon_sym_namespace] = ACTIONS(2442),
    [anon_sym_var] = ACTIONS(2442),
    [sym_predefined_type] = ACTIONS(2442),
    [anon_sym_break] = ACTIONS(2442),
    [anon_sym_checked] = ACTIONS(2442),
    [anon_sym_unchecked] = ACTIONS(2442),
    [anon_sym_continue] = ACTIONS(2442),
    [anon_sym_do] = ACTIONS(2442),
    [anon_sym_while] = ACTIONS(2442),
    [anon_sym_for] = ACTIONS(2442),
    [anon_sym_await] = ACTIONS(2442),
    [anon_sym_foreach] = ACTIONS(2442),
    [anon_sym_goto] = ACTIONS(2442),
    [anon_sym_default] = ACTIONS(2442),
    [anon_sym_if] = ACTIONS(2442),
    [anon_sym_else] = ACTIONS(2442),
    [anon_sym_lock] = ACTIONS(2442),
    [anon_sym_switch] = ACTIONS(2442),
    [anon_sym_when] = ACTIONS(2442),
    [anon_sym_throw] = ACTIONS(2442),
    [anon_sym_try] = ACTIONS(2442),
    [anon_sym_yield] = ACTIONS(2442),
    [anon_sym_stackalloc] = ACTIONS(2442),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2440),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2440),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2440),
    [anon_sym___makeref] = ACTIONS(2442),
    [anon_sym_from] = ACTIONS(2442),
    [anon_sym_join] = ACTIONS(2442),
    [anon_sym_on] = ACTIONS(2442),
    [anon_sym_equals] = ACTIONS(2442),
    [anon_sym_into] = ACTIONS(2442),
    [anon_sym_let] = ACTIONS(2442),
    [anon_sym_orderby] = ACTIONS(2442),
    [anon_sym_ascending] = ACTIONS(2442),
    [anon_sym_descending] = ACTIONS(2442),
    [anon_sym_group] = ACTIONS(2442),
    [anon_sym_by] = ACTIONS(2442),
    [anon_sym_select] = ACTIONS(2442),
    [anon_sym_DOT_DOT] = ACTIONS(2440),
    [anon_sym___reftype] = ACTIONS(2442),
    [anon_sym___refvalue] = ACTIONS(2442),
    [anon_sym_sizeof] = ACTIONS(2442),
    [anon_sym_typeof] = ACTIONS(2442),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [sym_integer_literal] = ACTIONS(2442),
    [sym_null_literal] = ACTIONS(2442),
    [sym_real_literal] = ACTIONS(2440),
    [sym_verbatim_string_literal] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2442),
    [anon_sym_nameof] = ACTIONS(2442),
    [sym_void_keyword] = ACTIONS(2442),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1606] = {
    [sym__preprocessor_call] = STATE(1606),
    [ts_builtin_sym_end] = ACTIONS(2444),
    [sym__identifier_token] = ACTIONS(2446),
    [anon_sym_extern] = ACTIONS(2446),
    [anon_sym_alias] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_global] = ACTIONS(2446),
    [anon_sym_using] = ACTIONS(2446),
    [anon_sym_static] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_abstract] = ACTIONS(2446),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_const] = ACTIONS(2446),
    [anon_sym_fixed] = ACTIONS(2446),
    [anon_sym_internal] = ACTIONS(2446),
    [anon_sym_new] = ACTIONS(2446),
    [anon_sym_override] = ACTIONS(2446),
    [anon_sym_partial] = ACTIONS(2446),
    [anon_sym_private] = ACTIONS(2446),
    [anon_sym_protected] = ACTIONS(2446),
    [anon_sym_public] = ACTIONS(2446),
    [anon_sym_readonly] = ACTIONS(2446),
    [anon_sym_ref] = ACTIONS(2446),
    [anon_sym_sealed] = ACTIONS(2446),
    [anon_sym_unsafe] = ACTIONS(2446),
    [anon_sym_virtual] = ACTIONS(2446),
    [anon_sym_volatile] = ACTIONS(2446),
    [anon_sym_this] = ACTIONS(2446),
    [anon_sym_base] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_TILDE] = ACTIONS(2444),
    [anon_sym_where] = ACTIONS(2446),
    [anon_sym_class] = ACTIONS(2446),
    [anon_sym_struct] = ACTIONS(2446),
    [anon_sym_notnull] = ACTIONS(2446),
    [anon_sym_unmanaged] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_true] = ACTIONS(2446),
    [anon_sym_false] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_get] = ACTIONS(2446),
    [anon_sym_set] = ACTIONS(2446),
    [anon_sym_add] = ACTIONS(2446),
    [anon_sym_remove] = ACTIONS(2446),
    [anon_sym_enum] = ACTIONS(2446),
    [anon_sym_interface] = ACTIONS(2446),
    [anon_sym_delegate] = ACTIONS(2446),
    [anon_sym_record] = ACTIONS(2446),
    [anon_sym_namespace] = ACTIONS(2446),
    [anon_sym_var] = ACTIONS(2446),
    [sym_predefined_type] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_checked] = ACTIONS(2446),
    [anon_sym_unchecked] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_do] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_await] = ACTIONS(2446),
    [anon_sym_foreach] = ACTIONS(2446),
    [anon_sym_goto] = ACTIONS(2446),
    [anon_sym_default] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_else] = ACTIONS(2446),
    [anon_sym_lock] = ACTIONS(2446),
    [anon_sym_switch] = ACTIONS(2446),
    [anon_sym_when] = ACTIONS(2446),
    [anon_sym_throw] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_stackalloc] = ACTIONS(2446),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2444),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2444),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2444),
    [anon_sym___makeref] = ACTIONS(2446),
    [anon_sym_from] = ACTIONS(2446),
    [anon_sym_join] = ACTIONS(2446),
    [anon_sym_on] = ACTIONS(2446),
    [anon_sym_equals] = ACTIONS(2446),
    [anon_sym_into] = ACTIONS(2446),
    [anon_sym_let] = ACTIONS(2446),
    [anon_sym_orderby] = ACTIONS(2446),
    [anon_sym_ascending] = ACTIONS(2446),
    [anon_sym_descending] = ACTIONS(2446),
    [anon_sym_group] = ACTIONS(2446),
    [anon_sym_by] = ACTIONS(2446),
    [anon_sym_select] = ACTIONS(2446),
    [anon_sym_DOT_DOT] = ACTIONS(2444),
    [anon_sym___reftype] = ACTIONS(2446),
    [anon_sym___refvalue] = ACTIONS(2446),
    [anon_sym_sizeof] = ACTIONS(2446),
    [anon_sym_typeof] = ACTIONS(2446),
    [anon_sym_SQUOTE] = ACTIONS(2444),
    [sym_integer_literal] = ACTIONS(2446),
    [sym_null_literal] = ACTIONS(2446),
    [sym_real_literal] = ACTIONS(2444),
    [sym_verbatim_string_literal] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2446),
    [anon_sym_nameof] = ACTIONS(2446),
    [sym_void_keyword] = ACTIONS(2446),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1607] = {
    [sym_catch_clause] = STATE(1651),
    [sym_finally_clause] = STATE(1665),
    [sym__preprocessor_call] = STATE(1607),
    [aux_sym_try_statement_repeat1] = STATE(1577),
    [sym__identifier_token] = ACTIONS(2189),
    [anon_sym_extern] = ACTIONS(2189),
    [anon_sym_alias] = ACTIONS(2189),
    [anon_sym_SEMI] = ACTIONS(2187),
    [anon_sym_global] = ACTIONS(2189),
    [anon_sym_using] = ACTIONS(2189),
    [anon_sym_static] = ACTIONS(2189),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_return] = ACTIONS(2189),
    [anon_sym_LPAREN] = ACTIONS(2187),
    [anon_sym_abstract] = ACTIONS(2189),
    [anon_sym_async] = ACTIONS(2189),
    [anon_sym_const] = ACTIONS(2189),
    [anon_sym_fixed] = ACTIONS(2189),
    [anon_sym_internal] = ACTIONS(2189),
    [anon_sym_new] = ACTIONS(2189),
    [anon_sym_override] = ACTIONS(2189),
    [anon_sym_partial] = ACTIONS(2189),
    [anon_sym_private] = ACTIONS(2189),
    [anon_sym_protected] = ACTIONS(2189),
    [anon_sym_public] = ACTIONS(2189),
    [anon_sym_readonly] = ACTIONS(2189),
    [anon_sym_ref] = ACTIONS(2189),
    [anon_sym_sealed] = ACTIONS(2189),
    [anon_sym_unsafe] = ACTIONS(2189),
    [anon_sym_virtual] = ACTIONS(2189),
    [anon_sym_volatile] = ACTIONS(2189),
    [anon_sym_this] = ACTIONS(2189),
    [anon_sym_base] = ACTIONS(2189),
    [anon_sym_LBRACE] = ACTIONS(2187),
    [anon_sym_RBRACE] = ACTIONS(2187),
    [anon_sym_TILDE] = ACTIONS(2187),
    [anon_sym_where] = ACTIONS(2189),
    [anon_sym_notnull] = ACTIONS(2189),
    [anon_sym_unmanaged] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(2187),
    [anon_sym_PLUS_PLUS] = ACTIONS(2187),
    [anon_sym_DASH_DASH] = ACTIONS(2187),
    [anon_sym_true] = ACTIONS(2189),
    [anon_sym_false] = ACTIONS(2189),
    [anon_sym_PLUS] = ACTIONS(2189),
    [anon_sym_DASH] = ACTIONS(2189),
    [anon_sym_STAR] = ACTIONS(2187),
    [anon_sym_CARET] = ACTIONS(2187),
    [anon_sym_AMP] = ACTIONS(2187),
    [anon_sym_get] = ACTIONS(2189),
    [anon_sym_set] = ACTIONS(2189),
    [anon_sym_add] = ACTIONS(2189),
    [anon_sym_remove] = ACTIONS(2189),
    [anon_sym_delegate] = ACTIONS(2189),
    [anon_sym_var] = ACTIONS(2189),
    [sym_predefined_type] = ACTIONS(2189),
    [anon_sym_break] = ACTIONS(2189),
    [anon_sym_checked] = ACTIONS(2189),
    [anon_sym_unchecked] = ACTIONS(2189),
    [anon_sym_continue] = ACTIONS(2189),
    [anon_sym_do] = ACTIONS(2189),
    [anon_sym_while] = ACTIONS(2189),
    [anon_sym_for] = ACTIONS(2189),
    [anon_sym_await] = ACTIONS(2189),
    [anon_sym_foreach] = ACTIONS(2189),
    [anon_sym_goto] = ACTIONS(2189),
    [anon_sym_case] = ACTIONS(2189),
    [anon_sym_default] = ACTIONS(2189),
    [anon_sym_if] = ACTIONS(2189),
    [anon_sym_else] = ACTIONS(2189),
    [anon_sym_lock] = ACTIONS(2189),
    [anon_sym_switch] = ACTIONS(2189),
    [anon_sym_when] = ACTIONS(2189),
    [anon_sym_throw] = ACTIONS(2189),
    [anon_sym_try] = ACTIONS(2189),
    [anon_sym_catch] = ACTIONS(2326),
    [anon_sym_finally] = ACTIONS(2328),
    [anon_sym_yield] = ACTIONS(2189),
    [anon_sym_stackalloc] = ACTIONS(2189),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2187),
    [anon_sym_DQUOTE] = ACTIONS(2187),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2187),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2187),
    [anon_sym___makeref] = ACTIONS(2189),
    [anon_sym_from] = ACTIONS(2189),
    [anon_sym_join] = ACTIONS(2189),
    [anon_sym_on] = ACTIONS(2189),
    [anon_sym_equals] = ACTIONS(2189),
    [anon_sym_into] = ACTIONS(2189),
    [anon_sym_let] = ACTIONS(2189),
    [anon_sym_orderby] = ACTIONS(2189),
    [anon_sym_ascending] = ACTIONS(2189),
    [anon_sym_descending] = ACTIONS(2189),
    [anon_sym_group] = ACTIONS(2189),
    [anon_sym_by] = ACTIONS(2189),
    [anon_sym_select] = ACTIONS(2189),
    [anon_sym_DOT_DOT] = ACTIONS(2187),
    [anon_sym___reftype] = ACTIONS(2189),
    [anon_sym___refvalue] = ACTIONS(2189),
    [anon_sym_sizeof] = ACTIONS(2189),
    [anon_sym_typeof] = ACTIONS(2189),
    [anon_sym_SQUOTE] = ACTIONS(2187),
    [sym_integer_literal] = ACTIONS(2189),
    [sym_null_literal] = ACTIONS(2189),
    [sym_real_literal] = ACTIONS(2187),
    [sym_verbatim_string_literal] = ACTIONS(2187),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2189),
    [anon_sym_nameof] = ACTIONS(2189),
    [sym_void_keyword] = ACTIONS(2189),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1608] = {
    [sym__preprocessor_call] = STATE(1608),
    [ts_builtin_sym_end] = ACTIONS(2448),
    [sym__identifier_token] = ACTIONS(2450),
    [anon_sym_extern] = ACTIONS(2450),
    [anon_sym_alias] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_global] = ACTIONS(2450),
    [anon_sym_using] = ACTIONS(2450),
    [anon_sym_static] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_return] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_abstract] = ACTIONS(2450),
    [anon_sym_async] = ACTIONS(2450),
    [anon_sym_const] = ACTIONS(2450),
    [anon_sym_fixed] = ACTIONS(2450),
    [anon_sym_internal] = ACTIONS(2450),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_override] = ACTIONS(2450),
    [anon_sym_partial] = ACTIONS(2450),
    [anon_sym_private] = ACTIONS(2450),
    [anon_sym_protected] = ACTIONS(2450),
    [anon_sym_public] = ACTIONS(2450),
    [anon_sym_readonly] = ACTIONS(2450),
    [anon_sym_ref] = ACTIONS(2450),
    [anon_sym_sealed] = ACTIONS(2450),
    [anon_sym_unsafe] = ACTIONS(2450),
    [anon_sym_virtual] = ACTIONS(2450),
    [anon_sym_volatile] = ACTIONS(2450),
    [anon_sym_this] = ACTIONS(2450),
    [anon_sym_base] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2448),
    [anon_sym_where] = ACTIONS(2450),
    [anon_sym_class] = ACTIONS(2450),
    [anon_sym_struct] = ACTIONS(2450),
    [anon_sym_notnull] = ACTIONS(2450),
    [anon_sym_unmanaged] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_true] = ACTIONS(2450),
    [anon_sym_false] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_CARET] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_get] = ACTIONS(2450),
    [anon_sym_set] = ACTIONS(2450),
    [anon_sym_add] = ACTIONS(2450),
    [anon_sym_remove] = ACTIONS(2450),
    [anon_sym_enum] = ACTIONS(2450),
    [anon_sym_interface] = ACTIONS(2450),
    [anon_sym_delegate] = ACTIONS(2450),
    [anon_sym_record] = ACTIONS(2450),
    [anon_sym_namespace] = ACTIONS(2450),
    [anon_sym_var] = ACTIONS(2450),
    [sym_predefined_type] = ACTIONS(2450),
    [anon_sym_break] = ACTIONS(2450),
    [anon_sym_checked] = ACTIONS(2450),
    [anon_sym_unchecked] = ACTIONS(2450),
    [anon_sym_continue] = ACTIONS(2450),
    [anon_sym_do] = ACTIONS(2450),
    [anon_sym_while] = ACTIONS(2450),
    [anon_sym_for] = ACTIONS(2450),
    [anon_sym_await] = ACTIONS(2450),
    [anon_sym_foreach] = ACTIONS(2450),
    [anon_sym_goto] = ACTIONS(2450),
    [anon_sym_default] = ACTIONS(2450),
    [anon_sym_if] = ACTIONS(2450),
    [anon_sym_else] = ACTIONS(2450),
    [anon_sym_lock] = ACTIONS(2450),
    [anon_sym_switch] = ACTIONS(2450),
    [anon_sym_when] = ACTIONS(2450),
    [anon_sym_throw] = ACTIONS(2450),
    [anon_sym_try] = ACTIONS(2450),
    [anon_sym_yield] = ACTIONS(2450),
    [anon_sym_stackalloc] = ACTIONS(2450),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2448),
    [anon_sym_DQUOTE] = ACTIONS(2448),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2448),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2448),
    [anon_sym___makeref] = ACTIONS(2450),
    [anon_sym_from] = ACTIONS(2450),
    [anon_sym_join] = ACTIONS(2450),
    [anon_sym_on] = ACTIONS(2450),
    [anon_sym_equals] = ACTIONS(2450),
    [anon_sym_into] = ACTIONS(2450),
    [anon_sym_let] = ACTIONS(2450),
    [anon_sym_orderby] = ACTIONS(2450),
    [anon_sym_ascending] = ACTIONS(2450),
    [anon_sym_descending] = ACTIONS(2450),
    [anon_sym_group] = ACTIONS(2450),
    [anon_sym_by] = ACTIONS(2450),
    [anon_sym_select] = ACTIONS(2450),
    [anon_sym_DOT_DOT] = ACTIONS(2448),
    [anon_sym___reftype] = ACTIONS(2450),
    [anon_sym___refvalue] = ACTIONS(2450),
    [anon_sym_sizeof] = ACTIONS(2450),
    [anon_sym_typeof] = ACTIONS(2450),
    [anon_sym_SQUOTE] = ACTIONS(2448),
    [sym_integer_literal] = ACTIONS(2450),
    [sym_null_literal] = ACTIONS(2450),
    [sym_real_literal] = ACTIONS(2448),
    [sym_verbatim_string_literal] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2450),
    [anon_sym_nameof] = ACTIONS(2450),
    [sym_void_keyword] = ACTIONS(2450),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1609] = {
    [sym__preprocessor_call] = STATE(1609),
    [ts_builtin_sym_end] = ACTIONS(2452),
    [sym__identifier_token] = ACTIONS(2454),
    [anon_sym_extern] = ACTIONS(2454),
    [anon_sym_alias] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_global] = ACTIONS(2454),
    [anon_sym_using] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_abstract] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_const] = ACTIONS(2454),
    [anon_sym_fixed] = ACTIONS(2454),
    [anon_sym_internal] = ACTIONS(2454),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_override] = ACTIONS(2454),
    [anon_sym_partial] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_readonly] = ACTIONS(2454),
    [anon_sym_ref] = ACTIONS(2454),
    [anon_sym_sealed] = ACTIONS(2454),
    [anon_sym_unsafe] = ACTIONS(2454),
    [anon_sym_virtual] = ACTIONS(2454),
    [anon_sym_volatile] = ACTIONS(2454),
    [anon_sym_this] = ACTIONS(2454),
    [anon_sym_base] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [anon_sym_where] = ACTIONS(2454),
    [anon_sym_class] = ACTIONS(2454),
    [anon_sym_struct] = ACTIONS(2454),
    [anon_sym_notnull] = ACTIONS(2454),
    [anon_sym_unmanaged] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [anon_sym_true] = ACTIONS(2454),
    [anon_sym_false] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_add] = ACTIONS(2454),
    [anon_sym_remove] = ACTIONS(2454),
    [anon_sym_enum] = ACTIONS(2454),
    [anon_sym_interface] = ACTIONS(2454),
    [anon_sym_delegate] = ACTIONS(2454),
    [anon_sym_record] = ACTIONS(2454),
    [anon_sym_namespace] = ACTIONS(2454),
    [anon_sym_var] = ACTIONS(2454),
    [sym_predefined_type] = ACTIONS(2454),
    [anon_sym_break] = ACTIONS(2454),
    [anon_sym_checked] = ACTIONS(2454),
    [anon_sym_unchecked] = ACTIONS(2454),
    [anon_sym_continue] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_await] = ACTIONS(2454),
    [anon_sym_foreach] = ACTIONS(2454),
    [anon_sym_goto] = ACTIONS(2454),
    [anon_sym_default] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_else] = ACTIONS(2454),
    [anon_sym_lock] = ACTIONS(2454),
    [anon_sym_switch] = ACTIONS(2454),
    [anon_sym_when] = ACTIONS(2454),
    [anon_sym_throw] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_stackalloc] = ACTIONS(2454),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2452),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2452),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2452),
    [anon_sym___makeref] = ACTIONS(2454),
    [anon_sym_from] = ACTIONS(2454),
    [anon_sym_join] = ACTIONS(2454),
    [anon_sym_on] = ACTIONS(2454),
    [anon_sym_equals] = ACTIONS(2454),
    [anon_sym_into] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_orderby] = ACTIONS(2454),
    [anon_sym_ascending] = ACTIONS(2454),
    [anon_sym_descending] = ACTIONS(2454),
    [anon_sym_group] = ACTIONS(2454),
    [anon_sym_by] = ACTIONS(2454),
    [anon_sym_select] = ACTIONS(2454),
    [anon_sym_DOT_DOT] = ACTIONS(2452),
    [anon_sym___reftype] = ACTIONS(2454),
    [anon_sym___refvalue] = ACTIONS(2454),
    [anon_sym_sizeof] = ACTIONS(2454),
    [anon_sym_typeof] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [sym_integer_literal] = ACTIONS(2454),
    [sym_null_literal] = ACTIONS(2454),
    [sym_real_literal] = ACTIONS(2452),
    [sym_verbatim_string_literal] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2454),
    [anon_sym_nameof] = ACTIONS(2454),
    [sym_void_keyword] = ACTIONS(2454),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1610] = {
    [sym__preprocessor_call] = STATE(1610),
    [ts_builtin_sym_end] = ACTIONS(2456),
    [sym__identifier_token] = ACTIONS(2458),
    [anon_sym_extern] = ACTIONS(2458),
    [anon_sym_alias] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_global] = ACTIONS(2458),
    [anon_sym_using] = ACTIONS(2458),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_fixed] = ACTIONS(2458),
    [anon_sym_internal] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_partial] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_ref] = ACTIONS(2458),
    [anon_sym_sealed] = ACTIONS(2458),
    [anon_sym_unsafe] = ACTIONS(2458),
    [anon_sym_virtual] = ACTIONS(2458),
    [anon_sym_volatile] = ACTIONS(2458),
    [anon_sym_this] = ACTIONS(2458),
    [anon_sym_base] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_TILDE] = ACTIONS(2456),
    [anon_sym_where] = ACTIONS(2458),
    [anon_sym_class] = ACTIONS(2458),
    [anon_sym_struct] = ACTIONS(2458),
    [anon_sym_notnull] = ACTIONS(2458),
    [anon_sym_unmanaged] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2456),
    [anon_sym_DASH_DASH] = ACTIONS(2456),
    [anon_sym_true] = ACTIONS(2458),
    [anon_sym_false] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_CARET] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_add] = ACTIONS(2458),
    [anon_sym_remove] = ACTIONS(2458),
    [anon_sym_enum] = ACTIONS(2458),
    [anon_sym_interface] = ACTIONS(2458),
    [anon_sym_delegate] = ACTIONS(2458),
    [anon_sym_record] = ACTIONS(2458),
    [anon_sym_namespace] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [sym_predefined_type] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_checked] = ACTIONS(2458),
    [anon_sym_unchecked] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_foreach] = ACTIONS(2458),
    [anon_sym_goto] = ACTIONS(2458),
    [anon_sym_default] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_else] = ACTIONS(2458),
    [anon_sym_lock] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_when] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_stackalloc] = ACTIONS(2458),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2456),
    [anon_sym___makeref] = ACTIONS(2458),
    [anon_sym_from] = ACTIONS(2458),
    [anon_sym_join] = ACTIONS(2458),
    [anon_sym_on] = ACTIONS(2458),
    [anon_sym_equals] = ACTIONS(2458),
    [anon_sym_into] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_orderby] = ACTIONS(2458),
    [anon_sym_ascending] = ACTIONS(2458),
    [anon_sym_descending] = ACTIONS(2458),
    [anon_sym_group] = ACTIONS(2458),
    [anon_sym_by] = ACTIONS(2458),
    [anon_sym_select] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2456),
    [anon_sym___reftype] = ACTIONS(2458),
    [anon_sym___refvalue] = ACTIONS(2458),
    [anon_sym_sizeof] = ACTIONS(2458),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_SQUOTE] = ACTIONS(2456),
    [sym_integer_literal] = ACTIONS(2458),
    [sym_null_literal] = ACTIONS(2458),
    [sym_real_literal] = ACTIONS(2456),
    [sym_verbatim_string_literal] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2458),
    [anon_sym_nameof] = ACTIONS(2458),
    [sym_void_keyword] = ACTIONS(2458),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1611] = {
    [sym__preprocessor_call] = STATE(1611),
    [ts_builtin_sym_end] = ACTIONS(2460),
    [sym__identifier_token] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym_alias] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_global] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_abstract] = ACTIONS(2462),
    [anon_sym_async] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_fixed] = ACTIONS(2462),
    [anon_sym_internal] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_override] = ACTIONS(2462),
    [anon_sym_partial] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_readonly] = ACTIONS(2462),
    [anon_sym_ref] = ACTIONS(2462),
    [anon_sym_sealed] = ACTIONS(2462),
    [anon_sym_unsafe] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_this] = ACTIONS(2462),
    [anon_sym_base] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_where] = ACTIONS(2462),
    [anon_sym_class] = ACTIONS(2462),
    [anon_sym_struct] = ACTIONS(2462),
    [anon_sym_notnull] = ACTIONS(2462),
    [anon_sym_unmanaged] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_true] = ACTIONS(2462),
    [anon_sym_false] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_get] = ACTIONS(2462),
    [anon_sym_set] = ACTIONS(2462),
    [anon_sym_add] = ACTIONS(2462),
    [anon_sym_remove] = ACTIONS(2462),
    [anon_sym_enum] = ACTIONS(2462),
    [anon_sym_interface] = ACTIONS(2462),
    [anon_sym_delegate] = ACTIONS(2462),
    [anon_sym_record] = ACTIONS(2462),
    [anon_sym_namespace] = ACTIONS(2462),
    [anon_sym_var] = ACTIONS(2462),
    [sym_predefined_type] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_checked] = ACTIONS(2462),
    [anon_sym_unchecked] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_await] = ACTIONS(2462),
    [anon_sym_foreach] = ACTIONS(2462),
    [anon_sym_goto] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_else] = ACTIONS(2462),
    [anon_sym_lock] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_when] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_stackalloc] = ACTIONS(2462),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2460),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2460),
    [anon_sym___makeref] = ACTIONS(2462),
    [anon_sym_from] = ACTIONS(2462),
    [anon_sym_join] = ACTIONS(2462),
    [anon_sym_on] = ACTIONS(2462),
    [anon_sym_equals] = ACTIONS(2462),
    [anon_sym_into] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_orderby] = ACTIONS(2462),
    [anon_sym_ascending] = ACTIONS(2462),
    [anon_sym_descending] = ACTIONS(2462),
    [anon_sym_group] = ACTIONS(2462),
    [anon_sym_by] = ACTIONS(2462),
    [anon_sym_select] = ACTIONS(2462),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym___reftype] = ACTIONS(2462),
    [anon_sym___refvalue] = ACTIONS(2462),
    [anon_sym_sizeof] = ACTIONS(2462),
    [anon_sym_typeof] = ACTIONS(2462),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_integer_literal] = ACTIONS(2462),
    [sym_null_literal] = ACTIONS(2462),
    [sym_real_literal] = ACTIONS(2460),
    [sym_verbatim_string_literal] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2462),
    [anon_sym_nameof] = ACTIONS(2462),
    [sym_void_keyword] = ACTIONS(2462),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1612] = {
    [sym__preprocessor_call] = STATE(1612),
    [ts_builtin_sym_end] = ACTIONS(2464),
    [sym__identifier_token] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym_alias] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_global] = ACTIONS(2466),
    [anon_sym_using] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2466),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_fixed] = ACTIONS(2466),
    [anon_sym_internal] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_override] = ACTIONS(2466),
    [anon_sym_partial] = ACTIONS(2466),
    [anon_sym_private] = ACTIONS(2466),
    [anon_sym_protected] = ACTIONS(2466),
    [anon_sym_public] = ACTIONS(2466),
    [anon_sym_readonly] = ACTIONS(2466),
    [anon_sym_ref] = ACTIONS(2466),
    [anon_sym_sealed] = ACTIONS(2466),
    [anon_sym_unsafe] = ACTIONS(2466),
    [anon_sym_virtual] = ACTIONS(2466),
    [anon_sym_volatile] = ACTIONS(2466),
    [anon_sym_this] = ACTIONS(2466),
    [anon_sym_base] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_where] = ACTIONS(2466),
    [anon_sym_class] = ACTIONS(2466),
    [anon_sym_struct] = ACTIONS(2466),
    [anon_sym_notnull] = ACTIONS(2466),
    [anon_sym_unmanaged] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_true] = ACTIONS(2466),
    [anon_sym_false] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_get] = ACTIONS(2466),
    [anon_sym_set] = ACTIONS(2466),
    [anon_sym_add] = ACTIONS(2466),
    [anon_sym_remove] = ACTIONS(2466),
    [anon_sym_enum] = ACTIONS(2466),
    [anon_sym_interface] = ACTIONS(2466),
    [anon_sym_delegate] = ACTIONS(2466),
    [anon_sym_record] = ACTIONS(2466),
    [anon_sym_namespace] = ACTIONS(2466),
    [anon_sym_var] = ACTIONS(2466),
    [sym_predefined_type] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_checked] = ACTIONS(2466),
    [anon_sym_unchecked] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_await] = ACTIONS(2466),
    [anon_sym_foreach] = ACTIONS(2466),
    [anon_sym_goto] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_else] = ACTIONS(2466),
    [anon_sym_lock] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_when] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_stackalloc] = ACTIONS(2466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2464),
    [anon_sym___makeref] = ACTIONS(2466),
    [anon_sym_from] = ACTIONS(2466),
    [anon_sym_join] = ACTIONS(2466),
    [anon_sym_on] = ACTIONS(2466),
    [anon_sym_equals] = ACTIONS(2466),
    [anon_sym_into] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_orderby] = ACTIONS(2466),
    [anon_sym_ascending] = ACTIONS(2466),
    [anon_sym_descending] = ACTIONS(2466),
    [anon_sym_group] = ACTIONS(2466),
    [anon_sym_by] = ACTIONS(2466),
    [anon_sym_select] = ACTIONS(2466),
    [anon_sym_DOT_DOT] = ACTIONS(2464),
    [anon_sym___reftype] = ACTIONS(2466),
    [anon_sym___refvalue] = ACTIONS(2466),
    [anon_sym_sizeof] = ACTIONS(2466),
    [anon_sym_typeof] = ACTIONS(2466),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [sym_integer_literal] = ACTIONS(2466),
    [sym_null_literal] = ACTIONS(2466),
    [sym_real_literal] = ACTIONS(2464),
    [sym_verbatim_string_literal] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2466),
    [anon_sym_nameof] = ACTIONS(2466),
    [sym_void_keyword] = ACTIONS(2466),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1613] = {
    [sym__preprocessor_call] = STATE(1613),
    [ts_builtin_sym_end] = ACTIONS(2468),
    [sym__identifier_token] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym_alias] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_global] = ACTIONS(2470),
    [anon_sym_using] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_abstract] = ACTIONS(2470),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_fixed] = ACTIONS(2470),
    [anon_sym_internal] = ACTIONS(2470),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_override] = ACTIONS(2470),
    [anon_sym_partial] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_readonly] = ACTIONS(2470),
    [anon_sym_ref] = ACTIONS(2470),
    [anon_sym_sealed] = ACTIONS(2470),
    [anon_sym_unsafe] = ACTIONS(2470),
    [anon_sym_virtual] = ACTIONS(2470),
    [anon_sym_volatile] = ACTIONS(2470),
    [anon_sym_this] = ACTIONS(2470),
    [anon_sym_base] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_where] = ACTIONS(2470),
    [anon_sym_class] = ACTIONS(2470),
    [anon_sym_struct] = ACTIONS(2470),
    [anon_sym_notnull] = ACTIONS(2470),
    [anon_sym_unmanaged] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_true] = ACTIONS(2470),
    [anon_sym_false] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_get] = ACTIONS(2470),
    [anon_sym_set] = ACTIONS(2470),
    [anon_sym_add] = ACTIONS(2470),
    [anon_sym_remove] = ACTIONS(2470),
    [anon_sym_enum] = ACTIONS(2470),
    [anon_sym_interface] = ACTIONS(2470),
    [anon_sym_delegate] = ACTIONS(2470),
    [anon_sym_record] = ACTIONS(2470),
    [anon_sym_namespace] = ACTIONS(2470),
    [anon_sym_var] = ACTIONS(2470),
    [sym_predefined_type] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_checked] = ACTIONS(2470),
    [anon_sym_unchecked] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_await] = ACTIONS(2470),
    [anon_sym_foreach] = ACTIONS(2470),
    [anon_sym_goto] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_else] = ACTIONS(2470),
    [anon_sym_lock] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_when] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_stackalloc] = ACTIONS(2470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2468),
    [anon_sym___makeref] = ACTIONS(2470),
    [anon_sym_from] = ACTIONS(2470),
    [anon_sym_join] = ACTIONS(2470),
    [anon_sym_on] = ACTIONS(2470),
    [anon_sym_equals] = ACTIONS(2470),
    [anon_sym_into] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_orderby] = ACTIONS(2470),
    [anon_sym_ascending] = ACTIONS(2470),
    [anon_sym_descending] = ACTIONS(2470),
    [anon_sym_group] = ACTIONS(2470),
    [anon_sym_by] = ACTIONS(2470),
    [anon_sym_select] = ACTIONS(2470),
    [anon_sym_DOT_DOT] = ACTIONS(2468),
    [anon_sym___reftype] = ACTIONS(2470),
    [anon_sym___refvalue] = ACTIONS(2470),
    [anon_sym_sizeof] = ACTIONS(2470),
    [anon_sym_typeof] = ACTIONS(2470),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [sym_integer_literal] = ACTIONS(2470),
    [sym_null_literal] = ACTIONS(2470),
    [sym_real_literal] = ACTIONS(2468),
    [sym_verbatim_string_literal] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2470),
    [anon_sym_nameof] = ACTIONS(2470),
    [sym_void_keyword] = ACTIONS(2470),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1614] = {
    [sym__preprocessor_call] = STATE(1614),
    [ts_builtin_sym_end] = ACTIONS(2472),
    [sym__identifier_token] = ACTIONS(2474),
    [anon_sym_extern] = ACTIONS(2474),
    [anon_sym_alias] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_global] = ACTIONS(2474),
    [anon_sym_using] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_async] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_fixed] = ACTIONS(2474),
    [anon_sym_internal] = ACTIONS(2474),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_override] = ACTIONS(2474),
    [anon_sym_partial] = ACTIONS(2474),
    [anon_sym_private] = ACTIONS(2474),
    [anon_sym_protected] = ACTIONS(2474),
    [anon_sym_public] = ACTIONS(2474),
    [anon_sym_readonly] = ACTIONS(2474),
    [anon_sym_ref] = ACTIONS(2474),
    [anon_sym_sealed] = ACTIONS(2474),
    [anon_sym_unsafe] = ACTIONS(2474),
    [anon_sym_virtual] = ACTIONS(2474),
    [anon_sym_volatile] = ACTIONS(2474),
    [anon_sym_this] = ACTIONS(2474),
    [anon_sym_base] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_where] = ACTIONS(2474),
    [anon_sym_class] = ACTIONS(2474),
    [anon_sym_struct] = ACTIONS(2474),
    [anon_sym_notnull] = ACTIONS(2474),
    [anon_sym_unmanaged] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_true] = ACTIONS(2474),
    [anon_sym_false] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_CARET] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_get] = ACTIONS(2474),
    [anon_sym_set] = ACTIONS(2474),
    [anon_sym_add] = ACTIONS(2474),
    [anon_sym_remove] = ACTIONS(2474),
    [anon_sym_enum] = ACTIONS(2474),
    [anon_sym_interface] = ACTIONS(2474),
    [anon_sym_delegate] = ACTIONS(2474),
    [anon_sym_record] = ACTIONS(2474),
    [anon_sym_namespace] = ACTIONS(2474),
    [anon_sym_var] = ACTIONS(2474),
    [sym_predefined_type] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_checked] = ACTIONS(2474),
    [anon_sym_unchecked] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_await] = ACTIONS(2474),
    [anon_sym_foreach] = ACTIONS(2474),
    [anon_sym_goto] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_lock] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_when] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_stackalloc] = ACTIONS(2474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2472),
    [anon_sym___makeref] = ACTIONS(2474),
    [anon_sym_from] = ACTIONS(2474),
    [anon_sym_join] = ACTIONS(2474),
    [anon_sym_on] = ACTIONS(2474),
    [anon_sym_equals] = ACTIONS(2474),
    [anon_sym_into] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_orderby] = ACTIONS(2474),
    [anon_sym_ascending] = ACTIONS(2474),
    [anon_sym_descending] = ACTIONS(2474),
    [anon_sym_group] = ACTIONS(2474),
    [anon_sym_by] = ACTIONS(2474),
    [anon_sym_select] = ACTIONS(2474),
    [anon_sym_DOT_DOT] = ACTIONS(2472),
    [anon_sym___reftype] = ACTIONS(2474),
    [anon_sym___refvalue] = ACTIONS(2474),
    [anon_sym_sizeof] = ACTIONS(2474),
    [anon_sym_typeof] = ACTIONS(2474),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [sym_integer_literal] = ACTIONS(2474),
    [sym_null_literal] = ACTIONS(2474),
    [sym_real_literal] = ACTIONS(2472),
    [sym_verbatim_string_literal] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2474),
    [anon_sym_nameof] = ACTIONS(2474),
    [sym_void_keyword] = ACTIONS(2474),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1615] = {
    [sym__preprocessor_call] = STATE(1615),
    [ts_builtin_sym_end] = ACTIONS(2476),
    [sym__identifier_token] = ACTIONS(2478),
    [anon_sym_extern] = ACTIONS(2478),
    [anon_sym_alias] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_global] = ACTIONS(2478),
    [anon_sym_using] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_abstract] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [anon_sym_fixed] = ACTIONS(2478),
    [anon_sym_internal] = ACTIONS(2478),
    [anon_sym_new] = ACTIONS(2478),
    [anon_sym_override] = ACTIONS(2478),
    [anon_sym_partial] = ACTIONS(2478),
    [anon_sym_private] = ACTIONS(2478),
    [anon_sym_protected] = ACTIONS(2478),
    [anon_sym_public] = ACTIONS(2478),
    [anon_sym_readonly] = ACTIONS(2478),
    [anon_sym_ref] = ACTIONS(2478),
    [anon_sym_sealed] = ACTIONS(2478),
    [anon_sym_unsafe] = ACTIONS(2478),
    [anon_sym_virtual] = ACTIONS(2478),
    [anon_sym_volatile] = ACTIONS(2478),
    [anon_sym_this] = ACTIONS(2478),
    [anon_sym_base] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_TILDE] = ACTIONS(2476),
    [anon_sym_where] = ACTIONS(2478),
    [anon_sym_class] = ACTIONS(2478),
    [anon_sym_struct] = ACTIONS(2478),
    [anon_sym_notnull] = ACTIONS(2478),
    [anon_sym_unmanaged] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_true] = ACTIONS(2478),
    [anon_sym_false] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2476),
    [anon_sym_CARET] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_get] = ACTIONS(2478),
    [anon_sym_set] = ACTIONS(2478),
    [anon_sym_add] = ACTIONS(2478),
    [anon_sym_remove] = ACTIONS(2478),
    [anon_sym_enum] = ACTIONS(2478),
    [anon_sym_interface] = ACTIONS(2478),
    [anon_sym_delegate] = ACTIONS(2478),
    [anon_sym_record] = ACTIONS(2478),
    [anon_sym_namespace] = ACTIONS(2478),
    [anon_sym_var] = ACTIONS(2478),
    [sym_predefined_type] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_checked] = ACTIONS(2478),
    [anon_sym_unchecked] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_do] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_await] = ACTIONS(2478),
    [anon_sym_foreach] = ACTIONS(2478),
    [anon_sym_goto] = ACTIONS(2478),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_if] = ACTIONS(2478),
    [anon_sym_else] = ACTIONS(2478),
    [anon_sym_lock] = ACTIONS(2478),
    [anon_sym_switch] = ACTIONS(2478),
    [anon_sym_when] = ACTIONS(2478),
    [anon_sym_throw] = ACTIONS(2478),
    [anon_sym_try] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2478),
    [anon_sym_stackalloc] = ACTIONS(2478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2476),
    [anon_sym___makeref] = ACTIONS(2478),
    [anon_sym_from] = ACTIONS(2478),
    [anon_sym_join] = ACTIONS(2478),
    [anon_sym_on] = ACTIONS(2478),
    [anon_sym_equals] = ACTIONS(2478),
    [anon_sym_into] = ACTIONS(2478),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_orderby] = ACTIONS(2478),
    [anon_sym_ascending] = ACTIONS(2478),
    [anon_sym_descending] = ACTIONS(2478),
    [anon_sym_group] = ACTIONS(2478),
    [anon_sym_by] = ACTIONS(2478),
    [anon_sym_select] = ACTIONS(2478),
    [anon_sym_DOT_DOT] = ACTIONS(2476),
    [anon_sym___reftype] = ACTIONS(2478),
    [anon_sym___refvalue] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2478),
    [anon_sym_typeof] = ACTIONS(2478),
    [anon_sym_SQUOTE] = ACTIONS(2476),
    [sym_integer_literal] = ACTIONS(2478),
    [sym_null_literal] = ACTIONS(2478),
    [sym_real_literal] = ACTIONS(2476),
    [sym_verbatim_string_literal] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2478),
    [anon_sym_nameof] = ACTIONS(2478),
    [sym_void_keyword] = ACTIONS(2478),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1616] = {
    [sym__preprocessor_call] = STATE(1616),
    [ts_builtin_sym_end] = ACTIONS(2480),
    [sym__identifier_token] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym_alias] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_global] = ACTIONS(2482),
    [anon_sym_using] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_fixed] = ACTIONS(2482),
    [anon_sym_internal] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_partial] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_ref] = ACTIONS(2482),
    [anon_sym_sealed] = ACTIONS(2482),
    [anon_sym_unsafe] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_this] = ACTIONS(2482),
    [anon_sym_base] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_TILDE] = ACTIONS(2480),
    [anon_sym_where] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_notnull] = ACTIONS(2482),
    [anon_sym_unmanaged] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [anon_sym_true] = ACTIONS(2482),
    [anon_sym_false] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(2480),
    [anon_sym_CARET] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_add] = ACTIONS(2482),
    [anon_sym_remove] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_delegate] = ACTIONS(2482),
    [anon_sym_record] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [sym_predefined_type] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_checked] = ACTIONS(2482),
    [anon_sym_unchecked] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_foreach] = ACTIONS(2482),
    [anon_sym_goto] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_lock] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_when] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_stackalloc] = ACTIONS(2482),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2480),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2480),
    [anon_sym___makeref] = ACTIONS(2482),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_join] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_equals] = ACTIONS(2482),
    [anon_sym_into] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_orderby] = ACTIONS(2482),
    [anon_sym_ascending] = ACTIONS(2482),
    [anon_sym_descending] = ACTIONS(2482),
    [anon_sym_group] = ACTIONS(2482),
    [anon_sym_by] = ACTIONS(2482),
    [anon_sym_select] = ACTIONS(2482),
    [anon_sym_DOT_DOT] = ACTIONS(2480),
    [anon_sym___reftype] = ACTIONS(2482),
    [anon_sym___refvalue] = ACTIONS(2482),
    [anon_sym_sizeof] = ACTIONS(2482),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [sym_integer_literal] = ACTIONS(2482),
    [sym_null_literal] = ACTIONS(2482),
    [sym_real_literal] = ACTIONS(2480),
    [sym_verbatim_string_literal] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2482),
    [anon_sym_nameof] = ACTIONS(2482),
    [sym_void_keyword] = ACTIONS(2482),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1617] = {
    [sym__preprocessor_call] = STATE(1617),
    [ts_builtin_sym_end] = ACTIONS(2484),
    [sym__identifier_token] = ACTIONS(2486),
    [anon_sym_extern] = ACTIONS(2486),
    [anon_sym_alias] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_global] = ACTIONS(2486),
    [anon_sym_using] = ACTIONS(2486),
    [anon_sym_static] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_fixed] = ACTIONS(2486),
    [anon_sym_internal] = ACTIONS(2486),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_override] = ACTIONS(2486),
    [anon_sym_partial] = ACTIONS(2486),
    [anon_sym_private] = ACTIONS(2486),
    [anon_sym_protected] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2486),
    [anon_sym_readonly] = ACTIONS(2486),
    [anon_sym_ref] = ACTIONS(2486),
    [anon_sym_sealed] = ACTIONS(2486),
    [anon_sym_unsafe] = ACTIONS(2486),
    [anon_sym_virtual] = ACTIONS(2486),
    [anon_sym_volatile] = ACTIONS(2486),
    [anon_sym_this] = ACTIONS(2486),
    [anon_sym_base] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_where] = ACTIONS(2486),
    [anon_sym_class] = ACTIONS(2486),
    [anon_sym_struct] = ACTIONS(2486),
    [anon_sym_notnull] = ACTIONS(2486),
    [anon_sym_unmanaged] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_true] = ACTIONS(2486),
    [anon_sym_false] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2486),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_CARET] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_get] = ACTIONS(2486),
    [anon_sym_set] = ACTIONS(2486),
    [anon_sym_add] = ACTIONS(2486),
    [anon_sym_remove] = ACTIONS(2486),
    [anon_sym_enum] = ACTIONS(2486),
    [anon_sym_interface] = ACTIONS(2486),
    [anon_sym_delegate] = ACTIONS(2486),
    [anon_sym_record] = ACTIONS(2486),
    [anon_sym_namespace] = ACTIONS(2486),
    [anon_sym_var] = ACTIONS(2486),
    [sym_predefined_type] = ACTIONS(2486),
    [anon_sym_break] = ACTIONS(2486),
    [anon_sym_checked] = ACTIONS(2486),
    [anon_sym_unchecked] = ACTIONS(2486),
    [anon_sym_continue] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_await] = ACTIONS(2486),
    [anon_sym_foreach] = ACTIONS(2486),
    [anon_sym_goto] = ACTIONS(2486),
    [anon_sym_default] = ACTIONS(2486),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_else] = ACTIONS(2486),
    [anon_sym_lock] = ACTIONS(2486),
    [anon_sym_switch] = ACTIONS(2486),
    [anon_sym_when] = ACTIONS(2486),
    [anon_sym_throw] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [anon_sym_yield] = ACTIONS(2486),
    [anon_sym_stackalloc] = ACTIONS(2486),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2484),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2484),
    [anon_sym___makeref] = ACTIONS(2486),
    [anon_sym_from] = ACTIONS(2486),
    [anon_sym_join] = ACTIONS(2486),
    [anon_sym_on] = ACTIONS(2486),
    [anon_sym_equals] = ACTIONS(2486),
    [anon_sym_into] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_orderby] = ACTIONS(2486),
    [anon_sym_ascending] = ACTIONS(2486),
    [anon_sym_descending] = ACTIONS(2486),
    [anon_sym_group] = ACTIONS(2486),
    [anon_sym_by] = ACTIONS(2486),
    [anon_sym_select] = ACTIONS(2486),
    [anon_sym_DOT_DOT] = ACTIONS(2484),
    [anon_sym___reftype] = ACTIONS(2486),
    [anon_sym___refvalue] = ACTIONS(2486),
    [anon_sym_sizeof] = ACTIONS(2486),
    [anon_sym_typeof] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_integer_literal] = ACTIONS(2486),
    [sym_null_literal] = ACTIONS(2486),
    [sym_real_literal] = ACTIONS(2484),
    [sym_verbatim_string_literal] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2486),
    [anon_sym_nameof] = ACTIONS(2486),
    [sym_void_keyword] = ACTIONS(2486),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1618] = {
    [sym__preprocessor_call] = STATE(1618),
    [ts_builtin_sym_end] = ACTIONS(2488),
    [sym__identifier_token] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym_alias] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_global] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2488),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_fixed] = ACTIONS(2490),
    [anon_sym_internal] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2490),
    [anon_sym_override] = ACTIONS(2490),
    [anon_sym_partial] = ACTIONS(2490),
    [anon_sym_private] = ACTIONS(2490),
    [anon_sym_protected] = ACTIONS(2490),
    [anon_sym_public] = ACTIONS(2490),
    [anon_sym_readonly] = ACTIONS(2490),
    [anon_sym_ref] = ACTIONS(2490),
    [anon_sym_sealed] = ACTIONS(2490),
    [anon_sym_unsafe] = ACTIONS(2490),
    [anon_sym_virtual] = ACTIONS(2490),
    [anon_sym_volatile] = ACTIONS(2490),
    [anon_sym_this] = ACTIONS(2490),
    [anon_sym_base] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_TILDE] = ACTIONS(2488),
    [anon_sym_where] = ACTIONS(2490),
    [anon_sym_class] = ACTIONS(2490),
    [anon_sym_struct] = ACTIONS(2490),
    [anon_sym_notnull] = ACTIONS(2490),
    [anon_sym_unmanaged] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2488),
    [anon_sym_true] = ACTIONS(2490),
    [anon_sym_false] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2490),
    [anon_sym_set] = ACTIONS(2490),
    [anon_sym_add] = ACTIONS(2490),
    [anon_sym_remove] = ACTIONS(2490),
    [anon_sym_enum] = ACTIONS(2490),
    [anon_sym_interface] = ACTIONS(2490),
    [anon_sym_delegate] = ACTIONS(2490),
    [anon_sym_record] = ACTIONS(2490),
    [anon_sym_namespace] = ACTIONS(2490),
    [anon_sym_var] = ACTIONS(2490),
    [sym_predefined_type] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_checked] = ACTIONS(2490),
    [anon_sym_unchecked] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_await] = ACTIONS(2490),
    [anon_sym_foreach] = ACTIONS(2490),
    [anon_sym_goto] = ACTIONS(2490),
    [anon_sym_default] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_lock] = ACTIONS(2490),
    [anon_sym_switch] = ACTIONS(2490),
    [anon_sym_when] = ACTIONS(2490),
    [anon_sym_throw] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_yield] = ACTIONS(2490),
    [anon_sym_stackalloc] = ACTIONS(2490),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2488),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2488),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2488),
    [anon_sym___makeref] = ACTIONS(2490),
    [anon_sym_from] = ACTIONS(2490),
    [anon_sym_join] = ACTIONS(2490),
    [anon_sym_on] = ACTIONS(2490),
    [anon_sym_equals] = ACTIONS(2490),
    [anon_sym_into] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_orderby] = ACTIONS(2490),
    [anon_sym_ascending] = ACTIONS(2490),
    [anon_sym_descending] = ACTIONS(2490),
    [anon_sym_group] = ACTIONS(2490),
    [anon_sym_by] = ACTIONS(2490),
    [anon_sym_select] = ACTIONS(2490),
    [anon_sym_DOT_DOT] = ACTIONS(2488),
    [anon_sym___reftype] = ACTIONS(2490),
    [anon_sym___refvalue] = ACTIONS(2490),
    [anon_sym_sizeof] = ACTIONS(2490),
    [anon_sym_typeof] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2488),
    [sym_integer_literal] = ACTIONS(2490),
    [sym_null_literal] = ACTIONS(2490),
    [sym_real_literal] = ACTIONS(2488),
    [sym_verbatim_string_literal] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2490),
    [anon_sym_nameof] = ACTIONS(2490),
    [sym_void_keyword] = ACTIONS(2490),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1619] = {
    [sym__preprocessor_call] = STATE(1619),
    [ts_builtin_sym_end] = ACTIONS(2492),
    [sym__identifier_token] = ACTIONS(2494),
    [anon_sym_extern] = ACTIONS(2494),
    [anon_sym_alias] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_using] = ACTIONS(2494),
    [anon_sym_static] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_async] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_fixed] = ACTIONS(2494),
    [anon_sym_internal] = ACTIONS(2494),
    [anon_sym_new] = ACTIONS(2494),
    [anon_sym_override] = ACTIONS(2494),
    [anon_sym_partial] = ACTIONS(2494),
    [anon_sym_private] = ACTIONS(2494),
    [anon_sym_protected] = ACTIONS(2494),
    [anon_sym_public] = ACTIONS(2494),
    [anon_sym_readonly] = ACTIONS(2494),
    [anon_sym_ref] = ACTIONS(2494),
    [anon_sym_sealed] = ACTIONS(2494),
    [anon_sym_unsafe] = ACTIONS(2494),
    [anon_sym_virtual] = ACTIONS(2494),
    [anon_sym_volatile] = ACTIONS(2494),
    [anon_sym_this] = ACTIONS(2494),
    [anon_sym_base] = ACTIONS(2494),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_where] = ACTIONS(2494),
    [anon_sym_class] = ACTIONS(2494),
    [anon_sym_struct] = ACTIONS(2494),
    [anon_sym_notnull] = ACTIONS(2494),
    [anon_sym_unmanaged] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [anon_sym_true] = ACTIONS(2494),
    [anon_sym_false] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_get] = ACTIONS(2494),
    [anon_sym_set] = ACTIONS(2494),
    [anon_sym_add] = ACTIONS(2494),
    [anon_sym_remove] = ACTIONS(2494),
    [anon_sym_enum] = ACTIONS(2494),
    [anon_sym_interface] = ACTIONS(2494),
    [anon_sym_delegate] = ACTIONS(2494),
    [anon_sym_record] = ACTIONS(2494),
    [anon_sym_namespace] = ACTIONS(2494),
    [anon_sym_var] = ACTIONS(2494),
    [sym_predefined_type] = ACTIONS(2494),
    [anon_sym_break] = ACTIONS(2494),
    [anon_sym_checked] = ACTIONS(2494),
    [anon_sym_unchecked] = ACTIONS(2494),
    [anon_sym_continue] = ACTIONS(2494),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_await] = ACTIONS(2494),
    [anon_sym_foreach] = ACTIONS(2494),
    [anon_sym_goto] = ACTIONS(2494),
    [anon_sym_default] = ACTIONS(2494),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_lock] = ACTIONS(2494),
    [anon_sym_switch] = ACTIONS(2494),
    [anon_sym_when] = ACTIONS(2494),
    [anon_sym_throw] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_yield] = ACTIONS(2494),
    [anon_sym_stackalloc] = ACTIONS(2494),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2492),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2492),
    [anon_sym___makeref] = ACTIONS(2494),
    [anon_sym_from] = ACTIONS(2494),
    [anon_sym_join] = ACTIONS(2494),
    [anon_sym_on] = ACTIONS(2494),
    [anon_sym_equals] = ACTIONS(2494),
    [anon_sym_into] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_orderby] = ACTIONS(2494),
    [anon_sym_ascending] = ACTIONS(2494),
    [anon_sym_descending] = ACTIONS(2494),
    [anon_sym_group] = ACTIONS(2494),
    [anon_sym_by] = ACTIONS(2494),
    [anon_sym_select] = ACTIONS(2494),
    [anon_sym_DOT_DOT] = ACTIONS(2492),
    [anon_sym___reftype] = ACTIONS(2494),
    [anon_sym___refvalue] = ACTIONS(2494),
    [anon_sym_sizeof] = ACTIONS(2494),
    [anon_sym_typeof] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [sym_integer_literal] = ACTIONS(2494),
    [sym_null_literal] = ACTIONS(2494),
    [sym_real_literal] = ACTIONS(2492),
    [sym_verbatim_string_literal] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2494),
    [anon_sym_nameof] = ACTIONS(2494),
    [sym_void_keyword] = ACTIONS(2494),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1620] = {
    [sym__preprocessor_call] = STATE(1620),
    [ts_builtin_sym_end] = ACTIONS(2496),
    [sym__identifier_token] = ACTIONS(2498),
    [anon_sym_extern] = ACTIONS(2498),
    [anon_sym_alias] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_global] = ACTIONS(2498),
    [anon_sym_using] = ACTIONS(2498),
    [anon_sym_static] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_async] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_fixed] = ACTIONS(2498),
    [anon_sym_internal] = ACTIONS(2498),
    [anon_sym_new] = ACTIONS(2498),
    [anon_sym_override] = ACTIONS(2498),
    [anon_sym_partial] = ACTIONS(2498),
    [anon_sym_private] = ACTIONS(2498),
    [anon_sym_protected] = ACTIONS(2498),
    [anon_sym_public] = ACTIONS(2498),
    [anon_sym_readonly] = ACTIONS(2498),
    [anon_sym_ref] = ACTIONS(2498),
    [anon_sym_sealed] = ACTIONS(2498),
    [anon_sym_unsafe] = ACTIONS(2498),
    [anon_sym_virtual] = ACTIONS(2498),
    [anon_sym_volatile] = ACTIONS(2498),
    [anon_sym_this] = ACTIONS(2498),
    [anon_sym_base] = ACTIONS(2498),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_where] = ACTIONS(2498),
    [anon_sym_class] = ACTIONS(2498),
    [anon_sym_struct] = ACTIONS(2498),
    [anon_sym_notnull] = ACTIONS(2498),
    [anon_sym_unmanaged] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_PLUS_PLUS] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2496),
    [anon_sym_true] = ACTIONS(2498),
    [anon_sym_false] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_STAR] = ACTIONS(2496),
    [anon_sym_CARET] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_get] = ACTIONS(2498),
    [anon_sym_set] = ACTIONS(2498),
    [anon_sym_add] = ACTIONS(2498),
    [anon_sym_remove] = ACTIONS(2498),
    [anon_sym_enum] = ACTIONS(2498),
    [anon_sym_interface] = ACTIONS(2498),
    [anon_sym_delegate] = ACTIONS(2498),
    [anon_sym_record] = ACTIONS(2498),
    [anon_sym_namespace] = ACTIONS(2498),
    [anon_sym_var] = ACTIONS(2498),
    [sym_predefined_type] = ACTIONS(2498),
    [anon_sym_break] = ACTIONS(2498),
    [anon_sym_checked] = ACTIONS(2498),
    [anon_sym_unchecked] = ACTIONS(2498),
    [anon_sym_continue] = ACTIONS(2498),
    [anon_sym_do] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_await] = ACTIONS(2498),
    [anon_sym_foreach] = ACTIONS(2498),
    [anon_sym_goto] = ACTIONS(2498),
    [anon_sym_default] = ACTIONS(2498),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_else] = ACTIONS(2498),
    [anon_sym_lock] = ACTIONS(2498),
    [anon_sym_switch] = ACTIONS(2498),
    [anon_sym_when] = ACTIONS(2498),
    [anon_sym_throw] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_yield] = ACTIONS(2498),
    [anon_sym_stackalloc] = ACTIONS(2498),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2496),
    [anon_sym_DQUOTE] = ACTIONS(2496),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2496),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2496),
    [anon_sym___makeref] = ACTIONS(2498),
    [anon_sym_from] = ACTIONS(2498),
    [anon_sym_join] = ACTIONS(2498),
    [anon_sym_on] = ACTIONS(2498),
    [anon_sym_equals] = ACTIONS(2498),
    [anon_sym_into] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_orderby] = ACTIONS(2498),
    [anon_sym_ascending] = ACTIONS(2498),
    [anon_sym_descending] = ACTIONS(2498),
    [anon_sym_group] = ACTIONS(2498),
    [anon_sym_by] = ACTIONS(2498),
    [anon_sym_select] = ACTIONS(2498),
    [anon_sym_DOT_DOT] = ACTIONS(2496),
    [anon_sym___reftype] = ACTIONS(2498),
    [anon_sym___refvalue] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2498),
    [anon_sym_typeof] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2496),
    [sym_integer_literal] = ACTIONS(2498),
    [sym_null_literal] = ACTIONS(2498),
    [sym_real_literal] = ACTIONS(2496),
    [sym_verbatim_string_literal] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2498),
    [anon_sym_nameof] = ACTIONS(2498),
    [sym_void_keyword] = ACTIONS(2498),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1621] = {
    [sym__preprocessor_call] = STATE(1621),
    [ts_builtin_sym_end] = ACTIONS(2195),
    [sym__identifier_token] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym_alias] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2195),
    [anon_sym_global] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_fixed] = ACTIONS(2197),
    [anon_sym_internal] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_partial] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2197),
    [anon_sym_sealed] = ACTIONS(2197),
    [anon_sym_unsafe] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2197),
    [anon_sym_base] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2195),
    [anon_sym_TILDE] = ACTIONS(2195),
    [anon_sym_where] = ACTIONS(2197),
    [anon_sym_class] = ACTIONS(2197),
    [anon_sym_struct] = ACTIONS(2197),
    [anon_sym_notnull] = ACTIONS(2197),
    [anon_sym_unmanaged] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2195),
    [anon_sym_PLUS_PLUS] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2195),
    [anon_sym_true] = ACTIONS(2197),
    [anon_sym_false] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2195),
    [anon_sym_CARET] = ACTIONS(2195),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_add] = ACTIONS(2197),
    [anon_sym_remove] = ACTIONS(2197),
    [anon_sym_enum] = ACTIONS(2197),
    [anon_sym_interface] = ACTIONS(2197),
    [anon_sym_delegate] = ACTIONS(2197),
    [anon_sym_record] = ACTIONS(2197),
    [anon_sym_namespace] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [sym_predefined_type] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_checked] = ACTIONS(2197),
    [anon_sym_unchecked] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_foreach] = ACTIONS(2197),
    [anon_sym_goto] = ACTIONS(2197),
    [anon_sym_default] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_lock] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_when] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_stackalloc] = ACTIONS(2197),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2195),
    [anon_sym_DQUOTE] = ACTIONS(2195),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2195),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2195),
    [anon_sym___makeref] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(2197),
    [anon_sym_join] = ACTIONS(2197),
    [anon_sym_on] = ACTIONS(2197),
    [anon_sym_equals] = ACTIONS(2197),
    [anon_sym_into] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_orderby] = ACTIONS(2197),
    [anon_sym_ascending] = ACTIONS(2197),
    [anon_sym_descending] = ACTIONS(2197),
    [anon_sym_group] = ACTIONS(2197),
    [anon_sym_by] = ACTIONS(2197),
    [anon_sym_select] = ACTIONS(2197),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym___reftype] = ACTIONS(2197),
    [anon_sym___refvalue] = ACTIONS(2197),
    [anon_sym_sizeof] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2195),
    [sym_integer_literal] = ACTIONS(2197),
    [sym_null_literal] = ACTIONS(2197),
    [sym_real_literal] = ACTIONS(2195),
    [sym_verbatim_string_literal] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2197),
    [anon_sym_nameof] = ACTIONS(2197),
    [sym_void_keyword] = ACTIONS(2197),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1622] = {
    [sym__preprocessor_call] = STATE(1622),
    [ts_builtin_sym_end] = ACTIONS(2500),
    [sym__identifier_token] = ACTIONS(2502),
    [anon_sym_extern] = ACTIONS(2502),
    [anon_sym_alias] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2500),
    [anon_sym_global] = ACTIONS(2502),
    [anon_sym_using] = ACTIONS(2502),
    [anon_sym_static] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2500),
    [anon_sym_abstract] = ACTIONS(2502),
    [anon_sym_async] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_fixed] = ACTIONS(2502),
    [anon_sym_internal] = ACTIONS(2502),
    [anon_sym_new] = ACTIONS(2502),
    [anon_sym_override] = ACTIONS(2502),
    [anon_sym_partial] = ACTIONS(2502),
    [anon_sym_private] = ACTIONS(2502),
    [anon_sym_protected] = ACTIONS(2502),
    [anon_sym_public] = ACTIONS(2502),
    [anon_sym_readonly] = ACTIONS(2502),
    [anon_sym_ref] = ACTIONS(2502),
    [anon_sym_sealed] = ACTIONS(2502),
    [anon_sym_unsafe] = ACTIONS(2502),
    [anon_sym_virtual] = ACTIONS(2502),
    [anon_sym_volatile] = ACTIONS(2502),
    [anon_sym_this] = ACTIONS(2502),
    [anon_sym_base] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2500),
    [anon_sym_TILDE] = ACTIONS(2500),
    [anon_sym_where] = ACTIONS(2502),
    [anon_sym_class] = ACTIONS(2502),
    [anon_sym_struct] = ACTIONS(2502),
    [anon_sym_notnull] = ACTIONS(2502),
    [anon_sym_unmanaged] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2500),
    [anon_sym_true] = ACTIONS(2502),
    [anon_sym_false] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_CARET] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_get] = ACTIONS(2502),
    [anon_sym_set] = ACTIONS(2502),
    [anon_sym_add] = ACTIONS(2502),
    [anon_sym_remove] = ACTIONS(2502),
    [anon_sym_enum] = ACTIONS(2502),
    [anon_sym_interface] = ACTIONS(2502),
    [anon_sym_delegate] = ACTIONS(2502),
    [anon_sym_record] = ACTIONS(2502),
    [anon_sym_namespace] = ACTIONS(2502),
    [anon_sym_var] = ACTIONS(2502),
    [sym_predefined_type] = ACTIONS(2502),
    [anon_sym_break] = ACTIONS(2502),
    [anon_sym_checked] = ACTIONS(2502),
    [anon_sym_unchecked] = ACTIONS(2502),
    [anon_sym_continue] = ACTIONS(2502),
    [anon_sym_do] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2502),
    [anon_sym_foreach] = ACTIONS(2502),
    [anon_sym_goto] = ACTIONS(2502),
    [anon_sym_default] = ACTIONS(2502),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_lock] = ACTIONS(2502),
    [anon_sym_switch] = ACTIONS(2502),
    [anon_sym_when] = ACTIONS(2502),
    [anon_sym_throw] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [anon_sym_yield] = ACTIONS(2502),
    [anon_sym_stackalloc] = ACTIONS(2502),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2500),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2500),
    [anon_sym___makeref] = ACTIONS(2502),
    [anon_sym_from] = ACTIONS(2502),
    [anon_sym_join] = ACTIONS(2502),
    [anon_sym_on] = ACTIONS(2502),
    [anon_sym_equals] = ACTIONS(2502),
    [anon_sym_into] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_orderby] = ACTIONS(2502),
    [anon_sym_ascending] = ACTIONS(2502),
    [anon_sym_descending] = ACTIONS(2502),
    [anon_sym_group] = ACTIONS(2502),
    [anon_sym_by] = ACTIONS(2502),
    [anon_sym_select] = ACTIONS(2502),
    [anon_sym_DOT_DOT] = ACTIONS(2500),
    [anon_sym___reftype] = ACTIONS(2502),
    [anon_sym___refvalue] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2502),
    [anon_sym_typeof] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [sym_integer_literal] = ACTIONS(2502),
    [sym_null_literal] = ACTIONS(2502),
    [sym_real_literal] = ACTIONS(2500),
    [sym_verbatim_string_literal] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2502),
    [anon_sym_nameof] = ACTIONS(2502),
    [sym_void_keyword] = ACTIONS(2502),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1623] = {
    [sym__preprocessor_call] = STATE(1623),
    [ts_builtin_sym_end] = ACTIONS(2504),
    [sym__identifier_token] = ACTIONS(2506),
    [anon_sym_extern] = ACTIONS(2506),
    [anon_sym_alias] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_global] = ACTIONS(2506),
    [anon_sym_using] = ACTIONS(2506),
    [anon_sym_static] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2504),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_async] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_fixed] = ACTIONS(2506),
    [anon_sym_internal] = ACTIONS(2506),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_override] = ACTIONS(2506),
    [anon_sym_partial] = ACTIONS(2506),
    [anon_sym_private] = ACTIONS(2506),
    [anon_sym_protected] = ACTIONS(2506),
    [anon_sym_public] = ACTIONS(2506),
    [anon_sym_readonly] = ACTIONS(2506),
    [anon_sym_ref] = ACTIONS(2506),
    [anon_sym_sealed] = ACTIONS(2506),
    [anon_sym_unsafe] = ACTIONS(2506),
    [anon_sym_virtual] = ACTIONS(2506),
    [anon_sym_volatile] = ACTIONS(2506),
    [anon_sym_this] = ACTIONS(2506),
    [anon_sym_base] = ACTIONS(2506),
    [anon_sym_LBRACE] = ACTIONS(2504),
    [anon_sym_TILDE] = ACTIONS(2504),
    [anon_sym_where] = ACTIONS(2506),
    [anon_sym_class] = ACTIONS(2506),
    [anon_sym_struct] = ACTIONS(2506),
    [anon_sym_notnull] = ACTIONS(2506),
    [anon_sym_unmanaged] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_PLUS_PLUS] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2504),
    [anon_sym_true] = ACTIONS(2506),
    [anon_sym_false] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_CARET] = ACTIONS(2504),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_get] = ACTIONS(2506),
    [anon_sym_set] = ACTIONS(2506),
    [anon_sym_add] = ACTIONS(2506),
    [anon_sym_remove] = ACTIONS(2506),
    [anon_sym_enum] = ACTIONS(2506),
    [anon_sym_interface] = ACTIONS(2506),
    [anon_sym_delegate] = ACTIONS(2506),
    [anon_sym_record] = ACTIONS(2506),
    [anon_sym_namespace] = ACTIONS(2506),
    [anon_sym_var] = ACTIONS(2506),
    [sym_predefined_type] = ACTIONS(2506),
    [anon_sym_break] = ACTIONS(2506),
    [anon_sym_checked] = ACTIONS(2506),
    [anon_sym_unchecked] = ACTIONS(2506),
    [anon_sym_continue] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_await] = ACTIONS(2506),
    [anon_sym_foreach] = ACTIONS(2506),
    [anon_sym_goto] = ACTIONS(2506),
    [anon_sym_default] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_lock] = ACTIONS(2506),
    [anon_sym_switch] = ACTIONS(2506),
    [anon_sym_when] = ACTIONS(2506),
    [anon_sym_throw] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_stackalloc] = ACTIONS(2506),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2504),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2504),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2504),
    [anon_sym___makeref] = ACTIONS(2506),
    [anon_sym_from] = ACTIONS(2506),
    [anon_sym_join] = ACTIONS(2506),
    [anon_sym_on] = ACTIONS(2506),
    [anon_sym_equals] = ACTIONS(2506),
    [anon_sym_into] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_orderby] = ACTIONS(2506),
    [anon_sym_ascending] = ACTIONS(2506),
    [anon_sym_descending] = ACTIONS(2506),
    [anon_sym_group] = ACTIONS(2506),
    [anon_sym_by] = ACTIONS(2506),
    [anon_sym_select] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(2504),
    [anon_sym___reftype] = ACTIONS(2506),
    [anon_sym___refvalue] = ACTIONS(2506),
    [anon_sym_sizeof] = ACTIONS(2506),
    [anon_sym_typeof] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2504),
    [sym_integer_literal] = ACTIONS(2506),
    [sym_null_literal] = ACTIONS(2506),
    [sym_real_literal] = ACTIONS(2504),
    [sym_verbatim_string_literal] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2506),
    [anon_sym_nameof] = ACTIONS(2506),
    [sym_void_keyword] = ACTIONS(2506),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1624] = {
    [sym__preprocessor_call] = STATE(1624),
    [ts_builtin_sym_end] = ACTIONS(2508),
    [sym__identifier_token] = ACTIONS(2510),
    [anon_sym_extern] = ACTIONS(2510),
    [anon_sym_alias] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_global] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2508),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_async] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_fixed] = ACTIONS(2510),
    [anon_sym_internal] = ACTIONS(2510),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_override] = ACTIONS(2510),
    [anon_sym_partial] = ACTIONS(2510),
    [anon_sym_private] = ACTIONS(2510),
    [anon_sym_protected] = ACTIONS(2510),
    [anon_sym_public] = ACTIONS(2510),
    [anon_sym_readonly] = ACTIONS(2510),
    [anon_sym_ref] = ACTIONS(2510),
    [anon_sym_sealed] = ACTIONS(2510),
    [anon_sym_unsafe] = ACTIONS(2510),
    [anon_sym_virtual] = ACTIONS(2510),
    [anon_sym_volatile] = ACTIONS(2510),
    [anon_sym_this] = ACTIONS(2510),
    [anon_sym_base] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2508),
    [anon_sym_TILDE] = ACTIONS(2508),
    [anon_sym_where] = ACTIONS(2510),
    [anon_sym_class] = ACTIONS(2510),
    [anon_sym_struct] = ACTIONS(2510),
    [anon_sym_notnull] = ACTIONS(2510),
    [anon_sym_unmanaged] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2508),
    [anon_sym_true] = ACTIONS(2510),
    [anon_sym_false] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_get] = ACTIONS(2510),
    [anon_sym_set] = ACTIONS(2510),
    [anon_sym_add] = ACTIONS(2510),
    [anon_sym_remove] = ACTIONS(2510),
    [anon_sym_enum] = ACTIONS(2510),
    [anon_sym_interface] = ACTIONS(2510),
    [anon_sym_delegate] = ACTIONS(2510),
    [anon_sym_record] = ACTIONS(2510),
    [anon_sym_namespace] = ACTIONS(2510),
    [anon_sym_var] = ACTIONS(2510),
    [sym_predefined_type] = ACTIONS(2510),
    [anon_sym_break] = ACTIONS(2510),
    [anon_sym_checked] = ACTIONS(2510),
    [anon_sym_unchecked] = ACTIONS(2510),
    [anon_sym_continue] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_await] = ACTIONS(2510),
    [anon_sym_foreach] = ACTIONS(2510),
    [anon_sym_goto] = ACTIONS(2510),
    [anon_sym_default] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_else] = ACTIONS(2510),
    [anon_sym_lock] = ACTIONS(2510),
    [anon_sym_switch] = ACTIONS(2510),
    [anon_sym_when] = ACTIONS(2510),
    [anon_sym_throw] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_stackalloc] = ACTIONS(2510),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2508),
    [anon_sym___makeref] = ACTIONS(2510),
    [anon_sym_from] = ACTIONS(2510),
    [anon_sym_join] = ACTIONS(2510),
    [anon_sym_on] = ACTIONS(2510),
    [anon_sym_equals] = ACTIONS(2510),
    [anon_sym_into] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_orderby] = ACTIONS(2510),
    [anon_sym_ascending] = ACTIONS(2510),
    [anon_sym_descending] = ACTIONS(2510),
    [anon_sym_group] = ACTIONS(2510),
    [anon_sym_by] = ACTIONS(2510),
    [anon_sym_select] = ACTIONS(2510),
    [anon_sym_DOT_DOT] = ACTIONS(2508),
    [anon_sym___reftype] = ACTIONS(2510),
    [anon_sym___refvalue] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(2510),
    [anon_sym_typeof] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2508),
    [sym_integer_literal] = ACTIONS(2510),
    [sym_null_literal] = ACTIONS(2510),
    [sym_real_literal] = ACTIONS(2508),
    [sym_verbatim_string_literal] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2510),
    [anon_sym_nameof] = ACTIONS(2510),
    [sym_void_keyword] = ACTIONS(2510),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1625] = {
    [sym__preprocessor_call] = STATE(1625),
    [ts_builtin_sym_end] = ACTIONS(2512),
    [sym__identifier_token] = ACTIONS(2514),
    [anon_sym_extern] = ACTIONS(2514),
    [anon_sym_alias] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_global] = ACTIONS(2514),
    [anon_sym_using] = ACTIONS(2514),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_fixed] = ACTIONS(2514),
    [anon_sym_internal] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_partial] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_ref] = ACTIONS(2514),
    [anon_sym_sealed] = ACTIONS(2514),
    [anon_sym_unsafe] = ACTIONS(2514),
    [anon_sym_virtual] = ACTIONS(2514),
    [anon_sym_volatile] = ACTIONS(2514),
    [anon_sym_this] = ACTIONS(2514),
    [anon_sym_base] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_where] = ACTIONS(2514),
    [anon_sym_class] = ACTIONS(2514),
    [anon_sym_struct] = ACTIONS(2514),
    [anon_sym_notnull] = ACTIONS(2514),
    [anon_sym_unmanaged] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_true] = ACTIONS(2514),
    [anon_sym_false] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_CARET] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_add] = ACTIONS(2514),
    [anon_sym_remove] = ACTIONS(2514),
    [anon_sym_enum] = ACTIONS(2514),
    [anon_sym_interface] = ACTIONS(2514),
    [anon_sym_delegate] = ACTIONS(2514),
    [anon_sym_record] = ACTIONS(2514),
    [anon_sym_namespace] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [sym_predefined_type] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_checked] = ACTIONS(2514),
    [anon_sym_unchecked] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_foreach] = ACTIONS(2514),
    [anon_sym_goto] = ACTIONS(2514),
    [anon_sym_default] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_lock] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_when] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_stackalloc] = ACTIONS(2514),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2512),
    [anon_sym___makeref] = ACTIONS(2514),
    [anon_sym_from] = ACTIONS(2514),
    [anon_sym_join] = ACTIONS(2514),
    [anon_sym_on] = ACTIONS(2514),
    [anon_sym_equals] = ACTIONS(2514),
    [anon_sym_into] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_orderby] = ACTIONS(2514),
    [anon_sym_ascending] = ACTIONS(2514),
    [anon_sym_descending] = ACTIONS(2514),
    [anon_sym_group] = ACTIONS(2514),
    [anon_sym_by] = ACTIONS(2514),
    [anon_sym_select] = ACTIONS(2514),
    [anon_sym_DOT_DOT] = ACTIONS(2512),
    [anon_sym___reftype] = ACTIONS(2514),
    [anon_sym___refvalue] = ACTIONS(2514),
    [anon_sym_sizeof] = ACTIONS(2514),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [sym_integer_literal] = ACTIONS(2514),
    [sym_null_literal] = ACTIONS(2514),
    [sym_real_literal] = ACTIONS(2512),
    [sym_verbatim_string_literal] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2514),
    [anon_sym_nameof] = ACTIONS(2514),
    [sym_void_keyword] = ACTIONS(2514),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1626] = {
    [sym__preprocessor_call] = STATE(1626),
    [ts_builtin_sym_end] = ACTIONS(2516),
    [sym__identifier_token] = ACTIONS(2518),
    [anon_sym_extern] = ACTIONS(2518),
    [anon_sym_alias] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_global] = ACTIONS(2518),
    [anon_sym_using] = ACTIONS(2518),
    [anon_sym_static] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_async] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_fixed] = ACTIONS(2518),
    [anon_sym_internal] = ACTIONS(2518),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_override] = ACTIONS(2518),
    [anon_sym_partial] = ACTIONS(2518),
    [anon_sym_private] = ACTIONS(2518),
    [anon_sym_protected] = ACTIONS(2518),
    [anon_sym_public] = ACTIONS(2518),
    [anon_sym_readonly] = ACTIONS(2518),
    [anon_sym_ref] = ACTIONS(2518),
    [anon_sym_sealed] = ACTIONS(2518),
    [anon_sym_unsafe] = ACTIONS(2518),
    [anon_sym_virtual] = ACTIONS(2518),
    [anon_sym_volatile] = ACTIONS(2518),
    [anon_sym_this] = ACTIONS(2518),
    [anon_sym_base] = ACTIONS(2518),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_where] = ACTIONS(2518),
    [anon_sym_class] = ACTIONS(2518),
    [anon_sym_struct] = ACTIONS(2518),
    [anon_sym_notnull] = ACTIONS(2518),
    [anon_sym_unmanaged] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_true] = ACTIONS(2518),
    [anon_sym_false] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_STAR] = ACTIONS(2516),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_get] = ACTIONS(2518),
    [anon_sym_set] = ACTIONS(2518),
    [anon_sym_add] = ACTIONS(2518),
    [anon_sym_remove] = ACTIONS(2518),
    [anon_sym_enum] = ACTIONS(2518),
    [anon_sym_interface] = ACTIONS(2518),
    [anon_sym_delegate] = ACTIONS(2518),
    [anon_sym_record] = ACTIONS(2518),
    [anon_sym_namespace] = ACTIONS(2518),
    [anon_sym_var] = ACTIONS(2518),
    [sym_predefined_type] = ACTIONS(2518),
    [anon_sym_break] = ACTIONS(2518),
    [anon_sym_checked] = ACTIONS(2518),
    [anon_sym_unchecked] = ACTIONS(2518),
    [anon_sym_continue] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_await] = ACTIONS(2518),
    [anon_sym_foreach] = ACTIONS(2518),
    [anon_sym_goto] = ACTIONS(2518),
    [anon_sym_default] = ACTIONS(2518),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_lock] = ACTIONS(2518),
    [anon_sym_switch] = ACTIONS(2518),
    [anon_sym_when] = ACTIONS(2518),
    [anon_sym_throw] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_stackalloc] = ACTIONS(2518),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2516),
    [anon_sym___makeref] = ACTIONS(2518),
    [anon_sym_from] = ACTIONS(2518),
    [anon_sym_join] = ACTIONS(2518),
    [anon_sym_on] = ACTIONS(2518),
    [anon_sym_equals] = ACTIONS(2518),
    [anon_sym_into] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_orderby] = ACTIONS(2518),
    [anon_sym_ascending] = ACTIONS(2518),
    [anon_sym_descending] = ACTIONS(2518),
    [anon_sym_group] = ACTIONS(2518),
    [anon_sym_by] = ACTIONS(2518),
    [anon_sym_select] = ACTIONS(2518),
    [anon_sym_DOT_DOT] = ACTIONS(2516),
    [anon_sym___reftype] = ACTIONS(2518),
    [anon_sym___refvalue] = ACTIONS(2518),
    [anon_sym_sizeof] = ACTIONS(2518),
    [anon_sym_typeof] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_integer_literal] = ACTIONS(2518),
    [sym_null_literal] = ACTIONS(2518),
    [sym_real_literal] = ACTIONS(2516),
    [sym_verbatim_string_literal] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2518),
    [anon_sym_nameof] = ACTIONS(2518),
    [sym_void_keyword] = ACTIONS(2518),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1627] = {
    [sym__preprocessor_call] = STATE(1627),
    [ts_builtin_sym_end] = ACTIONS(2520),
    [sym__identifier_token] = ACTIONS(2522),
    [anon_sym_extern] = ACTIONS(2522),
    [anon_sym_alias] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_global] = ACTIONS(2522),
    [anon_sym_using] = ACTIONS(2522),
    [anon_sym_static] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_fixed] = ACTIONS(2522),
    [anon_sym_internal] = ACTIONS(2522),
    [anon_sym_new] = ACTIONS(2522),
    [anon_sym_override] = ACTIONS(2522),
    [anon_sym_partial] = ACTIONS(2522),
    [anon_sym_private] = ACTIONS(2522),
    [anon_sym_protected] = ACTIONS(2522),
    [anon_sym_public] = ACTIONS(2522),
    [anon_sym_readonly] = ACTIONS(2522),
    [anon_sym_ref] = ACTIONS(2522),
    [anon_sym_sealed] = ACTIONS(2522),
    [anon_sym_unsafe] = ACTIONS(2522),
    [anon_sym_virtual] = ACTIONS(2522),
    [anon_sym_volatile] = ACTIONS(2522),
    [anon_sym_this] = ACTIONS(2522),
    [anon_sym_base] = ACTIONS(2522),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_where] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(2522),
    [anon_sym_struct] = ACTIONS(2522),
    [anon_sym_notnull] = ACTIONS(2522),
    [anon_sym_unmanaged] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2520),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [anon_sym_true] = ACTIONS(2522),
    [anon_sym_false] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_STAR] = ACTIONS(2520),
    [anon_sym_CARET] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_get] = ACTIONS(2522),
    [anon_sym_set] = ACTIONS(2522),
    [anon_sym_add] = ACTIONS(2522),
    [anon_sym_remove] = ACTIONS(2522),
    [anon_sym_enum] = ACTIONS(2522),
    [anon_sym_interface] = ACTIONS(2522),
    [anon_sym_delegate] = ACTIONS(2522),
    [anon_sym_record] = ACTIONS(2522),
    [anon_sym_namespace] = ACTIONS(2522),
    [anon_sym_var] = ACTIONS(2522),
    [sym_predefined_type] = ACTIONS(2522),
    [anon_sym_break] = ACTIONS(2522),
    [anon_sym_checked] = ACTIONS(2522),
    [anon_sym_unchecked] = ACTIONS(2522),
    [anon_sym_continue] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_await] = ACTIONS(2522),
    [anon_sym_foreach] = ACTIONS(2522),
    [anon_sym_goto] = ACTIONS(2522),
    [anon_sym_default] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_lock] = ACTIONS(2522),
    [anon_sym_switch] = ACTIONS(2522),
    [anon_sym_when] = ACTIONS(2522),
    [anon_sym_throw] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_yield] = ACTIONS(2522),
    [anon_sym_stackalloc] = ACTIONS(2522),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2520),
    [anon_sym___makeref] = ACTIONS(2522),
    [anon_sym_from] = ACTIONS(2522),
    [anon_sym_join] = ACTIONS(2522),
    [anon_sym_on] = ACTIONS(2522),
    [anon_sym_equals] = ACTIONS(2522),
    [anon_sym_into] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_orderby] = ACTIONS(2522),
    [anon_sym_ascending] = ACTIONS(2522),
    [anon_sym_descending] = ACTIONS(2522),
    [anon_sym_group] = ACTIONS(2522),
    [anon_sym_by] = ACTIONS(2522),
    [anon_sym_select] = ACTIONS(2522),
    [anon_sym_DOT_DOT] = ACTIONS(2520),
    [anon_sym___reftype] = ACTIONS(2522),
    [anon_sym___refvalue] = ACTIONS(2522),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym_typeof] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [sym_integer_literal] = ACTIONS(2522),
    [sym_null_literal] = ACTIONS(2522),
    [sym_real_literal] = ACTIONS(2520),
    [sym_verbatim_string_literal] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2522),
    [anon_sym_nameof] = ACTIONS(2522),
    [sym_void_keyword] = ACTIONS(2522),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1628] = {
    [sym__preprocessor_call] = STATE(1628),
    [ts_builtin_sym_end] = ACTIONS(2524),
    [sym__identifier_token] = ACTIONS(2526),
    [anon_sym_extern] = ACTIONS(2526),
    [anon_sym_alias] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(2524),
    [anon_sym_global] = ACTIONS(2526),
    [anon_sym_using] = ACTIONS(2526),
    [anon_sym_static] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2524),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_fixed] = ACTIONS(2526),
    [anon_sym_internal] = ACTIONS(2526),
    [anon_sym_new] = ACTIONS(2526),
    [anon_sym_override] = ACTIONS(2526),
    [anon_sym_partial] = ACTIONS(2526),
    [anon_sym_private] = ACTIONS(2526),
    [anon_sym_protected] = ACTIONS(2526),
    [anon_sym_public] = ACTIONS(2526),
    [anon_sym_readonly] = ACTIONS(2526),
    [anon_sym_ref] = ACTIONS(2526),
    [anon_sym_sealed] = ACTIONS(2526),
    [anon_sym_unsafe] = ACTIONS(2526),
    [anon_sym_virtual] = ACTIONS(2526),
    [anon_sym_volatile] = ACTIONS(2526),
    [anon_sym_this] = ACTIONS(2526),
    [anon_sym_base] = ACTIONS(2526),
    [anon_sym_LBRACE] = ACTIONS(2524),
    [anon_sym_TILDE] = ACTIONS(2524),
    [anon_sym_where] = ACTIONS(2526),
    [anon_sym_class] = ACTIONS(2526),
    [anon_sym_struct] = ACTIONS(2526),
    [anon_sym_notnull] = ACTIONS(2526),
    [anon_sym_unmanaged] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2524),
    [anon_sym_true] = ACTIONS(2526),
    [anon_sym_false] = ACTIONS(2526),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2524),
    [anon_sym_CARET] = ACTIONS(2524),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2526),
    [anon_sym_set] = ACTIONS(2526),
    [anon_sym_add] = ACTIONS(2526),
    [anon_sym_remove] = ACTIONS(2526),
    [anon_sym_enum] = ACTIONS(2526),
    [anon_sym_interface] = ACTIONS(2526),
    [anon_sym_delegate] = ACTIONS(2526),
    [anon_sym_record] = ACTIONS(2526),
    [anon_sym_namespace] = ACTIONS(2526),
    [anon_sym_var] = ACTIONS(2526),
    [sym_predefined_type] = ACTIONS(2526),
    [anon_sym_break] = ACTIONS(2526),
    [anon_sym_checked] = ACTIONS(2526),
    [anon_sym_unchecked] = ACTIONS(2526),
    [anon_sym_continue] = ACTIONS(2526),
    [anon_sym_do] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_await] = ACTIONS(2526),
    [anon_sym_foreach] = ACTIONS(2526),
    [anon_sym_goto] = ACTIONS(2526),
    [anon_sym_default] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_else] = ACTIONS(2526),
    [anon_sym_lock] = ACTIONS(2526),
    [anon_sym_switch] = ACTIONS(2526),
    [anon_sym_when] = ACTIONS(2526),
    [anon_sym_throw] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_yield] = ACTIONS(2526),
    [anon_sym_stackalloc] = ACTIONS(2526),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2524),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2524),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2524),
    [anon_sym___makeref] = ACTIONS(2526),
    [anon_sym_from] = ACTIONS(2526),
    [anon_sym_join] = ACTIONS(2526),
    [anon_sym_on] = ACTIONS(2526),
    [anon_sym_equals] = ACTIONS(2526),
    [anon_sym_into] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_orderby] = ACTIONS(2526),
    [anon_sym_ascending] = ACTIONS(2526),
    [anon_sym_descending] = ACTIONS(2526),
    [anon_sym_group] = ACTIONS(2526),
    [anon_sym_by] = ACTIONS(2526),
    [anon_sym_select] = ACTIONS(2526),
    [anon_sym_DOT_DOT] = ACTIONS(2524),
    [anon_sym___reftype] = ACTIONS(2526),
    [anon_sym___refvalue] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2526),
    [anon_sym_typeof] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [sym_integer_literal] = ACTIONS(2526),
    [sym_null_literal] = ACTIONS(2526),
    [sym_real_literal] = ACTIONS(2524),
    [sym_verbatim_string_literal] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2526),
    [anon_sym_nameof] = ACTIONS(2526),
    [sym_void_keyword] = ACTIONS(2526),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1629] = {
    [sym__preprocessor_call] = STATE(1629),
    [ts_builtin_sym_end] = ACTIONS(2528),
    [sym__identifier_token] = ACTIONS(2530),
    [anon_sym_extern] = ACTIONS(2530),
    [anon_sym_alias] = ACTIONS(2530),
    [anon_sym_SEMI] = ACTIONS(2528),
    [anon_sym_global] = ACTIONS(2530),
    [anon_sym_using] = ACTIONS(2530),
    [anon_sym_static] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2528),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_async] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_fixed] = ACTIONS(2530),
    [anon_sym_internal] = ACTIONS(2530),
    [anon_sym_new] = ACTIONS(2530),
    [anon_sym_override] = ACTIONS(2530),
    [anon_sym_partial] = ACTIONS(2530),
    [anon_sym_private] = ACTIONS(2530),
    [anon_sym_protected] = ACTIONS(2530),
    [anon_sym_public] = ACTIONS(2530),
    [anon_sym_readonly] = ACTIONS(2530),
    [anon_sym_ref] = ACTIONS(2530),
    [anon_sym_sealed] = ACTIONS(2530),
    [anon_sym_unsafe] = ACTIONS(2530),
    [anon_sym_virtual] = ACTIONS(2530),
    [anon_sym_volatile] = ACTIONS(2530),
    [anon_sym_this] = ACTIONS(2530),
    [anon_sym_base] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(2528),
    [anon_sym_TILDE] = ACTIONS(2528),
    [anon_sym_where] = ACTIONS(2530),
    [anon_sym_class] = ACTIONS(2530),
    [anon_sym_struct] = ACTIONS(2530),
    [anon_sym_notnull] = ACTIONS(2530),
    [anon_sym_unmanaged] = ACTIONS(2530),
    [anon_sym_BANG] = ACTIONS(2528),
    [anon_sym_PLUS_PLUS] = ACTIONS(2528),
    [anon_sym_DASH_DASH] = ACTIONS(2528),
    [anon_sym_true] = ACTIONS(2530),
    [anon_sym_false] = ACTIONS(2530),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_DASH] = ACTIONS(2530),
    [anon_sym_STAR] = ACTIONS(2528),
    [anon_sym_CARET] = ACTIONS(2528),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym_get] = ACTIONS(2530),
    [anon_sym_set] = ACTIONS(2530),
    [anon_sym_add] = ACTIONS(2530),
    [anon_sym_remove] = ACTIONS(2530),
    [anon_sym_enum] = ACTIONS(2530),
    [anon_sym_interface] = ACTIONS(2530),
    [anon_sym_delegate] = ACTIONS(2530),
    [anon_sym_record] = ACTIONS(2530),
    [anon_sym_namespace] = ACTIONS(2530),
    [anon_sym_var] = ACTIONS(2530),
    [sym_predefined_type] = ACTIONS(2530),
    [anon_sym_break] = ACTIONS(2530),
    [anon_sym_checked] = ACTIONS(2530),
    [anon_sym_unchecked] = ACTIONS(2530),
    [anon_sym_continue] = ACTIONS(2530),
    [anon_sym_do] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_await] = ACTIONS(2530),
    [anon_sym_foreach] = ACTIONS(2530),
    [anon_sym_goto] = ACTIONS(2530),
    [anon_sym_default] = ACTIONS(2530),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_else] = ACTIONS(2530),
    [anon_sym_lock] = ACTIONS(2530),
    [anon_sym_switch] = ACTIONS(2530),
    [anon_sym_when] = ACTIONS(2530),
    [anon_sym_throw] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_yield] = ACTIONS(2530),
    [anon_sym_stackalloc] = ACTIONS(2530),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2528),
    [anon_sym_DQUOTE] = ACTIONS(2528),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2528),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2528),
    [anon_sym___makeref] = ACTIONS(2530),
    [anon_sym_from] = ACTIONS(2530),
    [anon_sym_join] = ACTIONS(2530),
    [anon_sym_on] = ACTIONS(2530),
    [anon_sym_equals] = ACTIONS(2530),
    [anon_sym_into] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_orderby] = ACTIONS(2530),
    [anon_sym_ascending] = ACTIONS(2530),
    [anon_sym_descending] = ACTIONS(2530),
    [anon_sym_group] = ACTIONS(2530),
    [anon_sym_by] = ACTIONS(2530),
    [anon_sym_select] = ACTIONS(2530),
    [anon_sym_DOT_DOT] = ACTIONS(2528),
    [anon_sym___reftype] = ACTIONS(2530),
    [anon_sym___refvalue] = ACTIONS(2530),
    [anon_sym_sizeof] = ACTIONS(2530),
    [anon_sym_typeof] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2528),
    [sym_integer_literal] = ACTIONS(2530),
    [sym_null_literal] = ACTIONS(2530),
    [sym_real_literal] = ACTIONS(2528),
    [sym_verbatim_string_literal] = ACTIONS(2528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2530),
    [anon_sym_nameof] = ACTIONS(2530),
    [sym_void_keyword] = ACTIONS(2530),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1630] = {
    [sym__preprocessor_call] = STATE(1630),
    [ts_builtin_sym_end] = ACTIONS(2532),
    [sym__identifier_token] = ACTIONS(2534),
    [anon_sym_extern] = ACTIONS(2534),
    [anon_sym_alias] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_global] = ACTIONS(2534),
    [anon_sym_using] = ACTIONS(2534),
    [anon_sym_static] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_async] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_fixed] = ACTIONS(2534),
    [anon_sym_internal] = ACTIONS(2534),
    [anon_sym_new] = ACTIONS(2534),
    [anon_sym_override] = ACTIONS(2534),
    [anon_sym_partial] = ACTIONS(2534),
    [anon_sym_private] = ACTIONS(2534),
    [anon_sym_protected] = ACTIONS(2534),
    [anon_sym_public] = ACTIONS(2534),
    [anon_sym_readonly] = ACTIONS(2534),
    [anon_sym_ref] = ACTIONS(2534),
    [anon_sym_sealed] = ACTIONS(2534),
    [anon_sym_unsafe] = ACTIONS(2534),
    [anon_sym_virtual] = ACTIONS(2534),
    [anon_sym_volatile] = ACTIONS(2534),
    [anon_sym_this] = ACTIONS(2534),
    [anon_sym_base] = ACTIONS(2534),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_TILDE] = ACTIONS(2532),
    [anon_sym_where] = ACTIONS(2534),
    [anon_sym_class] = ACTIONS(2534),
    [anon_sym_struct] = ACTIONS(2534),
    [anon_sym_notnull] = ACTIONS(2534),
    [anon_sym_unmanaged] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2532),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [anon_sym_true] = ACTIONS(2534),
    [anon_sym_false] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(2532),
    [anon_sym_CARET] = ACTIONS(2532),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_get] = ACTIONS(2534),
    [anon_sym_set] = ACTIONS(2534),
    [anon_sym_add] = ACTIONS(2534),
    [anon_sym_remove] = ACTIONS(2534),
    [anon_sym_enum] = ACTIONS(2534),
    [anon_sym_interface] = ACTIONS(2534),
    [anon_sym_delegate] = ACTIONS(2534),
    [anon_sym_record] = ACTIONS(2534),
    [anon_sym_namespace] = ACTIONS(2534),
    [anon_sym_var] = ACTIONS(2534),
    [sym_predefined_type] = ACTIONS(2534),
    [anon_sym_break] = ACTIONS(2534),
    [anon_sym_checked] = ACTIONS(2534),
    [anon_sym_unchecked] = ACTIONS(2534),
    [anon_sym_continue] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_await] = ACTIONS(2534),
    [anon_sym_foreach] = ACTIONS(2534),
    [anon_sym_goto] = ACTIONS(2534),
    [anon_sym_default] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2534),
    [anon_sym_lock] = ACTIONS(2534),
    [anon_sym_switch] = ACTIONS(2534),
    [anon_sym_when] = ACTIONS(2534),
    [anon_sym_throw] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_yield] = ACTIONS(2534),
    [anon_sym_stackalloc] = ACTIONS(2534),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2532),
    [anon_sym_DQUOTE] = ACTIONS(2532),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2532),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2532),
    [anon_sym___makeref] = ACTIONS(2534),
    [anon_sym_from] = ACTIONS(2534),
    [anon_sym_join] = ACTIONS(2534),
    [anon_sym_on] = ACTIONS(2534),
    [anon_sym_equals] = ACTIONS(2534),
    [anon_sym_into] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_orderby] = ACTIONS(2534),
    [anon_sym_ascending] = ACTIONS(2534),
    [anon_sym_descending] = ACTIONS(2534),
    [anon_sym_group] = ACTIONS(2534),
    [anon_sym_by] = ACTIONS(2534),
    [anon_sym_select] = ACTIONS(2534),
    [anon_sym_DOT_DOT] = ACTIONS(2532),
    [anon_sym___reftype] = ACTIONS(2534),
    [anon_sym___refvalue] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2534),
    [anon_sym_typeof] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [sym_integer_literal] = ACTIONS(2534),
    [sym_null_literal] = ACTIONS(2534),
    [sym_real_literal] = ACTIONS(2532),
    [sym_verbatim_string_literal] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2534),
    [anon_sym_nameof] = ACTIONS(2534),
    [sym_void_keyword] = ACTIONS(2534),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1631] = {
    [sym__preprocessor_call] = STATE(1631),
    [ts_builtin_sym_end] = ACTIONS(2536),
    [sym__identifier_token] = ACTIONS(2538),
    [anon_sym_extern] = ACTIONS(2538),
    [anon_sym_alias] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_global] = ACTIONS(2538),
    [anon_sym_using] = ACTIONS(2538),
    [anon_sym_static] = ACTIONS(2538),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_async] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_fixed] = ACTIONS(2538),
    [anon_sym_internal] = ACTIONS(2538),
    [anon_sym_new] = ACTIONS(2538),
    [anon_sym_override] = ACTIONS(2538),
    [anon_sym_partial] = ACTIONS(2538),
    [anon_sym_private] = ACTIONS(2538),
    [anon_sym_protected] = ACTIONS(2538),
    [anon_sym_public] = ACTIONS(2538),
    [anon_sym_readonly] = ACTIONS(2538),
    [anon_sym_ref] = ACTIONS(2538),
    [anon_sym_sealed] = ACTIONS(2538),
    [anon_sym_unsafe] = ACTIONS(2538),
    [anon_sym_virtual] = ACTIONS(2538),
    [anon_sym_volatile] = ACTIONS(2538),
    [anon_sym_this] = ACTIONS(2538),
    [anon_sym_base] = ACTIONS(2538),
    [anon_sym_LBRACE] = ACTIONS(2536),
    [anon_sym_TILDE] = ACTIONS(2536),
    [anon_sym_where] = ACTIONS(2538),
    [anon_sym_class] = ACTIONS(2538),
    [anon_sym_struct] = ACTIONS(2538),
    [anon_sym_notnull] = ACTIONS(2538),
    [anon_sym_unmanaged] = ACTIONS(2538),
    [anon_sym_BANG] = ACTIONS(2536),
    [anon_sym_PLUS_PLUS] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2536),
    [anon_sym_true] = ACTIONS(2538),
    [anon_sym_false] = ACTIONS(2538),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_DASH] = ACTIONS(2538),
    [anon_sym_STAR] = ACTIONS(2536),
    [anon_sym_CARET] = ACTIONS(2536),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_get] = ACTIONS(2538),
    [anon_sym_set] = ACTIONS(2538),
    [anon_sym_add] = ACTIONS(2538),
    [anon_sym_remove] = ACTIONS(2538),
    [anon_sym_enum] = ACTIONS(2538),
    [anon_sym_interface] = ACTIONS(2538),
    [anon_sym_delegate] = ACTIONS(2538),
    [anon_sym_record] = ACTIONS(2538),
    [anon_sym_namespace] = ACTIONS(2538),
    [anon_sym_var] = ACTIONS(2538),
    [sym_predefined_type] = ACTIONS(2538),
    [anon_sym_break] = ACTIONS(2538),
    [anon_sym_checked] = ACTIONS(2538),
    [anon_sym_unchecked] = ACTIONS(2538),
    [anon_sym_continue] = ACTIONS(2538),
    [anon_sym_do] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_await] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_goto] = ACTIONS(2538),
    [anon_sym_default] = ACTIONS(2538),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_lock] = ACTIONS(2538),
    [anon_sym_switch] = ACTIONS(2538),
    [anon_sym_when] = ACTIONS(2538),
    [anon_sym_throw] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_yield] = ACTIONS(2538),
    [anon_sym_stackalloc] = ACTIONS(2538),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2536),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2536),
    [anon_sym___makeref] = ACTIONS(2538),
    [anon_sym_from] = ACTIONS(2538),
    [anon_sym_join] = ACTIONS(2538),
    [anon_sym_on] = ACTIONS(2538),
    [anon_sym_equals] = ACTIONS(2538),
    [anon_sym_into] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_orderby] = ACTIONS(2538),
    [anon_sym_ascending] = ACTIONS(2538),
    [anon_sym_descending] = ACTIONS(2538),
    [anon_sym_group] = ACTIONS(2538),
    [anon_sym_by] = ACTIONS(2538),
    [anon_sym_select] = ACTIONS(2538),
    [anon_sym_DOT_DOT] = ACTIONS(2536),
    [anon_sym___reftype] = ACTIONS(2538),
    [anon_sym___refvalue] = ACTIONS(2538),
    [anon_sym_sizeof] = ACTIONS(2538),
    [anon_sym_typeof] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2536),
    [sym_integer_literal] = ACTIONS(2538),
    [sym_null_literal] = ACTIONS(2538),
    [sym_real_literal] = ACTIONS(2536),
    [sym_verbatim_string_literal] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2538),
    [anon_sym_nameof] = ACTIONS(2538),
    [sym_void_keyword] = ACTIONS(2538),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1632] = {
    [sym__preprocessor_call] = STATE(1632),
    [ts_builtin_sym_end] = ACTIONS(2540),
    [sym__identifier_token] = ACTIONS(2542),
    [anon_sym_extern] = ACTIONS(2542),
    [anon_sym_alias] = ACTIONS(2542),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_global] = ACTIONS(2542),
    [anon_sym_using] = ACTIONS(2542),
    [anon_sym_static] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_return] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2540),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2542),
    [anon_sym_const] = ACTIONS(2542),
    [anon_sym_fixed] = ACTIONS(2542),
    [anon_sym_internal] = ACTIONS(2542),
    [anon_sym_new] = ACTIONS(2542),
    [anon_sym_override] = ACTIONS(2542),
    [anon_sym_partial] = ACTIONS(2542),
    [anon_sym_private] = ACTIONS(2542),
    [anon_sym_protected] = ACTIONS(2542),
    [anon_sym_public] = ACTIONS(2542),
    [anon_sym_readonly] = ACTIONS(2542),
    [anon_sym_ref] = ACTIONS(2542),
    [anon_sym_sealed] = ACTIONS(2542),
    [anon_sym_unsafe] = ACTIONS(2542),
    [anon_sym_virtual] = ACTIONS(2542),
    [anon_sym_volatile] = ACTIONS(2542),
    [anon_sym_this] = ACTIONS(2542),
    [anon_sym_base] = ACTIONS(2542),
    [anon_sym_LBRACE] = ACTIONS(2540),
    [anon_sym_TILDE] = ACTIONS(2540),
    [anon_sym_where] = ACTIONS(2542),
    [anon_sym_class] = ACTIONS(2542),
    [anon_sym_struct] = ACTIONS(2542),
    [anon_sym_notnull] = ACTIONS(2542),
    [anon_sym_unmanaged] = ACTIONS(2542),
    [anon_sym_BANG] = ACTIONS(2540),
    [anon_sym_PLUS_PLUS] = ACTIONS(2540),
    [anon_sym_DASH_DASH] = ACTIONS(2540),
    [anon_sym_true] = ACTIONS(2542),
    [anon_sym_false] = ACTIONS(2542),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_DASH] = ACTIONS(2542),
    [anon_sym_STAR] = ACTIONS(2540),
    [anon_sym_CARET] = ACTIONS(2540),
    [anon_sym_AMP] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2542),
    [anon_sym_set] = ACTIONS(2542),
    [anon_sym_add] = ACTIONS(2542),
    [anon_sym_remove] = ACTIONS(2542),
    [anon_sym_enum] = ACTIONS(2542),
    [anon_sym_interface] = ACTIONS(2542),
    [anon_sym_delegate] = ACTIONS(2542),
    [anon_sym_record] = ACTIONS(2542),
    [anon_sym_namespace] = ACTIONS(2542),
    [anon_sym_var] = ACTIONS(2542),
    [sym_predefined_type] = ACTIONS(2542),
    [anon_sym_break] = ACTIONS(2542),
    [anon_sym_checked] = ACTIONS(2542),
    [anon_sym_unchecked] = ACTIONS(2542),
    [anon_sym_continue] = ACTIONS(2542),
    [anon_sym_do] = ACTIONS(2542),
    [anon_sym_while] = ACTIONS(2542),
    [anon_sym_for] = ACTIONS(2542),
    [anon_sym_await] = ACTIONS(2542),
    [anon_sym_foreach] = ACTIONS(2542),
    [anon_sym_goto] = ACTIONS(2542),
    [anon_sym_default] = ACTIONS(2542),
    [anon_sym_if] = ACTIONS(2542),
    [anon_sym_else] = ACTIONS(2542),
    [anon_sym_lock] = ACTIONS(2542),
    [anon_sym_switch] = ACTIONS(2542),
    [anon_sym_when] = ACTIONS(2542),
    [anon_sym_throw] = ACTIONS(2542),
    [anon_sym_try] = ACTIONS(2542),
    [anon_sym_yield] = ACTIONS(2542),
    [anon_sym_stackalloc] = ACTIONS(2542),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2540),
    [anon_sym_DQUOTE] = ACTIONS(2540),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2540),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2540),
    [anon_sym___makeref] = ACTIONS(2542),
    [anon_sym_from] = ACTIONS(2542),
    [anon_sym_join] = ACTIONS(2542),
    [anon_sym_on] = ACTIONS(2542),
    [anon_sym_equals] = ACTIONS(2542),
    [anon_sym_into] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2542),
    [anon_sym_orderby] = ACTIONS(2542),
    [anon_sym_ascending] = ACTIONS(2542),
    [anon_sym_descending] = ACTIONS(2542),
    [anon_sym_group] = ACTIONS(2542),
    [anon_sym_by] = ACTIONS(2542),
    [anon_sym_select] = ACTIONS(2542),
    [anon_sym_DOT_DOT] = ACTIONS(2540),
    [anon_sym___reftype] = ACTIONS(2542),
    [anon_sym___refvalue] = ACTIONS(2542),
    [anon_sym_sizeof] = ACTIONS(2542),
    [anon_sym_typeof] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2540),
    [sym_integer_literal] = ACTIONS(2542),
    [sym_null_literal] = ACTIONS(2542),
    [sym_real_literal] = ACTIONS(2540),
    [sym_verbatim_string_literal] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2542),
    [anon_sym_nameof] = ACTIONS(2542),
    [sym_void_keyword] = ACTIONS(2542),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1633] = {
    [sym__preprocessor_call] = STATE(1633),
    [ts_builtin_sym_end] = ACTIONS(2544),
    [sym__identifier_token] = ACTIONS(2546),
    [anon_sym_extern] = ACTIONS(2546),
    [anon_sym_alias] = ACTIONS(2546),
    [anon_sym_SEMI] = ACTIONS(2544),
    [anon_sym_global] = ACTIONS(2546),
    [anon_sym_using] = ACTIONS(2546),
    [anon_sym_static] = ACTIONS(2546),
    [anon_sym_LBRACK] = ACTIONS(2544),
    [anon_sym_return] = ACTIONS(2546),
    [anon_sym_LPAREN] = ACTIONS(2544),
    [anon_sym_abstract] = ACTIONS(2546),
    [anon_sym_async] = ACTIONS(2546),
    [anon_sym_const] = ACTIONS(2546),
    [anon_sym_fixed] = ACTIONS(2546),
    [anon_sym_internal] = ACTIONS(2546),
    [anon_sym_new] = ACTIONS(2546),
    [anon_sym_override] = ACTIONS(2546),
    [anon_sym_partial] = ACTIONS(2546),
    [anon_sym_private] = ACTIONS(2546),
    [anon_sym_protected] = ACTIONS(2546),
    [anon_sym_public] = ACTIONS(2546),
    [anon_sym_readonly] = ACTIONS(2546),
    [anon_sym_ref] = ACTIONS(2546),
    [anon_sym_sealed] = ACTIONS(2546),
    [anon_sym_unsafe] = ACTIONS(2546),
    [anon_sym_virtual] = ACTIONS(2546),
    [anon_sym_volatile] = ACTIONS(2546),
    [anon_sym_this] = ACTIONS(2546),
    [anon_sym_base] = ACTIONS(2546),
    [anon_sym_LBRACE] = ACTIONS(2544),
    [anon_sym_TILDE] = ACTIONS(2544),
    [anon_sym_where] = ACTIONS(2546),
    [anon_sym_class] = ACTIONS(2546),
    [anon_sym_struct] = ACTIONS(2546),
    [anon_sym_notnull] = ACTIONS(2546),
    [anon_sym_unmanaged] = ACTIONS(2546),
    [anon_sym_BANG] = ACTIONS(2544),
    [anon_sym_PLUS_PLUS] = ACTIONS(2544),
    [anon_sym_DASH_DASH] = ACTIONS(2544),
    [anon_sym_true] = ACTIONS(2546),
    [anon_sym_false] = ACTIONS(2546),
    [anon_sym_PLUS] = ACTIONS(2546),
    [anon_sym_DASH] = ACTIONS(2546),
    [anon_sym_STAR] = ACTIONS(2544),
    [anon_sym_CARET] = ACTIONS(2544),
    [anon_sym_AMP] = ACTIONS(2544),
    [anon_sym_get] = ACTIONS(2546),
    [anon_sym_set] = ACTIONS(2546),
    [anon_sym_add] = ACTIONS(2546),
    [anon_sym_remove] = ACTIONS(2546),
    [anon_sym_enum] = ACTIONS(2546),
    [anon_sym_interface] = ACTIONS(2546),
    [anon_sym_delegate] = ACTIONS(2546),
    [anon_sym_record] = ACTIONS(2546),
    [anon_sym_namespace] = ACTIONS(2546),
    [anon_sym_var] = ACTIONS(2546),
    [sym_predefined_type] = ACTIONS(2546),
    [anon_sym_break] = ACTIONS(2546),
    [anon_sym_checked] = ACTIONS(2546),
    [anon_sym_unchecked] = ACTIONS(2546),
    [anon_sym_continue] = ACTIONS(2546),
    [anon_sym_do] = ACTIONS(2546),
    [anon_sym_while] = ACTIONS(2546),
    [anon_sym_for] = ACTIONS(2546),
    [anon_sym_await] = ACTIONS(2546),
    [anon_sym_foreach] = ACTIONS(2546),
    [anon_sym_goto] = ACTIONS(2546),
    [anon_sym_default] = ACTIONS(2546),
    [anon_sym_if] = ACTIONS(2546),
    [anon_sym_lock] = ACTIONS(2546),
    [anon_sym_switch] = ACTIONS(2546),
    [anon_sym_when] = ACTIONS(2546),
    [anon_sym_throw] = ACTIONS(2546),
    [anon_sym_try] = ACTIONS(2546),
    [anon_sym_yield] = ACTIONS(2546),
    [anon_sym_stackalloc] = ACTIONS(2546),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2544),
    [anon_sym_DQUOTE] = ACTIONS(2544),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2544),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2544),
    [anon_sym___makeref] = ACTIONS(2546),
    [anon_sym_from] = ACTIONS(2546),
    [anon_sym_join] = ACTIONS(2546),
    [anon_sym_on] = ACTIONS(2546),
    [anon_sym_equals] = ACTIONS(2546),
    [anon_sym_into] = ACTIONS(2546),
    [anon_sym_let] = ACTIONS(2546),
    [anon_sym_orderby] = ACTIONS(2546),
    [anon_sym_ascending] = ACTIONS(2546),
    [anon_sym_descending] = ACTIONS(2546),
    [anon_sym_group] = ACTIONS(2546),
    [anon_sym_by] = ACTIONS(2546),
    [anon_sym_select] = ACTIONS(2546),
    [anon_sym_DOT_DOT] = ACTIONS(2544),
    [anon_sym___reftype] = ACTIONS(2546),
    [anon_sym___refvalue] = ACTIONS(2546),
    [anon_sym_sizeof] = ACTIONS(2546),
    [anon_sym_typeof] = ACTIONS(2546),
    [anon_sym_SQUOTE] = ACTIONS(2544),
    [sym_integer_literal] = ACTIONS(2546),
    [sym_null_literal] = ACTIONS(2546),
    [sym_real_literal] = ACTIONS(2544),
    [sym_verbatim_string_literal] = ACTIONS(2544),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2546),
    [anon_sym_nameof] = ACTIONS(2546),
    [sym_void_keyword] = ACTIONS(2546),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1634] = {
    [sym__preprocessor_call] = STATE(1634),
    [ts_builtin_sym_end] = ACTIONS(2548),
    [sym__identifier_token] = ACTIONS(2550),
    [anon_sym_extern] = ACTIONS(2550),
    [anon_sym_alias] = ACTIONS(2550),
    [anon_sym_SEMI] = ACTIONS(2548),
    [anon_sym_global] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_return] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2548),
    [anon_sym_abstract] = ACTIONS(2550),
    [anon_sym_async] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_fixed] = ACTIONS(2550),
    [anon_sym_internal] = ACTIONS(2550),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_override] = ACTIONS(2550),
    [anon_sym_partial] = ACTIONS(2550),
    [anon_sym_private] = ACTIONS(2550),
    [anon_sym_protected] = ACTIONS(2550),
    [anon_sym_public] = ACTIONS(2550),
    [anon_sym_readonly] = ACTIONS(2550),
    [anon_sym_ref] = ACTIONS(2550),
    [anon_sym_sealed] = ACTIONS(2550),
    [anon_sym_unsafe] = ACTIONS(2550),
    [anon_sym_virtual] = ACTIONS(2550),
    [anon_sym_volatile] = ACTIONS(2550),
    [anon_sym_this] = ACTIONS(2550),
    [anon_sym_base] = ACTIONS(2550),
    [anon_sym_LBRACE] = ACTIONS(2548),
    [anon_sym_TILDE] = ACTIONS(2548),
    [anon_sym_where] = ACTIONS(2550),
    [anon_sym_class] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_notnull] = ACTIONS(2550),
    [anon_sym_unmanaged] = ACTIONS(2550),
    [anon_sym_BANG] = ACTIONS(2548),
    [anon_sym_PLUS_PLUS] = ACTIONS(2548),
    [anon_sym_DASH_DASH] = ACTIONS(2548),
    [anon_sym_true] = ACTIONS(2550),
    [anon_sym_false] = ACTIONS(2550),
    [anon_sym_PLUS] = ACTIONS(2550),
    [anon_sym_DASH] = ACTIONS(2550),
    [anon_sym_STAR] = ACTIONS(2548),
    [anon_sym_CARET] = ACTIONS(2548),
    [anon_sym_AMP] = ACTIONS(2548),
    [anon_sym_get] = ACTIONS(2550),
    [anon_sym_set] = ACTIONS(2550),
    [anon_sym_add] = ACTIONS(2550),
    [anon_sym_remove] = ACTIONS(2550),
    [anon_sym_enum] = ACTIONS(2550),
    [anon_sym_interface] = ACTIONS(2550),
    [anon_sym_delegate] = ACTIONS(2550),
    [anon_sym_record] = ACTIONS(2550),
    [anon_sym_namespace] = ACTIONS(2550),
    [anon_sym_var] = ACTIONS(2550),
    [sym_predefined_type] = ACTIONS(2550),
    [anon_sym_break] = ACTIONS(2550),
    [anon_sym_checked] = ACTIONS(2550),
    [anon_sym_unchecked] = ACTIONS(2550),
    [anon_sym_continue] = ACTIONS(2550),
    [anon_sym_do] = ACTIONS(2550),
    [anon_sym_while] = ACTIONS(2550),
    [anon_sym_for] = ACTIONS(2550),
    [anon_sym_await] = ACTIONS(2550),
    [anon_sym_foreach] = ACTIONS(2550),
    [anon_sym_goto] = ACTIONS(2550),
    [anon_sym_default] = ACTIONS(2550),
    [anon_sym_if] = ACTIONS(2550),
    [anon_sym_lock] = ACTIONS(2550),
    [anon_sym_switch] = ACTIONS(2550),
    [anon_sym_when] = ACTIONS(2550),
    [anon_sym_throw] = ACTIONS(2550),
    [anon_sym_try] = ACTIONS(2550),
    [anon_sym_yield] = ACTIONS(2550),
    [anon_sym_stackalloc] = ACTIONS(2550),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2548),
    [anon_sym_DQUOTE] = ACTIONS(2548),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2548),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2548),
    [anon_sym___makeref] = ACTIONS(2550),
    [anon_sym_from] = ACTIONS(2550),
    [anon_sym_join] = ACTIONS(2550),
    [anon_sym_on] = ACTIONS(2550),
    [anon_sym_equals] = ACTIONS(2550),
    [anon_sym_into] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_orderby] = ACTIONS(2550),
    [anon_sym_ascending] = ACTIONS(2550),
    [anon_sym_descending] = ACTIONS(2550),
    [anon_sym_group] = ACTIONS(2550),
    [anon_sym_by] = ACTIONS(2550),
    [anon_sym_select] = ACTIONS(2550),
    [anon_sym_DOT_DOT] = ACTIONS(2548),
    [anon_sym___reftype] = ACTIONS(2550),
    [anon_sym___refvalue] = ACTIONS(2550),
    [anon_sym_sizeof] = ACTIONS(2550),
    [anon_sym_typeof] = ACTIONS(2550),
    [anon_sym_SQUOTE] = ACTIONS(2548),
    [sym_integer_literal] = ACTIONS(2550),
    [sym_null_literal] = ACTIONS(2550),
    [sym_real_literal] = ACTIONS(2548),
    [sym_verbatim_string_literal] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2550),
    [anon_sym_nameof] = ACTIONS(2550),
    [sym_void_keyword] = ACTIONS(2550),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1635] = {
    [sym__preprocessor_call] = STATE(1635),
    [ts_builtin_sym_end] = ACTIONS(2552),
    [sym__identifier_token] = ACTIONS(2554),
    [anon_sym_extern] = ACTIONS(2554),
    [anon_sym_alias] = ACTIONS(2554),
    [anon_sym_SEMI] = ACTIONS(2552),
    [anon_sym_global] = ACTIONS(2554),
    [anon_sym_using] = ACTIONS(2554),
    [anon_sym_static] = ACTIONS(2554),
    [anon_sym_LBRACK] = ACTIONS(2552),
    [anon_sym_return] = ACTIONS(2554),
    [anon_sym_LPAREN] = ACTIONS(2552),
    [anon_sym_abstract] = ACTIONS(2554),
    [anon_sym_async] = ACTIONS(2554),
    [anon_sym_const] = ACTIONS(2554),
    [anon_sym_fixed] = ACTIONS(2554),
    [anon_sym_internal] = ACTIONS(2554),
    [anon_sym_new] = ACTIONS(2554),
    [anon_sym_override] = ACTIONS(2554),
    [anon_sym_partial] = ACTIONS(2554),
    [anon_sym_private] = ACTIONS(2554),
    [anon_sym_protected] = ACTIONS(2554),
    [anon_sym_public] = ACTIONS(2554),
    [anon_sym_readonly] = ACTIONS(2554),
    [anon_sym_ref] = ACTIONS(2554),
    [anon_sym_sealed] = ACTIONS(2554),
    [anon_sym_unsafe] = ACTIONS(2554),
    [anon_sym_virtual] = ACTIONS(2554),
    [anon_sym_volatile] = ACTIONS(2554),
    [anon_sym_this] = ACTIONS(2554),
    [anon_sym_base] = ACTIONS(2554),
    [anon_sym_LBRACE] = ACTIONS(2552),
    [anon_sym_TILDE] = ACTIONS(2552),
    [anon_sym_where] = ACTIONS(2554),
    [anon_sym_class] = ACTIONS(2554),
    [anon_sym_struct] = ACTIONS(2554),
    [anon_sym_notnull] = ACTIONS(2554),
    [anon_sym_unmanaged] = ACTIONS(2554),
    [anon_sym_BANG] = ACTIONS(2552),
    [anon_sym_PLUS_PLUS] = ACTIONS(2552),
    [anon_sym_DASH_DASH] = ACTIONS(2552),
    [anon_sym_true] = ACTIONS(2554),
    [anon_sym_false] = ACTIONS(2554),
    [anon_sym_PLUS] = ACTIONS(2554),
    [anon_sym_DASH] = ACTIONS(2554),
    [anon_sym_STAR] = ACTIONS(2552),
    [anon_sym_CARET] = ACTIONS(2552),
    [anon_sym_AMP] = ACTIONS(2552),
    [anon_sym_get] = ACTIONS(2554),
    [anon_sym_set] = ACTIONS(2554),
    [anon_sym_add] = ACTIONS(2554),
    [anon_sym_remove] = ACTIONS(2554),
    [anon_sym_enum] = ACTIONS(2554),
    [anon_sym_interface] = ACTIONS(2554),
    [anon_sym_delegate] = ACTIONS(2554),
    [anon_sym_record] = ACTIONS(2554),
    [anon_sym_namespace] = ACTIONS(2554),
    [anon_sym_var] = ACTIONS(2554),
    [sym_predefined_type] = ACTIONS(2554),
    [anon_sym_break] = ACTIONS(2554),
    [anon_sym_checked] = ACTIONS(2554),
    [anon_sym_unchecked] = ACTIONS(2554),
    [anon_sym_continue] = ACTIONS(2554),
    [anon_sym_do] = ACTIONS(2554),
    [anon_sym_while] = ACTIONS(2554),
    [anon_sym_for] = ACTIONS(2554),
    [anon_sym_await] = ACTIONS(2554),
    [anon_sym_foreach] = ACTIONS(2554),
    [anon_sym_goto] = ACTIONS(2554),
    [anon_sym_default] = ACTIONS(2554),
    [anon_sym_if] = ACTIONS(2554),
    [anon_sym_lock] = ACTIONS(2554),
    [anon_sym_switch] = ACTIONS(2554),
    [anon_sym_when] = ACTIONS(2554),
    [anon_sym_throw] = ACTIONS(2554),
    [anon_sym_try] = ACTIONS(2554),
    [anon_sym_yield] = ACTIONS(2554),
    [anon_sym_stackalloc] = ACTIONS(2554),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2552),
    [anon_sym_DQUOTE] = ACTIONS(2552),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2552),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2552),
    [anon_sym___makeref] = ACTIONS(2554),
    [anon_sym_from] = ACTIONS(2554),
    [anon_sym_join] = ACTIONS(2554),
    [anon_sym_on] = ACTIONS(2554),
    [anon_sym_equals] = ACTIONS(2554),
    [anon_sym_into] = ACTIONS(2554),
    [anon_sym_let] = ACTIONS(2554),
    [anon_sym_orderby] = ACTIONS(2554),
    [anon_sym_ascending] = ACTIONS(2554),
    [anon_sym_descending] = ACTIONS(2554),
    [anon_sym_group] = ACTIONS(2554),
    [anon_sym_by] = ACTIONS(2554),
    [anon_sym_select] = ACTIONS(2554),
    [anon_sym_DOT_DOT] = ACTIONS(2552),
    [anon_sym___reftype] = ACTIONS(2554),
    [anon_sym___refvalue] = ACTIONS(2554),
    [anon_sym_sizeof] = ACTIONS(2554),
    [anon_sym_typeof] = ACTIONS(2554),
    [anon_sym_SQUOTE] = ACTIONS(2552),
    [sym_integer_literal] = ACTIONS(2554),
    [sym_null_literal] = ACTIONS(2554),
    [sym_real_literal] = ACTIONS(2552),
    [sym_verbatim_string_literal] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2554),
    [anon_sym_nameof] = ACTIONS(2554),
    [sym_void_keyword] = ACTIONS(2554),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1636] = {
    [sym__preprocessor_call] = STATE(1636),
    [ts_builtin_sym_end] = ACTIONS(2556),
    [sym__identifier_token] = ACTIONS(2558),
    [anon_sym_extern] = ACTIONS(2558),
    [anon_sym_alias] = ACTIONS(2558),
    [anon_sym_SEMI] = ACTIONS(2556),
    [anon_sym_global] = ACTIONS(2558),
    [anon_sym_using] = ACTIONS(2558),
    [anon_sym_static] = ACTIONS(2558),
    [anon_sym_LBRACK] = ACTIONS(2556),
    [anon_sym_return] = ACTIONS(2558),
    [anon_sym_LPAREN] = ACTIONS(2556),
    [anon_sym_abstract] = ACTIONS(2558),
    [anon_sym_async] = ACTIONS(2558),
    [anon_sym_const] = ACTIONS(2558),
    [anon_sym_fixed] = ACTIONS(2558),
    [anon_sym_internal] = ACTIONS(2558),
    [anon_sym_new] = ACTIONS(2558),
    [anon_sym_override] = ACTIONS(2558),
    [anon_sym_partial] = ACTIONS(2558),
    [anon_sym_private] = ACTIONS(2558),
    [anon_sym_protected] = ACTIONS(2558),
    [anon_sym_public] = ACTIONS(2558),
    [anon_sym_readonly] = ACTIONS(2558),
    [anon_sym_ref] = ACTIONS(2558),
    [anon_sym_sealed] = ACTIONS(2558),
    [anon_sym_unsafe] = ACTIONS(2558),
    [anon_sym_virtual] = ACTIONS(2558),
    [anon_sym_volatile] = ACTIONS(2558),
    [anon_sym_this] = ACTIONS(2558),
    [anon_sym_base] = ACTIONS(2558),
    [anon_sym_LBRACE] = ACTIONS(2556),
    [anon_sym_TILDE] = ACTIONS(2556),
    [anon_sym_where] = ACTIONS(2558),
    [anon_sym_class] = ACTIONS(2558),
    [anon_sym_struct] = ACTIONS(2558),
    [anon_sym_notnull] = ACTIONS(2558),
    [anon_sym_unmanaged] = ACTIONS(2558),
    [anon_sym_BANG] = ACTIONS(2556),
    [anon_sym_PLUS_PLUS] = ACTIONS(2556),
    [anon_sym_DASH_DASH] = ACTIONS(2556),
    [anon_sym_true] = ACTIONS(2558),
    [anon_sym_false] = ACTIONS(2558),
    [anon_sym_PLUS] = ACTIONS(2558),
    [anon_sym_DASH] = ACTIONS(2558),
    [anon_sym_STAR] = ACTIONS(2556),
    [anon_sym_CARET] = ACTIONS(2556),
    [anon_sym_AMP] = ACTIONS(2556),
    [anon_sym_get] = ACTIONS(2558),
    [anon_sym_set] = ACTIONS(2558),
    [anon_sym_add] = ACTIONS(2558),
    [anon_sym_remove] = ACTIONS(2558),
    [anon_sym_enum] = ACTIONS(2558),
    [anon_sym_interface] = ACTIONS(2558),
    [anon_sym_delegate] = ACTIONS(2558),
    [anon_sym_record] = ACTIONS(2558),
    [anon_sym_namespace] = ACTIONS(2558),
    [anon_sym_var] = ACTIONS(2558),
    [sym_predefined_type] = ACTIONS(2558),
    [anon_sym_break] = ACTIONS(2558),
    [anon_sym_checked] = ACTIONS(2558),
    [anon_sym_unchecked] = ACTIONS(2558),
    [anon_sym_continue] = ACTIONS(2558),
    [anon_sym_do] = ACTIONS(2558),
    [anon_sym_while] = ACTIONS(2558),
    [anon_sym_for] = ACTIONS(2558),
    [anon_sym_await] = ACTIONS(2558),
    [anon_sym_foreach] = ACTIONS(2558),
    [anon_sym_goto] = ACTIONS(2558),
    [anon_sym_default] = ACTIONS(2558),
    [anon_sym_if] = ACTIONS(2558),
    [anon_sym_lock] = ACTIONS(2558),
    [anon_sym_switch] = ACTIONS(2558),
    [anon_sym_when] = ACTIONS(2558),
    [anon_sym_throw] = ACTIONS(2558),
    [anon_sym_try] = ACTIONS(2558),
    [anon_sym_yield] = ACTIONS(2558),
    [anon_sym_stackalloc] = ACTIONS(2558),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2556),
    [anon_sym_DQUOTE] = ACTIONS(2556),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2556),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2556),
    [anon_sym___makeref] = ACTIONS(2558),
    [anon_sym_from] = ACTIONS(2558),
    [anon_sym_join] = ACTIONS(2558),
    [anon_sym_on] = ACTIONS(2558),
    [anon_sym_equals] = ACTIONS(2558),
    [anon_sym_into] = ACTIONS(2558),
    [anon_sym_let] = ACTIONS(2558),
    [anon_sym_orderby] = ACTIONS(2558),
    [anon_sym_ascending] = ACTIONS(2558),
    [anon_sym_descending] = ACTIONS(2558),
    [anon_sym_group] = ACTIONS(2558),
    [anon_sym_by] = ACTIONS(2558),
    [anon_sym_select] = ACTIONS(2558),
    [anon_sym_DOT_DOT] = ACTIONS(2556),
    [anon_sym___reftype] = ACTIONS(2558),
    [anon_sym___refvalue] = ACTIONS(2558),
    [anon_sym_sizeof] = ACTIONS(2558),
    [anon_sym_typeof] = ACTIONS(2558),
    [anon_sym_SQUOTE] = ACTIONS(2556),
    [sym_integer_literal] = ACTIONS(2558),
    [sym_null_literal] = ACTIONS(2558),
    [sym_real_literal] = ACTIONS(2556),
    [sym_verbatim_string_literal] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2558),
    [anon_sym_nameof] = ACTIONS(2558),
    [sym_void_keyword] = ACTIONS(2558),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1637] = {
    [sym__preprocessor_call] = STATE(1637),
    [ts_builtin_sym_end] = ACTIONS(2560),
    [sym__identifier_token] = ACTIONS(2562),
    [anon_sym_extern] = ACTIONS(2562),
    [anon_sym_alias] = ACTIONS(2562),
    [anon_sym_SEMI] = ACTIONS(2560),
    [anon_sym_global] = ACTIONS(2562),
    [anon_sym_using] = ACTIONS(2562),
    [anon_sym_static] = ACTIONS(2562),
    [anon_sym_LBRACK] = ACTIONS(2560),
    [anon_sym_return] = ACTIONS(2562),
    [anon_sym_LPAREN] = ACTIONS(2560),
    [anon_sym_abstract] = ACTIONS(2562),
    [anon_sym_async] = ACTIONS(2562),
    [anon_sym_const] = ACTIONS(2562),
    [anon_sym_fixed] = ACTIONS(2562),
    [anon_sym_internal] = ACTIONS(2562),
    [anon_sym_new] = ACTIONS(2562),
    [anon_sym_override] = ACTIONS(2562),
    [anon_sym_partial] = ACTIONS(2562),
    [anon_sym_private] = ACTIONS(2562),
    [anon_sym_protected] = ACTIONS(2562),
    [anon_sym_public] = ACTIONS(2562),
    [anon_sym_readonly] = ACTIONS(2562),
    [anon_sym_ref] = ACTIONS(2562),
    [anon_sym_sealed] = ACTIONS(2562),
    [anon_sym_unsafe] = ACTIONS(2562),
    [anon_sym_virtual] = ACTIONS(2562),
    [anon_sym_volatile] = ACTIONS(2562),
    [anon_sym_this] = ACTIONS(2562),
    [anon_sym_base] = ACTIONS(2562),
    [anon_sym_LBRACE] = ACTIONS(2560),
    [anon_sym_TILDE] = ACTIONS(2560),
    [anon_sym_where] = ACTIONS(2562),
    [anon_sym_class] = ACTIONS(2562),
    [anon_sym_struct] = ACTIONS(2562),
    [anon_sym_notnull] = ACTIONS(2562),
    [anon_sym_unmanaged] = ACTIONS(2562),
    [anon_sym_BANG] = ACTIONS(2560),
    [anon_sym_PLUS_PLUS] = ACTIONS(2560),
    [anon_sym_DASH_DASH] = ACTIONS(2560),
    [anon_sym_true] = ACTIONS(2562),
    [anon_sym_false] = ACTIONS(2562),
    [anon_sym_PLUS] = ACTIONS(2562),
    [anon_sym_DASH] = ACTIONS(2562),
    [anon_sym_STAR] = ACTIONS(2560),
    [anon_sym_CARET] = ACTIONS(2560),
    [anon_sym_AMP] = ACTIONS(2560),
    [anon_sym_get] = ACTIONS(2562),
    [anon_sym_set] = ACTIONS(2562),
    [anon_sym_add] = ACTIONS(2562),
    [anon_sym_remove] = ACTIONS(2562),
    [anon_sym_enum] = ACTIONS(2562),
    [anon_sym_interface] = ACTIONS(2562),
    [anon_sym_delegate] = ACTIONS(2562),
    [anon_sym_record] = ACTIONS(2562),
    [anon_sym_namespace] = ACTIONS(2562),
    [anon_sym_var] = ACTIONS(2562),
    [sym_predefined_type] = ACTIONS(2562),
    [anon_sym_break] = ACTIONS(2562),
    [anon_sym_checked] = ACTIONS(2562),
    [anon_sym_unchecked] = ACTIONS(2562),
    [anon_sym_continue] = ACTIONS(2562),
    [anon_sym_do] = ACTIONS(2562),
    [anon_sym_while] = ACTIONS(2562),
    [anon_sym_for] = ACTIONS(2562),
    [anon_sym_await] = ACTIONS(2562),
    [anon_sym_foreach] = ACTIONS(2562),
    [anon_sym_goto] = ACTIONS(2562),
    [anon_sym_default] = ACTIONS(2562),
    [anon_sym_if] = ACTIONS(2562),
    [anon_sym_lock] = ACTIONS(2562),
    [anon_sym_switch] = ACTIONS(2562),
    [anon_sym_when] = ACTIONS(2562),
    [anon_sym_throw] = ACTIONS(2562),
    [anon_sym_try] = ACTIONS(2562),
    [anon_sym_yield] = ACTIONS(2562),
    [anon_sym_stackalloc] = ACTIONS(2562),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2560),
    [anon_sym_DQUOTE] = ACTIONS(2560),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2560),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2560),
    [anon_sym___makeref] = ACTIONS(2562),
    [anon_sym_from] = ACTIONS(2562),
    [anon_sym_join] = ACTIONS(2562),
    [anon_sym_on] = ACTIONS(2562),
    [anon_sym_equals] = ACTIONS(2562),
    [anon_sym_into] = ACTIONS(2562),
    [anon_sym_let] = ACTIONS(2562),
    [anon_sym_orderby] = ACTIONS(2562),
    [anon_sym_ascending] = ACTIONS(2562),
    [anon_sym_descending] = ACTIONS(2562),
    [anon_sym_group] = ACTIONS(2562),
    [anon_sym_by] = ACTIONS(2562),
    [anon_sym_select] = ACTIONS(2562),
    [anon_sym_DOT_DOT] = ACTIONS(2560),
    [anon_sym___reftype] = ACTIONS(2562),
    [anon_sym___refvalue] = ACTIONS(2562),
    [anon_sym_sizeof] = ACTIONS(2562),
    [anon_sym_typeof] = ACTIONS(2562),
    [anon_sym_SQUOTE] = ACTIONS(2560),
    [sym_integer_literal] = ACTIONS(2562),
    [sym_null_literal] = ACTIONS(2562),
    [sym_real_literal] = ACTIONS(2560),
    [sym_verbatim_string_literal] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2562),
    [anon_sym_nameof] = ACTIONS(2562),
    [sym_void_keyword] = ACTIONS(2562),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1638] = {
    [sym__preprocessor_call] = STATE(1638),
    [ts_builtin_sym_end] = ACTIONS(2564),
    [sym__identifier_token] = ACTIONS(2566),
    [anon_sym_extern] = ACTIONS(2566),
    [anon_sym_alias] = ACTIONS(2566),
    [anon_sym_SEMI] = ACTIONS(2564),
    [anon_sym_global] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_static] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_return] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_async] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_fixed] = ACTIONS(2566),
    [anon_sym_internal] = ACTIONS(2566),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_override] = ACTIONS(2566),
    [anon_sym_partial] = ACTIONS(2566),
    [anon_sym_private] = ACTIONS(2566),
    [anon_sym_protected] = ACTIONS(2566),
    [anon_sym_public] = ACTIONS(2566),
    [anon_sym_readonly] = ACTIONS(2566),
    [anon_sym_ref] = ACTIONS(2566),
    [anon_sym_sealed] = ACTIONS(2566),
    [anon_sym_unsafe] = ACTIONS(2566),
    [anon_sym_virtual] = ACTIONS(2566),
    [anon_sym_volatile] = ACTIONS(2566),
    [anon_sym_this] = ACTIONS(2566),
    [anon_sym_base] = ACTIONS(2566),
    [anon_sym_LBRACE] = ACTIONS(2564),
    [anon_sym_TILDE] = ACTIONS(2564),
    [anon_sym_where] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_notnull] = ACTIONS(2566),
    [anon_sym_unmanaged] = ACTIONS(2566),
    [anon_sym_BANG] = ACTIONS(2564),
    [anon_sym_PLUS_PLUS] = ACTIONS(2564),
    [anon_sym_DASH_DASH] = ACTIONS(2564),
    [anon_sym_true] = ACTIONS(2566),
    [anon_sym_false] = ACTIONS(2566),
    [anon_sym_PLUS] = ACTIONS(2566),
    [anon_sym_DASH] = ACTIONS(2566),
    [anon_sym_STAR] = ACTIONS(2564),
    [anon_sym_CARET] = ACTIONS(2564),
    [anon_sym_AMP] = ACTIONS(2564),
    [anon_sym_get] = ACTIONS(2566),
    [anon_sym_set] = ACTIONS(2566),
    [anon_sym_add] = ACTIONS(2566),
    [anon_sym_remove] = ACTIONS(2566),
    [anon_sym_enum] = ACTIONS(2566),
    [anon_sym_interface] = ACTIONS(2566),
    [anon_sym_delegate] = ACTIONS(2566),
    [anon_sym_record] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_var] = ACTIONS(2566),
    [sym_predefined_type] = ACTIONS(2566),
    [anon_sym_break] = ACTIONS(2566),
    [anon_sym_checked] = ACTIONS(2566),
    [anon_sym_unchecked] = ACTIONS(2566),
    [anon_sym_continue] = ACTIONS(2566),
    [anon_sym_do] = ACTIONS(2566),
    [anon_sym_while] = ACTIONS(2566),
    [anon_sym_for] = ACTIONS(2566),
    [anon_sym_await] = ACTIONS(2566),
    [anon_sym_foreach] = ACTIONS(2566),
    [anon_sym_goto] = ACTIONS(2566),
    [anon_sym_default] = ACTIONS(2566),
    [anon_sym_if] = ACTIONS(2566),
    [anon_sym_lock] = ACTIONS(2566),
    [anon_sym_switch] = ACTIONS(2566),
    [anon_sym_when] = ACTIONS(2566),
    [anon_sym_throw] = ACTIONS(2566),
    [anon_sym_try] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_stackalloc] = ACTIONS(2566),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2564),
    [anon_sym_DQUOTE] = ACTIONS(2564),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2564),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2564),
    [anon_sym___makeref] = ACTIONS(2566),
    [anon_sym_from] = ACTIONS(2566),
    [anon_sym_join] = ACTIONS(2566),
    [anon_sym_on] = ACTIONS(2566),
    [anon_sym_equals] = ACTIONS(2566),
    [anon_sym_into] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_orderby] = ACTIONS(2566),
    [anon_sym_ascending] = ACTIONS(2566),
    [anon_sym_descending] = ACTIONS(2566),
    [anon_sym_group] = ACTIONS(2566),
    [anon_sym_by] = ACTIONS(2566),
    [anon_sym_select] = ACTIONS(2566),
    [anon_sym_DOT_DOT] = ACTIONS(2564),
    [anon_sym___reftype] = ACTIONS(2566),
    [anon_sym___refvalue] = ACTIONS(2566),
    [anon_sym_sizeof] = ACTIONS(2566),
    [anon_sym_typeof] = ACTIONS(2566),
    [anon_sym_SQUOTE] = ACTIONS(2564),
    [sym_integer_literal] = ACTIONS(2566),
    [sym_null_literal] = ACTIONS(2566),
    [sym_real_literal] = ACTIONS(2564),
    [sym_verbatim_string_literal] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2566),
    [anon_sym_nameof] = ACTIONS(2566),
    [sym_void_keyword] = ACTIONS(2566),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1639] = {
    [sym_catch_clause] = STATE(1651),
    [sym__preprocessor_call] = STATE(1639),
    [aux_sym_try_statement_repeat1] = STATE(1639),
    [sym__identifier_token] = ACTIONS(2201),
    [anon_sym_extern] = ACTIONS(2201),
    [anon_sym_alias] = ACTIONS(2201),
    [anon_sym_SEMI] = ACTIONS(2199),
    [anon_sym_global] = ACTIONS(2201),
    [anon_sym_using] = ACTIONS(2201),
    [anon_sym_static] = ACTIONS(2201),
    [anon_sym_LBRACK] = ACTIONS(2199),
    [anon_sym_return] = ACTIONS(2201),
    [anon_sym_LPAREN] = ACTIONS(2199),
    [anon_sym_abstract] = ACTIONS(2201),
    [anon_sym_async] = ACTIONS(2201),
    [anon_sym_const] = ACTIONS(2201),
    [anon_sym_fixed] = ACTIONS(2201),
    [anon_sym_internal] = ACTIONS(2201),
    [anon_sym_new] = ACTIONS(2201),
    [anon_sym_override] = ACTIONS(2201),
    [anon_sym_partial] = ACTIONS(2201),
    [anon_sym_private] = ACTIONS(2201),
    [anon_sym_protected] = ACTIONS(2201),
    [anon_sym_public] = ACTIONS(2201),
    [anon_sym_readonly] = ACTIONS(2201),
    [anon_sym_ref] = ACTIONS(2201),
    [anon_sym_sealed] = ACTIONS(2201),
    [anon_sym_unsafe] = ACTIONS(2201),
    [anon_sym_virtual] = ACTIONS(2201),
    [anon_sym_volatile] = ACTIONS(2201),
    [anon_sym_this] = ACTIONS(2201),
    [anon_sym_base] = ACTIONS(2201),
    [anon_sym_LBRACE] = ACTIONS(2199),
    [anon_sym_RBRACE] = ACTIONS(2199),
    [anon_sym_TILDE] = ACTIONS(2199),
    [anon_sym_where] = ACTIONS(2201),
    [anon_sym_notnull] = ACTIONS(2201),
    [anon_sym_unmanaged] = ACTIONS(2201),
    [anon_sym_BANG] = ACTIONS(2199),
    [anon_sym_PLUS_PLUS] = ACTIONS(2199),
    [anon_sym_DASH_DASH] = ACTIONS(2199),
    [anon_sym_true] = ACTIONS(2201),
    [anon_sym_false] = ACTIONS(2201),
    [anon_sym_PLUS] = ACTIONS(2201),
    [anon_sym_DASH] = ACTIONS(2201),
    [anon_sym_STAR] = ACTIONS(2199),
    [anon_sym_CARET] = ACTIONS(2199),
    [anon_sym_AMP] = ACTIONS(2199),
    [anon_sym_get] = ACTIONS(2201),
    [anon_sym_set] = ACTIONS(2201),
    [anon_sym_add] = ACTIONS(2201),
    [anon_sym_remove] = ACTIONS(2201),
    [anon_sym_delegate] = ACTIONS(2201),
    [anon_sym_var] = ACTIONS(2201),
    [sym_predefined_type] = ACTIONS(2201),
    [anon_sym_break] = ACTIONS(2201),
    [anon_sym_checked] = ACTIONS(2201),
    [anon_sym_unchecked] = ACTIONS(2201),
    [anon_sym_continue] = ACTIONS(2201),
    [anon_sym_do] = ACTIONS(2201),
    [anon_sym_while] = ACTIONS(2201),
    [anon_sym_for] = ACTIONS(2201),
    [anon_sym_await] = ACTIONS(2201),
    [anon_sym_foreach] = ACTIONS(2201),
    [anon_sym_goto] = ACTIONS(2201),
    [anon_sym_case] = ACTIONS(2201),
    [anon_sym_default] = ACTIONS(2201),
    [anon_sym_if] = ACTIONS(2201),
    [anon_sym_else] = ACTIONS(2201),
    [anon_sym_lock] = ACTIONS(2201),
    [anon_sym_switch] = ACTIONS(2201),
    [anon_sym_when] = ACTIONS(2201),
    [anon_sym_throw] = ACTIONS(2201),
    [anon_sym_try] = ACTIONS(2201),
    [anon_sym_catch] = ACTIONS(2568),
    [anon_sym_finally] = ACTIONS(2201),
    [anon_sym_yield] = ACTIONS(2201),
    [anon_sym_stackalloc] = ACTIONS(2201),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2199),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2199),
    [anon_sym___makeref] = ACTIONS(2201),
    [anon_sym_from] = ACTIONS(2201),
    [anon_sym_join] = ACTIONS(2201),
    [anon_sym_on] = ACTIONS(2201),
    [anon_sym_equals] = ACTIONS(2201),
    [anon_sym_into] = ACTIONS(2201),
    [anon_sym_let] = ACTIONS(2201),
    [anon_sym_orderby] = ACTIONS(2201),
    [anon_sym_ascending] = ACTIONS(2201),
    [anon_sym_descending] = ACTIONS(2201),
    [anon_sym_group] = ACTIONS(2201),
    [anon_sym_by] = ACTIONS(2201),
    [anon_sym_select] = ACTIONS(2201),
    [anon_sym_DOT_DOT] = ACTIONS(2199),
    [anon_sym___reftype] = ACTIONS(2201),
    [anon_sym___refvalue] = ACTIONS(2201),
    [anon_sym_sizeof] = ACTIONS(2201),
    [anon_sym_typeof] = ACTIONS(2201),
    [anon_sym_SQUOTE] = ACTIONS(2199),
    [sym_integer_literal] = ACTIONS(2201),
    [sym_null_literal] = ACTIONS(2201),
    [sym_real_literal] = ACTIONS(2199),
    [sym_verbatim_string_literal] = ACTIONS(2199),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2201),
    [anon_sym_nameof] = ACTIONS(2201),
    [sym_void_keyword] = ACTIONS(2201),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1640] = {
    [sym__preprocessor_call] = STATE(1640),
    [ts_builtin_sym_end] = ACTIONS(2571),
    [sym__identifier_token] = ACTIONS(2573),
    [anon_sym_extern] = ACTIONS(2573),
    [anon_sym_alias] = ACTIONS(2573),
    [anon_sym_SEMI] = ACTIONS(2571),
    [anon_sym_global] = ACTIONS(2573),
    [anon_sym_using] = ACTIONS(2573),
    [anon_sym_static] = ACTIONS(2573),
    [anon_sym_LBRACK] = ACTIONS(2571),
    [anon_sym_return] = ACTIONS(2573),
    [anon_sym_LPAREN] = ACTIONS(2571),
    [anon_sym_abstract] = ACTIONS(2573),
    [anon_sym_async] = ACTIONS(2573),
    [anon_sym_const] = ACTIONS(2573),
    [anon_sym_fixed] = ACTIONS(2573),
    [anon_sym_internal] = ACTIONS(2573),
    [anon_sym_new] = ACTIONS(2573),
    [anon_sym_override] = ACTIONS(2573),
    [anon_sym_partial] = ACTIONS(2573),
    [anon_sym_private] = ACTIONS(2573),
    [anon_sym_protected] = ACTIONS(2573),
    [anon_sym_public] = ACTIONS(2573),
    [anon_sym_readonly] = ACTIONS(2573),
    [anon_sym_ref] = ACTIONS(2573),
    [anon_sym_sealed] = ACTIONS(2573),
    [anon_sym_unsafe] = ACTIONS(2573),
    [anon_sym_virtual] = ACTIONS(2573),
    [anon_sym_volatile] = ACTIONS(2573),
    [anon_sym_this] = ACTIONS(2573),
    [anon_sym_base] = ACTIONS(2573),
    [anon_sym_LBRACE] = ACTIONS(2571),
    [anon_sym_TILDE] = ACTIONS(2571),
    [anon_sym_where] = ACTIONS(2573),
    [anon_sym_class] = ACTIONS(2573),
    [anon_sym_struct] = ACTIONS(2573),
    [anon_sym_notnull] = ACTIONS(2573),
    [anon_sym_unmanaged] = ACTIONS(2573),
    [anon_sym_BANG] = ACTIONS(2571),
    [anon_sym_PLUS_PLUS] = ACTIONS(2571),
    [anon_sym_DASH_DASH] = ACTIONS(2571),
    [anon_sym_true] = ACTIONS(2573),
    [anon_sym_false] = ACTIONS(2573),
    [anon_sym_PLUS] = ACTIONS(2573),
    [anon_sym_DASH] = ACTIONS(2573),
    [anon_sym_STAR] = ACTIONS(2571),
    [anon_sym_CARET] = ACTIONS(2571),
    [anon_sym_AMP] = ACTIONS(2571),
    [anon_sym_get] = ACTIONS(2573),
    [anon_sym_set] = ACTIONS(2573),
    [anon_sym_add] = ACTIONS(2573),
    [anon_sym_remove] = ACTIONS(2573),
    [anon_sym_enum] = ACTIONS(2573),
    [anon_sym_interface] = ACTIONS(2573),
    [anon_sym_delegate] = ACTIONS(2573),
    [anon_sym_record] = ACTIONS(2573),
    [anon_sym_namespace] = ACTIONS(2573),
    [anon_sym_var] = ACTIONS(2573),
    [sym_predefined_type] = ACTIONS(2573),
    [anon_sym_break] = ACTIONS(2573),
    [anon_sym_checked] = ACTIONS(2573),
    [anon_sym_unchecked] = ACTIONS(2573),
    [anon_sym_continue] = ACTIONS(2573),
    [anon_sym_do] = ACTIONS(2573),
    [anon_sym_while] = ACTIONS(2573),
    [anon_sym_for] = ACTIONS(2573),
    [anon_sym_await] = ACTIONS(2573),
    [anon_sym_foreach] = ACTIONS(2573),
    [anon_sym_goto] = ACTIONS(2573),
    [anon_sym_default] = ACTIONS(2573),
    [anon_sym_if] = ACTIONS(2573),
    [anon_sym_lock] = ACTIONS(2573),
    [anon_sym_switch] = ACTIONS(2573),
    [anon_sym_when] = ACTIONS(2573),
    [anon_sym_throw] = ACTIONS(2573),
    [anon_sym_try] = ACTIONS(2573),
    [anon_sym_yield] = ACTIONS(2573),
    [anon_sym_stackalloc] = ACTIONS(2573),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2571),
    [anon_sym_DQUOTE] = ACTIONS(2571),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2571),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2571),
    [anon_sym___makeref] = ACTIONS(2573),
    [anon_sym_from] = ACTIONS(2573),
    [anon_sym_join] = ACTIONS(2573),
    [anon_sym_on] = ACTIONS(2573),
    [anon_sym_equals] = ACTIONS(2573),
    [anon_sym_into] = ACTIONS(2573),
    [anon_sym_let] = ACTIONS(2573),
    [anon_sym_orderby] = ACTIONS(2573),
    [anon_sym_ascending] = ACTIONS(2573),
    [anon_sym_descending] = ACTIONS(2573),
    [anon_sym_group] = ACTIONS(2573),
    [anon_sym_by] = ACTIONS(2573),
    [anon_sym_select] = ACTIONS(2573),
    [anon_sym_DOT_DOT] = ACTIONS(2571),
    [anon_sym___reftype] = ACTIONS(2573),
    [anon_sym___refvalue] = ACTIONS(2573),
    [anon_sym_sizeof] = ACTIONS(2573),
    [anon_sym_typeof] = ACTIONS(2573),
    [anon_sym_SQUOTE] = ACTIONS(2571),
    [sym_integer_literal] = ACTIONS(2573),
    [sym_null_literal] = ACTIONS(2573),
    [sym_real_literal] = ACTIONS(2571),
    [sym_verbatim_string_literal] = ACTIONS(2571),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2573),
    [anon_sym_nameof] = ACTIONS(2573),
    [sym_void_keyword] = ACTIONS(2573),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1641] = {
    [sym__preprocessor_call] = STATE(1641),
    [ts_builtin_sym_end] = ACTIONS(2575),
    [sym__identifier_token] = ACTIONS(2577),
    [anon_sym_extern] = ACTIONS(2577),
    [anon_sym_alias] = ACTIONS(2577),
    [anon_sym_SEMI] = ACTIONS(2575),
    [anon_sym_global] = ACTIONS(2577),
    [anon_sym_using] = ACTIONS(2577),
    [anon_sym_static] = ACTIONS(2577),
    [anon_sym_LBRACK] = ACTIONS(2575),
    [anon_sym_return] = ACTIONS(2577),
    [anon_sym_LPAREN] = ACTIONS(2575),
    [anon_sym_abstract] = ACTIONS(2577),
    [anon_sym_async] = ACTIONS(2577),
    [anon_sym_const] = ACTIONS(2577),
    [anon_sym_fixed] = ACTIONS(2577),
    [anon_sym_internal] = ACTIONS(2577),
    [anon_sym_new] = ACTIONS(2577),
    [anon_sym_override] = ACTIONS(2577),
    [anon_sym_partial] = ACTIONS(2577),
    [anon_sym_private] = ACTIONS(2577),
    [anon_sym_protected] = ACTIONS(2577),
    [anon_sym_public] = ACTIONS(2577),
    [anon_sym_readonly] = ACTIONS(2577),
    [anon_sym_ref] = ACTIONS(2577),
    [anon_sym_sealed] = ACTIONS(2577),
    [anon_sym_unsafe] = ACTIONS(2577),
    [anon_sym_virtual] = ACTIONS(2577),
    [anon_sym_volatile] = ACTIONS(2577),
    [anon_sym_this] = ACTIONS(2577),
    [anon_sym_base] = ACTIONS(2577),
    [anon_sym_LBRACE] = ACTIONS(2575),
    [anon_sym_TILDE] = ACTIONS(2575),
    [anon_sym_where] = ACTIONS(2577),
    [anon_sym_class] = ACTIONS(2577),
    [anon_sym_struct] = ACTIONS(2577),
    [anon_sym_notnull] = ACTIONS(2577),
    [anon_sym_unmanaged] = ACTIONS(2577),
    [anon_sym_BANG] = ACTIONS(2575),
    [anon_sym_PLUS_PLUS] = ACTIONS(2575),
    [anon_sym_DASH_DASH] = ACTIONS(2575),
    [anon_sym_true] = ACTIONS(2577),
    [anon_sym_false] = ACTIONS(2577),
    [anon_sym_PLUS] = ACTIONS(2577),
    [anon_sym_DASH] = ACTIONS(2577),
    [anon_sym_STAR] = ACTIONS(2575),
    [anon_sym_CARET] = ACTIONS(2575),
    [anon_sym_AMP] = ACTIONS(2575),
    [anon_sym_get] = ACTIONS(2577),
    [anon_sym_set] = ACTIONS(2577),
    [anon_sym_add] = ACTIONS(2577),
    [anon_sym_remove] = ACTIONS(2577),
    [anon_sym_enum] = ACTIONS(2577),
    [anon_sym_interface] = ACTIONS(2577),
    [anon_sym_delegate] = ACTIONS(2577),
    [anon_sym_record] = ACTIONS(2577),
    [anon_sym_namespace] = ACTIONS(2577),
    [anon_sym_var] = ACTIONS(2577),
    [sym_predefined_type] = ACTIONS(2577),
    [anon_sym_break] = ACTIONS(2577),
    [anon_sym_checked] = ACTIONS(2577),
    [anon_sym_unchecked] = ACTIONS(2577),
    [anon_sym_continue] = ACTIONS(2577),
    [anon_sym_do] = ACTIONS(2577),
    [anon_sym_while] = ACTIONS(2577),
    [anon_sym_for] = ACTIONS(2577),
    [anon_sym_await] = ACTIONS(2577),
    [anon_sym_foreach] = ACTIONS(2577),
    [anon_sym_goto] = ACTIONS(2577),
    [anon_sym_default] = ACTIONS(2577),
    [anon_sym_if] = ACTIONS(2577),
    [anon_sym_lock] = ACTIONS(2577),
    [anon_sym_switch] = ACTIONS(2577),
    [anon_sym_when] = ACTIONS(2577),
    [anon_sym_throw] = ACTIONS(2577),
    [anon_sym_try] = ACTIONS(2577),
    [anon_sym_yield] = ACTIONS(2577),
    [anon_sym_stackalloc] = ACTIONS(2577),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2575),
    [anon_sym_DQUOTE] = ACTIONS(2575),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2575),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2575),
    [anon_sym___makeref] = ACTIONS(2577),
    [anon_sym_from] = ACTIONS(2577),
    [anon_sym_join] = ACTIONS(2577),
    [anon_sym_on] = ACTIONS(2577),
    [anon_sym_equals] = ACTIONS(2577),
    [anon_sym_into] = ACTIONS(2577),
    [anon_sym_let] = ACTIONS(2577),
    [anon_sym_orderby] = ACTIONS(2577),
    [anon_sym_ascending] = ACTIONS(2577),
    [anon_sym_descending] = ACTIONS(2577),
    [anon_sym_group] = ACTIONS(2577),
    [anon_sym_by] = ACTIONS(2577),
    [anon_sym_select] = ACTIONS(2577),
    [anon_sym_DOT_DOT] = ACTIONS(2575),
    [anon_sym___reftype] = ACTIONS(2577),
    [anon_sym___refvalue] = ACTIONS(2577),
    [anon_sym_sizeof] = ACTIONS(2577),
    [anon_sym_typeof] = ACTIONS(2577),
    [anon_sym_SQUOTE] = ACTIONS(2575),
    [sym_integer_literal] = ACTIONS(2577),
    [sym_null_literal] = ACTIONS(2577),
    [sym_real_literal] = ACTIONS(2575),
    [sym_verbatim_string_literal] = ACTIONS(2575),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2577),
    [anon_sym_nameof] = ACTIONS(2577),
    [sym_void_keyword] = ACTIONS(2577),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1642] = {
    [sym__preprocessor_call] = STATE(1642),
    [ts_builtin_sym_end] = ACTIONS(2579),
    [sym__identifier_token] = ACTIONS(2581),
    [anon_sym_extern] = ACTIONS(2581),
    [anon_sym_alias] = ACTIONS(2581),
    [anon_sym_SEMI] = ACTIONS(2579),
    [anon_sym_global] = ACTIONS(2581),
    [anon_sym_using] = ACTIONS(2581),
    [anon_sym_static] = ACTIONS(2581),
    [anon_sym_LBRACK] = ACTIONS(2579),
    [anon_sym_return] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_abstract] = ACTIONS(2581),
    [anon_sym_async] = ACTIONS(2581),
    [anon_sym_const] = ACTIONS(2581),
    [anon_sym_fixed] = ACTIONS(2581),
    [anon_sym_internal] = ACTIONS(2581),
    [anon_sym_new] = ACTIONS(2581),
    [anon_sym_override] = ACTIONS(2581),
    [anon_sym_partial] = ACTIONS(2581),
    [anon_sym_private] = ACTIONS(2581),
    [anon_sym_protected] = ACTIONS(2581),
    [anon_sym_public] = ACTIONS(2581),
    [anon_sym_readonly] = ACTIONS(2581),
    [anon_sym_ref] = ACTIONS(2581),
    [anon_sym_sealed] = ACTIONS(2581),
    [anon_sym_unsafe] = ACTIONS(2581),
    [anon_sym_virtual] = ACTIONS(2581),
    [anon_sym_volatile] = ACTIONS(2581),
    [anon_sym_this] = ACTIONS(2581),
    [anon_sym_base] = ACTIONS(2581),
    [anon_sym_LBRACE] = ACTIONS(2579),
    [anon_sym_TILDE] = ACTIONS(2579),
    [anon_sym_where] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_struct] = ACTIONS(2581),
    [anon_sym_notnull] = ACTIONS(2581),
    [anon_sym_unmanaged] = ACTIONS(2581),
    [anon_sym_BANG] = ACTIONS(2579),
    [anon_sym_PLUS_PLUS] = ACTIONS(2579),
    [anon_sym_DASH_DASH] = ACTIONS(2579),
    [anon_sym_true] = ACTIONS(2581),
    [anon_sym_false] = ACTIONS(2581),
    [anon_sym_PLUS] = ACTIONS(2581),
    [anon_sym_DASH] = ACTIONS(2581),
    [anon_sym_STAR] = ACTIONS(2579),
    [anon_sym_CARET] = ACTIONS(2579),
    [anon_sym_AMP] = ACTIONS(2579),
    [anon_sym_get] = ACTIONS(2581),
    [anon_sym_set] = ACTIONS(2581),
    [anon_sym_add] = ACTIONS(2581),
    [anon_sym_remove] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2581),
    [anon_sym_interface] = ACTIONS(2581),
    [anon_sym_delegate] = ACTIONS(2581),
    [anon_sym_record] = ACTIONS(2581),
    [anon_sym_namespace] = ACTIONS(2581),
    [anon_sym_var] = ACTIONS(2581),
    [sym_predefined_type] = ACTIONS(2581),
    [anon_sym_break] = ACTIONS(2581),
    [anon_sym_checked] = ACTIONS(2581),
    [anon_sym_unchecked] = ACTIONS(2581),
    [anon_sym_continue] = ACTIONS(2581),
    [anon_sym_do] = ACTIONS(2581),
    [anon_sym_while] = ACTIONS(2581),
    [anon_sym_for] = ACTIONS(2581),
    [anon_sym_await] = ACTIONS(2581),
    [anon_sym_foreach] = ACTIONS(2581),
    [anon_sym_goto] = ACTIONS(2581),
    [anon_sym_default] = ACTIONS(2581),
    [anon_sym_if] = ACTIONS(2581),
    [anon_sym_lock] = ACTIONS(2581),
    [anon_sym_switch] = ACTIONS(2581),
    [anon_sym_when] = ACTIONS(2581),
    [anon_sym_throw] = ACTIONS(2581),
    [anon_sym_try] = ACTIONS(2581),
    [anon_sym_yield] = ACTIONS(2581),
    [anon_sym_stackalloc] = ACTIONS(2581),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2579),
    [anon_sym_DQUOTE] = ACTIONS(2579),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2579),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2579),
    [anon_sym___makeref] = ACTIONS(2581),
    [anon_sym_from] = ACTIONS(2581),
    [anon_sym_join] = ACTIONS(2581),
    [anon_sym_on] = ACTIONS(2581),
    [anon_sym_equals] = ACTIONS(2581),
    [anon_sym_into] = ACTIONS(2581),
    [anon_sym_let] = ACTIONS(2581),
    [anon_sym_orderby] = ACTIONS(2581),
    [anon_sym_ascending] = ACTIONS(2581),
    [anon_sym_descending] = ACTIONS(2581),
    [anon_sym_group] = ACTIONS(2581),
    [anon_sym_by] = ACTIONS(2581),
    [anon_sym_select] = ACTIONS(2581),
    [anon_sym_DOT_DOT] = ACTIONS(2579),
    [anon_sym___reftype] = ACTIONS(2581),
    [anon_sym___refvalue] = ACTIONS(2581),
    [anon_sym_sizeof] = ACTIONS(2581),
    [anon_sym_typeof] = ACTIONS(2581),
    [anon_sym_SQUOTE] = ACTIONS(2579),
    [sym_integer_literal] = ACTIONS(2581),
    [sym_null_literal] = ACTIONS(2581),
    [sym_real_literal] = ACTIONS(2579),
    [sym_verbatim_string_literal] = ACTIONS(2579),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2581),
    [anon_sym_nameof] = ACTIONS(2581),
    [sym_void_keyword] = ACTIONS(2581),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1643] = {
    [sym__preprocessor_call] = STATE(1643),
    [ts_builtin_sym_end] = ACTIONS(2583),
    [sym__identifier_token] = ACTIONS(2585),
    [anon_sym_extern] = ACTIONS(2585),
    [anon_sym_alias] = ACTIONS(2585),
    [anon_sym_SEMI] = ACTIONS(2583),
    [anon_sym_global] = ACTIONS(2585),
    [anon_sym_using] = ACTIONS(2585),
    [anon_sym_static] = ACTIONS(2585),
    [anon_sym_LBRACK] = ACTIONS(2583),
    [anon_sym_return] = ACTIONS(2585),
    [anon_sym_LPAREN] = ACTIONS(2583),
    [anon_sym_abstract] = ACTIONS(2585),
    [anon_sym_async] = ACTIONS(2585),
    [anon_sym_const] = ACTIONS(2585),
    [anon_sym_fixed] = ACTIONS(2585),
    [anon_sym_internal] = ACTIONS(2585),
    [anon_sym_new] = ACTIONS(2585),
    [anon_sym_override] = ACTIONS(2585),
    [anon_sym_partial] = ACTIONS(2585),
    [anon_sym_private] = ACTIONS(2585),
    [anon_sym_protected] = ACTIONS(2585),
    [anon_sym_public] = ACTIONS(2585),
    [anon_sym_readonly] = ACTIONS(2585),
    [anon_sym_ref] = ACTIONS(2585),
    [anon_sym_sealed] = ACTIONS(2585),
    [anon_sym_unsafe] = ACTIONS(2585),
    [anon_sym_virtual] = ACTIONS(2585),
    [anon_sym_volatile] = ACTIONS(2585),
    [anon_sym_this] = ACTIONS(2585),
    [anon_sym_base] = ACTIONS(2585),
    [anon_sym_LBRACE] = ACTIONS(2583),
    [anon_sym_TILDE] = ACTIONS(2583),
    [anon_sym_where] = ACTIONS(2585),
    [anon_sym_class] = ACTIONS(2585),
    [anon_sym_struct] = ACTIONS(2585),
    [anon_sym_notnull] = ACTIONS(2585),
    [anon_sym_unmanaged] = ACTIONS(2585),
    [anon_sym_BANG] = ACTIONS(2583),
    [anon_sym_PLUS_PLUS] = ACTIONS(2583),
    [anon_sym_DASH_DASH] = ACTIONS(2583),
    [anon_sym_true] = ACTIONS(2585),
    [anon_sym_false] = ACTIONS(2585),
    [anon_sym_PLUS] = ACTIONS(2585),
    [anon_sym_DASH] = ACTIONS(2585),
    [anon_sym_STAR] = ACTIONS(2583),
    [anon_sym_CARET] = ACTIONS(2583),
    [anon_sym_AMP] = ACTIONS(2583),
    [anon_sym_get] = ACTIONS(2585),
    [anon_sym_set] = ACTIONS(2585),
    [anon_sym_add] = ACTIONS(2585),
    [anon_sym_remove] = ACTIONS(2585),
    [anon_sym_enum] = ACTIONS(2585),
    [anon_sym_interface] = ACTIONS(2585),
    [anon_sym_delegate] = ACTIONS(2585),
    [anon_sym_record] = ACTIONS(2585),
    [anon_sym_namespace] = ACTIONS(2585),
    [anon_sym_var] = ACTIONS(2585),
    [sym_predefined_type] = ACTIONS(2585),
    [anon_sym_break] = ACTIONS(2585),
    [anon_sym_checked] = ACTIONS(2585),
    [anon_sym_unchecked] = ACTIONS(2585),
    [anon_sym_continue] = ACTIONS(2585),
    [anon_sym_do] = ACTIONS(2585),
    [anon_sym_while] = ACTIONS(2585),
    [anon_sym_for] = ACTIONS(2585),
    [anon_sym_await] = ACTIONS(2585),
    [anon_sym_foreach] = ACTIONS(2585),
    [anon_sym_goto] = ACTIONS(2585),
    [anon_sym_default] = ACTIONS(2585),
    [anon_sym_if] = ACTIONS(2585),
    [anon_sym_lock] = ACTIONS(2585),
    [anon_sym_switch] = ACTIONS(2585),
    [anon_sym_when] = ACTIONS(2585),
    [anon_sym_throw] = ACTIONS(2585),
    [anon_sym_try] = ACTIONS(2585),
    [anon_sym_yield] = ACTIONS(2585),
    [anon_sym_stackalloc] = ACTIONS(2585),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2583),
    [anon_sym_DQUOTE] = ACTIONS(2583),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2583),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2583),
    [anon_sym___makeref] = ACTIONS(2585),
    [anon_sym_from] = ACTIONS(2585),
    [anon_sym_join] = ACTIONS(2585),
    [anon_sym_on] = ACTIONS(2585),
    [anon_sym_equals] = ACTIONS(2585),
    [anon_sym_into] = ACTIONS(2585),
    [anon_sym_let] = ACTIONS(2585),
    [anon_sym_orderby] = ACTIONS(2585),
    [anon_sym_ascending] = ACTIONS(2585),
    [anon_sym_descending] = ACTIONS(2585),
    [anon_sym_group] = ACTIONS(2585),
    [anon_sym_by] = ACTIONS(2585),
    [anon_sym_select] = ACTIONS(2585),
    [anon_sym_DOT_DOT] = ACTIONS(2583),
    [anon_sym___reftype] = ACTIONS(2585),
    [anon_sym___refvalue] = ACTIONS(2585),
    [anon_sym_sizeof] = ACTIONS(2585),
    [anon_sym_typeof] = ACTIONS(2585),
    [anon_sym_SQUOTE] = ACTIONS(2583),
    [sym_integer_literal] = ACTIONS(2585),
    [sym_null_literal] = ACTIONS(2585),
    [sym_real_literal] = ACTIONS(2583),
    [sym_verbatim_string_literal] = ACTIONS(2583),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2585),
    [anon_sym_nameof] = ACTIONS(2585),
    [sym_void_keyword] = ACTIONS(2585),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1644] = {
    [sym__preprocessor_call] = STATE(1644),
    [ts_builtin_sym_end] = ACTIONS(2587),
    [sym__identifier_token] = ACTIONS(2589),
    [anon_sym_extern] = ACTIONS(2589),
    [anon_sym_alias] = ACTIONS(2589),
    [anon_sym_SEMI] = ACTIONS(2587),
    [anon_sym_global] = ACTIONS(2589),
    [anon_sym_using] = ACTIONS(2589),
    [anon_sym_static] = ACTIONS(2589),
    [anon_sym_LBRACK] = ACTIONS(2587),
    [anon_sym_return] = ACTIONS(2589),
    [anon_sym_LPAREN] = ACTIONS(2587),
    [anon_sym_abstract] = ACTIONS(2589),
    [anon_sym_async] = ACTIONS(2589),
    [anon_sym_const] = ACTIONS(2589),
    [anon_sym_fixed] = ACTIONS(2589),
    [anon_sym_internal] = ACTIONS(2589),
    [anon_sym_new] = ACTIONS(2589),
    [anon_sym_override] = ACTIONS(2589),
    [anon_sym_partial] = ACTIONS(2589),
    [anon_sym_private] = ACTIONS(2589),
    [anon_sym_protected] = ACTIONS(2589),
    [anon_sym_public] = ACTIONS(2589),
    [anon_sym_readonly] = ACTIONS(2589),
    [anon_sym_ref] = ACTIONS(2589),
    [anon_sym_sealed] = ACTIONS(2589),
    [anon_sym_unsafe] = ACTIONS(2589),
    [anon_sym_virtual] = ACTIONS(2589),
    [anon_sym_volatile] = ACTIONS(2589),
    [anon_sym_this] = ACTIONS(2589),
    [anon_sym_base] = ACTIONS(2589),
    [anon_sym_LBRACE] = ACTIONS(2587),
    [anon_sym_TILDE] = ACTIONS(2587),
    [anon_sym_where] = ACTIONS(2589),
    [anon_sym_class] = ACTIONS(2589),
    [anon_sym_struct] = ACTIONS(2589),
    [anon_sym_notnull] = ACTIONS(2589),
    [anon_sym_unmanaged] = ACTIONS(2589),
    [anon_sym_BANG] = ACTIONS(2587),
    [anon_sym_PLUS_PLUS] = ACTIONS(2587),
    [anon_sym_DASH_DASH] = ACTIONS(2587),
    [anon_sym_true] = ACTIONS(2589),
    [anon_sym_false] = ACTIONS(2589),
    [anon_sym_PLUS] = ACTIONS(2589),
    [anon_sym_DASH] = ACTIONS(2589),
    [anon_sym_STAR] = ACTIONS(2587),
    [anon_sym_CARET] = ACTIONS(2587),
    [anon_sym_AMP] = ACTIONS(2587),
    [anon_sym_get] = ACTIONS(2589),
    [anon_sym_set] = ACTIONS(2589),
    [anon_sym_add] = ACTIONS(2589),
    [anon_sym_remove] = ACTIONS(2589),
    [anon_sym_enum] = ACTIONS(2589),
    [anon_sym_interface] = ACTIONS(2589),
    [anon_sym_delegate] = ACTIONS(2589),
    [anon_sym_record] = ACTIONS(2589),
    [anon_sym_namespace] = ACTIONS(2589),
    [anon_sym_var] = ACTIONS(2589),
    [sym_predefined_type] = ACTIONS(2589),
    [anon_sym_break] = ACTIONS(2589),
    [anon_sym_checked] = ACTIONS(2589),
    [anon_sym_unchecked] = ACTIONS(2589),
    [anon_sym_continue] = ACTIONS(2589),
    [anon_sym_do] = ACTIONS(2589),
    [anon_sym_while] = ACTIONS(2589),
    [anon_sym_for] = ACTIONS(2589),
    [anon_sym_await] = ACTIONS(2589),
    [anon_sym_foreach] = ACTIONS(2589),
    [anon_sym_goto] = ACTIONS(2589),
    [anon_sym_default] = ACTIONS(2589),
    [anon_sym_if] = ACTIONS(2589),
    [anon_sym_lock] = ACTIONS(2589),
    [anon_sym_switch] = ACTIONS(2589),
    [anon_sym_when] = ACTIONS(2589),
    [anon_sym_throw] = ACTIONS(2589),
    [anon_sym_try] = ACTIONS(2589),
    [anon_sym_yield] = ACTIONS(2589),
    [anon_sym_stackalloc] = ACTIONS(2589),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2587),
    [anon_sym_DQUOTE] = ACTIONS(2587),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2587),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2587),
    [anon_sym___makeref] = ACTIONS(2589),
    [anon_sym_from] = ACTIONS(2589),
    [anon_sym_join] = ACTIONS(2589),
    [anon_sym_on] = ACTIONS(2589),
    [anon_sym_equals] = ACTIONS(2589),
    [anon_sym_into] = ACTIONS(2589),
    [anon_sym_let] = ACTIONS(2589),
    [anon_sym_orderby] = ACTIONS(2589),
    [anon_sym_ascending] = ACTIONS(2589),
    [anon_sym_descending] = ACTIONS(2589),
    [anon_sym_group] = ACTIONS(2589),
    [anon_sym_by] = ACTIONS(2589),
    [anon_sym_select] = ACTIONS(2589),
    [anon_sym_DOT_DOT] = ACTIONS(2587),
    [anon_sym___reftype] = ACTIONS(2589),
    [anon_sym___refvalue] = ACTIONS(2589),
    [anon_sym_sizeof] = ACTIONS(2589),
    [anon_sym_typeof] = ACTIONS(2589),
    [anon_sym_SQUOTE] = ACTIONS(2587),
    [sym_integer_literal] = ACTIONS(2589),
    [sym_null_literal] = ACTIONS(2589),
    [sym_real_literal] = ACTIONS(2587),
    [sym_verbatim_string_literal] = ACTIONS(2587),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2589),
    [anon_sym_nameof] = ACTIONS(2589),
    [sym_void_keyword] = ACTIONS(2589),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1645] = {
    [sym__preprocessor_call] = STATE(1645),
    [ts_builtin_sym_end] = ACTIONS(2591),
    [sym__identifier_token] = ACTIONS(2593),
    [anon_sym_extern] = ACTIONS(2593),
    [anon_sym_alias] = ACTIONS(2593),
    [anon_sym_SEMI] = ACTIONS(2591),
    [anon_sym_global] = ACTIONS(2593),
    [anon_sym_using] = ACTIONS(2593),
    [anon_sym_static] = ACTIONS(2593),
    [anon_sym_LBRACK] = ACTIONS(2591),
    [anon_sym_return] = ACTIONS(2593),
    [anon_sym_LPAREN] = ACTIONS(2591),
    [anon_sym_abstract] = ACTIONS(2593),
    [anon_sym_async] = ACTIONS(2593),
    [anon_sym_const] = ACTIONS(2593),
    [anon_sym_fixed] = ACTIONS(2593),
    [anon_sym_internal] = ACTIONS(2593),
    [anon_sym_new] = ACTIONS(2593),
    [anon_sym_override] = ACTIONS(2593),
    [anon_sym_partial] = ACTIONS(2593),
    [anon_sym_private] = ACTIONS(2593),
    [anon_sym_protected] = ACTIONS(2593),
    [anon_sym_public] = ACTIONS(2593),
    [anon_sym_readonly] = ACTIONS(2593),
    [anon_sym_ref] = ACTIONS(2593),
    [anon_sym_sealed] = ACTIONS(2593),
    [anon_sym_unsafe] = ACTIONS(2593),
    [anon_sym_virtual] = ACTIONS(2593),
    [anon_sym_volatile] = ACTIONS(2593),
    [anon_sym_this] = ACTIONS(2593),
    [anon_sym_base] = ACTIONS(2593),
    [anon_sym_LBRACE] = ACTIONS(2591),
    [anon_sym_TILDE] = ACTIONS(2591),
    [anon_sym_where] = ACTIONS(2593),
    [anon_sym_class] = ACTIONS(2593),
    [anon_sym_struct] = ACTIONS(2593),
    [anon_sym_notnull] = ACTIONS(2593),
    [anon_sym_unmanaged] = ACTIONS(2593),
    [anon_sym_BANG] = ACTIONS(2591),
    [anon_sym_PLUS_PLUS] = ACTIONS(2591),
    [anon_sym_DASH_DASH] = ACTIONS(2591),
    [anon_sym_true] = ACTIONS(2593),
    [anon_sym_false] = ACTIONS(2593),
    [anon_sym_PLUS] = ACTIONS(2593),
    [anon_sym_DASH] = ACTIONS(2593),
    [anon_sym_STAR] = ACTIONS(2591),
    [anon_sym_CARET] = ACTIONS(2591),
    [anon_sym_AMP] = ACTIONS(2591),
    [anon_sym_get] = ACTIONS(2593),
    [anon_sym_set] = ACTIONS(2593),
    [anon_sym_add] = ACTIONS(2593),
    [anon_sym_remove] = ACTIONS(2593),
    [anon_sym_enum] = ACTIONS(2593),
    [anon_sym_interface] = ACTIONS(2593),
    [anon_sym_delegate] = ACTIONS(2593),
    [anon_sym_record] = ACTIONS(2593),
    [anon_sym_namespace] = ACTIONS(2593),
    [anon_sym_var] = ACTIONS(2593),
    [sym_predefined_type] = ACTIONS(2593),
    [anon_sym_break] = ACTIONS(2593),
    [anon_sym_checked] = ACTIONS(2593),
    [anon_sym_unchecked] = ACTIONS(2593),
    [anon_sym_continue] = ACTIONS(2593),
    [anon_sym_do] = ACTIONS(2593),
    [anon_sym_while] = ACTIONS(2593),
    [anon_sym_for] = ACTIONS(2593),
    [anon_sym_await] = ACTIONS(2593),
    [anon_sym_foreach] = ACTIONS(2593),
    [anon_sym_goto] = ACTIONS(2593),
    [anon_sym_default] = ACTIONS(2593),
    [anon_sym_if] = ACTIONS(2593),
    [anon_sym_lock] = ACTIONS(2593),
    [anon_sym_switch] = ACTIONS(2593),
    [anon_sym_when] = ACTIONS(2593),
    [anon_sym_throw] = ACTIONS(2593),
    [anon_sym_try] = ACTIONS(2593),
    [anon_sym_yield] = ACTIONS(2593),
    [anon_sym_stackalloc] = ACTIONS(2593),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2591),
    [anon_sym_DQUOTE] = ACTIONS(2591),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2591),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2591),
    [anon_sym___makeref] = ACTIONS(2593),
    [anon_sym_from] = ACTIONS(2593),
    [anon_sym_join] = ACTIONS(2593),
    [anon_sym_on] = ACTIONS(2593),
    [anon_sym_equals] = ACTIONS(2593),
    [anon_sym_into] = ACTIONS(2593),
    [anon_sym_let] = ACTIONS(2593),
    [anon_sym_orderby] = ACTIONS(2593),
    [anon_sym_ascending] = ACTIONS(2593),
    [anon_sym_descending] = ACTIONS(2593),
    [anon_sym_group] = ACTIONS(2593),
    [anon_sym_by] = ACTIONS(2593),
    [anon_sym_select] = ACTIONS(2593),
    [anon_sym_DOT_DOT] = ACTIONS(2591),
    [anon_sym___reftype] = ACTIONS(2593),
    [anon_sym___refvalue] = ACTIONS(2593),
    [anon_sym_sizeof] = ACTIONS(2593),
    [anon_sym_typeof] = ACTIONS(2593),
    [anon_sym_SQUOTE] = ACTIONS(2591),
    [sym_integer_literal] = ACTIONS(2593),
    [sym_null_literal] = ACTIONS(2593),
    [sym_real_literal] = ACTIONS(2591),
    [sym_verbatim_string_literal] = ACTIONS(2591),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2593),
    [anon_sym_nameof] = ACTIONS(2593),
    [sym_void_keyword] = ACTIONS(2593),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1646] = {
    [sym__preprocessor_call] = STATE(1646),
    [sym__identifier_token] = ACTIONS(2224),
    [anon_sym_extern] = ACTIONS(2224),
    [anon_sym_alias] = ACTIONS(2224),
    [anon_sym_SEMI] = ACTIONS(2222),
    [anon_sym_global] = ACTIONS(2224),
    [anon_sym_using] = ACTIONS(2224),
    [anon_sym_static] = ACTIONS(2224),
    [anon_sym_LBRACK] = ACTIONS(2222),
    [anon_sym_return] = ACTIONS(2224),
    [anon_sym_LPAREN] = ACTIONS(2222),
    [anon_sym_abstract] = ACTIONS(2224),
    [anon_sym_async] = ACTIONS(2224),
    [anon_sym_const] = ACTIONS(2224),
    [anon_sym_fixed] = ACTIONS(2224),
    [anon_sym_internal] = ACTIONS(2224),
    [anon_sym_new] = ACTIONS(2224),
    [anon_sym_override] = ACTIONS(2224),
    [anon_sym_partial] = ACTIONS(2224),
    [anon_sym_private] = ACTIONS(2224),
    [anon_sym_protected] = ACTIONS(2224),
    [anon_sym_public] = ACTIONS(2224),
    [anon_sym_readonly] = ACTIONS(2224),
    [anon_sym_ref] = ACTIONS(2224),
    [anon_sym_sealed] = ACTIONS(2224),
    [anon_sym_unsafe] = ACTIONS(2224),
    [anon_sym_virtual] = ACTIONS(2224),
    [anon_sym_volatile] = ACTIONS(2224),
    [anon_sym_this] = ACTIONS(2224),
    [anon_sym_base] = ACTIONS(2224),
    [anon_sym_LBRACE] = ACTIONS(2222),
    [anon_sym_RBRACE] = ACTIONS(2222),
    [anon_sym_TILDE] = ACTIONS(2222),
    [anon_sym_where] = ACTIONS(2224),
    [anon_sym_notnull] = ACTIONS(2224),
    [anon_sym_unmanaged] = ACTIONS(2224),
    [anon_sym_BANG] = ACTIONS(2222),
    [anon_sym_PLUS_PLUS] = ACTIONS(2222),
    [anon_sym_DASH_DASH] = ACTIONS(2222),
    [anon_sym_true] = ACTIONS(2224),
    [anon_sym_false] = ACTIONS(2224),
    [anon_sym_PLUS] = ACTIONS(2224),
    [anon_sym_DASH] = ACTIONS(2224),
    [anon_sym_STAR] = ACTIONS(2222),
    [anon_sym_CARET] = ACTIONS(2222),
    [anon_sym_AMP] = ACTIONS(2222),
    [anon_sym_get] = ACTIONS(2224),
    [anon_sym_set] = ACTIONS(2224),
    [anon_sym_add] = ACTIONS(2224),
    [anon_sym_remove] = ACTIONS(2224),
    [anon_sym_delegate] = ACTIONS(2224),
    [anon_sym_var] = ACTIONS(2224),
    [sym_predefined_type] = ACTIONS(2224),
    [anon_sym_break] = ACTIONS(2224),
    [anon_sym_checked] = ACTIONS(2224),
    [anon_sym_unchecked] = ACTIONS(2224),
    [anon_sym_continue] = ACTIONS(2224),
    [anon_sym_do] = ACTIONS(2224),
    [anon_sym_while] = ACTIONS(2224),
    [anon_sym_for] = ACTIONS(2224),
    [anon_sym_await] = ACTIONS(2224),
    [anon_sym_foreach] = ACTIONS(2224),
    [anon_sym_goto] = ACTIONS(2224),
    [anon_sym_case] = ACTIONS(2224),
    [anon_sym_default] = ACTIONS(2224),
    [anon_sym_if] = ACTIONS(2224),
    [anon_sym_else] = ACTIONS(2224),
    [anon_sym_lock] = ACTIONS(2224),
    [anon_sym_switch] = ACTIONS(2224),
    [anon_sym_when] = ACTIONS(2224),
    [anon_sym_throw] = ACTIONS(2224),
    [anon_sym_try] = ACTIONS(2224),
    [anon_sym_catch] = ACTIONS(2224),
    [anon_sym_finally] = ACTIONS(2224),
    [anon_sym_yield] = ACTIONS(2224),
    [anon_sym_stackalloc] = ACTIONS(2224),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2222),
    [anon_sym_DQUOTE] = ACTIONS(2222),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2222),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2222),
    [anon_sym___makeref] = ACTIONS(2224),
    [anon_sym_from] = ACTIONS(2224),
    [anon_sym_join] = ACTIONS(2224),
    [anon_sym_on] = ACTIONS(2224),
    [anon_sym_equals] = ACTIONS(2224),
    [anon_sym_into] = ACTIONS(2224),
    [anon_sym_let] = ACTIONS(2224),
    [anon_sym_orderby] = ACTIONS(2224),
    [anon_sym_ascending] = ACTIONS(2224),
    [anon_sym_descending] = ACTIONS(2224),
    [anon_sym_group] = ACTIONS(2224),
    [anon_sym_by] = ACTIONS(2224),
    [anon_sym_select] = ACTIONS(2224),
    [anon_sym_DOT_DOT] = ACTIONS(2222),
    [anon_sym___reftype] = ACTIONS(2224),
    [anon_sym___refvalue] = ACTIONS(2224),
    [anon_sym_sizeof] = ACTIONS(2224),
    [anon_sym_typeof] = ACTIONS(2224),
    [anon_sym_SQUOTE] = ACTIONS(2222),
    [sym_integer_literal] = ACTIONS(2224),
    [sym_null_literal] = ACTIONS(2224),
    [sym_real_literal] = ACTIONS(2222),
    [sym_verbatim_string_literal] = ACTIONS(2222),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2224),
    [anon_sym_nameof] = ACTIONS(2224),
    [sym_void_keyword] = ACTIONS(2224),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1647] = {
    [sym__preprocessor_call] = STATE(1647),
    [sym__identifier_token] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(2216),
    [anon_sym_alias] = ACTIONS(2216),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_global] = ACTIONS(2216),
    [anon_sym_using] = ACTIONS(2216),
    [anon_sym_static] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_return] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_abstract] = ACTIONS(2216),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_const] = ACTIONS(2216),
    [anon_sym_fixed] = ACTIONS(2216),
    [anon_sym_internal] = ACTIONS(2216),
    [anon_sym_new] = ACTIONS(2216),
    [anon_sym_override] = ACTIONS(2216),
    [anon_sym_partial] = ACTIONS(2216),
    [anon_sym_private] = ACTIONS(2216),
    [anon_sym_protected] = ACTIONS(2216),
    [anon_sym_public] = ACTIONS(2216),
    [anon_sym_readonly] = ACTIONS(2216),
    [anon_sym_ref] = ACTIONS(2216),
    [anon_sym_sealed] = ACTIONS(2216),
    [anon_sym_unsafe] = ACTIONS(2216),
    [anon_sym_virtual] = ACTIONS(2216),
    [anon_sym_volatile] = ACTIONS(2216),
    [anon_sym_this] = ACTIONS(2216),
    [anon_sym_base] = ACTIONS(2216),
    [anon_sym_LBRACE] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_TILDE] = ACTIONS(2214),
    [anon_sym_where] = ACTIONS(2216),
    [anon_sym_notnull] = ACTIONS(2216),
    [anon_sym_unmanaged] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2214),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_true] = ACTIONS(2216),
    [anon_sym_false] = ACTIONS(2216),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(2214),
    [anon_sym_CARET] = ACTIONS(2214),
    [anon_sym_AMP] = ACTIONS(2214),
    [anon_sym_get] = ACTIONS(2216),
    [anon_sym_set] = ACTIONS(2216),
    [anon_sym_add] = ACTIONS(2216),
    [anon_sym_remove] = ACTIONS(2216),
    [anon_sym_delegate] = ACTIONS(2216),
    [anon_sym_var] = ACTIONS(2216),
    [sym_predefined_type] = ACTIONS(2216),
    [anon_sym_break] = ACTIONS(2216),
    [anon_sym_checked] = ACTIONS(2216),
    [anon_sym_unchecked] = ACTIONS(2216),
    [anon_sym_continue] = ACTIONS(2216),
    [anon_sym_do] = ACTIONS(2216),
    [anon_sym_while] = ACTIONS(2216),
    [anon_sym_for] = ACTIONS(2216),
    [anon_sym_await] = ACTIONS(2216),
    [anon_sym_foreach] = ACTIONS(2216),
    [anon_sym_goto] = ACTIONS(2216),
    [anon_sym_case] = ACTIONS(2216),
    [anon_sym_default] = ACTIONS(2216),
    [anon_sym_if] = ACTIONS(2216),
    [anon_sym_else] = ACTIONS(2216),
    [anon_sym_lock] = ACTIONS(2216),
    [anon_sym_switch] = ACTIONS(2216),
    [anon_sym_when] = ACTIONS(2216),
    [anon_sym_throw] = ACTIONS(2216),
    [anon_sym_try] = ACTIONS(2216),
    [anon_sym_catch] = ACTIONS(2216),
    [anon_sym_finally] = ACTIONS(2216),
    [anon_sym_yield] = ACTIONS(2216),
    [anon_sym_stackalloc] = ACTIONS(2216),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2214),
    [anon_sym_DQUOTE] = ACTIONS(2214),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2214),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2214),
    [anon_sym___makeref] = ACTIONS(2216),
    [anon_sym_from] = ACTIONS(2216),
    [anon_sym_join] = ACTIONS(2216),
    [anon_sym_on] = ACTIONS(2216),
    [anon_sym_equals] = ACTIONS(2216),
    [anon_sym_into] = ACTIONS(2216),
    [anon_sym_let] = ACTIONS(2216),
    [anon_sym_orderby] = ACTIONS(2216),
    [anon_sym_ascending] = ACTIONS(2216),
    [anon_sym_descending] = ACTIONS(2216),
    [anon_sym_group] = ACTIONS(2216),
    [anon_sym_by] = ACTIONS(2216),
    [anon_sym_select] = ACTIONS(2216),
    [anon_sym_DOT_DOT] = ACTIONS(2214),
    [anon_sym___reftype] = ACTIONS(2216),
    [anon_sym___refvalue] = ACTIONS(2216),
    [anon_sym_sizeof] = ACTIONS(2216),
    [anon_sym_typeof] = ACTIONS(2216),
    [anon_sym_SQUOTE] = ACTIONS(2214),
    [sym_integer_literal] = ACTIONS(2216),
    [sym_null_literal] = ACTIONS(2216),
    [sym_real_literal] = ACTIONS(2214),
    [sym_verbatim_string_literal] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2216),
    [anon_sym_nameof] = ACTIONS(2216),
    [sym_void_keyword] = ACTIONS(2216),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1648] = {
    [sym__declaration] = STATE(2459),
    [sym_using_directive] = STATE(2460),
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_event_field_declaration] = STATE(2460),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6936),
    [sym_field_declaration] = STATE(2460),
    [sym_constructor_declaration] = STATE(2460),
    [sym_conversion_operator_declaration] = STATE(2460),
    [sym_destructor_declaration] = STATE(2460),
    [sym_method_declaration] = STATE(2460),
    [sym_operator_declaration] = STATE(2460),
    [sym_event_declaration] = STATE(2460),
    [sym_indexer_declaration] = STATE(2460),
    [sym_property_declaration] = STATE(2460),
    [sym_enum_declaration] = STATE(2460),
    [sym_class_declaration] = STATE(2460),
    [sym_interface_declaration] = STATE(2460),
    [sym_struct_declaration] = STATE(2460),
    [sym_delegate_declaration] = STATE(2460),
    [sym_record_declaration] = STATE(2460),
    [sym_record_struct_declaration] = STATE(2460),
    [sym_namespace_declaration] = STATE(2460),
    [sym__type] = STATE(4571),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4646),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1648),
    [aux_sym_event_field_declaration_repeat1] = STATE(1857),
    [aux_sym_event_field_declaration_repeat2] = STATE(1948),
    [aux_sym_declaration_list_repeat1] = STATE(1648),
    [sym__identifier_token] = ACTIONS(2595),
    [anon_sym_extern] = ACTIONS(2598),
    [anon_sym_alias] = ACTIONS(2601),
    [anon_sym_global] = ACTIONS(2604),
    [anon_sym_using] = ACTIONS(2607),
    [anon_sym_static] = ACTIONS(2610),
    [anon_sym_LBRACK] = ACTIONS(2613),
    [anon_sym_event] = ACTIONS(2616),
    [anon_sym_LPAREN] = ACTIONS(2619),
    [anon_sym_abstract] = ACTIONS(2610),
    [anon_sym_async] = ACTIONS(2610),
    [anon_sym_const] = ACTIONS(2610),
    [anon_sym_fixed] = ACTIONS(2610),
    [anon_sym_internal] = ACTIONS(2610),
    [anon_sym_new] = ACTIONS(2610),
    [anon_sym_override] = ACTIONS(2610),
    [anon_sym_partial] = ACTIONS(2610),
    [anon_sym_private] = ACTIONS(2610),
    [anon_sym_protected] = ACTIONS(2610),
    [anon_sym_public] = ACTIONS(2610),
    [anon_sym_readonly] = ACTIONS(2610),
    [anon_sym_ref] = ACTIONS(2622),
    [anon_sym_sealed] = ACTIONS(2610),
    [anon_sym_unsafe] = ACTIONS(2610),
    [anon_sym_virtual] = ACTIONS(2610),
    [anon_sym_volatile] = ACTIONS(2610),
    [anon_sym_RBRACE] = ACTIONS(2625),
    [anon_sym_implicit] = ACTIONS(2627),
    [anon_sym_explicit] = ACTIONS(2627),
    [anon_sym_TILDE] = ACTIONS(2630),
    [anon_sym_where] = ACTIONS(2601),
    [anon_sym_class] = ACTIONS(2633),
    [anon_sym_struct] = ACTIONS(2636),
    [anon_sym_notnull] = ACTIONS(2601),
    [anon_sym_unmanaged] = ACTIONS(2601),
    [anon_sym_get] = ACTIONS(2601),
    [anon_sym_set] = ACTIONS(2601),
    [anon_sym_add] = ACTIONS(2601),
    [anon_sym_remove] = ACTIONS(2601),
    [anon_sym_enum] = ACTIONS(2639),
    [anon_sym_interface] = ACTIONS(2642),
    [anon_sym_delegate] = ACTIONS(2645),
    [anon_sym_record] = ACTIONS(2648),
    [anon_sym_namespace] = ACTIONS(2651),
    [anon_sym_var] = ACTIONS(2654),
    [sym_predefined_type] = ACTIONS(2657),
    [anon_sym_when] = ACTIONS(2601),
    [anon_sym_yield] = ACTIONS(2601),
    [anon_sym_from] = ACTIONS(2601),
    [anon_sym_join] = ACTIONS(2601),
    [anon_sym_on] = ACTIONS(2601),
    [anon_sym_equals] = ACTIONS(2601),
    [anon_sym_into] = ACTIONS(2601),
    [anon_sym_let] = ACTIONS(2601),
    [anon_sym_orderby] = ACTIONS(2601),
    [anon_sym_ascending] = ACTIONS(2601),
    [anon_sym_descending] = ACTIONS(2601),
    [anon_sym_group] = ACTIONS(2601),
    [anon_sym_by] = ACTIONS(2601),
    [anon_sym_select] = ACTIONS(2601),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2601),
    [anon_sym_nameof] = ACTIONS(2601),
    [sym_void_keyword] = ACTIONS(2660),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1649] = {
    [sym__preprocessor_call] = STATE(1649),
    [sym__identifier_token] = ACTIONS(2208),
    [anon_sym_extern] = ACTIONS(2208),
    [anon_sym_alias] = ACTIONS(2208),
    [anon_sym_SEMI] = ACTIONS(2206),
    [anon_sym_global] = ACTIONS(2208),
    [anon_sym_using] = ACTIONS(2208),
    [anon_sym_static] = ACTIONS(2208),
    [anon_sym_LBRACK] = ACTIONS(2206),
    [anon_sym_return] = ACTIONS(2208),
    [anon_sym_LPAREN] = ACTIONS(2206),
    [anon_sym_abstract] = ACTIONS(2208),
    [anon_sym_async] = ACTIONS(2208),
    [anon_sym_const] = ACTIONS(2208),
    [anon_sym_fixed] = ACTIONS(2208),
    [anon_sym_internal] = ACTIONS(2208),
    [anon_sym_new] = ACTIONS(2208),
    [anon_sym_override] = ACTIONS(2208),
    [anon_sym_partial] = ACTIONS(2208),
    [anon_sym_private] = ACTIONS(2208),
    [anon_sym_protected] = ACTIONS(2208),
    [anon_sym_public] = ACTIONS(2208),
    [anon_sym_readonly] = ACTIONS(2208),
    [anon_sym_ref] = ACTIONS(2208),
    [anon_sym_sealed] = ACTIONS(2208),
    [anon_sym_unsafe] = ACTIONS(2208),
    [anon_sym_virtual] = ACTIONS(2208),
    [anon_sym_volatile] = ACTIONS(2208),
    [anon_sym_this] = ACTIONS(2208),
    [anon_sym_base] = ACTIONS(2208),
    [anon_sym_LBRACE] = ACTIONS(2206),
    [anon_sym_RBRACE] = ACTIONS(2206),
    [anon_sym_TILDE] = ACTIONS(2206),
    [anon_sym_where] = ACTIONS(2208),
    [anon_sym_notnull] = ACTIONS(2208),
    [anon_sym_unmanaged] = ACTIONS(2208),
    [anon_sym_BANG] = ACTIONS(2206),
    [anon_sym_PLUS_PLUS] = ACTIONS(2206),
    [anon_sym_DASH_DASH] = ACTIONS(2206),
    [anon_sym_true] = ACTIONS(2208),
    [anon_sym_false] = ACTIONS(2208),
    [anon_sym_PLUS] = ACTIONS(2208),
    [anon_sym_DASH] = ACTIONS(2208),
    [anon_sym_STAR] = ACTIONS(2206),
    [anon_sym_CARET] = ACTIONS(2206),
    [anon_sym_AMP] = ACTIONS(2206),
    [anon_sym_get] = ACTIONS(2208),
    [anon_sym_set] = ACTIONS(2208),
    [anon_sym_add] = ACTIONS(2208),
    [anon_sym_remove] = ACTIONS(2208),
    [anon_sym_delegate] = ACTIONS(2208),
    [anon_sym_var] = ACTIONS(2208),
    [sym_predefined_type] = ACTIONS(2208),
    [anon_sym_break] = ACTIONS(2208),
    [anon_sym_checked] = ACTIONS(2208),
    [anon_sym_unchecked] = ACTIONS(2208),
    [anon_sym_continue] = ACTIONS(2208),
    [anon_sym_do] = ACTIONS(2208),
    [anon_sym_while] = ACTIONS(2208),
    [anon_sym_for] = ACTIONS(2208),
    [anon_sym_await] = ACTIONS(2208),
    [anon_sym_foreach] = ACTIONS(2208),
    [anon_sym_goto] = ACTIONS(2208),
    [anon_sym_case] = ACTIONS(2208),
    [anon_sym_default] = ACTIONS(2208),
    [anon_sym_if] = ACTIONS(2208),
    [anon_sym_else] = ACTIONS(2208),
    [anon_sym_lock] = ACTIONS(2208),
    [anon_sym_switch] = ACTIONS(2208),
    [anon_sym_when] = ACTIONS(2208),
    [anon_sym_throw] = ACTIONS(2208),
    [anon_sym_try] = ACTIONS(2208),
    [anon_sym_catch] = ACTIONS(2208),
    [anon_sym_finally] = ACTIONS(2208),
    [anon_sym_yield] = ACTIONS(2208),
    [anon_sym_stackalloc] = ACTIONS(2208),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2206),
    [anon_sym_DQUOTE] = ACTIONS(2206),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2206),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2206),
    [anon_sym___makeref] = ACTIONS(2208),
    [anon_sym_from] = ACTIONS(2208),
    [anon_sym_join] = ACTIONS(2208),
    [anon_sym_on] = ACTIONS(2208),
    [anon_sym_equals] = ACTIONS(2208),
    [anon_sym_into] = ACTIONS(2208),
    [anon_sym_let] = ACTIONS(2208),
    [anon_sym_orderby] = ACTIONS(2208),
    [anon_sym_ascending] = ACTIONS(2208),
    [anon_sym_descending] = ACTIONS(2208),
    [anon_sym_group] = ACTIONS(2208),
    [anon_sym_by] = ACTIONS(2208),
    [anon_sym_select] = ACTIONS(2208),
    [anon_sym_DOT_DOT] = ACTIONS(2206),
    [anon_sym___reftype] = ACTIONS(2208),
    [anon_sym___refvalue] = ACTIONS(2208),
    [anon_sym_sizeof] = ACTIONS(2208),
    [anon_sym_typeof] = ACTIONS(2208),
    [anon_sym_SQUOTE] = ACTIONS(2206),
    [sym_integer_literal] = ACTIONS(2208),
    [sym_null_literal] = ACTIONS(2208),
    [sym_real_literal] = ACTIONS(2206),
    [sym_verbatim_string_literal] = ACTIONS(2206),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2208),
    [anon_sym_nameof] = ACTIONS(2208),
    [sym_void_keyword] = ACTIONS(2208),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1650] = {
    [sym__declaration] = STATE(2459),
    [sym_using_directive] = STATE(2460),
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_event_field_declaration] = STATE(2460),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6936),
    [sym_field_declaration] = STATE(2460),
    [sym_constructor_declaration] = STATE(2460),
    [sym_conversion_operator_declaration] = STATE(2460),
    [sym_destructor_declaration] = STATE(2460),
    [sym_method_declaration] = STATE(2460),
    [sym_operator_declaration] = STATE(2460),
    [sym_event_declaration] = STATE(2460),
    [sym_indexer_declaration] = STATE(2460),
    [sym_property_declaration] = STATE(2460),
    [sym_enum_declaration] = STATE(2460),
    [sym_class_declaration] = STATE(2460),
    [sym_interface_declaration] = STATE(2460),
    [sym_struct_declaration] = STATE(2460),
    [sym_delegate_declaration] = STATE(2460),
    [sym_record_declaration] = STATE(2460),
    [sym_record_struct_declaration] = STATE(2460),
    [sym_namespace_declaration] = STATE(2460),
    [sym__type] = STATE(4571),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4646),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1650),
    [aux_sym_event_field_declaration_repeat1] = STATE(1857),
    [aux_sym_event_field_declaration_repeat2] = STATE(1948),
    [aux_sym_declaration_list_repeat1] = STATE(1648),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2671),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_event] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(29),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(2679),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(29),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2681),
    [anon_sym_implicit] = ACTIONS(2683),
    [anon_sym_explicit] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_interface] = ACTIONS(2693),
    [anon_sym_delegate] = ACTIONS(2695),
    [anon_sym_record] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2699),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(2703),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1651] = {
    [sym__preprocessor_call] = STATE(1651),
    [sym__identifier_token] = ACTIONS(2220),
    [anon_sym_extern] = ACTIONS(2220),
    [anon_sym_alias] = ACTIONS(2220),
    [anon_sym_SEMI] = ACTIONS(2218),
    [anon_sym_global] = ACTIONS(2220),
    [anon_sym_using] = ACTIONS(2220),
    [anon_sym_static] = ACTIONS(2220),
    [anon_sym_LBRACK] = ACTIONS(2218),
    [anon_sym_return] = ACTIONS(2220),
    [anon_sym_LPAREN] = ACTIONS(2218),
    [anon_sym_abstract] = ACTIONS(2220),
    [anon_sym_async] = ACTIONS(2220),
    [anon_sym_const] = ACTIONS(2220),
    [anon_sym_fixed] = ACTIONS(2220),
    [anon_sym_internal] = ACTIONS(2220),
    [anon_sym_new] = ACTIONS(2220),
    [anon_sym_override] = ACTIONS(2220),
    [anon_sym_partial] = ACTIONS(2220),
    [anon_sym_private] = ACTIONS(2220),
    [anon_sym_protected] = ACTIONS(2220),
    [anon_sym_public] = ACTIONS(2220),
    [anon_sym_readonly] = ACTIONS(2220),
    [anon_sym_ref] = ACTIONS(2220),
    [anon_sym_sealed] = ACTIONS(2220),
    [anon_sym_unsafe] = ACTIONS(2220),
    [anon_sym_virtual] = ACTIONS(2220),
    [anon_sym_volatile] = ACTIONS(2220),
    [anon_sym_this] = ACTIONS(2220),
    [anon_sym_base] = ACTIONS(2220),
    [anon_sym_LBRACE] = ACTIONS(2218),
    [anon_sym_RBRACE] = ACTIONS(2218),
    [anon_sym_TILDE] = ACTIONS(2218),
    [anon_sym_where] = ACTIONS(2220),
    [anon_sym_notnull] = ACTIONS(2220),
    [anon_sym_unmanaged] = ACTIONS(2220),
    [anon_sym_BANG] = ACTIONS(2218),
    [anon_sym_PLUS_PLUS] = ACTIONS(2218),
    [anon_sym_DASH_DASH] = ACTIONS(2218),
    [anon_sym_true] = ACTIONS(2220),
    [anon_sym_false] = ACTIONS(2220),
    [anon_sym_PLUS] = ACTIONS(2220),
    [anon_sym_DASH] = ACTIONS(2220),
    [anon_sym_STAR] = ACTIONS(2218),
    [anon_sym_CARET] = ACTIONS(2218),
    [anon_sym_AMP] = ACTIONS(2218),
    [anon_sym_get] = ACTIONS(2220),
    [anon_sym_set] = ACTIONS(2220),
    [anon_sym_add] = ACTIONS(2220),
    [anon_sym_remove] = ACTIONS(2220),
    [anon_sym_delegate] = ACTIONS(2220),
    [anon_sym_var] = ACTIONS(2220),
    [sym_predefined_type] = ACTIONS(2220),
    [anon_sym_break] = ACTIONS(2220),
    [anon_sym_checked] = ACTIONS(2220),
    [anon_sym_unchecked] = ACTIONS(2220),
    [anon_sym_continue] = ACTIONS(2220),
    [anon_sym_do] = ACTIONS(2220),
    [anon_sym_while] = ACTIONS(2220),
    [anon_sym_for] = ACTIONS(2220),
    [anon_sym_await] = ACTIONS(2220),
    [anon_sym_foreach] = ACTIONS(2220),
    [anon_sym_goto] = ACTIONS(2220),
    [anon_sym_case] = ACTIONS(2220),
    [anon_sym_default] = ACTIONS(2220),
    [anon_sym_if] = ACTIONS(2220),
    [anon_sym_else] = ACTIONS(2220),
    [anon_sym_lock] = ACTIONS(2220),
    [anon_sym_switch] = ACTIONS(2220),
    [anon_sym_when] = ACTIONS(2220),
    [anon_sym_throw] = ACTIONS(2220),
    [anon_sym_try] = ACTIONS(2220),
    [anon_sym_catch] = ACTIONS(2220),
    [anon_sym_finally] = ACTIONS(2220),
    [anon_sym_yield] = ACTIONS(2220),
    [anon_sym_stackalloc] = ACTIONS(2220),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2218),
    [anon_sym_DQUOTE] = ACTIONS(2218),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2218),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2218),
    [anon_sym___makeref] = ACTIONS(2220),
    [anon_sym_from] = ACTIONS(2220),
    [anon_sym_join] = ACTIONS(2220),
    [anon_sym_on] = ACTIONS(2220),
    [anon_sym_equals] = ACTIONS(2220),
    [anon_sym_into] = ACTIONS(2220),
    [anon_sym_let] = ACTIONS(2220),
    [anon_sym_orderby] = ACTIONS(2220),
    [anon_sym_ascending] = ACTIONS(2220),
    [anon_sym_descending] = ACTIONS(2220),
    [anon_sym_group] = ACTIONS(2220),
    [anon_sym_by] = ACTIONS(2220),
    [anon_sym_select] = ACTIONS(2220),
    [anon_sym_DOT_DOT] = ACTIONS(2218),
    [anon_sym___reftype] = ACTIONS(2220),
    [anon_sym___refvalue] = ACTIONS(2220),
    [anon_sym_sizeof] = ACTIONS(2220),
    [anon_sym_typeof] = ACTIONS(2220),
    [anon_sym_SQUOTE] = ACTIONS(2218),
    [sym_integer_literal] = ACTIONS(2220),
    [sym_null_literal] = ACTIONS(2220),
    [sym_real_literal] = ACTIONS(2218),
    [sym_verbatim_string_literal] = ACTIONS(2218),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2220),
    [anon_sym_nameof] = ACTIONS(2220),
    [sym_void_keyword] = ACTIONS(2220),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1652] = {
    [sym__preprocessor_call] = STATE(1652),
    [sym__identifier_token] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym_alias] = ACTIONS(1979),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_global] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_return] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_fixed] = ACTIONS(1979),
    [anon_sym_internal] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_partial] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_readonly] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_sealed] = ACTIONS(1979),
    [anon_sym_unsafe] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_this] = ACTIONS(1979),
    [anon_sym_base] = ACTIONS(1979),
    [anon_sym_LBRACE] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_where] = ACTIONS(1979),
    [anon_sym_notnull] = ACTIONS(1979),
    [anon_sym_unmanaged] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1977),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_true] = ACTIONS(1979),
    [anon_sym_false] = ACTIONS(1979),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1977),
    [anon_sym_CARET] = ACTIONS(1977),
    [anon_sym_AMP] = ACTIONS(1977),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_add] = ACTIONS(1979),
    [anon_sym_remove] = ACTIONS(1979),
    [anon_sym_delegate] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [sym_predefined_type] = ACTIONS(1979),
    [anon_sym_break] = ACTIONS(1979),
    [anon_sym_checked] = ACTIONS(1979),
    [anon_sym_unchecked] = ACTIONS(1979),
    [anon_sym_continue] = ACTIONS(1979),
    [anon_sym_do] = ACTIONS(1979),
    [anon_sym_while] = ACTIONS(1979),
    [anon_sym_for] = ACTIONS(1979),
    [anon_sym_await] = ACTIONS(1979),
    [anon_sym_foreach] = ACTIONS(1979),
    [anon_sym_goto] = ACTIONS(1979),
    [anon_sym_case] = ACTIONS(1979),
    [anon_sym_default] = ACTIONS(1979),
    [anon_sym_if] = ACTIONS(1979),
    [anon_sym_else] = ACTIONS(1979),
    [anon_sym_lock] = ACTIONS(1979),
    [anon_sym_switch] = ACTIONS(1979),
    [anon_sym_when] = ACTIONS(1979),
    [anon_sym_throw] = ACTIONS(1979),
    [anon_sym_try] = ACTIONS(1979),
    [anon_sym_catch] = ACTIONS(1979),
    [anon_sym_finally] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_stackalloc] = ACTIONS(1979),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(1977),
    [anon_sym_DQUOTE] = ACTIONS(1977),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(1977),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(1977),
    [anon_sym___makeref] = ACTIONS(1979),
    [anon_sym_from] = ACTIONS(1979),
    [anon_sym_join] = ACTIONS(1979),
    [anon_sym_on] = ACTIONS(1979),
    [anon_sym_equals] = ACTIONS(1979),
    [anon_sym_into] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_orderby] = ACTIONS(1979),
    [anon_sym_ascending] = ACTIONS(1979),
    [anon_sym_descending] = ACTIONS(1979),
    [anon_sym_group] = ACTIONS(1979),
    [anon_sym_by] = ACTIONS(1979),
    [anon_sym_select] = ACTIONS(1979),
    [anon_sym_DOT_DOT] = ACTIONS(1977),
    [anon_sym___reftype] = ACTIONS(1979),
    [anon_sym___refvalue] = ACTIONS(1979),
    [anon_sym_sizeof] = ACTIONS(1979),
    [anon_sym_typeof] = ACTIONS(1979),
    [anon_sym_SQUOTE] = ACTIONS(1977),
    [sym_integer_literal] = ACTIONS(1979),
    [sym_null_literal] = ACTIONS(1979),
    [sym_real_literal] = ACTIONS(1977),
    [sym_verbatim_string_literal] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(1979),
    [anon_sym_nameof] = ACTIONS(1979),
    [sym_void_keyword] = ACTIONS(1979),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1653] = {
    [sym_case_pattern_switch_label] = STATE(1735),
    [sym_case_switch_label] = STATE(1735),
    [sym_default_switch_label] = STATE(1735),
    [sym__preprocessor_call] = STATE(1653),
    [aux_sym_switch_section_repeat1] = STATE(1653),
    [sym__identifier_token] = ACTIONS(2705),
    [anon_sym_extern] = ACTIONS(2705),
    [anon_sym_alias] = ACTIONS(2705),
    [anon_sym_SEMI] = ACTIONS(2707),
    [anon_sym_global] = ACTIONS(2705),
    [anon_sym_using] = ACTIONS(2705),
    [anon_sym_static] = ACTIONS(2705),
    [anon_sym_LBRACK] = ACTIONS(2707),
    [anon_sym_return] = ACTIONS(2705),
    [anon_sym_LPAREN] = ACTIONS(2707),
    [anon_sym_abstract] = ACTIONS(2705),
    [anon_sym_async] = ACTIONS(2705),
    [anon_sym_const] = ACTIONS(2705),
    [anon_sym_fixed] = ACTIONS(2705),
    [anon_sym_internal] = ACTIONS(2705),
    [anon_sym_new] = ACTIONS(2705),
    [anon_sym_override] = ACTIONS(2705),
    [anon_sym_partial] = ACTIONS(2705),
    [anon_sym_private] = ACTIONS(2705),
    [anon_sym_protected] = ACTIONS(2705),
    [anon_sym_public] = ACTIONS(2705),
    [anon_sym_readonly] = ACTIONS(2705),
    [anon_sym_ref] = ACTIONS(2705),
    [anon_sym_sealed] = ACTIONS(2705),
    [anon_sym_unsafe] = ACTIONS(2705),
    [anon_sym_virtual] = ACTIONS(2705),
    [anon_sym_volatile] = ACTIONS(2705),
    [anon_sym_this] = ACTIONS(2705),
    [anon_sym_base] = ACTIONS(2705),
    [anon_sym_LBRACE] = ACTIONS(2707),
    [anon_sym_TILDE] = ACTIONS(2707),
    [anon_sym_where] = ACTIONS(2705),
    [anon_sym_notnull] = ACTIONS(2705),
    [anon_sym_unmanaged] = ACTIONS(2705),
    [anon_sym_BANG] = ACTIONS(2707),
    [anon_sym_PLUS_PLUS] = ACTIONS(2707),
    [anon_sym_DASH_DASH] = ACTIONS(2707),
    [anon_sym_true] = ACTIONS(2705),
    [anon_sym_false] = ACTIONS(2705),
    [anon_sym_PLUS] = ACTIONS(2705),
    [anon_sym_DASH] = ACTIONS(2705),
    [anon_sym_STAR] = ACTIONS(2707),
    [anon_sym_CARET] = ACTIONS(2707),
    [anon_sym_AMP] = ACTIONS(2707),
    [anon_sym_get] = ACTIONS(2705),
    [anon_sym_set] = ACTIONS(2705),
    [anon_sym_add] = ACTIONS(2705),
    [anon_sym_remove] = ACTIONS(2705),
    [anon_sym_delegate] = ACTIONS(2705),
    [anon_sym_var] = ACTIONS(2705),
    [sym_predefined_type] = ACTIONS(2705),
    [anon_sym_break] = ACTIONS(2705),
    [anon_sym_checked] = ACTIONS(2705),
    [anon_sym_unchecked] = ACTIONS(2705),
    [anon_sym_continue] = ACTIONS(2705),
    [anon_sym_do] = ACTIONS(2705),
    [anon_sym_while] = ACTIONS(2705),
    [anon_sym_for] = ACTIONS(2705),
    [anon_sym_await] = ACTIONS(2705),
    [anon_sym_foreach] = ACTIONS(2705),
    [anon_sym_goto] = ACTIONS(2705),
    [anon_sym_case] = ACTIONS(2709),
    [anon_sym_default] = ACTIONS(2712),
    [anon_sym_if] = ACTIONS(2705),
    [anon_sym_lock] = ACTIONS(2705),
    [anon_sym_switch] = ACTIONS(2705),
    [anon_sym_when] = ACTIONS(2705),
    [anon_sym_throw] = ACTIONS(2705),
    [anon_sym_try] = ACTIONS(2705),
    [anon_sym_yield] = ACTIONS(2705),
    [anon_sym_stackalloc] = ACTIONS(2705),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2707),
    [anon_sym_DQUOTE] = ACTIONS(2707),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2707),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2707),
    [anon_sym___makeref] = ACTIONS(2705),
    [anon_sym_from] = ACTIONS(2705),
    [anon_sym_join] = ACTIONS(2705),
    [anon_sym_on] = ACTIONS(2705),
    [anon_sym_equals] = ACTIONS(2705),
    [anon_sym_into] = ACTIONS(2705),
    [anon_sym_let] = ACTIONS(2705),
    [anon_sym_orderby] = ACTIONS(2705),
    [anon_sym_ascending] = ACTIONS(2705),
    [anon_sym_descending] = ACTIONS(2705),
    [anon_sym_group] = ACTIONS(2705),
    [anon_sym_by] = ACTIONS(2705),
    [anon_sym_select] = ACTIONS(2705),
    [anon_sym_DOT_DOT] = ACTIONS(2707),
    [anon_sym___reftype] = ACTIONS(2705),
    [anon_sym___refvalue] = ACTIONS(2705),
    [anon_sym_sizeof] = ACTIONS(2705),
    [anon_sym_typeof] = ACTIONS(2705),
    [anon_sym_SQUOTE] = ACTIONS(2707),
    [sym_integer_literal] = ACTIONS(2705),
    [sym_null_literal] = ACTIONS(2705),
    [sym_real_literal] = ACTIONS(2707),
    [sym_verbatim_string_literal] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2705),
    [anon_sym_nameof] = ACTIONS(2705),
    [sym_void_keyword] = ACTIONS(2705),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1654] = {
    [sym__declaration] = STATE(2459),
    [sym_using_directive] = STATE(2460),
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_event_field_declaration] = STATE(2460),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6936),
    [sym_field_declaration] = STATE(2460),
    [sym_constructor_declaration] = STATE(2460),
    [sym_conversion_operator_declaration] = STATE(2460),
    [sym_destructor_declaration] = STATE(2460),
    [sym_method_declaration] = STATE(2460),
    [sym_operator_declaration] = STATE(2460),
    [sym_event_declaration] = STATE(2460),
    [sym_indexer_declaration] = STATE(2460),
    [sym_property_declaration] = STATE(2460),
    [sym_enum_declaration] = STATE(2460),
    [sym_class_declaration] = STATE(2460),
    [sym_interface_declaration] = STATE(2460),
    [sym_struct_declaration] = STATE(2460),
    [sym_delegate_declaration] = STATE(2460),
    [sym_record_declaration] = STATE(2460),
    [sym_record_struct_declaration] = STATE(2460),
    [sym_namespace_declaration] = STATE(2460),
    [sym__type] = STATE(4571),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4646),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1654),
    [aux_sym_event_field_declaration_repeat1] = STATE(1857),
    [aux_sym_event_field_declaration_repeat2] = STATE(1948),
    [aux_sym_declaration_list_repeat1] = STATE(1648),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2671),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_event] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(29),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(2679),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(29),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2715),
    [anon_sym_implicit] = ACTIONS(2683),
    [anon_sym_explicit] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_interface] = ACTIONS(2693),
    [anon_sym_delegate] = ACTIONS(2695),
    [anon_sym_record] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2699),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(2703),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1655] = {
    [sym__preprocessor_call] = STATE(1655),
    [sym__identifier_token] = ACTIONS(2212),
    [anon_sym_extern] = ACTIONS(2212),
    [anon_sym_alias] = ACTIONS(2212),
    [anon_sym_SEMI] = ACTIONS(2210),
    [anon_sym_global] = ACTIONS(2212),
    [anon_sym_using] = ACTIONS(2212),
    [anon_sym_static] = ACTIONS(2212),
    [anon_sym_LBRACK] = ACTIONS(2210),
    [anon_sym_return] = ACTIONS(2212),
    [anon_sym_LPAREN] = ACTIONS(2210),
    [anon_sym_abstract] = ACTIONS(2212),
    [anon_sym_async] = ACTIONS(2212),
    [anon_sym_const] = ACTIONS(2212),
    [anon_sym_fixed] = ACTIONS(2212),
    [anon_sym_internal] = ACTIONS(2212),
    [anon_sym_new] = ACTIONS(2212),
    [anon_sym_override] = ACTIONS(2212),
    [anon_sym_partial] = ACTIONS(2212),
    [anon_sym_private] = ACTIONS(2212),
    [anon_sym_protected] = ACTIONS(2212),
    [anon_sym_public] = ACTIONS(2212),
    [anon_sym_readonly] = ACTIONS(2212),
    [anon_sym_ref] = ACTIONS(2212),
    [anon_sym_sealed] = ACTIONS(2212),
    [anon_sym_unsafe] = ACTIONS(2212),
    [anon_sym_virtual] = ACTIONS(2212),
    [anon_sym_volatile] = ACTIONS(2212),
    [anon_sym_this] = ACTIONS(2212),
    [anon_sym_base] = ACTIONS(2212),
    [anon_sym_LBRACE] = ACTIONS(2210),
    [anon_sym_RBRACE] = ACTIONS(2210),
    [anon_sym_TILDE] = ACTIONS(2210),
    [anon_sym_where] = ACTIONS(2212),
    [anon_sym_notnull] = ACTIONS(2212),
    [anon_sym_unmanaged] = ACTIONS(2212),
    [anon_sym_BANG] = ACTIONS(2210),
    [anon_sym_PLUS_PLUS] = ACTIONS(2210),
    [anon_sym_DASH_DASH] = ACTIONS(2210),
    [anon_sym_true] = ACTIONS(2212),
    [anon_sym_false] = ACTIONS(2212),
    [anon_sym_PLUS] = ACTIONS(2212),
    [anon_sym_DASH] = ACTIONS(2212),
    [anon_sym_STAR] = ACTIONS(2210),
    [anon_sym_CARET] = ACTIONS(2210),
    [anon_sym_AMP] = ACTIONS(2210),
    [anon_sym_get] = ACTIONS(2212),
    [anon_sym_set] = ACTIONS(2212),
    [anon_sym_add] = ACTIONS(2212),
    [anon_sym_remove] = ACTIONS(2212),
    [anon_sym_delegate] = ACTIONS(2212),
    [anon_sym_var] = ACTIONS(2212),
    [sym_predefined_type] = ACTIONS(2212),
    [anon_sym_break] = ACTIONS(2212),
    [anon_sym_checked] = ACTIONS(2212),
    [anon_sym_unchecked] = ACTIONS(2212),
    [anon_sym_continue] = ACTIONS(2212),
    [anon_sym_do] = ACTIONS(2212),
    [anon_sym_while] = ACTIONS(2212),
    [anon_sym_for] = ACTIONS(2212),
    [anon_sym_await] = ACTIONS(2212),
    [anon_sym_foreach] = ACTIONS(2212),
    [anon_sym_goto] = ACTIONS(2212),
    [anon_sym_case] = ACTIONS(2212),
    [anon_sym_default] = ACTIONS(2212),
    [anon_sym_if] = ACTIONS(2212),
    [anon_sym_else] = ACTIONS(2212),
    [anon_sym_lock] = ACTIONS(2212),
    [anon_sym_switch] = ACTIONS(2212),
    [anon_sym_when] = ACTIONS(2212),
    [anon_sym_throw] = ACTIONS(2212),
    [anon_sym_try] = ACTIONS(2212),
    [anon_sym_catch] = ACTIONS(2212),
    [anon_sym_finally] = ACTIONS(2212),
    [anon_sym_yield] = ACTIONS(2212),
    [anon_sym_stackalloc] = ACTIONS(2212),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2210),
    [anon_sym_DQUOTE] = ACTIONS(2210),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2210),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2210),
    [anon_sym___makeref] = ACTIONS(2212),
    [anon_sym_from] = ACTIONS(2212),
    [anon_sym_join] = ACTIONS(2212),
    [anon_sym_on] = ACTIONS(2212),
    [anon_sym_equals] = ACTIONS(2212),
    [anon_sym_into] = ACTIONS(2212),
    [anon_sym_let] = ACTIONS(2212),
    [anon_sym_orderby] = ACTIONS(2212),
    [anon_sym_ascending] = ACTIONS(2212),
    [anon_sym_descending] = ACTIONS(2212),
    [anon_sym_group] = ACTIONS(2212),
    [anon_sym_by] = ACTIONS(2212),
    [anon_sym_select] = ACTIONS(2212),
    [anon_sym_DOT_DOT] = ACTIONS(2210),
    [anon_sym___reftype] = ACTIONS(2212),
    [anon_sym___refvalue] = ACTIONS(2212),
    [anon_sym_sizeof] = ACTIONS(2212),
    [anon_sym_typeof] = ACTIONS(2212),
    [anon_sym_SQUOTE] = ACTIONS(2210),
    [sym_integer_literal] = ACTIONS(2212),
    [sym_null_literal] = ACTIONS(2212),
    [sym_real_literal] = ACTIONS(2210),
    [sym_verbatim_string_literal] = ACTIONS(2210),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2212),
    [anon_sym_nameof] = ACTIONS(2212),
    [sym_void_keyword] = ACTIONS(2212),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1656] = {
    [sym__declaration] = STATE(2459),
    [sym_using_directive] = STATE(2460),
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_event_field_declaration] = STATE(2460),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6936),
    [sym_field_declaration] = STATE(2460),
    [sym_constructor_declaration] = STATE(2460),
    [sym_conversion_operator_declaration] = STATE(2460),
    [sym_destructor_declaration] = STATE(2460),
    [sym_method_declaration] = STATE(2460),
    [sym_operator_declaration] = STATE(2460),
    [sym_event_declaration] = STATE(2460),
    [sym_indexer_declaration] = STATE(2460),
    [sym_property_declaration] = STATE(2460),
    [sym_enum_declaration] = STATE(2460),
    [sym_class_declaration] = STATE(2460),
    [sym_interface_declaration] = STATE(2460),
    [sym_struct_declaration] = STATE(2460),
    [sym_delegate_declaration] = STATE(2460),
    [sym_record_declaration] = STATE(2460),
    [sym_record_struct_declaration] = STATE(2460),
    [sym_namespace_declaration] = STATE(2460),
    [sym__type] = STATE(4571),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4646),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1656),
    [aux_sym_event_field_declaration_repeat1] = STATE(1857),
    [aux_sym_event_field_declaration_repeat2] = STATE(1948),
    [aux_sym_declaration_list_repeat1] = STATE(1650),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2671),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_event] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(29),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(2679),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(29),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2717),
    [anon_sym_implicit] = ACTIONS(2683),
    [anon_sym_explicit] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_interface] = ACTIONS(2693),
    [anon_sym_delegate] = ACTIONS(2695),
    [anon_sym_record] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2699),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(2703),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1657] = {
    [sym__declaration] = STATE(2459),
    [sym_using_directive] = STATE(2460),
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_event_field_declaration] = STATE(2460),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6936),
    [sym_field_declaration] = STATE(2460),
    [sym_constructor_declaration] = STATE(2460),
    [sym_conversion_operator_declaration] = STATE(2460),
    [sym_destructor_declaration] = STATE(2460),
    [sym_method_declaration] = STATE(2460),
    [sym_operator_declaration] = STATE(2460),
    [sym_event_declaration] = STATE(2460),
    [sym_indexer_declaration] = STATE(2460),
    [sym_property_declaration] = STATE(2460),
    [sym_enum_declaration] = STATE(2460),
    [sym_class_declaration] = STATE(2460),
    [sym_interface_declaration] = STATE(2460),
    [sym_struct_declaration] = STATE(2460),
    [sym_delegate_declaration] = STATE(2460),
    [sym_record_declaration] = STATE(2460),
    [sym_record_struct_declaration] = STATE(2460),
    [sym_namespace_declaration] = STATE(2460),
    [sym__type] = STATE(4571),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4646),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1657),
    [aux_sym_event_field_declaration_repeat1] = STATE(1857),
    [aux_sym_event_field_declaration_repeat2] = STATE(1948),
    [aux_sym_declaration_list_repeat1] = STATE(1654),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(2665),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2669),
    [anon_sym_using] = ACTIONS(2671),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_event] = ACTIONS(2675),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(29),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(2679),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(29),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_RBRACE] = ACTIONS(2719),
    [anon_sym_implicit] = ACTIONS(2683),
    [anon_sym_explicit] = ACTIONS(2683),
    [anon_sym_TILDE] = ACTIONS(2685),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(2687),
    [anon_sym_struct] = ACTIONS(2689),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_enum] = ACTIONS(2691),
    [anon_sym_interface] = ACTIONS(2693),
    [anon_sym_delegate] = ACTIONS(2695),
    [anon_sym_record] = ACTIONS(2697),
    [anon_sym_namespace] = ACTIONS(2699),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(2703),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1658] = {
    [sym__preprocessor_call] = STATE(1658),
    [sym__identifier_token] = ACTIONS(2300),
    [anon_sym_extern] = ACTIONS(2300),
    [anon_sym_alias] = ACTIONS(2300),
    [anon_sym_SEMI] = ACTIONS(2298),
    [anon_sym_global] = ACTIONS(2300),
    [anon_sym_using] = ACTIONS(2300),
    [anon_sym_static] = ACTIONS(2300),
    [anon_sym_LBRACK] = ACTIONS(2298),
    [anon_sym_return] = ACTIONS(2300),
    [anon_sym_LPAREN] = ACTIONS(2298),
    [anon_sym_abstract] = ACTIONS(2300),
    [anon_sym_async] = ACTIONS(2300),
    [anon_sym_const] = ACTIONS(2300),
    [anon_sym_fixed] = ACTIONS(2300),
    [anon_sym_internal] = ACTIONS(2300),
    [anon_sym_new] = ACTIONS(2300),
    [anon_sym_override] = ACTIONS(2300),
    [anon_sym_partial] = ACTIONS(2300),
    [anon_sym_private] = ACTIONS(2300),
    [anon_sym_protected] = ACTIONS(2300),
    [anon_sym_public] = ACTIONS(2300),
    [anon_sym_readonly] = ACTIONS(2300),
    [anon_sym_ref] = ACTIONS(2300),
    [anon_sym_sealed] = ACTIONS(2300),
    [anon_sym_unsafe] = ACTIONS(2300),
    [anon_sym_virtual] = ACTIONS(2300),
    [anon_sym_volatile] = ACTIONS(2300),
    [anon_sym_this] = ACTIONS(2300),
    [anon_sym_base] = ACTIONS(2300),
    [anon_sym_LBRACE] = ACTIONS(2298),
    [anon_sym_RBRACE] = ACTIONS(2298),
    [anon_sym_TILDE] = ACTIONS(2298),
    [anon_sym_where] = ACTIONS(2300),
    [anon_sym_notnull] = ACTIONS(2300),
    [anon_sym_unmanaged] = ACTIONS(2300),
    [anon_sym_BANG] = ACTIONS(2298),
    [anon_sym_PLUS_PLUS] = ACTIONS(2298),
    [anon_sym_DASH_DASH] = ACTIONS(2298),
    [anon_sym_true] = ACTIONS(2300),
    [anon_sym_false] = ACTIONS(2300),
    [anon_sym_PLUS] = ACTIONS(2300),
    [anon_sym_DASH] = ACTIONS(2300),
    [anon_sym_STAR] = ACTIONS(2298),
    [anon_sym_CARET] = ACTIONS(2298),
    [anon_sym_AMP] = ACTIONS(2298),
    [anon_sym_get] = ACTIONS(2300),
    [anon_sym_set] = ACTIONS(2300),
    [anon_sym_add] = ACTIONS(2300),
    [anon_sym_remove] = ACTIONS(2300),
    [anon_sym_delegate] = ACTIONS(2300),
    [anon_sym_var] = ACTIONS(2300),
    [sym_predefined_type] = ACTIONS(2300),
    [anon_sym_break] = ACTIONS(2300),
    [anon_sym_checked] = ACTIONS(2300),
    [anon_sym_unchecked] = ACTIONS(2300),
    [anon_sym_continue] = ACTIONS(2300),
    [anon_sym_do] = ACTIONS(2300),
    [anon_sym_while] = ACTIONS(2300),
    [anon_sym_for] = ACTIONS(2300),
    [anon_sym_await] = ACTIONS(2300),
    [anon_sym_foreach] = ACTIONS(2300),
    [anon_sym_goto] = ACTIONS(2300),
    [anon_sym_case] = ACTIONS(2300),
    [anon_sym_default] = ACTIONS(2300),
    [anon_sym_if] = ACTIONS(2300),
    [anon_sym_else] = ACTIONS(2300),
    [anon_sym_lock] = ACTIONS(2300),
    [anon_sym_switch] = ACTIONS(2300),
    [anon_sym_when] = ACTIONS(2300),
    [anon_sym_throw] = ACTIONS(2300),
    [anon_sym_try] = ACTIONS(2300),
    [anon_sym_yield] = ACTIONS(2300),
    [anon_sym_stackalloc] = ACTIONS(2300),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2298),
    [anon_sym_DQUOTE] = ACTIONS(2298),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2298),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2298),
    [anon_sym___makeref] = ACTIONS(2300),
    [anon_sym_from] = ACTIONS(2300),
    [anon_sym_join] = ACTIONS(2300),
    [anon_sym_on] = ACTIONS(2300),
    [anon_sym_equals] = ACTIONS(2300),
    [anon_sym_into] = ACTIONS(2300),
    [anon_sym_let] = ACTIONS(2300),
    [anon_sym_orderby] = ACTIONS(2300),
    [anon_sym_ascending] = ACTIONS(2300),
    [anon_sym_descending] = ACTIONS(2300),
    [anon_sym_group] = ACTIONS(2300),
    [anon_sym_by] = ACTIONS(2300),
    [anon_sym_select] = ACTIONS(2300),
    [anon_sym_DOT_DOT] = ACTIONS(2298),
    [anon_sym___reftype] = ACTIONS(2300),
    [anon_sym___refvalue] = ACTIONS(2300),
    [anon_sym_sizeof] = ACTIONS(2300),
    [anon_sym_typeof] = ACTIONS(2300),
    [anon_sym_SQUOTE] = ACTIONS(2298),
    [sym_integer_literal] = ACTIONS(2300),
    [sym_null_literal] = ACTIONS(2300),
    [sym_real_literal] = ACTIONS(2298),
    [sym_verbatim_string_literal] = ACTIONS(2298),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2300),
    [anon_sym_nameof] = ACTIONS(2300),
    [sym_void_keyword] = ACTIONS(2300),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1659] = {
    [sym__preprocessor_call] = STATE(1659),
    [sym__identifier_token] = ACTIONS(2438),
    [anon_sym_extern] = ACTIONS(2438),
    [anon_sym_alias] = ACTIONS(2438),
    [anon_sym_SEMI] = ACTIONS(2436),
    [anon_sym_global] = ACTIONS(2438),
    [anon_sym_using] = ACTIONS(2438),
    [anon_sym_static] = ACTIONS(2438),
    [anon_sym_LBRACK] = ACTIONS(2436),
    [anon_sym_return] = ACTIONS(2438),
    [anon_sym_LPAREN] = ACTIONS(2436),
    [anon_sym_abstract] = ACTIONS(2438),
    [anon_sym_async] = ACTIONS(2438),
    [anon_sym_const] = ACTIONS(2438),
    [anon_sym_fixed] = ACTIONS(2438),
    [anon_sym_internal] = ACTIONS(2438),
    [anon_sym_new] = ACTIONS(2438),
    [anon_sym_override] = ACTIONS(2438),
    [anon_sym_partial] = ACTIONS(2438),
    [anon_sym_private] = ACTIONS(2438),
    [anon_sym_protected] = ACTIONS(2438),
    [anon_sym_public] = ACTIONS(2438),
    [anon_sym_readonly] = ACTIONS(2438),
    [anon_sym_ref] = ACTIONS(2438),
    [anon_sym_sealed] = ACTIONS(2438),
    [anon_sym_unsafe] = ACTIONS(2438),
    [anon_sym_virtual] = ACTIONS(2438),
    [anon_sym_volatile] = ACTIONS(2438),
    [anon_sym_this] = ACTIONS(2438),
    [anon_sym_base] = ACTIONS(2438),
    [anon_sym_LBRACE] = ACTIONS(2436),
    [anon_sym_RBRACE] = ACTIONS(2436),
    [anon_sym_TILDE] = ACTIONS(2436),
    [anon_sym_where] = ACTIONS(2438),
    [anon_sym_notnull] = ACTIONS(2438),
    [anon_sym_unmanaged] = ACTIONS(2438),
    [anon_sym_BANG] = ACTIONS(2436),
    [anon_sym_PLUS_PLUS] = ACTIONS(2436),
    [anon_sym_DASH_DASH] = ACTIONS(2436),
    [anon_sym_true] = ACTIONS(2438),
    [anon_sym_false] = ACTIONS(2438),
    [anon_sym_PLUS] = ACTIONS(2438),
    [anon_sym_DASH] = ACTIONS(2438),
    [anon_sym_STAR] = ACTIONS(2436),
    [anon_sym_CARET] = ACTIONS(2436),
    [anon_sym_AMP] = ACTIONS(2436),
    [anon_sym_get] = ACTIONS(2438),
    [anon_sym_set] = ACTIONS(2438),
    [anon_sym_add] = ACTIONS(2438),
    [anon_sym_remove] = ACTIONS(2438),
    [anon_sym_delegate] = ACTIONS(2438),
    [anon_sym_var] = ACTIONS(2438),
    [sym_predefined_type] = ACTIONS(2438),
    [anon_sym_break] = ACTIONS(2438),
    [anon_sym_checked] = ACTIONS(2438),
    [anon_sym_unchecked] = ACTIONS(2438),
    [anon_sym_continue] = ACTIONS(2438),
    [anon_sym_do] = ACTIONS(2438),
    [anon_sym_while] = ACTIONS(2438),
    [anon_sym_for] = ACTIONS(2438),
    [anon_sym_await] = ACTIONS(2438),
    [anon_sym_foreach] = ACTIONS(2438),
    [anon_sym_goto] = ACTIONS(2438),
    [anon_sym_case] = ACTIONS(2438),
    [anon_sym_default] = ACTIONS(2438),
    [anon_sym_if] = ACTIONS(2438),
    [anon_sym_else] = ACTIONS(2438),
    [anon_sym_lock] = ACTIONS(2438),
    [anon_sym_switch] = ACTIONS(2438),
    [anon_sym_when] = ACTIONS(2438),
    [anon_sym_throw] = ACTIONS(2438),
    [anon_sym_try] = ACTIONS(2438),
    [anon_sym_yield] = ACTIONS(2438),
    [anon_sym_stackalloc] = ACTIONS(2438),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2436),
    [anon_sym_DQUOTE] = ACTIONS(2436),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2436),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2436),
    [anon_sym___makeref] = ACTIONS(2438),
    [anon_sym_from] = ACTIONS(2438),
    [anon_sym_join] = ACTIONS(2438),
    [anon_sym_on] = ACTIONS(2438),
    [anon_sym_equals] = ACTIONS(2438),
    [anon_sym_into] = ACTIONS(2438),
    [anon_sym_let] = ACTIONS(2438),
    [anon_sym_orderby] = ACTIONS(2438),
    [anon_sym_ascending] = ACTIONS(2438),
    [anon_sym_descending] = ACTIONS(2438),
    [anon_sym_group] = ACTIONS(2438),
    [anon_sym_by] = ACTIONS(2438),
    [anon_sym_select] = ACTIONS(2438),
    [anon_sym_DOT_DOT] = ACTIONS(2436),
    [anon_sym___reftype] = ACTIONS(2438),
    [anon_sym___refvalue] = ACTIONS(2438),
    [anon_sym_sizeof] = ACTIONS(2438),
    [anon_sym_typeof] = ACTIONS(2438),
    [anon_sym_SQUOTE] = ACTIONS(2436),
    [sym_integer_literal] = ACTIONS(2438),
    [sym_null_literal] = ACTIONS(2438),
    [sym_real_literal] = ACTIONS(2436),
    [sym_verbatim_string_literal] = ACTIONS(2436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2438),
    [anon_sym_nameof] = ACTIONS(2438),
    [sym_void_keyword] = ACTIONS(2438),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1660] = {
    [sym__preprocessor_call] = STATE(1660),
    [sym__identifier_token] = ACTIONS(2336),
    [anon_sym_extern] = ACTIONS(2336),
    [anon_sym_alias] = ACTIONS(2336),
    [anon_sym_SEMI] = ACTIONS(2334),
    [anon_sym_global] = ACTIONS(2336),
    [anon_sym_using] = ACTIONS(2336),
    [anon_sym_static] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_return] = ACTIONS(2336),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_abstract] = ACTIONS(2336),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_const] = ACTIONS(2336),
    [anon_sym_fixed] = ACTIONS(2336),
    [anon_sym_internal] = ACTIONS(2336),
    [anon_sym_new] = ACTIONS(2336),
    [anon_sym_override] = ACTIONS(2336),
    [anon_sym_partial] = ACTIONS(2336),
    [anon_sym_private] = ACTIONS(2336),
    [anon_sym_protected] = ACTIONS(2336),
    [anon_sym_public] = ACTIONS(2336),
    [anon_sym_readonly] = ACTIONS(2336),
    [anon_sym_ref] = ACTIONS(2336),
    [anon_sym_sealed] = ACTIONS(2336),
    [anon_sym_unsafe] = ACTIONS(2336),
    [anon_sym_virtual] = ACTIONS(2336),
    [anon_sym_volatile] = ACTIONS(2336),
    [anon_sym_this] = ACTIONS(2336),
    [anon_sym_base] = ACTIONS(2336),
    [anon_sym_LBRACE] = ACTIONS(2334),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_where] = ACTIONS(2336),
    [anon_sym_notnull] = ACTIONS(2336),
    [anon_sym_unmanaged] = ACTIONS(2336),
    [anon_sym_BANG] = ACTIONS(2334),
    [anon_sym_PLUS_PLUS] = ACTIONS(2334),
    [anon_sym_DASH_DASH] = ACTIONS(2334),
    [anon_sym_true] = ACTIONS(2336),
    [anon_sym_false] = ACTIONS(2336),
    [anon_sym_PLUS] = ACTIONS(2336),
    [anon_sym_DASH] = ACTIONS(2336),
    [anon_sym_STAR] = ACTIONS(2334),
    [anon_sym_CARET] = ACTIONS(2334),
    [anon_sym_AMP] = ACTIONS(2334),
    [anon_sym_get] = ACTIONS(2336),
    [anon_sym_set] = ACTIONS(2336),
    [anon_sym_add] = ACTIONS(2336),
    [anon_sym_remove] = ACTIONS(2336),
    [anon_sym_delegate] = ACTIONS(2336),
    [anon_sym_var] = ACTIONS(2336),
    [sym_predefined_type] = ACTIONS(2336),
    [anon_sym_break] = ACTIONS(2336),
    [anon_sym_checked] = ACTIONS(2336),
    [anon_sym_unchecked] = ACTIONS(2336),
    [anon_sym_continue] = ACTIONS(2336),
    [anon_sym_do] = ACTIONS(2336),
    [anon_sym_while] = ACTIONS(2336),
    [anon_sym_for] = ACTIONS(2336),
    [anon_sym_await] = ACTIONS(2336),
    [anon_sym_foreach] = ACTIONS(2336),
    [anon_sym_goto] = ACTIONS(2336),
    [anon_sym_case] = ACTIONS(2336),
    [anon_sym_default] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(2336),
    [anon_sym_else] = ACTIONS(2336),
    [anon_sym_lock] = ACTIONS(2336),
    [anon_sym_switch] = ACTIONS(2336),
    [anon_sym_when] = ACTIONS(2336),
    [anon_sym_throw] = ACTIONS(2336),
    [anon_sym_try] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_stackalloc] = ACTIONS(2336),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2334),
    [anon_sym_DQUOTE] = ACTIONS(2334),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2334),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2334),
    [anon_sym___makeref] = ACTIONS(2336),
    [anon_sym_from] = ACTIONS(2336),
    [anon_sym_join] = ACTIONS(2336),
    [anon_sym_on] = ACTIONS(2336),
    [anon_sym_equals] = ACTIONS(2336),
    [anon_sym_into] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(2336),
    [anon_sym_orderby] = ACTIONS(2336),
    [anon_sym_ascending] = ACTIONS(2336),
    [anon_sym_descending] = ACTIONS(2336),
    [anon_sym_group] = ACTIONS(2336),
    [anon_sym_by] = ACTIONS(2336),
    [anon_sym_select] = ACTIONS(2336),
    [anon_sym_DOT_DOT] = ACTIONS(2334),
    [anon_sym___reftype] = ACTIONS(2336),
    [anon_sym___refvalue] = ACTIONS(2336),
    [anon_sym_sizeof] = ACTIONS(2336),
    [anon_sym_typeof] = ACTIONS(2336),
    [anon_sym_SQUOTE] = ACTIONS(2334),
    [sym_integer_literal] = ACTIONS(2336),
    [sym_null_literal] = ACTIONS(2336),
    [sym_real_literal] = ACTIONS(2334),
    [sym_verbatim_string_literal] = ACTIONS(2334),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2336),
    [anon_sym_nameof] = ACTIONS(2336),
    [sym_void_keyword] = ACTIONS(2336),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1661] = {
    [sym__preprocessor_call] = STATE(1661),
    [sym__identifier_token] = ACTIONS(2344),
    [anon_sym_extern] = ACTIONS(2344),
    [anon_sym_alias] = ACTIONS(2344),
    [anon_sym_SEMI] = ACTIONS(2342),
    [anon_sym_global] = ACTIONS(2344),
    [anon_sym_using] = ACTIONS(2344),
    [anon_sym_static] = ACTIONS(2344),
    [anon_sym_LBRACK] = ACTIONS(2342),
    [anon_sym_return] = ACTIONS(2344),
    [anon_sym_LPAREN] = ACTIONS(2342),
    [anon_sym_abstract] = ACTIONS(2344),
    [anon_sym_async] = ACTIONS(2344),
    [anon_sym_const] = ACTIONS(2344),
    [anon_sym_fixed] = ACTIONS(2344),
    [anon_sym_internal] = ACTIONS(2344),
    [anon_sym_new] = ACTIONS(2344),
    [anon_sym_override] = ACTIONS(2344),
    [anon_sym_partial] = ACTIONS(2344),
    [anon_sym_private] = ACTIONS(2344),
    [anon_sym_protected] = ACTIONS(2344),
    [anon_sym_public] = ACTIONS(2344),
    [anon_sym_readonly] = ACTIONS(2344),
    [anon_sym_ref] = ACTIONS(2344),
    [anon_sym_sealed] = ACTIONS(2344),
    [anon_sym_unsafe] = ACTIONS(2344),
    [anon_sym_virtual] = ACTIONS(2344),
    [anon_sym_volatile] = ACTIONS(2344),
    [anon_sym_this] = ACTIONS(2344),
    [anon_sym_base] = ACTIONS(2344),
    [anon_sym_LBRACE] = ACTIONS(2342),
    [anon_sym_RBRACE] = ACTIONS(2342),
    [anon_sym_TILDE] = ACTIONS(2342),
    [anon_sym_where] = ACTIONS(2344),
    [anon_sym_notnull] = ACTIONS(2344),
    [anon_sym_unmanaged] = ACTIONS(2344),
    [anon_sym_BANG] = ACTIONS(2342),
    [anon_sym_PLUS_PLUS] = ACTIONS(2342),
    [anon_sym_DASH_DASH] = ACTIONS(2342),
    [anon_sym_true] = ACTIONS(2344),
    [anon_sym_false] = ACTIONS(2344),
    [anon_sym_PLUS] = ACTIONS(2344),
    [anon_sym_DASH] = ACTIONS(2344),
    [anon_sym_STAR] = ACTIONS(2342),
    [anon_sym_CARET] = ACTIONS(2342),
    [anon_sym_AMP] = ACTIONS(2342),
    [anon_sym_get] = ACTIONS(2344),
    [anon_sym_set] = ACTIONS(2344),
    [anon_sym_add] = ACTIONS(2344),
    [anon_sym_remove] = ACTIONS(2344),
    [anon_sym_delegate] = ACTIONS(2344),
    [anon_sym_var] = ACTIONS(2344),
    [sym_predefined_type] = ACTIONS(2344),
    [anon_sym_break] = ACTIONS(2344),
    [anon_sym_checked] = ACTIONS(2344),
    [anon_sym_unchecked] = ACTIONS(2344),
    [anon_sym_continue] = ACTIONS(2344),
    [anon_sym_do] = ACTIONS(2344),
    [anon_sym_while] = ACTIONS(2344),
    [anon_sym_for] = ACTIONS(2344),
    [anon_sym_await] = ACTIONS(2344),
    [anon_sym_foreach] = ACTIONS(2344),
    [anon_sym_goto] = ACTIONS(2344),
    [anon_sym_case] = ACTIONS(2344),
    [anon_sym_default] = ACTIONS(2344),
    [anon_sym_if] = ACTIONS(2344),
    [anon_sym_else] = ACTIONS(2344),
    [anon_sym_lock] = ACTIONS(2344),
    [anon_sym_switch] = ACTIONS(2344),
    [anon_sym_when] = ACTIONS(2344),
    [anon_sym_throw] = ACTIONS(2344),
    [anon_sym_try] = ACTIONS(2344),
    [anon_sym_yield] = ACTIONS(2344),
    [anon_sym_stackalloc] = ACTIONS(2344),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2342),
    [anon_sym_DQUOTE] = ACTIONS(2342),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2342),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2342),
    [anon_sym___makeref] = ACTIONS(2344),
    [anon_sym_from] = ACTIONS(2344),
    [anon_sym_join] = ACTIONS(2344),
    [anon_sym_on] = ACTIONS(2344),
    [anon_sym_equals] = ACTIONS(2344),
    [anon_sym_into] = ACTIONS(2344),
    [anon_sym_let] = ACTIONS(2344),
    [anon_sym_orderby] = ACTIONS(2344),
    [anon_sym_ascending] = ACTIONS(2344),
    [anon_sym_descending] = ACTIONS(2344),
    [anon_sym_group] = ACTIONS(2344),
    [anon_sym_by] = ACTIONS(2344),
    [anon_sym_select] = ACTIONS(2344),
    [anon_sym_DOT_DOT] = ACTIONS(2342),
    [anon_sym___reftype] = ACTIONS(2344),
    [anon_sym___refvalue] = ACTIONS(2344),
    [anon_sym_sizeof] = ACTIONS(2344),
    [anon_sym_typeof] = ACTIONS(2344),
    [anon_sym_SQUOTE] = ACTIONS(2342),
    [sym_integer_literal] = ACTIONS(2344),
    [sym_null_literal] = ACTIONS(2344),
    [sym_real_literal] = ACTIONS(2342),
    [sym_verbatim_string_literal] = ACTIONS(2342),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2344),
    [anon_sym_nameof] = ACTIONS(2344),
    [sym_void_keyword] = ACTIONS(2344),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1662] = {
    [sym__preprocessor_call] = STATE(1662),
    [sym__identifier_token] = ACTIONS(2470),
    [anon_sym_extern] = ACTIONS(2470),
    [anon_sym_alias] = ACTIONS(2470),
    [anon_sym_SEMI] = ACTIONS(2468),
    [anon_sym_global] = ACTIONS(2470),
    [anon_sym_using] = ACTIONS(2470),
    [anon_sym_static] = ACTIONS(2470),
    [anon_sym_LBRACK] = ACTIONS(2468),
    [anon_sym_return] = ACTIONS(2470),
    [anon_sym_LPAREN] = ACTIONS(2468),
    [anon_sym_abstract] = ACTIONS(2470),
    [anon_sym_async] = ACTIONS(2470),
    [anon_sym_const] = ACTIONS(2470),
    [anon_sym_fixed] = ACTIONS(2470),
    [anon_sym_internal] = ACTIONS(2470),
    [anon_sym_new] = ACTIONS(2470),
    [anon_sym_override] = ACTIONS(2470),
    [anon_sym_partial] = ACTIONS(2470),
    [anon_sym_private] = ACTIONS(2470),
    [anon_sym_protected] = ACTIONS(2470),
    [anon_sym_public] = ACTIONS(2470),
    [anon_sym_readonly] = ACTIONS(2470),
    [anon_sym_ref] = ACTIONS(2470),
    [anon_sym_sealed] = ACTIONS(2470),
    [anon_sym_unsafe] = ACTIONS(2470),
    [anon_sym_virtual] = ACTIONS(2470),
    [anon_sym_volatile] = ACTIONS(2470),
    [anon_sym_this] = ACTIONS(2470),
    [anon_sym_base] = ACTIONS(2470),
    [anon_sym_LBRACE] = ACTIONS(2468),
    [anon_sym_RBRACE] = ACTIONS(2468),
    [anon_sym_TILDE] = ACTIONS(2468),
    [anon_sym_where] = ACTIONS(2470),
    [anon_sym_notnull] = ACTIONS(2470),
    [anon_sym_unmanaged] = ACTIONS(2470),
    [anon_sym_BANG] = ACTIONS(2468),
    [anon_sym_PLUS_PLUS] = ACTIONS(2468),
    [anon_sym_DASH_DASH] = ACTIONS(2468),
    [anon_sym_true] = ACTIONS(2470),
    [anon_sym_false] = ACTIONS(2470),
    [anon_sym_PLUS] = ACTIONS(2470),
    [anon_sym_DASH] = ACTIONS(2470),
    [anon_sym_STAR] = ACTIONS(2468),
    [anon_sym_CARET] = ACTIONS(2468),
    [anon_sym_AMP] = ACTIONS(2468),
    [anon_sym_get] = ACTIONS(2470),
    [anon_sym_set] = ACTIONS(2470),
    [anon_sym_add] = ACTIONS(2470),
    [anon_sym_remove] = ACTIONS(2470),
    [anon_sym_delegate] = ACTIONS(2470),
    [anon_sym_var] = ACTIONS(2470),
    [sym_predefined_type] = ACTIONS(2470),
    [anon_sym_break] = ACTIONS(2470),
    [anon_sym_checked] = ACTIONS(2470),
    [anon_sym_unchecked] = ACTIONS(2470),
    [anon_sym_continue] = ACTIONS(2470),
    [anon_sym_do] = ACTIONS(2470),
    [anon_sym_while] = ACTIONS(2470),
    [anon_sym_for] = ACTIONS(2470),
    [anon_sym_await] = ACTIONS(2470),
    [anon_sym_foreach] = ACTIONS(2470),
    [anon_sym_goto] = ACTIONS(2470),
    [anon_sym_case] = ACTIONS(2470),
    [anon_sym_default] = ACTIONS(2470),
    [anon_sym_if] = ACTIONS(2470),
    [anon_sym_else] = ACTIONS(2470),
    [anon_sym_lock] = ACTIONS(2470),
    [anon_sym_switch] = ACTIONS(2470),
    [anon_sym_when] = ACTIONS(2470),
    [anon_sym_throw] = ACTIONS(2470),
    [anon_sym_try] = ACTIONS(2470),
    [anon_sym_yield] = ACTIONS(2470),
    [anon_sym_stackalloc] = ACTIONS(2470),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2468),
    [anon_sym_DQUOTE] = ACTIONS(2468),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2468),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2468),
    [anon_sym___makeref] = ACTIONS(2470),
    [anon_sym_from] = ACTIONS(2470),
    [anon_sym_join] = ACTIONS(2470),
    [anon_sym_on] = ACTIONS(2470),
    [anon_sym_equals] = ACTIONS(2470),
    [anon_sym_into] = ACTIONS(2470),
    [anon_sym_let] = ACTIONS(2470),
    [anon_sym_orderby] = ACTIONS(2470),
    [anon_sym_ascending] = ACTIONS(2470),
    [anon_sym_descending] = ACTIONS(2470),
    [anon_sym_group] = ACTIONS(2470),
    [anon_sym_by] = ACTIONS(2470),
    [anon_sym_select] = ACTIONS(2470),
    [anon_sym_DOT_DOT] = ACTIONS(2468),
    [anon_sym___reftype] = ACTIONS(2470),
    [anon_sym___refvalue] = ACTIONS(2470),
    [anon_sym_sizeof] = ACTIONS(2470),
    [anon_sym_typeof] = ACTIONS(2470),
    [anon_sym_SQUOTE] = ACTIONS(2468),
    [sym_integer_literal] = ACTIONS(2470),
    [sym_null_literal] = ACTIONS(2470),
    [sym_real_literal] = ACTIONS(2468),
    [sym_verbatim_string_literal] = ACTIONS(2468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2470),
    [anon_sym_nameof] = ACTIONS(2470),
    [sym_void_keyword] = ACTIONS(2470),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1663] = {
    [sym__preprocessor_call] = STATE(1663),
    [sym__identifier_token] = ACTIONS(2498),
    [anon_sym_extern] = ACTIONS(2498),
    [anon_sym_alias] = ACTIONS(2498),
    [anon_sym_SEMI] = ACTIONS(2496),
    [anon_sym_global] = ACTIONS(2498),
    [anon_sym_using] = ACTIONS(2498),
    [anon_sym_static] = ACTIONS(2498),
    [anon_sym_LBRACK] = ACTIONS(2496),
    [anon_sym_return] = ACTIONS(2498),
    [anon_sym_LPAREN] = ACTIONS(2496),
    [anon_sym_abstract] = ACTIONS(2498),
    [anon_sym_async] = ACTIONS(2498),
    [anon_sym_const] = ACTIONS(2498),
    [anon_sym_fixed] = ACTIONS(2498),
    [anon_sym_internal] = ACTIONS(2498),
    [anon_sym_new] = ACTIONS(2498),
    [anon_sym_override] = ACTIONS(2498),
    [anon_sym_partial] = ACTIONS(2498),
    [anon_sym_private] = ACTIONS(2498),
    [anon_sym_protected] = ACTIONS(2498),
    [anon_sym_public] = ACTIONS(2498),
    [anon_sym_readonly] = ACTIONS(2498),
    [anon_sym_ref] = ACTIONS(2498),
    [anon_sym_sealed] = ACTIONS(2498),
    [anon_sym_unsafe] = ACTIONS(2498),
    [anon_sym_virtual] = ACTIONS(2498),
    [anon_sym_volatile] = ACTIONS(2498),
    [anon_sym_this] = ACTIONS(2498),
    [anon_sym_base] = ACTIONS(2498),
    [anon_sym_LBRACE] = ACTIONS(2496),
    [anon_sym_RBRACE] = ACTIONS(2496),
    [anon_sym_TILDE] = ACTIONS(2496),
    [anon_sym_where] = ACTIONS(2498),
    [anon_sym_notnull] = ACTIONS(2498),
    [anon_sym_unmanaged] = ACTIONS(2498),
    [anon_sym_BANG] = ACTIONS(2496),
    [anon_sym_PLUS_PLUS] = ACTIONS(2496),
    [anon_sym_DASH_DASH] = ACTIONS(2496),
    [anon_sym_true] = ACTIONS(2498),
    [anon_sym_false] = ACTIONS(2498),
    [anon_sym_PLUS] = ACTIONS(2498),
    [anon_sym_DASH] = ACTIONS(2498),
    [anon_sym_STAR] = ACTIONS(2496),
    [anon_sym_CARET] = ACTIONS(2496),
    [anon_sym_AMP] = ACTIONS(2496),
    [anon_sym_get] = ACTIONS(2498),
    [anon_sym_set] = ACTIONS(2498),
    [anon_sym_add] = ACTIONS(2498),
    [anon_sym_remove] = ACTIONS(2498),
    [anon_sym_delegate] = ACTIONS(2498),
    [anon_sym_var] = ACTIONS(2498),
    [sym_predefined_type] = ACTIONS(2498),
    [anon_sym_break] = ACTIONS(2498),
    [anon_sym_checked] = ACTIONS(2498),
    [anon_sym_unchecked] = ACTIONS(2498),
    [anon_sym_continue] = ACTIONS(2498),
    [anon_sym_do] = ACTIONS(2498),
    [anon_sym_while] = ACTIONS(2498),
    [anon_sym_for] = ACTIONS(2498),
    [anon_sym_await] = ACTIONS(2498),
    [anon_sym_foreach] = ACTIONS(2498),
    [anon_sym_goto] = ACTIONS(2498),
    [anon_sym_case] = ACTIONS(2498),
    [anon_sym_default] = ACTIONS(2498),
    [anon_sym_if] = ACTIONS(2498),
    [anon_sym_else] = ACTIONS(2498),
    [anon_sym_lock] = ACTIONS(2498),
    [anon_sym_switch] = ACTIONS(2498),
    [anon_sym_when] = ACTIONS(2498),
    [anon_sym_throw] = ACTIONS(2498),
    [anon_sym_try] = ACTIONS(2498),
    [anon_sym_yield] = ACTIONS(2498),
    [anon_sym_stackalloc] = ACTIONS(2498),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2496),
    [anon_sym_DQUOTE] = ACTIONS(2496),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2496),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2496),
    [anon_sym___makeref] = ACTIONS(2498),
    [anon_sym_from] = ACTIONS(2498),
    [anon_sym_join] = ACTIONS(2498),
    [anon_sym_on] = ACTIONS(2498),
    [anon_sym_equals] = ACTIONS(2498),
    [anon_sym_into] = ACTIONS(2498),
    [anon_sym_let] = ACTIONS(2498),
    [anon_sym_orderby] = ACTIONS(2498),
    [anon_sym_ascending] = ACTIONS(2498),
    [anon_sym_descending] = ACTIONS(2498),
    [anon_sym_group] = ACTIONS(2498),
    [anon_sym_by] = ACTIONS(2498),
    [anon_sym_select] = ACTIONS(2498),
    [anon_sym_DOT_DOT] = ACTIONS(2496),
    [anon_sym___reftype] = ACTIONS(2498),
    [anon_sym___refvalue] = ACTIONS(2498),
    [anon_sym_sizeof] = ACTIONS(2498),
    [anon_sym_typeof] = ACTIONS(2498),
    [anon_sym_SQUOTE] = ACTIONS(2496),
    [sym_integer_literal] = ACTIONS(2498),
    [sym_null_literal] = ACTIONS(2498),
    [sym_real_literal] = ACTIONS(2496),
    [sym_verbatim_string_literal] = ACTIONS(2496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2498),
    [anon_sym_nameof] = ACTIONS(2498),
    [sym_void_keyword] = ACTIONS(2498),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1664] = {
    [sym__preprocessor_call] = STATE(1664),
    [sym__identifier_token] = ACTIONS(2348),
    [anon_sym_extern] = ACTIONS(2348),
    [anon_sym_alias] = ACTIONS(2348),
    [anon_sym_SEMI] = ACTIONS(2346),
    [anon_sym_global] = ACTIONS(2348),
    [anon_sym_using] = ACTIONS(2348),
    [anon_sym_static] = ACTIONS(2348),
    [anon_sym_LBRACK] = ACTIONS(2346),
    [anon_sym_return] = ACTIONS(2348),
    [anon_sym_LPAREN] = ACTIONS(2346),
    [anon_sym_abstract] = ACTIONS(2348),
    [anon_sym_async] = ACTIONS(2348),
    [anon_sym_const] = ACTIONS(2348),
    [anon_sym_fixed] = ACTIONS(2348),
    [anon_sym_internal] = ACTIONS(2348),
    [anon_sym_new] = ACTIONS(2348),
    [anon_sym_override] = ACTIONS(2348),
    [anon_sym_partial] = ACTIONS(2348),
    [anon_sym_private] = ACTIONS(2348),
    [anon_sym_protected] = ACTIONS(2348),
    [anon_sym_public] = ACTIONS(2348),
    [anon_sym_readonly] = ACTIONS(2348),
    [anon_sym_ref] = ACTIONS(2348),
    [anon_sym_sealed] = ACTIONS(2348),
    [anon_sym_unsafe] = ACTIONS(2348),
    [anon_sym_virtual] = ACTIONS(2348),
    [anon_sym_volatile] = ACTIONS(2348),
    [anon_sym_this] = ACTIONS(2348),
    [anon_sym_base] = ACTIONS(2348),
    [anon_sym_LBRACE] = ACTIONS(2346),
    [anon_sym_RBRACE] = ACTIONS(2346),
    [anon_sym_TILDE] = ACTIONS(2346),
    [anon_sym_where] = ACTIONS(2348),
    [anon_sym_notnull] = ACTIONS(2348),
    [anon_sym_unmanaged] = ACTIONS(2348),
    [anon_sym_BANG] = ACTIONS(2346),
    [anon_sym_PLUS_PLUS] = ACTIONS(2346),
    [anon_sym_DASH_DASH] = ACTIONS(2346),
    [anon_sym_true] = ACTIONS(2348),
    [anon_sym_false] = ACTIONS(2348),
    [anon_sym_PLUS] = ACTIONS(2348),
    [anon_sym_DASH] = ACTIONS(2348),
    [anon_sym_STAR] = ACTIONS(2346),
    [anon_sym_CARET] = ACTIONS(2346),
    [anon_sym_AMP] = ACTIONS(2346),
    [anon_sym_get] = ACTIONS(2348),
    [anon_sym_set] = ACTIONS(2348),
    [anon_sym_add] = ACTIONS(2348),
    [anon_sym_remove] = ACTIONS(2348),
    [anon_sym_delegate] = ACTIONS(2348),
    [anon_sym_var] = ACTIONS(2348),
    [sym_predefined_type] = ACTIONS(2348),
    [anon_sym_break] = ACTIONS(2348),
    [anon_sym_checked] = ACTIONS(2348),
    [anon_sym_unchecked] = ACTIONS(2348),
    [anon_sym_continue] = ACTIONS(2348),
    [anon_sym_do] = ACTIONS(2348),
    [anon_sym_while] = ACTIONS(2348),
    [anon_sym_for] = ACTIONS(2348),
    [anon_sym_await] = ACTIONS(2348),
    [anon_sym_foreach] = ACTIONS(2348),
    [anon_sym_goto] = ACTIONS(2348),
    [anon_sym_case] = ACTIONS(2348),
    [anon_sym_default] = ACTIONS(2348),
    [anon_sym_if] = ACTIONS(2348),
    [anon_sym_else] = ACTIONS(2348),
    [anon_sym_lock] = ACTIONS(2348),
    [anon_sym_switch] = ACTIONS(2348),
    [anon_sym_when] = ACTIONS(2348),
    [anon_sym_throw] = ACTIONS(2348),
    [anon_sym_try] = ACTIONS(2348),
    [anon_sym_yield] = ACTIONS(2348),
    [anon_sym_stackalloc] = ACTIONS(2348),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2346),
    [anon_sym_DQUOTE] = ACTIONS(2346),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2346),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2346),
    [anon_sym___makeref] = ACTIONS(2348),
    [anon_sym_from] = ACTIONS(2348),
    [anon_sym_join] = ACTIONS(2348),
    [anon_sym_on] = ACTIONS(2348),
    [anon_sym_equals] = ACTIONS(2348),
    [anon_sym_into] = ACTIONS(2348),
    [anon_sym_let] = ACTIONS(2348),
    [anon_sym_orderby] = ACTIONS(2348),
    [anon_sym_ascending] = ACTIONS(2348),
    [anon_sym_descending] = ACTIONS(2348),
    [anon_sym_group] = ACTIONS(2348),
    [anon_sym_by] = ACTIONS(2348),
    [anon_sym_select] = ACTIONS(2348),
    [anon_sym_DOT_DOT] = ACTIONS(2346),
    [anon_sym___reftype] = ACTIONS(2348),
    [anon_sym___refvalue] = ACTIONS(2348),
    [anon_sym_sizeof] = ACTIONS(2348),
    [anon_sym_typeof] = ACTIONS(2348),
    [anon_sym_SQUOTE] = ACTIONS(2346),
    [sym_integer_literal] = ACTIONS(2348),
    [sym_null_literal] = ACTIONS(2348),
    [sym_real_literal] = ACTIONS(2346),
    [sym_verbatim_string_literal] = ACTIONS(2346),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2348),
    [anon_sym_nameof] = ACTIONS(2348),
    [sym_void_keyword] = ACTIONS(2348),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1665] = {
    [sym__preprocessor_call] = STATE(1665),
    [sym__identifier_token] = ACTIONS(2197),
    [anon_sym_extern] = ACTIONS(2197),
    [anon_sym_alias] = ACTIONS(2197),
    [anon_sym_SEMI] = ACTIONS(2195),
    [anon_sym_global] = ACTIONS(2197),
    [anon_sym_using] = ACTIONS(2197),
    [anon_sym_static] = ACTIONS(2197),
    [anon_sym_LBRACK] = ACTIONS(2195),
    [anon_sym_return] = ACTIONS(2197),
    [anon_sym_LPAREN] = ACTIONS(2195),
    [anon_sym_abstract] = ACTIONS(2197),
    [anon_sym_async] = ACTIONS(2197),
    [anon_sym_const] = ACTIONS(2197),
    [anon_sym_fixed] = ACTIONS(2197),
    [anon_sym_internal] = ACTIONS(2197),
    [anon_sym_new] = ACTIONS(2197),
    [anon_sym_override] = ACTIONS(2197),
    [anon_sym_partial] = ACTIONS(2197),
    [anon_sym_private] = ACTIONS(2197),
    [anon_sym_protected] = ACTIONS(2197),
    [anon_sym_public] = ACTIONS(2197),
    [anon_sym_readonly] = ACTIONS(2197),
    [anon_sym_ref] = ACTIONS(2197),
    [anon_sym_sealed] = ACTIONS(2197),
    [anon_sym_unsafe] = ACTIONS(2197),
    [anon_sym_virtual] = ACTIONS(2197),
    [anon_sym_volatile] = ACTIONS(2197),
    [anon_sym_this] = ACTIONS(2197),
    [anon_sym_base] = ACTIONS(2197),
    [anon_sym_LBRACE] = ACTIONS(2195),
    [anon_sym_RBRACE] = ACTIONS(2195),
    [anon_sym_TILDE] = ACTIONS(2195),
    [anon_sym_where] = ACTIONS(2197),
    [anon_sym_notnull] = ACTIONS(2197),
    [anon_sym_unmanaged] = ACTIONS(2197),
    [anon_sym_BANG] = ACTIONS(2195),
    [anon_sym_PLUS_PLUS] = ACTIONS(2195),
    [anon_sym_DASH_DASH] = ACTIONS(2195),
    [anon_sym_true] = ACTIONS(2197),
    [anon_sym_false] = ACTIONS(2197),
    [anon_sym_PLUS] = ACTIONS(2197),
    [anon_sym_DASH] = ACTIONS(2197),
    [anon_sym_STAR] = ACTIONS(2195),
    [anon_sym_CARET] = ACTIONS(2195),
    [anon_sym_AMP] = ACTIONS(2195),
    [anon_sym_get] = ACTIONS(2197),
    [anon_sym_set] = ACTIONS(2197),
    [anon_sym_add] = ACTIONS(2197),
    [anon_sym_remove] = ACTIONS(2197),
    [anon_sym_delegate] = ACTIONS(2197),
    [anon_sym_var] = ACTIONS(2197),
    [sym_predefined_type] = ACTIONS(2197),
    [anon_sym_break] = ACTIONS(2197),
    [anon_sym_checked] = ACTIONS(2197),
    [anon_sym_unchecked] = ACTIONS(2197),
    [anon_sym_continue] = ACTIONS(2197),
    [anon_sym_do] = ACTIONS(2197),
    [anon_sym_while] = ACTIONS(2197),
    [anon_sym_for] = ACTIONS(2197),
    [anon_sym_await] = ACTIONS(2197),
    [anon_sym_foreach] = ACTIONS(2197),
    [anon_sym_goto] = ACTIONS(2197),
    [anon_sym_case] = ACTIONS(2197),
    [anon_sym_default] = ACTIONS(2197),
    [anon_sym_if] = ACTIONS(2197),
    [anon_sym_else] = ACTIONS(2197),
    [anon_sym_lock] = ACTIONS(2197),
    [anon_sym_switch] = ACTIONS(2197),
    [anon_sym_when] = ACTIONS(2197),
    [anon_sym_throw] = ACTIONS(2197),
    [anon_sym_try] = ACTIONS(2197),
    [anon_sym_yield] = ACTIONS(2197),
    [anon_sym_stackalloc] = ACTIONS(2197),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2195),
    [anon_sym_DQUOTE] = ACTIONS(2195),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2195),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2195),
    [anon_sym___makeref] = ACTIONS(2197),
    [anon_sym_from] = ACTIONS(2197),
    [anon_sym_join] = ACTIONS(2197),
    [anon_sym_on] = ACTIONS(2197),
    [anon_sym_equals] = ACTIONS(2197),
    [anon_sym_into] = ACTIONS(2197),
    [anon_sym_let] = ACTIONS(2197),
    [anon_sym_orderby] = ACTIONS(2197),
    [anon_sym_ascending] = ACTIONS(2197),
    [anon_sym_descending] = ACTIONS(2197),
    [anon_sym_group] = ACTIONS(2197),
    [anon_sym_by] = ACTIONS(2197),
    [anon_sym_select] = ACTIONS(2197),
    [anon_sym_DOT_DOT] = ACTIONS(2195),
    [anon_sym___reftype] = ACTIONS(2197),
    [anon_sym___refvalue] = ACTIONS(2197),
    [anon_sym_sizeof] = ACTIONS(2197),
    [anon_sym_typeof] = ACTIONS(2197),
    [anon_sym_SQUOTE] = ACTIONS(2195),
    [sym_integer_literal] = ACTIONS(2197),
    [sym_null_literal] = ACTIONS(2197),
    [sym_real_literal] = ACTIONS(2195),
    [sym_verbatim_string_literal] = ACTIONS(2195),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2197),
    [anon_sym_nameof] = ACTIONS(2197),
    [sym_void_keyword] = ACTIONS(2197),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1666] = {
    [sym__preprocessor_call] = STATE(1666),
    [sym__identifier_token] = ACTIONS(2502),
    [anon_sym_extern] = ACTIONS(2502),
    [anon_sym_alias] = ACTIONS(2502),
    [anon_sym_SEMI] = ACTIONS(2500),
    [anon_sym_global] = ACTIONS(2502),
    [anon_sym_using] = ACTIONS(2502),
    [anon_sym_static] = ACTIONS(2502),
    [anon_sym_LBRACK] = ACTIONS(2500),
    [anon_sym_return] = ACTIONS(2502),
    [anon_sym_LPAREN] = ACTIONS(2500),
    [anon_sym_abstract] = ACTIONS(2502),
    [anon_sym_async] = ACTIONS(2502),
    [anon_sym_const] = ACTIONS(2502),
    [anon_sym_fixed] = ACTIONS(2502),
    [anon_sym_internal] = ACTIONS(2502),
    [anon_sym_new] = ACTIONS(2502),
    [anon_sym_override] = ACTIONS(2502),
    [anon_sym_partial] = ACTIONS(2502),
    [anon_sym_private] = ACTIONS(2502),
    [anon_sym_protected] = ACTIONS(2502),
    [anon_sym_public] = ACTIONS(2502),
    [anon_sym_readonly] = ACTIONS(2502),
    [anon_sym_ref] = ACTIONS(2502),
    [anon_sym_sealed] = ACTIONS(2502),
    [anon_sym_unsafe] = ACTIONS(2502),
    [anon_sym_virtual] = ACTIONS(2502),
    [anon_sym_volatile] = ACTIONS(2502),
    [anon_sym_this] = ACTIONS(2502),
    [anon_sym_base] = ACTIONS(2502),
    [anon_sym_LBRACE] = ACTIONS(2500),
    [anon_sym_RBRACE] = ACTIONS(2500),
    [anon_sym_TILDE] = ACTIONS(2500),
    [anon_sym_where] = ACTIONS(2502),
    [anon_sym_notnull] = ACTIONS(2502),
    [anon_sym_unmanaged] = ACTIONS(2502),
    [anon_sym_BANG] = ACTIONS(2500),
    [anon_sym_PLUS_PLUS] = ACTIONS(2500),
    [anon_sym_DASH_DASH] = ACTIONS(2500),
    [anon_sym_true] = ACTIONS(2502),
    [anon_sym_false] = ACTIONS(2502),
    [anon_sym_PLUS] = ACTIONS(2502),
    [anon_sym_DASH] = ACTIONS(2502),
    [anon_sym_STAR] = ACTIONS(2500),
    [anon_sym_CARET] = ACTIONS(2500),
    [anon_sym_AMP] = ACTIONS(2500),
    [anon_sym_get] = ACTIONS(2502),
    [anon_sym_set] = ACTIONS(2502),
    [anon_sym_add] = ACTIONS(2502),
    [anon_sym_remove] = ACTIONS(2502),
    [anon_sym_delegate] = ACTIONS(2502),
    [anon_sym_var] = ACTIONS(2502),
    [sym_predefined_type] = ACTIONS(2502),
    [anon_sym_break] = ACTIONS(2502),
    [anon_sym_checked] = ACTIONS(2502),
    [anon_sym_unchecked] = ACTIONS(2502),
    [anon_sym_continue] = ACTIONS(2502),
    [anon_sym_do] = ACTIONS(2502),
    [anon_sym_while] = ACTIONS(2502),
    [anon_sym_for] = ACTIONS(2502),
    [anon_sym_await] = ACTIONS(2502),
    [anon_sym_foreach] = ACTIONS(2502),
    [anon_sym_goto] = ACTIONS(2502),
    [anon_sym_case] = ACTIONS(2502),
    [anon_sym_default] = ACTIONS(2502),
    [anon_sym_if] = ACTIONS(2502),
    [anon_sym_else] = ACTIONS(2502),
    [anon_sym_lock] = ACTIONS(2502),
    [anon_sym_switch] = ACTIONS(2502),
    [anon_sym_when] = ACTIONS(2502),
    [anon_sym_throw] = ACTIONS(2502),
    [anon_sym_try] = ACTIONS(2502),
    [anon_sym_yield] = ACTIONS(2502),
    [anon_sym_stackalloc] = ACTIONS(2502),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2500),
    [anon_sym_DQUOTE] = ACTIONS(2500),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2500),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2500),
    [anon_sym___makeref] = ACTIONS(2502),
    [anon_sym_from] = ACTIONS(2502),
    [anon_sym_join] = ACTIONS(2502),
    [anon_sym_on] = ACTIONS(2502),
    [anon_sym_equals] = ACTIONS(2502),
    [anon_sym_into] = ACTIONS(2502),
    [anon_sym_let] = ACTIONS(2502),
    [anon_sym_orderby] = ACTIONS(2502),
    [anon_sym_ascending] = ACTIONS(2502),
    [anon_sym_descending] = ACTIONS(2502),
    [anon_sym_group] = ACTIONS(2502),
    [anon_sym_by] = ACTIONS(2502),
    [anon_sym_select] = ACTIONS(2502),
    [anon_sym_DOT_DOT] = ACTIONS(2500),
    [anon_sym___reftype] = ACTIONS(2502),
    [anon_sym___refvalue] = ACTIONS(2502),
    [anon_sym_sizeof] = ACTIONS(2502),
    [anon_sym_typeof] = ACTIONS(2502),
    [anon_sym_SQUOTE] = ACTIONS(2500),
    [sym_integer_literal] = ACTIONS(2502),
    [sym_null_literal] = ACTIONS(2502),
    [sym_real_literal] = ACTIONS(2500),
    [sym_verbatim_string_literal] = ACTIONS(2500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2502),
    [anon_sym_nameof] = ACTIONS(2502),
    [sym_void_keyword] = ACTIONS(2502),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1667] = {
    [sym__preprocessor_call] = STATE(1667),
    [sym__identifier_token] = ACTIONS(2526),
    [anon_sym_extern] = ACTIONS(2526),
    [anon_sym_alias] = ACTIONS(2526),
    [anon_sym_SEMI] = ACTIONS(2524),
    [anon_sym_global] = ACTIONS(2526),
    [anon_sym_using] = ACTIONS(2526),
    [anon_sym_static] = ACTIONS(2526),
    [anon_sym_LBRACK] = ACTIONS(2524),
    [anon_sym_return] = ACTIONS(2526),
    [anon_sym_LPAREN] = ACTIONS(2524),
    [anon_sym_abstract] = ACTIONS(2526),
    [anon_sym_async] = ACTIONS(2526),
    [anon_sym_const] = ACTIONS(2526),
    [anon_sym_fixed] = ACTIONS(2526),
    [anon_sym_internal] = ACTIONS(2526),
    [anon_sym_new] = ACTIONS(2526),
    [anon_sym_override] = ACTIONS(2526),
    [anon_sym_partial] = ACTIONS(2526),
    [anon_sym_private] = ACTIONS(2526),
    [anon_sym_protected] = ACTIONS(2526),
    [anon_sym_public] = ACTIONS(2526),
    [anon_sym_readonly] = ACTIONS(2526),
    [anon_sym_ref] = ACTIONS(2526),
    [anon_sym_sealed] = ACTIONS(2526),
    [anon_sym_unsafe] = ACTIONS(2526),
    [anon_sym_virtual] = ACTIONS(2526),
    [anon_sym_volatile] = ACTIONS(2526),
    [anon_sym_this] = ACTIONS(2526),
    [anon_sym_base] = ACTIONS(2526),
    [anon_sym_LBRACE] = ACTIONS(2524),
    [anon_sym_RBRACE] = ACTIONS(2524),
    [anon_sym_TILDE] = ACTIONS(2524),
    [anon_sym_where] = ACTIONS(2526),
    [anon_sym_notnull] = ACTIONS(2526),
    [anon_sym_unmanaged] = ACTIONS(2526),
    [anon_sym_BANG] = ACTIONS(2524),
    [anon_sym_PLUS_PLUS] = ACTIONS(2524),
    [anon_sym_DASH_DASH] = ACTIONS(2524),
    [anon_sym_true] = ACTIONS(2526),
    [anon_sym_false] = ACTIONS(2526),
    [anon_sym_PLUS] = ACTIONS(2526),
    [anon_sym_DASH] = ACTIONS(2526),
    [anon_sym_STAR] = ACTIONS(2524),
    [anon_sym_CARET] = ACTIONS(2524),
    [anon_sym_AMP] = ACTIONS(2524),
    [anon_sym_get] = ACTIONS(2526),
    [anon_sym_set] = ACTIONS(2526),
    [anon_sym_add] = ACTIONS(2526),
    [anon_sym_remove] = ACTIONS(2526),
    [anon_sym_delegate] = ACTIONS(2526),
    [anon_sym_var] = ACTIONS(2526),
    [sym_predefined_type] = ACTIONS(2526),
    [anon_sym_break] = ACTIONS(2526),
    [anon_sym_checked] = ACTIONS(2526),
    [anon_sym_unchecked] = ACTIONS(2526),
    [anon_sym_continue] = ACTIONS(2526),
    [anon_sym_do] = ACTIONS(2526),
    [anon_sym_while] = ACTIONS(2526),
    [anon_sym_for] = ACTIONS(2526),
    [anon_sym_await] = ACTIONS(2526),
    [anon_sym_foreach] = ACTIONS(2526),
    [anon_sym_goto] = ACTIONS(2526),
    [anon_sym_case] = ACTIONS(2526),
    [anon_sym_default] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(2526),
    [anon_sym_else] = ACTIONS(2526),
    [anon_sym_lock] = ACTIONS(2526),
    [anon_sym_switch] = ACTIONS(2526),
    [anon_sym_when] = ACTIONS(2526),
    [anon_sym_throw] = ACTIONS(2526),
    [anon_sym_try] = ACTIONS(2526),
    [anon_sym_yield] = ACTIONS(2526),
    [anon_sym_stackalloc] = ACTIONS(2526),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2524),
    [anon_sym_DQUOTE] = ACTIONS(2524),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2524),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2524),
    [anon_sym___makeref] = ACTIONS(2526),
    [anon_sym_from] = ACTIONS(2526),
    [anon_sym_join] = ACTIONS(2526),
    [anon_sym_on] = ACTIONS(2526),
    [anon_sym_equals] = ACTIONS(2526),
    [anon_sym_into] = ACTIONS(2526),
    [anon_sym_let] = ACTIONS(2526),
    [anon_sym_orderby] = ACTIONS(2526),
    [anon_sym_ascending] = ACTIONS(2526),
    [anon_sym_descending] = ACTIONS(2526),
    [anon_sym_group] = ACTIONS(2526),
    [anon_sym_by] = ACTIONS(2526),
    [anon_sym_select] = ACTIONS(2526),
    [anon_sym_DOT_DOT] = ACTIONS(2524),
    [anon_sym___reftype] = ACTIONS(2526),
    [anon_sym___refvalue] = ACTIONS(2526),
    [anon_sym_sizeof] = ACTIONS(2526),
    [anon_sym_typeof] = ACTIONS(2526),
    [anon_sym_SQUOTE] = ACTIONS(2524),
    [sym_integer_literal] = ACTIONS(2526),
    [sym_null_literal] = ACTIONS(2526),
    [sym_real_literal] = ACTIONS(2524),
    [sym_verbatim_string_literal] = ACTIONS(2524),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2526),
    [anon_sym_nameof] = ACTIONS(2526),
    [sym_void_keyword] = ACTIONS(2526),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1668] = {
    [sym__preprocessor_call] = STATE(1668),
    [sym__identifier_token] = ACTIONS(2272),
    [anon_sym_extern] = ACTIONS(2272),
    [anon_sym_alias] = ACTIONS(2272),
    [anon_sym_SEMI] = ACTIONS(2270),
    [anon_sym_global] = ACTIONS(2272),
    [anon_sym_using] = ACTIONS(2272),
    [anon_sym_static] = ACTIONS(2272),
    [anon_sym_LBRACK] = ACTIONS(2270),
    [anon_sym_return] = ACTIONS(2272),
    [anon_sym_LPAREN] = ACTIONS(2270),
    [anon_sym_abstract] = ACTIONS(2272),
    [anon_sym_async] = ACTIONS(2272),
    [anon_sym_const] = ACTIONS(2272),
    [anon_sym_fixed] = ACTIONS(2272),
    [anon_sym_internal] = ACTIONS(2272),
    [anon_sym_new] = ACTIONS(2272),
    [anon_sym_override] = ACTIONS(2272),
    [anon_sym_partial] = ACTIONS(2272),
    [anon_sym_private] = ACTIONS(2272),
    [anon_sym_protected] = ACTIONS(2272),
    [anon_sym_public] = ACTIONS(2272),
    [anon_sym_readonly] = ACTIONS(2272),
    [anon_sym_ref] = ACTIONS(2272),
    [anon_sym_sealed] = ACTIONS(2272),
    [anon_sym_unsafe] = ACTIONS(2272),
    [anon_sym_virtual] = ACTIONS(2272),
    [anon_sym_volatile] = ACTIONS(2272),
    [anon_sym_this] = ACTIONS(2272),
    [anon_sym_base] = ACTIONS(2272),
    [anon_sym_LBRACE] = ACTIONS(2270),
    [anon_sym_RBRACE] = ACTIONS(2270),
    [anon_sym_TILDE] = ACTIONS(2270),
    [anon_sym_where] = ACTIONS(2272),
    [anon_sym_notnull] = ACTIONS(2272),
    [anon_sym_unmanaged] = ACTIONS(2272),
    [anon_sym_BANG] = ACTIONS(2270),
    [anon_sym_PLUS_PLUS] = ACTIONS(2270),
    [anon_sym_DASH_DASH] = ACTIONS(2270),
    [anon_sym_true] = ACTIONS(2272),
    [anon_sym_false] = ACTIONS(2272),
    [anon_sym_PLUS] = ACTIONS(2272),
    [anon_sym_DASH] = ACTIONS(2272),
    [anon_sym_STAR] = ACTIONS(2270),
    [anon_sym_CARET] = ACTIONS(2270),
    [anon_sym_AMP] = ACTIONS(2270),
    [anon_sym_get] = ACTIONS(2272),
    [anon_sym_set] = ACTIONS(2272),
    [anon_sym_add] = ACTIONS(2272),
    [anon_sym_remove] = ACTIONS(2272),
    [anon_sym_delegate] = ACTIONS(2272),
    [anon_sym_var] = ACTIONS(2272),
    [sym_predefined_type] = ACTIONS(2272),
    [anon_sym_break] = ACTIONS(2272),
    [anon_sym_checked] = ACTIONS(2272),
    [anon_sym_unchecked] = ACTIONS(2272),
    [anon_sym_continue] = ACTIONS(2272),
    [anon_sym_do] = ACTIONS(2272),
    [anon_sym_while] = ACTIONS(2272),
    [anon_sym_for] = ACTIONS(2272),
    [anon_sym_await] = ACTIONS(2272),
    [anon_sym_foreach] = ACTIONS(2272),
    [anon_sym_goto] = ACTIONS(2272),
    [anon_sym_case] = ACTIONS(2272),
    [anon_sym_default] = ACTIONS(2272),
    [anon_sym_if] = ACTIONS(2272),
    [anon_sym_else] = ACTIONS(2272),
    [anon_sym_lock] = ACTIONS(2272),
    [anon_sym_switch] = ACTIONS(2272),
    [anon_sym_when] = ACTIONS(2272),
    [anon_sym_throw] = ACTIONS(2272),
    [anon_sym_try] = ACTIONS(2272),
    [anon_sym_yield] = ACTIONS(2272),
    [anon_sym_stackalloc] = ACTIONS(2272),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2270),
    [anon_sym_DQUOTE] = ACTIONS(2270),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2270),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2270),
    [anon_sym___makeref] = ACTIONS(2272),
    [anon_sym_from] = ACTIONS(2272),
    [anon_sym_join] = ACTIONS(2272),
    [anon_sym_on] = ACTIONS(2272),
    [anon_sym_equals] = ACTIONS(2272),
    [anon_sym_into] = ACTIONS(2272),
    [anon_sym_let] = ACTIONS(2272),
    [anon_sym_orderby] = ACTIONS(2272),
    [anon_sym_ascending] = ACTIONS(2272),
    [anon_sym_descending] = ACTIONS(2272),
    [anon_sym_group] = ACTIONS(2272),
    [anon_sym_by] = ACTIONS(2272),
    [anon_sym_select] = ACTIONS(2272),
    [anon_sym_DOT_DOT] = ACTIONS(2270),
    [anon_sym___reftype] = ACTIONS(2272),
    [anon_sym___refvalue] = ACTIONS(2272),
    [anon_sym_sizeof] = ACTIONS(2272),
    [anon_sym_typeof] = ACTIONS(2272),
    [anon_sym_SQUOTE] = ACTIONS(2270),
    [sym_integer_literal] = ACTIONS(2272),
    [sym_null_literal] = ACTIONS(2272),
    [sym_real_literal] = ACTIONS(2270),
    [sym_verbatim_string_literal] = ACTIONS(2270),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2272),
    [anon_sym_nameof] = ACTIONS(2272),
    [sym_void_keyword] = ACTIONS(2272),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1669] = {
    [sym__preprocessor_call] = STATE(1669),
    [sym__identifier_token] = ACTIONS(2256),
    [anon_sym_extern] = ACTIONS(2256),
    [anon_sym_alias] = ACTIONS(2256),
    [anon_sym_SEMI] = ACTIONS(2254),
    [anon_sym_global] = ACTIONS(2256),
    [anon_sym_using] = ACTIONS(2256),
    [anon_sym_static] = ACTIONS(2256),
    [anon_sym_LBRACK] = ACTIONS(2254),
    [anon_sym_return] = ACTIONS(2256),
    [anon_sym_LPAREN] = ACTIONS(2254),
    [anon_sym_abstract] = ACTIONS(2256),
    [anon_sym_async] = ACTIONS(2256),
    [anon_sym_const] = ACTIONS(2256),
    [anon_sym_fixed] = ACTIONS(2256),
    [anon_sym_internal] = ACTIONS(2256),
    [anon_sym_new] = ACTIONS(2256),
    [anon_sym_override] = ACTIONS(2256),
    [anon_sym_partial] = ACTIONS(2256),
    [anon_sym_private] = ACTIONS(2256),
    [anon_sym_protected] = ACTIONS(2256),
    [anon_sym_public] = ACTIONS(2256),
    [anon_sym_readonly] = ACTIONS(2256),
    [anon_sym_ref] = ACTIONS(2256),
    [anon_sym_sealed] = ACTIONS(2256),
    [anon_sym_unsafe] = ACTIONS(2256),
    [anon_sym_virtual] = ACTIONS(2256),
    [anon_sym_volatile] = ACTIONS(2256),
    [anon_sym_this] = ACTIONS(2256),
    [anon_sym_base] = ACTIONS(2256),
    [anon_sym_LBRACE] = ACTIONS(2254),
    [anon_sym_RBRACE] = ACTIONS(2254),
    [anon_sym_TILDE] = ACTIONS(2254),
    [anon_sym_where] = ACTIONS(2256),
    [anon_sym_notnull] = ACTIONS(2256),
    [anon_sym_unmanaged] = ACTIONS(2256),
    [anon_sym_BANG] = ACTIONS(2254),
    [anon_sym_PLUS_PLUS] = ACTIONS(2254),
    [anon_sym_DASH_DASH] = ACTIONS(2254),
    [anon_sym_true] = ACTIONS(2256),
    [anon_sym_false] = ACTIONS(2256),
    [anon_sym_PLUS] = ACTIONS(2256),
    [anon_sym_DASH] = ACTIONS(2256),
    [anon_sym_STAR] = ACTIONS(2254),
    [anon_sym_CARET] = ACTIONS(2254),
    [anon_sym_AMP] = ACTIONS(2254),
    [anon_sym_get] = ACTIONS(2256),
    [anon_sym_set] = ACTIONS(2256),
    [anon_sym_add] = ACTIONS(2256),
    [anon_sym_remove] = ACTIONS(2256),
    [anon_sym_delegate] = ACTIONS(2256),
    [anon_sym_var] = ACTIONS(2256),
    [sym_predefined_type] = ACTIONS(2256),
    [anon_sym_break] = ACTIONS(2256),
    [anon_sym_checked] = ACTIONS(2256),
    [anon_sym_unchecked] = ACTIONS(2256),
    [anon_sym_continue] = ACTIONS(2256),
    [anon_sym_do] = ACTIONS(2256),
    [anon_sym_while] = ACTIONS(2256),
    [anon_sym_for] = ACTIONS(2256),
    [anon_sym_await] = ACTIONS(2256),
    [anon_sym_foreach] = ACTIONS(2256),
    [anon_sym_goto] = ACTIONS(2256),
    [anon_sym_case] = ACTIONS(2256),
    [anon_sym_default] = ACTIONS(2256),
    [anon_sym_if] = ACTIONS(2256),
    [anon_sym_else] = ACTIONS(2256),
    [anon_sym_lock] = ACTIONS(2256),
    [anon_sym_switch] = ACTIONS(2256),
    [anon_sym_when] = ACTIONS(2256),
    [anon_sym_throw] = ACTIONS(2256),
    [anon_sym_try] = ACTIONS(2256),
    [anon_sym_yield] = ACTIONS(2256),
    [anon_sym_stackalloc] = ACTIONS(2256),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2254),
    [anon_sym_DQUOTE] = ACTIONS(2254),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2254),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2254),
    [anon_sym___makeref] = ACTIONS(2256),
    [anon_sym_from] = ACTIONS(2256),
    [anon_sym_join] = ACTIONS(2256),
    [anon_sym_on] = ACTIONS(2256),
    [anon_sym_equals] = ACTIONS(2256),
    [anon_sym_into] = ACTIONS(2256),
    [anon_sym_let] = ACTIONS(2256),
    [anon_sym_orderby] = ACTIONS(2256),
    [anon_sym_ascending] = ACTIONS(2256),
    [anon_sym_descending] = ACTIONS(2256),
    [anon_sym_group] = ACTIONS(2256),
    [anon_sym_by] = ACTIONS(2256),
    [anon_sym_select] = ACTIONS(2256),
    [anon_sym_DOT_DOT] = ACTIONS(2254),
    [anon_sym___reftype] = ACTIONS(2256),
    [anon_sym___refvalue] = ACTIONS(2256),
    [anon_sym_sizeof] = ACTIONS(2256),
    [anon_sym_typeof] = ACTIONS(2256),
    [anon_sym_SQUOTE] = ACTIONS(2254),
    [sym_integer_literal] = ACTIONS(2256),
    [sym_null_literal] = ACTIONS(2256),
    [sym_real_literal] = ACTIONS(2254),
    [sym_verbatim_string_literal] = ACTIONS(2254),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2256),
    [anon_sym_nameof] = ACTIONS(2256),
    [sym_void_keyword] = ACTIONS(2256),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1670] = {
    [sym__preprocessor_call] = STATE(1670),
    [sym__identifier_token] = ACTIONS(2264),
    [anon_sym_extern] = ACTIONS(2264),
    [anon_sym_alias] = ACTIONS(2264),
    [anon_sym_SEMI] = ACTIONS(2262),
    [anon_sym_global] = ACTIONS(2264),
    [anon_sym_using] = ACTIONS(2264),
    [anon_sym_static] = ACTIONS(2264),
    [anon_sym_LBRACK] = ACTIONS(2262),
    [anon_sym_return] = ACTIONS(2264),
    [anon_sym_LPAREN] = ACTIONS(2262),
    [anon_sym_abstract] = ACTIONS(2264),
    [anon_sym_async] = ACTIONS(2264),
    [anon_sym_const] = ACTIONS(2264),
    [anon_sym_fixed] = ACTIONS(2264),
    [anon_sym_internal] = ACTIONS(2264),
    [anon_sym_new] = ACTIONS(2264),
    [anon_sym_override] = ACTIONS(2264),
    [anon_sym_partial] = ACTIONS(2264),
    [anon_sym_private] = ACTIONS(2264),
    [anon_sym_protected] = ACTIONS(2264),
    [anon_sym_public] = ACTIONS(2264),
    [anon_sym_readonly] = ACTIONS(2264),
    [anon_sym_ref] = ACTIONS(2264),
    [anon_sym_sealed] = ACTIONS(2264),
    [anon_sym_unsafe] = ACTIONS(2264),
    [anon_sym_virtual] = ACTIONS(2264),
    [anon_sym_volatile] = ACTIONS(2264),
    [anon_sym_this] = ACTIONS(2264),
    [anon_sym_base] = ACTIONS(2264),
    [anon_sym_LBRACE] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2262),
    [anon_sym_TILDE] = ACTIONS(2262),
    [anon_sym_where] = ACTIONS(2264),
    [anon_sym_notnull] = ACTIONS(2264),
    [anon_sym_unmanaged] = ACTIONS(2264),
    [anon_sym_BANG] = ACTIONS(2262),
    [anon_sym_PLUS_PLUS] = ACTIONS(2262),
    [anon_sym_DASH_DASH] = ACTIONS(2262),
    [anon_sym_true] = ACTIONS(2264),
    [anon_sym_false] = ACTIONS(2264),
    [anon_sym_PLUS] = ACTIONS(2264),
    [anon_sym_DASH] = ACTIONS(2264),
    [anon_sym_STAR] = ACTIONS(2262),
    [anon_sym_CARET] = ACTIONS(2262),
    [anon_sym_AMP] = ACTIONS(2262),
    [anon_sym_get] = ACTIONS(2264),
    [anon_sym_set] = ACTIONS(2264),
    [anon_sym_add] = ACTIONS(2264),
    [anon_sym_remove] = ACTIONS(2264),
    [anon_sym_delegate] = ACTIONS(2264),
    [anon_sym_var] = ACTIONS(2264),
    [sym_predefined_type] = ACTIONS(2264),
    [anon_sym_break] = ACTIONS(2264),
    [anon_sym_checked] = ACTIONS(2264),
    [anon_sym_unchecked] = ACTIONS(2264),
    [anon_sym_continue] = ACTIONS(2264),
    [anon_sym_do] = ACTIONS(2264),
    [anon_sym_while] = ACTIONS(2264),
    [anon_sym_for] = ACTIONS(2264),
    [anon_sym_await] = ACTIONS(2264),
    [anon_sym_foreach] = ACTIONS(2264),
    [anon_sym_goto] = ACTIONS(2264),
    [anon_sym_case] = ACTIONS(2264),
    [anon_sym_default] = ACTIONS(2264),
    [anon_sym_if] = ACTIONS(2264),
    [anon_sym_else] = ACTIONS(2264),
    [anon_sym_lock] = ACTIONS(2264),
    [anon_sym_switch] = ACTIONS(2264),
    [anon_sym_when] = ACTIONS(2264),
    [anon_sym_throw] = ACTIONS(2264),
    [anon_sym_try] = ACTIONS(2264),
    [anon_sym_yield] = ACTIONS(2264),
    [anon_sym_stackalloc] = ACTIONS(2264),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2262),
    [anon_sym_DQUOTE] = ACTIONS(2262),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2262),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2262),
    [anon_sym___makeref] = ACTIONS(2264),
    [anon_sym_from] = ACTIONS(2264),
    [anon_sym_join] = ACTIONS(2264),
    [anon_sym_on] = ACTIONS(2264),
    [anon_sym_equals] = ACTIONS(2264),
    [anon_sym_into] = ACTIONS(2264),
    [anon_sym_let] = ACTIONS(2264),
    [anon_sym_orderby] = ACTIONS(2264),
    [anon_sym_ascending] = ACTIONS(2264),
    [anon_sym_descending] = ACTIONS(2264),
    [anon_sym_group] = ACTIONS(2264),
    [anon_sym_by] = ACTIONS(2264),
    [anon_sym_select] = ACTIONS(2264),
    [anon_sym_DOT_DOT] = ACTIONS(2262),
    [anon_sym___reftype] = ACTIONS(2264),
    [anon_sym___refvalue] = ACTIONS(2264),
    [anon_sym_sizeof] = ACTIONS(2264),
    [anon_sym_typeof] = ACTIONS(2264),
    [anon_sym_SQUOTE] = ACTIONS(2262),
    [sym_integer_literal] = ACTIONS(2264),
    [sym_null_literal] = ACTIONS(2264),
    [sym_real_literal] = ACTIONS(2262),
    [sym_verbatim_string_literal] = ACTIONS(2262),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2264),
    [anon_sym_nameof] = ACTIONS(2264),
    [sym_void_keyword] = ACTIONS(2264),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1671] = {
    [sym__preprocessor_call] = STATE(1671),
    [sym__identifier_token] = ACTIONS(2442),
    [anon_sym_extern] = ACTIONS(2442),
    [anon_sym_alias] = ACTIONS(2442),
    [anon_sym_SEMI] = ACTIONS(2440),
    [anon_sym_global] = ACTIONS(2442),
    [anon_sym_using] = ACTIONS(2442),
    [anon_sym_static] = ACTIONS(2442),
    [anon_sym_LBRACK] = ACTIONS(2440),
    [anon_sym_return] = ACTIONS(2442),
    [anon_sym_LPAREN] = ACTIONS(2440),
    [anon_sym_abstract] = ACTIONS(2442),
    [anon_sym_async] = ACTIONS(2442),
    [anon_sym_const] = ACTIONS(2442),
    [anon_sym_fixed] = ACTIONS(2442),
    [anon_sym_internal] = ACTIONS(2442),
    [anon_sym_new] = ACTIONS(2442),
    [anon_sym_override] = ACTIONS(2442),
    [anon_sym_partial] = ACTIONS(2442),
    [anon_sym_private] = ACTIONS(2442),
    [anon_sym_protected] = ACTIONS(2442),
    [anon_sym_public] = ACTIONS(2442),
    [anon_sym_readonly] = ACTIONS(2442),
    [anon_sym_ref] = ACTIONS(2442),
    [anon_sym_sealed] = ACTIONS(2442),
    [anon_sym_unsafe] = ACTIONS(2442),
    [anon_sym_virtual] = ACTIONS(2442),
    [anon_sym_volatile] = ACTIONS(2442),
    [anon_sym_this] = ACTIONS(2442),
    [anon_sym_base] = ACTIONS(2442),
    [anon_sym_LBRACE] = ACTIONS(2440),
    [anon_sym_RBRACE] = ACTIONS(2440),
    [anon_sym_TILDE] = ACTIONS(2440),
    [anon_sym_where] = ACTIONS(2442),
    [anon_sym_notnull] = ACTIONS(2442),
    [anon_sym_unmanaged] = ACTIONS(2442),
    [anon_sym_BANG] = ACTIONS(2440),
    [anon_sym_PLUS_PLUS] = ACTIONS(2440),
    [anon_sym_DASH_DASH] = ACTIONS(2440),
    [anon_sym_true] = ACTIONS(2442),
    [anon_sym_false] = ACTIONS(2442),
    [anon_sym_PLUS] = ACTIONS(2442),
    [anon_sym_DASH] = ACTIONS(2442),
    [anon_sym_STAR] = ACTIONS(2440),
    [anon_sym_CARET] = ACTIONS(2440),
    [anon_sym_AMP] = ACTIONS(2440),
    [anon_sym_get] = ACTIONS(2442),
    [anon_sym_set] = ACTIONS(2442),
    [anon_sym_add] = ACTIONS(2442),
    [anon_sym_remove] = ACTIONS(2442),
    [anon_sym_delegate] = ACTIONS(2442),
    [anon_sym_var] = ACTIONS(2442),
    [sym_predefined_type] = ACTIONS(2442),
    [anon_sym_break] = ACTIONS(2442),
    [anon_sym_checked] = ACTIONS(2442),
    [anon_sym_unchecked] = ACTIONS(2442),
    [anon_sym_continue] = ACTIONS(2442),
    [anon_sym_do] = ACTIONS(2442),
    [anon_sym_while] = ACTIONS(2442),
    [anon_sym_for] = ACTIONS(2442),
    [anon_sym_await] = ACTIONS(2442),
    [anon_sym_foreach] = ACTIONS(2442),
    [anon_sym_goto] = ACTIONS(2442),
    [anon_sym_case] = ACTIONS(2442),
    [anon_sym_default] = ACTIONS(2442),
    [anon_sym_if] = ACTIONS(2442),
    [anon_sym_else] = ACTIONS(2442),
    [anon_sym_lock] = ACTIONS(2442),
    [anon_sym_switch] = ACTIONS(2442),
    [anon_sym_when] = ACTIONS(2442),
    [anon_sym_throw] = ACTIONS(2442),
    [anon_sym_try] = ACTIONS(2442),
    [anon_sym_yield] = ACTIONS(2442),
    [anon_sym_stackalloc] = ACTIONS(2442),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2440),
    [anon_sym_DQUOTE] = ACTIONS(2440),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2440),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2440),
    [anon_sym___makeref] = ACTIONS(2442),
    [anon_sym_from] = ACTIONS(2442),
    [anon_sym_join] = ACTIONS(2442),
    [anon_sym_on] = ACTIONS(2442),
    [anon_sym_equals] = ACTIONS(2442),
    [anon_sym_into] = ACTIONS(2442),
    [anon_sym_let] = ACTIONS(2442),
    [anon_sym_orderby] = ACTIONS(2442),
    [anon_sym_ascending] = ACTIONS(2442),
    [anon_sym_descending] = ACTIONS(2442),
    [anon_sym_group] = ACTIONS(2442),
    [anon_sym_by] = ACTIONS(2442),
    [anon_sym_select] = ACTIONS(2442),
    [anon_sym_DOT_DOT] = ACTIONS(2440),
    [anon_sym___reftype] = ACTIONS(2442),
    [anon_sym___refvalue] = ACTIONS(2442),
    [anon_sym_sizeof] = ACTIONS(2442),
    [anon_sym_typeof] = ACTIONS(2442),
    [anon_sym_SQUOTE] = ACTIONS(2440),
    [sym_integer_literal] = ACTIONS(2442),
    [sym_null_literal] = ACTIONS(2442),
    [sym_real_literal] = ACTIONS(2440),
    [sym_verbatim_string_literal] = ACTIONS(2440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2442),
    [anon_sym_nameof] = ACTIONS(2442),
    [sym_void_keyword] = ACTIONS(2442),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1672] = {
    [sym__preprocessor_call] = STATE(1672),
    [sym__identifier_token] = ACTIONS(2276),
    [anon_sym_extern] = ACTIONS(2276),
    [anon_sym_alias] = ACTIONS(2276),
    [anon_sym_SEMI] = ACTIONS(2274),
    [anon_sym_global] = ACTIONS(2276),
    [anon_sym_using] = ACTIONS(2276),
    [anon_sym_static] = ACTIONS(2276),
    [anon_sym_LBRACK] = ACTIONS(2274),
    [anon_sym_return] = ACTIONS(2276),
    [anon_sym_LPAREN] = ACTIONS(2274),
    [anon_sym_abstract] = ACTIONS(2276),
    [anon_sym_async] = ACTIONS(2276),
    [anon_sym_const] = ACTIONS(2276),
    [anon_sym_fixed] = ACTIONS(2276),
    [anon_sym_internal] = ACTIONS(2276),
    [anon_sym_new] = ACTIONS(2276),
    [anon_sym_override] = ACTIONS(2276),
    [anon_sym_partial] = ACTIONS(2276),
    [anon_sym_private] = ACTIONS(2276),
    [anon_sym_protected] = ACTIONS(2276),
    [anon_sym_public] = ACTIONS(2276),
    [anon_sym_readonly] = ACTIONS(2276),
    [anon_sym_ref] = ACTIONS(2276),
    [anon_sym_sealed] = ACTIONS(2276),
    [anon_sym_unsafe] = ACTIONS(2276),
    [anon_sym_virtual] = ACTIONS(2276),
    [anon_sym_volatile] = ACTIONS(2276),
    [anon_sym_this] = ACTIONS(2276),
    [anon_sym_base] = ACTIONS(2276),
    [anon_sym_LBRACE] = ACTIONS(2274),
    [anon_sym_RBRACE] = ACTIONS(2274),
    [anon_sym_TILDE] = ACTIONS(2274),
    [anon_sym_where] = ACTIONS(2276),
    [anon_sym_notnull] = ACTIONS(2276),
    [anon_sym_unmanaged] = ACTIONS(2276),
    [anon_sym_BANG] = ACTIONS(2274),
    [anon_sym_PLUS_PLUS] = ACTIONS(2274),
    [anon_sym_DASH_DASH] = ACTIONS(2274),
    [anon_sym_true] = ACTIONS(2276),
    [anon_sym_false] = ACTIONS(2276),
    [anon_sym_PLUS] = ACTIONS(2276),
    [anon_sym_DASH] = ACTIONS(2276),
    [anon_sym_STAR] = ACTIONS(2274),
    [anon_sym_CARET] = ACTIONS(2274),
    [anon_sym_AMP] = ACTIONS(2274),
    [anon_sym_get] = ACTIONS(2276),
    [anon_sym_set] = ACTIONS(2276),
    [anon_sym_add] = ACTIONS(2276),
    [anon_sym_remove] = ACTIONS(2276),
    [anon_sym_delegate] = ACTIONS(2276),
    [anon_sym_var] = ACTIONS(2276),
    [sym_predefined_type] = ACTIONS(2276),
    [anon_sym_break] = ACTIONS(2276),
    [anon_sym_checked] = ACTIONS(2276),
    [anon_sym_unchecked] = ACTIONS(2276),
    [anon_sym_continue] = ACTIONS(2276),
    [anon_sym_do] = ACTIONS(2276),
    [anon_sym_while] = ACTIONS(2276),
    [anon_sym_for] = ACTIONS(2276),
    [anon_sym_await] = ACTIONS(2276),
    [anon_sym_foreach] = ACTIONS(2276),
    [anon_sym_goto] = ACTIONS(2276),
    [anon_sym_case] = ACTIONS(2276),
    [anon_sym_default] = ACTIONS(2276),
    [anon_sym_if] = ACTIONS(2276),
    [anon_sym_else] = ACTIONS(2276),
    [anon_sym_lock] = ACTIONS(2276),
    [anon_sym_switch] = ACTIONS(2276),
    [anon_sym_when] = ACTIONS(2276),
    [anon_sym_throw] = ACTIONS(2276),
    [anon_sym_try] = ACTIONS(2276),
    [anon_sym_yield] = ACTIONS(2276),
    [anon_sym_stackalloc] = ACTIONS(2276),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2274),
    [anon_sym_DQUOTE] = ACTIONS(2274),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2274),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2274),
    [anon_sym___makeref] = ACTIONS(2276),
    [anon_sym_from] = ACTIONS(2276),
    [anon_sym_join] = ACTIONS(2276),
    [anon_sym_on] = ACTIONS(2276),
    [anon_sym_equals] = ACTIONS(2276),
    [anon_sym_into] = ACTIONS(2276),
    [anon_sym_let] = ACTIONS(2276),
    [anon_sym_orderby] = ACTIONS(2276),
    [anon_sym_ascending] = ACTIONS(2276),
    [anon_sym_descending] = ACTIONS(2276),
    [anon_sym_group] = ACTIONS(2276),
    [anon_sym_by] = ACTIONS(2276),
    [anon_sym_select] = ACTIONS(2276),
    [anon_sym_DOT_DOT] = ACTIONS(2274),
    [anon_sym___reftype] = ACTIONS(2276),
    [anon_sym___refvalue] = ACTIONS(2276),
    [anon_sym_sizeof] = ACTIONS(2276),
    [anon_sym_typeof] = ACTIONS(2276),
    [anon_sym_SQUOTE] = ACTIONS(2274),
    [sym_integer_literal] = ACTIONS(2276),
    [sym_null_literal] = ACTIONS(2276),
    [sym_real_literal] = ACTIONS(2274),
    [sym_verbatim_string_literal] = ACTIONS(2274),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2276),
    [anon_sym_nameof] = ACTIONS(2276),
    [sym_void_keyword] = ACTIONS(2276),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1673] = {
    [sym__preprocessor_call] = STATE(1673),
    [sym__identifier_token] = ACTIONS(2402),
    [anon_sym_extern] = ACTIONS(2402),
    [anon_sym_alias] = ACTIONS(2402),
    [anon_sym_SEMI] = ACTIONS(2400),
    [anon_sym_global] = ACTIONS(2402),
    [anon_sym_using] = ACTIONS(2402),
    [anon_sym_static] = ACTIONS(2402),
    [anon_sym_LBRACK] = ACTIONS(2400),
    [anon_sym_return] = ACTIONS(2402),
    [anon_sym_LPAREN] = ACTIONS(2400),
    [anon_sym_abstract] = ACTIONS(2402),
    [anon_sym_async] = ACTIONS(2402),
    [anon_sym_const] = ACTIONS(2402),
    [anon_sym_fixed] = ACTIONS(2402),
    [anon_sym_internal] = ACTIONS(2402),
    [anon_sym_new] = ACTIONS(2402),
    [anon_sym_override] = ACTIONS(2402),
    [anon_sym_partial] = ACTIONS(2402),
    [anon_sym_private] = ACTIONS(2402),
    [anon_sym_protected] = ACTIONS(2402),
    [anon_sym_public] = ACTIONS(2402),
    [anon_sym_readonly] = ACTIONS(2402),
    [anon_sym_ref] = ACTIONS(2402),
    [anon_sym_sealed] = ACTIONS(2402),
    [anon_sym_unsafe] = ACTIONS(2402),
    [anon_sym_virtual] = ACTIONS(2402),
    [anon_sym_volatile] = ACTIONS(2402),
    [anon_sym_this] = ACTIONS(2402),
    [anon_sym_base] = ACTIONS(2402),
    [anon_sym_LBRACE] = ACTIONS(2400),
    [anon_sym_RBRACE] = ACTIONS(2400),
    [anon_sym_TILDE] = ACTIONS(2400),
    [anon_sym_where] = ACTIONS(2402),
    [anon_sym_notnull] = ACTIONS(2402),
    [anon_sym_unmanaged] = ACTIONS(2402),
    [anon_sym_BANG] = ACTIONS(2400),
    [anon_sym_PLUS_PLUS] = ACTIONS(2400),
    [anon_sym_DASH_DASH] = ACTIONS(2400),
    [anon_sym_true] = ACTIONS(2402),
    [anon_sym_false] = ACTIONS(2402),
    [anon_sym_PLUS] = ACTIONS(2402),
    [anon_sym_DASH] = ACTIONS(2402),
    [anon_sym_STAR] = ACTIONS(2400),
    [anon_sym_CARET] = ACTIONS(2400),
    [anon_sym_AMP] = ACTIONS(2400),
    [anon_sym_get] = ACTIONS(2402),
    [anon_sym_set] = ACTIONS(2402),
    [anon_sym_add] = ACTIONS(2402),
    [anon_sym_remove] = ACTIONS(2402),
    [anon_sym_delegate] = ACTIONS(2402),
    [anon_sym_var] = ACTIONS(2402),
    [sym_predefined_type] = ACTIONS(2402),
    [anon_sym_break] = ACTIONS(2402),
    [anon_sym_checked] = ACTIONS(2402),
    [anon_sym_unchecked] = ACTIONS(2402),
    [anon_sym_continue] = ACTIONS(2402),
    [anon_sym_do] = ACTIONS(2402),
    [anon_sym_while] = ACTIONS(2402),
    [anon_sym_for] = ACTIONS(2402),
    [anon_sym_await] = ACTIONS(2402),
    [anon_sym_foreach] = ACTIONS(2402),
    [anon_sym_goto] = ACTIONS(2402),
    [anon_sym_case] = ACTIONS(2402),
    [anon_sym_default] = ACTIONS(2402),
    [anon_sym_if] = ACTIONS(2402),
    [anon_sym_else] = ACTIONS(2402),
    [anon_sym_lock] = ACTIONS(2402),
    [anon_sym_switch] = ACTIONS(2402),
    [anon_sym_when] = ACTIONS(2402),
    [anon_sym_throw] = ACTIONS(2402),
    [anon_sym_try] = ACTIONS(2402),
    [anon_sym_yield] = ACTIONS(2402),
    [anon_sym_stackalloc] = ACTIONS(2402),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2400),
    [anon_sym_DQUOTE] = ACTIONS(2400),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2400),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2400),
    [anon_sym___makeref] = ACTIONS(2402),
    [anon_sym_from] = ACTIONS(2402),
    [anon_sym_join] = ACTIONS(2402),
    [anon_sym_on] = ACTIONS(2402),
    [anon_sym_equals] = ACTIONS(2402),
    [anon_sym_into] = ACTIONS(2402),
    [anon_sym_let] = ACTIONS(2402),
    [anon_sym_orderby] = ACTIONS(2402),
    [anon_sym_ascending] = ACTIONS(2402),
    [anon_sym_descending] = ACTIONS(2402),
    [anon_sym_group] = ACTIONS(2402),
    [anon_sym_by] = ACTIONS(2402),
    [anon_sym_select] = ACTIONS(2402),
    [anon_sym_DOT_DOT] = ACTIONS(2400),
    [anon_sym___reftype] = ACTIONS(2402),
    [anon_sym___refvalue] = ACTIONS(2402),
    [anon_sym_sizeof] = ACTIONS(2402),
    [anon_sym_typeof] = ACTIONS(2402),
    [anon_sym_SQUOTE] = ACTIONS(2400),
    [sym_integer_literal] = ACTIONS(2402),
    [sym_null_literal] = ACTIONS(2402),
    [sym_real_literal] = ACTIONS(2400),
    [sym_verbatim_string_literal] = ACTIONS(2400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2402),
    [anon_sym_nameof] = ACTIONS(2402),
    [sym_void_keyword] = ACTIONS(2402),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1674] = {
    [sym__preprocessor_call] = STATE(1674),
    [sym__identifier_token] = ACTIONS(2454),
    [anon_sym_extern] = ACTIONS(2454),
    [anon_sym_alias] = ACTIONS(2454),
    [anon_sym_SEMI] = ACTIONS(2452),
    [anon_sym_global] = ACTIONS(2454),
    [anon_sym_using] = ACTIONS(2454),
    [anon_sym_static] = ACTIONS(2454),
    [anon_sym_LBRACK] = ACTIONS(2452),
    [anon_sym_return] = ACTIONS(2454),
    [anon_sym_LPAREN] = ACTIONS(2452),
    [anon_sym_abstract] = ACTIONS(2454),
    [anon_sym_async] = ACTIONS(2454),
    [anon_sym_const] = ACTIONS(2454),
    [anon_sym_fixed] = ACTIONS(2454),
    [anon_sym_internal] = ACTIONS(2454),
    [anon_sym_new] = ACTIONS(2454),
    [anon_sym_override] = ACTIONS(2454),
    [anon_sym_partial] = ACTIONS(2454),
    [anon_sym_private] = ACTIONS(2454),
    [anon_sym_protected] = ACTIONS(2454),
    [anon_sym_public] = ACTIONS(2454),
    [anon_sym_readonly] = ACTIONS(2454),
    [anon_sym_ref] = ACTIONS(2454),
    [anon_sym_sealed] = ACTIONS(2454),
    [anon_sym_unsafe] = ACTIONS(2454),
    [anon_sym_virtual] = ACTIONS(2454),
    [anon_sym_volatile] = ACTIONS(2454),
    [anon_sym_this] = ACTIONS(2454),
    [anon_sym_base] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2452),
    [anon_sym_RBRACE] = ACTIONS(2452),
    [anon_sym_TILDE] = ACTIONS(2452),
    [anon_sym_where] = ACTIONS(2454),
    [anon_sym_notnull] = ACTIONS(2454),
    [anon_sym_unmanaged] = ACTIONS(2454),
    [anon_sym_BANG] = ACTIONS(2452),
    [anon_sym_PLUS_PLUS] = ACTIONS(2452),
    [anon_sym_DASH_DASH] = ACTIONS(2452),
    [anon_sym_true] = ACTIONS(2454),
    [anon_sym_false] = ACTIONS(2454),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_STAR] = ACTIONS(2452),
    [anon_sym_CARET] = ACTIONS(2452),
    [anon_sym_AMP] = ACTIONS(2452),
    [anon_sym_get] = ACTIONS(2454),
    [anon_sym_set] = ACTIONS(2454),
    [anon_sym_add] = ACTIONS(2454),
    [anon_sym_remove] = ACTIONS(2454),
    [anon_sym_delegate] = ACTIONS(2454),
    [anon_sym_var] = ACTIONS(2454),
    [sym_predefined_type] = ACTIONS(2454),
    [anon_sym_break] = ACTIONS(2454),
    [anon_sym_checked] = ACTIONS(2454),
    [anon_sym_unchecked] = ACTIONS(2454),
    [anon_sym_continue] = ACTIONS(2454),
    [anon_sym_do] = ACTIONS(2454),
    [anon_sym_while] = ACTIONS(2454),
    [anon_sym_for] = ACTIONS(2454),
    [anon_sym_await] = ACTIONS(2454),
    [anon_sym_foreach] = ACTIONS(2454),
    [anon_sym_goto] = ACTIONS(2454),
    [anon_sym_case] = ACTIONS(2454),
    [anon_sym_default] = ACTIONS(2454),
    [anon_sym_if] = ACTIONS(2454),
    [anon_sym_else] = ACTIONS(2454),
    [anon_sym_lock] = ACTIONS(2454),
    [anon_sym_switch] = ACTIONS(2454),
    [anon_sym_when] = ACTIONS(2454),
    [anon_sym_throw] = ACTIONS(2454),
    [anon_sym_try] = ACTIONS(2454),
    [anon_sym_yield] = ACTIONS(2454),
    [anon_sym_stackalloc] = ACTIONS(2454),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2452),
    [anon_sym_DQUOTE] = ACTIONS(2452),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2452),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2452),
    [anon_sym___makeref] = ACTIONS(2454),
    [anon_sym_from] = ACTIONS(2454),
    [anon_sym_join] = ACTIONS(2454),
    [anon_sym_on] = ACTIONS(2454),
    [anon_sym_equals] = ACTIONS(2454),
    [anon_sym_into] = ACTIONS(2454),
    [anon_sym_let] = ACTIONS(2454),
    [anon_sym_orderby] = ACTIONS(2454),
    [anon_sym_ascending] = ACTIONS(2454),
    [anon_sym_descending] = ACTIONS(2454),
    [anon_sym_group] = ACTIONS(2454),
    [anon_sym_by] = ACTIONS(2454),
    [anon_sym_select] = ACTIONS(2454),
    [anon_sym_DOT_DOT] = ACTIONS(2452),
    [anon_sym___reftype] = ACTIONS(2454),
    [anon_sym___refvalue] = ACTIONS(2454),
    [anon_sym_sizeof] = ACTIONS(2454),
    [anon_sym_typeof] = ACTIONS(2454),
    [anon_sym_SQUOTE] = ACTIONS(2452),
    [sym_integer_literal] = ACTIONS(2454),
    [sym_null_literal] = ACTIONS(2454),
    [sym_real_literal] = ACTIONS(2452),
    [sym_verbatim_string_literal] = ACTIONS(2452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2454),
    [anon_sym_nameof] = ACTIONS(2454),
    [sym_void_keyword] = ACTIONS(2454),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1675] = {
    [sym__preprocessor_call] = STATE(1675),
    [sym__identifier_token] = ACTIONS(2494),
    [anon_sym_extern] = ACTIONS(2494),
    [anon_sym_alias] = ACTIONS(2494),
    [anon_sym_SEMI] = ACTIONS(2492),
    [anon_sym_global] = ACTIONS(2494),
    [anon_sym_using] = ACTIONS(2494),
    [anon_sym_static] = ACTIONS(2494),
    [anon_sym_LBRACK] = ACTIONS(2492),
    [anon_sym_return] = ACTIONS(2494),
    [anon_sym_LPAREN] = ACTIONS(2492),
    [anon_sym_abstract] = ACTIONS(2494),
    [anon_sym_async] = ACTIONS(2494),
    [anon_sym_const] = ACTIONS(2494),
    [anon_sym_fixed] = ACTIONS(2494),
    [anon_sym_internal] = ACTIONS(2494),
    [anon_sym_new] = ACTIONS(2494),
    [anon_sym_override] = ACTIONS(2494),
    [anon_sym_partial] = ACTIONS(2494),
    [anon_sym_private] = ACTIONS(2494),
    [anon_sym_protected] = ACTIONS(2494),
    [anon_sym_public] = ACTIONS(2494),
    [anon_sym_readonly] = ACTIONS(2494),
    [anon_sym_ref] = ACTIONS(2494),
    [anon_sym_sealed] = ACTIONS(2494),
    [anon_sym_unsafe] = ACTIONS(2494),
    [anon_sym_virtual] = ACTIONS(2494),
    [anon_sym_volatile] = ACTIONS(2494),
    [anon_sym_this] = ACTIONS(2494),
    [anon_sym_base] = ACTIONS(2494),
    [anon_sym_LBRACE] = ACTIONS(2492),
    [anon_sym_RBRACE] = ACTIONS(2492),
    [anon_sym_TILDE] = ACTIONS(2492),
    [anon_sym_where] = ACTIONS(2494),
    [anon_sym_notnull] = ACTIONS(2494),
    [anon_sym_unmanaged] = ACTIONS(2494),
    [anon_sym_BANG] = ACTIONS(2492),
    [anon_sym_PLUS_PLUS] = ACTIONS(2492),
    [anon_sym_DASH_DASH] = ACTIONS(2492),
    [anon_sym_true] = ACTIONS(2494),
    [anon_sym_false] = ACTIONS(2494),
    [anon_sym_PLUS] = ACTIONS(2494),
    [anon_sym_DASH] = ACTIONS(2494),
    [anon_sym_STAR] = ACTIONS(2492),
    [anon_sym_CARET] = ACTIONS(2492),
    [anon_sym_AMP] = ACTIONS(2492),
    [anon_sym_get] = ACTIONS(2494),
    [anon_sym_set] = ACTIONS(2494),
    [anon_sym_add] = ACTIONS(2494),
    [anon_sym_remove] = ACTIONS(2494),
    [anon_sym_delegate] = ACTIONS(2494),
    [anon_sym_var] = ACTIONS(2494),
    [sym_predefined_type] = ACTIONS(2494),
    [anon_sym_break] = ACTIONS(2494),
    [anon_sym_checked] = ACTIONS(2494),
    [anon_sym_unchecked] = ACTIONS(2494),
    [anon_sym_continue] = ACTIONS(2494),
    [anon_sym_do] = ACTIONS(2494),
    [anon_sym_while] = ACTIONS(2494),
    [anon_sym_for] = ACTIONS(2494),
    [anon_sym_await] = ACTIONS(2494),
    [anon_sym_foreach] = ACTIONS(2494),
    [anon_sym_goto] = ACTIONS(2494),
    [anon_sym_case] = ACTIONS(2494),
    [anon_sym_default] = ACTIONS(2494),
    [anon_sym_if] = ACTIONS(2494),
    [anon_sym_else] = ACTIONS(2494),
    [anon_sym_lock] = ACTIONS(2494),
    [anon_sym_switch] = ACTIONS(2494),
    [anon_sym_when] = ACTIONS(2494),
    [anon_sym_throw] = ACTIONS(2494),
    [anon_sym_try] = ACTIONS(2494),
    [anon_sym_yield] = ACTIONS(2494),
    [anon_sym_stackalloc] = ACTIONS(2494),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2492),
    [anon_sym_DQUOTE] = ACTIONS(2492),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2492),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2492),
    [anon_sym___makeref] = ACTIONS(2494),
    [anon_sym_from] = ACTIONS(2494),
    [anon_sym_join] = ACTIONS(2494),
    [anon_sym_on] = ACTIONS(2494),
    [anon_sym_equals] = ACTIONS(2494),
    [anon_sym_into] = ACTIONS(2494),
    [anon_sym_let] = ACTIONS(2494),
    [anon_sym_orderby] = ACTIONS(2494),
    [anon_sym_ascending] = ACTIONS(2494),
    [anon_sym_descending] = ACTIONS(2494),
    [anon_sym_group] = ACTIONS(2494),
    [anon_sym_by] = ACTIONS(2494),
    [anon_sym_select] = ACTIONS(2494),
    [anon_sym_DOT_DOT] = ACTIONS(2492),
    [anon_sym___reftype] = ACTIONS(2494),
    [anon_sym___refvalue] = ACTIONS(2494),
    [anon_sym_sizeof] = ACTIONS(2494),
    [anon_sym_typeof] = ACTIONS(2494),
    [anon_sym_SQUOTE] = ACTIONS(2492),
    [sym_integer_literal] = ACTIONS(2494),
    [sym_null_literal] = ACTIONS(2494),
    [sym_real_literal] = ACTIONS(2492),
    [sym_verbatim_string_literal] = ACTIONS(2492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2494),
    [anon_sym_nameof] = ACTIONS(2494),
    [sym_void_keyword] = ACTIONS(2494),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1676] = {
    [sym__preprocessor_call] = STATE(1676),
    [sym__identifier_token] = ACTIONS(2430),
    [anon_sym_extern] = ACTIONS(2430),
    [anon_sym_alias] = ACTIONS(2430),
    [anon_sym_SEMI] = ACTIONS(2428),
    [anon_sym_global] = ACTIONS(2430),
    [anon_sym_using] = ACTIONS(2430),
    [anon_sym_static] = ACTIONS(2430),
    [anon_sym_LBRACK] = ACTIONS(2428),
    [anon_sym_return] = ACTIONS(2430),
    [anon_sym_LPAREN] = ACTIONS(2428),
    [anon_sym_abstract] = ACTIONS(2430),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_const] = ACTIONS(2430),
    [anon_sym_fixed] = ACTIONS(2430),
    [anon_sym_internal] = ACTIONS(2430),
    [anon_sym_new] = ACTIONS(2430),
    [anon_sym_override] = ACTIONS(2430),
    [anon_sym_partial] = ACTIONS(2430),
    [anon_sym_private] = ACTIONS(2430),
    [anon_sym_protected] = ACTIONS(2430),
    [anon_sym_public] = ACTIONS(2430),
    [anon_sym_readonly] = ACTIONS(2430),
    [anon_sym_ref] = ACTIONS(2430),
    [anon_sym_sealed] = ACTIONS(2430),
    [anon_sym_unsafe] = ACTIONS(2430),
    [anon_sym_virtual] = ACTIONS(2430),
    [anon_sym_volatile] = ACTIONS(2430),
    [anon_sym_this] = ACTIONS(2430),
    [anon_sym_base] = ACTIONS(2430),
    [anon_sym_LBRACE] = ACTIONS(2428),
    [anon_sym_RBRACE] = ACTIONS(2428),
    [anon_sym_TILDE] = ACTIONS(2428),
    [anon_sym_where] = ACTIONS(2430),
    [anon_sym_notnull] = ACTIONS(2430),
    [anon_sym_unmanaged] = ACTIONS(2430),
    [anon_sym_BANG] = ACTIONS(2428),
    [anon_sym_PLUS_PLUS] = ACTIONS(2428),
    [anon_sym_DASH_DASH] = ACTIONS(2428),
    [anon_sym_true] = ACTIONS(2430),
    [anon_sym_false] = ACTIONS(2430),
    [anon_sym_PLUS] = ACTIONS(2430),
    [anon_sym_DASH] = ACTIONS(2430),
    [anon_sym_STAR] = ACTIONS(2428),
    [anon_sym_CARET] = ACTIONS(2428),
    [anon_sym_AMP] = ACTIONS(2428),
    [anon_sym_get] = ACTIONS(2430),
    [anon_sym_set] = ACTIONS(2430),
    [anon_sym_add] = ACTIONS(2430),
    [anon_sym_remove] = ACTIONS(2430),
    [anon_sym_delegate] = ACTIONS(2430),
    [anon_sym_var] = ACTIONS(2430),
    [sym_predefined_type] = ACTIONS(2430),
    [anon_sym_break] = ACTIONS(2430),
    [anon_sym_checked] = ACTIONS(2430),
    [anon_sym_unchecked] = ACTIONS(2430),
    [anon_sym_continue] = ACTIONS(2430),
    [anon_sym_do] = ACTIONS(2430),
    [anon_sym_while] = ACTIONS(2430),
    [anon_sym_for] = ACTIONS(2430),
    [anon_sym_await] = ACTIONS(2430),
    [anon_sym_foreach] = ACTIONS(2430),
    [anon_sym_goto] = ACTIONS(2430),
    [anon_sym_case] = ACTIONS(2430),
    [anon_sym_default] = ACTIONS(2430),
    [anon_sym_if] = ACTIONS(2430),
    [anon_sym_else] = ACTIONS(2430),
    [anon_sym_lock] = ACTIONS(2430),
    [anon_sym_switch] = ACTIONS(2430),
    [anon_sym_when] = ACTIONS(2430),
    [anon_sym_throw] = ACTIONS(2430),
    [anon_sym_try] = ACTIONS(2430),
    [anon_sym_yield] = ACTIONS(2430),
    [anon_sym_stackalloc] = ACTIONS(2430),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2428),
    [anon_sym_DQUOTE] = ACTIONS(2428),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2428),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2428),
    [anon_sym___makeref] = ACTIONS(2430),
    [anon_sym_from] = ACTIONS(2430),
    [anon_sym_join] = ACTIONS(2430),
    [anon_sym_on] = ACTIONS(2430),
    [anon_sym_equals] = ACTIONS(2430),
    [anon_sym_into] = ACTIONS(2430),
    [anon_sym_let] = ACTIONS(2430),
    [anon_sym_orderby] = ACTIONS(2430),
    [anon_sym_ascending] = ACTIONS(2430),
    [anon_sym_descending] = ACTIONS(2430),
    [anon_sym_group] = ACTIONS(2430),
    [anon_sym_by] = ACTIONS(2430),
    [anon_sym_select] = ACTIONS(2430),
    [anon_sym_DOT_DOT] = ACTIONS(2428),
    [anon_sym___reftype] = ACTIONS(2430),
    [anon_sym___refvalue] = ACTIONS(2430),
    [anon_sym_sizeof] = ACTIONS(2430),
    [anon_sym_typeof] = ACTIONS(2430),
    [anon_sym_SQUOTE] = ACTIONS(2428),
    [sym_integer_literal] = ACTIONS(2430),
    [sym_null_literal] = ACTIONS(2430),
    [sym_real_literal] = ACTIONS(2428),
    [sym_verbatim_string_literal] = ACTIONS(2428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2430),
    [anon_sym_nameof] = ACTIONS(2430),
    [sym_void_keyword] = ACTIONS(2430),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1677] = {
    [sym__preprocessor_call] = STATE(1677),
    [sym__identifier_token] = ACTIONS(2446),
    [anon_sym_extern] = ACTIONS(2446),
    [anon_sym_alias] = ACTIONS(2446),
    [anon_sym_SEMI] = ACTIONS(2444),
    [anon_sym_global] = ACTIONS(2446),
    [anon_sym_using] = ACTIONS(2446),
    [anon_sym_static] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_abstract] = ACTIONS(2446),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_const] = ACTIONS(2446),
    [anon_sym_fixed] = ACTIONS(2446),
    [anon_sym_internal] = ACTIONS(2446),
    [anon_sym_new] = ACTIONS(2446),
    [anon_sym_override] = ACTIONS(2446),
    [anon_sym_partial] = ACTIONS(2446),
    [anon_sym_private] = ACTIONS(2446),
    [anon_sym_protected] = ACTIONS(2446),
    [anon_sym_public] = ACTIONS(2446),
    [anon_sym_readonly] = ACTIONS(2446),
    [anon_sym_ref] = ACTIONS(2446),
    [anon_sym_sealed] = ACTIONS(2446),
    [anon_sym_unsafe] = ACTIONS(2446),
    [anon_sym_virtual] = ACTIONS(2446),
    [anon_sym_volatile] = ACTIONS(2446),
    [anon_sym_this] = ACTIONS(2446),
    [anon_sym_base] = ACTIONS(2446),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [anon_sym_RBRACE] = ACTIONS(2444),
    [anon_sym_TILDE] = ACTIONS(2444),
    [anon_sym_where] = ACTIONS(2446),
    [anon_sym_notnull] = ACTIONS(2446),
    [anon_sym_unmanaged] = ACTIONS(2446),
    [anon_sym_BANG] = ACTIONS(2444),
    [anon_sym_PLUS_PLUS] = ACTIONS(2444),
    [anon_sym_DASH_DASH] = ACTIONS(2444),
    [anon_sym_true] = ACTIONS(2446),
    [anon_sym_false] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2446),
    [anon_sym_DASH] = ACTIONS(2446),
    [anon_sym_STAR] = ACTIONS(2444),
    [anon_sym_CARET] = ACTIONS(2444),
    [anon_sym_AMP] = ACTIONS(2444),
    [anon_sym_get] = ACTIONS(2446),
    [anon_sym_set] = ACTIONS(2446),
    [anon_sym_add] = ACTIONS(2446),
    [anon_sym_remove] = ACTIONS(2446),
    [anon_sym_delegate] = ACTIONS(2446),
    [anon_sym_var] = ACTIONS(2446),
    [sym_predefined_type] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_checked] = ACTIONS(2446),
    [anon_sym_unchecked] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_do] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_await] = ACTIONS(2446),
    [anon_sym_foreach] = ACTIONS(2446),
    [anon_sym_goto] = ACTIONS(2446),
    [anon_sym_case] = ACTIONS(2446),
    [anon_sym_default] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_else] = ACTIONS(2446),
    [anon_sym_lock] = ACTIONS(2446),
    [anon_sym_switch] = ACTIONS(2446),
    [anon_sym_when] = ACTIONS(2446),
    [anon_sym_throw] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_stackalloc] = ACTIONS(2446),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2444),
    [anon_sym_DQUOTE] = ACTIONS(2444),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2444),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2444),
    [anon_sym___makeref] = ACTIONS(2446),
    [anon_sym_from] = ACTIONS(2446),
    [anon_sym_join] = ACTIONS(2446),
    [anon_sym_on] = ACTIONS(2446),
    [anon_sym_equals] = ACTIONS(2446),
    [anon_sym_into] = ACTIONS(2446),
    [anon_sym_let] = ACTIONS(2446),
    [anon_sym_orderby] = ACTIONS(2446),
    [anon_sym_ascending] = ACTIONS(2446),
    [anon_sym_descending] = ACTIONS(2446),
    [anon_sym_group] = ACTIONS(2446),
    [anon_sym_by] = ACTIONS(2446),
    [anon_sym_select] = ACTIONS(2446),
    [anon_sym_DOT_DOT] = ACTIONS(2444),
    [anon_sym___reftype] = ACTIONS(2446),
    [anon_sym___refvalue] = ACTIONS(2446),
    [anon_sym_sizeof] = ACTIONS(2446),
    [anon_sym_typeof] = ACTIONS(2446),
    [anon_sym_SQUOTE] = ACTIONS(2444),
    [sym_integer_literal] = ACTIONS(2446),
    [sym_null_literal] = ACTIONS(2446),
    [sym_real_literal] = ACTIONS(2444),
    [sym_verbatim_string_literal] = ACTIONS(2444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2446),
    [anon_sym_nameof] = ACTIONS(2446),
    [sym_void_keyword] = ACTIONS(2446),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1678] = {
    [sym__preprocessor_call] = STATE(1678),
    [sym__identifier_token] = ACTIONS(2312),
    [anon_sym_extern] = ACTIONS(2312),
    [anon_sym_alias] = ACTIONS(2312),
    [anon_sym_SEMI] = ACTIONS(2310),
    [anon_sym_global] = ACTIONS(2312),
    [anon_sym_using] = ACTIONS(2312),
    [anon_sym_static] = ACTIONS(2312),
    [anon_sym_LBRACK] = ACTIONS(2310),
    [anon_sym_return] = ACTIONS(2312),
    [anon_sym_LPAREN] = ACTIONS(2310),
    [anon_sym_abstract] = ACTIONS(2312),
    [anon_sym_async] = ACTIONS(2312),
    [anon_sym_const] = ACTIONS(2312),
    [anon_sym_fixed] = ACTIONS(2312),
    [anon_sym_internal] = ACTIONS(2312),
    [anon_sym_new] = ACTIONS(2312),
    [anon_sym_override] = ACTIONS(2312),
    [anon_sym_partial] = ACTIONS(2312),
    [anon_sym_private] = ACTIONS(2312),
    [anon_sym_protected] = ACTIONS(2312),
    [anon_sym_public] = ACTIONS(2312),
    [anon_sym_readonly] = ACTIONS(2312),
    [anon_sym_ref] = ACTIONS(2312),
    [anon_sym_sealed] = ACTIONS(2312),
    [anon_sym_unsafe] = ACTIONS(2312),
    [anon_sym_virtual] = ACTIONS(2312),
    [anon_sym_volatile] = ACTIONS(2312),
    [anon_sym_this] = ACTIONS(2312),
    [anon_sym_base] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(2310),
    [anon_sym_RBRACE] = ACTIONS(2310),
    [anon_sym_TILDE] = ACTIONS(2310),
    [anon_sym_where] = ACTIONS(2312),
    [anon_sym_notnull] = ACTIONS(2312),
    [anon_sym_unmanaged] = ACTIONS(2312),
    [anon_sym_BANG] = ACTIONS(2310),
    [anon_sym_PLUS_PLUS] = ACTIONS(2310),
    [anon_sym_DASH_DASH] = ACTIONS(2310),
    [anon_sym_true] = ACTIONS(2312),
    [anon_sym_false] = ACTIONS(2312),
    [anon_sym_PLUS] = ACTIONS(2312),
    [anon_sym_DASH] = ACTIONS(2312),
    [anon_sym_STAR] = ACTIONS(2310),
    [anon_sym_CARET] = ACTIONS(2310),
    [anon_sym_AMP] = ACTIONS(2310),
    [anon_sym_get] = ACTIONS(2312),
    [anon_sym_set] = ACTIONS(2312),
    [anon_sym_add] = ACTIONS(2312),
    [anon_sym_remove] = ACTIONS(2312),
    [anon_sym_delegate] = ACTIONS(2312),
    [anon_sym_var] = ACTIONS(2312),
    [sym_predefined_type] = ACTIONS(2312),
    [anon_sym_break] = ACTIONS(2312),
    [anon_sym_checked] = ACTIONS(2312),
    [anon_sym_unchecked] = ACTIONS(2312),
    [anon_sym_continue] = ACTIONS(2312),
    [anon_sym_do] = ACTIONS(2312),
    [anon_sym_while] = ACTIONS(2312),
    [anon_sym_for] = ACTIONS(2312),
    [anon_sym_await] = ACTIONS(2312),
    [anon_sym_foreach] = ACTIONS(2312),
    [anon_sym_goto] = ACTIONS(2312),
    [anon_sym_case] = ACTIONS(2312),
    [anon_sym_default] = ACTIONS(2312),
    [anon_sym_if] = ACTIONS(2312),
    [anon_sym_else] = ACTIONS(2312),
    [anon_sym_lock] = ACTIONS(2312),
    [anon_sym_switch] = ACTIONS(2312),
    [anon_sym_when] = ACTIONS(2312),
    [anon_sym_throw] = ACTIONS(2312),
    [anon_sym_try] = ACTIONS(2312),
    [anon_sym_yield] = ACTIONS(2312),
    [anon_sym_stackalloc] = ACTIONS(2312),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2310),
    [anon_sym_DQUOTE] = ACTIONS(2310),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2310),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2310),
    [anon_sym___makeref] = ACTIONS(2312),
    [anon_sym_from] = ACTIONS(2312),
    [anon_sym_join] = ACTIONS(2312),
    [anon_sym_on] = ACTIONS(2312),
    [anon_sym_equals] = ACTIONS(2312),
    [anon_sym_into] = ACTIONS(2312),
    [anon_sym_let] = ACTIONS(2312),
    [anon_sym_orderby] = ACTIONS(2312),
    [anon_sym_ascending] = ACTIONS(2312),
    [anon_sym_descending] = ACTIONS(2312),
    [anon_sym_group] = ACTIONS(2312),
    [anon_sym_by] = ACTIONS(2312),
    [anon_sym_select] = ACTIONS(2312),
    [anon_sym_DOT_DOT] = ACTIONS(2310),
    [anon_sym___reftype] = ACTIONS(2312),
    [anon_sym___refvalue] = ACTIONS(2312),
    [anon_sym_sizeof] = ACTIONS(2312),
    [anon_sym_typeof] = ACTIONS(2312),
    [anon_sym_SQUOTE] = ACTIONS(2310),
    [sym_integer_literal] = ACTIONS(2312),
    [sym_null_literal] = ACTIONS(2312),
    [sym_real_literal] = ACTIONS(2310),
    [sym_verbatim_string_literal] = ACTIONS(2310),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2312),
    [anon_sym_nameof] = ACTIONS(2312),
    [sym_void_keyword] = ACTIONS(2312),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1679] = {
    [sym__preprocessor_call] = STATE(1679),
    [sym__identifier_token] = ACTIONS(2426),
    [anon_sym_extern] = ACTIONS(2426),
    [anon_sym_alias] = ACTIONS(2426),
    [anon_sym_SEMI] = ACTIONS(2424),
    [anon_sym_global] = ACTIONS(2426),
    [anon_sym_using] = ACTIONS(2426),
    [anon_sym_static] = ACTIONS(2426),
    [anon_sym_LBRACK] = ACTIONS(2424),
    [anon_sym_return] = ACTIONS(2426),
    [anon_sym_LPAREN] = ACTIONS(2424),
    [anon_sym_abstract] = ACTIONS(2426),
    [anon_sym_async] = ACTIONS(2426),
    [anon_sym_const] = ACTIONS(2426),
    [anon_sym_fixed] = ACTIONS(2426),
    [anon_sym_internal] = ACTIONS(2426),
    [anon_sym_new] = ACTIONS(2426),
    [anon_sym_override] = ACTIONS(2426),
    [anon_sym_partial] = ACTIONS(2426),
    [anon_sym_private] = ACTIONS(2426),
    [anon_sym_protected] = ACTIONS(2426),
    [anon_sym_public] = ACTIONS(2426),
    [anon_sym_readonly] = ACTIONS(2426),
    [anon_sym_ref] = ACTIONS(2426),
    [anon_sym_sealed] = ACTIONS(2426),
    [anon_sym_unsafe] = ACTIONS(2426),
    [anon_sym_virtual] = ACTIONS(2426),
    [anon_sym_volatile] = ACTIONS(2426),
    [anon_sym_this] = ACTIONS(2426),
    [anon_sym_base] = ACTIONS(2426),
    [anon_sym_LBRACE] = ACTIONS(2424),
    [anon_sym_RBRACE] = ACTIONS(2424),
    [anon_sym_TILDE] = ACTIONS(2424),
    [anon_sym_where] = ACTIONS(2426),
    [anon_sym_notnull] = ACTIONS(2426),
    [anon_sym_unmanaged] = ACTIONS(2426),
    [anon_sym_BANG] = ACTIONS(2424),
    [anon_sym_PLUS_PLUS] = ACTIONS(2424),
    [anon_sym_DASH_DASH] = ACTIONS(2424),
    [anon_sym_true] = ACTIONS(2426),
    [anon_sym_false] = ACTIONS(2426),
    [anon_sym_PLUS] = ACTIONS(2426),
    [anon_sym_DASH] = ACTIONS(2426),
    [anon_sym_STAR] = ACTIONS(2424),
    [anon_sym_CARET] = ACTIONS(2424),
    [anon_sym_AMP] = ACTIONS(2424),
    [anon_sym_get] = ACTIONS(2426),
    [anon_sym_set] = ACTIONS(2426),
    [anon_sym_add] = ACTIONS(2426),
    [anon_sym_remove] = ACTIONS(2426),
    [anon_sym_delegate] = ACTIONS(2426),
    [anon_sym_var] = ACTIONS(2426),
    [sym_predefined_type] = ACTIONS(2426),
    [anon_sym_break] = ACTIONS(2426),
    [anon_sym_checked] = ACTIONS(2426),
    [anon_sym_unchecked] = ACTIONS(2426),
    [anon_sym_continue] = ACTIONS(2426),
    [anon_sym_do] = ACTIONS(2426),
    [anon_sym_while] = ACTIONS(2426),
    [anon_sym_for] = ACTIONS(2426),
    [anon_sym_await] = ACTIONS(2426),
    [anon_sym_foreach] = ACTIONS(2426),
    [anon_sym_goto] = ACTIONS(2426),
    [anon_sym_case] = ACTIONS(2426),
    [anon_sym_default] = ACTIONS(2426),
    [anon_sym_if] = ACTIONS(2426),
    [anon_sym_else] = ACTIONS(2426),
    [anon_sym_lock] = ACTIONS(2426),
    [anon_sym_switch] = ACTIONS(2426),
    [anon_sym_when] = ACTIONS(2426),
    [anon_sym_throw] = ACTIONS(2426),
    [anon_sym_try] = ACTIONS(2426),
    [anon_sym_yield] = ACTIONS(2426),
    [anon_sym_stackalloc] = ACTIONS(2426),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2424),
    [anon_sym_DQUOTE] = ACTIONS(2424),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2424),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2424),
    [anon_sym___makeref] = ACTIONS(2426),
    [anon_sym_from] = ACTIONS(2426),
    [anon_sym_join] = ACTIONS(2426),
    [anon_sym_on] = ACTIONS(2426),
    [anon_sym_equals] = ACTIONS(2426),
    [anon_sym_into] = ACTIONS(2426),
    [anon_sym_let] = ACTIONS(2426),
    [anon_sym_orderby] = ACTIONS(2426),
    [anon_sym_ascending] = ACTIONS(2426),
    [anon_sym_descending] = ACTIONS(2426),
    [anon_sym_group] = ACTIONS(2426),
    [anon_sym_by] = ACTIONS(2426),
    [anon_sym_select] = ACTIONS(2426),
    [anon_sym_DOT_DOT] = ACTIONS(2424),
    [anon_sym___reftype] = ACTIONS(2426),
    [anon_sym___refvalue] = ACTIONS(2426),
    [anon_sym_sizeof] = ACTIONS(2426),
    [anon_sym_typeof] = ACTIONS(2426),
    [anon_sym_SQUOTE] = ACTIONS(2424),
    [sym_integer_literal] = ACTIONS(2426),
    [sym_null_literal] = ACTIONS(2426),
    [sym_real_literal] = ACTIONS(2424),
    [sym_verbatim_string_literal] = ACTIONS(2424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2426),
    [anon_sym_nameof] = ACTIONS(2426),
    [sym_void_keyword] = ACTIONS(2426),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1680] = {
    [sym__preprocessor_call] = STATE(1680),
    [sym__identifier_token] = ACTIONS(2360),
    [anon_sym_extern] = ACTIONS(2360),
    [anon_sym_alias] = ACTIONS(2360),
    [anon_sym_SEMI] = ACTIONS(2358),
    [anon_sym_global] = ACTIONS(2360),
    [anon_sym_using] = ACTIONS(2360),
    [anon_sym_static] = ACTIONS(2360),
    [anon_sym_LBRACK] = ACTIONS(2358),
    [anon_sym_return] = ACTIONS(2360),
    [anon_sym_LPAREN] = ACTIONS(2358),
    [anon_sym_abstract] = ACTIONS(2360),
    [anon_sym_async] = ACTIONS(2360),
    [anon_sym_const] = ACTIONS(2360),
    [anon_sym_fixed] = ACTIONS(2360),
    [anon_sym_internal] = ACTIONS(2360),
    [anon_sym_new] = ACTIONS(2360),
    [anon_sym_override] = ACTIONS(2360),
    [anon_sym_partial] = ACTIONS(2360),
    [anon_sym_private] = ACTIONS(2360),
    [anon_sym_protected] = ACTIONS(2360),
    [anon_sym_public] = ACTIONS(2360),
    [anon_sym_readonly] = ACTIONS(2360),
    [anon_sym_ref] = ACTIONS(2360),
    [anon_sym_sealed] = ACTIONS(2360),
    [anon_sym_unsafe] = ACTIONS(2360),
    [anon_sym_virtual] = ACTIONS(2360),
    [anon_sym_volatile] = ACTIONS(2360),
    [anon_sym_this] = ACTIONS(2360),
    [anon_sym_base] = ACTIONS(2360),
    [anon_sym_LBRACE] = ACTIONS(2358),
    [anon_sym_RBRACE] = ACTIONS(2358),
    [anon_sym_TILDE] = ACTIONS(2358),
    [anon_sym_where] = ACTIONS(2360),
    [anon_sym_notnull] = ACTIONS(2360),
    [anon_sym_unmanaged] = ACTIONS(2360),
    [anon_sym_BANG] = ACTIONS(2358),
    [anon_sym_PLUS_PLUS] = ACTIONS(2358),
    [anon_sym_DASH_DASH] = ACTIONS(2358),
    [anon_sym_true] = ACTIONS(2360),
    [anon_sym_false] = ACTIONS(2360),
    [anon_sym_PLUS] = ACTIONS(2360),
    [anon_sym_DASH] = ACTIONS(2360),
    [anon_sym_STAR] = ACTIONS(2358),
    [anon_sym_CARET] = ACTIONS(2358),
    [anon_sym_AMP] = ACTIONS(2358),
    [anon_sym_get] = ACTIONS(2360),
    [anon_sym_set] = ACTIONS(2360),
    [anon_sym_add] = ACTIONS(2360),
    [anon_sym_remove] = ACTIONS(2360),
    [anon_sym_delegate] = ACTIONS(2360),
    [anon_sym_var] = ACTIONS(2360),
    [sym_predefined_type] = ACTIONS(2360),
    [anon_sym_break] = ACTIONS(2360),
    [anon_sym_checked] = ACTIONS(2360),
    [anon_sym_unchecked] = ACTIONS(2360),
    [anon_sym_continue] = ACTIONS(2360),
    [anon_sym_do] = ACTIONS(2360),
    [anon_sym_while] = ACTIONS(2360),
    [anon_sym_for] = ACTIONS(2360),
    [anon_sym_await] = ACTIONS(2360),
    [anon_sym_foreach] = ACTIONS(2360),
    [anon_sym_goto] = ACTIONS(2360),
    [anon_sym_case] = ACTIONS(2360),
    [anon_sym_default] = ACTIONS(2360),
    [anon_sym_if] = ACTIONS(2360),
    [anon_sym_else] = ACTIONS(2360),
    [anon_sym_lock] = ACTIONS(2360),
    [anon_sym_switch] = ACTIONS(2360),
    [anon_sym_when] = ACTIONS(2360),
    [anon_sym_throw] = ACTIONS(2360),
    [anon_sym_try] = ACTIONS(2360),
    [anon_sym_yield] = ACTIONS(2360),
    [anon_sym_stackalloc] = ACTIONS(2360),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2358),
    [anon_sym_DQUOTE] = ACTIONS(2358),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2358),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2358),
    [anon_sym___makeref] = ACTIONS(2360),
    [anon_sym_from] = ACTIONS(2360),
    [anon_sym_join] = ACTIONS(2360),
    [anon_sym_on] = ACTIONS(2360),
    [anon_sym_equals] = ACTIONS(2360),
    [anon_sym_into] = ACTIONS(2360),
    [anon_sym_let] = ACTIONS(2360),
    [anon_sym_orderby] = ACTIONS(2360),
    [anon_sym_ascending] = ACTIONS(2360),
    [anon_sym_descending] = ACTIONS(2360),
    [anon_sym_group] = ACTIONS(2360),
    [anon_sym_by] = ACTIONS(2360),
    [anon_sym_select] = ACTIONS(2360),
    [anon_sym_DOT_DOT] = ACTIONS(2358),
    [anon_sym___reftype] = ACTIONS(2360),
    [anon_sym___refvalue] = ACTIONS(2360),
    [anon_sym_sizeof] = ACTIONS(2360),
    [anon_sym_typeof] = ACTIONS(2360),
    [anon_sym_SQUOTE] = ACTIONS(2358),
    [sym_integer_literal] = ACTIONS(2360),
    [sym_null_literal] = ACTIONS(2360),
    [sym_real_literal] = ACTIONS(2358),
    [sym_verbatim_string_literal] = ACTIONS(2358),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2360),
    [anon_sym_nameof] = ACTIONS(2360),
    [sym_void_keyword] = ACTIONS(2360),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1681] = {
    [sym__preprocessor_call] = STATE(1681),
    [sym__identifier_token] = ACTIONS(2462),
    [anon_sym_extern] = ACTIONS(2462),
    [anon_sym_alias] = ACTIONS(2462),
    [anon_sym_SEMI] = ACTIONS(2460),
    [anon_sym_global] = ACTIONS(2462),
    [anon_sym_using] = ACTIONS(2462),
    [anon_sym_static] = ACTIONS(2462),
    [anon_sym_LBRACK] = ACTIONS(2460),
    [anon_sym_return] = ACTIONS(2462),
    [anon_sym_LPAREN] = ACTIONS(2460),
    [anon_sym_abstract] = ACTIONS(2462),
    [anon_sym_async] = ACTIONS(2462),
    [anon_sym_const] = ACTIONS(2462),
    [anon_sym_fixed] = ACTIONS(2462),
    [anon_sym_internal] = ACTIONS(2462),
    [anon_sym_new] = ACTIONS(2462),
    [anon_sym_override] = ACTIONS(2462),
    [anon_sym_partial] = ACTIONS(2462),
    [anon_sym_private] = ACTIONS(2462),
    [anon_sym_protected] = ACTIONS(2462),
    [anon_sym_public] = ACTIONS(2462),
    [anon_sym_readonly] = ACTIONS(2462),
    [anon_sym_ref] = ACTIONS(2462),
    [anon_sym_sealed] = ACTIONS(2462),
    [anon_sym_unsafe] = ACTIONS(2462),
    [anon_sym_virtual] = ACTIONS(2462),
    [anon_sym_volatile] = ACTIONS(2462),
    [anon_sym_this] = ACTIONS(2462),
    [anon_sym_base] = ACTIONS(2462),
    [anon_sym_LBRACE] = ACTIONS(2460),
    [anon_sym_RBRACE] = ACTIONS(2460),
    [anon_sym_TILDE] = ACTIONS(2460),
    [anon_sym_where] = ACTIONS(2462),
    [anon_sym_notnull] = ACTIONS(2462),
    [anon_sym_unmanaged] = ACTIONS(2462),
    [anon_sym_BANG] = ACTIONS(2460),
    [anon_sym_PLUS_PLUS] = ACTIONS(2460),
    [anon_sym_DASH_DASH] = ACTIONS(2460),
    [anon_sym_true] = ACTIONS(2462),
    [anon_sym_false] = ACTIONS(2462),
    [anon_sym_PLUS] = ACTIONS(2462),
    [anon_sym_DASH] = ACTIONS(2462),
    [anon_sym_STAR] = ACTIONS(2460),
    [anon_sym_CARET] = ACTIONS(2460),
    [anon_sym_AMP] = ACTIONS(2460),
    [anon_sym_get] = ACTIONS(2462),
    [anon_sym_set] = ACTIONS(2462),
    [anon_sym_add] = ACTIONS(2462),
    [anon_sym_remove] = ACTIONS(2462),
    [anon_sym_delegate] = ACTIONS(2462),
    [anon_sym_var] = ACTIONS(2462),
    [sym_predefined_type] = ACTIONS(2462),
    [anon_sym_break] = ACTIONS(2462),
    [anon_sym_checked] = ACTIONS(2462),
    [anon_sym_unchecked] = ACTIONS(2462),
    [anon_sym_continue] = ACTIONS(2462),
    [anon_sym_do] = ACTIONS(2462),
    [anon_sym_while] = ACTIONS(2462),
    [anon_sym_for] = ACTIONS(2462),
    [anon_sym_await] = ACTIONS(2462),
    [anon_sym_foreach] = ACTIONS(2462),
    [anon_sym_goto] = ACTIONS(2462),
    [anon_sym_case] = ACTIONS(2462),
    [anon_sym_default] = ACTIONS(2462),
    [anon_sym_if] = ACTIONS(2462),
    [anon_sym_else] = ACTIONS(2462),
    [anon_sym_lock] = ACTIONS(2462),
    [anon_sym_switch] = ACTIONS(2462),
    [anon_sym_when] = ACTIONS(2462),
    [anon_sym_throw] = ACTIONS(2462),
    [anon_sym_try] = ACTIONS(2462),
    [anon_sym_yield] = ACTIONS(2462),
    [anon_sym_stackalloc] = ACTIONS(2462),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2460),
    [anon_sym_DQUOTE] = ACTIONS(2460),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2460),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2460),
    [anon_sym___makeref] = ACTIONS(2462),
    [anon_sym_from] = ACTIONS(2462),
    [anon_sym_join] = ACTIONS(2462),
    [anon_sym_on] = ACTIONS(2462),
    [anon_sym_equals] = ACTIONS(2462),
    [anon_sym_into] = ACTIONS(2462),
    [anon_sym_let] = ACTIONS(2462),
    [anon_sym_orderby] = ACTIONS(2462),
    [anon_sym_ascending] = ACTIONS(2462),
    [anon_sym_descending] = ACTIONS(2462),
    [anon_sym_group] = ACTIONS(2462),
    [anon_sym_by] = ACTIONS(2462),
    [anon_sym_select] = ACTIONS(2462),
    [anon_sym_DOT_DOT] = ACTIONS(2460),
    [anon_sym___reftype] = ACTIONS(2462),
    [anon_sym___refvalue] = ACTIONS(2462),
    [anon_sym_sizeof] = ACTIONS(2462),
    [anon_sym_typeof] = ACTIONS(2462),
    [anon_sym_SQUOTE] = ACTIONS(2460),
    [sym_integer_literal] = ACTIONS(2462),
    [sym_null_literal] = ACTIONS(2462),
    [sym_real_literal] = ACTIONS(2460),
    [sym_verbatim_string_literal] = ACTIONS(2460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2462),
    [anon_sym_nameof] = ACTIONS(2462),
    [sym_void_keyword] = ACTIONS(2462),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1682] = {
    [sym__preprocessor_call] = STATE(1682),
    [sym__identifier_token] = ACTIONS(2356),
    [anon_sym_extern] = ACTIONS(2356),
    [anon_sym_alias] = ACTIONS(2356),
    [anon_sym_SEMI] = ACTIONS(2354),
    [anon_sym_global] = ACTIONS(2356),
    [anon_sym_using] = ACTIONS(2356),
    [anon_sym_static] = ACTIONS(2356),
    [anon_sym_LBRACK] = ACTIONS(2354),
    [anon_sym_return] = ACTIONS(2356),
    [anon_sym_LPAREN] = ACTIONS(2354),
    [anon_sym_abstract] = ACTIONS(2356),
    [anon_sym_async] = ACTIONS(2356),
    [anon_sym_const] = ACTIONS(2356),
    [anon_sym_fixed] = ACTIONS(2356),
    [anon_sym_internal] = ACTIONS(2356),
    [anon_sym_new] = ACTIONS(2356),
    [anon_sym_override] = ACTIONS(2356),
    [anon_sym_partial] = ACTIONS(2356),
    [anon_sym_private] = ACTIONS(2356),
    [anon_sym_protected] = ACTIONS(2356),
    [anon_sym_public] = ACTIONS(2356),
    [anon_sym_readonly] = ACTIONS(2356),
    [anon_sym_ref] = ACTIONS(2356),
    [anon_sym_sealed] = ACTIONS(2356),
    [anon_sym_unsafe] = ACTIONS(2356),
    [anon_sym_virtual] = ACTIONS(2356),
    [anon_sym_volatile] = ACTIONS(2356),
    [anon_sym_this] = ACTIONS(2356),
    [anon_sym_base] = ACTIONS(2356),
    [anon_sym_LBRACE] = ACTIONS(2354),
    [anon_sym_RBRACE] = ACTIONS(2354),
    [anon_sym_TILDE] = ACTIONS(2354),
    [anon_sym_where] = ACTIONS(2356),
    [anon_sym_notnull] = ACTIONS(2356),
    [anon_sym_unmanaged] = ACTIONS(2356),
    [anon_sym_BANG] = ACTIONS(2354),
    [anon_sym_PLUS_PLUS] = ACTIONS(2354),
    [anon_sym_DASH_DASH] = ACTIONS(2354),
    [anon_sym_true] = ACTIONS(2356),
    [anon_sym_false] = ACTIONS(2356),
    [anon_sym_PLUS] = ACTIONS(2356),
    [anon_sym_DASH] = ACTIONS(2356),
    [anon_sym_STAR] = ACTIONS(2354),
    [anon_sym_CARET] = ACTIONS(2354),
    [anon_sym_AMP] = ACTIONS(2354),
    [anon_sym_get] = ACTIONS(2356),
    [anon_sym_set] = ACTIONS(2356),
    [anon_sym_add] = ACTIONS(2356),
    [anon_sym_remove] = ACTIONS(2356),
    [anon_sym_delegate] = ACTIONS(2356),
    [anon_sym_var] = ACTIONS(2356),
    [sym_predefined_type] = ACTIONS(2356),
    [anon_sym_break] = ACTIONS(2356),
    [anon_sym_checked] = ACTIONS(2356),
    [anon_sym_unchecked] = ACTIONS(2356),
    [anon_sym_continue] = ACTIONS(2356),
    [anon_sym_do] = ACTIONS(2356),
    [anon_sym_while] = ACTIONS(2356),
    [anon_sym_for] = ACTIONS(2356),
    [anon_sym_await] = ACTIONS(2356),
    [anon_sym_foreach] = ACTIONS(2356),
    [anon_sym_goto] = ACTIONS(2356),
    [anon_sym_case] = ACTIONS(2356),
    [anon_sym_default] = ACTIONS(2356),
    [anon_sym_if] = ACTIONS(2356),
    [anon_sym_else] = ACTIONS(2356),
    [anon_sym_lock] = ACTIONS(2356),
    [anon_sym_switch] = ACTIONS(2356),
    [anon_sym_when] = ACTIONS(2356),
    [anon_sym_throw] = ACTIONS(2356),
    [anon_sym_try] = ACTIONS(2356),
    [anon_sym_yield] = ACTIONS(2356),
    [anon_sym_stackalloc] = ACTIONS(2356),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2354),
    [anon_sym_DQUOTE] = ACTIONS(2354),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2354),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2354),
    [anon_sym___makeref] = ACTIONS(2356),
    [anon_sym_from] = ACTIONS(2356),
    [anon_sym_join] = ACTIONS(2356),
    [anon_sym_on] = ACTIONS(2356),
    [anon_sym_equals] = ACTIONS(2356),
    [anon_sym_into] = ACTIONS(2356),
    [anon_sym_let] = ACTIONS(2356),
    [anon_sym_orderby] = ACTIONS(2356),
    [anon_sym_ascending] = ACTIONS(2356),
    [anon_sym_descending] = ACTIONS(2356),
    [anon_sym_group] = ACTIONS(2356),
    [anon_sym_by] = ACTIONS(2356),
    [anon_sym_select] = ACTIONS(2356),
    [anon_sym_DOT_DOT] = ACTIONS(2354),
    [anon_sym___reftype] = ACTIONS(2356),
    [anon_sym___refvalue] = ACTIONS(2356),
    [anon_sym_sizeof] = ACTIONS(2356),
    [anon_sym_typeof] = ACTIONS(2356),
    [anon_sym_SQUOTE] = ACTIONS(2354),
    [sym_integer_literal] = ACTIONS(2356),
    [sym_null_literal] = ACTIONS(2356),
    [sym_real_literal] = ACTIONS(2354),
    [sym_verbatim_string_literal] = ACTIONS(2354),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2356),
    [anon_sym_nameof] = ACTIONS(2356),
    [sym_void_keyword] = ACTIONS(2356),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1683] = {
    [sym__preprocessor_call] = STATE(1683),
    [sym__identifier_token] = ACTIONS(2406),
    [anon_sym_extern] = ACTIONS(2406),
    [anon_sym_alias] = ACTIONS(2406),
    [anon_sym_SEMI] = ACTIONS(2404),
    [anon_sym_global] = ACTIONS(2406),
    [anon_sym_using] = ACTIONS(2406),
    [anon_sym_static] = ACTIONS(2406),
    [anon_sym_LBRACK] = ACTIONS(2404),
    [anon_sym_return] = ACTIONS(2406),
    [anon_sym_LPAREN] = ACTIONS(2404),
    [anon_sym_abstract] = ACTIONS(2406),
    [anon_sym_async] = ACTIONS(2406),
    [anon_sym_const] = ACTIONS(2406),
    [anon_sym_fixed] = ACTIONS(2406),
    [anon_sym_internal] = ACTIONS(2406),
    [anon_sym_new] = ACTIONS(2406),
    [anon_sym_override] = ACTIONS(2406),
    [anon_sym_partial] = ACTIONS(2406),
    [anon_sym_private] = ACTIONS(2406),
    [anon_sym_protected] = ACTIONS(2406),
    [anon_sym_public] = ACTIONS(2406),
    [anon_sym_readonly] = ACTIONS(2406),
    [anon_sym_ref] = ACTIONS(2406),
    [anon_sym_sealed] = ACTIONS(2406),
    [anon_sym_unsafe] = ACTIONS(2406),
    [anon_sym_virtual] = ACTIONS(2406),
    [anon_sym_volatile] = ACTIONS(2406),
    [anon_sym_this] = ACTIONS(2406),
    [anon_sym_base] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2404),
    [anon_sym_RBRACE] = ACTIONS(2404),
    [anon_sym_TILDE] = ACTIONS(2404),
    [anon_sym_where] = ACTIONS(2406),
    [anon_sym_notnull] = ACTIONS(2406),
    [anon_sym_unmanaged] = ACTIONS(2406),
    [anon_sym_BANG] = ACTIONS(2404),
    [anon_sym_PLUS_PLUS] = ACTIONS(2404),
    [anon_sym_DASH_DASH] = ACTIONS(2404),
    [anon_sym_true] = ACTIONS(2406),
    [anon_sym_false] = ACTIONS(2406),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_STAR] = ACTIONS(2404),
    [anon_sym_CARET] = ACTIONS(2404),
    [anon_sym_AMP] = ACTIONS(2404),
    [anon_sym_get] = ACTIONS(2406),
    [anon_sym_set] = ACTIONS(2406),
    [anon_sym_add] = ACTIONS(2406),
    [anon_sym_remove] = ACTIONS(2406),
    [anon_sym_delegate] = ACTIONS(2406),
    [anon_sym_var] = ACTIONS(2406),
    [sym_predefined_type] = ACTIONS(2406),
    [anon_sym_break] = ACTIONS(2406),
    [anon_sym_checked] = ACTIONS(2406),
    [anon_sym_unchecked] = ACTIONS(2406),
    [anon_sym_continue] = ACTIONS(2406),
    [anon_sym_do] = ACTIONS(2406),
    [anon_sym_while] = ACTIONS(2406),
    [anon_sym_for] = ACTIONS(2406),
    [anon_sym_await] = ACTIONS(2406),
    [anon_sym_foreach] = ACTIONS(2406),
    [anon_sym_goto] = ACTIONS(2406),
    [anon_sym_case] = ACTIONS(2406),
    [anon_sym_default] = ACTIONS(2406),
    [anon_sym_if] = ACTIONS(2406),
    [anon_sym_else] = ACTIONS(2406),
    [anon_sym_lock] = ACTIONS(2406),
    [anon_sym_switch] = ACTIONS(2406),
    [anon_sym_when] = ACTIONS(2406),
    [anon_sym_throw] = ACTIONS(2406),
    [anon_sym_try] = ACTIONS(2406),
    [anon_sym_yield] = ACTIONS(2406),
    [anon_sym_stackalloc] = ACTIONS(2406),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2404),
    [anon_sym_DQUOTE] = ACTIONS(2404),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2404),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2404),
    [anon_sym___makeref] = ACTIONS(2406),
    [anon_sym_from] = ACTIONS(2406),
    [anon_sym_join] = ACTIONS(2406),
    [anon_sym_on] = ACTIONS(2406),
    [anon_sym_equals] = ACTIONS(2406),
    [anon_sym_into] = ACTIONS(2406),
    [anon_sym_let] = ACTIONS(2406),
    [anon_sym_orderby] = ACTIONS(2406),
    [anon_sym_ascending] = ACTIONS(2406),
    [anon_sym_descending] = ACTIONS(2406),
    [anon_sym_group] = ACTIONS(2406),
    [anon_sym_by] = ACTIONS(2406),
    [anon_sym_select] = ACTIONS(2406),
    [anon_sym_DOT_DOT] = ACTIONS(2404),
    [anon_sym___reftype] = ACTIONS(2406),
    [anon_sym___refvalue] = ACTIONS(2406),
    [anon_sym_sizeof] = ACTIONS(2406),
    [anon_sym_typeof] = ACTIONS(2406),
    [anon_sym_SQUOTE] = ACTIONS(2404),
    [sym_integer_literal] = ACTIONS(2406),
    [sym_null_literal] = ACTIONS(2406),
    [sym_real_literal] = ACTIONS(2404),
    [sym_verbatim_string_literal] = ACTIONS(2404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2406),
    [anon_sym_nameof] = ACTIONS(2406),
    [sym_void_keyword] = ACTIONS(2406),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1684] = {
    [sym__preprocessor_call] = STATE(1684),
    [sym__identifier_token] = ACTIONS(2458),
    [anon_sym_extern] = ACTIONS(2458),
    [anon_sym_alias] = ACTIONS(2458),
    [anon_sym_SEMI] = ACTIONS(2456),
    [anon_sym_global] = ACTIONS(2458),
    [anon_sym_using] = ACTIONS(2458),
    [anon_sym_static] = ACTIONS(2458),
    [anon_sym_LBRACK] = ACTIONS(2456),
    [anon_sym_return] = ACTIONS(2458),
    [anon_sym_LPAREN] = ACTIONS(2456),
    [anon_sym_abstract] = ACTIONS(2458),
    [anon_sym_async] = ACTIONS(2458),
    [anon_sym_const] = ACTIONS(2458),
    [anon_sym_fixed] = ACTIONS(2458),
    [anon_sym_internal] = ACTIONS(2458),
    [anon_sym_new] = ACTIONS(2458),
    [anon_sym_override] = ACTIONS(2458),
    [anon_sym_partial] = ACTIONS(2458),
    [anon_sym_private] = ACTIONS(2458),
    [anon_sym_protected] = ACTIONS(2458),
    [anon_sym_public] = ACTIONS(2458),
    [anon_sym_readonly] = ACTIONS(2458),
    [anon_sym_ref] = ACTIONS(2458),
    [anon_sym_sealed] = ACTIONS(2458),
    [anon_sym_unsafe] = ACTIONS(2458),
    [anon_sym_virtual] = ACTIONS(2458),
    [anon_sym_volatile] = ACTIONS(2458),
    [anon_sym_this] = ACTIONS(2458),
    [anon_sym_base] = ACTIONS(2458),
    [anon_sym_LBRACE] = ACTIONS(2456),
    [anon_sym_RBRACE] = ACTIONS(2456),
    [anon_sym_TILDE] = ACTIONS(2456),
    [anon_sym_where] = ACTIONS(2458),
    [anon_sym_notnull] = ACTIONS(2458),
    [anon_sym_unmanaged] = ACTIONS(2458),
    [anon_sym_BANG] = ACTIONS(2456),
    [anon_sym_PLUS_PLUS] = ACTIONS(2456),
    [anon_sym_DASH_DASH] = ACTIONS(2456),
    [anon_sym_true] = ACTIONS(2458),
    [anon_sym_false] = ACTIONS(2458),
    [anon_sym_PLUS] = ACTIONS(2458),
    [anon_sym_DASH] = ACTIONS(2458),
    [anon_sym_STAR] = ACTIONS(2456),
    [anon_sym_CARET] = ACTIONS(2456),
    [anon_sym_AMP] = ACTIONS(2456),
    [anon_sym_get] = ACTIONS(2458),
    [anon_sym_set] = ACTIONS(2458),
    [anon_sym_add] = ACTIONS(2458),
    [anon_sym_remove] = ACTIONS(2458),
    [anon_sym_delegate] = ACTIONS(2458),
    [anon_sym_var] = ACTIONS(2458),
    [sym_predefined_type] = ACTIONS(2458),
    [anon_sym_break] = ACTIONS(2458),
    [anon_sym_checked] = ACTIONS(2458),
    [anon_sym_unchecked] = ACTIONS(2458),
    [anon_sym_continue] = ACTIONS(2458),
    [anon_sym_do] = ACTIONS(2458),
    [anon_sym_while] = ACTIONS(2458),
    [anon_sym_for] = ACTIONS(2458),
    [anon_sym_await] = ACTIONS(2458),
    [anon_sym_foreach] = ACTIONS(2458),
    [anon_sym_goto] = ACTIONS(2458),
    [anon_sym_case] = ACTIONS(2458),
    [anon_sym_default] = ACTIONS(2458),
    [anon_sym_if] = ACTIONS(2458),
    [anon_sym_else] = ACTIONS(2458),
    [anon_sym_lock] = ACTIONS(2458),
    [anon_sym_switch] = ACTIONS(2458),
    [anon_sym_when] = ACTIONS(2458),
    [anon_sym_throw] = ACTIONS(2458),
    [anon_sym_try] = ACTIONS(2458),
    [anon_sym_yield] = ACTIONS(2458),
    [anon_sym_stackalloc] = ACTIONS(2458),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2456),
    [anon_sym_DQUOTE] = ACTIONS(2456),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2456),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2456),
    [anon_sym___makeref] = ACTIONS(2458),
    [anon_sym_from] = ACTIONS(2458),
    [anon_sym_join] = ACTIONS(2458),
    [anon_sym_on] = ACTIONS(2458),
    [anon_sym_equals] = ACTIONS(2458),
    [anon_sym_into] = ACTIONS(2458),
    [anon_sym_let] = ACTIONS(2458),
    [anon_sym_orderby] = ACTIONS(2458),
    [anon_sym_ascending] = ACTIONS(2458),
    [anon_sym_descending] = ACTIONS(2458),
    [anon_sym_group] = ACTIONS(2458),
    [anon_sym_by] = ACTIONS(2458),
    [anon_sym_select] = ACTIONS(2458),
    [anon_sym_DOT_DOT] = ACTIONS(2456),
    [anon_sym___reftype] = ACTIONS(2458),
    [anon_sym___refvalue] = ACTIONS(2458),
    [anon_sym_sizeof] = ACTIONS(2458),
    [anon_sym_typeof] = ACTIONS(2458),
    [anon_sym_SQUOTE] = ACTIONS(2456),
    [sym_integer_literal] = ACTIONS(2458),
    [sym_null_literal] = ACTIONS(2458),
    [sym_real_literal] = ACTIONS(2456),
    [sym_verbatim_string_literal] = ACTIONS(2456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2458),
    [anon_sym_nameof] = ACTIONS(2458),
    [sym_void_keyword] = ACTIONS(2458),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1685] = {
    [sym__preprocessor_call] = STATE(1685),
    [sym__identifier_token] = ACTIONS(2324),
    [anon_sym_extern] = ACTIONS(2324),
    [anon_sym_alias] = ACTIONS(2324),
    [anon_sym_SEMI] = ACTIONS(2322),
    [anon_sym_global] = ACTIONS(2324),
    [anon_sym_using] = ACTIONS(2324),
    [anon_sym_static] = ACTIONS(2324),
    [anon_sym_LBRACK] = ACTIONS(2322),
    [anon_sym_return] = ACTIONS(2324),
    [anon_sym_LPAREN] = ACTIONS(2322),
    [anon_sym_abstract] = ACTIONS(2324),
    [anon_sym_async] = ACTIONS(2324),
    [anon_sym_const] = ACTIONS(2324),
    [anon_sym_fixed] = ACTIONS(2324),
    [anon_sym_internal] = ACTIONS(2324),
    [anon_sym_new] = ACTIONS(2324),
    [anon_sym_override] = ACTIONS(2324),
    [anon_sym_partial] = ACTIONS(2324),
    [anon_sym_private] = ACTIONS(2324),
    [anon_sym_protected] = ACTIONS(2324),
    [anon_sym_public] = ACTIONS(2324),
    [anon_sym_readonly] = ACTIONS(2324),
    [anon_sym_ref] = ACTIONS(2324),
    [anon_sym_sealed] = ACTIONS(2324),
    [anon_sym_unsafe] = ACTIONS(2324),
    [anon_sym_virtual] = ACTIONS(2324),
    [anon_sym_volatile] = ACTIONS(2324),
    [anon_sym_this] = ACTIONS(2324),
    [anon_sym_base] = ACTIONS(2324),
    [anon_sym_LBRACE] = ACTIONS(2322),
    [anon_sym_RBRACE] = ACTIONS(2322),
    [anon_sym_TILDE] = ACTIONS(2322),
    [anon_sym_where] = ACTIONS(2324),
    [anon_sym_notnull] = ACTIONS(2324),
    [anon_sym_unmanaged] = ACTIONS(2324),
    [anon_sym_BANG] = ACTIONS(2322),
    [anon_sym_PLUS_PLUS] = ACTIONS(2322),
    [anon_sym_DASH_DASH] = ACTIONS(2322),
    [anon_sym_true] = ACTIONS(2324),
    [anon_sym_false] = ACTIONS(2324),
    [anon_sym_PLUS] = ACTIONS(2324),
    [anon_sym_DASH] = ACTIONS(2324),
    [anon_sym_STAR] = ACTIONS(2322),
    [anon_sym_CARET] = ACTIONS(2322),
    [anon_sym_AMP] = ACTIONS(2322),
    [anon_sym_get] = ACTIONS(2324),
    [anon_sym_set] = ACTIONS(2324),
    [anon_sym_add] = ACTIONS(2324),
    [anon_sym_remove] = ACTIONS(2324),
    [anon_sym_delegate] = ACTIONS(2324),
    [anon_sym_var] = ACTIONS(2324),
    [sym_predefined_type] = ACTIONS(2324),
    [anon_sym_break] = ACTIONS(2324),
    [anon_sym_checked] = ACTIONS(2324),
    [anon_sym_unchecked] = ACTIONS(2324),
    [anon_sym_continue] = ACTIONS(2324),
    [anon_sym_do] = ACTIONS(2324),
    [anon_sym_while] = ACTIONS(2324),
    [anon_sym_for] = ACTIONS(2324),
    [anon_sym_await] = ACTIONS(2324),
    [anon_sym_foreach] = ACTIONS(2324),
    [anon_sym_goto] = ACTIONS(2324),
    [anon_sym_case] = ACTIONS(2324),
    [anon_sym_default] = ACTIONS(2324),
    [anon_sym_if] = ACTIONS(2324),
    [anon_sym_else] = ACTIONS(2324),
    [anon_sym_lock] = ACTIONS(2324),
    [anon_sym_switch] = ACTIONS(2324),
    [anon_sym_when] = ACTIONS(2324),
    [anon_sym_throw] = ACTIONS(2324),
    [anon_sym_try] = ACTIONS(2324),
    [anon_sym_yield] = ACTIONS(2324),
    [anon_sym_stackalloc] = ACTIONS(2324),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2322),
    [anon_sym_DQUOTE] = ACTIONS(2322),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2322),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2322),
    [anon_sym___makeref] = ACTIONS(2324),
    [anon_sym_from] = ACTIONS(2324),
    [anon_sym_join] = ACTIONS(2324),
    [anon_sym_on] = ACTIONS(2324),
    [anon_sym_equals] = ACTIONS(2324),
    [anon_sym_into] = ACTIONS(2324),
    [anon_sym_let] = ACTIONS(2324),
    [anon_sym_orderby] = ACTIONS(2324),
    [anon_sym_ascending] = ACTIONS(2324),
    [anon_sym_descending] = ACTIONS(2324),
    [anon_sym_group] = ACTIONS(2324),
    [anon_sym_by] = ACTIONS(2324),
    [anon_sym_select] = ACTIONS(2324),
    [anon_sym_DOT_DOT] = ACTIONS(2322),
    [anon_sym___reftype] = ACTIONS(2324),
    [anon_sym___refvalue] = ACTIONS(2324),
    [anon_sym_sizeof] = ACTIONS(2324),
    [anon_sym_typeof] = ACTIONS(2324),
    [anon_sym_SQUOTE] = ACTIONS(2322),
    [sym_integer_literal] = ACTIONS(2324),
    [sym_null_literal] = ACTIONS(2324),
    [sym_real_literal] = ACTIONS(2322),
    [sym_verbatim_string_literal] = ACTIONS(2322),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2324),
    [anon_sym_nameof] = ACTIONS(2324),
    [sym_void_keyword] = ACTIONS(2324),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1686] = {
    [sym__preprocessor_call] = STATE(1686),
    [sym__identifier_token] = ACTIONS(2474),
    [anon_sym_extern] = ACTIONS(2474),
    [anon_sym_alias] = ACTIONS(2474),
    [anon_sym_SEMI] = ACTIONS(2472),
    [anon_sym_global] = ACTIONS(2474),
    [anon_sym_using] = ACTIONS(2474),
    [anon_sym_static] = ACTIONS(2474),
    [anon_sym_LBRACK] = ACTIONS(2472),
    [anon_sym_return] = ACTIONS(2474),
    [anon_sym_LPAREN] = ACTIONS(2472),
    [anon_sym_abstract] = ACTIONS(2474),
    [anon_sym_async] = ACTIONS(2474),
    [anon_sym_const] = ACTIONS(2474),
    [anon_sym_fixed] = ACTIONS(2474),
    [anon_sym_internal] = ACTIONS(2474),
    [anon_sym_new] = ACTIONS(2474),
    [anon_sym_override] = ACTIONS(2474),
    [anon_sym_partial] = ACTIONS(2474),
    [anon_sym_private] = ACTIONS(2474),
    [anon_sym_protected] = ACTIONS(2474),
    [anon_sym_public] = ACTIONS(2474),
    [anon_sym_readonly] = ACTIONS(2474),
    [anon_sym_ref] = ACTIONS(2474),
    [anon_sym_sealed] = ACTIONS(2474),
    [anon_sym_unsafe] = ACTIONS(2474),
    [anon_sym_virtual] = ACTIONS(2474),
    [anon_sym_volatile] = ACTIONS(2474),
    [anon_sym_this] = ACTIONS(2474),
    [anon_sym_base] = ACTIONS(2474),
    [anon_sym_LBRACE] = ACTIONS(2472),
    [anon_sym_RBRACE] = ACTIONS(2472),
    [anon_sym_TILDE] = ACTIONS(2472),
    [anon_sym_where] = ACTIONS(2474),
    [anon_sym_notnull] = ACTIONS(2474),
    [anon_sym_unmanaged] = ACTIONS(2474),
    [anon_sym_BANG] = ACTIONS(2472),
    [anon_sym_PLUS_PLUS] = ACTIONS(2472),
    [anon_sym_DASH_DASH] = ACTIONS(2472),
    [anon_sym_true] = ACTIONS(2474),
    [anon_sym_false] = ACTIONS(2474),
    [anon_sym_PLUS] = ACTIONS(2474),
    [anon_sym_DASH] = ACTIONS(2474),
    [anon_sym_STAR] = ACTIONS(2472),
    [anon_sym_CARET] = ACTIONS(2472),
    [anon_sym_AMP] = ACTIONS(2472),
    [anon_sym_get] = ACTIONS(2474),
    [anon_sym_set] = ACTIONS(2474),
    [anon_sym_add] = ACTIONS(2474),
    [anon_sym_remove] = ACTIONS(2474),
    [anon_sym_delegate] = ACTIONS(2474),
    [anon_sym_var] = ACTIONS(2474),
    [sym_predefined_type] = ACTIONS(2474),
    [anon_sym_break] = ACTIONS(2474),
    [anon_sym_checked] = ACTIONS(2474),
    [anon_sym_unchecked] = ACTIONS(2474),
    [anon_sym_continue] = ACTIONS(2474),
    [anon_sym_do] = ACTIONS(2474),
    [anon_sym_while] = ACTIONS(2474),
    [anon_sym_for] = ACTIONS(2474),
    [anon_sym_await] = ACTIONS(2474),
    [anon_sym_foreach] = ACTIONS(2474),
    [anon_sym_goto] = ACTIONS(2474),
    [anon_sym_case] = ACTIONS(2474),
    [anon_sym_default] = ACTIONS(2474),
    [anon_sym_if] = ACTIONS(2474),
    [anon_sym_else] = ACTIONS(2474),
    [anon_sym_lock] = ACTIONS(2474),
    [anon_sym_switch] = ACTIONS(2474),
    [anon_sym_when] = ACTIONS(2474),
    [anon_sym_throw] = ACTIONS(2474),
    [anon_sym_try] = ACTIONS(2474),
    [anon_sym_yield] = ACTIONS(2474),
    [anon_sym_stackalloc] = ACTIONS(2474),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2472),
    [anon_sym_DQUOTE] = ACTIONS(2472),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2472),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2472),
    [anon_sym___makeref] = ACTIONS(2474),
    [anon_sym_from] = ACTIONS(2474),
    [anon_sym_join] = ACTIONS(2474),
    [anon_sym_on] = ACTIONS(2474),
    [anon_sym_equals] = ACTIONS(2474),
    [anon_sym_into] = ACTIONS(2474),
    [anon_sym_let] = ACTIONS(2474),
    [anon_sym_orderby] = ACTIONS(2474),
    [anon_sym_ascending] = ACTIONS(2474),
    [anon_sym_descending] = ACTIONS(2474),
    [anon_sym_group] = ACTIONS(2474),
    [anon_sym_by] = ACTIONS(2474),
    [anon_sym_select] = ACTIONS(2474),
    [anon_sym_DOT_DOT] = ACTIONS(2472),
    [anon_sym___reftype] = ACTIONS(2474),
    [anon_sym___refvalue] = ACTIONS(2474),
    [anon_sym_sizeof] = ACTIONS(2474),
    [anon_sym_typeof] = ACTIONS(2474),
    [anon_sym_SQUOTE] = ACTIONS(2472),
    [sym_integer_literal] = ACTIONS(2474),
    [sym_null_literal] = ACTIONS(2474),
    [sym_real_literal] = ACTIONS(2472),
    [sym_verbatim_string_literal] = ACTIONS(2472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2474),
    [anon_sym_nameof] = ACTIONS(2474),
    [sym_void_keyword] = ACTIONS(2474),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1687] = {
    [sym__preprocessor_call] = STATE(1687),
    [sym__identifier_token] = ACTIONS(2280),
    [anon_sym_extern] = ACTIONS(2280),
    [anon_sym_alias] = ACTIONS(2280),
    [anon_sym_SEMI] = ACTIONS(2278),
    [anon_sym_global] = ACTIONS(2280),
    [anon_sym_using] = ACTIONS(2280),
    [anon_sym_static] = ACTIONS(2280),
    [anon_sym_LBRACK] = ACTIONS(2278),
    [anon_sym_return] = ACTIONS(2280),
    [anon_sym_LPAREN] = ACTIONS(2278),
    [anon_sym_abstract] = ACTIONS(2280),
    [anon_sym_async] = ACTIONS(2280),
    [anon_sym_const] = ACTIONS(2280),
    [anon_sym_fixed] = ACTIONS(2280),
    [anon_sym_internal] = ACTIONS(2280),
    [anon_sym_new] = ACTIONS(2280),
    [anon_sym_override] = ACTIONS(2280),
    [anon_sym_partial] = ACTIONS(2280),
    [anon_sym_private] = ACTIONS(2280),
    [anon_sym_protected] = ACTIONS(2280),
    [anon_sym_public] = ACTIONS(2280),
    [anon_sym_readonly] = ACTIONS(2280),
    [anon_sym_ref] = ACTIONS(2280),
    [anon_sym_sealed] = ACTIONS(2280),
    [anon_sym_unsafe] = ACTIONS(2280),
    [anon_sym_virtual] = ACTIONS(2280),
    [anon_sym_volatile] = ACTIONS(2280),
    [anon_sym_this] = ACTIONS(2280),
    [anon_sym_base] = ACTIONS(2280),
    [anon_sym_LBRACE] = ACTIONS(2278),
    [anon_sym_RBRACE] = ACTIONS(2278),
    [anon_sym_TILDE] = ACTIONS(2278),
    [anon_sym_where] = ACTIONS(2280),
    [anon_sym_notnull] = ACTIONS(2280),
    [anon_sym_unmanaged] = ACTIONS(2280),
    [anon_sym_BANG] = ACTIONS(2278),
    [anon_sym_PLUS_PLUS] = ACTIONS(2278),
    [anon_sym_DASH_DASH] = ACTIONS(2278),
    [anon_sym_true] = ACTIONS(2280),
    [anon_sym_false] = ACTIONS(2280),
    [anon_sym_PLUS] = ACTIONS(2280),
    [anon_sym_DASH] = ACTIONS(2280),
    [anon_sym_STAR] = ACTIONS(2278),
    [anon_sym_CARET] = ACTIONS(2278),
    [anon_sym_AMP] = ACTIONS(2278),
    [anon_sym_get] = ACTIONS(2280),
    [anon_sym_set] = ACTIONS(2280),
    [anon_sym_add] = ACTIONS(2280),
    [anon_sym_remove] = ACTIONS(2280),
    [anon_sym_delegate] = ACTIONS(2280),
    [anon_sym_var] = ACTIONS(2280),
    [sym_predefined_type] = ACTIONS(2280),
    [anon_sym_break] = ACTIONS(2280),
    [anon_sym_checked] = ACTIONS(2280),
    [anon_sym_unchecked] = ACTIONS(2280),
    [anon_sym_continue] = ACTIONS(2280),
    [anon_sym_do] = ACTIONS(2280),
    [anon_sym_while] = ACTIONS(2280),
    [anon_sym_for] = ACTIONS(2280),
    [anon_sym_await] = ACTIONS(2280),
    [anon_sym_foreach] = ACTIONS(2280),
    [anon_sym_goto] = ACTIONS(2280),
    [anon_sym_case] = ACTIONS(2280),
    [anon_sym_default] = ACTIONS(2280),
    [anon_sym_if] = ACTIONS(2280),
    [anon_sym_else] = ACTIONS(2280),
    [anon_sym_lock] = ACTIONS(2280),
    [anon_sym_switch] = ACTIONS(2280),
    [anon_sym_when] = ACTIONS(2280),
    [anon_sym_throw] = ACTIONS(2280),
    [anon_sym_try] = ACTIONS(2280),
    [anon_sym_yield] = ACTIONS(2280),
    [anon_sym_stackalloc] = ACTIONS(2280),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2278),
    [anon_sym_DQUOTE] = ACTIONS(2278),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2278),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2278),
    [anon_sym___makeref] = ACTIONS(2280),
    [anon_sym_from] = ACTIONS(2280),
    [anon_sym_join] = ACTIONS(2280),
    [anon_sym_on] = ACTIONS(2280),
    [anon_sym_equals] = ACTIONS(2280),
    [anon_sym_into] = ACTIONS(2280),
    [anon_sym_let] = ACTIONS(2280),
    [anon_sym_orderby] = ACTIONS(2280),
    [anon_sym_ascending] = ACTIONS(2280),
    [anon_sym_descending] = ACTIONS(2280),
    [anon_sym_group] = ACTIONS(2280),
    [anon_sym_by] = ACTIONS(2280),
    [anon_sym_select] = ACTIONS(2280),
    [anon_sym_DOT_DOT] = ACTIONS(2278),
    [anon_sym___reftype] = ACTIONS(2280),
    [anon_sym___refvalue] = ACTIONS(2280),
    [anon_sym_sizeof] = ACTIONS(2280),
    [anon_sym_typeof] = ACTIONS(2280),
    [anon_sym_SQUOTE] = ACTIONS(2278),
    [sym_integer_literal] = ACTIONS(2280),
    [sym_null_literal] = ACTIONS(2280),
    [sym_real_literal] = ACTIONS(2278),
    [sym_verbatim_string_literal] = ACTIONS(2278),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2280),
    [anon_sym_nameof] = ACTIONS(2280),
    [sym_void_keyword] = ACTIONS(2280),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1688] = {
    [sym__preprocessor_call] = STATE(1688),
    [sym__identifier_token] = ACTIONS(2284),
    [anon_sym_extern] = ACTIONS(2284),
    [anon_sym_alias] = ACTIONS(2284),
    [anon_sym_SEMI] = ACTIONS(2282),
    [anon_sym_global] = ACTIONS(2284),
    [anon_sym_using] = ACTIONS(2284),
    [anon_sym_static] = ACTIONS(2284),
    [anon_sym_LBRACK] = ACTIONS(2282),
    [anon_sym_return] = ACTIONS(2284),
    [anon_sym_LPAREN] = ACTIONS(2282),
    [anon_sym_abstract] = ACTIONS(2284),
    [anon_sym_async] = ACTIONS(2284),
    [anon_sym_const] = ACTIONS(2284),
    [anon_sym_fixed] = ACTIONS(2284),
    [anon_sym_internal] = ACTIONS(2284),
    [anon_sym_new] = ACTIONS(2284),
    [anon_sym_override] = ACTIONS(2284),
    [anon_sym_partial] = ACTIONS(2284),
    [anon_sym_private] = ACTIONS(2284),
    [anon_sym_protected] = ACTIONS(2284),
    [anon_sym_public] = ACTIONS(2284),
    [anon_sym_readonly] = ACTIONS(2284),
    [anon_sym_ref] = ACTIONS(2284),
    [anon_sym_sealed] = ACTIONS(2284),
    [anon_sym_unsafe] = ACTIONS(2284),
    [anon_sym_virtual] = ACTIONS(2284),
    [anon_sym_volatile] = ACTIONS(2284),
    [anon_sym_this] = ACTIONS(2284),
    [anon_sym_base] = ACTIONS(2284),
    [anon_sym_LBRACE] = ACTIONS(2282),
    [anon_sym_RBRACE] = ACTIONS(2282),
    [anon_sym_TILDE] = ACTIONS(2282),
    [anon_sym_where] = ACTIONS(2284),
    [anon_sym_notnull] = ACTIONS(2284),
    [anon_sym_unmanaged] = ACTIONS(2284),
    [anon_sym_BANG] = ACTIONS(2282),
    [anon_sym_PLUS_PLUS] = ACTIONS(2282),
    [anon_sym_DASH_DASH] = ACTIONS(2282),
    [anon_sym_true] = ACTIONS(2284),
    [anon_sym_false] = ACTIONS(2284),
    [anon_sym_PLUS] = ACTIONS(2284),
    [anon_sym_DASH] = ACTIONS(2284),
    [anon_sym_STAR] = ACTIONS(2282),
    [anon_sym_CARET] = ACTIONS(2282),
    [anon_sym_AMP] = ACTIONS(2282),
    [anon_sym_get] = ACTIONS(2284),
    [anon_sym_set] = ACTIONS(2284),
    [anon_sym_add] = ACTIONS(2284),
    [anon_sym_remove] = ACTIONS(2284),
    [anon_sym_delegate] = ACTIONS(2284),
    [anon_sym_var] = ACTIONS(2284),
    [sym_predefined_type] = ACTIONS(2284),
    [anon_sym_break] = ACTIONS(2284),
    [anon_sym_checked] = ACTIONS(2284),
    [anon_sym_unchecked] = ACTIONS(2284),
    [anon_sym_continue] = ACTIONS(2284),
    [anon_sym_do] = ACTIONS(2284),
    [anon_sym_while] = ACTIONS(2284),
    [anon_sym_for] = ACTIONS(2284),
    [anon_sym_await] = ACTIONS(2284),
    [anon_sym_foreach] = ACTIONS(2284),
    [anon_sym_goto] = ACTIONS(2284),
    [anon_sym_case] = ACTIONS(2284),
    [anon_sym_default] = ACTIONS(2284),
    [anon_sym_if] = ACTIONS(2284),
    [anon_sym_else] = ACTIONS(2284),
    [anon_sym_lock] = ACTIONS(2284),
    [anon_sym_switch] = ACTIONS(2284),
    [anon_sym_when] = ACTIONS(2284),
    [anon_sym_throw] = ACTIONS(2284),
    [anon_sym_try] = ACTIONS(2284),
    [anon_sym_yield] = ACTIONS(2284),
    [anon_sym_stackalloc] = ACTIONS(2284),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2282),
    [anon_sym_DQUOTE] = ACTIONS(2282),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2282),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2282),
    [anon_sym___makeref] = ACTIONS(2284),
    [anon_sym_from] = ACTIONS(2284),
    [anon_sym_join] = ACTIONS(2284),
    [anon_sym_on] = ACTIONS(2284),
    [anon_sym_equals] = ACTIONS(2284),
    [anon_sym_into] = ACTIONS(2284),
    [anon_sym_let] = ACTIONS(2284),
    [anon_sym_orderby] = ACTIONS(2284),
    [anon_sym_ascending] = ACTIONS(2284),
    [anon_sym_descending] = ACTIONS(2284),
    [anon_sym_group] = ACTIONS(2284),
    [anon_sym_by] = ACTIONS(2284),
    [anon_sym_select] = ACTIONS(2284),
    [anon_sym_DOT_DOT] = ACTIONS(2282),
    [anon_sym___reftype] = ACTIONS(2284),
    [anon_sym___refvalue] = ACTIONS(2284),
    [anon_sym_sizeof] = ACTIONS(2284),
    [anon_sym_typeof] = ACTIONS(2284),
    [anon_sym_SQUOTE] = ACTIONS(2282),
    [sym_integer_literal] = ACTIONS(2284),
    [sym_null_literal] = ACTIONS(2284),
    [sym_real_literal] = ACTIONS(2282),
    [sym_verbatim_string_literal] = ACTIONS(2282),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2284),
    [anon_sym_nameof] = ACTIONS(2284),
    [sym_void_keyword] = ACTIONS(2284),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1689] = {
    [sym__preprocessor_call] = STATE(1689),
    [sym__identifier_token] = ACTIONS(2332),
    [anon_sym_extern] = ACTIONS(2332),
    [anon_sym_alias] = ACTIONS(2332),
    [anon_sym_SEMI] = ACTIONS(2330),
    [anon_sym_global] = ACTIONS(2332),
    [anon_sym_using] = ACTIONS(2332),
    [anon_sym_static] = ACTIONS(2332),
    [anon_sym_LBRACK] = ACTIONS(2330),
    [anon_sym_return] = ACTIONS(2332),
    [anon_sym_LPAREN] = ACTIONS(2330),
    [anon_sym_abstract] = ACTIONS(2332),
    [anon_sym_async] = ACTIONS(2332),
    [anon_sym_const] = ACTIONS(2332),
    [anon_sym_fixed] = ACTIONS(2332),
    [anon_sym_internal] = ACTIONS(2332),
    [anon_sym_new] = ACTIONS(2332),
    [anon_sym_override] = ACTIONS(2332),
    [anon_sym_partial] = ACTIONS(2332),
    [anon_sym_private] = ACTIONS(2332),
    [anon_sym_protected] = ACTIONS(2332),
    [anon_sym_public] = ACTIONS(2332),
    [anon_sym_readonly] = ACTIONS(2332),
    [anon_sym_ref] = ACTIONS(2332),
    [anon_sym_sealed] = ACTIONS(2332),
    [anon_sym_unsafe] = ACTIONS(2332),
    [anon_sym_virtual] = ACTIONS(2332),
    [anon_sym_volatile] = ACTIONS(2332),
    [anon_sym_this] = ACTIONS(2332),
    [anon_sym_base] = ACTIONS(2332),
    [anon_sym_LBRACE] = ACTIONS(2330),
    [anon_sym_RBRACE] = ACTIONS(2330),
    [anon_sym_TILDE] = ACTIONS(2330),
    [anon_sym_where] = ACTIONS(2332),
    [anon_sym_notnull] = ACTIONS(2332),
    [anon_sym_unmanaged] = ACTIONS(2332),
    [anon_sym_BANG] = ACTIONS(2330),
    [anon_sym_PLUS_PLUS] = ACTIONS(2330),
    [anon_sym_DASH_DASH] = ACTIONS(2330),
    [anon_sym_true] = ACTIONS(2332),
    [anon_sym_false] = ACTIONS(2332),
    [anon_sym_PLUS] = ACTIONS(2332),
    [anon_sym_DASH] = ACTIONS(2332),
    [anon_sym_STAR] = ACTIONS(2330),
    [anon_sym_CARET] = ACTIONS(2330),
    [anon_sym_AMP] = ACTIONS(2330),
    [anon_sym_get] = ACTIONS(2332),
    [anon_sym_set] = ACTIONS(2332),
    [anon_sym_add] = ACTIONS(2332),
    [anon_sym_remove] = ACTIONS(2332),
    [anon_sym_delegate] = ACTIONS(2332),
    [anon_sym_var] = ACTIONS(2332),
    [sym_predefined_type] = ACTIONS(2332),
    [anon_sym_break] = ACTIONS(2332),
    [anon_sym_checked] = ACTIONS(2332),
    [anon_sym_unchecked] = ACTIONS(2332),
    [anon_sym_continue] = ACTIONS(2332),
    [anon_sym_do] = ACTIONS(2332),
    [anon_sym_while] = ACTIONS(2332),
    [anon_sym_for] = ACTIONS(2332),
    [anon_sym_await] = ACTIONS(2332),
    [anon_sym_foreach] = ACTIONS(2332),
    [anon_sym_goto] = ACTIONS(2332),
    [anon_sym_case] = ACTIONS(2332),
    [anon_sym_default] = ACTIONS(2332),
    [anon_sym_if] = ACTIONS(2332),
    [anon_sym_else] = ACTIONS(2332),
    [anon_sym_lock] = ACTIONS(2332),
    [anon_sym_switch] = ACTIONS(2332),
    [anon_sym_when] = ACTIONS(2332),
    [anon_sym_throw] = ACTIONS(2332),
    [anon_sym_try] = ACTIONS(2332),
    [anon_sym_yield] = ACTIONS(2332),
    [anon_sym_stackalloc] = ACTIONS(2332),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2330),
    [anon_sym_DQUOTE] = ACTIONS(2330),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2330),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2330),
    [anon_sym___makeref] = ACTIONS(2332),
    [anon_sym_from] = ACTIONS(2332),
    [anon_sym_join] = ACTIONS(2332),
    [anon_sym_on] = ACTIONS(2332),
    [anon_sym_equals] = ACTIONS(2332),
    [anon_sym_into] = ACTIONS(2332),
    [anon_sym_let] = ACTIONS(2332),
    [anon_sym_orderby] = ACTIONS(2332),
    [anon_sym_ascending] = ACTIONS(2332),
    [anon_sym_descending] = ACTIONS(2332),
    [anon_sym_group] = ACTIONS(2332),
    [anon_sym_by] = ACTIONS(2332),
    [anon_sym_select] = ACTIONS(2332),
    [anon_sym_DOT_DOT] = ACTIONS(2330),
    [anon_sym___reftype] = ACTIONS(2332),
    [anon_sym___refvalue] = ACTIONS(2332),
    [anon_sym_sizeof] = ACTIONS(2332),
    [anon_sym_typeof] = ACTIONS(2332),
    [anon_sym_SQUOTE] = ACTIONS(2330),
    [sym_integer_literal] = ACTIONS(2332),
    [sym_null_literal] = ACTIONS(2332),
    [sym_real_literal] = ACTIONS(2330),
    [sym_verbatim_string_literal] = ACTIONS(2330),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2332),
    [anon_sym_nameof] = ACTIONS(2332),
    [sym_void_keyword] = ACTIONS(2332),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1690] = {
    [sym__preprocessor_call] = STATE(1690),
    [sym__identifier_token] = ACTIONS(2260),
    [anon_sym_extern] = ACTIONS(2260),
    [anon_sym_alias] = ACTIONS(2260),
    [anon_sym_SEMI] = ACTIONS(2258),
    [anon_sym_global] = ACTIONS(2260),
    [anon_sym_using] = ACTIONS(2260),
    [anon_sym_static] = ACTIONS(2260),
    [anon_sym_LBRACK] = ACTIONS(2258),
    [anon_sym_return] = ACTIONS(2260),
    [anon_sym_LPAREN] = ACTIONS(2258),
    [anon_sym_abstract] = ACTIONS(2260),
    [anon_sym_async] = ACTIONS(2260),
    [anon_sym_const] = ACTIONS(2260),
    [anon_sym_fixed] = ACTIONS(2260),
    [anon_sym_internal] = ACTIONS(2260),
    [anon_sym_new] = ACTIONS(2260),
    [anon_sym_override] = ACTIONS(2260),
    [anon_sym_partial] = ACTIONS(2260),
    [anon_sym_private] = ACTIONS(2260),
    [anon_sym_protected] = ACTIONS(2260),
    [anon_sym_public] = ACTIONS(2260),
    [anon_sym_readonly] = ACTIONS(2260),
    [anon_sym_ref] = ACTIONS(2260),
    [anon_sym_sealed] = ACTIONS(2260),
    [anon_sym_unsafe] = ACTIONS(2260),
    [anon_sym_virtual] = ACTIONS(2260),
    [anon_sym_volatile] = ACTIONS(2260),
    [anon_sym_this] = ACTIONS(2260),
    [anon_sym_base] = ACTIONS(2260),
    [anon_sym_LBRACE] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2258),
    [anon_sym_TILDE] = ACTIONS(2258),
    [anon_sym_where] = ACTIONS(2260),
    [anon_sym_notnull] = ACTIONS(2260),
    [anon_sym_unmanaged] = ACTIONS(2260),
    [anon_sym_BANG] = ACTIONS(2258),
    [anon_sym_PLUS_PLUS] = ACTIONS(2258),
    [anon_sym_DASH_DASH] = ACTIONS(2258),
    [anon_sym_true] = ACTIONS(2260),
    [anon_sym_false] = ACTIONS(2260),
    [anon_sym_PLUS] = ACTIONS(2260),
    [anon_sym_DASH] = ACTIONS(2260),
    [anon_sym_STAR] = ACTIONS(2258),
    [anon_sym_CARET] = ACTIONS(2258),
    [anon_sym_AMP] = ACTIONS(2258),
    [anon_sym_get] = ACTIONS(2260),
    [anon_sym_set] = ACTIONS(2260),
    [anon_sym_add] = ACTIONS(2260),
    [anon_sym_remove] = ACTIONS(2260),
    [anon_sym_delegate] = ACTIONS(2260),
    [anon_sym_var] = ACTIONS(2260),
    [sym_predefined_type] = ACTIONS(2260),
    [anon_sym_break] = ACTIONS(2260),
    [anon_sym_checked] = ACTIONS(2260),
    [anon_sym_unchecked] = ACTIONS(2260),
    [anon_sym_continue] = ACTIONS(2260),
    [anon_sym_do] = ACTIONS(2260),
    [anon_sym_while] = ACTIONS(2260),
    [anon_sym_for] = ACTIONS(2260),
    [anon_sym_await] = ACTIONS(2260),
    [anon_sym_foreach] = ACTIONS(2260),
    [anon_sym_goto] = ACTIONS(2260),
    [anon_sym_case] = ACTIONS(2260),
    [anon_sym_default] = ACTIONS(2260),
    [anon_sym_if] = ACTIONS(2260),
    [anon_sym_else] = ACTIONS(2260),
    [anon_sym_lock] = ACTIONS(2260),
    [anon_sym_switch] = ACTIONS(2260),
    [anon_sym_when] = ACTIONS(2260),
    [anon_sym_throw] = ACTIONS(2260),
    [anon_sym_try] = ACTIONS(2260),
    [anon_sym_yield] = ACTIONS(2260),
    [anon_sym_stackalloc] = ACTIONS(2260),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2258),
    [anon_sym_DQUOTE] = ACTIONS(2258),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2258),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2258),
    [anon_sym___makeref] = ACTIONS(2260),
    [anon_sym_from] = ACTIONS(2260),
    [anon_sym_join] = ACTIONS(2260),
    [anon_sym_on] = ACTIONS(2260),
    [anon_sym_equals] = ACTIONS(2260),
    [anon_sym_into] = ACTIONS(2260),
    [anon_sym_let] = ACTIONS(2260),
    [anon_sym_orderby] = ACTIONS(2260),
    [anon_sym_ascending] = ACTIONS(2260),
    [anon_sym_descending] = ACTIONS(2260),
    [anon_sym_group] = ACTIONS(2260),
    [anon_sym_by] = ACTIONS(2260),
    [anon_sym_select] = ACTIONS(2260),
    [anon_sym_DOT_DOT] = ACTIONS(2258),
    [anon_sym___reftype] = ACTIONS(2260),
    [anon_sym___refvalue] = ACTIONS(2260),
    [anon_sym_sizeof] = ACTIONS(2260),
    [anon_sym_typeof] = ACTIONS(2260),
    [anon_sym_SQUOTE] = ACTIONS(2258),
    [sym_integer_literal] = ACTIONS(2260),
    [sym_null_literal] = ACTIONS(2260),
    [sym_real_literal] = ACTIONS(2258),
    [sym_verbatim_string_literal] = ACTIONS(2258),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2260),
    [anon_sym_nameof] = ACTIONS(2260),
    [sym_void_keyword] = ACTIONS(2260),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1691] = {
    [sym__preprocessor_call] = STATE(1691),
    [sym__identifier_token] = ACTIONS(2388),
    [anon_sym_extern] = ACTIONS(2388),
    [anon_sym_alias] = ACTIONS(2388),
    [anon_sym_SEMI] = ACTIONS(2386),
    [anon_sym_global] = ACTIONS(2388),
    [anon_sym_using] = ACTIONS(2388),
    [anon_sym_static] = ACTIONS(2388),
    [anon_sym_LBRACK] = ACTIONS(2386),
    [anon_sym_return] = ACTIONS(2388),
    [anon_sym_LPAREN] = ACTIONS(2386),
    [anon_sym_abstract] = ACTIONS(2388),
    [anon_sym_async] = ACTIONS(2388),
    [anon_sym_const] = ACTIONS(2388),
    [anon_sym_fixed] = ACTIONS(2388),
    [anon_sym_internal] = ACTIONS(2388),
    [anon_sym_new] = ACTIONS(2388),
    [anon_sym_override] = ACTIONS(2388),
    [anon_sym_partial] = ACTIONS(2388),
    [anon_sym_private] = ACTIONS(2388),
    [anon_sym_protected] = ACTIONS(2388),
    [anon_sym_public] = ACTIONS(2388),
    [anon_sym_readonly] = ACTIONS(2388),
    [anon_sym_ref] = ACTIONS(2388),
    [anon_sym_sealed] = ACTIONS(2388),
    [anon_sym_unsafe] = ACTIONS(2388),
    [anon_sym_virtual] = ACTIONS(2388),
    [anon_sym_volatile] = ACTIONS(2388),
    [anon_sym_this] = ACTIONS(2388),
    [anon_sym_base] = ACTIONS(2388),
    [anon_sym_LBRACE] = ACTIONS(2386),
    [anon_sym_RBRACE] = ACTIONS(2386),
    [anon_sym_TILDE] = ACTIONS(2386),
    [anon_sym_where] = ACTIONS(2388),
    [anon_sym_notnull] = ACTIONS(2388),
    [anon_sym_unmanaged] = ACTIONS(2388),
    [anon_sym_BANG] = ACTIONS(2386),
    [anon_sym_PLUS_PLUS] = ACTIONS(2386),
    [anon_sym_DASH_DASH] = ACTIONS(2386),
    [anon_sym_true] = ACTIONS(2388),
    [anon_sym_false] = ACTIONS(2388),
    [anon_sym_PLUS] = ACTIONS(2388),
    [anon_sym_DASH] = ACTIONS(2388),
    [anon_sym_STAR] = ACTIONS(2386),
    [anon_sym_CARET] = ACTIONS(2386),
    [anon_sym_AMP] = ACTIONS(2386),
    [anon_sym_get] = ACTIONS(2388),
    [anon_sym_set] = ACTIONS(2388),
    [anon_sym_add] = ACTIONS(2388),
    [anon_sym_remove] = ACTIONS(2388),
    [anon_sym_delegate] = ACTIONS(2388),
    [anon_sym_var] = ACTIONS(2388),
    [sym_predefined_type] = ACTIONS(2388),
    [anon_sym_break] = ACTIONS(2388),
    [anon_sym_checked] = ACTIONS(2388),
    [anon_sym_unchecked] = ACTIONS(2388),
    [anon_sym_continue] = ACTIONS(2388),
    [anon_sym_do] = ACTIONS(2388),
    [anon_sym_while] = ACTIONS(2388),
    [anon_sym_for] = ACTIONS(2388),
    [anon_sym_await] = ACTIONS(2388),
    [anon_sym_foreach] = ACTIONS(2388),
    [anon_sym_goto] = ACTIONS(2388),
    [anon_sym_case] = ACTIONS(2388),
    [anon_sym_default] = ACTIONS(2388),
    [anon_sym_if] = ACTIONS(2388),
    [anon_sym_else] = ACTIONS(2388),
    [anon_sym_lock] = ACTIONS(2388),
    [anon_sym_switch] = ACTIONS(2388),
    [anon_sym_when] = ACTIONS(2388),
    [anon_sym_throw] = ACTIONS(2388),
    [anon_sym_try] = ACTIONS(2388),
    [anon_sym_yield] = ACTIONS(2388),
    [anon_sym_stackalloc] = ACTIONS(2388),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2386),
    [anon_sym_DQUOTE] = ACTIONS(2386),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2386),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2386),
    [anon_sym___makeref] = ACTIONS(2388),
    [anon_sym_from] = ACTIONS(2388),
    [anon_sym_join] = ACTIONS(2388),
    [anon_sym_on] = ACTIONS(2388),
    [anon_sym_equals] = ACTIONS(2388),
    [anon_sym_into] = ACTIONS(2388),
    [anon_sym_let] = ACTIONS(2388),
    [anon_sym_orderby] = ACTIONS(2388),
    [anon_sym_ascending] = ACTIONS(2388),
    [anon_sym_descending] = ACTIONS(2388),
    [anon_sym_group] = ACTIONS(2388),
    [anon_sym_by] = ACTIONS(2388),
    [anon_sym_select] = ACTIONS(2388),
    [anon_sym_DOT_DOT] = ACTIONS(2386),
    [anon_sym___reftype] = ACTIONS(2388),
    [anon_sym___refvalue] = ACTIONS(2388),
    [anon_sym_sizeof] = ACTIONS(2388),
    [anon_sym_typeof] = ACTIONS(2388),
    [anon_sym_SQUOTE] = ACTIONS(2386),
    [sym_integer_literal] = ACTIONS(2388),
    [sym_null_literal] = ACTIONS(2388),
    [sym_real_literal] = ACTIONS(2386),
    [sym_verbatim_string_literal] = ACTIONS(2386),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2388),
    [anon_sym_nameof] = ACTIONS(2388),
    [sym_void_keyword] = ACTIONS(2388),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1692] = {
    [sym__preprocessor_call] = STATE(1692),
    [sym__identifier_token] = ACTIONS(2340),
    [anon_sym_extern] = ACTIONS(2340),
    [anon_sym_alias] = ACTIONS(2340),
    [anon_sym_SEMI] = ACTIONS(2338),
    [anon_sym_global] = ACTIONS(2340),
    [anon_sym_using] = ACTIONS(2340),
    [anon_sym_static] = ACTIONS(2340),
    [anon_sym_LBRACK] = ACTIONS(2338),
    [anon_sym_return] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(2338),
    [anon_sym_abstract] = ACTIONS(2340),
    [anon_sym_async] = ACTIONS(2340),
    [anon_sym_const] = ACTIONS(2340),
    [anon_sym_fixed] = ACTIONS(2340),
    [anon_sym_internal] = ACTIONS(2340),
    [anon_sym_new] = ACTIONS(2340),
    [anon_sym_override] = ACTIONS(2340),
    [anon_sym_partial] = ACTIONS(2340),
    [anon_sym_private] = ACTIONS(2340),
    [anon_sym_protected] = ACTIONS(2340),
    [anon_sym_public] = ACTIONS(2340),
    [anon_sym_readonly] = ACTIONS(2340),
    [anon_sym_ref] = ACTIONS(2340),
    [anon_sym_sealed] = ACTIONS(2340),
    [anon_sym_unsafe] = ACTIONS(2340),
    [anon_sym_virtual] = ACTIONS(2340),
    [anon_sym_volatile] = ACTIONS(2340),
    [anon_sym_this] = ACTIONS(2340),
    [anon_sym_base] = ACTIONS(2340),
    [anon_sym_LBRACE] = ACTIONS(2338),
    [anon_sym_RBRACE] = ACTIONS(2338),
    [anon_sym_TILDE] = ACTIONS(2338),
    [anon_sym_where] = ACTIONS(2340),
    [anon_sym_notnull] = ACTIONS(2340),
    [anon_sym_unmanaged] = ACTIONS(2340),
    [anon_sym_BANG] = ACTIONS(2338),
    [anon_sym_PLUS_PLUS] = ACTIONS(2338),
    [anon_sym_DASH_DASH] = ACTIONS(2338),
    [anon_sym_true] = ACTIONS(2340),
    [anon_sym_false] = ACTIONS(2340),
    [anon_sym_PLUS] = ACTIONS(2340),
    [anon_sym_DASH] = ACTIONS(2340),
    [anon_sym_STAR] = ACTIONS(2338),
    [anon_sym_CARET] = ACTIONS(2338),
    [anon_sym_AMP] = ACTIONS(2338),
    [anon_sym_get] = ACTIONS(2340),
    [anon_sym_set] = ACTIONS(2340),
    [anon_sym_add] = ACTIONS(2340),
    [anon_sym_remove] = ACTIONS(2340),
    [anon_sym_delegate] = ACTIONS(2340),
    [anon_sym_var] = ACTIONS(2340),
    [sym_predefined_type] = ACTIONS(2340),
    [anon_sym_break] = ACTIONS(2340),
    [anon_sym_checked] = ACTIONS(2340),
    [anon_sym_unchecked] = ACTIONS(2340),
    [anon_sym_continue] = ACTIONS(2340),
    [anon_sym_do] = ACTIONS(2340),
    [anon_sym_while] = ACTIONS(2340),
    [anon_sym_for] = ACTIONS(2340),
    [anon_sym_await] = ACTIONS(2340),
    [anon_sym_foreach] = ACTIONS(2340),
    [anon_sym_goto] = ACTIONS(2340),
    [anon_sym_case] = ACTIONS(2340),
    [anon_sym_default] = ACTIONS(2340),
    [anon_sym_if] = ACTIONS(2340),
    [anon_sym_else] = ACTIONS(2340),
    [anon_sym_lock] = ACTIONS(2340),
    [anon_sym_switch] = ACTIONS(2340),
    [anon_sym_when] = ACTIONS(2340),
    [anon_sym_throw] = ACTIONS(2340),
    [anon_sym_try] = ACTIONS(2340),
    [anon_sym_yield] = ACTIONS(2340),
    [anon_sym_stackalloc] = ACTIONS(2340),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2338),
    [anon_sym_DQUOTE] = ACTIONS(2338),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2338),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2338),
    [anon_sym___makeref] = ACTIONS(2340),
    [anon_sym_from] = ACTIONS(2340),
    [anon_sym_join] = ACTIONS(2340),
    [anon_sym_on] = ACTIONS(2340),
    [anon_sym_equals] = ACTIONS(2340),
    [anon_sym_into] = ACTIONS(2340),
    [anon_sym_let] = ACTIONS(2340),
    [anon_sym_orderby] = ACTIONS(2340),
    [anon_sym_ascending] = ACTIONS(2340),
    [anon_sym_descending] = ACTIONS(2340),
    [anon_sym_group] = ACTIONS(2340),
    [anon_sym_by] = ACTIONS(2340),
    [anon_sym_select] = ACTIONS(2340),
    [anon_sym_DOT_DOT] = ACTIONS(2338),
    [anon_sym___reftype] = ACTIONS(2340),
    [anon_sym___refvalue] = ACTIONS(2340),
    [anon_sym_sizeof] = ACTIONS(2340),
    [anon_sym_typeof] = ACTIONS(2340),
    [anon_sym_SQUOTE] = ACTIONS(2338),
    [sym_integer_literal] = ACTIONS(2340),
    [sym_null_literal] = ACTIONS(2340),
    [sym_real_literal] = ACTIONS(2338),
    [sym_verbatim_string_literal] = ACTIONS(2338),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2340),
    [anon_sym_nameof] = ACTIONS(2340),
    [sym_void_keyword] = ACTIONS(2340),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1693] = {
    [sym__preprocessor_call] = STATE(1693),
    [sym__identifier_token] = ACTIONS(2288),
    [anon_sym_extern] = ACTIONS(2288),
    [anon_sym_alias] = ACTIONS(2288),
    [anon_sym_SEMI] = ACTIONS(2286),
    [anon_sym_global] = ACTIONS(2288),
    [anon_sym_using] = ACTIONS(2288),
    [anon_sym_static] = ACTIONS(2288),
    [anon_sym_LBRACK] = ACTIONS(2286),
    [anon_sym_return] = ACTIONS(2288),
    [anon_sym_LPAREN] = ACTIONS(2286),
    [anon_sym_abstract] = ACTIONS(2288),
    [anon_sym_async] = ACTIONS(2288),
    [anon_sym_const] = ACTIONS(2288),
    [anon_sym_fixed] = ACTIONS(2288),
    [anon_sym_internal] = ACTIONS(2288),
    [anon_sym_new] = ACTIONS(2288),
    [anon_sym_override] = ACTIONS(2288),
    [anon_sym_partial] = ACTIONS(2288),
    [anon_sym_private] = ACTIONS(2288),
    [anon_sym_protected] = ACTIONS(2288),
    [anon_sym_public] = ACTIONS(2288),
    [anon_sym_readonly] = ACTIONS(2288),
    [anon_sym_ref] = ACTIONS(2288),
    [anon_sym_sealed] = ACTIONS(2288),
    [anon_sym_unsafe] = ACTIONS(2288),
    [anon_sym_virtual] = ACTIONS(2288),
    [anon_sym_volatile] = ACTIONS(2288),
    [anon_sym_this] = ACTIONS(2288),
    [anon_sym_base] = ACTIONS(2288),
    [anon_sym_LBRACE] = ACTIONS(2286),
    [anon_sym_RBRACE] = ACTIONS(2286),
    [anon_sym_TILDE] = ACTIONS(2286),
    [anon_sym_where] = ACTIONS(2288),
    [anon_sym_notnull] = ACTIONS(2288),
    [anon_sym_unmanaged] = ACTIONS(2288),
    [anon_sym_BANG] = ACTIONS(2286),
    [anon_sym_PLUS_PLUS] = ACTIONS(2286),
    [anon_sym_DASH_DASH] = ACTIONS(2286),
    [anon_sym_true] = ACTIONS(2288),
    [anon_sym_false] = ACTIONS(2288),
    [anon_sym_PLUS] = ACTIONS(2288),
    [anon_sym_DASH] = ACTIONS(2288),
    [anon_sym_STAR] = ACTIONS(2286),
    [anon_sym_CARET] = ACTIONS(2286),
    [anon_sym_AMP] = ACTIONS(2286),
    [anon_sym_get] = ACTIONS(2288),
    [anon_sym_set] = ACTIONS(2288),
    [anon_sym_add] = ACTIONS(2288),
    [anon_sym_remove] = ACTIONS(2288),
    [anon_sym_delegate] = ACTIONS(2288),
    [anon_sym_var] = ACTIONS(2288),
    [sym_predefined_type] = ACTIONS(2288),
    [anon_sym_break] = ACTIONS(2288),
    [anon_sym_checked] = ACTIONS(2288),
    [anon_sym_unchecked] = ACTIONS(2288),
    [anon_sym_continue] = ACTIONS(2288),
    [anon_sym_do] = ACTIONS(2288),
    [anon_sym_while] = ACTIONS(2288),
    [anon_sym_for] = ACTIONS(2288),
    [anon_sym_await] = ACTIONS(2288),
    [anon_sym_foreach] = ACTIONS(2288),
    [anon_sym_goto] = ACTIONS(2288),
    [anon_sym_case] = ACTIONS(2288),
    [anon_sym_default] = ACTIONS(2288),
    [anon_sym_if] = ACTIONS(2288),
    [anon_sym_else] = ACTIONS(2288),
    [anon_sym_lock] = ACTIONS(2288),
    [anon_sym_switch] = ACTIONS(2288),
    [anon_sym_when] = ACTIONS(2288),
    [anon_sym_throw] = ACTIONS(2288),
    [anon_sym_try] = ACTIONS(2288),
    [anon_sym_yield] = ACTIONS(2288),
    [anon_sym_stackalloc] = ACTIONS(2288),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2286),
    [anon_sym_DQUOTE] = ACTIONS(2286),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2286),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2286),
    [anon_sym___makeref] = ACTIONS(2288),
    [anon_sym_from] = ACTIONS(2288),
    [anon_sym_join] = ACTIONS(2288),
    [anon_sym_on] = ACTIONS(2288),
    [anon_sym_equals] = ACTIONS(2288),
    [anon_sym_into] = ACTIONS(2288),
    [anon_sym_let] = ACTIONS(2288),
    [anon_sym_orderby] = ACTIONS(2288),
    [anon_sym_ascending] = ACTIONS(2288),
    [anon_sym_descending] = ACTIONS(2288),
    [anon_sym_group] = ACTIONS(2288),
    [anon_sym_by] = ACTIONS(2288),
    [anon_sym_select] = ACTIONS(2288),
    [anon_sym_DOT_DOT] = ACTIONS(2286),
    [anon_sym___reftype] = ACTIONS(2288),
    [anon_sym___refvalue] = ACTIONS(2288),
    [anon_sym_sizeof] = ACTIONS(2288),
    [anon_sym_typeof] = ACTIONS(2288),
    [anon_sym_SQUOTE] = ACTIONS(2286),
    [sym_integer_literal] = ACTIONS(2288),
    [sym_null_literal] = ACTIONS(2288),
    [sym_real_literal] = ACTIONS(2286),
    [sym_verbatim_string_literal] = ACTIONS(2286),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2288),
    [anon_sym_nameof] = ACTIONS(2288),
    [sym_void_keyword] = ACTIONS(2288),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1694] = {
    [sym__preprocessor_call] = STATE(1694),
    [sym__identifier_token] = ACTIONS(2352),
    [anon_sym_extern] = ACTIONS(2352),
    [anon_sym_alias] = ACTIONS(2352),
    [anon_sym_SEMI] = ACTIONS(2350),
    [anon_sym_global] = ACTIONS(2352),
    [anon_sym_using] = ACTIONS(2352),
    [anon_sym_static] = ACTIONS(2352),
    [anon_sym_LBRACK] = ACTIONS(2350),
    [anon_sym_return] = ACTIONS(2352),
    [anon_sym_LPAREN] = ACTIONS(2350),
    [anon_sym_abstract] = ACTIONS(2352),
    [anon_sym_async] = ACTIONS(2352),
    [anon_sym_const] = ACTIONS(2352),
    [anon_sym_fixed] = ACTIONS(2352),
    [anon_sym_internal] = ACTIONS(2352),
    [anon_sym_new] = ACTIONS(2352),
    [anon_sym_override] = ACTIONS(2352),
    [anon_sym_partial] = ACTIONS(2352),
    [anon_sym_private] = ACTIONS(2352),
    [anon_sym_protected] = ACTIONS(2352),
    [anon_sym_public] = ACTIONS(2352),
    [anon_sym_readonly] = ACTIONS(2352),
    [anon_sym_ref] = ACTIONS(2352),
    [anon_sym_sealed] = ACTIONS(2352),
    [anon_sym_unsafe] = ACTIONS(2352),
    [anon_sym_virtual] = ACTIONS(2352),
    [anon_sym_volatile] = ACTIONS(2352),
    [anon_sym_this] = ACTIONS(2352),
    [anon_sym_base] = ACTIONS(2352),
    [anon_sym_LBRACE] = ACTIONS(2350),
    [anon_sym_RBRACE] = ACTIONS(2350),
    [anon_sym_TILDE] = ACTIONS(2350),
    [anon_sym_where] = ACTIONS(2352),
    [anon_sym_notnull] = ACTIONS(2352),
    [anon_sym_unmanaged] = ACTIONS(2352),
    [anon_sym_BANG] = ACTIONS(2350),
    [anon_sym_PLUS_PLUS] = ACTIONS(2350),
    [anon_sym_DASH_DASH] = ACTIONS(2350),
    [anon_sym_true] = ACTIONS(2352),
    [anon_sym_false] = ACTIONS(2352),
    [anon_sym_PLUS] = ACTIONS(2352),
    [anon_sym_DASH] = ACTIONS(2352),
    [anon_sym_STAR] = ACTIONS(2350),
    [anon_sym_CARET] = ACTIONS(2350),
    [anon_sym_AMP] = ACTIONS(2350),
    [anon_sym_get] = ACTIONS(2352),
    [anon_sym_set] = ACTIONS(2352),
    [anon_sym_add] = ACTIONS(2352),
    [anon_sym_remove] = ACTIONS(2352),
    [anon_sym_delegate] = ACTIONS(2352),
    [anon_sym_var] = ACTIONS(2352),
    [sym_predefined_type] = ACTIONS(2352),
    [anon_sym_break] = ACTIONS(2352),
    [anon_sym_checked] = ACTIONS(2352),
    [anon_sym_unchecked] = ACTIONS(2352),
    [anon_sym_continue] = ACTIONS(2352),
    [anon_sym_do] = ACTIONS(2352),
    [anon_sym_while] = ACTIONS(2352),
    [anon_sym_for] = ACTIONS(2352),
    [anon_sym_await] = ACTIONS(2352),
    [anon_sym_foreach] = ACTIONS(2352),
    [anon_sym_goto] = ACTIONS(2352),
    [anon_sym_case] = ACTIONS(2352),
    [anon_sym_default] = ACTIONS(2352),
    [anon_sym_if] = ACTIONS(2352),
    [anon_sym_else] = ACTIONS(2352),
    [anon_sym_lock] = ACTIONS(2352),
    [anon_sym_switch] = ACTIONS(2352),
    [anon_sym_when] = ACTIONS(2352),
    [anon_sym_throw] = ACTIONS(2352),
    [anon_sym_try] = ACTIONS(2352),
    [anon_sym_yield] = ACTIONS(2352),
    [anon_sym_stackalloc] = ACTIONS(2352),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2350),
    [anon_sym_DQUOTE] = ACTIONS(2350),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2350),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2350),
    [anon_sym___makeref] = ACTIONS(2352),
    [anon_sym_from] = ACTIONS(2352),
    [anon_sym_join] = ACTIONS(2352),
    [anon_sym_on] = ACTIONS(2352),
    [anon_sym_equals] = ACTIONS(2352),
    [anon_sym_into] = ACTIONS(2352),
    [anon_sym_let] = ACTIONS(2352),
    [anon_sym_orderby] = ACTIONS(2352),
    [anon_sym_ascending] = ACTIONS(2352),
    [anon_sym_descending] = ACTIONS(2352),
    [anon_sym_group] = ACTIONS(2352),
    [anon_sym_by] = ACTIONS(2352),
    [anon_sym_select] = ACTIONS(2352),
    [anon_sym_DOT_DOT] = ACTIONS(2350),
    [anon_sym___reftype] = ACTIONS(2352),
    [anon_sym___refvalue] = ACTIONS(2352),
    [anon_sym_sizeof] = ACTIONS(2352),
    [anon_sym_typeof] = ACTIONS(2352),
    [anon_sym_SQUOTE] = ACTIONS(2350),
    [sym_integer_literal] = ACTIONS(2352),
    [sym_null_literal] = ACTIONS(2352),
    [sym_real_literal] = ACTIONS(2350),
    [sym_verbatim_string_literal] = ACTIONS(2350),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2352),
    [anon_sym_nameof] = ACTIONS(2352),
    [sym_void_keyword] = ACTIONS(2352),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1695] = {
    [sym__preprocessor_call] = STATE(1695),
    [sym__identifier_token] = ACTIONS(2392),
    [anon_sym_extern] = ACTIONS(2392),
    [anon_sym_alias] = ACTIONS(2392),
    [anon_sym_SEMI] = ACTIONS(2390),
    [anon_sym_global] = ACTIONS(2392),
    [anon_sym_using] = ACTIONS(2392),
    [anon_sym_static] = ACTIONS(2392),
    [anon_sym_LBRACK] = ACTIONS(2390),
    [anon_sym_return] = ACTIONS(2392),
    [anon_sym_LPAREN] = ACTIONS(2390),
    [anon_sym_abstract] = ACTIONS(2392),
    [anon_sym_async] = ACTIONS(2392),
    [anon_sym_const] = ACTIONS(2392),
    [anon_sym_fixed] = ACTIONS(2392),
    [anon_sym_internal] = ACTIONS(2392),
    [anon_sym_new] = ACTIONS(2392),
    [anon_sym_override] = ACTIONS(2392),
    [anon_sym_partial] = ACTIONS(2392),
    [anon_sym_private] = ACTIONS(2392),
    [anon_sym_protected] = ACTIONS(2392),
    [anon_sym_public] = ACTIONS(2392),
    [anon_sym_readonly] = ACTIONS(2392),
    [anon_sym_ref] = ACTIONS(2392),
    [anon_sym_sealed] = ACTIONS(2392),
    [anon_sym_unsafe] = ACTIONS(2392),
    [anon_sym_virtual] = ACTIONS(2392),
    [anon_sym_volatile] = ACTIONS(2392),
    [anon_sym_this] = ACTIONS(2392),
    [anon_sym_base] = ACTIONS(2392),
    [anon_sym_LBRACE] = ACTIONS(2390),
    [anon_sym_RBRACE] = ACTIONS(2390),
    [anon_sym_TILDE] = ACTIONS(2390),
    [anon_sym_where] = ACTIONS(2392),
    [anon_sym_notnull] = ACTIONS(2392),
    [anon_sym_unmanaged] = ACTIONS(2392),
    [anon_sym_BANG] = ACTIONS(2390),
    [anon_sym_PLUS_PLUS] = ACTIONS(2390),
    [anon_sym_DASH_DASH] = ACTIONS(2390),
    [anon_sym_true] = ACTIONS(2392),
    [anon_sym_false] = ACTIONS(2392),
    [anon_sym_PLUS] = ACTIONS(2392),
    [anon_sym_DASH] = ACTIONS(2392),
    [anon_sym_STAR] = ACTIONS(2390),
    [anon_sym_CARET] = ACTIONS(2390),
    [anon_sym_AMP] = ACTIONS(2390),
    [anon_sym_get] = ACTIONS(2392),
    [anon_sym_set] = ACTIONS(2392),
    [anon_sym_add] = ACTIONS(2392),
    [anon_sym_remove] = ACTIONS(2392),
    [anon_sym_delegate] = ACTIONS(2392),
    [anon_sym_var] = ACTIONS(2392),
    [sym_predefined_type] = ACTIONS(2392),
    [anon_sym_break] = ACTIONS(2392),
    [anon_sym_checked] = ACTIONS(2392),
    [anon_sym_unchecked] = ACTIONS(2392),
    [anon_sym_continue] = ACTIONS(2392),
    [anon_sym_do] = ACTIONS(2392),
    [anon_sym_while] = ACTIONS(2392),
    [anon_sym_for] = ACTIONS(2392),
    [anon_sym_await] = ACTIONS(2392),
    [anon_sym_foreach] = ACTIONS(2392),
    [anon_sym_goto] = ACTIONS(2392),
    [anon_sym_case] = ACTIONS(2392),
    [anon_sym_default] = ACTIONS(2392),
    [anon_sym_if] = ACTIONS(2392),
    [anon_sym_else] = ACTIONS(2392),
    [anon_sym_lock] = ACTIONS(2392),
    [anon_sym_switch] = ACTIONS(2392),
    [anon_sym_when] = ACTIONS(2392),
    [anon_sym_throw] = ACTIONS(2392),
    [anon_sym_try] = ACTIONS(2392),
    [anon_sym_yield] = ACTIONS(2392),
    [anon_sym_stackalloc] = ACTIONS(2392),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2390),
    [anon_sym_DQUOTE] = ACTIONS(2390),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2390),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2390),
    [anon_sym___makeref] = ACTIONS(2392),
    [anon_sym_from] = ACTIONS(2392),
    [anon_sym_join] = ACTIONS(2392),
    [anon_sym_on] = ACTIONS(2392),
    [anon_sym_equals] = ACTIONS(2392),
    [anon_sym_into] = ACTIONS(2392),
    [anon_sym_let] = ACTIONS(2392),
    [anon_sym_orderby] = ACTIONS(2392),
    [anon_sym_ascending] = ACTIONS(2392),
    [anon_sym_descending] = ACTIONS(2392),
    [anon_sym_group] = ACTIONS(2392),
    [anon_sym_by] = ACTIONS(2392),
    [anon_sym_select] = ACTIONS(2392),
    [anon_sym_DOT_DOT] = ACTIONS(2390),
    [anon_sym___reftype] = ACTIONS(2392),
    [anon_sym___refvalue] = ACTIONS(2392),
    [anon_sym_sizeof] = ACTIONS(2392),
    [anon_sym_typeof] = ACTIONS(2392),
    [anon_sym_SQUOTE] = ACTIONS(2390),
    [sym_integer_literal] = ACTIONS(2392),
    [sym_null_literal] = ACTIONS(2392),
    [sym_real_literal] = ACTIONS(2390),
    [sym_verbatim_string_literal] = ACTIONS(2390),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2392),
    [anon_sym_nameof] = ACTIONS(2392),
    [sym_void_keyword] = ACTIONS(2392),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1696] = {
    [sym__preprocessor_call] = STATE(1696),
    [sym__identifier_token] = ACTIONS(2268),
    [anon_sym_extern] = ACTIONS(2268),
    [anon_sym_alias] = ACTIONS(2268),
    [anon_sym_SEMI] = ACTIONS(2266),
    [anon_sym_global] = ACTIONS(2268),
    [anon_sym_using] = ACTIONS(2268),
    [anon_sym_static] = ACTIONS(2268),
    [anon_sym_LBRACK] = ACTIONS(2266),
    [anon_sym_return] = ACTIONS(2268),
    [anon_sym_LPAREN] = ACTIONS(2266),
    [anon_sym_abstract] = ACTIONS(2268),
    [anon_sym_async] = ACTIONS(2268),
    [anon_sym_const] = ACTIONS(2268),
    [anon_sym_fixed] = ACTIONS(2268),
    [anon_sym_internal] = ACTIONS(2268),
    [anon_sym_new] = ACTIONS(2268),
    [anon_sym_override] = ACTIONS(2268),
    [anon_sym_partial] = ACTIONS(2268),
    [anon_sym_private] = ACTIONS(2268),
    [anon_sym_protected] = ACTIONS(2268),
    [anon_sym_public] = ACTIONS(2268),
    [anon_sym_readonly] = ACTIONS(2268),
    [anon_sym_ref] = ACTIONS(2268),
    [anon_sym_sealed] = ACTIONS(2268),
    [anon_sym_unsafe] = ACTIONS(2268),
    [anon_sym_virtual] = ACTIONS(2268),
    [anon_sym_volatile] = ACTIONS(2268),
    [anon_sym_this] = ACTIONS(2268),
    [anon_sym_base] = ACTIONS(2268),
    [anon_sym_LBRACE] = ACTIONS(2266),
    [anon_sym_RBRACE] = ACTIONS(2266),
    [anon_sym_TILDE] = ACTIONS(2266),
    [anon_sym_where] = ACTIONS(2268),
    [anon_sym_notnull] = ACTIONS(2268),
    [anon_sym_unmanaged] = ACTIONS(2268),
    [anon_sym_BANG] = ACTIONS(2266),
    [anon_sym_PLUS_PLUS] = ACTIONS(2266),
    [anon_sym_DASH_DASH] = ACTIONS(2266),
    [anon_sym_true] = ACTIONS(2268),
    [anon_sym_false] = ACTIONS(2268),
    [anon_sym_PLUS] = ACTIONS(2268),
    [anon_sym_DASH] = ACTIONS(2268),
    [anon_sym_STAR] = ACTIONS(2266),
    [anon_sym_CARET] = ACTIONS(2266),
    [anon_sym_AMP] = ACTIONS(2266),
    [anon_sym_get] = ACTIONS(2268),
    [anon_sym_set] = ACTIONS(2268),
    [anon_sym_add] = ACTIONS(2268),
    [anon_sym_remove] = ACTIONS(2268),
    [anon_sym_delegate] = ACTIONS(2268),
    [anon_sym_var] = ACTIONS(2268),
    [sym_predefined_type] = ACTIONS(2268),
    [anon_sym_break] = ACTIONS(2268),
    [anon_sym_checked] = ACTIONS(2268),
    [anon_sym_unchecked] = ACTIONS(2268),
    [anon_sym_continue] = ACTIONS(2268),
    [anon_sym_do] = ACTIONS(2268),
    [anon_sym_while] = ACTIONS(2268),
    [anon_sym_for] = ACTIONS(2268),
    [anon_sym_await] = ACTIONS(2268),
    [anon_sym_foreach] = ACTIONS(2268),
    [anon_sym_goto] = ACTIONS(2268),
    [anon_sym_case] = ACTIONS(2268),
    [anon_sym_default] = ACTIONS(2268),
    [anon_sym_if] = ACTIONS(2268),
    [anon_sym_else] = ACTIONS(2268),
    [anon_sym_lock] = ACTIONS(2268),
    [anon_sym_switch] = ACTIONS(2268),
    [anon_sym_when] = ACTIONS(2268),
    [anon_sym_throw] = ACTIONS(2268),
    [anon_sym_try] = ACTIONS(2268),
    [anon_sym_yield] = ACTIONS(2268),
    [anon_sym_stackalloc] = ACTIONS(2268),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2266),
    [anon_sym_DQUOTE] = ACTIONS(2266),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2266),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2266),
    [anon_sym___makeref] = ACTIONS(2268),
    [anon_sym_from] = ACTIONS(2268),
    [anon_sym_join] = ACTIONS(2268),
    [anon_sym_on] = ACTIONS(2268),
    [anon_sym_equals] = ACTIONS(2268),
    [anon_sym_into] = ACTIONS(2268),
    [anon_sym_let] = ACTIONS(2268),
    [anon_sym_orderby] = ACTIONS(2268),
    [anon_sym_ascending] = ACTIONS(2268),
    [anon_sym_descending] = ACTIONS(2268),
    [anon_sym_group] = ACTIONS(2268),
    [anon_sym_by] = ACTIONS(2268),
    [anon_sym_select] = ACTIONS(2268),
    [anon_sym_DOT_DOT] = ACTIONS(2266),
    [anon_sym___reftype] = ACTIONS(2268),
    [anon_sym___refvalue] = ACTIONS(2268),
    [anon_sym_sizeof] = ACTIONS(2268),
    [anon_sym_typeof] = ACTIONS(2268),
    [anon_sym_SQUOTE] = ACTIONS(2266),
    [sym_integer_literal] = ACTIONS(2268),
    [sym_null_literal] = ACTIONS(2268),
    [sym_real_literal] = ACTIONS(2266),
    [sym_verbatim_string_literal] = ACTIONS(2266),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2268),
    [anon_sym_nameof] = ACTIONS(2268),
    [sym_void_keyword] = ACTIONS(2268),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1697] = {
    [sym__preprocessor_call] = STATE(1697),
    [sym__identifier_token] = ACTIONS(2304),
    [anon_sym_extern] = ACTIONS(2304),
    [anon_sym_alias] = ACTIONS(2304),
    [anon_sym_SEMI] = ACTIONS(2302),
    [anon_sym_global] = ACTIONS(2304),
    [anon_sym_using] = ACTIONS(2304),
    [anon_sym_static] = ACTIONS(2304),
    [anon_sym_LBRACK] = ACTIONS(2302),
    [anon_sym_return] = ACTIONS(2304),
    [anon_sym_LPAREN] = ACTIONS(2302),
    [anon_sym_abstract] = ACTIONS(2304),
    [anon_sym_async] = ACTIONS(2304),
    [anon_sym_const] = ACTIONS(2304),
    [anon_sym_fixed] = ACTIONS(2304),
    [anon_sym_internal] = ACTIONS(2304),
    [anon_sym_new] = ACTIONS(2304),
    [anon_sym_override] = ACTIONS(2304),
    [anon_sym_partial] = ACTIONS(2304),
    [anon_sym_private] = ACTIONS(2304),
    [anon_sym_protected] = ACTIONS(2304),
    [anon_sym_public] = ACTIONS(2304),
    [anon_sym_readonly] = ACTIONS(2304),
    [anon_sym_ref] = ACTIONS(2304),
    [anon_sym_sealed] = ACTIONS(2304),
    [anon_sym_unsafe] = ACTIONS(2304),
    [anon_sym_virtual] = ACTIONS(2304),
    [anon_sym_volatile] = ACTIONS(2304),
    [anon_sym_this] = ACTIONS(2304),
    [anon_sym_base] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(2302),
    [anon_sym_RBRACE] = ACTIONS(2302),
    [anon_sym_TILDE] = ACTIONS(2302),
    [anon_sym_where] = ACTIONS(2304),
    [anon_sym_notnull] = ACTIONS(2304),
    [anon_sym_unmanaged] = ACTIONS(2304),
    [anon_sym_BANG] = ACTIONS(2302),
    [anon_sym_PLUS_PLUS] = ACTIONS(2302),
    [anon_sym_DASH_DASH] = ACTIONS(2302),
    [anon_sym_true] = ACTIONS(2304),
    [anon_sym_false] = ACTIONS(2304),
    [anon_sym_PLUS] = ACTIONS(2304),
    [anon_sym_DASH] = ACTIONS(2304),
    [anon_sym_STAR] = ACTIONS(2302),
    [anon_sym_CARET] = ACTIONS(2302),
    [anon_sym_AMP] = ACTIONS(2302),
    [anon_sym_get] = ACTIONS(2304),
    [anon_sym_set] = ACTIONS(2304),
    [anon_sym_add] = ACTIONS(2304),
    [anon_sym_remove] = ACTIONS(2304),
    [anon_sym_delegate] = ACTIONS(2304),
    [anon_sym_var] = ACTIONS(2304),
    [sym_predefined_type] = ACTIONS(2304),
    [anon_sym_break] = ACTIONS(2304),
    [anon_sym_checked] = ACTIONS(2304),
    [anon_sym_unchecked] = ACTIONS(2304),
    [anon_sym_continue] = ACTIONS(2304),
    [anon_sym_do] = ACTIONS(2304),
    [anon_sym_while] = ACTIONS(2304),
    [anon_sym_for] = ACTIONS(2304),
    [anon_sym_await] = ACTIONS(2304),
    [anon_sym_foreach] = ACTIONS(2304),
    [anon_sym_goto] = ACTIONS(2304),
    [anon_sym_case] = ACTIONS(2304),
    [anon_sym_default] = ACTIONS(2304),
    [anon_sym_if] = ACTIONS(2304),
    [anon_sym_else] = ACTIONS(2304),
    [anon_sym_lock] = ACTIONS(2304),
    [anon_sym_switch] = ACTIONS(2304),
    [anon_sym_when] = ACTIONS(2304),
    [anon_sym_throw] = ACTIONS(2304),
    [anon_sym_try] = ACTIONS(2304),
    [anon_sym_yield] = ACTIONS(2304),
    [anon_sym_stackalloc] = ACTIONS(2304),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2302),
    [anon_sym_DQUOTE] = ACTIONS(2302),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2302),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2302),
    [anon_sym___makeref] = ACTIONS(2304),
    [anon_sym_from] = ACTIONS(2304),
    [anon_sym_join] = ACTIONS(2304),
    [anon_sym_on] = ACTIONS(2304),
    [anon_sym_equals] = ACTIONS(2304),
    [anon_sym_into] = ACTIONS(2304),
    [anon_sym_let] = ACTIONS(2304),
    [anon_sym_orderby] = ACTIONS(2304),
    [anon_sym_ascending] = ACTIONS(2304),
    [anon_sym_descending] = ACTIONS(2304),
    [anon_sym_group] = ACTIONS(2304),
    [anon_sym_by] = ACTIONS(2304),
    [anon_sym_select] = ACTIONS(2304),
    [anon_sym_DOT_DOT] = ACTIONS(2302),
    [anon_sym___reftype] = ACTIONS(2304),
    [anon_sym___refvalue] = ACTIONS(2304),
    [anon_sym_sizeof] = ACTIONS(2304),
    [anon_sym_typeof] = ACTIONS(2304),
    [anon_sym_SQUOTE] = ACTIONS(2302),
    [sym_integer_literal] = ACTIONS(2304),
    [sym_null_literal] = ACTIONS(2304),
    [sym_real_literal] = ACTIONS(2302),
    [sym_verbatim_string_literal] = ACTIONS(2302),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2304),
    [anon_sym_nameof] = ACTIONS(2304),
    [sym_void_keyword] = ACTIONS(2304),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1698] = {
    [sym__preprocessor_call] = STATE(1698),
    [sym__identifier_token] = ACTIONS(2534),
    [anon_sym_extern] = ACTIONS(2534),
    [anon_sym_alias] = ACTIONS(2534),
    [anon_sym_SEMI] = ACTIONS(2532),
    [anon_sym_global] = ACTIONS(2534),
    [anon_sym_using] = ACTIONS(2534),
    [anon_sym_static] = ACTIONS(2534),
    [anon_sym_LBRACK] = ACTIONS(2532),
    [anon_sym_return] = ACTIONS(2534),
    [anon_sym_LPAREN] = ACTIONS(2532),
    [anon_sym_abstract] = ACTIONS(2534),
    [anon_sym_async] = ACTIONS(2534),
    [anon_sym_const] = ACTIONS(2534),
    [anon_sym_fixed] = ACTIONS(2534),
    [anon_sym_internal] = ACTIONS(2534),
    [anon_sym_new] = ACTIONS(2534),
    [anon_sym_override] = ACTIONS(2534),
    [anon_sym_partial] = ACTIONS(2534),
    [anon_sym_private] = ACTIONS(2534),
    [anon_sym_protected] = ACTIONS(2534),
    [anon_sym_public] = ACTIONS(2534),
    [anon_sym_readonly] = ACTIONS(2534),
    [anon_sym_ref] = ACTIONS(2534),
    [anon_sym_sealed] = ACTIONS(2534),
    [anon_sym_unsafe] = ACTIONS(2534),
    [anon_sym_virtual] = ACTIONS(2534),
    [anon_sym_volatile] = ACTIONS(2534),
    [anon_sym_this] = ACTIONS(2534),
    [anon_sym_base] = ACTIONS(2534),
    [anon_sym_LBRACE] = ACTIONS(2532),
    [anon_sym_RBRACE] = ACTIONS(2532),
    [anon_sym_TILDE] = ACTIONS(2532),
    [anon_sym_where] = ACTIONS(2534),
    [anon_sym_notnull] = ACTIONS(2534),
    [anon_sym_unmanaged] = ACTIONS(2534),
    [anon_sym_BANG] = ACTIONS(2532),
    [anon_sym_PLUS_PLUS] = ACTIONS(2532),
    [anon_sym_DASH_DASH] = ACTIONS(2532),
    [anon_sym_true] = ACTIONS(2534),
    [anon_sym_false] = ACTIONS(2534),
    [anon_sym_PLUS] = ACTIONS(2534),
    [anon_sym_DASH] = ACTIONS(2534),
    [anon_sym_STAR] = ACTIONS(2532),
    [anon_sym_CARET] = ACTIONS(2532),
    [anon_sym_AMP] = ACTIONS(2532),
    [anon_sym_get] = ACTIONS(2534),
    [anon_sym_set] = ACTIONS(2534),
    [anon_sym_add] = ACTIONS(2534),
    [anon_sym_remove] = ACTIONS(2534),
    [anon_sym_delegate] = ACTIONS(2534),
    [anon_sym_var] = ACTIONS(2534),
    [sym_predefined_type] = ACTIONS(2534),
    [anon_sym_break] = ACTIONS(2534),
    [anon_sym_checked] = ACTIONS(2534),
    [anon_sym_unchecked] = ACTIONS(2534),
    [anon_sym_continue] = ACTIONS(2534),
    [anon_sym_do] = ACTIONS(2534),
    [anon_sym_while] = ACTIONS(2534),
    [anon_sym_for] = ACTIONS(2534),
    [anon_sym_await] = ACTIONS(2534),
    [anon_sym_foreach] = ACTIONS(2534),
    [anon_sym_goto] = ACTIONS(2534),
    [anon_sym_case] = ACTIONS(2534),
    [anon_sym_default] = ACTIONS(2534),
    [anon_sym_if] = ACTIONS(2534),
    [anon_sym_else] = ACTIONS(2534),
    [anon_sym_lock] = ACTIONS(2534),
    [anon_sym_switch] = ACTIONS(2534),
    [anon_sym_when] = ACTIONS(2534),
    [anon_sym_throw] = ACTIONS(2534),
    [anon_sym_try] = ACTIONS(2534),
    [anon_sym_yield] = ACTIONS(2534),
    [anon_sym_stackalloc] = ACTIONS(2534),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2532),
    [anon_sym_DQUOTE] = ACTIONS(2532),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2532),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2532),
    [anon_sym___makeref] = ACTIONS(2534),
    [anon_sym_from] = ACTIONS(2534),
    [anon_sym_join] = ACTIONS(2534),
    [anon_sym_on] = ACTIONS(2534),
    [anon_sym_equals] = ACTIONS(2534),
    [anon_sym_into] = ACTIONS(2534),
    [anon_sym_let] = ACTIONS(2534),
    [anon_sym_orderby] = ACTIONS(2534),
    [anon_sym_ascending] = ACTIONS(2534),
    [anon_sym_descending] = ACTIONS(2534),
    [anon_sym_group] = ACTIONS(2534),
    [anon_sym_by] = ACTIONS(2534),
    [anon_sym_select] = ACTIONS(2534),
    [anon_sym_DOT_DOT] = ACTIONS(2532),
    [anon_sym___reftype] = ACTIONS(2534),
    [anon_sym___refvalue] = ACTIONS(2534),
    [anon_sym_sizeof] = ACTIONS(2534),
    [anon_sym_typeof] = ACTIONS(2534),
    [anon_sym_SQUOTE] = ACTIONS(2532),
    [sym_integer_literal] = ACTIONS(2534),
    [sym_null_literal] = ACTIONS(2534),
    [sym_real_literal] = ACTIONS(2532),
    [sym_verbatim_string_literal] = ACTIONS(2532),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2534),
    [anon_sym_nameof] = ACTIONS(2534),
    [sym_void_keyword] = ACTIONS(2534),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1699] = {
    [sym__preprocessor_call] = STATE(1699),
    [sym__identifier_token] = ACTIONS(2296),
    [anon_sym_extern] = ACTIONS(2296),
    [anon_sym_alias] = ACTIONS(2296),
    [anon_sym_SEMI] = ACTIONS(2294),
    [anon_sym_global] = ACTIONS(2296),
    [anon_sym_using] = ACTIONS(2296),
    [anon_sym_static] = ACTIONS(2296),
    [anon_sym_LBRACK] = ACTIONS(2294),
    [anon_sym_return] = ACTIONS(2296),
    [anon_sym_LPAREN] = ACTIONS(2294),
    [anon_sym_abstract] = ACTIONS(2296),
    [anon_sym_async] = ACTIONS(2296),
    [anon_sym_const] = ACTIONS(2296),
    [anon_sym_fixed] = ACTIONS(2296),
    [anon_sym_internal] = ACTIONS(2296),
    [anon_sym_new] = ACTIONS(2296),
    [anon_sym_override] = ACTIONS(2296),
    [anon_sym_partial] = ACTIONS(2296),
    [anon_sym_private] = ACTIONS(2296),
    [anon_sym_protected] = ACTIONS(2296),
    [anon_sym_public] = ACTIONS(2296),
    [anon_sym_readonly] = ACTIONS(2296),
    [anon_sym_ref] = ACTIONS(2296),
    [anon_sym_sealed] = ACTIONS(2296),
    [anon_sym_unsafe] = ACTIONS(2296),
    [anon_sym_virtual] = ACTIONS(2296),
    [anon_sym_volatile] = ACTIONS(2296),
    [anon_sym_this] = ACTIONS(2296),
    [anon_sym_base] = ACTIONS(2296),
    [anon_sym_LBRACE] = ACTIONS(2294),
    [anon_sym_RBRACE] = ACTIONS(2294),
    [anon_sym_TILDE] = ACTIONS(2294),
    [anon_sym_where] = ACTIONS(2296),
    [anon_sym_notnull] = ACTIONS(2296),
    [anon_sym_unmanaged] = ACTIONS(2296),
    [anon_sym_BANG] = ACTIONS(2294),
    [anon_sym_PLUS_PLUS] = ACTIONS(2294),
    [anon_sym_DASH_DASH] = ACTIONS(2294),
    [anon_sym_true] = ACTIONS(2296),
    [anon_sym_false] = ACTIONS(2296),
    [anon_sym_PLUS] = ACTIONS(2296),
    [anon_sym_DASH] = ACTIONS(2296),
    [anon_sym_STAR] = ACTIONS(2294),
    [anon_sym_CARET] = ACTIONS(2294),
    [anon_sym_AMP] = ACTIONS(2294),
    [anon_sym_get] = ACTIONS(2296),
    [anon_sym_set] = ACTIONS(2296),
    [anon_sym_add] = ACTIONS(2296),
    [anon_sym_remove] = ACTIONS(2296),
    [anon_sym_delegate] = ACTIONS(2296),
    [anon_sym_var] = ACTIONS(2296),
    [sym_predefined_type] = ACTIONS(2296),
    [anon_sym_break] = ACTIONS(2296),
    [anon_sym_checked] = ACTIONS(2296),
    [anon_sym_unchecked] = ACTIONS(2296),
    [anon_sym_continue] = ACTIONS(2296),
    [anon_sym_do] = ACTIONS(2296),
    [anon_sym_while] = ACTIONS(2296),
    [anon_sym_for] = ACTIONS(2296),
    [anon_sym_await] = ACTIONS(2296),
    [anon_sym_foreach] = ACTIONS(2296),
    [anon_sym_goto] = ACTIONS(2296),
    [anon_sym_case] = ACTIONS(2296),
    [anon_sym_default] = ACTIONS(2296),
    [anon_sym_if] = ACTIONS(2296),
    [anon_sym_else] = ACTIONS(2296),
    [anon_sym_lock] = ACTIONS(2296),
    [anon_sym_switch] = ACTIONS(2296),
    [anon_sym_when] = ACTIONS(2296),
    [anon_sym_throw] = ACTIONS(2296),
    [anon_sym_try] = ACTIONS(2296),
    [anon_sym_yield] = ACTIONS(2296),
    [anon_sym_stackalloc] = ACTIONS(2296),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2294),
    [anon_sym_DQUOTE] = ACTIONS(2294),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2294),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2294),
    [anon_sym___makeref] = ACTIONS(2296),
    [anon_sym_from] = ACTIONS(2296),
    [anon_sym_join] = ACTIONS(2296),
    [anon_sym_on] = ACTIONS(2296),
    [anon_sym_equals] = ACTIONS(2296),
    [anon_sym_into] = ACTIONS(2296),
    [anon_sym_let] = ACTIONS(2296),
    [anon_sym_orderby] = ACTIONS(2296),
    [anon_sym_ascending] = ACTIONS(2296),
    [anon_sym_descending] = ACTIONS(2296),
    [anon_sym_group] = ACTIONS(2296),
    [anon_sym_by] = ACTIONS(2296),
    [anon_sym_select] = ACTIONS(2296),
    [anon_sym_DOT_DOT] = ACTIONS(2294),
    [anon_sym___reftype] = ACTIONS(2296),
    [anon_sym___refvalue] = ACTIONS(2296),
    [anon_sym_sizeof] = ACTIONS(2296),
    [anon_sym_typeof] = ACTIONS(2296),
    [anon_sym_SQUOTE] = ACTIONS(2294),
    [sym_integer_literal] = ACTIONS(2296),
    [sym_null_literal] = ACTIONS(2296),
    [sym_real_literal] = ACTIONS(2294),
    [sym_verbatim_string_literal] = ACTIONS(2294),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2296),
    [anon_sym_nameof] = ACTIONS(2296),
    [sym_void_keyword] = ACTIONS(2296),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1700] = {
    [sym__preprocessor_call] = STATE(1700),
    [sym__identifier_token] = ACTIONS(2316),
    [anon_sym_extern] = ACTIONS(2316),
    [anon_sym_alias] = ACTIONS(2316),
    [anon_sym_SEMI] = ACTIONS(2314),
    [anon_sym_global] = ACTIONS(2316),
    [anon_sym_using] = ACTIONS(2316),
    [anon_sym_static] = ACTIONS(2316),
    [anon_sym_LBRACK] = ACTIONS(2314),
    [anon_sym_return] = ACTIONS(2316),
    [anon_sym_LPAREN] = ACTIONS(2314),
    [anon_sym_abstract] = ACTIONS(2316),
    [anon_sym_async] = ACTIONS(2316),
    [anon_sym_const] = ACTIONS(2316),
    [anon_sym_fixed] = ACTIONS(2316),
    [anon_sym_internal] = ACTIONS(2316),
    [anon_sym_new] = ACTIONS(2316),
    [anon_sym_override] = ACTIONS(2316),
    [anon_sym_partial] = ACTIONS(2316),
    [anon_sym_private] = ACTIONS(2316),
    [anon_sym_protected] = ACTIONS(2316),
    [anon_sym_public] = ACTIONS(2316),
    [anon_sym_readonly] = ACTIONS(2316),
    [anon_sym_ref] = ACTIONS(2316),
    [anon_sym_sealed] = ACTIONS(2316),
    [anon_sym_unsafe] = ACTIONS(2316),
    [anon_sym_virtual] = ACTIONS(2316),
    [anon_sym_volatile] = ACTIONS(2316),
    [anon_sym_this] = ACTIONS(2316),
    [anon_sym_base] = ACTIONS(2316),
    [anon_sym_LBRACE] = ACTIONS(2314),
    [anon_sym_RBRACE] = ACTIONS(2314),
    [anon_sym_TILDE] = ACTIONS(2314),
    [anon_sym_where] = ACTIONS(2316),
    [anon_sym_notnull] = ACTIONS(2316),
    [anon_sym_unmanaged] = ACTIONS(2316),
    [anon_sym_BANG] = ACTIONS(2314),
    [anon_sym_PLUS_PLUS] = ACTIONS(2314),
    [anon_sym_DASH_DASH] = ACTIONS(2314),
    [anon_sym_true] = ACTIONS(2316),
    [anon_sym_false] = ACTIONS(2316),
    [anon_sym_PLUS] = ACTIONS(2316),
    [anon_sym_DASH] = ACTIONS(2316),
    [anon_sym_STAR] = ACTIONS(2314),
    [anon_sym_CARET] = ACTIONS(2314),
    [anon_sym_AMP] = ACTIONS(2314),
    [anon_sym_get] = ACTIONS(2316),
    [anon_sym_set] = ACTIONS(2316),
    [anon_sym_add] = ACTIONS(2316),
    [anon_sym_remove] = ACTIONS(2316),
    [anon_sym_delegate] = ACTIONS(2316),
    [anon_sym_var] = ACTIONS(2316),
    [sym_predefined_type] = ACTIONS(2316),
    [anon_sym_break] = ACTIONS(2316),
    [anon_sym_checked] = ACTIONS(2316),
    [anon_sym_unchecked] = ACTIONS(2316),
    [anon_sym_continue] = ACTIONS(2316),
    [anon_sym_do] = ACTIONS(2316),
    [anon_sym_while] = ACTIONS(2316),
    [anon_sym_for] = ACTIONS(2316),
    [anon_sym_await] = ACTIONS(2316),
    [anon_sym_foreach] = ACTIONS(2316),
    [anon_sym_goto] = ACTIONS(2316),
    [anon_sym_case] = ACTIONS(2316),
    [anon_sym_default] = ACTIONS(2316),
    [anon_sym_if] = ACTIONS(2316),
    [anon_sym_else] = ACTIONS(2316),
    [anon_sym_lock] = ACTIONS(2316),
    [anon_sym_switch] = ACTIONS(2316),
    [anon_sym_when] = ACTIONS(2316),
    [anon_sym_throw] = ACTIONS(2316),
    [anon_sym_try] = ACTIONS(2316),
    [anon_sym_yield] = ACTIONS(2316),
    [anon_sym_stackalloc] = ACTIONS(2316),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2314),
    [anon_sym_DQUOTE] = ACTIONS(2314),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2314),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2314),
    [anon_sym___makeref] = ACTIONS(2316),
    [anon_sym_from] = ACTIONS(2316),
    [anon_sym_join] = ACTIONS(2316),
    [anon_sym_on] = ACTIONS(2316),
    [anon_sym_equals] = ACTIONS(2316),
    [anon_sym_into] = ACTIONS(2316),
    [anon_sym_let] = ACTIONS(2316),
    [anon_sym_orderby] = ACTIONS(2316),
    [anon_sym_ascending] = ACTIONS(2316),
    [anon_sym_descending] = ACTIONS(2316),
    [anon_sym_group] = ACTIONS(2316),
    [anon_sym_by] = ACTIONS(2316),
    [anon_sym_select] = ACTIONS(2316),
    [anon_sym_DOT_DOT] = ACTIONS(2314),
    [anon_sym___reftype] = ACTIONS(2316),
    [anon_sym___refvalue] = ACTIONS(2316),
    [anon_sym_sizeof] = ACTIONS(2316),
    [anon_sym_typeof] = ACTIONS(2316),
    [anon_sym_SQUOTE] = ACTIONS(2314),
    [sym_integer_literal] = ACTIONS(2316),
    [sym_null_literal] = ACTIONS(2316),
    [sym_real_literal] = ACTIONS(2314),
    [sym_verbatim_string_literal] = ACTIONS(2314),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2316),
    [anon_sym_nameof] = ACTIONS(2316),
    [sym_void_keyword] = ACTIONS(2316),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1701] = {
    [sym__preprocessor_call] = STATE(1701),
    [sym__identifier_token] = ACTIONS(2320),
    [anon_sym_extern] = ACTIONS(2320),
    [anon_sym_alias] = ACTIONS(2320),
    [anon_sym_SEMI] = ACTIONS(2318),
    [anon_sym_global] = ACTIONS(2320),
    [anon_sym_using] = ACTIONS(2320),
    [anon_sym_static] = ACTIONS(2320),
    [anon_sym_LBRACK] = ACTIONS(2318),
    [anon_sym_return] = ACTIONS(2320),
    [anon_sym_LPAREN] = ACTIONS(2318),
    [anon_sym_abstract] = ACTIONS(2320),
    [anon_sym_async] = ACTIONS(2320),
    [anon_sym_const] = ACTIONS(2320),
    [anon_sym_fixed] = ACTIONS(2320),
    [anon_sym_internal] = ACTIONS(2320),
    [anon_sym_new] = ACTIONS(2320),
    [anon_sym_override] = ACTIONS(2320),
    [anon_sym_partial] = ACTIONS(2320),
    [anon_sym_private] = ACTIONS(2320),
    [anon_sym_protected] = ACTIONS(2320),
    [anon_sym_public] = ACTIONS(2320),
    [anon_sym_readonly] = ACTIONS(2320),
    [anon_sym_ref] = ACTIONS(2320),
    [anon_sym_sealed] = ACTIONS(2320),
    [anon_sym_unsafe] = ACTIONS(2320),
    [anon_sym_virtual] = ACTIONS(2320),
    [anon_sym_volatile] = ACTIONS(2320),
    [anon_sym_this] = ACTIONS(2320),
    [anon_sym_base] = ACTIONS(2320),
    [anon_sym_LBRACE] = ACTIONS(2318),
    [anon_sym_RBRACE] = ACTIONS(2318),
    [anon_sym_TILDE] = ACTIONS(2318),
    [anon_sym_where] = ACTIONS(2320),
    [anon_sym_notnull] = ACTIONS(2320),
    [anon_sym_unmanaged] = ACTIONS(2320),
    [anon_sym_BANG] = ACTIONS(2318),
    [anon_sym_PLUS_PLUS] = ACTIONS(2318),
    [anon_sym_DASH_DASH] = ACTIONS(2318),
    [anon_sym_true] = ACTIONS(2320),
    [anon_sym_false] = ACTIONS(2320),
    [anon_sym_PLUS] = ACTIONS(2320),
    [anon_sym_DASH] = ACTIONS(2320),
    [anon_sym_STAR] = ACTIONS(2318),
    [anon_sym_CARET] = ACTIONS(2318),
    [anon_sym_AMP] = ACTIONS(2318),
    [anon_sym_get] = ACTIONS(2320),
    [anon_sym_set] = ACTIONS(2320),
    [anon_sym_add] = ACTIONS(2320),
    [anon_sym_remove] = ACTIONS(2320),
    [anon_sym_delegate] = ACTIONS(2320),
    [anon_sym_var] = ACTIONS(2320),
    [sym_predefined_type] = ACTIONS(2320),
    [anon_sym_break] = ACTIONS(2320),
    [anon_sym_checked] = ACTIONS(2320),
    [anon_sym_unchecked] = ACTIONS(2320),
    [anon_sym_continue] = ACTIONS(2320),
    [anon_sym_do] = ACTIONS(2320),
    [anon_sym_while] = ACTIONS(2320),
    [anon_sym_for] = ACTIONS(2320),
    [anon_sym_await] = ACTIONS(2320),
    [anon_sym_foreach] = ACTIONS(2320),
    [anon_sym_goto] = ACTIONS(2320),
    [anon_sym_case] = ACTIONS(2320),
    [anon_sym_default] = ACTIONS(2320),
    [anon_sym_if] = ACTIONS(2320),
    [anon_sym_else] = ACTIONS(2320),
    [anon_sym_lock] = ACTIONS(2320),
    [anon_sym_switch] = ACTIONS(2320),
    [anon_sym_when] = ACTIONS(2320),
    [anon_sym_throw] = ACTIONS(2320),
    [anon_sym_try] = ACTIONS(2320),
    [anon_sym_yield] = ACTIONS(2320),
    [anon_sym_stackalloc] = ACTIONS(2320),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2318),
    [anon_sym_DQUOTE] = ACTIONS(2318),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2318),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2318),
    [anon_sym___makeref] = ACTIONS(2320),
    [anon_sym_from] = ACTIONS(2320),
    [anon_sym_join] = ACTIONS(2320),
    [anon_sym_on] = ACTIONS(2320),
    [anon_sym_equals] = ACTIONS(2320),
    [anon_sym_into] = ACTIONS(2320),
    [anon_sym_let] = ACTIONS(2320),
    [anon_sym_orderby] = ACTIONS(2320),
    [anon_sym_ascending] = ACTIONS(2320),
    [anon_sym_descending] = ACTIONS(2320),
    [anon_sym_group] = ACTIONS(2320),
    [anon_sym_by] = ACTIONS(2320),
    [anon_sym_select] = ACTIONS(2320),
    [anon_sym_DOT_DOT] = ACTIONS(2318),
    [anon_sym___reftype] = ACTIONS(2320),
    [anon_sym___refvalue] = ACTIONS(2320),
    [anon_sym_sizeof] = ACTIONS(2320),
    [anon_sym_typeof] = ACTIONS(2320),
    [anon_sym_SQUOTE] = ACTIONS(2318),
    [sym_integer_literal] = ACTIONS(2320),
    [sym_null_literal] = ACTIONS(2320),
    [sym_real_literal] = ACTIONS(2318),
    [sym_verbatim_string_literal] = ACTIONS(2318),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2320),
    [anon_sym_nameof] = ACTIONS(2320),
    [sym_void_keyword] = ACTIONS(2320),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1702] = {
    [sym__preprocessor_call] = STATE(1702),
    [sym__identifier_token] = ACTIONS(2364),
    [anon_sym_extern] = ACTIONS(2364),
    [anon_sym_alias] = ACTIONS(2364),
    [anon_sym_SEMI] = ACTIONS(2362),
    [anon_sym_global] = ACTIONS(2364),
    [anon_sym_using] = ACTIONS(2364),
    [anon_sym_static] = ACTIONS(2364),
    [anon_sym_LBRACK] = ACTIONS(2362),
    [anon_sym_return] = ACTIONS(2364),
    [anon_sym_LPAREN] = ACTIONS(2362),
    [anon_sym_abstract] = ACTIONS(2364),
    [anon_sym_async] = ACTIONS(2364),
    [anon_sym_const] = ACTIONS(2364),
    [anon_sym_fixed] = ACTIONS(2364),
    [anon_sym_internal] = ACTIONS(2364),
    [anon_sym_new] = ACTIONS(2364),
    [anon_sym_override] = ACTIONS(2364),
    [anon_sym_partial] = ACTIONS(2364),
    [anon_sym_private] = ACTIONS(2364),
    [anon_sym_protected] = ACTIONS(2364),
    [anon_sym_public] = ACTIONS(2364),
    [anon_sym_readonly] = ACTIONS(2364),
    [anon_sym_ref] = ACTIONS(2364),
    [anon_sym_sealed] = ACTIONS(2364),
    [anon_sym_unsafe] = ACTIONS(2364),
    [anon_sym_virtual] = ACTIONS(2364),
    [anon_sym_volatile] = ACTIONS(2364),
    [anon_sym_this] = ACTIONS(2364),
    [anon_sym_base] = ACTIONS(2364),
    [anon_sym_LBRACE] = ACTIONS(2362),
    [anon_sym_RBRACE] = ACTIONS(2362),
    [anon_sym_TILDE] = ACTIONS(2362),
    [anon_sym_where] = ACTIONS(2364),
    [anon_sym_notnull] = ACTIONS(2364),
    [anon_sym_unmanaged] = ACTIONS(2364),
    [anon_sym_BANG] = ACTIONS(2362),
    [anon_sym_PLUS_PLUS] = ACTIONS(2362),
    [anon_sym_DASH_DASH] = ACTIONS(2362),
    [anon_sym_true] = ACTIONS(2364),
    [anon_sym_false] = ACTIONS(2364),
    [anon_sym_PLUS] = ACTIONS(2364),
    [anon_sym_DASH] = ACTIONS(2364),
    [anon_sym_STAR] = ACTIONS(2362),
    [anon_sym_CARET] = ACTIONS(2362),
    [anon_sym_AMP] = ACTIONS(2362),
    [anon_sym_get] = ACTIONS(2364),
    [anon_sym_set] = ACTIONS(2364),
    [anon_sym_add] = ACTIONS(2364),
    [anon_sym_remove] = ACTIONS(2364),
    [anon_sym_delegate] = ACTIONS(2364),
    [anon_sym_var] = ACTIONS(2364),
    [sym_predefined_type] = ACTIONS(2364),
    [anon_sym_break] = ACTIONS(2364),
    [anon_sym_checked] = ACTIONS(2364),
    [anon_sym_unchecked] = ACTIONS(2364),
    [anon_sym_continue] = ACTIONS(2364),
    [anon_sym_do] = ACTIONS(2364),
    [anon_sym_while] = ACTIONS(2364),
    [anon_sym_for] = ACTIONS(2364),
    [anon_sym_await] = ACTIONS(2364),
    [anon_sym_foreach] = ACTIONS(2364),
    [anon_sym_goto] = ACTIONS(2364),
    [anon_sym_case] = ACTIONS(2364),
    [anon_sym_default] = ACTIONS(2364),
    [anon_sym_if] = ACTIONS(2364),
    [anon_sym_else] = ACTIONS(2364),
    [anon_sym_lock] = ACTIONS(2364),
    [anon_sym_switch] = ACTIONS(2364),
    [anon_sym_when] = ACTIONS(2364),
    [anon_sym_throw] = ACTIONS(2364),
    [anon_sym_try] = ACTIONS(2364),
    [anon_sym_yield] = ACTIONS(2364),
    [anon_sym_stackalloc] = ACTIONS(2364),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2362),
    [anon_sym_DQUOTE] = ACTIONS(2362),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2362),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2362),
    [anon_sym___makeref] = ACTIONS(2364),
    [anon_sym_from] = ACTIONS(2364),
    [anon_sym_join] = ACTIONS(2364),
    [anon_sym_on] = ACTIONS(2364),
    [anon_sym_equals] = ACTIONS(2364),
    [anon_sym_into] = ACTIONS(2364),
    [anon_sym_let] = ACTIONS(2364),
    [anon_sym_orderby] = ACTIONS(2364),
    [anon_sym_ascending] = ACTIONS(2364),
    [anon_sym_descending] = ACTIONS(2364),
    [anon_sym_group] = ACTIONS(2364),
    [anon_sym_by] = ACTIONS(2364),
    [anon_sym_select] = ACTIONS(2364),
    [anon_sym_DOT_DOT] = ACTIONS(2362),
    [anon_sym___reftype] = ACTIONS(2364),
    [anon_sym___refvalue] = ACTIONS(2364),
    [anon_sym_sizeof] = ACTIONS(2364),
    [anon_sym_typeof] = ACTIONS(2364),
    [anon_sym_SQUOTE] = ACTIONS(2362),
    [sym_integer_literal] = ACTIONS(2364),
    [sym_null_literal] = ACTIONS(2364),
    [sym_real_literal] = ACTIONS(2362),
    [sym_verbatim_string_literal] = ACTIONS(2362),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2364),
    [anon_sym_nameof] = ACTIONS(2364),
    [sym_void_keyword] = ACTIONS(2364),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1703] = {
    [sym__preprocessor_call] = STATE(1703),
    [sym__identifier_token] = ACTIONS(2422),
    [anon_sym_extern] = ACTIONS(2422),
    [anon_sym_alias] = ACTIONS(2422),
    [anon_sym_SEMI] = ACTIONS(2420),
    [anon_sym_global] = ACTIONS(2422),
    [anon_sym_using] = ACTIONS(2422),
    [anon_sym_static] = ACTIONS(2422),
    [anon_sym_LBRACK] = ACTIONS(2420),
    [anon_sym_return] = ACTIONS(2422),
    [anon_sym_LPAREN] = ACTIONS(2420),
    [anon_sym_abstract] = ACTIONS(2422),
    [anon_sym_async] = ACTIONS(2422),
    [anon_sym_const] = ACTIONS(2422),
    [anon_sym_fixed] = ACTIONS(2422),
    [anon_sym_internal] = ACTIONS(2422),
    [anon_sym_new] = ACTIONS(2422),
    [anon_sym_override] = ACTIONS(2422),
    [anon_sym_partial] = ACTIONS(2422),
    [anon_sym_private] = ACTIONS(2422),
    [anon_sym_protected] = ACTIONS(2422),
    [anon_sym_public] = ACTIONS(2422),
    [anon_sym_readonly] = ACTIONS(2422),
    [anon_sym_ref] = ACTIONS(2422),
    [anon_sym_sealed] = ACTIONS(2422),
    [anon_sym_unsafe] = ACTIONS(2422),
    [anon_sym_virtual] = ACTIONS(2422),
    [anon_sym_volatile] = ACTIONS(2422),
    [anon_sym_this] = ACTIONS(2422),
    [anon_sym_base] = ACTIONS(2422),
    [anon_sym_LBRACE] = ACTIONS(2420),
    [anon_sym_RBRACE] = ACTIONS(2420),
    [anon_sym_TILDE] = ACTIONS(2420),
    [anon_sym_where] = ACTIONS(2422),
    [anon_sym_notnull] = ACTIONS(2422),
    [anon_sym_unmanaged] = ACTIONS(2422),
    [anon_sym_BANG] = ACTIONS(2420),
    [anon_sym_PLUS_PLUS] = ACTIONS(2420),
    [anon_sym_DASH_DASH] = ACTIONS(2420),
    [anon_sym_true] = ACTIONS(2422),
    [anon_sym_false] = ACTIONS(2422),
    [anon_sym_PLUS] = ACTIONS(2422),
    [anon_sym_DASH] = ACTIONS(2422),
    [anon_sym_STAR] = ACTIONS(2420),
    [anon_sym_CARET] = ACTIONS(2420),
    [anon_sym_AMP] = ACTIONS(2420),
    [anon_sym_get] = ACTIONS(2422),
    [anon_sym_set] = ACTIONS(2422),
    [anon_sym_add] = ACTIONS(2422),
    [anon_sym_remove] = ACTIONS(2422),
    [anon_sym_delegate] = ACTIONS(2422),
    [anon_sym_var] = ACTIONS(2422),
    [sym_predefined_type] = ACTIONS(2422),
    [anon_sym_break] = ACTIONS(2422),
    [anon_sym_checked] = ACTIONS(2422),
    [anon_sym_unchecked] = ACTIONS(2422),
    [anon_sym_continue] = ACTIONS(2422),
    [anon_sym_do] = ACTIONS(2422),
    [anon_sym_while] = ACTIONS(2422),
    [anon_sym_for] = ACTIONS(2422),
    [anon_sym_await] = ACTIONS(2422),
    [anon_sym_foreach] = ACTIONS(2422),
    [anon_sym_goto] = ACTIONS(2422),
    [anon_sym_case] = ACTIONS(2422),
    [anon_sym_default] = ACTIONS(2422),
    [anon_sym_if] = ACTIONS(2422),
    [anon_sym_else] = ACTIONS(2422),
    [anon_sym_lock] = ACTIONS(2422),
    [anon_sym_switch] = ACTIONS(2422),
    [anon_sym_when] = ACTIONS(2422),
    [anon_sym_throw] = ACTIONS(2422),
    [anon_sym_try] = ACTIONS(2422),
    [anon_sym_yield] = ACTIONS(2422),
    [anon_sym_stackalloc] = ACTIONS(2422),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2420),
    [anon_sym_DQUOTE] = ACTIONS(2420),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2420),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2420),
    [anon_sym___makeref] = ACTIONS(2422),
    [anon_sym_from] = ACTIONS(2422),
    [anon_sym_join] = ACTIONS(2422),
    [anon_sym_on] = ACTIONS(2422),
    [anon_sym_equals] = ACTIONS(2422),
    [anon_sym_into] = ACTIONS(2422),
    [anon_sym_let] = ACTIONS(2422),
    [anon_sym_orderby] = ACTIONS(2422),
    [anon_sym_ascending] = ACTIONS(2422),
    [anon_sym_descending] = ACTIONS(2422),
    [anon_sym_group] = ACTIONS(2422),
    [anon_sym_by] = ACTIONS(2422),
    [anon_sym_select] = ACTIONS(2422),
    [anon_sym_DOT_DOT] = ACTIONS(2420),
    [anon_sym___reftype] = ACTIONS(2422),
    [anon_sym___refvalue] = ACTIONS(2422),
    [anon_sym_sizeof] = ACTIONS(2422),
    [anon_sym_typeof] = ACTIONS(2422),
    [anon_sym_SQUOTE] = ACTIONS(2420),
    [sym_integer_literal] = ACTIONS(2422),
    [sym_null_literal] = ACTIONS(2422),
    [sym_real_literal] = ACTIONS(2420),
    [sym_verbatim_string_literal] = ACTIONS(2420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2422),
    [anon_sym_nameof] = ACTIONS(2422),
    [sym_void_keyword] = ACTIONS(2422),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1704] = {
    [sym__preprocessor_call] = STATE(1704),
    [sym__identifier_token] = ACTIONS(2490),
    [anon_sym_extern] = ACTIONS(2490),
    [anon_sym_alias] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(2488),
    [anon_sym_global] = ACTIONS(2490),
    [anon_sym_using] = ACTIONS(2490),
    [anon_sym_static] = ACTIONS(2490),
    [anon_sym_LBRACK] = ACTIONS(2488),
    [anon_sym_return] = ACTIONS(2490),
    [anon_sym_LPAREN] = ACTIONS(2488),
    [anon_sym_abstract] = ACTIONS(2490),
    [anon_sym_async] = ACTIONS(2490),
    [anon_sym_const] = ACTIONS(2490),
    [anon_sym_fixed] = ACTIONS(2490),
    [anon_sym_internal] = ACTIONS(2490),
    [anon_sym_new] = ACTIONS(2490),
    [anon_sym_override] = ACTIONS(2490),
    [anon_sym_partial] = ACTIONS(2490),
    [anon_sym_private] = ACTIONS(2490),
    [anon_sym_protected] = ACTIONS(2490),
    [anon_sym_public] = ACTIONS(2490),
    [anon_sym_readonly] = ACTIONS(2490),
    [anon_sym_ref] = ACTIONS(2490),
    [anon_sym_sealed] = ACTIONS(2490),
    [anon_sym_unsafe] = ACTIONS(2490),
    [anon_sym_virtual] = ACTIONS(2490),
    [anon_sym_volatile] = ACTIONS(2490),
    [anon_sym_this] = ACTIONS(2490),
    [anon_sym_base] = ACTIONS(2490),
    [anon_sym_LBRACE] = ACTIONS(2488),
    [anon_sym_RBRACE] = ACTIONS(2488),
    [anon_sym_TILDE] = ACTIONS(2488),
    [anon_sym_where] = ACTIONS(2490),
    [anon_sym_notnull] = ACTIONS(2490),
    [anon_sym_unmanaged] = ACTIONS(2490),
    [anon_sym_BANG] = ACTIONS(2488),
    [anon_sym_PLUS_PLUS] = ACTIONS(2488),
    [anon_sym_DASH_DASH] = ACTIONS(2488),
    [anon_sym_true] = ACTIONS(2490),
    [anon_sym_false] = ACTIONS(2490),
    [anon_sym_PLUS] = ACTIONS(2490),
    [anon_sym_DASH] = ACTIONS(2490),
    [anon_sym_STAR] = ACTIONS(2488),
    [anon_sym_CARET] = ACTIONS(2488),
    [anon_sym_AMP] = ACTIONS(2488),
    [anon_sym_get] = ACTIONS(2490),
    [anon_sym_set] = ACTIONS(2490),
    [anon_sym_add] = ACTIONS(2490),
    [anon_sym_remove] = ACTIONS(2490),
    [anon_sym_delegate] = ACTIONS(2490),
    [anon_sym_var] = ACTIONS(2490),
    [sym_predefined_type] = ACTIONS(2490),
    [anon_sym_break] = ACTIONS(2490),
    [anon_sym_checked] = ACTIONS(2490),
    [anon_sym_unchecked] = ACTIONS(2490),
    [anon_sym_continue] = ACTIONS(2490),
    [anon_sym_do] = ACTIONS(2490),
    [anon_sym_while] = ACTIONS(2490),
    [anon_sym_for] = ACTIONS(2490),
    [anon_sym_await] = ACTIONS(2490),
    [anon_sym_foreach] = ACTIONS(2490),
    [anon_sym_goto] = ACTIONS(2490),
    [anon_sym_case] = ACTIONS(2490),
    [anon_sym_default] = ACTIONS(2490),
    [anon_sym_if] = ACTIONS(2490),
    [anon_sym_else] = ACTIONS(2490),
    [anon_sym_lock] = ACTIONS(2490),
    [anon_sym_switch] = ACTIONS(2490),
    [anon_sym_when] = ACTIONS(2490),
    [anon_sym_throw] = ACTIONS(2490),
    [anon_sym_try] = ACTIONS(2490),
    [anon_sym_yield] = ACTIONS(2490),
    [anon_sym_stackalloc] = ACTIONS(2490),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2488),
    [anon_sym_DQUOTE] = ACTIONS(2488),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2488),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2488),
    [anon_sym___makeref] = ACTIONS(2490),
    [anon_sym_from] = ACTIONS(2490),
    [anon_sym_join] = ACTIONS(2490),
    [anon_sym_on] = ACTIONS(2490),
    [anon_sym_equals] = ACTIONS(2490),
    [anon_sym_into] = ACTIONS(2490),
    [anon_sym_let] = ACTIONS(2490),
    [anon_sym_orderby] = ACTIONS(2490),
    [anon_sym_ascending] = ACTIONS(2490),
    [anon_sym_descending] = ACTIONS(2490),
    [anon_sym_group] = ACTIONS(2490),
    [anon_sym_by] = ACTIONS(2490),
    [anon_sym_select] = ACTIONS(2490),
    [anon_sym_DOT_DOT] = ACTIONS(2488),
    [anon_sym___reftype] = ACTIONS(2490),
    [anon_sym___refvalue] = ACTIONS(2490),
    [anon_sym_sizeof] = ACTIONS(2490),
    [anon_sym_typeof] = ACTIONS(2490),
    [anon_sym_SQUOTE] = ACTIONS(2488),
    [sym_integer_literal] = ACTIONS(2490),
    [sym_null_literal] = ACTIONS(2490),
    [sym_real_literal] = ACTIONS(2488),
    [sym_verbatim_string_literal] = ACTIONS(2488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2490),
    [anon_sym_nameof] = ACTIONS(2490),
    [sym_void_keyword] = ACTIONS(2490),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1705] = {
    [sym__preprocessor_call] = STATE(1705),
    [sym__identifier_token] = ACTIONS(2522),
    [anon_sym_extern] = ACTIONS(2522),
    [anon_sym_alias] = ACTIONS(2522),
    [anon_sym_SEMI] = ACTIONS(2520),
    [anon_sym_global] = ACTIONS(2522),
    [anon_sym_using] = ACTIONS(2522),
    [anon_sym_static] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_abstract] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(2522),
    [anon_sym_const] = ACTIONS(2522),
    [anon_sym_fixed] = ACTIONS(2522),
    [anon_sym_internal] = ACTIONS(2522),
    [anon_sym_new] = ACTIONS(2522),
    [anon_sym_override] = ACTIONS(2522),
    [anon_sym_partial] = ACTIONS(2522),
    [anon_sym_private] = ACTIONS(2522),
    [anon_sym_protected] = ACTIONS(2522),
    [anon_sym_public] = ACTIONS(2522),
    [anon_sym_readonly] = ACTIONS(2522),
    [anon_sym_ref] = ACTIONS(2522),
    [anon_sym_sealed] = ACTIONS(2522),
    [anon_sym_unsafe] = ACTIONS(2522),
    [anon_sym_virtual] = ACTIONS(2522),
    [anon_sym_volatile] = ACTIONS(2522),
    [anon_sym_this] = ACTIONS(2522),
    [anon_sym_base] = ACTIONS(2522),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [anon_sym_RBRACE] = ACTIONS(2520),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_where] = ACTIONS(2522),
    [anon_sym_notnull] = ACTIONS(2522),
    [anon_sym_unmanaged] = ACTIONS(2522),
    [anon_sym_BANG] = ACTIONS(2520),
    [anon_sym_PLUS_PLUS] = ACTIONS(2520),
    [anon_sym_DASH_DASH] = ACTIONS(2520),
    [anon_sym_true] = ACTIONS(2522),
    [anon_sym_false] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2522),
    [anon_sym_DASH] = ACTIONS(2522),
    [anon_sym_STAR] = ACTIONS(2520),
    [anon_sym_CARET] = ACTIONS(2520),
    [anon_sym_AMP] = ACTIONS(2520),
    [anon_sym_get] = ACTIONS(2522),
    [anon_sym_set] = ACTIONS(2522),
    [anon_sym_add] = ACTIONS(2522),
    [anon_sym_remove] = ACTIONS(2522),
    [anon_sym_delegate] = ACTIONS(2522),
    [anon_sym_var] = ACTIONS(2522),
    [sym_predefined_type] = ACTIONS(2522),
    [anon_sym_break] = ACTIONS(2522),
    [anon_sym_checked] = ACTIONS(2522),
    [anon_sym_unchecked] = ACTIONS(2522),
    [anon_sym_continue] = ACTIONS(2522),
    [anon_sym_do] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_await] = ACTIONS(2522),
    [anon_sym_foreach] = ACTIONS(2522),
    [anon_sym_goto] = ACTIONS(2522),
    [anon_sym_case] = ACTIONS(2522),
    [anon_sym_default] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_else] = ACTIONS(2522),
    [anon_sym_lock] = ACTIONS(2522),
    [anon_sym_switch] = ACTIONS(2522),
    [anon_sym_when] = ACTIONS(2522),
    [anon_sym_throw] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_yield] = ACTIONS(2522),
    [anon_sym_stackalloc] = ACTIONS(2522),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2520),
    [anon_sym_DQUOTE] = ACTIONS(2520),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2520),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2520),
    [anon_sym___makeref] = ACTIONS(2522),
    [anon_sym_from] = ACTIONS(2522),
    [anon_sym_join] = ACTIONS(2522),
    [anon_sym_on] = ACTIONS(2522),
    [anon_sym_equals] = ACTIONS(2522),
    [anon_sym_into] = ACTIONS(2522),
    [anon_sym_let] = ACTIONS(2522),
    [anon_sym_orderby] = ACTIONS(2522),
    [anon_sym_ascending] = ACTIONS(2522),
    [anon_sym_descending] = ACTIONS(2522),
    [anon_sym_group] = ACTIONS(2522),
    [anon_sym_by] = ACTIONS(2522),
    [anon_sym_select] = ACTIONS(2522),
    [anon_sym_DOT_DOT] = ACTIONS(2520),
    [anon_sym___reftype] = ACTIONS(2522),
    [anon_sym___refvalue] = ACTIONS(2522),
    [anon_sym_sizeof] = ACTIONS(2522),
    [anon_sym_typeof] = ACTIONS(2522),
    [anon_sym_SQUOTE] = ACTIONS(2520),
    [sym_integer_literal] = ACTIONS(2522),
    [sym_null_literal] = ACTIONS(2522),
    [sym_real_literal] = ACTIONS(2520),
    [sym_verbatim_string_literal] = ACTIONS(2520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2522),
    [anon_sym_nameof] = ACTIONS(2522),
    [sym_void_keyword] = ACTIONS(2522),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1706] = {
    [sym__preprocessor_call] = STATE(1706),
    [sym__identifier_token] = ACTIONS(2372),
    [anon_sym_extern] = ACTIONS(2372),
    [anon_sym_alias] = ACTIONS(2372),
    [anon_sym_SEMI] = ACTIONS(2370),
    [anon_sym_global] = ACTIONS(2372),
    [anon_sym_using] = ACTIONS(2372),
    [anon_sym_static] = ACTIONS(2372),
    [anon_sym_LBRACK] = ACTIONS(2370),
    [anon_sym_return] = ACTIONS(2372),
    [anon_sym_LPAREN] = ACTIONS(2370),
    [anon_sym_abstract] = ACTIONS(2372),
    [anon_sym_async] = ACTIONS(2372),
    [anon_sym_const] = ACTIONS(2372),
    [anon_sym_fixed] = ACTIONS(2372),
    [anon_sym_internal] = ACTIONS(2372),
    [anon_sym_new] = ACTIONS(2372),
    [anon_sym_override] = ACTIONS(2372),
    [anon_sym_partial] = ACTIONS(2372),
    [anon_sym_private] = ACTIONS(2372),
    [anon_sym_protected] = ACTIONS(2372),
    [anon_sym_public] = ACTIONS(2372),
    [anon_sym_readonly] = ACTIONS(2372),
    [anon_sym_ref] = ACTIONS(2372),
    [anon_sym_sealed] = ACTIONS(2372),
    [anon_sym_unsafe] = ACTIONS(2372),
    [anon_sym_virtual] = ACTIONS(2372),
    [anon_sym_volatile] = ACTIONS(2372),
    [anon_sym_this] = ACTIONS(2372),
    [anon_sym_base] = ACTIONS(2372),
    [anon_sym_LBRACE] = ACTIONS(2370),
    [anon_sym_RBRACE] = ACTIONS(2370),
    [anon_sym_TILDE] = ACTIONS(2370),
    [anon_sym_where] = ACTIONS(2372),
    [anon_sym_notnull] = ACTIONS(2372),
    [anon_sym_unmanaged] = ACTIONS(2372),
    [anon_sym_BANG] = ACTIONS(2370),
    [anon_sym_PLUS_PLUS] = ACTIONS(2370),
    [anon_sym_DASH_DASH] = ACTIONS(2370),
    [anon_sym_true] = ACTIONS(2372),
    [anon_sym_false] = ACTIONS(2372),
    [anon_sym_PLUS] = ACTIONS(2372),
    [anon_sym_DASH] = ACTIONS(2372),
    [anon_sym_STAR] = ACTIONS(2370),
    [anon_sym_CARET] = ACTIONS(2370),
    [anon_sym_AMP] = ACTIONS(2370),
    [anon_sym_get] = ACTIONS(2372),
    [anon_sym_set] = ACTIONS(2372),
    [anon_sym_add] = ACTIONS(2372),
    [anon_sym_remove] = ACTIONS(2372),
    [anon_sym_delegate] = ACTIONS(2372),
    [anon_sym_var] = ACTIONS(2372),
    [sym_predefined_type] = ACTIONS(2372),
    [anon_sym_break] = ACTIONS(2372),
    [anon_sym_checked] = ACTIONS(2372),
    [anon_sym_unchecked] = ACTIONS(2372),
    [anon_sym_continue] = ACTIONS(2372),
    [anon_sym_do] = ACTIONS(2372),
    [anon_sym_while] = ACTIONS(2372),
    [anon_sym_for] = ACTIONS(2372),
    [anon_sym_await] = ACTIONS(2372),
    [anon_sym_foreach] = ACTIONS(2372),
    [anon_sym_goto] = ACTIONS(2372),
    [anon_sym_case] = ACTIONS(2372),
    [anon_sym_default] = ACTIONS(2372),
    [anon_sym_if] = ACTIONS(2372),
    [anon_sym_else] = ACTIONS(2372),
    [anon_sym_lock] = ACTIONS(2372),
    [anon_sym_switch] = ACTIONS(2372),
    [anon_sym_when] = ACTIONS(2372),
    [anon_sym_throw] = ACTIONS(2372),
    [anon_sym_try] = ACTIONS(2372),
    [anon_sym_yield] = ACTIONS(2372),
    [anon_sym_stackalloc] = ACTIONS(2372),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2370),
    [anon_sym_DQUOTE] = ACTIONS(2370),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2370),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2370),
    [anon_sym___makeref] = ACTIONS(2372),
    [anon_sym_from] = ACTIONS(2372),
    [anon_sym_join] = ACTIONS(2372),
    [anon_sym_on] = ACTIONS(2372),
    [anon_sym_equals] = ACTIONS(2372),
    [anon_sym_into] = ACTIONS(2372),
    [anon_sym_let] = ACTIONS(2372),
    [anon_sym_orderby] = ACTIONS(2372),
    [anon_sym_ascending] = ACTIONS(2372),
    [anon_sym_descending] = ACTIONS(2372),
    [anon_sym_group] = ACTIONS(2372),
    [anon_sym_by] = ACTIONS(2372),
    [anon_sym_select] = ACTIONS(2372),
    [anon_sym_DOT_DOT] = ACTIONS(2370),
    [anon_sym___reftype] = ACTIONS(2372),
    [anon_sym___refvalue] = ACTIONS(2372),
    [anon_sym_sizeof] = ACTIONS(2372),
    [anon_sym_typeof] = ACTIONS(2372),
    [anon_sym_SQUOTE] = ACTIONS(2370),
    [sym_integer_literal] = ACTIONS(2372),
    [sym_null_literal] = ACTIONS(2372),
    [sym_real_literal] = ACTIONS(2370),
    [sym_verbatim_string_literal] = ACTIONS(2370),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2372),
    [anon_sym_nameof] = ACTIONS(2372),
    [sym_void_keyword] = ACTIONS(2372),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1707] = {
    [sym__preprocessor_call] = STATE(1707),
    [sym__identifier_token] = ACTIONS(2308),
    [anon_sym_extern] = ACTIONS(2308),
    [anon_sym_alias] = ACTIONS(2308),
    [anon_sym_SEMI] = ACTIONS(2306),
    [anon_sym_global] = ACTIONS(2308),
    [anon_sym_using] = ACTIONS(2308),
    [anon_sym_static] = ACTIONS(2308),
    [anon_sym_LBRACK] = ACTIONS(2306),
    [anon_sym_return] = ACTIONS(2308),
    [anon_sym_LPAREN] = ACTIONS(2306),
    [anon_sym_abstract] = ACTIONS(2308),
    [anon_sym_async] = ACTIONS(2308),
    [anon_sym_const] = ACTIONS(2308),
    [anon_sym_fixed] = ACTIONS(2308),
    [anon_sym_internal] = ACTIONS(2308),
    [anon_sym_new] = ACTIONS(2308),
    [anon_sym_override] = ACTIONS(2308),
    [anon_sym_partial] = ACTIONS(2308),
    [anon_sym_private] = ACTIONS(2308),
    [anon_sym_protected] = ACTIONS(2308),
    [anon_sym_public] = ACTIONS(2308),
    [anon_sym_readonly] = ACTIONS(2308),
    [anon_sym_ref] = ACTIONS(2308),
    [anon_sym_sealed] = ACTIONS(2308),
    [anon_sym_unsafe] = ACTIONS(2308),
    [anon_sym_virtual] = ACTIONS(2308),
    [anon_sym_volatile] = ACTIONS(2308),
    [anon_sym_this] = ACTIONS(2308),
    [anon_sym_base] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(2306),
    [anon_sym_RBRACE] = ACTIONS(2306),
    [anon_sym_TILDE] = ACTIONS(2306),
    [anon_sym_where] = ACTIONS(2308),
    [anon_sym_notnull] = ACTIONS(2308),
    [anon_sym_unmanaged] = ACTIONS(2308),
    [anon_sym_BANG] = ACTIONS(2306),
    [anon_sym_PLUS_PLUS] = ACTIONS(2306),
    [anon_sym_DASH_DASH] = ACTIONS(2306),
    [anon_sym_true] = ACTIONS(2308),
    [anon_sym_false] = ACTIONS(2308),
    [anon_sym_PLUS] = ACTIONS(2308),
    [anon_sym_DASH] = ACTIONS(2308),
    [anon_sym_STAR] = ACTIONS(2306),
    [anon_sym_CARET] = ACTIONS(2306),
    [anon_sym_AMP] = ACTIONS(2306),
    [anon_sym_get] = ACTIONS(2308),
    [anon_sym_set] = ACTIONS(2308),
    [anon_sym_add] = ACTIONS(2308),
    [anon_sym_remove] = ACTIONS(2308),
    [anon_sym_delegate] = ACTIONS(2308),
    [anon_sym_var] = ACTIONS(2308),
    [sym_predefined_type] = ACTIONS(2308),
    [anon_sym_break] = ACTIONS(2308),
    [anon_sym_checked] = ACTIONS(2308),
    [anon_sym_unchecked] = ACTIONS(2308),
    [anon_sym_continue] = ACTIONS(2308),
    [anon_sym_do] = ACTIONS(2308),
    [anon_sym_while] = ACTIONS(2308),
    [anon_sym_for] = ACTIONS(2308),
    [anon_sym_await] = ACTIONS(2308),
    [anon_sym_foreach] = ACTIONS(2308),
    [anon_sym_goto] = ACTIONS(2308),
    [anon_sym_case] = ACTIONS(2308),
    [anon_sym_default] = ACTIONS(2308),
    [anon_sym_if] = ACTIONS(2308),
    [anon_sym_else] = ACTIONS(2308),
    [anon_sym_lock] = ACTIONS(2308),
    [anon_sym_switch] = ACTIONS(2308),
    [anon_sym_when] = ACTIONS(2308),
    [anon_sym_throw] = ACTIONS(2308),
    [anon_sym_try] = ACTIONS(2308),
    [anon_sym_yield] = ACTIONS(2308),
    [anon_sym_stackalloc] = ACTIONS(2308),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2306),
    [anon_sym_DQUOTE] = ACTIONS(2306),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2306),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2306),
    [anon_sym___makeref] = ACTIONS(2308),
    [anon_sym_from] = ACTIONS(2308),
    [anon_sym_join] = ACTIONS(2308),
    [anon_sym_on] = ACTIONS(2308),
    [anon_sym_equals] = ACTIONS(2308),
    [anon_sym_into] = ACTIONS(2308),
    [anon_sym_let] = ACTIONS(2308),
    [anon_sym_orderby] = ACTIONS(2308),
    [anon_sym_ascending] = ACTIONS(2308),
    [anon_sym_descending] = ACTIONS(2308),
    [anon_sym_group] = ACTIONS(2308),
    [anon_sym_by] = ACTIONS(2308),
    [anon_sym_select] = ACTIONS(2308),
    [anon_sym_DOT_DOT] = ACTIONS(2306),
    [anon_sym___reftype] = ACTIONS(2308),
    [anon_sym___refvalue] = ACTIONS(2308),
    [anon_sym_sizeof] = ACTIONS(2308),
    [anon_sym_typeof] = ACTIONS(2308),
    [anon_sym_SQUOTE] = ACTIONS(2306),
    [sym_integer_literal] = ACTIONS(2308),
    [sym_null_literal] = ACTIONS(2308),
    [sym_real_literal] = ACTIONS(2306),
    [sym_verbatim_string_literal] = ACTIONS(2306),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2308),
    [anon_sym_nameof] = ACTIONS(2308),
    [sym_void_keyword] = ACTIONS(2308),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1708] = {
    [sym__preprocessor_call] = STATE(1708),
    [sym__identifier_token] = ACTIONS(2292),
    [anon_sym_extern] = ACTIONS(2292),
    [anon_sym_alias] = ACTIONS(2292),
    [anon_sym_SEMI] = ACTIONS(2290),
    [anon_sym_global] = ACTIONS(2292),
    [anon_sym_using] = ACTIONS(2292),
    [anon_sym_static] = ACTIONS(2292),
    [anon_sym_LBRACK] = ACTIONS(2290),
    [anon_sym_return] = ACTIONS(2292),
    [anon_sym_LPAREN] = ACTIONS(2290),
    [anon_sym_abstract] = ACTIONS(2292),
    [anon_sym_async] = ACTIONS(2292),
    [anon_sym_const] = ACTIONS(2292),
    [anon_sym_fixed] = ACTIONS(2292),
    [anon_sym_internal] = ACTIONS(2292),
    [anon_sym_new] = ACTIONS(2292),
    [anon_sym_override] = ACTIONS(2292),
    [anon_sym_partial] = ACTIONS(2292),
    [anon_sym_private] = ACTIONS(2292),
    [anon_sym_protected] = ACTIONS(2292),
    [anon_sym_public] = ACTIONS(2292),
    [anon_sym_readonly] = ACTIONS(2292),
    [anon_sym_ref] = ACTIONS(2292),
    [anon_sym_sealed] = ACTIONS(2292),
    [anon_sym_unsafe] = ACTIONS(2292),
    [anon_sym_virtual] = ACTIONS(2292),
    [anon_sym_volatile] = ACTIONS(2292),
    [anon_sym_this] = ACTIONS(2292),
    [anon_sym_base] = ACTIONS(2292),
    [anon_sym_LBRACE] = ACTIONS(2290),
    [anon_sym_RBRACE] = ACTIONS(2290),
    [anon_sym_TILDE] = ACTIONS(2290),
    [anon_sym_where] = ACTIONS(2292),
    [anon_sym_notnull] = ACTIONS(2292),
    [anon_sym_unmanaged] = ACTIONS(2292),
    [anon_sym_BANG] = ACTIONS(2290),
    [anon_sym_PLUS_PLUS] = ACTIONS(2290),
    [anon_sym_DASH_DASH] = ACTIONS(2290),
    [anon_sym_true] = ACTIONS(2292),
    [anon_sym_false] = ACTIONS(2292),
    [anon_sym_PLUS] = ACTIONS(2292),
    [anon_sym_DASH] = ACTIONS(2292),
    [anon_sym_STAR] = ACTIONS(2290),
    [anon_sym_CARET] = ACTIONS(2290),
    [anon_sym_AMP] = ACTIONS(2290),
    [anon_sym_get] = ACTIONS(2292),
    [anon_sym_set] = ACTIONS(2292),
    [anon_sym_add] = ACTIONS(2292),
    [anon_sym_remove] = ACTIONS(2292),
    [anon_sym_delegate] = ACTIONS(2292),
    [anon_sym_var] = ACTIONS(2292),
    [sym_predefined_type] = ACTIONS(2292),
    [anon_sym_break] = ACTIONS(2292),
    [anon_sym_checked] = ACTIONS(2292),
    [anon_sym_unchecked] = ACTIONS(2292),
    [anon_sym_continue] = ACTIONS(2292),
    [anon_sym_do] = ACTIONS(2292),
    [anon_sym_while] = ACTIONS(2292),
    [anon_sym_for] = ACTIONS(2292),
    [anon_sym_await] = ACTIONS(2292),
    [anon_sym_foreach] = ACTIONS(2292),
    [anon_sym_goto] = ACTIONS(2292),
    [anon_sym_case] = ACTIONS(2292),
    [anon_sym_default] = ACTIONS(2292),
    [anon_sym_if] = ACTIONS(2292),
    [anon_sym_else] = ACTIONS(2292),
    [anon_sym_lock] = ACTIONS(2292),
    [anon_sym_switch] = ACTIONS(2292),
    [anon_sym_when] = ACTIONS(2292),
    [anon_sym_throw] = ACTIONS(2292),
    [anon_sym_try] = ACTIONS(2292),
    [anon_sym_yield] = ACTIONS(2292),
    [anon_sym_stackalloc] = ACTIONS(2292),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2290),
    [anon_sym_DQUOTE] = ACTIONS(2290),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2290),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2290),
    [anon_sym___makeref] = ACTIONS(2292),
    [anon_sym_from] = ACTIONS(2292),
    [anon_sym_join] = ACTIONS(2292),
    [anon_sym_on] = ACTIONS(2292),
    [anon_sym_equals] = ACTIONS(2292),
    [anon_sym_into] = ACTIONS(2292),
    [anon_sym_let] = ACTIONS(2292),
    [anon_sym_orderby] = ACTIONS(2292),
    [anon_sym_ascending] = ACTIONS(2292),
    [anon_sym_descending] = ACTIONS(2292),
    [anon_sym_group] = ACTIONS(2292),
    [anon_sym_by] = ACTIONS(2292),
    [anon_sym_select] = ACTIONS(2292),
    [anon_sym_DOT_DOT] = ACTIONS(2290),
    [anon_sym___reftype] = ACTIONS(2292),
    [anon_sym___refvalue] = ACTIONS(2292),
    [anon_sym_sizeof] = ACTIONS(2292),
    [anon_sym_typeof] = ACTIONS(2292),
    [anon_sym_SQUOTE] = ACTIONS(2290),
    [sym_integer_literal] = ACTIONS(2292),
    [sym_null_literal] = ACTIONS(2292),
    [sym_real_literal] = ACTIONS(2290),
    [sym_verbatim_string_literal] = ACTIONS(2290),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2292),
    [anon_sym_nameof] = ACTIONS(2292),
    [sym_void_keyword] = ACTIONS(2292),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1709] = {
    [sym__preprocessor_call] = STATE(1709),
    [sym__identifier_token] = ACTIONS(2542),
    [anon_sym_extern] = ACTIONS(2542),
    [anon_sym_alias] = ACTIONS(2542),
    [anon_sym_SEMI] = ACTIONS(2540),
    [anon_sym_global] = ACTIONS(2542),
    [anon_sym_using] = ACTIONS(2542),
    [anon_sym_static] = ACTIONS(2542),
    [anon_sym_LBRACK] = ACTIONS(2540),
    [anon_sym_return] = ACTIONS(2542),
    [anon_sym_LPAREN] = ACTIONS(2540),
    [anon_sym_abstract] = ACTIONS(2542),
    [anon_sym_async] = ACTIONS(2542),
    [anon_sym_const] = ACTIONS(2542),
    [anon_sym_fixed] = ACTIONS(2542),
    [anon_sym_internal] = ACTIONS(2542),
    [anon_sym_new] = ACTIONS(2542),
    [anon_sym_override] = ACTIONS(2542),
    [anon_sym_partial] = ACTIONS(2542),
    [anon_sym_private] = ACTIONS(2542),
    [anon_sym_protected] = ACTIONS(2542),
    [anon_sym_public] = ACTIONS(2542),
    [anon_sym_readonly] = ACTIONS(2542),
    [anon_sym_ref] = ACTIONS(2542),
    [anon_sym_sealed] = ACTIONS(2542),
    [anon_sym_unsafe] = ACTIONS(2542),
    [anon_sym_virtual] = ACTIONS(2542),
    [anon_sym_volatile] = ACTIONS(2542),
    [anon_sym_this] = ACTIONS(2542),
    [anon_sym_base] = ACTIONS(2542),
    [anon_sym_LBRACE] = ACTIONS(2540),
    [anon_sym_RBRACE] = ACTIONS(2540),
    [anon_sym_TILDE] = ACTIONS(2540),
    [anon_sym_where] = ACTIONS(2542),
    [anon_sym_notnull] = ACTIONS(2542),
    [anon_sym_unmanaged] = ACTIONS(2542),
    [anon_sym_BANG] = ACTIONS(2540),
    [anon_sym_PLUS_PLUS] = ACTIONS(2540),
    [anon_sym_DASH_DASH] = ACTIONS(2540),
    [anon_sym_true] = ACTIONS(2542),
    [anon_sym_false] = ACTIONS(2542),
    [anon_sym_PLUS] = ACTIONS(2542),
    [anon_sym_DASH] = ACTIONS(2542),
    [anon_sym_STAR] = ACTIONS(2540),
    [anon_sym_CARET] = ACTIONS(2540),
    [anon_sym_AMP] = ACTIONS(2540),
    [anon_sym_get] = ACTIONS(2542),
    [anon_sym_set] = ACTIONS(2542),
    [anon_sym_add] = ACTIONS(2542),
    [anon_sym_remove] = ACTIONS(2542),
    [anon_sym_delegate] = ACTIONS(2542),
    [anon_sym_var] = ACTIONS(2542),
    [sym_predefined_type] = ACTIONS(2542),
    [anon_sym_break] = ACTIONS(2542),
    [anon_sym_checked] = ACTIONS(2542),
    [anon_sym_unchecked] = ACTIONS(2542),
    [anon_sym_continue] = ACTIONS(2542),
    [anon_sym_do] = ACTIONS(2542),
    [anon_sym_while] = ACTIONS(2542),
    [anon_sym_for] = ACTIONS(2542),
    [anon_sym_await] = ACTIONS(2542),
    [anon_sym_foreach] = ACTIONS(2542),
    [anon_sym_goto] = ACTIONS(2542),
    [anon_sym_case] = ACTIONS(2542),
    [anon_sym_default] = ACTIONS(2542),
    [anon_sym_if] = ACTIONS(2542),
    [anon_sym_else] = ACTIONS(2542),
    [anon_sym_lock] = ACTIONS(2542),
    [anon_sym_switch] = ACTIONS(2542),
    [anon_sym_when] = ACTIONS(2542),
    [anon_sym_throw] = ACTIONS(2542),
    [anon_sym_try] = ACTIONS(2542),
    [anon_sym_yield] = ACTIONS(2542),
    [anon_sym_stackalloc] = ACTIONS(2542),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2540),
    [anon_sym_DQUOTE] = ACTIONS(2540),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2540),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2540),
    [anon_sym___makeref] = ACTIONS(2542),
    [anon_sym_from] = ACTIONS(2542),
    [anon_sym_join] = ACTIONS(2542),
    [anon_sym_on] = ACTIONS(2542),
    [anon_sym_equals] = ACTIONS(2542),
    [anon_sym_into] = ACTIONS(2542),
    [anon_sym_let] = ACTIONS(2542),
    [anon_sym_orderby] = ACTIONS(2542),
    [anon_sym_ascending] = ACTIONS(2542),
    [anon_sym_descending] = ACTIONS(2542),
    [anon_sym_group] = ACTIONS(2542),
    [anon_sym_by] = ACTIONS(2542),
    [anon_sym_select] = ACTIONS(2542),
    [anon_sym_DOT_DOT] = ACTIONS(2540),
    [anon_sym___reftype] = ACTIONS(2542),
    [anon_sym___refvalue] = ACTIONS(2542),
    [anon_sym_sizeof] = ACTIONS(2542),
    [anon_sym_typeof] = ACTIONS(2542),
    [anon_sym_SQUOTE] = ACTIONS(2540),
    [sym_integer_literal] = ACTIONS(2542),
    [sym_null_literal] = ACTIONS(2542),
    [sym_real_literal] = ACTIONS(2540),
    [sym_verbatim_string_literal] = ACTIONS(2540),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2542),
    [anon_sym_nameof] = ACTIONS(2542),
    [sym_void_keyword] = ACTIONS(2542),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1710] = {
    [sym__preprocessor_call] = STATE(1710),
    [sym__identifier_token] = ACTIONS(2486),
    [anon_sym_extern] = ACTIONS(2486),
    [anon_sym_alias] = ACTIONS(2486),
    [anon_sym_SEMI] = ACTIONS(2484),
    [anon_sym_global] = ACTIONS(2486),
    [anon_sym_using] = ACTIONS(2486),
    [anon_sym_static] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_return] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_fixed] = ACTIONS(2486),
    [anon_sym_internal] = ACTIONS(2486),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_override] = ACTIONS(2486),
    [anon_sym_partial] = ACTIONS(2486),
    [anon_sym_private] = ACTIONS(2486),
    [anon_sym_protected] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2486),
    [anon_sym_readonly] = ACTIONS(2486),
    [anon_sym_ref] = ACTIONS(2486),
    [anon_sym_sealed] = ACTIONS(2486),
    [anon_sym_unsafe] = ACTIONS(2486),
    [anon_sym_virtual] = ACTIONS(2486),
    [anon_sym_volatile] = ACTIONS(2486),
    [anon_sym_this] = ACTIONS(2486),
    [anon_sym_base] = ACTIONS(2486),
    [anon_sym_LBRACE] = ACTIONS(2484),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_where] = ACTIONS(2486),
    [anon_sym_notnull] = ACTIONS(2486),
    [anon_sym_unmanaged] = ACTIONS(2486),
    [anon_sym_BANG] = ACTIONS(2484),
    [anon_sym_PLUS_PLUS] = ACTIONS(2484),
    [anon_sym_DASH_DASH] = ACTIONS(2484),
    [anon_sym_true] = ACTIONS(2486),
    [anon_sym_false] = ACTIONS(2486),
    [anon_sym_PLUS] = ACTIONS(2486),
    [anon_sym_DASH] = ACTIONS(2486),
    [anon_sym_STAR] = ACTIONS(2484),
    [anon_sym_CARET] = ACTIONS(2484),
    [anon_sym_AMP] = ACTIONS(2484),
    [anon_sym_get] = ACTIONS(2486),
    [anon_sym_set] = ACTIONS(2486),
    [anon_sym_add] = ACTIONS(2486),
    [anon_sym_remove] = ACTIONS(2486),
    [anon_sym_delegate] = ACTIONS(2486),
    [anon_sym_var] = ACTIONS(2486),
    [sym_predefined_type] = ACTIONS(2486),
    [anon_sym_break] = ACTIONS(2486),
    [anon_sym_checked] = ACTIONS(2486),
    [anon_sym_unchecked] = ACTIONS(2486),
    [anon_sym_continue] = ACTIONS(2486),
    [anon_sym_do] = ACTIONS(2486),
    [anon_sym_while] = ACTIONS(2486),
    [anon_sym_for] = ACTIONS(2486),
    [anon_sym_await] = ACTIONS(2486),
    [anon_sym_foreach] = ACTIONS(2486),
    [anon_sym_goto] = ACTIONS(2486),
    [anon_sym_case] = ACTIONS(2486),
    [anon_sym_default] = ACTIONS(2486),
    [anon_sym_if] = ACTIONS(2486),
    [anon_sym_else] = ACTIONS(2486),
    [anon_sym_lock] = ACTIONS(2486),
    [anon_sym_switch] = ACTIONS(2486),
    [anon_sym_when] = ACTIONS(2486),
    [anon_sym_throw] = ACTIONS(2486),
    [anon_sym_try] = ACTIONS(2486),
    [anon_sym_yield] = ACTIONS(2486),
    [anon_sym_stackalloc] = ACTIONS(2486),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2484),
    [anon_sym_DQUOTE] = ACTIONS(2484),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2484),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2484),
    [anon_sym___makeref] = ACTIONS(2486),
    [anon_sym_from] = ACTIONS(2486),
    [anon_sym_join] = ACTIONS(2486),
    [anon_sym_on] = ACTIONS(2486),
    [anon_sym_equals] = ACTIONS(2486),
    [anon_sym_into] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_orderby] = ACTIONS(2486),
    [anon_sym_ascending] = ACTIONS(2486),
    [anon_sym_descending] = ACTIONS(2486),
    [anon_sym_group] = ACTIONS(2486),
    [anon_sym_by] = ACTIONS(2486),
    [anon_sym_select] = ACTIONS(2486),
    [anon_sym_DOT_DOT] = ACTIONS(2484),
    [anon_sym___reftype] = ACTIONS(2486),
    [anon_sym___refvalue] = ACTIONS(2486),
    [anon_sym_sizeof] = ACTIONS(2486),
    [anon_sym_typeof] = ACTIONS(2486),
    [anon_sym_SQUOTE] = ACTIONS(2484),
    [sym_integer_literal] = ACTIONS(2486),
    [sym_null_literal] = ACTIONS(2486),
    [sym_real_literal] = ACTIONS(2484),
    [sym_verbatim_string_literal] = ACTIONS(2484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2486),
    [anon_sym_nameof] = ACTIONS(2486),
    [sym_void_keyword] = ACTIONS(2486),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1711] = {
    [sym__preprocessor_call] = STATE(1711),
    [sym__identifier_token] = ACTIONS(2538),
    [anon_sym_extern] = ACTIONS(2538),
    [anon_sym_alias] = ACTIONS(2538),
    [anon_sym_SEMI] = ACTIONS(2536),
    [anon_sym_global] = ACTIONS(2538),
    [anon_sym_using] = ACTIONS(2538),
    [anon_sym_static] = ACTIONS(2538),
    [anon_sym_LBRACK] = ACTIONS(2536),
    [anon_sym_return] = ACTIONS(2538),
    [anon_sym_LPAREN] = ACTIONS(2536),
    [anon_sym_abstract] = ACTIONS(2538),
    [anon_sym_async] = ACTIONS(2538),
    [anon_sym_const] = ACTIONS(2538),
    [anon_sym_fixed] = ACTIONS(2538),
    [anon_sym_internal] = ACTIONS(2538),
    [anon_sym_new] = ACTIONS(2538),
    [anon_sym_override] = ACTIONS(2538),
    [anon_sym_partial] = ACTIONS(2538),
    [anon_sym_private] = ACTIONS(2538),
    [anon_sym_protected] = ACTIONS(2538),
    [anon_sym_public] = ACTIONS(2538),
    [anon_sym_readonly] = ACTIONS(2538),
    [anon_sym_ref] = ACTIONS(2538),
    [anon_sym_sealed] = ACTIONS(2538),
    [anon_sym_unsafe] = ACTIONS(2538),
    [anon_sym_virtual] = ACTIONS(2538),
    [anon_sym_volatile] = ACTIONS(2538),
    [anon_sym_this] = ACTIONS(2538),
    [anon_sym_base] = ACTIONS(2538),
    [anon_sym_LBRACE] = ACTIONS(2536),
    [anon_sym_RBRACE] = ACTIONS(2536),
    [anon_sym_TILDE] = ACTIONS(2536),
    [anon_sym_where] = ACTIONS(2538),
    [anon_sym_notnull] = ACTIONS(2538),
    [anon_sym_unmanaged] = ACTIONS(2538),
    [anon_sym_BANG] = ACTIONS(2536),
    [anon_sym_PLUS_PLUS] = ACTIONS(2536),
    [anon_sym_DASH_DASH] = ACTIONS(2536),
    [anon_sym_true] = ACTIONS(2538),
    [anon_sym_false] = ACTIONS(2538),
    [anon_sym_PLUS] = ACTIONS(2538),
    [anon_sym_DASH] = ACTIONS(2538),
    [anon_sym_STAR] = ACTIONS(2536),
    [anon_sym_CARET] = ACTIONS(2536),
    [anon_sym_AMP] = ACTIONS(2536),
    [anon_sym_get] = ACTIONS(2538),
    [anon_sym_set] = ACTIONS(2538),
    [anon_sym_add] = ACTIONS(2538),
    [anon_sym_remove] = ACTIONS(2538),
    [anon_sym_delegate] = ACTIONS(2538),
    [anon_sym_var] = ACTIONS(2538),
    [sym_predefined_type] = ACTIONS(2538),
    [anon_sym_break] = ACTIONS(2538),
    [anon_sym_checked] = ACTIONS(2538),
    [anon_sym_unchecked] = ACTIONS(2538),
    [anon_sym_continue] = ACTIONS(2538),
    [anon_sym_do] = ACTIONS(2538),
    [anon_sym_while] = ACTIONS(2538),
    [anon_sym_for] = ACTIONS(2538),
    [anon_sym_await] = ACTIONS(2538),
    [anon_sym_foreach] = ACTIONS(2538),
    [anon_sym_goto] = ACTIONS(2538),
    [anon_sym_case] = ACTIONS(2538),
    [anon_sym_default] = ACTIONS(2538),
    [anon_sym_if] = ACTIONS(2538),
    [anon_sym_else] = ACTIONS(2538),
    [anon_sym_lock] = ACTIONS(2538),
    [anon_sym_switch] = ACTIONS(2538),
    [anon_sym_when] = ACTIONS(2538),
    [anon_sym_throw] = ACTIONS(2538),
    [anon_sym_try] = ACTIONS(2538),
    [anon_sym_yield] = ACTIONS(2538),
    [anon_sym_stackalloc] = ACTIONS(2538),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2536),
    [anon_sym_DQUOTE] = ACTIONS(2536),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2536),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2536),
    [anon_sym___makeref] = ACTIONS(2538),
    [anon_sym_from] = ACTIONS(2538),
    [anon_sym_join] = ACTIONS(2538),
    [anon_sym_on] = ACTIONS(2538),
    [anon_sym_equals] = ACTIONS(2538),
    [anon_sym_into] = ACTIONS(2538),
    [anon_sym_let] = ACTIONS(2538),
    [anon_sym_orderby] = ACTIONS(2538),
    [anon_sym_ascending] = ACTIONS(2538),
    [anon_sym_descending] = ACTIONS(2538),
    [anon_sym_group] = ACTIONS(2538),
    [anon_sym_by] = ACTIONS(2538),
    [anon_sym_select] = ACTIONS(2538),
    [anon_sym_DOT_DOT] = ACTIONS(2536),
    [anon_sym___reftype] = ACTIONS(2538),
    [anon_sym___refvalue] = ACTIONS(2538),
    [anon_sym_sizeof] = ACTIONS(2538),
    [anon_sym_typeof] = ACTIONS(2538),
    [anon_sym_SQUOTE] = ACTIONS(2536),
    [sym_integer_literal] = ACTIONS(2538),
    [sym_null_literal] = ACTIONS(2538),
    [sym_real_literal] = ACTIONS(2536),
    [sym_verbatim_string_literal] = ACTIONS(2536),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2538),
    [anon_sym_nameof] = ACTIONS(2538),
    [sym_void_keyword] = ACTIONS(2538),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1712] = {
    [sym__preprocessor_call] = STATE(1712),
    [sym__identifier_token] = ACTIONS(2478),
    [anon_sym_extern] = ACTIONS(2478),
    [anon_sym_alias] = ACTIONS(2478),
    [anon_sym_SEMI] = ACTIONS(2476),
    [anon_sym_global] = ACTIONS(2478),
    [anon_sym_using] = ACTIONS(2478),
    [anon_sym_static] = ACTIONS(2478),
    [anon_sym_LBRACK] = ACTIONS(2476),
    [anon_sym_return] = ACTIONS(2478),
    [anon_sym_LPAREN] = ACTIONS(2476),
    [anon_sym_abstract] = ACTIONS(2478),
    [anon_sym_async] = ACTIONS(2478),
    [anon_sym_const] = ACTIONS(2478),
    [anon_sym_fixed] = ACTIONS(2478),
    [anon_sym_internal] = ACTIONS(2478),
    [anon_sym_new] = ACTIONS(2478),
    [anon_sym_override] = ACTIONS(2478),
    [anon_sym_partial] = ACTIONS(2478),
    [anon_sym_private] = ACTIONS(2478),
    [anon_sym_protected] = ACTIONS(2478),
    [anon_sym_public] = ACTIONS(2478),
    [anon_sym_readonly] = ACTIONS(2478),
    [anon_sym_ref] = ACTIONS(2478),
    [anon_sym_sealed] = ACTIONS(2478),
    [anon_sym_unsafe] = ACTIONS(2478),
    [anon_sym_virtual] = ACTIONS(2478),
    [anon_sym_volatile] = ACTIONS(2478),
    [anon_sym_this] = ACTIONS(2478),
    [anon_sym_base] = ACTIONS(2478),
    [anon_sym_LBRACE] = ACTIONS(2476),
    [anon_sym_RBRACE] = ACTIONS(2476),
    [anon_sym_TILDE] = ACTIONS(2476),
    [anon_sym_where] = ACTIONS(2478),
    [anon_sym_notnull] = ACTIONS(2478),
    [anon_sym_unmanaged] = ACTIONS(2478),
    [anon_sym_BANG] = ACTIONS(2476),
    [anon_sym_PLUS_PLUS] = ACTIONS(2476),
    [anon_sym_DASH_DASH] = ACTIONS(2476),
    [anon_sym_true] = ACTIONS(2478),
    [anon_sym_false] = ACTIONS(2478),
    [anon_sym_PLUS] = ACTIONS(2478),
    [anon_sym_DASH] = ACTIONS(2478),
    [anon_sym_STAR] = ACTIONS(2476),
    [anon_sym_CARET] = ACTIONS(2476),
    [anon_sym_AMP] = ACTIONS(2476),
    [anon_sym_get] = ACTIONS(2478),
    [anon_sym_set] = ACTIONS(2478),
    [anon_sym_add] = ACTIONS(2478),
    [anon_sym_remove] = ACTIONS(2478),
    [anon_sym_delegate] = ACTIONS(2478),
    [anon_sym_var] = ACTIONS(2478),
    [sym_predefined_type] = ACTIONS(2478),
    [anon_sym_break] = ACTIONS(2478),
    [anon_sym_checked] = ACTIONS(2478),
    [anon_sym_unchecked] = ACTIONS(2478),
    [anon_sym_continue] = ACTIONS(2478),
    [anon_sym_do] = ACTIONS(2478),
    [anon_sym_while] = ACTIONS(2478),
    [anon_sym_for] = ACTIONS(2478),
    [anon_sym_await] = ACTIONS(2478),
    [anon_sym_foreach] = ACTIONS(2478),
    [anon_sym_goto] = ACTIONS(2478),
    [anon_sym_case] = ACTIONS(2478),
    [anon_sym_default] = ACTIONS(2478),
    [anon_sym_if] = ACTIONS(2478),
    [anon_sym_else] = ACTIONS(2478),
    [anon_sym_lock] = ACTIONS(2478),
    [anon_sym_switch] = ACTIONS(2478),
    [anon_sym_when] = ACTIONS(2478),
    [anon_sym_throw] = ACTIONS(2478),
    [anon_sym_try] = ACTIONS(2478),
    [anon_sym_yield] = ACTIONS(2478),
    [anon_sym_stackalloc] = ACTIONS(2478),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2476),
    [anon_sym_DQUOTE] = ACTIONS(2476),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2476),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2476),
    [anon_sym___makeref] = ACTIONS(2478),
    [anon_sym_from] = ACTIONS(2478),
    [anon_sym_join] = ACTIONS(2478),
    [anon_sym_on] = ACTIONS(2478),
    [anon_sym_equals] = ACTIONS(2478),
    [anon_sym_into] = ACTIONS(2478),
    [anon_sym_let] = ACTIONS(2478),
    [anon_sym_orderby] = ACTIONS(2478),
    [anon_sym_ascending] = ACTIONS(2478),
    [anon_sym_descending] = ACTIONS(2478),
    [anon_sym_group] = ACTIONS(2478),
    [anon_sym_by] = ACTIONS(2478),
    [anon_sym_select] = ACTIONS(2478),
    [anon_sym_DOT_DOT] = ACTIONS(2476),
    [anon_sym___reftype] = ACTIONS(2478),
    [anon_sym___refvalue] = ACTIONS(2478),
    [anon_sym_sizeof] = ACTIONS(2478),
    [anon_sym_typeof] = ACTIONS(2478),
    [anon_sym_SQUOTE] = ACTIONS(2476),
    [sym_integer_literal] = ACTIONS(2478),
    [sym_null_literal] = ACTIONS(2478),
    [sym_real_literal] = ACTIONS(2476),
    [sym_verbatim_string_literal] = ACTIONS(2476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2478),
    [anon_sym_nameof] = ACTIONS(2478),
    [sym_void_keyword] = ACTIONS(2478),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1713] = {
    [sym__preprocessor_call] = STATE(1713),
    [sym__identifier_token] = ACTIONS(2418),
    [anon_sym_extern] = ACTIONS(2418),
    [anon_sym_alias] = ACTIONS(2418),
    [anon_sym_SEMI] = ACTIONS(2416),
    [anon_sym_global] = ACTIONS(2418),
    [anon_sym_using] = ACTIONS(2418),
    [anon_sym_static] = ACTIONS(2418),
    [anon_sym_LBRACK] = ACTIONS(2416),
    [anon_sym_return] = ACTIONS(2418),
    [anon_sym_LPAREN] = ACTIONS(2416),
    [anon_sym_abstract] = ACTIONS(2418),
    [anon_sym_async] = ACTIONS(2418),
    [anon_sym_const] = ACTIONS(2418),
    [anon_sym_fixed] = ACTIONS(2418),
    [anon_sym_internal] = ACTIONS(2418),
    [anon_sym_new] = ACTIONS(2418),
    [anon_sym_override] = ACTIONS(2418),
    [anon_sym_partial] = ACTIONS(2418),
    [anon_sym_private] = ACTIONS(2418),
    [anon_sym_protected] = ACTIONS(2418),
    [anon_sym_public] = ACTIONS(2418),
    [anon_sym_readonly] = ACTIONS(2418),
    [anon_sym_ref] = ACTIONS(2418),
    [anon_sym_sealed] = ACTIONS(2418),
    [anon_sym_unsafe] = ACTIONS(2418),
    [anon_sym_virtual] = ACTIONS(2418),
    [anon_sym_volatile] = ACTIONS(2418),
    [anon_sym_this] = ACTIONS(2418),
    [anon_sym_base] = ACTIONS(2418),
    [anon_sym_LBRACE] = ACTIONS(2416),
    [anon_sym_RBRACE] = ACTIONS(2416),
    [anon_sym_TILDE] = ACTIONS(2416),
    [anon_sym_where] = ACTIONS(2418),
    [anon_sym_notnull] = ACTIONS(2418),
    [anon_sym_unmanaged] = ACTIONS(2418),
    [anon_sym_BANG] = ACTIONS(2416),
    [anon_sym_PLUS_PLUS] = ACTIONS(2416),
    [anon_sym_DASH_DASH] = ACTIONS(2416),
    [anon_sym_true] = ACTIONS(2418),
    [anon_sym_false] = ACTIONS(2418),
    [anon_sym_PLUS] = ACTIONS(2418),
    [anon_sym_DASH] = ACTIONS(2418),
    [anon_sym_STAR] = ACTIONS(2416),
    [anon_sym_CARET] = ACTIONS(2416),
    [anon_sym_AMP] = ACTIONS(2416),
    [anon_sym_get] = ACTIONS(2418),
    [anon_sym_set] = ACTIONS(2418),
    [anon_sym_add] = ACTIONS(2418),
    [anon_sym_remove] = ACTIONS(2418),
    [anon_sym_delegate] = ACTIONS(2418),
    [anon_sym_var] = ACTIONS(2418),
    [sym_predefined_type] = ACTIONS(2418),
    [anon_sym_break] = ACTIONS(2418),
    [anon_sym_checked] = ACTIONS(2418),
    [anon_sym_unchecked] = ACTIONS(2418),
    [anon_sym_continue] = ACTIONS(2418),
    [anon_sym_do] = ACTIONS(2418),
    [anon_sym_while] = ACTIONS(2418),
    [anon_sym_for] = ACTIONS(2418),
    [anon_sym_await] = ACTIONS(2418),
    [anon_sym_foreach] = ACTIONS(2418),
    [anon_sym_goto] = ACTIONS(2418),
    [anon_sym_case] = ACTIONS(2418),
    [anon_sym_default] = ACTIONS(2418),
    [anon_sym_if] = ACTIONS(2418),
    [anon_sym_else] = ACTIONS(2418),
    [anon_sym_lock] = ACTIONS(2418),
    [anon_sym_switch] = ACTIONS(2418),
    [anon_sym_when] = ACTIONS(2418),
    [anon_sym_throw] = ACTIONS(2418),
    [anon_sym_try] = ACTIONS(2418),
    [anon_sym_yield] = ACTIONS(2418),
    [anon_sym_stackalloc] = ACTIONS(2418),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2416),
    [anon_sym_DQUOTE] = ACTIONS(2416),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2416),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2416),
    [anon_sym___makeref] = ACTIONS(2418),
    [anon_sym_from] = ACTIONS(2418),
    [anon_sym_join] = ACTIONS(2418),
    [anon_sym_on] = ACTIONS(2418),
    [anon_sym_equals] = ACTIONS(2418),
    [anon_sym_into] = ACTIONS(2418),
    [anon_sym_let] = ACTIONS(2418),
    [anon_sym_orderby] = ACTIONS(2418),
    [anon_sym_ascending] = ACTIONS(2418),
    [anon_sym_descending] = ACTIONS(2418),
    [anon_sym_group] = ACTIONS(2418),
    [anon_sym_by] = ACTIONS(2418),
    [anon_sym_select] = ACTIONS(2418),
    [anon_sym_DOT_DOT] = ACTIONS(2416),
    [anon_sym___reftype] = ACTIONS(2418),
    [anon_sym___refvalue] = ACTIONS(2418),
    [anon_sym_sizeof] = ACTIONS(2418),
    [anon_sym_typeof] = ACTIONS(2418),
    [anon_sym_SQUOTE] = ACTIONS(2416),
    [sym_integer_literal] = ACTIONS(2418),
    [sym_null_literal] = ACTIONS(2418),
    [sym_real_literal] = ACTIONS(2416),
    [sym_verbatim_string_literal] = ACTIONS(2416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2418),
    [anon_sym_nameof] = ACTIONS(2418),
    [sym_void_keyword] = ACTIONS(2418),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1714] = {
    [sym__preprocessor_call] = STATE(1714),
    [sym__identifier_token] = ACTIONS(2368),
    [anon_sym_extern] = ACTIONS(2368),
    [anon_sym_alias] = ACTIONS(2368),
    [anon_sym_SEMI] = ACTIONS(2366),
    [anon_sym_global] = ACTIONS(2368),
    [anon_sym_using] = ACTIONS(2368),
    [anon_sym_static] = ACTIONS(2368),
    [anon_sym_LBRACK] = ACTIONS(2366),
    [anon_sym_return] = ACTIONS(2368),
    [anon_sym_LPAREN] = ACTIONS(2366),
    [anon_sym_abstract] = ACTIONS(2368),
    [anon_sym_async] = ACTIONS(2368),
    [anon_sym_const] = ACTIONS(2368),
    [anon_sym_fixed] = ACTIONS(2368),
    [anon_sym_internal] = ACTIONS(2368),
    [anon_sym_new] = ACTIONS(2368),
    [anon_sym_override] = ACTIONS(2368),
    [anon_sym_partial] = ACTIONS(2368),
    [anon_sym_private] = ACTIONS(2368),
    [anon_sym_protected] = ACTIONS(2368),
    [anon_sym_public] = ACTIONS(2368),
    [anon_sym_readonly] = ACTIONS(2368),
    [anon_sym_ref] = ACTIONS(2368),
    [anon_sym_sealed] = ACTIONS(2368),
    [anon_sym_unsafe] = ACTIONS(2368),
    [anon_sym_virtual] = ACTIONS(2368),
    [anon_sym_volatile] = ACTIONS(2368),
    [anon_sym_this] = ACTIONS(2368),
    [anon_sym_base] = ACTIONS(2368),
    [anon_sym_LBRACE] = ACTIONS(2366),
    [anon_sym_RBRACE] = ACTIONS(2366),
    [anon_sym_TILDE] = ACTIONS(2366),
    [anon_sym_where] = ACTIONS(2368),
    [anon_sym_notnull] = ACTIONS(2368),
    [anon_sym_unmanaged] = ACTIONS(2368),
    [anon_sym_BANG] = ACTIONS(2366),
    [anon_sym_PLUS_PLUS] = ACTIONS(2366),
    [anon_sym_DASH_DASH] = ACTIONS(2366),
    [anon_sym_true] = ACTIONS(2368),
    [anon_sym_false] = ACTIONS(2368),
    [anon_sym_PLUS] = ACTIONS(2368),
    [anon_sym_DASH] = ACTIONS(2368),
    [anon_sym_STAR] = ACTIONS(2366),
    [anon_sym_CARET] = ACTIONS(2366),
    [anon_sym_AMP] = ACTIONS(2366),
    [anon_sym_get] = ACTIONS(2368),
    [anon_sym_set] = ACTIONS(2368),
    [anon_sym_add] = ACTIONS(2368),
    [anon_sym_remove] = ACTIONS(2368),
    [anon_sym_delegate] = ACTIONS(2368),
    [anon_sym_var] = ACTIONS(2368),
    [sym_predefined_type] = ACTIONS(2368),
    [anon_sym_break] = ACTIONS(2368),
    [anon_sym_checked] = ACTIONS(2368),
    [anon_sym_unchecked] = ACTIONS(2368),
    [anon_sym_continue] = ACTIONS(2368),
    [anon_sym_do] = ACTIONS(2368),
    [anon_sym_while] = ACTIONS(2368),
    [anon_sym_for] = ACTIONS(2368),
    [anon_sym_await] = ACTIONS(2368),
    [anon_sym_foreach] = ACTIONS(2368),
    [anon_sym_goto] = ACTIONS(2368),
    [anon_sym_case] = ACTIONS(2368),
    [anon_sym_default] = ACTIONS(2368),
    [anon_sym_if] = ACTIONS(2368),
    [anon_sym_else] = ACTIONS(2368),
    [anon_sym_lock] = ACTIONS(2368),
    [anon_sym_switch] = ACTIONS(2368),
    [anon_sym_when] = ACTIONS(2368),
    [anon_sym_throw] = ACTIONS(2368),
    [anon_sym_try] = ACTIONS(2368),
    [anon_sym_yield] = ACTIONS(2368),
    [anon_sym_stackalloc] = ACTIONS(2368),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2366),
    [anon_sym_DQUOTE] = ACTIONS(2366),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2366),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2366),
    [anon_sym___makeref] = ACTIONS(2368),
    [anon_sym_from] = ACTIONS(2368),
    [anon_sym_join] = ACTIONS(2368),
    [anon_sym_on] = ACTIONS(2368),
    [anon_sym_equals] = ACTIONS(2368),
    [anon_sym_into] = ACTIONS(2368),
    [anon_sym_let] = ACTIONS(2368),
    [anon_sym_orderby] = ACTIONS(2368),
    [anon_sym_ascending] = ACTIONS(2368),
    [anon_sym_descending] = ACTIONS(2368),
    [anon_sym_group] = ACTIONS(2368),
    [anon_sym_by] = ACTIONS(2368),
    [anon_sym_select] = ACTIONS(2368),
    [anon_sym_DOT_DOT] = ACTIONS(2366),
    [anon_sym___reftype] = ACTIONS(2368),
    [anon_sym___refvalue] = ACTIONS(2368),
    [anon_sym_sizeof] = ACTIONS(2368),
    [anon_sym_typeof] = ACTIONS(2368),
    [anon_sym_SQUOTE] = ACTIONS(2366),
    [sym_integer_literal] = ACTIONS(2368),
    [sym_null_literal] = ACTIONS(2368),
    [sym_real_literal] = ACTIONS(2366),
    [sym_verbatim_string_literal] = ACTIONS(2366),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2368),
    [anon_sym_nameof] = ACTIONS(2368),
    [sym_void_keyword] = ACTIONS(2368),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1715] = {
    [sym__preprocessor_call] = STATE(1715),
    [sym__identifier_token] = ACTIONS(2384),
    [anon_sym_extern] = ACTIONS(2384),
    [anon_sym_alias] = ACTIONS(2384),
    [anon_sym_SEMI] = ACTIONS(2382),
    [anon_sym_global] = ACTIONS(2384),
    [anon_sym_using] = ACTIONS(2384),
    [anon_sym_static] = ACTIONS(2384),
    [anon_sym_LBRACK] = ACTIONS(2382),
    [anon_sym_return] = ACTIONS(2384),
    [anon_sym_LPAREN] = ACTIONS(2382),
    [anon_sym_abstract] = ACTIONS(2384),
    [anon_sym_async] = ACTIONS(2384),
    [anon_sym_const] = ACTIONS(2384),
    [anon_sym_fixed] = ACTIONS(2384),
    [anon_sym_internal] = ACTIONS(2384),
    [anon_sym_new] = ACTIONS(2384),
    [anon_sym_override] = ACTIONS(2384),
    [anon_sym_partial] = ACTIONS(2384),
    [anon_sym_private] = ACTIONS(2384),
    [anon_sym_protected] = ACTIONS(2384),
    [anon_sym_public] = ACTIONS(2384),
    [anon_sym_readonly] = ACTIONS(2384),
    [anon_sym_ref] = ACTIONS(2384),
    [anon_sym_sealed] = ACTIONS(2384),
    [anon_sym_unsafe] = ACTIONS(2384),
    [anon_sym_virtual] = ACTIONS(2384),
    [anon_sym_volatile] = ACTIONS(2384),
    [anon_sym_this] = ACTIONS(2384),
    [anon_sym_base] = ACTIONS(2384),
    [anon_sym_LBRACE] = ACTIONS(2382),
    [anon_sym_RBRACE] = ACTIONS(2382),
    [anon_sym_TILDE] = ACTIONS(2382),
    [anon_sym_where] = ACTIONS(2384),
    [anon_sym_notnull] = ACTIONS(2384),
    [anon_sym_unmanaged] = ACTIONS(2384),
    [anon_sym_BANG] = ACTIONS(2382),
    [anon_sym_PLUS_PLUS] = ACTIONS(2382),
    [anon_sym_DASH_DASH] = ACTIONS(2382),
    [anon_sym_true] = ACTIONS(2384),
    [anon_sym_false] = ACTIONS(2384),
    [anon_sym_PLUS] = ACTIONS(2384),
    [anon_sym_DASH] = ACTIONS(2384),
    [anon_sym_STAR] = ACTIONS(2382),
    [anon_sym_CARET] = ACTIONS(2382),
    [anon_sym_AMP] = ACTIONS(2382),
    [anon_sym_get] = ACTIONS(2384),
    [anon_sym_set] = ACTIONS(2384),
    [anon_sym_add] = ACTIONS(2384),
    [anon_sym_remove] = ACTIONS(2384),
    [anon_sym_delegate] = ACTIONS(2384),
    [anon_sym_var] = ACTIONS(2384),
    [sym_predefined_type] = ACTIONS(2384),
    [anon_sym_break] = ACTIONS(2384),
    [anon_sym_checked] = ACTIONS(2384),
    [anon_sym_unchecked] = ACTIONS(2384),
    [anon_sym_continue] = ACTIONS(2384),
    [anon_sym_do] = ACTIONS(2384),
    [anon_sym_while] = ACTIONS(2384),
    [anon_sym_for] = ACTIONS(2384),
    [anon_sym_await] = ACTIONS(2384),
    [anon_sym_foreach] = ACTIONS(2384),
    [anon_sym_goto] = ACTIONS(2384),
    [anon_sym_case] = ACTIONS(2384),
    [anon_sym_default] = ACTIONS(2384),
    [anon_sym_if] = ACTIONS(2384),
    [anon_sym_else] = ACTIONS(2384),
    [anon_sym_lock] = ACTIONS(2384),
    [anon_sym_switch] = ACTIONS(2384),
    [anon_sym_when] = ACTIONS(2384),
    [anon_sym_throw] = ACTIONS(2384),
    [anon_sym_try] = ACTIONS(2384),
    [anon_sym_yield] = ACTIONS(2384),
    [anon_sym_stackalloc] = ACTIONS(2384),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2382),
    [anon_sym_DQUOTE] = ACTIONS(2382),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2382),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2382),
    [anon_sym___makeref] = ACTIONS(2384),
    [anon_sym_from] = ACTIONS(2384),
    [anon_sym_join] = ACTIONS(2384),
    [anon_sym_on] = ACTIONS(2384),
    [anon_sym_equals] = ACTIONS(2384),
    [anon_sym_into] = ACTIONS(2384),
    [anon_sym_let] = ACTIONS(2384),
    [anon_sym_orderby] = ACTIONS(2384),
    [anon_sym_ascending] = ACTIONS(2384),
    [anon_sym_descending] = ACTIONS(2384),
    [anon_sym_group] = ACTIONS(2384),
    [anon_sym_by] = ACTIONS(2384),
    [anon_sym_select] = ACTIONS(2384),
    [anon_sym_DOT_DOT] = ACTIONS(2382),
    [anon_sym___reftype] = ACTIONS(2384),
    [anon_sym___refvalue] = ACTIONS(2384),
    [anon_sym_sizeof] = ACTIONS(2384),
    [anon_sym_typeof] = ACTIONS(2384),
    [anon_sym_SQUOTE] = ACTIONS(2382),
    [sym_integer_literal] = ACTIONS(2384),
    [sym_null_literal] = ACTIONS(2384),
    [sym_real_literal] = ACTIONS(2382),
    [sym_verbatim_string_literal] = ACTIONS(2382),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2384),
    [anon_sym_nameof] = ACTIONS(2384),
    [sym_void_keyword] = ACTIONS(2384),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1716] = {
    [sym__preprocessor_call] = STATE(1716),
    [sym__identifier_token] = ACTIONS(2450),
    [anon_sym_extern] = ACTIONS(2450),
    [anon_sym_alias] = ACTIONS(2450),
    [anon_sym_SEMI] = ACTIONS(2448),
    [anon_sym_global] = ACTIONS(2450),
    [anon_sym_using] = ACTIONS(2450),
    [anon_sym_static] = ACTIONS(2450),
    [anon_sym_LBRACK] = ACTIONS(2448),
    [anon_sym_return] = ACTIONS(2450),
    [anon_sym_LPAREN] = ACTIONS(2448),
    [anon_sym_abstract] = ACTIONS(2450),
    [anon_sym_async] = ACTIONS(2450),
    [anon_sym_const] = ACTIONS(2450),
    [anon_sym_fixed] = ACTIONS(2450),
    [anon_sym_internal] = ACTIONS(2450),
    [anon_sym_new] = ACTIONS(2450),
    [anon_sym_override] = ACTIONS(2450),
    [anon_sym_partial] = ACTIONS(2450),
    [anon_sym_private] = ACTIONS(2450),
    [anon_sym_protected] = ACTIONS(2450),
    [anon_sym_public] = ACTIONS(2450),
    [anon_sym_readonly] = ACTIONS(2450),
    [anon_sym_ref] = ACTIONS(2450),
    [anon_sym_sealed] = ACTIONS(2450),
    [anon_sym_unsafe] = ACTIONS(2450),
    [anon_sym_virtual] = ACTIONS(2450),
    [anon_sym_volatile] = ACTIONS(2450),
    [anon_sym_this] = ACTIONS(2450),
    [anon_sym_base] = ACTIONS(2450),
    [anon_sym_LBRACE] = ACTIONS(2448),
    [anon_sym_RBRACE] = ACTIONS(2448),
    [anon_sym_TILDE] = ACTIONS(2448),
    [anon_sym_where] = ACTIONS(2450),
    [anon_sym_notnull] = ACTIONS(2450),
    [anon_sym_unmanaged] = ACTIONS(2450),
    [anon_sym_BANG] = ACTIONS(2448),
    [anon_sym_PLUS_PLUS] = ACTIONS(2448),
    [anon_sym_DASH_DASH] = ACTIONS(2448),
    [anon_sym_true] = ACTIONS(2450),
    [anon_sym_false] = ACTIONS(2450),
    [anon_sym_PLUS] = ACTIONS(2450),
    [anon_sym_DASH] = ACTIONS(2450),
    [anon_sym_STAR] = ACTIONS(2448),
    [anon_sym_CARET] = ACTIONS(2448),
    [anon_sym_AMP] = ACTIONS(2448),
    [anon_sym_get] = ACTIONS(2450),
    [anon_sym_set] = ACTIONS(2450),
    [anon_sym_add] = ACTIONS(2450),
    [anon_sym_remove] = ACTIONS(2450),
    [anon_sym_delegate] = ACTIONS(2450),
    [anon_sym_var] = ACTIONS(2450),
    [sym_predefined_type] = ACTIONS(2450),
    [anon_sym_break] = ACTIONS(2450),
    [anon_sym_checked] = ACTIONS(2450),
    [anon_sym_unchecked] = ACTIONS(2450),
    [anon_sym_continue] = ACTIONS(2450),
    [anon_sym_do] = ACTIONS(2450),
    [anon_sym_while] = ACTIONS(2450),
    [anon_sym_for] = ACTIONS(2450),
    [anon_sym_await] = ACTIONS(2450),
    [anon_sym_foreach] = ACTIONS(2450),
    [anon_sym_goto] = ACTIONS(2450),
    [anon_sym_case] = ACTIONS(2450),
    [anon_sym_default] = ACTIONS(2450),
    [anon_sym_if] = ACTIONS(2450),
    [anon_sym_else] = ACTIONS(2450),
    [anon_sym_lock] = ACTIONS(2450),
    [anon_sym_switch] = ACTIONS(2450),
    [anon_sym_when] = ACTIONS(2450),
    [anon_sym_throw] = ACTIONS(2450),
    [anon_sym_try] = ACTIONS(2450),
    [anon_sym_yield] = ACTIONS(2450),
    [anon_sym_stackalloc] = ACTIONS(2450),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2448),
    [anon_sym_DQUOTE] = ACTIONS(2448),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2448),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2448),
    [anon_sym___makeref] = ACTIONS(2450),
    [anon_sym_from] = ACTIONS(2450),
    [anon_sym_join] = ACTIONS(2450),
    [anon_sym_on] = ACTIONS(2450),
    [anon_sym_equals] = ACTIONS(2450),
    [anon_sym_into] = ACTIONS(2450),
    [anon_sym_let] = ACTIONS(2450),
    [anon_sym_orderby] = ACTIONS(2450),
    [anon_sym_ascending] = ACTIONS(2450),
    [anon_sym_descending] = ACTIONS(2450),
    [anon_sym_group] = ACTIONS(2450),
    [anon_sym_by] = ACTIONS(2450),
    [anon_sym_select] = ACTIONS(2450),
    [anon_sym_DOT_DOT] = ACTIONS(2448),
    [anon_sym___reftype] = ACTIONS(2450),
    [anon_sym___refvalue] = ACTIONS(2450),
    [anon_sym_sizeof] = ACTIONS(2450),
    [anon_sym_typeof] = ACTIONS(2450),
    [anon_sym_SQUOTE] = ACTIONS(2448),
    [sym_integer_literal] = ACTIONS(2450),
    [sym_null_literal] = ACTIONS(2450),
    [sym_real_literal] = ACTIONS(2448),
    [sym_verbatim_string_literal] = ACTIONS(2448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2450),
    [anon_sym_nameof] = ACTIONS(2450),
    [sym_void_keyword] = ACTIONS(2450),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1717] = {
    [sym__preprocessor_call] = STATE(1717),
    [sym__identifier_token] = ACTIONS(2380),
    [anon_sym_extern] = ACTIONS(2380),
    [anon_sym_alias] = ACTIONS(2380),
    [anon_sym_SEMI] = ACTIONS(2378),
    [anon_sym_global] = ACTIONS(2380),
    [anon_sym_using] = ACTIONS(2380),
    [anon_sym_static] = ACTIONS(2380),
    [anon_sym_LBRACK] = ACTIONS(2378),
    [anon_sym_return] = ACTIONS(2380),
    [anon_sym_LPAREN] = ACTIONS(2378),
    [anon_sym_abstract] = ACTIONS(2380),
    [anon_sym_async] = ACTIONS(2380),
    [anon_sym_const] = ACTIONS(2380),
    [anon_sym_fixed] = ACTIONS(2380),
    [anon_sym_internal] = ACTIONS(2380),
    [anon_sym_new] = ACTIONS(2380),
    [anon_sym_override] = ACTIONS(2380),
    [anon_sym_partial] = ACTIONS(2380),
    [anon_sym_private] = ACTIONS(2380),
    [anon_sym_protected] = ACTIONS(2380),
    [anon_sym_public] = ACTIONS(2380),
    [anon_sym_readonly] = ACTIONS(2380),
    [anon_sym_ref] = ACTIONS(2380),
    [anon_sym_sealed] = ACTIONS(2380),
    [anon_sym_unsafe] = ACTIONS(2380),
    [anon_sym_virtual] = ACTIONS(2380),
    [anon_sym_volatile] = ACTIONS(2380),
    [anon_sym_this] = ACTIONS(2380),
    [anon_sym_base] = ACTIONS(2380),
    [anon_sym_LBRACE] = ACTIONS(2378),
    [anon_sym_RBRACE] = ACTIONS(2378),
    [anon_sym_TILDE] = ACTIONS(2378),
    [anon_sym_where] = ACTIONS(2380),
    [anon_sym_notnull] = ACTIONS(2380),
    [anon_sym_unmanaged] = ACTIONS(2380),
    [anon_sym_BANG] = ACTIONS(2378),
    [anon_sym_PLUS_PLUS] = ACTIONS(2378),
    [anon_sym_DASH_DASH] = ACTIONS(2378),
    [anon_sym_true] = ACTIONS(2380),
    [anon_sym_false] = ACTIONS(2380),
    [anon_sym_PLUS] = ACTIONS(2380),
    [anon_sym_DASH] = ACTIONS(2380),
    [anon_sym_STAR] = ACTIONS(2378),
    [anon_sym_CARET] = ACTIONS(2378),
    [anon_sym_AMP] = ACTIONS(2378),
    [anon_sym_get] = ACTIONS(2380),
    [anon_sym_set] = ACTIONS(2380),
    [anon_sym_add] = ACTIONS(2380),
    [anon_sym_remove] = ACTIONS(2380),
    [anon_sym_delegate] = ACTIONS(2380),
    [anon_sym_var] = ACTIONS(2380),
    [sym_predefined_type] = ACTIONS(2380),
    [anon_sym_break] = ACTIONS(2380),
    [anon_sym_checked] = ACTIONS(2380),
    [anon_sym_unchecked] = ACTIONS(2380),
    [anon_sym_continue] = ACTIONS(2380),
    [anon_sym_do] = ACTIONS(2380),
    [anon_sym_while] = ACTIONS(2380),
    [anon_sym_for] = ACTIONS(2380),
    [anon_sym_await] = ACTIONS(2380),
    [anon_sym_foreach] = ACTIONS(2380),
    [anon_sym_goto] = ACTIONS(2380),
    [anon_sym_case] = ACTIONS(2380),
    [anon_sym_default] = ACTIONS(2380),
    [anon_sym_if] = ACTIONS(2380),
    [anon_sym_else] = ACTIONS(2380),
    [anon_sym_lock] = ACTIONS(2380),
    [anon_sym_switch] = ACTIONS(2380),
    [anon_sym_when] = ACTIONS(2380),
    [anon_sym_throw] = ACTIONS(2380),
    [anon_sym_try] = ACTIONS(2380),
    [anon_sym_yield] = ACTIONS(2380),
    [anon_sym_stackalloc] = ACTIONS(2380),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2378),
    [anon_sym_DQUOTE] = ACTIONS(2378),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2378),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2378),
    [anon_sym___makeref] = ACTIONS(2380),
    [anon_sym_from] = ACTIONS(2380),
    [anon_sym_join] = ACTIONS(2380),
    [anon_sym_on] = ACTIONS(2380),
    [anon_sym_equals] = ACTIONS(2380),
    [anon_sym_into] = ACTIONS(2380),
    [anon_sym_let] = ACTIONS(2380),
    [anon_sym_orderby] = ACTIONS(2380),
    [anon_sym_ascending] = ACTIONS(2380),
    [anon_sym_descending] = ACTIONS(2380),
    [anon_sym_group] = ACTIONS(2380),
    [anon_sym_by] = ACTIONS(2380),
    [anon_sym_select] = ACTIONS(2380),
    [anon_sym_DOT_DOT] = ACTIONS(2378),
    [anon_sym___reftype] = ACTIONS(2380),
    [anon_sym___refvalue] = ACTIONS(2380),
    [anon_sym_sizeof] = ACTIONS(2380),
    [anon_sym_typeof] = ACTIONS(2380),
    [anon_sym_SQUOTE] = ACTIONS(2378),
    [sym_integer_literal] = ACTIONS(2380),
    [sym_null_literal] = ACTIONS(2380),
    [sym_real_literal] = ACTIONS(2378),
    [sym_verbatim_string_literal] = ACTIONS(2378),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2380),
    [anon_sym_nameof] = ACTIONS(2380),
    [sym_void_keyword] = ACTIONS(2380),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1718] = {
    [sym__preprocessor_call] = STATE(1718),
    [sym__identifier_token] = ACTIONS(2396),
    [anon_sym_extern] = ACTIONS(2396),
    [anon_sym_alias] = ACTIONS(2396),
    [anon_sym_SEMI] = ACTIONS(2394),
    [anon_sym_global] = ACTIONS(2396),
    [anon_sym_using] = ACTIONS(2396),
    [anon_sym_static] = ACTIONS(2396),
    [anon_sym_LBRACK] = ACTIONS(2394),
    [anon_sym_return] = ACTIONS(2396),
    [anon_sym_LPAREN] = ACTIONS(2394),
    [anon_sym_abstract] = ACTIONS(2396),
    [anon_sym_async] = ACTIONS(2396),
    [anon_sym_const] = ACTIONS(2396),
    [anon_sym_fixed] = ACTIONS(2396),
    [anon_sym_internal] = ACTIONS(2396),
    [anon_sym_new] = ACTIONS(2396),
    [anon_sym_override] = ACTIONS(2396),
    [anon_sym_partial] = ACTIONS(2396),
    [anon_sym_private] = ACTIONS(2396),
    [anon_sym_protected] = ACTIONS(2396),
    [anon_sym_public] = ACTIONS(2396),
    [anon_sym_readonly] = ACTIONS(2396),
    [anon_sym_ref] = ACTIONS(2396),
    [anon_sym_sealed] = ACTIONS(2396),
    [anon_sym_unsafe] = ACTIONS(2396),
    [anon_sym_virtual] = ACTIONS(2396),
    [anon_sym_volatile] = ACTIONS(2396),
    [anon_sym_this] = ACTIONS(2396),
    [anon_sym_base] = ACTIONS(2396),
    [anon_sym_LBRACE] = ACTIONS(2394),
    [anon_sym_RBRACE] = ACTIONS(2394),
    [anon_sym_TILDE] = ACTIONS(2394),
    [anon_sym_where] = ACTIONS(2396),
    [anon_sym_notnull] = ACTIONS(2396),
    [anon_sym_unmanaged] = ACTIONS(2396),
    [anon_sym_BANG] = ACTIONS(2394),
    [anon_sym_PLUS_PLUS] = ACTIONS(2394),
    [anon_sym_DASH_DASH] = ACTIONS(2394),
    [anon_sym_true] = ACTIONS(2396),
    [anon_sym_false] = ACTIONS(2396),
    [anon_sym_PLUS] = ACTIONS(2396),
    [anon_sym_DASH] = ACTIONS(2396),
    [anon_sym_STAR] = ACTIONS(2394),
    [anon_sym_CARET] = ACTIONS(2394),
    [anon_sym_AMP] = ACTIONS(2394),
    [anon_sym_get] = ACTIONS(2396),
    [anon_sym_set] = ACTIONS(2396),
    [anon_sym_add] = ACTIONS(2396),
    [anon_sym_remove] = ACTIONS(2396),
    [anon_sym_delegate] = ACTIONS(2396),
    [anon_sym_var] = ACTIONS(2396),
    [sym_predefined_type] = ACTIONS(2396),
    [anon_sym_break] = ACTIONS(2396),
    [anon_sym_checked] = ACTIONS(2396),
    [anon_sym_unchecked] = ACTIONS(2396),
    [anon_sym_continue] = ACTIONS(2396),
    [anon_sym_do] = ACTIONS(2396),
    [anon_sym_while] = ACTIONS(2396),
    [anon_sym_for] = ACTIONS(2396),
    [anon_sym_await] = ACTIONS(2396),
    [anon_sym_foreach] = ACTIONS(2396),
    [anon_sym_goto] = ACTIONS(2396),
    [anon_sym_case] = ACTIONS(2396),
    [anon_sym_default] = ACTIONS(2396),
    [anon_sym_if] = ACTIONS(2396),
    [anon_sym_else] = ACTIONS(2721),
    [anon_sym_lock] = ACTIONS(2396),
    [anon_sym_switch] = ACTIONS(2396),
    [anon_sym_when] = ACTIONS(2396),
    [anon_sym_throw] = ACTIONS(2396),
    [anon_sym_try] = ACTIONS(2396),
    [anon_sym_yield] = ACTIONS(2396),
    [anon_sym_stackalloc] = ACTIONS(2396),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2394),
    [anon_sym_DQUOTE] = ACTIONS(2394),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2394),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2394),
    [anon_sym___makeref] = ACTIONS(2396),
    [anon_sym_from] = ACTIONS(2396),
    [anon_sym_join] = ACTIONS(2396),
    [anon_sym_on] = ACTIONS(2396),
    [anon_sym_equals] = ACTIONS(2396),
    [anon_sym_into] = ACTIONS(2396),
    [anon_sym_let] = ACTIONS(2396),
    [anon_sym_orderby] = ACTIONS(2396),
    [anon_sym_ascending] = ACTIONS(2396),
    [anon_sym_descending] = ACTIONS(2396),
    [anon_sym_group] = ACTIONS(2396),
    [anon_sym_by] = ACTIONS(2396),
    [anon_sym_select] = ACTIONS(2396),
    [anon_sym_DOT_DOT] = ACTIONS(2394),
    [anon_sym___reftype] = ACTIONS(2396),
    [anon_sym___refvalue] = ACTIONS(2396),
    [anon_sym_sizeof] = ACTIONS(2396),
    [anon_sym_typeof] = ACTIONS(2396),
    [anon_sym_SQUOTE] = ACTIONS(2394),
    [sym_integer_literal] = ACTIONS(2396),
    [sym_null_literal] = ACTIONS(2396),
    [sym_real_literal] = ACTIONS(2394),
    [sym_verbatim_string_literal] = ACTIONS(2394),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2396),
    [anon_sym_nameof] = ACTIONS(2396),
    [sym_void_keyword] = ACTIONS(2396),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1719] = {
    [sym__preprocessor_call] = STATE(1719),
    [sym__identifier_token] = ACTIONS(2530),
    [anon_sym_extern] = ACTIONS(2530),
    [anon_sym_alias] = ACTIONS(2530),
    [anon_sym_SEMI] = ACTIONS(2528),
    [anon_sym_global] = ACTIONS(2530),
    [anon_sym_using] = ACTIONS(2530),
    [anon_sym_static] = ACTIONS(2530),
    [anon_sym_LBRACK] = ACTIONS(2528),
    [anon_sym_return] = ACTIONS(2530),
    [anon_sym_LPAREN] = ACTIONS(2528),
    [anon_sym_abstract] = ACTIONS(2530),
    [anon_sym_async] = ACTIONS(2530),
    [anon_sym_const] = ACTIONS(2530),
    [anon_sym_fixed] = ACTIONS(2530),
    [anon_sym_internal] = ACTIONS(2530),
    [anon_sym_new] = ACTIONS(2530),
    [anon_sym_override] = ACTIONS(2530),
    [anon_sym_partial] = ACTIONS(2530),
    [anon_sym_private] = ACTIONS(2530),
    [anon_sym_protected] = ACTIONS(2530),
    [anon_sym_public] = ACTIONS(2530),
    [anon_sym_readonly] = ACTIONS(2530),
    [anon_sym_ref] = ACTIONS(2530),
    [anon_sym_sealed] = ACTIONS(2530),
    [anon_sym_unsafe] = ACTIONS(2530),
    [anon_sym_virtual] = ACTIONS(2530),
    [anon_sym_volatile] = ACTIONS(2530),
    [anon_sym_this] = ACTIONS(2530),
    [anon_sym_base] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(2528),
    [anon_sym_RBRACE] = ACTIONS(2528),
    [anon_sym_TILDE] = ACTIONS(2528),
    [anon_sym_where] = ACTIONS(2530),
    [anon_sym_notnull] = ACTIONS(2530),
    [anon_sym_unmanaged] = ACTIONS(2530),
    [anon_sym_BANG] = ACTIONS(2528),
    [anon_sym_PLUS_PLUS] = ACTIONS(2528),
    [anon_sym_DASH_DASH] = ACTIONS(2528),
    [anon_sym_true] = ACTIONS(2530),
    [anon_sym_false] = ACTIONS(2530),
    [anon_sym_PLUS] = ACTIONS(2530),
    [anon_sym_DASH] = ACTIONS(2530),
    [anon_sym_STAR] = ACTIONS(2528),
    [anon_sym_CARET] = ACTIONS(2528),
    [anon_sym_AMP] = ACTIONS(2528),
    [anon_sym_get] = ACTIONS(2530),
    [anon_sym_set] = ACTIONS(2530),
    [anon_sym_add] = ACTIONS(2530),
    [anon_sym_remove] = ACTIONS(2530),
    [anon_sym_delegate] = ACTIONS(2530),
    [anon_sym_var] = ACTIONS(2530),
    [sym_predefined_type] = ACTIONS(2530),
    [anon_sym_break] = ACTIONS(2530),
    [anon_sym_checked] = ACTIONS(2530),
    [anon_sym_unchecked] = ACTIONS(2530),
    [anon_sym_continue] = ACTIONS(2530),
    [anon_sym_do] = ACTIONS(2530),
    [anon_sym_while] = ACTIONS(2530),
    [anon_sym_for] = ACTIONS(2530),
    [anon_sym_await] = ACTIONS(2530),
    [anon_sym_foreach] = ACTIONS(2530),
    [anon_sym_goto] = ACTIONS(2530),
    [anon_sym_case] = ACTIONS(2530),
    [anon_sym_default] = ACTIONS(2530),
    [anon_sym_if] = ACTIONS(2530),
    [anon_sym_else] = ACTIONS(2530),
    [anon_sym_lock] = ACTIONS(2530),
    [anon_sym_switch] = ACTIONS(2530),
    [anon_sym_when] = ACTIONS(2530),
    [anon_sym_throw] = ACTIONS(2530),
    [anon_sym_try] = ACTIONS(2530),
    [anon_sym_yield] = ACTIONS(2530),
    [anon_sym_stackalloc] = ACTIONS(2530),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2528),
    [anon_sym_DQUOTE] = ACTIONS(2528),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2528),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2528),
    [anon_sym___makeref] = ACTIONS(2530),
    [anon_sym_from] = ACTIONS(2530),
    [anon_sym_join] = ACTIONS(2530),
    [anon_sym_on] = ACTIONS(2530),
    [anon_sym_equals] = ACTIONS(2530),
    [anon_sym_into] = ACTIONS(2530),
    [anon_sym_let] = ACTIONS(2530),
    [anon_sym_orderby] = ACTIONS(2530),
    [anon_sym_ascending] = ACTIONS(2530),
    [anon_sym_descending] = ACTIONS(2530),
    [anon_sym_group] = ACTIONS(2530),
    [anon_sym_by] = ACTIONS(2530),
    [anon_sym_select] = ACTIONS(2530),
    [anon_sym_DOT_DOT] = ACTIONS(2528),
    [anon_sym___reftype] = ACTIONS(2530),
    [anon_sym___refvalue] = ACTIONS(2530),
    [anon_sym_sizeof] = ACTIONS(2530),
    [anon_sym_typeof] = ACTIONS(2530),
    [anon_sym_SQUOTE] = ACTIONS(2528),
    [sym_integer_literal] = ACTIONS(2530),
    [sym_null_literal] = ACTIONS(2530),
    [sym_real_literal] = ACTIONS(2528),
    [sym_verbatim_string_literal] = ACTIONS(2528),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2530),
    [anon_sym_nameof] = ACTIONS(2530),
    [sym_void_keyword] = ACTIONS(2530),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1720] = {
    [sym__preprocessor_call] = STATE(1720),
    [sym__identifier_token] = ACTIONS(2376),
    [anon_sym_extern] = ACTIONS(2376),
    [anon_sym_alias] = ACTIONS(2376),
    [anon_sym_SEMI] = ACTIONS(2374),
    [anon_sym_global] = ACTIONS(2376),
    [anon_sym_using] = ACTIONS(2376),
    [anon_sym_static] = ACTIONS(2376),
    [anon_sym_LBRACK] = ACTIONS(2374),
    [anon_sym_return] = ACTIONS(2376),
    [anon_sym_LPAREN] = ACTIONS(2374),
    [anon_sym_abstract] = ACTIONS(2376),
    [anon_sym_async] = ACTIONS(2376),
    [anon_sym_const] = ACTIONS(2376),
    [anon_sym_fixed] = ACTIONS(2376),
    [anon_sym_internal] = ACTIONS(2376),
    [anon_sym_new] = ACTIONS(2376),
    [anon_sym_override] = ACTIONS(2376),
    [anon_sym_partial] = ACTIONS(2376),
    [anon_sym_private] = ACTIONS(2376),
    [anon_sym_protected] = ACTIONS(2376),
    [anon_sym_public] = ACTIONS(2376),
    [anon_sym_readonly] = ACTIONS(2376),
    [anon_sym_ref] = ACTIONS(2376),
    [anon_sym_sealed] = ACTIONS(2376),
    [anon_sym_unsafe] = ACTIONS(2376),
    [anon_sym_virtual] = ACTIONS(2376),
    [anon_sym_volatile] = ACTIONS(2376),
    [anon_sym_this] = ACTIONS(2376),
    [anon_sym_base] = ACTIONS(2376),
    [anon_sym_LBRACE] = ACTIONS(2374),
    [anon_sym_RBRACE] = ACTIONS(2374),
    [anon_sym_TILDE] = ACTIONS(2374),
    [anon_sym_where] = ACTIONS(2376),
    [anon_sym_notnull] = ACTIONS(2376),
    [anon_sym_unmanaged] = ACTIONS(2376),
    [anon_sym_BANG] = ACTIONS(2374),
    [anon_sym_PLUS_PLUS] = ACTIONS(2374),
    [anon_sym_DASH_DASH] = ACTIONS(2374),
    [anon_sym_true] = ACTIONS(2376),
    [anon_sym_false] = ACTIONS(2376),
    [anon_sym_PLUS] = ACTIONS(2376),
    [anon_sym_DASH] = ACTIONS(2376),
    [anon_sym_STAR] = ACTIONS(2374),
    [anon_sym_CARET] = ACTIONS(2374),
    [anon_sym_AMP] = ACTIONS(2374),
    [anon_sym_get] = ACTIONS(2376),
    [anon_sym_set] = ACTIONS(2376),
    [anon_sym_add] = ACTIONS(2376),
    [anon_sym_remove] = ACTIONS(2376),
    [anon_sym_delegate] = ACTIONS(2376),
    [anon_sym_var] = ACTIONS(2376),
    [sym_predefined_type] = ACTIONS(2376),
    [anon_sym_break] = ACTIONS(2376),
    [anon_sym_checked] = ACTIONS(2376),
    [anon_sym_unchecked] = ACTIONS(2376),
    [anon_sym_continue] = ACTIONS(2376),
    [anon_sym_do] = ACTIONS(2376),
    [anon_sym_while] = ACTIONS(2376),
    [anon_sym_for] = ACTIONS(2376),
    [anon_sym_await] = ACTIONS(2376),
    [anon_sym_foreach] = ACTIONS(2376),
    [anon_sym_goto] = ACTIONS(2376),
    [anon_sym_case] = ACTIONS(2376),
    [anon_sym_default] = ACTIONS(2376),
    [anon_sym_if] = ACTIONS(2376),
    [anon_sym_else] = ACTIONS(2376),
    [anon_sym_lock] = ACTIONS(2376),
    [anon_sym_switch] = ACTIONS(2376),
    [anon_sym_when] = ACTIONS(2376),
    [anon_sym_throw] = ACTIONS(2376),
    [anon_sym_try] = ACTIONS(2376),
    [anon_sym_yield] = ACTIONS(2376),
    [anon_sym_stackalloc] = ACTIONS(2376),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2374),
    [anon_sym_DQUOTE] = ACTIONS(2374),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2374),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2374),
    [anon_sym___makeref] = ACTIONS(2376),
    [anon_sym_from] = ACTIONS(2376),
    [anon_sym_join] = ACTIONS(2376),
    [anon_sym_on] = ACTIONS(2376),
    [anon_sym_equals] = ACTIONS(2376),
    [anon_sym_into] = ACTIONS(2376),
    [anon_sym_let] = ACTIONS(2376),
    [anon_sym_orderby] = ACTIONS(2376),
    [anon_sym_ascending] = ACTIONS(2376),
    [anon_sym_descending] = ACTIONS(2376),
    [anon_sym_group] = ACTIONS(2376),
    [anon_sym_by] = ACTIONS(2376),
    [anon_sym_select] = ACTIONS(2376),
    [anon_sym_DOT_DOT] = ACTIONS(2374),
    [anon_sym___reftype] = ACTIONS(2376),
    [anon_sym___refvalue] = ACTIONS(2376),
    [anon_sym_sizeof] = ACTIONS(2376),
    [anon_sym_typeof] = ACTIONS(2376),
    [anon_sym_SQUOTE] = ACTIONS(2374),
    [sym_integer_literal] = ACTIONS(2376),
    [sym_null_literal] = ACTIONS(2376),
    [sym_real_literal] = ACTIONS(2374),
    [sym_verbatim_string_literal] = ACTIONS(2374),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2376),
    [anon_sym_nameof] = ACTIONS(2376),
    [sym_void_keyword] = ACTIONS(2376),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1721] = {
    [sym__preprocessor_call] = STATE(1721),
    [sym__identifier_token] = ACTIONS(2518),
    [anon_sym_extern] = ACTIONS(2518),
    [anon_sym_alias] = ACTIONS(2518),
    [anon_sym_SEMI] = ACTIONS(2516),
    [anon_sym_global] = ACTIONS(2518),
    [anon_sym_using] = ACTIONS(2518),
    [anon_sym_static] = ACTIONS(2518),
    [anon_sym_LBRACK] = ACTIONS(2516),
    [anon_sym_return] = ACTIONS(2518),
    [anon_sym_LPAREN] = ACTIONS(2516),
    [anon_sym_abstract] = ACTIONS(2518),
    [anon_sym_async] = ACTIONS(2518),
    [anon_sym_const] = ACTIONS(2518),
    [anon_sym_fixed] = ACTIONS(2518),
    [anon_sym_internal] = ACTIONS(2518),
    [anon_sym_new] = ACTIONS(2518),
    [anon_sym_override] = ACTIONS(2518),
    [anon_sym_partial] = ACTIONS(2518),
    [anon_sym_private] = ACTIONS(2518),
    [anon_sym_protected] = ACTIONS(2518),
    [anon_sym_public] = ACTIONS(2518),
    [anon_sym_readonly] = ACTIONS(2518),
    [anon_sym_ref] = ACTIONS(2518),
    [anon_sym_sealed] = ACTIONS(2518),
    [anon_sym_unsafe] = ACTIONS(2518),
    [anon_sym_virtual] = ACTIONS(2518),
    [anon_sym_volatile] = ACTIONS(2518),
    [anon_sym_this] = ACTIONS(2518),
    [anon_sym_base] = ACTIONS(2518),
    [anon_sym_LBRACE] = ACTIONS(2516),
    [anon_sym_RBRACE] = ACTIONS(2516),
    [anon_sym_TILDE] = ACTIONS(2516),
    [anon_sym_where] = ACTIONS(2518),
    [anon_sym_notnull] = ACTIONS(2518),
    [anon_sym_unmanaged] = ACTIONS(2518),
    [anon_sym_BANG] = ACTIONS(2516),
    [anon_sym_PLUS_PLUS] = ACTIONS(2516),
    [anon_sym_DASH_DASH] = ACTIONS(2516),
    [anon_sym_true] = ACTIONS(2518),
    [anon_sym_false] = ACTIONS(2518),
    [anon_sym_PLUS] = ACTIONS(2518),
    [anon_sym_DASH] = ACTIONS(2518),
    [anon_sym_STAR] = ACTIONS(2516),
    [anon_sym_CARET] = ACTIONS(2516),
    [anon_sym_AMP] = ACTIONS(2516),
    [anon_sym_get] = ACTIONS(2518),
    [anon_sym_set] = ACTIONS(2518),
    [anon_sym_add] = ACTIONS(2518),
    [anon_sym_remove] = ACTIONS(2518),
    [anon_sym_delegate] = ACTIONS(2518),
    [anon_sym_var] = ACTIONS(2518),
    [sym_predefined_type] = ACTIONS(2518),
    [anon_sym_break] = ACTIONS(2518),
    [anon_sym_checked] = ACTIONS(2518),
    [anon_sym_unchecked] = ACTIONS(2518),
    [anon_sym_continue] = ACTIONS(2518),
    [anon_sym_do] = ACTIONS(2518),
    [anon_sym_while] = ACTIONS(2518),
    [anon_sym_for] = ACTIONS(2518),
    [anon_sym_await] = ACTIONS(2518),
    [anon_sym_foreach] = ACTIONS(2518),
    [anon_sym_goto] = ACTIONS(2518),
    [anon_sym_case] = ACTIONS(2518),
    [anon_sym_default] = ACTIONS(2518),
    [anon_sym_if] = ACTIONS(2518),
    [anon_sym_else] = ACTIONS(2518),
    [anon_sym_lock] = ACTIONS(2518),
    [anon_sym_switch] = ACTIONS(2518),
    [anon_sym_when] = ACTIONS(2518),
    [anon_sym_throw] = ACTIONS(2518),
    [anon_sym_try] = ACTIONS(2518),
    [anon_sym_yield] = ACTIONS(2518),
    [anon_sym_stackalloc] = ACTIONS(2518),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2516),
    [anon_sym_DQUOTE] = ACTIONS(2516),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2516),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2516),
    [anon_sym___makeref] = ACTIONS(2518),
    [anon_sym_from] = ACTIONS(2518),
    [anon_sym_join] = ACTIONS(2518),
    [anon_sym_on] = ACTIONS(2518),
    [anon_sym_equals] = ACTIONS(2518),
    [anon_sym_into] = ACTIONS(2518),
    [anon_sym_let] = ACTIONS(2518),
    [anon_sym_orderby] = ACTIONS(2518),
    [anon_sym_ascending] = ACTIONS(2518),
    [anon_sym_descending] = ACTIONS(2518),
    [anon_sym_group] = ACTIONS(2518),
    [anon_sym_by] = ACTIONS(2518),
    [anon_sym_select] = ACTIONS(2518),
    [anon_sym_DOT_DOT] = ACTIONS(2516),
    [anon_sym___reftype] = ACTIONS(2518),
    [anon_sym___refvalue] = ACTIONS(2518),
    [anon_sym_sizeof] = ACTIONS(2518),
    [anon_sym_typeof] = ACTIONS(2518),
    [anon_sym_SQUOTE] = ACTIONS(2516),
    [sym_integer_literal] = ACTIONS(2518),
    [sym_null_literal] = ACTIONS(2518),
    [sym_real_literal] = ACTIONS(2516),
    [sym_verbatim_string_literal] = ACTIONS(2516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2518),
    [anon_sym_nameof] = ACTIONS(2518),
    [sym_void_keyword] = ACTIONS(2518),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1722] = {
    [sym__preprocessor_call] = STATE(1722),
    [sym__identifier_token] = ACTIONS(2514),
    [anon_sym_extern] = ACTIONS(2514),
    [anon_sym_alias] = ACTIONS(2514),
    [anon_sym_SEMI] = ACTIONS(2512),
    [anon_sym_global] = ACTIONS(2514),
    [anon_sym_using] = ACTIONS(2514),
    [anon_sym_static] = ACTIONS(2514),
    [anon_sym_LBRACK] = ACTIONS(2512),
    [anon_sym_return] = ACTIONS(2514),
    [anon_sym_LPAREN] = ACTIONS(2512),
    [anon_sym_abstract] = ACTIONS(2514),
    [anon_sym_async] = ACTIONS(2514),
    [anon_sym_const] = ACTIONS(2514),
    [anon_sym_fixed] = ACTIONS(2514),
    [anon_sym_internal] = ACTIONS(2514),
    [anon_sym_new] = ACTIONS(2514),
    [anon_sym_override] = ACTIONS(2514),
    [anon_sym_partial] = ACTIONS(2514),
    [anon_sym_private] = ACTIONS(2514),
    [anon_sym_protected] = ACTIONS(2514),
    [anon_sym_public] = ACTIONS(2514),
    [anon_sym_readonly] = ACTIONS(2514),
    [anon_sym_ref] = ACTIONS(2514),
    [anon_sym_sealed] = ACTIONS(2514),
    [anon_sym_unsafe] = ACTIONS(2514),
    [anon_sym_virtual] = ACTIONS(2514),
    [anon_sym_volatile] = ACTIONS(2514),
    [anon_sym_this] = ACTIONS(2514),
    [anon_sym_base] = ACTIONS(2514),
    [anon_sym_LBRACE] = ACTIONS(2512),
    [anon_sym_RBRACE] = ACTIONS(2512),
    [anon_sym_TILDE] = ACTIONS(2512),
    [anon_sym_where] = ACTIONS(2514),
    [anon_sym_notnull] = ACTIONS(2514),
    [anon_sym_unmanaged] = ACTIONS(2514),
    [anon_sym_BANG] = ACTIONS(2512),
    [anon_sym_PLUS_PLUS] = ACTIONS(2512),
    [anon_sym_DASH_DASH] = ACTIONS(2512),
    [anon_sym_true] = ACTIONS(2514),
    [anon_sym_false] = ACTIONS(2514),
    [anon_sym_PLUS] = ACTIONS(2514),
    [anon_sym_DASH] = ACTIONS(2514),
    [anon_sym_STAR] = ACTIONS(2512),
    [anon_sym_CARET] = ACTIONS(2512),
    [anon_sym_AMP] = ACTIONS(2512),
    [anon_sym_get] = ACTIONS(2514),
    [anon_sym_set] = ACTIONS(2514),
    [anon_sym_add] = ACTIONS(2514),
    [anon_sym_remove] = ACTIONS(2514),
    [anon_sym_delegate] = ACTIONS(2514),
    [anon_sym_var] = ACTIONS(2514),
    [sym_predefined_type] = ACTIONS(2514),
    [anon_sym_break] = ACTIONS(2514),
    [anon_sym_checked] = ACTIONS(2514),
    [anon_sym_unchecked] = ACTIONS(2514),
    [anon_sym_continue] = ACTIONS(2514),
    [anon_sym_do] = ACTIONS(2514),
    [anon_sym_while] = ACTIONS(2514),
    [anon_sym_for] = ACTIONS(2514),
    [anon_sym_await] = ACTIONS(2514),
    [anon_sym_foreach] = ACTIONS(2514),
    [anon_sym_goto] = ACTIONS(2514),
    [anon_sym_case] = ACTIONS(2514),
    [anon_sym_default] = ACTIONS(2514),
    [anon_sym_if] = ACTIONS(2514),
    [anon_sym_else] = ACTIONS(2514),
    [anon_sym_lock] = ACTIONS(2514),
    [anon_sym_switch] = ACTIONS(2514),
    [anon_sym_when] = ACTIONS(2514),
    [anon_sym_throw] = ACTIONS(2514),
    [anon_sym_try] = ACTIONS(2514),
    [anon_sym_yield] = ACTIONS(2514),
    [anon_sym_stackalloc] = ACTIONS(2514),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2512),
    [anon_sym_DQUOTE] = ACTIONS(2512),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2512),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2512),
    [anon_sym___makeref] = ACTIONS(2514),
    [anon_sym_from] = ACTIONS(2514),
    [anon_sym_join] = ACTIONS(2514),
    [anon_sym_on] = ACTIONS(2514),
    [anon_sym_equals] = ACTIONS(2514),
    [anon_sym_into] = ACTIONS(2514),
    [anon_sym_let] = ACTIONS(2514),
    [anon_sym_orderby] = ACTIONS(2514),
    [anon_sym_ascending] = ACTIONS(2514),
    [anon_sym_descending] = ACTIONS(2514),
    [anon_sym_group] = ACTIONS(2514),
    [anon_sym_by] = ACTIONS(2514),
    [anon_sym_select] = ACTIONS(2514),
    [anon_sym_DOT_DOT] = ACTIONS(2512),
    [anon_sym___reftype] = ACTIONS(2514),
    [anon_sym___refvalue] = ACTIONS(2514),
    [anon_sym_sizeof] = ACTIONS(2514),
    [anon_sym_typeof] = ACTIONS(2514),
    [anon_sym_SQUOTE] = ACTIONS(2512),
    [sym_integer_literal] = ACTIONS(2514),
    [sym_null_literal] = ACTIONS(2514),
    [sym_real_literal] = ACTIONS(2512),
    [sym_verbatim_string_literal] = ACTIONS(2512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2514),
    [anon_sym_nameof] = ACTIONS(2514),
    [sym_void_keyword] = ACTIONS(2514),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1723] = {
    [sym__preprocessor_call] = STATE(1723),
    [sym__identifier_token] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym_alias] = ACTIONS(2482),
    [anon_sym_SEMI] = ACTIONS(2480),
    [anon_sym_global] = ACTIONS(2482),
    [anon_sym_using] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_return] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_fixed] = ACTIONS(2482),
    [anon_sym_internal] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_partial] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_ref] = ACTIONS(2482),
    [anon_sym_sealed] = ACTIONS(2482),
    [anon_sym_unsafe] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_this] = ACTIONS(2482),
    [anon_sym_base] = ACTIONS(2482),
    [anon_sym_LBRACE] = ACTIONS(2480),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_TILDE] = ACTIONS(2480),
    [anon_sym_where] = ACTIONS(2482),
    [anon_sym_notnull] = ACTIONS(2482),
    [anon_sym_unmanaged] = ACTIONS(2482),
    [anon_sym_BANG] = ACTIONS(2480),
    [anon_sym_PLUS_PLUS] = ACTIONS(2480),
    [anon_sym_DASH_DASH] = ACTIONS(2480),
    [anon_sym_true] = ACTIONS(2482),
    [anon_sym_false] = ACTIONS(2482),
    [anon_sym_PLUS] = ACTIONS(2482),
    [anon_sym_DASH] = ACTIONS(2482),
    [anon_sym_STAR] = ACTIONS(2480),
    [anon_sym_CARET] = ACTIONS(2480),
    [anon_sym_AMP] = ACTIONS(2480),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_add] = ACTIONS(2482),
    [anon_sym_remove] = ACTIONS(2482),
    [anon_sym_delegate] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [sym_predefined_type] = ACTIONS(2482),
    [anon_sym_break] = ACTIONS(2482),
    [anon_sym_checked] = ACTIONS(2482),
    [anon_sym_unchecked] = ACTIONS(2482),
    [anon_sym_continue] = ACTIONS(2482),
    [anon_sym_do] = ACTIONS(2482),
    [anon_sym_while] = ACTIONS(2482),
    [anon_sym_for] = ACTIONS(2482),
    [anon_sym_await] = ACTIONS(2482),
    [anon_sym_foreach] = ACTIONS(2482),
    [anon_sym_goto] = ACTIONS(2482),
    [anon_sym_case] = ACTIONS(2482),
    [anon_sym_default] = ACTIONS(2482),
    [anon_sym_if] = ACTIONS(2482),
    [anon_sym_else] = ACTIONS(2482),
    [anon_sym_lock] = ACTIONS(2482),
    [anon_sym_switch] = ACTIONS(2482),
    [anon_sym_when] = ACTIONS(2482),
    [anon_sym_throw] = ACTIONS(2482),
    [anon_sym_try] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_stackalloc] = ACTIONS(2482),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2480),
    [anon_sym_DQUOTE] = ACTIONS(2480),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2480),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2480),
    [anon_sym___makeref] = ACTIONS(2482),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_join] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_equals] = ACTIONS(2482),
    [anon_sym_into] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_orderby] = ACTIONS(2482),
    [anon_sym_ascending] = ACTIONS(2482),
    [anon_sym_descending] = ACTIONS(2482),
    [anon_sym_group] = ACTIONS(2482),
    [anon_sym_by] = ACTIONS(2482),
    [anon_sym_select] = ACTIONS(2482),
    [anon_sym_DOT_DOT] = ACTIONS(2480),
    [anon_sym___reftype] = ACTIONS(2482),
    [anon_sym___refvalue] = ACTIONS(2482),
    [anon_sym_sizeof] = ACTIONS(2482),
    [anon_sym_typeof] = ACTIONS(2482),
    [anon_sym_SQUOTE] = ACTIONS(2480),
    [sym_integer_literal] = ACTIONS(2482),
    [sym_null_literal] = ACTIONS(2482),
    [sym_real_literal] = ACTIONS(2480),
    [sym_verbatim_string_literal] = ACTIONS(2480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2482),
    [anon_sym_nameof] = ACTIONS(2482),
    [sym_void_keyword] = ACTIONS(2482),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1724] = {
    [sym__preprocessor_call] = STATE(1724),
    [sym__identifier_token] = ACTIONS(2252),
    [anon_sym_extern] = ACTIONS(2252),
    [anon_sym_alias] = ACTIONS(2252),
    [anon_sym_SEMI] = ACTIONS(2250),
    [anon_sym_global] = ACTIONS(2252),
    [anon_sym_using] = ACTIONS(2252),
    [anon_sym_static] = ACTIONS(2252),
    [anon_sym_LBRACK] = ACTIONS(2250),
    [anon_sym_return] = ACTIONS(2252),
    [anon_sym_LPAREN] = ACTIONS(2250),
    [anon_sym_abstract] = ACTIONS(2252),
    [anon_sym_async] = ACTIONS(2252),
    [anon_sym_const] = ACTIONS(2252),
    [anon_sym_fixed] = ACTIONS(2252),
    [anon_sym_internal] = ACTIONS(2252),
    [anon_sym_new] = ACTIONS(2252),
    [anon_sym_override] = ACTIONS(2252),
    [anon_sym_partial] = ACTIONS(2252),
    [anon_sym_private] = ACTIONS(2252),
    [anon_sym_protected] = ACTIONS(2252),
    [anon_sym_public] = ACTIONS(2252),
    [anon_sym_readonly] = ACTIONS(2252),
    [anon_sym_ref] = ACTIONS(2252),
    [anon_sym_sealed] = ACTIONS(2252),
    [anon_sym_unsafe] = ACTIONS(2252),
    [anon_sym_virtual] = ACTIONS(2252),
    [anon_sym_volatile] = ACTIONS(2252),
    [anon_sym_this] = ACTIONS(2252),
    [anon_sym_base] = ACTIONS(2252),
    [anon_sym_LBRACE] = ACTIONS(2250),
    [anon_sym_RBRACE] = ACTIONS(2250),
    [anon_sym_TILDE] = ACTIONS(2250),
    [anon_sym_where] = ACTIONS(2252),
    [anon_sym_notnull] = ACTIONS(2252),
    [anon_sym_unmanaged] = ACTIONS(2252),
    [anon_sym_BANG] = ACTIONS(2250),
    [anon_sym_PLUS_PLUS] = ACTIONS(2250),
    [anon_sym_DASH_DASH] = ACTIONS(2250),
    [anon_sym_true] = ACTIONS(2252),
    [anon_sym_false] = ACTIONS(2252),
    [anon_sym_PLUS] = ACTIONS(2252),
    [anon_sym_DASH] = ACTIONS(2252),
    [anon_sym_STAR] = ACTIONS(2250),
    [anon_sym_CARET] = ACTIONS(2250),
    [anon_sym_AMP] = ACTIONS(2250),
    [anon_sym_get] = ACTIONS(2252),
    [anon_sym_set] = ACTIONS(2252),
    [anon_sym_add] = ACTIONS(2252),
    [anon_sym_remove] = ACTIONS(2252),
    [anon_sym_delegate] = ACTIONS(2252),
    [anon_sym_var] = ACTIONS(2252),
    [sym_predefined_type] = ACTIONS(2252),
    [anon_sym_break] = ACTIONS(2252),
    [anon_sym_checked] = ACTIONS(2252),
    [anon_sym_unchecked] = ACTIONS(2252),
    [anon_sym_continue] = ACTIONS(2252),
    [anon_sym_do] = ACTIONS(2252),
    [anon_sym_while] = ACTIONS(2252),
    [anon_sym_for] = ACTIONS(2252),
    [anon_sym_await] = ACTIONS(2252),
    [anon_sym_foreach] = ACTIONS(2252),
    [anon_sym_goto] = ACTIONS(2252),
    [anon_sym_case] = ACTIONS(2252),
    [anon_sym_default] = ACTIONS(2252),
    [anon_sym_if] = ACTIONS(2252),
    [anon_sym_else] = ACTIONS(2252),
    [anon_sym_lock] = ACTIONS(2252),
    [anon_sym_switch] = ACTIONS(2252),
    [anon_sym_when] = ACTIONS(2252),
    [anon_sym_throw] = ACTIONS(2252),
    [anon_sym_try] = ACTIONS(2252),
    [anon_sym_yield] = ACTIONS(2252),
    [anon_sym_stackalloc] = ACTIONS(2252),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym_DQUOTE] = ACTIONS(2250),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2250),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2250),
    [anon_sym___makeref] = ACTIONS(2252),
    [anon_sym_from] = ACTIONS(2252),
    [anon_sym_join] = ACTIONS(2252),
    [anon_sym_on] = ACTIONS(2252),
    [anon_sym_equals] = ACTIONS(2252),
    [anon_sym_into] = ACTIONS(2252),
    [anon_sym_let] = ACTIONS(2252),
    [anon_sym_orderby] = ACTIONS(2252),
    [anon_sym_ascending] = ACTIONS(2252),
    [anon_sym_descending] = ACTIONS(2252),
    [anon_sym_group] = ACTIONS(2252),
    [anon_sym_by] = ACTIONS(2252),
    [anon_sym_select] = ACTIONS(2252),
    [anon_sym_DOT_DOT] = ACTIONS(2250),
    [anon_sym___reftype] = ACTIONS(2252),
    [anon_sym___refvalue] = ACTIONS(2252),
    [anon_sym_sizeof] = ACTIONS(2252),
    [anon_sym_typeof] = ACTIONS(2252),
    [anon_sym_SQUOTE] = ACTIONS(2250),
    [sym_integer_literal] = ACTIONS(2252),
    [sym_null_literal] = ACTIONS(2252),
    [sym_real_literal] = ACTIONS(2250),
    [sym_verbatim_string_literal] = ACTIONS(2250),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2252),
    [anon_sym_nameof] = ACTIONS(2252),
    [sym_void_keyword] = ACTIONS(2252),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1725] = {
    [sym__preprocessor_call] = STATE(1725),
    [sym__identifier_token] = ACTIONS(2506),
    [anon_sym_extern] = ACTIONS(2506),
    [anon_sym_alias] = ACTIONS(2506),
    [anon_sym_SEMI] = ACTIONS(2504),
    [anon_sym_global] = ACTIONS(2506),
    [anon_sym_using] = ACTIONS(2506),
    [anon_sym_static] = ACTIONS(2506),
    [anon_sym_LBRACK] = ACTIONS(2504),
    [anon_sym_return] = ACTIONS(2506),
    [anon_sym_LPAREN] = ACTIONS(2504),
    [anon_sym_abstract] = ACTIONS(2506),
    [anon_sym_async] = ACTIONS(2506),
    [anon_sym_const] = ACTIONS(2506),
    [anon_sym_fixed] = ACTIONS(2506),
    [anon_sym_internal] = ACTIONS(2506),
    [anon_sym_new] = ACTIONS(2506),
    [anon_sym_override] = ACTIONS(2506),
    [anon_sym_partial] = ACTIONS(2506),
    [anon_sym_private] = ACTIONS(2506),
    [anon_sym_protected] = ACTIONS(2506),
    [anon_sym_public] = ACTIONS(2506),
    [anon_sym_readonly] = ACTIONS(2506),
    [anon_sym_ref] = ACTIONS(2506),
    [anon_sym_sealed] = ACTIONS(2506),
    [anon_sym_unsafe] = ACTIONS(2506),
    [anon_sym_virtual] = ACTIONS(2506),
    [anon_sym_volatile] = ACTIONS(2506),
    [anon_sym_this] = ACTIONS(2506),
    [anon_sym_base] = ACTIONS(2506),
    [anon_sym_LBRACE] = ACTIONS(2504),
    [anon_sym_RBRACE] = ACTIONS(2504),
    [anon_sym_TILDE] = ACTIONS(2504),
    [anon_sym_where] = ACTIONS(2506),
    [anon_sym_notnull] = ACTIONS(2506),
    [anon_sym_unmanaged] = ACTIONS(2506),
    [anon_sym_BANG] = ACTIONS(2504),
    [anon_sym_PLUS_PLUS] = ACTIONS(2504),
    [anon_sym_DASH_DASH] = ACTIONS(2504),
    [anon_sym_true] = ACTIONS(2506),
    [anon_sym_false] = ACTIONS(2506),
    [anon_sym_PLUS] = ACTIONS(2506),
    [anon_sym_DASH] = ACTIONS(2506),
    [anon_sym_STAR] = ACTIONS(2504),
    [anon_sym_CARET] = ACTIONS(2504),
    [anon_sym_AMP] = ACTIONS(2504),
    [anon_sym_get] = ACTIONS(2506),
    [anon_sym_set] = ACTIONS(2506),
    [anon_sym_add] = ACTIONS(2506),
    [anon_sym_remove] = ACTIONS(2506),
    [anon_sym_delegate] = ACTIONS(2506),
    [anon_sym_var] = ACTIONS(2506),
    [sym_predefined_type] = ACTIONS(2506),
    [anon_sym_break] = ACTIONS(2506),
    [anon_sym_checked] = ACTIONS(2506),
    [anon_sym_unchecked] = ACTIONS(2506),
    [anon_sym_continue] = ACTIONS(2506),
    [anon_sym_do] = ACTIONS(2506),
    [anon_sym_while] = ACTIONS(2506),
    [anon_sym_for] = ACTIONS(2506),
    [anon_sym_await] = ACTIONS(2506),
    [anon_sym_foreach] = ACTIONS(2506),
    [anon_sym_goto] = ACTIONS(2506),
    [anon_sym_case] = ACTIONS(2506),
    [anon_sym_default] = ACTIONS(2506),
    [anon_sym_if] = ACTIONS(2506),
    [anon_sym_else] = ACTIONS(2506),
    [anon_sym_lock] = ACTIONS(2506),
    [anon_sym_switch] = ACTIONS(2506),
    [anon_sym_when] = ACTIONS(2506),
    [anon_sym_throw] = ACTIONS(2506),
    [anon_sym_try] = ACTIONS(2506),
    [anon_sym_yield] = ACTIONS(2506),
    [anon_sym_stackalloc] = ACTIONS(2506),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2504),
    [anon_sym_DQUOTE] = ACTIONS(2504),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2504),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2504),
    [anon_sym___makeref] = ACTIONS(2506),
    [anon_sym_from] = ACTIONS(2506),
    [anon_sym_join] = ACTIONS(2506),
    [anon_sym_on] = ACTIONS(2506),
    [anon_sym_equals] = ACTIONS(2506),
    [anon_sym_into] = ACTIONS(2506),
    [anon_sym_let] = ACTIONS(2506),
    [anon_sym_orderby] = ACTIONS(2506),
    [anon_sym_ascending] = ACTIONS(2506),
    [anon_sym_descending] = ACTIONS(2506),
    [anon_sym_group] = ACTIONS(2506),
    [anon_sym_by] = ACTIONS(2506),
    [anon_sym_select] = ACTIONS(2506),
    [anon_sym_DOT_DOT] = ACTIONS(2504),
    [anon_sym___reftype] = ACTIONS(2506),
    [anon_sym___refvalue] = ACTIONS(2506),
    [anon_sym_sizeof] = ACTIONS(2506),
    [anon_sym_typeof] = ACTIONS(2506),
    [anon_sym_SQUOTE] = ACTIONS(2504),
    [sym_integer_literal] = ACTIONS(2506),
    [sym_null_literal] = ACTIONS(2506),
    [sym_real_literal] = ACTIONS(2504),
    [sym_verbatim_string_literal] = ACTIONS(2504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2506),
    [anon_sym_nameof] = ACTIONS(2506),
    [sym_void_keyword] = ACTIONS(2506),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1726] = {
    [sym__preprocessor_call] = STATE(1726),
    [sym__identifier_token] = ACTIONS(2410),
    [anon_sym_extern] = ACTIONS(2410),
    [anon_sym_alias] = ACTIONS(2410),
    [anon_sym_SEMI] = ACTIONS(2408),
    [anon_sym_global] = ACTIONS(2410),
    [anon_sym_using] = ACTIONS(2410),
    [anon_sym_static] = ACTIONS(2410),
    [anon_sym_LBRACK] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2410),
    [anon_sym_LPAREN] = ACTIONS(2408),
    [anon_sym_abstract] = ACTIONS(2410),
    [anon_sym_async] = ACTIONS(2410),
    [anon_sym_const] = ACTIONS(2410),
    [anon_sym_fixed] = ACTIONS(2410),
    [anon_sym_internal] = ACTIONS(2410),
    [anon_sym_new] = ACTIONS(2410),
    [anon_sym_override] = ACTIONS(2410),
    [anon_sym_partial] = ACTIONS(2410),
    [anon_sym_private] = ACTIONS(2410),
    [anon_sym_protected] = ACTIONS(2410),
    [anon_sym_public] = ACTIONS(2410),
    [anon_sym_readonly] = ACTIONS(2410),
    [anon_sym_ref] = ACTIONS(2410),
    [anon_sym_sealed] = ACTIONS(2410),
    [anon_sym_unsafe] = ACTIONS(2410),
    [anon_sym_virtual] = ACTIONS(2410),
    [anon_sym_volatile] = ACTIONS(2410),
    [anon_sym_this] = ACTIONS(2410),
    [anon_sym_base] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2408),
    [anon_sym_RBRACE] = ACTIONS(2408),
    [anon_sym_TILDE] = ACTIONS(2408),
    [anon_sym_where] = ACTIONS(2410),
    [anon_sym_notnull] = ACTIONS(2410),
    [anon_sym_unmanaged] = ACTIONS(2410),
    [anon_sym_BANG] = ACTIONS(2408),
    [anon_sym_PLUS_PLUS] = ACTIONS(2408),
    [anon_sym_DASH_DASH] = ACTIONS(2408),
    [anon_sym_true] = ACTIONS(2410),
    [anon_sym_false] = ACTIONS(2410),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_STAR] = ACTIONS(2408),
    [anon_sym_CARET] = ACTIONS(2408),
    [anon_sym_AMP] = ACTIONS(2408),
    [anon_sym_get] = ACTIONS(2410),
    [anon_sym_set] = ACTIONS(2410),
    [anon_sym_add] = ACTIONS(2410),
    [anon_sym_remove] = ACTIONS(2410),
    [anon_sym_delegate] = ACTIONS(2410),
    [anon_sym_var] = ACTIONS(2410),
    [sym_predefined_type] = ACTIONS(2410),
    [anon_sym_break] = ACTIONS(2410),
    [anon_sym_checked] = ACTIONS(2410),
    [anon_sym_unchecked] = ACTIONS(2410),
    [anon_sym_continue] = ACTIONS(2410),
    [anon_sym_do] = ACTIONS(2410),
    [anon_sym_while] = ACTIONS(2410),
    [anon_sym_for] = ACTIONS(2410),
    [anon_sym_await] = ACTIONS(2410),
    [anon_sym_foreach] = ACTIONS(2410),
    [anon_sym_goto] = ACTIONS(2410),
    [anon_sym_case] = ACTIONS(2410),
    [anon_sym_default] = ACTIONS(2410),
    [anon_sym_if] = ACTIONS(2410),
    [anon_sym_else] = ACTIONS(2410),
    [anon_sym_lock] = ACTIONS(2410),
    [anon_sym_switch] = ACTIONS(2410),
    [anon_sym_when] = ACTIONS(2410),
    [anon_sym_throw] = ACTIONS(2410),
    [anon_sym_try] = ACTIONS(2410),
    [anon_sym_yield] = ACTIONS(2410),
    [anon_sym_stackalloc] = ACTIONS(2410),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2408),
    [anon_sym_DQUOTE] = ACTIONS(2408),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2408),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2408),
    [anon_sym___makeref] = ACTIONS(2410),
    [anon_sym_from] = ACTIONS(2410),
    [anon_sym_join] = ACTIONS(2410),
    [anon_sym_on] = ACTIONS(2410),
    [anon_sym_equals] = ACTIONS(2410),
    [anon_sym_into] = ACTIONS(2410),
    [anon_sym_let] = ACTIONS(2410),
    [anon_sym_orderby] = ACTIONS(2410),
    [anon_sym_ascending] = ACTIONS(2410),
    [anon_sym_descending] = ACTIONS(2410),
    [anon_sym_group] = ACTIONS(2410),
    [anon_sym_by] = ACTIONS(2410),
    [anon_sym_select] = ACTIONS(2410),
    [anon_sym_DOT_DOT] = ACTIONS(2408),
    [anon_sym___reftype] = ACTIONS(2410),
    [anon_sym___refvalue] = ACTIONS(2410),
    [anon_sym_sizeof] = ACTIONS(2410),
    [anon_sym_typeof] = ACTIONS(2410),
    [anon_sym_SQUOTE] = ACTIONS(2408),
    [sym_integer_literal] = ACTIONS(2410),
    [sym_null_literal] = ACTIONS(2410),
    [sym_real_literal] = ACTIONS(2408),
    [sym_verbatim_string_literal] = ACTIONS(2408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2410),
    [anon_sym_nameof] = ACTIONS(2410),
    [sym_void_keyword] = ACTIONS(2410),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1727] = {
    [sym__preprocessor_call] = STATE(1727),
    [sym__identifier_token] = ACTIONS(2414),
    [anon_sym_extern] = ACTIONS(2414),
    [anon_sym_alias] = ACTIONS(2414),
    [anon_sym_SEMI] = ACTIONS(2412),
    [anon_sym_global] = ACTIONS(2414),
    [anon_sym_using] = ACTIONS(2414),
    [anon_sym_static] = ACTIONS(2414),
    [anon_sym_LBRACK] = ACTIONS(2412),
    [anon_sym_return] = ACTIONS(2414),
    [anon_sym_LPAREN] = ACTIONS(2412),
    [anon_sym_abstract] = ACTIONS(2414),
    [anon_sym_async] = ACTIONS(2414),
    [anon_sym_const] = ACTIONS(2414),
    [anon_sym_fixed] = ACTIONS(2414),
    [anon_sym_internal] = ACTIONS(2414),
    [anon_sym_new] = ACTIONS(2414),
    [anon_sym_override] = ACTIONS(2414),
    [anon_sym_partial] = ACTIONS(2414),
    [anon_sym_private] = ACTIONS(2414),
    [anon_sym_protected] = ACTIONS(2414),
    [anon_sym_public] = ACTIONS(2414),
    [anon_sym_readonly] = ACTIONS(2414),
    [anon_sym_ref] = ACTIONS(2414),
    [anon_sym_sealed] = ACTIONS(2414),
    [anon_sym_unsafe] = ACTIONS(2414),
    [anon_sym_virtual] = ACTIONS(2414),
    [anon_sym_volatile] = ACTIONS(2414),
    [anon_sym_this] = ACTIONS(2414),
    [anon_sym_base] = ACTIONS(2414),
    [anon_sym_LBRACE] = ACTIONS(2412),
    [anon_sym_RBRACE] = ACTIONS(2412),
    [anon_sym_TILDE] = ACTIONS(2412),
    [anon_sym_where] = ACTIONS(2414),
    [anon_sym_notnull] = ACTIONS(2414),
    [anon_sym_unmanaged] = ACTIONS(2414),
    [anon_sym_BANG] = ACTIONS(2412),
    [anon_sym_PLUS_PLUS] = ACTIONS(2412),
    [anon_sym_DASH_DASH] = ACTIONS(2412),
    [anon_sym_true] = ACTIONS(2414),
    [anon_sym_false] = ACTIONS(2414),
    [anon_sym_PLUS] = ACTIONS(2414),
    [anon_sym_DASH] = ACTIONS(2414),
    [anon_sym_STAR] = ACTIONS(2412),
    [anon_sym_CARET] = ACTIONS(2412),
    [anon_sym_AMP] = ACTIONS(2412),
    [anon_sym_get] = ACTIONS(2414),
    [anon_sym_set] = ACTIONS(2414),
    [anon_sym_add] = ACTIONS(2414),
    [anon_sym_remove] = ACTIONS(2414),
    [anon_sym_delegate] = ACTIONS(2414),
    [anon_sym_var] = ACTIONS(2414),
    [sym_predefined_type] = ACTIONS(2414),
    [anon_sym_break] = ACTIONS(2414),
    [anon_sym_checked] = ACTIONS(2414),
    [anon_sym_unchecked] = ACTIONS(2414),
    [anon_sym_continue] = ACTIONS(2414),
    [anon_sym_do] = ACTIONS(2414),
    [anon_sym_while] = ACTIONS(2414),
    [anon_sym_for] = ACTIONS(2414),
    [anon_sym_await] = ACTIONS(2414),
    [anon_sym_foreach] = ACTIONS(2414),
    [anon_sym_goto] = ACTIONS(2414),
    [anon_sym_case] = ACTIONS(2414),
    [anon_sym_default] = ACTIONS(2414),
    [anon_sym_if] = ACTIONS(2414),
    [anon_sym_else] = ACTIONS(2414),
    [anon_sym_lock] = ACTIONS(2414),
    [anon_sym_switch] = ACTIONS(2414),
    [anon_sym_when] = ACTIONS(2414),
    [anon_sym_throw] = ACTIONS(2414),
    [anon_sym_try] = ACTIONS(2414),
    [anon_sym_yield] = ACTIONS(2414),
    [anon_sym_stackalloc] = ACTIONS(2414),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2412),
    [anon_sym_DQUOTE] = ACTIONS(2412),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2412),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2412),
    [anon_sym___makeref] = ACTIONS(2414),
    [anon_sym_from] = ACTIONS(2414),
    [anon_sym_join] = ACTIONS(2414),
    [anon_sym_on] = ACTIONS(2414),
    [anon_sym_equals] = ACTIONS(2414),
    [anon_sym_into] = ACTIONS(2414),
    [anon_sym_let] = ACTIONS(2414),
    [anon_sym_orderby] = ACTIONS(2414),
    [anon_sym_ascending] = ACTIONS(2414),
    [anon_sym_descending] = ACTIONS(2414),
    [anon_sym_group] = ACTIONS(2414),
    [anon_sym_by] = ACTIONS(2414),
    [anon_sym_select] = ACTIONS(2414),
    [anon_sym_DOT_DOT] = ACTIONS(2412),
    [anon_sym___reftype] = ACTIONS(2414),
    [anon_sym___refvalue] = ACTIONS(2414),
    [anon_sym_sizeof] = ACTIONS(2414),
    [anon_sym_typeof] = ACTIONS(2414),
    [anon_sym_SQUOTE] = ACTIONS(2412),
    [sym_integer_literal] = ACTIONS(2414),
    [sym_null_literal] = ACTIONS(2414),
    [sym_real_literal] = ACTIONS(2412),
    [sym_verbatim_string_literal] = ACTIONS(2412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2414),
    [anon_sym_nameof] = ACTIONS(2414),
    [sym_void_keyword] = ACTIONS(2414),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1728] = {
    [sym__preprocessor_call] = STATE(1728),
    [sym__identifier_token] = ACTIONS(2466),
    [anon_sym_extern] = ACTIONS(2466),
    [anon_sym_alias] = ACTIONS(2466),
    [anon_sym_SEMI] = ACTIONS(2464),
    [anon_sym_global] = ACTIONS(2466),
    [anon_sym_using] = ACTIONS(2466),
    [anon_sym_static] = ACTIONS(2466),
    [anon_sym_LBRACK] = ACTIONS(2464),
    [anon_sym_return] = ACTIONS(2466),
    [anon_sym_LPAREN] = ACTIONS(2464),
    [anon_sym_abstract] = ACTIONS(2466),
    [anon_sym_async] = ACTIONS(2466),
    [anon_sym_const] = ACTIONS(2466),
    [anon_sym_fixed] = ACTIONS(2466),
    [anon_sym_internal] = ACTIONS(2466),
    [anon_sym_new] = ACTIONS(2466),
    [anon_sym_override] = ACTIONS(2466),
    [anon_sym_partial] = ACTIONS(2466),
    [anon_sym_private] = ACTIONS(2466),
    [anon_sym_protected] = ACTIONS(2466),
    [anon_sym_public] = ACTIONS(2466),
    [anon_sym_readonly] = ACTIONS(2466),
    [anon_sym_ref] = ACTIONS(2466),
    [anon_sym_sealed] = ACTIONS(2466),
    [anon_sym_unsafe] = ACTIONS(2466),
    [anon_sym_virtual] = ACTIONS(2466),
    [anon_sym_volatile] = ACTIONS(2466),
    [anon_sym_this] = ACTIONS(2466),
    [anon_sym_base] = ACTIONS(2466),
    [anon_sym_LBRACE] = ACTIONS(2464),
    [anon_sym_RBRACE] = ACTIONS(2464),
    [anon_sym_TILDE] = ACTIONS(2464),
    [anon_sym_where] = ACTIONS(2466),
    [anon_sym_notnull] = ACTIONS(2466),
    [anon_sym_unmanaged] = ACTIONS(2466),
    [anon_sym_BANG] = ACTIONS(2464),
    [anon_sym_PLUS_PLUS] = ACTIONS(2464),
    [anon_sym_DASH_DASH] = ACTIONS(2464),
    [anon_sym_true] = ACTIONS(2466),
    [anon_sym_false] = ACTIONS(2466),
    [anon_sym_PLUS] = ACTIONS(2466),
    [anon_sym_DASH] = ACTIONS(2466),
    [anon_sym_STAR] = ACTIONS(2464),
    [anon_sym_CARET] = ACTIONS(2464),
    [anon_sym_AMP] = ACTIONS(2464),
    [anon_sym_get] = ACTIONS(2466),
    [anon_sym_set] = ACTIONS(2466),
    [anon_sym_add] = ACTIONS(2466),
    [anon_sym_remove] = ACTIONS(2466),
    [anon_sym_delegate] = ACTIONS(2466),
    [anon_sym_var] = ACTIONS(2466),
    [sym_predefined_type] = ACTIONS(2466),
    [anon_sym_break] = ACTIONS(2466),
    [anon_sym_checked] = ACTIONS(2466),
    [anon_sym_unchecked] = ACTIONS(2466),
    [anon_sym_continue] = ACTIONS(2466),
    [anon_sym_do] = ACTIONS(2466),
    [anon_sym_while] = ACTIONS(2466),
    [anon_sym_for] = ACTIONS(2466),
    [anon_sym_await] = ACTIONS(2466),
    [anon_sym_foreach] = ACTIONS(2466),
    [anon_sym_goto] = ACTIONS(2466),
    [anon_sym_case] = ACTIONS(2466),
    [anon_sym_default] = ACTIONS(2466),
    [anon_sym_if] = ACTIONS(2466),
    [anon_sym_else] = ACTIONS(2466),
    [anon_sym_lock] = ACTIONS(2466),
    [anon_sym_switch] = ACTIONS(2466),
    [anon_sym_when] = ACTIONS(2466),
    [anon_sym_throw] = ACTIONS(2466),
    [anon_sym_try] = ACTIONS(2466),
    [anon_sym_yield] = ACTIONS(2466),
    [anon_sym_stackalloc] = ACTIONS(2466),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2464),
    [anon_sym_DQUOTE] = ACTIONS(2464),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2464),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2464),
    [anon_sym___makeref] = ACTIONS(2466),
    [anon_sym_from] = ACTIONS(2466),
    [anon_sym_join] = ACTIONS(2466),
    [anon_sym_on] = ACTIONS(2466),
    [anon_sym_equals] = ACTIONS(2466),
    [anon_sym_into] = ACTIONS(2466),
    [anon_sym_let] = ACTIONS(2466),
    [anon_sym_orderby] = ACTIONS(2466),
    [anon_sym_ascending] = ACTIONS(2466),
    [anon_sym_descending] = ACTIONS(2466),
    [anon_sym_group] = ACTIONS(2466),
    [anon_sym_by] = ACTIONS(2466),
    [anon_sym_select] = ACTIONS(2466),
    [anon_sym_DOT_DOT] = ACTIONS(2464),
    [anon_sym___reftype] = ACTIONS(2466),
    [anon_sym___refvalue] = ACTIONS(2466),
    [anon_sym_sizeof] = ACTIONS(2466),
    [anon_sym_typeof] = ACTIONS(2466),
    [anon_sym_SQUOTE] = ACTIONS(2464),
    [sym_integer_literal] = ACTIONS(2466),
    [sym_null_literal] = ACTIONS(2466),
    [sym_real_literal] = ACTIONS(2464),
    [sym_verbatim_string_literal] = ACTIONS(2464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2466),
    [anon_sym_nameof] = ACTIONS(2466),
    [sym_void_keyword] = ACTIONS(2466),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1729] = {
    [sym__preprocessor_call] = STATE(1729),
    [sym__identifier_token] = ACTIONS(2510),
    [anon_sym_extern] = ACTIONS(2510),
    [anon_sym_alias] = ACTIONS(2510),
    [anon_sym_SEMI] = ACTIONS(2508),
    [anon_sym_global] = ACTIONS(2510),
    [anon_sym_using] = ACTIONS(2510),
    [anon_sym_static] = ACTIONS(2510),
    [anon_sym_LBRACK] = ACTIONS(2508),
    [anon_sym_return] = ACTIONS(2510),
    [anon_sym_LPAREN] = ACTIONS(2508),
    [anon_sym_abstract] = ACTIONS(2510),
    [anon_sym_async] = ACTIONS(2510),
    [anon_sym_const] = ACTIONS(2510),
    [anon_sym_fixed] = ACTIONS(2510),
    [anon_sym_internal] = ACTIONS(2510),
    [anon_sym_new] = ACTIONS(2510),
    [anon_sym_override] = ACTIONS(2510),
    [anon_sym_partial] = ACTIONS(2510),
    [anon_sym_private] = ACTIONS(2510),
    [anon_sym_protected] = ACTIONS(2510),
    [anon_sym_public] = ACTIONS(2510),
    [anon_sym_readonly] = ACTIONS(2510),
    [anon_sym_ref] = ACTIONS(2510),
    [anon_sym_sealed] = ACTIONS(2510),
    [anon_sym_unsafe] = ACTIONS(2510),
    [anon_sym_virtual] = ACTIONS(2510),
    [anon_sym_volatile] = ACTIONS(2510),
    [anon_sym_this] = ACTIONS(2510),
    [anon_sym_base] = ACTIONS(2510),
    [anon_sym_LBRACE] = ACTIONS(2508),
    [anon_sym_RBRACE] = ACTIONS(2508),
    [anon_sym_TILDE] = ACTIONS(2508),
    [anon_sym_where] = ACTIONS(2510),
    [anon_sym_notnull] = ACTIONS(2510),
    [anon_sym_unmanaged] = ACTIONS(2510),
    [anon_sym_BANG] = ACTIONS(2508),
    [anon_sym_PLUS_PLUS] = ACTIONS(2508),
    [anon_sym_DASH_DASH] = ACTIONS(2508),
    [anon_sym_true] = ACTIONS(2510),
    [anon_sym_false] = ACTIONS(2510),
    [anon_sym_PLUS] = ACTIONS(2510),
    [anon_sym_DASH] = ACTIONS(2510),
    [anon_sym_STAR] = ACTIONS(2508),
    [anon_sym_CARET] = ACTIONS(2508),
    [anon_sym_AMP] = ACTIONS(2508),
    [anon_sym_get] = ACTIONS(2510),
    [anon_sym_set] = ACTIONS(2510),
    [anon_sym_add] = ACTIONS(2510),
    [anon_sym_remove] = ACTIONS(2510),
    [anon_sym_delegate] = ACTIONS(2510),
    [anon_sym_var] = ACTIONS(2510),
    [sym_predefined_type] = ACTIONS(2510),
    [anon_sym_break] = ACTIONS(2510),
    [anon_sym_checked] = ACTIONS(2510),
    [anon_sym_unchecked] = ACTIONS(2510),
    [anon_sym_continue] = ACTIONS(2510),
    [anon_sym_do] = ACTIONS(2510),
    [anon_sym_while] = ACTIONS(2510),
    [anon_sym_for] = ACTIONS(2510),
    [anon_sym_await] = ACTIONS(2510),
    [anon_sym_foreach] = ACTIONS(2510),
    [anon_sym_goto] = ACTIONS(2510),
    [anon_sym_case] = ACTIONS(2510),
    [anon_sym_default] = ACTIONS(2510),
    [anon_sym_if] = ACTIONS(2510),
    [anon_sym_else] = ACTIONS(2510),
    [anon_sym_lock] = ACTIONS(2510),
    [anon_sym_switch] = ACTIONS(2510),
    [anon_sym_when] = ACTIONS(2510),
    [anon_sym_throw] = ACTIONS(2510),
    [anon_sym_try] = ACTIONS(2510),
    [anon_sym_yield] = ACTIONS(2510),
    [anon_sym_stackalloc] = ACTIONS(2510),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2508),
    [anon_sym_DQUOTE] = ACTIONS(2508),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2508),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2508),
    [anon_sym___makeref] = ACTIONS(2510),
    [anon_sym_from] = ACTIONS(2510),
    [anon_sym_join] = ACTIONS(2510),
    [anon_sym_on] = ACTIONS(2510),
    [anon_sym_equals] = ACTIONS(2510),
    [anon_sym_into] = ACTIONS(2510),
    [anon_sym_let] = ACTIONS(2510),
    [anon_sym_orderby] = ACTIONS(2510),
    [anon_sym_ascending] = ACTIONS(2510),
    [anon_sym_descending] = ACTIONS(2510),
    [anon_sym_group] = ACTIONS(2510),
    [anon_sym_by] = ACTIONS(2510),
    [anon_sym_select] = ACTIONS(2510),
    [anon_sym_DOT_DOT] = ACTIONS(2508),
    [anon_sym___reftype] = ACTIONS(2510),
    [anon_sym___refvalue] = ACTIONS(2510),
    [anon_sym_sizeof] = ACTIONS(2510),
    [anon_sym_typeof] = ACTIONS(2510),
    [anon_sym_SQUOTE] = ACTIONS(2508),
    [sym_integer_literal] = ACTIONS(2510),
    [sym_null_literal] = ACTIONS(2510),
    [sym_real_literal] = ACTIONS(2508),
    [sym_verbatim_string_literal] = ACTIONS(2508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2510),
    [anon_sym_nameof] = ACTIONS(2510),
    [sym_void_keyword] = ACTIONS(2510),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1730] = {
    [sym__preprocessor_call] = STATE(1730),
    [sym__identifier_token] = ACTIONS(2434),
    [anon_sym_extern] = ACTIONS(2434),
    [anon_sym_alias] = ACTIONS(2434),
    [anon_sym_SEMI] = ACTIONS(2432),
    [anon_sym_global] = ACTIONS(2434),
    [anon_sym_using] = ACTIONS(2434),
    [anon_sym_static] = ACTIONS(2434),
    [anon_sym_LBRACK] = ACTIONS(2432),
    [anon_sym_return] = ACTIONS(2434),
    [anon_sym_LPAREN] = ACTIONS(2432),
    [anon_sym_abstract] = ACTIONS(2434),
    [anon_sym_async] = ACTIONS(2434),
    [anon_sym_const] = ACTIONS(2434),
    [anon_sym_fixed] = ACTIONS(2434),
    [anon_sym_internal] = ACTIONS(2434),
    [anon_sym_new] = ACTIONS(2434),
    [anon_sym_override] = ACTIONS(2434),
    [anon_sym_partial] = ACTIONS(2434),
    [anon_sym_private] = ACTIONS(2434),
    [anon_sym_protected] = ACTIONS(2434),
    [anon_sym_public] = ACTIONS(2434),
    [anon_sym_readonly] = ACTIONS(2434),
    [anon_sym_ref] = ACTIONS(2434),
    [anon_sym_sealed] = ACTIONS(2434),
    [anon_sym_unsafe] = ACTIONS(2434),
    [anon_sym_virtual] = ACTIONS(2434),
    [anon_sym_volatile] = ACTIONS(2434),
    [anon_sym_this] = ACTIONS(2434),
    [anon_sym_base] = ACTIONS(2434),
    [anon_sym_LBRACE] = ACTIONS(2432),
    [anon_sym_RBRACE] = ACTIONS(2432),
    [anon_sym_TILDE] = ACTIONS(2432),
    [anon_sym_where] = ACTIONS(2434),
    [anon_sym_notnull] = ACTIONS(2434),
    [anon_sym_unmanaged] = ACTIONS(2434),
    [anon_sym_BANG] = ACTIONS(2432),
    [anon_sym_PLUS_PLUS] = ACTIONS(2432),
    [anon_sym_DASH_DASH] = ACTIONS(2432),
    [anon_sym_true] = ACTIONS(2434),
    [anon_sym_false] = ACTIONS(2434),
    [anon_sym_PLUS] = ACTIONS(2434),
    [anon_sym_DASH] = ACTIONS(2434),
    [anon_sym_STAR] = ACTIONS(2432),
    [anon_sym_CARET] = ACTIONS(2432),
    [anon_sym_AMP] = ACTIONS(2432),
    [anon_sym_get] = ACTIONS(2434),
    [anon_sym_set] = ACTIONS(2434),
    [anon_sym_add] = ACTIONS(2434),
    [anon_sym_remove] = ACTIONS(2434),
    [anon_sym_delegate] = ACTIONS(2434),
    [anon_sym_var] = ACTIONS(2434),
    [sym_predefined_type] = ACTIONS(2434),
    [anon_sym_break] = ACTIONS(2434),
    [anon_sym_checked] = ACTIONS(2434),
    [anon_sym_unchecked] = ACTIONS(2434),
    [anon_sym_continue] = ACTIONS(2434),
    [anon_sym_do] = ACTIONS(2434),
    [anon_sym_while] = ACTIONS(2434),
    [anon_sym_for] = ACTIONS(2434),
    [anon_sym_await] = ACTIONS(2434),
    [anon_sym_foreach] = ACTIONS(2434),
    [anon_sym_goto] = ACTIONS(2434),
    [anon_sym_case] = ACTIONS(2434),
    [anon_sym_default] = ACTIONS(2434),
    [anon_sym_if] = ACTIONS(2434),
    [anon_sym_else] = ACTIONS(2434),
    [anon_sym_lock] = ACTIONS(2434),
    [anon_sym_switch] = ACTIONS(2434),
    [anon_sym_when] = ACTIONS(2434),
    [anon_sym_throw] = ACTIONS(2434),
    [anon_sym_try] = ACTIONS(2434),
    [anon_sym_yield] = ACTIONS(2434),
    [anon_sym_stackalloc] = ACTIONS(2434),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2432),
    [anon_sym_DQUOTE] = ACTIONS(2432),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2432),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2432),
    [anon_sym___makeref] = ACTIONS(2434),
    [anon_sym_from] = ACTIONS(2434),
    [anon_sym_join] = ACTIONS(2434),
    [anon_sym_on] = ACTIONS(2434),
    [anon_sym_equals] = ACTIONS(2434),
    [anon_sym_into] = ACTIONS(2434),
    [anon_sym_let] = ACTIONS(2434),
    [anon_sym_orderby] = ACTIONS(2434),
    [anon_sym_ascending] = ACTIONS(2434),
    [anon_sym_descending] = ACTIONS(2434),
    [anon_sym_group] = ACTIONS(2434),
    [anon_sym_by] = ACTIONS(2434),
    [anon_sym_select] = ACTIONS(2434),
    [anon_sym_DOT_DOT] = ACTIONS(2432),
    [anon_sym___reftype] = ACTIONS(2434),
    [anon_sym___refvalue] = ACTIONS(2434),
    [anon_sym_sizeof] = ACTIONS(2434),
    [anon_sym_typeof] = ACTIONS(2434),
    [anon_sym_SQUOTE] = ACTIONS(2432),
    [sym_integer_literal] = ACTIONS(2434),
    [sym_null_literal] = ACTIONS(2434),
    [sym_real_literal] = ACTIONS(2432),
    [sym_verbatim_string_literal] = ACTIONS(2432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2434),
    [anon_sym_nameof] = ACTIONS(2434),
    [sym_void_keyword] = ACTIONS(2434),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1731] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1731),
    [sym__identifier_token] = ACTIONS(2723),
    [anon_sym_alias] = ACTIONS(2726),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_global] = ACTIONS(2731),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_RBRACK] = ACTIONS(2729),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_in] = ACTIONS(2734),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2726),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2726),
    [anon_sym_unmanaged] = ACTIONS(2726),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2726),
    [anon_sym_set] = ACTIONS(2726),
    [anon_sym_add] = ACTIONS(2726),
    [anon_sym_remove] = ACTIONS(2726),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [sym_discard] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2726),
    [anon_sym_yield] = ACTIONS(2726),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2726),
    [anon_sym_join] = ACTIONS(2726),
    [anon_sym_on] = ACTIONS(2726),
    [anon_sym_equals] = ACTIONS(2726),
    [anon_sym_into] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_orderby] = ACTIONS(2726),
    [anon_sym_ascending] = ACTIONS(2726),
    [anon_sym_descending] = ACTIONS(2726),
    [anon_sym_group] = ACTIONS(2726),
    [anon_sym_by] = ACTIONS(2726),
    [anon_sym_select] = ACTIONS(2726),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2726),
    [anon_sym_nameof] = ACTIONS(2726),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1732] = {
    [sym__preprocessor_call] = STATE(1732),
    [sym__identifier_token] = ACTIONS(2741),
    [anon_sym_extern] = ACTIONS(2741),
    [anon_sym_alias] = ACTIONS(2741),
    [anon_sym_SEMI] = ACTIONS(2743),
    [anon_sym_global] = ACTIONS(2741),
    [anon_sym_using] = ACTIONS(2741),
    [anon_sym_static] = ACTIONS(2741),
    [anon_sym_LBRACK] = ACTIONS(2743),
    [anon_sym_return] = ACTIONS(2741),
    [anon_sym_LPAREN] = ACTIONS(2743),
    [anon_sym_abstract] = ACTIONS(2741),
    [anon_sym_async] = ACTIONS(2741),
    [anon_sym_const] = ACTIONS(2741),
    [anon_sym_fixed] = ACTIONS(2741),
    [anon_sym_internal] = ACTIONS(2741),
    [anon_sym_new] = ACTIONS(2741),
    [anon_sym_override] = ACTIONS(2741),
    [anon_sym_partial] = ACTIONS(2741),
    [anon_sym_private] = ACTIONS(2741),
    [anon_sym_protected] = ACTIONS(2741),
    [anon_sym_public] = ACTIONS(2741),
    [anon_sym_readonly] = ACTIONS(2741),
    [anon_sym_ref] = ACTIONS(2741),
    [anon_sym_sealed] = ACTIONS(2741),
    [anon_sym_unsafe] = ACTIONS(2741),
    [anon_sym_virtual] = ACTIONS(2741),
    [anon_sym_volatile] = ACTIONS(2741),
    [anon_sym_this] = ACTIONS(2741),
    [anon_sym_base] = ACTIONS(2741),
    [anon_sym_LBRACE] = ACTIONS(2743),
    [anon_sym_RBRACE] = ACTIONS(2743),
    [anon_sym_TILDE] = ACTIONS(2743),
    [anon_sym_where] = ACTIONS(2741),
    [anon_sym_notnull] = ACTIONS(2741),
    [anon_sym_unmanaged] = ACTIONS(2741),
    [anon_sym_BANG] = ACTIONS(2743),
    [anon_sym_PLUS_PLUS] = ACTIONS(2743),
    [anon_sym_DASH_DASH] = ACTIONS(2743),
    [anon_sym_true] = ACTIONS(2741),
    [anon_sym_false] = ACTIONS(2741),
    [anon_sym_PLUS] = ACTIONS(2741),
    [anon_sym_DASH] = ACTIONS(2741),
    [anon_sym_STAR] = ACTIONS(2743),
    [anon_sym_CARET] = ACTIONS(2743),
    [anon_sym_AMP] = ACTIONS(2743),
    [anon_sym_get] = ACTIONS(2741),
    [anon_sym_set] = ACTIONS(2741),
    [anon_sym_add] = ACTIONS(2741),
    [anon_sym_remove] = ACTIONS(2741),
    [anon_sym_delegate] = ACTIONS(2741),
    [anon_sym_var] = ACTIONS(2741),
    [sym_predefined_type] = ACTIONS(2741),
    [anon_sym_break] = ACTIONS(2741),
    [anon_sym_checked] = ACTIONS(2741),
    [anon_sym_unchecked] = ACTIONS(2741),
    [anon_sym_continue] = ACTIONS(2741),
    [anon_sym_do] = ACTIONS(2741),
    [anon_sym_while] = ACTIONS(2741),
    [anon_sym_for] = ACTIONS(2741),
    [anon_sym_await] = ACTIONS(2741),
    [anon_sym_foreach] = ACTIONS(2741),
    [anon_sym_goto] = ACTIONS(2741),
    [anon_sym_case] = ACTIONS(2741),
    [anon_sym_default] = ACTIONS(2741),
    [anon_sym_if] = ACTIONS(2741),
    [anon_sym_lock] = ACTIONS(2741),
    [anon_sym_switch] = ACTIONS(2741),
    [anon_sym_when] = ACTIONS(2741),
    [anon_sym_throw] = ACTIONS(2741),
    [anon_sym_try] = ACTIONS(2741),
    [anon_sym_yield] = ACTIONS(2741),
    [anon_sym_stackalloc] = ACTIONS(2741),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2743),
    [anon_sym_DQUOTE] = ACTIONS(2743),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2743),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2743),
    [anon_sym___makeref] = ACTIONS(2741),
    [anon_sym_from] = ACTIONS(2741),
    [anon_sym_join] = ACTIONS(2741),
    [anon_sym_on] = ACTIONS(2741),
    [anon_sym_equals] = ACTIONS(2741),
    [anon_sym_into] = ACTIONS(2741),
    [anon_sym_let] = ACTIONS(2741),
    [anon_sym_orderby] = ACTIONS(2741),
    [anon_sym_ascending] = ACTIONS(2741),
    [anon_sym_descending] = ACTIONS(2741),
    [anon_sym_group] = ACTIONS(2741),
    [anon_sym_by] = ACTIONS(2741),
    [anon_sym_select] = ACTIONS(2741),
    [anon_sym_DOT_DOT] = ACTIONS(2743),
    [anon_sym___reftype] = ACTIONS(2741),
    [anon_sym___refvalue] = ACTIONS(2741),
    [anon_sym_sizeof] = ACTIONS(2741),
    [anon_sym_typeof] = ACTIONS(2741),
    [anon_sym_SQUOTE] = ACTIONS(2743),
    [sym_integer_literal] = ACTIONS(2741),
    [sym_null_literal] = ACTIONS(2741),
    [sym_real_literal] = ACTIONS(2743),
    [sym_verbatim_string_literal] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2741),
    [anon_sym_nameof] = ACTIONS(2741),
    [sym_void_keyword] = ACTIONS(2741),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1733] = {
    [sym__preprocessor_call] = STATE(1733),
    [sym__identifier_token] = ACTIONS(2745),
    [anon_sym_extern] = ACTIONS(2745),
    [anon_sym_alias] = ACTIONS(2745),
    [anon_sym_SEMI] = ACTIONS(2747),
    [anon_sym_global] = ACTIONS(2745),
    [anon_sym_using] = ACTIONS(2745),
    [anon_sym_static] = ACTIONS(2745),
    [anon_sym_LBRACK] = ACTIONS(2747),
    [anon_sym_return] = ACTIONS(2745),
    [anon_sym_LPAREN] = ACTIONS(2747),
    [anon_sym_abstract] = ACTIONS(2745),
    [anon_sym_async] = ACTIONS(2745),
    [anon_sym_const] = ACTIONS(2745),
    [anon_sym_fixed] = ACTIONS(2745),
    [anon_sym_internal] = ACTIONS(2745),
    [anon_sym_new] = ACTIONS(2745),
    [anon_sym_override] = ACTIONS(2745),
    [anon_sym_partial] = ACTIONS(2745),
    [anon_sym_private] = ACTIONS(2745),
    [anon_sym_protected] = ACTIONS(2745),
    [anon_sym_public] = ACTIONS(2745),
    [anon_sym_readonly] = ACTIONS(2745),
    [anon_sym_ref] = ACTIONS(2745),
    [anon_sym_sealed] = ACTIONS(2745),
    [anon_sym_unsafe] = ACTIONS(2745),
    [anon_sym_virtual] = ACTIONS(2745),
    [anon_sym_volatile] = ACTIONS(2745),
    [anon_sym_this] = ACTIONS(2745),
    [anon_sym_base] = ACTIONS(2745),
    [anon_sym_LBRACE] = ACTIONS(2747),
    [anon_sym_TILDE] = ACTIONS(2747),
    [anon_sym_where] = ACTIONS(2745),
    [anon_sym_notnull] = ACTIONS(2745),
    [anon_sym_unmanaged] = ACTIONS(2745),
    [anon_sym_BANG] = ACTIONS(2747),
    [anon_sym_PLUS_PLUS] = ACTIONS(2747),
    [anon_sym_DASH_DASH] = ACTIONS(2747),
    [anon_sym_true] = ACTIONS(2745),
    [anon_sym_false] = ACTIONS(2745),
    [anon_sym_PLUS] = ACTIONS(2745),
    [anon_sym_DASH] = ACTIONS(2745),
    [anon_sym_STAR] = ACTIONS(2747),
    [anon_sym_CARET] = ACTIONS(2747),
    [anon_sym_AMP] = ACTIONS(2747),
    [anon_sym_get] = ACTIONS(2745),
    [anon_sym_set] = ACTIONS(2745),
    [anon_sym_add] = ACTIONS(2745),
    [anon_sym_remove] = ACTIONS(2745),
    [anon_sym_delegate] = ACTIONS(2745),
    [anon_sym_var] = ACTIONS(2745),
    [sym_predefined_type] = ACTIONS(2745),
    [anon_sym_break] = ACTIONS(2745),
    [anon_sym_checked] = ACTIONS(2745),
    [anon_sym_unchecked] = ACTIONS(2745),
    [anon_sym_continue] = ACTIONS(2745),
    [anon_sym_do] = ACTIONS(2745),
    [anon_sym_while] = ACTIONS(2745),
    [anon_sym_for] = ACTIONS(2745),
    [anon_sym_await] = ACTIONS(2745),
    [anon_sym_foreach] = ACTIONS(2745),
    [anon_sym_goto] = ACTIONS(2745),
    [anon_sym_case] = ACTIONS(2745),
    [anon_sym_default] = ACTIONS(2745),
    [anon_sym_if] = ACTIONS(2745),
    [anon_sym_lock] = ACTIONS(2745),
    [anon_sym_switch] = ACTIONS(2745),
    [anon_sym_when] = ACTIONS(2745),
    [anon_sym_throw] = ACTIONS(2745),
    [anon_sym_try] = ACTIONS(2745),
    [anon_sym_yield] = ACTIONS(2745),
    [anon_sym_stackalloc] = ACTIONS(2745),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2747),
    [anon_sym_DQUOTE] = ACTIONS(2747),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2747),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2747),
    [anon_sym___makeref] = ACTIONS(2745),
    [anon_sym_from] = ACTIONS(2745),
    [anon_sym_join] = ACTIONS(2745),
    [anon_sym_on] = ACTIONS(2745),
    [anon_sym_equals] = ACTIONS(2745),
    [anon_sym_into] = ACTIONS(2745),
    [anon_sym_let] = ACTIONS(2745),
    [anon_sym_orderby] = ACTIONS(2745),
    [anon_sym_ascending] = ACTIONS(2745),
    [anon_sym_descending] = ACTIONS(2745),
    [anon_sym_group] = ACTIONS(2745),
    [anon_sym_by] = ACTIONS(2745),
    [anon_sym_select] = ACTIONS(2745),
    [anon_sym_DOT_DOT] = ACTIONS(2747),
    [anon_sym___reftype] = ACTIONS(2745),
    [anon_sym___refvalue] = ACTIONS(2745),
    [anon_sym_sizeof] = ACTIONS(2745),
    [anon_sym_typeof] = ACTIONS(2745),
    [anon_sym_SQUOTE] = ACTIONS(2747),
    [sym_integer_literal] = ACTIONS(2745),
    [sym_null_literal] = ACTIONS(2745),
    [sym_real_literal] = ACTIONS(2747),
    [sym_verbatim_string_literal] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2745),
    [anon_sym_nameof] = ACTIONS(2745),
    [sym_void_keyword] = ACTIONS(2745),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1734] = {
    [sym__preprocessor_call] = STATE(1734),
    [sym__identifier_token] = ACTIONS(2749),
    [anon_sym_extern] = ACTIONS(2749),
    [anon_sym_alias] = ACTIONS(2749),
    [anon_sym_SEMI] = ACTIONS(2751),
    [anon_sym_global] = ACTIONS(2749),
    [anon_sym_using] = ACTIONS(2749),
    [anon_sym_static] = ACTIONS(2749),
    [anon_sym_LBRACK] = ACTIONS(2751),
    [anon_sym_return] = ACTIONS(2749),
    [anon_sym_LPAREN] = ACTIONS(2751),
    [anon_sym_abstract] = ACTIONS(2749),
    [anon_sym_async] = ACTIONS(2749),
    [anon_sym_const] = ACTIONS(2749),
    [anon_sym_fixed] = ACTIONS(2749),
    [anon_sym_internal] = ACTIONS(2749),
    [anon_sym_new] = ACTIONS(2749),
    [anon_sym_override] = ACTIONS(2749),
    [anon_sym_partial] = ACTIONS(2749),
    [anon_sym_private] = ACTIONS(2749),
    [anon_sym_protected] = ACTIONS(2749),
    [anon_sym_public] = ACTIONS(2749),
    [anon_sym_readonly] = ACTIONS(2749),
    [anon_sym_ref] = ACTIONS(2749),
    [anon_sym_sealed] = ACTIONS(2749),
    [anon_sym_unsafe] = ACTIONS(2749),
    [anon_sym_virtual] = ACTIONS(2749),
    [anon_sym_volatile] = ACTIONS(2749),
    [anon_sym_this] = ACTIONS(2749),
    [anon_sym_base] = ACTIONS(2749),
    [anon_sym_LBRACE] = ACTIONS(2751),
    [anon_sym_TILDE] = ACTIONS(2751),
    [anon_sym_where] = ACTIONS(2749),
    [anon_sym_notnull] = ACTIONS(2749),
    [anon_sym_unmanaged] = ACTIONS(2749),
    [anon_sym_BANG] = ACTIONS(2751),
    [anon_sym_PLUS_PLUS] = ACTIONS(2751),
    [anon_sym_DASH_DASH] = ACTIONS(2751),
    [anon_sym_true] = ACTIONS(2749),
    [anon_sym_false] = ACTIONS(2749),
    [anon_sym_PLUS] = ACTIONS(2749),
    [anon_sym_DASH] = ACTIONS(2749),
    [anon_sym_STAR] = ACTIONS(2751),
    [anon_sym_CARET] = ACTIONS(2751),
    [anon_sym_AMP] = ACTIONS(2751),
    [anon_sym_get] = ACTIONS(2749),
    [anon_sym_set] = ACTIONS(2749),
    [anon_sym_add] = ACTIONS(2749),
    [anon_sym_remove] = ACTIONS(2749),
    [anon_sym_delegate] = ACTIONS(2749),
    [anon_sym_var] = ACTIONS(2749),
    [sym_predefined_type] = ACTIONS(2749),
    [anon_sym_break] = ACTIONS(2749),
    [anon_sym_checked] = ACTIONS(2749),
    [anon_sym_unchecked] = ACTIONS(2749),
    [anon_sym_continue] = ACTIONS(2749),
    [anon_sym_do] = ACTIONS(2749),
    [anon_sym_while] = ACTIONS(2749),
    [anon_sym_for] = ACTIONS(2749),
    [anon_sym_await] = ACTIONS(2749),
    [anon_sym_foreach] = ACTIONS(2749),
    [anon_sym_goto] = ACTIONS(2749),
    [anon_sym_case] = ACTIONS(2749),
    [anon_sym_default] = ACTIONS(2749),
    [anon_sym_if] = ACTIONS(2749),
    [anon_sym_lock] = ACTIONS(2749),
    [anon_sym_switch] = ACTIONS(2749),
    [anon_sym_when] = ACTIONS(2749),
    [anon_sym_throw] = ACTIONS(2749),
    [anon_sym_try] = ACTIONS(2749),
    [anon_sym_yield] = ACTIONS(2749),
    [anon_sym_stackalloc] = ACTIONS(2749),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2751),
    [anon_sym_DQUOTE] = ACTIONS(2751),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2751),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2751),
    [anon_sym___makeref] = ACTIONS(2749),
    [anon_sym_from] = ACTIONS(2749),
    [anon_sym_join] = ACTIONS(2749),
    [anon_sym_on] = ACTIONS(2749),
    [anon_sym_equals] = ACTIONS(2749),
    [anon_sym_into] = ACTIONS(2749),
    [anon_sym_let] = ACTIONS(2749),
    [anon_sym_orderby] = ACTIONS(2749),
    [anon_sym_ascending] = ACTIONS(2749),
    [anon_sym_descending] = ACTIONS(2749),
    [anon_sym_group] = ACTIONS(2749),
    [anon_sym_by] = ACTIONS(2749),
    [anon_sym_select] = ACTIONS(2749),
    [anon_sym_DOT_DOT] = ACTIONS(2751),
    [anon_sym___reftype] = ACTIONS(2749),
    [anon_sym___refvalue] = ACTIONS(2749),
    [anon_sym_sizeof] = ACTIONS(2749),
    [anon_sym_typeof] = ACTIONS(2749),
    [anon_sym_SQUOTE] = ACTIONS(2751),
    [sym_integer_literal] = ACTIONS(2749),
    [sym_null_literal] = ACTIONS(2749),
    [sym_real_literal] = ACTIONS(2751),
    [sym_verbatim_string_literal] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2749),
    [anon_sym_nameof] = ACTIONS(2749),
    [sym_void_keyword] = ACTIONS(2749),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1735] = {
    [sym__preprocessor_call] = STATE(1735),
    [sym__identifier_token] = ACTIONS(2753),
    [anon_sym_extern] = ACTIONS(2753),
    [anon_sym_alias] = ACTIONS(2753),
    [anon_sym_SEMI] = ACTIONS(2755),
    [anon_sym_global] = ACTIONS(2753),
    [anon_sym_using] = ACTIONS(2753),
    [anon_sym_static] = ACTIONS(2753),
    [anon_sym_LBRACK] = ACTIONS(2755),
    [anon_sym_return] = ACTIONS(2753),
    [anon_sym_LPAREN] = ACTIONS(2755),
    [anon_sym_abstract] = ACTIONS(2753),
    [anon_sym_async] = ACTIONS(2753),
    [anon_sym_const] = ACTIONS(2753),
    [anon_sym_fixed] = ACTIONS(2753),
    [anon_sym_internal] = ACTIONS(2753),
    [anon_sym_new] = ACTIONS(2753),
    [anon_sym_override] = ACTIONS(2753),
    [anon_sym_partial] = ACTIONS(2753),
    [anon_sym_private] = ACTIONS(2753),
    [anon_sym_protected] = ACTIONS(2753),
    [anon_sym_public] = ACTIONS(2753),
    [anon_sym_readonly] = ACTIONS(2753),
    [anon_sym_ref] = ACTIONS(2753),
    [anon_sym_sealed] = ACTIONS(2753),
    [anon_sym_unsafe] = ACTIONS(2753),
    [anon_sym_virtual] = ACTIONS(2753),
    [anon_sym_volatile] = ACTIONS(2753),
    [anon_sym_this] = ACTIONS(2753),
    [anon_sym_base] = ACTIONS(2753),
    [anon_sym_LBRACE] = ACTIONS(2755),
    [anon_sym_TILDE] = ACTIONS(2755),
    [anon_sym_where] = ACTIONS(2753),
    [anon_sym_notnull] = ACTIONS(2753),
    [anon_sym_unmanaged] = ACTIONS(2753),
    [anon_sym_BANG] = ACTIONS(2755),
    [anon_sym_PLUS_PLUS] = ACTIONS(2755),
    [anon_sym_DASH_DASH] = ACTIONS(2755),
    [anon_sym_true] = ACTIONS(2753),
    [anon_sym_false] = ACTIONS(2753),
    [anon_sym_PLUS] = ACTIONS(2753),
    [anon_sym_DASH] = ACTIONS(2753),
    [anon_sym_STAR] = ACTIONS(2755),
    [anon_sym_CARET] = ACTIONS(2755),
    [anon_sym_AMP] = ACTIONS(2755),
    [anon_sym_get] = ACTIONS(2753),
    [anon_sym_set] = ACTIONS(2753),
    [anon_sym_add] = ACTIONS(2753),
    [anon_sym_remove] = ACTIONS(2753),
    [anon_sym_delegate] = ACTIONS(2753),
    [anon_sym_var] = ACTIONS(2753),
    [sym_predefined_type] = ACTIONS(2753),
    [anon_sym_break] = ACTIONS(2753),
    [anon_sym_checked] = ACTIONS(2753),
    [anon_sym_unchecked] = ACTIONS(2753),
    [anon_sym_continue] = ACTIONS(2753),
    [anon_sym_do] = ACTIONS(2753),
    [anon_sym_while] = ACTIONS(2753),
    [anon_sym_for] = ACTIONS(2753),
    [anon_sym_await] = ACTIONS(2753),
    [anon_sym_foreach] = ACTIONS(2753),
    [anon_sym_goto] = ACTIONS(2753),
    [anon_sym_case] = ACTIONS(2753),
    [anon_sym_default] = ACTIONS(2753),
    [anon_sym_if] = ACTIONS(2753),
    [anon_sym_lock] = ACTIONS(2753),
    [anon_sym_switch] = ACTIONS(2753),
    [anon_sym_when] = ACTIONS(2753),
    [anon_sym_throw] = ACTIONS(2753),
    [anon_sym_try] = ACTIONS(2753),
    [anon_sym_yield] = ACTIONS(2753),
    [anon_sym_stackalloc] = ACTIONS(2753),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2755),
    [anon_sym_DQUOTE] = ACTIONS(2755),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2755),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2755),
    [anon_sym___makeref] = ACTIONS(2753),
    [anon_sym_from] = ACTIONS(2753),
    [anon_sym_join] = ACTIONS(2753),
    [anon_sym_on] = ACTIONS(2753),
    [anon_sym_equals] = ACTIONS(2753),
    [anon_sym_into] = ACTIONS(2753),
    [anon_sym_let] = ACTIONS(2753),
    [anon_sym_orderby] = ACTIONS(2753),
    [anon_sym_ascending] = ACTIONS(2753),
    [anon_sym_descending] = ACTIONS(2753),
    [anon_sym_group] = ACTIONS(2753),
    [anon_sym_by] = ACTIONS(2753),
    [anon_sym_select] = ACTIONS(2753),
    [anon_sym_DOT_DOT] = ACTIONS(2755),
    [anon_sym___reftype] = ACTIONS(2753),
    [anon_sym___refvalue] = ACTIONS(2753),
    [anon_sym_sizeof] = ACTIONS(2753),
    [anon_sym_typeof] = ACTIONS(2753),
    [anon_sym_SQUOTE] = ACTIONS(2755),
    [sym_integer_literal] = ACTIONS(2753),
    [sym_null_literal] = ACTIONS(2753),
    [sym_real_literal] = ACTIONS(2755),
    [sym_verbatim_string_literal] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2753),
    [anon_sym_nameof] = ACTIONS(2753),
    [sym_void_keyword] = ACTIONS(2753),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1736] = {
    [sym__preprocessor_call] = STATE(1736),
    [sym__identifier_token] = ACTIONS(2757),
    [anon_sym_extern] = ACTIONS(2757),
    [anon_sym_alias] = ACTIONS(2757),
    [anon_sym_SEMI] = ACTIONS(2759),
    [anon_sym_global] = ACTIONS(2757),
    [anon_sym_using] = ACTIONS(2757),
    [anon_sym_static] = ACTIONS(2757),
    [anon_sym_LBRACK] = ACTIONS(2759),
    [anon_sym_return] = ACTIONS(2757),
    [anon_sym_LPAREN] = ACTIONS(2759),
    [anon_sym_abstract] = ACTIONS(2757),
    [anon_sym_async] = ACTIONS(2757),
    [anon_sym_const] = ACTIONS(2757),
    [anon_sym_fixed] = ACTIONS(2757),
    [anon_sym_internal] = ACTIONS(2757),
    [anon_sym_new] = ACTIONS(2757),
    [anon_sym_override] = ACTIONS(2757),
    [anon_sym_partial] = ACTIONS(2757),
    [anon_sym_private] = ACTIONS(2757),
    [anon_sym_protected] = ACTIONS(2757),
    [anon_sym_public] = ACTIONS(2757),
    [anon_sym_readonly] = ACTIONS(2757),
    [anon_sym_ref] = ACTIONS(2757),
    [anon_sym_sealed] = ACTIONS(2757),
    [anon_sym_unsafe] = ACTIONS(2757),
    [anon_sym_virtual] = ACTIONS(2757),
    [anon_sym_volatile] = ACTIONS(2757),
    [anon_sym_this] = ACTIONS(2757),
    [anon_sym_base] = ACTIONS(2757),
    [anon_sym_LBRACE] = ACTIONS(2759),
    [anon_sym_TILDE] = ACTIONS(2759),
    [anon_sym_where] = ACTIONS(2757),
    [anon_sym_notnull] = ACTIONS(2757),
    [anon_sym_unmanaged] = ACTIONS(2757),
    [anon_sym_BANG] = ACTIONS(2759),
    [anon_sym_PLUS_PLUS] = ACTIONS(2759),
    [anon_sym_DASH_DASH] = ACTIONS(2759),
    [anon_sym_true] = ACTIONS(2757),
    [anon_sym_false] = ACTIONS(2757),
    [anon_sym_PLUS] = ACTIONS(2757),
    [anon_sym_DASH] = ACTIONS(2757),
    [anon_sym_STAR] = ACTIONS(2759),
    [anon_sym_CARET] = ACTIONS(2759),
    [anon_sym_AMP] = ACTIONS(2759),
    [anon_sym_get] = ACTIONS(2757),
    [anon_sym_set] = ACTIONS(2757),
    [anon_sym_add] = ACTIONS(2757),
    [anon_sym_remove] = ACTIONS(2757),
    [anon_sym_delegate] = ACTIONS(2757),
    [anon_sym_var] = ACTIONS(2757),
    [sym_predefined_type] = ACTIONS(2757),
    [anon_sym_break] = ACTIONS(2757),
    [anon_sym_checked] = ACTIONS(2757),
    [anon_sym_unchecked] = ACTIONS(2757),
    [anon_sym_continue] = ACTIONS(2757),
    [anon_sym_do] = ACTIONS(2757),
    [anon_sym_while] = ACTIONS(2757),
    [anon_sym_for] = ACTIONS(2757),
    [anon_sym_await] = ACTIONS(2757),
    [anon_sym_foreach] = ACTIONS(2757),
    [anon_sym_goto] = ACTIONS(2757),
    [anon_sym_case] = ACTIONS(2757),
    [anon_sym_default] = ACTIONS(2757),
    [anon_sym_if] = ACTIONS(2757),
    [anon_sym_lock] = ACTIONS(2757),
    [anon_sym_switch] = ACTIONS(2757),
    [anon_sym_when] = ACTIONS(2757),
    [anon_sym_throw] = ACTIONS(2757),
    [anon_sym_try] = ACTIONS(2757),
    [anon_sym_yield] = ACTIONS(2757),
    [anon_sym_stackalloc] = ACTIONS(2757),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2759),
    [anon_sym_DQUOTE] = ACTIONS(2759),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2759),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2759),
    [anon_sym___makeref] = ACTIONS(2757),
    [anon_sym_from] = ACTIONS(2757),
    [anon_sym_join] = ACTIONS(2757),
    [anon_sym_on] = ACTIONS(2757),
    [anon_sym_equals] = ACTIONS(2757),
    [anon_sym_into] = ACTIONS(2757),
    [anon_sym_let] = ACTIONS(2757),
    [anon_sym_orderby] = ACTIONS(2757),
    [anon_sym_ascending] = ACTIONS(2757),
    [anon_sym_descending] = ACTIONS(2757),
    [anon_sym_group] = ACTIONS(2757),
    [anon_sym_by] = ACTIONS(2757),
    [anon_sym_select] = ACTIONS(2757),
    [anon_sym_DOT_DOT] = ACTIONS(2759),
    [anon_sym___reftype] = ACTIONS(2757),
    [anon_sym___refvalue] = ACTIONS(2757),
    [anon_sym_sizeof] = ACTIONS(2757),
    [anon_sym_typeof] = ACTIONS(2757),
    [anon_sym_SQUOTE] = ACTIONS(2759),
    [sym_integer_literal] = ACTIONS(2757),
    [sym_null_literal] = ACTIONS(2757),
    [sym_real_literal] = ACTIONS(2759),
    [sym_verbatim_string_literal] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2757),
    [anon_sym_nameof] = ACTIONS(2757),
    [sym_void_keyword] = ACTIONS(2757),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1737] = {
    [sym__preprocessor_call] = STATE(1737),
    [sym__identifier_token] = ACTIONS(2761),
    [anon_sym_extern] = ACTIONS(2761),
    [anon_sym_alias] = ACTIONS(2761),
    [anon_sym_SEMI] = ACTIONS(2763),
    [anon_sym_global] = ACTIONS(2761),
    [anon_sym_using] = ACTIONS(2761),
    [anon_sym_static] = ACTIONS(2761),
    [anon_sym_LBRACK] = ACTIONS(2763),
    [anon_sym_return] = ACTIONS(2761),
    [anon_sym_LPAREN] = ACTIONS(2763),
    [anon_sym_abstract] = ACTIONS(2761),
    [anon_sym_async] = ACTIONS(2761),
    [anon_sym_const] = ACTIONS(2761),
    [anon_sym_fixed] = ACTIONS(2761),
    [anon_sym_internal] = ACTIONS(2761),
    [anon_sym_new] = ACTIONS(2761),
    [anon_sym_override] = ACTIONS(2761),
    [anon_sym_partial] = ACTIONS(2761),
    [anon_sym_private] = ACTIONS(2761),
    [anon_sym_protected] = ACTIONS(2761),
    [anon_sym_public] = ACTIONS(2761),
    [anon_sym_readonly] = ACTIONS(2761),
    [anon_sym_ref] = ACTIONS(2761),
    [anon_sym_sealed] = ACTIONS(2761),
    [anon_sym_unsafe] = ACTIONS(2761),
    [anon_sym_virtual] = ACTIONS(2761),
    [anon_sym_volatile] = ACTIONS(2761),
    [anon_sym_this] = ACTIONS(2761),
    [anon_sym_base] = ACTIONS(2761),
    [anon_sym_LBRACE] = ACTIONS(2763),
    [anon_sym_TILDE] = ACTIONS(2763),
    [anon_sym_where] = ACTIONS(2761),
    [anon_sym_notnull] = ACTIONS(2761),
    [anon_sym_unmanaged] = ACTIONS(2761),
    [anon_sym_BANG] = ACTIONS(2763),
    [anon_sym_PLUS_PLUS] = ACTIONS(2763),
    [anon_sym_DASH_DASH] = ACTIONS(2763),
    [anon_sym_true] = ACTIONS(2761),
    [anon_sym_false] = ACTIONS(2761),
    [anon_sym_PLUS] = ACTIONS(2761),
    [anon_sym_DASH] = ACTIONS(2761),
    [anon_sym_STAR] = ACTIONS(2763),
    [anon_sym_CARET] = ACTIONS(2763),
    [anon_sym_AMP] = ACTIONS(2763),
    [anon_sym_get] = ACTIONS(2761),
    [anon_sym_set] = ACTIONS(2761),
    [anon_sym_add] = ACTIONS(2761),
    [anon_sym_remove] = ACTIONS(2761),
    [anon_sym_delegate] = ACTIONS(2761),
    [anon_sym_var] = ACTIONS(2761),
    [sym_predefined_type] = ACTIONS(2761),
    [anon_sym_break] = ACTIONS(2761),
    [anon_sym_checked] = ACTIONS(2761),
    [anon_sym_unchecked] = ACTIONS(2761),
    [anon_sym_continue] = ACTIONS(2761),
    [anon_sym_do] = ACTIONS(2761),
    [anon_sym_while] = ACTIONS(2761),
    [anon_sym_for] = ACTIONS(2761),
    [anon_sym_await] = ACTIONS(2761),
    [anon_sym_foreach] = ACTIONS(2761),
    [anon_sym_goto] = ACTIONS(2761),
    [anon_sym_case] = ACTIONS(2761),
    [anon_sym_default] = ACTIONS(2761),
    [anon_sym_if] = ACTIONS(2761),
    [anon_sym_lock] = ACTIONS(2761),
    [anon_sym_switch] = ACTIONS(2761),
    [anon_sym_when] = ACTIONS(2761),
    [anon_sym_throw] = ACTIONS(2761),
    [anon_sym_try] = ACTIONS(2761),
    [anon_sym_yield] = ACTIONS(2761),
    [anon_sym_stackalloc] = ACTIONS(2761),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(2763),
    [anon_sym_DQUOTE] = ACTIONS(2763),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(2763),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(2763),
    [anon_sym___makeref] = ACTIONS(2761),
    [anon_sym_from] = ACTIONS(2761),
    [anon_sym_join] = ACTIONS(2761),
    [anon_sym_on] = ACTIONS(2761),
    [anon_sym_equals] = ACTIONS(2761),
    [anon_sym_into] = ACTIONS(2761),
    [anon_sym_let] = ACTIONS(2761),
    [anon_sym_orderby] = ACTIONS(2761),
    [anon_sym_ascending] = ACTIONS(2761),
    [anon_sym_descending] = ACTIONS(2761),
    [anon_sym_group] = ACTIONS(2761),
    [anon_sym_by] = ACTIONS(2761),
    [anon_sym_select] = ACTIONS(2761),
    [anon_sym_DOT_DOT] = ACTIONS(2763),
    [anon_sym___reftype] = ACTIONS(2761),
    [anon_sym___refvalue] = ACTIONS(2761),
    [anon_sym_sizeof] = ACTIONS(2761),
    [anon_sym_typeof] = ACTIONS(2761),
    [anon_sym_SQUOTE] = ACTIONS(2763),
    [sym_integer_literal] = ACTIONS(2761),
    [sym_null_literal] = ACTIONS(2761),
    [sym_real_literal] = ACTIONS(2763),
    [sym_verbatim_string_literal] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2761),
    [anon_sym_nameof] = ACTIONS(2761),
    [sym_void_keyword] = ACTIONS(2761),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1738] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1738),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_RBRACK] = ACTIONS(2729),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_in] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1739] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1739),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_RBRACK] = ACTIONS(2729),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_in] = ACTIONS(2734),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1740] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1740),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2726),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1741] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1741),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2726),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1742] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1742),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2726),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2726),
    [anon_sym_join] = ACTIONS(2726),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_orderby] = ACTIONS(2726),
    [anon_sym_ascending] = ACTIONS(2726),
    [anon_sym_descending] = ACTIONS(2726),
    [anon_sym_group] = ACTIONS(2726),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2726),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1743] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1743),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2726),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2726),
    [anon_sym_join] = ACTIONS(2726),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_orderby] = ACTIONS(2726),
    [anon_sym_ascending] = ACTIONS(2726),
    [anon_sym_descending] = ACTIONS(2726),
    [anon_sym_group] = ACTIONS(2726),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2726),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1744] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1744),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2726),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2726),
    [anon_sym_join] = ACTIONS(2726),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_orderby] = ACTIONS(2726),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2726),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2726),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1745] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1745),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2726),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1746] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1746),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2726),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1747] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1747),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2726),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1748] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1748),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2726),
    [anon_sym_into] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1749] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1749),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2726),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2726),
    [anon_sym_join] = ACTIONS(2726),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2726),
    [anon_sym_orderby] = ACTIONS(2726),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2726),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2726),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1750] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1750),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2726),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2726),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1751] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4928),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4715),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1751),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2736),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2726),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1752] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym__type] = STATE(4840),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4637),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1752),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2767),
    [anon_sym_EQ] = ACTIONS(2769),
    [anon_sym_LT] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2769),
    [anon_sym_DOT] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_COLON] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2771),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_QMARK] = ACTIONS(2769),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2769),
    [anon_sym_PERCENT] = ACTIONS(2769),
    [anon_sym_CARET] = ACTIONS(2769),
    [anon_sym_PIPE] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_LT_LT] = ACTIONS(2769),
    [anon_sym_GT_GT] = ACTIONS(2769),
    [anon_sym_EQ_EQ] = ACTIONS(2771),
    [anon_sym_BANG_EQ] = ACTIONS(2771),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_switch] = ACTIONS(2769),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_PLUS_EQ] = ACTIONS(2771),
    [anon_sym_DASH_EQ] = ACTIONS(2771),
    [anon_sym_STAR_EQ] = ACTIONS(2771),
    [anon_sym_SLASH_EQ] = ACTIONS(2771),
    [anon_sym_PERCENT_EQ] = ACTIONS(2771),
    [anon_sym_AMP_EQ] = ACTIONS(2771),
    [anon_sym_CARET_EQ] = ACTIONS(2771),
    [anon_sym_PIPE_EQ] = ACTIONS(2771),
    [anon_sym_LT_LT_EQ] = ACTIONS(2771),
    [anon_sym_GT_GT_EQ] = ACTIONS(2771),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2771),
    [anon_sym_is] = ACTIONS(2769),
    [anon_sym_DASH_GT] = ACTIONS(2771),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [anon_sym_DOT_DOT] = ACTIONS(2771),
    [anon_sym_with] = ACTIONS(2769),
    [anon_sym_AMP_AMP] = ACTIONS(2771),
    [anon_sym_PIPE_PIPE] = ACTIONS(2771),
    [anon_sym_QMARK_QMARK] = ACTIONS(2769),
    [anon_sym_as] = ACTIONS(2769),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1753] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1760),
    [sym_property_pattern_clause] = STATE(1766),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1753),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2780),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_RBRACK] = ACTIONS(2780),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_RPAREN] = ACTIONS(2780),
    [anon_sym_in] = ACTIONS(2782),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2780),
    [anon_sym_EQ_GT] = ACTIONS(2780),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1754] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1760),
    [sym_property_pattern_clause] = STATE(1766),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1754),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_RBRACK] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_RPAREN] = ACTIONS(2794),
    [anon_sym_in] = ACTIONS(2790),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_EQ_GT] = ACTIONS(2794),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2799),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1755] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1760),
    [sym_property_pattern_clause] = STATE(1766),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1755),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2780),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_RBRACK] = ACTIONS(2780),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_RPAREN] = ACTIONS(2780),
    [anon_sym_in] = ACTIONS(2782),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2780),
    [anon_sym_EQ_GT] = ACTIONS(2780),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1756] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1762),
    [sym_property_pattern_clause] = STATE(1768),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1756),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2780),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_RBRACK] = ACTIONS(2780),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_RPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2780),
    [anon_sym_EQ_GT] = ACTIONS(2780),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1757] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1762),
    [sym_property_pattern_clause] = STATE(1768),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1757),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2794),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_RBRACK] = ACTIONS(2794),
    [anon_sym_COLON] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_RPAREN] = ACTIONS(2794),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2794),
    [anon_sym_EQ_GT] = ACTIONS(2794),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1758] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1762),
    [sym_property_pattern_clause] = STATE(1768),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1758),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2780),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_RBRACK] = ACTIONS(2780),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_RPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2780),
    [anon_sym_EQ_GT] = ACTIONS(2780),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1759] = {
    [sym__variable_designation] = STATE(2808),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_property_pattern_clause] = STATE(1766),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1759),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_RBRACK] = ACTIONS(2807),
    [anon_sym_COLON] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_in] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1760] = {
    [sym__variable_designation] = STATE(2800),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_property_pattern_clause] = STATE(1767),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1760),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_COMMA] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_RBRACK] = ACTIONS(2811),
    [anon_sym_COLON] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_RPAREN] = ACTIONS(2811),
    [anon_sym_in] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1761] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1768),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1761),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_RBRACK] = ACTIONS(2807),
    [anon_sym_COLON] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1762] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1770),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1762),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_COMMA] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_RBRACK] = ACTIONS(2811),
    [anon_sym_COLON] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_RPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1763] = {
    [sym__variable_designation] = STATE(2810),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1763),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_RBRACK] = ACTIONS(2815),
    [anon_sym_COLON] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2819),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2817),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2817),
    [anon_sym_and] = ACTIONS(2817),
    [anon_sym_or] = ACTIONS(2817),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2815),
    [anon_sym_DASH_EQ] = ACTIONS(2815),
    [anon_sym_STAR_EQ] = ACTIONS(2815),
    [anon_sym_SLASH_EQ] = ACTIONS(2815),
    [anon_sym_PERCENT_EQ] = ACTIONS(2815),
    [anon_sym_AMP_EQ] = ACTIONS(2815),
    [anon_sym_CARET_EQ] = ACTIONS(2815),
    [anon_sym_PIPE_EQ] = ACTIONS(2815),
    [anon_sym_LT_LT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT_EQ] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2815),
    [anon_sym_is] = ACTIONS(2817),
    [anon_sym_DASH_GT] = ACTIONS(2815),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_with] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK] = ACTIONS(2817),
    [anon_sym_as] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1764] = {
    [sym__variable_designation] = STATE(2808),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1764),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_RBRACK] = ACTIONS(2807),
    [anon_sym_COLON] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_in] = ACTIONS(2809),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1765] = {
    [sym__variable_designation] = STATE(2945),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1765),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_RBRACK] = ACTIONS(2815),
    [anon_sym_COLON] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2821),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2817),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2817),
    [anon_sym_and] = ACTIONS(2817),
    [anon_sym_or] = ACTIONS(2817),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2815),
    [anon_sym_DASH_EQ] = ACTIONS(2815),
    [anon_sym_STAR_EQ] = ACTIONS(2815),
    [anon_sym_SLASH_EQ] = ACTIONS(2815),
    [anon_sym_PERCENT_EQ] = ACTIONS(2815),
    [anon_sym_AMP_EQ] = ACTIONS(2815),
    [anon_sym_CARET_EQ] = ACTIONS(2815),
    [anon_sym_PIPE_EQ] = ACTIONS(2815),
    [anon_sym_LT_LT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT_EQ] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2815),
    [anon_sym_is] = ACTIONS(2817),
    [anon_sym_DASH_GT] = ACTIONS(2815),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_with] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK] = ACTIONS(2817),
    [anon_sym_as] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1766] = {
    [sym__variable_designation] = STATE(2800),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1766),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_COMMA] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_RBRACK] = ACTIONS(2811),
    [anon_sym_COLON] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_RPAREN] = ACTIONS(2811),
    [anon_sym_in] = ACTIONS(2813),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1767] = {
    [sym__variable_designation] = STATE(2786),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1767),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_RBRACK] = ACTIONS(2823),
    [anon_sym_COLON] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(2825),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_EQ_GT] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1768] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1768),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2811),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_COMMA] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_RBRACK] = ACTIONS(2811),
    [anon_sym_COLON] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_RPAREN] = ACTIONS(2811),
    [anon_sym_RBRACE] = ACTIONS(2811),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1769] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1769),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2807),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_RBRACK] = ACTIONS(2807),
    [anon_sym_COLON] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_RPAREN] = ACTIONS(2807),
    [anon_sym_RBRACE] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1770] = {
    [sym__variable_designation] = STATE(2948),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1770),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_SEMI] = ACTIONS(2823),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_RBRACK] = ACTIONS(2823),
    [anon_sym_COLON] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_RPAREN] = ACTIONS(2823),
    [anon_sym_RBRACE] = ACTIONS(2823),
    [anon_sym_EQ_GT] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1771] = {
    [sym__preprocessor_call] = STATE(1771),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1772] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1853),
    [sym_property_pattern_clause] = STATE(1884),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1772),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_EQ_GT] = ACTIONS(2780),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2782),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1773] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1853),
    [sym_property_pattern_clause] = STATE(1884),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1773),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_COLON] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_EQ_GT] = ACTIONS(2794),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2799),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1774] = {
    [sym__preprocessor_call] = STATE(1774),
    [sym__identifier_token] = ACTIONS(2833),
    [anon_sym_alias] = ACTIONS(2833),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_global] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON_COLON] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2835),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_RBRACK] = ACTIONS(2835),
    [anon_sym_COLON] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_RPAREN] = ACTIONS(2835),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2835),
    [anon_sym_where] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_notnull] = ACTIONS(2833),
    [anon_sym_unmanaged] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_GT_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2835),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_add] = ACTIONS(2833),
    [anon_sym_remove] = ACTIONS(2833),
    [anon_sym_switch] = ACTIONS(2833),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [sym_discard] = ACTIONS(2833),
    [anon_sym_when] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2833),
    [anon_sym_PLUS_EQ] = ACTIONS(2835),
    [anon_sym_DASH_EQ] = ACTIONS(2835),
    [anon_sym_STAR_EQ] = ACTIONS(2835),
    [anon_sym_SLASH_EQ] = ACTIONS(2835),
    [anon_sym_PERCENT_EQ] = ACTIONS(2835),
    [anon_sym_AMP_EQ] = ACTIONS(2835),
    [anon_sym_CARET_EQ] = ACTIONS(2835),
    [anon_sym_PIPE_EQ] = ACTIONS(2835),
    [anon_sym_LT_LT_EQ] = ACTIONS(2835),
    [anon_sym_GT_GT_EQ] = ACTIONS(2835),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2835),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_DASH_GT] = ACTIONS(2835),
    [anon_sym_from] = ACTIONS(2833),
    [anon_sym_join] = ACTIONS(2833),
    [anon_sym_on] = ACTIONS(2833),
    [anon_sym_equals] = ACTIONS(2833),
    [anon_sym_into] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_orderby] = ACTIONS(2833),
    [anon_sym_ascending] = ACTIONS(2833),
    [anon_sym_descending] = ACTIONS(2833),
    [anon_sym_group] = ACTIONS(2833),
    [anon_sym_by] = ACTIONS(2833),
    [anon_sym_select] = ACTIONS(2833),
    [anon_sym_DOT_DOT] = ACTIONS(2835),
    [anon_sym_with] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_QMARK_QMARK] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2833),
    [anon_sym_nameof] = ACTIONS(2833),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1775] = {
    [sym__preprocessor_call] = STATE(1775),
    [sym__identifier_token] = ACTIONS(2734),
    [anon_sym_alias] = ACTIONS(2734),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_global] = ACTIONS(2734),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_RBRACK] = ACTIONS(2729),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_in] = ACTIONS(2734),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2734),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2734),
    [anon_sym_unmanaged] = ACTIONS(2734),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2734),
    [anon_sym_set] = ACTIONS(2734),
    [anon_sym_add] = ACTIONS(2734),
    [anon_sym_remove] = ACTIONS(2734),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [sym_discard] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2734),
    [anon_sym_yield] = ACTIONS(2734),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2734),
    [anon_sym_join] = ACTIONS(2734),
    [anon_sym_on] = ACTIONS(2734),
    [anon_sym_equals] = ACTIONS(2734),
    [anon_sym_into] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2734),
    [anon_sym_orderby] = ACTIONS(2734),
    [anon_sym_ascending] = ACTIONS(2734),
    [anon_sym_descending] = ACTIONS(2734),
    [anon_sym_group] = ACTIONS(2734),
    [anon_sym_by] = ACTIONS(2734),
    [anon_sym_select] = ACTIONS(2734),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2734),
    [anon_sym_nameof] = ACTIONS(2734),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1776] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1776),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1777] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1824),
    [sym_property_pattern_clause] = STATE(1888),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1777),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_COLON] = ACTIONS(2780),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_EQ_GT] = ACTIONS(2780),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2782),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1778] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1778),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2840),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1779] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1824),
    [sym_property_pattern_clause] = STATE(1888),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1779),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_COLON] = ACTIONS(2794),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_EQ_GT] = ACTIONS(2794),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2799),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2799),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1780] = {
    [sym__preprocessor_call] = STATE(1780),
    [sym__identifier_token] = ACTIONS(2844),
    [anon_sym_alias] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_global] = ACTIONS(2844),
    [anon_sym_EQ] = ACTIONS(2844),
    [anon_sym_COLON_COLON] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2844),
    [anon_sym_COMMA] = ACTIONS(2847),
    [anon_sym_GT] = ACTIONS(2844),
    [anon_sym_DOT] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_RBRACK] = ACTIONS(2847),
    [anon_sym_COLON] = ACTIONS(2844),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_RPAREN] = ACTIONS(2847),
    [anon_sym_in] = ACTIONS(2844),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2844),
    [anon_sym_QMARK] = ACTIONS(2844),
    [anon_sym_notnull] = ACTIONS(2844),
    [anon_sym_unmanaged] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_PERCENT] = ACTIONS(2844),
    [anon_sym_CARET] = ACTIONS(2844),
    [anon_sym_PIPE] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2844),
    [anon_sym_LT_LT] = ACTIONS(2844),
    [anon_sym_GT_GT] = ACTIONS(2844),
    [anon_sym_EQ_EQ] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_GT_EQ] = ACTIONS(2847),
    [anon_sym_LT_EQ] = ACTIONS(2847),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_add] = ACTIONS(2844),
    [anon_sym_remove] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_and] = ACTIONS(2844),
    [anon_sym_or] = ACTIONS(2844),
    [sym_discard] = ACTIONS(2844),
    [anon_sym_when] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_PLUS_EQ] = ACTIONS(2847),
    [anon_sym_DASH_EQ] = ACTIONS(2847),
    [anon_sym_STAR_EQ] = ACTIONS(2847),
    [anon_sym_SLASH_EQ] = ACTIONS(2847),
    [anon_sym_PERCENT_EQ] = ACTIONS(2847),
    [anon_sym_AMP_EQ] = ACTIONS(2847),
    [anon_sym_CARET_EQ] = ACTIONS(2847),
    [anon_sym_PIPE_EQ] = ACTIONS(2847),
    [anon_sym_LT_LT_EQ] = ACTIONS(2847),
    [anon_sym_GT_GT_EQ] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2847),
    [anon_sym_is] = ACTIONS(2844),
    [anon_sym_DASH_GT] = ACTIONS(2847),
    [anon_sym_from] = ACTIONS(2844),
    [anon_sym_join] = ACTIONS(2844),
    [anon_sym_on] = ACTIONS(2844),
    [anon_sym_equals] = ACTIONS(2844),
    [anon_sym_into] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_orderby] = ACTIONS(2844),
    [anon_sym_ascending] = ACTIONS(2844),
    [anon_sym_descending] = ACTIONS(2844),
    [anon_sym_group] = ACTIONS(2844),
    [anon_sym_by] = ACTIONS(2844),
    [anon_sym_select] = ACTIONS(2844),
    [anon_sym_DOT_DOT] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK] = ACTIONS(2844),
    [anon_sym_as] = ACTIONS(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2844),
    [anon_sym_nameof] = ACTIONS(2844),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1781] = {
    [sym__preprocessor_call] = STATE(1781),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2852),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_RBRACK] = ACTIONS(2852),
    [anon_sym_COLON] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_RPAREN] = ACTIONS(2852),
    [anon_sym_in] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_EQ_GT] = ACTIONS(2852),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1782] = {
    [sym__preprocessor_call] = STATE(1782),
    [sym__identifier_token] = ACTIONS(2860),
    [anon_sym_alias] = ACTIONS(2860),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_global] = ACTIONS(2860),
    [anon_sym_EQ] = ACTIONS(2860),
    [anon_sym_LT] = ACTIONS(2860),
    [anon_sym_COMMA] = ACTIONS(2862),
    [anon_sym_GT] = ACTIONS(2860),
    [anon_sym_DOT] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_RBRACK] = ACTIONS(2862),
    [anon_sym_COLON] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_RPAREN] = ACTIONS(2862),
    [anon_sym_in] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_EQ_GT] = ACTIONS(2862),
    [anon_sym_where] = ACTIONS(2860),
    [anon_sym_QMARK] = ACTIONS(2860),
    [anon_sym_notnull] = ACTIONS(2860),
    [anon_sym_unmanaged] = ACTIONS(2860),
    [anon_sym_BANG] = ACTIONS(2860),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2860),
    [anon_sym_SLASH] = ACTIONS(2860),
    [anon_sym_PERCENT] = ACTIONS(2860),
    [anon_sym_CARET] = ACTIONS(2860),
    [anon_sym_PIPE] = ACTIONS(2860),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym_LT_LT] = ACTIONS(2860),
    [anon_sym_GT_GT] = ACTIONS(2860),
    [anon_sym_EQ_EQ] = ACTIONS(2862),
    [anon_sym_BANG_EQ] = ACTIONS(2862),
    [anon_sym_GT_EQ] = ACTIONS(2862),
    [anon_sym_LT_EQ] = ACTIONS(2862),
    [anon_sym_get] = ACTIONS(2860),
    [anon_sym_set] = ACTIONS(2860),
    [anon_sym_add] = ACTIONS(2860),
    [anon_sym_remove] = ACTIONS(2860),
    [anon_sym_switch] = ACTIONS(2860),
    [anon_sym_and] = ACTIONS(2860),
    [anon_sym_or] = ACTIONS(2860),
    [sym_discard] = ACTIONS(2860),
    [anon_sym_when] = ACTIONS(2860),
    [anon_sym_yield] = ACTIONS(2860),
    [anon_sym_PLUS_EQ] = ACTIONS(2862),
    [anon_sym_DASH_EQ] = ACTIONS(2862),
    [anon_sym_STAR_EQ] = ACTIONS(2862),
    [anon_sym_SLASH_EQ] = ACTIONS(2862),
    [anon_sym_PERCENT_EQ] = ACTIONS(2862),
    [anon_sym_AMP_EQ] = ACTIONS(2862),
    [anon_sym_CARET_EQ] = ACTIONS(2862),
    [anon_sym_PIPE_EQ] = ACTIONS(2862),
    [anon_sym_LT_LT_EQ] = ACTIONS(2862),
    [anon_sym_GT_GT_EQ] = ACTIONS(2862),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2862),
    [anon_sym_is] = ACTIONS(2860),
    [anon_sym_DASH_GT] = ACTIONS(2862),
    [anon_sym_from] = ACTIONS(2860),
    [anon_sym_join] = ACTIONS(2860),
    [anon_sym_on] = ACTIONS(2860),
    [anon_sym_equals] = ACTIONS(2860),
    [anon_sym_into] = ACTIONS(2860),
    [anon_sym_let] = ACTIONS(2860),
    [anon_sym_orderby] = ACTIONS(2860),
    [anon_sym_ascending] = ACTIONS(2860),
    [anon_sym_descending] = ACTIONS(2860),
    [anon_sym_group] = ACTIONS(2860),
    [anon_sym_by] = ACTIONS(2860),
    [anon_sym_select] = ACTIONS(2860),
    [anon_sym_DOT_DOT] = ACTIONS(2862),
    [anon_sym_with] = ACTIONS(2860),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_PIPE_PIPE] = ACTIONS(2862),
    [anon_sym_QMARK_QMARK] = ACTIONS(2860),
    [anon_sym_as] = ACTIONS(2860),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2860),
    [anon_sym_nameof] = ACTIONS(2860),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1783] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2996),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_positional_pattern_clause] = STATE(1862),
    [sym_property_pattern_clause] = STATE(1908),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1783),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2782),
    [anon_sym_join] = ACTIONS(2782),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2782),
    [anon_sym_orderby] = ACTIONS(2782),
    [anon_sym_ascending] = ACTIONS(2782),
    [anon_sym_descending] = ACTIONS(2782),
    [anon_sym_group] = ACTIONS(2782),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2782),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1784] = {
    [sym__preprocessor_call] = STATE(1784),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1785] = {
    [sym__preprocessor_call] = STATE(1785),
    [sym__identifier_token] = ACTIONS(2866),
    [anon_sym_alias] = ACTIONS(2866),
    [anon_sym_SEMI] = ACTIONS(2868),
    [anon_sym_global] = ACTIONS(2866),
    [anon_sym_EQ] = ACTIONS(2866),
    [anon_sym_LT] = ACTIONS(2866),
    [anon_sym_COMMA] = ACTIONS(2868),
    [anon_sym_GT] = ACTIONS(2866),
    [anon_sym_DOT] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2868),
    [anon_sym_COLON] = ACTIONS(2868),
    [anon_sym_LPAREN] = ACTIONS(2868),
    [anon_sym_RPAREN] = ACTIONS(2868),
    [anon_sym_in] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(2868),
    [anon_sym_RBRACE] = ACTIONS(2868),
    [anon_sym_EQ_GT] = ACTIONS(2868),
    [anon_sym_where] = ACTIONS(2866),
    [anon_sym_QMARK] = ACTIONS(2866),
    [anon_sym_notnull] = ACTIONS(2866),
    [anon_sym_unmanaged] = ACTIONS(2866),
    [anon_sym_BANG] = ACTIONS(2866),
    [anon_sym_PLUS_PLUS] = ACTIONS(2868),
    [anon_sym_DASH_DASH] = ACTIONS(2868),
    [anon_sym_PLUS] = ACTIONS(2866),
    [anon_sym_DASH] = ACTIONS(2866),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_SLASH] = ACTIONS(2866),
    [anon_sym_PERCENT] = ACTIONS(2866),
    [anon_sym_CARET] = ACTIONS(2866),
    [anon_sym_PIPE] = ACTIONS(2866),
    [anon_sym_AMP] = ACTIONS(2866),
    [anon_sym_LT_LT] = ACTIONS(2866),
    [anon_sym_GT_GT] = ACTIONS(2866),
    [anon_sym_EQ_EQ] = ACTIONS(2868),
    [anon_sym_BANG_EQ] = ACTIONS(2868),
    [anon_sym_GT_EQ] = ACTIONS(2868),
    [anon_sym_LT_EQ] = ACTIONS(2868),
    [anon_sym_get] = ACTIONS(2866),
    [anon_sym_set] = ACTIONS(2866),
    [anon_sym_add] = ACTIONS(2866),
    [anon_sym_remove] = ACTIONS(2866),
    [anon_sym_switch] = ACTIONS(2866),
    [anon_sym_and] = ACTIONS(2866),
    [anon_sym_or] = ACTIONS(2866),
    [sym_discard] = ACTIONS(2866),
    [anon_sym_when] = ACTIONS(2866),
    [anon_sym_yield] = ACTIONS(2866),
    [anon_sym_PLUS_EQ] = ACTIONS(2868),
    [anon_sym_DASH_EQ] = ACTIONS(2868),
    [anon_sym_STAR_EQ] = ACTIONS(2868),
    [anon_sym_SLASH_EQ] = ACTIONS(2868),
    [anon_sym_PERCENT_EQ] = ACTIONS(2868),
    [anon_sym_AMP_EQ] = ACTIONS(2868),
    [anon_sym_CARET_EQ] = ACTIONS(2868),
    [anon_sym_PIPE_EQ] = ACTIONS(2868),
    [anon_sym_LT_LT_EQ] = ACTIONS(2868),
    [anon_sym_GT_GT_EQ] = ACTIONS(2868),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2868),
    [anon_sym_is] = ACTIONS(2866),
    [anon_sym_DASH_GT] = ACTIONS(2868),
    [anon_sym_from] = ACTIONS(2866),
    [anon_sym_join] = ACTIONS(2866),
    [anon_sym_on] = ACTIONS(2866),
    [anon_sym_equals] = ACTIONS(2866),
    [anon_sym_into] = ACTIONS(2866),
    [anon_sym_let] = ACTIONS(2866),
    [anon_sym_orderby] = ACTIONS(2866),
    [anon_sym_ascending] = ACTIONS(2866),
    [anon_sym_descending] = ACTIONS(2866),
    [anon_sym_group] = ACTIONS(2866),
    [anon_sym_by] = ACTIONS(2866),
    [anon_sym_select] = ACTIONS(2866),
    [anon_sym_DOT_DOT] = ACTIONS(2868),
    [anon_sym_with] = ACTIONS(2866),
    [anon_sym_AMP_AMP] = ACTIONS(2868),
    [anon_sym_PIPE_PIPE] = ACTIONS(2868),
    [anon_sym_QMARK_QMARK] = ACTIONS(2866),
    [anon_sym_as] = ACTIONS(2866),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2866),
    [anon_sym_nameof] = ACTIONS(2866),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1786] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1786),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1787] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1864),
    [sym_property_pattern_clause] = STATE(1902),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1787),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_in] = ACTIONS(2782),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(801),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1788] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2996),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_positional_pattern_clause] = STATE(1862),
    [sym_property_pattern_clause] = STATE(1908),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1788),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2873),
    [anon_sym_join] = ACTIONS(2873),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(2873),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_orderby] = ACTIONS(2873),
    [anon_sym_ascending] = ACTIONS(2873),
    [anon_sym_descending] = ACTIONS(2873),
    [anon_sym_group] = ACTIONS(2873),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2873),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1789] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2996),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_positional_pattern_clause] = STATE(1867),
    [sym_property_pattern_clause] = STATE(1903),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1789),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2782),
    [anon_sym_join] = ACTIONS(2782),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(2782),
    [anon_sym_orderby] = ACTIONS(2782),
    [anon_sym_ascending] = ACTIONS(2782),
    [anon_sym_descending] = ACTIONS(2782),
    [anon_sym_group] = ACTIONS(2782),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2782),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1790] = {
    [sym__preprocessor_call] = STATE(1790),
    [sym__identifier_token] = ACTIONS(2876),
    [anon_sym_alias] = ACTIONS(2876),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_global] = ACTIONS(2876),
    [anon_sym_EQ] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_COMMA] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2876),
    [anon_sym_LBRACK] = ACTIONS(2878),
    [anon_sym_RBRACK] = ACTIONS(2878),
    [anon_sym_COLON] = ACTIONS(2878),
    [anon_sym_LPAREN] = ACTIONS(2878),
    [anon_sym_RPAREN] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(2876),
    [anon_sym_LBRACE] = ACTIONS(2878),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_EQ_GT] = ACTIONS(2878),
    [anon_sym_where] = ACTIONS(2876),
    [anon_sym_QMARK] = ACTIONS(2876),
    [anon_sym_notnull] = ACTIONS(2876),
    [anon_sym_unmanaged] = ACTIONS(2876),
    [anon_sym_BANG] = ACTIONS(2876),
    [anon_sym_PLUS_PLUS] = ACTIONS(2878),
    [anon_sym_DASH_DASH] = ACTIONS(2878),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2876),
    [anon_sym_PERCENT] = ACTIONS(2876),
    [anon_sym_CARET] = ACTIONS(2876),
    [anon_sym_PIPE] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2876),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_GT_GT] = ACTIONS(2876),
    [anon_sym_EQ_EQ] = ACTIONS(2878),
    [anon_sym_BANG_EQ] = ACTIONS(2878),
    [anon_sym_GT_EQ] = ACTIONS(2878),
    [anon_sym_LT_EQ] = ACTIONS(2878),
    [anon_sym_get] = ACTIONS(2876),
    [anon_sym_set] = ACTIONS(2876),
    [anon_sym_add] = ACTIONS(2876),
    [anon_sym_remove] = ACTIONS(2876),
    [anon_sym_switch] = ACTIONS(2876),
    [anon_sym_and] = ACTIONS(2876),
    [anon_sym_or] = ACTIONS(2876),
    [sym_discard] = ACTIONS(2876),
    [anon_sym_when] = ACTIONS(2876),
    [anon_sym_yield] = ACTIONS(2876),
    [anon_sym_PLUS_EQ] = ACTIONS(2878),
    [anon_sym_DASH_EQ] = ACTIONS(2878),
    [anon_sym_STAR_EQ] = ACTIONS(2878),
    [anon_sym_SLASH_EQ] = ACTIONS(2878),
    [anon_sym_PERCENT_EQ] = ACTIONS(2878),
    [anon_sym_AMP_EQ] = ACTIONS(2878),
    [anon_sym_CARET_EQ] = ACTIONS(2878),
    [anon_sym_PIPE_EQ] = ACTIONS(2878),
    [anon_sym_LT_LT_EQ] = ACTIONS(2878),
    [anon_sym_GT_GT_EQ] = ACTIONS(2878),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2878),
    [anon_sym_is] = ACTIONS(2876),
    [anon_sym_DASH_GT] = ACTIONS(2878),
    [anon_sym_from] = ACTIONS(2876),
    [anon_sym_join] = ACTIONS(2876),
    [anon_sym_on] = ACTIONS(2876),
    [anon_sym_equals] = ACTIONS(2876),
    [anon_sym_into] = ACTIONS(2876),
    [anon_sym_let] = ACTIONS(2876),
    [anon_sym_orderby] = ACTIONS(2876),
    [anon_sym_ascending] = ACTIONS(2876),
    [anon_sym_descending] = ACTIONS(2876),
    [anon_sym_group] = ACTIONS(2876),
    [anon_sym_by] = ACTIONS(2876),
    [anon_sym_select] = ACTIONS(2876),
    [anon_sym_DOT_DOT] = ACTIONS(2878),
    [anon_sym_with] = ACTIONS(2876),
    [anon_sym_AMP_AMP] = ACTIONS(2878),
    [anon_sym_PIPE_PIPE] = ACTIONS(2878),
    [anon_sym_QMARK_QMARK] = ACTIONS(2876),
    [anon_sym_as] = ACTIONS(2876),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2876),
    [anon_sym_nameof] = ACTIONS(2876),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1791] = {
    [sym__preprocessor_call] = STATE(1791),
    [sym__identifier_token] = ACTIONS(2880),
    [anon_sym_alias] = ACTIONS(2880),
    [anon_sym_SEMI] = ACTIONS(2882),
    [anon_sym_global] = ACTIONS(2880),
    [anon_sym_EQ] = ACTIONS(2880),
    [anon_sym_LT] = ACTIONS(2880),
    [anon_sym_COMMA] = ACTIONS(2882),
    [anon_sym_GT] = ACTIONS(2880),
    [anon_sym_DOT] = ACTIONS(2880),
    [anon_sym_LBRACK] = ACTIONS(2882),
    [anon_sym_RBRACK] = ACTIONS(2882),
    [anon_sym_COLON] = ACTIONS(2882),
    [anon_sym_LPAREN] = ACTIONS(2882),
    [anon_sym_RPAREN] = ACTIONS(2882),
    [anon_sym_in] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(2882),
    [anon_sym_RBRACE] = ACTIONS(2882),
    [anon_sym_EQ_GT] = ACTIONS(2882),
    [anon_sym_where] = ACTIONS(2880),
    [anon_sym_QMARK] = ACTIONS(2880),
    [anon_sym_notnull] = ACTIONS(2880),
    [anon_sym_unmanaged] = ACTIONS(2880),
    [anon_sym_BANG] = ACTIONS(2880),
    [anon_sym_PLUS_PLUS] = ACTIONS(2882),
    [anon_sym_DASH_DASH] = ACTIONS(2882),
    [anon_sym_PLUS] = ACTIONS(2880),
    [anon_sym_DASH] = ACTIONS(2880),
    [anon_sym_STAR] = ACTIONS(2880),
    [anon_sym_SLASH] = ACTIONS(2880),
    [anon_sym_PERCENT] = ACTIONS(2880),
    [anon_sym_CARET] = ACTIONS(2880),
    [anon_sym_PIPE] = ACTIONS(2880),
    [anon_sym_AMP] = ACTIONS(2880),
    [anon_sym_LT_LT] = ACTIONS(2880),
    [anon_sym_GT_GT] = ACTIONS(2880),
    [anon_sym_EQ_EQ] = ACTIONS(2882),
    [anon_sym_BANG_EQ] = ACTIONS(2882),
    [anon_sym_GT_EQ] = ACTIONS(2882),
    [anon_sym_LT_EQ] = ACTIONS(2882),
    [anon_sym_get] = ACTIONS(2880),
    [anon_sym_set] = ACTIONS(2880),
    [anon_sym_add] = ACTIONS(2880),
    [anon_sym_remove] = ACTIONS(2880),
    [anon_sym_switch] = ACTIONS(2880),
    [anon_sym_and] = ACTIONS(2880),
    [anon_sym_or] = ACTIONS(2880),
    [sym_discard] = ACTIONS(2880),
    [anon_sym_when] = ACTIONS(2880),
    [anon_sym_yield] = ACTIONS(2880),
    [anon_sym_PLUS_EQ] = ACTIONS(2882),
    [anon_sym_DASH_EQ] = ACTIONS(2882),
    [anon_sym_STAR_EQ] = ACTIONS(2882),
    [anon_sym_SLASH_EQ] = ACTIONS(2882),
    [anon_sym_PERCENT_EQ] = ACTIONS(2882),
    [anon_sym_AMP_EQ] = ACTIONS(2882),
    [anon_sym_CARET_EQ] = ACTIONS(2882),
    [anon_sym_PIPE_EQ] = ACTIONS(2882),
    [anon_sym_LT_LT_EQ] = ACTIONS(2882),
    [anon_sym_GT_GT_EQ] = ACTIONS(2882),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2882),
    [anon_sym_is] = ACTIONS(2880),
    [anon_sym_DASH_GT] = ACTIONS(2882),
    [anon_sym_from] = ACTIONS(2880),
    [anon_sym_join] = ACTIONS(2880),
    [anon_sym_on] = ACTIONS(2880),
    [anon_sym_equals] = ACTIONS(2880),
    [anon_sym_into] = ACTIONS(2880),
    [anon_sym_let] = ACTIONS(2880),
    [anon_sym_orderby] = ACTIONS(2880),
    [anon_sym_ascending] = ACTIONS(2880),
    [anon_sym_descending] = ACTIONS(2880),
    [anon_sym_group] = ACTIONS(2880),
    [anon_sym_by] = ACTIONS(2880),
    [anon_sym_select] = ACTIONS(2880),
    [anon_sym_DOT_DOT] = ACTIONS(2882),
    [anon_sym_with] = ACTIONS(2880),
    [anon_sym_AMP_AMP] = ACTIONS(2882),
    [anon_sym_PIPE_PIPE] = ACTIONS(2882),
    [anon_sym_QMARK_QMARK] = ACTIONS(2880),
    [anon_sym_as] = ACTIONS(2880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2880),
    [anon_sym_nameof] = ACTIONS(2880),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1792] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2996),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_positional_pattern_clause] = STATE(1867),
    [sym_property_pattern_clause] = STATE(1903),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1792),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2782),
    [anon_sym_join] = ACTIONS(2782),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(2782),
    [anon_sym_orderby] = ACTIONS(2782),
    [anon_sym_ascending] = ACTIONS(2782),
    [anon_sym_descending] = ACTIONS(2782),
    [anon_sym_group] = ACTIONS(2782),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2782),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1793] = {
    [sym__preprocessor_call] = STATE(1793),
    [sym__identifier_token] = ACTIONS(2884),
    [anon_sym_alias] = ACTIONS(2884),
    [anon_sym_SEMI] = ACTIONS(2886),
    [anon_sym_global] = ACTIONS(2884),
    [anon_sym_EQ] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(2884),
    [anon_sym_COMMA] = ACTIONS(2886),
    [anon_sym_GT] = ACTIONS(2884),
    [anon_sym_DOT] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2886),
    [anon_sym_RBRACK] = ACTIONS(2886),
    [anon_sym_COLON] = ACTIONS(2886),
    [anon_sym_LPAREN] = ACTIONS(2886),
    [anon_sym_RPAREN] = ACTIONS(2886),
    [anon_sym_in] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(2886),
    [anon_sym_RBRACE] = ACTIONS(2886),
    [anon_sym_EQ_GT] = ACTIONS(2886),
    [anon_sym_where] = ACTIONS(2884),
    [anon_sym_QMARK] = ACTIONS(2884),
    [anon_sym_notnull] = ACTIONS(2884),
    [anon_sym_unmanaged] = ACTIONS(2884),
    [anon_sym_BANG] = ACTIONS(2884),
    [anon_sym_PLUS_PLUS] = ACTIONS(2886),
    [anon_sym_DASH_DASH] = ACTIONS(2886),
    [anon_sym_PLUS] = ACTIONS(2884),
    [anon_sym_DASH] = ACTIONS(2884),
    [anon_sym_STAR] = ACTIONS(2884),
    [anon_sym_SLASH] = ACTIONS(2884),
    [anon_sym_PERCENT] = ACTIONS(2884),
    [anon_sym_CARET] = ACTIONS(2884),
    [anon_sym_PIPE] = ACTIONS(2884),
    [anon_sym_AMP] = ACTIONS(2884),
    [anon_sym_LT_LT] = ACTIONS(2884),
    [anon_sym_GT_GT] = ACTIONS(2884),
    [anon_sym_EQ_EQ] = ACTIONS(2886),
    [anon_sym_BANG_EQ] = ACTIONS(2886),
    [anon_sym_GT_EQ] = ACTIONS(2886),
    [anon_sym_LT_EQ] = ACTIONS(2886),
    [anon_sym_get] = ACTIONS(2884),
    [anon_sym_set] = ACTIONS(2884),
    [anon_sym_add] = ACTIONS(2884),
    [anon_sym_remove] = ACTIONS(2884),
    [anon_sym_switch] = ACTIONS(2884),
    [anon_sym_and] = ACTIONS(2884),
    [anon_sym_or] = ACTIONS(2884),
    [sym_discard] = ACTIONS(2884),
    [anon_sym_when] = ACTIONS(2884),
    [anon_sym_yield] = ACTIONS(2884),
    [anon_sym_PLUS_EQ] = ACTIONS(2886),
    [anon_sym_DASH_EQ] = ACTIONS(2886),
    [anon_sym_STAR_EQ] = ACTIONS(2886),
    [anon_sym_SLASH_EQ] = ACTIONS(2886),
    [anon_sym_PERCENT_EQ] = ACTIONS(2886),
    [anon_sym_AMP_EQ] = ACTIONS(2886),
    [anon_sym_CARET_EQ] = ACTIONS(2886),
    [anon_sym_PIPE_EQ] = ACTIONS(2886),
    [anon_sym_LT_LT_EQ] = ACTIONS(2886),
    [anon_sym_GT_GT_EQ] = ACTIONS(2886),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2886),
    [anon_sym_is] = ACTIONS(2884),
    [anon_sym_DASH_GT] = ACTIONS(2886),
    [anon_sym_from] = ACTIONS(2884),
    [anon_sym_join] = ACTIONS(2884),
    [anon_sym_on] = ACTIONS(2884),
    [anon_sym_equals] = ACTIONS(2884),
    [anon_sym_into] = ACTIONS(2884),
    [anon_sym_let] = ACTIONS(2884),
    [anon_sym_orderby] = ACTIONS(2884),
    [anon_sym_ascending] = ACTIONS(2884),
    [anon_sym_descending] = ACTIONS(2884),
    [anon_sym_group] = ACTIONS(2884),
    [anon_sym_by] = ACTIONS(2884),
    [anon_sym_select] = ACTIONS(2884),
    [anon_sym_DOT_DOT] = ACTIONS(2886),
    [anon_sym_with] = ACTIONS(2884),
    [anon_sym_AMP_AMP] = ACTIONS(2886),
    [anon_sym_PIPE_PIPE] = ACTIONS(2886),
    [anon_sym_QMARK_QMARK] = ACTIONS(2884),
    [anon_sym_as] = ACTIONS(2884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2884),
    [anon_sym_nameof] = ACTIONS(2884),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1794] = {
    [sym__preprocessor_call] = STATE(1794),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_SEMI] = ACTIONS(2890),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2888),
    [anon_sym_LT] = ACTIONS(2888),
    [anon_sym_COMMA] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(2888),
    [anon_sym_DOT] = ACTIONS(2888),
    [anon_sym_LBRACK] = ACTIONS(2890),
    [anon_sym_RBRACK] = ACTIONS(2890),
    [anon_sym_COLON] = ACTIONS(2890),
    [anon_sym_LPAREN] = ACTIONS(2890),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [anon_sym_in] = ACTIONS(2888),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [anon_sym_EQ_GT] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2888),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2888),
    [anon_sym_PLUS_PLUS] = ACTIONS(2890),
    [anon_sym_DASH_DASH] = ACTIONS(2890),
    [anon_sym_PLUS] = ACTIONS(2888),
    [anon_sym_DASH] = ACTIONS(2888),
    [anon_sym_STAR] = ACTIONS(2888),
    [anon_sym_SLASH] = ACTIONS(2888),
    [anon_sym_PERCENT] = ACTIONS(2888),
    [anon_sym_CARET] = ACTIONS(2888),
    [anon_sym_PIPE] = ACTIONS(2888),
    [anon_sym_AMP] = ACTIONS(2888),
    [anon_sym_LT_LT] = ACTIONS(2888),
    [anon_sym_GT_GT] = ACTIONS(2888),
    [anon_sym_EQ_EQ] = ACTIONS(2890),
    [anon_sym_BANG_EQ] = ACTIONS(2890),
    [anon_sym_GT_EQ] = ACTIONS(2890),
    [anon_sym_LT_EQ] = ACTIONS(2890),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2888),
    [anon_sym_and] = ACTIONS(2888),
    [anon_sym_or] = ACTIONS(2888),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2890),
    [anon_sym_DASH_EQ] = ACTIONS(2890),
    [anon_sym_STAR_EQ] = ACTIONS(2890),
    [anon_sym_SLASH_EQ] = ACTIONS(2890),
    [anon_sym_PERCENT_EQ] = ACTIONS(2890),
    [anon_sym_AMP_EQ] = ACTIONS(2890),
    [anon_sym_CARET_EQ] = ACTIONS(2890),
    [anon_sym_PIPE_EQ] = ACTIONS(2890),
    [anon_sym_LT_LT_EQ] = ACTIONS(2890),
    [anon_sym_GT_GT_EQ] = ACTIONS(2890),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2890),
    [anon_sym_is] = ACTIONS(2888),
    [anon_sym_DASH_GT] = ACTIONS(2890),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2890),
    [anon_sym_with] = ACTIONS(2888),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_QMARK_QMARK] = ACTIONS(2888),
    [anon_sym_as] = ACTIONS(2888),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1795] = {
    [sym__preprocessor_call] = STATE(1795),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2892),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2894),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1796] = {
    [sym__preprocessor_call] = STATE(1796),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2894),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1797] = {
    [sym__preprocessor_call] = STATE(1797),
    [sym__identifier_token] = ACTIONS(2899),
    [anon_sym_alias] = ACTIONS(2899),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym_global] = ACTIONS(2899),
    [anon_sym_EQ] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_COMMA] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_DOT] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_RBRACK] = ACTIONS(2901),
    [anon_sym_COLON] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2901),
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2901),
    [anon_sym_EQ_GT] = ACTIONS(2901),
    [anon_sym_where] = ACTIONS(2899),
    [anon_sym_QMARK] = ACTIONS(2899),
    [anon_sym_notnull] = ACTIONS(2899),
    [anon_sym_unmanaged] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_SLASH] = ACTIONS(2899),
    [anon_sym_PERCENT] = ACTIONS(2899),
    [anon_sym_CARET] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2899),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_get] = ACTIONS(2899),
    [anon_sym_set] = ACTIONS(2899),
    [anon_sym_add] = ACTIONS(2899),
    [anon_sym_remove] = ACTIONS(2899),
    [anon_sym_switch] = ACTIONS(2899),
    [anon_sym_and] = ACTIONS(2899),
    [anon_sym_or] = ACTIONS(2899),
    [sym_discard] = ACTIONS(2899),
    [anon_sym_when] = ACTIONS(2899),
    [anon_sym_yield] = ACTIONS(2899),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_STAR_EQ] = ACTIONS(2901),
    [anon_sym_SLASH_EQ] = ACTIONS(2901),
    [anon_sym_PERCENT_EQ] = ACTIONS(2901),
    [anon_sym_AMP_EQ] = ACTIONS(2901),
    [anon_sym_CARET_EQ] = ACTIONS(2901),
    [anon_sym_PIPE_EQ] = ACTIONS(2901),
    [anon_sym_LT_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_GT_EQ] = ACTIONS(2901),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2901),
    [anon_sym_is] = ACTIONS(2899),
    [anon_sym_DASH_GT] = ACTIONS(2901),
    [anon_sym_from] = ACTIONS(2899),
    [anon_sym_join] = ACTIONS(2899),
    [anon_sym_on] = ACTIONS(2899),
    [anon_sym_equals] = ACTIONS(2899),
    [anon_sym_into] = ACTIONS(2899),
    [anon_sym_let] = ACTIONS(2899),
    [anon_sym_orderby] = ACTIONS(2899),
    [anon_sym_ascending] = ACTIONS(2899),
    [anon_sym_descending] = ACTIONS(2899),
    [anon_sym_group] = ACTIONS(2899),
    [anon_sym_by] = ACTIONS(2899),
    [anon_sym_select] = ACTIONS(2899),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_with] = ACTIONS(2899),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_QMARK_QMARK] = ACTIONS(2899),
    [anon_sym_as] = ACTIONS(2899),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2899),
    [anon_sym_nameof] = ACTIONS(2899),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1798] = {
    [sym__preprocessor_call] = STATE(1798),
    [sym__identifier_token] = ACTIONS(2903),
    [anon_sym_alias] = ACTIONS(2903),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_global] = ACTIONS(2903),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_DOT] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_RBRACK] = ACTIONS(2905),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_in] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(2905),
    [anon_sym_where] = ACTIONS(2903),
    [anon_sym_QMARK] = ACTIONS(2903),
    [anon_sym_notnull] = ACTIONS(2903),
    [anon_sym_unmanaged] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_SLASH] = ACTIONS(2903),
    [anon_sym_PERCENT] = ACTIONS(2903),
    [anon_sym_CARET] = ACTIONS(2903),
    [anon_sym_PIPE] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_LT_LT] = ACTIONS(2903),
    [anon_sym_GT_GT] = ACTIONS(2903),
    [anon_sym_EQ_EQ] = ACTIONS(2905),
    [anon_sym_BANG_EQ] = ACTIONS(2905),
    [anon_sym_GT_EQ] = ACTIONS(2905),
    [anon_sym_LT_EQ] = ACTIONS(2905),
    [anon_sym_get] = ACTIONS(2903),
    [anon_sym_set] = ACTIONS(2903),
    [anon_sym_add] = ACTIONS(2903),
    [anon_sym_remove] = ACTIONS(2903),
    [anon_sym_switch] = ACTIONS(2903),
    [anon_sym_and] = ACTIONS(2903),
    [anon_sym_or] = ACTIONS(2903),
    [sym_discard] = ACTIONS(2903),
    [anon_sym_when] = ACTIONS(2903),
    [anon_sym_yield] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2905),
    [anon_sym_DASH_EQ] = ACTIONS(2905),
    [anon_sym_STAR_EQ] = ACTIONS(2905),
    [anon_sym_SLASH_EQ] = ACTIONS(2905),
    [anon_sym_PERCENT_EQ] = ACTIONS(2905),
    [anon_sym_AMP_EQ] = ACTIONS(2905),
    [anon_sym_CARET_EQ] = ACTIONS(2905),
    [anon_sym_PIPE_EQ] = ACTIONS(2905),
    [anon_sym_LT_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_GT_EQ] = ACTIONS(2905),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2905),
    [anon_sym_is] = ACTIONS(2903),
    [anon_sym_DASH_GT] = ACTIONS(2905),
    [anon_sym_from] = ACTIONS(2903),
    [anon_sym_join] = ACTIONS(2903),
    [anon_sym_on] = ACTIONS(2903),
    [anon_sym_equals] = ACTIONS(2903),
    [anon_sym_into] = ACTIONS(2903),
    [anon_sym_let] = ACTIONS(2903),
    [anon_sym_orderby] = ACTIONS(2903),
    [anon_sym_ascending] = ACTIONS(2903),
    [anon_sym_descending] = ACTIONS(2903),
    [anon_sym_group] = ACTIONS(2903),
    [anon_sym_by] = ACTIONS(2903),
    [anon_sym_select] = ACTIONS(2903),
    [anon_sym_DOT_DOT] = ACTIONS(2905),
    [anon_sym_with] = ACTIONS(2903),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_QMARK_QMARK] = ACTIONS(2903),
    [anon_sym_as] = ACTIONS(2903),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2903),
    [anon_sym_nameof] = ACTIONS(2903),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1799] = {
    [sym__preprocessor_call] = STATE(1799),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(2907),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1800] = {
    [sym__preprocessor_call] = STATE(1800),
    [sym__identifier_token] = ACTIONS(2911),
    [anon_sym_alias] = ACTIONS(2911),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_global] = ACTIONS(2911),
    [anon_sym_EQ] = ACTIONS(2911),
    [anon_sym_LT] = ACTIONS(2911),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2911),
    [anon_sym_DOT] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_RBRACK] = ACTIONS(2913),
    [anon_sym_COLON] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_in] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_EQ_GT] = ACTIONS(2913),
    [anon_sym_where] = ACTIONS(2911),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_notnull] = ACTIONS(2911),
    [anon_sym_unmanaged] = ACTIONS(2911),
    [anon_sym_BANG] = ACTIONS(2911),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2911),
    [anon_sym_SLASH] = ACTIONS(2911),
    [anon_sym_PERCENT] = ACTIONS(2911),
    [anon_sym_CARET] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2911),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_LT_LT] = ACTIONS(2911),
    [anon_sym_GT_GT] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_get] = ACTIONS(2911),
    [anon_sym_set] = ACTIONS(2911),
    [anon_sym_add] = ACTIONS(2911),
    [anon_sym_remove] = ACTIONS(2911),
    [anon_sym_switch] = ACTIONS(2911),
    [anon_sym_and] = ACTIONS(2911),
    [anon_sym_or] = ACTIONS(2911),
    [sym_discard] = ACTIONS(2911),
    [anon_sym_when] = ACTIONS(2911),
    [anon_sym_yield] = ACTIONS(2911),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2913),
    [anon_sym_is] = ACTIONS(2911),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [anon_sym_from] = ACTIONS(2911),
    [anon_sym_join] = ACTIONS(2911),
    [anon_sym_on] = ACTIONS(2911),
    [anon_sym_equals] = ACTIONS(2911),
    [anon_sym_into] = ACTIONS(2911),
    [anon_sym_let] = ACTIONS(2911),
    [anon_sym_orderby] = ACTIONS(2911),
    [anon_sym_ascending] = ACTIONS(2911),
    [anon_sym_descending] = ACTIONS(2911),
    [anon_sym_group] = ACTIONS(2911),
    [anon_sym_by] = ACTIONS(2911),
    [anon_sym_select] = ACTIONS(2911),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_with] = ACTIONS(2911),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_QMARK_QMARK] = ACTIONS(2911),
    [anon_sym_as] = ACTIONS(2911),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2911),
    [anon_sym_nameof] = ACTIONS(2911),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1801] = {
    [sym__preprocessor_call] = STATE(1801),
    [sym__identifier_token] = ACTIONS(2915),
    [anon_sym_alias] = ACTIONS(2915),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_global] = ACTIONS(2915),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2917),
    [anon_sym_RBRACK] = ACTIONS(2917),
    [anon_sym_COLON] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_EQ_GT] = ACTIONS(2917),
    [anon_sym_where] = ACTIONS(2915),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_notnull] = ACTIONS(2915),
    [anon_sym_unmanaged] = ACTIONS(2915),
    [anon_sym_BANG] = ACTIONS(2915),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_get] = ACTIONS(2915),
    [anon_sym_set] = ACTIONS(2915),
    [anon_sym_add] = ACTIONS(2915),
    [anon_sym_remove] = ACTIONS(2915),
    [anon_sym_switch] = ACTIONS(2915),
    [anon_sym_and] = ACTIONS(2915),
    [anon_sym_or] = ACTIONS(2915),
    [sym_discard] = ACTIONS(2915),
    [anon_sym_when] = ACTIONS(2915),
    [anon_sym_yield] = ACTIONS(2915),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2917),
    [anon_sym_is] = ACTIONS(2915),
    [anon_sym_DASH_GT] = ACTIONS(2917),
    [anon_sym_from] = ACTIONS(2915),
    [anon_sym_join] = ACTIONS(2915),
    [anon_sym_on] = ACTIONS(2915),
    [anon_sym_equals] = ACTIONS(2915),
    [anon_sym_into] = ACTIONS(2915),
    [anon_sym_let] = ACTIONS(2915),
    [anon_sym_orderby] = ACTIONS(2915),
    [anon_sym_ascending] = ACTIONS(2915),
    [anon_sym_descending] = ACTIONS(2915),
    [anon_sym_group] = ACTIONS(2915),
    [anon_sym_by] = ACTIONS(2915),
    [anon_sym_select] = ACTIONS(2915),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_with] = ACTIONS(2915),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_QMARK_QMARK] = ACTIONS(2915),
    [anon_sym_as] = ACTIONS(2915),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2915),
    [anon_sym_nameof] = ACTIONS(2915),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1802] = {
    [sym__preprocessor_call] = STATE(1802),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_RPAREN] = ACTIONS(2919),
    [anon_sym_in] = ACTIONS(2930),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_EQ_GT] = ACTIONS(2919),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1803] = {
    [sym__preprocessor_call] = STATE(1803),
    [sym__identifier_token] = ACTIONS(2933),
    [anon_sym_alias] = ACTIONS(2933),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_global] = ACTIONS(2933),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_RBRACK] = ACTIONS(2935),
    [anon_sym_COLON] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_in] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_EQ_GT] = ACTIONS(2935),
    [anon_sym_where] = ACTIONS(2933),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_notnull] = ACTIONS(2933),
    [anon_sym_unmanaged] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2933),
    [anon_sym_CARET] = ACTIONS(2933),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_get] = ACTIONS(2933),
    [anon_sym_set] = ACTIONS(2933),
    [anon_sym_add] = ACTIONS(2933),
    [anon_sym_remove] = ACTIONS(2933),
    [anon_sym_switch] = ACTIONS(2933),
    [anon_sym_and] = ACTIONS(2933),
    [anon_sym_or] = ACTIONS(2933),
    [sym_discard] = ACTIONS(2933),
    [anon_sym_when] = ACTIONS(2933),
    [anon_sym_yield] = ACTIONS(2933),
    [anon_sym_PLUS_EQ] = ACTIONS(2935),
    [anon_sym_DASH_EQ] = ACTIONS(2935),
    [anon_sym_STAR_EQ] = ACTIONS(2935),
    [anon_sym_SLASH_EQ] = ACTIONS(2935),
    [anon_sym_PERCENT_EQ] = ACTIONS(2935),
    [anon_sym_AMP_EQ] = ACTIONS(2935),
    [anon_sym_CARET_EQ] = ACTIONS(2935),
    [anon_sym_PIPE_EQ] = ACTIONS(2935),
    [anon_sym_LT_LT_EQ] = ACTIONS(2935),
    [anon_sym_GT_GT_EQ] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2933),
    [anon_sym_DASH_GT] = ACTIONS(2935),
    [anon_sym_from] = ACTIONS(2933),
    [anon_sym_join] = ACTIONS(2933),
    [anon_sym_on] = ACTIONS(2933),
    [anon_sym_equals] = ACTIONS(2933),
    [anon_sym_into] = ACTIONS(2933),
    [anon_sym_let] = ACTIONS(2933),
    [anon_sym_orderby] = ACTIONS(2933),
    [anon_sym_ascending] = ACTIONS(2933),
    [anon_sym_descending] = ACTIONS(2933),
    [anon_sym_group] = ACTIONS(2933),
    [anon_sym_by] = ACTIONS(2933),
    [anon_sym_select] = ACTIONS(2933),
    [anon_sym_DOT_DOT] = ACTIONS(2935),
    [anon_sym_with] = ACTIONS(2933),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2933),
    [anon_sym_as] = ACTIONS(2933),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2933),
    [anon_sym_nameof] = ACTIONS(2933),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1804] = {
    [sym__preprocessor_call] = STATE(1804),
    [sym__identifier_token] = ACTIONS(2937),
    [anon_sym_alias] = ACTIONS(2937),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_global] = ACTIONS(2937),
    [anon_sym_EQ] = ACTIONS(2937),
    [anon_sym_LT] = ACTIONS(2937),
    [anon_sym_COMMA] = ACTIONS(2939),
    [anon_sym_GT] = ACTIONS(2937),
    [anon_sym_DOT] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_RBRACK] = ACTIONS(2939),
    [anon_sym_COLON] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_RPAREN] = ACTIONS(2939),
    [anon_sym_in] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(2939),
    [anon_sym_where] = ACTIONS(2937),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_notnull] = ACTIONS(2937),
    [anon_sym_unmanaged] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_SLASH] = ACTIONS(2937),
    [anon_sym_PERCENT] = ACTIONS(2937),
    [anon_sym_CARET] = ACTIONS(2937),
    [anon_sym_PIPE] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_LT_LT] = ACTIONS(2937),
    [anon_sym_GT_GT] = ACTIONS(2937),
    [anon_sym_EQ_EQ] = ACTIONS(2939),
    [anon_sym_BANG_EQ] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(2939),
    [anon_sym_LT_EQ] = ACTIONS(2939),
    [anon_sym_get] = ACTIONS(2937),
    [anon_sym_set] = ACTIONS(2937),
    [anon_sym_add] = ACTIONS(2937),
    [anon_sym_remove] = ACTIONS(2937),
    [anon_sym_switch] = ACTIONS(2937),
    [anon_sym_and] = ACTIONS(2937),
    [anon_sym_or] = ACTIONS(2937),
    [sym_discard] = ACTIONS(2937),
    [anon_sym_when] = ACTIONS(2937),
    [anon_sym_yield] = ACTIONS(2937),
    [anon_sym_PLUS_EQ] = ACTIONS(2939),
    [anon_sym_DASH_EQ] = ACTIONS(2939),
    [anon_sym_STAR_EQ] = ACTIONS(2939),
    [anon_sym_SLASH_EQ] = ACTIONS(2939),
    [anon_sym_PERCENT_EQ] = ACTIONS(2939),
    [anon_sym_AMP_EQ] = ACTIONS(2939),
    [anon_sym_CARET_EQ] = ACTIONS(2939),
    [anon_sym_PIPE_EQ] = ACTIONS(2939),
    [anon_sym_LT_LT_EQ] = ACTIONS(2939),
    [anon_sym_GT_GT_EQ] = ACTIONS(2939),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2939),
    [anon_sym_is] = ACTIONS(2937),
    [anon_sym_DASH_GT] = ACTIONS(2939),
    [anon_sym_from] = ACTIONS(2937),
    [anon_sym_join] = ACTIONS(2937),
    [anon_sym_on] = ACTIONS(2937),
    [anon_sym_equals] = ACTIONS(2937),
    [anon_sym_into] = ACTIONS(2937),
    [anon_sym_let] = ACTIONS(2937),
    [anon_sym_orderby] = ACTIONS(2937),
    [anon_sym_ascending] = ACTIONS(2937),
    [anon_sym_descending] = ACTIONS(2937),
    [anon_sym_group] = ACTIONS(2937),
    [anon_sym_by] = ACTIONS(2937),
    [anon_sym_select] = ACTIONS(2937),
    [anon_sym_DOT_DOT] = ACTIONS(2939),
    [anon_sym_with] = ACTIONS(2937),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_PIPE_PIPE] = ACTIONS(2939),
    [anon_sym_QMARK_QMARK] = ACTIONS(2937),
    [anon_sym_as] = ACTIONS(2937),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2937),
    [anon_sym_nameof] = ACTIONS(2937),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1805] = {
    [sym__preprocessor_call] = STATE(1805),
    [sym__identifier_token] = ACTIONS(2941),
    [anon_sym_alias] = ACTIONS(2941),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_global] = ACTIONS(2941),
    [anon_sym_EQ] = ACTIONS(2941),
    [anon_sym_LT] = ACTIONS(2941),
    [anon_sym_COMMA] = ACTIONS(2943),
    [anon_sym_GT] = ACTIONS(2941),
    [anon_sym_DOT] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_RBRACK] = ACTIONS(2943),
    [anon_sym_COLON] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_in] = ACTIONS(2941),
    [anon_sym_LBRACE] = ACTIONS(2943),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_EQ_GT] = ACTIONS(2943),
    [anon_sym_where] = ACTIONS(2941),
    [anon_sym_QMARK] = ACTIONS(2941),
    [anon_sym_notnull] = ACTIONS(2941),
    [anon_sym_unmanaged] = ACTIONS(2941),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_SLASH] = ACTIONS(2941),
    [anon_sym_PERCENT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym_LT_LT] = ACTIONS(2941),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_EQ_EQ] = ACTIONS(2943),
    [anon_sym_BANG_EQ] = ACTIONS(2943),
    [anon_sym_GT_EQ] = ACTIONS(2943),
    [anon_sym_LT_EQ] = ACTIONS(2943),
    [anon_sym_get] = ACTIONS(2941),
    [anon_sym_set] = ACTIONS(2941),
    [anon_sym_add] = ACTIONS(2941),
    [anon_sym_remove] = ACTIONS(2941),
    [anon_sym_switch] = ACTIONS(2941),
    [anon_sym_and] = ACTIONS(2941),
    [anon_sym_or] = ACTIONS(2941),
    [sym_discard] = ACTIONS(2941),
    [anon_sym_when] = ACTIONS(2941),
    [anon_sym_yield] = ACTIONS(2941),
    [anon_sym_PLUS_EQ] = ACTIONS(2943),
    [anon_sym_DASH_EQ] = ACTIONS(2943),
    [anon_sym_STAR_EQ] = ACTIONS(2943),
    [anon_sym_SLASH_EQ] = ACTIONS(2943),
    [anon_sym_PERCENT_EQ] = ACTIONS(2943),
    [anon_sym_AMP_EQ] = ACTIONS(2943),
    [anon_sym_CARET_EQ] = ACTIONS(2943),
    [anon_sym_PIPE_EQ] = ACTIONS(2943),
    [anon_sym_LT_LT_EQ] = ACTIONS(2943),
    [anon_sym_GT_GT_EQ] = ACTIONS(2943),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2943),
    [anon_sym_is] = ACTIONS(2941),
    [anon_sym_DASH_GT] = ACTIONS(2943),
    [anon_sym_from] = ACTIONS(2941),
    [anon_sym_join] = ACTIONS(2941),
    [anon_sym_on] = ACTIONS(2941),
    [anon_sym_equals] = ACTIONS(2941),
    [anon_sym_into] = ACTIONS(2941),
    [anon_sym_let] = ACTIONS(2941),
    [anon_sym_orderby] = ACTIONS(2941),
    [anon_sym_ascending] = ACTIONS(2941),
    [anon_sym_descending] = ACTIONS(2941),
    [anon_sym_group] = ACTIONS(2941),
    [anon_sym_by] = ACTIONS(2941),
    [anon_sym_select] = ACTIONS(2941),
    [anon_sym_DOT_DOT] = ACTIONS(2943),
    [anon_sym_with] = ACTIONS(2941),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2943),
    [anon_sym_QMARK_QMARK] = ACTIONS(2941),
    [anon_sym_as] = ACTIONS(2941),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2941),
    [anon_sym_nameof] = ACTIONS(2941),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1806] = {
    [sym__preprocessor_call] = STATE(1806),
    [sym__identifier_token] = ACTIONS(2945),
    [anon_sym_alias] = ACTIONS(2945),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_global] = ACTIONS(2945),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_RBRACK] = ACTIONS(2947),
    [anon_sym_COLON] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_where] = ACTIONS(2945),
    [anon_sym_QMARK] = ACTIONS(2945),
    [anon_sym_notnull] = ACTIONS(2945),
    [anon_sym_unmanaged] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2945),
    [anon_sym_PERCENT] = ACTIONS(2945),
    [anon_sym_CARET] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_get] = ACTIONS(2945),
    [anon_sym_set] = ACTIONS(2945),
    [anon_sym_add] = ACTIONS(2945),
    [anon_sym_remove] = ACTIONS(2945),
    [anon_sym_switch] = ACTIONS(2945),
    [anon_sym_and] = ACTIONS(2945),
    [anon_sym_or] = ACTIONS(2945),
    [sym_discard] = ACTIONS(2945),
    [anon_sym_when] = ACTIONS(2945),
    [anon_sym_yield] = ACTIONS(2945),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
    [anon_sym_STAR_EQ] = ACTIONS(2947),
    [anon_sym_SLASH_EQ] = ACTIONS(2947),
    [anon_sym_PERCENT_EQ] = ACTIONS(2947),
    [anon_sym_AMP_EQ] = ACTIONS(2947),
    [anon_sym_CARET_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_LT_LT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2947),
    [anon_sym_is] = ACTIONS(2945),
    [anon_sym_DASH_GT] = ACTIONS(2947),
    [anon_sym_from] = ACTIONS(2945),
    [anon_sym_join] = ACTIONS(2945),
    [anon_sym_on] = ACTIONS(2945),
    [anon_sym_equals] = ACTIONS(2945),
    [anon_sym_into] = ACTIONS(2945),
    [anon_sym_let] = ACTIONS(2945),
    [anon_sym_orderby] = ACTIONS(2945),
    [anon_sym_ascending] = ACTIONS(2945),
    [anon_sym_descending] = ACTIONS(2945),
    [anon_sym_group] = ACTIONS(2945),
    [anon_sym_by] = ACTIONS(2945),
    [anon_sym_select] = ACTIONS(2945),
    [anon_sym_DOT_DOT] = ACTIONS(2947),
    [anon_sym_with] = ACTIONS(2945),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_QMARK_QMARK] = ACTIONS(2945),
    [anon_sym_as] = ACTIONS(2945),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2945),
    [anon_sym_nameof] = ACTIONS(2945),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1807] = {
    [sym__preprocessor_call] = STATE(1807),
    [sym__identifier_token] = ACTIONS(2949),
    [anon_sym_alias] = ACTIONS(2949),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_global] = ACTIONS(2949),
    [anon_sym_EQ] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_RBRACK] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_EQ_GT] = ACTIONS(2951),
    [anon_sym_where] = ACTIONS(2949),
    [anon_sym_QMARK] = ACTIONS(2949),
    [anon_sym_notnull] = ACTIONS(2949),
    [anon_sym_unmanaged] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2949),
    [anon_sym_CARET] = ACTIONS(2949),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_GT_GT] = ACTIONS(2949),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_get] = ACTIONS(2949),
    [anon_sym_set] = ACTIONS(2949),
    [anon_sym_add] = ACTIONS(2949),
    [anon_sym_remove] = ACTIONS(2949),
    [anon_sym_switch] = ACTIONS(2949),
    [anon_sym_and] = ACTIONS(2949),
    [anon_sym_or] = ACTIONS(2949),
    [sym_discard] = ACTIONS(2949),
    [anon_sym_when] = ACTIONS(2949),
    [anon_sym_yield] = ACTIONS(2949),
    [anon_sym_PLUS_EQ] = ACTIONS(2951),
    [anon_sym_DASH_EQ] = ACTIONS(2951),
    [anon_sym_STAR_EQ] = ACTIONS(2951),
    [anon_sym_SLASH_EQ] = ACTIONS(2951),
    [anon_sym_PERCENT_EQ] = ACTIONS(2951),
    [anon_sym_AMP_EQ] = ACTIONS(2951),
    [anon_sym_CARET_EQ] = ACTIONS(2951),
    [anon_sym_PIPE_EQ] = ACTIONS(2951),
    [anon_sym_LT_LT_EQ] = ACTIONS(2951),
    [anon_sym_GT_GT_EQ] = ACTIONS(2951),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2949),
    [anon_sym_DASH_GT] = ACTIONS(2951),
    [anon_sym_from] = ACTIONS(2949),
    [anon_sym_join] = ACTIONS(2949),
    [anon_sym_on] = ACTIONS(2949),
    [anon_sym_equals] = ACTIONS(2949),
    [anon_sym_into] = ACTIONS(2949),
    [anon_sym_let] = ACTIONS(2949),
    [anon_sym_orderby] = ACTIONS(2949),
    [anon_sym_ascending] = ACTIONS(2949),
    [anon_sym_descending] = ACTIONS(2949),
    [anon_sym_group] = ACTIONS(2949),
    [anon_sym_by] = ACTIONS(2949),
    [anon_sym_select] = ACTIONS(2949),
    [anon_sym_DOT_DOT] = ACTIONS(2951),
    [anon_sym_with] = ACTIONS(2949),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2951),
    [anon_sym_QMARK_QMARK] = ACTIONS(2949),
    [anon_sym_as] = ACTIONS(2949),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2949),
    [anon_sym_nameof] = ACTIONS(2949),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1808] = {
    [sym__preprocessor_call] = STATE(1808),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2852),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2852),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_RBRACK] = ACTIONS(2852),
    [anon_sym_COLON] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_RPAREN] = ACTIONS(2852),
    [anon_sym_in] = ACTIONS(2855),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_EQ_GT] = ACTIONS(2852),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1809] = {
    [sym__preprocessor_call] = STATE(1809),
    [sym__identifier_token] = ACTIONS(2953),
    [anon_sym_alias] = ACTIONS(2953),
    [anon_sym_SEMI] = ACTIONS(2955),
    [anon_sym_global] = ACTIONS(2953),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_COMMA] = ACTIONS(2955),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_DOT] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_RBRACK] = ACTIONS(2955),
    [anon_sym_COLON] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_RPAREN] = ACTIONS(2955),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [anon_sym_EQ_GT] = ACTIONS(2955),
    [anon_sym_where] = ACTIONS(2953),
    [anon_sym_QMARK] = ACTIONS(2953),
    [anon_sym_notnull] = ACTIONS(2953),
    [anon_sym_unmanaged] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_SLASH] = ACTIONS(2953),
    [anon_sym_PERCENT] = ACTIONS(2953),
    [anon_sym_CARET] = ACTIONS(2953),
    [anon_sym_PIPE] = ACTIONS(2953),
    [anon_sym_AMP] = ACTIONS(2953),
    [anon_sym_LT_LT] = ACTIONS(2953),
    [anon_sym_GT_GT] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2955),
    [anon_sym_BANG_EQ] = ACTIONS(2955),
    [anon_sym_GT_EQ] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2955),
    [anon_sym_get] = ACTIONS(2953),
    [anon_sym_set] = ACTIONS(2953),
    [anon_sym_add] = ACTIONS(2953),
    [anon_sym_remove] = ACTIONS(2953),
    [anon_sym_switch] = ACTIONS(2953),
    [anon_sym_and] = ACTIONS(2953),
    [anon_sym_or] = ACTIONS(2953),
    [sym_discard] = ACTIONS(2953),
    [anon_sym_when] = ACTIONS(2953),
    [anon_sym_yield] = ACTIONS(2953),
    [anon_sym_PLUS_EQ] = ACTIONS(2955),
    [anon_sym_DASH_EQ] = ACTIONS(2955),
    [anon_sym_STAR_EQ] = ACTIONS(2955),
    [anon_sym_SLASH_EQ] = ACTIONS(2955),
    [anon_sym_PERCENT_EQ] = ACTIONS(2955),
    [anon_sym_AMP_EQ] = ACTIONS(2955),
    [anon_sym_CARET_EQ] = ACTIONS(2955),
    [anon_sym_PIPE_EQ] = ACTIONS(2955),
    [anon_sym_LT_LT_EQ] = ACTIONS(2955),
    [anon_sym_GT_GT_EQ] = ACTIONS(2955),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2955),
    [anon_sym_is] = ACTIONS(2953),
    [anon_sym_DASH_GT] = ACTIONS(2955),
    [anon_sym_from] = ACTIONS(2953),
    [anon_sym_join] = ACTIONS(2953),
    [anon_sym_on] = ACTIONS(2953),
    [anon_sym_equals] = ACTIONS(2953),
    [anon_sym_into] = ACTIONS(2953),
    [anon_sym_let] = ACTIONS(2953),
    [anon_sym_orderby] = ACTIONS(2953),
    [anon_sym_ascending] = ACTIONS(2953),
    [anon_sym_descending] = ACTIONS(2953),
    [anon_sym_group] = ACTIONS(2953),
    [anon_sym_by] = ACTIONS(2953),
    [anon_sym_select] = ACTIONS(2953),
    [anon_sym_DOT_DOT] = ACTIONS(2955),
    [anon_sym_with] = ACTIONS(2953),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_PIPE_PIPE] = ACTIONS(2955),
    [anon_sym_QMARK_QMARK] = ACTIONS(2953),
    [anon_sym_as] = ACTIONS(2953),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2953),
    [anon_sym_nameof] = ACTIONS(2953),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1810] = {
    [sym__preprocessor_call] = STATE(1810),
    [sym__identifier_token] = ACTIONS(2957),
    [anon_sym_alias] = ACTIONS(2957),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_global] = ACTIONS(2957),
    [anon_sym_EQ] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_RBRACK] = ACTIONS(2959),
    [anon_sym_COLON] = ACTIONS(2959),
    [anon_sym_LPAREN] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_in] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_EQ_GT] = ACTIONS(2959),
    [anon_sym_where] = ACTIONS(2957),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_notnull] = ACTIONS(2957),
    [anon_sym_unmanaged] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2957),
    [anon_sym_CARET] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_LT_LT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2957),
    [anon_sym_EQ_EQ] = ACTIONS(2959),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2959),
    [anon_sym_get] = ACTIONS(2957),
    [anon_sym_set] = ACTIONS(2957),
    [anon_sym_add] = ACTIONS(2957),
    [anon_sym_remove] = ACTIONS(2957),
    [anon_sym_switch] = ACTIONS(2957),
    [anon_sym_and] = ACTIONS(2957),
    [anon_sym_or] = ACTIONS(2957),
    [sym_discard] = ACTIONS(2957),
    [anon_sym_when] = ACTIONS(2957),
    [anon_sym_yield] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2959),
    [anon_sym_DASH_EQ] = ACTIONS(2959),
    [anon_sym_STAR_EQ] = ACTIONS(2959),
    [anon_sym_SLASH_EQ] = ACTIONS(2959),
    [anon_sym_PERCENT_EQ] = ACTIONS(2959),
    [anon_sym_AMP_EQ] = ACTIONS(2959),
    [anon_sym_CARET_EQ] = ACTIONS(2959),
    [anon_sym_PIPE_EQ] = ACTIONS(2959),
    [anon_sym_LT_LT_EQ] = ACTIONS(2959),
    [anon_sym_GT_GT_EQ] = ACTIONS(2959),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2959),
    [anon_sym_is] = ACTIONS(2957),
    [anon_sym_DASH_GT] = ACTIONS(2959),
    [anon_sym_from] = ACTIONS(2957),
    [anon_sym_join] = ACTIONS(2957),
    [anon_sym_on] = ACTIONS(2957),
    [anon_sym_equals] = ACTIONS(2957),
    [anon_sym_into] = ACTIONS(2957),
    [anon_sym_let] = ACTIONS(2957),
    [anon_sym_orderby] = ACTIONS(2957),
    [anon_sym_ascending] = ACTIONS(2957),
    [anon_sym_descending] = ACTIONS(2957),
    [anon_sym_group] = ACTIONS(2957),
    [anon_sym_by] = ACTIONS(2957),
    [anon_sym_select] = ACTIONS(2957),
    [anon_sym_DOT_DOT] = ACTIONS(2959),
    [anon_sym_with] = ACTIONS(2957),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_QMARK_QMARK] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2957),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2957),
    [anon_sym_nameof] = ACTIONS(2957),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1811] = {
    [sym__preprocessor_call] = STATE(1811),
    [sym__identifier_token] = ACTIONS(2961),
    [anon_sym_alias] = ACTIONS(2961),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_global] = ACTIONS(2961),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_RBRACK] = ACTIONS(2963),
    [anon_sym_COLON] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_in] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_EQ_GT] = ACTIONS(2963),
    [anon_sym_where] = ACTIONS(2961),
    [anon_sym_QMARK] = ACTIONS(2961),
    [anon_sym_notnull] = ACTIONS(2961),
    [anon_sym_unmanaged] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2963),
    [anon_sym_DASH_DASH] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_STAR] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2963),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2963),
    [anon_sym_get] = ACTIONS(2961),
    [anon_sym_set] = ACTIONS(2961),
    [anon_sym_add] = ACTIONS(2961),
    [anon_sym_remove] = ACTIONS(2961),
    [anon_sym_switch] = ACTIONS(2961),
    [anon_sym_and] = ACTIONS(2961),
    [anon_sym_or] = ACTIONS(2961),
    [sym_discard] = ACTIONS(2961),
    [anon_sym_when] = ACTIONS(2961),
    [anon_sym_yield] = ACTIONS(2961),
    [anon_sym_PLUS_EQ] = ACTIONS(2963),
    [anon_sym_DASH_EQ] = ACTIONS(2963),
    [anon_sym_STAR_EQ] = ACTIONS(2963),
    [anon_sym_SLASH_EQ] = ACTIONS(2963),
    [anon_sym_PERCENT_EQ] = ACTIONS(2963),
    [anon_sym_AMP_EQ] = ACTIONS(2963),
    [anon_sym_CARET_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_LT_LT_EQ] = ACTIONS(2963),
    [anon_sym_GT_GT_EQ] = ACTIONS(2963),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2963),
    [anon_sym_is] = ACTIONS(2961),
    [anon_sym_DASH_GT] = ACTIONS(2963),
    [anon_sym_from] = ACTIONS(2961),
    [anon_sym_join] = ACTIONS(2961),
    [anon_sym_on] = ACTIONS(2961),
    [anon_sym_equals] = ACTIONS(2961),
    [anon_sym_into] = ACTIONS(2961),
    [anon_sym_let] = ACTIONS(2961),
    [anon_sym_orderby] = ACTIONS(2961),
    [anon_sym_ascending] = ACTIONS(2961),
    [anon_sym_descending] = ACTIONS(2961),
    [anon_sym_group] = ACTIONS(2961),
    [anon_sym_by] = ACTIONS(2961),
    [anon_sym_select] = ACTIONS(2961),
    [anon_sym_DOT_DOT] = ACTIONS(2963),
    [anon_sym_with] = ACTIONS(2961),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2963),
    [anon_sym_QMARK_QMARK] = ACTIONS(2961),
    [anon_sym_as] = ACTIONS(2961),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2961),
    [anon_sym_nameof] = ACTIONS(2961),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1812] = {
    [sym__preprocessor_call] = STATE(1812),
    [sym__identifier_token] = ACTIONS(2965),
    [anon_sym_alias] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_global] = ACTIONS(2965),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_RBRACK] = ACTIONS(2967),
    [anon_sym_COLON] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2965),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2969),
    [anon_sym_where] = ACTIONS(2965),
    [anon_sym_QMARK] = ACTIONS(2965),
    [anon_sym_notnull] = ACTIONS(2965),
    [anon_sym_unmanaged] = ACTIONS(2965),
    [anon_sym_BANG] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_LT_LT] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2965),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_get] = ACTIONS(2965),
    [anon_sym_set] = ACTIONS(2965),
    [anon_sym_add] = ACTIONS(2965),
    [anon_sym_remove] = ACTIONS(2965),
    [anon_sym_switch] = ACTIONS(2965),
    [anon_sym_and] = ACTIONS(2965),
    [anon_sym_or] = ACTIONS(2965),
    [sym_discard] = ACTIONS(2965),
    [anon_sym_when] = ACTIONS(2965),
    [anon_sym_yield] = ACTIONS(2965),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2965),
    [anon_sym_DASH_GT] = ACTIONS(2967),
    [anon_sym_from] = ACTIONS(2965),
    [anon_sym_join] = ACTIONS(2965),
    [anon_sym_on] = ACTIONS(2965),
    [anon_sym_equals] = ACTIONS(2965),
    [anon_sym_into] = ACTIONS(2965),
    [anon_sym_let] = ACTIONS(2965),
    [anon_sym_orderby] = ACTIONS(2965),
    [anon_sym_ascending] = ACTIONS(2965),
    [anon_sym_descending] = ACTIONS(2965),
    [anon_sym_group] = ACTIONS(2965),
    [anon_sym_by] = ACTIONS(2965),
    [anon_sym_select] = ACTIONS(2965),
    [anon_sym_DOT_DOT] = ACTIONS(2967),
    [anon_sym_with] = ACTIONS(2965),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_QMARK_QMARK] = ACTIONS(2965),
    [anon_sym_as] = ACTIONS(2965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2965),
    [anon_sym_nameof] = ACTIONS(2965),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1813] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2996),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_positional_pattern_clause] = STATE(1867),
    [sym_property_pattern_clause] = STATE(1903),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1813),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_COMMA] = ACTIONS(2794),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2873),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2873),
    [anon_sym_join] = ACTIONS(2873),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(2873),
    [anon_sym_orderby] = ACTIONS(2873),
    [anon_sym_ascending] = ACTIONS(2873),
    [anon_sym_descending] = ACTIONS(2873),
    [anon_sym_group] = ACTIONS(2873),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2873),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1814] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1864),
    [sym_property_pattern_clause] = STATE(1902),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1814),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_in] = ACTIONS(2782),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(801),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1815] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2996),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_positional_pattern_clause] = STATE(1862),
    [sym_property_pattern_clause] = STATE(1908),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1815),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_COMMA] = ACTIONS(2780),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2782),
    [anon_sym_join] = ACTIONS(2782),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2782),
    [anon_sym_orderby] = ACTIONS(2782),
    [anon_sym_ascending] = ACTIONS(2782),
    [anon_sym_descending] = ACTIONS(2782),
    [anon_sym_group] = ACTIONS(2782),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2782),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1816] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1864),
    [sym_property_pattern_clause] = STATE(1902),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1816),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_in] = ACTIONS(2790),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(801),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1817] = {
    [sym__preprocessor_call] = STATE(1817),
    [sym__identifier_token] = ACTIONS(2971),
    [anon_sym_alias] = ACTIONS(2971),
    [anon_sym_SEMI] = ACTIONS(2973),
    [anon_sym_global] = ACTIONS(2971),
    [anon_sym_EQ] = ACTIONS(2971),
    [anon_sym_LT] = ACTIONS(2971),
    [anon_sym_COMMA] = ACTIONS(2973),
    [anon_sym_GT] = ACTIONS(2971),
    [anon_sym_DOT] = ACTIONS(2971),
    [anon_sym_LBRACK] = ACTIONS(2973),
    [anon_sym_RBRACK] = ACTIONS(2973),
    [anon_sym_COLON] = ACTIONS(2973),
    [anon_sym_LPAREN] = ACTIONS(2973),
    [anon_sym_RPAREN] = ACTIONS(2973),
    [anon_sym_in] = ACTIONS(2971),
    [anon_sym_LBRACE] = ACTIONS(2973),
    [anon_sym_RBRACE] = ACTIONS(2973),
    [anon_sym_EQ_GT] = ACTIONS(2973),
    [anon_sym_where] = ACTIONS(2971),
    [anon_sym_QMARK] = ACTIONS(2971),
    [anon_sym_notnull] = ACTIONS(2971),
    [anon_sym_unmanaged] = ACTIONS(2971),
    [anon_sym_BANG] = ACTIONS(2971),
    [anon_sym_PLUS_PLUS] = ACTIONS(2973),
    [anon_sym_DASH_DASH] = ACTIONS(2973),
    [anon_sym_PLUS] = ACTIONS(2971),
    [anon_sym_DASH] = ACTIONS(2971),
    [anon_sym_STAR] = ACTIONS(2971),
    [anon_sym_SLASH] = ACTIONS(2971),
    [anon_sym_PERCENT] = ACTIONS(2971),
    [anon_sym_CARET] = ACTIONS(2971),
    [anon_sym_PIPE] = ACTIONS(2971),
    [anon_sym_AMP] = ACTIONS(2971),
    [anon_sym_LT_LT] = ACTIONS(2971),
    [anon_sym_GT_GT] = ACTIONS(2971),
    [anon_sym_EQ_EQ] = ACTIONS(2973),
    [anon_sym_BANG_EQ] = ACTIONS(2973),
    [anon_sym_GT_EQ] = ACTIONS(2973),
    [anon_sym_LT_EQ] = ACTIONS(2973),
    [anon_sym_get] = ACTIONS(2971),
    [anon_sym_set] = ACTIONS(2971),
    [anon_sym_add] = ACTIONS(2971),
    [anon_sym_remove] = ACTIONS(2971),
    [anon_sym_switch] = ACTIONS(2971),
    [anon_sym_and] = ACTIONS(2971),
    [anon_sym_or] = ACTIONS(2971),
    [sym_discard] = ACTIONS(2971),
    [anon_sym_when] = ACTIONS(2971),
    [anon_sym_yield] = ACTIONS(2971),
    [anon_sym_PLUS_EQ] = ACTIONS(2973),
    [anon_sym_DASH_EQ] = ACTIONS(2973),
    [anon_sym_STAR_EQ] = ACTIONS(2973),
    [anon_sym_SLASH_EQ] = ACTIONS(2973),
    [anon_sym_PERCENT_EQ] = ACTIONS(2973),
    [anon_sym_AMP_EQ] = ACTIONS(2973),
    [anon_sym_CARET_EQ] = ACTIONS(2973),
    [anon_sym_PIPE_EQ] = ACTIONS(2973),
    [anon_sym_LT_LT_EQ] = ACTIONS(2973),
    [anon_sym_GT_GT_EQ] = ACTIONS(2973),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2973),
    [anon_sym_is] = ACTIONS(2971),
    [anon_sym_DASH_GT] = ACTIONS(2973),
    [anon_sym_from] = ACTIONS(2971),
    [anon_sym_join] = ACTIONS(2971),
    [anon_sym_on] = ACTIONS(2971),
    [anon_sym_equals] = ACTIONS(2971),
    [anon_sym_into] = ACTIONS(2971),
    [anon_sym_let] = ACTIONS(2971),
    [anon_sym_orderby] = ACTIONS(2971),
    [anon_sym_ascending] = ACTIONS(2971),
    [anon_sym_descending] = ACTIONS(2971),
    [anon_sym_group] = ACTIONS(2971),
    [anon_sym_by] = ACTIONS(2971),
    [anon_sym_select] = ACTIONS(2971),
    [anon_sym_DOT_DOT] = ACTIONS(2973),
    [anon_sym_with] = ACTIONS(2971),
    [anon_sym_AMP_AMP] = ACTIONS(2973),
    [anon_sym_PIPE_PIPE] = ACTIONS(2973),
    [anon_sym_QMARK_QMARK] = ACTIONS(2971),
    [anon_sym_as] = ACTIONS(2971),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2971),
    [anon_sym_nameof] = ACTIONS(2971),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1818] = {
    [sym__preprocessor_call] = STATE(1818),
    [sym__identifier_token] = ACTIONS(2965),
    [anon_sym_alias] = ACTIONS(2965),
    [anon_sym_SEMI] = ACTIONS(2967),
    [anon_sym_global] = ACTIONS(2965),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_COMMA] = ACTIONS(2967),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_RBRACK] = ACTIONS(2967),
    [anon_sym_COLON] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_RPAREN] = ACTIONS(2967),
    [anon_sym_in] = ACTIONS(2965),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_RBRACE] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2967),
    [anon_sym_where] = ACTIONS(2965),
    [anon_sym_QMARK] = ACTIONS(2965),
    [anon_sym_notnull] = ACTIONS(2965),
    [anon_sym_unmanaged] = ACTIONS(2965),
    [anon_sym_BANG] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_LT_LT] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2965),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_get] = ACTIONS(2965),
    [anon_sym_set] = ACTIONS(2965),
    [anon_sym_add] = ACTIONS(2965),
    [anon_sym_remove] = ACTIONS(2965),
    [anon_sym_switch] = ACTIONS(2965),
    [anon_sym_and] = ACTIONS(2965),
    [anon_sym_or] = ACTIONS(2965),
    [sym_discard] = ACTIONS(2965),
    [anon_sym_when] = ACTIONS(2965),
    [anon_sym_yield] = ACTIONS(2965),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2965),
    [anon_sym_DASH_GT] = ACTIONS(2967),
    [anon_sym_from] = ACTIONS(2965),
    [anon_sym_join] = ACTIONS(2965),
    [anon_sym_on] = ACTIONS(2965),
    [anon_sym_equals] = ACTIONS(2965),
    [anon_sym_into] = ACTIONS(2965),
    [anon_sym_let] = ACTIONS(2965),
    [anon_sym_orderby] = ACTIONS(2965),
    [anon_sym_ascending] = ACTIONS(2965),
    [anon_sym_descending] = ACTIONS(2965),
    [anon_sym_group] = ACTIONS(2965),
    [anon_sym_by] = ACTIONS(2965),
    [anon_sym_select] = ACTIONS(2965),
    [anon_sym_DOT_DOT] = ACTIONS(2967),
    [anon_sym_with] = ACTIONS(2965),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_QMARK_QMARK] = ACTIONS(2965),
    [anon_sym_as] = ACTIONS(2965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2965),
    [anon_sym_nameof] = ACTIONS(2965),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1819] = {
    [sym__preprocessor_call] = STATE(1819),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_SEMI] = ACTIONS(2919),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_RBRACK] = ACTIONS(2919),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_RPAREN] = ACTIONS(2919),
    [anon_sym_in] = ACTIONS(2930),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_EQ_GT] = ACTIONS(2919),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1820] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1879),
    [sym_property_pattern_clause] = STATE(1941),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1820),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2782),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1821] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1893),
    [sym_property_pattern_clause] = STATE(1934),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1821),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2782),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1822] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(3231),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_positional_pattern_clause] = STATE(1891),
    [sym_property_pattern_clause] = STATE(1943),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1822),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2782),
    [anon_sym_join] = ACTIONS(2782),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(2782),
    [anon_sym_orderby] = ACTIONS(2782),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(2782),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(2782),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1823] = {
    [sym__preprocessor_call] = STATE(1823),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2977),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_get] = ACTIONS(2977),
    [anon_sym_set] = ACTIONS(2977),
    [anon_sym_add] = ACTIONS(2977),
    [anon_sym_remove] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_and] = ACTIONS(2977),
    [anon_sym_or] = ACTIONS(2977),
    [sym_discard] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2979),
    [anon_sym_DASH_EQ] = ACTIONS(2979),
    [anon_sym_STAR_EQ] = ACTIONS(2979),
    [anon_sym_SLASH_EQ] = ACTIONS(2979),
    [anon_sym_PERCENT_EQ] = ACTIONS(2979),
    [anon_sym_AMP_EQ] = ACTIONS(2979),
    [anon_sym_CARET_EQ] = ACTIONS(2979),
    [anon_sym_PIPE_EQ] = ACTIONS(2979),
    [anon_sym_LT_LT_EQ] = ACTIONS(2979),
    [anon_sym_GT_GT_EQ] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2979),
    [anon_sym_is] = ACTIONS(2977),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2977),
    [anon_sym_nameof] = ACTIONS(2977),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1824] = {
    [sym__variable_designation] = STATE(2800),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_property_pattern_clause] = STATE(1887),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1824),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_COLON] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2813),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1825] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1825),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1826] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1877),
    [sym_property_pattern_clause] = STATE(1946),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1826),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2799),
    [anon_sym_into] = ACTIONS(2799),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1827] = {
    [sym__variable_designation] = STATE(2808),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_property_pattern_clause] = STATE(1888),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1827),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2809),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1828] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1884),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1828),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2809),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1829] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(3231),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_positional_pattern_clause] = STATE(1891),
    [sym_property_pattern_clause] = STATE(1943),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1829),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2986),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2986),
    [anon_sym_join] = ACTIONS(2986),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(2986),
    [anon_sym_orderby] = ACTIONS(2986),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(2986),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(2986),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1830] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(3231),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_positional_pattern_clause] = STATE(1872),
    [sym_property_pattern_clause] = STATE(1951),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1830),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2782),
    [anon_sym_join] = ACTIONS(2782),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2782),
    [anon_sym_orderby] = ACTIONS(2782),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(2782),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(2782),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1831] = {
    [sym__preprocessor_call] = STATE(1831),
    [sym__identifier_token] = ACTIONS(2989),
    [anon_sym_alias] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_RBRACK] = ACTIONS(2991),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_EQ_GT] = ACTIONS(2991),
    [anon_sym_where] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(2989),
    [anon_sym_unmanaged] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2989),
    [anon_sym_CARET] = ACTIONS(2989),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2989),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_add] = ACTIONS(2989),
    [anon_sym_remove] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_and] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [sym_discard] = ACTIONS(2989),
    [anon_sym_when] = ACTIONS(2989),
    [anon_sym_yield] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(2991),
    [anon_sym_DASH_EQ] = ACTIONS(2991),
    [anon_sym_STAR_EQ] = ACTIONS(2991),
    [anon_sym_SLASH_EQ] = ACTIONS(2991),
    [anon_sym_PERCENT_EQ] = ACTIONS(2991),
    [anon_sym_AMP_EQ] = ACTIONS(2991),
    [anon_sym_CARET_EQ] = ACTIONS(2991),
    [anon_sym_PIPE_EQ] = ACTIONS(2991),
    [anon_sym_LT_LT_EQ] = ACTIONS(2991),
    [anon_sym_GT_GT_EQ] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2991),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(2989),
    [anon_sym_join] = ACTIONS(2989),
    [anon_sym_on] = ACTIONS(2989),
    [anon_sym_equals] = ACTIONS(2989),
    [anon_sym_into] = ACTIONS(2989),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_orderby] = ACTIONS(2989),
    [anon_sym_ascending] = ACTIONS(2989),
    [anon_sym_descending] = ACTIONS(2989),
    [anon_sym_group] = ACTIONS(2989),
    [anon_sym_by] = ACTIONS(2989),
    [anon_sym_select] = ACTIONS(2989),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2989),
    [anon_sym_as] = ACTIONS(2989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2989),
    [anon_sym_nameof] = ACTIONS(2989),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1832] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1879),
    [sym_property_pattern_clause] = STATE(1941),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1832),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2782),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1833] = {
    [sym__preprocessor_call] = STATE(1833),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2852),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_RBRACK] = ACTIONS(2852),
    [anon_sym_COLON] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_RPAREN] = ACTIONS(2852),
    [anon_sym_in] = ACTIONS(2995),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2852),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1834] = {
    [sym__preprocessor_call] = STATE(1834),
    [sym__identifier_token] = ACTIONS(2989),
    [anon_sym_alias] = ACTIONS(2989),
    [anon_sym_SEMI] = ACTIONS(2991),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(2989),
    [anon_sym_LT] = ACTIONS(2989),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_GT] = ACTIONS(2989),
    [anon_sym_DOT] = ACTIONS(2989),
    [anon_sym_LBRACK] = ACTIONS(2991),
    [anon_sym_RBRACK] = ACTIONS(2991),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [anon_sym_in] = ACTIONS(2989),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_EQ_GT] = ACTIONS(2991),
    [anon_sym_where] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(2989),
    [anon_sym_notnull] = ACTIONS(2989),
    [anon_sym_unmanaged] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(2989),
    [anon_sym_PLUS_PLUS] = ACTIONS(2991),
    [anon_sym_DASH_DASH] = ACTIONS(2991),
    [anon_sym_PLUS] = ACTIONS(2989),
    [anon_sym_DASH] = ACTIONS(2989),
    [anon_sym_STAR] = ACTIONS(2989),
    [anon_sym_SLASH] = ACTIONS(2989),
    [anon_sym_PERCENT] = ACTIONS(2989),
    [anon_sym_CARET] = ACTIONS(2989),
    [anon_sym_PIPE] = ACTIONS(2989),
    [anon_sym_AMP] = ACTIONS(2989),
    [anon_sym_LT_LT] = ACTIONS(2989),
    [anon_sym_GT_GT] = ACTIONS(2989),
    [anon_sym_EQ_EQ] = ACTIONS(2991),
    [anon_sym_BANG_EQ] = ACTIONS(2991),
    [anon_sym_GT_EQ] = ACTIONS(2991),
    [anon_sym_LT_EQ] = ACTIONS(2991),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_add] = ACTIONS(2989),
    [anon_sym_remove] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(2989),
    [anon_sym_and] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [sym_discard] = ACTIONS(2989),
    [anon_sym_when] = ACTIONS(2989),
    [anon_sym_yield] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(2991),
    [anon_sym_DASH_EQ] = ACTIONS(2991),
    [anon_sym_STAR_EQ] = ACTIONS(2991),
    [anon_sym_SLASH_EQ] = ACTIONS(2991),
    [anon_sym_PERCENT_EQ] = ACTIONS(2991),
    [anon_sym_AMP_EQ] = ACTIONS(2991),
    [anon_sym_CARET_EQ] = ACTIONS(2991),
    [anon_sym_PIPE_EQ] = ACTIONS(2991),
    [anon_sym_LT_LT_EQ] = ACTIONS(2991),
    [anon_sym_GT_GT_EQ] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2991),
    [anon_sym_is] = ACTIONS(2989),
    [anon_sym_DASH_GT] = ACTIONS(2991),
    [anon_sym_from] = ACTIONS(2989),
    [anon_sym_join] = ACTIONS(2989),
    [anon_sym_on] = ACTIONS(2989),
    [anon_sym_equals] = ACTIONS(2989),
    [anon_sym_into] = ACTIONS(2989),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_orderby] = ACTIONS(2989),
    [anon_sym_ascending] = ACTIONS(2989),
    [anon_sym_descending] = ACTIONS(2989),
    [anon_sym_group] = ACTIONS(2989),
    [anon_sym_by] = ACTIONS(2989),
    [anon_sym_select] = ACTIONS(2989),
    [anon_sym_DOT_DOT] = ACTIONS(2991),
    [anon_sym_with] = ACTIONS(2989),
    [anon_sym_AMP_AMP] = ACTIONS(2991),
    [anon_sym_PIPE_PIPE] = ACTIONS(2991),
    [anon_sym_QMARK_QMARK] = ACTIONS(2989),
    [anon_sym_as] = ACTIONS(2989),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2989),
    [anon_sym_nameof] = ACTIONS(2989),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1835] = {
    [sym__preprocessor_call] = STATE(1835),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_SEMI] = ACTIONS(2979),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_EQ] = ACTIONS(2977),
    [anon_sym_LT] = ACTIONS(2977),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_GT] = ACTIONS(2977),
    [anon_sym_DOT] = ACTIONS(2977),
    [anon_sym_LBRACK] = ACTIONS(2979),
    [anon_sym_RBRACK] = ACTIONS(2979),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_in] = ACTIONS(2977),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(2977),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(2977),
    [anon_sym_PLUS_PLUS] = ACTIONS(2979),
    [anon_sym_DASH_DASH] = ACTIONS(2979),
    [anon_sym_PLUS] = ACTIONS(2977),
    [anon_sym_DASH] = ACTIONS(2977),
    [anon_sym_STAR] = ACTIONS(2977),
    [anon_sym_SLASH] = ACTIONS(2977),
    [anon_sym_PERCENT] = ACTIONS(2977),
    [anon_sym_CARET] = ACTIONS(2977),
    [anon_sym_PIPE] = ACTIONS(2977),
    [anon_sym_AMP] = ACTIONS(2977),
    [anon_sym_LT_LT] = ACTIONS(2977),
    [anon_sym_GT_GT] = ACTIONS(2977),
    [anon_sym_EQ_EQ] = ACTIONS(2979),
    [anon_sym_BANG_EQ] = ACTIONS(2979),
    [anon_sym_GT_EQ] = ACTIONS(2979),
    [anon_sym_LT_EQ] = ACTIONS(2979),
    [anon_sym_get] = ACTIONS(2977),
    [anon_sym_set] = ACTIONS(2977),
    [anon_sym_add] = ACTIONS(2977),
    [anon_sym_remove] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(2977),
    [anon_sym_and] = ACTIONS(2977),
    [anon_sym_or] = ACTIONS(2977),
    [sym_discard] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(2979),
    [anon_sym_DASH_EQ] = ACTIONS(2979),
    [anon_sym_STAR_EQ] = ACTIONS(2979),
    [anon_sym_SLASH_EQ] = ACTIONS(2979),
    [anon_sym_PERCENT_EQ] = ACTIONS(2979),
    [anon_sym_AMP_EQ] = ACTIONS(2979),
    [anon_sym_CARET_EQ] = ACTIONS(2979),
    [anon_sym_PIPE_EQ] = ACTIONS(2979),
    [anon_sym_LT_LT_EQ] = ACTIONS(2979),
    [anon_sym_GT_GT_EQ] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2979),
    [anon_sym_is] = ACTIONS(2977),
    [anon_sym_DASH_GT] = ACTIONS(2979),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_DOT_DOT] = ACTIONS(2979),
    [anon_sym_with] = ACTIONS(2977),
    [anon_sym_AMP_AMP] = ACTIONS(2979),
    [anon_sym_PIPE_PIPE] = ACTIONS(2979),
    [anon_sym_QMARK_QMARK] = ACTIONS(2977),
    [anon_sym_as] = ACTIONS(2977),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2977),
    [anon_sym_nameof] = ACTIONS(2977),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1836] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1871),
    [sym_property_pattern_clause] = STATE(1927),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1836),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2782),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1837] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1894),
    [sym_property_pattern_clause] = STATE(1939),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1837),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2782),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1838] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1877),
    [sym_property_pattern_clause] = STATE(1946),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1838),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2782),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1839] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1894),
    [sym_property_pattern_clause] = STATE(1939),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1839),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2799),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1840] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1877),
    [sym_property_pattern_clause] = STATE(1946),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1840),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2782),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1841] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1871),
    [sym_property_pattern_clause] = STATE(1927),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1841),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2782),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1842] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1876),
    [sym_property_pattern_clause] = STATE(1923),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1842),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2782),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1843] = {
    [sym_type_argument_list] = STATE(1785),
    [sym_equals_value_clause] = STATE(6471),
    [sym__preprocessor_call] = STATE(1843),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2997),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(3000),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1844] = {
    [sym__preprocessor_call] = STATE(1844),
    [sym__identifier_token] = ACTIONS(3005),
    [anon_sym_alias] = ACTIONS(3005),
    [anon_sym_SEMI] = ACTIONS(3007),
    [anon_sym_global] = ACTIONS(3005),
    [anon_sym_EQ] = ACTIONS(3005),
    [anon_sym_LT] = ACTIONS(3005),
    [anon_sym_COMMA] = ACTIONS(3007),
    [anon_sym_GT] = ACTIONS(3005),
    [anon_sym_DOT] = ACTIONS(3005),
    [anon_sym_LBRACK] = ACTIONS(3007),
    [anon_sym_RBRACK] = ACTIONS(3007),
    [anon_sym_COLON] = ACTIONS(3007),
    [anon_sym_LPAREN] = ACTIONS(3007),
    [anon_sym_RPAREN] = ACTIONS(3007),
    [anon_sym_in] = ACTIONS(3005),
    [anon_sym_RBRACE] = ACTIONS(3007),
    [anon_sym_EQ_GT] = ACTIONS(3007),
    [anon_sym_where] = ACTIONS(3005),
    [anon_sym_QMARK] = ACTIONS(3005),
    [anon_sym_notnull] = ACTIONS(3005),
    [anon_sym_unmanaged] = ACTIONS(3005),
    [anon_sym_BANG] = ACTIONS(3005),
    [anon_sym_PLUS_PLUS] = ACTIONS(3007),
    [anon_sym_DASH_DASH] = ACTIONS(3007),
    [anon_sym_PLUS] = ACTIONS(3005),
    [anon_sym_DASH] = ACTIONS(3005),
    [anon_sym_STAR] = ACTIONS(3005),
    [anon_sym_SLASH] = ACTIONS(3005),
    [anon_sym_PERCENT] = ACTIONS(3005),
    [anon_sym_CARET] = ACTIONS(3005),
    [anon_sym_PIPE] = ACTIONS(3005),
    [anon_sym_AMP] = ACTIONS(3005),
    [anon_sym_LT_LT] = ACTIONS(3005),
    [anon_sym_GT_GT] = ACTIONS(3005),
    [anon_sym_EQ_EQ] = ACTIONS(3007),
    [anon_sym_BANG_EQ] = ACTIONS(3007),
    [anon_sym_GT_EQ] = ACTIONS(3007),
    [anon_sym_LT_EQ] = ACTIONS(3007),
    [anon_sym_get] = ACTIONS(3005),
    [anon_sym_set] = ACTIONS(3005),
    [anon_sym_add] = ACTIONS(3005),
    [anon_sym_remove] = ACTIONS(3005),
    [anon_sym_switch] = ACTIONS(3005),
    [anon_sym_and] = ACTIONS(3005),
    [anon_sym_or] = ACTIONS(3005),
    [sym_discard] = ACTIONS(3005),
    [anon_sym_when] = ACTIONS(3005),
    [anon_sym_yield] = ACTIONS(3005),
    [anon_sym_PLUS_EQ] = ACTIONS(3007),
    [anon_sym_DASH_EQ] = ACTIONS(3007),
    [anon_sym_STAR_EQ] = ACTIONS(3007),
    [anon_sym_SLASH_EQ] = ACTIONS(3007),
    [anon_sym_PERCENT_EQ] = ACTIONS(3007),
    [anon_sym_AMP_EQ] = ACTIONS(3007),
    [anon_sym_CARET_EQ] = ACTIONS(3007),
    [anon_sym_PIPE_EQ] = ACTIONS(3007),
    [anon_sym_LT_LT_EQ] = ACTIONS(3007),
    [anon_sym_GT_GT_EQ] = ACTIONS(3007),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3007),
    [anon_sym_is] = ACTIONS(3005),
    [anon_sym_DASH_GT] = ACTIONS(3007),
    [anon_sym_from] = ACTIONS(3005),
    [anon_sym_join] = ACTIONS(3005),
    [anon_sym_on] = ACTIONS(3005),
    [anon_sym_equals] = ACTIONS(3005),
    [anon_sym_into] = ACTIONS(3005),
    [anon_sym_let] = ACTIONS(3005),
    [anon_sym_orderby] = ACTIONS(3005),
    [anon_sym_ascending] = ACTIONS(3005),
    [anon_sym_descending] = ACTIONS(3005),
    [anon_sym_group] = ACTIONS(3005),
    [anon_sym_by] = ACTIONS(3005),
    [anon_sym_select] = ACTIONS(3005),
    [anon_sym_DOT_DOT] = ACTIONS(3007),
    [anon_sym_with] = ACTIONS(3005),
    [anon_sym_AMP_AMP] = ACTIONS(3007),
    [anon_sym_PIPE_PIPE] = ACTIONS(3007),
    [anon_sym_QMARK_QMARK] = ACTIONS(3005),
    [anon_sym_as] = ACTIONS(3005),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3005),
    [anon_sym_nameof] = ACTIONS(3005),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1845] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(3231),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_positional_pattern_clause] = STATE(1872),
    [sym_property_pattern_clause] = STATE(1951),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1845),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2782),
    [anon_sym_join] = ACTIONS(2782),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2782),
    [anon_sym_orderby] = ACTIONS(2782),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(2782),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(2782),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1846] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1846),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1847] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(3231),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_positional_pattern_clause] = STATE(1872),
    [sym_property_pattern_clause] = STATE(1951),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1847),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2983),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(3011),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(3011),
    [anon_sym_join] = ACTIONS(3011),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(3011),
    [anon_sym_let] = ACTIONS(3011),
    [anon_sym_orderby] = ACTIONS(3011),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(3011),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(3011),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1848] = {
    [sym__preprocessor_call] = STATE(1848),
    [sym__identifier_token] = ACTIONS(3014),
    [anon_sym_alias] = ACTIONS(3014),
    [anon_sym_SEMI] = ACTIONS(3016),
    [anon_sym_global] = ACTIONS(3014),
    [anon_sym_EQ] = ACTIONS(3014),
    [anon_sym_LT] = ACTIONS(3014),
    [anon_sym_COMMA] = ACTIONS(3016),
    [anon_sym_GT] = ACTIONS(3014),
    [anon_sym_DOT] = ACTIONS(3014),
    [anon_sym_LBRACK] = ACTIONS(3016),
    [anon_sym_RBRACK] = ACTIONS(3016),
    [anon_sym_COLON] = ACTIONS(3016),
    [anon_sym_LPAREN] = ACTIONS(3016),
    [anon_sym_RPAREN] = ACTIONS(3016),
    [anon_sym_in] = ACTIONS(3014),
    [anon_sym_RBRACE] = ACTIONS(3016),
    [anon_sym_EQ_GT] = ACTIONS(3016),
    [anon_sym_where] = ACTIONS(3014),
    [anon_sym_QMARK] = ACTIONS(3014),
    [anon_sym_notnull] = ACTIONS(3014),
    [anon_sym_unmanaged] = ACTIONS(3014),
    [anon_sym_BANG] = ACTIONS(3014),
    [anon_sym_PLUS_PLUS] = ACTIONS(3016),
    [anon_sym_DASH_DASH] = ACTIONS(3016),
    [anon_sym_PLUS] = ACTIONS(3014),
    [anon_sym_DASH] = ACTIONS(3014),
    [anon_sym_STAR] = ACTIONS(3014),
    [anon_sym_SLASH] = ACTIONS(3014),
    [anon_sym_PERCENT] = ACTIONS(3014),
    [anon_sym_CARET] = ACTIONS(3014),
    [anon_sym_PIPE] = ACTIONS(3014),
    [anon_sym_AMP] = ACTIONS(3014),
    [anon_sym_LT_LT] = ACTIONS(3014),
    [anon_sym_GT_GT] = ACTIONS(3014),
    [anon_sym_EQ_EQ] = ACTIONS(3016),
    [anon_sym_BANG_EQ] = ACTIONS(3016),
    [anon_sym_GT_EQ] = ACTIONS(3016),
    [anon_sym_LT_EQ] = ACTIONS(3016),
    [anon_sym_get] = ACTIONS(3014),
    [anon_sym_set] = ACTIONS(3014),
    [anon_sym_add] = ACTIONS(3014),
    [anon_sym_remove] = ACTIONS(3014),
    [anon_sym_switch] = ACTIONS(3014),
    [anon_sym_and] = ACTIONS(3014),
    [anon_sym_or] = ACTIONS(3014),
    [sym_discard] = ACTIONS(3014),
    [anon_sym_when] = ACTIONS(3014),
    [anon_sym_yield] = ACTIONS(3014),
    [anon_sym_PLUS_EQ] = ACTIONS(3016),
    [anon_sym_DASH_EQ] = ACTIONS(3016),
    [anon_sym_STAR_EQ] = ACTIONS(3016),
    [anon_sym_SLASH_EQ] = ACTIONS(3016),
    [anon_sym_PERCENT_EQ] = ACTIONS(3016),
    [anon_sym_AMP_EQ] = ACTIONS(3016),
    [anon_sym_CARET_EQ] = ACTIONS(3016),
    [anon_sym_PIPE_EQ] = ACTIONS(3016),
    [anon_sym_LT_LT_EQ] = ACTIONS(3016),
    [anon_sym_GT_GT_EQ] = ACTIONS(3016),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3016),
    [anon_sym_is] = ACTIONS(3014),
    [anon_sym_DASH_GT] = ACTIONS(3016),
    [anon_sym_from] = ACTIONS(3014),
    [anon_sym_join] = ACTIONS(3014),
    [anon_sym_on] = ACTIONS(3014),
    [anon_sym_equals] = ACTIONS(3014),
    [anon_sym_into] = ACTIONS(3014),
    [anon_sym_let] = ACTIONS(3014),
    [anon_sym_orderby] = ACTIONS(3014),
    [anon_sym_ascending] = ACTIONS(3014),
    [anon_sym_descending] = ACTIONS(3014),
    [anon_sym_group] = ACTIONS(3014),
    [anon_sym_by] = ACTIONS(3014),
    [anon_sym_select] = ACTIONS(3014),
    [anon_sym_DOT_DOT] = ACTIONS(3016),
    [anon_sym_with] = ACTIONS(3014),
    [anon_sym_AMP_AMP] = ACTIONS(3016),
    [anon_sym_PIPE_PIPE] = ACTIONS(3016),
    [anon_sym_QMARK_QMARK] = ACTIONS(3014),
    [anon_sym_as] = ACTIONS(3014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3014),
    [anon_sym_nameof] = ACTIONS(3014),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1849] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1871),
    [sym_property_pattern_clause] = STATE(1927),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1849),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2799),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1850] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1894),
    [sym_property_pattern_clause] = STATE(1939),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1850),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2782),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1851] = {
    [sym__preprocessor_call] = STATE(1851),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3018),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1852] = {
    [sym__preprocessor_call] = STATE(1852),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2840),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1853] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1878),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1853),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_COLON] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2813),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1854] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1893),
    [sym_property_pattern_clause] = STATE(1934),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1854),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2782),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1855] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1876),
    [sym_property_pattern_clause] = STATE(1923),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1855),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2799),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2799),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1856] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1876),
    [sym_property_pattern_clause] = STATE(1923),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1856),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2782),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2782),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1857] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6722),
    [sym__type] = STATE(4560),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4650),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1857),
    [aux_sym_event_field_declaration_repeat1] = STATE(2628),
    [aux_sym_event_field_declaration_repeat2] = STATE(1922),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(3022),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_event] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(29),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(2679),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(29),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_implicit] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_TILDE] = ACTIONS(3028),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3032),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3036),
    [anon_sym_delegate] = ACTIONS(3038),
    [anon_sym_record] = ACTIONS(3040),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3042),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1858] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2885),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_positional_pattern_clause] = STATE(1879),
    [sym_property_pattern_clause] = STATE(1941),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1858),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2804),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2799),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1859] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(3231),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_positional_pattern_clause] = STATE(1891),
    [sym_property_pattern_clause] = STATE(1943),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1859),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(2782),
    [anon_sym_LT] = ACTIONS(2782),
    [anon_sym_GT] = ACTIONS(2782),
    [anon_sym_DOT] = ACTIONS(2782),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2780),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2782),
    [anon_sym_QMARK] = ACTIONS(2782),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(2782),
    [anon_sym_PLUS_PLUS] = ACTIONS(2780),
    [anon_sym_DASH_DASH] = ACTIONS(2780),
    [anon_sym_PLUS] = ACTIONS(2782),
    [anon_sym_DASH] = ACTIONS(2782),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2782),
    [anon_sym_PERCENT] = ACTIONS(2782),
    [anon_sym_CARET] = ACTIONS(2782),
    [anon_sym_PIPE] = ACTIONS(2782),
    [anon_sym_AMP] = ACTIONS(2782),
    [anon_sym_LT_LT] = ACTIONS(2782),
    [anon_sym_GT_GT] = ACTIONS(2782),
    [anon_sym_EQ_EQ] = ACTIONS(2780),
    [anon_sym_BANG_EQ] = ACTIONS(2780),
    [anon_sym_GT_EQ] = ACTIONS(2780),
    [anon_sym_LT_EQ] = ACTIONS(2780),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(2782),
    [anon_sym_and] = ACTIONS(2782),
    [anon_sym_or] = ACTIONS(2782),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(2780),
    [anon_sym_DASH_EQ] = ACTIONS(2780),
    [anon_sym_STAR_EQ] = ACTIONS(2780),
    [anon_sym_SLASH_EQ] = ACTIONS(2780),
    [anon_sym_PERCENT_EQ] = ACTIONS(2780),
    [anon_sym_AMP_EQ] = ACTIONS(2780),
    [anon_sym_CARET_EQ] = ACTIONS(2780),
    [anon_sym_PIPE_EQ] = ACTIONS(2780),
    [anon_sym_LT_LT_EQ] = ACTIONS(2780),
    [anon_sym_GT_GT_EQ] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2780),
    [anon_sym_is] = ACTIONS(2782),
    [anon_sym_DASH_GT] = ACTIONS(2780),
    [anon_sym_from] = ACTIONS(2782),
    [anon_sym_join] = ACTIONS(2782),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(2782),
    [anon_sym_orderby] = ACTIONS(2782),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(2782),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(2782),
    [anon_sym_DOT_DOT] = ACTIONS(2780),
    [anon_sym_with] = ACTIONS(2782),
    [anon_sym_AMP_AMP] = ACTIONS(2780),
    [anon_sym_PIPE_PIPE] = ACTIONS(2780),
    [anon_sym_QMARK_QMARK] = ACTIONS(2782),
    [anon_sym_as] = ACTIONS(2782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1860] = {
    [sym_array_rank_specifier] = STATE(1809),
    [sym__variable_designation] = STATE(2809),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_positional_pattern_clause] = STATE(1893),
    [sym_property_pattern_clause] = STATE(1934),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1860),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2790),
    [anon_sym_LT] = ACTIONS(2790),
    [anon_sym_GT] = ACTIONS(2790),
    [anon_sym_DOT] = ACTIONS(2790),
    [anon_sym_LBRACK] = ACTIONS(2784),
    [anon_sym_LPAREN] = ACTIONS(2796),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2790),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2790),
    [anon_sym_PLUS_PLUS] = ACTIONS(2794),
    [anon_sym_DASH_DASH] = ACTIONS(2794),
    [anon_sym_PLUS] = ACTIONS(2790),
    [anon_sym_DASH] = ACTIONS(2790),
    [anon_sym_STAR] = ACTIONS(2788),
    [anon_sym_SLASH] = ACTIONS(2790),
    [anon_sym_PERCENT] = ACTIONS(2790),
    [anon_sym_CARET] = ACTIONS(2790),
    [anon_sym_PIPE] = ACTIONS(2790),
    [anon_sym_AMP] = ACTIONS(2790),
    [anon_sym_LT_LT] = ACTIONS(2790),
    [anon_sym_GT_GT] = ACTIONS(2790),
    [anon_sym_EQ_EQ] = ACTIONS(2794),
    [anon_sym_BANG_EQ] = ACTIONS(2794),
    [anon_sym_GT_EQ] = ACTIONS(2794),
    [anon_sym_LT_EQ] = ACTIONS(2794),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2790),
    [anon_sym_or] = ACTIONS(2790),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2794),
    [anon_sym_DASH_EQ] = ACTIONS(2794),
    [anon_sym_STAR_EQ] = ACTIONS(2794),
    [anon_sym_SLASH_EQ] = ACTIONS(2794),
    [anon_sym_PERCENT_EQ] = ACTIONS(2794),
    [anon_sym_AMP_EQ] = ACTIONS(2794),
    [anon_sym_CARET_EQ] = ACTIONS(2794),
    [anon_sym_PIPE_EQ] = ACTIONS(2794),
    [anon_sym_LT_LT_EQ] = ACTIONS(2794),
    [anon_sym_GT_GT_EQ] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2794),
    [anon_sym_is] = ACTIONS(2790),
    [anon_sym_DASH_GT] = ACTIONS(2794),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2799),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2799),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2794),
    [anon_sym_with] = ACTIONS(2790),
    [anon_sym_AMP_AMP] = ACTIONS(2794),
    [anon_sym_PIPE_PIPE] = ACTIONS(2794),
    [anon_sym_QMARK_QMARK] = ACTIONS(2790),
    [anon_sym_as] = ACTIONS(2790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1861] = {
    [sym_type_argument_list] = STATE(1785),
    [sym_equals_value_clause] = STATE(6471),
    [sym__preprocessor_call] = STATE(1861),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2997),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1862] = {
    [sym__variable_designation] = STATE(3025),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_property_pattern_clause] = STATE(1920),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1862),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_COMMA] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2813),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2813),
    [anon_sym_join] = ACTIONS(2813),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_orderby] = ACTIONS(2813),
    [anon_sym_ascending] = ACTIONS(2813),
    [anon_sym_descending] = ACTIONS(2813),
    [anon_sym_group] = ACTIONS(2813),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2813),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1863] = {
    [sym__variable_designation] = STATE(2993),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_property_pattern_clause] = STATE(1903),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1863),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2809),
    [anon_sym_join] = ACTIONS(2809),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_orderby] = ACTIONS(2809),
    [anon_sym_ascending] = ACTIONS(2809),
    [anon_sym_descending] = ACTIONS(2809),
    [anon_sym_group] = ACTIONS(2809),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1864] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1916),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1864),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_in] = ACTIONS(2813),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(801),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1865] = {
    [sym__variable_designation] = STATE(2993),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_property_pattern_clause] = STATE(1908),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1865),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2809),
    [anon_sym_join] = ACTIONS(2809),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_orderby] = ACTIONS(2809),
    [anon_sym_ascending] = ACTIONS(2809),
    [anon_sym_descending] = ACTIONS(2809),
    [anon_sym_group] = ACTIONS(2809),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1866] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1902),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1866),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_in] = ACTIONS(2809),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(801),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1867] = {
    [sym__variable_designation] = STATE(3025),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_property_pattern_clause] = STATE(1904),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1867),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_COMMA] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2813),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2813),
    [anon_sym_join] = ACTIONS(2813),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_orderby] = ACTIONS(2813),
    [anon_sym_ascending] = ACTIONS(2813),
    [anon_sym_descending] = ACTIONS(2813),
    [anon_sym_group] = ACTIONS(2813),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2813),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1868] = {
    [sym__preprocessor_call] = STATE(1868),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3047),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1869] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1869),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(3000),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(3000),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1870] = {
    [sym__preprocessor_call] = STATE(1870),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1871] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1928),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1871),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2813),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1872] = {
    [sym__variable_designation] = STATE(3333),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_property_pattern_clause] = STATE(1952),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1872),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2813),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2813),
    [anon_sym_join] = ACTIONS(2813),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_orderby] = ACTIONS(2813),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(2813),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(2813),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1873] = {
    [sym__preprocessor_call] = STATE(1873),
    [sym__identifier_token] = ACTIONS(2844),
    [anon_sym_alias] = ACTIONS(2844),
    [anon_sym_global] = ACTIONS(2844),
    [anon_sym_EQ] = ACTIONS(2844),
    [anon_sym_COLON_COLON] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2844),
    [anon_sym_COMMA] = ACTIONS(2847),
    [anon_sym_GT] = ACTIONS(2844),
    [anon_sym_DOT] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_COLON] = ACTIONS(2844),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2844),
    [anon_sym_QMARK] = ACTIONS(2844),
    [anon_sym_notnull] = ACTIONS(2844),
    [anon_sym_unmanaged] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_PERCENT] = ACTIONS(2844),
    [anon_sym_CARET] = ACTIONS(2844),
    [anon_sym_PIPE] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2844),
    [anon_sym_LT_LT] = ACTIONS(2844),
    [anon_sym_GT_GT] = ACTIONS(2844),
    [anon_sym_EQ_EQ] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_GT_EQ] = ACTIONS(2847),
    [anon_sym_LT_EQ] = ACTIONS(2847),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_add] = ACTIONS(2844),
    [anon_sym_remove] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_and] = ACTIONS(2844),
    [anon_sym_or] = ACTIONS(2844),
    [sym_discard] = ACTIONS(2844),
    [anon_sym_when] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_PLUS_EQ] = ACTIONS(2847),
    [anon_sym_DASH_EQ] = ACTIONS(2847),
    [anon_sym_STAR_EQ] = ACTIONS(2847),
    [anon_sym_SLASH_EQ] = ACTIONS(2847),
    [anon_sym_PERCENT_EQ] = ACTIONS(2847),
    [anon_sym_AMP_EQ] = ACTIONS(2847),
    [anon_sym_CARET_EQ] = ACTIONS(2847),
    [anon_sym_PIPE_EQ] = ACTIONS(2847),
    [anon_sym_LT_LT_EQ] = ACTIONS(2847),
    [anon_sym_GT_GT_EQ] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2847),
    [anon_sym_is] = ACTIONS(2844),
    [anon_sym_DASH_GT] = ACTIONS(2847),
    [anon_sym_from] = ACTIONS(2844),
    [anon_sym_join] = ACTIONS(2844),
    [anon_sym_on] = ACTIONS(2844),
    [anon_sym_equals] = ACTIONS(2844),
    [anon_sym_into] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_orderby] = ACTIONS(2844),
    [anon_sym_ascending] = ACTIONS(2844),
    [anon_sym_descending] = ACTIONS(2844),
    [anon_sym_group] = ACTIONS(2844),
    [anon_sym_by] = ACTIONS(2844),
    [anon_sym_select] = ACTIONS(2844),
    [anon_sym_DOT_DOT] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK] = ACTIONS(2844),
    [anon_sym_as] = ACTIONS(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2844),
    [anon_sym_nameof] = ACTIONS(2844),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1874] = {
    [sym__variable_designation] = STATE(2808),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_property_pattern_clause] = STATE(1923),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1874),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2809),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1875] = {
    [sym__variable_designation] = STATE(3281),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_property_pattern_clause] = STATE(1951),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1875),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2809),
    [anon_sym_join] = ACTIONS(2809),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_orderby] = ACTIONS(2809),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(2809),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1876] = {
    [sym__variable_designation] = STATE(2800),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_property_pattern_clause] = STATE(1929),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1876),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2813),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1877] = {
    [sym__variable_designation] = STATE(2800),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_property_pattern_clause] = STATE(1949),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1877),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2813),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1878] = {
    [sym__variable_designation] = STATE(2948),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1878),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_COLON] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_EQ_GT] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2825),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1879] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1940),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1879),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2813),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1880] = {
    [sym__variable_designation] = STATE(3281),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_property_pattern_clause] = STATE(1943),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1880),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2809),
    [anon_sym_join] = ACTIONS(2809),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_orderby] = ACTIONS(2809),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(2809),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1881] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1881),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2809),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1882] = {
    [sym__variable_designation] = STATE(2808),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_property_pattern_clause] = STATE(1946),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1882),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2809),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1883] = {
    [sym__variable_designation] = STATE(2945),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1883),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2817),
    [anon_sym_GT] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2821),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2817),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_switch] = ACTIONS(2817),
    [anon_sym_and] = ACTIONS(2817),
    [anon_sym_or] = ACTIONS(2817),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(2815),
    [anon_sym_DASH_EQ] = ACTIONS(2815),
    [anon_sym_STAR_EQ] = ACTIONS(2815),
    [anon_sym_SLASH_EQ] = ACTIONS(2815),
    [anon_sym_PERCENT_EQ] = ACTIONS(2815),
    [anon_sym_AMP_EQ] = ACTIONS(2815),
    [anon_sym_CARET_EQ] = ACTIONS(2815),
    [anon_sym_PIPE_EQ] = ACTIONS(2815),
    [anon_sym_LT_LT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT_EQ] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2815),
    [anon_sym_is] = ACTIONS(2817),
    [anon_sym_DASH_GT] = ACTIONS(2815),
    [anon_sym_from] = ACTIONS(801),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_with] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK] = ACTIONS(2817),
    [anon_sym_as] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1884] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1884),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_COLON] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2813),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1885] = {
    [sym__variable_designation] = STATE(3006),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1885),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(3051),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_where] = ACTIONS(13),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2817),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2817),
    [anon_sym_and] = ACTIONS(2817),
    [anon_sym_or] = ACTIONS(2817),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2815),
    [anon_sym_DASH_EQ] = ACTIONS(2815),
    [anon_sym_STAR_EQ] = ACTIONS(2815),
    [anon_sym_SLASH_EQ] = ACTIONS(2815),
    [anon_sym_PERCENT_EQ] = ACTIONS(2815),
    [anon_sym_AMP_EQ] = ACTIONS(2815),
    [anon_sym_CARET_EQ] = ACTIONS(2815),
    [anon_sym_PIPE_EQ] = ACTIONS(2815),
    [anon_sym_LT_LT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT_EQ] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2815),
    [anon_sym_is] = ACTIONS(2817),
    [anon_sym_DASH_GT] = ACTIONS(2815),
    [anon_sym_from] = ACTIONS(13),
    [anon_sym_join] = ACTIONS(13),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(13),
    [anon_sym_orderby] = ACTIONS(13),
    [anon_sym_ascending] = ACTIONS(13),
    [anon_sym_descending] = ACTIONS(13),
    [anon_sym_group] = ACTIONS(13),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(13),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_with] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK] = ACTIONS(2817),
    [anon_sym_as] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1886] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1927),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1886),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2809),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1887] = {
    [sym__variable_designation] = STATE(2786),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1887),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_COLON] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_EQ_GT] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2825),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1888] = {
    [sym__variable_designation] = STATE(2800),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1888),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_COLON] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_EQ_GT] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2813),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1889] = {
    [sym__variable_designation] = STATE(2808),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1889),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_COLON] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_EQ_GT] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2809),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1890] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1939),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1890),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2809),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1891] = {
    [sym__variable_designation] = STATE(3333),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_property_pattern_clause] = STATE(1924),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1891),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2813),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2813),
    [anon_sym_join] = ACTIONS(2813),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_orderby] = ACTIONS(2813),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(2813),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(2813),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1892] = {
    [sym__variable_designation] = STATE(2808),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_property_pattern_clause] = STATE(1934),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1892),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2809),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1893] = {
    [sym__variable_designation] = STATE(2800),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_property_pattern_clause] = STATE(1936),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1893),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2813),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1894] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1921),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1894),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2813),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1895] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_property_pattern_clause] = STATE(1941),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1895),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_LBRACE] = ACTIONS(2786),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2809),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1896] = {
    [sym__preprocessor_call] = STATE(1896),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(3009),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1897] = {
    [sym__variable_designation] = STATE(2993),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1897),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2809),
    [anon_sym_join] = ACTIONS(2809),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_orderby] = ACTIONS(2809),
    [anon_sym_ascending] = ACTIONS(2809),
    [anon_sym_descending] = ACTIONS(2809),
    [anon_sym_group] = ACTIONS(2809),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1898] = {
    [sym__preprocessor_call] = STATE(1898),
    [sym__identifier_token] = ACTIONS(2734),
    [anon_sym_alias] = ACTIONS(2734),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_global] = ACTIONS(2734),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(3053),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2734),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2734),
    [anon_sym_unmanaged] = ACTIONS(2734),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2734),
    [anon_sym_set] = ACTIONS(2734),
    [anon_sym_add] = ACTIONS(2734),
    [anon_sym_remove] = ACTIONS(2734),
    [anon_sym_break] = ACTIONS(3055),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2734),
    [anon_sym_yield] = ACTIONS(2734),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2734),
    [anon_sym_join] = ACTIONS(2734),
    [anon_sym_on] = ACTIONS(2734),
    [anon_sym_equals] = ACTIONS(2734),
    [anon_sym_into] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2734),
    [anon_sym_orderby] = ACTIONS(2734),
    [anon_sym_ascending] = ACTIONS(2734),
    [anon_sym_descending] = ACTIONS(2734),
    [anon_sym_group] = ACTIONS(2734),
    [anon_sym_by] = ACTIONS(2734),
    [anon_sym_select] = ACTIONS(2734),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2734),
    [anon_sym_nameof] = ACTIONS(2734),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1899] = {
    [sym__preprocessor_call] = STATE(1899),
    [sym__identifier_token] = ACTIONS(2989),
    [anon_sym_alias] = ACTIONS(2989),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_COMMA] = ACTIONS(2991),
    [anon_sym_GT] = ACTIONS(3057),
    [anon_sym_DOT] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_RPAREN] = ACTIONS(2991),
    [anon_sym_RBRACE] = ACTIONS(2991),
    [anon_sym_EQ_GT] = ACTIONS(2991),
    [anon_sym_where] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(3057),
    [anon_sym_notnull] = ACTIONS(2989),
    [anon_sym_unmanaged] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3057),
    [anon_sym_CARET] = ACTIONS(3057),
    [anon_sym_PIPE] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_LT_LT] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(3057),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_GT_EQ] = ACTIONS(3059),
    [anon_sym_LT_EQ] = ACTIONS(3059),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_add] = ACTIONS(2989),
    [anon_sym_remove] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(3057),
    [anon_sym_and] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [sym_discard] = ACTIONS(2989),
    [anon_sym_when] = ACTIONS(2989),
    [anon_sym_yield] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(3059),
    [anon_sym_DASH_EQ] = ACTIONS(3059),
    [anon_sym_STAR_EQ] = ACTIONS(3059),
    [anon_sym_SLASH_EQ] = ACTIONS(3059),
    [anon_sym_PERCENT_EQ] = ACTIONS(3059),
    [anon_sym_AMP_EQ] = ACTIONS(3059),
    [anon_sym_CARET_EQ] = ACTIONS(3059),
    [anon_sym_PIPE_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3059),
    [anon_sym_is] = ACTIONS(3057),
    [anon_sym_DASH_GT] = ACTIONS(3059),
    [anon_sym_from] = ACTIONS(2989),
    [anon_sym_join] = ACTIONS(2989),
    [anon_sym_on] = ACTIONS(2989),
    [anon_sym_equals] = ACTIONS(2989),
    [anon_sym_into] = ACTIONS(2989),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_orderby] = ACTIONS(2989),
    [anon_sym_ascending] = ACTIONS(2989),
    [anon_sym_descending] = ACTIONS(2989),
    [anon_sym_group] = ACTIONS(2989),
    [anon_sym_by] = ACTIONS(2989),
    [anon_sym_select] = ACTIONS(2989),
    [anon_sym_DOT_DOT] = ACTIONS(3059),
    [anon_sym_with] = ACTIONS(3057),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_QMARK_QMARK] = ACTIONS(3057),
    [anon_sym_as] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2989),
    [anon_sym_nameof] = ACTIONS(2989),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1900] = {
    [sym__variable_designation] = STATE(2993),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1900),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_COMMA] = ACTIONS(2807),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2809),
    [anon_sym_join] = ACTIONS(2809),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_orderby] = ACTIONS(2809),
    [anon_sym_ascending] = ACTIONS(2809),
    [anon_sym_descending] = ACTIONS(2809),
    [anon_sym_group] = ACTIONS(2809),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1901] = {
    [sym__variable_designation] = STATE(3303),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1901),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2817),
    [anon_sym_GT] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2817),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(2817),
    [anon_sym_and] = ACTIONS(2817),
    [anon_sym_or] = ACTIONS(2817),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(2815),
    [anon_sym_DASH_EQ] = ACTIONS(2815),
    [anon_sym_STAR_EQ] = ACTIONS(2815),
    [anon_sym_SLASH_EQ] = ACTIONS(2815),
    [anon_sym_PERCENT_EQ] = ACTIONS(2815),
    [anon_sym_AMP_EQ] = ACTIONS(2815),
    [anon_sym_CARET_EQ] = ACTIONS(2815),
    [anon_sym_PIPE_EQ] = ACTIONS(2815),
    [anon_sym_LT_LT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT_EQ] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2815),
    [anon_sym_is] = ACTIONS(2817),
    [anon_sym_DASH_GT] = ACTIONS(2815),
    [anon_sym_from] = ACTIONS(951),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_with] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK] = ACTIONS(2817),
    [anon_sym_as] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1902] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1902),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_in] = ACTIONS(2813),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(801),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1903] = {
    [sym__variable_designation] = STATE(3025),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1903),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_COMMA] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2813),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2813),
    [anon_sym_join] = ACTIONS(2813),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_orderby] = ACTIONS(2813),
    [anon_sym_ascending] = ACTIONS(2813),
    [anon_sym_descending] = ACTIONS(2813),
    [anon_sym_group] = ACTIONS(2813),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2813),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1904] = {
    [sym__variable_designation] = STATE(3057),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1904),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2825),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2825),
    [anon_sym_join] = ACTIONS(2825),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(13),
    [anon_sym_let] = ACTIONS(2825),
    [anon_sym_orderby] = ACTIONS(2825),
    [anon_sym_ascending] = ACTIONS(2825),
    [anon_sym_descending] = ACTIONS(2825),
    [anon_sym_group] = ACTIONS(2825),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2825),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1905] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1905),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_in] = ACTIONS(2809),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(801),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1906] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1906),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1907] = {
    [sym__preprocessor_call] = STATE(1907),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(3002),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1908] = {
    [sym__variable_designation] = STATE(3025),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1908),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_COMMA] = ACTIONS(2811),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2813),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2813),
    [anon_sym_join] = ACTIONS(2813),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_orderby] = ACTIONS(2813),
    [anon_sym_ascending] = ACTIONS(2813),
    [anon_sym_descending] = ACTIONS(2813),
    [anon_sym_group] = ACTIONS(2813),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2813),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1909] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1909),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1910] = {
    [sym__preprocessor_call] = STATE(1910),
    [sym__identifier_token] = ACTIONS(2734),
    [anon_sym_alias] = ACTIONS(2734),
    [anon_sym_global] = ACTIONS(2734),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_COLON] = ACTIONS(2729),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2734),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2734),
    [anon_sym_unmanaged] = ACTIONS(2734),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2734),
    [anon_sym_set] = ACTIONS(2734),
    [anon_sym_add] = ACTIONS(2734),
    [anon_sym_remove] = ACTIONS(2734),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_and] = ACTIONS(2734),
    [anon_sym_or] = ACTIONS(2734),
    [sym_discard] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2734),
    [anon_sym_yield] = ACTIONS(2734),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2734),
    [anon_sym_join] = ACTIONS(2734),
    [anon_sym_on] = ACTIONS(2734),
    [anon_sym_equals] = ACTIONS(2734),
    [anon_sym_into] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2734),
    [anon_sym_orderby] = ACTIONS(2734),
    [anon_sym_ascending] = ACTIONS(2734),
    [anon_sym_descending] = ACTIONS(2734),
    [anon_sym_group] = ACTIONS(2734),
    [anon_sym_by] = ACTIONS(2734),
    [anon_sym_select] = ACTIONS(2734),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2734),
    [anon_sym_nameof] = ACTIONS(2734),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1911] = {
    [sym__preprocessor_call] = STATE(1911),
    [sym__identifier_token] = ACTIONS(2833),
    [anon_sym_alias] = ACTIONS(2833),
    [anon_sym_global] = ACTIONS(2833),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2835),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_COLON] = ACTIONS(2835),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_RPAREN] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_where] = ACTIONS(2833),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_notnull] = ACTIONS(2833),
    [anon_sym_unmanaged] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_GT_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2835),
    [anon_sym_get] = ACTIONS(2833),
    [anon_sym_set] = ACTIONS(2833),
    [anon_sym_add] = ACTIONS(2833),
    [anon_sym_remove] = ACTIONS(2833),
    [anon_sym_switch] = ACTIONS(2833),
    [anon_sym_and] = ACTIONS(2833),
    [anon_sym_or] = ACTIONS(2833),
    [sym_discard] = ACTIONS(2833),
    [anon_sym_when] = ACTIONS(2833),
    [anon_sym_yield] = ACTIONS(2833),
    [anon_sym_PLUS_EQ] = ACTIONS(2835),
    [anon_sym_DASH_EQ] = ACTIONS(2835),
    [anon_sym_STAR_EQ] = ACTIONS(2835),
    [anon_sym_SLASH_EQ] = ACTIONS(2835),
    [anon_sym_PERCENT_EQ] = ACTIONS(2835),
    [anon_sym_AMP_EQ] = ACTIONS(2835),
    [anon_sym_CARET_EQ] = ACTIONS(2835),
    [anon_sym_PIPE_EQ] = ACTIONS(2835),
    [anon_sym_LT_LT_EQ] = ACTIONS(2835),
    [anon_sym_GT_GT_EQ] = ACTIONS(2835),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2835),
    [anon_sym_is] = ACTIONS(2833),
    [anon_sym_DASH_GT] = ACTIONS(2835),
    [anon_sym_from] = ACTIONS(2833),
    [anon_sym_join] = ACTIONS(2833),
    [anon_sym_on] = ACTIONS(2833),
    [anon_sym_equals] = ACTIONS(2833),
    [anon_sym_into] = ACTIONS(2833),
    [anon_sym_let] = ACTIONS(2833),
    [anon_sym_orderby] = ACTIONS(2833),
    [anon_sym_ascending] = ACTIONS(2833),
    [anon_sym_descending] = ACTIONS(2833),
    [anon_sym_group] = ACTIONS(2833),
    [anon_sym_by] = ACTIONS(2833),
    [anon_sym_select] = ACTIONS(2833),
    [anon_sym_DOT_DOT] = ACTIONS(2835),
    [anon_sym_with] = ACTIONS(2833),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_QMARK_QMARK] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2833),
    [anon_sym_nameof] = ACTIONS(2833),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1912] = {
    [sym__preprocessor_call] = STATE(1912),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(2979),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(1989),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_RPAREN] = ACTIONS(2979),
    [anon_sym_RBRACE] = ACTIONS(2979),
    [anon_sym_EQ_GT] = ACTIONS(2979),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(1984),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(1984),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1989),
    [anon_sym_get] = ACTIONS(2977),
    [anon_sym_set] = ACTIONS(2977),
    [anon_sym_add] = ACTIONS(2977),
    [anon_sym_remove] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(2977),
    [anon_sym_or] = ACTIONS(2977),
    [sym_discard] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1989),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_DOT_DOT] = ACTIONS(1989),
    [anon_sym_with] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2977),
    [anon_sym_nameof] = ACTIONS(2977),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1913] = {
    [sym__preprocessor_call] = STATE(1913),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3065),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1914] = {
    [sym__preprocessor_call] = STATE(1914),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(2926),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3072),
    [anon_sym_RPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2926),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1915] = {
    [sym__preprocessor_call] = STATE(1915),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3077),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1916] = {
    [sym__variable_designation] = STATE(2948),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2645),
    [sym__preprocessor_call] = STATE(1916),
    [sym__identifier_token] = ACTIONS(799),
    [anon_sym_alias] = ACTIONS(801),
    [anon_sym_global] = ACTIONS(801),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_in] = ACTIONS(2825),
    [anon_sym_where] = ACTIONS(801),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(801),
    [anon_sym_unmanaged] = ACTIONS(801),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(801),
    [anon_sym_set] = ACTIONS(801),
    [anon_sym_add] = ACTIONS(801),
    [anon_sym_remove] = ACTIONS(801),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(801),
    [anon_sym_yield] = ACTIONS(801),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(801),
    [anon_sym_join] = ACTIONS(801),
    [anon_sym_on] = ACTIONS(801),
    [anon_sym_equals] = ACTIONS(801),
    [anon_sym_into] = ACTIONS(801),
    [anon_sym_let] = ACTIONS(801),
    [anon_sym_orderby] = ACTIONS(801),
    [anon_sym_ascending] = ACTIONS(801),
    [anon_sym_descending] = ACTIONS(801),
    [anon_sym_group] = ACTIONS(801),
    [anon_sym_by] = ACTIONS(801),
    [anon_sym_select] = ACTIONS(801),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(801),
    [anon_sym_nameof] = ACTIONS(801),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1917] = {
    [sym__preprocessor_call] = STATE(1917),
    [sym__identifier_token] = ACTIONS(2844),
    [anon_sym_alias] = ACTIONS(2844),
    [anon_sym_global] = ACTIONS(2844),
    [anon_sym_EQ] = ACTIONS(2844),
    [anon_sym_LT] = ACTIONS(2844),
    [anon_sym_COMMA] = ACTIONS(2847),
    [anon_sym_GT] = ACTIONS(2844),
    [anon_sym_DOT] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_COLON] = ACTIONS(2847),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_RPAREN] = ACTIONS(2847),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_where] = ACTIONS(2844),
    [anon_sym_QMARK] = ACTIONS(2844),
    [anon_sym_notnull] = ACTIONS(2844),
    [anon_sym_unmanaged] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_PERCENT] = ACTIONS(2844),
    [anon_sym_CARET] = ACTIONS(2844),
    [anon_sym_PIPE] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2844),
    [anon_sym_LT_LT] = ACTIONS(2844),
    [anon_sym_GT_GT] = ACTIONS(2844),
    [anon_sym_EQ_EQ] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_GT_EQ] = ACTIONS(2847),
    [anon_sym_LT_EQ] = ACTIONS(2847),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_add] = ACTIONS(2844),
    [anon_sym_remove] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_and] = ACTIONS(2844),
    [anon_sym_or] = ACTIONS(2844),
    [sym_discard] = ACTIONS(2844),
    [anon_sym_when] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_PLUS_EQ] = ACTIONS(2847),
    [anon_sym_DASH_EQ] = ACTIONS(2847),
    [anon_sym_STAR_EQ] = ACTIONS(2847),
    [anon_sym_SLASH_EQ] = ACTIONS(2847),
    [anon_sym_PERCENT_EQ] = ACTIONS(2847),
    [anon_sym_AMP_EQ] = ACTIONS(2847),
    [anon_sym_CARET_EQ] = ACTIONS(2847),
    [anon_sym_PIPE_EQ] = ACTIONS(2847),
    [anon_sym_LT_LT_EQ] = ACTIONS(2847),
    [anon_sym_GT_GT_EQ] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2847),
    [anon_sym_is] = ACTIONS(2844),
    [anon_sym_DASH_GT] = ACTIONS(2847),
    [anon_sym_from] = ACTIONS(2844),
    [anon_sym_join] = ACTIONS(2844),
    [anon_sym_on] = ACTIONS(2844),
    [anon_sym_equals] = ACTIONS(2844),
    [anon_sym_into] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_orderby] = ACTIONS(2844),
    [anon_sym_ascending] = ACTIONS(2844),
    [anon_sym_descending] = ACTIONS(2844),
    [anon_sym_group] = ACTIONS(2844),
    [anon_sym_by] = ACTIONS(2844),
    [anon_sym_select] = ACTIONS(2844),
    [anon_sym_DOT_DOT] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK] = ACTIONS(2844),
    [anon_sym_as] = ACTIONS(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2844),
    [anon_sym_nameof] = ACTIONS(2844),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1918] = {
    [sym__preprocessor_call] = STATE(1918),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3072),
    [anon_sym_RPAREN] = ACTIONS(2919),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2919),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1919] = {
    [sym__variable_designation] = STATE(3303),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1919),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2817),
    [anon_sym_GT] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(3061),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_where] = ACTIONS(869),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2817),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_switch] = ACTIONS(2817),
    [anon_sym_and] = ACTIONS(2817),
    [anon_sym_or] = ACTIONS(2817),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(2815),
    [anon_sym_DASH_EQ] = ACTIONS(2815),
    [anon_sym_STAR_EQ] = ACTIONS(2815),
    [anon_sym_SLASH_EQ] = ACTIONS(2815),
    [anon_sym_PERCENT_EQ] = ACTIONS(2815),
    [anon_sym_AMP_EQ] = ACTIONS(2815),
    [anon_sym_CARET_EQ] = ACTIONS(2815),
    [anon_sym_PIPE_EQ] = ACTIONS(2815),
    [anon_sym_LT_LT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT_EQ] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2815),
    [anon_sym_is] = ACTIONS(2817),
    [anon_sym_DASH_GT] = ACTIONS(2815),
    [anon_sym_from] = ACTIONS(869),
    [anon_sym_join] = ACTIONS(869),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(869),
    [anon_sym_let] = ACTIONS(869),
    [anon_sym_orderby] = ACTIONS(869),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(869),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(869),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_with] = ACTIONS(2817),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK] = ACTIONS(2817),
    [anon_sym_as] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1920] = {
    [sym__variable_designation] = STATE(3057),
    [sym_parenthesized_variable_designation] = STATE(3007),
    [sym_identifier] = STATE(3007),
    [sym__contextual_keywords] = STATE(1774),
    [sym__preprocessor_call] = STATE(1920),
    [sym__identifier_token] = ACTIONS(9),
    [anon_sym_alias] = ACTIONS(13),
    [anon_sym_global] = ACTIONS(13),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_COMMA] = ACTIONS(2823),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2825),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(13),
    [anon_sym_unmanaged] = ACTIONS(13),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(13),
    [anon_sym_set] = ACTIONS(13),
    [anon_sym_add] = ACTIONS(13),
    [anon_sym_remove] = ACTIONS(13),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2864),
    [anon_sym_when] = ACTIONS(13),
    [anon_sym_yield] = ACTIONS(13),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2825),
    [anon_sym_join] = ACTIONS(2825),
    [anon_sym_on] = ACTIONS(13),
    [anon_sym_equals] = ACTIONS(13),
    [anon_sym_into] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2825),
    [anon_sym_orderby] = ACTIONS(2825),
    [anon_sym_ascending] = ACTIONS(2825),
    [anon_sym_descending] = ACTIONS(2825),
    [anon_sym_group] = ACTIONS(2825),
    [anon_sym_by] = ACTIONS(13),
    [anon_sym_select] = ACTIONS(2825),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(13),
    [anon_sym_nameof] = ACTIONS(13),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1921] = {
    [sym__variable_designation] = STATE(2948),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1921),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2825),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1922] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6846),
    [sym__type] = STATE(4564),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4649),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1922),
    [aux_sym_event_field_declaration_repeat2] = STATE(2707),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_event] = ACTIONS(3079),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(29),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(2679),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(29),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_implicit] = ACTIONS(3081),
    [anon_sym_explicit] = ACTIONS(3081),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(3083),
    [anon_sym_struct] = ACTIONS(3085),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_enum] = ACTIONS(3087),
    [anon_sym_interface] = ACTIONS(3089),
    [anon_sym_delegate] = ACTIONS(3091),
    [anon_sym_record] = ACTIONS(3093),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3095),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1923] = {
    [sym__variable_designation] = STATE(2800),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1923),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2813),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1924] = {
    [sym__variable_designation] = STATE(3339),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1924),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2825),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2825),
    [anon_sym_join] = ACTIONS(2825),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(2825),
    [anon_sym_orderby] = ACTIONS(2825),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(2825),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(2825),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1925] = {
    [sym__variable_designation] = STATE(2808),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1925),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2809),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1926] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1926),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1927] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1927),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2813),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1928] = {
    [sym__variable_designation] = STATE(2948),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1928),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2825),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1929] = {
    [sym__variable_designation] = STATE(2786),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1929),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2825),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1930] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1930),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2809),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1931] = {
    [sym_type_argument_list] = STATE(1785),
    [sym_equals_value_clause] = STATE(6259),
    [sym__preprocessor_call] = STATE(1931),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2997),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_EQ_GT] = ACTIONS(2981),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1932] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1932),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(3102),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1933] = {
    [sym__variable_designation] = STATE(2808),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1933),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2809),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1934] = {
    [sym__variable_designation] = STATE(2800),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1934),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2813),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1935] = {
    [sym__preprocessor_call] = STATE(1935),
    [sym__identifier_token] = ACTIONS(2844),
    [anon_sym_alias] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_global] = ACTIONS(2844),
    [anon_sym_EQ] = ACTIONS(2844),
    [anon_sym_COLON_COLON] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2844),
    [anon_sym_COMMA] = ACTIONS(2847),
    [anon_sym_GT] = ACTIONS(2844),
    [anon_sym_DOT] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2844),
    [anon_sym_QMARK] = ACTIONS(2844),
    [anon_sym_notnull] = ACTIONS(2844),
    [anon_sym_unmanaged] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_PERCENT] = ACTIONS(2844),
    [anon_sym_CARET] = ACTIONS(2844),
    [anon_sym_PIPE] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2844),
    [anon_sym_LT_LT] = ACTIONS(2844),
    [anon_sym_GT_GT] = ACTIONS(2844),
    [anon_sym_EQ_EQ] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_GT_EQ] = ACTIONS(2847),
    [anon_sym_LT_EQ] = ACTIONS(2847),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_add] = ACTIONS(2844),
    [anon_sym_remove] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_when] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_PLUS_EQ] = ACTIONS(2847),
    [anon_sym_DASH_EQ] = ACTIONS(2847),
    [anon_sym_STAR_EQ] = ACTIONS(2847),
    [anon_sym_SLASH_EQ] = ACTIONS(2847),
    [anon_sym_PERCENT_EQ] = ACTIONS(2847),
    [anon_sym_AMP_EQ] = ACTIONS(2847),
    [anon_sym_CARET_EQ] = ACTIONS(2847),
    [anon_sym_PIPE_EQ] = ACTIONS(2847),
    [anon_sym_LT_LT_EQ] = ACTIONS(2847),
    [anon_sym_GT_GT_EQ] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2847),
    [anon_sym_is] = ACTIONS(2844),
    [anon_sym_DASH_GT] = ACTIONS(2847),
    [anon_sym_from] = ACTIONS(2844),
    [anon_sym_join] = ACTIONS(2844),
    [anon_sym_on] = ACTIONS(2844),
    [anon_sym_equals] = ACTIONS(2844),
    [anon_sym_into] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_orderby] = ACTIONS(2844),
    [anon_sym_ascending] = ACTIONS(2844),
    [anon_sym_descending] = ACTIONS(2844),
    [anon_sym_group] = ACTIONS(2844),
    [anon_sym_by] = ACTIONS(2844),
    [anon_sym_select] = ACTIONS(2844),
    [anon_sym_DOT_DOT] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK] = ACTIONS(2844),
    [anon_sym_as] = ACTIONS(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2844),
    [anon_sym_nameof] = ACTIONS(2844),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1936] = {
    [sym__variable_designation] = STATE(2786),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1936),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2825),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1937] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1937),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2809),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1938] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1938),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1939] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1939),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2813),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1940] = {
    [sym__variable_designation] = STATE(2948),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1940),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2825),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1941] = {
    [sym__variable_designation] = STATE(2879),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1941),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2813),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1942] = {
    [sym_type_argument_list] = STATE(1785),
    [sym_equals_value_clause] = STATE(6471),
    [sym__preprocessor_call] = STATE(1942),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2997),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(3044),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(3044),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1943] = {
    [sym__variable_designation] = STATE(3333),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1943),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2813),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2813),
    [anon_sym_join] = ACTIONS(2813),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_orderby] = ACTIONS(2813),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(2813),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(2813),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1944] = {
    [sym__variable_designation] = STATE(2808),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1944),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2809),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1945] = {
    [sym__variable_designation] = STATE(3281),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1945),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(951),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2809),
    [anon_sym_join] = ACTIONS(2809),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_orderby] = ACTIONS(2809),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(2809),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1946] = {
    [sym__variable_designation] = STATE(2800),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1946),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2813),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1947] = {
    [sym__variable_designation] = STATE(3281),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1947),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2809),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2809),
    [anon_sym_join] = ACTIONS(2809),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(2809),
    [anon_sym_let] = ACTIONS(2809),
    [anon_sym_orderby] = ACTIONS(2809),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(2809),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(2809),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1948] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6722),
    [sym__type] = STATE(4560),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4650),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1948),
    [aux_sym_event_field_declaration_repeat2] = STATE(2707),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_event] = ACTIONS(3024),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(29),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(2679),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(29),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_implicit] = ACTIONS(3026),
    [anon_sym_explicit] = ACTIONS(3026),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(3030),
    [anon_sym_struct] = ACTIONS(3032),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_enum] = ACTIONS(3034),
    [anon_sym_interface] = ACTIONS(3036),
    [anon_sym_delegate] = ACTIONS(3038),
    [anon_sym_record] = ACTIONS(3040),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3042),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1949] = {
    [sym__variable_designation] = STATE(2786),
    [sym_parenthesized_variable_designation] = STATE(2811),
    [sym_identifier] = STATE(2811),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1949),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2792),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2778),
    [anon_sym_equals] = ACTIONS(2825),
    [anon_sym_into] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1950] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1950),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1951] = {
    [sym__variable_designation] = STATE(3333),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1951),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(2813),
    [anon_sym_LT] = ACTIONS(2813),
    [anon_sym_GT] = ACTIONS(2813),
    [anon_sym_DOT] = ACTIONS(2813),
    [anon_sym_LBRACK] = ACTIONS(2811),
    [anon_sym_LPAREN] = ACTIONS(2811),
    [anon_sym_where] = ACTIONS(2813),
    [anon_sym_QMARK] = ACTIONS(2813),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(2813),
    [anon_sym_PLUS_PLUS] = ACTIONS(2811),
    [anon_sym_DASH_DASH] = ACTIONS(2811),
    [anon_sym_PLUS] = ACTIONS(2813),
    [anon_sym_DASH] = ACTIONS(2813),
    [anon_sym_STAR] = ACTIONS(2813),
    [anon_sym_SLASH] = ACTIONS(2813),
    [anon_sym_PERCENT] = ACTIONS(2813),
    [anon_sym_CARET] = ACTIONS(2813),
    [anon_sym_PIPE] = ACTIONS(2813),
    [anon_sym_AMP] = ACTIONS(2813),
    [anon_sym_LT_LT] = ACTIONS(2813),
    [anon_sym_GT_GT] = ACTIONS(2813),
    [anon_sym_EQ_EQ] = ACTIONS(2811),
    [anon_sym_BANG_EQ] = ACTIONS(2811),
    [anon_sym_GT_EQ] = ACTIONS(2811),
    [anon_sym_LT_EQ] = ACTIONS(2811),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_switch] = ACTIONS(2813),
    [anon_sym_and] = ACTIONS(2813),
    [anon_sym_or] = ACTIONS(2813),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(2811),
    [anon_sym_DASH_EQ] = ACTIONS(2811),
    [anon_sym_STAR_EQ] = ACTIONS(2811),
    [anon_sym_SLASH_EQ] = ACTIONS(2811),
    [anon_sym_PERCENT_EQ] = ACTIONS(2811),
    [anon_sym_AMP_EQ] = ACTIONS(2811),
    [anon_sym_CARET_EQ] = ACTIONS(2811),
    [anon_sym_PIPE_EQ] = ACTIONS(2811),
    [anon_sym_LT_LT_EQ] = ACTIONS(2811),
    [anon_sym_GT_GT_EQ] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2811),
    [anon_sym_is] = ACTIONS(2813),
    [anon_sym_DASH_GT] = ACTIONS(2811),
    [anon_sym_from] = ACTIONS(2813),
    [anon_sym_join] = ACTIONS(2813),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(2813),
    [anon_sym_let] = ACTIONS(2813),
    [anon_sym_orderby] = ACTIONS(2813),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(2813),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(2813),
    [anon_sym_DOT_DOT] = ACTIONS(2811),
    [anon_sym_with] = ACTIONS(2813),
    [anon_sym_AMP_AMP] = ACTIONS(2811),
    [anon_sym_PIPE_PIPE] = ACTIONS(2811),
    [anon_sym_QMARK_QMARK] = ACTIONS(2813),
    [anon_sym_as] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1952] = {
    [sym__variable_designation] = STATE(3339),
    [sym_parenthesized_variable_designation] = STATE(3309),
    [sym_identifier] = STATE(3309),
    [sym__contextual_keywords] = STATE(2059),
    [sym__preprocessor_call] = STATE(1952),
    [sym__identifier_token] = ACTIONS(867),
    [anon_sym_alias] = ACTIONS(869),
    [anon_sym_global] = ACTIONS(869),
    [anon_sym_EQ] = ACTIONS(2825),
    [anon_sym_LT] = ACTIONS(2825),
    [anon_sym_GT] = ACTIONS(2825),
    [anon_sym_DOT] = ACTIONS(2825),
    [anon_sym_LBRACK] = ACTIONS(2823),
    [anon_sym_LPAREN] = ACTIONS(2823),
    [anon_sym_where] = ACTIONS(2825),
    [anon_sym_QMARK] = ACTIONS(2825),
    [anon_sym_notnull] = ACTIONS(869),
    [anon_sym_unmanaged] = ACTIONS(869),
    [anon_sym_BANG] = ACTIONS(2825),
    [anon_sym_PLUS_PLUS] = ACTIONS(2823),
    [anon_sym_DASH_DASH] = ACTIONS(2823),
    [anon_sym_PLUS] = ACTIONS(2825),
    [anon_sym_DASH] = ACTIONS(2825),
    [anon_sym_STAR] = ACTIONS(2825),
    [anon_sym_SLASH] = ACTIONS(2825),
    [anon_sym_PERCENT] = ACTIONS(2825),
    [anon_sym_CARET] = ACTIONS(2825),
    [anon_sym_PIPE] = ACTIONS(2825),
    [anon_sym_AMP] = ACTIONS(2825),
    [anon_sym_LT_LT] = ACTIONS(2825),
    [anon_sym_GT_GT] = ACTIONS(2825),
    [anon_sym_EQ_EQ] = ACTIONS(2823),
    [anon_sym_BANG_EQ] = ACTIONS(2823),
    [anon_sym_GT_EQ] = ACTIONS(2823),
    [anon_sym_LT_EQ] = ACTIONS(2823),
    [anon_sym_get] = ACTIONS(869),
    [anon_sym_set] = ACTIONS(869),
    [anon_sym_add] = ACTIONS(869),
    [anon_sym_remove] = ACTIONS(869),
    [anon_sym_switch] = ACTIONS(2825),
    [anon_sym_and] = ACTIONS(2825),
    [anon_sym_or] = ACTIONS(2825),
    [sym_discard] = ACTIONS(2975),
    [anon_sym_when] = ACTIONS(869),
    [anon_sym_yield] = ACTIONS(869),
    [anon_sym_PLUS_EQ] = ACTIONS(2823),
    [anon_sym_DASH_EQ] = ACTIONS(2823),
    [anon_sym_STAR_EQ] = ACTIONS(2823),
    [anon_sym_SLASH_EQ] = ACTIONS(2823),
    [anon_sym_PERCENT_EQ] = ACTIONS(2823),
    [anon_sym_AMP_EQ] = ACTIONS(2823),
    [anon_sym_CARET_EQ] = ACTIONS(2823),
    [anon_sym_PIPE_EQ] = ACTIONS(2823),
    [anon_sym_LT_LT_EQ] = ACTIONS(2823),
    [anon_sym_GT_GT_EQ] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2823),
    [anon_sym_is] = ACTIONS(2825),
    [anon_sym_DASH_GT] = ACTIONS(2823),
    [anon_sym_from] = ACTIONS(2825),
    [anon_sym_join] = ACTIONS(2825),
    [anon_sym_on] = ACTIONS(869),
    [anon_sym_equals] = ACTIONS(869),
    [anon_sym_into] = ACTIONS(2825),
    [anon_sym_let] = ACTIONS(2825),
    [anon_sym_orderby] = ACTIONS(2825),
    [anon_sym_ascending] = ACTIONS(869),
    [anon_sym_descending] = ACTIONS(869),
    [anon_sym_group] = ACTIONS(2825),
    [anon_sym_by] = ACTIONS(869),
    [anon_sym_select] = ACTIONS(2825),
    [anon_sym_DOT_DOT] = ACTIONS(2823),
    [anon_sym_with] = ACTIONS(2825),
    [anon_sym_AMP_AMP] = ACTIONS(2823),
    [anon_sym_PIPE_PIPE] = ACTIONS(2823),
    [anon_sym_QMARK_QMARK] = ACTIONS(2825),
    [anon_sym_as] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(869),
    [anon_sym_nameof] = ACTIONS(869),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1953] = {
    [sym__variable_designation] = STATE(2957),
    [sym_parenthesized_variable_designation] = STATE(2947),
    [sym_identifier] = STATE(2947),
    [sym__contextual_keywords] = STATE(2643),
    [sym__preprocessor_call] = STATE(1953),
    [sym__identifier_token] = ACTIONS(2776),
    [anon_sym_alias] = ACTIONS(2778),
    [anon_sym_global] = ACTIONS(2778),
    [anon_sym_EQ] = ACTIONS(2809),
    [anon_sym_LT] = ACTIONS(2809),
    [anon_sym_GT] = ACTIONS(2809),
    [anon_sym_DOT] = ACTIONS(2809),
    [anon_sym_LBRACK] = ACTIONS(2807),
    [anon_sym_LPAREN] = ACTIONS(2807),
    [anon_sym_where] = ACTIONS(2778),
    [anon_sym_QMARK] = ACTIONS(2809),
    [anon_sym_notnull] = ACTIONS(2778),
    [anon_sym_unmanaged] = ACTIONS(2778),
    [anon_sym_BANG] = ACTIONS(2809),
    [anon_sym_PLUS_PLUS] = ACTIONS(2807),
    [anon_sym_DASH_DASH] = ACTIONS(2807),
    [anon_sym_PLUS] = ACTIONS(2809),
    [anon_sym_DASH] = ACTIONS(2809),
    [anon_sym_STAR] = ACTIONS(2809),
    [anon_sym_SLASH] = ACTIONS(2809),
    [anon_sym_PERCENT] = ACTIONS(2809),
    [anon_sym_CARET] = ACTIONS(2809),
    [anon_sym_PIPE] = ACTIONS(2809),
    [anon_sym_AMP] = ACTIONS(2809),
    [anon_sym_LT_LT] = ACTIONS(2809),
    [anon_sym_GT_GT] = ACTIONS(2809),
    [anon_sym_EQ_EQ] = ACTIONS(2807),
    [anon_sym_BANG_EQ] = ACTIONS(2807),
    [anon_sym_GT_EQ] = ACTIONS(2807),
    [anon_sym_LT_EQ] = ACTIONS(2807),
    [anon_sym_get] = ACTIONS(2778),
    [anon_sym_set] = ACTIONS(2778),
    [anon_sym_add] = ACTIONS(2778),
    [anon_sym_remove] = ACTIONS(2778),
    [anon_sym_switch] = ACTIONS(2809),
    [anon_sym_and] = ACTIONS(2809),
    [anon_sym_or] = ACTIONS(2809),
    [sym_discard] = ACTIONS(2802),
    [anon_sym_when] = ACTIONS(2778),
    [anon_sym_yield] = ACTIONS(2778),
    [anon_sym_PLUS_EQ] = ACTIONS(2807),
    [anon_sym_DASH_EQ] = ACTIONS(2807),
    [anon_sym_STAR_EQ] = ACTIONS(2807),
    [anon_sym_SLASH_EQ] = ACTIONS(2807),
    [anon_sym_PERCENT_EQ] = ACTIONS(2807),
    [anon_sym_AMP_EQ] = ACTIONS(2807),
    [anon_sym_CARET_EQ] = ACTIONS(2807),
    [anon_sym_PIPE_EQ] = ACTIONS(2807),
    [anon_sym_LT_LT_EQ] = ACTIONS(2807),
    [anon_sym_GT_GT_EQ] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2807),
    [anon_sym_is] = ACTIONS(2809),
    [anon_sym_DASH_GT] = ACTIONS(2807),
    [anon_sym_from] = ACTIONS(2778),
    [anon_sym_join] = ACTIONS(2778),
    [anon_sym_on] = ACTIONS(2809),
    [anon_sym_equals] = ACTIONS(2778),
    [anon_sym_into] = ACTIONS(2778),
    [anon_sym_let] = ACTIONS(2778),
    [anon_sym_orderby] = ACTIONS(2778),
    [anon_sym_ascending] = ACTIONS(2778),
    [anon_sym_descending] = ACTIONS(2778),
    [anon_sym_group] = ACTIONS(2778),
    [anon_sym_by] = ACTIONS(2778),
    [anon_sym_select] = ACTIONS(2778),
    [anon_sym_DOT_DOT] = ACTIONS(2807),
    [anon_sym_with] = ACTIONS(2809),
    [anon_sym_AMP_AMP] = ACTIONS(2807),
    [anon_sym_PIPE_PIPE] = ACTIONS(2807),
    [anon_sym_QMARK_QMARK] = ACTIONS(2809),
    [anon_sym_as] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2778),
    [anon_sym_nameof] = ACTIONS(2778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1954] = {
    [sym__preprocessor_call] = STATE(1954),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(3097),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1955] = {
    [sym_type_argument_list] = STATE(1785),
    [sym_equals_value_clause] = STATE(6259),
    [sym__preprocessor_call] = STATE(1955),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2997),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(3099),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1956] = {
    [sym__preprocessor_call] = STATE(1956),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_EQ_GT] = ACTIONS(2919),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2930),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1957] = {
    [sym__preprocessor_call] = STATE(1957),
    [sym__identifier_token] = ACTIONS(3106),
    [anon_sym_alias] = ACTIONS(3106),
    [anon_sym_global] = ACTIONS(3106),
    [anon_sym_static] = ACTIONS(3106),
    [anon_sym_LT] = ACTIONS(3106),
    [anon_sym_GT] = ACTIONS(3106),
    [anon_sym_LBRACK] = ACTIONS(3108),
    [anon_sym_LPAREN] = ACTIONS(3108),
    [anon_sym_async] = ACTIONS(3106),
    [anon_sym_new] = ACTIONS(3106),
    [anon_sym_ref] = ACTIONS(3106),
    [anon_sym_this] = ACTIONS(3106),
    [anon_sym_base] = ACTIONS(3106),
    [anon_sym_LBRACE] = ACTIONS(3108),
    [anon_sym_TILDE] = ACTIONS(3108),
    [anon_sym_where] = ACTIONS(3106),
    [anon_sym_notnull] = ACTIONS(3106),
    [anon_sym_unmanaged] = ACTIONS(3106),
    [anon_sym_BANG] = ACTIONS(3108),
    [anon_sym_PLUS_PLUS] = ACTIONS(3108),
    [anon_sym_DASH_DASH] = ACTIONS(3108),
    [anon_sym_true] = ACTIONS(3106),
    [anon_sym_false] = ACTIONS(3106),
    [anon_sym_PLUS] = ACTIONS(3106),
    [anon_sym_DASH] = ACTIONS(3106),
    [anon_sym_STAR] = ACTIONS(3108),
    [anon_sym_CARET] = ACTIONS(3108),
    [anon_sym_AMP] = ACTIONS(3108),
    [anon_sym_GT_EQ] = ACTIONS(3108),
    [anon_sym_LT_EQ] = ACTIONS(3108),
    [anon_sym_get] = ACTIONS(3106),
    [anon_sym_set] = ACTIONS(3106),
    [anon_sym_add] = ACTIONS(3106),
    [anon_sym_remove] = ACTIONS(3106),
    [anon_sym_delegate] = ACTIONS(3106),
    [anon_sym_var] = ACTIONS(3106),
    [sym_predefined_type] = ACTIONS(3106),
    [anon_sym_checked] = ACTIONS(3106),
    [anon_sym_unchecked] = ACTIONS(3106),
    [anon_sym_await] = ACTIONS(3106),
    [anon_sym_default] = ACTIONS(3106),
    [anon_sym_not] = ACTIONS(3106),
    [sym_discard] = ACTIONS(3106),
    [anon_sym_when] = ACTIONS(3106),
    [anon_sym_throw] = ACTIONS(3106),
    [anon_sym_yield] = ACTIONS(3106),
    [anon_sym_stackalloc] = ACTIONS(3106),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3108),
    [anon_sym_DQUOTE] = ACTIONS(3108),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(3108),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(3108),
    [anon_sym___makeref] = ACTIONS(3106),
    [anon_sym_from] = ACTIONS(3106),
    [anon_sym_join] = ACTIONS(3106),
    [anon_sym_on] = ACTIONS(3106),
    [anon_sym_equals] = ACTIONS(3106),
    [anon_sym_into] = ACTIONS(3106),
    [anon_sym_let] = ACTIONS(3106),
    [anon_sym_orderby] = ACTIONS(3106),
    [anon_sym_ascending] = ACTIONS(3106),
    [anon_sym_descending] = ACTIONS(3106),
    [anon_sym_group] = ACTIONS(3106),
    [anon_sym_by] = ACTIONS(3106),
    [anon_sym_select] = ACTIONS(3106),
    [anon_sym_DOT_DOT] = ACTIONS(3108),
    [anon_sym___reftype] = ACTIONS(3106),
    [anon_sym___refvalue] = ACTIONS(3106),
    [anon_sym_sizeof] = ACTIONS(3106),
    [anon_sym_typeof] = ACTIONS(3106),
    [anon_sym_SQUOTE] = ACTIONS(3108),
    [sym_integer_literal] = ACTIONS(3106),
    [sym_null_literal] = ACTIONS(3106),
    [sym_real_literal] = ACTIONS(3108),
    [sym_verbatim_string_literal] = ACTIONS(3108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3106),
    [anon_sym_nameof] = ACTIONS(3106),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1958] = {
    [sym_type_argument_list] = STATE(1785),
    [sym_equals_value_clause] = STATE(6259),
    [sym__preprocessor_call] = STATE(1958),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2997),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_COMMA] = ACTIONS(3099),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(3110),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1959] = {
    [sym__preprocessor_call] = STATE(1959),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_COLON] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_EQ_GT] = ACTIONS(2852),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2855),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1960] = {
    [sym__preprocessor_call] = STATE(1960),
    [sym__identifier_token] = ACTIONS(2734),
    [anon_sym_alias] = ACTIONS(2734),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_global] = ACTIONS(2734),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_return] = ACTIONS(3112),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2734),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_notnull] = ACTIONS(2734),
    [anon_sym_unmanaged] = ACTIONS(2734),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_get] = ACTIONS(2734),
    [anon_sym_set] = ACTIONS(2734),
    [anon_sym_add] = ACTIONS(2734),
    [anon_sym_remove] = ACTIONS(2734),
    [anon_sym_break] = ACTIONS(3114),
    [anon_sym_switch] = ACTIONS(2734),
    [anon_sym_when] = ACTIONS(2734),
    [anon_sym_yield] = ACTIONS(2734),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2734),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2734),
    [anon_sym_join] = ACTIONS(2734),
    [anon_sym_on] = ACTIONS(2734),
    [anon_sym_equals] = ACTIONS(2734),
    [anon_sym_into] = ACTIONS(2734),
    [anon_sym_let] = ACTIONS(2734),
    [anon_sym_orderby] = ACTIONS(2734),
    [anon_sym_ascending] = ACTIONS(2734),
    [anon_sym_descending] = ACTIONS(2734),
    [anon_sym_group] = ACTIONS(2734),
    [anon_sym_by] = ACTIONS(2734),
    [anon_sym_select] = ACTIONS(2734),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2734),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2734),
    [anon_sym_nameof] = ACTIONS(2734),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1961] = {
    [sym__preprocessor_call] = STATE(1961),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_COLON] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_EQ_GT] = ACTIONS(2852),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2855),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1962] = {
    [sym__preprocessor_call] = STATE(1962),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_EQ_GT] = ACTIONS(2919),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2930),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1963] = {
    [sym__preprocessor_call] = STATE(1963),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_COLON] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_EQ_GT] = ACTIONS(2852),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2855),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1964] = {
    [sym__preprocessor_call] = STATE(1964),
    [sym__identifier_token] = ACTIONS(2844),
    [anon_sym_alias] = ACTIONS(2844),
    [anon_sym_global] = ACTIONS(2844),
    [anon_sym_EQ] = ACTIONS(2844),
    [anon_sym_COLON_COLON] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2844),
    [anon_sym_GT] = ACTIONS(2844),
    [anon_sym_DOT] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_EQ_GT] = ACTIONS(2847),
    [anon_sym_where] = ACTIONS(2844),
    [anon_sym_QMARK] = ACTIONS(2844),
    [anon_sym_notnull] = ACTIONS(2844),
    [anon_sym_unmanaged] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_PERCENT] = ACTIONS(2844),
    [anon_sym_CARET] = ACTIONS(2844),
    [anon_sym_PIPE] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2844),
    [anon_sym_LT_LT] = ACTIONS(2844),
    [anon_sym_GT_GT] = ACTIONS(2844),
    [anon_sym_EQ_EQ] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_GT_EQ] = ACTIONS(2847),
    [anon_sym_LT_EQ] = ACTIONS(2847),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_add] = ACTIONS(2844),
    [anon_sym_remove] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_and] = ACTIONS(2844),
    [anon_sym_or] = ACTIONS(2844),
    [sym_discard] = ACTIONS(2844),
    [anon_sym_when] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_PLUS_EQ] = ACTIONS(2847),
    [anon_sym_DASH_EQ] = ACTIONS(2847),
    [anon_sym_STAR_EQ] = ACTIONS(2847),
    [anon_sym_SLASH_EQ] = ACTIONS(2847),
    [anon_sym_PERCENT_EQ] = ACTIONS(2847),
    [anon_sym_AMP_EQ] = ACTIONS(2847),
    [anon_sym_CARET_EQ] = ACTIONS(2847),
    [anon_sym_PIPE_EQ] = ACTIONS(2847),
    [anon_sym_LT_LT_EQ] = ACTIONS(2847),
    [anon_sym_GT_GT_EQ] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2847),
    [anon_sym_is] = ACTIONS(2844),
    [anon_sym_DASH_GT] = ACTIONS(2847),
    [anon_sym_from] = ACTIONS(2844),
    [anon_sym_join] = ACTIONS(2844),
    [anon_sym_on] = ACTIONS(2844),
    [anon_sym_equals] = ACTIONS(2844),
    [anon_sym_into] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_orderby] = ACTIONS(2844),
    [anon_sym_ascending] = ACTIONS(2844),
    [anon_sym_descending] = ACTIONS(2844),
    [anon_sym_group] = ACTIONS(2844),
    [anon_sym_by] = ACTIONS(2844),
    [anon_sym_select] = ACTIONS(2844),
    [anon_sym_DOT_DOT] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK] = ACTIONS(2844),
    [anon_sym_as] = ACTIONS(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2844),
    [anon_sym_nameof] = ACTIONS(2844),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1965] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(2669),
    [sym_modifier] = STATE(2909),
    [sym__type] = STATE(4849),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1965),
    [aux_sym_event_field_declaration_repeat1] = STATE(2628),
    [aux_sym_event_field_declaration_repeat2] = STATE(2023),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_LBRACK] = ACTIONS(2673),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(29),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(2679),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(29),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_struct] = ACTIONS(3118),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_enum] = ACTIONS(3120),
    [anon_sym_interface] = ACTIONS(3122),
    [anon_sym_delegate] = ACTIONS(3124),
    [anon_sym_record] = ACTIONS(3126),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3128),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1966] = {
    [sym__preprocessor_call] = STATE(1966),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_COLON] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_EQ_GT] = ACTIONS(2919),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2930),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1967] = {
    [sym__preprocessor_call] = STATE(1967),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_and] = ACTIONS(2827),
    [anon_sym_or] = ACTIONS(2827),
    [sym_discard] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1968] = {
    [sym__preprocessor_call] = STATE(1968),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3130),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3132),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1969] = {
    [sym__preprocessor_call] = STATE(1969),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3134),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1970] = {
    [sym__preprocessor_call] = STATE(1970),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3136),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3138),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1971] = {
    [sym__preprocessor_call] = STATE(1971),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2852),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2855),
    [anon_sym_join] = ACTIONS(2855),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_orderby] = ACTIONS(2855),
    [anon_sym_ascending] = ACTIONS(2855),
    [anon_sym_descending] = ACTIONS(2855),
    [anon_sym_group] = ACTIONS(2855),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1972] = {
    [sym__preprocessor_call] = STATE(1972),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3140),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1973] = {
    [sym__preprocessor_call] = STATE(1973),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3132),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1974] = {
    [sym__preprocessor_call] = STATE(1974),
    [sym__identifier_token] = ACTIONS(2965),
    [anon_sym_alias] = ACTIONS(2965),
    [anon_sym_global] = ACTIONS(2965),
    [anon_sym_EQ] = ACTIONS(2965),
    [anon_sym_LT] = ACTIONS(2965),
    [anon_sym_GT] = ACTIONS(2965),
    [anon_sym_DOT] = ACTIONS(2965),
    [anon_sym_LBRACK] = ACTIONS(2967),
    [anon_sym_LPAREN] = ACTIONS(2967),
    [anon_sym_LBRACE] = ACTIONS(2967),
    [anon_sym_EQ_GT] = ACTIONS(2967),
    [anon_sym_where] = ACTIONS(2965),
    [anon_sym_QMARK] = ACTIONS(2965),
    [anon_sym_notnull] = ACTIONS(2965),
    [anon_sym_unmanaged] = ACTIONS(2965),
    [anon_sym_BANG] = ACTIONS(2965),
    [anon_sym_PLUS_PLUS] = ACTIONS(2967),
    [anon_sym_DASH_DASH] = ACTIONS(2967),
    [anon_sym_PLUS] = ACTIONS(2965),
    [anon_sym_DASH] = ACTIONS(2965),
    [anon_sym_STAR] = ACTIONS(2965),
    [anon_sym_SLASH] = ACTIONS(2965),
    [anon_sym_PERCENT] = ACTIONS(2965),
    [anon_sym_CARET] = ACTIONS(2965),
    [anon_sym_PIPE] = ACTIONS(2965),
    [anon_sym_AMP] = ACTIONS(2965),
    [anon_sym_LT_LT] = ACTIONS(2965),
    [anon_sym_GT_GT] = ACTIONS(2965),
    [anon_sym_EQ_EQ] = ACTIONS(2967),
    [anon_sym_BANG_EQ] = ACTIONS(2967),
    [anon_sym_GT_EQ] = ACTIONS(2967),
    [anon_sym_LT_EQ] = ACTIONS(2967),
    [anon_sym_get] = ACTIONS(2965),
    [anon_sym_set] = ACTIONS(2965),
    [anon_sym_add] = ACTIONS(2965),
    [anon_sym_remove] = ACTIONS(2965),
    [anon_sym_switch] = ACTIONS(2965),
    [anon_sym_and] = ACTIONS(2965),
    [anon_sym_or] = ACTIONS(2965),
    [sym_discard] = ACTIONS(2965),
    [anon_sym_when] = ACTIONS(2965),
    [anon_sym_yield] = ACTIONS(2965),
    [anon_sym_PLUS_EQ] = ACTIONS(2967),
    [anon_sym_DASH_EQ] = ACTIONS(2967),
    [anon_sym_STAR_EQ] = ACTIONS(2967),
    [anon_sym_SLASH_EQ] = ACTIONS(2967),
    [anon_sym_PERCENT_EQ] = ACTIONS(2967),
    [anon_sym_AMP_EQ] = ACTIONS(2967),
    [anon_sym_CARET_EQ] = ACTIONS(2967),
    [anon_sym_PIPE_EQ] = ACTIONS(2967),
    [anon_sym_LT_LT_EQ] = ACTIONS(2967),
    [anon_sym_GT_GT_EQ] = ACTIONS(2967),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2967),
    [anon_sym_is] = ACTIONS(2965),
    [anon_sym_DASH_GT] = ACTIONS(2967),
    [anon_sym_from] = ACTIONS(2965),
    [anon_sym_join] = ACTIONS(2965),
    [anon_sym_on] = ACTIONS(2965),
    [anon_sym_equals] = ACTIONS(2965),
    [anon_sym_into] = ACTIONS(2965),
    [anon_sym_let] = ACTIONS(2965),
    [anon_sym_orderby] = ACTIONS(2965),
    [anon_sym_ascending] = ACTIONS(2965),
    [anon_sym_descending] = ACTIONS(2965),
    [anon_sym_group] = ACTIONS(2965),
    [anon_sym_by] = ACTIONS(2965),
    [anon_sym_select] = ACTIONS(2965),
    [anon_sym_DOT_DOT] = ACTIONS(2967),
    [anon_sym_with] = ACTIONS(2965),
    [anon_sym_AMP_AMP] = ACTIONS(2967),
    [anon_sym_PIPE_PIPE] = ACTIONS(2967),
    [anon_sym_QMARK_QMARK] = ACTIONS(2965),
    [anon_sym_as] = ACTIONS(2965),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2965),
    [anon_sym_nameof] = ACTIONS(2965),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1975] = {
    [sym__preprocessor_call] = STATE(1975),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_COMMA] = ACTIONS(2852),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2855),
    [anon_sym_join] = ACTIONS(2855),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_orderby] = ACTIONS(2855),
    [anon_sym_ascending] = ACTIONS(2855),
    [anon_sym_descending] = ACTIONS(2855),
    [anon_sym_group] = ACTIONS(2855),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1976] = {
    [sym__preprocessor_call] = STATE(1976),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(3104),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1977] = {
    [sym__preprocessor_call] = STATE(1977),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3144),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1978] = {
    [sym__preprocessor_call] = STATE(1978),
    [sym__identifier_token] = ACTIONS(2844),
    [anon_sym_alias] = ACTIONS(2844),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_global] = ACTIONS(2844),
    [anon_sym_using] = ACTIONS(3146),
    [anon_sym_EQ] = ACTIONS(2844),
    [anon_sym_COLON_COLON] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2844),
    [anon_sym_GT] = ACTIONS(2844),
    [anon_sym_DOT] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2844),
    [anon_sym_QMARK] = ACTIONS(2844),
    [anon_sym_notnull] = ACTIONS(2844),
    [anon_sym_unmanaged] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_PERCENT] = ACTIONS(2844),
    [anon_sym_CARET] = ACTIONS(2844),
    [anon_sym_PIPE] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2844),
    [anon_sym_LT_LT] = ACTIONS(2844),
    [anon_sym_GT_GT] = ACTIONS(2844),
    [anon_sym_EQ_EQ] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_GT_EQ] = ACTIONS(2847),
    [anon_sym_LT_EQ] = ACTIONS(2847),
    [anon_sym_get] = ACTIONS(2844),
    [anon_sym_set] = ACTIONS(2844),
    [anon_sym_add] = ACTIONS(2844),
    [anon_sym_remove] = ACTIONS(2844),
    [anon_sym_switch] = ACTIONS(2844),
    [anon_sym_when] = ACTIONS(2844),
    [anon_sym_yield] = ACTIONS(2844),
    [anon_sym_PLUS_EQ] = ACTIONS(2847),
    [anon_sym_DASH_EQ] = ACTIONS(2847),
    [anon_sym_STAR_EQ] = ACTIONS(2847),
    [anon_sym_SLASH_EQ] = ACTIONS(2847),
    [anon_sym_PERCENT_EQ] = ACTIONS(2847),
    [anon_sym_AMP_EQ] = ACTIONS(2847),
    [anon_sym_CARET_EQ] = ACTIONS(2847),
    [anon_sym_PIPE_EQ] = ACTIONS(2847),
    [anon_sym_LT_LT_EQ] = ACTIONS(2847),
    [anon_sym_GT_GT_EQ] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2847),
    [anon_sym_is] = ACTIONS(2844),
    [anon_sym_DASH_GT] = ACTIONS(2847),
    [anon_sym_from] = ACTIONS(2844),
    [anon_sym_join] = ACTIONS(2844),
    [anon_sym_on] = ACTIONS(2844),
    [anon_sym_equals] = ACTIONS(2844),
    [anon_sym_into] = ACTIONS(2844),
    [anon_sym_let] = ACTIONS(2844),
    [anon_sym_orderby] = ACTIONS(2844),
    [anon_sym_ascending] = ACTIONS(2844),
    [anon_sym_descending] = ACTIONS(2844),
    [anon_sym_group] = ACTIONS(2844),
    [anon_sym_by] = ACTIONS(2844),
    [anon_sym_select] = ACTIONS(2844),
    [anon_sym_DOT_DOT] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2844),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK] = ACTIONS(2844),
    [anon_sym_as] = ACTIONS(2844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2844),
    [anon_sym_nameof] = ACTIONS(2844),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1979] = {
    [sym__preprocessor_call] = STATE(1979),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3148),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1980] = {
    [sym__preprocessor_call] = STATE(1980),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2930),
    [anon_sym_join] = ACTIONS(2930),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_orderby] = ACTIONS(2930),
    [anon_sym_ascending] = ACTIONS(2930),
    [anon_sym_descending] = ACTIONS(2930),
    [anon_sym_group] = ACTIONS(2930),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2930),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1981] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1981),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(3150),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1982] = {
    [sym__preprocessor_call] = STATE(1982),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3049),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3138),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1983] = {
    [sym__preprocessor_call] = STATE(1983),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_COLON] = ACTIONS(2919),
    [anon_sym_LPAREN] = ACTIONS(3072),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2930),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1984] = {
    [sym__preprocessor_call] = STATE(1984),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_COMMA] = ACTIONS(2919),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2930),
    [anon_sym_join] = ACTIONS(2930),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_orderby] = ACTIONS(2930),
    [anon_sym_ascending] = ACTIONS(2930),
    [anon_sym_descending] = ACTIONS(2930),
    [anon_sym_group] = ACTIONS(2930),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2930),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1985] = {
    [sym__preprocessor_call] = STATE(1985),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3152),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1986] = {
    [sym__preprocessor_call] = STATE(1986),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3154),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3132),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1987] = {
    [sym__preprocessor_call] = STATE(1987),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1988] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1988),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(3158),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2842),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1989] = {
    [sym__preprocessor_call] = STATE(1989),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2855),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1990] = {
    [sym__preprocessor_call] = STATE(1990),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2930),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1991] = {
    [sym__preprocessor_call] = STATE(1991),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2930),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1992] = {
    [sym_type_argument_list] = STATE(1785),
    [sym__preprocessor_call] = STATE(1992),
    [sym__identifier_token] = ACTIONS(2827),
    [anon_sym_alias] = ACTIONS(2827),
    [anon_sym_global] = ACTIONS(2827),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(2831),
    [anon_sym_LT] = ACTIONS(2837),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_EQ_GT] = ACTIONS(3160),
    [anon_sym_where] = ACTIONS(2827),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_notnull] = ACTIONS(2827),
    [anon_sym_unmanaged] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_get] = ACTIONS(2827),
    [anon_sym_set] = ACTIONS(2827),
    [anon_sym_add] = ACTIONS(2827),
    [anon_sym_remove] = ACTIONS(2827),
    [anon_sym_switch] = ACTIONS(2827),
    [anon_sym_when] = ACTIONS(2827),
    [anon_sym_yield] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2827),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2827),
    [anon_sym_join] = ACTIONS(2827),
    [anon_sym_on] = ACTIONS(2827),
    [anon_sym_equals] = ACTIONS(2827),
    [anon_sym_into] = ACTIONS(2827),
    [anon_sym_let] = ACTIONS(2827),
    [anon_sym_orderby] = ACTIONS(2827),
    [anon_sym_ascending] = ACTIONS(2827),
    [anon_sym_descending] = ACTIONS(2827),
    [anon_sym_group] = ACTIONS(2827),
    [anon_sym_by] = ACTIONS(2827),
    [anon_sym_select] = ACTIONS(2827),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2827),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2827),
    [anon_sym_nameof] = ACTIONS(2827),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1993] = {
    [sym__preprocessor_call] = STATE(1993),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1994] = {
    [sym__preprocessor_call] = STATE(1994),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2930),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1995] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(2909),
    [sym_variable_declaration] = STATE(6679),
    [sym__type] = STATE(4698),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(1995),
    [aux_sym_event_field_declaration_repeat2] = STATE(2707),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(29),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(2679),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(29),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(3116),
    [anon_sym_struct] = ACTIONS(3118),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_enum] = ACTIONS(3120),
    [anon_sym_interface] = ACTIONS(3122),
    [anon_sym_delegate] = ACTIONS(3124),
    [anon_sym_record] = ACTIONS(3126),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3128),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1996] = {
    [sym__preprocessor_call] = STATE(1996),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2855),
    [anon_sym_join] = ACTIONS(2855),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_orderby] = ACTIONS(2855),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2855),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1997] = {
    [sym__preprocessor_call] = STATE(1997),
    [sym__identifier_token] = ACTIONS(2977),
    [anon_sym_alias] = ACTIONS(2977),
    [anon_sym_global] = ACTIONS(2977),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(2979),
    [anon_sym_LPAREN] = ACTIONS(2979),
    [anon_sym_where] = ACTIONS(2977),
    [anon_sym_QMARK] = ACTIONS(1984),
    [anon_sym_notnull] = ACTIONS(2977),
    [anon_sym_unmanaged] = ACTIONS(2977),
    [anon_sym_BANG] = ACTIONS(1984),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1989),
    [anon_sym_get] = ACTIONS(2977),
    [anon_sym_set] = ACTIONS(2977),
    [anon_sym_add] = ACTIONS(2977),
    [anon_sym_remove] = ACTIONS(2977),
    [anon_sym_switch] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(2977),
    [anon_sym_or] = ACTIONS(2977),
    [sym_discard] = ACTIONS(2977),
    [anon_sym_when] = ACTIONS(2977),
    [anon_sym_yield] = ACTIONS(2977),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1989),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(2977),
    [anon_sym_join] = ACTIONS(2977),
    [anon_sym_on] = ACTIONS(2977),
    [anon_sym_equals] = ACTIONS(2977),
    [anon_sym_into] = ACTIONS(2977),
    [anon_sym_let] = ACTIONS(2977),
    [anon_sym_orderby] = ACTIONS(2977),
    [anon_sym_ascending] = ACTIONS(2977),
    [anon_sym_descending] = ACTIONS(2977),
    [anon_sym_group] = ACTIONS(2977),
    [anon_sym_by] = ACTIONS(2977),
    [anon_sym_select] = ACTIONS(2977),
    [anon_sym_DOT_DOT] = ACTIONS(1989),
    [anon_sym_with] = ACTIONS(1984),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2977),
    [anon_sym_nameof] = ACTIONS(2977),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1998] = {
    [sym__preprocessor_call] = STATE(1998),
    [sym__identifier_token] = ACTIONS(2989),
    [anon_sym_alias] = ACTIONS(2989),
    [anon_sym_global] = ACTIONS(2989),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_GT] = ACTIONS(3057),
    [anon_sym_DOT] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_COLON] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(2991),
    [anon_sym_where] = ACTIONS(2989),
    [anon_sym_QMARK] = ACTIONS(3057),
    [anon_sym_notnull] = ACTIONS(2989),
    [anon_sym_unmanaged] = ACTIONS(2989),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3057),
    [anon_sym_CARET] = ACTIONS(3057),
    [anon_sym_PIPE] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_LT_LT] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(3057),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_GT_EQ] = ACTIONS(3059),
    [anon_sym_LT_EQ] = ACTIONS(3059),
    [anon_sym_get] = ACTIONS(2989),
    [anon_sym_set] = ACTIONS(2989),
    [anon_sym_add] = ACTIONS(2989),
    [anon_sym_remove] = ACTIONS(2989),
    [anon_sym_switch] = ACTIONS(3057),
    [anon_sym_and] = ACTIONS(2989),
    [anon_sym_or] = ACTIONS(2989),
    [sym_discard] = ACTIONS(2989),
    [anon_sym_when] = ACTIONS(2989),
    [anon_sym_yield] = ACTIONS(2989),
    [anon_sym_PLUS_EQ] = ACTIONS(3059),
    [anon_sym_DASH_EQ] = ACTIONS(3059),
    [anon_sym_STAR_EQ] = ACTIONS(3059),
    [anon_sym_SLASH_EQ] = ACTIONS(3059),
    [anon_sym_PERCENT_EQ] = ACTIONS(3059),
    [anon_sym_AMP_EQ] = ACTIONS(3059),
    [anon_sym_CARET_EQ] = ACTIONS(3059),
    [anon_sym_PIPE_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3059),
    [anon_sym_is] = ACTIONS(3057),
    [anon_sym_DASH_GT] = ACTIONS(3059),
    [anon_sym_from] = ACTIONS(2989),
    [anon_sym_join] = ACTIONS(2989),
    [anon_sym_on] = ACTIONS(2989),
    [anon_sym_equals] = ACTIONS(2989),
    [anon_sym_into] = ACTIONS(2989),
    [anon_sym_let] = ACTIONS(2989),
    [anon_sym_orderby] = ACTIONS(2989),
    [anon_sym_ascending] = ACTIONS(2989),
    [anon_sym_descending] = ACTIONS(2989),
    [anon_sym_group] = ACTIONS(2989),
    [anon_sym_by] = ACTIONS(2989),
    [anon_sym_select] = ACTIONS(2989),
    [anon_sym_DOT_DOT] = ACTIONS(3059),
    [anon_sym_with] = ACTIONS(3057),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_QMARK_QMARK] = ACTIONS(3057),
    [anon_sym_as] = ACTIONS(3057),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2989),
    [anon_sym_nameof] = ACTIONS(2989),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [1999] = {
    [sym__name] = STATE(2629),
    [sym_alias_qualified_name] = STATE(2111),
    [sym__simple_name] = STATE(2111),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(2111),
    [sym_argument_list] = STATE(2069),
    [sym__type] = STATE(2051),
    [sym_implicit_type] = STATE(2114),
    [sym_array_type] = STATE(2065),
    [sym_nullable_type] = STATE(2114),
    [sym__nullable_base_type] = STATE(6945),
    [sym_pointer_type] = STATE(2115),
    [sym_function_pointer_type] = STATE(2115),
    [sym_tuple_type] = STATE(2115),
    [sym_identifier] = STATE(2270),
    [sym_global] = STATE(2525),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(1999),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_extern] = ACTIONS(1949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1949),
    [anon_sym_LBRACK] = ACTIONS(3164),
    [anon_sym_LPAREN] = ACTIONS(3166),
    [anon_sym_abstract] = ACTIONS(1949),
    [anon_sym_async] = ACTIONS(1949),
    [anon_sym_const] = ACTIONS(1949),
    [anon_sym_fixed] = ACTIONS(1949),
    [anon_sym_internal] = ACTIONS(1949),
    [anon_sym_new] = ACTIONS(1949),
    [anon_sym_override] = ACTIONS(1949),
    [anon_sym_partial] = ACTIONS(1949),
    [anon_sym_private] = ACTIONS(1949),
    [anon_sym_protected] = ACTIONS(1949),
    [anon_sym_public] = ACTIONS(1949),
    [anon_sym_readonly] = ACTIONS(1949),
    [anon_sym_ref] = ACTIONS(1949),
    [anon_sym_sealed] = ACTIONS(1949),
    [anon_sym_unsafe] = ACTIONS(1949),
    [anon_sym_virtual] = ACTIONS(1949),
    [anon_sym_volatile] = ACTIONS(1949),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_class] = ACTIONS(1949),
    [anon_sym_struct] = ACTIONS(1949),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_enum] = ACTIONS(1949),
    [anon_sym_interface] = ACTIONS(1949),
    [anon_sym_delegate] = ACTIONS(3170),
    [anon_sym_record] = ACTIONS(1949),
    [anon_sym_var] = ACTIONS(3172),
    [sym_predefined_type] = ACTIONS(3174),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_from] = ACTIONS(951),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym_void_keyword] = ACTIONS(1949),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2000] = {
    [sym__preprocessor_call] = STATE(2000),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3176),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2001] = {
    [sym__preprocessor_call] = STATE(2001),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2855),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2855),
    [anon_sym_join] = ACTIONS(2855),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2855),
    [anon_sym_orderby] = ACTIONS(2855),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2855),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2855),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2002] = {
    [sym__preprocessor_call] = STATE(2002),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2930),
    [anon_sym_join] = ACTIONS(2930),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_orderby] = ACTIONS(2930),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2930),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2930),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2003] = {
    [sym__preprocessor_call] = STATE(2003),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2855),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2004] = {
    [sym__preprocessor_call] = STATE(2004),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2930),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2005] = {
    [sym__preprocessor_call] = STATE(2005),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3178),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2006] = {
    [sym__preprocessor_call] = STATE(2006),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2855),
    [anon_sym_into] = ACTIONS(2855),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2007] = {
    [sym__preprocessor_call] = STATE(2007),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3180),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2008] = {
    [sym__preprocessor_call] = STATE(2008),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2855),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2009] = {
    [sym__preprocessor_call] = STATE(2009),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2855),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2010] = {
    [sym__preprocessor_call] = STATE(2010),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3182),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3184),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2011] = {
    [sym__preprocessor_call] = STATE(2011),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3186),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3188),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2012] = {
    [sym__preprocessor_call] = STATE(2012),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3190),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3020),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2013] = {
    [sym__preprocessor_call] = STATE(2013),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3192),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3188),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2014] = {
    [sym__preprocessor_call] = STATE(2014),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2855),
    [anon_sym_LT] = ACTIONS(2855),
    [anon_sym_GT] = ACTIONS(2855),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2855),
    [anon_sym_PLUS_PLUS] = ACTIONS(2852),
    [anon_sym_DASH_DASH] = ACTIONS(2852),
    [anon_sym_PLUS] = ACTIONS(2855),
    [anon_sym_DASH] = ACTIONS(2855),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2855),
    [anon_sym_PERCENT] = ACTIONS(2855),
    [anon_sym_CARET] = ACTIONS(2855),
    [anon_sym_PIPE] = ACTIONS(2855),
    [anon_sym_AMP] = ACTIONS(2855),
    [anon_sym_LT_LT] = ACTIONS(2855),
    [anon_sym_GT_GT] = ACTIONS(2855),
    [anon_sym_EQ_EQ] = ACTIONS(2852),
    [anon_sym_BANG_EQ] = ACTIONS(2852),
    [anon_sym_GT_EQ] = ACTIONS(2852),
    [anon_sym_LT_EQ] = ACTIONS(2852),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2855),
    [anon_sym_and] = ACTIONS(2855),
    [anon_sym_or] = ACTIONS(2855),
    [sym_discard] = ACTIONS(2850),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2852),
    [anon_sym_DASH_EQ] = ACTIONS(2852),
    [anon_sym_STAR_EQ] = ACTIONS(2852),
    [anon_sym_SLASH_EQ] = ACTIONS(2852),
    [anon_sym_PERCENT_EQ] = ACTIONS(2852),
    [anon_sym_AMP_EQ] = ACTIONS(2852),
    [anon_sym_CARET_EQ] = ACTIONS(2852),
    [anon_sym_PIPE_EQ] = ACTIONS(2852),
    [anon_sym_LT_LT_EQ] = ACTIONS(2852),
    [anon_sym_GT_GT_EQ] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2852),
    [anon_sym_is] = ACTIONS(2855),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2855),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2852),
    [anon_sym_with] = ACTIONS(2855),
    [anon_sym_AMP_AMP] = ACTIONS(2852),
    [anon_sym_PIPE_PIPE] = ACTIONS(2852),
    [anon_sym_QMARK_QMARK] = ACTIONS(2855),
    [anon_sym_as] = ACTIONS(2855),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2015] = {
    [sym__preprocessor_call] = STATE(2015),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3194),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(2909),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2016] = {
    [sym__preprocessor_call] = STATE(2016),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2930),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2930),
    [anon_sym_join] = ACTIONS(2930),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2930),
    [anon_sym_orderby] = ACTIONS(2930),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2930),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2930),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2017] = {
    [sym__preprocessor_call] = STATE(2017),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2930),
    [anon_sym_into] = ACTIONS(2930),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2018] = {
    [sym__preprocessor_call] = STATE(2018),
    [sym__identifier_token] = ACTIONS(2892),
    [anon_sym_alias] = ACTIONS(2892),
    [anon_sym_global] = ACTIONS(2892),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(3196),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2892),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_notnull] = ACTIONS(2892),
    [anon_sym_unmanaged] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_get] = ACTIONS(2892),
    [anon_sym_set] = ACTIONS(2892),
    [anon_sym_add] = ACTIONS(2892),
    [anon_sym_remove] = ACTIONS(2892),
    [anon_sym_switch] = ACTIONS(2892),
    [anon_sym_and] = ACTIONS(2892),
    [anon_sym_or] = ACTIONS(2892),
    [sym_discard] = ACTIONS(2892),
    [anon_sym_when] = ACTIONS(2892),
    [anon_sym_yield] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2892),
    [anon_sym_DASH_GT] = ACTIONS(3184),
    [anon_sym_from] = ACTIONS(2892),
    [anon_sym_join] = ACTIONS(2892),
    [anon_sym_on] = ACTIONS(2892),
    [anon_sym_equals] = ACTIONS(2892),
    [anon_sym_into] = ACTIONS(2892),
    [anon_sym_let] = ACTIONS(2892),
    [anon_sym_orderby] = ACTIONS(2892),
    [anon_sym_ascending] = ACTIONS(2892),
    [anon_sym_descending] = ACTIONS(2892),
    [anon_sym_group] = ACTIONS(2892),
    [anon_sym_by] = ACTIONS(2892),
    [anon_sym_select] = ACTIONS(2892),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2892),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2892),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2892),
    [anon_sym_nameof] = ACTIONS(2892),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2019] = {
    [sym__preprocessor_call] = STATE(2019),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(2922),
    [anon_sym_LT] = ACTIONS(2922),
    [anon_sym_GT] = ACTIONS(2922),
    [anon_sym_DOT] = ACTIONS(2922),
    [anon_sym_LBRACK] = ACTIONS(2926),
    [anon_sym_LPAREN] = ACTIONS(2926),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(2922),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2922),
    [anon_sym_PLUS_PLUS] = ACTIONS(2926),
    [anon_sym_DASH_DASH] = ACTIONS(2926),
    [anon_sym_PLUS] = ACTIONS(2922),
    [anon_sym_DASH] = ACTIONS(2922),
    [anon_sym_STAR] = ACTIONS(2922),
    [anon_sym_SLASH] = ACTIONS(2922),
    [anon_sym_PERCENT] = ACTIONS(2922),
    [anon_sym_CARET] = ACTIONS(2922),
    [anon_sym_PIPE] = ACTIONS(2922),
    [anon_sym_AMP] = ACTIONS(2922),
    [anon_sym_LT_LT] = ACTIONS(2922),
    [anon_sym_GT_GT] = ACTIONS(2922),
    [anon_sym_EQ_EQ] = ACTIONS(2926),
    [anon_sym_BANG_EQ] = ACTIONS(2926),
    [anon_sym_GT_EQ] = ACTIONS(2926),
    [anon_sym_LT_EQ] = ACTIONS(2926),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(2922),
    [anon_sym_and] = ACTIONS(2930),
    [anon_sym_or] = ACTIONS(2930),
    [sym_discard] = ACTIONS(2888),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2926),
    [anon_sym_DASH_EQ] = ACTIONS(2926),
    [anon_sym_STAR_EQ] = ACTIONS(2926),
    [anon_sym_SLASH_EQ] = ACTIONS(2926),
    [anon_sym_PERCENT_EQ] = ACTIONS(2926),
    [anon_sym_AMP_EQ] = ACTIONS(2926),
    [anon_sym_CARET_EQ] = ACTIONS(2926),
    [anon_sym_PIPE_EQ] = ACTIONS(2926),
    [anon_sym_LT_LT_EQ] = ACTIONS(2926),
    [anon_sym_GT_GT_EQ] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2926),
    [anon_sym_is] = ACTIONS(2922),
    [anon_sym_DASH_GT] = ACTIONS(2926),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2930),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(2926),
    [anon_sym_with] = ACTIONS(2922),
    [anon_sym_AMP_AMP] = ACTIONS(2926),
    [anon_sym_PIPE_PIPE] = ACTIONS(2926),
    [anon_sym_QMARK_QMARK] = ACTIONS(2922),
    [anon_sym_as] = ACTIONS(2922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2020] = {
    [sym__preprocessor_call] = STATE(2020),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3072),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_RBRACK] = ACTIONS(3072),
    [anon_sym_LPAREN] = ACTIONS(3072),
    [anon_sym_in] = ACTIONS(3067),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2021] = {
    [sym__preprocessor_call] = STATE(2021),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3072),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2022] = {
    [sym__preprocessor_call] = STATE(2022),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_RBRACK] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2852),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2023] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(2909),
    [sym__type] = STATE(4945),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2023),
    [aux_sym_event_field_declaration_repeat2] = STATE(2707),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(29),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(29),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(29),
    [anon_sym_async] = ACTIONS(29),
    [anon_sym_const] = ACTIONS(29),
    [anon_sym_fixed] = ACTIONS(29),
    [anon_sym_internal] = ACTIONS(29),
    [anon_sym_new] = ACTIONS(29),
    [anon_sym_override] = ACTIONS(29),
    [anon_sym_partial] = ACTIONS(29),
    [anon_sym_private] = ACTIONS(29),
    [anon_sym_protected] = ACTIONS(29),
    [anon_sym_public] = ACTIONS(29),
    [anon_sym_readonly] = ACTIONS(29),
    [anon_sym_ref] = ACTIONS(2679),
    [anon_sym_sealed] = ACTIONS(29),
    [anon_sym_unsafe] = ACTIONS(29),
    [anon_sym_virtual] = ACTIONS(29),
    [anon_sym_volatile] = ACTIONS(29),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_class] = ACTIONS(3198),
    [anon_sym_struct] = ACTIONS(3200),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_enum] = ACTIONS(3202),
    [anon_sym_interface] = ACTIONS(3204),
    [anon_sym_delegate] = ACTIONS(3206),
    [anon_sym_record] = ACTIONS(3208),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3210),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2024] = {
    [sym__preprocessor_call] = STATE(2024),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2025] = {
    [sym__preprocessor_call] = STATE(2025),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2026] = {
    [sym__preprocessor_call] = STATE(2026),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_COLON] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2027] = {
    [sym__preprocessor_call] = STATE(2027),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_LPAREN] = ACTIONS(3072),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2028] = {
    [sym__preprocessor_call] = STATE(2028),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_LPAREN] = ACTIONS(3072),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2029] = {
    [sym__preprocessor_call] = STATE(2029),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2852),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2852),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2030] = {
    [sym__preprocessor_call] = STATE(2030),
    [sym__identifier_token] = ACTIONS(3212),
    [anon_sym_alias] = ACTIONS(3212),
    [anon_sym_global] = ACTIONS(3212),
    [anon_sym_static] = ACTIONS(3212),
    [anon_sym_LBRACK] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3212),
    [anon_sym_new] = ACTIONS(3212),
    [anon_sym_ref] = ACTIONS(3212),
    [anon_sym_out] = ACTIONS(3212),
    [anon_sym_in] = ACTIONS(3212),
    [anon_sym_this] = ACTIONS(3212),
    [anon_sym_base] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3214),
    [anon_sym_TILDE] = ACTIONS(3214),
    [anon_sym_where] = ACTIONS(3212),
    [anon_sym_notnull] = ACTIONS(3212),
    [anon_sym_unmanaged] = ACTIONS(3212),
    [anon_sym_BANG] = ACTIONS(3214),
    [anon_sym_PLUS_PLUS] = ACTIONS(3214),
    [anon_sym_DASH_DASH] = ACTIONS(3214),
    [anon_sym_true] = ACTIONS(3212),
    [anon_sym_false] = ACTIONS(3212),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_STAR] = ACTIONS(3214),
    [anon_sym_CARET] = ACTIONS(3214),
    [anon_sym_AMP] = ACTIONS(3214),
    [anon_sym_get] = ACTIONS(3212),
    [anon_sym_set] = ACTIONS(3212),
    [anon_sym_add] = ACTIONS(3212),
    [anon_sym_remove] = ACTIONS(3212),
    [anon_sym_delegate] = ACTIONS(3212),
    [anon_sym_var] = ACTIONS(3212),
    [sym_predefined_type] = ACTIONS(3212),
    [anon_sym_checked] = ACTIONS(3212),
    [anon_sym_unchecked] = ACTIONS(3212),
    [anon_sym_await] = ACTIONS(3212),
    [anon_sym_default] = ACTIONS(3212),
    [anon_sym_when] = ACTIONS(3212),
    [anon_sym_throw] = ACTIONS(3212),
    [anon_sym_yield] = ACTIONS(3212),
    [anon_sym_stackalloc] = ACTIONS(3212),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3214),
    [anon_sym_DQUOTE] = ACTIONS(3214),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(3214),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(3214),
    [anon_sym___makeref] = ACTIONS(3212),
    [anon_sym_from] = ACTIONS(3212),
    [anon_sym_join] = ACTIONS(3212),
    [anon_sym_on] = ACTIONS(3212),
    [anon_sym_equals] = ACTIONS(3212),
    [anon_sym_into] = ACTIONS(3212),
    [anon_sym_let] = ACTIONS(3212),
    [anon_sym_orderby] = ACTIONS(3212),
    [anon_sym_ascending] = ACTIONS(3212),
    [anon_sym_descending] = ACTIONS(3212),
    [anon_sym_group] = ACTIONS(3212),
    [anon_sym_by] = ACTIONS(3212),
    [anon_sym_select] = ACTIONS(3212),
    [anon_sym_DOT_DOT] = ACTIONS(3214),
    [anon_sym___reftype] = ACTIONS(3212),
    [anon_sym___refvalue] = ACTIONS(3212),
    [anon_sym_sizeof] = ACTIONS(3212),
    [anon_sym_typeof] = ACTIONS(3212),
    [anon_sym_SQUOTE] = ACTIONS(3214),
    [sym_integer_literal] = ACTIONS(3212),
    [sym_null_literal] = ACTIONS(3212),
    [sym_real_literal] = ACTIONS(3214),
    [sym_verbatim_string_literal] = ACTIONS(3214),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3212),
    [anon_sym_nameof] = ACTIONS(3212),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2031] = {
    [sym__preprocessor_call] = STATE(2031),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2858),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2852),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2032] = {
    [sym__preprocessor_call] = STATE(2032),
    [sym__identifier_token] = ACTIONS(2850),
    [anon_sym_alias] = ACTIONS(2850),
    [anon_sym_global] = ACTIONS(2850),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2852),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2852),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_where] = ACTIONS(2850),
    [anon_sym_QMARK] = ACTIONS(2855),
    [anon_sym_notnull] = ACTIONS(2850),
    [anon_sym_unmanaged] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2855),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_get] = ACTIONS(2850),
    [anon_sym_set] = ACTIONS(2850),
    [anon_sym_add] = ACTIONS(2850),
    [anon_sym_remove] = ACTIONS(2850),
    [anon_sym_switch] = ACTIONS(2995),
    [anon_sym_when] = ACTIONS(2850),
    [anon_sym_yield] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2995),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2850),
    [anon_sym_join] = ACTIONS(2850),
    [anon_sym_on] = ACTIONS(2850),
    [anon_sym_equals] = ACTIONS(2850),
    [anon_sym_into] = ACTIONS(2850),
    [anon_sym_let] = ACTIONS(2850),
    [anon_sym_orderby] = ACTIONS(2850),
    [anon_sym_ascending] = ACTIONS(2850),
    [anon_sym_descending] = ACTIONS(2850),
    [anon_sym_group] = ACTIONS(2850),
    [anon_sym_by] = ACTIONS(2850),
    [anon_sym_select] = ACTIONS(2850),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2995),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2995),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2850),
    [anon_sym_nameof] = ACTIONS(2850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2033] = {
    [sym__preprocessor_call] = STATE(2033),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3072),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2034] = {
    [sym__preprocessor_call] = STATE(2034),
    [sym__identifier_token] = ACTIONS(2888),
    [anon_sym_alias] = ACTIONS(2888),
    [anon_sym_global] = ACTIONS(2888),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3072),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3072),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3072),
    [anon_sym_where] = ACTIONS(2888),
    [anon_sym_QMARK] = ACTIONS(3069),
    [anon_sym_notnull] = ACTIONS(2888),
    [anon_sym_unmanaged] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3069),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_get] = ACTIONS(2888),
    [anon_sym_set] = ACTIONS(2888),
    [anon_sym_add] = ACTIONS(2888),
    [anon_sym_remove] = ACTIONS(2888),
    [anon_sym_switch] = ACTIONS(3067),
    [anon_sym_when] = ACTIONS(2888),
    [anon_sym_yield] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3067),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(2888),
    [anon_sym_join] = ACTIONS(2888),
    [anon_sym_on] = ACTIONS(2888),
    [anon_sym_equals] = ACTIONS(2888),
    [anon_sym_into] = ACTIONS(2888),
    [anon_sym_let] = ACTIONS(2888),
    [anon_sym_orderby] = ACTIONS(2888),
    [anon_sym_ascending] = ACTIONS(2888),
    [anon_sym_descending] = ACTIONS(2888),
    [anon_sym_group] = ACTIONS(2888),
    [anon_sym_by] = ACTIONS(2888),
    [anon_sym_select] = ACTIONS(2888),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3067),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3067),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2888),
    [anon_sym_nameof] = ACTIONS(2888),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2035] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym__type] = STATE(4867),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2035),
    [aux_sym_event_field_declaration_repeat1] = STATE(3368),
    [aux_sym_event_field_declaration_repeat2] = STATE(2056),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3220),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2036] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_attribute_list] = STATE(3724),
    [sym_modifier] = STATE(3923),
    [sym__type] = STATE(4849),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2036),
    [aux_sym_event_field_declaration_repeat1] = STATE(3368),
    [aux_sym_event_field_declaration_repeat2] = STATE(2052),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3128),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2037] = {
    [sym__preprocessor_call] = STATE(2037),
    [sym__identifier_token] = ACTIONS(3222),
    [anon_sym_alias] = ACTIONS(3222),
    [anon_sym_global] = ACTIONS(3222),
    [anon_sym_static] = ACTIONS(3222),
    [anon_sym_LBRACK] = ACTIONS(3224),
    [anon_sym_LPAREN] = ACTIONS(3224),
    [anon_sym_async] = ACTIONS(3222),
    [anon_sym_new] = ACTIONS(3222),
    [anon_sym_ref] = ACTIONS(3222),
    [anon_sym_this] = ACTIONS(3222),
    [anon_sym_base] = ACTIONS(3222),
    [anon_sym_LBRACE] = ACTIONS(3224),
    [anon_sym_TILDE] = ACTIONS(3224),
    [anon_sym_where] = ACTIONS(3222),
    [anon_sym_notnull] = ACTIONS(3222),
    [anon_sym_unmanaged] = ACTIONS(3222),
    [anon_sym_BANG] = ACTIONS(3224),
    [anon_sym_PLUS_PLUS] = ACTIONS(3224),
    [anon_sym_DASH_DASH] = ACTIONS(3224),
    [anon_sym_true] = ACTIONS(3222),
    [anon_sym_false] = ACTIONS(3222),
    [anon_sym_PLUS] = ACTIONS(3222),
    [anon_sym_DASH] = ACTIONS(3222),
    [anon_sym_STAR] = ACTIONS(3224),
    [anon_sym_CARET] = ACTIONS(3224),
    [anon_sym_AMP] = ACTIONS(3224),
    [anon_sym_get] = ACTIONS(3222),
    [anon_sym_set] = ACTIONS(3222),
    [anon_sym_add] = ACTIONS(3222),
    [anon_sym_remove] = ACTIONS(3222),
    [anon_sym_delegate] = ACTIONS(3222),
    [sym_predefined_type] = ACTIONS(3222),
    [anon_sym_checked] = ACTIONS(3222),
    [anon_sym_unchecked] = ACTIONS(3222),
    [anon_sym_await] = ACTIONS(3222),
    [anon_sym_default] = ACTIONS(3222),
    [anon_sym_when] = ACTIONS(3222),
    [anon_sym_throw] = ACTIONS(3222),
    [anon_sym_yield] = ACTIONS(3222),
    [anon_sym_stackalloc] = ACTIONS(3222),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3224),
    [anon_sym_DQUOTE] = ACTIONS(3224),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(3224),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(3224),
    [anon_sym___makeref] = ACTIONS(3222),
    [anon_sym_from] = ACTIONS(3222),
    [anon_sym_join] = ACTIONS(3222),
    [anon_sym_on] = ACTIONS(3222),
    [anon_sym_equals] = ACTIONS(3222),
    [anon_sym_into] = ACTIONS(3222),
    [anon_sym_let] = ACTIONS(3222),
    [anon_sym_orderby] = ACTIONS(3222),
    [anon_sym_ascending] = ACTIONS(3222),
    [anon_sym_descending] = ACTIONS(3222),
    [anon_sym_group] = ACTIONS(3222),
    [anon_sym_by] = ACTIONS(3222),
    [anon_sym_select] = ACTIONS(3222),
    [anon_sym_DOT_DOT] = ACTIONS(3224),
    [anon_sym___reftype] = ACTIONS(3222),
    [anon_sym___refvalue] = ACTIONS(3222),
    [anon_sym_sizeof] = ACTIONS(3222),
    [anon_sym_typeof] = ACTIONS(3222),
    [anon_sym_SQUOTE] = ACTIONS(3224),
    [sym_integer_literal] = ACTIONS(3222),
    [sym_null_literal] = ACTIONS(3222),
    [sym_real_literal] = ACTIONS(3224),
    [sym_verbatim_string_literal] = ACTIONS(3224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3222),
    [anon_sym_nameof] = ACTIONS(3222),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2038] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6679),
    [sym__type] = STATE(4698),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2038),
    [aux_sym_event_field_declaration_repeat2] = STATE(3490),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3128),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2039] = {
    [sym_name_equals] = STATE(4700),
    [sym__name] = STATE(4744),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6679),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4673),
    [sym_global] = STATE(4708),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2039),
    [aux_sym_event_field_declaration_repeat2] = STATE(2049),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(3226),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2040] = {
    [sym__preprocessor_call] = STATE(2040),
    [sym__identifier_token] = ACTIONS(3230),
    [anon_sym_alias] = ACTIONS(3230),
    [anon_sym_global] = ACTIONS(3230),
    [anon_sym_static] = ACTIONS(3230),
    [anon_sym_LBRACK] = ACTIONS(3232),
    [anon_sym_LPAREN] = ACTIONS(3232),
    [anon_sym_async] = ACTIONS(3230),
    [anon_sym_new] = ACTIONS(3230),
    [anon_sym_ref] = ACTIONS(3230),
    [anon_sym_this] = ACTIONS(3230),
    [anon_sym_base] = ACTIONS(3230),
    [anon_sym_LBRACE] = ACTIONS(3232),
    [anon_sym_TILDE] = ACTIONS(3232),
    [anon_sym_where] = ACTIONS(3230),
    [anon_sym_notnull] = ACTIONS(3230),
    [anon_sym_unmanaged] = ACTIONS(3230),
    [anon_sym_BANG] = ACTIONS(3232),
    [anon_sym_PLUS_PLUS] = ACTIONS(3232),
    [anon_sym_DASH_DASH] = ACTIONS(3232),
    [anon_sym_true] = ACTIONS(3230),
    [anon_sym_false] = ACTIONS(3230),
    [anon_sym_PLUS] = ACTIONS(3230),
    [anon_sym_DASH] = ACTIONS(3230),
    [anon_sym_STAR] = ACTIONS(3232),
    [anon_sym_CARET] = ACTIONS(3232),
    [anon_sym_AMP] = ACTIONS(3232),
    [anon_sym_get] = ACTIONS(3230),
    [anon_sym_set] = ACTIONS(3230),
    [anon_sym_add] = ACTIONS(3230),
    [anon_sym_remove] = ACTIONS(3230),
    [anon_sym_delegate] = ACTIONS(3230),
    [sym_predefined_type] = ACTIONS(3230),
    [anon_sym_checked] = ACTIONS(3230),
    [anon_sym_unchecked] = ACTIONS(3230),
    [anon_sym_await] = ACTIONS(3230),
    [anon_sym_default] = ACTIONS(3230),
    [anon_sym_when] = ACTIONS(3230),
    [anon_sym_throw] = ACTIONS(3230),
    [anon_sym_yield] = ACTIONS(3230),
    [anon_sym_stackalloc] = ACTIONS(3230),
    [anon_sym_DOLLAR_DQUOTE] = ACTIONS(3232),
    [anon_sym_DQUOTE] = ACTIONS(3232),
    [anon_sym_DOLLAR_AT_DQUOTE] = ACTIONS(3232),
    [anon_sym_AT_DOLLAR_DQUOTE] = ACTIONS(3232),
    [anon_sym___makeref] = ACTIONS(3230),
    [anon_sym_from] = ACTIONS(3230),
    [anon_sym_join] = ACTIONS(3230),
    [anon_sym_on] = ACTIONS(3230),
    [anon_sym_equals] = ACTIONS(3230),
    [anon_sym_into] = ACTIONS(3230),
    [anon_sym_let] = ACTIONS(3230),
    [anon_sym_orderby] = ACTIONS(3230),
    [anon_sym_ascending] = ACTIONS(3230),
    [anon_sym_descending] = ACTIONS(3230),
    [anon_sym_group] = ACTIONS(3230),
    [anon_sym_by] = ACTIONS(3230),
    [anon_sym_select] = ACTIONS(3230),
    [anon_sym_DOT_DOT] = ACTIONS(3232),
    [anon_sym___reftype] = ACTIONS(3230),
    [anon_sym___refvalue] = ACTIONS(3230),
    [anon_sym_sizeof] = ACTIONS(3230),
    [anon_sym_typeof] = ACTIONS(3230),
    [anon_sym_SQUOTE] = ACTIONS(3232),
    [sym_integer_literal] = ACTIONS(3230),
    [sym_null_literal] = ACTIONS(3230),
    [sym_real_literal] = ACTIONS(3232),
    [sym_verbatim_string_literal] = ACTIONS(3232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3230),
    [anon_sym_nameof] = ACTIONS(3230),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2041] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6941),
    [sym__type] = STATE(4702),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2041),
    [aux_sym_event_field_declaration_repeat2] = STATE(3490),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3220),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2042] = {
    [sym__name] = STATE(2629),
    [sym_alias_qualified_name] = STATE(2111),
    [sym__simple_name] = STATE(2111),
    [sym_generic_name] = STATE(2096),
    [sym_qualified_name] = STATE(2111),
    [sym_argument_list] = STATE(2069),
    [sym__type] = STATE(2051),
    [sym_implicit_type] = STATE(2114),
    [sym_array_type] = STATE(2065),
    [sym_nullable_type] = STATE(2114),
    [sym__nullable_base_type] = STATE(6945),
    [sym_pointer_type] = STATE(2115),
    [sym_function_pointer_type] = STATE(2115),
    [sym_tuple_type] = STATE(2115),
    [sym_identifier] = STATE(2270),
    [sym_global] = STATE(2525),
    [sym__contextual_keywords] = STATE(2091),
    [sym__preprocessor_call] = STATE(2042),
    [sym__identifier_token] = ACTIONS(949),
    [anon_sym_extern] = ACTIONS(1949),
    [anon_sym_alias] = ACTIONS(951),
    [anon_sym_global] = ACTIONS(871),
    [anon_sym_static] = ACTIONS(1949),
    [anon_sym_LBRACK] = ACTIONS(3164),
    [anon_sym_LPAREN] = ACTIONS(3166),
    [anon_sym_abstract] = ACTIONS(1949),
    [anon_sym_async] = ACTIONS(1949),
    [anon_sym_const] = ACTIONS(1949),
    [anon_sym_fixed] = ACTIONS(1949),
    [anon_sym_internal] = ACTIONS(1949),
    [anon_sym_new] = ACTIONS(1949),
    [anon_sym_override] = ACTIONS(1949),
    [anon_sym_partial] = ACTIONS(1949),
    [anon_sym_private] = ACTIONS(1949),
    [anon_sym_protected] = ACTIONS(1949),
    [anon_sym_public] = ACTIONS(1949),
    [anon_sym_readonly] = ACTIONS(1949),
    [anon_sym_ref] = ACTIONS(1949),
    [anon_sym_sealed] = ACTIONS(1949),
    [anon_sym_unsafe] = ACTIONS(1949),
    [anon_sym_virtual] = ACTIONS(1949),
    [anon_sym_volatile] = ACTIONS(1949),
    [anon_sym_LBRACE] = ACTIONS(3168),
    [anon_sym_where] = ACTIONS(951),
    [anon_sym_notnull] = ACTIONS(951),
    [anon_sym_unmanaged] = ACTIONS(951),
    [anon_sym_get] = ACTIONS(951),
    [anon_sym_set] = ACTIONS(951),
    [anon_sym_add] = ACTIONS(951),
    [anon_sym_remove] = ACTIONS(951),
    [anon_sym_delegate] = ACTIONS(3170),
    [anon_sym_var] = ACTIONS(3172),
    [sym_predefined_type] = ACTIONS(3174),
    [anon_sym_when] = ACTIONS(951),
    [anon_sym_yield] = ACTIONS(951),
    [anon_sym_from] = ACTIONS(951),
    [anon_sym_join] = ACTIONS(951),
    [anon_sym_on] = ACTIONS(951),
    [anon_sym_equals] = ACTIONS(951),
    [anon_sym_into] = ACTIONS(951),
    [anon_sym_let] = ACTIONS(951),
    [anon_sym_orderby] = ACTIONS(951),
    [anon_sym_ascending] = ACTIONS(951),
    [anon_sym_descending] = ACTIONS(951),
    [anon_sym_group] = ACTIONS(951),
    [anon_sym_by] = ACTIONS(951),
    [anon_sym_select] = ACTIONS(951),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(951),
    [anon_sym_nameof] = ACTIONS(951),
    [sym_void_keyword] = ACTIONS(1949),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2043] = {
    [sym_argument_list] = STATE(2057),
    [sym_array_rank_specifier] = STATE(2090),
    [sym_initializer_expression] = STATE(2183),
    [sym__preprocessor_call] = STATE(2043),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_EQ] = ACTIONS(3236),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_COMMA] = ACTIONS(3234),
    [anon_sym_GT] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_RBRACK] = ACTIONS(3234),
    [anon_sym_COLON] = ACTIONS(3234),
    [anon_sym_LPAREN] = ACTIONS(3240),
    [anon_sym_RPAREN] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_EQ_GT] = ACTIONS(3234),
    [anon_sym_where] = ACTIONS(3234),
    [anon_sym_QMARK] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_SLASH] = ACTIONS(3236),
    [anon_sym_PERCENT] = ACTIONS(3236),
    [anon_sym_CARET] = ACTIONS(3236),
    [anon_sym_PIPE] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3236),
    [anon_sym_LT_LT] = ACTIONS(3236),
    [anon_sym_GT_GT] = ACTIONS(3236),
    [anon_sym_EQ_EQ] = ACTIONS(3234),
    [anon_sym_BANG_EQ] = ACTIONS(3234),
    [anon_sym_GT_EQ] = ACTIONS(3234),
    [anon_sym_LT_EQ] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_and] = ACTIONS(3234),
    [anon_sym_or] = ACTIONS(3236),
    [anon_sym_PLUS_EQ] = ACTIONS(3234),
    [anon_sym_DASH_EQ] = ACTIONS(3234),
    [anon_sym_STAR_EQ] = ACTIONS(3234),
    [anon_sym_SLASH_EQ] = ACTIONS(3234),
    [anon_sym_PERCENT_EQ] = ACTIONS(3234),
    [anon_sym_AMP_EQ] = ACTIONS(3234),
    [anon_sym_CARET_EQ] = ACTIONS(3234),
    [anon_sym_PIPE_EQ] = ACTIONS(3234),
    [anon_sym_LT_LT_EQ] = ACTIONS(3234),
    [anon_sym_GT_GT_EQ] = ACTIONS(3234),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3234),
    [anon_sym_is] = ACTIONS(3234),
    [anon_sym_DASH_GT] = ACTIONS(3234),
    [anon_sym_from] = ACTIONS(3234),
    [anon_sym_join] = ACTIONS(3234),
    [anon_sym_on] = ACTIONS(3234),
    [anon_sym_equals] = ACTIONS(3234),
    [anon_sym_into] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_orderby] = ACTIONS(3234),
    [anon_sym_group] = ACTIONS(3234),
    [anon_sym_by] = ACTIONS(3234),
    [anon_sym_select] = ACTIONS(3234),
    [anon_sym_DOT_DOT] = ACTIONS(3234),
    [anon_sym_with] = ACTIONS(3234),
    [anon_sym_AMP_AMP] = ACTIONS(3234),
    [anon_sym_PIPE_PIPE] = ACTIONS(3234),
    [anon_sym_QMARK_QMARK] = ACTIONS(3236),
    [anon_sym_as] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2044] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6833),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2044),
    [aux_sym_event_field_declaration_repeat2] = STATE(3490),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2045] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6713),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2045),
    [aux_sym_event_field_declaration_repeat2] = STATE(3490),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2046] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6785),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2046),
    [aux_sym_event_field_declaration_repeat2] = STATE(3490),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2047] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6785),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2047),
    [aux_sym_event_field_declaration_repeat2] = STATE(2045),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(3244),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2048] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6645),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2048),
    [aux_sym_event_field_declaration_repeat2] = STATE(2044),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(3246),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2049] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6645),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2049),
    [aux_sym_event_field_declaration_repeat2] = STATE(3490),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2050] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6645),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2050),
    [aux_sym_event_field_declaration_repeat2] = STATE(2044),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(3248),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2051] = {
    [sym_argument_list] = STATE(2081),
    [sym_array_rank_specifier] = STATE(2148),
    [sym_initializer_expression] = STATE(2286),
    [sym__preprocessor_call] = STATE(2051),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_EQ] = ACTIONS(3236),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_COMMA] = ACTIONS(3234),
    [anon_sym_GT] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_RBRACK] = ACTIONS(3234),
    [anon_sym_COLON] = ACTIONS(3234),
    [anon_sym_LPAREN] = ACTIONS(3252),
    [anon_sym_RPAREN] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_EQ_GT] = ACTIONS(3234),
    [anon_sym_where] = ACTIONS(3234),
    [anon_sym_QMARK] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(3254),
    [anon_sym_SLASH] = ACTIONS(3236),
    [anon_sym_PERCENT] = ACTIONS(3236),
    [anon_sym_CARET] = ACTIONS(3236),
    [anon_sym_PIPE] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3236),
    [anon_sym_LT_LT] = ACTIONS(3236),
    [anon_sym_GT_GT] = ACTIONS(3236),
    [anon_sym_EQ_EQ] = ACTIONS(3234),
    [anon_sym_BANG_EQ] = ACTIONS(3234),
    [anon_sym_GT_EQ] = ACTIONS(3234),
    [anon_sym_LT_EQ] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_and] = ACTIONS(3234),
    [anon_sym_or] = ACTIONS(3236),
    [anon_sym_PLUS_EQ] = ACTIONS(3234),
    [anon_sym_DASH_EQ] = ACTIONS(3234),
    [anon_sym_STAR_EQ] = ACTIONS(3234),
    [anon_sym_SLASH_EQ] = ACTIONS(3234),
    [anon_sym_PERCENT_EQ] = ACTIONS(3234),
    [anon_sym_AMP_EQ] = ACTIONS(3234),
    [anon_sym_CARET_EQ] = ACTIONS(3234),
    [anon_sym_PIPE_EQ] = ACTIONS(3234),
    [anon_sym_LT_LT_EQ] = ACTIONS(3234),
    [anon_sym_GT_GT_EQ] = ACTIONS(3234),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3234),
    [anon_sym_is] = ACTIONS(3234),
    [anon_sym_DASH_GT] = ACTIONS(3234),
    [anon_sym_from] = ACTIONS(3234),
    [anon_sym_join] = ACTIONS(3234),
    [anon_sym_on] = ACTIONS(3234),
    [anon_sym_equals] = ACTIONS(3234),
    [anon_sym_let] = ACTIONS(3234),
    [anon_sym_orderby] = ACTIONS(3234),
    [anon_sym_group] = ACTIONS(3234),
    [anon_sym_by] = ACTIONS(3234),
    [anon_sym_select] = ACTIONS(3234),
    [anon_sym_DOT_DOT] = ACTIONS(3234),
    [anon_sym_with] = ACTIONS(3234),
    [anon_sym_AMP_AMP] = ACTIONS(3234),
    [anon_sym_PIPE_PIPE] = ACTIONS(3234),
    [anon_sym_QMARK_QMARK] = ACTIONS(3236),
    [anon_sym_as] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2052] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym__type] = STATE(4945),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2052),
    [aux_sym_event_field_declaration_repeat2] = STATE(3490),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3210),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2053] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6679),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2053),
    [aux_sym_event_field_declaration_repeat2] = STATE(2049),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(3256),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2054] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6679),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2054),
    [aux_sym_event_field_declaration_repeat2] = STATE(2049),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(3228),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2055] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym_variable_declaration] = STATE(6941),
    [sym__type] = STATE(4711),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2055),
    [aux_sym_event_field_declaration_repeat2] = STATE(2046),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(3258),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2056] = {
    [sym__name] = STATE(4620),
    [sym_alias_qualified_name] = STATE(4513),
    [sym__simple_name] = STATE(4513),
    [sym_generic_name] = STATE(4512),
    [sym_qualified_name] = STATE(4513),
    [sym_modifier] = STATE(3923),
    [sym__type] = STATE(4864),
    [sym_implicit_type] = STATE(4583),
    [sym_array_type] = STATE(4565),
    [sym_nullable_type] = STATE(4583),
    [sym__nullable_base_type] = STATE(6727),
    [sym_pointer_type] = STATE(4565),
    [sym_function_pointer_type] = STATE(4565),
    [sym_tuple_type] = STATE(4565),
    [sym_identifier] = STATE(4613),
    [sym_global] = STATE(4614),
    [sym__contextual_keywords] = STATE(3931),
    [sym__preprocessor_call] = STATE(2056),
    [aux_sym_event_field_declaration_repeat2] = STATE(3490),
    [sym__identifier_token] = ACTIONS(2663),
    [anon_sym_extern] = ACTIONS(318),
    [anon_sym_alias] = ACTIONS(2667),
    [anon_sym_global] = ACTIONS(2765),
    [anon_sym_static] = ACTIONS(318),
    [anon_sym_LPAREN] = ACTIONS(2677),
    [anon_sym_abstract] = ACTIONS(318),
    [anon_sym_async] = ACTIONS(318),
    [anon_sym_const] = ACTIONS(318),
    [anon_sym_fixed] = ACTIONS(318),
    [anon_sym_internal] = ACTIONS(318),
    [anon_sym_new] = ACTIONS(318),
    [anon_sym_override] = ACTIONS(318),
    [anon_sym_partial] = ACTIONS(318),
    [anon_sym_private] = ACTIONS(318),
    [anon_sym_protected] = ACTIONS(318),
    [anon_sym_public] = ACTIONS(318),
    [anon_sym_readonly] = ACTIONS(318),
    [anon_sym_ref] = ACTIONS(3218),
    [anon_sym_sealed] = ACTIONS(318),
    [anon_sym_unsafe] = ACTIONS(318),
    [anon_sym_virtual] = ACTIONS(318),
    [anon_sym_volatile] = ACTIONS(318),
    [anon_sym_where] = ACTIONS(2667),
    [anon_sym_notnull] = ACTIONS(2667),
    [anon_sym_unmanaged] = ACTIONS(2667),
    [anon_sym_get] = ACTIONS(2667),
    [anon_sym_set] = ACTIONS(2667),
    [anon_sym_add] = ACTIONS(2667),
    [anon_sym_remove] = ACTIONS(2667),
    [anon_sym_delegate] = ACTIONS(2739),
    [anon_sym_var] = ACTIONS(67),
    [sym_predefined_type] = ACTIONS(2701),
    [anon_sym_when] = ACTIONS(2667),
    [anon_sym_yield] = ACTIONS(2667),
    [anon_sym_from] = ACTIONS(2667),
    [anon_sym_join] = ACTIONS(2667),
    [anon_sym_on] = ACTIONS(2667),
    [anon_sym_equals] = ACTIONS(2667),
    [anon_sym_into] = ACTIONS(2667),
    [anon_sym_let] = ACTIONS(2667),
    [anon_sym_orderby] = ACTIONS(2667),
    [anon_sym_ascending] = ACTIONS(2667),
    [anon_sym_descending] = ACTIONS(2667),
    [anon_sym_group] = ACTIONS(2667),
    [anon_sym_by] = ACTIONS(2667),
    [anon_sym_select] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2667),
    [anon_sym_nameof] = ACTIONS(2667),
    [sym_void_keyword] = ACTIONS(3260),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2057] = {
    [sym_initializer_expression] = STATE(2157),
    [sym__preprocessor_call] = STATE(2057),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_COMMA] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3264),
    [anon_sym_DOT] = ACTIONS(3264),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_RBRACK] = ACTIONS(3262),
    [anon_sym_COLON] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_RPAREN] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3264),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_EQ_GT] = ACTIONS(3262),
    [anon_sym_where] = ACTIONS(3262),
    [anon_sym_QMARK] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3264),
    [anon_sym_PERCENT] = ACTIONS(3264),
    [anon_sym_CARET] = ACTIONS(3264),
    [anon_sym_PIPE] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3264),
    [anon_sym_LT_LT] = ACTIONS(3264),
    [anon_sym_GT_GT] = ACTIONS(3264),
    [anon_sym_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BANG_EQ] = ACTIONS(3262),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_and] = ACTIONS(3262),
    [anon_sym_or] = ACTIONS(3264),
    [anon_sym_PLUS_EQ] = ACTIONS(3262),
    [anon_sym_DASH_EQ] = ACTIONS(3262),
    [anon_sym_STAR_EQ] = ACTIONS(3262),
    [anon_sym_SLASH_EQ] = ACTIONS(3262),
    [anon_sym_PERCENT_EQ] = ACTIONS(3262),
    [anon_sym_AMP_EQ] = ACTIONS(3262),
    [anon_sym_CARET_EQ] = ACTIONS(3262),
    [anon_sym_PIPE_EQ] = ACTIONS(3262),
    [anon_sym_LT_LT_EQ] = ACTIONS(3262),
    [anon_sym_GT_GT_EQ] = ACTIONS(3262),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3262),
    [anon_sym_is] = ACTIONS(3262),
    [anon_sym_DASH_GT] = ACTIONS(3262),
    [anon_sym_from] = ACTIONS(3262),
    [anon_sym_join] = ACTIONS(3262),
    [anon_sym_on] = ACTIONS(3262),
    [anon_sym_equals] = ACTIONS(3262),
    [anon_sym_into] = ACTIONS(3262),
    [anon_sym_let] = ACTIONS(3262),
    [anon_sym_orderby] = ACTIONS(3262),
    [anon_sym_group] = ACTIONS(3262),
    [anon_sym_by] = ACTIONS(3262),
    [anon_sym_select] = ACTIONS(3262),
    [anon_sym_DOT_DOT] = ACTIONS(3262),
    [anon_sym_with] = ACTIONS(3262),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_QMARK_QMARK] = ACTIONS(3264),
    [anon_sym_as] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2058] = {
    [sym__preprocessor_call] = STATE(2058),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_RBRACK] = ACTIONS(2729),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_in] = ACTIONS(2734),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_switch] = ACTIONS(2729),
    [anon_sym_and] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2729),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2729),
    [anon_sym_join] = ACTIONS(2729),
    [anon_sym_on] = ACTIONS(2729),
    [anon_sym_equals] = ACTIONS(2729),
    [anon_sym_into] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_orderby] = ACTIONS(2729),
    [anon_sym_group] = ACTIONS(2729),
    [anon_sym_by] = ACTIONS(2729),
    [anon_sym_select] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2729),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2059] = {
    [sym__preprocessor_call] = STATE(2059),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON_COLON] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2835),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_RBRACK] = ACTIONS(2835),
    [anon_sym_COLON] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_RPAREN] = ACTIONS(2835),
    [anon_sym_in] = ACTIONS(2833),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2835),
    [anon_sym_where] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_GT_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2835),
    [anon_sym_switch] = ACTIONS(2835),
    [anon_sym_and] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PLUS_EQ] = ACTIONS(2835),
    [anon_sym_DASH_EQ] = ACTIONS(2835),
    [anon_sym_STAR_EQ] = ACTIONS(2835),
    [anon_sym_SLASH_EQ] = ACTIONS(2835),
    [anon_sym_PERCENT_EQ] = ACTIONS(2835),
    [anon_sym_AMP_EQ] = ACTIONS(2835),
    [anon_sym_CARET_EQ] = ACTIONS(2835),
    [anon_sym_PIPE_EQ] = ACTIONS(2835),
    [anon_sym_LT_LT_EQ] = ACTIONS(2835),
    [anon_sym_GT_GT_EQ] = ACTIONS(2835),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2835),
    [anon_sym_is] = ACTIONS(2835),
    [anon_sym_DASH_GT] = ACTIONS(2835),
    [anon_sym_from] = ACTIONS(2835),
    [anon_sym_join] = ACTIONS(2835),
    [anon_sym_on] = ACTIONS(2835),
    [anon_sym_equals] = ACTIONS(2835),
    [anon_sym_into] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_orderby] = ACTIONS(2835),
    [anon_sym_group] = ACTIONS(2835),
    [anon_sym_by] = ACTIONS(2835),
    [anon_sym_select] = ACTIONS(2835),
    [anon_sym_DOT_DOT] = ACTIONS(2835),
    [anon_sym_with] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_QMARK_QMARK] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2060] = {
    [sym_initializer_expression] = STATE(2184),
    [sym__preprocessor_call] = STATE(2060),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_DOT] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_RBRACK] = ACTIONS(3266),
    [anon_sym_COLON] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_RPAREN] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3268),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_EQ_GT] = ACTIONS(3266),
    [anon_sym_where] = ACTIONS(3266),
    [anon_sym_QMARK] = ACTIONS(3273),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_PERCENT] = ACTIONS(3268),
    [anon_sym_CARET] = ACTIONS(3268),
    [anon_sym_PIPE] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3268),
    [anon_sym_LT_LT] = ACTIONS(3268),
    [anon_sym_GT_GT] = ACTIONS(3268),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_and] = ACTIONS(3266),
    [anon_sym_or] = ACTIONS(3268),
    [anon_sym_PLUS_EQ] = ACTIONS(3266),
    [anon_sym_DASH_EQ] = ACTIONS(3266),
    [anon_sym_STAR_EQ] = ACTIONS(3266),
    [anon_sym_SLASH_EQ] = ACTIONS(3266),
    [anon_sym_PERCENT_EQ] = ACTIONS(3266),
    [anon_sym_AMP_EQ] = ACTIONS(3266),
    [anon_sym_CARET_EQ] = ACTIONS(3266),
    [anon_sym_PIPE_EQ] = ACTIONS(3266),
    [anon_sym_LT_LT_EQ] = ACTIONS(3266),
    [anon_sym_GT_GT_EQ] = ACTIONS(3266),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3266),
    [anon_sym_is] = ACTIONS(3266),
    [anon_sym_DASH_GT] = ACTIONS(3266),
    [anon_sym_from] = ACTIONS(3266),
    [anon_sym_join] = ACTIONS(3266),
    [anon_sym_on] = ACTIONS(3266),
    [anon_sym_equals] = ACTIONS(3266),
    [anon_sym_into] = ACTIONS(3266),
    [anon_sym_let] = ACTIONS(3266),
    [anon_sym_orderby] = ACTIONS(3266),
    [anon_sym_group] = ACTIONS(3266),
    [anon_sym_by] = ACTIONS(3266),
    [anon_sym_select] = ACTIONS(3266),
    [anon_sym_DOT_DOT] = ACTIONS(3266),
    [anon_sym_with] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_QMARK_QMARK] = ACTIONS(3268),
    [anon_sym_as] = ACTIONS(3266),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2061] = {
    [sym_initializer_expression] = STATE(2187),
    [sym__preprocessor_call] = STATE(2061),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(3282),
    [anon_sym_COMMA] = ACTIONS(3279),
    [anon_sym_GT] = ACTIONS(3282),
    [anon_sym_DOT] = ACTIONS(3282),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [anon_sym_RBRACK] = ACTIONS(3279),
    [anon_sym_COLON] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3279),
    [anon_sym_RPAREN] = ACTIONS(3279),
    [anon_sym_in] = ACTIONS(3282),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [anon_sym_RBRACE] = ACTIONS(3279),
    [anon_sym_EQ_GT] = ACTIONS(3279),
    [anon_sym_where] = ACTIONS(3279),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3282),
    [anon_sym_PLUS_PLUS] = ACTIONS(3279),
    [anon_sym_DASH_DASH] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3282),
    [anon_sym_DASH] = ACTIONS(3282),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_SLASH] = ACTIONS(3282),
    [anon_sym_PERCENT] = ACTIONS(3282),
    [anon_sym_CARET] = ACTIONS(3282),
    [anon_sym_PIPE] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3282),
    [anon_sym_LT_LT] = ACTIONS(3282),
    [anon_sym_GT_GT] = ACTIONS(3282),
    [anon_sym_EQ_EQ] = ACTIONS(3279),
    [anon_sym_BANG_EQ] = ACTIONS(3279),
    [anon_sym_GT_EQ] = ACTIONS(3279),
    [anon_sym_LT_EQ] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_and] = ACTIONS(3279),
    [anon_sym_or] = ACTIONS(3282),
    [anon_sym_PLUS_EQ] = ACTIONS(3279),
    [anon_sym_DASH_EQ] = ACTIONS(3279),
    [anon_sym_STAR_EQ] = ACTIONS(3279),
    [anon_sym_SLASH_EQ] = ACTIONS(3279),
    [anon_sym_PERCENT_EQ] = ACTIONS(3279),
    [anon_sym_AMP_EQ] = ACTIONS(3279),
    [anon_sym_CARET_EQ] = ACTIONS(3279),
    [anon_sym_PIPE_EQ] = ACTIONS(3279),
    [anon_sym_LT_LT_EQ] = ACTIONS(3279),
    [anon_sym_GT_GT_EQ] = ACTIONS(3279),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3279),
    [anon_sym_is] = ACTIONS(3279),
    [anon_sym_DASH_GT] = ACTIONS(3279),
    [anon_sym_from] = ACTIONS(3279),
    [anon_sym_join] = ACTIONS(3279),
    [anon_sym_on] = ACTIONS(3279),
    [anon_sym_equals] = ACTIONS(3279),
    [anon_sym_into] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_orderby] = ACTIONS(3279),
    [anon_sym_group] = ACTIONS(3279),
    [anon_sym_by] = ACTIONS(3279),
    [anon_sym_select] = ACTIONS(3279),
    [anon_sym_DOT_DOT] = ACTIONS(3279),
    [anon_sym_with] = ACTIONS(3279),
    [anon_sym_AMP_AMP] = ACTIONS(3279),
    [anon_sym_PIPE_PIPE] = ACTIONS(3279),
    [anon_sym_QMARK_QMARK] = ACTIONS(3282),
    [anon_sym_as] = ACTIONS(3279),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2062] = {
    [sym_initializer_expression] = STATE(2176),
    [sym__preprocessor_call] = STATE(2062),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_COMMA] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_RBRACK] = ACTIONS(3292),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_RPAREN] = ACTIONS(3292),
    [anon_sym_in] = ACTIONS(3294),
    [anon_sym_LBRACE] = ACTIONS(889),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_EQ_GT] = ACTIONS(3292),
    [anon_sym_where] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3294),
    [anon_sym_BANG] = ACTIONS(3294),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3294),
    [anon_sym_PERCENT] = ACTIONS(3294),
    [anon_sym_CARET] = ACTIONS(3294),
    [anon_sym_PIPE] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3294),
    [anon_sym_LT_LT] = ACTIONS(3294),
    [anon_sym_GT_GT] = ACTIONS(3294),
    [anon_sym_EQ_EQ] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_GT_EQ] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3292),
    [anon_sym_switch] = ACTIONS(3292),
    [anon_sym_and] = ACTIONS(3292),
    [anon_sym_or] = ACTIONS(3294),
    [anon_sym_PLUS_EQ] = ACTIONS(3292),
    [anon_sym_DASH_EQ] = ACTIONS(3292),
    [anon_sym_STAR_EQ] = ACTIONS(3292),
    [anon_sym_SLASH_EQ] = ACTIONS(3292),
    [anon_sym_PERCENT_EQ] = ACTIONS(3292),
    [anon_sym_AMP_EQ] = ACTIONS(3292),
    [anon_sym_CARET_EQ] = ACTIONS(3292),
    [anon_sym_PIPE_EQ] = ACTIONS(3292),
    [anon_sym_LT_LT_EQ] = ACTIONS(3292),
    [anon_sym_GT_GT_EQ] = ACTIONS(3292),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3292),
    [anon_sym_is] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_from] = ACTIONS(3292),
    [anon_sym_join] = ACTIONS(3292),
    [anon_sym_on] = ACTIONS(3292),
    [anon_sym_equals] = ACTIONS(3292),
    [anon_sym_into] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_orderby] = ACTIONS(3292),
    [anon_sym_group] = ACTIONS(3292),
    [anon_sym_by] = ACTIONS(3292),
    [anon_sym_select] = ACTIONS(3292),
    [anon_sym_DOT_DOT] = ACTIONS(3292),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_QMARK_QMARK] = ACTIONS(3294),
    [anon_sym_as] = ACTIONS(3292),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2063] = {
    [sym__preprocessor_call] = STATE(2063),
    [anon_sym_SEMI] = ACTIONS(2847),
    [anon_sym_EQ] = ACTIONS(2844),
    [anon_sym_COLON_COLON] = ACTIONS(2847),
    [anon_sym_LT] = ACTIONS(2844),
    [anon_sym_COMMA] = ACTIONS(2847),
    [anon_sym_GT] = ACTIONS(2844),
    [anon_sym_DOT] = ACTIONS(2844),
    [anon_sym_LBRACK] = ACTIONS(2847),
    [anon_sym_RBRACK] = ACTIONS(2847),
    [anon_sym_COLON] = ACTIONS(2844),
    [anon_sym_LPAREN] = ACTIONS(2847),
    [anon_sym_RPAREN] = ACTIONS(2847),
    [anon_sym_in] = ACTIONS(2844),
    [anon_sym_LBRACE] = ACTIONS(2847),
    [anon_sym_RBRACE] = ACTIONS(2847),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2847),
    [anon_sym_QMARK] = ACTIONS(2844),
    [anon_sym_BANG] = ACTIONS(2844),
    [anon_sym_PLUS_PLUS] = ACTIONS(2847),
    [anon_sym_DASH_DASH] = ACTIONS(2847),
    [anon_sym_PLUS] = ACTIONS(2844),
    [anon_sym_DASH] = ACTIONS(2844),
    [anon_sym_STAR] = ACTIONS(2844),
    [anon_sym_SLASH] = ACTIONS(2844),
    [anon_sym_PERCENT] = ACTIONS(2844),
    [anon_sym_CARET] = ACTIONS(2844),
    [anon_sym_PIPE] = ACTIONS(2844),
    [anon_sym_AMP] = ACTIONS(2844),
    [anon_sym_LT_LT] = ACTIONS(2844),
    [anon_sym_GT_GT] = ACTIONS(2844),
    [anon_sym_EQ_EQ] = ACTIONS(2847),
    [anon_sym_BANG_EQ] = ACTIONS(2847),
    [anon_sym_GT_EQ] = ACTIONS(2847),
    [anon_sym_LT_EQ] = ACTIONS(2847),
    [anon_sym_switch] = ACTIONS(2847),
    [anon_sym_and] = ACTIONS(2847),
    [anon_sym_or] = ACTIONS(2844),
    [anon_sym_PLUS_EQ] = ACTIONS(2847),
    [anon_sym_DASH_EQ] = ACTIONS(2847),
    [anon_sym_STAR_EQ] = ACTIONS(2847),
    [anon_sym_SLASH_EQ] = ACTIONS(2847),
    [anon_sym_PERCENT_EQ] = ACTIONS(2847),
    [anon_sym_AMP_EQ] = ACTIONS(2847),
    [anon_sym_CARET_EQ] = ACTIONS(2847),
    [anon_sym_PIPE_EQ] = ACTIONS(2847),
    [anon_sym_LT_LT_EQ] = ACTIONS(2847),
    [anon_sym_GT_GT_EQ] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2847),
    [anon_sym_is] = ACTIONS(2847),
    [anon_sym_DASH_GT] = ACTIONS(2847),
    [anon_sym_from] = ACTIONS(2847),
    [anon_sym_join] = ACTIONS(2847),
    [anon_sym_on] = ACTIONS(2847),
    [anon_sym_equals] = ACTIONS(2847),
    [anon_sym_into] = ACTIONS(2847),
    [anon_sym_let] = ACTIONS(2847),
    [anon_sym_orderby] = ACTIONS(2847),
    [anon_sym_group] = ACTIONS(2847),
    [anon_sym_by] = ACTIONS(2847),
    [anon_sym_select] = ACTIONS(2847),
    [anon_sym_DOT_DOT] = ACTIONS(2847),
    [anon_sym_with] = ACTIONS(2847),
    [anon_sym_AMP_AMP] = ACTIONS(2847),
    [anon_sym_PIPE_PIPE] = ACTIONS(2847),
    [anon_sym_QMARK_QMARK] = ACTIONS(2844),
    [anon_sym_as] = ACTIONS(2847),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2064] = {
    [sym_type_argument_list] = STATE(2086),
    [sym__preprocessor_call] = STATE(2064),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_switch] = ACTIONS(2829),
    [anon_sym_and] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2829),
    [anon_sym_join] = ACTIONS(2829),
    [anon_sym_on] = ACTIONS(2829),
    [anon_sym_equals] = ACTIONS(2829),
    [anon_sym_into] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_orderby] = ACTIONS(2829),
    [anon_sym_group] = ACTIONS(2829),
    [anon_sym_by] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2065] = {
    [sym_initializer_expression] = STATE(2295),
    [sym__preprocessor_call] = STATE(2065),
    [anon_sym_SEMI] = ACTIONS(3279),
    [anon_sym_EQ] = ACTIONS(3282),
    [anon_sym_LT] = ACTIONS(3282),
    [anon_sym_COMMA] = ACTIONS(3279),
    [anon_sym_GT] = ACTIONS(3282),
    [anon_sym_DOT] = ACTIONS(3282),
    [anon_sym_LBRACK] = ACTIONS(3279),
    [anon_sym_RBRACK] = ACTIONS(3279),
    [anon_sym_COLON] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3279),
    [anon_sym_RPAREN] = ACTIONS(3279),
    [anon_sym_in] = ACTIONS(3279),
    [anon_sym_LBRACE] = ACTIONS(3299),
    [anon_sym_RBRACE] = ACTIONS(3279),
    [anon_sym_EQ_GT] = ACTIONS(3279),
    [anon_sym_where] = ACTIONS(3279),
    [anon_sym_QMARK] = ACTIONS(3288),
    [anon_sym_BANG] = ACTIONS(3282),
    [anon_sym_PLUS_PLUS] = ACTIONS(3279),
    [anon_sym_DASH_DASH] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3282),
    [anon_sym_DASH] = ACTIONS(3282),
    [anon_sym_STAR] = ACTIONS(3282),
    [anon_sym_SLASH] = ACTIONS(3282),
    [anon_sym_PERCENT] = ACTIONS(3282),
    [anon_sym_CARET] = ACTIONS(3282),
    [anon_sym_PIPE] = ACTIONS(3282),
    [anon_sym_AMP] = ACTIONS(3282),
    [anon_sym_LT_LT] = ACTIONS(3282),
    [anon_sym_GT_GT] = ACTIONS(3282),
    [anon_sym_EQ_EQ] = ACTIONS(3279),
    [anon_sym_BANG_EQ] = ACTIONS(3279),
    [anon_sym_GT_EQ] = ACTIONS(3279),
    [anon_sym_LT_EQ] = ACTIONS(3279),
    [anon_sym_switch] = ACTIONS(3279),
    [anon_sym_and] = ACTIONS(3279),
    [anon_sym_or] = ACTIONS(3282),
    [anon_sym_PLUS_EQ] = ACTIONS(3279),
    [anon_sym_DASH_EQ] = ACTIONS(3279),
    [anon_sym_STAR_EQ] = ACTIONS(3279),
    [anon_sym_SLASH_EQ] = ACTIONS(3279),
    [anon_sym_PERCENT_EQ] = ACTIONS(3279),
    [anon_sym_AMP_EQ] = ACTIONS(3279),
    [anon_sym_CARET_EQ] = ACTIONS(3279),
    [anon_sym_PIPE_EQ] = ACTIONS(3279),
    [anon_sym_LT_LT_EQ] = ACTIONS(3279),
    [anon_sym_GT_GT_EQ] = ACTIONS(3279),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3279),
    [anon_sym_is] = ACTIONS(3279),
    [anon_sym_DASH_GT] = ACTIONS(3279),
    [anon_sym_from] = ACTIONS(3279),
    [anon_sym_join] = ACTIONS(3279),
    [anon_sym_on] = ACTIONS(3279),
    [anon_sym_equals] = ACTIONS(3279),
    [anon_sym_let] = ACTIONS(3279),
    [anon_sym_orderby] = ACTIONS(3279),
    [anon_sym_group] = ACTIONS(3279),
    [anon_sym_by] = ACTIONS(3279),
    [anon_sym_select] = ACTIONS(3279),
    [anon_sym_DOT_DOT] = ACTIONS(3279),
    [anon_sym_with] = ACTIONS(3279),
    [anon_sym_AMP_AMP] = ACTIONS(3279),
    [anon_sym_PIPE_PIPE] = ACTIONS(3279),
    [anon_sym_QMARK_QMARK] = ACTIONS(3282),
    [anon_sym_as] = ACTIONS(3279),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2066] = {
    [sym__preprocessor_call] = STATE(2066),
    [anon_sym_SEMI] = ACTIONS(2729),
    [anon_sym_EQ] = ACTIONS(2734),
    [anon_sym_COLON_COLON] = ACTIONS(2729),
    [anon_sym_LT] = ACTIONS(2734),
    [anon_sym_COMMA] = ACTIONS(2729),
    [anon_sym_GT] = ACTIONS(2734),
    [anon_sym_DOT] = ACTIONS(2734),
    [anon_sym_LBRACK] = ACTIONS(2729),
    [anon_sym_RBRACK] = ACTIONS(2729),
    [anon_sym_COLON] = ACTIONS(2734),
    [anon_sym_LPAREN] = ACTIONS(2729),
    [anon_sym_RPAREN] = ACTIONS(2729),
    [anon_sym_in] = ACTIONS(2729),
    [anon_sym_LBRACE] = ACTIONS(2729),
    [anon_sym_RBRACE] = ACTIONS(2729),
    [anon_sym_EQ_GT] = ACTIONS(2729),
    [anon_sym_where] = ACTIONS(2729),
    [anon_sym_QMARK] = ACTIONS(2734),
    [anon_sym_BANG] = ACTIONS(2734),
    [anon_sym_PLUS_PLUS] = ACTIONS(2729),
    [anon_sym_DASH_DASH] = ACTIONS(2729),
    [anon_sym_PLUS] = ACTIONS(2734),
    [anon_sym_DASH] = ACTIONS(2734),
    [anon_sym_STAR] = ACTIONS(2734),
    [anon_sym_SLASH] = ACTIONS(2734),
    [anon_sym_PERCENT] = ACTIONS(2734),
    [anon_sym_CARET] = ACTIONS(2734),
    [anon_sym_PIPE] = ACTIONS(2734),
    [anon_sym_AMP] = ACTIONS(2734),
    [anon_sym_LT_LT] = ACTIONS(2734),
    [anon_sym_GT_GT] = ACTIONS(2734),
    [anon_sym_EQ_EQ] = ACTIONS(2729),
    [anon_sym_BANG_EQ] = ACTIONS(2729),
    [anon_sym_GT_EQ] = ACTIONS(2729),
    [anon_sym_LT_EQ] = ACTIONS(2729),
    [anon_sym_switch] = ACTIONS(2729),
    [anon_sym_and] = ACTIONS(2729),
    [anon_sym_or] = ACTIONS(2734),
    [anon_sym_PLUS_EQ] = ACTIONS(2729),
    [anon_sym_DASH_EQ] = ACTIONS(2729),
    [anon_sym_STAR_EQ] = ACTIONS(2729),
    [anon_sym_SLASH_EQ] = ACTIONS(2729),
    [anon_sym_PERCENT_EQ] = ACTIONS(2729),
    [anon_sym_AMP_EQ] = ACTIONS(2729),
    [anon_sym_CARET_EQ] = ACTIONS(2729),
    [anon_sym_PIPE_EQ] = ACTIONS(2729),
    [anon_sym_LT_LT_EQ] = ACTIONS(2729),
    [anon_sym_GT_GT_EQ] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2729),
    [anon_sym_is] = ACTIONS(2729),
    [anon_sym_DASH_GT] = ACTIONS(2729),
    [anon_sym_from] = ACTIONS(2729),
    [anon_sym_join] = ACTIONS(2729),
    [anon_sym_on] = ACTIONS(2729),
    [anon_sym_equals] = ACTIONS(2729),
    [anon_sym_let] = ACTIONS(2729),
    [anon_sym_orderby] = ACTIONS(2729),
    [anon_sym_group] = ACTIONS(2729),
    [anon_sym_by] = ACTIONS(2729),
    [anon_sym_select] = ACTIONS(2729),
    [anon_sym_DOT_DOT] = ACTIONS(2729),
    [anon_sym_with] = ACTIONS(2729),
    [anon_sym_AMP_AMP] = ACTIONS(2729),
    [anon_sym_PIPE_PIPE] = ACTIONS(2729),
    [anon_sym_QMARK_QMARK] = ACTIONS(2734),
    [anon_sym_as] = ACTIONS(2729),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2067] = {
    [sym_initializer_expression] = STATE(2196),
    [sym__preprocessor_call] = STATE(2067),
    [anon_sym_SEMI] = ACTIONS(3266),
    [anon_sym_EQ] = ACTIONS(3268),
    [anon_sym_LT] = ACTIONS(3268),
    [anon_sym_COMMA] = ACTIONS(3266),
    [anon_sym_GT] = ACTIONS(3268),
    [anon_sym_DOT] = ACTIONS(3268),
    [anon_sym_LBRACK] = ACTIONS(3270),
    [anon_sym_RBRACK] = ACTIONS(3266),
    [anon_sym_COLON] = ACTIONS(3266),
    [anon_sym_LPAREN] = ACTIONS(3266),
    [anon_sym_RPAREN] = ACTIONS(3266),
    [anon_sym_in] = ACTIONS(3266),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(3266),
    [anon_sym_EQ_GT] = ACTIONS(3266),
    [anon_sym_where] = ACTIONS(3266),
    [anon_sym_QMARK] = ACTIONS(3273),
    [anon_sym_BANG] = ACTIONS(3268),
    [anon_sym_PLUS_PLUS] = ACTIONS(3266),
    [anon_sym_DASH_DASH] = ACTIONS(3266),
    [anon_sym_PLUS] = ACTIONS(3268),
    [anon_sym_DASH] = ACTIONS(3268),
    [anon_sym_STAR] = ACTIONS(3276),
    [anon_sym_SLASH] = ACTIONS(3268),
    [anon_sym_PERCENT] = ACTIONS(3268),
    [anon_sym_CARET] = ACTIONS(3268),
    [anon_sym_PIPE] = ACTIONS(3268),
    [anon_sym_AMP] = ACTIONS(3268),
    [anon_sym_LT_LT] = ACTIONS(3268),
    [anon_sym_GT_GT] = ACTIONS(3268),
    [anon_sym_EQ_EQ] = ACTIONS(3266),
    [anon_sym_BANG_EQ] = ACTIONS(3266),
    [anon_sym_GT_EQ] = ACTIONS(3266),
    [anon_sym_LT_EQ] = ACTIONS(3266),
    [anon_sym_switch] = ACTIONS(3266),
    [anon_sym_and] = ACTIONS(3266),
    [anon_sym_or] = ACTIONS(3268),
    [anon_sym_PLUS_EQ] = ACTIONS(3266),
    [anon_sym_DASH_EQ] = ACTIONS(3266),
    [anon_sym_STAR_EQ] = ACTIONS(3266),
    [anon_sym_SLASH_EQ] = ACTIONS(3266),
    [anon_sym_PERCENT_EQ] = ACTIONS(3266),
    [anon_sym_AMP_EQ] = ACTIONS(3266),
    [anon_sym_CARET_EQ] = ACTIONS(3266),
    [anon_sym_PIPE_EQ] = ACTIONS(3266),
    [anon_sym_LT_LT_EQ] = ACTIONS(3266),
    [anon_sym_GT_GT_EQ] = ACTIONS(3266),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3266),
    [anon_sym_is] = ACTIONS(3266),
    [anon_sym_DASH_GT] = ACTIONS(3266),
    [anon_sym_from] = ACTIONS(3266),
    [anon_sym_join] = ACTIONS(3266),
    [anon_sym_on] = ACTIONS(3266),
    [anon_sym_equals] = ACTIONS(3266),
    [anon_sym_let] = ACTIONS(3266),
    [anon_sym_orderby] = ACTIONS(3266),
    [anon_sym_group] = ACTIONS(3266),
    [anon_sym_by] = ACTIONS(3266),
    [anon_sym_select] = ACTIONS(3266),
    [anon_sym_DOT_DOT] = ACTIONS(3266),
    [anon_sym_with] = ACTIONS(3266),
    [anon_sym_AMP_AMP] = ACTIONS(3266),
    [anon_sym_PIPE_PIPE] = ACTIONS(3266),
    [anon_sym_QMARK_QMARK] = ACTIONS(3268),
    [anon_sym_as] = ACTIONS(3266),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2068] = {
    [sym__preprocessor_call] = STATE(2068),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_RBRACK] = ACTIONS(2815),
    [anon_sym_COLON] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_in] = ACTIONS(2817),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_where] = ACTIONS(2815),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2817),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_switch] = ACTIONS(2815),
    [anon_sym_and] = ACTIONS(2815),
    [anon_sym_or] = ACTIONS(2817),
    [anon_sym_PLUS_EQ] = ACTIONS(2815),
    [anon_sym_DASH_EQ] = ACTIONS(2815),
    [anon_sym_STAR_EQ] = ACTIONS(2815),
    [anon_sym_SLASH_EQ] = ACTIONS(2815),
    [anon_sym_PERCENT_EQ] = ACTIONS(2815),
    [anon_sym_AMP_EQ] = ACTIONS(2815),
    [anon_sym_CARET_EQ] = ACTIONS(2815),
    [anon_sym_PIPE_EQ] = ACTIONS(2815),
    [anon_sym_LT_LT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT_EQ] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2815),
    [anon_sym_is] = ACTIONS(2815),
    [anon_sym_DASH_GT] = ACTIONS(2815),
    [anon_sym_from] = ACTIONS(2815),
    [anon_sym_join] = ACTIONS(2815),
    [anon_sym_on] = ACTIONS(2815),
    [anon_sym_equals] = ACTIONS(2815),
    [anon_sym_into] = ACTIONS(2815),
    [anon_sym_let] = ACTIONS(2815),
    [anon_sym_orderby] = ACTIONS(2815),
    [anon_sym_group] = ACTIONS(2815),
    [anon_sym_by] = ACTIONS(2815),
    [anon_sym_select] = ACTIONS(2815),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_with] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK] = ACTIONS(2817),
    [anon_sym_as] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2069] = {
    [sym_initializer_expression] = STATE(2225),
    [sym__preprocessor_call] = STATE(2069),
    [anon_sym_SEMI] = ACTIONS(3292),
    [anon_sym_EQ] = ACTIONS(3294),
    [anon_sym_LT] = ACTIONS(3294),
    [anon_sym_COMMA] = ACTIONS(3292),
    [anon_sym_GT] = ACTIONS(3294),
    [anon_sym_DOT] = ACTIONS(3294),
    [anon_sym_LBRACK] = ACTIONS(3292),
    [anon_sym_RBRACK] = ACTIONS(3292),
    [anon_sym_COLON] = ACTIONS(3292),
    [anon_sym_LPAREN] = ACTIONS(3292),
    [anon_sym_RPAREN] = ACTIONS(3292),
    [anon_sym_in] = ACTIONS(3292),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(3292),
    [anon_sym_EQ_GT] = ACTIONS(3292),
    [anon_sym_where] = ACTIONS(3292),
    [anon_sym_QMARK] = ACTIONS(3294),
    [anon_sym_BANG] = ACTIONS(3294),
    [anon_sym_PLUS_PLUS] = ACTIONS(3292),
    [anon_sym_DASH_DASH] = ACTIONS(3292),
    [anon_sym_PLUS] = ACTIONS(3294),
    [anon_sym_DASH] = ACTIONS(3294),
    [anon_sym_STAR] = ACTIONS(3294),
    [anon_sym_SLASH] = ACTIONS(3294),
    [anon_sym_PERCENT] = ACTIONS(3294),
    [anon_sym_CARET] = ACTIONS(3294),
    [anon_sym_PIPE] = ACTIONS(3294),
    [anon_sym_AMP] = ACTIONS(3294),
    [anon_sym_LT_LT] = ACTIONS(3294),
    [anon_sym_GT_GT] = ACTIONS(3294),
    [anon_sym_EQ_EQ] = ACTIONS(3292),
    [anon_sym_BANG_EQ] = ACTIONS(3292),
    [anon_sym_GT_EQ] = ACTIONS(3292),
    [anon_sym_LT_EQ] = ACTIONS(3292),
    [anon_sym_switch] = ACTIONS(3292),
    [anon_sym_and] = ACTIONS(3292),
    [anon_sym_or] = ACTIONS(3294),
    [anon_sym_PLUS_EQ] = ACTIONS(3292),
    [anon_sym_DASH_EQ] = ACTIONS(3292),
    [anon_sym_STAR_EQ] = ACTIONS(3292),
    [anon_sym_SLASH_EQ] = ACTIONS(3292),
    [anon_sym_PERCENT_EQ] = ACTIONS(3292),
    [anon_sym_AMP_EQ] = ACTIONS(3292),
    [anon_sym_CARET_EQ] = ACTIONS(3292),
    [anon_sym_PIPE_EQ] = ACTIONS(3292),
    [anon_sym_LT_LT_EQ] = ACTIONS(3292),
    [anon_sym_GT_GT_EQ] = ACTIONS(3292),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3292),
    [anon_sym_is] = ACTIONS(3292),
    [anon_sym_DASH_GT] = ACTIONS(3292),
    [anon_sym_from] = ACTIONS(3292),
    [anon_sym_join] = ACTIONS(3292),
    [anon_sym_on] = ACTIONS(3292),
    [anon_sym_equals] = ACTIONS(3292),
    [anon_sym_let] = ACTIONS(3292),
    [anon_sym_orderby] = ACTIONS(3292),
    [anon_sym_group] = ACTIONS(3292),
    [anon_sym_by] = ACTIONS(3292),
    [anon_sym_select] = ACTIONS(3292),
    [anon_sym_DOT_DOT] = ACTIONS(3292),
    [anon_sym_with] = ACTIONS(3292),
    [anon_sym_AMP_AMP] = ACTIONS(3292),
    [anon_sym_PIPE_PIPE] = ACTIONS(3292),
    [anon_sym_QMARK_QMARK] = ACTIONS(3294),
    [anon_sym_as] = ACTIONS(3292),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2070] = {
    [sym__preprocessor_call] = STATE(2070),
    [anon_sym_SEMI] = ACTIONS(2890),
    [anon_sym_EQ] = ACTIONS(2888),
    [anon_sym_LT] = ACTIONS(2888),
    [anon_sym_COMMA] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(2888),
    [anon_sym_DOT] = ACTIONS(2888),
    [anon_sym_LBRACK] = ACTIONS(2890),
    [anon_sym_RBRACK] = ACTIONS(2890),
    [anon_sym_COLON] = ACTIONS(2890),
    [anon_sym_LPAREN] = ACTIONS(2890),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [anon_sym_in] = ACTIONS(2888),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [anon_sym_EQ_GT] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2890),
    [anon_sym_QMARK] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2888),
    [anon_sym_PLUS_PLUS] = ACTIONS(2890),
    [anon_sym_DASH_DASH] = ACTIONS(2890),
    [anon_sym_PLUS] = ACTIONS(2888),
    [anon_sym_DASH] = ACTIONS(2888),
    [anon_sym_STAR] = ACTIONS(2888),
    [anon_sym_SLASH] = ACTIONS(2888),
    [anon_sym_PERCENT] = ACTIONS(2888),
    [anon_sym_CARET] = ACTIONS(2888),
    [anon_sym_PIPE] = ACTIONS(2888),
    [anon_sym_AMP] = ACTIONS(2888),
    [anon_sym_LT_LT] = ACTIONS(2888),
    [anon_sym_GT_GT] = ACTIONS(2888),
    [anon_sym_EQ_EQ] = ACTIONS(2890),
    [anon_sym_BANG_EQ] = ACTIONS(2890),
    [anon_sym_GT_EQ] = ACTIONS(2890),
    [anon_sym_LT_EQ] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2890),
    [anon_sym_and] = ACTIONS(2890),
    [anon_sym_or] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2890),
    [anon_sym_DASH_EQ] = ACTIONS(2890),
    [anon_sym_STAR_EQ] = ACTIONS(2890),
    [anon_sym_SLASH_EQ] = ACTIONS(2890),
    [anon_sym_PERCENT_EQ] = ACTIONS(2890),
    [anon_sym_AMP_EQ] = ACTIONS(2890),
    [anon_sym_CARET_EQ] = ACTIONS(2890),
    [anon_sym_PIPE_EQ] = ACTIONS(2890),
    [anon_sym_LT_LT_EQ] = ACTIONS(2890),
    [anon_sym_GT_GT_EQ] = ACTIONS(2890),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2890),
    [anon_sym_is] = ACTIONS(2890),
    [anon_sym_DASH_GT] = ACTIONS(2890),
    [anon_sym_from] = ACTIONS(2890),
    [anon_sym_join] = ACTIONS(2890),
    [anon_sym_on] = ACTIONS(2890),
    [anon_sym_equals] = ACTIONS(2890),
    [anon_sym_into] = ACTIONS(2890),
    [anon_sym_let] = ACTIONS(2890),
    [anon_sym_orderby] = ACTIONS(2890),
    [anon_sym_group] = ACTIONS(2890),
    [anon_sym_by] = ACTIONS(2890),
    [anon_sym_select] = ACTIONS(2890),
    [anon_sym_DOT_DOT] = ACTIONS(2890),
    [anon_sym_with] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_QMARK_QMARK] = ACTIONS(2888),
    [anon_sym_as] = ACTIONS(2890),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2071] = {
    [sym_array_rank_specifier] = STATE(2090),
    [sym__preprocessor_call] = STATE(2071),
    [anon_sym_SEMI] = ACTIONS(3302),
    [anon_sym_EQ] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3238),
    [anon_sym_RBRACK] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3302),
    [anon_sym_RPAREN] = ACTIONS(3302),
    [anon_sym_in] = ACTIONS(3304),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_EQ_GT] = ACTIONS(3302),
    [anon_sym_where] = ACTIONS(3302),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3242),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3304),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LT_LT] = ACTIONS(3304),
    [anon_sym_GT_GT] = ACTIONS(3304),
    [anon_sym_EQ_EQ] = ACTIONS(3302),
    [anon_sym_BANG_EQ] = ACTIONS(3302),
    [anon_sym_GT_EQ] = ACTIONS(3302),
    [anon_sym_LT_EQ] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_and] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3304),
    [anon_sym_PLUS_EQ] = ACTIONS(3302),
    [anon_sym_DASH_EQ] = ACTIONS(3302),
    [anon_sym_STAR_EQ] = ACTIONS(3302),
    [anon_sym_SLASH_EQ] = ACTIONS(3302),
    [anon_sym_PERCENT_EQ] = ACTIONS(3302),
    [anon_sym_AMP_EQ] = ACTIONS(3302),
    [anon_sym_CARET_EQ] = ACTIONS(3302),
    [anon_sym_PIPE_EQ] = ACTIONS(3302),
    [anon_sym_LT_LT_EQ] = ACTIONS(3302),
    [anon_sym_GT_GT_EQ] = ACTIONS(3302),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3302),
    [anon_sym_is] = ACTIONS(3302),
    [anon_sym_DASH_GT] = ACTIONS(3302),
    [anon_sym_from] = ACTIONS(3302),
    [anon_sym_join] = ACTIONS(3302),
    [anon_sym_on] = ACTIONS(3302),
    [anon_sym_equals] = ACTIONS(3302),
    [anon_sym_into] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_orderby] = ACTIONS(3302),
    [anon_sym_group] = ACTIONS(3302),
    [anon_sym_by] = ACTIONS(3302),
    [anon_sym_select] = ACTIONS(3302),
    [anon_sym_DOT_DOT] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_PIPE_PIPE] = ACTIONS(3302),
    [anon_sym_QMARK_QMARK] = ACTIONS(3304),
    [anon_sym_as] = ACTIONS(3302),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2072] = {
    [sym__preprocessor_call] = STATE(2072),
    [anon_sym_SEMI] = ACTIONS(2951),
    [anon_sym_EQ] = ACTIONS(2949),
    [anon_sym_LT] = ACTIONS(2949),
    [anon_sym_COMMA] = ACTIONS(2951),
    [anon_sym_GT] = ACTIONS(2949),
    [anon_sym_DOT] = ACTIONS(2949),
    [anon_sym_LBRACK] = ACTIONS(2951),
    [anon_sym_RBRACK] = ACTIONS(2951),
    [anon_sym_COLON] = ACTIONS(2951),
    [anon_sym_LPAREN] = ACTIONS(2951),
    [anon_sym_RPAREN] = ACTIONS(2951),
    [anon_sym_in] = ACTIONS(2949),
    [anon_sym_LBRACE] = ACTIONS(2951),
    [anon_sym_RBRACE] = ACTIONS(2951),
    [anon_sym_EQ_GT] = ACTIONS(2951),
    [anon_sym_where] = ACTIONS(2951),
    [anon_sym_QMARK] = ACTIONS(2949),
    [anon_sym_BANG] = ACTIONS(2949),
    [anon_sym_PLUS_PLUS] = ACTIONS(2951),
    [anon_sym_DASH_DASH] = ACTIONS(2951),
    [anon_sym_PLUS] = ACTIONS(2949),
    [anon_sym_DASH] = ACTIONS(2949),
    [anon_sym_STAR] = ACTIONS(2949),
    [anon_sym_SLASH] = ACTIONS(2949),
    [anon_sym_PERCENT] = ACTIONS(2949),
    [anon_sym_CARET] = ACTIONS(2949),
    [anon_sym_PIPE] = ACTIONS(2949),
    [anon_sym_AMP] = ACTIONS(2949),
    [anon_sym_LT_LT] = ACTIONS(2949),
    [anon_sym_GT_GT] = ACTIONS(2949),
    [anon_sym_EQ_EQ] = ACTIONS(2951),
    [anon_sym_BANG_EQ] = ACTIONS(2951),
    [anon_sym_GT_EQ] = ACTIONS(2951),
    [anon_sym_LT_EQ] = ACTIONS(2951),
    [anon_sym_switch] = ACTIONS(2951),
    [anon_sym_and] = ACTIONS(2951),
    [anon_sym_or] = ACTIONS(2949),
    [anon_sym_PLUS_EQ] = ACTIONS(2951),
    [anon_sym_DASH_EQ] = ACTIONS(2951),
    [anon_sym_STAR_EQ] = ACTIONS(2951),
    [anon_sym_SLASH_EQ] = ACTIONS(2951),
    [anon_sym_PERCENT_EQ] = ACTIONS(2951),
    [anon_sym_AMP_EQ] = ACTIONS(2951),
    [anon_sym_CARET_EQ] = ACTIONS(2951),
    [anon_sym_PIPE_EQ] = ACTIONS(2951),
    [anon_sym_LT_LT_EQ] = ACTIONS(2951),
    [anon_sym_GT_GT_EQ] = ACTIONS(2951),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2951),
    [anon_sym_is] = ACTIONS(2951),
    [anon_sym_DASH_GT] = ACTIONS(2951),
    [anon_sym_from] = ACTIONS(2951),
    [anon_sym_join] = ACTIONS(2951),
    [anon_sym_on] = ACTIONS(2951),
    [anon_sym_equals] = ACTIONS(2951),
    [anon_sym_into] = ACTIONS(2951),
    [anon_sym_let] = ACTIONS(2951),
    [anon_sym_orderby] = ACTIONS(2951),
    [anon_sym_group] = ACTIONS(2951),
    [anon_sym_by] = ACTIONS(2951),
    [anon_sym_select] = ACTIONS(2951),
    [anon_sym_DOT_DOT] = ACTIONS(2951),
    [anon_sym_with] = ACTIONS(2951),
    [anon_sym_AMP_AMP] = ACTIONS(2951),
    [anon_sym_PIPE_PIPE] = ACTIONS(2951),
    [anon_sym_QMARK_QMARK] = ACTIONS(2949),
    [anon_sym_as] = ACTIONS(2951),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2073] = {
    [sym__preprocessor_call] = STATE(2073),
    [anon_sym_SEMI] = ACTIONS(3306),
    [anon_sym_EQ] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3306),
    [anon_sym_RPAREN] = ACTIONS(3306),
    [anon_sym_in] = ACTIONS(3308),
    [anon_sym_LBRACE] = ACTIONS(3306),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_EQ_GT] = ACTIONS(3306),
    [anon_sym_where] = ACTIONS(3306),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_CARET] = ACTIONS(3308),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(3308),
    [anon_sym_EQ_EQ] = ACTIONS(3306),
    [anon_sym_BANG_EQ] = ACTIONS(3306),
    [anon_sym_GT_EQ] = ACTIONS(3306),
    [anon_sym_LT_EQ] = ACTIONS(3306),
    [anon_sym_switch] = ACTIONS(3306),
    [anon_sym_and] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3308),
    [anon_sym_PLUS_EQ] = ACTIONS(3306),
    [anon_sym_DASH_EQ] = ACTIONS(3306),
    [anon_sym_STAR_EQ] = ACTIONS(3306),
    [anon_sym_SLASH_EQ] = ACTIONS(3306),
    [anon_sym_PERCENT_EQ] = ACTIONS(3306),
    [anon_sym_AMP_EQ] = ACTIONS(3306),
    [anon_sym_CARET_EQ] = ACTIONS(3306),
    [anon_sym_PIPE_EQ] = ACTIONS(3306),
    [anon_sym_LT_LT_EQ] = ACTIONS(3306),
    [anon_sym_GT_GT_EQ] = ACTIONS(3306),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3306),
    [anon_sym_is] = ACTIONS(3306),
    [anon_sym_DASH_GT] = ACTIONS(3306),
    [anon_sym_from] = ACTIONS(3306),
    [anon_sym_join] = ACTIONS(3306),
    [anon_sym_on] = ACTIONS(3306),
    [anon_sym_equals] = ACTIONS(3306),
    [anon_sym_into] = ACTIONS(3306),
    [anon_sym_let] = ACTIONS(3306),
    [anon_sym_orderby] = ACTIONS(3306),
    [anon_sym_group] = ACTIONS(3306),
    [anon_sym_by] = ACTIONS(3306),
    [anon_sym_select] = ACTIONS(3306),
    [anon_sym_DOT_DOT] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_PIPE_PIPE] = ACTIONS(3306),
    [anon_sym_QMARK_QMARK] = ACTIONS(3308),
    [anon_sym_as] = ACTIONS(3306),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2074] = {
    [sym__preprocessor_call] = STATE(2074),
    [anon_sym_SEMI] = ACTIONS(3310),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_GT] = ACTIONS(3312),
    [anon_sym_DOT] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_RBRACK] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3310),
    [anon_sym_RPAREN] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3312),
    [anon_sym_LBRACE] = ACTIONS(3310),
    [anon_sym_RBRACE] = ACTIONS(3310),
    [anon_sym_EQ_GT] = ACTIONS(3310),
    [anon_sym_where] = ACTIONS(3310),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_CARET] = ACTIONS(3312),
    [anon_sym_PIPE] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LT_LT] = ACTIONS(3312),
    [anon_sym_GT_GT] = ACTIONS(3312),
    [anon_sym_EQ_EQ] = ACTIONS(3310),
    [anon_sym_BANG_EQ] = ACTIONS(3310),
    [anon_sym_GT_EQ] = ACTIONS(3310),
    [anon_sym_LT_EQ] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_and] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3312),
    [anon_sym_PLUS_EQ] = ACTIONS(3310),
    [anon_sym_DASH_EQ] = ACTIONS(3310),
    [anon_sym_STAR_EQ] = ACTIONS(3310),
    [anon_sym_SLASH_EQ] = ACTIONS(3310),
    [anon_sym_PERCENT_EQ] = ACTIONS(3310),
    [anon_sym_AMP_EQ] = ACTIONS(3310),
    [anon_sym_CARET_EQ] = ACTIONS(3310),
    [anon_sym_PIPE_EQ] = ACTIONS(3310),
    [anon_sym_LT_LT_EQ] = ACTIONS(3310),
    [anon_sym_GT_GT_EQ] = ACTIONS(3310),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3310),
    [anon_sym_is] = ACTIONS(3310),
    [anon_sym_DASH_GT] = ACTIONS(3310),
    [anon_sym_from] = ACTIONS(3310),
    [anon_sym_join] = ACTIONS(3310),
    [anon_sym_on] = ACTIONS(3310),
    [anon_sym_equals] = ACTIONS(3310),
    [anon_sym_into] = ACTIONS(3310),
    [anon_sym_let] = ACTIONS(3310),
    [anon_sym_orderby] = ACTIONS(3310),
    [anon_sym_group] = ACTIONS(3310),
    [anon_sym_by] = ACTIONS(3310),
    [anon_sym_select] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3310),
    [anon_sym_with] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_PIPE_PIPE] = ACTIONS(3310),
    [anon_sym_QMARK_QMARK] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2075] = {
    [sym__preprocessor_call] = STATE(2075),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_RBRACK] = ACTIONS(2947),
    [anon_sym_COLON] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2945),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_where] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2945),
    [anon_sym_PERCENT] = ACTIONS(2945),
    [anon_sym_CARET] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_switch] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2945),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
    [anon_sym_STAR_EQ] = ACTIONS(2947),
    [anon_sym_SLASH_EQ] = ACTIONS(2947),
    [anon_sym_PERCENT_EQ] = ACTIONS(2947),
    [anon_sym_AMP_EQ] = ACTIONS(2947),
    [anon_sym_CARET_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_LT_LT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2947),
    [anon_sym_is] = ACTIONS(2947),
    [anon_sym_DASH_GT] = ACTIONS(2947),
    [anon_sym_from] = ACTIONS(2947),
    [anon_sym_join] = ACTIONS(2947),
    [anon_sym_on] = ACTIONS(2947),
    [anon_sym_equals] = ACTIONS(2947),
    [anon_sym_into] = ACTIONS(2947),
    [anon_sym_let] = ACTIONS(2947),
    [anon_sym_orderby] = ACTIONS(2947),
    [anon_sym_group] = ACTIONS(2947),
    [anon_sym_by] = ACTIONS(2947),
    [anon_sym_select] = ACTIONS(2947),
    [anon_sym_DOT_DOT] = ACTIONS(2947),
    [anon_sym_with] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_QMARK_QMARK] = ACTIONS(2945),
    [anon_sym_as] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2076] = {
    [sym__preprocessor_call] = STATE(2076),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_EQ] = ACTIONS(2860),
    [anon_sym_LT] = ACTIONS(2860),
    [anon_sym_COMMA] = ACTIONS(2862),
    [anon_sym_GT] = ACTIONS(2860),
    [anon_sym_DOT] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_RBRACK] = ACTIONS(2862),
    [anon_sym_COLON] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_RPAREN] = ACTIONS(2862),
    [anon_sym_in] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_EQ_GT] = ACTIONS(2862),
    [anon_sym_where] = ACTIONS(2862),
    [anon_sym_QMARK] = ACTIONS(2860),
    [anon_sym_BANG] = ACTIONS(2860),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2860),
    [anon_sym_SLASH] = ACTIONS(2860),
    [anon_sym_PERCENT] = ACTIONS(2860),
    [anon_sym_CARET] = ACTIONS(2860),
    [anon_sym_PIPE] = ACTIONS(2860),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym_LT_LT] = ACTIONS(2860),
    [anon_sym_GT_GT] = ACTIONS(2860),
    [anon_sym_EQ_EQ] = ACTIONS(2862),
    [anon_sym_BANG_EQ] = ACTIONS(2862),
    [anon_sym_GT_EQ] = ACTIONS(2862),
    [anon_sym_LT_EQ] = ACTIONS(2862),
    [anon_sym_switch] = ACTIONS(2862),
    [anon_sym_and] = ACTIONS(2862),
    [anon_sym_or] = ACTIONS(2860),
    [anon_sym_PLUS_EQ] = ACTIONS(2862),
    [anon_sym_DASH_EQ] = ACTIONS(2862),
    [anon_sym_STAR_EQ] = ACTIONS(2862),
    [anon_sym_SLASH_EQ] = ACTIONS(2862),
    [anon_sym_PERCENT_EQ] = ACTIONS(2862),
    [anon_sym_AMP_EQ] = ACTIONS(2862),
    [anon_sym_CARET_EQ] = ACTIONS(2862),
    [anon_sym_PIPE_EQ] = ACTIONS(2862),
    [anon_sym_LT_LT_EQ] = ACTIONS(2862),
    [anon_sym_GT_GT_EQ] = ACTIONS(2862),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2862),
    [anon_sym_is] = ACTIONS(2862),
    [anon_sym_DASH_GT] = ACTIONS(2862),
    [anon_sym_from] = ACTIONS(2862),
    [anon_sym_join] = ACTIONS(2862),
    [anon_sym_on] = ACTIONS(2862),
    [anon_sym_equals] = ACTIONS(2862),
    [anon_sym_into] = ACTIONS(2862),
    [anon_sym_let] = ACTIONS(2862),
    [anon_sym_orderby] = ACTIONS(2862),
    [anon_sym_group] = ACTIONS(2862),
    [anon_sym_by] = ACTIONS(2862),
    [anon_sym_select] = ACTIONS(2862),
    [anon_sym_DOT_DOT] = ACTIONS(2862),
    [anon_sym_with] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_PIPE_PIPE] = ACTIONS(2862),
    [anon_sym_QMARK_QMARK] = ACTIONS(2860),
    [anon_sym_as] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2077] = {
    [sym__preprocessor_call] = STATE(2077),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_EQ] = ACTIONS(2941),
    [anon_sym_LT] = ACTIONS(2941),
    [anon_sym_COMMA] = ACTIONS(2943),
    [anon_sym_GT] = ACTIONS(2941),
    [anon_sym_DOT] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_RBRACK] = ACTIONS(2943),
    [anon_sym_COLON] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_in] = ACTIONS(2941),
    [anon_sym_LBRACE] = ACTIONS(2943),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_EQ_GT] = ACTIONS(2943),
    [anon_sym_where] = ACTIONS(2943),
    [anon_sym_QMARK] = ACTIONS(2941),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_SLASH] = ACTIONS(2941),
    [anon_sym_PERCENT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym_LT_LT] = ACTIONS(2941),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_EQ_EQ] = ACTIONS(2943),
    [anon_sym_BANG_EQ] = ACTIONS(2943),
    [anon_sym_GT_EQ] = ACTIONS(2943),
    [anon_sym_LT_EQ] = ACTIONS(2943),
    [anon_sym_switch] = ACTIONS(2943),
    [anon_sym_and] = ACTIONS(2943),
    [anon_sym_or] = ACTIONS(2941),
    [anon_sym_PLUS_EQ] = ACTIONS(2943),
    [anon_sym_DASH_EQ] = ACTIONS(2943),
    [anon_sym_STAR_EQ] = ACTIONS(2943),
    [anon_sym_SLASH_EQ] = ACTIONS(2943),
    [anon_sym_PERCENT_EQ] = ACTIONS(2943),
    [anon_sym_AMP_EQ] = ACTIONS(2943),
    [anon_sym_CARET_EQ] = ACTIONS(2943),
    [anon_sym_PIPE_EQ] = ACTIONS(2943),
    [anon_sym_LT_LT_EQ] = ACTIONS(2943),
    [anon_sym_GT_GT_EQ] = ACTIONS(2943),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2943),
    [anon_sym_is] = ACTIONS(2943),
    [anon_sym_DASH_GT] = ACTIONS(2943),
    [anon_sym_from] = ACTIONS(2943),
    [anon_sym_join] = ACTIONS(2943),
    [anon_sym_on] = ACTIONS(2943),
    [anon_sym_equals] = ACTIONS(2943),
    [anon_sym_into] = ACTIONS(2943),
    [anon_sym_let] = ACTIONS(2943),
    [anon_sym_orderby] = ACTIONS(2943),
    [anon_sym_group] = ACTIONS(2943),
    [anon_sym_by] = ACTIONS(2943),
    [anon_sym_select] = ACTIONS(2943),
    [anon_sym_DOT_DOT] = ACTIONS(2943),
    [anon_sym_with] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2943),
    [anon_sym_QMARK_QMARK] = ACTIONS(2941),
    [anon_sym_as] = ACTIONS(2943),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2078] = {
    [sym__preprocessor_call] = STATE(2078),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_EQ] = ACTIONS(2937),
    [anon_sym_LT] = ACTIONS(2937),
    [anon_sym_COMMA] = ACTIONS(2939),
    [anon_sym_GT] = ACTIONS(2937),
    [anon_sym_DOT] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_RBRACK] = ACTIONS(2939),
    [anon_sym_COLON] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_RPAREN] = ACTIONS(2939),
    [anon_sym_in] = ACTIONS(2937),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(2939),
    [anon_sym_where] = ACTIONS(2939),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_SLASH] = ACTIONS(2937),
    [anon_sym_PERCENT] = ACTIONS(2937),
    [anon_sym_CARET] = ACTIONS(2937),
    [anon_sym_PIPE] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_LT_LT] = ACTIONS(2937),
    [anon_sym_GT_GT] = ACTIONS(2937),
    [anon_sym_EQ_EQ] = ACTIONS(2939),
    [anon_sym_BANG_EQ] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(2939),
    [anon_sym_LT_EQ] = ACTIONS(2939),
    [anon_sym_switch] = ACTIONS(2939),
    [anon_sym_and] = ACTIONS(2939),
    [anon_sym_or] = ACTIONS(2937),
    [anon_sym_PLUS_EQ] = ACTIONS(2939),
    [anon_sym_DASH_EQ] = ACTIONS(2939),
    [anon_sym_STAR_EQ] = ACTIONS(2939),
    [anon_sym_SLASH_EQ] = ACTIONS(2939),
    [anon_sym_PERCENT_EQ] = ACTIONS(2939),
    [anon_sym_AMP_EQ] = ACTIONS(2939),
    [anon_sym_CARET_EQ] = ACTIONS(2939),
    [anon_sym_PIPE_EQ] = ACTIONS(2939),
    [anon_sym_LT_LT_EQ] = ACTIONS(2939),
    [anon_sym_GT_GT_EQ] = ACTIONS(2939),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2939),
    [anon_sym_is] = ACTIONS(2939),
    [anon_sym_DASH_GT] = ACTIONS(2939),
    [anon_sym_from] = ACTIONS(2939),
    [anon_sym_join] = ACTIONS(2939),
    [anon_sym_on] = ACTIONS(2939),
    [anon_sym_equals] = ACTIONS(2939),
    [anon_sym_into] = ACTIONS(2939),
    [anon_sym_let] = ACTIONS(2939),
    [anon_sym_orderby] = ACTIONS(2939),
    [anon_sym_group] = ACTIONS(2939),
    [anon_sym_by] = ACTIONS(2939),
    [anon_sym_select] = ACTIONS(2939),
    [anon_sym_DOT_DOT] = ACTIONS(2939),
    [anon_sym_with] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_PIPE_PIPE] = ACTIONS(2939),
    [anon_sym_QMARK_QMARK] = ACTIONS(2937),
    [anon_sym_as] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2079] = {
    [sym__preprocessor_call] = STATE(2079),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_RBRACK] = ACTIONS(2935),
    [anon_sym_COLON] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_in] = ACTIONS(2933),
    [anon_sym_LBRACE] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_EQ_GT] = ACTIONS(2935),
    [anon_sym_where] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2933),
    [anon_sym_CARET] = ACTIONS(2933),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_and] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2933),
    [anon_sym_PLUS_EQ] = ACTIONS(2935),
    [anon_sym_DASH_EQ] = ACTIONS(2935),
    [anon_sym_STAR_EQ] = ACTIONS(2935),
    [anon_sym_SLASH_EQ] = ACTIONS(2935),
    [anon_sym_PERCENT_EQ] = ACTIONS(2935),
    [anon_sym_AMP_EQ] = ACTIONS(2935),
    [anon_sym_CARET_EQ] = ACTIONS(2935),
    [anon_sym_PIPE_EQ] = ACTIONS(2935),
    [anon_sym_LT_LT_EQ] = ACTIONS(2935),
    [anon_sym_GT_GT_EQ] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_DASH_GT] = ACTIONS(2935),
    [anon_sym_from] = ACTIONS(2935),
    [anon_sym_join] = ACTIONS(2935),
    [anon_sym_on] = ACTIONS(2935),
    [anon_sym_equals] = ACTIONS(2935),
    [anon_sym_into] = ACTIONS(2935),
    [anon_sym_let] = ACTIONS(2935),
    [anon_sym_orderby] = ACTIONS(2935),
    [anon_sym_group] = ACTIONS(2935),
    [anon_sym_by] = ACTIONS(2935),
    [anon_sym_select] = ACTIONS(2935),
    [anon_sym_DOT_DOT] = ACTIONS(2935),
    [anon_sym_with] = ACTIONS(2935),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2933),
    [anon_sym_as] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2080] = {
    [sym__preprocessor_call] = STATE(2080),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_DOT] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_RBRACK] = ACTIONS(2905),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_in] = ACTIONS(2903),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(2905),
    [anon_sym_where] = ACTIONS(2905),
    [anon_sym_QMARK] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_SLASH] = ACTIONS(2903),
    [anon_sym_PERCENT] = ACTIONS(2903),
    [anon_sym_CARET] = ACTIONS(2903),
    [anon_sym_PIPE] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_LT_LT] = ACTIONS(2903),
    [anon_sym_GT_GT] = ACTIONS(2903),
    [anon_sym_EQ_EQ] = ACTIONS(2905),
    [anon_sym_BANG_EQ] = ACTIONS(2905),
    [anon_sym_GT_EQ] = ACTIONS(2905),
    [anon_sym_LT_EQ] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2905),
    [anon_sym_DASH_EQ] = ACTIONS(2905),
    [anon_sym_STAR_EQ] = ACTIONS(2905),
    [anon_sym_SLASH_EQ] = ACTIONS(2905),
    [anon_sym_PERCENT_EQ] = ACTIONS(2905),
    [anon_sym_AMP_EQ] = ACTIONS(2905),
    [anon_sym_CARET_EQ] = ACTIONS(2905),
    [anon_sym_PIPE_EQ] = ACTIONS(2905),
    [anon_sym_LT_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_GT_EQ] = ACTIONS(2905),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2905),
    [anon_sym_is] = ACTIONS(2905),
    [anon_sym_DASH_GT] = ACTIONS(2905),
    [anon_sym_from] = ACTIONS(2905),
    [anon_sym_join] = ACTIONS(2905),
    [anon_sym_on] = ACTIONS(2905),
    [anon_sym_equals] = ACTIONS(2905),
    [anon_sym_into] = ACTIONS(2905),
    [anon_sym_let] = ACTIONS(2905),
    [anon_sym_orderby] = ACTIONS(2905),
    [anon_sym_group] = ACTIONS(2905),
    [anon_sym_by] = ACTIONS(2905),
    [anon_sym_select] = ACTIONS(2905),
    [anon_sym_DOT_DOT] = ACTIONS(2905),
    [anon_sym_with] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_QMARK_QMARK] = ACTIONS(2903),
    [anon_sym_as] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2081] = {
    [sym_initializer_expression] = STATE(2338),
    [sym__preprocessor_call] = STATE(2081),
    [anon_sym_SEMI] = ACTIONS(3262),
    [anon_sym_EQ] = ACTIONS(3264),
    [anon_sym_LT] = ACTIONS(3264),
    [anon_sym_COMMA] = ACTIONS(3262),
    [anon_sym_GT] = ACTIONS(3264),
    [anon_sym_DOT] = ACTIONS(3264),
    [anon_sym_LBRACK] = ACTIONS(3262),
    [anon_sym_RBRACK] = ACTIONS(3262),
    [anon_sym_COLON] = ACTIONS(3262),
    [anon_sym_LPAREN] = ACTIONS(3262),
    [anon_sym_RPAREN] = ACTIONS(3262),
    [anon_sym_in] = ACTIONS(3262),
    [anon_sym_LBRACE] = ACTIONS(965),
    [anon_sym_RBRACE] = ACTIONS(3262),
    [anon_sym_EQ_GT] = ACTIONS(3262),
    [anon_sym_where] = ACTIONS(3262),
    [anon_sym_QMARK] = ACTIONS(3264),
    [anon_sym_BANG] = ACTIONS(3264),
    [anon_sym_PLUS_PLUS] = ACTIONS(3262),
    [anon_sym_DASH_DASH] = ACTIONS(3262),
    [anon_sym_PLUS] = ACTIONS(3264),
    [anon_sym_DASH] = ACTIONS(3264),
    [anon_sym_STAR] = ACTIONS(3264),
    [anon_sym_SLASH] = ACTIONS(3264),
    [anon_sym_PERCENT] = ACTIONS(3264),
    [anon_sym_CARET] = ACTIONS(3264),
    [anon_sym_PIPE] = ACTIONS(3264),
    [anon_sym_AMP] = ACTIONS(3264),
    [anon_sym_LT_LT] = ACTIONS(3264),
    [anon_sym_GT_GT] = ACTIONS(3264),
    [anon_sym_EQ_EQ] = ACTIONS(3262),
    [anon_sym_BANG_EQ] = ACTIONS(3262),
    [anon_sym_GT_EQ] = ACTIONS(3262),
    [anon_sym_LT_EQ] = ACTIONS(3262),
    [anon_sym_switch] = ACTIONS(3262),
    [anon_sym_and] = ACTIONS(3262),
    [anon_sym_or] = ACTIONS(3264),
    [anon_sym_PLUS_EQ] = ACTIONS(3262),
    [anon_sym_DASH_EQ] = ACTIONS(3262),
    [anon_sym_STAR_EQ] = ACTIONS(3262),
    [anon_sym_SLASH_EQ] = ACTIONS(3262),
    [anon_sym_PERCENT_EQ] = ACTIONS(3262),
    [anon_sym_AMP_EQ] = ACTIONS(3262),
    [anon_sym_CARET_EQ] = ACTIONS(3262),
    [anon_sym_PIPE_EQ] = ACTIONS(3262),
    [anon_sym_LT_LT_EQ] = ACTIONS(3262),
    [anon_sym_GT_GT_EQ] = ACTIONS(3262),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3262),
    [anon_sym_is] = ACTIONS(3262),
    [anon_sym_DASH_GT] = ACTIONS(3262),
    [anon_sym_from] = ACTIONS(3262),
    [anon_sym_join] = ACTIONS(3262),
    [anon_sym_on] = ACTIONS(3262),
    [anon_sym_equals] = ACTIONS(3262),
    [anon_sym_let] = ACTIONS(3262),
    [anon_sym_orderby] = ACTIONS(3262),
    [anon_sym_group] = ACTIONS(3262),
    [anon_sym_by] = ACTIONS(3262),
    [anon_sym_select] = ACTIONS(3262),
    [anon_sym_DOT_DOT] = ACTIONS(3262),
    [anon_sym_with] = ACTIONS(3262),
    [anon_sym_AMP_AMP] = ACTIONS(3262),
    [anon_sym_PIPE_PIPE] = ACTIONS(3262),
    [anon_sym_QMARK_QMARK] = ACTIONS(3264),
    [anon_sym_as] = ACTIONS(3262),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2082] = {
    [sym__preprocessor_call] = STATE(2082),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_COMMA] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_DOT] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_RBRACK] = ACTIONS(2901),
    [anon_sym_COLON] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2901),
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2899),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2901),
    [anon_sym_EQ_GT] = ACTIONS(2901),
    [anon_sym_where] = ACTIONS(2901),
    [anon_sym_QMARK] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_SLASH] = ACTIONS(2899),
    [anon_sym_PERCENT] = ACTIONS(2899),
    [anon_sym_CARET] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2899),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_and] = ACTIONS(2901),
    [anon_sym_or] = ACTIONS(2899),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_STAR_EQ] = ACTIONS(2901),
    [anon_sym_SLASH_EQ] = ACTIONS(2901),
    [anon_sym_PERCENT_EQ] = ACTIONS(2901),
    [anon_sym_AMP_EQ] = ACTIONS(2901),
    [anon_sym_CARET_EQ] = ACTIONS(2901),
    [anon_sym_PIPE_EQ] = ACTIONS(2901),
    [anon_sym_LT_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_GT_EQ] = ACTIONS(2901),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2901),
    [anon_sym_is] = ACTIONS(2901),
    [anon_sym_DASH_GT] = ACTIONS(2901),
    [anon_sym_from] = ACTIONS(2901),
    [anon_sym_join] = ACTIONS(2901),
    [anon_sym_on] = ACTIONS(2901),
    [anon_sym_equals] = ACTIONS(2901),
    [anon_sym_into] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_orderby] = ACTIONS(2901),
    [anon_sym_group] = ACTIONS(2901),
    [anon_sym_by] = ACTIONS(2901),
    [anon_sym_select] = ACTIONS(2901),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_with] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_QMARK_QMARK] = ACTIONS(2899),
    [anon_sym_as] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2083] = {
    [sym__preprocessor_call] = STATE(2083),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_EQ] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_COMMA] = ACTIONS(2858),
    [anon_sym_GT] = ACTIONS(2850),
    [anon_sym_DOT] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2858),
    [anon_sym_RBRACK] = ACTIONS(2858),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2858),
    [anon_sym_in] = ACTIONS(2850),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_EQ_GT] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2858),
    [anon_sym_QMARK] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2850),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2850),
    [anon_sym_SLASH] = ACTIONS(2850),
    [anon_sym_PERCENT] = ACTIONS(2850),
    [anon_sym_CARET] = ACTIONS(2850),
    [anon_sym_PIPE] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_LT_LT] = ACTIONS(2850),
    [anon_sym_GT_GT] = ACTIONS(2850),
    [anon_sym_EQ_EQ] = ACTIONS(2858),
    [anon_sym_BANG_EQ] = ACTIONS(2858),
    [anon_sym_GT_EQ] = ACTIONS(2858),
    [anon_sym_LT_EQ] = ACTIONS(2858),
    [anon_sym_switch] = ACTIONS(2858),
    [anon_sym_and] = ACTIONS(2858),
    [anon_sym_or] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2858),
    [anon_sym_DASH_EQ] = ACTIONS(2858),
    [anon_sym_STAR_EQ] = ACTIONS(2858),
    [anon_sym_SLASH_EQ] = ACTIONS(2858),
    [anon_sym_PERCENT_EQ] = ACTIONS(2858),
    [anon_sym_AMP_EQ] = ACTIONS(2858),
    [anon_sym_CARET_EQ] = ACTIONS(2858),
    [anon_sym_PIPE_EQ] = ACTIONS(2858),
    [anon_sym_LT_LT_EQ] = ACTIONS(2858),
    [anon_sym_GT_GT_EQ] = ACTIONS(2858),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2858),
    [anon_sym_is] = ACTIONS(2858),
    [anon_sym_DASH_GT] = ACTIONS(2858),
    [anon_sym_from] = ACTIONS(2858),
    [anon_sym_join] = ACTIONS(2858),
    [anon_sym_on] = ACTIONS(2858),
    [anon_sym_equals] = ACTIONS(2858),
    [anon_sym_into] = ACTIONS(2858),
    [anon_sym_let] = ACTIONS(2858),
    [anon_sym_orderby] = ACTIONS(2858),
    [anon_sym_group] = ACTIONS(2858),
    [anon_sym_by] = ACTIONS(2858),
    [anon_sym_select] = ACTIONS(2858),
    [anon_sym_DOT_DOT] = ACTIONS(2858),
    [anon_sym_with] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_PIPE_PIPE] = ACTIONS(2858),
    [anon_sym_QMARK_QMARK] = ACTIONS(2850),
    [anon_sym_as] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2084] = {
    [sym__preprocessor_call] = STATE(2084),
    [anon_sym_SEMI] = ACTIONS(2959),
    [anon_sym_EQ] = ACTIONS(2957),
    [anon_sym_LT] = ACTIONS(2957),
    [anon_sym_COMMA] = ACTIONS(2959),
    [anon_sym_GT] = ACTIONS(2957),
    [anon_sym_DOT] = ACTIONS(2957),
    [anon_sym_LBRACK] = ACTIONS(2959),
    [anon_sym_RBRACK] = ACTIONS(2959),
    [anon_sym_COLON] = ACTIONS(2959),
    [anon_sym_LPAREN] = ACTIONS(2959),
    [anon_sym_RPAREN] = ACTIONS(2959),
    [anon_sym_in] = ACTIONS(2957),
    [anon_sym_LBRACE] = ACTIONS(2959),
    [anon_sym_RBRACE] = ACTIONS(2959),
    [anon_sym_EQ_GT] = ACTIONS(2959),
    [anon_sym_where] = ACTIONS(2959),
    [anon_sym_QMARK] = ACTIONS(2957),
    [anon_sym_BANG] = ACTIONS(2957),
    [anon_sym_PLUS_PLUS] = ACTIONS(2959),
    [anon_sym_DASH_DASH] = ACTIONS(2959),
    [anon_sym_PLUS] = ACTIONS(2957),
    [anon_sym_DASH] = ACTIONS(2957),
    [anon_sym_STAR] = ACTIONS(2957),
    [anon_sym_SLASH] = ACTIONS(2957),
    [anon_sym_PERCENT] = ACTIONS(2957),
    [anon_sym_CARET] = ACTIONS(2957),
    [anon_sym_PIPE] = ACTIONS(2957),
    [anon_sym_AMP] = ACTIONS(2957),
    [anon_sym_LT_LT] = ACTIONS(2957),
    [anon_sym_GT_GT] = ACTIONS(2957),
    [anon_sym_EQ_EQ] = ACTIONS(2959),
    [anon_sym_BANG_EQ] = ACTIONS(2959),
    [anon_sym_GT_EQ] = ACTIONS(2959),
    [anon_sym_LT_EQ] = ACTIONS(2959),
    [anon_sym_switch] = ACTIONS(2959),
    [anon_sym_and] = ACTIONS(2959),
    [anon_sym_or] = ACTIONS(2957),
    [anon_sym_PLUS_EQ] = ACTIONS(2959),
    [anon_sym_DASH_EQ] = ACTIONS(2959),
    [anon_sym_STAR_EQ] = ACTIONS(2959),
    [anon_sym_SLASH_EQ] = ACTIONS(2959),
    [anon_sym_PERCENT_EQ] = ACTIONS(2959),
    [anon_sym_AMP_EQ] = ACTIONS(2959),
    [anon_sym_CARET_EQ] = ACTIONS(2959),
    [anon_sym_PIPE_EQ] = ACTIONS(2959),
    [anon_sym_LT_LT_EQ] = ACTIONS(2959),
    [anon_sym_GT_GT_EQ] = ACTIONS(2959),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2959),
    [anon_sym_is] = ACTIONS(2959),
    [anon_sym_DASH_GT] = ACTIONS(2959),
    [anon_sym_from] = ACTIONS(2959),
    [anon_sym_join] = ACTIONS(2959),
    [anon_sym_on] = ACTIONS(2959),
    [anon_sym_equals] = ACTIONS(2959),
    [anon_sym_into] = ACTIONS(2959),
    [anon_sym_let] = ACTIONS(2959),
    [anon_sym_orderby] = ACTIONS(2959),
    [anon_sym_group] = ACTIONS(2959),
    [anon_sym_by] = ACTIONS(2959),
    [anon_sym_select] = ACTIONS(2959),
    [anon_sym_DOT_DOT] = ACTIONS(2959),
    [anon_sym_with] = ACTIONS(2959),
    [anon_sym_AMP_AMP] = ACTIONS(2959),
    [anon_sym_PIPE_PIPE] = ACTIONS(2959),
    [anon_sym_QMARK_QMARK] = ACTIONS(2957),
    [anon_sym_as] = ACTIONS(2959),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2085] = {
    [sym__preprocessor_call] = STATE(2085),
    [anon_sym_SEMI] = ACTIONS(2886),
    [anon_sym_EQ] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(2884),
    [anon_sym_COMMA] = ACTIONS(2886),
    [anon_sym_GT] = ACTIONS(2884),
    [anon_sym_DOT] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2886),
    [anon_sym_RBRACK] = ACTIONS(2886),
    [anon_sym_COLON] = ACTIONS(2886),
    [anon_sym_LPAREN] = ACTIONS(2886),
    [anon_sym_RPAREN] = ACTIONS(2886),
    [anon_sym_in] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(2886),
    [anon_sym_RBRACE] = ACTIONS(2886),
    [anon_sym_EQ_GT] = ACTIONS(2886),
    [anon_sym_where] = ACTIONS(2886),
    [anon_sym_QMARK] = ACTIONS(2884),
    [anon_sym_BANG] = ACTIONS(2884),
    [anon_sym_PLUS_PLUS] = ACTIONS(2886),
    [anon_sym_DASH_DASH] = ACTIONS(2886),
    [anon_sym_PLUS] = ACTIONS(2884),
    [anon_sym_DASH] = ACTIONS(2884),
    [anon_sym_STAR] = ACTIONS(2884),
    [anon_sym_SLASH] = ACTIONS(2884),
    [anon_sym_PERCENT] = ACTIONS(2884),
    [anon_sym_CARET] = ACTIONS(2884),
    [anon_sym_PIPE] = ACTIONS(2884),
    [anon_sym_AMP] = ACTIONS(2884),
    [anon_sym_LT_LT] = ACTIONS(2884),
    [anon_sym_GT_GT] = ACTIONS(2884),
    [anon_sym_EQ_EQ] = ACTIONS(2886),
    [anon_sym_BANG_EQ] = ACTIONS(2886),
    [anon_sym_GT_EQ] = ACTIONS(2886),
    [anon_sym_LT_EQ] = ACTIONS(2886),
    [anon_sym_switch] = ACTIONS(2886),
    [anon_sym_and] = ACTIONS(2886),
    [anon_sym_or] = ACTIONS(2884),
    [anon_sym_PLUS_EQ] = ACTIONS(2886),
    [anon_sym_DASH_EQ] = ACTIONS(2886),
    [anon_sym_STAR_EQ] = ACTIONS(2886),
    [anon_sym_SLASH_EQ] = ACTIONS(2886),
    [anon_sym_PERCENT_EQ] = ACTIONS(2886),
    [anon_sym_AMP_EQ] = ACTIONS(2886),
    [anon_sym_CARET_EQ] = ACTIONS(2886),
    [anon_sym_PIPE_EQ] = ACTIONS(2886),
    [anon_sym_LT_LT_EQ] = ACTIONS(2886),
    [anon_sym_GT_GT_EQ] = ACTIONS(2886),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2886),
    [anon_sym_is] = ACTIONS(2886),
    [anon_sym_DASH_GT] = ACTIONS(2886),
    [anon_sym_from] = ACTIONS(2886),
    [anon_sym_join] = ACTIONS(2886),
    [anon_sym_on] = ACTIONS(2886),
    [anon_sym_equals] = ACTIONS(2886),
    [anon_sym_into] = ACTIONS(2886),
    [anon_sym_let] = ACTIONS(2886),
    [anon_sym_orderby] = ACTIONS(2886),
    [anon_sym_group] = ACTIONS(2886),
    [anon_sym_by] = ACTIONS(2886),
    [anon_sym_select] = ACTIONS(2886),
    [anon_sym_DOT_DOT] = ACTIONS(2886),
    [anon_sym_with] = ACTIONS(2886),
    [anon_sym_AMP_AMP] = ACTIONS(2886),
    [anon_sym_PIPE_PIPE] = ACTIONS(2886),
    [anon_sym_QMARK_QMARK] = ACTIONS(2884),
    [anon_sym_as] = ACTIONS(2886),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2086] = {
    [sym__preprocessor_call] = STATE(2086),
    [anon_sym_SEMI] = ACTIONS(2868),
    [anon_sym_EQ] = ACTIONS(2866),
    [anon_sym_LT] = ACTIONS(2866),
    [anon_sym_COMMA] = ACTIONS(2868),
    [anon_sym_GT] = ACTIONS(2866),
    [anon_sym_DOT] = ACTIONS(2866),
    [anon_sym_LBRACK] = ACTIONS(2868),
    [anon_sym_RBRACK] = ACTIONS(2868),
    [anon_sym_COLON] = ACTIONS(2868),
    [anon_sym_LPAREN] = ACTIONS(2868),
    [anon_sym_RPAREN] = ACTIONS(2868),
    [anon_sym_in] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(2868),
    [anon_sym_RBRACE] = ACTIONS(2868),
    [anon_sym_EQ_GT] = ACTIONS(2868),
    [anon_sym_where] = ACTIONS(2868),
    [anon_sym_QMARK] = ACTIONS(2866),
    [anon_sym_BANG] = ACTIONS(2866),
    [anon_sym_PLUS_PLUS] = ACTIONS(2868),
    [anon_sym_DASH_DASH] = ACTIONS(2868),
    [anon_sym_PLUS] = ACTIONS(2866),
    [anon_sym_DASH] = ACTIONS(2866),
    [anon_sym_STAR] = ACTIONS(2866),
    [anon_sym_SLASH] = ACTIONS(2866),
    [anon_sym_PERCENT] = ACTIONS(2866),
    [anon_sym_CARET] = ACTIONS(2866),
    [anon_sym_PIPE] = ACTIONS(2866),
    [anon_sym_AMP] = ACTIONS(2866),
    [anon_sym_LT_LT] = ACTIONS(2866),
    [anon_sym_GT_GT] = ACTIONS(2866),
    [anon_sym_EQ_EQ] = ACTIONS(2868),
    [anon_sym_BANG_EQ] = ACTIONS(2868),
    [anon_sym_GT_EQ] = ACTIONS(2868),
    [anon_sym_LT_EQ] = ACTIONS(2868),
    [anon_sym_switch] = ACTIONS(2868),
    [anon_sym_and] = ACTIONS(2868),
    [anon_sym_or] = ACTIONS(2866),
    [anon_sym_PLUS_EQ] = ACTIONS(2868),
    [anon_sym_DASH_EQ] = ACTIONS(2868),
    [anon_sym_STAR_EQ] = ACTIONS(2868),
    [anon_sym_SLASH_EQ] = ACTIONS(2868),
    [anon_sym_PERCENT_EQ] = ACTIONS(2868),
    [anon_sym_AMP_EQ] = ACTIONS(2868),
    [anon_sym_CARET_EQ] = ACTIONS(2868),
    [anon_sym_PIPE_EQ] = ACTIONS(2868),
    [anon_sym_LT_LT_EQ] = ACTIONS(2868),
    [anon_sym_GT_GT_EQ] = ACTIONS(2868),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2868),
    [anon_sym_is] = ACTIONS(2868),
    [anon_sym_DASH_GT] = ACTIONS(2868),
    [anon_sym_from] = ACTIONS(2868),
    [anon_sym_join] = ACTIONS(2868),
    [anon_sym_on] = ACTIONS(2868),
    [anon_sym_equals] = ACTIONS(2868),
    [anon_sym_into] = ACTIONS(2868),
    [anon_sym_let] = ACTIONS(2868),
    [anon_sym_orderby] = ACTIONS(2868),
    [anon_sym_group] = ACTIONS(2868),
    [anon_sym_by] = ACTIONS(2868),
    [anon_sym_select] = ACTIONS(2868),
    [anon_sym_DOT_DOT] = ACTIONS(2868),
    [anon_sym_with] = ACTIONS(2868),
    [anon_sym_AMP_AMP] = ACTIONS(2868),
    [anon_sym_PIPE_PIPE] = ACTIONS(2868),
    [anon_sym_QMARK_QMARK] = ACTIONS(2866),
    [anon_sym_as] = ACTIONS(2868),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2087] = {
    [sym__preprocessor_call] = STATE(2087),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2894),
    [anon_sym_QMARK] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_switch] = ACTIONS(2894),
    [anon_sym_and] = ACTIONS(2894),
    [anon_sym_or] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2894),
    [anon_sym_DASH_GT] = ACTIONS(2894),
    [anon_sym_from] = ACTIONS(2894),
    [anon_sym_join] = ACTIONS(2894),
    [anon_sym_on] = ACTIONS(2894),
    [anon_sym_equals] = ACTIONS(2894),
    [anon_sym_into] = ACTIONS(2894),
    [anon_sym_let] = ACTIONS(2894),
    [anon_sym_orderby] = ACTIONS(2894),
    [anon_sym_group] = ACTIONS(2894),
    [anon_sym_by] = ACTIONS(2894),
    [anon_sym_select] = ACTIONS(2894),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2894),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2088] = {
    [sym__preprocessor_call] = STATE(2088),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2894),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_switch] = ACTIONS(2894),
    [anon_sym_and] = ACTIONS(2894),
    [anon_sym_or] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2894),
    [anon_sym_DASH_GT] = ACTIONS(2894),
    [anon_sym_from] = ACTIONS(2894),
    [anon_sym_join] = ACTIONS(2894),
    [anon_sym_on] = ACTIONS(2894),
    [anon_sym_equals] = ACTIONS(2894),
    [anon_sym_into] = ACTIONS(2894),
    [anon_sym_let] = ACTIONS(2894),
    [anon_sym_orderby] = ACTIONS(2894),
    [anon_sym_group] = ACTIONS(2894),
    [anon_sym_by] = ACTIONS(2894),
    [anon_sym_select] = ACTIONS(2894),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2894),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2089] = {
    [sym__preprocessor_call] = STATE(2089),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_EQ] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_COMMA] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2876),
    [anon_sym_LBRACK] = ACTIONS(2878),
    [anon_sym_RBRACK] = ACTIONS(2878),
    [anon_sym_COLON] = ACTIONS(2878),
    [anon_sym_LPAREN] = ACTIONS(2878),
    [anon_sym_RPAREN] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(2876),
    [anon_sym_LBRACE] = ACTIONS(2878),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_EQ_GT] = ACTIONS(2878),
    [anon_sym_where] = ACTIONS(2878),
    [anon_sym_QMARK] = ACTIONS(2876),
    [anon_sym_BANG] = ACTIONS(2876),
    [anon_sym_PLUS_PLUS] = ACTIONS(2878),
    [anon_sym_DASH_DASH] = ACTIONS(2878),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2876),
    [anon_sym_PERCENT] = ACTIONS(2876),
    [anon_sym_CARET] = ACTIONS(2876),
    [anon_sym_PIPE] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2876),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_GT_GT] = ACTIONS(2876),
    [anon_sym_EQ_EQ] = ACTIONS(2878),
    [anon_sym_BANG_EQ] = ACTIONS(2878),
    [anon_sym_GT_EQ] = ACTIONS(2878),
    [anon_sym_LT_EQ] = ACTIONS(2878),
    [anon_sym_switch] = ACTIONS(2878),
    [anon_sym_and] = ACTIONS(2878),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_PLUS_EQ] = ACTIONS(2878),
    [anon_sym_DASH_EQ] = ACTIONS(2878),
    [anon_sym_STAR_EQ] = ACTIONS(2878),
    [anon_sym_SLASH_EQ] = ACTIONS(2878),
    [anon_sym_PERCENT_EQ] = ACTIONS(2878),
    [anon_sym_AMP_EQ] = ACTIONS(2878),
    [anon_sym_CARET_EQ] = ACTIONS(2878),
    [anon_sym_PIPE_EQ] = ACTIONS(2878),
    [anon_sym_LT_LT_EQ] = ACTIONS(2878),
    [anon_sym_GT_GT_EQ] = ACTIONS(2878),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2878),
    [anon_sym_is] = ACTIONS(2878),
    [anon_sym_DASH_GT] = ACTIONS(2878),
    [anon_sym_from] = ACTIONS(2878),
    [anon_sym_join] = ACTIONS(2878),
    [anon_sym_on] = ACTIONS(2878),
    [anon_sym_equals] = ACTIONS(2878),
    [anon_sym_into] = ACTIONS(2878),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_orderby] = ACTIONS(2878),
    [anon_sym_group] = ACTIONS(2878),
    [anon_sym_by] = ACTIONS(2878),
    [anon_sym_select] = ACTIONS(2878),
    [anon_sym_DOT_DOT] = ACTIONS(2878),
    [anon_sym_with] = ACTIONS(2878),
    [anon_sym_AMP_AMP] = ACTIONS(2878),
    [anon_sym_PIPE_PIPE] = ACTIONS(2878),
    [anon_sym_QMARK_QMARK] = ACTIONS(2876),
    [anon_sym_as] = ACTIONS(2878),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2090] = {
    [sym__preprocessor_call] = STATE(2090),
    [anon_sym_SEMI] = ACTIONS(2955),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_COMMA] = ACTIONS(2955),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_DOT] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_RBRACK] = ACTIONS(2955),
    [anon_sym_COLON] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_RPAREN] = ACTIONS(2955),
    [anon_sym_in] = ACTIONS(2953),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [anon_sym_EQ_GT] = ACTIONS(2955),
    [anon_sym_where] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_SLASH] = ACTIONS(2953),
    [anon_sym_PERCENT] = ACTIONS(2953),
    [anon_sym_CARET] = ACTIONS(2953),
    [anon_sym_PIPE] = ACTIONS(2953),
    [anon_sym_AMP] = ACTIONS(2953),
    [anon_sym_LT_LT] = ACTIONS(2953),
    [anon_sym_GT_GT] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2955),
    [anon_sym_BANG_EQ] = ACTIONS(2955),
    [anon_sym_GT_EQ] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2955),
    [anon_sym_switch] = ACTIONS(2955),
    [anon_sym_and] = ACTIONS(2955),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS_EQ] = ACTIONS(2955),
    [anon_sym_DASH_EQ] = ACTIONS(2955),
    [anon_sym_STAR_EQ] = ACTIONS(2955),
    [anon_sym_SLASH_EQ] = ACTIONS(2955),
    [anon_sym_PERCENT_EQ] = ACTIONS(2955),
    [anon_sym_AMP_EQ] = ACTIONS(2955),
    [anon_sym_CARET_EQ] = ACTIONS(2955),
    [anon_sym_PIPE_EQ] = ACTIONS(2955),
    [anon_sym_LT_LT_EQ] = ACTIONS(2955),
    [anon_sym_GT_GT_EQ] = ACTIONS(2955),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2955),
    [anon_sym_is] = ACTIONS(2955),
    [anon_sym_DASH_GT] = ACTIONS(2955),
    [anon_sym_from] = ACTIONS(2955),
    [anon_sym_join] = ACTIONS(2955),
    [anon_sym_on] = ACTIONS(2955),
    [anon_sym_equals] = ACTIONS(2955),
    [anon_sym_into] = ACTIONS(2955),
    [anon_sym_let] = ACTIONS(2955),
    [anon_sym_orderby] = ACTIONS(2955),
    [anon_sym_group] = ACTIONS(2955),
    [anon_sym_by] = ACTIONS(2955),
    [anon_sym_select] = ACTIONS(2955),
    [anon_sym_DOT_DOT] = ACTIONS(2955),
    [anon_sym_with] = ACTIONS(2955),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_PIPE_PIPE] = ACTIONS(2955),
    [anon_sym_QMARK_QMARK] = ACTIONS(2953),
    [anon_sym_as] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2091] = {
    [sym__preprocessor_call] = STATE(2091),
    [anon_sym_SEMI] = ACTIONS(2835),
    [anon_sym_EQ] = ACTIONS(2833),
    [anon_sym_COLON_COLON] = ACTIONS(2835),
    [anon_sym_LT] = ACTIONS(2833),
    [anon_sym_COMMA] = ACTIONS(2835),
    [anon_sym_GT] = ACTIONS(2833),
    [anon_sym_DOT] = ACTIONS(2833),
    [anon_sym_LBRACK] = ACTIONS(2835),
    [anon_sym_RBRACK] = ACTIONS(2835),
    [anon_sym_COLON] = ACTIONS(2833),
    [anon_sym_LPAREN] = ACTIONS(2835),
    [anon_sym_RPAREN] = ACTIONS(2835),
    [anon_sym_in] = ACTIONS(2835),
    [anon_sym_LBRACE] = ACTIONS(2835),
    [anon_sym_RBRACE] = ACTIONS(2835),
    [anon_sym_EQ_GT] = ACTIONS(2835),
    [anon_sym_where] = ACTIONS(2835),
    [anon_sym_QMARK] = ACTIONS(2833),
    [anon_sym_BANG] = ACTIONS(2833),
    [anon_sym_PLUS_PLUS] = ACTIONS(2835),
    [anon_sym_DASH_DASH] = ACTIONS(2835),
    [anon_sym_PLUS] = ACTIONS(2833),
    [anon_sym_DASH] = ACTIONS(2833),
    [anon_sym_STAR] = ACTIONS(2833),
    [anon_sym_SLASH] = ACTIONS(2833),
    [anon_sym_PERCENT] = ACTIONS(2833),
    [anon_sym_CARET] = ACTIONS(2833),
    [anon_sym_PIPE] = ACTIONS(2833),
    [anon_sym_AMP] = ACTIONS(2833),
    [anon_sym_LT_LT] = ACTIONS(2833),
    [anon_sym_GT_GT] = ACTIONS(2833),
    [anon_sym_EQ_EQ] = ACTIONS(2835),
    [anon_sym_BANG_EQ] = ACTIONS(2835),
    [anon_sym_GT_EQ] = ACTIONS(2835),
    [anon_sym_LT_EQ] = ACTIONS(2835),
    [anon_sym_switch] = ACTIONS(2835),
    [anon_sym_and] = ACTIONS(2835),
    [anon_sym_or] = ACTIONS(2833),
    [anon_sym_PLUS_EQ] = ACTIONS(2835),
    [anon_sym_DASH_EQ] = ACTIONS(2835),
    [anon_sym_STAR_EQ] = ACTIONS(2835),
    [anon_sym_SLASH_EQ] = ACTIONS(2835),
    [anon_sym_PERCENT_EQ] = ACTIONS(2835),
    [anon_sym_AMP_EQ] = ACTIONS(2835),
    [anon_sym_CARET_EQ] = ACTIONS(2835),
    [anon_sym_PIPE_EQ] = ACTIONS(2835),
    [anon_sym_LT_LT_EQ] = ACTIONS(2835),
    [anon_sym_GT_GT_EQ] = ACTIONS(2835),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2835),
    [anon_sym_is] = ACTIONS(2835),
    [anon_sym_DASH_GT] = ACTIONS(2835),
    [anon_sym_from] = ACTIONS(2835),
    [anon_sym_join] = ACTIONS(2835),
    [anon_sym_on] = ACTIONS(2835),
    [anon_sym_equals] = ACTIONS(2835),
    [anon_sym_let] = ACTIONS(2835),
    [anon_sym_orderby] = ACTIONS(2835),
    [anon_sym_group] = ACTIONS(2835),
    [anon_sym_by] = ACTIONS(2835),
    [anon_sym_select] = ACTIONS(2835),
    [anon_sym_DOT_DOT] = ACTIONS(2835),
    [anon_sym_with] = ACTIONS(2835),
    [anon_sym_AMP_AMP] = ACTIONS(2835),
    [anon_sym_PIPE_PIPE] = ACTIONS(2835),
    [anon_sym_QMARK_QMARK] = ACTIONS(2833),
    [anon_sym_as] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2092] = {
    [sym__preprocessor_call] = STATE(2092),
    [anon_sym_SEMI] = ACTIONS(2913),
    [anon_sym_EQ] = ACTIONS(2911),
    [anon_sym_LT] = ACTIONS(2911),
    [anon_sym_COMMA] = ACTIONS(2913),
    [anon_sym_GT] = ACTIONS(2911),
    [anon_sym_DOT] = ACTIONS(2911),
    [anon_sym_LBRACK] = ACTIONS(2913),
    [anon_sym_RBRACK] = ACTIONS(2913),
    [anon_sym_COLON] = ACTIONS(2913),
    [anon_sym_LPAREN] = ACTIONS(2913),
    [anon_sym_RPAREN] = ACTIONS(2913),
    [anon_sym_in] = ACTIONS(2911),
    [anon_sym_LBRACE] = ACTIONS(2913),
    [anon_sym_RBRACE] = ACTIONS(2913),
    [anon_sym_EQ_GT] = ACTIONS(2913),
    [anon_sym_where] = ACTIONS(2913),
    [anon_sym_QMARK] = ACTIONS(2911),
    [anon_sym_BANG] = ACTIONS(2911),
    [anon_sym_PLUS_PLUS] = ACTIONS(2913),
    [anon_sym_DASH_DASH] = ACTIONS(2913),
    [anon_sym_PLUS] = ACTIONS(2911),
    [anon_sym_DASH] = ACTIONS(2911),
    [anon_sym_STAR] = ACTIONS(2911),
    [anon_sym_SLASH] = ACTIONS(2911),
    [anon_sym_PERCENT] = ACTIONS(2911),
    [anon_sym_CARET] = ACTIONS(2911),
    [anon_sym_PIPE] = ACTIONS(2911),
    [anon_sym_AMP] = ACTIONS(2911),
    [anon_sym_LT_LT] = ACTIONS(2911),
    [anon_sym_GT_GT] = ACTIONS(2911),
    [anon_sym_EQ_EQ] = ACTIONS(2913),
    [anon_sym_BANG_EQ] = ACTIONS(2913),
    [anon_sym_GT_EQ] = ACTIONS(2913),
    [anon_sym_LT_EQ] = ACTIONS(2913),
    [anon_sym_switch] = ACTIONS(2913),
    [anon_sym_and] = ACTIONS(2913),
    [anon_sym_or] = ACTIONS(2911),
    [anon_sym_PLUS_EQ] = ACTIONS(2913),
    [anon_sym_DASH_EQ] = ACTIONS(2913),
    [anon_sym_STAR_EQ] = ACTIONS(2913),
    [anon_sym_SLASH_EQ] = ACTIONS(2913),
    [anon_sym_PERCENT_EQ] = ACTIONS(2913),
    [anon_sym_AMP_EQ] = ACTIONS(2913),
    [anon_sym_CARET_EQ] = ACTIONS(2913),
    [anon_sym_PIPE_EQ] = ACTIONS(2913),
    [anon_sym_LT_LT_EQ] = ACTIONS(2913),
    [anon_sym_GT_GT_EQ] = ACTIONS(2913),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2913),
    [anon_sym_is] = ACTIONS(2913),
    [anon_sym_DASH_GT] = ACTIONS(2913),
    [anon_sym_from] = ACTIONS(2913),
    [anon_sym_join] = ACTIONS(2913),
    [anon_sym_on] = ACTIONS(2913),
    [anon_sym_equals] = ACTIONS(2913),
    [anon_sym_into] = ACTIONS(2913),
    [anon_sym_let] = ACTIONS(2913),
    [anon_sym_orderby] = ACTIONS(2913),
    [anon_sym_group] = ACTIONS(2913),
    [anon_sym_by] = ACTIONS(2913),
    [anon_sym_select] = ACTIONS(2913),
    [anon_sym_DOT_DOT] = ACTIONS(2913),
    [anon_sym_with] = ACTIONS(2913),
    [anon_sym_AMP_AMP] = ACTIONS(2913),
    [anon_sym_PIPE_PIPE] = ACTIONS(2913),
    [anon_sym_QMARK_QMARK] = ACTIONS(2911),
    [anon_sym_as] = ACTIONS(2913),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2093] = {
    [sym__preprocessor_call] = STATE(2093),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(3314),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_switch] = ACTIONS(2829),
    [anon_sym_and] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2829),
    [anon_sym_join] = ACTIONS(2829),
    [anon_sym_on] = ACTIONS(2829),
    [anon_sym_equals] = ACTIONS(2829),
    [anon_sym_into] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_orderby] = ACTIONS(2829),
    [anon_sym_group] = ACTIONS(2829),
    [anon_sym_by] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2094] = {
    [sym__preprocessor_call] = STATE(2094),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_RBRACK] = ACTIONS(2963),
    [anon_sym_COLON] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_in] = ACTIONS(2961),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_EQ_GT] = ACTIONS(2963),
    [anon_sym_where] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2963),
    [anon_sym_DASH_DASH] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_STAR] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2963),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2963),
    [anon_sym_switch] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2961),
    [anon_sym_PLUS_EQ] = ACTIONS(2963),
    [anon_sym_DASH_EQ] = ACTIONS(2963),
    [anon_sym_STAR_EQ] = ACTIONS(2963),
    [anon_sym_SLASH_EQ] = ACTIONS(2963),
    [anon_sym_PERCENT_EQ] = ACTIONS(2963),
    [anon_sym_AMP_EQ] = ACTIONS(2963),
    [anon_sym_CARET_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_LT_LT_EQ] = ACTIONS(2963),
    [anon_sym_GT_GT_EQ] = ACTIONS(2963),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2963),
    [anon_sym_is] = ACTIONS(2963),
    [anon_sym_DASH_GT] = ACTIONS(2963),
    [anon_sym_from] = ACTIONS(2963),
    [anon_sym_join] = ACTIONS(2963),
    [anon_sym_on] = ACTIONS(2963),
    [anon_sym_equals] = ACTIONS(2963),
    [anon_sym_into] = ACTIONS(2963),
    [anon_sym_let] = ACTIONS(2963),
    [anon_sym_orderby] = ACTIONS(2963),
    [anon_sym_group] = ACTIONS(2963),
    [anon_sym_by] = ACTIONS(2963),
    [anon_sym_select] = ACTIONS(2963),
    [anon_sym_DOT_DOT] = ACTIONS(2963),
    [anon_sym_with] = ACTIONS(2963),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2963),
    [anon_sym_QMARK_QMARK] = ACTIONS(2961),
    [anon_sym_as] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2095] = {
    [sym__preprocessor_call] = STATE(2095),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym_EQ] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3316),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_RBRACK] = ACTIONS(3316),
    [anon_sym_COLON] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3316),
    [anon_sym_RPAREN] = ACTIONS(3316),
    [anon_sym_in] = ACTIONS(3318),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_where] = ACTIONS(3316),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_CARET] = ACTIONS(3318),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3316),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_switch] = ACTIONS(3316),
    [anon_sym_and] = ACTIONS(3316),
    [anon_sym_or] = ACTIONS(3318),
    [anon_sym_PLUS_EQ] = ACTIONS(3316),
    [anon_sym_DASH_EQ] = ACTIONS(3316),
    [anon_sym_STAR_EQ] = ACTIONS(3316),
    [anon_sym_SLASH_EQ] = ACTIONS(3316),
    [anon_sym_PERCENT_EQ] = ACTIONS(3316),
    [anon_sym_AMP_EQ] = ACTIONS(3316),
    [anon_sym_CARET_EQ] = ACTIONS(3316),
    [anon_sym_PIPE_EQ] = ACTIONS(3316),
    [anon_sym_LT_LT_EQ] = ACTIONS(3316),
    [anon_sym_GT_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3316),
    [anon_sym_is] = ACTIONS(3316),
    [anon_sym_DASH_GT] = ACTIONS(3316),
    [anon_sym_from] = ACTIONS(3316),
    [anon_sym_join] = ACTIONS(3316),
    [anon_sym_on] = ACTIONS(3316),
    [anon_sym_equals] = ACTIONS(3316),
    [anon_sym_into] = ACTIONS(3316),
    [anon_sym_let] = ACTIONS(3316),
    [anon_sym_orderby] = ACTIONS(3316),
    [anon_sym_group] = ACTIONS(3316),
    [anon_sym_by] = ACTIONS(3316),
    [anon_sym_select] = ACTIONS(3316),
    [anon_sym_DOT_DOT] = ACTIONS(3316),
    [anon_sym_with] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3318),
    [anon_sym_as] = ACTIONS(3316),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2096] = {
    [sym__preprocessor_call] = STATE(2096),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_switch] = ACTIONS(2829),
    [anon_sym_and] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2829),
    [anon_sym_join] = ACTIONS(2829),
    [anon_sym_on] = ACTIONS(2829),
    [anon_sym_equals] = ACTIONS(2829),
    [anon_sym_into] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_orderby] = ACTIONS(2829),
    [anon_sym_group] = ACTIONS(2829),
    [anon_sym_by] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2097] = {
    [sym__preprocessor_call] = STATE(2097),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2917),
    [anon_sym_RBRACK] = ACTIONS(2917),
    [anon_sym_COLON] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_in] = ACTIONS(2915),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_EQ_GT] = ACTIONS(2917),
    [anon_sym_where] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_BANG] = ACTIONS(2915),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_switch] = ACTIONS(2917),
    [anon_sym_and] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2917),
    [anon_sym_is] = ACTIONS(2917),
    [anon_sym_DASH_GT] = ACTIONS(2917),
    [anon_sym_from] = ACTIONS(2917),
    [anon_sym_join] = ACTIONS(2917),
    [anon_sym_on] = ACTIONS(2917),
    [anon_sym_equals] = ACTIONS(2917),
    [anon_sym_into] = ACTIONS(2917),
    [anon_sym_let] = ACTIONS(2917),
    [anon_sym_orderby] = ACTIONS(2917),
    [anon_sym_group] = ACTIONS(2917),
    [anon_sym_by] = ACTIONS(2917),
    [anon_sym_select] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_with] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_QMARK_QMARK] = ACTIONS(2915),
    [anon_sym_as] = ACTIONS(2917),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2098] = {
    [sym__preprocessor_call] = STATE(2098),
    [anon_sym_SEMI] = ACTIONS(2939),
    [anon_sym_EQ] = ACTIONS(2937),
    [anon_sym_LT] = ACTIONS(2937),
    [anon_sym_COMMA] = ACTIONS(2939),
    [anon_sym_GT] = ACTIONS(2937),
    [anon_sym_DOT] = ACTIONS(2937),
    [anon_sym_LBRACK] = ACTIONS(2939),
    [anon_sym_RBRACK] = ACTIONS(2939),
    [anon_sym_COLON] = ACTIONS(2939),
    [anon_sym_LPAREN] = ACTIONS(2939),
    [anon_sym_RPAREN] = ACTIONS(2939),
    [anon_sym_in] = ACTIONS(2939),
    [anon_sym_LBRACE] = ACTIONS(2939),
    [anon_sym_RBRACE] = ACTIONS(2939),
    [anon_sym_EQ_GT] = ACTIONS(2939),
    [anon_sym_where] = ACTIONS(2939),
    [anon_sym_QMARK] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2937),
    [anon_sym_PLUS_PLUS] = ACTIONS(2939),
    [anon_sym_DASH_DASH] = ACTIONS(2939),
    [anon_sym_PLUS] = ACTIONS(2937),
    [anon_sym_DASH] = ACTIONS(2937),
    [anon_sym_STAR] = ACTIONS(2937),
    [anon_sym_SLASH] = ACTIONS(2937),
    [anon_sym_PERCENT] = ACTIONS(2937),
    [anon_sym_CARET] = ACTIONS(2937),
    [anon_sym_PIPE] = ACTIONS(2937),
    [anon_sym_AMP] = ACTIONS(2937),
    [anon_sym_LT_LT] = ACTIONS(2937),
    [anon_sym_GT_GT] = ACTIONS(2937),
    [anon_sym_EQ_EQ] = ACTIONS(2939),
    [anon_sym_BANG_EQ] = ACTIONS(2939),
    [anon_sym_GT_EQ] = ACTIONS(2939),
    [anon_sym_LT_EQ] = ACTIONS(2939),
    [anon_sym_switch] = ACTIONS(2939),
    [anon_sym_and] = ACTIONS(2939),
    [anon_sym_or] = ACTIONS(2937),
    [anon_sym_PLUS_EQ] = ACTIONS(2939),
    [anon_sym_DASH_EQ] = ACTIONS(2939),
    [anon_sym_STAR_EQ] = ACTIONS(2939),
    [anon_sym_SLASH_EQ] = ACTIONS(2939),
    [anon_sym_PERCENT_EQ] = ACTIONS(2939),
    [anon_sym_AMP_EQ] = ACTIONS(2939),
    [anon_sym_CARET_EQ] = ACTIONS(2939),
    [anon_sym_PIPE_EQ] = ACTIONS(2939),
    [anon_sym_LT_LT_EQ] = ACTIONS(2939),
    [anon_sym_GT_GT_EQ] = ACTIONS(2939),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2939),
    [anon_sym_is] = ACTIONS(2939),
    [anon_sym_DASH_GT] = ACTIONS(2939),
    [anon_sym_from] = ACTIONS(2939),
    [anon_sym_join] = ACTIONS(2939),
    [anon_sym_on] = ACTIONS(2939),
    [anon_sym_equals] = ACTIONS(2939),
    [anon_sym_let] = ACTIONS(2939),
    [anon_sym_orderby] = ACTIONS(2939),
    [anon_sym_group] = ACTIONS(2939),
    [anon_sym_by] = ACTIONS(2939),
    [anon_sym_select] = ACTIONS(2939),
    [anon_sym_DOT_DOT] = ACTIONS(2939),
    [anon_sym_with] = ACTIONS(2939),
    [anon_sym_AMP_AMP] = ACTIONS(2939),
    [anon_sym_PIPE_PIPE] = ACTIONS(2939),
    [anon_sym_QMARK_QMARK] = ACTIONS(2937),
    [anon_sym_as] = ACTIONS(2939),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2099] = {
    [sym__preprocessor_call] = STATE(2099),
    [anon_sym_SEMI] = ACTIONS(2943),
    [anon_sym_EQ] = ACTIONS(2941),
    [anon_sym_LT] = ACTIONS(2941),
    [anon_sym_COMMA] = ACTIONS(2943),
    [anon_sym_GT] = ACTIONS(2941),
    [anon_sym_DOT] = ACTIONS(2941),
    [anon_sym_LBRACK] = ACTIONS(2943),
    [anon_sym_RBRACK] = ACTIONS(2943),
    [anon_sym_COLON] = ACTIONS(2943),
    [anon_sym_LPAREN] = ACTIONS(2943),
    [anon_sym_RPAREN] = ACTIONS(2943),
    [anon_sym_in] = ACTIONS(2943),
    [anon_sym_LBRACE] = ACTIONS(2943),
    [anon_sym_RBRACE] = ACTIONS(2943),
    [anon_sym_EQ_GT] = ACTIONS(2943),
    [anon_sym_where] = ACTIONS(2943),
    [anon_sym_QMARK] = ACTIONS(2941),
    [anon_sym_BANG] = ACTIONS(2941),
    [anon_sym_PLUS_PLUS] = ACTIONS(2943),
    [anon_sym_DASH_DASH] = ACTIONS(2943),
    [anon_sym_PLUS] = ACTIONS(2941),
    [anon_sym_DASH] = ACTIONS(2941),
    [anon_sym_STAR] = ACTIONS(2941),
    [anon_sym_SLASH] = ACTIONS(2941),
    [anon_sym_PERCENT] = ACTIONS(2941),
    [anon_sym_CARET] = ACTIONS(2941),
    [anon_sym_PIPE] = ACTIONS(2941),
    [anon_sym_AMP] = ACTIONS(2941),
    [anon_sym_LT_LT] = ACTIONS(2941),
    [anon_sym_GT_GT] = ACTIONS(2941),
    [anon_sym_EQ_EQ] = ACTIONS(2943),
    [anon_sym_BANG_EQ] = ACTIONS(2943),
    [anon_sym_GT_EQ] = ACTIONS(2943),
    [anon_sym_LT_EQ] = ACTIONS(2943),
    [anon_sym_switch] = ACTIONS(2943),
    [anon_sym_and] = ACTIONS(2943),
    [anon_sym_or] = ACTIONS(2941),
    [anon_sym_PLUS_EQ] = ACTIONS(2943),
    [anon_sym_DASH_EQ] = ACTIONS(2943),
    [anon_sym_STAR_EQ] = ACTIONS(2943),
    [anon_sym_SLASH_EQ] = ACTIONS(2943),
    [anon_sym_PERCENT_EQ] = ACTIONS(2943),
    [anon_sym_AMP_EQ] = ACTIONS(2943),
    [anon_sym_CARET_EQ] = ACTIONS(2943),
    [anon_sym_PIPE_EQ] = ACTIONS(2943),
    [anon_sym_LT_LT_EQ] = ACTIONS(2943),
    [anon_sym_GT_GT_EQ] = ACTIONS(2943),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2943),
    [anon_sym_is] = ACTIONS(2943),
    [anon_sym_DASH_GT] = ACTIONS(2943),
    [anon_sym_from] = ACTIONS(2943),
    [anon_sym_join] = ACTIONS(2943),
    [anon_sym_on] = ACTIONS(2943),
    [anon_sym_equals] = ACTIONS(2943),
    [anon_sym_let] = ACTIONS(2943),
    [anon_sym_orderby] = ACTIONS(2943),
    [anon_sym_group] = ACTIONS(2943),
    [anon_sym_by] = ACTIONS(2943),
    [anon_sym_select] = ACTIONS(2943),
    [anon_sym_DOT_DOT] = ACTIONS(2943),
    [anon_sym_with] = ACTIONS(2943),
    [anon_sym_AMP_AMP] = ACTIONS(2943),
    [anon_sym_PIPE_PIPE] = ACTIONS(2943),
    [anon_sym_QMARK_QMARK] = ACTIONS(2941),
    [anon_sym_as] = ACTIONS(2943),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2100] = {
    [sym__preprocessor_call] = STATE(2100),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2855),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_RBRACK] = ACTIONS(2993),
    [anon_sym_COLON] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_in] = ACTIONS(2995),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_EQ_GT] = ACTIONS(2993),
    [anon_sym_where] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_and] = ACTIONS(2993),
    [anon_sym_or] = ACTIONS(2995),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2993),
    [anon_sym_DASH_GT] = ACTIONS(2852),
    [anon_sym_from] = ACTIONS(2993),
    [anon_sym_join] = ACTIONS(2993),
    [anon_sym_on] = ACTIONS(2993),
    [anon_sym_equals] = ACTIONS(2993),
    [anon_sym_into] = ACTIONS(2993),
    [anon_sym_let] = ACTIONS(2993),
    [anon_sym_orderby] = ACTIONS(2993),
    [anon_sym_group] = ACTIONS(2993),
    [anon_sym_by] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2101] = {
    [sym__preprocessor_call] = STATE(2101),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym_EQ] = ACTIONS(3322),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3320),
    [anon_sym_RBRACK] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3320),
    [anon_sym_RPAREN] = ACTIONS(3320),
    [anon_sym_in] = ACTIONS(3320),
    [anon_sym_LBRACE] = ACTIONS(3320),
    [anon_sym_RBRACE] = ACTIONS(3320),
    [anon_sym_EQ_GT] = ACTIONS(3320),
    [anon_sym_where] = ACTIONS(3320),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_BANG] = ACTIONS(3322),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_SLASH] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3322),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LT_LT] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(3322),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3320),
    [anon_sym_LT_EQ] = ACTIONS(3320),
    [anon_sym_switch] = ACTIONS(3320),
    [anon_sym_and] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3322),
    [anon_sym_PLUS_EQ] = ACTIONS(3320),
    [anon_sym_DASH_EQ] = ACTIONS(3320),
    [anon_sym_STAR_EQ] = ACTIONS(3320),
    [anon_sym_SLASH_EQ] = ACTIONS(3320),
    [anon_sym_PERCENT_EQ] = ACTIONS(3320),
    [anon_sym_AMP_EQ] = ACTIONS(3320),
    [anon_sym_CARET_EQ] = ACTIONS(3320),
    [anon_sym_PIPE_EQ] = ACTIONS(3320),
    [anon_sym_LT_LT_EQ] = ACTIONS(3320),
    [anon_sym_GT_GT_EQ] = ACTIONS(3320),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3320),
    [anon_sym_is] = ACTIONS(3320),
    [anon_sym_DASH_GT] = ACTIONS(3320),
    [anon_sym_from] = ACTIONS(3320),
    [anon_sym_join] = ACTIONS(3320),
    [anon_sym_on] = ACTIONS(3320),
    [anon_sym_equals] = ACTIONS(3320),
    [anon_sym_let] = ACTIONS(3320),
    [anon_sym_orderby] = ACTIONS(3320),
    [anon_sym_group] = ACTIONS(3320),
    [anon_sym_by] = ACTIONS(3320),
    [anon_sym_select] = ACTIONS(3320),
    [anon_sym_DOT_DOT] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_PIPE_PIPE] = ACTIONS(3320),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_as] = ACTIONS(3320),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2102] = {
    [sym__preprocessor_call] = STATE(2102),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym_EQ] = ACTIONS(3326),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_GT] = ACTIONS(3326),
    [anon_sym_DOT] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_RBRACK] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym_RPAREN] = ACTIONS(3324),
    [anon_sym_in] = ACTIONS(3326),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_EQ_GT] = ACTIONS(3324),
    [anon_sym_where] = ACTIONS(3324),
    [anon_sym_QMARK] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3326),
    [anon_sym_PERCENT] = ACTIONS(3326),
    [anon_sym_CARET] = ACTIONS(3326),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3326),
    [anon_sym_LT_LT] = ACTIONS(3326),
    [anon_sym_GT_GT] = ACTIONS(3326),
    [anon_sym_EQ_EQ] = ACTIONS(3324),
    [anon_sym_BANG_EQ] = ACTIONS(3324),
    [anon_sym_GT_EQ] = ACTIONS(3324),
    [anon_sym_LT_EQ] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_and] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3326),
    [anon_sym_PLUS_EQ] = ACTIONS(3324),
    [anon_sym_DASH_EQ] = ACTIONS(3324),
    [anon_sym_STAR_EQ] = ACTIONS(3324),
    [anon_sym_SLASH_EQ] = ACTIONS(3324),
    [anon_sym_PERCENT_EQ] = ACTIONS(3324),
    [anon_sym_AMP_EQ] = ACTIONS(3324),
    [anon_sym_CARET_EQ] = ACTIONS(3324),
    [anon_sym_PIPE_EQ] = ACTIONS(3324),
    [anon_sym_LT_LT_EQ] = ACTIONS(3324),
    [anon_sym_GT_GT_EQ] = ACTIONS(3324),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3324),
    [anon_sym_is] = ACTIONS(3324),
    [anon_sym_DASH_GT] = ACTIONS(3324),
    [anon_sym_from] = ACTIONS(3324),
    [anon_sym_join] = ACTIONS(3324),
    [anon_sym_on] = ACTIONS(3324),
    [anon_sym_equals] = ACTIONS(3324),
    [anon_sym_into] = ACTIONS(3324),
    [anon_sym_let] = ACTIONS(3324),
    [anon_sym_orderby] = ACTIONS(3324),
    [anon_sym_group] = ACTIONS(3324),
    [anon_sym_by] = ACTIONS(3324),
    [anon_sym_select] = ACTIONS(3324),
    [anon_sym_DOT_DOT] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_PIPE_PIPE] = ACTIONS(3324),
    [anon_sym_QMARK_QMARK] = ACTIONS(3326),
    [anon_sym_as] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2103] = {
    [sym__preprocessor_call] = STATE(2103),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_EQ] = ACTIONS(3330),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_DOT] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_RBRACK] = ACTIONS(3328),
    [anon_sym_COLON] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3330),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_EQ_GT] = ACTIONS(3328),
    [anon_sym_where] = ACTIONS(3328),
    [anon_sym_QMARK] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3330),
    [anon_sym_PERCENT] = ACTIONS(3330),
    [anon_sym_CARET] = ACTIONS(3330),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3330),
    [anon_sym_LT_LT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(3330),
    [anon_sym_EQ_EQ] = ACTIONS(3328),
    [anon_sym_BANG_EQ] = ACTIONS(3328),
    [anon_sym_GT_EQ] = ACTIONS(3328),
    [anon_sym_LT_EQ] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_and] = ACTIONS(3328),
    [anon_sym_or] = ACTIONS(3330),
    [anon_sym_PLUS_EQ] = ACTIONS(3328),
    [anon_sym_DASH_EQ] = ACTIONS(3328),
    [anon_sym_STAR_EQ] = ACTIONS(3328),
    [anon_sym_SLASH_EQ] = ACTIONS(3328),
    [anon_sym_PERCENT_EQ] = ACTIONS(3328),
    [anon_sym_AMP_EQ] = ACTIONS(3328),
    [anon_sym_CARET_EQ] = ACTIONS(3328),
    [anon_sym_PIPE_EQ] = ACTIONS(3328),
    [anon_sym_LT_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_GT_EQ] = ACTIONS(3328),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3328),
    [anon_sym_is] = ACTIONS(3328),
    [anon_sym_DASH_GT] = ACTIONS(3328),
    [anon_sym_from] = ACTIONS(3328),
    [anon_sym_join] = ACTIONS(3328),
    [anon_sym_on] = ACTIONS(3328),
    [anon_sym_equals] = ACTIONS(3328),
    [anon_sym_into] = ACTIONS(3328),
    [anon_sym_let] = ACTIONS(3328),
    [anon_sym_orderby] = ACTIONS(3328),
    [anon_sym_group] = ACTIONS(3328),
    [anon_sym_by] = ACTIONS(3328),
    [anon_sym_select] = ACTIONS(3328),
    [anon_sym_DOT_DOT] = ACTIONS(3328),
    [anon_sym_with] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3328),
    [anon_sym_PIPE_PIPE] = ACTIONS(3328),
    [anon_sym_QMARK_QMARK] = ACTIONS(3330),
    [anon_sym_as] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2104] = {
    [sym__preprocessor_call] = STATE(2104),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_EQ] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3334),
    [anon_sym_COMMA] = ACTIONS(3332),
    [anon_sym_GT] = ACTIONS(3334),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_RBRACK] = ACTIONS(3332),
    [anon_sym_COLON] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_RPAREN] = ACTIONS(3332),
    [anon_sym_in] = ACTIONS(3334),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_EQ_GT] = ACTIONS(3332),
    [anon_sym_where] = ACTIONS(3332),
    [anon_sym_QMARK] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3334),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3334),
    [anon_sym_PERCENT] = ACTIONS(3334),
    [anon_sym_CARET] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_LT_LT] = ACTIONS(3334),
    [anon_sym_GT_GT] = ACTIONS(3334),
    [anon_sym_EQ_EQ] = ACTIONS(3332),
    [anon_sym_BANG_EQ] = ACTIONS(3332),
    [anon_sym_GT_EQ] = ACTIONS(3332),
    [anon_sym_LT_EQ] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_and] = ACTIONS(3332),
    [anon_sym_or] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3332),
    [anon_sym_DASH_EQ] = ACTIONS(3332),
    [anon_sym_STAR_EQ] = ACTIONS(3332),
    [anon_sym_SLASH_EQ] = ACTIONS(3332),
    [anon_sym_PERCENT_EQ] = ACTIONS(3332),
    [anon_sym_AMP_EQ] = ACTIONS(3332),
    [anon_sym_CARET_EQ] = ACTIONS(3332),
    [anon_sym_PIPE_EQ] = ACTIONS(3332),
    [anon_sym_LT_LT_EQ] = ACTIONS(3332),
    [anon_sym_GT_GT_EQ] = ACTIONS(3332),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3332),
    [anon_sym_is] = ACTIONS(3332),
    [anon_sym_DASH_GT] = ACTIONS(3332),
    [anon_sym_from] = ACTIONS(3332),
    [anon_sym_join] = ACTIONS(3332),
    [anon_sym_on] = ACTIONS(3332),
    [anon_sym_equals] = ACTIONS(3332),
    [anon_sym_into] = ACTIONS(3332),
    [anon_sym_let] = ACTIONS(3332),
    [anon_sym_orderby] = ACTIONS(3332),
    [anon_sym_group] = ACTIONS(3332),
    [anon_sym_by] = ACTIONS(3332),
    [anon_sym_select] = ACTIONS(3332),
    [anon_sym_DOT_DOT] = ACTIONS(3332),
    [anon_sym_with] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_PIPE_PIPE] = ACTIONS(3332),
    [anon_sym_QMARK_QMARK] = ACTIONS(3334),
    [anon_sym_as] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2105] = {
    [sym__preprocessor_call] = STATE(2105),
    [anon_sym_SEMI] = ACTIONS(2886),
    [anon_sym_EQ] = ACTIONS(2884),
    [anon_sym_LT] = ACTIONS(2884),
    [anon_sym_COMMA] = ACTIONS(2886),
    [anon_sym_GT] = ACTIONS(2884),
    [anon_sym_DOT] = ACTIONS(2884),
    [anon_sym_LBRACK] = ACTIONS(2886),
    [anon_sym_RBRACK] = ACTIONS(2886),
    [anon_sym_COLON] = ACTIONS(2886),
    [anon_sym_LPAREN] = ACTIONS(2886),
    [anon_sym_RPAREN] = ACTIONS(2886),
    [anon_sym_in] = ACTIONS(2886),
    [anon_sym_LBRACE] = ACTIONS(2886),
    [anon_sym_RBRACE] = ACTIONS(2886),
    [anon_sym_EQ_GT] = ACTIONS(2886),
    [anon_sym_where] = ACTIONS(2886),
    [anon_sym_QMARK] = ACTIONS(2884),
    [anon_sym_BANG] = ACTIONS(2884),
    [anon_sym_PLUS_PLUS] = ACTIONS(2886),
    [anon_sym_DASH_DASH] = ACTIONS(2886),
    [anon_sym_PLUS] = ACTIONS(2884),
    [anon_sym_DASH] = ACTIONS(2884),
    [anon_sym_STAR] = ACTIONS(2884),
    [anon_sym_SLASH] = ACTIONS(2884),
    [anon_sym_PERCENT] = ACTIONS(2884),
    [anon_sym_CARET] = ACTIONS(2884),
    [anon_sym_PIPE] = ACTIONS(2884),
    [anon_sym_AMP] = ACTIONS(2884),
    [anon_sym_LT_LT] = ACTIONS(2884),
    [anon_sym_GT_GT] = ACTIONS(2884),
    [anon_sym_EQ_EQ] = ACTIONS(2886),
    [anon_sym_BANG_EQ] = ACTIONS(2886),
    [anon_sym_GT_EQ] = ACTIONS(2886),
    [anon_sym_LT_EQ] = ACTIONS(2886),
    [anon_sym_switch] = ACTIONS(2886),
    [anon_sym_and] = ACTIONS(2886),
    [anon_sym_or] = ACTIONS(2884),
    [anon_sym_PLUS_EQ] = ACTIONS(2886),
    [anon_sym_DASH_EQ] = ACTIONS(2886),
    [anon_sym_STAR_EQ] = ACTIONS(2886),
    [anon_sym_SLASH_EQ] = ACTIONS(2886),
    [anon_sym_PERCENT_EQ] = ACTIONS(2886),
    [anon_sym_AMP_EQ] = ACTIONS(2886),
    [anon_sym_CARET_EQ] = ACTIONS(2886),
    [anon_sym_PIPE_EQ] = ACTIONS(2886),
    [anon_sym_LT_LT_EQ] = ACTIONS(2886),
    [anon_sym_GT_GT_EQ] = ACTIONS(2886),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2886),
    [anon_sym_is] = ACTIONS(2886),
    [anon_sym_DASH_GT] = ACTIONS(2886),
    [anon_sym_from] = ACTIONS(2886),
    [anon_sym_join] = ACTIONS(2886),
    [anon_sym_on] = ACTIONS(2886),
    [anon_sym_equals] = ACTIONS(2886),
    [anon_sym_let] = ACTIONS(2886),
    [anon_sym_orderby] = ACTIONS(2886),
    [anon_sym_group] = ACTIONS(2886),
    [anon_sym_by] = ACTIONS(2886),
    [anon_sym_select] = ACTIONS(2886),
    [anon_sym_DOT_DOT] = ACTIONS(2886),
    [anon_sym_with] = ACTIONS(2886),
    [anon_sym_AMP_AMP] = ACTIONS(2886),
    [anon_sym_PIPE_PIPE] = ACTIONS(2886),
    [anon_sym_QMARK_QMARK] = ACTIONS(2884),
    [anon_sym_as] = ACTIONS(2886),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2106] = {
    [sym__preprocessor_call] = STATE(2106),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_RBRACK] = ACTIONS(3336),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_in] = ACTIONS(3338),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_EQ_GT] = ACTIONS(3336),
    [anon_sym_where] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_CARET] = ACTIONS(3338),
    [anon_sym_PIPE] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_LT_LT] = ACTIONS(3338),
    [anon_sym_GT_GT] = ACTIONS(3338),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_and] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3338),
    [anon_sym_PLUS_EQ] = ACTIONS(3336),
    [anon_sym_DASH_EQ] = ACTIONS(3336),
    [anon_sym_STAR_EQ] = ACTIONS(3336),
    [anon_sym_SLASH_EQ] = ACTIONS(3336),
    [anon_sym_PERCENT_EQ] = ACTIONS(3336),
    [anon_sym_AMP_EQ] = ACTIONS(3336),
    [anon_sym_CARET_EQ] = ACTIONS(3336),
    [anon_sym_PIPE_EQ] = ACTIONS(3336),
    [anon_sym_LT_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_GT_EQ] = ACTIONS(3336),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3336),
    [anon_sym_is] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_from] = ACTIONS(3336),
    [anon_sym_join] = ACTIONS(3336),
    [anon_sym_on] = ACTIONS(3336),
    [anon_sym_equals] = ACTIONS(3336),
    [anon_sym_into] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_orderby] = ACTIONS(3336),
    [anon_sym_group] = ACTIONS(3336),
    [anon_sym_by] = ACTIONS(3336),
    [anon_sym_select] = ACTIONS(3336),
    [anon_sym_DOT_DOT] = ACTIONS(3336),
    [anon_sym_with] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_QMARK_QMARK] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2107] = {
    [sym__preprocessor_call] = STATE(2107),
    [anon_sym_SEMI] = ACTIONS(2815),
    [anon_sym_EQ] = ACTIONS(2817),
    [anon_sym_LT] = ACTIONS(2817),
    [anon_sym_COMMA] = ACTIONS(2815),
    [anon_sym_GT] = ACTIONS(2817),
    [anon_sym_DOT] = ACTIONS(2817),
    [anon_sym_LBRACK] = ACTIONS(2815),
    [anon_sym_RBRACK] = ACTIONS(2815),
    [anon_sym_COLON] = ACTIONS(2815),
    [anon_sym_LPAREN] = ACTIONS(2815),
    [anon_sym_RPAREN] = ACTIONS(2815),
    [anon_sym_in] = ACTIONS(2815),
    [anon_sym_LBRACE] = ACTIONS(2815),
    [anon_sym_RBRACE] = ACTIONS(2815),
    [anon_sym_EQ_GT] = ACTIONS(2815),
    [anon_sym_where] = ACTIONS(2815),
    [anon_sym_QMARK] = ACTIONS(2817),
    [anon_sym_BANG] = ACTIONS(2817),
    [anon_sym_PLUS_PLUS] = ACTIONS(2815),
    [anon_sym_DASH_DASH] = ACTIONS(2815),
    [anon_sym_PLUS] = ACTIONS(2817),
    [anon_sym_DASH] = ACTIONS(2817),
    [anon_sym_STAR] = ACTIONS(2817),
    [anon_sym_SLASH] = ACTIONS(2817),
    [anon_sym_PERCENT] = ACTIONS(2817),
    [anon_sym_CARET] = ACTIONS(2817),
    [anon_sym_PIPE] = ACTIONS(2817),
    [anon_sym_AMP] = ACTIONS(2817),
    [anon_sym_LT_LT] = ACTIONS(2817),
    [anon_sym_GT_GT] = ACTIONS(2817),
    [anon_sym_EQ_EQ] = ACTIONS(2815),
    [anon_sym_BANG_EQ] = ACTIONS(2815),
    [anon_sym_GT_EQ] = ACTIONS(2815),
    [anon_sym_LT_EQ] = ACTIONS(2815),
    [anon_sym_switch] = ACTIONS(2815),
    [anon_sym_and] = ACTIONS(2815),
    [anon_sym_or] = ACTIONS(2817),
    [anon_sym_PLUS_EQ] = ACTIONS(2815),
    [anon_sym_DASH_EQ] = ACTIONS(2815),
    [anon_sym_STAR_EQ] = ACTIONS(2815),
    [anon_sym_SLASH_EQ] = ACTIONS(2815),
    [anon_sym_PERCENT_EQ] = ACTIONS(2815),
    [anon_sym_AMP_EQ] = ACTIONS(2815),
    [anon_sym_CARET_EQ] = ACTIONS(2815),
    [anon_sym_PIPE_EQ] = ACTIONS(2815),
    [anon_sym_LT_LT_EQ] = ACTIONS(2815),
    [anon_sym_GT_GT_EQ] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2815),
    [anon_sym_is] = ACTIONS(2815),
    [anon_sym_DASH_GT] = ACTIONS(2815),
    [anon_sym_from] = ACTIONS(2815),
    [anon_sym_join] = ACTIONS(2815),
    [anon_sym_on] = ACTIONS(2815),
    [anon_sym_equals] = ACTIONS(2815),
    [anon_sym_let] = ACTIONS(2815),
    [anon_sym_orderby] = ACTIONS(2815),
    [anon_sym_group] = ACTIONS(2815),
    [anon_sym_by] = ACTIONS(2815),
    [anon_sym_select] = ACTIONS(2815),
    [anon_sym_DOT_DOT] = ACTIONS(2815),
    [anon_sym_with] = ACTIONS(2815),
    [anon_sym_AMP_AMP] = ACTIONS(2815),
    [anon_sym_PIPE_PIPE] = ACTIONS(2815),
    [anon_sym_QMARK_QMARK] = ACTIONS(2817),
    [anon_sym_as] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2108] = {
    [sym__preprocessor_call] = STATE(2108),
    [anon_sym_SEMI] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_COMMA] = ACTIONS(3340),
    [anon_sym_GT] = ACTIONS(3342),
    [anon_sym_DOT] = ACTIONS(3342),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_RBRACK] = ACTIONS(3340),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(3344),
    [anon_sym_RPAREN] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3342),
    [anon_sym_RBRACE] = ACTIONS(3340),
    [anon_sym_EQ_GT] = ACTIONS(3340),
    [anon_sym_where] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_SLASH] = ACTIONS(3342),
    [anon_sym_PERCENT] = ACTIONS(3342),
    [anon_sym_CARET] = ACTIONS(3342),
    [anon_sym_PIPE] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3342),
    [anon_sym_LT_LT] = ACTIONS(3342),
    [anon_sym_GT_GT] = ACTIONS(3342),
    [anon_sym_EQ_EQ] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_GT_EQ] = ACTIONS(3340),
    [anon_sym_LT_EQ] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_and] = ACTIONS(3340),
    [anon_sym_or] = ACTIONS(3342),
    [anon_sym_PLUS_EQ] = ACTIONS(3340),
    [anon_sym_DASH_EQ] = ACTIONS(3340),
    [anon_sym_STAR_EQ] = ACTIONS(3340),
    [anon_sym_SLASH_EQ] = ACTIONS(3340),
    [anon_sym_PERCENT_EQ] = ACTIONS(3340),
    [anon_sym_AMP_EQ] = ACTIONS(3340),
    [anon_sym_CARET_EQ] = ACTIONS(3340),
    [anon_sym_PIPE_EQ] = ACTIONS(3340),
    [anon_sym_LT_LT_EQ] = ACTIONS(3340),
    [anon_sym_GT_GT_EQ] = ACTIONS(3340),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3340),
    [anon_sym_is] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_from] = ACTIONS(3340),
    [anon_sym_join] = ACTIONS(3340),
    [anon_sym_on] = ACTIONS(3340),
    [anon_sym_equals] = ACTIONS(3340),
    [anon_sym_into] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_orderby] = ACTIONS(3340),
    [anon_sym_group] = ACTIONS(3340),
    [anon_sym_by] = ACTIONS(3340),
    [anon_sym_select] = ACTIONS(3340),
    [anon_sym_DOT_DOT] = ACTIONS(3340),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_QMARK_QMARK] = ACTIONS(3342),
    [anon_sym_as] = ACTIONS(3340),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2109] = {
    [sym__preprocessor_call] = STATE(2109),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_EQ] = ACTIONS(3348),
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_DOT] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_RBRACK] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_RPAREN] = ACTIONS(3346),
    [anon_sym_in] = ACTIONS(3348),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_EQ_GT] = ACTIONS(3346),
    [anon_sym_where] = ACTIONS(3346),
    [anon_sym_QMARK] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3348),
    [anon_sym_CARET] = ACTIONS(3348),
    [anon_sym_PIPE] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_LT_LT] = ACTIONS(3348),
    [anon_sym_GT_GT] = ACTIONS(3348),
    [anon_sym_EQ_EQ] = ACTIONS(3346),
    [anon_sym_BANG_EQ] = ACTIONS(3346),
    [anon_sym_GT_EQ] = ACTIONS(3346),
    [anon_sym_LT_EQ] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_and] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3348),
    [anon_sym_PLUS_EQ] = ACTIONS(3346),
    [anon_sym_DASH_EQ] = ACTIONS(3346),
    [anon_sym_STAR_EQ] = ACTIONS(3346),
    [anon_sym_SLASH_EQ] = ACTIONS(3346),
    [anon_sym_PERCENT_EQ] = ACTIONS(3346),
    [anon_sym_AMP_EQ] = ACTIONS(3346),
    [anon_sym_CARET_EQ] = ACTIONS(3346),
    [anon_sym_PIPE_EQ] = ACTIONS(3346),
    [anon_sym_LT_LT_EQ] = ACTIONS(3346),
    [anon_sym_GT_GT_EQ] = ACTIONS(3346),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3346),
    [anon_sym_is] = ACTIONS(3346),
    [anon_sym_DASH_GT] = ACTIONS(3346),
    [anon_sym_from] = ACTIONS(3346),
    [anon_sym_join] = ACTIONS(3346),
    [anon_sym_on] = ACTIONS(3346),
    [anon_sym_equals] = ACTIONS(3346),
    [anon_sym_into] = ACTIONS(3346),
    [anon_sym_let] = ACTIONS(3346),
    [anon_sym_orderby] = ACTIONS(3346),
    [anon_sym_group] = ACTIONS(3346),
    [anon_sym_by] = ACTIONS(3346),
    [anon_sym_select] = ACTIONS(3346),
    [anon_sym_DOT_DOT] = ACTIONS(3346),
    [anon_sym_with] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_PIPE_PIPE] = ACTIONS(3346),
    [anon_sym_QMARK_QMARK] = ACTIONS(3348),
    [anon_sym_as] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2110] = {
    [sym__preprocessor_call] = STATE(2110),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym_EQ] = ACTIONS(2769),
    [anon_sym_LT] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2769),
    [anon_sym_DOT] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_RBRACK] = ACTIONS(2771),
    [anon_sym_COLON] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_RPAREN] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2769),
    [anon_sym_RBRACE] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(2771),
    [anon_sym_where] = ACTIONS(2771),
    [anon_sym_QMARK] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2769),
    [anon_sym_PERCENT] = ACTIONS(2769),
    [anon_sym_CARET] = ACTIONS(2769),
    [anon_sym_PIPE] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_LT_LT] = ACTIONS(2769),
    [anon_sym_GT_GT] = ACTIONS(2769),
    [anon_sym_EQ_EQ] = ACTIONS(2771),
    [anon_sym_BANG_EQ] = ACTIONS(2771),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_switch] = ACTIONS(2771),
    [anon_sym_and] = ACTIONS(2771),
    [anon_sym_or] = ACTIONS(2769),
    [anon_sym_PLUS_EQ] = ACTIONS(2771),
    [anon_sym_DASH_EQ] = ACTIONS(2771),
    [anon_sym_STAR_EQ] = ACTIONS(2771),
    [anon_sym_SLASH_EQ] = ACTIONS(2771),
    [anon_sym_PERCENT_EQ] = ACTIONS(2771),
    [anon_sym_AMP_EQ] = ACTIONS(2771),
    [anon_sym_CARET_EQ] = ACTIONS(2771),
    [anon_sym_PIPE_EQ] = ACTIONS(2771),
    [anon_sym_LT_LT_EQ] = ACTIONS(2771),
    [anon_sym_GT_GT_EQ] = ACTIONS(2771),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2771),
    [anon_sym_is] = ACTIONS(2771),
    [anon_sym_DASH_GT] = ACTIONS(2771),
    [anon_sym_from] = ACTIONS(2771),
    [anon_sym_join] = ACTIONS(2771),
    [anon_sym_on] = ACTIONS(2771),
    [anon_sym_equals] = ACTIONS(2771),
    [anon_sym_into] = ACTIONS(2771),
    [anon_sym_let] = ACTIONS(2771),
    [anon_sym_orderby] = ACTIONS(2771),
    [anon_sym_group] = ACTIONS(2771),
    [anon_sym_by] = ACTIONS(2771),
    [anon_sym_select] = ACTIONS(2771),
    [anon_sym_DOT_DOT] = ACTIONS(2771),
    [anon_sym_with] = ACTIONS(2771),
    [anon_sym_AMP_AMP] = ACTIONS(2771),
    [anon_sym_PIPE_PIPE] = ACTIONS(2771),
    [anon_sym_QMARK_QMARK] = ACTIONS(2769),
    [anon_sym_as] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2111] = {
    [sym__preprocessor_call] = STATE(2111),
    [anon_sym_SEMI] = ACTIONS(2890),
    [anon_sym_EQ] = ACTIONS(2888),
    [anon_sym_LT] = ACTIONS(2888),
    [anon_sym_COMMA] = ACTIONS(2890),
    [anon_sym_GT] = ACTIONS(2888),
    [anon_sym_DOT] = ACTIONS(2888),
    [anon_sym_LBRACK] = ACTIONS(2890),
    [anon_sym_RBRACK] = ACTIONS(2890),
    [anon_sym_COLON] = ACTIONS(2890),
    [anon_sym_LPAREN] = ACTIONS(2890),
    [anon_sym_RPAREN] = ACTIONS(2890),
    [anon_sym_in] = ACTIONS(2890),
    [anon_sym_LBRACE] = ACTIONS(2890),
    [anon_sym_RBRACE] = ACTIONS(2890),
    [anon_sym_EQ_GT] = ACTIONS(2890),
    [anon_sym_where] = ACTIONS(2890),
    [anon_sym_QMARK] = ACTIONS(2888),
    [anon_sym_BANG] = ACTIONS(2888),
    [anon_sym_PLUS_PLUS] = ACTIONS(2890),
    [anon_sym_DASH_DASH] = ACTIONS(2890),
    [anon_sym_PLUS] = ACTIONS(2888),
    [anon_sym_DASH] = ACTIONS(2888),
    [anon_sym_STAR] = ACTIONS(2888),
    [anon_sym_SLASH] = ACTIONS(2888),
    [anon_sym_PERCENT] = ACTIONS(2888),
    [anon_sym_CARET] = ACTIONS(2888),
    [anon_sym_PIPE] = ACTIONS(2888),
    [anon_sym_AMP] = ACTIONS(2888),
    [anon_sym_LT_LT] = ACTIONS(2888),
    [anon_sym_GT_GT] = ACTIONS(2888),
    [anon_sym_EQ_EQ] = ACTIONS(2890),
    [anon_sym_BANG_EQ] = ACTIONS(2890),
    [anon_sym_GT_EQ] = ACTIONS(2890),
    [anon_sym_LT_EQ] = ACTIONS(2890),
    [anon_sym_switch] = ACTIONS(2890),
    [anon_sym_and] = ACTIONS(2890),
    [anon_sym_or] = ACTIONS(2888),
    [anon_sym_PLUS_EQ] = ACTIONS(2890),
    [anon_sym_DASH_EQ] = ACTIONS(2890),
    [anon_sym_STAR_EQ] = ACTIONS(2890),
    [anon_sym_SLASH_EQ] = ACTIONS(2890),
    [anon_sym_PERCENT_EQ] = ACTIONS(2890),
    [anon_sym_AMP_EQ] = ACTIONS(2890),
    [anon_sym_CARET_EQ] = ACTIONS(2890),
    [anon_sym_PIPE_EQ] = ACTIONS(2890),
    [anon_sym_LT_LT_EQ] = ACTIONS(2890),
    [anon_sym_GT_GT_EQ] = ACTIONS(2890),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2890),
    [anon_sym_is] = ACTIONS(2890),
    [anon_sym_DASH_GT] = ACTIONS(2890),
    [anon_sym_from] = ACTIONS(2890),
    [anon_sym_join] = ACTIONS(2890),
    [anon_sym_on] = ACTIONS(2890),
    [anon_sym_equals] = ACTIONS(2890),
    [anon_sym_let] = ACTIONS(2890),
    [anon_sym_orderby] = ACTIONS(2890),
    [anon_sym_group] = ACTIONS(2890),
    [anon_sym_by] = ACTIONS(2890),
    [anon_sym_select] = ACTIONS(2890),
    [anon_sym_DOT_DOT] = ACTIONS(2890),
    [anon_sym_with] = ACTIONS(2890),
    [anon_sym_AMP_AMP] = ACTIONS(2890),
    [anon_sym_PIPE_PIPE] = ACTIONS(2890),
    [anon_sym_QMARK_QMARK] = ACTIONS(2888),
    [anon_sym_as] = ACTIONS(2890),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2112] = {
    [sym__preprocessor_call] = STATE(2112),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3069),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3067),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_EQ_GT] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_and] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3067),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3075),
    [anon_sym_DASH_GT] = ACTIONS(3072),
    [anon_sym_from] = ACTIONS(3075),
    [anon_sym_join] = ACTIONS(3075),
    [anon_sym_on] = ACTIONS(3075),
    [anon_sym_equals] = ACTIONS(3075),
    [anon_sym_into] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_orderby] = ACTIONS(3075),
    [anon_sym_group] = ACTIONS(3075),
    [anon_sym_by] = ACTIONS(3075),
    [anon_sym_select] = ACTIONS(3075),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3075),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2113] = {
    [sym__preprocessor_call] = STATE(2113),
    [anon_sym_SEMI] = ACTIONS(2858),
    [anon_sym_EQ] = ACTIONS(2850),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_COMMA] = ACTIONS(2858),
    [anon_sym_GT] = ACTIONS(2850),
    [anon_sym_DOT] = ACTIONS(2850),
    [anon_sym_LBRACK] = ACTIONS(2858),
    [anon_sym_RBRACK] = ACTIONS(2858),
    [anon_sym_COLON] = ACTIONS(2858),
    [anon_sym_LPAREN] = ACTIONS(2858),
    [anon_sym_RPAREN] = ACTIONS(2858),
    [anon_sym_in] = ACTIONS(2858),
    [anon_sym_LBRACE] = ACTIONS(2858),
    [anon_sym_RBRACE] = ACTIONS(2858),
    [anon_sym_EQ_GT] = ACTIONS(2858),
    [anon_sym_where] = ACTIONS(2858),
    [anon_sym_QMARK] = ACTIONS(2850),
    [anon_sym_BANG] = ACTIONS(2850),
    [anon_sym_PLUS_PLUS] = ACTIONS(2858),
    [anon_sym_DASH_DASH] = ACTIONS(2858),
    [anon_sym_PLUS] = ACTIONS(2850),
    [anon_sym_DASH] = ACTIONS(2850),
    [anon_sym_STAR] = ACTIONS(2850),
    [anon_sym_SLASH] = ACTIONS(2850),
    [anon_sym_PERCENT] = ACTIONS(2850),
    [anon_sym_CARET] = ACTIONS(2850),
    [anon_sym_PIPE] = ACTIONS(2850),
    [anon_sym_AMP] = ACTIONS(2850),
    [anon_sym_LT_LT] = ACTIONS(2850),
    [anon_sym_GT_GT] = ACTIONS(2850),
    [anon_sym_EQ_EQ] = ACTIONS(2858),
    [anon_sym_BANG_EQ] = ACTIONS(2858),
    [anon_sym_GT_EQ] = ACTIONS(2858),
    [anon_sym_LT_EQ] = ACTIONS(2858),
    [anon_sym_switch] = ACTIONS(2858),
    [anon_sym_and] = ACTIONS(2858),
    [anon_sym_or] = ACTIONS(2850),
    [anon_sym_PLUS_EQ] = ACTIONS(2858),
    [anon_sym_DASH_EQ] = ACTIONS(2858),
    [anon_sym_STAR_EQ] = ACTIONS(2858),
    [anon_sym_SLASH_EQ] = ACTIONS(2858),
    [anon_sym_PERCENT_EQ] = ACTIONS(2858),
    [anon_sym_AMP_EQ] = ACTIONS(2858),
    [anon_sym_CARET_EQ] = ACTIONS(2858),
    [anon_sym_PIPE_EQ] = ACTIONS(2858),
    [anon_sym_LT_LT_EQ] = ACTIONS(2858),
    [anon_sym_GT_GT_EQ] = ACTIONS(2858),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2858),
    [anon_sym_is] = ACTIONS(2858),
    [anon_sym_DASH_GT] = ACTIONS(2858),
    [anon_sym_from] = ACTIONS(2858),
    [anon_sym_join] = ACTIONS(2858),
    [anon_sym_on] = ACTIONS(2858),
    [anon_sym_equals] = ACTIONS(2858),
    [anon_sym_let] = ACTIONS(2858),
    [anon_sym_orderby] = ACTIONS(2858),
    [anon_sym_group] = ACTIONS(2858),
    [anon_sym_by] = ACTIONS(2858),
    [anon_sym_select] = ACTIONS(2858),
    [anon_sym_DOT_DOT] = ACTIONS(2858),
    [anon_sym_with] = ACTIONS(2858),
    [anon_sym_AMP_AMP] = ACTIONS(2858),
    [anon_sym_PIPE_PIPE] = ACTIONS(2858),
    [anon_sym_QMARK_QMARK] = ACTIONS(2850),
    [anon_sym_as] = ACTIONS(2858),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2114] = {
    [sym__preprocessor_call] = STATE(2114),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2894),
    [anon_sym_QMARK] = ACTIONS(2892),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_switch] = ACTIONS(2894),
    [anon_sym_and] = ACTIONS(2894),
    [anon_sym_or] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2894),
    [anon_sym_DASH_GT] = ACTIONS(2894),
    [anon_sym_from] = ACTIONS(2894),
    [anon_sym_join] = ACTIONS(2894),
    [anon_sym_on] = ACTIONS(2894),
    [anon_sym_equals] = ACTIONS(2894),
    [anon_sym_let] = ACTIONS(2894),
    [anon_sym_orderby] = ACTIONS(2894),
    [anon_sym_group] = ACTIONS(2894),
    [anon_sym_by] = ACTIONS(2894),
    [anon_sym_select] = ACTIONS(2894),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2894),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2115] = {
    [sym__preprocessor_call] = STATE(2115),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(2892),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_COLON] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_in] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_EQ_GT] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2894),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_switch] = ACTIONS(2894),
    [anon_sym_and] = ACTIONS(2894),
    [anon_sym_or] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2894),
    [anon_sym_DASH_GT] = ACTIONS(2894),
    [anon_sym_from] = ACTIONS(2894),
    [anon_sym_join] = ACTIONS(2894),
    [anon_sym_on] = ACTIONS(2894),
    [anon_sym_equals] = ACTIONS(2894),
    [anon_sym_let] = ACTIONS(2894),
    [anon_sym_orderby] = ACTIONS(2894),
    [anon_sym_group] = ACTIONS(2894),
    [anon_sym_by] = ACTIONS(2894),
    [anon_sym_select] = ACTIONS(2894),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2894),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2116] = {
    [sym__preprocessor_call] = STATE(2116),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym_EQ] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3352),
    [anon_sym_LBRACK] = ACTIONS(3350),
    [anon_sym_RBRACK] = ACTIONS(3350),
    [anon_sym_COLON] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [anon_sym_in] = ACTIONS(3352),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_EQ_GT] = ACTIONS(3350),
    [anon_sym_where] = ACTIONS(3350),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_SLASH] = ACTIONS(3352),
    [anon_sym_PERCENT] = ACTIONS(3352),
    [anon_sym_CARET] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
    [anon_sym_LT_LT] = ACTIONS(3352),
    [anon_sym_GT_GT] = ACTIONS(3352),
    [anon_sym_EQ_EQ] = ACTIONS(3350),
    [anon_sym_BANG_EQ] = ACTIONS(3350),
    [anon_sym_GT_EQ] = ACTIONS(3350),
    [anon_sym_LT_EQ] = ACTIONS(3350),
    [anon_sym_switch] = ACTIONS(3350),
    [anon_sym_and] = ACTIONS(3350),
    [anon_sym_or] = ACTIONS(3352),
    [anon_sym_PLUS_EQ] = ACTIONS(3350),
    [anon_sym_DASH_EQ] = ACTIONS(3350),
    [anon_sym_STAR_EQ] = ACTIONS(3350),
    [anon_sym_SLASH_EQ] = ACTIONS(3350),
    [anon_sym_PERCENT_EQ] = ACTIONS(3350),
    [anon_sym_AMP_EQ] = ACTIONS(3350),
    [anon_sym_CARET_EQ] = ACTIONS(3350),
    [anon_sym_PIPE_EQ] = ACTIONS(3350),
    [anon_sym_LT_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_GT_EQ] = ACTIONS(3350),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3350),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_DASH_GT] = ACTIONS(3350),
    [anon_sym_from] = ACTIONS(3350),
    [anon_sym_join] = ACTIONS(3350),
    [anon_sym_on] = ACTIONS(3350),
    [anon_sym_equals] = ACTIONS(3350),
    [anon_sym_into] = ACTIONS(3350),
    [anon_sym_let] = ACTIONS(3350),
    [anon_sym_orderby] = ACTIONS(3350),
    [anon_sym_group] = ACTIONS(3350),
    [anon_sym_by] = ACTIONS(3350),
    [anon_sym_select] = ACTIONS(3350),
    [anon_sym_DOT_DOT] = ACTIONS(3350),
    [anon_sym_with] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_QMARK_QMARK] = ACTIONS(3352),
    [anon_sym_as] = ACTIONS(3350),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2117] = {
    [sym__preprocessor_call] = STATE(2117),
    [anon_sym_SEMI] = ACTIONS(3354),
    [anon_sym_EQ] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_COMMA] = ACTIONS(3354),
    [anon_sym_GT] = ACTIONS(3356),
    [anon_sym_DOT] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_RBRACK] = ACTIONS(3354),
    [anon_sym_COLON] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3354),
    [anon_sym_RPAREN] = ACTIONS(3354),
    [anon_sym_in] = ACTIONS(3356),
    [anon_sym_RBRACE] = ACTIONS(3354),
    [anon_sym_EQ_GT] = ACTIONS(3354),
    [anon_sym_where] = ACTIONS(3354),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3354),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_PERCENT] = ACTIONS(3356),
    [anon_sym_CARET] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3356),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_EQ_EQ] = ACTIONS(3354),
    [anon_sym_BANG_EQ] = ACTIONS(3354),
    [anon_sym_GT_EQ] = ACTIONS(3354),
    [anon_sym_LT_EQ] = ACTIONS(3354),
    [anon_sym_switch] = ACTIONS(3354),
    [anon_sym_and] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(3356),
    [anon_sym_PLUS_EQ] = ACTIONS(3354),
    [anon_sym_DASH_EQ] = ACTIONS(3354),
    [anon_sym_STAR_EQ] = ACTIONS(3354),
    [anon_sym_SLASH_EQ] = ACTIONS(3354),
    [anon_sym_PERCENT_EQ] = ACTIONS(3354),
    [anon_sym_AMP_EQ] = ACTIONS(3354),
    [anon_sym_CARET_EQ] = ACTIONS(3354),
    [anon_sym_PIPE_EQ] = ACTIONS(3354),
    [anon_sym_LT_LT_EQ] = ACTIONS(3354),
    [anon_sym_GT_GT_EQ] = ACTIONS(3354),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3354),
    [anon_sym_is] = ACTIONS(3354),
    [anon_sym_DASH_GT] = ACTIONS(3354),
    [anon_sym_from] = ACTIONS(3354),
    [anon_sym_join] = ACTIONS(3354),
    [anon_sym_on] = ACTIONS(3354),
    [anon_sym_equals] = ACTIONS(3354),
    [anon_sym_into] = ACTIONS(3354),
    [anon_sym_let] = ACTIONS(3354),
    [anon_sym_orderby] = ACTIONS(3354),
    [anon_sym_group] = ACTIONS(3354),
    [anon_sym_by] = ACTIONS(3354),
    [anon_sym_select] = ACTIONS(3354),
    [anon_sym_DOT_DOT] = ACTIONS(3354),
    [anon_sym_with] = ACTIONS(3354),
    [anon_sym_AMP_AMP] = ACTIONS(3354),
    [anon_sym_PIPE_PIPE] = ACTIONS(3354),
    [anon_sym_QMARK_QMARK] = ACTIONS(3356),
    [anon_sym_as] = ACTIONS(3354),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2118] = {
    [sym__preprocessor_call] = STATE(2118),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_EQ] = ACTIONS(3360),
    [anon_sym_LT] = ACTIONS(3360),
    [anon_sym_COMMA] = ACTIONS(3358),
    [anon_sym_GT] = ACTIONS(3360),
    [anon_sym_DOT] = ACTIONS(3360),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_RBRACK] = ACTIONS(3358),
    [anon_sym_COLON] = ACTIONS(3358),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_RPAREN] = ACTIONS(3358),
    [anon_sym_in] = ACTIONS(3360),
    [anon_sym_RBRACE] = ACTIONS(3358),
    [anon_sym_EQ_GT] = ACTIONS(3358),
    [anon_sym_where] = ACTIONS(3358),
    [anon_sym_QMARK] = ACTIONS(3360),
    [anon_sym_BANG] = ACTIONS(3360),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_DASH] = ACTIONS(3360),
    [anon_sym_STAR] = ACTIONS(3360),
    [anon_sym_SLASH] = ACTIONS(3360),
    [anon_sym_PERCENT] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3360),
    [anon_sym_PIPE] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3360),
    [anon_sym_LT_LT] = ACTIONS(3360),
    [anon_sym_GT_GT] = ACTIONS(3360),
    [anon_sym_EQ_EQ] = ACTIONS(3358),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_GT_EQ] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3358),
    [anon_sym_switch] = ACTIONS(3358),
    [anon_sym_and] = ACTIONS(3358),
    [anon_sym_or] = ACTIONS(3360),
    [anon_sym_PLUS_EQ] = ACTIONS(3358),
    [anon_sym_DASH_EQ] = ACTIONS(3358),
    [anon_sym_STAR_EQ] = ACTIONS(3358),
    [anon_sym_SLASH_EQ] = ACTIONS(3358),
    [anon_sym_PERCENT_EQ] = ACTIONS(3358),
    [anon_sym_AMP_EQ] = ACTIONS(3358),
    [anon_sym_CARET_EQ] = ACTIONS(3358),
    [anon_sym_PIPE_EQ] = ACTIONS(3358),
    [anon_sym_LT_LT_EQ] = ACTIONS(3358),
    [anon_sym_GT_GT_EQ] = ACTIONS(3358),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3358),
    [anon_sym_is] = ACTIONS(3358),
    [anon_sym_DASH_GT] = ACTIONS(3358),
    [anon_sym_from] = ACTIONS(3358),
    [anon_sym_join] = ACTIONS(3358),
    [anon_sym_on] = ACTIONS(3358),
    [anon_sym_equals] = ACTIONS(3358),
    [anon_sym_into] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_orderby] = ACTIONS(3358),
    [anon_sym_group] = ACTIONS(3358),
    [anon_sym_by] = ACTIONS(3358),
    [anon_sym_select] = ACTIONS(3358),
    [anon_sym_DOT_DOT] = ACTIONS(3358),
    [anon_sym_with] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [anon_sym_QMARK_QMARK] = ACTIONS(3360),
    [anon_sym_as] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2119] = {
    [sym__preprocessor_call] = STATE(2119),
    [anon_sym_SEMI] = ACTIONS(3362),
    [anon_sym_EQ] = ACTIONS(3364),
    [anon_sym_LT] = ACTIONS(3364),
    [anon_sym_COMMA] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3364),
    [anon_sym_DOT] = ACTIONS(3364),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_RBRACK] = ACTIONS(3362),
    [anon_sym_COLON] = ACTIONS(3362),
    [anon_sym_LPAREN] = ACTIONS(3362),
    [anon_sym_RPAREN] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3364),
    [anon_sym_RBRACE] = ACTIONS(3362),
    [anon_sym_EQ_GT] = ACTIONS(3362),
    [anon_sym_where] = ACTIONS(3362),
    [anon_sym_QMARK] = ACTIONS(3364),
    [anon_sym_BANG] = ACTIONS(3364),
    [anon_sym_PLUS_PLUS] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3364),
    [anon_sym_STAR] = ACTIONS(3364),
    [anon_sym_SLASH] = ACTIONS(3364),
    [anon_sym_PERCENT] = ACTIONS(3364),
    [anon_sym_CARET] = ACTIONS(3364),
    [anon_sym_PIPE] = ACTIONS(3364),
    [anon_sym_AMP] = ACTIONS(3364),
    [anon_sym_LT_LT] = ACTIONS(3364),
    [anon_sym_GT_GT] = ACTIONS(3364),
    [anon_sym_EQ_EQ] = ACTIONS(3362),
    [anon_sym_BANG_EQ] = ACTIONS(3362),
    [anon_sym_GT_EQ] = ACTIONS(3362),
    [anon_sym_LT_EQ] = ACTIONS(3362),
    [anon_sym_switch] = ACTIONS(3362),
    [anon_sym_and] = ACTIONS(3362),
    [anon_sym_or] = ACTIONS(3364),
    [anon_sym_PLUS_EQ] = ACTIONS(3362),
    [anon_sym_DASH_EQ] = ACTIONS(3362),
    [anon_sym_STAR_EQ] = ACTIONS(3362),
    [anon_sym_SLASH_EQ] = ACTIONS(3362),
    [anon_sym_PERCENT_EQ] = ACTIONS(3362),
    [anon_sym_AMP_EQ] = ACTIONS(3362),
    [anon_sym_CARET_EQ] = ACTIONS(3362),
    [anon_sym_PIPE_EQ] = ACTIONS(3362),
    [anon_sym_LT_LT_EQ] = ACTIONS(3362),
    [anon_sym_GT_GT_EQ] = ACTIONS(3362),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3362),
    [anon_sym_is] = ACTIONS(3362),
    [anon_sym_DASH_GT] = ACTIONS(3362),
    [anon_sym_from] = ACTIONS(3362),
    [anon_sym_join] = ACTIONS(3362),
    [anon_sym_on] = ACTIONS(3362),
    [anon_sym_equals] = ACTIONS(3362),
    [anon_sym_into] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_orderby] = ACTIONS(3362),
    [anon_sym_group] = ACTIONS(3362),
    [anon_sym_by] = ACTIONS(3362),
    [anon_sym_select] = ACTIONS(3362),
    [anon_sym_DOT_DOT] = ACTIONS(3362),
    [anon_sym_with] = ACTIONS(3362),
    [anon_sym_AMP_AMP] = ACTIONS(3362),
    [anon_sym_PIPE_PIPE] = ACTIONS(3362),
    [anon_sym_QMARK_QMARK] = ACTIONS(3364),
    [anon_sym_as] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2120] = {
    [sym__preprocessor_call] = STATE(2120),
    [anon_sym_SEMI] = ACTIONS(3366),
    [anon_sym_EQ] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_COMMA] = ACTIONS(3366),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_DOT] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3366),
    [anon_sym_RBRACK] = ACTIONS(3366),
    [anon_sym_COLON] = ACTIONS(3366),
    [anon_sym_LPAREN] = ACTIONS(3366),
    [anon_sym_RPAREN] = ACTIONS(3366),
    [anon_sym_in] = ACTIONS(3368),
    [anon_sym_RBRACE] = ACTIONS(3366),
    [anon_sym_EQ_GT] = ACTIONS(3366),
    [anon_sym_where] = ACTIONS(3366),
    [anon_sym_QMARK] = ACTIONS(3368),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3366),
    [anon_sym_DASH_DASH] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_PERCENT] = ACTIONS(3368),
    [anon_sym_CARET] = ACTIONS(3368),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_LT_LT] = ACTIONS(3368),
    [anon_sym_GT_GT] = ACTIONS(3368),
    [anon_sym_EQ_EQ] = ACTIONS(3366),
    [anon_sym_BANG_EQ] = ACTIONS(3366),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LT_EQ] = ACTIONS(3366),
    [anon_sym_switch] = ACTIONS(3366),
    [anon_sym_and] = ACTIONS(3366),
    [anon_sym_or] = ACTIONS(3368),
    [anon_sym_PLUS_EQ] = ACTIONS(3366),
    [anon_sym_DASH_EQ] = ACTIONS(3366),
    [anon_sym_STAR_EQ] = ACTIONS(3366),
    [anon_sym_SLASH_EQ] = ACTIONS(3366),
    [anon_sym_PERCENT_EQ] = ACTIONS(3366),
    [anon_sym_AMP_EQ] = ACTIONS(3366),
    [anon_sym_CARET_EQ] = ACTIONS(3366),
    [anon_sym_PIPE_EQ] = ACTIONS(3366),
    [anon_sym_LT_LT_EQ] = ACTIONS(3366),
    [anon_sym_GT_GT_EQ] = ACTIONS(3366),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3366),
    [anon_sym_is] = ACTIONS(3366),
    [anon_sym_DASH_GT] = ACTIONS(3366),
    [anon_sym_from] = ACTIONS(3366),
    [anon_sym_join] = ACTIONS(3366),
    [anon_sym_on] = ACTIONS(3366),
    [anon_sym_equals] = ACTIONS(3366),
    [anon_sym_into] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_orderby] = ACTIONS(3366),
    [anon_sym_group] = ACTIONS(3366),
    [anon_sym_by] = ACTIONS(3366),
    [anon_sym_select] = ACTIONS(3366),
    [anon_sym_DOT_DOT] = ACTIONS(3366),
    [anon_sym_with] = ACTIONS(3366),
    [anon_sym_AMP_AMP] = ACTIONS(3366),
    [anon_sym_PIPE_PIPE] = ACTIONS(3366),
    [anon_sym_QMARK_QMARK] = ACTIONS(3368),
    [anon_sym_as] = ACTIONS(3366),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2121] = {
    [sym__preprocessor_call] = STATE(2121),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_GT] = ACTIONS(3057),
    [anon_sym_DOT] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_RBRACK] = ACTIONS(3059),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(3057),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_EQ_GT] = ACTIONS(3059),
    [anon_sym_where] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3057),
    [anon_sym_CARET] = ACTIONS(3057),
    [anon_sym_PIPE] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_LT_LT] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(3057),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_GT_EQ] = ACTIONS(3059),
    [anon_sym_LT_EQ] = ACTIONS(3059),
    [anon_sym_switch] = ACTIONS(3059),
    [anon_sym_and] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(3059),
    [anon_sym_DASH_EQ] = ACTIONS(3059),
    [anon_sym_STAR_EQ] = ACTIONS(3059),
    [anon_sym_SLASH_EQ] = ACTIONS(3059),
    [anon_sym_PERCENT_EQ] = ACTIONS(3059),
    [anon_sym_AMP_EQ] = ACTIONS(3059),
    [anon_sym_CARET_EQ] = ACTIONS(3059),
    [anon_sym_PIPE_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3059),
    [anon_sym_is] = ACTIONS(3059),
    [anon_sym_DASH_GT] = ACTIONS(3059),
    [anon_sym_from] = ACTIONS(3059),
    [anon_sym_join] = ACTIONS(3059),
    [anon_sym_on] = ACTIONS(3059),
    [anon_sym_equals] = ACTIONS(3059),
    [anon_sym_into] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_orderby] = ACTIONS(3059),
    [anon_sym_group] = ACTIONS(3059),
    [anon_sym_by] = ACTIONS(3059),
    [anon_sym_select] = ACTIONS(3059),
    [anon_sym_DOT_DOT] = ACTIONS(3059),
    [anon_sym_with] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_QMARK_QMARK] = ACTIONS(3057),
    [anon_sym_as] = ACTIONS(3059),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2122] = {
    [sym__preprocessor_call] = STATE(2122),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3372),
    [anon_sym_COMMA] = ACTIONS(3370),
    [anon_sym_GT] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_RBRACK] = ACTIONS(3370),
    [anon_sym_COLON] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_RPAREN] = ACTIONS(3370),
    [anon_sym_in] = ACTIONS(3372),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_EQ_GT] = ACTIONS(3370),
    [anon_sym_where] = ACTIONS(3370),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_BANG] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [anon_sym_PLUS] = ACTIONS(3372),
    [anon_sym_DASH] = ACTIONS(3372),
    [anon_sym_STAR] = ACTIONS(3372),
    [anon_sym_SLASH] = ACTIONS(3372),
    [anon_sym_PERCENT] = ACTIONS(3372),
    [anon_sym_CARET] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3372),
    [anon_sym_GT_GT] = ACTIONS(3372),
    [anon_sym_EQ_EQ] = ACTIONS(3370),
    [anon_sym_BANG_EQ] = ACTIONS(3370),
    [anon_sym_GT_EQ] = ACTIONS(3370),
    [anon_sym_LT_EQ] = ACTIONS(3370),
    [anon_sym_switch] = ACTIONS(3370),
    [anon_sym_and] = ACTIONS(3370),
    [anon_sym_or] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3370),
    [anon_sym_DASH_EQ] = ACTIONS(3370),
    [anon_sym_STAR_EQ] = ACTIONS(3370),
    [anon_sym_SLASH_EQ] = ACTIONS(3370),
    [anon_sym_PERCENT_EQ] = ACTIONS(3370),
    [anon_sym_AMP_EQ] = ACTIONS(3370),
    [anon_sym_CARET_EQ] = ACTIONS(3370),
    [anon_sym_PIPE_EQ] = ACTIONS(3370),
    [anon_sym_LT_LT_EQ] = ACTIONS(3370),
    [anon_sym_GT_GT_EQ] = ACTIONS(3370),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3370),
    [anon_sym_is] = ACTIONS(3370),
    [anon_sym_DASH_GT] = ACTIONS(3370),
    [anon_sym_from] = ACTIONS(3370),
    [anon_sym_join] = ACTIONS(3370),
    [anon_sym_on] = ACTIONS(3370),
    [anon_sym_equals] = ACTIONS(3370),
    [anon_sym_into] = ACTIONS(3370),
    [anon_sym_let] = ACTIONS(3370),
    [anon_sym_orderby] = ACTIONS(3370),
    [anon_sym_group] = ACTIONS(3370),
    [anon_sym_by] = ACTIONS(3370),
    [anon_sym_select] = ACTIONS(3370),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_with] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_PIPE_PIPE] = ACTIONS(3370),
    [anon_sym_QMARK_QMARK] = ACTIONS(3372),
    [anon_sym_as] = ACTIONS(3370),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2123] = {
    [sym__preprocessor_call] = STATE(2123),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3067),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_EQ_GT] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_and] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3067),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3075),
    [anon_sym_DASH_GT] = ACTIONS(3075),
    [anon_sym_from] = ACTIONS(3075),
    [anon_sym_join] = ACTIONS(3075),
    [anon_sym_on] = ACTIONS(3075),
    [anon_sym_equals] = ACTIONS(3075),
    [anon_sym_into] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_orderby] = ACTIONS(3075),
    [anon_sym_group] = ACTIONS(3075),
    [anon_sym_by] = ACTIONS(3075),
    [anon_sym_select] = ACTIONS(3075),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3075),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2124] = {
    [sym__preprocessor_call] = STATE(2124),
    [anon_sym_SEMI] = ACTIONS(3374),
    [anon_sym_EQ] = ACTIONS(3376),
    [anon_sym_LT] = ACTIONS(3376),
    [anon_sym_COMMA] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3376),
    [anon_sym_DOT] = ACTIONS(3376),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_RBRACK] = ACTIONS(3374),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3374),
    [anon_sym_RPAREN] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3376),
    [anon_sym_RBRACE] = ACTIONS(3374),
    [anon_sym_EQ_GT] = ACTIONS(3374),
    [anon_sym_where] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3376),
    [anon_sym_BANG] = ACTIONS(3376),
    [anon_sym_PLUS_PLUS] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3376),
    [anon_sym_DASH] = ACTIONS(3376),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_SLASH] = ACTIONS(3376),
    [anon_sym_PERCENT] = ACTIONS(3376),
    [anon_sym_CARET] = ACTIONS(3376),
    [anon_sym_PIPE] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3376),
    [anon_sym_LT_LT] = ACTIONS(3376),
    [anon_sym_GT_GT] = ACTIONS(3376),
    [anon_sym_EQ_EQ] = ACTIONS(3374),
    [anon_sym_BANG_EQ] = ACTIONS(3374),
    [anon_sym_GT_EQ] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3374),
    [anon_sym_switch] = ACTIONS(3374),
    [anon_sym_and] = ACTIONS(3374),
    [anon_sym_or] = ACTIONS(3376),
    [anon_sym_PLUS_EQ] = ACTIONS(3374),
    [anon_sym_DASH_EQ] = ACTIONS(3374),
    [anon_sym_STAR_EQ] = ACTIONS(3374),
    [anon_sym_SLASH_EQ] = ACTIONS(3374),
    [anon_sym_PERCENT_EQ] = ACTIONS(3374),
    [anon_sym_AMP_EQ] = ACTIONS(3374),
    [anon_sym_CARET_EQ] = ACTIONS(3374),
    [anon_sym_PIPE_EQ] = ACTIONS(3374),
    [anon_sym_LT_LT_EQ] = ACTIONS(3374),
    [anon_sym_GT_GT_EQ] = ACTIONS(3374),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3374),
    [anon_sym_is] = ACTIONS(3374),
    [anon_sym_DASH_GT] = ACTIONS(3374),
    [anon_sym_from] = ACTIONS(3374),
    [anon_sym_join] = ACTIONS(3374),
    [anon_sym_on] = ACTIONS(3374),
    [anon_sym_equals] = ACTIONS(3374),
    [anon_sym_into] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_orderby] = ACTIONS(3374),
    [anon_sym_group] = ACTIONS(3374),
    [anon_sym_by] = ACTIONS(3374),
    [anon_sym_select] = ACTIONS(3374),
    [anon_sym_DOT_DOT] = ACTIONS(3374),
    [anon_sym_with] = ACTIONS(3374),
    [anon_sym_AMP_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3374),
    [anon_sym_QMARK_QMARK] = ACTIONS(3376),
    [anon_sym_as] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2125] = {
    [sym__preprocessor_call] = STATE(2125),
    [anon_sym_SEMI] = ACTIONS(3378),
    [anon_sym_EQ] = ACTIONS(3380),
    [anon_sym_LT] = ACTIONS(3380),
    [anon_sym_COMMA] = ACTIONS(3378),
    [anon_sym_GT] = ACTIONS(3380),
    [anon_sym_DOT] = ACTIONS(3380),
    [anon_sym_LBRACK] = ACTIONS(3378),
    [anon_sym_RBRACK] = ACTIONS(3378),
    [anon_sym_COLON] = ACTIONS(3378),
    [anon_sym_LPAREN] = ACTIONS(3378),
    [anon_sym_RPAREN] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3380),
    [anon_sym_RBRACE] = ACTIONS(3378),
    [anon_sym_EQ_GT] = ACTIONS(3378),
    [anon_sym_where] = ACTIONS(3378),
    [anon_sym_QMARK] = ACTIONS(3380),
    [anon_sym_BANG] = ACTIONS(3380),
    [anon_sym_PLUS_PLUS] = ACTIONS(3378),
    [anon_sym_DASH_DASH] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3380),
    [anon_sym_DASH] = ACTIONS(3380),
    [anon_sym_STAR] = ACTIONS(3380),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [anon_sym_CARET] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_LT_LT] = ACTIONS(3380),
    [anon_sym_GT_GT] = ACTIONS(3380),
    [anon_sym_EQ_EQ] = ACTIONS(3378),
    [anon_sym_BANG_EQ] = ACTIONS(3378),
    [anon_sym_GT_EQ] = ACTIONS(3378),
    [anon_sym_LT_EQ] = ACTIONS(3378),
    [anon_sym_switch] = ACTIONS(3378),
    [anon_sym_and] = ACTIONS(3378),
    [anon_sym_or] = ACTIONS(3380),
    [anon_sym_PLUS_EQ] = ACTIONS(3378),
    [anon_sym_DASH_EQ] = ACTIONS(3378),
    [anon_sym_STAR_EQ] = ACTIONS(3378),
    [anon_sym_SLASH_EQ] = ACTIONS(3378),
    [anon_sym_PERCENT_EQ] = ACTIONS(3378),
    [anon_sym_AMP_EQ] = ACTIONS(3378),
    [anon_sym_CARET_EQ] = ACTIONS(3378),
    [anon_sym_PIPE_EQ] = ACTIONS(3378),
    [anon_sym_LT_LT_EQ] = ACTIONS(3378),
    [anon_sym_GT_GT_EQ] = ACTIONS(3378),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3378),
    [anon_sym_is] = ACTIONS(3378),
    [anon_sym_DASH_GT] = ACTIONS(3378),
    [anon_sym_from] = ACTIONS(3378),
    [anon_sym_join] = ACTIONS(3378),
    [anon_sym_on] = ACTIONS(3378),
    [anon_sym_equals] = ACTIONS(3378),
    [anon_sym_into] = ACTIONS(3378),
    [anon_sym_let] = ACTIONS(3378),
    [anon_sym_orderby] = ACTIONS(3378),
    [anon_sym_group] = ACTIONS(3378),
    [anon_sym_by] = ACTIONS(3378),
    [anon_sym_select] = ACTIONS(3378),
    [anon_sym_DOT_DOT] = ACTIONS(3378),
    [anon_sym_with] = ACTIONS(3378),
    [anon_sym_AMP_AMP] = ACTIONS(3378),
    [anon_sym_PIPE_PIPE] = ACTIONS(3378),
    [anon_sym_QMARK_QMARK] = ACTIONS(3380),
    [anon_sym_as] = ACTIONS(3378),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2126] = {
    [sym__preprocessor_call] = STATE(2126),
    [anon_sym_SEMI] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(3384),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_COMMA] = ACTIONS(3382),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_LBRACK] = ACTIONS(3382),
    [anon_sym_RBRACK] = ACTIONS(3382),
    [anon_sym_COLON] = ACTIONS(3382),
    [anon_sym_LPAREN] = ACTIONS(3382),
    [anon_sym_RPAREN] = ACTIONS(3382),
    [anon_sym_in] = ACTIONS(3384),
    [anon_sym_RBRACE] = ACTIONS(3382),
    [anon_sym_EQ_GT] = ACTIONS(3382),
    [anon_sym_where] = ACTIONS(3382),
    [anon_sym_QMARK] = ACTIONS(3384),
    [anon_sym_BANG] = ACTIONS(3384),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(3384),
    [anon_sym_DASH] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(3384),
    [anon_sym_SLASH] = ACTIONS(3384),
    [anon_sym_PERCENT] = ACTIONS(3384),
    [anon_sym_CARET] = ACTIONS(3384),
    [anon_sym_PIPE] = ACTIONS(3384),
    [anon_sym_AMP] = ACTIONS(3384),
    [anon_sym_LT_LT] = ACTIONS(3384),
    [anon_sym_GT_GT] = ACTIONS(3384),
    [anon_sym_EQ_EQ] = ACTIONS(3382),
    [anon_sym_BANG_EQ] = ACTIONS(3382),
    [anon_sym_GT_EQ] = ACTIONS(3382),
    [anon_sym_LT_EQ] = ACTIONS(3382),
    [anon_sym_switch] = ACTIONS(3382),
    [anon_sym_and] = ACTIONS(3382),
    [anon_sym_or] = ACTIONS(3384),
    [anon_sym_PLUS_EQ] = ACTIONS(3382),
    [anon_sym_DASH_EQ] = ACTIONS(3382),
    [anon_sym_STAR_EQ] = ACTIONS(3382),
    [anon_sym_SLASH_EQ] = ACTIONS(3382),
    [anon_sym_PERCENT_EQ] = ACTIONS(3382),
    [anon_sym_AMP_EQ] = ACTIONS(3382),
    [anon_sym_CARET_EQ] = ACTIONS(3382),
    [anon_sym_PIPE_EQ] = ACTIONS(3382),
    [anon_sym_LT_LT_EQ] = ACTIONS(3382),
    [anon_sym_GT_GT_EQ] = ACTIONS(3382),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3382),
    [anon_sym_is] = ACTIONS(3382),
    [anon_sym_DASH_GT] = ACTIONS(3382),
    [anon_sym_from] = ACTIONS(3382),
    [anon_sym_join] = ACTIONS(3382),
    [anon_sym_on] = ACTIONS(3382),
    [anon_sym_equals] = ACTIONS(3382),
    [anon_sym_into] = ACTIONS(3382),
    [anon_sym_let] = ACTIONS(3382),
    [anon_sym_orderby] = ACTIONS(3382),
    [anon_sym_group] = ACTIONS(3382),
    [anon_sym_by] = ACTIONS(3382),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_DOT_DOT] = ACTIONS(3382),
    [anon_sym_with] = ACTIONS(3382),
    [anon_sym_AMP_AMP] = ACTIONS(3382),
    [anon_sym_PIPE_PIPE] = ACTIONS(3382),
    [anon_sym_QMARK_QMARK] = ACTIONS(3384),
    [anon_sym_as] = ACTIONS(3382),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2127] = {
    [sym__preprocessor_call] = STATE(2127),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_RBRACK] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(1989),
    [anon_sym_LPAREN] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_EQ_GT] = ACTIONS(1989),
    [anon_sym_where] = ACTIONS(1989),
    [anon_sym_QMARK] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1984),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1989),
    [anon_sym_switch] = ACTIONS(1989),
    [anon_sym_and] = ACTIONS(1989),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1989),
    [anon_sym_is] = ACTIONS(1989),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(1989),
    [anon_sym_join] = ACTIONS(1989),
    [anon_sym_on] = ACTIONS(1989),
    [anon_sym_equals] = ACTIONS(1989),
    [anon_sym_into] = ACTIONS(1989),
    [anon_sym_let] = ACTIONS(1989),
    [anon_sym_orderby] = ACTIONS(1989),
    [anon_sym_group] = ACTIONS(1989),
    [anon_sym_by] = ACTIONS(1989),
    [anon_sym_select] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1989),
    [anon_sym_with] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2128] = {
    [sym__preprocessor_call] = STATE(2128),
    [anon_sym_SEMI] = ACTIONS(3386),
    [anon_sym_EQ] = ACTIONS(3388),
    [anon_sym_LT] = ACTIONS(3388),
    [anon_sym_COMMA] = ACTIONS(3386),
    [anon_sym_GT] = ACTIONS(3388),
    [anon_sym_DOT] = ACTIONS(3388),
    [anon_sym_LBRACK] = ACTIONS(3386),
    [anon_sym_RBRACK] = ACTIONS(3386),
    [anon_sym_COLON] = ACTIONS(3386),
    [anon_sym_LPAREN] = ACTIONS(3386),
    [anon_sym_RPAREN] = ACTIONS(3386),
    [anon_sym_in] = ACTIONS(3388),
    [anon_sym_RBRACE] = ACTIONS(3386),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_where] = ACTIONS(3386),
    [anon_sym_QMARK] = ACTIONS(3388),
    [anon_sym_BANG] = ACTIONS(3388),
    [anon_sym_PLUS_PLUS] = ACTIONS(3386),
    [anon_sym_DASH_DASH] = ACTIONS(3386),
    [anon_sym_PLUS] = ACTIONS(3388),
    [anon_sym_DASH] = ACTIONS(3388),
    [anon_sym_STAR] = ACTIONS(3388),
    [anon_sym_SLASH] = ACTIONS(3388),
    [anon_sym_PERCENT] = ACTIONS(3388),
    [anon_sym_CARET] = ACTIONS(3388),
    [anon_sym_PIPE] = ACTIONS(3388),
    [anon_sym_AMP] = ACTIONS(3388),
    [anon_sym_LT_LT] = ACTIONS(3388),
    [anon_sym_GT_GT] = ACTIONS(3388),
    [anon_sym_EQ_EQ] = ACTIONS(3386),
    [anon_sym_BANG_EQ] = ACTIONS(3386),
    [anon_sym_GT_EQ] = ACTIONS(3386),
    [anon_sym_LT_EQ] = ACTIONS(3386),
    [anon_sym_switch] = ACTIONS(3386),
    [anon_sym_and] = ACTIONS(3386),
    [anon_sym_or] = ACTIONS(3388),
    [anon_sym_PLUS_EQ] = ACTIONS(3386),
    [anon_sym_DASH_EQ] = ACTIONS(3386),
    [anon_sym_STAR_EQ] = ACTIONS(3386),
    [anon_sym_SLASH_EQ] = ACTIONS(3386),
    [anon_sym_PERCENT_EQ] = ACTIONS(3386),
    [anon_sym_AMP_EQ] = ACTIONS(3386),
    [anon_sym_CARET_EQ] = ACTIONS(3386),
    [anon_sym_PIPE_EQ] = ACTIONS(3386),
    [anon_sym_LT_LT_EQ] = ACTIONS(3386),
    [anon_sym_GT_GT_EQ] = ACTIONS(3386),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3386),
    [anon_sym_is] = ACTIONS(3386),
    [anon_sym_DASH_GT] = ACTIONS(3386),
    [anon_sym_from] = ACTIONS(3386),
    [anon_sym_join] = ACTIONS(3386),
    [anon_sym_on] = ACTIONS(3386),
    [anon_sym_equals] = ACTIONS(3386),
    [anon_sym_into] = ACTIONS(3386),
    [anon_sym_let] = ACTIONS(3386),
    [anon_sym_orderby] = ACTIONS(3386),
    [anon_sym_group] = ACTIONS(3386),
    [anon_sym_by] = ACTIONS(3386),
    [anon_sym_select] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3386),
    [anon_sym_with] = ACTIONS(3386),
    [anon_sym_AMP_AMP] = ACTIONS(3386),
    [anon_sym_PIPE_PIPE] = ACTIONS(3386),
    [anon_sym_QMARK_QMARK] = ACTIONS(3388),
    [anon_sym_as] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2129] = {
    [sym__preprocessor_call] = STATE(2129),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym_EQ] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(3392),
    [anon_sym_COMMA] = ACTIONS(3390),
    [anon_sym_GT] = ACTIONS(3392),
    [anon_sym_DOT] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3390),
    [anon_sym_RBRACK] = ACTIONS(3390),
    [anon_sym_COLON] = ACTIONS(3390),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_in] = ACTIONS(3392),
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_EQ_GT] = ACTIONS(3390),
    [anon_sym_where] = ACTIONS(3390),
    [anon_sym_QMARK] = ACTIONS(3392),
    [anon_sym_BANG] = ACTIONS(3392),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3392),
    [anon_sym_SLASH] = ACTIONS(3392),
    [anon_sym_PERCENT] = ACTIONS(3392),
    [anon_sym_CARET] = ACTIONS(3392),
    [anon_sym_PIPE] = ACTIONS(3392),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3392),
    [anon_sym_GT_GT] = ACTIONS(3392),
    [anon_sym_EQ_EQ] = ACTIONS(3390),
    [anon_sym_BANG_EQ] = ACTIONS(3390),
    [anon_sym_GT_EQ] = ACTIONS(3390),
    [anon_sym_LT_EQ] = ACTIONS(3390),
    [anon_sym_switch] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(3390),
    [anon_sym_or] = ACTIONS(3392),
    [anon_sym_PLUS_EQ] = ACTIONS(3390),
    [anon_sym_DASH_EQ] = ACTIONS(3390),
    [anon_sym_STAR_EQ] = ACTIONS(3390),
    [anon_sym_SLASH_EQ] = ACTIONS(3390),
    [anon_sym_PERCENT_EQ] = ACTIONS(3390),
    [anon_sym_AMP_EQ] = ACTIONS(3390),
    [anon_sym_CARET_EQ] = ACTIONS(3390),
    [anon_sym_PIPE_EQ] = ACTIONS(3390),
    [anon_sym_LT_LT_EQ] = ACTIONS(3390),
    [anon_sym_GT_GT_EQ] = ACTIONS(3390),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3390),
    [anon_sym_is] = ACTIONS(3390),
    [anon_sym_DASH_GT] = ACTIONS(3390),
    [anon_sym_from] = ACTIONS(3390),
    [anon_sym_join] = ACTIONS(3390),
    [anon_sym_on] = ACTIONS(3390),
    [anon_sym_equals] = ACTIONS(3390),
    [anon_sym_into] = ACTIONS(3390),
    [anon_sym_let] = ACTIONS(3390),
    [anon_sym_orderby] = ACTIONS(3390),
    [anon_sym_group] = ACTIONS(3390),
    [anon_sym_by] = ACTIONS(3390),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_DOT_DOT] = ACTIONS(3390),
    [anon_sym_with] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_PIPE_PIPE] = ACTIONS(3390),
    [anon_sym_QMARK_QMARK] = ACTIONS(3392),
    [anon_sym_as] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2130] = {
    [sym__preprocessor_call] = STATE(2130),
    [anon_sym_SEMI] = ACTIONS(3394),
    [anon_sym_EQ] = ACTIONS(3396),
    [anon_sym_LT] = ACTIONS(3396),
    [anon_sym_COMMA] = ACTIONS(3394),
    [anon_sym_GT] = ACTIONS(3396),
    [anon_sym_DOT] = ACTIONS(3396),
    [anon_sym_LBRACK] = ACTIONS(3394),
    [anon_sym_RBRACK] = ACTIONS(3394),
    [anon_sym_COLON] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(3394),
    [anon_sym_RPAREN] = ACTIONS(3394),
    [anon_sym_in] = ACTIONS(3396),
    [anon_sym_RBRACE] = ACTIONS(3394),
    [anon_sym_EQ_GT] = ACTIONS(3394),
    [anon_sym_where] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(3396),
    [anon_sym_BANG] = ACTIONS(3396),
    [anon_sym_PLUS_PLUS] = ACTIONS(3394),
    [anon_sym_DASH_DASH] = ACTIONS(3394),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_STAR] = ACTIONS(3396),
    [anon_sym_SLASH] = ACTIONS(3396),
    [anon_sym_PERCENT] = ACTIONS(3396),
    [anon_sym_CARET] = ACTIONS(3396),
    [anon_sym_PIPE] = ACTIONS(3396),
    [anon_sym_AMP] = ACTIONS(3396),
    [anon_sym_LT_LT] = ACTIONS(3396),
    [anon_sym_GT_GT] = ACTIONS(3396),
    [anon_sym_EQ_EQ] = ACTIONS(3394),
    [anon_sym_BANG_EQ] = ACTIONS(3394),
    [anon_sym_GT_EQ] = ACTIONS(3394),
    [anon_sym_LT_EQ] = ACTIONS(3394),
    [anon_sym_switch] = ACTIONS(3394),
    [anon_sym_and] = ACTIONS(3394),
    [anon_sym_or] = ACTIONS(3396),
    [anon_sym_PLUS_EQ] = ACTIONS(3394),
    [anon_sym_DASH_EQ] = ACTIONS(3394),
    [anon_sym_STAR_EQ] = ACTIONS(3394),
    [anon_sym_SLASH_EQ] = ACTIONS(3394),
    [anon_sym_PERCENT_EQ] = ACTIONS(3394),
    [anon_sym_AMP_EQ] = ACTIONS(3394),
    [anon_sym_CARET_EQ] = ACTIONS(3394),
    [anon_sym_PIPE_EQ] = ACTIONS(3394),
    [anon_sym_LT_LT_EQ] = ACTIONS(3394),
    [anon_sym_GT_GT_EQ] = ACTIONS(3394),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3394),
    [anon_sym_is] = ACTIONS(3394),
    [anon_sym_DASH_GT] = ACTIONS(3394),
    [anon_sym_from] = ACTIONS(3394),
    [anon_sym_join] = ACTIONS(3394),
    [anon_sym_on] = ACTIONS(3394),
    [anon_sym_equals] = ACTIONS(3394),
    [anon_sym_into] = ACTIONS(3394),
    [anon_sym_let] = ACTIONS(3394),
    [anon_sym_orderby] = ACTIONS(3394),
    [anon_sym_group] = ACTIONS(3394),
    [anon_sym_by] = ACTIONS(3394),
    [anon_sym_select] = ACTIONS(3394),
    [anon_sym_DOT_DOT] = ACTIONS(3394),
    [anon_sym_with] = ACTIONS(3394),
    [anon_sym_AMP_AMP] = ACTIONS(3394),
    [anon_sym_PIPE_PIPE] = ACTIONS(3394),
    [anon_sym_QMARK_QMARK] = ACTIONS(3396),
    [anon_sym_as] = ACTIONS(3394),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2131] = {
    [sym__preprocessor_call] = STATE(2131),
    [anon_sym_SEMI] = ACTIONS(3398),
    [anon_sym_EQ] = ACTIONS(3400),
    [anon_sym_LT] = ACTIONS(3400),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_GT] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(3398),
    [anon_sym_RBRACK] = ACTIONS(3398),
    [anon_sym_COLON] = ACTIONS(3398),
    [anon_sym_LPAREN] = ACTIONS(3398),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [anon_sym_in] = ACTIONS(3400),
    [anon_sym_RBRACE] = ACTIONS(3398),
    [anon_sym_EQ_GT] = ACTIONS(3398),
    [anon_sym_where] = ACTIONS(3398),
    [anon_sym_QMARK] = ACTIONS(3400),
    [anon_sym_BANG] = ACTIONS(3400),
    [anon_sym_PLUS_PLUS] = ACTIONS(3398),
    [anon_sym_DASH_DASH] = ACTIONS(3398),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_STAR] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3400),
    [anon_sym_PERCENT] = ACTIONS(3400),
    [anon_sym_CARET] = ACTIONS(3400),
    [anon_sym_PIPE] = ACTIONS(3400),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_LT_LT] = ACTIONS(3400),
    [anon_sym_GT_GT] = ACTIONS(3400),
    [anon_sym_EQ_EQ] = ACTIONS(3398),
    [anon_sym_BANG_EQ] = ACTIONS(3398),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_LT_EQ] = ACTIONS(3398),
    [anon_sym_switch] = ACTIONS(3398),
    [anon_sym_and] = ACTIONS(3398),
    [anon_sym_or] = ACTIONS(3400),
    [anon_sym_PLUS_EQ] = ACTIONS(3398),
    [anon_sym_DASH_EQ] = ACTIONS(3398),
    [anon_sym_STAR_EQ] = ACTIONS(3398),
    [anon_sym_SLASH_EQ] = ACTIONS(3398),
    [anon_sym_PERCENT_EQ] = ACTIONS(3398),
    [anon_sym_AMP_EQ] = ACTIONS(3398),
    [anon_sym_CARET_EQ] = ACTIONS(3398),
    [anon_sym_PIPE_EQ] = ACTIONS(3398),
    [anon_sym_LT_LT_EQ] = ACTIONS(3398),
    [anon_sym_GT_GT_EQ] = ACTIONS(3398),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3398),
    [anon_sym_is] = ACTIONS(3398),
    [anon_sym_DASH_GT] = ACTIONS(3398),
    [anon_sym_from] = ACTIONS(3398),
    [anon_sym_join] = ACTIONS(3398),
    [anon_sym_on] = ACTIONS(3398),
    [anon_sym_equals] = ACTIONS(3398),
    [anon_sym_into] = ACTIONS(3398),
    [anon_sym_let] = ACTIONS(3398),
    [anon_sym_orderby] = ACTIONS(3398),
    [anon_sym_group] = ACTIONS(3398),
    [anon_sym_by] = ACTIONS(3398),
    [anon_sym_select] = ACTIONS(3398),
    [anon_sym_DOT_DOT] = ACTIONS(3398),
    [anon_sym_with] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(3398),
    [anon_sym_PIPE_PIPE] = ACTIONS(3398),
    [anon_sym_QMARK_QMARK] = ACTIONS(3400),
    [anon_sym_as] = ACTIONS(3398),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2132] = {
    [sym__preprocessor_call] = STATE(2132),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym_EQ] = ACTIONS(3404),
    [anon_sym_LT] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_GT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_RBRACK] = ACTIONS(3402),
    [anon_sym_COLON] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_RPAREN] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3404),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_EQ_GT] = ACTIONS(3402),
    [anon_sym_where] = ACTIONS(3402),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_BANG] = ACTIONS(3404),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_STAR] = ACTIONS(3404),
    [anon_sym_SLASH] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_CARET] = ACTIONS(3404),
    [anon_sym_PIPE] = ACTIONS(3404),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LT_LT] = ACTIONS(3404),
    [anon_sym_GT_GT] = ACTIONS(3404),
    [anon_sym_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_switch] = ACTIONS(3402),
    [anon_sym_and] = ACTIONS(3402),
    [anon_sym_or] = ACTIONS(3404),
    [anon_sym_PLUS_EQ] = ACTIONS(3402),
    [anon_sym_DASH_EQ] = ACTIONS(3402),
    [anon_sym_STAR_EQ] = ACTIONS(3402),
    [anon_sym_SLASH_EQ] = ACTIONS(3402),
    [anon_sym_PERCENT_EQ] = ACTIONS(3402),
    [anon_sym_AMP_EQ] = ACTIONS(3402),
    [anon_sym_CARET_EQ] = ACTIONS(3402),
    [anon_sym_PIPE_EQ] = ACTIONS(3402),
    [anon_sym_LT_LT_EQ] = ACTIONS(3402),
    [anon_sym_GT_GT_EQ] = ACTIONS(3402),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3402),
    [anon_sym_is] = ACTIONS(3402),
    [anon_sym_DASH_GT] = ACTIONS(3402),
    [anon_sym_from] = ACTIONS(3402),
    [anon_sym_join] = ACTIONS(3402),
    [anon_sym_on] = ACTIONS(3402),
    [anon_sym_equals] = ACTIONS(3402),
    [anon_sym_into] = ACTIONS(3402),
    [anon_sym_let] = ACTIONS(3402),
    [anon_sym_orderby] = ACTIONS(3402),
    [anon_sym_group] = ACTIONS(3402),
    [anon_sym_by] = ACTIONS(3402),
    [anon_sym_select] = ACTIONS(3402),
    [anon_sym_DOT_DOT] = ACTIONS(3402),
    [anon_sym_with] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_PIPE_PIPE] = ACTIONS(3402),
    [anon_sym_QMARK_QMARK] = ACTIONS(3404),
    [anon_sym_as] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2133] = {
    [sym__preprocessor_call] = STATE(2133),
    [anon_sym_SEMI] = ACTIONS(3406),
    [anon_sym_EQ] = ACTIONS(3408),
    [anon_sym_LT] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_GT] = ACTIONS(3408),
    [anon_sym_DOT] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(3406),
    [anon_sym_RBRACK] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3406),
    [anon_sym_RPAREN] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3408),
    [anon_sym_RBRACE] = ACTIONS(3406),
    [anon_sym_EQ_GT] = ACTIONS(3406),
    [anon_sym_where] = ACTIONS(3406),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_BANG] = ACTIONS(3408),
    [anon_sym_PLUS_PLUS] = ACTIONS(3406),
    [anon_sym_DASH_DASH] = ACTIONS(3406),
    [anon_sym_PLUS] = ACTIONS(3408),
    [anon_sym_DASH] = ACTIONS(3408),
    [anon_sym_STAR] = ACTIONS(3408),
    [anon_sym_SLASH] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3408),
    [anon_sym_CARET] = ACTIONS(3408),
    [anon_sym_PIPE] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3408),
    [anon_sym_LT_LT] = ACTIONS(3408),
    [anon_sym_GT_GT] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3406),
    [anon_sym_BANG_EQ] = ACTIONS(3406),
    [anon_sym_GT_EQ] = ACTIONS(3406),
    [anon_sym_LT_EQ] = ACTIONS(3406),
    [anon_sym_switch] = ACTIONS(3406),
    [anon_sym_and] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3406),
    [anon_sym_DASH_EQ] = ACTIONS(3406),
    [anon_sym_STAR_EQ] = ACTIONS(3406),
    [anon_sym_SLASH_EQ] = ACTIONS(3406),
    [anon_sym_PERCENT_EQ] = ACTIONS(3406),
    [anon_sym_AMP_EQ] = ACTIONS(3406),
    [anon_sym_CARET_EQ] = ACTIONS(3406),
    [anon_sym_PIPE_EQ] = ACTIONS(3406),
    [anon_sym_LT_LT_EQ] = ACTIONS(3406),
    [anon_sym_GT_GT_EQ] = ACTIONS(3406),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3406),
    [anon_sym_is] = ACTIONS(3406),
    [anon_sym_DASH_GT] = ACTIONS(3406),
    [anon_sym_from] = ACTIONS(3406),
    [anon_sym_join] = ACTIONS(3406),
    [anon_sym_on] = ACTIONS(3406),
    [anon_sym_equals] = ACTIONS(3406),
    [anon_sym_into] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_orderby] = ACTIONS(3406),
    [anon_sym_group] = ACTIONS(3406),
    [anon_sym_by] = ACTIONS(3406),
    [anon_sym_select] = ACTIONS(3406),
    [anon_sym_DOT_DOT] = ACTIONS(3406),
    [anon_sym_with] = ACTIONS(3406),
    [anon_sym_AMP_AMP] = ACTIONS(3406),
    [anon_sym_PIPE_PIPE] = ACTIONS(3406),
    [anon_sym_QMARK_QMARK] = ACTIONS(3408),
    [anon_sym_as] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2134] = {
    [sym__preprocessor_call] = STATE(2134),
    [anon_sym_SEMI] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3412),
    [anon_sym_LT] = ACTIONS(3412),
    [anon_sym_COMMA] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3412),
    [anon_sym_DOT] = ACTIONS(3412),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_RBRACK] = ACTIONS(3410),
    [anon_sym_COLON] = ACTIONS(3410),
    [anon_sym_LPAREN] = ACTIONS(3410),
    [anon_sym_RPAREN] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3412),
    [anon_sym_RBRACE] = ACTIONS(3410),
    [anon_sym_EQ_GT] = ACTIONS(3410),
    [anon_sym_where] = ACTIONS(3410),
    [anon_sym_QMARK] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [anon_sym_PLUS_PLUS] = ACTIONS(3410),
    [anon_sym_DASH_DASH] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3412),
    [anon_sym_DASH] = ACTIONS(3412),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_SLASH] = ACTIONS(3412),
    [anon_sym_PERCENT] = ACTIONS(3412),
    [anon_sym_CARET] = ACTIONS(3412),
    [anon_sym_PIPE] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3412),
    [anon_sym_LT_LT] = ACTIONS(3412),
    [anon_sym_GT_GT] = ACTIONS(3412),
    [anon_sym_EQ_EQ] = ACTIONS(3410),
    [anon_sym_BANG_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3410),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3410),
    [anon_sym_and] = ACTIONS(3410),
    [anon_sym_or] = ACTIONS(3412),
    [anon_sym_PLUS_EQ] = ACTIONS(3410),
    [anon_sym_DASH_EQ] = ACTIONS(3410),
    [anon_sym_STAR_EQ] = ACTIONS(3410),
    [anon_sym_SLASH_EQ] = ACTIONS(3410),
    [anon_sym_PERCENT_EQ] = ACTIONS(3410),
    [anon_sym_AMP_EQ] = ACTIONS(3410),
    [anon_sym_CARET_EQ] = ACTIONS(3410),
    [anon_sym_PIPE_EQ] = ACTIONS(3410),
    [anon_sym_LT_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_GT_EQ] = ACTIONS(3410),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3410),
    [anon_sym_is] = ACTIONS(3410),
    [anon_sym_DASH_GT] = ACTIONS(3410),
    [anon_sym_from] = ACTIONS(3410),
    [anon_sym_join] = ACTIONS(3410),
    [anon_sym_on] = ACTIONS(3410),
    [anon_sym_equals] = ACTIONS(3410),
    [anon_sym_into] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_orderby] = ACTIONS(3410),
    [anon_sym_group] = ACTIONS(3410),
    [anon_sym_by] = ACTIONS(3410),
    [anon_sym_select] = ACTIONS(3410),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_with] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_QMARK_QMARK] = ACTIONS(3412),
    [anon_sym_as] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2135] = {
    [sym__preprocessor_call] = STATE(2135),
    [anon_sym_SEMI] = ACTIONS(3414),
    [anon_sym_EQ] = ACTIONS(3416),
    [anon_sym_LT] = ACTIONS(3416),
    [anon_sym_COMMA] = ACTIONS(3414),
    [anon_sym_GT] = ACTIONS(3416),
    [anon_sym_DOT] = ACTIONS(3416),
    [anon_sym_LBRACK] = ACTIONS(3414),
    [anon_sym_RBRACK] = ACTIONS(3414),
    [anon_sym_COLON] = ACTIONS(3414),
    [anon_sym_LPAREN] = ACTIONS(3414),
    [anon_sym_RPAREN] = ACTIONS(3414),
    [anon_sym_in] = ACTIONS(3416),
    [anon_sym_RBRACE] = ACTIONS(3414),
    [anon_sym_EQ_GT] = ACTIONS(3414),
    [anon_sym_where] = ACTIONS(3414),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3416),
    [anon_sym_PLUS_PLUS] = ACTIONS(3414),
    [anon_sym_DASH_DASH] = ACTIONS(3414),
    [anon_sym_PLUS] = ACTIONS(3416),
    [anon_sym_DASH] = ACTIONS(3416),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_SLASH] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3416),
    [anon_sym_CARET] = ACTIONS(3416),
    [anon_sym_PIPE] = ACTIONS(3416),
    [anon_sym_AMP] = ACTIONS(3416),
    [anon_sym_LT_LT] = ACTIONS(3416),
    [anon_sym_GT_GT] = ACTIONS(3416),
    [anon_sym_EQ_EQ] = ACTIONS(3414),
    [anon_sym_BANG_EQ] = ACTIONS(3414),
    [anon_sym_GT_EQ] = ACTIONS(3414),
    [anon_sym_LT_EQ] = ACTIONS(3414),
    [anon_sym_switch] = ACTIONS(3414),
    [anon_sym_and] = ACTIONS(3414),
    [anon_sym_or] = ACTIONS(3416),
    [anon_sym_PLUS_EQ] = ACTIONS(3414),
    [anon_sym_DASH_EQ] = ACTIONS(3414),
    [anon_sym_STAR_EQ] = ACTIONS(3414),
    [anon_sym_SLASH_EQ] = ACTIONS(3414),
    [anon_sym_PERCENT_EQ] = ACTIONS(3414),
    [anon_sym_AMP_EQ] = ACTIONS(3414),
    [anon_sym_CARET_EQ] = ACTIONS(3414),
    [anon_sym_PIPE_EQ] = ACTIONS(3414),
    [anon_sym_LT_LT_EQ] = ACTIONS(3414),
    [anon_sym_GT_GT_EQ] = ACTIONS(3414),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3414),
    [anon_sym_is] = ACTIONS(3414),
    [anon_sym_DASH_GT] = ACTIONS(3414),
    [anon_sym_from] = ACTIONS(3414),
    [anon_sym_join] = ACTIONS(3414),
    [anon_sym_on] = ACTIONS(3414),
    [anon_sym_equals] = ACTIONS(3414),
    [anon_sym_into] = ACTIONS(3414),
    [anon_sym_let] = ACTIONS(3414),
    [anon_sym_orderby] = ACTIONS(3414),
    [anon_sym_group] = ACTIONS(3414),
    [anon_sym_by] = ACTIONS(3414),
    [anon_sym_select] = ACTIONS(3414),
    [anon_sym_DOT_DOT] = ACTIONS(3414),
    [anon_sym_with] = ACTIONS(3414),
    [anon_sym_AMP_AMP] = ACTIONS(3414),
    [anon_sym_PIPE_PIPE] = ACTIONS(3414),
    [anon_sym_QMARK_QMARK] = ACTIONS(3416),
    [anon_sym_as] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2136] = {
    [sym__preprocessor_call] = STATE(2136),
    [anon_sym_SEMI] = ACTIONS(3418),
    [anon_sym_EQ] = ACTIONS(3420),
    [anon_sym_LT] = ACTIONS(3420),
    [anon_sym_COMMA] = ACTIONS(3418),
    [anon_sym_GT] = ACTIONS(3420),
    [anon_sym_DOT] = ACTIONS(3420),
    [anon_sym_LBRACK] = ACTIONS(3418),
    [anon_sym_RBRACK] = ACTIONS(3418),
    [anon_sym_COLON] = ACTIONS(3418),
    [anon_sym_LPAREN] = ACTIONS(3418),
    [anon_sym_RPAREN] = ACTIONS(3418),
    [anon_sym_in] = ACTIONS(3420),
    [anon_sym_RBRACE] = ACTIONS(3418),
    [anon_sym_EQ_GT] = ACTIONS(3418),
    [anon_sym_where] = ACTIONS(3418),
    [anon_sym_QMARK] = ACTIONS(3420),
    [anon_sym_BANG] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3418),
    [anon_sym_DASH_DASH] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3420),
    [anon_sym_DASH] = ACTIONS(3420),
    [anon_sym_STAR] = ACTIONS(3420),
    [anon_sym_SLASH] = ACTIONS(3420),
    [anon_sym_PERCENT] = ACTIONS(3420),
    [anon_sym_CARET] = ACTIONS(3420),
    [anon_sym_PIPE] = ACTIONS(3420),
    [anon_sym_AMP] = ACTIONS(3420),
    [anon_sym_LT_LT] = ACTIONS(3420),
    [anon_sym_GT_GT] = ACTIONS(3420),
    [anon_sym_EQ_EQ] = ACTIONS(3418),
    [anon_sym_BANG_EQ] = ACTIONS(3418),
    [anon_sym_GT_EQ] = ACTIONS(3418),
    [anon_sym_LT_EQ] = ACTIONS(3418),
    [anon_sym_switch] = ACTIONS(3418),
    [anon_sym_and] = ACTIONS(3418),
    [anon_sym_or] = ACTIONS(3420),
    [anon_sym_PLUS_EQ] = ACTIONS(3418),
    [anon_sym_DASH_EQ] = ACTIONS(3418),
    [anon_sym_STAR_EQ] = ACTIONS(3418),
    [anon_sym_SLASH_EQ] = ACTIONS(3418),
    [anon_sym_PERCENT_EQ] = ACTIONS(3418),
    [anon_sym_AMP_EQ] = ACTIONS(3418),
    [anon_sym_CARET_EQ] = ACTIONS(3418),
    [anon_sym_PIPE_EQ] = ACTIONS(3418),
    [anon_sym_LT_LT_EQ] = ACTIONS(3418),
    [anon_sym_GT_GT_EQ] = ACTIONS(3418),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3418),
    [anon_sym_is] = ACTIONS(3418),
    [anon_sym_DASH_GT] = ACTIONS(3418),
    [anon_sym_from] = ACTIONS(3418),
    [anon_sym_join] = ACTIONS(3418),
    [anon_sym_on] = ACTIONS(3418),
    [anon_sym_equals] = ACTIONS(3418),
    [anon_sym_into] = ACTIONS(3418),
    [anon_sym_let] = ACTIONS(3418),
    [anon_sym_orderby] = ACTIONS(3418),
    [anon_sym_group] = ACTIONS(3418),
    [anon_sym_by] = ACTIONS(3418),
    [anon_sym_select] = ACTIONS(3418),
    [anon_sym_DOT_DOT] = ACTIONS(3418),
    [anon_sym_with] = ACTIONS(3418),
    [anon_sym_AMP_AMP] = ACTIONS(3418),
    [anon_sym_PIPE_PIPE] = ACTIONS(3418),
    [anon_sym_QMARK_QMARK] = ACTIONS(3420),
    [anon_sym_as] = ACTIONS(3418),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2137] = {
    [sym__preprocessor_call] = STATE(2137),
    [anon_sym_SEMI] = ACTIONS(3422),
    [anon_sym_EQ] = ACTIONS(3424),
    [anon_sym_LT] = ACTIONS(3424),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_GT] = ACTIONS(3424),
    [anon_sym_DOT] = ACTIONS(3424),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_RBRACK] = ACTIONS(3422),
    [anon_sym_COLON] = ACTIONS(3422),
    [anon_sym_LPAREN] = ACTIONS(3422),
    [anon_sym_RPAREN] = ACTIONS(3422),
    [anon_sym_in] = ACTIONS(3424),
    [anon_sym_RBRACE] = ACTIONS(3422),
    [anon_sym_EQ_GT] = ACTIONS(3422),
    [anon_sym_where] = ACTIONS(3422),
    [anon_sym_QMARK] = ACTIONS(3424),
    [anon_sym_BANG] = ACTIONS(3424),
    [anon_sym_PLUS_PLUS] = ACTIONS(3422),
    [anon_sym_DASH_DASH] = ACTIONS(3422),
    [anon_sym_PLUS] = ACTIONS(3424),
    [anon_sym_DASH] = ACTIONS(3424),
    [anon_sym_STAR] = ACTIONS(3424),
    [anon_sym_SLASH] = ACTIONS(3424),
    [anon_sym_PERCENT] = ACTIONS(3424),
    [anon_sym_CARET] = ACTIONS(3424),
    [anon_sym_PIPE] = ACTIONS(3424),
    [anon_sym_AMP] = ACTIONS(3424),
    [anon_sym_LT_LT] = ACTIONS(3424),
    [anon_sym_GT_GT] = ACTIONS(3424),
    [anon_sym_EQ_EQ] = ACTIONS(3422),
    [anon_sym_BANG_EQ] = ACTIONS(3422),
    [anon_sym_GT_EQ] = ACTIONS(3422),
    [anon_sym_LT_EQ] = ACTIONS(3422),
    [anon_sym_switch] = ACTIONS(3422),
    [anon_sym_and] = ACTIONS(3422),
    [anon_sym_or] = ACTIONS(3424),
    [anon_sym_PLUS_EQ] = ACTIONS(3422),
    [anon_sym_DASH_EQ] = ACTIONS(3422),
    [anon_sym_STAR_EQ] = ACTIONS(3422),
    [anon_sym_SLASH_EQ] = ACTIONS(3422),
    [anon_sym_PERCENT_EQ] = ACTIONS(3422),
    [anon_sym_AMP_EQ] = ACTIONS(3422),
    [anon_sym_CARET_EQ] = ACTIONS(3422),
    [anon_sym_PIPE_EQ] = ACTIONS(3422),
    [anon_sym_LT_LT_EQ] = ACTIONS(3422),
    [anon_sym_GT_GT_EQ] = ACTIONS(3422),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3422),
    [anon_sym_is] = ACTIONS(3422),
    [anon_sym_DASH_GT] = ACTIONS(3422),
    [anon_sym_from] = ACTIONS(3422),
    [anon_sym_join] = ACTIONS(3422),
    [anon_sym_on] = ACTIONS(3422),
    [anon_sym_equals] = ACTIONS(3422),
    [anon_sym_into] = ACTIONS(3422),
    [anon_sym_let] = ACTIONS(3422),
    [anon_sym_orderby] = ACTIONS(3422),
    [anon_sym_group] = ACTIONS(3422),
    [anon_sym_by] = ACTIONS(3422),
    [anon_sym_select] = ACTIONS(3422),
    [anon_sym_DOT_DOT] = ACTIONS(3422),
    [anon_sym_with] = ACTIONS(3422),
    [anon_sym_AMP_AMP] = ACTIONS(3422),
    [anon_sym_PIPE_PIPE] = ACTIONS(3422),
    [anon_sym_QMARK_QMARK] = ACTIONS(3424),
    [anon_sym_as] = ACTIONS(3422),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2138] = {
    [sym__preprocessor_call] = STATE(2138),
    [anon_sym_SEMI] = ACTIONS(3426),
    [anon_sym_EQ] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3428),
    [anon_sym_COMMA] = ACTIONS(3426),
    [anon_sym_GT] = ACTIONS(3428),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_LBRACK] = ACTIONS(3426),
    [anon_sym_RBRACK] = ACTIONS(3426),
    [anon_sym_COLON] = ACTIONS(3426),
    [anon_sym_LPAREN] = ACTIONS(3426),
    [anon_sym_RPAREN] = ACTIONS(3426),
    [anon_sym_in] = ACTIONS(3428),
    [anon_sym_RBRACE] = ACTIONS(3426),
    [anon_sym_EQ_GT] = ACTIONS(3426),
    [anon_sym_where] = ACTIONS(3426),
    [anon_sym_QMARK] = ACTIONS(3428),
    [anon_sym_BANG] = ACTIONS(3428),
    [anon_sym_PLUS_PLUS] = ACTIONS(3426),
    [anon_sym_DASH_DASH] = ACTIONS(3426),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3428),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3428),
    [anon_sym_CARET] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(3428),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_LT_LT] = ACTIONS(3428),
    [anon_sym_GT_GT] = ACTIONS(3428),
    [anon_sym_EQ_EQ] = ACTIONS(3426),
    [anon_sym_BANG_EQ] = ACTIONS(3426),
    [anon_sym_GT_EQ] = ACTIONS(3426),
    [anon_sym_LT_EQ] = ACTIONS(3426),
    [anon_sym_switch] = ACTIONS(3426),
    [anon_sym_and] = ACTIONS(3426),
    [anon_sym_or] = ACTIONS(3428),
    [anon_sym_PLUS_EQ] = ACTIONS(3426),
    [anon_sym_DASH_EQ] = ACTIONS(3426),
    [anon_sym_STAR_EQ] = ACTIONS(3426),
    [anon_sym_SLASH_EQ] = ACTIONS(3426),
    [anon_sym_PERCENT_EQ] = ACTIONS(3426),
    [anon_sym_AMP_EQ] = ACTIONS(3426),
    [anon_sym_CARET_EQ] = ACTIONS(3426),
    [anon_sym_PIPE_EQ] = ACTIONS(3426),
    [anon_sym_LT_LT_EQ] = ACTIONS(3426),
    [anon_sym_GT_GT_EQ] = ACTIONS(3426),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3426),
    [anon_sym_is] = ACTIONS(3426),
    [anon_sym_DASH_GT] = ACTIONS(3426),
    [anon_sym_from] = ACTIONS(3426),
    [anon_sym_join] = ACTIONS(3426),
    [anon_sym_on] = ACTIONS(3426),
    [anon_sym_equals] = ACTIONS(3426),
    [anon_sym_into] = ACTIONS(3426),
    [anon_sym_let] = ACTIONS(3426),
    [anon_sym_orderby] = ACTIONS(3426),
    [anon_sym_group] = ACTIONS(3426),
    [anon_sym_by] = ACTIONS(3426),
    [anon_sym_select] = ACTIONS(3426),
    [anon_sym_DOT_DOT] = ACTIONS(3426),
    [anon_sym_with] = ACTIONS(3426),
    [anon_sym_AMP_AMP] = ACTIONS(3426),
    [anon_sym_PIPE_PIPE] = ACTIONS(3426),
    [anon_sym_QMARK_QMARK] = ACTIONS(3428),
    [anon_sym_as] = ACTIONS(3426),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2139] = {
    [sym__preprocessor_call] = STATE(2139),
    [anon_sym_SEMI] = ACTIONS(3430),
    [anon_sym_EQ] = ACTIONS(3432),
    [anon_sym_LT] = ACTIONS(3432),
    [anon_sym_COMMA] = ACTIONS(3430),
    [anon_sym_GT] = ACTIONS(3432),
    [anon_sym_DOT] = ACTIONS(3432),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [anon_sym_RBRACK] = ACTIONS(3430),
    [anon_sym_COLON] = ACTIONS(3430),
    [anon_sym_LPAREN] = ACTIONS(3430),
    [anon_sym_RPAREN] = ACTIONS(3430),
    [anon_sym_in] = ACTIONS(3432),
    [anon_sym_RBRACE] = ACTIONS(3430),
    [anon_sym_EQ_GT] = ACTIONS(3430),
    [anon_sym_where] = ACTIONS(3430),
    [anon_sym_QMARK] = ACTIONS(3432),
    [anon_sym_BANG] = ACTIONS(3432),
    [anon_sym_PLUS_PLUS] = ACTIONS(3430),
    [anon_sym_DASH_DASH] = ACTIONS(3430),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_DASH] = ACTIONS(3432),
    [anon_sym_STAR] = ACTIONS(3432),
    [anon_sym_SLASH] = ACTIONS(3432),
    [anon_sym_PERCENT] = ACTIONS(3432),
    [anon_sym_CARET] = ACTIONS(3432),
    [anon_sym_PIPE] = ACTIONS(3432),
    [anon_sym_AMP] = ACTIONS(3432),
    [anon_sym_LT_LT] = ACTIONS(3432),
    [anon_sym_GT_GT] = ACTIONS(3432),
    [anon_sym_EQ_EQ] = ACTIONS(3430),
    [anon_sym_BANG_EQ] = ACTIONS(3430),
    [anon_sym_GT_EQ] = ACTIONS(3430),
    [anon_sym_LT_EQ] = ACTIONS(3430),
    [anon_sym_switch] = ACTIONS(3430),
    [anon_sym_and] = ACTIONS(3430),
    [anon_sym_or] = ACTIONS(3432),
    [anon_sym_PLUS_EQ] = ACTIONS(3430),
    [anon_sym_DASH_EQ] = ACTIONS(3430),
    [anon_sym_STAR_EQ] = ACTIONS(3430),
    [anon_sym_SLASH_EQ] = ACTIONS(3430),
    [anon_sym_PERCENT_EQ] = ACTIONS(3430),
    [anon_sym_AMP_EQ] = ACTIONS(3430),
    [anon_sym_CARET_EQ] = ACTIONS(3430),
    [anon_sym_PIPE_EQ] = ACTIONS(3430),
    [anon_sym_LT_LT_EQ] = ACTIONS(3430),
    [anon_sym_GT_GT_EQ] = ACTIONS(3430),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3430),
    [anon_sym_is] = ACTIONS(3430),
    [anon_sym_DASH_GT] = ACTIONS(3430),
    [anon_sym_from] = ACTIONS(3430),
    [anon_sym_join] = ACTIONS(3430),
    [anon_sym_on] = ACTIONS(3430),
    [anon_sym_equals] = ACTIONS(3430),
    [anon_sym_into] = ACTIONS(3430),
    [anon_sym_let] = ACTIONS(3430),
    [anon_sym_orderby] = ACTIONS(3430),
    [anon_sym_group] = ACTIONS(3430),
    [anon_sym_by] = ACTIONS(3430),
    [anon_sym_select] = ACTIONS(3430),
    [anon_sym_DOT_DOT] = ACTIONS(3430),
    [anon_sym_with] = ACTIONS(3430),
    [anon_sym_AMP_AMP] = ACTIONS(3430),
    [anon_sym_PIPE_PIPE] = ACTIONS(3430),
    [anon_sym_QMARK_QMARK] = ACTIONS(3432),
    [anon_sym_as] = ACTIONS(3430),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2140] = {
    [sym__preprocessor_call] = STATE(2140),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_EQ] = ACTIONS(3436),
    [anon_sym_LT] = ACTIONS(3436),
    [anon_sym_COMMA] = ACTIONS(3434),
    [anon_sym_GT] = ACTIONS(3436),
    [anon_sym_DOT] = ACTIONS(3436),
    [anon_sym_LBRACK] = ACTIONS(3434),
    [anon_sym_RBRACK] = ACTIONS(3434),
    [anon_sym_COLON] = ACTIONS(3434),
    [anon_sym_LPAREN] = ACTIONS(3434),
    [anon_sym_RPAREN] = ACTIONS(3434),
    [anon_sym_in] = ACTIONS(3436),
    [anon_sym_RBRACE] = ACTIONS(3434),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [anon_sym_where] = ACTIONS(3434),
    [anon_sym_QMARK] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3436),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [anon_sym_PLUS] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3436),
    [anon_sym_STAR] = ACTIONS(3436),
    [anon_sym_SLASH] = ACTIONS(3436),
    [anon_sym_PERCENT] = ACTIONS(3436),
    [anon_sym_CARET] = ACTIONS(3436),
    [anon_sym_PIPE] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3436),
    [anon_sym_LT_LT] = ACTIONS(3436),
    [anon_sym_GT_GT] = ACTIONS(3436),
    [anon_sym_EQ_EQ] = ACTIONS(3434),
    [anon_sym_BANG_EQ] = ACTIONS(3434),
    [anon_sym_GT_EQ] = ACTIONS(3434),
    [anon_sym_LT_EQ] = ACTIONS(3434),
    [anon_sym_switch] = ACTIONS(3434),
    [anon_sym_and] = ACTIONS(3434),
    [anon_sym_or] = ACTIONS(3436),
    [anon_sym_PLUS_EQ] = ACTIONS(3434),
    [anon_sym_DASH_EQ] = ACTIONS(3434),
    [anon_sym_STAR_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_PERCENT_EQ] = ACTIONS(3434),
    [anon_sym_AMP_EQ] = ACTIONS(3434),
    [anon_sym_CARET_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_LT_LT_EQ] = ACTIONS(3434),
    [anon_sym_GT_GT_EQ] = ACTIONS(3434),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3434),
    [anon_sym_is] = ACTIONS(3434),
    [anon_sym_DASH_GT] = ACTIONS(3434),
    [anon_sym_from] = ACTIONS(3434),
    [anon_sym_join] = ACTIONS(3434),
    [anon_sym_on] = ACTIONS(3434),
    [anon_sym_equals] = ACTIONS(3434),
    [anon_sym_into] = ACTIONS(3434),
    [anon_sym_let] = ACTIONS(3434),
    [anon_sym_orderby] = ACTIONS(3434),
    [anon_sym_group] = ACTIONS(3434),
    [anon_sym_by] = ACTIONS(3434),
    [anon_sym_select] = ACTIONS(3434),
    [anon_sym_DOT_DOT] = ACTIONS(3434),
    [anon_sym_with] = ACTIONS(3434),
    [anon_sym_AMP_AMP] = ACTIONS(3434),
    [anon_sym_PIPE_PIPE] = ACTIONS(3434),
    [anon_sym_QMARK_QMARK] = ACTIONS(3436),
    [anon_sym_as] = ACTIONS(3434),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2141] = {
    [sym__preprocessor_call] = STATE(2141),
    [anon_sym_SEMI] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_COMMA] = ACTIONS(3438),
    [anon_sym_GT] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_RBRACK] = ACTIONS(3438),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_RPAREN] = ACTIONS(3438),
    [anon_sym_in] = ACTIONS(3440),
    [anon_sym_RBRACE] = ACTIONS(3438),
    [anon_sym_EQ_GT] = ACTIONS(3438),
    [anon_sym_where] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3440),
    [anon_sym_BANG] = ACTIONS(3440),
    [anon_sym_PLUS_PLUS] = ACTIONS(3438),
    [anon_sym_DASH_DASH] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_DASH] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_CARET] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_GT_GT] = ACTIONS(3440),
    [anon_sym_EQ_EQ] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_GT_EQ] = ACTIONS(3438),
    [anon_sym_LT_EQ] = ACTIONS(3438),
    [anon_sym_switch] = ACTIONS(3438),
    [anon_sym_and] = ACTIONS(3438),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_PLUS_EQ] = ACTIONS(3438),
    [anon_sym_DASH_EQ] = ACTIONS(3438),
    [anon_sym_STAR_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_PERCENT_EQ] = ACTIONS(3438),
    [anon_sym_AMP_EQ] = ACTIONS(3438),
    [anon_sym_CARET_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_LT_LT_EQ] = ACTIONS(3438),
    [anon_sym_GT_GT_EQ] = ACTIONS(3438),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3438),
    [anon_sym_is] = ACTIONS(3438),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_from] = ACTIONS(3438),
    [anon_sym_join] = ACTIONS(3438),
    [anon_sym_on] = ACTIONS(3438),
    [anon_sym_equals] = ACTIONS(3438),
    [anon_sym_into] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_orderby] = ACTIONS(3438),
    [anon_sym_group] = ACTIONS(3438),
    [anon_sym_by] = ACTIONS(3438),
    [anon_sym_select] = ACTIONS(3438),
    [anon_sym_DOT_DOT] = ACTIONS(3438),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_QMARK_QMARK] = ACTIONS(3440),
    [anon_sym_as] = ACTIONS(3438),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2142] = {
    [sym__preprocessor_call] = STATE(2142),
    [anon_sym_SEMI] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_COMMA] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3444),
    [anon_sym_DOT] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_RBRACK] = ACTIONS(3442),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_RPAREN] = ACTIONS(3442),
    [anon_sym_in] = ACTIONS(3444),
    [anon_sym_RBRACE] = ACTIONS(3442),
    [anon_sym_EQ_GT] = ACTIONS(3442),
    [anon_sym_where] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_BANG] = ACTIONS(3444),
    [anon_sym_PLUS_PLUS] = ACTIONS(3442),
    [anon_sym_DASH_DASH] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_DASH] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3444),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [anon_sym_CARET] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3444),
    [anon_sym_LT_LT] = ACTIONS(3444),
    [anon_sym_GT_GT] = ACTIONS(3444),
    [anon_sym_EQ_EQ] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3442),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_switch] = ACTIONS(3442),
    [anon_sym_and] = ACTIONS(3442),
    [anon_sym_or] = ACTIONS(3444),
    [anon_sym_PLUS_EQ] = ACTIONS(3442),
    [anon_sym_DASH_EQ] = ACTIONS(3442),
    [anon_sym_STAR_EQ] = ACTIONS(3442),
    [anon_sym_SLASH_EQ] = ACTIONS(3442),
    [anon_sym_PERCENT_EQ] = ACTIONS(3442),
    [anon_sym_AMP_EQ] = ACTIONS(3442),
    [anon_sym_CARET_EQ] = ACTIONS(3442),
    [anon_sym_PIPE_EQ] = ACTIONS(3442),
    [anon_sym_LT_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT_GT_EQ] = ACTIONS(3442),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3442),
    [anon_sym_is] = ACTIONS(3442),
    [anon_sym_DASH_GT] = ACTIONS(3442),
    [anon_sym_from] = ACTIONS(3442),
    [anon_sym_join] = ACTIONS(3442),
    [anon_sym_on] = ACTIONS(3442),
    [anon_sym_equals] = ACTIONS(3442),
    [anon_sym_into] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_orderby] = ACTIONS(3442),
    [anon_sym_group] = ACTIONS(3442),
    [anon_sym_by] = ACTIONS(3442),
    [anon_sym_select] = ACTIONS(3442),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_with] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_QMARK_QMARK] = ACTIONS(3444),
    [anon_sym_as] = ACTIONS(3442),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2143] = {
    [sym__preprocessor_call] = STATE(2143),
    [anon_sym_SEMI] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(3448),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_COMMA] = ACTIONS(3446),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_DOT] = ACTIONS(3448),
    [anon_sym_LBRACK] = ACTIONS(3446),
    [anon_sym_RBRACK] = ACTIONS(3446),
    [anon_sym_COLON] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(3446),
    [anon_sym_RPAREN] = ACTIONS(3446),
    [anon_sym_in] = ACTIONS(3448),
    [anon_sym_RBRACE] = ACTIONS(3446),
    [anon_sym_EQ_GT] = ACTIONS(3446),
    [anon_sym_where] = ACTIONS(3446),
    [anon_sym_QMARK] = ACTIONS(3448),
    [anon_sym_BANG] = ACTIONS(3448),
    [anon_sym_PLUS_PLUS] = ACTIONS(3446),
    [anon_sym_DASH_DASH] = ACTIONS(3446),
    [anon_sym_PLUS] = ACTIONS(3448),
    [anon_sym_DASH] = ACTIONS(3448),
    [anon_sym_STAR] = ACTIONS(3448),
    [anon_sym_SLASH] = ACTIONS(3448),
    [anon_sym_PERCENT] = ACTIONS(3448),
    [anon_sym_CARET] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3448),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_LT_LT] = ACTIONS(3448),
    [anon_sym_GT_GT] = ACTIONS(3448),
    [anon_sym_EQ_EQ] = ACTIONS(3446),
    [anon_sym_BANG_EQ] = ACTIONS(3446),
    [anon_sym_GT_EQ] = ACTIONS(3446),
    [anon_sym_LT_EQ] = ACTIONS(3446),
    [anon_sym_switch] = ACTIONS(3446),
    [anon_sym_and] = ACTIONS(3446),
    [anon_sym_or] = ACTIONS(3448),
    [anon_sym_PLUS_EQ] = ACTIONS(3446),
    [anon_sym_DASH_EQ] = ACTIONS(3446),
    [anon_sym_STAR_EQ] = ACTIONS(3446),
    [anon_sym_SLASH_EQ] = ACTIONS(3446),
    [anon_sym_PERCENT_EQ] = ACTIONS(3446),
    [anon_sym_AMP_EQ] = ACTIONS(3446),
    [anon_sym_CARET_EQ] = ACTIONS(3446),
    [anon_sym_PIPE_EQ] = ACTIONS(3446),
    [anon_sym_LT_LT_EQ] = ACTIONS(3446),
    [anon_sym_GT_GT_EQ] = ACTIONS(3446),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3446),
    [anon_sym_is] = ACTIONS(3446),
    [anon_sym_DASH_GT] = ACTIONS(3446),
    [anon_sym_from] = ACTIONS(3446),
    [anon_sym_join] = ACTIONS(3446),
    [anon_sym_on] = ACTIONS(3446),
    [anon_sym_equals] = ACTIONS(3446),
    [anon_sym_into] = ACTIONS(3446),
    [anon_sym_let] = ACTIONS(3446),
    [anon_sym_orderby] = ACTIONS(3446),
    [anon_sym_group] = ACTIONS(3446),
    [anon_sym_by] = ACTIONS(3446),
    [anon_sym_select] = ACTIONS(3446),
    [anon_sym_DOT_DOT] = ACTIONS(3446),
    [anon_sym_with] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_PIPE_PIPE] = ACTIONS(3446),
    [anon_sym_QMARK_QMARK] = ACTIONS(3448),
    [anon_sym_as] = ACTIONS(3446),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2144] = {
    [sym__preprocessor_call] = STATE(2144),
    [anon_sym_SEMI] = ACTIONS(2963),
    [anon_sym_EQ] = ACTIONS(2961),
    [anon_sym_LT] = ACTIONS(2961),
    [anon_sym_COMMA] = ACTIONS(2963),
    [anon_sym_GT] = ACTIONS(2961),
    [anon_sym_DOT] = ACTIONS(2961),
    [anon_sym_LBRACK] = ACTIONS(2963),
    [anon_sym_RBRACK] = ACTIONS(2963),
    [anon_sym_COLON] = ACTIONS(2963),
    [anon_sym_LPAREN] = ACTIONS(2963),
    [anon_sym_RPAREN] = ACTIONS(2963),
    [anon_sym_in] = ACTIONS(2963),
    [anon_sym_LBRACE] = ACTIONS(2963),
    [anon_sym_RBRACE] = ACTIONS(2963),
    [anon_sym_EQ_GT] = ACTIONS(2963),
    [anon_sym_where] = ACTIONS(2963),
    [anon_sym_QMARK] = ACTIONS(2961),
    [anon_sym_BANG] = ACTIONS(2961),
    [anon_sym_PLUS_PLUS] = ACTIONS(2963),
    [anon_sym_DASH_DASH] = ACTIONS(2963),
    [anon_sym_PLUS] = ACTIONS(2961),
    [anon_sym_DASH] = ACTIONS(2961),
    [anon_sym_STAR] = ACTIONS(2961),
    [anon_sym_SLASH] = ACTIONS(2961),
    [anon_sym_PERCENT] = ACTIONS(2961),
    [anon_sym_CARET] = ACTIONS(2961),
    [anon_sym_PIPE] = ACTIONS(2961),
    [anon_sym_AMP] = ACTIONS(2961),
    [anon_sym_LT_LT] = ACTIONS(2961),
    [anon_sym_GT_GT] = ACTIONS(2961),
    [anon_sym_EQ_EQ] = ACTIONS(2963),
    [anon_sym_BANG_EQ] = ACTIONS(2963),
    [anon_sym_GT_EQ] = ACTIONS(2963),
    [anon_sym_LT_EQ] = ACTIONS(2963),
    [anon_sym_switch] = ACTIONS(2963),
    [anon_sym_and] = ACTIONS(2963),
    [anon_sym_or] = ACTIONS(2961),
    [anon_sym_PLUS_EQ] = ACTIONS(2963),
    [anon_sym_DASH_EQ] = ACTIONS(2963),
    [anon_sym_STAR_EQ] = ACTIONS(2963),
    [anon_sym_SLASH_EQ] = ACTIONS(2963),
    [anon_sym_PERCENT_EQ] = ACTIONS(2963),
    [anon_sym_AMP_EQ] = ACTIONS(2963),
    [anon_sym_CARET_EQ] = ACTIONS(2963),
    [anon_sym_PIPE_EQ] = ACTIONS(2963),
    [anon_sym_LT_LT_EQ] = ACTIONS(2963),
    [anon_sym_GT_GT_EQ] = ACTIONS(2963),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2963),
    [anon_sym_is] = ACTIONS(2963),
    [anon_sym_DASH_GT] = ACTIONS(2963),
    [anon_sym_from] = ACTIONS(2963),
    [anon_sym_join] = ACTIONS(2963),
    [anon_sym_on] = ACTIONS(2963),
    [anon_sym_equals] = ACTIONS(2963),
    [anon_sym_let] = ACTIONS(2963),
    [anon_sym_orderby] = ACTIONS(2963),
    [anon_sym_group] = ACTIONS(2963),
    [anon_sym_by] = ACTIONS(2963),
    [anon_sym_select] = ACTIONS(2963),
    [anon_sym_DOT_DOT] = ACTIONS(2963),
    [anon_sym_with] = ACTIONS(2963),
    [anon_sym_AMP_AMP] = ACTIONS(2963),
    [anon_sym_PIPE_PIPE] = ACTIONS(2963),
    [anon_sym_QMARK_QMARK] = ACTIONS(2961),
    [anon_sym_as] = ACTIONS(2963),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2145] = {
    [sym__preprocessor_call] = STATE(2145),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym_EQ] = ACTIONS(3452),
    [anon_sym_LT] = ACTIONS(3452),
    [anon_sym_COMMA] = ACTIONS(3450),
    [anon_sym_GT] = ACTIONS(3452),
    [anon_sym_DOT] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3450),
    [anon_sym_RBRACK] = ACTIONS(3450),
    [anon_sym_COLON] = ACTIONS(3450),
    [anon_sym_LPAREN] = ACTIONS(3450),
    [anon_sym_RPAREN] = ACTIONS(3450),
    [anon_sym_in] = ACTIONS(3452),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_EQ_GT] = ACTIONS(3450),
    [anon_sym_where] = ACTIONS(3450),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_BANG] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3452),
    [anon_sym_SLASH] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3452),
    [anon_sym_CARET] = ACTIONS(3452),
    [anon_sym_PIPE] = ACTIONS(3452),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_LT_LT] = ACTIONS(3452),
    [anon_sym_GT_GT] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3450),
    [anon_sym_BANG_EQ] = ACTIONS(3450),
    [anon_sym_GT_EQ] = ACTIONS(3450),
    [anon_sym_LT_EQ] = ACTIONS(3450),
    [anon_sym_switch] = ACTIONS(3450),
    [anon_sym_and] = ACTIONS(3450),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3450),
    [anon_sym_DASH_EQ] = ACTIONS(3450),
    [anon_sym_STAR_EQ] = ACTIONS(3450),
    [anon_sym_SLASH_EQ] = ACTIONS(3450),
    [anon_sym_PERCENT_EQ] = ACTIONS(3450),
    [anon_sym_AMP_EQ] = ACTIONS(3450),
    [anon_sym_CARET_EQ] = ACTIONS(3450),
    [anon_sym_PIPE_EQ] = ACTIONS(3450),
    [anon_sym_LT_LT_EQ] = ACTIONS(3450),
    [anon_sym_GT_GT_EQ] = ACTIONS(3450),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3450),
    [anon_sym_is] = ACTIONS(3450),
    [anon_sym_DASH_GT] = ACTIONS(3450),
    [anon_sym_from] = ACTIONS(3450),
    [anon_sym_join] = ACTIONS(3450),
    [anon_sym_on] = ACTIONS(3450),
    [anon_sym_equals] = ACTIONS(3450),
    [anon_sym_into] = ACTIONS(3450),
    [anon_sym_let] = ACTIONS(3450),
    [anon_sym_orderby] = ACTIONS(3450),
    [anon_sym_group] = ACTIONS(3450),
    [anon_sym_by] = ACTIONS(3450),
    [anon_sym_select] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3450),
    [anon_sym_with] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_PIPE_PIPE] = ACTIONS(3450),
    [anon_sym_QMARK_QMARK] = ACTIONS(3452),
    [anon_sym_as] = ACTIONS(3450),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2146] = {
    [sym__preprocessor_call] = STATE(2146),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_COMMA] = ACTIONS(3454),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_LBRACK] = ACTIONS(3454),
    [anon_sym_RBRACK] = ACTIONS(3454),
    [anon_sym_COLON] = ACTIONS(3454),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(3454),
    [anon_sym_in] = ACTIONS(3456),
    [anon_sym_RBRACE] = ACTIONS(3454),
    [anon_sym_EQ_GT] = ACTIONS(3454),
    [anon_sym_where] = ACTIONS(3454),
    [anon_sym_QMARK] = ACTIONS(3456),
    [anon_sym_BANG] = ACTIONS(3456),
    [anon_sym_PLUS_PLUS] = ACTIONS(3454),
    [anon_sym_DASH_DASH] = ACTIONS(3454),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_CARET] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_GT_GT] = ACTIONS(3456),
    [anon_sym_EQ_EQ] = ACTIONS(3454),
    [anon_sym_BANG_EQ] = ACTIONS(3454),
    [anon_sym_GT_EQ] = ACTIONS(3454),
    [anon_sym_LT_EQ] = ACTIONS(3454),
    [anon_sym_switch] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(3454),
    [anon_sym_or] = ACTIONS(3456),
    [anon_sym_PLUS_EQ] = ACTIONS(3454),
    [anon_sym_DASH_EQ] = ACTIONS(3454),
    [anon_sym_STAR_EQ] = ACTIONS(3454),
    [anon_sym_SLASH_EQ] = ACTIONS(3454),
    [anon_sym_PERCENT_EQ] = ACTIONS(3454),
    [anon_sym_AMP_EQ] = ACTIONS(3454),
    [anon_sym_CARET_EQ] = ACTIONS(3454),
    [anon_sym_PIPE_EQ] = ACTIONS(3454),
    [anon_sym_LT_LT_EQ] = ACTIONS(3454),
    [anon_sym_GT_GT_EQ] = ACTIONS(3454),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3454),
    [anon_sym_is] = ACTIONS(3454),
    [anon_sym_DASH_GT] = ACTIONS(3454),
    [anon_sym_from] = ACTIONS(3454),
    [anon_sym_join] = ACTIONS(3454),
    [anon_sym_on] = ACTIONS(3454),
    [anon_sym_equals] = ACTIONS(3454),
    [anon_sym_into] = ACTIONS(3454),
    [anon_sym_let] = ACTIONS(3454),
    [anon_sym_orderby] = ACTIONS(3454),
    [anon_sym_group] = ACTIONS(3454),
    [anon_sym_by] = ACTIONS(3454),
    [anon_sym_select] = ACTIONS(3454),
    [anon_sym_DOT_DOT] = ACTIONS(3454),
    [anon_sym_with] = ACTIONS(3454),
    [anon_sym_AMP_AMP] = ACTIONS(3454),
    [anon_sym_PIPE_PIPE] = ACTIONS(3454),
    [anon_sym_QMARK_QMARK] = ACTIONS(3456),
    [anon_sym_as] = ACTIONS(3454),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2147] = {
    [sym__preprocessor_call] = STATE(2147),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym_EQ] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_GT] = ACTIONS(3460),
    [anon_sym_DOT] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(3458),
    [anon_sym_RBRACK] = ACTIONS(3458),
    [anon_sym_COLON] = ACTIONS(3458),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_RPAREN] = ACTIONS(3458),
    [anon_sym_in] = ACTIONS(3460),
    [anon_sym_RBRACE] = ACTIONS(3458),
    [anon_sym_EQ_GT] = ACTIONS(3458),
    [anon_sym_where] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3460),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_PLUS_PLUS] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_SLASH] = ACTIONS(3460),
    [anon_sym_PERCENT] = ACTIONS(3460),
    [anon_sym_CARET] = ACTIONS(3460),
    [anon_sym_PIPE] = ACTIONS(3460),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_LT_LT] = ACTIONS(3460),
    [anon_sym_GT_GT] = ACTIONS(3460),
    [anon_sym_EQ_EQ] = ACTIONS(3458),
    [anon_sym_BANG_EQ] = ACTIONS(3458),
    [anon_sym_GT_EQ] = ACTIONS(3458),
    [anon_sym_LT_EQ] = ACTIONS(3458),
    [anon_sym_switch] = ACTIONS(3458),
    [anon_sym_and] = ACTIONS(3458),
    [anon_sym_or] = ACTIONS(3460),
    [anon_sym_PLUS_EQ] = ACTIONS(3458),
    [anon_sym_DASH_EQ] = ACTIONS(3458),
    [anon_sym_STAR_EQ] = ACTIONS(3458),
    [anon_sym_SLASH_EQ] = ACTIONS(3458),
    [anon_sym_PERCENT_EQ] = ACTIONS(3458),
    [anon_sym_AMP_EQ] = ACTIONS(3458),
    [anon_sym_CARET_EQ] = ACTIONS(3458),
    [anon_sym_PIPE_EQ] = ACTIONS(3458),
    [anon_sym_LT_LT_EQ] = ACTIONS(3458),
    [anon_sym_GT_GT_EQ] = ACTIONS(3458),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3458),
    [anon_sym_is] = ACTIONS(3458),
    [anon_sym_DASH_GT] = ACTIONS(3458),
    [anon_sym_from] = ACTIONS(3458),
    [anon_sym_join] = ACTIONS(3458),
    [anon_sym_on] = ACTIONS(3458),
    [anon_sym_equals] = ACTIONS(3458),
    [anon_sym_into] = ACTIONS(3458),
    [anon_sym_let] = ACTIONS(3458),
    [anon_sym_orderby] = ACTIONS(3458),
    [anon_sym_group] = ACTIONS(3458),
    [anon_sym_by] = ACTIONS(3458),
    [anon_sym_select] = ACTIONS(3458),
    [anon_sym_DOT_DOT] = ACTIONS(3458),
    [anon_sym_with] = ACTIONS(3458),
    [anon_sym_AMP_AMP] = ACTIONS(3458),
    [anon_sym_PIPE_PIPE] = ACTIONS(3458),
    [anon_sym_QMARK_QMARK] = ACTIONS(3460),
    [anon_sym_as] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2148] = {
    [sym__preprocessor_call] = STATE(2148),
    [anon_sym_SEMI] = ACTIONS(2955),
    [anon_sym_EQ] = ACTIONS(2953),
    [anon_sym_LT] = ACTIONS(2953),
    [anon_sym_COMMA] = ACTIONS(2955),
    [anon_sym_GT] = ACTIONS(2953),
    [anon_sym_DOT] = ACTIONS(2953),
    [anon_sym_LBRACK] = ACTIONS(2955),
    [anon_sym_RBRACK] = ACTIONS(2955),
    [anon_sym_COLON] = ACTIONS(2955),
    [anon_sym_LPAREN] = ACTIONS(2955),
    [anon_sym_RPAREN] = ACTIONS(2955),
    [anon_sym_in] = ACTIONS(2955),
    [anon_sym_LBRACE] = ACTIONS(2955),
    [anon_sym_RBRACE] = ACTIONS(2955),
    [anon_sym_EQ_GT] = ACTIONS(2955),
    [anon_sym_where] = ACTIONS(2955),
    [anon_sym_QMARK] = ACTIONS(2953),
    [anon_sym_BANG] = ACTIONS(2953),
    [anon_sym_PLUS_PLUS] = ACTIONS(2955),
    [anon_sym_DASH_DASH] = ACTIONS(2955),
    [anon_sym_PLUS] = ACTIONS(2953),
    [anon_sym_DASH] = ACTIONS(2953),
    [anon_sym_STAR] = ACTIONS(2953),
    [anon_sym_SLASH] = ACTIONS(2953),
    [anon_sym_PERCENT] = ACTIONS(2953),
    [anon_sym_CARET] = ACTIONS(2953),
    [anon_sym_PIPE] = ACTIONS(2953),
    [anon_sym_AMP] = ACTIONS(2953),
    [anon_sym_LT_LT] = ACTIONS(2953),
    [anon_sym_GT_GT] = ACTIONS(2953),
    [anon_sym_EQ_EQ] = ACTIONS(2955),
    [anon_sym_BANG_EQ] = ACTIONS(2955),
    [anon_sym_GT_EQ] = ACTIONS(2955),
    [anon_sym_LT_EQ] = ACTIONS(2955),
    [anon_sym_switch] = ACTIONS(2955),
    [anon_sym_and] = ACTIONS(2955),
    [anon_sym_or] = ACTIONS(2953),
    [anon_sym_PLUS_EQ] = ACTIONS(2955),
    [anon_sym_DASH_EQ] = ACTIONS(2955),
    [anon_sym_STAR_EQ] = ACTIONS(2955),
    [anon_sym_SLASH_EQ] = ACTIONS(2955),
    [anon_sym_PERCENT_EQ] = ACTIONS(2955),
    [anon_sym_AMP_EQ] = ACTIONS(2955),
    [anon_sym_CARET_EQ] = ACTIONS(2955),
    [anon_sym_PIPE_EQ] = ACTIONS(2955),
    [anon_sym_LT_LT_EQ] = ACTIONS(2955),
    [anon_sym_GT_GT_EQ] = ACTIONS(2955),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2955),
    [anon_sym_is] = ACTIONS(2955),
    [anon_sym_DASH_GT] = ACTIONS(2955),
    [anon_sym_from] = ACTIONS(2955),
    [anon_sym_join] = ACTIONS(2955),
    [anon_sym_on] = ACTIONS(2955),
    [anon_sym_equals] = ACTIONS(2955),
    [anon_sym_let] = ACTIONS(2955),
    [anon_sym_orderby] = ACTIONS(2955),
    [anon_sym_group] = ACTIONS(2955),
    [anon_sym_by] = ACTIONS(2955),
    [anon_sym_select] = ACTIONS(2955),
    [anon_sym_DOT_DOT] = ACTIONS(2955),
    [anon_sym_with] = ACTIONS(2955),
    [anon_sym_AMP_AMP] = ACTIONS(2955),
    [anon_sym_PIPE_PIPE] = ACTIONS(2955),
    [anon_sym_QMARK_QMARK] = ACTIONS(2953),
    [anon_sym_as] = ACTIONS(2955),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2149] = {
    [sym__preprocessor_call] = STATE(2149),
    [anon_sym_SEMI] = ACTIONS(2917),
    [anon_sym_EQ] = ACTIONS(2915),
    [anon_sym_LT] = ACTIONS(2915),
    [anon_sym_COMMA] = ACTIONS(2917),
    [anon_sym_GT] = ACTIONS(2915),
    [anon_sym_DOT] = ACTIONS(2915),
    [anon_sym_LBRACK] = ACTIONS(2917),
    [anon_sym_RBRACK] = ACTIONS(2917),
    [anon_sym_COLON] = ACTIONS(2917),
    [anon_sym_LPAREN] = ACTIONS(2917),
    [anon_sym_RPAREN] = ACTIONS(2917),
    [anon_sym_in] = ACTIONS(2917),
    [anon_sym_LBRACE] = ACTIONS(2917),
    [anon_sym_RBRACE] = ACTIONS(2917),
    [anon_sym_EQ_GT] = ACTIONS(2917),
    [anon_sym_where] = ACTIONS(2917),
    [anon_sym_QMARK] = ACTIONS(2915),
    [anon_sym_BANG] = ACTIONS(2915),
    [anon_sym_PLUS_PLUS] = ACTIONS(2917),
    [anon_sym_DASH_DASH] = ACTIONS(2917),
    [anon_sym_PLUS] = ACTIONS(2915),
    [anon_sym_DASH] = ACTIONS(2915),
    [anon_sym_STAR] = ACTIONS(2915),
    [anon_sym_SLASH] = ACTIONS(2915),
    [anon_sym_PERCENT] = ACTIONS(2915),
    [anon_sym_CARET] = ACTIONS(2915),
    [anon_sym_PIPE] = ACTIONS(2915),
    [anon_sym_AMP] = ACTIONS(2915),
    [anon_sym_LT_LT] = ACTIONS(2915),
    [anon_sym_GT_GT] = ACTIONS(2915),
    [anon_sym_EQ_EQ] = ACTIONS(2917),
    [anon_sym_BANG_EQ] = ACTIONS(2917),
    [anon_sym_GT_EQ] = ACTIONS(2917),
    [anon_sym_LT_EQ] = ACTIONS(2917),
    [anon_sym_switch] = ACTIONS(2917),
    [anon_sym_and] = ACTIONS(2917),
    [anon_sym_or] = ACTIONS(2915),
    [anon_sym_PLUS_EQ] = ACTIONS(2917),
    [anon_sym_DASH_EQ] = ACTIONS(2917),
    [anon_sym_STAR_EQ] = ACTIONS(2917),
    [anon_sym_SLASH_EQ] = ACTIONS(2917),
    [anon_sym_PERCENT_EQ] = ACTIONS(2917),
    [anon_sym_AMP_EQ] = ACTIONS(2917),
    [anon_sym_CARET_EQ] = ACTIONS(2917),
    [anon_sym_PIPE_EQ] = ACTIONS(2917),
    [anon_sym_LT_LT_EQ] = ACTIONS(2917),
    [anon_sym_GT_GT_EQ] = ACTIONS(2917),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2917),
    [anon_sym_is] = ACTIONS(2917),
    [anon_sym_DASH_GT] = ACTIONS(2917),
    [anon_sym_from] = ACTIONS(2917),
    [anon_sym_join] = ACTIONS(2917),
    [anon_sym_on] = ACTIONS(2917),
    [anon_sym_equals] = ACTIONS(2917),
    [anon_sym_let] = ACTIONS(2917),
    [anon_sym_orderby] = ACTIONS(2917),
    [anon_sym_group] = ACTIONS(2917),
    [anon_sym_by] = ACTIONS(2917),
    [anon_sym_select] = ACTIONS(2917),
    [anon_sym_DOT_DOT] = ACTIONS(2917),
    [anon_sym_with] = ACTIONS(2917),
    [anon_sym_AMP_AMP] = ACTIONS(2917),
    [anon_sym_PIPE_PIPE] = ACTIONS(2917),
    [anon_sym_QMARK_QMARK] = ACTIONS(2915),
    [anon_sym_as] = ACTIONS(2917),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2150] = {
    [sym__preprocessor_call] = STATE(2150),
    [anon_sym_SEMI] = ACTIONS(3462),
    [anon_sym_EQ] = ACTIONS(3464),
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_COMMA] = ACTIONS(3462),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_DOT] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(3462),
    [anon_sym_RBRACK] = ACTIONS(3462),
    [anon_sym_COLON] = ACTIONS(3462),
    [anon_sym_LPAREN] = ACTIONS(3462),
    [anon_sym_RPAREN] = ACTIONS(3462),
    [anon_sym_in] = ACTIONS(3464),
    [anon_sym_RBRACE] = ACTIONS(3462),
    [anon_sym_EQ_GT] = ACTIONS(3462),
    [anon_sym_where] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(3464),
    [anon_sym_BANG] = ACTIONS(3464),
    [anon_sym_PLUS_PLUS] = ACTIONS(3462),
    [anon_sym_DASH_DASH] = ACTIONS(3462),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3464),
    [anon_sym_CARET] = ACTIONS(3464),
    [anon_sym_PIPE] = ACTIONS(3464),
    [anon_sym_AMP] = ACTIONS(3464),
    [anon_sym_LT_LT] = ACTIONS(3464),
    [anon_sym_GT_GT] = ACTIONS(3464),
    [anon_sym_EQ_EQ] = ACTIONS(3462),
    [anon_sym_BANG_EQ] = ACTIONS(3462),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_LT_EQ] = ACTIONS(3462),
    [anon_sym_switch] = ACTIONS(3462),
    [anon_sym_and] = ACTIONS(3462),
    [anon_sym_or] = ACTIONS(3464),
    [anon_sym_PLUS_EQ] = ACTIONS(3462),
    [anon_sym_DASH_EQ] = ACTIONS(3462),
    [anon_sym_STAR_EQ] = ACTIONS(3462),
    [anon_sym_SLASH_EQ] = ACTIONS(3462),
    [anon_sym_PERCENT_EQ] = ACTIONS(3462),
    [anon_sym_AMP_EQ] = ACTIONS(3462),
    [anon_sym_CARET_EQ] = ACTIONS(3462),
    [anon_sym_PIPE_EQ] = ACTIONS(3462),
    [anon_sym_LT_LT_EQ] = ACTIONS(3462),
    [anon_sym_GT_GT_EQ] = ACTIONS(3462),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3462),
    [anon_sym_is] = ACTIONS(3462),
    [anon_sym_DASH_GT] = ACTIONS(3462),
    [anon_sym_from] = ACTIONS(3462),
    [anon_sym_join] = ACTIONS(3462),
    [anon_sym_on] = ACTIONS(3462),
    [anon_sym_equals] = ACTIONS(3462),
    [anon_sym_into] = ACTIONS(3462),
    [anon_sym_let] = ACTIONS(3462),
    [anon_sym_orderby] = ACTIONS(3462),
    [anon_sym_group] = ACTIONS(3462),
    [anon_sym_by] = ACTIONS(3462),
    [anon_sym_select] = ACTIONS(3462),
    [anon_sym_DOT_DOT] = ACTIONS(3462),
    [anon_sym_with] = ACTIONS(3462),
    [anon_sym_AMP_AMP] = ACTIONS(3462),
    [anon_sym_PIPE_PIPE] = ACTIONS(3462),
    [anon_sym_QMARK_QMARK] = ACTIONS(3464),
    [anon_sym_as] = ACTIONS(3462),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2151] = {
    [sym__preprocessor_call] = STATE(2151),
    [anon_sym_SEMI] = ACTIONS(2935),
    [anon_sym_EQ] = ACTIONS(2933),
    [anon_sym_LT] = ACTIONS(2933),
    [anon_sym_COMMA] = ACTIONS(2935),
    [anon_sym_GT] = ACTIONS(2933),
    [anon_sym_DOT] = ACTIONS(2933),
    [anon_sym_LBRACK] = ACTIONS(2935),
    [anon_sym_RBRACK] = ACTIONS(2935),
    [anon_sym_COLON] = ACTIONS(2935),
    [anon_sym_LPAREN] = ACTIONS(2935),
    [anon_sym_RPAREN] = ACTIONS(2935),
    [anon_sym_in] = ACTIONS(2935),
    [anon_sym_LBRACE] = ACTIONS(2935),
    [anon_sym_RBRACE] = ACTIONS(2935),
    [anon_sym_EQ_GT] = ACTIONS(2935),
    [anon_sym_where] = ACTIONS(2935),
    [anon_sym_QMARK] = ACTIONS(2933),
    [anon_sym_BANG] = ACTIONS(2933),
    [anon_sym_PLUS_PLUS] = ACTIONS(2935),
    [anon_sym_DASH_DASH] = ACTIONS(2935),
    [anon_sym_PLUS] = ACTIONS(2933),
    [anon_sym_DASH] = ACTIONS(2933),
    [anon_sym_STAR] = ACTIONS(2933),
    [anon_sym_SLASH] = ACTIONS(2933),
    [anon_sym_PERCENT] = ACTIONS(2933),
    [anon_sym_CARET] = ACTIONS(2933),
    [anon_sym_PIPE] = ACTIONS(2933),
    [anon_sym_AMP] = ACTIONS(2933),
    [anon_sym_LT_LT] = ACTIONS(2933),
    [anon_sym_GT_GT] = ACTIONS(2933),
    [anon_sym_EQ_EQ] = ACTIONS(2935),
    [anon_sym_BANG_EQ] = ACTIONS(2935),
    [anon_sym_GT_EQ] = ACTIONS(2935),
    [anon_sym_LT_EQ] = ACTIONS(2935),
    [anon_sym_switch] = ACTIONS(2935),
    [anon_sym_and] = ACTIONS(2935),
    [anon_sym_or] = ACTIONS(2933),
    [anon_sym_PLUS_EQ] = ACTIONS(2935),
    [anon_sym_DASH_EQ] = ACTIONS(2935),
    [anon_sym_STAR_EQ] = ACTIONS(2935),
    [anon_sym_SLASH_EQ] = ACTIONS(2935),
    [anon_sym_PERCENT_EQ] = ACTIONS(2935),
    [anon_sym_AMP_EQ] = ACTIONS(2935),
    [anon_sym_CARET_EQ] = ACTIONS(2935),
    [anon_sym_PIPE_EQ] = ACTIONS(2935),
    [anon_sym_LT_LT_EQ] = ACTIONS(2935),
    [anon_sym_GT_GT_EQ] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2935),
    [anon_sym_is] = ACTIONS(2935),
    [anon_sym_DASH_GT] = ACTIONS(2935),
    [anon_sym_from] = ACTIONS(2935),
    [anon_sym_join] = ACTIONS(2935),
    [anon_sym_on] = ACTIONS(2935),
    [anon_sym_equals] = ACTIONS(2935),
    [anon_sym_let] = ACTIONS(2935),
    [anon_sym_orderby] = ACTIONS(2935),
    [anon_sym_group] = ACTIONS(2935),
    [anon_sym_by] = ACTIONS(2935),
    [anon_sym_select] = ACTIONS(2935),
    [anon_sym_DOT_DOT] = ACTIONS(2935),
    [anon_sym_with] = ACTIONS(2935),
    [anon_sym_AMP_AMP] = ACTIONS(2935),
    [anon_sym_PIPE_PIPE] = ACTIONS(2935),
    [anon_sym_QMARK_QMARK] = ACTIONS(2933),
    [anon_sym_as] = ACTIONS(2935),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2152] = {
    [sym__preprocessor_call] = STATE(2152),
    [anon_sym_SEMI] = ACTIONS(3466),
    [anon_sym_EQ] = ACTIONS(3468),
    [anon_sym_LT] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_GT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [anon_sym_RBRACK] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3466),
    [anon_sym_RPAREN] = ACTIONS(3466),
    [anon_sym_in] = ACTIONS(3468),
    [anon_sym_RBRACE] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(3466),
    [anon_sym_where] = ACTIONS(3466),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_PLUS_PLUS] = ACTIONS(3466),
    [anon_sym_DASH_DASH] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(3468),
    [anon_sym_SLASH] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_CARET] = ACTIONS(3468),
    [anon_sym_PIPE] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_LT] = ACTIONS(3468),
    [anon_sym_GT_GT] = ACTIONS(3468),
    [anon_sym_EQ_EQ] = ACTIONS(3466),
    [anon_sym_BANG_EQ] = ACTIONS(3466),
    [anon_sym_GT_EQ] = ACTIONS(3466),
    [anon_sym_LT_EQ] = ACTIONS(3466),
    [anon_sym_switch] = ACTIONS(3466),
    [anon_sym_and] = ACTIONS(3466),
    [anon_sym_or] = ACTIONS(3468),
    [anon_sym_PLUS_EQ] = ACTIONS(3466),
    [anon_sym_DASH_EQ] = ACTIONS(3466),
    [anon_sym_STAR_EQ] = ACTIONS(3466),
    [anon_sym_SLASH_EQ] = ACTIONS(3466),
    [anon_sym_PERCENT_EQ] = ACTIONS(3466),
    [anon_sym_AMP_EQ] = ACTIONS(3466),
    [anon_sym_CARET_EQ] = ACTIONS(3466),
    [anon_sym_PIPE_EQ] = ACTIONS(3466),
    [anon_sym_LT_LT_EQ] = ACTIONS(3466),
    [anon_sym_GT_GT_EQ] = ACTIONS(3466),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3466),
    [anon_sym_is] = ACTIONS(3466),
    [anon_sym_DASH_GT] = ACTIONS(3466),
    [anon_sym_from] = ACTIONS(3466),
    [anon_sym_join] = ACTIONS(3466),
    [anon_sym_on] = ACTIONS(3466),
    [anon_sym_equals] = ACTIONS(3466),
    [anon_sym_into] = ACTIONS(3466),
    [anon_sym_let] = ACTIONS(3466),
    [anon_sym_orderby] = ACTIONS(3466),
    [anon_sym_group] = ACTIONS(3466),
    [anon_sym_by] = ACTIONS(3466),
    [anon_sym_select] = ACTIONS(3466),
    [anon_sym_DOT_DOT] = ACTIONS(3466),
    [anon_sym_with] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_PIPE_PIPE] = ACTIONS(3466),
    [anon_sym_QMARK_QMARK] = ACTIONS(3468),
    [anon_sym_as] = ACTIONS(3466),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2153] = {
    [sym__preprocessor_call] = STATE(2153),
    [anon_sym_SEMI] = ACTIONS(3470),
    [anon_sym_EQ] = ACTIONS(3472),
    [anon_sym_LT] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_GT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [anon_sym_RBRACK] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3470),
    [anon_sym_RPAREN] = ACTIONS(3470),
    [anon_sym_in] = ACTIONS(3472),
    [anon_sym_RBRACE] = ACTIONS(3470),
    [anon_sym_EQ_GT] = ACTIONS(3470),
    [anon_sym_where] = ACTIONS(3470),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_BANG] = ACTIONS(3472),
    [anon_sym_PLUS_PLUS] = ACTIONS(3470),
    [anon_sym_DASH_DASH] = ACTIONS(3470),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_STAR] = ACTIONS(3472),
    [anon_sym_SLASH] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_CARET] = ACTIONS(3472),
    [anon_sym_PIPE] = ACTIONS(3472),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3472),
    [anon_sym_GT_GT] = ACTIONS(3472),
    [anon_sym_EQ_EQ] = ACTIONS(3470),
    [anon_sym_BANG_EQ] = ACTIONS(3470),
    [anon_sym_GT_EQ] = ACTIONS(3470),
    [anon_sym_LT_EQ] = ACTIONS(3470),
    [anon_sym_switch] = ACTIONS(3470),
    [anon_sym_and] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(3472),
    [anon_sym_PLUS_EQ] = ACTIONS(3470),
    [anon_sym_DASH_EQ] = ACTIONS(3470),
    [anon_sym_STAR_EQ] = ACTIONS(3470),
    [anon_sym_SLASH_EQ] = ACTIONS(3470),
    [anon_sym_PERCENT_EQ] = ACTIONS(3470),
    [anon_sym_AMP_EQ] = ACTIONS(3470),
    [anon_sym_CARET_EQ] = ACTIONS(3470),
    [anon_sym_PIPE_EQ] = ACTIONS(3470),
    [anon_sym_LT_LT_EQ] = ACTIONS(3470),
    [anon_sym_GT_GT_EQ] = ACTIONS(3470),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3470),
    [anon_sym_is] = ACTIONS(3470),
    [anon_sym_DASH_GT] = ACTIONS(3470),
    [anon_sym_from] = ACTIONS(3470),
    [anon_sym_join] = ACTIONS(3470),
    [anon_sym_on] = ACTIONS(3470),
    [anon_sym_equals] = ACTIONS(3470),
    [anon_sym_into] = ACTIONS(3470),
    [anon_sym_let] = ACTIONS(3470),
    [anon_sym_orderby] = ACTIONS(3470),
    [anon_sym_group] = ACTIONS(3470),
    [anon_sym_by] = ACTIONS(3470),
    [anon_sym_select] = ACTIONS(3470),
    [anon_sym_DOT_DOT] = ACTIONS(3470),
    [anon_sym_with] = ACTIONS(3470),
    [anon_sym_AMP_AMP] = ACTIONS(3470),
    [anon_sym_PIPE_PIPE] = ACTIONS(3470),
    [anon_sym_QMARK_QMARK] = ACTIONS(3472),
    [anon_sym_as] = ACTIONS(3470),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2154] = {
    [sym__preprocessor_call] = STATE(2154),
    [anon_sym_SEMI] = ACTIONS(3474),
    [anon_sym_EQ] = ACTIONS(3476),
    [anon_sym_LT] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_GT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3474),
    [anon_sym_RBRACK] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(3474),
    [anon_sym_in] = ACTIONS(3476),
    [anon_sym_RBRACE] = ACTIONS(3474),
    [anon_sym_EQ_GT] = ACTIONS(3474),
    [anon_sym_where] = ACTIONS(3474),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_BANG] = ACTIONS(3476),
    [anon_sym_PLUS_PLUS] = ACTIONS(3474),
    [anon_sym_DASH_DASH] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_CARET] = ACTIONS(3476),
    [anon_sym_PIPE] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LT_LT] = ACTIONS(3476),
    [anon_sym_GT_GT] = ACTIONS(3476),
    [anon_sym_EQ_EQ] = ACTIONS(3474),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_GT_EQ] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3474),
    [anon_sym_switch] = ACTIONS(3474),
    [anon_sym_and] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3476),
    [anon_sym_PLUS_EQ] = ACTIONS(3474),
    [anon_sym_DASH_EQ] = ACTIONS(3474),
    [anon_sym_STAR_EQ] = ACTIONS(3474),
    [anon_sym_SLASH_EQ] = ACTIONS(3474),
    [anon_sym_PERCENT_EQ] = ACTIONS(3474),
    [anon_sym_AMP_EQ] = ACTIONS(3474),
    [anon_sym_CARET_EQ] = ACTIONS(3474),
    [anon_sym_PIPE_EQ] = ACTIONS(3474),
    [anon_sym_LT_LT_EQ] = ACTIONS(3474),
    [anon_sym_GT_GT_EQ] = ACTIONS(3474),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3474),
    [anon_sym_is] = ACTIONS(3474),
    [anon_sym_DASH_GT] = ACTIONS(3474),
    [anon_sym_from] = ACTIONS(3474),
    [anon_sym_join] = ACTIONS(3474),
    [anon_sym_on] = ACTIONS(3474),
    [anon_sym_equals] = ACTIONS(3474),
    [anon_sym_into] = ACTIONS(3474),
    [anon_sym_let] = ACTIONS(3474),
    [anon_sym_orderby] = ACTIONS(3474),
    [anon_sym_group] = ACTIONS(3474),
    [anon_sym_by] = ACTIONS(3474),
    [anon_sym_select] = ACTIONS(3474),
    [anon_sym_DOT_DOT] = ACTIONS(3474),
    [anon_sym_with] = ACTIONS(3474),
    [anon_sym_AMP_AMP] = ACTIONS(3474),
    [anon_sym_PIPE_PIPE] = ACTIONS(3474),
    [anon_sym_QMARK_QMARK] = ACTIONS(3476),
    [anon_sym_as] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2155] = {
    [sym__preprocessor_call] = STATE(2155),
    [anon_sym_SEMI] = ACTIONS(3478),
    [anon_sym_EQ] = ACTIONS(3480),
    [anon_sym_LT] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3478),
    [anon_sym_RBRACK] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3478),
    [anon_sym_RPAREN] = ACTIONS(3478),
    [anon_sym_in] = ACTIONS(3480),
    [anon_sym_RBRACE] = ACTIONS(3478),
    [anon_sym_EQ_GT] = ACTIONS(3478),
    [anon_sym_where] = ACTIONS(3478),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_BANG] = ACTIONS(3480),
    [anon_sym_PLUS_PLUS] = ACTIONS(3478),
    [anon_sym_DASH_DASH] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_SLASH] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_CARET] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LT_LT] = ACTIONS(3480),
    [anon_sym_GT_GT] = ACTIONS(3480),
    [anon_sym_EQ_EQ] = ACTIONS(3478),
    [anon_sym_BANG_EQ] = ACTIONS(3478),
    [anon_sym_GT_EQ] = ACTIONS(3478),
    [anon_sym_LT_EQ] = ACTIONS(3478),
    [anon_sym_switch] = ACTIONS(3478),
    [anon_sym_and] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_PLUS_EQ] = ACTIONS(3478),
    [anon_sym_DASH_EQ] = ACTIONS(3478),
    [anon_sym_STAR_EQ] = ACTIONS(3478),
    [anon_sym_SLASH_EQ] = ACTIONS(3478),
    [anon_sym_PERCENT_EQ] = ACTIONS(3478),
    [anon_sym_AMP_EQ] = ACTIONS(3478),
    [anon_sym_CARET_EQ] = ACTIONS(3478),
    [anon_sym_PIPE_EQ] = ACTIONS(3478),
    [anon_sym_LT_LT_EQ] = ACTIONS(3478),
    [anon_sym_GT_GT_EQ] = ACTIONS(3478),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3478),
    [anon_sym_is] = ACTIONS(3478),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_from] = ACTIONS(3478),
    [anon_sym_join] = ACTIONS(3478),
    [anon_sym_on] = ACTIONS(3478),
    [anon_sym_equals] = ACTIONS(3478),
    [anon_sym_into] = ACTIONS(3478),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_orderby] = ACTIONS(3478),
    [anon_sym_group] = ACTIONS(3478),
    [anon_sym_by] = ACTIONS(3478),
    [anon_sym_select] = ACTIONS(3478),
    [anon_sym_DOT_DOT] = ACTIONS(3478),
    [anon_sym_with] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_PIPE_PIPE] = ACTIONS(3478),
    [anon_sym_QMARK_QMARK] = ACTIONS(3480),
    [anon_sym_as] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2156] = {
    [sym__preprocessor_call] = STATE(2156),
    [anon_sym_SEMI] = ACTIONS(3482),
    [anon_sym_EQ] = ACTIONS(3484),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_COMMA] = ACTIONS(3482),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_DOT] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(3482),
    [anon_sym_RBRACK] = ACTIONS(3482),
    [anon_sym_COLON] = ACTIONS(3482),
    [anon_sym_LPAREN] = ACTIONS(3482),
    [anon_sym_RPAREN] = ACTIONS(3482),
    [anon_sym_in] = ACTIONS(3484),
    [anon_sym_RBRACE] = ACTIONS(3482),
    [anon_sym_EQ_GT] = ACTIONS(3482),
    [anon_sym_where] = ACTIONS(3482),
    [anon_sym_QMARK] = ACTIONS(3484),
    [anon_sym_BANG] = ACTIONS(3484),
    [anon_sym_PLUS_PLUS] = ACTIONS(3482),
    [anon_sym_DASH_DASH] = ACTIONS(3482),
    [anon_sym_PLUS] = ACTIONS(3484),
    [anon_sym_DASH] = ACTIONS(3484),
    [anon_sym_STAR] = ACTIONS(3484),
    [anon_sym_SLASH] = ACTIONS(3484),
    [anon_sym_PERCENT] = ACTIONS(3484),
    [anon_sym_CARET] = ACTIONS(3484),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_AMP] = ACTIONS(3484),
    [anon_sym_LT_LT] = ACTIONS(3484),
    [anon_sym_GT_GT] = ACTIONS(3484),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_BANG_EQ] = ACTIONS(3482),
    [anon_sym_GT_EQ] = ACTIONS(3482),
    [anon_sym_LT_EQ] = ACTIONS(3482),
    [anon_sym_switch] = ACTIONS(3482),
    [anon_sym_and] = ACTIONS(3482),
    [anon_sym_or] = ACTIONS(3484),
    [anon_sym_PLUS_EQ] = ACTIONS(3482),
    [anon_sym_DASH_EQ] = ACTIONS(3482),
    [anon_sym_STAR_EQ] = ACTIONS(3482),
    [anon_sym_SLASH_EQ] = ACTIONS(3482),
    [anon_sym_PERCENT_EQ] = ACTIONS(3482),
    [anon_sym_AMP_EQ] = ACTIONS(3482),
    [anon_sym_CARET_EQ] = ACTIONS(3482),
    [anon_sym_PIPE_EQ] = ACTIONS(3482),
    [anon_sym_LT_LT_EQ] = ACTIONS(3482),
    [anon_sym_GT_GT_EQ] = ACTIONS(3482),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3482),
    [anon_sym_is] = ACTIONS(3482),
    [anon_sym_DASH_GT] = ACTIONS(3482),
    [anon_sym_from] = ACTIONS(3482),
    [anon_sym_join] = ACTIONS(3482),
    [anon_sym_on] = ACTIONS(3482),
    [anon_sym_equals] = ACTIONS(3482),
    [anon_sym_into] = ACTIONS(3482),
    [anon_sym_let] = ACTIONS(3482),
    [anon_sym_orderby] = ACTIONS(3482),
    [anon_sym_group] = ACTIONS(3482),
    [anon_sym_by] = ACTIONS(3482),
    [anon_sym_select] = ACTIONS(3482),
    [anon_sym_DOT_DOT] = ACTIONS(3482),
    [anon_sym_with] = ACTIONS(3482),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_QMARK_QMARK] = ACTIONS(3484),
    [anon_sym_as] = ACTIONS(3482),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2157] = {
    [sym__preprocessor_call] = STATE(2157),
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_COMMA] = ACTIONS(3486),
    [anon_sym_GT] = ACTIONS(3488),
    [anon_sym_DOT] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3486),
    [anon_sym_RBRACK] = ACTIONS(3486),
    [anon_sym_COLON] = ACTIONS(3486),
    [anon_sym_LPAREN] = ACTIONS(3486),
    [anon_sym_RPAREN] = ACTIONS(3486),
    [anon_sym_in] = ACTIONS(3488),
    [anon_sym_RBRACE] = ACTIONS(3486),
    [anon_sym_EQ_GT] = ACTIONS(3486),
    [anon_sym_where] = ACTIONS(3486),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_PLUS_PLUS] = ACTIONS(3486),
    [anon_sym_DASH_DASH] = ACTIONS(3486),
    [anon_sym_PLUS] = ACTIONS(3488),
    [anon_sym_DASH] = ACTIONS(3488),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_SLASH] = ACTIONS(3488),
    [anon_sym_PERCENT] = ACTIONS(3488),
    [anon_sym_CARET] = ACTIONS(3488),
    [anon_sym_PIPE] = ACTIONS(3488),
    [anon_sym_AMP] = ACTIONS(3488),
    [anon_sym_LT_LT] = ACTIONS(3488),
    [anon_sym_GT_GT] = ACTIONS(3488),
    [anon_sym_EQ_EQ] = ACTIONS(3486),
    [anon_sym_BANG_EQ] = ACTIONS(3486),
    [anon_sym_GT_EQ] = ACTIONS(3486),
    [anon_sym_LT_EQ] = ACTIONS(3486),
    [anon_sym_switch] = ACTIONS(3486),
    [anon_sym_and] = ACTIONS(3486),
    [anon_sym_or] = ACTIONS(3488),
    [anon_sym_PLUS_EQ] = ACTIONS(3486),
    [anon_sym_DASH_EQ] = ACTIONS(3486),
    [anon_sym_STAR_EQ] = ACTIONS(3486),
    [anon_sym_SLASH_EQ] = ACTIONS(3486),
    [anon_sym_PERCENT_EQ] = ACTIONS(3486),
    [anon_sym_AMP_EQ] = ACTIONS(3486),
    [anon_sym_CARET_EQ] = ACTIONS(3486),
    [anon_sym_PIPE_EQ] = ACTIONS(3486),
    [anon_sym_LT_LT_EQ] = ACTIONS(3486),
    [anon_sym_GT_GT_EQ] = ACTIONS(3486),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3486),
    [anon_sym_is] = ACTIONS(3486),
    [anon_sym_DASH_GT] = ACTIONS(3486),
    [anon_sym_from] = ACTIONS(3486),
    [anon_sym_join] = ACTIONS(3486),
    [anon_sym_on] = ACTIONS(3486),
    [anon_sym_equals] = ACTIONS(3486),
    [anon_sym_into] = ACTIONS(3486),
    [anon_sym_let] = ACTIONS(3486),
    [anon_sym_orderby] = ACTIONS(3486),
    [anon_sym_group] = ACTIONS(3486),
    [anon_sym_by] = ACTIONS(3486),
    [anon_sym_select] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3486),
    [anon_sym_with] = ACTIONS(3486),
    [anon_sym_AMP_AMP] = ACTIONS(3486),
    [anon_sym_PIPE_PIPE] = ACTIONS(3486),
    [anon_sym_QMARK_QMARK] = ACTIONS(3488),
    [anon_sym_as] = ACTIONS(3486),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2158] = {
    [sym__preprocessor_call] = STATE(2158),
    [anon_sym_SEMI] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_COMMA] = ACTIONS(3490),
    [anon_sym_GT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(3492),
    [anon_sym_LBRACK] = ACTIONS(3490),
    [anon_sym_RBRACK] = ACTIONS(3490),
    [anon_sym_COLON] = ACTIONS(3490),
    [anon_sym_LPAREN] = ACTIONS(3490),
    [anon_sym_RPAREN] = ACTIONS(3490),
    [anon_sym_in] = ACTIONS(3492),
    [anon_sym_RBRACE] = ACTIONS(3490),
    [anon_sym_EQ_GT] = ACTIONS(3490),
    [anon_sym_where] = ACTIONS(3490),
    [anon_sym_QMARK] = ACTIONS(3492),
    [anon_sym_BANG] = ACTIONS(3492),
    [anon_sym_PLUS_PLUS] = ACTIONS(3490),
    [anon_sym_DASH_DASH] = ACTIONS(3490),
    [anon_sym_PLUS] = ACTIONS(3492),
    [anon_sym_DASH] = ACTIONS(3492),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_SLASH] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_CARET] = ACTIONS(3492),
    [anon_sym_PIPE] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3492),
    [anon_sym_LT_LT] = ACTIONS(3492),
    [anon_sym_GT_GT] = ACTIONS(3492),
    [anon_sym_EQ_EQ] = ACTIONS(3490),
    [anon_sym_BANG_EQ] = ACTIONS(3490),
    [anon_sym_GT_EQ] = ACTIONS(3490),
    [anon_sym_LT_EQ] = ACTIONS(3490),
    [anon_sym_switch] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3490),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PLUS_EQ] = ACTIONS(3490),
    [anon_sym_DASH_EQ] = ACTIONS(3490),
    [anon_sym_STAR_EQ] = ACTIONS(3490),
    [anon_sym_SLASH_EQ] = ACTIONS(3490),
    [anon_sym_PERCENT_EQ] = ACTIONS(3490),
    [anon_sym_AMP_EQ] = ACTIONS(3490),
    [anon_sym_CARET_EQ] = ACTIONS(3490),
    [anon_sym_PIPE_EQ] = ACTIONS(3490),
    [anon_sym_LT_LT_EQ] = ACTIONS(3490),
    [anon_sym_GT_GT_EQ] = ACTIONS(3490),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3490),
    [anon_sym_is] = ACTIONS(3490),
    [anon_sym_DASH_GT] = ACTIONS(3490),
    [anon_sym_from] = ACTIONS(3490),
    [anon_sym_join] = ACTIONS(3490),
    [anon_sym_on] = ACTIONS(3490),
    [anon_sym_equals] = ACTIONS(3490),
    [anon_sym_into] = ACTIONS(3490),
    [anon_sym_let] = ACTIONS(3490),
    [anon_sym_orderby] = ACTIONS(3490),
    [anon_sym_group] = ACTIONS(3490),
    [anon_sym_by] = ACTIONS(3490),
    [anon_sym_select] = ACTIONS(3490),
    [anon_sym_DOT_DOT] = ACTIONS(3490),
    [anon_sym_with] = ACTIONS(3490),
    [anon_sym_AMP_AMP] = ACTIONS(3490),
    [anon_sym_PIPE_PIPE] = ACTIONS(3490),
    [anon_sym_QMARK_QMARK] = ACTIONS(3492),
    [anon_sym_as] = ACTIONS(3490),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2159] = {
    [sym__preprocessor_call] = STATE(2159),
    [anon_sym_SEMI] = ACTIONS(3494),
    [anon_sym_EQ] = ACTIONS(3496),
    [anon_sym_LT] = ACTIONS(3496),
    [anon_sym_COMMA] = ACTIONS(3494),
    [anon_sym_GT] = ACTIONS(3496),
    [anon_sym_DOT] = ACTIONS(3496),
    [anon_sym_LBRACK] = ACTIONS(3494),
    [anon_sym_RBRACK] = ACTIONS(3494),
    [anon_sym_COLON] = ACTIONS(3494),
    [anon_sym_LPAREN] = ACTIONS(3494),
    [anon_sym_RPAREN] = ACTIONS(3494),
    [anon_sym_in] = ACTIONS(3496),
    [anon_sym_RBRACE] = ACTIONS(3494),
    [anon_sym_EQ_GT] = ACTIONS(3494),
    [anon_sym_where] = ACTIONS(3494),
    [anon_sym_QMARK] = ACTIONS(3496),
    [anon_sym_BANG] = ACTIONS(3496),
    [anon_sym_PLUS_PLUS] = ACTIONS(3494),
    [anon_sym_DASH_DASH] = ACTIONS(3494),
    [anon_sym_PLUS] = ACTIONS(3496),
    [anon_sym_DASH] = ACTIONS(3496),
    [anon_sym_STAR] = ACTIONS(3496),
    [anon_sym_SLASH] = ACTIONS(3496),
    [anon_sym_PERCENT] = ACTIONS(3496),
    [anon_sym_CARET] = ACTIONS(3496),
    [anon_sym_PIPE] = ACTIONS(3496),
    [anon_sym_AMP] = ACTIONS(3496),
    [anon_sym_LT_LT] = ACTIONS(3496),
    [anon_sym_GT_GT] = ACTIONS(3496),
    [anon_sym_EQ_EQ] = ACTIONS(3494),
    [anon_sym_BANG_EQ] = ACTIONS(3494),
    [anon_sym_GT_EQ] = ACTIONS(3494),
    [anon_sym_LT_EQ] = ACTIONS(3494),
    [anon_sym_switch] = ACTIONS(3494),
    [anon_sym_and] = ACTIONS(3494),
    [anon_sym_or] = ACTIONS(3496),
    [anon_sym_PLUS_EQ] = ACTIONS(3494),
    [anon_sym_DASH_EQ] = ACTIONS(3494),
    [anon_sym_STAR_EQ] = ACTIONS(3494),
    [anon_sym_SLASH_EQ] = ACTIONS(3494),
    [anon_sym_PERCENT_EQ] = ACTIONS(3494),
    [anon_sym_AMP_EQ] = ACTIONS(3494),
    [anon_sym_CARET_EQ] = ACTIONS(3494),
    [anon_sym_PIPE_EQ] = ACTIONS(3494),
    [anon_sym_LT_LT_EQ] = ACTIONS(3494),
    [anon_sym_GT_GT_EQ] = ACTIONS(3494),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3494),
    [anon_sym_is] = ACTIONS(3494),
    [anon_sym_DASH_GT] = ACTIONS(3494),
    [anon_sym_from] = ACTIONS(3494),
    [anon_sym_join] = ACTIONS(3494),
    [anon_sym_on] = ACTIONS(3494),
    [anon_sym_equals] = ACTIONS(3494),
    [anon_sym_into] = ACTIONS(3494),
    [anon_sym_let] = ACTIONS(3494),
    [anon_sym_orderby] = ACTIONS(3494),
    [anon_sym_group] = ACTIONS(3494),
    [anon_sym_by] = ACTIONS(3494),
    [anon_sym_select] = ACTIONS(3494),
    [anon_sym_DOT_DOT] = ACTIONS(3494),
    [anon_sym_with] = ACTIONS(3494),
    [anon_sym_AMP_AMP] = ACTIONS(3494),
    [anon_sym_PIPE_PIPE] = ACTIONS(3494),
    [anon_sym_QMARK_QMARK] = ACTIONS(3496),
    [anon_sym_as] = ACTIONS(3494),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2160] = {
    [sym__preprocessor_call] = STATE(2160),
    [anon_sym_SEMI] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3500),
    [anon_sym_LT] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(3498),
    [anon_sym_GT] = ACTIONS(3500),
    [anon_sym_DOT] = ACTIONS(3500),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_RBRACK] = ACTIONS(3498),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_RPAREN] = ACTIONS(3498),
    [anon_sym_in] = ACTIONS(3500),
    [anon_sym_RBRACE] = ACTIONS(3498),
    [anon_sym_EQ_GT] = ACTIONS(3498),
    [anon_sym_where] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3500),
    [anon_sym_PLUS_PLUS] = ACTIONS(3498),
    [anon_sym_DASH_DASH] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3500),
    [anon_sym_SLASH] = ACTIONS(3500),
    [anon_sym_PERCENT] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3500),
    [anon_sym_PIPE] = ACTIONS(3500),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_LT_LT] = ACTIONS(3500),
    [anon_sym_GT_GT] = ACTIONS(3500),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_GT_EQ] = ACTIONS(3498),
    [anon_sym_LT_EQ] = ACTIONS(3498),
    [anon_sym_switch] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3500),
    [anon_sym_PLUS_EQ] = ACTIONS(3498),
    [anon_sym_DASH_EQ] = ACTIONS(3498),
    [anon_sym_STAR_EQ] = ACTIONS(3498),
    [anon_sym_SLASH_EQ] = ACTIONS(3498),
    [anon_sym_PERCENT_EQ] = ACTIONS(3498),
    [anon_sym_AMP_EQ] = ACTIONS(3498),
    [anon_sym_CARET_EQ] = ACTIONS(3498),
    [anon_sym_PIPE_EQ] = ACTIONS(3498),
    [anon_sym_LT_LT_EQ] = ACTIONS(3498),
    [anon_sym_GT_GT_EQ] = ACTIONS(3498),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3498),
    [anon_sym_is] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_from] = ACTIONS(3498),
    [anon_sym_join] = ACTIONS(3498),
    [anon_sym_on] = ACTIONS(3498),
    [anon_sym_equals] = ACTIONS(3498),
    [anon_sym_into] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_orderby] = ACTIONS(3498),
    [anon_sym_group] = ACTIONS(3498),
    [anon_sym_by] = ACTIONS(3498),
    [anon_sym_select] = ACTIONS(3498),
    [anon_sym_DOT_DOT] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_QMARK_QMARK] = ACTIONS(3500),
    [anon_sym_as] = ACTIONS(3498),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2161] = {
    [sym_array_rank_specifier] = STATE(2148),
    [sym__preprocessor_call] = STATE(2161),
    [anon_sym_SEMI] = ACTIONS(3302),
    [anon_sym_EQ] = ACTIONS(3304),
    [anon_sym_LT] = ACTIONS(3304),
    [anon_sym_COMMA] = ACTIONS(3302),
    [anon_sym_GT] = ACTIONS(3304),
    [anon_sym_DOT] = ACTIONS(3304),
    [anon_sym_LBRACK] = ACTIONS(3250),
    [anon_sym_RBRACK] = ACTIONS(3302),
    [anon_sym_COLON] = ACTIONS(3302),
    [anon_sym_LPAREN] = ACTIONS(3302),
    [anon_sym_RPAREN] = ACTIONS(3302),
    [anon_sym_in] = ACTIONS(3302),
    [anon_sym_RBRACE] = ACTIONS(3302),
    [anon_sym_EQ_GT] = ACTIONS(3302),
    [anon_sym_where] = ACTIONS(3302),
    [anon_sym_QMARK] = ACTIONS(3304),
    [anon_sym_BANG] = ACTIONS(3304),
    [anon_sym_PLUS_PLUS] = ACTIONS(3302),
    [anon_sym_DASH_DASH] = ACTIONS(3302),
    [anon_sym_PLUS] = ACTIONS(3304),
    [anon_sym_DASH] = ACTIONS(3304),
    [anon_sym_STAR] = ACTIONS(3254),
    [anon_sym_SLASH] = ACTIONS(3304),
    [anon_sym_PERCENT] = ACTIONS(3304),
    [anon_sym_CARET] = ACTIONS(3304),
    [anon_sym_PIPE] = ACTIONS(3304),
    [anon_sym_AMP] = ACTIONS(3304),
    [anon_sym_LT_LT] = ACTIONS(3304),
    [anon_sym_GT_GT] = ACTIONS(3304),
    [anon_sym_EQ_EQ] = ACTIONS(3302),
    [anon_sym_BANG_EQ] = ACTIONS(3302),
    [anon_sym_GT_EQ] = ACTIONS(3302),
    [anon_sym_LT_EQ] = ACTIONS(3302),
    [anon_sym_switch] = ACTIONS(3302),
    [anon_sym_and] = ACTIONS(3302),
    [anon_sym_or] = ACTIONS(3304),
    [anon_sym_PLUS_EQ] = ACTIONS(3302),
    [anon_sym_DASH_EQ] = ACTIONS(3302),
    [anon_sym_STAR_EQ] = ACTIONS(3302),
    [anon_sym_SLASH_EQ] = ACTIONS(3302),
    [anon_sym_PERCENT_EQ] = ACTIONS(3302),
    [anon_sym_AMP_EQ] = ACTIONS(3302),
    [anon_sym_CARET_EQ] = ACTIONS(3302),
    [anon_sym_PIPE_EQ] = ACTIONS(3302),
    [anon_sym_LT_LT_EQ] = ACTIONS(3302),
    [anon_sym_GT_GT_EQ] = ACTIONS(3302),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3302),
    [anon_sym_is] = ACTIONS(3302),
    [anon_sym_DASH_GT] = ACTIONS(3302),
    [anon_sym_from] = ACTIONS(3302),
    [anon_sym_join] = ACTIONS(3302),
    [anon_sym_on] = ACTIONS(3302),
    [anon_sym_equals] = ACTIONS(3302),
    [anon_sym_let] = ACTIONS(3302),
    [anon_sym_orderby] = ACTIONS(3302),
    [anon_sym_group] = ACTIONS(3302),
    [anon_sym_by] = ACTIONS(3302),
    [anon_sym_select] = ACTIONS(3302),
    [anon_sym_DOT_DOT] = ACTIONS(3302),
    [anon_sym_with] = ACTIONS(3302),
    [anon_sym_AMP_AMP] = ACTIONS(3302),
    [anon_sym_PIPE_PIPE] = ACTIONS(3302),
    [anon_sym_QMARK_QMARK] = ACTIONS(3304),
    [anon_sym_as] = ACTIONS(3302),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2162] = {
    [sym__preprocessor_call] = STATE(2162),
    [anon_sym_SEMI] = ACTIONS(2905),
    [anon_sym_EQ] = ACTIONS(2903),
    [anon_sym_LT] = ACTIONS(2903),
    [anon_sym_COMMA] = ACTIONS(2905),
    [anon_sym_GT] = ACTIONS(2903),
    [anon_sym_DOT] = ACTIONS(2903),
    [anon_sym_LBRACK] = ACTIONS(2905),
    [anon_sym_RBRACK] = ACTIONS(2905),
    [anon_sym_COLON] = ACTIONS(2905),
    [anon_sym_LPAREN] = ACTIONS(2905),
    [anon_sym_RPAREN] = ACTIONS(2905),
    [anon_sym_in] = ACTIONS(2905),
    [anon_sym_LBRACE] = ACTIONS(2905),
    [anon_sym_RBRACE] = ACTIONS(2905),
    [anon_sym_EQ_GT] = ACTIONS(2905),
    [anon_sym_where] = ACTIONS(2905),
    [anon_sym_QMARK] = ACTIONS(2903),
    [anon_sym_BANG] = ACTIONS(2903),
    [anon_sym_PLUS_PLUS] = ACTIONS(2905),
    [anon_sym_DASH_DASH] = ACTIONS(2905),
    [anon_sym_PLUS] = ACTIONS(2903),
    [anon_sym_DASH] = ACTIONS(2903),
    [anon_sym_STAR] = ACTIONS(2903),
    [anon_sym_SLASH] = ACTIONS(2903),
    [anon_sym_PERCENT] = ACTIONS(2903),
    [anon_sym_CARET] = ACTIONS(2903),
    [anon_sym_PIPE] = ACTIONS(2903),
    [anon_sym_AMP] = ACTIONS(2903),
    [anon_sym_LT_LT] = ACTIONS(2903),
    [anon_sym_GT_GT] = ACTIONS(2903),
    [anon_sym_EQ_EQ] = ACTIONS(2905),
    [anon_sym_BANG_EQ] = ACTIONS(2905),
    [anon_sym_GT_EQ] = ACTIONS(2905),
    [anon_sym_LT_EQ] = ACTIONS(2905),
    [anon_sym_switch] = ACTIONS(2905),
    [anon_sym_and] = ACTIONS(2905),
    [anon_sym_or] = ACTIONS(2903),
    [anon_sym_PLUS_EQ] = ACTIONS(2905),
    [anon_sym_DASH_EQ] = ACTIONS(2905),
    [anon_sym_STAR_EQ] = ACTIONS(2905),
    [anon_sym_SLASH_EQ] = ACTIONS(2905),
    [anon_sym_PERCENT_EQ] = ACTIONS(2905),
    [anon_sym_AMP_EQ] = ACTIONS(2905),
    [anon_sym_CARET_EQ] = ACTIONS(2905),
    [anon_sym_PIPE_EQ] = ACTIONS(2905),
    [anon_sym_LT_LT_EQ] = ACTIONS(2905),
    [anon_sym_GT_GT_EQ] = ACTIONS(2905),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2905),
    [anon_sym_is] = ACTIONS(2905),
    [anon_sym_DASH_GT] = ACTIONS(2905),
    [anon_sym_from] = ACTIONS(2905),
    [anon_sym_join] = ACTIONS(2905),
    [anon_sym_on] = ACTIONS(2905),
    [anon_sym_equals] = ACTIONS(2905),
    [anon_sym_let] = ACTIONS(2905),
    [anon_sym_orderby] = ACTIONS(2905),
    [anon_sym_group] = ACTIONS(2905),
    [anon_sym_by] = ACTIONS(2905),
    [anon_sym_select] = ACTIONS(2905),
    [anon_sym_DOT_DOT] = ACTIONS(2905),
    [anon_sym_with] = ACTIONS(2905),
    [anon_sym_AMP_AMP] = ACTIONS(2905),
    [anon_sym_PIPE_PIPE] = ACTIONS(2905),
    [anon_sym_QMARK_QMARK] = ACTIONS(2903),
    [anon_sym_as] = ACTIONS(2905),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2163] = {
    [sym__preprocessor_call] = STATE(2163),
    [anon_sym_SEMI] = ACTIONS(3502),
    [anon_sym_EQ] = ACTIONS(3504),
    [anon_sym_LT] = ACTIONS(3504),
    [anon_sym_COMMA] = ACTIONS(3502),
    [anon_sym_GT] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [anon_sym_RBRACK] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(3502),
    [anon_sym_LPAREN] = ACTIONS(3502),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [anon_sym_in] = ACTIONS(3504),
    [anon_sym_RBRACE] = ACTIONS(3502),
    [anon_sym_EQ_GT] = ACTIONS(3502),
    [anon_sym_where] = ACTIONS(3502),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_BANG] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(3504),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_SLASH] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3504),
    [anon_sym_LT_LT] = ACTIONS(3504),
    [anon_sym_GT_GT] = ACTIONS(3504),
    [anon_sym_EQ_EQ] = ACTIONS(3502),
    [anon_sym_BANG_EQ] = ACTIONS(3502),
    [anon_sym_GT_EQ] = ACTIONS(3502),
    [anon_sym_LT_EQ] = ACTIONS(3502),
    [anon_sym_switch] = ACTIONS(3502),
    [anon_sym_and] = ACTIONS(3502),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3502),
    [anon_sym_DASH_EQ] = ACTIONS(3502),
    [anon_sym_STAR_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_PERCENT_EQ] = ACTIONS(3502),
    [anon_sym_AMP_EQ] = ACTIONS(3502),
    [anon_sym_CARET_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_LT_LT_EQ] = ACTIONS(3502),
    [anon_sym_GT_GT_EQ] = ACTIONS(3502),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3502),
    [anon_sym_is] = ACTIONS(3502),
    [anon_sym_DASH_GT] = ACTIONS(3502),
    [anon_sym_from] = ACTIONS(3502),
    [anon_sym_join] = ACTIONS(3502),
    [anon_sym_on] = ACTIONS(3502),
    [anon_sym_equals] = ACTIONS(3502),
    [anon_sym_into] = ACTIONS(3502),
    [anon_sym_let] = ACTIONS(3502),
    [anon_sym_orderby] = ACTIONS(3502),
    [anon_sym_group] = ACTIONS(3502),
    [anon_sym_by] = ACTIONS(3502),
    [anon_sym_select] = ACTIONS(3502),
    [anon_sym_DOT_DOT] = ACTIONS(3502),
    [anon_sym_with] = ACTIONS(3502),
    [anon_sym_AMP_AMP] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE] = ACTIONS(3502),
    [anon_sym_QMARK_QMARK] = ACTIONS(3504),
    [anon_sym_as] = ACTIONS(3502),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2164] = {
    [sym__preprocessor_call] = STATE(2164),
    [anon_sym_SEMI] = ACTIONS(3320),
    [anon_sym_EQ] = ACTIONS(3322),
    [anon_sym_LT] = ACTIONS(3322),
    [anon_sym_COMMA] = ACTIONS(3320),
    [anon_sym_GT] = ACTIONS(3322),
    [anon_sym_DOT] = ACTIONS(3322),
    [anon_sym_LBRACK] = ACTIONS(3320),
    [anon_sym_RBRACK] = ACTIONS(3320),
    [anon_sym_COLON] = ACTIONS(3320),
    [anon_sym_LPAREN] = ACTIONS(3320),
    [anon_sym_RPAREN] = ACTIONS(3320),
    [anon_sym_in] = ACTIONS(3322),
    [anon_sym_RBRACE] = ACTIONS(3320),
    [anon_sym_EQ_GT] = ACTIONS(3320),
    [anon_sym_where] = ACTIONS(3320),
    [anon_sym_QMARK] = ACTIONS(3322),
    [anon_sym_BANG] = ACTIONS(3322),
    [anon_sym_PLUS_PLUS] = ACTIONS(3320),
    [anon_sym_DASH_DASH] = ACTIONS(3320),
    [anon_sym_PLUS] = ACTIONS(3322),
    [anon_sym_DASH] = ACTIONS(3322),
    [anon_sym_STAR] = ACTIONS(3322),
    [anon_sym_SLASH] = ACTIONS(3322),
    [anon_sym_PERCENT] = ACTIONS(3322),
    [anon_sym_CARET] = ACTIONS(3322),
    [anon_sym_PIPE] = ACTIONS(3322),
    [anon_sym_AMP] = ACTIONS(3322),
    [anon_sym_LT_LT] = ACTIONS(3322),
    [anon_sym_GT_GT] = ACTIONS(3322),
    [anon_sym_EQ_EQ] = ACTIONS(3320),
    [anon_sym_BANG_EQ] = ACTIONS(3320),
    [anon_sym_GT_EQ] = ACTIONS(3320),
    [anon_sym_LT_EQ] = ACTIONS(3320),
    [anon_sym_switch] = ACTIONS(3320),
    [anon_sym_and] = ACTIONS(3320),
    [anon_sym_or] = ACTIONS(3322),
    [anon_sym_PLUS_EQ] = ACTIONS(3320),
    [anon_sym_DASH_EQ] = ACTIONS(3320),
    [anon_sym_STAR_EQ] = ACTIONS(3320),
    [anon_sym_SLASH_EQ] = ACTIONS(3320),
    [anon_sym_PERCENT_EQ] = ACTIONS(3320),
    [anon_sym_AMP_EQ] = ACTIONS(3320),
    [anon_sym_CARET_EQ] = ACTIONS(3320),
    [anon_sym_PIPE_EQ] = ACTIONS(3320),
    [anon_sym_LT_LT_EQ] = ACTIONS(3320),
    [anon_sym_GT_GT_EQ] = ACTIONS(3320),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3320),
    [anon_sym_is] = ACTIONS(3320),
    [anon_sym_DASH_GT] = ACTIONS(3320),
    [anon_sym_from] = ACTIONS(3320),
    [anon_sym_join] = ACTIONS(3320),
    [anon_sym_on] = ACTIONS(3320),
    [anon_sym_equals] = ACTIONS(3320),
    [anon_sym_into] = ACTIONS(3320),
    [anon_sym_let] = ACTIONS(3320),
    [anon_sym_orderby] = ACTIONS(3320),
    [anon_sym_group] = ACTIONS(3320),
    [anon_sym_by] = ACTIONS(3320),
    [anon_sym_select] = ACTIONS(3320),
    [anon_sym_DOT_DOT] = ACTIONS(3320),
    [anon_sym_with] = ACTIONS(3320),
    [anon_sym_AMP_AMP] = ACTIONS(3320),
    [anon_sym_PIPE_PIPE] = ACTIONS(3320),
    [anon_sym_QMARK_QMARK] = ACTIONS(3322),
    [anon_sym_as] = ACTIONS(3320),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2165] = {
    [sym__preprocessor_call] = STATE(2165),
    [anon_sym_SEMI] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3508),
    [anon_sym_LT] = ACTIONS(3508),
    [anon_sym_COMMA] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3508),
    [anon_sym_DOT] = ACTIONS(3508),
    [anon_sym_LBRACK] = ACTIONS(3506),
    [anon_sym_RBRACK] = ACTIONS(3506),
    [anon_sym_COLON] = ACTIONS(3506),
    [anon_sym_LPAREN] = ACTIONS(3506),
    [anon_sym_RPAREN] = ACTIONS(3506),
    [anon_sym_in] = ACTIONS(3508),
    [anon_sym_RBRACE] = ACTIONS(3506),
    [anon_sym_EQ_GT] = ACTIONS(3506),
    [anon_sym_where] = ACTIONS(3506),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_BANG] = ACTIONS(3508),
    [anon_sym_PLUS_PLUS] = ACTIONS(3506),
    [anon_sym_DASH_DASH] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3508),
    [anon_sym_DASH] = ACTIONS(3508),
    [anon_sym_STAR] = ACTIONS(3508),
    [anon_sym_SLASH] = ACTIONS(3508),
    [anon_sym_PERCENT] = ACTIONS(3508),
    [anon_sym_CARET] = ACTIONS(3508),
    [anon_sym_PIPE] = ACTIONS(3508),
    [anon_sym_AMP] = ACTIONS(3508),
    [anon_sym_LT_LT] = ACTIONS(3508),
    [anon_sym_GT_GT] = ACTIONS(3508),
    [anon_sym_EQ_EQ] = ACTIONS(3506),
    [anon_sym_BANG_EQ] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3506),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_switch] = ACTIONS(3506),
    [anon_sym_and] = ACTIONS(3506),
    [anon_sym_or] = ACTIONS(3508),
    [anon_sym_PLUS_EQ] = ACTIONS(3506),
    [anon_sym_DASH_EQ] = ACTIONS(3506),
    [anon_sym_STAR_EQ] = ACTIONS(3506),
    [anon_sym_SLASH_EQ] = ACTIONS(3506),
    [anon_sym_PERCENT_EQ] = ACTIONS(3506),
    [anon_sym_AMP_EQ] = ACTIONS(3506),
    [anon_sym_CARET_EQ] = ACTIONS(3506),
    [anon_sym_PIPE_EQ] = ACTIONS(3506),
    [anon_sym_LT_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT_GT_EQ] = ACTIONS(3506),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3506),
    [anon_sym_is] = ACTIONS(3506),
    [anon_sym_DASH_GT] = ACTIONS(3506),
    [anon_sym_from] = ACTIONS(3506),
    [anon_sym_join] = ACTIONS(3506),
    [anon_sym_on] = ACTIONS(3506),
    [anon_sym_equals] = ACTIONS(3506),
    [anon_sym_into] = ACTIONS(3506),
    [anon_sym_let] = ACTIONS(3506),
    [anon_sym_orderby] = ACTIONS(3506),
    [anon_sym_group] = ACTIONS(3506),
    [anon_sym_by] = ACTIONS(3506),
    [anon_sym_select] = ACTIONS(3506),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_with] = ACTIONS(3506),
    [anon_sym_AMP_AMP] = ACTIONS(3506),
    [anon_sym_PIPE_PIPE] = ACTIONS(3506),
    [anon_sym_QMARK_QMARK] = ACTIONS(3508),
    [anon_sym_as] = ACTIONS(3506),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2166] = {
    [sym__preprocessor_call] = STATE(2166),
    [anon_sym_SEMI] = ACTIONS(3510),
    [anon_sym_EQ] = ACTIONS(3512),
    [anon_sym_LT] = ACTIONS(3512),
    [anon_sym_COMMA] = ACTIONS(3510),
    [anon_sym_GT] = ACTIONS(3512),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3510),
    [anon_sym_RBRACK] = ACTIONS(3510),
    [anon_sym_COLON] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3510),
    [anon_sym_RPAREN] = ACTIONS(3510),
    [anon_sym_in] = ACTIONS(3512),
    [anon_sym_RBRACE] = ACTIONS(3510),
    [anon_sym_EQ_GT] = ACTIONS(3510),
    [anon_sym_where] = ACTIONS(3510),
    [anon_sym_QMARK] = ACTIONS(3512),
    [anon_sym_BANG] = ACTIONS(3512),
    [anon_sym_PLUS_PLUS] = ACTIONS(3510),
    [anon_sym_DASH_DASH] = ACTIONS(3510),
    [anon_sym_PLUS] = ACTIONS(3512),
    [anon_sym_DASH] = ACTIONS(3512),
    [anon_sym_STAR] = ACTIONS(3512),
    [anon_sym_SLASH] = ACTIONS(3512),
    [anon_sym_PERCENT] = ACTIONS(3512),
    [anon_sym_CARET] = ACTIONS(3512),
    [anon_sym_PIPE] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3512),
    [anon_sym_LT_LT] = ACTIONS(3512),
    [anon_sym_GT_GT] = ACTIONS(3512),
    [anon_sym_EQ_EQ] = ACTIONS(3510),
    [anon_sym_BANG_EQ] = ACTIONS(3510),
    [anon_sym_GT_EQ] = ACTIONS(3510),
    [anon_sym_LT_EQ] = ACTIONS(3510),
    [anon_sym_switch] = ACTIONS(3510),
    [anon_sym_and] = ACTIONS(3510),
    [anon_sym_or] = ACTIONS(3512),
    [anon_sym_PLUS_EQ] = ACTIONS(3510),
    [anon_sym_DASH_EQ] = ACTIONS(3510),
    [anon_sym_STAR_EQ] = ACTIONS(3510),
    [anon_sym_SLASH_EQ] = ACTIONS(3510),
    [anon_sym_PERCENT_EQ] = ACTIONS(3510),
    [anon_sym_AMP_EQ] = ACTIONS(3510),
    [anon_sym_CARET_EQ] = ACTIONS(3510),
    [anon_sym_PIPE_EQ] = ACTIONS(3510),
    [anon_sym_LT_LT_EQ] = ACTIONS(3510),
    [anon_sym_GT_GT_EQ] = ACTIONS(3510),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3510),
    [anon_sym_is] = ACTIONS(3510),
    [anon_sym_DASH_GT] = ACTIONS(3510),
    [anon_sym_from] = ACTIONS(3510),
    [anon_sym_join] = ACTIONS(3510),
    [anon_sym_on] = ACTIONS(3510),
    [anon_sym_equals] = ACTIONS(3510),
    [anon_sym_into] = ACTIONS(3510),
    [anon_sym_let] = ACTIONS(3510),
    [anon_sym_orderby] = ACTIONS(3510),
    [anon_sym_group] = ACTIONS(3510),
    [anon_sym_by] = ACTIONS(3510),
    [anon_sym_select] = ACTIONS(3510),
    [anon_sym_DOT_DOT] = ACTIONS(3510),
    [anon_sym_with] = ACTIONS(3510),
    [anon_sym_AMP_AMP] = ACTIONS(3510),
    [anon_sym_PIPE_PIPE] = ACTIONS(3510),
    [anon_sym_QMARK_QMARK] = ACTIONS(3512),
    [anon_sym_as] = ACTIONS(3510),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2167] = {
    [sym__preprocessor_call] = STATE(2167),
    [anon_sym_SEMI] = ACTIONS(2947),
    [anon_sym_EQ] = ACTIONS(2945),
    [anon_sym_LT] = ACTIONS(2945),
    [anon_sym_COMMA] = ACTIONS(2947),
    [anon_sym_GT] = ACTIONS(2945),
    [anon_sym_DOT] = ACTIONS(2945),
    [anon_sym_LBRACK] = ACTIONS(2947),
    [anon_sym_RBRACK] = ACTIONS(2947),
    [anon_sym_COLON] = ACTIONS(2947),
    [anon_sym_LPAREN] = ACTIONS(2947),
    [anon_sym_RPAREN] = ACTIONS(2947),
    [anon_sym_in] = ACTIONS(2947),
    [anon_sym_LBRACE] = ACTIONS(2947),
    [anon_sym_RBRACE] = ACTIONS(2947),
    [anon_sym_EQ_GT] = ACTIONS(2947),
    [anon_sym_where] = ACTIONS(2947),
    [anon_sym_QMARK] = ACTIONS(2945),
    [anon_sym_BANG] = ACTIONS(2945),
    [anon_sym_PLUS_PLUS] = ACTIONS(2947),
    [anon_sym_DASH_DASH] = ACTIONS(2947),
    [anon_sym_PLUS] = ACTIONS(2945),
    [anon_sym_DASH] = ACTIONS(2945),
    [anon_sym_STAR] = ACTIONS(2945),
    [anon_sym_SLASH] = ACTIONS(2945),
    [anon_sym_PERCENT] = ACTIONS(2945),
    [anon_sym_CARET] = ACTIONS(2945),
    [anon_sym_PIPE] = ACTIONS(2945),
    [anon_sym_AMP] = ACTIONS(2945),
    [anon_sym_LT_LT] = ACTIONS(2945),
    [anon_sym_GT_GT] = ACTIONS(2945),
    [anon_sym_EQ_EQ] = ACTIONS(2947),
    [anon_sym_BANG_EQ] = ACTIONS(2947),
    [anon_sym_GT_EQ] = ACTIONS(2947),
    [anon_sym_LT_EQ] = ACTIONS(2947),
    [anon_sym_switch] = ACTIONS(2947),
    [anon_sym_and] = ACTIONS(2947),
    [anon_sym_or] = ACTIONS(2945),
    [anon_sym_PLUS_EQ] = ACTIONS(2947),
    [anon_sym_DASH_EQ] = ACTIONS(2947),
    [anon_sym_STAR_EQ] = ACTIONS(2947),
    [anon_sym_SLASH_EQ] = ACTIONS(2947),
    [anon_sym_PERCENT_EQ] = ACTIONS(2947),
    [anon_sym_AMP_EQ] = ACTIONS(2947),
    [anon_sym_CARET_EQ] = ACTIONS(2947),
    [anon_sym_PIPE_EQ] = ACTIONS(2947),
    [anon_sym_LT_LT_EQ] = ACTIONS(2947),
    [anon_sym_GT_GT_EQ] = ACTIONS(2947),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2947),
    [anon_sym_is] = ACTIONS(2947),
    [anon_sym_DASH_GT] = ACTIONS(2947),
    [anon_sym_from] = ACTIONS(2947),
    [anon_sym_join] = ACTIONS(2947),
    [anon_sym_on] = ACTIONS(2947),
    [anon_sym_equals] = ACTIONS(2947),
    [anon_sym_let] = ACTIONS(2947),
    [anon_sym_orderby] = ACTIONS(2947),
    [anon_sym_group] = ACTIONS(2947),
    [anon_sym_by] = ACTIONS(2947),
    [anon_sym_select] = ACTIONS(2947),
    [anon_sym_DOT_DOT] = ACTIONS(2947),
    [anon_sym_with] = ACTIONS(2947),
    [anon_sym_AMP_AMP] = ACTIONS(2947),
    [anon_sym_PIPE_PIPE] = ACTIONS(2947),
    [anon_sym_QMARK_QMARK] = ACTIONS(2945),
    [anon_sym_as] = ACTIONS(2947),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2168] = {
    [sym__preprocessor_call] = STATE(2168),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_EQ] = ACTIONS(2216),
    [anon_sym_LT] = ACTIONS(2216),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2216),
    [anon_sym_DOT] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_RBRACK] = ACTIONS(2214),
    [anon_sym_COLON] = ACTIONS(2214),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_RPAREN] = ACTIONS(2214),
    [anon_sym_in] = ACTIONS(2216),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_EQ_GT] = ACTIONS(2214),
    [anon_sym_where] = ACTIONS(2214),
    [anon_sym_QMARK] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_PERCENT] = ACTIONS(2216),
    [anon_sym_CARET] = ACTIONS(2216),
    [anon_sym_PIPE] = ACTIONS(2216),
    [anon_sym_AMP] = ACTIONS(2216),
    [anon_sym_LT_LT] = ACTIONS(2216),
    [anon_sym_GT_GT] = ACTIONS(2216),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_switch] = ACTIONS(2214),
    [anon_sym_and] = ACTIONS(2214),
    [anon_sym_or] = ACTIONS(2216),
    [anon_sym_PLUS_EQ] = ACTIONS(2214),
    [anon_sym_DASH_EQ] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2214),
    [anon_sym_SLASH_EQ] = ACTIONS(2214),
    [anon_sym_PERCENT_EQ] = ACTIONS(2214),
    [anon_sym_AMP_EQ] = ACTIONS(2214),
    [anon_sym_CARET_EQ] = ACTIONS(2214),
    [anon_sym_PIPE_EQ] = ACTIONS(2214),
    [anon_sym_LT_LT_EQ] = ACTIONS(2214),
    [anon_sym_GT_GT_EQ] = ACTIONS(2214),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2214),
    [anon_sym_is] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_from] = ACTIONS(2214),
    [anon_sym_join] = ACTIONS(2214),
    [anon_sym_on] = ACTIONS(2214),
    [anon_sym_equals] = ACTIONS(2214),
    [anon_sym_into] = ACTIONS(2214),
    [anon_sym_let] = ACTIONS(2214),
    [anon_sym_orderby] = ACTIONS(2214),
    [anon_sym_group] = ACTIONS(2214),
    [anon_sym_by] = ACTIONS(2214),
    [anon_sym_select] = ACTIONS(2214),
    [anon_sym_DOT_DOT] = ACTIONS(2214),
    [anon_sym_with] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2216),
    [anon_sym_as] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2169] = {
    [sym__preprocessor_call] = STATE(2169),
    [anon_sym_SEMI] = ACTIONS(2862),
    [anon_sym_EQ] = ACTIONS(2860),
    [anon_sym_LT] = ACTIONS(2860),
    [anon_sym_COMMA] = ACTIONS(2862),
    [anon_sym_GT] = ACTIONS(2860),
    [anon_sym_DOT] = ACTIONS(2860),
    [anon_sym_LBRACK] = ACTIONS(2862),
    [anon_sym_RBRACK] = ACTIONS(2862),
    [anon_sym_COLON] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_RPAREN] = ACTIONS(2862),
    [anon_sym_in] = ACTIONS(2862),
    [anon_sym_LBRACE] = ACTIONS(2862),
    [anon_sym_RBRACE] = ACTIONS(2862),
    [anon_sym_EQ_GT] = ACTIONS(2862),
    [anon_sym_where] = ACTIONS(2862),
    [anon_sym_QMARK] = ACTIONS(2860),
    [anon_sym_BANG] = ACTIONS(2860),
    [anon_sym_PLUS_PLUS] = ACTIONS(2862),
    [anon_sym_DASH_DASH] = ACTIONS(2862),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_STAR] = ACTIONS(2860),
    [anon_sym_SLASH] = ACTIONS(2860),
    [anon_sym_PERCENT] = ACTIONS(2860),
    [anon_sym_CARET] = ACTIONS(2860),
    [anon_sym_PIPE] = ACTIONS(2860),
    [anon_sym_AMP] = ACTIONS(2860),
    [anon_sym_LT_LT] = ACTIONS(2860),
    [anon_sym_GT_GT] = ACTIONS(2860),
    [anon_sym_EQ_EQ] = ACTIONS(2862),
    [anon_sym_BANG_EQ] = ACTIONS(2862),
    [anon_sym_GT_EQ] = ACTIONS(2862),
    [anon_sym_LT_EQ] = ACTIONS(2862),
    [anon_sym_switch] = ACTIONS(2862),
    [anon_sym_and] = ACTIONS(2862),
    [anon_sym_or] = ACTIONS(2860),
    [anon_sym_PLUS_EQ] = ACTIONS(2862),
    [anon_sym_DASH_EQ] = ACTIONS(2862),
    [anon_sym_STAR_EQ] = ACTIONS(2862),
    [anon_sym_SLASH_EQ] = ACTIONS(2862),
    [anon_sym_PERCENT_EQ] = ACTIONS(2862),
    [anon_sym_AMP_EQ] = ACTIONS(2862),
    [anon_sym_CARET_EQ] = ACTIONS(2862),
    [anon_sym_PIPE_EQ] = ACTIONS(2862),
    [anon_sym_LT_LT_EQ] = ACTIONS(2862),
    [anon_sym_GT_GT_EQ] = ACTIONS(2862),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2862),
    [anon_sym_is] = ACTIONS(2862),
    [anon_sym_DASH_GT] = ACTIONS(2862),
    [anon_sym_from] = ACTIONS(2862),
    [anon_sym_join] = ACTIONS(2862),
    [anon_sym_on] = ACTIONS(2862),
    [anon_sym_equals] = ACTIONS(2862),
    [anon_sym_let] = ACTIONS(2862),
    [anon_sym_orderby] = ACTIONS(2862),
    [anon_sym_group] = ACTIONS(2862),
    [anon_sym_by] = ACTIONS(2862),
    [anon_sym_select] = ACTIONS(2862),
    [anon_sym_DOT_DOT] = ACTIONS(2862),
    [anon_sym_with] = ACTIONS(2862),
    [anon_sym_AMP_AMP] = ACTIONS(2862),
    [anon_sym_PIPE_PIPE] = ACTIONS(2862),
    [anon_sym_QMARK_QMARK] = ACTIONS(2860),
    [anon_sym_as] = ACTIONS(2862),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2170] = {
    [sym__preprocessor_call] = STATE(2170),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_RBRACK] = ACTIONS(1977),
    [anon_sym_COLON] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_in] = ACTIONS(1979),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_EQ_GT] = ACTIONS(1977),
    [anon_sym_where] = ACTIONS(1977),
    [anon_sym_QMARK] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1979),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_EQ] = ACTIONS(1977),
    [anon_sym_switch] = ACTIONS(1977),
    [anon_sym_and] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1977),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1977),
    [anon_sym_is] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [anon_sym_from] = ACTIONS(1977),
    [anon_sym_join] = ACTIONS(1977),
    [anon_sym_on] = ACTIONS(1977),
    [anon_sym_equals] = ACTIONS(1977),
    [anon_sym_into] = ACTIONS(1977),
    [anon_sym_let] = ACTIONS(1977),
    [anon_sym_orderby] = ACTIONS(1977),
    [anon_sym_group] = ACTIONS(1977),
    [anon_sym_by] = ACTIONS(1977),
    [anon_sym_select] = ACTIONS(1977),
    [anon_sym_DOT_DOT] = ACTIONS(1977),
    [anon_sym_with] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_QMARK_QMARK] = ACTIONS(1979),
    [anon_sym_as] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2171] = {
    [sym__preprocessor_call] = STATE(2171),
    [anon_sym_SEMI] = ACTIONS(3306),
    [anon_sym_EQ] = ACTIONS(3308),
    [anon_sym_LT] = ACTIONS(3308),
    [anon_sym_COMMA] = ACTIONS(3306),
    [anon_sym_GT] = ACTIONS(3308),
    [anon_sym_DOT] = ACTIONS(3308),
    [anon_sym_LBRACK] = ACTIONS(3306),
    [anon_sym_RBRACK] = ACTIONS(3306),
    [anon_sym_COLON] = ACTIONS(3306),
    [anon_sym_LPAREN] = ACTIONS(3306),
    [anon_sym_RPAREN] = ACTIONS(3306),
    [anon_sym_in] = ACTIONS(3306),
    [anon_sym_LBRACE] = ACTIONS(3306),
    [anon_sym_RBRACE] = ACTIONS(3306),
    [anon_sym_EQ_GT] = ACTIONS(3306),
    [anon_sym_where] = ACTIONS(3306),
    [anon_sym_QMARK] = ACTIONS(3308),
    [anon_sym_BANG] = ACTIONS(3308),
    [anon_sym_PLUS_PLUS] = ACTIONS(3306),
    [anon_sym_DASH_DASH] = ACTIONS(3306),
    [anon_sym_PLUS] = ACTIONS(3308),
    [anon_sym_DASH] = ACTIONS(3308),
    [anon_sym_STAR] = ACTIONS(3308),
    [anon_sym_SLASH] = ACTIONS(3308),
    [anon_sym_PERCENT] = ACTIONS(3308),
    [anon_sym_CARET] = ACTIONS(3308),
    [anon_sym_PIPE] = ACTIONS(3308),
    [anon_sym_AMP] = ACTIONS(3308),
    [anon_sym_LT_LT] = ACTIONS(3308),
    [anon_sym_GT_GT] = ACTIONS(3308),
    [anon_sym_EQ_EQ] = ACTIONS(3306),
    [anon_sym_BANG_EQ] = ACTIONS(3306),
    [anon_sym_GT_EQ] = ACTIONS(3306),
    [anon_sym_LT_EQ] = ACTIONS(3306),
    [anon_sym_switch] = ACTIONS(3306),
    [anon_sym_and] = ACTIONS(3306),
    [anon_sym_or] = ACTIONS(3308),
    [anon_sym_PLUS_EQ] = ACTIONS(3306),
    [anon_sym_DASH_EQ] = ACTIONS(3306),
    [anon_sym_STAR_EQ] = ACTIONS(3306),
    [anon_sym_SLASH_EQ] = ACTIONS(3306),
    [anon_sym_PERCENT_EQ] = ACTIONS(3306),
    [anon_sym_AMP_EQ] = ACTIONS(3306),
    [anon_sym_CARET_EQ] = ACTIONS(3306),
    [anon_sym_PIPE_EQ] = ACTIONS(3306),
    [anon_sym_LT_LT_EQ] = ACTIONS(3306),
    [anon_sym_GT_GT_EQ] = ACTIONS(3306),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3306),
    [anon_sym_is] = ACTIONS(3306),
    [anon_sym_DASH_GT] = ACTIONS(3306),
    [anon_sym_from] = ACTIONS(3306),
    [anon_sym_join] = ACTIONS(3306),
    [anon_sym_on] = ACTIONS(3306),
    [anon_sym_equals] = ACTIONS(3306),
    [anon_sym_let] = ACTIONS(3306),
    [anon_sym_orderby] = ACTIONS(3306),
    [anon_sym_group] = ACTIONS(3306),
    [anon_sym_by] = ACTIONS(3306),
    [anon_sym_select] = ACTIONS(3306),
    [anon_sym_DOT_DOT] = ACTIONS(3306),
    [anon_sym_with] = ACTIONS(3306),
    [anon_sym_AMP_AMP] = ACTIONS(3306),
    [anon_sym_PIPE_PIPE] = ACTIONS(3306),
    [anon_sym_QMARK_QMARK] = ACTIONS(3308),
    [anon_sym_as] = ACTIONS(3306),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2172] = {
    [sym__preprocessor_call] = STATE(2172),
    [anon_sym_SEMI] = ACTIONS(3374),
    [anon_sym_EQ] = ACTIONS(3376),
    [anon_sym_LT] = ACTIONS(3376),
    [anon_sym_COMMA] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3376),
    [anon_sym_DOT] = ACTIONS(3376),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_RBRACK] = ACTIONS(3374),
    [anon_sym_COLON] = ACTIONS(3374),
    [anon_sym_LPAREN] = ACTIONS(3374),
    [anon_sym_RPAREN] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3376),
    [anon_sym_RBRACE] = ACTIONS(3374),
    [anon_sym_EQ_GT] = ACTIONS(3374),
    [anon_sym_where] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3376),
    [anon_sym_BANG] = ACTIONS(3376),
    [anon_sym_PLUS_PLUS] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3376),
    [anon_sym_DASH] = ACTIONS(3376),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_SLASH] = ACTIONS(3376),
    [anon_sym_PERCENT] = ACTIONS(3376),
    [anon_sym_CARET] = ACTIONS(3376),
    [anon_sym_PIPE] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3376),
    [anon_sym_LT_LT] = ACTIONS(3376),
    [anon_sym_GT_GT] = ACTIONS(3376),
    [anon_sym_EQ_EQ] = ACTIONS(3374),
    [anon_sym_BANG_EQ] = ACTIONS(3374),
    [anon_sym_GT_EQ] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3374),
    [anon_sym_switch] = ACTIONS(3374),
    [anon_sym_and] = ACTIONS(3374),
    [anon_sym_or] = ACTIONS(3376),
    [anon_sym_PLUS_EQ] = ACTIONS(3374),
    [anon_sym_DASH_EQ] = ACTIONS(3374),
    [anon_sym_STAR_EQ] = ACTIONS(3374),
    [anon_sym_SLASH_EQ] = ACTIONS(3374),
    [anon_sym_PERCENT_EQ] = ACTIONS(3374),
    [anon_sym_AMP_EQ] = ACTIONS(3374),
    [anon_sym_CARET_EQ] = ACTIONS(3374),
    [anon_sym_PIPE_EQ] = ACTIONS(3374),
    [anon_sym_LT_LT_EQ] = ACTIONS(3374),
    [anon_sym_GT_GT_EQ] = ACTIONS(3374),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3374),
    [anon_sym_is] = ACTIONS(3374),
    [anon_sym_DASH_GT] = ACTIONS(3374),
    [anon_sym_from] = ACTIONS(3374),
    [anon_sym_join] = ACTIONS(3374),
    [anon_sym_on] = ACTIONS(3374),
    [anon_sym_equals] = ACTIONS(3374),
    [anon_sym_into] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_orderby] = ACTIONS(3374),
    [anon_sym_group] = ACTIONS(3374),
    [anon_sym_by] = ACTIONS(3374),
    [anon_sym_select] = ACTIONS(3374),
    [anon_sym_DOT_DOT] = ACTIONS(3374),
    [anon_sym_with] = ACTIONS(3374),
    [anon_sym_AMP_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3374),
    [anon_sym_QMARK_QMARK] = ACTIONS(3376),
    [anon_sym_as] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2173] = {
    [sym__preprocessor_call] = STATE(2173),
    [anon_sym_SEMI] = ACTIONS(3514),
    [anon_sym_EQ] = ACTIONS(3516),
    [anon_sym_LT] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3514),
    [anon_sym_GT] = ACTIONS(3516),
    [anon_sym_DOT] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_RBRACK] = ACTIONS(3514),
    [anon_sym_COLON] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(3514),
    [anon_sym_RPAREN] = ACTIONS(3514),
    [anon_sym_in] = ACTIONS(3516),
    [anon_sym_RBRACE] = ACTIONS(3514),
    [anon_sym_EQ_GT] = ACTIONS(3514),
    [anon_sym_where] = ACTIONS(3514),
    [anon_sym_QMARK] = ACTIONS(3516),
    [anon_sym_BANG] = ACTIONS(3516),
    [anon_sym_PLUS_PLUS] = ACTIONS(3514),
    [anon_sym_DASH_DASH] = ACTIONS(3514),
    [anon_sym_PLUS] = ACTIONS(3516),
    [anon_sym_DASH] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(3516),
    [anon_sym_SLASH] = ACTIONS(3516),
    [anon_sym_PERCENT] = ACTIONS(3516),
    [anon_sym_CARET] = ACTIONS(3516),
    [anon_sym_PIPE] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3516),
    [anon_sym_LT_LT] = ACTIONS(3516),
    [anon_sym_GT_GT] = ACTIONS(3516),
    [anon_sym_EQ_EQ] = ACTIONS(3514),
    [anon_sym_BANG_EQ] = ACTIONS(3514),
    [anon_sym_GT_EQ] = ACTIONS(3514),
    [anon_sym_LT_EQ] = ACTIONS(3514),
    [anon_sym_switch] = ACTIONS(3514),
    [anon_sym_and] = ACTIONS(3514),
    [anon_sym_or] = ACTIONS(3516),
    [anon_sym_PLUS_EQ] = ACTIONS(3514),
    [anon_sym_DASH_EQ] = ACTIONS(3514),
    [anon_sym_STAR_EQ] = ACTIONS(3514),
    [anon_sym_SLASH_EQ] = ACTIONS(3514),
    [anon_sym_PERCENT_EQ] = ACTIONS(3514),
    [anon_sym_AMP_EQ] = ACTIONS(3514),
    [anon_sym_CARET_EQ] = ACTIONS(3514),
    [anon_sym_PIPE_EQ] = ACTIONS(3514),
    [anon_sym_LT_LT_EQ] = ACTIONS(3514),
    [anon_sym_GT_GT_EQ] = ACTIONS(3514),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3514),
    [anon_sym_is] = ACTIONS(3514),
    [anon_sym_DASH_GT] = ACTIONS(3514),
    [anon_sym_from] = ACTIONS(3514),
    [anon_sym_join] = ACTIONS(3514),
    [anon_sym_on] = ACTIONS(3514),
    [anon_sym_equals] = ACTIONS(3514),
    [anon_sym_into] = ACTIONS(3514),
    [anon_sym_let] = ACTIONS(3514),
    [anon_sym_orderby] = ACTIONS(3514),
    [anon_sym_group] = ACTIONS(3514),
    [anon_sym_by] = ACTIONS(3514),
    [anon_sym_select] = ACTIONS(3514),
    [anon_sym_DOT_DOT] = ACTIONS(3514),
    [anon_sym_with] = ACTIONS(3514),
    [anon_sym_AMP_AMP] = ACTIONS(3514),
    [anon_sym_PIPE_PIPE] = ACTIONS(3514),
    [anon_sym_QMARK_QMARK] = ACTIONS(3516),
    [anon_sym_as] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2174] = {
    [sym__preprocessor_call] = STATE(2174),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_DOT] = ACTIONS(1986),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_RBRACK] = ACTIONS(1981),
    [anon_sym_COLON] = ACTIONS(1981),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_in] = ACTIONS(1986),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_EQ_GT] = ACTIONS(1981),
    [anon_sym_where] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(1986),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1986),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_LT_LT] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1986),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1981),
    [anon_sym_switch] = ACTIONS(1981),
    [anon_sym_and] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1986),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1981),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1981),
    [anon_sym_is] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [anon_sym_from] = ACTIONS(1981),
    [anon_sym_join] = ACTIONS(1981),
    [anon_sym_on] = ACTIONS(1981),
    [anon_sym_equals] = ACTIONS(1981),
    [anon_sym_into] = ACTIONS(1981),
    [anon_sym_let] = ACTIONS(1981),
    [anon_sym_orderby] = ACTIONS(1981),
    [anon_sym_group] = ACTIONS(1981),
    [anon_sym_by] = ACTIONS(1981),
    [anon_sym_select] = ACTIONS(1981),
    [anon_sym_DOT_DOT] = ACTIONS(1981),
    [anon_sym_with] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_QMARK_QMARK] = ACTIONS(1986),
    [anon_sym_as] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2175] = {
    [sym__preprocessor_call] = STATE(2175),
    [anon_sym_SEMI] = ACTIONS(3518),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(3520),
    [anon_sym_COMMA] = ACTIONS(3518),
    [anon_sym_GT] = ACTIONS(3520),
    [anon_sym_DOT] = ACTIONS(3520),
    [anon_sym_LBRACK] = ACTIONS(3518),
    [anon_sym_RBRACK] = ACTIONS(3518),
    [anon_sym_COLON] = ACTIONS(3518),
    [anon_sym_LPAREN] = ACTIONS(3518),
    [anon_sym_RPAREN] = ACTIONS(3518),
    [anon_sym_in] = ACTIONS(3520),
    [anon_sym_RBRACE] = ACTIONS(3518),
    [anon_sym_EQ_GT] = ACTIONS(3518),
    [anon_sym_where] = ACTIONS(3518),
    [anon_sym_QMARK] = ACTIONS(3520),
    [anon_sym_BANG] = ACTIONS(3520),
    [anon_sym_PLUS_PLUS] = ACTIONS(3518),
    [anon_sym_DASH_DASH] = ACTIONS(3518),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3520),
    [anon_sym_PERCENT] = ACTIONS(3520),
    [anon_sym_CARET] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_LT_LT] = ACTIONS(3520),
    [anon_sym_GT_GT] = ACTIONS(3520),
    [anon_sym_EQ_EQ] = ACTIONS(3518),
    [anon_sym_BANG_EQ] = ACTIONS(3518),
    [anon_sym_GT_EQ] = ACTIONS(3518),
    [anon_sym_LT_EQ] = ACTIONS(3518),
    [anon_sym_switch] = ACTIONS(3518),
    [anon_sym_and] = ACTIONS(3518),
    [anon_sym_or] = ACTIONS(3520),
    [anon_sym_PLUS_EQ] = ACTIONS(3518),
    [anon_sym_DASH_EQ] = ACTIONS(3518),
    [anon_sym_STAR_EQ] = ACTIONS(3518),
    [anon_sym_SLASH_EQ] = ACTIONS(3518),
    [anon_sym_PERCENT_EQ] = ACTIONS(3518),
    [anon_sym_AMP_EQ] = ACTIONS(3518),
    [anon_sym_CARET_EQ] = ACTIONS(3518),
    [anon_sym_PIPE_EQ] = ACTIONS(3518),
    [anon_sym_LT_LT_EQ] = ACTIONS(3518),
    [anon_sym_GT_GT_EQ] = ACTIONS(3518),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3518),
    [anon_sym_is] = ACTIONS(3518),
    [anon_sym_DASH_GT] = ACTIONS(3518),
    [anon_sym_from] = ACTIONS(3518),
    [anon_sym_join] = ACTIONS(3518),
    [anon_sym_on] = ACTIONS(3518),
    [anon_sym_equals] = ACTIONS(3518),
    [anon_sym_into] = ACTIONS(3518),
    [anon_sym_let] = ACTIONS(3518),
    [anon_sym_orderby] = ACTIONS(3518),
    [anon_sym_group] = ACTIONS(3518),
    [anon_sym_by] = ACTIONS(3518),
    [anon_sym_select] = ACTIONS(3518),
    [anon_sym_DOT_DOT] = ACTIONS(3518),
    [anon_sym_with] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_PIPE_PIPE] = ACTIONS(3518),
    [anon_sym_QMARK_QMARK] = ACTIONS(3520),
    [anon_sym_as] = ACTIONS(3518),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2176] = {
    [sym__preprocessor_call] = STATE(2176),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_EQ] = ACTIONS(3524),
    [anon_sym_LT] = ACTIONS(3524),
    [anon_sym_COMMA] = ACTIONS(3522),
    [anon_sym_GT] = ACTIONS(3524),
    [anon_sym_DOT] = ACTIONS(3524),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_RBRACK] = ACTIONS(3522),
    [anon_sym_COLON] = ACTIONS(3522),
    [anon_sym_LPAREN] = ACTIONS(3522),
    [anon_sym_RPAREN] = ACTIONS(3522),
    [anon_sym_in] = ACTIONS(3524),
    [anon_sym_RBRACE] = ACTIONS(3522),
    [anon_sym_EQ_GT] = ACTIONS(3522),
    [anon_sym_where] = ACTIONS(3522),
    [anon_sym_QMARK] = ACTIONS(3524),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_PLUS_PLUS] = ACTIONS(3522),
    [anon_sym_DASH_DASH] = ACTIONS(3522),
    [anon_sym_PLUS] = ACTIONS(3524),
    [anon_sym_DASH] = ACTIONS(3524),
    [anon_sym_STAR] = ACTIONS(3524),
    [anon_sym_SLASH] = ACTIONS(3524),
    [anon_sym_PERCENT] = ACTIONS(3524),
    [anon_sym_CARET] = ACTIONS(3524),
    [anon_sym_PIPE] = ACTIONS(3524),
    [anon_sym_AMP] = ACTIONS(3524),
    [anon_sym_LT_LT] = ACTIONS(3524),
    [anon_sym_GT_GT] = ACTIONS(3524),
    [anon_sym_EQ_EQ] = ACTIONS(3522),
    [anon_sym_BANG_EQ] = ACTIONS(3522),
    [anon_sym_GT_EQ] = ACTIONS(3522),
    [anon_sym_LT_EQ] = ACTIONS(3522),
    [anon_sym_switch] = ACTIONS(3522),
    [anon_sym_and] = ACTIONS(3522),
    [anon_sym_or] = ACTIONS(3524),
    [anon_sym_PLUS_EQ] = ACTIONS(3522),
    [anon_sym_DASH_EQ] = ACTIONS(3522),
    [anon_sym_STAR_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_PERCENT_EQ] = ACTIONS(3522),
    [anon_sym_AMP_EQ] = ACTIONS(3522),
    [anon_sym_CARET_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_LT_LT_EQ] = ACTIONS(3522),
    [anon_sym_GT_GT_EQ] = ACTIONS(3522),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3522),
    [anon_sym_is] = ACTIONS(3522),
    [anon_sym_DASH_GT] = ACTIONS(3522),
    [anon_sym_from] = ACTIONS(3522),
    [anon_sym_join] = ACTIONS(3522),
    [anon_sym_on] = ACTIONS(3522),
    [anon_sym_equals] = ACTIONS(3522),
    [anon_sym_into] = ACTIONS(3522),
    [anon_sym_let] = ACTIONS(3522),
    [anon_sym_orderby] = ACTIONS(3522),
    [anon_sym_group] = ACTIONS(3522),
    [anon_sym_by] = ACTIONS(3522),
    [anon_sym_select] = ACTIONS(3522),
    [anon_sym_DOT_DOT] = ACTIONS(3522),
    [anon_sym_with] = ACTIONS(3522),
    [anon_sym_AMP_AMP] = ACTIONS(3522),
    [anon_sym_PIPE_PIPE] = ACTIONS(3522),
    [anon_sym_QMARK_QMARK] = ACTIONS(3524),
    [anon_sym_as] = ACTIONS(3522),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2177] = {
    [sym__preprocessor_call] = STATE(2177),
    [anon_sym_SEMI] = ACTIONS(3316),
    [anon_sym_EQ] = ACTIONS(3318),
    [anon_sym_LT] = ACTIONS(3318),
    [anon_sym_COMMA] = ACTIONS(3316),
    [anon_sym_GT] = ACTIONS(3318),
    [anon_sym_DOT] = ACTIONS(3318),
    [anon_sym_LBRACK] = ACTIONS(3316),
    [anon_sym_RBRACK] = ACTIONS(3316),
    [anon_sym_COLON] = ACTIONS(3316),
    [anon_sym_LPAREN] = ACTIONS(3316),
    [anon_sym_RPAREN] = ACTIONS(3316),
    [anon_sym_in] = ACTIONS(3316),
    [anon_sym_LBRACE] = ACTIONS(3316),
    [anon_sym_RBRACE] = ACTIONS(3316),
    [anon_sym_EQ_GT] = ACTIONS(3316),
    [anon_sym_where] = ACTIONS(3316),
    [anon_sym_QMARK] = ACTIONS(3318),
    [anon_sym_BANG] = ACTIONS(3318),
    [anon_sym_PLUS_PLUS] = ACTIONS(3316),
    [anon_sym_DASH_DASH] = ACTIONS(3316),
    [anon_sym_PLUS] = ACTIONS(3318),
    [anon_sym_DASH] = ACTIONS(3318),
    [anon_sym_STAR] = ACTIONS(3318),
    [anon_sym_SLASH] = ACTIONS(3318),
    [anon_sym_PERCENT] = ACTIONS(3318),
    [anon_sym_CARET] = ACTIONS(3318),
    [anon_sym_PIPE] = ACTIONS(3318),
    [anon_sym_AMP] = ACTIONS(3318),
    [anon_sym_LT_LT] = ACTIONS(3318),
    [anon_sym_GT_GT] = ACTIONS(3318),
    [anon_sym_EQ_EQ] = ACTIONS(3316),
    [anon_sym_BANG_EQ] = ACTIONS(3316),
    [anon_sym_GT_EQ] = ACTIONS(3316),
    [anon_sym_LT_EQ] = ACTIONS(3316),
    [anon_sym_switch] = ACTIONS(3316),
    [anon_sym_and] = ACTIONS(3316),
    [anon_sym_or] = ACTIONS(3318),
    [anon_sym_PLUS_EQ] = ACTIONS(3316),
    [anon_sym_DASH_EQ] = ACTIONS(3316),
    [anon_sym_STAR_EQ] = ACTIONS(3316),
    [anon_sym_SLASH_EQ] = ACTIONS(3316),
    [anon_sym_PERCENT_EQ] = ACTIONS(3316),
    [anon_sym_AMP_EQ] = ACTIONS(3316),
    [anon_sym_CARET_EQ] = ACTIONS(3316),
    [anon_sym_PIPE_EQ] = ACTIONS(3316),
    [anon_sym_LT_LT_EQ] = ACTIONS(3316),
    [anon_sym_GT_GT_EQ] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3316),
    [anon_sym_is] = ACTIONS(3316),
    [anon_sym_DASH_GT] = ACTIONS(3316),
    [anon_sym_from] = ACTIONS(3316),
    [anon_sym_join] = ACTIONS(3316),
    [anon_sym_on] = ACTIONS(3316),
    [anon_sym_equals] = ACTIONS(3316),
    [anon_sym_let] = ACTIONS(3316),
    [anon_sym_orderby] = ACTIONS(3316),
    [anon_sym_group] = ACTIONS(3316),
    [anon_sym_by] = ACTIONS(3316),
    [anon_sym_select] = ACTIONS(3316),
    [anon_sym_DOT_DOT] = ACTIONS(3316),
    [anon_sym_with] = ACTIONS(3316),
    [anon_sym_AMP_AMP] = ACTIONS(3316),
    [anon_sym_PIPE_PIPE] = ACTIONS(3316),
    [anon_sym_QMARK_QMARK] = ACTIONS(3318),
    [anon_sym_as] = ACTIONS(3316),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2178] = {
    [sym__preprocessor_call] = STATE(2178),
    [anon_sym_SEMI] = ACTIONS(3526),
    [anon_sym_EQ] = ACTIONS(3528),
    [anon_sym_LT] = ACTIONS(3528),
    [anon_sym_COMMA] = ACTIONS(3526),
    [anon_sym_GT] = ACTIONS(3528),
    [anon_sym_DOT] = ACTIONS(3528),
    [anon_sym_LBRACK] = ACTIONS(3526),
    [anon_sym_RBRACK] = ACTIONS(3526),
    [anon_sym_COLON] = ACTIONS(3526),
    [anon_sym_LPAREN] = ACTIONS(3526),
    [anon_sym_RPAREN] = ACTIONS(3526),
    [anon_sym_in] = ACTIONS(3528),
    [anon_sym_RBRACE] = ACTIONS(3526),
    [anon_sym_EQ_GT] = ACTIONS(3526),
    [anon_sym_where] = ACTIONS(3526),
    [anon_sym_QMARK] = ACTIONS(3528),
    [anon_sym_BANG] = ACTIONS(3528),
    [anon_sym_PLUS_PLUS] = ACTIONS(3526),
    [anon_sym_DASH_DASH] = ACTIONS(3526),
    [anon_sym_PLUS] = ACTIONS(3528),
    [anon_sym_DASH] = ACTIONS(3528),
    [anon_sym_STAR] = ACTIONS(3528),
    [anon_sym_SLASH] = ACTIONS(3528),
    [anon_sym_PERCENT] = ACTIONS(3528),
    [anon_sym_CARET] = ACTIONS(3528),
    [anon_sym_PIPE] = ACTIONS(3528),
    [anon_sym_AMP] = ACTIONS(3528),
    [anon_sym_LT_LT] = ACTIONS(3528),
    [anon_sym_GT_GT] = ACTIONS(3528),
    [anon_sym_EQ_EQ] = ACTIONS(3526),
    [anon_sym_BANG_EQ] = ACTIONS(3526),
    [anon_sym_GT_EQ] = ACTIONS(3526),
    [anon_sym_LT_EQ] = ACTIONS(3526),
    [anon_sym_switch] = ACTIONS(3526),
    [anon_sym_and] = ACTIONS(3526),
    [anon_sym_or] = ACTIONS(3528),
    [anon_sym_PLUS_EQ] = ACTIONS(3526),
    [anon_sym_DASH_EQ] = ACTIONS(3526),
    [anon_sym_STAR_EQ] = ACTIONS(3526),
    [anon_sym_SLASH_EQ] = ACTIONS(3526),
    [anon_sym_PERCENT_EQ] = ACTIONS(3526),
    [anon_sym_AMP_EQ] = ACTIONS(3526),
    [anon_sym_CARET_EQ] = ACTIONS(3526),
    [anon_sym_PIPE_EQ] = ACTIONS(3526),
    [anon_sym_LT_LT_EQ] = ACTIONS(3526),
    [anon_sym_GT_GT_EQ] = ACTIONS(3526),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3526),
    [anon_sym_is] = ACTIONS(3526),
    [anon_sym_DASH_GT] = ACTIONS(3526),
    [anon_sym_from] = ACTIONS(3526),
    [anon_sym_join] = ACTIONS(3526),
    [anon_sym_on] = ACTIONS(3526),
    [anon_sym_equals] = ACTIONS(3526),
    [anon_sym_into] = ACTIONS(3526),
    [anon_sym_let] = ACTIONS(3526),
    [anon_sym_orderby] = ACTIONS(3526),
    [anon_sym_group] = ACTIONS(3526),
    [anon_sym_by] = ACTIONS(3526),
    [anon_sym_select] = ACTIONS(3526),
    [anon_sym_DOT_DOT] = ACTIONS(3526),
    [anon_sym_with] = ACTIONS(3526),
    [anon_sym_AMP_AMP] = ACTIONS(3526),
    [anon_sym_PIPE_PIPE] = ACTIONS(3526),
    [anon_sym_QMARK_QMARK] = ACTIONS(3528),
    [anon_sym_as] = ACTIONS(3526),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2179] = {
    [sym__preprocessor_call] = STATE(2179),
    [anon_sym_SEMI] = ACTIONS(2901),
    [anon_sym_EQ] = ACTIONS(2899),
    [anon_sym_LT] = ACTIONS(2899),
    [anon_sym_COMMA] = ACTIONS(2901),
    [anon_sym_GT] = ACTIONS(2899),
    [anon_sym_DOT] = ACTIONS(2899),
    [anon_sym_LBRACK] = ACTIONS(2901),
    [anon_sym_RBRACK] = ACTIONS(2901),
    [anon_sym_COLON] = ACTIONS(2901),
    [anon_sym_LPAREN] = ACTIONS(2901),
    [anon_sym_RPAREN] = ACTIONS(2901),
    [anon_sym_in] = ACTIONS(2901),
    [anon_sym_LBRACE] = ACTIONS(2901),
    [anon_sym_RBRACE] = ACTIONS(2901),
    [anon_sym_EQ_GT] = ACTIONS(2901),
    [anon_sym_where] = ACTIONS(2901),
    [anon_sym_QMARK] = ACTIONS(2899),
    [anon_sym_BANG] = ACTIONS(2899),
    [anon_sym_PLUS_PLUS] = ACTIONS(2901),
    [anon_sym_DASH_DASH] = ACTIONS(2901),
    [anon_sym_PLUS] = ACTIONS(2899),
    [anon_sym_DASH] = ACTIONS(2899),
    [anon_sym_STAR] = ACTIONS(2899),
    [anon_sym_SLASH] = ACTIONS(2899),
    [anon_sym_PERCENT] = ACTIONS(2899),
    [anon_sym_CARET] = ACTIONS(2899),
    [anon_sym_PIPE] = ACTIONS(2899),
    [anon_sym_AMP] = ACTIONS(2899),
    [anon_sym_LT_LT] = ACTIONS(2899),
    [anon_sym_GT_GT] = ACTIONS(2899),
    [anon_sym_EQ_EQ] = ACTIONS(2901),
    [anon_sym_BANG_EQ] = ACTIONS(2901),
    [anon_sym_GT_EQ] = ACTIONS(2901),
    [anon_sym_LT_EQ] = ACTIONS(2901),
    [anon_sym_switch] = ACTIONS(2901),
    [anon_sym_and] = ACTIONS(2901),
    [anon_sym_or] = ACTIONS(2899),
    [anon_sym_PLUS_EQ] = ACTIONS(2901),
    [anon_sym_DASH_EQ] = ACTIONS(2901),
    [anon_sym_STAR_EQ] = ACTIONS(2901),
    [anon_sym_SLASH_EQ] = ACTIONS(2901),
    [anon_sym_PERCENT_EQ] = ACTIONS(2901),
    [anon_sym_AMP_EQ] = ACTIONS(2901),
    [anon_sym_CARET_EQ] = ACTIONS(2901),
    [anon_sym_PIPE_EQ] = ACTIONS(2901),
    [anon_sym_LT_LT_EQ] = ACTIONS(2901),
    [anon_sym_GT_GT_EQ] = ACTIONS(2901),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2901),
    [anon_sym_is] = ACTIONS(2901),
    [anon_sym_DASH_GT] = ACTIONS(2901),
    [anon_sym_from] = ACTIONS(2901),
    [anon_sym_join] = ACTIONS(2901),
    [anon_sym_on] = ACTIONS(2901),
    [anon_sym_equals] = ACTIONS(2901),
    [anon_sym_let] = ACTIONS(2901),
    [anon_sym_orderby] = ACTIONS(2901),
    [anon_sym_group] = ACTIONS(2901),
    [anon_sym_by] = ACTIONS(2901),
    [anon_sym_select] = ACTIONS(2901),
    [anon_sym_DOT_DOT] = ACTIONS(2901),
    [anon_sym_with] = ACTIONS(2901),
    [anon_sym_AMP_AMP] = ACTIONS(2901),
    [anon_sym_PIPE_PIPE] = ACTIONS(2901),
    [anon_sym_QMARK_QMARK] = ACTIONS(2899),
    [anon_sym_as] = ACTIONS(2901),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2180] = {
    [sym_type_argument_list] = STATE(2086),
    [sym__preprocessor_call] = STATE(2180),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_switch] = ACTIONS(2829),
    [anon_sym_and] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2829),
    [anon_sym_join] = ACTIONS(2829),
    [anon_sym_on] = ACTIONS(2829),
    [anon_sym_equals] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_orderby] = ACTIONS(2829),
    [anon_sym_group] = ACTIONS(2829),
    [anon_sym_by] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2181] = {
    [sym__preprocessor_call] = STATE(2181),
    [anon_sym_SEMI] = ACTIONS(3530),
    [anon_sym_EQ] = ACTIONS(3532),
    [anon_sym_LT] = ACTIONS(3532),
    [anon_sym_COMMA] = ACTIONS(3530),
    [anon_sym_GT] = ACTIONS(3532),
    [anon_sym_DOT] = ACTIONS(3532),
    [anon_sym_LBRACK] = ACTIONS(3530),
    [anon_sym_RBRACK] = ACTIONS(3530),
    [anon_sym_COLON] = ACTIONS(3530),
    [anon_sym_LPAREN] = ACTIONS(3530),
    [anon_sym_RPAREN] = ACTIONS(3530),
    [anon_sym_in] = ACTIONS(3532),
    [anon_sym_RBRACE] = ACTIONS(3530),
    [anon_sym_EQ_GT] = ACTIONS(3530),
    [anon_sym_where] = ACTIONS(3530),
    [anon_sym_QMARK] = ACTIONS(3532),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_PLUS_PLUS] = ACTIONS(3530),
    [anon_sym_DASH_DASH] = ACTIONS(3530),
    [anon_sym_PLUS] = ACTIONS(3532),
    [anon_sym_DASH] = ACTIONS(3532),
    [anon_sym_STAR] = ACTIONS(3532),
    [anon_sym_SLASH] = ACTIONS(3532),
    [anon_sym_PERCENT] = ACTIONS(3532),
    [anon_sym_CARET] = ACTIONS(3532),
    [anon_sym_PIPE] = ACTIONS(3532),
    [anon_sym_AMP] = ACTIONS(3532),
    [anon_sym_LT_LT] = ACTIONS(3532),
    [anon_sym_GT_GT] = ACTIONS(3532),
    [anon_sym_EQ_EQ] = ACTIONS(3530),
    [anon_sym_BANG_EQ] = ACTIONS(3530),
    [anon_sym_GT_EQ] = ACTIONS(3530),
    [anon_sym_LT_EQ] = ACTIONS(3530),
    [anon_sym_switch] = ACTIONS(3530),
    [anon_sym_and] = ACTIONS(3530),
    [anon_sym_or] = ACTIONS(3532),
    [anon_sym_PLUS_EQ] = ACTIONS(3530),
    [anon_sym_DASH_EQ] = ACTIONS(3530),
    [anon_sym_STAR_EQ] = ACTIONS(3530),
    [anon_sym_SLASH_EQ] = ACTIONS(3530),
    [anon_sym_PERCENT_EQ] = ACTIONS(3530),
    [anon_sym_AMP_EQ] = ACTIONS(3530),
    [anon_sym_CARET_EQ] = ACTIONS(3530),
    [anon_sym_PIPE_EQ] = ACTIONS(3530),
    [anon_sym_LT_LT_EQ] = ACTIONS(3530),
    [anon_sym_GT_GT_EQ] = ACTIONS(3530),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3530),
    [anon_sym_is] = ACTIONS(3530),
    [anon_sym_DASH_GT] = ACTIONS(3530),
    [anon_sym_from] = ACTIONS(3530),
    [anon_sym_join] = ACTIONS(3530),
    [anon_sym_on] = ACTIONS(3530),
    [anon_sym_equals] = ACTIONS(3530),
    [anon_sym_into] = ACTIONS(3530),
    [anon_sym_let] = ACTIONS(3530),
    [anon_sym_orderby] = ACTIONS(3530),
    [anon_sym_group] = ACTIONS(3530),
    [anon_sym_by] = ACTIONS(3530),
    [anon_sym_select] = ACTIONS(3530),
    [anon_sym_DOT_DOT] = ACTIONS(3530),
    [anon_sym_with] = ACTIONS(3530),
    [anon_sym_AMP_AMP] = ACTIONS(3530),
    [anon_sym_PIPE_PIPE] = ACTIONS(3530),
    [anon_sym_QMARK_QMARK] = ACTIONS(3532),
    [anon_sym_as] = ACTIONS(3530),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2182] = {
    [sym__preprocessor_call] = STATE(2182),
    [anon_sym_SEMI] = ACTIONS(3534),
    [anon_sym_EQ] = ACTIONS(3536),
    [anon_sym_LT] = ACTIONS(3536),
    [anon_sym_COMMA] = ACTIONS(3534),
    [anon_sym_GT] = ACTIONS(3536),
    [anon_sym_DOT] = ACTIONS(3536),
    [anon_sym_LBRACK] = ACTIONS(3534),
    [anon_sym_RBRACK] = ACTIONS(3534),
    [anon_sym_COLON] = ACTIONS(3534),
    [anon_sym_LPAREN] = ACTIONS(3534),
    [anon_sym_RPAREN] = ACTIONS(3534),
    [anon_sym_in] = ACTIONS(3536),
    [anon_sym_RBRACE] = ACTIONS(3534),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_where] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_BANG] = ACTIONS(3536),
    [anon_sym_PLUS_PLUS] = ACTIONS(3534),
    [anon_sym_DASH_DASH] = ACTIONS(3534),
    [anon_sym_PLUS] = ACTIONS(3536),
    [anon_sym_DASH] = ACTIONS(3536),
    [anon_sym_STAR] = ACTIONS(3536),
    [anon_sym_SLASH] = ACTIONS(3536),
    [anon_sym_PERCENT] = ACTIONS(3536),
    [anon_sym_CARET] = ACTIONS(3536),
    [anon_sym_PIPE] = ACTIONS(3536),
    [anon_sym_AMP] = ACTIONS(3536),
    [anon_sym_LT_LT] = ACTIONS(3536),
    [anon_sym_GT_GT] = ACTIONS(3536),
    [anon_sym_EQ_EQ] = ACTIONS(3534),
    [anon_sym_BANG_EQ] = ACTIONS(3534),
    [anon_sym_GT_EQ] = ACTIONS(3534),
    [anon_sym_LT_EQ] = ACTIONS(3534),
    [anon_sym_switch] = ACTIONS(3534),
    [anon_sym_and] = ACTIONS(3534),
    [anon_sym_or] = ACTIONS(3536),
    [anon_sym_PLUS_EQ] = ACTIONS(3534),
    [anon_sym_DASH_EQ] = ACTIONS(3534),
    [anon_sym_STAR_EQ] = ACTIONS(3534),
    [anon_sym_SLASH_EQ] = ACTIONS(3534),
    [anon_sym_PERCENT_EQ] = ACTIONS(3534),
    [anon_sym_AMP_EQ] = ACTIONS(3534),
    [anon_sym_CARET_EQ] = ACTIONS(3534),
    [anon_sym_PIPE_EQ] = ACTIONS(3534),
    [anon_sym_LT_LT_EQ] = ACTIONS(3534),
    [anon_sym_GT_GT_EQ] = ACTIONS(3534),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3534),
    [anon_sym_is] = ACTIONS(3534),
    [anon_sym_DASH_GT] = ACTIONS(3534),
    [anon_sym_from] = ACTIONS(3534),
    [anon_sym_join] = ACTIONS(3534),
    [anon_sym_on] = ACTIONS(3534),
    [anon_sym_equals] = ACTIONS(3534),
    [anon_sym_into] = ACTIONS(3534),
    [anon_sym_let] = ACTIONS(3534),
    [anon_sym_orderby] = ACTIONS(3534),
    [anon_sym_group] = ACTIONS(3534),
    [anon_sym_by] = ACTIONS(3534),
    [anon_sym_select] = ACTIONS(3534),
    [anon_sym_DOT_DOT] = ACTIONS(3534),
    [anon_sym_with] = ACTIONS(3534),
    [anon_sym_AMP_AMP] = ACTIONS(3534),
    [anon_sym_PIPE_PIPE] = ACTIONS(3534),
    [anon_sym_QMARK_QMARK] = ACTIONS(3536),
    [anon_sym_as] = ACTIONS(3534),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2183] = {
    [sym__preprocessor_call] = STATE(2183),
    [anon_sym_SEMI] = ACTIONS(3538),
    [anon_sym_EQ] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3540),
    [anon_sym_COMMA] = ACTIONS(3538),
    [anon_sym_GT] = ACTIONS(3540),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACK] = ACTIONS(3538),
    [anon_sym_RBRACK] = ACTIONS(3538),
    [anon_sym_COLON] = ACTIONS(3538),
    [anon_sym_LPAREN] = ACTIONS(3538),
    [anon_sym_RPAREN] = ACTIONS(3538),
    [anon_sym_in] = ACTIONS(3540),
    [anon_sym_RBRACE] = ACTIONS(3538),
    [anon_sym_EQ_GT] = ACTIONS(3538),
    [anon_sym_where] = ACTIONS(3538),
    [anon_sym_QMARK] = ACTIONS(3540),
    [anon_sym_BANG] = ACTIONS(3540),
    [anon_sym_PLUS_PLUS] = ACTIONS(3538),
    [anon_sym_DASH_DASH] = ACTIONS(3538),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3540),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3540),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3540),
    [anon_sym_GT_GT] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3538),
    [anon_sym_BANG_EQ] = ACTIONS(3538),
    [anon_sym_GT_EQ] = ACTIONS(3538),
    [anon_sym_LT_EQ] = ACTIONS(3538),
    [anon_sym_switch] = ACTIONS(3538),
    [anon_sym_and] = ACTIONS(3538),
    [anon_sym_or] = ACTIONS(3540),
    [anon_sym_PLUS_EQ] = ACTIONS(3538),
    [anon_sym_DASH_EQ] = ACTIONS(3538),
    [anon_sym_STAR_EQ] = ACTIONS(3538),
    [anon_sym_SLASH_EQ] = ACTIONS(3538),
    [anon_sym_PERCENT_EQ] = ACTIONS(3538),
    [anon_sym_AMP_EQ] = ACTIONS(3538),
    [anon_sym_CARET_EQ] = ACTIONS(3538),
    [anon_sym_PIPE_EQ] = ACTIONS(3538),
    [anon_sym_LT_LT_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3538),
    [anon_sym_is] = ACTIONS(3538),
    [anon_sym_DASH_GT] = ACTIONS(3538),
    [anon_sym_from] = ACTIONS(3538),
    [anon_sym_join] = ACTIONS(3538),
    [anon_sym_on] = ACTIONS(3538),
    [anon_sym_equals] = ACTIONS(3538),
    [anon_sym_into] = ACTIONS(3538),
    [anon_sym_let] = ACTIONS(3538),
    [anon_sym_orderby] = ACTIONS(3538),
    [anon_sym_group] = ACTIONS(3538),
    [anon_sym_by] = ACTIONS(3538),
    [anon_sym_select] = ACTIONS(3538),
    [anon_sym_DOT_DOT] = ACTIONS(3538),
    [anon_sym_with] = ACTIONS(3538),
    [anon_sym_AMP_AMP] = ACTIONS(3538),
    [anon_sym_PIPE_PIPE] = ACTIONS(3538),
    [anon_sym_QMARK_QMARK] = ACTIONS(3540),
    [anon_sym_as] = ACTIONS(3538),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2184] = {
    [sym__preprocessor_call] = STATE(2184),
    [anon_sym_SEMI] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3544),
    [anon_sym_DOT] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_RBRACK] = ACTIONS(3542),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_RPAREN] = ACTIONS(3542),
    [anon_sym_in] = ACTIONS(3544),
    [anon_sym_RBRACE] = ACTIONS(3542),
    [anon_sym_EQ_GT] = ACTIONS(3542),
    [anon_sym_where] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3544),
    [anon_sym_BANG] = ACTIONS(3544),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3544),
    [anon_sym_DASH] = ACTIONS(3544),
    [anon_sym_STAR] = ACTIONS(3544),
    [anon_sym_SLASH] = ACTIONS(3544),
    [anon_sym_PERCENT] = ACTIONS(3544),
    [anon_sym_CARET] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_AMP] = ACTIONS(3544),
    [anon_sym_LT_LT] = ACTIONS(3544),
    [anon_sym_GT_GT] = ACTIONS(3544),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_GT_EQ] = ACTIONS(3542),
    [anon_sym_LT_EQ] = ACTIONS(3542),
    [anon_sym_switch] = ACTIONS(3542),
    [anon_sym_and] = ACTIONS(3542),
    [anon_sym_or] = ACTIONS(3544),
    [anon_sym_PLUS_EQ] = ACTIONS(3542),
    [anon_sym_DASH_EQ] = ACTIONS(3542),
    [anon_sym_STAR_EQ] = ACTIONS(3542),
    [anon_sym_SLASH_EQ] = ACTIONS(3542),
    [anon_sym_PERCENT_EQ] = ACTIONS(3542),
    [anon_sym_AMP_EQ] = ACTIONS(3542),
    [anon_sym_CARET_EQ] = ACTIONS(3542),
    [anon_sym_PIPE_EQ] = ACTIONS(3542),
    [anon_sym_LT_LT_EQ] = ACTIONS(3542),
    [anon_sym_GT_GT_EQ] = ACTIONS(3542),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3542),
    [anon_sym_is] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3542),
    [anon_sym_from] = ACTIONS(3542),
    [anon_sym_join] = ACTIONS(3542),
    [anon_sym_on] = ACTIONS(3542),
    [anon_sym_equals] = ACTIONS(3542),
    [anon_sym_into] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_orderby] = ACTIONS(3542),
    [anon_sym_group] = ACTIONS(3542),
    [anon_sym_by] = ACTIONS(3542),
    [anon_sym_select] = ACTIONS(3542),
    [anon_sym_DOT_DOT] = ACTIONS(3542),
    [anon_sym_with] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_QMARK_QMARK] = ACTIONS(3544),
    [anon_sym_as] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2185] = {
    [sym__preprocessor_call] = STATE(2185),
    [anon_sym_SEMI] = ACTIONS(3310),
    [anon_sym_EQ] = ACTIONS(3312),
    [anon_sym_LT] = ACTIONS(3312),
    [anon_sym_COMMA] = ACTIONS(3310),
    [anon_sym_GT] = ACTIONS(3312),
    [anon_sym_DOT] = ACTIONS(3312),
    [anon_sym_LBRACK] = ACTIONS(3310),
    [anon_sym_RBRACK] = ACTIONS(3310),
    [anon_sym_COLON] = ACTIONS(3310),
    [anon_sym_LPAREN] = ACTIONS(3310),
    [anon_sym_RPAREN] = ACTIONS(3310),
    [anon_sym_in] = ACTIONS(3310),
    [anon_sym_LBRACE] = ACTIONS(3310),
    [anon_sym_RBRACE] = ACTIONS(3310),
    [anon_sym_EQ_GT] = ACTIONS(3310),
    [anon_sym_where] = ACTIONS(3310),
    [anon_sym_QMARK] = ACTIONS(3312),
    [anon_sym_BANG] = ACTIONS(3312),
    [anon_sym_PLUS_PLUS] = ACTIONS(3310),
    [anon_sym_DASH_DASH] = ACTIONS(3310),
    [anon_sym_PLUS] = ACTIONS(3312),
    [anon_sym_DASH] = ACTIONS(3312),
    [anon_sym_STAR] = ACTIONS(3312),
    [anon_sym_SLASH] = ACTIONS(3312),
    [anon_sym_PERCENT] = ACTIONS(3312),
    [anon_sym_CARET] = ACTIONS(3312),
    [anon_sym_PIPE] = ACTIONS(3312),
    [anon_sym_AMP] = ACTIONS(3312),
    [anon_sym_LT_LT] = ACTIONS(3312),
    [anon_sym_GT_GT] = ACTIONS(3312),
    [anon_sym_EQ_EQ] = ACTIONS(3310),
    [anon_sym_BANG_EQ] = ACTIONS(3310),
    [anon_sym_GT_EQ] = ACTIONS(3310),
    [anon_sym_LT_EQ] = ACTIONS(3310),
    [anon_sym_switch] = ACTIONS(3310),
    [anon_sym_and] = ACTIONS(3310),
    [anon_sym_or] = ACTIONS(3312),
    [anon_sym_PLUS_EQ] = ACTIONS(3310),
    [anon_sym_DASH_EQ] = ACTIONS(3310),
    [anon_sym_STAR_EQ] = ACTIONS(3310),
    [anon_sym_SLASH_EQ] = ACTIONS(3310),
    [anon_sym_PERCENT_EQ] = ACTIONS(3310),
    [anon_sym_AMP_EQ] = ACTIONS(3310),
    [anon_sym_CARET_EQ] = ACTIONS(3310),
    [anon_sym_PIPE_EQ] = ACTIONS(3310),
    [anon_sym_LT_LT_EQ] = ACTIONS(3310),
    [anon_sym_GT_GT_EQ] = ACTIONS(3310),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3310),
    [anon_sym_is] = ACTIONS(3310),
    [anon_sym_DASH_GT] = ACTIONS(3310),
    [anon_sym_from] = ACTIONS(3310),
    [anon_sym_join] = ACTIONS(3310),
    [anon_sym_on] = ACTIONS(3310),
    [anon_sym_equals] = ACTIONS(3310),
    [anon_sym_let] = ACTIONS(3310),
    [anon_sym_orderby] = ACTIONS(3310),
    [anon_sym_group] = ACTIONS(3310),
    [anon_sym_by] = ACTIONS(3310),
    [anon_sym_select] = ACTIONS(3310),
    [anon_sym_DOT_DOT] = ACTIONS(3310),
    [anon_sym_with] = ACTIONS(3310),
    [anon_sym_AMP_AMP] = ACTIONS(3310),
    [anon_sym_PIPE_PIPE] = ACTIONS(3310),
    [anon_sym_QMARK_QMARK] = ACTIONS(3312),
    [anon_sym_as] = ACTIONS(3310),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2186] = {
    [sym__preprocessor_call] = STATE(2186),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_RBRACK] = ACTIONS(2993),
    [anon_sym_COLON] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_in] = ACTIONS(2995),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_EQ_GT] = ACTIONS(2993),
    [anon_sym_where] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_and] = ACTIONS(2993),
    [anon_sym_or] = ACTIONS(2995),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2993),
    [anon_sym_DASH_GT] = ACTIONS(2993),
    [anon_sym_from] = ACTIONS(2993),
    [anon_sym_join] = ACTIONS(2993),
    [anon_sym_on] = ACTIONS(2993),
    [anon_sym_equals] = ACTIONS(2993),
    [anon_sym_into] = ACTIONS(2993),
    [anon_sym_let] = ACTIONS(2993),
    [anon_sym_orderby] = ACTIONS(2993),
    [anon_sym_group] = ACTIONS(2993),
    [anon_sym_by] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2187] = {
    [sym__preprocessor_call] = STATE(2187),
    [anon_sym_SEMI] = ACTIONS(3546),
    [anon_sym_EQ] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3548),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_GT] = ACTIONS(3548),
    [anon_sym_DOT] = ACTIONS(3548),
    [anon_sym_LBRACK] = ACTIONS(3546),
    [anon_sym_RBRACK] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3546),
    [anon_sym_RPAREN] = ACTIONS(3546),
    [anon_sym_in] = ACTIONS(3548),
    [anon_sym_RBRACE] = ACTIONS(3546),
    [anon_sym_EQ_GT] = ACTIONS(3546),
    [anon_sym_where] = ACTIONS(3546),
    [anon_sym_QMARK] = ACTIONS(3548),
    [anon_sym_BANG] = ACTIONS(3548),
    [anon_sym_PLUS_PLUS] = ACTIONS(3546),
    [anon_sym_DASH_DASH] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3548),
    [anon_sym_SLASH] = ACTIONS(3548),
    [anon_sym_PERCENT] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_PIPE] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT_LT] = ACTIONS(3548),
    [anon_sym_GT_GT] = ACTIONS(3548),
    [anon_sym_EQ_EQ] = ACTIONS(3546),
    [anon_sym_BANG_EQ] = ACTIONS(3546),
    [anon_sym_GT_EQ] = ACTIONS(3546),
    [anon_sym_LT_EQ] = ACTIONS(3546),
    [anon_sym_switch] = ACTIONS(3546),
    [anon_sym_and] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3548),
    [anon_sym_PLUS_EQ] = ACTIONS(3546),
    [anon_sym_DASH_EQ] = ACTIONS(3546),
    [anon_sym_STAR_EQ] = ACTIONS(3546),
    [anon_sym_SLASH_EQ] = ACTIONS(3546),
    [anon_sym_PERCENT_EQ] = ACTIONS(3546),
    [anon_sym_AMP_EQ] = ACTIONS(3546),
    [anon_sym_CARET_EQ] = ACTIONS(3546),
    [anon_sym_PIPE_EQ] = ACTIONS(3546),
    [anon_sym_LT_LT_EQ] = ACTIONS(3546),
    [anon_sym_GT_GT_EQ] = ACTIONS(3546),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3546),
    [anon_sym_is] = ACTIONS(3546),
    [anon_sym_DASH_GT] = ACTIONS(3546),
    [anon_sym_from] = ACTIONS(3546),
    [anon_sym_join] = ACTIONS(3546),
    [anon_sym_on] = ACTIONS(3546),
    [anon_sym_equals] = ACTIONS(3546),
    [anon_sym_into] = ACTIONS(3546),
    [anon_sym_let] = ACTIONS(3546),
    [anon_sym_orderby] = ACTIONS(3546),
    [anon_sym_group] = ACTIONS(3546),
    [anon_sym_by] = ACTIONS(3546),
    [anon_sym_select] = ACTIONS(3546),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_with] = ACTIONS(3546),
    [anon_sym_AMP_AMP] = ACTIONS(3546),
    [anon_sym_PIPE_PIPE] = ACTIONS(3546),
    [anon_sym_QMARK_QMARK] = ACTIONS(3548),
    [anon_sym_as] = ACTIONS(3546),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2188] = {
    [sym__preprocessor_call] = STATE(2188),
    [anon_sym_SEMI] = ACTIONS(2878),
    [anon_sym_EQ] = ACTIONS(2876),
    [anon_sym_LT] = ACTIONS(2876),
    [anon_sym_COMMA] = ACTIONS(2878),
    [anon_sym_GT] = ACTIONS(2876),
    [anon_sym_DOT] = ACTIONS(2876),
    [anon_sym_LBRACK] = ACTIONS(2878),
    [anon_sym_RBRACK] = ACTIONS(2878),
    [anon_sym_COLON] = ACTIONS(2878),
    [anon_sym_LPAREN] = ACTIONS(2878),
    [anon_sym_RPAREN] = ACTIONS(2878),
    [anon_sym_in] = ACTIONS(2878),
    [anon_sym_LBRACE] = ACTIONS(2878),
    [anon_sym_RBRACE] = ACTIONS(2878),
    [anon_sym_EQ_GT] = ACTIONS(2878),
    [anon_sym_where] = ACTIONS(2878),
    [anon_sym_QMARK] = ACTIONS(2876),
    [anon_sym_BANG] = ACTIONS(2876),
    [anon_sym_PLUS_PLUS] = ACTIONS(2878),
    [anon_sym_DASH_DASH] = ACTIONS(2878),
    [anon_sym_PLUS] = ACTIONS(2876),
    [anon_sym_DASH] = ACTIONS(2876),
    [anon_sym_STAR] = ACTIONS(2876),
    [anon_sym_SLASH] = ACTIONS(2876),
    [anon_sym_PERCENT] = ACTIONS(2876),
    [anon_sym_CARET] = ACTIONS(2876),
    [anon_sym_PIPE] = ACTIONS(2876),
    [anon_sym_AMP] = ACTIONS(2876),
    [anon_sym_LT_LT] = ACTIONS(2876),
    [anon_sym_GT_GT] = ACTIONS(2876),
    [anon_sym_EQ_EQ] = ACTIONS(2878),
    [anon_sym_BANG_EQ] = ACTIONS(2878),
    [anon_sym_GT_EQ] = ACTIONS(2878),
    [anon_sym_LT_EQ] = ACTIONS(2878),
    [anon_sym_switch] = ACTIONS(2878),
    [anon_sym_and] = ACTIONS(2878),
    [anon_sym_or] = ACTIONS(2876),
    [anon_sym_PLUS_EQ] = ACTIONS(2878),
    [anon_sym_DASH_EQ] = ACTIONS(2878),
    [anon_sym_STAR_EQ] = ACTIONS(2878),
    [anon_sym_SLASH_EQ] = ACTIONS(2878),
    [anon_sym_PERCENT_EQ] = ACTIONS(2878),
    [anon_sym_AMP_EQ] = ACTIONS(2878),
    [anon_sym_CARET_EQ] = ACTIONS(2878),
    [anon_sym_PIPE_EQ] = ACTIONS(2878),
    [anon_sym_LT_LT_EQ] = ACTIONS(2878),
    [anon_sym_GT_GT_EQ] = ACTIONS(2878),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2878),
    [anon_sym_is] = ACTIONS(2878),
    [anon_sym_DASH_GT] = ACTIONS(2878),
    [anon_sym_from] = ACTIONS(2878),
    [anon_sym_join] = ACTIONS(2878),
    [anon_sym_on] = ACTIONS(2878),
    [anon_sym_equals] = ACTIONS(2878),
    [anon_sym_let] = ACTIONS(2878),
    [anon_sym_orderby] = ACTIONS(2878),
    [anon_sym_group] = ACTIONS(2878),
    [anon_sym_by] = ACTIONS(2878),
    [anon_sym_select] = ACTIONS(2878),
    [anon_sym_DOT_DOT] = ACTIONS(2878),
    [anon_sym_with] = ACTIONS(2878),
    [anon_sym_AMP_AMP] = ACTIONS(2878),
    [anon_sym_PIPE_PIPE] = ACTIONS(2878),
    [anon_sym_QMARK_QMARK] = ACTIONS(2876),
    [anon_sym_as] = ACTIONS(2878),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2189] = {
    [sym__preprocessor_call] = STATE(2189),
    [sym__identifier_token] = ACTIONS(3550),
    [anon_sym_extern] = ACTIONS(3550),
    [anon_sym_alias] = ACTIONS(3550),
    [anon_sym_SEMI] = ACTIONS(3552),
    [anon_sym_global] = ACTIONS(3550),
    [anon_sym_using] = ACTIONS(3550),
    [anon_sym_static] = ACTIONS(3550),
    [anon_sym_LBRACK] = ACTIONS(3554),
    [anon_sym_event] = ACTIONS(3550),
    [anon_sym_LPAREN] = ACTIONS(3554),
    [anon_sym_abstract] = ACTIONS(3550),
    [anon_sym_async] = ACTIONS(3550),
    [anon_sym_const] = ACTIONS(3550),
    [anon_sym_fixed] = ACTIONS(3550),
    [anon_sym_internal] = ACTIONS(3550),
    [anon_sym_new] = ACTIONS(3550),
    [anon_sym_override] = ACTIONS(3550),
    [anon_sym_partial] = ACTIONS(3550),
    [anon_sym_private] = ACTIONS(3550),
    [anon_sym_protected] = ACTIONS(3550),
    [anon_sym_public] = ACTIONS(3550),
    [anon_sym_readonly] = ACTIONS(3550),
    [anon_sym_ref] = ACTIONS(3550),
    [anon_sym_sealed] = ACTIONS(3550),
    [anon_sym_unsafe] = ACTIONS(3550),
    [anon_sym_virtual] = ACTIONS(3550),
    [anon_sym_volatile] = ACTIONS(3550),
    [anon_sym_RBRACE] = ACTIONS(3554),
    [anon_sym_implicit] = ACTIONS(3550),
    [anon_sym_explicit] = ACTIONS(3550),
    [anon_sym_TILDE] = ACTIONS(3554),
    [anon_sym_where] = ACTIONS(3550),
    [anon_sym_class] = ACTIONS(3550),
    [anon_sym_struct] = ACTIONS(3550),
    [anon_sym_notnull] = ACTIONS(3550),
    [anon_sym_unmanaged] = ACTIONS(3550),
    [anon_sym_get] = ACTIONS(3550),
    [anon_sym_set] = ACTIONS(3550),
    [anon_sym_add] = ACTIONS(3550),
    [anon_sym_remove] = ACTIONS(3550),
    [anon_sym_enum] = ACTIONS(3550),
    [anon_sym_interface] = ACTIONS(3550),
    [anon_sym_delegate] = ACTIONS(3550),
    [anon_sym_record] = ACTIONS(3550),
    [anon_sym_namespace] = ACTIONS(3550),
    [anon_sym_var] = ACTIONS(3550),
    [sym_predefined_type] = ACTIONS(3550),
    [anon_sym_when] = ACTIONS(3550),
    [anon_sym_yield] = ACTIONS(3550),
    [anon_sym_from] = ACTIONS(3550),
    [anon_sym_join] = ACTIONS(3550),
    [anon_sym_on] = ACTIONS(3550),
    [anon_sym_equals] = ACTIONS(3550),
    [anon_sym_into] = ACTIONS(3550),
    [anon_sym_let] = ACTIONS(3550),
    [anon_sym_orderby] = ACTIONS(3550),
    [anon_sym_ascending] = ACTIONS(3550),
    [anon_sym_descending] = ACTIONS(3550),
    [anon_sym_group] = ACTIONS(3550),
    [anon_sym_by] = ACTIONS(3550),
    [anon_sym_select] = ACTIONS(3550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3550),
    [anon_sym_nameof] = ACTIONS(3550),
    [sym_void_keyword] = ACTIONS(3550),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2190] = {
    [sym__preprocessor_call] = STATE(2190),
    [sym__identifier_token] = ACTIONS(3556),
    [anon_sym_extern] = ACTIONS(3556),
    [anon_sym_alias] = ACTIONS(3556),
    [anon_sym_SEMI] = ACTIONS(3558),
    [anon_sym_global] = ACTIONS(3556),
    [anon_sym_using] = ACTIONS(3556),
    [anon_sym_static] = ACTIONS(3556),
    [anon_sym_LBRACK] = ACTIONS(3560),
    [anon_sym_event] = ACTIONS(3556),
    [anon_sym_LPAREN] = ACTIONS(3560),
    [anon_sym_abstract] = ACTIONS(3556),
    [anon_sym_async] = ACTIONS(3556),
    [anon_sym_const] = ACTIONS(3556),
    [anon_sym_fixed] = ACTIONS(3556),
    [anon_sym_internal] = ACTIONS(3556),
    [anon_sym_new] = ACTIONS(3556),
    [anon_sym_override] = ACTIONS(3556),
    [anon_sym_partial] = ACTIONS(3556),
    [anon_sym_private] = ACTIONS(3556),
    [anon_sym_protected] = ACTIONS(3556),
    [anon_sym_public] = ACTIONS(3556),
    [anon_sym_readonly] = ACTIONS(3556),
    [anon_sym_ref] = ACTIONS(3556),
    [anon_sym_sealed] = ACTIONS(3556),
    [anon_sym_unsafe] = ACTIONS(3556),
    [anon_sym_virtual] = ACTIONS(3556),
    [anon_sym_volatile] = ACTIONS(3556),
    [anon_sym_RBRACE] = ACTIONS(3560),
    [anon_sym_implicit] = ACTIONS(3556),
    [anon_sym_explicit] = ACTIONS(3556),
    [anon_sym_TILDE] = ACTIONS(3560),
    [anon_sym_where] = ACTIONS(3556),
    [anon_sym_class] = ACTIONS(3556),
    [anon_sym_struct] = ACTIONS(3556),
    [anon_sym_notnull] = ACTIONS(3556),
    [anon_sym_unmanaged] = ACTIONS(3556),
    [anon_sym_get] = ACTIONS(3556),
    [anon_sym_set] = ACTIONS(3556),
    [anon_sym_add] = ACTIONS(3556),
    [anon_sym_remove] = ACTIONS(3556),
    [anon_sym_enum] = ACTIONS(3556),
    [anon_sym_interface] = ACTIONS(3556),
    [anon_sym_delegate] = ACTIONS(3556),
    [anon_sym_record] = ACTIONS(3556),
    [anon_sym_namespace] = ACTIONS(3556),
    [anon_sym_var] = ACTIONS(3556),
    [sym_predefined_type] = ACTIONS(3556),
    [anon_sym_when] = ACTIONS(3556),
    [anon_sym_yield] = ACTIONS(3556),
    [anon_sym_from] = ACTIONS(3556),
    [anon_sym_join] = ACTIONS(3556),
    [anon_sym_on] = ACTIONS(3556),
    [anon_sym_equals] = ACTIONS(3556),
    [anon_sym_into] = ACTIONS(3556),
    [anon_sym_let] = ACTIONS(3556),
    [anon_sym_orderby] = ACTIONS(3556),
    [anon_sym_ascending] = ACTIONS(3556),
    [anon_sym_descending] = ACTIONS(3556),
    [anon_sym_group] = ACTIONS(3556),
    [anon_sym_by] = ACTIONS(3556),
    [anon_sym_select] = ACTIONS(3556),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3556),
    [anon_sym_nameof] = ACTIONS(3556),
    [sym_void_keyword] = ACTIONS(3556),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2191] = {
    [sym__preprocessor_call] = STATE(2191),
    [anon_sym_SEMI] = ACTIONS(3534),
    [anon_sym_EQ] = ACTIONS(3536),
    [anon_sym_LT] = ACTIONS(3536),
    [anon_sym_COMMA] = ACTIONS(3534),
    [anon_sym_GT] = ACTIONS(3536),
    [anon_sym_DOT] = ACTIONS(3536),
    [anon_sym_LBRACK] = ACTIONS(3534),
    [anon_sym_RBRACK] = ACTIONS(3534),
    [anon_sym_COLON] = ACTIONS(3534),
    [anon_sym_LPAREN] = ACTIONS(3534),
    [anon_sym_RPAREN] = ACTIONS(3534),
    [anon_sym_in] = ACTIONS(3534),
    [anon_sym_RBRACE] = ACTIONS(3534),
    [anon_sym_EQ_GT] = ACTIONS(3534),
    [anon_sym_where] = ACTIONS(3534),
    [anon_sym_QMARK] = ACTIONS(3536),
    [anon_sym_BANG] = ACTIONS(3536),
    [anon_sym_PLUS_PLUS] = ACTIONS(3534),
    [anon_sym_DASH_DASH] = ACTIONS(3534),
    [anon_sym_PLUS] = ACTIONS(3536),
    [anon_sym_DASH] = ACTIONS(3536),
    [anon_sym_STAR] = ACTIONS(3536),
    [anon_sym_SLASH] = ACTIONS(3536),
    [anon_sym_PERCENT] = ACTIONS(3536),
    [anon_sym_CARET] = ACTIONS(3536),
    [anon_sym_PIPE] = ACTIONS(3536),
    [anon_sym_AMP] = ACTIONS(3536),
    [anon_sym_LT_LT] = ACTIONS(3536),
    [anon_sym_GT_GT] = ACTIONS(3536),
    [anon_sym_EQ_EQ] = ACTIONS(3534),
    [anon_sym_BANG_EQ] = ACTIONS(3534),
    [anon_sym_GT_EQ] = ACTIONS(3534),
    [anon_sym_LT_EQ] = ACTIONS(3534),
    [anon_sym_switch] = ACTIONS(3534),
    [anon_sym_and] = ACTIONS(3534),
    [anon_sym_or] = ACTIONS(3536),
    [anon_sym_PLUS_EQ] = ACTIONS(3534),
    [anon_sym_DASH_EQ] = ACTIONS(3534),
    [anon_sym_STAR_EQ] = ACTIONS(3534),
    [anon_sym_SLASH_EQ] = ACTIONS(3534),
    [anon_sym_PERCENT_EQ] = ACTIONS(3534),
    [anon_sym_AMP_EQ] = ACTIONS(3534),
    [anon_sym_CARET_EQ] = ACTIONS(3534),
    [anon_sym_PIPE_EQ] = ACTIONS(3534),
    [anon_sym_LT_LT_EQ] = ACTIONS(3534),
    [anon_sym_GT_GT_EQ] = ACTIONS(3534),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3534),
    [anon_sym_is] = ACTIONS(3534),
    [anon_sym_DASH_GT] = ACTIONS(3534),
    [anon_sym_from] = ACTIONS(3534),
    [anon_sym_join] = ACTIONS(3534),
    [anon_sym_on] = ACTIONS(3534),
    [anon_sym_equals] = ACTIONS(3534),
    [anon_sym_let] = ACTIONS(3534),
    [anon_sym_orderby] = ACTIONS(3534),
    [anon_sym_group] = ACTIONS(3534),
    [anon_sym_by] = ACTIONS(3534),
    [anon_sym_select] = ACTIONS(3534),
    [anon_sym_DOT_DOT] = ACTIONS(3534),
    [anon_sym_with] = ACTIONS(3534),
    [anon_sym_AMP_AMP] = ACTIONS(3534),
    [anon_sym_PIPE_PIPE] = ACTIONS(3534),
    [anon_sym_QMARK_QMARK] = ACTIONS(3536),
    [anon_sym_as] = ACTIONS(3534),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2192] = {
    [sym__preprocessor_call] = STATE(2192),
    [anon_sym_SEMI] = ACTIONS(2214),
    [anon_sym_EQ] = ACTIONS(2216),
    [anon_sym_LT] = ACTIONS(2216),
    [anon_sym_COMMA] = ACTIONS(2214),
    [anon_sym_GT] = ACTIONS(2216),
    [anon_sym_DOT] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_RBRACK] = ACTIONS(2214),
    [anon_sym_COLON] = ACTIONS(2214),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_RPAREN] = ACTIONS(2214),
    [anon_sym_in] = ACTIONS(2214),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_EQ_GT] = ACTIONS(2214),
    [anon_sym_where] = ACTIONS(2214),
    [anon_sym_QMARK] = ACTIONS(2216),
    [anon_sym_BANG] = ACTIONS(2216),
    [anon_sym_PLUS_PLUS] = ACTIONS(2214),
    [anon_sym_DASH_DASH] = ACTIONS(2214),
    [anon_sym_PLUS] = ACTIONS(2216),
    [anon_sym_DASH] = ACTIONS(2216),
    [anon_sym_STAR] = ACTIONS(2216),
    [anon_sym_SLASH] = ACTIONS(2216),
    [anon_sym_PERCENT] = ACTIONS(2216),
    [anon_sym_CARET] = ACTIONS(2216),
    [anon_sym_PIPE] = ACTIONS(2216),
    [anon_sym_AMP] = ACTIONS(2216),
    [anon_sym_LT_LT] = ACTIONS(2216),
    [anon_sym_GT_GT] = ACTIONS(2216),
    [anon_sym_EQ_EQ] = ACTIONS(2214),
    [anon_sym_BANG_EQ] = ACTIONS(2214),
    [anon_sym_GT_EQ] = ACTIONS(2214),
    [anon_sym_LT_EQ] = ACTIONS(2214),
    [anon_sym_switch] = ACTIONS(2214),
    [anon_sym_and] = ACTIONS(2214),
    [anon_sym_or] = ACTIONS(2216),
    [anon_sym_PLUS_EQ] = ACTIONS(2214),
    [anon_sym_DASH_EQ] = ACTIONS(2214),
    [anon_sym_STAR_EQ] = ACTIONS(2214),
    [anon_sym_SLASH_EQ] = ACTIONS(2214),
    [anon_sym_PERCENT_EQ] = ACTIONS(2214),
    [anon_sym_AMP_EQ] = ACTIONS(2214),
    [anon_sym_CARET_EQ] = ACTIONS(2214),
    [anon_sym_PIPE_EQ] = ACTIONS(2214),
    [anon_sym_LT_LT_EQ] = ACTIONS(2214),
    [anon_sym_GT_GT_EQ] = ACTIONS(2214),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2214),
    [anon_sym_is] = ACTIONS(2214),
    [anon_sym_DASH_GT] = ACTIONS(2214),
    [anon_sym_from] = ACTIONS(2214),
    [anon_sym_join] = ACTIONS(2214),
    [anon_sym_on] = ACTIONS(2214),
    [anon_sym_equals] = ACTIONS(2214),
    [anon_sym_let] = ACTIONS(2214),
    [anon_sym_orderby] = ACTIONS(2214),
    [anon_sym_group] = ACTIONS(2214),
    [anon_sym_by] = ACTIONS(2214),
    [anon_sym_select] = ACTIONS(2214),
    [anon_sym_DOT_DOT] = ACTIONS(2214),
    [anon_sym_with] = ACTIONS(2214),
    [anon_sym_AMP_AMP] = ACTIONS(2214),
    [anon_sym_PIPE_PIPE] = ACTIONS(2214),
    [anon_sym_QMARK_QMARK] = ACTIONS(2216),
    [anon_sym_as] = ACTIONS(2214),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2193] = {
    [sym__preprocessor_call] = STATE(2193),
    [anon_sym_SEMI] = ACTIONS(3426),
    [anon_sym_EQ] = ACTIONS(3428),
    [anon_sym_LT] = ACTIONS(3428),
    [anon_sym_COMMA] = ACTIONS(3426),
    [anon_sym_GT] = ACTIONS(3428),
    [anon_sym_DOT] = ACTIONS(3428),
    [anon_sym_LBRACK] = ACTIONS(3426),
    [anon_sym_RBRACK] = ACTIONS(3426),
    [anon_sym_COLON] = ACTIONS(3426),
    [anon_sym_LPAREN] = ACTIONS(3426),
    [anon_sym_RPAREN] = ACTIONS(3426),
    [anon_sym_in] = ACTIONS(3426),
    [anon_sym_RBRACE] = ACTIONS(3426),
    [anon_sym_EQ_GT] = ACTIONS(3426),
    [anon_sym_where] = ACTIONS(3426),
    [anon_sym_QMARK] = ACTIONS(3428),
    [anon_sym_BANG] = ACTIONS(3428),
    [anon_sym_PLUS_PLUS] = ACTIONS(3426),
    [anon_sym_DASH_DASH] = ACTIONS(3426),
    [anon_sym_PLUS] = ACTIONS(3428),
    [anon_sym_DASH] = ACTIONS(3428),
    [anon_sym_STAR] = ACTIONS(3428),
    [anon_sym_SLASH] = ACTIONS(3428),
    [anon_sym_PERCENT] = ACTIONS(3428),
    [anon_sym_CARET] = ACTIONS(3428),
    [anon_sym_PIPE] = ACTIONS(3428),
    [anon_sym_AMP] = ACTIONS(3428),
    [anon_sym_LT_LT] = ACTIONS(3428),
    [anon_sym_GT_GT] = ACTIONS(3428),
    [anon_sym_EQ_EQ] = ACTIONS(3426),
    [anon_sym_BANG_EQ] = ACTIONS(3426),
    [anon_sym_GT_EQ] = ACTIONS(3426),
    [anon_sym_LT_EQ] = ACTIONS(3426),
    [anon_sym_switch] = ACTIONS(3426),
    [anon_sym_and] = ACTIONS(3426),
    [anon_sym_or] = ACTIONS(3428),
    [anon_sym_PLUS_EQ] = ACTIONS(3426),
    [anon_sym_DASH_EQ] = ACTIONS(3426),
    [anon_sym_STAR_EQ] = ACTIONS(3426),
    [anon_sym_SLASH_EQ] = ACTIONS(3426),
    [anon_sym_PERCENT_EQ] = ACTIONS(3426),
    [anon_sym_AMP_EQ] = ACTIONS(3426),
    [anon_sym_CARET_EQ] = ACTIONS(3426),
    [anon_sym_PIPE_EQ] = ACTIONS(3426),
    [anon_sym_LT_LT_EQ] = ACTIONS(3426),
    [anon_sym_GT_GT_EQ] = ACTIONS(3426),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3426),
    [anon_sym_is] = ACTIONS(3426),
    [anon_sym_DASH_GT] = ACTIONS(3426),
    [anon_sym_from] = ACTIONS(3426),
    [anon_sym_join] = ACTIONS(3426),
    [anon_sym_on] = ACTIONS(3426),
    [anon_sym_equals] = ACTIONS(3426),
    [anon_sym_let] = ACTIONS(3426),
    [anon_sym_orderby] = ACTIONS(3426),
    [anon_sym_group] = ACTIONS(3426),
    [anon_sym_by] = ACTIONS(3426),
    [anon_sym_select] = ACTIONS(3426),
    [anon_sym_DOT_DOT] = ACTIONS(3426),
    [anon_sym_with] = ACTIONS(3426),
    [anon_sym_AMP_AMP] = ACTIONS(3426),
    [anon_sym_PIPE_PIPE] = ACTIONS(3426),
    [anon_sym_QMARK_QMARK] = ACTIONS(3428),
    [anon_sym_as] = ACTIONS(3426),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2194] = {
    [sym__preprocessor_call] = STATE(2194),
    [sym__identifier_token] = ACTIONS(3562),
    [anon_sym_extern] = ACTIONS(3562),
    [anon_sym_alias] = ACTIONS(3562),
    [anon_sym_SEMI] = ACTIONS(3564),
    [anon_sym_global] = ACTIONS(3562),
    [anon_sym_using] = ACTIONS(3562),
    [anon_sym_static] = ACTIONS(3562),
    [anon_sym_LBRACK] = ACTIONS(3566),
    [anon_sym_event] = ACTIONS(3562),
    [anon_sym_LPAREN] = ACTIONS(3566),
    [anon_sym_abstract] = ACTIONS(3562),
    [anon_sym_async] = ACTIONS(3562),
    [anon_sym_const] = ACTIONS(3562),
    [anon_sym_fixed] = ACTIONS(3562),
    [anon_sym_internal] = ACTIONS(3562),
    [anon_sym_new] = ACTIONS(3562),
    [anon_sym_override] = ACTIONS(3562),
    [anon_sym_partial] = ACTIONS(3562),
    [anon_sym_private] = ACTIONS(3562),
    [anon_sym_protected] = ACTIONS(3562),
    [anon_sym_public] = ACTIONS(3562),
    [anon_sym_readonly] = ACTIONS(3562),
    [anon_sym_ref] = ACTIONS(3562),
    [anon_sym_sealed] = ACTIONS(3562),
    [anon_sym_unsafe] = ACTIONS(3562),
    [anon_sym_virtual] = ACTIONS(3562),
    [anon_sym_volatile] = ACTIONS(3562),
    [anon_sym_RBRACE] = ACTIONS(3566),
    [anon_sym_implicit] = ACTIONS(3562),
    [anon_sym_explicit] = ACTIONS(3562),
    [anon_sym_TILDE] = ACTIONS(3566),
    [anon_sym_where] = ACTIONS(3562),
    [anon_sym_class] = ACTIONS(3562),
    [anon_sym_struct] = ACTIONS(3562),
    [anon_sym_notnull] = ACTIONS(3562),
    [anon_sym_unmanaged] = ACTIONS(3562),
    [anon_sym_get] = ACTIONS(3562),
    [anon_sym_set] = ACTIONS(3562),
    [anon_sym_add] = ACTIONS(3562),
    [anon_sym_remove] = ACTIONS(3562),
    [anon_sym_enum] = ACTIONS(3562),
    [anon_sym_interface] = ACTIONS(3562),
    [anon_sym_delegate] = ACTIONS(3562),
    [anon_sym_record] = ACTIONS(3562),
    [anon_sym_namespace] = ACTIONS(3562),
    [anon_sym_var] = ACTIONS(3562),
    [sym_predefined_type] = ACTIONS(3562),
    [anon_sym_when] = ACTIONS(3562),
    [anon_sym_yield] = ACTIONS(3562),
    [anon_sym_from] = ACTIONS(3562),
    [anon_sym_join] = ACTIONS(3562),
    [anon_sym_on] = ACTIONS(3562),
    [anon_sym_equals] = ACTIONS(3562),
    [anon_sym_into] = ACTIONS(3562),
    [anon_sym_let] = ACTIONS(3562),
    [anon_sym_orderby] = ACTIONS(3562),
    [anon_sym_ascending] = ACTIONS(3562),
    [anon_sym_descending] = ACTIONS(3562),
    [anon_sym_group] = ACTIONS(3562),
    [anon_sym_by] = ACTIONS(3562),
    [anon_sym_select] = ACTIONS(3562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3562),
    [anon_sym_nameof] = ACTIONS(3562),
    [sym_void_keyword] = ACTIONS(3562),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2195] = {
    [sym__preprocessor_call] = STATE(2195),
    [anon_sym_SEMI] = ACTIONS(3402),
    [anon_sym_EQ] = ACTIONS(3404),
    [anon_sym_LT] = ACTIONS(3404),
    [anon_sym_COMMA] = ACTIONS(3402),
    [anon_sym_GT] = ACTIONS(3404),
    [anon_sym_DOT] = ACTIONS(3404),
    [anon_sym_LBRACK] = ACTIONS(3402),
    [anon_sym_RBRACK] = ACTIONS(3402),
    [anon_sym_COLON] = ACTIONS(3402),
    [anon_sym_LPAREN] = ACTIONS(3402),
    [anon_sym_RPAREN] = ACTIONS(3402),
    [anon_sym_in] = ACTIONS(3402),
    [anon_sym_RBRACE] = ACTIONS(3402),
    [anon_sym_EQ_GT] = ACTIONS(3402),
    [anon_sym_where] = ACTIONS(3402),
    [anon_sym_QMARK] = ACTIONS(3404),
    [anon_sym_BANG] = ACTIONS(3404),
    [anon_sym_PLUS_PLUS] = ACTIONS(3402),
    [anon_sym_DASH_DASH] = ACTIONS(3402),
    [anon_sym_PLUS] = ACTIONS(3404),
    [anon_sym_DASH] = ACTIONS(3404),
    [anon_sym_STAR] = ACTIONS(3404),
    [anon_sym_SLASH] = ACTIONS(3404),
    [anon_sym_PERCENT] = ACTIONS(3404),
    [anon_sym_CARET] = ACTIONS(3404),
    [anon_sym_PIPE] = ACTIONS(3404),
    [anon_sym_AMP] = ACTIONS(3404),
    [anon_sym_LT_LT] = ACTIONS(3404),
    [anon_sym_GT_GT] = ACTIONS(3404),
    [anon_sym_EQ_EQ] = ACTIONS(3402),
    [anon_sym_BANG_EQ] = ACTIONS(3402),
    [anon_sym_GT_EQ] = ACTIONS(3402),
    [anon_sym_LT_EQ] = ACTIONS(3402),
    [anon_sym_switch] = ACTIONS(3402),
    [anon_sym_and] = ACTIONS(3402),
    [anon_sym_or] = ACTIONS(3404),
    [anon_sym_PLUS_EQ] = ACTIONS(3402),
    [anon_sym_DASH_EQ] = ACTIONS(3402),
    [anon_sym_STAR_EQ] = ACTIONS(3402),
    [anon_sym_SLASH_EQ] = ACTIONS(3402),
    [anon_sym_PERCENT_EQ] = ACTIONS(3402),
    [anon_sym_AMP_EQ] = ACTIONS(3402),
    [anon_sym_CARET_EQ] = ACTIONS(3402),
    [anon_sym_PIPE_EQ] = ACTIONS(3402),
    [anon_sym_LT_LT_EQ] = ACTIONS(3402),
    [anon_sym_GT_GT_EQ] = ACTIONS(3402),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3402),
    [anon_sym_is] = ACTIONS(3402),
    [anon_sym_DASH_GT] = ACTIONS(3402),
    [anon_sym_from] = ACTIONS(3402),
    [anon_sym_join] = ACTIONS(3402),
    [anon_sym_on] = ACTIONS(3402),
    [anon_sym_equals] = ACTIONS(3402),
    [anon_sym_let] = ACTIONS(3402),
    [anon_sym_orderby] = ACTIONS(3402),
    [anon_sym_group] = ACTIONS(3402),
    [anon_sym_by] = ACTIONS(3402),
    [anon_sym_select] = ACTIONS(3402),
    [anon_sym_DOT_DOT] = ACTIONS(3402),
    [anon_sym_with] = ACTIONS(3402),
    [anon_sym_AMP_AMP] = ACTIONS(3402),
    [anon_sym_PIPE_PIPE] = ACTIONS(3402),
    [anon_sym_QMARK_QMARK] = ACTIONS(3404),
    [anon_sym_as] = ACTIONS(3402),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2196] = {
    [sym__preprocessor_call] = STATE(2196),
    [anon_sym_SEMI] = ACTIONS(3542),
    [anon_sym_EQ] = ACTIONS(3544),
    [anon_sym_LT] = ACTIONS(3544),
    [anon_sym_COMMA] = ACTIONS(3542),
    [anon_sym_GT] = ACTIONS(3544),
    [anon_sym_DOT] = ACTIONS(3544),
    [anon_sym_LBRACK] = ACTIONS(3542),
    [anon_sym_RBRACK] = ACTIONS(3542),
    [anon_sym_COLON] = ACTIONS(3542),
    [anon_sym_LPAREN] = ACTIONS(3542),
    [anon_sym_RPAREN] = ACTIONS(3542),
    [anon_sym_in] = ACTIONS(3542),
    [anon_sym_RBRACE] = ACTIONS(3542),
    [anon_sym_EQ_GT] = ACTIONS(3542),
    [anon_sym_where] = ACTIONS(3542),
    [anon_sym_QMARK] = ACTIONS(3544),
    [anon_sym_BANG] = ACTIONS(3544),
    [anon_sym_PLUS_PLUS] = ACTIONS(3542),
    [anon_sym_DASH_DASH] = ACTIONS(3542),
    [anon_sym_PLUS] = ACTIONS(3544),
    [anon_sym_DASH] = ACTIONS(3544),
    [anon_sym_STAR] = ACTIONS(3544),
    [anon_sym_SLASH] = ACTIONS(3544),
    [anon_sym_PERCENT] = ACTIONS(3544),
    [anon_sym_CARET] = ACTIONS(3544),
    [anon_sym_PIPE] = ACTIONS(3544),
    [anon_sym_AMP] = ACTIONS(3544),
    [anon_sym_LT_LT] = ACTIONS(3544),
    [anon_sym_GT_GT] = ACTIONS(3544),
    [anon_sym_EQ_EQ] = ACTIONS(3542),
    [anon_sym_BANG_EQ] = ACTIONS(3542),
    [anon_sym_GT_EQ] = ACTIONS(3542),
    [anon_sym_LT_EQ] = ACTIONS(3542),
    [anon_sym_switch] = ACTIONS(3542),
    [anon_sym_and] = ACTIONS(3542),
    [anon_sym_or] = ACTIONS(3544),
    [anon_sym_PLUS_EQ] = ACTIONS(3542),
    [anon_sym_DASH_EQ] = ACTIONS(3542),
    [anon_sym_STAR_EQ] = ACTIONS(3542),
    [anon_sym_SLASH_EQ] = ACTIONS(3542),
    [anon_sym_PERCENT_EQ] = ACTIONS(3542),
    [anon_sym_AMP_EQ] = ACTIONS(3542),
    [anon_sym_CARET_EQ] = ACTIONS(3542),
    [anon_sym_PIPE_EQ] = ACTIONS(3542),
    [anon_sym_LT_LT_EQ] = ACTIONS(3542),
    [anon_sym_GT_GT_EQ] = ACTIONS(3542),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3542),
    [anon_sym_is] = ACTIONS(3542),
    [anon_sym_DASH_GT] = ACTIONS(3542),
    [anon_sym_from] = ACTIONS(3542),
    [anon_sym_join] = ACTIONS(3542),
    [anon_sym_on] = ACTIONS(3542),
    [anon_sym_equals] = ACTIONS(3542),
    [anon_sym_let] = ACTIONS(3542),
    [anon_sym_orderby] = ACTIONS(3542),
    [anon_sym_group] = ACTIONS(3542),
    [anon_sym_by] = ACTIONS(3542),
    [anon_sym_select] = ACTIONS(3542),
    [anon_sym_DOT_DOT] = ACTIONS(3542),
    [anon_sym_with] = ACTIONS(3542),
    [anon_sym_AMP_AMP] = ACTIONS(3542),
    [anon_sym_PIPE_PIPE] = ACTIONS(3542),
    [anon_sym_QMARK_QMARK] = ACTIONS(3544),
    [anon_sym_as] = ACTIONS(3542),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2197] = {
    [sym__preprocessor_call] = STATE(2197),
    [sym__identifier_token] = ACTIONS(3568),
    [anon_sym_extern] = ACTIONS(3568),
    [anon_sym_alias] = ACTIONS(3568),
    [anon_sym_SEMI] = ACTIONS(3570),
    [anon_sym_global] = ACTIONS(3568),
    [anon_sym_using] = ACTIONS(3568),
    [anon_sym_static] = ACTIONS(3568),
    [anon_sym_LBRACK] = ACTIONS(3572),
    [anon_sym_event] = ACTIONS(3568),
    [anon_sym_LPAREN] = ACTIONS(3572),
    [anon_sym_abstract] = ACTIONS(3568),
    [anon_sym_async] = ACTIONS(3568),
    [anon_sym_const] = ACTIONS(3568),
    [anon_sym_fixed] = ACTIONS(3568),
    [anon_sym_internal] = ACTIONS(3568),
    [anon_sym_new] = ACTIONS(3568),
    [anon_sym_override] = ACTIONS(3568),
    [anon_sym_partial] = ACTIONS(3568),
    [anon_sym_private] = ACTIONS(3568),
    [anon_sym_protected] = ACTIONS(3568),
    [anon_sym_public] = ACTIONS(3568),
    [anon_sym_readonly] = ACTIONS(3568),
    [anon_sym_ref] = ACTIONS(3568),
    [anon_sym_sealed] = ACTIONS(3568),
    [anon_sym_unsafe] = ACTIONS(3568),
    [anon_sym_virtual] = ACTIONS(3568),
    [anon_sym_volatile] = ACTIONS(3568),
    [anon_sym_RBRACE] = ACTIONS(3572),
    [anon_sym_implicit] = ACTIONS(3568),
    [anon_sym_explicit] = ACTIONS(3568),
    [anon_sym_TILDE] = ACTIONS(3572),
    [anon_sym_where] = ACTIONS(3568),
    [anon_sym_class] = ACTIONS(3568),
    [anon_sym_struct] = ACTIONS(3568),
    [anon_sym_notnull] = ACTIONS(3568),
    [anon_sym_unmanaged] = ACTIONS(3568),
    [anon_sym_get] = ACTIONS(3568),
    [anon_sym_set] = ACTIONS(3568),
    [anon_sym_add] = ACTIONS(3568),
    [anon_sym_remove] = ACTIONS(3568),
    [anon_sym_enum] = ACTIONS(3568),
    [anon_sym_interface] = ACTIONS(3568),
    [anon_sym_delegate] = ACTIONS(3568),
    [anon_sym_record] = ACTIONS(3568),
    [anon_sym_namespace] = ACTIONS(3568),
    [anon_sym_var] = ACTIONS(3568),
    [sym_predefined_type] = ACTIONS(3568),
    [anon_sym_when] = ACTIONS(3568),
    [anon_sym_yield] = ACTIONS(3568),
    [anon_sym_from] = ACTIONS(3568),
    [anon_sym_join] = ACTIONS(3568),
    [anon_sym_on] = ACTIONS(3568),
    [anon_sym_equals] = ACTIONS(3568),
    [anon_sym_into] = ACTIONS(3568),
    [anon_sym_let] = ACTIONS(3568),
    [anon_sym_orderby] = ACTIONS(3568),
    [anon_sym_ascending] = ACTIONS(3568),
    [anon_sym_descending] = ACTIONS(3568),
    [anon_sym_group] = ACTIONS(3568),
    [anon_sym_by] = ACTIONS(3568),
    [anon_sym_select] = ACTIONS(3568),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3568),
    [anon_sym_nameof] = ACTIONS(3568),
    [sym_void_keyword] = ACTIONS(3568),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2198] = {
    [sym__preprocessor_call] = STATE(2198),
    [sym__identifier_token] = ACTIONS(3574),
    [anon_sym_extern] = ACTIONS(3574),
    [anon_sym_alias] = ACTIONS(3574),
    [anon_sym_global] = ACTIONS(3574),
    [anon_sym_using] = ACTIONS(3574),
    [anon_sym_static] = ACTIONS(3574),
    [anon_sym_EQ] = ACTIONS(3576),
    [anon_sym_LBRACK] = ACTIONS(3578),
    [anon_sym_event] = ACTIONS(3574),
    [anon_sym_LPAREN] = ACTIONS(3578),
    [anon_sym_abstract] = ACTIONS(3574),
    [anon_sym_async] = ACTIONS(3574),
    [anon_sym_const] = ACTIONS(3574),
    [anon_sym_fixed] = ACTIONS(3574),
    [anon_sym_internal] = ACTIONS(3574),
    [anon_sym_new] = ACTIONS(3574),
    [anon_sym_override] = ACTIONS(3574),
    [anon_sym_partial] = ACTIONS(3574),
    [anon_sym_private] = ACTIONS(3574),
    [anon_sym_protected] = ACTIONS(3574),
    [anon_sym_public] = ACTIONS(3574),
    [anon_sym_readonly] = ACTIONS(3574),
    [anon_sym_ref] = ACTIONS(3574),
    [anon_sym_sealed] = ACTIONS(3574),
    [anon_sym_unsafe] = ACTIONS(3574),
    [anon_sym_virtual] = ACTIONS(3574),
    [anon_sym_volatile] = ACTIONS(3574),
    [anon_sym_RBRACE] = ACTIONS(3578),
    [anon_sym_implicit] = ACTIONS(3574),
    [anon_sym_explicit] = ACTIONS(3574),
    [anon_sym_TILDE] = ACTIONS(3578),
    [anon_sym_where] = ACTIONS(3574),
    [anon_sym_class] = ACTIONS(3574),
    [anon_sym_struct] = ACTIONS(3574),
    [anon_sym_notnull] = ACTIONS(3574),
    [anon_sym_unmanaged] = ACTIONS(3574),
    [anon_sym_get] = ACTIONS(3574),
    [anon_sym_set] = ACTIONS(3574),
    [anon_sym_add] = ACTIONS(3574),
    [anon_sym_remove] = ACTIONS(3574),
    [anon_sym_enum] = ACTIONS(3574),
    [anon_sym_interface] = ACTIONS(3574),
    [anon_sym_delegate] = ACTIONS(3574),
    [anon_sym_record] = ACTIONS(3574),
    [anon_sym_namespace] = ACTIONS(3574),
    [anon_sym_var] = ACTIONS(3574),
    [sym_predefined_type] = ACTIONS(3574),
    [anon_sym_when] = ACTIONS(3574),
    [anon_sym_yield] = ACTIONS(3574),
    [anon_sym_from] = ACTIONS(3574),
    [anon_sym_join] = ACTIONS(3574),
    [anon_sym_on] = ACTIONS(3574),
    [anon_sym_equals] = ACTIONS(3574),
    [anon_sym_into] = ACTIONS(3574),
    [anon_sym_let] = ACTIONS(3574),
    [anon_sym_orderby] = ACTIONS(3574),
    [anon_sym_ascending] = ACTIONS(3574),
    [anon_sym_descending] = ACTIONS(3574),
    [anon_sym_group] = ACTIONS(3574),
    [anon_sym_by] = ACTIONS(3574),
    [anon_sym_select] = ACTIONS(3574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3574),
    [anon_sym_nameof] = ACTIONS(3574),
    [sym_void_keyword] = ACTIONS(3574),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2199] = {
    [sym__preprocessor_call] = STATE(2199),
    [sym__identifier_token] = ACTIONS(3580),
    [anon_sym_extern] = ACTIONS(3580),
    [anon_sym_alias] = ACTIONS(3580),
    [anon_sym_SEMI] = ACTIONS(3582),
    [anon_sym_global] = ACTIONS(3580),
    [anon_sym_using] = ACTIONS(3580),
    [anon_sym_static] = ACTIONS(3580),
    [anon_sym_LBRACK] = ACTIONS(3584),
    [anon_sym_event] = ACTIONS(3580),
    [anon_sym_LPAREN] = ACTIONS(3584),
    [anon_sym_abstract] = ACTIONS(3580),
    [anon_sym_async] = ACTIONS(3580),
    [anon_sym_const] = ACTIONS(3580),
    [anon_sym_fixed] = ACTIONS(3580),
    [anon_sym_internal] = ACTIONS(3580),
    [anon_sym_new] = ACTIONS(3580),
    [anon_sym_override] = ACTIONS(3580),
    [anon_sym_partial] = ACTIONS(3580),
    [anon_sym_private] = ACTIONS(3580),
    [anon_sym_protected] = ACTIONS(3580),
    [anon_sym_public] = ACTIONS(3580),
    [anon_sym_readonly] = ACTIONS(3580),
    [anon_sym_ref] = ACTIONS(3580),
    [anon_sym_sealed] = ACTIONS(3580),
    [anon_sym_unsafe] = ACTIONS(3580),
    [anon_sym_virtual] = ACTIONS(3580),
    [anon_sym_volatile] = ACTIONS(3580),
    [anon_sym_RBRACE] = ACTIONS(3584),
    [anon_sym_implicit] = ACTIONS(3580),
    [anon_sym_explicit] = ACTIONS(3580),
    [anon_sym_TILDE] = ACTIONS(3584),
    [anon_sym_where] = ACTIONS(3580),
    [anon_sym_class] = ACTIONS(3580),
    [anon_sym_struct] = ACTIONS(3580),
    [anon_sym_notnull] = ACTIONS(3580),
    [anon_sym_unmanaged] = ACTIONS(3580),
    [anon_sym_get] = ACTIONS(3580),
    [anon_sym_set] = ACTIONS(3580),
    [anon_sym_add] = ACTIONS(3580),
    [anon_sym_remove] = ACTIONS(3580),
    [anon_sym_enum] = ACTIONS(3580),
    [anon_sym_interface] = ACTIONS(3580),
    [anon_sym_delegate] = ACTIONS(3580),
    [anon_sym_record] = ACTIONS(3580),
    [anon_sym_namespace] = ACTIONS(3580),
    [anon_sym_var] = ACTIONS(3580),
    [sym_predefined_type] = ACTIONS(3580),
    [anon_sym_when] = ACTIONS(3580),
    [anon_sym_yield] = ACTIONS(3580),
    [anon_sym_from] = ACTIONS(3580),
    [anon_sym_join] = ACTIONS(3580),
    [anon_sym_on] = ACTIONS(3580),
    [anon_sym_equals] = ACTIONS(3580),
    [anon_sym_into] = ACTIONS(3580),
    [anon_sym_let] = ACTIONS(3580),
    [anon_sym_orderby] = ACTIONS(3580),
    [anon_sym_ascending] = ACTIONS(3580),
    [anon_sym_descending] = ACTIONS(3580),
    [anon_sym_group] = ACTIONS(3580),
    [anon_sym_by] = ACTIONS(3580),
    [anon_sym_select] = ACTIONS(3580),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3580),
    [anon_sym_nameof] = ACTIONS(3580),
    [sym_void_keyword] = ACTIONS(3580),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2200] = {
    [sym__preprocessor_call] = STATE(2200),
    [sym__identifier_token] = ACTIONS(3586),
    [anon_sym_extern] = ACTIONS(3586),
    [anon_sym_alias] = ACTIONS(3586),
    [anon_sym_SEMI] = ACTIONS(3588),
    [anon_sym_global] = ACTIONS(3586),
    [anon_sym_using] = ACTIONS(3586),
    [anon_sym_static] = ACTIONS(3586),
    [anon_sym_LBRACK] = ACTIONS(3590),
    [anon_sym_event] = ACTIONS(3586),
    [anon_sym_LPAREN] = ACTIONS(3590),
    [anon_sym_abstract] = ACTIONS(3586),
    [anon_sym_async] = ACTIONS(3586),
    [anon_sym_const] = ACTIONS(3586),
    [anon_sym_fixed] = ACTIONS(3586),
    [anon_sym_internal] = ACTIONS(3586),
    [anon_sym_new] = ACTIONS(3586),
    [anon_sym_override] = ACTIONS(3586),
    [anon_sym_partial] = ACTIONS(3586),
    [anon_sym_private] = ACTIONS(3586),
    [anon_sym_protected] = ACTIONS(3586),
    [anon_sym_public] = ACTIONS(3586),
    [anon_sym_readonly] = ACTIONS(3586),
    [anon_sym_ref] = ACTIONS(3586),
    [anon_sym_sealed] = ACTIONS(3586),
    [anon_sym_unsafe] = ACTIONS(3586),
    [anon_sym_virtual] = ACTIONS(3586),
    [anon_sym_volatile] = ACTIONS(3586),
    [anon_sym_RBRACE] = ACTIONS(3590),
    [anon_sym_implicit] = ACTIONS(3586),
    [anon_sym_explicit] = ACTIONS(3586),
    [anon_sym_TILDE] = ACTIONS(3590),
    [anon_sym_where] = ACTIONS(3586),
    [anon_sym_class] = ACTIONS(3586),
    [anon_sym_struct] = ACTIONS(3586),
    [anon_sym_notnull] = ACTIONS(3586),
    [anon_sym_unmanaged] = ACTIONS(3586),
    [anon_sym_get] = ACTIONS(3586),
    [anon_sym_set] = ACTIONS(3586),
    [anon_sym_add] = ACTIONS(3586),
    [anon_sym_remove] = ACTIONS(3586),
    [anon_sym_enum] = ACTIONS(3586),
    [anon_sym_interface] = ACTIONS(3586),
    [anon_sym_delegate] = ACTIONS(3586),
    [anon_sym_record] = ACTIONS(3586),
    [anon_sym_namespace] = ACTIONS(3586),
    [anon_sym_var] = ACTIONS(3586),
    [sym_predefined_type] = ACTIONS(3586),
    [anon_sym_when] = ACTIONS(3586),
    [anon_sym_yield] = ACTIONS(3586),
    [anon_sym_from] = ACTIONS(3586),
    [anon_sym_join] = ACTIONS(3586),
    [anon_sym_on] = ACTIONS(3586),
    [anon_sym_equals] = ACTIONS(3586),
    [anon_sym_into] = ACTIONS(3586),
    [anon_sym_let] = ACTIONS(3586),
    [anon_sym_orderby] = ACTIONS(3586),
    [anon_sym_ascending] = ACTIONS(3586),
    [anon_sym_descending] = ACTIONS(3586),
    [anon_sym_group] = ACTIONS(3586),
    [anon_sym_by] = ACTIONS(3586),
    [anon_sym_select] = ACTIONS(3586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3586),
    [anon_sym_nameof] = ACTIONS(3586),
    [sym_void_keyword] = ACTIONS(3586),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2201] = {
    [sym__preprocessor_call] = STATE(2201),
    [anon_sym_SEMI] = ACTIONS(3454),
    [anon_sym_EQ] = ACTIONS(3456),
    [anon_sym_LT] = ACTIONS(3456),
    [anon_sym_COMMA] = ACTIONS(3454),
    [anon_sym_GT] = ACTIONS(3456),
    [anon_sym_DOT] = ACTIONS(3456),
    [anon_sym_LBRACK] = ACTIONS(3454),
    [anon_sym_RBRACK] = ACTIONS(3454),
    [anon_sym_COLON] = ACTIONS(3454),
    [anon_sym_LPAREN] = ACTIONS(3454),
    [anon_sym_RPAREN] = ACTIONS(3454),
    [anon_sym_in] = ACTIONS(3454),
    [anon_sym_RBRACE] = ACTIONS(3454),
    [anon_sym_EQ_GT] = ACTIONS(3454),
    [anon_sym_where] = ACTIONS(3454),
    [anon_sym_QMARK] = ACTIONS(3456),
    [anon_sym_BANG] = ACTIONS(3456),
    [anon_sym_PLUS_PLUS] = ACTIONS(3454),
    [anon_sym_DASH_DASH] = ACTIONS(3454),
    [anon_sym_PLUS] = ACTIONS(3456),
    [anon_sym_DASH] = ACTIONS(3456),
    [anon_sym_STAR] = ACTIONS(3456),
    [anon_sym_SLASH] = ACTIONS(3456),
    [anon_sym_PERCENT] = ACTIONS(3456),
    [anon_sym_CARET] = ACTIONS(3456),
    [anon_sym_PIPE] = ACTIONS(3456),
    [anon_sym_AMP] = ACTIONS(3456),
    [anon_sym_LT_LT] = ACTIONS(3456),
    [anon_sym_GT_GT] = ACTIONS(3456),
    [anon_sym_EQ_EQ] = ACTIONS(3454),
    [anon_sym_BANG_EQ] = ACTIONS(3454),
    [anon_sym_GT_EQ] = ACTIONS(3454),
    [anon_sym_LT_EQ] = ACTIONS(3454),
    [anon_sym_switch] = ACTIONS(3454),
    [anon_sym_and] = ACTIONS(3454),
    [anon_sym_or] = ACTIONS(3456),
    [anon_sym_PLUS_EQ] = ACTIONS(3454),
    [anon_sym_DASH_EQ] = ACTIONS(3454),
    [anon_sym_STAR_EQ] = ACTIONS(3454),
    [anon_sym_SLASH_EQ] = ACTIONS(3454),
    [anon_sym_PERCENT_EQ] = ACTIONS(3454),
    [anon_sym_AMP_EQ] = ACTIONS(3454),
    [anon_sym_CARET_EQ] = ACTIONS(3454),
    [anon_sym_PIPE_EQ] = ACTIONS(3454),
    [anon_sym_LT_LT_EQ] = ACTIONS(3454),
    [anon_sym_GT_GT_EQ] = ACTIONS(3454),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3454),
    [anon_sym_is] = ACTIONS(3454),
    [anon_sym_DASH_GT] = ACTIONS(3454),
    [anon_sym_from] = ACTIONS(3454),
    [anon_sym_join] = ACTIONS(3454),
    [anon_sym_on] = ACTIONS(3454),
    [anon_sym_equals] = ACTIONS(3454),
    [anon_sym_let] = ACTIONS(3454),
    [anon_sym_orderby] = ACTIONS(3454),
    [anon_sym_group] = ACTIONS(3454),
    [anon_sym_by] = ACTIONS(3454),
    [anon_sym_select] = ACTIONS(3454),
    [anon_sym_DOT_DOT] = ACTIONS(3454),
    [anon_sym_with] = ACTIONS(3454),
    [anon_sym_AMP_AMP] = ACTIONS(3454),
    [anon_sym_PIPE_PIPE] = ACTIONS(3454),
    [anon_sym_QMARK_QMARK] = ACTIONS(3456),
    [anon_sym_as] = ACTIONS(3454),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2202] = {
    [sym__preprocessor_call] = STATE(2202),
    [sym__identifier_token] = ACTIONS(3592),
    [anon_sym_extern] = ACTIONS(3592),
    [anon_sym_alias] = ACTIONS(3592),
    [anon_sym_global] = ACTIONS(3592),
    [anon_sym_using] = ACTIONS(3592),
    [anon_sym_static] = ACTIONS(3592),
    [anon_sym_EQ] = ACTIONS(3594),
    [anon_sym_LBRACK] = ACTIONS(3594),
    [anon_sym_event] = ACTIONS(3592),
    [anon_sym_LPAREN] = ACTIONS(3594),
    [anon_sym_abstract] = ACTIONS(3592),
    [anon_sym_async] = ACTIONS(3592),
    [anon_sym_const] = ACTIONS(3592),
    [anon_sym_fixed] = ACTIONS(3592),
    [anon_sym_internal] = ACTIONS(3592),
    [anon_sym_new] = ACTIONS(3592),
    [anon_sym_override] = ACTIONS(3592),
    [anon_sym_partial] = ACTIONS(3592),
    [anon_sym_private] = ACTIONS(3592),
    [anon_sym_protected] = ACTIONS(3592),
    [anon_sym_public] = ACTIONS(3592),
    [anon_sym_readonly] = ACTIONS(3592),
    [anon_sym_ref] = ACTIONS(3592),
    [anon_sym_sealed] = ACTIONS(3592),
    [anon_sym_unsafe] = ACTIONS(3592),
    [anon_sym_virtual] = ACTIONS(3592),
    [anon_sym_volatile] = ACTIONS(3592),
    [anon_sym_RBRACE] = ACTIONS(3594),
    [anon_sym_implicit] = ACTIONS(3592),
    [anon_sym_explicit] = ACTIONS(3592),
    [anon_sym_TILDE] = ACTIONS(3594),
    [anon_sym_where] = ACTIONS(3592),
    [anon_sym_class] = ACTIONS(3592),
    [anon_sym_struct] = ACTIONS(3592),
    [anon_sym_notnull] = ACTIONS(3592),
    [anon_sym_unmanaged] = ACTIONS(3592),
    [anon_sym_get] = ACTIONS(3592),
    [anon_sym_set] = ACTIONS(3592),
    [anon_sym_add] = ACTIONS(3592),
    [anon_sym_remove] = ACTIONS(3592),
    [anon_sym_enum] = ACTIONS(3592),
    [anon_sym_interface] = ACTIONS(3592),
    [anon_sym_delegate] = ACTIONS(3592),
    [anon_sym_record] = ACTIONS(3592),
    [anon_sym_namespace] = ACTIONS(3592),
    [anon_sym_var] = ACTIONS(3592),
    [sym_predefined_type] = ACTIONS(3592),
    [anon_sym_when] = ACTIONS(3592),
    [anon_sym_yield] = ACTIONS(3592),
    [anon_sym_from] = ACTIONS(3592),
    [anon_sym_join] = ACTIONS(3592),
    [anon_sym_on] = ACTIONS(3592),
    [anon_sym_equals] = ACTIONS(3592),
    [anon_sym_into] = ACTIONS(3592),
    [anon_sym_let] = ACTIONS(3592),
    [anon_sym_orderby] = ACTIONS(3592),
    [anon_sym_ascending] = ACTIONS(3592),
    [anon_sym_descending] = ACTIONS(3592),
    [anon_sym_group] = ACTIONS(3592),
    [anon_sym_by] = ACTIONS(3592),
    [anon_sym_select] = ACTIONS(3592),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3592),
    [anon_sym_nameof] = ACTIONS(3592),
    [sym_void_keyword] = ACTIONS(3592),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2203] = {
    [sym__preprocessor_call] = STATE(2203),
    [anon_sym_SEMI] = ACTIONS(3075),
    [anon_sym_EQ] = ACTIONS(3067),
    [anon_sym_LT] = ACTIONS(3067),
    [anon_sym_COMMA] = ACTIONS(3075),
    [anon_sym_GT] = ACTIONS(3067),
    [anon_sym_DOT] = ACTIONS(3067),
    [anon_sym_LBRACK] = ACTIONS(3075),
    [anon_sym_RBRACK] = ACTIONS(3075),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3075),
    [anon_sym_RPAREN] = ACTIONS(3075),
    [anon_sym_in] = ACTIONS(3075),
    [anon_sym_RBRACE] = ACTIONS(3075),
    [anon_sym_EQ_GT] = ACTIONS(3075),
    [anon_sym_where] = ACTIONS(3075),
    [anon_sym_QMARK] = ACTIONS(3067),
    [anon_sym_BANG] = ACTIONS(3067),
    [anon_sym_PLUS_PLUS] = ACTIONS(3075),
    [anon_sym_DASH_DASH] = ACTIONS(3075),
    [anon_sym_PLUS] = ACTIONS(3067),
    [anon_sym_DASH] = ACTIONS(3067),
    [anon_sym_STAR] = ACTIONS(3067),
    [anon_sym_SLASH] = ACTIONS(3067),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_CARET] = ACTIONS(3067),
    [anon_sym_PIPE] = ACTIONS(3067),
    [anon_sym_AMP] = ACTIONS(3067),
    [anon_sym_LT_LT] = ACTIONS(3067),
    [anon_sym_GT_GT] = ACTIONS(3067),
    [anon_sym_EQ_EQ] = ACTIONS(3075),
    [anon_sym_BANG_EQ] = ACTIONS(3075),
    [anon_sym_GT_EQ] = ACTIONS(3075),
    [anon_sym_LT_EQ] = ACTIONS(3075),
    [anon_sym_switch] = ACTIONS(3075),
    [anon_sym_and] = ACTIONS(3075),
    [anon_sym_or] = ACTIONS(3067),
    [anon_sym_PLUS_EQ] = ACTIONS(3075),
    [anon_sym_DASH_EQ] = ACTIONS(3075),
    [anon_sym_STAR_EQ] = ACTIONS(3075),
    [anon_sym_SLASH_EQ] = ACTIONS(3075),
    [anon_sym_PERCENT_EQ] = ACTIONS(3075),
    [anon_sym_AMP_EQ] = ACTIONS(3075),
    [anon_sym_CARET_EQ] = ACTIONS(3075),
    [anon_sym_PIPE_EQ] = ACTIONS(3075),
    [anon_sym_LT_LT_EQ] = ACTIONS(3075),
    [anon_sym_GT_GT_EQ] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3075),
    [anon_sym_is] = ACTIONS(3075),
    [anon_sym_DASH_GT] = ACTIONS(3075),
    [anon_sym_from] = ACTIONS(3075),
    [anon_sym_join] = ACTIONS(3075),
    [anon_sym_on] = ACTIONS(3075),
    [anon_sym_equals] = ACTIONS(3075),
    [anon_sym_let] = ACTIONS(3075),
    [anon_sym_orderby] = ACTIONS(3075),
    [anon_sym_group] = ACTIONS(3075),
    [anon_sym_by] = ACTIONS(3075),
    [anon_sym_select] = ACTIONS(3075),
    [anon_sym_DOT_DOT] = ACTIONS(3075),
    [anon_sym_with] = ACTIONS(3075),
    [anon_sym_AMP_AMP] = ACTIONS(3075),
    [anon_sym_PIPE_PIPE] = ACTIONS(3075),
    [anon_sym_QMARK_QMARK] = ACTIONS(3067),
    [anon_sym_as] = ACTIONS(3075),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2204] = {
    [sym__preprocessor_call] = STATE(2204),
    [sym__identifier_token] = ACTIONS(3596),
    [anon_sym_extern] = ACTIONS(3596),
    [anon_sym_alias] = ACTIONS(3596),
    [anon_sym_SEMI] = ACTIONS(3598),
    [anon_sym_global] = ACTIONS(3596),
    [anon_sym_using] = ACTIONS(3596),
    [anon_sym_static] = ACTIONS(3596),
    [anon_sym_LBRACK] = ACTIONS(3600),
    [anon_sym_event] = ACTIONS(3596),
    [anon_sym_LPAREN] = ACTIONS(3600),
    [anon_sym_abstract] = ACTIONS(3596),
    [anon_sym_async] = ACTIONS(3596),
    [anon_sym_const] = ACTIONS(3596),
    [anon_sym_fixed] = ACTIONS(3596),
    [anon_sym_internal] = ACTIONS(3596),
    [anon_sym_new] = ACTIONS(3596),
    [anon_sym_override] = ACTIONS(3596),
    [anon_sym_partial] = ACTIONS(3596),
    [anon_sym_private] = ACTIONS(3596),
    [anon_sym_protected] = ACTIONS(3596),
    [anon_sym_public] = ACTIONS(3596),
    [anon_sym_readonly] = ACTIONS(3596),
    [anon_sym_ref] = ACTIONS(3596),
    [anon_sym_sealed] = ACTIONS(3596),
    [anon_sym_unsafe] = ACTIONS(3596),
    [anon_sym_virtual] = ACTIONS(3596),
    [anon_sym_volatile] = ACTIONS(3596),
    [anon_sym_RBRACE] = ACTIONS(3600),
    [anon_sym_implicit] = ACTIONS(3596),
    [anon_sym_explicit] = ACTIONS(3596),
    [anon_sym_TILDE] = ACTIONS(3600),
    [anon_sym_where] = ACTIONS(3596),
    [anon_sym_class] = ACTIONS(3596),
    [anon_sym_struct] = ACTIONS(3596),
    [anon_sym_notnull] = ACTIONS(3596),
    [anon_sym_unmanaged] = ACTIONS(3596),
    [anon_sym_get] = ACTIONS(3596),
    [anon_sym_set] = ACTIONS(3596),
    [anon_sym_add] = ACTIONS(3596),
    [anon_sym_remove] = ACTIONS(3596),
    [anon_sym_enum] = ACTIONS(3596),
    [anon_sym_interface] = ACTIONS(3596),
    [anon_sym_delegate] = ACTIONS(3596),
    [anon_sym_record] = ACTIONS(3596),
    [anon_sym_namespace] = ACTIONS(3596),
    [anon_sym_var] = ACTIONS(3596),
    [sym_predefined_type] = ACTIONS(3596),
    [anon_sym_when] = ACTIONS(3596),
    [anon_sym_yield] = ACTIONS(3596),
    [anon_sym_from] = ACTIONS(3596),
    [anon_sym_join] = ACTIONS(3596),
    [anon_sym_on] = ACTIONS(3596),
    [anon_sym_equals] = ACTIONS(3596),
    [anon_sym_into] = ACTIONS(3596),
    [anon_sym_let] = ACTIONS(3596),
    [anon_sym_orderby] = ACTIONS(3596),
    [anon_sym_ascending] = ACTIONS(3596),
    [anon_sym_descending] = ACTIONS(3596),
    [anon_sym_group] = ACTIONS(3596),
    [anon_sym_by] = ACTIONS(3596),
    [anon_sym_select] = ACTIONS(3596),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3596),
    [anon_sym_nameof] = ACTIONS(3596),
    [sym_void_keyword] = ACTIONS(3596),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2205] = {
    [sym__preprocessor_call] = STATE(2205),
    [sym__identifier_token] = ACTIONS(3602),
    [anon_sym_extern] = ACTIONS(3602),
    [anon_sym_alias] = ACTIONS(3602),
    [anon_sym_SEMI] = ACTIONS(3604),
    [anon_sym_global] = ACTIONS(3602),
    [anon_sym_using] = ACTIONS(3602),
    [anon_sym_static] = ACTIONS(3602),
    [anon_sym_LBRACK] = ACTIONS(3606),
    [anon_sym_event] = ACTIONS(3602),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_abstract] = ACTIONS(3602),
    [anon_sym_async] = ACTIONS(3602),
    [anon_sym_const] = ACTIONS(3602),
    [anon_sym_fixed] = ACTIONS(3602),
    [anon_sym_internal] = ACTIONS(3602),
    [anon_sym_new] = ACTIONS(3602),
    [anon_sym_override] = ACTIONS(3602),
    [anon_sym_partial] = ACTIONS(3602),
    [anon_sym_private] = ACTIONS(3602),
    [anon_sym_protected] = ACTIONS(3602),
    [anon_sym_public] = ACTIONS(3602),
    [anon_sym_readonly] = ACTIONS(3602),
    [anon_sym_ref] = ACTIONS(3602),
    [anon_sym_sealed] = ACTIONS(3602),
    [anon_sym_unsafe] = ACTIONS(3602),
    [anon_sym_virtual] = ACTIONS(3602),
    [anon_sym_volatile] = ACTIONS(3602),
    [anon_sym_RBRACE] = ACTIONS(3606),
    [anon_sym_implicit] = ACTIONS(3602),
    [anon_sym_explicit] = ACTIONS(3602),
    [anon_sym_TILDE] = ACTIONS(3606),
    [anon_sym_where] = ACTIONS(3602),
    [anon_sym_class] = ACTIONS(3602),
    [anon_sym_struct] = ACTIONS(3602),
    [anon_sym_notnull] = ACTIONS(3602),
    [anon_sym_unmanaged] = ACTIONS(3602),
    [anon_sym_get] = ACTIONS(3602),
    [anon_sym_set] = ACTIONS(3602),
    [anon_sym_add] = ACTIONS(3602),
    [anon_sym_remove] = ACTIONS(3602),
    [anon_sym_enum] = ACTIONS(3602),
    [anon_sym_interface] = ACTIONS(3602),
    [anon_sym_delegate] = ACTIONS(3602),
    [anon_sym_record] = ACTIONS(3602),
    [anon_sym_namespace] = ACTIONS(3602),
    [anon_sym_var] = ACTIONS(3602),
    [sym_predefined_type] = ACTIONS(3602),
    [anon_sym_when] = ACTIONS(3602),
    [anon_sym_yield] = ACTIONS(3602),
    [anon_sym_from] = ACTIONS(3602),
    [anon_sym_join] = ACTIONS(3602),
    [anon_sym_on] = ACTIONS(3602),
    [anon_sym_equals] = ACTIONS(3602),
    [anon_sym_into] = ACTIONS(3602),
    [anon_sym_let] = ACTIONS(3602),
    [anon_sym_orderby] = ACTIONS(3602),
    [anon_sym_ascending] = ACTIONS(3602),
    [anon_sym_descending] = ACTIONS(3602),
    [anon_sym_group] = ACTIONS(3602),
    [anon_sym_by] = ACTIONS(3602),
    [anon_sym_select] = ACTIONS(3602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3602),
    [anon_sym_nameof] = ACTIONS(3602),
    [sym_void_keyword] = ACTIONS(3602),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2206] = {
    [sym__preprocessor_call] = STATE(2206),
    [anon_sym_SEMI] = ACTIONS(3324),
    [anon_sym_EQ] = ACTIONS(3326),
    [anon_sym_LT] = ACTIONS(3326),
    [anon_sym_COMMA] = ACTIONS(3324),
    [anon_sym_GT] = ACTIONS(3326),
    [anon_sym_DOT] = ACTIONS(3326),
    [anon_sym_LBRACK] = ACTIONS(3324),
    [anon_sym_RBRACK] = ACTIONS(3324),
    [anon_sym_COLON] = ACTIONS(3324),
    [anon_sym_LPAREN] = ACTIONS(3324),
    [anon_sym_RPAREN] = ACTIONS(3324),
    [anon_sym_in] = ACTIONS(3324),
    [anon_sym_RBRACE] = ACTIONS(3324),
    [anon_sym_EQ_GT] = ACTIONS(3324),
    [anon_sym_where] = ACTIONS(3324),
    [anon_sym_QMARK] = ACTIONS(3326),
    [anon_sym_BANG] = ACTIONS(3326),
    [anon_sym_PLUS_PLUS] = ACTIONS(3324),
    [anon_sym_DASH_DASH] = ACTIONS(3324),
    [anon_sym_PLUS] = ACTIONS(3326),
    [anon_sym_DASH] = ACTIONS(3326),
    [anon_sym_STAR] = ACTIONS(3326),
    [anon_sym_SLASH] = ACTIONS(3326),
    [anon_sym_PERCENT] = ACTIONS(3326),
    [anon_sym_CARET] = ACTIONS(3326),
    [anon_sym_PIPE] = ACTIONS(3326),
    [anon_sym_AMP] = ACTIONS(3326),
    [anon_sym_LT_LT] = ACTIONS(3326),
    [anon_sym_GT_GT] = ACTIONS(3326),
    [anon_sym_EQ_EQ] = ACTIONS(3324),
    [anon_sym_BANG_EQ] = ACTIONS(3324),
    [anon_sym_GT_EQ] = ACTIONS(3324),
    [anon_sym_LT_EQ] = ACTIONS(3324),
    [anon_sym_switch] = ACTIONS(3324),
    [anon_sym_and] = ACTIONS(3324),
    [anon_sym_or] = ACTIONS(3326),
    [anon_sym_PLUS_EQ] = ACTIONS(3324),
    [anon_sym_DASH_EQ] = ACTIONS(3324),
    [anon_sym_STAR_EQ] = ACTIONS(3324),
    [anon_sym_SLASH_EQ] = ACTIONS(3324),
    [anon_sym_PERCENT_EQ] = ACTIONS(3324),
    [anon_sym_AMP_EQ] = ACTIONS(3324),
    [anon_sym_CARET_EQ] = ACTIONS(3324),
    [anon_sym_PIPE_EQ] = ACTIONS(3324),
    [anon_sym_LT_LT_EQ] = ACTIONS(3324),
    [anon_sym_GT_GT_EQ] = ACTIONS(3324),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3324),
    [anon_sym_is] = ACTIONS(3324),
    [anon_sym_DASH_GT] = ACTIONS(3324),
    [anon_sym_from] = ACTIONS(3324),
    [anon_sym_join] = ACTIONS(3324),
    [anon_sym_on] = ACTIONS(3324),
    [anon_sym_equals] = ACTIONS(3324),
    [anon_sym_let] = ACTIONS(3324),
    [anon_sym_orderby] = ACTIONS(3324),
    [anon_sym_group] = ACTIONS(3324),
    [anon_sym_by] = ACTIONS(3324),
    [anon_sym_select] = ACTIONS(3324),
    [anon_sym_DOT_DOT] = ACTIONS(3324),
    [anon_sym_with] = ACTIONS(3324),
    [anon_sym_AMP_AMP] = ACTIONS(3324),
    [anon_sym_PIPE_PIPE] = ACTIONS(3324),
    [anon_sym_QMARK_QMARK] = ACTIONS(3326),
    [anon_sym_as] = ACTIONS(3324),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2207] = {
    [sym__preprocessor_call] = STATE(2207),
    [sym__identifier_token] = ACTIONS(3608),
    [anon_sym_extern] = ACTIONS(3608),
    [anon_sym_alias] = ACTIONS(3608),
    [anon_sym_SEMI] = ACTIONS(3610),
    [anon_sym_global] = ACTIONS(3608),
    [anon_sym_using] = ACTIONS(3608),
    [anon_sym_static] = ACTIONS(3608),
    [anon_sym_LBRACK] = ACTIONS(3612),
    [anon_sym_event] = ACTIONS(3608),
    [anon_sym_LPAREN] = ACTIONS(3612),
    [anon_sym_abstract] = ACTIONS(3608),
    [anon_sym_async] = ACTIONS(3608),
    [anon_sym_const] = ACTIONS(3608),
    [anon_sym_fixed] = ACTIONS(3608),
    [anon_sym_internal] = ACTIONS(3608),
    [anon_sym_new] = ACTIONS(3608),
    [anon_sym_override] = ACTIONS(3608),
    [anon_sym_partial] = ACTIONS(3608),
    [anon_sym_private] = ACTIONS(3608),
    [anon_sym_protected] = ACTIONS(3608),
    [anon_sym_public] = ACTIONS(3608),
    [anon_sym_readonly] = ACTIONS(3608),
    [anon_sym_ref] = ACTIONS(3608),
    [anon_sym_sealed] = ACTIONS(3608),
    [anon_sym_unsafe] = ACTIONS(3608),
    [anon_sym_virtual] = ACTIONS(3608),
    [anon_sym_volatile] = ACTIONS(3608),
    [anon_sym_RBRACE] = ACTIONS(3612),
    [anon_sym_implicit] = ACTIONS(3608),
    [anon_sym_explicit] = ACTIONS(3608),
    [anon_sym_TILDE] = ACTIONS(3612),
    [anon_sym_where] = ACTIONS(3608),
    [anon_sym_class] = ACTIONS(3608),
    [anon_sym_struct] = ACTIONS(3608),
    [anon_sym_notnull] = ACTIONS(3608),
    [anon_sym_unmanaged] = ACTIONS(3608),
    [anon_sym_get] = ACTIONS(3608),
    [anon_sym_set] = ACTIONS(3608),
    [anon_sym_add] = ACTIONS(3608),
    [anon_sym_remove] = ACTIONS(3608),
    [anon_sym_enum] = ACTIONS(3608),
    [anon_sym_interface] = ACTIONS(3608),
    [anon_sym_delegate] = ACTIONS(3608),
    [anon_sym_record] = ACTIONS(3608),
    [anon_sym_namespace] = ACTIONS(3608),
    [anon_sym_var] = ACTIONS(3608),
    [sym_predefined_type] = ACTIONS(3608),
    [anon_sym_when] = ACTIONS(3608),
    [anon_sym_yield] = ACTIONS(3608),
    [anon_sym_from] = ACTIONS(3608),
    [anon_sym_join] = ACTIONS(3608),
    [anon_sym_on] = ACTIONS(3608),
    [anon_sym_equals] = ACTIONS(3608),
    [anon_sym_into] = ACTIONS(3608),
    [anon_sym_let] = ACTIONS(3608),
    [anon_sym_orderby] = ACTIONS(3608),
    [anon_sym_ascending] = ACTIONS(3608),
    [anon_sym_descending] = ACTIONS(3608),
    [anon_sym_group] = ACTIONS(3608),
    [anon_sym_by] = ACTIONS(3608),
    [anon_sym_select] = ACTIONS(3608),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3608),
    [anon_sym_nameof] = ACTIONS(3608),
    [sym_void_keyword] = ACTIONS(3608),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2208] = {
    [sym__preprocessor_call] = STATE(2208),
    [anon_sym_SEMI] = ACTIONS(3530),
    [anon_sym_EQ] = ACTIONS(3532),
    [anon_sym_LT] = ACTIONS(3532),
    [anon_sym_COMMA] = ACTIONS(3530),
    [anon_sym_GT] = ACTIONS(3532),
    [anon_sym_DOT] = ACTIONS(3532),
    [anon_sym_LBRACK] = ACTIONS(3530),
    [anon_sym_RBRACK] = ACTIONS(3530),
    [anon_sym_COLON] = ACTIONS(3530),
    [anon_sym_LPAREN] = ACTIONS(3530),
    [anon_sym_RPAREN] = ACTIONS(3530),
    [anon_sym_in] = ACTIONS(3530),
    [anon_sym_RBRACE] = ACTIONS(3530),
    [anon_sym_EQ_GT] = ACTIONS(3530),
    [anon_sym_where] = ACTIONS(3530),
    [anon_sym_QMARK] = ACTIONS(3532),
    [anon_sym_BANG] = ACTIONS(3532),
    [anon_sym_PLUS_PLUS] = ACTIONS(3530),
    [anon_sym_DASH_DASH] = ACTIONS(3530),
    [anon_sym_PLUS] = ACTIONS(3532),
    [anon_sym_DASH] = ACTIONS(3532),
    [anon_sym_STAR] = ACTIONS(3532),
    [anon_sym_SLASH] = ACTIONS(3532),
    [anon_sym_PERCENT] = ACTIONS(3532),
    [anon_sym_CARET] = ACTIONS(3532),
    [anon_sym_PIPE] = ACTIONS(3532),
    [anon_sym_AMP] = ACTIONS(3532),
    [anon_sym_LT_LT] = ACTIONS(3532),
    [anon_sym_GT_GT] = ACTIONS(3532),
    [anon_sym_EQ_EQ] = ACTIONS(3530),
    [anon_sym_BANG_EQ] = ACTIONS(3530),
    [anon_sym_GT_EQ] = ACTIONS(3530),
    [anon_sym_LT_EQ] = ACTIONS(3530),
    [anon_sym_switch] = ACTIONS(3530),
    [anon_sym_and] = ACTIONS(3530),
    [anon_sym_or] = ACTIONS(3532),
    [anon_sym_PLUS_EQ] = ACTIONS(3530),
    [anon_sym_DASH_EQ] = ACTIONS(3530),
    [anon_sym_STAR_EQ] = ACTIONS(3530),
    [anon_sym_SLASH_EQ] = ACTIONS(3530),
    [anon_sym_PERCENT_EQ] = ACTIONS(3530),
    [anon_sym_AMP_EQ] = ACTIONS(3530),
    [anon_sym_CARET_EQ] = ACTIONS(3530),
    [anon_sym_PIPE_EQ] = ACTIONS(3530),
    [anon_sym_LT_LT_EQ] = ACTIONS(3530),
    [anon_sym_GT_GT_EQ] = ACTIONS(3530),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3530),
    [anon_sym_is] = ACTIONS(3530),
    [anon_sym_DASH_GT] = ACTIONS(3530),
    [anon_sym_from] = ACTIONS(3530),
    [anon_sym_join] = ACTIONS(3530),
    [anon_sym_on] = ACTIONS(3530),
    [anon_sym_equals] = ACTIONS(3530),
    [anon_sym_let] = ACTIONS(3530),
    [anon_sym_orderby] = ACTIONS(3530),
    [anon_sym_group] = ACTIONS(3530),
    [anon_sym_by] = ACTIONS(3530),
    [anon_sym_select] = ACTIONS(3530),
    [anon_sym_DOT_DOT] = ACTIONS(3530),
    [anon_sym_with] = ACTIONS(3530),
    [anon_sym_AMP_AMP] = ACTIONS(3530),
    [anon_sym_PIPE_PIPE] = ACTIONS(3530),
    [anon_sym_QMARK_QMARK] = ACTIONS(3532),
    [anon_sym_as] = ACTIONS(3530),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2209] = {
    [sym__preprocessor_call] = STATE(2209),
    [anon_sym_SEMI] = ACTIONS(3328),
    [anon_sym_EQ] = ACTIONS(3330),
    [anon_sym_LT] = ACTIONS(3330),
    [anon_sym_COMMA] = ACTIONS(3328),
    [anon_sym_GT] = ACTIONS(3330),
    [anon_sym_DOT] = ACTIONS(3330),
    [anon_sym_LBRACK] = ACTIONS(3328),
    [anon_sym_RBRACK] = ACTIONS(3328),
    [anon_sym_COLON] = ACTIONS(3328),
    [anon_sym_LPAREN] = ACTIONS(3328),
    [anon_sym_RPAREN] = ACTIONS(3328),
    [anon_sym_in] = ACTIONS(3328),
    [anon_sym_RBRACE] = ACTIONS(3328),
    [anon_sym_EQ_GT] = ACTIONS(3328),
    [anon_sym_where] = ACTIONS(3328),
    [anon_sym_QMARK] = ACTIONS(3330),
    [anon_sym_BANG] = ACTIONS(3330),
    [anon_sym_PLUS_PLUS] = ACTIONS(3328),
    [anon_sym_DASH_DASH] = ACTIONS(3328),
    [anon_sym_PLUS] = ACTIONS(3330),
    [anon_sym_DASH] = ACTIONS(3330),
    [anon_sym_STAR] = ACTIONS(3330),
    [anon_sym_SLASH] = ACTIONS(3330),
    [anon_sym_PERCENT] = ACTIONS(3330),
    [anon_sym_CARET] = ACTIONS(3330),
    [anon_sym_PIPE] = ACTIONS(3330),
    [anon_sym_AMP] = ACTIONS(3330),
    [anon_sym_LT_LT] = ACTIONS(3330),
    [anon_sym_GT_GT] = ACTIONS(3330),
    [anon_sym_EQ_EQ] = ACTIONS(3328),
    [anon_sym_BANG_EQ] = ACTIONS(3328),
    [anon_sym_GT_EQ] = ACTIONS(3328),
    [anon_sym_LT_EQ] = ACTIONS(3328),
    [anon_sym_switch] = ACTIONS(3328),
    [anon_sym_and] = ACTIONS(3328),
    [anon_sym_or] = ACTIONS(3330),
    [anon_sym_PLUS_EQ] = ACTIONS(3328),
    [anon_sym_DASH_EQ] = ACTIONS(3328),
    [anon_sym_STAR_EQ] = ACTIONS(3328),
    [anon_sym_SLASH_EQ] = ACTIONS(3328),
    [anon_sym_PERCENT_EQ] = ACTIONS(3328),
    [anon_sym_AMP_EQ] = ACTIONS(3328),
    [anon_sym_CARET_EQ] = ACTIONS(3328),
    [anon_sym_PIPE_EQ] = ACTIONS(3328),
    [anon_sym_LT_LT_EQ] = ACTIONS(3328),
    [anon_sym_GT_GT_EQ] = ACTIONS(3328),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3328),
    [anon_sym_is] = ACTIONS(3328),
    [anon_sym_DASH_GT] = ACTIONS(3328),
    [anon_sym_from] = ACTIONS(3328),
    [anon_sym_join] = ACTIONS(3328),
    [anon_sym_on] = ACTIONS(3328),
    [anon_sym_equals] = ACTIONS(3328),
    [anon_sym_let] = ACTIONS(3328),
    [anon_sym_orderby] = ACTIONS(3328),
    [anon_sym_group] = ACTIONS(3328),
    [anon_sym_by] = ACTIONS(3328),
    [anon_sym_select] = ACTIONS(3328),
    [anon_sym_DOT_DOT] = ACTIONS(3328),
    [anon_sym_with] = ACTIONS(3328),
    [anon_sym_AMP_AMP] = ACTIONS(3328),
    [anon_sym_PIPE_PIPE] = ACTIONS(3328),
    [anon_sym_QMARK_QMARK] = ACTIONS(3330),
    [anon_sym_as] = ACTIONS(3328),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2210] = {
    [sym__preprocessor_call] = STATE(2210),
    [anon_sym_SEMI] = ACTIONS(3442),
    [anon_sym_EQ] = ACTIONS(3444),
    [anon_sym_LT] = ACTIONS(3444),
    [anon_sym_COMMA] = ACTIONS(3442),
    [anon_sym_GT] = ACTIONS(3444),
    [anon_sym_DOT] = ACTIONS(3444),
    [anon_sym_LBRACK] = ACTIONS(3442),
    [anon_sym_RBRACK] = ACTIONS(3442),
    [anon_sym_COLON] = ACTIONS(3442),
    [anon_sym_LPAREN] = ACTIONS(3442),
    [anon_sym_RPAREN] = ACTIONS(3442),
    [anon_sym_in] = ACTIONS(3442),
    [anon_sym_RBRACE] = ACTIONS(3442),
    [anon_sym_EQ_GT] = ACTIONS(3442),
    [anon_sym_where] = ACTIONS(3442),
    [anon_sym_QMARK] = ACTIONS(3444),
    [anon_sym_BANG] = ACTIONS(3444),
    [anon_sym_PLUS_PLUS] = ACTIONS(3442),
    [anon_sym_DASH_DASH] = ACTIONS(3442),
    [anon_sym_PLUS] = ACTIONS(3444),
    [anon_sym_DASH] = ACTIONS(3444),
    [anon_sym_STAR] = ACTIONS(3444),
    [anon_sym_SLASH] = ACTIONS(3444),
    [anon_sym_PERCENT] = ACTIONS(3444),
    [anon_sym_CARET] = ACTIONS(3444),
    [anon_sym_PIPE] = ACTIONS(3444),
    [anon_sym_AMP] = ACTIONS(3444),
    [anon_sym_LT_LT] = ACTIONS(3444),
    [anon_sym_GT_GT] = ACTIONS(3444),
    [anon_sym_EQ_EQ] = ACTIONS(3442),
    [anon_sym_BANG_EQ] = ACTIONS(3442),
    [anon_sym_GT_EQ] = ACTIONS(3442),
    [anon_sym_LT_EQ] = ACTIONS(3442),
    [anon_sym_switch] = ACTIONS(3442),
    [anon_sym_and] = ACTIONS(3442),
    [anon_sym_or] = ACTIONS(3444),
    [anon_sym_PLUS_EQ] = ACTIONS(3442),
    [anon_sym_DASH_EQ] = ACTIONS(3442),
    [anon_sym_STAR_EQ] = ACTIONS(3442),
    [anon_sym_SLASH_EQ] = ACTIONS(3442),
    [anon_sym_PERCENT_EQ] = ACTIONS(3442),
    [anon_sym_AMP_EQ] = ACTIONS(3442),
    [anon_sym_CARET_EQ] = ACTIONS(3442),
    [anon_sym_PIPE_EQ] = ACTIONS(3442),
    [anon_sym_LT_LT_EQ] = ACTIONS(3442),
    [anon_sym_GT_GT_EQ] = ACTIONS(3442),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3442),
    [anon_sym_is] = ACTIONS(3442),
    [anon_sym_DASH_GT] = ACTIONS(3442),
    [anon_sym_from] = ACTIONS(3442),
    [anon_sym_join] = ACTIONS(3442),
    [anon_sym_on] = ACTIONS(3442),
    [anon_sym_equals] = ACTIONS(3442),
    [anon_sym_let] = ACTIONS(3442),
    [anon_sym_orderby] = ACTIONS(3442),
    [anon_sym_group] = ACTIONS(3442),
    [anon_sym_by] = ACTIONS(3442),
    [anon_sym_select] = ACTIONS(3442),
    [anon_sym_DOT_DOT] = ACTIONS(3442),
    [anon_sym_with] = ACTIONS(3442),
    [anon_sym_AMP_AMP] = ACTIONS(3442),
    [anon_sym_PIPE_PIPE] = ACTIONS(3442),
    [anon_sym_QMARK_QMARK] = ACTIONS(3444),
    [anon_sym_as] = ACTIONS(3442),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2211] = {
    [sym__preprocessor_call] = STATE(2211),
    [anon_sym_SEMI] = ACTIONS(1977),
    [anon_sym_EQ] = ACTIONS(1979),
    [anon_sym_LT] = ACTIONS(1979),
    [anon_sym_COMMA] = ACTIONS(1977),
    [anon_sym_GT] = ACTIONS(1979),
    [anon_sym_DOT] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_RBRACK] = ACTIONS(1977),
    [anon_sym_COLON] = ACTIONS(1977),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_RPAREN] = ACTIONS(1977),
    [anon_sym_in] = ACTIONS(1977),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_EQ_GT] = ACTIONS(1977),
    [anon_sym_where] = ACTIONS(1977),
    [anon_sym_QMARK] = ACTIONS(1979),
    [anon_sym_BANG] = ACTIONS(1979),
    [anon_sym_PLUS_PLUS] = ACTIONS(1977),
    [anon_sym_DASH_DASH] = ACTIONS(1977),
    [anon_sym_PLUS] = ACTIONS(1979),
    [anon_sym_DASH] = ACTIONS(1979),
    [anon_sym_STAR] = ACTIONS(1979),
    [anon_sym_SLASH] = ACTIONS(1979),
    [anon_sym_PERCENT] = ACTIONS(1979),
    [anon_sym_CARET] = ACTIONS(1979),
    [anon_sym_PIPE] = ACTIONS(1979),
    [anon_sym_AMP] = ACTIONS(1979),
    [anon_sym_LT_LT] = ACTIONS(1979),
    [anon_sym_GT_GT] = ACTIONS(1979),
    [anon_sym_EQ_EQ] = ACTIONS(1977),
    [anon_sym_BANG_EQ] = ACTIONS(1977),
    [anon_sym_GT_EQ] = ACTIONS(1977),
    [anon_sym_LT_EQ] = ACTIONS(1977),
    [anon_sym_switch] = ACTIONS(1977),
    [anon_sym_and] = ACTIONS(1977),
    [anon_sym_or] = ACTIONS(1979),
    [anon_sym_PLUS_EQ] = ACTIONS(1977),
    [anon_sym_DASH_EQ] = ACTIONS(1977),
    [anon_sym_STAR_EQ] = ACTIONS(1977),
    [anon_sym_SLASH_EQ] = ACTIONS(1977),
    [anon_sym_PERCENT_EQ] = ACTIONS(1977),
    [anon_sym_AMP_EQ] = ACTIONS(1977),
    [anon_sym_CARET_EQ] = ACTIONS(1977),
    [anon_sym_PIPE_EQ] = ACTIONS(1977),
    [anon_sym_LT_LT_EQ] = ACTIONS(1977),
    [anon_sym_GT_GT_EQ] = ACTIONS(1977),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1977),
    [anon_sym_is] = ACTIONS(1977),
    [anon_sym_DASH_GT] = ACTIONS(1977),
    [anon_sym_from] = ACTIONS(1977),
    [anon_sym_join] = ACTIONS(1977),
    [anon_sym_on] = ACTIONS(1977),
    [anon_sym_equals] = ACTIONS(1977),
    [anon_sym_let] = ACTIONS(1977),
    [anon_sym_orderby] = ACTIONS(1977),
    [anon_sym_group] = ACTIONS(1977),
    [anon_sym_by] = ACTIONS(1977),
    [anon_sym_select] = ACTIONS(1977),
    [anon_sym_DOT_DOT] = ACTIONS(1977),
    [anon_sym_with] = ACTIONS(1977),
    [anon_sym_AMP_AMP] = ACTIONS(1977),
    [anon_sym_PIPE_PIPE] = ACTIONS(1977),
    [anon_sym_QMARK_QMARK] = ACTIONS(1979),
    [anon_sym_as] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2212] = {
    [sym__preprocessor_call] = STATE(2212),
    [anon_sym_SEMI] = ACTIONS(3414),
    [anon_sym_EQ] = ACTIONS(3416),
    [anon_sym_LT] = ACTIONS(3416),
    [anon_sym_COMMA] = ACTIONS(3414),
    [anon_sym_GT] = ACTIONS(3416),
    [anon_sym_DOT] = ACTIONS(3416),
    [anon_sym_LBRACK] = ACTIONS(3414),
    [anon_sym_RBRACK] = ACTIONS(3414),
    [anon_sym_COLON] = ACTIONS(3414),
    [anon_sym_LPAREN] = ACTIONS(3414),
    [anon_sym_RPAREN] = ACTIONS(3414),
    [anon_sym_in] = ACTIONS(3414),
    [anon_sym_RBRACE] = ACTIONS(3414),
    [anon_sym_EQ_GT] = ACTIONS(3414),
    [anon_sym_where] = ACTIONS(3414),
    [anon_sym_QMARK] = ACTIONS(3416),
    [anon_sym_BANG] = ACTIONS(3416),
    [anon_sym_PLUS_PLUS] = ACTIONS(3414),
    [anon_sym_DASH_DASH] = ACTIONS(3414),
    [anon_sym_PLUS] = ACTIONS(3416),
    [anon_sym_DASH] = ACTIONS(3416),
    [anon_sym_STAR] = ACTIONS(3416),
    [anon_sym_SLASH] = ACTIONS(3416),
    [anon_sym_PERCENT] = ACTIONS(3416),
    [anon_sym_CARET] = ACTIONS(3416),
    [anon_sym_PIPE] = ACTIONS(3416),
    [anon_sym_AMP] = ACTIONS(3416),
    [anon_sym_LT_LT] = ACTIONS(3416),
    [anon_sym_GT_GT] = ACTIONS(3416),
    [anon_sym_EQ_EQ] = ACTIONS(3414),
    [anon_sym_BANG_EQ] = ACTIONS(3414),
    [anon_sym_GT_EQ] = ACTIONS(3414),
    [anon_sym_LT_EQ] = ACTIONS(3414),
    [anon_sym_switch] = ACTIONS(3414),
    [anon_sym_and] = ACTIONS(3414),
    [anon_sym_or] = ACTIONS(3416),
    [anon_sym_PLUS_EQ] = ACTIONS(3414),
    [anon_sym_DASH_EQ] = ACTIONS(3414),
    [anon_sym_STAR_EQ] = ACTIONS(3414),
    [anon_sym_SLASH_EQ] = ACTIONS(3414),
    [anon_sym_PERCENT_EQ] = ACTIONS(3414),
    [anon_sym_AMP_EQ] = ACTIONS(3414),
    [anon_sym_CARET_EQ] = ACTIONS(3414),
    [anon_sym_PIPE_EQ] = ACTIONS(3414),
    [anon_sym_LT_LT_EQ] = ACTIONS(3414),
    [anon_sym_GT_GT_EQ] = ACTIONS(3414),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3414),
    [anon_sym_is] = ACTIONS(3414),
    [anon_sym_DASH_GT] = ACTIONS(3414),
    [anon_sym_from] = ACTIONS(3414),
    [anon_sym_join] = ACTIONS(3414),
    [anon_sym_on] = ACTIONS(3414),
    [anon_sym_equals] = ACTIONS(3414),
    [anon_sym_let] = ACTIONS(3414),
    [anon_sym_orderby] = ACTIONS(3414),
    [anon_sym_group] = ACTIONS(3414),
    [anon_sym_by] = ACTIONS(3414),
    [anon_sym_select] = ACTIONS(3414),
    [anon_sym_DOT_DOT] = ACTIONS(3414),
    [anon_sym_with] = ACTIONS(3414),
    [anon_sym_AMP_AMP] = ACTIONS(3414),
    [anon_sym_PIPE_PIPE] = ACTIONS(3414),
    [anon_sym_QMARK_QMARK] = ACTIONS(3416),
    [anon_sym_as] = ACTIONS(3414),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2213] = {
    [sym__preprocessor_call] = STATE(2213),
    [anon_sym_SEMI] = ACTIONS(3446),
    [anon_sym_EQ] = ACTIONS(3448),
    [anon_sym_LT] = ACTIONS(3448),
    [anon_sym_COMMA] = ACTIONS(3446),
    [anon_sym_GT] = ACTIONS(3448),
    [anon_sym_DOT] = ACTIONS(3448),
    [anon_sym_LBRACK] = ACTIONS(3446),
    [anon_sym_RBRACK] = ACTIONS(3446),
    [anon_sym_COLON] = ACTIONS(3446),
    [anon_sym_LPAREN] = ACTIONS(3446),
    [anon_sym_RPAREN] = ACTIONS(3446),
    [anon_sym_in] = ACTIONS(3446),
    [anon_sym_RBRACE] = ACTIONS(3446),
    [anon_sym_EQ_GT] = ACTIONS(3446),
    [anon_sym_where] = ACTIONS(3446),
    [anon_sym_QMARK] = ACTIONS(3448),
    [anon_sym_BANG] = ACTIONS(3448),
    [anon_sym_PLUS_PLUS] = ACTIONS(3446),
    [anon_sym_DASH_DASH] = ACTIONS(3446),
    [anon_sym_PLUS] = ACTIONS(3448),
    [anon_sym_DASH] = ACTIONS(3448),
    [anon_sym_STAR] = ACTIONS(3448),
    [anon_sym_SLASH] = ACTIONS(3448),
    [anon_sym_PERCENT] = ACTIONS(3448),
    [anon_sym_CARET] = ACTIONS(3448),
    [anon_sym_PIPE] = ACTIONS(3448),
    [anon_sym_AMP] = ACTIONS(3448),
    [anon_sym_LT_LT] = ACTIONS(3448),
    [anon_sym_GT_GT] = ACTIONS(3448),
    [anon_sym_EQ_EQ] = ACTIONS(3446),
    [anon_sym_BANG_EQ] = ACTIONS(3446),
    [anon_sym_GT_EQ] = ACTIONS(3446),
    [anon_sym_LT_EQ] = ACTIONS(3446),
    [anon_sym_switch] = ACTIONS(3446),
    [anon_sym_and] = ACTIONS(3446),
    [anon_sym_or] = ACTIONS(3448),
    [anon_sym_PLUS_EQ] = ACTIONS(3446),
    [anon_sym_DASH_EQ] = ACTIONS(3446),
    [anon_sym_STAR_EQ] = ACTIONS(3446),
    [anon_sym_SLASH_EQ] = ACTIONS(3446),
    [anon_sym_PERCENT_EQ] = ACTIONS(3446),
    [anon_sym_AMP_EQ] = ACTIONS(3446),
    [anon_sym_CARET_EQ] = ACTIONS(3446),
    [anon_sym_PIPE_EQ] = ACTIONS(3446),
    [anon_sym_LT_LT_EQ] = ACTIONS(3446),
    [anon_sym_GT_GT_EQ] = ACTIONS(3446),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3446),
    [anon_sym_is] = ACTIONS(3446),
    [anon_sym_DASH_GT] = ACTIONS(3446),
    [anon_sym_from] = ACTIONS(3446),
    [anon_sym_join] = ACTIONS(3446),
    [anon_sym_on] = ACTIONS(3446),
    [anon_sym_equals] = ACTIONS(3446),
    [anon_sym_let] = ACTIONS(3446),
    [anon_sym_orderby] = ACTIONS(3446),
    [anon_sym_group] = ACTIONS(3446),
    [anon_sym_by] = ACTIONS(3446),
    [anon_sym_select] = ACTIONS(3446),
    [anon_sym_DOT_DOT] = ACTIONS(3446),
    [anon_sym_with] = ACTIONS(3446),
    [anon_sym_AMP_AMP] = ACTIONS(3446),
    [anon_sym_PIPE_PIPE] = ACTIONS(3446),
    [anon_sym_QMARK_QMARK] = ACTIONS(3448),
    [anon_sym_as] = ACTIONS(3446),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2214] = {
    [sym__preprocessor_call] = STATE(2214),
    [anon_sym_SEMI] = ACTIONS(3386),
    [anon_sym_EQ] = ACTIONS(3388),
    [anon_sym_LT] = ACTIONS(3388),
    [anon_sym_COMMA] = ACTIONS(3386),
    [anon_sym_GT] = ACTIONS(3388),
    [anon_sym_DOT] = ACTIONS(3388),
    [anon_sym_LBRACK] = ACTIONS(3386),
    [anon_sym_RBRACK] = ACTIONS(3386),
    [anon_sym_COLON] = ACTIONS(3386),
    [anon_sym_LPAREN] = ACTIONS(3386),
    [anon_sym_RPAREN] = ACTIONS(3386),
    [anon_sym_in] = ACTIONS(3386),
    [anon_sym_RBRACE] = ACTIONS(3386),
    [anon_sym_EQ_GT] = ACTIONS(3386),
    [anon_sym_where] = ACTIONS(3386),
    [anon_sym_QMARK] = ACTIONS(3388),
    [anon_sym_BANG] = ACTIONS(3388),
    [anon_sym_PLUS_PLUS] = ACTIONS(3386),
    [anon_sym_DASH_DASH] = ACTIONS(3386),
    [anon_sym_PLUS] = ACTIONS(3388),
    [anon_sym_DASH] = ACTIONS(3388),
    [anon_sym_STAR] = ACTIONS(3388),
    [anon_sym_SLASH] = ACTIONS(3388),
    [anon_sym_PERCENT] = ACTIONS(3388),
    [anon_sym_CARET] = ACTIONS(3388),
    [anon_sym_PIPE] = ACTIONS(3388),
    [anon_sym_AMP] = ACTIONS(3388),
    [anon_sym_LT_LT] = ACTIONS(3388),
    [anon_sym_GT_GT] = ACTIONS(3388),
    [anon_sym_EQ_EQ] = ACTIONS(3386),
    [anon_sym_BANG_EQ] = ACTIONS(3386),
    [anon_sym_GT_EQ] = ACTIONS(3386),
    [anon_sym_LT_EQ] = ACTIONS(3386),
    [anon_sym_switch] = ACTIONS(3386),
    [anon_sym_and] = ACTIONS(3386),
    [anon_sym_or] = ACTIONS(3388),
    [anon_sym_PLUS_EQ] = ACTIONS(3386),
    [anon_sym_DASH_EQ] = ACTIONS(3386),
    [anon_sym_STAR_EQ] = ACTIONS(3386),
    [anon_sym_SLASH_EQ] = ACTIONS(3386),
    [anon_sym_PERCENT_EQ] = ACTIONS(3386),
    [anon_sym_AMP_EQ] = ACTIONS(3386),
    [anon_sym_CARET_EQ] = ACTIONS(3386),
    [anon_sym_PIPE_EQ] = ACTIONS(3386),
    [anon_sym_LT_LT_EQ] = ACTIONS(3386),
    [anon_sym_GT_GT_EQ] = ACTIONS(3386),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3386),
    [anon_sym_is] = ACTIONS(3386),
    [anon_sym_DASH_GT] = ACTIONS(3386),
    [anon_sym_from] = ACTIONS(3386),
    [anon_sym_join] = ACTIONS(3386),
    [anon_sym_on] = ACTIONS(3386),
    [anon_sym_equals] = ACTIONS(3386),
    [anon_sym_let] = ACTIONS(3386),
    [anon_sym_orderby] = ACTIONS(3386),
    [anon_sym_group] = ACTIONS(3386),
    [anon_sym_by] = ACTIONS(3386),
    [anon_sym_select] = ACTIONS(3386),
    [anon_sym_DOT_DOT] = ACTIONS(3386),
    [anon_sym_with] = ACTIONS(3386),
    [anon_sym_AMP_AMP] = ACTIONS(3386),
    [anon_sym_PIPE_PIPE] = ACTIONS(3386),
    [anon_sym_QMARK_QMARK] = ACTIONS(3388),
    [anon_sym_as] = ACTIONS(3386),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2215] = {
    [sym__preprocessor_call] = STATE(2215),
    [sym__identifier_token] = ACTIONS(3614),
    [anon_sym_extern] = ACTIONS(3614),
    [anon_sym_alias] = ACTIONS(3614),
    [anon_sym_SEMI] = ACTIONS(3616),
    [anon_sym_global] = ACTIONS(3614),
    [anon_sym_using] = ACTIONS(3614),
    [anon_sym_static] = ACTIONS(3614),
    [anon_sym_LBRACK] = ACTIONS(3618),
    [anon_sym_event] = ACTIONS(3614),
    [anon_sym_LPAREN] = ACTIONS(3618),
    [anon_sym_abstract] = ACTIONS(3614),
    [anon_sym_async] = ACTIONS(3614),
    [anon_sym_const] = ACTIONS(3614),
    [anon_sym_fixed] = ACTIONS(3614),
    [anon_sym_internal] = ACTIONS(3614),
    [anon_sym_new] = ACTIONS(3614),
    [anon_sym_override] = ACTIONS(3614),
    [anon_sym_partial] = ACTIONS(3614),
    [anon_sym_private] = ACTIONS(3614),
    [anon_sym_protected] = ACTIONS(3614),
    [anon_sym_public] = ACTIONS(3614),
    [anon_sym_readonly] = ACTIONS(3614),
    [anon_sym_ref] = ACTIONS(3614),
    [anon_sym_sealed] = ACTIONS(3614),
    [anon_sym_unsafe] = ACTIONS(3614),
    [anon_sym_virtual] = ACTIONS(3614),
    [anon_sym_volatile] = ACTIONS(3614),
    [anon_sym_RBRACE] = ACTIONS(3618),
    [anon_sym_implicit] = ACTIONS(3614),
    [anon_sym_explicit] = ACTIONS(3614),
    [anon_sym_TILDE] = ACTIONS(3618),
    [anon_sym_where] = ACTIONS(3614),
    [anon_sym_class] = ACTIONS(3614),
    [anon_sym_struct] = ACTIONS(3614),
    [anon_sym_notnull] = ACTIONS(3614),
    [anon_sym_unmanaged] = ACTIONS(3614),
    [anon_sym_get] = ACTIONS(3614),
    [anon_sym_set] = ACTIONS(3614),
    [anon_sym_add] = ACTIONS(3614),
    [anon_sym_remove] = ACTIONS(3614),
    [anon_sym_enum] = ACTIONS(3614),
    [anon_sym_interface] = ACTIONS(3614),
    [anon_sym_delegate] = ACTIONS(3614),
    [anon_sym_record] = ACTIONS(3614),
    [anon_sym_namespace] = ACTIONS(3614),
    [anon_sym_var] = ACTIONS(3614),
    [sym_predefined_type] = ACTIONS(3614),
    [anon_sym_when] = ACTIONS(3614),
    [anon_sym_yield] = ACTIONS(3614),
    [anon_sym_from] = ACTIONS(3614),
    [anon_sym_join] = ACTIONS(3614),
    [anon_sym_on] = ACTIONS(3614),
    [anon_sym_equals] = ACTIONS(3614),
    [anon_sym_into] = ACTIONS(3614),
    [anon_sym_let] = ACTIONS(3614),
    [anon_sym_orderby] = ACTIONS(3614),
    [anon_sym_ascending] = ACTIONS(3614),
    [anon_sym_descending] = ACTIONS(3614),
    [anon_sym_group] = ACTIONS(3614),
    [anon_sym_by] = ACTIONS(3614),
    [anon_sym_select] = ACTIONS(3614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3614),
    [anon_sym_nameof] = ACTIONS(3614),
    [sym_void_keyword] = ACTIONS(3614),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2216] = {
    [sym__preprocessor_call] = STATE(2216),
    [sym__identifier_token] = ACTIONS(3620),
    [anon_sym_extern] = ACTIONS(3620),
    [anon_sym_alias] = ACTIONS(3620),
    [anon_sym_SEMI] = ACTIONS(3622),
    [anon_sym_global] = ACTIONS(3620),
    [anon_sym_using] = ACTIONS(3620),
    [anon_sym_static] = ACTIONS(3620),
    [anon_sym_LBRACK] = ACTIONS(3624),
    [anon_sym_event] = ACTIONS(3620),
    [anon_sym_LPAREN] = ACTIONS(3624),
    [anon_sym_abstract] = ACTIONS(3620),
    [anon_sym_async] = ACTIONS(3620),
    [anon_sym_const] = ACTIONS(3620),
    [anon_sym_fixed] = ACTIONS(3620),
    [anon_sym_internal] = ACTIONS(3620),
    [anon_sym_new] = ACTIONS(3620),
    [anon_sym_override] = ACTIONS(3620),
    [anon_sym_partial] = ACTIONS(3620),
    [anon_sym_private] = ACTIONS(3620),
    [anon_sym_protected] = ACTIONS(3620),
    [anon_sym_public] = ACTIONS(3620),
    [anon_sym_readonly] = ACTIONS(3620),
    [anon_sym_ref] = ACTIONS(3620),
    [anon_sym_sealed] = ACTIONS(3620),
    [anon_sym_unsafe] = ACTIONS(3620),
    [anon_sym_virtual] = ACTIONS(3620),
    [anon_sym_volatile] = ACTIONS(3620),
    [anon_sym_RBRACE] = ACTIONS(3624),
    [anon_sym_implicit] = ACTIONS(3620),
    [anon_sym_explicit] = ACTIONS(3620),
    [anon_sym_TILDE] = ACTIONS(3624),
    [anon_sym_where] = ACTIONS(3620),
    [anon_sym_class] = ACTIONS(3620),
    [anon_sym_struct] = ACTIONS(3620),
    [anon_sym_notnull] = ACTIONS(3620),
    [anon_sym_unmanaged] = ACTIONS(3620),
    [anon_sym_get] = ACTIONS(3620),
    [anon_sym_set] = ACTIONS(3620),
    [anon_sym_add] = ACTIONS(3620),
    [anon_sym_remove] = ACTIONS(3620),
    [anon_sym_enum] = ACTIONS(3620),
    [anon_sym_interface] = ACTIONS(3620),
    [anon_sym_delegate] = ACTIONS(3620),
    [anon_sym_record] = ACTIONS(3620),
    [anon_sym_namespace] = ACTIONS(3620),
    [anon_sym_var] = ACTIONS(3620),
    [sym_predefined_type] = ACTIONS(3620),
    [anon_sym_when] = ACTIONS(3620),
    [anon_sym_yield] = ACTIONS(3620),
    [anon_sym_from] = ACTIONS(3620),
    [anon_sym_join] = ACTIONS(3620),
    [anon_sym_on] = ACTIONS(3620),
    [anon_sym_equals] = ACTIONS(3620),
    [anon_sym_into] = ACTIONS(3620),
    [anon_sym_let] = ACTIONS(3620),
    [anon_sym_orderby] = ACTIONS(3620),
    [anon_sym_ascending] = ACTIONS(3620),
    [anon_sym_descending] = ACTIONS(3620),
    [anon_sym_group] = ACTIONS(3620),
    [anon_sym_by] = ACTIONS(3620),
    [anon_sym_select] = ACTIONS(3620),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3620),
    [anon_sym_nameof] = ACTIONS(3620),
    [sym_void_keyword] = ACTIONS(3620),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2217] = {
    [sym__preprocessor_call] = STATE(2217),
    [anon_sym_SEMI] = ACTIONS(3526),
    [anon_sym_EQ] = ACTIONS(3528),
    [anon_sym_LT] = ACTIONS(3528),
    [anon_sym_COMMA] = ACTIONS(3526),
    [anon_sym_GT] = ACTIONS(3528),
    [anon_sym_DOT] = ACTIONS(3528),
    [anon_sym_LBRACK] = ACTIONS(3526),
    [anon_sym_RBRACK] = ACTIONS(3526),
    [anon_sym_COLON] = ACTIONS(3526),
    [anon_sym_LPAREN] = ACTIONS(3526),
    [anon_sym_RPAREN] = ACTIONS(3526),
    [anon_sym_in] = ACTIONS(3526),
    [anon_sym_RBRACE] = ACTIONS(3526),
    [anon_sym_EQ_GT] = ACTIONS(3526),
    [anon_sym_where] = ACTIONS(3526),
    [anon_sym_QMARK] = ACTIONS(3528),
    [anon_sym_BANG] = ACTIONS(3528),
    [anon_sym_PLUS_PLUS] = ACTIONS(3526),
    [anon_sym_DASH_DASH] = ACTIONS(3526),
    [anon_sym_PLUS] = ACTIONS(3528),
    [anon_sym_DASH] = ACTIONS(3528),
    [anon_sym_STAR] = ACTIONS(3528),
    [anon_sym_SLASH] = ACTIONS(3528),
    [anon_sym_PERCENT] = ACTIONS(3528),
    [anon_sym_CARET] = ACTIONS(3528),
    [anon_sym_PIPE] = ACTIONS(3528),
    [anon_sym_AMP] = ACTIONS(3528),
    [anon_sym_LT_LT] = ACTIONS(3528),
    [anon_sym_GT_GT] = ACTIONS(3528),
    [anon_sym_EQ_EQ] = ACTIONS(3526),
    [anon_sym_BANG_EQ] = ACTIONS(3526),
    [anon_sym_GT_EQ] = ACTIONS(3526),
    [anon_sym_LT_EQ] = ACTIONS(3526),
    [anon_sym_switch] = ACTIONS(3526),
    [anon_sym_and] = ACTIONS(3526),
    [anon_sym_or] = ACTIONS(3528),
    [anon_sym_PLUS_EQ] = ACTIONS(3526),
    [anon_sym_DASH_EQ] = ACTIONS(3526),
    [anon_sym_STAR_EQ] = ACTIONS(3526),
    [anon_sym_SLASH_EQ] = ACTIONS(3526),
    [anon_sym_PERCENT_EQ] = ACTIONS(3526),
    [anon_sym_AMP_EQ] = ACTIONS(3526),
    [anon_sym_CARET_EQ] = ACTIONS(3526),
    [anon_sym_PIPE_EQ] = ACTIONS(3526),
    [anon_sym_LT_LT_EQ] = ACTIONS(3526),
    [anon_sym_GT_GT_EQ] = ACTIONS(3526),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3526),
    [anon_sym_is] = ACTIONS(3526),
    [anon_sym_DASH_GT] = ACTIONS(3526),
    [anon_sym_from] = ACTIONS(3526),
    [anon_sym_join] = ACTIONS(3526),
    [anon_sym_on] = ACTIONS(3526),
    [anon_sym_equals] = ACTIONS(3526),
    [anon_sym_let] = ACTIONS(3526),
    [anon_sym_orderby] = ACTIONS(3526),
    [anon_sym_group] = ACTIONS(3526),
    [anon_sym_by] = ACTIONS(3526),
    [anon_sym_select] = ACTIONS(3526),
    [anon_sym_DOT_DOT] = ACTIONS(3526),
    [anon_sym_with] = ACTIONS(3526),
    [anon_sym_AMP_AMP] = ACTIONS(3526),
    [anon_sym_PIPE_PIPE] = ACTIONS(3526),
    [anon_sym_QMARK_QMARK] = ACTIONS(3528),
    [anon_sym_as] = ACTIONS(3526),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2218] = {
    [sym__preprocessor_call] = STATE(2218),
    [sym__identifier_token] = ACTIONS(3626),
    [anon_sym_extern] = ACTIONS(3626),
    [anon_sym_alias] = ACTIONS(3626),
    [anon_sym_SEMI] = ACTIONS(3628),
    [anon_sym_global] = ACTIONS(3626),
    [anon_sym_using] = ACTIONS(3626),
    [anon_sym_static] = ACTIONS(3626),
    [anon_sym_LBRACK] = ACTIONS(3628),
    [anon_sym_event] = ACTIONS(3626),
    [anon_sym_LPAREN] = ACTIONS(3628),
    [anon_sym_abstract] = ACTIONS(3626),
    [anon_sym_async] = ACTIONS(3626),
    [anon_sym_const] = ACTIONS(3626),
    [anon_sym_fixed] = ACTIONS(3626),
    [anon_sym_internal] = ACTIONS(3626),
    [anon_sym_new] = ACTIONS(3626),
    [anon_sym_override] = ACTIONS(3626),
    [anon_sym_partial] = ACTIONS(3626),
    [anon_sym_private] = ACTIONS(3626),
    [anon_sym_protected] = ACTIONS(3626),
    [anon_sym_public] = ACTIONS(3626),
    [anon_sym_readonly] = ACTIONS(3626),
    [anon_sym_ref] = ACTIONS(3626),
    [anon_sym_sealed] = ACTIONS(3626),
    [anon_sym_unsafe] = ACTIONS(3626),
    [anon_sym_virtual] = ACTIONS(3626),
    [anon_sym_volatile] = ACTIONS(3626),
    [anon_sym_RBRACE] = ACTIONS(3628),
    [anon_sym_implicit] = ACTIONS(3626),
    [anon_sym_explicit] = ACTIONS(3626),
    [anon_sym_TILDE] = ACTIONS(3628),
    [anon_sym_where] = ACTIONS(3626),
    [anon_sym_class] = ACTIONS(3626),
    [anon_sym_struct] = ACTIONS(3626),
    [anon_sym_notnull] = ACTIONS(3626),
    [anon_sym_unmanaged] = ACTIONS(3626),
    [anon_sym_get] = ACTIONS(3626),
    [anon_sym_set] = ACTIONS(3626),
    [anon_sym_add] = ACTIONS(3626),
    [anon_sym_remove] = ACTIONS(3626),
    [anon_sym_enum] = ACTIONS(3626),
    [anon_sym_interface] = ACTIONS(3626),
    [anon_sym_delegate] = ACTIONS(3626),
    [anon_sym_record] = ACTIONS(3626),
    [anon_sym_namespace] = ACTIONS(3626),
    [anon_sym_var] = ACTIONS(3626),
    [sym_predefined_type] = ACTIONS(3626),
    [anon_sym_when] = ACTIONS(3626),
    [anon_sym_yield] = ACTIONS(3626),
    [anon_sym_from] = ACTIONS(3626),
    [anon_sym_join] = ACTIONS(3626),
    [anon_sym_on] = ACTIONS(3626),
    [anon_sym_equals] = ACTIONS(3626),
    [anon_sym_into] = ACTIONS(3626),
    [anon_sym_let] = ACTIONS(3626),
    [anon_sym_orderby] = ACTIONS(3626),
    [anon_sym_ascending] = ACTIONS(3626),
    [anon_sym_descending] = ACTIONS(3626),
    [anon_sym_group] = ACTIONS(3626),
    [anon_sym_by] = ACTIONS(3626),
    [anon_sym_select] = ACTIONS(3626),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3626),
    [anon_sym_nameof] = ACTIONS(3626),
    [sym_void_keyword] = ACTIONS(3626),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2219] = {
    [sym__preprocessor_call] = STATE(2219),
    [anon_sym_SEMI] = ACTIONS(3498),
    [anon_sym_EQ] = ACTIONS(3500),
    [anon_sym_LT] = ACTIONS(3500),
    [anon_sym_COMMA] = ACTIONS(3498),
    [anon_sym_GT] = ACTIONS(3500),
    [anon_sym_DOT] = ACTIONS(3500),
    [anon_sym_LBRACK] = ACTIONS(3498),
    [anon_sym_RBRACK] = ACTIONS(3498),
    [anon_sym_COLON] = ACTIONS(3498),
    [anon_sym_LPAREN] = ACTIONS(3498),
    [anon_sym_RPAREN] = ACTIONS(3498),
    [anon_sym_in] = ACTIONS(3498),
    [anon_sym_RBRACE] = ACTIONS(3498),
    [anon_sym_EQ_GT] = ACTIONS(3498),
    [anon_sym_where] = ACTIONS(3498),
    [anon_sym_QMARK] = ACTIONS(3500),
    [anon_sym_BANG] = ACTIONS(3500),
    [anon_sym_PLUS_PLUS] = ACTIONS(3498),
    [anon_sym_DASH_DASH] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(3500),
    [anon_sym_DASH] = ACTIONS(3500),
    [anon_sym_STAR] = ACTIONS(3500),
    [anon_sym_SLASH] = ACTIONS(3500),
    [anon_sym_PERCENT] = ACTIONS(3500),
    [anon_sym_CARET] = ACTIONS(3500),
    [anon_sym_PIPE] = ACTIONS(3500),
    [anon_sym_AMP] = ACTIONS(3500),
    [anon_sym_LT_LT] = ACTIONS(3500),
    [anon_sym_GT_GT] = ACTIONS(3500),
    [anon_sym_EQ_EQ] = ACTIONS(3498),
    [anon_sym_BANG_EQ] = ACTIONS(3498),
    [anon_sym_GT_EQ] = ACTIONS(3498),
    [anon_sym_LT_EQ] = ACTIONS(3498),
    [anon_sym_switch] = ACTIONS(3498),
    [anon_sym_and] = ACTIONS(3498),
    [anon_sym_or] = ACTIONS(3500),
    [anon_sym_PLUS_EQ] = ACTIONS(3498),
    [anon_sym_DASH_EQ] = ACTIONS(3498),
    [anon_sym_STAR_EQ] = ACTIONS(3498),
    [anon_sym_SLASH_EQ] = ACTIONS(3498),
    [anon_sym_PERCENT_EQ] = ACTIONS(3498),
    [anon_sym_AMP_EQ] = ACTIONS(3498),
    [anon_sym_CARET_EQ] = ACTIONS(3498),
    [anon_sym_PIPE_EQ] = ACTIONS(3498),
    [anon_sym_LT_LT_EQ] = ACTIONS(3498),
    [anon_sym_GT_GT_EQ] = ACTIONS(3498),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3498),
    [anon_sym_is] = ACTIONS(3498),
    [anon_sym_DASH_GT] = ACTIONS(3498),
    [anon_sym_from] = ACTIONS(3498),
    [anon_sym_join] = ACTIONS(3498),
    [anon_sym_on] = ACTIONS(3498),
    [anon_sym_equals] = ACTIONS(3498),
    [anon_sym_let] = ACTIONS(3498),
    [anon_sym_orderby] = ACTIONS(3498),
    [anon_sym_group] = ACTIONS(3498),
    [anon_sym_by] = ACTIONS(3498),
    [anon_sym_select] = ACTIONS(3498),
    [anon_sym_DOT_DOT] = ACTIONS(3498),
    [anon_sym_with] = ACTIONS(3498),
    [anon_sym_AMP_AMP] = ACTIONS(3498),
    [anon_sym_PIPE_PIPE] = ACTIONS(3498),
    [anon_sym_QMARK_QMARK] = ACTIONS(3500),
    [anon_sym_as] = ACTIONS(3498),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2220] = {
    [sym__preprocessor_call] = STATE(2220),
    [sym__identifier_token] = ACTIONS(3630),
    [anon_sym_extern] = ACTIONS(3630),
    [anon_sym_alias] = ACTIONS(3630),
    [anon_sym_SEMI] = ACTIONS(3632),
    [anon_sym_global] = ACTIONS(3630),
    [anon_sym_using] = ACTIONS(3630),
    [anon_sym_static] = ACTIONS(3630),
    [anon_sym_LBRACK] = ACTIONS(3634),
    [anon_sym_event] = ACTIONS(3630),
    [anon_sym_LPAREN] = ACTIONS(3634),
    [anon_sym_abstract] = ACTIONS(3630),
    [anon_sym_async] = ACTIONS(3630),
    [anon_sym_const] = ACTIONS(3630),
    [anon_sym_fixed] = ACTIONS(3630),
    [anon_sym_internal] = ACTIONS(3630),
    [anon_sym_new] = ACTIONS(3630),
    [anon_sym_override] = ACTIONS(3630),
    [anon_sym_partial] = ACTIONS(3630),
    [anon_sym_private] = ACTIONS(3630),
    [anon_sym_protected] = ACTIONS(3630),
    [anon_sym_public] = ACTIONS(3630),
    [anon_sym_readonly] = ACTIONS(3630),
    [anon_sym_ref] = ACTIONS(3630),
    [anon_sym_sealed] = ACTIONS(3630),
    [anon_sym_unsafe] = ACTIONS(3630),
    [anon_sym_virtual] = ACTIONS(3630),
    [anon_sym_volatile] = ACTIONS(3630),
    [anon_sym_RBRACE] = ACTIONS(3634),
    [anon_sym_implicit] = ACTIONS(3630),
    [anon_sym_explicit] = ACTIONS(3630),
    [anon_sym_TILDE] = ACTIONS(3634),
    [anon_sym_where] = ACTIONS(3630),
    [anon_sym_class] = ACTIONS(3630),
    [anon_sym_struct] = ACTIONS(3630),
    [anon_sym_notnull] = ACTIONS(3630),
    [anon_sym_unmanaged] = ACTIONS(3630),
    [anon_sym_get] = ACTIONS(3630),
    [anon_sym_set] = ACTIONS(3630),
    [anon_sym_add] = ACTIONS(3630),
    [anon_sym_remove] = ACTIONS(3630),
    [anon_sym_enum] = ACTIONS(3630),
    [anon_sym_interface] = ACTIONS(3630),
    [anon_sym_delegate] = ACTIONS(3630),
    [anon_sym_record] = ACTIONS(3630),
    [anon_sym_namespace] = ACTIONS(3630),
    [anon_sym_var] = ACTIONS(3630),
    [sym_predefined_type] = ACTIONS(3630),
    [anon_sym_when] = ACTIONS(3630),
    [anon_sym_yield] = ACTIONS(3630),
    [anon_sym_from] = ACTIONS(3630),
    [anon_sym_join] = ACTIONS(3630),
    [anon_sym_on] = ACTIONS(3630),
    [anon_sym_equals] = ACTIONS(3630),
    [anon_sym_into] = ACTIONS(3630),
    [anon_sym_let] = ACTIONS(3630),
    [anon_sym_orderby] = ACTIONS(3630),
    [anon_sym_ascending] = ACTIONS(3630),
    [anon_sym_descending] = ACTIONS(3630),
    [anon_sym_group] = ACTIONS(3630),
    [anon_sym_by] = ACTIONS(3630),
    [anon_sym_select] = ACTIONS(3630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3630),
    [anon_sym_nameof] = ACTIONS(3630),
    [sym_void_keyword] = ACTIONS(3630),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2221] = {
    [sym__preprocessor_call] = STATE(2221),
    [sym__identifier_token] = ACTIONS(3636),
    [anon_sym_extern] = ACTIONS(3636),
    [anon_sym_alias] = ACTIONS(3636),
    [anon_sym_SEMI] = ACTIONS(3638),
    [anon_sym_global] = ACTIONS(3636),
    [anon_sym_using] = ACTIONS(3636),
    [anon_sym_static] = ACTIONS(3636),
    [anon_sym_LBRACK] = ACTIONS(3640),
    [anon_sym_event] = ACTIONS(3636),
    [anon_sym_LPAREN] = ACTIONS(3640),
    [anon_sym_abstract] = ACTIONS(3636),
    [anon_sym_async] = ACTIONS(3636),
    [anon_sym_const] = ACTIONS(3636),
    [anon_sym_fixed] = ACTIONS(3636),
    [anon_sym_internal] = ACTIONS(3636),
    [anon_sym_new] = ACTIONS(3636),
    [anon_sym_override] = ACTIONS(3636),
    [anon_sym_partial] = ACTIONS(3636),
    [anon_sym_private] = ACTIONS(3636),
    [anon_sym_protected] = ACTIONS(3636),
    [anon_sym_public] = ACTIONS(3636),
    [anon_sym_readonly] = ACTIONS(3636),
    [anon_sym_ref] = ACTIONS(3636),
    [anon_sym_sealed] = ACTIONS(3636),
    [anon_sym_unsafe] = ACTIONS(3636),
    [anon_sym_virtual] = ACTIONS(3636),
    [anon_sym_volatile] = ACTIONS(3636),
    [anon_sym_RBRACE] = ACTIONS(3640),
    [anon_sym_implicit] = ACTIONS(3636),
    [anon_sym_explicit] = ACTIONS(3636),
    [anon_sym_TILDE] = ACTIONS(3640),
    [anon_sym_where] = ACTIONS(3636),
    [anon_sym_class] = ACTIONS(3636),
    [anon_sym_struct] = ACTIONS(3636),
    [anon_sym_notnull] = ACTIONS(3636),
    [anon_sym_unmanaged] = ACTIONS(3636),
    [anon_sym_get] = ACTIONS(3636),
    [anon_sym_set] = ACTIONS(3636),
    [anon_sym_add] = ACTIONS(3636),
    [anon_sym_remove] = ACTIONS(3636),
    [anon_sym_enum] = ACTIONS(3636),
    [anon_sym_interface] = ACTIONS(3636),
    [anon_sym_delegate] = ACTIONS(3636),
    [anon_sym_record] = ACTIONS(3636),
    [anon_sym_namespace] = ACTIONS(3636),
    [anon_sym_var] = ACTIONS(3636),
    [sym_predefined_type] = ACTIONS(3636),
    [anon_sym_when] = ACTIONS(3636),
    [anon_sym_yield] = ACTIONS(3636),
    [anon_sym_from] = ACTIONS(3636),
    [anon_sym_join] = ACTIONS(3636),
    [anon_sym_on] = ACTIONS(3636),
    [anon_sym_equals] = ACTIONS(3636),
    [anon_sym_into] = ACTIONS(3636),
    [anon_sym_let] = ACTIONS(3636),
    [anon_sym_orderby] = ACTIONS(3636),
    [anon_sym_ascending] = ACTIONS(3636),
    [anon_sym_descending] = ACTIONS(3636),
    [anon_sym_group] = ACTIONS(3636),
    [anon_sym_by] = ACTIONS(3636),
    [anon_sym_select] = ACTIONS(3636),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3636),
    [anon_sym_nameof] = ACTIONS(3636),
    [sym_void_keyword] = ACTIONS(3636),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2222] = {
    [sym__preprocessor_call] = STATE(2222),
    [sym__identifier_token] = ACTIONS(3642),
    [anon_sym_extern] = ACTIONS(3642),
    [anon_sym_alias] = ACTIONS(3642),
    [anon_sym_SEMI] = ACTIONS(3644),
    [anon_sym_global] = ACTIONS(3642),
    [anon_sym_using] = ACTIONS(3642),
    [anon_sym_static] = ACTIONS(3642),
    [anon_sym_LBRACK] = ACTIONS(3646),
    [anon_sym_event] = ACTIONS(3642),
    [anon_sym_LPAREN] = ACTIONS(3646),
    [anon_sym_abstract] = ACTIONS(3642),
    [anon_sym_async] = ACTIONS(3642),
    [anon_sym_const] = ACTIONS(3642),
    [anon_sym_fixed] = ACTIONS(3642),
    [anon_sym_internal] = ACTIONS(3642),
    [anon_sym_new] = ACTIONS(3642),
    [anon_sym_override] = ACTIONS(3642),
    [anon_sym_partial] = ACTIONS(3642),
    [anon_sym_private] = ACTIONS(3642),
    [anon_sym_protected] = ACTIONS(3642),
    [anon_sym_public] = ACTIONS(3642),
    [anon_sym_readonly] = ACTIONS(3642),
    [anon_sym_ref] = ACTIONS(3642),
    [anon_sym_sealed] = ACTIONS(3642),
    [anon_sym_unsafe] = ACTIONS(3642),
    [anon_sym_virtual] = ACTIONS(3642),
    [anon_sym_volatile] = ACTIONS(3642),
    [anon_sym_RBRACE] = ACTIONS(3646),
    [anon_sym_implicit] = ACTIONS(3642),
    [anon_sym_explicit] = ACTIONS(3642),
    [anon_sym_TILDE] = ACTIONS(3646),
    [anon_sym_where] = ACTIONS(3642),
    [anon_sym_class] = ACTIONS(3642),
    [anon_sym_struct] = ACTIONS(3642),
    [anon_sym_notnull] = ACTIONS(3642),
    [anon_sym_unmanaged] = ACTIONS(3642),
    [anon_sym_get] = ACTIONS(3642),
    [anon_sym_set] = ACTIONS(3642),
    [anon_sym_add] = ACTIONS(3642),
    [anon_sym_remove] = ACTIONS(3642),
    [anon_sym_enum] = ACTIONS(3642),
    [anon_sym_interface] = ACTIONS(3642),
    [anon_sym_delegate] = ACTIONS(3642),
    [anon_sym_record] = ACTIONS(3642),
    [anon_sym_namespace] = ACTIONS(3642),
    [anon_sym_var] = ACTIONS(3642),
    [sym_predefined_type] = ACTIONS(3642),
    [anon_sym_when] = ACTIONS(3642),
    [anon_sym_yield] = ACTIONS(3642),
    [anon_sym_from] = ACTIONS(3642),
    [anon_sym_join] = ACTIONS(3642),
    [anon_sym_on] = ACTIONS(3642),
    [anon_sym_equals] = ACTIONS(3642),
    [anon_sym_into] = ACTIONS(3642),
    [anon_sym_let] = ACTIONS(3642),
    [anon_sym_orderby] = ACTIONS(3642),
    [anon_sym_ascending] = ACTIONS(3642),
    [anon_sym_descending] = ACTIONS(3642),
    [anon_sym_group] = ACTIONS(3642),
    [anon_sym_by] = ACTIONS(3642),
    [anon_sym_select] = ACTIONS(3642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3642),
    [anon_sym_nameof] = ACTIONS(3642),
    [sym_void_keyword] = ACTIONS(3642),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2223] = {
    [sym__preprocessor_call] = STATE(2223),
    [anon_sym_SEMI] = ACTIONS(3398),
    [anon_sym_EQ] = ACTIONS(3400),
    [anon_sym_LT] = ACTIONS(3400),
    [anon_sym_COMMA] = ACTIONS(3398),
    [anon_sym_GT] = ACTIONS(3400),
    [anon_sym_DOT] = ACTIONS(3400),
    [anon_sym_LBRACK] = ACTIONS(3398),
    [anon_sym_RBRACK] = ACTIONS(3398),
    [anon_sym_COLON] = ACTIONS(3398),
    [anon_sym_LPAREN] = ACTIONS(3398),
    [anon_sym_RPAREN] = ACTIONS(3398),
    [anon_sym_in] = ACTIONS(3398),
    [anon_sym_RBRACE] = ACTIONS(3398),
    [anon_sym_EQ_GT] = ACTIONS(3398),
    [anon_sym_where] = ACTIONS(3398),
    [anon_sym_QMARK] = ACTIONS(3400),
    [anon_sym_BANG] = ACTIONS(3400),
    [anon_sym_PLUS_PLUS] = ACTIONS(3398),
    [anon_sym_DASH_DASH] = ACTIONS(3398),
    [anon_sym_PLUS] = ACTIONS(3400),
    [anon_sym_DASH] = ACTIONS(3400),
    [anon_sym_STAR] = ACTIONS(3400),
    [anon_sym_SLASH] = ACTIONS(3400),
    [anon_sym_PERCENT] = ACTIONS(3400),
    [anon_sym_CARET] = ACTIONS(3400),
    [anon_sym_PIPE] = ACTIONS(3400),
    [anon_sym_AMP] = ACTIONS(3400),
    [anon_sym_LT_LT] = ACTIONS(3400),
    [anon_sym_GT_GT] = ACTIONS(3400),
    [anon_sym_EQ_EQ] = ACTIONS(3398),
    [anon_sym_BANG_EQ] = ACTIONS(3398),
    [anon_sym_GT_EQ] = ACTIONS(3398),
    [anon_sym_LT_EQ] = ACTIONS(3398),
    [anon_sym_switch] = ACTIONS(3398),
    [anon_sym_and] = ACTIONS(3398),
    [anon_sym_or] = ACTIONS(3400),
    [anon_sym_PLUS_EQ] = ACTIONS(3398),
    [anon_sym_DASH_EQ] = ACTIONS(3398),
    [anon_sym_STAR_EQ] = ACTIONS(3398),
    [anon_sym_SLASH_EQ] = ACTIONS(3398),
    [anon_sym_PERCENT_EQ] = ACTIONS(3398),
    [anon_sym_AMP_EQ] = ACTIONS(3398),
    [anon_sym_CARET_EQ] = ACTIONS(3398),
    [anon_sym_PIPE_EQ] = ACTIONS(3398),
    [anon_sym_LT_LT_EQ] = ACTIONS(3398),
    [anon_sym_GT_GT_EQ] = ACTIONS(3398),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3398),
    [anon_sym_is] = ACTIONS(3398),
    [anon_sym_DASH_GT] = ACTIONS(3398),
    [anon_sym_from] = ACTIONS(3398),
    [anon_sym_join] = ACTIONS(3398),
    [anon_sym_on] = ACTIONS(3398),
    [anon_sym_equals] = ACTIONS(3398),
    [anon_sym_let] = ACTIONS(3398),
    [anon_sym_orderby] = ACTIONS(3398),
    [anon_sym_group] = ACTIONS(3398),
    [anon_sym_by] = ACTIONS(3398),
    [anon_sym_select] = ACTIONS(3398),
    [anon_sym_DOT_DOT] = ACTIONS(3398),
    [anon_sym_with] = ACTIONS(3398),
    [anon_sym_AMP_AMP] = ACTIONS(3398),
    [anon_sym_PIPE_PIPE] = ACTIONS(3398),
    [anon_sym_QMARK_QMARK] = ACTIONS(3400),
    [anon_sym_as] = ACTIONS(3398),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2224] = {
    [sym__preprocessor_call] = STATE(2224),
    [anon_sym_SEMI] = ACTIONS(1989),
    [anon_sym_EQ] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1989),
    [anon_sym_GT] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1989),
    [anon_sym_RBRACK] = ACTIONS(1989),
    [anon_sym_COLON] = ACTIONS(1989),
    [anon_sym_LPAREN] = ACTIONS(1989),
    [anon_sym_RPAREN] = ACTIONS(1989),
    [anon_sym_in] = ACTIONS(1989),
    [anon_sym_RBRACE] = ACTIONS(1989),
    [anon_sym_EQ_GT] = ACTIONS(1989),
    [anon_sym_where] = ACTIONS(1989),
    [anon_sym_QMARK] = ACTIONS(1984),
    [anon_sym_BANG] = ACTIONS(1984),
    [anon_sym_PLUS_PLUS] = ACTIONS(1989),
    [anon_sym_DASH_DASH] = ACTIONS(1989),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1984),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1989),
    [anon_sym_BANG_EQ] = ACTIONS(1989),
    [anon_sym_GT_EQ] = ACTIONS(1989),
    [anon_sym_LT_EQ] = ACTIONS(1989),
    [anon_sym_switch] = ACTIONS(1989),
    [anon_sym_and] = ACTIONS(1989),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1989),
    [anon_sym_DASH_EQ] = ACTIONS(1989),
    [anon_sym_STAR_EQ] = ACTIONS(1989),
    [anon_sym_SLASH_EQ] = ACTIONS(1989),
    [anon_sym_PERCENT_EQ] = ACTIONS(1989),
    [anon_sym_AMP_EQ] = ACTIONS(1989),
    [anon_sym_CARET_EQ] = ACTIONS(1989),
    [anon_sym_PIPE_EQ] = ACTIONS(1989),
    [anon_sym_LT_LT_EQ] = ACTIONS(1989),
    [anon_sym_GT_GT_EQ] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1989),
    [anon_sym_is] = ACTIONS(1989),
    [anon_sym_DASH_GT] = ACTIONS(1989),
    [anon_sym_from] = ACTIONS(1989),
    [anon_sym_join] = ACTIONS(1989),
    [anon_sym_on] = ACTIONS(1989),
    [anon_sym_equals] = ACTIONS(1989),
    [anon_sym_let] = ACTIONS(1989),
    [anon_sym_orderby] = ACTIONS(1989),
    [anon_sym_group] = ACTIONS(1989),
    [anon_sym_by] = ACTIONS(1989),
    [anon_sym_select] = ACTIONS(1989),
    [anon_sym_DOT_DOT] = ACTIONS(1989),
    [anon_sym_with] = ACTIONS(1989),
    [anon_sym_AMP_AMP] = ACTIONS(1989),
    [anon_sym_PIPE_PIPE] = ACTIONS(1989),
    [anon_sym_QMARK_QMARK] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1989),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2225] = {
    [sym__preprocessor_call] = STATE(2225),
    [anon_sym_SEMI] = ACTIONS(3522),
    [anon_sym_EQ] = ACTIONS(3524),
    [anon_sym_LT] = ACTIONS(3524),
    [anon_sym_COMMA] = ACTIONS(3522),
    [anon_sym_GT] = ACTIONS(3524),
    [anon_sym_DOT] = ACTIONS(3524),
    [anon_sym_LBRACK] = ACTIONS(3522),
    [anon_sym_RBRACK] = ACTIONS(3522),
    [anon_sym_COLON] = ACTIONS(3522),
    [anon_sym_LPAREN] = ACTIONS(3522),
    [anon_sym_RPAREN] = ACTIONS(3522),
    [anon_sym_in] = ACTIONS(3522),
    [anon_sym_RBRACE] = ACTIONS(3522),
    [anon_sym_EQ_GT] = ACTIONS(3522),
    [anon_sym_where] = ACTIONS(3522),
    [anon_sym_QMARK] = ACTIONS(3524),
    [anon_sym_BANG] = ACTIONS(3524),
    [anon_sym_PLUS_PLUS] = ACTIONS(3522),
    [anon_sym_DASH_DASH] = ACTIONS(3522),
    [anon_sym_PLUS] = ACTIONS(3524),
    [anon_sym_DASH] = ACTIONS(3524),
    [anon_sym_STAR] = ACTIONS(3524),
    [anon_sym_SLASH] = ACTIONS(3524),
    [anon_sym_PERCENT] = ACTIONS(3524),
    [anon_sym_CARET] = ACTIONS(3524),
    [anon_sym_PIPE] = ACTIONS(3524),
    [anon_sym_AMP] = ACTIONS(3524),
    [anon_sym_LT_LT] = ACTIONS(3524),
    [anon_sym_GT_GT] = ACTIONS(3524),
    [anon_sym_EQ_EQ] = ACTIONS(3522),
    [anon_sym_BANG_EQ] = ACTIONS(3522),
    [anon_sym_GT_EQ] = ACTIONS(3522),
    [anon_sym_LT_EQ] = ACTIONS(3522),
    [anon_sym_switch] = ACTIONS(3522),
    [anon_sym_and] = ACTIONS(3522),
    [anon_sym_or] = ACTIONS(3524),
    [anon_sym_PLUS_EQ] = ACTIONS(3522),
    [anon_sym_DASH_EQ] = ACTIONS(3522),
    [anon_sym_STAR_EQ] = ACTIONS(3522),
    [anon_sym_SLASH_EQ] = ACTIONS(3522),
    [anon_sym_PERCENT_EQ] = ACTIONS(3522),
    [anon_sym_AMP_EQ] = ACTIONS(3522),
    [anon_sym_CARET_EQ] = ACTIONS(3522),
    [anon_sym_PIPE_EQ] = ACTIONS(3522),
    [anon_sym_LT_LT_EQ] = ACTIONS(3522),
    [anon_sym_GT_GT_EQ] = ACTIONS(3522),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3522),
    [anon_sym_is] = ACTIONS(3522),
    [anon_sym_DASH_GT] = ACTIONS(3522),
    [anon_sym_from] = ACTIONS(3522),
    [anon_sym_join] = ACTIONS(3522),
    [anon_sym_on] = ACTIONS(3522),
    [anon_sym_equals] = ACTIONS(3522),
    [anon_sym_let] = ACTIONS(3522),
    [anon_sym_orderby] = ACTIONS(3522),
    [anon_sym_group] = ACTIONS(3522),
    [anon_sym_by] = ACTIONS(3522),
    [anon_sym_select] = ACTIONS(3522),
    [anon_sym_DOT_DOT] = ACTIONS(3522),
    [anon_sym_with] = ACTIONS(3522),
    [anon_sym_AMP_AMP] = ACTIONS(3522),
    [anon_sym_PIPE_PIPE] = ACTIONS(3522),
    [anon_sym_QMARK_QMARK] = ACTIONS(3524),
    [anon_sym_as] = ACTIONS(3522),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2226] = {
    [sym__preprocessor_call] = STATE(2226),
    [anon_sym_SEMI] = ACTIONS(3332),
    [anon_sym_EQ] = ACTIONS(3334),
    [anon_sym_LT] = ACTIONS(3334),
    [anon_sym_COMMA] = ACTIONS(3332),
    [anon_sym_GT] = ACTIONS(3334),
    [anon_sym_DOT] = ACTIONS(3334),
    [anon_sym_LBRACK] = ACTIONS(3332),
    [anon_sym_RBRACK] = ACTIONS(3332),
    [anon_sym_COLON] = ACTIONS(3332),
    [anon_sym_LPAREN] = ACTIONS(3332),
    [anon_sym_RPAREN] = ACTIONS(3332),
    [anon_sym_in] = ACTIONS(3332),
    [anon_sym_RBRACE] = ACTIONS(3332),
    [anon_sym_EQ_GT] = ACTIONS(3332),
    [anon_sym_where] = ACTIONS(3332),
    [anon_sym_QMARK] = ACTIONS(3334),
    [anon_sym_BANG] = ACTIONS(3334),
    [anon_sym_PLUS_PLUS] = ACTIONS(3332),
    [anon_sym_DASH_DASH] = ACTIONS(3332),
    [anon_sym_PLUS] = ACTIONS(3334),
    [anon_sym_DASH] = ACTIONS(3334),
    [anon_sym_STAR] = ACTIONS(3334),
    [anon_sym_SLASH] = ACTIONS(3334),
    [anon_sym_PERCENT] = ACTIONS(3334),
    [anon_sym_CARET] = ACTIONS(3334),
    [anon_sym_PIPE] = ACTIONS(3334),
    [anon_sym_AMP] = ACTIONS(3334),
    [anon_sym_LT_LT] = ACTIONS(3334),
    [anon_sym_GT_GT] = ACTIONS(3334),
    [anon_sym_EQ_EQ] = ACTIONS(3332),
    [anon_sym_BANG_EQ] = ACTIONS(3332),
    [anon_sym_GT_EQ] = ACTIONS(3332),
    [anon_sym_LT_EQ] = ACTIONS(3332),
    [anon_sym_switch] = ACTIONS(3332),
    [anon_sym_and] = ACTIONS(3332),
    [anon_sym_or] = ACTIONS(3334),
    [anon_sym_PLUS_EQ] = ACTIONS(3332),
    [anon_sym_DASH_EQ] = ACTIONS(3332),
    [anon_sym_STAR_EQ] = ACTIONS(3332),
    [anon_sym_SLASH_EQ] = ACTIONS(3332),
    [anon_sym_PERCENT_EQ] = ACTIONS(3332),
    [anon_sym_AMP_EQ] = ACTIONS(3332),
    [anon_sym_CARET_EQ] = ACTIONS(3332),
    [anon_sym_PIPE_EQ] = ACTIONS(3332),
    [anon_sym_LT_LT_EQ] = ACTIONS(3332),
    [anon_sym_GT_GT_EQ] = ACTIONS(3332),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3332),
    [anon_sym_is] = ACTIONS(3332),
    [anon_sym_DASH_GT] = ACTIONS(3332),
    [anon_sym_from] = ACTIONS(3332),
    [anon_sym_join] = ACTIONS(3332),
    [anon_sym_on] = ACTIONS(3332),
    [anon_sym_equals] = ACTIONS(3332),
    [anon_sym_let] = ACTIONS(3332),
    [anon_sym_orderby] = ACTIONS(3332),
    [anon_sym_group] = ACTIONS(3332),
    [anon_sym_by] = ACTIONS(3332),
    [anon_sym_select] = ACTIONS(3332),
    [anon_sym_DOT_DOT] = ACTIONS(3332),
    [anon_sym_with] = ACTIONS(3332),
    [anon_sym_AMP_AMP] = ACTIONS(3332),
    [anon_sym_PIPE_PIPE] = ACTIONS(3332),
    [anon_sym_QMARK_QMARK] = ACTIONS(3334),
    [anon_sym_as] = ACTIONS(3332),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2227] = {
    [sym__preprocessor_call] = STATE(2227),
    [anon_sym_SEMI] = ACTIONS(3450),
    [anon_sym_EQ] = ACTIONS(3452),
    [anon_sym_LT] = ACTIONS(3452),
    [anon_sym_COMMA] = ACTIONS(3450),
    [anon_sym_GT] = ACTIONS(3452),
    [anon_sym_DOT] = ACTIONS(3452),
    [anon_sym_LBRACK] = ACTIONS(3450),
    [anon_sym_RBRACK] = ACTIONS(3450),
    [anon_sym_COLON] = ACTIONS(3450),
    [anon_sym_LPAREN] = ACTIONS(3450),
    [anon_sym_RPAREN] = ACTIONS(3450),
    [anon_sym_in] = ACTIONS(3450),
    [anon_sym_RBRACE] = ACTIONS(3450),
    [anon_sym_EQ_GT] = ACTIONS(3450),
    [anon_sym_where] = ACTIONS(3450),
    [anon_sym_QMARK] = ACTIONS(3452),
    [anon_sym_BANG] = ACTIONS(3452),
    [anon_sym_PLUS_PLUS] = ACTIONS(3450),
    [anon_sym_DASH_DASH] = ACTIONS(3450),
    [anon_sym_PLUS] = ACTIONS(3452),
    [anon_sym_DASH] = ACTIONS(3452),
    [anon_sym_STAR] = ACTIONS(3452),
    [anon_sym_SLASH] = ACTIONS(3452),
    [anon_sym_PERCENT] = ACTIONS(3452),
    [anon_sym_CARET] = ACTIONS(3452),
    [anon_sym_PIPE] = ACTIONS(3452),
    [anon_sym_AMP] = ACTIONS(3452),
    [anon_sym_LT_LT] = ACTIONS(3452),
    [anon_sym_GT_GT] = ACTIONS(3452),
    [anon_sym_EQ_EQ] = ACTIONS(3450),
    [anon_sym_BANG_EQ] = ACTIONS(3450),
    [anon_sym_GT_EQ] = ACTIONS(3450),
    [anon_sym_LT_EQ] = ACTIONS(3450),
    [anon_sym_switch] = ACTIONS(3450),
    [anon_sym_and] = ACTIONS(3450),
    [anon_sym_or] = ACTIONS(3452),
    [anon_sym_PLUS_EQ] = ACTIONS(3450),
    [anon_sym_DASH_EQ] = ACTIONS(3450),
    [anon_sym_STAR_EQ] = ACTIONS(3450),
    [anon_sym_SLASH_EQ] = ACTIONS(3450),
    [anon_sym_PERCENT_EQ] = ACTIONS(3450),
    [anon_sym_AMP_EQ] = ACTIONS(3450),
    [anon_sym_CARET_EQ] = ACTIONS(3450),
    [anon_sym_PIPE_EQ] = ACTIONS(3450),
    [anon_sym_LT_LT_EQ] = ACTIONS(3450),
    [anon_sym_GT_GT_EQ] = ACTIONS(3450),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3450),
    [anon_sym_is] = ACTIONS(3450),
    [anon_sym_DASH_GT] = ACTIONS(3450),
    [anon_sym_from] = ACTIONS(3450),
    [anon_sym_join] = ACTIONS(3450),
    [anon_sym_on] = ACTIONS(3450),
    [anon_sym_equals] = ACTIONS(3450),
    [anon_sym_let] = ACTIONS(3450),
    [anon_sym_orderby] = ACTIONS(3450),
    [anon_sym_group] = ACTIONS(3450),
    [anon_sym_by] = ACTIONS(3450),
    [anon_sym_select] = ACTIONS(3450),
    [anon_sym_DOT_DOT] = ACTIONS(3450),
    [anon_sym_with] = ACTIONS(3450),
    [anon_sym_AMP_AMP] = ACTIONS(3450),
    [anon_sym_PIPE_PIPE] = ACTIONS(3450),
    [anon_sym_QMARK_QMARK] = ACTIONS(3452),
    [anon_sym_as] = ACTIONS(3450),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2228] = {
    [sym__preprocessor_call] = STATE(2228),
    [anon_sym_SEMI] = ACTIONS(1981),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_COMMA] = ACTIONS(1981),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_DOT] = ACTIONS(1986),
    [anon_sym_LBRACK] = ACTIONS(1981),
    [anon_sym_RBRACK] = ACTIONS(1981),
    [anon_sym_COLON] = ACTIONS(1981),
    [anon_sym_LPAREN] = ACTIONS(1981),
    [anon_sym_RPAREN] = ACTIONS(1981),
    [anon_sym_in] = ACTIONS(1981),
    [anon_sym_RBRACE] = ACTIONS(1981),
    [anon_sym_EQ_GT] = ACTIONS(1981),
    [anon_sym_where] = ACTIONS(1981),
    [anon_sym_QMARK] = ACTIONS(1986),
    [anon_sym_BANG] = ACTIONS(1986),
    [anon_sym_PLUS_PLUS] = ACTIONS(1981),
    [anon_sym_DASH_DASH] = ACTIONS(1981),
    [anon_sym_PLUS] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1986),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_LT_LT] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1986),
    [anon_sym_EQ_EQ] = ACTIONS(1981),
    [anon_sym_BANG_EQ] = ACTIONS(1981),
    [anon_sym_GT_EQ] = ACTIONS(1981),
    [anon_sym_LT_EQ] = ACTIONS(1981),
    [anon_sym_switch] = ACTIONS(1981),
    [anon_sym_and] = ACTIONS(1981),
    [anon_sym_or] = ACTIONS(1986),
    [anon_sym_PLUS_EQ] = ACTIONS(1981),
    [anon_sym_DASH_EQ] = ACTIONS(1981),
    [anon_sym_STAR_EQ] = ACTIONS(1981),
    [anon_sym_SLASH_EQ] = ACTIONS(1981),
    [anon_sym_PERCENT_EQ] = ACTIONS(1981),
    [anon_sym_AMP_EQ] = ACTIONS(1981),
    [anon_sym_CARET_EQ] = ACTIONS(1981),
    [anon_sym_PIPE_EQ] = ACTIONS(1981),
    [anon_sym_LT_LT_EQ] = ACTIONS(1981),
    [anon_sym_GT_GT_EQ] = ACTIONS(1981),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(1981),
    [anon_sym_is] = ACTIONS(1981),
    [anon_sym_DASH_GT] = ACTIONS(1981),
    [anon_sym_from] = ACTIONS(1981),
    [anon_sym_join] = ACTIONS(1981),
    [anon_sym_on] = ACTIONS(1981),
    [anon_sym_equals] = ACTIONS(1981),
    [anon_sym_let] = ACTIONS(1981),
    [anon_sym_orderby] = ACTIONS(1981),
    [anon_sym_group] = ACTIONS(1981),
    [anon_sym_by] = ACTIONS(1981),
    [anon_sym_select] = ACTIONS(1981),
    [anon_sym_DOT_DOT] = ACTIONS(1981),
    [anon_sym_with] = ACTIONS(1981),
    [anon_sym_AMP_AMP] = ACTIONS(1981),
    [anon_sym_PIPE_PIPE] = ACTIONS(1981),
    [anon_sym_QMARK_QMARK] = ACTIONS(1986),
    [anon_sym_as] = ACTIONS(1981),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2229] = {
    [sym__preprocessor_call] = STATE(2229),
    [anon_sym_SEMI] = ACTIONS(3458),
    [anon_sym_EQ] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_GT] = ACTIONS(3460),
    [anon_sym_DOT] = ACTIONS(3460),
    [anon_sym_LBRACK] = ACTIONS(3458),
    [anon_sym_RBRACK] = ACTIONS(3458),
    [anon_sym_COLON] = ACTIONS(3458),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_RPAREN] = ACTIONS(3458),
    [anon_sym_in] = ACTIONS(3458),
    [anon_sym_RBRACE] = ACTIONS(3458),
    [anon_sym_EQ_GT] = ACTIONS(3458),
    [anon_sym_where] = ACTIONS(3458),
    [anon_sym_QMARK] = ACTIONS(3460),
    [anon_sym_BANG] = ACTIONS(3460),
    [anon_sym_PLUS_PLUS] = ACTIONS(3458),
    [anon_sym_DASH_DASH] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_SLASH] = ACTIONS(3460),
    [anon_sym_PERCENT] = ACTIONS(3460),
    [anon_sym_CARET] = ACTIONS(3460),
    [anon_sym_PIPE] = ACTIONS(3460),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_LT_LT] = ACTIONS(3460),
    [anon_sym_GT_GT] = ACTIONS(3460),
    [anon_sym_EQ_EQ] = ACTIONS(3458),
    [anon_sym_BANG_EQ] = ACTIONS(3458),
    [anon_sym_GT_EQ] = ACTIONS(3458),
    [anon_sym_LT_EQ] = ACTIONS(3458),
    [anon_sym_switch] = ACTIONS(3458),
    [anon_sym_and] = ACTIONS(3458),
    [anon_sym_or] = ACTIONS(3460),
    [anon_sym_PLUS_EQ] = ACTIONS(3458),
    [anon_sym_DASH_EQ] = ACTIONS(3458),
    [anon_sym_STAR_EQ] = ACTIONS(3458),
    [anon_sym_SLASH_EQ] = ACTIONS(3458),
    [anon_sym_PERCENT_EQ] = ACTIONS(3458),
    [anon_sym_AMP_EQ] = ACTIONS(3458),
    [anon_sym_CARET_EQ] = ACTIONS(3458),
    [anon_sym_PIPE_EQ] = ACTIONS(3458),
    [anon_sym_LT_LT_EQ] = ACTIONS(3458),
    [anon_sym_GT_GT_EQ] = ACTIONS(3458),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3458),
    [anon_sym_is] = ACTIONS(3458),
    [anon_sym_DASH_GT] = ACTIONS(3458),
    [anon_sym_from] = ACTIONS(3458),
    [anon_sym_join] = ACTIONS(3458),
    [anon_sym_on] = ACTIONS(3458),
    [anon_sym_equals] = ACTIONS(3458),
    [anon_sym_let] = ACTIONS(3458),
    [anon_sym_orderby] = ACTIONS(3458),
    [anon_sym_group] = ACTIONS(3458),
    [anon_sym_by] = ACTIONS(3458),
    [anon_sym_select] = ACTIONS(3458),
    [anon_sym_DOT_DOT] = ACTIONS(3458),
    [anon_sym_with] = ACTIONS(3458),
    [anon_sym_AMP_AMP] = ACTIONS(3458),
    [anon_sym_PIPE_PIPE] = ACTIONS(3458),
    [anon_sym_QMARK_QMARK] = ACTIONS(3460),
    [anon_sym_as] = ACTIONS(3458),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2230] = {
    [sym__preprocessor_call] = STATE(2230),
    [anon_sym_SEMI] = ACTIONS(3462),
    [anon_sym_EQ] = ACTIONS(3464),
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_COMMA] = ACTIONS(3462),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_DOT] = ACTIONS(3464),
    [anon_sym_LBRACK] = ACTIONS(3462),
    [anon_sym_RBRACK] = ACTIONS(3462),
    [anon_sym_COLON] = ACTIONS(3462),
    [anon_sym_LPAREN] = ACTIONS(3462),
    [anon_sym_RPAREN] = ACTIONS(3462),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_RBRACE] = ACTIONS(3462),
    [anon_sym_EQ_GT] = ACTIONS(3462),
    [anon_sym_where] = ACTIONS(3462),
    [anon_sym_QMARK] = ACTIONS(3464),
    [anon_sym_BANG] = ACTIONS(3464),
    [anon_sym_PLUS_PLUS] = ACTIONS(3462),
    [anon_sym_DASH_DASH] = ACTIONS(3462),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3464),
    [anon_sym_CARET] = ACTIONS(3464),
    [anon_sym_PIPE] = ACTIONS(3464),
    [anon_sym_AMP] = ACTIONS(3464),
    [anon_sym_LT_LT] = ACTIONS(3464),
    [anon_sym_GT_GT] = ACTIONS(3464),
    [anon_sym_EQ_EQ] = ACTIONS(3462),
    [anon_sym_BANG_EQ] = ACTIONS(3462),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_LT_EQ] = ACTIONS(3462),
    [anon_sym_switch] = ACTIONS(3462),
    [anon_sym_and] = ACTIONS(3462),
    [anon_sym_or] = ACTIONS(3464),
    [anon_sym_PLUS_EQ] = ACTIONS(3462),
    [anon_sym_DASH_EQ] = ACTIONS(3462),
    [anon_sym_STAR_EQ] = ACTIONS(3462),
    [anon_sym_SLASH_EQ] = ACTIONS(3462),
    [anon_sym_PERCENT_EQ] = ACTIONS(3462),
    [anon_sym_AMP_EQ] = ACTIONS(3462),
    [anon_sym_CARET_EQ] = ACTIONS(3462),
    [anon_sym_PIPE_EQ] = ACTIONS(3462),
    [anon_sym_LT_LT_EQ] = ACTIONS(3462),
    [anon_sym_GT_GT_EQ] = ACTIONS(3462),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3462),
    [anon_sym_is] = ACTIONS(3462),
    [anon_sym_DASH_GT] = ACTIONS(3462),
    [anon_sym_from] = ACTIONS(3462),
    [anon_sym_join] = ACTIONS(3462),
    [anon_sym_on] = ACTIONS(3462),
    [anon_sym_equals] = ACTIONS(3462),
    [anon_sym_let] = ACTIONS(3462),
    [anon_sym_orderby] = ACTIONS(3462),
    [anon_sym_group] = ACTIONS(3462),
    [anon_sym_by] = ACTIONS(3462),
    [anon_sym_select] = ACTIONS(3462),
    [anon_sym_DOT_DOT] = ACTIONS(3462),
    [anon_sym_with] = ACTIONS(3462),
    [anon_sym_AMP_AMP] = ACTIONS(3462),
    [anon_sym_PIPE_PIPE] = ACTIONS(3462),
    [anon_sym_QMARK_QMARK] = ACTIONS(3464),
    [anon_sym_as] = ACTIONS(3462),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2231] = {
    [sym__preprocessor_call] = STATE(2231),
    [sym__identifier_token] = ACTIONS(3648),
    [anon_sym_extern] = ACTIONS(3648),
    [anon_sym_alias] = ACTIONS(3648),
    [anon_sym_SEMI] = ACTIONS(3650),
    [anon_sym_global] = ACTIONS(3648),
    [anon_sym_using] = ACTIONS(3648),
    [anon_sym_static] = ACTIONS(3648),
    [anon_sym_LBRACK] = ACTIONS(3650),
    [anon_sym_event] = ACTIONS(3648),
    [anon_sym_LPAREN] = ACTIONS(3650),
    [anon_sym_abstract] = ACTIONS(3648),
    [anon_sym_async] = ACTIONS(3648),
    [anon_sym_const] = ACTIONS(3648),
    [anon_sym_fixed] = ACTIONS(3648),
    [anon_sym_internal] = ACTIONS(3648),
    [anon_sym_new] = ACTIONS(3648),
    [anon_sym_override] = ACTIONS(3648),
    [anon_sym_partial] = ACTIONS(3648),
    [anon_sym_private] = ACTIONS(3648),
    [anon_sym_protected] = ACTIONS(3648),
    [anon_sym_public] = ACTIONS(3648),
    [anon_sym_readonly] = ACTIONS(3648),
    [anon_sym_ref] = ACTIONS(3648),
    [anon_sym_sealed] = ACTIONS(3648),
    [anon_sym_unsafe] = ACTIONS(3648),
    [anon_sym_virtual] = ACTIONS(3648),
    [anon_sym_volatile] = ACTIONS(3648),
    [anon_sym_RBRACE] = ACTIONS(3650),
    [anon_sym_implicit] = ACTIONS(3648),
    [anon_sym_explicit] = ACTIONS(3648),
    [anon_sym_TILDE] = ACTIONS(3650),
    [anon_sym_where] = ACTIONS(3648),
    [anon_sym_class] = ACTIONS(3648),
    [anon_sym_struct] = ACTIONS(3648),
    [anon_sym_notnull] = ACTIONS(3648),
    [anon_sym_unmanaged] = ACTIONS(3648),
    [anon_sym_get] = ACTIONS(3648),
    [anon_sym_set] = ACTIONS(3648),
    [anon_sym_add] = ACTIONS(3648),
    [anon_sym_remove] = ACTIONS(3648),
    [anon_sym_enum] = ACTIONS(3648),
    [anon_sym_interface] = ACTIONS(3648),
    [anon_sym_delegate] = ACTIONS(3648),
    [anon_sym_record] = ACTIONS(3648),
    [anon_sym_namespace] = ACTIONS(3648),
    [anon_sym_var] = ACTIONS(3648),
    [sym_predefined_type] = ACTIONS(3648),
    [anon_sym_when] = ACTIONS(3648),
    [anon_sym_yield] = ACTIONS(3648),
    [anon_sym_from] = ACTIONS(3648),
    [anon_sym_join] = ACTIONS(3648),
    [anon_sym_on] = ACTIONS(3648),
    [anon_sym_equals] = ACTIONS(3648),
    [anon_sym_into] = ACTIONS(3648),
    [anon_sym_let] = ACTIONS(3648),
    [anon_sym_orderby] = ACTIONS(3648),
    [anon_sym_ascending] = ACTIONS(3648),
    [anon_sym_descending] = ACTIONS(3648),
    [anon_sym_group] = ACTIONS(3648),
    [anon_sym_by] = ACTIONS(3648),
    [anon_sym_select] = ACTIONS(3648),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3648),
    [anon_sym_nameof] = ACTIONS(3648),
    [sym_void_keyword] = ACTIONS(3648),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2232] = {
    [sym__preprocessor_call] = STATE(2232),
    [sym__identifier_token] = ACTIONS(3652),
    [anon_sym_extern] = ACTIONS(3652),
    [anon_sym_alias] = ACTIONS(3652),
    [anon_sym_SEMI] = ACTIONS(3654),
    [anon_sym_global] = ACTIONS(3652),
    [anon_sym_using] = ACTIONS(3652),
    [anon_sym_static] = ACTIONS(3652),
    [anon_sym_LBRACK] = ACTIONS(3656),
    [anon_sym_event] = ACTIONS(3652),
    [anon_sym_LPAREN] = ACTIONS(3656),
    [anon_sym_abstract] = ACTIONS(3652),
    [anon_sym_async] = ACTIONS(3652),
    [anon_sym_const] = ACTIONS(3652),
    [anon_sym_fixed] = ACTIONS(3652),
    [anon_sym_internal] = ACTIONS(3652),
    [anon_sym_new] = ACTIONS(3652),
    [anon_sym_override] = ACTIONS(3652),
    [anon_sym_partial] = ACTIONS(3652),
    [anon_sym_private] = ACTIONS(3652),
    [anon_sym_protected] = ACTIONS(3652),
    [anon_sym_public] = ACTIONS(3652),
    [anon_sym_readonly] = ACTIONS(3652),
    [anon_sym_ref] = ACTIONS(3652),
    [anon_sym_sealed] = ACTIONS(3652),
    [anon_sym_unsafe] = ACTIONS(3652),
    [anon_sym_virtual] = ACTIONS(3652),
    [anon_sym_volatile] = ACTIONS(3652),
    [anon_sym_RBRACE] = ACTIONS(3656),
    [anon_sym_implicit] = ACTIONS(3652),
    [anon_sym_explicit] = ACTIONS(3652),
    [anon_sym_TILDE] = ACTIONS(3656),
    [anon_sym_where] = ACTIONS(3652),
    [anon_sym_class] = ACTIONS(3652),
    [anon_sym_struct] = ACTIONS(3652),
    [anon_sym_notnull] = ACTIONS(3652),
    [anon_sym_unmanaged] = ACTIONS(3652),
    [anon_sym_get] = ACTIONS(3652),
    [anon_sym_set] = ACTIONS(3652),
    [anon_sym_add] = ACTIONS(3652),
    [anon_sym_remove] = ACTIONS(3652),
    [anon_sym_enum] = ACTIONS(3652),
    [anon_sym_interface] = ACTIONS(3652),
    [anon_sym_delegate] = ACTIONS(3652),
    [anon_sym_record] = ACTIONS(3652),
    [anon_sym_namespace] = ACTIONS(3652),
    [anon_sym_var] = ACTIONS(3652),
    [sym_predefined_type] = ACTIONS(3652),
    [anon_sym_when] = ACTIONS(3652),
    [anon_sym_yield] = ACTIONS(3652),
    [anon_sym_from] = ACTIONS(3652),
    [anon_sym_join] = ACTIONS(3652),
    [anon_sym_on] = ACTIONS(3652),
    [anon_sym_equals] = ACTIONS(3652),
    [anon_sym_into] = ACTIONS(3652),
    [anon_sym_let] = ACTIONS(3652),
    [anon_sym_orderby] = ACTIONS(3652),
    [anon_sym_ascending] = ACTIONS(3652),
    [anon_sym_descending] = ACTIONS(3652),
    [anon_sym_group] = ACTIONS(3652),
    [anon_sym_by] = ACTIONS(3652),
    [anon_sym_select] = ACTIONS(3652),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3652),
    [anon_sym_nameof] = ACTIONS(3652),
    [sym_void_keyword] = ACTIONS(3652),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2233] = {
    [sym__preprocessor_call] = STATE(2233),
    [anon_sym_SEMI] = ACTIONS(3466),
    [anon_sym_EQ] = ACTIONS(3468),
    [anon_sym_LT] = ACTIONS(3468),
    [anon_sym_COMMA] = ACTIONS(3466),
    [anon_sym_GT] = ACTIONS(3468),
    [anon_sym_DOT] = ACTIONS(3468),
    [anon_sym_LBRACK] = ACTIONS(3466),
    [anon_sym_RBRACK] = ACTIONS(3466),
    [anon_sym_COLON] = ACTIONS(3466),
    [anon_sym_LPAREN] = ACTIONS(3466),
    [anon_sym_RPAREN] = ACTIONS(3466),
    [anon_sym_in] = ACTIONS(3466),
    [anon_sym_RBRACE] = ACTIONS(3466),
    [anon_sym_EQ_GT] = ACTIONS(3466),
    [anon_sym_where] = ACTIONS(3466),
    [anon_sym_QMARK] = ACTIONS(3468),
    [anon_sym_BANG] = ACTIONS(3468),
    [anon_sym_PLUS_PLUS] = ACTIONS(3466),
    [anon_sym_DASH_DASH] = ACTIONS(3466),
    [anon_sym_PLUS] = ACTIONS(3468),
    [anon_sym_DASH] = ACTIONS(3468),
    [anon_sym_STAR] = ACTIONS(3468),
    [anon_sym_SLASH] = ACTIONS(3468),
    [anon_sym_PERCENT] = ACTIONS(3468),
    [anon_sym_CARET] = ACTIONS(3468),
    [anon_sym_PIPE] = ACTIONS(3468),
    [anon_sym_AMP] = ACTIONS(3468),
    [anon_sym_LT_LT] = ACTIONS(3468),
    [anon_sym_GT_GT] = ACTIONS(3468),
    [anon_sym_EQ_EQ] = ACTIONS(3466),
    [anon_sym_BANG_EQ] = ACTIONS(3466),
    [anon_sym_GT_EQ] = ACTIONS(3466),
    [anon_sym_LT_EQ] = ACTIONS(3466),
    [anon_sym_switch] = ACTIONS(3466),
    [anon_sym_and] = ACTIONS(3466),
    [anon_sym_or] = ACTIONS(3468),
    [anon_sym_PLUS_EQ] = ACTIONS(3466),
    [anon_sym_DASH_EQ] = ACTIONS(3466),
    [anon_sym_STAR_EQ] = ACTIONS(3466),
    [anon_sym_SLASH_EQ] = ACTIONS(3466),
    [anon_sym_PERCENT_EQ] = ACTIONS(3466),
    [anon_sym_AMP_EQ] = ACTIONS(3466),
    [anon_sym_CARET_EQ] = ACTIONS(3466),
    [anon_sym_PIPE_EQ] = ACTIONS(3466),
    [anon_sym_LT_LT_EQ] = ACTIONS(3466),
    [anon_sym_GT_GT_EQ] = ACTIONS(3466),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3466),
    [anon_sym_is] = ACTIONS(3466),
    [anon_sym_DASH_GT] = ACTIONS(3466),
    [anon_sym_from] = ACTIONS(3466),
    [anon_sym_join] = ACTIONS(3466),
    [anon_sym_on] = ACTIONS(3466),
    [anon_sym_equals] = ACTIONS(3466),
    [anon_sym_let] = ACTIONS(3466),
    [anon_sym_orderby] = ACTIONS(3466),
    [anon_sym_group] = ACTIONS(3466),
    [anon_sym_by] = ACTIONS(3466),
    [anon_sym_select] = ACTIONS(3466),
    [anon_sym_DOT_DOT] = ACTIONS(3466),
    [anon_sym_with] = ACTIONS(3466),
    [anon_sym_AMP_AMP] = ACTIONS(3466),
    [anon_sym_PIPE_PIPE] = ACTIONS(3466),
    [anon_sym_QMARK_QMARK] = ACTIONS(3468),
    [anon_sym_as] = ACTIONS(3466),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2234] = {
    [sym__preprocessor_call] = STATE(2234),
    [sym__identifier_token] = ACTIONS(3658),
    [anon_sym_extern] = ACTIONS(3658),
    [anon_sym_alias] = ACTIONS(3658),
    [anon_sym_SEMI] = ACTIONS(3660),
    [anon_sym_global] = ACTIONS(3658),
    [anon_sym_using] = ACTIONS(3658),
    [anon_sym_static] = ACTIONS(3658),
    [anon_sym_LBRACK] = ACTIONS(3662),
    [anon_sym_event] = ACTIONS(3658),
    [anon_sym_LPAREN] = ACTIONS(3662),
    [anon_sym_abstract] = ACTIONS(3658),
    [anon_sym_async] = ACTIONS(3658),
    [anon_sym_const] = ACTIONS(3658),
    [anon_sym_fixed] = ACTIONS(3658),
    [anon_sym_internal] = ACTIONS(3658),
    [anon_sym_new] = ACTIONS(3658),
    [anon_sym_override] = ACTIONS(3658),
    [anon_sym_partial] = ACTIONS(3658),
    [anon_sym_private] = ACTIONS(3658),
    [anon_sym_protected] = ACTIONS(3658),
    [anon_sym_public] = ACTIONS(3658),
    [anon_sym_readonly] = ACTIONS(3658),
    [anon_sym_ref] = ACTIONS(3658),
    [anon_sym_sealed] = ACTIONS(3658),
    [anon_sym_unsafe] = ACTIONS(3658),
    [anon_sym_virtual] = ACTIONS(3658),
    [anon_sym_volatile] = ACTIONS(3658),
    [anon_sym_RBRACE] = ACTIONS(3662),
    [anon_sym_implicit] = ACTIONS(3658),
    [anon_sym_explicit] = ACTIONS(3658),
    [anon_sym_TILDE] = ACTIONS(3662),
    [anon_sym_where] = ACTIONS(3658),
    [anon_sym_class] = ACTIONS(3658),
    [anon_sym_struct] = ACTIONS(3658),
    [anon_sym_notnull] = ACTIONS(3658),
    [anon_sym_unmanaged] = ACTIONS(3658),
    [anon_sym_get] = ACTIONS(3658),
    [anon_sym_set] = ACTIONS(3658),
    [anon_sym_add] = ACTIONS(3658),
    [anon_sym_remove] = ACTIONS(3658),
    [anon_sym_enum] = ACTIONS(3658),
    [anon_sym_interface] = ACTIONS(3658),
    [anon_sym_delegate] = ACTIONS(3658),
    [anon_sym_record] = ACTIONS(3658),
    [anon_sym_namespace] = ACTIONS(3658),
    [anon_sym_var] = ACTIONS(3658),
    [sym_predefined_type] = ACTIONS(3658),
    [anon_sym_when] = ACTIONS(3658),
    [anon_sym_yield] = ACTIONS(3658),
    [anon_sym_from] = ACTIONS(3658),
    [anon_sym_join] = ACTIONS(3658),
    [anon_sym_on] = ACTIONS(3658),
    [anon_sym_equals] = ACTIONS(3658),
    [anon_sym_into] = ACTIONS(3658),
    [anon_sym_let] = ACTIONS(3658),
    [anon_sym_orderby] = ACTIONS(3658),
    [anon_sym_ascending] = ACTIONS(3658),
    [anon_sym_descending] = ACTIONS(3658),
    [anon_sym_group] = ACTIONS(3658),
    [anon_sym_by] = ACTIONS(3658),
    [anon_sym_select] = ACTIONS(3658),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3658),
    [anon_sym_nameof] = ACTIONS(3658),
    [sym_void_keyword] = ACTIONS(3658),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2235] = {
    [sym__preprocessor_call] = STATE(2235),
    [sym__identifier_token] = ACTIONS(3664),
    [anon_sym_extern] = ACTIONS(3664),
    [anon_sym_alias] = ACTIONS(3664),
    [anon_sym_SEMI] = ACTIONS(3666),
    [anon_sym_global] = ACTIONS(3664),
    [anon_sym_using] = ACTIONS(3664),
    [anon_sym_static] = ACTIONS(3664),
    [anon_sym_LBRACK] = ACTIONS(3668),
    [anon_sym_event] = ACTIONS(3664),
    [anon_sym_LPAREN] = ACTIONS(3668),
    [anon_sym_abstract] = ACTIONS(3664),
    [anon_sym_async] = ACTIONS(3664),
    [anon_sym_const] = ACTIONS(3664),
    [anon_sym_fixed] = ACTIONS(3664),
    [anon_sym_internal] = ACTIONS(3664),
    [anon_sym_new] = ACTIONS(3664),
    [anon_sym_override] = ACTIONS(3664),
    [anon_sym_partial] = ACTIONS(3664),
    [anon_sym_private] = ACTIONS(3664),
    [anon_sym_protected] = ACTIONS(3664),
    [anon_sym_public] = ACTIONS(3664),
    [anon_sym_readonly] = ACTIONS(3664),
    [anon_sym_ref] = ACTIONS(3664),
    [anon_sym_sealed] = ACTIONS(3664),
    [anon_sym_unsafe] = ACTIONS(3664),
    [anon_sym_virtual] = ACTIONS(3664),
    [anon_sym_volatile] = ACTIONS(3664),
    [anon_sym_RBRACE] = ACTIONS(3668),
    [anon_sym_implicit] = ACTIONS(3664),
    [anon_sym_explicit] = ACTIONS(3664),
    [anon_sym_TILDE] = ACTIONS(3668),
    [anon_sym_where] = ACTIONS(3664),
    [anon_sym_class] = ACTIONS(3664),
    [anon_sym_struct] = ACTIONS(3664),
    [anon_sym_notnull] = ACTIONS(3664),
    [anon_sym_unmanaged] = ACTIONS(3664),
    [anon_sym_get] = ACTIONS(3664),
    [anon_sym_set] = ACTIONS(3664),
    [anon_sym_add] = ACTIONS(3664),
    [anon_sym_remove] = ACTIONS(3664),
    [anon_sym_enum] = ACTIONS(3664),
    [anon_sym_interface] = ACTIONS(3664),
    [anon_sym_delegate] = ACTIONS(3664),
    [anon_sym_record] = ACTIONS(3664),
    [anon_sym_namespace] = ACTIONS(3664),
    [anon_sym_var] = ACTIONS(3664),
    [sym_predefined_type] = ACTIONS(3664),
    [anon_sym_when] = ACTIONS(3664),
    [anon_sym_yield] = ACTIONS(3664),
    [anon_sym_from] = ACTIONS(3664),
    [anon_sym_join] = ACTIONS(3664),
    [anon_sym_on] = ACTIONS(3664),
    [anon_sym_equals] = ACTIONS(3664),
    [anon_sym_into] = ACTIONS(3664),
    [anon_sym_let] = ACTIONS(3664),
    [anon_sym_orderby] = ACTIONS(3664),
    [anon_sym_ascending] = ACTIONS(3664),
    [anon_sym_descending] = ACTIONS(3664),
    [anon_sym_group] = ACTIONS(3664),
    [anon_sym_by] = ACTIONS(3664),
    [anon_sym_select] = ACTIONS(3664),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3664),
    [anon_sym_nameof] = ACTIONS(3664),
    [sym_void_keyword] = ACTIONS(3664),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2236] = {
    [sym__preprocessor_call] = STATE(2236),
    [sym__identifier_token] = ACTIONS(3670),
    [anon_sym_extern] = ACTIONS(3670),
    [anon_sym_alias] = ACTIONS(3670),
    [anon_sym_SEMI] = ACTIONS(3672),
    [anon_sym_global] = ACTIONS(3670),
    [anon_sym_using] = ACTIONS(3670),
    [anon_sym_static] = ACTIONS(3670),
    [anon_sym_LBRACK] = ACTIONS(3674),
    [anon_sym_event] = ACTIONS(3670),
    [anon_sym_LPAREN] = ACTIONS(3674),
    [anon_sym_abstract] = ACTIONS(3670),
    [anon_sym_async] = ACTIONS(3670),
    [anon_sym_const] = ACTIONS(3670),
    [anon_sym_fixed] = ACTIONS(3670),
    [anon_sym_internal] = ACTIONS(3670),
    [anon_sym_new] = ACTIONS(3670),
    [anon_sym_override] = ACTIONS(3670),
    [anon_sym_partial] = ACTIONS(3670),
    [anon_sym_private] = ACTIONS(3670),
    [anon_sym_protected] = ACTIONS(3670),
    [anon_sym_public] = ACTIONS(3670),
    [anon_sym_readonly] = ACTIONS(3670),
    [anon_sym_ref] = ACTIONS(3670),
    [anon_sym_sealed] = ACTIONS(3670),
    [anon_sym_unsafe] = ACTIONS(3670),
    [anon_sym_virtual] = ACTIONS(3670),
    [anon_sym_volatile] = ACTIONS(3670),
    [anon_sym_RBRACE] = ACTIONS(3674),
    [anon_sym_implicit] = ACTIONS(3670),
    [anon_sym_explicit] = ACTIONS(3670),
    [anon_sym_TILDE] = ACTIONS(3674),
    [anon_sym_where] = ACTIONS(3670),
    [anon_sym_class] = ACTIONS(3670),
    [anon_sym_struct] = ACTIONS(3670),
    [anon_sym_notnull] = ACTIONS(3670),
    [anon_sym_unmanaged] = ACTIONS(3670),
    [anon_sym_get] = ACTIONS(3670),
    [anon_sym_set] = ACTIONS(3670),
    [anon_sym_add] = ACTIONS(3670),
    [anon_sym_remove] = ACTIONS(3670),
    [anon_sym_enum] = ACTIONS(3670),
    [anon_sym_interface] = ACTIONS(3670),
    [anon_sym_delegate] = ACTIONS(3670),
    [anon_sym_record] = ACTIONS(3670),
    [anon_sym_namespace] = ACTIONS(3670),
    [anon_sym_var] = ACTIONS(3670),
    [sym_predefined_type] = ACTIONS(3670),
    [anon_sym_when] = ACTIONS(3670),
    [anon_sym_yield] = ACTIONS(3670),
    [anon_sym_from] = ACTIONS(3670),
    [anon_sym_join] = ACTIONS(3670),
    [anon_sym_on] = ACTIONS(3670),
    [anon_sym_equals] = ACTIONS(3670),
    [anon_sym_into] = ACTIONS(3670),
    [anon_sym_let] = ACTIONS(3670),
    [anon_sym_orderby] = ACTIONS(3670),
    [anon_sym_ascending] = ACTIONS(3670),
    [anon_sym_descending] = ACTIONS(3670),
    [anon_sym_group] = ACTIONS(3670),
    [anon_sym_by] = ACTIONS(3670),
    [anon_sym_select] = ACTIONS(3670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3670),
    [anon_sym_nameof] = ACTIONS(3670),
    [sym_void_keyword] = ACTIONS(3670),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2237] = {
    [sym__preprocessor_call] = STATE(2237),
    [sym__identifier_token] = ACTIONS(3676),
    [anon_sym_extern] = ACTIONS(3676),
    [anon_sym_alias] = ACTIONS(3676),
    [anon_sym_SEMI] = ACTIONS(3678),
    [anon_sym_global] = ACTIONS(3676),
    [anon_sym_using] = ACTIONS(3676),
    [anon_sym_static] = ACTIONS(3676),
    [anon_sym_LBRACK] = ACTIONS(3680),
    [anon_sym_event] = ACTIONS(3676),
    [anon_sym_LPAREN] = ACTIONS(3680),
    [anon_sym_abstract] = ACTIONS(3676),
    [anon_sym_async] = ACTIONS(3676),
    [anon_sym_const] = ACTIONS(3676),
    [anon_sym_fixed] = ACTIONS(3676),
    [anon_sym_internal] = ACTIONS(3676),
    [anon_sym_new] = ACTIONS(3676),
    [anon_sym_override] = ACTIONS(3676),
    [anon_sym_partial] = ACTIONS(3676),
    [anon_sym_private] = ACTIONS(3676),
    [anon_sym_protected] = ACTIONS(3676),
    [anon_sym_public] = ACTIONS(3676),
    [anon_sym_readonly] = ACTIONS(3676),
    [anon_sym_ref] = ACTIONS(3676),
    [anon_sym_sealed] = ACTIONS(3676),
    [anon_sym_unsafe] = ACTIONS(3676),
    [anon_sym_virtual] = ACTIONS(3676),
    [anon_sym_volatile] = ACTIONS(3676),
    [anon_sym_RBRACE] = ACTIONS(3680),
    [anon_sym_implicit] = ACTIONS(3676),
    [anon_sym_explicit] = ACTIONS(3676),
    [anon_sym_TILDE] = ACTIONS(3680),
    [anon_sym_where] = ACTIONS(3676),
    [anon_sym_class] = ACTIONS(3676),
    [anon_sym_struct] = ACTIONS(3676),
    [anon_sym_notnull] = ACTIONS(3676),
    [anon_sym_unmanaged] = ACTIONS(3676),
    [anon_sym_get] = ACTIONS(3676),
    [anon_sym_set] = ACTIONS(3676),
    [anon_sym_add] = ACTIONS(3676),
    [anon_sym_remove] = ACTIONS(3676),
    [anon_sym_enum] = ACTIONS(3676),
    [anon_sym_interface] = ACTIONS(3676),
    [anon_sym_delegate] = ACTIONS(3676),
    [anon_sym_record] = ACTIONS(3676),
    [anon_sym_namespace] = ACTIONS(3676),
    [anon_sym_var] = ACTIONS(3676),
    [sym_predefined_type] = ACTIONS(3676),
    [anon_sym_when] = ACTIONS(3676),
    [anon_sym_yield] = ACTIONS(3676),
    [anon_sym_from] = ACTIONS(3676),
    [anon_sym_join] = ACTIONS(3676),
    [anon_sym_on] = ACTIONS(3676),
    [anon_sym_equals] = ACTIONS(3676),
    [anon_sym_into] = ACTIONS(3676),
    [anon_sym_let] = ACTIONS(3676),
    [anon_sym_orderby] = ACTIONS(3676),
    [anon_sym_ascending] = ACTIONS(3676),
    [anon_sym_descending] = ACTIONS(3676),
    [anon_sym_group] = ACTIONS(3676),
    [anon_sym_by] = ACTIONS(3676),
    [anon_sym_select] = ACTIONS(3676),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3676),
    [anon_sym_nameof] = ACTIONS(3676),
    [sym_void_keyword] = ACTIONS(3676),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2238] = {
    [sym__preprocessor_call] = STATE(2238),
    [sym__identifier_token] = ACTIONS(3682),
    [anon_sym_extern] = ACTIONS(3682),
    [anon_sym_alias] = ACTIONS(3682),
    [anon_sym_SEMI] = ACTIONS(3684),
    [anon_sym_global] = ACTIONS(3682),
    [anon_sym_using] = ACTIONS(3682),
    [anon_sym_static] = ACTIONS(3682),
    [anon_sym_LBRACK] = ACTIONS(3686),
    [anon_sym_event] = ACTIONS(3682),
    [anon_sym_LPAREN] = ACTIONS(3686),
    [anon_sym_abstract] = ACTIONS(3682),
    [anon_sym_async] = ACTIONS(3682),
    [anon_sym_const] = ACTIONS(3682),
    [anon_sym_fixed] = ACTIONS(3682),
    [anon_sym_internal] = ACTIONS(3682),
    [anon_sym_new] = ACTIONS(3682),
    [anon_sym_override] = ACTIONS(3682),
    [anon_sym_partial] = ACTIONS(3682),
    [anon_sym_private] = ACTIONS(3682),
    [anon_sym_protected] = ACTIONS(3682),
    [anon_sym_public] = ACTIONS(3682),
    [anon_sym_readonly] = ACTIONS(3682),
    [anon_sym_ref] = ACTIONS(3682),
    [anon_sym_sealed] = ACTIONS(3682),
    [anon_sym_unsafe] = ACTIONS(3682),
    [anon_sym_virtual] = ACTIONS(3682),
    [anon_sym_volatile] = ACTIONS(3682),
    [anon_sym_RBRACE] = ACTIONS(3686),
    [anon_sym_implicit] = ACTIONS(3682),
    [anon_sym_explicit] = ACTIONS(3682),
    [anon_sym_TILDE] = ACTIONS(3686),
    [anon_sym_where] = ACTIONS(3682),
    [anon_sym_class] = ACTIONS(3682),
    [anon_sym_struct] = ACTIONS(3682),
    [anon_sym_notnull] = ACTIONS(3682),
    [anon_sym_unmanaged] = ACTIONS(3682),
    [anon_sym_get] = ACTIONS(3682),
    [anon_sym_set] = ACTIONS(3682),
    [anon_sym_add] = ACTIONS(3682),
    [anon_sym_remove] = ACTIONS(3682),
    [anon_sym_enum] = ACTIONS(3682),
    [anon_sym_interface] = ACTIONS(3682),
    [anon_sym_delegate] = ACTIONS(3682),
    [anon_sym_record] = ACTIONS(3682),
    [anon_sym_namespace] = ACTIONS(3682),
    [anon_sym_var] = ACTIONS(3682),
    [sym_predefined_type] = ACTIONS(3682),
    [anon_sym_when] = ACTIONS(3682),
    [anon_sym_yield] = ACTIONS(3682),
    [anon_sym_from] = ACTIONS(3682),
    [anon_sym_join] = ACTIONS(3682),
    [anon_sym_on] = ACTIONS(3682),
    [anon_sym_equals] = ACTIONS(3682),
    [anon_sym_into] = ACTIONS(3682),
    [anon_sym_let] = ACTIONS(3682),
    [anon_sym_orderby] = ACTIONS(3682),
    [anon_sym_ascending] = ACTIONS(3682),
    [anon_sym_descending] = ACTIONS(3682),
    [anon_sym_group] = ACTIONS(3682),
    [anon_sym_by] = ACTIONS(3682),
    [anon_sym_select] = ACTIONS(3682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3682),
    [anon_sym_nameof] = ACTIONS(3682),
    [sym_void_keyword] = ACTIONS(3682),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2239] = {
    [sym__preprocessor_call] = STATE(2239),
    [sym__identifier_token] = ACTIONS(3688),
    [anon_sym_extern] = ACTIONS(3688),
    [anon_sym_alias] = ACTIONS(3688),
    [anon_sym_SEMI] = ACTIONS(3690),
    [anon_sym_global] = ACTIONS(3688),
    [anon_sym_using] = ACTIONS(3688),
    [anon_sym_static] = ACTIONS(3688),
    [anon_sym_LBRACK] = ACTIONS(3692),
    [anon_sym_event] = ACTIONS(3688),
    [anon_sym_LPAREN] = ACTIONS(3692),
    [anon_sym_abstract] = ACTIONS(3688),
    [anon_sym_async] = ACTIONS(3688),
    [anon_sym_const] = ACTIONS(3688),
    [anon_sym_fixed] = ACTIONS(3688),
    [anon_sym_internal] = ACTIONS(3688),
    [anon_sym_new] = ACTIONS(3688),
    [anon_sym_override] = ACTIONS(3688),
    [anon_sym_partial] = ACTIONS(3688),
    [anon_sym_private] = ACTIONS(3688),
    [anon_sym_protected] = ACTIONS(3688),
    [anon_sym_public] = ACTIONS(3688),
    [anon_sym_readonly] = ACTIONS(3688),
    [anon_sym_ref] = ACTIONS(3688),
    [anon_sym_sealed] = ACTIONS(3688),
    [anon_sym_unsafe] = ACTIONS(3688),
    [anon_sym_virtual] = ACTIONS(3688),
    [anon_sym_volatile] = ACTIONS(3688),
    [anon_sym_RBRACE] = ACTIONS(3692),
    [anon_sym_implicit] = ACTIONS(3688),
    [anon_sym_explicit] = ACTIONS(3688),
    [anon_sym_TILDE] = ACTIONS(3692),
    [anon_sym_where] = ACTIONS(3688),
    [anon_sym_class] = ACTIONS(3688),
    [anon_sym_struct] = ACTIONS(3688),
    [anon_sym_notnull] = ACTIONS(3688),
    [anon_sym_unmanaged] = ACTIONS(3688),
    [anon_sym_get] = ACTIONS(3688),
    [anon_sym_set] = ACTIONS(3688),
    [anon_sym_add] = ACTIONS(3688),
    [anon_sym_remove] = ACTIONS(3688),
    [anon_sym_enum] = ACTIONS(3688),
    [anon_sym_interface] = ACTIONS(3688),
    [anon_sym_delegate] = ACTIONS(3688),
    [anon_sym_record] = ACTIONS(3688),
    [anon_sym_namespace] = ACTIONS(3688),
    [anon_sym_var] = ACTIONS(3688),
    [sym_predefined_type] = ACTIONS(3688),
    [anon_sym_when] = ACTIONS(3688),
    [anon_sym_yield] = ACTIONS(3688),
    [anon_sym_from] = ACTIONS(3688),
    [anon_sym_join] = ACTIONS(3688),
    [anon_sym_on] = ACTIONS(3688),
    [anon_sym_equals] = ACTIONS(3688),
    [anon_sym_into] = ACTIONS(3688),
    [anon_sym_let] = ACTIONS(3688),
    [anon_sym_orderby] = ACTIONS(3688),
    [anon_sym_ascending] = ACTIONS(3688),
    [anon_sym_descending] = ACTIONS(3688),
    [anon_sym_group] = ACTIONS(3688),
    [anon_sym_by] = ACTIONS(3688),
    [anon_sym_select] = ACTIONS(3688),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3688),
    [anon_sym_nameof] = ACTIONS(3688),
    [sym_void_keyword] = ACTIONS(3688),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2240] = {
    [sym__preprocessor_call] = STATE(2240),
    [sym__identifier_token] = ACTIONS(3694),
    [anon_sym_extern] = ACTIONS(3694),
    [anon_sym_alias] = ACTIONS(3694),
    [anon_sym_SEMI] = ACTIONS(3696),
    [anon_sym_global] = ACTIONS(3694),
    [anon_sym_using] = ACTIONS(3694),
    [anon_sym_static] = ACTIONS(3694),
    [anon_sym_LBRACK] = ACTIONS(3698),
    [anon_sym_event] = ACTIONS(3694),
    [anon_sym_LPAREN] = ACTIONS(3698),
    [anon_sym_abstract] = ACTIONS(3694),
    [anon_sym_async] = ACTIONS(3694),
    [anon_sym_const] = ACTIONS(3694),
    [anon_sym_fixed] = ACTIONS(3694),
    [anon_sym_internal] = ACTIONS(3694),
    [anon_sym_new] = ACTIONS(3694),
    [anon_sym_override] = ACTIONS(3694),
    [anon_sym_partial] = ACTIONS(3694),
    [anon_sym_private] = ACTIONS(3694),
    [anon_sym_protected] = ACTIONS(3694),
    [anon_sym_public] = ACTIONS(3694),
    [anon_sym_readonly] = ACTIONS(3694),
    [anon_sym_ref] = ACTIONS(3694),
    [anon_sym_sealed] = ACTIONS(3694),
    [anon_sym_unsafe] = ACTIONS(3694),
    [anon_sym_virtual] = ACTIONS(3694),
    [anon_sym_volatile] = ACTIONS(3694),
    [anon_sym_RBRACE] = ACTIONS(3698),
    [anon_sym_implicit] = ACTIONS(3694),
    [anon_sym_explicit] = ACTIONS(3694),
    [anon_sym_TILDE] = ACTIONS(3698),
    [anon_sym_where] = ACTIONS(3694),
    [anon_sym_class] = ACTIONS(3694),
    [anon_sym_struct] = ACTIONS(3694),
    [anon_sym_notnull] = ACTIONS(3694),
    [anon_sym_unmanaged] = ACTIONS(3694),
    [anon_sym_get] = ACTIONS(3694),
    [anon_sym_set] = ACTIONS(3694),
    [anon_sym_add] = ACTIONS(3694),
    [anon_sym_remove] = ACTIONS(3694),
    [anon_sym_enum] = ACTIONS(3694),
    [anon_sym_interface] = ACTIONS(3694),
    [anon_sym_delegate] = ACTIONS(3694),
    [anon_sym_record] = ACTIONS(3694),
    [anon_sym_namespace] = ACTIONS(3694),
    [anon_sym_var] = ACTIONS(3694),
    [sym_predefined_type] = ACTIONS(3694),
    [anon_sym_when] = ACTIONS(3694),
    [anon_sym_yield] = ACTIONS(3694),
    [anon_sym_from] = ACTIONS(3694),
    [anon_sym_join] = ACTIONS(3694),
    [anon_sym_on] = ACTIONS(3694),
    [anon_sym_equals] = ACTIONS(3694),
    [anon_sym_into] = ACTIONS(3694),
    [anon_sym_let] = ACTIONS(3694),
    [anon_sym_orderby] = ACTIONS(3694),
    [anon_sym_ascending] = ACTIONS(3694),
    [anon_sym_descending] = ACTIONS(3694),
    [anon_sym_group] = ACTIONS(3694),
    [anon_sym_by] = ACTIONS(3694),
    [anon_sym_select] = ACTIONS(3694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3694),
    [anon_sym_nameof] = ACTIONS(3694),
    [sym_void_keyword] = ACTIONS(3694),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2241] = {
    [sym__preprocessor_call] = STATE(2241),
    [sym__identifier_token] = ACTIONS(3700),
    [anon_sym_extern] = ACTIONS(3700),
    [anon_sym_alias] = ACTIONS(3700),
    [anon_sym_SEMI] = ACTIONS(3702),
    [anon_sym_global] = ACTIONS(3700),
    [anon_sym_using] = ACTIONS(3700),
    [anon_sym_static] = ACTIONS(3700),
    [anon_sym_LBRACK] = ACTIONS(3704),
    [anon_sym_event] = ACTIONS(3700),
    [anon_sym_LPAREN] = ACTIONS(3704),
    [anon_sym_abstract] = ACTIONS(3700),
    [anon_sym_async] = ACTIONS(3700),
    [anon_sym_const] = ACTIONS(3700),
    [anon_sym_fixed] = ACTIONS(3700),
    [anon_sym_internal] = ACTIONS(3700),
    [anon_sym_new] = ACTIONS(3700),
    [anon_sym_override] = ACTIONS(3700),
    [anon_sym_partial] = ACTIONS(3700),
    [anon_sym_private] = ACTIONS(3700),
    [anon_sym_protected] = ACTIONS(3700),
    [anon_sym_public] = ACTIONS(3700),
    [anon_sym_readonly] = ACTIONS(3700),
    [anon_sym_ref] = ACTIONS(3700),
    [anon_sym_sealed] = ACTIONS(3700),
    [anon_sym_unsafe] = ACTIONS(3700),
    [anon_sym_virtual] = ACTIONS(3700),
    [anon_sym_volatile] = ACTIONS(3700),
    [anon_sym_RBRACE] = ACTIONS(3704),
    [anon_sym_implicit] = ACTIONS(3700),
    [anon_sym_explicit] = ACTIONS(3700),
    [anon_sym_TILDE] = ACTIONS(3704),
    [anon_sym_where] = ACTIONS(3700),
    [anon_sym_class] = ACTIONS(3700),
    [anon_sym_struct] = ACTIONS(3700),
    [anon_sym_notnull] = ACTIONS(3700),
    [anon_sym_unmanaged] = ACTIONS(3700),
    [anon_sym_get] = ACTIONS(3700),
    [anon_sym_set] = ACTIONS(3700),
    [anon_sym_add] = ACTIONS(3700),
    [anon_sym_remove] = ACTIONS(3700),
    [anon_sym_enum] = ACTIONS(3700),
    [anon_sym_interface] = ACTIONS(3700),
    [anon_sym_delegate] = ACTIONS(3700),
    [anon_sym_record] = ACTIONS(3700),
    [anon_sym_namespace] = ACTIONS(3700),
    [anon_sym_var] = ACTIONS(3700),
    [sym_predefined_type] = ACTIONS(3700),
    [anon_sym_when] = ACTIONS(3700),
    [anon_sym_yield] = ACTIONS(3700),
    [anon_sym_from] = ACTIONS(3700),
    [anon_sym_join] = ACTIONS(3700),
    [anon_sym_on] = ACTIONS(3700),
    [anon_sym_equals] = ACTIONS(3700),
    [anon_sym_into] = ACTIONS(3700),
    [anon_sym_let] = ACTIONS(3700),
    [anon_sym_orderby] = ACTIONS(3700),
    [anon_sym_ascending] = ACTIONS(3700),
    [anon_sym_descending] = ACTIONS(3700),
    [anon_sym_group] = ACTIONS(3700),
    [anon_sym_by] = ACTIONS(3700),
    [anon_sym_select] = ACTIONS(3700),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3700),
    [anon_sym_nameof] = ACTIONS(3700),
    [sym_void_keyword] = ACTIONS(3700),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2242] = {
    [sym__preprocessor_call] = STATE(2242),
    [sym__identifier_token] = ACTIONS(3706),
    [anon_sym_extern] = ACTIONS(3706),
    [anon_sym_alias] = ACTIONS(3706),
    [anon_sym_SEMI] = ACTIONS(3708),
    [anon_sym_global] = ACTIONS(3706),
    [anon_sym_using] = ACTIONS(3706),
    [anon_sym_static] = ACTIONS(3706),
    [anon_sym_LBRACK] = ACTIONS(3710),
    [anon_sym_event] = ACTIONS(3706),
    [anon_sym_LPAREN] = ACTIONS(3710),
    [anon_sym_abstract] = ACTIONS(3706),
    [anon_sym_async] = ACTIONS(3706),
    [anon_sym_const] = ACTIONS(3706),
    [anon_sym_fixed] = ACTIONS(3706),
    [anon_sym_internal] = ACTIONS(3706),
    [anon_sym_new] = ACTIONS(3706),
    [anon_sym_override] = ACTIONS(3706),
    [anon_sym_partial] = ACTIONS(3706),
    [anon_sym_private] = ACTIONS(3706),
    [anon_sym_protected] = ACTIONS(3706),
    [anon_sym_public] = ACTIONS(3706),
    [anon_sym_readonly] = ACTIONS(3706),
    [anon_sym_ref] = ACTIONS(3706),
    [anon_sym_sealed] = ACTIONS(3706),
    [anon_sym_unsafe] = ACTIONS(3706),
    [anon_sym_virtual] = ACTIONS(3706),
    [anon_sym_volatile] = ACTIONS(3706),
    [anon_sym_RBRACE] = ACTIONS(3710),
    [anon_sym_implicit] = ACTIONS(3706),
    [anon_sym_explicit] = ACTIONS(3706),
    [anon_sym_TILDE] = ACTIONS(3710),
    [anon_sym_where] = ACTIONS(3706),
    [anon_sym_class] = ACTIONS(3706),
    [anon_sym_struct] = ACTIONS(3706),
    [anon_sym_notnull] = ACTIONS(3706),
    [anon_sym_unmanaged] = ACTIONS(3706),
    [anon_sym_get] = ACTIONS(3706),
    [anon_sym_set] = ACTIONS(3706),
    [anon_sym_add] = ACTIONS(3706),
    [anon_sym_remove] = ACTIONS(3706),
    [anon_sym_enum] = ACTIONS(3706),
    [anon_sym_interface] = ACTIONS(3706),
    [anon_sym_delegate] = ACTIONS(3706),
    [anon_sym_record] = ACTIONS(3706),
    [anon_sym_namespace] = ACTIONS(3706),
    [anon_sym_var] = ACTIONS(3706),
    [sym_predefined_type] = ACTIONS(3706),
    [anon_sym_when] = ACTIONS(3706),
    [anon_sym_yield] = ACTIONS(3706),
    [anon_sym_from] = ACTIONS(3706),
    [anon_sym_join] = ACTIONS(3706),
    [anon_sym_on] = ACTIONS(3706),
    [anon_sym_equals] = ACTIONS(3706),
    [anon_sym_into] = ACTIONS(3706),
    [anon_sym_let] = ACTIONS(3706),
    [anon_sym_orderby] = ACTIONS(3706),
    [anon_sym_ascending] = ACTIONS(3706),
    [anon_sym_descending] = ACTIONS(3706),
    [anon_sym_group] = ACTIONS(3706),
    [anon_sym_by] = ACTIONS(3706),
    [anon_sym_select] = ACTIONS(3706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3706),
    [anon_sym_nameof] = ACTIONS(3706),
    [sym_void_keyword] = ACTIONS(3706),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2243] = {
    [sym__preprocessor_call] = STATE(2243),
    [sym__identifier_token] = ACTIONS(3712),
    [anon_sym_extern] = ACTIONS(3712),
    [anon_sym_alias] = ACTIONS(3712),
    [anon_sym_SEMI] = ACTIONS(3714),
    [anon_sym_global] = ACTIONS(3712),
    [anon_sym_using] = ACTIONS(3712),
    [anon_sym_static] = ACTIONS(3712),
    [anon_sym_LBRACK] = ACTIONS(3716),
    [anon_sym_event] = ACTIONS(3712),
    [anon_sym_LPAREN] = ACTIONS(3716),
    [anon_sym_abstract] = ACTIONS(3712),
    [anon_sym_async] = ACTIONS(3712),
    [anon_sym_const] = ACTIONS(3712),
    [anon_sym_fixed] = ACTIONS(3712),
    [anon_sym_internal] = ACTIONS(3712),
    [anon_sym_new] = ACTIONS(3712),
    [anon_sym_override] = ACTIONS(3712),
    [anon_sym_partial] = ACTIONS(3712),
    [anon_sym_private] = ACTIONS(3712),
    [anon_sym_protected] = ACTIONS(3712),
    [anon_sym_public] = ACTIONS(3712),
    [anon_sym_readonly] = ACTIONS(3712),
    [anon_sym_ref] = ACTIONS(3712),
    [anon_sym_sealed] = ACTIONS(3712),
    [anon_sym_unsafe] = ACTIONS(3712),
    [anon_sym_virtual] = ACTIONS(3712),
    [anon_sym_volatile] = ACTIONS(3712),
    [anon_sym_RBRACE] = ACTIONS(3716),
    [anon_sym_implicit] = ACTIONS(3712),
    [anon_sym_explicit] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3716),
    [anon_sym_where] = ACTIONS(3712),
    [anon_sym_class] = ACTIONS(3712),
    [anon_sym_struct] = ACTIONS(3712),
    [anon_sym_notnull] = ACTIONS(3712),
    [anon_sym_unmanaged] = ACTIONS(3712),
    [anon_sym_get] = ACTIONS(3712),
    [anon_sym_set] = ACTIONS(3712),
    [anon_sym_add] = ACTIONS(3712),
    [anon_sym_remove] = ACTIONS(3712),
    [anon_sym_enum] = ACTIONS(3712),
    [anon_sym_interface] = ACTIONS(3712),
    [anon_sym_delegate] = ACTIONS(3712),
    [anon_sym_record] = ACTIONS(3712),
    [anon_sym_namespace] = ACTIONS(3712),
    [anon_sym_var] = ACTIONS(3712),
    [sym_predefined_type] = ACTIONS(3712),
    [anon_sym_when] = ACTIONS(3712),
    [anon_sym_yield] = ACTIONS(3712),
    [anon_sym_from] = ACTIONS(3712),
    [anon_sym_join] = ACTIONS(3712),
    [anon_sym_on] = ACTIONS(3712),
    [anon_sym_equals] = ACTIONS(3712),
    [anon_sym_into] = ACTIONS(3712),
    [anon_sym_let] = ACTIONS(3712),
    [anon_sym_orderby] = ACTIONS(3712),
    [anon_sym_ascending] = ACTIONS(3712),
    [anon_sym_descending] = ACTIONS(3712),
    [anon_sym_group] = ACTIONS(3712),
    [anon_sym_by] = ACTIONS(3712),
    [anon_sym_select] = ACTIONS(3712),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3712),
    [anon_sym_nameof] = ACTIONS(3712),
    [sym_void_keyword] = ACTIONS(3712),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2244] = {
    [sym__preprocessor_call] = STATE(2244),
    [sym__identifier_token] = ACTIONS(3718),
    [anon_sym_extern] = ACTIONS(3718),
    [anon_sym_alias] = ACTIONS(3718),
    [anon_sym_SEMI] = ACTIONS(3720),
    [anon_sym_global] = ACTIONS(3718),
    [anon_sym_using] = ACTIONS(3718),
    [anon_sym_static] = ACTIONS(3718),
    [anon_sym_LBRACK] = ACTIONS(3720),
    [anon_sym_event] = ACTIONS(3718),
    [anon_sym_LPAREN] = ACTIONS(3720),
    [anon_sym_abstract] = ACTIONS(3718),
    [anon_sym_async] = ACTIONS(3718),
    [anon_sym_const] = ACTIONS(3718),
    [anon_sym_fixed] = ACTIONS(3718),
    [anon_sym_internal] = ACTIONS(3718),
    [anon_sym_new] = ACTIONS(3718),
    [anon_sym_override] = ACTIONS(3718),
    [anon_sym_partial] = ACTIONS(3718),
    [anon_sym_private] = ACTIONS(3718),
    [anon_sym_protected] = ACTIONS(3718),
    [anon_sym_public] = ACTIONS(3718),
    [anon_sym_readonly] = ACTIONS(3718),
    [anon_sym_ref] = ACTIONS(3718),
    [anon_sym_sealed] = ACTIONS(3718),
    [anon_sym_unsafe] = ACTIONS(3718),
    [anon_sym_virtual] = ACTIONS(3718),
    [anon_sym_volatile] = ACTIONS(3718),
    [anon_sym_RBRACE] = ACTIONS(3720),
    [anon_sym_implicit] = ACTIONS(3718),
    [anon_sym_explicit] = ACTIONS(3718),
    [anon_sym_TILDE] = ACTIONS(3720),
    [anon_sym_where] = ACTIONS(3718),
    [anon_sym_class] = ACTIONS(3718),
    [anon_sym_struct] = ACTIONS(3718),
    [anon_sym_notnull] = ACTIONS(3718),
    [anon_sym_unmanaged] = ACTIONS(3718),
    [anon_sym_get] = ACTIONS(3718),
    [anon_sym_set] = ACTIONS(3718),
    [anon_sym_add] = ACTIONS(3718),
    [anon_sym_remove] = ACTIONS(3718),
    [anon_sym_enum] = ACTIONS(3718),
    [anon_sym_interface] = ACTIONS(3718),
    [anon_sym_delegate] = ACTIONS(3718),
    [anon_sym_record] = ACTIONS(3718),
    [anon_sym_namespace] = ACTIONS(3718),
    [anon_sym_var] = ACTIONS(3718),
    [sym_predefined_type] = ACTIONS(3718),
    [anon_sym_when] = ACTIONS(3718),
    [anon_sym_yield] = ACTIONS(3718),
    [anon_sym_from] = ACTIONS(3718),
    [anon_sym_join] = ACTIONS(3718),
    [anon_sym_on] = ACTIONS(3718),
    [anon_sym_equals] = ACTIONS(3718),
    [anon_sym_into] = ACTIONS(3718),
    [anon_sym_let] = ACTIONS(3718),
    [anon_sym_orderby] = ACTIONS(3718),
    [anon_sym_ascending] = ACTIONS(3718),
    [anon_sym_descending] = ACTIONS(3718),
    [anon_sym_group] = ACTIONS(3718),
    [anon_sym_by] = ACTIONS(3718),
    [anon_sym_select] = ACTIONS(3718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3718),
    [anon_sym_nameof] = ACTIONS(3718),
    [sym_void_keyword] = ACTIONS(3718),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2245] = {
    [sym__preprocessor_call] = STATE(2245),
    [sym__identifier_token] = ACTIONS(3722),
    [anon_sym_extern] = ACTIONS(3722),
    [anon_sym_alias] = ACTIONS(3722),
    [anon_sym_SEMI] = ACTIONS(3724),
    [anon_sym_global] = ACTIONS(3722),
    [anon_sym_using] = ACTIONS(3722),
    [anon_sym_static] = ACTIONS(3722),
    [anon_sym_LBRACK] = ACTIONS(3726),
    [anon_sym_event] = ACTIONS(3722),
    [anon_sym_LPAREN] = ACTIONS(3726),
    [anon_sym_abstract] = ACTIONS(3722),
    [anon_sym_async] = ACTIONS(3722),
    [anon_sym_const] = ACTIONS(3722),
    [anon_sym_fixed] = ACTIONS(3722),
    [anon_sym_internal] = ACTIONS(3722),
    [anon_sym_new] = ACTIONS(3722),
    [anon_sym_override] = ACTIONS(3722),
    [anon_sym_partial] = ACTIONS(3722),
    [anon_sym_private] = ACTIONS(3722),
    [anon_sym_protected] = ACTIONS(3722),
    [anon_sym_public] = ACTIONS(3722),
    [anon_sym_readonly] = ACTIONS(3722),
    [anon_sym_ref] = ACTIONS(3722),
    [anon_sym_sealed] = ACTIONS(3722),
    [anon_sym_unsafe] = ACTIONS(3722),
    [anon_sym_virtual] = ACTIONS(3722),
    [anon_sym_volatile] = ACTIONS(3722),
    [anon_sym_RBRACE] = ACTIONS(3726),
    [anon_sym_implicit] = ACTIONS(3722),
    [anon_sym_explicit] = ACTIONS(3722),
    [anon_sym_TILDE] = ACTIONS(3726),
    [anon_sym_where] = ACTIONS(3722),
    [anon_sym_class] = ACTIONS(3722),
    [anon_sym_struct] = ACTIONS(3722),
    [anon_sym_notnull] = ACTIONS(3722),
    [anon_sym_unmanaged] = ACTIONS(3722),
    [anon_sym_get] = ACTIONS(3722),
    [anon_sym_set] = ACTIONS(3722),
    [anon_sym_add] = ACTIONS(3722),
    [anon_sym_remove] = ACTIONS(3722),
    [anon_sym_enum] = ACTIONS(3722),
    [anon_sym_interface] = ACTIONS(3722),
    [anon_sym_delegate] = ACTIONS(3722),
    [anon_sym_record] = ACTIONS(3722),
    [anon_sym_namespace] = ACTIONS(3722),
    [anon_sym_var] = ACTIONS(3722),
    [sym_predefined_type] = ACTIONS(3722),
    [anon_sym_when] = ACTIONS(3722),
    [anon_sym_yield] = ACTIONS(3722),
    [anon_sym_from] = ACTIONS(3722),
    [anon_sym_join] = ACTIONS(3722),
    [anon_sym_on] = ACTIONS(3722),
    [anon_sym_equals] = ACTIONS(3722),
    [anon_sym_into] = ACTIONS(3722),
    [anon_sym_let] = ACTIONS(3722),
    [anon_sym_orderby] = ACTIONS(3722),
    [anon_sym_ascending] = ACTIONS(3722),
    [anon_sym_descending] = ACTIONS(3722),
    [anon_sym_group] = ACTIONS(3722),
    [anon_sym_by] = ACTIONS(3722),
    [anon_sym_select] = ACTIONS(3722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3722),
    [anon_sym_nameof] = ACTIONS(3722),
    [sym_void_keyword] = ACTIONS(3722),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2246] = {
    [sym__preprocessor_call] = STATE(2246),
    [sym__identifier_token] = ACTIONS(3728),
    [anon_sym_extern] = ACTIONS(3728),
    [anon_sym_alias] = ACTIONS(3728),
    [anon_sym_SEMI] = ACTIONS(3730),
    [anon_sym_global] = ACTIONS(3728),
    [anon_sym_using] = ACTIONS(3728),
    [anon_sym_static] = ACTIONS(3728),
    [anon_sym_LBRACK] = ACTIONS(3732),
    [anon_sym_event] = ACTIONS(3728),
    [anon_sym_LPAREN] = ACTIONS(3732),
    [anon_sym_abstract] = ACTIONS(3728),
    [anon_sym_async] = ACTIONS(3728),
    [anon_sym_const] = ACTIONS(3728),
    [anon_sym_fixed] = ACTIONS(3728),
    [anon_sym_internal] = ACTIONS(3728),
    [anon_sym_new] = ACTIONS(3728),
    [anon_sym_override] = ACTIONS(3728),
    [anon_sym_partial] = ACTIONS(3728),
    [anon_sym_private] = ACTIONS(3728),
    [anon_sym_protected] = ACTIONS(3728),
    [anon_sym_public] = ACTIONS(3728),
    [anon_sym_readonly] = ACTIONS(3728),
    [anon_sym_ref] = ACTIONS(3728),
    [anon_sym_sealed] = ACTIONS(3728),
    [anon_sym_unsafe] = ACTIONS(3728),
    [anon_sym_virtual] = ACTIONS(3728),
    [anon_sym_volatile] = ACTIONS(3728),
    [anon_sym_RBRACE] = ACTIONS(3732),
    [anon_sym_implicit] = ACTIONS(3728),
    [anon_sym_explicit] = ACTIONS(3728),
    [anon_sym_TILDE] = ACTIONS(3732),
    [anon_sym_where] = ACTIONS(3728),
    [anon_sym_class] = ACTIONS(3728),
    [anon_sym_struct] = ACTIONS(3728),
    [anon_sym_notnull] = ACTIONS(3728),
    [anon_sym_unmanaged] = ACTIONS(3728),
    [anon_sym_get] = ACTIONS(3728),
    [anon_sym_set] = ACTIONS(3728),
    [anon_sym_add] = ACTIONS(3728),
    [anon_sym_remove] = ACTIONS(3728),
    [anon_sym_enum] = ACTIONS(3728),
    [anon_sym_interface] = ACTIONS(3728),
    [anon_sym_delegate] = ACTIONS(3728),
    [anon_sym_record] = ACTIONS(3728),
    [anon_sym_namespace] = ACTIONS(3728),
    [anon_sym_var] = ACTIONS(3728),
    [sym_predefined_type] = ACTIONS(3728),
    [anon_sym_when] = ACTIONS(3728),
    [anon_sym_yield] = ACTIONS(3728),
    [anon_sym_from] = ACTIONS(3728),
    [anon_sym_join] = ACTIONS(3728),
    [anon_sym_on] = ACTIONS(3728),
    [anon_sym_equals] = ACTIONS(3728),
    [anon_sym_into] = ACTIONS(3728),
    [anon_sym_let] = ACTIONS(3728),
    [anon_sym_orderby] = ACTIONS(3728),
    [anon_sym_ascending] = ACTIONS(3728),
    [anon_sym_descending] = ACTIONS(3728),
    [anon_sym_group] = ACTIONS(3728),
    [anon_sym_by] = ACTIONS(3728),
    [anon_sym_select] = ACTIONS(3728),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3728),
    [anon_sym_nameof] = ACTIONS(3728),
    [sym_void_keyword] = ACTIONS(3728),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2247] = {
    [sym__preprocessor_call] = STATE(2247),
    [sym__identifier_token] = ACTIONS(3734),
    [anon_sym_extern] = ACTIONS(3734),
    [anon_sym_alias] = ACTIONS(3734),
    [anon_sym_SEMI] = ACTIONS(3736),
    [anon_sym_global] = ACTIONS(3734),
    [anon_sym_using] = ACTIONS(3734),
    [anon_sym_static] = ACTIONS(3734),
    [anon_sym_LBRACK] = ACTIONS(3738),
    [anon_sym_event] = ACTIONS(3734),
    [anon_sym_LPAREN] = ACTIONS(3738),
    [anon_sym_abstract] = ACTIONS(3734),
    [anon_sym_async] = ACTIONS(3734),
    [anon_sym_const] = ACTIONS(3734),
    [anon_sym_fixed] = ACTIONS(3734),
    [anon_sym_internal] = ACTIONS(3734),
    [anon_sym_new] = ACTIONS(3734),
    [anon_sym_override] = ACTIONS(3734),
    [anon_sym_partial] = ACTIONS(3734),
    [anon_sym_private] = ACTIONS(3734),
    [anon_sym_protected] = ACTIONS(3734),
    [anon_sym_public] = ACTIONS(3734),
    [anon_sym_readonly] = ACTIONS(3734),
    [anon_sym_ref] = ACTIONS(3734),
    [anon_sym_sealed] = ACTIONS(3734),
    [anon_sym_unsafe] = ACTIONS(3734),
    [anon_sym_virtual] = ACTIONS(3734),
    [anon_sym_volatile] = ACTIONS(3734),
    [anon_sym_RBRACE] = ACTIONS(3738),
    [anon_sym_implicit] = ACTIONS(3734),
    [anon_sym_explicit] = ACTIONS(3734),
    [anon_sym_TILDE] = ACTIONS(3738),
    [anon_sym_where] = ACTIONS(3734),
    [anon_sym_class] = ACTIONS(3734),
    [anon_sym_struct] = ACTIONS(3734),
    [anon_sym_notnull] = ACTIONS(3734),
    [anon_sym_unmanaged] = ACTIONS(3734),
    [anon_sym_get] = ACTIONS(3734),
    [anon_sym_set] = ACTIONS(3734),
    [anon_sym_add] = ACTIONS(3734),
    [anon_sym_remove] = ACTIONS(3734),
    [anon_sym_enum] = ACTIONS(3734),
    [anon_sym_interface] = ACTIONS(3734),
    [anon_sym_delegate] = ACTIONS(3734),
    [anon_sym_record] = ACTIONS(3734),
    [anon_sym_namespace] = ACTIONS(3734),
    [anon_sym_var] = ACTIONS(3734),
    [sym_predefined_type] = ACTIONS(3734),
    [anon_sym_when] = ACTIONS(3734),
    [anon_sym_yield] = ACTIONS(3734),
    [anon_sym_from] = ACTIONS(3734),
    [anon_sym_join] = ACTIONS(3734),
    [anon_sym_on] = ACTIONS(3734),
    [anon_sym_equals] = ACTIONS(3734),
    [anon_sym_into] = ACTIONS(3734),
    [anon_sym_let] = ACTIONS(3734),
    [anon_sym_orderby] = ACTIONS(3734),
    [anon_sym_ascending] = ACTIONS(3734),
    [anon_sym_descending] = ACTIONS(3734),
    [anon_sym_group] = ACTIONS(3734),
    [anon_sym_by] = ACTIONS(3734),
    [anon_sym_select] = ACTIONS(3734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3734),
    [anon_sym_nameof] = ACTIONS(3734),
    [sym_void_keyword] = ACTIONS(3734),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2248] = {
    [sym__preprocessor_call] = STATE(2248),
    [sym__identifier_token] = ACTIONS(3740),
    [anon_sym_extern] = ACTIONS(3740),
    [anon_sym_alias] = ACTIONS(3740),
    [anon_sym_SEMI] = ACTIONS(3742),
    [anon_sym_global] = ACTIONS(3740),
    [anon_sym_using] = ACTIONS(3740),
    [anon_sym_static] = ACTIONS(3740),
    [anon_sym_LBRACK] = ACTIONS(3744),
    [anon_sym_event] = ACTIONS(3740),
    [anon_sym_LPAREN] = ACTIONS(3744),
    [anon_sym_abstract] = ACTIONS(3740),
    [anon_sym_async] = ACTIONS(3740),
    [anon_sym_const] = ACTIONS(3740),
    [anon_sym_fixed] = ACTIONS(3740),
    [anon_sym_internal] = ACTIONS(3740),
    [anon_sym_new] = ACTIONS(3740),
    [anon_sym_override] = ACTIONS(3740),
    [anon_sym_partial] = ACTIONS(3740),
    [anon_sym_private] = ACTIONS(3740),
    [anon_sym_protected] = ACTIONS(3740),
    [anon_sym_public] = ACTIONS(3740),
    [anon_sym_readonly] = ACTIONS(3740),
    [anon_sym_ref] = ACTIONS(3740),
    [anon_sym_sealed] = ACTIONS(3740),
    [anon_sym_unsafe] = ACTIONS(3740),
    [anon_sym_virtual] = ACTIONS(3740),
    [anon_sym_volatile] = ACTIONS(3740),
    [anon_sym_RBRACE] = ACTIONS(3744),
    [anon_sym_implicit] = ACTIONS(3740),
    [anon_sym_explicit] = ACTIONS(3740),
    [anon_sym_TILDE] = ACTIONS(3744),
    [anon_sym_where] = ACTIONS(3740),
    [anon_sym_class] = ACTIONS(3740),
    [anon_sym_struct] = ACTIONS(3740),
    [anon_sym_notnull] = ACTIONS(3740),
    [anon_sym_unmanaged] = ACTIONS(3740),
    [anon_sym_get] = ACTIONS(3740),
    [anon_sym_set] = ACTIONS(3740),
    [anon_sym_add] = ACTIONS(3740),
    [anon_sym_remove] = ACTIONS(3740),
    [anon_sym_enum] = ACTIONS(3740),
    [anon_sym_interface] = ACTIONS(3740),
    [anon_sym_delegate] = ACTIONS(3740),
    [anon_sym_record] = ACTIONS(3740),
    [anon_sym_namespace] = ACTIONS(3740),
    [anon_sym_var] = ACTIONS(3740),
    [sym_predefined_type] = ACTIONS(3740),
    [anon_sym_when] = ACTIONS(3740),
    [anon_sym_yield] = ACTIONS(3740),
    [anon_sym_from] = ACTIONS(3740),
    [anon_sym_join] = ACTIONS(3740),
    [anon_sym_on] = ACTIONS(3740),
    [anon_sym_equals] = ACTIONS(3740),
    [anon_sym_into] = ACTIONS(3740),
    [anon_sym_let] = ACTIONS(3740),
    [anon_sym_orderby] = ACTIONS(3740),
    [anon_sym_ascending] = ACTIONS(3740),
    [anon_sym_descending] = ACTIONS(3740),
    [anon_sym_group] = ACTIONS(3740),
    [anon_sym_by] = ACTIONS(3740),
    [anon_sym_select] = ACTIONS(3740),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3740),
    [anon_sym_nameof] = ACTIONS(3740),
    [sym_void_keyword] = ACTIONS(3740),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2249] = {
    [sym__preprocessor_call] = STATE(2249),
    [sym__identifier_token] = ACTIONS(3746),
    [anon_sym_extern] = ACTIONS(3746),
    [anon_sym_alias] = ACTIONS(3746),
    [anon_sym_SEMI] = ACTIONS(3748),
    [anon_sym_global] = ACTIONS(3746),
    [anon_sym_using] = ACTIONS(3746),
    [anon_sym_static] = ACTIONS(3746),
    [anon_sym_LBRACK] = ACTIONS(3750),
    [anon_sym_event] = ACTIONS(3746),
    [anon_sym_LPAREN] = ACTIONS(3750),
    [anon_sym_abstract] = ACTIONS(3746),
    [anon_sym_async] = ACTIONS(3746),
    [anon_sym_const] = ACTIONS(3746),
    [anon_sym_fixed] = ACTIONS(3746),
    [anon_sym_internal] = ACTIONS(3746),
    [anon_sym_new] = ACTIONS(3746),
    [anon_sym_override] = ACTIONS(3746),
    [anon_sym_partial] = ACTIONS(3746),
    [anon_sym_private] = ACTIONS(3746),
    [anon_sym_protected] = ACTIONS(3746),
    [anon_sym_public] = ACTIONS(3746),
    [anon_sym_readonly] = ACTIONS(3746),
    [anon_sym_ref] = ACTIONS(3746),
    [anon_sym_sealed] = ACTIONS(3746),
    [anon_sym_unsafe] = ACTIONS(3746),
    [anon_sym_virtual] = ACTIONS(3746),
    [anon_sym_volatile] = ACTIONS(3746),
    [anon_sym_RBRACE] = ACTIONS(3750),
    [anon_sym_implicit] = ACTIONS(3746),
    [anon_sym_explicit] = ACTIONS(3746),
    [anon_sym_TILDE] = ACTIONS(3750),
    [anon_sym_where] = ACTIONS(3746),
    [anon_sym_class] = ACTIONS(3746),
    [anon_sym_struct] = ACTIONS(3746),
    [anon_sym_notnull] = ACTIONS(3746),
    [anon_sym_unmanaged] = ACTIONS(3746),
    [anon_sym_get] = ACTIONS(3746),
    [anon_sym_set] = ACTIONS(3746),
    [anon_sym_add] = ACTIONS(3746),
    [anon_sym_remove] = ACTIONS(3746),
    [anon_sym_enum] = ACTIONS(3746),
    [anon_sym_interface] = ACTIONS(3746),
    [anon_sym_delegate] = ACTIONS(3746),
    [anon_sym_record] = ACTIONS(3746),
    [anon_sym_namespace] = ACTIONS(3746),
    [anon_sym_var] = ACTIONS(3746),
    [sym_predefined_type] = ACTIONS(3746),
    [anon_sym_when] = ACTIONS(3746),
    [anon_sym_yield] = ACTIONS(3746),
    [anon_sym_from] = ACTIONS(3746),
    [anon_sym_join] = ACTIONS(3746),
    [anon_sym_on] = ACTIONS(3746),
    [anon_sym_equals] = ACTIONS(3746),
    [anon_sym_into] = ACTIONS(3746),
    [anon_sym_let] = ACTIONS(3746),
    [anon_sym_orderby] = ACTIONS(3746),
    [anon_sym_ascending] = ACTIONS(3746),
    [anon_sym_descending] = ACTIONS(3746),
    [anon_sym_group] = ACTIONS(3746),
    [anon_sym_by] = ACTIONS(3746),
    [anon_sym_select] = ACTIONS(3746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3746),
    [anon_sym_nameof] = ACTIONS(3746),
    [sym_void_keyword] = ACTIONS(3746),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2250] = {
    [sym__preprocessor_call] = STATE(2250),
    [sym__identifier_token] = ACTIONS(3752),
    [anon_sym_extern] = ACTIONS(3752),
    [anon_sym_alias] = ACTIONS(3752),
    [anon_sym_SEMI] = ACTIONS(3754),
    [anon_sym_global] = ACTIONS(3752),
    [anon_sym_using] = ACTIONS(3752),
    [anon_sym_static] = ACTIONS(3752),
    [anon_sym_LBRACK] = ACTIONS(3756),
    [anon_sym_event] = ACTIONS(3752),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_abstract] = ACTIONS(3752),
    [anon_sym_async] = ACTIONS(3752),
    [anon_sym_const] = ACTIONS(3752),
    [anon_sym_fixed] = ACTIONS(3752),
    [anon_sym_internal] = ACTIONS(3752),
    [anon_sym_new] = ACTIONS(3752),
    [anon_sym_override] = ACTIONS(3752),
    [anon_sym_partial] = ACTIONS(3752),
    [anon_sym_private] = ACTIONS(3752),
    [anon_sym_protected] = ACTIONS(3752),
    [anon_sym_public] = ACTIONS(3752),
    [anon_sym_readonly] = ACTIONS(3752),
    [anon_sym_ref] = ACTIONS(3752),
    [anon_sym_sealed] = ACTIONS(3752),
    [anon_sym_unsafe] = ACTIONS(3752),
    [anon_sym_virtual] = ACTIONS(3752),
    [anon_sym_volatile] = ACTIONS(3752),
    [anon_sym_RBRACE] = ACTIONS(3756),
    [anon_sym_implicit] = ACTIONS(3752),
    [anon_sym_explicit] = ACTIONS(3752),
    [anon_sym_TILDE] = ACTIONS(3756),
    [anon_sym_where] = ACTIONS(3752),
    [anon_sym_class] = ACTIONS(3752),
    [anon_sym_struct] = ACTIONS(3752),
    [anon_sym_notnull] = ACTIONS(3752),
    [anon_sym_unmanaged] = ACTIONS(3752),
    [anon_sym_get] = ACTIONS(3752),
    [anon_sym_set] = ACTIONS(3752),
    [anon_sym_add] = ACTIONS(3752),
    [anon_sym_remove] = ACTIONS(3752),
    [anon_sym_enum] = ACTIONS(3752),
    [anon_sym_interface] = ACTIONS(3752),
    [anon_sym_delegate] = ACTIONS(3752),
    [anon_sym_record] = ACTIONS(3752),
    [anon_sym_namespace] = ACTIONS(3752),
    [anon_sym_var] = ACTIONS(3752),
    [sym_predefined_type] = ACTIONS(3752),
    [anon_sym_when] = ACTIONS(3752),
    [anon_sym_yield] = ACTIONS(3752),
    [anon_sym_from] = ACTIONS(3752),
    [anon_sym_join] = ACTIONS(3752),
    [anon_sym_on] = ACTIONS(3752),
    [anon_sym_equals] = ACTIONS(3752),
    [anon_sym_into] = ACTIONS(3752),
    [anon_sym_let] = ACTIONS(3752),
    [anon_sym_orderby] = ACTIONS(3752),
    [anon_sym_ascending] = ACTIONS(3752),
    [anon_sym_descending] = ACTIONS(3752),
    [anon_sym_group] = ACTIONS(3752),
    [anon_sym_by] = ACTIONS(3752),
    [anon_sym_select] = ACTIONS(3752),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3752),
    [anon_sym_nameof] = ACTIONS(3752),
    [sym_void_keyword] = ACTIONS(3752),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2251] = {
    [sym__preprocessor_call] = STATE(2251),
    [sym__identifier_token] = ACTIONS(3758),
    [anon_sym_extern] = ACTIONS(3758),
    [anon_sym_alias] = ACTIONS(3758),
    [anon_sym_SEMI] = ACTIONS(3760),
    [anon_sym_global] = ACTIONS(3758),
    [anon_sym_using] = ACTIONS(3758),
    [anon_sym_static] = ACTIONS(3758),
    [anon_sym_LBRACK] = ACTIONS(3762),
    [anon_sym_event] = ACTIONS(3758),
    [anon_sym_LPAREN] = ACTIONS(3762),
    [anon_sym_abstract] = ACTIONS(3758),
    [anon_sym_async] = ACTIONS(3758),
    [anon_sym_const] = ACTIONS(3758),
    [anon_sym_fixed] = ACTIONS(3758),
    [anon_sym_internal] = ACTIONS(3758),
    [anon_sym_new] = ACTIONS(3758),
    [anon_sym_override] = ACTIONS(3758),
    [anon_sym_partial] = ACTIONS(3758),
    [anon_sym_private] = ACTIONS(3758),
    [anon_sym_protected] = ACTIONS(3758),
    [anon_sym_public] = ACTIONS(3758),
    [anon_sym_readonly] = ACTIONS(3758),
    [anon_sym_ref] = ACTIONS(3758),
    [anon_sym_sealed] = ACTIONS(3758),
    [anon_sym_unsafe] = ACTIONS(3758),
    [anon_sym_virtual] = ACTIONS(3758),
    [anon_sym_volatile] = ACTIONS(3758),
    [anon_sym_RBRACE] = ACTIONS(3762),
    [anon_sym_implicit] = ACTIONS(3758),
    [anon_sym_explicit] = ACTIONS(3758),
    [anon_sym_TILDE] = ACTIONS(3762),
    [anon_sym_where] = ACTIONS(3758),
    [anon_sym_class] = ACTIONS(3758),
    [anon_sym_struct] = ACTIONS(3758),
    [anon_sym_notnull] = ACTIONS(3758),
    [anon_sym_unmanaged] = ACTIONS(3758),
    [anon_sym_get] = ACTIONS(3758),
    [anon_sym_set] = ACTIONS(3758),
    [anon_sym_add] = ACTIONS(3758),
    [anon_sym_remove] = ACTIONS(3758),
    [anon_sym_enum] = ACTIONS(3758),
    [anon_sym_interface] = ACTIONS(3758),
    [anon_sym_delegate] = ACTIONS(3758),
    [anon_sym_record] = ACTIONS(3758),
    [anon_sym_namespace] = ACTIONS(3758),
    [anon_sym_var] = ACTIONS(3758),
    [sym_predefined_type] = ACTIONS(3758),
    [anon_sym_when] = ACTIONS(3758),
    [anon_sym_yield] = ACTIONS(3758),
    [anon_sym_from] = ACTIONS(3758),
    [anon_sym_join] = ACTIONS(3758),
    [anon_sym_on] = ACTIONS(3758),
    [anon_sym_equals] = ACTIONS(3758),
    [anon_sym_into] = ACTIONS(3758),
    [anon_sym_let] = ACTIONS(3758),
    [anon_sym_orderby] = ACTIONS(3758),
    [anon_sym_ascending] = ACTIONS(3758),
    [anon_sym_descending] = ACTIONS(3758),
    [anon_sym_group] = ACTIONS(3758),
    [anon_sym_by] = ACTIONS(3758),
    [anon_sym_select] = ACTIONS(3758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3758),
    [anon_sym_nameof] = ACTIONS(3758),
    [sym_void_keyword] = ACTIONS(3758),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2252] = {
    [sym__preprocessor_call] = STATE(2252),
    [sym__identifier_token] = ACTIONS(3764),
    [anon_sym_extern] = ACTIONS(3764),
    [anon_sym_alias] = ACTIONS(3764),
    [anon_sym_SEMI] = ACTIONS(3766),
    [anon_sym_global] = ACTIONS(3764),
    [anon_sym_using] = ACTIONS(3764),
    [anon_sym_static] = ACTIONS(3764),
    [anon_sym_LBRACK] = ACTIONS(3768),
    [anon_sym_event] = ACTIONS(3764),
    [anon_sym_LPAREN] = ACTIONS(3768),
    [anon_sym_abstract] = ACTIONS(3764),
    [anon_sym_async] = ACTIONS(3764),
    [anon_sym_const] = ACTIONS(3764),
    [anon_sym_fixed] = ACTIONS(3764),
    [anon_sym_internal] = ACTIONS(3764),
    [anon_sym_new] = ACTIONS(3764),
    [anon_sym_override] = ACTIONS(3764),
    [anon_sym_partial] = ACTIONS(3764),
    [anon_sym_private] = ACTIONS(3764),
    [anon_sym_protected] = ACTIONS(3764),
    [anon_sym_public] = ACTIONS(3764),
    [anon_sym_readonly] = ACTIONS(3764),
    [anon_sym_ref] = ACTIONS(3764),
    [anon_sym_sealed] = ACTIONS(3764),
    [anon_sym_unsafe] = ACTIONS(3764),
    [anon_sym_virtual] = ACTIONS(3764),
    [anon_sym_volatile] = ACTIONS(3764),
    [anon_sym_RBRACE] = ACTIONS(3768),
    [anon_sym_implicit] = ACTIONS(3764),
    [anon_sym_explicit] = ACTIONS(3764),
    [anon_sym_TILDE] = ACTIONS(3768),
    [anon_sym_where] = ACTIONS(3764),
    [anon_sym_class] = ACTIONS(3764),
    [anon_sym_struct] = ACTIONS(3764),
    [anon_sym_notnull] = ACTIONS(3764),
    [anon_sym_unmanaged] = ACTIONS(3764),
    [anon_sym_get] = ACTIONS(3764),
    [anon_sym_set] = ACTIONS(3764),
    [anon_sym_add] = ACTIONS(3764),
    [anon_sym_remove] = ACTIONS(3764),
    [anon_sym_enum] = ACTIONS(3764),
    [anon_sym_interface] = ACTIONS(3764),
    [anon_sym_delegate] = ACTIONS(3764),
    [anon_sym_record] = ACTIONS(3764),
    [anon_sym_namespace] = ACTIONS(3764),
    [anon_sym_var] = ACTIONS(3764),
    [sym_predefined_type] = ACTIONS(3764),
    [anon_sym_when] = ACTIONS(3764),
    [anon_sym_yield] = ACTIONS(3764),
    [anon_sym_from] = ACTIONS(3764),
    [anon_sym_join] = ACTIONS(3764),
    [anon_sym_on] = ACTIONS(3764),
    [anon_sym_equals] = ACTIONS(3764),
    [anon_sym_into] = ACTIONS(3764),
    [anon_sym_let] = ACTIONS(3764),
    [anon_sym_orderby] = ACTIONS(3764),
    [anon_sym_ascending] = ACTIONS(3764),
    [anon_sym_descending] = ACTIONS(3764),
    [anon_sym_group] = ACTIONS(3764),
    [anon_sym_by] = ACTIONS(3764),
    [anon_sym_select] = ACTIONS(3764),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3764),
    [anon_sym_nameof] = ACTIONS(3764),
    [sym_void_keyword] = ACTIONS(3764),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2253] = {
    [sym__preprocessor_call] = STATE(2253),
    [sym__identifier_token] = ACTIONS(3770),
    [anon_sym_extern] = ACTIONS(3770),
    [anon_sym_alias] = ACTIONS(3770),
    [anon_sym_SEMI] = ACTIONS(3772),
    [anon_sym_global] = ACTIONS(3770),
    [anon_sym_using] = ACTIONS(3770),
    [anon_sym_static] = ACTIONS(3770),
    [anon_sym_LBRACK] = ACTIONS(3774),
    [anon_sym_event] = ACTIONS(3770),
    [anon_sym_LPAREN] = ACTIONS(3774),
    [anon_sym_abstract] = ACTIONS(3770),
    [anon_sym_async] = ACTIONS(3770),
    [anon_sym_const] = ACTIONS(3770),
    [anon_sym_fixed] = ACTIONS(3770),
    [anon_sym_internal] = ACTIONS(3770),
    [anon_sym_new] = ACTIONS(3770),
    [anon_sym_override] = ACTIONS(3770),
    [anon_sym_partial] = ACTIONS(3770),
    [anon_sym_private] = ACTIONS(3770),
    [anon_sym_protected] = ACTIONS(3770),
    [anon_sym_public] = ACTIONS(3770),
    [anon_sym_readonly] = ACTIONS(3770),
    [anon_sym_ref] = ACTIONS(3770),
    [anon_sym_sealed] = ACTIONS(3770),
    [anon_sym_unsafe] = ACTIONS(3770),
    [anon_sym_virtual] = ACTIONS(3770),
    [anon_sym_volatile] = ACTIONS(3770),
    [anon_sym_RBRACE] = ACTIONS(3774),
    [anon_sym_implicit] = ACTIONS(3770),
    [anon_sym_explicit] = ACTIONS(3770),
    [anon_sym_TILDE] = ACTIONS(3774),
    [anon_sym_where] = ACTIONS(3770),
    [anon_sym_class] = ACTIONS(3770),
    [anon_sym_struct] = ACTIONS(3770),
    [anon_sym_notnull] = ACTIONS(3770),
    [anon_sym_unmanaged] = ACTIONS(3770),
    [anon_sym_get] = ACTIONS(3770),
    [anon_sym_set] = ACTIONS(3770),
    [anon_sym_add] = ACTIONS(3770),
    [anon_sym_remove] = ACTIONS(3770),
    [anon_sym_enum] = ACTIONS(3770),
    [anon_sym_interface] = ACTIONS(3770),
    [anon_sym_delegate] = ACTIONS(3770),
    [anon_sym_record] = ACTIONS(3770),
    [anon_sym_namespace] = ACTIONS(3770),
    [anon_sym_var] = ACTIONS(3770),
    [sym_predefined_type] = ACTIONS(3770),
    [anon_sym_when] = ACTIONS(3770),
    [anon_sym_yield] = ACTIONS(3770),
    [anon_sym_from] = ACTIONS(3770),
    [anon_sym_join] = ACTIONS(3770),
    [anon_sym_on] = ACTIONS(3770),
    [anon_sym_equals] = ACTIONS(3770),
    [anon_sym_into] = ACTIONS(3770),
    [anon_sym_let] = ACTIONS(3770),
    [anon_sym_orderby] = ACTIONS(3770),
    [anon_sym_ascending] = ACTIONS(3770),
    [anon_sym_descending] = ACTIONS(3770),
    [anon_sym_group] = ACTIONS(3770),
    [anon_sym_by] = ACTIONS(3770),
    [anon_sym_select] = ACTIONS(3770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3770),
    [anon_sym_nameof] = ACTIONS(3770),
    [sym_void_keyword] = ACTIONS(3770),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2254] = {
    [sym__preprocessor_call] = STATE(2254),
    [sym__identifier_token] = ACTIONS(3776),
    [anon_sym_extern] = ACTIONS(3776),
    [anon_sym_alias] = ACTIONS(3776),
    [anon_sym_SEMI] = ACTIONS(3778),
    [anon_sym_global] = ACTIONS(3776),
    [anon_sym_using] = ACTIONS(3776),
    [anon_sym_static] = ACTIONS(3776),
    [anon_sym_LBRACK] = ACTIONS(3780),
    [anon_sym_event] = ACTIONS(3776),
    [anon_sym_LPAREN] = ACTIONS(3780),
    [anon_sym_abstract] = ACTIONS(3776),
    [anon_sym_async] = ACTIONS(3776),
    [anon_sym_const] = ACTIONS(3776),
    [anon_sym_fixed] = ACTIONS(3776),
    [anon_sym_internal] = ACTIONS(3776),
    [anon_sym_new] = ACTIONS(3776),
    [anon_sym_override] = ACTIONS(3776),
    [anon_sym_partial] = ACTIONS(3776),
    [anon_sym_private] = ACTIONS(3776),
    [anon_sym_protected] = ACTIONS(3776),
    [anon_sym_public] = ACTIONS(3776),
    [anon_sym_readonly] = ACTIONS(3776),
    [anon_sym_ref] = ACTIONS(3776),
    [anon_sym_sealed] = ACTIONS(3776),
    [anon_sym_unsafe] = ACTIONS(3776),
    [anon_sym_virtual] = ACTIONS(3776),
    [anon_sym_volatile] = ACTIONS(3776),
    [anon_sym_RBRACE] = ACTIONS(3780),
    [anon_sym_implicit] = ACTIONS(3776),
    [anon_sym_explicit] = ACTIONS(3776),
    [anon_sym_TILDE] = ACTIONS(3780),
    [anon_sym_where] = ACTIONS(3776),
    [anon_sym_class] = ACTIONS(3776),
    [anon_sym_struct] = ACTIONS(3776),
    [anon_sym_notnull] = ACTIONS(3776),
    [anon_sym_unmanaged] = ACTIONS(3776),
    [anon_sym_get] = ACTIONS(3776),
    [anon_sym_set] = ACTIONS(3776),
    [anon_sym_add] = ACTIONS(3776),
    [anon_sym_remove] = ACTIONS(3776),
    [anon_sym_enum] = ACTIONS(3776),
    [anon_sym_interface] = ACTIONS(3776),
    [anon_sym_delegate] = ACTIONS(3776),
    [anon_sym_record] = ACTIONS(3776),
    [anon_sym_namespace] = ACTIONS(3776),
    [anon_sym_var] = ACTIONS(3776),
    [sym_predefined_type] = ACTIONS(3776),
    [anon_sym_when] = ACTIONS(3776),
    [anon_sym_yield] = ACTIONS(3776),
    [anon_sym_from] = ACTIONS(3776),
    [anon_sym_join] = ACTIONS(3776),
    [anon_sym_on] = ACTIONS(3776),
    [anon_sym_equals] = ACTIONS(3776),
    [anon_sym_into] = ACTIONS(3776),
    [anon_sym_let] = ACTIONS(3776),
    [anon_sym_orderby] = ACTIONS(3776),
    [anon_sym_ascending] = ACTIONS(3776),
    [anon_sym_descending] = ACTIONS(3776),
    [anon_sym_group] = ACTIONS(3776),
    [anon_sym_by] = ACTIONS(3776),
    [anon_sym_select] = ACTIONS(3776),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3776),
    [anon_sym_nameof] = ACTIONS(3776),
    [sym_void_keyword] = ACTIONS(3776),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2255] = {
    [sym__preprocessor_call] = STATE(2255),
    [sym__identifier_token] = ACTIONS(3782),
    [anon_sym_extern] = ACTIONS(3782),
    [anon_sym_alias] = ACTIONS(3782),
    [anon_sym_SEMI] = ACTIONS(3784),
    [anon_sym_global] = ACTIONS(3782),
    [anon_sym_using] = ACTIONS(3782),
    [anon_sym_static] = ACTIONS(3782),
    [anon_sym_LBRACK] = ACTIONS(3786),
    [anon_sym_event] = ACTIONS(3782),
    [anon_sym_LPAREN] = ACTIONS(3786),
    [anon_sym_abstract] = ACTIONS(3782),
    [anon_sym_async] = ACTIONS(3782),
    [anon_sym_const] = ACTIONS(3782),
    [anon_sym_fixed] = ACTIONS(3782),
    [anon_sym_internal] = ACTIONS(3782),
    [anon_sym_new] = ACTIONS(3782),
    [anon_sym_override] = ACTIONS(3782),
    [anon_sym_partial] = ACTIONS(3782),
    [anon_sym_private] = ACTIONS(3782),
    [anon_sym_protected] = ACTIONS(3782),
    [anon_sym_public] = ACTIONS(3782),
    [anon_sym_readonly] = ACTIONS(3782),
    [anon_sym_ref] = ACTIONS(3782),
    [anon_sym_sealed] = ACTIONS(3782),
    [anon_sym_unsafe] = ACTIONS(3782),
    [anon_sym_virtual] = ACTIONS(3782),
    [anon_sym_volatile] = ACTIONS(3782),
    [anon_sym_RBRACE] = ACTIONS(3786),
    [anon_sym_implicit] = ACTIONS(3782),
    [anon_sym_explicit] = ACTIONS(3782),
    [anon_sym_TILDE] = ACTIONS(3786),
    [anon_sym_where] = ACTIONS(3782),
    [anon_sym_class] = ACTIONS(3782),
    [anon_sym_struct] = ACTIONS(3782),
    [anon_sym_notnull] = ACTIONS(3782),
    [anon_sym_unmanaged] = ACTIONS(3782),
    [anon_sym_get] = ACTIONS(3782),
    [anon_sym_set] = ACTIONS(3782),
    [anon_sym_add] = ACTIONS(3782),
    [anon_sym_remove] = ACTIONS(3782),
    [anon_sym_enum] = ACTIONS(3782),
    [anon_sym_interface] = ACTIONS(3782),
    [anon_sym_delegate] = ACTIONS(3782),
    [anon_sym_record] = ACTIONS(3782),
    [anon_sym_namespace] = ACTIONS(3782),
    [anon_sym_var] = ACTIONS(3782),
    [sym_predefined_type] = ACTIONS(3782),
    [anon_sym_when] = ACTIONS(3782),
    [anon_sym_yield] = ACTIONS(3782),
    [anon_sym_from] = ACTIONS(3782),
    [anon_sym_join] = ACTIONS(3782),
    [anon_sym_on] = ACTIONS(3782),
    [anon_sym_equals] = ACTIONS(3782),
    [anon_sym_into] = ACTIONS(3782),
    [anon_sym_let] = ACTIONS(3782),
    [anon_sym_orderby] = ACTIONS(3782),
    [anon_sym_ascending] = ACTIONS(3782),
    [anon_sym_descending] = ACTIONS(3782),
    [anon_sym_group] = ACTIONS(3782),
    [anon_sym_by] = ACTIONS(3782),
    [anon_sym_select] = ACTIONS(3782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3782),
    [anon_sym_nameof] = ACTIONS(3782),
    [sym_void_keyword] = ACTIONS(3782),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2256] = {
    [sym__preprocessor_call] = STATE(2256),
    [sym__identifier_token] = ACTIONS(3788),
    [anon_sym_extern] = ACTIONS(3788),
    [anon_sym_alias] = ACTIONS(3788),
    [anon_sym_SEMI] = ACTIONS(3790),
    [anon_sym_global] = ACTIONS(3788),
    [anon_sym_using] = ACTIONS(3788),
    [anon_sym_static] = ACTIONS(3788),
    [anon_sym_LBRACK] = ACTIONS(3792),
    [anon_sym_event] = ACTIONS(3788),
    [anon_sym_LPAREN] = ACTIONS(3792),
    [anon_sym_abstract] = ACTIONS(3788),
    [anon_sym_async] = ACTIONS(3788),
    [anon_sym_const] = ACTIONS(3788),
    [anon_sym_fixed] = ACTIONS(3788),
    [anon_sym_internal] = ACTIONS(3788),
    [anon_sym_new] = ACTIONS(3788),
    [anon_sym_override] = ACTIONS(3788),
    [anon_sym_partial] = ACTIONS(3788),
    [anon_sym_private] = ACTIONS(3788),
    [anon_sym_protected] = ACTIONS(3788),
    [anon_sym_public] = ACTIONS(3788),
    [anon_sym_readonly] = ACTIONS(3788),
    [anon_sym_ref] = ACTIONS(3788),
    [anon_sym_sealed] = ACTIONS(3788),
    [anon_sym_unsafe] = ACTIONS(3788),
    [anon_sym_virtual] = ACTIONS(3788),
    [anon_sym_volatile] = ACTIONS(3788),
    [anon_sym_RBRACE] = ACTIONS(3792),
    [anon_sym_implicit] = ACTIONS(3788),
    [anon_sym_explicit] = ACTIONS(3788),
    [anon_sym_TILDE] = ACTIONS(3792),
    [anon_sym_where] = ACTIONS(3788),
    [anon_sym_class] = ACTIONS(3788),
    [anon_sym_struct] = ACTIONS(3788),
    [anon_sym_notnull] = ACTIONS(3788),
    [anon_sym_unmanaged] = ACTIONS(3788),
    [anon_sym_get] = ACTIONS(3788),
    [anon_sym_set] = ACTIONS(3788),
    [anon_sym_add] = ACTIONS(3788),
    [anon_sym_remove] = ACTIONS(3788),
    [anon_sym_enum] = ACTIONS(3788),
    [anon_sym_interface] = ACTIONS(3788),
    [anon_sym_delegate] = ACTIONS(3788),
    [anon_sym_record] = ACTIONS(3788),
    [anon_sym_namespace] = ACTIONS(3788),
    [anon_sym_var] = ACTIONS(3788),
    [sym_predefined_type] = ACTIONS(3788),
    [anon_sym_when] = ACTIONS(3788),
    [anon_sym_yield] = ACTIONS(3788),
    [anon_sym_from] = ACTIONS(3788),
    [anon_sym_join] = ACTIONS(3788),
    [anon_sym_on] = ACTIONS(3788),
    [anon_sym_equals] = ACTIONS(3788),
    [anon_sym_into] = ACTIONS(3788),
    [anon_sym_let] = ACTIONS(3788),
    [anon_sym_orderby] = ACTIONS(3788),
    [anon_sym_ascending] = ACTIONS(3788),
    [anon_sym_descending] = ACTIONS(3788),
    [anon_sym_group] = ACTIONS(3788),
    [anon_sym_by] = ACTIONS(3788),
    [anon_sym_select] = ACTIONS(3788),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3788),
    [anon_sym_nameof] = ACTIONS(3788),
    [sym_void_keyword] = ACTIONS(3788),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2257] = {
    [sym__preprocessor_call] = STATE(2257),
    [sym__identifier_token] = ACTIONS(3794),
    [anon_sym_extern] = ACTIONS(3794),
    [anon_sym_alias] = ACTIONS(3794),
    [anon_sym_SEMI] = ACTIONS(3796),
    [anon_sym_global] = ACTIONS(3794),
    [anon_sym_using] = ACTIONS(3794),
    [anon_sym_static] = ACTIONS(3794),
    [anon_sym_LBRACK] = ACTIONS(3798),
    [anon_sym_event] = ACTIONS(3794),
    [anon_sym_LPAREN] = ACTIONS(3798),
    [anon_sym_abstract] = ACTIONS(3794),
    [anon_sym_async] = ACTIONS(3794),
    [anon_sym_const] = ACTIONS(3794),
    [anon_sym_fixed] = ACTIONS(3794),
    [anon_sym_internal] = ACTIONS(3794),
    [anon_sym_new] = ACTIONS(3794),
    [anon_sym_override] = ACTIONS(3794),
    [anon_sym_partial] = ACTIONS(3794),
    [anon_sym_private] = ACTIONS(3794),
    [anon_sym_protected] = ACTIONS(3794),
    [anon_sym_public] = ACTIONS(3794),
    [anon_sym_readonly] = ACTIONS(3794),
    [anon_sym_ref] = ACTIONS(3794),
    [anon_sym_sealed] = ACTIONS(3794),
    [anon_sym_unsafe] = ACTIONS(3794),
    [anon_sym_virtual] = ACTIONS(3794),
    [anon_sym_volatile] = ACTIONS(3794),
    [anon_sym_RBRACE] = ACTIONS(3798),
    [anon_sym_implicit] = ACTIONS(3794),
    [anon_sym_explicit] = ACTIONS(3794),
    [anon_sym_TILDE] = ACTIONS(3798),
    [anon_sym_where] = ACTIONS(3794),
    [anon_sym_class] = ACTIONS(3794),
    [anon_sym_struct] = ACTIONS(3794),
    [anon_sym_notnull] = ACTIONS(3794),
    [anon_sym_unmanaged] = ACTIONS(3794),
    [anon_sym_get] = ACTIONS(3794),
    [anon_sym_set] = ACTIONS(3794),
    [anon_sym_add] = ACTIONS(3794),
    [anon_sym_remove] = ACTIONS(3794),
    [anon_sym_enum] = ACTIONS(3794),
    [anon_sym_interface] = ACTIONS(3794),
    [anon_sym_delegate] = ACTIONS(3794),
    [anon_sym_record] = ACTIONS(3794),
    [anon_sym_namespace] = ACTIONS(3794),
    [anon_sym_var] = ACTIONS(3794),
    [sym_predefined_type] = ACTIONS(3794),
    [anon_sym_when] = ACTIONS(3794),
    [anon_sym_yield] = ACTIONS(3794),
    [anon_sym_from] = ACTIONS(3794),
    [anon_sym_join] = ACTIONS(3794),
    [anon_sym_on] = ACTIONS(3794),
    [anon_sym_equals] = ACTIONS(3794),
    [anon_sym_into] = ACTIONS(3794),
    [anon_sym_let] = ACTIONS(3794),
    [anon_sym_orderby] = ACTIONS(3794),
    [anon_sym_ascending] = ACTIONS(3794),
    [anon_sym_descending] = ACTIONS(3794),
    [anon_sym_group] = ACTIONS(3794),
    [anon_sym_by] = ACTIONS(3794),
    [anon_sym_select] = ACTIONS(3794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3794),
    [anon_sym_nameof] = ACTIONS(3794),
    [sym_void_keyword] = ACTIONS(3794),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2258] = {
    [sym__preprocessor_call] = STATE(2258),
    [sym__identifier_token] = ACTIONS(3800),
    [anon_sym_extern] = ACTIONS(3800),
    [anon_sym_alias] = ACTIONS(3800),
    [anon_sym_SEMI] = ACTIONS(3802),
    [anon_sym_global] = ACTIONS(3800),
    [anon_sym_using] = ACTIONS(3800),
    [anon_sym_static] = ACTIONS(3800),
    [anon_sym_LBRACK] = ACTIONS(3804),
    [anon_sym_event] = ACTIONS(3800),
    [anon_sym_LPAREN] = ACTIONS(3804),
    [anon_sym_abstract] = ACTIONS(3800),
    [anon_sym_async] = ACTIONS(3800),
    [anon_sym_const] = ACTIONS(3800),
    [anon_sym_fixed] = ACTIONS(3800),
    [anon_sym_internal] = ACTIONS(3800),
    [anon_sym_new] = ACTIONS(3800),
    [anon_sym_override] = ACTIONS(3800),
    [anon_sym_partial] = ACTIONS(3800),
    [anon_sym_private] = ACTIONS(3800),
    [anon_sym_protected] = ACTIONS(3800),
    [anon_sym_public] = ACTIONS(3800),
    [anon_sym_readonly] = ACTIONS(3800),
    [anon_sym_ref] = ACTIONS(3800),
    [anon_sym_sealed] = ACTIONS(3800),
    [anon_sym_unsafe] = ACTIONS(3800),
    [anon_sym_virtual] = ACTIONS(3800),
    [anon_sym_volatile] = ACTIONS(3800),
    [anon_sym_RBRACE] = ACTIONS(3804),
    [anon_sym_implicit] = ACTIONS(3800),
    [anon_sym_explicit] = ACTIONS(3800),
    [anon_sym_TILDE] = ACTIONS(3804),
    [anon_sym_where] = ACTIONS(3800),
    [anon_sym_class] = ACTIONS(3800),
    [anon_sym_struct] = ACTIONS(3800),
    [anon_sym_notnull] = ACTIONS(3800),
    [anon_sym_unmanaged] = ACTIONS(3800),
    [anon_sym_get] = ACTIONS(3800),
    [anon_sym_set] = ACTIONS(3800),
    [anon_sym_add] = ACTIONS(3800),
    [anon_sym_remove] = ACTIONS(3800),
    [anon_sym_enum] = ACTIONS(3800),
    [anon_sym_interface] = ACTIONS(3800),
    [anon_sym_delegate] = ACTIONS(3800),
    [anon_sym_record] = ACTIONS(3800),
    [anon_sym_namespace] = ACTIONS(3800),
    [anon_sym_var] = ACTIONS(3800),
    [sym_predefined_type] = ACTIONS(3800),
    [anon_sym_when] = ACTIONS(3800),
    [anon_sym_yield] = ACTIONS(3800),
    [anon_sym_from] = ACTIONS(3800),
    [anon_sym_join] = ACTIONS(3800),
    [anon_sym_on] = ACTIONS(3800),
    [anon_sym_equals] = ACTIONS(3800),
    [anon_sym_into] = ACTIONS(3800),
    [anon_sym_let] = ACTIONS(3800),
    [anon_sym_orderby] = ACTIONS(3800),
    [anon_sym_ascending] = ACTIONS(3800),
    [anon_sym_descending] = ACTIONS(3800),
    [anon_sym_group] = ACTIONS(3800),
    [anon_sym_by] = ACTIONS(3800),
    [anon_sym_select] = ACTIONS(3800),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3800),
    [anon_sym_nameof] = ACTIONS(3800),
    [sym_void_keyword] = ACTIONS(3800),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2259] = {
    [sym__preprocessor_call] = STATE(2259),
    [anon_sym_SEMI] = ACTIONS(3470),
    [anon_sym_EQ] = ACTIONS(3472),
    [anon_sym_LT] = ACTIONS(3472),
    [anon_sym_COMMA] = ACTIONS(3470),
    [anon_sym_GT] = ACTIONS(3472),
    [anon_sym_DOT] = ACTIONS(3472),
    [anon_sym_LBRACK] = ACTIONS(3470),
    [anon_sym_RBRACK] = ACTIONS(3470),
    [anon_sym_COLON] = ACTIONS(3470),
    [anon_sym_LPAREN] = ACTIONS(3470),
    [anon_sym_RPAREN] = ACTIONS(3470),
    [anon_sym_in] = ACTIONS(3470),
    [anon_sym_RBRACE] = ACTIONS(3470),
    [anon_sym_EQ_GT] = ACTIONS(3470),
    [anon_sym_where] = ACTIONS(3470),
    [anon_sym_QMARK] = ACTIONS(3472),
    [anon_sym_BANG] = ACTIONS(3472),
    [anon_sym_PLUS_PLUS] = ACTIONS(3470),
    [anon_sym_DASH_DASH] = ACTIONS(3470),
    [anon_sym_PLUS] = ACTIONS(3472),
    [anon_sym_DASH] = ACTIONS(3472),
    [anon_sym_STAR] = ACTIONS(3472),
    [anon_sym_SLASH] = ACTIONS(3472),
    [anon_sym_PERCENT] = ACTIONS(3472),
    [anon_sym_CARET] = ACTIONS(3472),
    [anon_sym_PIPE] = ACTIONS(3472),
    [anon_sym_AMP] = ACTIONS(3472),
    [anon_sym_LT_LT] = ACTIONS(3472),
    [anon_sym_GT_GT] = ACTIONS(3472),
    [anon_sym_EQ_EQ] = ACTIONS(3470),
    [anon_sym_BANG_EQ] = ACTIONS(3470),
    [anon_sym_GT_EQ] = ACTIONS(3470),
    [anon_sym_LT_EQ] = ACTIONS(3470),
    [anon_sym_switch] = ACTIONS(3470),
    [anon_sym_and] = ACTIONS(3470),
    [anon_sym_or] = ACTIONS(3472),
    [anon_sym_PLUS_EQ] = ACTIONS(3470),
    [anon_sym_DASH_EQ] = ACTIONS(3470),
    [anon_sym_STAR_EQ] = ACTIONS(3470),
    [anon_sym_SLASH_EQ] = ACTIONS(3470),
    [anon_sym_PERCENT_EQ] = ACTIONS(3470),
    [anon_sym_AMP_EQ] = ACTIONS(3470),
    [anon_sym_CARET_EQ] = ACTIONS(3470),
    [anon_sym_PIPE_EQ] = ACTIONS(3470),
    [anon_sym_LT_LT_EQ] = ACTIONS(3470),
    [anon_sym_GT_GT_EQ] = ACTIONS(3470),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3470),
    [anon_sym_is] = ACTIONS(3470),
    [anon_sym_DASH_GT] = ACTIONS(3470),
    [anon_sym_from] = ACTIONS(3470),
    [anon_sym_join] = ACTIONS(3470),
    [anon_sym_on] = ACTIONS(3470),
    [anon_sym_equals] = ACTIONS(3470),
    [anon_sym_let] = ACTIONS(3470),
    [anon_sym_orderby] = ACTIONS(3470),
    [anon_sym_group] = ACTIONS(3470),
    [anon_sym_by] = ACTIONS(3470),
    [anon_sym_select] = ACTIONS(3470),
    [anon_sym_DOT_DOT] = ACTIONS(3470),
    [anon_sym_with] = ACTIONS(3470),
    [anon_sym_AMP_AMP] = ACTIONS(3470),
    [anon_sym_PIPE_PIPE] = ACTIONS(3470),
    [anon_sym_QMARK_QMARK] = ACTIONS(3472),
    [anon_sym_as] = ACTIONS(3470),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2260] = {
    [sym__preprocessor_call] = STATE(2260),
    [anon_sym_SEMI] = ACTIONS(3410),
    [anon_sym_EQ] = ACTIONS(3412),
    [anon_sym_LT] = ACTIONS(3412),
    [anon_sym_COMMA] = ACTIONS(3410),
    [anon_sym_GT] = ACTIONS(3412),
    [anon_sym_DOT] = ACTIONS(3412),
    [anon_sym_LBRACK] = ACTIONS(3410),
    [anon_sym_RBRACK] = ACTIONS(3410),
    [anon_sym_COLON] = ACTIONS(3410),
    [anon_sym_LPAREN] = ACTIONS(3410),
    [anon_sym_RPAREN] = ACTIONS(3410),
    [anon_sym_in] = ACTIONS(3410),
    [anon_sym_RBRACE] = ACTIONS(3410),
    [anon_sym_EQ_GT] = ACTIONS(3410),
    [anon_sym_where] = ACTIONS(3410),
    [anon_sym_QMARK] = ACTIONS(3412),
    [anon_sym_BANG] = ACTIONS(3412),
    [anon_sym_PLUS_PLUS] = ACTIONS(3410),
    [anon_sym_DASH_DASH] = ACTIONS(3410),
    [anon_sym_PLUS] = ACTIONS(3412),
    [anon_sym_DASH] = ACTIONS(3412),
    [anon_sym_STAR] = ACTIONS(3412),
    [anon_sym_SLASH] = ACTIONS(3412),
    [anon_sym_PERCENT] = ACTIONS(3412),
    [anon_sym_CARET] = ACTIONS(3412),
    [anon_sym_PIPE] = ACTIONS(3412),
    [anon_sym_AMP] = ACTIONS(3412),
    [anon_sym_LT_LT] = ACTIONS(3412),
    [anon_sym_GT_GT] = ACTIONS(3412),
    [anon_sym_EQ_EQ] = ACTIONS(3410),
    [anon_sym_BANG_EQ] = ACTIONS(3410),
    [anon_sym_GT_EQ] = ACTIONS(3410),
    [anon_sym_LT_EQ] = ACTIONS(3410),
    [anon_sym_switch] = ACTIONS(3410),
    [anon_sym_and] = ACTIONS(3410),
    [anon_sym_or] = ACTIONS(3412),
    [anon_sym_PLUS_EQ] = ACTIONS(3410),
    [anon_sym_DASH_EQ] = ACTIONS(3410),
    [anon_sym_STAR_EQ] = ACTIONS(3410),
    [anon_sym_SLASH_EQ] = ACTIONS(3410),
    [anon_sym_PERCENT_EQ] = ACTIONS(3410),
    [anon_sym_AMP_EQ] = ACTIONS(3410),
    [anon_sym_CARET_EQ] = ACTIONS(3410),
    [anon_sym_PIPE_EQ] = ACTIONS(3410),
    [anon_sym_LT_LT_EQ] = ACTIONS(3410),
    [anon_sym_GT_GT_EQ] = ACTIONS(3410),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3410),
    [anon_sym_is] = ACTIONS(3410),
    [anon_sym_DASH_GT] = ACTIONS(3410),
    [anon_sym_from] = ACTIONS(3410),
    [anon_sym_join] = ACTIONS(3410),
    [anon_sym_on] = ACTIONS(3410),
    [anon_sym_equals] = ACTIONS(3410),
    [anon_sym_let] = ACTIONS(3410),
    [anon_sym_orderby] = ACTIONS(3410),
    [anon_sym_group] = ACTIONS(3410),
    [anon_sym_by] = ACTIONS(3410),
    [anon_sym_select] = ACTIONS(3410),
    [anon_sym_DOT_DOT] = ACTIONS(3410),
    [anon_sym_with] = ACTIONS(3410),
    [anon_sym_AMP_AMP] = ACTIONS(3410),
    [anon_sym_PIPE_PIPE] = ACTIONS(3410),
    [anon_sym_QMARK_QMARK] = ACTIONS(3412),
    [anon_sym_as] = ACTIONS(3410),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2261] = {
    [sym__preprocessor_call] = STATE(2261),
    [anon_sym_SEMI] = ACTIONS(3350),
    [anon_sym_EQ] = ACTIONS(3352),
    [anon_sym_LT] = ACTIONS(3352),
    [anon_sym_COMMA] = ACTIONS(3350),
    [anon_sym_GT] = ACTIONS(3352),
    [anon_sym_DOT] = ACTIONS(3352),
    [anon_sym_LBRACK] = ACTIONS(3350),
    [anon_sym_RBRACK] = ACTIONS(3350),
    [anon_sym_COLON] = ACTIONS(3350),
    [anon_sym_LPAREN] = ACTIONS(3350),
    [anon_sym_RPAREN] = ACTIONS(3350),
    [anon_sym_in] = ACTIONS(3350),
    [anon_sym_RBRACE] = ACTIONS(3350),
    [anon_sym_EQ_GT] = ACTIONS(3350),
    [anon_sym_where] = ACTIONS(3350),
    [anon_sym_QMARK] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3352),
    [anon_sym_PLUS_PLUS] = ACTIONS(3350),
    [anon_sym_DASH_DASH] = ACTIONS(3350),
    [anon_sym_PLUS] = ACTIONS(3352),
    [anon_sym_DASH] = ACTIONS(3352),
    [anon_sym_STAR] = ACTIONS(3352),
    [anon_sym_SLASH] = ACTIONS(3352),
    [anon_sym_PERCENT] = ACTIONS(3352),
    [anon_sym_CARET] = ACTIONS(3352),
    [anon_sym_PIPE] = ACTIONS(3352),
    [anon_sym_AMP] = ACTIONS(3352),
    [anon_sym_LT_LT] = ACTIONS(3352),
    [anon_sym_GT_GT] = ACTIONS(3352),
    [anon_sym_EQ_EQ] = ACTIONS(3350),
    [anon_sym_BANG_EQ] = ACTIONS(3350),
    [anon_sym_GT_EQ] = ACTIONS(3350),
    [anon_sym_LT_EQ] = ACTIONS(3350),
    [anon_sym_switch] = ACTIONS(3350),
    [anon_sym_and] = ACTIONS(3350),
    [anon_sym_or] = ACTIONS(3352),
    [anon_sym_PLUS_EQ] = ACTIONS(3350),
    [anon_sym_DASH_EQ] = ACTIONS(3350),
    [anon_sym_STAR_EQ] = ACTIONS(3350),
    [anon_sym_SLASH_EQ] = ACTIONS(3350),
    [anon_sym_PERCENT_EQ] = ACTIONS(3350),
    [anon_sym_AMP_EQ] = ACTIONS(3350),
    [anon_sym_CARET_EQ] = ACTIONS(3350),
    [anon_sym_PIPE_EQ] = ACTIONS(3350),
    [anon_sym_LT_LT_EQ] = ACTIONS(3350),
    [anon_sym_GT_GT_EQ] = ACTIONS(3350),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3350),
    [anon_sym_is] = ACTIONS(3350),
    [anon_sym_DASH_GT] = ACTIONS(3350),
    [anon_sym_from] = ACTIONS(3350),
    [anon_sym_join] = ACTIONS(3350),
    [anon_sym_on] = ACTIONS(3350),
    [anon_sym_equals] = ACTIONS(3350),
    [anon_sym_let] = ACTIONS(3350),
    [anon_sym_orderby] = ACTIONS(3350),
    [anon_sym_group] = ACTIONS(3350),
    [anon_sym_by] = ACTIONS(3350),
    [anon_sym_select] = ACTIONS(3350),
    [anon_sym_DOT_DOT] = ACTIONS(3350),
    [anon_sym_with] = ACTIONS(3350),
    [anon_sym_AMP_AMP] = ACTIONS(3350),
    [anon_sym_PIPE_PIPE] = ACTIONS(3350),
    [anon_sym_QMARK_QMARK] = ACTIONS(3352),
    [anon_sym_as] = ACTIONS(3350),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2262] = {
    [sym__preprocessor_call] = STATE(2262),
    [anon_sym_SEMI] = ACTIONS(3438),
    [anon_sym_EQ] = ACTIONS(3440),
    [anon_sym_LT] = ACTIONS(3440),
    [anon_sym_COMMA] = ACTIONS(3438),
    [anon_sym_GT] = ACTIONS(3440),
    [anon_sym_DOT] = ACTIONS(3440),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_RBRACK] = ACTIONS(3438),
    [anon_sym_COLON] = ACTIONS(3438),
    [anon_sym_LPAREN] = ACTIONS(3438),
    [anon_sym_RPAREN] = ACTIONS(3438),
    [anon_sym_in] = ACTIONS(3438),
    [anon_sym_RBRACE] = ACTIONS(3438),
    [anon_sym_EQ_GT] = ACTIONS(3438),
    [anon_sym_where] = ACTIONS(3438),
    [anon_sym_QMARK] = ACTIONS(3440),
    [anon_sym_BANG] = ACTIONS(3440),
    [anon_sym_PLUS_PLUS] = ACTIONS(3438),
    [anon_sym_DASH_DASH] = ACTIONS(3438),
    [anon_sym_PLUS] = ACTIONS(3440),
    [anon_sym_DASH] = ACTIONS(3440),
    [anon_sym_STAR] = ACTIONS(3440),
    [anon_sym_SLASH] = ACTIONS(3440),
    [anon_sym_PERCENT] = ACTIONS(3440),
    [anon_sym_CARET] = ACTIONS(3440),
    [anon_sym_PIPE] = ACTIONS(3440),
    [anon_sym_AMP] = ACTIONS(3440),
    [anon_sym_LT_LT] = ACTIONS(3440),
    [anon_sym_GT_GT] = ACTIONS(3440),
    [anon_sym_EQ_EQ] = ACTIONS(3438),
    [anon_sym_BANG_EQ] = ACTIONS(3438),
    [anon_sym_GT_EQ] = ACTIONS(3438),
    [anon_sym_LT_EQ] = ACTIONS(3438),
    [anon_sym_switch] = ACTIONS(3438),
    [anon_sym_and] = ACTIONS(3438),
    [anon_sym_or] = ACTIONS(3440),
    [anon_sym_PLUS_EQ] = ACTIONS(3438),
    [anon_sym_DASH_EQ] = ACTIONS(3438),
    [anon_sym_STAR_EQ] = ACTIONS(3438),
    [anon_sym_SLASH_EQ] = ACTIONS(3438),
    [anon_sym_PERCENT_EQ] = ACTIONS(3438),
    [anon_sym_AMP_EQ] = ACTIONS(3438),
    [anon_sym_CARET_EQ] = ACTIONS(3438),
    [anon_sym_PIPE_EQ] = ACTIONS(3438),
    [anon_sym_LT_LT_EQ] = ACTIONS(3438),
    [anon_sym_GT_GT_EQ] = ACTIONS(3438),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3438),
    [anon_sym_is] = ACTIONS(3438),
    [anon_sym_DASH_GT] = ACTIONS(3438),
    [anon_sym_from] = ACTIONS(3438),
    [anon_sym_join] = ACTIONS(3438),
    [anon_sym_on] = ACTIONS(3438),
    [anon_sym_equals] = ACTIONS(3438),
    [anon_sym_let] = ACTIONS(3438),
    [anon_sym_orderby] = ACTIONS(3438),
    [anon_sym_group] = ACTIONS(3438),
    [anon_sym_by] = ACTIONS(3438),
    [anon_sym_select] = ACTIONS(3438),
    [anon_sym_DOT_DOT] = ACTIONS(3438),
    [anon_sym_with] = ACTIONS(3438),
    [anon_sym_AMP_AMP] = ACTIONS(3438),
    [anon_sym_PIPE_PIPE] = ACTIONS(3438),
    [anon_sym_QMARK_QMARK] = ACTIONS(3440),
    [anon_sym_as] = ACTIONS(3438),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2263] = {
    [sym__preprocessor_call] = STATE(2263),
    [sym__identifier_token] = ACTIONS(3806),
    [anon_sym_extern] = ACTIONS(3806),
    [anon_sym_alias] = ACTIONS(3806),
    [anon_sym_SEMI] = ACTIONS(3808),
    [anon_sym_global] = ACTIONS(3806),
    [anon_sym_using] = ACTIONS(3806),
    [anon_sym_static] = ACTIONS(3806),
    [anon_sym_LBRACK] = ACTIONS(3810),
    [anon_sym_event] = ACTIONS(3806),
    [anon_sym_LPAREN] = ACTIONS(3810),
    [anon_sym_abstract] = ACTIONS(3806),
    [anon_sym_async] = ACTIONS(3806),
    [anon_sym_const] = ACTIONS(3806),
    [anon_sym_fixed] = ACTIONS(3806),
    [anon_sym_internal] = ACTIONS(3806),
    [anon_sym_new] = ACTIONS(3806),
    [anon_sym_override] = ACTIONS(3806),
    [anon_sym_partial] = ACTIONS(3806),
    [anon_sym_private] = ACTIONS(3806),
    [anon_sym_protected] = ACTIONS(3806),
    [anon_sym_public] = ACTIONS(3806),
    [anon_sym_readonly] = ACTIONS(3806),
    [anon_sym_ref] = ACTIONS(3806),
    [anon_sym_sealed] = ACTIONS(3806),
    [anon_sym_unsafe] = ACTIONS(3806),
    [anon_sym_virtual] = ACTIONS(3806),
    [anon_sym_volatile] = ACTIONS(3806),
    [anon_sym_RBRACE] = ACTIONS(3810),
    [anon_sym_implicit] = ACTIONS(3806),
    [anon_sym_explicit] = ACTIONS(3806),
    [anon_sym_TILDE] = ACTIONS(3810),
    [anon_sym_where] = ACTIONS(3806),
    [anon_sym_class] = ACTIONS(3806),
    [anon_sym_struct] = ACTIONS(3806),
    [anon_sym_notnull] = ACTIONS(3806),
    [anon_sym_unmanaged] = ACTIONS(3806),
    [anon_sym_get] = ACTIONS(3806),
    [anon_sym_set] = ACTIONS(3806),
    [anon_sym_add] = ACTIONS(3806),
    [anon_sym_remove] = ACTIONS(3806),
    [anon_sym_enum] = ACTIONS(3806),
    [anon_sym_interface] = ACTIONS(3806),
    [anon_sym_delegate] = ACTIONS(3806),
    [anon_sym_record] = ACTIONS(3806),
    [anon_sym_namespace] = ACTIONS(3806),
    [anon_sym_var] = ACTIONS(3806),
    [sym_predefined_type] = ACTIONS(3806),
    [anon_sym_when] = ACTIONS(3806),
    [anon_sym_yield] = ACTIONS(3806),
    [anon_sym_from] = ACTIONS(3806),
    [anon_sym_join] = ACTIONS(3806),
    [anon_sym_on] = ACTIONS(3806),
    [anon_sym_equals] = ACTIONS(3806),
    [anon_sym_into] = ACTIONS(3806),
    [anon_sym_let] = ACTIONS(3806),
    [anon_sym_orderby] = ACTIONS(3806),
    [anon_sym_ascending] = ACTIONS(3806),
    [anon_sym_descending] = ACTIONS(3806),
    [anon_sym_group] = ACTIONS(3806),
    [anon_sym_by] = ACTIONS(3806),
    [anon_sym_select] = ACTIONS(3806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3806),
    [anon_sym_nameof] = ACTIONS(3806),
    [sym_void_keyword] = ACTIONS(3806),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2264] = {
    [sym__preprocessor_call] = STATE(2264),
    [sym__identifier_token] = ACTIONS(3812),
    [anon_sym_extern] = ACTIONS(3812),
    [anon_sym_alias] = ACTIONS(3812),
    [anon_sym_global] = ACTIONS(3812),
    [anon_sym_using] = ACTIONS(3812),
    [anon_sym_static] = ACTIONS(3812),
    [anon_sym_EQ] = ACTIONS(3814),
    [anon_sym_LBRACK] = ACTIONS(3816),
    [anon_sym_event] = ACTIONS(3812),
    [anon_sym_LPAREN] = ACTIONS(3816),
    [anon_sym_abstract] = ACTIONS(3812),
    [anon_sym_async] = ACTIONS(3812),
    [anon_sym_const] = ACTIONS(3812),
    [anon_sym_fixed] = ACTIONS(3812),
    [anon_sym_internal] = ACTIONS(3812),
    [anon_sym_new] = ACTIONS(3812),
    [anon_sym_override] = ACTIONS(3812),
    [anon_sym_partial] = ACTIONS(3812),
    [anon_sym_private] = ACTIONS(3812),
    [anon_sym_protected] = ACTIONS(3812),
    [anon_sym_public] = ACTIONS(3812),
    [anon_sym_readonly] = ACTIONS(3812),
    [anon_sym_ref] = ACTIONS(3812),
    [anon_sym_sealed] = ACTIONS(3812),
    [anon_sym_unsafe] = ACTIONS(3812),
    [anon_sym_virtual] = ACTIONS(3812),
    [anon_sym_volatile] = ACTIONS(3812),
    [anon_sym_RBRACE] = ACTIONS(3816),
    [anon_sym_implicit] = ACTIONS(3812),
    [anon_sym_explicit] = ACTIONS(3812),
    [anon_sym_TILDE] = ACTIONS(3816),
    [anon_sym_where] = ACTIONS(3812),
    [anon_sym_class] = ACTIONS(3812),
    [anon_sym_struct] = ACTIONS(3812),
    [anon_sym_notnull] = ACTIONS(3812),
    [anon_sym_unmanaged] = ACTIONS(3812),
    [anon_sym_get] = ACTIONS(3812),
    [anon_sym_set] = ACTIONS(3812),
    [anon_sym_add] = ACTIONS(3812),
    [anon_sym_remove] = ACTIONS(3812),
    [anon_sym_enum] = ACTIONS(3812),
    [anon_sym_interface] = ACTIONS(3812),
    [anon_sym_delegate] = ACTIONS(3812),
    [anon_sym_record] = ACTIONS(3812),
    [anon_sym_namespace] = ACTIONS(3812),
    [anon_sym_var] = ACTIONS(3812),
    [sym_predefined_type] = ACTIONS(3812),
    [anon_sym_when] = ACTIONS(3812),
    [anon_sym_yield] = ACTIONS(3812),
    [anon_sym_from] = ACTIONS(3812),
    [anon_sym_join] = ACTIONS(3812),
    [anon_sym_on] = ACTIONS(3812),
    [anon_sym_equals] = ACTIONS(3812),
    [anon_sym_into] = ACTIONS(3812),
    [anon_sym_let] = ACTIONS(3812),
    [anon_sym_orderby] = ACTIONS(3812),
    [anon_sym_ascending] = ACTIONS(3812),
    [anon_sym_descending] = ACTIONS(3812),
    [anon_sym_group] = ACTIONS(3812),
    [anon_sym_by] = ACTIONS(3812),
    [anon_sym_select] = ACTIONS(3812),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3812),
    [anon_sym_nameof] = ACTIONS(3812),
    [sym_void_keyword] = ACTIONS(3812),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2265] = {
    [sym__preprocessor_call] = STATE(2265),
    [sym__identifier_token] = ACTIONS(3818),
    [anon_sym_extern] = ACTIONS(3818),
    [anon_sym_alias] = ACTIONS(3818),
    [anon_sym_global] = ACTIONS(3818),
    [anon_sym_using] = ACTIONS(3818),
    [anon_sym_static] = ACTIONS(3818),
    [anon_sym_EQ] = ACTIONS(3820),
    [anon_sym_LBRACK] = ACTIONS(3822),
    [anon_sym_event] = ACTIONS(3818),
    [anon_sym_LPAREN] = ACTIONS(3822),
    [anon_sym_abstract] = ACTIONS(3818),
    [anon_sym_async] = ACTIONS(3818),
    [anon_sym_const] = ACTIONS(3818),
    [anon_sym_fixed] = ACTIONS(3818),
    [anon_sym_internal] = ACTIONS(3818),
    [anon_sym_new] = ACTIONS(3818),
    [anon_sym_override] = ACTIONS(3818),
    [anon_sym_partial] = ACTIONS(3818),
    [anon_sym_private] = ACTIONS(3818),
    [anon_sym_protected] = ACTIONS(3818),
    [anon_sym_public] = ACTIONS(3818),
    [anon_sym_readonly] = ACTIONS(3818),
    [anon_sym_ref] = ACTIONS(3818),
    [anon_sym_sealed] = ACTIONS(3818),
    [anon_sym_unsafe] = ACTIONS(3818),
    [anon_sym_virtual] = ACTIONS(3818),
    [anon_sym_volatile] = ACTIONS(3818),
    [anon_sym_RBRACE] = ACTIONS(3822),
    [anon_sym_implicit] = ACTIONS(3818),
    [anon_sym_explicit] = ACTIONS(3818),
    [anon_sym_TILDE] = ACTIONS(3822),
    [anon_sym_where] = ACTIONS(3818),
    [anon_sym_class] = ACTIONS(3818),
    [anon_sym_struct] = ACTIONS(3818),
    [anon_sym_notnull] = ACTIONS(3818),
    [anon_sym_unmanaged] = ACTIONS(3818),
    [anon_sym_get] = ACTIONS(3818),
    [anon_sym_set] = ACTIONS(3818),
    [anon_sym_add] = ACTIONS(3818),
    [anon_sym_remove] = ACTIONS(3818),
    [anon_sym_enum] = ACTIONS(3818),
    [anon_sym_interface] = ACTIONS(3818),
    [anon_sym_delegate] = ACTIONS(3818),
    [anon_sym_record] = ACTIONS(3818),
    [anon_sym_namespace] = ACTIONS(3818),
    [anon_sym_var] = ACTIONS(3818),
    [sym_predefined_type] = ACTIONS(3818),
    [anon_sym_when] = ACTIONS(3818),
    [anon_sym_yield] = ACTIONS(3818),
    [anon_sym_from] = ACTIONS(3818),
    [anon_sym_join] = ACTIONS(3818),
    [anon_sym_on] = ACTIONS(3818),
    [anon_sym_equals] = ACTIONS(3818),
    [anon_sym_into] = ACTIONS(3818),
    [anon_sym_let] = ACTIONS(3818),
    [anon_sym_orderby] = ACTIONS(3818),
    [anon_sym_ascending] = ACTIONS(3818),
    [anon_sym_descending] = ACTIONS(3818),
    [anon_sym_group] = ACTIONS(3818),
    [anon_sym_by] = ACTIONS(3818),
    [anon_sym_select] = ACTIONS(3818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3818),
    [anon_sym_nameof] = ACTIONS(3818),
    [sym_void_keyword] = ACTIONS(3818),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2266] = {
    [sym__preprocessor_call] = STATE(2266),
    [anon_sym_SEMI] = ACTIONS(3434),
    [anon_sym_EQ] = ACTIONS(3436),
    [anon_sym_LT] = ACTIONS(3436),
    [anon_sym_COMMA] = ACTIONS(3434),
    [anon_sym_GT] = ACTIONS(3436),
    [anon_sym_DOT] = ACTIONS(3436),
    [anon_sym_LBRACK] = ACTIONS(3434),
    [anon_sym_RBRACK] = ACTIONS(3434),
    [anon_sym_COLON] = ACTIONS(3434),
    [anon_sym_LPAREN] = ACTIONS(3434),
    [anon_sym_RPAREN] = ACTIONS(3434),
    [anon_sym_in] = ACTIONS(3434),
    [anon_sym_RBRACE] = ACTIONS(3434),
    [anon_sym_EQ_GT] = ACTIONS(3434),
    [anon_sym_where] = ACTIONS(3434),
    [anon_sym_QMARK] = ACTIONS(3436),
    [anon_sym_BANG] = ACTIONS(3436),
    [anon_sym_PLUS_PLUS] = ACTIONS(3434),
    [anon_sym_DASH_DASH] = ACTIONS(3434),
    [anon_sym_PLUS] = ACTIONS(3436),
    [anon_sym_DASH] = ACTIONS(3436),
    [anon_sym_STAR] = ACTIONS(3436),
    [anon_sym_SLASH] = ACTIONS(3436),
    [anon_sym_PERCENT] = ACTIONS(3436),
    [anon_sym_CARET] = ACTIONS(3436),
    [anon_sym_PIPE] = ACTIONS(3436),
    [anon_sym_AMP] = ACTIONS(3436),
    [anon_sym_LT_LT] = ACTIONS(3436),
    [anon_sym_GT_GT] = ACTIONS(3436),
    [anon_sym_EQ_EQ] = ACTIONS(3434),
    [anon_sym_BANG_EQ] = ACTIONS(3434),
    [anon_sym_GT_EQ] = ACTIONS(3434),
    [anon_sym_LT_EQ] = ACTIONS(3434),
    [anon_sym_switch] = ACTIONS(3434),
    [anon_sym_and] = ACTIONS(3434),
    [anon_sym_or] = ACTIONS(3436),
    [anon_sym_PLUS_EQ] = ACTIONS(3434),
    [anon_sym_DASH_EQ] = ACTIONS(3434),
    [anon_sym_STAR_EQ] = ACTIONS(3434),
    [anon_sym_SLASH_EQ] = ACTIONS(3434),
    [anon_sym_PERCENT_EQ] = ACTIONS(3434),
    [anon_sym_AMP_EQ] = ACTIONS(3434),
    [anon_sym_CARET_EQ] = ACTIONS(3434),
    [anon_sym_PIPE_EQ] = ACTIONS(3434),
    [anon_sym_LT_LT_EQ] = ACTIONS(3434),
    [anon_sym_GT_GT_EQ] = ACTIONS(3434),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3434),
    [anon_sym_is] = ACTIONS(3434),
    [anon_sym_DASH_GT] = ACTIONS(3434),
    [anon_sym_from] = ACTIONS(3434),
    [anon_sym_join] = ACTIONS(3434),
    [anon_sym_on] = ACTIONS(3434),
    [anon_sym_equals] = ACTIONS(3434),
    [anon_sym_let] = ACTIONS(3434),
    [anon_sym_orderby] = ACTIONS(3434),
    [anon_sym_group] = ACTIONS(3434),
    [anon_sym_by] = ACTIONS(3434),
    [anon_sym_select] = ACTIONS(3434),
    [anon_sym_DOT_DOT] = ACTIONS(3434),
    [anon_sym_with] = ACTIONS(3434),
    [anon_sym_AMP_AMP] = ACTIONS(3434),
    [anon_sym_PIPE_PIPE] = ACTIONS(3434),
    [anon_sym_QMARK_QMARK] = ACTIONS(3436),
    [anon_sym_as] = ACTIONS(3434),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2267] = {
    [sym__preprocessor_call] = STATE(2267),
    [anon_sym_SEMI] = ACTIONS(3336),
    [anon_sym_EQ] = ACTIONS(3338),
    [anon_sym_LT] = ACTIONS(3338),
    [anon_sym_COMMA] = ACTIONS(3336),
    [anon_sym_GT] = ACTIONS(3338),
    [anon_sym_DOT] = ACTIONS(3338),
    [anon_sym_LBRACK] = ACTIONS(3336),
    [anon_sym_RBRACK] = ACTIONS(3336),
    [anon_sym_COLON] = ACTIONS(3336),
    [anon_sym_LPAREN] = ACTIONS(3336),
    [anon_sym_RPAREN] = ACTIONS(3336),
    [anon_sym_in] = ACTIONS(3336),
    [anon_sym_RBRACE] = ACTIONS(3336),
    [anon_sym_EQ_GT] = ACTIONS(3336),
    [anon_sym_where] = ACTIONS(3336),
    [anon_sym_QMARK] = ACTIONS(3338),
    [anon_sym_BANG] = ACTIONS(3338),
    [anon_sym_PLUS_PLUS] = ACTIONS(3336),
    [anon_sym_DASH_DASH] = ACTIONS(3336),
    [anon_sym_PLUS] = ACTIONS(3338),
    [anon_sym_DASH] = ACTIONS(3338),
    [anon_sym_STAR] = ACTIONS(3338),
    [anon_sym_SLASH] = ACTIONS(3338),
    [anon_sym_PERCENT] = ACTIONS(3338),
    [anon_sym_CARET] = ACTIONS(3338),
    [anon_sym_PIPE] = ACTIONS(3338),
    [anon_sym_AMP] = ACTIONS(3338),
    [anon_sym_LT_LT] = ACTIONS(3338),
    [anon_sym_GT_GT] = ACTIONS(3338),
    [anon_sym_EQ_EQ] = ACTIONS(3336),
    [anon_sym_BANG_EQ] = ACTIONS(3336),
    [anon_sym_GT_EQ] = ACTIONS(3336),
    [anon_sym_LT_EQ] = ACTIONS(3336),
    [anon_sym_switch] = ACTIONS(3336),
    [anon_sym_and] = ACTIONS(3336),
    [anon_sym_or] = ACTIONS(3338),
    [anon_sym_PLUS_EQ] = ACTIONS(3336),
    [anon_sym_DASH_EQ] = ACTIONS(3336),
    [anon_sym_STAR_EQ] = ACTIONS(3336),
    [anon_sym_SLASH_EQ] = ACTIONS(3336),
    [anon_sym_PERCENT_EQ] = ACTIONS(3336),
    [anon_sym_AMP_EQ] = ACTIONS(3336),
    [anon_sym_CARET_EQ] = ACTIONS(3336),
    [anon_sym_PIPE_EQ] = ACTIONS(3336),
    [anon_sym_LT_LT_EQ] = ACTIONS(3336),
    [anon_sym_GT_GT_EQ] = ACTIONS(3336),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3336),
    [anon_sym_is] = ACTIONS(3336),
    [anon_sym_DASH_GT] = ACTIONS(3336),
    [anon_sym_from] = ACTIONS(3336),
    [anon_sym_join] = ACTIONS(3336),
    [anon_sym_on] = ACTIONS(3336),
    [anon_sym_equals] = ACTIONS(3336),
    [anon_sym_let] = ACTIONS(3336),
    [anon_sym_orderby] = ACTIONS(3336),
    [anon_sym_group] = ACTIONS(3336),
    [anon_sym_by] = ACTIONS(3336),
    [anon_sym_select] = ACTIONS(3336),
    [anon_sym_DOT_DOT] = ACTIONS(3336),
    [anon_sym_with] = ACTIONS(3336),
    [anon_sym_AMP_AMP] = ACTIONS(3336),
    [anon_sym_PIPE_PIPE] = ACTIONS(3336),
    [anon_sym_QMARK_QMARK] = ACTIONS(3338),
    [anon_sym_as] = ACTIONS(3336),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2268] = {
    [sym__preprocessor_call] = STATE(2268),
    [anon_sym_SEMI] = ACTIONS(3406),
    [anon_sym_EQ] = ACTIONS(3408),
    [anon_sym_LT] = ACTIONS(3408),
    [anon_sym_COMMA] = ACTIONS(3406),
    [anon_sym_GT] = ACTIONS(3408),
    [anon_sym_DOT] = ACTIONS(3408),
    [anon_sym_LBRACK] = ACTIONS(3406),
    [anon_sym_RBRACK] = ACTIONS(3406),
    [anon_sym_COLON] = ACTIONS(3406),
    [anon_sym_LPAREN] = ACTIONS(3406),
    [anon_sym_RPAREN] = ACTIONS(3406),
    [anon_sym_in] = ACTIONS(3406),
    [anon_sym_RBRACE] = ACTIONS(3406),
    [anon_sym_EQ_GT] = ACTIONS(3406),
    [anon_sym_where] = ACTIONS(3406),
    [anon_sym_QMARK] = ACTIONS(3408),
    [anon_sym_BANG] = ACTIONS(3408),
    [anon_sym_PLUS_PLUS] = ACTIONS(3406),
    [anon_sym_DASH_DASH] = ACTIONS(3406),
    [anon_sym_PLUS] = ACTIONS(3408),
    [anon_sym_DASH] = ACTIONS(3408),
    [anon_sym_STAR] = ACTIONS(3408),
    [anon_sym_SLASH] = ACTIONS(3408),
    [anon_sym_PERCENT] = ACTIONS(3408),
    [anon_sym_CARET] = ACTIONS(3408),
    [anon_sym_PIPE] = ACTIONS(3408),
    [anon_sym_AMP] = ACTIONS(3408),
    [anon_sym_LT_LT] = ACTIONS(3408),
    [anon_sym_GT_GT] = ACTIONS(3408),
    [anon_sym_EQ_EQ] = ACTIONS(3406),
    [anon_sym_BANG_EQ] = ACTIONS(3406),
    [anon_sym_GT_EQ] = ACTIONS(3406),
    [anon_sym_LT_EQ] = ACTIONS(3406),
    [anon_sym_switch] = ACTIONS(3406),
    [anon_sym_and] = ACTIONS(3406),
    [anon_sym_or] = ACTIONS(3408),
    [anon_sym_PLUS_EQ] = ACTIONS(3406),
    [anon_sym_DASH_EQ] = ACTIONS(3406),
    [anon_sym_STAR_EQ] = ACTIONS(3406),
    [anon_sym_SLASH_EQ] = ACTIONS(3406),
    [anon_sym_PERCENT_EQ] = ACTIONS(3406),
    [anon_sym_AMP_EQ] = ACTIONS(3406),
    [anon_sym_CARET_EQ] = ACTIONS(3406),
    [anon_sym_PIPE_EQ] = ACTIONS(3406),
    [anon_sym_LT_LT_EQ] = ACTIONS(3406),
    [anon_sym_GT_GT_EQ] = ACTIONS(3406),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3406),
    [anon_sym_is] = ACTIONS(3406),
    [anon_sym_DASH_GT] = ACTIONS(3406),
    [anon_sym_from] = ACTIONS(3406),
    [anon_sym_join] = ACTIONS(3406),
    [anon_sym_on] = ACTIONS(3406),
    [anon_sym_equals] = ACTIONS(3406),
    [anon_sym_let] = ACTIONS(3406),
    [anon_sym_orderby] = ACTIONS(3406),
    [anon_sym_group] = ACTIONS(3406),
    [anon_sym_by] = ACTIONS(3406),
    [anon_sym_select] = ACTIONS(3406),
    [anon_sym_DOT_DOT] = ACTIONS(3406),
    [anon_sym_with] = ACTIONS(3406),
    [anon_sym_AMP_AMP] = ACTIONS(3406),
    [anon_sym_PIPE_PIPE] = ACTIONS(3406),
    [anon_sym_QMARK_QMARK] = ACTIONS(3408),
    [anon_sym_as] = ACTIONS(3406),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2269] = {
    [sym__preprocessor_call] = STATE(2269),
    [anon_sym_SEMI] = ACTIONS(3478),
    [anon_sym_EQ] = ACTIONS(3480),
    [anon_sym_LT] = ACTIONS(3480),
    [anon_sym_COMMA] = ACTIONS(3478),
    [anon_sym_GT] = ACTIONS(3480),
    [anon_sym_DOT] = ACTIONS(3480),
    [anon_sym_LBRACK] = ACTIONS(3478),
    [anon_sym_RBRACK] = ACTIONS(3478),
    [anon_sym_COLON] = ACTIONS(3478),
    [anon_sym_LPAREN] = ACTIONS(3478),
    [anon_sym_RPAREN] = ACTIONS(3478),
    [anon_sym_in] = ACTIONS(3478),
    [anon_sym_RBRACE] = ACTIONS(3478),
    [anon_sym_EQ_GT] = ACTIONS(3478),
    [anon_sym_where] = ACTIONS(3478),
    [anon_sym_QMARK] = ACTIONS(3480),
    [anon_sym_BANG] = ACTIONS(3480),
    [anon_sym_PLUS_PLUS] = ACTIONS(3478),
    [anon_sym_DASH_DASH] = ACTIONS(3478),
    [anon_sym_PLUS] = ACTIONS(3480),
    [anon_sym_DASH] = ACTIONS(3480),
    [anon_sym_STAR] = ACTIONS(3480),
    [anon_sym_SLASH] = ACTIONS(3480),
    [anon_sym_PERCENT] = ACTIONS(3480),
    [anon_sym_CARET] = ACTIONS(3480),
    [anon_sym_PIPE] = ACTIONS(3480),
    [anon_sym_AMP] = ACTIONS(3480),
    [anon_sym_LT_LT] = ACTIONS(3480),
    [anon_sym_GT_GT] = ACTIONS(3480),
    [anon_sym_EQ_EQ] = ACTIONS(3478),
    [anon_sym_BANG_EQ] = ACTIONS(3478),
    [anon_sym_GT_EQ] = ACTIONS(3478),
    [anon_sym_LT_EQ] = ACTIONS(3478),
    [anon_sym_switch] = ACTIONS(3478),
    [anon_sym_and] = ACTIONS(3478),
    [anon_sym_or] = ACTIONS(3480),
    [anon_sym_PLUS_EQ] = ACTIONS(3478),
    [anon_sym_DASH_EQ] = ACTIONS(3478),
    [anon_sym_STAR_EQ] = ACTIONS(3478),
    [anon_sym_SLASH_EQ] = ACTIONS(3478),
    [anon_sym_PERCENT_EQ] = ACTIONS(3478),
    [anon_sym_AMP_EQ] = ACTIONS(3478),
    [anon_sym_CARET_EQ] = ACTIONS(3478),
    [anon_sym_PIPE_EQ] = ACTIONS(3478),
    [anon_sym_LT_LT_EQ] = ACTIONS(3478),
    [anon_sym_GT_GT_EQ] = ACTIONS(3478),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3478),
    [anon_sym_is] = ACTIONS(3478),
    [anon_sym_DASH_GT] = ACTIONS(3478),
    [anon_sym_from] = ACTIONS(3478),
    [anon_sym_join] = ACTIONS(3478),
    [anon_sym_on] = ACTIONS(3478),
    [anon_sym_equals] = ACTIONS(3478),
    [anon_sym_let] = ACTIONS(3478),
    [anon_sym_orderby] = ACTIONS(3478),
    [anon_sym_group] = ACTIONS(3478),
    [anon_sym_by] = ACTIONS(3478),
    [anon_sym_select] = ACTIONS(3478),
    [anon_sym_DOT_DOT] = ACTIONS(3478),
    [anon_sym_with] = ACTIONS(3478),
    [anon_sym_AMP_AMP] = ACTIONS(3478),
    [anon_sym_PIPE_PIPE] = ACTIONS(3478),
    [anon_sym_QMARK_QMARK] = ACTIONS(3480),
    [anon_sym_as] = ACTIONS(3478),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2270] = {
    [sym_type_argument_list] = STATE(2086),
    [sym__preprocessor_call] = STATE(2270),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(3824),
    [anon_sym_LT] = ACTIONS(3296),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_switch] = ACTIONS(2829),
    [anon_sym_and] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2829),
    [anon_sym_join] = ACTIONS(2829),
    [anon_sym_on] = ACTIONS(2829),
    [anon_sym_equals] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_orderby] = ACTIONS(2829),
    [anon_sym_group] = ACTIONS(2829),
    [anon_sym_by] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2271] = {
    [sym__preprocessor_call] = STATE(2271),
    [sym__identifier_token] = ACTIONS(3826),
    [anon_sym_extern] = ACTIONS(3826),
    [anon_sym_alias] = ACTIONS(3826),
    [anon_sym_SEMI] = ACTIONS(3828),
    [anon_sym_global] = ACTIONS(3826),
    [anon_sym_using] = ACTIONS(3826),
    [anon_sym_static] = ACTIONS(3826),
    [anon_sym_LBRACK] = ACTIONS(3830),
    [anon_sym_event] = ACTIONS(3826),
    [anon_sym_LPAREN] = ACTIONS(3830),
    [anon_sym_abstract] = ACTIONS(3826),
    [anon_sym_async] = ACTIONS(3826),
    [anon_sym_const] = ACTIONS(3826),
    [anon_sym_fixed] = ACTIONS(3826),
    [anon_sym_internal] = ACTIONS(3826),
    [anon_sym_new] = ACTIONS(3826),
    [anon_sym_override] = ACTIONS(3826),
    [anon_sym_partial] = ACTIONS(3826),
    [anon_sym_private] = ACTIONS(3826),
    [anon_sym_protected] = ACTIONS(3826),
    [anon_sym_public] = ACTIONS(3826),
    [anon_sym_readonly] = ACTIONS(3826),
    [anon_sym_ref] = ACTIONS(3826),
    [anon_sym_sealed] = ACTIONS(3826),
    [anon_sym_unsafe] = ACTIONS(3826),
    [anon_sym_virtual] = ACTIONS(3826),
    [anon_sym_volatile] = ACTIONS(3826),
    [anon_sym_RBRACE] = ACTIONS(3830),
    [anon_sym_implicit] = ACTIONS(3826),
    [anon_sym_explicit] = ACTIONS(3826),
    [anon_sym_TILDE] = ACTIONS(3830),
    [anon_sym_where] = ACTIONS(3826),
    [anon_sym_class] = ACTIONS(3826),
    [anon_sym_struct] = ACTIONS(3826),
    [anon_sym_notnull] = ACTIONS(3826),
    [anon_sym_unmanaged] = ACTIONS(3826),
    [anon_sym_get] = ACTIONS(3826),
    [anon_sym_set] = ACTIONS(3826),
    [anon_sym_add] = ACTIONS(3826),
    [anon_sym_remove] = ACTIONS(3826),
    [anon_sym_enum] = ACTIONS(3826),
    [anon_sym_interface] = ACTIONS(3826),
    [anon_sym_delegate] = ACTIONS(3826),
    [anon_sym_record] = ACTIONS(3826),
    [anon_sym_namespace] = ACTIONS(3826),
    [anon_sym_var] = ACTIONS(3826),
    [sym_predefined_type] = ACTIONS(3826),
    [anon_sym_when] = ACTIONS(3826),
    [anon_sym_yield] = ACTIONS(3826),
    [anon_sym_from] = ACTIONS(3826),
    [anon_sym_join] = ACTIONS(3826),
    [anon_sym_on] = ACTIONS(3826),
    [anon_sym_equals] = ACTIONS(3826),
    [anon_sym_into] = ACTIONS(3826),
    [anon_sym_let] = ACTIONS(3826),
    [anon_sym_orderby] = ACTIONS(3826),
    [anon_sym_ascending] = ACTIONS(3826),
    [anon_sym_descending] = ACTIONS(3826),
    [anon_sym_group] = ACTIONS(3826),
    [anon_sym_by] = ACTIONS(3826),
    [anon_sym_select] = ACTIONS(3826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3826),
    [anon_sym_nameof] = ACTIONS(3826),
    [sym_void_keyword] = ACTIONS(3826),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2272] = {
    [sym__preprocessor_call] = STATE(2272),
    [sym__identifier_token] = ACTIONS(3832),
    [anon_sym_extern] = ACTIONS(3832),
    [anon_sym_alias] = ACTIONS(3832),
    [anon_sym_SEMI] = ACTIONS(3834),
    [anon_sym_global] = ACTIONS(3832),
    [anon_sym_using] = ACTIONS(3832),
    [anon_sym_static] = ACTIONS(3832),
    [anon_sym_LBRACK] = ACTIONS(3836),
    [anon_sym_event] = ACTIONS(3832),
    [anon_sym_LPAREN] = ACTIONS(3836),
    [anon_sym_abstract] = ACTIONS(3832),
    [anon_sym_async] = ACTIONS(3832),
    [anon_sym_const] = ACTIONS(3832),
    [anon_sym_fixed] = ACTIONS(3832),
    [anon_sym_internal] = ACTIONS(3832),
    [anon_sym_new] = ACTIONS(3832),
    [anon_sym_override] = ACTIONS(3832),
    [anon_sym_partial] = ACTIONS(3832),
    [anon_sym_private] = ACTIONS(3832),
    [anon_sym_protected] = ACTIONS(3832),
    [anon_sym_public] = ACTIONS(3832),
    [anon_sym_readonly] = ACTIONS(3832),
    [anon_sym_ref] = ACTIONS(3832),
    [anon_sym_sealed] = ACTIONS(3832),
    [anon_sym_unsafe] = ACTIONS(3832),
    [anon_sym_virtual] = ACTIONS(3832),
    [anon_sym_volatile] = ACTIONS(3832),
    [anon_sym_RBRACE] = ACTIONS(3836),
    [anon_sym_implicit] = ACTIONS(3832),
    [anon_sym_explicit] = ACTIONS(3832),
    [anon_sym_TILDE] = ACTIONS(3836),
    [anon_sym_where] = ACTIONS(3832),
    [anon_sym_class] = ACTIONS(3832),
    [anon_sym_struct] = ACTIONS(3832),
    [anon_sym_notnull] = ACTIONS(3832),
    [anon_sym_unmanaged] = ACTIONS(3832),
    [anon_sym_get] = ACTIONS(3832),
    [anon_sym_set] = ACTIONS(3832),
    [anon_sym_add] = ACTIONS(3832),
    [anon_sym_remove] = ACTIONS(3832),
    [anon_sym_enum] = ACTIONS(3832),
    [anon_sym_interface] = ACTIONS(3832),
    [anon_sym_delegate] = ACTIONS(3832),
    [anon_sym_record] = ACTIONS(3832),
    [anon_sym_namespace] = ACTIONS(3832),
    [anon_sym_var] = ACTIONS(3832),
    [sym_predefined_type] = ACTIONS(3832),
    [anon_sym_when] = ACTIONS(3832),
    [anon_sym_yield] = ACTIONS(3832),
    [anon_sym_from] = ACTIONS(3832),
    [anon_sym_join] = ACTIONS(3832),
    [anon_sym_on] = ACTIONS(3832),
    [anon_sym_equals] = ACTIONS(3832),
    [anon_sym_into] = ACTIONS(3832),
    [anon_sym_let] = ACTIONS(3832),
    [anon_sym_orderby] = ACTIONS(3832),
    [anon_sym_ascending] = ACTIONS(3832),
    [anon_sym_descending] = ACTIONS(3832),
    [anon_sym_group] = ACTIONS(3832),
    [anon_sym_by] = ACTIONS(3832),
    [anon_sym_select] = ACTIONS(3832),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3832),
    [anon_sym_nameof] = ACTIONS(3832),
    [sym_void_keyword] = ACTIONS(3832),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2273] = {
    [sym__preprocessor_call] = STATE(2273),
    [sym__identifier_token] = ACTIONS(3838),
    [anon_sym_extern] = ACTIONS(3838),
    [anon_sym_alias] = ACTIONS(3838),
    [anon_sym_SEMI] = ACTIONS(3840),
    [anon_sym_global] = ACTIONS(3838),
    [anon_sym_using] = ACTIONS(3838),
    [anon_sym_static] = ACTIONS(3838),
    [anon_sym_LBRACK] = ACTIONS(3842),
    [anon_sym_event] = ACTIONS(3838),
    [anon_sym_LPAREN] = ACTIONS(3842),
    [anon_sym_abstract] = ACTIONS(3838),
    [anon_sym_async] = ACTIONS(3838),
    [anon_sym_const] = ACTIONS(3838),
    [anon_sym_fixed] = ACTIONS(3838),
    [anon_sym_internal] = ACTIONS(3838),
    [anon_sym_new] = ACTIONS(3838),
    [anon_sym_override] = ACTIONS(3838),
    [anon_sym_partial] = ACTIONS(3838),
    [anon_sym_private] = ACTIONS(3838),
    [anon_sym_protected] = ACTIONS(3838),
    [anon_sym_public] = ACTIONS(3838),
    [anon_sym_readonly] = ACTIONS(3838),
    [anon_sym_ref] = ACTIONS(3838),
    [anon_sym_sealed] = ACTIONS(3838),
    [anon_sym_unsafe] = ACTIONS(3838),
    [anon_sym_virtual] = ACTIONS(3838),
    [anon_sym_volatile] = ACTIONS(3838),
    [anon_sym_RBRACE] = ACTIONS(3842),
    [anon_sym_implicit] = ACTIONS(3838),
    [anon_sym_explicit] = ACTIONS(3838),
    [anon_sym_TILDE] = ACTIONS(3842),
    [anon_sym_where] = ACTIONS(3838),
    [anon_sym_class] = ACTIONS(3838),
    [anon_sym_struct] = ACTIONS(3838),
    [anon_sym_notnull] = ACTIONS(3838),
    [anon_sym_unmanaged] = ACTIONS(3838),
    [anon_sym_get] = ACTIONS(3838),
    [anon_sym_set] = ACTIONS(3838),
    [anon_sym_add] = ACTIONS(3838),
    [anon_sym_remove] = ACTIONS(3838),
    [anon_sym_enum] = ACTIONS(3838),
    [anon_sym_interface] = ACTIONS(3838),
    [anon_sym_delegate] = ACTIONS(3838),
    [anon_sym_record] = ACTIONS(3838),
    [anon_sym_namespace] = ACTIONS(3838),
    [anon_sym_var] = ACTIONS(3838),
    [sym_predefined_type] = ACTIONS(3838),
    [anon_sym_when] = ACTIONS(3838),
    [anon_sym_yield] = ACTIONS(3838),
    [anon_sym_from] = ACTIONS(3838),
    [anon_sym_join] = ACTIONS(3838),
    [anon_sym_on] = ACTIONS(3838),
    [anon_sym_equals] = ACTIONS(3838),
    [anon_sym_into] = ACTIONS(3838),
    [anon_sym_let] = ACTIONS(3838),
    [anon_sym_orderby] = ACTIONS(3838),
    [anon_sym_ascending] = ACTIONS(3838),
    [anon_sym_descending] = ACTIONS(3838),
    [anon_sym_group] = ACTIONS(3838),
    [anon_sym_by] = ACTIONS(3838),
    [anon_sym_select] = ACTIONS(3838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3838),
    [anon_sym_nameof] = ACTIONS(3838),
    [sym_void_keyword] = ACTIONS(3838),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2274] = {
    [sym__preprocessor_call] = STATE(2274),
    [sym__identifier_token] = ACTIONS(3844),
    [anon_sym_extern] = ACTIONS(3844),
    [anon_sym_alias] = ACTIONS(3844),
    [anon_sym_SEMI] = ACTIONS(3846),
    [anon_sym_global] = ACTIONS(3844),
    [anon_sym_using] = ACTIONS(3844),
    [anon_sym_static] = ACTIONS(3844),
    [anon_sym_LBRACK] = ACTIONS(3848),
    [anon_sym_event] = ACTIONS(3844),
    [anon_sym_LPAREN] = ACTIONS(3848),
    [anon_sym_abstract] = ACTIONS(3844),
    [anon_sym_async] = ACTIONS(3844),
    [anon_sym_const] = ACTIONS(3844),
    [anon_sym_fixed] = ACTIONS(3844),
    [anon_sym_internal] = ACTIONS(3844),
    [anon_sym_new] = ACTIONS(3844),
    [anon_sym_override] = ACTIONS(3844),
    [anon_sym_partial] = ACTIONS(3844),
    [anon_sym_private] = ACTIONS(3844),
    [anon_sym_protected] = ACTIONS(3844),
    [anon_sym_public] = ACTIONS(3844),
    [anon_sym_readonly] = ACTIONS(3844),
    [anon_sym_ref] = ACTIONS(3844),
    [anon_sym_sealed] = ACTIONS(3844),
    [anon_sym_unsafe] = ACTIONS(3844),
    [anon_sym_virtual] = ACTIONS(3844),
    [anon_sym_volatile] = ACTIONS(3844),
    [anon_sym_RBRACE] = ACTIONS(3848),
    [anon_sym_implicit] = ACTIONS(3844),
    [anon_sym_explicit] = ACTIONS(3844),
    [anon_sym_TILDE] = ACTIONS(3848),
    [anon_sym_where] = ACTIONS(3844),
    [anon_sym_class] = ACTIONS(3844),
    [anon_sym_struct] = ACTIONS(3844),
    [anon_sym_notnull] = ACTIONS(3844),
    [anon_sym_unmanaged] = ACTIONS(3844),
    [anon_sym_get] = ACTIONS(3844),
    [anon_sym_set] = ACTIONS(3844),
    [anon_sym_add] = ACTIONS(3844),
    [anon_sym_remove] = ACTIONS(3844),
    [anon_sym_enum] = ACTIONS(3844),
    [anon_sym_interface] = ACTIONS(3844),
    [anon_sym_delegate] = ACTIONS(3844),
    [anon_sym_record] = ACTIONS(3844),
    [anon_sym_namespace] = ACTIONS(3844),
    [anon_sym_var] = ACTIONS(3844),
    [sym_predefined_type] = ACTIONS(3844),
    [anon_sym_when] = ACTIONS(3844),
    [anon_sym_yield] = ACTIONS(3844),
    [anon_sym_from] = ACTIONS(3844),
    [anon_sym_join] = ACTIONS(3844),
    [anon_sym_on] = ACTIONS(3844),
    [anon_sym_equals] = ACTIONS(3844),
    [anon_sym_into] = ACTIONS(3844),
    [anon_sym_let] = ACTIONS(3844),
    [anon_sym_orderby] = ACTIONS(3844),
    [anon_sym_ascending] = ACTIONS(3844),
    [anon_sym_descending] = ACTIONS(3844),
    [anon_sym_group] = ACTIONS(3844),
    [anon_sym_by] = ACTIONS(3844),
    [anon_sym_select] = ACTIONS(3844),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3844),
    [anon_sym_nameof] = ACTIONS(3844),
    [sym_void_keyword] = ACTIONS(3844),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2275] = {
    [sym__preprocessor_call] = STATE(2275),
    [sym__identifier_token] = ACTIONS(3850),
    [anon_sym_extern] = ACTIONS(3850),
    [anon_sym_alias] = ACTIONS(3850),
    [anon_sym_SEMI] = ACTIONS(3852),
    [anon_sym_global] = ACTIONS(3850),
    [anon_sym_using] = ACTIONS(3850),
    [anon_sym_static] = ACTIONS(3850),
    [anon_sym_LBRACK] = ACTIONS(3854),
    [anon_sym_event] = ACTIONS(3850),
    [anon_sym_LPAREN] = ACTIONS(3854),
    [anon_sym_abstract] = ACTIONS(3850),
    [anon_sym_async] = ACTIONS(3850),
    [anon_sym_const] = ACTIONS(3850),
    [anon_sym_fixed] = ACTIONS(3850),
    [anon_sym_internal] = ACTIONS(3850),
    [anon_sym_new] = ACTIONS(3850),
    [anon_sym_override] = ACTIONS(3850),
    [anon_sym_partial] = ACTIONS(3850),
    [anon_sym_private] = ACTIONS(3850),
    [anon_sym_protected] = ACTIONS(3850),
    [anon_sym_public] = ACTIONS(3850),
    [anon_sym_readonly] = ACTIONS(3850),
    [anon_sym_ref] = ACTIONS(3850),
    [anon_sym_sealed] = ACTIONS(3850),
    [anon_sym_unsafe] = ACTIONS(3850),
    [anon_sym_virtual] = ACTIONS(3850),
    [anon_sym_volatile] = ACTIONS(3850),
    [anon_sym_RBRACE] = ACTIONS(3854),
    [anon_sym_implicit] = ACTIONS(3850),
    [anon_sym_explicit] = ACTIONS(3850),
    [anon_sym_TILDE] = ACTIONS(3854),
    [anon_sym_where] = ACTIONS(3850),
    [anon_sym_class] = ACTIONS(3850),
    [anon_sym_struct] = ACTIONS(3850),
    [anon_sym_notnull] = ACTIONS(3850),
    [anon_sym_unmanaged] = ACTIONS(3850),
    [anon_sym_get] = ACTIONS(3850),
    [anon_sym_set] = ACTIONS(3850),
    [anon_sym_add] = ACTIONS(3850),
    [anon_sym_remove] = ACTIONS(3850),
    [anon_sym_enum] = ACTIONS(3850),
    [anon_sym_interface] = ACTIONS(3850),
    [anon_sym_delegate] = ACTIONS(3850),
    [anon_sym_record] = ACTIONS(3850),
    [anon_sym_namespace] = ACTIONS(3850),
    [anon_sym_var] = ACTIONS(3850),
    [sym_predefined_type] = ACTIONS(3850),
    [anon_sym_when] = ACTIONS(3850),
    [anon_sym_yield] = ACTIONS(3850),
    [anon_sym_from] = ACTIONS(3850),
    [anon_sym_join] = ACTIONS(3850),
    [anon_sym_on] = ACTIONS(3850),
    [anon_sym_equals] = ACTIONS(3850),
    [anon_sym_into] = ACTIONS(3850),
    [anon_sym_let] = ACTIONS(3850),
    [anon_sym_orderby] = ACTIONS(3850),
    [anon_sym_ascending] = ACTIONS(3850),
    [anon_sym_descending] = ACTIONS(3850),
    [anon_sym_group] = ACTIONS(3850),
    [anon_sym_by] = ACTIONS(3850),
    [anon_sym_select] = ACTIONS(3850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3850),
    [anon_sym_nameof] = ACTIONS(3850),
    [sym_void_keyword] = ACTIONS(3850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2276] = {
    [sym__preprocessor_call] = STATE(2276),
    [anon_sym_SEMI] = ACTIONS(3430),
    [anon_sym_EQ] = ACTIONS(3432),
    [anon_sym_LT] = ACTIONS(3432),
    [anon_sym_COMMA] = ACTIONS(3430),
    [anon_sym_GT] = ACTIONS(3432),
    [anon_sym_DOT] = ACTIONS(3432),
    [anon_sym_LBRACK] = ACTIONS(3430),
    [anon_sym_RBRACK] = ACTIONS(3430),
    [anon_sym_COLON] = ACTIONS(3430),
    [anon_sym_LPAREN] = ACTIONS(3430),
    [anon_sym_RPAREN] = ACTIONS(3430),
    [anon_sym_in] = ACTIONS(3430),
    [anon_sym_RBRACE] = ACTIONS(3430),
    [anon_sym_EQ_GT] = ACTIONS(3430),
    [anon_sym_where] = ACTIONS(3430),
    [anon_sym_QMARK] = ACTIONS(3432),
    [anon_sym_BANG] = ACTIONS(3432),
    [anon_sym_PLUS_PLUS] = ACTIONS(3430),
    [anon_sym_DASH_DASH] = ACTIONS(3430),
    [anon_sym_PLUS] = ACTIONS(3432),
    [anon_sym_DASH] = ACTIONS(3432),
    [anon_sym_STAR] = ACTIONS(3432),
    [anon_sym_SLASH] = ACTIONS(3432),
    [anon_sym_PERCENT] = ACTIONS(3432),
    [anon_sym_CARET] = ACTIONS(3432),
    [anon_sym_PIPE] = ACTIONS(3432),
    [anon_sym_AMP] = ACTIONS(3432),
    [anon_sym_LT_LT] = ACTIONS(3432),
    [anon_sym_GT_GT] = ACTIONS(3432),
    [anon_sym_EQ_EQ] = ACTIONS(3430),
    [anon_sym_BANG_EQ] = ACTIONS(3430),
    [anon_sym_GT_EQ] = ACTIONS(3430),
    [anon_sym_LT_EQ] = ACTIONS(3430),
    [anon_sym_switch] = ACTIONS(3430),
    [anon_sym_and] = ACTIONS(3430),
    [anon_sym_or] = ACTIONS(3432),
    [anon_sym_PLUS_EQ] = ACTIONS(3430),
    [anon_sym_DASH_EQ] = ACTIONS(3430),
    [anon_sym_STAR_EQ] = ACTIONS(3430),
    [anon_sym_SLASH_EQ] = ACTIONS(3430),
    [anon_sym_PERCENT_EQ] = ACTIONS(3430),
    [anon_sym_AMP_EQ] = ACTIONS(3430),
    [anon_sym_CARET_EQ] = ACTIONS(3430),
    [anon_sym_PIPE_EQ] = ACTIONS(3430),
    [anon_sym_LT_LT_EQ] = ACTIONS(3430),
    [anon_sym_GT_GT_EQ] = ACTIONS(3430),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3430),
    [anon_sym_is] = ACTIONS(3430),
    [anon_sym_DASH_GT] = ACTIONS(3430),
    [anon_sym_from] = ACTIONS(3430),
    [anon_sym_join] = ACTIONS(3430),
    [anon_sym_on] = ACTIONS(3430),
    [anon_sym_equals] = ACTIONS(3430),
    [anon_sym_let] = ACTIONS(3430),
    [anon_sym_orderby] = ACTIONS(3430),
    [anon_sym_group] = ACTIONS(3430),
    [anon_sym_by] = ACTIONS(3430),
    [anon_sym_select] = ACTIONS(3430),
    [anon_sym_DOT_DOT] = ACTIONS(3430),
    [anon_sym_with] = ACTIONS(3430),
    [anon_sym_AMP_AMP] = ACTIONS(3430),
    [anon_sym_PIPE_PIPE] = ACTIONS(3430),
    [anon_sym_QMARK_QMARK] = ACTIONS(3432),
    [anon_sym_as] = ACTIONS(3430),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2277] = {
    [sym__preprocessor_call] = STATE(2277),
    [sym__identifier_token] = ACTIONS(3856),
    [anon_sym_extern] = ACTIONS(3856),
    [anon_sym_alias] = ACTIONS(3856),
    [anon_sym_SEMI] = ACTIONS(3858),
    [anon_sym_global] = ACTIONS(3856),
    [anon_sym_using] = ACTIONS(3856),
    [anon_sym_static] = ACTIONS(3856),
    [anon_sym_LBRACK] = ACTIONS(3860),
    [anon_sym_event] = ACTIONS(3856),
    [anon_sym_LPAREN] = ACTIONS(3860),
    [anon_sym_abstract] = ACTIONS(3856),
    [anon_sym_async] = ACTIONS(3856),
    [anon_sym_const] = ACTIONS(3856),
    [anon_sym_fixed] = ACTIONS(3856),
    [anon_sym_internal] = ACTIONS(3856),
    [anon_sym_new] = ACTIONS(3856),
    [anon_sym_override] = ACTIONS(3856),
    [anon_sym_partial] = ACTIONS(3856),
    [anon_sym_private] = ACTIONS(3856),
    [anon_sym_protected] = ACTIONS(3856),
    [anon_sym_public] = ACTIONS(3856),
    [anon_sym_readonly] = ACTIONS(3856),
    [anon_sym_ref] = ACTIONS(3856),
    [anon_sym_sealed] = ACTIONS(3856),
    [anon_sym_unsafe] = ACTIONS(3856),
    [anon_sym_virtual] = ACTIONS(3856),
    [anon_sym_volatile] = ACTIONS(3856),
    [anon_sym_RBRACE] = ACTIONS(3860),
    [anon_sym_implicit] = ACTIONS(3856),
    [anon_sym_explicit] = ACTIONS(3856),
    [anon_sym_TILDE] = ACTIONS(3860),
    [anon_sym_where] = ACTIONS(3856),
    [anon_sym_class] = ACTIONS(3856),
    [anon_sym_struct] = ACTIONS(3856),
    [anon_sym_notnull] = ACTIONS(3856),
    [anon_sym_unmanaged] = ACTIONS(3856),
    [anon_sym_get] = ACTIONS(3856),
    [anon_sym_set] = ACTIONS(3856),
    [anon_sym_add] = ACTIONS(3856),
    [anon_sym_remove] = ACTIONS(3856),
    [anon_sym_enum] = ACTIONS(3856),
    [anon_sym_interface] = ACTIONS(3856),
    [anon_sym_delegate] = ACTIONS(3856),
    [anon_sym_record] = ACTIONS(3856),
    [anon_sym_namespace] = ACTIONS(3856),
    [anon_sym_var] = ACTIONS(3856),
    [sym_predefined_type] = ACTIONS(3856),
    [anon_sym_when] = ACTIONS(3856),
    [anon_sym_yield] = ACTIONS(3856),
    [anon_sym_from] = ACTIONS(3856),
    [anon_sym_join] = ACTIONS(3856),
    [anon_sym_on] = ACTIONS(3856),
    [anon_sym_equals] = ACTIONS(3856),
    [anon_sym_into] = ACTIONS(3856),
    [anon_sym_let] = ACTIONS(3856),
    [anon_sym_orderby] = ACTIONS(3856),
    [anon_sym_ascending] = ACTIONS(3856),
    [anon_sym_descending] = ACTIONS(3856),
    [anon_sym_group] = ACTIONS(3856),
    [anon_sym_by] = ACTIONS(3856),
    [anon_sym_select] = ACTIONS(3856),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3856),
    [anon_sym_nameof] = ACTIONS(3856),
    [sym_void_keyword] = ACTIONS(3856),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2278] = {
    [sym__preprocessor_call] = STATE(2278),
    [sym__identifier_token] = ACTIONS(3862),
    [anon_sym_extern] = ACTIONS(3862),
    [anon_sym_alias] = ACTIONS(3862),
    [anon_sym_SEMI] = ACTIONS(3864),
    [anon_sym_global] = ACTIONS(3862),
    [anon_sym_using] = ACTIONS(3862),
    [anon_sym_static] = ACTIONS(3862),
    [anon_sym_LBRACK] = ACTIONS(3866),
    [anon_sym_event] = ACTIONS(3862),
    [anon_sym_LPAREN] = ACTIONS(3866),
    [anon_sym_abstract] = ACTIONS(3862),
    [anon_sym_async] = ACTIONS(3862),
    [anon_sym_const] = ACTIONS(3862),
    [anon_sym_fixed] = ACTIONS(3862),
    [anon_sym_internal] = ACTIONS(3862),
    [anon_sym_new] = ACTIONS(3862),
    [anon_sym_override] = ACTIONS(3862),
    [anon_sym_partial] = ACTIONS(3862),
    [anon_sym_private] = ACTIONS(3862),
    [anon_sym_protected] = ACTIONS(3862),
    [anon_sym_public] = ACTIONS(3862),
    [anon_sym_readonly] = ACTIONS(3862),
    [anon_sym_ref] = ACTIONS(3862),
    [anon_sym_sealed] = ACTIONS(3862),
    [anon_sym_unsafe] = ACTIONS(3862),
    [anon_sym_virtual] = ACTIONS(3862),
    [anon_sym_volatile] = ACTIONS(3862),
    [anon_sym_RBRACE] = ACTIONS(3866),
    [anon_sym_implicit] = ACTIONS(3862),
    [anon_sym_explicit] = ACTIONS(3862),
    [anon_sym_TILDE] = ACTIONS(3866),
    [anon_sym_where] = ACTIONS(3862),
    [anon_sym_class] = ACTIONS(3862),
    [anon_sym_struct] = ACTIONS(3862),
    [anon_sym_notnull] = ACTIONS(3862),
    [anon_sym_unmanaged] = ACTIONS(3862),
    [anon_sym_get] = ACTIONS(3862),
    [anon_sym_set] = ACTIONS(3862),
    [anon_sym_add] = ACTIONS(3862),
    [anon_sym_remove] = ACTIONS(3862),
    [anon_sym_enum] = ACTIONS(3862),
    [anon_sym_interface] = ACTIONS(3862),
    [anon_sym_delegate] = ACTIONS(3862),
    [anon_sym_record] = ACTIONS(3862),
    [anon_sym_namespace] = ACTIONS(3862),
    [anon_sym_var] = ACTIONS(3862),
    [sym_predefined_type] = ACTIONS(3862),
    [anon_sym_when] = ACTIONS(3862),
    [anon_sym_yield] = ACTIONS(3862),
    [anon_sym_from] = ACTIONS(3862),
    [anon_sym_join] = ACTIONS(3862),
    [anon_sym_on] = ACTIONS(3862),
    [anon_sym_equals] = ACTIONS(3862),
    [anon_sym_into] = ACTIONS(3862),
    [anon_sym_let] = ACTIONS(3862),
    [anon_sym_orderby] = ACTIONS(3862),
    [anon_sym_ascending] = ACTIONS(3862),
    [anon_sym_descending] = ACTIONS(3862),
    [anon_sym_group] = ACTIONS(3862),
    [anon_sym_by] = ACTIONS(3862),
    [anon_sym_select] = ACTIONS(3862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3862),
    [anon_sym_nameof] = ACTIONS(3862),
    [sym_void_keyword] = ACTIONS(3862),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2279] = {
    [sym__preprocessor_call] = STATE(2279),
    [sym__identifier_token] = ACTIONS(3868),
    [anon_sym_extern] = ACTIONS(3868),
    [anon_sym_alias] = ACTIONS(3868),
    [anon_sym_SEMI] = ACTIONS(3870),
    [anon_sym_global] = ACTIONS(3868),
    [anon_sym_using] = ACTIONS(3868),
    [anon_sym_static] = ACTIONS(3868),
    [anon_sym_LBRACK] = ACTIONS(3872),
    [anon_sym_event] = ACTIONS(3868),
    [anon_sym_LPAREN] = ACTIONS(3872),
    [anon_sym_abstract] = ACTIONS(3868),
    [anon_sym_async] = ACTIONS(3868),
    [anon_sym_const] = ACTIONS(3868),
    [anon_sym_fixed] = ACTIONS(3868),
    [anon_sym_internal] = ACTIONS(3868),
    [anon_sym_new] = ACTIONS(3868),
    [anon_sym_override] = ACTIONS(3868),
    [anon_sym_partial] = ACTIONS(3868),
    [anon_sym_private] = ACTIONS(3868),
    [anon_sym_protected] = ACTIONS(3868),
    [anon_sym_public] = ACTIONS(3868),
    [anon_sym_readonly] = ACTIONS(3868),
    [anon_sym_ref] = ACTIONS(3868),
    [anon_sym_sealed] = ACTIONS(3868),
    [anon_sym_unsafe] = ACTIONS(3868),
    [anon_sym_virtual] = ACTIONS(3868),
    [anon_sym_volatile] = ACTIONS(3868),
    [anon_sym_RBRACE] = ACTIONS(3872),
    [anon_sym_implicit] = ACTIONS(3868),
    [anon_sym_explicit] = ACTIONS(3868),
    [anon_sym_TILDE] = ACTIONS(3872),
    [anon_sym_where] = ACTIONS(3868),
    [anon_sym_class] = ACTIONS(3868),
    [anon_sym_struct] = ACTIONS(3868),
    [anon_sym_notnull] = ACTIONS(3868),
    [anon_sym_unmanaged] = ACTIONS(3868),
    [anon_sym_get] = ACTIONS(3868),
    [anon_sym_set] = ACTIONS(3868),
    [anon_sym_add] = ACTIONS(3868),
    [anon_sym_remove] = ACTIONS(3868),
    [anon_sym_enum] = ACTIONS(3868),
    [anon_sym_interface] = ACTIONS(3868),
    [anon_sym_delegate] = ACTIONS(3868),
    [anon_sym_record] = ACTIONS(3868),
    [anon_sym_namespace] = ACTIONS(3868),
    [anon_sym_var] = ACTIONS(3868),
    [sym_predefined_type] = ACTIONS(3868),
    [anon_sym_when] = ACTIONS(3868),
    [anon_sym_yield] = ACTIONS(3868),
    [anon_sym_from] = ACTIONS(3868),
    [anon_sym_join] = ACTIONS(3868),
    [anon_sym_on] = ACTIONS(3868),
    [anon_sym_equals] = ACTIONS(3868),
    [anon_sym_into] = ACTIONS(3868),
    [anon_sym_let] = ACTIONS(3868),
    [anon_sym_orderby] = ACTIONS(3868),
    [anon_sym_ascending] = ACTIONS(3868),
    [anon_sym_descending] = ACTIONS(3868),
    [anon_sym_group] = ACTIONS(3868),
    [anon_sym_by] = ACTIONS(3868),
    [anon_sym_select] = ACTIONS(3868),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3868),
    [anon_sym_nameof] = ACTIONS(3868),
    [sym_void_keyword] = ACTIONS(3868),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2280] = {
    [sym__preprocessor_call] = STATE(2280),
    [anon_sym_SEMI] = ACTIONS(3518),
    [anon_sym_EQ] = ACTIONS(3520),
    [anon_sym_LT] = ACTIONS(3520),
    [anon_sym_COMMA] = ACTIONS(3518),
    [anon_sym_GT] = ACTIONS(3520),
    [anon_sym_DOT] = ACTIONS(3520),
    [anon_sym_LBRACK] = ACTIONS(3518),
    [anon_sym_RBRACK] = ACTIONS(3518),
    [anon_sym_COLON] = ACTIONS(3518),
    [anon_sym_LPAREN] = ACTIONS(3518),
    [anon_sym_RPAREN] = ACTIONS(3518),
    [anon_sym_in] = ACTIONS(3518),
    [anon_sym_RBRACE] = ACTIONS(3518),
    [anon_sym_EQ_GT] = ACTIONS(3518),
    [anon_sym_where] = ACTIONS(3518),
    [anon_sym_QMARK] = ACTIONS(3520),
    [anon_sym_BANG] = ACTIONS(3520),
    [anon_sym_PLUS_PLUS] = ACTIONS(3518),
    [anon_sym_DASH_DASH] = ACTIONS(3518),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_STAR] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3520),
    [anon_sym_PERCENT] = ACTIONS(3520),
    [anon_sym_CARET] = ACTIONS(3520),
    [anon_sym_PIPE] = ACTIONS(3520),
    [anon_sym_AMP] = ACTIONS(3520),
    [anon_sym_LT_LT] = ACTIONS(3520),
    [anon_sym_GT_GT] = ACTIONS(3520),
    [anon_sym_EQ_EQ] = ACTIONS(3518),
    [anon_sym_BANG_EQ] = ACTIONS(3518),
    [anon_sym_GT_EQ] = ACTIONS(3518),
    [anon_sym_LT_EQ] = ACTIONS(3518),
    [anon_sym_switch] = ACTIONS(3518),
    [anon_sym_and] = ACTIONS(3518),
    [anon_sym_or] = ACTIONS(3520),
    [anon_sym_PLUS_EQ] = ACTIONS(3518),
    [anon_sym_DASH_EQ] = ACTIONS(3518),
    [anon_sym_STAR_EQ] = ACTIONS(3518),
    [anon_sym_SLASH_EQ] = ACTIONS(3518),
    [anon_sym_PERCENT_EQ] = ACTIONS(3518),
    [anon_sym_AMP_EQ] = ACTIONS(3518),
    [anon_sym_CARET_EQ] = ACTIONS(3518),
    [anon_sym_PIPE_EQ] = ACTIONS(3518),
    [anon_sym_LT_LT_EQ] = ACTIONS(3518),
    [anon_sym_GT_GT_EQ] = ACTIONS(3518),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3518),
    [anon_sym_is] = ACTIONS(3518),
    [anon_sym_DASH_GT] = ACTIONS(3518),
    [anon_sym_from] = ACTIONS(3518),
    [anon_sym_join] = ACTIONS(3518),
    [anon_sym_on] = ACTIONS(3518),
    [anon_sym_equals] = ACTIONS(3518),
    [anon_sym_let] = ACTIONS(3518),
    [anon_sym_orderby] = ACTIONS(3518),
    [anon_sym_group] = ACTIONS(3518),
    [anon_sym_by] = ACTIONS(3518),
    [anon_sym_select] = ACTIONS(3518),
    [anon_sym_DOT_DOT] = ACTIONS(3518),
    [anon_sym_with] = ACTIONS(3518),
    [anon_sym_AMP_AMP] = ACTIONS(3518),
    [anon_sym_PIPE_PIPE] = ACTIONS(3518),
    [anon_sym_QMARK_QMARK] = ACTIONS(3520),
    [anon_sym_as] = ACTIONS(3518),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2281] = {
    [sym__preprocessor_call] = STATE(2281),
    [sym__identifier_token] = ACTIONS(3874),
    [anon_sym_extern] = ACTIONS(3874),
    [anon_sym_alias] = ACTIONS(3874),
    [anon_sym_SEMI] = ACTIONS(3876),
    [anon_sym_global] = ACTIONS(3874),
    [anon_sym_using] = ACTIONS(3874),
    [anon_sym_static] = ACTIONS(3874),
    [anon_sym_LBRACK] = ACTIONS(3878),
    [anon_sym_event] = ACTIONS(3874),
    [anon_sym_LPAREN] = ACTIONS(3878),
    [anon_sym_abstract] = ACTIONS(3874),
    [anon_sym_async] = ACTIONS(3874),
    [anon_sym_const] = ACTIONS(3874),
    [anon_sym_fixed] = ACTIONS(3874),
    [anon_sym_internal] = ACTIONS(3874),
    [anon_sym_new] = ACTIONS(3874),
    [anon_sym_override] = ACTIONS(3874),
    [anon_sym_partial] = ACTIONS(3874),
    [anon_sym_private] = ACTIONS(3874),
    [anon_sym_protected] = ACTIONS(3874),
    [anon_sym_public] = ACTIONS(3874),
    [anon_sym_readonly] = ACTIONS(3874),
    [anon_sym_ref] = ACTIONS(3874),
    [anon_sym_sealed] = ACTIONS(3874),
    [anon_sym_unsafe] = ACTIONS(3874),
    [anon_sym_virtual] = ACTIONS(3874),
    [anon_sym_volatile] = ACTIONS(3874),
    [anon_sym_RBRACE] = ACTIONS(3878),
    [anon_sym_implicit] = ACTIONS(3874),
    [anon_sym_explicit] = ACTIONS(3874),
    [anon_sym_TILDE] = ACTIONS(3878),
    [anon_sym_where] = ACTIONS(3874),
    [anon_sym_class] = ACTIONS(3874),
    [anon_sym_struct] = ACTIONS(3874),
    [anon_sym_notnull] = ACTIONS(3874),
    [anon_sym_unmanaged] = ACTIONS(3874),
    [anon_sym_get] = ACTIONS(3874),
    [anon_sym_set] = ACTIONS(3874),
    [anon_sym_add] = ACTIONS(3874),
    [anon_sym_remove] = ACTIONS(3874),
    [anon_sym_enum] = ACTIONS(3874),
    [anon_sym_interface] = ACTIONS(3874),
    [anon_sym_delegate] = ACTIONS(3874),
    [anon_sym_record] = ACTIONS(3874),
    [anon_sym_namespace] = ACTIONS(3874),
    [anon_sym_var] = ACTIONS(3874),
    [sym_predefined_type] = ACTIONS(3874),
    [anon_sym_when] = ACTIONS(3874),
    [anon_sym_yield] = ACTIONS(3874),
    [anon_sym_from] = ACTIONS(3874),
    [anon_sym_join] = ACTIONS(3874),
    [anon_sym_on] = ACTIONS(3874),
    [anon_sym_equals] = ACTIONS(3874),
    [anon_sym_into] = ACTIONS(3874),
    [anon_sym_let] = ACTIONS(3874),
    [anon_sym_orderby] = ACTIONS(3874),
    [anon_sym_ascending] = ACTIONS(3874),
    [anon_sym_descending] = ACTIONS(3874),
    [anon_sym_group] = ACTIONS(3874),
    [anon_sym_by] = ACTIONS(3874),
    [anon_sym_select] = ACTIONS(3874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3874),
    [anon_sym_nameof] = ACTIONS(3874),
    [sym_void_keyword] = ACTIONS(3874),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2282] = {
    [sym__preprocessor_call] = STATE(2282),
    [sym__identifier_token] = ACTIONS(3880),
    [anon_sym_extern] = ACTIONS(3880),
    [anon_sym_alias] = ACTIONS(3880),
    [anon_sym_SEMI] = ACTIONS(3882),
    [anon_sym_global] = ACTIONS(3880),
    [anon_sym_using] = ACTIONS(3880),
    [anon_sym_static] = ACTIONS(3880),
    [anon_sym_LBRACK] = ACTIONS(3882),
    [anon_sym_event] = ACTIONS(3880),
    [anon_sym_LPAREN] = ACTIONS(3882),
    [anon_sym_abstract] = ACTIONS(3880),
    [anon_sym_async] = ACTIONS(3880),
    [anon_sym_const] = ACTIONS(3880),
    [anon_sym_fixed] = ACTIONS(3880),
    [anon_sym_internal] = ACTIONS(3880),
    [anon_sym_new] = ACTIONS(3880),
    [anon_sym_override] = ACTIONS(3880),
    [anon_sym_partial] = ACTIONS(3880),
    [anon_sym_private] = ACTIONS(3880),
    [anon_sym_protected] = ACTIONS(3880),
    [anon_sym_public] = ACTIONS(3880),
    [anon_sym_readonly] = ACTIONS(3880),
    [anon_sym_ref] = ACTIONS(3880),
    [anon_sym_sealed] = ACTIONS(3880),
    [anon_sym_unsafe] = ACTIONS(3880),
    [anon_sym_virtual] = ACTIONS(3880),
    [anon_sym_volatile] = ACTIONS(3880),
    [anon_sym_RBRACE] = ACTIONS(3882),
    [anon_sym_implicit] = ACTIONS(3880),
    [anon_sym_explicit] = ACTIONS(3880),
    [anon_sym_TILDE] = ACTIONS(3882),
    [anon_sym_where] = ACTIONS(3880),
    [anon_sym_class] = ACTIONS(3880),
    [anon_sym_struct] = ACTIONS(3880),
    [anon_sym_notnull] = ACTIONS(3880),
    [anon_sym_unmanaged] = ACTIONS(3880),
    [anon_sym_get] = ACTIONS(3880),
    [anon_sym_set] = ACTIONS(3880),
    [anon_sym_add] = ACTIONS(3880),
    [anon_sym_remove] = ACTIONS(3880),
    [anon_sym_enum] = ACTIONS(3880),
    [anon_sym_interface] = ACTIONS(3880),
    [anon_sym_delegate] = ACTIONS(3880),
    [anon_sym_record] = ACTIONS(3880),
    [anon_sym_namespace] = ACTIONS(3880),
    [anon_sym_var] = ACTIONS(3880),
    [sym_predefined_type] = ACTIONS(3880),
    [anon_sym_when] = ACTIONS(3880),
    [anon_sym_yield] = ACTIONS(3880),
    [anon_sym_from] = ACTIONS(3880),
    [anon_sym_join] = ACTIONS(3880),
    [anon_sym_on] = ACTIONS(3880),
    [anon_sym_equals] = ACTIONS(3880),
    [anon_sym_into] = ACTIONS(3880),
    [anon_sym_let] = ACTIONS(3880),
    [anon_sym_orderby] = ACTIONS(3880),
    [anon_sym_ascending] = ACTIONS(3880),
    [anon_sym_descending] = ACTIONS(3880),
    [anon_sym_group] = ACTIONS(3880),
    [anon_sym_by] = ACTIONS(3880),
    [anon_sym_select] = ACTIONS(3880),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3880),
    [anon_sym_nameof] = ACTIONS(3880),
    [sym_void_keyword] = ACTIONS(3880),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2283] = {
    [sym__preprocessor_call] = STATE(2283),
    [sym__identifier_token] = ACTIONS(3884),
    [anon_sym_extern] = ACTIONS(3884),
    [anon_sym_alias] = ACTIONS(3884),
    [anon_sym_SEMI] = ACTIONS(3886),
    [anon_sym_global] = ACTIONS(3884),
    [anon_sym_using] = ACTIONS(3884),
    [anon_sym_static] = ACTIONS(3884),
    [anon_sym_LBRACK] = ACTIONS(3888),
    [anon_sym_event] = ACTIONS(3884),
    [anon_sym_LPAREN] = ACTIONS(3888),
    [anon_sym_abstract] = ACTIONS(3884),
    [anon_sym_async] = ACTIONS(3884),
    [anon_sym_const] = ACTIONS(3884),
    [anon_sym_fixed] = ACTIONS(3884),
    [anon_sym_internal] = ACTIONS(3884),
    [anon_sym_new] = ACTIONS(3884),
    [anon_sym_override] = ACTIONS(3884),
    [anon_sym_partial] = ACTIONS(3884),
    [anon_sym_private] = ACTIONS(3884),
    [anon_sym_protected] = ACTIONS(3884),
    [anon_sym_public] = ACTIONS(3884),
    [anon_sym_readonly] = ACTIONS(3884),
    [anon_sym_ref] = ACTIONS(3884),
    [anon_sym_sealed] = ACTIONS(3884),
    [anon_sym_unsafe] = ACTIONS(3884),
    [anon_sym_virtual] = ACTIONS(3884),
    [anon_sym_volatile] = ACTIONS(3884),
    [anon_sym_RBRACE] = ACTIONS(3888),
    [anon_sym_implicit] = ACTIONS(3884),
    [anon_sym_explicit] = ACTIONS(3884),
    [anon_sym_TILDE] = ACTIONS(3888),
    [anon_sym_where] = ACTIONS(3884),
    [anon_sym_class] = ACTIONS(3884),
    [anon_sym_struct] = ACTIONS(3884),
    [anon_sym_notnull] = ACTIONS(3884),
    [anon_sym_unmanaged] = ACTIONS(3884),
    [anon_sym_get] = ACTIONS(3884),
    [anon_sym_set] = ACTIONS(3884),
    [anon_sym_add] = ACTIONS(3884),
    [anon_sym_remove] = ACTIONS(3884),
    [anon_sym_enum] = ACTIONS(3884),
    [anon_sym_interface] = ACTIONS(3884),
    [anon_sym_delegate] = ACTIONS(3884),
    [anon_sym_record] = ACTIONS(3884),
    [anon_sym_namespace] = ACTIONS(3884),
    [anon_sym_var] = ACTIONS(3884),
    [sym_predefined_type] = ACTIONS(3884),
    [anon_sym_when] = ACTIONS(3884),
    [anon_sym_yield] = ACTIONS(3884),
    [anon_sym_from] = ACTIONS(3884),
    [anon_sym_join] = ACTIONS(3884),
    [anon_sym_on] = ACTIONS(3884),
    [anon_sym_equals] = ACTIONS(3884),
    [anon_sym_into] = ACTIONS(3884),
    [anon_sym_let] = ACTIONS(3884),
    [anon_sym_orderby] = ACTIONS(3884),
    [anon_sym_ascending] = ACTIONS(3884),
    [anon_sym_descending] = ACTIONS(3884),
    [anon_sym_group] = ACTIONS(3884),
    [anon_sym_by] = ACTIONS(3884),
    [anon_sym_select] = ACTIONS(3884),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3884),
    [anon_sym_nameof] = ACTIONS(3884),
    [sym_void_keyword] = ACTIONS(3884),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2284] = {
    [sym__preprocessor_call] = STATE(2284),
    [anon_sym_SEMI] = ACTIONS(3418),
    [anon_sym_EQ] = ACTIONS(3420),
    [anon_sym_LT] = ACTIONS(3420),
    [anon_sym_COMMA] = ACTIONS(3418),
    [anon_sym_GT] = ACTIONS(3420),
    [anon_sym_DOT] = ACTIONS(3420),
    [anon_sym_LBRACK] = ACTIONS(3418),
    [anon_sym_RBRACK] = ACTIONS(3418),
    [anon_sym_COLON] = ACTIONS(3418),
    [anon_sym_LPAREN] = ACTIONS(3418),
    [anon_sym_RPAREN] = ACTIONS(3418),
    [anon_sym_in] = ACTIONS(3418),
    [anon_sym_RBRACE] = ACTIONS(3418),
    [anon_sym_EQ_GT] = ACTIONS(3418),
    [anon_sym_where] = ACTIONS(3418),
    [anon_sym_QMARK] = ACTIONS(3420),
    [anon_sym_BANG] = ACTIONS(3420),
    [anon_sym_PLUS_PLUS] = ACTIONS(3418),
    [anon_sym_DASH_DASH] = ACTIONS(3418),
    [anon_sym_PLUS] = ACTIONS(3420),
    [anon_sym_DASH] = ACTIONS(3420),
    [anon_sym_STAR] = ACTIONS(3420),
    [anon_sym_SLASH] = ACTIONS(3420),
    [anon_sym_PERCENT] = ACTIONS(3420),
    [anon_sym_CARET] = ACTIONS(3420),
    [anon_sym_PIPE] = ACTIONS(3420),
    [anon_sym_AMP] = ACTIONS(3420),
    [anon_sym_LT_LT] = ACTIONS(3420),
    [anon_sym_GT_GT] = ACTIONS(3420),
    [anon_sym_EQ_EQ] = ACTIONS(3418),
    [anon_sym_BANG_EQ] = ACTIONS(3418),
    [anon_sym_GT_EQ] = ACTIONS(3418),
    [anon_sym_LT_EQ] = ACTIONS(3418),
    [anon_sym_switch] = ACTIONS(3418),
    [anon_sym_and] = ACTIONS(3418),
    [anon_sym_or] = ACTIONS(3420),
    [anon_sym_PLUS_EQ] = ACTIONS(3418),
    [anon_sym_DASH_EQ] = ACTIONS(3418),
    [anon_sym_STAR_EQ] = ACTIONS(3418),
    [anon_sym_SLASH_EQ] = ACTIONS(3418),
    [anon_sym_PERCENT_EQ] = ACTIONS(3418),
    [anon_sym_AMP_EQ] = ACTIONS(3418),
    [anon_sym_CARET_EQ] = ACTIONS(3418),
    [anon_sym_PIPE_EQ] = ACTIONS(3418),
    [anon_sym_LT_LT_EQ] = ACTIONS(3418),
    [anon_sym_GT_GT_EQ] = ACTIONS(3418),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3418),
    [anon_sym_is] = ACTIONS(3418),
    [anon_sym_DASH_GT] = ACTIONS(3418),
    [anon_sym_from] = ACTIONS(3418),
    [anon_sym_join] = ACTIONS(3418),
    [anon_sym_on] = ACTIONS(3418),
    [anon_sym_equals] = ACTIONS(3418),
    [anon_sym_let] = ACTIONS(3418),
    [anon_sym_orderby] = ACTIONS(3418),
    [anon_sym_group] = ACTIONS(3418),
    [anon_sym_by] = ACTIONS(3418),
    [anon_sym_select] = ACTIONS(3418),
    [anon_sym_DOT_DOT] = ACTIONS(3418),
    [anon_sym_with] = ACTIONS(3418),
    [anon_sym_AMP_AMP] = ACTIONS(3418),
    [anon_sym_PIPE_PIPE] = ACTIONS(3418),
    [anon_sym_QMARK_QMARK] = ACTIONS(3420),
    [anon_sym_as] = ACTIONS(3418),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2285] = {
    [sym__preprocessor_call] = STATE(2285),
    [sym__identifier_token] = ACTIONS(3890),
    [anon_sym_extern] = ACTIONS(3890),
    [anon_sym_alias] = ACTIONS(3890),
    [anon_sym_SEMI] = ACTIONS(3892),
    [anon_sym_global] = ACTIONS(3890),
    [anon_sym_using] = ACTIONS(3890),
    [anon_sym_static] = ACTIONS(3890),
    [anon_sym_LBRACK] = ACTIONS(3894),
    [anon_sym_event] = ACTIONS(3890),
    [anon_sym_LPAREN] = ACTIONS(3894),
    [anon_sym_abstract] = ACTIONS(3890),
    [anon_sym_async] = ACTIONS(3890),
    [anon_sym_const] = ACTIONS(3890),
    [anon_sym_fixed] = ACTIONS(3890),
    [anon_sym_internal] = ACTIONS(3890),
    [anon_sym_new] = ACTIONS(3890),
    [anon_sym_override] = ACTIONS(3890),
    [anon_sym_partial] = ACTIONS(3890),
    [anon_sym_private] = ACTIONS(3890),
    [anon_sym_protected] = ACTIONS(3890),
    [anon_sym_public] = ACTIONS(3890),
    [anon_sym_readonly] = ACTIONS(3890),
    [anon_sym_ref] = ACTIONS(3890),
    [anon_sym_sealed] = ACTIONS(3890),
    [anon_sym_unsafe] = ACTIONS(3890),
    [anon_sym_virtual] = ACTIONS(3890),
    [anon_sym_volatile] = ACTIONS(3890),
    [anon_sym_RBRACE] = ACTIONS(3894),
    [anon_sym_implicit] = ACTIONS(3890),
    [anon_sym_explicit] = ACTIONS(3890),
    [anon_sym_TILDE] = ACTIONS(3894),
    [anon_sym_where] = ACTIONS(3890),
    [anon_sym_class] = ACTIONS(3890),
    [anon_sym_struct] = ACTIONS(3890),
    [anon_sym_notnull] = ACTIONS(3890),
    [anon_sym_unmanaged] = ACTIONS(3890),
    [anon_sym_get] = ACTIONS(3890),
    [anon_sym_set] = ACTIONS(3890),
    [anon_sym_add] = ACTIONS(3890),
    [anon_sym_remove] = ACTIONS(3890),
    [anon_sym_enum] = ACTIONS(3890),
    [anon_sym_interface] = ACTIONS(3890),
    [anon_sym_delegate] = ACTIONS(3890),
    [anon_sym_record] = ACTIONS(3890),
    [anon_sym_namespace] = ACTIONS(3890),
    [anon_sym_var] = ACTIONS(3890),
    [sym_predefined_type] = ACTIONS(3890),
    [anon_sym_when] = ACTIONS(3890),
    [anon_sym_yield] = ACTIONS(3890),
    [anon_sym_from] = ACTIONS(3890),
    [anon_sym_join] = ACTIONS(3890),
    [anon_sym_on] = ACTIONS(3890),
    [anon_sym_equals] = ACTIONS(3890),
    [anon_sym_into] = ACTIONS(3890),
    [anon_sym_let] = ACTIONS(3890),
    [anon_sym_orderby] = ACTIONS(3890),
    [anon_sym_ascending] = ACTIONS(3890),
    [anon_sym_descending] = ACTIONS(3890),
    [anon_sym_group] = ACTIONS(3890),
    [anon_sym_by] = ACTIONS(3890),
    [anon_sym_select] = ACTIONS(3890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3890),
    [anon_sym_nameof] = ACTIONS(3890),
    [sym_void_keyword] = ACTIONS(3890),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2286] = {
    [sym__preprocessor_call] = STATE(2286),
    [anon_sym_SEMI] = ACTIONS(3538),
    [anon_sym_EQ] = ACTIONS(3540),
    [anon_sym_LT] = ACTIONS(3540),
    [anon_sym_COMMA] = ACTIONS(3538),
    [anon_sym_GT] = ACTIONS(3540),
    [anon_sym_DOT] = ACTIONS(3540),
    [anon_sym_LBRACK] = ACTIONS(3538),
    [anon_sym_RBRACK] = ACTIONS(3538),
    [anon_sym_COLON] = ACTIONS(3538),
    [anon_sym_LPAREN] = ACTIONS(3538),
    [anon_sym_RPAREN] = ACTIONS(3538),
    [anon_sym_in] = ACTIONS(3538),
    [anon_sym_RBRACE] = ACTIONS(3538),
    [anon_sym_EQ_GT] = ACTIONS(3538),
    [anon_sym_where] = ACTIONS(3538),
    [anon_sym_QMARK] = ACTIONS(3540),
    [anon_sym_BANG] = ACTIONS(3540),
    [anon_sym_PLUS_PLUS] = ACTIONS(3538),
    [anon_sym_DASH_DASH] = ACTIONS(3538),
    [anon_sym_PLUS] = ACTIONS(3540),
    [anon_sym_DASH] = ACTIONS(3540),
    [anon_sym_STAR] = ACTIONS(3540),
    [anon_sym_SLASH] = ACTIONS(3540),
    [anon_sym_PERCENT] = ACTIONS(3540),
    [anon_sym_CARET] = ACTIONS(3540),
    [anon_sym_PIPE] = ACTIONS(3540),
    [anon_sym_AMP] = ACTIONS(3540),
    [anon_sym_LT_LT] = ACTIONS(3540),
    [anon_sym_GT_GT] = ACTIONS(3540),
    [anon_sym_EQ_EQ] = ACTIONS(3538),
    [anon_sym_BANG_EQ] = ACTIONS(3538),
    [anon_sym_GT_EQ] = ACTIONS(3538),
    [anon_sym_LT_EQ] = ACTIONS(3538),
    [anon_sym_switch] = ACTIONS(3538),
    [anon_sym_and] = ACTIONS(3538),
    [anon_sym_or] = ACTIONS(3540),
    [anon_sym_PLUS_EQ] = ACTIONS(3538),
    [anon_sym_DASH_EQ] = ACTIONS(3538),
    [anon_sym_STAR_EQ] = ACTIONS(3538),
    [anon_sym_SLASH_EQ] = ACTIONS(3538),
    [anon_sym_PERCENT_EQ] = ACTIONS(3538),
    [anon_sym_AMP_EQ] = ACTIONS(3538),
    [anon_sym_CARET_EQ] = ACTIONS(3538),
    [anon_sym_PIPE_EQ] = ACTIONS(3538),
    [anon_sym_LT_LT_EQ] = ACTIONS(3538),
    [anon_sym_GT_GT_EQ] = ACTIONS(3538),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3538),
    [anon_sym_is] = ACTIONS(3538),
    [anon_sym_DASH_GT] = ACTIONS(3538),
    [anon_sym_from] = ACTIONS(3538),
    [anon_sym_join] = ACTIONS(3538),
    [anon_sym_on] = ACTIONS(3538),
    [anon_sym_equals] = ACTIONS(3538),
    [anon_sym_let] = ACTIONS(3538),
    [anon_sym_orderby] = ACTIONS(3538),
    [anon_sym_group] = ACTIONS(3538),
    [anon_sym_by] = ACTIONS(3538),
    [anon_sym_select] = ACTIONS(3538),
    [anon_sym_DOT_DOT] = ACTIONS(3538),
    [anon_sym_with] = ACTIONS(3538),
    [anon_sym_AMP_AMP] = ACTIONS(3538),
    [anon_sym_PIPE_PIPE] = ACTIONS(3538),
    [anon_sym_QMARK_QMARK] = ACTIONS(3540),
    [anon_sym_as] = ACTIONS(3538),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2287] = {
    [sym__preprocessor_call] = STATE(2287),
    [sym__identifier_token] = ACTIONS(3896),
    [anon_sym_extern] = ACTIONS(3896),
    [anon_sym_alias] = ACTIONS(3896),
    [anon_sym_SEMI] = ACTIONS(3898),
    [anon_sym_global] = ACTIONS(3896),
    [anon_sym_using] = ACTIONS(3896),
    [anon_sym_static] = ACTIONS(3896),
    [anon_sym_LBRACK] = ACTIONS(3900),
    [anon_sym_event] = ACTIONS(3896),
    [anon_sym_LPAREN] = ACTIONS(3900),
    [anon_sym_abstract] = ACTIONS(3896),
    [anon_sym_async] = ACTIONS(3896),
    [anon_sym_const] = ACTIONS(3896),
    [anon_sym_fixed] = ACTIONS(3896),
    [anon_sym_internal] = ACTIONS(3896),
    [anon_sym_new] = ACTIONS(3896),
    [anon_sym_override] = ACTIONS(3896),
    [anon_sym_partial] = ACTIONS(3896),
    [anon_sym_private] = ACTIONS(3896),
    [anon_sym_protected] = ACTIONS(3896),
    [anon_sym_public] = ACTIONS(3896),
    [anon_sym_readonly] = ACTIONS(3896),
    [anon_sym_ref] = ACTIONS(3896),
    [anon_sym_sealed] = ACTIONS(3896),
    [anon_sym_unsafe] = ACTIONS(3896),
    [anon_sym_virtual] = ACTIONS(3896),
    [anon_sym_volatile] = ACTIONS(3896),
    [anon_sym_RBRACE] = ACTIONS(3900),
    [anon_sym_implicit] = ACTIONS(3896),
    [anon_sym_explicit] = ACTIONS(3896),
    [anon_sym_TILDE] = ACTIONS(3900),
    [anon_sym_where] = ACTIONS(3896),
    [anon_sym_class] = ACTIONS(3896),
    [anon_sym_struct] = ACTIONS(3896),
    [anon_sym_notnull] = ACTIONS(3896),
    [anon_sym_unmanaged] = ACTIONS(3896),
    [anon_sym_get] = ACTIONS(3896),
    [anon_sym_set] = ACTIONS(3896),
    [anon_sym_add] = ACTIONS(3896),
    [anon_sym_remove] = ACTIONS(3896),
    [anon_sym_enum] = ACTIONS(3896),
    [anon_sym_interface] = ACTIONS(3896),
    [anon_sym_delegate] = ACTIONS(3896),
    [anon_sym_record] = ACTIONS(3896),
    [anon_sym_namespace] = ACTIONS(3896),
    [anon_sym_var] = ACTIONS(3896),
    [sym_predefined_type] = ACTIONS(3896),
    [anon_sym_when] = ACTIONS(3896),
    [anon_sym_yield] = ACTIONS(3896),
    [anon_sym_from] = ACTIONS(3896),
    [anon_sym_join] = ACTIONS(3896),
    [anon_sym_on] = ACTIONS(3896),
    [anon_sym_equals] = ACTIONS(3896),
    [anon_sym_into] = ACTIONS(3896),
    [anon_sym_let] = ACTIONS(3896),
    [anon_sym_orderby] = ACTIONS(3896),
    [anon_sym_ascending] = ACTIONS(3896),
    [anon_sym_descending] = ACTIONS(3896),
    [anon_sym_group] = ACTIONS(3896),
    [anon_sym_by] = ACTIONS(3896),
    [anon_sym_select] = ACTIONS(3896),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3896),
    [anon_sym_nameof] = ACTIONS(3896),
    [sym_void_keyword] = ACTIONS(3896),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2288] = {
    [sym__preprocessor_call] = STATE(2288),
    [sym__identifier_token] = ACTIONS(3902),
    [anon_sym_extern] = ACTIONS(3902),
    [anon_sym_alias] = ACTIONS(3902),
    [anon_sym_SEMI] = ACTIONS(3904),
    [anon_sym_global] = ACTIONS(3902),
    [anon_sym_using] = ACTIONS(3902),
    [anon_sym_static] = ACTIONS(3902),
    [anon_sym_LBRACK] = ACTIONS(3906),
    [anon_sym_event] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(3906),
    [anon_sym_abstract] = ACTIONS(3902),
    [anon_sym_async] = ACTIONS(3902),
    [anon_sym_const] = ACTIONS(3902),
    [anon_sym_fixed] = ACTIONS(3902),
    [anon_sym_internal] = ACTIONS(3902),
    [anon_sym_new] = ACTIONS(3902),
    [anon_sym_override] = ACTIONS(3902),
    [anon_sym_partial] = ACTIONS(3902),
    [anon_sym_private] = ACTIONS(3902),
    [anon_sym_protected] = ACTIONS(3902),
    [anon_sym_public] = ACTIONS(3902),
    [anon_sym_readonly] = ACTIONS(3902),
    [anon_sym_ref] = ACTIONS(3902),
    [anon_sym_sealed] = ACTIONS(3902),
    [anon_sym_unsafe] = ACTIONS(3902),
    [anon_sym_virtual] = ACTIONS(3902),
    [anon_sym_volatile] = ACTIONS(3902),
    [anon_sym_RBRACE] = ACTIONS(3906),
    [anon_sym_implicit] = ACTIONS(3902),
    [anon_sym_explicit] = ACTIONS(3902),
    [anon_sym_TILDE] = ACTIONS(3906),
    [anon_sym_where] = ACTIONS(3902),
    [anon_sym_class] = ACTIONS(3902),
    [anon_sym_struct] = ACTIONS(3902),
    [anon_sym_notnull] = ACTIONS(3902),
    [anon_sym_unmanaged] = ACTIONS(3902),
    [anon_sym_get] = ACTIONS(3902),
    [anon_sym_set] = ACTIONS(3902),
    [anon_sym_add] = ACTIONS(3902),
    [anon_sym_remove] = ACTIONS(3902),
    [anon_sym_enum] = ACTIONS(3902),
    [anon_sym_interface] = ACTIONS(3902),
    [anon_sym_delegate] = ACTIONS(3902),
    [anon_sym_record] = ACTIONS(3902),
    [anon_sym_namespace] = ACTIONS(3902),
    [anon_sym_var] = ACTIONS(3902),
    [sym_predefined_type] = ACTIONS(3902),
    [anon_sym_when] = ACTIONS(3902),
    [anon_sym_yield] = ACTIONS(3902),
    [anon_sym_from] = ACTIONS(3902),
    [anon_sym_join] = ACTIONS(3902),
    [anon_sym_on] = ACTIONS(3902),
    [anon_sym_equals] = ACTIONS(3902),
    [anon_sym_into] = ACTIONS(3902),
    [anon_sym_let] = ACTIONS(3902),
    [anon_sym_orderby] = ACTIONS(3902),
    [anon_sym_ascending] = ACTIONS(3902),
    [anon_sym_descending] = ACTIONS(3902),
    [anon_sym_group] = ACTIONS(3902),
    [anon_sym_by] = ACTIONS(3902),
    [anon_sym_select] = ACTIONS(3902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3902),
    [anon_sym_nameof] = ACTIONS(3902),
    [sym_void_keyword] = ACTIONS(3902),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2289] = {
    [sym__preprocessor_call] = STATE(2289),
    [sym__identifier_token] = ACTIONS(3908),
    [anon_sym_extern] = ACTIONS(3908),
    [anon_sym_alias] = ACTIONS(3908),
    [anon_sym_SEMI] = ACTIONS(3910),
    [anon_sym_global] = ACTIONS(3908),
    [anon_sym_using] = ACTIONS(3908),
    [anon_sym_static] = ACTIONS(3908),
    [anon_sym_LBRACK] = ACTIONS(3912),
    [anon_sym_event] = ACTIONS(3908),
    [anon_sym_LPAREN] = ACTIONS(3912),
    [anon_sym_abstract] = ACTIONS(3908),
    [anon_sym_async] = ACTIONS(3908),
    [anon_sym_const] = ACTIONS(3908),
    [anon_sym_fixed] = ACTIONS(3908),
    [anon_sym_internal] = ACTIONS(3908),
    [anon_sym_new] = ACTIONS(3908),
    [anon_sym_override] = ACTIONS(3908),
    [anon_sym_partial] = ACTIONS(3908),
    [anon_sym_private] = ACTIONS(3908),
    [anon_sym_protected] = ACTIONS(3908),
    [anon_sym_public] = ACTIONS(3908),
    [anon_sym_readonly] = ACTIONS(3908),
    [anon_sym_ref] = ACTIONS(3908),
    [anon_sym_sealed] = ACTIONS(3908),
    [anon_sym_unsafe] = ACTIONS(3908),
    [anon_sym_virtual] = ACTIONS(3908),
    [anon_sym_volatile] = ACTIONS(3908),
    [anon_sym_RBRACE] = ACTIONS(3912),
    [anon_sym_implicit] = ACTIONS(3908),
    [anon_sym_explicit] = ACTIONS(3908),
    [anon_sym_TILDE] = ACTIONS(3912),
    [anon_sym_where] = ACTIONS(3908),
    [anon_sym_class] = ACTIONS(3908),
    [anon_sym_struct] = ACTIONS(3908),
    [anon_sym_notnull] = ACTIONS(3908),
    [anon_sym_unmanaged] = ACTIONS(3908),
    [anon_sym_get] = ACTIONS(3908),
    [anon_sym_set] = ACTIONS(3908),
    [anon_sym_add] = ACTIONS(3908),
    [anon_sym_remove] = ACTIONS(3908),
    [anon_sym_enum] = ACTIONS(3908),
    [anon_sym_interface] = ACTIONS(3908),
    [anon_sym_delegate] = ACTIONS(3908),
    [anon_sym_record] = ACTIONS(3908),
    [anon_sym_namespace] = ACTIONS(3908),
    [anon_sym_var] = ACTIONS(3908),
    [sym_predefined_type] = ACTIONS(3908),
    [anon_sym_when] = ACTIONS(3908),
    [anon_sym_yield] = ACTIONS(3908),
    [anon_sym_from] = ACTIONS(3908),
    [anon_sym_join] = ACTIONS(3908),
    [anon_sym_on] = ACTIONS(3908),
    [anon_sym_equals] = ACTIONS(3908),
    [anon_sym_into] = ACTIONS(3908),
    [anon_sym_let] = ACTIONS(3908),
    [anon_sym_orderby] = ACTIONS(3908),
    [anon_sym_ascending] = ACTIONS(3908),
    [anon_sym_descending] = ACTIONS(3908),
    [anon_sym_group] = ACTIONS(3908),
    [anon_sym_by] = ACTIONS(3908),
    [anon_sym_select] = ACTIONS(3908),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3908),
    [anon_sym_nameof] = ACTIONS(3908),
    [sym_void_keyword] = ACTIONS(3908),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2290] = {
    [sym__preprocessor_call] = STATE(2290),
    [sym__identifier_token] = ACTIONS(3914),
    [anon_sym_extern] = ACTIONS(3914),
    [anon_sym_alias] = ACTIONS(3914),
    [anon_sym_SEMI] = ACTIONS(3916),
    [anon_sym_global] = ACTIONS(3914),
    [anon_sym_using] = ACTIONS(3914),
    [anon_sym_static] = ACTIONS(3914),
    [anon_sym_LBRACK] = ACTIONS(3918),
    [anon_sym_event] = ACTIONS(3914),
    [anon_sym_LPAREN] = ACTIONS(3918),
    [anon_sym_abstract] = ACTIONS(3914),
    [anon_sym_async] = ACTIONS(3914),
    [anon_sym_const] = ACTIONS(3914),
    [anon_sym_fixed] = ACTIONS(3914),
    [anon_sym_internal] = ACTIONS(3914),
    [anon_sym_new] = ACTIONS(3914),
    [anon_sym_override] = ACTIONS(3914),
    [anon_sym_partial] = ACTIONS(3914),
    [anon_sym_private] = ACTIONS(3914),
    [anon_sym_protected] = ACTIONS(3914),
    [anon_sym_public] = ACTIONS(3914),
    [anon_sym_readonly] = ACTIONS(3914),
    [anon_sym_ref] = ACTIONS(3914),
    [anon_sym_sealed] = ACTIONS(3914),
    [anon_sym_unsafe] = ACTIONS(3914),
    [anon_sym_virtual] = ACTIONS(3914),
    [anon_sym_volatile] = ACTIONS(3914),
    [anon_sym_RBRACE] = ACTIONS(3918),
    [anon_sym_implicit] = ACTIONS(3914),
    [anon_sym_explicit] = ACTIONS(3914),
    [anon_sym_TILDE] = ACTIONS(3918),
    [anon_sym_where] = ACTIONS(3914),
    [anon_sym_class] = ACTIONS(3914),
    [anon_sym_struct] = ACTIONS(3914),
    [anon_sym_notnull] = ACTIONS(3914),
    [anon_sym_unmanaged] = ACTIONS(3914),
    [anon_sym_get] = ACTIONS(3914),
    [anon_sym_set] = ACTIONS(3914),
    [anon_sym_add] = ACTIONS(3914),
    [anon_sym_remove] = ACTIONS(3914),
    [anon_sym_enum] = ACTIONS(3914),
    [anon_sym_interface] = ACTIONS(3914),
    [anon_sym_delegate] = ACTIONS(3914),
    [anon_sym_record] = ACTIONS(3914),
    [anon_sym_namespace] = ACTIONS(3914),
    [anon_sym_var] = ACTIONS(3914),
    [sym_predefined_type] = ACTIONS(3914),
    [anon_sym_when] = ACTIONS(3914),
    [anon_sym_yield] = ACTIONS(3914),
    [anon_sym_from] = ACTIONS(3914),
    [anon_sym_join] = ACTIONS(3914),
    [anon_sym_on] = ACTIONS(3914),
    [anon_sym_equals] = ACTIONS(3914),
    [anon_sym_into] = ACTIONS(3914),
    [anon_sym_let] = ACTIONS(3914),
    [anon_sym_orderby] = ACTIONS(3914),
    [anon_sym_ascending] = ACTIONS(3914),
    [anon_sym_descending] = ACTIONS(3914),
    [anon_sym_group] = ACTIONS(3914),
    [anon_sym_by] = ACTIONS(3914),
    [anon_sym_select] = ACTIONS(3914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3914),
    [anon_sym_nameof] = ACTIONS(3914),
    [sym_void_keyword] = ACTIONS(3914),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2291] = {
    [sym__preprocessor_call] = STATE(2291),
    [sym__identifier_token] = ACTIONS(3920),
    [anon_sym_extern] = ACTIONS(3920),
    [anon_sym_alias] = ACTIONS(3920),
    [anon_sym_SEMI] = ACTIONS(3922),
    [anon_sym_global] = ACTIONS(3920),
    [anon_sym_using] = ACTIONS(3920),
    [anon_sym_static] = ACTIONS(3920),
    [anon_sym_LBRACK] = ACTIONS(3924),
    [anon_sym_event] = ACTIONS(3920),
    [anon_sym_LPAREN] = ACTIONS(3924),
    [anon_sym_abstract] = ACTIONS(3920),
    [anon_sym_async] = ACTIONS(3920),
    [anon_sym_const] = ACTIONS(3920),
    [anon_sym_fixed] = ACTIONS(3920),
    [anon_sym_internal] = ACTIONS(3920),
    [anon_sym_new] = ACTIONS(3920),
    [anon_sym_override] = ACTIONS(3920),
    [anon_sym_partial] = ACTIONS(3920),
    [anon_sym_private] = ACTIONS(3920),
    [anon_sym_protected] = ACTIONS(3920),
    [anon_sym_public] = ACTIONS(3920),
    [anon_sym_readonly] = ACTIONS(3920),
    [anon_sym_ref] = ACTIONS(3920),
    [anon_sym_sealed] = ACTIONS(3920),
    [anon_sym_unsafe] = ACTIONS(3920),
    [anon_sym_virtual] = ACTIONS(3920),
    [anon_sym_volatile] = ACTIONS(3920),
    [anon_sym_RBRACE] = ACTIONS(3924),
    [anon_sym_implicit] = ACTIONS(3920),
    [anon_sym_explicit] = ACTIONS(3920),
    [anon_sym_TILDE] = ACTIONS(3924),
    [anon_sym_where] = ACTIONS(3920),
    [anon_sym_class] = ACTIONS(3920),
    [anon_sym_struct] = ACTIONS(3920),
    [anon_sym_notnull] = ACTIONS(3920),
    [anon_sym_unmanaged] = ACTIONS(3920),
    [anon_sym_get] = ACTIONS(3920),
    [anon_sym_set] = ACTIONS(3920),
    [anon_sym_add] = ACTIONS(3920),
    [anon_sym_remove] = ACTIONS(3920),
    [anon_sym_enum] = ACTIONS(3920),
    [anon_sym_interface] = ACTIONS(3920),
    [anon_sym_delegate] = ACTIONS(3920),
    [anon_sym_record] = ACTIONS(3920),
    [anon_sym_namespace] = ACTIONS(3920),
    [anon_sym_var] = ACTIONS(3920),
    [sym_predefined_type] = ACTIONS(3920),
    [anon_sym_when] = ACTIONS(3920),
    [anon_sym_yield] = ACTIONS(3920),
    [anon_sym_from] = ACTIONS(3920),
    [anon_sym_join] = ACTIONS(3920),
    [anon_sym_on] = ACTIONS(3920),
    [anon_sym_equals] = ACTIONS(3920),
    [anon_sym_into] = ACTIONS(3920),
    [anon_sym_let] = ACTIONS(3920),
    [anon_sym_orderby] = ACTIONS(3920),
    [anon_sym_ascending] = ACTIONS(3920),
    [anon_sym_descending] = ACTIONS(3920),
    [anon_sym_group] = ACTIONS(3920),
    [anon_sym_by] = ACTIONS(3920),
    [anon_sym_select] = ACTIONS(3920),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3920),
    [anon_sym_nameof] = ACTIONS(3920),
    [sym_void_keyword] = ACTIONS(3920),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2292] = {
    [sym__preprocessor_call] = STATE(2292),
    [sym__identifier_token] = ACTIONS(3926),
    [anon_sym_extern] = ACTIONS(3926),
    [anon_sym_alias] = ACTIONS(3926),
    [anon_sym_SEMI] = ACTIONS(3928),
    [anon_sym_global] = ACTIONS(3926),
    [anon_sym_using] = ACTIONS(3926),
    [anon_sym_static] = ACTIONS(3926),
    [anon_sym_LBRACK] = ACTIONS(3928),
    [anon_sym_event] = ACTIONS(3926),
    [anon_sym_LPAREN] = ACTIONS(3928),
    [anon_sym_abstract] = ACTIONS(3926),
    [anon_sym_async] = ACTIONS(3926),
    [anon_sym_const] = ACTIONS(3926),
    [anon_sym_fixed] = ACTIONS(3926),
    [anon_sym_internal] = ACTIONS(3926),
    [anon_sym_new] = ACTIONS(3926),
    [anon_sym_override] = ACTIONS(3926),
    [anon_sym_partial] = ACTIONS(3926),
    [anon_sym_private] = ACTIONS(3926),
    [anon_sym_protected] = ACTIONS(3926),
    [anon_sym_public] = ACTIONS(3926),
    [anon_sym_readonly] = ACTIONS(3926),
    [anon_sym_ref] = ACTIONS(3926),
    [anon_sym_sealed] = ACTIONS(3926),
    [anon_sym_unsafe] = ACTIONS(3926),
    [anon_sym_virtual] = ACTIONS(3926),
    [anon_sym_volatile] = ACTIONS(3926),
    [anon_sym_RBRACE] = ACTIONS(3928),
    [anon_sym_implicit] = ACTIONS(3926),
    [anon_sym_explicit] = ACTIONS(3926),
    [anon_sym_TILDE] = ACTIONS(3928),
    [anon_sym_where] = ACTIONS(3926),
    [anon_sym_class] = ACTIONS(3926),
    [anon_sym_struct] = ACTIONS(3926),
    [anon_sym_notnull] = ACTIONS(3926),
    [anon_sym_unmanaged] = ACTIONS(3926),
    [anon_sym_get] = ACTIONS(3926),
    [anon_sym_set] = ACTIONS(3926),
    [anon_sym_add] = ACTIONS(3926),
    [anon_sym_remove] = ACTIONS(3926),
    [anon_sym_enum] = ACTIONS(3926),
    [anon_sym_interface] = ACTIONS(3926),
    [anon_sym_delegate] = ACTIONS(3926),
    [anon_sym_record] = ACTIONS(3926),
    [anon_sym_namespace] = ACTIONS(3926),
    [anon_sym_var] = ACTIONS(3926),
    [sym_predefined_type] = ACTIONS(3926),
    [anon_sym_when] = ACTIONS(3926),
    [anon_sym_yield] = ACTIONS(3926),
    [anon_sym_from] = ACTIONS(3926),
    [anon_sym_join] = ACTIONS(3926),
    [anon_sym_on] = ACTIONS(3926),
    [anon_sym_equals] = ACTIONS(3926),
    [anon_sym_into] = ACTIONS(3926),
    [anon_sym_let] = ACTIONS(3926),
    [anon_sym_orderby] = ACTIONS(3926),
    [anon_sym_ascending] = ACTIONS(3926),
    [anon_sym_descending] = ACTIONS(3926),
    [anon_sym_group] = ACTIONS(3926),
    [anon_sym_by] = ACTIONS(3926),
    [anon_sym_select] = ACTIONS(3926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3926),
    [anon_sym_nameof] = ACTIONS(3926),
    [sym_void_keyword] = ACTIONS(3926),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2293] = {
    [sym__preprocessor_call] = STATE(2293),
    [sym__identifier_token] = ACTIONS(3930),
    [anon_sym_extern] = ACTIONS(3930),
    [anon_sym_alias] = ACTIONS(3930),
    [anon_sym_SEMI] = ACTIONS(3932),
    [anon_sym_global] = ACTIONS(3930),
    [anon_sym_using] = ACTIONS(3930),
    [anon_sym_static] = ACTIONS(3930),
    [anon_sym_LBRACK] = ACTIONS(3934),
    [anon_sym_event] = ACTIONS(3930),
    [anon_sym_LPAREN] = ACTIONS(3934),
    [anon_sym_abstract] = ACTIONS(3930),
    [anon_sym_async] = ACTIONS(3930),
    [anon_sym_const] = ACTIONS(3930),
    [anon_sym_fixed] = ACTIONS(3930),
    [anon_sym_internal] = ACTIONS(3930),
    [anon_sym_new] = ACTIONS(3930),
    [anon_sym_override] = ACTIONS(3930),
    [anon_sym_partial] = ACTIONS(3930),
    [anon_sym_private] = ACTIONS(3930),
    [anon_sym_protected] = ACTIONS(3930),
    [anon_sym_public] = ACTIONS(3930),
    [anon_sym_readonly] = ACTIONS(3930),
    [anon_sym_ref] = ACTIONS(3930),
    [anon_sym_sealed] = ACTIONS(3930),
    [anon_sym_unsafe] = ACTIONS(3930),
    [anon_sym_virtual] = ACTIONS(3930),
    [anon_sym_volatile] = ACTIONS(3930),
    [anon_sym_RBRACE] = ACTIONS(3934),
    [anon_sym_implicit] = ACTIONS(3930),
    [anon_sym_explicit] = ACTIONS(3930),
    [anon_sym_TILDE] = ACTIONS(3934),
    [anon_sym_where] = ACTIONS(3930),
    [anon_sym_class] = ACTIONS(3930),
    [anon_sym_struct] = ACTIONS(3930),
    [anon_sym_notnull] = ACTIONS(3930),
    [anon_sym_unmanaged] = ACTIONS(3930),
    [anon_sym_get] = ACTIONS(3930),
    [anon_sym_set] = ACTIONS(3930),
    [anon_sym_add] = ACTIONS(3930),
    [anon_sym_remove] = ACTIONS(3930),
    [anon_sym_enum] = ACTIONS(3930),
    [anon_sym_interface] = ACTIONS(3930),
    [anon_sym_delegate] = ACTIONS(3930),
    [anon_sym_record] = ACTIONS(3930),
    [anon_sym_namespace] = ACTIONS(3930),
    [anon_sym_var] = ACTIONS(3930),
    [sym_predefined_type] = ACTIONS(3930),
    [anon_sym_when] = ACTIONS(3930),
    [anon_sym_yield] = ACTIONS(3930),
    [anon_sym_from] = ACTIONS(3930),
    [anon_sym_join] = ACTIONS(3930),
    [anon_sym_on] = ACTIONS(3930),
    [anon_sym_equals] = ACTIONS(3930),
    [anon_sym_into] = ACTIONS(3930),
    [anon_sym_let] = ACTIONS(3930),
    [anon_sym_orderby] = ACTIONS(3930),
    [anon_sym_ascending] = ACTIONS(3930),
    [anon_sym_descending] = ACTIONS(3930),
    [anon_sym_group] = ACTIONS(3930),
    [anon_sym_by] = ACTIONS(3930),
    [anon_sym_select] = ACTIONS(3930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3930),
    [anon_sym_nameof] = ACTIONS(3930),
    [sym_void_keyword] = ACTIONS(3930),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2294] = {
    [sym__preprocessor_call] = STATE(2294),
    [sym__identifier_token] = ACTIONS(3936),
    [anon_sym_extern] = ACTIONS(3936),
    [anon_sym_alias] = ACTIONS(3936),
    [anon_sym_SEMI] = ACTIONS(3938),
    [anon_sym_global] = ACTIONS(3936),
    [anon_sym_using] = ACTIONS(3936),
    [anon_sym_static] = ACTIONS(3936),
    [anon_sym_LBRACK] = ACTIONS(3940),
    [anon_sym_event] = ACTIONS(3936),
    [anon_sym_LPAREN] = ACTIONS(3940),
    [anon_sym_abstract] = ACTIONS(3936),
    [anon_sym_async] = ACTIONS(3936),
    [anon_sym_const] = ACTIONS(3936),
    [anon_sym_fixed] = ACTIONS(3936),
    [anon_sym_internal] = ACTIONS(3936),
    [anon_sym_new] = ACTIONS(3936),
    [anon_sym_override] = ACTIONS(3936),
    [anon_sym_partial] = ACTIONS(3936),
    [anon_sym_private] = ACTIONS(3936),
    [anon_sym_protected] = ACTIONS(3936),
    [anon_sym_public] = ACTIONS(3936),
    [anon_sym_readonly] = ACTIONS(3936),
    [anon_sym_ref] = ACTIONS(3936),
    [anon_sym_sealed] = ACTIONS(3936),
    [anon_sym_unsafe] = ACTIONS(3936),
    [anon_sym_virtual] = ACTIONS(3936),
    [anon_sym_volatile] = ACTIONS(3936),
    [anon_sym_RBRACE] = ACTIONS(3940),
    [anon_sym_implicit] = ACTIONS(3936),
    [anon_sym_explicit] = ACTIONS(3936),
    [anon_sym_TILDE] = ACTIONS(3940),
    [anon_sym_where] = ACTIONS(3936),
    [anon_sym_class] = ACTIONS(3936),
    [anon_sym_struct] = ACTIONS(3936),
    [anon_sym_notnull] = ACTIONS(3936),
    [anon_sym_unmanaged] = ACTIONS(3936),
    [anon_sym_get] = ACTIONS(3936),
    [anon_sym_set] = ACTIONS(3936),
    [anon_sym_add] = ACTIONS(3936),
    [anon_sym_remove] = ACTIONS(3936),
    [anon_sym_enum] = ACTIONS(3936),
    [anon_sym_interface] = ACTIONS(3936),
    [anon_sym_delegate] = ACTIONS(3936),
    [anon_sym_record] = ACTIONS(3936),
    [anon_sym_namespace] = ACTIONS(3936),
    [anon_sym_var] = ACTIONS(3936),
    [sym_predefined_type] = ACTIONS(3936),
    [anon_sym_when] = ACTIONS(3936),
    [anon_sym_yield] = ACTIONS(3936),
    [anon_sym_from] = ACTIONS(3936),
    [anon_sym_join] = ACTIONS(3936),
    [anon_sym_on] = ACTIONS(3936),
    [anon_sym_equals] = ACTIONS(3936),
    [anon_sym_into] = ACTIONS(3936),
    [anon_sym_let] = ACTIONS(3936),
    [anon_sym_orderby] = ACTIONS(3936),
    [anon_sym_ascending] = ACTIONS(3936),
    [anon_sym_descending] = ACTIONS(3936),
    [anon_sym_group] = ACTIONS(3936),
    [anon_sym_by] = ACTIONS(3936),
    [anon_sym_select] = ACTIONS(3936),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3936),
    [anon_sym_nameof] = ACTIONS(3936),
    [sym_void_keyword] = ACTIONS(3936),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2295] = {
    [sym__preprocessor_call] = STATE(2295),
    [anon_sym_SEMI] = ACTIONS(3546),
    [anon_sym_EQ] = ACTIONS(3548),
    [anon_sym_LT] = ACTIONS(3548),
    [anon_sym_COMMA] = ACTIONS(3546),
    [anon_sym_GT] = ACTIONS(3548),
    [anon_sym_DOT] = ACTIONS(3548),
    [anon_sym_LBRACK] = ACTIONS(3546),
    [anon_sym_RBRACK] = ACTIONS(3546),
    [anon_sym_COLON] = ACTIONS(3546),
    [anon_sym_LPAREN] = ACTIONS(3546),
    [anon_sym_RPAREN] = ACTIONS(3546),
    [anon_sym_in] = ACTIONS(3546),
    [anon_sym_RBRACE] = ACTIONS(3546),
    [anon_sym_EQ_GT] = ACTIONS(3546),
    [anon_sym_where] = ACTIONS(3546),
    [anon_sym_QMARK] = ACTIONS(3548),
    [anon_sym_BANG] = ACTIONS(3548),
    [anon_sym_PLUS_PLUS] = ACTIONS(3546),
    [anon_sym_DASH_DASH] = ACTIONS(3546),
    [anon_sym_PLUS] = ACTIONS(3548),
    [anon_sym_DASH] = ACTIONS(3548),
    [anon_sym_STAR] = ACTIONS(3548),
    [anon_sym_SLASH] = ACTIONS(3548),
    [anon_sym_PERCENT] = ACTIONS(3548),
    [anon_sym_CARET] = ACTIONS(3548),
    [anon_sym_PIPE] = ACTIONS(3548),
    [anon_sym_AMP] = ACTIONS(3548),
    [anon_sym_LT_LT] = ACTIONS(3548),
    [anon_sym_GT_GT] = ACTIONS(3548),
    [anon_sym_EQ_EQ] = ACTIONS(3546),
    [anon_sym_BANG_EQ] = ACTIONS(3546),
    [anon_sym_GT_EQ] = ACTIONS(3546),
    [anon_sym_LT_EQ] = ACTIONS(3546),
    [anon_sym_switch] = ACTIONS(3546),
    [anon_sym_and] = ACTIONS(3546),
    [anon_sym_or] = ACTIONS(3548),
    [anon_sym_PLUS_EQ] = ACTIONS(3546),
    [anon_sym_DASH_EQ] = ACTIONS(3546),
    [anon_sym_STAR_EQ] = ACTIONS(3546),
    [anon_sym_SLASH_EQ] = ACTIONS(3546),
    [anon_sym_PERCENT_EQ] = ACTIONS(3546),
    [anon_sym_AMP_EQ] = ACTIONS(3546),
    [anon_sym_CARET_EQ] = ACTIONS(3546),
    [anon_sym_PIPE_EQ] = ACTIONS(3546),
    [anon_sym_LT_LT_EQ] = ACTIONS(3546),
    [anon_sym_GT_GT_EQ] = ACTIONS(3546),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3546),
    [anon_sym_is] = ACTIONS(3546),
    [anon_sym_DASH_GT] = ACTIONS(3546),
    [anon_sym_from] = ACTIONS(3546),
    [anon_sym_join] = ACTIONS(3546),
    [anon_sym_on] = ACTIONS(3546),
    [anon_sym_equals] = ACTIONS(3546),
    [anon_sym_let] = ACTIONS(3546),
    [anon_sym_orderby] = ACTIONS(3546),
    [anon_sym_group] = ACTIONS(3546),
    [anon_sym_by] = ACTIONS(3546),
    [anon_sym_select] = ACTIONS(3546),
    [anon_sym_DOT_DOT] = ACTIONS(3546),
    [anon_sym_with] = ACTIONS(3546),
    [anon_sym_AMP_AMP] = ACTIONS(3546),
    [anon_sym_PIPE_PIPE] = ACTIONS(3546),
    [anon_sym_QMARK_QMARK] = ACTIONS(3548),
    [anon_sym_as] = ACTIONS(3546),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2296] = {
    [sym__preprocessor_call] = STATE(2296),
    [anon_sym_SEMI] = ACTIONS(3382),
    [anon_sym_EQ] = ACTIONS(3384),
    [anon_sym_LT] = ACTIONS(3384),
    [anon_sym_COMMA] = ACTIONS(3382),
    [anon_sym_GT] = ACTIONS(3384),
    [anon_sym_DOT] = ACTIONS(3384),
    [anon_sym_LBRACK] = ACTIONS(3382),
    [anon_sym_RBRACK] = ACTIONS(3382),
    [anon_sym_COLON] = ACTIONS(3382),
    [anon_sym_LPAREN] = ACTIONS(3382),
    [anon_sym_RPAREN] = ACTIONS(3382),
    [anon_sym_in] = ACTIONS(3382),
    [anon_sym_RBRACE] = ACTIONS(3382),
    [anon_sym_EQ_GT] = ACTIONS(3382),
    [anon_sym_where] = ACTIONS(3382),
    [anon_sym_QMARK] = ACTIONS(3384),
    [anon_sym_BANG] = ACTIONS(3384),
    [anon_sym_PLUS_PLUS] = ACTIONS(3382),
    [anon_sym_DASH_DASH] = ACTIONS(3382),
    [anon_sym_PLUS] = ACTIONS(3384),
    [anon_sym_DASH] = ACTIONS(3384),
    [anon_sym_STAR] = ACTIONS(3384),
    [anon_sym_SLASH] = ACTIONS(3384),
    [anon_sym_PERCENT] = ACTIONS(3384),
    [anon_sym_CARET] = ACTIONS(3384),
    [anon_sym_PIPE] = ACTIONS(3384),
    [anon_sym_AMP] = ACTIONS(3384),
    [anon_sym_LT_LT] = ACTIONS(3384),
    [anon_sym_GT_GT] = ACTIONS(3384),
    [anon_sym_EQ_EQ] = ACTIONS(3382),
    [anon_sym_BANG_EQ] = ACTIONS(3382),
    [anon_sym_GT_EQ] = ACTIONS(3382),
    [anon_sym_LT_EQ] = ACTIONS(3382),
    [anon_sym_switch] = ACTIONS(3382),
    [anon_sym_and] = ACTIONS(3382),
    [anon_sym_or] = ACTIONS(3384),
    [anon_sym_PLUS_EQ] = ACTIONS(3382),
    [anon_sym_DASH_EQ] = ACTIONS(3382),
    [anon_sym_STAR_EQ] = ACTIONS(3382),
    [anon_sym_SLASH_EQ] = ACTIONS(3382),
    [anon_sym_PERCENT_EQ] = ACTIONS(3382),
    [anon_sym_AMP_EQ] = ACTIONS(3382),
    [anon_sym_CARET_EQ] = ACTIONS(3382),
    [anon_sym_PIPE_EQ] = ACTIONS(3382),
    [anon_sym_LT_LT_EQ] = ACTIONS(3382),
    [anon_sym_GT_GT_EQ] = ACTIONS(3382),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3382),
    [anon_sym_is] = ACTIONS(3382),
    [anon_sym_DASH_GT] = ACTIONS(3382),
    [anon_sym_from] = ACTIONS(3382),
    [anon_sym_join] = ACTIONS(3382),
    [anon_sym_on] = ACTIONS(3382),
    [anon_sym_equals] = ACTIONS(3382),
    [anon_sym_let] = ACTIONS(3382),
    [anon_sym_orderby] = ACTIONS(3382),
    [anon_sym_group] = ACTIONS(3382),
    [anon_sym_by] = ACTIONS(3382),
    [anon_sym_select] = ACTIONS(3382),
    [anon_sym_DOT_DOT] = ACTIONS(3382),
    [anon_sym_with] = ACTIONS(3382),
    [anon_sym_AMP_AMP] = ACTIONS(3382),
    [anon_sym_PIPE_PIPE] = ACTIONS(3382),
    [anon_sym_QMARK_QMARK] = ACTIONS(3384),
    [anon_sym_as] = ACTIONS(3382),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2297] = {
    [sym__preprocessor_call] = STATE(2297),
    [anon_sym_SEMI] = ACTIONS(3378),
    [anon_sym_EQ] = ACTIONS(3380),
    [anon_sym_LT] = ACTIONS(3380),
    [anon_sym_COMMA] = ACTIONS(3378),
    [anon_sym_GT] = ACTIONS(3380),
    [anon_sym_DOT] = ACTIONS(3380),
    [anon_sym_LBRACK] = ACTIONS(3378),
    [anon_sym_RBRACK] = ACTIONS(3378),
    [anon_sym_COLON] = ACTIONS(3378),
    [anon_sym_LPAREN] = ACTIONS(3378),
    [anon_sym_RPAREN] = ACTIONS(3378),
    [anon_sym_in] = ACTIONS(3378),
    [anon_sym_RBRACE] = ACTIONS(3378),
    [anon_sym_EQ_GT] = ACTIONS(3378),
    [anon_sym_where] = ACTIONS(3378),
    [anon_sym_QMARK] = ACTIONS(3380),
    [anon_sym_BANG] = ACTIONS(3380),
    [anon_sym_PLUS_PLUS] = ACTIONS(3378),
    [anon_sym_DASH_DASH] = ACTIONS(3378),
    [anon_sym_PLUS] = ACTIONS(3380),
    [anon_sym_DASH] = ACTIONS(3380),
    [anon_sym_STAR] = ACTIONS(3380),
    [anon_sym_SLASH] = ACTIONS(3380),
    [anon_sym_PERCENT] = ACTIONS(3380),
    [anon_sym_CARET] = ACTIONS(3380),
    [anon_sym_PIPE] = ACTIONS(3380),
    [anon_sym_AMP] = ACTIONS(3380),
    [anon_sym_LT_LT] = ACTIONS(3380),
    [anon_sym_GT_GT] = ACTIONS(3380),
    [anon_sym_EQ_EQ] = ACTIONS(3378),
    [anon_sym_BANG_EQ] = ACTIONS(3378),
    [anon_sym_GT_EQ] = ACTIONS(3378),
    [anon_sym_LT_EQ] = ACTIONS(3378),
    [anon_sym_switch] = ACTIONS(3378),
    [anon_sym_and] = ACTIONS(3378),
    [anon_sym_or] = ACTIONS(3380),
    [anon_sym_PLUS_EQ] = ACTIONS(3378),
    [anon_sym_DASH_EQ] = ACTIONS(3378),
    [anon_sym_STAR_EQ] = ACTIONS(3378),
    [anon_sym_SLASH_EQ] = ACTIONS(3378),
    [anon_sym_PERCENT_EQ] = ACTIONS(3378),
    [anon_sym_AMP_EQ] = ACTIONS(3378),
    [anon_sym_CARET_EQ] = ACTIONS(3378),
    [anon_sym_PIPE_EQ] = ACTIONS(3378),
    [anon_sym_LT_LT_EQ] = ACTIONS(3378),
    [anon_sym_GT_GT_EQ] = ACTIONS(3378),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3378),
    [anon_sym_is] = ACTIONS(3378),
    [anon_sym_DASH_GT] = ACTIONS(3378),
    [anon_sym_from] = ACTIONS(3378),
    [anon_sym_join] = ACTIONS(3378),
    [anon_sym_on] = ACTIONS(3378),
    [anon_sym_equals] = ACTIONS(3378),
    [anon_sym_let] = ACTIONS(3378),
    [anon_sym_orderby] = ACTIONS(3378),
    [anon_sym_group] = ACTIONS(3378),
    [anon_sym_by] = ACTIONS(3378),
    [anon_sym_select] = ACTIONS(3378),
    [anon_sym_DOT_DOT] = ACTIONS(3378),
    [anon_sym_with] = ACTIONS(3378),
    [anon_sym_AMP_AMP] = ACTIONS(3378),
    [anon_sym_PIPE_PIPE] = ACTIONS(3378),
    [anon_sym_QMARK_QMARK] = ACTIONS(3380),
    [anon_sym_as] = ACTIONS(3378),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2298] = {
    [sym__preprocessor_call] = STATE(2298),
    [sym__identifier_token] = ACTIONS(3942),
    [anon_sym_extern] = ACTIONS(3942),
    [anon_sym_alias] = ACTIONS(3942),
    [anon_sym_global] = ACTIONS(3942),
    [anon_sym_using] = ACTIONS(3942),
    [anon_sym_static] = ACTIONS(3942),
    [anon_sym_EQ] = ACTIONS(3944),
    [anon_sym_LBRACK] = ACTIONS(3946),
    [anon_sym_event] = ACTIONS(3942),
    [anon_sym_LPAREN] = ACTIONS(3946),
    [anon_sym_abstract] = ACTIONS(3942),
    [anon_sym_async] = ACTIONS(3942),
    [anon_sym_const] = ACTIONS(3942),
    [anon_sym_fixed] = ACTIONS(3942),
    [anon_sym_internal] = ACTIONS(3942),
    [anon_sym_new] = ACTIONS(3942),
    [anon_sym_override] = ACTIONS(3942),
    [anon_sym_partial] = ACTIONS(3942),
    [anon_sym_private] = ACTIONS(3942),
    [anon_sym_protected] = ACTIONS(3942),
    [anon_sym_public] = ACTIONS(3942),
    [anon_sym_readonly] = ACTIONS(3942),
    [anon_sym_ref] = ACTIONS(3942),
    [anon_sym_sealed] = ACTIONS(3942),
    [anon_sym_unsafe] = ACTIONS(3942),
    [anon_sym_virtual] = ACTIONS(3942),
    [anon_sym_volatile] = ACTIONS(3942),
    [anon_sym_RBRACE] = ACTIONS(3946),
    [anon_sym_implicit] = ACTIONS(3942),
    [anon_sym_explicit] = ACTIONS(3942),
    [anon_sym_TILDE] = ACTIONS(3946),
    [anon_sym_where] = ACTIONS(3942),
    [anon_sym_class] = ACTIONS(3942),
    [anon_sym_struct] = ACTIONS(3942),
    [anon_sym_notnull] = ACTIONS(3942),
    [anon_sym_unmanaged] = ACTIONS(3942),
    [anon_sym_get] = ACTIONS(3942),
    [anon_sym_set] = ACTIONS(3942),
    [anon_sym_add] = ACTIONS(3942),
    [anon_sym_remove] = ACTIONS(3942),
    [anon_sym_enum] = ACTIONS(3942),
    [anon_sym_interface] = ACTIONS(3942),
    [anon_sym_delegate] = ACTIONS(3942),
    [anon_sym_record] = ACTIONS(3942),
    [anon_sym_namespace] = ACTIONS(3942),
    [anon_sym_var] = ACTIONS(3942),
    [sym_predefined_type] = ACTIONS(3942),
    [anon_sym_when] = ACTIONS(3942),
    [anon_sym_yield] = ACTIONS(3942),
    [anon_sym_from] = ACTIONS(3942),
    [anon_sym_join] = ACTIONS(3942),
    [anon_sym_on] = ACTIONS(3942),
    [anon_sym_equals] = ACTIONS(3942),
    [anon_sym_into] = ACTIONS(3942),
    [anon_sym_let] = ACTIONS(3942),
    [anon_sym_orderby] = ACTIONS(3942),
    [anon_sym_ascending] = ACTIONS(3942),
    [anon_sym_descending] = ACTIONS(3942),
    [anon_sym_group] = ACTIONS(3942),
    [anon_sym_by] = ACTIONS(3942),
    [anon_sym_select] = ACTIONS(3942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3942),
    [anon_sym_nameof] = ACTIONS(3942),
    [sym_void_keyword] = ACTIONS(3942),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2299] = {
    [sym__preprocessor_call] = STATE(2299),
    [anon_sym_SEMI] = ACTIONS(3374),
    [anon_sym_EQ] = ACTIONS(3376),
    [anon_sym_LT] = ACTIONS(3376),
    [anon_sym_COMMA] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3376),
    [anon_sym_DOT] = ACTIONS(3376),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_RBRACK] = ACTIONS(3374),
    [anon_sym_COLON] = ACTIONS(3374),
    [anon_sym_LPAREN] = ACTIONS(3374),
    [anon_sym_RPAREN] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_RBRACE] = ACTIONS(3374),
    [anon_sym_EQ_GT] = ACTIONS(3374),
    [anon_sym_where] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3376),
    [anon_sym_BANG] = ACTIONS(3376),
    [anon_sym_PLUS_PLUS] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3376),
    [anon_sym_DASH] = ACTIONS(3376),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_SLASH] = ACTIONS(3376),
    [anon_sym_PERCENT] = ACTIONS(3376),
    [anon_sym_CARET] = ACTIONS(3376),
    [anon_sym_PIPE] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3376),
    [anon_sym_LT_LT] = ACTIONS(3376),
    [anon_sym_GT_GT] = ACTIONS(3376),
    [anon_sym_EQ_EQ] = ACTIONS(3374),
    [anon_sym_BANG_EQ] = ACTIONS(3374),
    [anon_sym_GT_EQ] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3374),
    [anon_sym_switch] = ACTIONS(3374),
    [anon_sym_and] = ACTIONS(3374),
    [anon_sym_or] = ACTIONS(3376),
    [anon_sym_PLUS_EQ] = ACTIONS(3374),
    [anon_sym_DASH_EQ] = ACTIONS(3374),
    [anon_sym_STAR_EQ] = ACTIONS(3374),
    [anon_sym_SLASH_EQ] = ACTIONS(3374),
    [anon_sym_PERCENT_EQ] = ACTIONS(3374),
    [anon_sym_AMP_EQ] = ACTIONS(3374),
    [anon_sym_CARET_EQ] = ACTIONS(3374),
    [anon_sym_PIPE_EQ] = ACTIONS(3374),
    [anon_sym_LT_LT_EQ] = ACTIONS(3374),
    [anon_sym_GT_GT_EQ] = ACTIONS(3374),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3374),
    [anon_sym_is] = ACTIONS(3374),
    [anon_sym_DASH_GT] = ACTIONS(3374),
    [anon_sym_from] = ACTIONS(3374),
    [anon_sym_join] = ACTIONS(3374),
    [anon_sym_on] = ACTIONS(3374),
    [anon_sym_equals] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_orderby] = ACTIONS(3374),
    [anon_sym_group] = ACTIONS(3374),
    [anon_sym_by] = ACTIONS(3374),
    [anon_sym_select] = ACTIONS(3374),
    [anon_sym_DOT_DOT] = ACTIONS(3374),
    [anon_sym_with] = ACTIONS(3374),
    [anon_sym_AMP_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3374),
    [anon_sym_QMARK_QMARK] = ACTIONS(3376),
    [anon_sym_as] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2300] = {
    [sym__preprocessor_call] = STATE(2300),
    [sym__identifier_token] = ACTIONS(3948),
    [anon_sym_extern] = ACTIONS(3948),
    [anon_sym_alias] = ACTIONS(3948),
    [anon_sym_SEMI] = ACTIONS(3950),
    [anon_sym_global] = ACTIONS(3948),
    [anon_sym_using] = ACTIONS(3948),
    [anon_sym_static] = ACTIONS(3948),
    [anon_sym_LBRACK] = ACTIONS(3952),
    [anon_sym_event] = ACTIONS(3948),
    [anon_sym_LPAREN] = ACTIONS(3952),
    [anon_sym_abstract] = ACTIONS(3948),
    [anon_sym_async] = ACTIONS(3948),
    [anon_sym_const] = ACTIONS(3948),
    [anon_sym_fixed] = ACTIONS(3948),
    [anon_sym_internal] = ACTIONS(3948),
    [anon_sym_new] = ACTIONS(3948),
    [anon_sym_override] = ACTIONS(3948),
    [anon_sym_partial] = ACTIONS(3948),
    [anon_sym_private] = ACTIONS(3948),
    [anon_sym_protected] = ACTIONS(3948),
    [anon_sym_public] = ACTIONS(3948),
    [anon_sym_readonly] = ACTIONS(3948),
    [anon_sym_ref] = ACTIONS(3948),
    [anon_sym_sealed] = ACTIONS(3948),
    [anon_sym_unsafe] = ACTIONS(3948),
    [anon_sym_virtual] = ACTIONS(3948),
    [anon_sym_volatile] = ACTIONS(3948),
    [anon_sym_RBRACE] = ACTIONS(3952),
    [anon_sym_implicit] = ACTIONS(3948),
    [anon_sym_explicit] = ACTIONS(3948),
    [anon_sym_TILDE] = ACTIONS(3952),
    [anon_sym_where] = ACTIONS(3948),
    [anon_sym_class] = ACTIONS(3948),
    [anon_sym_struct] = ACTIONS(3948),
    [anon_sym_notnull] = ACTIONS(3948),
    [anon_sym_unmanaged] = ACTIONS(3948),
    [anon_sym_get] = ACTIONS(3948),
    [anon_sym_set] = ACTIONS(3948),
    [anon_sym_add] = ACTIONS(3948),
    [anon_sym_remove] = ACTIONS(3948),
    [anon_sym_enum] = ACTIONS(3948),
    [anon_sym_interface] = ACTIONS(3948),
    [anon_sym_delegate] = ACTIONS(3948),
    [anon_sym_record] = ACTIONS(3948),
    [anon_sym_namespace] = ACTIONS(3948),
    [anon_sym_var] = ACTIONS(3948),
    [sym_predefined_type] = ACTIONS(3948),
    [anon_sym_when] = ACTIONS(3948),
    [anon_sym_yield] = ACTIONS(3948),
    [anon_sym_from] = ACTIONS(3948),
    [anon_sym_join] = ACTIONS(3948),
    [anon_sym_on] = ACTIONS(3948),
    [anon_sym_equals] = ACTIONS(3948),
    [anon_sym_into] = ACTIONS(3948),
    [anon_sym_let] = ACTIONS(3948),
    [anon_sym_orderby] = ACTIONS(3948),
    [anon_sym_ascending] = ACTIONS(3948),
    [anon_sym_descending] = ACTIONS(3948),
    [anon_sym_group] = ACTIONS(3948),
    [anon_sym_by] = ACTIONS(3948),
    [anon_sym_select] = ACTIONS(3948),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3948),
    [anon_sym_nameof] = ACTIONS(3948),
    [sym_void_keyword] = ACTIONS(3948),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2301] = {
    [sym__preprocessor_call] = STATE(2301),
    [anon_sym_SEMI] = ACTIONS(3059),
    [anon_sym_EQ] = ACTIONS(3057),
    [anon_sym_LT] = ACTIONS(3057),
    [anon_sym_COMMA] = ACTIONS(3059),
    [anon_sym_GT] = ACTIONS(3057),
    [anon_sym_DOT] = ACTIONS(3057),
    [anon_sym_LBRACK] = ACTIONS(3059),
    [anon_sym_RBRACK] = ACTIONS(3059),
    [anon_sym_COLON] = ACTIONS(3059),
    [anon_sym_LPAREN] = ACTIONS(3059),
    [anon_sym_RPAREN] = ACTIONS(3059),
    [anon_sym_in] = ACTIONS(3059),
    [anon_sym_RBRACE] = ACTIONS(3059),
    [anon_sym_EQ_GT] = ACTIONS(3059),
    [anon_sym_where] = ACTIONS(3059),
    [anon_sym_QMARK] = ACTIONS(3057),
    [anon_sym_BANG] = ACTIONS(3057),
    [anon_sym_PLUS_PLUS] = ACTIONS(3059),
    [anon_sym_DASH_DASH] = ACTIONS(3059),
    [anon_sym_PLUS] = ACTIONS(3057),
    [anon_sym_DASH] = ACTIONS(3057),
    [anon_sym_STAR] = ACTIONS(3057),
    [anon_sym_SLASH] = ACTIONS(3057),
    [anon_sym_PERCENT] = ACTIONS(3057),
    [anon_sym_CARET] = ACTIONS(3057),
    [anon_sym_PIPE] = ACTIONS(3057),
    [anon_sym_AMP] = ACTIONS(3057),
    [anon_sym_LT_LT] = ACTIONS(3057),
    [anon_sym_GT_GT] = ACTIONS(3057),
    [anon_sym_EQ_EQ] = ACTIONS(3059),
    [anon_sym_BANG_EQ] = ACTIONS(3059),
    [anon_sym_GT_EQ] = ACTIONS(3059),
    [anon_sym_LT_EQ] = ACTIONS(3059),
    [anon_sym_switch] = ACTIONS(3059),
    [anon_sym_and] = ACTIONS(3059),
    [anon_sym_or] = ACTIONS(3057),
    [anon_sym_PLUS_EQ] = ACTIONS(3059),
    [anon_sym_DASH_EQ] = ACTIONS(3059),
    [anon_sym_STAR_EQ] = ACTIONS(3059),
    [anon_sym_SLASH_EQ] = ACTIONS(3059),
    [anon_sym_PERCENT_EQ] = ACTIONS(3059),
    [anon_sym_AMP_EQ] = ACTIONS(3059),
    [anon_sym_CARET_EQ] = ACTIONS(3059),
    [anon_sym_PIPE_EQ] = ACTIONS(3059),
    [anon_sym_LT_LT_EQ] = ACTIONS(3059),
    [anon_sym_GT_GT_EQ] = ACTIONS(3059),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3059),
    [anon_sym_is] = ACTIONS(3059),
    [anon_sym_DASH_GT] = ACTIONS(3059),
    [anon_sym_from] = ACTIONS(3059),
    [anon_sym_join] = ACTIONS(3059),
    [anon_sym_on] = ACTIONS(3059),
    [anon_sym_equals] = ACTIONS(3059),
    [anon_sym_let] = ACTIONS(3059),
    [anon_sym_orderby] = ACTIONS(3059),
    [anon_sym_group] = ACTIONS(3059),
    [anon_sym_by] = ACTIONS(3059),
    [anon_sym_select] = ACTIONS(3059),
    [anon_sym_DOT_DOT] = ACTIONS(3059),
    [anon_sym_with] = ACTIONS(3059),
    [anon_sym_AMP_AMP] = ACTIONS(3059),
    [anon_sym_PIPE_PIPE] = ACTIONS(3059),
    [anon_sym_QMARK_QMARK] = ACTIONS(3057),
    [anon_sym_as] = ACTIONS(3059),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2302] = {
    [sym__preprocessor_call] = STATE(2302),
    [sym__identifier_token] = ACTIONS(3954),
    [anon_sym_extern] = ACTIONS(3954),
    [anon_sym_alias] = ACTIONS(3954),
    [anon_sym_SEMI] = ACTIONS(3956),
    [anon_sym_global] = ACTIONS(3954),
    [anon_sym_using] = ACTIONS(3954),
    [anon_sym_static] = ACTIONS(3954),
    [anon_sym_LBRACK] = ACTIONS(3958),
    [anon_sym_event] = ACTIONS(3954),
    [anon_sym_LPAREN] = ACTIONS(3958),
    [anon_sym_abstract] = ACTIONS(3954),
    [anon_sym_async] = ACTIONS(3954),
    [anon_sym_const] = ACTIONS(3954),
    [anon_sym_fixed] = ACTIONS(3954),
    [anon_sym_internal] = ACTIONS(3954),
    [anon_sym_new] = ACTIONS(3954),
    [anon_sym_override] = ACTIONS(3954),
    [anon_sym_partial] = ACTIONS(3954),
    [anon_sym_private] = ACTIONS(3954),
    [anon_sym_protected] = ACTIONS(3954),
    [anon_sym_public] = ACTIONS(3954),
    [anon_sym_readonly] = ACTIONS(3954),
    [anon_sym_ref] = ACTIONS(3954),
    [anon_sym_sealed] = ACTIONS(3954),
    [anon_sym_unsafe] = ACTIONS(3954),
    [anon_sym_virtual] = ACTIONS(3954),
    [anon_sym_volatile] = ACTIONS(3954),
    [anon_sym_RBRACE] = ACTIONS(3958),
    [anon_sym_implicit] = ACTIONS(3954),
    [anon_sym_explicit] = ACTIONS(3954),
    [anon_sym_TILDE] = ACTIONS(3958),
    [anon_sym_where] = ACTIONS(3954),
    [anon_sym_class] = ACTIONS(3954),
    [anon_sym_struct] = ACTIONS(3954),
    [anon_sym_notnull] = ACTIONS(3954),
    [anon_sym_unmanaged] = ACTIONS(3954),
    [anon_sym_get] = ACTIONS(3954),
    [anon_sym_set] = ACTIONS(3954),
    [anon_sym_add] = ACTIONS(3954),
    [anon_sym_remove] = ACTIONS(3954),
    [anon_sym_enum] = ACTIONS(3954),
    [anon_sym_interface] = ACTIONS(3954),
    [anon_sym_delegate] = ACTIONS(3954),
    [anon_sym_record] = ACTIONS(3954),
    [anon_sym_namespace] = ACTIONS(3954),
    [anon_sym_var] = ACTIONS(3954),
    [sym_predefined_type] = ACTIONS(3954),
    [anon_sym_when] = ACTIONS(3954),
    [anon_sym_yield] = ACTIONS(3954),
    [anon_sym_from] = ACTIONS(3954),
    [anon_sym_join] = ACTIONS(3954),
    [anon_sym_on] = ACTIONS(3954),
    [anon_sym_equals] = ACTIONS(3954),
    [anon_sym_into] = ACTIONS(3954),
    [anon_sym_let] = ACTIONS(3954),
    [anon_sym_orderby] = ACTIONS(3954),
    [anon_sym_ascending] = ACTIONS(3954),
    [anon_sym_descending] = ACTIONS(3954),
    [anon_sym_group] = ACTIONS(3954),
    [anon_sym_by] = ACTIONS(3954),
    [anon_sym_select] = ACTIONS(3954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3954),
    [anon_sym_nameof] = ACTIONS(3954),
    [sym_void_keyword] = ACTIONS(3954),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2303] = {
    [sym__preprocessor_call] = STATE(2303),
    [sym__identifier_token] = ACTIONS(3960),
    [anon_sym_extern] = ACTIONS(3960),
    [anon_sym_alias] = ACTIONS(3960),
    [anon_sym_SEMI] = ACTIONS(3962),
    [anon_sym_global] = ACTIONS(3960),
    [anon_sym_using] = ACTIONS(3960),
    [anon_sym_static] = ACTIONS(3960),
    [anon_sym_LBRACK] = ACTIONS(3964),
    [anon_sym_event] = ACTIONS(3960),
    [anon_sym_LPAREN] = ACTIONS(3964),
    [anon_sym_abstract] = ACTIONS(3960),
    [anon_sym_async] = ACTIONS(3960),
    [anon_sym_const] = ACTIONS(3960),
    [anon_sym_fixed] = ACTIONS(3960),
    [anon_sym_internal] = ACTIONS(3960),
    [anon_sym_new] = ACTIONS(3960),
    [anon_sym_override] = ACTIONS(3960),
    [anon_sym_partial] = ACTIONS(3960),
    [anon_sym_private] = ACTIONS(3960),
    [anon_sym_protected] = ACTIONS(3960),
    [anon_sym_public] = ACTIONS(3960),
    [anon_sym_readonly] = ACTIONS(3960),
    [anon_sym_ref] = ACTIONS(3960),
    [anon_sym_sealed] = ACTIONS(3960),
    [anon_sym_unsafe] = ACTIONS(3960),
    [anon_sym_virtual] = ACTIONS(3960),
    [anon_sym_volatile] = ACTIONS(3960),
    [anon_sym_RBRACE] = ACTIONS(3964),
    [anon_sym_implicit] = ACTIONS(3960),
    [anon_sym_explicit] = ACTIONS(3960),
    [anon_sym_TILDE] = ACTIONS(3964),
    [anon_sym_where] = ACTIONS(3960),
    [anon_sym_class] = ACTIONS(3960),
    [anon_sym_struct] = ACTIONS(3960),
    [anon_sym_notnull] = ACTIONS(3960),
    [anon_sym_unmanaged] = ACTIONS(3960),
    [anon_sym_get] = ACTIONS(3960),
    [anon_sym_set] = ACTIONS(3960),
    [anon_sym_add] = ACTIONS(3960),
    [anon_sym_remove] = ACTIONS(3960),
    [anon_sym_enum] = ACTIONS(3960),
    [anon_sym_interface] = ACTIONS(3960),
    [anon_sym_delegate] = ACTIONS(3960),
    [anon_sym_record] = ACTIONS(3960),
    [anon_sym_namespace] = ACTIONS(3960),
    [anon_sym_var] = ACTIONS(3960),
    [sym_predefined_type] = ACTIONS(3960),
    [anon_sym_when] = ACTIONS(3960),
    [anon_sym_yield] = ACTIONS(3960),
    [anon_sym_from] = ACTIONS(3960),
    [anon_sym_join] = ACTIONS(3960),
    [anon_sym_on] = ACTIONS(3960),
    [anon_sym_equals] = ACTIONS(3960),
    [anon_sym_into] = ACTIONS(3960),
    [anon_sym_let] = ACTIONS(3960),
    [anon_sym_orderby] = ACTIONS(3960),
    [anon_sym_ascending] = ACTIONS(3960),
    [anon_sym_descending] = ACTIONS(3960),
    [anon_sym_group] = ACTIONS(3960),
    [anon_sym_by] = ACTIONS(3960),
    [anon_sym_select] = ACTIONS(3960),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3960),
    [anon_sym_nameof] = ACTIONS(3960),
    [sym_void_keyword] = ACTIONS(3960),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2304] = {
    [sym__preprocessor_call] = STATE(2304),
    [sym__identifier_token] = ACTIONS(3966),
    [anon_sym_extern] = ACTIONS(3966),
    [anon_sym_alias] = ACTIONS(3966),
    [anon_sym_SEMI] = ACTIONS(3968),
    [anon_sym_global] = ACTIONS(3966),
    [anon_sym_using] = ACTIONS(3966),
    [anon_sym_static] = ACTIONS(3966),
    [anon_sym_LBRACK] = ACTIONS(3970),
    [anon_sym_event] = ACTIONS(3966),
    [anon_sym_LPAREN] = ACTIONS(3970),
    [anon_sym_abstract] = ACTIONS(3966),
    [anon_sym_async] = ACTIONS(3966),
    [anon_sym_const] = ACTIONS(3966),
    [anon_sym_fixed] = ACTIONS(3966),
    [anon_sym_internal] = ACTIONS(3966),
    [anon_sym_new] = ACTIONS(3966),
    [anon_sym_override] = ACTIONS(3966),
    [anon_sym_partial] = ACTIONS(3966),
    [anon_sym_private] = ACTIONS(3966),
    [anon_sym_protected] = ACTIONS(3966),
    [anon_sym_public] = ACTIONS(3966),
    [anon_sym_readonly] = ACTIONS(3966),
    [anon_sym_ref] = ACTIONS(3966),
    [anon_sym_sealed] = ACTIONS(3966),
    [anon_sym_unsafe] = ACTIONS(3966),
    [anon_sym_virtual] = ACTIONS(3966),
    [anon_sym_volatile] = ACTIONS(3966),
    [anon_sym_RBRACE] = ACTIONS(3970),
    [anon_sym_implicit] = ACTIONS(3966),
    [anon_sym_explicit] = ACTIONS(3966),
    [anon_sym_TILDE] = ACTIONS(3970),
    [anon_sym_where] = ACTIONS(3966),
    [anon_sym_class] = ACTIONS(3966),
    [anon_sym_struct] = ACTIONS(3966),
    [anon_sym_notnull] = ACTIONS(3966),
    [anon_sym_unmanaged] = ACTIONS(3966),
    [anon_sym_get] = ACTIONS(3966),
    [anon_sym_set] = ACTIONS(3966),
    [anon_sym_add] = ACTIONS(3966),
    [anon_sym_remove] = ACTIONS(3966),
    [anon_sym_enum] = ACTIONS(3966),
    [anon_sym_interface] = ACTIONS(3966),
    [anon_sym_delegate] = ACTIONS(3966),
    [anon_sym_record] = ACTIONS(3966),
    [anon_sym_namespace] = ACTIONS(3966),
    [anon_sym_var] = ACTIONS(3966),
    [sym_predefined_type] = ACTIONS(3966),
    [anon_sym_when] = ACTIONS(3966),
    [anon_sym_yield] = ACTIONS(3966),
    [anon_sym_from] = ACTIONS(3966),
    [anon_sym_join] = ACTIONS(3966),
    [anon_sym_on] = ACTIONS(3966),
    [anon_sym_equals] = ACTIONS(3966),
    [anon_sym_into] = ACTIONS(3966),
    [anon_sym_let] = ACTIONS(3966),
    [anon_sym_orderby] = ACTIONS(3966),
    [anon_sym_ascending] = ACTIONS(3966),
    [anon_sym_descending] = ACTIONS(3966),
    [anon_sym_group] = ACTIONS(3966),
    [anon_sym_by] = ACTIONS(3966),
    [anon_sym_select] = ACTIONS(3966),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3966),
    [anon_sym_nameof] = ACTIONS(3966),
    [sym_void_keyword] = ACTIONS(3966),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2305] = {
    [sym__preprocessor_call] = STATE(2305),
    [sym__identifier_token] = ACTIONS(3972),
    [anon_sym_extern] = ACTIONS(3972),
    [anon_sym_alias] = ACTIONS(3972),
    [anon_sym_SEMI] = ACTIONS(3974),
    [anon_sym_global] = ACTIONS(3972),
    [anon_sym_using] = ACTIONS(3972),
    [anon_sym_static] = ACTIONS(3972),
    [anon_sym_LBRACK] = ACTIONS(3976),
    [anon_sym_event] = ACTIONS(3972),
    [anon_sym_LPAREN] = ACTIONS(3976),
    [anon_sym_abstract] = ACTIONS(3972),
    [anon_sym_async] = ACTIONS(3972),
    [anon_sym_const] = ACTIONS(3972),
    [anon_sym_fixed] = ACTIONS(3972),
    [anon_sym_internal] = ACTIONS(3972),
    [anon_sym_new] = ACTIONS(3972),
    [anon_sym_override] = ACTIONS(3972),
    [anon_sym_partial] = ACTIONS(3972),
    [anon_sym_private] = ACTIONS(3972),
    [anon_sym_protected] = ACTIONS(3972),
    [anon_sym_public] = ACTIONS(3972),
    [anon_sym_readonly] = ACTIONS(3972),
    [anon_sym_ref] = ACTIONS(3972),
    [anon_sym_sealed] = ACTIONS(3972),
    [anon_sym_unsafe] = ACTIONS(3972),
    [anon_sym_virtual] = ACTIONS(3972),
    [anon_sym_volatile] = ACTIONS(3972),
    [anon_sym_RBRACE] = ACTIONS(3976),
    [anon_sym_implicit] = ACTIONS(3972),
    [anon_sym_explicit] = ACTIONS(3972),
    [anon_sym_TILDE] = ACTIONS(3976),
    [anon_sym_where] = ACTIONS(3972),
    [anon_sym_class] = ACTIONS(3972),
    [anon_sym_struct] = ACTIONS(3972),
    [anon_sym_notnull] = ACTIONS(3972),
    [anon_sym_unmanaged] = ACTIONS(3972),
    [anon_sym_get] = ACTIONS(3972),
    [anon_sym_set] = ACTIONS(3972),
    [anon_sym_add] = ACTIONS(3972),
    [anon_sym_remove] = ACTIONS(3972),
    [anon_sym_enum] = ACTIONS(3972),
    [anon_sym_interface] = ACTIONS(3972),
    [anon_sym_delegate] = ACTIONS(3972),
    [anon_sym_record] = ACTIONS(3972),
    [anon_sym_namespace] = ACTIONS(3972),
    [anon_sym_var] = ACTIONS(3972),
    [sym_predefined_type] = ACTIONS(3972),
    [anon_sym_when] = ACTIONS(3972),
    [anon_sym_yield] = ACTIONS(3972),
    [anon_sym_from] = ACTIONS(3972),
    [anon_sym_join] = ACTIONS(3972),
    [anon_sym_on] = ACTIONS(3972),
    [anon_sym_equals] = ACTIONS(3972),
    [anon_sym_into] = ACTIONS(3972),
    [anon_sym_let] = ACTIONS(3972),
    [anon_sym_orderby] = ACTIONS(3972),
    [anon_sym_ascending] = ACTIONS(3972),
    [anon_sym_descending] = ACTIONS(3972),
    [anon_sym_group] = ACTIONS(3972),
    [anon_sym_by] = ACTIONS(3972),
    [anon_sym_select] = ACTIONS(3972),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3972),
    [anon_sym_nameof] = ACTIONS(3972),
    [sym_void_keyword] = ACTIONS(3972),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2306] = {
    [sym__preprocessor_call] = STATE(2306),
    [sym__identifier_token] = ACTIONS(3978),
    [anon_sym_extern] = ACTIONS(3978),
    [anon_sym_alias] = ACTIONS(3978),
    [anon_sym_SEMI] = ACTIONS(3980),
    [anon_sym_global] = ACTIONS(3978),
    [anon_sym_using] = ACTIONS(3978),
    [anon_sym_static] = ACTIONS(3978),
    [anon_sym_LBRACK] = ACTIONS(3982),
    [anon_sym_event] = ACTIONS(3978),
    [anon_sym_LPAREN] = ACTIONS(3982),
    [anon_sym_abstract] = ACTIONS(3978),
    [anon_sym_async] = ACTIONS(3978),
    [anon_sym_const] = ACTIONS(3978),
    [anon_sym_fixed] = ACTIONS(3978),
    [anon_sym_internal] = ACTIONS(3978),
    [anon_sym_new] = ACTIONS(3978),
    [anon_sym_override] = ACTIONS(3978),
    [anon_sym_partial] = ACTIONS(3978),
    [anon_sym_private] = ACTIONS(3978),
    [anon_sym_protected] = ACTIONS(3978),
    [anon_sym_public] = ACTIONS(3978),
    [anon_sym_readonly] = ACTIONS(3978),
    [anon_sym_ref] = ACTIONS(3978),
    [anon_sym_sealed] = ACTIONS(3978),
    [anon_sym_unsafe] = ACTIONS(3978),
    [anon_sym_virtual] = ACTIONS(3978),
    [anon_sym_volatile] = ACTIONS(3978),
    [anon_sym_RBRACE] = ACTIONS(3982),
    [anon_sym_implicit] = ACTIONS(3978),
    [anon_sym_explicit] = ACTIONS(3978),
    [anon_sym_TILDE] = ACTIONS(3982),
    [anon_sym_where] = ACTIONS(3978),
    [anon_sym_class] = ACTIONS(3978),
    [anon_sym_struct] = ACTIONS(3978),
    [anon_sym_notnull] = ACTIONS(3978),
    [anon_sym_unmanaged] = ACTIONS(3978),
    [anon_sym_get] = ACTIONS(3978),
    [anon_sym_set] = ACTIONS(3978),
    [anon_sym_add] = ACTIONS(3978),
    [anon_sym_remove] = ACTIONS(3978),
    [anon_sym_enum] = ACTIONS(3978),
    [anon_sym_interface] = ACTIONS(3978),
    [anon_sym_delegate] = ACTIONS(3978),
    [anon_sym_record] = ACTIONS(3978),
    [anon_sym_namespace] = ACTIONS(3978),
    [anon_sym_var] = ACTIONS(3978),
    [sym_predefined_type] = ACTIONS(3978),
    [anon_sym_when] = ACTIONS(3978),
    [anon_sym_yield] = ACTIONS(3978),
    [anon_sym_from] = ACTIONS(3978),
    [anon_sym_join] = ACTIONS(3978),
    [anon_sym_on] = ACTIONS(3978),
    [anon_sym_equals] = ACTIONS(3978),
    [anon_sym_into] = ACTIONS(3978),
    [anon_sym_let] = ACTIONS(3978),
    [anon_sym_orderby] = ACTIONS(3978),
    [anon_sym_ascending] = ACTIONS(3978),
    [anon_sym_descending] = ACTIONS(3978),
    [anon_sym_group] = ACTIONS(3978),
    [anon_sym_by] = ACTIONS(3978),
    [anon_sym_select] = ACTIONS(3978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3978),
    [anon_sym_nameof] = ACTIONS(3978),
    [sym_void_keyword] = ACTIONS(3978),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2307] = {
    [sym__preprocessor_call] = STATE(2307),
    [sym__identifier_token] = ACTIONS(3984),
    [anon_sym_extern] = ACTIONS(3984),
    [anon_sym_alias] = ACTIONS(3984),
    [anon_sym_SEMI] = ACTIONS(3986),
    [anon_sym_global] = ACTIONS(3984),
    [anon_sym_using] = ACTIONS(3984),
    [anon_sym_static] = ACTIONS(3984),
    [anon_sym_LBRACK] = ACTIONS(3988),
    [anon_sym_event] = ACTIONS(3984),
    [anon_sym_LPAREN] = ACTIONS(3988),
    [anon_sym_abstract] = ACTIONS(3984),
    [anon_sym_async] = ACTIONS(3984),
    [anon_sym_const] = ACTIONS(3984),
    [anon_sym_fixed] = ACTIONS(3984),
    [anon_sym_internal] = ACTIONS(3984),
    [anon_sym_new] = ACTIONS(3984),
    [anon_sym_override] = ACTIONS(3984),
    [anon_sym_partial] = ACTIONS(3984),
    [anon_sym_private] = ACTIONS(3984),
    [anon_sym_protected] = ACTIONS(3984),
    [anon_sym_public] = ACTIONS(3984),
    [anon_sym_readonly] = ACTIONS(3984),
    [anon_sym_ref] = ACTIONS(3984),
    [anon_sym_sealed] = ACTIONS(3984),
    [anon_sym_unsafe] = ACTIONS(3984),
    [anon_sym_virtual] = ACTIONS(3984),
    [anon_sym_volatile] = ACTIONS(3984),
    [anon_sym_RBRACE] = ACTIONS(3988),
    [anon_sym_implicit] = ACTIONS(3984),
    [anon_sym_explicit] = ACTIONS(3984),
    [anon_sym_TILDE] = ACTIONS(3988),
    [anon_sym_where] = ACTIONS(3984),
    [anon_sym_class] = ACTIONS(3984),
    [anon_sym_struct] = ACTIONS(3984),
    [anon_sym_notnull] = ACTIONS(3984),
    [anon_sym_unmanaged] = ACTIONS(3984),
    [anon_sym_get] = ACTIONS(3984),
    [anon_sym_set] = ACTIONS(3984),
    [anon_sym_add] = ACTIONS(3984),
    [anon_sym_remove] = ACTIONS(3984),
    [anon_sym_enum] = ACTIONS(3984),
    [anon_sym_interface] = ACTIONS(3984),
    [anon_sym_delegate] = ACTIONS(3984),
    [anon_sym_record] = ACTIONS(3984),
    [anon_sym_namespace] = ACTIONS(3984),
    [anon_sym_var] = ACTIONS(3984),
    [sym_predefined_type] = ACTIONS(3984),
    [anon_sym_when] = ACTIONS(3984),
    [anon_sym_yield] = ACTIONS(3984),
    [anon_sym_from] = ACTIONS(3984),
    [anon_sym_join] = ACTIONS(3984),
    [anon_sym_on] = ACTIONS(3984),
    [anon_sym_equals] = ACTIONS(3984),
    [anon_sym_into] = ACTIONS(3984),
    [anon_sym_let] = ACTIONS(3984),
    [anon_sym_orderby] = ACTIONS(3984),
    [anon_sym_ascending] = ACTIONS(3984),
    [anon_sym_descending] = ACTIONS(3984),
    [anon_sym_group] = ACTIONS(3984),
    [anon_sym_by] = ACTIONS(3984),
    [anon_sym_select] = ACTIONS(3984),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3984),
    [anon_sym_nameof] = ACTIONS(3984),
    [sym_void_keyword] = ACTIONS(3984),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2308] = {
    [sym__preprocessor_call] = STATE(2308),
    [sym__identifier_token] = ACTIONS(3990),
    [anon_sym_extern] = ACTIONS(3990),
    [anon_sym_alias] = ACTIONS(3990),
    [anon_sym_SEMI] = ACTIONS(3992),
    [anon_sym_global] = ACTIONS(3990),
    [anon_sym_using] = ACTIONS(3990),
    [anon_sym_static] = ACTIONS(3990),
    [anon_sym_LBRACK] = ACTIONS(3994),
    [anon_sym_event] = ACTIONS(3990),
    [anon_sym_LPAREN] = ACTIONS(3994),
    [anon_sym_abstract] = ACTIONS(3990),
    [anon_sym_async] = ACTIONS(3990),
    [anon_sym_const] = ACTIONS(3990),
    [anon_sym_fixed] = ACTIONS(3990),
    [anon_sym_internal] = ACTIONS(3990),
    [anon_sym_new] = ACTIONS(3990),
    [anon_sym_override] = ACTIONS(3990),
    [anon_sym_partial] = ACTIONS(3990),
    [anon_sym_private] = ACTIONS(3990),
    [anon_sym_protected] = ACTIONS(3990),
    [anon_sym_public] = ACTIONS(3990),
    [anon_sym_readonly] = ACTIONS(3990),
    [anon_sym_ref] = ACTIONS(3990),
    [anon_sym_sealed] = ACTIONS(3990),
    [anon_sym_unsafe] = ACTIONS(3990),
    [anon_sym_virtual] = ACTIONS(3990),
    [anon_sym_volatile] = ACTIONS(3990),
    [anon_sym_RBRACE] = ACTIONS(3994),
    [anon_sym_implicit] = ACTIONS(3990),
    [anon_sym_explicit] = ACTIONS(3990),
    [anon_sym_TILDE] = ACTIONS(3994),
    [anon_sym_where] = ACTIONS(3990),
    [anon_sym_class] = ACTIONS(3990),
    [anon_sym_struct] = ACTIONS(3990),
    [anon_sym_notnull] = ACTIONS(3990),
    [anon_sym_unmanaged] = ACTIONS(3990),
    [anon_sym_get] = ACTIONS(3990),
    [anon_sym_set] = ACTIONS(3990),
    [anon_sym_add] = ACTIONS(3990),
    [anon_sym_remove] = ACTIONS(3990),
    [anon_sym_enum] = ACTIONS(3990),
    [anon_sym_interface] = ACTIONS(3990),
    [anon_sym_delegate] = ACTIONS(3990),
    [anon_sym_record] = ACTIONS(3990),
    [anon_sym_namespace] = ACTIONS(3990),
    [anon_sym_var] = ACTIONS(3990),
    [sym_predefined_type] = ACTIONS(3990),
    [anon_sym_when] = ACTIONS(3990),
    [anon_sym_yield] = ACTIONS(3990),
    [anon_sym_from] = ACTIONS(3990),
    [anon_sym_join] = ACTIONS(3990),
    [anon_sym_on] = ACTIONS(3990),
    [anon_sym_equals] = ACTIONS(3990),
    [anon_sym_into] = ACTIONS(3990),
    [anon_sym_let] = ACTIONS(3990),
    [anon_sym_orderby] = ACTIONS(3990),
    [anon_sym_ascending] = ACTIONS(3990),
    [anon_sym_descending] = ACTIONS(3990),
    [anon_sym_group] = ACTIONS(3990),
    [anon_sym_by] = ACTIONS(3990),
    [anon_sym_select] = ACTIONS(3990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3990),
    [anon_sym_nameof] = ACTIONS(3990),
    [sym_void_keyword] = ACTIONS(3990),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2309] = {
    [sym__preprocessor_call] = STATE(2309),
    [sym__identifier_token] = ACTIONS(3996),
    [anon_sym_extern] = ACTIONS(3996),
    [anon_sym_alias] = ACTIONS(3996),
    [anon_sym_SEMI] = ACTIONS(3998),
    [anon_sym_global] = ACTIONS(3996),
    [anon_sym_using] = ACTIONS(3996),
    [anon_sym_static] = ACTIONS(3996),
    [anon_sym_LBRACK] = ACTIONS(4000),
    [anon_sym_event] = ACTIONS(3996),
    [anon_sym_LPAREN] = ACTIONS(4000),
    [anon_sym_abstract] = ACTIONS(3996),
    [anon_sym_async] = ACTIONS(3996),
    [anon_sym_const] = ACTIONS(3996),
    [anon_sym_fixed] = ACTIONS(3996),
    [anon_sym_internal] = ACTIONS(3996),
    [anon_sym_new] = ACTIONS(3996),
    [anon_sym_override] = ACTIONS(3996),
    [anon_sym_partial] = ACTIONS(3996),
    [anon_sym_private] = ACTIONS(3996),
    [anon_sym_protected] = ACTIONS(3996),
    [anon_sym_public] = ACTIONS(3996),
    [anon_sym_readonly] = ACTIONS(3996),
    [anon_sym_ref] = ACTIONS(3996),
    [anon_sym_sealed] = ACTIONS(3996),
    [anon_sym_unsafe] = ACTIONS(3996),
    [anon_sym_virtual] = ACTIONS(3996),
    [anon_sym_volatile] = ACTIONS(3996),
    [anon_sym_RBRACE] = ACTIONS(4000),
    [anon_sym_implicit] = ACTIONS(3996),
    [anon_sym_explicit] = ACTIONS(3996),
    [anon_sym_TILDE] = ACTIONS(4000),
    [anon_sym_where] = ACTIONS(3996),
    [anon_sym_class] = ACTIONS(3996),
    [anon_sym_struct] = ACTIONS(3996),
    [anon_sym_notnull] = ACTIONS(3996),
    [anon_sym_unmanaged] = ACTIONS(3996),
    [anon_sym_get] = ACTIONS(3996),
    [anon_sym_set] = ACTIONS(3996),
    [anon_sym_add] = ACTIONS(3996),
    [anon_sym_remove] = ACTIONS(3996),
    [anon_sym_enum] = ACTIONS(3996),
    [anon_sym_interface] = ACTIONS(3996),
    [anon_sym_delegate] = ACTIONS(3996),
    [anon_sym_record] = ACTIONS(3996),
    [anon_sym_namespace] = ACTIONS(3996),
    [anon_sym_var] = ACTIONS(3996),
    [sym_predefined_type] = ACTIONS(3996),
    [anon_sym_when] = ACTIONS(3996),
    [anon_sym_yield] = ACTIONS(3996),
    [anon_sym_from] = ACTIONS(3996),
    [anon_sym_join] = ACTIONS(3996),
    [anon_sym_on] = ACTIONS(3996),
    [anon_sym_equals] = ACTIONS(3996),
    [anon_sym_into] = ACTIONS(3996),
    [anon_sym_let] = ACTIONS(3996),
    [anon_sym_orderby] = ACTIONS(3996),
    [anon_sym_ascending] = ACTIONS(3996),
    [anon_sym_descending] = ACTIONS(3996),
    [anon_sym_group] = ACTIONS(3996),
    [anon_sym_by] = ACTIONS(3996),
    [anon_sym_select] = ACTIONS(3996),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(3996),
    [anon_sym_nameof] = ACTIONS(3996),
    [sym_void_keyword] = ACTIONS(3996),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2310] = {
    [sym__preprocessor_call] = STATE(2310),
    [sym__identifier_token] = ACTIONS(4002),
    [anon_sym_extern] = ACTIONS(4002),
    [anon_sym_alias] = ACTIONS(4002),
    [anon_sym_SEMI] = ACTIONS(4004),
    [anon_sym_global] = ACTIONS(4002),
    [anon_sym_using] = ACTIONS(4002),
    [anon_sym_static] = ACTIONS(4002),
    [anon_sym_LBRACK] = ACTIONS(4006),
    [anon_sym_event] = ACTIONS(4002),
    [anon_sym_LPAREN] = ACTIONS(4006),
    [anon_sym_abstract] = ACTIONS(4002),
    [anon_sym_async] = ACTIONS(4002),
    [anon_sym_const] = ACTIONS(4002),
    [anon_sym_fixed] = ACTIONS(4002),
    [anon_sym_internal] = ACTIONS(4002),
    [anon_sym_new] = ACTIONS(4002),
    [anon_sym_override] = ACTIONS(4002),
    [anon_sym_partial] = ACTIONS(4002),
    [anon_sym_private] = ACTIONS(4002),
    [anon_sym_protected] = ACTIONS(4002),
    [anon_sym_public] = ACTIONS(4002),
    [anon_sym_readonly] = ACTIONS(4002),
    [anon_sym_ref] = ACTIONS(4002),
    [anon_sym_sealed] = ACTIONS(4002),
    [anon_sym_unsafe] = ACTIONS(4002),
    [anon_sym_virtual] = ACTIONS(4002),
    [anon_sym_volatile] = ACTIONS(4002),
    [anon_sym_RBRACE] = ACTIONS(4006),
    [anon_sym_implicit] = ACTIONS(4002),
    [anon_sym_explicit] = ACTIONS(4002),
    [anon_sym_TILDE] = ACTIONS(4006),
    [anon_sym_where] = ACTIONS(4002),
    [anon_sym_class] = ACTIONS(4002),
    [anon_sym_struct] = ACTIONS(4002),
    [anon_sym_notnull] = ACTIONS(4002),
    [anon_sym_unmanaged] = ACTIONS(4002),
    [anon_sym_get] = ACTIONS(4002),
    [anon_sym_set] = ACTIONS(4002),
    [anon_sym_add] = ACTIONS(4002),
    [anon_sym_remove] = ACTIONS(4002),
    [anon_sym_enum] = ACTIONS(4002),
    [anon_sym_interface] = ACTIONS(4002),
    [anon_sym_delegate] = ACTIONS(4002),
    [anon_sym_record] = ACTIONS(4002),
    [anon_sym_namespace] = ACTIONS(4002),
    [anon_sym_var] = ACTIONS(4002),
    [sym_predefined_type] = ACTIONS(4002),
    [anon_sym_when] = ACTIONS(4002),
    [anon_sym_yield] = ACTIONS(4002),
    [anon_sym_from] = ACTIONS(4002),
    [anon_sym_join] = ACTIONS(4002),
    [anon_sym_on] = ACTIONS(4002),
    [anon_sym_equals] = ACTIONS(4002),
    [anon_sym_into] = ACTIONS(4002),
    [anon_sym_let] = ACTIONS(4002),
    [anon_sym_orderby] = ACTIONS(4002),
    [anon_sym_ascending] = ACTIONS(4002),
    [anon_sym_descending] = ACTIONS(4002),
    [anon_sym_group] = ACTIONS(4002),
    [anon_sym_by] = ACTIONS(4002),
    [anon_sym_select] = ACTIONS(4002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4002),
    [anon_sym_nameof] = ACTIONS(4002),
    [sym_void_keyword] = ACTIONS(4002),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2311] = {
    [sym__preprocessor_call] = STATE(2311),
    [sym__identifier_token] = ACTIONS(4008),
    [anon_sym_extern] = ACTIONS(4008),
    [anon_sym_alias] = ACTIONS(4008),
    [anon_sym_SEMI] = ACTIONS(4010),
    [anon_sym_global] = ACTIONS(4008),
    [anon_sym_using] = ACTIONS(4008),
    [anon_sym_static] = ACTIONS(4008),
    [anon_sym_LBRACK] = ACTIONS(4012),
    [anon_sym_event] = ACTIONS(4008),
    [anon_sym_LPAREN] = ACTIONS(4012),
    [anon_sym_abstract] = ACTIONS(4008),
    [anon_sym_async] = ACTIONS(4008),
    [anon_sym_const] = ACTIONS(4008),
    [anon_sym_fixed] = ACTIONS(4008),
    [anon_sym_internal] = ACTIONS(4008),
    [anon_sym_new] = ACTIONS(4008),
    [anon_sym_override] = ACTIONS(4008),
    [anon_sym_partial] = ACTIONS(4008),
    [anon_sym_private] = ACTIONS(4008),
    [anon_sym_protected] = ACTIONS(4008),
    [anon_sym_public] = ACTIONS(4008),
    [anon_sym_readonly] = ACTIONS(4008),
    [anon_sym_ref] = ACTIONS(4008),
    [anon_sym_sealed] = ACTIONS(4008),
    [anon_sym_unsafe] = ACTIONS(4008),
    [anon_sym_virtual] = ACTIONS(4008),
    [anon_sym_volatile] = ACTIONS(4008),
    [anon_sym_RBRACE] = ACTIONS(4012),
    [anon_sym_implicit] = ACTIONS(4008),
    [anon_sym_explicit] = ACTIONS(4008),
    [anon_sym_TILDE] = ACTIONS(4012),
    [anon_sym_where] = ACTIONS(4008),
    [anon_sym_class] = ACTIONS(4008),
    [anon_sym_struct] = ACTIONS(4008),
    [anon_sym_notnull] = ACTIONS(4008),
    [anon_sym_unmanaged] = ACTIONS(4008),
    [anon_sym_get] = ACTIONS(4008),
    [anon_sym_set] = ACTIONS(4008),
    [anon_sym_add] = ACTIONS(4008),
    [anon_sym_remove] = ACTIONS(4008),
    [anon_sym_enum] = ACTIONS(4008),
    [anon_sym_interface] = ACTIONS(4008),
    [anon_sym_delegate] = ACTIONS(4008),
    [anon_sym_record] = ACTIONS(4008),
    [anon_sym_namespace] = ACTIONS(4008),
    [anon_sym_var] = ACTIONS(4008),
    [sym_predefined_type] = ACTIONS(4008),
    [anon_sym_when] = ACTIONS(4008),
    [anon_sym_yield] = ACTIONS(4008),
    [anon_sym_from] = ACTIONS(4008),
    [anon_sym_join] = ACTIONS(4008),
    [anon_sym_on] = ACTIONS(4008),
    [anon_sym_equals] = ACTIONS(4008),
    [anon_sym_into] = ACTIONS(4008),
    [anon_sym_let] = ACTIONS(4008),
    [anon_sym_orderby] = ACTIONS(4008),
    [anon_sym_ascending] = ACTIONS(4008),
    [anon_sym_descending] = ACTIONS(4008),
    [anon_sym_group] = ACTIONS(4008),
    [anon_sym_by] = ACTIONS(4008),
    [anon_sym_select] = ACTIONS(4008),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4008),
    [anon_sym_nameof] = ACTIONS(4008),
    [sym_void_keyword] = ACTIONS(4008),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2312] = {
    [sym__preprocessor_call] = STATE(2312),
    [sym__identifier_token] = ACTIONS(4014),
    [anon_sym_extern] = ACTIONS(4014),
    [anon_sym_alias] = ACTIONS(4014),
    [anon_sym_SEMI] = ACTIONS(4016),
    [anon_sym_global] = ACTIONS(4014),
    [anon_sym_using] = ACTIONS(4014),
    [anon_sym_static] = ACTIONS(4014),
    [anon_sym_LBRACK] = ACTIONS(4018),
    [anon_sym_event] = ACTIONS(4014),
    [anon_sym_LPAREN] = ACTIONS(4018),
    [anon_sym_abstract] = ACTIONS(4014),
    [anon_sym_async] = ACTIONS(4014),
    [anon_sym_const] = ACTIONS(4014),
    [anon_sym_fixed] = ACTIONS(4014),
    [anon_sym_internal] = ACTIONS(4014),
    [anon_sym_new] = ACTIONS(4014),
    [anon_sym_override] = ACTIONS(4014),
    [anon_sym_partial] = ACTIONS(4014),
    [anon_sym_private] = ACTIONS(4014),
    [anon_sym_protected] = ACTIONS(4014),
    [anon_sym_public] = ACTIONS(4014),
    [anon_sym_readonly] = ACTIONS(4014),
    [anon_sym_ref] = ACTIONS(4014),
    [anon_sym_sealed] = ACTIONS(4014),
    [anon_sym_unsafe] = ACTIONS(4014),
    [anon_sym_virtual] = ACTIONS(4014),
    [anon_sym_volatile] = ACTIONS(4014),
    [anon_sym_RBRACE] = ACTIONS(4018),
    [anon_sym_implicit] = ACTIONS(4014),
    [anon_sym_explicit] = ACTIONS(4014),
    [anon_sym_TILDE] = ACTIONS(4018),
    [anon_sym_where] = ACTIONS(4014),
    [anon_sym_class] = ACTIONS(4014),
    [anon_sym_struct] = ACTIONS(4014),
    [anon_sym_notnull] = ACTIONS(4014),
    [anon_sym_unmanaged] = ACTIONS(4014),
    [anon_sym_get] = ACTIONS(4014),
    [anon_sym_set] = ACTIONS(4014),
    [anon_sym_add] = ACTIONS(4014),
    [anon_sym_remove] = ACTIONS(4014),
    [anon_sym_enum] = ACTIONS(4014),
    [anon_sym_interface] = ACTIONS(4014),
    [anon_sym_delegate] = ACTIONS(4014),
    [anon_sym_record] = ACTIONS(4014),
    [anon_sym_namespace] = ACTIONS(4014),
    [anon_sym_var] = ACTIONS(4014),
    [sym_predefined_type] = ACTIONS(4014),
    [anon_sym_when] = ACTIONS(4014),
    [anon_sym_yield] = ACTIONS(4014),
    [anon_sym_from] = ACTIONS(4014),
    [anon_sym_join] = ACTIONS(4014),
    [anon_sym_on] = ACTIONS(4014),
    [anon_sym_equals] = ACTIONS(4014),
    [anon_sym_into] = ACTIONS(4014),
    [anon_sym_let] = ACTIONS(4014),
    [anon_sym_orderby] = ACTIONS(4014),
    [anon_sym_ascending] = ACTIONS(4014),
    [anon_sym_descending] = ACTIONS(4014),
    [anon_sym_group] = ACTIONS(4014),
    [anon_sym_by] = ACTIONS(4014),
    [anon_sym_select] = ACTIONS(4014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4014),
    [anon_sym_nameof] = ACTIONS(4014),
    [sym_void_keyword] = ACTIONS(4014),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2313] = {
    [sym__preprocessor_call] = STATE(2313),
    [sym__identifier_token] = ACTIONS(4020),
    [anon_sym_extern] = ACTIONS(4020),
    [anon_sym_alias] = ACTIONS(4020),
    [anon_sym_SEMI] = ACTIONS(4022),
    [anon_sym_global] = ACTIONS(4020),
    [anon_sym_using] = ACTIONS(4020),
    [anon_sym_static] = ACTIONS(4020),
    [anon_sym_LBRACK] = ACTIONS(4024),
    [anon_sym_event] = ACTIONS(4020),
    [anon_sym_LPAREN] = ACTIONS(4024),
    [anon_sym_abstract] = ACTIONS(4020),
    [anon_sym_async] = ACTIONS(4020),
    [anon_sym_const] = ACTIONS(4020),
    [anon_sym_fixed] = ACTIONS(4020),
    [anon_sym_internal] = ACTIONS(4020),
    [anon_sym_new] = ACTIONS(4020),
    [anon_sym_override] = ACTIONS(4020),
    [anon_sym_partial] = ACTIONS(4020),
    [anon_sym_private] = ACTIONS(4020),
    [anon_sym_protected] = ACTIONS(4020),
    [anon_sym_public] = ACTIONS(4020),
    [anon_sym_readonly] = ACTIONS(4020),
    [anon_sym_ref] = ACTIONS(4020),
    [anon_sym_sealed] = ACTIONS(4020),
    [anon_sym_unsafe] = ACTIONS(4020),
    [anon_sym_virtual] = ACTIONS(4020),
    [anon_sym_volatile] = ACTIONS(4020),
    [anon_sym_RBRACE] = ACTIONS(4024),
    [anon_sym_implicit] = ACTIONS(4020),
    [anon_sym_explicit] = ACTIONS(4020),
    [anon_sym_TILDE] = ACTIONS(4024),
    [anon_sym_where] = ACTIONS(4020),
    [anon_sym_class] = ACTIONS(4020),
    [anon_sym_struct] = ACTIONS(4020),
    [anon_sym_notnull] = ACTIONS(4020),
    [anon_sym_unmanaged] = ACTIONS(4020),
    [anon_sym_get] = ACTIONS(4020),
    [anon_sym_set] = ACTIONS(4020),
    [anon_sym_add] = ACTIONS(4020),
    [anon_sym_remove] = ACTIONS(4020),
    [anon_sym_enum] = ACTIONS(4020),
    [anon_sym_interface] = ACTIONS(4020),
    [anon_sym_delegate] = ACTIONS(4020),
    [anon_sym_record] = ACTIONS(4020),
    [anon_sym_namespace] = ACTIONS(4020),
    [anon_sym_var] = ACTIONS(4020),
    [sym_predefined_type] = ACTIONS(4020),
    [anon_sym_when] = ACTIONS(4020),
    [anon_sym_yield] = ACTIONS(4020),
    [anon_sym_from] = ACTIONS(4020),
    [anon_sym_join] = ACTIONS(4020),
    [anon_sym_on] = ACTIONS(4020),
    [anon_sym_equals] = ACTIONS(4020),
    [anon_sym_into] = ACTIONS(4020),
    [anon_sym_let] = ACTIONS(4020),
    [anon_sym_orderby] = ACTIONS(4020),
    [anon_sym_ascending] = ACTIONS(4020),
    [anon_sym_descending] = ACTIONS(4020),
    [anon_sym_group] = ACTIONS(4020),
    [anon_sym_by] = ACTIONS(4020),
    [anon_sym_select] = ACTIONS(4020),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4020),
    [anon_sym_nameof] = ACTIONS(4020),
    [sym_void_keyword] = ACTIONS(4020),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2314] = {
    [sym__preprocessor_call] = STATE(2314),
    [anon_sym_SEMI] = ACTIONS(3474),
    [anon_sym_EQ] = ACTIONS(3476),
    [anon_sym_LT] = ACTIONS(3476),
    [anon_sym_COMMA] = ACTIONS(3474),
    [anon_sym_GT] = ACTIONS(3476),
    [anon_sym_DOT] = ACTIONS(3476),
    [anon_sym_LBRACK] = ACTIONS(3474),
    [anon_sym_RBRACK] = ACTIONS(3474),
    [anon_sym_COLON] = ACTIONS(3474),
    [anon_sym_LPAREN] = ACTIONS(3474),
    [anon_sym_RPAREN] = ACTIONS(3474),
    [anon_sym_in] = ACTIONS(3474),
    [anon_sym_RBRACE] = ACTIONS(3474),
    [anon_sym_EQ_GT] = ACTIONS(3474),
    [anon_sym_where] = ACTIONS(3474),
    [anon_sym_QMARK] = ACTIONS(3476),
    [anon_sym_BANG] = ACTIONS(3476),
    [anon_sym_PLUS_PLUS] = ACTIONS(3474),
    [anon_sym_DASH_DASH] = ACTIONS(3474),
    [anon_sym_PLUS] = ACTIONS(3476),
    [anon_sym_DASH] = ACTIONS(3476),
    [anon_sym_STAR] = ACTIONS(3476),
    [anon_sym_SLASH] = ACTIONS(3476),
    [anon_sym_PERCENT] = ACTIONS(3476),
    [anon_sym_CARET] = ACTIONS(3476),
    [anon_sym_PIPE] = ACTIONS(3476),
    [anon_sym_AMP] = ACTIONS(3476),
    [anon_sym_LT_LT] = ACTIONS(3476),
    [anon_sym_GT_GT] = ACTIONS(3476),
    [anon_sym_EQ_EQ] = ACTIONS(3474),
    [anon_sym_BANG_EQ] = ACTIONS(3474),
    [anon_sym_GT_EQ] = ACTIONS(3474),
    [anon_sym_LT_EQ] = ACTIONS(3474),
    [anon_sym_switch] = ACTIONS(3474),
    [anon_sym_and] = ACTIONS(3474),
    [anon_sym_or] = ACTIONS(3476),
    [anon_sym_PLUS_EQ] = ACTIONS(3474),
    [anon_sym_DASH_EQ] = ACTIONS(3474),
    [anon_sym_STAR_EQ] = ACTIONS(3474),
    [anon_sym_SLASH_EQ] = ACTIONS(3474),
    [anon_sym_PERCENT_EQ] = ACTIONS(3474),
    [anon_sym_AMP_EQ] = ACTIONS(3474),
    [anon_sym_CARET_EQ] = ACTIONS(3474),
    [anon_sym_PIPE_EQ] = ACTIONS(3474),
    [anon_sym_LT_LT_EQ] = ACTIONS(3474),
    [anon_sym_GT_GT_EQ] = ACTIONS(3474),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3474),
    [anon_sym_is] = ACTIONS(3474),
    [anon_sym_DASH_GT] = ACTIONS(3474),
    [anon_sym_from] = ACTIONS(3474),
    [anon_sym_join] = ACTIONS(3474),
    [anon_sym_on] = ACTIONS(3474),
    [anon_sym_equals] = ACTIONS(3474),
    [anon_sym_let] = ACTIONS(3474),
    [anon_sym_orderby] = ACTIONS(3474),
    [anon_sym_group] = ACTIONS(3474),
    [anon_sym_by] = ACTIONS(3474),
    [anon_sym_select] = ACTIONS(3474),
    [anon_sym_DOT_DOT] = ACTIONS(3474),
    [anon_sym_with] = ACTIONS(3474),
    [anon_sym_AMP_AMP] = ACTIONS(3474),
    [anon_sym_PIPE_PIPE] = ACTIONS(3474),
    [anon_sym_QMARK_QMARK] = ACTIONS(3476),
    [anon_sym_as] = ACTIONS(3474),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2315] = {
    [sym__preprocessor_call] = STATE(2315),
    [sym__identifier_token] = ACTIONS(4026),
    [anon_sym_extern] = ACTIONS(4026),
    [anon_sym_alias] = ACTIONS(4026),
    [anon_sym_SEMI] = ACTIONS(4028),
    [anon_sym_global] = ACTIONS(4026),
    [anon_sym_using] = ACTIONS(4026),
    [anon_sym_static] = ACTIONS(4026),
    [anon_sym_LBRACK] = ACTIONS(4030),
    [anon_sym_event] = ACTIONS(4026),
    [anon_sym_LPAREN] = ACTIONS(4030),
    [anon_sym_abstract] = ACTIONS(4026),
    [anon_sym_async] = ACTIONS(4026),
    [anon_sym_const] = ACTIONS(4026),
    [anon_sym_fixed] = ACTIONS(4026),
    [anon_sym_internal] = ACTIONS(4026),
    [anon_sym_new] = ACTIONS(4026),
    [anon_sym_override] = ACTIONS(4026),
    [anon_sym_partial] = ACTIONS(4026),
    [anon_sym_private] = ACTIONS(4026),
    [anon_sym_protected] = ACTIONS(4026),
    [anon_sym_public] = ACTIONS(4026),
    [anon_sym_readonly] = ACTIONS(4026),
    [anon_sym_ref] = ACTIONS(4026),
    [anon_sym_sealed] = ACTIONS(4026),
    [anon_sym_unsafe] = ACTIONS(4026),
    [anon_sym_virtual] = ACTIONS(4026),
    [anon_sym_volatile] = ACTIONS(4026),
    [anon_sym_RBRACE] = ACTIONS(4030),
    [anon_sym_implicit] = ACTIONS(4026),
    [anon_sym_explicit] = ACTIONS(4026),
    [anon_sym_TILDE] = ACTIONS(4030),
    [anon_sym_where] = ACTIONS(4026),
    [anon_sym_class] = ACTIONS(4026),
    [anon_sym_struct] = ACTIONS(4026),
    [anon_sym_notnull] = ACTIONS(4026),
    [anon_sym_unmanaged] = ACTIONS(4026),
    [anon_sym_get] = ACTIONS(4026),
    [anon_sym_set] = ACTIONS(4026),
    [anon_sym_add] = ACTIONS(4026),
    [anon_sym_remove] = ACTIONS(4026),
    [anon_sym_enum] = ACTIONS(4026),
    [anon_sym_interface] = ACTIONS(4026),
    [anon_sym_delegate] = ACTIONS(4026),
    [anon_sym_record] = ACTIONS(4026),
    [anon_sym_namespace] = ACTIONS(4026),
    [anon_sym_var] = ACTIONS(4026),
    [sym_predefined_type] = ACTIONS(4026),
    [anon_sym_when] = ACTIONS(4026),
    [anon_sym_yield] = ACTIONS(4026),
    [anon_sym_from] = ACTIONS(4026),
    [anon_sym_join] = ACTIONS(4026),
    [anon_sym_on] = ACTIONS(4026),
    [anon_sym_equals] = ACTIONS(4026),
    [anon_sym_into] = ACTIONS(4026),
    [anon_sym_let] = ACTIONS(4026),
    [anon_sym_orderby] = ACTIONS(4026),
    [anon_sym_ascending] = ACTIONS(4026),
    [anon_sym_descending] = ACTIONS(4026),
    [anon_sym_group] = ACTIONS(4026),
    [anon_sym_by] = ACTIONS(4026),
    [anon_sym_select] = ACTIONS(4026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4026),
    [anon_sym_nameof] = ACTIONS(4026),
    [sym_void_keyword] = ACTIONS(4026),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2316] = {
    [sym__preprocessor_call] = STATE(2316),
    [sym__identifier_token] = ACTIONS(4032),
    [anon_sym_extern] = ACTIONS(4032),
    [anon_sym_alias] = ACTIONS(4032),
    [anon_sym_global] = ACTIONS(4032),
    [anon_sym_using] = ACTIONS(4032),
    [anon_sym_static] = ACTIONS(4032),
    [anon_sym_EQ] = ACTIONS(4034),
    [anon_sym_LBRACK] = ACTIONS(4034),
    [anon_sym_event] = ACTIONS(4032),
    [anon_sym_LPAREN] = ACTIONS(4034),
    [anon_sym_abstract] = ACTIONS(4032),
    [anon_sym_async] = ACTIONS(4032),
    [anon_sym_const] = ACTIONS(4032),
    [anon_sym_fixed] = ACTIONS(4032),
    [anon_sym_internal] = ACTIONS(4032),
    [anon_sym_new] = ACTIONS(4032),
    [anon_sym_override] = ACTIONS(4032),
    [anon_sym_partial] = ACTIONS(4032),
    [anon_sym_private] = ACTIONS(4032),
    [anon_sym_protected] = ACTIONS(4032),
    [anon_sym_public] = ACTIONS(4032),
    [anon_sym_readonly] = ACTIONS(4032),
    [anon_sym_ref] = ACTIONS(4032),
    [anon_sym_sealed] = ACTIONS(4032),
    [anon_sym_unsafe] = ACTIONS(4032),
    [anon_sym_virtual] = ACTIONS(4032),
    [anon_sym_volatile] = ACTIONS(4032),
    [anon_sym_RBRACE] = ACTIONS(4034),
    [anon_sym_implicit] = ACTIONS(4032),
    [anon_sym_explicit] = ACTIONS(4032),
    [anon_sym_TILDE] = ACTIONS(4034),
    [anon_sym_where] = ACTIONS(4032),
    [anon_sym_class] = ACTIONS(4032),
    [anon_sym_struct] = ACTIONS(4032),
    [anon_sym_notnull] = ACTIONS(4032),
    [anon_sym_unmanaged] = ACTIONS(4032),
    [anon_sym_get] = ACTIONS(4032),
    [anon_sym_set] = ACTIONS(4032),
    [anon_sym_add] = ACTIONS(4032),
    [anon_sym_remove] = ACTIONS(4032),
    [anon_sym_enum] = ACTIONS(4032),
    [anon_sym_interface] = ACTIONS(4032),
    [anon_sym_delegate] = ACTIONS(4032),
    [anon_sym_record] = ACTIONS(4032),
    [anon_sym_namespace] = ACTIONS(4032),
    [anon_sym_var] = ACTIONS(4032),
    [sym_predefined_type] = ACTIONS(4032),
    [anon_sym_when] = ACTIONS(4032),
    [anon_sym_yield] = ACTIONS(4032),
    [anon_sym_from] = ACTIONS(4032),
    [anon_sym_join] = ACTIONS(4032),
    [anon_sym_on] = ACTIONS(4032),
    [anon_sym_equals] = ACTIONS(4032),
    [anon_sym_into] = ACTIONS(4032),
    [anon_sym_let] = ACTIONS(4032),
    [anon_sym_orderby] = ACTIONS(4032),
    [anon_sym_ascending] = ACTIONS(4032),
    [anon_sym_descending] = ACTIONS(4032),
    [anon_sym_group] = ACTIONS(4032),
    [anon_sym_by] = ACTIONS(4032),
    [anon_sym_select] = ACTIONS(4032),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4032),
    [anon_sym_nameof] = ACTIONS(4032),
    [sym_void_keyword] = ACTIONS(4032),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2317] = {
    [sym__preprocessor_call] = STATE(2317),
    [anon_sym_SEMI] = ACTIONS(3514),
    [anon_sym_EQ] = ACTIONS(3516),
    [anon_sym_LT] = ACTIONS(3516),
    [anon_sym_COMMA] = ACTIONS(3514),
    [anon_sym_GT] = ACTIONS(3516),
    [anon_sym_DOT] = ACTIONS(3516),
    [anon_sym_LBRACK] = ACTIONS(3514),
    [anon_sym_RBRACK] = ACTIONS(3514),
    [anon_sym_COLON] = ACTIONS(3514),
    [anon_sym_LPAREN] = ACTIONS(3514),
    [anon_sym_RPAREN] = ACTIONS(3514),
    [anon_sym_in] = ACTIONS(3514),
    [anon_sym_RBRACE] = ACTIONS(3514),
    [anon_sym_EQ_GT] = ACTIONS(3514),
    [anon_sym_where] = ACTIONS(3514),
    [anon_sym_QMARK] = ACTIONS(3516),
    [anon_sym_BANG] = ACTIONS(3516),
    [anon_sym_PLUS_PLUS] = ACTIONS(3514),
    [anon_sym_DASH_DASH] = ACTIONS(3514),
    [anon_sym_PLUS] = ACTIONS(3516),
    [anon_sym_DASH] = ACTIONS(3516),
    [anon_sym_STAR] = ACTIONS(3516),
    [anon_sym_SLASH] = ACTIONS(3516),
    [anon_sym_PERCENT] = ACTIONS(3516),
    [anon_sym_CARET] = ACTIONS(3516),
    [anon_sym_PIPE] = ACTIONS(3516),
    [anon_sym_AMP] = ACTIONS(3516),
    [anon_sym_LT_LT] = ACTIONS(3516),
    [anon_sym_GT_GT] = ACTIONS(3516),
    [anon_sym_EQ_EQ] = ACTIONS(3514),
    [anon_sym_BANG_EQ] = ACTIONS(3514),
    [anon_sym_GT_EQ] = ACTIONS(3514),
    [anon_sym_LT_EQ] = ACTIONS(3514),
    [anon_sym_switch] = ACTIONS(3514),
    [anon_sym_and] = ACTIONS(3514),
    [anon_sym_or] = ACTIONS(3516),
    [anon_sym_PLUS_EQ] = ACTIONS(3514),
    [anon_sym_DASH_EQ] = ACTIONS(3514),
    [anon_sym_STAR_EQ] = ACTIONS(3514),
    [anon_sym_SLASH_EQ] = ACTIONS(3514),
    [anon_sym_PERCENT_EQ] = ACTIONS(3514),
    [anon_sym_AMP_EQ] = ACTIONS(3514),
    [anon_sym_CARET_EQ] = ACTIONS(3514),
    [anon_sym_PIPE_EQ] = ACTIONS(3514),
    [anon_sym_LT_LT_EQ] = ACTIONS(3514),
    [anon_sym_GT_GT_EQ] = ACTIONS(3514),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3514),
    [anon_sym_is] = ACTIONS(3514),
    [anon_sym_DASH_GT] = ACTIONS(3514),
    [anon_sym_from] = ACTIONS(3514),
    [anon_sym_join] = ACTIONS(3514),
    [anon_sym_on] = ACTIONS(3514),
    [anon_sym_equals] = ACTIONS(3514),
    [anon_sym_let] = ACTIONS(3514),
    [anon_sym_orderby] = ACTIONS(3514),
    [anon_sym_group] = ACTIONS(3514),
    [anon_sym_by] = ACTIONS(3514),
    [anon_sym_select] = ACTIONS(3514),
    [anon_sym_DOT_DOT] = ACTIONS(3514),
    [anon_sym_with] = ACTIONS(3514),
    [anon_sym_AMP_AMP] = ACTIONS(3514),
    [anon_sym_PIPE_PIPE] = ACTIONS(3514),
    [anon_sym_QMARK_QMARK] = ACTIONS(3516),
    [anon_sym_as] = ACTIONS(3514),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2318] = {
    [sym__preprocessor_call] = STATE(2318),
    [anon_sym_SEMI] = ACTIONS(3510),
    [anon_sym_EQ] = ACTIONS(3512),
    [anon_sym_LT] = ACTIONS(3512),
    [anon_sym_COMMA] = ACTIONS(3510),
    [anon_sym_GT] = ACTIONS(3512),
    [anon_sym_DOT] = ACTIONS(3512),
    [anon_sym_LBRACK] = ACTIONS(3510),
    [anon_sym_RBRACK] = ACTIONS(3510),
    [anon_sym_COLON] = ACTIONS(3510),
    [anon_sym_LPAREN] = ACTIONS(3510),
    [anon_sym_RPAREN] = ACTIONS(3510),
    [anon_sym_in] = ACTIONS(3510),
    [anon_sym_RBRACE] = ACTIONS(3510),
    [anon_sym_EQ_GT] = ACTIONS(3510),
    [anon_sym_where] = ACTIONS(3510),
    [anon_sym_QMARK] = ACTIONS(3512),
    [anon_sym_BANG] = ACTIONS(3512),
    [anon_sym_PLUS_PLUS] = ACTIONS(3510),
    [anon_sym_DASH_DASH] = ACTIONS(3510),
    [anon_sym_PLUS] = ACTIONS(3512),
    [anon_sym_DASH] = ACTIONS(3512),
    [anon_sym_STAR] = ACTIONS(3512),
    [anon_sym_SLASH] = ACTIONS(3512),
    [anon_sym_PERCENT] = ACTIONS(3512),
    [anon_sym_CARET] = ACTIONS(3512),
    [anon_sym_PIPE] = ACTIONS(3512),
    [anon_sym_AMP] = ACTIONS(3512),
    [anon_sym_LT_LT] = ACTIONS(3512),
    [anon_sym_GT_GT] = ACTIONS(3512),
    [anon_sym_EQ_EQ] = ACTIONS(3510),
    [anon_sym_BANG_EQ] = ACTIONS(3510),
    [anon_sym_GT_EQ] = ACTIONS(3510),
    [anon_sym_LT_EQ] = ACTIONS(3510),
    [anon_sym_switch] = ACTIONS(3510),
    [anon_sym_and] = ACTIONS(3510),
    [anon_sym_or] = ACTIONS(3512),
    [anon_sym_PLUS_EQ] = ACTIONS(3510),
    [anon_sym_DASH_EQ] = ACTIONS(3510),
    [anon_sym_STAR_EQ] = ACTIONS(3510),
    [anon_sym_SLASH_EQ] = ACTIONS(3510),
    [anon_sym_PERCENT_EQ] = ACTIONS(3510),
    [anon_sym_AMP_EQ] = ACTIONS(3510),
    [anon_sym_CARET_EQ] = ACTIONS(3510),
    [anon_sym_PIPE_EQ] = ACTIONS(3510),
    [anon_sym_LT_LT_EQ] = ACTIONS(3510),
    [anon_sym_GT_GT_EQ] = ACTIONS(3510),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3510),
    [anon_sym_is] = ACTIONS(3510),
    [anon_sym_DASH_GT] = ACTIONS(3510),
    [anon_sym_from] = ACTIONS(3510),
    [anon_sym_join] = ACTIONS(3510),
    [anon_sym_on] = ACTIONS(3510),
    [anon_sym_equals] = ACTIONS(3510),
    [anon_sym_let] = ACTIONS(3510),
    [anon_sym_orderby] = ACTIONS(3510),
    [anon_sym_group] = ACTIONS(3510),
    [anon_sym_by] = ACTIONS(3510),
    [anon_sym_select] = ACTIONS(3510),
    [anon_sym_DOT_DOT] = ACTIONS(3510),
    [anon_sym_with] = ACTIONS(3510),
    [anon_sym_AMP_AMP] = ACTIONS(3510),
    [anon_sym_PIPE_PIPE] = ACTIONS(3510),
    [anon_sym_QMARK_QMARK] = ACTIONS(3512),
    [anon_sym_as] = ACTIONS(3510),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2319] = {
    [sym__preprocessor_call] = STATE(2319),
    [anon_sym_SEMI] = ACTIONS(3340),
    [anon_sym_EQ] = ACTIONS(3342),
    [anon_sym_LT] = ACTIONS(3342),
    [anon_sym_COMMA] = ACTIONS(3340),
    [anon_sym_GT] = ACTIONS(3342),
    [anon_sym_DOT] = ACTIONS(3342),
    [anon_sym_LBRACK] = ACTIONS(3340),
    [anon_sym_RBRACK] = ACTIONS(3340),
    [anon_sym_COLON] = ACTIONS(3340),
    [anon_sym_LPAREN] = ACTIONS(4036),
    [anon_sym_RPAREN] = ACTIONS(3340),
    [anon_sym_in] = ACTIONS(3340),
    [anon_sym_RBRACE] = ACTIONS(3340),
    [anon_sym_EQ_GT] = ACTIONS(3340),
    [anon_sym_where] = ACTIONS(3340),
    [anon_sym_QMARK] = ACTIONS(3342),
    [anon_sym_BANG] = ACTIONS(3342),
    [anon_sym_PLUS_PLUS] = ACTIONS(3340),
    [anon_sym_DASH_DASH] = ACTIONS(3340),
    [anon_sym_PLUS] = ACTIONS(3342),
    [anon_sym_DASH] = ACTIONS(3342),
    [anon_sym_STAR] = ACTIONS(3342),
    [anon_sym_SLASH] = ACTIONS(3342),
    [anon_sym_PERCENT] = ACTIONS(3342),
    [anon_sym_CARET] = ACTIONS(3342),
    [anon_sym_PIPE] = ACTIONS(3342),
    [anon_sym_AMP] = ACTIONS(3342),
    [anon_sym_LT_LT] = ACTIONS(3342),
    [anon_sym_GT_GT] = ACTIONS(3342),
    [anon_sym_EQ_EQ] = ACTIONS(3340),
    [anon_sym_BANG_EQ] = ACTIONS(3340),
    [anon_sym_GT_EQ] = ACTIONS(3340),
    [anon_sym_LT_EQ] = ACTIONS(3340),
    [anon_sym_switch] = ACTIONS(3340),
    [anon_sym_and] = ACTIONS(3340),
    [anon_sym_or] = ACTIONS(3342),
    [anon_sym_PLUS_EQ] = ACTIONS(3340),
    [anon_sym_DASH_EQ] = ACTIONS(3340),
    [anon_sym_STAR_EQ] = ACTIONS(3340),
    [anon_sym_SLASH_EQ] = ACTIONS(3340),
    [anon_sym_PERCENT_EQ] = ACTIONS(3340),
    [anon_sym_AMP_EQ] = ACTIONS(3340),
    [anon_sym_CARET_EQ] = ACTIONS(3340),
    [anon_sym_PIPE_EQ] = ACTIONS(3340),
    [anon_sym_LT_LT_EQ] = ACTIONS(3340),
    [anon_sym_GT_GT_EQ] = ACTIONS(3340),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3340),
    [anon_sym_is] = ACTIONS(3340),
    [anon_sym_DASH_GT] = ACTIONS(3340),
    [anon_sym_from] = ACTIONS(3340),
    [anon_sym_join] = ACTIONS(3340),
    [anon_sym_on] = ACTIONS(3340),
    [anon_sym_equals] = ACTIONS(3340),
    [anon_sym_let] = ACTIONS(3340),
    [anon_sym_orderby] = ACTIONS(3340),
    [anon_sym_group] = ACTIONS(3340),
    [anon_sym_by] = ACTIONS(3340),
    [anon_sym_select] = ACTIONS(3340),
    [anon_sym_DOT_DOT] = ACTIONS(3340),
    [anon_sym_with] = ACTIONS(3340),
    [anon_sym_AMP_AMP] = ACTIONS(3340),
    [anon_sym_PIPE_PIPE] = ACTIONS(3340),
    [anon_sym_QMARK_QMARK] = ACTIONS(3342),
    [anon_sym_as] = ACTIONS(3340),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2320] = {
    [sym__preprocessor_call] = STATE(2320),
    [anon_sym_SEMI] = ACTIONS(3506),
    [anon_sym_EQ] = ACTIONS(3508),
    [anon_sym_LT] = ACTIONS(3508),
    [anon_sym_COMMA] = ACTIONS(3506),
    [anon_sym_GT] = ACTIONS(3508),
    [anon_sym_DOT] = ACTIONS(3508),
    [anon_sym_LBRACK] = ACTIONS(3506),
    [anon_sym_RBRACK] = ACTIONS(3506),
    [anon_sym_COLON] = ACTIONS(3506),
    [anon_sym_LPAREN] = ACTIONS(3506),
    [anon_sym_RPAREN] = ACTIONS(3506),
    [anon_sym_in] = ACTIONS(3506),
    [anon_sym_RBRACE] = ACTIONS(3506),
    [anon_sym_EQ_GT] = ACTIONS(3506),
    [anon_sym_where] = ACTIONS(3506),
    [anon_sym_QMARK] = ACTIONS(3508),
    [anon_sym_BANG] = ACTIONS(3508),
    [anon_sym_PLUS_PLUS] = ACTIONS(3506),
    [anon_sym_DASH_DASH] = ACTIONS(3506),
    [anon_sym_PLUS] = ACTIONS(3508),
    [anon_sym_DASH] = ACTIONS(3508),
    [anon_sym_STAR] = ACTIONS(3508),
    [anon_sym_SLASH] = ACTIONS(3508),
    [anon_sym_PERCENT] = ACTIONS(3508),
    [anon_sym_CARET] = ACTIONS(3508),
    [anon_sym_PIPE] = ACTIONS(3508),
    [anon_sym_AMP] = ACTIONS(3508),
    [anon_sym_LT_LT] = ACTIONS(3508),
    [anon_sym_GT_GT] = ACTIONS(3508),
    [anon_sym_EQ_EQ] = ACTIONS(3506),
    [anon_sym_BANG_EQ] = ACTIONS(3506),
    [anon_sym_GT_EQ] = ACTIONS(3506),
    [anon_sym_LT_EQ] = ACTIONS(3506),
    [anon_sym_switch] = ACTIONS(3506),
    [anon_sym_and] = ACTIONS(3506),
    [anon_sym_or] = ACTIONS(3508),
    [anon_sym_PLUS_EQ] = ACTIONS(3506),
    [anon_sym_DASH_EQ] = ACTIONS(3506),
    [anon_sym_STAR_EQ] = ACTIONS(3506),
    [anon_sym_SLASH_EQ] = ACTIONS(3506),
    [anon_sym_PERCENT_EQ] = ACTIONS(3506),
    [anon_sym_AMP_EQ] = ACTIONS(3506),
    [anon_sym_CARET_EQ] = ACTIONS(3506),
    [anon_sym_PIPE_EQ] = ACTIONS(3506),
    [anon_sym_LT_LT_EQ] = ACTIONS(3506),
    [anon_sym_GT_GT_EQ] = ACTIONS(3506),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3506),
    [anon_sym_is] = ACTIONS(3506),
    [anon_sym_DASH_GT] = ACTIONS(3506),
    [anon_sym_from] = ACTIONS(3506),
    [anon_sym_join] = ACTIONS(3506),
    [anon_sym_on] = ACTIONS(3506),
    [anon_sym_equals] = ACTIONS(3506),
    [anon_sym_let] = ACTIONS(3506),
    [anon_sym_orderby] = ACTIONS(3506),
    [anon_sym_group] = ACTIONS(3506),
    [anon_sym_by] = ACTIONS(3506),
    [anon_sym_select] = ACTIONS(3506),
    [anon_sym_DOT_DOT] = ACTIONS(3506),
    [anon_sym_with] = ACTIONS(3506),
    [anon_sym_AMP_AMP] = ACTIONS(3506),
    [anon_sym_PIPE_PIPE] = ACTIONS(3506),
    [anon_sym_QMARK_QMARK] = ACTIONS(3508),
    [anon_sym_as] = ACTIONS(3506),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2321] = {
    [sym__preprocessor_call] = STATE(2321),
    [anon_sym_SEMI] = ACTIONS(3390),
    [anon_sym_EQ] = ACTIONS(3392),
    [anon_sym_LT] = ACTIONS(3392),
    [anon_sym_COMMA] = ACTIONS(3390),
    [anon_sym_GT] = ACTIONS(3392),
    [anon_sym_DOT] = ACTIONS(3392),
    [anon_sym_LBRACK] = ACTIONS(3390),
    [anon_sym_RBRACK] = ACTIONS(3390),
    [anon_sym_COLON] = ACTIONS(3390),
    [anon_sym_LPAREN] = ACTIONS(3390),
    [anon_sym_RPAREN] = ACTIONS(3390),
    [anon_sym_in] = ACTIONS(3390),
    [anon_sym_RBRACE] = ACTIONS(3390),
    [anon_sym_EQ_GT] = ACTIONS(3390),
    [anon_sym_where] = ACTIONS(3390),
    [anon_sym_QMARK] = ACTIONS(3392),
    [anon_sym_BANG] = ACTIONS(3392),
    [anon_sym_PLUS_PLUS] = ACTIONS(3390),
    [anon_sym_DASH_DASH] = ACTIONS(3390),
    [anon_sym_PLUS] = ACTIONS(3392),
    [anon_sym_DASH] = ACTIONS(3392),
    [anon_sym_STAR] = ACTIONS(3392),
    [anon_sym_SLASH] = ACTIONS(3392),
    [anon_sym_PERCENT] = ACTIONS(3392),
    [anon_sym_CARET] = ACTIONS(3392),
    [anon_sym_PIPE] = ACTIONS(3392),
    [anon_sym_AMP] = ACTIONS(3392),
    [anon_sym_LT_LT] = ACTIONS(3392),
    [anon_sym_GT_GT] = ACTIONS(3392),
    [anon_sym_EQ_EQ] = ACTIONS(3390),
    [anon_sym_BANG_EQ] = ACTIONS(3390),
    [anon_sym_GT_EQ] = ACTIONS(3390),
    [anon_sym_LT_EQ] = ACTIONS(3390),
    [anon_sym_switch] = ACTIONS(3390),
    [anon_sym_and] = ACTIONS(3390),
    [anon_sym_or] = ACTIONS(3392),
    [anon_sym_PLUS_EQ] = ACTIONS(3390),
    [anon_sym_DASH_EQ] = ACTIONS(3390),
    [anon_sym_STAR_EQ] = ACTIONS(3390),
    [anon_sym_SLASH_EQ] = ACTIONS(3390),
    [anon_sym_PERCENT_EQ] = ACTIONS(3390),
    [anon_sym_AMP_EQ] = ACTIONS(3390),
    [anon_sym_CARET_EQ] = ACTIONS(3390),
    [anon_sym_PIPE_EQ] = ACTIONS(3390),
    [anon_sym_LT_LT_EQ] = ACTIONS(3390),
    [anon_sym_GT_GT_EQ] = ACTIONS(3390),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3390),
    [anon_sym_is] = ACTIONS(3390),
    [anon_sym_DASH_GT] = ACTIONS(3390),
    [anon_sym_from] = ACTIONS(3390),
    [anon_sym_join] = ACTIONS(3390),
    [anon_sym_on] = ACTIONS(3390),
    [anon_sym_equals] = ACTIONS(3390),
    [anon_sym_let] = ACTIONS(3390),
    [anon_sym_orderby] = ACTIONS(3390),
    [anon_sym_group] = ACTIONS(3390),
    [anon_sym_by] = ACTIONS(3390),
    [anon_sym_select] = ACTIONS(3390),
    [anon_sym_DOT_DOT] = ACTIONS(3390),
    [anon_sym_with] = ACTIONS(3390),
    [anon_sym_AMP_AMP] = ACTIONS(3390),
    [anon_sym_PIPE_PIPE] = ACTIONS(3390),
    [anon_sym_QMARK_QMARK] = ACTIONS(3392),
    [anon_sym_as] = ACTIONS(3390),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2322] = {
    [sym__preprocessor_call] = STATE(2322),
    [anon_sym_SEMI] = ACTIONS(3346),
    [anon_sym_EQ] = ACTIONS(3348),
    [anon_sym_LT] = ACTIONS(3348),
    [anon_sym_COMMA] = ACTIONS(3346),
    [anon_sym_GT] = ACTIONS(3348),
    [anon_sym_DOT] = ACTIONS(3348),
    [anon_sym_LBRACK] = ACTIONS(3346),
    [anon_sym_RBRACK] = ACTIONS(3346),
    [anon_sym_COLON] = ACTIONS(3346),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_RPAREN] = ACTIONS(3346),
    [anon_sym_in] = ACTIONS(3346),
    [anon_sym_RBRACE] = ACTIONS(3346),
    [anon_sym_EQ_GT] = ACTIONS(3346),
    [anon_sym_where] = ACTIONS(3346),
    [anon_sym_QMARK] = ACTIONS(3348),
    [anon_sym_BANG] = ACTIONS(3348),
    [anon_sym_PLUS_PLUS] = ACTIONS(3346),
    [anon_sym_DASH_DASH] = ACTIONS(3346),
    [anon_sym_PLUS] = ACTIONS(3348),
    [anon_sym_DASH] = ACTIONS(3348),
    [anon_sym_STAR] = ACTIONS(3348),
    [anon_sym_SLASH] = ACTIONS(3348),
    [anon_sym_PERCENT] = ACTIONS(3348),
    [anon_sym_CARET] = ACTIONS(3348),
    [anon_sym_PIPE] = ACTIONS(3348),
    [anon_sym_AMP] = ACTIONS(3348),
    [anon_sym_LT_LT] = ACTIONS(3348),
    [anon_sym_GT_GT] = ACTIONS(3348),
    [anon_sym_EQ_EQ] = ACTIONS(3346),
    [anon_sym_BANG_EQ] = ACTIONS(3346),
    [anon_sym_GT_EQ] = ACTIONS(3346),
    [anon_sym_LT_EQ] = ACTIONS(3346),
    [anon_sym_switch] = ACTIONS(3346),
    [anon_sym_and] = ACTIONS(3346),
    [anon_sym_or] = ACTIONS(3348),
    [anon_sym_PLUS_EQ] = ACTIONS(3346),
    [anon_sym_DASH_EQ] = ACTIONS(3346),
    [anon_sym_STAR_EQ] = ACTIONS(3346),
    [anon_sym_SLASH_EQ] = ACTIONS(3346),
    [anon_sym_PERCENT_EQ] = ACTIONS(3346),
    [anon_sym_AMP_EQ] = ACTIONS(3346),
    [anon_sym_CARET_EQ] = ACTIONS(3346),
    [anon_sym_PIPE_EQ] = ACTIONS(3346),
    [anon_sym_LT_LT_EQ] = ACTIONS(3346),
    [anon_sym_GT_GT_EQ] = ACTIONS(3346),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3346),
    [anon_sym_is] = ACTIONS(3346),
    [anon_sym_DASH_GT] = ACTIONS(3346),
    [anon_sym_from] = ACTIONS(3346),
    [anon_sym_join] = ACTIONS(3346),
    [anon_sym_on] = ACTIONS(3346),
    [anon_sym_equals] = ACTIONS(3346),
    [anon_sym_let] = ACTIONS(3346),
    [anon_sym_orderby] = ACTIONS(3346),
    [anon_sym_group] = ACTIONS(3346),
    [anon_sym_by] = ACTIONS(3346),
    [anon_sym_select] = ACTIONS(3346),
    [anon_sym_DOT_DOT] = ACTIONS(3346),
    [anon_sym_with] = ACTIONS(3346),
    [anon_sym_AMP_AMP] = ACTIONS(3346),
    [anon_sym_PIPE_PIPE] = ACTIONS(3346),
    [anon_sym_QMARK_QMARK] = ACTIONS(3348),
    [anon_sym_as] = ACTIONS(3346),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2323] = {
    [sym__preprocessor_call] = STATE(2323),
    [anon_sym_SEMI] = ACTIONS(2771),
    [anon_sym_EQ] = ACTIONS(2769),
    [anon_sym_LT] = ACTIONS(2769),
    [anon_sym_COMMA] = ACTIONS(2771),
    [anon_sym_GT] = ACTIONS(2769),
    [anon_sym_DOT] = ACTIONS(2769),
    [anon_sym_LBRACK] = ACTIONS(2771),
    [anon_sym_RBRACK] = ACTIONS(2771),
    [anon_sym_COLON] = ACTIONS(2771),
    [anon_sym_LPAREN] = ACTIONS(2771),
    [anon_sym_RPAREN] = ACTIONS(2771),
    [anon_sym_in] = ACTIONS(2771),
    [anon_sym_RBRACE] = ACTIONS(2771),
    [anon_sym_EQ_GT] = ACTIONS(2771),
    [anon_sym_where] = ACTIONS(2771),
    [anon_sym_QMARK] = ACTIONS(2769),
    [anon_sym_BANG] = ACTIONS(2769),
    [anon_sym_PLUS_PLUS] = ACTIONS(2771),
    [anon_sym_DASH_DASH] = ACTIONS(2771),
    [anon_sym_PLUS] = ACTIONS(2769),
    [anon_sym_DASH] = ACTIONS(2769),
    [anon_sym_STAR] = ACTIONS(2769),
    [anon_sym_SLASH] = ACTIONS(2769),
    [anon_sym_PERCENT] = ACTIONS(2769),
    [anon_sym_CARET] = ACTIONS(2769),
    [anon_sym_PIPE] = ACTIONS(2769),
    [anon_sym_AMP] = ACTIONS(2769),
    [anon_sym_LT_LT] = ACTIONS(2769),
    [anon_sym_GT_GT] = ACTIONS(2769),
    [anon_sym_EQ_EQ] = ACTIONS(2771),
    [anon_sym_BANG_EQ] = ACTIONS(2771),
    [anon_sym_GT_EQ] = ACTIONS(2771),
    [anon_sym_LT_EQ] = ACTIONS(2771),
    [anon_sym_switch] = ACTIONS(2771),
    [anon_sym_and] = ACTIONS(2771),
    [anon_sym_or] = ACTIONS(2769),
    [anon_sym_PLUS_EQ] = ACTIONS(2771),
    [anon_sym_DASH_EQ] = ACTIONS(2771),
    [anon_sym_STAR_EQ] = ACTIONS(2771),
    [anon_sym_SLASH_EQ] = ACTIONS(2771),
    [anon_sym_PERCENT_EQ] = ACTIONS(2771),
    [anon_sym_AMP_EQ] = ACTIONS(2771),
    [anon_sym_CARET_EQ] = ACTIONS(2771),
    [anon_sym_PIPE_EQ] = ACTIONS(2771),
    [anon_sym_LT_LT_EQ] = ACTIONS(2771),
    [anon_sym_GT_GT_EQ] = ACTIONS(2771),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2771),
    [anon_sym_is] = ACTIONS(2771),
    [anon_sym_DASH_GT] = ACTIONS(2771),
    [anon_sym_from] = ACTIONS(2771),
    [anon_sym_join] = ACTIONS(2771),
    [anon_sym_on] = ACTIONS(2771),
    [anon_sym_equals] = ACTIONS(2771),
    [anon_sym_let] = ACTIONS(2771),
    [anon_sym_orderby] = ACTIONS(2771),
    [anon_sym_group] = ACTIONS(2771),
    [anon_sym_by] = ACTIONS(2771),
    [anon_sym_select] = ACTIONS(2771),
    [anon_sym_DOT_DOT] = ACTIONS(2771),
    [anon_sym_with] = ACTIONS(2771),
    [anon_sym_AMP_AMP] = ACTIONS(2771),
    [anon_sym_PIPE_PIPE] = ACTIONS(2771),
    [anon_sym_QMARK_QMARK] = ACTIONS(2769),
    [anon_sym_as] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2324] = {
    [sym__preprocessor_call] = STATE(2324),
    [anon_sym_SEMI] = ACTIONS(3354),
    [anon_sym_EQ] = ACTIONS(3356),
    [anon_sym_LT] = ACTIONS(3356),
    [anon_sym_COMMA] = ACTIONS(3354),
    [anon_sym_GT] = ACTIONS(3356),
    [anon_sym_DOT] = ACTIONS(3356),
    [anon_sym_LBRACK] = ACTIONS(3354),
    [anon_sym_RBRACK] = ACTIONS(3354),
    [anon_sym_COLON] = ACTIONS(3354),
    [anon_sym_LPAREN] = ACTIONS(3354),
    [anon_sym_RPAREN] = ACTIONS(3354),
    [anon_sym_in] = ACTIONS(3354),
    [anon_sym_RBRACE] = ACTIONS(3354),
    [anon_sym_EQ_GT] = ACTIONS(3354),
    [anon_sym_where] = ACTIONS(3354),
    [anon_sym_QMARK] = ACTIONS(3356),
    [anon_sym_BANG] = ACTIONS(3356),
    [anon_sym_PLUS_PLUS] = ACTIONS(3354),
    [anon_sym_DASH_DASH] = ACTIONS(3354),
    [anon_sym_PLUS] = ACTIONS(3356),
    [anon_sym_DASH] = ACTIONS(3356),
    [anon_sym_STAR] = ACTIONS(3356),
    [anon_sym_SLASH] = ACTIONS(3356),
    [anon_sym_PERCENT] = ACTIONS(3356),
    [anon_sym_CARET] = ACTIONS(3356),
    [anon_sym_PIPE] = ACTIONS(3356),
    [anon_sym_AMP] = ACTIONS(3356),
    [anon_sym_LT_LT] = ACTIONS(3356),
    [anon_sym_GT_GT] = ACTIONS(3356),
    [anon_sym_EQ_EQ] = ACTIONS(3354),
    [anon_sym_BANG_EQ] = ACTIONS(3354),
    [anon_sym_GT_EQ] = ACTIONS(3354),
    [anon_sym_LT_EQ] = ACTIONS(3354),
    [anon_sym_switch] = ACTIONS(3354),
    [anon_sym_and] = ACTIONS(3354),
    [anon_sym_or] = ACTIONS(3356),
    [anon_sym_PLUS_EQ] = ACTIONS(3354),
    [anon_sym_DASH_EQ] = ACTIONS(3354),
    [anon_sym_STAR_EQ] = ACTIONS(3354),
    [anon_sym_SLASH_EQ] = ACTIONS(3354),
    [anon_sym_PERCENT_EQ] = ACTIONS(3354),
    [anon_sym_AMP_EQ] = ACTIONS(3354),
    [anon_sym_CARET_EQ] = ACTIONS(3354),
    [anon_sym_PIPE_EQ] = ACTIONS(3354),
    [anon_sym_LT_LT_EQ] = ACTIONS(3354),
    [anon_sym_GT_GT_EQ] = ACTIONS(3354),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3354),
    [anon_sym_is] = ACTIONS(3354),
    [anon_sym_DASH_GT] = ACTIONS(3354),
    [anon_sym_from] = ACTIONS(3354),
    [anon_sym_join] = ACTIONS(3354),
    [anon_sym_on] = ACTIONS(3354),
    [anon_sym_equals] = ACTIONS(3354),
    [anon_sym_let] = ACTIONS(3354),
    [anon_sym_orderby] = ACTIONS(3354),
    [anon_sym_group] = ACTIONS(3354),
    [anon_sym_by] = ACTIONS(3354),
    [anon_sym_select] = ACTIONS(3354),
    [anon_sym_DOT_DOT] = ACTIONS(3354),
    [anon_sym_with] = ACTIONS(3354),
    [anon_sym_AMP_AMP] = ACTIONS(3354),
    [anon_sym_PIPE_PIPE] = ACTIONS(3354),
    [anon_sym_QMARK_QMARK] = ACTIONS(3356),
    [anon_sym_as] = ACTIONS(3354),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2325] = {
    [sym__preprocessor_call] = STATE(2325),
    [anon_sym_SEMI] = ACTIONS(3394),
    [anon_sym_EQ] = ACTIONS(3396),
    [anon_sym_LT] = ACTIONS(3396),
    [anon_sym_COMMA] = ACTIONS(3394),
    [anon_sym_GT] = ACTIONS(3396),
    [anon_sym_DOT] = ACTIONS(3396),
    [anon_sym_LBRACK] = ACTIONS(3394),
    [anon_sym_RBRACK] = ACTIONS(3394),
    [anon_sym_COLON] = ACTIONS(3394),
    [anon_sym_LPAREN] = ACTIONS(3394),
    [anon_sym_RPAREN] = ACTIONS(3394),
    [anon_sym_in] = ACTIONS(3394),
    [anon_sym_RBRACE] = ACTIONS(3394),
    [anon_sym_EQ_GT] = ACTIONS(3394),
    [anon_sym_where] = ACTIONS(3394),
    [anon_sym_QMARK] = ACTIONS(3396),
    [anon_sym_BANG] = ACTIONS(3396),
    [anon_sym_PLUS_PLUS] = ACTIONS(3394),
    [anon_sym_DASH_DASH] = ACTIONS(3394),
    [anon_sym_PLUS] = ACTIONS(3396),
    [anon_sym_DASH] = ACTIONS(3396),
    [anon_sym_STAR] = ACTIONS(3396),
    [anon_sym_SLASH] = ACTIONS(3396),
    [anon_sym_PERCENT] = ACTIONS(3396),
    [anon_sym_CARET] = ACTIONS(3396),
    [anon_sym_PIPE] = ACTIONS(3396),
    [anon_sym_AMP] = ACTIONS(3396),
    [anon_sym_LT_LT] = ACTIONS(3396),
    [anon_sym_GT_GT] = ACTIONS(3396),
    [anon_sym_EQ_EQ] = ACTIONS(3394),
    [anon_sym_BANG_EQ] = ACTIONS(3394),
    [anon_sym_GT_EQ] = ACTIONS(3394),
    [anon_sym_LT_EQ] = ACTIONS(3394),
    [anon_sym_switch] = ACTIONS(3394),
    [anon_sym_and] = ACTIONS(3394),
    [anon_sym_or] = ACTIONS(3396),
    [anon_sym_PLUS_EQ] = ACTIONS(3394),
    [anon_sym_DASH_EQ] = ACTIONS(3394),
    [anon_sym_STAR_EQ] = ACTIONS(3394),
    [anon_sym_SLASH_EQ] = ACTIONS(3394),
    [anon_sym_PERCENT_EQ] = ACTIONS(3394),
    [anon_sym_AMP_EQ] = ACTIONS(3394),
    [anon_sym_CARET_EQ] = ACTIONS(3394),
    [anon_sym_PIPE_EQ] = ACTIONS(3394),
    [anon_sym_LT_LT_EQ] = ACTIONS(3394),
    [anon_sym_GT_GT_EQ] = ACTIONS(3394),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3394),
    [anon_sym_is] = ACTIONS(3394),
    [anon_sym_DASH_GT] = ACTIONS(3394),
    [anon_sym_from] = ACTIONS(3394),
    [anon_sym_join] = ACTIONS(3394),
    [anon_sym_on] = ACTIONS(3394),
    [anon_sym_equals] = ACTIONS(3394),
    [anon_sym_let] = ACTIONS(3394),
    [anon_sym_orderby] = ACTIONS(3394),
    [anon_sym_group] = ACTIONS(3394),
    [anon_sym_by] = ACTIONS(3394),
    [anon_sym_select] = ACTIONS(3394),
    [anon_sym_DOT_DOT] = ACTIONS(3394),
    [anon_sym_with] = ACTIONS(3394),
    [anon_sym_AMP_AMP] = ACTIONS(3394),
    [anon_sym_PIPE_PIPE] = ACTIONS(3394),
    [anon_sym_QMARK_QMARK] = ACTIONS(3396),
    [anon_sym_as] = ACTIONS(3394),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2326] = {
    [sym__preprocessor_call] = STATE(2326),
    [sym__identifier_token] = ACTIONS(4038),
    [anon_sym_extern] = ACTIONS(4038),
    [anon_sym_alias] = ACTIONS(4038),
    [anon_sym_global] = ACTIONS(4038),
    [anon_sym_using] = ACTIONS(4038),
    [anon_sym_static] = ACTIONS(4038),
    [anon_sym_EQ] = ACTIONS(4040),
    [anon_sym_LBRACK] = ACTIONS(4042),
    [anon_sym_event] = ACTIONS(4038),
    [anon_sym_LPAREN] = ACTIONS(4042),
    [anon_sym_abstract] = ACTIONS(4038),
    [anon_sym_async] = ACTIONS(4038),
    [anon_sym_const] = ACTIONS(4038),
    [anon_sym_fixed] = ACTIONS(4038),
    [anon_sym_internal] = ACTIONS(4038),
    [anon_sym_new] = ACTIONS(4038),
    [anon_sym_override] = ACTIONS(4038),
    [anon_sym_partial] = ACTIONS(4038),
    [anon_sym_private] = ACTIONS(4038),
    [anon_sym_protected] = ACTIONS(4038),
    [anon_sym_public] = ACTIONS(4038),
    [anon_sym_readonly] = ACTIONS(4038),
    [anon_sym_ref] = ACTIONS(4038),
    [anon_sym_sealed] = ACTIONS(4038),
    [anon_sym_unsafe] = ACTIONS(4038),
    [anon_sym_virtual] = ACTIONS(4038),
    [anon_sym_volatile] = ACTIONS(4038),
    [anon_sym_RBRACE] = ACTIONS(4042),
    [anon_sym_implicit] = ACTIONS(4038),
    [anon_sym_explicit] = ACTIONS(4038),
    [anon_sym_TILDE] = ACTIONS(4042),
    [anon_sym_where] = ACTIONS(4038),
    [anon_sym_class] = ACTIONS(4038),
    [anon_sym_struct] = ACTIONS(4038),
    [anon_sym_notnull] = ACTIONS(4038),
    [anon_sym_unmanaged] = ACTIONS(4038),
    [anon_sym_get] = ACTIONS(4038),
    [anon_sym_set] = ACTIONS(4038),
    [anon_sym_add] = ACTIONS(4038),
    [anon_sym_remove] = ACTIONS(4038),
    [anon_sym_enum] = ACTIONS(4038),
    [anon_sym_interface] = ACTIONS(4038),
    [anon_sym_delegate] = ACTIONS(4038),
    [anon_sym_record] = ACTIONS(4038),
    [anon_sym_namespace] = ACTIONS(4038),
    [anon_sym_var] = ACTIONS(4038),
    [sym_predefined_type] = ACTIONS(4038),
    [anon_sym_when] = ACTIONS(4038),
    [anon_sym_yield] = ACTIONS(4038),
    [anon_sym_from] = ACTIONS(4038),
    [anon_sym_join] = ACTIONS(4038),
    [anon_sym_on] = ACTIONS(4038),
    [anon_sym_equals] = ACTIONS(4038),
    [anon_sym_into] = ACTIONS(4038),
    [anon_sym_let] = ACTIONS(4038),
    [anon_sym_orderby] = ACTIONS(4038),
    [anon_sym_ascending] = ACTIONS(4038),
    [anon_sym_descending] = ACTIONS(4038),
    [anon_sym_group] = ACTIONS(4038),
    [anon_sym_by] = ACTIONS(4038),
    [anon_sym_select] = ACTIONS(4038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4038),
    [anon_sym_nameof] = ACTIONS(4038),
    [sym_void_keyword] = ACTIONS(4038),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2327] = {
    [sym__preprocessor_call] = STATE(2327),
    [anon_sym_SEMI] = ACTIONS(2993),
    [anon_sym_EQ] = ACTIONS(2995),
    [anon_sym_LT] = ACTIONS(2995),
    [anon_sym_COMMA] = ACTIONS(2993),
    [anon_sym_GT] = ACTIONS(2995),
    [anon_sym_DOT] = ACTIONS(2995),
    [anon_sym_LBRACK] = ACTIONS(2993),
    [anon_sym_RBRACK] = ACTIONS(2993),
    [anon_sym_COLON] = ACTIONS(2993),
    [anon_sym_LPAREN] = ACTIONS(2993),
    [anon_sym_RPAREN] = ACTIONS(2993),
    [anon_sym_in] = ACTIONS(2993),
    [anon_sym_RBRACE] = ACTIONS(2993),
    [anon_sym_EQ_GT] = ACTIONS(2993),
    [anon_sym_where] = ACTIONS(2993),
    [anon_sym_QMARK] = ACTIONS(2995),
    [anon_sym_BANG] = ACTIONS(2995),
    [anon_sym_PLUS_PLUS] = ACTIONS(2993),
    [anon_sym_DASH_DASH] = ACTIONS(2993),
    [anon_sym_PLUS] = ACTIONS(2995),
    [anon_sym_DASH] = ACTIONS(2995),
    [anon_sym_STAR] = ACTIONS(2995),
    [anon_sym_SLASH] = ACTIONS(2995),
    [anon_sym_PERCENT] = ACTIONS(2995),
    [anon_sym_CARET] = ACTIONS(2995),
    [anon_sym_PIPE] = ACTIONS(2995),
    [anon_sym_AMP] = ACTIONS(2995),
    [anon_sym_LT_LT] = ACTIONS(2995),
    [anon_sym_GT_GT] = ACTIONS(2995),
    [anon_sym_EQ_EQ] = ACTIONS(2993),
    [anon_sym_BANG_EQ] = ACTIONS(2993),
    [anon_sym_GT_EQ] = ACTIONS(2993),
    [anon_sym_LT_EQ] = ACTIONS(2993),
    [anon_sym_switch] = ACTIONS(2993),
    [anon_sym_and] = ACTIONS(2993),
    [anon_sym_or] = ACTIONS(2995),
    [anon_sym_PLUS_EQ] = ACTIONS(2993),
    [anon_sym_DASH_EQ] = ACTIONS(2993),
    [anon_sym_STAR_EQ] = ACTIONS(2993),
    [anon_sym_SLASH_EQ] = ACTIONS(2993),
    [anon_sym_PERCENT_EQ] = ACTIONS(2993),
    [anon_sym_AMP_EQ] = ACTIONS(2993),
    [anon_sym_CARET_EQ] = ACTIONS(2993),
    [anon_sym_PIPE_EQ] = ACTIONS(2993),
    [anon_sym_LT_LT_EQ] = ACTIONS(2993),
    [anon_sym_GT_GT_EQ] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2993),
    [anon_sym_is] = ACTIONS(2993),
    [anon_sym_DASH_GT] = ACTIONS(2993),
    [anon_sym_from] = ACTIONS(2993),
    [anon_sym_join] = ACTIONS(2993),
    [anon_sym_on] = ACTIONS(2993),
    [anon_sym_equals] = ACTIONS(2993),
    [anon_sym_let] = ACTIONS(2993),
    [anon_sym_orderby] = ACTIONS(2993),
    [anon_sym_group] = ACTIONS(2993),
    [anon_sym_by] = ACTIONS(2993),
    [anon_sym_select] = ACTIONS(2993),
    [anon_sym_DOT_DOT] = ACTIONS(2993),
    [anon_sym_with] = ACTIONS(2993),
    [anon_sym_AMP_AMP] = ACTIONS(2993),
    [anon_sym_PIPE_PIPE] = ACTIONS(2993),
    [anon_sym_QMARK_QMARK] = ACTIONS(2995),
    [anon_sym_as] = ACTIONS(2993),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2328] = {
    [sym__preprocessor_call] = STATE(2328),
    [anon_sym_SEMI] = ACTIONS(3482),
    [anon_sym_EQ] = ACTIONS(3484),
    [anon_sym_LT] = ACTIONS(3484),
    [anon_sym_COMMA] = ACTIONS(3482),
    [anon_sym_GT] = ACTIONS(3484),
    [anon_sym_DOT] = ACTIONS(3484),
    [anon_sym_LBRACK] = ACTIONS(3482),
    [anon_sym_RBRACK] = ACTIONS(3482),
    [anon_sym_COLON] = ACTIONS(3482),
    [anon_sym_LPAREN] = ACTIONS(3482),
    [anon_sym_RPAREN] = ACTIONS(3482),
    [anon_sym_in] = ACTIONS(3482),
    [anon_sym_RBRACE] = ACTIONS(3482),
    [anon_sym_EQ_GT] = ACTIONS(3482),
    [anon_sym_where] = ACTIONS(3482),
    [anon_sym_QMARK] = ACTIONS(3484),
    [anon_sym_BANG] = ACTIONS(3484),
    [anon_sym_PLUS_PLUS] = ACTIONS(3482),
    [anon_sym_DASH_DASH] = ACTIONS(3482),
    [anon_sym_PLUS] = ACTIONS(3484),
    [anon_sym_DASH] = ACTIONS(3484),
    [anon_sym_STAR] = ACTIONS(3484),
    [anon_sym_SLASH] = ACTIONS(3484),
    [anon_sym_PERCENT] = ACTIONS(3484),
    [anon_sym_CARET] = ACTIONS(3484),
    [anon_sym_PIPE] = ACTIONS(3484),
    [anon_sym_AMP] = ACTIONS(3484),
    [anon_sym_LT_LT] = ACTIONS(3484),
    [anon_sym_GT_GT] = ACTIONS(3484),
    [anon_sym_EQ_EQ] = ACTIONS(3482),
    [anon_sym_BANG_EQ] = ACTIONS(3482),
    [anon_sym_GT_EQ] = ACTIONS(3482),
    [anon_sym_LT_EQ] = ACTIONS(3482),
    [anon_sym_switch] = ACTIONS(3482),
    [anon_sym_and] = ACTIONS(3482),
    [anon_sym_or] = ACTIONS(3484),
    [anon_sym_PLUS_EQ] = ACTIONS(3482),
    [anon_sym_DASH_EQ] = ACTIONS(3482),
    [anon_sym_STAR_EQ] = ACTIONS(3482),
    [anon_sym_SLASH_EQ] = ACTIONS(3482),
    [anon_sym_PERCENT_EQ] = ACTIONS(3482),
    [anon_sym_AMP_EQ] = ACTIONS(3482),
    [anon_sym_CARET_EQ] = ACTIONS(3482),
    [anon_sym_PIPE_EQ] = ACTIONS(3482),
    [anon_sym_LT_LT_EQ] = ACTIONS(3482),
    [anon_sym_GT_GT_EQ] = ACTIONS(3482),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3482),
    [anon_sym_is] = ACTIONS(3482),
    [anon_sym_DASH_GT] = ACTIONS(3482),
    [anon_sym_from] = ACTIONS(3482),
    [anon_sym_join] = ACTIONS(3482),
    [anon_sym_on] = ACTIONS(3482),
    [anon_sym_equals] = ACTIONS(3482),
    [anon_sym_let] = ACTIONS(3482),
    [anon_sym_orderby] = ACTIONS(3482),
    [anon_sym_group] = ACTIONS(3482),
    [anon_sym_by] = ACTIONS(3482),
    [anon_sym_select] = ACTIONS(3482),
    [anon_sym_DOT_DOT] = ACTIONS(3482),
    [anon_sym_with] = ACTIONS(3482),
    [anon_sym_AMP_AMP] = ACTIONS(3482),
    [anon_sym_PIPE_PIPE] = ACTIONS(3482),
    [anon_sym_QMARK_QMARK] = ACTIONS(3484),
    [anon_sym_as] = ACTIONS(3482),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2329] = {
    [sym__preprocessor_call] = STATE(2329),
    [anon_sym_SEMI] = ACTIONS(3502),
    [anon_sym_EQ] = ACTIONS(3504),
    [anon_sym_LT] = ACTIONS(3504),
    [anon_sym_COMMA] = ACTIONS(3502),
    [anon_sym_GT] = ACTIONS(3504),
    [anon_sym_DOT] = ACTIONS(3504),
    [anon_sym_LBRACK] = ACTIONS(3502),
    [anon_sym_RBRACK] = ACTIONS(3502),
    [anon_sym_COLON] = ACTIONS(3502),
    [anon_sym_LPAREN] = ACTIONS(3502),
    [anon_sym_RPAREN] = ACTIONS(3502),
    [anon_sym_in] = ACTIONS(3502),
    [anon_sym_RBRACE] = ACTIONS(3502),
    [anon_sym_EQ_GT] = ACTIONS(3502),
    [anon_sym_where] = ACTIONS(3502),
    [anon_sym_QMARK] = ACTIONS(3504),
    [anon_sym_BANG] = ACTIONS(3504),
    [anon_sym_PLUS_PLUS] = ACTIONS(3502),
    [anon_sym_DASH_DASH] = ACTIONS(3502),
    [anon_sym_PLUS] = ACTIONS(3504),
    [anon_sym_DASH] = ACTIONS(3504),
    [anon_sym_STAR] = ACTIONS(3504),
    [anon_sym_SLASH] = ACTIONS(3504),
    [anon_sym_PERCENT] = ACTIONS(3504),
    [anon_sym_CARET] = ACTIONS(3504),
    [anon_sym_PIPE] = ACTIONS(3504),
    [anon_sym_AMP] = ACTIONS(3504),
    [anon_sym_LT_LT] = ACTIONS(3504),
    [anon_sym_GT_GT] = ACTIONS(3504),
    [anon_sym_EQ_EQ] = ACTIONS(3502),
    [anon_sym_BANG_EQ] = ACTIONS(3502),
    [anon_sym_GT_EQ] = ACTIONS(3502),
    [anon_sym_LT_EQ] = ACTIONS(3502),
    [anon_sym_switch] = ACTIONS(3502),
    [anon_sym_and] = ACTIONS(3502),
    [anon_sym_or] = ACTIONS(3504),
    [anon_sym_PLUS_EQ] = ACTIONS(3502),
    [anon_sym_DASH_EQ] = ACTIONS(3502),
    [anon_sym_STAR_EQ] = ACTIONS(3502),
    [anon_sym_SLASH_EQ] = ACTIONS(3502),
    [anon_sym_PERCENT_EQ] = ACTIONS(3502),
    [anon_sym_AMP_EQ] = ACTIONS(3502),
    [anon_sym_CARET_EQ] = ACTIONS(3502),
    [anon_sym_PIPE_EQ] = ACTIONS(3502),
    [anon_sym_LT_LT_EQ] = ACTIONS(3502),
    [anon_sym_GT_GT_EQ] = ACTIONS(3502),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3502),
    [anon_sym_is] = ACTIONS(3502),
    [anon_sym_DASH_GT] = ACTIONS(3502),
    [anon_sym_from] = ACTIONS(3502),
    [anon_sym_join] = ACTIONS(3502),
    [anon_sym_on] = ACTIONS(3502),
    [anon_sym_equals] = ACTIONS(3502),
    [anon_sym_let] = ACTIONS(3502),
    [anon_sym_orderby] = ACTIONS(3502),
    [anon_sym_group] = ACTIONS(3502),
    [anon_sym_by] = ACTIONS(3502),
    [anon_sym_select] = ACTIONS(3502),
    [anon_sym_DOT_DOT] = ACTIONS(3502),
    [anon_sym_with] = ACTIONS(3502),
    [anon_sym_AMP_AMP] = ACTIONS(3502),
    [anon_sym_PIPE_PIPE] = ACTIONS(3502),
    [anon_sym_QMARK_QMARK] = ACTIONS(3504),
    [anon_sym_as] = ACTIONS(3502),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2330] = {
    [sym__preprocessor_call] = STATE(2330),
    [anon_sym_SEMI] = ACTIONS(3422),
    [anon_sym_EQ] = ACTIONS(3424),
    [anon_sym_LT] = ACTIONS(3424),
    [anon_sym_COMMA] = ACTIONS(3422),
    [anon_sym_GT] = ACTIONS(3424),
    [anon_sym_DOT] = ACTIONS(3424),
    [anon_sym_LBRACK] = ACTIONS(3422),
    [anon_sym_RBRACK] = ACTIONS(3422),
    [anon_sym_COLON] = ACTIONS(3422),
    [anon_sym_LPAREN] = ACTIONS(3422),
    [anon_sym_RPAREN] = ACTIONS(3422),
    [anon_sym_in] = ACTIONS(3422),
    [anon_sym_RBRACE] = ACTIONS(3422),
    [anon_sym_EQ_GT] = ACTIONS(3422),
    [anon_sym_where] = ACTIONS(3422),
    [anon_sym_QMARK] = ACTIONS(3424),
    [anon_sym_BANG] = ACTIONS(3424),
    [anon_sym_PLUS_PLUS] = ACTIONS(3422),
    [anon_sym_DASH_DASH] = ACTIONS(3422),
    [anon_sym_PLUS] = ACTIONS(3424),
    [anon_sym_DASH] = ACTIONS(3424),
    [anon_sym_STAR] = ACTIONS(3424),
    [anon_sym_SLASH] = ACTIONS(3424),
    [anon_sym_PERCENT] = ACTIONS(3424),
    [anon_sym_CARET] = ACTIONS(3424),
    [anon_sym_PIPE] = ACTIONS(3424),
    [anon_sym_AMP] = ACTIONS(3424),
    [anon_sym_LT_LT] = ACTIONS(3424),
    [anon_sym_GT_GT] = ACTIONS(3424),
    [anon_sym_EQ_EQ] = ACTIONS(3422),
    [anon_sym_BANG_EQ] = ACTIONS(3422),
    [anon_sym_GT_EQ] = ACTIONS(3422),
    [anon_sym_LT_EQ] = ACTIONS(3422),
    [anon_sym_switch] = ACTIONS(3422),
    [anon_sym_and] = ACTIONS(3422),
    [anon_sym_or] = ACTIONS(3424),
    [anon_sym_PLUS_EQ] = ACTIONS(3422),
    [anon_sym_DASH_EQ] = ACTIONS(3422),
    [anon_sym_STAR_EQ] = ACTIONS(3422),
    [anon_sym_SLASH_EQ] = ACTIONS(3422),
    [anon_sym_PERCENT_EQ] = ACTIONS(3422),
    [anon_sym_AMP_EQ] = ACTIONS(3422),
    [anon_sym_CARET_EQ] = ACTIONS(3422),
    [anon_sym_PIPE_EQ] = ACTIONS(3422),
    [anon_sym_LT_LT_EQ] = ACTIONS(3422),
    [anon_sym_GT_GT_EQ] = ACTIONS(3422),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3422),
    [anon_sym_is] = ACTIONS(3422),
    [anon_sym_DASH_GT] = ACTIONS(3422),
    [anon_sym_from] = ACTIONS(3422),
    [anon_sym_join] = ACTIONS(3422),
    [anon_sym_on] = ACTIONS(3422),
    [anon_sym_equals] = ACTIONS(3422),
    [anon_sym_let] = ACTIONS(3422),
    [anon_sym_orderby] = ACTIONS(3422),
    [anon_sym_group] = ACTIONS(3422),
    [anon_sym_by] = ACTIONS(3422),
    [anon_sym_select] = ACTIONS(3422),
    [anon_sym_DOT_DOT] = ACTIONS(3422),
    [anon_sym_with] = ACTIONS(3422),
    [anon_sym_AMP_AMP] = ACTIONS(3422),
    [anon_sym_PIPE_PIPE] = ACTIONS(3422),
    [anon_sym_QMARK_QMARK] = ACTIONS(3424),
    [anon_sym_as] = ACTIONS(3422),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2331] = {
    [sym__preprocessor_call] = STATE(2331),
    [sym__identifier_token] = ACTIONS(4044),
    [anon_sym_extern] = ACTIONS(4044),
    [anon_sym_alias] = ACTIONS(4044),
    [anon_sym_SEMI] = ACTIONS(4046),
    [anon_sym_global] = ACTIONS(4044),
    [anon_sym_using] = ACTIONS(4044),
    [anon_sym_static] = ACTIONS(4044),
    [anon_sym_LBRACK] = ACTIONS(4048),
    [anon_sym_event] = ACTIONS(4044),
    [anon_sym_LPAREN] = ACTIONS(4048),
    [anon_sym_abstract] = ACTIONS(4044),
    [anon_sym_async] = ACTIONS(4044),
    [anon_sym_const] = ACTIONS(4044),
    [anon_sym_fixed] = ACTIONS(4044),
    [anon_sym_internal] = ACTIONS(4044),
    [anon_sym_new] = ACTIONS(4044),
    [anon_sym_override] = ACTIONS(4044),
    [anon_sym_partial] = ACTIONS(4044),
    [anon_sym_private] = ACTIONS(4044),
    [anon_sym_protected] = ACTIONS(4044),
    [anon_sym_public] = ACTIONS(4044),
    [anon_sym_readonly] = ACTIONS(4044),
    [anon_sym_ref] = ACTIONS(4044),
    [anon_sym_sealed] = ACTIONS(4044),
    [anon_sym_unsafe] = ACTIONS(4044),
    [anon_sym_virtual] = ACTIONS(4044),
    [anon_sym_volatile] = ACTIONS(4044),
    [anon_sym_RBRACE] = ACTIONS(4048),
    [anon_sym_implicit] = ACTIONS(4044),
    [anon_sym_explicit] = ACTIONS(4044),
    [anon_sym_TILDE] = ACTIONS(4048),
    [anon_sym_where] = ACTIONS(4044),
    [anon_sym_class] = ACTIONS(4044),
    [anon_sym_struct] = ACTIONS(4044),
    [anon_sym_notnull] = ACTIONS(4044),
    [anon_sym_unmanaged] = ACTIONS(4044),
    [anon_sym_get] = ACTIONS(4044),
    [anon_sym_set] = ACTIONS(4044),
    [anon_sym_add] = ACTIONS(4044),
    [anon_sym_remove] = ACTIONS(4044),
    [anon_sym_enum] = ACTIONS(4044),
    [anon_sym_interface] = ACTIONS(4044),
    [anon_sym_delegate] = ACTIONS(4044),
    [anon_sym_record] = ACTIONS(4044),
    [anon_sym_namespace] = ACTIONS(4044),
    [anon_sym_var] = ACTIONS(4044),
    [sym_predefined_type] = ACTIONS(4044),
    [anon_sym_when] = ACTIONS(4044),
    [anon_sym_yield] = ACTIONS(4044),
    [anon_sym_from] = ACTIONS(4044),
    [anon_sym_join] = ACTIONS(4044),
    [anon_sym_on] = ACTIONS(4044),
    [anon_sym_equals] = ACTIONS(4044),
    [anon_sym_into] = ACTIONS(4044),
    [anon_sym_let] = ACTIONS(4044),
    [anon_sym_orderby] = ACTIONS(4044),
    [anon_sym_ascending] = ACTIONS(4044),
    [anon_sym_descending] = ACTIONS(4044),
    [anon_sym_group] = ACTIONS(4044),
    [anon_sym_by] = ACTIONS(4044),
    [anon_sym_select] = ACTIONS(4044),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4044),
    [anon_sym_nameof] = ACTIONS(4044),
    [sym_void_keyword] = ACTIONS(4044),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2332] = {
    [sym__preprocessor_call] = STATE(2332),
    [sym__identifier_token] = ACTIONS(4050),
    [anon_sym_extern] = ACTIONS(4050),
    [anon_sym_alias] = ACTIONS(4050),
    [anon_sym_SEMI] = ACTIONS(4052),
    [anon_sym_global] = ACTIONS(4050),
    [anon_sym_using] = ACTIONS(4050),
    [anon_sym_static] = ACTIONS(4050),
    [anon_sym_LBRACK] = ACTIONS(4054),
    [anon_sym_event] = ACTIONS(4050),
    [anon_sym_LPAREN] = ACTIONS(4054),
    [anon_sym_abstract] = ACTIONS(4050),
    [anon_sym_async] = ACTIONS(4050),
    [anon_sym_const] = ACTIONS(4050),
    [anon_sym_fixed] = ACTIONS(4050),
    [anon_sym_internal] = ACTIONS(4050),
    [anon_sym_new] = ACTIONS(4050),
    [anon_sym_override] = ACTIONS(4050),
    [anon_sym_partial] = ACTIONS(4050),
    [anon_sym_private] = ACTIONS(4050),
    [anon_sym_protected] = ACTIONS(4050),
    [anon_sym_public] = ACTIONS(4050),
    [anon_sym_readonly] = ACTIONS(4050),
    [anon_sym_ref] = ACTIONS(4050),
    [anon_sym_sealed] = ACTIONS(4050),
    [anon_sym_unsafe] = ACTIONS(4050),
    [anon_sym_virtual] = ACTIONS(4050),
    [anon_sym_volatile] = ACTIONS(4050),
    [anon_sym_RBRACE] = ACTIONS(4054),
    [anon_sym_implicit] = ACTIONS(4050),
    [anon_sym_explicit] = ACTIONS(4050),
    [anon_sym_TILDE] = ACTIONS(4054),
    [anon_sym_where] = ACTIONS(4050),
    [anon_sym_class] = ACTIONS(4050),
    [anon_sym_struct] = ACTIONS(4050),
    [anon_sym_notnull] = ACTIONS(4050),
    [anon_sym_unmanaged] = ACTIONS(4050),
    [anon_sym_get] = ACTIONS(4050),
    [anon_sym_set] = ACTIONS(4050),
    [anon_sym_add] = ACTIONS(4050),
    [anon_sym_remove] = ACTIONS(4050),
    [anon_sym_enum] = ACTIONS(4050),
    [anon_sym_interface] = ACTIONS(4050),
    [anon_sym_delegate] = ACTIONS(4050),
    [anon_sym_record] = ACTIONS(4050),
    [anon_sym_namespace] = ACTIONS(4050),
    [anon_sym_var] = ACTIONS(4050),
    [sym_predefined_type] = ACTIONS(4050),
    [anon_sym_when] = ACTIONS(4050),
    [anon_sym_yield] = ACTIONS(4050),
    [anon_sym_from] = ACTIONS(4050),
    [anon_sym_join] = ACTIONS(4050),
    [anon_sym_on] = ACTIONS(4050),
    [anon_sym_equals] = ACTIONS(4050),
    [anon_sym_into] = ACTIONS(4050),
    [anon_sym_let] = ACTIONS(4050),
    [anon_sym_orderby] = ACTIONS(4050),
    [anon_sym_ascending] = ACTIONS(4050),
    [anon_sym_descending] = ACTIONS(4050),
    [anon_sym_group] = ACTIONS(4050),
    [anon_sym_by] = ACTIONS(4050),
    [anon_sym_select] = ACTIONS(4050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4050),
    [anon_sym_nameof] = ACTIONS(4050),
    [sym_void_keyword] = ACTIONS(4050),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2333] = {
    [sym__preprocessor_call] = STATE(2333),
    [sym__identifier_token] = ACTIONS(4056),
    [anon_sym_extern] = ACTIONS(4056),
    [anon_sym_alias] = ACTIONS(4056),
    [anon_sym_SEMI] = ACTIONS(4058),
    [anon_sym_global] = ACTIONS(4056),
    [anon_sym_using] = ACTIONS(4056),
    [anon_sym_static] = ACTIONS(4056),
    [anon_sym_LBRACK] = ACTIONS(4060),
    [anon_sym_event] = ACTIONS(4056),
    [anon_sym_LPAREN] = ACTIONS(4060),
    [anon_sym_abstract] = ACTIONS(4056),
    [anon_sym_async] = ACTIONS(4056),
    [anon_sym_const] = ACTIONS(4056),
    [anon_sym_fixed] = ACTIONS(4056),
    [anon_sym_internal] = ACTIONS(4056),
    [anon_sym_new] = ACTIONS(4056),
    [anon_sym_override] = ACTIONS(4056),
    [anon_sym_partial] = ACTIONS(4056),
    [anon_sym_private] = ACTIONS(4056),
    [anon_sym_protected] = ACTIONS(4056),
    [anon_sym_public] = ACTIONS(4056),
    [anon_sym_readonly] = ACTIONS(4056),
    [anon_sym_ref] = ACTIONS(4056),
    [anon_sym_sealed] = ACTIONS(4056),
    [anon_sym_unsafe] = ACTIONS(4056),
    [anon_sym_virtual] = ACTIONS(4056),
    [anon_sym_volatile] = ACTIONS(4056),
    [anon_sym_RBRACE] = ACTIONS(4060),
    [anon_sym_implicit] = ACTIONS(4056),
    [anon_sym_explicit] = ACTIONS(4056),
    [anon_sym_TILDE] = ACTIONS(4060),
    [anon_sym_where] = ACTIONS(4056),
    [anon_sym_class] = ACTIONS(4056),
    [anon_sym_struct] = ACTIONS(4056),
    [anon_sym_notnull] = ACTIONS(4056),
    [anon_sym_unmanaged] = ACTIONS(4056),
    [anon_sym_get] = ACTIONS(4056),
    [anon_sym_set] = ACTIONS(4056),
    [anon_sym_add] = ACTIONS(4056),
    [anon_sym_remove] = ACTIONS(4056),
    [anon_sym_enum] = ACTIONS(4056),
    [anon_sym_interface] = ACTIONS(4056),
    [anon_sym_delegate] = ACTIONS(4056),
    [anon_sym_record] = ACTIONS(4056),
    [anon_sym_namespace] = ACTIONS(4056),
    [anon_sym_var] = ACTIONS(4056),
    [sym_predefined_type] = ACTIONS(4056),
    [anon_sym_when] = ACTIONS(4056),
    [anon_sym_yield] = ACTIONS(4056),
    [anon_sym_from] = ACTIONS(4056),
    [anon_sym_join] = ACTIONS(4056),
    [anon_sym_on] = ACTIONS(4056),
    [anon_sym_equals] = ACTIONS(4056),
    [anon_sym_into] = ACTIONS(4056),
    [anon_sym_let] = ACTIONS(4056),
    [anon_sym_orderby] = ACTIONS(4056),
    [anon_sym_ascending] = ACTIONS(4056),
    [anon_sym_descending] = ACTIONS(4056),
    [anon_sym_group] = ACTIONS(4056),
    [anon_sym_by] = ACTIONS(4056),
    [anon_sym_select] = ACTIONS(4056),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4056),
    [anon_sym_nameof] = ACTIONS(4056),
    [sym_void_keyword] = ACTIONS(4056),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2334] = {
    [sym__preprocessor_call] = STATE(2334),
    [sym__identifier_token] = ACTIONS(4062),
    [anon_sym_extern] = ACTIONS(4062),
    [anon_sym_alias] = ACTIONS(4062),
    [anon_sym_SEMI] = ACTIONS(4064),
    [anon_sym_global] = ACTIONS(4062),
    [anon_sym_using] = ACTIONS(4062),
    [anon_sym_static] = ACTIONS(4062),
    [anon_sym_LBRACK] = ACTIONS(4066),
    [anon_sym_event] = ACTIONS(4062),
    [anon_sym_LPAREN] = ACTIONS(4066),
    [anon_sym_abstract] = ACTIONS(4062),
    [anon_sym_async] = ACTIONS(4062),
    [anon_sym_const] = ACTIONS(4062),
    [anon_sym_fixed] = ACTIONS(4062),
    [anon_sym_internal] = ACTIONS(4062),
    [anon_sym_new] = ACTIONS(4062),
    [anon_sym_override] = ACTIONS(4062),
    [anon_sym_partial] = ACTIONS(4062),
    [anon_sym_private] = ACTIONS(4062),
    [anon_sym_protected] = ACTIONS(4062),
    [anon_sym_public] = ACTIONS(4062),
    [anon_sym_readonly] = ACTIONS(4062),
    [anon_sym_ref] = ACTIONS(4062),
    [anon_sym_sealed] = ACTIONS(4062),
    [anon_sym_unsafe] = ACTIONS(4062),
    [anon_sym_virtual] = ACTIONS(4062),
    [anon_sym_volatile] = ACTIONS(4062),
    [anon_sym_RBRACE] = ACTIONS(4066),
    [anon_sym_implicit] = ACTIONS(4062),
    [anon_sym_explicit] = ACTIONS(4062),
    [anon_sym_TILDE] = ACTIONS(4066),
    [anon_sym_where] = ACTIONS(4062),
    [anon_sym_class] = ACTIONS(4062),
    [anon_sym_struct] = ACTIONS(4062),
    [anon_sym_notnull] = ACTIONS(4062),
    [anon_sym_unmanaged] = ACTIONS(4062),
    [anon_sym_get] = ACTIONS(4062),
    [anon_sym_set] = ACTIONS(4062),
    [anon_sym_add] = ACTIONS(4062),
    [anon_sym_remove] = ACTIONS(4062),
    [anon_sym_enum] = ACTIONS(4062),
    [anon_sym_interface] = ACTIONS(4062),
    [anon_sym_delegate] = ACTIONS(4062),
    [anon_sym_record] = ACTIONS(4062),
    [anon_sym_namespace] = ACTIONS(4062),
    [anon_sym_var] = ACTIONS(4062),
    [sym_predefined_type] = ACTIONS(4062),
    [anon_sym_when] = ACTIONS(4062),
    [anon_sym_yield] = ACTIONS(4062),
    [anon_sym_from] = ACTIONS(4062),
    [anon_sym_join] = ACTIONS(4062),
    [anon_sym_on] = ACTIONS(4062),
    [anon_sym_equals] = ACTIONS(4062),
    [anon_sym_into] = ACTIONS(4062),
    [anon_sym_let] = ACTIONS(4062),
    [anon_sym_orderby] = ACTIONS(4062),
    [anon_sym_ascending] = ACTIONS(4062),
    [anon_sym_descending] = ACTIONS(4062),
    [anon_sym_group] = ACTIONS(4062),
    [anon_sym_by] = ACTIONS(4062),
    [anon_sym_select] = ACTIONS(4062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4062),
    [anon_sym_nameof] = ACTIONS(4062),
    [sym_void_keyword] = ACTIONS(4062),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2335] = {
    [sym__preprocessor_call] = STATE(2335),
    [anon_sym_SEMI] = ACTIONS(3370),
    [anon_sym_EQ] = ACTIONS(3372),
    [anon_sym_LT] = ACTIONS(3372),
    [anon_sym_COMMA] = ACTIONS(3370),
    [anon_sym_GT] = ACTIONS(3372),
    [anon_sym_DOT] = ACTIONS(3372),
    [anon_sym_LBRACK] = ACTIONS(3370),
    [anon_sym_RBRACK] = ACTIONS(3370),
    [anon_sym_COLON] = ACTIONS(3370),
    [anon_sym_LPAREN] = ACTIONS(3370),
    [anon_sym_RPAREN] = ACTIONS(3370),
    [anon_sym_in] = ACTIONS(3370),
    [anon_sym_RBRACE] = ACTIONS(3370),
    [anon_sym_EQ_GT] = ACTIONS(3370),
    [anon_sym_where] = ACTIONS(3370),
    [anon_sym_QMARK] = ACTIONS(3372),
    [anon_sym_BANG] = ACTIONS(3372),
    [anon_sym_PLUS_PLUS] = ACTIONS(3370),
    [anon_sym_DASH_DASH] = ACTIONS(3370),
    [anon_sym_PLUS] = ACTIONS(3372),
    [anon_sym_DASH] = ACTIONS(3372),
    [anon_sym_STAR] = ACTIONS(3372),
    [anon_sym_SLASH] = ACTIONS(3372),
    [anon_sym_PERCENT] = ACTIONS(3372),
    [anon_sym_CARET] = ACTIONS(3372),
    [anon_sym_PIPE] = ACTIONS(3372),
    [anon_sym_AMP] = ACTIONS(3372),
    [anon_sym_LT_LT] = ACTIONS(3372),
    [anon_sym_GT_GT] = ACTIONS(3372),
    [anon_sym_EQ_EQ] = ACTIONS(3370),
    [anon_sym_BANG_EQ] = ACTIONS(3370),
    [anon_sym_GT_EQ] = ACTIONS(3370),
    [anon_sym_LT_EQ] = ACTIONS(3370),
    [anon_sym_switch] = ACTIONS(3370),
    [anon_sym_and] = ACTIONS(3370),
    [anon_sym_or] = ACTIONS(3372),
    [anon_sym_PLUS_EQ] = ACTIONS(3370),
    [anon_sym_DASH_EQ] = ACTIONS(3370),
    [anon_sym_STAR_EQ] = ACTIONS(3370),
    [anon_sym_SLASH_EQ] = ACTIONS(3370),
    [anon_sym_PERCENT_EQ] = ACTIONS(3370),
    [anon_sym_AMP_EQ] = ACTIONS(3370),
    [anon_sym_CARET_EQ] = ACTIONS(3370),
    [anon_sym_PIPE_EQ] = ACTIONS(3370),
    [anon_sym_LT_LT_EQ] = ACTIONS(3370),
    [anon_sym_GT_GT_EQ] = ACTIONS(3370),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3370),
    [anon_sym_is] = ACTIONS(3370),
    [anon_sym_DASH_GT] = ACTIONS(3370),
    [anon_sym_from] = ACTIONS(3370),
    [anon_sym_join] = ACTIONS(3370),
    [anon_sym_on] = ACTIONS(3370),
    [anon_sym_equals] = ACTIONS(3370),
    [anon_sym_let] = ACTIONS(3370),
    [anon_sym_orderby] = ACTIONS(3370),
    [anon_sym_group] = ACTIONS(3370),
    [anon_sym_by] = ACTIONS(3370),
    [anon_sym_select] = ACTIONS(3370),
    [anon_sym_DOT_DOT] = ACTIONS(3370),
    [anon_sym_with] = ACTIONS(3370),
    [anon_sym_AMP_AMP] = ACTIONS(3370),
    [anon_sym_PIPE_PIPE] = ACTIONS(3370),
    [anon_sym_QMARK_QMARK] = ACTIONS(3372),
    [anon_sym_as] = ACTIONS(3370),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2336] = {
    [sym__preprocessor_call] = STATE(2336),
    [anon_sym_SEMI] = ACTIONS(3366),
    [anon_sym_EQ] = ACTIONS(3368),
    [anon_sym_LT] = ACTIONS(3368),
    [anon_sym_COMMA] = ACTIONS(3366),
    [anon_sym_GT] = ACTIONS(3368),
    [anon_sym_DOT] = ACTIONS(3368),
    [anon_sym_LBRACK] = ACTIONS(3366),
    [anon_sym_RBRACK] = ACTIONS(3366),
    [anon_sym_COLON] = ACTIONS(3366),
    [anon_sym_LPAREN] = ACTIONS(3366),
    [anon_sym_RPAREN] = ACTIONS(3366),
    [anon_sym_in] = ACTIONS(3366),
    [anon_sym_RBRACE] = ACTIONS(3366),
    [anon_sym_EQ_GT] = ACTIONS(3366),
    [anon_sym_where] = ACTIONS(3366),
    [anon_sym_QMARK] = ACTIONS(3368),
    [anon_sym_BANG] = ACTIONS(3368),
    [anon_sym_PLUS_PLUS] = ACTIONS(3366),
    [anon_sym_DASH_DASH] = ACTIONS(3366),
    [anon_sym_PLUS] = ACTIONS(3368),
    [anon_sym_DASH] = ACTIONS(3368),
    [anon_sym_STAR] = ACTIONS(3368),
    [anon_sym_SLASH] = ACTIONS(3368),
    [anon_sym_PERCENT] = ACTIONS(3368),
    [anon_sym_CARET] = ACTIONS(3368),
    [anon_sym_PIPE] = ACTIONS(3368),
    [anon_sym_AMP] = ACTIONS(3368),
    [anon_sym_LT_LT] = ACTIONS(3368),
    [anon_sym_GT_GT] = ACTIONS(3368),
    [anon_sym_EQ_EQ] = ACTIONS(3366),
    [anon_sym_BANG_EQ] = ACTIONS(3366),
    [anon_sym_GT_EQ] = ACTIONS(3366),
    [anon_sym_LT_EQ] = ACTIONS(3366),
    [anon_sym_switch] = ACTIONS(3366),
    [anon_sym_and] = ACTIONS(3366),
    [anon_sym_or] = ACTIONS(3368),
    [anon_sym_PLUS_EQ] = ACTIONS(3366),
    [anon_sym_DASH_EQ] = ACTIONS(3366),
    [anon_sym_STAR_EQ] = ACTIONS(3366),
    [anon_sym_SLASH_EQ] = ACTIONS(3366),
    [anon_sym_PERCENT_EQ] = ACTIONS(3366),
    [anon_sym_AMP_EQ] = ACTIONS(3366),
    [anon_sym_CARET_EQ] = ACTIONS(3366),
    [anon_sym_PIPE_EQ] = ACTIONS(3366),
    [anon_sym_LT_LT_EQ] = ACTIONS(3366),
    [anon_sym_GT_GT_EQ] = ACTIONS(3366),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3366),
    [anon_sym_is] = ACTIONS(3366),
    [anon_sym_DASH_GT] = ACTIONS(3366),
    [anon_sym_from] = ACTIONS(3366),
    [anon_sym_join] = ACTIONS(3366),
    [anon_sym_on] = ACTIONS(3366),
    [anon_sym_equals] = ACTIONS(3366),
    [anon_sym_let] = ACTIONS(3366),
    [anon_sym_orderby] = ACTIONS(3366),
    [anon_sym_group] = ACTIONS(3366),
    [anon_sym_by] = ACTIONS(3366),
    [anon_sym_select] = ACTIONS(3366),
    [anon_sym_DOT_DOT] = ACTIONS(3366),
    [anon_sym_with] = ACTIONS(3366),
    [anon_sym_AMP_AMP] = ACTIONS(3366),
    [anon_sym_PIPE_PIPE] = ACTIONS(3366),
    [anon_sym_QMARK_QMARK] = ACTIONS(3368),
    [anon_sym_as] = ACTIONS(3366),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2337] = {
    [sym__preprocessor_call] = STATE(2337),
    [anon_sym_SEMI] = ACTIONS(3362),
    [anon_sym_EQ] = ACTIONS(3364),
    [anon_sym_LT] = ACTIONS(3364),
    [anon_sym_COMMA] = ACTIONS(3362),
    [anon_sym_GT] = ACTIONS(3364),
    [anon_sym_DOT] = ACTIONS(3364),
    [anon_sym_LBRACK] = ACTIONS(3362),
    [anon_sym_RBRACK] = ACTIONS(3362),
    [anon_sym_COLON] = ACTIONS(3362),
    [anon_sym_LPAREN] = ACTIONS(3362),
    [anon_sym_RPAREN] = ACTIONS(3362),
    [anon_sym_in] = ACTIONS(3362),
    [anon_sym_RBRACE] = ACTIONS(3362),
    [anon_sym_EQ_GT] = ACTIONS(3362),
    [anon_sym_where] = ACTIONS(3362),
    [anon_sym_QMARK] = ACTIONS(3364),
    [anon_sym_BANG] = ACTIONS(3364),
    [anon_sym_PLUS_PLUS] = ACTIONS(3362),
    [anon_sym_DASH_DASH] = ACTIONS(3362),
    [anon_sym_PLUS] = ACTIONS(3364),
    [anon_sym_DASH] = ACTIONS(3364),
    [anon_sym_STAR] = ACTIONS(3364),
    [anon_sym_SLASH] = ACTIONS(3364),
    [anon_sym_PERCENT] = ACTIONS(3364),
    [anon_sym_CARET] = ACTIONS(3364),
    [anon_sym_PIPE] = ACTIONS(3364),
    [anon_sym_AMP] = ACTIONS(3364),
    [anon_sym_LT_LT] = ACTIONS(3364),
    [anon_sym_GT_GT] = ACTIONS(3364),
    [anon_sym_EQ_EQ] = ACTIONS(3362),
    [anon_sym_BANG_EQ] = ACTIONS(3362),
    [anon_sym_GT_EQ] = ACTIONS(3362),
    [anon_sym_LT_EQ] = ACTIONS(3362),
    [anon_sym_switch] = ACTIONS(3362),
    [anon_sym_and] = ACTIONS(3362),
    [anon_sym_or] = ACTIONS(3364),
    [anon_sym_PLUS_EQ] = ACTIONS(3362),
    [anon_sym_DASH_EQ] = ACTIONS(3362),
    [anon_sym_STAR_EQ] = ACTIONS(3362),
    [anon_sym_SLASH_EQ] = ACTIONS(3362),
    [anon_sym_PERCENT_EQ] = ACTIONS(3362),
    [anon_sym_AMP_EQ] = ACTIONS(3362),
    [anon_sym_CARET_EQ] = ACTIONS(3362),
    [anon_sym_PIPE_EQ] = ACTIONS(3362),
    [anon_sym_LT_LT_EQ] = ACTIONS(3362),
    [anon_sym_GT_GT_EQ] = ACTIONS(3362),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3362),
    [anon_sym_is] = ACTIONS(3362),
    [anon_sym_DASH_GT] = ACTIONS(3362),
    [anon_sym_from] = ACTIONS(3362),
    [anon_sym_join] = ACTIONS(3362),
    [anon_sym_on] = ACTIONS(3362),
    [anon_sym_equals] = ACTIONS(3362),
    [anon_sym_let] = ACTIONS(3362),
    [anon_sym_orderby] = ACTIONS(3362),
    [anon_sym_group] = ACTIONS(3362),
    [anon_sym_by] = ACTIONS(3362),
    [anon_sym_select] = ACTIONS(3362),
    [anon_sym_DOT_DOT] = ACTIONS(3362),
    [anon_sym_with] = ACTIONS(3362),
    [anon_sym_AMP_AMP] = ACTIONS(3362),
    [anon_sym_PIPE_PIPE] = ACTIONS(3362),
    [anon_sym_QMARK_QMARK] = ACTIONS(3364),
    [anon_sym_as] = ACTIONS(3362),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2338] = {
    [sym__preprocessor_call] = STATE(2338),
    [anon_sym_SEMI] = ACTIONS(3486),
    [anon_sym_EQ] = ACTIONS(3488),
    [anon_sym_LT] = ACTIONS(3488),
    [anon_sym_COMMA] = ACTIONS(3486),
    [anon_sym_GT] = ACTIONS(3488),
    [anon_sym_DOT] = ACTIONS(3488),
    [anon_sym_LBRACK] = ACTIONS(3486),
    [anon_sym_RBRACK] = ACTIONS(3486),
    [anon_sym_COLON] = ACTIONS(3486),
    [anon_sym_LPAREN] = ACTIONS(3486),
    [anon_sym_RPAREN] = ACTIONS(3486),
    [anon_sym_in] = ACTIONS(3486),
    [anon_sym_RBRACE] = ACTIONS(3486),
    [anon_sym_EQ_GT] = ACTIONS(3486),
    [anon_sym_where] = ACTIONS(3486),
    [anon_sym_QMARK] = ACTIONS(3488),
    [anon_sym_BANG] = ACTIONS(3488),
    [anon_sym_PLUS_PLUS] = ACTIONS(3486),
    [anon_sym_DASH_DASH] = ACTIONS(3486),
    [anon_sym_PLUS] = ACTIONS(3488),
    [anon_sym_DASH] = ACTIONS(3488),
    [anon_sym_STAR] = ACTIONS(3488),
    [anon_sym_SLASH] = ACTIONS(3488),
    [anon_sym_PERCENT] = ACTIONS(3488),
    [anon_sym_CARET] = ACTIONS(3488),
    [anon_sym_PIPE] = ACTIONS(3488),
    [anon_sym_AMP] = ACTIONS(3488),
    [anon_sym_LT_LT] = ACTIONS(3488),
    [anon_sym_GT_GT] = ACTIONS(3488),
    [anon_sym_EQ_EQ] = ACTIONS(3486),
    [anon_sym_BANG_EQ] = ACTIONS(3486),
    [anon_sym_GT_EQ] = ACTIONS(3486),
    [anon_sym_LT_EQ] = ACTIONS(3486),
    [anon_sym_switch] = ACTIONS(3486),
    [anon_sym_and] = ACTIONS(3486),
    [anon_sym_or] = ACTIONS(3488),
    [anon_sym_PLUS_EQ] = ACTIONS(3486),
    [anon_sym_DASH_EQ] = ACTIONS(3486),
    [anon_sym_STAR_EQ] = ACTIONS(3486),
    [anon_sym_SLASH_EQ] = ACTIONS(3486),
    [anon_sym_PERCENT_EQ] = ACTIONS(3486),
    [anon_sym_AMP_EQ] = ACTIONS(3486),
    [anon_sym_CARET_EQ] = ACTIONS(3486),
    [anon_sym_PIPE_EQ] = ACTIONS(3486),
    [anon_sym_LT_LT_EQ] = ACTIONS(3486),
    [anon_sym_GT_GT_EQ] = ACTIONS(3486),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3486),
    [anon_sym_is] = ACTIONS(3486),
    [anon_sym_DASH_GT] = ACTIONS(3486),
    [anon_sym_from] = ACTIONS(3486),
    [anon_sym_join] = ACTIONS(3486),
    [anon_sym_on] = ACTIONS(3486),
    [anon_sym_equals] = ACTIONS(3486),
    [anon_sym_let] = ACTIONS(3486),
    [anon_sym_orderby] = ACTIONS(3486),
    [anon_sym_group] = ACTIONS(3486),
    [anon_sym_by] = ACTIONS(3486),
    [anon_sym_select] = ACTIONS(3486),
    [anon_sym_DOT_DOT] = ACTIONS(3486),
    [anon_sym_with] = ACTIONS(3486),
    [anon_sym_AMP_AMP] = ACTIONS(3486),
    [anon_sym_PIPE_PIPE] = ACTIONS(3486),
    [anon_sym_QMARK_QMARK] = ACTIONS(3488),
    [anon_sym_as] = ACTIONS(3486),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2339] = {
    [sym__preprocessor_call] = STATE(2339),
    [anon_sym_SEMI] = ACTIONS(3374),
    [anon_sym_EQ] = ACTIONS(3376),
    [anon_sym_LT] = ACTIONS(3376),
    [anon_sym_COMMA] = ACTIONS(3374),
    [anon_sym_GT] = ACTIONS(3376),
    [anon_sym_DOT] = ACTIONS(3376),
    [anon_sym_LBRACK] = ACTIONS(3374),
    [anon_sym_RBRACK] = ACTIONS(3374),
    [anon_sym_COLON] = ACTIONS(3075),
    [anon_sym_LPAREN] = ACTIONS(3374),
    [anon_sym_RPAREN] = ACTIONS(3374),
    [anon_sym_in] = ACTIONS(3374),
    [anon_sym_RBRACE] = ACTIONS(3374),
    [anon_sym_EQ_GT] = ACTIONS(3374),
    [anon_sym_where] = ACTIONS(3374),
    [anon_sym_QMARK] = ACTIONS(3376),
    [anon_sym_BANG] = ACTIONS(3376),
    [anon_sym_PLUS_PLUS] = ACTIONS(3374),
    [anon_sym_DASH_DASH] = ACTIONS(3374),
    [anon_sym_PLUS] = ACTIONS(3376),
    [anon_sym_DASH] = ACTIONS(3376),
    [anon_sym_STAR] = ACTIONS(3376),
    [anon_sym_SLASH] = ACTIONS(3376),
    [anon_sym_PERCENT] = ACTIONS(3376),
    [anon_sym_CARET] = ACTIONS(3376),
    [anon_sym_PIPE] = ACTIONS(3376),
    [anon_sym_AMP] = ACTIONS(3376),
    [anon_sym_LT_LT] = ACTIONS(3376),
    [anon_sym_GT_GT] = ACTIONS(3376),
    [anon_sym_EQ_EQ] = ACTIONS(3374),
    [anon_sym_BANG_EQ] = ACTIONS(3374),
    [anon_sym_GT_EQ] = ACTIONS(3374),
    [anon_sym_LT_EQ] = ACTIONS(3374),
    [anon_sym_switch] = ACTIONS(3374),
    [anon_sym_and] = ACTIONS(3374),
    [anon_sym_or] = ACTIONS(3376),
    [anon_sym_PLUS_EQ] = ACTIONS(3374),
    [anon_sym_DASH_EQ] = ACTIONS(3374),
    [anon_sym_STAR_EQ] = ACTIONS(3374),
    [anon_sym_SLASH_EQ] = ACTIONS(3374),
    [anon_sym_PERCENT_EQ] = ACTIONS(3374),
    [anon_sym_AMP_EQ] = ACTIONS(3374),
    [anon_sym_CARET_EQ] = ACTIONS(3374),
    [anon_sym_PIPE_EQ] = ACTIONS(3374),
    [anon_sym_LT_LT_EQ] = ACTIONS(3374),
    [anon_sym_GT_GT_EQ] = ACTIONS(3374),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3374),
    [anon_sym_is] = ACTIONS(3374),
    [anon_sym_DASH_GT] = ACTIONS(3374),
    [anon_sym_from] = ACTIONS(3374),
    [anon_sym_join] = ACTIONS(3374),
    [anon_sym_on] = ACTIONS(3374),
    [anon_sym_equals] = ACTIONS(3374),
    [anon_sym_let] = ACTIONS(3374),
    [anon_sym_orderby] = ACTIONS(3374),
    [anon_sym_group] = ACTIONS(3374),
    [anon_sym_by] = ACTIONS(3374),
    [anon_sym_select] = ACTIONS(3374),
    [anon_sym_DOT_DOT] = ACTIONS(3374),
    [anon_sym_with] = ACTIONS(3374),
    [anon_sym_AMP_AMP] = ACTIONS(3374),
    [anon_sym_PIPE_PIPE] = ACTIONS(3374),
    [anon_sym_QMARK_QMARK] = ACTIONS(3376),
    [anon_sym_as] = ACTIONS(3374),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2340] = {
    [sym__preprocessor_call] = STATE(2340),
    [anon_sym_SEMI] = ACTIONS(3490),
    [anon_sym_EQ] = ACTIONS(3492),
    [anon_sym_LT] = ACTIONS(3492),
    [anon_sym_COMMA] = ACTIONS(3490),
    [anon_sym_GT] = ACTIONS(3492),
    [anon_sym_DOT] = ACTIONS(3492),
    [anon_sym_LBRACK] = ACTIONS(3490),
    [anon_sym_RBRACK] = ACTIONS(3490),
    [anon_sym_COLON] = ACTIONS(3490),
    [anon_sym_LPAREN] = ACTIONS(3490),
    [anon_sym_RPAREN] = ACTIONS(3490),
    [anon_sym_in] = ACTIONS(3490),
    [anon_sym_RBRACE] = ACTIONS(3490),
    [anon_sym_EQ_GT] = ACTIONS(3490),
    [anon_sym_where] = ACTIONS(3490),
    [anon_sym_QMARK] = ACTIONS(3492),
    [anon_sym_BANG] = ACTIONS(3492),
    [anon_sym_PLUS_PLUS] = ACTIONS(3490),
    [anon_sym_DASH_DASH] = ACTIONS(3490),
    [anon_sym_PLUS] = ACTIONS(3492),
    [anon_sym_DASH] = ACTIONS(3492),
    [anon_sym_STAR] = ACTIONS(3492),
    [anon_sym_SLASH] = ACTIONS(3492),
    [anon_sym_PERCENT] = ACTIONS(3492),
    [anon_sym_CARET] = ACTIONS(3492),
    [anon_sym_PIPE] = ACTIONS(3492),
    [anon_sym_AMP] = ACTIONS(3492),
    [anon_sym_LT_LT] = ACTIONS(3492),
    [anon_sym_GT_GT] = ACTIONS(3492),
    [anon_sym_EQ_EQ] = ACTIONS(3490),
    [anon_sym_BANG_EQ] = ACTIONS(3490),
    [anon_sym_GT_EQ] = ACTIONS(3490),
    [anon_sym_LT_EQ] = ACTIONS(3490),
    [anon_sym_switch] = ACTIONS(3490),
    [anon_sym_and] = ACTIONS(3490),
    [anon_sym_or] = ACTIONS(3492),
    [anon_sym_PLUS_EQ] = ACTIONS(3490),
    [anon_sym_DASH_EQ] = ACTIONS(3490),
    [anon_sym_STAR_EQ] = ACTIONS(3490),
    [anon_sym_SLASH_EQ] = ACTIONS(3490),
    [anon_sym_PERCENT_EQ] = ACTIONS(3490),
    [anon_sym_AMP_EQ] = ACTIONS(3490),
    [anon_sym_CARET_EQ] = ACTIONS(3490),
    [anon_sym_PIPE_EQ] = ACTIONS(3490),
    [anon_sym_LT_LT_EQ] = ACTIONS(3490),
    [anon_sym_GT_GT_EQ] = ACTIONS(3490),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3490),
    [anon_sym_is] = ACTIONS(3490),
    [anon_sym_DASH_GT] = ACTIONS(3490),
    [anon_sym_from] = ACTIONS(3490),
    [anon_sym_join] = ACTIONS(3490),
    [anon_sym_on] = ACTIONS(3490),
    [anon_sym_equals] = ACTIONS(3490),
    [anon_sym_let] = ACTIONS(3490),
    [anon_sym_orderby] = ACTIONS(3490),
    [anon_sym_group] = ACTIONS(3490),
    [anon_sym_by] = ACTIONS(3490),
    [anon_sym_select] = ACTIONS(3490),
    [anon_sym_DOT_DOT] = ACTIONS(3490),
    [anon_sym_with] = ACTIONS(3490),
    [anon_sym_AMP_AMP] = ACTIONS(3490),
    [anon_sym_PIPE_PIPE] = ACTIONS(3490),
    [anon_sym_QMARK_QMARK] = ACTIONS(3492),
    [anon_sym_as] = ACTIONS(3490),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2341] = {
    [sym__preprocessor_call] = STATE(2341),
    [sym__identifier_token] = ACTIONS(4068),
    [anon_sym_extern] = ACTIONS(4068),
    [anon_sym_alias] = ACTIONS(4068),
    [anon_sym_SEMI] = ACTIONS(4070),
    [anon_sym_global] = ACTIONS(4068),
    [anon_sym_using] = ACTIONS(4068),
    [anon_sym_static] = ACTIONS(4068),
    [anon_sym_LBRACK] = ACTIONS(4072),
    [anon_sym_event] = ACTIONS(4068),
    [anon_sym_LPAREN] = ACTIONS(4072),
    [anon_sym_abstract] = ACTIONS(4068),
    [anon_sym_async] = ACTIONS(4068),
    [anon_sym_const] = ACTIONS(4068),
    [anon_sym_fixed] = ACTIONS(4068),
    [anon_sym_internal] = ACTIONS(4068),
    [anon_sym_new] = ACTIONS(4068),
    [anon_sym_override] = ACTIONS(4068),
    [anon_sym_partial] = ACTIONS(4068),
    [anon_sym_private] = ACTIONS(4068),
    [anon_sym_protected] = ACTIONS(4068),
    [anon_sym_public] = ACTIONS(4068),
    [anon_sym_readonly] = ACTIONS(4068),
    [anon_sym_ref] = ACTIONS(4068),
    [anon_sym_sealed] = ACTIONS(4068),
    [anon_sym_unsafe] = ACTIONS(4068),
    [anon_sym_virtual] = ACTIONS(4068),
    [anon_sym_volatile] = ACTIONS(4068),
    [anon_sym_RBRACE] = ACTIONS(4072),
    [anon_sym_implicit] = ACTIONS(4068),
    [anon_sym_explicit] = ACTIONS(4068),
    [anon_sym_TILDE] = ACTIONS(4072),
    [anon_sym_where] = ACTIONS(4068),
    [anon_sym_class] = ACTIONS(4068),
    [anon_sym_struct] = ACTIONS(4068),
    [anon_sym_notnull] = ACTIONS(4068),
    [anon_sym_unmanaged] = ACTIONS(4068),
    [anon_sym_get] = ACTIONS(4068),
    [anon_sym_set] = ACTIONS(4068),
    [anon_sym_add] = ACTIONS(4068),
    [anon_sym_remove] = ACTIONS(4068),
    [anon_sym_enum] = ACTIONS(4068),
    [anon_sym_interface] = ACTIONS(4068),
    [anon_sym_delegate] = ACTIONS(4068),
    [anon_sym_record] = ACTIONS(4068),
    [anon_sym_namespace] = ACTIONS(4068),
    [anon_sym_var] = ACTIONS(4068),
    [sym_predefined_type] = ACTIONS(4068),
    [anon_sym_when] = ACTIONS(4068),
    [anon_sym_yield] = ACTIONS(4068),
    [anon_sym_from] = ACTIONS(4068),
    [anon_sym_join] = ACTIONS(4068),
    [anon_sym_on] = ACTIONS(4068),
    [anon_sym_equals] = ACTIONS(4068),
    [anon_sym_into] = ACTIONS(4068),
    [anon_sym_let] = ACTIONS(4068),
    [anon_sym_orderby] = ACTIONS(4068),
    [anon_sym_ascending] = ACTIONS(4068),
    [anon_sym_descending] = ACTIONS(4068),
    [anon_sym_group] = ACTIONS(4068),
    [anon_sym_by] = ACTIONS(4068),
    [anon_sym_select] = ACTIONS(4068),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4068),
    [anon_sym_nameof] = ACTIONS(4068),
    [sym_void_keyword] = ACTIONS(4068),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2342] = {
    [sym__preprocessor_call] = STATE(2342),
    [sym__identifier_token] = ACTIONS(4074),
    [anon_sym_extern] = ACTIONS(4074),
    [anon_sym_alias] = ACTIONS(4074),
    [anon_sym_SEMI] = ACTIONS(4076),
    [anon_sym_global] = ACTIONS(4074),
    [anon_sym_using] = ACTIONS(4074),
    [anon_sym_static] = ACTIONS(4074),
    [anon_sym_LBRACK] = ACTIONS(4078),
    [anon_sym_event] = ACTIONS(4074),
    [anon_sym_LPAREN] = ACTIONS(4078),
    [anon_sym_abstract] = ACTIONS(4074),
    [anon_sym_async] = ACTIONS(4074),
    [anon_sym_const] = ACTIONS(4074),
    [anon_sym_fixed] = ACTIONS(4074),
    [anon_sym_internal] = ACTIONS(4074),
    [anon_sym_new] = ACTIONS(4074),
    [anon_sym_override] = ACTIONS(4074),
    [anon_sym_partial] = ACTIONS(4074),
    [anon_sym_private] = ACTIONS(4074),
    [anon_sym_protected] = ACTIONS(4074),
    [anon_sym_public] = ACTIONS(4074),
    [anon_sym_readonly] = ACTIONS(4074),
    [anon_sym_ref] = ACTIONS(4074),
    [anon_sym_sealed] = ACTIONS(4074),
    [anon_sym_unsafe] = ACTIONS(4074),
    [anon_sym_virtual] = ACTIONS(4074),
    [anon_sym_volatile] = ACTIONS(4074),
    [anon_sym_RBRACE] = ACTIONS(4078),
    [anon_sym_implicit] = ACTIONS(4074),
    [anon_sym_explicit] = ACTIONS(4074),
    [anon_sym_TILDE] = ACTIONS(4078),
    [anon_sym_where] = ACTIONS(4074),
    [anon_sym_class] = ACTIONS(4074),
    [anon_sym_struct] = ACTIONS(4074),
    [anon_sym_notnull] = ACTIONS(4074),
    [anon_sym_unmanaged] = ACTIONS(4074),
    [anon_sym_get] = ACTIONS(4074),
    [anon_sym_set] = ACTIONS(4074),
    [anon_sym_add] = ACTIONS(4074),
    [anon_sym_remove] = ACTIONS(4074),
    [anon_sym_enum] = ACTIONS(4074),
    [anon_sym_interface] = ACTIONS(4074),
    [anon_sym_delegate] = ACTIONS(4074),
    [anon_sym_record] = ACTIONS(4074),
    [anon_sym_namespace] = ACTIONS(4074),
    [anon_sym_var] = ACTIONS(4074),
    [sym_predefined_type] = ACTIONS(4074),
    [anon_sym_when] = ACTIONS(4074),
    [anon_sym_yield] = ACTIONS(4074),
    [anon_sym_from] = ACTIONS(4074),
    [anon_sym_join] = ACTIONS(4074),
    [anon_sym_on] = ACTIONS(4074),
    [anon_sym_equals] = ACTIONS(4074),
    [anon_sym_into] = ACTIONS(4074),
    [anon_sym_let] = ACTIONS(4074),
    [anon_sym_orderby] = ACTIONS(4074),
    [anon_sym_ascending] = ACTIONS(4074),
    [anon_sym_descending] = ACTIONS(4074),
    [anon_sym_group] = ACTIONS(4074),
    [anon_sym_by] = ACTIONS(4074),
    [anon_sym_select] = ACTIONS(4074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4074),
    [anon_sym_nameof] = ACTIONS(4074),
    [sym_void_keyword] = ACTIONS(4074),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2343] = {
    [sym__preprocessor_call] = STATE(2343),
    [anon_sym_SEMI] = ACTIONS(3358),
    [anon_sym_EQ] = ACTIONS(3360),
    [anon_sym_LT] = ACTIONS(3360),
    [anon_sym_COMMA] = ACTIONS(3358),
    [anon_sym_GT] = ACTIONS(3360),
    [anon_sym_DOT] = ACTIONS(3360),
    [anon_sym_LBRACK] = ACTIONS(3358),
    [anon_sym_RBRACK] = ACTIONS(3358),
    [anon_sym_COLON] = ACTIONS(3358),
    [anon_sym_LPAREN] = ACTIONS(3358),
    [anon_sym_RPAREN] = ACTIONS(3358),
    [anon_sym_in] = ACTIONS(3358),
    [anon_sym_RBRACE] = ACTIONS(3358),
    [anon_sym_EQ_GT] = ACTIONS(3358),
    [anon_sym_where] = ACTIONS(3358),
    [anon_sym_QMARK] = ACTIONS(3360),
    [anon_sym_BANG] = ACTIONS(3360),
    [anon_sym_PLUS_PLUS] = ACTIONS(3358),
    [anon_sym_DASH_DASH] = ACTIONS(3358),
    [anon_sym_PLUS] = ACTIONS(3360),
    [anon_sym_DASH] = ACTIONS(3360),
    [anon_sym_STAR] = ACTIONS(3360),
    [anon_sym_SLASH] = ACTIONS(3360),
    [anon_sym_PERCENT] = ACTIONS(3360),
    [anon_sym_CARET] = ACTIONS(3360),
    [anon_sym_PIPE] = ACTIONS(3360),
    [anon_sym_AMP] = ACTIONS(3360),
    [anon_sym_LT_LT] = ACTIONS(3360),
    [anon_sym_GT_GT] = ACTIONS(3360),
    [anon_sym_EQ_EQ] = ACTIONS(3358),
    [anon_sym_BANG_EQ] = ACTIONS(3358),
    [anon_sym_GT_EQ] = ACTIONS(3358),
    [anon_sym_LT_EQ] = ACTIONS(3358),
    [anon_sym_switch] = ACTIONS(3358),
    [anon_sym_and] = ACTIONS(3358),
    [anon_sym_or] = ACTIONS(3360),
    [anon_sym_PLUS_EQ] = ACTIONS(3358),
    [anon_sym_DASH_EQ] = ACTIONS(3358),
    [anon_sym_STAR_EQ] = ACTIONS(3358),
    [anon_sym_SLASH_EQ] = ACTIONS(3358),
    [anon_sym_PERCENT_EQ] = ACTIONS(3358),
    [anon_sym_AMP_EQ] = ACTIONS(3358),
    [anon_sym_CARET_EQ] = ACTIONS(3358),
    [anon_sym_PIPE_EQ] = ACTIONS(3358),
    [anon_sym_LT_LT_EQ] = ACTIONS(3358),
    [anon_sym_GT_GT_EQ] = ACTIONS(3358),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3358),
    [anon_sym_is] = ACTIONS(3358),
    [anon_sym_DASH_GT] = ACTIONS(3358),
    [anon_sym_from] = ACTIONS(3358),
    [anon_sym_join] = ACTIONS(3358),
    [anon_sym_on] = ACTIONS(3358),
    [anon_sym_equals] = ACTIONS(3358),
    [anon_sym_let] = ACTIONS(3358),
    [anon_sym_orderby] = ACTIONS(3358),
    [anon_sym_group] = ACTIONS(3358),
    [anon_sym_by] = ACTIONS(3358),
    [anon_sym_select] = ACTIONS(3358),
    [anon_sym_DOT_DOT] = ACTIONS(3358),
    [anon_sym_with] = ACTIONS(3358),
    [anon_sym_AMP_AMP] = ACTIONS(3358),
    [anon_sym_PIPE_PIPE] = ACTIONS(3358),
    [anon_sym_QMARK_QMARK] = ACTIONS(3360),
    [anon_sym_as] = ACTIONS(3358),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2344] = {
    [sym__preprocessor_call] = STATE(2344),
    [sym__identifier_token] = ACTIONS(4080),
    [anon_sym_extern] = ACTIONS(4080),
    [anon_sym_alias] = ACTIONS(4080),
    [anon_sym_SEMI] = ACTIONS(4082),
    [anon_sym_global] = ACTIONS(4080),
    [anon_sym_using] = ACTIONS(4080),
    [anon_sym_static] = ACTIONS(4080),
    [anon_sym_LBRACK] = ACTIONS(4082),
    [anon_sym_event] = ACTIONS(4080),
    [anon_sym_LPAREN] = ACTIONS(4082),
    [anon_sym_abstract] = ACTIONS(4080),
    [anon_sym_async] = ACTIONS(4080),
    [anon_sym_const] = ACTIONS(4080),
    [anon_sym_fixed] = ACTIONS(4080),
    [anon_sym_internal] = ACTIONS(4080),
    [anon_sym_new] = ACTIONS(4080),
    [anon_sym_override] = ACTIONS(4080),
    [anon_sym_partial] = ACTIONS(4080),
    [anon_sym_private] = ACTIONS(4080),
    [anon_sym_protected] = ACTIONS(4080),
    [anon_sym_public] = ACTIONS(4080),
    [anon_sym_readonly] = ACTIONS(4080),
    [anon_sym_ref] = ACTIONS(4080),
    [anon_sym_sealed] = ACTIONS(4080),
    [anon_sym_unsafe] = ACTIONS(4080),
    [anon_sym_virtual] = ACTIONS(4080),
    [anon_sym_volatile] = ACTIONS(4080),
    [anon_sym_RBRACE] = ACTIONS(4082),
    [anon_sym_implicit] = ACTIONS(4080),
    [anon_sym_explicit] = ACTIONS(4080),
    [anon_sym_TILDE] = ACTIONS(4082),
    [anon_sym_where] = ACTIONS(4080),
    [anon_sym_class] = ACTIONS(4080),
    [anon_sym_struct] = ACTIONS(4080),
    [anon_sym_notnull] = ACTIONS(4080),
    [anon_sym_unmanaged] = ACTIONS(4080),
    [anon_sym_get] = ACTIONS(4080),
    [anon_sym_set] = ACTIONS(4080),
    [anon_sym_add] = ACTIONS(4080),
    [anon_sym_remove] = ACTIONS(4080),
    [anon_sym_enum] = ACTIONS(4080),
    [anon_sym_interface] = ACTIONS(4080),
    [anon_sym_delegate] = ACTIONS(4080),
    [anon_sym_record] = ACTIONS(4080),
    [anon_sym_namespace] = ACTIONS(4080),
    [anon_sym_var] = ACTIONS(4080),
    [sym_predefined_type] = ACTIONS(4080),
    [anon_sym_when] = ACTIONS(4080),
    [anon_sym_yield] = ACTIONS(4080),
    [anon_sym_from] = ACTIONS(4080),
    [anon_sym_join] = ACTIONS(4080),
    [anon_sym_on] = ACTIONS(4080),
    [anon_sym_equals] = ACTIONS(4080),
    [anon_sym_into] = ACTIONS(4080),
    [anon_sym_let] = ACTIONS(4080),
    [anon_sym_orderby] = ACTIONS(4080),
    [anon_sym_ascending] = ACTIONS(4080),
    [anon_sym_descending] = ACTIONS(4080),
    [anon_sym_group] = ACTIONS(4080),
    [anon_sym_by] = ACTIONS(4080),
    [anon_sym_select] = ACTIONS(4080),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4080),
    [anon_sym_nameof] = ACTIONS(4080),
    [sym_void_keyword] = ACTIONS(4080),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2345] = {
    [sym__preprocessor_call] = STATE(2345),
    [sym__identifier_token] = ACTIONS(4084),
    [anon_sym_extern] = ACTIONS(4084),
    [anon_sym_alias] = ACTIONS(4084),
    [anon_sym_SEMI] = ACTIONS(4086),
    [anon_sym_global] = ACTIONS(4084),
    [anon_sym_using] = ACTIONS(4084),
    [anon_sym_static] = ACTIONS(4084),
    [anon_sym_LBRACK] = ACTIONS(4088),
    [anon_sym_event] = ACTIONS(4084),
    [anon_sym_LPAREN] = ACTIONS(4088),
    [anon_sym_abstract] = ACTIONS(4084),
    [anon_sym_async] = ACTIONS(4084),
    [anon_sym_const] = ACTIONS(4084),
    [anon_sym_fixed] = ACTIONS(4084),
    [anon_sym_internal] = ACTIONS(4084),
    [anon_sym_new] = ACTIONS(4084),
    [anon_sym_override] = ACTIONS(4084),
    [anon_sym_partial] = ACTIONS(4084),
    [anon_sym_private] = ACTIONS(4084),
    [anon_sym_protected] = ACTIONS(4084),
    [anon_sym_public] = ACTIONS(4084),
    [anon_sym_readonly] = ACTIONS(4084),
    [anon_sym_ref] = ACTIONS(4084),
    [anon_sym_sealed] = ACTIONS(4084),
    [anon_sym_unsafe] = ACTIONS(4084),
    [anon_sym_virtual] = ACTIONS(4084),
    [anon_sym_volatile] = ACTIONS(4084),
    [anon_sym_RBRACE] = ACTIONS(4088),
    [anon_sym_implicit] = ACTIONS(4084),
    [anon_sym_explicit] = ACTIONS(4084),
    [anon_sym_TILDE] = ACTIONS(4088),
    [anon_sym_where] = ACTIONS(4084),
    [anon_sym_class] = ACTIONS(4084),
    [anon_sym_struct] = ACTIONS(4084),
    [anon_sym_notnull] = ACTIONS(4084),
    [anon_sym_unmanaged] = ACTIONS(4084),
    [anon_sym_get] = ACTIONS(4084),
    [anon_sym_set] = ACTIONS(4084),
    [anon_sym_add] = ACTIONS(4084),
    [anon_sym_remove] = ACTIONS(4084),
    [anon_sym_enum] = ACTIONS(4084),
    [anon_sym_interface] = ACTIONS(4084),
    [anon_sym_delegate] = ACTIONS(4084),
    [anon_sym_record] = ACTIONS(4084),
    [anon_sym_namespace] = ACTIONS(4084),
    [anon_sym_var] = ACTIONS(4084),
    [sym_predefined_type] = ACTIONS(4084),
    [anon_sym_when] = ACTIONS(4084),
    [anon_sym_yield] = ACTIONS(4084),
    [anon_sym_from] = ACTIONS(4084),
    [anon_sym_join] = ACTIONS(4084),
    [anon_sym_on] = ACTIONS(4084),
    [anon_sym_equals] = ACTIONS(4084),
    [anon_sym_into] = ACTIONS(4084),
    [anon_sym_let] = ACTIONS(4084),
    [anon_sym_orderby] = ACTIONS(4084),
    [anon_sym_ascending] = ACTIONS(4084),
    [anon_sym_descending] = ACTIONS(4084),
    [anon_sym_group] = ACTIONS(4084),
    [anon_sym_by] = ACTIONS(4084),
    [anon_sym_select] = ACTIONS(4084),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4084),
    [anon_sym_nameof] = ACTIONS(4084),
    [sym_void_keyword] = ACTIONS(4084),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2346] = {
    [sym__preprocessor_call] = STATE(2346),
    [sym__identifier_token] = ACTIONS(4090),
    [anon_sym_extern] = ACTIONS(4090),
    [anon_sym_alias] = ACTIONS(4090),
    [anon_sym_global] = ACTIONS(4090),
    [anon_sym_using] = ACTIONS(4090),
    [anon_sym_static] = ACTIONS(4090),
    [anon_sym_EQ] = ACTIONS(4092),
    [anon_sym_LBRACK] = ACTIONS(4094),
    [anon_sym_event] = ACTIONS(4090),
    [anon_sym_LPAREN] = ACTIONS(4094),
    [anon_sym_abstract] = ACTIONS(4090),
    [anon_sym_async] = ACTIONS(4090),
    [anon_sym_const] = ACTIONS(4090),
    [anon_sym_fixed] = ACTIONS(4090),
    [anon_sym_internal] = ACTIONS(4090),
    [anon_sym_new] = ACTIONS(4090),
    [anon_sym_override] = ACTIONS(4090),
    [anon_sym_partial] = ACTIONS(4090),
    [anon_sym_private] = ACTIONS(4090),
    [anon_sym_protected] = ACTIONS(4090),
    [anon_sym_public] = ACTIONS(4090),
    [anon_sym_readonly] = ACTIONS(4090),
    [anon_sym_ref] = ACTIONS(4090),
    [anon_sym_sealed] = ACTIONS(4090),
    [anon_sym_unsafe] = ACTIONS(4090),
    [anon_sym_virtual] = ACTIONS(4090),
    [anon_sym_volatile] = ACTIONS(4090),
    [anon_sym_RBRACE] = ACTIONS(4094),
    [anon_sym_implicit] = ACTIONS(4090),
    [anon_sym_explicit] = ACTIONS(4090),
    [anon_sym_TILDE] = ACTIONS(4094),
    [anon_sym_where] = ACTIONS(4090),
    [anon_sym_class] = ACTIONS(4090),
    [anon_sym_struct] = ACTIONS(4090),
    [anon_sym_notnull] = ACTIONS(4090),
    [anon_sym_unmanaged] = ACTIONS(4090),
    [anon_sym_get] = ACTIONS(4090),
    [anon_sym_set] = ACTIONS(4090),
    [anon_sym_add] = ACTIONS(4090),
    [anon_sym_remove] = ACTIONS(4090),
    [anon_sym_enum] = ACTIONS(4090),
    [anon_sym_interface] = ACTIONS(4090),
    [anon_sym_delegate] = ACTIONS(4090),
    [anon_sym_record] = ACTIONS(4090),
    [anon_sym_namespace] = ACTIONS(4090),
    [anon_sym_var] = ACTIONS(4090),
    [sym_predefined_type] = ACTIONS(4090),
    [anon_sym_when] = ACTIONS(4090),
    [anon_sym_yield] = ACTIONS(4090),
    [anon_sym_from] = ACTIONS(4090),
    [anon_sym_join] = ACTIONS(4090),
    [anon_sym_on] = ACTIONS(4090),
    [anon_sym_equals] = ACTIONS(4090),
    [anon_sym_into] = ACTIONS(4090),
    [anon_sym_let] = ACTIONS(4090),
    [anon_sym_orderby] = ACTIONS(4090),
    [anon_sym_ascending] = ACTIONS(4090),
    [anon_sym_descending] = ACTIONS(4090),
    [anon_sym_group] = ACTIONS(4090),
    [anon_sym_by] = ACTIONS(4090),
    [anon_sym_select] = ACTIONS(4090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4090),
    [anon_sym_nameof] = ACTIONS(4090),
    [sym_void_keyword] = ACTIONS(4090),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2347] = {
    [sym__preprocessor_call] = STATE(2347),
    [sym__identifier_token] = ACTIONS(4096),
    [anon_sym_extern] = ACTIONS(4096),
    [anon_sym_alias] = ACTIONS(4096),
    [anon_sym_global] = ACTIONS(4096),
    [anon_sym_using] = ACTIONS(4096),
    [anon_sym_static] = ACTIONS(4096),
    [anon_sym_LBRACK] = ACTIONS(4098),
    [anon_sym_event] = ACTIONS(4096),
    [anon_sym_LPAREN] = ACTIONS(4098),
    [anon_sym_abstract] = ACTIONS(4096),
    [anon_sym_async] = ACTIONS(4096),
    [anon_sym_const] = ACTIONS(4096),
    [anon_sym_fixed] = ACTIONS(4096),
    [anon_sym_internal] = ACTIONS(4096),
    [anon_sym_new] = ACTIONS(4096),
    [anon_sym_override] = ACTIONS(4096),
    [anon_sym_partial] = ACTIONS(4096),
    [anon_sym_private] = ACTIONS(4096),
    [anon_sym_protected] = ACTIONS(4096),
    [anon_sym_public] = ACTIONS(4096),
    [anon_sym_readonly] = ACTIONS(4096),
    [anon_sym_ref] = ACTIONS(4096),
    [anon_sym_sealed] = ACTIONS(4096),
    [anon_sym_unsafe] = ACTIONS(4096),
    [anon_sym_virtual] = ACTIONS(4096),
    [anon_sym_volatile] = ACTIONS(4096),
    [anon_sym_RBRACE] = ACTIONS(4098),
    [anon_sym_implicit] = ACTIONS(4096),
    [anon_sym_explicit] = ACTIONS(4096),
    [anon_sym_TILDE] = ACTIONS(4098),
    [anon_sym_where] = ACTIONS(4096),
    [anon_sym_class] = ACTIONS(4096),
    [anon_sym_struct] = ACTIONS(4096),
    [anon_sym_notnull] = ACTIONS(4096),
    [anon_sym_unmanaged] = ACTIONS(4096),
    [anon_sym_get] = ACTIONS(4096),
    [anon_sym_set] = ACTIONS(4096),
    [anon_sym_add] = ACTIONS(4096),
    [anon_sym_remove] = ACTIONS(4096),
    [anon_sym_enum] = ACTIONS(4096),
    [anon_sym_interface] = ACTIONS(4096),
    [anon_sym_delegate] = ACTIONS(4096),
    [anon_sym_record] = ACTIONS(4096),
    [anon_sym_namespace] = ACTIONS(4096),
    [anon_sym_var] = ACTIONS(4096),
    [sym_predefined_type] = ACTIONS(4096),
    [anon_sym_when] = ACTIONS(4096),
    [anon_sym_yield] = ACTIONS(4096),
    [anon_sym_from] = ACTIONS(4096),
    [anon_sym_join] = ACTIONS(4096),
    [anon_sym_on] = ACTIONS(4096),
    [anon_sym_equals] = ACTIONS(4096),
    [anon_sym_into] = ACTIONS(4096),
    [anon_sym_let] = ACTIONS(4096),
    [anon_sym_orderby] = ACTIONS(4096),
    [anon_sym_ascending] = ACTIONS(4096),
    [anon_sym_descending] = ACTIONS(4096),
    [anon_sym_group] = ACTIONS(4096),
    [anon_sym_by] = ACTIONS(4096),
    [anon_sym_select] = ACTIONS(4096),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4096),
    [anon_sym_nameof] = ACTIONS(4096),
    [sym_void_keyword] = ACTIONS(4096),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2348] = {
    [sym__preprocessor_call] = STATE(2348),
    [sym__identifier_token] = ACTIONS(4100),
    [anon_sym_extern] = ACTIONS(4100),
    [anon_sym_alias] = ACTIONS(4100),
    [anon_sym_global] = ACTIONS(4100),
    [anon_sym_using] = ACTIONS(4100),
    [anon_sym_static] = ACTIONS(4100),
    [anon_sym_LBRACK] = ACTIONS(4102),
    [anon_sym_event] = ACTIONS(4100),
    [anon_sym_LPAREN] = ACTIONS(4102),
    [anon_sym_abstract] = ACTIONS(4100),
    [anon_sym_async] = ACTIONS(4100),
    [anon_sym_const] = ACTIONS(4100),
    [anon_sym_fixed] = ACTIONS(4100),
    [anon_sym_internal] = ACTIONS(4100),
    [anon_sym_new] = ACTIONS(4100),
    [anon_sym_override] = ACTIONS(4100),
    [anon_sym_partial] = ACTIONS(4100),
    [anon_sym_private] = ACTIONS(4100),
    [anon_sym_protected] = ACTIONS(4100),
    [anon_sym_public] = ACTIONS(4100),
    [anon_sym_readonly] = ACTIONS(4100),
    [anon_sym_ref] = ACTIONS(4100),
    [anon_sym_sealed] = ACTIONS(4100),
    [anon_sym_unsafe] = ACTIONS(4100),
    [anon_sym_virtual] = ACTIONS(4100),
    [anon_sym_volatile] = ACTIONS(4100),
    [anon_sym_RBRACE] = ACTIONS(4102),
    [anon_sym_implicit] = ACTIONS(4100),
    [anon_sym_explicit] = ACTIONS(4100),
    [anon_sym_TILDE] = ACTIONS(4102),
    [anon_sym_where] = ACTIONS(4100),
    [anon_sym_class] = ACTIONS(4100),
    [anon_sym_struct] = ACTIONS(4100),
    [anon_sym_notnull] = ACTIONS(4100),
    [anon_sym_unmanaged] = ACTIONS(4100),
    [anon_sym_get] = ACTIONS(4100),
    [anon_sym_set] = ACTIONS(4100),
    [anon_sym_add] = ACTIONS(4100),
    [anon_sym_remove] = ACTIONS(4100),
    [anon_sym_enum] = ACTIONS(4100),
    [anon_sym_interface] = ACTIONS(4100),
    [anon_sym_delegate] = ACTIONS(4100),
    [anon_sym_record] = ACTIONS(4100),
    [anon_sym_namespace] = ACTIONS(4100),
    [anon_sym_var] = ACTIONS(4100),
    [sym_predefined_type] = ACTIONS(4100),
    [anon_sym_when] = ACTIONS(4100),
    [anon_sym_yield] = ACTIONS(4100),
    [anon_sym_from] = ACTIONS(4100),
    [anon_sym_join] = ACTIONS(4100),
    [anon_sym_on] = ACTIONS(4100),
    [anon_sym_equals] = ACTIONS(4100),
    [anon_sym_into] = ACTIONS(4100),
    [anon_sym_let] = ACTIONS(4100),
    [anon_sym_orderby] = ACTIONS(4100),
    [anon_sym_ascending] = ACTIONS(4100),
    [anon_sym_descending] = ACTIONS(4100),
    [anon_sym_group] = ACTIONS(4100),
    [anon_sym_by] = ACTIONS(4100),
    [anon_sym_select] = ACTIONS(4100),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4100),
    [anon_sym_nameof] = ACTIONS(4100),
    [sym_void_keyword] = ACTIONS(4100),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2349] = {
    [sym__preprocessor_call] = STATE(2349),
    [sym__identifier_token] = ACTIONS(4104),
    [anon_sym_extern] = ACTIONS(4104),
    [anon_sym_alias] = ACTIONS(4104),
    [anon_sym_global] = ACTIONS(4104),
    [anon_sym_using] = ACTIONS(4104),
    [anon_sym_static] = ACTIONS(4104),
    [anon_sym_LBRACK] = ACTIONS(4106),
    [anon_sym_event] = ACTIONS(4104),
    [anon_sym_LPAREN] = ACTIONS(4106),
    [anon_sym_abstract] = ACTIONS(4104),
    [anon_sym_async] = ACTIONS(4104),
    [anon_sym_const] = ACTIONS(4104),
    [anon_sym_fixed] = ACTIONS(4104),
    [anon_sym_internal] = ACTIONS(4104),
    [anon_sym_new] = ACTIONS(4104),
    [anon_sym_override] = ACTIONS(4104),
    [anon_sym_partial] = ACTIONS(4104),
    [anon_sym_private] = ACTIONS(4104),
    [anon_sym_protected] = ACTIONS(4104),
    [anon_sym_public] = ACTIONS(4104),
    [anon_sym_readonly] = ACTIONS(4104),
    [anon_sym_ref] = ACTIONS(4104),
    [anon_sym_sealed] = ACTIONS(4104),
    [anon_sym_unsafe] = ACTIONS(4104),
    [anon_sym_virtual] = ACTIONS(4104),
    [anon_sym_volatile] = ACTIONS(4104),
    [anon_sym_RBRACE] = ACTIONS(4106),
    [anon_sym_implicit] = ACTIONS(4104),
    [anon_sym_explicit] = ACTIONS(4104),
    [anon_sym_TILDE] = ACTIONS(4106),
    [anon_sym_where] = ACTIONS(4104),
    [anon_sym_class] = ACTIONS(4104),
    [anon_sym_struct] = ACTIONS(4104),
    [anon_sym_notnull] = ACTIONS(4104),
    [anon_sym_unmanaged] = ACTIONS(4104),
    [anon_sym_get] = ACTIONS(4104),
    [anon_sym_set] = ACTIONS(4104),
    [anon_sym_add] = ACTIONS(4104),
    [anon_sym_remove] = ACTIONS(4104),
    [anon_sym_enum] = ACTIONS(4104),
    [anon_sym_interface] = ACTIONS(4104),
    [anon_sym_delegate] = ACTIONS(4104),
    [anon_sym_record] = ACTIONS(4104),
    [anon_sym_namespace] = ACTIONS(4104),
    [anon_sym_var] = ACTIONS(4104),
    [sym_predefined_type] = ACTIONS(4104),
    [anon_sym_when] = ACTIONS(4104),
    [anon_sym_yield] = ACTIONS(4104),
    [anon_sym_from] = ACTIONS(4104),
    [anon_sym_join] = ACTIONS(4104),
    [anon_sym_on] = ACTIONS(4104),
    [anon_sym_equals] = ACTIONS(4104),
    [anon_sym_into] = ACTIONS(4104),
    [anon_sym_let] = ACTIONS(4104),
    [anon_sym_orderby] = ACTIONS(4104),
    [anon_sym_ascending] = ACTIONS(4104),
    [anon_sym_descending] = ACTIONS(4104),
    [anon_sym_group] = ACTIONS(4104),
    [anon_sym_by] = ACTIONS(4104),
    [anon_sym_select] = ACTIONS(4104),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4104),
    [anon_sym_nameof] = ACTIONS(4104),
    [sym_void_keyword] = ACTIONS(4104),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2350] = {
    [sym__preprocessor_call] = STATE(2350),
    [sym__identifier_token] = ACTIONS(4108),
    [anon_sym_extern] = ACTIONS(4108),
    [anon_sym_alias] = ACTIONS(4108),
    [anon_sym_global] = ACTIONS(4108),
    [anon_sym_using] = ACTIONS(4108),
    [anon_sym_static] = ACTIONS(4108),
    [anon_sym_LBRACK] = ACTIONS(4110),
    [anon_sym_event] = ACTIONS(4108),
    [anon_sym_LPAREN] = ACTIONS(4110),
    [anon_sym_abstract] = ACTIONS(4108),
    [anon_sym_async] = ACTIONS(4108),
    [anon_sym_const] = ACTIONS(4108),
    [anon_sym_fixed] = ACTIONS(4108),
    [anon_sym_internal] = ACTIONS(4108),
    [anon_sym_new] = ACTIONS(4108),
    [anon_sym_override] = ACTIONS(4108),
    [anon_sym_partial] = ACTIONS(4108),
    [anon_sym_private] = ACTIONS(4108),
    [anon_sym_protected] = ACTIONS(4108),
    [anon_sym_public] = ACTIONS(4108),
    [anon_sym_readonly] = ACTIONS(4108),
    [anon_sym_ref] = ACTIONS(4108),
    [anon_sym_sealed] = ACTIONS(4108),
    [anon_sym_unsafe] = ACTIONS(4108),
    [anon_sym_virtual] = ACTIONS(4108),
    [anon_sym_volatile] = ACTIONS(4108),
    [anon_sym_RBRACE] = ACTIONS(4110),
    [anon_sym_implicit] = ACTIONS(4108),
    [anon_sym_explicit] = ACTIONS(4108),
    [anon_sym_TILDE] = ACTIONS(4110),
    [anon_sym_where] = ACTIONS(4108),
    [anon_sym_class] = ACTIONS(4108),
    [anon_sym_struct] = ACTIONS(4108),
    [anon_sym_notnull] = ACTIONS(4108),
    [anon_sym_unmanaged] = ACTIONS(4108),
    [anon_sym_get] = ACTIONS(4108),
    [anon_sym_set] = ACTIONS(4108),
    [anon_sym_add] = ACTIONS(4108),
    [anon_sym_remove] = ACTIONS(4108),
    [anon_sym_enum] = ACTIONS(4108),
    [anon_sym_interface] = ACTIONS(4108),
    [anon_sym_delegate] = ACTIONS(4108),
    [anon_sym_record] = ACTIONS(4108),
    [anon_sym_namespace] = ACTIONS(4108),
    [anon_sym_var] = ACTIONS(4108),
    [sym_predefined_type] = ACTIONS(4108),
    [anon_sym_when] = ACTIONS(4108),
    [anon_sym_yield] = ACTIONS(4108),
    [anon_sym_from] = ACTIONS(4108),
    [anon_sym_join] = ACTIONS(4108),
    [anon_sym_on] = ACTIONS(4108),
    [anon_sym_equals] = ACTIONS(4108),
    [anon_sym_into] = ACTIONS(4108),
    [anon_sym_let] = ACTIONS(4108),
    [anon_sym_orderby] = ACTIONS(4108),
    [anon_sym_ascending] = ACTIONS(4108),
    [anon_sym_descending] = ACTIONS(4108),
    [anon_sym_group] = ACTIONS(4108),
    [anon_sym_by] = ACTIONS(4108),
    [anon_sym_select] = ACTIONS(4108),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4108),
    [anon_sym_nameof] = ACTIONS(4108),
    [sym_void_keyword] = ACTIONS(4108),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2351] = {
    [sym__preprocessor_call] = STATE(2351),
    [sym__identifier_token] = ACTIONS(4112),
    [anon_sym_extern] = ACTIONS(4112),
    [anon_sym_alias] = ACTIONS(4112),
    [anon_sym_global] = ACTIONS(4112),
    [anon_sym_using] = ACTIONS(4112),
    [anon_sym_static] = ACTIONS(4112),
    [anon_sym_LBRACK] = ACTIONS(4114),
    [anon_sym_event] = ACTIONS(4112),
    [anon_sym_LPAREN] = ACTIONS(4114),
    [anon_sym_abstract] = ACTIONS(4112),
    [anon_sym_async] = ACTIONS(4112),
    [anon_sym_const] = ACTIONS(4112),
    [anon_sym_fixed] = ACTIONS(4112),
    [anon_sym_internal] = ACTIONS(4112),
    [anon_sym_new] = ACTIONS(4112),
    [anon_sym_override] = ACTIONS(4112),
    [anon_sym_partial] = ACTIONS(4112),
    [anon_sym_private] = ACTIONS(4112),
    [anon_sym_protected] = ACTIONS(4112),
    [anon_sym_public] = ACTIONS(4112),
    [anon_sym_readonly] = ACTIONS(4112),
    [anon_sym_ref] = ACTIONS(4112),
    [anon_sym_sealed] = ACTIONS(4112),
    [anon_sym_unsafe] = ACTIONS(4112),
    [anon_sym_virtual] = ACTIONS(4112),
    [anon_sym_volatile] = ACTIONS(4112),
    [anon_sym_RBRACE] = ACTIONS(4114),
    [anon_sym_implicit] = ACTIONS(4112),
    [anon_sym_explicit] = ACTIONS(4112),
    [anon_sym_TILDE] = ACTIONS(4114),
    [anon_sym_where] = ACTIONS(4112),
    [anon_sym_class] = ACTIONS(4112),
    [anon_sym_struct] = ACTIONS(4112),
    [anon_sym_notnull] = ACTIONS(4112),
    [anon_sym_unmanaged] = ACTIONS(4112),
    [anon_sym_get] = ACTIONS(4112),
    [anon_sym_set] = ACTIONS(4112),
    [anon_sym_add] = ACTIONS(4112),
    [anon_sym_remove] = ACTIONS(4112),
    [anon_sym_enum] = ACTIONS(4112),
    [anon_sym_interface] = ACTIONS(4112),
    [anon_sym_delegate] = ACTIONS(4112),
    [anon_sym_record] = ACTIONS(4112),
    [anon_sym_namespace] = ACTIONS(4112),
    [anon_sym_var] = ACTIONS(4112),
    [sym_predefined_type] = ACTIONS(4112),
    [anon_sym_when] = ACTIONS(4112),
    [anon_sym_yield] = ACTIONS(4112),
    [anon_sym_from] = ACTIONS(4112),
    [anon_sym_join] = ACTIONS(4112),
    [anon_sym_on] = ACTIONS(4112),
    [anon_sym_equals] = ACTIONS(4112),
    [anon_sym_into] = ACTIONS(4112),
    [anon_sym_let] = ACTIONS(4112),
    [anon_sym_orderby] = ACTIONS(4112),
    [anon_sym_ascending] = ACTIONS(4112),
    [anon_sym_descending] = ACTIONS(4112),
    [anon_sym_group] = ACTIONS(4112),
    [anon_sym_by] = ACTIONS(4112),
    [anon_sym_select] = ACTIONS(4112),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4112),
    [anon_sym_nameof] = ACTIONS(4112),
    [sym_void_keyword] = ACTIONS(4112),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2352] = {
    [sym__preprocessor_call] = STATE(2352),
    [sym__identifier_token] = ACTIONS(4116),
    [anon_sym_extern] = ACTIONS(4116),
    [anon_sym_alias] = ACTIONS(4116),
    [anon_sym_global] = ACTIONS(4116),
    [anon_sym_using] = ACTIONS(4116),
    [anon_sym_static] = ACTIONS(4116),
    [anon_sym_LBRACK] = ACTIONS(4118),
    [anon_sym_event] = ACTIONS(4116),
    [anon_sym_LPAREN] = ACTIONS(4118),
    [anon_sym_abstract] = ACTIONS(4116),
    [anon_sym_async] = ACTIONS(4116),
    [anon_sym_const] = ACTIONS(4116),
    [anon_sym_fixed] = ACTIONS(4116),
    [anon_sym_internal] = ACTIONS(4116),
    [anon_sym_new] = ACTIONS(4116),
    [anon_sym_override] = ACTIONS(4116),
    [anon_sym_partial] = ACTIONS(4116),
    [anon_sym_private] = ACTIONS(4116),
    [anon_sym_protected] = ACTIONS(4116),
    [anon_sym_public] = ACTIONS(4116),
    [anon_sym_readonly] = ACTIONS(4116),
    [anon_sym_ref] = ACTIONS(4116),
    [anon_sym_sealed] = ACTIONS(4116),
    [anon_sym_unsafe] = ACTIONS(4116),
    [anon_sym_virtual] = ACTIONS(4116),
    [anon_sym_volatile] = ACTIONS(4116),
    [anon_sym_RBRACE] = ACTIONS(4118),
    [anon_sym_implicit] = ACTIONS(4116),
    [anon_sym_explicit] = ACTIONS(4116),
    [anon_sym_TILDE] = ACTIONS(4118),
    [anon_sym_where] = ACTIONS(4116),
    [anon_sym_class] = ACTIONS(4116),
    [anon_sym_struct] = ACTIONS(4116),
    [anon_sym_notnull] = ACTIONS(4116),
    [anon_sym_unmanaged] = ACTIONS(4116),
    [anon_sym_get] = ACTIONS(4116),
    [anon_sym_set] = ACTIONS(4116),
    [anon_sym_add] = ACTIONS(4116),
    [anon_sym_remove] = ACTIONS(4116),
    [anon_sym_enum] = ACTIONS(4116),
    [anon_sym_interface] = ACTIONS(4116),
    [anon_sym_delegate] = ACTIONS(4116),
    [anon_sym_record] = ACTIONS(4116),
    [anon_sym_namespace] = ACTIONS(4116),
    [anon_sym_var] = ACTIONS(4116),
    [sym_predefined_type] = ACTIONS(4116),
    [anon_sym_when] = ACTIONS(4116),
    [anon_sym_yield] = ACTIONS(4116),
    [anon_sym_from] = ACTIONS(4116),
    [anon_sym_join] = ACTIONS(4116),
    [anon_sym_on] = ACTIONS(4116),
    [anon_sym_equals] = ACTIONS(4116),
    [anon_sym_into] = ACTIONS(4116),
    [anon_sym_let] = ACTIONS(4116),
    [anon_sym_orderby] = ACTIONS(4116),
    [anon_sym_ascending] = ACTIONS(4116),
    [anon_sym_descending] = ACTIONS(4116),
    [anon_sym_group] = ACTIONS(4116),
    [anon_sym_by] = ACTIONS(4116),
    [anon_sym_select] = ACTIONS(4116),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4116),
    [anon_sym_nameof] = ACTIONS(4116),
    [sym_void_keyword] = ACTIONS(4116),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2353] = {
    [sym__preprocessor_call] = STATE(2353),
    [sym__identifier_token] = ACTIONS(4120),
    [anon_sym_extern] = ACTIONS(4120),
    [anon_sym_alias] = ACTIONS(4120),
    [anon_sym_global] = ACTIONS(4120),
    [anon_sym_using] = ACTIONS(4120),
    [anon_sym_static] = ACTIONS(4120),
    [anon_sym_LBRACK] = ACTIONS(4122),
    [anon_sym_event] = ACTIONS(4120),
    [anon_sym_LPAREN] = ACTIONS(4122),
    [anon_sym_abstract] = ACTIONS(4120),
    [anon_sym_async] = ACTIONS(4120),
    [anon_sym_const] = ACTIONS(4120),
    [anon_sym_fixed] = ACTIONS(4120),
    [anon_sym_internal] = ACTIONS(4120),
    [anon_sym_new] = ACTIONS(4120),
    [anon_sym_override] = ACTIONS(4120),
    [anon_sym_partial] = ACTIONS(4120),
    [anon_sym_private] = ACTIONS(4120),
    [anon_sym_protected] = ACTIONS(4120),
    [anon_sym_public] = ACTIONS(4120),
    [anon_sym_readonly] = ACTIONS(4120),
    [anon_sym_ref] = ACTIONS(4120),
    [anon_sym_sealed] = ACTIONS(4120),
    [anon_sym_unsafe] = ACTIONS(4120),
    [anon_sym_virtual] = ACTIONS(4120),
    [anon_sym_volatile] = ACTIONS(4120),
    [anon_sym_RBRACE] = ACTIONS(4122),
    [anon_sym_implicit] = ACTIONS(4120),
    [anon_sym_explicit] = ACTIONS(4120),
    [anon_sym_TILDE] = ACTIONS(4122),
    [anon_sym_where] = ACTIONS(4120),
    [anon_sym_class] = ACTIONS(4120),
    [anon_sym_struct] = ACTIONS(4120),
    [anon_sym_notnull] = ACTIONS(4120),
    [anon_sym_unmanaged] = ACTIONS(4120),
    [anon_sym_get] = ACTIONS(4120),
    [anon_sym_set] = ACTIONS(4120),
    [anon_sym_add] = ACTIONS(4120),
    [anon_sym_remove] = ACTIONS(4120),
    [anon_sym_enum] = ACTIONS(4120),
    [anon_sym_interface] = ACTIONS(4120),
    [anon_sym_delegate] = ACTIONS(4120),
    [anon_sym_record] = ACTIONS(4120),
    [anon_sym_namespace] = ACTIONS(4120),
    [anon_sym_var] = ACTIONS(4120),
    [sym_predefined_type] = ACTIONS(4120),
    [anon_sym_when] = ACTIONS(4120),
    [anon_sym_yield] = ACTIONS(4120),
    [anon_sym_from] = ACTIONS(4120),
    [anon_sym_join] = ACTIONS(4120),
    [anon_sym_on] = ACTIONS(4120),
    [anon_sym_equals] = ACTIONS(4120),
    [anon_sym_into] = ACTIONS(4120),
    [anon_sym_let] = ACTIONS(4120),
    [anon_sym_orderby] = ACTIONS(4120),
    [anon_sym_ascending] = ACTIONS(4120),
    [anon_sym_descending] = ACTIONS(4120),
    [anon_sym_group] = ACTIONS(4120),
    [anon_sym_by] = ACTIONS(4120),
    [anon_sym_select] = ACTIONS(4120),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4120),
    [anon_sym_nameof] = ACTIONS(4120),
    [sym_void_keyword] = ACTIONS(4120),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2354] = {
    [sym__preprocessor_call] = STATE(2354),
    [sym__identifier_token] = ACTIONS(4124),
    [anon_sym_extern] = ACTIONS(4124),
    [anon_sym_alias] = ACTIONS(4124),
    [anon_sym_global] = ACTIONS(4124),
    [anon_sym_using] = ACTIONS(4124),
    [anon_sym_static] = ACTIONS(4124),
    [anon_sym_LBRACK] = ACTIONS(4126),
    [anon_sym_event] = ACTIONS(4124),
    [anon_sym_LPAREN] = ACTIONS(4126),
    [anon_sym_abstract] = ACTIONS(4124),
    [anon_sym_async] = ACTIONS(4124),
    [anon_sym_const] = ACTIONS(4124),
    [anon_sym_fixed] = ACTIONS(4124),
    [anon_sym_internal] = ACTIONS(4124),
    [anon_sym_new] = ACTIONS(4124),
    [anon_sym_override] = ACTIONS(4124),
    [anon_sym_partial] = ACTIONS(4124),
    [anon_sym_private] = ACTIONS(4124),
    [anon_sym_protected] = ACTIONS(4124),
    [anon_sym_public] = ACTIONS(4124),
    [anon_sym_readonly] = ACTIONS(4124),
    [anon_sym_ref] = ACTIONS(4124),
    [anon_sym_sealed] = ACTIONS(4124),
    [anon_sym_unsafe] = ACTIONS(4124),
    [anon_sym_virtual] = ACTIONS(4124),
    [anon_sym_volatile] = ACTIONS(4124),
    [anon_sym_RBRACE] = ACTIONS(4126),
    [anon_sym_implicit] = ACTIONS(4124),
    [anon_sym_explicit] = ACTIONS(4124),
    [anon_sym_TILDE] = ACTIONS(4126),
    [anon_sym_where] = ACTIONS(4124),
    [anon_sym_class] = ACTIONS(4124),
    [anon_sym_struct] = ACTIONS(4124),
    [anon_sym_notnull] = ACTIONS(4124),
    [anon_sym_unmanaged] = ACTIONS(4124),
    [anon_sym_get] = ACTIONS(4124),
    [anon_sym_set] = ACTIONS(4124),
    [anon_sym_add] = ACTIONS(4124),
    [anon_sym_remove] = ACTIONS(4124),
    [anon_sym_enum] = ACTIONS(4124),
    [anon_sym_interface] = ACTIONS(4124),
    [anon_sym_delegate] = ACTIONS(4124),
    [anon_sym_record] = ACTIONS(4124),
    [anon_sym_namespace] = ACTIONS(4124),
    [anon_sym_var] = ACTIONS(4124),
    [sym_predefined_type] = ACTIONS(4124),
    [anon_sym_when] = ACTIONS(4124),
    [anon_sym_yield] = ACTIONS(4124),
    [anon_sym_from] = ACTIONS(4124),
    [anon_sym_join] = ACTIONS(4124),
    [anon_sym_on] = ACTIONS(4124),
    [anon_sym_equals] = ACTIONS(4124),
    [anon_sym_into] = ACTIONS(4124),
    [anon_sym_let] = ACTIONS(4124),
    [anon_sym_orderby] = ACTIONS(4124),
    [anon_sym_ascending] = ACTIONS(4124),
    [anon_sym_descending] = ACTIONS(4124),
    [anon_sym_group] = ACTIONS(4124),
    [anon_sym_by] = ACTIONS(4124),
    [anon_sym_select] = ACTIONS(4124),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4124),
    [anon_sym_nameof] = ACTIONS(4124),
    [sym_void_keyword] = ACTIONS(4124),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2355] = {
    [sym__preprocessor_call] = STATE(2355),
    [sym__identifier_token] = ACTIONS(4128),
    [anon_sym_extern] = ACTIONS(4128),
    [anon_sym_alias] = ACTIONS(4128),
    [anon_sym_global] = ACTIONS(4128),
    [anon_sym_using] = ACTIONS(4128),
    [anon_sym_static] = ACTIONS(4128),
    [anon_sym_LBRACK] = ACTIONS(4130),
    [anon_sym_event] = ACTIONS(4128),
    [anon_sym_LPAREN] = ACTIONS(4130),
    [anon_sym_abstract] = ACTIONS(4128),
    [anon_sym_async] = ACTIONS(4128),
    [anon_sym_const] = ACTIONS(4128),
    [anon_sym_fixed] = ACTIONS(4128),
    [anon_sym_internal] = ACTIONS(4128),
    [anon_sym_new] = ACTIONS(4128),
    [anon_sym_override] = ACTIONS(4128),
    [anon_sym_partial] = ACTIONS(4128),
    [anon_sym_private] = ACTIONS(4128),
    [anon_sym_protected] = ACTIONS(4128),
    [anon_sym_public] = ACTIONS(4128),
    [anon_sym_readonly] = ACTIONS(4128),
    [anon_sym_ref] = ACTIONS(4128),
    [anon_sym_sealed] = ACTIONS(4128),
    [anon_sym_unsafe] = ACTIONS(4128),
    [anon_sym_virtual] = ACTIONS(4128),
    [anon_sym_volatile] = ACTIONS(4128),
    [anon_sym_RBRACE] = ACTIONS(4130),
    [anon_sym_implicit] = ACTIONS(4128),
    [anon_sym_explicit] = ACTIONS(4128),
    [anon_sym_TILDE] = ACTIONS(4130),
    [anon_sym_where] = ACTIONS(4128),
    [anon_sym_class] = ACTIONS(4128),
    [anon_sym_struct] = ACTIONS(4128),
    [anon_sym_notnull] = ACTIONS(4128),
    [anon_sym_unmanaged] = ACTIONS(4128),
    [anon_sym_get] = ACTIONS(4128),
    [anon_sym_set] = ACTIONS(4128),
    [anon_sym_add] = ACTIONS(4128),
    [anon_sym_remove] = ACTIONS(4128),
    [anon_sym_enum] = ACTIONS(4128),
    [anon_sym_interface] = ACTIONS(4128),
    [anon_sym_delegate] = ACTIONS(4128),
    [anon_sym_record] = ACTIONS(4128),
    [anon_sym_namespace] = ACTIONS(4128),
    [anon_sym_var] = ACTIONS(4128),
    [sym_predefined_type] = ACTIONS(4128),
    [anon_sym_when] = ACTIONS(4128),
    [anon_sym_yield] = ACTIONS(4128),
    [anon_sym_from] = ACTIONS(4128),
    [anon_sym_join] = ACTIONS(4128),
    [anon_sym_on] = ACTIONS(4128),
    [anon_sym_equals] = ACTIONS(4128),
    [anon_sym_into] = ACTIONS(4128),
    [anon_sym_let] = ACTIONS(4128),
    [anon_sym_orderby] = ACTIONS(4128),
    [anon_sym_ascending] = ACTIONS(4128),
    [anon_sym_descending] = ACTIONS(4128),
    [anon_sym_group] = ACTIONS(4128),
    [anon_sym_by] = ACTIONS(4128),
    [anon_sym_select] = ACTIONS(4128),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4128),
    [anon_sym_nameof] = ACTIONS(4128),
    [sym_void_keyword] = ACTIONS(4128),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2356] = {
    [sym__preprocessor_call] = STATE(2356),
    [sym__identifier_token] = ACTIONS(4132),
    [anon_sym_extern] = ACTIONS(4132),
    [anon_sym_alias] = ACTIONS(4132),
    [anon_sym_global] = ACTIONS(4132),
    [anon_sym_using] = ACTIONS(4132),
    [anon_sym_static] = ACTIONS(4132),
    [anon_sym_LBRACK] = ACTIONS(4134),
    [anon_sym_event] = ACTIONS(4132),
    [anon_sym_LPAREN] = ACTIONS(4134),
    [anon_sym_abstract] = ACTIONS(4132),
    [anon_sym_async] = ACTIONS(4132),
    [anon_sym_const] = ACTIONS(4132),
    [anon_sym_fixed] = ACTIONS(4132),
    [anon_sym_internal] = ACTIONS(4132),
    [anon_sym_new] = ACTIONS(4132),
    [anon_sym_override] = ACTIONS(4132),
    [anon_sym_partial] = ACTIONS(4132),
    [anon_sym_private] = ACTIONS(4132),
    [anon_sym_protected] = ACTIONS(4132),
    [anon_sym_public] = ACTIONS(4132),
    [anon_sym_readonly] = ACTIONS(4132),
    [anon_sym_ref] = ACTIONS(4132),
    [anon_sym_sealed] = ACTIONS(4132),
    [anon_sym_unsafe] = ACTIONS(4132),
    [anon_sym_virtual] = ACTIONS(4132),
    [anon_sym_volatile] = ACTIONS(4132),
    [anon_sym_RBRACE] = ACTIONS(4134),
    [anon_sym_implicit] = ACTIONS(4132),
    [anon_sym_explicit] = ACTIONS(4132),
    [anon_sym_TILDE] = ACTIONS(4134),
    [anon_sym_where] = ACTIONS(4132),
    [anon_sym_class] = ACTIONS(4132),
    [anon_sym_struct] = ACTIONS(4132),
    [anon_sym_notnull] = ACTIONS(4132),
    [anon_sym_unmanaged] = ACTIONS(4132),
    [anon_sym_get] = ACTIONS(4132),
    [anon_sym_set] = ACTIONS(4132),
    [anon_sym_add] = ACTIONS(4132),
    [anon_sym_remove] = ACTIONS(4132),
    [anon_sym_enum] = ACTIONS(4132),
    [anon_sym_interface] = ACTIONS(4132),
    [anon_sym_delegate] = ACTIONS(4132),
    [anon_sym_record] = ACTIONS(4132),
    [anon_sym_namespace] = ACTIONS(4132),
    [anon_sym_var] = ACTIONS(4132),
    [sym_predefined_type] = ACTIONS(4132),
    [anon_sym_when] = ACTIONS(4132),
    [anon_sym_yield] = ACTIONS(4132),
    [anon_sym_from] = ACTIONS(4132),
    [anon_sym_join] = ACTIONS(4132),
    [anon_sym_on] = ACTIONS(4132),
    [anon_sym_equals] = ACTIONS(4132),
    [anon_sym_into] = ACTIONS(4132),
    [anon_sym_let] = ACTIONS(4132),
    [anon_sym_orderby] = ACTIONS(4132),
    [anon_sym_ascending] = ACTIONS(4132),
    [anon_sym_descending] = ACTIONS(4132),
    [anon_sym_group] = ACTIONS(4132),
    [anon_sym_by] = ACTIONS(4132),
    [anon_sym_select] = ACTIONS(4132),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4132),
    [anon_sym_nameof] = ACTIONS(4132),
    [sym_void_keyword] = ACTIONS(4132),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2357] = {
    [sym__preprocessor_call] = STATE(2357),
    [sym__identifier_token] = ACTIONS(4136),
    [anon_sym_extern] = ACTIONS(4136),
    [anon_sym_alias] = ACTIONS(4136),
    [anon_sym_global] = ACTIONS(4136),
    [anon_sym_using] = ACTIONS(4136),
    [anon_sym_static] = ACTIONS(4136),
    [anon_sym_LBRACK] = ACTIONS(4138),
    [anon_sym_event] = ACTIONS(4136),
    [anon_sym_LPAREN] = ACTIONS(4138),
    [anon_sym_abstract] = ACTIONS(4136),
    [anon_sym_async] = ACTIONS(4136),
    [anon_sym_const] = ACTIONS(4136),
    [anon_sym_fixed] = ACTIONS(4136),
    [anon_sym_internal] = ACTIONS(4136),
    [anon_sym_new] = ACTIONS(4136),
    [anon_sym_override] = ACTIONS(4136),
    [anon_sym_partial] = ACTIONS(4136),
    [anon_sym_private] = ACTIONS(4136),
    [anon_sym_protected] = ACTIONS(4136),
    [anon_sym_public] = ACTIONS(4136),
    [anon_sym_readonly] = ACTIONS(4136),
    [anon_sym_ref] = ACTIONS(4136),
    [anon_sym_sealed] = ACTIONS(4136),
    [anon_sym_unsafe] = ACTIONS(4136),
    [anon_sym_virtual] = ACTIONS(4136),
    [anon_sym_volatile] = ACTIONS(4136),
    [anon_sym_RBRACE] = ACTIONS(4138),
    [anon_sym_implicit] = ACTIONS(4136),
    [anon_sym_explicit] = ACTIONS(4136),
    [anon_sym_TILDE] = ACTIONS(4138),
    [anon_sym_where] = ACTIONS(4136),
    [anon_sym_class] = ACTIONS(4136),
    [anon_sym_struct] = ACTIONS(4136),
    [anon_sym_notnull] = ACTIONS(4136),
    [anon_sym_unmanaged] = ACTIONS(4136),
    [anon_sym_get] = ACTIONS(4136),
    [anon_sym_set] = ACTIONS(4136),
    [anon_sym_add] = ACTIONS(4136),
    [anon_sym_remove] = ACTIONS(4136),
    [anon_sym_enum] = ACTIONS(4136),
    [anon_sym_interface] = ACTIONS(4136),
    [anon_sym_delegate] = ACTIONS(4136),
    [anon_sym_record] = ACTIONS(4136),
    [anon_sym_namespace] = ACTIONS(4136),
    [anon_sym_var] = ACTIONS(4136),
    [sym_predefined_type] = ACTIONS(4136),
    [anon_sym_when] = ACTIONS(4136),
    [anon_sym_yield] = ACTIONS(4136),
    [anon_sym_from] = ACTIONS(4136),
    [anon_sym_join] = ACTIONS(4136),
    [anon_sym_on] = ACTIONS(4136),
    [anon_sym_equals] = ACTIONS(4136),
    [anon_sym_into] = ACTIONS(4136),
    [anon_sym_let] = ACTIONS(4136),
    [anon_sym_orderby] = ACTIONS(4136),
    [anon_sym_ascending] = ACTIONS(4136),
    [anon_sym_descending] = ACTIONS(4136),
    [anon_sym_group] = ACTIONS(4136),
    [anon_sym_by] = ACTIONS(4136),
    [anon_sym_select] = ACTIONS(4136),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4136),
    [anon_sym_nameof] = ACTIONS(4136),
    [sym_void_keyword] = ACTIONS(4136),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2358] = {
    [sym__preprocessor_call] = STATE(2358),
    [sym__identifier_token] = ACTIONS(4140),
    [anon_sym_extern] = ACTIONS(4140),
    [anon_sym_alias] = ACTIONS(4140),
    [anon_sym_global] = ACTIONS(4140),
    [anon_sym_using] = ACTIONS(4140),
    [anon_sym_static] = ACTIONS(4140),
    [anon_sym_LBRACK] = ACTIONS(4142),
    [anon_sym_event] = ACTIONS(4140),
    [anon_sym_LPAREN] = ACTIONS(4142),
    [anon_sym_abstract] = ACTIONS(4140),
    [anon_sym_async] = ACTIONS(4140),
    [anon_sym_const] = ACTIONS(4140),
    [anon_sym_fixed] = ACTIONS(4140),
    [anon_sym_internal] = ACTIONS(4140),
    [anon_sym_new] = ACTIONS(4140),
    [anon_sym_override] = ACTIONS(4140),
    [anon_sym_partial] = ACTIONS(4140),
    [anon_sym_private] = ACTIONS(4140),
    [anon_sym_protected] = ACTIONS(4140),
    [anon_sym_public] = ACTIONS(4140),
    [anon_sym_readonly] = ACTIONS(4140),
    [anon_sym_ref] = ACTIONS(4140),
    [anon_sym_sealed] = ACTIONS(4140),
    [anon_sym_unsafe] = ACTIONS(4140),
    [anon_sym_virtual] = ACTIONS(4140),
    [anon_sym_volatile] = ACTIONS(4140),
    [anon_sym_RBRACE] = ACTIONS(4142),
    [anon_sym_implicit] = ACTIONS(4140),
    [anon_sym_explicit] = ACTIONS(4140),
    [anon_sym_TILDE] = ACTIONS(4142),
    [anon_sym_where] = ACTIONS(4140),
    [anon_sym_class] = ACTIONS(4140),
    [anon_sym_struct] = ACTIONS(4140),
    [anon_sym_notnull] = ACTIONS(4140),
    [anon_sym_unmanaged] = ACTIONS(4140),
    [anon_sym_get] = ACTIONS(4140),
    [anon_sym_set] = ACTIONS(4140),
    [anon_sym_add] = ACTIONS(4140),
    [anon_sym_remove] = ACTIONS(4140),
    [anon_sym_enum] = ACTIONS(4140),
    [anon_sym_interface] = ACTIONS(4140),
    [anon_sym_delegate] = ACTIONS(4140),
    [anon_sym_record] = ACTIONS(4140),
    [anon_sym_namespace] = ACTIONS(4140),
    [anon_sym_var] = ACTIONS(4140),
    [sym_predefined_type] = ACTIONS(4140),
    [anon_sym_when] = ACTIONS(4140),
    [anon_sym_yield] = ACTIONS(4140),
    [anon_sym_from] = ACTIONS(4140),
    [anon_sym_join] = ACTIONS(4140),
    [anon_sym_on] = ACTIONS(4140),
    [anon_sym_equals] = ACTIONS(4140),
    [anon_sym_into] = ACTIONS(4140),
    [anon_sym_let] = ACTIONS(4140),
    [anon_sym_orderby] = ACTIONS(4140),
    [anon_sym_ascending] = ACTIONS(4140),
    [anon_sym_descending] = ACTIONS(4140),
    [anon_sym_group] = ACTIONS(4140),
    [anon_sym_by] = ACTIONS(4140),
    [anon_sym_select] = ACTIONS(4140),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4140),
    [anon_sym_nameof] = ACTIONS(4140),
    [sym_void_keyword] = ACTIONS(4140),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2359] = {
    [sym__preprocessor_call] = STATE(2359),
    [sym__identifier_token] = ACTIONS(4144),
    [anon_sym_extern] = ACTIONS(4144),
    [anon_sym_alias] = ACTIONS(4144),
    [anon_sym_global] = ACTIONS(4144),
    [anon_sym_using] = ACTIONS(4144),
    [anon_sym_static] = ACTIONS(4144),
    [anon_sym_LBRACK] = ACTIONS(4146),
    [anon_sym_event] = ACTIONS(4144),
    [anon_sym_LPAREN] = ACTIONS(4146),
    [anon_sym_abstract] = ACTIONS(4144),
    [anon_sym_async] = ACTIONS(4144),
    [anon_sym_const] = ACTIONS(4144),
    [anon_sym_fixed] = ACTIONS(4144),
    [anon_sym_internal] = ACTIONS(4144),
    [anon_sym_new] = ACTIONS(4144),
    [anon_sym_override] = ACTIONS(4144),
    [anon_sym_partial] = ACTIONS(4144),
    [anon_sym_private] = ACTIONS(4144),
    [anon_sym_protected] = ACTIONS(4144),
    [anon_sym_public] = ACTIONS(4144),
    [anon_sym_readonly] = ACTIONS(4144),
    [anon_sym_ref] = ACTIONS(4144),
    [anon_sym_sealed] = ACTIONS(4144),
    [anon_sym_unsafe] = ACTIONS(4144),
    [anon_sym_virtual] = ACTIONS(4144),
    [anon_sym_volatile] = ACTIONS(4144),
    [anon_sym_RBRACE] = ACTIONS(4146),
    [anon_sym_implicit] = ACTIONS(4144),
    [anon_sym_explicit] = ACTIONS(4144),
    [anon_sym_TILDE] = ACTIONS(4146),
    [anon_sym_where] = ACTIONS(4144),
    [anon_sym_class] = ACTIONS(4144),
    [anon_sym_struct] = ACTIONS(4144),
    [anon_sym_notnull] = ACTIONS(4144),
    [anon_sym_unmanaged] = ACTIONS(4144),
    [anon_sym_get] = ACTIONS(4144),
    [anon_sym_set] = ACTIONS(4144),
    [anon_sym_add] = ACTIONS(4144),
    [anon_sym_remove] = ACTIONS(4144),
    [anon_sym_enum] = ACTIONS(4144),
    [anon_sym_interface] = ACTIONS(4144),
    [anon_sym_delegate] = ACTIONS(4144),
    [anon_sym_record] = ACTIONS(4144),
    [anon_sym_namespace] = ACTIONS(4144),
    [anon_sym_var] = ACTIONS(4144),
    [sym_predefined_type] = ACTIONS(4144),
    [anon_sym_when] = ACTIONS(4144),
    [anon_sym_yield] = ACTIONS(4144),
    [anon_sym_from] = ACTIONS(4144),
    [anon_sym_join] = ACTIONS(4144),
    [anon_sym_on] = ACTIONS(4144),
    [anon_sym_equals] = ACTIONS(4144),
    [anon_sym_into] = ACTIONS(4144),
    [anon_sym_let] = ACTIONS(4144),
    [anon_sym_orderby] = ACTIONS(4144),
    [anon_sym_ascending] = ACTIONS(4144),
    [anon_sym_descending] = ACTIONS(4144),
    [anon_sym_group] = ACTIONS(4144),
    [anon_sym_by] = ACTIONS(4144),
    [anon_sym_select] = ACTIONS(4144),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4144),
    [anon_sym_nameof] = ACTIONS(4144),
    [sym_void_keyword] = ACTIONS(4144),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2360] = {
    [sym__preprocessor_call] = STATE(2360),
    [sym__identifier_token] = ACTIONS(4148),
    [anon_sym_extern] = ACTIONS(4148),
    [anon_sym_alias] = ACTIONS(4148),
    [anon_sym_global] = ACTIONS(4148),
    [anon_sym_using] = ACTIONS(4148),
    [anon_sym_static] = ACTIONS(4148),
    [anon_sym_LBRACK] = ACTIONS(4150),
    [anon_sym_event] = ACTIONS(4148),
    [anon_sym_LPAREN] = ACTIONS(4150),
    [anon_sym_abstract] = ACTIONS(4148),
    [anon_sym_async] = ACTIONS(4148),
    [anon_sym_const] = ACTIONS(4148),
    [anon_sym_fixed] = ACTIONS(4148),
    [anon_sym_internal] = ACTIONS(4148),
    [anon_sym_new] = ACTIONS(4148),
    [anon_sym_override] = ACTIONS(4148),
    [anon_sym_partial] = ACTIONS(4148),
    [anon_sym_private] = ACTIONS(4148),
    [anon_sym_protected] = ACTIONS(4148),
    [anon_sym_public] = ACTIONS(4148),
    [anon_sym_readonly] = ACTIONS(4148),
    [anon_sym_ref] = ACTIONS(4148),
    [anon_sym_sealed] = ACTIONS(4148),
    [anon_sym_unsafe] = ACTIONS(4148),
    [anon_sym_virtual] = ACTIONS(4148),
    [anon_sym_volatile] = ACTIONS(4148),
    [anon_sym_RBRACE] = ACTIONS(4150),
    [anon_sym_implicit] = ACTIONS(4148),
    [anon_sym_explicit] = ACTIONS(4148),
    [anon_sym_TILDE] = ACTIONS(4150),
    [anon_sym_where] = ACTIONS(4148),
    [anon_sym_class] = ACTIONS(4148),
    [anon_sym_struct] = ACTIONS(4148),
    [anon_sym_notnull] = ACTIONS(4148),
    [anon_sym_unmanaged] = ACTIONS(4148),
    [anon_sym_get] = ACTIONS(4148),
    [anon_sym_set] = ACTIONS(4148),
    [anon_sym_add] = ACTIONS(4148),
    [anon_sym_remove] = ACTIONS(4148),
    [anon_sym_enum] = ACTIONS(4148),
    [anon_sym_interface] = ACTIONS(4148),
    [anon_sym_delegate] = ACTIONS(4148),
    [anon_sym_record] = ACTIONS(4148),
    [anon_sym_namespace] = ACTIONS(4148),
    [anon_sym_var] = ACTIONS(4148),
    [sym_predefined_type] = ACTIONS(4148),
    [anon_sym_when] = ACTIONS(4148),
    [anon_sym_yield] = ACTIONS(4148),
    [anon_sym_from] = ACTIONS(4148),
    [anon_sym_join] = ACTIONS(4148),
    [anon_sym_on] = ACTIONS(4148),
    [anon_sym_equals] = ACTIONS(4148),
    [anon_sym_into] = ACTIONS(4148),
    [anon_sym_let] = ACTIONS(4148),
    [anon_sym_orderby] = ACTIONS(4148),
    [anon_sym_ascending] = ACTIONS(4148),
    [anon_sym_descending] = ACTIONS(4148),
    [anon_sym_group] = ACTIONS(4148),
    [anon_sym_by] = ACTIONS(4148),
    [anon_sym_select] = ACTIONS(4148),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4148),
    [anon_sym_nameof] = ACTIONS(4148),
    [sym_void_keyword] = ACTIONS(4148),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2361] = {
    [sym__preprocessor_call] = STATE(2361),
    [sym__identifier_token] = ACTIONS(4152),
    [anon_sym_extern] = ACTIONS(4152),
    [anon_sym_alias] = ACTIONS(4152),
    [anon_sym_global] = ACTIONS(4152),
    [anon_sym_using] = ACTIONS(4152),
    [anon_sym_static] = ACTIONS(4152),
    [anon_sym_LBRACK] = ACTIONS(4154),
    [anon_sym_event] = ACTIONS(4152),
    [anon_sym_LPAREN] = ACTIONS(4154),
    [anon_sym_abstract] = ACTIONS(4152),
    [anon_sym_async] = ACTIONS(4152),
    [anon_sym_const] = ACTIONS(4152),
    [anon_sym_fixed] = ACTIONS(4152),
    [anon_sym_internal] = ACTIONS(4152),
    [anon_sym_new] = ACTIONS(4152),
    [anon_sym_override] = ACTIONS(4152),
    [anon_sym_partial] = ACTIONS(4152),
    [anon_sym_private] = ACTIONS(4152),
    [anon_sym_protected] = ACTIONS(4152),
    [anon_sym_public] = ACTIONS(4152),
    [anon_sym_readonly] = ACTIONS(4152),
    [anon_sym_ref] = ACTIONS(4152),
    [anon_sym_sealed] = ACTIONS(4152),
    [anon_sym_unsafe] = ACTIONS(4152),
    [anon_sym_virtual] = ACTIONS(4152),
    [anon_sym_volatile] = ACTIONS(4152),
    [anon_sym_RBRACE] = ACTIONS(4154),
    [anon_sym_implicit] = ACTIONS(4152),
    [anon_sym_explicit] = ACTIONS(4152),
    [anon_sym_TILDE] = ACTIONS(4154),
    [anon_sym_where] = ACTIONS(4152),
    [anon_sym_class] = ACTIONS(4152),
    [anon_sym_struct] = ACTIONS(4152),
    [anon_sym_notnull] = ACTIONS(4152),
    [anon_sym_unmanaged] = ACTIONS(4152),
    [anon_sym_get] = ACTIONS(4152),
    [anon_sym_set] = ACTIONS(4152),
    [anon_sym_add] = ACTIONS(4152),
    [anon_sym_remove] = ACTIONS(4152),
    [anon_sym_enum] = ACTIONS(4152),
    [anon_sym_interface] = ACTIONS(4152),
    [anon_sym_delegate] = ACTIONS(4152),
    [anon_sym_record] = ACTIONS(4152),
    [anon_sym_namespace] = ACTIONS(4152),
    [anon_sym_var] = ACTIONS(4152),
    [sym_predefined_type] = ACTIONS(4152),
    [anon_sym_when] = ACTIONS(4152),
    [anon_sym_yield] = ACTIONS(4152),
    [anon_sym_from] = ACTIONS(4152),
    [anon_sym_join] = ACTIONS(4152),
    [anon_sym_on] = ACTIONS(4152),
    [anon_sym_equals] = ACTIONS(4152),
    [anon_sym_into] = ACTIONS(4152),
    [anon_sym_let] = ACTIONS(4152),
    [anon_sym_orderby] = ACTIONS(4152),
    [anon_sym_ascending] = ACTIONS(4152),
    [anon_sym_descending] = ACTIONS(4152),
    [anon_sym_group] = ACTIONS(4152),
    [anon_sym_by] = ACTIONS(4152),
    [anon_sym_select] = ACTIONS(4152),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4152),
    [anon_sym_nameof] = ACTIONS(4152),
    [sym_void_keyword] = ACTIONS(4152),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2362] = {
    [sym__preprocessor_call] = STATE(2362),
    [sym__identifier_token] = ACTIONS(4156),
    [anon_sym_extern] = ACTIONS(4156),
    [anon_sym_alias] = ACTIONS(4156),
    [anon_sym_global] = ACTIONS(4156),
    [anon_sym_using] = ACTIONS(4156),
    [anon_sym_static] = ACTIONS(4156),
    [anon_sym_LBRACK] = ACTIONS(4158),
    [anon_sym_event] = ACTIONS(4156),
    [anon_sym_LPAREN] = ACTIONS(4158),
    [anon_sym_abstract] = ACTIONS(4156),
    [anon_sym_async] = ACTIONS(4156),
    [anon_sym_const] = ACTIONS(4156),
    [anon_sym_fixed] = ACTIONS(4156),
    [anon_sym_internal] = ACTIONS(4156),
    [anon_sym_new] = ACTIONS(4156),
    [anon_sym_override] = ACTIONS(4156),
    [anon_sym_partial] = ACTIONS(4156),
    [anon_sym_private] = ACTIONS(4156),
    [anon_sym_protected] = ACTIONS(4156),
    [anon_sym_public] = ACTIONS(4156),
    [anon_sym_readonly] = ACTIONS(4156),
    [anon_sym_ref] = ACTIONS(4156),
    [anon_sym_sealed] = ACTIONS(4156),
    [anon_sym_unsafe] = ACTIONS(4156),
    [anon_sym_virtual] = ACTIONS(4156),
    [anon_sym_volatile] = ACTIONS(4156),
    [anon_sym_RBRACE] = ACTIONS(4158),
    [anon_sym_implicit] = ACTIONS(4156),
    [anon_sym_explicit] = ACTIONS(4156),
    [anon_sym_TILDE] = ACTIONS(4158),
    [anon_sym_where] = ACTIONS(4156),
    [anon_sym_class] = ACTIONS(4156),
    [anon_sym_struct] = ACTIONS(4156),
    [anon_sym_notnull] = ACTIONS(4156),
    [anon_sym_unmanaged] = ACTIONS(4156),
    [anon_sym_get] = ACTIONS(4156),
    [anon_sym_set] = ACTIONS(4156),
    [anon_sym_add] = ACTIONS(4156),
    [anon_sym_remove] = ACTIONS(4156),
    [anon_sym_enum] = ACTIONS(4156),
    [anon_sym_interface] = ACTIONS(4156),
    [anon_sym_delegate] = ACTIONS(4156),
    [anon_sym_record] = ACTIONS(4156),
    [anon_sym_namespace] = ACTIONS(4156),
    [anon_sym_var] = ACTIONS(4156),
    [sym_predefined_type] = ACTIONS(4156),
    [anon_sym_when] = ACTIONS(4156),
    [anon_sym_yield] = ACTIONS(4156),
    [anon_sym_from] = ACTIONS(4156),
    [anon_sym_join] = ACTIONS(4156),
    [anon_sym_on] = ACTIONS(4156),
    [anon_sym_equals] = ACTIONS(4156),
    [anon_sym_into] = ACTIONS(4156),
    [anon_sym_let] = ACTIONS(4156),
    [anon_sym_orderby] = ACTIONS(4156),
    [anon_sym_ascending] = ACTIONS(4156),
    [anon_sym_descending] = ACTIONS(4156),
    [anon_sym_group] = ACTIONS(4156),
    [anon_sym_by] = ACTIONS(4156),
    [anon_sym_select] = ACTIONS(4156),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4156),
    [anon_sym_nameof] = ACTIONS(4156),
    [sym_void_keyword] = ACTIONS(4156),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2363] = {
    [sym__preprocessor_call] = STATE(2363),
    [sym__identifier_token] = ACTIONS(4160),
    [anon_sym_extern] = ACTIONS(4160),
    [anon_sym_alias] = ACTIONS(4160),
    [anon_sym_global] = ACTIONS(4160),
    [anon_sym_using] = ACTIONS(4160),
    [anon_sym_static] = ACTIONS(4160),
    [anon_sym_LBRACK] = ACTIONS(4162),
    [anon_sym_event] = ACTIONS(4160),
    [anon_sym_LPAREN] = ACTIONS(4162),
    [anon_sym_abstract] = ACTIONS(4160),
    [anon_sym_async] = ACTIONS(4160),
    [anon_sym_const] = ACTIONS(4160),
    [anon_sym_fixed] = ACTIONS(4160),
    [anon_sym_internal] = ACTIONS(4160),
    [anon_sym_new] = ACTIONS(4160),
    [anon_sym_override] = ACTIONS(4160),
    [anon_sym_partial] = ACTIONS(4160),
    [anon_sym_private] = ACTIONS(4160),
    [anon_sym_protected] = ACTIONS(4160),
    [anon_sym_public] = ACTIONS(4160),
    [anon_sym_readonly] = ACTIONS(4160),
    [anon_sym_ref] = ACTIONS(4160),
    [anon_sym_sealed] = ACTIONS(4160),
    [anon_sym_unsafe] = ACTIONS(4160),
    [anon_sym_virtual] = ACTIONS(4160),
    [anon_sym_volatile] = ACTIONS(4160),
    [anon_sym_RBRACE] = ACTIONS(4162),
    [anon_sym_implicit] = ACTIONS(4160),
    [anon_sym_explicit] = ACTIONS(4160),
    [anon_sym_TILDE] = ACTIONS(4162),
    [anon_sym_where] = ACTIONS(4160),
    [anon_sym_class] = ACTIONS(4160),
    [anon_sym_struct] = ACTIONS(4160),
    [anon_sym_notnull] = ACTIONS(4160),
    [anon_sym_unmanaged] = ACTIONS(4160),
    [anon_sym_get] = ACTIONS(4160),
    [anon_sym_set] = ACTIONS(4160),
    [anon_sym_add] = ACTIONS(4160),
    [anon_sym_remove] = ACTIONS(4160),
    [anon_sym_enum] = ACTIONS(4160),
    [anon_sym_interface] = ACTIONS(4160),
    [anon_sym_delegate] = ACTIONS(4160),
    [anon_sym_record] = ACTIONS(4160),
    [anon_sym_namespace] = ACTIONS(4160),
    [anon_sym_var] = ACTIONS(4160),
    [sym_predefined_type] = ACTIONS(4160),
    [anon_sym_when] = ACTIONS(4160),
    [anon_sym_yield] = ACTIONS(4160),
    [anon_sym_from] = ACTIONS(4160),
    [anon_sym_join] = ACTIONS(4160),
    [anon_sym_on] = ACTIONS(4160),
    [anon_sym_equals] = ACTIONS(4160),
    [anon_sym_into] = ACTIONS(4160),
    [anon_sym_let] = ACTIONS(4160),
    [anon_sym_orderby] = ACTIONS(4160),
    [anon_sym_ascending] = ACTIONS(4160),
    [anon_sym_descending] = ACTIONS(4160),
    [anon_sym_group] = ACTIONS(4160),
    [anon_sym_by] = ACTIONS(4160),
    [anon_sym_select] = ACTIONS(4160),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4160),
    [anon_sym_nameof] = ACTIONS(4160),
    [sym_void_keyword] = ACTIONS(4160),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2364] = {
    [sym__preprocessor_call] = STATE(2364),
    [sym__identifier_token] = ACTIONS(4164),
    [anon_sym_extern] = ACTIONS(4164),
    [anon_sym_alias] = ACTIONS(4164),
    [anon_sym_global] = ACTIONS(4164),
    [anon_sym_using] = ACTIONS(4164),
    [anon_sym_static] = ACTIONS(4164),
    [anon_sym_LBRACK] = ACTIONS(4166),
    [anon_sym_event] = ACTIONS(4164),
    [anon_sym_LPAREN] = ACTIONS(4166),
    [anon_sym_abstract] = ACTIONS(4164),
    [anon_sym_async] = ACTIONS(4164),
    [anon_sym_const] = ACTIONS(4164),
    [anon_sym_fixed] = ACTIONS(4164),
    [anon_sym_internal] = ACTIONS(4164),
    [anon_sym_new] = ACTIONS(4164),
    [anon_sym_override] = ACTIONS(4164),
    [anon_sym_partial] = ACTIONS(4164),
    [anon_sym_private] = ACTIONS(4164),
    [anon_sym_protected] = ACTIONS(4164),
    [anon_sym_public] = ACTIONS(4164),
    [anon_sym_readonly] = ACTIONS(4164),
    [anon_sym_ref] = ACTIONS(4164),
    [anon_sym_sealed] = ACTIONS(4164),
    [anon_sym_unsafe] = ACTIONS(4164),
    [anon_sym_virtual] = ACTIONS(4164),
    [anon_sym_volatile] = ACTIONS(4164),
    [anon_sym_RBRACE] = ACTIONS(4166),
    [anon_sym_implicit] = ACTIONS(4164),
    [anon_sym_explicit] = ACTIONS(4164),
    [anon_sym_TILDE] = ACTIONS(4166),
    [anon_sym_where] = ACTIONS(4164),
    [anon_sym_class] = ACTIONS(4164),
    [anon_sym_struct] = ACTIONS(4164),
    [anon_sym_notnull] = ACTIONS(4164),
    [anon_sym_unmanaged] = ACTIONS(4164),
    [anon_sym_get] = ACTIONS(4164),
    [anon_sym_set] = ACTIONS(4164),
    [anon_sym_add] = ACTIONS(4164),
    [anon_sym_remove] = ACTIONS(4164),
    [anon_sym_enum] = ACTIONS(4164),
    [anon_sym_interface] = ACTIONS(4164),
    [anon_sym_delegate] = ACTIONS(4164),
    [anon_sym_record] = ACTIONS(4164),
    [anon_sym_namespace] = ACTIONS(4164),
    [anon_sym_var] = ACTIONS(4164),
    [sym_predefined_type] = ACTIONS(4164),
    [anon_sym_when] = ACTIONS(4164),
    [anon_sym_yield] = ACTIONS(4164),
    [anon_sym_from] = ACTIONS(4164),
    [anon_sym_join] = ACTIONS(4164),
    [anon_sym_on] = ACTIONS(4164),
    [anon_sym_equals] = ACTIONS(4164),
    [anon_sym_into] = ACTIONS(4164),
    [anon_sym_let] = ACTIONS(4164),
    [anon_sym_orderby] = ACTIONS(4164),
    [anon_sym_ascending] = ACTIONS(4164),
    [anon_sym_descending] = ACTIONS(4164),
    [anon_sym_group] = ACTIONS(4164),
    [anon_sym_by] = ACTIONS(4164),
    [anon_sym_select] = ACTIONS(4164),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4164),
    [anon_sym_nameof] = ACTIONS(4164),
    [sym_void_keyword] = ACTIONS(4164),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2365] = {
    [sym__preprocessor_call] = STATE(2365),
    [sym__identifier_token] = ACTIONS(4168),
    [anon_sym_extern] = ACTIONS(4168),
    [anon_sym_alias] = ACTIONS(4168),
    [anon_sym_global] = ACTIONS(4168),
    [anon_sym_using] = ACTIONS(4168),
    [anon_sym_static] = ACTIONS(4168),
    [anon_sym_LBRACK] = ACTIONS(4170),
    [anon_sym_event] = ACTIONS(4168),
    [anon_sym_LPAREN] = ACTIONS(4170),
    [anon_sym_abstract] = ACTIONS(4168),
    [anon_sym_async] = ACTIONS(4168),
    [anon_sym_const] = ACTIONS(4168),
    [anon_sym_fixed] = ACTIONS(4168),
    [anon_sym_internal] = ACTIONS(4168),
    [anon_sym_new] = ACTIONS(4168),
    [anon_sym_override] = ACTIONS(4168),
    [anon_sym_partial] = ACTIONS(4168),
    [anon_sym_private] = ACTIONS(4168),
    [anon_sym_protected] = ACTIONS(4168),
    [anon_sym_public] = ACTIONS(4168),
    [anon_sym_readonly] = ACTIONS(4168),
    [anon_sym_ref] = ACTIONS(4168),
    [anon_sym_sealed] = ACTIONS(4168),
    [anon_sym_unsafe] = ACTIONS(4168),
    [anon_sym_virtual] = ACTIONS(4168),
    [anon_sym_volatile] = ACTIONS(4168),
    [anon_sym_RBRACE] = ACTIONS(4170),
    [anon_sym_implicit] = ACTIONS(4168),
    [anon_sym_explicit] = ACTIONS(4168),
    [anon_sym_TILDE] = ACTIONS(4170),
    [anon_sym_where] = ACTIONS(4168),
    [anon_sym_class] = ACTIONS(4168),
    [anon_sym_struct] = ACTIONS(4168),
    [anon_sym_notnull] = ACTIONS(4168),
    [anon_sym_unmanaged] = ACTIONS(4168),
    [anon_sym_get] = ACTIONS(4168),
    [anon_sym_set] = ACTIONS(4168),
    [anon_sym_add] = ACTIONS(4168),
    [anon_sym_remove] = ACTIONS(4168),
    [anon_sym_enum] = ACTIONS(4168),
    [anon_sym_interface] = ACTIONS(4168),
    [anon_sym_delegate] = ACTIONS(4168),
    [anon_sym_record] = ACTIONS(4168),
    [anon_sym_namespace] = ACTIONS(4168),
    [anon_sym_var] = ACTIONS(4168),
    [sym_predefined_type] = ACTIONS(4168),
    [anon_sym_when] = ACTIONS(4168),
    [anon_sym_yield] = ACTIONS(4168),
    [anon_sym_from] = ACTIONS(4168),
    [anon_sym_join] = ACTIONS(4168),
    [anon_sym_on] = ACTIONS(4168),
    [anon_sym_equals] = ACTIONS(4168),
    [anon_sym_into] = ACTIONS(4168),
    [anon_sym_let] = ACTIONS(4168),
    [anon_sym_orderby] = ACTIONS(4168),
    [anon_sym_ascending] = ACTIONS(4168),
    [anon_sym_descending] = ACTIONS(4168),
    [anon_sym_group] = ACTIONS(4168),
    [anon_sym_by] = ACTIONS(4168),
    [anon_sym_select] = ACTIONS(4168),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4168),
    [anon_sym_nameof] = ACTIONS(4168),
    [sym_void_keyword] = ACTIONS(4168),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2366] = {
    [sym__preprocessor_call] = STATE(2366),
    [sym__identifier_token] = ACTIONS(4172),
    [anon_sym_extern] = ACTIONS(4172),
    [anon_sym_alias] = ACTIONS(4172),
    [anon_sym_global] = ACTIONS(4172),
    [anon_sym_using] = ACTIONS(4172),
    [anon_sym_static] = ACTIONS(4172),
    [anon_sym_LBRACK] = ACTIONS(4174),
    [anon_sym_event] = ACTIONS(4172),
    [anon_sym_LPAREN] = ACTIONS(4174),
    [anon_sym_abstract] = ACTIONS(4172),
    [anon_sym_async] = ACTIONS(4172),
    [anon_sym_const] = ACTIONS(4172),
    [anon_sym_fixed] = ACTIONS(4172),
    [anon_sym_internal] = ACTIONS(4172),
    [anon_sym_new] = ACTIONS(4172),
    [anon_sym_override] = ACTIONS(4172),
    [anon_sym_partial] = ACTIONS(4172),
    [anon_sym_private] = ACTIONS(4172),
    [anon_sym_protected] = ACTIONS(4172),
    [anon_sym_public] = ACTIONS(4172),
    [anon_sym_readonly] = ACTIONS(4172),
    [anon_sym_ref] = ACTIONS(4172),
    [anon_sym_sealed] = ACTIONS(4172),
    [anon_sym_unsafe] = ACTIONS(4172),
    [anon_sym_virtual] = ACTIONS(4172),
    [anon_sym_volatile] = ACTIONS(4172),
    [anon_sym_RBRACE] = ACTIONS(4174),
    [anon_sym_implicit] = ACTIONS(4172),
    [anon_sym_explicit] = ACTIONS(4172),
    [anon_sym_TILDE] = ACTIONS(4174),
    [anon_sym_where] = ACTIONS(4172),
    [anon_sym_class] = ACTIONS(4172),
    [anon_sym_struct] = ACTIONS(4172),
    [anon_sym_notnull] = ACTIONS(4172),
    [anon_sym_unmanaged] = ACTIONS(4172),
    [anon_sym_get] = ACTIONS(4172),
    [anon_sym_set] = ACTIONS(4172),
    [anon_sym_add] = ACTIONS(4172),
    [anon_sym_remove] = ACTIONS(4172),
    [anon_sym_enum] = ACTIONS(4172),
    [anon_sym_interface] = ACTIONS(4172),
    [anon_sym_delegate] = ACTIONS(4172),
    [anon_sym_record] = ACTIONS(4172),
    [anon_sym_namespace] = ACTIONS(4172),
    [anon_sym_var] = ACTIONS(4172),
    [sym_predefined_type] = ACTIONS(4172),
    [anon_sym_when] = ACTIONS(4172),
    [anon_sym_yield] = ACTIONS(4172),
    [anon_sym_from] = ACTIONS(4172),
    [anon_sym_join] = ACTIONS(4172),
    [anon_sym_on] = ACTIONS(4172),
    [anon_sym_equals] = ACTIONS(4172),
    [anon_sym_into] = ACTIONS(4172),
    [anon_sym_let] = ACTIONS(4172),
    [anon_sym_orderby] = ACTIONS(4172),
    [anon_sym_ascending] = ACTIONS(4172),
    [anon_sym_descending] = ACTIONS(4172),
    [anon_sym_group] = ACTIONS(4172),
    [anon_sym_by] = ACTIONS(4172),
    [anon_sym_select] = ACTIONS(4172),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4172),
    [anon_sym_nameof] = ACTIONS(4172),
    [sym_void_keyword] = ACTIONS(4172),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2367] = {
    [sym__preprocessor_call] = STATE(2367),
    [sym__identifier_token] = ACTIONS(4176),
    [anon_sym_extern] = ACTIONS(4176),
    [anon_sym_alias] = ACTIONS(4176),
    [anon_sym_global] = ACTIONS(4176),
    [anon_sym_using] = ACTIONS(4176),
    [anon_sym_static] = ACTIONS(4176),
    [anon_sym_LBRACK] = ACTIONS(4178),
    [anon_sym_event] = ACTIONS(4176),
    [anon_sym_LPAREN] = ACTIONS(4178),
    [anon_sym_abstract] = ACTIONS(4176),
    [anon_sym_async] = ACTIONS(4176),
    [anon_sym_const] = ACTIONS(4176),
    [anon_sym_fixed] = ACTIONS(4176),
    [anon_sym_internal] = ACTIONS(4176),
    [anon_sym_new] = ACTIONS(4176),
    [anon_sym_override] = ACTIONS(4176),
    [anon_sym_partial] = ACTIONS(4176),
    [anon_sym_private] = ACTIONS(4176),
    [anon_sym_protected] = ACTIONS(4176),
    [anon_sym_public] = ACTIONS(4176),
    [anon_sym_readonly] = ACTIONS(4176),
    [anon_sym_ref] = ACTIONS(4176),
    [anon_sym_sealed] = ACTIONS(4176),
    [anon_sym_unsafe] = ACTIONS(4176),
    [anon_sym_virtual] = ACTIONS(4176),
    [anon_sym_volatile] = ACTIONS(4176),
    [anon_sym_RBRACE] = ACTIONS(4178),
    [anon_sym_implicit] = ACTIONS(4176),
    [anon_sym_explicit] = ACTIONS(4176),
    [anon_sym_TILDE] = ACTIONS(4178),
    [anon_sym_where] = ACTIONS(4176),
    [anon_sym_class] = ACTIONS(4176),
    [anon_sym_struct] = ACTIONS(4176),
    [anon_sym_notnull] = ACTIONS(4176),
    [anon_sym_unmanaged] = ACTIONS(4176),
    [anon_sym_get] = ACTIONS(4176),
    [anon_sym_set] = ACTIONS(4176),
    [anon_sym_add] = ACTIONS(4176),
    [anon_sym_remove] = ACTIONS(4176),
    [anon_sym_enum] = ACTIONS(4176),
    [anon_sym_interface] = ACTIONS(4176),
    [anon_sym_delegate] = ACTIONS(4176),
    [anon_sym_record] = ACTIONS(4176),
    [anon_sym_namespace] = ACTIONS(4176),
    [anon_sym_var] = ACTIONS(4176),
    [sym_predefined_type] = ACTIONS(4176),
    [anon_sym_when] = ACTIONS(4176),
    [anon_sym_yield] = ACTIONS(4176),
    [anon_sym_from] = ACTIONS(4176),
    [anon_sym_join] = ACTIONS(4176),
    [anon_sym_on] = ACTIONS(4176),
    [anon_sym_equals] = ACTIONS(4176),
    [anon_sym_into] = ACTIONS(4176),
    [anon_sym_let] = ACTIONS(4176),
    [anon_sym_orderby] = ACTIONS(4176),
    [anon_sym_ascending] = ACTIONS(4176),
    [anon_sym_descending] = ACTIONS(4176),
    [anon_sym_group] = ACTIONS(4176),
    [anon_sym_by] = ACTIONS(4176),
    [anon_sym_select] = ACTIONS(4176),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4176),
    [anon_sym_nameof] = ACTIONS(4176),
    [sym_void_keyword] = ACTIONS(4176),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2368] = {
    [sym__preprocessor_call] = STATE(2368),
    [sym__identifier_token] = ACTIONS(4180),
    [anon_sym_extern] = ACTIONS(4180),
    [anon_sym_alias] = ACTIONS(4180),
    [anon_sym_global] = ACTIONS(4180),
    [anon_sym_using] = ACTIONS(4180),
    [anon_sym_static] = ACTIONS(4180),
    [anon_sym_LBRACK] = ACTIONS(4182),
    [anon_sym_event] = ACTIONS(4180),
    [anon_sym_LPAREN] = ACTIONS(4182),
    [anon_sym_abstract] = ACTIONS(4180),
    [anon_sym_async] = ACTIONS(4180),
    [anon_sym_const] = ACTIONS(4180),
    [anon_sym_fixed] = ACTIONS(4180),
    [anon_sym_internal] = ACTIONS(4180),
    [anon_sym_new] = ACTIONS(4180),
    [anon_sym_override] = ACTIONS(4180),
    [anon_sym_partial] = ACTIONS(4180),
    [anon_sym_private] = ACTIONS(4180),
    [anon_sym_protected] = ACTIONS(4180),
    [anon_sym_public] = ACTIONS(4180),
    [anon_sym_readonly] = ACTIONS(4180),
    [anon_sym_ref] = ACTIONS(4180),
    [anon_sym_sealed] = ACTIONS(4180),
    [anon_sym_unsafe] = ACTIONS(4180),
    [anon_sym_virtual] = ACTIONS(4180),
    [anon_sym_volatile] = ACTIONS(4180),
    [anon_sym_RBRACE] = ACTIONS(4182),
    [anon_sym_implicit] = ACTIONS(4180),
    [anon_sym_explicit] = ACTIONS(4180),
    [anon_sym_TILDE] = ACTIONS(4182),
    [anon_sym_where] = ACTIONS(4180),
    [anon_sym_class] = ACTIONS(4180),
    [anon_sym_struct] = ACTIONS(4180),
    [anon_sym_notnull] = ACTIONS(4180),
    [anon_sym_unmanaged] = ACTIONS(4180),
    [anon_sym_get] = ACTIONS(4180),
    [anon_sym_set] = ACTIONS(4180),
    [anon_sym_add] = ACTIONS(4180),
    [anon_sym_remove] = ACTIONS(4180),
    [anon_sym_enum] = ACTIONS(4180),
    [anon_sym_interface] = ACTIONS(4180),
    [anon_sym_delegate] = ACTIONS(4180),
    [anon_sym_record] = ACTIONS(4180),
    [anon_sym_namespace] = ACTIONS(4180),
    [anon_sym_var] = ACTIONS(4180),
    [sym_predefined_type] = ACTIONS(4180),
    [anon_sym_when] = ACTIONS(4180),
    [anon_sym_yield] = ACTIONS(4180),
    [anon_sym_from] = ACTIONS(4180),
    [anon_sym_join] = ACTIONS(4180),
    [anon_sym_on] = ACTIONS(4180),
    [anon_sym_equals] = ACTIONS(4180),
    [anon_sym_into] = ACTIONS(4180),
    [anon_sym_let] = ACTIONS(4180),
    [anon_sym_orderby] = ACTIONS(4180),
    [anon_sym_ascending] = ACTIONS(4180),
    [anon_sym_descending] = ACTIONS(4180),
    [anon_sym_group] = ACTIONS(4180),
    [anon_sym_by] = ACTIONS(4180),
    [anon_sym_select] = ACTIONS(4180),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4180),
    [anon_sym_nameof] = ACTIONS(4180),
    [sym_void_keyword] = ACTIONS(4180),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2369] = {
    [sym__preprocessor_call] = STATE(2369),
    [sym__identifier_token] = ACTIONS(4184),
    [anon_sym_extern] = ACTIONS(4184),
    [anon_sym_alias] = ACTIONS(4184),
    [anon_sym_global] = ACTIONS(4184),
    [anon_sym_using] = ACTIONS(4184),
    [anon_sym_static] = ACTIONS(4184),
    [anon_sym_LBRACK] = ACTIONS(4186),
    [anon_sym_event] = ACTIONS(4184),
    [anon_sym_LPAREN] = ACTIONS(4186),
    [anon_sym_abstract] = ACTIONS(4184),
    [anon_sym_async] = ACTIONS(4184),
    [anon_sym_const] = ACTIONS(4184),
    [anon_sym_fixed] = ACTIONS(4184),
    [anon_sym_internal] = ACTIONS(4184),
    [anon_sym_new] = ACTIONS(4184),
    [anon_sym_override] = ACTIONS(4184),
    [anon_sym_partial] = ACTIONS(4184),
    [anon_sym_private] = ACTIONS(4184),
    [anon_sym_protected] = ACTIONS(4184),
    [anon_sym_public] = ACTIONS(4184),
    [anon_sym_readonly] = ACTIONS(4184),
    [anon_sym_ref] = ACTIONS(4184),
    [anon_sym_sealed] = ACTIONS(4184),
    [anon_sym_unsafe] = ACTIONS(4184),
    [anon_sym_virtual] = ACTIONS(4184),
    [anon_sym_volatile] = ACTIONS(4184),
    [anon_sym_RBRACE] = ACTIONS(4186),
    [anon_sym_implicit] = ACTIONS(4184),
    [anon_sym_explicit] = ACTIONS(4184),
    [anon_sym_TILDE] = ACTIONS(4186),
    [anon_sym_where] = ACTIONS(4184),
    [anon_sym_class] = ACTIONS(4184),
    [anon_sym_struct] = ACTIONS(4184),
    [anon_sym_notnull] = ACTIONS(4184),
    [anon_sym_unmanaged] = ACTIONS(4184),
    [anon_sym_get] = ACTIONS(4184),
    [anon_sym_set] = ACTIONS(4184),
    [anon_sym_add] = ACTIONS(4184),
    [anon_sym_remove] = ACTIONS(4184),
    [anon_sym_enum] = ACTIONS(4184),
    [anon_sym_interface] = ACTIONS(4184),
    [anon_sym_delegate] = ACTIONS(4184),
    [anon_sym_record] = ACTIONS(4184),
    [anon_sym_namespace] = ACTIONS(4184),
    [anon_sym_var] = ACTIONS(4184),
    [sym_predefined_type] = ACTIONS(4184),
    [anon_sym_when] = ACTIONS(4184),
    [anon_sym_yield] = ACTIONS(4184),
    [anon_sym_from] = ACTIONS(4184),
    [anon_sym_join] = ACTIONS(4184),
    [anon_sym_on] = ACTIONS(4184),
    [anon_sym_equals] = ACTIONS(4184),
    [anon_sym_into] = ACTIONS(4184),
    [anon_sym_let] = ACTIONS(4184),
    [anon_sym_orderby] = ACTIONS(4184),
    [anon_sym_ascending] = ACTIONS(4184),
    [anon_sym_descending] = ACTIONS(4184),
    [anon_sym_group] = ACTIONS(4184),
    [anon_sym_by] = ACTIONS(4184),
    [anon_sym_select] = ACTIONS(4184),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4184),
    [anon_sym_nameof] = ACTIONS(4184),
    [sym_void_keyword] = ACTIONS(4184),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2370] = {
    [sym__preprocessor_call] = STATE(2370),
    [sym__identifier_token] = ACTIONS(4188),
    [anon_sym_extern] = ACTIONS(4188),
    [anon_sym_alias] = ACTIONS(4188),
    [anon_sym_global] = ACTIONS(4188),
    [anon_sym_using] = ACTIONS(4188),
    [anon_sym_static] = ACTIONS(4188),
    [anon_sym_LBRACK] = ACTIONS(4190),
    [anon_sym_event] = ACTIONS(4188),
    [anon_sym_LPAREN] = ACTIONS(4190),
    [anon_sym_abstract] = ACTIONS(4188),
    [anon_sym_async] = ACTIONS(4188),
    [anon_sym_const] = ACTIONS(4188),
    [anon_sym_fixed] = ACTIONS(4188),
    [anon_sym_internal] = ACTIONS(4188),
    [anon_sym_new] = ACTIONS(4188),
    [anon_sym_override] = ACTIONS(4188),
    [anon_sym_partial] = ACTIONS(4188),
    [anon_sym_private] = ACTIONS(4188),
    [anon_sym_protected] = ACTIONS(4188),
    [anon_sym_public] = ACTIONS(4188),
    [anon_sym_readonly] = ACTIONS(4188),
    [anon_sym_ref] = ACTIONS(4188),
    [anon_sym_sealed] = ACTIONS(4188),
    [anon_sym_unsafe] = ACTIONS(4188),
    [anon_sym_virtual] = ACTIONS(4188),
    [anon_sym_volatile] = ACTIONS(4188),
    [anon_sym_RBRACE] = ACTIONS(4190),
    [anon_sym_implicit] = ACTIONS(4188),
    [anon_sym_explicit] = ACTIONS(4188),
    [anon_sym_TILDE] = ACTIONS(4190),
    [anon_sym_where] = ACTIONS(4188),
    [anon_sym_class] = ACTIONS(4188),
    [anon_sym_struct] = ACTIONS(4188),
    [anon_sym_notnull] = ACTIONS(4188),
    [anon_sym_unmanaged] = ACTIONS(4188),
    [anon_sym_get] = ACTIONS(4188),
    [anon_sym_set] = ACTIONS(4188),
    [anon_sym_add] = ACTIONS(4188),
    [anon_sym_remove] = ACTIONS(4188),
    [anon_sym_enum] = ACTIONS(4188),
    [anon_sym_interface] = ACTIONS(4188),
    [anon_sym_delegate] = ACTIONS(4188),
    [anon_sym_record] = ACTIONS(4188),
    [anon_sym_namespace] = ACTIONS(4188),
    [anon_sym_var] = ACTIONS(4188),
    [sym_predefined_type] = ACTIONS(4188),
    [anon_sym_when] = ACTIONS(4188),
    [anon_sym_yield] = ACTIONS(4188),
    [anon_sym_from] = ACTIONS(4188),
    [anon_sym_join] = ACTIONS(4188),
    [anon_sym_on] = ACTIONS(4188),
    [anon_sym_equals] = ACTIONS(4188),
    [anon_sym_into] = ACTIONS(4188),
    [anon_sym_let] = ACTIONS(4188),
    [anon_sym_orderby] = ACTIONS(4188),
    [anon_sym_ascending] = ACTIONS(4188),
    [anon_sym_descending] = ACTIONS(4188),
    [anon_sym_group] = ACTIONS(4188),
    [anon_sym_by] = ACTIONS(4188),
    [anon_sym_select] = ACTIONS(4188),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4188),
    [anon_sym_nameof] = ACTIONS(4188),
    [sym_void_keyword] = ACTIONS(4188),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2371] = {
    [sym__preprocessor_call] = STATE(2371),
    [sym__identifier_token] = ACTIONS(4192),
    [anon_sym_extern] = ACTIONS(4192),
    [anon_sym_alias] = ACTIONS(4192),
    [anon_sym_global] = ACTIONS(4192),
    [anon_sym_using] = ACTIONS(4192),
    [anon_sym_static] = ACTIONS(4192),
    [anon_sym_LBRACK] = ACTIONS(4194),
    [anon_sym_event] = ACTIONS(4192),
    [anon_sym_LPAREN] = ACTIONS(4194),
    [anon_sym_abstract] = ACTIONS(4192),
    [anon_sym_async] = ACTIONS(4192),
    [anon_sym_const] = ACTIONS(4192),
    [anon_sym_fixed] = ACTIONS(4192),
    [anon_sym_internal] = ACTIONS(4192),
    [anon_sym_new] = ACTIONS(4192),
    [anon_sym_override] = ACTIONS(4192),
    [anon_sym_partial] = ACTIONS(4192),
    [anon_sym_private] = ACTIONS(4192),
    [anon_sym_protected] = ACTIONS(4192),
    [anon_sym_public] = ACTIONS(4192),
    [anon_sym_readonly] = ACTIONS(4192),
    [anon_sym_ref] = ACTIONS(4192),
    [anon_sym_sealed] = ACTIONS(4192),
    [anon_sym_unsafe] = ACTIONS(4192),
    [anon_sym_virtual] = ACTIONS(4192),
    [anon_sym_volatile] = ACTIONS(4192),
    [anon_sym_RBRACE] = ACTIONS(4194),
    [anon_sym_implicit] = ACTIONS(4192),
    [anon_sym_explicit] = ACTIONS(4192),
    [anon_sym_TILDE] = ACTIONS(4194),
    [anon_sym_where] = ACTIONS(4192),
    [anon_sym_class] = ACTIONS(4192),
    [anon_sym_struct] = ACTIONS(4192),
    [anon_sym_notnull] = ACTIONS(4192),
    [anon_sym_unmanaged] = ACTIONS(4192),
    [anon_sym_get] = ACTIONS(4192),
    [anon_sym_set] = ACTIONS(4192),
    [anon_sym_add] = ACTIONS(4192),
    [anon_sym_remove] = ACTIONS(4192),
    [anon_sym_enum] = ACTIONS(4192),
    [anon_sym_interface] = ACTIONS(4192),
    [anon_sym_delegate] = ACTIONS(4192),
    [anon_sym_record] = ACTIONS(4192),
    [anon_sym_namespace] = ACTIONS(4192),
    [anon_sym_var] = ACTIONS(4192),
    [sym_predefined_type] = ACTIONS(4192),
    [anon_sym_when] = ACTIONS(4192),
    [anon_sym_yield] = ACTIONS(4192),
    [anon_sym_from] = ACTIONS(4192),
    [anon_sym_join] = ACTIONS(4192),
    [anon_sym_on] = ACTIONS(4192),
    [anon_sym_equals] = ACTIONS(4192),
    [anon_sym_into] = ACTIONS(4192),
    [anon_sym_let] = ACTIONS(4192),
    [anon_sym_orderby] = ACTIONS(4192),
    [anon_sym_ascending] = ACTIONS(4192),
    [anon_sym_descending] = ACTIONS(4192),
    [anon_sym_group] = ACTIONS(4192),
    [anon_sym_by] = ACTIONS(4192),
    [anon_sym_select] = ACTIONS(4192),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4192),
    [anon_sym_nameof] = ACTIONS(4192),
    [sym_void_keyword] = ACTIONS(4192),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2372] = {
    [sym__preprocessor_call] = STATE(2372),
    [sym__identifier_token] = ACTIONS(4196),
    [anon_sym_extern] = ACTIONS(4196),
    [anon_sym_alias] = ACTIONS(4196),
    [anon_sym_global] = ACTIONS(4196),
    [anon_sym_using] = ACTIONS(4196),
    [anon_sym_static] = ACTIONS(4196),
    [anon_sym_LBRACK] = ACTIONS(4198),
    [anon_sym_event] = ACTIONS(4196),
    [anon_sym_LPAREN] = ACTIONS(4198),
    [anon_sym_abstract] = ACTIONS(4196),
    [anon_sym_async] = ACTIONS(4196),
    [anon_sym_const] = ACTIONS(4196),
    [anon_sym_fixed] = ACTIONS(4196),
    [anon_sym_internal] = ACTIONS(4196),
    [anon_sym_new] = ACTIONS(4196),
    [anon_sym_override] = ACTIONS(4196),
    [anon_sym_partial] = ACTIONS(4196),
    [anon_sym_private] = ACTIONS(4196),
    [anon_sym_protected] = ACTIONS(4196),
    [anon_sym_public] = ACTIONS(4196),
    [anon_sym_readonly] = ACTIONS(4196),
    [anon_sym_ref] = ACTIONS(4196),
    [anon_sym_sealed] = ACTIONS(4196),
    [anon_sym_unsafe] = ACTIONS(4196),
    [anon_sym_virtual] = ACTIONS(4196),
    [anon_sym_volatile] = ACTIONS(4196),
    [anon_sym_RBRACE] = ACTIONS(4198),
    [anon_sym_implicit] = ACTIONS(4196),
    [anon_sym_explicit] = ACTIONS(4196),
    [anon_sym_TILDE] = ACTIONS(4198),
    [anon_sym_where] = ACTIONS(4196),
    [anon_sym_class] = ACTIONS(4196),
    [anon_sym_struct] = ACTIONS(4196),
    [anon_sym_notnull] = ACTIONS(4196),
    [anon_sym_unmanaged] = ACTIONS(4196),
    [anon_sym_get] = ACTIONS(4196),
    [anon_sym_set] = ACTIONS(4196),
    [anon_sym_add] = ACTIONS(4196),
    [anon_sym_remove] = ACTIONS(4196),
    [anon_sym_enum] = ACTIONS(4196),
    [anon_sym_interface] = ACTIONS(4196),
    [anon_sym_delegate] = ACTIONS(4196),
    [anon_sym_record] = ACTIONS(4196),
    [anon_sym_namespace] = ACTIONS(4196),
    [anon_sym_var] = ACTIONS(4196),
    [sym_predefined_type] = ACTIONS(4196),
    [anon_sym_when] = ACTIONS(4196),
    [anon_sym_yield] = ACTIONS(4196),
    [anon_sym_from] = ACTIONS(4196),
    [anon_sym_join] = ACTIONS(4196),
    [anon_sym_on] = ACTIONS(4196),
    [anon_sym_equals] = ACTIONS(4196),
    [anon_sym_into] = ACTIONS(4196),
    [anon_sym_let] = ACTIONS(4196),
    [anon_sym_orderby] = ACTIONS(4196),
    [anon_sym_ascending] = ACTIONS(4196),
    [anon_sym_descending] = ACTIONS(4196),
    [anon_sym_group] = ACTIONS(4196),
    [anon_sym_by] = ACTIONS(4196),
    [anon_sym_select] = ACTIONS(4196),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4196),
    [anon_sym_nameof] = ACTIONS(4196),
    [sym_void_keyword] = ACTIONS(4196),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2373] = {
    [sym__preprocessor_call] = STATE(2373),
    [sym__identifier_token] = ACTIONS(4200),
    [anon_sym_extern] = ACTIONS(4200),
    [anon_sym_alias] = ACTIONS(4200),
    [anon_sym_global] = ACTIONS(4200),
    [anon_sym_using] = ACTIONS(4200),
    [anon_sym_static] = ACTIONS(4200),
    [anon_sym_LBRACK] = ACTIONS(4202),
    [anon_sym_event] = ACTIONS(4200),
    [anon_sym_LPAREN] = ACTIONS(4202),
    [anon_sym_abstract] = ACTIONS(4200),
    [anon_sym_async] = ACTIONS(4200),
    [anon_sym_const] = ACTIONS(4200),
    [anon_sym_fixed] = ACTIONS(4200),
    [anon_sym_internal] = ACTIONS(4200),
    [anon_sym_new] = ACTIONS(4200),
    [anon_sym_override] = ACTIONS(4200),
    [anon_sym_partial] = ACTIONS(4200),
    [anon_sym_private] = ACTIONS(4200),
    [anon_sym_protected] = ACTIONS(4200),
    [anon_sym_public] = ACTIONS(4200),
    [anon_sym_readonly] = ACTIONS(4200),
    [anon_sym_ref] = ACTIONS(4200),
    [anon_sym_sealed] = ACTIONS(4200),
    [anon_sym_unsafe] = ACTIONS(4200),
    [anon_sym_virtual] = ACTIONS(4200),
    [anon_sym_volatile] = ACTIONS(4200),
    [anon_sym_RBRACE] = ACTIONS(4202),
    [anon_sym_implicit] = ACTIONS(4200),
    [anon_sym_explicit] = ACTIONS(4200),
    [anon_sym_TILDE] = ACTIONS(4202),
    [anon_sym_where] = ACTIONS(4200),
    [anon_sym_class] = ACTIONS(4200),
    [anon_sym_struct] = ACTIONS(4200),
    [anon_sym_notnull] = ACTIONS(4200),
    [anon_sym_unmanaged] = ACTIONS(4200),
    [anon_sym_get] = ACTIONS(4200),
    [anon_sym_set] = ACTIONS(4200),
    [anon_sym_add] = ACTIONS(4200),
    [anon_sym_remove] = ACTIONS(4200),
    [anon_sym_enum] = ACTIONS(4200),
    [anon_sym_interface] = ACTIONS(4200),
    [anon_sym_delegate] = ACTIONS(4200),
    [anon_sym_record] = ACTIONS(4200),
    [anon_sym_namespace] = ACTIONS(4200),
    [anon_sym_var] = ACTIONS(4200),
    [sym_predefined_type] = ACTIONS(4200),
    [anon_sym_when] = ACTIONS(4200),
    [anon_sym_yield] = ACTIONS(4200),
    [anon_sym_from] = ACTIONS(4200),
    [anon_sym_join] = ACTIONS(4200),
    [anon_sym_on] = ACTIONS(4200),
    [anon_sym_equals] = ACTIONS(4200),
    [anon_sym_into] = ACTIONS(4200),
    [anon_sym_let] = ACTIONS(4200),
    [anon_sym_orderby] = ACTIONS(4200),
    [anon_sym_ascending] = ACTIONS(4200),
    [anon_sym_descending] = ACTIONS(4200),
    [anon_sym_group] = ACTIONS(4200),
    [anon_sym_by] = ACTIONS(4200),
    [anon_sym_select] = ACTIONS(4200),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4200),
    [anon_sym_nameof] = ACTIONS(4200),
    [sym_void_keyword] = ACTIONS(4200),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2374] = {
    [sym__preprocessor_call] = STATE(2374),
    [sym__identifier_token] = ACTIONS(4204),
    [anon_sym_extern] = ACTIONS(4204),
    [anon_sym_alias] = ACTIONS(4204),
    [anon_sym_global] = ACTIONS(4204),
    [anon_sym_using] = ACTIONS(4204),
    [anon_sym_static] = ACTIONS(4204),
    [anon_sym_LBRACK] = ACTIONS(4206),
    [anon_sym_event] = ACTIONS(4204),
    [anon_sym_LPAREN] = ACTIONS(4206),
    [anon_sym_abstract] = ACTIONS(4204),
    [anon_sym_async] = ACTIONS(4204),
    [anon_sym_const] = ACTIONS(4204),
    [anon_sym_fixed] = ACTIONS(4204),
    [anon_sym_internal] = ACTIONS(4204),
    [anon_sym_new] = ACTIONS(4204),
    [anon_sym_override] = ACTIONS(4204),
    [anon_sym_partial] = ACTIONS(4204),
    [anon_sym_private] = ACTIONS(4204),
    [anon_sym_protected] = ACTIONS(4204),
    [anon_sym_public] = ACTIONS(4204),
    [anon_sym_readonly] = ACTIONS(4204),
    [anon_sym_ref] = ACTIONS(4204),
    [anon_sym_sealed] = ACTIONS(4204),
    [anon_sym_unsafe] = ACTIONS(4204),
    [anon_sym_virtual] = ACTIONS(4204),
    [anon_sym_volatile] = ACTIONS(4204),
    [anon_sym_RBRACE] = ACTIONS(4206),
    [anon_sym_implicit] = ACTIONS(4204),
    [anon_sym_explicit] = ACTIONS(4204),
    [anon_sym_TILDE] = ACTIONS(4206),
    [anon_sym_where] = ACTIONS(4204),
    [anon_sym_class] = ACTIONS(4204),
    [anon_sym_struct] = ACTIONS(4204),
    [anon_sym_notnull] = ACTIONS(4204),
    [anon_sym_unmanaged] = ACTIONS(4204),
    [anon_sym_get] = ACTIONS(4204),
    [anon_sym_set] = ACTIONS(4204),
    [anon_sym_add] = ACTIONS(4204),
    [anon_sym_remove] = ACTIONS(4204),
    [anon_sym_enum] = ACTIONS(4204),
    [anon_sym_interface] = ACTIONS(4204),
    [anon_sym_delegate] = ACTIONS(4204),
    [anon_sym_record] = ACTIONS(4204),
    [anon_sym_namespace] = ACTIONS(4204),
    [anon_sym_var] = ACTIONS(4204),
    [sym_predefined_type] = ACTIONS(4204),
    [anon_sym_when] = ACTIONS(4204),
    [anon_sym_yield] = ACTIONS(4204),
    [anon_sym_from] = ACTIONS(4204),
    [anon_sym_join] = ACTIONS(4204),
    [anon_sym_on] = ACTIONS(4204),
    [anon_sym_equals] = ACTIONS(4204),
    [anon_sym_into] = ACTIONS(4204),
    [anon_sym_let] = ACTIONS(4204),
    [anon_sym_orderby] = ACTIONS(4204),
    [anon_sym_ascending] = ACTIONS(4204),
    [anon_sym_descending] = ACTIONS(4204),
    [anon_sym_group] = ACTIONS(4204),
    [anon_sym_by] = ACTIONS(4204),
    [anon_sym_select] = ACTIONS(4204),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4204),
    [anon_sym_nameof] = ACTIONS(4204),
    [sym_void_keyword] = ACTIONS(4204),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2375] = {
    [sym__preprocessor_call] = STATE(2375),
    [sym__identifier_token] = ACTIONS(4208),
    [anon_sym_extern] = ACTIONS(4208),
    [anon_sym_alias] = ACTIONS(4208),
    [anon_sym_global] = ACTIONS(4208),
    [anon_sym_using] = ACTIONS(4208),
    [anon_sym_static] = ACTIONS(4208),
    [anon_sym_LBRACK] = ACTIONS(4210),
    [anon_sym_event] = ACTIONS(4208),
    [anon_sym_LPAREN] = ACTIONS(4210),
    [anon_sym_abstract] = ACTIONS(4208),
    [anon_sym_async] = ACTIONS(4208),
    [anon_sym_const] = ACTIONS(4208),
    [anon_sym_fixed] = ACTIONS(4208),
    [anon_sym_internal] = ACTIONS(4208),
    [anon_sym_new] = ACTIONS(4208),
    [anon_sym_override] = ACTIONS(4208),
    [anon_sym_partial] = ACTIONS(4208),
    [anon_sym_private] = ACTIONS(4208),
    [anon_sym_protected] = ACTIONS(4208),
    [anon_sym_public] = ACTIONS(4208),
    [anon_sym_readonly] = ACTIONS(4208),
    [anon_sym_ref] = ACTIONS(4208),
    [anon_sym_sealed] = ACTIONS(4208),
    [anon_sym_unsafe] = ACTIONS(4208),
    [anon_sym_virtual] = ACTIONS(4208),
    [anon_sym_volatile] = ACTIONS(4208),
    [anon_sym_RBRACE] = ACTIONS(4210),
    [anon_sym_implicit] = ACTIONS(4208),
    [anon_sym_explicit] = ACTIONS(4208),
    [anon_sym_TILDE] = ACTIONS(4210),
    [anon_sym_where] = ACTIONS(4208),
    [anon_sym_class] = ACTIONS(4208),
    [anon_sym_struct] = ACTIONS(4208),
    [anon_sym_notnull] = ACTIONS(4208),
    [anon_sym_unmanaged] = ACTIONS(4208),
    [anon_sym_get] = ACTIONS(4208),
    [anon_sym_set] = ACTIONS(4208),
    [anon_sym_add] = ACTIONS(4208),
    [anon_sym_remove] = ACTIONS(4208),
    [anon_sym_enum] = ACTIONS(4208),
    [anon_sym_interface] = ACTIONS(4208),
    [anon_sym_delegate] = ACTIONS(4208),
    [anon_sym_record] = ACTIONS(4208),
    [anon_sym_namespace] = ACTIONS(4208),
    [anon_sym_var] = ACTIONS(4208),
    [sym_predefined_type] = ACTIONS(4208),
    [anon_sym_when] = ACTIONS(4208),
    [anon_sym_yield] = ACTIONS(4208),
    [anon_sym_from] = ACTIONS(4208),
    [anon_sym_join] = ACTIONS(4208),
    [anon_sym_on] = ACTIONS(4208),
    [anon_sym_equals] = ACTIONS(4208),
    [anon_sym_into] = ACTIONS(4208),
    [anon_sym_let] = ACTIONS(4208),
    [anon_sym_orderby] = ACTIONS(4208),
    [anon_sym_ascending] = ACTIONS(4208),
    [anon_sym_descending] = ACTIONS(4208),
    [anon_sym_group] = ACTIONS(4208),
    [anon_sym_by] = ACTIONS(4208),
    [anon_sym_select] = ACTIONS(4208),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4208),
    [anon_sym_nameof] = ACTIONS(4208),
    [sym_void_keyword] = ACTIONS(4208),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2376] = {
    [sym__preprocessor_call] = STATE(2376),
    [sym__identifier_token] = ACTIONS(4212),
    [anon_sym_extern] = ACTIONS(4212),
    [anon_sym_alias] = ACTIONS(4212),
    [anon_sym_global] = ACTIONS(4212),
    [anon_sym_using] = ACTIONS(4212),
    [anon_sym_static] = ACTIONS(4212),
    [anon_sym_LBRACK] = ACTIONS(4214),
    [anon_sym_event] = ACTIONS(4212),
    [anon_sym_LPAREN] = ACTIONS(4214),
    [anon_sym_abstract] = ACTIONS(4212),
    [anon_sym_async] = ACTIONS(4212),
    [anon_sym_const] = ACTIONS(4212),
    [anon_sym_fixed] = ACTIONS(4212),
    [anon_sym_internal] = ACTIONS(4212),
    [anon_sym_new] = ACTIONS(4212),
    [anon_sym_override] = ACTIONS(4212),
    [anon_sym_partial] = ACTIONS(4212),
    [anon_sym_private] = ACTIONS(4212),
    [anon_sym_protected] = ACTIONS(4212),
    [anon_sym_public] = ACTIONS(4212),
    [anon_sym_readonly] = ACTIONS(4212),
    [anon_sym_ref] = ACTIONS(4212),
    [anon_sym_sealed] = ACTIONS(4212),
    [anon_sym_unsafe] = ACTIONS(4212),
    [anon_sym_virtual] = ACTIONS(4212),
    [anon_sym_volatile] = ACTIONS(4212),
    [anon_sym_RBRACE] = ACTIONS(4214),
    [anon_sym_implicit] = ACTIONS(4212),
    [anon_sym_explicit] = ACTIONS(4212),
    [anon_sym_TILDE] = ACTIONS(4214),
    [anon_sym_where] = ACTIONS(4212),
    [anon_sym_class] = ACTIONS(4212),
    [anon_sym_struct] = ACTIONS(4212),
    [anon_sym_notnull] = ACTIONS(4212),
    [anon_sym_unmanaged] = ACTIONS(4212),
    [anon_sym_get] = ACTIONS(4212),
    [anon_sym_set] = ACTIONS(4212),
    [anon_sym_add] = ACTIONS(4212),
    [anon_sym_remove] = ACTIONS(4212),
    [anon_sym_enum] = ACTIONS(4212),
    [anon_sym_interface] = ACTIONS(4212),
    [anon_sym_delegate] = ACTIONS(4212),
    [anon_sym_record] = ACTIONS(4212),
    [anon_sym_namespace] = ACTIONS(4212),
    [anon_sym_var] = ACTIONS(4212),
    [sym_predefined_type] = ACTIONS(4212),
    [anon_sym_when] = ACTIONS(4212),
    [anon_sym_yield] = ACTIONS(4212),
    [anon_sym_from] = ACTIONS(4212),
    [anon_sym_join] = ACTIONS(4212),
    [anon_sym_on] = ACTIONS(4212),
    [anon_sym_equals] = ACTIONS(4212),
    [anon_sym_into] = ACTIONS(4212),
    [anon_sym_let] = ACTIONS(4212),
    [anon_sym_orderby] = ACTIONS(4212),
    [anon_sym_ascending] = ACTIONS(4212),
    [anon_sym_descending] = ACTIONS(4212),
    [anon_sym_group] = ACTIONS(4212),
    [anon_sym_by] = ACTIONS(4212),
    [anon_sym_select] = ACTIONS(4212),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4212),
    [anon_sym_nameof] = ACTIONS(4212),
    [sym_void_keyword] = ACTIONS(4212),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2377] = {
    [sym__preprocessor_call] = STATE(2377),
    [sym__identifier_token] = ACTIONS(4216),
    [anon_sym_extern] = ACTIONS(4216),
    [anon_sym_alias] = ACTIONS(4216),
    [anon_sym_global] = ACTIONS(4216),
    [anon_sym_using] = ACTIONS(4216),
    [anon_sym_static] = ACTIONS(4216),
    [anon_sym_LBRACK] = ACTIONS(4218),
    [anon_sym_event] = ACTIONS(4216),
    [anon_sym_LPAREN] = ACTIONS(4218),
    [anon_sym_abstract] = ACTIONS(4216),
    [anon_sym_async] = ACTIONS(4216),
    [anon_sym_const] = ACTIONS(4216),
    [anon_sym_fixed] = ACTIONS(4216),
    [anon_sym_internal] = ACTIONS(4216),
    [anon_sym_new] = ACTIONS(4216),
    [anon_sym_override] = ACTIONS(4216),
    [anon_sym_partial] = ACTIONS(4216),
    [anon_sym_private] = ACTIONS(4216),
    [anon_sym_protected] = ACTIONS(4216),
    [anon_sym_public] = ACTIONS(4216),
    [anon_sym_readonly] = ACTIONS(4216),
    [anon_sym_ref] = ACTIONS(4216),
    [anon_sym_sealed] = ACTIONS(4216),
    [anon_sym_unsafe] = ACTIONS(4216),
    [anon_sym_virtual] = ACTIONS(4216),
    [anon_sym_volatile] = ACTIONS(4216),
    [anon_sym_RBRACE] = ACTIONS(4218),
    [anon_sym_implicit] = ACTIONS(4216),
    [anon_sym_explicit] = ACTIONS(4216),
    [anon_sym_TILDE] = ACTIONS(4218),
    [anon_sym_where] = ACTIONS(4216),
    [anon_sym_class] = ACTIONS(4216),
    [anon_sym_struct] = ACTIONS(4216),
    [anon_sym_notnull] = ACTIONS(4216),
    [anon_sym_unmanaged] = ACTIONS(4216),
    [anon_sym_get] = ACTIONS(4216),
    [anon_sym_set] = ACTIONS(4216),
    [anon_sym_add] = ACTIONS(4216),
    [anon_sym_remove] = ACTIONS(4216),
    [anon_sym_enum] = ACTIONS(4216),
    [anon_sym_interface] = ACTIONS(4216),
    [anon_sym_delegate] = ACTIONS(4216),
    [anon_sym_record] = ACTIONS(4216),
    [anon_sym_namespace] = ACTIONS(4216),
    [anon_sym_var] = ACTIONS(4216),
    [sym_predefined_type] = ACTIONS(4216),
    [anon_sym_when] = ACTIONS(4216),
    [anon_sym_yield] = ACTIONS(4216),
    [anon_sym_from] = ACTIONS(4216),
    [anon_sym_join] = ACTIONS(4216),
    [anon_sym_on] = ACTIONS(4216),
    [anon_sym_equals] = ACTIONS(4216),
    [anon_sym_into] = ACTIONS(4216),
    [anon_sym_let] = ACTIONS(4216),
    [anon_sym_orderby] = ACTIONS(4216),
    [anon_sym_ascending] = ACTIONS(4216),
    [anon_sym_descending] = ACTIONS(4216),
    [anon_sym_group] = ACTIONS(4216),
    [anon_sym_by] = ACTIONS(4216),
    [anon_sym_select] = ACTIONS(4216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4216),
    [anon_sym_nameof] = ACTIONS(4216),
    [sym_void_keyword] = ACTIONS(4216),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2378] = {
    [sym__preprocessor_call] = STATE(2378),
    [sym__identifier_token] = ACTIONS(4220),
    [anon_sym_extern] = ACTIONS(4220),
    [anon_sym_alias] = ACTIONS(4220),
    [anon_sym_global] = ACTIONS(4220),
    [anon_sym_using] = ACTIONS(4220),
    [anon_sym_static] = ACTIONS(4220),
    [anon_sym_LBRACK] = ACTIONS(4222),
    [anon_sym_event] = ACTIONS(4220),
    [anon_sym_LPAREN] = ACTIONS(4222),
    [anon_sym_abstract] = ACTIONS(4220),
    [anon_sym_async] = ACTIONS(4220),
    [anon_sym_const] = ACTIONS(4220),
    [anon_sym_fixed] = ACTIONS(4220),
    [anon_sym_internal] = ACTIONS(4220),
    [anon_sym_new] = ACTIONS(4220),
    [anon_sym_override] = ACTIONS(4220),
    [anon_sym_partial] = ACTIONS(4220),
    [anon_sym_private] = ACTIONS(4220),
    [anon_sym_protected] = ACTIONS(4220),
    [anon_sym_public] = ACTIONS(4220),
    [anon_sym_readonly] = ACTIONS(4220),
    [anon_sym_ref] = ACTIONS(4220),
    [anon_sym_sealed] = ACTIONS(4220),
    [anon_sym_unsafe] = ACTIONS(4220),
    [anon_sym_virtual] = ACTIONS(4220),
    [anon_sym_volatile] = ACTIONS(4220),
    [anon_sym_RBRACE] = ACTIONS(4222),
    [anon_sym_implicit] = ACTIONS(4220),
    [anon_sym_explicit] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4222),
    [anon_sym_where] = ACTIONS(4220),
    [anon_sym_class] = ACTIONS(4220),
    [anon_sym_struct] = ACTIONS(4220),
    [anon_sym_notnull] = ACTIONS(4220),
    [anon_sym_unmanaged] = ACTIONS(4220),
    [anon_sym_get] = ACTIONS(4220),
    [anon_sym_set] = ACTIONS(4220),
    [anon_sym_add] = ACTIONS(4220),
    [anon_sym_remove] = ACTIONS(4220),
    [anon_sym_enum] = ACTIONS(4220),
    [anon_sym_interface] = ACTIONS(4220),
    [anon_sym_delegate] = ACTIONS(4220),
    [anon_sym_record] = ACTIONS(4220),
    [anon_sym_namespace] = ACTIONS(4220),
    [anon_sym_var] = ACTIONS(4220),
    [sym_predefined_type] = ACTIONS(4220),
    [anon_sym_when] = ACTIONS(4220),
    [anon_sym_yield] = ACTIONS(4220),
    [anon_sym_from] = ACTIONS(4220),
    [anon_sym_join] = ACTIONS(4220),
    [anon_sym_on] = ACTIONS(4220),
    [anon_sym_equals] = ACTIONS(4220),
    [anon_sym_into] = ACTIONS(4220),
    [anon_sym_let] = ACTIONS(4220),
    [anon_sym_orderby] = ACTIONS(4220),
    [anon_sym_ascending] = ACTIONS(4220),
    [anon_sym_descending] = ACTIONS(4220),
    [anon_sym_group] = ACTIONS(4220),
    [anon_sym_by] = ACTIONS(4220),
    [anon_sym_select] = ACTIONS(4220),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4220),
    [anon_sym_nameof] = ACTIONS(4220),
    [sym_void_keyword] = ACTIONS(4220),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2379] = {
    [sym__preprocessor_call] = STATE(2379),
    [sym__identifier_token] = ACTIONS(4224),
    [anon_sym_extern] = ACTIONS(4224),
    [anon_sym_alias] = ACTIONS(4224),
    [anon_sym_global] = ACTIONS(4224),
    [anon_sym_using] = ACTIONS(4224),
    [anon_sym_static] = ACTIONS(4224),
    [anon_sym_LBRACK] = ACTIONS(4226),
    [anon_sym_event] = ACTIONS(4224),
    [anon_sym_LPAREN] = ACTIONS(4226),
    [anon_sym_abstract] = ACTIONS(4224),
    [anon_sym_async] = ACTIONS(4224),
    [anon_sym_const] = ACTIONS(4224),
    [anon_sym_fixed] = ACTIONS(4224),
    [anon_sym_internal] = ACTIONS(4224),
    [anon_sym_new] = ACTIONS(4224),
    [anon_sym_override] = ACTIONS(4224),
    [anon_sym_partial] = ACTIONS(4224),
    [anon_sym_private] = ACTIONS(4224),
    [anon_sym_protected] = ACTIONS(4224),
    [anon_sym_public] = ACTIONS(4224),
    [anon_sym_readonly] = ACTIONS(4224),
    [anon_sym_ref] = ACTIONS(4224),
    [anon_sym_sealed] = ACTIONS(4224),
    [anon_sym_unsafe] = ACTIONS(4224),
    [anon_sym_virtual] = ACTIONS(4224),
    [anon_sym_volatile] = ACTIONS(4224),
    [anon_sym_RBRACE] = ACTIONS(4226),
    [anon_sym_implicit] = ACTIONS(4224),
    [anon_sym_explicit] = ACTIONS(4224),
    [anon_sym_TILDE] = ACTIONS(4226),
    [anon_sym_where] = ACTIONS(4224),
    [anon_sym_class] = ACTIONS(4224),
    [anon_sym_struct] = ACTIONS(4224),
    [anon_sym_notnull] = ACTIONS(4224),
    [anon_sym_unmanaged] = ACTIONS(4224),
    [anon_sym_get] = ACTIONS(4224),
    [anon_sym_set] = ACTIONS(4224),
    [anon_sym_add] = ACTIONS(4224),
    [anon_sym_remove] = ACTIONS(4224),
    [anon_sym_enum] = ACTIONS(4224),
    [anon_sym_interface] = ACTIONS(4224),
    [anon_sym_delegate] = ACTIONS(4224),
    [anon_sym_record] = ACTIONS(4224),
    [anon_sym_namespace] = ACTIONS(4224),
    [anon_sym_var] = ACTIONS(4224),
    [sym_predefined_type] = ACTIONS(4224),
    [anon_sym_when] = ACTIONS(4224),
    [anon_sym_yield] = ACTIONS(4224),
    [anon_sym_from] = ACTIONS(4224),
    [anon_sym_join] = ACTIONS(4224),
    [anon_sym_on] = ACTIONS(4224),
    [anon_sym_equals] = ACTIONS(4224),
    [anon_sym_into] = ACTIONS(4224),
    [anon_sym_let] = ACTIONS(4224),
    [anon_sym_orderby] = ACTIONS(4224),
    [anon_sym_ascending] = ACTIONS(4224),
    [anon_sym_descending] = ACTIONS(4224),
    [anon_sym_group] = ACTIONS(4224),
    [anon_sym_by] = ACTIONS(4224),
    [anon_sym_select] = ACTIONS(4224),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4224),
    [anon_sym_nameof] = ACTIONS(4224),
    [sym_void_keyword] = ACTIONS(4224),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2380] = {
    [sym__preprocessor_call] = STATE(2380),
    [sym__identifier_token] = ACTIONS(4228),
    [anon_sym_extern] = ACTIONS(4228),
    [anon_sym_alias] = ACTIONS(4228),
    [anon_sym_global] = ACTIONS(4228),
    [anon_sym_using] = ACTIONS(4228),
    [anon_sym_static] = ACTIONS(4228),
    [anon_sym_LBRACK] = ACTIONS(4230),
    [anon_sym_event] = ACTIONS(4228),
    [anon_sym_LPAREN] = ACTIONS(4230),
    [anon_sym_abstract] = ACTIONS(4228),
    [anon_sym_async] = ACTIONS(4228),
    [anon_sym_const] = ACTIONS(4228),
    [anon_sym_fixed] = ACTIONS(4228),
    [anon_sym_internal] = ACTIONS(4228),
    [anon_sym_new] = ACTIONS(4228),
    [anon_sym_override] = ACTIONS(4228),
    [anon_sym_partial] = ACTIONS(4228),
    [anon_sym_private] = ACTIONS(4228),
    [anon_sym_protected] = ACTIONS(4228),
    [anon_sym_public] = ACTIONS(4228),
    [anon_sym_readonly] = ACTIONS(4228),
    [anon_sym_ref] = ACTIONS(4228),
    [anon_sym_sealed] = ACTIONS(4228),
    [anon_sym_unsafe] = ACTIONS(4228),
    [anon_sym_virtual] = ACTIONS(4228),
    [anon_sym_volatile] = ACTIONS(4228),
    [anon_sym_RBRACE] = ACTIONS(4230),
    [anon_sym_implicit] = ACTIONS(4228),
    [anon_sym_explicit] = ACTIONS(4228),
    [anon_sym_TILDE] = ACTIONS(4230),
    [anon_sym_where] = ACTIONS(4228),
    [anon_sym_class] = ACTIONS(4228),
    [anon_sym_struct] = ACTIONS(4228),
    [anon_sym_notnull] = ACTIONS(4228),
    [anon_sym_unmanaged] = ACTIONS(4228),
    [anon_sym_get] = ACTIONS(4228),
    [anon_sym_set] = ACTIONS(4228),
    [anon_sym_add] = ACTIONS(4228),
    [anon_sym_remove] = ACTIONS(4228),
    [anon_sym_enum] = ACTIONS(4228),
    [anon_sym_interface] = ACTIONS(4228),
    [anon_sym_delegate] = ACTIONS(4228),
    [anon_sym_record] = ACTIONS(4228),
    [anon_sym_namespace] = ACTIONS(4228),
    [anon_sym_var] = ACTIONS(4228),
    [sym_predefined_type] = ACTIONS(4228),
    [anon_sym_when] = ACTIONS(4228),
    [anon_sym_yield] = ACTIONS(4228),
    [anon_sym_from] = ACTIONS(4228),
    [anon_sym_join] = ACTIONS(4228),
    [anon_sym_on] = ACTIONS(4228),
    [anon_sym_equals] = ACTIONS(4228),
    [anon_sym_into] = ACTIONS(4228),
    [anon_sym_let] = ACTIONS(4228),
    [anon_sym_orderby] = ACTIONS(4228),
    [anon_sym_ascending] = ACTIONS(4228),
    [anon_sym_descending] = ACTIONS(4228),
    [anon_sym_group] = ACTIONS(4228),
    [anon_sym_by] = ACTIONS(4228),
    [anon_sym_select] = ACTIONS(4228),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4228),
    [anon_sym_nameof] = ACTIONS(4228),
    [sym_void_keyword] = ACTIONS(4228),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2381] = {
    [sym__preprocessor_call] = STATE(2381),
    [sym__identifier_token] = ACTIONS(4232),
    [anon_sym_extern] = ACTIONS(4232),
    [anon_sym_alias] = ACTIONS(4232),
    [anon_sym_global] = ACTIONS(4232),
    [anon_sym_using] = ACTIONS(4232),
    [anon_sym_static] = ACTIONS(4232),
    [anon_sym_LBRACK] = ACTIONS(4234),
    [anon_sym_event] = ACTIONS(4232),
    [anon_sym_LPAREN] = ACTIONS(4234),
    [anon_sym_abstract] = ACTIONS(4232),
    [anon_sym_async] = ACTIONS(4232),
    [anon_sym_const] = ACTIONS(4232),
    [anon_sym_fixed] = ACTIONS(4232),
    [anon_sym_internal] = ACTIONS(4232),
    [anon_sym_new] = ACTIONS(4232),
    [anon_sym_override] = ACTIONS(4232),
    [anon_sym_partial] = ACTIONS(4232),
    [anon_sym_private] = ACTIONS(4232),
    [anon_sym_protected] = ACTIONS(4232),
    [anon_sym_public] = ACTIONS(4232),
    [anon_sym_readonly] = ACTIONS(4232),
    [anon_sym_ref] = ACTIONS(4232),
    [anon_sym_sealed] = ACTIONS(4232),
    [anon_sym_unsafe] = ACTIONS(4232),
    [anon_sym_virtual] = ACTIONS(4232),
    [anon_sym_volatile] = ACTIONS(4232),
    [anon_sym_RBRACE] = ACTIONS(4234),
    [anon_sym_implicit] = ACTIONS(4232),
    [anon_sym_explicit] = ACTIONS(4232),
    [anon_sym_TILDE] = ACTIONS(4234),
    [anon_sym_where] = ACTIONS(4232),
    [anon_sym_class] = ACTIONS(4232),
    [anon_sym_struct] = ACTIONS(4232),
    [anon_sym_notnull] = ACTIONS(4232),
    [anon_sym_unmanaged] = ACTIONS(4232),
    [anon_sym_get] = ACTIONS(4232),
    [anon_sym_set] = ACTIONS(4232),
    [anon_sym_add] = ACTIONS(4232),
    [anon_sym_remove] = ACTIONS(4232),
    [anon_sym_enum] = ACTIONS(4232),
    [anon_sym_interface] = ACTIONS(4232),
    [anon_sym_delegate] = ACTIONS(4232),
    [anon_sym_record] = ACTIONS(4232),
    [anon_sym_namespace] = ACTIONS(4232),
    [anon_sym_var] = ACTIONS(4232),
    [sym_predefined_type] = ACTIONS(4232),
    [anon_sym_when] = ACTIONS(4232),
    [anon_sym_yield] = ACTIONS(4232),
    [anon_sym_from] = ACTIONS(4232),
    [anon_sym_join] = ACTIONS(4232),
    [anon_sym_on] = ACTIONS(4232),
    [anon_sym_equals] = ACTIONS(4232),
    [anon_sym_into] = ACTIONS(4232),
    [anon_sym_let] = ACTIONS(4232),
    [anon_sym_orderby] = ACTIONS(4232),
    [anon_sym_ascending] = ACTIONS(4232),
    [anon_sym_descending] = ACTIONS(4232),
    [anon_sym_group] = ACTIONS(4232),
    [anon_sym_by] = ACTIONS(4232),
    [anon_sym_select] = ACTIONS(4232),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4232),
    [anon_sym_nameof] = ACTIONS(4232),
    [sym_void_keyword] = ACTIONS(4232),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2382] = {
    [sym__preprocessor_call] = STATE(2382),
    [sym__identifier_token] = ACTIONS(4236),
    [anon_sym_extern] = ACTIONS(4236),
    [anon_sym_alias] = ACTIONS(4236),
    [anon_sym_global] = ACTIONS(4236),
    [anon_sym_using] = ACTIONS(4236),
    [anon_sym_static] = ACTIONS(4236),
    [anon_sym_LBRACK] = ACTIONS(4238),
    [anon_sym_event] = ACTIONS(4236),
    [anon_sym_LPAREN] = ACTIONS(4238),
    [anon_sym_abstract] = ACTIONS(4236),
    [anon_sym_async] = ACTIONS(4236),
    [anon_sym_const] = ACTIONS(4236),
    [anon_sym_fixed] = ACTIONS(4236),
    [anon_sym_internal] = ACTIONS(4236),
    [anon_sym_new] = ACTIONS(4236),
    [anon_sym_override] = ACTIONS(4236),
    [anon_sym_partial] = ACTIONS(4236),
    [anon_sym_private] = ACTIONS(4236),
    [anon_sym_protected] = ACTIONS(4236),
    [anon_sym_public] = ACTIONS(4236),
    [anon_sym_readonly] = ACTIONS(4236),
    [anon_sym_ref] = ACTIONS(4236),
    [anon_sym_sealed] = ACTIONS(4236),
    [anon_sym_unsafe] = ACTIONS(4236),
    [anon_sym_virtual] = ACTIONS(4236),
    [anon_sym_volatile] = ACTIONS(4236),
    [anon_sym_RBRACE] = ACTIONS(4238),
    [anon_sym_implicit] = ACTIONS(4236),
    [anon_sym_explicit] = ACTIONS(4236),
    [anon_sym_TILDE] = ACTIONS(4238),
    [anon_sym_where] = ACTIONS(4236),
    [anon_sym_class] = ACTIONS(4236),
    [anon_sym_struct] = ACTIONS(4236),
    [anon_sym_notnull] = ACTIONS(4236),
    [anon_sym_unmanaged] = ACTIONS(4236),
    [anon_sym_get] = ACTIONS(4236),
    [anon_sym_set] = ACTIONS(4236),
    [anon_sym_add] = ACTIONS(4236),
    [anon_sym_remove] = ACTIONS(4236),
    [anon_sym_enum] = ACTIONS(4236),
    [anon_sym_interface] = ACTIONS(4236),
    [anon_sym_delegate] = ACTIONS(4236),
    [anon_sym_record] = ACTIONS(4236),
    [anon_sym_namespace] = ACTIONS(4236),
    [anon_sym_var] = ACTIONS(4236),
    [sym_predefined_type] = ACTIONS(4236),
    [anon_sym_when] = ACTIONS(4236),
    [anon_sym_yield] = ACTIONS(4236),
    [anon_sym_from] = ACTIONS(4236),
    [anon_sym_join] = ACTIONS(4236),
    [anon_sym_on] = ACTIONS(4236),
    [anon_sym_equals] = ACTIONS(4236),
    [anon_sym_into] = ACTIONS(4236),
    [anon_sym_let] = ACTIONS(4236),
    [anon_sym_orderby] = ACTIONS(4236),
    [anon_sym_ascending] = ACTIONS(4236),
    [anon_sym_descending] = ACTIONS(4236),
    [anon_sym_group] = ACTIONS(4236),
    [anon_sym_by] = ACTIONS(4236),
    [anon_sym_select] = ACTIONS(4236),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4236),
    [anon_sym_nameof] = ACTIONS(4236),
    [sym_void_keyword] = ACTIONS(4236),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2383] = {
    [sym__preprocessor_call] = STATE(2383),
    [sym__identifier_token] = ACTIONS(4240),
    [anon_sym_extern] = ACTIONS(4240),
    [anon_sym_alias] = ACTIONS(4240),
    [anon_sym_global] = ACTIONS(4240),
    [anon_sym_using] = ACTIONS(4240),
    [anon_sym_static] = ACTIONS(4240),
    [anon_sym_LBRACK] = ACTIONS(4242),
    [anon_sym_event] = ACTIONS(4240),
    [anon_sym_LPAREN] = ACTIONS(4242),
    [anon_sym_abstract] = ACTIONS(4240),
    [anon_sym_async] = ACTIONS(4240),
    [anon_sym_const] = ACTIONS(4240),
    [anon_sym_fixed] = ACTIONS(4240),
    [anon_sym_internal] = ACTIONS(4240),
    [anon_sym_new] = ACTIONS(4240),
    [anon_sym_override] = ACTIONS(4240),
    [anon_sym_partial] = ACTIONS(4240),
    [anon_sym_private] = ACTIONS(4240),
    [anon_sym_protected] = ACTIONS(4240),
    [anon_sym_public] = ACTIONS(4240),
    [anon_sym_readonly] = ACTIONS(4240),
    [anon_sym_ref] = ACTIONS(4240),
    [anon_sym_sealed] = ACTIONS(4240),
    [anon_sym_unsafe] = ACTIONS(4240),
    [anon_sym_virtual] = ACTIONS(4240),
    [anon_sym_volatile] = ACTIONS(4240),
    [anon_sym_RBRACE] = ACTIONS(4242),
    [anon_sym_implicit] = ACTIONS(4240),
    [anon_sym_explicit] = ACTIONS(4240),
    [anon_sym_TILDE] = ACTIONS(4242),
    [anon_sym_where] = ACTIONS(4240),
    [anon_sym_class] = ACTIONS(4240),
    [anon_sym_struct] = ACTIONS(4240),
    [anon_sym_notnull] = ACTIONS(4240),
    [anon_sym_unmanaged] = ACTIONS(4240),
    [anon_sym_get] = ACTIONS(4240),
    [anon_sym_set] = ACTIONS(4240),
    [anon_sym_add] = ACTIONS(4240),
    [anon_sym_remove] = ACTIONS(4240),
    [anon_sym_enum] = ACTIONS(4240),
    [anon_sym_interface] = ACTIONS(4240),
    [anon_sym_delegate] = ACTIONS(4240),
    [anon_sym_record] = ACTIONS(4240),
    [anon_sym_namespace] = ACTIONS(4240),
    [anon_sym_var] = ACTIONS(4240),
    [sym_predefined_type] = ACTIONS(4240),
    [anon_sym_when] = ACTIONS(4240),
    [anon_sym_yield] = ACTIONS(4240),
    [anon_sym_from] = ACTIONS(4240),
    [anon_sym_join] = ACTIONS(4240),
    [anon_sym_on] = ACTIONS(4240),
    [anon_sym_equals] = ACTIONS(4240),
    [anon_sym_into] = ACTIONS(4240),
    [anon_sym_let] = ACTIONS(4240),
    [anon_sym_orderby] = ACTIONS(4240),
    [anon_sym_ascending] = ACTIONS(4240),
    [anon_sym_descending] = ACTIONS(4240),
    [anon_sym_group] = ACTIONS(4240),
    [anon_sym_by] = ACTIONS(4240),
    [anon_sym_select] = ACTIONS(4240),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4240),
    [anon_sym_nameof] = ACTIONS(4240),
    [sym_void_keyword] = ACTIONS(4240),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2384] = {
    [sym__preprocessor_call] = STATE(2384),
    [sym__identifier_token] = ACTIONS(2336),
    [anon_sym_extern] = ACTIONS(2336),
    [anon_sym_alias] = ACTIONS(2336),
    [anon_sym_global] = ACTIONS(2336),
    [anon_sym_using] = ACTIONS(2336),
    [anon_sym_static] = ACTIONS(2336),
    [anon_sym_LBRACK] = ACTIONS(2334),
    [anon_sym_event] = ACTIONS(2336),
    [anon_sym_LPAREN] = ACTIONS(2334),
    [anon_sym_abstract] = ACTIONS(2336),
    [anon_sym_async] = ACTIONS(2336),
    [anon_sym_const] = ACTIONS(2336),
    [anon_sym_fixed] = ACTIONS(2336),
    [anon_sym_internal] = ACTIONS(2336),
    [anon_sym_new] = ACTIONS(2336),
    [anon_sym_override] = ACTIONS(2336),
    [anon_sym_partial] = ACTIONS(2336),
    [anon_sym_private] = ACTIONS(2336),
    [anon_sym_protected] = ACTIONS(2336),
    [anon_sym_public] = ACTIONS(2336),
    [anon_sym_readonly] = ACTIONS(2336),
    [anon_sym_ref] = ACTIONS(2336),
    [anon_sym_sealed] = ACTIONS(2336),
    [anon_sym_unsafe] = ACTIONS(2336),
    [anon_sym_virtual] = ACTIONS(2336),
    [anon_sym_volatile] = ACTIONS(2336),
    [anon_sym_RBRACE] = ACTIONS(2334),
    [anon_sym_implicit] = ACTIONS(2336),
    [anon_sym_explicit] = ACTIONS(2336),
    [anon_sym_TILDE] = ACTIONS(2334),
    [anon_sym_where] = ACTIONS(2336),
    [anon_sym_class] = ACTIONS(2336),
    [anon_sym_struct] = ACTIONS(2336),
    [anon_sym_notnull] = ACTIONS(2336),
    [anon_sym_unmanaged] = ACTIONS(2336),
    [anon_sym_get] = ACTIONS(2336),
    [anon_sym_set] = ACTIONS(2336),
    [anon_sym_add] = ACTIONS(2336),
    [anon_sym_remove] = ACTIONS(2336),
    [anon_sym_enum] = ACTIONS(2336),
    [anon_sym_interface] = ACTIONS(2336),
    [anon_sym_delegate] = ACTIONS(2336),
    [anon_sym_record] = ACTIONS(2336),
    [anon_sym_namespace] = ACTIONS(2336),
    [anon_sym_var] = ACTIONS(2336),
    [sym_predefined_type] = ACTIONS(2336),
    [anon_sym_when] = ACTIONS(2336),
    [anon_sym_yield] = ACTIONS(2336),
    [anon_sym_from] = ACTIONS(2336),
    [anon_sym_join] = ACTIONS(2336),
    [anon_sym_on] = ACTIONS(2336),
    [anon_sym_equals] = ACTIONS(2336),
    [anon_sym_into] = ACTIONS(2336),
    [anon_sym_let] = ACTIONS(2336),
    [anon_sym_orderby] = ACTIONS(2336),
    [anon_sym_ascending] = ACTIONS(2336),
    [anon_sym_descending] = ACTIONS(2336),
    [anon_sym_group] = ACTIONS(2336),
    [anon_sym_by] = ACTIONS(2336),
    [anon_sym_select] = ACTIONS(2336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2336),
    [anon_sym_nameof] = ACTIONS(2336),
    [sym_void_keyword] = ACTIONS(2336),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2385] = {
    [sym__preprocessor_call] = STATE(2385),
    [sym__identifier_token] = ACTIONS(4244),
    [anon_sym_extern] = ACTIONS(4244),
    [anon_sym_alias] = ACTIONS(4244),
    [anon_sym_global] = ACTIONS(4244),
    [anon_sym_using] = ACTIONS(4244),
    [anon_sym_static] = ACTIONS(4244),
    [anon_sym_LBRACK] = ACTIONS(4246),
    [anon_sym_event] = ACTIONS(4244),
    [anon_sym_LPAREN] = ACTIONS(4246),
    [anon_sym_abstract] = ACTIONS(4244),
    [anon_sym_async] = ACTIONS(4244),
    [anon_sym_const] = ACTIONS(4244),
    [anon_sym_fixed] = ACTIONS(4244),
    [anon_sym_internal] = ACTIONS(4244),
    [anon_sym_new] = ACTIONS(4244),
    [anon_sym_override] = ACTIONS(4244),
    [anon_sym_partial] = ACTIONS(4244),
    [anon_sym_private] = ACTIONS(4244),
    [anon_sym_protected] = ACTIONS(4244),
    [anon_sym_public] = ACTIONS(4244),
    [anon_sym_readonly] = ACTIONS(4244),
    [anon_sym_ref] = ACTIONS(4244),
    [anon_sym_sealed] = ACTIONS(4244),
    [anon_sym_unsafe] = ACTIONS(4244),
    [anon_sym_virtual] = ACTIONS(4244),
    [anon_sym_volatile] = ACTIONS(4244),
    [anon_sym_RBRACE] = ACTIONS(4246),
    [anon_sym_implicit] = ACTIONS(4244),
    [anon_sym_explicit] = ACTIONS(4244),
    [anon_sym_TILDE] = ACTIONS(4246),
    [anon_sym_where] = ACTIONS(4244),
    [anon_sym_class] = ACTIONS(4244),
    [anon_sym_struct] = ACTIONS(4244),
    [anon_sym_notnull] = ACTIONS(4244),
    [anon_sym_unmanaged] = ACTIONS(4244),
    [anon_sym_get] = ACTIONS(4244),
    [anon_sym_set] = ACTIONS(4244),
    [anon_sym_add] = ACTIONS(4244),
    [anon_sym_remove] = ACTIONS(4244),
    [anon_sym_enum] = ACTIONS(4244),
    [anon_sym_interface] = ACTIONS(4244),
    [anon_sym_delegate] = ACTIONS(4244),
    [anon_sym_record] = ACTIONS(4244),
    [anon_sym_namespace] = ACTIONS(4244),
    [anon_sym_var] = ACTIONS(4244),
    [sym_predefined_type] = ACTIONS(4244),
    [anon_sym_when] = ACTIONS(4244),
    [anon_sym_yield] = ACTIONS(4244),
    [anon_sym_from] = ACTIONS(4244),
    [anon_sym_join] = ACTIONS(4244),
    [anon_sym_on] = ACTIONS(4244),
    [anon_sym_equals] = ACTIONS(4244),
    [anon_sym_into] = ACTIONS(4244),
    [anon_sym_let] = ACTIONS(4244),
    [anon_sym_orderby] = ACTIONS(4244),
    [anon_sym_ascending] = ACTIONS(4244),
    [anon_sym_descending] = ACTIONS(4244),
    [anon_sym_group] = ACTIONS(4244),
    [anon_sym_by] = ACTIONS(4244),
    [anon_sym_select] = ACTIONS(4244),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4244),
    [anon_sym_nameof] = ACTIONS(4244),
    [sym_void_keyword] = ACTIONS(4244),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2386] = {
    [sym__preprocessor_call] = STATE(2386),
    [sym__identifier_token] = ACTIONS(4248),
    [anon_sym_extern] = ACTIONS(4248),
    [anon_sym_alias] = ACTIONS(4248),
    [anon_sym_global] = ACTIONS(4248),
    [anon_sym_using] = ACTIONS(4248),
    [anon_sym_static] = ACTIONS(4248),
    [anon_sym_LBRACK] = ACTIONS(4250),
    [anon_sym_event] = ACTIONS(4248),
    [anon_sym_LPAREN] = ACTIONS(4250),
    [anon_sym_abstract] = ACTIONS(4248),
    [anon_sym_async] = ACTIONS(4248),
    [anon_sym_const] = ACTIONS(4248),
    [anon_sym_fixed] = ACTIONS(4248),
    [anon_sym_internal] = ACTIONS(4248),
    [anon_sym_new] = ACTIONS(4248),
    [anon_sym_override] = ACTIONS(4248),
    [anon_sym_partial] = ACTIONS(4248),
    [anon_sym_private] = ACTIONS(4248),
    [anon_sym_protected] = ACTIONS(4248),
    [anon_sym_public] = ACTIONS(4248),
    [anon_sym_readonly] = ACTIONS(4248),
    [anon_sym_ref] = ACTIONS(4248),
    [anon_sym_sealed] = ACTIONS(4248),
    [anon_sym_unsafe] = ACTIONS(4248),
    [anon_sym_virtual] = ACTIONS(4248),
    [anon_sym_volatile] = ACTIONS(4248),
    [anon_sym_RBRACE] = ACTIONS(4250),
    [anon_sym_implicit] = ACTIONS(4248),
    [anon_sym_explicit] = ACTIONS(4248),
    [anon_sym_TILDE] = ACTIONS(4250),
    [anon_sym_where] = ACTIONS(4248),
    [anon_sym_class] = ACTIONS(4248),
    [anon_sym_struct] = ACTIONS(4248),
    [anon_sym_notnull] = ACTIONS(4248),
    [anon_sym_unmanaged] = ACTIONS(4248),
    [anon_sym_get] = ACTIONS(4248),
    [anon_sym_set] = ACTIONS(4248),
    [anon_sym_add] = ACTIONS(4248),
    [anon_sym_remove] = ACTIONS(4248),
    [anon_sym_enum] = ACTIONS(4248),
    [anon_sym_interface] = ACTIONS(4248),
    [anon_sym_delegate] = ACTIONS(4248),
    [anon_sym_record] = ACTIONS(4248),
    [anon_sym_namespace] = ACTIONS(4248),
    [anon_sym_var] = ACTIONS(4248),
    [sym_predefined_type] = ACTIONS(4248),
    [anon_sym_when] = ACTIONS(4248),
    [anon_sym_yield] = ACTIONS(4248),
    [anon_sym_from] = ACTIONS(4248),
    [anon_sym_join] = ACTIONS(4248),
    [anon_sym_on] = ACTIONS(4248),
    [anon_sym_equals] = ACTIONS(4248),
    [anon_sym_into] = ACTIONS(4248),
    [anon_sym_let] = ACTIONS(4248),
    [anon_sym_orderby] = ACTIONS(4248),
    [anon_sym_ascending] = ACTIONS(4248),
    [anon_sym_descending] = ACTIONS(4248),
    [anon_sym_group] = ACTIONS(4248),
    [anon_sym_by] = ACTIONS(4248),
    [anon_sym_select] = ACTIONS(4248),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4248),
    [anon_sym_nameof] = ACTIONS(4248),
    [sym_void_keyword] = ACTIONS(4248),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2387] = {
    [sym__preprocessor_call] = STATE(2387),
    [sym__identifier_token] = ACTIONS(4252),
    [anon_sym_extern] = ACTIONS(4252),
    [anon_sym_alias] = ACTIONS(4252),
    [anon_sym_global] = ACTIONS(4252),
    [anon_sym_using] = ACTIONS(4252),
    [anon_sym_static] = ACTIONS(4252),
    [anon_sym_LBRACK] = ACTIONS(4254),
    [anon_sym_event] = ACTIONS(4252),
    [anon_sym_LPAREN] = ACTIONS(4254),
    [anon_sym_abstract] = ACTIONS(4252),
    [anon_sym_async] = ACTIONS(4252),
    [anon_sym_const] = ACTIONS(4252),
    [anon_sym_fixed] = ACTIONS(4252),
    [anon_sym_internal] = ACTIONS(4252),
    [anon_sym_new] = ACTIONS(4252),
    [anon_sym_override] = ACTIONS(4252),
    [anon_sym_partial] = ACTIONS(4252),
    [anon_sym_private] = ACTIONS(4252),
    [anon_sym_protected] = ACTIONS(4252),
    [anon_sym_public] = ACTIONS(4252),
    [anon_sym_readonly] = ACTIONS(4252),
    [anon_sym_ref] = ACTIONS(4252),
    [anon_sym_sealed] = ACTIONS(4252),
    [anon_sym_unsafe] = ACTIONS(4252),
    [anon_sym_virtual] = ACTIONS(4252),
    [anon_sym_volatile] = ACTIONS(4252),
    [anon_sym_RBRACE] = ACTIONS(4254),
    [anon_sym_implicit] = ACTIONS(4252),
    [anon_sym_explicit] = ACTIONS(4252),
    [anon_sym_TILDE] = ACTIONS(4254),
    [anon_sym_where] = ACTIONS(4252),
    [anon_sym_class] = ACTIONS(4252),
    [anon_sym_struct] = ACTIONS(4252),
    [anon_sym_notnull] = ACTIONS(4252),
    [anon_sym_unmanaged] = ACTIONS(4252),
    [anon_sym_get] = ACTIONS(4252),
    [anon_sym_set] = ACTIONS(4252),
    [anon_sym_add] = ACTIONS(4252),
    [anon_sym_remove] = ACTIONS(4252),
    [anon_sym_enum] = ACTIONS(4252),
    [anon_sym_interface] = ACTIONS(4252),
    [anon_sym_delegate] = ACTIONS(4252),
    [anon_sym_record] = ACTIONS(4252),
    [anon_sym_namespace] = ACTIONS(4252),
    [anon_sym_var] = ACTIONS(4252),
    [sym_predefined_type] = ACTIONS(4252),
    [anon_sym_when] = ACTIONS(4252),
    [anon_sym_yield] = ACTIONS(4252),
    [anon_sym_from] = ACTIONS(4252),
    [anon_sym_join] = ACTIONS(4252),
    [anon_sym_on] = ACTIONS(4252),
    [anon_sym_equals] = ACTIONS(4252),
    [anon_sym_into] = ACTIONS(4252),
    [anon_sym_let] = ACTIONS(4252),
    [anon_sym_orderby] = ACTIONS(4252),
    [anon_sym_ascending] = ACTIONS(4252),
    [anon_sym_descending] = ACTIONS(4252),
    [anon_sym_group] = ACTIONS(4252),
    [anon_sym_by] = ACTIONS(4252),
    [anon_sym_select] = ACTIONS(4252),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4252),
    [anon_sym_nameof] = ACTIONS(4252),
    [sym_void_keyword] = ACTIONS(4252),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2388] = {
    [sym__preprocessor_call] = STATE(2388),
    [sym__identifier_token] = ACTIONS(4256),
    [anon_sym_extern] = ACTIONS(4256),
    [anon_sym_alias] = ACTIONS(4256),
    [anon_sym_global] = ACTIONS(4256),
    [anon_sym_using] = ACTIONS(4256),
    [anon_sym_static] = ACTIONS(4256),
    [anon_sym_LBRACK] = ACTIONS(4258),
    [anon_sym_event] = ACTIONS(4256),
    [anon_sym_LPAREN] = ACTIONS(4258),
    [anon_sym_abstract] = ACTIONS(4256),
    [anon_sym_async] = ACTIONS(4256),
    [anon_sym_const] = ACTIONS(4256),
    [anon_sym_fixed] = ACTIONS(4256),
    [anon_sym_internal] = ACTIONS(4256),
    [anon_sym_new] = ACTIONS(4256),
    [anon_sym_override] = ACTIONS(4256),
    [anon_sym_partial] = ACTIONS(4256),
    [anon_sym_private] = ACTIONS(4256),
    [anon_sym_protected] = ACTIONS(4256),
    [anon_sym_public] = ACTIONS(4256),
    [anon_sym_readonly] = ACTIONS(4256),
    [anon_sym_ref] = ACTIONS(4256),
    [anon_sym_sealed] = ACTIONS(4256),
    [anon_sym_unsafe] = ACTIONS(4256),
    [anon_sym_virtual] = ACTIONS(4256),
    [anon_sym_volatile] = ACTIONS(4256),
    [anon_sym_RBRACE] = ACTIONS(4258),
    [anon_sym_implicit] = ACTIONS(4256),
    [anon_sym_explicit] = ACTIONS(4256),
    [anon_sym_TILDE] = ACTIONS(4258),
    [anon_sym_where] = ACTIONS(4256),
    [anon_sym_class] = ACTIONS(4256),
    [anon_sym_struct] = ACTIONS(4256),
    [anon_sym_notnull] = ACTIONS(4256),
    [anon_sym_unmanaged] = ACTIONS(4256),
    [anon_sym_get] = ACTIONS(4256),
    [anon_sym_set] = ACTIONS(4256),
    [anon_sym_add] = ACTIONS(4256),
    [anon_sym_remove] = ACTIONS(4256),
    [anon_sym_enum] = ACTIONS(4256),
    [anon_sym_interface] = ACTIONS(4256),
    [anon_sym_delegate] = ACTIONS(4256),
    [anon_sym_record] = ACTIONS(4256),
    [anon_sym_namespace] = ACTIONS(4256),
    [anon_sym_var] = ACTIONS(4256),
    [sym_predefined_type] = ACTIONS(4256),
    [anon_sym_when] = ACTIONS(4256),
    [anon_sym_yield] = ACTIONS(4256),
    [anon_sym_from] = ACTIONS(4256),
    [anon_sym_join] = ACTIONS(4256),
    [anon_sym_on] = ACTIONS(4256),
    [anon_sym_equals] = ACTIONS(4256),
    [anon_sym_into] = ACTIONS(4256),
    [anon_sym_let] = ACTIONS(4256),
    [anon_sym_orderby] = ACTIONS(4256),
    [anon_sym_ascending] = ACTIONS(4256),
    [anon_sym_descending] = ACTIONS(4256),
    [anon_sym_group] = ACTIONS(4256),
    [anon_sym_by] = ACTIONS(4256),
    [anon_sym_select] = ACTIONS(4256),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4256),
    [anon_sym_nameof] = ACTIONS(4256),
    [sym_void_keyword] = ACTIONS(4256),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2389] = {
    [sym__preprocessor_call] = STATE(2389),
    [sym__identifier_token] = ACTIONS(4260),
    [anon_sym_extern] = ACTIONS(4260),
    [anon_sym_alias] = ACTIONS(4260),
    [anon_sym_global] = ACTIONS(4260),
    [anon_sym_using] = ACTIONS(4260),
    [anon_sym_static] = ACTIONS(4260),
    [anon_sym_LBRACK] = ACTIONS(4262),
    [anon_sym_event] = ACTIONS(4260),
    [anon_sym_LPAREN] = ACTIONS(4262),
    [anon_sym_abstract] = ACTIONS(4260),
    [anon_sym_async] = ACTIONS(4260),
    [anon_sym_const] = ACTIONS(4260),
    [anon_sym_fixed] = ACTIONS(4260),
    [anon_sym_internal] = ACTIONS(4260),
    [anon_sym_new] = ACTIONS(4260),
    [anon_sym_override] = ACTIONS(4260),
    [anon_sym_partial] = ACTIONS(4260),
    [anon_sym_private] = ACTIONS(4260),
    [anon_sym_protected] = ACTIONS(4260),
    [anon_sym_public] = ACTIONS(4260),
    [anon_sym_readonly] = ACTIONS(4260),
    [anon_sym_ref] = ACTIONS(4260),
    [anon_sym_sealed] = ACTIONS(4260),
    [anon_sym_unsafe] = ACTIONS(4260),
    [anon_sym_virtual] = ACTIONS(4260),
    [anon_sym_volatile] = ACTIONS(4260),
    [anon_sym_RBRACE] = ACTIONS(4262),
    [anon_sym_implicit] = ACTIONS(4260),
    [anon_sym_explicit] = ACTIONS(4260),
    [anon_sym_TILDE] = ACTIONS(4262),
    [anon_sym_where] = ACTIONS(4260),
    [anon_sym_class] = ACTIONS(4260),
    [anon_sym_struct] = ACTIONS(4260),
    [anon_sym_notnull] = ACTIONS(4260),
    [anon_sym_unmanaged] = ACTIONS(4260),
    [anon_sym_get] = ACTIONS(4260),
    [anon_sym_set] = ACTIONS(4260),
    [anon_sym_add] = ACTIONS(4260),
    [anon_sym_remove] = ACTIONS(4260),
    [anon_sym_enum] = ACTIONS(4260),
    [anon_sym_interface] = ACTIONS(4260),
    [anon_sym_delegate] = ACTIONS(4260),
    [anon_sym_record] = ACTIONS(4260),
    [anon_sym_namespace] = ACTIONS(4260),
    [anon_sym_var] = ACTIONS(4260),
    [sym_predefined_type] = ACTIONS(4260),
    [anon_sym_when] = ACTIONS(4260),
    [anon_sym_yield] = ACTIONS(4260),
    [anon_sym_from] = ACTIONS(4260),
    [anon_sym_join] = ACTIONS(4260),
    [anon_sym_on] = ACTIONS(4260),
    [anon_sym_equals] = ACTIONS(4260),
    [anon_sym_into] = ACTIONS(4260),
    [anon_sym_let] = ACTIONS(4260),
    [anon_sym_orderby] = ACTIONS(4260),
    [anon_sym_ascending] = ACTIONS(4260),
    [anon_sym_descending] = ACTIONS(4260),
    [anon_sym_group] = ACTIONS(4260),
    [anon_sym_by] = ACTIONS(4260),
    [anon_sym_select] = ACTIONS(4260),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4260),
    [anon_sym_nameof] = ACTIONS(4260),
    [sym_void_keyword] = ACTIONS(4260),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2390] = {
    [sym__preprocessor_call] = STATE(2390),
    [sym__identifier_token] = ACTIONS(4264),
    [anon_sym_extern] = ACTIONS(4264),
    [anon_sym_alias] = ACTIONS(4264),
    [anon_sym_global] = ACTIONS(4264),
    [anon_sym_using] = ACTIONS(4264),
    [anon_sym_static] = ACTIONS(4264),
    [anon_sym_LBRACK] = ACTIONS(4266),
    [anon_sym_event] = ACTIONS(4264),
    [anon_sym_LPAREN] = ACTIONS(4266),
    [anon_sym_abstract] = ACTIONS(4264),
    [anon_sym_async] = ACTIONS(4264),
    [anon_sym_const] = ACTIONS(4264),
    [anon_sym_fixed] = ACTIONS(4264),
    [anon_sym_internal] = ACTIONS(4264),
    [anon_sym_new] = ACTIONS(4264),
    [anon_sym_override] = ACTIONS(4264),
    [anon_sym_partial] = ACTIONS(4264),
    [anon_sym_private] = ACTIONS(4264),
    [anon_sym_protected] = ACTIONS(4264),
    [anon_sym_public] = ACTIONS(4264),
    [anon_sym_readonly] = ACTIONS(4264),
    [anon_sym_ref] = ACTIONS(4264),
    [anon_sym_sealed] = ACTIONS(4264),
    [anon_sym_unsafe] = ACTIONS(4264),
    [anon_sym_virtual] = ACTIONS(4264),
    [anon_sym_volatile] = ACTIONS(4264),
    [anon_sym_RBRACE] = ACTIONS(4266),
    [anon_sym_implicit] = ACTIONS(4264),
    [anon_sym_explicit] = ACTIONS(4264),
    [anon_sym_TILDE] = ACTIONS(4266),
    [anon_sym_where] = ACTIONS(4264),
    [anon_sym_class] = ACTIONS(4264),
    [anon_sym_struct] = ACTIONS(4264),
    [anon_sym_notnull] = ACTIONS(4264),
    [anon_sym_unmanaged] = ACTIONS(4264),
    [anon_sym_get] = ACTIONS(4264),
    [anon_sym_set] = ACTIONS(4264),
    [anon_sym_add] = ACTIONS(4264),
    [anon_sym_remove] = ACTIONS(4264),
    [anon_sym_enum] = ACTIONS(4264),
    [anon_sym_interface] = ACTIONS(4264),
    [anon_sym_delegate] = ACTIONS(4264),
    [anon_sym_record] = ACTIONS(4264),
    [anon_sym_namespace] = ACTIONS(4264),
    [anon_sym_var] = ACTIONS(4264),
    [sym_predefined_type] = ACTIONS(4264),
    [anon_sym_when] = ACTIONS(4264),
    [anon_sym_yield] = ACTIONS(4264),
    [anon_sym_from] = ACTIONS(4264),
    [anon_sym_join] = ACTIONS(4264),
    [anon_sym_on] = ACTIONS(4264),
    [anon_sym_equals] = ACTIONS(4264),
    [anon_sym_into] = ACTIONS(4264),
    [anon_sym_let] = ACTIONS(4264),
    [anon_sym_orderby] = ACTIONS(4264),
    [anon_sym_ascending] = ACTIONS(4264),
    [anon_sym_descending] = ACTIONS(4264),
    [anon_sym_group] = ACTIONS(4264),
    [anon_sym_by] = ACTIONS(4264),
    [anon_sym_select] = ACTIONS(4264),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4264),
    [anon_sym_nameof] = ACTIONS(4264),
    [sym_void_keyword] = ACTIONS(4264),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2391] = {
    [sym__preprocessor_call] = STATE(2391),
    [sym__identifier_token] = ACTIONS(4268),
    [anon_sym_extern] = ACTIONS(4268),
    [anon_sym_alias] = ACTIONS(4268),
    [anon_sym_global] = ACTIONS(4268),
    [anon_sym_using] = ACTIONS(4268),
    [anon_sym_static] = ACTIONS(4268),
    [anon_sym_LBRACK] = ACTIONS(4270),
    [anon_sym_event] = ACTIONS(4268),
    [anon_sym_LPAREN] = ACTIONS(4270),
    [anon_sym_abstract] = ACTIONS(4268),
    [anon_sym_async] = ACTIONS(4268),
    [anon_sym_const] = ACTIONS(4268),
    [anon_sym_fixed] = ACTIONS(4268),
    [anon_sym_internal] = ACTIONS(4268),
    [anon_sym_new] = ACTIONS(4268),
    [anon_sym_override] = ACTIONS(4268),
    [anon_sym_partial] = ACTIONS(4268),
    [anon_sym_private] = ACTIONS(4268),
    [anon_sym_protected] = ACTIONS(4268),
    [anon_sym_public] = ACTIONS(4268),
    [anon_sym_readonly] = ACTIONS(4268),
    [anon_sym_ref] = ACTIONS(4268),
    [anon_sym_sealed] = ACTIONS(4268),
    [anon_sym_unsafe] = ACTIONS(4268),
    [anon_sym_virtual] = ACTIONS(4268),
    [anon_sym_volatile] = ACTIONS(4268),
    [anon_sym_RBRACE] = ACTIONS(4270),
    [anon_sym_implicit] = ACTIONS(4268),
    [anon_sym_explicit] = ACTIONS(4268),
    [anon_sym_TILDE] = ACTIONS(4270),
    [anon_sym_where] = ACTIONS(4268),
    [anon_sym_class] = ACTIONS(4268),
    [anon_sym_struct] = ACTIONS(4268),
    [anon_sym_notnull] = ACTIONS(4268),
    [anon_sym_unmanaged] = ACTIONS(4268),
    [anon_sym_get] = ACTIONS(4268),
    [anon_sym_set] = ACTIONS(4268),
    [anon_sym_add] = ACTIONS(4268),
    [anon_sym_remove] = ACTIONS(4268),
    [anon_sym_enum] = ACTIONS(4268),
    [anon_sym_interface] = ACTIONS(4268),
    [anon_sym_delegate] = ACTIONS(4268),
    [anon_sym_record] = ACTIONS(4268),
    [anon_sym_namespace] = ACTIONS(4268),
    [anon_sym_var] = ACTIONS(4268),
    [sym_predefined_type] = ACTIONS(4268),
    [anon_sym_when] = ACTIONS(4268),
    [anon_sym_yield] = ACTIONS(4268),
    [anon_sym_from] = ACTIONS(4268),
    [anon_sym_join] = ACTIONS(4268),
    [anon_sym_on] = ACTIONS(4268),
    [anon_sym_equals] = ACTIONS(4268),
    [anon_sym_into] = ACTIONS(4268),
    [anon_sym_let] = ACTIONS(4268),
    [anon_sym_orderby] = ACTIONS(4268),
    [anon_sym_ascending] = ACTIONS(4268),
    [anon_sym_descending] = ACTIONS(4268),
    [anon_sym_group] = ACTIONS(4268),
    [anon_sym_by] = ACTIONS(4268),
    [anon_sym_select] = ACTIONS(4268),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4268),
    [anon_sym_nameof] = ACTIONS(4268),
    [sym_void_keyword] = ACTIONS(4268),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2392] = {
    [sym__preprocessor_call] = STATE(2392),
    [sym__identifier_token] = ACTIONS(4272),
    [anon_sym_extern] = ACTIONS(4272),
    [anon_sym_alias] = ACTIONS(4272),
    [anon_sym_global] = ACTIONS(4272),
    [anon_sym_using] = ACTIONS(4272),
    [anon_sym_static] = ACTIONS(4272),
    [anon_sym_LBRACK] = ACTIONS(4274),
    [anon_sym_event] = ACTIONS(4272),
    [anon_sym_LPAREN] = ACTIONS(4274),
    [anon_sym_abstract] = ACTIONS(4272),
    [anon_sym_async] = ACTIONS(4272),
    [anon_sym_const] = ACTIONS(4272),
    [anon_sym_fixed] = ACTIONS(4272),
    [anon_sym_internal] = ACTIONS(4272),
    [anon_sym_new] = ACTIONS(4272),
    [anon_sym_override] = ACTIONS(4272),
    [anon_sym_partial] = ACTIONS(4272),
    [anon_sym_private] = ACTIONS(4272),
    [anon_sym_protected] = ACTIONS(4272),
    [anon_sym_public] = ACTIONS(4272),
    [anon_sym_readonly] = ACTIONS(4272),
    [anon_sym_ref] = ACTIONS(4272),
    [anon_sym_sealed] = ACTIONS(4272),
    [anon_sym_unsafe] = ACTIONS(4272),
    [anon_sym_virtual] = ACTIONS(4272),
    [anon_sym_volatile] = ACTIONS(4272),
    [anon_sym_RBRACE] = ACTIONS(4274),
    [anon_sym_implicit] = ACTIONS(4272),
    [anon_sym_explicit] = ACTIONS(4272),
    [anon_sym_TILDE] = ACTIONS(4274),
    [anon_sym_where] = ACTIONS(4272),
    [anon_sym_class] = ACTIONS(4272),
    [anon_sym_struct] = ACTIONS(4272),
    [anon_sym_notnull] = ACTIONS(4272),
    [anon_sym_unmanaged] = ACTIONS(4272),
    [anon_sym_get] = ACTIONS(4272),
    [anon_sym_set] = ACTIONS(4272),
    [anon_sym_add] = ACTIONS(4272),
    [anon_sym_remove] = ACTIONS(4272),
    [anon_sym_enum] = ACTIONS(4272),
    [anon_sym_interface] = ACTIONS(4272),
    [anon_sym_delegate] = ACTIONS(4272),
    [anon_sym_record] = ACTIONS(4272),
    [anon_sym_namespace] = ACTIONS(4272),
    [anon_sym_var] = ACTIONS(4272),
    [sym_predefined_type] = ACTIONS(4272),
    [anon_sym_when] = ACTIONS(4272),
    [anon_sym_yield] = ACTIONS(4272),
    [anon_sym_from] = ACTIONS(4272),
    [anon_sym_join] = ACTIONS(4272),
    [anon_sym_on] = ACTIONS(4272),
    [anon_sym_equals] = ACTIONS(4272),
    [anon_sym_into] = ACTIONS(4272),
    [anon_sym_let] = ACTIONS(4272),
    [anon_sym_orderby] = ACTIONS(4272),
    [anon_sym_ascending] = ACTIONS(4272),
    [anon_sym_descending] = ACTIONS(4272),
    [anon_sym_group] = ACTIONS(4272),
    [anon_sym_by] = ACTIONS(4272),
    [anon_sym_select] = ACTIONS(4272),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4272),
    [anon_sym_nameof] = ACTIONS(4272),
    [sym_void_keyword] = ACTIONS(4272),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2393] = {
    [sym__preprocessor_call] = STATE(2393),
    [sym__identifier_token] = ACTIONS(4276),
    [anon_sym_extern] = ACTIONS(4276),
    [anon_sym_alias] = ACTIONS(4276),
    [anon_sym_global] = ACTIONS(4276),
    [anon_sym_using] = ACTIONS(4276),
    [anon_sym_static] = ACTIONS(4276),
    [anon_sym_LBRACK] = ACTIONS(4278),
    [anon_sym_event] = ACTIONS(4276),
    [anon_sym_LPAREN] = ACTIONS(4278),
    [anon_sym_abstract] = ACTIONS(4276),
    [anon_sym_async] = ACTIONS(4276),
    [anon_sym_const] = ACTIONS(4276),
    [anon_sym_fixed] = ACTIONS(4276),
    [anon_sym_internal] = ACTIONS(4276),
    [anon_sym_new] = ACTIONS(4276),
    [anon_sym_override] = ACTIONS(4276),
    [anon_sym_partial] = ACTIONS(4276),
    [anon_sym_private] = ACTIONS(4276),
    [anon_sym_protected] = ACTIONS(4276),
    [anon_sym_public] = ACTIONS(4276),
    [anon_sym_readonly] = ACTIONS(4276),
    [anon_sym_ref] = ACTIONS(4276),
    [anon_sym_sealed] = ACTIONS(4276),
    [anon_sym_unsafe] = ACTIONS(4276),
    [anon_sym_virtual] = ACTIONS(4276),
    [anon_sym_volatile] = ACTIONS(4276),
    [anon_sym_RBRACE] = ACTIONS(4278),
    [anon_sym_implicit] = ACTIONS(4276),
    [anon_sym_explicit] = ACTIONS(4276),
    [anon_sym_TILDE] = ACTIONS(4278),
    [anon_sym_where] = ACTIONS(4276),
    [anon_sym_class] = ACTIONS(4276),
    [anon_sym_struct] = ACTIONS(4276),
    [anon_sym_notnull] = ACTIONS(4276),
    [anon_sym_unmanaged] = ACTIONS(4276),
    [anon_sym_get] = ACTIONS(4276),
    [anon_sym_set] = ACTIONS(4276),
    [anon_sym_add] = ACTIONS(4276),
    [anon_sym_remove] = ACTIONS(4276),
    [anon_sym_enum] = ACTIONS(4276),
    [anon_sym_interface] = ACTIONS(4276),
    [anon_sym_delegate] = ACTIONS(4276),
    [anon_sym_record] = ACTIONS(4276),
    [anon_sym_namespace] = ACTIONS(4276),
    [anon_sym_var] = ACTIONS(4276),
    [sym_predefined_type] = ACTIONS(4276),
    [anon_sym_when] = ACTIONS(4276),
    [anon_sym_yield] = ACTIONS(4276),
    [anon_sym_from] = ACTIONS(4276),
    [anon_sym_join] = ACTIONS(4276),
    [anon_sym_on] = ACTIONS(4276),
    [anon_sym_equals] = ACTIONS(4276),
    [anon_sym_into] = ACTIONS(4276),
    [anon_sym_let] = ACTIONS(4276),
    [anon_sym_orderby] = ACTIONS(4276),
    [anon_sym_ascending] = ACTIONS(4276),
    [anon_sym_descending] = ACTIONS(4276),
    [anon_sym_group] = ACTIONS(4276),
    [anon_sym_by] = ACTIONS(4276),
    [anon_sym_select] = ACTIONS(4276),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4276),
    [anon_sym_nameof] = ACTIONS(4276),
    [sym_void_keyword] = ACTIONS(4276),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2394] = {
    [sym__preprocessor_call] = STATE(2394),
    [sym__identifier_token] = ACTIONS(4280),
    [anon_sym_extern] = ACTIONS(4280),
    [anon_sym_alias] = ACTIONS(4280),
    [anon_sym_global] = ACTIONS(4280),
    [anon_sym_using] = ACTIONS(4280),
    [anon_sym_static] = ACTIONS(4280),
    [anon_sym_LBRACK] = ACTIONS(4282),
    [anon_sym_event] = ACTIONS(4280),
    [anon_sym_LPAREN] = ACTIONS(4282),
    [anon_sym_abstract] = ACTIONS(4280),
    [anon_sym_async] = ACTIONS(4280),
    [anon_sym_const] = ACTIONS(4280),
    [anon_sym_fixed] = ACTIONS(4280),
    [anon_sym_internal] = ACTIONS(4280),
    [anon_sym_new] = ACTIONS(4280),
    [anon_sym_override] = ACTIONS(4280),
    [anon_sym_partial] = ACTIONS(4280),
    [anon_sym_private] = ACTIONS(4280),
    [anon_sym_protected] = ACTIONS(4280),
    [anon_sym_public] = ACTIONS(4280),
    [anon_sym_readonly] = ACTIONS(4280),
    [anon_sym_ref] = ACTIONS(4280),
    [anon_sym_sealed] = ACTIONS(4280),
    [anon_sym_unsafe] = ACTIONS(4280),
    [anon_sym_virtual] = ACTIONS(4280),
    [anon_sym_volatile] = ACTIONS(4280),
    [anon_sym_RBRACE] = ACTIONS(4282),
    [anon_sym_implicit] = ACTIONS(4280),
    [anon_sym_explicit] = ACTIONS(4280),
    [anon_sym_TILDE] = ACTIONS(4282),
    [anon_sym_where] = ACTIONS(4280),
    [anon_sym_class] = ACTIONS(4280),
    [anon_sym_struct] = ACTIONS(4280),
    [anon_sym_notnull] = ACTIONS(4280),
    [anon_sym_unmanaged] = ACTIONS(4280),
    [anon_sym_get] = ACTIONS(4280),
    [anon_sym_set] = ACTIONS(4280),
    [anon_sym_add] = ACTIONS(4280),
    [anon_sym_remove] = ACTIONS(4280),
    [anon_sym_enum] = ACTIONS(4280),
    [anon_sym_interface] = ACTIONS(4280),
    [anon_sym_delegate] = ACTIONS(4280),
    [anon_sym_record] = ACTIONS(4280),
    [anon_sym_namespace] = ACTIONS(4280),
    [anon_sym_var] = ACTIONS(4280),
    [sym_predefined_type] = ACTIONS(4280),
    [anon_sym_when] = ACTIONS(4280),
    [anon_sym_yield] = ACTIONS(4280),
    [anon_sym_from] = ACTIONS(4280),
    [anon_sym_join] = ACTIONS(4280),
    [anon_sym_on] = ACTIONS(4280),
    [anon_sym_equals] = ACTIONS(4280),
    [anon_sym_into] = ACTIONS(4280),
    [anon_sym_let] = ACTIONS(4280),
    [anon_sym_orderby] = ACTIONS(4280),
    [anon_sym_ascending] = ACTIONS(4280),
    [anon_sym_descending] = ACTIONS(4280),
    [anon_sym_group] = ACTIONS(4280),
    [anon_sym_by] = ACTIONS(4280),
    [anon_sym_select] = ACTIONS(4280),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4280),
    [anon_sym_nameof] = ACTIONS(4280),
    [sym_void_keyword] = ACTIONS(4280),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2395] = {
    [sym__preprocessor_call] = STATE(2395),
    [sym__identifier_token] = ACTIONS(4284),
    [anon_sym_extern] = ACTIONS(4284),
    [anon_sym_alias] = ACTIONS(4284),
    [anon_sym_global] = ACTIONS(4284),
    [anon_sym_using] = ACTIONS(4284),
    [anon_sym_static] = ACTIONS(4284),
    [anon_sym_LBRACK] = ACTIONS(4286),
    [anon_sym_event] = ACTIONS(4284),
    [anon_sym_LPAREN] = ACTIONS(4286),
    [anon_sym_abstract] = ACTIONS(4284),
    [anon_sym_async] = ACTIONS(4284),
    [anon_sym_const] = ACTIONS(4284),
    [anon_sym_fixed] = ACTIONS(4284),
    [anon_sym_internal] = ACTIONS(4284),
    [anon_sym_new] = ACTIONS(4284),
    [anon_sym_override] = ACTIONS(4284),
    [anon_sym_partial] = ACTIONS(4284),
    [anon_sym_private] = ACTIONS(4284),
    [anon_sym_protected] = ACTIONS(4284),
    [anon_sym_public] = ACTIONS(4284),
    [anon_sym_readonly] = ACTIONS(4284),
    [anon_sym_ref] = ACTIONS(4284),
    [anon_sym_sealed] = ACTIONS(4284),
    [anon_sym_unsafe] = ACTIONS(4284),
    [anon_sym_virtual] = ACTIONS(4284),
    [anon_sym_volatile] = ACTIONS(4284),
    [anon_sym_RBRACE] = ACTIONS(4286),
    [anon_sym_implicit] = ACTIONS(4284),
    [anon_sym_explicit] = ACTIONS(4284),
    [anon_sym_TILDE] = ACTIONS(4286),
    [anon_sym_where] = ACTIONS(4284),
    [anon_sym_class] = ACTIONS(4284),
    [anon_sym_struct] = ACTIONS(4284),
    [anon_sym_notnull] = ACTIONS(4284),
    [anon_sym_unmanaged] = ACTIONS(4284),
    [anon_sym_get] = ACTIONS(4284),
    [anon_sym_set] = ACTIONS(4284),
    [anon_sym_add] = ACTIONS(4284),
    [anon_sym_remove] = ACTIONS(4284),
    [anon_sym_enum] = ACTIONS(4284),
    [anon_sym_interface] = ACTIONS(4284),
    [anon_sym_delegate] = ACTIONS(4284),
    [anon_sym_record] = ACTIONS(4284),
    [anon_sym_namespace] = ACTIONS(4284),
    [anon_sym_var] = ACTIONS(4284),
    [sym_predefined_type] = ACTIONS(4284),
    [anon_sym_when] = ACTIONS(4284),
    [anon_sym_yield] = ACTIONS(4284),
    [anon_sym_from] = ACTIONS(4284),
    [anon_sym_join] = ACTIONS(4284),
    [anon_sym_on] = ACTIONS(4284),
    [anon_sym_equals] = ACTIONS(4284),
    [anon_sym_into] = ACTIONS(4284),
    [anon_sym_let] = ACTIONS(4284),
    [anon_sym_orderby] = ACTIONS(4284),
    [anon_sym_ascending] = ACTIONS(4284),
    [anon_sym_descending] = ACTIONS(4284),
    [anon_sym_group] = ACTIONS(4284),
    [anon_sym_by] = ACTIONS(4284),
    [anon_sym_select] = ACTIONS(4284),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4284),
    [anon_sym_nameof] = ACTIONS(4284),
    [sym_void_keyword] = ACTIONS(4284),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2396] = {
    [sym__preprocessor_call] = STATE(2396),
    [sym__identifier_token] = ACTIONS(4288),
    [anon_sym_extern] = ACTIONS(4288),
    [anon_sym_alias] = ACTIONS(4288),
    [anon_sym_global] = ACTIONS(4288),
    [anon_sym_using] = ACTIONS(4288),
    [anon_sym_static] = ACTIONS(4288),
    [anon_sym_LBRACK] = ACTIONS(4290),
    [anon_sym_event] = ACTIONS(4288),
    [anon_sym_LPAREN] = ACTIONS(4290),
    [anon_sym_abstract] = ACTIONS(4288),
    [anon_sym_async] = ACTIONS(4288),
    [anon_sym_const] = ACTIONS(4288),
    [anon_sym_fixed] = ACTIONS(4288),
    [anon_sym_internal] = ACTIONS(4288),
    [anon_sym_new] = ACTIONS(4288),
    [anon_sym_override] = ACTIONS(4288),
    [anon_sym_partial] = ACTIONS(4288),
    [anon_sym_private] = ACTIONS(4288),
    [anon_sym_protected] = ACTIONS(4288),
    [anon_sym_public] = ACTIONS(4288),
    [anon_sym_readonly] = ACTIONS(4288),
    [anon_sym_ref] = ACTIONS(4288),
    [anon_sym_sealed] = ACTIONS(4288),
    [anon_sym_unsafe] = ACTIONS(4288),
    [anon_sym_virtual] = ACTIONS(4288),
    [anon_sym_volatile] = ACTIONS(4288),
    [anon_sym_RBRACE] = ACTIONS(4290),
    [anon_sym_implicit] = ACTIONS(4288),
    [anon_sym_explicit] = ACTIONS(4288),
    [anon_sym_TILDE] = ACTIONS(4290),
    [anon_sym_where] = ACTIONS(4288),
    [anon_sym_class] = ACTIONS(4288),
    [anon_sym_struct] = ACTIONS(4288),
    [anon_sym_notnull] = ACTIONS(4288),
    [anon_sym_unmanaged] = ACTIONS(4288),
    [anon_sym_get] = ACTIONS(4288),
    [anon_sym_set] = ACTIONS(4288),
    [anon_sym_add] = ACTIONS(4288),
    [anon_sym_remove] = ACTIONS(4288),
    [anon_sym_enum] = ACTIONS(4288),
    [anon_sym_interface] = ACTIONS(4288),
    [anon_sym_delegate] = ACTIONS(4288),
    [anon_sym_record] = ACTIONS(4288),
    [anon_sym_namespace] = ACTIONS(4288),
    [anon_sym_var] = ACTIONS(4288),
    [sym_predefined_type] = ACTIONS(4288),
    [anon_sym_when] = ACTIONS(4288),
    [anon_sym_yield] = ACTIONS(4288),
    [anon_sym_from] = ACTIONS(4288),
    [anon_sym_join] = ACTIONS(4288),
    [anon_sym_on] = ACTIONS(4288),
    [anon_sym_equals] = ACTIONS(4288),
    [anon_sym_into] = ACTIONS(4288),
    [anon_sym_let] = ACTIONS(4288),
    [anon_sym_orderby] = ACTIONS(4288),
    [anon_sym_ascending] = ACTIONS(4288),
    [anon_sym_descending] = ACTIONS(4288),
    [anon_sym_group] = ACTIONS(4288),
    [anon_sym_by] = ACTIONS(4288),
    [anon_sym_select] = ACTIONS(4288),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4288),
    [anon_sym_nameof] = ACTIONS(4288),
    [sym_void_keyword] = ACTIONS(4288),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2397] = {
    [sym__preprocessor_call] = STATE(2397),
    [sym__identifier_token] = ACTIONS(4292),
    [anon_sym_extern] = ACTIONS(4292),
    [anon_sym_alias] = ACTIONS(4292),
    [anon_sym_global] = ACTIONS(4292),
    [anon_sym_using] = ACTIONS(4292),
    [anon_sym_static] = ACTIONS(4292),
    [anon_sym_LBRACK] = ACTIONS(4294),
    [anon_sym_event] = ACTIONS(4292),
    [anon_sym_LPAREN] = ACTIONS(4294),
    [anon_sym_abstract] = ACTIONS(4292),
    [anon_sym_async] = ACTIONS(4292),
    [anon_sym_const] = ACTIONS(4292),
    [anon_sym_fixed] = ACTIONS(4292),
    [anon_sym_internal] = ACTIONS(4292),
    [anon_sym_new] = ACTIONS(4292),
    [anon_sym_override] = ACTIONS(4292),
    [anon_sym_partial] = ACTIONS(4292),
    [anon_sym_private] = ACTIONS(4292),
    [anon_sym_protected] = ACTIONS(4292),
    [anon_sym_public] = ACTIONS(4292),
    [anon_sym_readonly] = ACTIONS(4292),
    [anon_sym_ref] = ACTIONS(4292),
    [anon_sym_sealed] = ACTIONS(4292),
    [anon_sym_unsafe] = ACTIONS(4292),
    [anon_sym_virtual] = ACTIONS(4292),
    [anon_sym_volatile] = ACTIONS(4292),
    [anon_sym_RBRACE] = ACTIONS(4294),
    [anon_sym_implicit] = ACTIONS(4292),
    [anon_sym_explicit] = ACTIONS(4292),
    [anon_sym_TILDE] = ACTIONS(4294),
    [anon_sym_where] = ACTIONS(4292),
    [anon_sym_class] = ACTIONS(4292),
    [anon_sym_struct] = ACTIONS(4292),
    [anon_sym_notnull] = ACTIONS(4292),
    [anon_sym_unmanaged] = ACTIONS(4292),
    [anon_sym_get] = ACTIONS(4292),
    [anon_sym_set] = ACTIONS(4292),
    [anon_sym_add] = ACTIONS(4292),
    [anon_sym_remove] = ACTIONS(4292),
    [anon_sym_enum] = ACTIONS(4292),
    [anon_sym_interface] = ACTIONS(4292),
    [anon_sym_delegate] = ACTIONS(4292),
    [anon_sym_record] = ACTIONS(4292),
    [anon_sym_namespace] = ACTIONS(4292),
    [anon_sym_var] = ACTIONS(4292),
    [sym_predefined_type] = ACTIONS(4292),
    [anon_sym_when] = ACTIONS(4292),
    [anon_sym_yield] = ACTIONS(4292),
    [anon_sym_from] = ACTIONS(4292),
    [anon_sym_join] = ACTIONS(4292),
    [anon_sym_on] = ACTIONS(4292),
    [anon_sym_equals] = ACTIONS(4292),
    [anon_sym_into] = ACTIONS(4292),
    [anon_sym_let] = ACTIONS(4292),
    [anon_sym_orderby] = ACTIONS(4292),
    [anon_sym_ascending] = ACTIONS(4292),
    [anon_sym_descending] = ACTIONS(4292),
    [anon_sym_group] = ACTIONS(4292),
    [anon_sym_by] = ACTIONS(4292),
    [anon_sym_select] = ACTIONS(4292),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4292),
    [anon_sym_nameof] = ACTIONS(4292),
    [sym_void_keyword] = ACTIONS(4292),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2398] = {
    [sym__preprocessor_call] = STATE(2398),
    [sym__identifier_token] = ACTIONS(4296),
    [anon_sym_extern] = ACTIONS(4296),
    [anon_sym_alias] = ACTIONS(4296),
    [anon_sym_global] = ACTIONS(4296),
    [anon_sym_using] = ACTIONS(4296),
    [anon_sym_static] = ACTIONS(4296),
    [anon_sym_LBRACK] = ACTIONS(4298),
    [anon_sym_event] = ACTIONS(4296),
    [anon_sym_LPAREN] = ACTIONS(4298),
    [anon_sym_abstract] = ACTIONS(4296),
    [anon_sym_async] = ACTIONS(4296),
    [anon_sym_const] = ACTIONS(4296),
    [anon_sym_fixed] = ACTIONS(4296),
    [anon_sym_internal] = ACTIONS(4296),
    [anon_sym_new] = ACTIONS(4296),
    [anon_sym_override] = ACTIONS(4296),
    [anon_sym_partial] = ACTIONS(4296),
    [anon_sym_private] = ACTIONS(4296),
    [anon_sym_protected] = ACTIONS(4296),
    [anon_sym_public] = ACTIONS(4296),
    [anon_sym_readonly] = ACTIONS(4296),
    [anon_sym_ref] = ACTIONS(4296),
    [anon_sym_sealed] = ACTIONS(4296),
    [anon_sym_unsafe] = ACTIONS(4296),
    [anon_sym_virtual] = ACTIONS(4296),
    [anon_sym_volatile] = ACTIONS(4296),
    [anon_sym_RBRACE] = ACTIONS(4298),
    [anon_sym_implicit] = ACTIONS(4296),
    [anon_sym_explicit] = ACTIONS(4296),
    [anon_sym_TILDE] = ACTIONS(4298),
    [anon_sym_where] = ACTIONS(4296),
    [anon_sym_class] = ACTIONS(4296),
    [anon_sym_struct] = ACTIONS(4296),
    [anon_sym_notnull] = ACTIONS(4296),
    [anon_sym_unmanaged] = ACTIONS(4296),
    [anon_sym_get] = ACTIONS(4296),
    [anon_sym_set] = ACTIONS(4296),
    [anon_sym_add] = ACTIONS(4296),
    [anon_sym_remove] = ACTIONS(4296),
    [anon_sym_enum] = ACTIONS(4296),
    [anon_sym_interface] = ACTIONS(4296),
    [anon_sym_delegate] = ACTIONS(4296),
    [anon_sym_record] = ACTIONS(4296),
    [anon_sym_namespace] = ACTIONS(4296),
    [anon_sym_var] = ACTIONS(4296),
    [sym_predefined_type] = ACTIONS(4296),
    [anon_sym_when] = ACTIONS(4296),
    [anon_sym_yield] = ACTIONS(4296),
    [anon_sym_from] = ACTIONS(4296),
    [anon_sym_join] = ACTIONS(4296),
    [anon_sym_on] = ACTIONS(4296),
    [anon_sym_equals] = ACTIONS(4296),
    [anon_sym_into] = ACTIONS(4296),
    [anon_sym_let] = ACTIONS(4296),
    [anon_sym_orderby] = ACTIONS(4296),
    [anon_sym_ascending] = ACTIONS(4296),
    [anon_sym_descending] = ACTIONS(4296),
    [anon_sym_group] = ACTIONS(4296),
    [anon_sym_by] = ACTIONS(4296),
    [anon_sym_select] = ACTIONS(4296),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4296),
    [anon_sym_nameof] = ACTIONS(4296),
    [sym_void_keyword] = ACTIONS(4296),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2399] = {
    [sym__preprocessor_call] = STATE(2399),
    [sym__identifier_token] = ACTIONS(4300),
    [anon_sym_extern] = ACTIONS(4300),
    [anon_sym_alias] = ACTIONS(4300),
    [anon_sym_global] = ACTIONS(4300),
    [anon_sym_using] = ACTIONS(4300),
    [anon_sym_static] = ACTIONS(4300),
    [anon_sym_LBRACK] = ACTIONS(4302),
    [anon_sym_event] = ACTIONS(4300),
    [anon_sym_LPAREN] = ACTIONS(4302),
    [anon_sym_abstract] = ACTIONS(4300),
    [anon_sym_async] = ACTIONS(4300),
    [anon_sym_const] = ACTIONS(4300),
    [anon_sym_fixed] = ACTIONS(4300),
    [anon_sym_internal] = ACTIONS(4300),
    [anon_sym_new] = ACTIONS(4300),
    [anon_sym_override] = ACTIONS(4300),
    [anon_sym_partial] = ACTIONS(4300),
    [anon_sym_private] = ACTIONS(4300),
    [anon_sym_protected] = ACTIONS(4300),
    [anon_sym_public] = ACTIONS(4300),
    [anon_sym_readonly] = ACTIONS(4300),
    [anon_sym_ref] = ACTIONS(4300),
    [anon_sym_sealed] = ACTIONS(4300),
    [anon_sym_unsafe] = ACTIONS(4300),
    [anon_sym_virtual] = ACTIONS(4300),
    [anon_sym_volatile] = ACTIONS(4300),
    [anon_sym_RBRACE] = ACTIONS(4302),
    [anon_sym_implicit] = ACTIONS(4300),
    [anon_sym_explicit] = ACTIONS(4300),
    [anon_sym_TILDE] = ACTIONS(4302),
    [anon_sym_where] = ACTIONS(4300),
    [anon_sym_class] = ACTIONS(4300),
    [anon_sym_struct] = ACTIONS(4300),
    [anon_sym_notnull] = ACTIONS(4300),
    [anon_sym_unmanaged] = ACTIONS(4300),
    [anon_sym_get] = ACTIONS(4300),
    [anon_sym_set] = ACTIONS(4300),
    [anon_sym_add] = ACTIONS(4300),
    [anon_sym_remove] = ACTIONS(4300),
    [anon_sym_enum] = ACTIONS(4300),
    [anon_sym_interface] = ACTIONS(4300),
    [anon_sym_delegate] = ACTIONS(4300),
    [anon_sym_record] = ACTIONS(4300),
    [anon_sym_namespace] = ACTIONS(4300),
    [anon_sym_var] = ACTIONS(4300),
    [sym_predefined_type] = ACTIONS(4300),
    [anon_sym_when] = ACTIONS(4300),
    [anon_sym_yield] = ACTIONS(4300),
    [anon_sym_from] = ACTIONS(4300),
    [anon_sym_join] = ACTIONS(4300),
    [anon_sym_on] = ACTIONS(4300),
    [anon_sym_equals] = ACTIONS(4300),
    [anon_sym_into] = ACTIONS(4300),
    [anon_sym_let] = ACTIONS(4300),
    [anon_sym_orderby] = ACTIONS(4300),
    [anon_sym_ascending] = ACTIONS(4300),
    [anon_sym_descending] = ACTIONS(4300),
    [anon_sym_group] = ACTIONS(4300),
    [anon_sym_by] = ACTIONS(4300),
    [anon_sym_select] = ACTIONS(4300),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4300),
    [anon_sym_nameof] = ACTIONS(4300),
    [sym_void_keyword] = ACTIONS(4300),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2400] = {
    [sym__preprocessor_call] = STATE(2400),
    [sym__identifier_token] = ACTIONS(4304),
    [anon_sym_extern] = ACTIONS(4304),
    [anon_sym_alias] = ACTIONS(4304),
    [anon_sym_global] = ACTIONS(4304),
    [anon_sym_using] = ACTIONS(4304),
    [anon_sym_static] = ACTIONS(4304),
    [anon_sym_LBRACK] = ACTIONS(4306),
    [anon_sym_event] = ACTIONS(4304),
    [anon_sym_LPAREN] = ACTIONS(4306),
    [anon_sym_abstract] = ACTIONS(4304),
    [anon_sym_async] = ACTIONS(4304),
    [anon_sym_const] = ACTIONS(4304),
    [anon_sym_fixed] = ACTIONS(4304),
    [anon_sym_internal] = ACTIONS(4304),
    [anon_sym_new] = ACTIONS(4304),
    [anon_sym_override] = ACTIONS(4304),
    [anon_sym_partial] = ACTIONS(4304),
    [anon_sym_private] = ACTIONS(4304),
    [anon_sym_protected] = ACTIONS(4304),
    [anon_sym_public] = ACTIONS(4304),
    [anon_sym_readonly] = ACTIONS(4304),
    [anon_sym_ref] = ACTIONS(4304),
    [anon_sym_sealed] = ACTIONS(4304),
    [anon_sym_unsafe] = ACTIONS(4304),
    [anon_sym_virtual] = ACTIONS(4304),
    [anon_sym_volatile] = ACTIONS(4304),
    [anon_sym_RBRACE] = ACTIONS(4306),
    [anon_sym_implicit] = ACTIONS(4304),
    [anon_sym_explicit] = ACTIONS(4304),
    [anon_sym_TILDE] = ACTIONS(4306),
    [anon_sym_where] = ACTIONS(4304),
    [anon_sym_class] = ACTIONS(4304),
    [anon_sym_struct] = ACTIONS(4304),
    [anon_sym_notnull] = ACTIONS(4304),
    [anon_sym_unmanaged] = ACTIONS(4304),
    [anon_sym_get] = ACTIONS(4304),
    [anon_sym_set] = ACTIONS(4304),
    [anon_sym_add] = ACTIONS(4304),
    [anon_sym_remove] = ACTIONS(4304),
    [anon_sym_enum] = ACTIONS(4304),
    [anon_sym_interface] = ACTIONS(4304),
    [anon_sym_delegate] = ACTIONS(4304),
    [anon_sym_record] = ACTIONS(4304),
    [anon_sym_namespace] = ACTIONS(4304),
    [anon_sym_var] = ACTIONS(4304),
    [sym_predefined_type] = ACTIONS(4304),
    [anon_sym_when] = ACTIONS(4304),
    [anon_sym_yield] = ACTIONS(4304),
    [anon_sym_from] = ACTIONS(4304),
    [anon_sym_join] = ACTIONS(4304),
    [anon_sym_on] = ACTIONS(4304),
    [anon_sym_equals] = ACTIONS(4304),
    [anon_sym_into] = ACTIONS(4304),
    [anon_sym_let] = ACTIONS(4304),
    [anon_sym_orderby] = ACTIONS(4304),
    [anon_sym_ascending] = ACTIONS(4304),
    [anon_sym_descending] = ACTIONS(4304),
    [anon_sym_group] = ACTIONS(4304),
    [anon_sym_by] = ACTIONS(4304),
    [anon_sym_select] = ACTIONS(4304),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4304),
    [anon_sym_nameof] = ACTIONS(4304),
    [sym_void_keyword] = ACTIONS(4304),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2401] = {
    [sym__preprocessor_call] = STATE(2401),
    [sym__identifier_token] = ACTIONS(4308),
    [anon_sym_extern] = ACTIONS(4308),
    [anon_sym_alias] = ACTIONS(4308),
    [anon_sym_global] = ACTIONS(4308),
    [anon_sym_using] = ACTIONS(4308),
    [anon_sym_static] = ACTIONS(4308),
    [anon_sym_LBRACK] = ACTIONS(4310),
    [anon_sym_event] = ACTIONS(4308),
    [anon_sym_LPAREN] = ACTIONS(4310),
    [anon_sym_abstract] = ACTIONS(4308),
    [anon_sym_async] = ACTIONS(4308),
    [anon_sym_const] = ACTIONS(4308),
    [anon_sym_fixed] = ACTIONS(4308),
    [anon_sym_internal] = ACTIONS(4308),
    [anon_sym_new] = ACTIONS(4308),
    [anon_sym_override] = ACTIONS(4308),
    [anon_sym_partial] = ACTIONS(4308),
    [anon_sym_private] = ACTIONS(4308),
    [anon_sym_protected] = ACTIONS(4308),
    [anon_sym_public] = ACTIONS(4308),
    [anon_sym_readonly] = ACTIONS(4308),
    [anon_sym_ref] = ACTIONS(4308),
    [anon_sym_sealed] = ACTIONS(4308),
    [anon_sym_unsafe] = ACTIONS(4308),
    [anon_sym_virtual] = ACTIONS(4308),
    [anon_sym_volatile] = ACTIONS(4308),
    [anon_sym_RBRACE] = ACTIONS(4310),
    [anon_sym_implicit] = ACTIONS(4308),
    [anon_sym_explicit] = ACTIONS(4308),
    [anon_sym_TILDE] = ACTIONS(4310),
    [anon_sym_where] = ACTIONS(4308),
    [anon_sym_class] = ACTIONS(4308),
    [anon_sym_struct] = ACTIONS(4308),
    [anon_sym_notnull] = ACTIONS(4308),
    [anon_sym_unmanaged] = ACTIONS(4308),
    [anon_sym_get] = ACTIONS(4308),
    [anon_sym_set] = ACTIONS(4308),
    [anon_sym_add] = ACTIONS(4308),
    [anon_sym_remove] = ACTIONS(4308),
    [anon_sym_enum] = ACTIONS(4308),
    [anon_sym_interface] = ACTIONS(4308),
    [anon_sym_delegate] = ACTIONS(4308),
    [anon_sym_record] = ACTIONS(4308),
    [anon_sym_namespace] = ACTIONS(4308),
    [anon_sym_var] = ACTIONS(4308),
    [sym_predefined_type] = ACTIONS(4308),
    [anon_sym_when] = ACTIONS(4308),
    [anon_sym_yield] = ACTIONS(4308),
    [anon_sym_from] = ACTIONS(4308),
    [anon_sym_join] = ACTIONS(4308),
    [anon_sym_on] = ACTIONS(4308),
    [anon_sym_equals] = ACTIONS(4308),
    [anon_sym_into] = ACTIONS(4308),
    [anon_sym_let] = ACTIONS(4308),
    [anon_sym_orderby] = ACTIONS(4308),
    [anon_sym_ascending] = ACTIONS(4308),
    [anon_sym_descending] = ACTIONS(4308),
    [anon_sym_group] = ACTIONS(4308),
    [anon_sym_by] = ACTIONS(4308),
    [anon_sym_select] = ACTIONS(4308),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4308),
    [anon_sym_nameof] = ACTIONS(4308),
    [sym_void_keyword] = ACTIONS(4308),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2402] = {
    [sym__preprocessor_call] = STATE(2402),
    [sym__identifier_token] = ACTIONS(4312),
    [anon_sym_extern] = ACTIONS(4312),
    [anon_sym_alias] = ACTIONS(4312),
    [anon_sym_global] = ACTIONS(4312),
    [anon_sym_using] = ACTIONS(4312),
    [anon_sym_static] = ACTIONS(4312),
    [anon_sym_LBRACK] = ACTIONS(4314),
    [anon_sym_event] = ACTIONS(4312),
    [anon_sym_LPAREN] = ACTIONS(4314),
    [anon_sym_abstract] = ACTIONS(4312),
    [anon_sym_async] = ACTIONS(4312),
    [anon_sym_const] = ACTIONS(4312),
    [anon_sym_fixed] = ACTIONS(4312),
    [anon_sym_internal] = ACTIONS(4312),
    [anon_sym_new] = ACTIONS(4312),
    [anon_sym_override] = ACTIONS(4312),
    [anon_sym_partial] = ACTIONS(4312),
    [anon_sym_private] = ACTIONS(4312),
    [anon_sym_protected] = ACTIONS(4312),
    [anon_sym_public] = ACTIONS(4312),
    [anon_sym_readonly] = ACTIONS(4312),
    [anon_sym_ref] = ACTIONS(4312),
    [anon_sym_sealed] = ACTIONS(4312),
    [anon_sym_unsafe] = ACTIONS(4312),
    [anon_sym_virtual] = ACTIONS(4312),
    [anon_sym_volatile] = ACTIONS(4312),
    [anon_sym_RBRACE] = ACTIONS(4314),
    [anon_sym_implicit] = ACTIONS(4312),
    [anon_sym_explicit] = ACTIONS(4312),
    [anon_sym_TILDE] = ACTIONS(4314),
    [anon_sym_where] = ACTIONS(4312),
    [anon_sym_class] = ACTIONS(4312),
    [anon_sym_struct] = ACTIONS(4312),
    [anon_sym_notnull] = ACTIONS(4312),
    [anon_sym_unmanaged] = ACTIONS(4312),
    [anon_sym_get] = ACTIONS(4312),
    [anon_sym_set] = ACTIONS(4312),
    [anon_sym_add] = ACTIONS(4312),
    [anon_sym_remove] = ACTIONS(4312),
    [anon_sym_enum] = ACTIONS(4312),
    [anon_sym_interface] = ACTIONS(4312),
    [anon_sym_delegate] = ACTIONS(4312),
    [anon_sym_record] = ACTIONS(4312),
    [anon_sym_namespace] = ACTIONS(4312),
    [anon_sym_var] = ACTIONS(4312),
    [sym_predefined_type] = ACTIONS(4312),
    [anon_sym_when] = ACTIONS(4312),
    [anon_sym_yield] = ACTIONS(4312),
    [anon_sym_from] = ACTIONS(4312),
    [anon_sym_join] = ACTIONS(4312),
    [anon_sym_on] = ACTIONS(4312),
    [anon_sym_equals] = ACTIONS(4312),
    [anon_sym_into] = ACTIONS(4312),
    [anon_sym_let] = ACTIONS(4312),
    [anon_sym_orderby] = ACTIONS(4312),
    [anon_sym_ascending] = ACTIONS(4312),
    [anon_sym_descending] = ACTIONS(4312),
    [anon_sym_group] = ACTIONS(4312),
    [anon_sym_by] = ACTIONS(4312),
    [anon_sym_select] = ACTIONS(4312),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4312),
    [anon_sym_nameof] = ACTIONS(4312),
    [sym_void_keyword] = ACTIONS(4312),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2403] = {
    [sym__preprocessor_call] = STATE(2403),
    [sym__identifier_token] = ACTIONS(4316),
    [anon_sym_extern] = ACTIONS(4316),
    [anon_sym_alias] = ACTIONS(4316),
    [anon_sym_global] = ACTIONS(4316),
    [anon_sym_using] = ACTIONS(4316),
    [anon_sym_static] = ACTIONS(4316),
    [anon_sym_LBRACK] = ACTIONS(4318),
    [anon_sym_event] = ACTIONS(4316),
    [anon_sym_LPAREN] = ACTIONS(4318),
    [anon_sym_abstract] = ACTIONS(4316),
    [anon_sym_async] = ACTIONS(4316),
    [anon_sym_const] = ACTIONS(4316),
    [anon_sym_fixed] = ACTIONS(4316),
    [anon_sym_internal] = ACTIONS(4316),
    [anon_sym_new] = ACTIONS(4316),
    [anon_sym_override] = ACTIONS(4316),
    [anon_sym_partial] = ACTIONS(4316),
    [anon_sym_private] = ACTIONS(4316),
    [anon_sym_protected] = ACTIONS(4316),
    [anon_sym_public] = ACTIONS(4316),
    [anon_sym_readonly] = ACTIONS(4316),
    [anon_sym_ref] = ACTIONS(4316),
    [anon_sym_sealed] = ACTIONS(4316),
    [anon_sym_unsafe] = ACTIONS(4316),
    [anon_sym_virtual] = ACTIONS(4316),
    [anon_sym_volatile] = ACTIONS(4316),
    [anon_sym_RBRACE] = ACTIONS(4318),
    [anon_sym_implicit] = ACTIONS(4316),
    [anon_sym_explicit] = ACTIONS(4316),
    [anon_sym_TILDE] = ACTIONS(4318),
    [anon_sym_where] = ACTIONS(4316),
    [anon_sym_class] = ACTIONS(4316),
    [anon_sym_struct] = ACTIONS(4316),
    [anon_sym_notnull] = ACTIONS(4316),
    [anon_sym_unmanaged] = ACTIONS(4316),
    [anon_sym_get] = ACTIONS(4316),
    [anon_sym_set] = ACTIONS(4316),
    [anon_sym_add] = ACTIONS(4316),
    [anon_sym_remove] = ACTIONS(4316),
    [anon_sym_enum] = ACTIONS(4316),
    [anon_sym_interface] = ACTIONS(4316),
    [anon_sym_delegate] = ACTIONS(4316),
    [anon_sym_record] = ACTIONS(4316),
    [anon_sym_namespace] = ACTIONS(4316),
    [anon_sym_var] = ACTIONS(4316),
    [sym_predefined_type] = ACTIONS(4316),
    [anon_sym_when] = ACTIONS(4316),
    [anon_sym_yield] = ACTIONS(4316),
    [anon_sym_from] = ACTIONS(4316),
    [anon_sym_join] = ACTIONS(4316),
    [anon_sym_on] = ACTIONS(4316),
    [anon_sym_equals] = ACTIONS(4316),
    [anon_sym_into] = ACTIONS(4316),
    [anon_sym_let] = ACTIONS(4316),
    [anon_sym_orderby] = ACTIONS(4316),
    [anon_sym_ascending] = ACTIONS(4316),
    [anon_sym_descending] = ACTIONS(4316),
    [anon_sym_group] = ACTIONS(4316),
    [anon_sym_by] = ACTIONS(4316),
    [anon_sym_select] = ACTIONS(4316),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4316),
    [anon_sym_nameof] = ACTIONS(4316),
    [sym_void_keyword] = ACTIONS(4316),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2404] = {
    [sym__preprocessor_call] = STATE(2404),
    [sym__identifier_token] = ACTIONS(4320),
    [anon_sym_extern] = ACTIONS(4320),
    [anon_sym_alias] = ACTIONS(4320),
    [anon_sym_global] = ACTIONS(4320),
    [anon_sym_using] = ACTIONS(4320),
    [anon_sym_static] = ACTIONS(4320),
    [anon_sym_LBRACK] = ACTIONS(4322),
    [anon_sym_event] = ACTIONS(4320),
    [anon_sym_LPAREN] = ACTIONS(4322),
    [anon_sym_abstract] = ACTIONS(4320),
    [anon_sym_async] = ACTIONS(4320),
    [anon_sym_const] = ACTIONS(4320),
    [anon_sym_fixed] = ACTIONS(4320),
    [anon_sym_internal] = ACTIONS(4320),
    [anon_sym_new] = ACTIONS(4320),
    [anon_sym_override] = ACTIONS(4320),
    [anon_sym_partial] = ACTIONS(4320),
    [anon_sym_private] = ACTIONS(4320),
    [anon_sym_protected] = ACTIONS(4320),
    [anon_sym_public] = ACTIONS(4320),
    [anon_sym_readonly] = ACTIONS(4320),
    [anon_sym_ref] = ACTIONS(4320),
    [anon_sym_sealed] = ACTIONS(4320),
    [anon_sym_unsafe] = ACTIONS(4320),
    [anon_sym_virtual] = ACTIONS(4320),
    [anon_sym_volatile] = ACTIONS(4320),
    [anon_sym_RBRACE] = ACTIONS(4322),
    [anon_sym_implicit] = ACTIONS(4320),
    [anon_sym_explicit] = ACTIONS(4320),
    [anon_sym_TILDE] = ACTIONS(4322),
    [anon_sym_where] = ACTIONS(4320),
    [anon_sym_class] = ACTIONS(4320),
    [anon_sym_struct] = ACTIONS(4320),
    [anon_sym_notnull] = ACTIONS(4320),
    [anon_sym_unmanaged] = ACTIONS(4320),
    [anon_sym_get] = ACTIONS(4320),
    [anon_sym_set] = ACTIONS(4320),
    [anon_sym_add] = ACTIONS(4320),
    [anon_sym_remove] = ACTIONS(4320),
    [anon_sym_enum] = ACTIONS(4320),
    [anon_sym_interface] = ACTIONS(4320),
    [anon_sym_delegate] = ACTIONS(4320),
    [anon_sym_record] = ACTIONS(4320),
    [anon_sym_namespace] = ACTIONS(4320),
    [anon_sym_var] = ACTIONS(4320),
    [sym_predefined_type] = ACTIONS(4320),
    [anon_sym_when] = ACTIONS(4320),
    [anon_sym_yield] = ACTIONS(4320),
    [anon_sym_from] = ACTIONS(4320),
    [anon_sym_join] = ACTIONS(4320),
    [anon_sym_on] = ACTIONS(4320),
    [anon_sym_equals] = ACTIONS(4320),
    [anon_sym_into] = ACTIONS(4320),
    [anon_sym_let] = ACTIONS(4320),
    [anon_sym_orderby] = ACTIONS(4320),
    [anon_sym_ascending] = ACTIONS(4320),
    [anon_sym_descending] = ACTIONS(4320),
    [anon_sym_group] = ACTIONS(4320),
    [anon_sym_by] = ACTIONS(4320),
    [anon_sym_select] = ACTIONS(4320),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4320),
    [anon_sym_nameof] = ACTIONS(4320),
    [sym_void_keyword] = ACTIONS(4320),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2405] = {
    [sym__preprocessor_call] = STATE(2405),
    [sym__identifier_token] = ACTIONS(4324),
    [anon_sym_extern] = ACTIONS(4324),
    [anon_sym_alias] = ACTIONS(4324),
    [anon_sym_global] = ACTIONS(4324),
    [anon_sym_using] = ACTIONS(4324),
    [anon_sym_static] = ACTIONS(4324),
    [anon_sym_LBRACK] = ACTIONS(4326),
    [anon_sym_event] = ACTIONS(4324),
    [anon_sym_LPAREN] = ACTIONS(4326),
    [anon_sym_abstract] = ACTIONS(4324),
    [anon_sym_async] = ACTIONS(4324),
    [anon_sym_const] = ACTIONS(4324),
    [anon_sym_fixed] = ACTIONS(4324),
    [anon_sym_internal] = ACTIONS(4324),
    [anon_sym_new] = ACTIONS(4324),
    [anon_sym_override] = ACTIONS(4324),
    [anon_sym_partial] = ACTIONS(4324),
    [anon_sym_private] = ACTIONS(4324),
    [anon_sym_protected] = ACTIONS(4324),
    [anon_sym_public] = ACTIONS(4324),
    [anon_sym_readonly] = ACTIONS(4324),
    [anon_sym_ref] = ACTIONS(4324),
    [anon_sym_sealed] = ACTIONS(4324),
    [anon_sym_unsafe] = ACTIONS(4324),
    [anon_sym_virtual] = ACTIONS(4324),
    [anon_sym_volatile] = ACTIONS(4324),
    [anon_sym_RBRACE] = ACTIONS(4326),
    [anon_sym_implicit] = ACTIONS(4324),
    [anon_sym_explicit] = ACTIONS(4324),
    [anon_sym_TILDE] = ACTIONS(4326),
    [anon_sym_where] = ACTIONS(4324),
    [anon_sym_class] = ACTIONS(4324),
    [anon_sym_struct] = ACTIONS(4324),
    [anon_sym_notnull] = ACTIONS(4324),
    [anon_sym_unmanaged] = ACTIONS(4324),
    [anon_sym_get] = ACTIONS(4324),
    [anon_sym_set] = ACTIONS(4324),
    [anon_sym_add] = ACTIONS(4324),
    [anon_sym_remove] = ACTIONS(4324),
    [anon_sym_enum] = ACTIONS(4324),
    [anon_sym_interface] = ACTIONS(4324),
    [anon_sym_delegate] = ACTIONS(4324),
    [anon_sym_record] = ACTIONS(4324),
    [anon_sym_namespace] = ACTIONS(4324),
    [anon_sym_var] = ACTIONS(4324),
    [sym_predefined_type] = ACTIONS(4324),
    [anon_sym_when] = ACTIONS(4324),
    [anon_sym_yield] = ACTIONS(4324),
    [anon_sym_from] = ACTIONS(4324),
    [anon_sym_join] = ACTIONS(4324),
    [anon_sym_on] = ACTIONS(4324),
    [anon_sym_equals] = ACTIONS(4324),
    [anon_sym_into] = ACTIONS(4324),
    [anon_sym_let] = ACTIONS(4324),
    [anon_sym_orderby] = ACTIONS(4324),
    [anon_sym_ascending] = ACTIONS(4324),
    [anon_sym_descending] = ACTIONS(4324),
    [anon_sym_group] = ACTIONS(4324),
    [anon_sym_by] = ACTIONS(4324),
    [anon_sym_select] = ACTIONS(4324),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4324),
    [anon_sym_nameof] = ACTIONS(4324),
    [sym_void_keyword] = ACTIONS(4324),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2406] = {
    [sym__preprocessor_call] = STATE(2406),
    [sym__identifier_token] = ACTIONS(4328),
    [anon_sym_extern] = ACTIONS(4328),
    [anon_sym_alias] = ACTIONS(4328),
    [anon_sym_global] = ACTIONS(4328),
    [anon_sym_using] = ACTIONS(4328),
    [anon_sym_static] = ACTIONS(4328),
    [anon_sym_LBRACK] = ACTIONS(4330),
    [anon_sym_event] = ACTIONS(4328),
    [anon_sym_LPAREN] = ACTIONS(4330),
    [anon_sym_abstract] = ACTIONS(4328),
    [anon_sym_async] = ACTIONS(4328),
    [anon_sym_const] = ACTIONS(4328),
    [anon_sym_fixed] = ACTIONS(4328),
    [anon_sym_internal] = ACTIONS(4328),
    [anon_sym_new] = ACTIONS(4328),
    [anon_sym_override] = ACTIONS(4328),
    [anon_sym_partial] = ACTIONS(4328),
    [anon_sym_private] = ACTIONS(4328),
    [anon_sym_protected] = ACTIONS(4328),
    [anon_sym_public] = ACTIONS(4328),
    [anon_sym_readonly] = ACTIONS(4328),
    [anon_sym_ref] = ACTIONS(4328),
    [anon_sym_sealed] = ACTIONS(4328),
    [anon_sym_unsafe] = ACTIONS(4328),
    [anon_sym_virtual] = ACTIONS(4328),
    [anon_sym_volatile] = ACTIONS(4328),
    [anon_sym_RBRACE] = ACTIONS(4330),
    [anon_sym_implicit] = ACTIONS(4328),
    [anon_sym_explicit] = ACTIONS(4328),
    [anon_sym_TILDE] = ACTIONS(4330),
    [anon_sym_where] = ACTIONS(4328),
    [anon_sym_class] = ACTIONS(4328),
    [anon_sym_struct] = ACTIONS(4328),
    [anon_sym_notnull] = ACTIONS(4328),
    [anon_sym_unmanaged] = ACTIONS(4328),
    [anon_sym_get] = ACTIONS(4328),
    [anon_sym_set] = ACTIONS(4328),
    [anon_sym_add] = ACTIONS(4328),
    [anon_sym_remove] = ACTIONS(4328),
    [anon_sym_enum] = ACTIONS(4328),
    [anon_sym_interface] = ACTIONS(4328),
    [anon_sym_delegate] = ACTIONS(4328),
    [anon_sym_record] = ACTIONS(4328),
    [anon_sym_namespace] = ACTIONS(4328),
    [anon_sym_var] = ACTIONS(4328),
    [sym_predefined_type] = ACTIONS(4328),
    [anon_sym_when] = ACTIONS(4328),
    [anon_sym_yield] = ACTIONS(4328),
    [anon_sym_from] = ACTIONS(4328),
    [anon_sym_join] = ACTIONS(4328),
    [anon_sym_on] = ACTIONS(4328),
    [anon_sym_equals] = ACTIONS(4328),
    [anon_sym_into] = ACTIONS(4328),
    [anon_sym_let] = ACTIONS(4328),
    [anon_sym_orderby] = ACTIONS(4328),
    [anon_sym_ascending] = ACTIONS(4328),
    [anon_sym_descending] = ACTIONS(4328),
    [anon_sym_group] = ACTIONS(4328),
    [anon_sym_by] = ACTIONS(4328),
    [anon_sym_select] = ACTIONS(4328),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4328),
    [anon_sym_nameof] = ACTIONS(4328),
    [sym_void_keyword] = ACTIONS(4328),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2407] = {
    [sym__preprocessor_call] = STATE(2407),
    [sym__identifier_token] = ACTIONS(2550),
    [anon_sym_extern] = ACTIONS(2550),
    [anon_sym_alias] = ACTIONS(2550),
    [anon_sym_global] = ACTIONS(2550),
    [anon_sym_using] = ACTIONS(2550),
    [anon_sym_static] = ACTIONS(2550),
    [anon_sym_LBRACK] = ACTIONS(2548),
    [anon_sym_event] = ACTIONS(2550),
    [anon_sym_LPAREN] = ACTIONS(2548),
    [anon_sym_abstract] = ACTIONS(2550),
    [anon_sym_async] = ACTIONS(2550),
    [anon_sym_const] = ACTIONS(2550),
    [anon_sym_fixed] = ACTIONS(2550),
    [anon_sym_internal] = ACTIONS(2550),
    [anon_sym_new] = ACTIONS(2550),
    [anon_sym_override] = ACTIONS(2550),
    [anon_sym_partial] = ACTIONS(2550),
    [anon_sym_private] = ACTIONS(2550),
    [anon_sym_protected] = ACTIONS(2550),
    [anon_sym_public] = ACTIONS(2550),
    [anon_sym_readonly] = ACTIONS(2550),
    [anon_sym_ref] = ACTIONS(2550),
    [anon_sym_sealed] = ACTIONS(2550),
    [anon_sym_unsafe] = ACTIONS(2550),
    [anon_sym_virtual] = ACTIONS(2550),
    [anon_sym_volatile] = ACTIONS(2550),
    [anon_sym_RBRACE] = ACTIONS(2548),
    [anon_sym_implicit] = ACTIONS(2550),
    [anon_sym_explicit] = ACTIONS(2550),
    [anon_sym_TILDE] = ACTIONS(2548),
    [anon_sym_where] = ACTIONS(2550),
    [anon_sym_class] = ACTIONS(2550),
    [anon_sym_struct] = ACTIONS(2550),
    [anon_sym_notnull] = ACTIONS(2550),
    [anon_sym_unmanaged] = ACTIONS(2550),
    [anon_sym_get] = ACTIONS(2550),
    [anon_sym_set] = ACTIONS(2550),
    [anon_sym_add] = ACTIONS(2550),
    [anon_sym_remove] = ACTIONS(2550),
    [anon_sym_enum] = ACTIONS(2550),
    [anon_sym_interface] = ACTIONS(2550),
    [anon_sym_delegate] = ACTIONS(2550),
    [anon_sym_record] = ACTIONS(2550),
    [anon_sym_namespace] = ACTIONS(2550),
    [anon_sym_var] = ACTIONS(2550),
    [sym_predefined_type] = ACTIONS(2550),
    [anon_sym_when] = ACTIONS(2550),
    [anon_sym_yield] = ACTIONS(2550),
    [anon_sym_from] = ACTIONS(2550),
    [anon_sym_join] = ACTIONS(2550),
    [anon_sym_on] = ACTIONS(2550),
    [anon_sym_equals] = ACTIONS(2550),
    [anon_sym_into] = ACTIONS(2550),
    [anon_sym_let] = ACTIONS(2550),
    [anon_sym_orderby] = ACTIONS(2550),
    [anon_sym_ascending] = ACTIONS(2550),
    [anon_sym_descending] = ACTIONS(2550),
    [anon_sym_group] = ACTIONS(2550),
    [anon_sym_by] = ACTIONS(2550),
    [anon_sym_select] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2550),
    [anon_sym_nameof] = ACTIONS(2550),
    [sym_void_keyword] = ACTIONS(2550),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2408] = {
    [sym__preprocessor_call] = STATE(2408),
    [sym__identifier_token] = ACTIONS(4332),
    [anon_sym_extern] = ACTIONS(4332),
    [anon_sym_alias] = ACTIONS(4332),
    [anon_sym_global] = ACTIONS(4332),
    [anon_sym_using] = ACTIONS(4332),
    [anon_sym_static] = ACTIONS(4332),
    [anon_sym_LBRACK] = ACTIONS(4334),
    [anon_sym_event] = ACTIONS(4332),
    [anon_sym_LPAREN] = ACTIONS(4334),
    [anon_sym_abstract] = ACTIONS(4332),
    [anon_sym_async] = ACTIONS(4332),
    [anon_sym_const] = ACTIONS(4332),
    [anon_sym_fixed] = ACTIONS(4332),
    [anon_sym_internal] = ACTIONS(4332),
    [anon_sym_new] = ACTIONS(4332),
    [anon_sym_override] = ACTIONS(4332),
    [anon_sym_partial] = ACTIONS(4332),
    [anon_sym_private] = ACTIONS(4332),
    [anon_sym_protected] = ACTIONS(4332),
    [anon_sym_public] = ACTIONS(4332),
    [anon_sym_readonly] = ACTIONS(4332),
    [anon_sym_ref] = ACTIONS(4332),
    [anon_sym_sealed] = ACTIONS(4332),
    [anon_sym_unsafe] = ACTIONS(4332),
    [anon_sym_virtual] = ACTIONS(4332),
    [anon_sym_volatile] = ACTIONS(4332),
    [anon_sym_RBRACE] = ACTIONS(4334),
    [anon_sym_implicit] = ACTIONS(4332),
    [anon_sym_explicit] = ACTIONS(4332),
    [anon_sym_TILDE] = ACTIONS(4334),
    [anon_sym_where] = ACTIONS(4332),
    [anon_sym_class] = ACTIONS(4332),
    [anon_sym_struct] = ACTIONS(4332),
    [anon_sym_notnull] = ACTIONS(4332),
    [anon_sym_unmanaged] = ACTIONS(4332),
    [anon_sym_get] = ACTIONS(4332),
    [anon_sym_set] = ACTIONS(4332),
    [anon_sym_add] = ACTIONS(4332),
    [anon_sym_remove] = ACTIONS(4332),
    [anon_sym_enum] = ACTIONS(4332),
    [anon_sym_interface] = ACTIONS(4332),
    [anon_sym_delegate] = ACTIONS(4332),
    [anon_sym_record] = ACTIONS(4332),
    [anon_sym_namespace] = ACTIONS(4332),
    [anon_sym_var] = ACTIONS(4332),
    [sym_predefined_type] = ACTIONS(4332),
    [anon_sym_when] = ACTIONS(4332),
    [anon_sym_yield] = ACTIONS(4332),
    [anon_sym_from] = ACTIONS(4332),
    [anon_sym_join] = ACTIONS(4332),
    [anon_sym_on] = ACTIONS(4332),
    [anon_sym_equals] = ACTIONS(4332),
    [anon_sym_into] = ACTIONS(4332),
    [anon_sym_let] = ACTIONS(4332),
    [anon_sym_orderby] = ACTIONS(4332),
    [anon_sym_ascending] = ACTIONS(4332),
    [anon_sym_descending] = ACTIONS(4332),
    [anon_sym_group] = ACTIONS(4332),
    [anon_sym_by] = ACTIONS(4332),
    [anon_sym_select] = ACTIONS(4332),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4332),
    [anon_sym_nameof] = ACTIONS(4332),
    [sym_void_keyword] = ACTIONS(4332),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2409] = {
    [sym__preprocessor_call] = STATE(2409),
    [sym__identifier_token] = ACTIONS(4336),
    [anon_sym_extern] = ACTIONS(4336),
    [anon_sym_alias] = ACTIONS(4336),
    [anon_sym_global] = ACTIONS(4336),
    [anon_sym_using] = ACTIONS(4336),
    [anon_sym_static] = ACTIONS(4336),
    [anon_sym_LBRACK] = ACTIONS(4338),
    [anon_sym_event] = ACTIONS(4336),
    [anon_sym_LPAREN] = ACTIONS(4338),
    [anon_sym_abstract] = ACTIONS(4336),
    [anon_sym_async] = ACTIONS(4336),
    [anon_sym_const] = ACTIONS(4336),
    [anon_sym_fixed] = ACTIONS(4336),
    [anon_sym_internal] = ACTIONS(4336),
    [anon_sym_new] = ACTIONS(4336),
    [anon_sym_override] = ACTIONS(4336),
    [anon_sym_partial] = ACTIONS(4336),
    [anon_sym_private] = ACTIONS(4336),
    [anon_sym_protected] = ACTIONS(4336),
    [anon_sym_public] = ACTIONS(4336),
    [anon_sym_readonly] = ACTIONS(4336),
    [anon_sym_ref] = ACTIONS(4336),
    [anon_sym_sealed] = ACTIONS(4336),
    [anon_sym_unsafe] = ACTIONS(4336),
    [anon_sym_virtual] = ACTIONS(4336),
    [anon_sym_volatile] = ACTIONS(4336),
    [anon_sym_RBRACE] = ACTIONS(4338),
    [anon_sym_implicit] = ACTIONS(4336),
    [anon_sym_explicit] = ACTIONS(4336),
    [anon_sym_TILDE] = ACTIONS(4338),
    [anon_sym_where] = ACTIONS(4336),
    [anon_sym_class] = ACTIONS(4336),
    [anon_sym_struct] = ACTIONS(4336),
    [anon_sym_notnull] = ACTIONS(4336),
    [anon_sym_unmanaged] = ACTIONS(4336),
    [anon_sym_get] = ACTIONS(4336),
    [anon_sym_set] = ACTIONS(4336),
    [anon_sym_add] = ACTIONS(4336),
    [anon_sym_remove] = ACTIONS(4336),
    [anon_sym_enum] = ACTIONS(4336),
    [anon_sym_interface] = ACTIONS(4336),
    [anon_sym_delegate] = ACTIONS(4336),
    [anon_sym_record] = ACTIONS(4336),
    [anon_sym_namespace] = ACTIONS(4336),
    [anon_sym_var] = ACTIONS(4336),
    [sym_predefined_type] = ACTIONS(4336),
    [anon_sym_when] = ACTIONS(4336),
    [anon_sym_yield] = ACTIONS(4336),
    [anon_sym_from] = ACTIONS(4336),
    [anon_sym_join] = ACTIONS(4336),
    [anon_sym_on] = ACTIONS(4336),
    [anon_sym_equals] = ACTIONS(4336),
    [anon_sym_into] = ACTIONS(4336),
    [anon_sym_let] = ACTIONS(4336),
    [anon_sym_orderby] = ACTIONS(4336),
    [anon_sym_ascending] = ACTIONS(4336),
    [anon_sym_descending] = ACTIONS(4336),
    [anon_sym_group] = ACTIONS(4336),
    [anon_sym_by] = ACTIONS(4336),
    [anon_sym_select] = ACTIONS(4336),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4336),
    [anon_sym_nameof] = ACTIONS(4336),
    [sym_void_keyword] = ACTIONS(4336),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2410] = {
    [sym__preprocessor_call] = STATE(2410),
    [sym__identifier_token] = ACTIONS(4340),
    [anon_sym_extern] = ACTIONS(4340),
    [anon_sym_alias] = ACTIONS(4340),
    [anon_sym_global] = ACTIONS(4340),
    [anon_sym_using] = ACTIONS(4340),
    [anon_sym_static] = ACTIONS(4340),
    [anon_sym_LBRACK] = ACTIONS(4342),
    [anon_sym_event] = ACTIONS(4340),
    [anon_sym_LPAREN] = ACTIONS(4342),
    [anon_sym_abstract] = ACTIONS(4340),
    [anon_sym_async] = ACTIONS(4340),
    [anon_sym_const] = ACTIONS(4340),
    [anon_sym_fixed] = ACTIONS(4340),
    [anon_sym_internal] = ACTIONS(4340),
    [anon_sym_new] = ACTIONS(4340),
    [anon_sym_override] = ACTIONS(4340),
    [anon_sym_partial] = ACTIONS(4340),
    [anon_sym_private] = ACTIONS(4340),
    [anon_sym_protected] = ACTIONS(4340),
    [anon_sym_public] = ACTIONS(4340),
    [anon_sym_readonly] = ACTIONS(4340),
    [anon_sym_ref] = ACTIONS(4340),
    [anon_sym_sealed] = ACTIONS(4340),
    [anon_sym_unsafe] = ACTIONS(4340),
    [anon_sym_virtual] = ACTIONS(4340),
    [anon_sym_volatile] = ACTIONS(4340),
    [anon_sym_RBRACE] = ACTIONS(4342),
    [anon_sym_implicit] = ACTIONS(4340),
    [anon_sym_explicit] = ACTIONS(4340),
    [anon_sym_TILDE] = ACTIONS(4342),
    [anon_sym_where] = ACTIONS(4340),
    [anon_sym_class] = ACTIONS(4340),
    [anon_sym_struct] = ACTIONS(4340),
    [anon_sym_notnull] = ACTIONS(4340),
    [anon_sym_unmanaged] = ACTIONS(4340),
    [anon_sym_get] = ACTIONS(4340),
    [anon_sym_set] = ACTIONS(4340),
    [anon_sym_add] = ACTIONS(4340),
    [anon_sym_remove] = ACTIONS(4340),
    [anon_sym_enum] = ACTIONS(4340),
    [anon_sym_interface] = ACTIONS(4340),
    [anon_sym_delegate] = ACTIONS(4340),
    [anon_sym_record] = ACTIONS(4340),
    [anon_sym_namespace] = ACTIONS(4340),
    [anon_sym_var] = ACTIONS(4340),
    [sym_predefined_type] = ACTIONS(4340),
    [anon_sym_when] = ACTIONS(4340),
    [anon_sym_yield] = ACTIONS(4340),
    [anon_sym_from] = ACTIONS(4340),
    [anon_sym_join] = ACTIONS(4340),
    [anon_sym_on] = ACTIONS(4340),
    [anon_sym_equals] = ACTIONS(4340),
    [anon_sym_into] = ACTIONS(4340),
    [anon_sym_let] = ACTIONS(4340),
    [anon_sym_orderby] = ACTIONS(4340),
    [anon_sym_ascending] = ACTIONS(4340),
    [anon_sym_descending] = ACTIONS(4340),
    [anon_sym_group] = ACTIONS(4340),
    [anon_sym_by] = ACTIONS(4340),
    [anon_sym_select] = ACTIONS(4340),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4340),
    [anon_sym_nameof] = ACTIONS(4340),
    [sym_void_keyword] = ACTIONS(4340),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2411] = {
    [sym__preprocessor_call] = STATE(2411),
    [sym__identifier_token] = ACTIONS(4344),
    [anon_sym_extern] = ACTIONS(4344),
    [anon_sym_alias] = ACTIONS(4344),
    [anon_sym_global] = ACTIONS(4344),
    [anon_sym_using] = ACTIONS(4344),
    [anon_sym_static] = ACTIONS(4344),
    [anon_sym_LBRACK] = ACTIONS(4346),
    [anon_sym_event] = ACTIONS(4344),
    [anon_sym_LPAREN] = ACTIONS(4346),
    [anon_sym_abstract] = ACTIONS(4344),
    [anon_sym_async] = ACTIONS(4344),
    [anon_sym_const] = ACTIONS(4344),
    [anon_sym_fixed] = ACTIONS(4344),
    [anon_sym_internal] = ACTIONS(4344),
    [anon_sym_new] = ACTIONS(4344),
    [anon_sym_override] = ACTIONS(4344),
    [anon_sym_partial] = ACTIONS(4344),
    [anon_sym_private] = ACTIONS(4344),
    [anon_sym_protected] = ACTIONS(4344),
    [anon_sym_public] = ACTIONS(4344),
    [anon_sym_readonly] = ACTIONS(4344),
    [anon_sym_ref] = ACTIONS(4344),
    [anon_sym_sealed] = ACTIONS(4344),
    [anon_sym_unsafe] = ACTIONS(4344),
    [anon_sym_virtual] = ACTIONS(4344),
    [anon_sym_volatile] = ACTIONS(4344),
    [anon_sym_RBRACE] = ACTIONS(4346),
    [anon_sym_implicit] = ACTIONS(4344),
    [anon_sym_explicit] = ACTIONS(4344),
    [anon_sym_TILDE] = ACTIONS(4346),
    [anon_sym_where] = ACTIONS(4344),
    [anon_sym_class] = ACTIONS(4344),
    [anon_sym_struct] = ACTIONS(4344),
    [anon_sym_notnull] = ACTIONS(4344),
    [anon_sym_unmanaged] = ACTIONS(4344),
    [anon_sym_get] = ACTIONS(4344),
    [anon_sym_set] = ACTIONS(4344),
    [anon_sym_add] = ACTIONS(4344),
    [anon_sym_remove] = ACTIONS(4344),
    [anon_sym_enum] = ACTIONS(4344),
    [anon_sym_interface] = ACTIONS(4344),
    [anon_sym_delegate] = ACTIONS(4344),
    [anon_sym_record] = ACTIONS(4344),
    [anon_sym_namespace] = ACTIONS(4344),
    [anon_sym_var] = ACTIONS(4344),
    [sym_predefined_type] = ACTIONS(4344),
    [anon_sym_when] = ACTIONS(4344),
    [anon_sym_yield] = ACTIONS(4344),
    [anon_sym_from] = ACTIONS(4344),
    [anon_sym_join] = ACTIONS(4344),
    [anon_sym_on] = ACTIONS(4344),
    [anon_sym_equals] = ACTIONS(4344),
    [anon_sym_into] = ACTIONS(4344),
    [anon_sym_let] = ACTIONS(4344),
    [anon_sym_orderby] = ACTIONS(4344),
    [anon_sym_ascending] = ACTIONS(4344),
    [anon_sym_descending] = ACTIONS(4344),
    [anon_sym_group] = ACTIONS(4344),
    [anon_sym_by] = ACTIONS(4344),
    [anon_sym_select] = ACTIONS(4344),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4344),
    [anon_sym_nameof] = ACTIONS(4344),
    [sym_void_keyword] = ACTIONS(4344),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2412] = {
    [sym__preprocessor_call] = STATE(2412),
    [sym__identifier_token] = ACTIONS(4348),
    [anon_sym_extern] = ACTIONS(4348),
    [anon_sym_alias] = ACTIONS(4348),
    [anon_sym_global] = ACTIONS(4348),
    [anon_sym_using] = ACTIONS(4348),
    [anon_sym_static] = ACTIONS(4348),
    [anon_sym_LBRACK] = ACTIONS(4350),
    [anon_sym_event] = ACTIONS(4348),
    [anon_sym_LPAREN] = ACTIONS(4350),
    [anon_sym_abstract] = ACTIONS(4348),
    [anon_sym_async] = ACTIONS(4348),
    [anon_sym_const] = ACTIONS(4348),
    [anon_sym_fixed] = ACTIONS(4348),
    [anon_sym_internal] = ACTIONS(4348),
    [anon_sym_new] = ACTIONS(4348),
    [anon_sym_override] = ACTIONS(4348),
    [anon_sym_partial] = ACTIONS(4348),
    [anon_sym_private] = ACTIONS(4348),
    [anon_sym_protected] = ACTIONS(4348),
    [anon_sym_public] = ACTIONS(4348),
    [anon_sym_readonly] = ACTIONS(4348),
    [anon_sym_ref] = ACTIONS(4348),
    [anon_sym_sealed] = ACTIONS(4348),
    [anon_sym_unsafe] = ACTIONS(4348),
    [anon_sym_virtual] = ACTIONS(4348),
    [anon_sym_volatile] = ACTIONS(4348),
    [anon_sym_RBRACE] = ACTIONS(4350),
    [anon_sym_implicit] = ACTIONS(4348),
    [anon_sym_explicit] = ACTIONS(4348),
    [anon_sym_TILDE] = ACTIONS(4350),
    [anon_sym_where] = ACTIONS(4348),
    [anon_sym_class] = ACTIONS(4348),
    [anon_sym_struct] = ACTIONS(4348),
    [anon_sym_notnull] = ACTIONS(4348),
    [anon_sym_unmanaged] = ACTIONS(4348),
    [anon_sym_get] = ACTIONS(4348),
    [anon_sym_set] = ACTIONS(4348),
    [anon_sym_add] = ACTIONS(4348),
    [anon_sym_remove] = ACTIONS(4348),
    [anon_sym_enum] = ACTIONS(4348),
    [anon_sym_interface] = ACTIONS(4348),
    [anon_sym_delegate] = ACTIONS(4348),
    [anon_sym_record] = ACTIONS(4348),
    [anon_sym_namespace] = ACTIONS(4348),
    [anon_sym_var] = ACTIONS(4348),
    [sym_predefined_type] = ACTIONS(4348),
    [anon_sym_when] = ACTIONS(4348),
    [anon_sym_yield] = ACTIONS(4348),
    [anon_sym_from] = ACTIONS(4348),
    [anon_sym_join] = ACTIONS(4348),
    [anon_sym_on] = ACTIONS(4348),
    [anon_sym_equals] = ACTIONS(4348),
    [anon_sym_into] = ACTIONS(4348),
    [anon_sym_let] = ACTIONS(4348),
    [anon_sym_orderby] = ACTIONS(4348),
    [anon_sym_ascending] = ACTIONS(4348),
    [anon_sym_descending] = ACTIONS(4348),
    [anon_sym_group] = ACTIONS(4348),
    [anon_sym_by] = ACTIONS(4348),
    [anon_sym_select] = ACTIONS(4348),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4348),
    [anon_sym_nameof] = ACTIONS(4348),
    [sym_void_keyword] = ACTIONS(4348),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2413] = {
    [sym__preprocessor_call] = STATE(2413),
    [sym__identifier_token] = ACTIONS(4352),
    [anon_sym_extern] = ACTIONS(4352),
    [anon_sym_alias] = ACTIONS(4352),
    [anon_sym_global] = ACTIONS(4352),
    [anon_sym_using] = ACTIONS(4352),
    [anon_sym_static] = ACTIONS(4352),
    [anon_sym_LBRACK] = ACTIONS(4354),
    [anon_sym_event] = ACTIONS(4352),
    [anon_sym_LPAREN] = ACTIONS(4354),
    [anon_sym_abstract] = ACTIONS(4352),
    [anon_sym_async] = ACTIONS(4352),
    [anon_sym_const] = ACTIONS(4352),
    [anon_sym_fixed] = ACTIONS(4352),
    [anon_sym_internal] = ACTIONS(4352),
    [anon_sym_new] = ACTIONS(4352),
    [anon_sym_override] = ACTIONS(4352),
    [anon_sym_partial] = ACTIONS(4352),
    [anon_sym_private] = ACTIONS(4352),
    [anon_sym_protected] = ACTIONS(4352),
    [anon_sym_public] = ACTIONS(4352),
    [anon_sym_readonly] = ACTIONS(4352),
    [anon_sym_ref] = ACTIONS(4352),
    [anon_sym_sealed] = ACTIONS(4352),
    [anon_sym_unsafe] = ACTIONS(4352),
    [anon_sym_virtual] = ACTIONS(4352),
    [anon_sym_volatile] = ACTIONS(4352),
    [anon_sym_RBRACE] = ACTIONS(4354),
    [anon_sym_implicit] = ACTIONS(4352),
    [anon_sym_explicit] = ACTIONS(4352),
    [anon_sym_TILDE] = ACTIONS(4354),
    [anon_sym_where] = ACTIONS(4352),
    [anon_sym_class] = ACTIONS(4352),
    [anon_sym_struct] = ACTIONS(4352),
    [anon_sym_notnull] = ACTIONS(4352),
    [anon_sym_unmanaged] = ACTIONS(4352),
    [anon_sym_get] = ACTIONS(4352),
    [anon_sym_set] = ACTIONS(4352),
    [anon_sym_add] = ACTIONS(4352),
    [anon_sym_remove] = ACTIONS(4352),
    [anon_sym_enum] = ACTIONS(4352),
    [anon_sym_interface] = ACTIONS(4352),
    [anon_sym_delegate] = ACTIONS(4352),
    [anon_sym_record] = ACTIONS(4352),
    [anon_sym_namespace] = ACTIONS(4352),
    [anon_sym_var] = ACTIONS(4352),
    [sym_predefined_type] = ACTIONS(4352),
    [anon_sym_when] = ACTIONS(4352),
    [anon_sym_yield] = ACTIONS(4352),
    [anon_sym_from] = ACTIONS(4352),
    [anon_sym_join] = ACTIONS(4352),
    [anon_sym_on] = ACTIONS(4352),
    [anon_sym_equals] = ACTIONS(4352),
    [anon_sym_into] = ACTIONS(4352),
    [anon_sym_let] = ACTIONS(4352),
    [anon_sym_orderby] = ACTIONS(4352),
    [anon_sym_ascending] = ACTIONS(4352),
    [anon_sym_descending] = ACTIONS(4352),
    [anon_sym_group] = ACTIONS(4352),
    [anon_sym_by] = ACTIONS(4352),
    [anon_sym_select] = ACTIONS(4352),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4352),
    [anon_sym_nameof] = ACTIONS(4352),
    [sym_void_keyword] = ACTIONS(4352),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2414] = {
    [sym__preprocessor_call] = STATE(2414),
    [sym__identifier_token] = ACTIONS(4356),
    [anon_sym_extern] = ACTIONS(4356),
    [anon_sym_alias] = ACTIONS(4356),
    [anon_sym_global] = ACTIONS(4356),
    [anon_sym_using] = ACTIONS(4356),
    [anon_sym_static] = ACTIONS(4356),
    [anon_sym_LBRACK] = ACTIONS(4358),
    [anon_sym_event] = ACTIONS(4356),
    [anon_sym_LPAREN] = ACTIONS(4358),
    [anon_sym_abstract] = ACTIONS(4356),
    [anon_sym_async] = ACTIONS(4356),
    [anon_sym_const] = ACTIONS(4356),
    [anon_sym_fixed] = ACTIONS(4356),
    [anon_sym_internal] = ACTIONS(4356),
    [anon_sym_new] = ACTIONS(4356),
    [anon_sym_override] = ACTIONS(4356),
    [anon_sym_partial] = ACTIONS(4356),
    [anon_sym_private] = ACTIONS(4356),
    [anon_sym_protected] = ACTIONS(4356),
    [anon_sym_public] = ACTIONS(4356),
    [anon_sym_readonly] = ACTIONS(4356),
    [anon_sym_ref] = ACTIONS(4356),
    [anon_sym_sealed] = ACTIONS(4356),
    [anon_sym_unsafe] = ACTIONS(4356),
    [anon_sym_virtual] = ACTIONS(4356),
    [anon_sym_volatile] = ACTIONS(4356),
    [anon_sym_RBRACE] = ACTIONS(4358),
    [anon_sym_implicit] = ACTIONS(4356),
    [anon_sym_explicit] = ACTIONS(4356),
    [anon_sym_TILDE] = ACTIONS(4358),
    [anon_sym_where] = ACTIONS(4356),
    [anon_sym_class] = ACTIONS(4356),
    [anon_sym_struct] = ACTIONS(4356),
    [anon_sym_notnull] = ACTIONS(4356),
    [anon_sym_unmanaged] = ACTIONS(4356),
    [anon_sym_get] = ACTIONS(4356),
    [anon_sym_set] = ACTIONS(4356),
    [anon_sym_add] = ACTIONS(4356),
    [anon_sym_remove] = ACTIONS(4356),
    [anon_sym_enum] = ACTIONS(4356),
    [anon_sym_interface] = ACTIONS(4356),
    [anon_sym_delegate] = ACTIONS(4356),
    [anon_sym_record] = ACTIONS(4356),
    [anon_sym_namespace] = ACTIONS(4356),
    [anon_sym_var] = ACTIONS(4356),
    [sym_predefined_type] = ACTIONS(4356),
    [anon_sym_when] = ACTIONS(4356),
    [anon_sym_yield] = ACTIONS(4356),
    [anon_sym_from] = ACTIONS(4356),
    [anon_sym_join] = ACTIONS(4356),
    [anon_sym_on] = ACTIONS(4356),
    [anon_sym_equals] = ACTIONS(4356),
    [anon_sym_into] = ACTIONS(4356),
    [anon_sym_let] = ACTIONS(4356),
    [anon_sym_orderby] = ACTIONS(4356),
    [anon_sym_ascending] = ACTIONS(4356),
    [anon_sym_descending] = ACTIONS(4356),
    [anon_sym_group] = ACTIONS(4356),
    [anon_sym_by] = ACTIONS(4356),
    [anon_sym_select] = ACTIONS(4356),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4356),
    [anon_sym_nameof] = ACTIONS(4356),
    [sym_void_keyword] = ACTIONS(4356),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2415] = {
    [sym__preprocessor_call] = STATE(2415),
    [sym__identifier_token] = ACTIONS(4360),
    [anon_sym_extern] = ACTIONS(4360),
    [anon_sym_alias] = ACTIONS(4360),
    [anon_sym_global] = ACTIONS(4360),
    [anon_sym_using] = ACTIONS(4360),
    [anon_sym_static] = ACTIONS(4360),
    [anon_sym_LBRACK] = ACTIONS(4362),
    [anon_sym_event] = ACTIONS(4360),
    [anon_sym_LPAREN] = ACTIONS(4362),
    [anon_sym_abstract] = ACTIONS(4360),
    [anon_sym_async] = ACTIONS(4360),
    [anon_sym_const] = ACTIONS(4360),
    [anon_sym_fixed] = ACTIONS(4360),
    [anon_sym_internal] = ACTIONS(4360),
    [anon_sym_new] = ACTIONS(4360),
    [anon_sym_override] = ACTIONS(4360),
    [anon_sym_partial] = ACTIONS(4360),
    [anon_sym_private] = ACTIONS(4360),
    [anon_sym_protected] = ACTIONS(4360),
    [anon_sym_public] = ACTIONS(4360),
    [anon_sym_readonly] = ACTIONS(4360),
    [anon_sym_ref] = ACTIONS(4360),
    [anon_sym_sealed] = ACTIONS(4360),
    [anon_sym_unsafe] = ACTIONS(4360),
    [anon_sym_virtual] = ACTIONS(4360),
    [anon_sym_volatile] = ACTIONS(4360),
    [anon_sym_RBRACE] = ACTIONS(4362),
    [anon_sym_implicit] = ACTIONS(4360),
    [anon_sym_explicit] = ACTIONS(4360),
    [anon_sym_TILDE] = ACTIONS(4362),
    [anon_sym_where] = ACTIONS(4360),
    [anon_sym_class] = ACTIONS(4360),
    [anon_sym_struct] = ACTIONS(4360),
    [anon_sym_notnull] = ACTIONS(4360),
    [anon_sym_unmanaged] = ACTIONS(4360),
    [anon_sym_get] = ACTIONS(4360),
    [anon_sym_set] = ACTIONS(4360),
    [anon_sym_add] = ACTIONS(4360),
    [anon_sym_remove] = ACTIONS(4360),
    [anon_sym_enum] = ACTIONS(4360),
    [anon_sym_interface] = ACTIONS(4360),
    [anon_sym_delegate] = ACTIONS(4360),
    [anon_sym_record] = ACTIONS(4360),
    [anon_sym_namespace] = ACTIONS(4360),
    [anon_sym_var] = ACTIONS(4360),
    [sym_predefined_type] = ACTIONS(4360),
    [anon_sym_when] = ACTIONS(4360),
    [anon_sym_yield] = ACTIONS(4360),
    [anon_sym_from] = ACTIONS(4360),
    [anon_sym_join] = ACTIONS(4360),
    [anon_sym_on] = ACTIONS(4360),
    [anon_sym_equals] = ACTIONS(4360),
    [anon_sym_into] = ACTIONS(4360),
    [anon_sym_let] = ACTIONS(4360),
    [anon_sym_orderby] = ACTIONS(4360),
    [anon_sym_ascending] = ACTIONS(4360),
    [anon_sym_descending] = ACTIONS(4360),
    [anon_sym_group] = ACTIONS(4360),
    [anon_sym_by] = ACTIONS(4360),
    [anon_sym_select] = ACTIONS(4360),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4360),
    [anon_sym_nameof] = ACTIONS(4360),
    [sym_void_keyword] = ACTIONS(4360),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2416] = {
    [sym__preprocessor_call] = STATE(2416),
    [sym__identifier_token] = ACTIONS(4364),
    [anon_sym_extern] = ACTIONS(4364),
    [anon_sym_alias] = ACTIONS(4364),
    [anon_sym_global] = ACTIONS(4364),
    [anon_sym_using] = ACTIONS(4364),
    [anon_sym_static] = ACTIONS(4364),
    [anon_sym_LBRACK] = ACTIONS(4366),
    [anon_sym_event] = ACTIONS(4364),
    [anon_sym_LPAREN] = ACTIONS(4366),
    [anon_sym_abstract] = ACTIONS(4364),
    [anon_sym_async] = ACTIONS(4364),
    [anon_sym_const] = ACTIONS(4364),
    [anon_sym_fixed] = ACTIONS(4364),
    [anon_sym_internal] = ACTIONS(4364),
    [anon_sym_new] = ACTIONS(4364),
    [anon_sym_override] = ACTIONS(4364),
    [anon_sym_partial] = ACTIONS(4364),
    [anon_sym_private] = ACTIONS(4364),
    [anon_sym_protected] = ACTIONS(4364),
    [anon_sym_public] = ACTIONS(4364),
    [anon_sym_readonly] = ACTIONS(4364),
    [anon_sym_ref] = ACTIONS(4364),
    [anon_sym_sealed] = ACTIONS(4364),
    [anon_sym_unsafe] = ACTIONS(4364),
    [anon_sym_virtual] = ACTIONS(4364),
    [anon_sym_volatile] = ACTIONS(4364),
    [anon_sym_RBRACE] = ACTIONS(4366),
    [anon_sym_implicit] = ACTIONS(4364),
    [anon_sym_explicit] = ACTIONS(4364),
    [anon_sym_TILDE] = ACTIONS(4366),
    [anon_sym_where] = ACTIONS(4364),
    [anon_sym_class] = ACTIONS(4364),
    [anon_sym_struct] = ACTIONS(4364),
    [anon_sym_notnull] = ACTIONS(4364),
    [anon_sym_unmanaged] = ACTIONS(4364),
    [anon_sym_get] = ACTIONS(4364),
    [anon_sym_set] = ACTIONS(4364),
    [anon_sym_add] = ACTIONS(4364),
    [anon_sym_remove] = ACTIONS(4364),
    [anon_sym_enum] = ACTIONS(4364),
    [anon_sym_interface] = ACTIONS(4364),
    [anon_sym_delegate] = ACTIONS(4364),
    [anon_sym_record] = ACTIONS(4364),
    [anon_sym_namespace] = ACTIONS(4364),
    [anon_sym_var] = ACTIONS(4364),
    [sym_predefined_type] = ACTIONS(4364),
    [anon_sym_when] = ACTIONS(4364),
    [anon_sym_yield] = ACTIONS(4364),
    [anon_sym_from] = ACTIONS(4364),
    [anon_sym_join] = ACTIONS(4364),
    [anon_sym_on] = ACTIONS(4364),
    [anon_sym_equals] = ACTIONS(4364),
    [anon_sym_into] = ACTIONS(4364),
    [anon_sym_let] = ACTIONS(4364),
    [anon_sym_orderby] = ACTIONS(4364),
    [anon_sym_ascending] = ACTIONS(4364),
    [anon_sym_descending] = ACTIONS(4364),
    [anon_sym_group] = ACTIONS(4364),
    [anon_sym_by] = ACTIONS(4364),
    [anon_sym_select] = ACTIONS(4364),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4364),
    [anon_sym_nameof] = ACTIONS(4364),
    [sym_void_keyword] = ACTIONS(4364),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2417] = {
    [sym__preprocessor_call] = STATE(2417),
    [sym__identifier_token] = ACTIONS(4368),
    [anon_sym_extern] = ACTIONS(4368),
    [anon_sym_alias] = ACTIONS(4368),
    [anon_sym_global] = ACTIONS(4368),
    [anon_sym_using] = ACTIONS(4368),
    [anon_sym_static] = ACTIONS(4368),
    [anon_sym_LBRACK] = ACTIONS(4370),
    [anon_sym_event] = ACTIONS(4368),
    [anon_sym_LPAREN] = ACTIONS(4370),
    [anon_sym_abstract] = ACTIONS(4368),
    [anon_sym_async] = ACTIONS(4368),
    [anon_sym_const] = ACTIONS(4368),
    [anon_sym_fixed] = ACTIONS(4368),
    [anon_sym_internal] = ACTIONS(4368),
    [anon_sym_new] = ACTIONS(4368),
    [anon_sym_override] = ACTIONS(4368),
    [anon_sym_partial] = ACTIONS(4368),
    [anon_sym_private] = ACTIONS(4368),
    [anon_sym_protected] = ACTIONS(4368),
    [anon_sym_public] = ACTIONS(4368),
    [anon_sym_readonly] = ACTIONS(4368),
    [anon_sym_ref] = ACTIONS(4368),
    [anon_sym_sealed] = ACTIONS(4368),
    [anon_sym_unsafe] = ACTIONS(4368),
    [anon_sym_virtual] = ACTIONS(4368),
    [anon_sym_volatile] = ACTIONS(4368),
    [anon_sym_RBRACE] = ACTIONS(4370),
    [anon_sym_implicit] = ACTIONS(4368),
    [anon_sym_explicit] = ACTIONS(4368),
    [anon_sym_TILDE] = ACTIONS(4370),
    [anon_sym_where] = ACTIONS(4368),
    [anon_sym_class] = ACTIONS(4368),
    [anon_sym_struct] = ACTIONS(4368),
    [anon_sym_notnull] = ACTIONS(4368),
    [anon_sym_unmanaged] = ACTIONS(4368),
    [anon_sym_get] = ACTIONS(4368),
    [anon_sym_set] = ACTIONS(4368),
    [anon_sym_add] = ACTIONS(4368),
    [anon_sym_remove] = ACTIONS(4368),
    [anon_sym_enum] = ACTIONS(4368),
    [anon_sym_interface] = ACTIONS(4368),
    [anon_sym_delegate] = ACTIONS(4368),
    [anon_sym_record] = ACTIONS(4368),
    [anon_sym_namespace] = ACTIONS(4368),
    [anon_sym_var] = ACTIONS(4368),
    [sym_predefined_type] = ACTIONS(4368),
    [anon_sym_when] = ACTIONS(4368),
    [anon_sym_yield] = ACTIONS(4368),
    [anon_sym_from] = ACTIONS(4368),
    [anon_sym_join] = ACTIONS(4368),
    [anon_sym_on] = ACTIONS(4368),
    [anon_sym_equals] = ACTIONS(4368),
    [anon_sym_into] = ACTIONS(4368),
    [anon_sym_let] = ACTIONS(4368),
    [anon_sym_orderby] = ACTIONS(4368),
    [anon_sym_ascending] = ACTIONS(4368),
    [anon_sym_descending] = ACTIONS(4368),
    [anon_sym_group] = ACTIONS(4368),
    [anon_sym_by] = ACTIONS(4368),
    [anon_sym_select] = ACTIONS(4368),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4368),
    [anon_sym_nameof] = ACTIONS(4368),
    [sym_void_keyword] = ACTIONS(4368),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2418] = {
    [sym__preprocessor_call] = STATE(2418),
    [sym__identifier_token] = ACTIONS(4372),
    [anon_sym_extern] = ACTIONS(4372),
    [anon_sym_alias] = ACTIONS(4372),
    [anon_sym_global] = ACTIONS(4372),
    [anon_sym_using] = ACTIONS(4372),
    [anon_sym_static] = ACTIONS(4372),
    [anon_sym_LBRACK] = ACTIONS(4374),
    [anon_sym_event] = ACTIONS(4372),
    [anon_sym_LPAREN] = ACTIONS(4374),
    [anon_sym_abstract] = ACTIONS(4372),
    [anon_sym_async] = ACTIONS(4372),
    [anon_sym_const] = ACTIONS(4372),
    [anon_sym_fixed] = ACTIONS(4372),
    [anon_sym_internal] = ACTIONS(4372),
    [anon_sym_new] = ACTIONS(4372),
    [anon_sym_override] = ACTIONS(4372),
    [anon_sym_partial] = ACTIONS(4372),
    [anon_sym_private] = ACTIONS(4372),
    [anon_sym_protected] = ACTIONS(4372),
    [anon_sym_public] = ACTIONS(4372),
    [anon_sym_readonly] = ACTIONS(4372),
    [anon_sym_ref] = ACTIONS(4372),
    [anon_sym_sealed] = ACTIONS(4372),
    [anon_sym_unsafe] = ACTIONS(4372),
    [anon_sym_virtual] = ACTIONS(4372),
    [anon_sym_volatile] = ACTIONS(4372),
    [anon_sym_RBRACE] = ACTIONS(4374),
    [anon_sym_implicit] = ACTIONS(4372),
    [anon_sym_explicit] = ACTIONS(4372),
    [anon_sym_TILDE] = ACTIONS(4374),
    [anon_sym_where] = ACTIONS(4372),
    [anon_sym_class] = ACTIONS(4372),
    [anon_sym_struct] = ACTIONS(4372),
    [anon_sym_notnull] = ACTIONS(4372),
    [anon_sym_unmanaged] = ACTIONS(4372),
    [anon_sym_get] = ACTIONS(4372),
    [anon_sym_set] = ACTIONS(4372),
    [anon_sym_add] = ACTIONS(4372),
    [anon_sym_remove] = ACTIONS(4372),
    [anon_sym_enum] = ACTIONS(4372),
    [anon_sym_interface] = ACTIONS(4372),
    [anon_sym_delegate] = ACTIONS(4372),
    [anon_sym_record] = ACTIONS(4372),
    [anon_sym_namespace] = ACTIONS(4372),
    [anon_sym_var] = ACTIONS(4372),
    [sym_predefined_type] = ACTIONS(4372),
    [anon_sym_when] = ACTIONS(4372),
    [anon_sym_yield] = ACTIONS(4372),
    [anon_sym_from] = ACTIONS(4372),
    [anon_sym_join] = ACTIONS(4372),
    [anon_sym_on] = ACTIONS(4372),
    [anon_sym_equals] = ACTIONS(4372),
    [anon_sym_into] = ACTIONS(4372),
    [anon_sym_let] = ACTIONS(4372),
    [anon_sym_orderby] = ACTIONS(4372),
    [anon_sym_ascending] = ACTIONS(4372),
    [anon_sym_descending] = ACTIONS(4372),
    [anon_sym_group] = ACTIONS(4372),
    [anon_sym_by] = ACTIONS(4372),
    [anon_sym_select] = ACTIONS(4372),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4372),
    [anon_sym_nameof] = ACTIONS(4372),
    [sym_void_keyword] = ACTIONS(4372),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2419] = {
    [sym__preprocessor_call] = STATE(2419),
    [sym__identifier_token] = ACTIONS(4376),
    [anon_sym_extern] = ACTIONS(4376),
    [anon_sym_alias] = ACTIONS(4376),
    [anon_sym_global] = ACTIONS(4376),
    [anon_sym_using] = ACTIONS(4376),
    [anon_sym_static] = ACTIONS(4376),
    [anon_sym_LBRACK] = ACTIONS(4378),
    [anon_sym_event] = ACTIONS(4376),
    [anon_sym_LPAREN] = ACTIONS(4378),
    [anon_sym_abstract] = ACTIONS(4376),
    [anon_sym_async] = ACTIONS(4376),
    [anon_sym_const] = ACTIONS(4376),
    [anon_sym_fixed] = ACTIONS(4376),
    [anon_sym_internal] = ACTIONS(4376),
    [anon_sym_new] = ACTIONS(4376),
    [anon_sym_override] = ACTIONS(4376),
    [anon_sym_partial] = ACTIONS(4376),
    [anon_sym_private] = ACTIONS(4376),
    [anon_sym_protected] = ACTIONS(4376),
    [anon_sym_public] = ACTIONS(4376),
    [anon_sym_readonly] = ACTIONS(4376),
    [anon_sym_ref] = ACTIONS(4376),
    [anon_sym_sealed] = ACTIONS(4376),
    [anon_sym_unsafe] = ACTIONS(4376),
    [anon_sym_virtual] = ACTIONS(4376),
    [anon_sym_volatile] = ACTIONS(4376),
    [anon_sym_RBRACE] = ACTIONS(4378),
    [anon_sym_implicit] = ACTIONS(4376),
    [anon_sym_explicit] = ACTIONS(4376),
    [anon_sym_TILDE] = ACTIONS(4378),
    [anon_sym_where] = ACTIONS(4376),
    [anon_sym_class] = ACTIONS(4376),
    [anon_sym_struct] = ACTIONS(4376),
    [anon_sym_notnull] = ACTIONS(4376),
    [anon_sym_unmanaged] = ACTIONS(4376),
    [anon_sym_get] = ACTIONS(4376),
    [anon_sym_set] = ACTIONS(4376),
    [anon_sym_add] = ACTIONS(4376),
    [anon_sym_remove] = ACTIONS(4376),
    [anon_sym_enum] = ACTIONS(4376),
    [anon_sym_interface] = ACTIONS(4376),
    [anon_sym_delegate] = ACTIONS(4376),
    [anon_sym_record] = ACTIONS(4376),
    [anon_sym_namespace] = ACTIONS(4376),
    [anon_sym_var] = ACTIONS(4376),
    [sym_predefined_type] = ACTIONS(4376),
    [anon_sym_when] = ACTIONS(4376),
    [anon_sym_yield] = ACTIONS(4376),
    [anon_sym_from] = ACTIONS(4376),
    [anon_sym_join] = ACTIONS(4376),
    [anon_sym_on] = ACTIONS(4376),
    [anon_sym_equals] = ACTIONS(4376),
    [anon_sym_into] = ACTIONS(4376),
    [anon_sym_let] = ACTIONS(4376),
    [anon_sym_orderby] = ACTIONS(4376),
    [anon_sym_ascending] = ACTIONS(4376),
    [anon_sym_descending] = ACTIONS(4376),
    [anon_sym_group] = ACTIONS(4376),
    [anon_sym_by] = ACTIONS(4376),
    [anon_sym_select] = ACTIONS(4376),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4376),
    [anon_sym_nameof] = ACTIONS(4376),
    [sym_void_keyword] = ACTIONS(4376),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2420] = {
    [sym__preprocessor_call] = STATE(2420),
    [sym__identifier_token] = ACTIONS(4380),
    [anon_sym_extern] = ACTIONS(4380),
    [anon_sym_alias] = ACTIONS(4380),
    [anon_sym_global] = ACTIONS(4380),
    [anon_sym_using] = ACTIONS(4380),
    [anon_sym_static] = ACTIONS(4380),
    [anon_sym_LBRACK] = ACTIONS(4382),
    [anon_sym_event] = ACTIONS(4380),
    [anon_sym_LPAREN] = ACTIONS(4382),
    [anon_sym_abstract] = ACTIONS(4380),
    [anon_sym_async] = ACTIONS(4380),
    [anon_sym_const] = ACTIONS(4380),
    [anon_sym_fixed] = ACTIONS(4380),
    [anon_sym_internal] = ACTIONS(4380),
    [anon_sym_new] = ACTIONS(4380),
    [anon_sym_override] = ACTIONS(4380),
    [anon_sym_partial] = ACTIONS(4380),
    [anon_sym_private] = ACTIONS(4380),
    [anon_sym_protected] = ACTIONS(4380),
    [anon_sym_public] = ACTIONS(4380),
    [anon_sym_readonly] = ACTIONS(4380),
    [anon_sym_ref] = ACTIONS(4380),
    [anon_sym_sealed] = ACTIONS(4380),
    [anon_sym_unsafe] = ACTIONS(4380),
    [anon_sym_virtual] = ACTIONS(4380),
    [anon_sym_volatile] = ACTIONS(4380),
    [anon_sym_RBRACE] = ACTIONS(4382),
    [anon_sym_implicit] = ACTIONS(4380),
    [anon_sym_explicit] = ACTIONS(4380),
    [anon_sym_TILDE] = ACTIONS(4382),
    [anon_sym_where] = ACTIONS(4380),
    [anon_sym_class] = ACTIONS(4380),
    [anon_sym_struct] = ACTIONS(4380),
    [anon_sym_notnull] = ACTIONS(4380),
    [anon_sym_unmanaged] = ACTIONS(4380),
    [anon_sym_get] = ACTIONS(4380),
    [anon_sym_set] = ACTIONS(4380),
    [anon_sym_add] = ACTIONS(4380),
    [anon_sym_remove] = ACTIONS(4380),
    [anon_sym_enum] = ACTIONS(4380),
    [anon_sym_interface] = ACTIONS(4380),
    [anon_sym_delegate] = ACTIONS(4380),
    [anon_sym_record] = ACTIONS(4380),
    [anon_sym_namespace] = ACTIONS(4380),
    [anon_sym_var] = ACTIONS(4380),
    [sym_predefined_type] = ACTIONS(4380),
    [anon_sym_when] = ACTIONS(4380),
    [anon_sym_yield] = ACTIONS(4380),
    [anon_sym_from] = ACTIONS(4380),
    [anon_sym_join] = ACTIONS(4380),
    [anon_sym_on] = ACTIONS(4380),
    [anon_sym_equals] = ACTIONS(4380),
    [anon_sym_into] = ACTIONS(4380),
    [anon_sym_let] = ACTIONS(4380),
    [anon_sym_orderby] = ACTIONS(4380),
    [anon_sym_ascending] = ACTIONS(4380),
    [anon_sym_descending] = ACTIONS(4380),
    [anon_sym_group] = ACTIONS(4380),
    [anon_sym_by] = ACTIONS(4380),
    [anon_sym_select] = ACTIONS(4380),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4380),
    [anon_sym_nameof] = ACTIONS(4380),
    [sym_void_keyword] = ACTIONS(4380),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2421] = {
    [sym__preprocessor_call] = STATE(2421),
    [sym__identifier_token] = ACTIONS(4384),
    [anon_sym_extern] = ACTIONS(4384),
    [anon_sym_alias] = ACTIONS(4384),
    [anon_sym_global] = ACTIONS(4384),
    [anon_sym_using] = ACTIONS(4384),
    [anon_sym_static] = ACTIONS(4384),
    [anon_sym_LBRACK] = ACTIONS(4386),
    [anon_sym_event] = ACTIONS(4384),
    [anon_sym_LPAREN] = ACTIONS(4386),
    [anon_sym_abstract] = ACTIONS(4384),
    [anon_sym_async] = ACTIONS(4384),
    [anon_sym_const] = ACTIONS(4384),
    [anon_sym_fixed] = ACTIONS(4384),
    [anon_sym_internal] = ACTIONS(4384),
    [anon_sym_new] = ACTIONS(4384),
    [anon_sym_override] = ACTIONS(4384),
    [anon_sym_partial] = ACTIONS(4384),
    [anon_sym_private] = ACTIONS(4384),
    [anon_sym_protected] = ACTIONS(4384),
    [anon_sym_public] = ACTIONS(4384),
    [anon_sym_readonly] = ACTIONS(4384),
    [anon_sym_ref] = ACTIONS(4384),
    [anon_sym_sealed] = ACTIONS(4384),
    [anon_sym_unsafe] = ACTIONS(4384),
    [anon_sym_virtual] = ACTIONS(4384),
    [anon_sym_volatile] = ACTIONS(4384),
    [anon_sym_RBRACE] = ACTIONS(4386),
    [anon_sym_implicit] = ACTIONS(4384),
    [anon_sym_explicit] = ACTIONS(4384),
    [anon_sym_TILDE] = ACTIONS(4386),
    [anon_sym_where] = ACTIONS(4384),
    [anon_sym_class] = ACTIONS(4384),
    [anon_sym_struct] = ACTIONS(4384),
    [anon_sym_notnull] = ACTIONS(4384),
    [anon_sym_unmanaged] = ACTIONS(4384),
    [anon_sym_get] = ACTIONS(4384),
    [anon_sym_set] = ACTIONS(4384),
    [anon_sym_add] = ACTIONS(4384),
    [anon_sym_remove] = ACTIONS(4384),
    [anon_sym_enum] = ACTIONS(4384),
    [anon_sym_interface] = ACTIONS(4384),
    [anon_sym_delegate] = ACTIONS(4384),
    [anon_sym_record] = ACTIONS(4384),
    [anon_sym_namespace] = ACTIONS(4384),
    [anon_sym_var] = ACTIONS(4384),
    [sym_predefined_type] = ACTIONS(4384),
    [anon_sym_when] = ACTIONS(4384),
    [anon_sym_yield] = ACTIONS(4384),
    [anon_sym_from] = ACTIONS(4384),
    [anon_sym_join] = ACTIONS(4384),
    [anon_sym_on] = ACTIONS(4384),
    [anon_sym_equals] = ACTIONS(4384),
    [anon_sym_into] = ACTIONS(4384),
    [anon_sym_let] = ACTIONS(4384),
    [anon_sym_orderby] = ACTIONS(4384),
    [anon_sym_ascending] = ACTIONS(4384),
    [anon_sym_descending] = ACTIONS(4384),
    [anon_sym_group] = ACTIONS(4384),
    [anon_sym_by] = ACTIONS(4384),
    [anon_sym_select] = ACTIONS(4384),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4384),
    [anon_sym_nameof] = ACTIONS(4384),
    [sym_void_keyword] = ACTIONS(4384),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2422] = {
    [sym__preprocessor_call] = STATE(2422),
    [sym__identifier_token] = ACTIONS(4388),
    [anon_sym_extern] = ACTIONS(4388),
    [anon_sym_alias] = ACTIONS(4388),
    [anon_sym_global] = ACTIONS(4388),
    [anon_sym_using] = ACTIONS(4388),
    [anon_sym_static] = ACTIONS(4388),
    [anon_sym_LBRACK] = ACTIONS(4390),
    [anon_sym_event] = ACTIONS(4388),
    [anon_sym_LPAREN] = ACTIONS(4390),
    [anon_sym_abstract] = ACTIONS(4388),
    [anon_sym_async] = ACTIONS(4388),
    [anon_sym_const] = ACTIONS(4388),
    [anon_sym_fixed] = ACTIONS(4388),
    [anon_sym_internal] = ACTIONS(4388),
    [anon_sym_new] = ACTIONS(4388),
    [anon_sym_override] = ACTIONS(4388),
    [anon_sym_partial] = ACTIONS(4388),
    [anon_sym_private] = ACTIONS(4388),
    [anon_sym_protected] = ACTIONS(4388),
    [anon_sym_public] = ACTIONS(4388),
    [anon_sym_readonly] = ACTIONS(4388),
    [anon_sym_ref] = ACTIONS(4388),
    [anon_sym_sealed] = ACTIONS(4388),
    [anon_sym_unsafe] = ACTIONS(4388),
    [anon_sym_virtual] = ACTIONS(4388),
    [anon_sym_volatile] = ACTIONS(4388),
    [anon_sym_RBRACE] = ACTIONS(4390),
    [anon_sym_implicit] = ACTIONS(4388),
    [anon_sym_explicit] = ACTIONS(4388),
    [anon_sym_TILDE] = ACTIONS(4390),
    [anon_sym_where] = ACTIONS(4388),
    [anon_sym_class] = ACTIONS(4388),
    [anon_sym_struct] = ACTIONS(4388),
    [anon_sym_notnull] = ACTIONS(4388),
    [anon_sym_unmanaged] = ACTIONS(4388),
    [anon_sym_get] = ACTIONS(4388),
    [anon_sym_set] = ACTIONS(4388),
    [anon_sym_add] = ACTIONS(4388),
    [anon_sym_remove] = ACTIONS(4388),
    [anon_sym_enum] = ACTIONS(4388),
    [anon_sym_interface] = ACTIONS(4388),
    [anon_sym_delegate] = ACTIONS(4388),
    [anon_sym_record] = ACTIONS(4388),
    [anon_sym_namespace] = ACTIONS(4388),
    [anon_sym_var] = ACTIONS(4388),
    [sym_predefined_type] = ACTIONS(4388),
    [anon_sym_when] = ACTIONS(4388),
    [anon_sym_yield] = ACTIONS(4388),
    [anon_sym_from] = ACTIONS(4388),
    [anon_sym_join] = ACTIONS(4388),
    [anon_sym_on] = ACTIONS(4388),
    [anon_sym_equals] = ACTIONS(4388),
    [anon_sym_into] = ACTIONS(4388),
    [anon_sym_let] = ACTIONS(4388),
    [anon_sym_orderby] = ACTIONS(4388),
    [anon_sym_ascending] = ACTIONS(4388),
    [anon_sym_descending] = ACTIONS(4388),
    [anon_sym_group] = ACTIONS(4388),
    [anon_sym_by] = ACTIONS(4388),
    [anon_sym_select] = ACTIONS(4388),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4388),
    [anon_sym_nameof] = ACTIONS(4388),
    [sym_void_keyword] = ACTIONS(4388),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2423] = {
    [sym__preprocessor_call] = STATE(2423),
    [sym__identifier_token] = ACTIONS(4392),
    [anon_sym_extern] = ACTIONS(4392),
    [anon_sym_alias] = ACTIONS(4392),
    [anon_sym_global] = ACTIONS(4392),
    [anon_sym_using] = ACTIONS(4392),
    [anon_sym_static] = ACTIONS(4392),
    [anon_sym_LBRACK] = ACTIONS(4394),
    [anon_sym_event] = ACTIONS(4392),
    [anon_sym_LPAREN] = ACTIONS(4394),
    [anon_sym_abstract] = ACTIONS(4392),
    [anon_sym_async] = ACTIONS(4392),
    [anon_sym_const] = ACTIONS(4392),
    [anon_sym_fixed] = ACTIONS(4392),
    [anon_sym_internal] = ACTIONS(4392),
    [anon_sym_new] = ACTIONS(4392),
    [anon_sym_override] = ACTIONS(4392),
    [anon_sym_partial] = ACTIONS(4392),
    [anon_sym_private] = ACTIONS(4392),
    [anon_sym_protected] = ACTIONS(4392),
    [anon_sym_public] = ACTIONS(4392),
    [anon_sym_readonly] = ACTIONS(4392),
    [anon_sym_ref] = ACTIONS(4392),
    [anon_sym_sealed] = ACTIONS(4392),
    [anon_sym_unsafe] = ACTIONS(4392),
    [anon_sym_virtual] = ACTIONS(4392),
    [anon_sym_volatile] = ACTIONS(4392),
    [anon_sym_RBRACE] = ACTIONS(4394),
    [anon_sym_implicit] = ACTIONS(4392),
    [anon_sym_explicit] = ACTIONS(4392),
    [anon_sym_TILDE] = ACTIONS(4394),
    [anon_sym_where] = ACTIONS(4392),
    [anon_sym_class] = ACTIONS(4392),
    [anon_sym_struct] = ACTIONS(4392),
    [anon_sym_notnull] = ACTIONS(4392),
    [anon_sym_unmanaged] = ACTIONS(4392),
    [anon_sym_get] = ACTIONS(4392),
    [anon_sym_set] = ACTIONS(4392),
    [anon_sym_add] = ACTIONS(4392),
    [anon_sym_remove] = ACTIONS(4392),
    [anon_sym_enum] = ACTIONS(4392),
    [anon_sym_interface] = ACTIONS(4392),
    [anon_sym_delegate] = ACTIONS(4392),
    [anon_sym_record] = ACTIONS(4392),
    [anon_sym_namespace] = ACTIONS(4392),
    [anon_sym_var] = ACTIONS(4392),
    [sym_predefined_type] = ACTIONS(4392),
    [anon_sym_when] = ACTIONS(4392),
    [anon_sym_yield] = ACTIONS(4392),
    [anon_sym_from] = ACTIONS(4392),
    [anon_sym_join] = ACTIONS(4392),
    [anon_sym_on] = ACTIONS(4392),
    [anon_sym_equals] = ACTIONS(4392),
    [anon_sym_into] = ACTIONS(4392),
    [anon_sym_let] = ACTIONS(4392),
    [anon_sym_orderby] = ACTIONS(4392),
    [anon_sym_ascending] = ACTIONS(4392),
    [anon_sym_descending] = ACTIONS(4392),
    [anon_sym_group] = ACTIONS(4392),
    [anon_sym_by] = ACTIONS(4392),
    [anon_sym_select] = ACTIONS(4392),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4392),
    [anon_sym_nameof] = ACTIONS(4392),
    [sym_void_keyword] = ACTIONS(4392),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2424] = {
    [sym__preprocessor_call] = STATE(2424),
    [sym__identifier_token] = ACTIONS(4396),
    [anon_sym_extern] = ACTIONS(4396),
    [anon_sym_alias] = ACTIONS(4396),
    [anon_sym_global] = ACTIONS(4396),
    [anon_sym_using] = ACTIONS(4396),
    [anon_sym_static] = ACTIONS(4396),
    [anon_sym_LBRACK] = ACTIONS(4398),
    [anon_sym_event] = ACTIONS(4396),
    [anon_sym_LPAREN] = ACTIONS(4398),
    [anon_sym_abstract] = ACTIONS(4396),
    [anon_sym_async] = ACTIONS(4396),
    [anon_sym_const] = ACTIONS(4396),
    [anon_sym_fixed] = ACTIONS(4396),
    [anon_sym_internal] = ACTIONS(4396),
    [anon_sym_new] = ACTIONS(4396),
    [anon_sym_override] = ACTIONS(4396),
    [anon_sym_partial] = ACTIONS(4396),
    [anon_sym_private] = ACTIONS(4396),
    [anon_sym_protected] = ACTIONS(4396),
    [anon_sym_public] = ACTIONS(4396),
    [anon_sym_readonly] = ACTIONS(4396),
    [anon_sym_ref] = ACTIONS(4396),
    [anon_sym_sealed] = ACTIONS(4396),
    [anon_sym_unsafe] = ACTIONS(4396),
    [anon_sym_virtual] = ACTIONS(4396),
    [anon_sym_volatile] = ACTIONS(4396),
    [anon_sym_RBRACE] = ACTIONS(4398),
    [anon_sym_implicit] = ACTIONS(4396),
    [anon_sym_explicit] = ACTIONS(4396),
    [anon_sym_TILDE] = ACTIONS(4398),
    [anon_sym_where] = ACTIONS(4396),
    [anon_sym_class] = ACTIONS(4396),
    [anon_sym_struct] = ACTIONS(4396),
    [anon_sym_notnull] = ACTIONS(4396),
    [anon_sym_unmanaged] = ACTIONS(4396),
    [anon_sym_get] = ACTIONS(4396),
    [anon_sym_set] = ACTIONS(4396),
    [anon_sym_add] = ACTIONS(4396),
    [anon_sym_remove] = ACTIONS(4396),
    [anon_sym_enum] = ACTIONS(4396),
    [anon_sym_interface] = ACTIONS(4396),
    [anon_sym_delegate] = ACTIONS(4396),
    [anon_sym_record] = ACTIONS(4396),
    [anon_sym_namespace] = ACTIONS(4396),
    [anon_sym_var] = ACTIONS(4396),
    [sym_predefined_type] = ACTIONS(4396),
    [anon_sym_when] = ACTIONS(4396),
    [anon_sym_yield] = ACTIONS(4396),
    [anon_sym_from] = ACTIONS(4396),
    [anon_sym_join] = ACTIONS(4396),
    [anon_sym_on] = ACTIONS(4396),
    [anon_sym_equals] = ACTIONS(4396),
    [anon_sym_into] = ACTIONS(4396),
    [anon_sym_let] = ACTIONS(4396),
    [anon_sym_orderby] = ACTIONS(4396),
    [anon_sym_ascending] = ACTIONS(4396),
    [anon_sym_descending] = ACTIONS(4396),
    [anon_sym_group] = ACTIONS(4396),
    [anon_sym_by] = ACTIONS(4396),
    [anon_sym_select] = ACTIONS(4396),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4396),
    [anon_sym_nameof] = ACTIONS(4396),
    [sym_void_keyword] = ACTIONS(4396),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2425] = {
    [sym__preprocessor_call] = STATE(2425),
    [sym__identifier_token] = ACTIONS(2482),
    [anon_sym_extern] = ACTIONS(2482),
    [anon_sym_alias] = ACTIONS(2482),
    [anon_sym_global] = ACTIONS(2482),
    [anon_sym_using] = ACTIONS(2482),
    [anon_sym_static] = ACTIONS(2482),
    [anon_sym_LBRACK] = ACTIONS(2480),
    [anon_sym_event] = ACTIONS(2482),
    [anon_sym_LPAREN] = ACTIONS(2480),
    [anon_sym_abstract] = ACTIONS(2482),
    [anon_sym_async] = ACTIONS(2482),
    [anon_sym_const] = ACTIONS(2482),
    [anon_sym_fixed] = ACTIONS(2482),
    [anon_sym_internal] = ACTIONS(2482),
    [anon_sym_new] = ACTIONS(2482),
    [anon_sym_override] = ACTIONS(2482),
    [anon_sym_partial] = ACTIONS(2482),
    [anon_sym_private] = ACTIONS(2482),
    [anon_sym_protected] = ACTIONS(2482),
    [anon_sym_public] = ACTIONS(2482),
    [anon_sym_readonly] = ACTIONS(2482),
    [anon_sym_ref] = ACTIONS(2482),
    [anon_sym_sealed] = ACTIONS(2482),
    [anon_sym_unsafe] = ACTIONS(2482),
    [anon_sym_virtual] = ACTIONS(2482),
    [anon_sym_volatile] = ACTIONS(2482),
    [anon_sym_RBRACE] = ACTIONS(2480),
    [anon_sym_implicit] = ACTIONS(2482),
    [anon_sym_explicit] = ACTIONS(2482),
    [anon_sym_TILDE] = ACTIONS(2480),
    [anon_sym_where] = ACTIONS(2482),
    [anon_sym_class] = ACTIONS(2482),
    [anon_sym_struct] = ACTIONS(2482),
    [anon_sym_notnull] = ACTIONS(2482),
    [anon_sym_unmanaged] = ACTIONS(2482),
    [anon_sym_get] = ACTIONS(2482),
    [anon_sym_set] = ACTIONS(2482),
    [anon_sym_add] = ACTIONS(2482),
    [anon_sym_remove] = ACTIONS(2482),
    [anon_sym_enum] = ACTIONS(2482),
    [anon_sym_interface] = ACTIONS(2482),
    [anon_sym_delegate] = ACTIONS(2482),
    [anon_sym_record] = ACTIONS(2482),
    [anon_sym_namespace] = ACTIONS(2482),
    [anon_sym_var] = ACTIONS(2482),
    [sym_predefined_type] = ACTIONS(2482),
    [anon_sym_when] = ACTIONS(2482),
    [anon_sym_yield] = ACTIONS(2482),
    [anon_sym_from] = ACTIONS(2482),
    [anon_sym_join] = ACTIONS(2482),
    [anon_sym_on] = ACTIONS(2482),
    [anon_sym_equals] = ACTIONS(2482),
    [anon_sym_into] = ACTIONS(2482),
    [anon_sym_let] = ACTIONS(2482),
    [anon_sym_orderby] = ACTIONS(2482),
    [anon_sym_ascending] = ACTIONS(2482),
    [anon_sym_descending] = ACTIONS(2482),
    [anon_sym_group] = ACTIONS(2482),
    [anon_sym_by] = ACTIONS(2482),
    [anon_sym_select] = ACTIONS(2482),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2482),
    [anon_sym_nameof] = ACTIONS(2482),
    [sym_void_keyword] = ACTIONS(2482),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2426] = {
    [sym__preprocessor_call] = STATE(2426),
    [sym__identifier_token] = ACTIONS(4400),
    [anon_sym_extern] = ACTIONS(4400),
    [anon_sym_alias] = ACTIONS(4400),
    [anon_sym_global] = ACTIONS(4400),
    [anon_sym_using] = ACTIONS(4400),
    [anon_sym_static] = ACTIONS(4400),
    [anon_sym_LBRACK] = ACTIONS(4402),
    [anon_sym_event] = ACTIONS(4400),
    [anon_sym_LPAREN] = ACTIONS(4402),
    [anon_sym_abstract] = ACTIONS(4400),
    [anon_sym_async] = ACTIONS(4400),
    [anon_sym_const] = ACTIONS(4400),
    [anon_sym_fixed] = ACTIONS(4400),
    [anon_sym_internal] = ACTIONS(4400),
    [anon_sym_new] = ACTIONS(4400),
    [anon_sym_override] = ACTIONS(4400),
    [anon_sym_partial] = ACTIONS(4400),
    [anon_sym_private] = ACTIONS(4400),
    [anon_sym_protected] = ACTIONS(4400),
    [anon_sym_public] = ACTIONS(4400),
    [anon_sym_readonly] = ACTIONS(4400),
    [anon_sym_ref] = ACTIONS(4400),
    [anon_sym_sealed] = ACTIONS(4400),
    [anon_sym_unsafe] = ACTIONS(4400),
    [anon_sym_virtual] = ACTIONS(4400),
    [anon_sym_volatile] = ACTIONS(4400),
    [anon_sym_RBRACE] = ACTIONS(4402),
    [anon_sym_implicit] = ACTIONS(4400),
    [anon_sym_explicit] = ACTIONS(4400),
    [anon_sym_TILDE] = ACTIONS(4402),
    [anon_sym_where] = ACTIONS(4400),
    [anon_sym_class] = ACTIONS(4400),
    [anon_sym_struct] = ACTIONS(4400),
    [anon_sym_notnull] = ACTIONS(4400),
    [anon_sym_unmanaged] = ACTIONS(4400),
    [anon_sym_get] = ACTIONS(4400),
    [anon_sym_set] = ACTIONS(4400),
    [anon_sym_add] = ACTIONS(4400),
    [anon_sym_remove] = ACTIONS(4400),
    [anon_sym_enum] = ACTIONS(4400),
    [anon_sym_interface] = ACTIONS(4400),
    [anon_sym_delegate] = ACTIONS(4400),
    [anon_sym_record] = ACTIONS(4400),
    [anon_sym_namespace] = ACTIONS(4400),
    [anon_sym_var] = ACTIONS(4400),
    [sym_predefined_type] = ACTIONS(4400),
    [anon_sym_when] = ACTIONS(4400),
    [anon_sym_yield] = ACTIONS(4400),
    [anon_sym_from] = ACTIONS(4400),
    [anon_sym_join] = ACTIONS(4400),
    [anon_sym_on] = ACTIONS(4400),
    [anon_sym_equals] = ACTIONS(4400),
    [anon_sym_into] = ACTIONS(4400),
    [anon_sym_let] = ACTIONS(4400),
    [anon_sym_orderby] = ACTIONS(4400),
    [anon_sym_ascending] = ACTIONS(4400),
    [anon_sym_descending] = ACTIONS(4400),
    [anon_sym_group] = ACTIONS(4400),
    [anon_sym_by] = ACTIONS(4400),
    [anon_sym_select] = ACTIONS(4400),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4400),
    [anon_sym_nameof] = ACTIONS(4400),
    [sym_void_keyword] = ACTIONS(4400),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2427] = {
    [sym__preprocessor_call] = STATE(2427),
    [sym__identifier_token] = ACTIONS(2486),
    [anon_sym_extern] = ACTIONS(2486),
    [anon_sym_alias] = ACTIONS(2486),
    [anon_sym_global] = ACTIONS(2486),
    [anon_sym_using] = ACTIONS(2486),
    [anon_sym_static] = ACTIONS(2486),
    [anon_sym_LBRACK] = ACTIONS(2484),
    [anon_sym_event] = ACTIONS(2486),
    [anon_sym_LPAREN] = ACTIONS(2484),
    [anon_sym_abstract] = ACTIONS(2486),
    [anon_sym_async] = ACTIONS(2486),
    [anon_sym_const] = ACTIONS(2486),
    [anon_sym_fixed] = ACTIONS(2486),
    [anon_sym_internal] = ACTIONS(2486),
    [anon_sym_new] = ACTIONS(2486),
    [anon_sym_override] = ACTIONS(2486),
    [anon_sym_partial] = ACTIONS(2486),
    [anon_sym_private] = ACTIONS(2486),
    [anon_sym_protected] = ACTIONS(2486),
    [anon_sym_public] = ACTIONS(2486),
    [anon_sym_readonly] = ACTIONS(2486),
    [anon_sym_ref] = ACTIONS(2486),
    [anon_sym_sealed] = ACTIONS(2486),
    [anon_sym_unsafe] = ACTIONS(2486),
    [anon_sym_virtual] = ACTIONS(2486),
    [anon_sym_volatile] = ACTIONS(2486),
    [anon_sym_RBRACE] = ACTIONS(2484),
    [anon_sym_implicit] = ACTIONS(2486),
    [anon_sym_explicit] = ACTIONS(2486),
    [anon_sym_TILDE] = ACTIONS(2484),
    [anon_sym_where] = ACTIONS(2486),
    [anon_sym_class] = ACTIONS(2486),
    [anon_sym_struct] = ACTIONS(2486),
    [anon_sym_notnull] = ACTIONS(2486),
    [anon_sym_unmanaged] = ACTIONS(2486),
    [anon_sym_get] = ACTIONS(2486),
    [anon_sym_set] = ACTIONS(2486),
    [anon_sym_add] = ACTIONS(2486),
    [anon_sym_remove] = ACTIONS(2486),
    [anon_sym_enum] = ACTIONS(2486),
    [anon_sym_interface] = ACTIONS(2486),
    [anon_sym_delegate] = ACTIONS(2486),
    [anon_sym_record] = ACTIONS(2486),
    [anon_sym_namespace] = ACTIONS(2486),
    [anon_sym_var] = ACTIONS(2486),
    [sym_predefined_type] = ACTIONS(2486),
    [anon_sym_when] = ACTIONS(2486),
    [anon_sym_yield] = ACTIONS(2486),
    [anon_sym_from] = ACTIONS(2486),
    [anon_sym_join] = ACTIONS(2486),
    [anon_sym_on] = ACTIONS(2486),
    [anon_sym_equals] = ACTIONS(2486),
    [anon_sym_into] = ACTIONS(2486),
    [anon_sym_let] = ACTIONS(2486),
    [anon_sym_orderby] = ACTIONS(2486),
    [anon_sym_ascending] = ACTIONS(2486),
    [anon_sym_descending] = ACTIONS(2486),
    [anon_sym_group] = ACTIONS(2486),
    [anon_sym_by] = ACTIONS(2486),
    [anon_sym_select] = ACTIONS(2486),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2486),
    [anon_sym_nameof] = ACTIONS(2486),
    [sym_void_keyword] = ACTIONS(2486),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2428] = {
    [sym__preprocessor_call] = STATE(2428),
    [sym__identifier_token] = ACTIONS(4404),
    [anon_sym_extern] = ACTIONS(4404),
    [anon_sym_alias] = ACTIONS(4404),
    [anon_sym_global] = ACTIONS(4404),
    [anon_sym_using] = ACTIONS(4404),
    [anon_sym_static] = ACTIONS(4404),
    [anon_sym_LBRACK] = ACTIONS(4406),
    [anon_sym_event] = ACTIONS(4404),
    [anon_sym_LPAREN] = ACTIONS(4406),
    [anon_sym_abstract] = ACTIONS(4404),
    [anon_sym_async] = ACTIONS(4404),
    [anon_sym_const] = ACTIONS(4404),
    [anon_sym_fixed] = ACTIONS(4404),
    [anon_sym_internal] = ACTIONS(4404),
    [anon_sym_new] = ACTIONS(4404),
    [anon_sym_override] = ACTIONS(4404),
    [anon_sym_partial] = ACTIONS(4404),
    [anon_sym_private] = ACTIONS(4404),
    [anon_sym_protected] = ACTIONS(4404),
    [anon_sym_public] = ACTIONS(4404),
    [anon_sym_readonly] = ACTIONS(4404),
    [anon_sym_ref] = ACTIONS(4404),
    [anon_sym_sealed] = ACTIONS(4404),
    [anon_sym_unsafe] = ACTIONS(4404),
    [anon_sym_virtual] = ACTIONS(4404),
    [anon_sym_volatile] = ACTIONS(4404),
    [anon_sym_RBRACE] = ACTIONS(4406),
    [anon_sym_implicit] = ACTIONS(4404),
    [anon_sym_explicit] = ACTIONS(4404),
    [anon_sym_TILDE] = ACTIONS(4406),
    [anon_sym_where] = ACTIONS(4404),
    [anon_sym_class] = ACTIONS(4404),
    [anon_sym_struct] = ACTIONS(4404),
    [anon_sym_notnull] = ACTIONS(4404),
    [anon_sym_unmanaged] = ACTIONS(4404),
    [anon_sym_get] = ACTIONS(4404),
    [anon_sym_set] = ACTIONS(4404),
    [anon_sym_add] = ACTIONS(4404),
    [anon_sym_remove] = ACTIONS(4404),
    [anon_sym_enum] = ACTIONS(4404),
    [anon_sym_interface] = ACTIONS(4404),
    [anon_sym_delegate] = ACTIONS(4404),
    [anon_sym_record] = ACTIONS(4404),
    [anon_sym_namespace] = ACTIONS(4404),
    [anon_sym_var] = ACTIONS(4404),
    [sym_predefined_type] = ACTIONS(4404),
    [anon_sym_when] = ACTIONS(4404),
    [anon_sym_yield] = ACTIONS(4404),
    [anon_sym_from] = ACTIONS(4404),
    [anon_sym_join] = ACTIONS(4404),
    [anon_sym_on] = ACTIONS(4404),
    [anon_sym_equals] = ACTIONS(4404),
    [anon_sym_into] = ACTIONS(4404),
    [anon_sym_let] = ACTIONS(4404),
    [anon_sym_orderby] = ACTIONS(4404),
    [anon_sym_ascending] = ACTIONS(4404),
    [anon_sym_descending] = ACTIONS(4404),
    [anon_sym_group] = ACTIONS(4404),
    [anon_sym_by] = ACTIONS(4404),
    [anon_sym_select] = ACTIONS(4404),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4404),
    [anon_sym_nameof] = ACTIONS(4404),
    [sym_void_keyword] = ACTIONS(4404),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2429] = {
    [sym__preprocessor_call] = STATE(2429),
    [sym__identifier_token] = ACTIONS(4408),
    [anon_sym_extern] = ACTIONS(4408),
    [anon_sym_alias] = ACTIONS(4408),
    [anon_sym_global] = ACTIONS(4408),
    [anon_sym_using] = ACTIONS(4408),
    [anon_sym_static] = ACTIONS(4408),
    [anon_sym_LBRACK] = ACTIONS(4410),
    [anon_sym_event] = ACTIONS(4408),
    [anon_sym_LPAREN] = ACTIONS(4410),
    [anon_sym_abstract] = ACTIONS(4408),
    [anon_sym_async] = ACTIONS(4408),
    [anon_sym_const] = ACTIONS(4408),
    [anon_sym_fixed] = ACTIONS(4408),
    [anon_sym_internal] = ACTIONS(4408),
    [anon_sym_new] = ACTIONS(4408),
    [anon_sym_override] = ACTIONS(4408),
    [anon_sym_partial] = ACTIONS(4408),
    [anon_sym_private] = ACTIONS(4408),
    [anon_sym_protected] = ACTIONS(4408),
    [anon_sym_public] = ACTIONS(4408),
    [anon_sym_readonly] = ACTIONS(4408),
    [anon_sym_ref] = ACTIONS(4408),
    [anon_sym_sealed] = ACTIONS(4408),
    [anon_sym_unsafe] = ACTIONS(4408),
    [anon_sym_virtual] = ACTIONS(4408),
    [anon_sym_volatile] = ACTIONS(4408),
    [anon_sym_RBRACE] = ACTIONS(4410),
    [anon_sym_implicit] = ACTIONS(4408),
    [anon_sym_explicit] = ACTIONS(4408),
    [anon_sym_TILDE] = ACTIONS(4410),
    [anon_sym_where] = ACTIONS(4408),
    [anon_sym_class] = ACTIONS(4408),
    [anon_sym_struct] = ACTIONS(4408),
    [anon_sym_notnull] = ACTIONS(4408),
    [anon_sym_unmanaged] = ACTIONS(4408),
    [anon_sym_get] = ACTIONS(4408),
    [anon_sym_set] = ACTIONS(4408),
    [anon_sym_add] = ACTIONS(4408),
    [anon_sym_remove] = ACTIONS(4408),
    [anon_sym_enum] = ACTIONS(4408),
    [anon_sym_interface] = ACTIONS(4408),
    [anon_sym_delegate] = ACTIONS(4408),
    [anon_sym_record] = ACTIONS(4408),
    [anon_sym_namespace] = ACTIONS(4408),
    [anon_sym_var] = ACTIONS(4408),
    [sym_predefined_type] = ACTIONS(4408),
    [anon_sym_when] = ACTIONS(4408),
    [anon_sym_yield] = ACTIONS(4408),
    [anon_sym_from] = ACTIONS(4408),
    [anon_sym_join] = ACTIONS(4408),
    [anon_sym_on] = ACTIONS(4408),
    [anon_sym_equals] = ACTIONS(4408),
    [anon_sym_into] = ACTIONS(4408),
    [anon_sym_let] = ACTIONS(4408),
    [anon_sym_orderby] = ACTIONS(4408),
    [anon_sym_ascending] = ACTIONS(4408),
    [anon_sym_descending] = ACTIONS(4408),
    [anon_sym_group] = ACTIONS(4408),
    [anon_sym_by] = ACTIONS(4408),
    [anon_sym_select] = ACTIONS(4408),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4408),
    [anon_sym_nameof] = ACTIONS(4408),
    [sym_void_keyword] = ACTIONS(4408),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2430] = {
    [sym__preprocessor_call] = STATE(2430),
    [sym__identifier_token] = ACTIONS(4412),
    [anon_sym_extern] = ACTIONS(4412),
    [anon_sym_alias] = ACTIONS(4412),
    [anon_sym_global] = ACTIONS(4412),
    [anon_sym_using] = ACTIONS(4412),
    [anon_sym_static] = ACTIONS(4412),
    [anon_sym_LBRACK] = ACTIONS(4414),
    [anon_sym_event] = ACTIONS(4412),
    [anon_sym_LPAREN] = ACTIONS(4414),
    [anon_sym_abstract] = ACTIONS(4412),
    [anon_sym_async] = ACTIONS(4412),
    [anon_sym_const] = ACTIONS(4412),
    [anon_sym_fixed] = ACTIONS(4412),
    [anon_sym_internal] = ACTIONS(4412),
    [anon_sym_new] = ACTIONS(4412),
    [anon_sym_override] = ACTIONS(4412),
    [anon_sym_partial] = ACTIONS(4412),
    [anon_sym_private] = ACTIONS(4412),
    [anon_sym_protected] = ACTIONS(4412),
    [anon_sym_public] = ACTIONS(4412),
    [anon_sym_readonly] = ACTIONS(4412),
    [anon_sym_ref] = ACTIONS(4412),
    [anon_sym_sealed] = ACTIONS(4412),
    [anon_sym_unsafe] = ACTIONS(4412),
    [anon_sym_virtual] = ACTIONS(4412),
    [anon_sym_volatile] = ACTIONS(4412),
    [anon_sym_RBRACE] = ACTIONS(4414),
    [anon_sym_implicit] = ACTIONS(4412),
    [anon_sym_explicit] = ACTIONS(4412),
    [anon_sym_TILDE] = ACTIONS(4414),
    [anon_sym_where] = ACTIONS(4412),
    [anon_sym_class] = ACTIONS(4412),
    [anon_sym_struct] = ACTIONS(4412),
    [anon_sym_notnull] = ACTIONS(4412),
    [anon_sym_unmanaged] = ACTIONS(4412),
    [anon_sym_get] = ACTIONS(4412),
    [anon_sym_set] = ACTIONS(4412),
    [anon_sym_add] = ACTIONS(4412),
    [anon_sym_remove] = ACTIONS(4412),
    [anon_sym_enum] = ACTIONS(4412),
    [anon_sym_interface] = ACTIONS(4412),
    [anon_sym_delegate] = ACTIONS(4412),
    [anon_sym_record] = ACTIONS(4412),
    [anon_sym_namespace] = ACTIONS(4412),
    [anon_sym_var] = ACTIONS(4412),
    [sym_predefined_type] = ACTIONS(4412),
    [anon_sym_when] = ACTIONS(4412),
    [anon_sym_yield] = ACTIONS(4412),
    [anon_sym_from] = ACTIONS(4412),
    [anon_sym_join] = ACTIONS(4412),
    [anon_sym_on] = ACTIONS(4412),
    [anon_sym_equals] = ACTIONS(4412),
    [anon_sym_into] = ACTIONS(4412),
    [anon_sym_let] = ACTIONS(4412),
    [anon_sym_orderby] = ACTIONS(4412),
    [anon_sym_ascending] = ACTIONS(4412),
    [anon_sym_descending] = ACTIONS(4412),
    [anon_sym_group] = ACTIONS(4412),
    [anon_sym_by] = ACTIONS(4412),
    [anon_sym_select] = ACTIONS(4412),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4412),
    [anon_sym_nameof] = ACTIONS(4412),
    [sym_void_keyword] = ACTIONS(4412),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2431] = {
    [sym__preprocessor_call] = STATE(2431),
    [sym__identifier_token] = ACTIONS(4416),
    [anon_sym_extern] = ACTIONS(4416),
    [anon_sym_alias] = ACTIONS(4416),
    [anon_sym_global] = ACTIONS(4416),
    [anon_sym_using] = ACTIONS(4416),
    [anon_sym_static] = ACTIONS(4416),
    [anon_sym_LBRACK] = ACTIONS(4418),
    [anon_sym_event] = ACTIONS(4416),
    [anon_sym_LPAREN] = ACTIONS(4418),
    [anon_sym_abstract] = ACTIONS(4416),
    [anon_sym_async] = ACTIONS(4416),
    [anon_sym_const] = ACTIONS(4416),
    [anon_sym_fixed] = ACTIONS(4416),
    [anon_sym_internal] = ACTIONS(4416),
    [anon_sym_new] = ACTIONS(4416),
    [anon_sym_override] = ACTIONS(4416),
    [anon_sym_partial] = ACTIONS(4416),
    [anon_sym_private] = ACTIONS(4416),
    [anon_sym_protected] = ACTIONS(4416),
    [anon_sym_public] = ACTIONS(4416),
    [anon_sym_readonly] = ACTIONS(4416),
    [anon_sym_ref] = ACTIONS(4416),
    [anon_sym_sealed] = ACTIONS(4416),
    [anon_sym_unsafe] = ACTIONS(4416),
    [anon_sym_virtual] = ACTIONS(4416),
    [anon_sym_volatile] = ACTIONS(4416),
    [anon_sym_RBRACE] = ACTIONS(4418),
    [anon_sym_implicit] = ACTIONS(4416),
    [anon_sym_explicit] = ACTIONS(4416),
    [anon_sym_TILDE] = ACTIONS(4418),
    [anon_sym_where] = ACTIONS(4416),
    [anon_sym_class] = ACTIONS(4416),
    [anon_sym_struct] = ACTIONS(4416),
    [anon_sym_notnull] = ACTIONS(4416),
    [anon_sym_unmanaged] = ACTIONS(4416),
    [anon_sym_get] = ACTIONS(4416),
    [anon_sym_set] = ACTIONS(4416),
    [anon_sym_add] = ACTIONS(4416),
    [anon_sym_remove] = ACTIONS(4416),
    [anon_sym_enum] = ACTIONS(4416),
    [anon_sym_interface] = ACTIONS(4416),
    [anon_sym_delegate] = ACTIONS(4416),
    [anon_sym_record] = ACTIONS(4416),
    [anon_sym_namespace] = ACTIONS(4416),
    [anon_sym_var] = ACTIONS(4416),
    [sym_predefined_type] = ACTIONS(4416),
    [anon_sym_when] = ACTIONS(4416),
    [anon_sym_yield] = ACTIONS(4416),
    [anon_sym_from] = ACTIONS(4416),
    [anon_sym_join] = ACTIONS(4416),
    [anon_sym_on] = ACTIONS(4416),
    [anon_sym_equals] = ACTIONS(4416),
    [anon_sym_into] = ACTIONS(4416),
    [anon_sym_let] = ACTIONS(4416),
    [anon_sym_orderby] = ACTIONS(4416),
    [anon_sym_ascending] = ACTIONS(4416),
    [anon_sym_descending] = ACTIONS(4416),
    [anon_sym_group] = ACTIONS(4416),
    [anon_sym_by] = ACTIONS(4416),
    [anon_sym_select] = ACTIONS(4416),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4416),
    [anon_sym_nameof] = ACTIONS(4416),
    [sym_void_keyword] = ACTIONS(4416),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2432] = {
    [sym__preprocessor_call] = STATE(2432),
    [sym__identifier_token] = ACTIONS(4420),
    [anon_sym_extern] = ACTIONS(4420),
    [anon_sym_alias] = ACTIONS(4420),
    [anon_sym_global] = ACTIONS(4420),
    [anon_sym_using] = ACTIONS(4420),
    [anon_sym_static] = ACTIONS(4420),
    [anon_sym_LBRACK] = ACTIONS(4422),
    [anon_sym_event] = ACTIONS(4420),
    [anon_sym_LPAREN] = ACTIONS(4422),
    [anon_sym_abstract] = ACTIONS(4420),
    [anon_sym_async] = ACTIONS(4420),
    [anon_sym_const] = ACTIONS(4420),
    [anon_sym_fixed] = ACTIONS(4420),
    [anon_sym_internal] = ACTIONS(4420),
    [anon_sym_new] = ACTIONS(4420),
    [anon_sym_override] = ACTIONS(4420),
    [anon_sym_partial] = ACTIONS(4420),
    [anon_sym_private] = ACTIONS(4420),
    [anon_sym_protected] = ACTIONS(4420),
    [anon_sym_public] = ACTIONS(4420),
    [anon_sym_readonly] = ACTIONS(4420),
    [anon_sym_ref] = ACTIONS(4420),
    [anon_sym_sealed] = ACTIONS(4420),
    [anon_sym_unsafe] = ACTIONS(4420),
    [anon_sym_virtual] = ACTIONS(4420),
    [anon_sym_volatile] = ACTIONS(4420),
    [anon_sym_RBRACE] = ACTIONS(4422),
    [anon_sym_implicit] = ACTIONS(4420),
    [anon_sym_explicit] = ACTIONS(4420),
    [anon_sym_TILDE] = ACTIONS(4422),
    [anon_sym_where] = ACTIONS(4420),
    [anon_sym_class] = ACTIONS(4420),
    [anon_sym_struct] = ACTIONS(4420),
    [anon_sym_notnull] = ACTIONS(4420),
    [anon_sym_unmanaged] = ACTIONS(4420),
    [anon_sym_get] = ACTIONS(4420),
    [anon_sym_set] = ACTIONS(4420),
    [anon_sym_add] = ACTIONS(4420),
    [anon_sym_remove] = ACTIONS(4420),
    [anon_sym_enum] = ACTIONS(4420),
    [anon_sym_interface] = ACTIONS(4420),
    [anon_sym_delegate] = ACTIONS(4420),
    [anon_sym_record] = ACTIONS(4420),
    [anon_sym_namespace] = ACTIONS(4420),
    [anon_sym_var] = ACTIONS(4420),
    [sym_predefined_type] = ACTIONS(4420),
    [anon_sym_when] = ACTIONS(4420),
    [anon_sym_yield] = ACTIONS(4420),
    [anon_sym_from] = ACTIONS(4420),
    [anon_sym_join] = ACTIONS(4420),
    [anon_sym_on] = ACTIONS(4420),
    [anon_sym_equals] = ACTIONS(4420),
    [anon_sym_into] = ACTIONS(4420),
    [anon_sym_let] = ACTIONS(4420),
    [anon_sym_orderby] = ACTIONS(4420),
    [anon_sym_ascending] = ACTIONS(4420),
    [anon_sym_descending] = ACTIONS(4420),
    [anon_sym_group] = ACTIONS(4420),
    [anon_sym_by] = ACTIONS(4420),
    [anon_sym_select] = ACTIONS(4420),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4420),
    [anon_sym_nameof] = ACTIONS(4420),
    [sym_void_keyword] = ACTIONS(4420),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2433] = {
    [sym__preprocessor_call] = STATE(2433),
    [sym__identifier_token] = ACTIONS(4424),
    [anon_sym_extern] = ACTIONS(4424),
    [anon_sym_alias] = ACTIONS(4424),
    [anon_sym_global] = ACTIONS(4424),
    [anon_sym_using] = ACTIONS(4424),
    [anon_sym_static] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4426),
    [anon_sym_event] = ACTIONS(4424),
    [anon_sym_LPAREN] = ACTIONS(4426),
    [anon_sym_abstract] = ACTIONS(4424),
    [anon_sym_async] = ACTIONS(4424),
    [anon_sym_const] = ACTIONS(4424),
    [anon_sym_fixed] = ACTIONS(4424),
    [anon_sym_internal] = ACTIONS(4424),
    [anon_sym_new] = ACTIONS(4424),
    [anon_sym_override] = ACTIONS(4424),
    [anon_sym_partial] = ACTIONS(4424),
    [anon_sym_private] = ACTIONS(4424),
    [anon_sym_protected] = ACTIONS(4424),
    [anon_sym_public] = ACTIONS(4424),
    [anon_sym_readonly] = ACTIONS(4424),
    [anon_sym_ref] = ACTIONS(4424),
    [anon_sym_sealed] = ACTIONS(4424),
    [anon_sym_unsafe] = ACTIONS(4424),
    [anon_sym_virtual] = ACTIONS(4424),
    [anon_sym_volatile] = ACTIONS(4424),
    [anon_sym_RBRACE] = ACTIONS(4426),
    [anon_sym_implicit] = ACTIONS(4424),
    [anon_sym_explicit] = ACTIONS(4424),
    [anon_sym_TILDE] = ACTIONS(4426),
    [anon_sym_where] = ACTIONS(4424),
    [anon_sym_class] = ACTIONS(4424),
    [anon_sym_struct] = ACTIONS(4424),
    [anon_sym_notnull] = ACTIONS(4424),
    [anon_sym_unmanaged] = ACTIONS(4424),
    [anon_sym_get] = ACTIONS(4424),
    [anon_sym_set] = ACTIONS(4424),
    [anon_sym_add] = ACTIONS(4424),
    [anon_sym_remove] = ACTIONS(4424),
    [anon_sym_enum] = ACTIONS(4424),
    [anon_sym_interface] = ACTIONS(4424),
    [anon_sym_delegate] = ACTIONS(4424),
    [anon_sym_record] = ACTIONS(4424),
    [anon_sym_namespace] = ACTIONS(4424),
    [anon_sym_var] = ACTIONS(4424),
    [sym_predefined_type] = ACTIONS(4424),
    [anon_sym_when] = ACTIONS(4424),
    [anon_sym_yield] = ACTIONS(4424),
    [anon_sym_from] = ACTIONS(4424),
    [anon_sym_join] = ACTIONS(4424),
    [anon_sym_on] = ACTIONS(4424),
    [anon_sym_equals] = ACTIONS(4424),
    [anon_sym_into] = ACTIONS(4424),
    [anon_sym_let] = ACTIONS(4424),
    [anon_sym_orderby] = ACTIONS(4424),
    [anon_sym_ascending] = ACTIONS(4424),
    [anon_sym_descending] = ACTIONS(4424),
    [anon_sym_group] = ACTIONS(4424),
    [anon_sym_by] = ACTIONS(4424),
    [anon_sym_select] = ACTIONS(4424),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4424),
    [anon_sym_nameof] = ACTIONS(4424),
    [sym_void_keyword] = ACTIONS(4424),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2434] = {
    [sym__preprocessor_call] = STATE(2434),
    [sym__identifier_token] = ACTIONS(4428),
    [anon_sym_extern] = ACTIONS(4428),
    [anon_sym_alias] = ACTIONS(4428),
    [anon_sym_global] = ACTIONS(4428),
    [anon_sym_using] = ACTIONS(4428),
    [anon_sym_static] = ACTIONS(4428),
    [anon_sym_LBRACK] = ACTIONS(4430),
    [anon_sym_event] = ACTIONS(4428),
    [anon_sym_LPAREN] = ACTIONS(4430),
    [anon_sym_abstract] = ACTIONS(4428),
    [anon_sym_async] = ACTIONS(4428),
    [anon_sym_const] = ACTIONS(4428),
    [anon_sym_fixed] = ACTIONS(4428),
    [anon_sym_internal] = ACTIONS(4428),
    [anon_sym_new] = ACTIONS(4428),
    [anon_sym_override] = ACTIONS(4428),
    [anon_sym_partial] = ACTIONS(4428),
    [anon_sym_private] = ACTIONS(4428),
    [anon_sym_protected] = ACTIONS(4428),
    [anon_sym_public] = ACTIONS(4428),
    [anon_sym_readonly] = ACTIONS(4428),
    [anon_sym_ref] = ACTIONS(4428),
    [anon_sym_sealed] = ACTIONS(4428),
    [anon_sym_unsafe] = ACTIONS(4428),
    [anon_sym_virtual] = ACTIONS(4428),
    [anon_sym_volatile] = ACTIONS(4428),
    [anon_sym_RBRACE] = ACTIONS(4430),
    [anon_sym_implicit] = ACTIONS(4428),
    [anon_sym_explicit] = ACTIONS(4428),
    [anon_sym_TILDE] = ACTIONS(4430),
    [anon_sym_where] = ACTIONS(4428),
    [anon_sym_class] = ACTIONS(4428),
    [anon_sym_struct] = ACTIONS(4428),
    [anon_sym_notnull] = ACTIONS(4428),
    [anon_sym_unmanaged] = ACTIONS(4428),
    [anon_sym_get] = ACTIONS(4428),
    [anon_sym_set] = ACTIONS(4428),
    [anon_sym_add] = ACTIONS(4428),
    [anon_sym_remove] = ACTIONS(4428),
    [anon_sym_enum] = ACTIONS(4428),
    [anon_sym_interface] = ACTIONS(4428),
    [anon_sym_delegate] = ACTIONS(4428),
    [anon_sym_record] = ACTIONS(4428),
    [anon_sym_namespace] = ACTIONS(4428),
    [anon_sym_var] = ACTIONS(4428),
    [sym_predefined_type] = ACTIONS(4428),
    [anon_sym_when] = ACTIONS(4428),
    [anon_sym_yield] = ACTIONS(4428),
    [anon_sym_from] = ACTIONS(4428),
    [anon_sym_join] = ACTIONS(4428),
    [anon_sym_on] = ACTIONS(4428),
    [anon_sym_equals] = ACTIONS(4428),
    [anon_sym_into] = ACTIONS(4428),
    [anon_sym_let] = ACTIONS(4428),
    [anon_sym_orderby] = ACTIONS(4428),
    [anon_sym_ascending] = ACTIONS(4428),
    [anon_sym_descending] = ACTIONS(4428),
    [anon_sym_group] = ACTIONS(4428),
    [anon_sym_by] = ACTIONS(4428),
    [anon_sym_select] = ACTIONS(4428),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4428),
    [anon_sym_nameof] = ACTIONS(4428),
    [sym_void_keyword] = ACTIONS(4428),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2435] = {
    [sym__preprocessor_call] = STATE(2435),
    [sym__identifier_token] = ACTIONS(4432),
    [anon_sym_extern] = ACTIONS(4432),
    [anon_sym_alias] = ACTIONS(4432),
    [anon_sym_global] = ACTIONS(4432),
    [anon_sym_using] = ACTIONS(4432),
    [anon_sym_static] = ACTIONS(4432),
    [anon_sym_LBRACK] = ACTIONS(4434),
    [anon_sym_event] = ACTIONS(4432),
    [anon_sym_LPAREN] = ACTIONS(4434),
    [anon_sym_abstract] = ACTIONS(4432),
    [anon_sym_async] = ACTIONS(4432),
    [anon_sym_const] = ACTIONS(4432),
    [anon_sym_fixed] = ACTIONS(4432),
    [anon_sym_internal] = ACTIONS(4432),
    [anon_sym_new] = ACTIONS(4432),
    [anon_sym_override] = ACTIONS(4432),
    [anon_sym_partial] = ACTIONS(4432),
    [anon_sym_private] = ACTIONS(4432),
    [anon_sym_protected] = ACTIONS(4432),
    [anon_sym_public] = ACTIONS(4432),
    [anon_sym_readonly] = ACTIONS(4432),
    [anon_sym_ref] = ACTIONS(4432),
    [anon_sym_sealed] = ACTIONS(4432),
    [anon_sym_unsafe] = ACTIONS(4432),
    [anon_sym_virtual] = ACTIONS(4432),
    [anon_sym_volatile] = ACTIONS(4432),
    [anon_sym_RBRACE] = ACTIONS(4434),
    [anon_sym_implicit] = ACTIONS(4432),
    [anon_sym_explicit] = ACTIONS(4432),
    [anon_sym_TILDE] = ACTIONS(4434),
    [anon_sym_where] = ACTIONS(4432),
    [anon_sym_class] = ACTIONS(4432),
    [anon_sym_struct] = ACTIONS(4432),
    [anon_sym_notnull] = ACTIONS(4432),
    [anon_sym_unmanaged] = ACTIONS(4432),
    [anon_sym_get] = ACTIONS(4432),
    [anon_sym_set] = ACTIONS(4432),
    [anon_sym_add] = ACTIONS(4432),
    [anon_sym_remove] = ACTIONS(4432),
    [anon_sym_enum] = ACTIONS(4432),
    [anon_sym_interface] = ACTIONS(4432),
    [anon_sym_delegate] = ACTIONS(4432),
    [anon_sym_record] = ACTIONS(4432),
    [anon_sym_namespace] = ACTIONS(4432),
    [anon_sym_var] = ACTIONS(4432),
    [sym_predefined_type] = ACTIONS(4432),
    [anon_sym_when] = ACTIONS(4432),
    [anon_sym_yield] = ACTIONS(4432),
    [anon_sym_from] = ACTIONS(4432),
    [anon_sym_join] = ACTIONS(4432),
    [anon_sym_on] = ACTIONS(4432),
    [anon_sym_equals] = ACTIONS(4432),
    [anon_sym_into] = ACTIONS(4432),
    [anon_sym_let] = ACTIONS(4432),
    [anon_sym_orderby] = ACTIONS(4432),
    [anon_sym_ascending] = ACTIONS(4432),
    [anon_sym_descending] = ACTIONS(4432),
    [anon_sym_group] = ACTIONS(4432),
    [anon_sym_by] = ACTIONS(4432),
    [anon_sym_select] = ACTIONS(4432),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4432),
    [anon_sym_nameof] = ACTIONS(4432),
    [sym_void_keyword] = ACTIONS(4432),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2436] = {
    [sym__preprocessor_call] = STATE(2436),
    [sym__identifier_token] = ACTIONS(4436),
    [anon_sym_extern] = ACTIONS(4436),
    [anon_sym_alias] = ACTIONS(4436),
    [anon_sym_global] = ACTIONS(4436),
    [anon_sym_using] = ACTIONS(4436),
    [anon_sym_static] = ACTIONS(4436),
    [anon_sym_LBRACK] = ACTIONS(4438),
    [anon_sym_event] = ACTIONS(4436),
    [anon_sym_LPAREN] = ACTIONS(4438),
    [anon_sym_abstract] = ACTIONS(4436),
    [anon_sym_async] = ACTIONS(4436),
    [anon_sym_const] = ACTIONS(4436),
    [anon_sym_fixed] = ACTIONS(4436),
    [anon_sym_internal] = ACTIONS(4436),
    [anon_sym_new] = ACTIONS(4436),
    [anon_sym_override] = ACTIONS(4436),
    [anon_sym_partial] = ACTIONS(4436),
    [anon_sym_private] = ACTIONS(4436),
    [anon_sym_protected] = ACTIONS(4436),
    [anon_sym_public] = ACTIONS(4436),
    [anon_sym_readonly] = ACTIONS(4436),
    [anon_sym_ref] = ACTIONS(4436),
    [anon_sym_sealed] = ACTIONS(4436),
    [anon_sym_unsafe] = ACTIONS(4436),
    [anon_sym_virtual] = ACTIONS(4436),
    [anon_sym_volatile] = ACTIONS(4436),
    [anon_sym_RBRACE] = ACTIONS(4438),
    [anon_sym_implicit] = ACTIONS(4436),
    [anon_sym_explicit] = ACTIONS(4436),
    [anon_sym_TILDE] = ACTIONS(4438),
    [anon_sym_where] = ACTIONS(4436),
    [anon_sym_class] = ACTIONS(4436),
    [anon_sym_struct] = ACTIONS(4436),
    [anon_sym_notnull] = ACTIONS(4436),
    [anon_sym_unmanaged] = ACTIONS(4436),
    [anon_sym_get] = ACTIONS(4436),
    [anon_sym_set] = ACTIONS(4436),
    [anon_sym_add] = ACTIONS(4436),
    [anon_sym_remove] = ACTIONS(4436),
    [anon_sym_enum] = ACTIONS(4436),
    [anon_sym_interface] = ACTIONS(4436),
    [anon_sym_delegate] = ACTIONS(4436),
    [anon_sym_record] = ACTIONS(4436),
    [anon_sym_namespace] = ACTIONS(4436),
    [anon_sym_var] = ACTIONS(4436),
    [sym_predefined_type] = ACTIONS(4436),
    [anon_sym_when] = ACTIONS(4436),
    [anon_sym_yield] = ACTIONS(4436),
    [anon_sym_from] = ACTIONS(4436),
    [anon_sym_join] = ACTIONS(4436),
    [anon_sym_on] = ACTIONS(4436),
    [anon_sym_equals] = ACTIONS(4436),
    [anon_sym_into] = ACTIONS(4436),
    [anon_sym_let] = ACTIONS(4436),
    [anon_sym_orderby] = ACTIONS(4436),
    [anon_sym_ascending] = ACTIONS(4436),
    [anon_sym_descending] = ACTIONS(4436),
    [anon_sym_group] = ACTIONS(4436),
    [anon_sym_by] = ACTIONS(4436),
    [anon_sym_select] = ACTIONS(4436),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4436),
    [anon_sym_nameof] = ACTIONS(4436),
    [sym_void_keyword] = ACTIONS(4436),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2437] = {
    [sym__preprocessor_call] = STATE(2437),
    [sym__identifier_token] = ACTIONS(4440),
    [anon_sym_extern] = ACTIONS(4440),
    [anon_sym_alias] = ACTIONS(4440),
    [anon_sym_global] = ACTIONS(4440),
    [anon_sym_using] = ACTIONS(4440),
    [anon_sym_static] = ACTIONS(4440),
    [anon_sym_LBRACK] = ACTIONS(4442),
    [anon_sym_event] = ACTIONS(4440),
    [anon_sym_LPAREN] = ACTIONS(4442),
    [anon_sym_abstract] = ACTIONS(4440),
    [anon_sym_async] = ACTIONS(4440),
    [anon_sym_const] = ACTIONS(4440),
    [anon_sym_fixed] = ACTIONS(4440),
    [anon_sym_internal] = ACTIONS(4440),
    [anon_sym_new] = ACTIONS(4440),
    [anon_sym_override] = ACTIONS(4440),
    [anon_sym_partial] = ACTIONS(4440),
    [anon_sym_private] = ACTIONS(4440),
    [anon_sym_protected] = ACTIONS(4440),
    [anon_sym_public] = ACTIONS(4440),
    [anon_sym_readonly] = ACTIONS(4440),
    [anon_sym_ref] = ACTIONS(4440),
    [anon_sym_sealed] = ACTIONS(4440),
    [anon_sym_unsafe] = ACTIONS(4440),
    [anon_sym_virtual] = ACTIONS(4440),
    [anon_sym_volatile] = ACTIONS(4440),
    [anon_sym_RBRACE] = ACTIONS(4442),
    [anon_sym_implicit] = ACTIONS(4440),
    [anon_sym_explicit] = ACTIONS(4440),
    [anon_sym_TILDE] = ACTIONS(4442),
    [anon_sym_where] = ACTIONS(4440),
    [anon_sym_class] = ACTIONS(4440),
    [anon_sym_struct] = ACTIONS(4440),
    [anon_sym_notnull] = ACTIONS(4440),
    [anon_sym_unmanaged] = ACTIONS(4440),
    [anon_sym_get] = ACTIONS(4440),
    [anon_sym_set] = ACTIONS(4440),
    [anon_sym_add] = ACTIONS(4440),
    [anon_sym_remove] = ACTIONS(4440),
    [anon_sym_enum] = ACTIONS(4440),
    [anon_sym_interface] = ACTIONS(4440),
    [anon_sym_delegate] = ACTIONS(4440),
    [anon_sym_record] = ACTIONS(4440),
    [anon_sym_namespace] = ACTIONS(4440),
    [anon_sym_var] = ACTIONS(4440),
    [sym_predefined_type] = ACTIONS(4440),
    [anon_sym_when] = ACTIONS(4440),
    [anon_sym_yield] = ACTIONS(4440),
    [anon_sym_from] = ACTIONS(4440),
    [anon_sym_join] = ACTIONS(4440),
    [anon_sym_on] = ACTIONS(4440),
    [anon_sym_equals] = ACTIONS(4440),
    [anon_sym_into] = ACTIONS(4440),
    [anon_sym_let] = ACTIONS(4440),
    [anon_sym_orderby] = ACTIONS(4440),
    [anon_sym_ascending] = ACTIONS(4440),
    [anon_sym_descending] = ACTIONS(4440),
    [anon_sym_group] = ACTIONS(4440),
    [anon_sym_by] = ACTIONS(4440),
    [anon_sym_select] = ACTIONS(4440),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4440),
    [anon_sym_nameof] = ACTIONS(4440),
    [sym_void_keyword] = ACTIONS(4440),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2438] = {
    [sym__preprocessor_call] = STATE(2438),
    [sym__identifier_token] = ACTIONS(4444),
    [anon_sym_extern] = ACTIONS(4444),
    [anon_sym_alias] = ACTIONS(4444),
    [anon_sym_global] = ACTIONS(4444),
    [anon_sym_using] = ACTIONS(4444),
    [anon_sym_static] = ACTIONS(4444),
    [anon_sym_LBRACK] = ACTIONS(4446),
    [anon_sym_event] = ACTIONS(4444),
    [anon_sym_LPAREN] = ACTIONS(4446),
    [anon_sym_abstract] = ACTIONS(4444),
    [anon_sym_async] = ACTIONS(4444),
    [anon_sym_const] = ACTIONS(4444),
    [anon_sym_fixed] = ACTIONS(4444),
    [anon_sym_internal] = ACTIONS(4444),
    [anon_sym_new] = ACTIONS(4444),
    [anon_sym_override] = ACTIONS(4444),
    [anon_sym_partial] = ACTIONS(4444),
    [anon_sym_private] = ACTIONS(4444),
    [anon_sym_protected] = ACTIONS(4444),
    [anon_sym_public] = ACTIONS(4444),
    [anon_sym_readonly] = ACTIONS(4444),
    [anon_sym_ref] = ACTIONS(4444),
    [anon_sym_sealed] = ACTIONS(4444),
    [anon_sym_unsafe] = ACTIONS(4444),
    [anon_sym_virtual] = ACTIONS(4444),
    [anon_sym_volatile] = ACTIONS(4444),
    [anon_sym_RBRACE] = ACTIONS(4446),
    [anon_sym_implicit] = ACTIONS(4444),
    [anon_sym_explicit] = ACTIONS(4444),
    [anon_sym_TILDE] = ACTIONS(4446),
    [anon_sym_where] = ACTIONS(4444),
    [anon_sym_class] = ACTIONS(4444),
    [anon_sym_struct] = ACTIONS(4444),
    [anon_sym_notnull] = ACTIONS(4444),
    [anon_sym_unmanaged] = ACTIONS(4444),
    [anon_sym_get] = ACTIONS(4444),
    [anon_sym_set] = ACTIONS(4444),
    [anon_sym_add] = ACTIONS(4444),
    [anon_sym_remove] = ACTIONS(4444),
    [anon_sym_enum] = ACTIONS(4444),
    [anon_sym_interface] = ACTIONS(4444),
    [anon_sym_delegate] = ACTIONS(4444),
    [anon_sym_record] = ACTIONS(4444),
    [anon_sym_namespace] = ACTIONS(4444),
    [anon_sym_var] = ACTIONS(4444),
    [sym_predefined_type] = ACTIONS(4444),
    [anon_sym_when] = ACTIONS(4444),
    [anon_sym_yield] = ACTIONS(4444),
    [anon_sym_from] = ACTIONS(4444),
    [anon_sym_join] = ACTIONS(4444),
    [anon_sym_on] = ACTIONS(4444),
    [anon_sym_equals] = ACTIONS(4444),
    [anon_sym_into] = ACTIONS(4444),
    [anon_sym_let] = ACTIONS(4444),
    [anon_sym_orderby] = ACTIONS(4444),
    [anon_sym_ascending] = ACTIONS(4444),
    [anon_sym_descending] = ACTIONS(4444),
    [anon_sym_group] = ACTIONS(4444),
    [anon_sym_by] = ACTIONS(4444),
    [anon_sym_select] = ACTIONS(4444),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4444),
    [anon_sym_nameof] = ACTIONS(4444),
    [sym_void_keyword] = ACTIONS(4444),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2439] = {
    [sym__preprocessor_call] = STATE(2439),
    [sym__identifier_token] = ACTIONS(4448),
    [anon_sym_extern] = ACTIONS(4448),
    [anon_sym_alias] = ACTIONS(4448),
    [anon_sym_global] = ACTIONS(4448),
    [anon_sym_using] = ACTIONS(4448),
    [anon_sym_static] = ACTIONS(4448),
    [anon_sym_LBRACK] = ACTIONS(4450),
    [anon_sym_event] = ACTIONS(4448),
    [anon_sym_LPAREN] = ACTIONS(4450),
    [anon_sym_abstract] = ACTIONS(4448),
    [anon_sym_async] = ACTIONS(4448),
    [anon_sym_const] = ACTIONS(4448),
    [anon_sym_fixed] = ACTIONS(4448),
    [anon_sym_internal] = ACTIONS(4448),
    [anon_sym_new] = ACTIONS(4448),
    [anon_sym_override] = ACTIONS(4448),
    [anon_sym_partial] = ACTIONS(4448),
    [anon_sym_private] = ACTIONS(4448),
    [anon_sym_protected] = ACTIONS(4448),
    [anon_sym_public] = ACTIONS(4448),
    [anon_sym_readonly] = ACTIONS(4448),
    [anon_sym_ref] = ACTIONS(4448),
    [anon_sym_sealed] = ACTIONS(4448),
    [anon_sym_unsafe] = ACTIONS(4448),
    [anon_sym_virtual] = ACTIONS(4448),
    [anon_sym_volatile] = ACTIONS(4448),
    [anon_sym_RBRACE] = ACTIONS(4450),
    [anon_sym_implicit] = ACTIONS(4448),
    [anon_sym_explicit] = ACTIONS(4448),
    [anon_sym_TILDE] = ACTIONS(4450),
    [anon_sym_where] = ACTIONS(4448),
    [anon_sym_class] = ACTIONS(4448),
    [anon_sym_struct] = ACTIONS(4448),
    [anon_sym_notnull] = ACTIONS(4448),
    [anon_sym_unmanaged] = ACTIONS(4448),
    [anon_sym_get] = ACTIONS(4448),
    [anon_sym_set] = ACTIONS(4448),
    [anon_sym_add] = ACTIONS(4448),
    [anon_sym_remove] = ACTIONS(4448),
    [anon_sym_enum] = ACTIONS(4448),
    [anon_sym_interface] = ACTIONS(4448),
    [anon_sym_delegate] = ACTIONS(4448),
    [anon_sym_record] = ACTIONS(4448),
    [anon_sym_namespace] = ACTIONS(4448),
    [anon_sym_var] = ACTIONS(4448),
    [sym_predefined_type] = ACTIONS(4448),
    [anon_sym_when] = ACTIONS(4448),
    [anon_sym_yield] = ACTIONS(4448),
    [anon_sym_from] = ACTIONS(4448),
    [anon_sym_join] = ACTIONS(4448),
    [anon_sym_on] = ACTIONS(4448),
    [anon_sym_equals] = ACTIONS(4448),
    [anon_sym_into] = ACTIONS(4448),
    [anon_sym_let] = ACTIONS(4448),
    [anon_sym_orderby] = ACTIONS(4448),
    [anon_sym_ascending] = ACTIONS(4448),
    [anon_sym_descending] = ACTIONS(4448),
    [anon_sym_group] = ACTIONS(4448),
    [anon_sym_by] = ACTIONS(4448),
    [anon_sym_select] = ACTIONS(4448),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4448),
    [anon_sym_nameof] = ACTIONS(4448),
    [sym_void_keyword] = ACTIONS(4448),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2440] = {
    [sym__preprocessor_call] = STATE(2440),
    [sym__identifier_token] = ACTIONS(4452),
    [anon_sym_extern] = ACTIONS(4452),
    [anon_sym_alias] = ACTIONS(4452),
    [anon_sym_global] = ACTIONS(4452),
    [anon_sym_using] = ACTIONS(4452),
    [anon_sym_static] = ACTIONS(4452),
    [anon_sym_LBRACK] = ACTIONS(4454),
    [anon_sym_event] = ACTIONS(4452),
    [anon_sym_LPAREN] = ACTIONS(4454),
    [anon_sym_abstract] = ACTIONS(4452),
    [anon_sym_async] = ACTIONS(4452),
    [anon_sym_const] = ACTIONS(4452),
    [anon_sym_fixed] = ACTIONS(4452),
    [anon_sym_internal] = ACTIONS(4452),
    [anon_sym_new] = ACTIONS(4452),
    [anon_sym_override] = ACTIONS(4452),
    [anon_sym_partial] = ACTIONS(4452),
    [anon_sym_private] = ACTIONS(4452),
    [anon_sym_protected] = ACTIONS(4452),
    [anon_sym_public] = ACTIONS(4452),
    [anon_sym_readonly] = ACTIONS(4452),
    [anon_sym_ref] = ACTIONS(4452),
    [anon_sym_sealed] = ACTIONS(4452),
    [anon_sym_unsafe] = ACTIONS(4452),
    [anon_sym_virtual] = ACTIONS(4452),
    [anon_sym_volatile] = ACTIONS(4452),
    [anon_sym_RBRACE] = ACTIONS(4454),
    [anon_sym_implicit] = ACTIONS(4452),
    [anon_sym_explicit] = ACTIONS(4452),
    [anon_sym_TILDE] = ACTIONS(4454),
    [anon_sym_where] = ACTIONS(4452),
    [anon_sym_class] = ACTIONS(4452),
    [anon_sym_struct] = ACTIONS(4452),
    [anon_sym_notnull] = ACTIONS(4452),
    [anon_sym_unmanaged] = ACTIONS(4452),
    [anon_sym_get] = ACTIONS(4452),
    [anon_sym_set] = ACTIONS(4452),
    [anon_sym_add] = ACTIONS(4452),
    [anon_sym_remove] = ACTIONS(4452),
    [anon_sym_enum] = ACTIONS(4452),
    [anon_sym_interface] = ACTIONS(4452),
    [anon_sym_delegate] = ACTIONS(4452),
    [anon_sym_record] = ACTIONS(4452),
    [anon_sym_namespace] = ACTIONS(4452),
    [anon_sym_var] = ACTIONS(4452),
    [sym_predefined_type] = ACTIONS(4452),
    [anon_sym_when] = ACTIONS(4452),
    [anon_sym_yield] = ACTIONS(4452),
    [anon_sym_from] = ACTIONS(4452),
    [anon_sym_join] = ACTIONS(4452),
    [anon_sym_on] = ACTIONS(4452),
    [anon_sym_equals] = ACTIONS(4452),
    [anon_sym_into] = ACTIONS(4452),
    [anon_sym_let] = ACTIONS(4452),
    [anon_sym_orderby] = ACTIONS(4452),
    [anon_sym_ascending] = ACTIONS(4452),
    [anon_sym_descending] = ACTIONS(4452),
    [anon_sym_group] = ACTIONS(4452),
    [anon_sym_by] = ACTIONS(4452),
    [anon_sym_select] = ACTIONS(4452),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4452),
    [anon_sym_nameof] = ACTIONS(4452),
    [sym_void_keyword] = ACTIONS(4452),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2441] = {
    [sym__preprocessor_call] = STATE(2441),
    [sym__identifier_token] = ACTIONS(4456),
    [anon_sym_extern] = ACTIONS(4456),
    [anon_sym_alias] = ACTIONS(4456),
    [anon_sym_global] = ACTIONS(4456),
    [anon_sym_using] = ACTIONS(4456),
    [anon_sym_static] = ACTIONS(4456),
    [anon_sym_LBRACK] = ACTIONS(4458),
    [anon_sym_event] = ACTIONS(4456),
    [anon_sym_LPAREN] = ACTIONS(4458),
    [anon_sym_abstract] = ACTIONS(4456),
    [anon_sym_async] = ACTIONS(4456),
    [anon_sym_const] = ACTIONS(4456),
    [anon_sym_fixed] = ACTIONS(4456),
    [anon_sym_internal] = ACTIONS(4456),
    [anon_sym_new] = ACTIONS(4456),
    [anon_sym_override] = ACTIONS(4456),
    [anon_sym_partial] = ACTIONS(4456),
    [anon_sym_private] = ACTIONS(4456),
    [anon_sym_protected] = ACTIONS(4456),
    [anon_sym_public] = ACTIONS(4456),
    [anon_sym_readonly] = ACTIONS(4456),
    [anon_sym_ref] = ACTIONS(4456),
    [anon_sym_sealed] = ACTIONS(4456),
    [anon_sym_unsafe] = ACTIONS(4456),
    [anon_sym_virtual] = ACTIONS(4456),
    [anon_sym_volatile] = ACTIONS(4456),
    [anon_sym_RBRACE] = ACTIONS(4458),
    [anon_sym_implicit] = ACTIONS(4456),
    [anon_sym_explicit] = ACTIONS(4456),
    [anon_sym_TILDE] = ACTIONS(4458),
    [anon_sym_where] = ACTIONS(4456),
    [anon_sym_class] = ACTIONS(4456),
    [anon_sym_struct] = ACTIONS(4456),
    [anon_sym_notnull] = ACTIONS(4456),
    [anon_sym_unmanaged] = ACTIONS(4456),
    [anon_sym_get] = ACTIONS(4456),
    [anon_sym_set] = ACTIONS(4456),
    [anon_sym_add] = ACTIONS(4456),
    [anon_sym_remove] = ACTIONS(4456),
    [anon_sym_enum] = ACTIONS(4456),
    [anon_sym_interface] = ACTIONS(4456),
    [anon_sym_delegate] = ACTIONS(4456),
    [anon_sym_record] = ACTIONS(4456),
    [anon_sym_namespace] = ACTIONS(4456),
    [anon_sym_var] = ACTIONS(4456),
    [sym_predefined_type] = ACTIONS(4456),
    [anon_sym_when] = ACTIONS(4456),
    [anon_sym_yield] = ACTIONS(4456),
    [anon_sym_from] = ACTIONS(4456),
    [anon_sym_join] = ACTIONS(4456),
    [anon_sym_on] = ACTIONS(4456),
    [anon_sym_equals] = ACTIONS(4456),
    [anon_sym_into] = ACTIONS(4456),
    [anon_sym_let] = ACTIONS(4456),
    [anon_sym_orderby] = ACTIONS(4456),
    [anon_sym_ascending] = ACTIONS(4456),
    [anon_sym_descending] = ACTIONS(4456),
    [anon_sym_group] = ACTIONS(4456),
    [anon_sym_by] = ACTIONS(4456),
    [anon_sym_select] = ACTIONS(4456),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4456),
    [anon_sym_nameof] = ACTIONS(4456),
    [sym_void_keyword] = ACTIONS(4456),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2442] = {
    [sym__preprocessor_call] = STATE(2442),
    [sym__identifier_token] = ACTIONS(4460),
    [anon_sym_extern] = ACTIONS(4460),
    [anon_sym_alias] = ACTIONS(4460),
    [anon_sym_global] = ACTIONS(4460),
    [anon_sym_using] = ACTIONS(4460),
    [anon_sym_static] = ACTIONS(4460),
    [anon_sym_LBRACK] = ACTIONS(4462),
    [anon_sym_event] = ACTIONS(4460),
    [anon_sym_LPAREN] = ACTIONS(4462),
    [anon_sym_abstract] = ACTIONS(4460),
    [anon_sym_async] = ACTIONS(4460),
    [anon_sym_const] = ACTIONS(4460),
    [anon_sym_fixed] = ACTIONS(4460),
    [anon_sym_internal] = ACTIONS(4460),
    [anon_sym_new] = ACTIONS(4460),
    [anon_sym_override] = ACTIONS(4460),
    [anon_sym_partial] = ACTIONS(4460),
    [anon_sym_private] = ACTIONS(4460),
    [anon_sym_protected] = ACTIONS(4460),
    [anon_sym_public] = ACTIONS(4460),
    [anon_sym_readonly] = ACTIONS(4460),
    [anon_sym_ref] = ACTIONS(4460),
    [anon_sym_sealed] = ACTIONS(4460),
    [anon_sym_unsafe] = ACTIONS(4460),
    [anon_sym_virtual] = ACTIONS(4460),
    [anon_sym_volatile] = ACTIONS(4460),
    [anon_sym_RBRACE] = ACTIONS(4462),
    [anon_sym_implicit] = ACTIONS(4460),
    [anon_sym_explicit] = ACTIONS(4460),
    [anon_sym_TILDE] = ACTIONS(4462),
    [anon_sym_where] = ACTIONS(4460),
    [anon_sym_class] = ACTIONS(4460),
    [anon_sym_struct] = ACTIONS(4460),
    [anon_sym_notnull] = ACTIONS(4460),
    [anon_sym_unmanaged] = ACTIONS(4460),
    [anon_sym_get] = ACTIONS(4460),
    [anon_sym_set] = ACTIONS(4460),
    [anon_sym_add] = ACTIONS(4460),
    [anon_sym_remove] = ACTIONS(4460),
    [anon_sym_enum] = ACTIONS(4460),
    [anon_sym_interface] = ACTIONS(4460),
    [anon_sym_delegate] = ACTIONS(4460),
    [anon_sym_record] = ACTIONS(4460),
    [anon_sym_namespace] = ACTIONS(4460),
    [anon_sym_var] = ACTIONS(4460),
    [sym_predefined_type] = ACTIONS(4460),
    [anon_sym_when] = ACTIONS(4460),
    [anon_sym_yield] = ACTIONS(4460),
    [anon_sym_from] = ACTIONS(4460),
    [anon_sym_join] = ACTIONS(4460),
    [anon_sym_on] = ACTIONS(4460),
    [anon_sym_equals] = ACTIONS(4460),
    [anon_sym_into] = ACTIONS(4460),
    [anon_sym_let] = ACTIONS(4460),
    [anon_sym_orderby] = ACTIONS(4460),
    [anon_sym_ascending] = ACTIONS(4460),
    [anon_sym_descending] = ACTIONS(4460),
    [anon_sym_group] = ACTIONS(4460),
    [anon_sym_by] = ACTIONS(4460),
    [anon_sym_select] = ACTIONS(4460),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4460),
    [anon_sym_nameof] = ACTIONS(4460),
    [sym_void_keyword] = ACTIONS(4460),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2443] = {
    [sym__preprocessor_call] = STATE(2443),
    [sym__identifier_token] = ACTIONS(4464),
    [anon_sym_extern] = ACTIONS(4464),
    [anon_sym_alias] = ACTIONS(4464),
    [anon_sym_global] = ACTIONS(4464),
    [anon_sym_using] = ACTIONS(4464),
    [anon_sym_static] = ACTIONS(4464),
    [anon_sym_LBRACK] = ACTIONS(4466),
    [anon_sym_event] = ACTIONS(4464),
    [anon_sym_LPAREN] = ACTIONS(4466),
    [anon_sym_abstract] = ACTIONS(4464),
    [anon_sym_async] = ACTIONS(4464),
    [anon_sym_const] = ACTIONS(4464),
    [anon_sym_fixed] = ACTIONS(4464),
    [anon_sym_internal] = ACTIONS(4464),
    [anon_sym_new] = ACTIONS(4464),
    [anon_sym_override] = ACTIONS(4464),
    [anon_sym_partial] = ACTIONS(4464),
    [anon_sym_private] = ACTIONS(4464),
    [anon_sym_protected] = ACTIONS(4464),
    [anon_sym_public] = ACTIONS(4464),
    [anon_sym_readonly] = ACTIONS(4464),
    [anon_sym_ref] = ACTIONS(4464),
    [anon_sym_sealed] = ACTIONS(4464),
    [anon_sym_unsafe] = ACTIONS(4464),
    [anon_sym_virtual] = ACTIONS(4464),
    [anon_sym_volatile] = ACTIONS(4464),
    [anon_sym_RBRACE] = ACTIONS(4466),
    [anon_sym_implicit] = ACTIONS(4464),
    [anon_sym_explicit] = ACTIONS(4464),
    [anon_sym_TILDE] = ACTIONS(4466),
    [anon_sym_where] = ACTIONS(4464),
    [anon_sym_class] = ACTIONS(4464),
    [anon_sym_struct] = ACTIONS(4464),
    [anon_sym_notnull] = ACTIONS(4464),
    [anon_sym_unmanaged] = ACTIONS(4464),
    [anon_sym_get] = ACTIONS(4464),
    [anon_sym_set] = ACTIONS(4464),
    [anon_sym_add] = ACTIONS(4464),
    [anon_sym_remove] = ACTIONS(4464),
    [anon_sym_enum] = ACTIONS(4464),
    [anon_sym_interface] = ACTIONS(4464),
    [anon_sym_delegate] = ACTIONS(4464),
    [anon_sym_record] = ACTIONS(4464),
    [anon_sym_namespace] = ACTIONS(4464),
    [anon_sym_var] = ACTIONS(4464),
    [sym_predefined_type] = ACTIONS(4464),
    [anon_sym_when] = ACTIONS(4464),
    [anon_sym_yield] = ACTIONS(4464),
    [anon_sym_from] = ACTIONS(4464),
    [anon_sym_join] = ACTIONS(4464),
    [anon_sym_on] = ACTIONS(4464),
    [anon_sym_equals] = ACTIONS(4464),
    [anon_sym_into] = ACTIONS(4464),
    [anon_sym_let] = ACTIONS(4464),
    [anon_sym_orderby] = ACTIONS(4464),
    [anon_sym_ascending] = ACTIONS(4464),
    [anon_sym_descending] = ACTIONS(4464),
    [anon_sym_group] = ACTIONS(4464),
    [anon_sym_by] = ACTIONS(4464),
    [anon_sym_select] = ACTIONS(4464),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4464),
    [anon_sym_nameof] = ACTIONS(4464),
    [sym_void_keyword] = ACTIONS(4464),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2444] = {
    [sym__preprocessor_call] = STATE(2444),
    [sym__identifier_token] = ACTIONS(4468),
    [anon_sym_extern] = ACTIONS(4468),
    [anon_sym_alias] = ACTIONS(4468),
    [anon_sym_global] = ACTIONS(4468),
    [anon_sym_using] = ACTIONS(4468),
    [anon_sym_static] = ACTIONS(4468),
    [anon_sym_LBRACK] = ACTIONS(4470),
    [anon_sym_event] = ACTIONS(4468),
    [anon_sym_LPAREN] = ACTIONS(4470),
    [anon_sym_abstract] = ACTIONS(4468),
    [anon_sym_async] = ACTIONS(4468),
    [anon_sym_const] = ACTIONS(4468),
    [anon_sym_fixed] = ACTIONS(4468),
    [anon_sym_internal] = ACTIONS(4468),
    [anon_sym_new] = ACTIONS(4468),
    [anon_sym_override] = ACTIONS(4468),
    [anon_sym_partial] = ACTIONS(4468),
    [anon_sym_private] = ACTIONS(4468),
    [anon_sym_protected] = ACTIONS(4468),
    [anon_sym_public] = ACTIONS(4468),
    [anon_sym_readonly] = ACTIONS(4468),
    [anon_sym_ref] = ACTIONS(4468),
    [anon_sym_sealed] = ACTIONS(4468),
    [anon_sym_unsafe] = ACTIONS(4468),
    [anon_sym_virtual] = ACTIONS(4468),
    [anon_sym_volatile] = ACTIONS(4468),
    [anon_sym_RBRACE] = ACTIONS(4470),
    [anon_sym_implicit] = ACTIONS(4468),
    [anon_sym_explicit] = ACTIONS(4468),
    [anon_sym_TILDE] = ACTIONS(4470),
    [anon_sym_where] = ACTIONS(4468),
    [anon_sym_class] = ACTIONS(4468),
    [anon_sym_struct] = ACTIONS(4468),
    [anon_sym_notnull] = ACTIONS(4468),
    [anon_sym_unmanaged] = ACTIONS(4468),
    [anon_sym_get] = ACTIONS(4468),
    [anon_sym_set] = ACTIONS(4468),
    [anon_sym_add] = ACTIONS(4468),
    [anon_sym_remove] = ACTIONS(4468),
    [anon_sym_enum] = ACTIONS(4468),
    [anon_sym_interface] = ACTIONS(4468),
    [anon_sym_delegate] = ACTIONS(4468),
    [anon_sym_record] = ACTIONS(4468),
    [anon_sym_namespace] = ACTIONS(4468),
    [anon_sym_var] = ACTIONS(4468),
    [sym_predefined_type] = ACTIONS(4468),
    [anon_sym_when] = ACTIONS(4468),
    [anon_sym_yield] = ACTIONS(4468),
    [anon_sym_from] = ACTIONS(4468),
    [anon_sym_join] = ACTIONS(4468),
    [anon_sym_on] = ACTIONS(4468),
    [anon_sym_equals] = ACTIONS(4468),
    [anon_sym_into] = ACTIONS(4468),
    [anon_sym_let] = ACTIONS(4468),
    [anon_sym_orderby] = ACTIONS(4468),
    [anon_sym_ascending] = ACTIONS(4468),
    [anon_sym_descending] = ACTIONS(4468),
    [anon_sym_group] = ACTIONS(4468),
    [anon_sym_by] = ACTIONS(4468),
    [anon_sym_select] = ACTIONS(4468),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4468),
    [anon_sym_nameof] = ACTIONS(4468),
    [sym_void_keyword] = ACTIONS(4468),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2445] = {
    [sym__preprocessor_call] = STATE(2445),
    [sym__identifier_token] = ACTIONS(4472),
    [anon_sym_extern] = ACTIONS(4472),
    [anon_sym_alias] = ACTIONS(4472),
    [anon_sym_global] = ACTIONS(4472),
    [anon_sym_using] = ACTIONS(4472),
    [anon_sym_static] = ACTIONS(4472),
    [anon_sym_LBRACK] = ACTIONS(4474),
    [anon_sym_event] = ACTIONS(4472),
    [anon_sym_LPAREN] = ACTIONS(4474),
    [anon_sym_abstract] = ACTIONS(4472),
    [anon_sym_async] = ACTIONS(4472),
    [anon_sym_const] = ACTIONS(4472),
    [anon_sym_fixed] = ACTIONS(4472),
    [anon_sym_internal] = ACTIONS(4472),
    [anon_sym_new] = ACTIONS(4472),
    [anon_sym_override] = ACTIONS(4472),
    [anon_sym_partial] = ACTIONS(4472),
    [anon_sym_private] = ACTIONS(4472),
    [anon_sym_protected] = ACTIONS(4472),
    [anon_sym_public] = ACTIONS(4472),
    [anon_sym_readonly] = ACTIONS(4472),
    [anon_sym_ref] = ACTIONS(4472),
    [anon_sym_sealed] = ACTIONS(4472),
    [anon_sym_unsafe] = ACTIONS(4472),
    [anon_sym_virtual] = ACTIONS(4472),
    [anon_sym_volatile] = ACTIONS(4472),
    [anon_sym_RBRACE] = ACTIONS(4474),
    [anon_sym_implicit] = ACTIONS(4472),
    [anon_sym_explicit] = ACTIONS(4472),
    [anon_sym_TILDE] = ACTIONS(4474),
    [anon_sym_where] = ACTIONS(4472),
    [anon_sym_class] = ACTIONS(4472),
    [anon_sym_struct] = ACTIONS(4472),
    [anon_sym_notnull] = ACTIONS(4472),
    [anon_sym_unmanaged] = ACTIONS(4472),
    [anon_sym_get] = ACTIONS(4472),
    [anon_sym_set] = ACTIONS(4472),
    [anon_sym_add] = ACTIONS(4472),
    [anon_sym_remove] = ACTIONS(4472),
    [anon_sym_enum] = ACTIONS(4472),
    [anon_sym_interface] = ACTIONS(4472),
    [anon_sym_delegate] = ACTIONS(4472),
    [anon_sym_record] = ACTIONS(4472),
    [anon_sym_namespace] = ACTIONS(4472),
    [anon_sym_var] = ACTIONS(4472),
    [sym_predefined_type] = ACTIONS(4472),
    [anon_sym_when] = ACTIONS(4472),
    [anon_sym_yield] = ACTIONS(4472),
    [anon_sym_from] = ACTIONS(4472),
    [anon_sym_join] = ACTIONS(4472),
    [anon_sym_on] = ACTIONS(4472),
    [anon_sym_equals] = ACTIONS(4472),
    [anon_sym_into] = ACTIONS(4472),
    [anon_sym_let] = ACTIONS(4472),
    [anon_sym_orderby] = ACTIONS(4472),
    [anon_sym_ascending] = ACTIONS(4472),
    [anon_sym_descending] = ACTIONS(4472),
    [anon_sym_group] = ACTIONS(4472),
    [anon_sym_by] = ACTIONS(4472),
    [anon_sym_select] = ACTIONS(4472),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4472),
    [anon_sym_nameof] = ACTIONS(4472),
    [sym_void_keyword] = ACTIONS(4472),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2446] = {
    [sym__preprocessor_call] = STATE(2446),
    [sym__identifier_token] = ACTIONS(4476),
    [anon_sym_extern] = ACTIONS(4476),
    [anon_sym_alias] = ACTIONS(4476),
    [anon_sym_global] = ACTIONS(4476),
    [anon_sym_using] = ACTIONS(4476),
    [anon_sym_static] = ACTIONS(4476),
    [anon_sym_LBRACK] = ACTIONS(4478),
    [anon_sym_event] = ACTIONS(4476),
    [anon_sym_LPAREN] = ACTIONS(4478),
    [anon_sym_abstract] = ACTIONS(4476),
    [anon_sym_async] = ACTIONS(4476),
    [anon_sym_const] = ACTIONS(4476),
    [anon_sym_fixed] = ACTIONS(4476),
    [anon_sym_internal] = ACTIONS(4476),
    [anon_sym_new] = ACTIONS(4476),
    [anon_sym_override] = ACTIONS(4476),
    [anon_sym_partial] = ACTIONS(4476),
    [anon_sym_private] = ACTIONS(4476),
    [anon_sym_protected] = ACTIONS(4476),
    [anon_sym_public] = ACTIONS(4476),
    [anon_sym_readonly] = ACTIONS(4476),
    [anon_sym_ref] = ACTIONS(4476),
    [anon_sym_sealed] = ACTIONS(4476),
    [anon_sym_unsafe] = ACTIONS(4476),
    [anon_sym_virtual] = ACTIONS(4476),
    [anon_sym_volatile] = ACTIONS(4476),
    [anon_sym_RBRACE] = ACTIONS(4478),
    [anon_sym_implicit] = ACTIONS(4476),
    [anon_sym_explicit] = ACTIONS(4476),
    [anon_sym_TILDE] = ACTIONS(4478),
    [anon_sym_where] = ACTIONS(4476),
    [anon_sym_class] = ACTIONS(4476),
    [anon_sym_struct] = ACTIONS(4476),
    [anon_sym_notnull] = ACTIONS(4476),
    [anon_sym_unmanaged] = ACTIONS(4476),
    [anon_sym_get] = ACTIONS(4476),
    [anon_sym_set] = ACTIONS(4476),
    [anon_sym_add] = ACTIONS(4476),
    [anon_sym_remove] = ACTIONS(4476),
    [anon_sym_enum] = ACTIONS(4476),
    [anon_sym_interface] = ACTIONS(4476),
    [anon_sym_delegate] = ACTIONS(4476),
    [anon_sym_record] = ACTIONS(4476),
    [anon_sym_namespace] = ACTIONS(4476),
    [anon_sym_var] = ACTIONS(4476),
    [sym_predefined_type] = ACTIONS(4476),
    [anon_sym_when] = ACTIONS(4476),
    [anon_sym_yield] = ACTIONS(4476),
    [anon_sym_from] = ACTIONS(4476),
    [anon_sym_join] = ACTIONS(4476),
    [anon_sym_on] = ACTIONS(4476),
    [anon_sym_equals] = ACTIONS(4476),
    [anon_sym_into] = ACTIONS(4476),
    [anon_sym_let] = ACTIONS(4476),
    [anon_sym_orderby] = ACTIONS(4476),
    [anon_sym_ascending] = ACTIONS(4476),
    [anon_sym_descending] = ACTIONS(4476),
    [anon_sym_group] = ACTIONS(4476),
    [anon_sym_by] = ACTIONS(4476),
    [anon_sym_select] = ACTIONS(4476),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4476),
    [anon_sym_nameof] = ACTIONS(4476),
    [sym_void_keyword] = ACTIONS(4476),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2447] = {
    [sym__preprocessor_call] = STATE(2447),
    [sym__identifier_token] = ACTIONS(4480),
    [anon_sym_extern] = ACTIONS(4480),
    [anon_sym_alias] = ACTIONS(4480),
    [anon_sym_global] = ACTIONS(4480),
    [anon_sym_using] = ACTIONS(4480),
    [anon_sym_static] = ACTIONS(4480),
    [anon_sym_LBRACK] = ACTIONS(4482),
    [anon_sym_event] = ACTIONS(4480),
    [anon_sym_LPAREN] = ACTIONS(4482),
    [anon_sym_abstract] = ACTIONS(4480),
    [anon_sym_async] = ACTIONS(4480),
    [anon_sym_const] = ACTIONS(4480),
    [anon_sym_fixed] = ACTIONS(4480),
    [anon_sym_internal] = ACTIONS(4480),
    [anon_sym_new] = ACTIONS(4480),
    [anon_sym_override] = ACTIONS(4480),
    [anon_sym_partial] = ACTIONS(4480),
    [anon_sym_private] = ACTIONS(4480),
    [anon_sym_protected] = ACTIONS(4480),
    [anon_sym_public] = ACTIONS(4480),
    [anon_sym_readonly] = ACTIONS(4480),
    [anon_sym_ref] = ACTIONS(4480),
    [anon_sym_sealed] = ACTIONS(4480),
    [anon_sym_unsafe] = ACTIONS(4480),
    [anon_sym_virtual] = ACTIONS(4480),
    [anon_sym_volatile] = ACTIONS(4480),
    [anon_sym_RBRACE] = ACTIONS(4482),
    [anon_sym_implicit] = ACTIONS(4480),
    [anon_sym_explicit] = ACTIONS(4480),
    [anon_sym_TILDE] = ACTIONS(4482),
    [anon_sym_where] = ACTIONS(4480),
    [anon_sym_class] = ACTIONS(4480),
    [anon_sym_struct] = ACTIONS(4480),
    [anon_sym_notnull] = ACTIONS(4480),
    [anon_sym_unmanaged] = ACTIONS(4480),
    [anon_sym_get] = ACTIONS(4480),
    [anon_sym_set] = ACTIONS(4480),
    [anon_sym_add] = ACTIONS(4480),
    [anon_sym_remove] = ACTIONS(4480),
    [anon_sym_enum] = ACTIONS(4480),
    [anon_sym_interface] = ACTIONS(4480),
    [anon_sym_delegate] = ACTIONS(4480),
    [anon_sym_record] = ACTIONS(4480),
    [anon_sym_namespace] = ACTIONS(4480),
    [anon_sym_var] = ACTIONS(4480),
    [sym_predefined_type] = ACTIONS(4480),
    [anon_sym_when] = ACTIONS(4480),
    [anon_sym_yield] = ACTIONS(4480),
    [anon_sym_from] = ACTIONS(4480),
    [anon_sym_join] = ACTIONS(4480),
    [anon_sym_on] = ACTIONS(4480),
    [anon_sym_equals] = ACTIONS(4480),
    [anon_sym_into] = ACTIONS(4480),
    [anon_sym_let] = ACTIONS(4480),
    [anon_sym_orderby] = ACTIONS(4480),
    [anon_sym_ascending] = ACTIONS(4480),
    [anon_sym_descending] = ACTIONS(4480),
    [anon_sym_group] = ACTIONS(4480),
    [anon_sym_by] = ACTIONS(4480),
    [anon_sym_select] = ACTIONS(4480),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4480),
    [anon_sym_nameof] = ACTIONS(4480),
    [sym_void_keyword] = ACTIONS(4480),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2448] = {
    [sym__preprocessor_call] = STATE(2448),
    [sym__identifier_token] = ACTIONS(4484),
    [anon_sym_extern] = ACTIONS(4484),
    [anon_sym_alias] = ACTIONS(4484),
    [anon_sym_global] = ACTIONS(4484),
    [anon_sym_using] = ACTIONS(4484),
    [anon_sym_static] = ACTIONS(4484),
    [anon_sym_LBRACK] = ACTIONS(4486),
    [anon_sym_event] = ACTIONS(4484),
    [anon_sym_LPAREN] = ACTIONS(4486),
    [anon_sym_abstract] = ACTIONS(4484),
    [anon_sym_async] = ACTIONS(4484),
    [anon_sym_const] = ACTIONS(4484),
    [anon_sym_fixed] = ACTIONS(4484),
    [anon_sym_internal] = ACTIONS(4484),
    [anon_sym_new] = ACTIONS(4484),
    [anon_sym_override] = ACTIONS(4484),
    [anon_sym_partial] = ACTIONS(4484),
    [anon_sym_private] = ACTIONS(4484),
    [anon_sym_protected] = ACTIONS(4484),
    [anon_sym_public] = ACTIONS(4484),
    [anon_sym_readonly] = ACTIONS(4484),
    [anon_sym_ref] = ACTIONS(4484),
    [anon_sym_sealed] = ACTIONS(4484),
    [anon_sym_unsafe] = ACTIONS(4484),
    [anon_sym_virtual] = ACTIONS(4484),
    [anon_sym_volatile] = ACTIONS(4484),
    [anon_sym_RBRACE] = ACTIONS(4486),
    [anon_sym_implicit] = ACTIONS(4484),
    [anon_sym_explicit] = ACTIONS(4484),
    [anon_sym_TILDE] = ACTIONS(4486),
    [anon_sym_where] = ACTIONS(4484),
    [anon_sym_class] = ACTIONS(4484),
    [anon_sym_struct] = ACTIONS(4484),
    [anon_sym_notnull] = ACTIONS(4484),
    [anon_sym_unmanaged] = ACTIONS(4484),
    [anon_sym_get] = ACTIONS(4484),
    [anon_sym_set] = ACTIONS(4484),
    [anon_sym_add] = ACTIONS(4484),
    [anon_sym_remove] = ACTIONS(4484),
    [anon_sym_enum] = ACTIONS(4484),
    [anon_sym_interface] = ACTIONS(4484),
    [anon_sym_delegate] = ACTIONS(4484),
    [anon_sym_record] = ACTIONS(4484),
    [anon_sym_namespace] = ACTIONS(4484),
    [anon_sym_var] = ACTIONS(4484),
    [sym_predefined_type] = ACTIONS(4484),
    [anon_sym_when] = ACTIONS(4484),
    [anon_sym_yield] = ACTIONS(4484),
    [anon_sym_from] = ACTIONS(4484),
    [anon_sym_join] = ACTIONS(4484),
    [anon_sym_on] = ACTIONS(4484),
    [anon_sym_equals] = ACTIONS(4484),
    [anon_sym_into] = ACTIONS(4484),
    [anon_sym_let] = ACTIONS(4484),
    [anon_sym_orderby] = ACTIONS(4484),
    [anon_sym_ascending] = ACTIONS(4484),
    [anon_sym_descending] = ACTIONS(4484),
    [anon_sym_group] = ACTIONS(4484),
    [anon_sym_by] = ACTIONS(4484),
    [anon_sym_select] = ACTIONS(4484),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4484),
    [anon_sym_nameof] = ACTIONS(4484),
    [sym_void_keyword] = ACTIONS(4484),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2449] = {
    [sym__preprocessor_call] = STATE(2449),
    [sym__identifier_token] = ACTIONS(4488),
    [anon_sym_extern] = ACTIONS(4488),
    [anon_sym_alias] = ACTIONS(4488),
    [anon_sym_global] = ACTIONS(4488),
    [anon_sym_using] = ACTIONS(4488),
    [anon_sym_static] = ACTIONS(4488),
    [anon_sym_LBRACK] = ACTIONS(4490),
    [anon_sym_event] = ACTIONS(4488),
    [anon_sym_LPAREN] = ACTIONS(4490),
    [anon_sym_abstract] = ACTIONS(4488),
    [anon_sym_async] = ACTIONS(4488),
    [anon_sym_const] = ACTIONS(4488),
    [anon_sym_fixed] = ACTIONS(4488),
    [anon_sym_internal] = ACTIONS(4488),
    [anon_sym_new] = ACTIONS(4488),
    [anon_sym_override] = ACTIONS(4488),
    [anon_sym_partial] = ACTIONS(4488),
    [anon_sym_private] = ACTIONS(4488),
    [anon_sym_protected] = ACTIONS(4488),
    [anon_sym_public] = ACTIONS(4488),
    [anon_sym_readonly] = ACTIONS(4488),
    [anon_sym_ref] = ACTIONS(4488),
    [anon_sym_sealed] = ACTIONS(4488),
    [anon_sym_unsafe] = ACTIONS(4488),
    [anon_sym_virtual] = ACTIONS(4488),
    [anon_sym_volatile] = ACTIONS(4488),
    [anon_sym_RBRACE] = ACTIONS(4490),
    [anon_sym_implicit] = ACTIONS(4488),
    [anon_sym_explicit] = ACTIONS(4488),
    [anon_sym_TILDE] = ACTIONS(4490),
    [anon_sym_where] = ACTIONS(4488),
    [anon_sym_class] = ACTIONS(4488),
    [anon_sym_struct] = ACTIONS(4488),
    [anon_sym_notnull] = ACTIONS(4488),
    [anon_sym_unmanaged] = ACTIONS(4488),
    [anon_sym_get] = ACTIONS(4488),
    [anon_sym_set] = ACTIONS(4488),
    [anon_sym_add] = ACTIONS(4488),
    [anon_sym_remove] = ACTIONS(4488),
    [anon_sym_enum] = ACTIONS(4488),
    [anon_sym_interface] = ACTIONS(4488),
    [anon_sym_delegate] = ACTIONS(4488),
    [anon_sym_record] = ACTIONS(4488),
    [anon_sym_namespace] = ACTIONS(4488),
    [anon_sym_var] = ACTIONS(4488),
    [sym_predefined_type] = ACTIONS(4488),
    [anon_sym_when] = ACTIONS(4488),
    [anon_sym_yield] = ACTIONS(4488),
    [anon_sym_from] = ACTIONS(4488),
    [anon_sym_join] = ACTIONS(4488),
    [anon_sym_on] = ACTIONS(4488),
    [anon_sym_equals] = ACTIONS(4488),
    [anon_sym_into] = ACTIONS(4488),
    [anon_sym_let] = ACTIONS(4488),
    [anon_sym_orderby] = ACTIONS(4488),
    [anon_sym_ascending] = ACTIONS(4488),
    [anon_sym_descending] = ACTIONS(4488),
    [anon_sym_group] = ACTIONS(4488),
    [anon_sym_by] = ACTIONS(4488),
    [anon_sym_select] = ACTIONS(4488),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4488),
    [anon_sym_nameof] = ACTIONS(4488),
    [sym_void_keyword] = ACTIONS(4488),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2450] = {
    [sym__preprocessor_call] = STATE(2450),
    [sym__identifier_token] = ACTIONS(4492),
    [anon_sym_extern] = ACTIONS(4492),
    [anon_sym_alias] = ACTIONS(4492),
    [anon_sym_global] = ACTIONS(4492),
    [anon_sym_using] = ACTIONS(4492),
    [anon_sym_static] = ACTIONS(4492),
    [anon_sym_LBRACK] = ACTIONS(4494),
    [anon_sym_event] = ACTIONS(4492),
    [anon_sym_LPAREN] = ACTIONS(4494),
    [anon_sym_abstract] = ACTIONS(4492),
    [anon_sym_async] = ACTIONS(4492),
    [anon_sym_const] = ACTIONS(4492),
    [anon_sym_fixed] = ACTIONS(4492),
    [anon_sym_internal] = ACTIONS(4492),
    [anon_sym_new] = ACTIONS(4492),
    [anon_sym_override] = ACTIONS(4492),
    [anon_sym_partial] = ACTIONS(4492),
    [anon_sym_private] = ACTIONS(4492),
    [anon_sym_protected] = ACTIONS(4492),
    [anon_sym_public] = ACTIONS(4492),
    [anon_sym_readonly] = ACTIONS(4492),
    [anon_sym_ref] = ACTIONS(4492),
    [anon_sym_sealed] = ACTIONS(4492),
    [anon_sym_unsafe] = ACTIONS(4492),
    [anon_sym_virtual] = ACTIONS(4492),
    [anon_sym_volatile] = ACTIONS(4492),
    [anon_sym_RBRACE] = ACTIONS(4494),
    [anon_sym_implicit] = ACTIONS(4492),
    [anon_sym_explicit] = ACTIONS(4492),
    [anon_sym_TILDE] = ACTIONS(4494),
    [anon_sym_where] = ACTIONS(4492),
    [anon_sym_class] = ACTIONS(4492),
    [anon_sym_struct] = ACTIONS(4492),
    [anon_sym_notnull] = ACTIONS(4492),
    [anon_sym_unmanaged] = ACTIONS(4492),
    [anon_sym_get] = ACTIONS(4492),
    [anon_sym_set] = ACTIONS(4492),
    [anon_sym_add] = ACTIONS(4492),
    [anon_sym_remove] = ACTIONS(4492),
    [anon_sym_enum] = ACTIONS(4492),
    [anon_sym_interface] = ACTIONS(4492),
    [anon_sym_delegate] = ACTIONS(4492),
    [anon_sym_record] = ACTIONS(4492),
    [anon_sym_namespace] = ACTIONS(4492),
    [anon_sym_var] = ACTIONS(4492),
    [sym_predefined_type] = ACTIONS(4492),
    [anon_sym_when] = ACTIONS(4492),
    [anon_sym_yield] = ACTIONS(4492),
    [anon_sym_from] = ACTIONS(4492),
    [anon_sym_join] = ACTIONS(4492),
    [anon_sym_on] = ACTIONS(4492),
    [anon_sym_equals] = ACTIONS(4492),
    [anon_sym_into] = ACTIONS(4492),
    [anon_sym_let] = ACTIONS(4492),
    [anon_sym_orderby] = ACTIONS(4492),
    [anon_sym_ascending] = ACTIONS(4492),
    [anon_sym_descending] = ACTIONS(4492),
    [anon_sym_group] = ACTIONS(4492),
    [anon_sym_by] = ACTIONS(4492),
    [anon_sym_select] = ACTIONS(4492),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4492),
    [anon_sym_nameof] = ACTIONS(4492),
    [sym_void_keyword] = ACTIONS(4492),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2451] = {
    [sym__preprocessor_call] = STATE(2451),
    [sym__identifier_token] = ACTIONS(4496),
    [anon_sym_extern] = ACTIONS(4496),
    [anon_sym_alias] = ACTIONS(4496),
    [anon_sym_global] = ACTIONS(4496),
    [anon_sym_using] = ACTIONS(4496),
    [anon_sym_static] = ACTIONS(4496),
    [anon_sym_LBRACK] = ACTIONS(4498),
    [anon_sym_event] = ACTIONS(4496),
    [anon_sym_LPAREN] = ACTIONS(4498),
    [anon_sym_abstract] = ACTIONS(4496),
    [anon_sym_async] = ACTIONS(4496),
    [anon_sym_const] = ACTIONS(4496),
    [anon_sym_fixed] = ACTIONS(4496),
    [anon_sym_internal] = ACTIONS(4496),
    [anon_sym_new] = ACTIONS(4496),
    [anon_sym_override] = ACTIONS(4496),
    [anon_sym_partial] = ACTIONS(4496),
    [anon_sym_private] = ACTIONS(4496),
    [anon_sym_protected] = ACTIONS(4496),
    [anon_sym_public] = ACTIONS(4496),
    [anon_sym_readonly] = ACTIONS(4496),
    [anon_sym_ref] = ACTIONS(4496),
    [anon_sym_sealed] = ACTIONS(4496),
    [anon_sym_unsafe] = ACTIONS(4496),
    [anon_sym_virtual] = ACTIONS(4496),
    [anon_sym_volatile] = ACTIONS(4496),
    [anon_sym_RBRACE] = ACTIONS(4498),
    [anon_sym_implicit] = ACTIONS(4496),
    [anon_sym_explicit] = ACTIONS(4496),
    [anon_sym_TILDE] = ACTIONS(4498),
    [anon_sym_where] = ACTIONS(4496),
    [anon_sym_class] = ACTIONS(4496),
    [anon_sym_struct] = ACTIONS(4496),
    [anon_sym_notnull] = ACTIONS(4496),
    [anon_sym_unmanaged] = ACTIONS(4496),
    [anon_sym_get] = ACTIONS(4496),
    [anon_sym_set] = ACTIONS(4496),
    [anon_sym_add] = ACTIONS(4496),
    [anon_sym_remove] = ACTIONS(4496),
    [anon_sym_enum] = ACTIONS(4496),
    [anon_sym_interface] = ACTIONS(4496),
    [anon_sym_delegate] = ACTIONS(4496),
    [anon_sym_record] = ACTIONS(4496),
    [anon_sym_namespace] = ACTIONS(4496),
    [anon_sym_var] = ACTIONS(4496),
    [sym_predefined_type] = ACTIONS(4496),
    [anon_sym_when] = ACTIONS(4496),
    [anon_sym_yield] = ACTIONS(4496),
    [anon_sym_from] = ACTIONS(4496),
    [anon_sym_join] = ACTIONS(4496),
    [anon_sym_on] = ACTIONS(4496),
    [anon_sym_equals] = ACTIONS(4496),
    [anon_sym_into] = ACTIONS(4496),
    [anon_sym_let] = ACTIONS(4496),
    [anon_sym_orderby] = ACTIONS(4496),
    [anon_sym_ascending] = ACTIONS(4496),
    [anon_sym_descending] = ACTIONS(4496),
    [anon_sym_group] = ACTIONS(4496),
    [anon_sym_by] = ACTIONS(4496),
    [anon_sym_select] = ACTIONS(4496),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4496),
    [anon_sym_nameof] = ACTIONS(4496),
    [sym_void_keyword] = ACTIONS(4496),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2452] = {
    [sym__preprocessor_call] = STATE(2452),
    [sym__identifier_token] = ACTIONS(4500),
    [anon_sym_extern] = ACTIONS(4500),
    [anon_sym_alias] = ACTIONS(4500),
    [anon_sym_global] = ACTIONS(4500),
    [anon_sym_using] = ACTIONS(4500),
    [anon_sym_static] = ACTIONS(4500),
    [anon_sym_LBRACK] = ACTIONS(4502),
    [anon_sym_event] = ACTIONS(4500),
    [anon_sym_LPAREN] = ACTIONS(4502),
    [anon_sym_abstract] = ACTIONS(4500),
    [anon_sym_async] = ACTIONS(4500),
    [anon_sym_const] = ACTIONS(4500),
    [anon_sym_fixed] = ACTIONS(4500),
    [anon_sym_internal] = ACTIONS(4500),
    [anon_sym_new] = ACTIONS(4500),
    [anon_sym_override] = ACTIONS(4500),
    [anon_sym_partial] = ACTIONS(4500),
    [anon_sym_private] = ACTIONS(4500),
    [anon_sym_protected] = ACTIONS(4500),
    [anon_sym_public] = ACTIONS(4500),
    [anon_sym_readonly] = ACTIONS(4500),
    [anon_sym_ref] = ACTIONS(4500),
    [anon_sym_sealed] = ACTIONS(4500),
    [anon_sym_unsafe] = ACTIONS(4500),
    [anon_sym_virtual] = ACTIONS(4500),
    [anon_sym_volatile] = ACTIONS(4500),
    [anon_sym_RBRACE] = ACTIONS(4502),
    [anon_sym_implicit] = ACTIONS(4500),
    [anon_sym_explicit] = ACTIONS(4500),
    [anon_sym_TILDE] = ACTIONS(4502),
    [anon_sym_where] = ACTIONS(4500),
    [anon_sym_class] = ACTIONS(4500),
    [anon_sym_struct] = ACTIONS(4500),
    [anon_sym_notnull] = ACTIONS(4500),
    [anon_sym_unmanaged] = ACTIONS(4500),
    [anon_sym_get] = ACTIONS(4500),
    [anon_sym_set] = ACTIONS(4500),
    [anon_sym_add] = ACTIONS(4500),
    [anon_sym_remove] = ACTIONS(4500),
    [anon_sym_enum] = ACTIONS(4500),
    [anon_sym_interface] = ACTIONS(4500),
    [anon_sym_delegate] = ACTIONS(4500),
    [anon_sym_record] = ACTIONS(4500),
    [anon_sym_namespace] = ACTIONS(4500),
    [anon_sym_var] = ACTIONS(4500),
    [sym_predefined_type] = ACTIONS(4500),
    [anon_sym_when] = ACTIONS(4500),
    [anon_sym_yield] = ACTIONS(4500),
    [anon_sym_from] = ACTIONS(4500),
    [anon_sym_join] = ACTIONS(4500),
    [anon_sym_on] = ACTIONS(4500),
    [anon_sym_equals] = ACTIONS(4500),
    [anon_sym_into] = ACTIONS(4500),
    [anon_sym_let] = ACTIONS(4500),
    [anon_sym_orderby] = ACTIONS(4500),
    [anon_sym_ascending] = ACTIONS(4500),
    [anon_sym_descending] = ACTIONS(4500),
    [anon_sym_group] = ACTIONS(4500),
    [anon_sym_by] = ACTIONS(4500),
    [anon_sym_select] = ACTIONS(4500),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4500),
    [anon_sym_nameof] = ACTIONS(4500),
    [sym_void_keyword] = ACTIONS(4500),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2453] = {
    [sym__preprocessor_call] = STATE(2453),
    [sym__identifier_token] = ACTIONS(4504),
    [anon_sym_extern] = ACTIONS(4504),
    [anon_sym_alias] = ACTIONS(4504),
    [anon_sym_global] = ACTIONS(4504),
    [anon_sym_using] = ACTIONS(4504),
    [anon_sym_static] = ACTIONS(4504),
    [anon_sym_LBRACK] = ACTIONS(4506),
    [anon_sym_event] = ACTIONS(4504),
    [anon_sym_LPAREN] = ACTIONS(4506),
    [anon_sym_abstract] = ACTIONS(4504),
    [anon_sym_async] = ACTIONS(4504),
    [anon_sym_const] = ACTIONS(4504),
    [anon_sym_fixed] = ACTIONS(4504),
    [anon_sym_internal] = ACTIONS(4504),
    [anon_sym_new] = ACTIONS(4504),
    [anon_sym_override] = ACTIONS(4504),
    [anon_sym_partial] = ACTIONS(4504),
    [anon_sym_private] = ACTIONS(4504),
    [anon_sym_protected] = ACTIONS(4504),
    [anon_sym_public] = ACTIONS(4504),
    [anon_sym_readonly] = ACTIONS(4504),
    [anon_sym_ref] = ACTIONS(4504),
    [anon_sym_sealed] = ACTIONS(4504),
    [anon_sym_unsafe] = ACTIONS(4504),
    [anon_sym_virtual] = ACTIONS(4504),
    [anon_sym_volatile] = ACTIONS(4504),
    [anon_sym_RBRACE] = ACTIONS(4506),
    [anon_sym_implicit] = ACTIONS(4504),
    [anon_sym_explicit] = ACTIONS(4504),
    [anon_sym_TILDE] = ACTIONS(4506),
    [anon_sym_where] = ACTIONS(4504),
    [anon_sym_class] = ACTIONS(4504),
    [anon_sym_struct] = ACTIONS(4504),
    [anon_sym_notnull] = ACTIONS(4504),
    [anon_sym_unmanaged] = ACTIONS(4504),
    [anon_sym_get] = ACTIONS(4504),
    [anon_sym_set] = ACTIONS(4504),
    [anon_sym_add] = ACTIONS(4504),
    [anon_sym_remove] = ACTIONS(4504),
    [anon_sym_enum] = ACTIONS(4504),
    [anon_sym_interface] = ACTIONS(4504),
    [anon_sym_delegate] = ACTIONS(4504),
    [anon_sym_record] = ACTIONS(4504),
    [anon_sym_namespace] = ACTIONS(4504),
    [anon_sym_var] = ACTIONS(4504),
    [sym_predefined_type] = ACTIONS(4504),
    [anon_sym_when] = ACTIONS(4504),
    [anon_sym_yield] = ACTIONS(4504),
    [anon_sym_from] = ACTIONS(4504),
    [anon_sym_join] = ACTIONS(4504),
    [anon_sym_on] = ACTIONS(4504),
    [anon_sym_equals] = ACTIONS(4504),
    [anon_sym_into] = ACTIONS(4504),
    [anon_sym_let] = ACTIONS(4504),
    [anon_sym_orderby] = ACTIONS(4504),
    [anon_sym_ascending] = ACTIONS(4504),
    [anon_sym_descending] = ACTIONS(4504),
    [anon_sym_group] = ACTIONS(4504),
    [anon_sym_by] = ACTIONS(4504),
    [anon_sym_select] = ACTIONS(4504),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4504),
    [anon_sym_nameof] = ACTIONS(4504),
    [sym_void_keyword] = ACTIONS(4504),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2454] = {
    [sym__preprocessor_call] = STATE(2454),
    [sym__identifier_token] = ACTIONS(4508),
    [anon_sym_extern] = ACTIONS(4508),
    [anon_sym_alias] = ACTIONS(4508),
    [anon_sym_global] = ACTIONS(4508),
    [anon_sym_using] = ACTIONS(4508),
    [anon_sym_static] = ACTIONS(4508),
    [anon_sym_LBRACK] = ACTIONS(4510),
    [anon_sym_event] = ACTIONS(4508),
    [anon_sym_LPAREN] = ACTIONS(4510),
    [anon_sym_abstract] = ACTIONS(4508),
    [anon_sym_async] = ACTIONS(4508),
    [anon_sym_const] = ACTIONS(4508),
    [anon_sym_fixed] = ACTIONS(4508),
    [anon_sym_internal] = ACTIONS(4508),
    [anon_sym_new] = ACTIONS(4508),
    [anon_sym_override] = ACTIONS(4508),
    [anon_sym_partial] = ACTIONS(4508),
    [anon_sym_private] = ACTIONS(4508),
    [anon_sym_protected] = ACTIONS(4508),
    [anon_sym_public] = ACTIONS(4508),
    [anon_sym_readonly] = ACTIONS(4508),
    [anon_sym_ref] = ACTIONS(4508),
    [anon_sym_sealed] = ACTIONS(4508),
    [anon_sym_unsafe] = ACTIONS(4508),
    [anon_sym_virtual] = ACTIONS(4508),
    [anon_sym_volatile] = ACTIONS(4508),
    [anon_sym_RBRACE] = ACTIONS(4510),
    [anon_sym_implicit] = ACTIONS(4508),
    [anon_sym_explicit] = ACTIONS(4508),
    [anon_sym_TILDE] = ACTIONS(4510),
    [anon_sym_where] = ACTIONS(4508),
    [anon_sym_class] = ACTIONS(4508),
    [anon_sym_struct] = ACTIONS(4508),
    [anon_sym_notnull] = ACTIONS(4508),
    [anon_sym_unmanaged] = ACTIONS(4508),
    [anon_sym_get] = ACTIONS(4508),
    [anon_sym_set] = ACTIONS(4508),
    [anon_sym_add] = ACTIONS(4508),
    [anon_sym_remove] = ACTIONS(4508),
    [anon_sym_enum] = ACTIONS(4508),
    [anon_sym_interface] = ACTIONS(4508),
    [anon_sym_delegate] = ACTIONS(4508),
    [anon_sym_record] = ACTIONS(4508),
    [anon_sym_namespace] = ACTIONS(4508),
    [anon_sym_var] = ACTIONS(4508),
    [sym_predefined_type] = ACTIONS(4508),
    [anon_sym_when] = ACTIONS(4508),
    [anon_sym_yield] = ACTIONS(4508),
    [anon_sym_from] = ACTIONS(4508),
    [anon_sym_join] = ACTIONS(4508),
    [anon_sym_on] = ACTIONS(4508),
    [anon_sym_equals] = ACTIONS(4508),
    [anon_sym_into] = ACTIONS(4508),
    [anon_sym_let] = ACTIONS(4508),
    [anon_sym_orderby] = ACTIONS(4508),
    [anon_sym_ascending] = ACTIONS(4508),
    [anon_sym_descending] = ACTIONS(4508),
    [anon_sym_group] = ACTIONS(4508),
    [anon_sym_by] = ACTIONS(4508),
    [anon_sym_select] = ACTIONS(4508),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4508),
    [anon_sym_nameof] = ACTIONS(4508),
    [sym_void_keyword] = ACTIONS(4508),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2455] = {
    [sym__preprocessor_call] = STATE(2455),
    [sym__identifier_token] = ACTIONS(4512),
    [anon_sym_extern] = ACTIONS(4512),
    [anon_sym_alias] = ACTIONS(4512),
    [anon_sym_global] = ACTIONS(4512),
    [anon_sym_using] = ACTIONS(4512),
    [anon_sym_static] = ACTIONS(4512),
    [anon_sym_LBRACK] = ACTIONS(4514),
    [anon_sym_event] = ACTIONS(4512),
    [anon_sym_LPAREN] = ACTIONS(4514),
    [anon_sym_abstract] = ACTIONS(4512),
    [anon_sym_async] = ACTIONS(4512),
    [anon_sym_const] = ACTIONS(4512),
    [anon_sym_fixed] = ACTIONS(4512),
    [anon_sym_internal] = ACTIONS(4512),
    [anon_sym_new] = ACTIONS(4512),
    [anon_sym_override] = ACTIONS(4512),
    [anon_sym_partial] = ACTIONS(4512),
    [anon_sym_private] = ACTIONS(4512),
    [anon_sym_protected] = ACTIONS(4512),
    [anon_sym_public] = ACTIONS(4512),
    [anon_sym_readonly] = ACTIONS(4512),
    [anon_sym_ref] = ACTIONS(4512),
    [anon_sym_sealed] = ACTIONS(4512),
    [anon_sym_unsafe] = ACTIONS(4512),
    [anon_sym_virtual] = ACTIONS(4512),
    [anon_sym_volatile] = ACTIONS(4512),
    [anon_sym_RBRACE] = ACTIONS(4514),
    [anon_sym_implicit] = ACTIONS(4512),
    [anon_sym_explicit] = ACTIONS(4512),
    [anon_sym_TILDE] = ACTIONS(4514),
    [anon_sym_where] = ACTIONS(4512),
    [anon_sym_class] = ACTIONS(4512),
    [anon_sym_struct] = ACTIONS(4512),
    [anon_sym_notnull] = ACTIONS(4512),
    [anon_sym_unmanaged] = ACTIONS(4512),
    [anon_sym_get] = ACTIONS(4512),
    [anon_sym_set] = ACTIONS(4512),
    [anon_sym_add] = ACTIONS(4512),
    [anon_sym_remove] = ACTIONS(4512),
    [anon_sym_enum] = ACTIONS(4512),
    [anon_sym_interface] = ACTIONS(4512),
    [anon_sym_delegate] = ACTIONS(4512),
    [anon_sym_record] = ACTIONS(4512),
    [anon_sym_namespace] = ACTIONS(4512),
    [anon_sym_var] = ACTIONS(4512),
    [sym_predefined_type] = ACTIONS(4512),
    [anon_sym_when] = ACTIONS(4512),
    [anon_sym_yield] = ACTIONS(4512),
    [anon_sym_from] = ACTIONS(4512),
    [anon_sym_join] = ACTIONS(4512),
    [anon_sym_on] = ACTIONS(4512),
    [anon_sym_equals] = ACTIONS(4512),
    [anon_sym_into] = ACTIONS(4512),
    [anon_sym_let] = ACTIONS(4512),
    [anon_sym_orderby] = ACTIONS(4512),
    [anon_sym_ascending] = ACTIONS(4512),
    [anon_sym_descending] = ACTIONS(4512),
    [anon_sym_group] = ACTIONS(4512),
    [anon_sym_by] = ACTIONS(4512),
    [anon_sym_select] = ACTIONS(4512),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4512),
    [anon_sym_nameof] = ACTIONS(4512),
    [sym_void_keyword] = ACTIONS(4512),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2456] = {
    [sym__preprocessor_call] = STATE(2456),
    [sym__identifier_token] = ACTIONS(4516),
    [anon_sym_extern] = ACTIONS(4516),
    [anon_sym_alias] = ACTIONS(4516),
    [anon_sym_global] = ACTIONS(4516),
    [anon_sym_using] = ACTIONS(4516),
    [anon_sym_static] = ACTIONS(4516),
    [anon_sym_LBRACK] = ACTIONS(4518),
    [anon_sym_event] = ACTIONS(4516),
    [anon_sym_LPAREN] = ACTIONS(4518),
    [anon_sym_abstract] = ACTIONS(4516),
    [anon_sym_async] = ACTIONS(4516),
    [anon_sym_const] = ACTIONS(4516),
    [anon_sym_fixed] = ACTIONS(4516),
    [anon_sym_internal] = ACTIONS(4516),
    [anon_sym_new] = ACTIONS(4516),
    [anon_sym_override] = ACTIONS(4516),
    [anon_sym_partial] = ACTIONS(4516),
    [anon_sym_private] = ACTIONS(4516),
    [anon_sym_protected] = ACTIONS(4516),
    [anon_sym_public] = ACTIONS(4516),
    [anon_sym_readonly] = ACTIONS(4516),
    [anon_sym_ref] = ACTIONS(4516),
    [anon_sym_sealed] = ACTIONS(4516),
    [anon_sym_unsafe] = ACTIONS(4516),
    [anon_sym_virtual] = ACTIONS(4516),
    [anon_sym_volatile] = ACTIONS(4516),
    [anon_sym_RBRACE] = ACTIONS(4518),
    [anon_sym_implicit] = ACTIONS(4516),
    [anon_sym_explicit] = ACTIONS(4516),
    [anon_sym_TILDE] = ACTIONS(4518),
    [anon_sym_where] = ACTIONS(4516),
    [anon_sym_class] = ACTIONS(4516),
    [anon_sym_struct] = ACTIONS(4516),
    [anon_sym_notnull] = ACTIONS(4516),
    [anon_sym_unmanaged] = ACTIONS(4516),
    [anon_sym_get] = ACTIONS(4516),
    [anon_sym_set] = ACTIONS(4516),
    [anon_sym_add] = ACTIONS(4516),
    [anon_sym_remove] = ACTIONS(4516),
    [anon_sym_enum] = ACTIONS(4516),
    [anon_sym_interface] = ACTIONS(4516),
    [anon_sym_delegate] = ACTIONS(4516),
    [anon_sym_record] = ACTIONS(4516),
    [anon_sym_namespace] = ACTIONS(4516),
    [anon_sym_var] = ACTIONS(4516),
    [sym_predefined_type] = ACTIONS(4516),
    [anon_sym_when] = ACTIONS(4516),
    [anon_sym_yield] = ACTIONS(4516),
    [anon_sym_from] = ACTIONS(4516),
    [anon_sym_join] = ACTIONS(4516),
    [anon_sym_on] = ACTIONS(4516),
    [anon_sym_equals] = ACTIONS(4516),
    [anon_sym_into] = ACTIONS(4516),
    [anon_sym_let] = ACTIONS(4516),
    [anon_sym_orderby] = ACTIONS(4516),
    [anon_sym_ascending] = ACTIONS(4516),
    [anon_sym_descending] = ACTIONS(4516),
    [anon_sym_group] = ACTIONS(4516),
    [anon_sym_by] = ACTIONS(4516),
    [anon_sym_select] = ACTIONS(4516),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4516),
    [anon_sym_nameof] = ACTIONS(4516),
    [sym_void_keyword] = ACTIONS(4516),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2457] = {
    [sym__preprocessor_call] = STATE(2457),
    [sym__identifier_token] = ACTIONS(4520),
    [anon_sym_extern] = ACTIONS(4520),
    [anon_sym_alias] = ACTIONS(4520),
    [anon_sym_global] = ACTIONS(4520),
    [anon_sym_using] = ACTIONS(4520),
    [anon_sym_static] = ACTIONS(4520),
    [anon_sym_LBRACK] = ACTIONS(4522),
    [anon_sym_event] = ACTIONS(4520),
    [anon_sym_LPAREN] = ACTIONS(4522),
    [anon_sym_abstract] = ACTIONS(4520),
    [anon_sym_async] = ACTIONS(4520),
    [anon_sym_const] = ACTIONS(4520),
    [anon_sym_fixed] = ACTIONS(4520),
    [anon_sym_internal] = ACTIONS(4520),
    [anon_sym_new] = ACTIONS(4520),
    [anon_sym_override] = ACTIONS(4520),
    [anon_sym_partial] = ACTIONS(4520),
    [anon_sym_private] = ACTIONS(4520),
    [anon_sym_protected] = ACTIONS(4520),
    [anon_sym_public] = ACTIONS(4520),
    [anon_sym_readonly] = ACTIONS(4520),
    [anon_sym_ref] = ACTIONS(4520),
    [anon_sym_sealed] = ACTIONS(4520),
    [anon_sym_unsafe] = ACTIONS(4520),
    [anon_sym_virtual] = ACTIONS(4520),
    [anon_sym_volatile] = ACTIONS(4520),
    [anon_sym_RBRACE] = ACTIONS(4522),
    [anon_sym_implicit] = ACTIONS(4520),
    [anon_sym_explicit] = ACTIONS(4520),
    [anon_sym_TILDE] = ACTIONS(4522),
    [anon_sym_where] = ACTIONS(4520),
    [anon_sym_class] = ACTIONS(4520),
    [anon_sym_struct] = ACTIONS(4520),
    [anon_sym_notnull] = ACTIONS(4520),
    [anon_sym_unmanaged] = ACTIONS(4520),
    [anon_sym_get] = ACTIONS(4520),
    [anon_sym_set] = ACTIONS(4520),
    [anon_sym_add] = ACTIONS(4520),
    [anon_sym_remove] = ACTIONS(4520),
    [anon_sym_enum] = ACTIONS(4520),
    [anon_sym_interface] = ACTIONS(4520),
    [anon_sym_delegate] = ACTIONS(4520),
    [anon_sym_record] = ACTIONS(4520),
    [anon_sym_namespace] = ACTIONS(4520),
    [anon_sym_var] = ACTIONS(4520),
    [sym_predefined_type] = ACTIONS(4520),
    [anon_sym_when] = ACTIONS(4520),
    [anon_sym_yield] = ACTIONS(4520),
    [anon_sym_from] = ACTIONS(4520),
    [anon_sym_join] = ACTIONS(4520),
    [anon_sym_on] = ACTIONS(4520),
    [anon_sym_equals] = ACTIONS(4520),
    [anon_sym_into] = ACTIONS(4520),
    [anon_sym_let] = ACTIONS(4520),
    [anon_sym_orderby] = ACTIONS(4520),
    [anon_sym_ascending] = ACTIONS(4520),
    [anon_sym_descending] = ACTIONS(4520),
    [anon_sym_group] = ACTIONS(4520),
    [anon_sym_by] = ACTIONS(4520),
    [anon_sym_select] = ACTIONS(4520),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4520),
    [anon_sym_nameof] = ACTIONS(4520),
    [sym_void_keyword] = ACTIONS(4520),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2458] = {
    [sym_argument_list] = STATE(2638),
    [sym_array_rank_specifier] = STATE(2689),
    [sym_initializer_expression] = STATE(2734),
    [sym__preprocessor_call] = STATE(2458),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_EQ] = ACTIONS(3236),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_COMMA] = ACTIONS(3234),
    [anon_sym_GT] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(4524),
    [anon_sym_RBRACK] = ACTIONS(3234),
    [anon_sym_COLON] = ACTIONS(3234),
    [anon_sym_LPAREN] = ACTIONS(4526),
    [anon_sym_RPAREN] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3236),
    [anon_sym_LBRACE] = ACTIONS(747),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_EQ_GT] = ACTIONS(3234),
    [anon_sym_QMARK] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(4528),
    [anon_sym_SLASH] = ACTIONS(3236),
    [anon_sym_PERCENT] = ACTIONS(3236),
    [anon_sym_CARET] = ACTIONS(3236),
    [anon_sym_PIPE] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3236),
    [anon_sym_LT_LT] = ACTIONS(3236),
    [anon_sym_GT_GT] = ACTIONS(3236),
    [anon_sym_EQ_EQ] = ACTIONS(3234),
    [anon_sym_BANG_EQ] = ACTIONS(3234),
    [anon_sym_GT_EQ] = ACTIONS(3234),
    [anon_sym_LT_EQ] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_and] = ACTIONS(3234),
    [anon_sym_or] = ACTIONS(3234),
    [anon_sym_when] = ACTIONS(3234),
    [anon_sym_PLUS_EQ] = ACTIONS(3234),
    [anon_sym_DASH_EQ] = ACTIONS(3234),
    [anon_sym_STAR_EQ] = ACTIONS(3234),
    [anon_sym_SLASH_EQ] = ACTIONS(3234),
    [anon_sym_PERCENT_EQ] = ACTIONS(3234),
    [anon_sym_AMP_EQ] = ACTIONS(3234),
    [anon_sym_CARET_EQ] = ACTIONS(3234),
    [anon_sym_PIPE_EQ] = ACTIONS(3234),
    [anon_sym_LT_LT_EQ] = ACTIONS(3234),
    [anon_sym_GT_GT_EQ] = ACTIONS(3234),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3234),
    [anon_sym_is] = ACTIONS(3234),
    [anon_sym_DASH_GT] = ACTIONS(3234),
    [anon_sym_on] = ACTIONS(3234),
    [anon_sym_equals] = ACTIONS(3234),
    [anon_sym_into] = ACTIONS(3234),
    [anon_sym_by] = ACTIONS(3234),
    [anon_sym_DOT_DOT] = ACTIONS(3234),
    [anon_sym_with] = ACTIONS(3234),
    [anon_sym_AMP_AMP] = ACTIONS(3234),
    [anon_sym_PIPE_PIPE] = ACTIONS(3234),
    [anon_sym_QMARK_QMARK] = ACTIONS(3236),
    [anon_sym_as] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2459] = {
    [sym__preprocessor_call] = STATE(2459),
    [sym__identifier_token] = ACTIONS(4530),
    [anon_sym_extern] = ACTIONS(4530),
    [anon_sym_alias] = ACTIONS(4530),
    [anon_sym_global] = ACTIONS(4530),
    [anon_sym_using] = ACTIONS(4530),
    [anon_sym_static] = ACTIONS(4530),
    [anon_sym_LBRACK] = ACTIONS(4532),
    [anon_sym_event] = ACTIONS(4530),
    [anon_sym_LPAREN] = ACTIONS(4532),
    [anon_sym_abstract] = ACTIONS(4530),
    [anon_sym_async] = ACTIONS(4530),
    [anon_sym_const] = ACTIONS(4530),
    [anon_sym_fixed] = ACTIONS(4530),
    [anon_sym_internal] = ACTIONS(4530),
    [anon_sym_new] = ACTIONS(4530),
    [anon_sym_override] = ACTIONS(4530),
    [anon_sym_partial] = ACTIONS(4530),
    [anon_sym_private] = ACTIONS(4530),
    [anon_sym_protected] = ACTIONS(4530),
    [anon_sym_public] = ACTIONS(4530),
    [anon_sym_readonly] = ACTIONS(4530),
    [anon_sym_ref] = ACTIONS(4530),
    [anon_sym_sealed] = ACTIONS(4530),
    [anon_sym_unsafe] = ACTIONS(4530),
    [anon_sym_virtual] = ACTIONS(4530),
    [anon_sym_volatile] = ACTIONS(4530),
    [anon_sym_RBRACE] = ACTIONS(4532),
    [anon_sym_implicit] = ACTIONS(4530),
    [anon_sym_explicit] = ACTIONS(4530),
    [anon_sym_TILDE] = ACTIONS(4532),
    [anon_sym_where] = ACTIONS(4530),
    [anon_sym_class] = ACTIONS(4530),
    [anon_sym_struct] = ACTIONS(4530),
    [anon_sym_notnull] = ACTIONS(4530),
    [anon_sym_unmanaged] = ACTIONS(4530),
    [anon_sym_get] = ACTIONS(4530),
    [anon_sym_set] = ACTIONS(4530),
    [anon_sym_add] = ACTIONS(4530),
    [anon_sym_remove] = ACTIONS(4530),
    [anon_sym_enum] = ACTIONS(4530),
    [anon_sym_interface] = ACTIONS(4530),
    [anon_sym_delegate] = ACTIONS(4530),
    [anon_sym_record] = ACTIONS(4530),
    [anon_sym_namespace] = ACTIONS(4530),
    [anon_sym_var] = ACTIONS(4530),
    [sym_predefined_type] = ACTIONS(4530),
    [anon_sym_when] = ACTIONS(4530),
    [anon_sym_yield] = ACTIONS(4530),
    [anon_sym_from] = ACTIONS(4530),
    [anon_sym_join] = ACTIONS(4530),
    [anon_sym_on] = ACTIONS(4530),
    [anon_sym_equals] = ACTIONS(4530),
    [anon_sym_into] = ACTIONS(4530),
    [anon_sym_let] = ACTIONS(4530),
    [anon_sym_orderby] = ACTIONS(4530),
    [anon_sym_ascending] = ACTIONS(4530),
    [anon_sym_descending] = ACTIONS(4530),
    [anon_sym_group] = ACTIONS(4530),
    [anon_sym_by] = ACTIONS(4530),
    [anon_sym_select] = ACTIONS(4530),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4530),
    [anon_sym_nameof] = ACTIONS(4530),
    [sym_void_keyword] = ACTIONS(4530),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2460] = {
    [sym__preprocessor_call] = STATE(2460),
    [sym__identifier_token] = ACTIONS(4534),
    [anon_sym_extern] = ACTIONS(4534),
    [anon_sym_alias] = ACTIONS(4534),
    [anon_sym_global] = ACTIONS(4534),
    [anon_sym_using] = ACTIONS(4534),
    [anon_sym_static] = ACTIONS(4534),
    [anon_sym_LBRACK] = ACTIONS(4536),
    [anon_sym_event] = ACTIONS(4534),
    [anon_sym_LPAREN] = ACTIONS(4536),
    [anon_sym_abstract] = ACTIONS(4534),
    [anon_sym_async] = ACTIONS(4534),
    [anon_sym_const] = ACTIONS(4534),
    [anon_sym_fixed] = ACTIONS(4534),
    [anon_sym_internal] = ACTIONS(4534),
    [anon_sym_new] = ACTIONS(4534),
    [anon_sym_override] = ACTIONS(4534),
    [anon_sym_partial] = ACTIONS(4534),
    [anon_sym_private] = ACTIONS(4534),
    [anon_sym_protected] = ACTIONS(4534),
    [anon_sym_public] = ACTIONS(4534),
    [anon_sym_readonly] = ACTIONS(4534),
    [anon_sym_ref] = ACTIONS(4534),
    [anon_sym_sealed] = ACTIONS(4534),
    [anon_sym_unsafe] = ACTIONS(4534),
    [anon_sym_virtual] = ACTIONS(4534),
    [anon_sym_volatile] = ACTIONS(4534),
    [anon_sym_RBRACE] = ACTIONS(4536),
    [anon_sym_implicit] = ACTIONS(4534),
    [anon_sym_explicit] = ACTIONS(4534),
    [anon_sym_TILDE] = ACTIONS(4536),
    [anon_sym_where] = ACTIONS(4534),
    [anon_sym_class] = ACTIONS(4534),
    [anon_sym_struct] = ACTIONS(4534),
    [anon_sym_notnull] = ACTIONS(4534),
    [anon_sym_unmanaged] = ACTIONS(4534),
    [anon_sym_get] = ACTIONS(4534),
    [anon_sym_set] = ACTIONS(4534),
    [anon_sym_add] = ACTIONS(4534),
    [anon_sym_remove] = ACTIONS(4534),
    [anon_sym_enum] = ACTIONS(4534),
    [anon_sym_interface] = ACTIONS(4534),
    [anon_sym_delegate] = ACTIONS(4534),
    [anon_sym_record] = ACTIONS(4534),
    [anon_sym_namespace] = ACTIONS(4534),
    [anon_sym_var] = ACTIONS(4534),
    [sym_predefined_type] = ACTIONS(4534),
    [anon_sym_when] = ACTIONS(4534),
    [anon_sym_yield] = ACTIONS(4534),
    [anon_sym_from] = ACTIONS(4534),
    [anon_sym_join] = ACTIONS(4534),
    [anon_sym_on] = ACTIONS(4534),
    [anon_sym_equals] = ACTIONS(4534),
    [anon_sym_into] = ACTIONS(4534),
    [anon_sym_let] = ACTIONS(4534),
    [anon_sym_orderby] = ACTIONS(4534),
    [anon_sym_ascending] = ACTIONS(4534),
    [anon_sym_descending] = ACTIONS(4534),
    [anon_sym_group] = ACTIONS(4534),
    [anon_sym_by] = ACTIONS(4534),
    [anon_sym_select] = ACTIONS(4534),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4534),
    [anon_sym_nameof] = ACTIONS(4534),
    [sym_void_keyword] = ACTIONS(4534),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2461] = {
    [sym__preprocessor_call] = STATE(2461),
    [sym__identifier_token] = ACTIONS(4538),
    [anon_sym_extern] = ACTIONS(4538),
    [anon_sym_alias] = ACTIONS(4538),
    [anon_sym_global] = ACTIONS(4538),
    [anon_sym_using] = ACTIONS(4538),
    [anon_sym_static] = ACTIONS(4538),
    [anon_sym_LBRACK] = ACTIONS(4540),
    [anon_sym_event] = ACTIONS(4538),
    [anon_sym_LPAREN] = ACTIONS(4540),
    [anon_sym_abstract] = ACTIONS(4538),
    [anon_sym_async] = ACTIONS(4538),
    [anon_sym_const] = ACTIONS(4538),
    [anon_sym_fixed] = ACTIONS(4538),
    [anon_sym_internal] = ACTIONS(4538),
    [anon_sym_new] = ACTIONS(4538),
    [anon_sym_override] = ACTIONS(4538),
    [anon_sym_partial] = ACTIONS(4538),
    [anon_sym_private] = ACTIONS(4538),
    [anon_sym_protected] = ACTIONS(4538),
    [anon_sym_public] = ACTIONS(4538),
    [anon_sym_readonly] = ACTIONS(4538),
    [anon_sym_ref] = ACTIONS(4538),
    [anon_sym_sealed] = ACTIONS(4538),
    [anon_sym_unsafe] = ACTIONS(4538),
    [anon_sym_virtual] = ACTIONS(4538),
    [anon_sym_volatile] = ACTIONS(4538),
    [anon_sym_RBRACE] = ACTIONS(4540),
    [anon_sym_implicit] = ACTIONS(4538),
    [anon_sym_explicit] = ACTIONS(4538),
    [anon_sym_TILDE] = ACTIONS(4540),
    [anon_sym_where] = ACTIONS(4538),
    [anon_sym_class] = ACTIONS(4538),
    [anon_sym_struct] = ACTIONS(4538),
    [anon_sym_notnull] = ACTIONS(4538),
    [anon_sym_unmanaged] = ACTIONS(4538),
    [anon_sym_get] = ACTIONS(4538),
    [anon_sym_set] = ACTIONS(4538),
    [anon_sym_add] = ACTIONS(4538),
    [anon_sym_remove] = ACTIONS(4538),
    [anon_sym_enum] = ACTIONS(4538),
    [anon_sym_interface] = ACTIONS(4538),
    [anon_sym_delegate] = ACTIONS(4538),
    [anon_sym_record] = ACTIONS(4538),
    [anon_sym_namespace] = ACTIONS(4538),
    [anon_sym_var] = ACTIONS(4538),
    [sym_predefined_type] = ACTIONS(4538),
    [anon_sym_when] = ACTIONS(4538),
    [anon_sym_yield] = ACTIONS(4538),
    [anon_sym_from] = ACTIONS(4538),
    [anon_sym_join] = ACTIONS(4538),
    [anon_sym_on] = ACTIONS(4538),
    [anon_sym_equals] = ACTIONS(4538),
    [anon_sym_into] = ACTIONS(4538),
    [anon_sym_let] = ACTIONS(4538),
    [anon_sym_orderby] = ACTIONS(4538),
    [anon_sym_ascending] = ACTIONS(4538),
    [anon_sym_descending] = ACTIONS(4538),
    [anon_sym_group] = ACTIONS(4538),
    [anon_sym_by] = ACTIONS(4538),
    [anon_sym_select] = ACTIONS(4538),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4538),
    [anon_sym_nameof] = ACTIONS(4538),
    [sym_void_keyword] = ACTIONS(4538),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2462] = {
    [sym__preprocessor_call] = STATE(2462),
    [sym__identifier_token] = ACTIONS(4542),
    [anon_sym_extern] = ACTIONS(4542),
    [anon_sym_alias] = ACTIONS(4542),
    [anon_sym_global] = ACTIONS(4542),
    [anon_sym_using] = ACTIONS(4542),
    [anon_sym_static] = ACTIONS(4542),
    [anon_sym_LBRACK] = ACTIONS(4544),
    [anon_sym_event] = ACTIONS(4542),
    [anon_sym_LPAREN] = ACTIONS(4544),
    [anon_sym_abstract] = ACTIONS(4542),
    [anon_sym_async] = ACTIONS(4542),
    [anon_sym_const] = ACTIONS(4542),
    [anon_sym_fixed] = ACTIONS(4542),
    [anon_sym_internal] = ACTIONS(4542),
    [anon_sym_new] = ACTIONS(4542),
    [anon_sym_override] = ACTIONS(4542),
    [anon_sym_partial] = ACTIONS(4542),
    [anon_sym_private] = ACTIONS(4542),
    [anon_sym_protected] = ACTIONS(4542),
    [anon_sym_public] = ACTIONS(4542),
    [anon_sym_readonly] = ACTIONS(4542),
    [anon_sym_ref] = ACTIONS(4542),
    [anon_sym_sealed] = ACTIONS(4542),
    [anon_sym_unsafe] = ACTIONS(4542),
    [anon_sym_virtual] = ACTIONS(4542),
    [anon_sym_volatile] = ACTIONS(4542),
    [anon_sym_RBRACE] = ACTIONS(4544),
    [anon_sym_implicit] = ACTIONS(4542),
    [anon_sym_explicit] = ACTIONS(4542),
    [anon_sym_TILDE] = ACTIONS(4544),
    [anon_sym_where] = ACTIONS(4542),
    [anon_sym_class] = ACTIONS(4542),
    [anon_sym_struct] = ACTIONS(4542),
    [anon_sym_notnull] = ACTIONS(4542),
    [anon_sym_unmanaged] = ACTIONS(4542),
    [anon_sym_get] = ACTIONS(4542),
    [anon_sym_set] = ACTIONS(4542),
    [anon_sym_add] = ACTIONS(4542),
    [anon_sym_remove] = ACTIONS(4542),
    [anon_sym_enum] = ACTIONS(4542),
    [anon_sym_interface] = ACTIONS(4542),
    [anon_sym_delegate] = ACTIONS(4542),
    [anon_sym_record] = ACTIONS(4542),
    [anon_sym_namespace] = ACTIONS(4542),
    [anon_sym_var] = ACTIONS(4542),
    [sym_predefined_type] = ACTIONS(4542),
    [anon_sym_when] = ACTIONS(4542),
    [anon_sym_yield] = ACTIONS(4542),
    [anon_sym_from] = ACTIONS(4542),
    [anon_sym_join] = ACTIONS(4542),
    [anon_sym_on] = ACTIONS(4542),
    [anon_sym_equals] = ACTIONS(4542),
    [anon_sym_into] = ACTIONS(4542),
    [anon_sym_let] = ACTIONS(4542),
    [anon_sym_orderby] = ACTIONS(4542),
    [anon_sym_ascending] = ACTIONS(4542),
    [anon_sym_descending] = ACTIONS(4542),
    [anon_sym_group] = ACTIONS(4542),
    [anon_sym_by] = ACTIONS(4542),
    [anon_sym_select] = ACTIONS(4542),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4542),
    [anon_sym_nameof] = ACTIONS(4542),
    [sym_void_keyword] = ACTIONS(4542),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2463] = {
    [sym__preprocessor_call] = STATE(2463),
    [sym__identifier_token] = ACTIONS(4546),
    [anon_sym_extern] = ACTIONS(4546),
    [anon_sym_alias] = ACTIONS(4546),
    [anon_sym_global] = ACTIONS(4546),
    [anon_sym_using] = ACTIONS(4546),
    [anon_sym_static] = ACTIONS(4546),
    [anon_sym_LBRACK] = ACTIONS(4548),
    [anon_sym_event] = ACTIONS(4546),
    [anon_sym_LPAREN] = ACTIONS(4548),
    [anon_sym_abstract] = ACTIONS(4546),
    [anon_sym_async] = ACTIONS(4546),
    [anon_sym_const] = ACTIONS(4546),
    [anon_sym_fixed] = ACTIONS(4546),
    [anon_sym_internal] = ACTIONS(4546),
    [anon_sym_new] = ACTIONS(4546),
    [anon_sym_override] = ACTIONS(4546),
    [anon_sym_partial] = ACTIONS(4546),
    [anon_sym_private] = ACTIONS(4546),
    [anon_sym_protected] = ACTIONS(4546),
    [anon_sym_public] = ACTIONS(4546),
    [anon_sym_readonly] = ACTIONS(4546),
    [anon_sym_ref] = ACTIONS(4546),
    [anon_sym_sealed] = ACTIONS(4546),
    [anon_sym_unsafe] = ACTIONS(4546),
    [anon_sym_virtual] = ACTIONS(4546),
    [anon_sym_volatile] = ACTIONS(4546),
    [anon_sym_RBRACE] = ACTIONS(4548),
    [anon_sym_implicit] = ACTIONS(4546),
    [anon_sym_explicit] = ACTIONS(4546),
    [anon_sym_TILDE] = ACTIONS(4548),
    [anon_sym_where] = ACTIONS(4546),
    [anon_sym_class] = ACTIONS(4546),
    [anon_sym_struct] = ACTIONS(4546),
    [anon_sym_notnull] = ACTIONS(4546),
    [anon_sym_unmanaged] = ACTIONS(4546),
    [anon_sym_get] = ACTIONS(4546),
    [anon_sym_set] = ACTIONS(4546),
    [anon_sym_add] = ACTIONS(4546),
    [anon_sym_remove] = ACTIONS(4546),
    [anon_sym_enum] = ACTIONS(4546),
    [anon_sym_interface] = ACTIONS(4546),
    [anon_sym_delegate] = ACTIONS(4546),
    [anon_sym_record] = ACTIONS(4546),
    [anon_sym_namespace] = ACTIONS(4546),
    [anon_sym_var] = ACTIONS(4546),
    [sym_predefined_type] = ACTIONS(4546),
    [anon_sym_when] = ACTIONS(4546),
    [anon_sym_yield] = ACTIONS(4546),
    [anon_sym_from] = ACTIONS(4546),
    [anon_sym_join] = ACTIONS(4546),
    [anon_sym_on] = ACTIONS(4546),
    [anon_sym_equals] = ACTIONS(4546),
    [anon_sym_into] = ACTIONS(4546),
    [anon_sym_let] = ACTIONS(4546),
    [anon_sym_orderby] = ACTIONS(4546),
    [anon_sym_ascending] = ACTIONS(4546),
    [anon_sym_descending] = ACTIONS(4546),
    [anon_sym_group] = ACTIONS(4546),
    [anon_sym_by] = ACTIONS(4546),
    [anon_sym_select] = ACTIONS(4546),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4546),
    [anon_sym_nameof] = ACTIONS(4546),
    [sym_void_keyword] = ACTIONS(4546),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2464] = {
    [sym__preprocessor_call] = STATE(2464),
    [sym__identifier_token] = ACTIONS(4550),
    [anon_sym_extern] = ACTIONS(4550),
    [anon_sym_alias] = ACTIONS(4550),
    [anon_sym_global] = ACTIONS(4550),
    [anon_sym_using] = ACTIONS(4550),
    [anon_sym_static] = ACTIONS(4550),
    [anon_sym_LBRACK] = ACTIONS(4552),
    [anon_sym_event] = ACTIONS(4550),
    [anon_sym_LPAREN] = ACTIONS(4552),
    [anon_sym_abstract] = ACTIONS(4550),
    [anon_sym_async] = ACTIONS(4550),
    [anon_sym_const] = ACTIONS(4550),
    [anon_sym_fixed] = ACTIONS(4550),
    [anon_sym_internal] = ACTIONS(4550),
    [anon_sym_new] = ACTIONS(4550),
    [anon_sym_override] = ACTIONS(4550),
    [anon_sym_partial] = ACTIONS(4550),
    [anon_sym_private] = ACTIONS(4550),
    [anon_sym_protected] = ACTIONS(4550),
    [anon_sym_public] = ACTIONS(4550),
    [anon_sym_readonly] = ACTIONS(4550),
    [anon_sym_ref] = ACTIONS(4550),
    [anon_sym_sealed] = ACTIONS(4550),
    [anon_sym_unsafe] = ACTIONS(4550),
    [anon_sym_virtual] = ACTIONS(4550),
    [anon_sym_volatile] = ACTIONS(4550),
    [anon_sym_RBRACE] = ACTIONS(4552),
    [anon_sym_implicit] = ACTIONS(4550),
    [anon_sym_explicit] = ACTIONS(4550),
    [anon_sym_TILDE] = ACTIONS(4552),
    [anon_sym_where] = ACTIONS(4550),
    [anon_sym_class] = ACTIONS(4550),
    [anon_sym_struct] = ACTIONS(4550),
    [anon_sym_notnull] = ACTIONS(4550),
    [anon_sym_unmanaged] = ACTIONS(4550),
    [anon_sym_get] = ACTIONS(4550),
    [anon_sym_set] = ACTIONS(4550),
    [anon_sym_add] = ACTIONS(4550),
    [anon_sym_remove] = ACTIONS(4550),
    [anon_sym_enum] = ACTIONS(4550),
    [anon_sym_interface] = ACTIONS(4550),
    [anon_sym_delegate] = ACTIONS(4550),
    [anon_sym_record] = ACTIONS(4550),
    [anon_sym_namespace] = ACTIONS(4550),
    [anon_sym_var] = ACTIONS(4550),
    [sym_predefined_type] = ACTIONS(4550),
    [anon_sym_when] = ACTIONS(4550),
    [anon_sym_yield] = ACTIONS(4550),
    [anon_sym_from] = ACTIONS(4550),
    [anon_sym_join] = ACTIONS(4550),
    [anon_sym_on] = ACTIONS(4550),
    [anon_sym_equals] = ACTIONS(4550),
    [anon_sym_into] = ACTIONS(4550),
    [anon_sym_let] = ACTIONS(4550),
    [anon_sym_orderby] = ACTIONS(4550),
    [anon_sym_ascending] = ACTIONS(4550),
    [anon_sym_descending] = ACTIONS(4550),
    [anon_sym_group] = ACTIONS(4550),
    [anon_sym_by] = ACTIONS(4550),
    [anon_sym_select] = ACTIONS(4550),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4550),
    [anon_sym_nameof] = ACTIONS(4550),
    [sym_void_keyword] = ACTIONS(4550),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2465] = {
    [sym__preprocessor_call] = STATE(2465),
    [sym__identifier_token] = ACTIONS(4554),
    [anon_sym_extern] = ACTIONS(4554),
    [anon_sym_alias] = ACTIONS(4554),
    [anon_sym_global] = ACTIONS(4554),
    [anon_sym_using] = ACTIONS(4554),
    [anon_sym_static] = ACTIONS(4554),
    [anon_sym_LBRACK] = ACTIONS(4556),
    [anon_sym_event] = ACTIONS(4554),
    [anon_sym_LPAREN] = ACTIONS(4556),
    [anon_sym_abstract] = ACTIONS(4554),
    [anon_sym_async] = ACTIONS(4554),
    [anon_sym_const] = ACTIONS(4554),
    [anon_sym_fixed] = ACTIONS(4554),
    [anon_sym_internal] = ACTIONS(4554),
    [anon_sym_new] = ACTIONS(4554),
    [anon_sym_override] = ACTIONS(4554),
    [anon_sym_partial] = ACTIONS(4554),
    [anon_sym_private] = ACTIONS(4554),
    [anon_sym_protected] = ACTIONS(4554),
    [anon_sym_public] = ACTIONS(4554),
    [anon_sym_readonly] = ACTIONS(4554),
    [anon_sym_ref] = ACTIONS(4554),
    [anon_sym_sealed] = ACTIONS(4554),
    [anon_sym_unsafe] = ACTIONS(4554),
    [anon_sym_virtual] = ACTIONS(4554),
    [anon_sym_volatile] = ACTIONS(4554),
    [anon_sym_RBRACE] = ACTIONS(4556),
    [anon_sym_implicit] = ACTIONS(4554),
    [anon_sym_explicit] = ACTIONS(4554),
    [anon_sym_TILDE] = ACTIONS(4556),
    [anon_sym_where] = ACTIONS(4554),
    [anon_sym_class] = ACTIONS(4554),
    [anon_sym_struct] = ACTIONS(4554),
    [anon_sym_notnull] = ACTIONS(4554),
    [anon_sym_unmanaged] = ACTIONS(4554),
    [anon_sym_get] = ACTIONS(4554),
    [anon_sym_set] = ACTIONS(4554),
    [anon_sym_add] = ACTIONS(4554),
    [anon_sym_remove] = ACTIONS(4554),
    [anon_sym_enum] = ACTIONS(4554),
    [anon_sym_interface] = ACTIONS(4554),
    [anon_sym_delegate] = ACTIONS(4554),
    [anon_sym_record] = ACTIONS(4554),
    [anon_sym_namespace] = ACTIONS(4554),
    [anon_sym_var] = ACTIONS(4554),
    [sym_predefined_type] = ACTIONS(4554),
    [anon_sym_when] = ACTIONS(4554),
    [anon_sym_yield] = ACTIONS(4554),
    [anon_sym_from] = ACTIONS(4554),
    [anon_sym_join] = ACTIONS(4554),
    [anon_sym_on] = ACTIONS(4554),
    [anon_sym_equals] = ACTIONS(4554),
    [anon_sym_into] = ACTIONS(4554),
    [anon_sym_let] = ACTIONS(4554),
    [anon_sym_orderby] = ACTIONS(4554),
    [anon_sym_ascending] = ACTIONS(4554),
    [anon_sym_descending] = ACTIONS(4554),
    [anon_sym_group] = ACTIONS(4554),
    [anon_sym_by] = ACTIONS(4554),
    [anon_sym_select] = ACTIONS(4554),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4554),
    [anon_sym_nameof] = ACTIONS(4554),
    [sym_void_keyword] = ACTIONS(4554),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2466] = {
    [sym__preprocessor_call] = STATE(2466),
    [sym__identifier_token] = ACTIONS(4558),
    [anon_sym_extern] = ACTIONS(4558),
    [anon_sym_alias] = ACTIONS(4558),
    [anon_sym_global] = ACTIONS(4558),
    [anon_sym_using] = ACTIONS(4558),
    [anon_sym_static] = ACTIONS(4558),
    [anon_sym_LBRACK] = ACTIONS(4560),
    [anon_sym_event] = ACTIONS(4558),
    [anon_sym_LPAREN] = ACTIONS(4560),
    [anon_sym_abstract] = ACTIONS(4558),
    [anon_sym_async] = ACTIONS(4558),
    [anon_sym_const] = ACTIONS(4558),
    [anon_sym_fixed] = ACTIONS(4558),
    [anon_sym_internal] = ACTIONS(4558),
    [anon_sym_new] = ACTIONS(4558),
    [anon_sym_override] = ACTIONS(4558),
    [anon_sym_partial] = ACTIONS(4558),
    [anon_sym_private] = ACTIONS(4558),
    [anon_sym_protected] = ACTIONS(4558),
    [anon_sym_public] = ACTIONS(4558),
    [anon_sym_readonly] = ACTIONS(4558),
    [anon_sym_ref] = ACTIONS(4558),
    [anon_sym_sealed] = ACTIONS(4558),
    [anon_sym_unsafe] = ACTIONS(4558),
    [anon_sym_virtual] = ACTIONS(4558),
    [anon_sym_volatile] = ACTIONS(4558),
    [anon_sym_RBRACE] = ACTIONS(4560),
    [anon_sym_implicit] = ACTIONS(4558),
    [anon_sym_explicit] = ACTIONS(4558),
    [anon_sym_TILDE] = ACTIONS(4560),
    [anon_sym_where] = ACTIONS(4558),
    [anon_sym_class] = ACTIONS(4558),
    [anon_sym_struct] = ACTIONS(4558),
    [anon_sym_notnull] = ACTIONS(4558),
    [anon_sym_unmanaged] = ACTIONS(4558),
    [anon_sym_get] = ACTIONS(4558),
    [anon_sym_set] = ACTIONS(4558),
    [anon_sym_add] = ACTIONS(4558),
    [anon_sym_remove] = ACTIONS(4558),
    [anon_sym_enum] = ACTIONS(4558),
    [anon_sym_interface] = ACTIONS(4558),
    [anon_sym_delegate] = ACTIONS(4558),
    [anon_sym_record] = ACTIONS(4558),
    [anon_sym_namespace] = ACTIONS(4558),
    [anon_sym_var] = ACTIONS(4558),
    [sym_predefined_type] = ACTIONS(4558),
    [anon_sym_when] = ACTIONS(4558),
    [anon_sym_yield] = ACTIONS(4558),
    [anon_sym_from] = ACTIONS(4558),
    [anon_sym_join] = ACTIONS(4558),
    [anon_sym_on] = ACTIONS(4558),
    [anon_sym_equals] = ACTIONS(4558),
    [anon_sym_into] = ACTIONS(4558),
    [anon_sym_let] = ACTIONS(4558),
    [anon_sym_orderby] = ACTIONS(4558),
    [anon_sym_ascending] = ACTIONS(4558),
    [anon_sym_descending] = ACTIONS(4558),
    [anon_sym_group] = ACTIONS(4558),
    [anon_sym_by] = ACTIONS(4558),
    [anon_sym_select] = ACTIONS(4558),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4558),
    [anon_sym_nameof] = ACTIONS(4558),
    [sym_void_keyword] = ACTIONS(4558),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2467] = {
    [sym__preprocessor_call] = STATE(2467),
    [sym__identifier_token] = ACTIONS(1979),
    [anon_sym_extern] = ACTIONS(1979),
    [anon_sym_alias] = ACTIONS(1979),
    [anon_sym_global] = ACTIONS(1979),
    [anon_sym_using] = ACTIONS(1979),
    [anon_sym_static] = ACTIONS(1979),
    [anon_sym_LBRACK] = ACTIONS(1977),
    [anon_sym_event] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(1977),
    [anon_sym_abstract] = ACTIONS(1979),
    [anon_sym_async] = ACTIONS(1979),
    [anon_sym_const] = ACTIONS(1979),
    [anon_sym_fixed] = ACTIONS(1979),
    [anon_sym_internal] = ACTIONS(1979),
    [anon_sym_new] = ACTIONS(1979),
    [anon_sym_override] = ACTIONS(1979),
    [anon_sym_partial] = ACTIONS(1979),
    [anon_sym_private] = ACTIONS(1979),
    [anon_sym_protected] = ACTIONS(1979),
    [anon_sym_public] = ACTIONS(1979),
    [anon_sym_readonly] = ACTIONS(1979),
    [anon_sym_ref] = ACTIONS(1979),
    [anon_sym_sealed] = ACTIONS(1979),
    [anon_sym_unsafe] = ACTIONS(1979),
    [anon_sym_virtual] = ACTIONS(1979),
    [anon_sym_volatile] = ACTIONS(1979),
    [anon_sym_RBRACE] = ACTIONS(1977),
    [anon_sym_implicit] = ACTIONS(1979),
    [anon_sym_explicit] = ACTIONS(1979),
    [anon_sym_TILDE] = ACTIONS(1977),
    [anon_sym_where] = ACTIONS(1979),
    [anon_sym_class] = ACTIONS(1979),
    [anon_sym_struct] = ACTIONS(1979),
    [anon_sym_notnull] = ACTIONS(1979),
    [anon_sym_unmanaged] = ACTIONS(1979),
    [anon_sym_get] = ACTIONS(1979),
    [anon_sym_set] = ACTIONS(1979),
    [anon_sym_add] = ACTIONS(1979),
    [anon_sym_remove] = ACTIONS(1979),
    [anon_sym_enum] = ACTIONS(1979),
    [anon_sym_interface] = ACTIONS(1979),
    [anon_sym_delegate] = ACTIONS(1979),
    [anon_sym_record] = ACTIONS(1979),
    [anon_sym_namespace] = ACTIONS(1979),
    [anon_sym_var] = ACTIONS(1979),
    [sym_predefined_type] = ACTIONS(1979),
    [anon_sym_when] = ACTIONS(1979),
    [anon_sym_yield] = ACTIONS(1979),
    [anon_sym_from] = ACTIONS(1979),
    [anon_sym_join] = ACTIONS(1979),
    [anon_sym_on] = ACTIONS(1979),
    [anon_sym_equals] = ACTIONS(1979),
    [anon_sym_into] = ACTIONS(1979),
    [anon_sym_let] = ACTIONS(1979),
    [anon_sym_orderby] = ACTIONS(1979),
    [anon_sym_ascending] = ACTIONS(1979),
    [anon_sym_descending] = ACTIONS(1979),
    [anon_sym_group] = ACTIONS(1979),
    [anon_sym_by] = ACTIONS(1979),
    [anon_sym_select] = ACTIONS(1979),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(1979),
    [anon_sym_nameof] = ACTIONS(1979),
    [sym_void_keyword] = ACTIONS(1979),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2468] = {
    [sym__preprocessor_call] = STATE(2468),
    [sym__identifier_token] = ACTIONS(2566),
    [anon_sym_extern] = ACTIONS(2566),
    [anon_sym_alias] = ACTIONS(2566),
    [anon_sym_global] = ACTIONS(2566),
    [anon_sym_using] = ACTIONS(2566),
    [anon_sym_static] = ACTIONS(2566),
    [anon_sym_LBRACK] = ACTIONS(2564),
    [anon_sym_event] = ACTIONS(2566),
    [anon_sym_LPAREN] = ACTIONS(2564),
    [anon_sym_abstract] = ACTIONS(2566),
    [anon_sym_async] = ACTIONS(2566),
    [anon_sym_const] = ACTIONS(2566),
    [anon_sym_fixed] = ACTIONS(2566),
    [anon_sym_internal] = ACTIONS(2566),
    [anon_sym_new] = ACTIONS(2566),
    [anon_sym_override] = ACTIONS(2566),
    [anon_sym_partial] = ACTIONS(2566),
    [anon_sym_private] = ACTIONS(2566),
    [anon_sym_protected] = ACTIONS(2566),
    [anon_sym_public] = ACTIONS(2566),
    [anon_sym_readonly] = ACTIONS(2566),
    [anon_sym_ref] = ACTIONS(2566),
    [anon_sym_sealed] = ACTIONS(2566),
    [anon_sym_unsafe] = ACTIONS(2566),
    [anon_sym_virtual] = ACTIONS(2566),
    [anon_sym_volatile] = ACTIONS(2566),
    [anon_sym_RBRACE] = ACTIONS(2564),
    [anon_sym_implicit] = ACTIONS(2566),
    [anon_sym_explicit] = ACTIONS(2566),
    [anon_sym_TILDE] = ACTIONS(2564),
    [anon_sym_where] = ACTIONS(2566),
    [anon_sym_class] = ACTIONS(2566),
    [anon_sym_struct] = ACTIONS(2566),
    [anon_sym_notnull] = ACTIONS(2566),
    [anon_sym_unmanaged] = ACTIONS(2566),
    [anon_sym_get] = ACTIONS(2566),
    [anon_sym_set] = ACTIONS(2566),
    [anon_sym_add] = ACTIONS(2566),
    [anon_sym_remove] = ACTIONS(2566),
    [anon_sym_enum] = ACTIONS(2566),
    [anon_sym_interface] = ACTIONS(2566),
    [anon_sym_delegate] = ACTIONS(2566),
    [anon_sym_record] = ACTIONS(2566),
    [anon_sym_namespace] = ACTIONS(2566),
    [anon_sym_var] = ACTIONS(2566),
    [sym_predefined_type] = ACTIONS(2566),
    [anon_sym_when] = ACTIONS(2566),
    [anon_sym_yield] = ACTIONS(2566),
    [anon_sym_from] = ACTIONS(2566),
    [anon_sym_join] = ACTIONS(2566),
    [anon_sym_on] = ACTIONS(2566),
    [anon_sym_equals] = ACTIONS(2566),
    [anon_sym_into] = ACTIONS(2566),
    [anon_sym_let] = ACTIONS(2566),
    [anon_sym_orderby] = ACTIONS(2566),
    [anon_sym_ascending] = ACTIONS(2566),
    [anon_sym_descending] = ACTIONS(2566),
    [anon_sym_group] = ACTIONS(2566),
    [anon_sym_by] = ACTIONS(2566),
    [anon_sym_select] = ACTIONS(2566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2566),
    [anon_sym_nameof] = ACTIONS(2566),
    [sym_void_keyword] = ACTIONS(2566),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2469] = {
    [sym__preprocessor_call] = STATE(2469),
    [sym__identifier_token] = ACTIONS(4562),
    [anon_sym_extern] = ACTIONS(4562),
    [anon_sym_alias] = ACTIONS(4562),
    [anon_sym_global] = ACTIONS(4562),
    [anon_sym_using] = ACTIONS(4562),
    [anon_sym_static] = ACTIONS(4562),
    [anon_sym_LBRACK] = ACTIONS(4564),
    [anon_sym_event] = ACTIONS(4562),
    [anon_sym_LPAREN] = ACTIONS(4564),
    [anon_sym_abstract] = ACTIONS(4562),
    [anon_sym_async] = ACTIONS(4562),
    [anon_sym_const] = ACTIONS(4562),
    [anon_sym_fixed] = ACTIONS(4562),
    [anon_sym_internal] = ACTIONS(4562),
    [anon_sym_new] = ACTIONS(4562),
    [anon_sym_override] = ACTIONS(4562),
    [anon_sym_partial] = ACTIONS(4562),
    [anon_sym_private] = ACTIONS(4562),
    [anon_sym_protected] = ACTIONS(4562),
    [anon_sym_public] = ACTIONS(4562),
    [anon_sym_readonly] = ACTIONS(4562),
    [anon_sym_ref] = ACTIONS(4562),
    [anon_sym_sealed] = ACTIONS(4562),
    [anon_sym_unsafe] = ACTIONS(4562),
    [anon_sym_virtual] = ACTIONS(4562),
    [anon_sym_volatile] = ACTIONS(4562),
    [anon_sym_RBRACE] = ACTIONS(4564),
    [anon_sym_implicit] = ACTIONS(4562),
    [anon_sym_explicit] = ACTIONS(4562),
    [anon_sym_TILDE] = ACTIONS(4564),
    [anon_sym_where] = ACTIONS(4562),
    [anon_sym_class] = ACTIONS(4562),
    [anon_sym_struct] = ACTIONS(4562),
    [anon_sym_notnull] = ACTIONS(4562),
    [anon_sym_unmanaged] = ACTIONS(4562),
    [anon_sym_get] = ACTIONS(4562),
    [anon_sym_set] = ACTIONS(4562),
    [anon_sym_add] = ACTIONS(4562),
    [anon_sym_remove] = ACTIONS(4562),
    [anon_sym_enum] = ACTIONS(4562),
    [anon_sym_interface] = ACTIONS(4562),
    [anon_sym_delegate] = ACTIONS(4562),
    [anon_sym_record] = ACTIONS(4562),
    [anon_sym_namespace] = ACTIONS(4562),
    [anon_sym_var] = ACTIONS(4562),
    [sym_predefined_type] = ACTIONS(4562),
    [anon_sym_when] = ACTIONS(4562),
    [anon_sym_yield] = ACTIONS(4562),
    [anon_sym_from] = ACTIONS(4562),
    [anon_sym_join] = ACTIONS(4562),
    [anon_sym_on] = ACTIONS(4562),
    [anon_sym_equals] = ACTIONS(4562),
    [anon_sym_into] = ACTIONS(4562),
    [anon_sym_let] = ACTIONS(4562),
    [anon_sym_orderby] = ACTIONS(4562),
    [anon_sym_ascending] = ACTIONS(4562),
    [anon_sym_descending] = ACTIONS(4562),
    [anon_sym_group] = ACTIONS(4562),
    [anon_sym_by] = ACTIONS(4562),
    [anon_sym_select] = ACTIONS(4562),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4562),
    [anon_sym_nameof] = ACTIONS(4562),
    [sym_void_keyword] = ACTIONS(4562),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2470] = {
    [sym__preprocessor_call] = STATE(2470),
    [sym__identifier_token] = ACTIONS(4566),
    [anon_sym_extern] = ACTIONS(4566),
    [anon_sym_alias] = ACTIONS(4566),
    [anon_sym_global] = ACTIONS(4566),
    [anon_sym_using] = ACTIONS(4566),
    [anon_sym_static] = ACTIONS(4566),
    [anon_sym_LBRACK] = ACTIONS(4568),
    [anon_sym_event] = ACTIONS(4566),
    [anon_sym_LPAREN] = ACTIONS(4568),
    [anon_sym_abstract] = ACTIONS(4566),
    [anon_sym_async] = ACTIONS(4566),
    [anon_sym_const] = ACTIONS(4566),
    [anon_sym_fixed] = ACTIONS(4566),
    [anon_sym_internal] = ACTIONS(4566),
    [anon_sym_new] = ACTIONS(4566),
    [anon_sym_override] = ACTIONS(4566),
    [anon_sym_partial] = ACTIONS(4566),
    [anon_sym_private] = ACTIONS(4566),
    [anon_sym_protected] = ACTIONS(4566),
    [anon_sym_public] = ACTIONS(4566),
    [anon_sym_readonly] = ACTIONS(4566),
    [anon_sym_ref] = ACTIONS(4566),
    [anon_sym_sealed] = ACTIONS(4566),
    [anon_sym_unsafe] = ACTIONS(4566),
    [anon_sym_virtual] = ACTIONS(4566),
    [anon_sym_volatile] = ACTIONS(4566),
    [anon_sym_RBRACE] = ACTIONS(4568),
    [anon_sym_implicit] = ACTIONS(4566),
    [anon_sym_explicit] = ACTIONS(4566),
    [anon_sym_TILDE] = ACTIONS(4568),
    [anon_sym_where] = ACTIONS(4566),
    [anon_sym_class] = ACTIONS(4566),
    [anon_sym_struct] = ACTIONS(4566),
    [anon_sym_notnull] = ACTIONS(4566),
    [anon_sym_unmanaged] = ACTIONS(4566),
    [anon_sym_get] = ACTIONS(4566),
    [anon_sym_set] = ACTIONS(4566),
    [anon_sym_add] = ACTIONS(4566),
    [anon_sym_remove] = ACTIONS(4566),
    [anon_sym_enum] = ACTIONS(4566),
    [anon_sym_interface] = ACTIONS(4566),
    [anon_sym_delegate] = ACTIONS(4566),
    [anon_sym_record] = ACTIONS(4566),
    [anon_sym_namespace] = ACTIONS(4566),
    [anon_sym_var] = ACTIONS(4566),
    [sym_predefined_type] = ACTIONS(4566),
    [anon_sym_when] = ACTIONS(4566),
    [anon_sym_yield] = ACTIONS(4566),
    [anon_sym_from] = ACTIONS(4566),
    [anon_sym_join] = ACTIONS(4566),
    [anon_sym_on] = ACTIONS(4566),
    [anon_sym_equals] = ACTIONS(4566),
    [anon_sym_into] = ACTIONS(4566),
    [anon_sym_let] = ACTIONS(4566),
    [anon_sym_orderby] = ACTIONS(4566),
    [anon_sym_ascending] = ACTIONS(4566),
    [anon_sym_descending] = ACTIONS(4566),
    [anon_sym_group] = ACTIONS(4566),
    [anon_sym_by] = ACTIONS(4566),
    [anon_sym_select] = ACTIONS(4566),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4566),
    [anon_sym_nameof] = ACTIONS(4566),
    [sym_void_keyword] = ACTIONS(4566),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2471] = {
    [sym__preprocessor_call] = STATE(2471),
    [sym__identifier_token] = ACTIONS(2216),
    [anon_sym_extern] = ACTIONS(2216),
    [anon_sym_alias] = ACTIONS(2216),
    [anon_sym_global] = ACTIONS(2216),
    [anon_sym_using] = ACTIONS(2216),
    [anon_sym_static] = ACTIONS(2216),
    [anon_sym_LBRACK] = ACTIONS(2214),
    [anon_sym_event] = ACTIONS(2216),
    [anon_sym_LPAREN] = ACTIONS(2214),
    [anon_sym_abstract] = ACTIONS(2216),
    [anon_sym_async] = ACTIONS(2216),
    [anon_sym_const] = ACTIONS(2216),
    [anon_sym_fixed] = ACTIONS(2216),
    [anon_sym_internal] = ACTIONS(2216),
    [anon_sym_new] = ACTIONS(2216),
    [anon_sym_override] = ACTIONS(2216),
    [anon_sym_partial] = ACTIONS(2216),
    [anon_sym_private] = ACTIONS(2216),
    [anon_sym_protected] = ACTIONS(2216),
    [anon_sym_public] = ACTIONS(2216),
    [anon_sym_readonly] = ACTIONS(2216),
    [anon_sym_ref] = ACTIONS(2216),
    [anon_sym_sealed] = ACTIONS(2216),
    [anon_sym_unsafe] = ACTIONS(2216),
    [anon_sym_virtual] = ACTIONS(2216),
    [anon_sym_volatile] = ACTIONS(2216),
    [anon_sym_RBRACE] = ACTIONS(2214),
    [anon_sym_implicit] = ACTIONS(2216),
    [anon_sym_explicit] = ACTIONS(2216),
    [anon_sym_TILDE] = ACTIONS(2214),
    [anon_sym_where] = ACTIONS(2216),
    [anon_sym_class] = ACTIONS(2216),
    [anon_sym_struct] = ACTIONS(2216),
    [anon_sym_notnull] = ACTIONS(2216),
    [anon_sym_unmanaged] = ACTIONS(2216),
    [anon_sym_get] = ACTIONS(2216),
    [anon_sym_set] = ACTIONS(2216),
    [anon_sym_add] = ACTIONS(2216),
    [anon_sym_remove] = ACTIONS(2216),
    [anon_sym_enum] = ACTIONS(2216),
    [anon_sym_interface] = ACTIONS(2216),
    [anon_sym_delegate] = ACTIONS(2216),
    [anon_sym_record] = ACTIONS(2216),
    [anon_sym_namespace] = ACTIONS(2216),
    [anon_sym_var] = ACTIONS(2216),
    [sym_predefined_type] = ACTIONS(2216),
    [anon_sym_when] = ACTIONS(2216),
    [anon_sym_yield] = ACTIONS(2216),
    [anon_sym_from] = ACTIONS(2216),
    [anon_sym_join] = ACTIONS(2216),
    [anon_sym_on] = ACTIONS(2216),
    [anon_sym_equals] = ACTIONS(2216),
    [anon_sym_into] = ACTIONS(2216),
    [anon_sym_let] = ACTIONS(2216),
    [anon_sym_orderby] = ACTIONS(2216),
    [anon_sym_ascending] = ACTIONS(2216),
    [anon_sym_descending] = ACTIONS(2216),
    [anon_sym_group] = ACTIONS(2216),
    [anon_sym_by] = ACTIONS(2216),
    [anon_sym_select] = ACTIONS(2216),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2216),
    [anon_sym_nameof] = ACTIONS(2216),
    [sym_void_keyword] = ACTIONS(2216),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2472] = {
    [sym__preprocessor_call] = STATE(2472),
    [sym__identifier_token] = ACTIONS(4570),
    [anon_sym_extern] = ACTIONS(4570),
    [anon_sym_alias] = ACTIONS(4570),
    [anon_sym_global] = ACTIONS(4570),
    [anon_sym_using] = ACTIONS(4570),
    [anon_sym_static] = ACTIONS(4570),
    [anon_sym_LBRACK] = ACTIONS(4572),
    [anon_sym_event] = ACTIONS(4570),
    [anon_sym_LPAREN] = ACTIONS(4572),
    [anon_sym_abstract] = ACTIONS(4570),
    [anon_sym_async] = ACTIONS(4570),
    [anon_sym_const] = ACTIONS(4570),
    [anon_sym_fixed] = ACTIONS(4570),
    [anon_sym_internal] = ACTIONS(4570),
    [anon_sym_new] = ACTIONS(4570),
    [anon_sym_override] = ACTIONS(4570),
    [anon_sym_partial] = ACTIONS(4570),
    [anon_sym_private] = ACTIONS(4570),
    [anon_sym_protected] = ACTIONS(4570),
    [anon_sym_public] = ACTIONS(4570),
    [anon_sym_readonly] = ACTIONS(4570),
    [anon_sym_ref] = ACTIONS(4570),
    [anon_sym_sealed] = ACTIONS(4570),
    [anon_sym_unsafe] = ACTIONS(4570),
    [anon_sym_virtual] = ACTIONS(4570),
    [anon_sym_volatile] = ACTIONS(4570),
    [anon_sym_RBRACE] = ACTIONS(4572),
    [anon_sym_implicit] = ACTIONS(4570),
    [anon_sym_explicit] = ACTIONS(4570),
    [anon_sym_TILDE] = ACTIONS(4572),
    [anon_sym_where] = ACTIONS(4570),
    [anon_sym_class] = ACTIONS(4570),
    [anon_sym_struct] = ACTIONS(4570),
    [anon_sym_notnull] = ACTIONS(4570),
    [anon_sym_unmanaged] = ACTIONS(4570),
    [anon_sym_get] = ACTIONS(4570),
    [anon_sym_set] = ACTIONS(4570),
    [anon_sym_add] = ACTIONS(4570),
    [anon_sym_remove] = ACTIONS(4570),
    [anon_sym_enum] = ACTIONS(4570),
    [anon_sym_interface] = ACTIONS(4570),
    [anon_sym_delegate] = ACTIONS(4570),
    [anon_sym_record] = ACTIONS(4570),
    [anon_sym_namespace] = ACTIONS(4570),
    [anon_sym_var] = ACTIONS(4570),
    [sym_predefined_type] = ACTIONS(4570),
    [anon_sym_when] = ACTIONS(4570),
    [anon_sym_yield] = ACTIONS(4570),
    [anon_sym_from] = ACTIONS(4570),
    [anon_sym_join] = ACTIONS(4570),
    [anon_sym_on] = ACTIONS(4570),
    [anon_sym_equals] = ACTIONS(4570),
    [anon_sym_into] = ACTIONS(4570),
    [anon_sym_let] = ACTIONS(4570),
    [anon_sym_orderby] = ACTIONS(4570),
    [anon_sym_ascending] = ACTIONS(4570),
    [anon_sym_descending] = ACTIONS(4570),
    [anon_sym_group] = ACTIONS(4570),
    [anon_sym_by] = ACTIONS(4570),
    [anon_sym_select] = ACTIONS(4570),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4570),
    [anon_sym_nameof] = ACTIONS(4570),
    [sym_void_keyword] = ACTIONS(4570),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2473] = {
    [sym__preprocessor_call] = STATE(2473),
    [sym__identifier_token] = ACTIONS(4574),
    [anon_sym_extern] = ACTIONS(4574),
    [anon_sym_alias] = ACTIONS(4574),
    [anon_sym_global] = ACTIONS(4574),
    [anon_sym_using] = ACTIONS(4574),
    [anon_sym_static] = ACTIONS(4574),
    [anon_sym_LBRACK] = ACTIONS(4576),
    [anon_sym_event] = ACTIONS(4574),
    [anon_sym_LPAREN] = ACTIONS(4576),
    [anon_sym_abstract] = ACTIONS(4574),
    [anon_sym_async] = ACTIONS(4574),
    [anon_sym_const] = ACTIONS(4574),
    [anon_sym_fixed] = ACTIONS(4574),
    [anon_sym_internal] = ACTIONS(4574),
    [anon_sym_new] = ACTIONS(4574),
    [anon_sym_override] = ACTIONS(4574),
    [anon_sym_partial] = ACTIONS(4574),
    [anon_sym_private] = ACTIONS(4574),
    [anon_sym_protected] = ACTIONS(4574),
    [anon_sym_public] = ACTIONS(4574),
    [anon_sym_readonly] = ACTIONS(4574),
    [anon_sym_ref] = ACTIONS(4574),
    [anon_sym_sealed] = ACTIONS(4574),
    [anon_sym_unsafe] = ACTIONS(4574),
    [anon_sym_virtual] = ACTIONS(4574),
    [anon_sym_volatile] = ACTIONS(4574),
    [anon_sym_RBRACE] = ACTIONS(4576),
    [anon_sym_implicit] = ACTIONS(4574),
    [anon_sym_explicit] = ACTIONS(4574),
    [anon_sym_TILDE] = ACTIONS(4576),
    [anon_sym_where] = ACTIONS(4574),
    [anon_sym_class] = ACTIONS(4574),
    [anon_sym_struct] = ACTIONS(4574),
    [anon_sym_notnull] = ACTIONS(4574),
    [anon_sym_unmanaged] = ACTIONS(4574),
    [anon_sym_get] = ACTIONS(4574),
    [anon_sym_set] = ACTIONS(4574),
    [anon_sym_add] = ACTIONS(4574),
    [anon_sym_remove] = ACTIONS(4574),
    [anon_sym_enum] = ACTIONS(4574),
    [anon_sym_interface] = ACTIONS(4574),
    [anon_sym_delegate] = ACTIONS(4574),
    [anon_sym_record] = ACTIONS(4574),
    [anon_sym_namespace] = ACTIONS(4574),
    [anon_sym_var] = ACTIONS(4574),
    [sym_predefined_type] = ACTIONS(4574),
    [anon_sym_when] = ACTIONS(4574),
    [anon_sym_yield] = ACTIONS(4574),
    [anon_sym_from] = ACTIONS(4574),
    [anon_sym_join] = ACTIONS(4574),
    [anon_sym_on] = ACTIONS(4574),
    [anon_sym_equals] = ACTIONS(4574),
    [anon_sym_into] = ACTIONS(4574),
    [anon_sym_let] = ACTIONS(4574),
    [anon_sym_orderby] = ACTIONS(4574),
    [anon_sym_ascending] = ACTIONS(4574),
    [anon_sym_descending] = ACTIONS(4574),
    [anon_sym_group] = ACTIONS(4574),
    [anon_sym_by] = ACTIONS(4574),
    [anon_sym_select] = ACTIONS(4574),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4574),
    [anon_sym_nameof] = ACTIONS(4574),
    [sym_void_keyword] = ACTIONS(4574),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2474] = {
    [sym__preprocessor_call] = STATE(2474),
    [sym__identifier_token] = ACTIONS(4578),
    [anon_sym_extern] = ACTIONS(4578),
    [anon_sym_alias] = ACTIONS(4578),
    [anon_sym_global] = ACTIONS(4578),
    [anon_sym_using] = ACTIONS(4578),
    [anon_sym_static] = ACTIONS(4578),
    [anon_sym_LBRACK] = ACTIONS(4580),
    [anon_sym_event] = ACTIONS(4578),
    [anon_sym_LPAREN] = ACTIONS(4580),
    [anon_sym_abstract] = ACTIONS(4578),
    [anon_sym_async] = ACTIONS(4578),
    [anon_sym_const] = ACTIONS(4578),
    [anon_sym_fixed] = ACTIONS(4578),
    [anon_sym_internal] = ACTIONS(4578),
    [anon_sym_new] = ACTIONS(4578),
    [anon_sym_override] = ACTIONS(4578),
    [anon_sym_partial] = ACTIONS(4578),
    [anon_sym_private] = ACTIONS(4578),
    [anon_sym_protected] = ACTIONS(4578),
    [anon_sym_public] = ACTIONS(4578),
    [anon_sym_readonly] = ACTIONS(4578),
    [anon_sym_ref] = ACTIONS(4578),
    [anon_sym_sealed] = ACTIONS(4578),
    [anon_sym_unsafe] = ACTIONS(4578),
    [anon_sym_virtual] = ACTIONS(4578),
    [anon_sym_volatile] = ACTIONS(4578),
    [anon_sym_RBRACE] = ACTIONS(4580),
    [anon_sym_implicit] = ACTIONS(4578),
    [anon_sym_explicit] = ACTIONS(4578),
    [anon_sym_TILDE] = ACTIONS(4580),
    [anon_sym_where] = ACTIONS(4578),
    [anon_sym_class] = ACTIONS(4578),
    [anon_sym_struct] = ACTIONS(4578),
    [anon_sym_notnull] = ACTIONS(4578),
    [anon_sym_unmanaged] = ACTIONS(4578),
    [anon_sym_get] = ACTIONS(4578),
    [anon_sym_set] = ACTIONS(4578),
    [anon_sym_add] = ACTIONS(4578),
    [anon_sym_remove] = ACTIONS(4578),
    [anon_sym_enum] = ACTIONS(4578),
    [anon_sym_interface] = ACTIONS(4578),
    [anon_sym_delegate] = ACTIONS(4578),
    [anon_sym_record] = ACTIONS(4578),
    [anon_sym_namespace] = ACTIONS(4578),
    [anon_sym_var] = ACTIONS(4578),
    [sym_predefined_type] = ACTIONS(4578),
    [anon_sym_when] = ACTIONS(4578),
    [anon_sym_yield] = ACTIONS(4578),
    [anon_sym_from] = ACTIONS(4578),
    [anon_sym_join] = ACTIONS(4578),
    [anon_sym_on] = ACTIONS(4578),
    [anon_sym_equals] = ACTIONS(4578),
    [anon_sym_into] = ACTIONS(4578),
    [anon_sym_let] = ACTIONS(4578),
    [anon_sym_orderby] = ACTIONS(4578),
    [anon_sym_ascending] = ACTIONS(4578),
    [anon_sym_descending] = ACTIONS(4578),
    [anon_sym_group] = ACTIONS(4578),
    [anon_sym_by] = ACTIONS(4578),
    [anon_sym_select] = ACTIONS(4578),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4578),
    [anon_sym_nameof] = ACTIONS(4578),
    [sym_void_keyword] = ACTIONS(4578),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2475] = {
    [sym__preprocessor_call] = STATE(2475),
    [sym__identifier_token] = ACTIONS(4582),
    [anon_sym_extern] = ACTIONS(4582),
    [anon_sym_alias] = ACTIONS(4582),
    [anon_sym_global] = ACTIONS(4582),
    [anon_sym_using] = ACTIONS(4582),
    [anon_sym_static] = ACTIONS(4582),
    [anon_sym_LBRACK] = ACTIONS(4584),
    [anon_sym_event] = ACTIONS(4582),
    [anon_sym_LPAREN] = ACTIONS(4584),
    [anon_sym_abstract] = ACTIONS(4582),
    [anon_sym_async] = ACTIONS(4582),
    [anon_sym_const] = ACTIONS(4582),
    [anon_sym_fixed] = ACTIONS(4582),
    [anon_sym_internal] = ACTIONS(4582),
    [anon_sym_new] = ACTIONS(4582),
    [anon_sym_override] = ACTIONS(4582),
    [anon_sym_partial] = ACTIONS(4582),
    [anon_sym_private] = ACTIONS(4582),
    [anon_sym_protected] = ACTIONS(4582),
    [anon_sym_public] = ACTIONS(4582),
    [anon_sym_readonly] = ACTIONS(4582),
    [anon_sym_ref] = ACTIONS(4582),
    [anon_sym_sealed] = ACTIONS(4582),
    [anon_sym_unsafe] = ACTIONS(4582),
    [anon_sym_virtual] = ACTIONS(4582),
    [anon_sym_volatile] = ACTIONS(4582),
    [anon_sym_RBRACE] = ACTIONS(4584),
    [anon_sym_implicit] = ACTIONS(4582),
    [anon_sym_explicit] = ACTIONS(4582),
    [anon_sym_TILDE] = ACTIONS(4584),
    [anon_sym_where] = ACTIONS(4582),
    [anon_sym_class] = ACTIONS(4582),
    [anon_sym_struct] = ACTIONS(4582),
    [anon_sym_notnull] = ACTIONS(4582),
    [anon_sym_unmanaged] = ACTIONS(4582),
    [anon_sym_get] = ACTIONS(4582),
    [anon_sym_set] = ACTIONS(4582),
    [anon_sym_add] = ACTIONS(4582),
    [anon_sym_remove] = ACTIONS(4582),
    [anon_sym_enum] = ACTIONS(4582),
    [anon_sym_interface] = ACTIONS(4582),
    [anon_sym_delegate] = ACTIONS(4582),
    [anon_sym_record] = ACTIONS(4582),
    [anon_sym_namespace] = ACTIONS(4582),
    [anon_sym_var] = ACTIONS(4582),
    [sym_predefined_type] = ACTIONS(4582),
    [anon_sym_when] = ACTIONS(4582),
    [anon_sym_yield] = ACTIONS(4582),
    [anon_sym_from] = ACTIONS(4582),
    [anon_sym_join] = ACTIONS(4582),
    [anon_sym_on] = ACTIONS(4582),
    [anon_sym_equals] = ACTIONS(4582),
    [anon_sym_into] = ACTIONS(4582),
    [anon_sym_let] = ACTIONS(4582),
    [anon_sym_orderby] = ACTIONS(4582),
    [anon_sym_ascending] = ACTIONS(4582),
    [anon_sym_descending] = ACTIONS(4582),
    [anon_sym_group] = ACTIONS(4582),
    [anon_sym_by] = ACTIONS(4582),
    [anon_sym_select] = ACTIONS(4582),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4582),
    [anon_sym_nameof] = ACTIONS(4582),
    [sym_void_keyword] = ACTIONS(4582),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2476] = {
    [sym__preprocessor_call] = STATE(2476),
    [sym__identifier_token] = ACTIONS(4586),
    [anon_sym_extern] = ACTIONS(4586),
    [anon_sym_alias] = ACTIONS(4586),
    [anon_sym_global] = ACTIONS(4586),
    [anon_sym_using] = ACTIONS(4586),
    [anon_sym_static] = ACTIONS(4586),
    [anon_sym_LBRACK] = ACTIONS(4588),
    [anon_sym_event] = ACTIONS(4586),
    [anon_sym_LPAREN] = ACTIONS(4588),
    [anon_sym_abstract] = ACTIONS(4586),
    [anon_sym_async] = ACTIONS(4586),
    [anon_sym_const] = ACTIONS(4586),
    [anon_sym_fixed] = ACTIONS(4586),
    [anon_sym_internal] = ACTIONS(4586),
    [anon_sym_new] = ACTIONS(4586),
    [anon_sym_override] = ACTIONS(4586),
    [anon_sym_partial] = ACTIONS(4586),
    [anon_sym_private] = ACTIONS(4586),
    [anon_sym_protected] = ACTIONS(4586),
    [anon_sym_public] = ACTIONS(4586),
    [anon_sym_readonly] = ACTIONS(4586),
    [anon_sym_ref] = ACTIONS(4586),
    [anon_sym_sealed] = ACTIONS(4586),
    [anon_sym_unsafe] = ACTIONS(4586),
    [anon_sym_virtual] = ACTIONS(4586),
    [anon_sym_volatile] = ACTIONS(4586),
    [anon_sym_RBRACE] = ACTIONS(4588),
    [anon_sym_implicit] = ACTIONS(4586),
    [anon_sym_explicit] = ACTIONS(4586),
    [anon_sym_TILDE] = ACTIONS(4588),
    [anon_sym_where] = ACTIONS(4586),
    [anon_sym_class] = ACTIONS(4586),
    [anon_sym_struct] = ACTIONS(4586),
    [anon_sym_notnull] = ACTIONS(4586),
    [anon_sym_unmanaged] = ACTIONS(4586),
    [anon_sym_get] = ACTIONS(4586),
    [anon_sym_set] = ACTIONS(4586),
    [anon_sym_add] = ACTIONS(4586),
    [anon_sym_remove] = ACTIONS(4586),
    [anon_sym_enum] = ACTIONS(4586),
    [anon_sym_interface] = ACTIONS(4586),
    [anon_sym_delegate] = ACTIONS(4586),
    [anon_sym_record] = ACTIONS(4586),
    [anon_sym_namespace] = ACTIONS(4586),
    [anon_sym_var] = ACTIONS(4586),
    [sym_predefined_type] = ACTIONS(4586),
    [anon_sym_when] = ACTIONS(4586),
    [anon_sym_yield] = ACTIONS(4586),
    [anon_sym_from] = ACTIONS(4586),
    [anon_sym_join] = ACTIONS(4586),
    [anon_sym_on] = ACTIONS(4586),
    [anon_sym_equals] = ACTIONS(4586),
    [anon_sym_into] = ACTIONS(4586),
    [anon_sym_let] = ACTIONS(4586),
    [anon_sym_orderby] = ACTIONS(4586),
    [anon_sym_ascending] = ACTIONS(4586),
    [anon_sym_descending] = ACTIONS(4586),
    [anon_sym_group] = ACTIONS(4586),
    [anon_sym_by] = ACTIONS(4586),
    [anon_sym_select] = ACTIONS(4586),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4586),
    [anon_sym_nameof] = ACTIONS(4586),
    [sym_void_keyword] = ACTIONS(4586),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2477] = {
    [sym__preprocessor_call] = STATE(2477),
    [sym__identifier_token] = ACTIONS(4590),
    [anon_sym_extern] = ACTIONS(4590),
    [anon_sym_alias] = ACTIONS(4590),
    [anon_sym_global] = ACTIONS(4590),
    [anon_sym_using] = ACTIONS(4590),
    [anon_sym_static] = ACTIONS(4590),
    [anon_sym_LBRACK] = ACTIONS(4592),
    [anon_sym_event] = ACTIONS(4590),
    [anon_sym_LPAREN] = ACTIONS(4592),
    [anon_sym_abstract] = ACTIONS(4590),
    [anon_sym_async] = ACTIONS(4590),
    [anon_sym_const] = ACTIONS(4590),
    [anon_sym_fixed] = ACTIONS(4590),
    [anon_sym_internal] = ACTIONS(4590),
    [anon_sym_new] = ACTIONS(4590),
    [anon_sym_override] = ACTIONS(4590),
    [anon_sym_partial] = ACTIONS(4590),
    [anon_sym_private] = ACTIONS(4590),
    [anon_sym_protected] = ACTIONS(4590),
    [anon_sym_public] = ACTIONS(4590),
    [anon_sym_readonly] = ACTIONS(4590),
    [anon_sym_ref] = ACTIONS(4590),
    [anon_sym_sealed] = ACTIONS(4590),
    [anon_sym_unsafe] = ACTIONS(4590),
    [anon_sym_virtual] = ACTIONS(4590),
    [anon_sym_volatile] = ACTIONS(4590),
    [anon_sym_RBRACE] = ACTIONS(4592),
    [anon_sym_implicit] = ACTIONS(4590),
    [anon_sym_explicit] = ACTIONS(4590),
    [anon_sym_TILDE] = ACTIONS(4592),
    [anon_sym_where] = ACTIONS(4590),
    [anon_sym_class] = ACTIONS(4590),
    [anon_sym_struct] = ACTIONS(4590),
    [anon_sym_notnull] = ACTIONS(4590),
    [anon_sym_unmanaged] = ACTIONS(4590),
    [anon_sym_get] = ACTIONS(4590),
    [anon_sym_set] = ACTIONS(4590),
    [anon_sym_add] = ACTIONS(4590),
    [anon_sym_remove] = ACTIONS(4590),
    [anon_sym_enum] = ACTIONS(4590),
    [anon_sym_interface] = ACTIONS(4590),
    [anon_sym_delegate] = ACTIONS(4590),
    [anon_sym_record] = ACTIONS(4590),
    [anon_sym_namespace] = ACTIONS(4590),
    [anon_sym_var] = ACTIONS(4590),
    [sym_predefined_type] = ACTIONS(4590),
    [anon_sym_when] = ACTIONS(4590),
    [anon_sym_yield] = ACTIONS(4590),
    [anon_sym_from] = ACTIONS(4590),
    [anon_sym_join] = ACTIONS(4590),
    [anon_sym_on] = ACTIONS(4590),
    [anon_sym_equals] = ACTIONS(4590),
    [anon_sym_into] = ACTIONS(4590),
    [anon_sym_let] = ACTIONS(4590),
    [anon_sym_orderby] = ACTIONS(4590),
    [anon_sym_ascending] = ACTIONS(4590),
    [anon_sym_descending] = ACTIONS(4590),
    [anon_sym_group] = ACTIONS(4590),
    [anon_sym_by] = ACTIONS(4590),
    [anon_sym_select] = ACTIONS(4590),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4590),
    [anon_sym_nameof] = ACTIONS(4590),
    [sym_void_keyword] = ACTIONS(4590),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2478] = {
    [sym__preprocessor_call] = STATE(2478),
    [sym__identifier_token] = ACTIONS(4594),
    [anon_sym_extern] = ACTIONS(4594),
    [anon_sym_alias] = ACTIONS(4594),
    [anon_sym_global] = ACTIONS(4594),
    [anon_sym_using] = ACTIONS(4594),
    [anon_sym_static] = ACTIONS(4594),
    [anon_sym_LBRACK] = ACTIONS(4596),
    [anon_sym_event] = ACTIONS(4594),
    [anon_sym_LPAREN] = ACTIONS(4596),
    [anon_sym_abstract] = ACTIONS(4594),
    [anon_sym_async] = ACTIONS(4594),
    [anon_sym_const] = ACTIONS(4594),
    [anon_sym_fixed] = ACTIONS(4594),
    [anon_sym_internal] = ACTIONS(4594),
    [anon_sym_new] = ACTIONS(4594),
    [anon_sym_override] = ACTIONS(4594),
    [anon_sym_partial] = ACTIONS(4594),
    [anon_sym_private] = ACTIONS(4594),
    [anon_sym_protected] = ACTIONS(4594),
    [anon_sym_public] = ACTIONS(4594),
    [anon_sym_readonly] = ACTIONS(4594),
    [anon_sym_ref] = ACTIONS(4594),
    [anon_sym_sealed] = ACTIONS(4594),
    [anon_sym_unsafe] = ACTIONS(4594),
    [anon_sym_virtual] = ACTIONS(4594),
    [anon_sym_volatile] = ACTIONS(4594),
    [anon_sym_RBRACE] = ACTIONS(4596),
    [anon_sym_implicit] = ACTIONS(4594),
    [anon_sym_explicit] = ACTIONS(4594),
    [anon_sym_TILDE] = ACTIONS(4596),
    [anon_sym_where] = ACTIONS(4594),
    [anon_sym_class] = ACTIONS(4594),
    [anon_sym_struct] = ACTIONS(4594),
    [anon_sym_notnull] = ACTIONS(4594),
    [anon_sym_unmanaged] = ACTIONS(4594),
    [anon_sym_get] = ACTIONS(4594),
    [anon_sym_set] = ACTIONS(4594),
    [anon_sym_add] = ACTIONS(4594),
    [anon_sym_remove] = ACTIONS(4594),
    [anon_sym_enum] = ACTIONS(4594),
    [anon_sym_interface] = ACTIONS(4594),
    [anon_sym_delegate] = ACTIONS(4594),
    [anon_sym_record] = ACTIONS(4594),
    [anon_sym_namespace] = ACTIONS(4594),
    [anon_sym_var] = ACTIONS(4594),
    [sym_predefined_type] = ACTIONS(4594),
    [anon_sym_when] = ACTIONS(4594),
    [anon_sym_yield] = ACTIONS(4594),
    [anon_sym_from] = ACTIONS(4594),
    [anon_sym_join] = ACTIONS(4594),
    [anon_sym_on] = ACTIONS(4594),
    [anon_sym_equals] = ACTIONS(4594),
    [anon_sym_into] = ACTIONS(4594),
    [anon_sym_let] = ACTIONS(4594),
    [anon_sym_orderby] = ACTIONS(4594),
    [anon_sym_ascending] = ACTIONS(4594),
    [anon_sym_descending] = ACTIONS(4594),
    [anon_sym_group] = ACTIONS(4594),
    [anon_sym_by] = ACTIONS(4594),
    [anon_sym_select] = ACTIONS(4594),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4594),
    [anon_sym_nameof] = ACTIONS(4594),
    [sym_void_keyword] = ACTIONS(4594),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2479] = {
    [sym__preprocessor_call] = STATE(2479),
    [sym__identifier_token] = ACTIONS(4598),
    [anon_sym_extern] = ACTIONS(4598),
    [anon_sym_alias] = ACTIONS(4598),
    [anon_sym_global] = ACTIONS(4598),
    [anon_sym_using] = ACTIONS(4598),
    [anon_sym_static] = ACTIONS(4598),
    [anon_sym_LBRACK] = ACTIONS(4600),
    [anon_sym_event] = ACTIONS(4598),
    [anon_sym_LPAREN] = ACTIONS(4600),
    [anon_sym_abstract] = ACTIONS(4598),
    [anon_sym_async] = ACTIONS(4598),
    [anon_sym_const] = ACTIONS(4598),
    [anon_sym_fixed] = ACTIONS(4598),
    [anon_sym_internal] = ACTIONS(4598),
    [anon_sym_new] = ACTIONS(4598),
    [anon_sym_override] = ACTIONS(4598),
    [anon_sym_partial] = ACTIONS(4598),
    [anon_sym_private] = ACTIONS(4598),
    [anon_sym_protected] = ACTIONS(4598),
    [anon_sym_public] = ACTIONS(4598),
    [anon_sym_readonly] = ACTIONS(4598),
    [anon_sym_ref] = ACTIONS(4598),
    [anon_sym_sealed] = ACTIONS(4598),
    [anon_sym_unsafe] = ACTIONS(4598),
    [anon_sym_virtual] = ACTIONS(4598),
    [anon_sym_volatile] = ACTIONS(4598),
    [anon_sym_RBRACE] = ACTIONS(4600),
    [anon_sym_implicit] = ACTIONS(4598),
    [anon_sym_explicit] = ACTIONS(4598),
    [anon_sym_TILDE] = ACTIONS(4600),
    [anon_sym_where] = ACTIONS(4598),
    [anon_sym_class] = ACTIONS(4598),
    [anon_sym_struct] = ACTIONS(4598),
    [anon_sym_notnull] = ACTIONS(4598),
    [anon_sym_unmanaged] = ACTIONS(4598),
    [anon_sym_get] = ACTIONS(4598),
    [anon_sym_set] = ACTIONS(4598),
    [anon_sym_add] = ACTIONS(4598),
    [anon_sym_remove] = ACTIONS(4598),
    [anon_sym_enum] = ACTIONS(4598),
    [anon_sym_interface] = ACTIONS(4598),
    [anon_sym_delegate] = ACTIONS(4598),
    [anon_sym_record] = ACTIONS(4598),
    [anon_sym_namespace] = ACTIONS(4598),
    [anon_sym_var] = ACTIONS(4598),
    [sym_predefined_type] = ACTIONS(4598),
    [anon_sym_when] = ACTIONS(4598),
    [anon_sym_yield] = ACTIONS(4598),
    [anon_sym_from] = ACTIONS(4598),
    [anon_sym_join] = ACTIONS(4598),
    [anon_sym_on] = ACTIONS(4598),
    [anon_sym_equals] = ACTIONS(4598),
    [anon_sym_into] = ACTIONS(4598),
    [anon_sym_let] = ACTIONS(4598),
    [anon_sym_orderby] = ACTIONS(4598),
    [anon_sym_ascending] = ACTIONS(4598),
    [anon_sym_descending] = ACTIONS(4598),
    [anon_sym_group] = ACTIONS(4598),
    [anon_sym_by] = ACTIONS(4598),
    [anon_sym_select] = ACTIONS(4598),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4598),
    [anon_sym_nameof] = ACTIONS(4598),
    [sym_void_keyword] = ACTIONS(4598),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2480] = {
    [sym__preprocessor_call] = STATE(2480),
    [sym__identifier_token] = ACTIONS(4602),
    [anon_sym_extern] = ACTIONS(4602),
    [anon_sym_alias] = ACTIONS(4602),
    [anon_sym_global] = ACTIONS(4602),
    [anon_sym_using] = ACTIONS(4602),
    [anon_sym_static] = ACTIONS(4602),
    [anon_sym_LBRACK] = ACTIONS(4604),
    [anon_sym_event] = ACTIONS(4602),
    [anon_sym_LPAREN] = ACTIONS(4604),
    [anon_sym_abstract] = ACTIONS(4602),
    [anon_sym_async] = ACTIONS(4602),
    [anon_sym_const] = ACTIONS(4602),
    [anon_sym_fixed] = ACTIONS(4602),
    [anon_sym_internal] = ACTIONS(4602),
    [anon_sym_new] = ACTIONS(4602),
    [anon_sym_override] = ACTIONS(4602),
    [anon_sym_partial] = ACTIONS(4602),
    [anon_sym_private] = ACTIONS(4602),
    [anon_sym_protected] = ACTIONS(4602),
    [anon_sym_public] = ACTIONS(4602),
    [anon_sym_readonly] = ACTIONS(4602),
    [anon_sym_ref] = ACTIONS(4602),
    [anon_sym_sealed] = ACTIONS(4602),
    [anon_sym_unsafe] = ACTIONS(4602),
    [anon_sym_virtual] = ACTIONS(4602),
    [anon_sym_volatile] = ACTIONS(4602),
    [anon_sym_RBRACE] = ACTIONS(4604),
    [anon_sym_implicit] = ACTIONS(4602),
    [anon_sym_explicit] = ACTIONS(4602),
    [anon_sym_TILDE] = ACTIONS(4604),
    [anon_sym_where] = ACTIONS(4602),
    [anon_sym_class] = ACTIONS(4602),
    [anon_sym_struct] = ACTIONS(4602),
    [anon_sym_notnull] = ACTIONS(4602),
    [anon_sym_unmanaged] = ACTIONS(4602),
    [anon_sym_get] = ACTIONS(4602),
    [anon_sym_set] = ACTIONS(4602),
    [anon_sym_add] = ACTIONS(4602),
    [anon_sym_remove] = ACTIONS(4602),
    [anon_sym_enum] = ACTIONS(4602),
    [anon_sym_interface] = ACTIONS(4602),
    [anon_sym_delegate] = ACTIONS(4602),
    [anon_sym_record] = ACTIONS(4602),
    [anon_sym_namespace] = ACTIONS(4602),
    [anon_sym_var] = ACTIONS(4602),
    [sym_predefined_type] = ACTIONS(4602),
    [anon_sym_when] = ACTIONS(4602),
    [anon_sym_yield] = ACTIONS(4602),
    [anon_sym_from] = ACTIONS(4602),
    [anon_sym_join] = ACTIONS(4602),
    [anon_sym_on] = ACTIONS(4602),
    [anon_sym_equals] = ACTIONS(4602),
    [anon_sym_into] = ACTIONS(4602),
    [anon_sym_let] = ACTIONS(4602),
    [anon_sym_orderby] = ACTIONS(4602),
    [anon_sym_ascending] = ACTIONS(4602),
    [anon_sym_descending] = ACTIONS(4602),
    [anon_sym_group] = ACTIONS(4602),
    [anon_sym_by] = ACTIONS(4602),
    [anon_sym_select] = ACTIONS(4602),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4602),
    [anon_sym_nameof] = ACTIONS(4602),
    [sym_void_keyword] = ACTIONS(4602),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2481] = {
    [sym__preprocessor_call] = STATE(2481),
    [sym__identifier_token] = ACTIONS(4606),
    [anon_sym_extern] = ACTIONS(4606),
    [anon_sym_alias] = ACTIONS(4606),
    [anon_sym_global] = ACTIONS(4606),
    [anon_sym_using] = ACTIONS(4606),
    [anon_sym_static] = ACTIONS(4606),
    [anon_sym_LBRACK] = ACTIONS(4608),
    [anon_sym_event] = ACTIONS(4606),
    [anon_sym_LPAREN] = ACTIONS(4608),
    [anon_sym_abstract] = ACTIONS(4606),
    [anon_sym_async] = ACTIONS(4606),
    [anon_sym_const] = ACTIONS(4606),
    [anon_sym_fixed] = ACTIONS(4606),
    [anon_sym_internal] = ACTIONS(4606),
    [anon_sym_new] = ACTIONS(4606),
    [anon_sym_override] = ACTIONS(4606),
    [anon_sym_partial] = ACTIONS(4606),
    [anon_sym_private] = ACTIONS(4606),
    [anon_sym_protected] = ACTIONS(4606),
    [anon_sym_public] = ACTIONS(4606),
    [anon_sym_readonly] = ACTIONS(4606),
    [anon_sym_ref] = ACTIONS(4606),
    [anon_sym_sealed] = ACTIONS(4606),
    [anon_sym_unsafe] = ACTIONS(4606),
    [anon_sym_virtual] = ACTIONS(4606),
    [anon_sym_volatile] = ACTIONS(4606),
    [anon_sym_RBRACE] = ACTIONS(4608),
    [anon_sym_implicit] = ACTIONS(4606),
    [anon_sym_explicit] = ACTIONS(4606),
    [anon_sym_TILDE] = ACTIONS(4608),
    [anon_sym_where] = ACTIONS(4606),
    [anon_sym_class] = ACTIONS(4606),
    [anon_sym_struct] = ACTIONS(4606),
    [anon_sym_notnull] = ACTIONS(4606),
    [anon_sym_unmanaged] = ACTIONS(4606),
    [anon_sym_get] = ACTIONS(4606),
    [anon_sym_set] = ACTIONS(4606),
    [anon_sym_add] = ACTIONS(4606),
    [anon_sym_remove] = ACTIONS(4606),
    [anon_sym_enum] = ACTIONS(4606),
    [anon_sym_interface] = ACTIONS(4606),
    [anon_sym_delegate] = ACTIONS(4606),
    [anon_sym_record] = ACTIONS(4606),
    [anon_sym_namespace] = ACTIONS(4606),
    [anon_sym_var] = ACTIONS(4606),
    [sym_predefined_type] = ACTIONS(4606),
    [anon_sym_when] = ACTIONS(4606),
    [anon_sym_yield] = ACTIONS(4606),
    [anon_sym_from] = ACTIONS(4606),
    [anon_sym_join] = ACTIONS(4606),
    [anon_sym_on] = ACTIONS(4606),
    [anon_sym_equals] = ACTIONS(4606),
    [anon_sym_into] = ACTIONS(4606),
    [anon_sym_let] = ACTIONS(4606),
    [anon_sym_orderby] = ACTIONS(4606),
    [anon_sym_ascending] = ACTIONS(4606),
    [anon_sym_descending] = ACTIONS(4606),
    [anon_sym_group] = ACTIONS(4606),
    [anon_sym_by] = ACTIONS(4606),
    [anon_sym_select] = ACTIONS(4606),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4606),
    [anon_sym_nameof] = ACTIONS(4606),
    [sym_void_keyword] = ACTIONS(4606),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2482] = {
    [sym__preprocessor_call] = STATE(2482),
    [sym__identifier_token] = ACTIONS(4610),
    [anon_sym_extern] = ACTIONS(4610),
    [anon_sym_alias] = ACTIONS(4610),
    [anon_sym_global] = ACTIONS(4610),
    [anon_sym_using] = ACTIONS(4610),
    [anon_sym_static] = ACTIONS(4610),
    [anon_sym_LBRACK] = ACTIONS(4612),
    [anon_sym_event] = ACTIONS(4610),
    [anon_sym_LPAREN] = ACTIONS(4612),
    [anon_sym_abstract] = ACTIONS(4610),
    [anon_sym_async] = ACTIONS(4610),
    [anon_sym_const] = ACTIONS(4610),
    [anon_sym_fixed] = ACTIONS(4610),
    [anon_sym_internal] = ACTIONS(4610),
    [anon_sym_new] = ACTIONS(4610),
    [anon_sym_override] = ACTIONS(4610),
    [anon_sym_partial] = ACTIONS(4610),
    [anon_sym_private] = ACTIONS(4610),
    [anon_sym_protected] = ACTIONS(4610),
    [anon_sym_public] = ACTIONS(4610),
    [anon_sym_readonly] = ACTIONS(4610),
    [anon_sym_ref] = ACTIONS(4610),
    [anon_sym_sealed] = ACTIONS(4610),
    [anon_sym_unsafe] = ACTIONS(4610),
    [anon_sym_virtual] = ACTIONS(4610),
    [anon_sym_volatile] = ACTIONS(4610),
    [anon_sym_RBRACE] = ACTIONS(4612),
    [anon_sym_implicit] = ACTIONS(4610),
    [anon_sym_explicit] = ACTIONS(4610),
    [anon_sym_TILDE] = ACTIONS(4612),
    [anon_sym_where] = ACTIONS(4610),
    [anon_sym_class] = ACTIONS(4610),
    [anon_sym_struct] = ACTIONS(4610),
    [anon_sym_notnull] = ACTIONS(4610),
    [anon_sym_unmanaged] = ACTIONS(4610),
    [anon_sym_get] = ACTIONS(4610),
    [anon_sym_set] = ACTIONS(4610),
    [anon_sym_add] = ACTIONS(4610),
    [anon_sym_remove] = ACTIONS(4610),
    [anon_sym_enum] = ACTIONS(4610),
    [anon_sym_interface] = ACTIONS(4610),
    [anon_sym_delegate] = ACTIONS(4610),
    [anon_sym_record] = ACTIONS(4610),
    [anon_sym_namespace] = ACTIONS(4610),
    [anon_sym_var] = ACTIONS(4610),
    [sym_predefined_type] = ACTIONS(4610),
    [anon_sym_when] = ACTIONS(4610),
    [anon_sym_yield] = ACTIONS(4610),
    [anon_sym_from] = ACTIONS(4610),
    [anon_sym_join] = ACTIONS(4610),
    [anon_sym_on] = ACTIONS(4610),
    [anon_sym_equals] = ACTIONS(4610),
    [anon_sym_into] = ACTIONS(4610),
    [anon_sym_let] = ACTIONS(4610),
    [anon_sym_orderby] = ACTIONS(4610),
    [anon_sym_ascending] = ACTIONS(4610),
    [anon_sym_descending] = ACTIONS(4610),
    [anon_sym_group] = ACTIONS(4610),
    [anon_sym_by] = ACTIONS(4610),
    [anon_sym_select] = ACTIONS(4610),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4610),
    [anon_sym_nameof] = ACTIONS(4610),
    [sym_void_keyword] = ACTIONS(4610),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2483] = {
    [sym__preprocessor_call] = STATE(2483),
    [sym__identifier_token] = ACTIONS(4614),
    [anon_sym_extern] = ACTIONS(4614),
    [anon_sym_alias] = ACTIONS(4614),
    [anon_sym_global] = ACTIONS(4614),
    [anon_sym_using] = ACTIONS(4614),
    [anon_sym_static] = ACTIONS(4614),
    [anon_sym_LBRACK] = ACTIONS(4616),
    [anon_sym_event] = ACTIONS(4614),
    [anon_sym_LPAREN] = ACTIONS(4616),
    [anon_sym_abstract] = ACTIONS(4614),
    [anon_sym_async] = ACTIONS(4614),
    [anon_sym_const] = ACTIONS(4614),
    [anon_sym_fixed] = ACTIONS(4614),
    [anon_sym_internal] = ACTIONS(4614),
    [anon_sym_new] = ACTIONS(4614),
    [anon_sym_override] = ACTIONS(4614),
    [anon_sym_partial] = ACTIONS(4614),
    [anon_sym_private] = ACTIONS(4614),
    [anon_sym_protected] = ACTIONS(4614),
    [anon_sym_public] = ACTIONS(4614),
    [anon_sym_readonly] = ACTIONS(4614),
    [anon_sym_ref] = ACTIONS(4614),
    [anon_sym_sealed] = ACTIONS(4614),
    [anon_sym_unsafe] = ACTIONS(4614),
    [anon_sym_virtual] = ACTIONS(4614),
    [anon_sym_volatile] = ACTIONS(4614),
    [anon_sym_RBRACE] = ACTIONS(4616),
    [anon_sym_implicit] = ACTIONS(4614),
    [anon_sym_explicit] = ACTIONS(4614),
    [anon_sym_TILDE] = ACTIONS(4616),
    [anon_sym_where] = ACTIONS(4614),
    [anon_sym_class] = ACTIONS(4614),
    [anon_sym_struct] = ACTIONS(4614),
    [anon_sym_notnull] = ACTIONS(4614),
    [anon_sym_unmanaged] = ACTIONS(4614),
    [anon_sym_get] = ACTIONS(4614),
    [anon_sym_set] = ACTIONS(4614),
    [anon_sym_add] = ACTIONS(4614),
    [anon_sym_remove] = ACTIONS(4614),
    [anon_sym_enum] = ACTIONS(4614),
    [anon_sym_interface] = ACTIONS(4614),
    [anon_sym_delegate] = ACTIONS(4614),
    [anon_sym_record] = ACTIONS(4614),
    [anon_sym_namespace] = ACTIONS(4614),
    [anon_sym_var] = ACTIONS(4614),
    [sym_predefined_type] = ACTIONS(4614),
    [anon_sym_when] = ACTIONS(4614),
    [anon_sym_yield] = ACTIONS(4614),
    [anon_sym_from] = ACTIONS(4614),
    [anon_sym_join] = ACTIONS(4614),
    [anon_sym_on] = ACTIONS(4614),
    [anon_sym_equals] = ACTIONS(4614),
    [anon_sym_into] = ACTIONS(4614),
    [anon_sym_let] = ACTIONS(4614),
    [anon_sym_orderby] = ACTIONS(4614),
    [anon_sym_ascending] = ACTIONS(4614),
    [anon_sym_descending] = ACTIONS(4614),
    [anon_sym_group] = ACTIONS(4614),
    [anon_sym_by] = ACTIONS(4614),
    [anon_sym_select] = ACTIONS(4614),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4614),
    [anon_sym_nameof] = ACTIONS(4614),
    [sym_void_keyword] = ACTIONS(4614),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2484] = {
    [sym__preprocessor_call] = STATE(2484),
    [sym__identifier_token] = ACTIONS(4618),
    [anon_sym_extern] = ACTIONS(4618),
    [anon_sym_alias] = ACTIONS(4618),
    [anon_sym_global] = ACTIONS(4618),
    [anon_sym_using] = ACTIONS(4618),
    [anon_sym_static] = ACTIONS(4618),
    [anon_sym_LBRACK] = ACTIONS(4620),
    [anon_sym_event] = ACTIONS(4618),
    [anon_sym_LPAREN] = ACTIONS(4620),
    [anon_sym_abstract] = ACTIONS(4618),
    [anon_sym_async] = ACTIONS(4618),
    [anon_sym_const] = ACTIONS(4618),
    [anon_sym_fixed] = ACTIONS(4618),
    [anon_sym_internal] = ACTIONS(4618),
    [anon_sym_new] = ACTIONS(4618),
    [anon_sym_override] = ACTIONS(4618),
    [anon_sym_partial] = ACTIONS(4618),
    [anon_sym_private] = ACTIONS(4618),
    [anon_sym_protected] = ACTIONS(4618),
    [anon_sym_public] = ACTIONS(4618),
    [anon_sym_readonly] = ACTIONS(4618),
    [anon_sym_ref] = ACTIONS(4618),
    [anon_sym_sealed] = ACTIONS(4618),
    [anon_sym_unsafe] = ACTIONS(4618),
    [anon_sym_virtual] = ACTIONS(4618),
    [anon_sym_volatile] = ACTIONS(4618),
    [anon_sym_RBRACE] = ACTIONS(4620),
    [anon_sym_implicit] = ACTIONS(4618),
    [anon_sym_explicit] = ACTIONS(4618),
    [anon_sym_TILDE] = ACTIONS(4620),
    [anon_sym_where] = ACTIONS(4618),
    [anon_sym_class] = ACTIONS(4618),
    [anon_sym_struct] = ACTIONS(4618),
    [anon_sym_notnull] = ACTIONS(4618),
    [anon_sym_unmanaged] = ACTIONS(4618),
    [anon_sym_get] = ACTIONS(4618),
    [anon_sym_set] = ACTIONS(4618),
    [anon_sym_add] = ACTIONS(4618),
    [anon_sym_remove] = ACTIONS(4618),
    [anon_sym_enum] = ACTIONS(4618),
    [anon_sym_interface] = ACTIONS(4618),
    [anon_sym_delegate] = ACTIONS(4618),
    [anon_sym_record] = ACTIONS(4618),
    [anon_sym_namespace] = ACTIONS(4618),
    [anon_sym_var] = ACTIONS(4618),
    [sym_predefined_type] = ACTIONS(4618),
    [anon_sym_when] = ACTIONS(4618),
    [anon_sym_yield] = ACTIONS(4618),
    [anon_sym_from] = ACTIONS(4618),
    [anon_sym_join] = ACTIONS(4618),
    [anon_sym_on] = ACTIONS(4618),
    [anon_sym_equals] = ACTIONS(4618),
    [anon_sym_into] = ACTIONS(4618),
    [anon_sym_let] = ACTIONS(4618),
    [anon_sym_orderby] = ACTIONS(4618),
    [anon_sym_ascending] = ACTIONS(4618),
    [anon_sym_descending] = ACTIONS(4618),
    [anon_sym_group] = ACTIONS(4618),
    [anon_sym_by] = ACTIONS(4618),
    [anon_sym_select] = ACTIONS(4618),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4618),
    [anon_sym_nameof] = ACTIONS(4618),
    [sym_void_keyword] = ACTIONS(4618),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2485] = {
    [sym__preprocessor_call] = STATE(2485),
    [sym__identifier_token] = ACTIONS(4622),
    [anon_sym_extern] = ACTIONS(4622),
    [anon_sym_alias] = ACTIONS(4622),
    [anon_sym_global] = ACTIONS(4622),
    [anon_sym_using] = ACTIONS(4622),
    [anon_sym_static] = ACTIONS(4622),
    [anon_sym_LBRACK] = ACTIONS(4624),
    [anon_sym_event] = ACTIONS(4622),
    [anon_sym_LPAREN] = ACTIONS(4624),
    [anon_sym_abstract] = ACTIONS(4622),
    [anon_sym_async] = ACTIONS(4622),
    [anon_sym_const] = ACTIONS(4622),
    [anon_sym_fixed] = ACTIONS(4622),
    [anon_sym_internal] = ACTIONS(4622),
    [anon_sym_new] = ACTIONS(4622),
    [anon_sym_override] = ACTIONS(4622),
    [anon_sym_partial] = ACTIONS(4622),
    [anon_sym_private] = ACTIONS(4622),
    [anon_sym_protected] = ACTIONS(4622),
    [anon_sym_public] = ACTIONS(4622),
    [anon_sym_readonly] = ACTIONS(4622),
    [anon_sym_ref] = ACTIONS(4622),
    [anon_sym_sealed] = ACTIONS(4622),
    [anon_sym_unsafe] = ACTIONS(4622),
    [anon_sym_virtual] = ACTIONS(4622),
    [anon_sym_volatile] = ACTIONS(4622),
    [anon_sym_RBRACE] = ACTIONS(4624),
    [anon_sym_implicit] = ACTIONS(4622),
    [anon_sym_explicit] = ACTIONS(4622),
    [anon_sym_TILDE] = ACTIONS(4624),
    [anon_sym_where] = ACTIONS(4622),
    [anon_sym_class] = ACTIONS(4622),
    [anon_sym_struct] = ACTIONS(4622),
    [anon_sym_notnull] = ACTIONS(4622),
    [anon_sym_unmanaged] = ACTIONS(4622),
    [anon_sym_get] = ACTIONS(4622),
    [anon_sym_set] = ACTIONS(4622),
    [anon_sym_add] = ACTIONS(4622),
    [anon_sym_remove] = ACTIONS(4622),
    [anon_sym_enum] = ACTIONS(4622),
    [anon_sym_interface] = ACTIONS(4622),
    [anon_sym_delegate] = ACTIONS(4622),
    [anon_sym_record] = ACTIONS(4622),
    [anon_sym_namespace] = ACTIONS(4622),
    [anon_sym_var] = ACTIONS(4622),
    [sym_predefined_type] = ACTIONS(4622),
    [anon_sym_when] = ACTIONS(4622),
    [anon_sym_yield] = ACTIONS(4622),
    [anon_sym_from] = ACTIONS(4622),
    [anon_sym_join] = ACTIONS(4622),
    [anon_sym_on] = ACTIONS(4622),
    [anon_sym_equals] = ACTIONS(4622),
    [anon_sym_into] = ACTIONS(4622),
    [anon_sym_let] = ACTIONS(4622),
    [anon_sym_orderby] = ACTIONS(4622),
    [anon_sym_ascending] = ACTIONS(4622),
    [anon_sym_descending] = ACTIONS(4622),
    [anon_sym_group] = ACTIONS(4622),
    [anon_sym_by] = ACTIONS(4622),
    [anon_sym_select] = ACTIONS(4622),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4622),
    [anon_sym_nameof] = ACTIONS(4622),
    [sym_void_keyword] = ACTIONS(4622),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2486] = {
    [sym__preprocessor_call] = STATE(2486),
    [sym__identifier_token] = ACTIONS(4626),
    [anon_sym_extern] = ACTIONS(4626),
    [anon_sym_alias] = ACTIONS(4626),
    [anon_sym_global] = ACTIONS(4626),
    [anon_sym_using] = ACTIONS(4626),
    [anon_sym_static] = ACTIONS(4626),
    [anon_sym_LBRACK] = ACTIONS(4628),
    [anon_sym_event] = ACTIONS(4626),
    [anon_sym_LPAREN] = ACTIONS(4628),
    [anon_sym_abstract] = ACTIONS(4626),
    [anon_sym_async] = ACTIONS(4626),
    [anon_sym_const] = ACTIONS(4626),
    [anon_sym_fixed] = ACTIONS(4626),
    [anon_sym_internal] = ACTIONS(4626),
    [anon_sym_new] = ACTIONS(4626),
    [anon_sym_override] = ACTIONS(4626),
    [anon_sym_partial] = ACTIONS(4626),
    [anon_sym_private] = ACTIONS(4626),
    [anon_sym_protected] = ACTIONS(4626),
    [anon_sym_public] = ACTIONS(4626),
    [anon_sym_readonly] = ACTIONS(4626),
    [anon_sym_ref] = ACTIONS(4626),
    [anon_sym_sealed] = ACTIONS(4626),
    [anon_sym_unsafe] = ACTIONS(4626),
    [anon_sym_virtual] = ACTIONS(4626),
    [anon_sym_volatile] = ACTIONS(4626),
    [anon_sym_RBRACE] = ACTIONS(4628),
    [anon_sym_implicit] = ACTIONS(4626),
    [anon_sym_explicit] = ACTIONS(4626),
    [anon_sym_TILDE] = ACTIONS(4628),
    [anon_sym_where] = ACTIONS(4626),
    [anon_sym_class] = ACTIONS(4626),
    [anon_sym_struct] = ACTIONS(4626),
    [anon_sym_notnull] = ACTIONS(4626),
    [anon_sym_unmanaged] = ACTIONS(4626),
    [anon_sym_get] = ACTIONS(4626),
    [anon_sym_set] = ACTIONS(4626),
    [anon_sym_add] = ACTIONS(4626),
    [anon_sym_remove] = ACTIONS(4626),
    [anon_sym_enum] = ACTIONS(4626),
    [anon_sym_interface] = ACTIONS(4626),
    [anon_sym_delegate] = ACTIONS(4626),
    [anon_sym_record] = ACTIONS(4626),
    [anon_sym_namespace] = ACTIONS(4626),
    [anon_sym_var] = ACTIONS(4626),
    [sym_predefined_type] = ACTIONS(4626),
    [anon_sym_when] = ACTIONS(4626),
    [anon_sym_yield] = ACTIONS(4626),
    [anon_sym_from] = ACTIONS(4626),
    [anon_sym_join] = ACTIONS(4626),
    [anon_sym_on] = ACTIONS(4626),
    [anon_sym_equals] = ACTIONS(4626),
    [anon_sym_into] = ACTIONS(4626),
    [anon_sym_let] = ACTIONS(4626),
    [anon_sym_orderby] = ACTIONS(4626),
    [anon_sym_ascending] = ACTIONS(4626),
    [anon_sym_descending] = ACTIONS(4626),
    [anon_sym_group] = ACTIONS(4626),
    [anon_sym_by] = ACTIONS(4626),
    [anon_sym_select] = ACTIONS(4626),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4626),
    [anon_sym_nameof] = ACTIONS(4626),
    [sym_void_keyword] = ACTIONS(4626),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2487] = {
    [sym__preprocessor_call] = STATE(2487),
    [sym__identifier_token] = ACTIONS(4630),
    [anon_sym_extern] = ACTIONS(4630),
    [anon_sym_alias] = ACTIONS(4630),
    [anon_sym_global] = ACTIONS(4630),
    [anon_sym_using] = ACTIONS(4630),
    [anon_sym_static] = ACTIONS(4630),
    [anon_sym_LBRACK] = ACTIONS(4632),
    [anon_sym_event] = ACTIONS(4630),
    [anon_sym_LPAREN] = ACTIONS(4632),
    [anon_sym_abstract] = ACTIONS(4630),
    [anon_sym_async] = ACTIONS(4630),
    [anon_sym_const] = ACTIONS(4630),
    [anon_sym_fixed] = ACTIONS(4630),
    [anon_sym_internal] = ACTIONS(4630),
    [anon_sym_new] = ACTIONS(4630),
    [anon_sym_override] = ACTIONS(4630),
    [anon_sym_partial] = ACTIONS(4630),
    [anon_sym_private] = ACTIONS(4630),
    [anon_sym_protected] = ACTIONS(4630),
    [anon_sym_public] = ACTIONS(4630),
    [anon_sym_readonly] = ACTIONS(4630),
    [anon_sym_ref] = ACTIONS(4630),
    [anon_sym_sealed] = ACTIONS(4630),
    [anon_sym_unsafe] = ACTIONS(4630),
    [anon_sym_virtual] = ACTIONS(4630),
    [anon_sym_volatile] = ACTIONS(4630),
    [anon_sym_RBRACE] = ACTIONS(4632),
    [anon_sym_implicit] = ACTIONS(4630),
    [anon_sym_explicit] = ACTIONS(4630),
    [anon_sym_TILDE] = ACTIONS(4632),
    [anon_sym_where] = ACTIONS(4630),
    [anon_sym_class] = ACTIONS(4630),
    [anon_sym_struct] = ACTIONS(4630),
    [anon_sym_notnull] = ACTIONS(4630),
    [anon_sym_unmanaged] = ACTIONS(4630),
    [anon_sym_get] = ACTIONS(4630),
    [anon_sym_set] = ACTIONS(4630),
    [anon_sym_add] = ACTIONS(4630),
    [anon_sym_remove] = ACTIONS(4630),
    [anon_sym_enum] = ACTIONS(4630),
    [anon_sym_interface] = ACTIONS(4630),
    [anon_sym_delegate] = ACTIONS(4630),
    [anon_sym_record] = ACTIONS(4630),
    [anon_sym_namespace] = ACTIONS(4630),
    [anon_sym_var] = ACTIONS(4630),
    [sym_predefined_type] = ACTIONS(4630),
    [anon_sym_when] = ACTIONS(4630),
    [anon_sym_yield] = ACTIONS(4630),
    [anon_sym_from] = ACTIONS(4630),
    [anon_sym_join] = ACTIONS(4630),
    [anon_sym_on] = ACTIONS(4630),
    [anon_sym_equals] = ACTIONS(4630),
    [anon_sym_into] = ACTIONS(4630),
    [anon_sym_let] = ACTIONS(4630),
    [anon_sym_orderby] = ACTIONS(4630),
    [anon_sym_ascending] = ACTIONS(4630),
    [anon_sym_descending] = ACTIONS(4630),
    [anon_sym_group] = ACTIONS(4630),
    [anon_sym_by] = ACTIONS(4630),
    [anon_sym_select] = ACTIONS(4630),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4630),
    [anon_sym_nameof] = ACTIONS(4630),
    [sym_void_keyword] = ACTIONS(4630),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2488] = {
    [sym__preprocessor_call] = STATE(2488),
    [sym__identifier_token] = ACTIONS(4634),
    [anon_sym_extern] = ACTIONS(4634),
    [anon_sym_alias] = ACTIONS(4634),
    [anon_sym_global] = ACTIONS(4634),
    [anon_sym_using] = ACTIONS(4634),
    [anon_sym_static] = ACTIONS(4634),
    [anon_sym_LBRACK] = ACTIONS(4636),
    [anon_sym_event] = ACTIONS(4634),
    [anon_sym_LPAREN] = ACTIONS(4636),
    [anon_sym_abstract] = ACTIONS(4634),
    [anon_sym_async] = ACTIONS(4634),
    [anon_sym_const] = ACTIONS(4634),
    [anon_sym_fixed] = ACTIONS(4634),
    [anon_sym_internal] = ACTIONS(4634),
    [anon_sym_new] = ACTIONS(4634),
    [anon_sym_override] = ACTIONS(4634),
    [anon_sym_partial] = ACTIONS(4634),
    [anon_sym_private] = ACTIONS(4634),
    [anon_sym_protected] = ACTIONS(4634),
    [anon_sym_public] = ACTIONS(4634),
    [anon_sym_readonly] = ACTIONS(4634),
    [anon_sym_ref] = ACTIONS(4634),
    [anon_sym_sealed] = ACTIONS(4634),
    [anon_sym_unsafe] = ACTIONS(4634),
    [anon_sym_virtual] = ACTIONS(4634),
    [anon_sym_volatile] = ACTIONS(4634),
    [anon_sym_RBRACE] = ACTIONS(4636),
    [anon_sym_implicit] = ACTIONS(4634),
    [anon_sym_explicit] = ACTIONS(4634),
    [anon_sym_TILDE] = ACTIONS(4636),
    [anon_sym_where] = ACTIONS(4634),
    [anon_sym_class] = ACTIONS(4634),
    [anon_sym_struct] = ACTIONS(4634),
    [anon_sym_notnull] = ACTIONS(4634),
    [anon_sym_unmanaged] = ACTIONS(4634),
    [anon_sym_get] = ACTIONS(4634),
    [anon_sym_set] = ACTIONS(4634),
    [anon_sym_add] = ACTIONS(4634),
    [anon_sym_remove] = ACTIONS(4634),
    [anon_sym_enum] = ACTIONS(4634),
    [anon_sym_interface] = ACTIONS(4634),
    [anon_sym_delegate] = ACTIONS(4634),
    [anon_sym_record] = ACTIONS(4634),
    [anon_sym_namespace] = ACTIONS(4634),
    [anon_sym_var] = ACTIONS(4634),
    [sym_predefined_type] = ACTIONS(4634),
    [anon_sym_when] = ACTIONS(4634),
    [anon_sym_yield] = ACTIONS(4634),
    [anon_sym_from] = ACTIONS(4634),
    [anon_sym_join] = ACTIONS(4634),
    [anon_sym_on] = ACTIONS(4634),
    [anon_sym_equals] = ACTIONS(4634),
    [anon_sym_into] = ACTIONS(4634),
    [anon_sym_let] = ACTIONS(4634),
    [anon_sym_orderby] = ACTIONS(4634),
    [anon_sym_ascending] = ACTIONS(4634),
    [anon_sym_descending] = ACTIONS(4634),
    [anon_sym_group] = ACTIONS(4634),
    [anon_sym_by] = ACTIONS(4634),
    [anon_sym_select] = ACTIONS(4634),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4634),
    [anon_sym_nameof] = ACTIONS(4634),
    [sym_void_keyword] = ACTIONS(4634),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2489] = {
    [sym__preprocessor_call] = STATE(2489),
    [sym__identifier_token] = ACTIONS(4638),
    [anon_sym_extern] = ACTIONS(4638),
    [anon_sym_alias] = ACTIONS(4638),
    [anon_sym_global] = ACTIONS(4638),
    [anon_sym_using] = ACTIONS(4638),
    [anon_sym_static] = ACTIONS(4638),
    [anon_sym_LBRACK] = ACTIONS(4640),
    [anon_sym_event] = ACTIONS(4638),
    [anon_sym_LPAREN] = ACTIONS(4640),
    [anon_sym_abstract] = ACTIONS(4638),
    [anon_sym_async] = ACTIONS(4638),
    [anon_sym_const] = ACTIONS(4638),
    [anon_sym_fixed] = ACTIONS(4638),
    [anon_sym_internal] = ACTIONS(4638),
    [anon_sym_new] = ACTIONS(4638),
    [anon_sym_override] = ACTIONS(4638),
    [anon_sym_partial] = ACTIONS(4638),
    [anon_sym_private] = ACTIONS(4638),
    [anon_sym_protected] = ACTIONS(4638),
    [anon_sym_public] = ACTIONS(4638),
    [anon_sym_readonly] = ACTIONS(4638),
    [anon_sym_ref] = ACTIONS(4638),
    [anon_sym_sealed] = ACTIONS(4638),
    [anon_sym_unsafe] = ACTIONS(4638),
    [anon_sym_virtual] = ACTIONS(4638),
    [anon_sym_volatile] = ACTIONS(4638),
    [anon_sym_RBRACE] = ACTIONS(4640),
    [anon_sym_implicit] = ACTIONS(4638),
    [anon_sym_explicit] = ACTIONS(4638),
    [anon_sym_TILDE] = ACTIONS(4640),
    [anon_sym_where] = ACTIONS(4638),
    [anon_sym_class] = ACTIONS(4638),
    [anon_sym_struct] = ACTIONS(4638),
    [anon_sym_notnull] = ACTIONS(4638),
    [anon_sym_unmanaged] = ACTIONS(4638),
    [anon_sym_get] = ACTIONS(4638),
    [anon_sym_set] = ACTIONS(4638),
    [anon_sym_add] = ACTIONS(4638),
    [anon_sym_remove] = ACTIONS(4638),
    [anon_sym_enum] = ACTIONS(4638),
    [anon_sym_interface] = ACTIONS(4638),
    [anon_sym_delegate] = ACTIONS(4638),
    [anon_sym_record] = ACTIONS(4638),
    [anon_sym_namespace] = ACTIONS(4638),
    [anon_sym_var] = ACTIONS(4638),
    [sym_predefined_type] = ACTIONS(4638),
    [anon_sym_when] = ACTIONS(4638),
    [anon_sym_yield] = ACTIONS(4638),
    [anon_sym_from] = ACTIONS(4638),
    [anon_sym_join] = ACTIONS(4638),
    [anon_sym_on] = ACTIONS(4638),
    [anon_sym_equals] = ACTIONS(4638),
    [anon_sym_into] = ACTIONS(4638),
    [anon_sym_let] = ACTIONS(4638),
    [anon_sym_orderby] = ACTIONS(4638),
    [anon_sym_ascending] = ACTIONS(4638),
    [anon_sym_descending] = ACTIONS(4638),
    [anon_sym_group] = ACTIONS(4638),
    [anon_sym_by] = ACTIONS(4638),
    [anon_sym_select] = ACTIONS(4638),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4638),
    [anon_sym_nameof] = ACTIONS(4638),
    [sym_void_keyword] = ACTIONS(4638),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2490] = {
    [sym__preprocessor_call] = STATE(2490),
    [sym__identifier_token] = ACTIONS(4642),
    [anon_sym_extern] = ACTIONS(4642),
    [anon_sym_alias] = ACTIONS(4642),
    [anon_sym_global] = ACTIONS(4642),
    [anon_sym_using] = ACTIONS(4642),
    [anon_sym_static] = ACTIONS(4642),
    [anon_sym_LBRACK] = ACTIONS(4644),
    [anon_sym_event] = ACTIONS(4642),
    [anon_sym_LPAREN] = ACTIONS(4644),
    [anon_sym_abstract] = ACTIONS(4642),
    [anon_sym_async] = ACTIONS(4642),
    [anon_sym_const] = ACTIONS(4642),
    [anon_sym_fixed] = ACTIONS(4642),
    [anon_sym_internal] = ACTIONS(4642),
    [anon_sym_new] = ACTIONS(4642),
    [anon_sym_override] = ACTIONS(4642),
    [anon_sym_partial] = ACTIONS(4642),
    [anon_sym_private] = ACTIONS(4642),
    [anon_sym_protected] = ACTIONS(4642),
    [anon_sym_public] = ACTIONS(4642),
    [anon_sym_readonly] = ACTIONS(4642),
    [anon_sym_ref] = ACTIONS(4642),
    [anon_sym_sealed] = ACTIONS(4642),
    [anon_sym_unsafe] = ACTIONS(4642),
    [anon_sym_virtual] = ACTIONS(4642),
    [anon_sym_volatile] = ACTIONS(4642),
    [anon_sym_RBRACE] = ACTIONS(4644),
    [anon_sym_implicit] = ACTIONS(4642),
    [anon_sym_explicit] = ACTIONS(4642),
    [anon_sym_TILDE] = ACTIONS(4644),
    [anon_sym_where] = ACTIONS(4642),
    [anon_sym_class] = ACTIONS(4642),
    [anon_sym_struct] = ACTIONS(4642),
    [anon_sym_notnull] = ACTIONS(4642),
    [anon_sym_unmanaged] = ACTIONS(4642),
    [anon_sym_get] = ACTIONS(4642),
    [anon_sym_set] = ACTIONS(4642),
    [anon_sym_add] = ACTIONS(4642),
    [anon_sym_remove] = ACTIONS(4642),
    [anon_sym_enum] = ACTIONS(4642),
    [anon_sym_interface] = ACTIONS(4642),
    [anon_sym_delegate] = ACTIONS(4642),
    [anon_sym_record] = ACTIONS(4642),
    [anon_sym_namespace] = ACTIONS(4642),
    [anon_sym_var] = ACTIONS(4642),
    [sym_predefined_type] = ACTIONS(4642),
    [anon_sym_when] = ACTIONS(4642),
    [anon_sym_yield] = ACTIONS(4642),
    [anon_sym_from] = ACTIONS(4642),
    [anon_sym_join] = ACTIONS(4642),
    [anon_sym_on] = ACTIONS(4642),
    [anon_sym_equals] = ACTIONS(4642),
    [anon_sym_into] = ACTIONS(4642),
    [anon_sym_let] = ACTIONS(4642),
    [anon_sym_orderby] = ACTIONS(4642),
    [anon_sym_ascending] = ACTIONS(4642),
    [anon_sym_descending] = ACTIONS(4642),
    [anon_sym_group] = ACTIONS(4642),
    [anon_sym_by] = ACTIONS(4642),
    [anon_sym_select] = ACTIONS(4642),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4642),
    [anon_sym_nameof] = ACTIONS(4642),
    [sym_void_keyword] = ACTIONS(4642),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2491] = {
    [sym__preprocessor_call] = STATE(2491),
    [sym__identifier_token] = ACTIONS(4646),
    [anon_sym_extern] = ACTIONS(4646),
    [anon_sym_alias] = ACTIONS(4646),
    [anon_sym_global] = ACTIONS(4646),
    [anon_sym_using] = ACTIONS(4646),
    [anon_sym_static] = ACTIONS(4646),
    [anon_sym_LBRACK] = ACTIONS(4648),
    [anon_sym_event] = ACTIONS(4646),
    [anon_sym_LPAREN] = ACTIONS(4648),
    [anon_sym_abstract] = ACTIONS(4646),
    [anon_sym_async] = ACTIONS(4646),
    [anon_sym_const] = ACTIONS(4646),
    [anon_sym_fixed] = ACTIONS(4646),
    [anon_sym_internal] = ACTIONS(4646),
    [anon_sym_new] = ACTIONS(4646),
    [anon_sym_override] = ACTIONS(4646),
    [anon_sym_partial] = ACTIONS(4646),
    [anon_sym_private] = ACTIONS(4646),
    [anon_sym_protected] = ACTIONS(4646),
    [anon_sym_public] = ACTIONS(4646),
    [anon_sym_readonly] = ACTIONS(4646),
    [anon_sym_ref] = ACTIONS(4646),
    [anon_sym_sealed] = ACTIONS(4646),
    [anon_sym_unsafe] = ACTIONS(4646),
    [anon_sym_virtual] = ACTIONS(4646),
    [anon_sym_volatile] = ACTIONS(4646),
    [anon_sym_RBRACE] = ACTIONS(4648),
    [anon_sym_implicit] = ACTIONS(4646),
    [anon_sym_explicit] = ACTIONS(4646),
    [anon_sym_TILDE] = ACTIONS(4648),
    [anon_sym_where] = ACTIONS(4646),
    [anon_sym_class] = ACTIONS(4646),
    [anon_sym_struct] = ACTIONS(4646),
    [anon_sym_notnull] = ACTIONS(4646),
    [anon_sym_unmanaged] = ACTIONS(4646),
    [anon_sym_get] = ACTIONS(4646),
    [anon_sym_set] = ACTIONS(4646),
    [anon_sym_add] = ACTIONS(4646),
    [anon_sym_remove] = ACTIONS(4646),
    [anon_sym_enum] = ACTIONS(4646),
    [anon_sym_interface] = ACTIONS(4646),
    [anon_sym_delegate] = ACTIONS(4646),
    [anon_sym_record] = ACTIONS(4646),
    [anon_sym_namespace] = ACTIONS(4646),
    [anon_sym_var] = ACTIONS(4646),
    [sym_predefined_type] = ACTIONS(4646),
    [anon_sym_when] = ACTIONS(4646),
    [anon_sym_yield] = ACTIONS(4646),
    [anon_sym_from] = ACTIONS(4646),
    [anon_sym_join] = ACTIONS(4646),
    [anon_sym_on] = ACTIONS(4646),
    [anon_sym_equals] = ACTIONS(4646),
    [anon_sym_into] = ACTIONS(4646),
    [anon_sym_let] = ACTIONS(4646),
    [anon_sym_orderby] = ACTIONS(4646),
    [anon_sym_ascending] = ACTIONS(4646),
    [anon_sym_descending] = ACTIONS(4646),
    [anon_sym_group] = ACTIONS(4646),
    [anon_sym_by] = ACTIONS(4646),
    [anon_sym_select] = ACTIONS(4646),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4646),
    [anon_sym_nameof] = ACTIONS(4646),
    [sym_void_keyword] = ACTIONS(4646),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2492] = {
    [sym__preprocessor_call] = STATE(2492),
    [sym__identifier_token] = ACTIONS(4650),
    [anon_sym_extern] = ACTIONS(4650),
    [anon_sym_alias] = ACTIONS(4650),
    [anon_sym_global] = ACTIONS(4650),
    [anon_sym_using] = ACTIONS(4650),
    [anon_sym_static] = ACTIONS(4650),
    [anon_sym_LBRACK] = ACTIONS(4652),
    [anon_sym_event] = ACTIONS(4650),
    [anon_sym_LPAREN] = ACTIONS(4652),
    [anon_sym_abstract] = ACTIONS(4650),
    [anon_sym_async] = ACTIONS(4650),
    [anon_sym_const] = ACTIONS(4650),
    [anon_sym_fixed] = ACTIONS(4650),
    [anon_sym_internal] = ACTIONS(4650),
    [anon_sym_new] = ACTIONS(4650),
    [anon_sym_override] = ACTIONS(4650),
    [anon_sym_partial] = ACTIONS(4650),
    [anon_sym_private] = ACTIONS(4650),
    [anon_sym_protected] = ACTIONS(4650),
    [anon_sym_public] = ACTIONS(4650),
    [anon_sym_readonly] = ACTIONS(4650),
    [anon_sym_ref] = ACTIONS(4650),
    [anon_sym_sealed] = ACTIONS(4650),
    [anon_sym_unsafe] = ACTIONS(4650),
    [anon_sym_virtual] = ACTIONS(4650),
    [anon_sym_volatile] = ACTIONS(4650),
    [anon_sym_RBRACE] = ACTIONS(4652),
    [anon_sym_implicit] = ACTIONS(4650),
    [anon_sym_explicit] = ACTIONS(4650),
    [anon_sym_TILDE] = ACTIONS(4652),
    [anon_sym_where] = ACTIONS(4650),
    [anon_sym_class] = ACTIONS(4650),
    [anon_sym_struct] = ACTIONS(4650),
    [anon_sym_notnull] = ACTIONS(4650),
    [anon_sym_unmanaged] = ACTIONS(4650),
    [anon_sym_get] = ACTIONS(4650),
    [anon_sym_set] = ACTIONS(4650),
    [anon_sym_add] = ACTIONS(4650),
    [anon_sym_remove] = ACTIONS(4650),
    [anon_sym_enum] = ACTIONS(4650),
    [anon_sym_interface] = ACTIONS(4650),
    [anon_sym_delegate] = ACTIONS(4650),
    [anon_sym_record] = ACTIONS(4650),
    [anon_sym_namespace] = ACTIONS(4650),
    [anon_sym_var] = ACTIONS(4650),
    [sym_predefined_type] = ACTIONS(4650),
    [anon_sym_when] = ACTIONS(4650),
    [anon_sym_yield] = ACTIONS(4650),
    [anon_sym_from] = ACTIONS(4650),
    [anon_sym_join] = ACTIONS(4650),
    [anon_sym_on] = ACTIONS(4650),
    [anon_sym_equals] = ACTIONS(4650),
    [anon_sym_into] = ACTIONS(4650),
    [anon_sym_let] = ACTIONS(4650),
    [anon_sym_orderby] = ACTIONS(4650),
    [anon_sym_ascending] = ACTIONS(4650),
    [anon_sym_descending] = ACTIONS(4650),
    [anon_sym_group] = ACTIONS(4650),
    [anon_sym_by] = ACTIONS(4650),
    [anon_sym_select] = ACTIONS(4650),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4650),
    [anon_sym_nameof] = ACTIONS(4650),
    [sym_void_keyword] = ACTIONS(4650),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2493] = {
    [sym__preprocessor_call] = STATE(2493),
    [sym__identifier_token] = ACTIONS(4654),
    [anon_sym_extern] = ACTIONS(4654),
    [anon_sym_alias] = ACTIONS(4654),
    [anon_sym_global] = ACTIONS(4654),
    [anon_sym_using] = ACTIONS(4654),
    [anon_sym_static] = ACTIONS(4654),
    [anon_sym_LBRACK] = ACTIONS(4656),
    [anon_sym_event] = ACTIONS(4654),
    [anon_sym_LPAREN] = ACTIONS(4656),
    [anon_sym_abstract] = ACTIONS(4654),
    [anon_sym_async] = ACTIONS(4654),
    [anon_sym_const] = ACTIONS(4654),
    [anon_sym_fixed] = ACTIONS(4654),
    [anon_sym_internal] = ACTIONS(4654),
    [anon_sym_new] = ACTIONS(4654),
    [anon_sym_override] = ACTIONS(4654),
    [anon_sym_partial] = ACTIONS(4654),
    [anon_sym_private] = ACTIONS(4654),
    [anon_sym_protected] = ACTIONS(4654),
    [anon_sym_public] = ACTIONS(4654),
    [anon_sym_readonly] = ACTIONS(4654),
    [anon_sym_ref] = ACTIONS(4654),
    [anon_sym_sealed] = ACTIONS(4654),
    [anon_sym_unsafe] = ACTIONS(4654),
    [anon_sym_virtual] = ACTIONS(4654),
    [anon_sym_volatile] = ACTIONS(4654),
    [anon_sym_RBRACE] = ACTIONS(4656),
    [anon_sym_implicit] = ACTIONS(4654),
    [anon_sym_explicit] = ACTIONS(4654),
    [anon_sym_TILDE] = ACTIONS(4656),
    [anon_sym_where] = ACTIONS(4654),
    [anon_sym_class] = ACTIONS(4654),
    [anon_sym_struct] = ACTIONS(4654),
    [anon_sym_notnull] = ACTIONS(4654),
    [anon_sym_unmanaged] = ACTIONS(4654),
    [anon_sym_get] = ACTIONS(4654),
    [anon_sym_set] = ACTIONS(4654),
    [anon_sym_add] = ACTIONS(4654),
    [anon_sym_remove] = ACTIONS(4654),
    [anon_sym_enum] = ACTIONS(4654),
    [anon_sym_interface] = ACTIONS(4654),
    [anon_sym_delegate] = ACTIONS(4654),
    [anon_sym_record] = ACTIONS(4654),
    [anon_sym_namespace] = ACTIONS(4654),
    [anon_sym_var] = ACTIONS(4654),
    [sym_predefined_type] = ACTIONS(4654),
    [anon_sym_when] = ACTIONS(4654),
    [anon_sym_yield] = ACTIONS(4654),
    [anon_sym_from] = ACTIONS(4654),
    [anon_sym_join] = ACTIONS(4654),
    [anon_sym_on] = ACTIONS(4654),
    [anon_sym_equals] = ACTIONS(4654),
    [anon_sym_into] = ACTIONS(4654),
    [anon_sym_let] = ACTIONS(4654),
    [anon_sym_orderby] = ACTIONS(4654),
    [anon_sym_ascending] = ACTIONS(4654),
    [anon_sym_descending] = ACTIONS(4654),
    [anon_sym_group] = ACTIONS(4654),
    [anon_sym_by] = ACTIONS(4654),
    [anon_sym_select] = ACTIONS(4654),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4654),
    [anon_sym_nameof] = ACTIONS(4654),
    [sym_void_keyword] = ACTIONS(4654),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2494] = {
    [sym__preprocessor_call] = STATE(2494),
    [sym__identifier_token] = ACTIONS(4658),
    [anon_sym_extern] = ACTIONS(4658),
    [anon_sym_alias] = ACTIONS(4658),
    [anon_sym_global] = ACTIONS(4658),
    [anon_sym_using] = ACTIONS(4658),
    [anon_sym_static] = ACTIONS(4658),
    [anon_sym_LBRACK] = ACTIONS(4660),
    [anon_sym_event] = ACTIONS(4658),
    [anon_sym_LPAREN] = ACTIONS(4660),
    [anon_sym_abstract] = ACTIONS(4658),
    [anon_sym_async] = ACTIONS(4658),
    [anon_sym_const] = ACTIONS(4658),
    [anon_sym_fixed] = ACTIONS(4658),
    [anon_sym_internal] = ACTIONS(4658),
    [anon_sym_new] = ACTIONS(4658),
    [anon_sym_override] = ACTIONS(4658),
    [anon_sym_partial] = ACTIONS(4658),
    [anon_sym_private] = ACTIONS(4658),
    [anon_sym_protected] = ACTIONS(4658),
    [anon_sym_public] = ACTIONS(4658),
    [anon_sym_readonly] = ACTIONS(4658),
    [anon_sym_ref] = ACTIONS(4658),
    [anon_sym_sealed] = ACTIONS(4658),
    [anon_sym_unsafe] = ACTIONS(4658),
    [anon_sym_virtual] = ACTIONS(4658),
    [anon_sym_volatile] = ACTIONS(4658),
    [anon_sym_RBRACE] = ACTIONS(4660),
    [anon_sym_implicit] = ACTIONS(4658),
    [anon_sym_explicit] = ACTIONS(4658),
    [anon_sym_TILDE] = ACTIONS(4660),
    [anon_sym_where] = ACTIONS(4658),
    [anon_sym_class] = ACTIONS(4658),
    [anon_sym_struct] = ACTIONS(4658),
    [anon_sym_notnull] = ACTIONS(4658),
    [anon_sym_unmanaged] = ACTIONS(4658),
    [anon_sym_get] = ACTIONS(4658),
    [anon_sym_set] = ACTIONS(4658),
    [anon_sym_add] = ACTIONS(4658),
    [anon_sym_remove] = ACTIONS(4658),
    [anon_sym_enum] = ACTIONS(4658),
    [anon_sym_interface] = ACTIONS(4658),
    [anon_sym_delegate] = ACTIONS(4658),
    [anon_sym_record] = ACTIONS(4658),
    [anon_sym_namespace] = ACTIONS(4658),
    [anon_sym_var] = ACTIONS(4658),
    [sym_predefined_type] = ACTIONS(4658),
    [anon_sym_when] = ACTIONS(4658),
    [anon_sym_yield] = ACTIONS(4658),
    [anon_sym_from] = ACTIONS(4658),
    [anon_sym_join] = ACTIONS(4658),
    [anon_sym_on] = ACTIONS(4658),
    [anon_sym_equals] = ACTIONS(4658),
    [anon_sym_into] = ACTIONS(4658),
    [anon_sym_let] = ACTIONS(4658),
    [anon_sym_orderby] = ACTIONS(4658),
    [anon_sym_ascending] = ACTIONS(4658),
    [anon_sym_descending] = ACTIONS(4658),
    [anon_sym_group] = ACTIONS(4658),
    [anon_sym_by] = ACTIONS(4658),
    [anon_sym_select] = ACTIONS(4658),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4658),
    [anon_sym_nameof] = ACTIONS(4658),
    [sym_void_keyword] = ACTIONS(4658),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2495] = {
    [sym__preprocessor_call] = STATE(2495),
    [sym__identifier_token] = ACTIONS(4662),
    [anon_sym_extern] = ACTIONS(4662),
    [anon_sym_alias] = ACTIONS(4662),
    [anon_sym_global] = ACTIONS(4662),
    [anon_sym_using] = ACTIONS(4662),
    [anon_sym_static] = ACTIONS(4662),
    [anon_sym_LBRACK] = ACTIONS(4664),
    [anon_sym_event] = ACTIONS(4662),
    [anon_sym_LPAREN] = ACTIONS(4664),
    [anon_sym_abstract] = ACTIONS(4662),
    [anon_sym_async] = ACTIONS(4662),
    [anon_sym_const] = ACTIONS(4662),
    [anon_sym_fixed] = ACTIONS(4662),
    [anon_sym_internal] = ACTIONS(4662),
    [anon_sym_new] = ACTIONS(4662),
    [anon_sym_override] = ACTIONS(4662),
    [anon_sym_partial] = ACTIONS(4662),
    [anon_sym_private] = ACTIONS(4662),
    [anon_sym_protected] = ACTIONS(4662),
    [anon_sym_public] = ACTIONS(4662),
    [anon_sym_readonly] = ACTIONS(4662),
    [anon_sym_ref] = ACTIONS(4662),
    [anon_sym_sealed] = ACTIONS(4662),
    [anon_sym_unsafe] = ACTIONS(4662),
    [anon_sym_virtual] = ACTIONS(4662),
    [anon_sym_volatile] = ACTIONS(4662),
    [anon_sym_RBRACE] = ACTIONS(4664),
    [anon_sym_implicit] = ACTIONS(4662),
    [anon_sym_explicit] = ACTIONS(4662),
    [anon_sym_TILDE] = ACTIONS(4664),
    [anon_sym_where] = ACTIONS(4662),
    [anon_sym_class] = ACTIONS(4662),
    [anon_sym_struct] = ACTIONS(4662),
    [anon_sym_notnull] = ACTIONS(4662),
    [anon_sym_unmanaged] = ACTIONS(4662),
    [anon_sym_get] = ACTIONS(4662),
    [anon_sym_set] = ACTIONS(4662),
    [anon_sym_add] = ACTIONS(4662),
    [anon_sym_remove] = ACTIONS(4662),
    [anon_sym_enum] = ACTIONS(4662),
    [anon_sym_interface] = ACTIONS(4662),
    [anon_sym_delegate] = ACTIONS(4662),
    [anon_sym_record] = ACTIONS(4662),
    [anon_sym_namespace] = ACTIONS(4662),
    [anon_sym_var] = ACTIONS(4662),
    [sym_predefined_type] = ACTIONS(4662),
    [anon_sym_when] = ACTIONS(4662),
    [anon_sym_yield] = ACTIONS(4662),
    [anon_sym_from] = ACTIONS(4662),
    [anon_sym_join] = ACTIONS(4662),
    [anon_sym_on] = ACTIONS(4662),
    [anon_sym_equals] = ACTIONS(4662),
    [anon_sym_into] = ACTIONS(4662),
    [anon_sym_let] = ACTIONS(4662),
    [anon_sym_orderby] = ACTIONS(4662),
    [anon_sym_ascending] = ACTIONS(4662),
    [anon_sym_descending] = ACTIONS(4662),
    [anon_sym_group] = ACTIONS(4662),
    [anon_sym_by] = ACTIONS(4662),
    [anon_sym_select] = ACTIONS(4662),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4662),
    [anon_sym_nameof] = ACTIONS(4662),
    [sym_void_keyword] = ACTIONS(4662),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2496] = {
    [sym__preprocessor_call] = STATE(2496),
    [sym__identifier_token] = ACTIONS(4666),
    [anon_sym_extern] = ACTIONS(4666),
    [anon_sym_alias] = ACTIONS(4666),
    [anon_sym_global] = ACTIONS(4666),
    [anon_sym_using] = ACTIONS(4666),
    [anon_sym_static] = ACTIONS(4666),
    [anon_sym_LBRACK] = ACTIONS(4668),
    [anon_sym_event] = ACTIONS(4666),
    [anon_sym_LPAREN] = ACTIONS(4668),
    [anon_sym_abstract] = ACTIONS(4666),
    [anon_sym_async] = ACTIONS(4666),
    [anon_sym_const] = ACTIONS(4666),
    [anon_sym_fixed] = ACTIONS(4666),
    [anon_sym_internal] = ACTIONS(4666),
    [anon_sym_new] = ACTIONS(4666),
    [anon_sym_override] = ACTIONS(4666),
    [anon_sym_partial] = ACTIONS(4666),
    [anon_sym_private] = ACTIONS(4666),
    [anon_sym_protected] = ACTIONS(4666),
    [anon_sym_public] = ACTIONS(4666),
    [anon_sym_readonly] = ACTIONS(4666),
    [anon_sym_ref] = ACTIONS(4666),
    [anon_sym_sealed] = ACTIONS(4666),
    [anon_sym_unsafe] = ACTIONS(4666),
    [anon_sym_virtual] = ACTIONS(4666),
    [anon_sym_volatile] = ACTIONS(4666),
    [anon_sym_RBRACE] = ACTIONS(4668),
    [anon_sym_implicit] = ACTIONS(4666),
    [anon_sym_explicit] = ACTIONS(4666),
    [anon_sym_TILDE] = ACTIONS(4668),
    [anon_sym_where] = ACTIONS(4666),
    [anon_sym_class] = ACTIONS(4666),
    [anon_sym_struct] = ACTIONS(4666),
    [anon_sym_notnull] = ACTIONS(4666),
    [anon_sym_unmanaged] = ACTIONS(4666),
    [anon_sym_get] = ACTIONS(4666),
    [anon_sym_set] = ACTIONS(4666),
    [anon_sym_add] = ACTIONS(4666),
    [anon_sym_remove] = ACTIONS(4666),
    [anon_sym_enum] = ACTIONS(4666),
    [anon_sym_interface] = ACTIONS(4666),
    [anon_sym_delegate] = ACTIONS(4666),
    [anon_sym_record] = ACTIONS(4666),
    [anon_sym_namespace] = ACTIONS(4666),
    [anon_sym_var] = ACTIONS(4666),
    [sym_predefined_type] = ACTIONS(4666),
    [anon_sym_when] = ACTIONS(4666),
    [anon_sym_yield] = ACTIONS(4666),
    [anon_sym_from] = ACTIONS(4666),
    [anon_sym_join] = ACTIONS(4666),
    [anon_sym_on] = ACTIONS(4666),
    [anon_sym_equals] = ACTIONS(4666),
    [anon_sym_into] = ACTIONS(4666),
    [anon_sym_let] = ACTIONS(4666),
    [anon_sym_orderby] = ACTIONS(4666),
    [anon_sym_ascending] = ACTIONS(4666),
    [anon_sym_descending] = ACTIONS(4666),
    [anon_sym_group] = ACTIONS(4666),
    [anon_sym_by] = ACTIONS(4666),
    [anon_sym_select] = ACTIONS(4666),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4666),
    [anon_sym_nameof] = ACTIONS(4666),
    [sym_void_keyword] = ACTIONS(4666),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2497] = {
    [sym__preprocessor_call] = STATE(2497),
    [sym__identifier_token] = ACTIONS(4670),
    [anon_sym_extern] = ACTIONS(4670),
    [anon_sym_alias] = ACTIONS(4670),
    [anon_sym_global] = ACTIONS(4670),
    [anon_sym_using] = ACTIONS(4670),
    [anon_sym_static] = ACTIONS(4670),
    [anon_sym_LBRACK] = ACTIONS(4672),
    [anon_sym_event] = ACTIONS(4670),
    [anon_sym_LPAREN] = ACTIONS(4672),
    [anon_sym_abstract] = ACTIONS(4670),
    [anon_sym_async] = ACTIONS(4670),
    [anon_sym_const] = ACTIONS(4670),
    [anon_sym_fixed] = ACTIONS(4670),
    [anon_sym_internal] = ACTIONS(4670),
    [anon_sym_new] = ACTIONS(4670),
    [anon_sym_override] = ACTIONS(4670),
    [anon_sym_partial] = ACTIONS(4670),
    [anon_sym_private] = ACTIONS(4670),
    [anon_sym_protected] = ACTIONS(4670),
    [anon_sym_public] = ACTIONS(4670),
    [anon_sym_readonly] = ACTIONS(4670),
    [anon_sym_ref] = ACTIONS(4670),
    [anon_sym_sealed] = ACTIONS(4670),
    [anon_sym_unsafe] = ACTIONS(4670),
    [anon_sym_virtual] = ACTIONS(4670),
    [anon_sym_volatile] = ACTIONS(4670),
    [anon_sym_RBRACE] = ACTIONS(4672),
    [anon_sym_implicit] = ACTIONS(4670),
    [anon_sym_explicit] = ACTIONS(4670),
    [anon_sym_TILDE] = ACTIONS(4672),
    [anon_sym_where] = ACTIONS(4670),
    [anon_sym_class] = ACTIONS(4670),
    [anon_sym_struct] = ACTIONS(4670),
    [anon_sym_notnull] = ACTIONS(4670),
    [anon_sym_unmanaged] = ACTIONS(4670),
    [anon_sym_get] = ACTIONS(4670),
    [anon_sym_set] = ACTIONS(4670),
    [anon_sym_add] = ACTIONS(4670),
    [anon_sym_remove] = ACTIONS(4670),
    [anon_sym_enum] = ACTIONS(4670),
    [anon_sym_interface] = ACTIONS(4670),
    [anon_sym_delegate] = ACTIONS(4670),
    [anon_sym_record] = ACTIONS(4670),
    [anon_sym_namespace] = ACTIONS(4670),
    [anon_sym_var] = ACTIONS(4670),
    [sym_predefined_type] = ACTIONS(4670),
    [anon_sym_when] = ACTIONS(4670),
    [anon_sym_yield] = ACTIONS(4670),
    [anon_sym_from] = ACTIONS(4670),
    [anon_sym_join] = ACTIONS(4670),
    [anon_sym_on] = ACTIONS(4670),
    [anon_sym_equals] = ACTIONS(4670),
    [anon_sym_into] = ACTIONS(4670),
    [anon_sym_let] = ACTIONS(4670),
    [anon_sym_orderby] = ACTIONS(4670),
    [anon_sym_ascending] = ACTIONS(4670),
    [anon_sym_descending] = ACTIONS(4670),
    [anon_sym_group] = ACTIONS(4670),
    [anon_sym_by] = ACTIONS(4670),
    [anon_sym_select] = ACTIONS(4670),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4670),
    [anon_sym_nameof] = ACTIONS(4670),
    [sym_void_keyword] = ACTIONS(4670),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2498] = {
    [sym__preprocessor_call] = STATE(2498),
    [sym__identifier_token] = ACTIONS(4674),
    [anon_sym_extern] = ACTIONS(4674),
    [anon_sym_alias] = ACTIONS(4674),
    [anon_sym_global] = ACTIONS(4674),
    [anon_sym_using] = ACTIONS(4674),
    [anon_sym_static] = ACTIONS(4674),
    [anon_sym_LBRACK] = ACTIONS(4676),
    [anon_sym_event] = ACTIONS(4674),
    [anon_sym_LPAREN] = ACTIONS(4676),
    [anon_sym_abstract] = ACTIONS(4674),
    [anon_sym_async] = ACTIONS(4674),
    [anon_sym_const] = ACTIONS(4674),
    [anon_sym_fixed] = ACTIONS(4674),
    [anon_sym_internal] = ACTIONS(4674),
    [anon_sym_new] = ACTIONS(4674),
    [anon_sym_override] = ACTIONS(4674),
    [anon_sym_partial] = ACTIONS(4674),
    [anon_sym_private] = ACTIONS(4674),
    [anon_sym_protected] = ACTIONS(4674),
    [anon_sym_public] = ACTIONS(4674),
    [anon_sym_readonly] = ACTIONS(4674),
    [anon_sym_ref] = ACTIONS(4674),
    [anon_sym_sealed] = ACTIONS(4674),
    [anon_sym_unsafe] = ACTIONS(4674),
    [anon_sym_virtual] = ACTIONS(4674),
    [anon_sym_volatile] = ACTIONS(4674),
    [anon_sym_RBRACE] = ACTIONS(4676),
    [anon_sym_implicit] = ACTIONS(4674),
    [anon_sym_explicit] = ACTIONS(4674),
    [anon_sym_TILDE] = ACTIONS(4676),
    [anon_sym_where] = ACTIONS(4674),
    [anon_sym_class] = ACTIONS(4674),
    [anon_sym_struct] = ACTIONS(4674),
    [anon_sym_notnull] = ACTIONS(4674),
    [anon_sym_unmanaged] = ACTIONS(4674),
    [anon_sym_get] = ACTIONS(4674),
    [anon_sym_set] = ACTIONS(4674),
    [anon_sym_add] = ACTIONS(4674),
    [anon_sym_remove] = ACTIONS(4674),
    [anon_sym_enum] = ACTIONS(4674),
    [anon_sym_interface] = ACTIONS(4674),
    [anon_sym_delegate] = ACTIONS(4674),
    [anon_sym_record] = ACTIONS(4674),
    [anon_sym_namespace] = ACTIONS(4674),
    [anon_sym_var] = ACTIONS(4674),
    [sym_predefined_type] = ACTIONS(4674),
    [anon_sym_when] = ACTIONS(4674),
    [anon_sym_yield] = ACTIONS(4674),
    [anon_sym_from] = ACTIONS(4674),
    [anon_sym_join] = ACTIONS(4674),
    [anon_sym_on] = ACTIONS(4674),
    [anon_sym_equals] = ACTIONS(4674),
    [anon_sym_into] = ACTIONS(4674),
    [anon_sym_let] = ACTIONS(4674),
    [anon_sym_orderby] = ACTIONS(4674),
    [anon_sym_ascending] = ACTIONS(4674),
    [anon_sym_descending] = ACTIONS(4674),
    [anon_sym_group] = ACTIONS(4674),
    [anon_sym_by] = ACTIONS(4674),
    [anon_sym_select] = ACTIONS(4674),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4674),
    [anon_sym_nameof] = ACTIONS(4674),
    [sym_void_keyword] = ACTIONS(4674),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2499] = {
    [sym__preprocessor_call] = STATE(2499),
    [sym__identifier_token] = ACTIONS(4678),
    [anon_sym_extern] = ACTIONS(4678),
    [anon_sym_alias] = ACTIONS(4678),
    [anon_sym_global] = ACTIONS(4678),
    [anon_sym_using] = ACTIONS(4678),
    [anon_sym_static] = ACTIONS(4678),
    [anon_sym_LBRACK] = ACTIONS(4680),
    [anon_sym_event] = ACTIONS(4678),
    [anon_sym_LPAREN] = ACTIONS(4680),
    [anon_sym_abstract] = ACTIONS(4678),
    [anon_sym_async] = ACTIONS(4678),
    [anon_sym_const] = ACTIONS(4678),
    [anon_sym_fixed] = ACTIONS(4678),
    [anon_sym_internal] = ACTIONS(4678),
    [anon_sym_new] = ACTIONS(4678),
    [anon_sym_override] = ACTIONS(4678),
    [anon_sym_partial] = ACTIONS(4678),
    [anon_sym_private] = ACTIONS(4678),
    [anon_sym_protected] = ACTIONS(4678),
    [anon_sym_public] = ACTIONS(4678),
    [anon_sym_readonly] = ACTIONS(4678),
    [anon_sym_ref] = ACTIONS(4678),
    [anon_sym_sealed] = ACTIONS(4678),
    [anon_sym_unsafe] = ACTIONS(4678),
    [anon_sym_virtual] = ACTIONS(4678),
    [anon_sym_volatile] = ACTIONS(4678),
    [anon_sym_RBRACE] = ACTIONS(4680),
    [anon_sym_implicit] = ACTIONS(4678),
    [anon_sym_explicit] = ACTIONS(4678),
    [anon_sym_TILDE] = ACTIONS(4680),
    [anon_sym_where] = ACTIONS(4678),
    [anon_sym_class] = ACTIONS(4678),
    [anon_sym_struct] = ACTIONS(4678),
    [anon_sym_notnull] = ACTIONS(4678),
    [anon_sym_unmanaged] = ACTIONS(4678),
    [anon_sym_get] = ACTIONS(4678),
    [anon_sym_set] = ACTIONS(4678),
    [anon_sym_add] = ACTIONS(4678),
    [anon_sym_remove] = ACTIONS(4678),
    [anon_sym_enum] = ACTIONS(4678),
    [anon_sym_interface] = ACTIONS(4678),
    [anon_sym_delegate] = ACTIONS(4678),
    [anon_sym_record] = ACTIONS(4678),
    [anon_sym_namespace] = ACTIONS(4678),
    [anon_sym_var] = ACTIONS(4678),
    [sym_predefined_type] = ACTIONS(4678),
    [anon_sym_when] = ACTIONS(4678),
    [anon_sym_yield] = ACTIONS(4678),
    [anon_sym_from] = ACTIONS(4678),
    [anon_sym_join] = ACTIONS(4678),
    [anon_sym_on] = ACTIONS(4678),
    [anon_sym_equals] = ACTIONS(4678),
    [anon_sym_into] = ACTIONS(4678),
    [anon_sym_let] = ACTIONS(4678),
    [anon_sym_orderby] = ACTIONS(4678),
    [anon_sym_ascending] = ACTIONS(4678),
    [anon_sym_descending] = ACTIONS(4678),
    [anon_sym_group] = ACTIONS(4678),
    [anon_sym_by] = ACTIONS(4678),
    [anon_sym_select] = ACTIONS(4678),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4678),
    [anon_sym_nameof] = ACTIONS(4678),
    [sym_void_keyword] = ACTIONS(4678),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2500] = {
    [sym__preprocessor_call] = STATE(2500),
    [sym__identifier_token] = ACTIONS(4682),
    [anon_sym_extern] = ACTIONS(4682),
    [anon_sym_alias] = ACTIONS(4682),
    [anon_sym_global] = ACTIONS(4682),
    [anon_sym_using] = ACTIONS(4682),
    [anon_sym_static] = ACTIONS(4682),
    [anon_sym_LBRACK] = ACTIONS(4684),
    [anon_sym_event] = ACTIONS(4682),
    [anon_sym_LPAREN] = ACTIONS(4684),
    [anon_sym_abstract] = ACTIONS(4682),
    [anon_sym_async] = ACTIONS(4682),
    [anon_sym_const] = ACTIONS(4682),
    [anon_sym_fixed] = ACTIONS(4682),
    [anon_sym_internal] = ACTIONS(4682),
    [anon_sym_new] = ACTIONS(4682),
    [anon_sym_override] = ACTIONS(4682),
    [anon_sym_partial] = ACTIONS(4682),
    [anon_sym_private] = ACTIONS(4682),
    [anon_sym_protected] = ACTIONS(4682),
    [anon_sym_public] = ACTIONS(4682),
    [anon_sym_readonly] = ACTIONS(4682),
    [anon_sym_ref] = ACTIONS(4682),
    [anon_sym_sealed] = ACTIONS(4682),
    [anon_sym_unsafe] = ACTIONS(4682),
    [anon_sym_virtual] = ACTIONS(4682),
    [anon_sym_volatile] = ACTIONS(4682),
    [anon_sym_RBRACE] = ACTIONS(4684),
    [anon_sym_implicit] = ACTIONS(4682),
    [anon_sym_explicit] = ACTIONS(4682),
    [anon_sym_TILDE] = ACTIONS(4684),
    [anon_sym_where] = ACTIONS(4682),
    [anon_sym_class] = ACTIONS(4682),
    [anon_sym_struct] = ACTIONS(4682),
    [anon_sym_notnull] = ACTIONS(4682),
    [anon_sym_unmanaged] = ACTIONS(4682),
    [anon_sym_get] = ACTIONS(4682),
    [anon_sym_set] = ACTIONS(4682),
    [anon_sym_add] = ACTIONS(4682),
    [anon_sym_remove] = ACTIONS(4682),
    [anon_sym_enum] = ACTIONS(4682),
    [anon_sym_interface] = ACTIONS(4682),
    [anon_sym_delegate] = ACTIONS(4682),
    [anon_sym_record] = ACTIONS(4682),
    [anon_sym_namespace] = ACTIONS(4682),
    [anon_sym_var] = ACTIONS(4682),
    [sym_predefined_type] = ACTIONS(4682),
    [anon_sym_when] = ACTIONS(4682),
    [anon_sym_yield] = ACTIONS(4682),
    [anon_sym_from] = ACTIONS(4682),
    [anon_sym_join] = ACTIONS(4682),
    [anon_sym_on] = ACTIONS(4682),
    [anon_sym_equals] = ACTIONS(4682),
    [anon_sym_into] = ACTIONS(4682),
    [anon_sym_let] = ACTIONS(4682),
    [anon_sym_orderby] = ACTIONS(4682),
    [anon_sym_ascending] = ACTIONS(4682),
    [anon_sym_descending] = ACTIONS(4682),
    [anon_sym_group] = ACTIONS(4682),
    [anon_sym_by] = ACTIONS(4682),
    [anon_sym_select] = ACTIONS(4682),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4682),
    [anon_sym_nameof] = ACTIONS(4682),
    [sym_void_keyword] = ACTIONS(4682),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2501] = {
    [sym__preprocessor_call] = STATE(2501),
    [sym__identifier_token] = ACTIONS(4686),
    [anon_sym_extern] = ACTIONS(4686),
    [anon_sym_alias] = ACTIONS(4686),
    [anon_sym_global] = ACTIONS(4686),
    [anon_sym_using] = ACTIONS(4686),
    [anon_sym_static] = ACTIONS(4686),
    [anon_sym_LBRACK] = ACTIONS(4688),
    [anon_sym_event] = ACTIONS(4686),
    [anon_sym_LPAREN] = ACTIONS(4688),
    [anon_sym_abstract] = ACTIONS(4686),
    [anon_sym_async] = ACTIONS(4686),
    [anon_sym_const] = ACTIONS(4686),
    [anon_sym_fixed] = ACTIONS(4686),
    [anon_sym_internal] = ACTIONS(4686),
    [anon_sym_new] = ACTIONS(4686),
    [anon_sym_override] = ACTIONS(4686),
    [anon_sym_partial] = ACTIONS(4686),
    [anon_sym_private] = ACTIONS(4686),
    [anon_sym_protected] = ACTIONS(4686),
    [anon_sym_public] = ACTIONS(4686),
    [anon_sym_readonly] = ACTIONS(4686),
    [anon_sym_ref] = ACTIONS(4686),
    [anon_sym_sealed] = ACTIONS(4686),
    [anon_sym_unsafe] = ACTIONS(4686),
    [anon_sym_virtual] = ACTIONS(4686),
    [anon_sym_volatile] = ACTIONS(4686),
    [anon_sym_RBRACE] = ACTIONS(4688),
    [anon_sym_implicit] = ACTIONS(4686),
    [anon_sym_explicit] = ACTIONS(4686),
    [anon_sym_TILDE] = ACTIONS(4688),
    [anon_sym_where] = ACTIONS(4686),
    [anon_sym_class] = ACTIONS(4686),
    [anon_sym_struct] = ACTIONS(4686),
    [anon_sym_notnull] = ACTIONS(4686),
    [anon_sym_unmanaged] = ACTIONS(4686),
    [anon_sym_get] = ACTIONS(4686),
    [anon_sym_set] = ACTIONS(4686),
    [anon_sym_add] = ACTIONS(4686),
    [anon_sym_remove] = ACTIONS(4686),
    [anon_sym_enum] = ACTIONS(4686),
    [anon_sym_interface] = ACTIONS(4686),
    [anon_sym_delegate] = ACTIONS(4686),
    [anon_sym_record] = ACTIONS(4686),
    [anon_sym_namespace] = ACTIONS(4686),
    [anon_sym_var] = ACTIONS(4686),
    [sym_predefined_type] = ACTIONS(4686),
    [anon_sym_when] = ACTIONS(4686),
    [anon_sym_yield] = ACTIONS(4686),
    [anon_sym_from] = ACTIONS(4686),
    [anon_sym_join] = ACTIONS(4686),
    [anon_sym_on] = ACTIONS(4686),
    [anon_sym_equals] = ACTIONS(4686),
    [anon_sym_into] = ACTIONS(4686),
    [anon_sym_let] = ACTIONS(4686),
    [anon_sym_orderby] = ACTIONS(4686),
    [anon_sym_ascending] = ACTIONS(4686),
    [anon_sym_descending] = ACTIONS(4686),
    [anon_sym_group] = ACTIONS(4686),
    [anon_sym_by] = ACTIONS(4686),
    [anon_sym_select] = ACTIONS(4686),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4686),
    [anon_sym_nameof] = ACTIONS(4686),
    [sym_void_keyword] = ACTIONS(4686),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2502] = {
    [sym__preprocessor_call] = STATE(2502),
    [sym__identifier_token] = ACTIONS(4690),
    [anon_sym_extern] = ACTIONS(4690),
    [anon_sym_alias] = ACTIONS(4690),
    [anon_sym_global] = ACTIONS(4690),
    [anon_sym_using] = ACTIONS(4690),
    [anon_sym_static] = ACTIONS(4690),
    [anon_sym_LBRACK] = ACTIONS(4692),
    [anon_sym_event] = ACTIONS(4690),
    [anon_sym_LPAREN] = ACTIONS(4692),
    [anon_sym_abstract] = ACTIONS(4690),
    [anon_sym_async] = ACTIONS(4690),
    [anon_sym_const] = ACTIONS(4690),
    [anon_sym_fixed] = ACTIONS(4690),
    [anon_sym_internal] = ACTIONS(4690),
    [anon_sym_new] = ACTIONS(4690),
    [anon_sym_override] = ACTIONS(4690),
    [anon_sym_partial] = ACTIONS(4690),
    [anon_sym_private] = ACTIONS(4690),
    [anon_sym_protected] = ACTIONS(4690),
    [anon_sym_public] = ACTIONS(4690),
    [anon_sym_readonly] = ACTIONS(4690),
    [anon_sym_ref] = ACTIONS(4690),
    [anon_sym_sealed] = ACTIONS(4690),
    [anon_sym_unsafe] = ACTIONS(4690),
    [anon_sym_virtual] = ACTIONS(4690),
    [anon_sym_volatile] = ACTIONS(4690),
    [anon_sym_RBRACE] = ACTIONS(4692),
    [anon_sym_implicit] = ACTIONS(4690),
    [anon_sym_explicit] = ACTIONS(4690),
    [anon_sym_TILDE] = ACTIONS(4692),
    [anon_sym_where] = ACTIONS(4690),
    [anon_sym_class] = ACTIONS(4690),
    [anon_sym_struct] = ACTIONS(4690),
    [anon_sym_notnull] = ACTIONS(4690),
    [anon_sym_unmanaged] = ACTIONS(4690),
    [anon_sym_get] = ACTIONS(4690),
    [anon_sym_set] = ACTIONS(4690),
    [anon_sym_add] = ACTIONS(4690),
    [anon_sym_remove] = ACTIONS(4690),
    [anon_sym_enum] = ACTIONS(4690),
    [anon_sym_interface] = ACTIONS(4690),
    [anon_sym_delegate] = ACTIONS(4690),
    [anon_sym_record] = ACTIONS(4690),
    [anon_sym_namespace] = ACTIONS(4690),
    [anon_sym_var] = ACTIONS(4690),
    [sym_predefined_type] = ACTIONS(4690),
    [anon_sym_when] = ACTIONS(4690),
    [anon_sym_yield] = ACTIONS(4690),
    [anon_sym_from] = ACTIONS(4690),
    [anon_sym_join] = ACTIONS(4690),
    [anon_sym_on] = ACTIONS(4690),
    [anon_sym_equals] = ACTIONS(4690),
    [anon_sym_into] = ACTIONS(4690),
    [anon_sym_let] = ACTIONS(4690),
    [anon_sym_orderby] = ACTIONS(4690),
    [anon_sym_ascending] = ACTIONS(4690),
    [anon_sym_descending] = ACTIONS(4690),
    [anon_sym_group] = ACTIONS(4690),
    [anon_sym_by] = ACTIONS(4690),
    [anon_sym_select] = ACTIONS(4690),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4690),
    [anon_sym_nameof] = ACTIONS(4690),
    [sym_void_keyword] = ACTIONS(4690),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2503] = {
    [sym__preprocessor_call] = STATE(2503),
    [sym__identifier_token] = ACTIONS(4694),
    [anon_sym_extern] = ACTIONS(4694),
    [anon_sym_alias] = ACTIONS(4694),
    [anon_sym_global] = ACTIONS(4694),
    [anon_sym_using] = ACTIONS(4694),
    [anon_sym_static] = ACTIONS(4694),
    [anon_sym_LBRACK] = ACTIONS(4696),
    [anon_sym_event] = ACTIONS(4694),
    [anon_sym_LPAREN] = ACTIONS(4696),
    [anon_sym_abstract] = ACTIONS(4694),
    [anon_sym_async] = ACTIONS(4694),
    [anon_sym_const] = ACTIONS(4694),
    [anon_sym_fixed] = ACTIONS(4694),
    [anon_sym_internal] = ACTIONS(4694),
    [anon_sym_new] = ACTIONS(4694),
    [anon_sym_override] = ACTIONS(4694),
    [anon_sym_partial] = ACTIONS(4694),
    [anon_sym_private] = ACTIONS(4694),
    [anon_sym_protected] = ACTIONS(4694),
    [anon_sym_public] = ACTIONS(4694),
    [anon_sym_readonly] = ACTIONS(4694),
    [anon_sym_ref] = ACTIONS(4694),
    [anon_sym_sealed] = ACTIONS(4694),
    [anon_sym_unsafe] = ACTIONS(4694),
    [anon_sym_virtual] = ACTIONS(4694),
    [anon_sym_volatile] = ACTIONS(4694),
    [anon_sym_RBRACE] = ACTIONS(4696),
    [anon_sym_implicit] = ACTIONS(4694),
    [anon_sym_explicit] = ACTIONS(4694),
    [anon_sym_TILDE] = ACTIONS(4696),
    [anon_sym_where] = ACTIONS(4694),
    [anon_sym_class] = ACTIONS(4694),
    [anon_sym_struct] = ACTIONS(4694),
    [anon_sym_notnull] = ACTIONS(4694),
    [anon_sym_unmanaged] = ACTIONS(4694),
    [anon_sym_get] = ACTIONS(4694),
    [anon_sym_set] = ACTIONS(4694),
    [anon_sym_add] = ACTIONS(4694),
    [anon_sym_remove] = ACTIONS(4694),
    [anon_sym_enum] = ACTIONS(4694),
    [anon_sym_interface] = ACTIONS(4694),
    [anon_sym_delegate] = ACTIONS(4694),
    [anon_sym_record] = ACTIONS(4694),
    [anon_sym_namespace] = ACTIONS(4694),
    [anon_sym_var] = ACTIONS(4694),
    [sym_predefined_type] = ACTIONS(4694),
    [anon_sym_when] = ACTIONS(4694),
    [anon_sym_yield] = ACTIONS(4694),
    [anon_sym_from] = ACTIONS(4694),
    [anon_sym_join] = ACTIONS(4694),
    [anon_sym_on] = ACTIONS(4694),
    [anon_sym_equals] = ACTIONS(4694),
    [anon_sym_into] = ACTIONS(4694),
    [anon_sym_let] = ACTIONS(4694),
    [anon_sym_orderby] = ACTIONS(4694),
    [anon_sym_ascending] = ACTIONS(4694),
    [anon_sym_descending] = ACTIONS(4694),
    [anon_sym_group] = ACTIONS(4694),
    [anon_sym_by] = ACTIONS(4694),
    [anon_sym_select] = ACTIONS(4694),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4694),
    [anon_sym_nameof] = ACTIONS(4694),
    [sym_void_keyword] = ACTIONS(4694),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2504] = {
    [sym__preprocessor_call] = STATE(2504),
    [sym__identifier_token] = ACTIONS(4698),
    [anon_sym_extern] = ACTIONS(4698),
    [anon_sym_alias] = ACTIONS(4698),
    [anon_sym_global] = ACTIONS(4698),
    [anon_sym_using] = ACTIONS(4698),
    [anon_sym_static] = ACTIONS(4698),
    [anon_sym_LBRACK] = ACTIONS(4700),
    [anon_sym_event] = ACTIONS(4698),
    [anon_sym_LPAREN] = ACTIONS(4700),
    [anon_sym_abstract] = ACTIONS(4698),
    [anon_sym_async] = ACTIONS(4698),
    [anon_sym_const] = ACTIONS(4698),
    [anon_sym_fixed] = ACTIONS(4698),
    [anon_sym_internal] = ACTIONS(4698),
    [anon_sym_new] = ACTIONS(4698),
    [anon_sym_override] = ACTIONS(4698),
    [anon_sym_partial] = ACTIONS(4698),
    [anon_sym_private] = ACTIONS(4698),
    [anon_sym_protected] = ACTIONS(4698),
    [anon_sym_public] = ACTIONS(4698),
    [anon_sym_readonly] = ACTIONS(4698),
    [anon_sym_ref] = ACTIONS(4698),
    [anon_sym_sealed] = ACTIONS(4698),
    [anon_sym_unsafe] = ACTIONS(4698),
    [anon_sym_virtual] = ACTIONS(4698),
    [anon_sym_volatile] = ACTIONS(4698),
    [anon_sym_RBRACE] = ACTIONS(4700),
    [anon_sym_implicit] = ACTIONS(4698),
    [anon_sym_explicit] = ACTIONS(4698),
    [anon_sym_TILDE] = ACTIONS(4700),
    [anon_sym_where] = ACTIONS(4698),
    [anon_sym_class] = ACTIONS(4698),
    [anon_sym_struct] = ACTIONS(4698),
    [anon_sym_notnull] = ACTIONS(4698),
    [anon_sym_unmanaged] = ACTIONS(4698),
    [anon_sym_get] = ACTIONS(4698),
    [anon_sym_set] = ACTIONS(4698),
    [anon_sym_add] = ACTIONS(4698),
    [anon_sym_remove] = ACTIONS(4698),
    [anon_sym_enum] = ACTIONS(4698),
    [anon_sym_interface] = ACTIONS(4698),
    [anon_sym_delegate] = ACTIONS(4698),
    [anon_sym_record] = ACTIONS(4698),
    [anon_sym_namespace] = ACTIONS(4698),
    [anon_sym_var] = ACTIONS(4698),
    [sym_predefined_type] = ACTIONS(4698),
    [anon_sym_when] = ACTIONS(4698),
    [anon_sym_yield] = ACTIONS(4698),
    [anon_sym_from] = ACTIONS(4698),
    [anon_sym_join] = ACTIONS(4698),
    [anon_sym_on] = ACTIONS(4698),
    [anon_sym_equals] = ACTIONS(4698),
    [anon_sym_into] = ACTIONS(4698),
    [anon_sym_let] = ACTIONS(4698),
    [anon_sym_orderby] = ACTIONS(4698),
    [anon_sym_ascending] = ACTIONS(4698),
    [anon_sym_descending] = ACTIONS(4698),
    [anon_sym_group] = ACTIONS(4698),
    [anon_sym_by] = ACTIONS(4698),
    [anon_sym_select] = ACTIONS(4698),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4698),
    [anon_sym_nameof] = ACTIONS(4698),
    [sym_void_keyword] = ACTIONS(4698),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2505] = {
    [sym__preprocessor_call] = STATE(2505),
    [sym__identifier_token] = ACTIONS(4702),
    [anon_sym_extern] = ACTIONS(4702),
    [anon_sym_alias] = ACTIONS(4702),
    [anon_sym_global] = ACTIONS(4702),
    [anon_sym_using] = ACTIONS(4702),
    [anon_sym_static] = ACTIONS(4702),
    [anon_sym_LBRACK] = ACTIONS(4704),
    [anon_sym_event] = ACTIONS(4702),
    [anon_sym_LPAREN] = ACTIONS(4704),
    [anon_sym_abstract] = ACTIONS(4702),
    [anon_sym_async] = ACTIONS(4702),
    [anon_sym_const] = ACTIONS(4702),
    [anon_sym_fixed] = ACTIONS(4702),
    [anon_sym_internal] = ACTIONS(4702),
    [anon_sym_new] = ACTIONS(4702),
    [anon_sym_override] = ACTIONS(4702),
    [anon_sym_partial] = ACTIONS(4702),
    [anon_sym_private] = ACTIONS(4702),
    [anon_sym_protected] = ACTIONS(4702),
    [anon_sym_public] = ACTIONS(4702),
    [anon_sym_readonly] = ACTIONS(4702),
    [anon_sym_ref] = ACTIONS(4702),
    [anon_sym_sealed] = ACTIONS(4702),
    [anon_sym_unsafe] = ACTIONS(4702),
    [anon_sym_virtual] = ACTIONS(4702),
    [anon_sym_volatile] = ACTIONS(4702),
    [anon_sym_RBRACE] = ACTIONS(4704),
    [anon_sym_implicit] = ACTIONS(4702),
    [anon_sym_explicit] = ACTIONS(4702),
    [anon_sym_TILDE] = ACTIONS(4704),
    [anon_sym_where] = ACTIONS(4702),
    [anon_sym_class] = ACTIONS(4702),
    [anon_sym_struct] = ACTIONS(4702),
    [anon_sym_notnull] = ACTIONS(4702),
    [anon_sym_unmanaged] = ACTIONS(4702),
    [anon_sym_get] = ACTIONS(4702),
    [anon_sym_set] = ACTIONS(4702),
    [anon_sym_add] = ACTIONS(4702),
    [anon_sym_remove] = ACTIONS(4702),
    [anon_sym_enum] = ACTIONS(4702),
    [anon_sym_interface] = ACTIONS(4702),
    [anon_sym_delegate] = ACTIONS(4702),
    [anon_sym_record] = ACTIONS(4702),
    [anon_sym_namespace] = ACTIONS(4702),
    [anon_sym_var] = ACTIONS(4702),
    [sym_predefined_type] = ACTIONS(4702),
    [anon_sym_when] = ACTIONS(4702),
    [anon_sym_yield] = ACTIONS(4702),
    [anon_sym_from] = ACTIONS(4702),
    [anon_sym_join] = ACTIONS(4702),
    [anon_sym_on] = ACTIONS(4702),
    [anon_sym_equals] = ACTIONS(4702),
    [anon_sym_into] = ACTIONS(4702),
    [anon_sym_let] = ACTIONS(4702),
    [anon_sym_orderby] = ACTIONS(4702),
    [anon_sym_ascending] = ACTIONS(4702),
    [anon_sym_descending] = ACTIONS(4702),
    [anon_sym_group] = ACTIONS(4702),
    [anon_sym_by] = ACTIONS(4702),
    [anon_sym_select] = ACTIONS(4702),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4702),
    [anon_sym_nameof] = ACTIONS(4702),
    [sym_void_keyword] = ACTIONS(4702),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2506] = {
    [sym__preprocessor_call] = STATE(2506),
    [sym__identifier_token] = ACTIONS(4706),
    [anon_sym_extern] = ACTIONS(4706),
    [anon_sym_alias] = ACTIONS(4706),
    [anon_sym_global] = ACTIONS(4706),
    [anon_sym_using] = ACTIONS(4706),
    [anon_sym_static] = ACTIONS(4706),
    [anon_sym_LBRACK] = ACTIONS(4708),
    [anon_sym_event] = ACTIONS(4706),
    [anon_sym_LPAREN] = ACTIONS(4708),
    [anon_sym_abstract] = ACTIONS(4706),
    [anon_sym_async] = ACTIONS(4706),
    [anon_sym_const] = ACTIONS(4706),
    [anon_sym_fixed] = ACTIONS(4706),
    [anon_sym_internal] = ACTIONS(4706),
    [anon_sym_new] = ACTIONS(4706),
    [anon_sym_override] = ACTIONS(4706),
    [anon_sym_partial] = ACTIONS(4706),
    [anon_sym_private] = ACTIONS(4706),
    [anon_sym_protected] = ACTIONS(4706),
    [anon_sym_public] = ACTIONS(4706),
    [anon_sym_readonly] = ACTIONS(4706),
    [anon_sym_ref] = ACTIONS(4706),
    [anon_sym_sealed] = ACTIONS(4706),
    [anon_sym_unsafe] = ACTIONS(4706),
    [anon_sym_virtual] = ACTIONS(4706),
    [anon_sym_volatile] = ACTIONS(4706),
    [anon_sym_RBRACE] = ACTIONS(4708),
    [anon_sym_implicit] = ACTIONS(4706),
    [anon_sym_explicit] = ACTIONS(4706),
    [anon_sym_TILDE] = ACTIONS(4708),
    [anon_sym_where] = ACTIONS(4706),
    [anon_sym_class] = ACTIONS(4706),
    [anon_sym_struct] = ACTIONS(4706),
    [anon_sym_notnull] = ACTIONS(4706),
    [anon_sym_unmanaged] = ACTIONS(4706),
    [anon_sym_get] = ACTIONS(4706),
    [anon_sym_set] = ACTIONS(4706),
    [anon_sym_add] = ACTIONS(4706),
    [anon_sym_remove] = ACTIONS(4706),
    [anon_sym_enum] = ACTIONS(4706),
    [anon_sym_interface] = ACTIONS(4706),
    [anon_sym_delegate] = ACTIONS(4706),
    [anon_sym_record] = ACTIONS(4706),
    [anon_sym_namespace] = ACTIONS(4706),
    [anon_sym_var] = ACTIONS(4706),
    [sym_predefined_type] = ACTIONS(4706),
    [anon_sym_when] = ACTIONS(4706),
    [anon_sym_yield] = ACTIONS(4706),
    [anon_sym_from] = ACTIONS(4706),
    [anon_sym_join] = ACTIONS(4706),
    [anon_sym_on] = ACTIONS(4706),
    [anon_sym_equals] = ACTIONS(4706),
    [anon_sym_into] = ACTIONS(4706),
    [anon_sym_let] = ACTIONS(4706),
    [anon_sym_orderby] = ACTIONS(4706),
    [anon_sym_ascending] = ACTIONS(4706),
    [anon_sym_descending] = ACTIONS(4706),
    [anon_sym_group] = ACTIONS(4706),
    [anon_sym_by] = ACTIONS(4706),
    [anon_sym_select] = ACTIONS(4706),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4706),
    [anon_sym_nameof] = ACTIONS(4706),
    [sym_void_keyword] = ACTIONS(4706),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2507] = {
    [sym__preprocessor_call] = STATE(2507),
    [sym__identifier_token] = ACTIONS(4710),
    [anon_sym_extern] = ACTIONS(4710),
    [anon_sym_alias] = ACTIONS(4710),
    [anon_sym_global] = ACTIONS(4710),
    [anon_sym_using] = ACTIONS(4710),
    [anon_sym_static] = ACTIONS(4710),
    [anon_sym_LBRACK] = ACTIONS(4712),
    [anon_sym_event] = ACTIONS(4710),
    [anon_sym_LPAREN] = ACTIONS(4712),
    [anon_sym_abstract] = ACTIONS(4710),
    [anon_sym_async] = ACTIONS(4710),
    [anon_sym_const] = ACTIONS(4710),
    [anon_sym_fixed] = ACTIONS(4710),
    [anon_sym_internal] = ACTIONS(4710),
    [anon_sym_new] = ACTIONS(4710),
    [anon_sym_override] = ACTIONS(4710),
    [anon_sym_partial] = ACTIONS(4710),
    [anon_sym_private] = ACTIONS(4710),
    [anon_sym_protected] = ACTIONS(4710),
    [anon_sym_public] = ACTIONS(4710),
    [anon_sym_readonly] = ACTIONS(4710),
    [anon_sym_ref] = ACTIONS(4710),
    [anon_sym_sealed] = ACTIONS(4710),
    [anon_sym_unsafe] = ACTIONS(4710),
    [anon_sym_virtual] = ACTIONS(4710),
    [anon_sym_volatile] = ACTIONS(4710),
    [anon_sym_RBRACE] = ACTIONS(4712),
    [anon_sym_implicit] = ACTIONS(4710),
    [anon_sym_explicit] = ACTIONS(4710),
    [anon_sym_TILDE] = ACTIONS(4712),
    [anon_sym_where] = ACTIONS(4710),
    [anon_sym_class] = ACTIONS(4710),
    [anon_sym_struct] = ACTIONS(4710),
    [anon_sym_notnull] = ACTIONS(4710),
    [anon_sym_unmanaged] = ACTIONS(4710),
    [anon_sym_get] = ACTIONS(4710),
    [anon_sym_set] = ACTIONS(4710),
    [anon_sym_add] = ACTIONS(4710),
    [anon_sym_remove] = ACTIONS(4710),
    [anon_sym_enum] = ACTIONS(4710),
    [anon_sym_interface] = ACTIONS(4710),
    [anon_sym_delegate] = ACTIONS(4710),
    [anon_sym_record] = ACTIONS(4710),
    [anon_sym_namespace] = ACTIONS(4710),
    [anon_sym_var] = ACTIONS(4710),
    [sym_predefined_type] = ACTIONS(4710),
    [anon_sym_when] = ACTIONS(4710),
    [anon_sym_yield] = ACTIONS(4710),
    [anon_sym_from] = ACTIONS(4710),
    [anon_sym_join] = ACTIONS(4710),
    [anon_sym_on] = ACTIONS(4710),
    [anon_sym_equals] = ACTIONS(4710),
    [anon_sym_into] = ACTIONS(4710),
    [anon_sym_let] = ACTIONS(4710),
    [anon_sym_orderby] = ACTIONS(4710),
    [anon_sym_ascending] = ACTIONS(4710),
    [anon_sym_descending] = ACTIONS(4710),
    [anon_sym_group] = ACTIONS(4710),
    [anon_sym_by] = ACTIONS(4710),
    [anon_sym_select] = ACTIONS(4710),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4710),
    [anon_sym_nameof] = ACTIONS(4710),
    [sym_void_keyword] = ACTIONS(4710),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2508] = {
    [sym__preprocessor_call] = STATE(2508),
    [sym__identifier_token] = ACTIONS(4714),
    [anon_sym_extern] = ACTIONS(4714),
    [anon_sym_alias] = ACTIONS(4714),
    [anon_sym_global] = ACTIONS(4714),
    [anon_sym_using] = ACTIONS(4714),
    [anon_sym_static] = ACTIONS(4714),
    [anon_sym_LBRACK] = ACTIONS(4716),
    [anon_sym_event] = ACTIONS(4714),
    [anon_sym_LPAREN] = ACTIONS(4716),
    [anon_sym_abstract] = ACTIONS(4714),
    [anon_sym_async] = ACTIONS(4714),
    [anon_sym_const] = ACTIONS(4714),
    [anon_sym_fixed] = ACTIONS(4714),
    [anon_sym_internal] = ACTIONS(4714),
    [anon_sym_new] = ACTIONS(4714),
    [anon_sym_override] = ACTIONS(4714),
    [anon_sym_partial] = ACTIONS(4714),
    [anon_sym_private] = ACTIONS(4714),
    [anon_sym_protected] = ACTIONS(4714),
    [anon_sym_public] = ACTIONS(4714),
    [anon_sym_readonly] = ACTIONS(4714),
    [anon_sym_ref] = ACTIONS(4714),
    [anon_sym_sealed] = ACTIONS(4714),
    [anon_sym_unsafe] = ACTIONS(4714),
    [anon_sym_virtual] = ACTIONS(4714),
    [anon_sym_volatile] = ACTIONS(4714),
    [anon_sym_RBRACE] = ACTIONS(4716),
    [anon_sym_implicit] = ACTIONS(4714),
    [anon_sym_explicit] = ACTIONS(4714),
    [anon_sym_TILDE] = ACTIONS(4716),
    [anon_sym_where] = ACTIONS(4714),
    [anon_sym_class] = ACTIONS(4714),
    [anon_sym_struct] = ACTIONS(4714),
    [anon_sym_notnull] = ACTIONS(4714),
    [anon_sym_unmanaged] = ACTIONS(4714),
    [anon_sym_get] = ACTIONS(4714),
    [anon_sym_set] = ACTIONS(4714),
    [anon_sym_add] = ACTIONS(4714),
    [anon_sym_remove] = ACTIONS(4714),
    [anon_sym_enum] = ACTIONS(4714),
    [anon_sym_interface] = ACTIONS(4714),
    [anon_sym_delegate] = ACTIONS(4714),
    [anon_sym_record] = ACTIONS(4714),
    [anon_sym_namespace] = ACTIONS(4714),
    [anon_sym_var] = ACTIONS(4714),
    [sym_predefined_type] = ACTIONS(4714),
    [anon_sym_when] = ACTIONS(4714),
    [anon_sym_yield] = ACTIONS(4714),
    [anon_sym_from] = ACTIONS(4714),
    [anon_sym_join] = ACTIONS(4714),
    [anon_sym_on] = ACTIONS(4714),
    [anon_sym_equals] = ACTIONS(4714),
    [anon_sym_into] = ACTIONS(4714),
    [anon_sym_let] = ACTIONS(4714),
    [anon_sym_orderby] = ACTIONS(4714),
    [anon_sym_ascending] = ACTIONS(4714),
    [anon_sym_descending] = ACTIONS(4714),
    [anon_sym_group] = ACTIONS(4714),
    [anon_sym_by] = ACTIONS(4714),
    [anon_sym_select] = ACTIONS(4714),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4714),
    [anon_sym_nameof] = ACTIONS(4714),
    [sym_void_keyword] = ACTIONS(4714),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2509] = {
    [sym__preprocessor_call] = STATE(2509),
    [sym__identifier_token] = ACTIONS(4718),
    [anon_sym_extern] = ACTIONS(4718),
    [anon_sym_alias] = ACTIONS(4718),
    [anon_sym_global] = ACTIONS(4718),
    [anon_sym_using] = ACTIONS(4718),
    [anon_sym_static] = ACTIONS(4718),
    [anon_sym_LBRACK] = ACTIONS(4720),
    [anon_sym_event] = ACTIONS(4718),
    [anon_sym_LPAREN] = ACTIONS(4720),
    [anon_sym_abstract] = ACTIONS(4718),
    [anon_sym_async] = ACTIONS(4718),
    [anon_sym_const] = ACTIONS(4718),
    [anon_sym_fixed] = ACTIONS(4718),
    [anon_sym_internal] = ACTIONS(4718),
    [anon_sym_new] = ACTIONS(4718),
    [anon_sym_override] = ACTIONS(4718),
    [anon_sym_partial] = ACTIONS(4718),
    [anon_sym_private] = ACTIONS(4718),
    [anon_sym_protected] = ACTIONS(4718),
    [anon_sym_public] = ACTIONS(4718),
    [anon_sym_readonly] = ACTIONS(4718),
    [anon_sym_ref] = ACTIONS(4718),
    [anon_sym_sealed] = ACTIONS(4718),
    [anon_sym_unsafe] = ACTIONS(4718),
    [anon_sym_virtual] = ACTIONS(4718),
    [anon_sym_volatile] = ACTIONS(4718),
    [anon_sym_RBRACE] = ACTIONS(4720),
    [anon_sym_implicit] = ACTIONS(4718),
    [anon_sym_explicit] = ACTIONS(4718),
    [anon_sym_TILDE] = ACTIONS(4720),
    [anon_sym_where] = ACTIONS(4718),
    [anon_sym_class] = ACTIONS(4718),
    [anon_sym_struct] = ACTIONS(4718),
    [anon_sym_notnull] = ACTIONS(4718),
    [anon_sym_unmanaged] = ACTIONS(4718),
    [anon_sym_get] = ACTIONS(4718),
    [anon_sym_set] = ACTIONS(4718),
    [anon_sym_add] = ACTIONS(4718),
    [anon_sym_remove] = ACTIONS(4718),
    [anon_sym_enum] = ACTIONS(4718),
    [anon_sym_interface] = ACTIONS(4718),
    [anon_sym_delegate] = ACTIONS(4718),
    [anon_sym_record] = ACTIONS(4718),
    [anon_sym_namespace] = ACTIONS(4718),
    [anon_sym_var] = ACTIONS(4718),
    [sym_predefined_type] = ACTIONS(4718),
    [anon_sym_when] = ACTIONS(4718),
    [anon_sym_yield] = ACTIONS(4718),
    [anon_sym_from] = ACTIONS(4718),
    [anon_sym_join] = ACTIONS(4718),
    [anon_sym_on] = ACTIONS(4718),
    [anon_sym_equals] = ACTIONS(4718),
    [anon_sym_into] = ACTIONS(4718),
    [anon_sym_let] = ACTIONS(4718),
    [anon_sym_orderby] = ACTIONS(4718),
    [anon_sym_ascending] = ACTIONS(4718),
    [anon_sym_descending] = ACTIONS(4718),
    [anon_sym_group] = ACTIONS(4718),
    [anon_sym_by] = ACTIONS(4718),
    [anon_sym_select] = ACTIONS(4718),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4718),
    [anon_sym_nameof] = ACTIONS(4718),
    [sym_void_keyword] = ACTIONS(4718),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2510] = {
    [sym__preprocessor_call] = STATE(2510),
    [sym__identifier_token] = ACTIONS(4722),
    [anon_sym_extern] = ACTIONS(4722),
    [anon_sym_alias] = ACTIONS(4722),
    [anon_sym_global] = ACTIONS(4722),
    [anon_sym_using] = ACTIONS(4722),
    [anon_sym_static] = ACTIONS(4722),
    [anon_sym_LBRACK] = ACTIONS(4724),
    [anon_sym_event] = ACTIONS(4722),
    [anon_sym_LPAREN] = ACTIONS(4724),
    [anon_sym_abstract] = ACTIONS(4722),
    [anon_sym_async] = ACTIONS(4722),
    [anon_sym_const] = ACTIONS(4722),
    [anon_sym_fixed] = ACTIONS(4722),
    [anon_sym_internal] = ACTIONS(4722),
    [anon_sym_new] = ACTIONS(4722),
    [anon_sym_override] = ACTIONS(4722),
    [anon_sym_partial] = ACTIONS(4722),
    [anon_sym_private] = ACTIONS(4722),
    [anon_sym_protected] = ACTIONS(4722),
    [anon_sym_public] = ACTIONS(4722),
    [anon_sym_readonly] = ACTIONS(4722),
    [anon_sym_ref] = ACTIONS(4722),
    [anon_sym_sealed] = ACTIONS(4722),
    [anon_sym_unsafe] = ACTIONS(4722),
    [anon_sym_virtual] = ACTIONS(4722),
    [anon_sym_volatile] = ACTIONS(4722),
    [anon_sym_RBRACE] = ACTIONS(4724),
    [anon_sym_implicit] = ACTIONS(4722),
    [anon_sym_explicit] = ACTIONS(4722),
    [anon_sym_TILDE] = ACTIONS(4724),
    [anon_sym_where] = ACTIONS(4722),
    [anon_sym_class] = ACTIONS(4722),
    [anon_sym_struct] = ACTIONS(4722),
    [anon_sym_notnull] = ACTIONS(4722),
    [anon_sym_unmanaged] = ACTIONS(4722),
    [anon_sym_get] = ACTIONS(4722),
    [anon_sym_set] = ACTIONS(4722),
    [anon_sym_add] = ACTIONS(4722),
    [anon_sym_remove] = ACTIONS(4722),
    [anon_sym_enum] = ACTIONS(4722),
    [anon_sym_interface] = ACTIONS(4722),
    [anon_sym_delegate] = ACTIONS(4722),
    [anon_sym_record] = ACTIONS(4722),
    [anon_sym_namespace] = ACTIONS(4722),
    [anon_sym_var] = ACTIONS(4722),
    [sym_predefined_type] = ACTIONS(4722),
    [anon_sym_when] = ACTIONS(4722),
    [anon_sym_yield] = ACTIONS(4722),
    [anon_sym_from] = ACTIONS(4722),
    [anon_sym_join] = ACTIONS(4722),
    [anon_sym_on] = ACTIONS(4722),
    [anon_sym_equals] = ACTIONS(4722),
    [anon_sym_into] = ACTIONS(4722),
    [anon_sym_let] = ACTIONS(4722),
    [anon_sym_orderby] = ACTIONS(4722),
    [anon_sym_ascending] = ACTIONS(4722),
    [anon_sym_descending] = ACTIONS(4722),
    [anon_sym_group] = ACTIONS(4722),
    [anon_sym_by] = ACTIONS(4722),
    [anon_sym_select] = ACTIONS(4722),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4722),
    [anon_sym_nameof] = ACTIONS(4722),
    [sym_void_keyword] = ACTIONS(4722),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2511] = {
    [sym__preprocessor_call] = STATE(2511),
    [sym__identifier_token] = ACTIONS(4726),
    [anon_sym_extern] = ACTIONS(4726),
    [anon_sym_alias] = ACTIONS(4726),
    [anon_sym_global] = ACTIONS(4726),
    [anon_sym_using] = ACTIONS(4726),
    [anon_sym_static] = ACTIONS(4726),
    [anon_sym_LBRACK] = ACTIONS(4728),
    [anon_sym_event] = ACTIONS(4726),
    [anon_sym_LPAREN] = ACTIONS(4728),
    [anon_sym_abstract] = ACTIONS(4726),
    [anon_sym_async] = ACTIONS(4726),
    [anon_sym_const] = ACTIONS(4726),
    [anon_sym_fixed] = ACTIONS(4726),
    [anon_sym_internal] = ACTIONS(4726),
    [anon_sym_new] = ACTIONS(4726),
    [anon_sym_override] = ACTIONS(4726),
    [anon_sym_partial] = ACTIONS(4726),
    [anon_sym_private] = ACTIONS(4726),
    [anon_sym_protected] = ACTIONS(4726),
    [anon_sym_public] = ACTIONS(4726),
    [anon_sym_readonly] = ACTIONS(4726),
    [anon_sym_ref] = ACTIONS(4726),
    [anon_sym_sealed] = ACTIONS(4726),
    [anon_sym_unsafe] = ACTIONS(4726),
    [anon_sym_virtual] = ACTIONS(4726),
    [anon_sym_volatile] = ACTIONS(4726),
    [anon_sym_RBRACE] = ACTIONS(4728),
    [anon_sym_implicit] = ACTIONS(4726),
    [anon_sym_explicit] = ACTIONS(4726),
    [anon_sym_TILDE] = ACTIONS(4728),
    [anon_sym_where] = ACTIONS(4726),
    [anon_sym_class] = ACTIONS(4726),
    [anon_sym_struct] = ACTIONS(4726),
    [anon_sym_notnull] = ACTIONS(4726),
    [anon_sym_unmanaged] = ACTIONS(4726),
    [anon_sym_get] = ACTIONS(4726),
    [anon_sym_set] = ACTIONS(4726),
    [anon_sym_add] = ACTIONS(4726),
    [anon_sym_remove] = ACTIONS(4726),
    [anon_sym_enum] = ACTIONS(4726),
    [anon_sym_interface] = ACTIONS(4726),
    [anon_sym_delegate] = ACTIONS(4726),
    [anon_sym_record] = ACTIONS(4726),
    [anon_sym_namespace] = ACTIONS(4726),
    [anon_sym_var] = ACTIONS(4726),
    [sym_predefined_type] = ACTIONS(4726),
    [anon_sym_when] = ACTIONS(4726),
    [anon_sym_yield] = ACTIONS(4726),
    [anon_sym_from] = ACTIONS(4726),
    [anon_sym_join] = ACTIONS(4726),
    [anon_sym_on] = ACTIONS(4726),
    [anon_sym_equals] = ACTIONS(4726),
    [anon_sym_into] = ACTIONS(4726),
    [anon_sym_let] = ACTIONS(4726),
    [anon_sym_orderby] = ACTIONS(4726),
    [anon_sym_ascending] = ACTIONS(4726),
    [anon_sym_descending] = ACTIONS(4726),
    [anon_sym_group] = ACTIONS(4726),
    [anon_sym_by] = ACTIONS(4726),
    [anon_sym_select] = ACTIONS(4726),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4726),
    [anon_sym_nameof] = ACTIONS(4726),
    [sym_void_keyword] = ACTIONS(4726),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2512] = {
    [sym__preprocessor_call] = STATE(2512),
    [sym__identifier_token] = ACTIONS(4730),
    [anon_sym_extern] = ACTIONS(4730),
    [anon_sym_alias] = ACTIONS(4730),
    [anon_sym_global] = ACTIONS(4730),
    [anon_sym_using] = ACTIONS(4730),
    [anon_sym_static] = ACTIONS(4730),
    [anon_sym_LBRACK] = ACTIONS(4732),
    [anon_sym_event] = ACTIONS(4730),
    [anon_sym_LPAREN] = ACTIONS(4732),
    [anon_sym_abstract] = ACTIONS(4730),
    [anon_sym_async] = ACTIONS(4730),
    [anon_sym_const] = ACTIONS(4730),
    [anon_sym_fixed] = ACTIONS(4730),
    [anon_sym_internal] = ACTIONS(4730),
    [anon_sym_new] = ACTIONS(4730),
    [anon_sym_override] = ACTIONS(4730),
    [anon_sym_partial] = ACTIONS(4730),
    [anon_sym_private] = ACTIONS(4730),
    [anon_sym_protected] = ACTIONS(4730),
    [anon_sym_public] = ACTIONS(4730),
    [anon_sym_readonly] = ACTIONS(4730),
    [anon_sym_ref] = ACTIONS(4730),
    [anon_sym_sealed] = ACTIONS(4730),
    [anon_sym_unsafe] = ACTIONS(4730),
    [anon_sym_virtual] = ACTIONS(4730),
    [anon_sym_volatile] = ACTIONS(4730),
    [anon_sym_RBRACE] = ACTIONS(4732),
    [anon_sym_implicit] = ACTIONS(4730),
    [anon_sym_explicit] = ACTIONS(4730),
    [anon_sym_TILDE] = ACTIONS(4732),
    [anon_sym_where] = ACTIONS(4730),
    [anon_sym_class] = ACTIONS(4730),
    [anon_sym_struct] = ACTIONS(4730),
    [anon_sym_notnull] = ACTIONS(4730),
    [anon_sym_unmanaged] = ACTIONS(4730),
    [anon_sym_get] = ACTIONS(4730),
    [anon_sym_set] = ACTIONS(4730),
    [anon_sym_add] = ACTIONS(4730),
    [anon_sym_remove] = ACTIONS(4730),
    [anon_sym_enum] = ACTIONS(4730),
    [anon_sym_interface] = ACTIONS(4730),
    [anon_sym_delegate] = ACTIONS(4730),
    [anon_sym_record] = ACTIONS(4730),
    [anon_sym_namespace] = ACTIONS(4730),
    [anon_sym_var] = ACTIONS(4730),
    [sym_predefined_type] = ACTIONS(4730),
    [anon_sym_when] = ACTIONS(4730),
    [anon_sym_yield] = ACTIONS(4730),
    [anon_sym_from] = ACTIONS(4730),
    [anon_sym_join] = ACTIONS(4730),
    [anon_sym_on] = ACTIONS(4730),
    [anon_sym_equals] = ACTIONS(4730),
    [anon_sym_into] = ACTIONS(4730),
    [anon_sym_let] = ACTIONS(4730),
    [anon_sym_orderby] = ACTIONS(4730),
    [anon_sym_ascending] = ACTIONS(4730),
    [anon_sym_descending] = ACTIONS(4730),
    [anon_sym_group] = ACTIONS(4730),
    [anon_sym_by] = ACTIONS(4730),
    [anon_sym_select] = ACTIONS(4730),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4730),
    [anon_sym_nameof] = ACTIONS(4730),
    [sym_void_keyword] = ACTIONS(4730),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2513] = {
    [sym__preprocessor_call] = STATE(2513),
    [sym__identifier_token] = ACTIONS(4734),
    [anon_sym_extern] = ACTIONS(4734),
    [anon_sym_alias] = ACTIONS(4734),
    [anon_sym_global] = ACTIONS(4734),
    [anon_sym_using] = ACTIONS(4734),
    [anon_sym_static] = ACTIONS(4734),
    [anon_sym_LBRACK] = ACTIONS(4736),
    [anon_sym_event] = ACTIONS(4734),
    [anon_sym_LPAREN] = ACTIONS(4736),
    [anon_sym_abstract] = ACTIONS(4734),
    [anon_sym_async] = ACTIONS(4734),
    [anon_sym_const] = ACTIONS(4734),
    [anon_sym_fixed] = ACTIONS(4734),
    [anon_sym_internal] = ACTIONS(4734),
    [anon_sym_new] = ACTIONS(4734),
    [anon_sym_override] = ACTIONS(4734),
    [anon_sym_partial] = ACTIONS(4734),
    [anon_sym_private] = ACTIONS(4734),
    [anon_sym_protected] = ACTIONS(4734),
    [anon_sym_public] = ACTIONS(4734),
    [anon_sym_readonly] = ACTIONS(4734),
    [anon_sym_ref] = ACTIONS(4734),
    [anon_sym_sealed] = ACTIONS(4734),
    [anon_sym_unsafe] = ACTIONS(4734),
    [anon_sym_virtual] = ACTIONS(4734),
    [anon_sym_volatile] = ACTIONS(4734),
    [anon_sym_RBRACE] = ACTIONS(4736),
    [anon_sym_implicit] = ACTIONS(4734),
    [anon_sym_explicit] = ACTIONS(4734),
    [anon_sym_TILDE] = ACTIONS(4736),
    [anon_sym_where] = ACTIONS(4734),
    [anon_sym_class] = ACTIONS(4734),
    [anon_sym_struct] = ACTIONS(4734),
    [anon_sym_notnull] = ACTIONS(4734),
    [anon_sym_unmanaged] = ACTIONS(4734),
    [anon_sym_get] = ACTIONS(4734),
    [anon_sym_set] = ACTIONS(4734),
    [anon_sym_add] = ACTIONS(4734),
    [anon_sym_remove] = ACTIONS(4734),
    [anon_sym_enum] = ACTIONS(4734),
    [anon_sym_interface] = ACTIONS(4734),
    [anon_sym_delegate] = ACTIONS(4734),
    [anon_sym_record] = ACTIONS(4734),
    [anon_sym_namespace] = ACTIONS(4734),
    [anon_sym_var] = ACTIONS(4734),
    [sym_predefined_type] = ACTIONS(4734),
    [anon_sym_when] = ACTIONS(4734),
    [anon_sym_yield] = ACTIONS(4734),
    [anon_sym_from] = ACTIONS(4734),
    [anon_sym_join] = ACTIONS(4734),
    [anon_sym_on] = ACTIONS(4734),
    [anon_sym_equals] = ACTIONS(4734),
    [anon_sym_into] = ACTIONS(4734),
    [anon_sym_let] = ACTIONS(4734),
    [anon_sym_orderby] = ACTIONS(4734),
    [anon_sym_ascending] = ACTIONS(4734),
    [anon_sym_descending] = ACTIONS(4734),
    [anon_sym_group] = ACTIONS(4734),
    [anon_sym_by] = ACTIONS(4734),
    [anon_sym_select] = ACTIONS(4734),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4734),
    [anon_sym_nameof] = ACTIONS(4734),
    [sym_void_keyword] = ACTIONS(4734),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2514] = {
    [sym__preprocessor_call] = STATE(2514),
    [sym__identifier_token] = ACTIONS(4738),
    [anon_sym_extern] = ACTIONS(4738),
    [anon_sym_alias] = ACTIONS(4738),
    [anon_sym_global] = ACTIONS(4738),
    [anon_sym_using] = ACTIONS(4738),
    [anon_sym_static] = ACTIONS(4738),
    [anon_sym_LBRACK] = ACTIONS(4740),
    [anon_sym_event] = ACTIONS(4738),
    [anon_sym_LPAREN] = ACTIONS(4740),
    [anon_sym_abstract] = ACTIONS(4738),
    [anon_sym_async] = ACTIONS(4738),
    [anon_sym_const] = ACTIONS(4738),
    [anon_sym_fixed] = ACTIONS(4738),
    [anon_sym_internal] = ACTIONS(4738),
    [anon_sym_new] = ACTIONS(4738),
    [anon_sym_override] = ACTIONS(4738),
    [anon_sym_partial] = ACTIONS(4738),
    [anon_sym_private] = ACTIONS(4738),
    [anon_sym_protected] = ACTIONS(4738),
    [anon_sym_public] = ACTIONS(4738),
    [anon_sym_readonly] = ACTIONS(4738),
    [anon_sym_ref] = ACTIONS(4738),
    [anon_sym_sealed] = ACTIONS(4738),
    [anon_sym_unsafe] = ACTIONS(4738),
    [anon_sym_virtual] = ACTIONS(4738),
    [anon_sym_volatile] = ACTIONS(4738),
    [anon_sym_RBRACE] = ACTIONS(4740),
    [anon_sym_implicit] = ACTIONS(4738),
    [anon_sym_explicit] = ACTIONS(4738),
    [anon_sym_TILDE] = ACTIONS(4740),
    [anon_sym_where] = ACTIONS(4738),
    [anon_sym_class] = ACTIONS(4738),
    [anon_sym_struct] = ACTIONS(4738),
    [anon_sym_notnull] = ACTIONS(4738),
    [anon_sym_unmanaged] = ACTIONS(4738),
    [anon_sym_get] = ACTIONS(4738),
    [anon_sym_set] = ACTIONS(4738),
    [anon_sym_add] = ACTIONS(4738),
    [anon_sym_remove] = ACTIONS(4738),
    [anon_sym_enum] = ACTIONS(4738),
    [anon_sym_interface] = ACTIONS(4738),
    [anon_sym_delegate] = ACTIONS(4738),
    [anon_sym_record] = ACTIONS(4738),
    [anon_sym_namespace] = ACTIONS(4738),
    [anon_sym_var] = ACTIONS(4738),
    [sym_predefined_type] = ACTIONS(4738),
    [anon_sym_when] = ACTIONS(4738),
    [anon_sym_yield] = ACTIONS(4738),
    [anon_sym_from] = ACTIONS(4738),
    [anon_sym_join] = ACTIONS(4738),
    [anon_sym_on] = ACTIONS(4738),
    [anon_sym_equals] = ACTIONS(4738),
    [anon_sym_into] = ACTIONS(4738),
    [anon_sym_let] = ACTIONS(4738),
    [anon_sym_orderby] = ACTIONS(4738),
    [anon_sym_ascending] = ACTIONS(4738),
    [anon_sym_descending] = ACTIONS(4738),
    [anon_sym_group] = ACTIONS(4738),
    [anon_sym_by] = ACTIONS(4738),
    [anon_sym_select] = ACTIONS(4738),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4738),
    [anon_sym_nameof] = ACTIONS(4738),
    [sym_void_keyword] = ACTIONS(4738),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2515] = {
    [sym__preprocessor_call] = STATE(2515),
    [sym__identifier_token] = ACTIONS(4742),
    [anon_sym_extern] = ACTIONS(4742),
    [anon_sym_alias] = ACTIONS(4742),
    [anon_sym_global] = ACTIONS(4742),
    [anon_sym_using] = ACTIONS(4742),
    [anon_sym_static] = ACTIONS(4742),
    [anon_sym_LBRACK] = ACTIONS(4744),
    [anon_sym_event] = ACTIONS(4742),
    [anon_sym_LPAREN] = ACTIONS(4744),
    [anon_sym_abstract] = ACTIONS(4742),
    [anon_sym_async] = ACTIONS(4742),
    [anon_sym_const] = ACTIONS(4742),
    [anon_sym_fixed] = ACTIONS(4742),
    [anon_sym_internal] = ACTIONS(4742),
    [anon_sym_new] = ACTIONS(4742),
    [anon_sym_override] = ACTIONS(4742),
    [anon_sym_partial] = ACTIONS(4742),
    [anon_sym_private] = ACTIONS(4742),
    [anon_sym_protected] = ACTIONS(4742),
    [anon_sym_public] = ACTIONS(4742),
    [anon_sym_readonly] = ACTIONS(4742),
    [anon_sym_ref] = ACTIONS(4742),
    [anon_sym_sealed] = ACTIONS(4742),
    [anon_sym_unsafe] = ACTIONS(4742),
    [anon_sym_virtual] = ACTIONS(4742),
    [anon_sym_volatile] = ACTIONS(4742),
    [anon_sym_RBRACE] = ACTIONS(4744),
    [anon_sym_implicit] = ACTIONS(4742),
    [anon_sym_explicit] = ACTIONS(4742),
    [anon_sym_TILDE] = ACTIONS(4744),
    [anon_sym_where] = ACTIONS(4742),
    [anon_sym_class] = ACTIONS(4742),
    [anon_sym_struct] = ACTIONS(4742),
    [anon_sym_notnull] = ACTIONS(4742),
    [anon_sym_unmanaged] = ACTIONS(4742),
    [anon_sym_get] = ACTIONS(4742),
    [anon_sym_set] = ACTIONS(4742),
    [anon_sym_add] = ACTIONS(4742),
    [anon_sym_remove] = ACTIONS(4742),
    [anon_sym_enum] = ACTIONS(4742),
    [anon_sym_interface] = ACTIONS(4742),
    [anon_sym_delegate] = ACTIONS(4742),
    [anon_sym_record] = ACTIONS(4742),
    [anon_sym_namespace] = ACTIONS(4742),
    [anon_sym_var] = ACTIONS(4742),
    [sym_predefined_type] = ACTIONS(4742),
    [anon_sym_when] = ACTIONS(4742),
    [anon_sym_yield] = ACTIONS(4742),
    [anon_sym_from] = ACTIONS(4742),
    [anon_sym_join] = ACTIONS(4742),
    [anon_sym_on] = ACTIONS(4742),
    [anon_sym_equals] = ACTIONS(4742),
    [anon_sym_into] = ACTIONS(4742),
    [anon_sym_let] = ACTIONS(4742),
    [anon_sym_orderby] = ACTIONS(4742),
    [anon_sym_ascending] = ACTIONS(4742),
    [anon_sym_descending] = ACTIONS(4742),
    [anon_sym_group] = ACTIONS(4742),
    [anon_sym_by] = ACTIONS(4742),
    [anon_sym_select] = ACTIONS(4742),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4742),
    [anon_sym_nameof] = ACTIONS(4742),
    [sym_void_keyword] = ACTIONS(4742),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2516] = {
    [sym__preprocessor_call] = STATE(2516),
    [sym__identifier_token] = ACTIONS(4746),
    [anon_sym_extern] = ACTIONS(4746),
    [anon_sym_alias] = ACTIONS(4746),
    [anon_sym_global] = ACTIONS(4746),
    [anon_sym_using] = ACTIONS(4746),
    [anon_sym_static] = ACTIONS(4746),
    [anon_sym_LBRACK] = ACTIONS(4748),
    [anon_sym_event] = ACTIONS(4746),
    [anon_sym_LPAREN] = ACTIONS(4748),
    [anon_sym_abstract] = ACTIONS(4746),
    [anon_sym_async] = ACTIONS(4746),
    [anon_sym_const] = ACTIONS(4746),
    [anon_sym_fixed] = ACTIONS(4746),
    [anon_sym_internal] = ACTIONS(4746),
    [anon_sym_new] = ACTIONS(4746),
    [anon_sym_override] = ACTIONS(4746),
    [anon_sym_partial] = ACTIONS(4746),
    [anon_sym_private] = ACTIONS(4746),
    [anon_sym_protected] = ACTIONS(4746),
    [anon_sym_public] = ACTIONS(4746),
    [anon_sym_readonly] = ACTIONS(4746),
    [anon_sym_ref] = ACTIONS(4746),
    [anon_sym_sealed] = ACTIONS(4746),
    [anon_sym_unsafe] = ACTIONS(4746),
    [anon_sym_virtual] = ACTIONS(4746),
    [anon_sym_volatile] = ACTIONS(4746),
    [anon_sym_RBRACE] = ACTIONS(4748),
    [anon_sym_implicit] = ACTIONS(4746),
    [anon_sym_explicit] = ACTIONS(4746),
    [anon_sym_TILDE] = ACTIONS(4748),
    [anon_sym_where] = ACTIONS(4746),
    [anon_sym_class] = ACTIONS(4746),
    [anon_sym_struct] = ACTIONS(4746),
    [anon_sym_notnull] = ACTIONS(4746),
    [anon_sym_unmanaged] = ACTIONS(4746),
    [anon_sym_get] = ACTIONS(4746),
    [anon_sym_set] = ACTIONS(4746),
    [anon_sym_add] = ACTIONS(4746),
    [anon_sym_remove] = ACTIONS(4746),
    [anon_sym_enum] = ACTIONS(4746),
    [anon_sym_interface] = ACTIONS(4746),
    [anon_sym_delegate] = ACTIONS(4746),
    [anon_sym_record] = ACTIONS(4746),
    [anon_sym_namespace] = ACTIONS(4746),
    [anon_sym_var] = ACTIONS(4746),
    [sym_predefined_type] = ACTIONS(4746),
    [anon_sym_when] = ACTIONS(4746),
    [anon_sym_yield] = ACTIONS(4746),
    [anon_sym_from] = ACTIONS(4746),
    [anon_sym_join] = ACTIONS(4746),
    [anon_sym_on] = ACTIONS(4746),
    [anon_sym_equals] = ACTIONS(4746),
    [anon_sym_into] = ACTIONS(4746),
    [anon_sym_let] = ACTIONS(4746),
    [anon_sym_orderby] = ACTIONS(4746),
    [anon_sym_ascending] = ACTIONS(4746),
    [anon_sym_descending] = ACTIONS(4746),
    [anon_sym_group] = ACTIONS(4746),
    [anon_sym_by] = ACTIONS(4746),
    [anon_sym_select] = ACTIONS(4746),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4746),
    [anon_sym_nameof] = ACTIONS(4746),
    [sym_void_keyword] = ACTIONS(4746),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2517] = {
    [sym__preprocessor_call] = STATE(2517),
    [sym__identifier_token] = ACTIONS(4750),
    [anon_sym_extern] = ACTIONS(4750),
    [anon_sym_alias] = ACTIONS(4750),
    [anon_sym_global] = ACTIONS(4750),
    [anon_sym_using] = ACTIONS(4750),
    [anon_sym_static] = ACTIONS(4750),
    [anon_sym_LBRACK] = ACTIONS(4752),
    [anon_sym_event] = ACTIONS(4750),
    [anon_sym_LPAREN] = ACTIONS(4752),
    [anon_sym_abstract] = ACTIONS(4750),
    [anon_sym_async] = ACTIONS(4750),
    [anon_sym_const] = ACTIONS(4750),
    [anon_sym_fixed] = ACTIONS(4750),
    [anon_sym_internal] = ACTIONS(4750),
    [anon_sym_new] = ACTIONS(4750),
    [anon_sym_override] = ACTIONS(4750),
    [anon_sym_partial] = ACTIONS(4750),
    [anon_sym_private] = ACTIONS(4750),
    [anon_sym_protected] = ACTIONS(4750),
    [anon_sym_public] = ACTIONS(4750),
    [anon_sym_readonly] = ACTIONS(4750),
    [anon_sym_ref] = ACTIONS(4750),
    [anon_sym_sealed] = ACTIONS(4750),
    [anon_sym_unsafe] = ACTIONS(4750),
    [anon_sym_virtual] = ACTIONS(4750),
    [anon_sym_volatile] = ACTIONS(4750),
    [anon_sym_RBRACE] = ACTIONS(4752),
    [anon_sym_implicit] = ACTIONS(4750),
    [anon_sym_explicit] = ACTIONS(4750),
    [anon_sym_TILDE] = ACTIONS(4752),
    [anon_sym_where] = ACTIONS(4750),
    [anon_sym_class] = ACTIONS(4750),
    [anon_sym_struct] = ACTIONS(4750),
    [anon_sym_notnull] = ACTIONS(4750),
    [anon_sym_unmanaged] = ACTIONS(4750),
    [anon_sym_get] = ACTIONS(4750),
    [anon_sym_set] = ACTIONS(4750),
    [anon_sym_add] = ACTIONS(4750),
    [anon_sym_remove] = ACTIONS(4750),
    [anon_sym_enum] = ACTIONS(4750),
    [anon_sym_interface] = ACTIONS(4750),
    [anon_sym_delegate] = ACTIONS(4750),
    [anon_sym_record] = ACTIONS(4750),
    [anon_sym_namespace] = ACTIONS(4750),
    [anon_sym_var] = ACTIONS(4750),
    [sym_predefined_type] = ACTIONS(4750),
    [anon_sym_when] = ACTIONS(4750),
    [anon_sym_yield] = ACTIONS(4750),
    [anon_sym_from] = ACTIONS(4750),
    [anon_sym_join] = ACTIONS(4750),
    [anon_sym_on] = ACTIONS(4750),
    [anon_sym_equals] = ACTIONS(4750),
    [anon_sym_into] = ACTIONS(4750),
    [anon_sym_let] = ACTIONS(4750),
    [anon_sym_orderby] = ACTIONS(4750),
    [anon_sym_ascending] = ACTIONS(4750),
    [anon_sym_descending] = ACTIONS(4750),
    [anon_sym_group] = ACTIONS(4750),
    [anon_sym_by] = ACTIONS(4750),
    [anon_sym_select] = ACTIONS(4750),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4750),
    [anon_sym_nameof] = ACTIONS(4750),
    [sym_void_keyword] = ACTIONS(4750),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2518] = {
    [sym__preprocessor_call] = STATE(2518),
    [sym__identifier_token] = ACTIONS(4754),
    [anon_sym_extern] = ACTIONS(4754),
    [anon_sym_alias] = ACTIONS(4754),
    [anon_sym_global] = ACTIONS(4754),
    [anon_sym_using] = ACTIONS(4754),
    [anon_sym_static] = ACTIONS(4754),
    [anon_sym_LBRACK] = ACTIONS(4756),
    [anon_sym_event] = ACTIONS(4754),
    [anon_sym_LPAREN] = ACTIONS(4756),
    [anon_sym_abstract] = ACTIONS(4754),
    [anon_sym_async] = ACTIONS(4754),
    [anon_sym_const] = ACTIONS(4754),
    [anon_sym_fixed] = ACTIONS(4754),
    [anon_sym_internal] = ACTIONS(4754),
    [anon_sym_new] = ACTIONS(4754),
    [anon_sym_override] = ACTIONS(4754),
    [anon_sym_partial] = ACTIONS(4754),
    [anon_sym_private] = ACTIONS(4754),
    [anon_sym_protected] = ACTIONS(4754),
    [anon_sym_public] = ACTIONS(4754),
    [anon_sym_readonly] = ACTIONS(4754),
    [anon_sym_ref] = ACTIONS(4754),
    [anon_sym_sealed] = ACTIONS(4754),
    [anon_sym_unsafe] = ACTIONS(4754),
    [anon_sym_virtual] = ACTIONS(4754),
    [anon_sym_volatile] = ACTIONS(4754),
    [anon_sym_RBRACE] = ACTIONS(4756),
    [anon_sym_implicit] = ACTIONS(4754),
    [anon_sym_explicit] = ACTIONS(4754),
    [anon_sym_TILDE] = ACTIONS(4756),
    [anon_sym_where] = ACTIONS(4754),
    [anon_sym_class] = ACTIONS(4754),
    [anon_sym_struct] = ACTIONS(4754),
    [anon_sym_notnull] = ACTIONS(4754),
    [anon_sym_unmanaged] = ACTIONS(4754),
    [anon_sym_get] = ACTIONS(4754),
    [anon_sym_set] = ACTIONS(4754),
    [anon_sym_add] = ACTIONS(4754),
    [anon_sym_remove] = ACTIONS(4754),
    [anon_sym_enum] = ACTIONS(4754),
    [anon_sym_interface] = ACTIONS(4754),
    [anon_sym_delegate] = ACTIONS(4754),
    [anon_sym_record] = ACTIONS(4754),
    [anon_sym_namespace] = ACTIONS(4754),
    [anon_sym_var] = ACTIONS(4754),
    [sym_predefined_type] = ACTIONS(4754),
    [anon_sym_when] = ACTIONS(4754),
    [anon_sym_yield] = ACTIONS(4754),
    [anon_sym_from] = ACTIONS(4754),
    [anon_sym_join] = ACTIONS(4754),
    [anon_sym_on] = ACTIONS(4754),
    [anon_sym_equals] = ACTIONS(4754),
    [anon_sym_into] = ACTIONS(4754),
    [anon_sym_let] = ACTIONS(4754),
    [anon_sym_orderby] = ACTIONS(4754),
    [anon_sym_ascending] = ACTIONS(4754),
    [anon_sym_descending] = ACTIONS(4754),
    [anon_sym_group] = ACTIONS(4754),
    [anon_sym_by] = ACTIONS(4754),
    [anon_sym_select] = ACTIONS(4754),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4754),
    [anon_sym_nameof] = ACTIONS(4754),
    [sym_void_keyword] = ACTIONS(4754),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2519] = {
    [sym__preprocessor_call] = STATE(2519),
    [sym__identifier_token] = ACTIONS(4758),
    [anon_sym_extern] = ACTIONS(4758),
    [anon_sym_alias] = ACTIONS(4758),
    [anon_sym_global] = ACTIONS(4758),
    [anon_sym_using] = ACTIONS(4758),
    [anon_sym_static] = ACTIONS(4758),
    [anon_sym_LBRACK] = ACTIONS(4760),
    [anon_sym_event] = ACTIONS(4758),
    [anon_sym_LPAREN] = ACTIONS(4760),
    [anon_sym_abstract] = ACTIONS(4758),
    [anon_sym_async] = ACTIONS(4758),
    [anon_sym_const] = ACTIONS(4758),
    [anon_sym_fixed] = ACTIONS(4758),
    [anon_sym_internal] = ACTIONS(4758),
    [anon_sym_new] = ACTIONS(4758),
    [anon_sym_override] = ACTIONS(4758),
    [anon_sym_partial] = ACTIONS(4758),
    [anon_sym_private] = ACTIONS(4758),
    [anon_sym_protected] = ACTIONS(4758),
    [anon_sym_public] = ACTIONS(4758),
    [anon_sym_readonly] = ACTIONS(4758),
    [anon_sym_ref] = ACTIONS(4758),
    [anon_sym_sealed] = ACTIONS(4758),
    [anon_sym_unsafe] = ACTIONS(4758),
    [anon_sym_virtual] = ACTIONS(4758),
    [anon_sym_volatile] = ACTIONS(4758),
    [anon_sym_RBRACE] = ACTIONS(4760),
    [anon_sym_implicit] = ACTIONS(4758),
    [anon_sym_explicit] = ACTIONS(4758),
    [anon_sym_TILDE] = ACTIONS(4760),
    [anon_sym_where] = ACTIONS(4758),
    [anon_sym_class] = ACTIONS(4758),
    [anon_sym_struct] = ACTIONS(4758),
    [anon_sym_notnull] = ACTIONS(4758),
    [anon_sym_unmanaged] = ACTIONS(4758),
    [anon_sym_get] = ACTIONS(4758),
    [anon_sym_set] = ACTIONS(4758),
    [anon_sym_add] = ACTIONS(4758),
    [anon_sym_remove] = ACTIONS(4758),
    [anon_sym_enum] = ACTIONS(4758),
    [anon_sym_interface] = ACTIONS(4758),
    [anon_sym_delegate] = ACTIONS(4758),
    [anon_sym_record] = ACTIONS(4758),
    [anon_sym_namespace] = ACTIONS(4758),
    [anon_sym_var] = ACTIONS(4758),
    [sym_predefined_type] = ACTIONS(4758),
    [anon_sym_when] = ACTIONS(4758),
    [anon_sym_yield] = ACTIONS(4758),
    [anon_sym_from] = ACTIONS(4758),
    [anon_sym_join] = ACTIONS(4758),
    [anon_sym_on] = ACTIONS(4758),
    [anon_sym_equals] = ACTIONS(4758),
    [anon_sym_into] = ACTIONS(4758),
    [anon_sym_let] = ACTIONS(4758),
    [anon_sym_orderby] = ACTIONS(4758),
    [anon_sym_ascending] = ACTIONS(4758),
    [anon_sym_descending] = ACTIONS(4758),
    [anon_sym_group] = ACTIONS(4758),
    [anon_sym_by] = ACTIONS(4758),
    [anon_sym_select] = ACTIONS(4758),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4758),
    [anon_sym_nameof] = ACTIONS(4758),
    [sym_void_keyword] = ACTIONS(4758),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2520] = {
    [sym__preprocessor_call] = STATE(2520),
    [sym__identifier_token] = ACTIONS(4762),
    [anon_sym_extern] = ACTIONS(4762),
    [anon_sym_alias] = ACTIONS(4762),
    [anon_sym_global] = ACTIONS(4762),
    [anon_sym_using] = ACTIONS(4762),
    [anon_sym_static] = ACTIONS(4762),
    [anon_sym_LBRACK] = ACTIONS(4764),
    [anon_sym_event] = ACTIONS(4762),
    [anon_sym_LPAREN] = ACTIONS(4764),
    [anon_sym_abstract] = ACTIONS(4762),
    [anon_sym_async] = ACTIONS(4762),
    [anon_sym_const] = ACTIONS(4762),
    [anon_sym_fixed] = ACTIONS(4762),
    [anon_sym_internal] = ACTIONS(4762),
    [anon_sym_new] = ACTIONS(4762),
    [anon_sym_override] = ACTIONS(4762),
    [anon_sym_partial] = ACTIONS(4762),
    [anon_sym_private] = ACTIONS(4762),
    [anon_sym_protected] = ACTIONS(4762),
    [anon_sym_public] = ACTIONS(4762),
    [anon_sym_readonly] = ACTIONS(4762),
    [anon_sym_ref] = ACTIONS(4762),
    [anon_sym_sealed] = ACTIONS(4762),
    [anon_sym_unsafe] = ACTIONS(4762),
    [anon_sym_virtual] = ACTIONS(4762),
    [anon_sym_volatile] = ACTIONS(4762),
    [anon_sym_RBRACE] = ACTIONS(4764),
    [anon_sym_implicit] = ACTIONS(4762),
    [anon_sym_explicit] = ACTIONS(4762),
    [anon_sym_TILDE] = ACTIONS(4764),
    [anon_sym_where] = ACTIONS(4762),
    [anon_sym_class] = ACTIONS(4762),
    [anon_sym_struct] = ACTIONS(4762),
    [anon_sym_notnull] = ACTIONS(4762),
    [anon_sym_unmanaged] = ACTIONS(4762),
    [anon_sym_get] = ACTIONS(4762),
    [anon_sym_set] = ACTIONS(4762),
    [anon_sym_add] = ACTIONS(4762),
    [anon_sym_remove] = ACTIONS(4762),
    [anon_sym_enum] = ACTIONS(4762),
    [anon_sym_interface] = ACTIONS(4762),
    [anon_sym_delegate] = ACTIONS(4762),
    [anon_sym_record] = ACTIONS(4762),
    [anon_sym_namespace] = ACTIONS(4762),
    [anon_sym_var] = ACTIONS(4762),
    [sym_predefined_type] = ACTIONS(4762),
    [anon_sym_when] = ACTIONS(4762),
    [anon_sym_yield] = ACTIONS(4762),
    [anon_sym_from] = ACTIONS(4762),
    [anon_sym_join] = ACTIONS(4762),
    [anon_sym_on] = ACTIONS(4762),
    [anon_sym_equals] = ACTIONS(4762),
    [anon_sym_into] = ACTIONS(4762),
    [anon_sym_let] = ACTIONS(4762),
    [anon_sym_orderby] = ACTIONS(4762),
    [anon_sym_ascending] = ACTIONS(4762),
    [anon_sym_descending] = ACTIONS(4762),
    [anon_sym_group] = ACTIONS(4762),
    [anon_sym_by] = ACTIONS(4762),
    [anon_sym_select] = ACTIONS(4762),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4762),
    [anon_sym_nameof] = ACTIONS(4762),
    [sym_void_keyword] = ACTIONS(4762),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2521] = {
    [sym__preprocessor_call] = STATE(2521),
    [sym__identifier_token] = ACTIONS(4766),
    [anon_sym_extern] = ACTIONS(4766),
    [anon_sym_alias] = ACTIONS(4766),
    [anon_sym_global] = ACTIONS(4766),
    [anon_sym_using] = ACTIONS(4766),
    [anon_sym_static] = ACTIONS(4766),
    [anon_sym_LBRACK] = ACTIONS(4768),
    [anon_sym_event] = ACTIONS(4766),
    [anon_sym_LPAREN] = ACTIONS(4768),
    [anon_sym_abstract] = ACTIONS(4766),
    [anon_sym_async] = ACTIONS(4766),
    [anon_sym_const] = ACTIONS(4766),
    [anon_sym_fixed] = ACTIONS(4766),
    [anon_sym_internal] = ACTIONS(4766),
    [anon_sym_new] = ACTIONS(4766),
    [anon_sym_override] = ACTIONS(4766),
    [anon_sym_partial] = ACTIONS(4766),
    [anon_sym_private] = ACTIONS(4766),
    [anon_sym_protected] = ACTIONS(4766),
    [anon_sym_public] = ACTIONS(4766),
    [anon_sym_readonly] = ACTIONS(4766),
    [anon_sym_ref] = ACTIONS(4766),
    [anon_sym_sealed] = ACTIONS(4766),
    [anon_sym_unsafe] = ACTIONS(4766),
    [anon_sym_virtual] = ACTIONS(4766),
    [anon_sym_volatile] = ACTIONS(4766),
    [anon_sym_RBRACE] = ACTIONS(4768),
    [anon_sym_implicit] = ACTIONS(4766),
    [anon_sym_explicit] = ACTIONS(4766),
    [anon_sym_TILDE] = ACTIONS(4768),
    [anon_sym_where] = ACTIONS(4766),
    [anon_sym_class] = ACTIONS(4766),
    [anon_sym_struct] = ACTIONS(4766),
    [anon_sym_notnull] = ACTIONS(4766),
    [anon_sym_unmanaged] = ACTIONS(4766),
    [anon_sym_get] = ACTIONS(4766),
    [anon_sym_set] = ACTIONS(4766),
    [anon_sym_add] = ACTIONS(4766),
    [anon_sym_remove] = ACTIONS(4766),
    [anon_sym_enum] = ACTIONS(4766),
    [anon_sym_interface] = ACTIONS(4766),
    [anon_sym_delegate] = ACTIONS(4766),
    [anon_sym_record] = ACTIONS(4766),
    [anon_sym_namespace] = ACTIONS(4766),
    [anon_sym_var] = ACTIONS(4766),
    [sym_predefined_type] = ACTIONS(4766),
    [anon_sym_when] = ACTIONS(4766),
    [anon_sym_yield] = ACTIONS(4766),
    [anon_sym_from] = ACTIONS(4766),
    [anon_sym_join] = ACTIONS(4766),
    [anon_sym_on] = ACTIONS(4766),
    [anon_sym_equals] = ACTIONS(4766),
    [anon_sym_into] = ACTIONS(4766),
    [anon_sym_let] = ACTIONS(4766),
    [anon_sym_orderby] = ACTIONS(4766),
    [anon_sym_ascending] = ACTIONS(4766),
    [anon_sym_descending] = ACTIONS(4766),
    [anon_sym_group] = ACTIONS(4766),
    [anon_sym_by] = ACTIONS(4766),
    [anon_sym_select] = ACTIONS(4766),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4766),
    [anon_sym_nameof] = ACTIONS(4766),
    [sym_void_keyword] = ACTIONS(4766),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2522] = {
    [sym__preprocessor_call] = STATE(2522),
    [sym__identifier_token] = ACTIONS(4770),
    [anon_sym_extern] = ACTIONS(4770),
    [anon_sym_alias] = ACTIONS(4770),
    [anon_sym_global] = ACTIONS(4770),
    [anon_sym_using] = ACTIONS(4770),
    [anon_sym_static] = ACTIONS(4770),
    [anon_sym_LBRACK] = ACTIONS(4772),
    [anon_sym_event] = ACTIONS(4770),
    [anon_sym_LPAREN] = ACTIONS(4772),
    [anon_sym_abstract] = ACTIONS(4770),
    [anon_sym_async] = ACTIONS(4770),
    [anon_sym_const] = ACTIONS(4770),
    [anon_sym_fixed] = ACTIONS(4770),
    [anon_sym_internal] = ACTIONS(4770),
    [anon_sym_new] = ACTIONS(4770),
    [anon_sym_override] = ACTIONS(4770),
    [anon_sym_partial] = ACTIONS(4770),
    [anon_sym_private] = ACTIONS(4770),
    [anon_sym_protected] = ACTIONS(4770),
    [anon_sym_public] = ACTIONS(4770),
    [anon_sym_readonly] = ACTIONS(4770),
    [anon_sym_ref] = ACTIONS(4770),
    [anon_sym_sealed] = ACTIONS(4770),
    [anon_sym_unsafe] = ACTIONS(4770),
    [anon_sym_virtual] = ACTIONS(4770),
    [anon_sym_volatile] = ACTIONS(4770),
    [anon_sym_RBRACE] = ACTIONS(4772),
    [anon_sym_implicit] = ACTIONS(4770),
    [anon_sym_explicit] = ACTIONS(4770),
    [anon_sym_TILDE] = ACTIONS(4772),
    [anon_sym_where] = ACTIONS(4770),
    [anon_sym_class] = ACTIONS(4770),
    [anon_sym_struct] = ACTIONS(4770),
    [anon_sym_notnull] = ACTIONS(4770),
    [anon_sym_unmanaged] = ACTIONS(4770),
    [anon_sym_get] = ACTIONS(4770),
    [anon_sym_set] = ACTIONS(4770),
    [anon_sym_add] = ACTIONS(4770),
    [anon_sym_remove] = ACTIONS(4770),
    [anon_sym_enum] = ACTIONS(4770),
    [anon_sym_interface] = ACTIONS(4770),
    [anon_sym_delegate] = ACTIONS(4770),
    [anon_sym_record] = ACTIONS(4770),
    [anon_sym_namespace] = ACTIONS(4770),
    [anon_sym_var] = ACTIONS(4770),
    [sym_predefined_type] = ACTIONS(4770),
    [anon_sym_when] = ACTIONS(4770),
    [anon_sym_yield] = ACTIONS(4770),
    [anon_sym_from] = ACTIONS(4770),
    [anon_sym_join] = ACTIONS(4770),
    [anon_sym_on] = ACTIONS(4770),
    [anon_sym_equals] = ACTIONS(4770),
    [anon_sym_into] = ACTIONS(4770),
    [anon_sym_let] = ACTIONS(4770),
    [anon_sym_orderby] = ACTIONS(4770),
    [anon_sym_ascending] = ACTIONS(4770),
    [anon_sym_descending] = ACTIONS(4770),
    [anon_sym_group] = ACTIONS(4770),
    [anon_sym_by] = ACTIONS(4770),
    [anon_sym_select] = ACTIONS(4770),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4770),
    [anon_sym_nameof] = ACTIONS(4770),
    [sym_void_keyword] = ACTIONS(4770),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2523] = {
    [sym__preprocessor_call] = STATE(2523),
    [sym__identifier_token] = ACTIONS(4774),
    [anon_sym_extern] = ACTIONS(4774),
    [anon_sym_alias] = ACTIONS(4774),
    [anon_sym_global] = ACTIONS(4774),
    [anon_sym_using] = ACTIONS(4774),
    [anon_sym_static] = ACTIONS(4774),
    [anon_sym_LBRACK] = ACTIONS(4776),
    [anon_sym_event] = ACTIONS(4774),
    [anon_sym_LPAREN] = ACTIONS(4776),
    [anon_sym_abstract] = ACTIONS(4774),
    [anon_sym_async] = ACTIONS(4774),
    [anon_sym_const] = ACTIONS(4774),
    [anon_sym_fixed] = ACTIONS(4774),
    [anon_sym_internal] = ACTIONS(4774),
    [anon_sym_new] = ACTIONS(4774),
    [anon_sym_override] = ACTIONS(4774),
    [anon_sym_partial] = ACTIONS(4774),
    [anon_sym_private] = ACTIONS(4774),
    [anon_sym_protected] = ACTIONS(4774),
    [anon_sym_public] = ACTIONS(4774),
    [anon_sym_readonly] = ACTIONS(4774),
    [anon_sym_ref] = ACTIONS(4774),
    [anon_sym_sealed] = ACTIONS(4774),
    [anon_sym_unsafe] = ACTIONS(4774),
    [anon_sym_virtual] = ACTIONS(4774),
    [anon_sym_volatile] = ACTIONS(4774),
    [anon_sym_RBRACE] = ACTIONS(4776),
    [anon_sym_implicit] = ACTIONS(4774),
    [anon_sym_explicit] = ACTIONS(4774),
    [anon_sym_TILDE] = ACTIONS(4776),
    [anon_sym_where] = ACTIONS(4774),
    [anon_sym_class] = ACTIONS(4774),
    [anon_sym_struct] = ACTIONS(4774),
    [anon_sym_notnull] = ACTIONS(4774),
    [anon_sym_unmanaged] = ACTIONS(4774),
    [anon_sym_get] = ACTIONS(4774),
    [anon_sym_set] = ACTIONS(4774),
    [anon_sym_add] = ACTIONS(4774),
    [anon_sym_remove] = ACTIONS(4774),
    [anon_sym_enum] = ACTIONS(4774),
    [anon_sym_interface] = ACTIONS(4774),
    [anon_sym_delegate] = ACTIONS(4774),
    [anon_sym_record] = ACTIONS(4774),
    [anon_sym_namespace] = ACTIONS(4774),
    [anon_sym_var] = ACTIONS(4774),
    [sym_predefined_type] = ACTIONS(4774),
    [anon_sym_when] = ACTIONS(4774),
    [anon_sym_yield] = ACTIONS(4774),
    [anon_sym_from] = ACTIONS(4774),
    [anon_sym_join] = ACTIONS(4774),
    [anon_sym_on] = ACTIONS(4774),
    [anon_sym_equals] = ACTIONS(4774),
    [anon_sym_into] = ACTIONS(4774),
    [anon_sym_let] = ACTIONS(4774),
    [anon_sym_orderby] = ACTIONS(4774),
    [anon_sym_ascending] = ACTIONS(4774),
    [anon_sym_descending] = ACTIONS(4774),
    [anon_sym_group] = ACTIONS(4774),
    [anon_sym_by] = ACTIONS(4774),
    [anon_sym_select] = ACTIONS(4774),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4774),
    [anon_sym_nameof] = ACTIONS(4774),
    [sym_void_keyword] = ACTIONS(4774),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2524] = {
    [sym__preprocessor_call] = STATE(2524),
    [sym__identifier_token] = ACTIONS(4778),
    [anon_sym_extern] = ACTIONS(4778),
    [anon_sym_alias] = ACTIONS(4778),
    [anon_sym_global] = ACTIONS(4778),
    [anon_sym_using] = ACTIONS(4778),
    [anon_sym_static] = ACTIONS(4778),
    [anon_sym_LBRACK] = ACTIONS(4780),
    [anon_sym_event] = ACTIONS(4778),
    [anon_sym_LPAREN] = ACTIONS(4780),
    [anon_sym_abstract] = ACTIONS(4778),
    [anon_sym_async] = ACTIONS(4778),
    [anon_sym_const] = ACTIONS(4778),
    [anon_sym_fixed] = ACTIONS(4778),
    [anon_sym_internal] = ACTIONS(4778),
    [anon_sym_new] = ACTIONS(4778),
    [anon_sym_override] = ACTIONS(4778),
    [anon_sym_partial] = ACTIONS(4778),
    [anon_sym_private] = ACTIONS(4778),
    [anon_sym_protected] = ACTIONS(4778),
    [anon_sym_public] = ACTIONS(4778),
    [anon_sym_readonly] = ACTIONS(4778),
    [anon_sym_ref] = ACTIONS(4778),
    [anon_sym_sealed] = ACTIONS(4778),
    [anon_sym_unsafe] = ACTIONS(4778),
    [anon_sym_virtual] = ACTIONS(4778),
    [anon_sym_volatile] = ACTIONS(4778),
    [anon_sym_RBRACE] = ACTIONS(4780),
    [anon_sym_implicit] = ACTIONS(4778),
    [anon_sym_explicit] = ACTIONS(4778),
    [anon_sym_TILDE] = ACTIONS(4780),
    [anon_sym_where] = ACTIONS(4778),
    [anon_sym_class] = ACTIONS(4778),
    [anon_sym_struct] = ACTIONS(4778),
    [anon_sym_notnull] = ACTIONS(4778),
    [anon_sym_unmanaged] = ACTIONS(4778),
    [anon_sym_get] = ACTIONS(4778),
    [anon_sym_set] = ACTIONS(4778),
    [anon_sym_add] = ACTIONS(4778),
    [anon_sym_remove] = ACTIONS(4778),
    [anon_sym_enum] = ACTIONS(4778),
    [anon_sym_interface] = ACTIONS(4778),
    [anon_sym_delegate] = ACTIONS(4778),
    [anon_sym_record] = ACTIONS(4778),
    [anon_sym_namespace] = ACTIONS(4778),
    [anon_sym_var] = ACTIONS(4778),
    [sym_predefined_type] = ACTIONS(4778),
    [anon_sym_when] = ACTIONS(4778),
    [anon_sym_yield] = ACTIONS(4778),
    [anon_sym_from] = ACTIONS(4778),
    [anon_sym_join] = ACTIONS(4778),
    [anon_sym_on] = ACTIONS(4778),
    [anon_sym_equals] = ACTIONS(4778),
    [anon_sym_into] = ACTIONS(4778),
    [anon_sym_let] = ACTIONS(4778),
    [anon_sym_orderby] = ACTIONS(4778),
    [anon_sym_ascending] = ACTIONS(4778),
    [anon_sym_descending] = ACTIONS(4778),
    [anon_sym_group] = ACTIONS(4778),
    [anon_sym_by] = ACTIONS(4778),
    [anon_sym_select] = ACTIONS(4778),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4778),
    [anon_sym_nameof] = ACTIONS(4778),
    [sym_void_keyword] = ACTIONS(4778),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2525] = {
    [sym__preprocessor_call] = STATE(2525),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(3824),
    [anon_sym_LT] = ACTIONS(2827),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_where] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_switch] = ACTIONS(2829),
    [anon_sym_and] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2827),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_from] = ACTIONS(2829),
    [anon_sym_join] = ACTIONS(2829),
    [anon_sym_on] = ACTIONS(2829),
    [anon_sym_equals] = ACTIONS(2829),
    [anon_sym_let] = ACTIONS(2829),
    [anon_sym_orderby] = ACTIONS(2829),
    [anon_sym_group] = ACTIONS(2829),
    [anon_sym_by] = ACTIONS(2829),
    [anon_sym_select] = ACTIONS(2829),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2526] = {
    [sym__preprocessor_call] = STATE(2526),
    [sym__identifier_token] = ACTIONS(4782),
    [anon_sym_extern] = ACTIONS(4782),
    [anon_sym_alias] = ACTIONS(4782),
    [anon_sym_global] = ACTIONS(4782),
    [anon_sym_using] = ACTIONS(4782),
    [anon_sym_static] = ACTIONS(4782),
    [anon_sym_LBRACK] = ACTIONS(4784),
    [anon_sym_event] = ACTIONS(4782),
    [anon_sym_LPAREN] = ACTIONS(4784),
    [anon_sym_abstract] = ACTIONS(4782),
    [anon_sym_async] = ACTIONS(4782),
    [anon_sym_const] = ACTIONS(4782),
    [anon_sym_fixed] = ACTIONS(4782),
    [anon_sym_internal] = ACTIONS(4782),
    [anon_sym_new] = ACTIONS(4782),
    [anon_sym_override] = ACTIONS(4782),
    [anon_sym_partial] = ACTIONS(4782),
    [anon_sym_private] = ACTIONS(4782),
    [anon_sym_protected] = ACTIONS(4782),
    [anon_sym_public] = ACTIONS(4782),
    [anon_sym_readonly] = ACTIONS(4782),
    [anon_sym_ref] = ACTIONS(4782),
    [anon_sym_sealed] = ACTIONS(4782),
    [anon_sym_unsafe] = ACTIONS(4782),
    [anon_sym_virtual] = ACTIONS(4782),
    [anon_sym_volatile] = ACTIONS(4782),
    [anon_sym_RBRACE] = ACTIONS(4784),
    [anon_sym_implicit] = ACTIONS(4782),
    [anon_sym_explicit] = ACTIONS(4782),
    [anon_sym_TILDE] = ACTIONS(4784),
    [anon_sym_where] = ACTIONS(4782),
    [anon_sym_class] = ACTIONS(4782),
    [anon_sym_struct] = ACTIONS(4782),
    [anon_sym_notnull] = ACTIONS(4782),
    [anon_sym_unmanaged] = ACTIONS(4782),
    [anon_sym_get] = ACTIONS(4782),
    [anon_sym_set] = ACTIONS(4782),
    [anon_sym_add] = ACTIONS(4782),
    [anon_sym_remove] = ACTIONS(4782),
    [anon_sym_enum] = ACTIONS(4782),
    [anon_sym_interface] = ACTIONS(4782),
    [anon_sym_delegate] = ACTIONS(4782),
    [anon_sym_record] = ACTIONS(4782),
    [anon_sym_namespace] = ACTIONS(4782),
    [anon_sym_var] = ACTIONS(4782),
    [sym_predefined_type] = ACTIONS(4782),
    [anon_sym_when] = ACTIONS(4782),
    [anon_sym_yield] = ACTIONS(4782),
    [anon_sym_from] = ACTIONS(4782),
    [anon_sym_join] = ACTIONS(4782),
    [anon_sym_on] = ACTIONS(4782),
    [anon_sym_equals] = ACTIONS(4782),
    [anon_sym_into] = ACTIONS(4782),
    [anon_sym_let] = ACTIONS(4782),
    [anon_sym_orderby] = ACTIONS(4782),
    [anon_sym_ascending] = ACTIONS(4782),
    [anon_sym_descending] = ACTIONS(4782),
    [anon_sym_group] = ACTIONS(4782),
    [anon_sym_by] = ACTIONS(4782),
    [anon_sym_select] = ACTIONS(4782),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4782),
    [anon_sym_nameof] = ACTIONS(4782),
    [sym_void_keyword] = ACTIONS(4782),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2527] = {
    [sym__preprocessor_call] = STATE(2527),
    [sym__identifier_token] = ACTIONS(4786),
    [anon_sym_extern] = ACTIONS(4786),
    [anon_sym_alias] = ACTIONS(4786),
    [anon_sym_global] = ACTIONS(4786),
    [anon_sym_using] = ACTIONS(4786),
    [anon_sym_static] = ACTIONS(4786),
    [anon_sym_LBRACK] = ACTIONS(4788),
    [anon_sym_event] = ACTIONS(4786),
    [anon_sym_LPAREN] = ACTIONS(4788),
    [anon_sym_abstract] = ACTIONS(4786),
    [anon_sym_async] = ACTIONS(4786),
    [anon_sym_const] = ACTIONS(4786),
    [anon_sym_fixed] = ACTIONS(4786),
    [anon_sym_internal] = ACTIONS(4786),
    [anon_sym_new] = ACTIONS(4786),
    [anon_sym_override] = ACTIONS(4786),
    [anon_sym_partial] = ACTIONS(4786),
    [anon_sym_private] = ACTIONS(4786),
    [anon_sym_protected] = ACTIONS(4786),
    [anon_sym_public] = ACTIONS(4786),
    [anon_sym_readonly] = ACTIONS(4786),
    [anon_sym_ref] = ACTIONS(4786),
    [anon_sym_sealed] = ACTIONS(4786),
    [anon_sym_unsafe] = ACTIONS(4786),
    [anon_sym_virtual] = ACTIONS(4786),
    [anon_sym_volatile] = ACTIONS(4786),
    [anon_sym_RBRACE] = ACTIONS(4788),
    [anon_sym_implicit] = ACTIONS(4786),
    [anon_sym_explicit] = ACTIONS(4786),
    [anon_sym_TILDE] = ACTIONS(4788),
    [anon_sym_where] = ACTIONS(4786),
    [anon_sym_class] = ACTIONS(4786),
    [anon_sym_struct] = ACTIONS(4786),
    [anon_sym_notnull] = ACTIONS(4786),
    [anon_sym_unmanaged] = ACTIONS(4786),
    [anon_sym_get] = ACTIONS(4786),
    [anon_sym_set] = ACTIONS(4786),
    [anon_sym_add] = ACTIONS(4786),
    [anon_sym_remove] = ACTIONS(4786),
    [anon_sym_enum] = ACTIONS(4786),
    [anon_sym_interface] = ACTIONS(4786),
    [anon_sym_delegate] = ACTIONS(4786),
    [anon_sym_record] = ACTIONS(4786),
    [anon_sym_namespace] = ACTIONS(4786),
    [anon_sym_var] = ACTIONS(4786),
    [sym_predefined_type] = ACTIONS(4786),
    [anon_sym_when] = ACTIONS(4786),
    [anon_sym_yield] = ACTIONS(4786),
    [anon_sym_from] = ACTIONS(4786),
    [anon_sym_join] = ACTIONS(4786),
    [anon_sym_on] = ACTIONS(4786),
    [anon_sym_equals] = ACTIONS(4786),
    [anon_sym_into] = ACTIONS(4786),
    [anon_sym_let] = ACTIONS(4786),
    [anon_sym_orderby] = ACTIONS(4786),
    [anon_sym_ascending] = ACTIONS(4786),
    [anon_sym_descending] = ACTIONS(4786),
    [anon_sym_group] = ACTIONS(4786),
    [anon_sym_by] = ACTIONS(4786),
    [anon_sym_select] = ACTIONS(4786),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4786),
    [anon_sym_nameof] = ACTIONS(4786),
    [sym_void_keyword] = ACTIONS(4786),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2528] = {
    [sym__preprocessor_call] = STATE(2528),
    [sym__identifier_token] = ACTIONS(4790),
    [anon_sym_extern] = ACTIONS(4790),
    [anon_sym_alias] = ACTIONS(4790),
    [anon_sym_global] = ACTIONS(4790),
    [anon_sym_using] = ACTIONS(4790),
    [anon_sym_static] = ACTIONS(4790),
    [anon_sym_LBRACK] = ACTIONS(4792),
    [anon_sym_event] = ACTIONS(4790),
    [anon_sym_LPAREN] = ACTIONS(4792),
    [anon_sym_abstract] = ACTIONS(4790),
    [anon_sym_async] = ACTIONS(4790),
    [anon_sym_const] = ACTIONS(4790),
    [anon_sym_fixed] = ACTIONS(4790),
    [anon_sym_internal] = ACTIONS(4790),
    [anon_sym_new] = ACTIONS(4790),
    [anon_sym_override] = ACTIONS(4790),
    [anon_sym_partial] = ACTIONS(4790),
    [anon_sym_private] = ACTIONS(4790),
    [anon_sym_protected] = ACTIONS(4790),
    [anon_sym_public] = ACTIONS(4790),
    [anon_sym_readonly] = ACTIONS(4790),
    [anon_sym_ref] = ACTIONS(4790),
    [anon_sym_sealed] = ACTIONS(4790),
    [anon_sym_unsafe] = ACTIONS(4790),
    [anon_sym_virtual] = ACTIONS(4790),
    [anon_sym_volatile] = ACTIONS(4790),
    [anon_sym_RBRACE] = ACTIONS(4792),
    [anon_sym_implicit] = ACTIONS(4790),
    [anon_sym_explicit] = ACTIONS(4790),
    [anon_sym_TILDE] = ACTIONS(4792),
    [anon_sym_where] = ACTIONS(4790),
    [anon_sym_class] = ACTIONS(4790),
    [anon_sym_struct] = ACTIONS(4790),
    [anon_sym_notnull] = ACTIONS(4790),
    [anon_sym_unmanaged] = ACTIONS(4790),
    [anon_sym_get] = ACTIONS(4790),
    [anon_sym_set] = ACTIONS(4790),
    [anon_sym_add] = ACTIONS(4790),
    [anon_sym_remove] = ACTIONS(4790),
    [anon_sym_enum] = ACTIONS(4790),
    [anon_sym_interface] = ACTIONS(4790),
    [anon_sym_delegate] = ACTIONS(4790),
    [anon_sym_record] = ACTIONS(4790),
    [anon_sym_namespace] = ACTIONS(4790),
    [anon_sym_var] = ACTIONS(4790),
    [sym_predefined_type] = ACTIONS(4790),
    [anon_sym_when] = ACTIONS(4790),
    [anon_sym_yield] = ACTIONS(4790),
    [anon_sym_from] = ACTIONS(4790),
    [anon_sym_join] = ACTIONS(4790),
    [anon_sym_on] = ACTIONS(4790),
    [anon_sym_equals] = ACTIONS(4790),
    [anon_sym_into] = ACTIONS(4790),
    [anon_sym_let] = ACTIONS(4790),
    [anon_sym_orderby] = ACTIONS(4790),
    [anon_sym_ascending] = ACTIONS(4790),
    [anon_sym_descending] = ACTIONS(4790),
    [anon_sym_group] = ACTIONS(4790),
    [anon_sym_by] = ACTIONS(4790),
    [anon_sym_select] = ACTIONS(4790),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4790),
    [anon_sym_nameof] = ACTIONS(4790),
    [sym_void_keyword] = ACTIONS(4790),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2529] = {
    [sym__preprocessor_call] = STATE(2529),
    [sym__identifier_token] = ACTIONS(4794),
    [anon_sym_extern] = ACTIONS(4794),
    [anon_sym_alias] = ACTIONS(4794),
    [anon_sym_global] = ACTIONS(4794),
    [anon_sym_using] = ACTIONS(4794),
    [anon_sym_static] = ACTIONS(4794),
    [anon_sym_LBRACK] = ACTIONS(4796),
    [anon_sym_event] = ACTIONS(4794),
    [anon_sym_LPAREN] = ACTIONS(4796),
    [anon_sym_abstract] = ACTIONS(4794),
    [anon_sym_async] = ACTIONS(4794),
    [anon_sym_const] = ACTIONS(4794),
    [anon_sym_fixed] = ACTIONS(4794),
    [anon_sym_internal] = ACTIONS(4794),
    [anon_sym_new] = ACTIONS(4794),
    [anon_sym_override] = ACTIONS(4794),
    [anon_sym_partial] = ACTIONS(4794),
    [anon_sym_private] = ACTIONS(4794),
    [anon_sym_protected] = ACTIONS(4794),
    [anon_sym_public] = ACTIONS(4794),
    [anon_sym_readonly] = ACTIONS(4794),
    [anon_sym_ref] = ACTIONS(4794),
    [anon_sym_sealed] = ACTIONS(4794),
    [anon_sym_unsafe] = ACTIONS(4794),
    [anon_sym_virtual] = ACTIONS(4794),
    [anon_sym_volatile] = ACTIONS(4794),
    [anon_sym_RBRACE] = ACTIONS(4796),
    [anon_sym_implicit] = ACTIONS(4794),
    [anon_sym_explicit] = ACTIONS(4794),
    [anon_sym_TILDE] = ACTIONS(4796),
    [anon_sym_where] = ACTIONS(4794),
    [anon_sym_class] = ACTIONS(4794),
    [anon_sym_struct] = ACTIONS(4794),
    [anon_sym_notnull] = ACTIONS(4794),
    [anon_sym_unmanaged] = ACTIONS(4794),
    [anon_sym_get] = ACTIONS(4794),
    [anon_sym_set] = ACTIONS(4794),
    [anon_sym_add] = ACTIONS(4794),
    [anon_sym_remove] = ACTIONS(4794),
    [anon_sym_enum] = ACTIONS(4794),
    [anon_sym_interface] = ACTIONS(4794),
    [anon_sym_delegate] = ACTIONS(4794),
    [anon_sym_record] = ACTIONS(4794),
    [anon_sym_namespace] = ACTIONS(4794),
    [anon_sym_var] = ACTIONS(4794),
    [sym_predefined_type] = ACTIONS(4794),
    [anon_sym_when] = ACTIONS(4794),
    [anon_sym_yield] = ACTIONS(4794),
    [anon_sym_from] = ACTIONS(4794),
    [anon_sym_join] = ACTIONS(4794),
    [anon_sym_on] = ACTIONS(4794),
    [anon_sym_equals] = ACTIONS(4794),
    [anon_sym_into] = ACTIONS(4794),
    [anon_sym_let] = ACTIONS(4794),
    [anon_sym_orderby] = ACTIONS(4794),
    [anon_sym_ascending] = ACTIONS(4794),
    [anon_sym_descending] = ACTIONS(4794),
    [anon_sym_group] = ACTIONS(4794),
    [anon_sym_by] = ACTIONS(4794),
    [anon_sym_select] = ACTIONS(4794),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4794),
    [anon_sym_nameof] = ACTIONS(4794),
    [sym_void_keyword] = ACTIONS(4794),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2530] = {
    [sym__preprocessor_call] = STATE(2530),
    [sym__identifier_token] = ACTIONS(4798),
    [anon_sym_extern] = ACTIONS(4798),
    [anon_sym_alias] = ACTIONS(4798),
    [anon_sym_global] = ACTIONS(4798),
    [anon_sym_using] = ACTIONS(4798),
    [anon_sym_static] = ACTIONS(4798),
    [anon_sym_LBRACK] = ACTIONS(4800),
    [anon_sym_event] = ACTIONS(4798),
    [anon_sym_LPAREN] = ACTIONS(4800),
    [anon_sym_abstract] = ACTIONS(4798),
    [anon_sym_async] = ACTIONS(4798),
    [anon_sym_const] = ACTIONS(4798),
    [anon_sym_fixed] = ACTIONS(4798),
    [anon_sym_internal] = ACTIONS(4798),
    [anon_sym_new] = ACTIONS(4798),
    [anon_sym_override] = ACTIONS(4798),
    [anon_sym_partial] = ACTIONS(4798),
    [anon_sym_private] = ACTIONS(4798),
    [anon_sym_protected] = ACTIONS(4798),
    [anon_sym_public] = ACTIONS(4798),
    [anon_sym_readonly] = ACTIONS(4798),
    [anon_sym_ref] = ACTIONS(4798),
    [anon_sym_sealed] = ACTIONS(4798),
    [anon_sym_unsafe] = ACTIONS(4798),
    [anon_sym_virtual] = ACTIONS(4798),
    [anon_sym_volatile] = ACTIONS(4798),
    [anon_sym_RBRACE] = ACTIONS(4800),
    [anon_sym_implicit] = ACTIONS(4798),
    [anon_sym_explicit] = ACTIONS(4798),
    [anon_sym_TILDE] = ACTIONS(4800),
    [anon_sym_where] = ACTIONS(4798),
    [anon_sym_class] = ACTIONS(4798),
    [anon_sym_struct] = ACTIONS(4798),
    [anon_sym_notnull] = ACTIONS(4798),
    [anon_sym_unmanaged] = ACTIONS(4798),
    [anon_sym_get] = ACTIONS(4798),
    [anon_sym_set] = ACTIONS(4798),
    [anon_sym_add] = ACTIONS(4798),
    [anon_sym_remove] = ACTIONS(4798),
    [anon_sym_enum] = ACTIONS(4798),
    [anon_sym_interface] = ACTIONS(4798),
    [anon_sym_delegate] = ACTIONS(4798),
    [anon_sym_record] = ACTIONS(4798),
    [anon_sym_namespace] = ACTIONS(4798),
    [anon_sym_var] = ACTIONS(4798),
    [sym_predefined_type] = ACTIONS(4798),
    [anon_sym_when] = ACTIONS(4798),
    [anon_sym_yield] = ACTIONS(4798),
    [anon_sym_from] = ACTIONS(4798),
    [anon_sym_join] = ACTIONS(4798),
    [anon_sym_on] = ACTIONS(4798),
    [anon_sym_equals] = ACTIONS(4798),
    [anon_sym_into] = ACTIONS(4798),
    [anon_sym_let] = ACTIONS(4798),
    [anon_sym_orderby] = ACTIONS(4798),
    [anon_sym_ascending] = ACTIONS(4798),
    [anon_sym_descending] = ACTIONS(4798),
    [anon_sym_group] = ACTIONS(4798),
    [anon_sym_by] = ACTIONS(4798),
    [anon_sym_select] = ACTIONS(4798),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4798),
    [anon_sym_nameof] = ACTIONS(4798),
    [sym_void_keyword] = ACTIONS(4798),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2531] = {
    [sym__preprocessor_call] = STATE(2531),
    [sym__identifier_token] = ACTIONS(4802),
    [anon_sym_extern] = ACTIONS(4802),
    [anon_sym_alias] = ACTIONS(4802),
    [anon_sym_global] = ACTIONS(4802),
    [anon_sym_using] = ACTIONS(4802),
    [anon_sym_static] = ACTIONS(4802),
    [anon_sym_LBRACK] = ACTIONS(4804),
    [anon_sym_event] = ACTIONS(4802),
    [anon_sym_LPAREN] = ACTIONS(4804),
    [anon_sym_abstract] = ACTIONS(4802),
    [anon_sym_async] = ACTIONS(4802),
    [anon_sym_const] = ACTIONS(4802),
    [anon_sym_fixed] = ACTIONS(4802),
    [anon_sym_internal] = ACTIONS(4802),
    [anon_sym_new] = ACTIONS(4802),
    [anon_sym_override] = ACTIONS(4802),
    [anon_sym_partial] = ACTIONS(4802),
    [anon_sym_private] = ACTIONS(4802),
    [anon_sym_protected] = ACTIONS(4802),
    [anon_sym_public] = ACTIONS(4802),
    [anon_sym_readonly] = ACTIONS(4802),
    [anon_sym_ref] = ACTIONS(4802),
    [anon_sym_sealed] = ACTIONS(4802),
    [anon_sym_unsafe] = ACTIONS(4802),
    [anon_sym_virtual] = ACTIONS(4802),
    [anon_sym_volatile] = ACTIONS(4802),
    [anon_sym_RBRACE] = ACTIONS(4804),
    [anon_sym_implicit] = ACTIONS(4802),
    [anon_sym_explicit] = ACTIONS(4802),
    [anon_sym_TILDE] = ACTIONS(4804),
    [anon_sym_where] = ACTIONS(4802),
    [anon_sym_class] = ACTIONS(4802),
    [anon_sym_struct] = ACTIONS(4802),
    [anon_sym_notnull] = ACTIONS(4802),
    [anon_sym_unmanaged] = ACTIONS(4802),
    [anon_sym_get] = ACTIONS(4802),
    [anon_sym_set] = ACTIONS(4802),
    [anon_sym_add] = ACTIONS(4802),
    [anon_sym_remove] = ACTIONS(4802),
    [anon_sym_enum] = ACTIONS(4802),
    [anon_sym_interface] = ACTIONS(4802),
    [anon_sym_delegate] = ACTIONS(4802),
    [anon_sym_record] = ACTIONS(4802),
    [anon_sym_namespace] = ACTIONS(4802),
    [anon_sym_var] = ACTIONS(4802),
    [sym_predefined_type] = ACTIONS(4802),
    [anon_sym_when] = ACTIONS(4802),
    [anon_sym_yield] = ACTIONS(4802),
    [anon_sym_from] = ACTIONS(4802),
    [anon_sym_join] = ACTIONS(4802),
    [anon_sym_on] = ACTIONS(4802),
    [anon_sym_equals] = ACTIONS(4802),
    [anon_sym_into] = ACTIONS(4802),
    [anon_sym_let] = ACTIONS(4802),
    [anon_sym_orderby] = ACTIONS(4802),
    [anon_sym_ascending] = ACTIONS(4802),
    [anon_sym_descending] = ACTIONS(4802),
    [anon_sym_group] = ACTIONS(4802),
    [anon_sym_by] = ACTIONS(4802),
    [anon_sym_select] = ACTIONS(4802),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4802),
    [anon_sym_nameof] = ACTIONS(4802),
    [sym_void_keyword] = ACTIONS(4802),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2532] = {
    [sym__preprocessor_call] = STATE(2532),
    [sym__identifier_token] = ACTIONS(4806),
    [anon_sym_extern] = ACTIONS(4806),
    [anon_sym_alias] = ACTIONS(4806),
    [anon_sym_global] = ACTIONS(4806),
    [anon_sym_using] = ACTIONS(4806),
    [anon_sym_static] = ACTIONS(4806),
    [anon_sym_LBRACK] = ACTIONS(4808),
    [anon_sym_event] = ACTIONS(4806),
    [anon_sym_LPAREN] = ACTIONS(4808),
    [anon_sym_abstract] = ACTIONS(4806),
    [anon_sym_async] = ACTIONS(4806),
    [anon_sym_const] = ACTIONS(4806),
    [anon_sym_fixed] = ACTIONS(4806),
    [anon_sym_internal] = ACTIONS(4806),
    [anon_sym_new] = ACTIONS(4806),
    [anon_sym_override] = ACTIONS(4806),
    [anon_sym_partial] = ACTIONS(4806),
    [anon_sym_private] = ACTIONS(4806),
    [anon_sym_protected] = ACTIONS(4806),
    [anon_sym_public] = ACTIONS(4806),
    [anon_sym_readonly] = ACTIONS(4806),
    [anon_sym_ref] = ACTIONS(4806),
    [anon_sym_sealed] = ACTIONS(4806),
    [anon_sym_unsafe] = ACTIONS(4806),
    [anon_sym_virtual] = ACTIONS(4806),
    [anon_sym_volatile] = ACTIONS(4806),
    [anon_sym_RBRACE] = ACTIONS(4808),
    [anon_sym_implicit] = ACTIONS(4806),
    [anon_sym_explicit] = ACTIONS(4806),
    [anon_sym_TILDE] = ACTIONS(4808),
    [anon_sym_where] = ACTIONS(4806),
    [anon_sym_class] = ACTIONS(4806),
    [anon_sym_struct] = ACTIONS(4806),
    [anon_sym_notnull] = ACTIONS(4806),
    [anon_sym_unmanaged] = ACTIONS(4806),
    [anon_sym_get] = ACTIONS(4806),
    [anon_sym_set] = ACTIONS(4806),
    [anon_sym_add] = ACTIONS(4806),
    [anon_sym_remove] = ACTIONS(4806),
    [anon_sym_enum] = ACTIONS(4806),
    [anon_sym_interface] = ACTIONS(4806),
    [anon_sym_delegate] = ACTIONS(4806),
    [anon_sym_record] = ACTIONS(4806),
    [anon_sym_namespace] = ACTIONS(4806),
    [anon_sym_var] = ACTIONS(4806),
    [sym_predefined_type] = ACTIONS(4806),
    [anon_sym_when] = ACTIONS(4806),
    [anon_sym_yield] = ACTIONS(4806),
    [anon_sym_from] = ACTIONS(4806),
    [anon_sym_join] = ACTIONS(4806),
    [anon_sym_on] = ACTIONS(4806),
    [anon_sym_equals] = ACTIONS(4806),
    [anon_sym_into] = ACTIONS(4806),
    [anon_sym_let] = ACTIONS(4806),
    [anon_sym_orderby] = ACTIONS(4806),
    [anon_sym_ascending] = ACTIONS(4806),
    [anon_sym_descending] = ACTIONS(4806),
    [anon_sym_group] = ACTIONS(4806),
    [anon_sym_by] = ACTIONS(4806),
    [anon_sym_select] = ACTIONS(4806),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4806),
    [anon_sym_nameof] = ACTIONS(4806),
    [sym_void_keyword] = ACTIONS(4806),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2533] = {
    [sym__preprocessor_call] = STATE(2533),
    [sym__identifier_token] = ACTIONS(4810),
    [anon_sym_extern] = ACTIONS(4810),
    [anon_sym_alias] = ACTIONS(4810),
    [anon_sym_global] = ACTIONS(4810),
    [anon_sym_using] = ACTIONS(4810),
    [anon_sym_static] = ACTIONS(4810),
    [anon_sym_LBRACK] = ACTIONS(4812),
    [anon_sym_event] = ACTIONS(4810),
    [anon_sym_LPAREN] = ACTIONS(4812),
    [anon_sym_abstract] = ACTIONS(4810),
    [anon_sym_async] = ACTIONS(4810),
    [anon_sym_const] = ACTIONS(4810),
    [anon_sym_fixed] = ACTIONS(4810),
    [anon_sym_internal] = ACTIONS(4810),
    [anon_sym_new] = ACTIONS(4810),
    [anon_sym_override] = ACTIONS(4810),
    [anon_sym_partial] = ACTIONS(4810),
    [anon_sym_private] = ACTIONS(4810),
    [anon_sym_protected] = ACTIONS(4810),
    [anon_sym_public] = ACTIONS(4810),
    [anon_sym_readonly] = ACTIONS(4810),
    [anon_sym_ref] = ACTIONS(4810),
    [anon_sym_sealed] = ACTIONS(4810),
    [anon_sym_unsafe] = ACTIONS(4810),
    [anon_sym_virtual] = ACTIONS(4810),
    [anon_sym_volatile] = ACTIONS(4810),
    [anon_sym_RBRACE] = ACTIONS(4812),
    [anon_sym_implicit] = ACTIONS(4810),
    [anon_sym_explicit] = ACTIONS(4810),
    [anon_sym_TILDE] = ACTIONS(4812),
    [anon_sym_where] = ACTIONS(4810),
    [anon_sym_class] = ACTIONS(4810),
    [anon_sym_struct] = ACTIONS(4810),
    [anon_sym_notnull] = ACTIONS(4810),
    [anon_sym_unmanaged] = ACTIONS(4810),
    [anon_sym_get] = ACTIONS(4810),
    [anon_sym_set] = ACTIONS(4810),
    [anon_sym_add] = ACTIONS(4810),
    [anon_sym_remove] = ACTIONS(4810),
    [anon_sym_enum] = ACTIONS(4810),
    [anon_sym_interface] = ACTIONS(4810),
    [anon_sym_delegate] = ACTIONS(4810),
    [anon_sym_record] = ACTIONS(4810),
    [anon_sym_namespace] = ACTIONS(4810),
    [anon_sym_var] = ACTIONS(4810),
    [sym_predefined_type] = ACTIONS(4810),
    [anon_sym_when] = ACTIONS(4810),
    [anon_sym_yield] = ACTIONS(4810),
    [anon_sym_from] = ACTIONS(4810),
    [anon_sym_join] = ACTIONS(4810),
    [anon_sym_on] = ACTIONS(4810),
    [anon_sym_equals] = ACTIONS(4810),
    [anon_sym_into] = ACTIONS(4810),
    [anon_sym_let] = ACTIONS(4810),
    [anon_sym_orderby] = ACTIONS(4810),
    [anon_sym_ascending] = ACTIONS(4810),
    [anon_sym_descending] = ACTIONS(4810),
    [anon_sym_group] = ACTIONS(4810),
    [anon_sym_by] = ACTIONS(4810),
    [anon_sym_select] = ACTIONS(4810),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4810),
    [anon_sym_nameof] = ACTIONS(4810),
    [sym_void_keyword] = ACTIONS(4810),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2534] = {
    [sym__preprocessor_call] = STATE(2534),
    [sym__identifier_token] = ACTIONS(4814),
    [anon_sym_extern] = ACTIONS(4814),
    [anon_sym_alias] = ACTIONS(4814),
    [anon_sym_global] = ACTIONS(4814),
    [anon_sym_using] = ACTIONS(4814),
    [anon_sym_static] = ACTIONS(4814),
    [anon_sym_LBRACK] = ACTIONS(4816),
    [anon_sym_event] = ACTIONS(4814),
    [anon_sym_LPAREN] = ACTIONS(4816),
    [anon_sym_abstract] = ACTIONS(4814),
    [anon_sym_async] = ACTIONS(4814),
    [anon_sym_const] = ACTIONS(4814),
    [anon_sym_fixed] = ACTIONS(4814),
    [anon_sym_internal] = ACTIONS(4814),
    [anon_sym_new] = ACTIONS(4814),
    [anon_sym_override] = ACTIONS(4814),
    [anon_sym_partial] = ACTIONS(4814),
    [anon_sym_private] = ACTIONS(4814),
    [anon_sym_protected] = ACTIONS(4814),
    [anon_sym_public] = ACTIONS(4814),
    [anon_sym_readonly] = ACTIONS(4814),
    [anon_sym_ref] = ACTIONS(4814),
    [anon_sym_sealed] = ACTIONS(4814),
    [anon_sym_unsafe] = ACTIONS(4814),
    [anon_sym_virtual] = ACTIONS(4814),
    [anon_sym_volatile] = ACTIONS(4814),
    [anon_sym_RBRACE] = ACTIONS(4816),
    [anon_sym_implicit] = ACTIONS(4814),
    [anon_sym_explicit] = ACTIONS(4814),
    [anon_sym_TILDE] = ACTIONS(4816),
    [anon_sym_where] = ACTIONS(4814),
    [anon_sym_class] = ACTIONS(4814),
    [anon_sym_struct] = ACTIONS(4814),
    [anon_sym_notnull] = ACTIONS(4814),
    [anon_sym_unmanaged] = ACTIONS(4814),
    [anon_sym_get] = ACTIONS(4814),
    [anon_sym_set] = ACTIONS(4814),
    [anon_sym_add] = ACTIONS(4814),
    [anon_sym_remove] = ACTIONS(4814),
    [anon_sym_enum] = ACTIONS(4814),
    [anon_sym_interface] = ACTIONS(4814),
    [anon_sym_delegate] = ACTIONS(4814),
    [anon_sym_record] = ACTIONS(4814),
    [anon_sym_namespace] = ACTIONS(4814),
    [anon_sym_var] = ACTIONS(4814),
    [sym_predefined_type] = ACTIONS(4814),
    [anon_sym_when] = ACTIONS(4814),
    [anon_sym_yield] = ACTIONS(4814),
    [anon_sym_from] = ACTIONS(4814),
    [anon_sym_join] = ACTIONS(4814),
    [anon_sym_on] = ACTIONS(4814),
    [anon_sym_equals] = ACTIONS(4814),
    [anon_sym_into] = ACTIONS(4814),
    [anon_sym_let] = ACTIONS(4814),
    [anon_sym_orderby] = ACTIONS(4814),
    [anon_sym_ascending] = ACTIONS(4814),
    [anon_sym_descending] = ACTIONS(4814),
    [anon_sym_group] = ACTIONS(4814),
    [anon_sym_by] = ACTIONS(4814),
    [anon_sym_select] = ACTIONS(4814),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4814),
    [anon_sym_nameof] = ACTIONS(4814),
    [sym_void_keyword] = ACTIONS(4814),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2535] = {
    [sym__preprocessor_call] = STATE(2535),
    [sym__identifier_token] = ACTIONS(4818),
    [anon_sym_extern] = ACTIONS(4818),
    [anon_sym_alias] = ACTIONS(4818),
    [anon_sym_global] = ACTIONS(4818),
    [anon_sym_using] = ACTIONS(4818),
    [anon_sym_static] = ACTIONS(4818),
    [anon_sym_LBRACK] = ACTIONS(4820),
    [anon_sym_event] = ACTIONS(4818),
    [anon_sym_LPAREN] = ACTIONS(4820),
    [anon_sym_abstract] = ACTIONS(4818),
    [anon_sym_async] = ACTIONS(4818),
    [anon_sym_const] = ACTIONS(4818),
    [anon_sym_fixed] = ACTIONS(4818),
    [anon_sym_internal] = ACTIONS(4818),
    [anon_sym_new] = ACTIONS(4818),
    [anon_sym_override] = ACTIONS(4818),
    [anon_sym_partial] = ACTIONS(4818),
    [anon_sym_private] = ACTIONS(4818),
    [anon_sym_protected] = ACTIONS(4818),
    [anon_sym_public] = ACTIONS(4818),
    [anon_sym_readonly] = ACTIONS(4818),
    [anon_sym_ref] = ACTIONS(4818),
    [anon_sym_sealed] = ACTIONS(4818),
    [anon_sym_unsafe] = ACTIONS(4818),
    [anon_sym_virtual] = ACTIONS(4818),
    [anon_sym_volatile] = ACTIONS(4818),
    [anon_sym_RBRACE] = ACTIONS(4820),
    [anon_sym_implicit] = ACTIONS(4818),
    [anon_sym_explicit] = ACTIONS(4818),
    [anon_sym_TILDE] = ACTIONS(4820),
    [anon_sym_where] = ACTIONS(4818),
    [anon_sym_class] = ACTIONS(4818),
    [anon_sym_struct] = ACTIONS(4818),
    [anon_sym_notnull] = ACTIONS(4818),
    [anon_sym_unmanaged] = ACTIONS(4818),
    [anon_sym_get] = ACTIONS(4818),
    [anon_sym_set] = ACTIONS(4818),
    [anon_sym_add] = ACTIONS(4818),
    [anon_sym_remove] = ACTIONS(4818),
    [anon_sym_enum] = ACTIONS(4818),
    [anon_sym_interface] = ACTIONS(4818),
    [anon_sym_delegate] = ACTIONS(4818),
    [anon_sym_record] = ACTIONS(4818),
    [anon_sym_namespace] = ACTIONS(4818),
    [anon_sym_var] = ACTIONS(4818),
    [sym_predefined_type] = ACTIONS(4818),
    [anon_sym_when] = ACTIONS(4818),
    [anon_sym_yield] = ACTIONS(4818),
    [anon_sym_from] = ACTIONS(4818),
    [anon_sym_join] = ACTIONS(4818),
    [anon_sym_on] = ACTIONS(4818),
    [anon_sym_equals] = ACTIONS(4818),
    [anon_sym_into] = ACTIONS(4818),
    [anon_sym_let] = ACTIONS(4818),
    [anon_sym_orderby] = ACTIONS(4818),
    [anon_sym_ascending] = ACTIONS(4818),
    [anon_sym_descending] = ACTIONS(4818),
    [anon_sym_group] = ACTIONS(4818),
    [anon_sym_by] = ACTIONS(4818),
    [anon_sym_select] = ACTIONS(4818),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4818),
    [anon_sym_nameof] = ACTIONS(4818),
    [sym_void_keyword] = ACTIONS(4818),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2536] = {
    [sym__preprocessor_call] = STATE(2536),
    [sym__identifier_token] = ACTIONS(4822),
    [anon_sym_extern] = ACTIONS(4822),
    [anon_sym_alias] = ACTIONS(4822),
    [anon_sym_global] = ACTIONS(4822),
    [anon_sym_using] = ACTIONS(4822),
    [anon_sym_static] = ACTIONS(4822),
    [anon_sym_LBRACK] = ACTIONS(4824),
    [anon_sym_event] = ACTIONS(4822),
    [anon_sym_LPAREN] = ACTIONS(4824),
    [anon_sym_abstract] = ACTIONS(4822),
    [anon_sym_async] = ACTIONS(4822),
    [anon_sym_const] = ACTIONS(4822),
    [anon_sym_fixed] = ACTIONS(4822),
    [anon_sym_internal] = ACTIONS(4822),
    [anon_sym_new] = ACTIONS(4822),
    [anon_sym_override] = ACTIONS(4822),
    [anon_sym_partial] = ACTIONS(4822),
    [anon_sym_private] = ACTIONS(4822),
    [anon_sym_protected] = ACTIONS(4822),
    [anon_sym_public] = ACTIONS(4822),
    [anon_sym_readonly] = ACTIONS(4822),
    [anon_sym_ref] = ACTIONS(4822),
    [anon_sym_sealed] = ACTIONS(4822),
    [anon_sym_unsafe] = ACTIONS(4822),
    [anon_sym_virtual] = ACTIONS(4822),
    [anon_sym_volatile] = ACTIONS(4822),
    [anon_sym_RBRACE] = ACTIONS(4824),
    [anon_sym_implicit] = ACTIONS(4822),
    [anon_sym_explicit] = ACTIONS(4822),
    [anon_sym_TILDE] = ACTIONS(4824),
    [anon_sym_where] = ACTIONS(4822),
    [anon_sym_class] = ACTIONS(4822),
    [anon_sym_struct] = ACTIONS(4822),
    [anon_sym_notnull] = ACTIONS(4822),
    [anon_sym_unmanaged] = ACTIONS(4822),
    [anon_sym_get] = ACTIONS(4822),
    [anon_sym_set] = ACTIONS(4822),
    [anon_sym_add] = ACTIONS(4822),
    [anon_sym_remove] = ACTIONS(4822),
    [anon_sym_enum] = ACTIONS(4822),
    [anon_sym_interface] = ACTIONS(4822),
    [anon_sym_delegate] = ACTIONS(4822),
    [anon_sym_record] = ACTIONS(4822),
    [anon_sym_namespace] = ACTIONS(4822),
    [anon_sym_var] = ACTIONS(4822),
    [sym_predefined_type] = ACTIONS(4822),
    [anon_sym_when] = ACTIONS(4822),
    [anon_sym_yield] = ACTIONS(4822),
    [anon_sym_from] = ACTIONS(4822),
    [anon_sym_join] = ACTIONS(4822),
    [anon_sym_on] = ACTIONS(4822),
    [anon_sym_equals] = ACTIONS(4822),
    [anon_sym_into] = ACTIONS(4822),
    [anon_sym_let] = ACTIONS(4822),
    [anon_sym_orderby] = ACTIONS(4822),
    [anon_sym_ascending] = ACTIONS(4822),
    [anon_sym_descending] = ACTIONS(4822),
    [anon_sym_group] = ACTIONS(4822),
    [anon_sym_by] = ACTIONS(4822),
    [anon_sym_select] = ACTIONS(4822),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4822),
    [anon_sym_nameof] = ACTIONS(4822),
    [sym_void_keyword] = ACTIONS(4822),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2537] = {
    [sym__preprocessor_call] = STATE(2537),
    [sym__identifier_token] = ACTIONS(4826),
    [anon_sym_extern] = ACTIONS(4826),
    [anon_sym_alias] = ACTIONS(4826),
    [anon_sym_global] = ACTIONS(4826),
    [anon_sym_using] = ACTIONS(4826),
    [anon_sym_static] = ACTIONS(4826),
    [anon_sym_LBRACK] = ACTIONS(4828),
    [anon_sym_event] = ACTIONS(4826),
    [anon_sym_LPAREN] = ACTIONS(4828),
    [anon_sym_abstract] = ACTIONS(4826),
    [anon_sym_async] = ACTIONS(4826),
    [anon_sym_const] = ACTIONS(4826),
    [anon_sym_fixed] = ACTIONS(4826),
    [anon_sym_internal] = ACTIONS(4826),
    [anon_sym_new] = ACTIONS(4826),
    [anon_sym_override] = ACTIONS(4826),
    [anon_sym_partial] = ACTIONS(4826),
    [anon_sym_private] = ACTIONS(4826),
    [anon_sym_protected] = ACTIONS(4826),
    [anon_sym_public] = ACTIONS(4826),
    [anon_sym_readonly] = ACTIONS(4826),
    [anon_sym_ref] = ACTIONS(4826),
    [anon_sym_sealed] = ACTIONS(4826),
    [anon_sym_unsafe] = ACTIONS(4826),
    [anon_sym_virtual] = ACTIONS(4826),
    [anon_sym_volatile] = ACTIONS(4826),
    [anon_sym_RBRACE] = ACTIONS(4828),
    [anon_sym_implicit] = ACTIONS(4826),
    [anon_sym_explicit] = ACTIONS(4826),
    [anon_sym_TILDE] = ACTIONS(4828),
    [anon_sym_where] = ACTIONS(4826),
    [anon_sym_class] = ACTIONS(4826),
    [anon_sym_struct] = ACTIONS(4826),
    [anon_sym_notnull] = ACTIONS(4826),
    [anon_sym_unmanaged] = ACTIONS(4826),
    [anon_sym_get] = ACTIONS(4826),
    [anon_sym_set] = ACTIONS(4826),
    [anon_sym_add] = ACTIONS(4826),
    [anon_sym_remove] = ACTIONS(4826),
    [anon_sym_enum] = ACTIONS(4826),
    [anon_sym_interface] = ACTIONS(4826),
    [anon_sym_delegate] = ACTIONS(4826),
    [anon_sym_record] = ACTIONS(4826),
    [anon_sym_namespace] = ACTIONS(4826),
    [anon_sym_var] = ACTIONS(4826),
    [sym_predefined_type] = ACTIONS(4826),
    [anon_sym_when] = ACTIONS(4826),
    [anon_sym_yield] = ACTIONS(4826),
    [anon_sym_from] = ACTIONS(4826),
    [anon_sym_join] = ACTIONS(4826),
    [anon_sym_on] = ACTIONS(4826),
    [anon_sym_equals] = ACTIONS(4826),
    [anon_sym_into] = ACTIONS(4826),
    [anon_sym_let] = ACTIONS(4826),
    [anon_sym_orderby] = ACTIONS(4826),
    [anon_sym_ascending] = ACTIONS(4826),
    [anon_sym_descending] = ACTIONS(4826),
    [anon_sym_group] = ACTIONS(4826),
    [anon_sym_by] = ACTIONS(4826),
    [anon_sym_select] = ACTIONS(4826),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4826),
    [anon_sym_nameof] = ACTIONS(4826),
    [sym_void_keyword] = ACTIONS(4826),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2538] = {
    [sym__preprocessor_call] = STATE(2538),
    [sym__identifier_token] = ACTIONS(4830),
    [anon_sym_extern] = ACTIONS(4830),
    [anon_sym_alias] = ACTIONS(4830),
    [anon_sym_global] = ACTIONS(4830),
    [anon_sym_using] = ACTIONS(4830),
    [anon_sym_static] = ACTIONS(4830),
    [anon_sym_LBRACK] = ACTIONS(4832),
    [anon_sym_event] = ACTIONS(4830),
    [anon_sym_LPAREN] = ACTIONS(4832),
    [anon_sym_abstract] = ACTIONS(4830),
    [anon_sym_async] = ACTIONS(4830),
    [anon_sym_const] = ACTIONS(4830),
    [anon_sym_fixed] = ACTIONS(4830),
    [anon_sym_internal] = ACTIONS(4830),
    [anon_sym_new] = ACTIONS(4830),
    [anon_sym_override] = ACTIONS(4830),
    [anon_sym_partial] = ACTIONS(4830),
    [anon_sym_private] = ACTIONS(4830),
    [anon_sym_protected] = ACTIONS(4830),
    [anon_sym_public] = ACTIONS(4830),
    [anon_sym_readonly] = ACTIONS(4830),
    [anon_sym_ref] = ACTIONS(4830),
    [anon_sym_sealed] = ACTIONS(4830),
    [anon_sym_unsafe] = ACTIONS(4830),
    [anon_sym_virtual] = ACTIONS(4830),
    [anon_sym_volatile] = ACTIONS(4830),
    [anon_sym_RBRACE] = ACTIONS(4832),
    [anon_sym_implicit] = ACTIONS(4830),
    [anon_sym_explicit] = ACTIONS(4830),
    [anon_sym_TILDE] = ACTIONS(4832),
    [anon_sym_where] = ACTIONS(4830),
    [anon_sym_class] = ACTIONS(4830),
    [anon_sym_struct] = ACTIONS(4830),
    [anon_sym_notnull] = ACTIONS(4830),
    [anon_sym_unmanaged] = ACTIONS(4830),
    [anon_sym_get] = ACTIONS(4830),
    [anon_sym_set] = ACTIONS(4830),
    [anon_sym_add] = ACTIONS(4830),
    [anon_sym_remove] = ACTIONS(4830),
    [anon_sym_enum] = ACTIONS(4830),
    [anon_sym_interface] = ACTIONS(4830),
    [anon_sym_delegate] = ACTIONS(4830),
    [anon_sym_record] = ACTIONS(4830),
    [anon_sym_namespace] = ACTIONS(4830),
    [anon_sym_var] = ACTIONS(4830),
    [sym_predefined_type] = ACTIONS(4830),
    [anon_sym_when] = ACTIONS(4830),
    [anon_sym_yield] = ACTIONS(4830),
    [anon_sym_from] = ACTIONS(4830),
    [anon_sym_join] = ACTIONS(4830),
    [anon_sym_on] = ACTIONS(4830),
    [anon_sym_equals] = ACTIONS(4830),
    [anon_sym_into] = ACTIONS(4830),
    [anon_sym_let] = ACTIONS(4830),
    [anon_sym_orderby] = ACTIONS(4830),
    [anon_sym_ascending] = ACTIONS(4830),
    [anon_sym_descending] = ACTIONS(4830),
    [anon_sym_group] = ACTIONS(4830),
    [anon_sym_by] = ACTIONS(4830),
    [anon_sym_select] = ACTIONS(4830),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4830),
    [anon_sym_nameof] = ACTIONS(4830),
    [sym_void_keyword] = ACTIONS(4830),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2539] = {
    [sym__preprocessor_call] = STATE(2539),
    [sym__identifier_token] = ACTIONS(4834),
    [anon_sym_extern] = ACTIONS(4834),
    [anon_sym_alias] = ACTIONS(4834),
    [anon_sym_global] = ACTIONS(4834),
    [anon_sym_using] = ACTIONS(4834),
    [anon_sym_static] = ACTIONS(4834),
    [anon_sym_LBRACK] = ACTIONS(4836),
    [anon_sym_event] = ACTIONS(4834),
    [anon_sym_LPAREN] = ACTIONS(4836),
    [anon_sym_abstract] = ACTIONS(4834),
    [anon_sym_async] = ACTIONS(4834),
    [anon_sym_const] = ACTIONS(4834),
    [anon_sym_fixed] = ACTIONS(4834),
    [anon_sym_internal] = ACTIONS(4834),
    [anon_sym_new] = ACTIONS(4834),
    [anon_sym_override] = ACTIONS(4834),
    [anon_sym_partial] = ACTIONS(4834),
    [anon_sym_private] = ACTIONS(4834),
    [anon_sym_protected] = ACTIONS(4834),
    [anon_sym_public] = ACTIONS(4834),
    [anon_sym_readonly] = ACTIONS(4834),
    [anon_sym_ref] = ACTIONS(4834),
    [anon_sym_sealed] = ACTIONS(4834),
    [anon_sym_unsafe] = ACTIONS(4834),
    [anon_sym_virtual] = ACTIONS(4834),
    [anon_sym_volatile] = ACTIONS(4834),
    [anon_sym_RBRACE] = ACTIONS(4836),
    [anon_sym_implicit] = ACTIONS(4834),
    [anon_sym_explicit] = ACTIONS(4834),
    [anon_sym_TILDE] = ACTIONS(4836),
    [anon_sym_where] = ACTIONS(4834),
    [anon_sym_class] = ACTIONS(4834),
    [anon_sym_struct] = ACTIONS(4834),
    [anon_sym_notnull] = ACTIONS(4834),
    [anon_sym_unmanaged] = ACTIONS(4834),
    [anon_sym_get] = ACTIONS(4834),
    [anon_sym_set] = ACTIONS(4834),
    [anon_sym_add] = ACTIONS(4834),
    [anon_sym_remove] = ACTIONS(4834),
    [anon_sym_enum] = ACTIONS(4834),
    [anon_sym_interface] = ACTIONS(4834),
    [anon_sym_delegate] = ACTIONS(4834),
    [anon_sym_record] = ACTIONS(4834),
    [anon_sym_namespace] = ACTIONS(4834),
    [anon_sym_var] = ACTIONS(4834),
    [sym_predefined_type] = ACTIONS(4834),
    [anon_sym_when] = ACTIONS(4834),
    [anon_sym_yield] = ACTIONS(4834),
    [anon_sym_from] = ACTIONS(4834),
    [anon_sym_join] = ACTIONS(4834),
    [anon_sym_on] = ACTIONS(4834),
    [anon_sym_equals] = ACTIONS(4834),
    [anon_sym_into] = ACTIONS(4834),
    [anon_sym_let] = ACTIONS(4834),
    [anon_sym_orderby] = ACTIONS(4834),
    [anon_sym_ascending] = ACTIONS(4834),
    [anon_sym_descending] = ACTIONS(4834),
    [anon_sym_group] = ACTIONS(4834),
    [anon_sym_by] = ACTIONS(4834),
    [anon_sym_select] = ACTIONS(4834),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4834),
    [anon_sym_nameof] = ACTIONS(4834),
    [sym_void_keyword] = ACTIONS(4834),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2540] = {
    [sym__preprocessor_call] = STATE(2540),
    [sym__identifier_token] = ACTIONS(4838),
    [anon_sym_extern] = ACTIONS(4838),
    [anon_sym_alias] = ACTIONS(4838),
    [anon_sym_global] = ACTIONS(4838),
    [anon_sym_using] = ACTIONS(4838),
    [anon_sym_static] = ACTIONS(4838),
    [anon_sym_LBRACK] = ACTIONS(4840),
    [anon_sym_event] = ACTIONS(4838),
    [anon_sym_LPAREN] = ACTIONS(4840),
    [anon_sym_abstract] = ACTIONS(4838),
    [anon_sym_async] = ACTIONS(4838),
    [anon_sym_const] = ACTIONS(4838),
    [anon_sym_fixed] = ACTIONS(4838),
    [anon_sym_internal] = ACTIONS(4838),
    [anon_sym_new] = ACTIONS(4838),
    [anon_sym_override] = ACTIONS(4838),
    [anon_sym_partial] = ACTIONS(4838),
    [anon_sym_private] = ACTIONS(4838),
    [anon_sym_protected] = ACTIONS(4838),
    [anon_sym_public] = ACTIONS(4838),
    [anon_sym_readonly] = ACTIONS(4838),
    [anon_sym_ref] = ACTIONS(4838),
    [anon_sym_sealed] = ACTIONS(4838),
    [anon_sym_unsafe] = ACTIONS(4838),
    [anon_sym_virtual] = ACTIONS(4838),
    [anon_sym_volatile] = ACTIONS(4838),
    [anon_sym_RBRACE] = ACTIONS(4840),
    [anon_sym_implicit] = ACTIONS(4838),
    [anon_sym_explicit] = ACTIONS(4838),
    [anon_sym_TILDE] = ACTIONS(4840),
    [anon_sym_where] = ACTIONS(4838),
    [anon_sym_class] = ACTIONS(4838),
    [anon_sym_struct] = ACTIONS(4838),
    [anon_sym_notnull] = ACTIONS(4838),
    [anon_sym_unmanaged] = ACTIONS(4838),
    [anon_sym_get] = ACTIONS(4838),
    [anon_sym_set] = ACTIONS(4838),
    [anon_sym_add] = ACTIONS(4838),
    [anon_sym_remove] = ACTIONS(4838),
    [anon_sym_enum] = ACTIONS(4838),
    [anon_sym_interface] = ACTIONS(4838),
    [anon_sym_delegate] = ACTIONS(4838),
    [anon_sym_record] = ACTIONS(4838),
    [anon_sym_namespace] = ACTIONS(4838),
    [anon_sym_var] = ACTIONS(4838),
    [sym_predefined_type] = ACTIONS(4838),
    [anon_sym_when] = ACTIONS(4838),
    [anon_sym_yield] = ACTIONS(4838),
    [anon_sym_from] = ACTIONS(4838),
    [anon_sym_join] = ACTIONS(4838),
    [anon_sym_on] = ACTIONS(4838),
    [anon_sym_equals] = ACTIONS(4838),
    [anon_sym_into] = ACTIONS(4838),
    [anon_sym_let] = ACTIONS(4838),
    [anon_sym_orderby] = ACTIONS(4838),
    [anon_sym_ascending] = ACTIONS(4838),
    [anon_sym_descending] = ACTIONS(4838),
    [anon_sym_group] = ACTIONS(4838),
    [anon_sym_by] = ACTIONS(4838),
    [anon_sym_select] = ACTIONS(4838),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4838),
    [anon_sym_nameof] = ACTIONS(4838),
    [sym_void_keyword] = ACTIONS(4838),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2541] = {
    [sym__preprocessor_call] = STATE(2541),
    [sym__identifier_token] = ACTIONS(4842),
    [anon_sym_extern] = ACTIONS(4842),
    [anon_sym_alias] = ACTIONS(4842),
    [anon_sym_global] = ACTIONS(4842),
    [anon_sym_using] = ACTIONS(4842),
    [anon_sym_static] = ACTIONS(4842),
    [anon_sym_LBRACK] = ACTIONS(4844),
    [anon_sym_event] = ACTIONS(4842),
    [anon_sym_LPAREN] = ACTIONS(4844),
    [anon_sym_abstract] = ACTIONS(4842),
    [anon_sym_async] = ACTIONS(4842),
    [anon_sym_const] = ACTIONS(4842),
    [anon_sym_fixed] = ACTIONS(4842),
    [anon_sym_internal] = ACTIONS(4842),
    [anon_sym_new] = ACTIONS(4842),
    [anon_sym_override] = ACTIONS(4842),
    [anon_sym_partial] = ACTIONS(4842),
    [anon_sym_private] = ACTIONS(4842),
    [anon_sym_protected] = ACTIONS(4842),
    [anon_sym_public] = ACTIONS(4842),
    [anon_sym_readonly] = ACTIONS(4842),
    [anon_sym_ref] = ACTIONS(4842),
    [anon_sym_sealed] = ACTIONS(4842),
    [anon_sym_unsafe] = ACTIONS(4842),
    [anon_sym_virtual] = ACTIONS(4842),
    [anon_sym_volatile] = ACTIONS(4842),
    [anon_sym_RBRACE] = ACTIONS(4844),
    [anon_sym_implicit] = ACTIONS(4842),
    [anon_sym_explicit] = ACTIONS(4842),
    [anon_sym_TILDE] = ACTIONS(4844),
    [anon_sym_where] = ACTIONS(4842),
    [anon_sym_class] = ACTIONS(4842),
    [anon_sym_struct] = ACTIONS(4842),
    [anon_sym_notnull] = ACTIONS(4842),
    [anon_sym_unmanaged] = ACTIONS(4842),
    [anon_sym_get] = ACTIONS(4842),
    [anon_sym_set] = ACTIONS(4842),
    [anon_sym_add] = ACTIONS(4842),
    [anon_sym_remove] = ACTIONS(4842),
    [anon_sym_enum] = ACTIONS(4842),
    [anon_sym_interface] = ACTIONS(4842),
    [anon_sym_delegate] = ACTIONS(4842),
    [anon_sym_record] = ACTIONS(4842),
    [anon_sym_namespace] = ACTIONS(4842),
    [anon_sym_var] = ACTIONS(4842),
    [sym_predefined_type] = ACTIONS(4842),
    [anon_sym_when] = ACTIONS(4842),
    [anon_sym_yield] = ACTIONS(4842),
    [anon_sym_from] = ACTIONS(4842),
    [anon_sym_join] = ACTIONS(4842),
    [anon_sym_on] = ACTIONS(4842),
    [anon_sym_equals] = ACTIONS(4842),
    [anon_sym_into] = ACTIONS(4842),
    [anon_sym_let] = ACTIONS(4842),
    [anon_sym_orderby] = ACTIONS(4842),
    [anon_sym_ascending] = ACTIONS(4842),
    [anon_sym_descending] = ACTIONS(4842),
    [anon_sym_group] = ACTIONS(4842),
    [anon_sym_by] = ACTIONS(4842),
    [anon_sym_select] = ACTIONS(4842),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4842),
    [anon_sym_nameof] = ACTIONS(4842),
    [sym_void_keyword] = ACTIONS(4842),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2542] = {
    [sym__preprocessor_call] = STATE(2542),
    [sym__identifier_token] = ACTIONS(4846),
    [anon_sym_extern] = ACTIONS(4846),
    [anon_sym_alias] = ACTIONS(4846),
    [anon_sym_global] = ACTIONS(4846),
    [anon_sym_using] = ACTIONS(4846),
    [anon_sym_static] = ACTIONS(4846),
    [anon_sym_LBRACK] = ACTIONS(4848),
    [anon_sym_event] = ACTIONS(4846),
    [anon_sym_LPAREN] = ACTIONS(4848),
    [anon_sym_abstract] = ACTIONS(4846),
    [anon_sym_async] = ACTIONS(4846),
    [anon_sym_const] = ACTIONS(4846),
    [anon_sym_fixed] = ACTIONS(4846),
    [anon_sym_internal] = ACTIONS(4846),
    [anon_sym_new] = ACTIONS(4846),
    [anon_sym_override] = ACTIONS(4846),
    [anon_sym_partial] = ACTIONS(4846),
    [anon_sym_private] = ACTIONS(4846),
    [anon_sym_protected] = ACTIONS(4846),
    [anon_sym_public] = ACTIONS(4846),
    [anon_sym_readonly] = ACTIONS(4846),
    [anon_sym_ref] = ACTIONS(4846),
    [anon_sym_sealed] = ACTIONS(4846),
    [anon_sym_unsafe] = ACTIONS(4846),
    [anon_sym_virtual] = ACTIONS(4846),
    [anon_sym_volatile] = ACTIONS(4846),
    [anon_sym_RBRACE] = ACTIONS(4848),
    [anon_sym_implicit] = ACTIONS(4846),
    [anon_sym_explicit] = ACTIONS(4846),
    [anon_sym_TILDE] = ACTIONS(4848),
    [anon_sym_where] = ACTIONS(4846),
    [anon_sym_class] = ACTIONS(4846),
    [anon_sym_struct] = ACTIONS(4846),
    [anon_sym_notnull] = ACTIONS(4846),
    [anon_sym_unmanaged] = ACTIONS(4846),
    [anon_sym_get] = ACTIONS(4846),
    [anon_sym_set] = ACTIONS(4846),
    [anon_sym_add] = ACTIONS(4846),
    [anon_sym_remove] = ACTIONS(4846),
    [anon_sym_enum] = ACTIONS(4846),
    [anon_sym_interface] = ACTIONS(4846),
    [anon_sym_delegate] = ACTIONS(4846),
    [anon_sym_record] = ACTIONS(4846),
    [anon_sym_namespace] = ACTIONS(4846),
    [anon_sym_var] = ACTIONS(4846),
    [sym_predefined_type] = ACTIONS(4846),
    [anon_sym_when] = ACTIONS(4846),
    [anon_sym_yield] = ACTIONS(4846),
    [anon_sym_from] = ACTIONS(4846),
    [anon_sym_join] = ACTIONS(4846),
    [anon_sym_on] = ACTIONS(4846),
    [anon_sym_equals] = ACTIONS(4846),
    [anon_sym_into] = ACTIONS(4846),
    [anon_sym_let] = ACTIONS(4846),
    [anon_sym_orderby] = ACTIONS(4846),
    [anon_sym_ascending] = ACTIONS(4846),
    [anon_sym_descending] = ACTIONS(4846),
    [anon_sym_group] = ACTIONS(4846),
    [anon_sym_by] = ACTIONS(4846),
    [anon_sym_select] = ACTIONS(4846),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4846),
    [anon_sym_nameof] = ACTIONS(4846),
    [sym_void_keyword] = ACTIONS(4846),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2543] = {
    [sym__preprocessor_call] = STATE(2543),
    [sym__identifier_token] = ACTIONS(4850),
    [anon_sym_extern] = ACTIONS(4850),
    [anon_sym_alias] = ACTIONS(4850),
    [anon_sym_global] = ACTIONS(4850),
    [anon_sym_using] = ACTIONS(4850),
    [anon_sym_static] = ACTIONS(4850),
    [anon_sym_LBRACK] = ACTIONS(4852),
    [anon_sym_event] = ACTIONS(4850),
    [anon_sym_LPAREN] = ACTIONS(4852),
    [anon_sym_abstract] = ACTIONS(4850),
    [anon_sym_async] = ACTIONS(4850),
    [anon_sym_const] = ACTIONS(4850),
    [anon_sym_fixed] = ACTIONS(4850),
    [anon_sym_internal] = ACTIONS(4850),
    [anon_sym_new] = ACTIONS(4850),
    [anon_sym_override] = ACTIONS(4850),
    [anon_sym_partial] = ACTIONS(4850),
    [anon_sym_private] = ACTIONS(4850),
    [anon_sym_protected] = ACTIONS(4850),
    [anon_sym_public] = ACTIONS(4850),
    [anon_sym_readonly] = ACTIONS(4850),
    [anon_sym_ref] = ACTIONS(4850),
    [anon_sym_sealed] = ACTIONS(4850),
    [anon_sym_unsafe] = ACTIONS(4850),
    [anon_sym_virtual] = ACTIONS(4850),
    [anon_sym_volatile] = ACTIONS(4850),
    [anon_sym_RBRACE] = ACTIONS(4852),
    [anon_sym_implicit] = ACTIONS(4850),
    [anon_sym_explicit] = ACTIONS(4850),
    [anon_sym_TILDE] = ACTIONS(4852),
    [anon_sym_where] = ACTIONS(4850),
    [anon_sym_class] = ACTIONS(4850),
    [anon_sym_struct] = ACTIONS(4850),
    [anon_sym_notnull] = ACTIONS(4850),
    [anon_sym_unmanaged] = ACTIONS(4850),
    [anon_sym_get] = ACTIONS(4850),
    [anon_sym_set] = ACTIONS(4850),
    [anon_sym_add] = ACTIONS(4850),
    [anon_sym_remove] = ACTIONS(4850),
    [anon_sym_enum] = ACTIONS(4850),
    [anon_sym_interface] = ACTIONS(4850),
    [anon_sym_delegate] = ACTIONS(4850),
    [anon_sym_record] = ACTIONS(4850),
    [anon_sym_namespace] = ACTIONS(4850),
    [anon_sym_var] = ACTIONS(4850),
    [sym_predefined_type] = ACTIONS(4850),
    [anon_sym_when] = ACTIONS(4850),
    [anon_sym_yield] = ACTIONS(4850),
    [anon_sym_from] = ACTIONS(4850),
    [anon_sym_join] = ACTIONS(4850),
    [anon_sym_on] = ACTIONS(4850),
    [anon_sym_equals] = ACTIONS(4850),
    [anon_sym_into] = ACTIONS(4850),
    [anon_sym_let] = ACTIONS(4850),
    [anon_sym_orderby] = ACTIONS(4850),
    [anon_sym_ascending] = ACTIONS(4850),
    [anon_sym_descending] = ACTIONS(4850),
    [anon_sym_group] = ACTIONS(4850),
    [anon_sym_by] = ACTIONS(4850),
    [anon_sym_select] = ACTIONS(4850),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4850),
    [anon_sym_nameof] = ACTIONS(4850),
    [sym_void_keyword] = ACTIONS(4850),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2544] = {
    [sym__preprocessor_call] = STATE(2544),
    [sym__identifier_token] = ACTIONS(4854),
    [anon_sym_extern] = ACTIONS(4854),
    [anon_sym_alias] = ACTIONS(4854),
    [anon_sym_global] = ACTIONS(4854),
    [anon_sym_using] = ACTIONS(4854),
    [anon_sym_static] = ACTIONS(4854),
    [anon_sym_LBRACK] = ACTIONS(4856),
    [anon_sym_event] = ACTIONS(4854),
    [anon_sym_LPAREN] = ACTIONS(4856),
    [anon_sym_abstract] = ACTIONS(4854),
    [anon_sym_async] = ACTIONS(4854),
    [anon_sym_const] = ACTIONS(4854),
    [anon_sym_fixed] = ACTIONS(4854),
    [anon_sym_internal] = ACTIONS(4854),
    [anon_sym_new] = ACTIONS(4854),
    [anon_sym_override] = ACTIONS(4854),
    [anon_sym_partial] = ACTIONS(4854),
    [anon_sym_private] = ACTIONS(4854),
    [anon_sym_protected] = ACTIONS(4854),
    [anon_sym_public] = ACTIONS(4854),
    [anon_sym_readonly] = ACTIONS(4854),
    [anon_sym_ref] = ACTIONS(4854),
    [anon_sym_sealed] = ACTIONS(4854),
    [anon_sym_unsafe] = ACTIONS(4854),
    [anon_sym_virtual] = ACTIONS(4854),
    [anon_sym_volatile] = ACTIONS(4854),
    [anon_sym_RBRACE] = ACTIONS(4856),
    [anon_sym_implicit] = ACTIONS(4854),
    [anon_sym_explicit] = ACTIONS(4854),
    [anon_sym_TILDE] = ACTIONS(4856),
    [anon_sym_where] = ACTIONS(4854),
    [anon_sym_class] = ACTIONS(4854),
    [anon_sym_struct] = ACTIONS(4854),
    [anon_sym_notnull] = ACTIONS(4854),
    [anon_sym_unmanaged] = ACTIONS(4854),
    [anon_sym_get] = ACTIONS(4854),
    [anon_sym_set] = ACTIONS(4854),
    [anon_sym_add] = ACTIONS(4854),
    [anon_sym_remove] = ACTIONS(4854),
    [anon_sym_enum] = ACTIONS(4854),
    [anon_sym_interface] = ACTIONS(4854),
    [anon_sym_delegate] = ACTIONS(4854),
    [anon_sym_record] = ACTIONS(4854),
    [anon_sym_namespace] = ACTIONS(4854),
    [anon_sym_var] = ACTIONS(4854),
    [sym_predefined_type] = ACTIONS(4854),
    [anon_sym_when] = ACTIONS(4854),
    [anon_sym_yield] = ACTIONS(4854),
    [anon_sym_from] = ACTIONS(4854),
    [anon_sym_join] = ACTIONS(4854),
    [anon_sym_on] = ACTIONS(4854),
    [anon_sym_equals] = ACTIONS(4854),
    [anon_sym_into] = ACTIONS(4854),
    [anon_sym_let] = ACTIONS(4854),
    [anon_sym_orderby] = ACTIONS(4854),
    [anon_sym_ascending] = ACTIONS(4854),
    [anon_sym_descending] = ACTIONS(4854),
    [anon_sym_group] = ACTIONS(4854),
    [anon_sym_by] = ACTIONS(4854),
    [anon_sym_select] = ACTIONS(4854),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4854),
    [anon_sym_nameof] = ACTIONS(4854),
    [sym_void_keyword] = ACTIONS(4854),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2545] = {
    [sym__preprocessor_call] = STATE(2545),
    [sym__identifier_token] = ACTIONS(4858),
    [anon_sym_extern] = ACTIONS(4858),
    [anon_sym_alias] = ACTIONS(4858),
    [anon_sym_global] = ACTIONS(4858),
    [anon_sym_using] = ACTIONS(4858),
    [anon_sym_static] = ACTIONS(4858),
    [anon_sym_LBRACK] = ACTIONS(4860),
    [anon_sym_event] = ACTIONS(4858),
    [anon_sym_LPAREN] = ACTIONS(4860),
    [anon_sym_abstract] = ACTIONS(4858),
    [anon_sym_async] = ACTIONS(4858),
    [anon_sym_const] = ACTIONS(4858),
    [anon_sym_fixed] = ACTIONS(4858),
    [anon_sym_internal] = ACTIONS(4858),
    [anon_sym_new] = ACTIONS(4858),
    [anon_sym_override] = ACTIONS(4858),
    [anon_sym_partial] = ACTIONS(4858),
    [anon_sym_private] = ACTIONS(4858),
    [anon_sym_protected] = ACTIONS(4858),
    [anon_sym_public] = ACTIONS(4858),
    [anon_sym_readonly] = ACTIONS(4858),
    [anon_sym_ref] = ACTIONS(4858),
    [anon_sym_sealed] = ACTIONS(4858),
    [anon_sym_unsafe] = ACTIONS(4858),
    [anon_sym_virtual] = ACTIONS(4858),
    [anon_sym_volatile] = ACTIONS(4858),
    [anon_sym_RBRACE] = ACTIONS(4860),
    [anon_sym_implicit] = ACTIONS(4858),
    [anon_sym_explicit] = ACTIONS(4858),
    [anon_sym_TILDE] = ACTIONS(4860),
    [anon_sym_where] = ACTIONS(4858),
    [anon_sym_class] = ACTIONS(4858),
    [anon_sym_struct] = ACTIONS(4858),
    [anon_sym_notnull] = ACTIONS(4858),
    [anon_sym_unmanaged] = ACTIONS(4858),
    [anon_sym_get] = ACTIONS(4858),
    [anon_sym_set] = ACTIONS(4858),
    [anon_sym_add] = ACTIONS(4858),
    [anon_sym_remove] = ACTIONS(4858),
    [anon_sym_enum] = ACTIONS(4858),
    [anon_sym_interface] = ACTIONS(4858),
    [anon_sym_delegate] = ACTIONS(4858),
    [anon_sym_record] = ACTIONS(4858),
    [anon_sym_namespace] = ACTIONS(4858),
    [anon_sym_var] = ACTIONS(4858),
    [sym_predefined_type] = ACTIONS(4858),
    [anon_sym_when] = ACTIONS(4858),
    [anon_sym_yield] = ACTIONS(4858),
    [anon_sym_from] = ACTIONS(4858),
    [anon_sym_join] = ACTIONS(4858),
    [anon_sym_on] = ACTIONS(4858),
    [anon_sym_equals] = ACTIONS(4858),
    [anon_sym_into] = ACTIONS(4858),
    [anon_sym_let] = ACTIONS(4858),
    [anon_sym_orderby] = ACTIONS(4858),
    [anon_sym_ascending] = ACTIONS(4858),
    [anon_sym_descending] = ACTIONS(4858),
    [anon_sym_group] = ACTIONS(4858),
    [anon_sym_by] = ACTIONS(4858),
    [anon_sym_select] = ACTIONS(4858),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4858),
    [anon_sym_nameof] = ACTIONS(4858),
    [sym_void_keyword] = ACTIONS(4858),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2546] = {
    [sym__preprocessor_call] = STATE(2546),
    [sym__identifier_token] = ACTIONS(4862),
    [anon_sym_extern] = ACTIONS(4862),
    [anon_sym_alias] = ACTIONS(4862),
    [anon_sym_global] = ACTIONS(4862),
    [anon_sym_using] = ACTIONS(4862),
    [anon_sym_static] = ACTIONS(4862),
    [anon_sym_LBRACK] = ACTIONS(4864),
    [anon_sym_event] = ACTIONS(4862),
    [anon_sym_LPAREN] = ACTIONS(4864),
    [anon_sym_abstract] = ACTIONS(4862),
    [anon_sym_async] = ACTIONS(4862),
    [anon_sym_const] = ACTIONS(4862),
    [anon_sym_fixed] = ACTIONS(4862),
    [anon_sym_internal] = ACTIONS(4862),
    [anon_sym_new] = ACTIONS(4862),
    [anon_sym_override] = ACTIONS(4862),
    [anon_sym_partial] = ACTIONS(4862),
    [anon_sym_private] = ACTIONS(4862),
    [anon_sym_protected] = ACTIONS(4862),
    [anon_sym_public] = ACTIONS(4862),
    [anon_sym_readonly] = ACTIONS(4862),
    [anon_sym_ref] = ACTIONS(4862),
    [anon_sym_sealed] = ACTIONS(4862),
    [anon_sym_unsafe] = ACTIONS(4862),
    [anon_sym_virtual] = ACTIONS(4862),
    [anon_sym_volatile] = ACTIONS(4862),
    [anon_sym_RBRACE] = ACTIONS(4864),
    [anon_sym_implicit] = ACTIONS(4862),
    [anon_sym_explicit] = ACTIONS(4862),
    [anon_sym_TILDE] = ACTIONS(4864),
    [anon_sym_where] = ACTIONS(4862),
    [anon_sym_class] = ACTIONS(4862),
    [anon_sym_struct] = ACTIONS(4862),
    [anon_sym_notnull] = ACTIONS(4862),
    [anon_sym_unmanaged] = ACTIONS(4862),
    [anon_sym_get] = ACTIONS(4862),
    [anon_sym_set] = ACTIONS(4862),
    [anon_sym_add] = ACTIONS(4862),
    [anon_sym_remove] = ACTIONS(4862),
    [anon_sym_enum] = ACTIONS(4862),
    [anon_sym_interface] = ACTIONS(4862),
    [anon_sym_delegate] = ACTIONS(4862),
    [anon_sym_record] = ACTIONS(4862),
    [anon_sym_namespace] = ACTIONS(4862),
    [anon_sym_var] = ACTIONS(4862),
    [sym_predefined_type] = ACTIONS(4862),
    [anon_sym_when] = ACTIONS(4862),
    [anon_sym_yield] = ACTIONS(4862),
    [anon_sym_from] = ACTIONS(4862),
    [anon_sym_join] = ACTIONS(4862),
    [anon_sym_on] = ACTIONS(4862),
    [anon_sym_equals] = ACTIONS(4862),
    [anon_sym_into] = ACTIONS(4862),
    [anon_sym_let] = ACTIONS(4862),
    [anon_sym_orderby] = ACTIONS(4862),
    [anon_sym_ascending] = ACTIONS(4862),
    [anon_sym_descending] = ACTIONS(4862),
    [anon_sym_group] = ACTIONS(4862),
    [anon_sym_by] = ACTIONS(4862),
    [anon_sym_select] = ACTIONS(4862),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4862),
    [anon_sym_nameof] = ACTIONS(4862),
    [sym_void_keyword] = ACTIONS(4862),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2547] = {
    [sym__preprocessor_call] = STATE(2547),
    [sym__identifier_token] = ACTIONS(4866),
    [anon_sym_extern] = ACTIONS(4866),
    [anon_sym_alias] = ACTIONS(4866),
    [anon_sym_global] = ACTIONS(4866),
    [anon_sym_using] = ACTIONS(4866),
    [anon_sym_static] = ACTIONS(4866),
    [anon_sym_LBRACK] = ACTIONS(4868),
    [anon_sym_event] = ACTIONS(4866),
    [anon_sym_LPAREN] = ACTIONS(4868),
    [anon_sym_abstract] = ACTIONS(4866),
    [anon_sym_async] = ACTIONS(4866),
    [anon_sym_const] = ACTIONS(4866),
    [anon_sym_fixed] = ACTIONS(4866),
    [anon_sym_internal] = ACTIONS(4866),
    [anon_sym_new] = ACTIONS(4866),
    [anon_sym_override] = ACTIONS(4866),
    [anon_sym_partial] = ACTIONS(4866),
    [anon_sym_private] = ACTIONS(4866),
    [anon_sym_protected] = ACTIONS(4866),
    [anon_sym_public] = ACTIONS(4866),
    [anon_sym_readonly] = ACTIONS(4866),
    [anon_sym_ref] = ACTIONS(4866),
    [anon_sym_sealed] = ACTIONS(4866),
    [anon_sym_unsafe] = ACTIONS(4866),
    [anon_sym_virtual] = ACTIONS(4866),
    [anon_sym_volatile] = ACTIONS(4866),
    [anon_sym_RBRACE] = ACTIONS(4868),
    [anon_sym_implicit] = ACTIONS(4866),
    [anon_sym_explicit] = ACTIONS(4866),
    [anon_sym_TILDE] = ACTIONS(4868),
    [anon_sym_where] = ACTIONS(4866),
    [anon_sym_class] = ACTIONS(4866),
    [anon_sym_struct] = ACTIONS(4866),
    [anon_sym_notnull] = ACTIONS(4866),
    [anon_sym_unmanaged] = ACTIONS(4866),
    [anon_sym_get] = ACTIONS(4866),
    [anon_sym_set] = ACTIONS(4866),
    [anon_sym_add] = ACTIONS(4866),
    [anon_sym_remove] = ACTIONS(4866),
    [anon_sym_enum] = ACTIONS(4866),
    [anon_sym_interface] = ACTIONS(4866),
    [anon_sym_delegate] = ACTIONS(4866),
    [anon_sym_record] = ACTIONS(4866),
    [anon_sym_namespace] = ACTIONS(4866),
    [anon_sym_var] = ACTIONS(4866),
    [sym_predefined_type] = ACTIONS(4866),
    [anon_sym_when] = ACTIONS(4866),
    [anon_sym_yield] = ACTIONS(4866),
    [anon_sym_from] = ACTIONS(4866),
    [anon_sym_join] = ACTIONS(4866),
    [anon_sym_on] = ACTIONS(4866),
    [anon_sym_equals] = ACTIONS(4866),
    [anon_sym_into] = ACTIONS(4866),
    [anon_sym_let] = ACTIONS(4866),
    [anon_sym_orderby] = ACTIONS(4866),
    [anon_sym_ascending] = ACTIONS(4866),
    [anon_sym_descending] = ACTIONS(4866),
    [anon_sym_group] = ACTIONS(4866),
    [anon_sym_by] = ACTIONS(4866),
    [anon_sym_select] = ACTIONS(4866),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4866),
    [anon_sym_nameof] = ACTIONS(4866),
    [sym_void_keyword] = ACTIONS(4866),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2548] = {
    [sym__preprocessor_call] = STATE(2548),
    [sym__identifier_token] = ACTIONS(4870),
    [anon_sym_extern] = ACTIONS(4870),
    [anon_sym_alias] = ACTIONS(4870),
    [anon_sym_global] = ACTIONS(4870),
    [anon_sym_using] = ACTIONS(4870),
    [anon_sym_static] = ACTIONS(4870),
    [anon_sym_LBRACK] = ACTIONS(4872),
    [anon_sym_event] = ACTIONS(4870),
    [anon_sym_LPAREN] = ACTIONS(4872),
    [anon_sym_abstract] = ACTIONS(4870),
    [anon_sym_async] = ACTIONS(4870),
    [anon_sym_const] = ACTIONS(4870),
    [anon_sym_fixed] = ACTIONS(4870),
    [anon_sym_internal] = ACTIONS(4870),
    [anon_sym_new] = ACTIONS(4870),
    [anon_sym_override] = ACTIONS(4870),
    [anon_sym_partial] = ACTIONS(4870),
    [anon_sym_private] = ACTIONS(4870),
    [anon_sym_protected] = ACTIONS(4870),
    [anon_sym_public] = ACTIONS(4870),
    [anon_sym_readonly] = ACTIONS(4870),
    [anon_sym_ref] = ACTIONS(4870),
    [anon_sym_sealed] = ACTIONS(4870),
    [anon_sym_unsafe] = ACTIONS(4870),
    [anon_sym_virtual] = ACTIONS(4870),
    [anon_sym_volatile] = ACTIONS(4870),
    [anon_sym_RBRACE] = ACTIONS(4872),
    [anon_sym_implicit] = ACTIONS(4870),
    [anon_sym_explicit] = ACTIONS(4870),
    [anon_sym_TILDE] = ACTIONS(4872),
    [anon_sym_where] = ACTIONS(4870),
    [anon_sym_class] = ACTIONS(4870),
    [anon_sym_struct] = ACTIONS(4870),
    [anon_sym_notnull] = ACTIONS(4870),
    [anon_sym_unmanaged] = ACTIONS(4870),
    [anon_sym_get] = ACTIONS(4870),
    [anon_sym_set] = ACTIONS(4870),
    [anon_sym_add] = ACTIONS(4870),
    [anon_sym_remove] = ACTIONS(4870),
    [anon_sym_enum] = ACTIONS(4870),
    [anon_sym_interface] = ACTIONS(4870),
    [anon_sym_delegate] = ACTIONS(4870),
    [anon_sym_record] = ACTIONS(4870),
    [anon_sym_namespace] = ACTIONS(4870),
    [anon_sym_var] = ACTIONS(4870),
    [sym_predefined_type] = ACTIONS(4870),
    [anon_sym_when] = ACTIONS(4870),
    [anon_sym_yield] = ACTIONS(4870),
    [anon_sym_from] = ACTIONS(4870),
    [anon_sym_join] = ACTIONS(4870),
    [anon_sym_on] = ACTIONS(4870),
    [anon_sym_equals] = ACTIONS(4870),
    [anon_sym_into] = ACTIONS(4870),
    [anon_sym_let] = ACTIONS(4870),
    [anon_sym_orderby] = ACTIONS(4870),
    [anon_sym_ascending] = ACTIONS(4870),
    [anon_sym_descending] = ACTIONS(4870),
    [anon_sym_group] = ACTIONS(4870),
    [anon_sym_by] = ACTIONS(4870),
    [anon_sym_select] = ACTIONS(4870),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4870),
    [anon_sym_nameof] = ACTIONS(4870),
    [sym_void_keyword] = ACTIONS(4870),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2549] = {
    [sym__preprocessor_call] = STATE(2549),
    [sym__identifier_token] = ACTIONS(4874),
    [anon_sym_extern] = ACTIONS(4874),
    [anon_sym_alias] = ACTIONS(4874),
    [anon_sym_global] = ACTIONS(4874),
    [anon_sym_using] = ACTIONS(4874),
    [anon_sym_static] = ACTIONS(4874),
    [anon_sym_LBRACK] = ACTIONS(4876),
    [anon_sym_event] = ACTIONS(4874),
    [anon_sym_LPAREN] = ACTIONS(4876),
    [anon_sym_abstract] = ACTIONS(4874),
    [anon_sym_async] = ACTIONS(4874),
    [anon_sym_const] = ACTIONS(4874),
    [anon_sym_fixed] = ACTIONS(4874),
    [anon_sym_internal] = ACTIONS(4874),
    [anon_sym_new] = ACTIONS(4874),
    [anon_sym_override] = ACTIONS(4874),
    [anon_sym_partial] = ACTIONS(4874),
    [anon_sym_private] = ACTIONS(4874),
    [anon_sym_protected] = ACTIONS(4874),
    [anon_sym_public] = ACTIONS(4874),
    [anon_sym_readonly] = ACTIONS(4874),
    [anon_sym_ref] = ACTIONS(4874),
    [anon_sym_sealed] = ACTIONS(4874),
    [anon_sym_unsafe] = ACTIONS(4874),
    [anon_sym_virtual] = ACTIONS(4874),
    [anon_sym_volatile] = ACTIONS(4874),
    [anon_sym_RBRACE] = ACTIONS(4876),
    [anon_sym_implicit] = ACTIONS(4874),
    [anon_sym_explicit] = ACTIONS(4874),
    [anon_sym_TILDE] = ACTIONS(4876),
    [anon_sym_where] = ACTIONS(4874),
    [anon_sym_class] = ACTIONS(4874),
    [anon_sym_struct] = ACTIONS(4874),
    [anon_sym_notnull] = ACTIONS(4874),
    [anon_sym_unmanaged] = ACTIONS(4874),
    [anon_sym_get] = ACTIONS(4874),
    [anon_sym_set] = ACTIONS(4874),
    [anon_sym_add] = ACTIONS(4874),
    [anon_sym_remove] = ACTIONS(4874),
    [anon_sym_enum] = ACTIONS(4874),
    [anon_sym_interface] = ACTIONS(4874),
    [anon_sym_delegate] = ACTIONS(4874),
    [anon_sym_record] = ACTIONS(4874),
    [anon_sym_namespace] = ACTIONS(4874),
    [anon_sym_var] = ACTIONS(4874),
    [sym_predefined_type] = ACTIONS(4874),
    [anon_sym_when] = ACTIONS(4874),
    [anon_sym_yield] = ACTIONS(4874),
    [anon_sym_from] = ACTIONS(4874),
    [anon_sym_join] = ACTIONS(4874),
    [anon_sym_on] = ACTIONS(4874),
    [anon_sym_equals] = ACTIONS(4874),
    [anon_sym_into] = ACTIONS(4874),
    [anon_sym_let] = ACTIONS(4874),
    [anon_sym_orderby] = ACTIONS(4874),
    [anon_sym_ascending] = ACTIONS(4874),
    [anon_sym_descending] = ACTIONS(4874),
    [anon_sym_group] = ACTIONS(4874),
    [anon_sym_by] = ACTIONS(4874),
    [anon_sym_select] = ACTIONS(4874),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4874),
    [anon_sym_nameof] = ACTIONS(4874),
    [sym_void_keyword] = ACTIONS(4874),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2550] = {
    [sym__preprocessor_call] = STATE(2550),
    [sym__identifier_token] = ACTIONS(4878),
    [anon_sym_extern] = ACTIONS(4878),
    [anon_sym_alias] = ACTIONS(4878),
    [anon_sym_global] = ACTIONS(4878),
    [anon_sym_using] = ACTIONS(4878),
    [anon_sym_static] = ACTIONS(4878),
    [anon_sym_LBRACK] = ACTIONS(4880),
    [anon_sym_event] = ACTIONS(4878),
    [anon_sym_LPAREN] = ACTIONS(4880),
    [anon_sym_abstract] = ACTIONS(4878),
    [anon_sym_async] = ACTIONS(4878),
    [anon_sym_const] = ACTIONS(4878),
    [anon_sym_fixed] = ACTIONS(4878),
    [anon_sym_internal] = ACTIONS(4878),
    [anon_sym_new] = ACTIONS(4878),
    [anon_sym_override] = ACTIONS(4878),
    [anon_sym_partial] = ACTIONS(4878),
    [anon_sym_private] = ACTIONS(4878),
    [anon_sym_protected] = ACTIONS(4878),
    [anon_sym_public] = ACTIONS(4878),
    [anon_sym_readonly] = ACTIONS(4878),
    [anon_sym_ref] = ACTIONS(4878),
    [anon_sym_sealed] = ACTIONS(4878),
    [anon_sym_unsafe] = ACTIONS(4878),
    [anon_sym_virtual] = ACTIONS(4878),
    [anon_sym_volatile] = ACTIONS(4878),
    [anon_sym_RBRACE] = ACTIONS(4880),
    [anon_sym_implicit] = ACTIONS(4878),
    [anon_sym_explicit] = ACTIONS(4878),
    [anon_sym_TILDE] = ACTIONS(4880),
    [anon_sym_where] = ACTIONS(4878),
    [anon_sym_class] = ACTIONS(4878),
    [anon_sym_struct] = ACTIONS(4878),
    [anon_sym_notnull] = ACTIONS(4878),
    [anon_sym_unmanaged] = ACTIONS(4878),
    [anon_sym_get] = ACTIONS(4878),
    [anon_sym_set] = ACTIONS(4878),
    [anon_sym_add] = ACTIONS(4878),
    [anon_sym_remove] = ACTIONS(4878),
    [anon_sym_enum] = ACTIONS(4878),
    [anon_sym_interface] = ACTIONS(4878),
    [anon_sym_delegate] = ACTIONS(4878),
    [anon_sym_record] = ACTIONS(4878),
    [anon_sym_namespace] = ACTIONS(4878),
    [anon_sym_var] = ACTIONS(4878),
    [sym_predefined_type] = ACTIONS(4878),
    [anon_sym_when] = ACTIONS(4878),
    [anon_sym_yield] = ACTIONS(4878),
    [anon_sym_from] = ACTIONS(4878),
    [anon_sym_join] = ACTIONS(4878),
    [anon_sym_on] = ACTIONS(4878),
    [anon_sym_equals] = ACTIONS(4878),
    [anon_sym_into] = ACTIONS(4878),
    [anon_sym_let] = ACTIONS(4878),
    [anon_sym_orderby] = ACTIONS(4878),
    [anon_sym_ascending] = ACTIONS(4878),
    [anon_sym_descending] = ACTIONS(4878),
    [anon_sym_group] = ACTIONS(4878),
    [anon_sym_by] = ACTIONS(4878),
    [anon_sym_select] = ACTIONS(4878),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4878),
    [anon_sym_nameof] = ACTIONS(4878),
    [sym_void_keyword] = ACTIONS(4878),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2551] = {
    [sym__preprocessor_call] = STATE(2551),
    [sym__identifier_token] = ACTIONS(4882),
    [anon_sym_extern] = ACTIONS(4882),
    [anon_sym_alias] = ACTIONS(4882),
    [anon_sym_global] = ACTIONS(4882),
    [anon_sym_using] = ACTIONS(4882),
    [anon_sym_static] = ACTIONS(4882),
    [anon_sym_LBRACK] = ACTIONS(4884),
    [anon_sym_event] = ACTIONS(4882),
    [anon_sym_LPAREN] = ACTIONS(4884),
    [anon_sym_abstract] = ACTIONS(4882),
    [anon_sym_async] = ACTIONS(4882),
    [anon_sym_const] = ACTIONS(4882),
    [anon_sym_fixed] = ACTIONS(4882),
    [anon_sym_internal] = ACTIONS(4882),
    [anon_sym_new] = ACTIONS(4882),
    [anon_sym_override] = ACTIONS(4882),
    [anon_sym_partial] = ACTIONS(4882),
    [anon_sym_private] = ACTIONS(4882),
    [anon_sym_protected] = ACTIONS(4882),
    [anon_sym_public] = ACTIONS(4882),
    [anon_sym_readonly] = ACTIONS(4882),
    [anon_sym_ref] = ACTIONS(4882),
    [anon_sym_sealed] = ACTIONS(4882),
    [anon_sym_unsafe] = ACTIONS(4882),
    [anon_sym_virtual] = ACTIONS(4882),
    [anon_sym_volatile] = ACTIONS(4882),
    [anon_sym_RBRACE] = ACTIONS(4884),
    [anon_sym_implicit] = ACTIONS(4882),
    [anon_sym_explicit] = ACTIONS(4882),
    [anon_sym_TILDE] = ACTIONS(4884),
    [anon_sym_where] = ACTIONS(4882),
    [anon_sym_class] = ACTIONS(4882),
    [anon_sym_struct] = ACTIONS(4882),
    [anon_sym_notnull] = ACTIONS(4882),
    [anon_sym_unmanaged] = ACTIONS(4882),
    [anon_sym_get] = ACTIONS(4882),
    [anon_sym_set] = ACTIONS(4882),
    [anon_sym_add] = ACTIONS(4882),
    [anon_sym_remove] = ACTIONS(4882),
    [anon_sym_enum] = ACTIONS(4882),
    [anon_sym_interface] = ACTIONS(4882),
    [anon_sym_delegate] = ACTIONS(4882),
    [anon_sym_record] = ACTIONS(4882),
    [anon_sym_namespace] = ACTIONS(4882),
    [anon_sym_var] = ACTIONS(4882),
    [sym_predefined_type] = ACTIONS(4882),
    [anon_sym_when] = ACTIONS(4882),
    [anon_sym_yield] = ACTIONS(4882),
    [anon_sym_from] = ACTIONS(4882),
    [anon_sym_join] = ACTIONS(4882),
    [anon_sym_on] = ACTIONS(4882),
    [anon_sym_equals] = ACTIONS(4882),
    [anon_sym_into] = ACTIONS(4882),
    [anon_sym_let] = ACTIONS(4882),
    [anon_sym_orderby] = ACTIONS(4882),
    [anon_sym_ascending] = ACTIONS(4882),
    [anon_sym_descending] = ACTIONS(4882),
    [anon_sym_group] = ACTIONS(4882),
    [anon_sym_by] = ACTIONS(4882),
    [anon_sym_select] = ACTIONS(4882),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4882),
    [anon_sym_nameof] = ACTIONS(4882),
    [sym_void_keyword] = ACTIONS(4882),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2552] = {
    [sym__preprocessor_call] = STATE(2552),
    [sym__identifier_token] = ACTIONS(4886),
    [anon_sym_extern] = ACTIONS(4886),
    [anon_sym_alias] = ACTIONS(4886),
    [anon_sym_global] = ACTIONS(4886),
    [anon_sym_using] = ACTIONS(4886),
    [anon_sym_static] = ACTIONS(4886),
    [anon_sym_LBRACK] = ACTIONS(4888),
    [anon_sym_event] = ACTIONS(4886),
    [anon_sym_LPAREN] = ACTIONS(4888),
    [anon_sym_abstract] = ACTIONS(4886),
    [anon_sym_async] = ACTIONS(4886),
    [anon_sym_const] = ACTIONS(4886),
    [anon_sym_fixed] = ACTIONS(4886),
    [anon_sym_internal] = ACTIONS(4886),
    [anon_sym_new] = ACTIONS(4886),
    [anon_sym_override] = ACTIONS(4886),
    [anon_sym_partial] = ACTIONS(4886),
    [anon_sym_private] = ACTIONS(4886),
    [anon_sym_protected] = ACTIONS(4886),
    [anon_sym_public] = ACTIONS(4886),
    [anon_sym_readonly] = ACTIONS(4886),
    [anon_sym_ref] = ACTIONS(4886),
    [anon_sym_sealed] = ACTIONS(4886),
    [anon_sym_unsafe] = ACTIONS(4886),
    [anon_sym_virtual] = ACTIONS(4886),
    [anon_sym_volatile] = ACTIONS(4886),
    [anon_sym_RBRACE] = ACTIONS(4888),
    [anon_sym_implicit] = ACTIONS(4886),
    [anon_sym_explicit] = ACTIONS(4886),
    [anon_sym_TILDE] = ACTIONS(4888),
    [anon_sym_where] = ACTIONS(4886),
    [anon_sym_class] = ACTIONS(4886),
    [anon_sym_struct] = ACTIONS(4886),
    [anon_sym_notnull] = ACTIONS(4886),
    [anon_sym_unmanaged] = ACTIONS(4886),
    [anon_sym_get] = ACTIONS(4886),
    [anon_sym_set] = ACTIONS(4886),
    [anon_sym_add] = ACTIONS(4886),
    [anon_sym_remove] = ACTIONS(4886),
    [anon_sym_enum] = ACTIONS(4886),
    [anon_sym_interface] = ACTIONS(4886),
    [anon_sym_delegate] = ACTIONS(4886),
    [anon_sym_record] = ACTIONS(4886),
    [anon_sym_namespace] = ACTIONS(4886),
    [anon_sym_var] = ACTIONS(4886),
    [sym_predefined_type] = ACTIONS(4886),
    [anon_sym_when] = ACTIONS(4886),
    [anon_sym_yield] = ACTIONS(4886),
    [anon_sym_from] = ACTIONS(4886),
    [anon_sym_join] = ACTIONS(4886),
    [anon_sym_on] = ACTIONS(4886),
    [anon_sym_equals] = ACTIONS(4886),
    [anon_sym_into] = ACTIONS(4886),
    [anon_sym_let] = ACTIONS(4886),
    [anon_sym_orderby] = ACTIONS(4886),
    [anon_sym_ascending] = ACTIONS(4886),
    [anon_sym_descending] = ACTIONS(4886),
    [anon_sym_group] = ACTIONS(4886),
    [anon_sym_by] = ACTIONS(4886),
    [anon_sym_select] = ACTIONS(4886),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4886),
    [anon_sym_nameof] = ACTIONS(4886),
    [sym_void_keyword] = ACTIONS(4886),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2553] = {
    [sym__preprocessor_call] = STATE(2553),
    [sym__identifier_token] = ACTIONS(4890),
    [anon_sym_extern] = ACTIONS(4890),
    [anon_sym_alias] = ACTIONS(4890),
    [anon_sym_global] = ACTIONS(4890),
    [anon_sym_using] = ACTIONS(4890),
    [anon_sym_static] = ACTIONS(4890),
    [anon_sym_LBRACK] = ACTIONS(4892),
    [anon_sym_event] = ACTIONS(4890),
    [anon_sym_LPAREN] = ACTIONS(4892),
    [anon_sym_abstract] = ACTIONS(4890),
    [anon_sym_async] = ACTIONS(4890),
    [anon_sym_const] = ACTIONS(4890),
    [anon_sym_fixed] = ACTIONS(4890),
    [anon_sym_internal] = ACTIONS(4890),
    [anon_sym_new] = ACTIONS(4890),
    [anon_sym_override] = ACTIONS(4890),
    [anon_sym_partial] = ACTIONS(4890),
    [anon_sym_private] = ACTIONS(4890),
    [anon_sym_protected] = ACTIONS(4890),
    [anon_sym_public] = ACTIONS(4890),
    [anon_sym_readonly] = ACTIONS(4890),
    [anon_sym_ref] = ACTIONS(4890),
    [anon_sym_sealed] = ACTIONS(4890),
    [anon_sym_unsafe] = ACTIONS(4890),
    [anon_sym_virtual] = ACTIONS(4890),
    [anon_sym_volatile] = ACTIONS(4890),
    [anon_sym_RBRACE] = ACTIONS(4892),
    [anon_sym_implicit] = ACTIONS(4890),
    [anon_sym_explicit] = ACTIONS(4890),
    [anon_sym_TILDE] = ACTIONS(4892),
    [anon_sym_where] = ACTIONS(4890),
    [anon_sym_class] = ACTIONS(4890),
    [anon_sym_struct] = ACTIONS(4890),
    [anon_sym_notnull] = ACTIONS(4890),
    [anon_sym_unmanaged] = ACTIONS(4890),
    [anon_sym_get] = ACTIONS(4890),
    [anon_sym_set] = ACTIONS(4890),
    [anon_sym_add] = ACTIONS(4890),
    [anon_sym_remove] = ACTIONS(4890),
    [anon_sym_enum] = ACTIONS(4890),
    [anon_sym_interface] = ACTIONS(4890),
    [anon_sym_delegate] = ACTIONS(4890),
    [anon_sym_record] = ACTIONS(4890),
    [anon_sym_namespace] = ACTIONS(4890),
    [anon_sym_var] = ACTIONS(4890),
    [sym_predefined_type] = ACTIONS(4890),
    [anon_sym_when] = ACTIONS(4890),
    [anon_sym_yield] = ACTIONS(4890),
    [anon_sym_from] = ACTIONS(4890),
    [anon_sym_join] = ACTIONS(4890),
    [anon_sym_on] = ACTIONS(4890),
    [anon_sym_equals] = ACTIONS(4890),
    [anon_sym_into] = ACTIONS(4890),
    [anon_sym_let] = ACTIONS(4890),
    [anon_sym_orderby] = ACTIONS(4890),
    [anon_sym_ascending] = ACTIONS(4890),
    [anon_sym_descending] = ACTIONS(4890),
    [anon_sym_group] = ACTIONS(4890),
    [anon_sym_by] = ACTIONS(4890),
    [anon_sym_select] = ACTIONS(4890),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4890),
    [anon_sym_nameof] = ACTIONS(4890),
    [sym_void_keyword] = ACTIONS(4890),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2554] = {
    [sym__preprocessor_call] = STATE(2554),
    [sym__identifier_token] = ACTIONS(4894),
    [anon_sym_extern] = ACTIONS(4894),
    [anon_sym_alias] = ACTIONS(4894),
    [anon_sym_global] = ACTIONS(4894),
    [anon_sym_using] = ACTIONS(4894),
    [anon_sym_static] = ACTIONS(4894),
    [anon_sym_LBRACK] = ACTIONS(4896),
    [anon_sym_event] = ACTIONS(4894),
    [anon_sym_LPAREN] = ACTIONS(4896),
    [anon_sym_abstract] = ACTIONS(4894),
    [anon_sym_async] = ACTIONS(4894),
    [anon_sym_const] = ACTIONS(4894),
    [anon_sym_fixed] = ACTIONS(4894),
    [anon_sym_internal] = ACTIONS(4894),
    [anon_sym_new] = ACTIONS(4894),
    [anon_sym_override] = ACTIONS(4894),
    [anon_sym_partial] = ACTIONS(4894),
    [anon_sym_private] = ACTIONS(4894),
    [anon_sym_protected] = ACTIONS(4894),
    [anon_sym_public] = ACTIONS(4894),
    [anon_sym_readonly] = ACTIONS(4894),
    [anon_sym_ref] = ACTIONS(4894),
    [anon_sym_sealed] = ACTIONS(4894),
    [anon_sym_unsafe] = ACTIONS(4894),
    [anon_sym_virtual] = ACTIONS(4894),
    [anon_sym_volatile] = ACTIONS(4894),
    [anon_sym_RBRACE] = ACTIONS(4896),
    [anon_sym_implicit] = ACTIONS(4894),
    [anon_sym_explicit] = ACTIONS(4894),
    [anon_sym_TILDE] = ACTIONS(4896),
    [anon_sym_where] = ACTIONS(4894),
    [anon_sym_class] = ACTIONS(4894),
    [anon_sym_struct] = ACTIONS(4894),
    [anon_sym_notnull] = ACTIONS(4894),
    [anon_sym_unmanaged] = ACTIONS(4894),
    [anon_sym_get] = ACTIONS(4894),
    [anon_sym_set] = ACTIONS(4894),
    [anon_sym_add] = ACTIONS(4894),
    [anon_sym_remove] = ACTIONS(4894),
    [anon_sym_enum] = ACTIONS(4894),
    [anon_sym_interface] = ACTIONS(4894),
    [anon_sym_delegate] = ACTIONS(4894),
    [anon_sym_record] = ACTIONS(4894),
    [anon_sym_namespace] = ACTIONS(4894),
    [anon_sym_var] = ACTIONS(4894),
    [sym_predefined_type] = ACTIONS(4894),
    [anon_sym_when] = ACTIONS(4894),
    [anon_sym_yield] = ACTIONS(4894),
    [anon_sym_from] = ACTIONS(4894),
    [anon_sym_join] = ACTIONS(4894),
    [anon_sym_on] = ACTIONS(4894),
    [anon_sym_equals] = ACTIONS(4894),
    [anon_sym_into] = ACTIONS(4894),
    [anon_sym_let] = ACTIONS(4894),
    [anon_sym_orderby] = ACTIONS(4894),
    [anon_sym_ascending] = ACTIONS(4894),
    [anon_sym_descending] = ACTIONS(4894),
    [anon_sym_group] = ACTIONS(4894),
    [anon_sym_by] = ACTIONS(4894),
    [anon_sym_select] = ACTIONS(4894),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4894),
    [anon_sym_nameof] = ACTIONS(4894),
    [sym_void_keyword] = ACTIONS(4894),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2555] = {
    [sym__preprocessor_call] = STATE(2555),
    [sym__identifier_token] = ACTIONS(4898),
    [anon_sym_extern] = ACTIONS(4898),
    [anon_sym_alias] = ACTIONS(4898),
    [anon_sym_global] = ACTIONS(4898),
    [anon_sym_using] = ACTIONS(4898),
    [anon_sym_static] = ACTIONS(4898),
    [anon_sym_LBRACK] = ACTIONS(4900),
    [anon_sym_event] = ACTIONS(4898),
    [anon_sym_LPAREN] = ACTIONS(4900),
    [anon_sym_abstract] = ACTIONS(4898),
    [anon_sym_async] = ACTIONS(4898),
    [anon_sym_const] = ACTIONS(4898),
    [anon_sym_fixed] = ACTIONS(4898),
    [anon_sym_internal] = ACTIONS(4898),
    [anon_sym_new] = ACTIONS(4898),
    [anon_sym_override] = ACTIONS(4898),
    [anon_sym_partial] = ACTIONS(4898),
    [anon_sym_private] = ACTIONS(4898),
    [anon_sym_protected] = ACTIONS(4898),
    [anon_sym_public] = ACTIONS(4898),
    [anon_sym_readonly] = ACTIONS(4898),
    [anon_sym_ref] = ACTIONS(4898),
    [anon_sym_sealed] = ACTIONS(4898),
    [anon_sym_unsafe] = ACTIONS(4898),
    [anon_sym_virtual] = ACTIONS(4898),
    [anon_sym_volatile] = ACTIONS(4898),
    [anon_sym_RBRACE] = ACTIONS(4900),
    [anon_sym_implicit] = ACTIONS(4898),
    [anon_sym_explicit] = ACTIONS(4898),
    [anon_sym_TILDE] = ACTIONS(4900),
    [anon_sym_where] = ACTIONS(4898),
    [anon_sym_class] = ACTIONS(4898),
    [anon_sym_struct] = ACTIONS(4898),
    [anon_sym_notnull] = ACTIONS(4898),
    [anon_sym_unmanaged] = ACTIONS(4898),
    [anon_sym_get] = ACTIONS(4898),
    [anon_sym_set] = ACTIONS(4898),
    [anon_sym_add] = ACTIONS(4898),
    [anon_sym_remove] = ACTIONS(4898),
    [anon_sym_enum] = ACTIONS(4898),
    [anon_sym_interface] = ACTIONS(4898),
    [anon_sym_delegate] = ACTIONS(4898),
    [anon_sym_record] = ACTIONS(4898),
    [anon_sym_namespace] = ACTIONS(4898),
    [anon_sym_var] = ACTIONS(4898),
    [sym_predefined_type] = ACTIONS(4898),
    [anon_sym_when] = ACTIONS(4898),
    [anon_sym_yield] = ACTIONS(4898),
    [anon_sym_from] = ACTIONS(4898),
    [anon_sym_join] = ACTIONS(4898),
    [anon_sym_on] = ACTIONS(4898),
    [anon_sym_equals] = ACTIONS(4898),
    [anon_sym_into] = ACTIONS(4898),
    [anon_sym_let] = ACTIONS(4898),
    [anon_sym_orderby] = ACTIONS(4898),
    [anon_sym_ascending] = ACTIONS(4898),
    [anon_sym_descending] = ACTIONS(4898),
    [anon_sym_group] = ACTIONS(4898),
    [anon_sym_by] = ACTIONS(4898),
    [anon_sym_select] = ACTIONS(4898),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4898),
    [anon_sym_nameof] = ACTIONS(4898),
    [sym_void_keyword] = ACTIONS(4898),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2556] = {
    [sym__preprocessor_call] = STATE(2556),
    [sym__identifier_token] = ACTIONS(4902),
    [anon_sym_extern] = ACTIONS(4902),
    [anon_sym_alias] = ACTIONS(4902),
    [anon_sym_global] = ACTIONS(4902),
    [anon_sym_using] = ACTIONS(4902),
    [anon_sym_static] = ACTIONS(4902),
    [anon_sym_LBRACK] = ACTIONS(4904),
    [anon_sym_event] = ACTIONS(4902),
    [anon_sym_LPAREN] = ACTIONS(4904),
    [anon_sym_abstract] = ACTIONS(4902),
    [anon_sym_async] = ACTIONS(4902),
    [anon_sym_const] = ACTIONS(4902),
    [anon_sym_fixed] = ACTIONS(4902),
    [anon_sym_internal] = ACTIONS(4902),
    [anon_sym_new] = ACTIONS(4902),
    [anon_sym_override] = ACTIONS(4902),
    [anon_sym_partial] = ACTIONS(4902),
    [anon_sym_private] = ACTIONS(4902),
    [anon_sym_protected] = ACTIONS(4902),
    [anon_sym_public] = ACTIONS(4902),
    [anon_sym_readonly] = ACTIONS(4902),
    [anon_sym_ref] = ACTIONS(4902),
    [anon_sym_sealed] = ACTIONS(4902),
    [anon_sym_unsafe] = ACTIONS(4902),
    [anon_sym_virtual] = ACTIONS(4902),
    [anon_sym_volatile] = ACTIONS(4902),
    [anon_sym_RBRACE] = ACTIONS(4904),
    [anon_sym_implicit] = ACTIONS(4902),
    [anon_sym_explicit] = ACTIONS(4902),
    [anon_sym_TILDE] = ACTIONS(4904),
    [anon_sym_where] = ACTIONS(4902),
    [anon_sym_class] = ACTIONS(4902),
    [anon_sym_struct] = ACTIONS(4902),
    [anon_sym_notnull] = ACTIONS(4902),
    [anon_sym_unmanaged] = ACTIONS(4902),
    [anon_sym_get] = ACTIONS(4902),
    [anon_sym_set] = ACTIONS(4902),
    [anon_sym_add] = ACTIONS(4902),
    [anon_sym_remove] = ACTIONS(4902),
    [anon_sym_enum] = ACTIONS(4902),
    [anon_sym_interface] = ACTIONS(4902),
    [anon_sym_delegate] = ACTIONS(4902),
    [anon_sym_record] = ACTIONS(4902),
    [anon_sym_namespace] = ACTIONS(4902),
    [anon_sym_var] = ACTIONS(4902),
    [sym_predefined_type] = ACTIONS(4902),
    [anon_sym_when] = ACTIONS(4902),
    [anon_sym_yield] = ACTIONS(4902),
    [anon_sym_from] = ACTIONS(4902),
    [anon_sym_join] = ACTIONS(4902),
    [anon_sym_on] = ACTIONS(4902),
    [anon_sym_equals] = ACTIONS(4902),
    [anon_sym_into] = ACTIONS(4902),
    [anon_sym_let] = ACTIONS(4902),
    [anon_sym_orderby] = ACTIONS(4902),
    [anon_sym_ascending] = ACTIONS(4902),
    [anon_sym_descending] = ACTIONS(4902),
    [anon_sym_group] = ACTIONS(4902),
    [anon_sym_by] = ACTIONS(4902),
    [anon_sym_select] = ACTIONS(4902),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4902),
    [anon_sym_nameof] = ACTIONS(4902),
    [sym_void_keyword] = ACTIONS(4902),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2557] = {
    [sym__preprocessor_call] = STATE(2557),
    [sym__identifier_token] = ACTIONS(4906),
    [anon_sym_extern] = ACTIONS(4906),
    [anon_sym_alias] = ACTIONS(4906),
    [anon_sym_global] = ACTIONS(4906),
    [anon_sym_using] = ACTIONS(4906),
    [anon_sym_static] = ACTIONS(4906),
    [anon_sym_LBRACK] = ACTIONS(4908),
    [anon_sym_event] = ACTIONS(4906),
    [anon_sym_LPAREN] = ACTIONS(4908),
    [anon_sym_abstract] = ACTIONS(4906),
    [anon_sym_async] = ACTIONS(4906),
    [anon_sym_const] = ACTIONS(4906),
    [anon_sym_fixed] = ACTIONS(4906),
    [anon_sym_internal] = ACTIONS(4906),
    [anon_sym_new] = ACTIONS(4906),
    [anon_sym_override] = ACTIONS(4906),
    [anon_sym_partial] = ACTIONS(4906),
    [anon_sym_private] = ACTIONS(4906),
    [anon_sym_protected] = ACTIONS(4906),
    [anon_sym_public] = ACTIONS(4906),
    [anon_sym_readonly] = ACTIONS(4906),
    [anon_sym_ref] = ACTIONS(4906),
    [anon_sym_sealed] = ACTIONS(4906),
    [anon_sym_unsafe] = ACTIONS(4906),
    [anon_sym_virtual] = ACTIONS(4906),
    [anon_sym_volatile] = ACTIONS(4906),
    [anon_sym_RBRACE] = ACTIONS(4908),
    [anon_sym_implicit] = ACTIONS(4906),
    [anon_sym_explicit] = ACTIONS(4906),
    [anon_sym_TILDE] = ACTIONS(4908),
    [anon_sym_where] = ACTIONS(4906),
    [anon_sym_class] = ACTIONS(4906),
    [anon_sym_struct] = ACTIONS(4906),
    [anon_sym_notnull] = ACTIONS(4906),
    [anon_sym_unmanaged] = ACTIONS(4906),
    [anon_sym_get] = ACTIONS(4906),
    [anon_sym_set] = ACTIONS(4906),
    [anon_sym_add] = ACTIONS(4906),
    [anon_sym_remove] = ACTIONS(4906),
    [anon_sym_enum] = ACTIONS(4906),
    [anon_sym_interface] = ACTIONS(4906),
    [anon_sym_delegate] = ACTIONS(4906),
    [anon_sym_record] = ACTIONS(4906),
    [anon_sym_namespace] = ACTIONS(4906),
    [anon_sym_var] = ACTIONS(4906),
    [sym_predefined_type] = ACTIONS(4906),
    [anon_sym_when] = ACTIONS(4906),
    [anon_sym_yield] = ACTIONS(4906),
    [anon_sym_from] = ACTIONS(4906),
    [anon_sym_join] = ACTIONS(4906),
    [anon_sym_on] = ACTIONS(4906),
    [anon_sym_equals] = ACTIONS(4906),
    [anon_sym_into] = ACTIONS(4906),
    [anon_sym_let] = ACTIONS(4906),
    [anon_sym_orderby] = ACTIONS(4906),
    [anon_sym_ascending] = ACTIONS(4906),
    [anon_sym_descending] = ACTIONS(4906),
    [anon_sym_group] = ACTIONS(4906),
    [anon_sym_by] = ACTIONS(4906),
    [anon_sym_select] = ACTIONS(4906),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4906),
    [anon_sym_nameof] = ACTIONS(4906),
    [sym_void_keyword] = ACTIONS(4906),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2558] = {
    [sym__preprocessor_call] = STATE(2558),
    [sym__identifier_token] = ACTIONS(4910),
    [anon_sym_extern] = ACTIONS(4910),
    [anon_sym_alias] = ACTIONS(4910),
    [anon_sym_global] = ACTIONS(4910),
    [anon_sym_using] = ACTIONS(4910),
    [anon_sym_static] = ACTIONS(4910),
    [anon_sym_LBRACK] = ACTIONS(4912),
    [anon_sym_event] = ACTIONS(4910),
    [anon_sym_LPAREN] = ACTIONS(4912),
    [anon_sym_abstract] = ACTIONS(4910),
    [anon_sym_async] = ACTIONS(4910),
    [anon_sym_const] = ACTIONS(4910),
    [anon_sym_fixed] = ACTIONS(4910),
    [anon_sym_internal] = ACTIONS(4910),
    [anon_sym_new] = ACTIONS(4910),
    [anon_sym_override] = ACTIONS(4910),
    [anon_sym_partial] = ACTIONS(4910),
    [anon_sym_private] = ACTIONS(4910),
    [anon_sym_protected] = ACTIONS(4910),
    [anon_sym_public] = ACTIONS(4910),
    [anon_sym_readonly] = ACTIONS(4910),
    [anon_sym_ref] = ACTIONS(4910),
    [anon_sym_sealed] = ACTIONS(4910),
    [anon_sym_unsafe] = ACTIONS(4910),
    [anon_sym_virtual] = ACTIONS(4910),
    [anon_sym_volatile] = ACTIONS(4910),
    [anon_sym_RBRACE] = ACTIONS(4912),
    [anon_sym_implicit] = ACTIONS(4910),
    [anon_sym_explicit] = ACTIONS(4910),
    [anon_sym_TILDE] = ACTIONS(4912),
    [anon_sym_where] = ACTIONS(4910),
    [anon_sym_class] = ACTIONS(4910),
    [anon_sym_struct] = ACTIONS(4910),
    [anon_sym_notnull] = ACTIONS(4910),
    [anon_sym_unmanaged] = ACTIONS(4910),
    [anon_sym_get] = ACTIONS(4910),
    [anon_sym_set] = ACTIONS(4910),
    [anon_sym_add] = ACTIONS(4910),
    [anon_sym_remove] = ACTIONS(4910),
    [anon_sym_enum] = ACTIONS(4910),
    [anon_sym_interface] = ACTIONS(4910),
    [anon_sym_delegate] = ACTIONS(4910),
    [anon_sym_record] = ACTIONS(4910),
    [anon_sym_namespace] = ACTIONS(4910),
    [anon_sym_var] = ACTIONS(4910),
    [sym_predefined_type] = ACTIONS(4910),
    [anon_sym_when] = ACTIONS(4910),
    [anon_sym_yield] = ACTIONS(4910),
    [anon_sym_from] = ACTIONS(4910),
    [anon_sym_join] = ACTIONS(4910),
    [anon_sym_on] = ACTIONS(4910),
    [anon_sym_equals] = ACTIONS(4910),
    [anon_sym_into] = ACTIONS(4910),
    [anon_sym_let] = ACTIONS(4910),
    [anon_sym_orderby] = ACTIONS(4910),
    [anon_sym_ascending] = ACTIONS(4910),
    [anon_sym_descending] = ACTIONS(4910),
    [anon_sym_group] = ACTIONS(4910),
    [anon_sym_by] = ACTIONS(4910),
    [anon_sym_select] = ACTIONS(4910),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4910),
    [anon_sym_nameof] = ACTIONS(4910),
    [sym_void_keyword] = ACTIONS(4910),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2559] = {
    [sym__preprocessor_call] = STATE(2559),
    [sym__identifier_token] = ACTIONS(4914),
    [anon_sym_extern] = ACTIONS(4914),
    [anon_sym_alias] = ACTIONS(4914),
    [anon_sym_global] = ACTIONS(4914),
    [anon_sym_using] = ACTIONS(4914),
    [anon_sym_static] = ACTIONS(4914),
    [anon_sym_LBRACK] = ACTIONS(4916),
    [anon_sym_event] = ACTIONS(4914),
    [anon_sym_LPAREN] = ACTIONS(4916),
    [anon_sym_abstract] = ACTIONS(4914),
    [anon_sym_async] = ACTIONS(4914),
    [anon_sym_const] = ACTIONS(4914),
    [anon_sym_fixed] = ACTIONS(4914),
    [anon_sym_internal] = ACTIONS(4914),
    [anon_sym_new] = ACTIONS(4914),
    [anon_sym_override] = ACTIONS(4914),
    [anon_sym_partial] = ACTIONS(4914),
    [anon_sym_private] = ACTIONS(4914),
    [anon_sym_protected] = ACTIONS(4914),
    [anon_sym_public] = ACTIONS(4914),
    [anon_sym_readonly] = ACTIONS(4914),
    [anon_sym_ref] = ACTIONS(4914),
    [anon_sym_sealed] = ACTIONS(4914),
    [anon_sym_unsafe] = ACTIONS(4914),
    [anon_sym_virtual] = ACTIONS(4914),
    [anon_sym_volatile] = ACTIONS(4914),
    [anon_sym_RBRACE] = ACTIONS(4916),
    [anon_sym_implicit] = ACTIONS(4914),
    [anon_sym_explicit] = ACTIONS(4914),
    [anon_sym_TILDE] = ACTIONS(4916),
    [anon_sym_where] = ACTIONS(4914),
    [anon_sym_class] = ACTIONS(4914),
    [anon_sym_struct] = ACTIONS(4914),
    [anon_sym_notnull] = ACTIONS(4914),
    [anon_sym_unmanaged] = ACTIONS(4914),
    [anon_sym_get] = ACTIONS(4914),
    [anon_sym_set] = ACTIONS(4914),
    [anon_sym_add] = ACTIONS(4914),
    [anon_sym_remove] = ACTIONS(4914),
    [anon_sym_enum] = ACTIONS(4914),
    [anon_sym_interface] = ACTIONS(4914),
    [anon_sym_delegate] = ACTIONS(4914),
    [anon_sym_record] = ACTIONS(4914),
    [anon_sym_namespace] = ACTIONS(4914),
    [anon_sym_var] = ACTIONS(4914),
    [sym_predefined_type] = ACTIONS(4914),
    [anon_sym_when] = ACTIONS(4914),
    [anon_sym_yield] = ACTIONS(4914),
    [anon_sym_from] = ACTIONS(4914),
    [anon_sym_join] = ACTIONS(4914),
    [anon_sym_on] = ACTIONS(4914),
    [anon_sym_equals] = ACTIONS(4914),
    [anon_sym_into] = ACTIONS(4914),
    [anon_sym_let] = ACTIONS(4914),
    [anon_sym_orderby] = ACTIONS(4914),
    [anon_sym_ascending] = ACTIONS(4914),
    [anon_sym_descending] = ACTIONS(4914),
    [anon_sym_group] = ACTIONS(4914),
    [anon_sym_by] = ACTIONS(4914),
    [anon_sym_select] = ACTIONS(4914),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4914),
    [anon_sym_nameof] = ACTIONS(4914),
    [sym_void_keyword] = ACTIONS(4914),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2560] = {
    [sym__preprocessor_call] = STATE(2560),
    [sym__identifier_token] = ACTIONS(4918),
    [anon_sym_extern] = ACTIONS(4918),
    [anon_sym_alias] = ACTIONS(4918),
    [anon_sym_global] = ACTIONS(4918),
    [anon_sym_using] = ACTIONS(4918),
    [anon_sym_static] = ACTIONS(4918),
    [anon_sym_LBRACK] = ACTIONS(4920),
    [anon_sym_event] = ACTIONS(4918),
    [anon_sym_LPAREN] = ACTIONS(4920),
    [anon_sym_abstract] = ACTIONS(4918),
    [anon_sym_async] = ACTIONS(4918),
    [anon_sym_const] = ACTIONS(4918),
    [anon_sym_fixed] = ACTIONS(4918),
    [anon_sym_internal] = ACTIONS(4918),
    [anon_sym_new] = ACTIONS(4918),
    [anon_sym_override] = ACTIONS(4918),
    [anon_sym_partial] = ACTIONS(4918),
    [anon_sym_private] = ACTIONS(4918),
    [anon_sym_protected] = ACTIONS(4918),
    [anon_sym_public] = ACTIONS(4918),
    [anon_sym_readonly] = ACTIONS(4918),
    [anon_sym_ref] = ACTIONS(4918),
    [anon_sym_sealed] = ACTIONS(4918),
    [anon_sym_unsafe] = ACTIONS(4918),
    [anon_sym_virtual] = ACTIONS(4918),
    [anon_sym_volatile] = ACTIONS(4918),
    [anon_sym_RBRACE] = ACTIONS(4920),
    [anon_sym_implicit] = ACTIONS(4918),
    [anon_sym_explicit] = ACTIONS(4918),
    [anon_sym_TILDE] = ACTIONS(4920),
    [anon_sym_where] = ACTIONS(4918),
    [anon_sym_class] = ACTIONS(4918),
    [anon_sym_struct] = ACTIONS(4918),
    [anon_sym_notnull] = ACTIONS(4918),
    [anon_sym_unmanaged] = ACTIONS(4918),
    [anon_sym_get] = ACTIONS(4918),
    [anon_sym_set] = ACTIONS(4918),
    [anon_sym_add] = ACTIONS(4918),
    [anon_sym_remove] = ACTIONS(4918),
    [anon_sym_enum] = ACTIONS(4918),
    [anon_sym_interface] = ACTIONS(4918),
    [anon_sym_delegate] = ACTIONS(4918),
    [anon_sym_record] = ACTIONS(4918),
    [anon_sym_namespace] = ACTIONS(4918),
    [anon_sym_var] = ACTIONS(4918),
    [sym_predefined_type] = ACTIONS(4918),
    [anon_sym_when] = ACTIONS(4918),
    [anon_sym_yield] = ACTIONS(4918),
    [anon_sym_from] = ACTIONS(4918),
    [anon_sym_join] = ACTIONS(4918),
    [anon_sym_on] = ACTIONS(4918),
    [anon_sym_equals] = ACTIONS(4918),
    [anon_sym_into] = ACTIONS(4918),
    [anon_sym_let] = ACTIONS(4918),
    [anon_sym_orderby] = ACTIONS(4918),
    [anon_sym_ascending] = ACTIONS(4918),
    [anon_sym_descending] = ACTIONS(4918),
    [anon_sym_group] = ACTIONS(4918),
    [anon_sym_by] = ACTIONS(4918),
    [anon_sym_select] = ACTIONS(4918),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4918),
    [anon_sym_nameof] = ACTIONS(4918),
    [sym_void_keyword] = ACTIONS(4918),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2561] = {
    [sym__preprocessor_call] = STATE(2561),
    [sym__identifier_token] = ACTIONS(4922),
    [anon_sym_extern] = ACTIONS(4922),
    [anon_sym_alias] = ACTIONS(4922),
    [anon_sym_global] = ACTIONS(4922),
    [anon_sym_using] = ACTIONS(4922),
    [anon_sym_static] = ACTIONS(4922),
    [anon_sym_LBRACK] = ACTIONS(4924),
    [anon_sym_event] = ACTIONS(4922),
    [anon_sym_LPAREN] = ACTIONS(4924),
    [anon_sym_abstract] = ACTIONS(4922),
    [anon_sym_async] = ACTIONS(4922),
    [anon_sym_const] = ACTIONS(4922),
    [anon_sym_fixed] = ACTIONS(4922),
    [anon_sym_internal] = ACTIONS(4922),
    [anon_sym_new] = ACTIONS(4922),
    [anon_sym_override] = ACTIONS(4922),
    [anon_sym_partial] = ACTIONS(4922),
    [anon_sym_private] = ACTIONS(4922),
    [anon_sym_protected] = ACTIONS(4922),
    [anon_sym_public] = ACTIONS(4922),
    [anon_sym_readonly] = ACTIONS(4922),
    [anon_sym_ref] = ACTIONS(4922),
    [anon_sym_sealed] = ACTIONS(4922),
    [anon_sym_unsafe] = ACTIONS(4922),
    [anon_sym_virtual] = ACTIONS(4922),
    [anon_sym_volatile] = ACTIONS(4922),
    [anon_sym_RBRACE] = ACTIONS(4924),
    [anon_sym_implicit] = ACTIONS(4922),
    [anon_sym_explicit] = ACTIONS(4922),
    [anon_sym_TILDE] = ACTIONS(4924),
    [anon_sym_where] = ACTIONS(4922),
    [anon_sym_class] = ACTIONS(4922),
    [anon_sym_struct] = ACTIONS(4922),
    [anon_sym_notnull] = ACTIONS(4922),
    [anon_sym_unmanaged] = ACTIONS(4922),
    [anon_sym_get] = ACTIONS(4922),
    [anon_sym_set] = ACTIONS(4922),
    [anon_sym_add] = ACTIONS(4922),
    [anon_sym_remove] = ACTIONS(4922),
    [anon_sym_enum] = ACTIONS(4922),
    [anon_sym_interface] = ACTIONS(4922),
    [anon_sym_delegate] = ACTIONS(4922),
    [anon_sym_record] = ACTIONS(4922),
    [anon_sym_namespace] = ACTIONS(4922),
    [anon_sym_var] = ACTIONS(4922),
    [sym_predefined_type] = ACTIONS(4922),
    [anon_sym_when] = ACTIONS(4922),
    [anon_sym_yield] = ACTIONS(4922),
    [anon_sym_from] = ACTIONS(4922),
    [anon_sym_join] = ACTIONS(4922),
    [anon_sym_on] = ACTIONS(4922),
    [anon_sym_equals] = ACTIONS(4922),
    [anon_sym_into] = ACTIONS(4922),
    [anon_sym_let] = ACTIONS(4922),
    [anon_sym_orderby] = ACTIONS(4922),
    [anon_sym_ascending] = ACTIONS(4922),
    [anon_sym_descending] = ACTIONS(4922),
    [anon_sym_group] = ACTIONS(4922),
    [anon_sym_by] = ACTIONS(4922),
    [anon_sym_select] = ACTIONS(4922),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4922),
    [anon_sym_nameof] = ACTIONS(4922),
    [sym_void_keyword] = ACTIONS(4922),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2562] = {
    [sym__preprocessor_call] = STATE(2562),
    [sym__identifier_token] = ACTIONS(4926),
    [anon_sym_extern] = ACTIONS(4926),
    [anon_sym_alias] = ACTIONS(4926),
    [anon_sym_global] = ACTIONS(4926),
    [anon_sym_using] = ACTIONS(4926),
    [anon_sym_static] = ACTIONS(4926),
    [anon_sym_LBRACK] = ACTIONS(4928),
    [anon_sym_event] = ACTIONS(4926),
    [anon_sym_LPAREN] = ACTIONS(4928),
    [anon_sym_abstract] = ACTIONS(4926),
    [anon_sym_async] = ACTIONS(4926),
    [anon_sym_const] = ACTIONS(4926),
    [anon_sym_fixed] = ACTIONS(4926),
    [anon_sym_internal] = ACTIONS(4926),
    [anon_sym_new] = ACTIONS(4926),
    [anon_sym_override] = ACTIONS(4926),
    [anon_sym_partial] = ACTIONS(4926),
    [anon_sym_private] = ACTIONS(4926),
    [anon_sym_protected] = ACTIONS(4926),
    [anon_sym_public] = ACTIONS(4926),
    [anon_sym_readonly] = ACTIONS(4926),
    [anon_sym_ref] = ACTIONS(4926),
    [anon_sym_sealed] = ACTIONS(4926),
    [anon_sym_unsafe] = ACTIONS(4926),
    [anon_sym_virtual] = ACTIONS(4926),
    [anon_sym_volatile] = ACTIONS(4926),
    [anon_sym_RBRACE] = ACTIONS(4928),
    [anon_sym_implicit] = ACTIONS(4926),
    [anon_sym_explicit] = ACTIONS(4926),
    [anon_sym_TILDE] = ACTIONS(4928),
    [anon_sym_where] = ACTIONS(4926),
    [anon_sym_class] = ACTIONS(4926),
    [anon_sym_struct] = ACTIONS(4926),
    [anon_sym_notnull] = ACTIONS(4926),
    [anon_sym_unmanaged] = ACTIONS(4926),
    [anon_sym_get] = ACTIONS(4926),
    [anon_sym_set] = ACTIONS(4926),
    [anon_sym_add] = ACTIONS(4926),
    [anon_sym_remove] = ACTIONS(4926),
    [anon_sym_enum] = ACTIONS(4926),
    [anon_sym_interface] = ACTIONS(4926),
    [anon_sym_delegate] = ACTIONS(4926),
    [anon_sym_record] = ACTIONS(4926),
    [anon_sym_namespace] = ACTIONS(4926),
    [anon_sym_var] = ACTIONS(4926),
    [sym_predefined_type] = ACTIONS(4926),
    [anon_sym_when] = ACTIONS(4926),
    [anon_sym_yield] = ACTIONS(4926),
    [anon_sym_from] = ACTIONS(4926),
    [anon_sym_join] = ACTIONS(4926),
    [anon_sym_on] = ACTIONS(4926),
    [anon_sym_equals] = ACTIONS(4926),
    [anon_sym_into] = ACTIONS(4926),
    [anon_sym_let] = ACTIONS(4926),
    [anon_sym_orderby] = ACTIONS(4926),
    [anon_sym_ascending] = ACTIONS(4926),
    [anon_sym_descending] = ACTIONS(4926),
    [anon_sym_group] = ACTIONS(4926),
    [anon_sym_by] = ACTIONS(4926),
    [anon_sym_select] = ACTIONS(4926),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4926),
    [anon_sym_nameof] = ACTIONS(4926),
    [sym_void_keyword] = ACTIONS(4926),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2563] = {
    [sym__preprocessor_call] = STATE(2563),
    [sym__identifier_token] = ACTIONS(4930),
    [anon_sym_extern] = ACTIONS(4930),
    [anon_sym_alias] = ACTIONS(4930),
    [anon_sym_global] = ACTIONS(4930),
    [anon_sym_using] = ACTIONS(4930),
    [anon_sym_static] = ACTIONS(4930),
    [anon_sym_LBRACK] = ACTIONS(4932),
    [anon_sym_event] = ACTIONS(4930),
    [anon_sym_LPAREN] = ACTIONS(4932),
    [anon_sym_abstract] = ACTIONS(4930),
    [anon_sym_async] = ACTIONS(4930),
    [anon_sym_const] = ACTIONS(4930),
    [anon_sym_fixed] = ACTIONS(4930),
    [anon_sym_internal] = ACTIONS(4930),
    [anon_sym_new] = ACTIONS(4930),
    [anon_sym_override] = ACTIONS(4930),
    [anon_sym_partial] = ACTIONS(4930),
    [anon_sym_private] = ACTIONS(4930),
    [anon_sym_protected] = ACTIONS(4930),
    [anon_sym_public] = ACTIONS(4930),
    [anon_sym_readonly] = ACTIONS(4930),
    [anon_sym_ref] = ACTIONS(4930),
    [anon_sym_sealed] = ACTIONS(4930),
    [anon_sym_unsafe] = ACTIONS(4930),
    [anon_sym_virtual] = ACTIONS(4930),
    [anon_sym_volatile] = ACTIONS(4930),
    [anon_sym_RBRACE] = ACTIONS(4932),
    [anon_sym_implicit] = ACTIONS(4930),
    [anon_sym_explicit] = ACTIONS(4930),
    [anon_sym_TILDE] = ACTIONS(4932),
    [anon_sym_where] = ACTIONS(4930),
    [anon_sym_class] = ACTIONS(4930),
    [anon_sym_struct] = ACTIONS(4930),
    [anon_sym_notnull] = ACTIONS(4930),
    [anon_sym_unmanaged] = ACTIONS(4930),
    [anon_sym_get] = ACTIONS(4930),
    [anon_sym_set] = ACTIONS(4930),
    [anon_sym_add] = ACTIONS(4930),
    [anon_sym_remove] = ACTIONS(4930),
    [anon_sym_enum] = ACTIONS(4930),
    [anon_sym_interface] = ACTIONS(4930),
    [anon_sym_delegate] = ACTIONS(4930),
    [anon_sym_record] = ACTIONS(4930),
    [anon_sym_namespace] = ACTIONS(4930),
    [anon_sym_var] = ACTIONS(4930),
    [sym_predefined_type] = ACTIONS(4930),
    [anon_sym_when] = ACTIONS(4930),
    [anon_sym_yield] = ACTIONS(4930),
    [anon_sym_from] = ACTIONS(4930),
    [anon_sym_join] = ACTIONS(4930),
    [anon_sym_on] = ACTIONS(4930),
    [anon_sym_equals] = ACTIONS(4930),
    [anon_sym_into] = ACTIONS(4930),
    [anon_sym_let] = ACTIONS(4930),
    [anon_sym_orderby] = ACTIONS(4930),
    [anon_sym_ascending] = ACTIONS(4930),
    [anon_sym_descending] = ACTIONS(4930),
    [anon_sym_group] = ACTIONS(4930),
    [anon_sym_by] = ACTIONS(4930),
    [anon_sym_select] = ACTIONS(4930),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4930),
    [anon_sym_nameof] = ACTIONS(4930),
    [sym_void_keyword] = ACTIONS(4930),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2564] = {
    [sym__preprocessor_call] = STATE(2564),
    [sym__identifier_token] = ACTIONS(4934),
    [anon_sym_extern] = ACTIONS(4934),
    [anon_sym_alias] = ACTIONS(4934),
    [anon_sym_global] = ACTIONS(4934),
    [anon_sym_using] = ACTIONS(4934),
    [anon_sym_static] = ACTIONS(4934),
    [anon_sym_LBRACK] = ACTIONS(4936),
    [anon_sym_event] = ACTIONS(4934),
    [anon_sym_LPAREN] = ACTIONS(4936),
    [anon_sym_abstract] = ACTIONS(4934),
    [anon_sym_async] = ACTIONS(4934),
    [anon_sym_const] = ACTIONS(4934),
    [anon_sym_fixed] = ACTIONS(4934),
    [anon_sym_internal] = ACTIONS(4934),
    [anon_sym_new] = ACTIONS(4934),
    [anon_sym_override] = ACTIONS(4934),
    [anon_sym_partial] = ACTIONS(4934),
    [anon_sym_private] = ACTIONS(4934),
    [anon_sym_protected] = ACTIONS(4934),
    [anon_sym_public] = ACTIONS(4934),
    [anon_sym_readonly] = ACTIONS(4934),
    [anon_sym_ref] = ACTIONS(4934),
    [anon_sym_sealed] = ACTIONS(4934),
    [anon_sym_unsafe] = ACTIONS(4934),
    [anon_sym_virtual] = ACTIONS(4934),
    [anon_sym_volatile] = ACTIONS(4934),
    [anon_sym_RBRACE] = ACTIONS(4936),
    [anon_sym_implicit] = ACTIONS(4934),
    [anon_sym_explicit] = ACTIONS(4934),
    [anon_sym_TILDE] = ACTIONS(4936),
    [anon_sym_where] = ACTIONS(4934),
    [anon_sym_class] = ACTIONS(4934),
    [anon_sym_struct] = ACTIONS(4934),
    [anon_sym_notnull] = ACTIONS(4934),
    [anon_sym_unmanaged] = ACTIONS(4934),
    [anon_sym_get] = ACTIONS(4934),
    [anon_sym_set] = ACTIONS(4934),
    [anon_sym_add] = ACTIONS(4934),
    [anon_sym_remove] = ACTIONS(4934),
    [anon_sym_enum] = ACTIONS(4934),
    [anon_sym_interface] = ACTIONS(4934),
    [anon_sym_delegate] = ACTIONS(4934),
    [anon_sym_record] = ACTIONS(4934),
    [anon_sym_namespace] = ACTIONS(4934),
    [anon_sym_var] = ACTIONS(4934),
    [sym_predefined_type] = ACTIONS(4934),
    [anon_sym_when] = ACTIONS(4934),
    [anon_sym_yield] = ACTIONS(4934),
    [anon_sym_from] = ACTIONS(4934),
    [anon_sym_join] = ACTIONS(4934),
    [anon_sym_on] = ACTIONS(4934),
    [anon_sym_equals] = ACTIONS(4934),
    [anon_sym_into] = ACTIONS(4934),
    [anon_sym_let] = ACTIONS(4934),
    [anon_sym_orderby] = ACTIONS(4934),
    [anon_sym_ascending] = ACTIONS(4934),
    [anon_sym_descending] = ACTIONS(4934),
    [anon_sym_group] = ACTIONS(4934),
    [anon_sym_by] = ACTIONS(4934),
    [anon_sym_select] = ACTIONS(4934),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4934),
    [anon_sym_nameof] = ACTIONS(4934),
    [sym_void_keyword] = ACTIONS(4934),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2565] = {
    [sym__preprocessor_call] = STATE(2565),
    [sym__identifier_token] = ACTIONS(4938),
    [anon_sym_extern] = ACTIONS(4938),
    [anon_sym_alias] = ACTIONS(4938),
    [anon_sym_global] = ACTIONS(4938),
    [anon_sym_using] = ACTIONS(4938),
    [anon_sym_static] = ACTIONS(4938),
    [anon_sym_LBRACK] = ACTIONS(4940),
    [anon_sym_event] = ACTIONS(4938),
    [anon_sym_LPAREN] = ACTIONS(4940),
    [anon_sym_abstract] = ACTIONS(4938),
    [anon_sym_async] = ACTIONS(4938),
    [anon_sym_const] = ACTIONS(4938),
    [anon_sym_fixed] = ACTIONS(4938),
    [anon_sym_internal] = ACTIONS(4938),
    [anon_sym_new] = ACTIONS(4938),
    [anon_sym_override] = ACTIONS(4938),
    [anon_sym_partial] = ACTIONS(4938),
    [anon_sym_private] = ACTIONS(4938),
    [anon_sym_protected] = ACTIONS(4938),
    [anon_sym_public] = ACTIONS(4938),
    [anon_sym_readonly] = ACTIONS(4938),
    [anon_sym_ref] = ACTIONS(4938),
    [anon_sym_sealed] = ACTIONS(4938),
    [anon_sym_unsafe] = ACTIONS(4938),
    [anon_sym_virtual] = ACTIONS(4938),
    [anon_sym_volatile] = ACTIONS(4938),
    [anon_sym_RBRACE] = ACTIONS(4940),
    [anon_sym_implicit] = ACTIONS(4938),
    [anon_sym_explicit] = ACTIONS(4938),
    [anon_sym_TILDE] = ACTIONS(4940),
    [anon_sym_where] = ACTIONS(4938),
    [anon_sym_class] = ACTIONS(4938),
    [anon_sym_struct] = ACTIONS(4938),
    [anon_sym_notnull] = ACTIONS(4938),
    [anon_sym_unmanaged] = ACTIONS(4938),
    [anon_sym_get] = ACTIONS(4938),
    [anon_sym_set] = ACTIONS(4938),
    [anon_sym_add] = ACTIONS(4938),
    [anon_sym_remove] = ACTIONS(4938),
    [anon_sym_enum] = ACTIONS(4938),
    [anon_sym_interface] = ACTIONS(4938),
    [anon_sym_delegate] = ACTIONS(4938),
    [anon_sym_record] = ACTIONS(4938),
    [anon_sym_namespace] = ACTIONS(4938),
    [anon_sym_var] = ACTIONS(4938),
    [sym_predefined_type] = ACTIONS(4938),
    [anon_sym_when] = ACTIONS(4938),
    [anon_sym_yield] = ACTIONS(4938),
    [anon_sym_from] = ACTIONS(4938),
    [anon_sym_join] = ACTIONS(4938),
    [anon_sym_on] = ACTIONS(4938),
    [anon_sym_equals] = ACTIONS(4938),
    [anon_sym_into] = ACTIONS(4938),
    [anon_sym_let] = ACTIONS(4938),
    [anon_sym_orderby] = ACTIONS(4938),
    [anon_sym_ascending] = ACTIONS(4938),
    [anon_sym_descending] = ACTIONS(4938),
    [anon_sym_group] = ACTIONS(4938),
    [anon_sym_by] = ACTIONS(4938),
    [anon_sym_select] = ACTIONS(4938),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4938),
    [anon_sym_nameof] = ACTIONS(4938),
    [sym_void_keyword] = ACTIONS(4938),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2566] = {
    [sym__preprocessor_call] = STATE(2566),
    [sym__identifier_token] = ACTIONS(4942),
    [anon_sym_extern] = ACTIONS(4942),
    [anon_sym_alias] = ACTIONS(4942),
    [anon_sym_global] = ACTIONS(4942),
    [anon_sym_using] = ACTIONS(4942),
    [anon_sym_static] = ACTIONS(4942),
    [anon_sym_LBRACK] = ACTIONS(4944),
    [anon_sym_event] = ACTIONS(4942),
    [anon_sym_LPAREN] = ACTIONS(4944),
    [anon_sym_abstract] = ACTIONS(4942),
    [anon_sym_async] = ACTIONS(4942),
    [anon_sym_const] = ACTIONS(4942),
    [anon_sym_fixed] = ACTIONS(4942),
    [anon_sym_internal] = ACTIONS(4942),
    [anon_sym_new] = ACTIONS(4942),
    [anon_sym_override] = ACTIONS(4942),
    [anon_sym_partial] = ACTIONS(4942),
    [anon_sym_private] = ACTIONS(4942),
    [anon_sym_protected] = ACTIONS(4942),
    [anon_sym_public] = ACTIONS(4942),
    [anon_sym_readonly] = ACTIONS(4942),
    [anon_sym_ref] = ACTIONS(4942),
    [anon_sym_sealed] = ACTIONS(4942),
    [anon_sym_unsafe] = ACTIONS(4942),
    [anon_sym_virtual] = ACTIONS(4942),
    [anon_sym_volatile] = ACTIONS(4942),
    [anon_sym_RBRACE] = ACTIONS(4944),
    [anon_sym_implicit] = ACTIONS(4942),
    [anon_sym_explicit] = ACTIONS(4942),
    [anon_sym_TILDE] = ACTIONS(4944),
    [anon_sym_where] = ACTIONS(4942),
    [anon_sym_class] = ACTIONS(4942),
    [anon_sym_struct] = ACTIONS(4942),
    [anon_sym_notnull] = ACTIONS(4942),
    [anon_sym_unmanaged] = ACTIONS(4942),
    [anon_sym_get] = ACTIONS(4942),
    [anon_sym_set] = ACTIONS(4942),
    [anon_sym_add] = ACTIONS(4942),
    [anon_sym_remove] = ACTIONS(4942),
    [anon_sym_enum] = ACTIONS(4942),
    [anon_sym_interface] = ACTIONS(4942),
    [anon_sym_delegate] = ACTIONS(4942),
    [anon_sym_record] = ACTIONS(4942),
    [anon_sym_namespace] = ACTIONS(4942),
    [anon_sym_var] = ACTIONS(4942),
    [sym_predefined_type] = ACTIONS(4942),
    [anon_sym_when] = ACTIONS(4942),
    [anon_sym_yield] = ACTIONS(4942),
    [anon_sym_from] = ACTIONS(4942),
    [anon_sym_join] = ACTIONS(4942),
    [anon_sym_on] = ACTIONS(4942),
    [anon_sym_equals] = ACTIONS(4942),
    [anon_sym_into] = ACTIONS(4942),
    [anon_sym_let] = ACTIONS(4942),
    [anon_sym_orderby] = ACTIONS(4942),
    [anon_sym_ascending] = ACTIONS(4942),
    [anon_sym_descending] = ACTIONS(4942),
    [anon_sym_group] = ACTIONS(4942),
    [anon_sym_by] = ACTIONS(4942),
    [anon_sym_select] = ACTIONS(4942),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4942),
    [anon_sym_nameof] = ACTIONS(4942),
    [sym_void_keyword] = ACTIONS(4942),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2567] = {
    [sym__preprocessor_call] = STATE(2567),
    [sym__identifier_token] = ACTIONS(4946),
    [anon_sym_extern] = ACTIONS(4946),
    [anon_sym_alias] = ACTIONS(4946),
    [anon_sym_global] = ACTIONS(4946),
    [anon_sym_using] = ACTIONS(4946),
    [anon_sym_static] = ACTIONS(4946),
    [anon_sym_LBRACK] = ACTIONS(4948),
    [anon_sym_event] = ACTIONS(4946),
    [anon_sym_LPAREN] = ACTIONS(4948),
    [anon_sym_abstract] = ACTIONS(4946),
    [anon_sym_async] = ACTIONS(4946),
    [anon_sym_const] = ACTIONS(4946),
    [anon_sym_fixed] = ACTIONS(4946),
    [anon_sym_internal] = ACTIONS(4946),
    [anon_sym_new] = ACTIONS(4946),
    [anon_sym_override] = ACTIONS(4946),
    [anon_sym_partial] = ACTIONS(4946),
    [anon_sym_private] = ACTIONS(4946),
    [anon_sym_protected] = ACTIONS(4946),
    [anon_sym_public] = ACTIONS(4946),
    [anon_sym_readonly] = ACTIONS(4946),
    [anon_sym_ref] = ACTIONS(4946),
    [anon_sym_sealed] = ACTIONS(4946),
    [anon_sym_unsafe] = ACTIONS(4946),
    [anon_sym_virtual] = ACTIONS(4946),
    [anon_sym_volatile] = ACTIONS(4946),
    [anon_sym_RBRACE] = ACTIONS(4948),
    [anon_sym_implicit] = ACTIONS(4946),
    [anon_sym_explicit] = ACTIONS(4946),
    [anon_sym_TILDE] = ACTIONS(4948),
    [anon_sym_where] = ACTIONS(4946),
    [anon_sym_class] = ACTIONS(4946),
    [anon_sym_struct] = ACTIONS(4946),
    [anon_sym_notnull] = ACTIONS(4946),
    [anon_sym_unmanaged] = ACTIONS(4946),
    [anon_sym_get] = ACTIONS(4946),
    [anon_sym_set] = ACTIONS(4946),
    [anon_sym_add] = ACTIONS(4946),
    [anon_sym_remove] = ACTIONS(4946),
    [anon_sym_enum] = ACTIONS(4946),
    [anon_sym_interface] = ACTIONS(4946),
    [anon_sym_delegate] = ACTIONS(4946),
    [anon_sym_record] = ACTIONS(4946),
    [anon_sym_namespace] = ACTIONS(4946),
    [anon_sym_var] = ACTIONS(4946),
    [sym_predefined_type] = ACTIONS(4946),
    [anon_sym_when] = ACTIONS(4946),
    [anon_sym_yield] = ACTIONS(4946),
    [anon_sym_from] = ACTIONS(4946),
    [anon_sym_join] = ACTIONS(4946),
    [anon_sym_on] = ACTIONS(4946),
    [anon_sym_equals] = ACTIONS(4946),
    [anon_sym_into] = ACTIONS(4946),
    [anon_sym_let] = ACTIONS(4946),
    [anon_sym_orderby] = ACTIONS(4946),
    [anon_sym_ascending] = ACTIONS(4946),
    [anon_sym_descending] = ACTIONS(4946),
    [anon_sym_group] = ACTIONS(4946),
    [anon_sym_by] = ACTIONS(4946),
    [anon_sym_select] = ACTIONS(4946),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4946),
    [anon_sym_nameof] = ACTIONS(4946),
    [sym_void_keyword] = ACTIONS(4946),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2568] = {
    [sym__preprocessor_call] = STATE(2568),
    [sym__identifier_token] = ACTIONS(4950),
    [anon_sym_extern] = ACTIONS(4950),
    [anon_sym_alias] = ACTIONS(4950),
    [anon_sym_global] = ACTIONS(4950),
    [anon_sym_using] = ACTIONS(4950),
    [anon_sym_static] = ACTIONS(4950),
    [anon_sym_LBRACK] = ACTIONS(4952),
    [anon_sym_event] = ACTIONS(4950),
    [anon_sym_LPAREN] = ACTIONS(4952),
    [anon_sym_abstract] = ACTIONS(4950),
    [anon_sym_async] = ACTIONS(4950),
    [anon_sym_const] = ACTIONS(4950),
    [anon_sym_fixed] = ACTIONS(4950),
    [anon_sym_internal] = ACTIONS(4950),
    [anon_sym_new] = ACTIONS(4950),
    [anon_sym_override] = ACTIONS(4950),
    [anon_sym_partial] = ACTIONS(4950),
    [anon_sym_private] = ACTIONS(4950),
    [anon_sym_protected] = ACTIONS(4950),
    [anon_sym_public] = ACTIONS(4950),
    [anon_sym_readonly] = ACTIONS(4950),
    [anon_sym_ref] = ACTIONS(4950),
    [anon_sym_sealed] = ACTIONS(4950),
    [anon_sym_unsafe] = ACTIONS(4950),
    [anon_sym_virtual] = ACTIONS(4950),
    [anon_sym_volatile] = ACTIONS(4950),
    [anon_sym_RBRACE] = ACTIONS(4952),
    [anon_sym_implicit] = ACTIONS(4950),
    [anon_sym_explicit] = ACTIONS(4950),
    [anon_sym_TILDE] = ACTIONS(4952),
    [anon_sym_where] = ACTIONS(4950),
    [anon_sym_class] = ACTIONS(4950),
    [anon_sym_struct] = ACTIONS(4950),
    [anon_sym_notnull] = ACTIONS(4950),
    [anon_sym_unmanaged] = ACTIONS(4950),
    [anon_sym_get] = ACTIONS(4950),
    [anon_sym_set] = ACTIONS(4950),
    [anon_sym_add] = ACTIONS(4950),
    [anon_sym_remove] = ACTIONS(4950),
    [anon_sym_enum] = ACTIONS(4950),
    [anon_sym_interface] = ACTIONS(4950),
    [anon_sym_delegate] = ACTIONS(4950),
    [anon_sym_record] = ACTIONS(4950),
    [anon_sym_namespace] = ACTIONS(4950),
    [anon_sym_var] = ACTIONS(4950),
    [sym_predefined_type] = ACTIONS(4950),
    [anon_sym_when] = ACTIONS(4950),
    [anon_sym_yield] = ACTIONS(4950),
    [anon_sym_from] = ACTIONS(4950),
    [anon_sym_join] = ACTIONS(4950),
    [anon_sym_on] = ACTIONS(4950),
    [anon_sym_equals] = ACTIONS(4950),
    [anon_sym_into] = ACTIONS(4950),
    [anon_sym_let] = ACTIONS(4950),
    [anon_sym_orderby] = ACTIONS(4950),
    [anon_sym_ascending] = ACTIONS(4950),
    [anon_sym_descending] = ACTIONS(4950),
    [anon_sym_group] = ACTIONS(4950),
    [anon_sym_by] = ACTIONS(4950),
    [anon_sym_select] = ACTIONS(4950),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4950),
    [anon_sym_nameof] = ACTIONS(4950),
    [sym_void_keyword] = ACTIONS(4950),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2569] = {
    [sym__preprocessor_call] = STATE(2569),
    [sym__identifier_token] = ACTIONS(4954),
    [anon_sym_extern] = ACTIONS(4954),
    [anon_sym_alias] = ACTIONS(4954),
    [anon_sym_global] = ACTIONS(4954),
    [anon_sym_using] = ACTIONS(4954),
    [anon_sym_static] = ACTIONS(4954),
    [anon_sym_LBRACK] = ACTIONS(4956),
    [anon_sym_event] = ACTIONS(4954),
    [anon_sym_LPAREN] = ACTIONS(4956),
    [anon_sym_abstract] = ACTIONS(4954),
    [anon_sym_async] = ACTIONS(4954),
    [anon_sym_const] = ACTIONS(4954),
    [anon_sym_fixed] = ACTIONS(4954),
    [anon_sym_internal] = ACTIONS(4954),
    [anon_sym_new] = ACTIONS(4954),
    [anon_sym_override] = ACTIONS(4954),
    [anon_sym_partial] = ACTIONS(4954),
    [anon_sym_private] = ACTIONS(4954),
    [anon_sym_protected] = ACTIONS(4954),
    [anon_sym_public] = ACTIONS(4954),
    [anon_sym_readonly] = ACTIONS(4954),
    [anon_sym_ref] = ACTIONS(4954),
    [anon_sym_sealed] = ACTIONS(4954),
    [anon_sym_unsafe] = ACTIONS(4954),
    [anon_sym_virtual] = ACTIONS(4954),
    [anon_sym_volatile] = ACTIONS(4954),
    [anon_sym_RBRACE] = ACTIONS(4956),
    [anon_sym_implicit] = ACTIONS(4954),
    [anon_sym_explicit] = ACTIONS(4954),
    [anon_sym_TILDE] = ACTIONS(4956),
    [anon_sym_where] = ACTIONS(4954),
    [anon_sym_class] = ACTIONS(4954),
    [anon_sym_struct] = ACTIONS(4954),
    [anon_sym_notnull] = ACTIONS(4954),
    [anon_sym_unmanaged] = ACTIONS(4954),
    [anon_sym_get] = ACTIONS(4954),
    [anon_sym_set] = ACTIONS(4954),
    [anon_sym_add] = ACTIONS(4954),
    [anon_sym_remove] = ACTIONS(4954),
    [anon_sym_enum] = ACTIONS(4954),
    [anon_sym_interface] = ACTIONS(4954),
    [anon_sym_delegate] = ACTIONS(4954),
    [anon_sym_record] = ACTIONS(4954),
    [anon_sym_namespace] = ACTIONS(4954),
    [anon_sym_var] = ACTIONS(4954),
    [sym_predefined_type] = ACTIONS(4954),
    [anon_sym_when] = ACTIONS(4954),
    [anon_sym_yield] = ACTIONS(4954),
    [anon_sym_from] = ACTIONS(4954),
    [anon_sym_join] = ACTIONS(4954),
    [anon_sym_on] = ACTIONS(4954),
    [anon_sym_equals] = ACTIONS(4954),
    [anon_sym_into] = ACTIONS(4954),
    [anon_sym_let] = ACTIONS(4954),
    [anon_sym_orderby] = ACTIONS(4954),
    [anon_sym_ascending] = ACTIONS(4954),
    [anon_sym_descending] = ACTIONS(4954),
    [anon_sym_group] = ACTIONS(4954),
    [anon_sym_by] = ACTIONS(4954),
    [anon_sym_select] = ACTIONS(4954),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4954),
    [anon_sym_nameof] = ACTIONS(4954),
    [sym_void_keyword] = ACTIONS(4954),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2570] = {
    [sym__preprocessor_call] = STATE(2570),
    [sym__identifier_token] = ACTIONS(4958),
    [anon_sym_extern] = ACTIONS(4958),
    [anon_sym_alias] = ACTIONS(4958),
    [anon_sym_global] = ACTIONS(4958),
    [anon_sym_using] = ACTIONS(4958),
    [anon_sym_static] = ACTIONS(4958),
    [anon_sym_LBRACK] = ACTIONS(4960),
    [anon_sym_event] = ACTIONS(4958),
    [anon_sym_LPAREN] = ACTIONS(4960),
    [anon_sym_abstract] = ACTIONS(4958),
    [anon_sym_async] = ACTIONS(4958),
    [anon_sym_const] = ACTIONS(4958),
    [anon_sym_fixed] = ACTIONS(4958),
    [anon_sym_internal] = ACTIONS(4958),
    [anon_sym_new] = ACTIONS(4958),
    [anon_sym_override] = ACTIONS(4958),
    [anon_sym_partial] = ACTIONS(4958),
    [anon_sym_private] = ACTIONS(4958),
    [anon_sym_protected] = ACTIONS(4958),
    [anon_sym_public] = ACTIONS(4958),
    [anon_sym_readonly] = ACTIONS(4958),
    [anon_sym_ref] = ACTIONS(4958),
    [anon_sym_sealed] = ACTIONS(4958),
    [anon_sym_unsafe] = ACTIONS(4958),
    [anon_sym_virtual] = ACTIONS(4958),
    [anon_sym_volatile] = ACTIONS(4958),
    [anon_sym_RBRACE] = ACTIONS(4960),
    [anon_sym_implicit] = ACTIONS(4958),
    [anon_sym_explicit] = ACTIONS(4958),
    [anon_sym_TILDE] = ACTIONS(4960),
    [anon_sym_where] = ACTIONS(4958),
    [anon_sym_class] = ACTIONS(4958),
    [anon_sym_struct] = ACTIONS(4958),
    [anon_sym_notnull] = ACTIONS(4958),
    [anon_sym_unmanaged] = ACTIONS(4958),
    [anon_sym_get] = ACTIONS(4958),
    [anon_sym_set] = ACTIONS(4958),
    [anon_sym_add] = ACTIONS(4958),
    [anon_sym_remove] = ACTIONS(4958),
    [anon_sym_enum] = ACTIONS(4958),
    [anon_sym_interface] = ACTIONS(4958),
    [anon_sym_delegate] = ACTIONS(4958),
    [anon_sym_record] = ACTIONS(4958),
    [anon_sym_namespace] = ACTIONS(4958),
    [anon_sym_var] = ACTIONS(4958),
    [sym_predefined_type] = ACTIONS(4958),
    [anon_sym_when] = ACTIONS(4958),
    [anon_sym_yield] = ACTIONS(4958),
    [anon_sym_from] = ACTIONS(4958),
    [anon_sym_join] = ACTIONS(4958),
    [anon_sym_on] = ACTIONS(4958),
    [anon_sym_equals] = ACTIONS(4958),
    [anon_sym_into] = ACTIONS(4958),
    [anon_sym_let] = ACTIONS(4958),
    [anon_sym_orderby] = ACTIONS(4958),
    [anon_sym_ascending] = ACTIONS(4958),
    [anon_sym_descending] = ACTIONS(4958),
    [anon_sym_group] = ACTIONS(4958),
    [anon_sym_by] = ACTIONS(4958),
    [anon_sym_select] = ACTIONS(4958),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4958),
    [anon_sym_nameof] = ACTIONS(4958),
    [sym_void_keyword] = ACTIONS(4958),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2571] = {
    [sym__preprocessor_call] = STATE(2571),
    [sym__identifier_token] = ACTIONS(4962),
    [anon_sym_extern] = ACTIONS(4962),
    [anon_sym_alias] = ACTIONS(4962),
    [anon_sym_global] = ACTIONS(4962),
    [anon_sym_using] = ACTIONS(4962),
    [anon_sym_static] = ACTIONS(4962),
    [anon_sym_LBRACK] = ACTIONS(4964),
    [anon_sym_event] = ACTIONS(4962),
    [anon_sym_LPAREN] = ACTIONS(4964),
    [anon_sym_abstract] = ACTIONS(4962),
    [anon_sym_async] = ACTIONS(4962),
    [anon_sym_const] = ACTIONS(4962),
    [anon_sym_fixed] = ACTIONS(4962),
    [anon_sym_internal] = ACTIONS(4962),
    [anon_sym_new] = ACTIONS(4962),
    [anon_sym_override] = ACTIONS(4962),
    [anon_sym_partial] = ACTIONS(4962),
    [anon_sym_private] = ACTIONS(4962),
    [anon_sym_protected] = ACTIONS(4962),
    [anon_sym_public] = ACTIONS(4962),
    [anon_sym_readonly] = ACTIONS(4962),
    [anon_sym_ref] = ACTIONS(4962),
    [anon_sym_sealed] = ACTIONS(4962),
    [anon_sym_unsafe] = ACTIONS(4962),
    [anon_sym_virtual] = ACTIONS(4962),
    [anon_sym_volatile] = ACTIONS(4962),
    [anon_sym_RBRACE] = ACTIONS(4964),
    [anon_sym_implicit] = ACTIONS(4962),
    [anon_sym_explicit] = ACTIONS(4962),
    [anon_sym_TILDE] = ACTIONS(4964),
    [anon_sym_where] = ACTIONS(4962),
    [anon_sym_class] = ACTIONS(4962),
    [anon_sym_struct] = ACTIONS(4962),
    [anon_sym_notnull] = ACTIONS(4962),
    [anon_sym_unmanaged] = ACTIONS(4962),
    [anon_sym_get] = ACTIONS(4962),
    [anon_sym_set] = ACTIONS(4962),
    [anon_sym_add] = ACTIONS(4962),
    [anon_sym_remove] = ACTIONS(4962),
    [anon_sym_enum] = ACTIONS(4962),
    [anon_sym_interface] = ACTIONS(4962),
    [anon_sym_delegate] = ACTIONS(4962),
    [anon_sym_record] = ACTIONS(4962),
    [anon_sym_namespace] = ACTIONS(4962),
    [anon_sym_var] = ACTIONS(4962),
    [sym_predefined_type] = ACTIONS(4962),
    [anon_sym_when] = ACTIONS(4962),
    [anon_sym_yield] = ACTIONS(4962),
    [anon_sym_from] = ACTIONS(4962),
    [anon_sym_join] = ACTIONS(4962),
    [anon_sym_on] = ACTIONS(4962),
    [anon_sym_equals] = ACTIONS(4962),
    [anon_sym_into] = ACTIONS(4962),
    [anon_sym_let] = ACTIONS(4962),
    [anon_sym_orderby] = ACTIONS(4962),
    [anon_sym_ascending] = ACTIONS(4962),
    [anon_sym_descending] = ACTIONS(4962),
    [anon_sym_group] = ACTIONS(4962),
    [anon_sym_by] = ACTIONS(4962),
    [anon_sym_select] = ACTIONS(4962),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4962),
    [anon_sym_nameof] = ACTIONS(4962),
    [sym_void_keyword] = ACTIONS(4962),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2572] = {
    [sym__preprocessor_call] = STATE(2572),
    [sym__identifier_token] = ACTIONS(4966),
    [anon_sym_extern] = ACTIONS(4966),
    [anon_sym_alias] = ACTIONS(4966),
    [anon_sym_global] = ACTIONS(4966),
    [anon_sym_using] = ACTIONS(4966),
    [anon_sym_static] = ACTIONS(4966),
    [anon_sym_LBRACK] = ACTIONS(4968),
    [anon_sym_event] = ACTIONS(4966),
    [anon_sym_LPAREN] = ACTIONS(4968),
    [anon_sym_abstract] = ACTIONS(4966),
    [anon_sym_async] = ACTIONS(4966),
    [anon_sym_const] = ACTIONS(4966),
    [anon_sym_fixed] = ACTIONS(4966),
    [anon_sym_internal] = ACTIONS(4966),
    [anon_sym_new] = ACTIONS(4966),
    [anon_sym_override] = ACTIONS(4966),
    [anon_sym_partial] = ACTIONS(4966),
    [anon_sym_private] = ACTIONS(4966),
    [anon_sym_protected] = ACTIONS(4966),
    [anon_sym_public] = ACTIONS(4966),
    [anon_sym_readonly] = ACTIONS(4966),
    [anon_sym_ref] = ACTIONS(4966),
    [anon_sym_sealed] = ACTIONS(4966),
    [anon_sym_unsafe] = ACTIONS(4966),
    [anon_sym_virtual] = ACTIONS(4966),
    [anon_sym_volatile] = ACTIONS(4966),
    [anon_sym_RBRACE] = ACTIONS(4968),
    [anon_sym_implicit] = ACTIONS(4966),
    [anon_sym_explicit] = ACTIONS(4966),
    [anon_sym_TILDE] = ACTIONS(4968),
    [anon_sym_where] = ACTIONS(4966),
    [anon_sym_class] = ACTIONS(4966),
    [anon_sym_struct] = ACTIONS(4966),
    [anon_sym_notnull] = ACTIONS(4966),
    [anon_sym_unmanaged] = ACTIONS(4966),
    [anon_sym_get] = ACTIONS(4966),
    [anon_sym_set] = ACTIONS(4966),
    [anon_sym_add] = ACTIONS(4966),
    [anon_sym_remove] = ACTIONS(4966),
    [anon_sym_enum] = ACTIONS(4966),
    [anon_sym_interface] = ACTIONS(4966),
    [anon_sym_delegate] = ACTIONS(4966),
    [anon_sym_record] = ACTIONS(4966),
    [anon_sym_namespace] = ACTIONS(4966),
    [anon_sym_var] = ACTIONS(4966),
    [sym_predefined_type] = ACTIONS(4966),
    [anon_sym_when] = ACTIONS(4966),
    [anon_sym_yield] = ACTIONS(4966),
    [anon_sym_from] = ACTIONS(4966),
    [anon_sym_join] = ACTIONS(4966),
    [anon_sym_on] = ACTIONS(4966),
    [anon_sym_equals] = ACTIONS(4966),
    [anon_sym_into] = ACTIONS(4966),
    [anon_sym_let] = ACTIONS(4966),
    [anon_sym_orderby] = ACTIONS(4966),
    [anon_sym_ascending] = ACTIONS(4966),
    [anon_sym_descending] = ACTIONS(4966),
    [anon_sym_group] = ACTIONS(4966),
    [anon_sym_by] = ACTIONS(4966),
    [anon_sym_select] = ACTIONS(4966),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4966),
    [anon_sym_nameof] = ACTIONS(4966),
    [sym_void_keyword] = ACTIONS(4966),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2573] = {
    [sym__preprocessor_call] = STATE(2573),
    [sym__identifier_token] = ACTIONS(4970),
    [anon_sym_extern] = ACTIONS(4970),
    [anon_sym_alias] = ACTIONS(4970),
    [anon_sym_global] = ACTIONS(4970),
    [anon_sym_using] = ACTIONS(4970),
    [anon_sym_static] = ACTIONS(4970),
    [anon_sym_LBRACK] = ACTIONS(4972),
    [anon_sym_event] = ACTIONS(4970),
    [anon_sym_LPAREN] = ACTIONS(4972),
    [anon_sym_abstract] = ACTIONS(4970),
    [anon_sym_async] = ACTIONS(4970),
    [anon_sym_const] = ACTIONS(4970),
    [anon_sym_fixed] = ACTIONS(4970),
    [anon_sym_internal] = ACTIONS(4970),
    [anon_sym_new] = ACTIONS(4970),
    [anon_sym_override] = ACTIONS(4970),
    [anon_sym_partial] = ACTIONS(4970),
    [anon_sym_private] = ACTIONS(4970),
    [anon_sym_protected] = ACTIONS(4970),
    [anon_sym_public] = ACTIONS(4970),
    [anon_sym_readonly] = ACTIONS(4970),
    [anon_sym_ref] = ACTIONS(4970),
    [anon_sym_sealed] = ACTIONS(4970),
    [anon_sym_unsafe] = ACTIONS(4970),
    [anon_sym_virtual] = ACTIONS(4970),
    [anon_sym_volatile] = ACTIONS(4970),
    [anon_sym_RBRACE] = ACTIONS(4972),
    [anon_sym_implicit] = ACTIONS(4970),
    [anon_sym_explicit] = ACTIONS(4970),
    [anon_sym_TILDE] = ACTIONS(4972),
    [anon_sym_where] = ACTIONS(4970),
    [anon_sym_class] = ACTIONS(4970),
    [anon_sym_struct] = ACTIONS(4970),
    [anon_sym_notnull] = ACTIONS(4970),
    [anon_sym_unmanaged] = ACTIONS(4970),
    [anon_sym_get] = ACTIONS(4970),
    [anon_sym_set] = ACTIONS(4970),
    [anon_sym_add] = ACTIONS(4970),
    [anon_sym_remove] = ACTIONS(4970),
    [anon_sym_enum] = ACTIONS(4970),
    [anon_sym_interface] = ACTIONS(4970),
    [anon_sym_delegate] = ACTIONS(4970),
    [anon_sym_record] = ACTIONS(4970),
    [anon_sym_namespace] = ACTIONS(4970),
    [anon_sym_var] = ACTIONS(4970),
    [sym_predefined_type] = ACTIONS(4970),
    [anon_sym_when] = ACTIONS(4970),
    [anon_sym_yield] = ACTIONS(4970),
    [anon_sym_from] = ACTIONS(4970),
    [anon_sym_join] = ACTIONS(4970),
    [anon_sym_on] = ACTIONS(4970),
    [anon_sym_equals] = ACTIONS(4970),
    [anon_sym_into] = ACTIONS(4970),
    [anon_sym_let] = ACTIONS(4970),
    [anon_sym_orderby] = ACTIONS(4970),
    [anon_sym_ascending] = ACTIONS(4970),
    [anon_sym_descending] = ACTIONS(4970),
    [anon_sym_group] = ACTIONS(4970),
    [anon_sym_by] = ACTIONS(4970),
    [anon_sym_select] = ACTIONS(4970),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4970),
    [anon_sym_nameof] = ACTIONS(4970),
    [sym_void_keyword] = ACTIONS(4970),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2574] = {
    [sym__preprocessor_call] = STATE(2574),
    [sym__identifier_token] = ACTIONS(4974),
    [anon_sym_extern] = ACTIONS(4974),
    [anon_sym_alias] = ACTIONS(4974),
    [anon_sym_global] = ACTIONS(4974),
    [anon_sym_using] = ACTIONS(4974),
    [anon_sym_static] = ACTIONS(4974),
    [anon_sym_LBRACK] = ACTIONS(4976),
    [anon_sym_event] = ACTIONS(4974),
    [anon_sym_LPAREN] = ACTIONS(4976),
    [anon_sym_abstract] = ACTIONS(4974),
    [anon_sym_async] = ACTIONS(4974),
    [anon_sym_const] = ACTIONS(4974),
    [anon_sym_fixed] = ACTIONS(4974),
    [anon_sym_internal] = ACTIONS(4974),
    [anon_sym_new] = ACTIONS(4974),
    [anon_sym_override] = ACTIONS(4974),
    [anon_sym_partial] = ACTIONS(4974),
    [anon_sym_private] = ACTIONS(4974),
    [anon_sym_protected] = ACTIONS(4974),
    [anon_sym_public] = ACTIONS(4974),
    [anon_sym_readonly] = ACTIONS(4974),
    [anon_sym_ref] = ACTIONS(4974),
    [anon_sym_sealed] = ACTIONS(4974),
    [anon_sym_unsafe] = ACTIONS(4974),
    [anon_sym_virtual] = ACTIONS(4974),
    [anon_sym_volatile] = ACTIONS(4974),
    [anon_sym_RBRACE] = ACTIONS(4976),
    [anon_sym_implicit] = ACTIONS(4974),
    [anon_sym_explicit] = ACTIONS(4974),
    [anon_sym_TILDE] = ACTIONS(4976),
    [anon_sym_where] = ACTIONS(4974),
    [anon_sym_class] = ACTIONS(4974),
    [anon_sym_struct] = ACTIONS(4974),
    [anon_sym_notnull] = ACTIONS(4974),
    [anon_sym_unmanaged] = ACTIONS(4974),
    [anon_sym_get] = ACTIONS(4974),
    [anon_sym_set] = ACTIONS(4974),
    [anon_sym_add] = ACTIONS(4974),
    [anon_sym_remove] = ACTIONS(4974),
    [anon_sym_enum] = ACTIONS(4974),
    [anon_sym_interface] = ACTIONS(4974),
    [anon_sym_delegate] = ACTIONS(4974),
    [anon_sym_record] = ACTIONS(4974),
    [anon_sym_namespace] = ACTIONS(4974),
    [anon_sym_var] = ACTIONS(4974),
    [sym_predefined_type] = ACTIONS(4974),
    [anon_sym_when] = ACTIONS(4974),
    [anon_sym_yield] = ACTIONS(4974),
    [anon_sym_from] = ACTIONS(4974),
    [anon_sym_join] = ACTIONS(4974),
    [anon_sym_on] = ACTIONS(4974),
    [anon_sym_equals] = ACTIONS(4974),
    [anon_sym_into] = ACTIONS(4974),
    [anon_sym_let] = ACTIONS(4974),
    [anon_sym_orderby] = ACTIONS(4974),
    [anon_sym_ascending] = ACTIONS(4974),
    [anon_sym_descending] = ACTIONS(4974),
    [anon_sym_group] = ACTIONS(4974),
    [anon_sym_by] = ACTIONS(4974),
    [anon_sym_select] = ACTIONS(4974),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4974),
    [anon_sym_nameof] = ACTIONS(4974),
    [sym_void_keyword] = ACTIONS(4974),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2575] = {
    [sym__preprocessor_call] = STATE(2575),
    [sym__identifier_token] = ACTIONS(4978),
    [anon_sym_extern] = ACTIONS(4978),
    [anon_sym_alias] = ACTIONS(4978),
    [anon_sym_global] = ACTIONS(4978),
    [anon_sym_using] = ACTIONS(4978),
    [anon_sym_static] = ACTIONS(4978),
    [anon_sym_LBRACK] = ACTIONS(4980),
    [anon_sym_event] = ACTIONS(4978),
    [anon_sym_LPAREN] = ACTIONS(4980),
    [anon_sym_abstract] = ACTIONS(4978),
    [anon_sym_async] = ACTIONS(4978),
    [anon_sym_const] = ACTIONS(4978),
    [anon_sym_fixed] = ACTIONS(4978),
    [anon_sym_internal] = ACTIONS(4978),
    [anon_sym_new] = ACTIONS(4978),
    [anon_sym_override] = ACTIONS(4978),
    [anon_sym_partial] = ACTIONS(4978),
    [anon_sym_private] = ACTIONS(4978),
    [anon_sym_protected] = ACTIONS(4978),
    [anon_sym_public] = ACTIONS(4978),
    [anon_sym_readonly] = ACTIONS(4978),
    [anon_sym_ref] = ACTIONS(4978),
    [anon_sym_sealed] = ACTIONS(4978),
    [anon_sym_unsafe] = ACTIONS(4978),
    [anon_sym_virtual] = ACTIONS(4978),
    [anon_sym_volatile] = ACTIONS(4978),
    [anon_sym_RBRACE] = ACTIONS(4980),
    [anon_sym_implicit] = ACTIONS(4978),
    [anon_sym_explicit] = ACTIONS(4978),
    [anon_sym_TILDE] = ACTIONS(4980),
    [anon_sym_where] = ACTIONS(4978),
    [anon_sym_class] = ACTIONS(4978),
    [anon_sym_struct] = ACTIONS(4978),
    [anon_sym_notnull] = ACTIONS(4978),
    [anon_sym_unmanaged] = ACTIONS(4978),
    [anon_sym_get] = ACTIONS(4978),
    [anon_sym_set] = ACTIONS(4978),
    [anon_sym_add] = ACTIONS(4978),
    [anon_sym_remove] = ACTIONS(4978),
    [anon_sym_enum] = ACTIONS(4978),
    [anon_sym_interface] = ACTIONS(4978),
    [anon_sym_delegate] = ACTIONS(4978),
    [anon_sym_record] = ACTIONS(4978),
    [anon_sym_namespace] = ACTIONS(4978),
    [anon_sym_var] = ACTIONS(4978),
    [sym_predefined_type] = ACTIONS(4978),
    [anon_sym_when] = ACTIONS(4978),
    [anon_sym_yield] = ACTIONS(4978),
    [anon_sym_from] = ACTIONS(4978),
    [anon_sym_join] = ACTIONS(4978),
    [anon_sym_on] = ACTIONS(4978),
    [anon_sym_equals] = ACTIONS(4978),
    [anon_sym_into] = ACTIONS(4978),
    [anon_sym_let] = ACTIONS(4978),
    [anon_sym_orderby] = ACTIONS(4978),
    [anon_sym_ascending] = ACTIONS(4978),
    [anon_sym_descending] = ACTIONS(4978),
    [anon_sym_group] = ACTIONS(4978),
    [anon_sym_by] = ACTIONS(4978),
    [anon_sym_select] = ACTIONS(4978),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4978),
    [anon_sym_nameof] = ACTIONS(4978),
    [sym_void_keyword] = ACTIONS(4978),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2576] = {
    [sym__preprocessor_call] = STATE(2576),
    [sym__identifier_token] = ACTIONS(4982),
    [anon_sym_extern] = ACTIONS(4982),
    [anon_sym_alias] = ACTIONS(4982),
    [anon_sym_global] = ACTIONS(4982),
    [anon_sym_using] = ACTIONS(4982),
    [anon_sym_static] = ACTIONS(4982),
    [anon_sym_LBRACK] = ACTIONS(4984),
    [anon_sym_event] = ACTIONS(4982),
    [anon_sym_LPAREN] = ACTIONS(4984),
    [anon_sym_abstract] = ACTIONS(4982),
    [anon_sym_async] = ACTIONS(4982),
    [anon_sym_const] = ACTIONS(4982),
    [anon_sym_fixed] = ACTIONS(4982),
    [anon_sym_internal] = ACTIONS(4982),
    [anon_sym_new] = ACTIONS(4982),
    [anon_sym_override] = ACTIONS(4982),
    [anon_sym_partial] = ACTIONS(4982),
    [anon_sym_private] = ACTIONS(4982),
    [anon_sym_protected] = ACTIONS(4982),
    [anon_sym_public] = ACTIONS(4982),
    [anon_sym_readonly] = ACTIONS(4982),
    [anon_sym_ref] = ACTIONS(4982),
    [anon_sym_sealed] = ACTIONS(4982),
    [anon_sym_unsafe] = ACTIONS(4982),
    [anon_sym_virtual] = ACTIONS(4982),
    [anon_sym_volatile] = ACTIONS(4982),
    [anon_sym_RBRACE] = ACTIONS(4984),
    [anon_sym_implicit] = ACTIONS(4982),
    [anon_sym_explicit] = ACTIONS(4982),
    [anon_sym_TILDE] = ACTIONS(4984),
    [anon_sym_where] = ACTIONS(4982),
    [anon_sym_class] = ACTIONS(4982),
    [anon_sym_struct] = ACTIONS(4982),
    [anon_sym_notnull] = ACTIONS(4982),
    [anon_sym_unmanaged] = ACTIONS(4982),
    [anon_sym_get] = ACTIONS(4982),
    [anon_sym_set] = ACTIONS(4982),
    [anon_sym_add] = ACTIONS(4982),
    [anon_sym_remove] = ACTIONS(4982),
    [anon_sym_enum] = ACTIONS(4982),
    [anon_sym_interface] = ACTIONS(4982),
    [anon_sym_delegate] = ACTIONS(4982),
    [anon_sym_record] = ACTIONS(4982),
    [anon_sym_namespace] = ACTIONS(4982),
    [anon_sym_var] = ACTIONS(4982),
    [sym_predefined_type] = ACTIONS(4982),
    [anon_sym_when] = ACTIONS(4982),
    [anon_sym_yield] = ACTIONS(4982),
    [anon_sym_from] = ACTIONS(4982),
    [anon_sym_join] = ACTIONS(4982),
    [anon_sym_on] = ACTIONS(4982),
    [anon_sym_equals] = ACTIONS(4982),
    [anon_sym_into] = ACTIONS(4982),
    [anon_sym_let] = ACTIONS(4982),
    [anon_sym_orderby] = ACTIONS(4982),
    [anon_sym_ascending] = ACTIONS(4982),
    [anon_sym_descending] = ACTIONS(4982),
    [anon_sym_group] = ACTIONS(4982),
    [anon_sym_by] = ACTIONS(4982),
    [anon_sym_select] = ACTIONS(4982),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4982),
    [anon_sym_nameof] = ACTIONS(4982),
    [sym_void_keyword] = ACTIONS(4982),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2577] = {
    [sym__preprocessor_call] = STATE(2577),
    [sym__identifier_token] = ACTIONS(4986),
    [anon_sym_extern] = ACTIONS(4986),
    [anon_sym_alias] = ACTIONS(4986),
    [anon_sym_global] = ACTIONS(4986),
    [anon_sym_using] = ACTIONS(4986),
    [anon_sym_static] = ACTIONS(4986),
    [anon_sym_LBRACK] = ACTIONS(4988),
    [anon_sym_event] = ACTIONS(4986),
    [anon_sym_LPAREN] = ACTIONS(4988),
    [anon_sym_abstract] = ACTIONS(4986),
    [anon_sym_async] = ACTIONS(4986),
    [anon_sym_const] = ACTIONS(4986),
    [anon_sym_fixed] = ACTIONS(4986),
    [anon_sym_internal] = ACTIONS(4986),
    [anon_sym_new] = ACTIONS(4986),
    [anon_sym_override] = ACTIONS(4986),
    [anon_sym_partial] = ACTIONS(4986),
    [anon_sym_private] = ACTIONS(4986),
    [anon_sym_protected] = ACTIONS(4986),
    [anon_sym_public] = ACTIONS(4986),
    [anon_sym_readonly] = ACTIONS(4986),
    [anon_sym_ref] = ACTIONS(4986),
    [anon_sym_sealed] = ACTIONS(4986),
    [anon_sym_unsafe] = ACTIONS(4986),
    [anon_sym_virtual] = ACTIONS(4986),
    [anon_sym_volatile] = ACTIONS(4986),
    [anon_sym_RBRACE] = ACTIONS(4988),
    [anon_sym_implicit] = ACTIONS(4986),
    [anon_sym_explicit] = ACTIONS(4986),
    [anon_sym_TILDE] = ACTIONS(4988),
    [anon_sym_where] = ACTIONS(4986),
    [anon_sym_class] = ACTIONS(4986),
    [anon_sym_struct] = ACTIONS(4986),
    [anon_sym_notnull] = ACTIONS(4986),
    [anon_sym_unmanaged] = ACTIONS(4986),
    [anon_sym_get] = ACTIONS(4986),
    [anon_sym_set] = ACTIONS(4986),
    [anon_sym_add] = ACTIONS(4986),
    [anon_sym_remove] = ACTIONS(4986),
    [anon_sym_enum] = ACTIONS(4986),
    [anon_sym_interface] = ACTIONS(4986),
    [anon_sym_delegate] = ACTIONS(4986),
    [anon_sym_record] = ACTIONS(4986),
    [anon_sym_namespace] = ACTIONS(4986),
    [anon_sym_var] = ACTIONS(4986),
    [sym_predefined_type] = ACTIONS(4986),
    [anon_sym_when] = ACTIONS(4986),
    [anon_sym_yield] = ACTIONS(4986),
    [anon_sym_from] = ACTIONS(4986),
    [anon_sym_join] = ACTIONS(4986),
    [anon_sym_on] = ACTIONS(4986),
    [anon_sym_equals] = ACTIONS(4986),
    [anon_sym_into] = ACTIONS(4986),
    [anon_sym_let] = ACTIONS(4986),
    [anon_sym_orderby] = ACTIONS(4986),
    [anon_sym_ascending] = ACTIONS(4986),
    [anon_sym_descending] = ACTIONS(4986),
    [anon_sym_group] = ACTIONS(4986),
    [anon_sym_by] = ACTIONS(4986),
    [anon_sym_select] = ACTIONS(4986),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4986),
    [anon_sym_nameof] = ACTIONS(4986),
    [sym_void_keyword] = ACTIONS(4986),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2578] = {
    [sym__preprocessor_call] = STATE(2578),
    [sym__identifier_token] = ACTIONS(4990),
    [anon_sym_extern] = ACTIONS(4990),
    [anon_sym_alias] = ACTIONS(4990),
    [anon_sym_global] = ACTIONS(4990),
    [anon_sym_using] = ACTIONS(4990),
    [anon_sym_static] = ACTIONS(4990),
    [anon_sym_LBRACK] = ACTIONS(4992),
    [anon_sym_event] = ACTIONS(4990),
    [anon_sym_LPAREN] = ACTIONS(4992),
    [anon_sym_abstract] = ACTIONS(4990),
    [anon_sym_async] = ACTIONS(4990),
    [anon_sym_const] = ACTIONS(4990),
    [anon_sym_fixed] = ACTIONS(4990),
    [anon_sym_internal] = ACTIONS(4990),
    [anon_sym_new] = ACTIONS(4990),
    [anon_sym_override] = ACTIONS(4990),
    [anon_sym_partial] = ACTIONS(4990),
    [anon_sym_private] = ACTIONS(4990),
    [anon_sym_protected] = ACTIONS(4990),
    [anon_sym_public] = ACTIONS(4990),
    [anon_sym_readonly] = ACTIONS(4990),
    [anon_sym_ref] = ACTIONS(4990),
    [anon_sym_sealed] = ACTIONS(4990),
    [anon_sym_unsafe] = ACTIONS(4990),
    [anon_sym_virtual] = ACTIONS(4990),
    [anon_sym_volatile] = ACTIONS(4990),
    [anon_sym_RBRACE] = ACTIONS(4992),
    [anon_sym_implicit] = ACTIONS(4990),
    [anon_sym_explicit] = ACTIONS(4990),
    [anon_sym_TILDE] = ACTIONS(4992),
    [anon_sym_where] = ACTIONS(4990),
    [anon_sym_class] = ACTIONS(4990),
    [anon_sym_struct] = ACTIONS(4990),
    [anon_sym_notnull] = ACTIONS(4990),
    [anon_sym_unmanaged] = ACTIONS(4990),
    [anon_sym_get] = ACTIONS(4990),
    [anon_sym_set] = ACTIONS(4990),
    [anon_sym_add] = ACTIONS(4990),
    [anon_sym_remove] = ACTIONS(4990),
    [anon_sym_enum] = ACTIONS(4990),
    [anon_sym_interface] = ACTIONS(4990),
    [anon_sym_delegate] = ACTIONS(4990),
    [anon_sym_record] = ACTIONS(4990),
    [anon_sym_namespace] = ACTIONS(4990),
    [anon_sym_var] = ACTIONS(4990),
    [sym_predefined_type] = ACTIONS(4990),
    [anon_sym_when] = ACTIONS(4990),
    [anon_sym_yield] = ACTIONS(4990),
    [anon_sym_from] = ACTIONS(4990),
    [anon_sym_join] = ACTIONS(4990),
    [anon_sym_on] = ACTIONS(4990),
    [anon_sym_equals] = ACTIONS(4990),
    [anon_sym_into] = ACTIONS(4990),
    [anon_sym_let] = ACTIONS(4990),
    [anon_sym_orderby] = ACTIONS(4990),
    [anon_sym_ascending] = ACTIONS(4990),
    [anon_sym_descending] = ACTIONS(4990),
    [anon_sym_group] = ACTIONS(4990),
    [anon_sym_by] = ACTIONS(4990),
    [anon_sym_select] = ACTIONS(4990),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4990),
    [anon_sym_nameof] = ACTIONS(4990),
    [sym_void_keyword] = ACTIONS(4990),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2579] = {
    [sym__preprocessor_call] = STATE(2579),
    [sym__identifier_token] = ACTIONS(4994),
    [anon_sym_extern] = ACTIONS(4994),
    [anon_sym_alias] = ACTIONS(4994),
    [anon_sym_global] = ACTIONS(4994),
    [anon_sym_using] = ACTIONS(4994),
    [anon_sym_static] = ACTIONS(4994),
    [anon_sym_LBRACK] = ACTIONS(4996),
    [anon_sym_event] = ACTIONS(4994),
    [anon_sym_LPAREN] = ACTIONS(4996),
    [anon_sym_abstract] = ACTIONS(4994),
    [anon_sym_async] = ACTIONS(4994),
    [anon_sym_const] = ACTIONS(4994),
    [anon_sym_fixed] = ACTIONS(4994),
    [anon_sym_internal] = ACTIONS(4994),
    [anon_sym_new] = ACTIONS(4994),
    [anon_sym_override] = ACTIONS(4994),
    [anon_sym_partial] = ACTIONS(4994),
    [anon_sym_private] = ACTIONS(4994),
    [anon_sym_protected] = ACTIONS(4994),
    [anon_sym_public] = ACTIONS(4994),
    [anon_sym_readonly] = ACTIONS(4994),
    [anon_sym_ref] = ACTIONS(4994),
    [anon_sym_sealed] = ACTIONS(4994),
    [anon_sym_unsafe] = ACTIONS(4994),
    [anon_sym_virtual] = ACTIONS(4994),
    [anon_sym_volatile] = ACTIONS(4994),
    [anon_sym_RBRACE] = ACTIONS(4996),
    [anon_sym_implicit] = ACTIONS(4994),
    [anon_sym_explicit] = ACTIONS(4994),
    [anon_sym_TILDE] = ACTIONS(4996),
    [anon_sym_where] = ACTIONS(4994),
    [anon_sym_class] = ACTIONS(4994),
    [anon_sym_struct] = ACTIONS(4994),
    [anon_sym_notnull] = ACTIONS(4994),
    [anon_sym_unmanaged] = ACTIONS(4994),
    [anon_sym_get] = ACTIONS(4994),
    [anon_sym_set] = ACTIONS(4994),
    [anon_sym_add] = ACTIONS(4994),
    [anon_sym_remove] = ACTIONS(4994),
    [anon_sym_enum] = ACTIONS(4994),
    [anon_sym_interface] = ACTIONS(4994),
    [anon_sym_delegate] = ACTIONS(4994),
    [anon_sym_record] = ACTIONS(4994),
    [anon_sym_namespace] = ACTIONS(4994),
    [anon_sym_var] = ACTIONS(4994),
    [sym_predefined_type] = ACTIONS(4994),
    [anon_sym_when] = ACTIONS(4994),
    [anon_sym_yield] = ACTIONS(4994),
    [anon_sym_from] = ACTIONS(4994),
    [anon_sym_join] = ACTIONS(4994),
    [anon_sym_on] = ACTIONS(4994),
    [anon_sym_equals] = ACTIONS(4994),
    [anon_sym_into] = ACTIONS(4994),
    [anon_sym_let] = ACTIONS(4994),
    [anon_sym_orderby] = ACTIONS(4994),
    [anon_sym_ascending] = ACTIONS(4994),
    [anon_sym_descending] = ACTIONS(4994),
    [anon_sym_group] = ACTIONS(4994),
    [anon_sym_by] = ACTIONS(4994),
    [anon_sym_select] = ACTIONS(4994),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4994),
    [anon_sym_nameof] = ACTIONS(4994),
    [sym_void_keyword] = ACTIONS(4994),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2580] = {
    [sym__preprocessor_call] = STATE(2580),
    [sym__identifier_token] = ACTIONS(4998),
    [anon_sym_extern] = ACTIONS(4998),
    [anon_sym_alias] = ACTIONS(4998),
    [anon_sym_global] = ACTIONS(4998),
    [anon_sym_using] = ACTIONS(4998),
    [anon_sym_static] = ACTIONS(4998),
    [anon_sym_LBRACK] = ACTIONS(5000),
    [anon_sym_event] = ACTIONS(4998),
    [anon_sym_LPAREN] = ACTIONS(5000),
    [anon_sym_abstract] = ACTIONS(4998),
    [anon_sym_async] = ACTIONS(4998),
    [anon_sym_const] = ACTIONS(4998),
    [anon_sym_fixed] = ACTIONS(4998),
    [anon_sym_internal] = ACTIONS(4998),
    [anon_sym_new] = ACTIONS(4998),
    [anon_sym_override] = ACTIONS(4998),
    [anon_sym_partial] = ACTIONS(4998),
    [anon_sym_private] = ACTIONS(4998),
    [anon_sym_protected] = ACTIONS(4998),
    [anon_sym_public] = ACTIONS(4998),
    [anon_sym_readonly] = ACTIONS(4998),
    [anon_sym_ref] = ACTIONS(4998),
    [anon_sym_sealed] = ACTIONS(4998),
    [anon_sym_unsafe] = ACTIONS(4998),
    [anon_sym_virtual] = ACTIONS(4998),
    [anon_sym_volatile] = ACTIONS(4998),
    [anon_sym_RBRACE] = ACTIONS(5000),
    [anon_sym_implicit] = ACTIONS(4998),
    [anon_sym_explicit] = ACTIONS(4998),
    [anon_sym_TILDE] = ACTIONS(5000),
    [anon_sym_where] = ACTIONS(4998),
    [anon_sym_class] = ACTIONS(4998),
    [anon_sym_struct] = ACTIONS(4998),
    [anon_sym_notnull] = ACTIONS(4998),
    [anon_sym_unmanaged] = ACTIONS(4998),
    [anon_sym_get] = ACTIONS(4998),
    [anon_sym_set] = ACTIONS(4998),
    [anon_sym_add] = ACTIONS(4998),
    [anon_sym_remove] = ACTIONS(4998),
    [anon_sym_enum] = ACTIONS(4998),
    [anon_sym_interface] = ACTIONS(4998),
    [anon_sym_delegate] = ACTIONS(4998),
    [anon_sym_record] = ACTIONS(4998),
    [anon_sym_namespace] = ACTIONS(4998),
    [anon_sym_var] = ACTIONS(4998),
    [sym_predefined_type] = ACTIONS(4998),
    [anon_sym_when] = ACTIONS(4998),
    [anon_sym_yield] = ACTIONS(4998),
    [anon_sym_from] = ACTIONS(4998),
    [anon_sym_join] = ACTIONS(4998),
    [anon_sym_on] = ACTIONS(4998),
    [anon_sym_equals] = ACTIONS(4998),
    [anon_sym_into] = ACTIONS(4998),
    [anon_sym_let] = ACTIONS(4998),
    [anon_sym_orderby] = ACTIONS(4998),
    [anon_sym_ascending] = ACTIONS(4998),
    [anon_sym_descending] = ACTIONS(4998),
    [anon_sym_group] = ACTIONS(4998),
    [anon_sym_by] = ACTIONS(4998),
    [anon_sym_select] = ACTIONS(4998),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(4998),
    [anon_sym_nameof] = ACTIONS(4998),
    [sym_void_keyword] = ACTIONS(4998),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2581] = {
    [sym__preprocessor_call] = STATE(2581),
    [sym__identifier_token] = ACTIONS(5002),
    [anon_sym_extern] = ACTIONS(5002),
    [anon_sym_alias] = ACTIONS(5002),
    [anon_sym_global] = ACTIONS(5002),
    [anon_sym_using] = ACTIONS(5002),
    [anon_sym_static] = ACTIONS(5002),
    [anon_sym_LBRACK] = ACTIONS(5004),
    [anon_sym_event] = ACTIONS(5002),
    [anon_sym_LPAREN] = ACTIONS(5004),
    [anon_sym_abstract] = ACTIONS(5002),
    [anon_sym_async] = ACTIONS(5002),
    [anon_sym_const] = ACTIONS(5002),
    [anon_sym_fixed] = ACTIONS(5002),
    [anon_sym_internal] = ACTIONS(5002),
    [anon_sym_new] = ACTIONS(5002),
    [anon_sym_override] = ACTIONS(5002),
    [anon_sym_partial] = ACTIONS(5002),
    [anon_sym_private] = ACTIONS(5002),
    [anon_sym_protected] = ACTIONS(5002),
    [anon_sym_public] = ACTIONS(5002),
    [anon_sym_readonly] = ACTIONS(5002),
    [anon_sym_ref] = ACTIONS(5002),
    [anon_sym_sealed] = ACTIONS(5002),
    [anon_sym_unsafe] = ACTIONS(5002),
    [anon_sym_virtual] = ACTIONS(5002),
    [anon_sym_volatile] = ACTIONS(5002),
    [anon_sym_RBRACE] = ACTIONS(5004),
    [anon_sym_implicit] = ACTIONS(5002),
    [anon_sym_explicit] = ACTIONS(5002),
    [anon_sym_TILDE] = ACTIONS(5004),
    [anon_sym_where] = ACTIONS(5002),
    [anon_sym_class] = ACTIONS(5002),
    [anon_sym_struct] = ACTIONS(5002),
    [anon_sym_notnull] = ACTIONS(5002),
    [anon_sym_unmanaged] = ACTIONS(5002),
    [anon_sym_get] = ACTIONS(5002),
    [anon_sym_set] = ACTIONS(5002),
    [anon_sym_add] = ACTIONS(5002),
    [anon_sym_remove] = ACTIONS(5002),
    [anon_sym_enum] = ACTIONS(5002),
    [anon_sym_interface] = ACTIONS(5002),
    [anon_sym_delegate] = ACTIONS(5002),
    [anon_sym_record] = ACTIONS(5002),
    [anon_sym_namespace] = ACTIONS(5002),
    [anon_sym_var] = ACTIONS(5002),
    [sym_predefined_type] = ACTIONS(5002),
    [anon_sym_when] = ACTIONS(5002),
    [anon_sym_yield] = ACTIONS(5002),
    [anon_sym_from] = ACTIONS(5002),
    [anon_sym_join] = ACTIONS(5002),
    [anon_sym_on] = ACTIONS(5002),
    [anon_sym_equals] = ACTIONS(5002),
    [anon_sym_into] = ACTIONS(5002),
    [anon_sym_let] = ACTIONS(5002),
    [anon_sym_orderby] = ACTIONS(5002),
    [anon_sym_ascending] = ACTIONS(5002),
    [anon_sym_descending] = ACTIONS(5002),
    [anon_sym_group] = ACTIONS(5002),
    [anon_sym_by] = ACTIONS(5002),
    [anon_sym_select] = ACTIONS(5002),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5002),
    [anon_sym_nameof] = ACTIONS(5002),
    [sym_void_keyword] = ACTIONS(5002),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2582] = {
    [sym__preprocessor_call] = STATE(2582),
    [sym__identifier_token] = ACTIONS(5006),
    [anon_sym_extern] = ACTIONS(5006),
    [anon_sym_alias] = ACTIONS(5006),
    [anon_sym_global] = ACTIONS(5006),
    [anon_sym_using] = ACTIONS(5006),
    [anon_sym_static] = ACTIONS(5006),
    [anon_sym_LBRACK] = ACTIONS(5008),
    [anon_sym_event] = ACTIONS(5006),
    [anon_sym_LPAREN] = ACTIONS(5008),
    [anon_sym_abstract] = ACTIONS(5006),
    [anon_sym_async] = ACTIONS(5006),
    [anon_sym_const] = ACTIONS(5006),
    [anon_sym_fixed] = ACTIONS(5006),
    [anon_sym_internal] = ACTIONS(5006),
    [anon_sym_new] = ACTIONS(5006),
    [anon_sym_override] = ACTIONS(5006),
    [anon_sym_partial] = ACTIONS(5006),
    [anon_sym_private] = ACTIONS(5006),
    [anon_sym_protected] = ACTIONS(5006),
    [anon_sym_public] = ACTIONS(5006),
    [anon_sym_readonly] = ACTIONS(5006),
    [anon_sym_ref] = ACTIONS(5006),
    [anon_sym_sealed] = ACTIONS(5006),
    [anon_sym_unsafe] = ACTIONS(5006),
    [anon_sym_virtual] = ACTIONS(5006),
    [anon_sym_volatile] = ACTIONS(5006),
    [anon_sym_RBRACE] = ACTIONS(5008),
    [anon_sym_implicit] = ACTIONS(5006),
    [anon_sym_explicit] = ACTIONS(5006),
    [anon_sym_TILDE] = ACTIONS(5008),
    [anon_sym_where] = ACTIONS(5006),
    [anon_sym_class] = ACTIONS(5006),
    [anon_sym_struct] = ACTIONS(5006),
    [anon_sym_notnull] = ACTIONS(5006),
    [anon_sym_unmanaged] = ACTIONS(5006),
    [anon_sym_get] = ACTIONS(5006),
    [anon_sym_set] = ACTIONS(5006),
    [anon_sym_add] = ACTIONS(5006),
    [anon_sym_remove] = ACTIONS(5006),
    [anon_sym_enum] = ACTIONS(5006),
    [anon_sym_interface] = ACTIONS(5006),
    [anon_sym_delegate] = ACTIONS(5006),
    [anon_sym_record] = ACTIONS(5006),
    [anon_sym_namespace] = ACTIONS(5006),
    [anon_sym_var] = ACTIONS(5006),
    [sym_predefined_type] = ACTIONS(5006),
    [anon_sym_when] = ACTIONS(5006),
    [anon_sym_yield] = ACTIONS(5006),
    [anon_sym_from] = ACTIONS(5006),
    [anon_sym_join] = ACTIONS(5006),
    [anon_sym_on] = ACTIONS(5006),
    [anon_sym_equals] = ACTIONS(5006),
    [anon_sym_into] = ACTIONS(5006),
    [anon_sym_let] = ACTIONS(5006),
    [anon_sym_orderby] = ACTIONS(5006),
    [anon_sym_ascending] = ACTIONS(5006),
    [anon_sym_descending] = ACTIONS(5006),
    [anon_sym_group] = ACTIONS(5006),
    [anon_sym_by] = ACTIONS(5006),
    [anon_sym_select] = ACTIONS(5006),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5006),
    [anon_sym_nameof] = ACTIONS(5006),
    [sym_void_keyword] = ACTIONS(5006),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2583] = {
    [sym__preprocessor_call] = STATE(2583),
    [sym__identifier_token] = ACTIONS(5010),
    [anon_sym_extern] = ACTIONS(5010),
    [anon_sym_alias] = ACTIONS(5010),
    [anon_sym_global] = ACTIONS(5010),
    [anon_sym_using] = ACTIONS(5010),
    [anon_sym_static] = ACTIONS(5010),
    [anon_sym_LBRACK] = ACTIONS(5012),
    [anon_sym_event] = ACTIONS(5010),
    [anon_sym_LPAREN] = ACTIONS(5012),
    [anon_sym_abstract] = ACTIONS(5010),
    [anon_sym_async] = ACTIONS(5010),
    [anon_sym_const] = ACTIONS(5010),
    [anon_sym_fixed] = ACTIONS(5010),
    [anon_sym_internal] = ACTIONS(5010),
    [anon_sym_new] = ACTIONS(5010),
    [anon_sym_override] = ACTIONS(5010),
    [anon_sym_partial] = ACTIONS(5010),
    [anon_sym_private] = ACTIONS(5010),
    [anon_sym_protected] = ACTIONS(5010),
    [anon_sym_public] = ACTIONS(5010),
    [anon_sym_readonly] = ACTIONS(5010),
    [anon_sym_ref] = ACTIONS(5010),
    [anon_sym_sealed] = ACTIONS(5010),
    [anon_sym_unsafe] = ACTIONS(5010),
    [anon_sym_virtual] = ACTIONS(5010),
    [anon_sym_volatile] = ACTIONS(5010),
    [anon_sym_RBRACE] = ACTIONS(5012),
    [anon_sym_implicit] = ACTIONS(5010),
    [anon_sym_explicit] = ACTIONS(5010),
    [anon_sym_TILDE] = ACTIONS(5012),
    [anon_sym_where] = ACTIONS(5010),
    [anon_sym_class] = ACTIONS(5010),
    [anon_sym_struct] = ACTIONS(5010),
    [anon_sym_notnull] = ACTIONS(5010),
    [anon_sym_unmanaged] = ACTIONS(5010),
    [anon_sym_get] = ACTIONS(5010),
    [anon_sym_set] = ACTIONS(5010),
    [anon_sym_add] = ACTIONS(5010),
    [anon_sym_remove] = ACTIONS(5010),
    [anon_sym_enum] = ACTIONS(5010),
    [anon_sym_interface] = ACTIONS(5010),
    [anon_sym_delegate] = ACTIONS(5010),
    [anon_sym_record] = ACTIONS(5010),
    [anon_sym_namespace] = ACTIONS(5010),
    [anon_sym_var] = ACTIONS(5010),
    [sym_predefined_type] = ACTIONS(5010),
    [anon_sym_when] = ACTIONS(5010),
    [anon_sym_yield] = ACTIONS(5010),
    [anon_sym_from] = ACTIONS(5010),
    [anon_sym_join] = ACTIONS(5010),
    [anon_sym_on] = ACTIONS(5010),
    [anon_sym_equals] = ACTIONS(5010),
    [anon_sym_into] = ACTIONS(5010),
    [anon_sym_let] = ACTIONS(5010),
    [anon_sym_orderby] = ACTIONS(5010),
    [anon_sym_ascending] = ACTIONS(5010),
    [anon_sym_descending] = ACTIONS(5010),
    [anon_sym_group] = ACTIONS(5010),
    [anon_sym_by] = ACTIONS(5010),
    [anon_sym_select] = ACTIONS(5010),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5010),
    [anon_sym_nameof] = ACTIONS(5010),
    [sym_void_keyword] = ACTIONS(5010),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2584] = {
    [sym__preprocessor_call] = STATE(2584),
    [sym__identifier_token] = ACTIONS(5014),
    [anon_sym_extern] = ACTIONS(5014),
    [anon_sym_alias] = ACTIONS(5014),
    [anon_sym_global] = ACTIONS(5014),
    [anon_sym_using] = ACTIONS(5014),
    [anon_sym_static] = ACTIONS(5014),
    [anon_sym_LBRACK] = ACTIONS(5016),
    [anon_sym_event] = ACTIONS(5014),
    [anon_sym_LPAREN] = ACTIONS(5016),
    [anon_sym_abstract] = ACTIONS(5014),
    [anon_sym_async] = ACTIONS(5014),
    [anon_sym_const] = ACTIONS(5014),
    [anon_sym_fixed] = ACTIONS(5014),
    [anon_sym_internal] = ACTIONS(5014),
    [anon_sym_new] = ACTIONS(5014),
    [anon_sym_override] = ACTIONS(5014),
    [anon_sym_partial] = ACTIONS(5014),
    [anon_sym_private] = ACTIONS(5014),
    [anon_sym_protected] = ACTIONS(5014),
    [anon_sym_public] = ACTIONS(5014),
    [anon_sym_readonly] = ACTIONS(5014),
    [anon_sym_ref] = ACTIONS(5014),
    [anon_sym_sealed] = ACTIONS(5014),
    [anon_sym_unsafe] = ACTIONS(5014),
    [anon_sym_virtual] = ACTIONS(5014),
    [anon_sym_volatile] = ACTIONS(5014),
    [anon_sym_RBRACE] = ACTIONS(5016),
    [anon_sym_implicit] = ACTIONS(5014),
    [anon_sym_explicit] = ACTIONS(5014),
    [anon_sym_TILDE] = ACTIONS(5016),
    [anon_sym_where] = ACTIONS(5014),
    [anon_sym_class] = ACTIONS(5014),
    [anon_sym_struct] = ACTIONS(5014),
    [anon_sym_notnull] = ACTIONS(5014),
    [anon_sym_unmanaged] = ACTIONS(5014),
    [anon_sym_get] = ACTIONS(5014),
    [anon_sym_set] = ACTIONS(5014),
    [anon_sym_add] = ACTIONS(5014),
    [anon_sym_remove] = ACTIONS(5014),
    [anon_sym_enum] = ACTIONS(5014),
    [anon_sym_interface] = ACTIONS(5014),
    [anon_sym_delegate] = ACTIONS(5014),
    [anon_sym_record] = ACTIONS(5014),
    [anon_sym_namespace] = ACTIONS(5014),
    [anon_sym_var] = ACTIONS(5014),
    [sym_predefined_type] = ACTIONS(5014),
    [anon_sym_when] = ACTIONS(5014),
    [anon_sym_yield] = ACTIONS(5014),
    [anon_sym_from] = ACTIONS(5014),
    [anon_sym_join] = ACTIONS(5014),
    [anon_sym_on] = ACTIONS(5014),
    [anon_sym_equals] = ACTIONS(5014),
    [anon_sym_into] = ACTIONS(5014),
    [anon_sym_let] = ACTIONS(5014),
    [anon_sym_orderby] = ACTIONS(5014),
    [anon_sym_ascending] = ACTIONS(5014),
    [anon_sym_descending] = ACTIONS(5014),
    [anon_sym_group] = ACTIONS(5014),
    [anon_sym_by] = ACTIONS(5014),
    [anon_sym_select] = ACTIONS(5014),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5014),
    [anon_sym_nameof] = ACTIONS(5014),
    [sym_void_keyword] = ACTIONS(5014),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2585] = {
    [sym__preprocessor_call] = STATE(2585),
    [sym__identifier_token] = ACTIONS(5018),
    [anon_sym_extern] = ACTIONS(5018),
    [anon_sym_alias] = ACTIONS(5018),
    [anon_sym_global] = ACTIONS(5018),
    [anon_sym_using] = ACTIONS(5018),
    [anon_sym_static] = ACTIONS(5018),
    [anon_sym_LBRACK] = ACTIONS(5020),
    [anon_sym_event] = ACTIONS(5018),
    [anon_sym_LPAREN] = ACTIONS(5020),
    [anon_sym_abstract] = ACTIONS(5018),
    [anon_sym_async] = ACTIONS(5018),
    [anon_sym_const] = ACTIONS(5018),
    [anon_sym_fixed] = ACTIONS(5018),
    [anon_sym_internal] = ACTIONS(5018),
    [anon_sym_new] = ACTIONS(5018),
    [anon_sym_override] = ACTIONS(5018),
    [anon_sym_partial] = ACTIONS(5018),
    [anon_sym_private] = ACTIONS(5018),
    [anon_sym_protected] = ACTIONS(5018),
    [anon_sym_public] = ACTIONS(5018),
    [anon_sym_readonly] = ACTIONS(5018),
    [anon_sym_ref] = ACTIONS(5018),
    [anon_sym_sealed] = ACTIONS(5018),
    [anon_sym_unsafe] = ACTIONS(5018),
    [anon_sym_virtual] = ACTIONS(5018),
    [anon_sym_volatile] = ACTIONS(5018),
    [anon_sym_RBRACE] = ACTIONS(5020),
    [anon_sym_implicit] = ACTIONS(5018),
    [anon_sym_explicit] = ACTIONS(5018),
    [anon_sym_TILDE] = ACTIONS(5020),
    [anon_sym_where] = ACTIONS(5018),
    [anon_sym_class] = ACTIONS(5018),
    [anon_sym_struct] = ACTIONS(5018),
    [anon_sym_notnull] = ACTIONS(5018),
    [anon_sym_unmanaged] = ACTIONS(5018),
    [anon_sym_get] = ACTIONS(5018),
    [anon_sym_set] = ACTIONS(5018),
    [anon_sym_add] = ACTIONS(5018),
    [anon_sym_remove] = ACTIONS(5018),
    [anon_sym_enum] = ACTIONS(5018),
    [anon_sym_interface] = ACTIONS(5018),
    [anon_sym_delegate] = ACTIONS(5018),
    [anon_sym_record] = ACTIONS(5018),
    [anon_sym_namespace] = ACTIONS(5018),
    [anon_sym_var] = ACTIONS(5018),
    [sym_predefined_type] = ACTIONS(5018),
    [anon_sym_when] = ACTIONS(5018),
    [anon_sym_yield] = ACTIONS(5018),
    [anon_sym_from] = ACTIONS(5018),
    [anon_sym_join] = ACTIONS(5018),
    [anon_sym_on] = ACTIONS(5018),
    [anon_sym_equals] = ACTIONS(5018),
    [anon_sym_into] = ACTIONS(5018),
    [anon_sym_let] = ACTIONS(5018),
    [anon_sym_orderby] = ACTIONS(5018),
    [anon_sym_ascending] = ACTIONS(5018),
    [anon_sym_descending] = ACTIONS(5018),
    [anon_sym_group] = ACTIONS(5018),
    [anon_sym_by] = ACTIONS(5018),
    [anon_sym_select] = ACTIONS(5018),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5018),
    [anon_sym_nameof] = ACTIONS(5018),
    [sym_void_keyword] = ACTIONS(5018),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2586] = {
    [sym__preprocessor_call] = STATE(2586),
    [sym__identifier_token] = ACTIONS(5022),
    [anon_sym_extern] = ACTIONS(5022),
    [anon_sym_alias] = ACTIONS(5022),
    [anon_sym_global] = ACTIONS(5022),
    [anon_sym_using] = ACTIONS(5022),
    [anon_sym_static] = ACTIONS(5022),
    [anon_sym_LBRACK] = ACTIONS(5024),
    [anon_sym_event] = ACTIONS(5022),
    [anon_sym_LPAREN] = ACTIONS(5024),
    [anon_sym_abstract] = ACTIONS(5022),
    [anon_sym_async] = ACTIONS(5022),
    [anon_sym_const] = ACTIONS(5022),
    [anon_sym_fixed] = ACTIONS(5022),
    [anon_sym_internal] = ACTIONS(5022),
    [anon_sym_new] = ACTIONS(5022),
    [anon_sym_override] = ACTIONS(5022),
    [anon_sym_partial] = ACTIONS(5022),
    [anon_sym_private] = ACTIONS(5022),
    [anon_sym_protected] = ACTIONS(5022),
    [anon_sym_public] = ACTIONS(5022),
    [anon_sym_readonly] = ACTIONS(5022),
    [anon_sym_ref] = ACTIONS(5022),
    [anon_sym_sealed] = ACTIONS(5022),
    [anon_sym_unsafe] = ACTIONS(5022),
    [anon_sym_virtual] = ACTIONS(5022),
    [anon_sym_volatile] = ACTIONS(5022),
    [anon_sym_RBRACE] = ACTIONS(5024),
    [anon_sym_implicit] = ACTIONS(5022),
    [anon_sym_explicit] = ACTIONS(5022),
    [anon_sym_TILDE] = ACTIONS(5024),
    [anon_sym_where] = ACTIONS(5022),
    [anon_sym_class] = ACTIONS(5022),
    [anon_sym_struct] = ACTIONS(5022),
    [anon_sym_notnull] = ACTIONS(5022),
    [anon_sym_unmanaged] = ACTIONS(5022),
    [anon_sym_get] = ACTIONS(5022),
    [anon_sym_set] = ACTIONS(5022),
    [anon_sym_add] = ACTIONS(5022),
    [anon_sym_remove] = ACTIONS(5022),
    [anon_sym_enum] = ACTIONS(5022),
    [anon_sym_interface] = ACTIONS(5022),
    [anon_sym_delegate] = ACTIONS(5022),
    [anon_sym_record] = ACTIONS(5022),
    [anon_sym_namespace] = ACTIONS(5022),
    [anon_sym_var] = ACTIONS(5022),
    [sym_predefined_type] = ACTIONS(5022),
    [anon_sym_when] = ACTIONS(5022),
    [anon_sym_yield] = ACTIONS(5022),
    [anon_sym_from] = ACTIONS(5022),
    [anon_sym_join] = ACTIONS(5022),
    [anon_sym_on] = ACTIONS(5022),
    [anon_sym_equals] = ACTIONS(5022),
    [anon_sym_into] = ACTIONS(5022),
    [anon_sym_let] = ACTIONS(5022),
    [anon_sym_orderby] = ACTIONS(5022),
    [anon_sym_ascending] = ACTIONS(5022),
    [anon_sym_descending] = ACTIONS(5022),
    [anon_sym_group] = ACTIONS(5022),
    [anon_sym_by] = ACTIONS(5022),
    [anon_sym_select] = ACTIONS(5022),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5022),
    [anon_sym_nameof] = ACTIONS(5022),
    [sym_void_keyword] = ACTIONS(5022),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2587] = {
    [sym__preprocessor_call] = STATE(2587),
    [sym__identifier_token] = ACTIONS(5026),
    [anon_sym_extern] = ACTIONS(5026),
    [anon_sym_alias] = ACTIONS(5026),
    [anon_sym_global] = ACTIONS(5026),
    [anon_sym_using] = ACTIONS(5026),
    [anon_sym_static] = ACTIONS(5026),
    [anon_sym_LBRACK] = ACTIONS(5028),
    [anon_sym_event] = ACTIONS(5026),
    [anon_sym_LPAREN] = ACTIONS(5028),
    [anon_sym_abstract] = ACTIONS(5026),
    [anon_sym_async] = ACTIONS(5026),
    [anon_sym_const] = ACTIONS(5026),
    [anon_sym_fixed] = ACTIONS(5026),
    [anon_sym_internal] = ACTIONS(5026),
    [anon_sym_new] = ACTIONS(5026),
    [anon_sym_override] = ACTIONS(5026),
    [anon_sym_partial] = ACTIONS(5026),
    [anon_sym_private] = ACTIONS(5026),
    [anon_sym_protected] = ACTIONS(5026),
    [anon_sym_public] = ACTIONS(5026),
    [anon_sym_readonly] = ACTIONS(5026),
    [anon_sym_ref] = ACTIONS(5026),
    [anon_sym_sealed] = ACTIONS(5026),
    [anon_sym_unsafe] = ACTIONS(5026),
    [anon_sym_virtual] = ACTIONS(5026),
    [anon_sym_volatile] = ACTIONS(5026),
    [anon_sym_RBRACE] = ACTIONS(5028),
    [anon_sym_implicit] = ACTIONS(5026),
    [anon_sym_explicit] = ACTIONS(5026),
    [anon_sym_TILDE] = ACTIONS(5028),
    [anon_sym_where] = ACTIONS(5026),
    [anon_sym_class] = ACTIONS(5026),
    [anon_sym_struct] = ACTIONS(5026),
    [anon_sym_notnull] = ACTIONS(5026),
    [anon_sym_unmanaged] = ACTIONS(5026),
    [anon_sym_get] = ACTIONS(5026),
    [anon_sym_set] = ACTIONS(5026),
    [anon_sym_add] = ACTIONS(5026),
    [anon_sym_remove] = ACTIONS(5026),
    [anon_sym_enum] = ACTIONS(5026),
    [anon_sym_interface] = ACTIONS(5026),
    [anon_sym_delegate] = ACTIONS(5026),
    [anon_sym_record] = ACTIONS(5026),
    [anon_sym_namespace] = ACTIONS(5026),
    [anon_sym_var] = ACTIONS(5026),
    [sym_predefined_type] = ACTIONS(5026),
    [anon_sym_when] = ACTIONS(5026),
    [anon_sym_yield] = ACTIONS(5026),
    [anon_sym_from] = ACTIONS(5026),
    [anon_sym_join] = ACTIONS(5026),
    [anon_sym_on] = ACTIONS(5026),
    [anon_sym_equals] = ACTIONS(5026),
    [anon_sym_into] = ACTIONS(5026),
    [anon_sym_let] = ACTIONS(5026),
    [anon_sym_orderby] = ACTIONS(5026),
    [anon_sym_ascending] = ACTIONS(5026),
    [anon_sym_descending] = ACTIONS(5026),
    [anon_sym_group] = ACTIONS(5026),
    [anon_sym_by] = ACTIONS(5026),
    [anon_sym_select] = ACTIONS(5026),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5026),
    [anon_sym_nameof] = ACTIONS(5026),
    [sym_void_keyword] = ACTIONS(5026),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2588] = {
    [sym__preprocessor_call] = STATE(2588),
    [sym__identifier_token] = ACTIONS(5030),
    [anon_sym_extern] = ACTIONS(5030),
    [anon_sym_alias] = ACTIONS(5030),
    [anon_sym_global] = ACTIONS(5030),
    [anon_sym_using] = ACTIONS(5030),
    [anon_sym_static] = ACTIONS(5030),
    [anon_sym_LBRACK] = ACTIONS(5032),
    [anon_sym_event] = ACTIONS(5030),
    [anon_sym_LPAREN] = ACTIONS(5032),
    [anon_sym_abstract] = ACTIONS(5030),
    [anon_sym_async] = ACTIONS(5030),
    [anon_sym_const] = ACTIONS(5030),
    [anon_sym_fixed] = ACTIONS(5030),
    [anon_sym_internal] = ACTIONS(5030),
    [anon_sym_new] = ACTIONS(5030),
    [anon_sym_override] = ACTIONS(5030),
    [anon_sym_partial] = ACTIONS(5030),
    [anon_sym_private] = ACTIONS(5030),
    [anon_sym_protected] = ACTIONS(5030),
    [anon_sym_public] = ACTIONS(5030),
    [anon_sym_readonly] = ACTIONS(5030),
    [anon_sym_ref] = ACTIONS(5030),
    [anon_sym_sealed] = ACTIONS(5030),
    [anon_sym_unsafe] = ACTIONS(5030),
    [anon_sym_virtual] = ACTIONS(5030),
    [anon_sym_volatile] = ACTIONS(5030),
    [anon_sym_RBRACE] = ACTIONS(5032),
    [anon_sym_implicit] = ACTIONS(5030),
    [anon_sym_explicit] = ACTIONS(5030),
    [anon_sym_TILDE] = ACTIONS(5032),
    [anon_sym_where] = ACTIONS(5030),
    [anon_sym_class] = ACTIONS(5030),
    [anon_sym_struct] = ACTIONS(5030),
    [anon_sym_notnull] = ACTIONS(5030),
    [anon_sym_unmanaged] = ACTIONS(5030),
    [anon_sym_get] = ACTIONS(5030),
    [anon_sym_set] = ACTIONS(5030),
    [anon_sym_add] = ACTIONS(5030),
    [anon_sym_remove] = ACTIONS(5030),
    [anon_sym_enum] = ACTIONS(5030),
    [anon_sym_interface] = ACTIONS(5030),
    [anon_sym_delegate] = ACTIONS(5030),
    [anon_sym_record] = ACTIONS(5030),
    [anon_sym_namespace] = ACTIONS(5030),
    [anon_sym_var] = ACTIONS(5030),
    [sym_predefined_type] = ACTIONS(5030),
    [anon_sym_when] = ACTIONS(5030),
    [anon_sym_yield] = ACTIONS(5030),
    [anon_sym_from] = ACTIONS(5030),
    [anon_sym_join] = ACTIONS(5030),
    [anon_sym_on] = ACTIONS(5030),
    [anon_sym_equals] = ACTIONS(5030),
    [anon_sym_into] = ACTIONS(5030),
    [anon_sym_let] = ACTIONS(5030),
    [anon_sym_orderby] = ACTIONS(5030),
    [anon_sym_ascending] = ACTIONS(5030),
    [anon_sym_descending] = ACTIONS(5030),
    [anon_sym_group] = ACTIONS(5030),
    [anon_sym_by] = ACTIONS(5030),
    [anon_sym_select] = ACTIONS(5030),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5030),
    [anon_sym_nameof] = ACTIONS(5030),
    [sym_void_keyword] = ACTIONS(5030),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2589] = {
    [sym__preprocessor_call] = STATE(2589),
    [sym__identifier_token] = ACTIONS(5034),
    [anon_sym_extern] = ACTIONS(5034),
    [anon_sym_alias] = ACTIONS(5034),
    [anon_sym_global] = ACTIONS(5034),
    [anon_sym_using] = ACTIONS(5034),
    [anon_sym_static] = ACTIONS(5034),
    [anon_sym_LBRACK] = ACTIONS(5036),
    [anon_sym_event] = ACTIONS(5034),
    [anon_sym_LPAREN] = ACTIONS(5036),
    [anon_sym_abstract] = ACTIONS(5034),
    [anon_sym_async] = ACTIONS(5034),
    [anon_sym_const] = ACTIONS(5034),
    [anon_sym_fixed] = ACTIONS(5034),
    [anon_sym_internal] = ACTIONS(5034),
    [anon_sym_new] = ACTIONS(5034),
    [anon_sym_override] = ACTIONS(5034),
    [anon_sym_partial] = ACTIONS(5034),
    [anon_sym_private] = ACTIONS(5034),
    [anon_sym_protected] = ACTIONS(5034),
    [anon_sym_public] = ACTIONS(5034),
    [anon_sym_readonly] = ACTIONS(5034),
    [anon_sym_ref] = ACTIONS(5034),
    [anon_sym_sealed] = ACTIONS(5034),
    [anon_sym_unsafe] = ACTIONS(5034),
    [anon_sym_virtual] = ACTIONS(5034),
    [anon_sym_volatile] = ACTIONS(5034),
    [anon_sym_RBRACE] = ACTIONS(5036),
    [anon_sym_implicit] = ACTIONS(5034),
    [anon_sym_explicit] = ACTIONS(5034),
    [anon_sym_TILDE] = ACTIONS(5036),
    [anon_sym_where] = ACTIONS(5034),
    [anon_sym_class] = ACTIONS(5034),
    [anon_sym_struct] = ACTIONS(5034),
    [anon_sym_notnull] = ACTIONS(5034),
    [anon_sym_unmanaged] = ACTIONS(5034),
    [anon_sym_get] = ACTIONS(5034),
    [anon_sym_set] = ACTIONS(5034),
    [anon_sym_add] = ACTIONS(5034),
    [anon_sym_remove] = ACTIONS(5034),
    [anon_sym_enum] = ACTIONS(5034),
    [anon_sym_interface] = ACTIONS(5034),
    [anon_sym_delegate] = ACTIONS(5034),
    [anon_sym_record] = ACTIONS(5034),
    [anon_sym_namespace] = ACTIONS(5034),
    [anon_sym_var] = ACTIONS(5034),
    [sym_predefined_type] = ACTIONS(5034),
    [anon_sym_when] = ACTIONS(5034),
    [anon_sym_yield] = ACTIONS(5034),
    [anon_sym_from] = ACTIONS(5034),
    [anon_sym_join] = ACTIONS(5034),
    [anon_sym_on] = ACTIONS(5034),
    [anon_sym_equals] = ACTIONS(5034),
    [anon_sym_into] = ACTIONS(5034),
    [anon_sym_let] = ACTIONS(5034),
    [anon_sym_orderby] = ACTIONS(5034),
    [anon_sym_ascending] = ACTIONS(5034),
    [anon_sym_descending] = ACTIONS(5034),
    [anon_sym_group] = ACTIONS(5034),
    [anon_sym_by] = ACTIONS(5034),
    [anon_sym_select] = ACTIONS(5034),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5034),
    [anon_sym_nameof] = ACTIONS(5034),
    [sym_void_keyword] = ACTIONS(5034),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2590] = {
    [sym__preprocessor_call] = STATE(2590),
    [sym__identifier_token] = ACTIONS(5038),
    [anon_sym_extern] = ACTIONS(5038),
    [anon_sym_alias] = ACTIONS(5038),
    [anon_sym_global] = ACTIONS(5038),
    [anon_sym_using] = ACTIONS(5038),
    [anon_sym_static] = ACTIONS(5038),
    [anon_sym_LBRACK] = ACTIONS(5040),
    [anon_sym_event] = ACTIONS(5038),
    [anon_sym_LPAREN] = ACTIONS(5040),
    [anon_sym_abstract] = ACTIONS(5038),
    [anon_sym_async] = ACTIONS(5038),
    [anon_sym_const] = ACTIONS(5038),
    [anon_sym_fixed] = ACTIONS(5038),
    [anon_sym_internal] = ACTIONS(5038),
    [anon_sym_new] = ACTIONS(5038),
    [anon_sym_override] = ACTIONS(5038),
    [anon_sym_partial] = ACTIONS(5038),
    [anon_sym_private] = ACTIONS(5038),
    [anon_sym_protected] = ACTIONS(5038),
    [anon_sym_public] = ACTIONS(5038),
    [anon_sym_readonly] = ACTIONS(5038),
    [anon_sym_ref] = ACTIONS(5038),
    [anon_sym_sealed] = ACTIONS(5038),
    [anon_sym_unsafe] = ACTIONS(5038),
    [anon_sym_virtual] = ACTIONS(5038),
    [anon_sym_volatile] = ACTIONS(5038),
    [anon_sym_RBRACE] = ACTIONS(5040),
    [anon_sym_implicit] = ACTIONS(5038),
    [anon_sym_explicit] = ACTIONS(5038),
    [anon_sym_TILDE] = ACTIONS(5040),
    [anon_sym_where] = ACTIONS(5038),
    [anon_sym_class] = ACTIONS(5038),
    [anon_sym_struct] = ACTIONS(5038),
    [anon_sym_notnull] = ACTIONS(5038),
    [anon_sym_unmanaged] = ACTIONS(5038),
    [anon_sym_get] = ACTIONS(5038),
    [anon_sym_set] = ACTIONS(5038),
    [anon_sym_add] = ACTIONS(5038),
    [anon_sym_remove] = ACTIONS(5038),
    [anon_sym_enum] = ACTIONS(5038),
    [anon_sym_interface] = ACTIONS(5038),
    [anon_sym_delegate] = ACTIONS(5038),
    [anon_sym_record] = ACTIONS(5038),
    [anon_sym_namespace] = ACTIONS(5038),
    [anon_sym_var] = ACTIONS(5038),
    [sym_predefined_type] = ACTIONS(5038),
    [anon_sym_when] = ACTIONS(5038),
    [anon_sym_yield] = ACTIONS(5038),
    [anon_sym_from] = ACTIONS(5038),
    [anon_sym_join] = ACTIONS(5038),
    [anon_sym_on] = ACTIONS(5038),
    [anon_sym_equals] = ACTIONS(5038),
    [anon_sym_into] = ACTIONS(5038),
    [anon_sym_let] = ACTIONS(5038),
    [anon_sym_orderby] = ACTIONS(5038),
    [anon_sym_ascending] = ACTIONS(5038),
    [anon_sym_descending] = ACTIONS(5038),
    [anon_sym_group] = ACTIONS(5038),
    [anon_sym_by] = ACTIONS(5038),
    [anon_sym_select] = ACTIONS(5038),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5038),
    [anon_sym_nameof] = ACTIONS(5038),
    [sym_void_keyword] = ACTIONS(5038),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2591] = {
    [sym__preprocessor_call] = STATE(2591),
    [sym__identifier_token] = ACTIONS(5042),
    [anon_sym_extern] = ACTIONS(5042),
    [anon_sym_alias] = ACTIONS(5042),
    [anon_sym_global] = ACTIONS(5042),
    [anon_sym_using] = ACTIONS(5042),
    [anon_sym_static] = ACTIONS(5042),
    [anon_sym_LBRACK] = ACTIONS(5044),
    [anon_sym_event] = ACTIONS(5042),
    [anon_sym_LPAREN] = ACTIONS(5044),
    [anon_sym_abstract] = ACTIONS(5042),
    [anon_sym_async] = ACTIONS(5042),
    [anon_sym_const] = ACTIONS(5042),
    [anon_sym_fixed] = ACTIONS(5042),
    [anon_sym_internal] = ACTIONS(5042),
    [anon_sym_new] = ACTIONS(5042),
    [anon_sym_override] = ACTIONS(5042),
    [anon_sym_partial] = ACTIONS(5042),
    [anon_sym_private] = ACTIONS(5042),
    [anon_sym_protected] = ACTIONS(5042),
    [anon_sym_public] = ACTIONS(5042),
    [anon_sym_readonly] = ACTIONS(5042),
    [anon_sym_ref] = ACTIONS(5042),
    [anon_sym_sealed] = ACTIONS(5042),
    [anon_sym_unsafe] = ACTIONS(5042),
    [anon_sym_virtual] = ACTIONS(5042),
    [anon_sym_volatile] = ACTIONS(5042),
    [anon_sym_RBRACE] = ACTIONS(5044),
    [anon_sym_implicit] = ACTIONS(5042),
    [anon_sym_explicit] = ACTIONS(5042),
    [anon_sym_TILDE] = ACTIONS(5044),
    [anon_sym_where] = ACTIONS(5042),
    [anon_sym_class] = ACTIONS(5042),
    [anon_sym_struct] = ACTIONS(5042),
    [anon_sym_notnull] = ACTIONS(5042),
    [anon_sym_unmanaged] = ACTIONS(5042),
    [anon_sym_get] = ACTIONS(5042),
    [anon_sym_set] = ACTIONS(5042),
    [anon_sym_add] = ACTIONS(5042),
    [anon_sym_remove] = ACTIONS(5042),
    [anon_sym_enum] = ACTIONS(5042),
    [anon_sym_interface] = ACTIONS(5042),
    [anon_sym_delegate] = ACTIONS(5042),
    [anon_sym_record] = ACTIONS(5042),
    [anon_sym_namespace] = ACTIONS(5042),
    [anon_sym_var] = ACTIONS(5042),
    [sym_predefined_type] = ACTIONS(5042),
    [anon_sym_when] = ACTIONS(5042),
    [anon_sym_yield] = ACTIONS(5042),
    [anon_sym_from] = ACTIONS(5042),
    [anon_sym_join] = ACTIONS(5042),
    [anon_sym_on] = ACTIONS(5042),
    [anon_sym_equals] = ACTIONS(5042),
    [anon_sym_into] = ACTIONS(5042),
    [anon_sym_let] = ACTIONS(5042),
    [anon_sym_orderby] = ACTIONS(5042),
    [anon_sym_ascending] = ACTIONS(5042),
    [anon_sym_descending] = ACTIONS(5042),
    [anon_sym_group] = ACTIONS(5042),
    [anon_sym_by] = ACTIONS(5042),
    [anon_sym_select] = ACTIONS(5042),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5042),
    [anon_sym_nameof] = ACTIONS(5042),
    [sym_void_keyword] = ACTIONS(5042),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2592] = {
    [sym__preprocessor_call] = STATE(2592),
    [sym__identifier_token] = ACTIONS(5046),
    [anon_sym_extern] = ACTIONS(5046),
    [anon_sym_alias] = ACTIONS(5046),
    [anon_sym_global] = ACTIONS(5046),
    [anon_sym_using] = ACTIONS(5046),
    [anon_sym_static] = ACTIONS(5046),
    [anon_sym_LBRACK] = ACTIONS(5048),
    [anon_sym_event] = ACTIONS(5046),
    [anon_sym_LPAREN] = ACTIONS(5048),
    [anon_sym_abstract] = ACTIONS(5046),
    [anon_sym_async] = ACTIONS(5046),
    [anon_sym_const] = ACTIONS(5046),
    [anon_sym_fixed] = ACTIONS(5046),
    [anon_sym_internal] = ACTIONS(5046),
    [anon_sym_new] = ACTIONS(5046),
    [anon_sym_override] = ACTIONS(5046),
    [anon_sym_partial] = ACTIONS(5046),
    [anon_sym_private] = ACTIONS(5046),
    [anon_sym_protected] = ACTIONS(5046),
    [anon_sym_public] = ACTIONS(5046),
    [anon_sym_readonly] = ACTIONS(5046),
    [anon_sym_ref] = ACTIONS(5046),
    [anon_sym_sealed] = ACTIONS(5046),
    [anon_sym_unsafe] = ACTIONS(5046),
    [anon_sym_virtual] = ACTIONS(5046),
    [anon_sym_volatile] = ACTIONS(5046),
    [anon_sym_RBRACE] = ACTIONS(5048),
    [anon_sym_implicit] = ACTIONS(5046),
    [anon_sym_explicit] = ACTIONS(5046),
    [anon_sym_TILDE] = ACTIONS(5048),
    [anon_sym_where] = ACTIONS(5046),
    [anon_sym_class] = ACTIONS(5046),
    [anon_sym_struct] = ACTIONS(5046),
    [anon_sym_notnull] = ACTIONS(5046),
    [anon_sym_unmanaged] = ACTIONS(5046),
    [anon_sym_get] = ACTIONS(5046),
    [anon_sym_set] = ACTIONS(5046),
    [anon_sym_add] = ACTIONS(5046),
    [anon_sym_remove] = ACTIONS(5046),
    [anon_sym_enum] = ACTIONS(5046),
    [anon_sym_interface] = ACTIONS(5046),
    [anon_sym_delegate] = ACTIONS(5046),
    [anon_sym_record] = ACTIONS(5046),
    [anon_sym_namespace] = ACTIONS(5046),
    [anon_sym_var] = ACTIONS(5046),
    [sym_predefined_type] = ACTIONS(5046),
    [anon_sym_when] = ACTIONS(5046),
    [anon_sym_yield] = ACTIONS(5046),
    [anon_sym_from] = ACTIONS(5046),
    [anon_sym_join] = ACTIONS(5046),
    [anon_sym_on] = ACTIONS(5046),
    [anon_sym_equals] = ACTIONS(5046),
    [anon_sym_into] = ACTIONS(5046),
    [anon_sym_let] = ACTIONS(5046),
    [anon_sym_orderby] = ACTIONS(5046),
    [anon_sym_ascending] = ACTIONS(5046),
    [anon_sym_descending] = ACTIONS(5046),
    [anon_sym_group] = ACTIONS(5046),
    [anon_sym_by] = ACTIONS(5046),
    [anon_sym_select] = ACTIONS(5046),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5046),
    [anon_sym_nameof] = ACTIONS(5046),
    [sym_void_keyword] = ACTIONS(5046),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2593] = {
    [sym__preprocessor_call] = STATE(2593),
    [sym__identifier_token] = ACTIONS(5050),
    [anon_sym_extern] = ACTIONS(5050),
    [anon_sym_alias] = ACTIONS(5050),
    [anon_sym_global] = ACTIONS(5050),
    [anon_sym_using] = ACTIONS(5050),
    [anon_sym_static] = ACTIONS(5050),
    [anon_sym_LBRACK] = ACTIONS(5052),
    [anon_sym_event] = ACTIONS(5050),
    [anon_sym_LPAREN] = ACTIONS(5052),
    [anon_sym_abstract] = ACTIONS(5050),
    [anon_sym_async] = ACTIONS(5050),
    [anon_sym_const] = ACTIONS(5050),
    [anon_sym_fixed] = ACTIONS(5050),
    [anon_sym_internal] = ACTIONS(5050),
    [anon_sym_new] = ACTIONS(5050),
    [anon_sym_override] = ACTIONS(5050),
    [anon_sym_partial] = ACTIONS(5050),
    [anon_sym_private] = ACTIONS(5050),
    [anon_sym_protected] = ACTIONS(5050),
    [anon_sym_public] = ACTIONS(5050),
    [anon_sym_readonly] = ACTIONS(5050),
    [anon_sym_ref] = ACTIONS(5050),
    [anon_sym_sealed] = ACTIONS(5050),
    [anon_sym_unsafe] = ACTIONS(5050),
    [anon_sym_virtual] = ACTIONS(5050),
    [anon_sym_volatile] = ACTIONS(5050),
    [anon_sym_RBRACE] = ACTIONS(5052),
    [anon_sym_implicit] = ACTIONS(5050),
    [anon_sym_explicit] = ACTIONS(5050),
    [anon_sym_TILDE] = ACTIONS(5052),
    [anon_sym_where] = ACTIONS(5050),
    [anon_sym_class] = ACTIONS(5050),
    [anon_sym_struct] = ACTIONS(5050),
    [anon_sym_notnull] = ACTIONS(5050),
    [anon_sym_unmanaged] = ACTIONS(5050),
    [anon_sym_get] = ACTIONS(5050),
    [anon_sym_set] = ACTIONS(5050),
    [anon_sym_add] = ACTIONS(5050),
    [anon_sym_remove] = ACTIONS(5050),
    [anon_sym_enum] = ACTIONS(5050),
    [anon_sym_interface] = ACTIONS(5050),
    [anon_sym_delegate] = ACTIONS(5050),
    [anon_sym_record] = ACTIONS(5050),
    [anon_sym_namespace] = ACTIONS(5050),
    [anon_sym_var] = ACTIONS(5050),
    [sym_predefined_type] = ACTIONS(5050),
    [anon_sym_when] = ACTIONS(5050),
    [anon_sym_yield] = ACTIONS(5050),
    [anon_sym_from] = ACTIONS(5050),
    [anon_sym_join] = ACTIONS(5050),
    [anon_sym_on] = ACTIONS(5050),
    [anon_sym_equals] = ACTIONS(5050),
    [anon_sym_into] = ACTIONS(5050),
    [anon_sym_let] = ACTIONS(5050),
    [anon_sym_orderby] = ACTIONS(5050),
    [anon_sym_ascending] = ACTIONS(5050),
    [anon_sym_descending] = ACTIONS(5050),
    [anon_sym_group] = ACTIONS(5050),
    [anon_sym_by] = ACTIONS(5050),
    [anon_sym_select] = ACTIONS(5050),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5050),
    [anon_sym_nameof] = ACTIONS(5050),
    [sym_void_keyword] = ACTIONS(5050),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2594] = {
    [sym__preprocessor_call] = STATE(2594),
    [sym__identifier_token] = ACTIONS(5054),
    [anon_sym_extern] = ACTIONS(5054),
    [anon_sym_alias] = ACTIONS(5054),
    [anon_sym_global] = ACTIONS(5054),
    [anon_sym_using] = ACTIONS(5054),
    [anon_sym_static] = ACTIONS(5054),
    [anon_sym_LBRACK] = ACTIONS(5056),
    [anon_sym_event] = ACTIONS(5054),
    [anon_sym_LPAREN] = ACTIONS(5056),
    [anon_sym_abstract] = ACTIONS(5054),
    [anon_sym_async] = ACTIONS(5054),
    [anon_sym_const] = ACTIONS(5054),
    [anon_sym_fixed] = ACTIONS(5054),
    [anon_sym_internal] = ACTIONS(5054),
    [anon_sym_new] = ACTIONS(5054),
    [anon_sym_override] = ACTIONS(5054),
    [anon_sym_partial] = ACTIONS(5054),
    [anon_sym_private] = ACTIONS(5054),
    [anon_sym_protected] = ACTIONS(5054),
    [anon_sym_public] = ACTIONS(5054),
    [anon_sym_readonly] = ACTIONS(5054),
    [anon_sym_ref] = ACTIONS(5054),
    [anon_sym_sealed] = ACTIONS(5054),
    [anon_sym_unsafe] = ACTIONS(5054),
    [anon_sym_virtual] = ACTIONS(5054),
    [anon_sym_volatile] = ACTIONS(5054),
    [anon_sym_RBRACE] = ACTIONS(5056),
    [anon_sym_implicit] = ACTIONS(5054),
    [anon_sym_explicit] = ACTIONS(5054),
    [anon_sym_TILDE] = ACTIONS(5056),
    [anon_sym_where] = ACTIONS(5054),
    [anon_sym_class] = ACTIONS(5054),
    [anon_sym_struct] = ACTIONS(5054),
    [anon_sym_notnull] = ACTIONS(5054),
    [anon_sym_unmanaged] = ACTIONS(5054),
    [anon_sym_get] = ACTIONS(5054),
    [anon_sym_set] = ACTIONS(5054),
    [anon_sym_add] = ACTIONS(5054),
    [anon_sym_remove] = ACTIONS(5054),
    [anon_sym_enum] = ACTIONS(5054),
    [anon_sym_interface] = ACTIONS(5054),
    [anon_sym_delegate] = ACTIONS(5054),
    [anon_sym_record] = ACTIONS(5054),
    [anon_sym_namespace] = ACTIONS(5054),
    [anon_sym_var] = ACTIONS(5054),
    [sym_predefined_type] = ACTIONS(5054),
    [anon_sym_when] = ACTIONS(5054),
    [anon_sym_yield] = ACTIONS(5054),
    [anon_sym_from] = ACTIONS(5054),
    [anon_sym_join] = ACTIONS(5054),
    [anon_sym_on] = ACTIONS(5054),
    [anon_sym_equals] = ACTIONS(5054),
    [anon_sym_into] = ACTIONS(5054),
    [anon_sym_let] = ACTIONS(5054),
    [anon_sym_orderby] = ACTIONS(5054),
    [anon_sym_ascending] = ACTIONS(5054),
    [anon_sym_descending] = ACTIONS(5054),
    [anon_sym_group] = ACTIONS(5054),
    [anon_sym_by] = ACTIONS(5054),
    [anon_sym_select] = ACTIONS(5054),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5054),
    [anon_sym_nameof] = ACTIONS(5054),
    [sym_void_keyword] = ACTIONS(5054),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2595] = {
    [sym__preprocessor_call] = STATE(2595),
    [sym__identifier_token] = ACTIONS(5058),
    [anon_sym_extern] = ACTIONS(5058),
    [anon_sym_alias] = ACTIONS(5058),
    [anon_sym_global] = ACTIONS(5058),
    [anon_sym_using] = ACTIONS(5058),
    [anon_sym_static] = ACTIONS(5058),
    [anon_sym_LBRACK] = ACTIONS(5060),
    [anon_sym_event] = ACTIONS(5058),
    [anon_sym_LPAREN] = ACTIONS(5060),
    [anon_sym_abstract] = ACTIONS(5058),
    [anon_sym_async] = ACTIONS(5058),
    [anon_sym_const] = ACTIONS(5058),
    [anon_sym_fixed] = ACTIONS(5058),
    [anon_sym_internal] = ACTIONS(5058),
    [anon_sym_new] = ACTIONS(5058),
    [anon_sym_override] = ACTIONS(5058),
    [anon_sym_partial] = ACTIONS(5058),
    [anon_sym_private] = ACTIONS(5058),
    [anon_sym_protected] = ACTIONS(5058),
    [anon_sym_public] = ACTIONS(5058),
    [anon_sym_readonly] = ACTIONS(5058),
    [anon_sym_ref] = ACTIONS(5058),
    [anon_sym_sealed] = ACTIONS(5058),
    [anon_sym_unsafe] = ACTIONS(5058),
    [anon_sym_virtual] = ACTIONS(5058),
    [anon_sym_volatile] = ACTIONS(5058),
    [anon_sym_RBRACE] = ACTIONS(5060),
    [anon_sym_implicit] = ACTIONS(5058),
    [anon_sym_explicit] = ACTIONS(5058),
    [anon_sym_TILDE] = ACTIONS(5060),
    [anon_sym_where] = ACTIONS(5058),
    [anon_sym_class] = ACTIONS(5058),
    [anon_sym_struct] = ACTIONS(5058),
    [anon_sym_notnull] = ACTIONS(5058),
    [anon_sym_unmanaged] = ACTIONS(5058),
    [anon_sym_get] = ACTIONS(5058),
    [anon_sym_set] = ACTIONS(5058),
    [anon_sym_add] = ACTIONS(5058),
    [anon_sym_remove] = ACTIONS(5058),
    [anon_sym_enum] = ACTIONS(5058),
    [anon_sym_interface] = ACTIONS(5058),
    [anon_sym_delegate] = ACTIONS(5058),
    [anon_sym_record] = ACTIONS(5058),
    [anon_sym_namespace] = ACTIONS(5058),
    [anon_sym_var] = ACTIONS(5058),
    [sym_predefined_type] = ACTIONS(5058),
    [anon_sym_when] = ACTIONS(5058),
    [anon_sym_yield] = ACTIONS(5058),
    [anon_sym_from] = ACTIONS(5058),
    [anon_sym_join] = ACTIONS(5058),
    [anon_sym_on] = ACTIONS(5058),
    [anon_sym_equals] = ACTIONS(5058),
    [anon_sym_into] = ACTIONS(5058),
    [anon_sym_let] = ACTIONS(5058),
    [anon_sym_orderby] = ACTIONS(5058),
    [anon_sym_ascending] = ACTIONS(5058),
    [anon_sym_descending] = ACTIONS(5058),
    [anon_sym_group] = ACTIONS(5058),
    [anon_sym_by] = ACTIONS(5058),
    [anon_sym_select] = ACTIONS(5058),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5058),
    [anon_sym_nameof] = ACTIONS(5058),
    [sym_void_keyword] = ACTIONS(5058),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2596] = {
    [sym__preprocessor_call] = STATE(2596),
    [sym__identifier_token] = ACTIONS(5062),
    [anon_sym_extern] = ACTIONS(5062),
    [anon_sym_alias] = ACTIONS(5062),
    [anon_sym_global] = ACTIONS(5062),
    [anon_sym_using] = ACTIONS(5062),
    [anon_sym_static] = ACTIONS(5062),
    [anon_sym_LBRACK] = ACTIONS(5064),
    [anon_sym_event] = ACTIONS(5062),
    [anon_sym_LPAREN] = ACTIONS(5064),
    [anon_sym_abstract] = ACTIONS(5062),
    [anon_sym_async] = ACTIONS(5062),
    [anon_sym_const] = ACTIONS(5062),
    [anon_sym_fixed] = ACTIONS(5062),
    [anon_sym_internal] = ACTIONS(5062),
    [anon_sym_new] = ACTIONS(5062),
    [anon_sym_override] = ACTIONS(5062),
    [anon_sym_partial] = ACTIONS(5062),
    [anon_sym_private] = ACTIONS(5062),
    [anon_sym_protected] = ACTIONS(5062),
    [anon_sym_public] = ACTIONS(5062),
    [anon_sym_readonly] = ACTIONS(5062),
    [anon_sym_ref] = ACTIONS(5062),
    [anon_sym_sealed] = ACTIONS(5062),
    [anon_sym_unsafe] = ACTIONS(5062),
    [anon_sym_virtual] = ACTIONS(5062),
    [anon_sym_volatile] = ACTIONS(5062),
    [anon_sym_RBRACE] = ACTIONS(5064),
    [anon_sym_implicit] = ACTIONS(5062),
    [anon_sym_explicit] = ACTIONS(5062),
    [anon_sym_TILDE] = ACTIONS(5064),
    [anon_sym_where] = ACTIONS(5062),
    [anon_sym_class] = ACTIONS(5062),
    [anon_sym_struct] = ACTIONS(5062),
    [anon_sym_notnull] = ACTIONS(5062),
    [anon_sym_unmanaged] = ACTIONS(5062),
    [anon_sym_get] = ACTIONS(5062),
    [anon_sym_set] = ACTIONS(5062),
    [anon_sym_add] = ACTIONS(5062),
    [anon_sym_remove] = ACTIONS(5062),
    [anon_sym_enum] = ACTIONS(5062),
    [anon_sym_interface] = ACTIONS(5062),
    [anon_sym_delegate] = ACTIONS(5062),
    [anon_sym_record] = ACTIONS(5062),
    [anon_sym_namespace] = ACTIONS(5062),
    [anon_sym_var] = ACTIONS(5062),
    [sym_predefined_type] = ACTIONS(5062),
    [anon_sym_when] = ACTIONS(5062),
    [anon_sym_yield] = ACTIONS(5062),
    [anon_sym_from] = ACTIONS(5062),
    [anon_sym_join] = ACTIONS(5062),
    [anon_sym_on] = ACTIONS(5062),
    [anon_sym_equals] = ACTIONS(5062),
    [anon_sym_into] = ACTIONS(5062),
    [anon_sym_let] = ACTIONS(5062),
    [anon_sym_orderby] = ACTIONS(5062),
    [anon_sym_ascending] = ACTIONS(5062),
    [anon_sym_descending] = ACTIONS(5062),
    [anon_sym_group] = ACTIONS(5062),
    [anon_sym_by] = ACTIONS(5062),
    [anon_sym_select] = ACTIONS(5062),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5062),
    [anon_sym_nameof] = ACTIONS(5062),
    [sym_void_keyword] = ACTIONS(5062),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2597] = {
    [sym__preprocessor_call] = STATE(2597),
    [sym__identifier_token] = ACTIONS(5066),
    [anon_sym_extern] = ACTIONS(5066),
    [anon_sym_alias] = ACTIONS(5066),
    [anon_sym_global] = ACTIONS(5066),
    [anon_sym_using] = ACTIONS(5066),
    [anon_sym_static] = ACTIONS(5066),
    [anon_sym_LBRACK] = ACTIONS(5068),
    [anon_sym_event] = ACTIONS(5066),
    [anon_sym_LPAREN] = ACTIONS(5068),
    [anon_sym_abstract] = ACTIONS(5066),
    [anon_sym_async] = ACTIONS(5066),
    [anon_sym_const] = ACTIONS(5066),
    [anon_sym_fixed] = ACTIONS(5066),
    [anon_sym_internal] = ACTIONS(5066),
    [anon_sym_new] = ACTIONS(5066),
    [anon_sym_override] = ACTIONS(5066),
    [anon_sym_partial] = ACTIONS(5066),
    [anon_sym_private] = ACTIONS(5066),
    [anon_sym_protected] = ACTIONS(5066),
    [anon_sym_public] = ACTIONS(5066),
    [anon_sym_readonly] = ACTIONS(5066),
    [anon_sym_ref] = ACTIONS(5066),
    [anon_sym_sealed] = ACTIONS(5066),
    [anon_sym_unsafe] = ACTIONS(5066),
    [anon_sym_virtual] = ACTIONS(5066),
    [anon_sym_volatile] = ACTIONS(5066),
    [anon_sym_RBRACE] = ACTIONS(5068),
    [anon_sym_implicit] = ACTIONS(5066),
    [anon_sym_explicit] = ACTIONS(5066),
    [anon_sym_TILDE] = ACTIONS(5068),
    [anon_sym_where] = ACTIONS(5066),
    [anon_sym_class] = ACTIONS(5066),
    [anon_sym_struct] = ACTIONS(5066),
    [anon_sym_notnull] = ACTIONS(5066),
    [anon_sym_unmanaged] = ACTIONS(5066),
    [anon_sym_get] = ACTIONS(5066),
    [anon_sym_set] = ACTIONS(5066),
    [anon_sym_add] = ACTIONS(5066),
    [anon_sym_remove] = ACTIONS(5066),
    [anon_sym_enum] = ACTIONS(5066),
    [anon_sym_interface] = ACTIONS(5066),
    [anon_sym_delegate] = ACTIONS(5066),
    [anon_sym_record] = ACTIONS(5066),
    [anon_sym_namespace] = ACTIONS(5066),
    [anon_sym_var] = ACTIONS(5066),
    [sym_predefined_type] = ACTIONS(5066),
    [anon_sym_when] = ACTIONS(5066),
    [anon_sym_yield] = ACTIONS(5066),
    [anon_sym_from] = ACTIONS(5066),
    [anon_sym_join] = ACTIONS(5066),
    [anon_sym_on] = ACTIONS(5066),
    [anon_sym_equals] = ACTIONS(5066),
    [anon_sym_into] = ACTIONS(5066),
    [anon_sym_let] = ACTIONS(5066),
    [anon_sym_orderby] = ACTIONS(5066),
    [anon_sym_ascending] = ACTIONS(5066),
    [anon_sym_descending] = ACTIONS(5066),
    [anon_sym_group] = ACTIONS(5066),
    [anon_sym_by] = ACTIONS(5066),
    [anon_sym_select] = ACTIONS(5066),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5066),
    [anon_sym_nameof] = ACTIONS(5066),
    [sym_void_keyword] = ACTIONS(5066),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2598] = {
    [sym__preprocessor_call] = STATE(2598),
    [sym__identifier_token] = ACTIONS(5070),
    [anon_sym_extern] = ACTIONS(5070),
    [anon_sym_alias] = ACTIONS(5070),
    [anon_sym_global] = ACTIONS(5070),
    [anon_sym_using] = ACTIONS(5070),
    [anon_sym_static] = ACTIONS(5070),
    [anon_sym_LBRACK] = ACTIONS(5072),
    [anon_sym_event] = ACTIONS(5070),
    [anon_sym_LPAREN] = ACTIONS(5072),
    [anon_sym_abstract] = ACTIONS(5070),
    [anon_sym_async] = ACTIONS(5070),
    [anon_sym_const] = ACTIONS(5070),
    [anon_sym_fixed] = ACTIONS(5070),
    [anon_sym_internal] = ACTIONS(5070),
    [anon_sym_new] = ACTIONS(5070),
    [anon_sym_override] = ACTIONS(5070),
    [anon_sym_partial] = ACTIONS(5070),
    [anon_sym_private] = ACTIONS(5070),
    [anon_sym_protected] = ACTIONS(5070),
    [anon_sym_public] = ACTIONS(5070),
    [anon_sym_readonly] = ACTIONS(5070),
    [anon_sym_ref] = ACTIONS(5070),
    [anon_sym_sealed] = ACTIONS(5070),
    [anon_sym_unsafe] = ACTIONS(5070),
    [anon_sym_virtual] = ACTIONS(5070),
    [anon_sym_volatile] = ACTIONS(5070),
    [anon_sym_RBRACE] = ACTIONS(5072),
    [anon_sym_implicit] = ACTIONS(5070),
    [anon_sym_explicit] = ACTIONS(5070),
    [anon_sym_TILDE] = ACTIONS(5072),
    [anon_sym_where] = ACTIONS(5070),
    [anon_sym_class] = ACTIONS(5070),
    [anon_sym_struct] = ACTIONS(5070),
    [anon_sym_notnull] = ACTIONS(5070),
    [anon_sym_unmanaged] = ACTIONS(5070),
    [anon_sym_get] = ACTIONS(5070),
    [anon_sym_set] = ACTIONS(5070),
    [anon_sym_add] = ACTIONS(5070),
    [anon_sym_remove] = ACTIONS(5070),
    [anon_sym_enum] = ACTIONS(5070),
    [anon_sym_interface] = ACTIONS(5070),
    [anon_sym_delegate] = ACTIONS(5070),
    [anon_sym_record] = ACTIONS(5070),
    [anon_sym_namespace] = ACTIONS(5070),
    [anon_sym_var] = ACTIONS(5070),
    [sym_predefined_type] = ACTIONS(5070),
    [anon_sym_when] = ACTIONS(5070),
    [anon_sym_yield] = ACTIONS(5070),
    [anon_sym_from] = ACTIONS(5070),
    [anon_sym_join] = ACTIONS(5070),
    [anon_sym_on] = ACTIONS(5070),
    [anon_sym_equals] = ACTIONS(5070),
    [anon_sym_into] = ACTIONS(5070),
    [anon_sym_let] = ACTIONS(5070),
    [anon_sym_orderby] = ACTIONS(5070),
    [anon_sym_ascending] = ACTIONS(5070),
    [anon_sym_descending] = ACTIONS(5070),
    [anon_sym_group] = ACTIONS(5070),
    [anon_sym_by] = ACTIONS(5070),
    [anon_sym_select] = ACTIONS(5070),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5070),
    [anon_sym_nameof] = ACTIONS(5070),
    [sym_void_keyword] = ACTIONS(5070),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2599] = {
    [sym__preprocessor_call] = STATE(2599),
    [sym__identifier_token] = ACTIONS(5074),
    [anon_sym_extern] = ACTIONS(5074),
    [anon_sym_alias] = ACTIONS(5074),
    [anon_sym_global] = ACTIONS(5074),
    [anon_sym_using] = ACTIONS(5074),
    [anon_sym_static] = ACTIONS(5074),
    [anon_sym_LBRACK] = ACTIONS(5076),
    [anon_sym_event] = ACTIONS(5074),
    [anon_sym_LPAREN] = ACTIONS(5076),
    [anon_sym_abstract] = ACTIONS(5074),
    [anon_sym_async] = ACTIONS(5074),
    [anon_sym_const] = ACTIONS(5074),
    [anon_sym_fixed] = ACTIONS(5074),
    [anon_sym_internal] = ACTIONS(5074),
    [anon_sym_new] = ACTIONS(5074),
    [anon_sym_override] = ACTIONS(5074),
    [anon_sym_partial] = ACTIONS(5074),
    [anon_sym_private] = ACTIONS(5074),
    [anon_sym_protected] = ACTIONS(5074),
    [anon_sym_public] = ACTIONS(5074),
    [anon_sym_readonly] = ACTIONS(5074),
    [anon_sym_ref] = ACTIONS(5074),
    [anon_sym_sealed] = ACTIONS(5074),
    [anon_sym_unsafe] = ACTIONS(5074),
    [anon_sym_virtual] = ACTIONS(5074),
    [anon_sym_volatile] = ACTIONS(5074),
    [anon_sym_RBRACE] = ACTIONS(5076),
    [anon_sym_implicit] = ACTIONS(5074),
    [anon_sym_explicit] = ACTIONS(5074),
    [anon_sym_TILDE] = ACTIONS(5076),
    [anon_sym_where] = ACTIONS(5074),
    [anon_sym_class] = ACTIONS(5074),
    [anon_sym_struct] = ACTIONS(5074),
    [anon_sym_notnull] = ACTIONS(5074),
    [anon_sym_unmanaged] = ACTIONS(5074),
    [anon_sym_get] = ACTIONS(5074),
    [anon_sym_set] = ACTIONS(5074),
    [anon_sym_add] = ACTIONS(5074),
    [anon_sym_remove] = ACTIONS(5074),
    [anon_sym_enum] = ACTIONS(5074),
    [anon_sym_interface] = ACTIONS(5074),
    [anon_sym_delegate] = ACTIONS(5074),
    [anon_sym_record] = ACTIONS(5074),
    [anon_sym_namespace] = ACTIONS(5074),
    [anon_sym_var] = ACTIONS(5074),
    [sym_predefined_type] = ACTIONS(5074),
    [anon_sym_when] = ACTIONS(5074),
    [anon_sym_yield] = ACTIONS(5074),
    [anon_sym_from] = ACTIONS(5074),
    [anon_sym_join] = ACTIONS(5074),
    [anon_sym_on] = ACTIONS(5074),
    [anon_sym_equals] = ACTIONS(5074),
    [anon_sym_into] = ACTIONS(5074),
    [anon_sym_let] = ACTIONS(5074),
    [anon_sym_orderby] = ACTIONS(5074),
    [anon_sym_ascending] = ACTIONS(5074),
    [anon_sym_descending] = ACTIONS(5074),
    [anon_sym_group] = ACTIONS(5074),
    [anon_sym_by] = ACTIONS(5074),
    [anon_sym_select] = ACTIONS(5074),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5074),
    [anon_sym_nameof] = ACTIONS(5074),
    [sym_void_keyword] = ACTIONS(5074),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2600] = {
    [sym__preprocessor_call] = STATE(2600),
    [sym__identifier_token] = ACTIONS(5078),
    [anon_sym_extern] = ACTIONS(5078),
    [anon_sym_alias] = ACTIONS(5078),
    [anon_sym_global] = ACTIONS(5078),
    [anon_sym_using] = ACTIONS(5078),
    [anon_sym_static] = ACTIONS(5078),
    [anon_sym_LBRACK] = ACTIONS(5080),
    [anon_sym_event] = ACTIONS(5078),
    [anon_sym_LPAREN] = ACTIONS(5080),
    [anon_sym_abstract] = ACTIONS(5078),
    [anon_sym_async] = ACTIONS(5078),
    [anon_sym_const] = ACTIONS(5078),
    [anon_sym_fixed] = ACTIONS(5078),
    [anon_sym_internal] = ACTIONS(5078),
    [anon_sym_new] = ACTIONS(5078),
    [anon_sym_override] = ACTIONS(5078),
    [anon_sym_partial] = ACTIONS(5078),
    [anon_sym_private] = ACTIONS(5078),
    [anon_sym_protected] = ACTIONS(5078),
    [anon_sym_public] = ACTIONS(5078),
    [anon_sym_readonly] = ACTIONS(5078),
    [anon_sym_ref] = ACTIONS(5078),
    [anon_sym_sealed] = ACTIONS(5078),
    [anon_sym_unsafe] = ACTIONS(5078),
    [anon_sym_virtual] = ACTIONS(5078),
    [anon_sym_volatile] = ACTIONS(5078),
    [anon_sym_RBRACE] = ACTIONS(5080),
    [anon_sym_implicit] = ACTIONS(5078),
    [anon_sym_explicit] = ACTIONS(5078),
    [anon_sym_TILDE] = ACTIONS(5080),
    [anon_sym_where] = ACTIONS(5078),
    [anon_sym_class] = ACTIONS(5078),
    [anon_sym_struct] = ACTIONS(5078),
    [anon_sym_notnull] = ACTIONS(5078),
    [anon_sym_unmanaged] = ACTIONS(5078),
    [anon_sym_get] = ACTIONS(5078),
    [anon_sym_set] = ACTIONS(5078),
    [anon_sym_add] = ACTIONS(5078),
    [anon_sym_remove] = ACTIONS(5078),
    [anon_sym_enum] = ACTIONS(5078),
    [anon_sym_interface] = ACTIONS(5078),
    [anon_sym_delegate] = ACTIONS(5078),
    [anon_sym_record] = ACTIONS(5078),
    [anon_sym_namespace] = ACTIONS(5078),
    [anon_sym_var] = ACTIONS(5078),
    [sym_predefined_type] = ACTIONS(5078),
    [anon_sym_when] = ACTIONS(5078),
    [anon_sym_yield] = ACTIONS(5078),
    [anon_sym_from] = ACTIONS(5078),
    [anon_sym_join] = ACTIONS(5078),
    [anon_sym_on] = ACTIONS(5078),
    [anon_sym_equals] = ACTIONS(5078),
    [anon_sym_into] = ACTIONS(5078),
    [anon_sym_let] = ACTIONS(5078),
    [anon_sym_orderby] = ACTIONS(5078),
    [anon_sym_ascending] = ACTIONS(5078),
    [anon_sym_descending] = ACTIONS(5078),
    [anon_sym_group] = ACTIONS(5078),
    [anon_sym_by] = ACTIONS(5078),
    [anon_sym_select] = ACTIONS(5078),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5078),
    [anon_sym_nameof] = ACTIONS(5078),
    [sym_void_keyword] = ACTIONS(5078),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2601] = {
    [sym__preprocessor_call] = STATE(2601),
    [sym__identifier_token] = ACTIONS(5082),
    [anon_sym_extern] = ACTIONS(5082),
    [anon_sym_alias] = ACTIONS(5082),
    [anon_sym_global] = ACTIONS(5082),
    [anon_sym_using] = ACTIONS(5082),
    [anon_sym_static] = ACTIONS(5082),
    [anon_sym_LBRACK] = ACTIONS(5084),
    [anon_sym_event] = ACTIONS(5082),
    [anon_sym_LPAREN] = ACTIONS(5084),
    [anon_sym_abstract] = ACTIONS(5082),
    [anon_sym_async] = ACTIONS(5082),
    [anon_sym_const] = ACTIONS(5082),
    [anon_sym_fixed] = ACTIONS(5082),
    [anon_sym_internal] = ACTIONS(5082),
    [anon_sym_new] = ACTIONS(5082),
    [anon_sym_override] = ACTIONS(5082),
    [anon_sym_partial] = ACTIONS(5082),
    [anon_sym_private] = ACTIONS(5082),
    [anon_sym_protected] = ACTIONS(5082),
    [anon_sym_public] = ACTIONS(5082),
    [anon_sym_readonly] = ACTIONS(5082),
    [anon_sym_ref] = ACTIONS(5082),
    [anon_sym_sealed] = ACTIONS(5082),
    [anon_sym_unsafe] = ACTIONS(5082),
    [anon_sym_virtual] = ACTIONS(5082),
    [anon_sym_volatile] = ACTIONS(5082),
    [anon_sym_RBRACE] = ACTIONS(5084),
    [anon_sym_implicit] = ACTIONS(5082),
    [anon_sym_explicit] = ACTIONS(5082),
    [anon_sym_TILDE] = ACTIONS(5084),
    [anon_sym_where] = ACTIONS(5082),
    [anon_sym_class] = ACTIONS(5082),
    [anon_sym_struct] = ACTIONS(5082),
    [anon_sym_notnull] = ACTIONS(5082),
    [anon_sym_unmanaged] = ACTIONS(5082),
    [anon_sym_get] = ACTIONS(5082),
    [anon_sym_set] = ACTIONS(5082),
    [anon_sym_add] = ACTIONS(5082),
    [anon_sym_remove] = ACTIONS(5082),
    [anon_sym_enum] = ACTIONS(5082),
    [anon_sym_interface] = ACTIONS(5082),
    [anon_sym_delegate] = ACTIONS(5082),
    [anon_sym_record] = ACTIONS(5082),
    [anon_sym_namespace] = ACTIONS(5082),
    [anon_sym_var] = ACTIONS(5082),
    [sym_predefined_type] = ACTIONS(5082),
    [anon_sym_when] = ACTIONS(5082),
    [anon_sym_yield] = ACTIONS(5082),
    [anon_sym_from] = ACTIONS(5082),
    [anon_sym_join] = ACTIONS(5082),
    [anon_sym_on] = ACTIONS(5082),
    [anon_sym_equals] = ACTIONS(5082),
    [anon_sym_into] = ACTIONS(5082),
    [anon_sym_let] = ACTIONS(5082),
    [anon_sym_orderby] = ACTIONS(5082),
    [anon_sym_ascending] = ACTIONS(5082),
    [anon_sym_descending] = ACTIONS(5082),
    [anon_sym_group] = ACTIONS(5082),
    [anon_sym_by] = ACTIONS(5082),
    [anon_sym_select] = ACTIONS(5082),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5082),
    [anon_sym_nameof] = ACTIONS(5082),
    [sym_void_keyword] = ACTIONS(5082),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2602] = {
    [sym__preprocessor_call] = STATE(2602),
    [sym__identifier_token] = ACTIONS(5086),
    [anon_sym_extern] = ACTIONS(5086),
    [anon_sym_alias] = ACTIONS(5086),
    [anon_sym_global] = ACTIONS(5086),
    [anon_sym_using] = ACTIONS(5086),
    [anon_sym_static] = ACTIONS(5086),
    [anon_sym_LBRACK] = ACTIONS(5088),
    [anon_sym_event] = ACTIONS(5086),
    [anon_sym_LPAREN] = ACTIONS(5088),
    [anon_sym_abstract] = ACTIONS(5086),
    [anon_sym_async] = ACTIONS(5086),
    [anon_sym_const] = ACTIONS(5086),
    [anon_sym_fixed] = ACTIONS(5086),
    [anon_sym_internal] = ACTIONS(5086),
    [anon_sym_new] = ACTIONS(5086),
    [anon_sym_override] = ACTIONS(5086),
    [anon_sym_partial] = ACTIONS(5086),
    [anon_sym_private] = ACTIONS(5086),
    [anon_sym_protected] = ACTIONS(5086),
    [anon_sym_public] = ACTIONS(5086),
    [anon_sym_readonly] = ACTIONS(5086),
    [anon_sym_ref] = ACTIONS(5086),
    [anon_sym_sealed] = ACTIONS(5086),
    [anon_sym_unsafe] = ACTIONS(5086),
    [anon_sym_virtual] = ACTIONS(5086),
    [anon_sym_volatile] = ACTIONS(5086),
    [anon_sym_RBRACE] = ACTIONS(5088),
    [anon_sym_implicit] = ACTIONS(5086),
    [anon_sym_explicit] = ACTIONS(5086),
    [anon_sym_TILDE] = ACTIONS(5088),
    [anon_sym_where] = ACTIONS(5086),
    [anon_sym_class] = ACTIONS(5086),
    [anon_sym_struct] = ACTIONS(5086),
    [anon_sym_notnull] = ACTIONS(5086),
    [anon_sym_unmanaged] = ACTIONS(5086),
    [anon_sym_get] = ACTIONS(5086),
    [anon_sym_set] = ACTIONS(5086),
    [anon_sym_add] = ACTIONS(5086),
    [anon_sym_remove] = ACTIONS(5086),
    [anon_sym_enum] = ACTIONS(5086),
    [anon_sym_interface] = ACTIONS(5086),
    [anon_sym_delegate] = ACTIONS(5086),
    [anon_sym_record] = ACTIONS(5086),
    [anon_sym_namespace] = ACTIONS(5086),
    [anon_sym_var] = ACTIONS(5086),
    [sym_predefined_type] = ACTIONS(5086),
    [anon_sym_when] = ACTIONS(5086),
    [anon_sym_yield] = ACTIONS(5086),
    [anon_sym_from] = ACTIONS(5086),
    [anon_sym_join] = ACTIONS(5086),
    [anon_sym_on] = ACTIONS(5086),
    [anon_sym_equals] = ACTIONS(5086),
    [anon_sym_into] = ACTIONS(5086),
    [anon_sym_let] = ACTIONS(5086),
    [anon_sym_orderby] = ACTIONS(5086),
    [anon_sym_ascending] = ACTIONS(5086),
    [anon_sym_descending] = ACTIONS(5086),
    [anon_sym_group] = ACTIONS(5086),
    [anon_sym_by] = ACTIONS(5086),
    [anon_sym_select] = ACTIONS(5086),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5086),
    [anon_sym_nameof] = ACTIONS(5086),
    [sym_void_keyword] = ACTIONS(5086),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2603] = {
    [sym__preprocessor_call] = STATE(2603),
    [sym__identifier_token] = ACTIONS(5090),
    [anon_sym_extern] = ACTIONS(5090),
    [anon_sym_alias] = ACTIONS(5090),
    [anon_sym_global] = ACTIONS(5090),
    [anon_sym_using] = ACTIONS(5090),
    [anon_sym_static] = ACTIONS(5090),
    [anon_sym_LBRACK] = ACTIONS(5092),
    [anon_sym_event] = ACTIONS(5090),
    [anon_sym_LPAREN] = ACTIONS(5092),
    [anon_sym_abstract] = ACTIONS(5090),
    [anon_sym_async] = ACTIONS(5090),
    [anon_sym_const] = ACTIONS(5090),
    [anon_sym_fixed] = ACTIONS(5090),
    [anon_sym_internal] = ACTIONS(5090),
    [anon_sym_new] = ACTIONS(5090),
    [anon_sym_override] = ACTIONS(5090),
    [anon_sym_partial] = ACTIONS(5090),
    [anon_sym_private] = ACTIONS(5090),
    [anon_sym_protected] = ACTIONS(5090),
    [anon_sym_public] = ACTIONS(5090),
    [anon_sym_readonly] = ACTIONS(5090),
    [anon_sym_ref] = ACTIONS(5090),
    [anon_sym_sealed] = ACTIONS(5090),
    [anon_sym_unsafe] = ACTIONS(5090),
    [anon_sym_virtual] = ACTIONS(5090),
    [anon_sym_volatile] = ACTIONS(5090),
    [anon_sym_RBRACE] = ACTIONS(5092),
    [anon_sym_implicit] = ACTIONS(5090),
    [anon_sym_explicit] = ACTIONS(5090),
    [anon_sym_TILDE] = ACTIONS(5092),
    [anon_sym_where] = ACTIONS(5090),
    [anon_sym_class] = ACTIONS(5090),
    [anon_sym_struct] = ACTIONS(5090),
    [anon_sym_notnull] = ACTIONS(5090),
    [anon_sym_unmanaged] = ACTIONS(5090),
    [anon_sym_get] = ACTIONS(5090),
    [anon_sym_set] = ACTIONS(5090),
    [anon_sym_add] = ACTIONS(5090),
    [anon_sym_remove] = ACTIONS(5090),
    [anon_sym_enum] = ACTIONS(5090),
    [anon_sym_interface] = ACTIONS(5090),
    [anon_sym_delegate] = ACTIONS(5090),
    [anon_sym_record] = ACTIONS(5090),
    [anon_sym_namespace] = ACTIONS(5090),
    [anon_sym_var] = ACTIONS(5090),
    [sym_predefined_type] = ACTIONS(5090),
    [anon_sym_when] = ACTIONS(5090),
    [anon_sym_yield] = ACTIONS(5090),
    [anon_sym_from] = ACTIONS(5090),
    [anon_sym_join] = ACTIONS(5090),
    [anon_sym_on] = ACTIONS(5090),
    [anon_sym_equals] = ACTIONS(5090),
    [anon_sym_into] = ACTIONS(5090),
    [anon_sym_let] = ACTIONS(5090),
    [anon_sym_orderby] = ACTIONS(5090),
    [anon_sym_ascending] = ACTIONS(5090),
    [anon_sym_descending] = ACTIONS(5090),
    [anon_sym_group] = ACTIONS(5090),
    [anon_sym_by] = ACTIONS(5090),
    [anon_sym_select] = ACTIONS(5090),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5090),
    [anon_sym_nameof] = ACTIONS(5090),
    [sym_void_keyword] = ACTIONS(5090),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2604] = {
    [sym__preprocessor_call] = STATE(2604),
    [sym__identifier_token] = ACTIONS(5094),
    [anon_sym_extern] = ACTIONS(5094),
    [anon_sym_alias] = ACTIONS(5094),
    [anon_sym_global] = ACTIONS(5094),
    [anon_sym_using] = ACTIONS(5094),
    [anon_sym_static] = ACTIONS(5094),
    [anon_sym_LBRACK] = ACTIONS(5096),
    [anon_sym_event] = ACTIONS(5094),
    [anon_sym_LPAREN] = ACTIONS(5096),
    [anon_sym_abstract] = ACTIONS(5094),
    [anon_sym_async] = ACTIONS(5094),
    [anon_sym_const] = ACTIONS(5094),
    [anon_sym_fixed] = ACTIONS(5094),
    [anon_sym_internal] = ACTIONS(5094),
    [anon_sym_new] = ACTIONS(5094),
    [anon_sym_override] = ACTIONS(5094),
    [anon_sym_partial] = ACTIONS(5094),
    [anon_sym_private] = ACTIONS(5094),
    [anon_sym_protected] = ACTIONS(5094),
    [anon_sym_public] = ACTIONS(5094),
    [anon_sym_readonly] = ACTIONS(5094),
    [anon_sym_ref] = ACTIONS(5094),
    [anon_sym_sealed] = ACTIONS(5094),
    [anon_sym_unsafe] = ACTIONS(5094),
    [anon_sym_virtual] = ACTIONS(5094),
    [anon_sym_volatile] = ACTIONS(5094),
    [anon_sym_RBRACE] = ACTIONS(5096),
    [anon_sym_implicit] = ACTIONS(5094),
    [anon_sym_explicit] = ACTIONS(5094),
    [anon_sym_TILDE] = ACTIONS(5096),
    [anon_sym_where] = ACTIONS(5094),
    [anon_sym_class] = ACTIONS(5094),
    [anon_sym_struct] = ACTIONS(5094),
    [anon_sym_notnull] = ACTIONS(5094),
    [anon_sym_unmanaged] = ACTIONS(5094),
    [anon_sym_get] = ACTIONS(5094),
    [anon_sym_set] = ACTIONS(5094),
    [anon_sym_add] = ACTIONS(5094),
    [anon_sym_remove] = ACTIONS(5094),
    [anon_sym_enum] = ACTIONS(5094),
    [anon_sym_interface] = ACTIONS(5094),
    [anon_sym_delegate] = ACTIONS(5094),
    [anon_sym_record] = ACTIONS(5094),
    [anon_sym_namespace] = ACTIONS(5094),
    [anon_sym_var] = ACTIONS(5094),
    [sym_predefined_type] = ACTIONS(5094),
    [anon_sym_when] = ACTIONS(5094),
    [anon_sym_yield] = ACTIONS(5094),
    [anon_sym_from] = ACTIONS(5094),
    [anon_sym_join] = ACTIONS(5094),
    [anon_sym_on] = ACTIONS(5094),
    [anon_sym_equals] = ACTIONS(5094),
    [anon_sym_into] = ACTIONS(5094),
    [anon_sym_let] = ACTIONS(5094),
    [anon_sym_orderby] = ACTIONS(5094),
    [anon_sym_ascending] = ACTIONS(5094),
    [anon_sym_descending] = ACTIONS(5094),
    [anon_sym_group] = ACTIONS(5094),
    [anon_sym_by] = ACTIONS(5094),
    [anon_sym_select] = ACTIONS(5094),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5094),
    [anon_sym_nameof] = ACTIONS(5094),
    [sym_void_keyword] = ACTIONS(5094),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2605] = {
    [sym__preprocessor_call] = STATE(2605),
    [sym__identifier_token] = ACTIONS(5098),
    [anon_sym_extern] = ACTIONS(5098),
    [anon_sym_alias] = ACTIONS(5098),
    [anon_sym_global] = ACTIONS(5098),
    [anon_sym_using] = ACTIONS(5098),
    [anon_sym_static] = ACTIONS(5098),
    [anon_sym_LBRACK] = ACTIONS(5100),
    [anon_sym_event] = ACTIONS(5098),
    [anon_sym_LPAREN] = ACTIONS(5100),
    [anon_sym_abstract] = ACTIONS(5098),
    [anon_sym_async] = ACTIONS(5098),
    [anon_sym_const] = ACTIONS(5098),
    [anon_sym_fixed] = ACTIONS(5098),
    [anon_sym_internal] = ACTIONS(5098),
    [anon_sym_new] = ACTIONS(5098),
    [anon_sym_override] = ACTIONS(5098),
    [anon_sym_partial] = ACTIONS(5098),
    [anon_sym_private] = ACTIONS(5098),
    [anon_sym_protected] = ACTIONS(5098),
    [anon_sym_public] = ACTIONS(5098),
    [anon_sym_readonly] = ACTIONS(5098),
    [anon_sym_ref] = ACTIONS(5098),
    [anon_sym_sealed] = ACTIONS(5098),
    [anon_sym_unsafe] = ACTIONS(5098),
    [anon_sym_virtual] = ACTIONS(5098),
    [anon_sym_volatile] = ACTIONS(5098),
    [anon_sym_RBRACE] = ACTIONS(5100),
    [anon_sym_implicit] = ACTIONS(5098),
    [anon_sym_explicit] = ACTIONS(5098),
    [anon_sym_TILDE] = ACTIONS(5100),
    [anon_sym_where] = ACTIONS(5098),
    [anon_sym_class] = ACTIONS(5098),
    [anon_sym_struct] = ACTIONS(5098),
    [anon_sym_notnull] = ACTIONS(5098),
    [anon_sym_unmanaged] = ACTIONS(5098),
    [anon_sym_get] = ACTIONS(5098),
    [anon_sym_set] = ACTIONS(5098),
    [anon_sym_add] = ACTIONS(5098),
    [anon_sym_remove] = ACTIONS(5098),
    [anon_sym_enum] = ACTIONS(5098),
    [anon_sym_interface] = ACTIONS(5098),
    [anon_sym_delegate] = ACTIONS(5098),
    [anon_sym_record] = ACTIONS(5098),
    [anon_sym_namespace] = ACTIONS(5098),
    [anon_sym_var] = ACTIONS(5098),
    [sym_predefined_type] = ACTIONS(5098),
    [anon_sym_when] = ACTIONS(5098),
    [anon_sym_yield] = ACTIONS(5098),
    [anon_sym_from] = ACTIONS(5098),
    [anon_sym_join] = ACTIONS(5098),
    [anon_sym_on] = ACTIONS(5098),
    [anon_sym_equals] = ACTIONS(5098),
    [anon_sym_into] = ACTIONS(5098),
    [anon_sym_let] = ACTIONS(5098),
    [anon_sym_orderby] = ACTIONS(5098),
    [anon_sym_ascending] = ACTIONS(5098),
    [anon_sym_descending] = ACTIONS(5098),
    [anon_sym_group] = ACTIONS(5098),
    [anon_sym_by] = ACTIONS(5098),
    [anon_sym_select] = ACTIONS(5098),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5098),
    [anon_sym_nameof] = ACTIONS(5098),
    [sym_void_keyword] = ACTIONS(5098),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2606] = {
    [sym__preprocessor_call] = STATE(2606),
    [sym__identifier_token] = ACTIONS(5102),
    [anon_sym_extern] = ACTIONS(5102),
    [anon_sym_alias] = ACTIONS(5102),
    [anon_sym_global] = ACTIONS(5102),
    [anon_sym_using] = ACTIONS(5102),
    [anon_sym_static] = ACTIONS(5102),
    [anon_sym_LBRACK] = ACTIONS(5104),
    [anon_sym_event] = ACTIONS(5102),
    [anon_sym_LPAREN] = ACTIONS(5104),
    [anon_sym_abstract] = ACTIONS(5102),
    [anon_sym_async] = ACTIONS(5102),
    [anon_sym_const] = ACTIONS(5102),
    [anon_sym_fixed] = ACTIONS(5102),
    [anon_sym_internal] = ACTIONS(5102),
    [anon_sym_new] = ACTIONS(5102),
    [anon_sym_override] = ACTIONS(5102),
    [anon_sym_partial] = ACTIONS(5102),
    [anon_sym_private] = ACTIONS(5102),
    [anon_sym_protected] = ACTIONS(5102),
    [anon_sym_public] = ACTIONS(5102),
    [anon_sym_readonly] = ACTIONS(5102),
    [anon_sym_ref] = ACTIONS(5102),
    [anon_sym_sealed] = ACTIONS(5102),
    [anon_sym_unsafe] = ACTIONS(5102),
    [anon_sym_virtual] = ACTIONS(5102),
    [anon_sym_volatile] = ACTIONS(5102),
    [anon_sym_RBRACE] = ACTIONS(5104),
    [anon_sym_implicit] = ACTIONS(5102),
    [anon_sym_explicit] = ACTIONS(5102),
    [anon_sym_TILDE] = ACTIONS(5104),
    [anon_sym_where] = ACTIONS(5102),
    [anon_sym_class] = ACTIONS(5102),
    [anon_sym_struct] = ACTIONS(5102),
    [anon_sym_notnull] = ACTIONS(5102),
    [anon_sym_unmanaged] = ACTIONS(5102),
    [anon_sym_get] = ACTIONS(5102),
    [anon_sym_set] = ACTIONS(5102),
    [anon_sym_add] = ACTIONS(5102),
    [anon_sym_remove] = ACTIONS(5102),
    [anon_sym_enum] = ACTIONS(5102),
    [anon_sym_interface] = ACTIONS(5102),
    [anon_sym_delegate] = ACTIONS(5102),
    [anon_sym_record] = ACTIONS(5102),
    [anon_sym_namespace] = ACTIONS(5102),
    [anon_sym_var] = ACTIONS(5102),
    [sym_predefined_type] = ACTIONS(5102),
    [anon_sym_when] = ACTIONS(5102),
    [anon_sym_yield] = ACTIONS(5102),
    [anon_sym_from] = ACTIONS(5102),
    [anon_sym_join] = ACTIONS(5102),
    [anon_sym_on] = ACTIONS(5102),
    [anon_sym_equals] = ACTIONS(5102),
    [anon_sym_into] = ACTIONS(5102),
    [anon_sym_let] = ACTIONS(5102),
    [anon_sym_orderby] = ACTIONS(5102),
    [anon_sym_ascending] = ACTIONS(5102),
    [anon_sym_descending] = ACTIONS(5102),
    [anon_sym_group] = ACTIONS(5102),
    [anon_sym_by] = ACTIONS(5102),
    [anon_sym_select] = ACTIONS(5102),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5102),
    [anon_sym_nameof] = ACTIONS(5102),
    [sym_void_keyword] = ACTIONS(5102),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2607] = {
    [sym__preprocessor_call] = STATE(2607),
    [sym__identifier_token] = ACTIONS(5106),
    [anon_sym_extern] = ACTIONS(5106),
    [anon_sym_alias] = ACTIONS(5106),
    [anon_sym_global] = ACTIONS(5106),
    [anon_sym_using] = ACTIONS(5106),
    [anon_sym_static] = ACTIONS(5106),
    [anon_sym_LBRACK] = ACTIONS(5108),
    [anon_sym_event] = ACTIONS(5106),
    [anon_sym_LPAREN] = ACTIONS(5108),
    [anon_sym_abstract] = ACTIONS(5106),
    [anon_sym_async] = ACTIONS(5106),
    [anon_sym_const] = ACTIONS(5106),
    [anon_sym_fixed] = ACTIONS(5106),
    [anon_sym_internal] = ACTIONS(5106),
    [anon_sym_new] = ACTIONS(5106),
    [anon_sym_override] = ACTIONS(5106),
    [anon_sym_partial] = ACTIONS(5106),
    [anon_sym_private] = ACTIONS(5106),
    [anon_sym_protected] = ACTIONS(5106),
    [anon_sym_public] = ACTIONS(5106),
    [anon_sym_readonly] = ACTIONS(5106),
    [anon_sym_ref] = ACTIONS(5106),
    [anon_sym_sealed] = ACTIONS(5106),
    [anon_sym_unsafe] = ACTIONS(5106),
    [anon_sym_virtual] = ACTIONS(5106),
    [anon_sym_volatile] = ACTIONS(5106),
    [anon_sym_RBRACE] = ACTIONS(5108),
    [anon_sym_implicit] = ACTIONS(5106),
    [anon_sym_explicit] = ACTIONS(5106),
    [anon_sym_TILDE] = ACTIONS(5108),
    [anon_sym_where] = ACTIONS(5106),
    [anon_sym_class] = ACTIONS(5106),
    [anon_sym_struct] = ACTIONS(5106),
    [anon_sym_notnull] = ACTIONS(5106),
    [anon_sym_unmanaged] = ACTIONS(5106),
    [anon_sym_get] = ACTIONS(5106),
    [anon_sym_set] = ACTIONS(5106),
    [anon_sym_add] = ACTIONS(5106),
    [anon_sym_remove] = ACTIONS(5106),
    [anon_sym_enum] = ACTIONS(5106),
    [anon_sym_interface] = ACTIONS(5106),
    [anon_sym_delegate] = ACTIONS(5106),
    [anon_sym_record] = ACTIONS(5106),
    [anon_sym_namespace] = ACTIONS(5106),
    [anon_sym_var] = ACTIONS(5106),
    [sym_predefined_type] = ACTIONS(5106),
    [anon_sym_when] = ACTIONS(5106),
    [anon_sym_yield] = ACTIONS(5106),
    [anon_sym_from] = ACTIONS(5106),
    [anon_sym_join] = ACTIONS(5106),
    [anon_sym_on] = ACTIONS(5106),
    [anon_sym_equals] = ACTIONS(5106),
    [anon_sym_into] = ACTIONS(5106),
    [anon_sym_let] = ACTIONS(5106),
    [anon_sym_orderby] = ACTIONS(5106),
    [anon_sym_ascending] = ACTIONS(5106),
    [anon_sym_descending] = ACTIONS(5106),
    [anon_sym_group] = ACTIONS(5106),
    [anon_sym_by] = ACTIONS(5106),
    [anon_sym_select] = ACTIONS(5106),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5106),
    [anon_sym_nameof] = ACTIONS(5106),
    [sym_void_keyword] = ACTIONS(5106),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2608] = {
    [sym__preprocessor_call] = STATE(2608),
    [sym__identifier_token] = ACTIONS(5110),
    [anon_sym_extern] = ACTIONS(5110),
    [anon_sym_alias] = ACTIONS(5110),
    [anon_sym_global] = ACTIONS(5110),
    [anon_sym_using] = ACTIONS(5110),
    [anon_sym_static] = ACTIONS(5110),
    [anon_sym_LBRACK] = ACTIONS(5112),
    [anon_sym_event] = ACTIONS(5110),
    [anon_sym_LPAREN] = ACTIONS(5112),
    [anon_sym_abstract] = ACTIONS(5110),
    [anon_sym_async] = ACTIONS(5110),
    [anon_sym_const] = ACTIONS(5110),
    [anon_sym_fixed] = ACTIONS(5110),
    [anon_sym_internal] = ACTIONS(5110),
    [anon_sym_new] = ACTIONS(5110),
    [anon_sym_override] = ACTIONS(5110),
    [anon_sym_partial] = ACTIONS(5110),
    [anon_sym_private] = ACTIONS(5110),
    [anon_sym_protected] = ACTIONS(5110),
    [anon_sym_public] = ACTIONS(5110),
    [anon_sym_readonly] = ACTIONS(5110),
    [anon_sym_ref] = ACTIONS(5110),
    [anon_sym_sealed] = ACTIONS(5110),
    [anon_sym_unsafe] = ACTIONS(5110),
    [anon_sym_virtual] = ACTIONS(5110),
    [anon_sym_volatile] = ACTIONS(5110),
    [anon_sym_RBRACE] = ACTIONS(5112),
    [anon_sym_implicit] = ACTIONS(5110),
    [anon_sym_explicit] = ACTIONS(5110),
    [anon_sym_TILDE] = ACTIONS(5112),
    [anon_sym_where] = ACTIONS(5110),
    [anon_sym_class] = ACTIONS(5110),
    [anon_sym_struct] = ACTIONS(5110),
    [anon_sym_notnull] = ACTIONS(5110),
    [anon_sym_unmanaged] = ACTIONS(5110),
    [anon_sym_get] = ACTIONS(5110),
    [anon_sym_set] = ACTIONS(5110),
    [anon_sym_add] = ACTIONS(5110),
    [anon_sym_remove] = ACTIONS(5110),
    [anon_sym_enum] = ACTIONS(5110),
    [anon_sym_interface] = ACTIONS(5110),
    [anon_sym_delegate] = ACTIONS(5110),
    [anon_sym_record] = ACTIONS(5110),
    [anon_sym_namespace] = ACTIONS(5110),
    [anon_sym_var] = ACTIONS(5110),
    [sym_predefined_type] = ACTIONS(5110),
    [anon_sym_when] = ACTIONS(5110),
    [anon_sym_yield] = ACTIONS(5110),
    [anon_sym_from] = ACTIONS(5110),
    [anon_sym_join] = ACTIONS(5110),
    [anon_sym_on] = ACTIONS(5110),
    [anon_sym_equals] = ACTIONS(5110),
    [anon_sym_into] = ACTIONS(5110),
    [anon_sym_let] = ACTIONS(5110),
    [anon_sym_orderby] = ACTIONS(5110),
    [anon_sym_ascending] = ACTIONS(5110),
    [anon_sym_descending] = ACTIONS(5110),
    [anon_sym_group] = ACTIONS(5110),
    [anon_sym_by] = ACTIONS(5110),
    [anon_sym_select] = ACTIONS(5110),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5110),
    [anon_sym_nameof] = ACTIONS(5110),
    [sym_void_keyword] = ACTIONS(5110),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2609] = {
    [sym__preprocessor_call] = STATE(2609),
    [sym__identifier_token] = ACTIONS(5114),
    [anon_sym_extern] = ACTIONS(5114),
    [anon_sym_alias] = ACTIONS(5114),
    [anon_sym_global] = ACTIONS(5114),
    [anon_sym_using] = ACTIONS(5114),
    [anon_sym_static] = ACTIONS(5114),
    [anon_sym_LBRACK] = ACTIONS(5116),
    [anon_sym_event] = ACTIONS(5114),
    [anon_sym_LPAREN] = ACTIONS(5116),
    [anon_sym_abstract] = ACTIONS(5114),
    [anon_sym_async] = ACTIONS(5114),
    [anon_sym_const] = ACTIONS(5114),
    [anon_sym_fixed] = ACTIONS(5114),
    [anon_sym_internal] = ACTIONS(5114),
    [anon_sym_new] = ACTIONS(5114),
    [anon_sym_override] = ACTIONS(5114),
    [anon_sym_partial] = ACTIONS(5114),
    [anon_sym_private] = ACTIONS(5114),
    [anon_sym_protected] = ACTIONS(5114),
    [anon_sym_public] = ACTIONS(5114),
    [anon_sym_readonly] = ACTIONS(5114),
    [anon_sym_ref] = ACTIONS(5114),
    [anon_sym_sealed] = ACTIONS(5114),
    [anon_sym_unsafe] = ACTIONS(5114),
    [anon_sym_virtual] = ACTIONS(5114),
    [anon_sym_volatile] = ACTIONS(5114),
    [anon_sym_RBRACE] = ACTIONS(5116),
    [anon_sym_implicit] = ACTIONS(5114),
    [anon_sym_explicit] = ACTIONS(5114),
    [anon_sym_TILDE] = ACTIONS(5116),
    [anon_sym_where] = ACTIONS(5114),
    [anon_sym_class] = ACTIONS(5114),
    [anon_sym_struct] = ACTIONS(5114),
    [anon_sym_notnull] = ACTIONS(5114),
    [anon_sym_unmanaged] = ACTIONS(5114),
    [anon_sym_get] = ACTIONS(5114),
    [anon_sym_set] = ACTIONS(5114),
    [anon_sym_add] = ACTIONS(5114),
    [anon_sym_remove] = ACTIONS(5114),
    [anon_sym_enum] = ACTIONS(5114),
    [anon_sym_interface] = ACTIONS(5114),
    [anon_sym_delegate] = ACTIONS(5114),
    [anon_sym_record] = ACTIONS(5114),
    [anon_sym_namespace] = ACTIONS(5114),
    [anon_sym_var] = ACTIONS(5114),
    [sym_predefined_type] = ACTIONS(5114),
    [anon_sym_when] = ACTIONS(5114),
    [anon_sym_yield] = ACTIONS(5114),
    [anon_sym_from] = ACTIONS(5114),
    [anon_sym_join] = ACTIONS(5114),
    [anon_sym_on] = ACTIONS(5114),
    [anon_sym_equals] = ACTIONS(5114),
    [anon_sym_into] = ACTIONS(5114),
    [anon_sym_let] = ACTIONS(5114),
    [anon_sym_orderby] = ACTIONS(5114),
    [anon_sym_ascending] = ACTIONS(5114),
    [anon_sym_descending] = ACTIONS(5114),
    [anon_sym_group] = ACTIONS(5114),
    [anon_sym_by] = ACTIONS(5114),
    [anon_sym_select] = ACTIONS(5114),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5114),
    [anon_sym_nameof] = ACTIONS(5114),
    [sym_void_keyword] = ACTIONS(5114),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2610] = {
    [sym__preprocessor_call] = STATE(2610),
    [sym__identifier_token] = ACTIONS(5118),
    [anon_sym_extern] = ACTIONS(5118),
    [anon_sym_alias] = ACTIONS(5118),
    [anon_sym_global] = ACTIONS(5118),
    [anon_sym_using] = ACTIONS(5118),
    [anon_sym_static] = ACTIONS(5118),
    [anon_sym_LBRACK] = ACTIONS(5120),
    [anon_sym_event] = ACTIONS(5118),
    [anon_sym_LPAREN] = ACTIONS(5120),
    [anon_sym_abstract] = ACTIONS(5118),
    [anon_sym_async] = ACTIONS(5118),
    [anon_sym_const] = ACTIONS(5118),
    [anon_sym_fixed] = ACTIONS(5118),
    [anon_sym_internal] = ACTIONS(5118),
    [anon_sym_new] = ACTIONS(5118),
    [anon_sym_override] = ACTIONS(5118),
    [anon_sym_partial] = ACTIONS(5118),
    [anon_sym_private] = ACTIONS(5118),
    [anon_sym_protected] = ACTIONS(5118),
    [anon_sym_public] = ACTIONS(5118),
    [anon_sym_readonly] = ACTIONS(5118),
    [anon_sym_ref] = ACTIONS(5118),
    [anon_sym_sealed] = ACTIONS(5118),
    [anon_sym_unsafe] = ACTIONS(5118),
    [anon_sym_virtual] = ACTIONS(5118),
    [anon_sym_volatile] = ACTIONS(5118),
    [anon_sym_RBRACE] = ACTIONS(5120),
    [anon_sym_implicit] = ACTIONS(5118),
    [anon_sym_explicit] = ACTIONS(5118),
    [anon_sym_TILDE] = ACTIONS(5120),
    [anon_sym_where] = ACTIONS(5118),
    [anon_sym_class] = ACTIONS(5118),
    [anon_sym_struct] = ACTIONS(5118),
    [anon_sym_notnull] = ACTIONS(5118),
    [anon_sym_unmanaged] = ACTIONS(5118),
    [anon_sym_get] = ACTIONS(5118),
    [anon_sym_set] = ACTIONS(5118),
    [anon_sym_add] = ACTIONS(5118),
    [anon_sym_remove] = ACTIONS(5118),
    [anon_sym_enum] = ACTIONS(5118),
    [anon_sym_interface] = ACTIONS(5118),
    [anon_sym_delegate] = ACTIONS(5118),
    [anon_sym_record] = ACTIONS(5118),
    [anon_sym_namespace] = ACTIONS(5118),
    [anon_sym_var] = ACTIONS(5118),
    [sym_predefined_type] = ACTIONS(5118),
    [anon_sym_when] = ACTIONS(5118),
    [anon_sym_yield] = ACTIONS(5118),
    [anon_sym_from] = ACTIONS(5118),
    [anon_sym_join] = ACTIONS(5118),
    [anon_sym_on] = ACTIONS(5118),
    [anon_sym_equals] = ACTIONS(5118),
    [anon_sym_into] = ACTIONS(5118),
    [anon_sym_let] = ACTIONS(5118),
    [anon_sym_orderby] = ACTIONS(5118),
    [anon_sym_ascending] = ACTIONS(5118),
    [anon_sym_descending] = ACTIONS(5118),
    [anon_sym_group] = ACTIONS(5118),
    [anon_sym_by] = ACTIONS(5118),
    [anon_sym_select] = ACTIONS(5118),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5118),
    [anon_sym_nameof] = ACTIONS(5118),
    [sym_void_keyword] = ACTIONS(5118),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2611] = {
    [sym__preprocessor_call] = STATE(2611),
    [sym__identifier_token] = ACTIONS(5122),
    [anon_sym_extern] = ACTIONS(5122),
    [anon_sym_alias] = ACTIONS(5122),
    [anon_sym_global] = ACTIONS(5122),
    [anon_sym_using] = ACTIONS(5122),
    [anon_sym_static] = ACTIONS(5122),
    [anon_sym_LBRACK] = ACTIONS(5124),
    [anon_sym_event] = ACTIONS(5122),
    [anon_sym_LPAREN] = ACTIONS(5124),
    [anon_sym_abstract] = ACTIONS(5122),
    [anon_sym_async] = ACTIONS(5122),
    [anon_sym_const] = ACTIONS(5122),
    [anon_sym_fixed] = ACTIONS(5122),
    [anon_sym_internal] = ACTIONS(5122),
    [anon_sym_new] = ACTIONS(5122),
    [anon_sym_override] = ACTIONS(5122),
    [anon_sym_partial] = ACTIONS(5122),
    [anon_sym_private] = ACTIONS(5122),
    [anon_sym_protected] = ACTIONS(5122),
    [anon_sym_public] = ACTIONS(5122),
    [anon_sym_readonly] = ACTIONS(5122),
    [anon_sym_ref] = ACTIONS(5122),
    [anon_sym_sealed] = ACTIONS(5122),
    [anon_sym_unsafe] = ACTIONS(5122),
    [anon_sym_virtual] = ACTIONS(5122),
    [anon_sym_volatile] = ACTIONS(5122),
    [anon_sym_RBRACE] = ACTIONS(5124),
    [anon_sym_implicit] = ACTIONS(5122),
    [anon_sym_explicit] = ACTIONS(5122),
    [anon_sym_TILDE] = ACTIONS(5124),
    [anon_sym_where] = ACTIONS(5122),
    [anon_sym_class] = ACTIONS(5122),
    [anon_sym_struct] = ACTIONS(5122),
    [anon_sym_notnull] = ACTIONS(5122),
    [anon_sym_unmanaged] = ACTIONS(5122),
    [anon_sym_get] = ACTIONS(5122),
    [anon_sym_set] = ACTIONS(5122),
    [anon_sym_add] = ACTIONS(5122),
    [anon_sym_remove] = ACTIONS(5122),
    [anon_sym_enum] = ACTIONS(5122),
    [anon_sym_interface] = ACTIONS(5122),
    [anon_sym_delegate] = ACTIONS(5122),
    [anon_sym_record] = ACTIONS(5122),
    [anon_sym_namespace] = ACTIONS(5122),
    [anon_sym_var] = ACTIONS(5122),
    [sym_predefined_type] = ACTIONS(5122),
    [anon_sym_when] = ACTIONS(5122),
    [anon_sym_yield] = ACTIONS(5122),
    [anon_sym_from] = ACTIONS(5122),
    [anon_sym_join] = ACTIONS(5122),
    [anon_sym_on] = ACTIONS(5122),
    [anon_sym_equals] = ACTIONS(5122),
    [anon_sym_into] = ACTIONS(5122),
    [anon_sym_let] = ACTIONS(5122),
    [anon_sym_orderby] = ACTIONS(5122),
    [anon_sym_ascending] = ACTIONS(5122),
    [anon_sym_descending] = ACTIONS(5122),
    [anon_sym_group] = ACTIONS(5122),
    [anon_sym_by] = ACTIONS(5122),
    [anon_sym_select] = ACTIONS(5122),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5122),
    [anon_sym_nameof] = ACTIONS(5122),
    [sym_void_keyword] = ACTIONS(5122),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2612] = {
    [sym__preprocessor_call] = STATE(2612),
    [sym__identifier_token] = ACTIONS(5126),
    [anon_sym_extern] = ACTIONS(5126),
    [anon_sym_alias] = ACTIONS(5126),
    [anon_sym_global] = ACTIONS(5126),
    [anon_sym_using] = ACTIONS(5126),
    [anon_sym_static] = ACTIONS(5126),
    [anon_sym_LBRACK] = ACTIONS(5128),
    [anon_sym_event] = ACTIONS(5126),
    [anon_sym_LPAREN] = ACTIONS(5128),
    [anon_sym_abstract] = ACTIONS(5126),
    [anon_sym_async] = ACTIONS(5126),
    [anon_sym_const] = ACTIONS(5126),
    [anon_sym_fixed] = ACTIONS(5126),
    [anon_sym_internal] = ACTIONS(5126),
    [anon_sym_new] = ACTIONS(5126),
    [anon_sym_override] = ACTIONS(5126),
    [anon_sym_partial] = ACTIONS(5126),
    [anon_sym_private] = ACTIONS(5126),
    [anon_sym_protected] = ACTIONS(5126),
    [anon_sym_public] = ACTIONS(5126),
    [anon_sym_readonly] = ACTIONS(5126),
    [anon_sym_ref] = ACTIONS(5126),
    [anon_sym_sealed] = ACTIONS(5126),
    [anon_sym_unsafe] = ACTIONS(5126),
    [anon_sym_virtual] = ACTIONS(5126),
    [anon_sym_volatile] = ACTIONS(5126),
    [anon_sym_RBRACE] = ACTIONS(5128),
    [anon_sym_implicit] = ACTIONS(5126),
    [anon_sym_explicit] = ACTIONS(5126),
    [anon_sym_TILDE] = ACTIONS(5128),
    [anon_sym_where] = ACTIONS(5126),
    [anon_sym_class] = ACTIONS(5126),
    [anon_sym_struct] = ACTIONS(5126),
    [anon_sym_notnull] = ACTIONS(5126),
    [anon_sym_unmanaged] = ACTIONS(5126),
    [anon_sym_get] = ACTIONS(5126),
    [anon_sym_set] = ACTIONS(5126),
    [anon_sym_add] = ACTIONS(5126),
    [anon_sym_remove] = ACTIONS(5126),
    [anon_sym_enum] = ACTIONS(5126),
    [anon_sym_interface] = ACTIONS(5126),
    [anon_sym_delegate] = ACTIONS(5126),
    [anon_sym_record] = ACTIONS(5126),
    [anon_sym_namespace] = ACTIONS(5126),
    [anon_sym_var] = ACTIONS(5126),
    [sym_predefined_type] = ACTIONS(5126),
    [anon_sym_when] = ACTIONS(5126),
    [anon_sym_yield] = ACTIONS(5126),
    [anon_sym_from] = ACTIONS(5126),
    [anon_sym_join] = ACTIONS(5126),
    [anon_sym_on] = ACTIONS(5126),
    [anon_sym_equals] = ACTIONS(5126),
    [anon_sym_into] = ACTIONS(5126),
    [anon_sym_let] = ACTIONS(5126),
    [anon_sym_orderby] = ACTIONS(5126),
    [anon_sym_ascending] = ACTIONS(5126),
    [anon_sym_descending] = ACTIONS(5126),
    [anon_sym_group] = ACTIONS(5126),
    [anon_sym_by] = ACTIONS(5126),
    [anon_sym_select] = ACTIONS(5126),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5126),
    [anon_sym_nameof] = ACTIONS(5126),
    [sym_void_keyword] = ACTIONS(5126),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2613] = {
    [sym__preprocessor_call] = STATE(2613),
    [sym__identifier_token] = ACTIONS(2581),
    [anon_sym_extern] = ACTIONS(2581),
    [anon_sym_alias] = ACTIONS(2581),
    [anon_sym_global] = ACTIONS(2581),
    [anon_sym_using] = ACTIONS(2581),
    [anon_sym_static] = ACTIONS(2581),
    [anon_sym_LBRACK] = ACTIONS(2579),
    [anon_sym_event] = ACTIONS(2581),
    [anon_sym_LPAREN] = ACTIONS(2579),
    [anon_sym_abstract] = ACTIONS(2581),
    [anon_sym_async] = ACTIONS(2581),
    [anon_sym_const] = ACTIONS(2581),
    [anon_sym_fixed] = ACTIONS(2581),
    [anon_sym_internal] = ACTIONS(2581),
    [anon_sym_new] = ACTIONS(2581),
    [anon_sym_override] = ACTIONS(2581),
    [anon_sym_partial] = ACTIONS(2581),
    [anon_sym_private] = ACTIONS(2581),
    [anon_sym_protected] = ACTIONS(2581),
    [anon_sym_public] = ACTIONS(2581),
    [anon_sym_readonly] = ACTIONS(2581),
    [anon_sym_ref] = ACTIONS(2581),
    [anon_sym_sealed] = ACTIONS(2581),
    [anon_sym_unsafe] = ACTIONS(2581),
    [anon_sym_virtual] = ACTIONS(2581),
    [anon_sym_volatile] = ACTIONS(2581),
    [anon_sym_RBRACE] = ACTIONS(2579),
    [anon_sym_implicit] = ACTIONS(2581),
    [anon_sym_explicit] = ACTIONS(2581),
    [anon_sym_TILDE] = ACTIONS(2579),
    [anon_sym_where] = ACTIONS(2581),
    [anon_sym_class] = ACTIONS(2581),
    [anon_sym_struct] = ACTIONS(2581),
    [anon_sym_notnull] = ACTIONS(2581),
    [anon_sym_unmanaged] = ACTIONS(2581),
    [anon_sym_get] = ACTIONS(2581),
    [anon_sym_set] = ACTIONS(2581),
    [anon_sym_add] = ACTIONS(2581),
    [anon_sym_remove] = ACTIONS(2581),
    [anon_sym_enum] = ACTIONS(2581),
    [anon_sym_interface] = ACTIONS(2581),
    [anon_sym_delegate] = ACTIONS(2581),
    [anon_sym_record] = ACTIONS(2581),
    [anon_sym_namespace] = ACTIONS(2581),
    [anon_sym_var] = ACTIONS(2581),
    [sym_predefined_type] = ACTIONS(2581),
    [anon_sym_when] = ACTIONS(2581),
    [anon_sym_yield] = ACTIONS(2581),
    [anon_sym_from] = ACTIONS(2581),
    [anon_sym_join] = ACTIONS(2581),
    [anon_sym_on] = ACTIONS(2581),
    [anon_sym_equals] = ACTIONS(2581),
    [anon_sym_into] = ACTIONS(2581),
    [anon_sym_let] = ACTIONS(2581),
    [anon_sym_orderby] = ACTIONS(2581),
    [anon_sym_ascending] = ACTIONS(2581),
    [anon_sym_descending] = ACTIONS(2581),
    [anon_sym_group] = ACTIONS(2581),
    [anon_sym_by] = ACTIONS(2581),
    [anon_sym_select] = ACTIONS(2581),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(2581),
    [anon_sym_nameof] = ACTIONS(2581),
    [sym_void_keyword] = ACTIONS(2581),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2614] = {
    [sym__preprocessor_call] = STATE(2614),
    [sym__identifier_token] = ACTIONS(5130),
    [anon_sym_extern] = ACTIONS(5130),
    [anon_sym_alias] = ACTIONS(5130),
    [anon_sym_global] = ACTIONS(5130),
    [anon_sym_using] = ACTIONS(5130),
    [anon_sym_static] = ACTIONS(5130),
    [anon_sym_LBRACK] = ACTIONS(5132),
    [anon_sym_event] = ACTIONS(5130),
    [anon_sym_LPAREN] = ACTIONS(5132),
    [anon_sym_abstract] = ACTIONS(5130),
    [anon_sym_async] = ACTIONS(5130),
    [anon_sym_const] = ACTIONS(5130),
    [anon_sym_fixed] = ACTIONS(5130),
    [anon_sym_internal] = ACTIONS(5130),
    [anon_sym_new] = ACTIONS(5130),
    [anon_sym_override] = ACTIONS(5130),
    [anon_sym_partial] = ACTIONS(5130),
    [anon_sym_private] = ACTIONS(5130),
    [anon_sym_protected] = ACTIONS(5130),
    [anon_sym_public] = ACTIONS(5130),
    [anon_sym_readonly] = ACTIONS(5130),
    [anon_sym_ref] = ACTIONS(5130),
    [anon_sym_sealed] = ACTIONS(5130),
    [anon_sym_unsafe] = ACTIONS(5130),
    [anon_sym_virtual] = ACTIONS(5130),
    [anon_sym_volatile] = ACTIONS(5130),
    [anon_sym_RBRACE] = ACTIONS(5132),
    [anon_sym_implicit] = ACTIONS(5130),
    [anon_sym_explicit] = ACTIONS(5130),
    [anon_sym_TILDE] = ACTIONS(5132),
    [anon_sym_where] = ACTIONS(5130),
    [anon_sym_class] = ACTIONS(5130),
    [anon_sym_struct] = ACTIONS(5130),
    [anon_sym_notnull] = ACTIONS(5130),
    [anon_sym_unmanaged] = ACTIONS(5130),
    [anon_sym_get] = ACTIONS(5130),
    [anon_sym_set] = ACTIONS(5130),
    [anon_sym_add] = ACTIONS(5130),
    [anon_sym_remove] = ACTIONS(5130),
    [anon_sym_enum] = ACTIONS(5130),
    [anon_sym_interface] = ACTIONS(5130),
    [anon_sym_delegate] = ACTIONS(5130),
    [anon_sym_record] = ACTIONS(5130),
    [anon_sym_namespace] = ACTIONS(5130),
    [anon_sym_var] = ACTIONS(5130),
    [sym_predefined_type] = ACTIONS(5130),
    [anon_sym_when] = ACTIONS(5130),
    [anon_sym_yield] = ACTIONS(5130),
    [anon_sym_from] = ACTIONS(5130),
    [anon_sym_join] = ACTIONS(5130),
    [anon_sym_on] = ACTIONS(5130),
    [anon_sym_equals] = ACTIONS(5130),
    [anon_sym_into] = ACTIONS(5130),
    [anon_sym_let] = ACTIONS(5130),
    [anon_sym_orderby] = ACTIONS(5130),
    [anon_sym_ascending] = ACTIONS(5130),
    [anon_sym_descending] = ACTIONS(5130),
    [anon_sym_group] = ACTIONS(5130),
    [anon_sym_by] = ACTIONS(5130),
    [anon_sym_select] = ACTIONS(5130),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5130),
    [anon_sym_nameof] = ACTIONS(5130),
    [sym_void_keyword] = ACTIONS(5130),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2615] = {
    [sym__preprocessor_call] = STATE(2615),
    [sym__identifier_token] = ACTIONS(5134),
    [anon_sym_extern] = ACTIONS(5134),
    [anon_sym_alias] = ACTIONS(5134),
    [anon_sym_global] = ACTIONS(5134),
    [anon_sym_using] = ACTIONS(5134),
    [anon_sym_static] = ACTIONS(5134),
    [anon_sym_LBRACK] = ACTIONS(5136),
    [anon_sym_event] = ACTIONS(5134),
    [anon_sym_LPAREN] = ACTIONS(5136),
    [anon_sym_abstract] = ACTIONS(5134),
    [anon_sym_async] = ACTIONS(5134),
    [anon_sym_const] = ACTIONS(5134),
    [anon_sym_fixed] = ACTIONS(5134),
    [anon_sym_internal] = ACTIONS(5134),
    [anon_sym_new] = ACTIONS(5134),
    [anon_sym_override] = ACTIONS(5134),
    [anon_sym_partial] = ACTIONS(5134),
    [anon_sym_private] = ACTIONS(5134),
    [anon_sym_protected] = ACTIONS(5134),
    [anon_sym_public] = ACTIONS(5134),
    [anon_sym_readonly] = ACTIONS(5134),
    [anon_sym_ref] = ACTIONS(5134),
    [anon_sym_sealed] = ACTIONS(5134),
    [anon_sym_unsafe] = ACTIONS(5134),
    [anon_sym_virtual] = ACTIONS(5134),
    [anon_sym_volatile] = ACTIONS(5134),
    [anon_sym_RBRACE] = ACTIONS(5136),
    [anon_sym_implicit] = ACTIONS(5134),
    [anon_sym_explicit] = ACTIONS(5134),
    [anon_sym_TILDE] = ACTIONS(5136),
    [anon_sym_where] = ACTIONS(5134),
    [anon_sym_class] = ACTIONS(5134),
    [anon_sym_struct] = ACTIONS(5134),
    [anon_sym_notnull] = ACTIONS(5134),
    [anon_sym_unmanaged] = ACTIONS(5134),
    [anon_sym_get] = ACTIONS(5134),
    [anon_sym_set] = ACTIONS(5134),
    [anon_sym_add] = ACTIONS(5134),
    [anon_sym_remove] = ACTIONS(5134),
    [anon_sym_enum] = ACTIONS(5134),
    [anon_sym_interface] = ACTIONS(5134),
    [anon_sym_delegate] = ACTIONS(5134),
    [anon_sym_record] = ACTIONS(5134),
    [anon_sym_namespace] = ACTIONS(5134),
    [anon_sym_var] = ACTIONS(5134),
    [sym_predefined_type] = ACTIONS(5134),
    [anon_sym_when] = ACTIONS(5134),
    [anon_sym_yield] = ACTIONS(5134),
    [anon_sym_from] = ACTIONS(5134),
    [anon_sym_join] = ACTIONS(5134),
    [anon_sym_on] = ACTIONS(5134),
    [anon_sym_equals] = ACTIONS(5134),
    [anon_sym_into] = ACTIONS(5134),
    [anon_sym_let] = ACTIONS(5134),
    [anon_sym_orderby] = ACTIONS(5134),
    [anon_sym_ascending] = ACTIONS(5134),
    [anon_sym_descending] = ACTIONS(5134),
    [anon_sym_group] = ACTIONS(5134),
    [anon_sym_by] = ACTIONS(5134),
    [anon_sym_select] = ACTIONS(5134),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5134),
    [anon_sym_nameof] = ACTIONS(5134),
    [sym_void_keyword] = ACTIONS(5134),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2616] = {
    [sym__preprocessor_call] = STATE(2616),
    [sym__identifier_token] = ACTIONS(5138),
    [anon_sym_extern] = ACTIONS(5138),
    [anon_sym_alias] = ACTIONS(5138),
    [anon_sym_global] = ACTIONS(5138),
    [anon_sym_using] = ACTIONS(5138),
    [anon_sym_static] = ACTIONS(5138),
    [anon_sym_LBRACK] = ACTIONS(5140),
    [anon_sym_event] = ACTIONS(5138),
    [anon_sym_LPAREN] = ACTIONS(5140),
    [anon_sym_abstract] = ACTIONS(5138),
    [anon_sym_async] = ACTIONS(5138),
    [anon_sym_const] = ACTIONS(5138),
    [anon_sym_fixed] = ACTIONS(5138),
    [anon_sym_internal] = ACTIONS(5138),
    [anon_sym_new] = ACTIONS(5138),
    [anon_sym_override] = ACTIONS(5138),
    [anon_sym_partial] = ACTIONS(5138),
    [anon_sym_private] = ACTIONS(5138),
    [anon_sym_protected] = ACTIONS(5138),
    [anon_sym_public] = ACTIONS(5138),
    [anon_sym_readonly] = ACTIONS(5138),
    [anon_sym_ref] = ACTIONS(5138),
    [anon_sym_sealed] = ACTIONS(5138),
    [anon_sym_unsafe] = ACTIONS(5138),
    [anon_sym_virtual] = ACTIONS(5138),
    [anon_sym_volatile] = ACTIONS(5138),
    [anon_sym_RBRACE] = ACTIONS(5140),
    [anon_sym_implicit] = ACTIONS(5138),
    [anon_sym_explicit] = ACTIONS(5138),
    [anon_sym_TILDE] = ACTIONS(5140),
    [anon_sym_where] = ACTIONS(5138),
    [anon_sym_class] = ACTIONS(5138),
    [anon_sym_struct] = ACTIONS(5138),
    [anon_sym_notnull] = ACTIONS(5138),
    [anon_sym_unmanaged] = ACTIONS(5138),
    [anon_sym_get] = ACTIONS(5138),
    [anon_sym_set] = ACTIONS(5138),
    [anon_sym_add] = ACTIONS(5138),
    [anon_sym_remove] = ACTIONS(5138),
    [anon_sym_enum] = ACTIONS(5138),
    [anon_sym_interface] = ACTIONS(5138),
    [anon_sym_delegate] = ACTIONS(5138),
    [anon_sym_record] = ACTIONS(5138),
    [anon_sym_namespace] = ACTIONS(5138),
    [anon_sym_var] = ACTIONS(5138),
    [sym_predefined_type] = ACTIONS(5138),
    [anon_sym_when] = ACTIONS(5138),
    [anon_sym_yield] = ACTIONS(5138),
    [anon_sym_from] = ACTIONS(5138),
    [anon_sym_join] = ACTIONS(5138),
    [anon_sym_on] = ACTIONS(5138),
    [anon_sym_equals] = ACTIONS(5138),
    [anon_sym_into] = ACTIONS(5138),
    [anon_sym_let] = ACTIONS(5138),
    [anon_sym_orderby] = ACTIONS(5138),
    [anon_sym_ascending] = ACTIONS(5138),
    [anon_sym_descending] = ACTIONS(5138),
    [anon_sym_group] = ACTIONS(5138),
    [anon_sym_by] = ACTIONS(5138),
    [anon_sym_select] = ACTIONS(5138),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5138),
    [anon_sym_nameof] = ACTIONS(5138),
    [sym_void_keyword] = ACTIONS(5138),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2617] = {
    [sym__preprocessor_call] = STATE(2617),
    [sym__identifier_token] = ACTIONS(5142),
    [anon_sym_extern] = ACTIONS(5142),
    [anon_sym_alias] = ACTIONS(5142),
    [anon_sym_global] = ACTIONS(5142),
    [anon_sym_using] = ACTIONS(5142),
    [anon_sym_static] = ACTIONS(5142),
    [anon_sym_LBRACK] = ACTIONS(5144),
    [anon_sym_event] = ACTIONS(5142),
    [anon_sym_LPAREN] = ACTIONS(5144),
    [anon_sym_abstract] = ACTIONS(5142),
    [anon_sym_async] = ACTIONS(5142),
    [anon_sym_const] = ACTIONS(5142),
    [anon_sym_fixed] = ACTIONS(5142),
    [anon_sym_internal] = ACTIONS(5142),
    [anon_sym_new] = ACTIONS(5142),
    [anon_sym_override] = ACTIONS(5142),
    [anon_sym_partial] = ACTIONS(5142),
    [anon_sym_private] = ACTIONS(5142),
    [anon_sym_protected] = ACTIONS(5142),
    [anon_sym_public] = ACTIONS(5142),
    [anon_sym_readonly] = ACTIONS(5142),
    [anon_sym_ref] = ACTIONS(5142),
    [anon_sym_sealed] = ACTIONS(5142),
    [anon_sym_unsafe] = ACTIONS(5142),
    [anon_sym_virtual] = ACTIONS(5142),
    [anon_sym_volatile] = ACTIONS(5142),
    [anon_sym_RBRACE] = ACTIONS(5144),
    [anon_sym_implicit] = ACTIONS(5142),
    [anon_sym_explicit] = ACTIONS(5142),
    [anon_sym_TILDE] = ACTIONS(5144),
    [anon_sym_where] = ACTIONS(5142),
    [anon_sym_class] = ACTIONS(5142),
    [anon_sym_struct] = ACTIONS(5142),
    [anon_sym_notnull] = ACTIONS(5142),
    [anon_sym_unmanaged] = ACTIONS(5142),
    [anon_sym_get] = ACTIONS(5142),
    [anon_sym_set] = ACTIONS(5142),
    [anon_sym_add] = ACTIONS(5142),
    [anon_sym_remove] = ACTIONS(5142),
    [anon_sym_enum] = ACTIONS(5142),
    [anon_sym_interface] = ACTIONS(5142),
    [anon_sym_delegate] = ACTIONS(5142),
    [anon_sym_record] = ACTIONS(5142),
    [anon_sym_namespace] = ACTIONS(5142),
    [anon_sym_var] = ACTIONS(5142),
    [sym_predefined_type] = ACTIONS(5142),
    [anon_sym_when] = ACTIONS(5142),
    [anon_sym_yield] = ACTIONS(5142),
    [anon_sym_from] = ACTIONS(5142),
    [anon_sym_join] = ACTIONS(5142),
    [anon_sym_on] = ACTIONS(5142),
    [anon_sym_equals] = ACTIONS(5142),
    [anon_sym_into] = ACTIONS(5142),
    [anon_sym_let] = ACTIONS(5142),
    [anon_sym_orderby] = ACTIONS(5142),
    [anon_sym_ascending] = ACTIONS(5142),
    [anon_sym_descending] = ACTIONS(5142),
    [anon_sym_group] = ACTIONS(5142),
    [anon_sym_by] = ACTIONS(5142),
    [anon_sym_select] = ACTIONS(5142),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5142),
    [anon_sym_nameof] = ACTIONS(5142),
    [sym_void_keyword] = ACTIONS(5142),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2618] = {
    [sym__preprocessor_call] = STATE(2618),
    [sym__identifier_token] = ACTIONS(5146),
    [anon_sym_extern] = ACTIONS(5146),
    [anon_sym_alias] = ACTIONS(5146),
    [anon_sym_global] = ACTIONS(5146),
    [anon_sym_using] = ACTIONS(5146),
    [anon_sym_static] = ACTIONS(5146),
    [anon_sym_LBRACK] = ACTIONS(5148),
    [anon_sym_event] = ACTIONS(5146),
    [anon_sym_LPAREN] = ACTIONS(5148),
    [anon_sym_abstract] = ACTIONS(5146),
    [anon_sym_async] = ACTIONS(5146),
    [anon_sym_const] = ACTIONS(5146),
    [anon_sym_fixed] = ACTIONS(5146),
    [anon_sym_internal] = ACTIONS(5146),
    [anon_sym_new] = ACTIONS(5146),
    [anon_sym_override] = ACTIONS(5146),
    [anon_sym_partial] = ACTIONS(5146),
    [anon_sym_private] = ACTIONS(5146),
    [anon_sym_protected] = ACTIONS(5146),
    [anon_sym_public] = ACTIONS(5146),
    [anon_sym_readonly] = ACTIONS(5146),
    [anon_sym_ref] = ACTIONS(5146),
    [anon_sym_sealed] = ACTIONS(5146),
    [anon_sym_unsafe] = ACTIONS(5146),
    [anon_sym_virtual] = ACTIONS(5146),
    [anon_sym_volatile] = ACTIONS(5146),
    [anon_sym_RBRACE] = ACTIONS(5148),
    [anon_sym_implicit] = ACTIONS(5146),
    [anon_sym_explicit] = ACTIONS(5146),
    [anon_sym_TILDE] = ACTIONS(5148),
    [anon_sym_where] = ACTIONS(5146),
    [anon_sym_class] = ACTIONS(5146),
    [anon_sym_struct] = ACTIONS(5146),
    [anon_sym_notnull] = ACTIONS(5146),
    [anon_sym_unmanaged] = ACTIONS(5146),
    [anon_sym_get] = ACTIONS(5146),
    [anon_sym_set] = ACTIONS(5146),
    [anon_sym_add] = ACTIONS(5146),
    [anon_sym_remove] = ACTIONS(5146),
    [anon_sym_enum] = ACTIONS(5146),
    [anon_sym_interface] = ACTIONS(5146),
    [anon_sym_delegate] = ACTIONS(5146),
    [anon_sym_record] = ACTIONS(5146),
    [anon_sym_namespace] = ACTIONS(5146),
    [anon_sym_var] = ACTIONS(5146),
    [sym_predefined_type] = ACTIONS(5146),
    [anon_sym_when] = ACTIONS(5146),
    [anon_sym_yield] = ACTIONS(5146),
    [anon_sym_from] = ACTIONS(5146),
    [anon_sym_join] = ACTIONS(5146),
    [anon_sym_on] = ACTIONS(5146),
    [anon_sym_equals] = ACTIONS(5146),
    [anon_sym_into] = ACTIONS(5146),
    [anon_sym_let] = ACTIONS(5146),
    [anon_sym_orderby] = ACTIONS(5146),
    [anon_sym_ascending] = ACTIONS(5146),
    [anon_sym_descending] = ACTIONS(5146),
    [anon_sym_group] = ACTIONS(5146),
    [anon_sym_by] = ACTIONS(5146),
    [anon_sym_select] = ACTIONS(5146),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5146),
    [anon_sym_nameof] = ACTIONS(5146),
    [sym_void_keyword] = ACTIONS(5146),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2619] = {
    [sym__preprocessor_call] = STATE(2619),
    [sym__identifier_token] = ACTIONS(5150),
    [anon_sym_extern] = ACTIONS(5150),
    [anon_sym_alias] = ACTIONS(5150),
    [anon_sym_global] = ACTIONS(5150),
    [anon_sym_using] = ACTIONS(5150),
    [anon_sym_static] = ACTIONS(5150),
    [anon_sym_LBRACK] = ACTIONS(5152),
    [anon_sym_event] = ACTIONS(5150),
    [anon_sym_LPAREN] = ACTIONS(5152),
    [anon_sym_abstract] = ACTIONS(5150),
    [anon_sym_async] = ACTIONS(5150),
    [anon_sym_const] = ACTIONS(5150),
    [anon_sym_fixed] = ACTIONS(5150),
    [anon_sym_internal] = ACTIONS(5150),
    [anon_sym_new] = ACTIONS(5150),
    [anon_sym_override] = ACTIONS(5150),
    [anon_sym_partial] = ACTIONS(5150),
    [anon_sym_private] = ACTIONS(5150),
    [anon_sym_protected] = ACTIONS(5150),
    [anon_sym_public] = ACTIONS(5150),
    [anon_sym_readonly] = ACTIONS(5150),
    [anon_sym_ref] = ACTIONS(5150),
    [anon_sym_sealed] = ACTIONS(5150),
    [anon_sym_unsafe] = ACTIONS(5150),
    [anon_sym_virtual] = ACTIONS(5150),
    [anon_sym_volatile] = ACTIONS(5150),
    [anon_sym_RBRACE] = ACTIONS(5152),
    [anon_sym_implicit] = ACTIONS(5150),
    [anon_sym_explicit] = ACTIONS(5150),
    [anon_sym_TILDE] = ACTIONS(5152),
    [anon_sym_where] = ACTIONS(5150),
    [anon_sym_class] = ACTIONS(5150),
    [anon_sym_struct] = ACTIONS(5150),
    [anon_sym_notnull] = ACTIONS(5150),
    [anon_sym_unmanaged] = ACTIONS(5150),
    [anon_sym_get] = ACTIONS(5150),
    [anon_sym_set] = ACTIONS(5150),
    [anon_sym_add] = ACTIONS(5150),
    [anon_sym_remove] = ACTIONS(5150),
    [anon_sym_enum] = ACTIONS(5150),
    [anon_sym_interface] = ACTIONS(5150),
    [anon_sym_delegate] = ACTIONS(5150),
    [anon_sym_record] = ACTIONS(5150),
    [anon_sym_namespace] = ACTIONS(5150),
    [anon_sym_var] = ACTIONS(5150),
    [sym_predefined_type] = ACTIONS(5150),
    [anon_sym_when] = ACTIONS(5150),
    [anon_sym_yield] = ACTIONS(5150),
    [anon_sym_from] = ACTIONS(5150),
    [anon_sym_join] = ACTIONS(5150),
    [anon_sym_on] = ACTIONS(5150),
    [anon_sym_equals] = ACTIONS(5150),
    [anon_sym_into] = ACTIONS(5150),
    [anon_sym_let] = ACTIONS(5150),
    [anon_sym_orderby] = ACTIONS(5150),
    [anon_sym_ascending] = ACTIONS(5150),
    [anon_sym_descending] = ACTIONS(5150),
    [anon_sym_group] = ACTIONS(5150),
    [anon_sym_by] = ACTIONS(5150),
    [anon_sym_select] = ACTIONS(5150),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5150),
    [anon_sym_nameof] = ACTIONS(5150),
    [sym_void_keyword] = ACTIONS(5150),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2620] = {
    [sym__preprocessor_call] = STATE(2620),
    [sym__identifier_token] = ACTIONS(5154),
    [anon_sym_extern] = ACTIONS(5154),
    [anon_sym_alias] = ACTIONS(5154),
    [anon_sym_global] = ACTIONS(5154),
    [anon_sym_using] = ACTIONS(5154),
    [anon_sym_static] = ACTIONS(5154),
    [anon_sym_LBRACK] = ACTIONS(5156),
    [anon_sym_event] = ACTIONS(5154),
    [anon_sym_LPAREN] = ACTIONS(5156),
    [anon_sym_abstract] = ACTIONS(5154),
    [anon_sym_async] = ACTIONS(5154),
    [anon_sym_const] = ACTIONS(5154),
    [anon_sym_fixed] = ACTIONS(5154),
    [anon_sym_internal] = ACTIONS(5154),
    [anon_sym_new] = ACTIONS(5154),
    [anon_sym_override] = ACTIONS(5154),
    [anon_sym_partial] = ACTIONS(5154),
    [anon_sym_private] = ACTIONS(5154),
    [anon_sym_protected] = ACTIONS(5154),
    [anon_sym_public] = ACTIONS(5154),
    [anon_sym_readonly] = ACTIONS(5154),
    [anon_sym_ref] = ACTIONS(5154),
    [anon_sym_sealed] = ACTIONS(5154),
    [anon_sym_unsafe] = ACTIONS(5154),
    [anon_sym_virtual] = ACTIONS(5154),
    [anon_sym_volatile] = ACTIONS(5154),
    [anon_sym_RBRACE] = ACTIONS(5156),
    [anon_sym_implicit] = ACTIONS(5154),
    [anon_sym_explicit] = ACTIONS(5154),
    [anon_sym_TILDE] = ACTIONS(5156),
    [anon_sym_where] = ACTIONS(5154),
    [anon_sym_class] = ACTIONS(5154),
    [anon_sym_struct] = ACTIONS(5154),
    [anon_sym_notnull] = ACTIONS(5154),
    [anon_sym_unmanaged] = ACTIONS(5154),
    [anon_sym_get] = ACTIONS(5154),
    [anon_sym_set] = ACTIONS(5154),
    [anon_sym_add] = ACTIONS(5154),
    [anon_sym_remove] = ACTIONS(5154),
    [anon_sym_enum] = ACTIONS(5154),
    [anon_sym_interface] = ACTIONS(5154),
    [anon_sym_delegate] = ACTIONS(5154),
    [anon_sym_record] = ACTIONS(5154),
    [anon_sym_namespace] = ACTIONS(5154),
    [anon_sym_var] = ACTIONS(5154),
    [sym_predefined_type] = ACTIONS(5154),
    [anon_sym_when] = ACTIONS(5154),
    [anon_sym_yield] = ACTIONS(5154),
    [anon_sym_from] = ACTIONS(5154),
    [anon_sym_join] = ACTIONS(5154),
    [anon_sym_on] = ACTIONS(5154),
    [anon_sym_equals] = ACTIONS(5154),
    [anon_sym_into] = ACTIONS(5154),
    [anon_sym_let] = ACTIONS(5154),
    [anon_sym_orderby] = ACTIONS(5154),
    [anon_sym_ascending] = ACTIONS(5154),
    [anon_sym_descending] = ACTIONS(5154),
    [anon_sym_group] = ACTIONS(5154),
    [anon_sym_by] = ACTIONS(5154),
    [anon_sym_select] = ACTIONS(5154),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5154),
    [anon_sym_nameof] = ACTIONS(5154),
    [sym_void_keyword] = ACTIONS(5154),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2621] = {
    [sym__preprocessor_call] = STATE(2621),
    [sym__identifier_token] = ACTIONS(5158),
    [anon_sym_extern] = ACTIONS(5158),
    [anon_sym_alias] = ACTIONS(5158),
    [anon_sym_global] = ACTIONS(5158),
    [anon_sym_using] = ACTIONS(5158),
    [anon_sym_static] = ACTIONS(5158),
    [anon_sym_LBRACK] = ACTIONS(5160),
    [anon_sym_event] = ACTIONS(5158),
    [anon_sym_LPAREN] = ACTIONS(5160),
    [anon_sym_abstract] = ACTIONS(5158),
    [anon_sym_async] = ACTIONS(5158),
    [anon_sym_const] = ACTIONS(5158),
    [anon_sym_fixed] = ACTIONS(5158),
    [anon_sym_internal] = ACTIONS(5158),
    [anon_sym_new] = ACTIONS(5158),
    [anon_sym_override] = ACTIONS(5158),
    [anon_sym_partial] = ACTIONS(5158),
    [anon_sym_private] = ACTIONS(5158),
    [anon_sym_protected] = ACTIONS(5158),
    [anon_sym_public] = ACTIONS(5158),
    [anon_sym_readonly] = ACTIONS(5158),
    [anon_sym_ref] = ACTIONS(5158),
    [anon_sym_sealed] = ACTIONS(5158),
    [anon_sym_unsafe] = ACTIONS(5158),
    [anon_sym_virtual] = ACTIONS(5158),
    [anon_sym_volatile] = ACTIONS(5158),
    [anon_sym_RBRACE] = ACTIONS(5160),
    [anon_sym_implicit] = ACTIONS(5158),
    [anon_sym_explicit] = ACTIONS(5158),
    [anon_sym_TILDE] = ACTIONS(5160),
    [anon_sym_where] = ACTIONS(5158),
    [anon_sym_class] = ACTIONS(5158),
    [anon_sym_struct] = ACTIONS(5158),
    [anon_sym_notnull] = ACTIONS(5158),
    [anon_sym_unmanaged] = ACTIONS(5158),
    [anon_sym_get] = ACTIONS(5158),
    [anon_sym_set] = ACTIONS(5158),
    [anon_sym_add] = ACTIONS(5158),
    [anon_sym_remove] = ACTIONS(5158),
    [anon_sym_enum] = ACTIONS(5158),
    [anon_sym_interface] = ACTIONS(5158),
    [anon_sym_delegate] = ACTIONS(5158),
    [anon_sym_record] = ACTIONS(5158),
    [anon_sym_namespace] = ACTIONS(5158),
    [anon_sym_var] = ACTIONS(5158),
    [sym_predefined_type] = ACTIONS(5158),
    [anon_sym_when] = ACTIONS(5158),
    [anon_sym_yield] = ACTIONS(5158),
    [anon_sym_from] = ACTIONS(5158),
    [anon_sym_join] = ACTIONS(5158),
    [anon_sym_on] = ACTIONS(5158),
    [anon_sym_equals] = ACTIONS(5158),
    [anon_sym_into] = ACTIONS(5158),
    [anon_sym_let] = ACTIONS(5158),
    [anon_sym_orderby] = ACTIONS(5158),
    [anon_sym_ascending] = ACTIONS(5158),
    [anon_sym_descending] = ACTIONS(5158),
    [anon_sym_group] = ACTIONS(5158),
    [anon_sym_by] = ACTIONS(5158),
    [anon_sym_select] = ACTIONS(5158),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5158),
    [anon_sym_nameof] = ACTIONS(5158),
    [sym_void_keyword] = ACTIONS(5158),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2622] = {
    [sym__preprocessor_call] = STATE(2622),
    [sym__identifier_token] = ACTIONS(5162),
    [anon_sym_extern] = ACTIONS(5162),
    [anon_sym_alias] = ACTIONS(5162),
    [anon_sym_global] = ACTIONS(5162),
    [anon_sym_using] = ACTIONS(5162),
    [anon_sym_static] = ACTIONS(5162),
    [anon_sym_LBRACK] = ACTIONS(5164),
    [anon_sym_event] = ACTIONS(5162),
    [anon_sym_LPAREN] = ACTIONS(5164),
    [anon_sym_abstract] = ACTIONS(5162),
    [anon_sym_async] = ACTIONS(5162),
    [anon_sym_const] = ACTIONS(5162),
    [anon_sym_fixed] = ACTIONS(5162),
    [anon_sym_internal] = ACTIONS(5162),
    [anon_sym_new] = ACTIONS(5162),
    [anon_sym_override] = ACTIONS(5162),
    [anon_sym_partial] = ACTIONS(5162),
    [anon_sym_private] = ACTIONS(5162),
    [anon_sym_protected] = ACTIONS(5162),
    [anon_sym_public] = ACTIONS(5162),
    [anon_sym_readonly] = ACTIONS(5162),
    [anon_sym_ref] = ACTIONS(5162),
    [anon_sym_sealed] = ACTIONS(5162),
    [anon_sym_unsafe] = ACTIONS(5162),
    [anon_sym_virtual] = ACTIONS(5162),
    [anon_sym_volatile] = ACTIONS(5162),
    [anon_sym_RBRACE] = ACTIONS(5164),
    [anon_sym_implicit] = ACTIONS(5162),
    [anon_sym_explicit] = ACTIONS(5162),
    [anon_sym_TILDE] = ACTIONS(5164),
    [anon_sym_where] = ACTIONS(5162),
    [anon_sym_class] = ACTIONS(5162),
    [anon_sym_struct] = ACTIONS(5162),
    [anon_sym_notnull] = ACTIONS(5162),
    [anon_sym_unmanaged] = ACTIONS(5162),
    [anon_sym_get] = ACTIONS(5162),
    [anon_sym_set] = ACTIONS(5162),
    [anon_sym_add] = ACTIONS(5162),
    [anon_sym_remove] = ACTIONS(5162),
    [anon_sym_enum] = ACTIONS(5162),
    [anon_sym_interface] = ACTIONS(5162),
    [anon_sym_delegate] = ACTIONS(5162),
    [anon_sym_record] = ACTIONS(5162),
    [anon_sym_namespace] = ACTIONS(5162),
    [anon_sym_var] = ACTIONS(5162),
    [sym_predefined_type] = ACTIONS(5162),
    [anon_sym_when] = ACTIONS(5162),
    [anon_sym_yield] = ACTIONS(5162),
    [anon_sym_from] = ACTIONS(5162),
    [anon_sym_join] = ACTIONS(5162),
    [anon_sym_on] = ACTIONS(5162),
    [anon_sym_equals] = ACTIONS(5162),
    [anon_sym_into] = ACTIONS(5162),
    [anon_sym_let] = ACTIONS(5162),
    [anon_sym_orderby] = ACTIONS(5162),
    [anon_sym_ascending] = ACTIONS(5162),
    [anon_sym_descending] = ACTIONS(5162),
    [anon_sym_group] = ACTIONS(5162),
    [anon_sym_by] = ACTIONS(5162),
    [anon_sym_select] = ACTIONS(5162),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5162),
    [anon_sym_nameof] = ACTIONS(5162),
    [sym_void_keyword] = ACTIONS(5162),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2623] = {
    [sym__preprocessor_call] = STATE(2623),
    [sym__identifier_token] = ACTIONS(5166),
    [anon_sym_extern] = ACTIONS(5166),
    [anon_sym_alias] = ACTIONS(5166),
    [anon_sym_global] = ACTIONS(5166),
    [anon_sym_using] = ACTIONS(5166),
    [anon_sym_static] = ACTIONS(5166),
    [anon_sym_LBRACK] = ACTIONS(5168),
    [anon_sym_event] = ACTIONS(5166),
    [anon_sym_LPAREN] = ACTIONS(5168),
    [anon_sym_abstract] = ACTIONS(5166),
    [anon_sym_async] = ACTIONS(5166),
    [anon_sym_const] = ACTIONS(5166),
    [anon_sym_fixed] = ACTIONS(5166),
    [anon_sym_internal] = ACTIONS(5166),
    [anon_sym_new] = ACTIONS(5166),
    [anon_sym_override] = ACTIONS(5166),
    [anon_sym_partial] = ACTIONS(5166),
    [anon_sym_private] = ACTIONS(5166),
    [anon_sym_protected] = ACTIONS(5166),
    [anon_sym_public] = ACTIONS(5166),
    [anon_sym_readonly] = ACTIONS(5166),
    [anon_sym_ref] = ACTIONS(5166),
    [anon_sym_sealed] = ACTIONS(5166),
    [anon_sym_unsafe] = ACTIONS(5166),
    [anon_sym_virtual] = ACTIONS(5166),
    [anon_sym_volatile] = ACTIONS(5166),
    [anon_sym_RBRACE] = ACTIONS(5168),
    [anon_sym_implicit] = ACTIONS(5166),
    [anon_sym_explicit] = ACTIONS(5166),
    [anon_sym_TILDE] = ACTIONS(5168),
    [anon_sym_where] = ACTIONS(5166),
    [anon_sym_class] = ACTIONS(5166),
    [anon_sym_struct] = ACTIONS(5166),
    [anon_sym_notnull] = ACTIONS(5166),
    [anon_sym_unmanaged] = ACTIONS(5166),
    [anon_sym_get] = ACTIONS(5166),
    [anon_sym_set] = ACTIONS(5166),
    [anon_sym_add] = ACTIONS(5166),
    [anon_sym_remove] = ACTIONS(5166),
    [anon_sym_enum] = ACTIONS(5166),
    [anon_sym_interface] = ACTIONS(5166),
    [anon_sym_delegate] = ACTIONS(5166),
    [anon_sym_record] = ACTIONS(5166),
    [anon_sym_namespace] = ACTIONS(5166),
    [anon_sym_var] = ACTIONS(5166),
    [sym_predefined_type] = ACTIONS(5166),
    [anon_sym_when] = ACTIONS(5166),
    [anon_sym_yield] = ACTIONS(5166),
    [anon_sym_from] = ACTIONS(5166),
    [anon_sym_join] = ACTIONS(5166),
    [anon_sym_on] = ACTIONS(5166),
    [anon_sym_equals] = ACTIONS(5166),
    [anon_sym_into] = ACTIONS(5166),
    [anon_sym_let] = ACTIONS(5166),
    [anon_sym_orderby] = ACTIONS(5166),
    [anon_sym_ascending] = ACTIONS(5166),
    [anon_sym_descending] = ACTIONS(5166),
    [anon_sym_group] = ACTIONS(5166),
    [anon_sym_by] = ACTIONS(5166),
    [anon_sym_select] = ACTIONS(5166),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5166),
    [anon_sym_nameof] = ACTIONS(5166),
    [sym_void_keyword] = ACTIONS(5166),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2624] = {
    [sym__preprocessor_call] = STATE(2624),
    [sym__identifier_token] = ACTIONS(5170),
    [anon_sym_extern] = ACTIONS(5170),
    [anon_sym_alias] = ACTIONS(5170),
    [anon_sym_global] = ACTIONS(5170),
    [anon_sym_using] = ACTIONS(5170),
    [anon_sym_static] = ACTIONS(5170),
    [anon_sym_LBRACK] = ACTIONS(5172),
    [anon_sym_event] = ACTIONS(5170),
    [anon_sym_LPAREN] = ACTIONS(5172),
    [anon_sym_abstract] = ACTIONS(5170),
    [anon_sym_async] = ACTIONS(5170),
    [anon_sym_const] = ACTIONS(5170),
    [anon_sym_fixed] = ACTIONS(5170),
    [anon_sym_internal] = ACTIONS(5170),
    [anon_sym_new] = ACTIONS(5170),
    [anon_sym_override] = ACTIONS(5170),
    [anon_sym_partial] = ACTIONS(5170),
    [anon_sym_private] = ACTIONS(5170),
    [anon_sym_protected] = ACTIONS(5170),
    [anon_sym_public] = ACTIONS(5170),
    [anon_sym_readonly] = ACTIONS(5170),
    [anon_sym_ref] = ACTIONS(5170),
    [anon_sym_sealed] = ACTIONS(5170),
    [anon_sym_unsafe] = ACTIONS(5170),
    [anon_sym_virtual] = ACTIONS(5170),
    [anon_sym_volatile] = ACTIONS(5170),
    [anon_sym_RBRACE] = ACTIONS(5172),
    [anon_sym_implicit] = ACTIONS(5170),
    [anon_sym_explicit] = ACTIONS(5170),
    [anon_sym_TILDE] = ACTIONS(5172),
    [anon_sym_where] = ACTIONS(5170),
    [anon_sym_class] = ACTIONS(5170),
    [anon_sym_struct] = ACTIONS(5170),
    [anon_sym_notnull] = ACTIONS(5170),
    [anon_sym_unmanaged] = ACTIONS(5170),
    [anon_sym_get] = ACTIONS(5170),
    [anon_sym_set] = ACTIONS(5170),
    [anon_sym_add] = ACTIONS(5170),
    [anon_sym_remove] = ACTIONS(5170),
    [anon_sym_enum] = ACTIONS(5170),
    [anon_sym_interface] = ACTIONS(5170),
    [anon_sym_delegate] = ACTIONS(5170),
    [anon_sym_record] = ACTIONS(5170),
    [anon_sym_namespace] = ACTIONS(5170),
    [anon_sym_var] = ACTIONS(5170),
    [sym_predefined_type] = ACTIONS(5170),
    [anon_sym_when] = ACTIONS(5170),
    [anon_sym_yield] = ACTIONS(5170),
    [anon_sym_from] = ACTIONS(5170),
    [anon_sym_join] = ACTIONS(5170),
    [anon_sym_on] = ACTIONS(5170),
    [anon_sym_equals] = ACTIONS(5170),
    [anon_sym_into] = ACTIONS(5170),
    [anon_sym_let] = ACTIONS(5170),
    [anon_sym_orderby] = ACTIONS(5170),
    [anon_sym_ascending] = ACTIONS(5170),
    [anon_sym_descending] = ACTIONS(5170),
    [anon_sym_group] = ACTIONS(5170),
    [anon_sym_by] = ACTIONS(5170),
    [anon_sym_select] = ACTIONS(5170),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5170),
    [anon_sym_nameof] = ACTIONS(5170),
    [sym_void_keyword] = ACTIONS(5170),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2625] = {
    [sym__preprocessor_call] = STATE(2625),
    [sym__identifier_token] = ACTIONS(5174),
    [anon_sym_extern] = ACTIONS(5174),
    [anon_sym_alias] = ACTIONS(5174),
    [anon_sym_global] = ACTIONS(5174),
    [anon_sym_using] = ACTIONS(5174),
    [anon_sym_static] = ACTIONS(5174),
    [anon_sym_LBRACK] = ACTIONS(5176),
    [anon_sym_event] = ACTIONS(5174),
    [anon_sym_LPAREN] = ACTIONS(5176),
    [anon_sym_abstract] = ACTIONS(5174),
    [anon_sym_async] = ACTIONS(5174),
    [anon_sym_const] = ACTIONS(5174),
    [anon_sym_fixed] = ACTIONS(5174),
    [anon_sym_internal] = ACTIONS(5174),
    [anon_sym_new] = ACTIONS(5174),
    [anon_sym_override] = ACTIONS(5174),
    [anon_sym_partial] = ACTIONS(5174),
    [anon_sym_private] = ACTIONS(5174),
    [anon_sym_protected] = ACTIONS(5174),
    [anon_sym_public] = ACTIONS(5174),
    [anon_sym_readonly] = ACTIONS(5174),
    [anon_sym_ref] = ACTIONS(5174),
    [anon_sym_sealed] = ACTIONS(5174),
    [anon_sym_unsafe] = ACTIONS(5174),
    [anon_sym_virtual] = ACTIONS(5174),
    [anon_sym_volatile] = ACTIONS(5174),
    [anon_sym_RBRACE] = ACTIONS(5176),
    [anon_sym_implicit] = ACTIONS(5174),
    [anon_sym_explicit] = ACTIONS(5174),
    [anon_sym_TILDE] = ACTIONS(5176),
    [anon_sym_where] = ACTIONS(5174),
    [anon_sym_class] = ACTIONS(5174),
    [anon_sym_struct] = ACTIONS(5174),
    [anon_sym_notnull] = ACTIONS(5174),
    [anon_sym_unmanaged] = ACTIONS(5174),
    [anon_sym_get] = ACTIONS(5174),
    [anon_sym_set] = ACTIONS(5174),
    [anon_sym_add] = ACTIONS(5174),
    [anon_sym_remove] = ACTIONS(5174),
    [anon_sym_enum] = ACTIONS(5174),
    [anon_sym_interface] = ACTIONS(5174),
    [anon_sym_delegate] = ACTIONS(5174),
    [anon_sym_record] = ACTIONS(5174),
    [anon_sym_namespace] = ACTIONS(5174),
    [anon_sym_var] = ACTIONS(5174),
    [sym_predefined_type] = ACTIONS(5174),
    [anon_sym_when] = ACTIONS(5174),
    [anon_sym_yield] = ACTIONS(5174),
    [anon_sym_from] = ACTIONS(5174),
    [anon_sym_join] = ACTIONS(5174),
    [anon_sym_on] = ACTIONS(5174),
    [anon_sym_equals] = ACTIONS(5174),
    [anon_sym_into] = ACTIONS(5174),
    [anon_sym_let] = ACTIONS(5174),
    [anon_sym_orderby] = ACTIONS(5174),
    [anon_sym_ascending] = ACTIONS(5174),
    [anon_sym_descending] = ACTIONS(5174),
    [anon_sym_group] = ACTIONS(5174),
    [anon_sym_by] = ACTIONS(5174),
    [anon_sym_select] = ACTIONS(5174),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5174),
    [anon_sym_nameof] = ACTIONS(5174),
    [sym_void_keyword] = ACTIONS(5174),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2626] = {
    [sym__preprocessor_call] = STATE(2626),
    [sym__identifier_token] = ACTIONS(5178),
    [anon_sym_extern] = ACTIONS(5178),
    [anon_sym_alias] = ACTIONS(5178),
    [anon_sym_global] = ACTIONS(5178),
    [anon_sym_using] = ACTIONS(5178),
    [anon_sym_static] = ACTIONS(5178),
    [anon_sym_LBRACK] = ACTIONS(5180),
    [anon_sym_event] = ACTIONS(5178),
    [anon_sym_LPAREN] = ACTIONS(5180),
    [anon_sym_abstract] = ACTIONS(5178),
    [anon_sym_async] = ACTIONS(5178),
    [anon_sym_const] = ACTIONS(5178),
    [anon_sym_fixed] = ACTIONS(5178),
    [anon_sym_internal] = ACTIONS(5178),
    [anon_sym_new] = ACTIONS(5178),
    [anon_sym_override] = ACTIONS(5178),
    [anon_sym_partial] = ACTIONS(5178),
    [anon_sym_private] = ACTIONS(5178),
    [anon_sym_protected] = ACTIONS(5178),
    [anon_sym_public] = ACTIONS(5178),
    [anon_sym_readonly] = ACTIONS(5178),
    [anon_sym_ref] = ACTIONS(5178),
    [anon_sym_sealed] = ACTIONS(5178),
    [anon_sym_unsafe] = ACTIONS(5178),
    [anon_sym_virtual] = ACTIONS(5178),
    [anon_sym_volatile] = ACTIONS(5178),
    [anon_sym_RBRACE] = ACTIONS(5180),
    [anon_sym_implicit] = ACTIONS(5178),
    [anon_sym_explicit] = ACTIONS(5178),
    [anon_sym_TILDE] = ACTIONS(5180),
    [anon_sym_where] = ACTIONS(5178),
    [anon_sym_class] = ACTIONS(5178),
    [anon_sym_struct] = ACTIONS(5178),
    [anon_sym_notnull] = ACTIONS(5178),
    [anon_sym_unmanaged] = ACTIONS(5178),
    [anon_sym_get] = ACTIONS(5178),
    [anon_sym_set] = ACTIONS(5178),
    [anon_sym_add] = ACTIONS(5178),
    [anon_sym_remove] = ACTIONS(5178),
    [anon_sym_enum] = ACTIONS(5178),
    [anon_sym_interface] = ACTIONS(5178),
    [anon_sym_delegate] = ACTIONS(5178),
    [anon_sym_record] = ACTIONS(5178),
    [anon_sym_namespace] = ACTIONS(5178),
    [anon_sym_var] = ACTIONS(5178),
    [sym_predefined_type] = ACTIONS(5178),
    [anon_sym_when] = ACTIONS(5178),
    [anon_sym_yield] = ACTIONS(5178),
    [anon_sym_from] = ACTIONS(5178),
    [anon_sym_join] = ACTIONS(5178),
    [anon_sym_on] = ACTIONS(5178),
    [anon_sym_equals] = ACTIONS(5178),
    [anon_sym_into] = ACTIONS(5178),
    [anon_sym_let] = ACTIONS(5178),
    [anon_sym_orderby] = ACTIONS(5178),
    [anon_sym_ascending] = ACTIONS(5178),
    [anon_sym_descending] = ACTIONS(5178),
    [anon_sym_group] = ACTIONS(5178),
    [anon_sym_by] = ACTIONS(5178),
    [anon_sym_select] = ACTIONS(5178),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5178),
    [anon_sym_nameof] = ACTIONS(5178),
    [sym_void_keyword] = ACTIONS(5178),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2627] = {
    [sym__preprocessor_call] = STATE(2627),
    [sym__identifier_token] = ACTIONS(5182),
    [anon_sym_extern] = ACTIONS(5182),
    [anon_sym_alias] = ACTIONS(5182),
    [anon_sym_global] = ACTIONS(5182),
    [anon_sym_using] = ACTIONS(5182),
    [anon_sym_static] = ACTIONS(5182),
    [anon_sym_LBRACK] = ACTIONS(5184),
    [anon_sym_event] = ACTIONS(5182),
    [anon_sym_LPAREN] = ACTIONS(5184),
    [anon_sym_abstract] = ACTIONS(5182),
    [anon_sym_async] = ACTIONS(5182),
    [anon_sym_const] = ACTIONS(5182),
    [anon_sym_fixed] = ACTIONS(5182),
    [anon_sym_internal] = ACTIONS(5182),
    [anon_sym_new] = ACTIONS(5182),
    [anon_sym_override] = ACTIONS(5182),
    [anon_sym_partial] = ACTIONS(5182),
    [anon_sym_private] = ACTIONS(5182),
    [anon_sym_protected] = ACTIONS(5182),
    [anon_sym_public] = ACTIONS(5182),
    [anon_sym_readonly] = ACTIONS(5182),
    [anon_sym_ref] = ACTIONS(5182),
    [anon_sym_sealed] = ACTIONS(5182),
    [anon_sym_unsafe] = ACTIONS(5182),
    [anon_sym_virtual] = ACTIONS(5182),
    [anon_sym_volatile] = ACTIONS(5182),
    [anon_sym_RBRACE] = ACTIONS(5184),
    [anon_sym_implicit] = ACTIONS(5182),
    [anon_sym_explicit] = ACTIONS(5182),
    [anon_sym_TILDE] = ACTIONS(5184),
    [anon_sym_where] = ACTIONS(5182),
    [anon_sym_class] = ACTIONS(5182),
    [anon_sym_struct] = ACTIONS(5182),
    [anon_sym_notnull] = ACTIONS(5182),
    [anon_sym_unmanaged] = ACTIONS(5182),
    [anon_sym_get] = ACTIONS(5182),
    [anon_sym_set] = ACTIONS(5182),
    [anon_sym_add] = ACTIONS(5182),
    [anon_sym_remove] = ACTIONS(5182),
    [anon_sym_enum] = ACTIONS(5182),
    [anon_sym_interface] = ACTIONS(5182),
    [anon_sym_delegate] = ACTIONS(5182),
    [anon_sym_record] = ACTIONS(5182),
    [anon_sym_namespace] = ACTIONS(5182),
    [anon_sym_var] = ACTIONS(5182),
    [sym_predefined_type] = ACTIONS(5182),
    [anon_sym_when] = ACTIONS(5182),
    [anon_sym_yield] = ACTIONS(5182),
    [anon_sym_from] = ACTIONS(5182),
    [anon_sym_join] = ACTIONS(5182),
    [anon_sym_on] = ACTIONS(5182),
    [anon_sym_equals] = ACTIONS(5182),
    [anon_sym_into] = ACTIONS(5182),
    [anon_sym_let] = ACTIONS(5182),
    [anon_sym_orderby] = ACTIONS(5182),
    [anon_sym_ascending] = ACTIONS(5182),
    [anon_sym_descending] = ACTIONS(5182),
    [anon_sym_group] = ACTIONS(5182),
    [anon_sym_by] = ACTIONS(5182),
    [anon_sym_select] = ACTIONS(5182),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5182),
    [anon_sym_nameof] = ACTIONS(5182),
    [sym_void_keyword] = ACTIONS(5182),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2628] = {
    [sym_attribute_list] = STATE(2669),
    [sym__preprocessor_call] = STATE(2628),
    [aux_sym_event_field_declaration_repeat1] = STATE(2628),
    [sym__identifier_token] = ACTIONS(5186),
    [anon_sym_extern] = ACTIONS(5186),
    [anon_sym_alias] = ACTIONS(5186),
    [anon_sym_global] = ACTIONS(5186),
    [anon_sym_static] = ACTIONS(5186),
    [anon_sym_LBRACK] = ACTIONS(5188),
    [anon_sym_event] = ACTIONS(5186),
    [anon_sym_LPAREN] = ACTIONS(5191),
    [anon_sym_abstract] = ACTIONS(5186),
    [anon_sym_async] = ACTIONS(5186),
    [anon_sym_const] = ACTIONS(5186),
    [anon_sym_fixed] = ACTIONS(5186),
    [anon_sym_internal] = ACTIONS(5186),
    [anon_sym_new] = ACTIONS(5186),
    [anon_sym_override] = ACTIONS(5186),
    [anon_sym_partial] = ACTIONS(5186),
    [anon_sym_private] = ACTIONS(5186),
    [anon_sym_protected] = ACTIONS(5186),
    [anon_sym_public] = ACTIONS(5186),
    [anon_sym_readonly] = ACTIONS(5186),
    [anon_sym_ref] = ACTIONS(5186),
    [anon_sym_sealed] = ACTIONS(5186),
    [anon_sym_unsafe] = ACTIONS(5186),
    [anon_sym_virtual] = ACTIONS(5186),
    [anon_sym_volatile] = ACTIONS(5186),
    [anon_sym_implicit] = ACTIONS(5186),
    [anon_sym_explicit] = ACTIONS(5186),
    [anon_sym_TILDE] = ACTIONS(5191),
    [anon_sym_where] = ACTIONS(5186),
    [anon_sym_class] = ACTIONS(5186),
    [anon_sym_struct] = ACTIONS(5186),
    [anon_sym_notnull] = ACTIONS(5186),
    [anon_sym_unmanaged] = ACTIONS(5186),
    [anon_sym_get] = ACTIONS(5186),
    [anon_sym_set] = ACTIONS(5186),
    [anon_sym_add] = ACTIONS(5186),
    [anon_sym_remove] = ACTIONS(5186),
    [anon_sym_enum] = ACTIONS(5186),
    [anon_sym_interface] = ACTIONS(5186),
    [anon_sym_delegate] = ACTIONS(5186),
    [anon_sym_record] = ACTIONS(5186),
    [anon_sym_var] = ACTIONS(5186),
    [sym_predefined_type] = ACTIONS(5186),
    [anon_sym_when] = ACTIONS(5186),
    [anon_sym_yield] = ACTIONS(5186),
    [anon_sym_from] = ACTIONS(5186),
    [anon_sym_join] = ACTIONS(5186),
    [anon_sym_on] = ACTIONS(5186),
    [anon_sym_equals] = ACTIONS(5186),
    [anon_sym_into] = ACTIONS(5186),
    [anon_sym_let] = ACTIONS(5186),
    [anon_sym_orderby] = ACTIONS(5186),
    [anon_sym_ascending] = ACTIONS(5186),
    [anon_sym_descending] = ACTIONS(5186),
    [anon_sym_group] = ACTIONS(5186),
    [anon_sym_by] = ACTIONS(5186),
    [anon_sym_select] = ACTIONS(5186),
    [sym_comment] = ACTIONS(3),
    [anon_sym_dynamic] = ACTIONS(5186),
    [anon_sym_nameof] = ACTIONS(5186),
    [sym_void_keyword] = ACTIONS(5186),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2629] = {
    [sym__preprocessor_call] = STATE(2629),
    [anon_sym_SEMI] = ACTIONS(2894),
    [anon_sym_EQ] = ACTIONS(2892),
    [anon_sym_LT] = ACTIONS(2892),
    [anon_sym_COMMA] = ACTIONS(2894),
    [anon_sym_GT] = ACTIONS(2892),
    [anon_sym_DOT] = ACTIONS(5193),
    [anon_sym_LBRACK] = ACTIONS(2894),
    [anon_sym_RBRACK] = ACTIONS(2894),
    [anon_sym_LPAREN] = ACTIONS(2894),
    [anon_sym_RPAREN] = ACTIONS(2894),
    [anon_sym_LBRACE] = ACTIONS(2894),
    [anon_sym_RBRACE] = ACTIONS(2894),
    [anon_sym_where] = ACTIONS(2894),
    [anon_sym_QMARK] = ACTIONS(2896),
    [anon_sym_BANG] = ACTIONS(2892),
    [anon_sym_PLUS_PLUS] = ACTIONS(2894),
    [anon_sym_DASH_DASH] = ACTIONS(2894),
    [anon_sym_PLUS] = ACTIONS(2892),
    [anon_sym_DASH] = ACTIONS(2892),
    [anon_sym_STAR] = ACTIONS(2892),
    [anon_sym_SLASH] = ACTIONS(2892),
    [anon_sym_PERCENT] = ACTIONS(2892),
    [anon_sym_CARET] = ACTIONS(2892),
    [anon_sym_PIPE] = ACTIONS(2892),
    [anon_sym_AMP] = ACTIONS(2892),
    [anon_sym_LT_LT] = ACTIONS(2892),
    [anon_sym_GT_GT] = ACTIONS(2892),
    [anon_sym_EQ_EQ] = ACTIONS(2894),
    [anon_sym_BANG_EQ] = ACTIONS(2894),
    [anon_sym_GT_EQ] = ACTIONS(2894),
    [anon_sym_LT_EQ] = ACTIONS(2894),
    [anon_sym_switch] = ACTIONS(2894),
    [anon_sym_and] = ACTIONS(2894),
    [anon_sym_or] = ACTIONS(2892),
    [anon_sym_PLUS_EQ] = ACTIONS(2894),
    [anon_sym_DASH_EQ] = ACTIONS(2894),
    [anon_sym_STAR_EQ] = ACTIONS(2894),
    [anon_sym_SLASH_EQ] = ACTIONS(2894),
    [anon_sym_PERCENT_EQ] = ACTIONS(2894),
    [anon_sym_AMP_EQ] = ACTIONS(2894),
    [anon_sym_CARET_EQ] = ACTIONS(2894),
    [anon_sym_PIPE_EQ] = ACTIONS(2894),
    [anon_sym_LT_LT_EQ] = ACTIONS(2894),
    [anon_sym_GT_GT_EQ] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2894),
    [anon_sym_is] = ACTIONS(2894),
    [anon_sym_DASH_GT] = ACTIONS(2894),
    [anon_sym_from] = ACTIONS(2894),
    [anon_sym_join] = ACTIONS(2894),
    [anon_sym_on] = ACTIONS(2894),
    [anon_sym_equals] = ACTIONS(2894),
    [anon_sym_let] = ACTIONS(2894),
    [anon_sym_orderby] = ACTIONS(2894),
    [anon_sym_group] = ACTIONS(2894),
    [anon_sym_by] = ACTIONS(2894),
    [anon_sym_select] = ACTIONS(2894),
    [anon_sym_DOT_DOT] = ACTIONS(2894),
    [anon_sym_with] = ACTIONS(2894),
    [anon_sym_AMP_AMP] = ACTIONS(2894),
    [anon_sym_PIPE_PIPE] = ACTIONS(2894),
    [anon_sym_QMARK_QMARK] = ACTIONS(2892),
    [anon_sym_as] = ACTIONS(2894),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2630] = {
    [sym_type_argument_list] = STATE(2714),
    [sym__preprocessor_call] = STATE(2630),
    [anon_sym_SEMI] = ACTIONS(2829),
    [anon_sym_EQ] = ACTIONS(2827),
    [anon_sym_COLON_COLON] = ACTIONS(5195),
    [anon_sym_LT] = ACTIONS(5197),
    [anon_sym_COMMA] = ACTIONS(2829),
    [anon_sym_GT] = ACTIONS(2827),
    [anon_sym_DOT] = ACTIONS(2827),
    [anon_sym_LBRACK] = ACTIONS(2829),
    [anon_sym_RBRACK] = ACTIONS(2829),
    [anon_sym_COLON] = ACTIONS(2827),
    [anon_sym_LPAREN] = ACTIONS(2829),
    [anon_sym_RPAREN] = ACTIONS(2829),
    [anon_sym_in] = ACTIONS(2827),
    [anon_sym_LBRACE] = ACTIONS(2829),
    [anon_sym_RBRACE] = ACTIONS(2829),
    [anon_sym_EQ_GT] = ACTIONS(2829),
    [anon_sym_QMARK] = ACTIONS(2827),
    [anon_sym_BANG] = ACTIONS(2827),
    [anon_sym_PLUS_PLUS] = ACTIONS(2829),
    [anon_sym_DASH_DASH] = ACTIONS(2829),
    [anon_sym_PLUS] = ACTIONS(2827),
    [anon_sym_DASH] = ACTIONS(2827),
    [anon_sym_STAR] = ACTIONS(2827),
    [anon_sym_SLASH] = ACTIONS(2827),
    [anon_sym_PERCENT] = ACTIONS(2827),
    [anon_sym_CARET] = ACTIONS(2827),
    [anon_sym_PIPE] = ACTIONS(2827),
    [anon_sym_AMP] = ACTIONS(2827),
    [anon_sym_LT_LT] = ACTIONS(2827),
    [anon_sym_GT_GT] = ACTIONS(2827),
    [anon_sym_EQ_EQ] = ACTIONS(2829),
    [anon_sym_BANG_EQ] = ACTIONS(2829),
    [anon_sym_GT_EQ] = ACTIONS(2829),
    [anon_sym_LT_EQ] = ACTIONS(2829),
    [anon_sym_switch] = ACTIONS(2829),
    [anon_sym_and] = ACTIONS(2829),
    [anon_sym_or] = ACTIONS(2829),
    [anon_sym_when] = ACTIONS(2829),
    [anon_sym_PLUS_EQ] = ACTIONS(2829),
    [anon_sym_DASH_EQ] = ACTIONS(2829),
    [anon_sym_STAR_EQ] = ACTIONS(2829),
    [anon_sym_SLASH_EQ] = ACTIONS(2829),
    [anon_sym_PERCENT_EQ] = ACTIONS(2829),
    [anon_sym_AMP_EQ] = ACTIONS(2829),
    [anon_sym_CARET_EQ] = ACTIONS(2829),
    [anon_sym_PIPE_EQ] = ACTIONS(2829),
    [anon_sym_LT_LT_EQ] = ACTIONS(2829),
    [anon_sym_GT_GT_EQ] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(2829),
    [anon_sym_is] = ACTIONS(2829),
    [anon_sym_DASH_GT] = ACTIONS(2829),
    [anon_sym_on] = ACTIONS(2829),
    [anon_sym_equals] = ACTIONS(2829),
    [anon_sym_into] = ACTIONS(2829),
    [anon_sym_by] = ACTIONS(2829),
    [anon_sym_DOT_DOT] = ACTIONS(2829),
    [anon_sym_with] = ACTIONS(2829),
    [anon_sym_AMP_AMP] = ACTIONS(2829),
    [anon_sym_PIPE_PIPE] = ACTIONS(2829),
    [anon_sym_QMARK_QMARK] = ACTIONS(2827),
    [anon_sym_as] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
  [2631] = {
    [sym_argument_list] = STATE(2674),
    [sym_array_rank_specifier] = STATE(2753),
    [sym_initializer_expression] = STATE(2934),
    [sym__preprocessor_call] = STATE(2631),
    [anon_sym_SEMI] = ACTIONS(3234),
    [anon_sym_EQ] = ACTIONS(3236),
    [anon_sym_LT] = ACTIONS(3236),
    [anon_sym_COMMA] = ACTIONS(3234),
    [anon_sym_GT] = ACTIONS(3236),
    [anon_sym_DOT] = ACTIONS(3236),
    [anon_sym_LBRACK] = ACTIONS(5200),
    [anon_sym_RBRACK] = ACTIONS(3234),
    [anon_sym_COLON] = ACTIONS(3234),
    [anon_sym_LPAREN] = ACTIONS(5202),
    [anon_sym_RPAREN] = ACTIONS(3234),
    [anon_sym_in] = ACTIONS(3234),
    [anon_sym_LBRACE] = ACTIONS(821),
    [anon_sym_RBRACE] = ACTIONS(3234),
    [anon_sym_EQ_GT] = ACTIONS(3234),
    [anon_sym_QMARK] = ACTIONS(3236),
    [anon_sym_BANG] = ACTIONS(3236),
    [anon_sym_PLUS_PLUS] = ACTIONS(3234),
    [anon_sym_DASH_DASH] = ACTIONS(3234),
    [anon_sym_PLUS] = ACTIONS(3236),
    [anon_sym_DASH] = ACTIONS(3236),
    [anon_sym_STAR] = ACTIONS(5204),
    [anon_sym_SLASH] = ACTIONS(3236),
    [anon_sym_PERCENT] = ACTIONS(3236),
    [anon_sym_CARET] = ACTIONS(3236),
    [anon_sym_PIPE] = ACTIONS(3236),
    [anon_sym_AMP] = ACTIONS(3236),
    [anon_sym_LT_LT] = ACTIONS(3236),
    [anon_sym_GT_GT] = ACTIONS(3236),
    [anon_sym_EQ_EQ] = ACTIONS(3234),
    [anon_sym_BANG_EQ] = ACTIONS(3234),
    [anon_sym_GT_EQ] = ACTIONS(3234),
    [anon_sym_LT_EQ] = ACTIONS(3234),
    [anon_sym_switch] = ACTIONS(3234),
    [anon_sym_and] = ACTIONS(3234),
    [anon_sym_or] = ACTIONS(3234),
    [anon_sym_when] = ACTIONS(3234),
    [anon_sym_PLUS_EQ] = ACTIONS(3234),
    [anon_sym_DASH_EQ] = ACTIONS(3234),
    [anon_sym_STAR_EQ] = ACTIONS(3234),
    [anon_sym_SLASH_EQ] = ACTIONS(3234),
    [anon_sym_PERCENT_EQ] = ACTIONS(3234),
    [anon_sym_AMP_EQ] = ACTIONS(3234),
    [anon_sym_CARET_EQ] = ACTIONS(3234),
    [anon_sym_PIPE_EQ] = ACTIONS(3234),
    [anon_sym_LT_LT_EQ] = ACTIONS(3234),
    [anon_sym_GT_GT_EQ] = ACTIONS(3234),
    [anon_sym_QMARK_QMARK_EQ] = ACTIONS(3234),
    [anon_sym_is] = ACTIONS(3234),
    [anon_sym_DASH_GT] = ACTIONS(3234),
    [anon_sym_on] = ACTIONS(3234),
    [anon_sym_equals] = ACTIONS(3234),
    [anon_sym_by] = ACTIONS(3234),
    [anon_sym_DOT_DOT] = ACTIONS(3234),
    [anon_sym_with] = ACTIONS(3234),
    [anon_sym_AMP_AMP] = ACTIONS(3234),
    [anon_sym_PIPE_PIPE] = ACTIONS(3234),
    [anon_sym_QMARK_QMARK] = ACTIONS(3236),
    [anon_sym_as] = ACTIONS(3234),
    [sym_comment] = ACTIONS(3),
    [sym__preproc_directive_start] = ACTIONS(5),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2632), 1,
      sym__preprocessor_call,
    ACTIONS(2844), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2847), 42,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [75] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2633), 1,
      sym__preprocessor_call,
    ACTIONS(2833), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2835), 42,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [150] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2634), 1,
      sym__preprocessor_call,
    ACTIONS(2734), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2729), 42,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [225] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1023), 1,
      anon_sym_LBRACE,
    ACTIONS(2784), 1,
      anon_sym_LBRACK,
    ACTIONS(2788), 1,
      anon_sym_STAR,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    STATE(1809), 1,
      sym_array_rank_specifier,
    STATE(2635), 1,
      sym__preprocessor_call,
    STATE(2835), 1,
      sym_argument_list,
    STATE(3046), 1,
      sym_initializer_expression,
    ACTIONS(3236), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3234), 36,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5195), 1,
      anon_sym_COLON_COLON,
    STATE(2636), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [391] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5197), 1,
      anon_sym_LT,
    STATE(2637), 1,
      sym__preprocessor_call,
    STATE(2714), 1,
      sym_type_argument_list,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [470] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(747), 1,
      anon_sym_LBRACE,
    STATE(2638), 1,
      sym__preprocessor_call,
    STATE(2833), 1,
      sym_initializer_expression,
    ACTIONS(3264), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3262), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [549] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(747), 1,
      anon_sym_LBRACE,
    ACTIONS(3270), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_QMARK,
    ACTIONS(3276), 1,
      anon_sym_STAR,
    STATE(2639), 1,
      sym__preprocessor_call,
    STATE(2725), 1,
      sym_initializer_expression,
    ACTIONS(3268), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3266), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [634] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3288), 1,
      anon_sym_QMARK,
    ACTIONS(5208), 1,
      anon_sym_LBRACE,
    STATE(2640), 1,
      sym__preprocessor_call,
    STATE(2733), 1,
      sym_initializer_expression,
    ACTIONS(3282), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3279), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [715] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    STATE(2641), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2829), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [792] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(747), 1,
      anon_sym_LBRACE,
    STATE(2642), 1,
      sym__preprocessor_call,
    STATE(2735), 1,
      sym_initializer_expression,
    ACTIONS(3294), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3292), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [871] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2643), 1,
      sym__preprocessor_call,
    ACTIONS(2833), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2835), 43,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2644), 1,
      sym__preprocessor_call,
    ACTIONS(2734), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2729), 43,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [1021] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2645), 1,
      sym__preprocessor_call,
    ACTIONS(2833), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2835), 42,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [1095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2729), 1,
      anon_sym_EQ_GT,
    STATE(2646), 1,
      sym__preprocessor_call,
    ACTIONS(2844), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2847), 40,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [1171] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2647), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1297] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2837), 1,
      anon_sym_LT,
    ACTIONS(2840), 1,
      anon_sym_COLON_COLON,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2648), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 18,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2829), 39,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [1377] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5259), 1,
      anon_sym_or,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2649), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5255), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1509] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2650), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3510), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1641] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2651), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 30,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [1743] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2652), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [1863] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(3352), 1,
      anon_sym_or,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2653), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3350), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [1995] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2654), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 30,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [2093] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3288), 1,
      anon_sym_QMARK,
    ACTIONS(5263), 1,
      anon_sym_LBRACE,
    STATE(2655), 1,
      sym__preprocessor_call,
    STATE(2935), 1,
      sym_initializer_expression,
    ACTIONS(3282), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3279), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [2173] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5268), 1,
      anon_sym_or,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2656), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5266), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [2305] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2657), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5270), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [2433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2658), 1,
      sym__preprocessor_call,
    ACTIONS(5276), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_TILDE,
    ACTIONS(5274), 57,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_event,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [2507] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2659), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [2619] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2660), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5280), 33,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [2711] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2661), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [2825] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2662), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [2943] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2663), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [3059] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2664), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5284), 33,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [3151] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2665), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(725), 32,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [3245] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(821), 1,
      anon_sym_LBRACE,
    STATE(2666), 1,
      sym__preprocessor_call,
    STATE(2932), 1,
      sym_initializer_expression,
    ACTIONS(3294), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3292), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [3323] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5286), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5288), 1,
      anon_sym_LT,
    STATE(2667), 1,
      sym__preprocessor_call,
    STATE(2838), 1,
      sym_type_argument_list,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [3403] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(821), 1,
      anon_sym_LBRACE,
    ACTIONS(3270), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_QMARK,
    ACTIONS(3276), 1,
      anon_sym_STAR,
    STATE(2668), 1,
      sym__preprocessor_call,
    STATE(2941), 1,
      sym_initializer_expression,
    ACTIONS(3268), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3266), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [3487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2669), 1,
      sym__preprocessor_call,
    ACTIONS(5293), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_TILDE,
    ACTIONS(5291), 57,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_event,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [3561] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2670), 1,
      sym__preprocessor_call,
    ACTIONS(2844), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2847), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [3635] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2837), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5295), 1,
      anon_sym_EQ_GT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2671), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 18,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2829), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [3717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2672), 1,
      sym__preprocessor_call,
    ACTIONS(2734), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2729), 42,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [3791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2673), 1,
      sym__preprocessor_call,
    ACTIONS(2945), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2947), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [3865] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(821), 1,
      anon_sym_LBRACE,
    STATE(2674), 1,
      sym__preprocessor_call,
    STATE(2979), 1,
      sym_initializer_expression,
    ACTIONS(3264), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3262), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [3943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2675), 1,
      sym__preprocessor_call,
    ACTIONS(2860), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2862), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2676), 1,
      sym__preprocessor_call,
    ACTIONS(3308), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3306), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2677), 1,
      sym__preprocessor_call,
    ACTIONS(2941), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2943), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4165] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2678), 1,
      sym__preprocessor_call,
    ACTIONS(2937), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2939), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2679), 1,
      sym__preprocessor_call,
    ACTIONS(2933), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2935), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2680), 1,
      sym__preprocessor_call,
    ACTIONS(2903), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2905), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2681), 1,
      sym__preprocessor_call,
    ACTIONS(2899), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2901), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2682), 1,
      sym__preprocessor_call,
    ACTIONS(2850), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2858), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4535] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2683), 1,
      sym__preprocessor_call,
    ACTIONS(2949), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2951), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2684), 1,
      sym__preprocessor_call,
    ACTIONS(2884), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2886), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4683] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(4524), 1,
      anon_sym_LBRACK,
    ACTIONS(4528), 1,
      anon_sym_STAR,
    STATE(2685), 1,
      sym__preprocessor_call,
    STATE(2689), 1,
      sym_array_rank_specifier,
    ACTIONS(3304), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3302), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2686), 1,
      sym__preprocessor_call,
    ACTIONS(2876), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2878), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2687), 1,
      sym__preprocessor_call,
    ACTIONS(5299), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_TILDE,
    ACTIONS(5297), 57,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_event,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [4911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2688), 1,
      sym__preprocessor_call,
    ACTIONS(2961), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2963), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [4985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2689), 1,
      sym__preprocessor_call,
    ACTIONS(2953), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2955), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [5059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2690), 1,
      sym__preprocessor_call,
    ACTIONS(3318), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3316), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [5133] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2691), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 14,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 30,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [5233] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(3520), 1,
      anon_sym_or,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2692), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(3518), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [5365] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5303), 1,
      anon_sym_or,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2693), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5301), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [5497] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2694), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 30,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [5601] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2695), 1,
      sym__preprocessor_call,
    ACTIONS(2915), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2917), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [5675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    ACTIONS(5305), 1,
      anon_sym_DOT,
    STATE(2696), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [5753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2697), 1,
      sym__preprocessor_call,
    ACTIONS(2911), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2913), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [5827] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    STATE(2698), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [5903] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5309), 1,
      anon_sym_or,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2699), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5307), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [6035] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    STATE(2700), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [6111] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2701), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5311), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [6239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2702), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [6313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2703), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [6387] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2704), 1,
      sym__preprocessor_call,
    ACTIONS(5317), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_TILDE,
    ACTIONS(5315), 57,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_event,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [6461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2705), 1,
      sym__preprocessor_call,
    ACTIONS(2888), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2890), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [6535] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2706), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5321), 33,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [6627] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5328), 1,
      anon_sym_LPAREN,
    ACTIONS(5330), 1,
      anon_sym_ref,
    STATE(2909), 1,
      sym_modifier,
    STATE(2707), 2,
      sym__preprocessor_call,
      aux_sym_event_field_declaration_repeat2,
    ACTIONS(5325), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
    ACTIONS(5323), 38,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_event,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [6707] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2729), 1,
      anon_sym_EQ_GT,
    STATE(2708), 1,
      sym__preprocessor_call,
    ACTIONS(2844), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2847), 41,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [6783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2709), 1,
      sym__preprocessor_call,
    ACTIONS(2957), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2959), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [6857] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2710), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5335), 32,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [6951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2711), 1,
      sym__preprocessor_call,
    ACTIONS(3312), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3310), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [7025] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5257), 1,
      anon_sym_QMARK,
    ACTIONS(5339), 1,
      anon_sym_or,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2712), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5337), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [7157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2713), 1,
      sym__preprocessor_call,
    ACTIONS(2817), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2815), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [7231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2714), 1,
      sym__preprocessor_call,
    ACTIONS(2866), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2868), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [7305] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5239), 1,
      anon_sym_is,
    ACTIONS(5241), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5251), 1,
      anon_sym_as,
    STATE(1484), 1,
      sym_assignment_operator,
    STATE(2715), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_PIPE_PIPE,
  [7427] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5288), 1,
      anon_sym_LT,
    STATE(2716), 1,
      sym__preprocessor_call,
    STATE(2838), 1,
      sym_type_argument_list,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [7505] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2717), 1,
      sym__preprocessor_call,
    ACTIONS(5343), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_TILDE,
    ACTIONS(5341), 57,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_event,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [7579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2718), 1,
      sym__preprocessor_call,
    ACTIONS(2961), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2963), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [7652] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5259), 1,
      anon_sym_or,
    ACTIONS(5347), 1,
      anon_sym_QMARK,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5373), 1,
      anon_sym_QMARK_QMARK,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2719), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [7783] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3288), 1,
      anon_sym_QMARK,
    ACTIONS(5375), 1,
      anon_sym_LBRACE,
    STATE(2720), 1,
      sym__preprocessor_call,
    STATE(3045), 1,
      sym_initializer_expression,
    ACTIONS(3282), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3279), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [7862] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2852), 1,
      anon_sym_DASH_GT,
    ACTIONS(2855), 1,
      anon_sym_DOT,
    STATE(2721), 1,
      sym__preprocessor_call,
    ACTIONS(2995), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2993), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [7939] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2722), 1,
      sym__preprocessor_call,
    ACTIONS(3528), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3526), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [8012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2723), 1,
      sym__preprocessor_call,
    ACTIONS(3532), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3530), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [8085] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2724), 1,
      sym__preprocessor_call,
    ACTIONS(3536), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3534), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [8158] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2725), 1,
      sym__preprocessor_call,
    ACTIONS(3544), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3542), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [8231] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    ACTIONS(3028), 1,
      anon_sym_TILDE,
    STATE(2726), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 57,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_event,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [8306] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2727), 1,
      sym__preprocessor_call,
    ACTIONS(2995), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2993), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [8379] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2728), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(725), 31,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [8472] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2729), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5284), 32,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [8563] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2730), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5280), 32,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [8654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2731), 1,
      sym__preprocessor_call,
    ACTIONS(3057), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3059), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [8727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2732), 1,
      sym__preprocessor_call,
    ACTIONS(2941), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2943), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [8800] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2733), 1,
      sym__preprocessor_call,
    ACTIONS(3548), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3546), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [8873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2734), 1,
      sym__preprocessor_call,
    ACTIONS(3540), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3538), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [8946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2735), 1,
      sym__preprocessor_call,
    ACTIONS(3524), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3522), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2736), 1,
      sym__preprocessor_call,
    ACTIONS(3456), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3454), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9092] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2737), 1,
      sym__preprocessor_call,
    ACTIONS(3428), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3426), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9165] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2738), 1,
      sym__preprocessor_call,
    ACTIONS(3416), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3414), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9238] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2739), 1,
      sym__preprocessor_call,
    ACTIONS(3400), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3398), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9311] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2740), 1,
      sym__preprocessor_call,
    ACTIONS(3424), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3422), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9384] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2741), 1,
      sym__preprocessor_call,
    ACTIONS(2860), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2862), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2742), 1,
      sym__preprocessor_call,
    ACTIONS(1984), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(1989), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9530] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3069), 1,
      anon_sym_DOT,
    ACTIONS(3072), 1,
      anon_sym_DASH_GT,
    STATE(2743), 1,
      sym__preprocessor_call,
    ACTIONS(3067), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3075), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2744), 1,
      sym__preprocessor_call,
    ACTIONS(3408), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3406), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9680] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2745), 1,
      sym__preprocessor_call,
    ACTIONS(3372), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3370), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2746), 1,
      sym__preprocessor_call,
    ACTIONS(3368), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3366), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9826] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2747), 1,
      sym__preprocessor_call,
    ACTIONS(3404), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3402), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9899] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2748), 1,
      sym__preprocessor_call,
    ACTIONS(2945), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2947), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [9972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2749), 1,
      sym__preprocessor_call,
    ACTIONS(3396), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3394), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10045] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2750), 1,
      sym__preprocessor_call,
    ACTIONS(3392), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3390), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10118] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2751), 1,
      sym__preprocessor_call,
    ACTIONS(3364), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3362), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2752), 1,
      sym__preprocessor_call,
    ACTIONS(3360), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3358), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10264] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2753), 1,
      sym__preprocessor_call,
    ACTIONS(2953), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2955), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2754), 1,
      sym__preprocessor_call,
    ACTIONS(2915), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2917), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2755), 1,
      sym__preprocessor_call,
    ACTIONS(3356), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3354), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10483] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2756), 1,
      sym__preprocessor_call,
    ACTIONS(3520), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3518), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10556] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2757), 1,
      sym__preprocessor_call,
    ACTIONS(3444), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3442), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10629] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2758), 1,
      sym__preprocessor_call,
    ACTIONS(3436), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3434), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10702] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2759), 1,
      sym__preprocessor_call,
    ACTIONS(3412), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3410), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2760), 1,
      sym__preprocessor_call,
    ACTIONS(3388), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3386), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2761), 1,
      sym__preprocessor_call,
    ACTIONS(2876), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2878), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10921] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5286), 1,
      anon_sym_COLON_COLON,
    STATE(2762), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [10996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2763), 1,
      sym__preprocessor_call,
    ACTIONS(3067), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3075), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11069] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    STATE(2764), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2765), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2766), 1,
      sym__preprocessor_call,
    ACTIONS(3448), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3446), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2767), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11363] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2768), 1,
      sym__preprocessor_call,
    ACTIONS(2888), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2890), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11436] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2769), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2770), 1,
      sym__preprocessor_call,
    ACTIONS(3338), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3336), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11582] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2771), 1,
      sym__preprocessor_call,
    ACTIONS(3376), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3374), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2772), 1,
      sym__preprocessor_call,
    ACTIONS(2216), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2214), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11728] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2773), 1,
      sym__preprocessor_call,
    ACTIONS(3384), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3382), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2774), 1,
      sym__preprocessor_call,
    ACTIONS(3380), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3378), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2775), 1,
      sym__preprocessor_call,
    ACTIONS(3496), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3494), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [11947] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1023), 1,
      anon_sym_LBRACE,
    ACTIONS(3270), 1,
      anon_sym_LBRACK,
    ACTIONS(3273), 1,
      anon_sym_QMARK,
    ACTIONS(3276), 1,
      anon_sym_STAR,
    STATE(2776), 1,
      sym__preprocessor_call,
    STATE(3102), 1,
      sym_initializer_expression,
    ACTIONS(3268), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3266), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [12030] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5382), 1,
      anon_sym_LPAREN,
    STATE(2777), 1,
      sym__preprocessor_call,
    ACTIONS(3342), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3340), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [12105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2778), 1,
      sym__preprocessor_call,
    ACTIONS(2817), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2815), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [12178] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2779), 1,
      sym__preprocessor_call,
    ACTIONS(2937), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2939), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [12251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2780), 1,
      sym__preprocessor_call,
    ACTIONS(3348), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3346), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [12324] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2781), 1,
      sym__preprocessor_call,
    ACTIONS(1979), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(1977), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [12397] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2782), 1,
      sym__preprocessor_call,
    ACTIONS(2769), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2771), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [12470] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5347), 1,
      anon_sym_QMARK,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5373), 1,
      anon_sym_QMARK_QMARK,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2783), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5270), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [12597] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2784), 1,
      sym__preprocessor_call,
    ACTIONS(5386), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5384), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [12670] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(3352), 1,
      anon_sym_or,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5347), 1,
      anon_sym_QMARK,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5373), 1,
      anon_sym_QMARK_QMARK,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2785), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [12801] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2786), 1,
      sym__preprocessor_call,
    ACTIONS(5390), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5388), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [12874] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2787), 1,
      sym__preprocessor_call,
    ACTIONS(5394), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5392), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [12947] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5347), 1,
      anon_sym_QMARK,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5373), 1,
      anon_sym_QMARK_QMARK,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2788), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [13078] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1023), 1,
      anon_sym_LBRACE,
    STATE(2789), 1,
      sym__preprocessor_call,
    STATE(3002), 1,
      sym_initializer_expression,
    ACTIONS(3294), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3292), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13155] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5373), 1,
      anon_sym_QMARK_QMARK,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2790), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13280] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5309), 1,
      anon_sym_or,
    ACTIONS(5347), 1,
      anon_sym_QMARK,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5373), 1,
      anon_sym_QMARK_QMARK,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2791), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5307), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [13411] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2792), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_PIPE_PIPE,
  [13532] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2793), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2794), 1,
      sym__preprocessor_call,
    ACTIONS(1986), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(1981), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [13724] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2795), 1,
      sym__preprocessor_call,
    ACTIONS(2933), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2935), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [13797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2796), 1,
      sym__preprocessor_call,
    ACTIONS(2957), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2959), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [13870] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2797), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [13981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2798), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14054] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2799), 1,
      sym__preprocessor_call,
    ACTIONS(3326), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3324), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2800), 1,
      sym__preprocessor_call,
    ACTIONS(2825), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2823), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14200] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2801), 1,
      sym__preprocessor_call,
    ACTIONS(5402), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5400), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14273] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2802), 1,
      sym__preprocessor_call,
    ACTIONS(5406), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5404), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14346] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2803), 1,
      sym__preprocessor_call,
    ACTIONS(3330), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3328), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14419] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2804), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [14532] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2805), 1,
      sym__preprocessor_call,
    ACTIONS(3334), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3332), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14605] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2806), 1,
      sym__preprocessor_call,
    ACTIONS(3318), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3316), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14678] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2807), 1,
      sym__preprocessor_call,
    ACTIONS(2911), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2913), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2808), 1,
      sym__preprocessor_call,
    ACTIONS(2813), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2811), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2809), 1,
      sym__preprocessor_call,
    ACTIONS(5410), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5408), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14897] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2810), 1,
      sym__preprocessor_call,
    ACTIONS(5414), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5412), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [14970] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2811), 1,
      sym__preprocessor_call,
    ACTIONS(5416), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3000), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [15043] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5347), 1,
      anon_sym_QMARK,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5373), 1,
      anon_sym_QMARK_QMARK,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2812), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5311), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [15170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2813), 1,
      sym__preprocessor_call,
    ACTIONS(3308), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3306), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [15243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2814), 1,
      sym__preprocessor_call,
    ACTIONS(2949), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2951), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [15316] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2815), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2816), 1,
      sym__preprocessor_call,
    ACTIONS(3352), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3350), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [15506] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2817), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [15621] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5200), 1,
      anon_sym_LBRACK,
    ACTIONS(5204), 1,
      anon_sym_STAR,
    STATE(2753), 1,
      sym_array_rank_specifier,
    STATE(2818), 1,
      sym__preprocessor_call,
    ACTIONS(3304), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3302), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [15700] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5426), 1,
      anon_sym_in,
    STATE(2819), 1,
      sym__preprocessor_call,
    ACTIONS(5418), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5420), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5423), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [15777] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    STATE(2820), 1,
      sym__preprocessor_call,
    ACTIONS(3376), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3374), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [15852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2821), 1,
      sym__preprocessor_call,
    ACTIONS(5430), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [15925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2822), 1,
      sym__preprocessor_call,
    ACTIONS(2903), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2905), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [15998] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2823), 1,
      sym__preprocessor_call,
    ACTIONS(2884), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2886), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2824), 1,
      sym__preprocessor_call,
    ACTIONS(2850), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2858), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16144] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2825), 1,
      sym__preprocessor_call,
    ACTIONS(3512), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3510), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2826), 1,
      sym__preprocessor_call,
    ACTIONS(3508), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3506), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16290] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2827), 1,
      sym__preprocessor_call,
    ACTIONS(3322), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3320), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16363] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2828), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 29,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [16460] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2829), 1,
      sym__preprocessor_call,
    ACTIONS(3504), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3502), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2830), 1,
      sym__preprocessor_call,
    ACTIONS(3500), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3498), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2831), 1,
      sym__preprocessor_call,
    ACTIONS(3492), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3490), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2832), 1,
      sym__preprocessor_call,
    ACTIONS(3312), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3310), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2833), 1,
      sym__preprocessor_call,
    ACTIONS(3488), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2834), 1,
      sym__preprocessor_call,
    ACTIONS(3484), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3482), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [16898] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1023), 1,
      anon_sym_LBRACE,
    STATE(2835), 1,
      sym__preprocessor_call,
    STATE(3113), 1,
      sym_initializer_expression,
    ACTIONS(3264), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3262), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [16975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2836), 1,
      sym__preprocessor_call,
    ACTIONS(3480), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3478), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [17048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2837), 1,
      sym__preprocessor_call,
    ACTIONS(3476), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3474), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [17121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2838), 1,
      sym__preprocessor_call,
    ACTIONS(2866), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2868), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [17194] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2839), 1,
      sym__preprocessor_call,
    ACTIONS(3472), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3470), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [17267] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2840), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 14,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 29,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17366] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2841), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5321), 32,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [17457] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2842), 1,
      sym__preprocessor_call,
    ACTIONS(3468), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3466), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [17530] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2843), 1,
      sym__preprocessor_call,
    ACTIONS(3464), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3462), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [17603] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(3520), 1,
      anon_sym_or,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5347), 1,
      anon_sym_QMARK,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5373), 1,
      anon_sym_QMARK_QMARK,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2844), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [17734] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5303), 1,
      anon_sym_or,
    ACTIONS(5347), 1,
      anon_sym_QMARK,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5365), 1,
      anon_sym_is,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5373), 1,
      anon_sym_QMARK_QMARK,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2845), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5301), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [17865] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2846), 1,
      sym__preprocessor_call,
    ACTIONS(3460), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3458), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [17938] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    STATE(2847), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [18013] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2848), 1,
      sym__preprocessor_call,
    ACTIONS(3452), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3450), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [18086] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2849), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5335), 31,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [18179] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2850), 1,
      sym__preprocessor_call,
    ACTIONS(2899), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2901), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [18252] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2837), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5432), 1,
      anon_sym_EQ_GT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2851), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 18,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2829), 37,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [18333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2852), 1,
      sym__preprocessor_call,
    ACTIONS(3440), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3438), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [18406] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2853), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 29,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [18509] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5367), 1,
      anon_sym_DOT_DOT,
    STATE(1385), 1,
      sym_assignment_operator,
    STATE(2854), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 29,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [18610] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    ACTIONS(5434), 1,
      anon_sym_TILDE,
    STATE(2855), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 57,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_event,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [18685] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2856), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 42,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [18758] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2857), 1,
      sym__preprocessor_call,
    ACTIONS(3432), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3430), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [18831] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(665), 1,
      anon_sym_params,
    ACTIONS(1945), 1,
      anon_sym_RPAREN,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(5436), 1,
      anon_sym_global,
    ACTIONS(5438), 1,
      anon_sym_LBRACK,
    STATE(2858), 1,
      sym__preprocessor_call,
    STATE(3323), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4643), 1,
      sym_identifier,
    STATE(4670), 1,
      sym_attribute_list,
    STATE(4749), 1,
      sym__type,
    STATE(6629), 1,
      sym__formal_parameter_list,
    STATE(6632), 1,
      sym_tuple_element,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(6103), 2,
      sym_parameter,
      sym__parameter_array,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(5440), 4,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [18952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2859), 1,
      sym__preprocessor_call,
    ACTIONS(3420), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3418), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [19025] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2860), 1,
      sym__preprocessor_call,
    ACTIONS(3392), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3390), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [19097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2861), 1,
      sym__preprocessor_call,
    ACTIONS(3468), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3466), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [19169] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2862), 1,
      sym__preprocessor_call,
    ACTIONS(3448), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3446), 39,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [19241] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    ACTIONS(5442), 1,
      anon_sym_DOT,
    STATE(2863), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [19317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2864), 1,
      sym__preprocessor_call,
    ACTIONS(5386), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5384), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [19389] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2852), 1,
      anon_sym_DASH_GT,
    ACTIONS(2855), 1,
      anon_sym_DOT,
    STATE(2865), 1,
      sym__preprocessor_call,
    ACTIONS(2995), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2993), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [19465] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5444), 1,
      anon_sym_into,
    STATE(2866), 1,
      sym__preprocessor_call,
    STATE(3044), 1,
      sym_query_continuation,
    ACTIONS(3516), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3514), 37,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [19541] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5444), 1,
      anon_sym_into,
    STATE(2867), 1,
      sym__preprocessor_call,
    STATE(3092), 1,
      sym_query_continuation,
    ACTIONS(5446), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5448), 37,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [19617] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2837), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5450), 1,
      anon_sym_EQ_GT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2868), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2829), 37,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [19697] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5454), 1,
      anon_sym_QMARK,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5478), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5480), 1,
      anon_sym_QMARK_QMARK,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2869), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5337), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [19825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2870), 1,
      sym__preprocessor_call,
    ACTIONS(1986), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(1981), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [19897] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2784), 1,
      anon_sym_LBRACK,
    ACTIONS(2788), 1,
      anon_sym_STAR,
    STATE(1809), 1,
      sym_array_rank_specifier,
    STATE(2871), 1,
      sym__preprocessor_call,
    ACTIONS(3304), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3302), 37,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [19975] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2872), 1,
      sym__preprocessor_call,
    ACTIONS(2769), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2771), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [20047] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2873), 1,
      sym__preprocessor_call,
    ACTIONS(3348), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3346), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [20119] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2874), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(725), 31,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [20211] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5482), 1,
      anon_sym_LPAREN,
    STATE(2875), 1,
      sym__preprocessor_call,
    ACTIONS(3342), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3340), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [20285] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2876), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5284), 32,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [20375] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2877), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5280), 32,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [20465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2878), 1,
      sym__preprocessor_call,
    ACTIONS(3338), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3336), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [20537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2879), 1,
      sym__preprocessor_call,
    ACTIONS(2825), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2823), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [20609] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2880), 1,
      sym__preprocessor_call,
    ACTIONS(2817), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2815), 39,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [20681] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2881), 1,
      sym__preprocessor_call,
    ACTIONS(3448), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3446), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [20753] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5454), 1,
      anon_sym_QMARK,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5478), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5480), 1,
      anon_sym_QMARK_QMARK,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2882), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5307), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [20881] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5454), 1,
      anon_sym_QMARK,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5478), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5480), 1,
      anon_sym_QMARK_QMARK,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2883), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5301), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [21009] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2884), 1,
      sym__preprocessor_call,
    ACTIONS(3067), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3075), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [21081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2885), 1,
      sym__preprocessor_call,
    ACTIONS(5410), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5408), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [21153] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5454), 1,
      anon_sym_QMARK,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5478), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5480), 1,
      anon_sym_QMARK_QMARK,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2886), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [21281] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2887), 1,
      sym__preprocessor_call,
    ACTIONS(5418), 14,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
    ACTIONS(5420), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5423), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [21355] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2888), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21469] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2889), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21585] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2890), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21697] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2891), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2892), 1,
      sym__preprocessor_call,
    ACTIONS(3412), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3410), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [21879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2893), 1,
      sym__preprocessor_call,
    ACTIONS(3508), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3506), 39,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [21951] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2894), 1,
      sym__preprocessor_call,
    ACTIONS(3436), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3434), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [22023] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2895), 1,
      sym__preprocessor_call,
    ACTIONS(3444), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3442), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [22095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    STATE(2896), 1,
      sym__preprocessor_call,
    ACTIONS(3376), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3374), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22169] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2897), 1,
      sym__preprocessor_call,
    ACTIONS(3400), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3398), 39,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22241] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2898), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [22359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2899), 1,
      sym__preprocessor_call,
    ACTIONS(5430), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [22431] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2900), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_PIPE_PIPE,
  [22551] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2901), 1,
      sym__preprocessor_call,
    ACTIONS(3360), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3358), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [22623] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5478), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5480), 1,
      anon_sym_QMARK_QMARK,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2902), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [22747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2903), 1,
      sym__preprocessor_call,
    ACTIONS(3364), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3362), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [22819] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5454), 1,
      anon_sym_QMARK,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5478), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5480), 1,
      anon_sym_QMARK_QMARK,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2904), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [22947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2905), 1,
      sym__preprocessor_call,
    ACTIONS(3308), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3306), 39,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23019] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5454), 1,
      anon_sym_QMARK,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5478), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5480), 1,
      anon_sym_QMARK_QMARK,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2906), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [23147] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2907), 1,
      sym__preprocessor_call,
    ACTIONS(2850), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2858), 39,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23219] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(2908), 1,
      sym__preprocessor_call,
    STATE(6662), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(1949), 53,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [23297] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5488), 1,
      anon_sym_LPAREN,
    STATE(2909), 1,
      sym__preprocessor_call,
    ACTIONS(5486), 57,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_event,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [23369] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2910), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5321), 32,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [23459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2911), 1,
      sym__preprocessor_call,
    ACTIONS(3396), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3394), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [23531] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2912), 1,
      sym__preprocessor_call,
    ACTIONS(5406), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5404), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [23603] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3069), 1,
      anon_sym_DOT,
    ACTIONS(3072), 1,
      anon_sym_DASH_GT,
    STATE(2913), 1,
      sym__preprocessor_call,
    ACTIONS(3067), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3075), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [23679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2914), 1,
      sym__preprocessor_call,
    ACTIONS(3404), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3402), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [23751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2915), 1,
      sym__preprocessor_call,
    ACTIONS(3368), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3366), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [23823] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2916), 1,
      sym__preprocessor_call,
    ACTIONS(3372), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3370), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [23895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2917), 1,
      sym__preprocessor_call,
    ACTIONS(3408), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3406), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [23967] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2918), 1,
      sym__preprocessor_call,
    ACTIONS(3424), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3422), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24039] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(2919), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 57,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_event,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [24111] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(2920), 1,
      sym__preprocessor_call,
    STATE(6662), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(1949), 54,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [24187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2921), 1,
      sym__preprocessor_call,
    ACTIONS(3388), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3386), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24259] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2922), 1,
      sym__preprocessor_call,
    ACTIONS(3384), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3382), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24331] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2923), 1,
      sym__preprocessor_call,
    ACTIONS(1984), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(1989), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2924), 1,
      sym__preprocessor_call,
    ACTIONS(1979), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(1977), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2925), 1,
      sym__preprocessor_call,
    ACTIONS(3380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3378), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2926), 1,
      sym__preprocessor_call,
    ACTIONS(3400), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3398), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2927), 1,
      sym__preprocessor_call,
    ACTIONS(3326), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3324), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24691] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2928), 1,
      sym__preprocessor_call,
    ACTIONS(3416), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3414), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2929), 1,
      sym__preprocessor_call,
    ACTIONS(3428), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3426), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24835] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2930), 1,
      sym__preprocessor_call,
    ACTIONS(3330), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3328), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2931), 1,
      sym__preprocessor_call,
    ACTIONS(3456), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3454), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [24979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2932), 1,
      sym__preprocessor_call,
    ACTIONS(3524), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3522), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25051] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2933), 1,
      sym__preprocessor_call,
    ACTIONS(2216), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2214), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2934), 1,
      sym__preprocessor_call,
    ACTIONS(3540), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3538), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25195] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2935), 1,
      sym__preprocessor_call,
    ACTIONS(3548), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3546), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25267] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2936), 1,
      sym__preprocessor_call,
    ACTIONS(3334), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3332), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2937), 1,
      sym__preprocessor_call,
    ACTIONS(3057), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3059), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25411] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2938), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5335), 31,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [25503] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2939), 1,
      sym__preprocessor_call,
    ACTIONS(2995), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2993), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2940), 1,
      sym__preprocessor_call,
    ACTIONS(3352), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3350), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25647] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2941), 1,
      sym__preprocessor_call,
    ACTIONS(3544), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3542), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25719] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2942), 1,
      sym__preprocessor_call,
    ACTIONS(3536), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3534), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2943), 1,
      sym__preprocessor_call,
    ACTIONS(3532), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3530), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2944), 1,
      sym__preprocessor_call,
    ACTIONS(3528), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3526), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [25935] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2945), 1,
      sym__preprocessor_call,
    ACTIONS(5414), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5412), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26007] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2946), 1,
      sym__preprocessor_call,
    ACTIONS(3520), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3518), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26079] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2947), 1,
      sym__preprocessor_call,
    ACTIONS(5416), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3000), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2948), 1,
      sym__preprocessor_call,
    ACTIONS(5390), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5388), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2949), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26295] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2950), 1,
      sym__preprocessor_call,
    ACTIONS(3356), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3354), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2951), 1,
      sym__preprocessor_call,
    ACTIONS(5402), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5400), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2952), 1,
      sym__preprocessor_call,
    ACTIONS(3376), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3374), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26511] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5454), 1,
      anon_sym_QMARK,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5478), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5480), 1,
      anon_sym_QMARK_QMARK,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2953), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [26639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2954), 1,
      sym__preprocessor_call,
    ACTIONS(5394), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5392), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26711] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2955), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 11,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 29,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [26811] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2956), 1,
      sym__preprocessor_call,
    ACTIONS(3420), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3418), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2957), 1,
      sym__preprocessor_call,
    ACTIONS(2813), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2811), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [26955] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2958), 1,
      sym__preprocessor_call,
    ACTIONS(3432), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3430), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [27027] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(665), 1,
      anon_sym_params,
    ACTIONS(1945), 1,
      anon_sym_RPAREN,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2767), 1,
      anon_sym_global,
    ACTIONS(5438), 1,
      anon_sym_LBRACK,
    STATE(2959), 1,
      sym__preprocessor_call,
    STATE(3323), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4634), 1,
      sym_identifier,
    STATE(4670), 1,
      sym_attribute_list,
    STATE(4899), 1,
      sym__type,
    STATE(6629), 1,
      sym__formal_parameter_list,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(6103), 2,
      sym_parameter,
      sym__parameter_array,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(5440), 4,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [27145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2960), 1,
      sym__preprocessor_call,
    ACTIONS(3318), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3316), 39,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(2961), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 57,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_event,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_implicit,
      anon_sym_explicit,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [27289] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2962), 1,
      sym__preprocessor_call,
    ACTIONS(3440), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3438), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [27361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2963), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [27433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2964), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [27505] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5454), 1,
      anon_sym_QMARK,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5478), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5480), 1,
      anon_sym_QMARK_QMARK,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2965), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [27631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2966), 1,
      sym__preprocessor_call,
    ACTIONS(3312), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3310), 39,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27703] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2967), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 29,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [27799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2968), 1,
      sym__preprocessor_call,
    ACTIONS(3452), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3450), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [27871] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2969), 1,
      sym__preprocessor_call,
    ACTIONS(3460), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3458), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [27943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2970), 1,
      sym__preprocessor_call,
    ACTIONS(3464), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3462), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [28015] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    ACTIONS(5490), 1,
      anon_sym_DOT,
    STATE(2971), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2894), 39,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3075), 1,
      anon_sym_COLON,
    STATE(2972), 1,
      sym__preprocessor_call,
    ACTIONS(3376), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3374), 40,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [28165] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2973), 1,
      sym__preprocessor_call,
    ACTIONS(3472), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3470), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [28237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2974), 1,
      sym__preprocessor_call,
    ACTIONS(3476), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3474), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [28309] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2975), 1,
      sym__preprocessor_call,
    ACTIONS(3480), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3478), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [28381] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5454), 1,
      anon_sym_QMARK,
    ACTIONS(5460), 1,
      anon_sym_CARET,
    ACTIONS(5462), 1,
      anon_sym_PIPE,
    ACTIONS(5464), 1,
      anon_sym_AMP,
    ACTIONS(5472), 1,
      anon_sym_is,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5476), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5478), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5480), 1,
      anon_sym_QMARK_QMARK,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2976), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5452), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5468), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5470), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
    ACTIONS(5266), 11,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [28509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2977), 1,
      sym__preprocessor_call,
    ACTIONS(3512), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3510), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [28581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2978), 1,
      sym__preprocessor_call,
    ACTIONS(3484), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3482), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [28653] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2979), 1,
      sym__preprocessor_call,
    ACTIONS(3488), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3486), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [28725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2980), 1,
      sym__preprocessor_call,
    ACTIONS(3508), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3506), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [28797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2981), 1,
      sym__preprocessor_call,
    ACTIONS(3322), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3320), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [28869] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2982), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5456), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5466), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 9,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 29,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [28971] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5474), 1,
      anon_sym_DOT_DOT,
    STATE(1161), 1,
      sym_assignment_operator,
    STATE(2983), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5458), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 13,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 29,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29069] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2984), 1,
      sym__preprocessor_call,
    ACTIONS(3504), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3502), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [29141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2985), 1,
      sym__preprocessor_call,
    ACTIONS(3500), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3498), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [29213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2986), 1,
      sym__preprocessor_call,
    ACTIONS(3492), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3490), 41,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_in,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [29285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2987), 1,
      sym__preprocessor_call,
    ACTIONS(3444), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3442), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2988), 1,
      sym__preprocessor_call,
    ACTIONS(3496), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3494), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29427] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2989), 1,
      sym__preprocessor_call,
    ACTIONS(3428), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3426), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29498] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(2990), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29607] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2991), 1,
      sym__preprocessor_call,
    ACTIONS(3380), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3378), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29678] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2852), 1,
      anon_sym_DASH_GT,
    ACTIONS(2855), 1,
      anon_sym_DOT,
    STATE(2992), 1,
      sym__preprocessor_call,
    ACTIONS(2995), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2993), 37,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2993), 1,
      sym__preprocessor_call,
    ACTIONS(2813), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2811), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29824] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2837), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5516), 1,
      anon_sym_EQ_GT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2994), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2829), 36,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [29903] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(2995), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2996), 1,
      sym__preprocessor_call,
    ACTIONS(5410), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5408), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30085] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5426), 1,
      anon_sym_or,
    STATE(2997), 1,
      sym__preprocessor_call,
    ACTIONS(5418), 12,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5420), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5423), 26,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30160] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2998), 1,
      sym__preprocessor_call,
    ACTIONS(3356), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3354), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(2999), 1,
      sym__preprocessor_call,
    ACTIONS(3456), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3454), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30302] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3000), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5378), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3001), 1,
      sym__preprocessor_call,
    ACTIONS(3404), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3402), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30444] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3002), 1,
      sym__preprocessor_call,
    ACTIONS(3524), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3522), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30515] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5522), 1,
      anon_sym_QMARK,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5544), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5546), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5548), 1,
      anon_sym_QMARK_QMARK,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3003), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [30642] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3004), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_PIPE_PIPE,
  [30761] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3005), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 9,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 28,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30862] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3006), 1,
      sym__preprocessor_call,
    ACTIONS(5414), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5412), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [30933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3007), 1,
      sym__preprocessor_call,
    ACTIONS(5416), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3000), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31004] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3008), 1,
      sym__preprocessor_call,
    ACTIONS(3460), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3458), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31075] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3009), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 20,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [31198] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5562), 1,
      anon_sym_and,
    STATE(3010), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5396), 37,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31271] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5259), 1,
      anon_sym_or,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3011), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [31400] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3012), 1,
      sym__preprocessor_call,
    ACTIONS(3360), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3358), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31471] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3013), 1,
      sym__preprocessor_call,
    ACTIONS(3384), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3382), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31542] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3014), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [31671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3015), 1,
      sym__preprocessor_call,
    ACTIONS(3408), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3406), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31742] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3016), 1,
      sym__preprocessor_call,
    ACTIONS(3067), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3075), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3017), 1,
      sym__preprocessor_call,
    ACTIONS(3416), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3414), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31884] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3018), 1,
      sym__preprocessor_call,
    ACTIONS(3436), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3434), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [31955] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5522), 1,
      anon_sym_QMARK,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5544), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5546), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5548), 1,
      anon_sym_QMARK_QMARK,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3019), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [32082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3020), 1,
      sym__preprocessor_call,
    ACTIONS(2216), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2214), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32153] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3021), 1,
      sym__preprocessor_call,
    ACTIONS(1979), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(1977), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32224] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(3352), 1,
      anon_sym_or,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3022), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [32353] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3023), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32466] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(665), 1,
      anon_sym_params,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2767), 1,
      anon_sym_global,
    ACTIONS(5438), 1,
      anon_sym_LBRACK,
    STATE(3024), 1,
      sym__preprocessor_call,
    STATE(3323), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4634), 1,
      sym_identifier,
    STATE(4670), 1,
      sym_attribute_list,
    STATE(4899), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6976), 1,
      sym__formal_parameter_list,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(6103), 2,
      sym_parameter,
      sym__parameter_array,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(5440), 4,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [32581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3025), 1,
      sym__preprocessor_call,
    ACTIONS(2825), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2823), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32652] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3026), 1,
      sym__preprocessor_call,
    ACTIONS(5270), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 20,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [32777] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3027), 1,
      sym__preprocessor_call,
    ACTIONS(3338), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3336), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [32848] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5522), 1,
      anon_sym_QMARK,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5544), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5546), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5548), 1,
      anon_sym_QMARK_QMARK,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3028), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [32973] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3029), 1,
      sym__preprocessor_call,
    ACTIONS(3376), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3374), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33044] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3030), 1,
      sym__preprocessor_call,
    ACTIONS(5406), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5404), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33115] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3031), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 31,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [33204] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3032), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 31,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [33293] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3033), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 30,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [33384] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3034), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 13,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 28,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33481] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3035), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 28,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33576] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3036), 1,
      sym__preprocessor_call,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 11,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5215), 28,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33675] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3037), 1,
      sym__preprocessor_call,
    ACTIONS(3368), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3366), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33746] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3038), 1,
      sym__preprocessor_call,
    ACTIONS(3364), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3362), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3039), 1,
      sym__preprocessor_call,
    ACTIONS(1986), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(1981), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33888] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3040), 1,
      sym__preprocessor_call,
    ACTIONS(5402), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5400), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [33959] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3041), 1,
      sym__preprocessor_call,
    ACTIONS(3420), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3418), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34030] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5562), 1,
      anon_sym_and,
    ACTIONS(5566), 1,
      anon_sym_or,
    STATE(3042), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5378), 37,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3043), 1,
      sym__preprocessor_call,
    ACTIONS(3432), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3430), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3044), 1,
      sym__preprocessor_call,
    ACTIONS(3440), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3438), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34247] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3045), 1,
      sym__preprocessor_call,
    ACTIONS(3548), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3546), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34318] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3046), 1,
      sym__preprocessor_call,
    ACTIONS(3540), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3538), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34389] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3047), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 11,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 28,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [34488] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3048), 1,
      sym__preprocessor_call,
    ACTIONS(3057), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3059), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34559] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5562), 1,
      anon_sym_and,
    ACTIONS(5566), 1,
      anon_sym_or,
    STATE(3049), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5570), 37,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34634] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3050), 1,
      sym__preprocessor_call,
    ACTIONS(3452), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3450), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34705] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3051), 1,
      sym__preprocessor_call,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(725), 30,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [34796] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5522), 1,
      anon_sym_QMARK,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5544), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5546), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5548), 1,
      anon_sym_QMARK_QMARK,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3052), 1,
      sym__preprocessor_call,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [34923] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(3520), 1,
      anon_sym_or,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3053), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [35052] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5303), 1,
      anon_sym_or,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3054), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [35181] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3055), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35296] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3056), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35413] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3057), 1,
      sym__preprocessor_call,
    ACTIONS(5390), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5388), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35484] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5544), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5546), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5548), 1,
      anon_sym_QMARK_QMARK,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3058), 1,
      sym__preprocessor_call,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 21,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
  [35607] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5544), 1,
      anon_sym_AMP_AMP,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3059), 1,
      sym__preprocessor_call,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 22,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_PIPE_PIPE,
  [35726] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3060), 1,
      sym__preprocessor_call,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3061), 1,
      sym__preprocessor_call,
    ACTIONS(3484), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3482), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [35914] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(3062), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6623), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1949), 22,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [36003] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5522), 1,
      anon_sym_QMARK,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5544), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5546), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5548), 1,
      anon_sym_QMARK_QMARK,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3063), 1,
      sym__preprocessor_call,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5574), 2,
      anon_sym_ascending,
      anon_sym_descending,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5572), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [36132] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3064), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 9,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 28,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [36233] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3065), 1,
      sym__preprocessor_call,
    ACTIONS(3492), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3490), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36304] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3066), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 13,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 28,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [36401] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3067), 1,
      sym__preprocessor_call,
    ACTIONS(5430), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5428), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36472] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3068), 1,
      sym__preprocessor_call,
    STATE(3074), 1,
      sym_argument_list,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5284), 31,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36561] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3069), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 28,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [36656] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3070), 1,
      sym__preprocessor_call,
    ACTIONS(3500), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3498), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3071), 1,
      sym__preprocessor_call,
    ACTIONS(2769), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2771), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36798] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3072), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 30,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [36889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3073), 1,
      sym__preprocessor_call,
    ACTIONS(3388), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3386), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [36960] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3074), 1,
      sym__preprocessor_call,
    ACTIONS(3372), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3370), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37031] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3069), 1,
      anon_sym_DOT,
    ACTIONS(3072), 1,
      anon_sym_DASH_GT,
    STATE(3075), 1,
      sym__preprocessor_call,
    ACTIONS(3067), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3075), 37,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37106] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3076), 1,
      sym__preprocessor_call,
    ACTIONS(2995), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(2993), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3077), 1,
      sym__preprocessor_call,
    ACTIONS(3326), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3324), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37248] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(5576), 1,
      anon_sym_COLON_COLON,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3078), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 37,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [37325] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3079), 1,
      sym__preprocessor_call,
    ACTIONS(3330), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3328), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37396] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(3080), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37505] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3081), 1,
      sym__preprocessor_call,
    ACTIONS(3464), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3462), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37576] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3082), 1,
      sym__preprocessor_call,
    ACTIONS(3504), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3502), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37647] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(3083), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37758] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(3084), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37873] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(3085), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [37986] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(3086), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5321), 31,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38075] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3087), 1,
      sym__preprocessor_call,
    ACTIONS(3322), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3320), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38146] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3088), 1,
      sym__preprocessor_call,
    ACTIONS(3468), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3466), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38217] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3089), 1,
      sym__preprocessor_call,
    ACTIONS(3334), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3332), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38288] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3090), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 31,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [38377] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5578), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3091), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [38456] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3092), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3514), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3093), 1,
      sym__preprocessor_call,
    ACTIONS(3348), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3346), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38598] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5339), 1,
      anon_sym_or,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3094), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [38727] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5522), 1,
      anon_sym_QMARK,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5544), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5546), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5548), 1,
      anon_sym_QMARK_QMARK,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(3095), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [38854] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3096), 1,
      sym__preprocessor_call,
    ACTIONS(3412), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3410), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3097), 1,
      sym__preprocessor_call,
    ACTIONS(3396), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3394), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [38996] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3098), 1,
      sym__preprocessor_call,
    ACTIONS(3472), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3470), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3099), 1,
      sym__preprocessor_call,
    ACTIONS(1984), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(1989), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39138] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5580), 1,
      anon_sym_LPAREN,
    STATE(3100), 1,
      sym__preprocessor_call,
    ACTIONS(3342), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3340), 37,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39211] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3101), 1,
      sym__preprocessor_call,
    ACTIONS(3512), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3510), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39282] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3102), 1,
      sym__preprocessor_call,
    ACTIONS(3544), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3542), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3103), 1,
      sym__preprocessor_call,
    ACTIONS(3476), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3474), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39424] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(3104), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5280), 31,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39513] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3105), 1,
      sym__preprocessor_call,
    ACTIONS(3536), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3534), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3106), 1,
      sym__preprocessor_call,
    ACTIONS(3532), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3530), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3107), 1,
      sym__preprocessor_call,
    ACTIONS(3528), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3526), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39726] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3108), 1,
      sym__preprocessor_call,
    ACTIONS(3352), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3350), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3109), 1,
      sym__preprocessor_call,
    ACTIONS(5386), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5384), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39868] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3110), 1,
      sym__preprocessor_call,
    ACTIONS(3480), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3478), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [39939] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(3111), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5335), 30,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40030] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5522), 1,
      anon_sym_QMARK,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5544), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5546), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5548), 1,
      anon_sym_QMARK_QMARK,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(3112), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [40157] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3113), 1,
      sym__preprocessor_call,
    ACTIONS(3488), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3486), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40228] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3114), 1,
      sym__preprocessor_call,
    ACTIONS(3520), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3518), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40299] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3115), 1,
      sym__preprocessor_call,
    ACTIONS(5394), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5392), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40370] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3116), 1,
      sym__preprocessor_call,
    ACTIONS(5311), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 20,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [40495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3117), 1,
      sym__preprocessor_call,
    ACTIONS(3424), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3422), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [40566] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5309), 1,
      anon_sym_or,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3118), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [40695] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1009), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5237), 1,
      anon_sym_switch,
    ACTIONS(5243), 1,
      anon_sym_with,
    ACTIONS(5251), 1,
      anon_sym_as,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5522), 1,
      anon_sym_QMARK,
    ACTIONS(5528), 1,
      anon_sym_CARET,
    ACTIONS(5530), 1,
      anon_sym_PIPE,
    ACTIONS(5532), 1,
      anon_sym_AMP,
    ACTIONS(5540), 1,
      anon_sym_is,
    ACTIONS(5542), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5544), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5546), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5548), 1,
      anon_sym_QMARK_QMARK,
    STATE(1507), 1,
      sym_assignment_operator,
    STATE(3037), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(3119), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5520), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5524), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5534), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5536), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5538), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5526), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 10,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [40822] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(5582), 1,
      anon_sym_COLON_COLON,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3120), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 37,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [40899] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5268), 1,
      anon_sym_or,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5508), 1,
      anon_sym_is,
    ACTIONS(5510), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5564), 1,
      anon_sym_QMARK,
    STATE(1505), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3121), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [41028] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(1600), 1,
      sym_block,
    STATE(3122), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 54,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [41103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3123), 1,
      sym__preprocessor_call,
    ACTIONS(3392), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3390), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41174] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3124), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5396), 38,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41245] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3125), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [41361] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5582), 1,
      anon_sym_COLON_COLON,
    STATE(3126), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 37,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [41433] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3127), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [41527] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5309), 1,
      anon_sym_in,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3128), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [41655] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3129), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [41745] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5197), 1,
      anon_sym_LT,
    ACTIONS(5658), 1,
      anon_sym_EQ_GT,
    STATE(2714), 1,
      sym_type_argument_list,
    STATE(3130), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 35,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [41823] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3131), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [41911] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3132), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 13,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [42007] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5660), 1,
      sym__identifier_token,
    ACTIONS(5669), 1,
      anon_sym_LBRACK,
    ACTIONS(5672), 1,
      anon_sym_ref,
    ACTIONS(5675), 1,
      anon_sym_RBRACE,
    ACTIONS(5680), 1,
      anon_sym_init,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(3381), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(3735), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(4303), 1,
      sym_accessor_declaration,
    STATE(4492), 1,
      sym_attribute_list,
    STATE(4521), 1,
      sym_modifier,
    STATE(5909), 1,
      sym_identifier,
    STATE(3133), 2,
      sym__preprocessor_call,
      aux_sym_accessor_list_repeat1,
    ACTIONS(5677), 4,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
    ACTIONS(5663), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
    ACTIONS(5666), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [42103] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5339), 1,
      anon_sym_in,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3134), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [42231] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3135), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 30,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [42319] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5683), 1,
      anon_sym_and,
    ACTIONS(5685), 1,
      anon_sym_or,
    STATE(3136), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5378), 36,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42393] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3137), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 11,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [42491] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5711), 1,
      anon_sym_into,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3138), 1,
      sym__preprocessor_call,
    STATE(5873), 1,
      sym_join_into_clause,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5689), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [42621] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3139), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 9,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [42721] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3140), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [42809] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5683), 1,
      anon_sym_and,
    STATE(3141), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 19,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5396), 36,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [42881] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5721), 1,
      anon_sym_QMARK,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5725), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_QMARK_QMARK,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3142), 1,
      sym__preprocessor_call,
    ACTIONS(5270), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 19,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [43005] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3143), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43117] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3352), 1,
      anon_sym_or,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5721), 1,
      anon_sym_QMARK,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5725), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_QMARK_QMARK,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3144), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [43245] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3512), 1,
      anon_sym_or,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5721), 1,
      anon_sym_QMARK,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5725), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_QMARK_QMARK,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3145), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [43373] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3146), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 29,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [43463] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5259), 1,
      anon_sym_or,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5721), 1,
      anon_sym_QMARK,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5725), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_QMARK_QMARK,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3147), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [43591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5729), 1,
      anon_sym_into,
    STATE(3092), 1,
      sym_query_continuation,
    STATE(3148), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5448), 36,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [43665] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5725), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_QMARK_QMARK,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3149), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 19,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [43787] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3150), 1,
      sym__preprocessor_call,
    ACTIONS(5270), 2,
      anon_sym_EQ,
      anon_sym_in,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [43911] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(3352), 1,
      anon_sym_in,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3151), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [44039] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3152), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 29,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [44129] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(3512), 1,
      anon_sym_in,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3153), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [44257] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5259), 1,
      anon_sym_in,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3154), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [44385] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3155), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_PIPE_PIPE,
  [44503] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3156), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [44625] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3157), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [44743] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5721), 1,
      anon_sym_QMARK,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5725), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_QMARK_QMARK,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3158), 1,
      sym__preprocessor_call,
    ACTIONS(5311), 2,
      anon_sym_EQ,
      anon_sym_or,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 19,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [44867] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3159), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [44975] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3160), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45091] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5683), 1,
      anon_sym_and,
    ACTIONS(5685), 1,
      anon_sym_or,
    STATE(3161), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(5570), 36,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45165] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5733), 1,
      anon_sym_LBRACK,
    ACTIONS(5735), 1,
      anon_sym_ref,
    ACTIONS(5737), 1,
      anon_sym_RBRACE,
    ACTIONS(5741), 1,
      anon_sym_init,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(3162), 1,
      sym__preprocessor_call,
    STATE(3176), 1,
      aux_sym_accessor_list_repeat1,
    STATE(3381), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(3735), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(4303), 1,
      sym_accessor_declaration,
    STATE(4492), 1,
      sym_attribute_list,
    STATE(4521), 1,
      sym_modifier,
    STATE(5909), 1,
      sym_identifier,
    ACTIONS(5739), 4,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
    ACTIONS(5731), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
    ACTIONS(13), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [45263] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3163), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45373] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3164), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_where,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45487] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5303), 1,
      anon_sym_in,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3165), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [45615] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5711), 1,
      anon_sym_into,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3166), 1,
      sym__preprocessor_call,
    STATE(5843), 1,
      sym_join_into_clause,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5743), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [45745] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3167), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 30,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [45833] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3168), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [45941] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3169), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46051] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3520), 1,
      anon_sym_or,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5721), 1,
      anon_sym_QMARK,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5725), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_QMARK_QMARK,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3170), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [46179] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3171), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46293] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5303), 1,
      anon_sym_or,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5721), 1,
      anon_sym_QMARK,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5725), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_QMARK_QMARK,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3172), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [46421] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3173), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [46533] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3174), 1,
      sym__preprocessor_call,
    ACTIONS(5311), 2,
      anon_sym_EQ,
      anon_sym_in,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [46657] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5268), 1,
      anon_sym_in,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3175), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [46785] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5733), 1,
      anon_sym_LBRACK,
    ACTIONS(5735), 1,
      anon_sym_ref,
    ACTIONS(5741), 1,
      anon_sym_init,
    ACTIONS(5745), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(3133), 1,
      aux_sym_accessor_list_repeat1,
    STATE(3176), 1,
      sym__preprocessor_call,
    STATE(3381), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(3735), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(4303), 1,
      sym_accessor_declaration,
    STATE(4492), 1,
      sym_attribute_list,
    STATE(4521), 1,
      sym_modifier,
    STATE(5909), 1,
      sym_identifier,
    ACTIONS(5739), 4,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
    ACTIONS(5731), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
    ACTIONS(13), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [46883] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(3520), 1,
      anon_sym_in,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5620), 1,
      anon_sym_QMARK,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5644), 1,
      anon_sym_is,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5656), 1,
      anon_sym_as,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3177), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 8,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [47011] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(665), 1,
      anon_sym_params,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2767), 1,
      anon_sym_global,
    ACTIONS(5438), 1,
      anon_sym_LBRACK,
    STATE(3178), 1,
      sym__preprocessor_call,
    STATE(3323), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4634), 1,
      sym_identifier,
    STATE(4670), 1,
      sym_attribute_list,
    STATE(4899), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(6253), 2,
      sym_parameter,
      sym__parameter_array,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(5440), 4,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [47123] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5729), 1,
      anon_sym_into,
    STATE(3044), 1,
      sym_query_continuation,
    STATE(3179), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
      anon_sym_as,
    ACTIONS(3514), 36,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [47197] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5747), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3180), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 35,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [47275] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3181), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 30,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [47363] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3182), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 9,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [47463] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3183), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 13,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [47559] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3184), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [47653] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5648), 1,
      anon_sym_with,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3185), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 11,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [47751] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5646), 1,
      anon_sym_DOT_DOT,
    STATE(1331), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3186), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [47841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5576), 1,
      anon_sym_COLON_COLON,
    STATE(3187), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 37,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [47913] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5309), 1,
      anon_sym_or,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5610), 1,
      anon_sym_is,
    ACTIONS(5612), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5721), 1,
      anon_sym_QMARK,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5725), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_QMARK_QMARK,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3188), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 8,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [48041] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(848), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3189), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 30,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [48129] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3190), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [48254] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3191), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 30,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [48341] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3192), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 19,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [48464] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3193), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [48589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5749), 1,
      anon_sym_into,
    STATE(2317), 1,
      sym_query_continuation,
    STATE(3194), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 35,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [48662] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5751), 1,
      anon_sym_into,
    STATE(2173), 1,
      sym_query_continuation,
    STATE(3195), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 35,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [48735] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3196), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [48860] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5751), 1,
      anon_sym_into,
    STATE(2141), 1,
      sym_query_continuation,
    STATE(3197), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 35,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [48933] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3198), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 30,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [49020] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3199), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 30,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [49107] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3200), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 29,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [49196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    ACTIONS(5753), 1,
      anon_sym_alias,
    STATE(3201), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 53,
      anon_sym_extern,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [49267] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    ACTIONS(5755), 1,
      anon_sym_DOT,
    STATE(3202), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 37,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [49340] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3203), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [49465] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(5759), 1,
      anon_sym_GT,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    STATE(3204), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4730), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(5649), 1,
      sym_identifier,
    STATE(5902), 1,
      sym__type,
    STATE(6231), 1,
      sym_type_parameter,
    STATE(6309), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(5763), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [49580] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3205), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [49705] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3206), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 19,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [49826] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3207), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 20,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_PIPE_PIPE,
  [49943] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5765), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3208), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 35,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [50020] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5749), 1,
      anon_sym_into,
    STATE(2262), 1,
      sym_query_continuation,
    STATE(3209), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 35,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [50093] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3210), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [50218] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5767), 1,
      anon_sym_LPAREN,
    STATE(3211), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 54,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [50287] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3212), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 21,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50402] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3213), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50509] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3214), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50618] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3215), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50731] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3216), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [50842] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    ACTIONS(5769), 1,
      anon_sym_DOT,
    STATE(3217), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 37,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [50915] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3218), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [51040] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5514), 1,
      anon_sym_as,
    ACTIONS(5691), 1,
      anon_sym_QMARK,
    ACTIONS(5697), 1,
      anon_sym_CARET,
    ACTIONS(5699), 1,
      anon_sym_PIPE,
    ACTIONS(5701), 1,
      anon_sym_AMP,
    ACTIONS(5709), 1,
      anon_sym_is,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5715), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5717), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5719), 1,
      anon_sym_QMARK_QMARK,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3219), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5687), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5705), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5707), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 8,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [51165] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3220), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 29,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [51254] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3221), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5703), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [51353] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3222), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [51448] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3223), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [51541] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5713), 1,
      anon_sym_DOT_DOT,
    STATE(1137), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3224), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5693), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5695), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 27,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [51638] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5799), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5801), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5803), 1,
      anon_sym_as,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3225), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [51758] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3226), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [51866] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5823), 1,
      anon_sym_QMARK,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3227), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [51990] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3228), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [52114] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3229), 1,
      sym__preprocessor_call,
    ACTIONS(5386), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5384), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [52182] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5875), 1,
      anon_sym_into,
    STATE(2852), 1,
      sym_query_continuation,
    STATE(3230), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [52254] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3231), 1,
      sym__preprocessor_call,
    ACTIONS(5410), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5408), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [52322] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5268), 1,
      anon_sym_in,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5799), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5801), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(5877), 1,
      anon_sym_QMARK,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3232), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [52448] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3233), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [52560] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3234), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [52648] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5879), 1,
      anon_sym_into,
    STATE(2962), 1,
      sym_query_continuation,
    STATE(3235), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [52720] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3236), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 9,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [52818] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3237), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 13,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [52912] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3238), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [53004] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5881), 1,
      anon_sym_and,
    ACTIONS(5883), 1,
      anon_sym_or,
    STATE(3239), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 35,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [53076] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3240), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 11,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [53172] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5197), 1,
      anon_sym_LT,
    ACTIONS(5885), 1,
      anon_sym_EQ_GT,
    STATE(2714), 1,
      sym_type_argument_list,
    STATE(3241), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 33,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [53248] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3242), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [53372] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3243), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [53494] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(5917), 1,
      anon_sym_EQ_GT,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(3244), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [53570] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3245), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [53694] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5823), 1,
      anon_sym_QMARK,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3246), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [53816] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3247), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [53884] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5799), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5801), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(5877), 1,
      anon_sym_QMARK,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3248), 1,
      sym__preprocessor_call,
    ACTIONS(5270), 2,
      anon_sym_EQ,
      anon_sym_in,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [54006] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3249), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [54130] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3250), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54240] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3251), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 29,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [54326] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3252), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [54434] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(3352), 1,
      anon_sym_in,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5799), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5801), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(5877), 1,
      anon_sym_QMARK,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3253), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [54560] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3254), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [54684] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5881), 1,
      anon_sym_and,
    ACTIONS(5883), 1,
      anon_sym_or,
    STATE(3255), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 35,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [54756] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3256), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_PIPE_PIPE,
  [54872] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3257), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [54960] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5823), 1,
      anon_sym_QMARK,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3258), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [55082] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3259), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5919), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [55206] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3260), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [55292] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3261), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5921), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [55416] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5426), 1,
      anon_sym_or,
    STATE(3262), 1,
      sym__preprocessor_call,
    ACTIONS(5418), 9,
      anon_sym_where,
      anon_sym_and,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5420), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5423), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [55488] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3263), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [55608] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3264), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 19,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [55724] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3265), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [55810] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5823), 1,
      anon_sym_QMARK,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3266), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [55934] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3267), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 19,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_PIPE_PIPE,
  [56050] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3268), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 29,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [56136] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(3512), 1,
      anon_sym_in,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5799), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5801), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(5877), 1,
      anon_sym_QMARK,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3269), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [56262] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3270), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 20,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56376] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5259), 1,
      anon_sym_in,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5799), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5801), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(5877), 1,
      anon_sym_QMARK,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3271), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [56502] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3272), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [56590] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5803), 1,
      anon_sym_as,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3273), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [56706] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5803), 1,
      anon_sym_as,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3274), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [56820] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3275), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [56908] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5881), 1,
      anon_sym_and,
    STATE(3276), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 35,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [56978] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3277), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57084] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3278), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57192] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3279), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [57316] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3280), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57428] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3281), 1,
      sym__preprocessor_call,
    ACTIONS(2813), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(2811), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [57496] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3282), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [57606] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3283), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [57730] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3284), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [57828] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3285), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [57922] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5879), 1,
      anon_sym_into,
    STATE(2949), 1,
      sym_query_continuation,
    STATE(3286), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [57994] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3287), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 29,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [58080] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3288), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [58166] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3289), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [58290] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3290), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [58414] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3291), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 7,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [58538] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5823), 1,
      anon_sym_QMARK,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3292), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [58662] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5803), 1,
      anon_sym_as,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3293), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58768] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3294), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [58878] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3295), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [58974] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5803), 1,
      anon_sym_as,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3296), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 7,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59082] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5803), 1,
      anon_sym_as,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3297), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59194] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3298), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [59286] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5803), 1,
      anon_sym_as,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3299), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59396] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3300), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [59492] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3301), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [59616] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3302), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 28,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [59704] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3303), 1,
      sym__preprocessor_call,
    ACTIONS(5414), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5412), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [59772] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3304), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [59864] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3305), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [59976] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3306), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [60070] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3307), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [60168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3308), 1,
      sym__preprocessor_call,
    ACTIONS(5394), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5392), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [60236] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3309), 1,
      sym__preprocessor_call,
    ACTIONS(5416), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(3000), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [60304] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3310), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [60410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3311), 1,
      sym__preprocessor_call,
    ACTIONS(5406), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5404), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [60478] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(3520), 1,
      anon_sym_in,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5799), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5801), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(5877), 1,
      anon_sym_QMARK,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3312), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [60604] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3313), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 29,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [60690] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3314), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 28,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [60778] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3315), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 28,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [60866] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3316), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 18,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [60988] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5923), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3317), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [61064] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5303), 1,
      anon_sym_in,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5799), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5801), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(5877), 1,
      anon_sym_QMARK,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3318), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [61190] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3319), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [61286] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3320), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [61378] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3321), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [61472] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3322), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 26,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [61570] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2767), 1,
      anon_sym_global,
    ACTIONS(5438), 1,
      anon_sym_LBRACK,
    ACTIONS(5927), 1,
      anon_sym_params,
    STATE(3323), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4635), 1,
      sym_identifier,
    STATE(4640), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(4670), 1,
      sym_attribute_list,
    STATE(4902), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(5925), 4,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [61678] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3324), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [61784] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3325), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [61908] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3326), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 29,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [61994] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3327), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 28,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [62082] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3328), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 29,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [62168] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5929), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3329), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 34,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [62244] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3330), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [62364] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3331), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [62478] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3332), 1,
      sym__preprocessor_call,
    ACTIONS(5402), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5400), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [62546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3333), 1,
      sym__preprocessor_call,
    ACTIONS(2825), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(2823), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [62614] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3334), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 29,
      anon_sym_where,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [62700] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5823), 1,
      anon_sym_QMARK,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3335), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [62824] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3336), 1,
      sym__preprocessor_call,
    ACTIONS(5430), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5428), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [62892] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(5889), 1,
      anon_sym_QMARK,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5907), 1,
      anon_sym_is,
    ACTIONS(5909), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    STATE(1229), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3337), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [63014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3338), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [63082] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3339), 1,
      sym__preprocessor_call,
    ACTIONS(5390), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5388), 36,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [63150] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5875), 1,
      anon_sym_into,
    STATE(2767), 1,
      sym_query_continuation,
    STATE(3340), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [63222] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5823), 1,
      anon_sym_QMARK,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3341), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [63346] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5309), 1,
      anon_sym_in,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5799), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5801), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(5877), 1,
      anon_sym_QMARK,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3342), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [63472] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5339), 1,
      anon_sym_in,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5779), 1,
      anon_sym_CARET,
    ACTIONS(5781), 1,
      anon_sym_PIPE,
    ACTIONS(5783), 1,
      anon_sym_AMP,
    ACTIONS(5791), 1,
      anon_sym_is,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5795), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5797), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5799), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5801), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(5877), 1,
      anon_sym_QMARK,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3343), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5771), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5775), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5785), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5787), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5789), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5777), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [63598] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5823), 1,
      anon_sym_QMARK,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3344), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [63722] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3345), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [63808] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3346), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 18,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [63928] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3347), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5931), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [64052] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3348), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5933), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [64176] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3349), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [64300] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3350), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 20,
      anon_sym_where,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64414] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(1448), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3351), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 16,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 28,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [64500] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5817), 1,
      anon_sym_is,
    ACTIONS(5819), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5861), 1,
      anon_sym_QMARK,
    ACTIONS(5863), 1,
      anon_sym_CARET,
    ACTIONS(5865), 1,
      anon_sym_PIPE,
    ACTIONS(5867), 1,
      anon_sym_AMP,
    ACTIONS(5869), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5871), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5873), 1,
      anon_sym_QMARK_QMARK,
    STATE(982), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3352), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5805), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5807), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5811), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5813), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5815), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5809), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [64624] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5937), 1,
      anon_sym_QMARK,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3353), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [64745] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3354), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [64850] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5965), 1,
      anon_sym_into,
    STATE(2262), 1,
      sym_query_continuation,
    STATE(3355), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 34,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [64921] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5937), 1,
      anon_sym_QMARK,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3356), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [65044] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(3357), 1,
      sym__preprocessor_call,
    STATE(6662), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(1949), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [65115] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3358), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [65234] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5967), 1,
      anon_sym_and,
    ACTIONS(5969), 1,
      anon_sym_or,
    STATE(3359), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [65305] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3360), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 28,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [65390] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5937), 1,
      anon_sym_QMARK,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3361), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [65511] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3362), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 19,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [65624] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5965), 1,
      anon_sym_into,
    STATE(2317), 1,
      sym_query_continuation,
    STATE(3363), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 34,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [65695] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3364), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 27,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [65782] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3365), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [65879] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5967), 1,
      anon_sym_and,
    STATE(3366), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 34,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [65948] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5937), 1,
      anon_sym_QMARK,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3367), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [66071] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5191), 1,
      anon_sym_LPAREN,
    ACTIONS(5971), 1,
      anon_sym_LBRACK,
    STATE(3724), 1,
      sym_attribute_list,
    STATE(3368), 2,
      sym__preprocessor_call,
      aux_sym_event_field_declaration_repeat1,
    ACTIONS(5186), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [66142] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3369), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [66249] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5974), 1,
      anon_sym_and,
    ACTIONS(5976), 1,
      anon_sym_or,
    STATE(3370), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 34,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [66320] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3371), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 27,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [66407] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5937), 1,
      anon_sym_QMARK,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3372), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [66530] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3373), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 28,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [66615] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3374), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 28,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [66700] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3375), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_PIPE_PIPE,
  [66815] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(3376), 1,
      sym__preprocessor_call,
    STATE(6662), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(1949), 48,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [66888] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5937), 1,
      anon_sym_QMARK,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3377), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [67011] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(5978), 1,
      anon_sym_EQ_GT,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(3378), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 32,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [67086] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3379), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [67179] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5967), 1,
      anon_sym_and,
    ACTIONS(5969), 1,
      anon_sym_or,
    STATE(3380), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [67250] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5733), 1,
      anon_sym_LBRACK,
    ACTIONS(5735), 1,
      anon_sym_ref,
    ACTIONS(5982), 1,
      anon_sym_init,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(3381), 1,
      sym__preprocessor_call,
    STATE(3814), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(4089), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(4492), 1,
      sym_attribute_list,
    STATE(4521), 1,
      sym_modifier,
    STATE(5893), 1,
      sym_identifier,
    ACTIONS(5980), 4,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
    ACTIONS(5731), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
    ACTIONS(13), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [67339] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3382), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [67450] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3383), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [67559] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5937), 1,
      anon_sym_QMARK,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3384), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [67682] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(5937), 1,
      anon_sym_QMARK,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5955), 1,
      anon_sym_is,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3385), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 6,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [67805] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5984), 1,
      anon_sym_into,
    STATE(2173), 1,
      sym_query_continuation,
    STATE(3386), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 34,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [67876] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(5986), 1,
      anon_sym_COLON_COLON,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3387), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 33,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [67949] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5974), 1,
      anon_sym_and,
    STATE(3388), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_or,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 34,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [68018] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5984), 1,
      anon_sym_into,
    STATE(2141), 1,
      sym_query_continuation,
    STATE(3389), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 34,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [68089] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3390), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [68184] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5957), 1,
      anon_sym_DOT_DOT,
    STATE(1443), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3391), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 25,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [68275] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5974), 1,
      anon_sym_and,
    ACTIONS(5976), 1,
      anon_sym_or,
    STATE(3392), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 34,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_where,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [68346] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3393), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [68466] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3394), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 27,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [68550] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3395), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 27,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [68634] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3396), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 26,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [68720] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3397), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [68834] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6072), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6074), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3398), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [68954] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3399), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 26,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [69040] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3400), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 27,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [69124] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6072), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6074), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3401), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [69246] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3402), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [69332] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6080), 1,
      anon_sym_new,
    ACTIONS(6082), 1,
      anon_sym_class,
    ACTIONS(6084), 1,
      anon_sym_struct,
    STATE(3403), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5705), 1,
      sym__type,
    STATE(5888), 1,
      sym_type_parameter_constraint,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6086), 2,
      anon_sym_notnull,
      anon_sym_unmanaged,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(6024), 2,
      sym_constructor_constraint,
      sym_type_constraint,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 22,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [69440] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3404), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [69536] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3405), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [69628] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3406), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [69718] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3407), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [69826] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3408), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 27,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [69910] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3409), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [70002] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3410), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 16,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [70122] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3411), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [70218] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3412), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [70340] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_QMARK,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3413), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [70462] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3414), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [70546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5986), 1,
      anon_sym_COLON_COLON,
    STATE(3415), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 33,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [70614] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3416), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [70736] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3417), 1,
      sym__preprocessor_call,
    ACTIONS(5423), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5418), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(3067), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3075), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [70806] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3418), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [70910] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3419), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 16,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [71030] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3420), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [71152] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3421), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [71274] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3422), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [71396] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3423), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 26,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [71482] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3424), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [71600] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6072), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6074), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3425), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [71722] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6122), 1,
      anon_sym_into,
    STATE(2262), 1,
      sym_query_continuation,
    STATE(3426), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [71792] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3427), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 26,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [71878] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3428), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [71962] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3429), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [72084] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3430), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72194] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3431), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [72312] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3432), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_PIPE_PIPE,
  [72426] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3433), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [72540] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3434), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72652] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3435), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 18,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72764] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_is,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3436), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72868] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6114), 1,
      anon_sym_is,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3437), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [72974] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3438), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [73068] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3439), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 27,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [73152] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3440), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73262] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3441), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [73370] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3442), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [73464] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3443), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [73586] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3444), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [73708] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    STATE(1703), 1,
      sym_block,
    STATE(3445), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [73778] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3446), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 26,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [73864] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3447), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [73954] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3448), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [74076] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3449), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74182] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6072), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6074), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3450), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [74304] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3451), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [74426] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6072), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6074), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3452), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [74548] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3453), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [74656] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(1600), 1,
      sym_block,
    STATE(3454), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [74726] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2842), 1,
      anon_sym_EQ_GT,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3455), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [74800] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3456), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [74922] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3457), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 26,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [75008] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6088), 1,
      anon_sym_QMARK,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3458), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [75130] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3459), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [75248] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6072), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6074), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3460), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [75370] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5197), 1,
      anon_sym_LT,
    ACTIONS(6126), 1,
      anon_sym_EQ_GT,
    STATE(2714), 1,
      sym_type_argument_list,
    STATE(3461), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [75444] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3462), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [75540] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3463), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [75632] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3464), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 26,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [75718] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3465), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 27,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [75802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6128), 1,
      anon_sym_into,
    STATE(2141), 1,
      sym_query_continuation,
    STATE(3466), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [75872] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6132), 1,
      anon_sym_COMMA,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6136), 1,
      anon_sym_COLON,
    ACTIONS(6138), 1,
      anon_sym_RBRACE,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3467), 1,
      sym__preprocessor_call,
    STATE(6370), 1,
      sym_interpolation_alignment_clause,
    STATE(6698), 1,
      sym_interpolation_format_clause,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [76002] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3468), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76112] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3469), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [76202] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_QMARK,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3470), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [76324] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3471), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [76430] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6072), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6074), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3472), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [76552] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6122), 1,
      anon_sym_into,
    STATE(2317), 1,
      sym_query_continuation,
    STATE(3473), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [76622] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3474), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [76712] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_QMARK,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3475), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [76834] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3476), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [76956] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3477), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [77050] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3478), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [77144] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3479), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [77236] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_QMARK,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3480), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [77358] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3481), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 27,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [77442] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_QMARK,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3482), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [77564] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_QMARK,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3483), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [77686] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6080), 1,
      anon_sym_new,
    ACTIONS(6082), 1,
      anon_sym_class,
    ACTIONS(6084), 1,
      anon_sym_struct,
    STATE(3484), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5705), 1,
      sym__type,
    STATE(6012), 1,
      sym_type_parameter_constraint,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6086), 2,
      anon_sym_notnull,
      anon_sym_unmanaged,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(6024), 2,
      sym_constructor_constraint,
      sym_type_constraint,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 22,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [77794] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6172), 1,
      anon_sym_into,
    STATE(2949), 1,
      sym_query_continuation,
    STATE(3485), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 33,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [77864] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3486), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 24,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [77960] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6172), 1,
      anon_sym_into,
    STATE(2962), 1,
      sym_query_continuation,
    STATE(3487), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 33,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [78030] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_QMARK,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3488), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [78152] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_QMARK,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3489), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 16,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [78272] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5328), 1,
      anon_sym_LPAREN,
    ACTIONS(6177), 1,
      anon_sym_ref,
    STATE(3923), 1,
      sym_modifier,
    STATE(3490), 2,
      sym__preprocessor_call,
      aux_sym_event_field_declaration_repeat2,
    ACTIONS(6174), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
    ACTIONS(5323), 30,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [78344] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6132), 1,
      anon_sym_COMMA,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6136), 1,
      anon_sym_COLON,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(6180), 1,
      anon_sym_RBRACE,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3491), 1,
      sym__preprocessor_call,
    STATE(6301), 1,
      sym_interpolation_alignment_clause,
    STATE(6809), 1,
      sym_interpolation_format_clause,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [78474] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3492), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [78596] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3493), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 27,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [78680] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6182), 1,
      anon_sym_into,
    STATE(2767), 1,
      sym_query_continuation,
    STATE(3494), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 33,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [78750] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6182), 1,
      anon_sym_into,
    STATE(2852), 1,
      sym_query_continuation,
    STATE(3495), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 33,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [78820] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3496), 1,
      sym__preprocessor_call,
    ACTIONS(3376), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3374), 35,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [78886] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5823), 1,
      anon_sym_QMARK,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5847), 1,
      anon_sym_is,
    ACTIONS(5849), 1,
      anon_sym_DOT_DOT,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5859), 1,
      anon_sym_as,
    STATE(1420), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3497), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [79008] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3498), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 27,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [79092] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6072), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6074), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3499), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [79214] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6050), 1,
      anon_sym_QMARK,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6072), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6074), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3500), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 5,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [79336] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3501), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79444] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3502), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79548] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6184), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3503), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 31,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [79622] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3504), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79732] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3505), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79838] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3506), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [79942] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3507), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 18,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80054] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_QMARK,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3508), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 16,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [80174] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3509), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [80288] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6022), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6056), 1,
      anon_sym_CARET,
    ACTIONS(6058), 1,
      anon_sym_PIPE,
    ACTIONS(6060), 1,
      anon_sym_AMP,
    ACTIONS(6068), 1,
      anon_sym_is,
    ACTIONS(6070), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6072), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6074), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6076), 1,
      anon_sym_as,
    STATE(1186), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3510), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6048), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6052), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6062), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6064), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6066), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6054), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [80406] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3511), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 27,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [80490] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6042), 1,
      anon_sym_is,
    ACTIONS(6044), 1,
      anon_sym_DOT_DOT,
    STATE(1020), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3512), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 18,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80602] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6128), 1,
      anon_sym_into,
    STATE(2173), 1,
      sym_query_continuation,
    STATE(3513), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_in,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [80672] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6078), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6096), 1,
      anon_sym_QMARK,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6114), 1,
      anon_sym_is,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1307), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3514), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 5,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [80794] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3515), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [80905] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3516), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81010] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6226), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3517), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [81131] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3518), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81240] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3519), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81351] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3520), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_PIPE_PIPE,
  [81464] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3521), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
  [81581] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3522), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 26,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [81664] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3523), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [81769] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    ACTIONS(6266), 1,
      anon_sym_DOT,
    STATE(3524), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 34,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [81838] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6268), 1,
      anon_sym_and,
    ACTIONS(6270), 1,
      anon_sym_or,
    STATE(3525), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [81907] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3526), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [81998] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3527), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82101] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3528), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82208] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3529), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6395), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [82311] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3530), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 26,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [82394] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6280), 1,
      anon_sym_QMARK,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3531), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [82515] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3532), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [82604] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3533), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82711] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3534), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [82820] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3535), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [82905] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(6308), 1,
      anon_sym_EQ_GT,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(3536), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [82978] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3537), 1,
      sym__preprocessor_call,
    ACTIONS(5343), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(5341), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [83043] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3538), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83146] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3539), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [83255] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3540), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 26,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [83338] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3541), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6448), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [83441] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3542), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [83536] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3543), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 25,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [83621] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3544), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 26,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [83704] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3545), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [83795] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3546), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [83888] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3547), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [84009] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6326), 1,
      anon_sym_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3548), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [84130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6268), 1,
      anon_sym_and,
    STATE(3549), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 33,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [84197] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6226), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3550), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [84318] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3551), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [84439] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6328), 1,
      anon_sym_SEMI,
    ACTIONS(6330), 1,
      anon_sym_COMMA,
    ACTIONS(6332), 1,
      anon_sym_RBRACE,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3552), 1,
      sym__preprocessor_call,
    STATE(6336), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [84566] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3553), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6287), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [84669] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3554), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [84782] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3555), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [84867] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3556), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [84984] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3557), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6482), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [85087] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6336), 1,
      anon_sym_QMARK,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3558), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [85208] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6336), 1,
      anon_sym_QMARK,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3559), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [85329] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3560), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85436] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6356), 1,
      anon_sym_and,
    ACTIONS(6358), 1,
      anon_sym_or,
    STATE(3561), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 32,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [85505] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3562), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85614] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6348), 1,
      anon_sym_is,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3563), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85719] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6348), 1,
      anon_sym_is,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3564), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85822] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3565), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [85933] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3566), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [86046] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3567), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
  [86163] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6336), 1,
      anon_sym_QMARK,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3568), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86284] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6336), 1,
      anon_sym_QMARK,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3569), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86405] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3570), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86526] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3571), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86647] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3572), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86768] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6336), 1,
      anon_sym_QMARK,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3573), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [86889] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6336), 1,
      anon_sym_QMARK,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3574), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
  [87008] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3575), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 25,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [87093] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3576), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 26,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [87176] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6328), 1,
      anon_sym_SEMI,
    ACTIONS(6360), 1,
      anon_sym_COMMA,
    ACTIONS(6362), 1,
      anon_sym_RBRACE,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3577), 1,
      sym__preprocessor_call,
    STATE(6262), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [87303] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6226), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3578), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
  [87422] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6226), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3579), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [87543] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6226), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3580), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [87664] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6226), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3581), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [87785] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3582), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
  [87902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6356), 1,
      anon_sym_and,
    ACTIONS(6358), 1,
      anon_sym_or,
    STATE(3583), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 32,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [87971] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3584), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [88084] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3585), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [88195] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3586), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [88298] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3587), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [88403] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3588), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [88512] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3589), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [88619] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6226), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3590), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [88740] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6226), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3591), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [88861] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3592), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [88954] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3593), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [89039] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3594), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [89160] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3595), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [89253] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3596), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 15,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [89372] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3597), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [89467] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6326), 1,
      anon_sym_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3598), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [89588] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6326), 1,
      anon_sym_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3599), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [89709] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3600), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [89830] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3601), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6364), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [89951] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6368), 1,
      anon_sym_QMARK,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3602), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [90072] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3603), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [90157] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6396), 1,
      anon_sym_LPAREN,
    ACTIONS(6398), 1,
      anon_sym_LBRACE,
    ACTIONS(6400), 1,
      anon_sym_STAR,
    ACTIONS(6402), 1,
      sym_void_keyword,
    STATE(2260), 1,
      sym_block,
    STATE(3604), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4875), 1,
      sym__type,
    STATE(6551), 1,
      sym_parameter_list,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [90262] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3605), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 26,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [90345] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6336), 1,
      anon_sym_QMARK,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3606), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [90466] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3607), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_PIPE_PIPE,
  [90579] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3608), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [90672] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6280), 1,
      anon_sym_QMARK,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3609), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [90791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3610), 1,
      sym__preprocessor_call,
    ACTIONS(5276), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(5274), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [90856] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3611), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [90947] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3612), 1,
      sym__preprocessor_call,
    ACTIONS(5299), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(5297), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [91012] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3613), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [91101] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3614), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [91192] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3615), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 26,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [91275] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3616), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [91370] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3617), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [91465] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3618), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [91586] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3619), 1,
      sym__preprocessor_call,
    ACTIONS(5317), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(5315), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [91651] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(6404), 1,
      anon_sym_COLON_COLON,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3620), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 31,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [91722] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6336), 1,
      anon_sym_QMARK,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3621), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5266), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [91843] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3622), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6243), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [91946] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6326), 1,
      anon_sym_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3623), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [92067] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6356), 1,
      anon_sym_and,
    STATE(3624), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 33,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [92134] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6328), 1,
      anon_sym_SEMI,
    ACTIONS(6406), 1,
      anon_sym_COMMA,
    ACTIONS(6408), 1,
      anon_sym_RBRACE,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3625), 1,
      sym__preprocessor_call,
    STATE(6420), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [92261] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3626), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6237), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [92364] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3627), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 26,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [92447] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3628), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 26,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [92530] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3629), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 25,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [92615] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3630), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 26,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [92698] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3631), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6411), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [92801] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3632), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 25,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [92886] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6326), 1,
      anon_sym_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3633), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [93007] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6326), 1,
      anon_sym_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3634), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [93128] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6280), 1,
      anon_sym_QMARK,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3635), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [93249] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6226), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3636), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [93370] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3637), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 26,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [93453] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3638), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [93538] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6204), 1,
      anon_sym_is,
    ACTIONS(6206), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6318), 1,
      anon_sym_QMARK,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3639), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 15,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [93657] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3640), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [93746] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6328), 1,
      anon_sym_SEMI,
    ACTIONS(6410), 1,
      anon_sym_COMMA,
    ACTIONS(6412), 1,
      anon_sym_RBRACE,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3641), 1,
      sym__preprocessor_call,
    STATE(6450), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [93873] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5197), 1,
      anon_sym_LT,
    ACTIONS(6414), 1,
      anon_sym_EQ_GT,
    STATE(2714), 1,
      sym_type_argument_list,
    STATE(3642), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [93946] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3643), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94067] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6368), 1,
      anon_sym_QMARK,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3644), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 15,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94186] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3645), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6295), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [94289] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3646), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6403), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [94392] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3647), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [94477] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3648), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 26,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [94560] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3649), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94681] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(1042), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3650), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 26,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [94764] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3651), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [94885] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3652), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 26,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [94968] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3653), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 26,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [95051] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3654), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [95146] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3655), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6416), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [95267] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3656), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6363), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [95370] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3657), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [95465] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3658), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 25,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [95550] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3659), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 26,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [95633] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3660), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 26,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [95716] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3661), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 26,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [95799] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3662), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [95890] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3663), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 26,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [95973] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3664), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96094] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6268), 1,
      anon_sym_and,
    ACTIONS(6270), 1,
      anon_sym_or,
    STATE(3665), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 32,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [96163] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6368), 1,
      anon_sym_QMARK,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3666), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5307), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96284] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5197), 1,
      anon_sym_LT,
    ACTIONS(6418), 1,
      anon_sym_EQ_GT,
    STATE(2714), 1,
      sym_type_argument_list,
    STATE(3667), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [96357] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3668), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96476] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3669), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96597] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3670), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [96686] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6368), 1,
      anon_sym_QMARK,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3671), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 15,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96805] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6368), 1,
      anon_sym_QMARK,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3672), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [96926] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6368), 1,
      anon_sym_QMARK,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3673), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [97047] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6368), 1,
      anon_sym_QMARK,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3674), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [97168] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3675), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [97285] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3676), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_PIPE_PIPE,
  [97398] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3677), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [97509] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6326), 1,
      anon_sym_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3678), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [97630] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6328), 1,
      anon_sym_SEMI,
    ACTIONS(6420), 1,
      anon_sym_COMMA,
    ACTIONS(6422), 1,
      anon_sym_RBRACE,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3679), 1,
      sym__preprocessor_call,
    STATE(6325), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [97757] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6280), 1,
      anon_sym_QMARK,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3680), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3350), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [97878] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5423), 1,
      anon_sym_COLON,
    STATE(3681), 1,
      sym__preprocessor_call,
    ACTIONS(5418), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(3067), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3075), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [97947] = 36,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(6410), 1,
      anon_sym_COMMA,
    ACTIONS(6412), 1,
      anon_sym_RBRACE,
    ACTIONS(6424), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3682), 1,
      sym__preprocessor_call,
    STATE(6450), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [98074] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3683), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [98177] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3684), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [98282] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3685), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [98391] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3686), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [98498] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6368), 1,
      anon_sym_QMARK,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3687), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [98619] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6368), 1,
      anon_sym_QMARK,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6386), 1,
      anon_sym_is,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3688), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 4,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [98740] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3689), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 26,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [98823] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6226), 1,
      anon_sym_QMARK,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6244), 1,
      anon_sym_is,
    ACTIONS(6246), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(796), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3690), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
  [98942] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3691), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [99033] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6336), 1,
      anon_sym_QMARK,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3692), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5337), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [99154] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6316), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6336), 1,
      anon_sym_QMARK,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6348), 1,
      anon_sym_is,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(757), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3693), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
  [99273] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3694), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [99362] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3695), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [99469] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3696), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [99578] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5197), 1,
      anon_sym_LT,
    ACTIONS(6426), 1,
      anon_sym_EQ_GT,
    STATE(2714), 1,
      sym_type_argument_list,
    STATE(3697), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [99651] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3698), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [99756] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3699), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [99849] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3700), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [99952] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6280), 1,
      anon_sym_QMARK,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3701), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [100071] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3702), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [100160] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3703), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 30,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [100233] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3704), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [100344] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3705), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 25,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [100429] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6326), 1,
      anon_sym_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3706), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 4,
      anon_sym_and,
      anon_sym_or,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [100550] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3707), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6311), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [100653] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5197), 1,
      anon_sym_LT,
    STATE(2714), 1,
      sym_type_argument_list,
    STATE(3708), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 32,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [100724] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3709), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [100841] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3710), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 17,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [100952] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3711), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [101045] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3712), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_PIPE_PIPE,
  [101158] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3713), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 25,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [101243] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3714), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [101338] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3715), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [101429] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3716), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 26,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [101512] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3717), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [101601] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3718), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [101694] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3719), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [101799] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3720), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6349), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [101902] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3721), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102019] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3722), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 4,
      anon_sym_COMMA,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102140] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6280), 1,
      anon_sym_QMARK,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3723), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5255), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102261] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3724), 1,
      sym__preprocessor_call,
    ACTIONS(5293), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(5291), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [102326] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6326), 1,
      anon_sym_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3725), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
  [102445] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6388), 1,
      anon_sym_DOT_DOT,
    STATE(1394), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3726), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 25,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [102530] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6280), 1,
      anon_sym_QMARK,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3727), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3510), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102651] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6280), 1,
      anon_sym_QMARK,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3728), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5301), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102772] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6272), 1,
      anon_sym_ref,
    ACTIONS(6276), 1,
      sym_void_keyword,
    STATE(3729), 1,
      sym__preprocessor_call,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6076), 1,
      sym__type,
    STATE(6323), 1,
      sym_function_pointer_parameter,
    STATE(6727), 1,
      sym__nullable_base_type,
    ACTIONS(6274), 2,
      anon_sym_out,
      anon_sym_in,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [102875] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6280), 1,
      anon_sym_QMARK,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3730), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(3518), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [102996] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(733), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5642), 1,
      anon_sym_switch,
    ACTIONS(5648), 1,
      anon_sym_with,
    ACTIONS(5656), 1,
      anon_sym_as,
    ACTIONS(6220), 1,
      anon_sym_is,
    ACTIONS(6222), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6326), 1,
      anon_sym_QMARK,
    STATE(895), 1,
      sym_assignment_operator,
    STATE(2745), 1,
      sym_argument_list,
    STATE(2746), 1,
      sym_bracketed_argument_list,
    STATE(3731), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
  [103115] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3732), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [103222] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6298), 1,
      anon_sym_is,
    ACTIONS(6300), 1,
      anon_sym_DOT_DOT,
    STATE(1077), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3733), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 19,
      anon_sym_COLON,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [103325] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6454), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6456), 1,
      anon_sym_QMARK_QMARK,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3734), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3350), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103445] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5735), 1,
      anon_sym_ref,
    ACTIONS(5982), 1,
      anon_sym_init,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(3735), 1,
      sym__preprocessor_call,
    STATE(4202), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(4521), 1,
      sym_modifier,
    STATE(5893), 1,
      sym_identifier,
    ACTIONS(5980), 4,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
    ACTIONS(5731), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
    ACTIONS(13), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [103525] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(6458), 1,
      anon_sym_COMMA,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3736), 1,
      sym__preprocessor_call,
    ACTIONS(5307), 2,
      anon_sym_COLON,
      anon_sym_RPAREN,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103647] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6462), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3737), 1,
      sym__preprocessor_call,
    STATE(6308), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103771] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6420), 1,
      anon_sym_COMMA,
    ACTIONS(6422), 1,
      anon_sym_RBRACE,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3738), 1,
      sym__preprocessor_call,
    STATE(6325), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [103895] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6464), 1,
      anon_sym_and,
    ACTIONS(6466), 1,
      anon_sym_or,
    STATE(3739), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 31,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [103963] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6454), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6456), 1,
      anon_sym_QMARK_QMARK,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3740), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 14,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104081] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6468), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3741), 1,
      sym__preprocessor_call,
    STATE(6310), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104205] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6454), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6456), 1,
      anon_sym_QMARK_QMARK,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3742), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5307), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [104325] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3743), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 24,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [104409] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3744), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 25,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [104491] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5288), 1,
      anon_sym_LT,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(3745), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [104561] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(6472), 1,
      anon_sym_COLON_COLON,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(3746), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [104631] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3747), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 25,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [104713] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3748), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [104807] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3749), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [104897] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6476), 1,
      anon_sym_QMARK,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6502), 1,
      anon_sym_QMARK_QMARK,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3750), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5307), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [105017] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3751), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [105099] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(6504), 1,
      anon_sym_EQ_GT,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(3752), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [105171] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3753), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [105253] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3754), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [105337] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6506), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3755), 1,
      sym__preprocessor_call,
    ACTIONS(5301), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [105459] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3756), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [105547] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6510), 1,
      anon_sym_QMARK,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6534), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6536), 1,
      anon_sym_QMARK_QMARK,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3757), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 14,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
  [105665] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_QMARK,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6562), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6564), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3758), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5307), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [105785] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3759), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [105877] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3760), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 24,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [105961] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6454), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6456), 1,
      anon_sym_QMARK_QMARK,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3761), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5301), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [106081] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3762), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [106175] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3763), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [106265] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6454), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6456), 1,
      anon_sym_QMARK_QMARK,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3764), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3518), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [106385] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3765), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [106473] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3766), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [106565] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3767), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [106649] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3768), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [106731] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3769), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [106837] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3770), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [106945] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6576), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3771), 1,
      sym__preprocessor_call,
    STATE(6247), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [107069] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6578), 1,
      anon_sym_into,
    STATE(2317), 1,
      sym_query_continuation,
    STATE(3772), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 31,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [107137] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6580), 1,
      anon_sym_RBRACK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3773), 1,
      sym__preprocessor_call,
    STATE(6242), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [107261] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3774), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107365] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(6582), 1,
      anon_sym_EQ_GT,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(3775), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [107437] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3776), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6584), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [107557] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3777), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6584), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [107677] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3778), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107779] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3779), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [107889] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3780), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_PIPE_PIPE,
  [108001] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6360), 1,
      anon_sym_COMMA,
    ACTIONS(6362), 1,
      anon_sym_RBRACE,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3781), 1,
      sym__preprocessor_call,
    STATE(6262), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [108125] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6454), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6456), 1,
      anon_sym_QMARK_QMARK,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3782), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [108241] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6454), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6456), 1,
      anon_sym_QMARK_QMARK,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3783), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5255), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [108361] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6454), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6456), 1,
      anon_sym_QMARK_QMARK,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3784), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3510), 3,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [108481] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6586), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3785), 1,
      sym__preprocessor_call,
    STATE(6257), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [108605] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6430), 1,
      anon_sym_QMARK,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6448), 1,
      anon_sym_is,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6454), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6456), 1,
      anon_sym_QMARK_QMARK,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3786), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 14,
      anon_sym_EQ_GT,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [108723] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2842), 1,
      anon_sym_EQ_GT,
    ACTIONS(3104), 1,
      anon_sym_COLON,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6588), 1,
      anon_sym_EQ,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3787), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 15,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [108799] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6590), 1,
      anon_sym_RBRACK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3788), 1,
      sym__preprocessor_call,
    STATE(6373), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [108923] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6592), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3789), 1,
      sym__preprocessor_call,
    STATE(6298), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [109047] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6406), 1,
      anon_sym_COMMA,
    ACTIONS(6408), 1,
      anon_sym_RBRACE,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3790), 1,
      sym__preprocessor_call,
    STATE(6420), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [109171] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6594), 1,
      anon_sym_RBRACK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3791), 1,
      sym__preprocessor_call,
    STATE(6410), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [109295] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6596), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3792), 1,
      sym__preprocessor_call,
    STATE(6427), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [109419] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6598), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3793), 1,
      sym__preprocessor_call,
    STATE(6466), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [109543] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6476), 1,
      anon_sym_QMARK,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6502), 1,
      anon_sym_QMARK_QMARK,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3794), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 14,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
  [109661] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(6424), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6602), 1,
      anon_sym_RPAREN,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3795), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [109785] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(6424), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6604), 1,
      anon_sym_RPAREN,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3796), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [109909] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6464), 1,
      anon_sym_and,
    STATE(3797), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 32,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [109975] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6404), 1,
      anon_sym_COLON_COLON,
    STATE(3798), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 18,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_COLON,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 31,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [110041] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6606), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3799), 1,
      sym__preprocessor_call,
    STATE(6227), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [110165] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6578), 1,
      anon_sym_into,
    STATE(2262), 1,
      sym_query_continuation,
    STATE(3800), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 31,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [110233] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6608), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3801), 1,
      sym__preprocessor_call,
    STATE(6226), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [110357] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6612), 1,
      anon_sym_QMARK,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6630), 1,
      anon_sym_QMARK_QMARK,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3802), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5301), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [110477] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6632), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3803), 1,
      sym__preprocessor_call,
    STATE(6462), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [110601] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6634), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3804), 1,
      sym__preprocessor_call,
    STATE(6461), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [110725] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6612), 1,
      anon_sym_QMARK,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6630), 1,
      anon_sym_QMARK_QMARK,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3805), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3518), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [110845] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3806), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [110951] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6636), 1,
      anon_sym_RBRACK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3807), 1,
      sym__preprocessor_call,
    STATE(6291), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [111075] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6638), 1,
      anon_sym_into,
    STATE(2852), 1,
      sym_query_continuation,
    STATE(3808), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 31,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [111143] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6638), 1,
      anon_sym_into,
    STATE(2767), 1,
      sym_query_continuation,
    STATE(3809), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 31,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [111211] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6640), 1,
      anon_sym_into,
    STATE(2962), 1,
      sym_query_continuation,
    STATE(3810), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 31,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [111279] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6640), 1,
      anon_sym_into,
    STATE(2949), 1,
      sym_query_continuation,
    STATE(3811), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 31,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [111347] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6510), 1,
      anon_sym_QMARK,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6534), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6536), 1,
      anon_sym_QMARK_QMARK,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3812), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 14,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
  [111465] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6510), 1,
      anon_sym_QMARK,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6534), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6536), 1,
      anon_sym_QMARK_QMARK,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3813), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3350), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [111585] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5735), 1,
      anon_sym_ref,
    ACTIONS(6644), 1,
      anon_sym_init,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(3814), 1,
      sym__preprocessor_call,
    STATE(4202), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(4521), 1,
      sym_modifier,
    STATE(5907), 1,
      sym_identifier,
    ACTIONS(6642), 4,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
    ACTIONS(5731), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
    ACTIONS(13), 21,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [111665] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6510), 1,
      anon_sym_QMARK,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6534), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6536), 1,
      anon_sym_QMARK_QMARK,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3815), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3510), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [111785] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6510), 1,
      anon_sym_QMARK,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6534), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6536), 1,
      anon_sym_QMARK_QMARK,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3816), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5255), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [111905] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6534), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6536), 1,
      anon_sym_QMARK_QMARK,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3817), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
  [112021] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3818), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_PIPE_PIPE,
  [112133] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3819), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [112243] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3820), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [112345] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3821), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [112449] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3822), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [112557] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3823), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [112663] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6510), 1,
      anon_sym_QMARK,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6534), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6536), 1,
      anon_sym_QMARK_QMARK,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3824), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3518), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [112783] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6510), 1,
      anon_sym_QMARK,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6534), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6536), 1,
      anon_sym_QMARK_QMARK,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3825), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5301), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [112903] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3826), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [112987] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3827), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [113079] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6624), 1,
      anon_sym_is,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3828), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [113183] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3829), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [113271] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3830), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [113361] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3831), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [113455] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3832), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [113563] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3833), 1,
      sym__preprocessor_call,
    ACTIONS(5418), 5,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(3067), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3075), 28,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [113629] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6510), 1,
      anon_sym_QMARK,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6528), 1,
      anon_sym_is,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6534), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6536), 1,
      anon_sym_QMARK_QMARK,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3834), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5307), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_equals,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [113749] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_QMARK,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6562), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6564), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3835), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 14,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [113867] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3836), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [113961] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3837), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [114043] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3838), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [114133] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6646), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3839), 1,
      sym__preprocessor_call,
    STATE(6440), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114257] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3840), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [114345] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3841), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [114437] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3842), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [114547] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3843), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [114631] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6410), 1,
      anon_sym_COMMA,
    ACTIONS(6412), 1,
      anon_sym_RBRACE,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3844), 1,
      sym__preprocessor_call,
    STATE(6450), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114755] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6476), 1,
      anon_sym_QMARK,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6502), 1,
      anon_sym_QMARK_QMARK,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3845), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5301), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114875] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6648), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3846), 1,
      sym__preprocessor_call,
    STATE(6457), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [114999] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6476), 1,
      anon_sym_QMARK,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6502), 1,
      anon_sym_QMARK_QMARK,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3847), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3518), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [115119] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6650), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3848), 1,
      sym__preprocessor_call,
    STATE(6456), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [115243] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3849), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [115327] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3850), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [115409] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3851), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [115491] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6612), 1,
      anon_sym_QMARK,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6630), 1,
      anon_sym_QMARK_QMARK,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3852), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5307), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [115611] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3853), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [115693] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3854), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [115775] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3855), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_PIPE_PIPE,
  [115887] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6652), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3856), 1,
      sym__preprocessor_call,
    STATE(6430), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [116011] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3857), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 25,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [116093] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6654), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3858), 1,
      sym__preprocessor_call,
    STATE(6429), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [116217] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6630), 1,
      anon_sym_QMARK_QMARK,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3859), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
  [116333] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3860), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6458), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [116453] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3861), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [116559] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3862), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [116667] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3863), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 24,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [116751] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5307), 1,
      anon_sym_RPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3864), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6458), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [116873] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3865), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [116977] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3866), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [117069] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3867), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [117171] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6656), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3868), 1,
      sym__preprocessor_call,
    STATE(6425), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [117295] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6658), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3869), 1,
      sym__preprocessor_call,
    STATE(6424), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [117419] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3870), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [117529] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3871), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [117617] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3872), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [117707] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3873), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 22,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [117801] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6660), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3874), 1,
      sym__preprocessor_call,
    STATE(6423), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [117925] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6662), 1,
      anon_sym_LPAREN,
    STATE(3875), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [117989] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6612), 1,
      anon_sym_QMARK,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6630), 1,
      anon_sym_QMARK_QMARK,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3876), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5255), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [118109] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6530), 1,
      anon_sym_DOT_DOT,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3877), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [118193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5767), 1,
      anon_sym_LPAREN,
    STATE(3878), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [118257] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6612), 1,
      anon_sym_QMARK,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6630), 1,
      anon_sym_QMARK_QMARK,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3879), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3510), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [118377] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3880), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_PIPE_PIPE,
  [118489] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3881), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 25,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [118571] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5311), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6612), 1,
      anon_sym_QMARK,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6630), 1,
      anon_sym_QMARK_QMARK,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3882), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5313), 14,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
  [118689] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6664), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3883), 1,
      sym__preprocessor_call,
    STATE(6375), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [118813] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(6666), 1,
      anon_sym_EQ_GT,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(3884), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [118885] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(6424), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6668), 1,
      anon_sym_RPAREN,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3885), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [119009] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6612), 1,
      anon_sym_QMARK,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6630), 1,
      anon_sym_QMARK_QMARK,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3886), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3350), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_by,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [119129] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6612), 1,
      anon_sym_QMARK,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6624), 1,
      anon_sym_is,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6630), 1,
      anon_sym_QMARK_QMARK,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3887), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 14,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
  [119247] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_QMARK,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6562), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6564), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3888), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 14,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [119365] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_QMARK,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6562), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6564), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3889), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3350), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [119485] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(6424), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6670), 1,
      anon_sym_RPAREN,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3890), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [119609] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(6672), 1,
      anon_sym_EQ_GT,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(3891), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [119681] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6674), 1,
      anon_sym_into,
    STATE(2852), 1,
      sym_query_continuation,
    STATE(3892), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [119749] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6674), 1,
      anon_sym_into,
    STATE(2767), 1,
      sym_query_continuation,
    STATE(3893), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [119817] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_QMARK,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6562), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6564), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3894), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3510), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [119937] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6574), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6624), 1,
      anon_sym_is,
    STATE(1367), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3895), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [120039] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_QMARK,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6562), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6564), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3896), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5255), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [120159] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6502), 1,
      anon_sym_QMARK_QMARK,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3897), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
  [120275] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6562), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6564), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3898), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [120391] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6676), 1,
      anon_sym_RBRACK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3899), 1,
      sym__preprocessor_call,
    STATE(6322), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [120515] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6476), 1,
      anon_sym_QMARK,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6502), 1,
      anon_sym_QMARK_QMARK,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3900), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5255), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [120635] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(3901), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [120699] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6464), 1,
      anon_sym_and,
    ACTIONS(6466), 1,
      anon_sym_or,
    STATE(3902), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 31,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [120767] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6330), 1,
      anon_sym_COMMA,
    ACTIONS(6332), 1,
      anon_sym_RBRACE,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3903), 1,
      sym__preprocessor_call,
    STATE(6336), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [120891] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6476), 1,
      anon_sym_QMARK,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6502), 1,
      anon_sym_QMARK_QMARK,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3904), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3510), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [121011] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6678), 1,
      anon_sym_into,
    STATE(2141), 1,
      sym_query_continuation,
    STATE(3905), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 31,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [121079] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(776), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3906), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 25,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [121161] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3907), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_PIPE_PIPE,
  [121273] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6678), 1,
      anon_sym_into,
    STATE(2173), 1,
      sym_query_continuation,
    STATE(3908), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 31,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [121341] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(6424), 1,
      anon_sym_COLON,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6680), 1,
      anon_sym_RPAREN,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3909), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [121465] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6476), 1,
      anon_sym_QMARK,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6502), 1,
      anon_sym_QMARK_QMARK,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3910), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3350), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_on,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [121585] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3911), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 16,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [121695] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3912), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 18,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [121797] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3913), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [121901] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(5859), 1,
      anon_sym_as,
    ACTIONS(6476), 1,
      anon_sym_QMARK,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6494), 1,
      anon_sym_is,
    ACTIONS(6496), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6502), 1,
      anon_sym_QMARK_QMARK,
    STATE(920), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3914), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 14,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
  [122019] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3915), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [122127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1951), 1,
      anon_sym_LPAREN,
    STATE(3916), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [122191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6682), 1,
      anon_sym_LPAREN,
    STATE(3917), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [122255] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3918), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [122361] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3919), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 25,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [122443] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6684), 1,
      anon_sym_RBRACK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3920), 1,
      sym__preprocessor_call,
    STATE(6318), 1,
      aux_sym_array_rank_specifier_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [122567] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3921), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 25,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [122649] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6450), 1,
      anon_sym_DOT_DOT,
    STATE(1103), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3922), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 24,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [122733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5488), 1,
      anon_sym_LPAREN,
    STATE(3923), 1,
      sym__preprocessor_call,
    ACTIONS(5486), 49,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
      sym_void_keyword,
  [122797] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_QMARK,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6562), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6564), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3924), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5301), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [122917] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3925), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(6600), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [123037] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(6686), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3926), 1,
      sym__preprocessor_call,
    STATE(6437), 1,
      aux_sym_for_statement_repeat1,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [123161] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6688), 1,
      anon_sym_into,
    STATE(2962), 1,
      sym_query_continuation,
    STATE(3927), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [123229] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6688), 1,
      anon_sym_into,
    STATE(2949), 1,
      sym_query_continuation,
    STATE(3928), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [123297] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(807), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5845), 1,
      anon_sym_switch,
    ACTIONS(5851), 1,
      anon_sym_with,
    ACTIONS(6470), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6540), 1,
      anon_sym_QMARK,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6558), 1,
      anon_sym_is,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6562), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6564), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6566), 1,
      anon_sym_as,
    STATE(1204), 1,
      sym_assignment_operator,
    STATE(2915), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(3929), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(3518), 3,
      anon_sym_in,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [123417] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    ACTIONS(6690), 1,
      anon_sym_LBRACK,
    ACTIONS(6692), 1,
      anon_sym_LPAREN,
    ACTIONS(6694), 1,
      anon_sym_LBRACE,
    ACTIONS(6696), 1,
      anon_sym_delegate,
    ACTIONS(6698), 1,
      anon_sym_var,
    ACTIONS(6700), 1,
      sym_predefined_type,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(1852), 1,
      sym_global,
    STATE(2635), 1,
      sym__type,
    STATE(2648), 1,
      sym_identifier,
    STATE(2720), 1,
      sym_array_type,
    STATE(2789), 1,
      sym_argument_list,
    STATE(2971), 1,
      sym__name,
    STATE(3930), 1,
      sym__preprocessor_call,
    STATE(6760), 1,
      sym__nullable_base_type,
    STATE(1795), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(1794), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(1796), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [123518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3931), 1,
      sym__preprocessor_call,
    ACTIONS(2835), 16,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2833), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [123581] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(799), 1,
      sym__identifier_token,
    ACTIONS(1133), 1,
      anon_sym_global,
    ACTIONS(6702), 1,
      anon_sym_LBRACK,
    ACTIONS(6704), 1,
      anon_sym_LPAREN,
    ACTIONS(6706), 1,
      anon_sym_LBRACE,
    ACTIONS(6708), 1,
      anon_sym_delegate,
    ACTIONS(6710), 1,
      anon_sym_var,
    ACTIONS(6712), 1,
      sym_predefined_type,
    STATE(2631), 1,
      sym__type,
    STATE(2645), 1,
      sym__contextual_keywords,
    STATE(2655), 1,
      sym_array_type,
    STATE(2666), 1,
      sym_argument_list,
    STATE(2667), 1,
      sym_identifier,
    STATE(2762), 1,
      sym_global,
    STATE(2856), 1,
      sym_generic_name,
    STATE(2863), 1,
      sym__name,
    STATE(3932), 1,
      sym__preprocessor_call,
    STATE(6864), 1,
      sym__nullable_base_type,
    STATE(2765), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2764), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    STATE(2768), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(801), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [123682] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6714), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(3933), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [123753] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_QMARK,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3934), 1,
      sym__preprocessor_call,
    ACTIONS(5266), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [123872] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6680), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3935), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [123993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(3936), 1,
      sym__preprocessor_call,
    ACTIONS(2729), 16,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2734), 33,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_EQ,
      anon_sym_in,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [124056] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(3164), 1,
      anon_sym_LBRACK,
    ACTIONS(3166), 1,
      anon_sym_LPAREN,
    ACTIONS(3168), 1,
      anon_sym_LBRACE,
    ACTIONS(3170), 1,
      anon_sym_delegate,
    ACTIONS(3172), 1,
      anon_sym_var,
    ACTIONS(3174), 1,
      sym_predefined_type,
    STATE(2051), 1,
      sym__type,
    STATE(2065), 1,
      sym_array_type,
    STATE(2069), 1,
      sym_argument_list,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2096), 1,
      sym_generic_name,
    STATE(2270), 1,
      sym_identifier,
    STATE(2525), 1,
      sym_global,
    STATE(2629), 1,
      sym__name,
    STATE(3937), 1,
      sym__preprocessor_call,
    STATE(6945), 1,
      sym__nullable_base_type,
    STATE(2114), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2111), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2115), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [124157] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6748), 1,
      anon_sym_and,
    STATE(3938), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [124222] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(721), 1,
      sym__identifier_token,
    ACTIONS(1133), 1,
      anon_sym_global,
    ACTIONS(6750), 1,
      anon_sym_LBRACK,
    ACTIONS(6752), 1,
      anon_sym_LPAREN,
    ACTIONS(6754), 1,
      anon_sym_LBRACE,
    ACTIONS(6756), 1,
      anon_sym_delegate,
    ACTIONS(6758), 1,
      anon_sym_var,
    ACTIONS(6760), 1,
      sym_predefined_type,
    STATE(2458), 1,
      sym__type,
    STATE(2630), 1,
      sym_identifier,
    STATE(2633), 1,
      sym__contextual_keywords,
    STATE(2636), 1,
      sym_global,
    STATE(2640), 1,
      sym_array_type,
    STATE(2642), 1,
      sym_argument_list,
    STATE(2696), 1,
      sym__name,
    STATE(2702), 1,
      sym_generic_name,
    STATE(3939), 1,
      sym__preprocessor_call,
    STATE(6883), 1,
      sym__nullable_base_type,
    STATE(2703), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2700), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    STATE(2705), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(723), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [124323] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6604), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3940), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [124444] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3941), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6762), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [124563] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(6764), 1,
      anon_sym_GT,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(3942), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5915), 1,
      sym__type,
    STATE(6332), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [124662] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2729), 1,
      anon_sym_LT,
    ACTIONS(2734), 1,
      anon_sym_in,
    STATE(3943), 1,
      sym__preprocessor_call,
    ACTIONS(2847), 15,
      anon_sym_SEMI,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2844), 32,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_EQ,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [124729] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3944), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [124822] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3945), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [124911] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3946), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [124998] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3947), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [125081] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_QMARK,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3948), 1,
      sym__preprocessor_call,
    ACTIONS(5301), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [125200] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3949), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6766), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [125319] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(799), 1,
      sym__identifier_token,
    ACTIONS(803), 1,
      anon_sym_global,
    ACTIONS(6702), 1,
      anon_sym_LBRACK,
    ACTIONS(6704), 1,
      anon_sym_LPAREN,
    ACTIONS(6706), 1,
      anon_sym_LBRACE,
    ACTIONS(6708), 1,
      anon_sym_delegate,
    ACTIONS(6710), 1,
      anon_sym_var,
    ACTIONS(6712), 1,
      sym_predefined_type,
    STATE(2631), 1,
      sym__type,
    STATE(2645), 1,
      sym__contextual_keywords,
    STATE(2655), 1,
      sym_array_type,
    STATE(2666), 1,
      sym_argument_list,
    STATE(2856), 1,
      sym_generic_name,
    STATE(3746), 1,
      sym_identifier,
    STATE(3950), 1,
      sym__preprocessor_call,
    STATE(4067), 1,
      sym_global,
    STATE(4130), 1,
      sym__name,
    STATE(6864), 1,
      sym__nullable_base_type,
    STATE(2765), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2764), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    STATE(2768), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(801), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [125420] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3951), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6768), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [125539] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_QMARK,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3952), 1,
      sym__preprocessor_call,
    ACTIONS(3518), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [125658] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3953), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [125763] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3954), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [125870] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3955), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [125963] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3956), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [126066] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3957), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [126167] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3958), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [126276] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3959), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [126387] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3960), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 13,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [126502] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_QMARK,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3961), 1,
      sym__preprocessor_call,
    ACTIONS(5255), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [126621] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3962), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [126710] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_QMARK,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3963), 1,
      sym__preprocessor_call,
    ACTIONS(3510), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [126829] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_QMARK,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3964), 1,
      sym__preprocessor_call,
    ACTIONS(3350), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [126948] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3965), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [127039] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3966), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [127126] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3967), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [127217] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3968), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [127300] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3969), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [127381] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_QMARK,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3970), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 13,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
  [127498] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6780), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6798), 1,
      anon_sym_QMARK_QMARK,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3971), 1,
      sym__preprocessor_call,
    ACTIONS(5301), 2,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [127617] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6780), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6798), 1,
      anon_sym_QMARK_QMARK,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3972), 1,
      sym__preprocessor_call,
    ACTIONS(3518), 2,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [127736] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3973), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [127841] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3974), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [127948] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6792), 1,
      anon_sym_is,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3975), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [128051] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(1133), 1,
      anon_sym_global,
    ACTIONS(3164), 1,
      anon_sym_LBRACK,
    ACTIONS(3166), 1,
      anon_sym_LPAREN,
    ACTIONS(3168), 1,
      anon_sym_LBRACE,
    ACTIONS(3170), 1,
      anon_sym_delegate,
    ACTIONS(3172), 1,
      anon_sym_var,
    ACTIONS(3174), 1,
      sym_predefined_type,
    STATE(2051), 1,
      sym__type,
    STATE(2065), 1,
      sym_array_type,
    STATE(2069), 1,
      sym_argument_list,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2096), 1,
      sym_generic_name,
    STATE(3976), 1,
      sym__preprocessor_call,
    STATE(4136), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_global,
    STATE(4548), 1,
      sym__name,
    STATE(6945), 1,
      sym__nullable_base_type,
    STATE(2114), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2111), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2115), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [128152] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3977), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6458), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [128271] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6792), 1,
      anon_sym_is,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3978), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [128372] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3979), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [128481] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3980), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [128592] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6798), 1,
      anon_sym_QMARK_QMARK,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3981), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
  [128707] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6780), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6798), 1,
      anon_sym_QMARK_QMARK,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3982), 1,
      sym__preprocessor_call,
    ACTIONS(5255), 2,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [128826] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6780), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6798), 1,
      anon_sym_QMARK_QMARK,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3983), 1,
      sym__preprocessor_call,
    ACTIONS(3510), 2,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [128945] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6780), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6798), 1,
      anon_sym_QMARK_QMARK,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3984), 1,
      sym__preprocessor_call,
    ACTIONS(3350), 2,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [129064] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6802), 1,
      anon_sym_QMARK,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6826), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6828), 1,
      anon_sym_QMARK_QMARK,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3985), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
  [129181] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6780), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6798), 1,
      anon_sym_QMARK_QMARK,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3986), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_into,
  [129298] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3987), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [129379] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6802), 1,
      anon_sym_QMARK,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6826), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6828), 1,
      anon_sym_QMARK_QMARK,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3988), 1,
      sym__preprocessor_call,
    ACTIONS(3350), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [129498] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    ACTIONS(6830), 1,
      anon_sym_DOT,
    STATE(3989), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 32,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [129565] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6802), 1,
      anon_sym_QMARK,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6826), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6828), 1,
      anon_sym_QMARK_QMARK,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3990), 1,
      sym__preprocessor_call,
    ACTIONS(3510), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [129684] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6802), 1,
      anon_sym_QMARK,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6826), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6828), 1,
      anon_sym_QMARK_QMARK,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3991), 1,
      sym__preprocessor_call,
    ACTIONS(5255), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [129803] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(803), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(3164), 1,
      anon_sym_LBRACK,
    ACTIONS(3166), 1,
      anon_sym_LPAREN,
    ACTIONS(3168), 1,
      anon_sym_LBRACE,
    ACTIONS(3170), 1,
      anon_sym_delegate,
    ACTIONS(3172), 1,
      anon_sym_var,
    ACTIONS(3174), 1,
      sym_predefined_type,
    STATE(2051), 1,
      sym__type,
    STATE(2065), 1,
      sym_array_type,
    STATE(2069), 1,
      sym_argument_list,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2856), 1,
      sym_generic_name,
    STATE(3992), 1,
      sym__preprocessor_call,
    STATE(4205), 1,
      sym_identifier,
    STATE(4432), 1,
      sym_global,
    STATE(4529), 1,
      sym__name,
    STATE(6945), 1,
      sym__nullable_base_type,
    STATE(2114), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2111), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2115), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [129904] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6826), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6828), 1,
      anon_sym_QMARK_QMARK,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3993), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
  [130019] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3994), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_PIPE_PIPE,
  [130130] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3995), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [130239] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3996), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [130340] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3997), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [130443] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(3998), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [130550] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(5759), 1,
      anon_sym_GT,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(3999), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5902), 1,
      sym__type,
    STATE(6309), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [130649] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4000), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [130754] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6832), 1,
      anon_sym_into,
    STATE(2949), 1,
      sym_query_continuation,
    STATE(4001), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [130821] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6802), 1,
      anon_sym_QMARK,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6826), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6828), 1,
      anon_sym_QMARK_QMARK,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4002), 1,
      sym__preprocessor_call,
    ACTIONS(3518), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [130940] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6802), 1,
      anon_sym_QMARK,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6826), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6828), 1,
      anon_sym_QMARK_QMARK,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4003), 1,
      sym__preprocessor_call,
    ACTIONS(5301), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [131059] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6832), 1,
      anon_sym_into,
    STATE(2962), 1,
      sym_query_continuation,
    STATE(4004), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [131126] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6802), 1,
      anon_sym_QMARK,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6826), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6828), 1,
      anon_sym_QMARK_QMARK,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4005), 1,
      sym__preprocessor_call,
    ACTIONS(5337), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [131245] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6834), 1,
      anon_sym_into,
    STATE(2767), 1,
      sym_query_continuation,
    STATE(4006), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [131312] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6836), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4007), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [131433] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4008), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [131514] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4009), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [131597] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4010), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [131688] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6834), 1,
      anon_sym_into,
    STATE(2852), 1,
      sym_query_continuation,
    STATE(4011), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [131755] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4012), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [131842] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4013), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [131931] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4014), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [132024] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6838), 1,
      anon_sym_into,
    STATE(2949), 1,
      sym_query_continuation,
    STATE(4015), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [132091] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(1133), 1,
      anon_sym_global,
    ACTIONS(6840), 1,
      anon_sym_LBRACK,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym_LBRACE,
    ACTIONS(6846), 1,
      anon_sym_delegate,
    ACTIONS(6848), 1,
      anon_sym_var,
    ACTIONS(6850), 1,
      sym_predefined_type,
    STATE(2043), 1,
      sym__type,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2061), 1,
      sym_array_type,
    STATE(2062), 1,
      sym_argument_list,
    STATE(2096), 1,
      sym_generic_name,
    STATE(3387), 1,
      sym_identifier,
    STATE(3415), 1,
      sym_global,
    STATE(3524), 1,
      sym__name,
    STATE(4016), 1,
      sym__preprocessor_call,
    STATE(6712), 1,
      sym__nullable_base_type,
    STATE(2087), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2070), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2088), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [132192] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6838), 1,
      anon_sym_into,
    STATE(2962), 1,
      sym_query_continuation,
    STATE(4017), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [132259] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6852), 1,
      anon_sym_into,
    STATE(2767), 1,
      sym_query_continuation,
    STATE(4018), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [132326] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6852), 1,
      anon_sym_into,
    STATE(2852), 1,
      sym_query_continuation,
    STATE(4019), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [132393] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(6840), 1,
      anon_sym_LBRACK,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym_LBRACE,
    ACTIONS(6846), 1,
      anon_sym_delegate,
    ACTIONS(6848), 1,
      anon_sym_var,
    ACTIONS(6850), 1,
      sym_predefined_type,
    STATE(2043), 1,
      sym__type,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2061), 1,
      sym_array_type,
    STATE(2062), 1,
      sym_argument_list,
    STATE(2096), 1,
      sym_generic_name,
    STATE(3387), 1,
      sym_identifier,
    STATE(3415), 1,
      sym_global,
    STATE(3524), 1,
      sym__name,
    STATE(4020), 1,
      sym__preprocessor_call,
    STATE(6712), 1,
      sym__nullable_base_type,
    STATE(2087), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2070), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2088), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [132494] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6854), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(4021), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [132565] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6602), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4022), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [132686] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6856), 1,
      anon_sym_into,
    STATE(2949), 1,
      sym_query_continuation,
    STATE(4023), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [132753] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6856), 1,
      anon_sym_into,
    STATE(2962), 1,
      sym_query_continuation,
    STATE(4024), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [132820] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6858), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(4025), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [132891] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6860), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4026), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [133012] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_QMARK,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4027), 1,
      sym__preprocessor_call,
    ACTIONS(5337), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [133131] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(6840), 1,
      anon_sym_LBRACK,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym_LBRACE,
    ACTIONS(6846), 1,
      anon_sym_delegate,
    ACTIONS(6848), 1,
      anon_sym_var,
    ACTIONS(6850), 1,
      sym_predefined_type,
    STATE(2043), 1,
      sym__type,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2061), 1,
      sym_array_type,
    STATE(2062), 1,
      sym_argument_list,
    STATE(2096), 1,
      sym_generic_name,
    STATE(3120), 1,
      sym_identifier,
    STATE(3126), 1,
      sym_global,
    STATE(3202), 1,
      sym__name,
    STATE(4028), 1,
      sym__preprocessor_call,
    STATE(6712), 1,
      sym__nullable_base_type,
    STATE(2087), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2070), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2088), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [133232] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4029), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6862), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [133351] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(6864), 1,
      anon_sym_GT,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4030), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5892), 1,
      sym__type,
    STATE(6417), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [133450] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4031), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6866), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [133569] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6670), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4032), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [133690] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(6840), 1,
      anon_sym_LBRACK,
    ACTIONS(6842), 1,
      anon_sym_LPAREN,
    ACTIONS(6844), 1,
      anon_sym_LBRACE,
    ACTIONS(6846), 1,
      anon_sym_delegate,
    ACTIONS(6848), 1,
      anon_sym_var,
    ACTIONS(6850), 1,
      sym_predefined_type,
    STATE(2043), 1,
      sym__type,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2061), 1,
      sym_array_type,
    STATE(2062), 1,
      sym_argument_list,
    STATE(2096), 1,
      sym_generic_name,
    STATE(3078), 1,
      sym_identifier,
    STATE(3187), 1,
      sym_global,
    STATE(3217), 1,
      sym__name,
    STATE(4033), 1,
      sym__preprocessor_call,
    STATE(6712), 1,
      sym__nullable_base_type,
    STATE(2087), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2070), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2088), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [133791] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6896), 1,
      anon_sym_QMARK_QMARK,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4034), 1,
      sym__preprocessor_call,
    ACTIONS(5307), 2,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [133910] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6896), 1,
      anon_sym_QMARK_QMARK,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4035), 1,
      sym__preprocessor_call,
    ACTIONS(5266), 2,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [134029] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6896), 1,
      anon_sym_QMARK_QMARK,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4036), 1,
      sym__preprocessor_call,
    ACTIONS(5337), 2,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [134148] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4037), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [134231] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4038), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [134312] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4039), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [134393] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6898), 1,
      anon_sym_into,
    STATE(2767), 1,
      sym_query_continuation,
    STATE(4040), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [134460] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6900), 1,
      anon_sym_and,
    ACTIONS(6902), 1,
      anon_sym_or,
    STATE(4041), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [134527] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6898), 1,
      anon_sym_into,
    STATE(2852), 1,
      sym_query_continuation,
    STATE(4042), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [134594] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4043), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [134677] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4044), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [134758] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6904), 1,
      anon_sym_into,
    STATE(2949), 1,
      sym_query_continuation,
    STATE(4045), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [134825] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6904), 1,
      anon_sym_into,
    STATE(2962), 1,
      sym_query_continuation,
    STATE(4046), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [134892] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(6906), 1,
      anon_sym_GT,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4047), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5897), 1,
      sym__type,
    STATE(6250), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [134991] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4048), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6908), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [135110] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6910), 1,
      anon_sym_into,
    STATE(2767), 1,
      sym_query_continuation,
    STATE(4049), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [135177] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6600), 1,
      anon_sym_COMMA,
    ACTIONS(6668), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4050), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [135298] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6910), 1,
      anon_sym_into,
    STATE(2852), 1,
      sym_query_continuation,
    STATE(4051), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [135365] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4052), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [135446] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6900), 1,
      anon_sym_and,
    STATE(4053), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 31,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [135511] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6896), 1,
      anon_sym_QMARK_QMARK,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4054), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
  [135628] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6896), 1,
      anon_sym_QMARK_QMARK,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4055), 1,
      sym__preprocessor_call,
    ACTIONS(3350), 2,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [135747] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6780), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6798), 1,
      anon_sym_QMARK_QMARK,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4056), 1,
      sym__preprocessor_call,
    ACTIONS(5307), 2,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [135866] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6896), 1,
      anon_sym_QMARK_QMARK,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4057), 1,
      sym__preprocessor_call,
    ACTIONS(3510), 2,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [135985] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6780), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6798), 1,
      anon_sym_QMARK_QMARK,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4058), 1,
      sym__preprocessor_call,
    ACTIONS(5266), 2,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [136104] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6896), 1,
      anon_sym_QMARK_QMARK,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4059), 1,
      sym__preprocessor_call,
    ACTIONS(5255), 2,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [136223] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6896), 1,
      anon_sym_QMARK_QMARK,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4060), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
  [136338] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4061), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_PIPE_PIPE,
  [136449] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4062), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [136558] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4063), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 17,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [136659] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4064), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [136762] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6776), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6780), 1,
      anon_sym_QMARK,
    ACTIONS(6782), 1,
      anon_sym_CARET,
    ACTIONS(6784), 1,
      anon_sym_PIPE,
    ACTIONS(6786), 1,
      anon_sym_AMP,
    ACTIONS(6792), 1,
      anon_sym_is,
    ACTIONS(6794), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6796), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6798), 1,
      anon_sym_QMARK_QMARK,
    STATE(810), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4065), 1,
      sym__preprocessor_call,
    ACTIONS(5337), 2,
      anon_sym_on,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6770), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6774), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6778), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6788), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6790), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6772), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [136881] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4066), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6912), 2,
      anon_sym_COLON,
      anon_sym_RBRACE,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [137000] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6472), 1,
      anon_sym_COLON_COLON,
    STATE(4067), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [137065] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6748), 1,
      anon_sym_and,
    ACTIONS(6914), 1,
      anon_sym_or,
    STATE(4068), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [137132] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4069), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [137239] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4070), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 15,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [137344] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6896), 1,
      anon_sym_QMARK_QMARK,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4071), 1,
      sym__preprocessor_call,
    ACTIONS(3518), 2,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [137463] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6870), 1,
      anon_sym_QMARK,
    ACTIONS(6876), 1,
      anon_sym_CARET,
    ACTIONS(6878), 1,
      anon_sym_PIPE,
    ACTIONS(6880), 1,
      anon_sym_AMP,
    ACTIONS(6888), 1,
      anon_sym_is,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6892), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6894), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6896), 1,
      anon_sym_QMARK_QMARK,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4072), 1,
      sym__preprocessor_call,
    ACTIONS(5301), 2,
      anon_sym_equals,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6868), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6884), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6886), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [137582] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4073), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 24,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [137663] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4074), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6916), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [137782] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4075), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [137865] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4076), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6918), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [137984] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4077), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [138075] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(6920), 1,
      anon_sym_GT,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4078), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5883), 1,
      sym__type,
    STATE(6220), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [138174] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4079), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6922), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [138293] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4080), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [138380] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4081), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [138469] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(3164), 1,
      anon_sym_LBRACK,
    ACTIONS(3166), 1,
      anon_sym_LPAREN,
    ACTIONS(3168), 1,
      anon_sym_LBRACE,
    ACTIONS(3170), 1,
      anon_sym_delegate,
    ACTIONS(3172), 1,
      anon_sym_var,
    ACTIONS(3174), 1,
      sym_predefined_type,
    STATE(2051), 1,
      sym__type,
    STATE(2065), 1,
      sym_array_type,
    STATE(2069), 1,
      sym_argument_list,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2096), 1,
      sym_generic_name,
    STATE(3620), 1,
      sym_identifier,
    STATE(3798), 1,
      sym_global,
    STATE(3989), 1,
      sym__name,
    STATE(4082), 1,
      sym__preprocessor_call,
    STATE(6945), 1,
      sym__nullable_base_type,
    STATE(2114), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2111), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2115), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [138570] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4083), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [138653] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4084), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [138734] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4085), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 24,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [138815] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6802), 1,
      anon_sym_QMARK,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6826), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6828), 1,
      anon_sym_QMARK_QMARK,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4086), 1,
      sym__preprocessor_call,
    ACTIONS(5307), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [138934] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(5803), 1,
      anon_sym_as,
    ACTIONS(6802), 1,
      anon_sym_QMARK,
    ACTIONS(6808), 1,
      anon_sym_CARET,
    ACTIONS(6810), 1,
      anon_sym_PIPE,
    ACTIONS(6812), 1,
      anon_sym_AMP,
    ACTIONS(6820), 1,
      anon_sym_is,
    ACTIONS(6822), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6824), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6826), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6828), 1,
      anon_sym_QMARK_QMARK,
    STATE(944), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4087), 1,
      sym__preprocessor_call,
    ACTIONS(5266), 2,
      anon_sym_into,
      anon_sym_by,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6800), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6804), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6814), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6816), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6818), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6806), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [139053] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(5773), 1,
      anon_sym_DOT,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(6890), 1,
      anon_sym_DOT_DOT,
    STATE(718), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4088), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6872), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6882), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6874), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 21,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [139146] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6924), 1,
      anon_sym_LBRACK,
    STATE(4492), 1,
      sym_attribute_list,
    STATE(4089), 2,
      sym__preprocessor_call,
      aux_sym_event_field_declaration_repeat1,
    ACTIONS(5186), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [139211] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4090), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6927), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [139330] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5506), 1,
      anon_sym_switch,
    ACTIONS(5512), 1,
      anon_sym_with,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6718), 1,
      anon_sym_QMARK,
    ACTIONS(6724), 1,
      anon_sym_CARET,
    ACTIONS(6726), 1,
      anon_sym_PIPE,
    ACTIONS(6728), 1,
      anon_sym_AMP,
    ACTIONS(6736), 1,
      anon_sym_is,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6740), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6742), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6744), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6746), 1,
      anon_sym_as,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4091), 1,
      sym__preprocessor_call,
    ACTIONS(5307), 2,
      anon_sym_EQ_GT,
      anon_sym_into,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6716), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6720), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6730), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6732), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6734), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6722), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [139449] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4092), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 24,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [139530] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4093), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 24,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [139611] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(875), 1,
      anon_sym_LBRACK,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(6018), 1,
      anon_sym_DOT,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(6738), 1,
      anon_sym_DOT_DOT,
    STATE(1283), 1,
      sym_assignment_operator,
    STATE(2120), 1,
      sym_bracketed_argument_list,
    STATE(2122), 1,
      sym_argument_list,
    STATE(4094), 1,
      sym__preprocessor_call,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_into,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [139694] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2842), 1,
      anon_sym_EQ_GT,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6588), 1,
      anon_sym_EQ,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(4095), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 15,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [139767] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4096), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [139855] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6933), 1,
      anon_sym_COMMA,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4097), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [139973] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6957), 1,
      anon_sym_by,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4098), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [140091] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_equals,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6969), 1,
      anon_sym_QMARK,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6993), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6995), 1,
      anon_sym_QMARK_QMARK,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4099), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [140209] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6969), 1,
      anon_sym_QMARK,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6993), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6995), 1,
      anon_sym_QMARK_QMARK,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4100), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
  [140325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6997), 1,
      anon_sym_and,
    STATE(4101), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 30,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [140389] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6999), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4102), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [140507] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5301), 1,
      anon_sym_by,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4103), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [140625] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7001), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4104), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [140743] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4105), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [140823] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3510), 1,
      anon_sym_equals,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6969), 1,
      anon_sym_QMARK,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6993), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6995), 1,
      anon_sym_QMARK_QMARK,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4106), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [140941] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7003), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4107), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141059] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7005), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4108), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141177] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5255), 1,
      anon_sym_equals,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6969), 1,
      anon_sym_QMARK,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6993), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6995), 1,
      anon_sym_QMARK_QMARK,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4109), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141295] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7007), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4110), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141413] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6993), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6995), 1,
      anon_sym_QMARK_QMARK,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4111), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
  [141527] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7009), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4112), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141645] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6969), 1,
      anon_sym_QMARK,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6993), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6995), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7011), 1,
      anon_sym_equals,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4113), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141763] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7013), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4114), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [141881] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4115), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_PIPE_PIPE,
  [141991] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4116), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [142099] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4117), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 22,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [142181] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4118), 1,
      sym__preprocessor_call,
    ACTIONS(7023), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(7021), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [142243] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3518), 1,
      anon_sym_by,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4119), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4120), 1,
      sym__preprocessor_call,
    ACTIONS(7023), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(7021), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [142423] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4121), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 22,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [142505] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7031), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4122), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142623] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7033), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4123), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142741] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7035), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4124), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142859] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7037), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4125), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [142977] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(6424), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4126), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143095] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7039), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4127), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143213] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7043), 1,
      anon_sym_QMARK,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7065), 1,
      anon_sym_QMARK_QMARK,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4128), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
  [143329] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4129), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [143409] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    ACTIONS(7067), 1,
      anon_sym_DOT,
    STATE(4130), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 31,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_and,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [143475] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7069), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4131), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143593] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7071), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4132), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143711] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7073), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4133), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143829] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7075), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4134), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [143947] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7077), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4135), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [144065] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(7079), 1,
      anon_sym_COLON_COLON,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(4136), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [144133] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4137), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 23,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [144213] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4138), 1,
      sym__preprocessor_call,
    ACTIONS(2334), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2336), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [144275] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_on,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7043), 1,
      anon_sym_QMARK,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7065), 1,
      anon_sym_QMARK_QMARK,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4139), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [144393] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_in,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4140), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [144511] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5307), 1,
      anon_sym_in,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4141), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [144629] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4142), 1,
      sym__preprocessor_call,
    ACTIONS(5418), 4,
      anon_sym_COLON,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(3067), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3075), 27,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [144693] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4143), 1,
      sym__preprocessor_call,
    ACTIONS(2480), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2482), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [144755] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4144), 1,
      sym__preprocessor_call,
    ACTIONS(7113), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(7111), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [144817] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4145), 1,
      sym__preprocessor_call,
    ACTIONS(2484), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2486), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [144879] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7115), 1,
      anon_sym_and,
    ACTIONS(7117), 1,
      anon_sym_or,
    STATE(4146), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [144945] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4147), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [145049] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7119), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4148), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [145167] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7121), 1,
      anon_sym_and,
    ACTIONS(7123), 1,
      anon_sym_or,
    STATE(4149), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [145233] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6400), 1,
      anon_sym_STAR,
    ACTIONS(7125), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4150), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4865), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [145329] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4151), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [145435] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    ACTIONS(7127), 1,
      anon_sym_in,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4152), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [145553] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4153), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [145655] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4154), 1,
      sym__preprocessor_call,
    ACTIONS(7113), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(7111), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [145717] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4155), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [145817] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7129), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4156), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [145935] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7131), 1,
      anon_sym_and,
    ACTIONS(7133), 1,
      anon_sym_or,
    STATE(4157), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [146001] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7135), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4158), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [146119] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4159), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [146211] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7143), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4160), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [146329] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7145), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4161), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [146447] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7147), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4162), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [146565] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7149), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4163), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [146683] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6400), 1,
      anon_sym_STAR,
    ACTIONS(7151), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4164), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4861), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [146779] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7043), 1,
      anon_sym_QMARK,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7065), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7153), 1,
      anon_sym_on,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4165), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [146897] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4166), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [146977] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4167), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [147077] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7155), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4168), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [147195] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4169), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 23,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [147275] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7157), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4170), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [147393] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7159), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4171), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [147511] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4172), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [147599] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4173), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [147685] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5307), 1,
      anon_sym_by,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4174), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [147803] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4175), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [147893] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5307), 1,
      anon_sym_on,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7043), 1,
      anon_sym_QMARK,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7065), 1,
      anon_sym_QMARK_QMARK,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4176), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [148011] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    ACTIONS(7161), 1,
      anon_sym_in,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4177), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [148129] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4178), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [148237] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4179), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [148317] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4180), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [148397] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4181), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
      anon_sym_PIPE_PIPE,
  [148507] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4182), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
  [148621] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4183), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 22,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [148703] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4184), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [148783] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3510), 1,
      anon_sym_on,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7043), 1,
      anon_sym_QMARK,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7065), 1,
      anon_sym_QMARK_QMARK,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4185), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [148901] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5255), 1,
      anon_sym_by,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4186), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [149019] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4187), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [149109] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4188), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [149211] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5255), 1,
      anon_sym_on,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7043), 1,
      anon_sym_QMARK,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7065), 1,
      anon_sym_QMARK_QMARK,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4189), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [149329] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7065), 1,
      anon_sym_QMARK_QMARK,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4190), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
  [149443] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3510), 1,
      anon_sym_by,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4191), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [149561] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7131), 1,
      anon_sym_and,
    ACTIONS(7133), 1,
      anon_sym_or,
    STATE(4192), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [149627] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7131), 1,
      anon_sym_and,
    STATE(4193), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [149691] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4194), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [149797] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7163), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(4195), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [149867] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7165), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4196), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [149985] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4197), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [150089] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7167), 1,
      anon_sym_LT,
    STATE(4198), 1,
      sym__preprocessor_call,
    STATE(4537), 1,
      sym_type_argument_list,
    ACTIONS(2829), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2827), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [150155] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4199), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 13,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_PIPE_PIPE,
  [150265] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4200), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [150373] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4201), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [150455] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7172), 1,
      anon_sym_ref,
    STATE(4521), 1,
      sym_modifier,
    STATE(4202), 2,
      sym__preprocessor_call,
      aux_sym_event_field_declaration_repeat2,
    ACTIONS(7169), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
    ACTIONS(5323), 27,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [150521] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7175), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4203), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [150639] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7177), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4204), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [150757] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5288), 1,
      anon_sym_LT,
    ACTIONS(7179), 1,
      anon_sym_COLON_COLON,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(4205), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [150825] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7181), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4206), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [150943] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6400), 1,
      anon_sym_STAR,
    ACTIONS(7183), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4207), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4842), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [151039] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7185), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4208), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [151157] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7187), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4209), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [151275] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7059), 1,
      anon_sym_is,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4210), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [151375] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4211), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [151461] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4212), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [151551] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7189), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4213), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [151669] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7191), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4214), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [151787] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7193), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4215), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [151905] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7059), 1,
      anon_sym_is,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4216), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [152007] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7195), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4217), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [152125] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4218), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [152231] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7197), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4219), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [152349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4220), 1,
      sym__preprocessor_call,
    ACTIONS(1977), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(1979), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [152411] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5301), 1,
      anon_sym_in,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4221), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [152529] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4222), 1,
      sym__preprocessor_call,
    ACTIONS(2214), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(2216), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [152591] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7199), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4223), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [152709] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4224), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [152813] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4225), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [152899] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4226), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [152987] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7201), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4227), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [153105] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4228), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [153197] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4229), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [153289] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7203), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4230), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [153407] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7205), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4231), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [153525] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3518), 1,
      anon_sym_equals,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6969), 1,
      anon_sym_QMARK,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6993), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6995), 1,
      anon_sym_QMARK_QMARK,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4232), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [153643] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7207), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4233), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [153761] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3518), 1,
      anon_sym_on,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7043), 1,
      anon_sym_QMARK,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7065), 1,
      anon_sym_QMARK_QMARK,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4234), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [153879] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7211), 1,
      anon_sym_EQ_GT,
    ACTIONS(7213), 1,
      anon_sym_QMARK,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4235), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [153997] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7235), 1,
      anon_sym_and,
    ACTIONS(7237), 1,
      anon_sym_or,
    STATE(4236), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [154063] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7211), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4237), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [154181] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7239), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4238), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [154299] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7241), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4239), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [154417] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7043), 1,
      anon_sym_QMARK,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7065), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7243), 1,
      anon_sym_on,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4240), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [154535] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7245), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4241), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [154653] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7247), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4242), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [154771] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7249), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4243), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [154889] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5301), 1,
      anon_sym_equals,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6969), 1,
      anon_sym_QMARK,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6993), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6995), 1,
      anon_sym_QMARK_QMARK,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4244), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [155007] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4245), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [155099] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7251), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4246), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [155217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(4247), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [155285] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4248), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [155373] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4249), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [155459] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4250), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [155549] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7253), 1,
      anon_sym_COMMA,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4251), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [155667] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7255), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4252), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [155785] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4253), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [155867] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7257), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(4254), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [155937] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7259), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4255), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [156055] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5307), 1,
      anon_sym_EQ_GT,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7213), 1,
      anon_sym_QMARK,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4256), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [156173] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7261), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4257), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [156291] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4258), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [156371] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4259), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [156453] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4260), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [156533] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4261), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 23,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [156613] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7263), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4262), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [156731] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7265), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4263), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [156849] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7267), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4264), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [156967] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7269), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4265), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [157085] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7115), 1,
      anon_sym_and,
    ACTIONS(7117), 1,
      anon_sym_or,
    STATE(4266), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [157151] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7271), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4267), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [157269] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4268), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 12,
      anon_sym_in,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [157385] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7273), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4269), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [157503] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7275), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4270), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [157621] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7277), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4271), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [157739] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_by,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4272), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [157857] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5301), 1,
      anon_sym_on,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7043), 1,
      anon_sym_QMARK,
    ACTIONS(7047), 1,
      anon_sym_CARET,
    ACTIONS(7049), 1,
      anon_sym_PIPE,
    ACTIONS(7051), 1,
      anon_sym_AMP,
    ACTIONS(7059), 1,
      anon_sym_is,
    ACTIONS(7061), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7063), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7065), 1,
      anon_sym_QMARK_QMARK,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4273), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7041), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7045), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7053), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7055), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7057), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6929), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [157975] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7279), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4274), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [158093] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7281), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4275), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [158211] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7283), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4276), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [158329] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7285), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4277), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [158447] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7287), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4278), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [158565] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7289), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4279), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [158683] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7291), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4280), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [158801] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7293), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4281), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [158919] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7295), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4282), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [159037] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7297), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4283), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [159155] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3104), 1,
      anon_sym_COLON,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6588), 1,
      anon_sym_EQ,
    STATE(4284), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [159223] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7299), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4285), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [159341] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7301), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4286), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [159459] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7303), 1,
      anon_sym_and,
    ACTIONS(7305), 1,
      anon_sym_or,
    STATE(4287), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [159525] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7307), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4288), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [159643] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4289), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 12,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_by,
  [159759] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7309), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4290), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [159877] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7235), 1,
      anon_sym_and,
    ACTIONS(7237), 1,
      anon_sym_or,
    STATE(4291), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [159943] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7311), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4292), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [160061] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4293), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 8,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [160153] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7313), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4294), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [160271] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4295), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 12,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [160359] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    ACTIONS(7315), 1,
      anon_sym_in,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4296), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [160477] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7317), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4297), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [160595] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7319), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4298), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [160713] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4299), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5211), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [160799] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7321), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4300), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [160917] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7323), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4301), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [161035] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4302), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_in,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [161139] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4303), 1,
      sym__preprocessor_call,
    ACTIONS(7327), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(7325), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [161201] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7329), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4304), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [161319] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7331), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4305), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [161437] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7333), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4306), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [161555] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7335), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4307), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [161673] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5301), 1,
      anon_sym_EQ_GT,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7213), 1,
      anon_sym_QMARK,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4308), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [161791] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3518), 1,
      anon_sym_EQ_GT,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7213), 1,
      anon_sym_QMARK,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4309), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [161909] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6969), 1,
      anon_sym_QMARK,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6993), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6995), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7337), 1,
      anon_sym_equals,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4310), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [162027] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7339), 1,
      anon_sym_COMMA,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4311), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [162145] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7341), 1,
      anon_sym_readonly,
    ACTIONS(7343), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4312), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5955), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [162241] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7235), 1,
      anon_sym_and,
    STATE(4313), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [162305] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4314), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_in,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [162411] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4315), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_in,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [162513] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5307), 1,
      anon_sym_equals,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6969), 1,
      anon_sym_QMARK,
    ACTIONS(6975), 1,
      anon_sym_CARET,
    ACTIONS(6977), 1,
      anon_sym_PIPE,
    ACTIONS(6979), 1,
      anon_sym_AMP,
    ACTIONS(6987), 1,
      anon_sym_is,
    ACTIONS(6989), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6991), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6993), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6995), 1,
      anon_sym_QMARK_QMARK,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4316), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6967), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6971), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6981), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6983), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6985), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6973), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [162631] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4317), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [162711] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4318), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 10,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 20,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [162801] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7345), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4319), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [162919] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7347), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4320), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [163037] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7349), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4321), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [163155] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7351), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4322), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [163273] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6997), 1,
      anon_sym_and,
    ACTIONS(7353), 1,
      anon_sym_or,
    STATE(4323), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 29,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [163339] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7355), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4324), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [163457] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4325), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [163539] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7357), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4326), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [163657] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4327), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [163757] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6400), 1,
      anon_sym_STAR,
    ACTIONS(7359), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4328), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4932), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [163853] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3160), 1,
      anon_sym_EQ_GT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(5288), 1,
      anon_sym_LT,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(4329), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [163923] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7361), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4330), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [164041] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7363), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4331), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [164159] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7365), 1,
      anon_sym_COMMA,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4332), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [164277] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    ACTIONS(7367), 1,
      anon_sym_in,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4333), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [164395] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7369), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4334), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [164513] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7371), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4335), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [164631] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7373), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4336), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [164749] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7115), 1,
      anon_sym_and,
    STATE(4337), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [164813] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7375), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4338), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [164931] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7377), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4339), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [165049] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7379), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4340), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [165167] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4341), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(731), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(725), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [165249] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(966), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4342), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5278), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5280), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [165329] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7381), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4343), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [165447] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4344), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5319), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5321), 23,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [165527] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4345), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5282), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5284), 23,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [165607] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3510), 1,
      anon_sym_in,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4346), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [165725] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7383), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4347), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [165843] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7385), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4348), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [165961] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6328), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4349), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [166079] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7387), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4350), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [166197] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7389), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4351), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [166315] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7391), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4352), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [166433] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7393), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4353), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [166551] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3296), 1,
      anon_sym_LT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7395), 1,
      anon_sym_EQ_GT,
    STATE(2086), 1,
      sym_type_argument_list,
    STATE(4354), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [166621] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4355), 1,
      sym__preprocessor_call,
    ACTIONS(7399), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(7397), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [166683] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7401), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4356), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [166801] = 26,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4357), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 5,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [166905] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4358), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 4,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_PIPE,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [167011] = 25,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4359), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 14,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [167113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4360), 1,
      sym__preprocessor_call,
    ACTIONS(7399), 2,
      anon_sym_LBRACK,
      anon_sym_RBRACE,
    ACTIONS(7397), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [167175] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4361), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5211), 6,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_QMARK_QMARK,
    ACTIONS(5215), 16,
      anon_sym_EQ_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [167275] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6400), 1,
      anon_sym_STAR,
    ACTIONS(7403), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4362), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4878), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [167371] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(6931), 1,
      anon_sym_DOT_DOT,
    STATE(738), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4363), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 22,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_on,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [167453] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4364), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [167561] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4365), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 13,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_PIPE_PIPE,
  [167671] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4366), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 12,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [167785] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5255), 1,
      anon_sym_EQ_GT,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7213), 1,
      anon_sym_QMARK,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4367), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [167903] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7405), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4368), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [168021] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7407), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4369), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [168139] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7121), 1,
      anon_sym_and,
    ACTIONS(7123), 1,
      anon_sym_or,
    STATE(4370), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [168205] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7409), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4371), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [168323] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7411), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4372), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [168441] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7121), 1,
      anon_sym_and,
    STATE(4373), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_into,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [168505] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4374), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5333), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_QMARK,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5335), 22,
      anon_sym_in,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [168587] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7413), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4375), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [168705] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3510), 1,
      anon_sym_EQ_GT,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7213), 1,
      anon_sym_QMARK,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4376), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [168823] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7415), 1,
      anon_sym_COMMA,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4377), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [168941] = 28,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4378), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 14,
      anon_sym_in,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [169049] = 29,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4379), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5211), 3,
      anon_sym_EQ,
      anon_sym_QMARK,
      anon_sym_QMARK_QMARK,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 13,
      anon_sym_in,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_PIPE_PIPE,
  [169159] = 31,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4380), 1,
      sym__preprocessor_call,
    ACTIONS(5211), 2,
      anon_sym_EQ,
      anon_sym_QMARK,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5215), 12,
      anon_sym_in,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [169273] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7417), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4381), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [169391] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7419), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4382), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [169509] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(6937), 1,
      anon_sym_QMARK,
    ACTIONS(6943), 1,
      anon_sym_CARET,
    ACTIONS(6945), 1,
      anon_sym_PIPE,
    ACTIONS(6947), 1,
      anon_sym_AMP,
    ACTIONS(6955), 1,
      anon_sym_is,
    ACTIONS(6959), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6961), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6963), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6965), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7421), 1,
      anon_sym_by,
    STATE(854), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4383), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [169627] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5255), 1,
      anon_sym_in,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4384), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [169745] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7423), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4385), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [169863] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3350), 1,
      anon_sym_EQ_GT,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7213), 1,
      anon_sym_QMARK,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4386), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [169981] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(3518), 1,
      anon_sym_in,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4387), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [170099] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7425), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4388), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [170217] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7427), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4389), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [170335] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5270), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7025), 1,
      anon_sym_DOT,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(7029), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7213), 1,
      anon_sym_QMARK,
    ACTIONS(7215), 1,
      anon_sym_CARET,
    ACTIONS(7217), 1,
      anon_sym_PIPE,
    ACTIONS(7219), 1,
      anon_sym_AMP,
    ACTIONS(7225), 1,
      anon_sym_is,
    ACTIONS(7227), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7229), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7231), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7233), 1,
      anon_sym_as,
    STATE(893), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4390), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7137), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7141), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7209), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7221), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7223), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7139), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5272), 12,
      anon_sym_EQ_GT,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [170451] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7429), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4391), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [170569] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7431), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4392), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [170687] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7303), 1,
      anon_sym_and,
    STATE(4393), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 30,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_when,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [170751] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    ACTIONS(7433), 1,
      anon_sym_in,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4394), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [170869] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7435), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4395), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [170987] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(7015), 1,
      anon_sym_DOT,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7019), 1,
      anon_sym_DOT_DOT,
    ACTIONS(7083), 1,
      anon_sym_QMARK,
    ACTIONS(7089), 1,
      anon_sym_CARET,
    ACTIONS(7091), 1,
      anon_sym_PIPE,
    ACTIONS(7093), 1,
      anon_sym_AMP,
    ACTIONS(7101), 1,
      anon_sym_is,
    ACTIONS(7103), 1,
      anon_sym_AMP_AMP,
    ACTIONS(7105), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(7107), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7109), 1,
      anon_sym_as,
    ACTIONS(7437), 1,
      anon_sym_in,
    STATE(1241), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4396), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(7081), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(7085), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(7095), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(7097), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(7099), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(7087), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [171105] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7439), 1,
      anon_sym_SEMI,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4397), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [171223] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7441), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4398), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [171341] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(6134), 1,
      anon_sym_DOT,
    ACTIONS(6140), 1,
      anon_sym_QMARK,
    ACTIONS(6146), 1,
      anon_sym_CARET,
    ACTIONS(6148), 1,
      anon_sym_PIPE,
    ACTIONS(6150), 1,
      anon_sym_AMP,
    ACTIONS(6158), 1,
      anon_sym_is,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(6162), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6164), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6166), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6168), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(6170), 1,
      anon_sym_as,
    ACTIONS(7443), 1,
      anon_sym_COLON,
    STATE(1120), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4399), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6130), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6142), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6152), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6154), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6156), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6144), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [171459] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7445), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4400), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [171577] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(5996), 1,
      anon_sym_CARET,
    ACTIONS(5998), 1,
      anon_sym_PIPE,
    ACTIONS(6000), 1,
      anon_sym_AMP,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6012), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6014), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6016), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(7447), 1,
      anon_sym_RPAREN,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4401), 1,
      sym__preprocessor_call,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5988), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5992), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6002), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6004), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6006), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5994), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [171695] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4402), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4711), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6970), 1,
      sym_variable_declaration,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [171788] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3136), 1,
      anon_sym_DOT,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6546), 1,
      anon_sym_CARET,
    ACTIONS(6548), 1,
      anon_sym_PIPE,
    ACTIONS(6550), 1,
      anon_sym_AMP,
    ACTIONS(6560), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6562), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6564), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4403), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6538), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6542), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6552), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6554), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6556), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6544), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [171903] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7449), 1,
      anon_sym_and,
    STATE(4404), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [171966] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6286), 1,
      anon_sym_CARET,
    ACTIONS(6288), 1,
      anon_sym_PIPE,
    ACTIONS(6290), 1,
      anon_sym_AMP,
    ACTIONS(6302), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6304), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6306), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4405), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6278), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6282), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6292), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6294), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6296), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6284), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [172081] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4406), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4711), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6780), 1,
      sym_variable_declaration,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [172174] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_or,
    STATE(4407), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [172239] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3186), 1,
      anon_sym_DOT,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(3240), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5494), 1,
      anon_sym_BANG,
    ACTIONS(5550), 1,
      anon_sym_CARET,
    ACTIONS(5552), 1,
      anon_sym_PIPE,
    ACTIONS(5554), 1,
      anon_sym_AMP,
    ACTIONS(5556), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5558), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5560), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2122), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4408), 1,
      sym__preprocessor_call,
    ACTIONS(5492), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5496), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5498), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5502), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5504), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5518), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5500), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [172354] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5317), 1,
      anon_sym_LBRACK,
    STATE(4409), 1,
      sym__preprocessor_call,
    ACTIONS(5315), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [172415] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7451), 1,
      anon_sym_and,
    ACTIONS(7453), 1,
      anon_sym_or,
    STATE(4410), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [172480] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4411), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4605), 1,
      sym__type,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6825), 1,
      sym_variable_declaration,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [172573] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7455), 1,
      anon_sym_and,
    STATE(4412), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [172636] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6232), 1,
      anon_sym_CARET,
    ACTIONS(6234), 1,
      anon_sym_PIPE,
    ACTIONS(6236), 1,
      anon_sym_AMP,
    ACTIONS(6248), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6250), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6252), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2745), 1,
      sym_argument_list,
    STATE(4413), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6224), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6228), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6238), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6240), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6242), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6230), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [172751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4414), 1,
      sym__preprocessor_call,
    ACTIONS(1977), 2,
      anon_sym_while,
      anon_sym_else,
    ACTIONS(1984), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(1989), 28,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [172814] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5353), 1,
      anon_sym_CARET,
    ACTIONS(5355), 1,
      anon_sym_PIPE,
    ACTIONS(5357), 1,
      anon_sym_AMP,
    ACTIONS(5369), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5371), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5373), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(4415), 1,
      sym__preprocessor_call,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5345), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5349), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5359), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5361), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5363), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5351), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [172929] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4416), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6255), 1,
      sym_tuple_element,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [173022] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7449), 1,
      anon_sym_and,
    ACTIONS(7457), 1,
      anon_sym_or,
    STATE(4417), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [173087] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7079), 1,
      anon_sym_COLON_COLON,
    STATE(4418), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [173150] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6436), 1,
      anon_sym_CARET,
    ACTIONS(6438), 1,
      anon_sym_PIPE,
    ACTIONS(6440), 1,
      anon_sym_AMP,
    ACTIONS(6452), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6454), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6456), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4419), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6428), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6432), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6442), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6444), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6446), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6434), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [173265] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6374), 1,
      anon_sym_CARET,
    ACTIONS(6376), 1,
      anon_sym_PIPE,
    ACTIONS(6378), 1,
      anon_sym_AMP,
    ACTIONS(6390), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6392), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6394), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4420), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6366), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6370), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6380), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6382), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6384), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6372), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [173380] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7459), 1,
      anon_sym_into,
    STATE(2141), 1,
      sym_query_continuation,
    STATE(4421), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [173445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5299), 1,
      anon_sym_LBRACK,
    STATE(4422), 1,
      sym__preprocessor_call,
    ACTIONS(5297), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [173506] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4423), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6289), 1,
      sym_tuple_element,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [173599] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5833), 1,
      anon_sym_CARET,
    ACTIONS(5835), 1,
      anon_sym_PIPE,
    ACTIONS(5837), 1,
      anon_sym_AMP,
    ACTIONS(5853), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5855), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5857), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4424), 1,
      sym__preprocessor_call,
    ACTIONS(5821), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5829), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5839), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5841), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5843), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5831), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [173714] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4425), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6248), 1,
      sym_tuple_element,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [173807] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6338), 1,
      anon_sym_CARET,
    ACTIONS(6340), 1,
      anon_sym_PIPE,
    ACTIONS(6342), 1,
      anon_sym_AMP,
    ACTIONS(6350), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6352), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6354), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2745), 1,
      sym_argument_list,
    STATE(4426), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6310), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6314), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6334), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6344), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6346), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6312), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [173922] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6254), 1,
      anon_sym_CARET,
    ACTIONS(6256), 1,
      anon_sym_PIPE,
    ACTIONS(6258), 1,
      anon_sym_AMP,
    ACTIONS(6260), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6262), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6264), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2745), 1,
      sym_argument_list,
    STATE(4427), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6208), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6210), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6214), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6216), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6218), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6212), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [174037] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7461), 1,
      anon_sym_into,
    STATE(2317), 1,
      sym_query_continuation,
    STATE(4428), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [174102] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7403), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4429), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4878), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [174195] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(3196), 1,
      anon_sym_DOT,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5588), 1,
      anon_sym_BANG,
    ACTIONS(5596), 1,
      anon_sym_CARET,
    ACTIONS(5598), 1,
      anon_sym_PIPE,
    ACTIONS(5600), 1,
      anon_sym_AMP,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5723), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5725), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5727), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2335), 1,
      sym_argument_list,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(4430), 1,
      sym__preprocessor_call,
    ACTIONS(5586), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5590), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5592), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5602), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5604), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5606), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5594), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [174310] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4431), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6632), 1,
      sym_tuple_element,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [174403] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7179), 1,
      anon_sym_COLON_COLON,
    STATE(4432), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [174466] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7455), 1,
      anon_sym_and,
    ACTIONS(7463), 1,
      anon_sym_or,
    STATE(4433), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [174531] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6192), 1,
      anon_sym_CARET,
    ACTIONS(6194), 1,
      anon_sym_PIPE,
    ACTIONS(6196), 1,
      anon_sym_AMP,
    ACTIONS(6320), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6322), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6324), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2745), 1,
      sym_argument_list,
    STATE(4434), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6186), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6188), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6198), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6200), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6202), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6190), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [174646] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4435), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6832), 1,
      sym_tuple_element,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [174739] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7465), 1,
      anon_sym_into,
    STATE(2141), 1,
      sym_query_continuation,
    STATE(4436), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [174804] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7467), 1,
      anon_sym_into,
    STATE(2262), 1,
      sym_query_continuation,
    STATE(4437), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [174869] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(6402), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4438), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4875), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [174962] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5630), 1,
      anon_sym_CARET,
    ACTIONS(5632), 1,
      anon_sym_PIPE,
    ACTIONS(5634), 1,
      anon_sym_AMP,
    ACTIONS(5650), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5652), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5654), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2745), 1,
      sym_argument_list,
    STATE(4439), 1,
      sym__preprocessor_call,
    ACTIONS(5618), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5626), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5636), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5638), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5640), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5628), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [175077] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7449), 1,
      anon_sym_and,
    ACTIONS(7457), 1,
      anon_sym_or,
    STATE(4440), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [175142] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5943), 1,
      anon_sym_CARET,
    ACTIONS(5945), 1,
      anon_sym_PIPE,
    ACTIONS(5947), 1,
      anon_sym_AMP,
    ACTIONS(5959), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5961), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5963), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4441), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5935), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5939), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5949), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5951), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5953), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5941), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [175257] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7465), 1,
      anon_sym_into,
    STATE(2173), 1,
      sym_query_continuation,
    STATE(4442), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [175322] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7459), 1,
      anon_sym_into,
    STATE(2173), 1,
      sym_query_continuation,
    STATE(4443), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [175387] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4444), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6352), 1,
      sym_tuple_element,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [175480] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7469), 1,
      anon_sym_LBRACK,
    STATE(2060), 1,
      sym_array_type,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4445), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6353), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [175575] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4446), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6810), 1,
      sym_tuple_element,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [175668] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7471), 1,
      anon_sym_into,
    STATE(2173), 1,
      sym_query_continuation,
    STATE(4447), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [175733] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7467), 1,
      anon_sym_into,
    STATE(2317), 1,
      sym_query_continuation,
    STATE(4448), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [175798] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5343), 1,
      anon_sym_LBRACK,
    STATE(4449), 1,
      sym__preprocessor_call,
    ACTIONS(5341), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [175859] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7473), 1,
      anon_sym_and,
    STATE(4450), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [175922] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7475), 1,
      anon_sym_and,
    STATE(4451), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [175985] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4452), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6575), 1,
      sym_tuple_element,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [176078] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7471), 1,
      anon_sym_into,
    STATE(2141), 1,
      sym_query_continuation,
    STATE(4453), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [176143] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7359), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4454), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4932), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [176236] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5276), 1,
      anon_sym_LBRACK,
    STATE(4455), 1,
      sym__preprocessor_call,
    ACTIONS(5274), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [176297] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4456), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6330), 1,
      sym_tuple_element,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [176390] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7473), 1,
      anon_sym_and,
    ACTIONS(7477), 1,
      anon_sym_or,
    STATE(4457), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [176455] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(6588), 1,
      anon_sym_EQ,
    STATE(4458), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [176520] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7479), 1,
      anon_sym_LBRACK,
    STATE(2067), 1,
      sym_array_type,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4459), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6470), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [176615] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7475), 1,
      anon_sym_and,
    ACTIONS(7481), 1,
      anon_sym_or,
    STATE(4460), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [176680] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7483), 1,
      anon_sym_LBRACK,
    STATE(2668), 1,
      sym_array_type,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4461), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6282), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [176775] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6614), 1,
      anon_sym_CARET,
    ACTIONS(6616), 1,
      anon_sym_PIPE,
    ACTIONS(6618), 1,
      anon_sym_AMP,
    ACTIONS(6626), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6628), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6630), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4462), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6568), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6572), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6610), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6620), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6622), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6570), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [176890] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5288), 1,
      anon_sym_LT,
    STATE(2838), 1,
      sym_type_argument_list,
    STATE(4463), 1,
      sym__preprocessor_call,
    ACTIONS(2827), 16,
      anon_sym_EQ,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2829), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [176955] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7485), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4464), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6015), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [177048] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7461), 1,
      anon_sym_into,
    STATE(2262), 1,
      sym_query_continuation,
    STATE(4465), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [177113] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7487), 1,
      anon_sym_LBRACK,
    STATE(2639), 1,
      sym_array_type,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4466), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6283), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [177208] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7343), 1,
      sym_void_keyword,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4467), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5955), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [177301] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4468), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4711), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6931), 1,
      sym_variable_declaration,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [177394] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7489), 1,
      anon_sym_LBRACK,
    STATE(2776), 1,
      sym_array_type,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4469), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6438), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [177489] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6030), 1,
      anon_sym_CARET,
    ACTIONS(6032), 1,
      anon_sym_PIPE,
    ACTIONS(6034), 1,
      anon_sym_AMP,
    ACTIONS(6046), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6090), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6092), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2745), 1,
      sym_argument_list,
    STATE(4470), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6024), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6026), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6036), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6038), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6040), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6028), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [177604] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4471), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6415), 1,
      sym_tuple_element,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [177697] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4472), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4606), 1,
      sym__type,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6874), 1,
      sym_variable_declaration,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [177790] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4473), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6764), 1,
      sym_tuple_element,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [177883] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7451), 1,
      anon_sym_and,
    STATE(4474), 1,
      sym__preprocessor_call,
    ACTIONS(5398), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5396), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_or,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [177946] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4475), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4607), 1,
      sym__type,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6660), 1,
      sym_variable_declaration,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [178039] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7473), 1,
      anon_sym_and,
    ACTIONS(7477), 1,
      anon_sym_or,
    STATE(4476), 1,
      sym__preprocessor_call,
    ACTIONS(5380), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5378), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_equals,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [178104] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6482), 1,
      anon_sym_CARET,
    ACTIONS(6484), 1,
      anon_sym_PIPE,
    ACTIONS(6486), 1,
      anon_sym_AMP,
    ACTIONS(6498), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6500), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6502), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4477), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6474), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6478), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6488), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6490), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6492), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6480), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [178219] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(3154), 1,
      anon_sym_DOT,
    ACTIONS(5206), 1,
      anon_sym_LPAREN,
    ACTIONS(5217), 1,
      anon_sym_BANG,
    ACTIONS(5225), 1,
      anon_sym_CARET,
    ACTIONS(5227), 1,
      anon_sym_PIPE,
    ACTIONS(5229), 1,
      anon_sym_AMP,
    ACTIONS(5245), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5247), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5249), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(3074), 1,
      sym_argument_list,
    STATE(4478), 1,
      sym__preprocessor_call,
    ACTIONS(5213), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5219), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5221), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5231), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5233), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5235), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5223), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [178334] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7491), 1,
      anon_sym_into,
    STATE(2317), 1,
      sym_query_continuation,
    STATE(4479), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [178399] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7493), 1,
      anon_sym_into,
    STATE(2262), 1,
      sym_query_continuation,
    STATE(4480), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [178464] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7455), 1,
      anon_sym_and,
    ACTIONS(7463), 1,
      anon_sym_or,
    STATE(4481), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [178529] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7491), 1,
      anon_sym_into,
    STATE(2262), 1,
      sym_query_continuation,
    STATE(4482), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [178594] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4483), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6869), 1,
      sym_tuple_element,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [178687] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(3018), 1,
      anon_sym_DOT,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(5202), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5825), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6516), 1,
      anon_sym_CARET,
    ACTIONS(6518), 1,
      anon_sym_PIPE,
    ACTIONS(6520), 1,
      anon_sym_AMP,
    ACTIONS(6532), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6534), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6536), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2916), 1,
      sym_argument_list,
    STATE(4484), 1,
      sym__preprocessor_call,
    ACTIONS(5827), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6508), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6512), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6522), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6524), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6526), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6514), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [178802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7475), 1,
      anon_sym_and,
    ACTIONS(7481), 1,
      anon_sym_or,
    STATE(4485), 1,
      sym__preprocessor_call,
    ACTIONS(5568), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5570), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [178867] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    ACTIONS(6102), 1,
      anon_sym_CARET,
    ACTIONS(6104), 1,
      anon_sym_PIPE,
    ACTIONS(6106), 1,
      anon_sym_AMP,
    ACTIONS(6116), 1,
      anon_sym_AMP_AMP,
    ACTIONS(6118), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(6120), 1,
      anon_sym_QMARK_QMARK,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2745), 1,
      sym_argument_list,
    STATE(4486), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(6094), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(6098), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(6108), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(6110), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(6112), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(6100), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [178982] = 32,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2907), 1,
      anon_sym_DOT,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(4526), 1,
      anon_sym_LPAREN,
    ACTIONS(5253), 1,
      anon_sym_EQ,
    ACTIONS(5608), 1,
      anon_sym_switch,
    ACTIONS(5614), 1,
      anon_sym_with,
    ACTIONS(5616), 1,
      anon_sym_as,
    ACTIONS(5622), 1,
      anon_sym_BANG,
    ACTIONS(5895), 1,
      anon_sym_CARET,
    ACTIONS(5897), 1,
      anon_sym_PIPE,
    ACTIONS(5899), 1,
      anon_sym_AMP,
    ACTIONS(5911), 1,
      anon_sym_AMP_AMP,
    ACTIONS(5913), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(5915), 1,
      anon_sym_QMARK_QMARK,
    ACTIONS(5990), 1,
      anon_sym_QMARK,
    ACTIONS(6008), 1,
      anon_sym_is,
    ACTIONS(6010), 1,
      anon_sym_DOT_DOT,
    STATE(1222), 1,
      sym_assignment_operator,
    STATE(2336), 1,
      sym_bracketed_argument_list,
    STATE(2745), 1,
      sym_argument_list,
    STATE(4487), 1,
      sym__preprocessor_call,
    ACTIONS(5624), 2,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
    ACTIONS(5887), 2,
      anon_sym_LT,
      anon_sym_GT,
    ACTIONS(5891), 2,
      anon_sym_PLUS,
      anon_sym_DASH,
    ACTIONS(5901), 2,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
    ACTIONS(5903), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(5905), 2,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
    ACTIONS(5893), 3,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
    ACTIONS(5261), 11,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
  [179097] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4488), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4739), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(6853), 1,
      sym_tuple_element,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [179190] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7495), 1,
      anon_sym_into,
    STATE(2141), 1,
      sym_query_continuation,
    STATE(4489), 1,
      sym__preprocessor_call,
    ACTIONS(3516), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3514), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [179255] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7493), 1,
      anon_sym_into,
    STATE(2317), 1,
      sym_query_continuation,
    STATE(4490), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_by,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [179320] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7495), 1,
      anon_sym_into,
    STATE(2173), 1,
      sym_query_continuation,
    STATE(4491), 1,
      sym__preprocessor_call,
    ACTIONS(5446), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(5448), 28,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_on,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [179385] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5293), 1,
      anon_sym_LBRACK,
    STATE(4492), 1,
      sym__preprocessor_call,
    ACTIONS(5291), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [179446] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    ACTIONS(6696), 1,
      anon_sym_delegate,
    ACTIONS(6698), 1,
      anon_sym_var,
    ACTIONS(6700), 1,
      sym_predefined_type,
    ACTIONS(7497), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(1852), 1,
      sym_global,
    STATE(2648), 1,
      sym_identifier,
    STATE(2871), 1,
      sym__type,
    STATE(2971), 1,
      sym__name,
    STATE(4493), 1,
      sym__preprocessor_call,
    STATE(6760), 1,
      sym__nullable_base_type,
    STATE(1795), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(1794), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(1796), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [179536] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7499), 1,
      ts_builtin_sym_end,
    ACTIONS(7501), 1,
      anon_sym_extern,
    ACTIONS(7503), 1,
      anon_sym_global,
    ACTIONS(7505), 1,
      anon_sym_using,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    STATE(1635), 1,
      sym_using_directive,
    STATE(1637), 1,
      sym_extern_alias_directive,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4494), 1,
      sym__preprocessor_call,
    STATE(4496), 1,
      aux_sym_compilation_unit_repeat1,
    STATE(4552), 1,
      aux_sym_compilation_unit_repeat2,
    STATE(4612), 1,
      aux_sym_file_scoped_namespace_declaration_repeat1,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5426), 1,
      sym__type_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 17,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [179640] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4495), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6203), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [179730] = 27,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7501), 1,
      anon_sym_extern,
    ACTIONS(7503), 1,
      anon_sym_global,
    ACTIONS(7505), 1,
      anon_sym_using,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7523), 1,
      ts_builtin_sym_end,
    STATE(1555), 1,
      aux_sym_compilation_unit_repeat1,
    STATE(1635), 1,
      sym_using_directive,
    STATE(1637), 1,
      sym_extern_alias_directive,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4496), 1,
      sym__preprocessor_call,
    STATE(4553), 1,
      aux_sym_compilation_unit_repeat2,
    STATE(4609), 1,
      aux_sym_file_scoped_namespace_declaration_repeat1,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5426), 1,
      sym__type_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 17,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [179834] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4497), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6182), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [179924] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4498), 1,
      sym__preprocessor_call,
    ACTIONS(2913), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2911), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [179984] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4499), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6202), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [180074] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4500), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6201), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [180164] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4501), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6215), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [180254] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(4036), 1,
      anon_sym_LPAREN,
    ACTIONS(7525), 1,
      anon_sym_COLON,
    STATE(4502), 1,
      sym__preprocessor_call,
    ACTIONS(3342), 17,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_QMARK,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(3340), 27,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [180318] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(3170), 1,
      anon_sym_delegate,
    ACTIONS(3172), 1,
      anon_sym_var,
    ACTIONS(3174), 1,
      sym_predefined_type,
    ACTIONS(7527), 1,
      anon_sym_LPAREN,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2096), 1,
      sym_generic_name,
    STATE(2161), 1,
      sym__type,
    STATE(3620), 1,
      sym_identifier,
    STATE(3798), 1,
      sym_global,
    STATE(3989), 1,
      sym__name,
    STATE(4503), 1,
      sym__preprocessor_call,
    STATE(6945), 1,
      sym__nullable_base_type,
    STATE(2114), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2111), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2115), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [180408] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4504), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6098), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [180498] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4505), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6100), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [180588] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4506), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4712), 1,
      sym_identifier,
    STATE(4925), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [180678] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4507), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6101), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [180768] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4508), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6211), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [180858] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4509), 1,
      sym__preprocessor_call,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6017), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [180948] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(721), 1,
      sym__identifier_token,
    ACTIONS(1133), 1,
      anon_sym_global,
    ACTIONS(6756), 1,
      anon_sym_delegate,
    ACTIONS(6758), 1,
      anon_sym_var,
    ACTIONS(6760), 1,
      sym_predefined_type,
    ACTIONS(7529), 1,
      anon_sym_LPAREN,
    STATE(2630), 1,
      sym_identifier,
    STATE(2633), 1,
      sym__contextual_keywords,
    STATE(2636), 1,
      sym_global,
    STATE(2685), 1,
      sym__type,
    STATE(2696), 1,
      sym__name,
    STATE(2702), 1,
      sym_generic_name,
    STATE(4510), 1,
      sym__preprocessor_call,
    STATE(6883), 1,
      sym__nullable_base_type,
    STATE(2703), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2705), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2700), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(723), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181038] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(6846), 1,
      anon_sym_delegate,
    ACTIONS(6848), 1,
      anon_sym_var,
    ACTIONS(6850), 1,
      sym_predefined_type,
    ACTIONS(7531), 1,
      anon_sym_LPAREN,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2071), 1,
      sym__type,
    STATE(2096), 1,
      sym_generic_name,
    STATE(3120), 1,
      sym_identifier,
    STATE(3126), 1,
      sym_global,
    STATE(3202), 1,
      sym__name,
    STATE(4511), 1,
      sym__preprocessor_call,
    STATE(6712), 1,
      sym__nullable_base_type,
    STATE(2087), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2070), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2088), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181128] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4512), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2827), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181188] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4513), 1,
      sym__preprocessor_call,
    ACTIONS(2890), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2888), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4514), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181306] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(1133), 1,
      anon_sym_global,
    ACTIONS(3170), 1,
      anon_sym_delegate,
    ACTIONS(3172), 1,
      anon_sym_var,
    ACTIONS(3174), 1,
      sym_predefined_type,
    ACTIONS(7527), 1,
      anon_sym_LPAREN,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2096), 1,
      sym_generic_name,
    STATE(2161), 1,
      sym__type,
    STATE(4136), 1,
      sym_identifier,
    STATE(4418), 1,
      sym_global,
    STATE(4515), 1,
      sym__preprocessor_call,
    STATE(4548), 1,
      sym__name,
    STATE(6945), 1,
      sym__nullable_base_type,
    STATE(2114), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2111), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2115), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181396] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4516), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6165), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181486] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(799), 1,
      sym__identifier_token,
    ACTIONS(803), 1,
      anon_sym_global,
    ACTIONS(6708), 1,
      anon_sym_delegate,
    ACTIONS(6710), 1,
      anon_sym_var,
    ACTIONS(6712), 1,
      sym_predefined_type,
    ACTIONS(7533), 1,
      anon_sym_LPAREN,
    STATE(2645), 1,
      sym__contextual_keywords,
    STATE(2818), 1,
      sym__type,
    STATE(2856), 1,
      sym_generic_name,
    STATE(3746), 1,
      sym_identifier,
    STATE(4067), 1,
      sym_global,
    STATE(4130), 1,
      sym__name,
    STATE(4517), 1,
      sym__preprocessor_call,
    STATE(6864), 1,
      sym__nullable_base_type,
    STATE(2765), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2768), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2764), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(801), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181576] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4518), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6056), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181666] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4519), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6185), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181756] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4520), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6158), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4521), 1,
      sym__preprocessor_call,
    ACTIONS(5486), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181904] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4522), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6155), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [181994] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(6846), 1,
      anon_sym_delegate,
    ACTIONS(6848), 1,
      anon_sym_var,
    ACTIONS(6850), 1,
      sym_predefined_type,
    ACTIONS(7531), 1,
      anon_sym_LPAREN,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2071), 1,
      sym__type,
    STATE(2096), 1,
      sym_generic_name,
    STATE(3387), 1,
      sym_identifier,
    STATE(3415), 1,
      sym_global,
    STATE(3524), 1,
      sym__name,
    STATE(4523), 1,
      sym__preprocessor_call,
    STATE(6712), 1,
      sym__nullable_base_type,
    STATE(2087), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2070), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2088), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182084] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(1133), 1,
      anon_sym_global,
    ACTIONS(6846), 1,
      anon_sym_delegate,
    ACTIONS(6848), 1,
      anon_sym_var,
    ACTIONS(6850), 1,
      sym_predefined_type,
    ACTIONS(7531), 1,
      anon_sym_LPAREN,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2071), 1,
      sym__type,
    STATE(2096), 1,
      sym_generic_name,
    STATE(3387), 1,
      sym_identifier,
    STATE(3415), 1,
      sym_global,
    STATE(3524), 1,
      sym__name,
    STATE(4524), 1,
      sym__preprocessor_call,
    STATE(6712), 1,
      sym__nullable_base_type,
    STATE(2087), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2070), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2088), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4525), 1,
      sym__preprocessor_call,
    ACTIONS(1949), 46,
      anon_sym_extern,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_init,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182232] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4526), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6207), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182322] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4527), 1,
      sym__preprocessor_call,
    STATE(4583), 1,
      sym_implicit_type,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4901), 1,
      sym_array_type,
    STATE(5023), 1,
      sym_nullable_type,
    STATE(6297), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182416] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4528), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5780), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182506] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    ACTIONS(7535), 1,
      anon_sym_DOT,
    STATE(4529), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_in,
      anon_sym_LBRACE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [182570] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4530), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6181), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182660] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4531), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6097), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182750] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(6846), 1,
      anon_sym_delegate,
    ACTIONS(6848), 1,
      anon_sym_var,
    ACTIONS(6850), 1,
      sym_predefined_type,
    ACTIONS(7531), 1,
      anon_sym_LPAREN,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2071), 1,
      sym__type,
    STATE(2096), 1,
      sym_generic_name,
    STATE(3078), 1,
      sym_identifier,
    STATE(3187), 1,
      sym_global,
    STATE(3217), 1,
      sym__name,
    STATE(4532), 1,
      sym__preprocessor_call,
    STATE(6712), 1,
      sym__nullable_base_type,
    STATE(2087), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2070), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2088), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182840] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4533), 1,
      sym__preprocessor_call,
    ACTIONS(2951), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2949), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182900] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4534), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6145), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [182990] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4535), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4819), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183080] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4536), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6164), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4537), 1,
      sym__preprocessor_call,
    ACTIONS(2868), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2866), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183230] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2767), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4538), 1,
      sym__preprocessor_call,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4637), 1,
      sym_identifier,
    STATE(4840), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183320] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(803), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(3170), 1,
      anon_sym_delegate,
    ACTIONS(3172), 1,
      anon_sym_var,
    ACTIONS(3174), 1,
      sym_predefined_type,
    ACTIONS(7527), 1,
      anon_sym_LPAREN,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2161), 1,
      sym__type,
    STATE(2856), 1,
      sym_generic_name,
    STATE(4205), 1,
      sym_identifier,
    STATE(4432), 1,
      sym_global,
    STATE(4529), 1,
      sym__name,
    STATE(4539), 1,
      sym__preprocessor_call,
    STATE(6945), 1,
      sym__nullable_base_type,
    STATE(2114), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2111), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2115), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183410] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4540), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6144), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183500] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4541), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(6178), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183590] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4542), 1,
      sym__preprocessor_call,
    ACTIONS(2959), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2957), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183650] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2767), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4543), 1,
      sym__preprocessor_call,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4638), 1,
      sym_identifier,
    STATE(4851), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183740] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4544), 1,
      sym__preprocessor_call,
    ACTIONS(2886), 15,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2884), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183800] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4545), 1,
      sym__preprocessor_call,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4715), 1,
      sym_identifier,
    STATE(4928), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183890] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(3170), 1,
      anon_sym_delegate,
    ACTIONS(3172), 1,
      anon_sym_var,
    ACTIONS(3174), 1,
      sym_predefined_type,
    ACTIONS(7527), 1,
      anon_sym_LPAREN,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2096), 1,
      sym_generic_name,
    STATE(2161), 1,
      sym__type,
    STATE(2270), 1,
      sym_identifier,
    STATE(2525), 1,
      sym_global,
    STATE(2629), 1,
      sym__name,
    STATE(4546), 1,
      sym__preprocessor_call,
    STATE(6945), 1,
      sym__nullable_base_type,
    STATE(2114), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2111), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2115), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [183980] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4547), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5715), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [184070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2896), 1,
      anon_sym_QMARK,
    ACTIONS(7537), 1,
      anon_sym_DOT,
    STATE(4548), 1,
      sym__preprocessor_call,
    ACTIONS(2892), 15,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_STAR,
      anon_sym_SLASH,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_QMARK_QMARK,
    ACTIONS(2894), 29,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
      anon_sym_switch,
      anon_sym_PLUS_EQ,
      anon_sym_DASH_EQ,
      anon_sym_STAR_EQ,
      anon_sym_SLASH_EQ,
      anon_sym_PERCENT_EQ,
      anon_sym_AMP_EQ,
      anon_sym_CARET_EQ,
      anon_sym_PIPE_EQ,
      anon_sym_LT_LT_EQ,
      anon_sym_GT_GT_EQ,
      anon_sym_QMARK_QMARK_EQ,
      anon_sym_is,
      anon_sym_DASH_GT,
      anon_sym_DOT_DOT,
      anon_sym_with,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
      anon_sym_as,
  [184134] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4549), 1,
      sym__preprocessor_call,
    STATE(4583), 1,
      sym_implicit_type,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(4870), 1,
      sym_array_type,
    STATE(4968), 1,
      sym_nullable_type,
    STATE(6297), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 3,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [184228] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(67), 1,
      anon_sym_var,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2677), 1,
      anon_sym_LPAREN,
    ACTIONS(2701), 1,
      sym_predefined_type,
    ACTIONS(2739), 1,
      anon_sym_delegate,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4512), 1,
      sym_generic_name,
    STATE(4550), 1,
      sym__preprocessor_call,
    STATE(4613), 1,
      sym_identifier,
    STATE(4614), 1,
      sym_global,
    STATE(4620), 1,
      sym__name,
    STATE(5946), 1,
      sym__type,
    STATE(6727), 1,
      sym__nullable_base_type,
    STATE(4583), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(4565), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [184318] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(799), 1,
      sym__identifier_token,
    ACTIONS(1133), 1,
      anon_sym_global,
    ACTIONS(6708), 1,
      anon_sym_delegate,
    ACTIONS(6710), 1,
      anon_sym_var,
    ACTIONS(6712), 1,
      sym_predefined_type,
    ACTIONS(7533), 1,
      anon_sym_LPAREN,
    STATE(2645), 1,
      sym__contextual_keywords,
    STATE(2667), 1,
      sym_identifier,
    STATE(2762), 1,
      sym_global,
    STATE(2818), 1,
      sym__type,
    STATE(2856), 1,
      sym_generic_name,
    STATE(2863), 1,
      sym__name,
    STATE(4551), 1,
      sym__preprocessor_call,
    STATE(6864), 1,
      sym__nullable_base_type,
    STATE(2765), 2,
      sym_implicit_type,
      sym_nullable_type,
    STATE(2768), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    STATE(2764), 4,
      sym_array_type,
      sym_pointer_type,
      sym_function_pointer_type,
      sym_tuple_type,
    ACTIONS(801), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [184408] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7503), 1,
      anon_sym_global,
    ACTIONS(7505), 1,
      anon_sym_using,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7523), 1,
      ts_builtin_sym_end,
    STATE(1556), 1,
      aux_sym_compilation_unit_repeat2,
    STATE(1635), 1,
      sym_using_directive,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4552), 1,
      sym__preprocessor_call,
    STATE(4609), 1,
      aux_sym_file_scoped_namespace_declaration_repeat1,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5426), 1,
      sym__type_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [184504] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7503), 1,
      anon_sym_global,
    ACTIONS(7505), 1,
      anon_sym_using,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7539), 1,
      ts_builtin_sym_end,
    STATE(1556), 1,
      aux_sym_compilation_unit_repeat2,
    STATE(1635), 1,
      sym_using_directive,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4553), 1,
      sym__preprocessor_call,
    STATE(4615), 1,
      aux_sym_file_scoped_namespace_declaration_repeat1,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5426), 1,
      sym__type_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [184600] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4554), 1,
      sym__preprocessor_call,
    ACTIONS(2947), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2945), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [184657] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(147), 1,
      ts_builtin_sym_end,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7541), 1,
      anon_sym_namespace,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4555), 1,
      sym__preprocessor_call,
    STATE(4563), 1,
      aux_sym_compilation_unit_repeat5,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5345), 1,
      sym__namespace_member_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5349), 2,
      sym__type_declaration,
      sym_namespace_declaration,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [184748] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4556), 1,
      sym__preprocessor_call,
    ACTIONS(2917), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2915), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [184805] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4557), 1,
      sym__preprocessor_call,
    STATE(4684), 1,
      sym_attribute_target_specifier,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6285), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1937), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [184882] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4558), 1,
      sym__preprocessor_call,
    ACTIONS(2939), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2937), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [184939] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(141), 1,
      ts_builtin_sym_end,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7541), 1,
      anon_sym_namespace,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4559), 1,
      sym__preprocessor_call,
    STATE(4563), 1,
      aux_sym_compilation_unit_repeat5,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5345), 1,
      sym__namespace_member_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5349), 2,
      sym__type_declaration,
      sym_namespace_declaration,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [185030] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7543), 1,
      anon_sym_global,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7549), 1,
      anon_sym_this,
    ACTIONS(7551), 1,
      anon_sym_operator,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4560), 1,
      sym__preprocessor_call,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5075), 1,
      sym_explicit_interface_specifier,
    STATE(5504), 1,
      sym_identifier,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(6126), 1,
      sym_variable_declarator,
    STATE(6654), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185119] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4561), 1,
      sym__preprocessor_call,
    ACTIONS(2935), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2933), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185176] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4562), 1,
      sym__preprocessor_call,
    ACTIONS(2901), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2899), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185233] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7555), 1,
      ts_builtin_sym_end,
    ACTIONS(7560), 1,
      anon_sym_LBRACK,
    ACTIONS(7563), 1,
      anon_sym_ref,
    ACTIONS(7566), 1,
      anon_sym_class,
    ACTIONS(7569), 1,
      anon_sym_struct,
    ACTIONS(7572), 1,
      anon_sym_enum,
    ACTIONS(7575), 1,
      anon_sym_interface,
    ACTIONS(7578), 1,
      anon_sym_delegate,
    ACTIONS(7581), 1,
      anon_sym_record,
    ACTIONS(7584), 1,
      anon_sym_namespace,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5345), 1,
      sym__namespace_member_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(4563), 2,
      sym__preprocessor_call,
      aux_sym_compilation_unit_repeat5,
    STATE(5349), 2,
      sym__type_declaration,
      sym_namespace_declaration,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7557), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [185322] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7543), 1,
      anon_sym_global,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7587), 1,
      anon_sym_this,
    ACTIONS(7589), 1,
      anon_sym_operator,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4564), 1,
      sym__preprocessor_call,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5121), 1,
      sym_explicit_interface_specifier,
    STATE(5517), 1,
      sym_identifier,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(6126), 1,
      sym_variable_declarator,
    STATE(6654), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185411] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    STATE(4565), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_STAR,
    ACTIONS(2892), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4566), 1,
      sym__preprocessor_call,
    ACTIONS(2862), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2860), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185527] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(133), 1,
      ts_builtin_sym_end,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7541), 1,
      anon_sym_namespace,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4563), 1,
      aux_sym_compilation_unit_repeat5,
    STATE(4567), 1,
      sym__preprocessor_call,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5345), 1,
      sym__namespace_member_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5349), 2,
      sym__type_declaration,
      sym_namespace_declaration,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [185618] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4568), 1,
      sym__preprocessor_call,
    STATE(4687), 1,
      sym_attribute_target_specifier,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6404), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1937), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185695] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4569), 1,
      sym__preprocessor_call,
    STATE(4692), 1,
      sym_attribute_target_specifier,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6441), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1937), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4570), 1,
      sym__preprocessor_call,
    ACTIONS(2878), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2876), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185829] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7543), 1,
      anon_sym_global,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7593), 1,
      anon_sym_this,
    ACTIONS(7595), 1,
      anon_sym_operator,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4571), 1,
      sym__preprocessor_call,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5093), 1,
      sym_explicit_interface_specifier,
    STATE(5518), 1,
      sym_identifier,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(6126), 1,
      sym_variable_declarator,
    STATE(6654), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185918] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4572), 1,
      sym__preprocessor_call,
    STATE(4690), 1,
      sym_attribute_target_specifier,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6360), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1937), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [185995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4573), 1,
      sym__preprocessor_call,
    ACTIONS(2905), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2903), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186052] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(4574), 1,
      sym__preprocessor_call,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2794), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186135] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(135), 1,
      ts_builtin_sym_end,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7541), 1,
      anon_sym_namespace,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4563), 1,
      aux_sym_compilation_unit_repeat5,
    STATE(4575), 1,
      sym__preprocessor_call,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5345), 1,
      sym__namespace_member_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5349), 2,
      sym__type_declaration,
      sym_namespace_declaration,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [186226] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4576), 1,
      sym__preprocessor_call,
    ACTIONS(2955), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2953), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4577), 1,
      sym__preprocessor_call,
    ACTIONS(2943), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2941), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186340] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4578), 1,
      sym__preprocessor_call,
    STATE(4688), 1,
      sym_attribute_target_specifier,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6251), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(1937), 7,
      anon_sym_field,
      anon_sym_event,
      anon_sym_method,
      anon_sym_param,
      anon_sym_property,
      anon_sym_return,
      anon_sym_type,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186417] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7541), 1,
      anon_sym_namespace,
    ACTIONS(7599), 1,
      ts_builtin_sym_end,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4563), 1,
      aux_sym_compilation_unit_repeat5,
    STATE(4579), 1,
      sym__preprocessor_call,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5345), 1,
      sym__namespace_member_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5349), 2,
      sym__type_declaration,
      sym_namespace_declaration,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [186508] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7604), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4580), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186594] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7606), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4581), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186680] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7608), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4582), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186766] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4583), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_STAR,
    ACTIONS(2892), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186822] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7610), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4584), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186908] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7612), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4585), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [186994] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7614), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4586), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187080] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7616), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4587), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187166] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7618), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4588), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187252] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7620), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4589), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187338] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7622), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4590), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187424] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7624), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4591), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187510] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7626), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4592), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187596] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7628), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4593), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187682] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4594), 1,
      sym__preprocessor_call,
    ACTIONS(2963), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_STAR,
    ACTIONS(2961), 31,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187738] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7630), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4595), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187824] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7632), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4596), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187910] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7634), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4597), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [187996] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7636), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4598), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188082] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7638), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4599), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188168] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7640), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4600), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188254] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7642), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4601), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188340] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    ACTIONS(7601), 1,
      anon_sym_COMMA,
    ACTIONS(7644), 1,
      anon_sym_RPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(2947), 1,
      sym_parenthesized_variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4602), 1,
      sym__preprocessor_call,
    STATE(4632), 1,
      sym_positional_pattern_clause,
    STATE(4644), 1,
      sym_property_pattern_clause,
    STATE(5905), 1,
      sym_identifier,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188426] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2945), 1,
      sym__variable_designation,
    STATE(4603), 1,
      sym__preprocessor_call,
    ACTIONS(2817), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2815), 8,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_STAR,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188496] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2799), 1,
      anon_sym_when,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7597), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2885), 1,
      sym__variable_designation,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4604), 1,
      sym__preprocessor_call,
    STATE(4641), 1,
      sym_positional_pattern_clause,
    STATE(4682), 1,
      sym_property_pattern_clause,
    ACTIONS(2790), 2,
      anon_sym_and,
      anon_sym_or,
    ACTIONS(2794), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188580] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7543), 1,
      anon_sym_global,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4605), 1,
      sym__preprocessor_call,
    STATE(5212), 1,
      sym_explicit_interface_specifier,
    STATE(5553), 1,
      sym_identifier,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(6126), 1,
      sym_variable_declarator,
    STATE(6654), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188663] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7543), 1,
      anon_sym_global,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4606), 1,
      sym__preprocessor_call,
    STATE(5266), 1,
      sym_explicit_interface_specifier,
    STATE(5554), 1,
      sym_identifier,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(6126), 1,
      sym_variable_declarator,
    STATE(6654), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188746] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7543), 1,
      anon_sym_global,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4607), 1,
      sym__preprocessor_call,
    STATE(5318), 1,
      sym_explicit_interface_specifier,
    STATE(5555), 1,
      sym_identifier,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(6126), 1,
      sym_variable_declarator,
    STATE(6654), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188829] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    STATE(4608), 1,
      sym__preprocessor_call,
    ACTIONS(3020), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2894), 9,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_EQ_GT,
      anon_sym_STAR,
    ACTIONS(2892), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [188888] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7539), 1,
      ts_builtin_sym_end,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4609), 1,
      sym__preprocessor_call,
    STATE(4611), 1,
      aux_sym_file_scoped_namespace_declaration_repeat1,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5426), 1,
      sym__type_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [188972] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4610), 1,
      sym__preprocessor_call,
    ACTIONS(2858), 12,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2850), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189026] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7646), 1,
      ts_builtin_sym_end,
    ACTIONS(7651), 1,
      anon_sym_LBRACK,
    ACTIONS(7654), 1,
      anon_sym_ref,
    ACTIONS(7657), 1,
      anon_sym_class,
    ACTIONS(7660), 1,
      anon_sym_struct,
    ACTIONS(7663), 1,
      anon_sym_enum,
    ACTIONS(7666), 1,
      anon_sym_interface,
    ACTIONS(7669), 1,
      anon_sym_delegate,
    ACTIONS(7672), 1,
      anon_sym_record,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5426), 1,
      sym__type_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(4611), 2,
      sym__preprocessor_call,
      aux_sym_file_scoped_namespace_declaration_repeat1,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7648), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [189108] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7523), 1,
      ts_builtin_sym_end,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4611), 1,
      aux_sym_file_scoped_namespace_declaration_repeat1,
    STATE(4612), 1,
      sym__preprocessor_call,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5426), 1,
      sym__type_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [189192] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4613), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    STATE(4614), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 11,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189308] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7511), 1,
      anon_sym_class,
    ACTIONS(7513), 1,
      anon_sym_struct,
    ACTIONS(7515), 1,
      anon_sym_enum,
    ACTIONS(7517), 1,
      anon_sym_interface,
    ACTIONS(7519), 1,
      anon_sym_delegate,
    ACTIONS(7521), 1,
      anon_sym_record,
    ACTIONS(7675), 1,
      ts_builtin_sym_end,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4611), 1,
      aux_sym_file_scoped_namespace_declaration_repeat1,
    STATE(4615), 1,
      sym__preprocessor_call,
    STATE(4958), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5426), 1,
      sym__type_declaration,
    STATE(5427), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(5402), 7,
      sym_enum_declaration,
      sym_class_declaration,
      sym_interface_declaration,
      sym_struct_declaration,
      sym_delegate_declaration,
      sym_record_declaration,
      sym_record_struct_declaration,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [189392] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7677), 1,
      anon_sym_LPAREN,
    ACTIONS(7679), 1,
      anon_sym_BANG,
    ACTIONS(7681), 1,
      sym_preproc_integer_literal,
    ACTIONS(7683), 1,
      sym_preproc_string_literal,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4616), 1,
      sym__preprocessor_call,
    STATE(6007), 1,
      sym__preproc_expression,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6072), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189461] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7685), 1,
      anon_sym_DOT,
    STATE(4617), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 7,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
    ACTIONS(2892), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189520] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_DOT,
    STATE(4618), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 7,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      anon_sym_STAR,
    ACTIONS(2892), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189579] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7677), 1,
      anon_sym_LPAREN,
    ACTIONS(7679), 1,
      anon_sym_BANG,
    ACTIONS(7681), 1,
      sym_preproc_integer_literal,
    ACTIONS(7683), 1,
      sym_preproc_string_literal,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4619), 1,
      sym__preprocessor_call,
    STATE(5973), 1,
      sym__preproc_expression,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6072), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189648] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7689), 1,
      anon_sym_DOT,
    STATE(4620), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_STAR,
    ACTIONS(2892), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189705] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7677), 1,
      anon_sym_LPAREN,
    ACTIONS(7679), 1,
      anon_sym_BANG,
    ACTIONS(7681), 1,
      sym_preproc_integer_literal,
    ACTIONS(7683), 1,
      sym_preproc_string_literal,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4621), 1,
      sym__preprocessor_call,
    STATE(6025), 1,
      sym__preproc_expression,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6072), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189774] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7691), 1,
      sym__identifier_token,
    ACTIONS(7695), 1,
      anon_sym_LPAREN,
    ACTIONS(7697), 1,
      anon_sym_BANG,
    ACTIONS(7701), 1,
      sym_preproc_integer_literal,
    ACTIONS(7703), 1,
      sym_preproc_string_literal,
    STATE(4622), 1,
      sym__preprocessor_call,
    STATE(5890), 1,
      sym__contextual_keywords,
    STATE(5996), 1,
      sym__preproc_expression,
    ACTIONS(7699), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5997), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(7693), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189843] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7677), 1,
      anon_sym_LPAREN,
    ACTIONS(7679), 1,
      anon_sym_BANG,
    ACTIONS(7681), 1,
      sym_preproc_integer_literal,
    ACTIONS(7683), 1,
      sym_preproc_string_literal,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4623), 1,
      sym__preprocessor_call,
    STATE(6049), 1,
      sym__preproc_expression,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6072), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189912] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7677), 1,
      anon_sym_LPAREN,
    ACTIONS(7679), 1,
      anon_sym_BANG,
    ACTIONS(7681), 1,
      sym_preproc_integer_literal,
    ACTIONS(7683), 1,
      sym_preproc_string_literal,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4624), 1,
      sym__preprocessor_call,
    STATE(5954), 1,
      sym__preproc_expression,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6072), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [189981] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2957), 1,
      sym__variable_designation,
    STATE(4625), 1,
      sym__preprocessor_call,
    STATE(4644), 1,
      sym_property_pattern_clause,
    ACTIONS(2809), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2807), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190052] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7691), 1,
      sym__identifier_token,
    ACTIONS(7695), 1,
      anon_sym_LPAREN,
    ACTIONS(7697), 1,
      anon_sym_BANG,
    ACTIONS(7701), 1,
      sym_preproc_integer_literal,
    ACTIONS(7703), 1,
      sym_preproc_string_literal,
    STATE(4626), 1,
      sym__preprocessor_call,
    STATE(5890), 1,
      sym__contextual_keywords,
    STATE(6006), 1,
      sym__preproc_expression,
    ACTIONS(7699), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5997), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(7693), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190121] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7691), 1,
      sym__identifier_token,
    ACTIONS(7695), 1,
      anon_sym_LPAREN,
    ACTIONS(7697), 1,
      anon_sym_BANG,
    ACTIONS(7701), 1,
      sym_preproc_integer_literal,
    ACTIONS(7703), 1,
      sym_preproc_string_literal,
    STATE(4627), 1,
      sym__preprocessor_call,
    STATE(5890), 1,
      sym__contextual_keywords,
    STATE(5989), 1,
      sym__preproc_expression,
    ACTIONS(7699), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5997), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(7693), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190190] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7691), 1,
      sym__identifier_token,
    ACTIONS(7695), 1,
      anon_sym_LPAREN,
    ACTIONS(7697), 1,
      anon_sym_BANG,
    ACTIONS(7701), 1,
      sym_preproc_integer_literal,
    ACTIONS(7703), 1,
      sym_preproc_string_literal,
    STATE(4628), 1,
      sym__preprocessor_call,
    STATE(5890), 1,
      sym__contextual_keywords,
    STATE(5987), 1,
      sym__preproc_expression,
    ACTIONS(7699), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5997), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(7693), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190259] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7691), 1,
      sym__identifier_token,
    ACTIONS(7695), 1,
      anon_sym_LPAREN,
    ACTIONS(7697), 1,
      anon_sym_BANG,
    ACTIONS(7701), 1,
      sym_preproc_integer_literal,
    ACTIONS(7703), 1,
      sym_preproc_string_literal,
    STATE(4629), 1,
      sym__preprocessor_call,
    STATE(5890), 1,
      sym__contextual_keywords,
    STATE(5994), 1,
      sym__preproc_expression,
    ACTIONS(7699), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5997), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(7693), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190328] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7691), 1,
      sym__identifier_token,
    ACTIONS(7695), 1,
      anon_sym_LPAREN,
    ACTIONS(7697), 1,
      anon_sym_BANG,
    ACTIONS(7701), 1,
      sym_preproc_integer_literal,
    ACTIONS(7703), 1,
      sym_preproc_string_literal,
    STATE(4630), 1,
      sym__preprocessor_call,
    STATE(5890), 1,
      sym__contextual_keywords,
    STATE(5918), 1,
      sym__preproc_expression,
    ACTIONS(7699), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5997), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(7693), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190397] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7677), 1,
      anon_sym_LPAREN,
    ACTIONS(7679), 1,
      anon_sym_BANG,
    ACTIONS(7681), 1,
      sym_preproc_integer_literal,
    ACTIONS(7683), 1,
      sym_preproc_string_literal,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4631), 1,
      sym__preprocessor_call,
    STATE(6008), 1,
      sym__preproc_expression,
    ACTIONS(53), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(6072), 5,
      sym_identifier,
      sym_boolean_literal,
      sym_preproc_parenthesized_expression,
      sym_preproc_unary_expression,
      sym_preproc_binary_expression,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190466] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2879), 1,
      sym__variable_designation,
    STATE(4632), 1,
      sym__preprocessor_call,
    STATE(4652), 1,
      sym_property_pattern_clause,
    ACTIONS(2813), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2811), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190537] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2957), 1,
      sym__variable_designation,
    STATE(4633), 1,
      sym__preprocessor_call,
    STATE(4682), 1,
      sym_property_pattern_clause,
    ACTIONS(2807), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2809), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190607] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4634), 1,
      sym__preprocessor_call,
    STATE(6471), 1,
      sym_equals_value_clause,
    ACTIONS(7707), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190671] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4635), 1,
      sym__preprocessor_call,
    STATE(6288), 1,
      sym_equals_value_clause,
    ACTIONS(7709), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190735] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4636), 1,
      sym__preprocessor_call,
    ACTIONS(2835), 9,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2833), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190787] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4637), 1,
      sym__preprocessor_call,
    STATE(6259), 1,
      sym_equals_value_clause,
    ACTIONS(3110), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190851] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4638), 1,
      sym__preprocessor_call,
    STATE(6387), 1,
      sym_equals_value_clause,
    ACTIONS(7711), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190915] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4639), 1,
      sym__preprocessor_call,
    ACTIONS(2729), 9,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2734), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [190967] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5191), 1,
      anon_sym_LPAREN,
    ACTIONS(7713), 1,
      anon_sym_LBRACK,
    STATE(4670), 1,
      sym_attribute_list,
    STATE(4640), 2,
      sym__preprocessor_call,
      aux_sym_event_field_declaration_repeat1,
    ACTIONS(5186), 34,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
      anon_sym_params,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191023] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2786), 1,
      anon_sym_LBRACE,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2879), 1,
      sym__variable_designation,
    STATE(4641), 1,
      sym__preprocessor_call,
    STATE(4663), 1,
      sym_property_pattern_clause,
    ACTIONS(2811), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2813), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191093] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2729), 1,
      anon_sym_LT,
    STATE(4642), 1,
      sym__preprocessor_call,
    ACTIONS(2847), 8,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_QMARK,
      anon_sym_STAR,
      anon_sym_DASH_GT,
    ACTIONS(2844), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191147] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(3044), 1,
      anon_sym_COMMA,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(7707), 1,
      anon_sym_RPAREN,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4643), 1,
      sym__preprocessor_call,
    STATE(6471), 1,
      sym_equals_value_clause,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191212] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2879), 1,
      sym__variable_designation,
    STATE(4644), 1,
      sym__preprocessor_call,
    ACTIONS(2813), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2811), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191277] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2957), 1,
      sym__variable_designation,
    STATE(4645), 1,
      sym__preprocessor_call,
    ACTIONS(2809), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2807), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191342] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7716), 1,
      anon_sym_LPAREN,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4646), 1,
      sym__preprocessor_call,
    STATE(5702), 1,
      sym_parameter_list,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191403] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4647), 1,
      sym__preprocessor_call,
    ACTIONS(2847), 5,
      anon_sym_COLON_COLON,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2729), 6,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
    ACTIONS(2844), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191456] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7719), 1,
      anon_sym_DOT,
    STATE(4648), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 5,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_STAR,
    ACTIONS(2892), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191513] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7716), 1,
      anon_sym_LPAREN,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4649), 1,
      sym__preprocessor_call,
    STATE(5698), 1,
      sym_parameter_list,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191574] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7716), 1,
      anon_sym_LPAREN,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4650), 1,
      sym__preprocessor_call,
    STATE(5704), 1,
      sym_parameter_list,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191635] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7721), 1,
      anon_sym_DOT,
    STATE(4651), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 5,
      anon_sym_LBRACK,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_STAR,
    ACTIONS(2892), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191692] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2948), 1,
      sym__variable_designation,
    STATE(4652), 1,
      sym__preprocessor_call,
    ACTIONS(2825), 2,
      anon_sym_and,
      anon_sym_or,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2823), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191757] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4653), 1,
      sym__preprocessor_call,
    ACTIONS(2815), 9,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_STAR,
    ACTIONS(2817), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191808] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4654), 1,
      sym__preprocessor_call,
    ACTIONS(5276), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(5274), 34,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
      anon_sym_params,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191858] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7723), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4655), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191926] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7725), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(4656), 1,
      sym__preprocessor_call,
    STATE(4705), 1,
      sym_name_equals,
    STATE(5914), 1,
      sym_identifier,
    STATE(6186), 1,
      sym_global,
    STATE(6546), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [191994] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4657), 1,
      sym__preprocessor_call,
    ACTIONS(5343), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(5341), 34,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
      anon_sym_params,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192044] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7727), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4658), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192112] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4659), 1,
      sym__preprocessor_call,
    ACTIONS(5317), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(5315), 34,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
      anon_sym_params,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192162] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7729), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4660), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192230] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7731), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4661), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192298] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7733), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4662), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192366] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2948), 1,
      sym__variable_designation,
    STATE(4663), 1,
      sym__preprocessor_call,
    ACTIONS(2823), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2825), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192430] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7735), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(4664), 1,
      sym__preprocessor_call,
    STATE(4700), 1,
      sym_name_equals,
    STATE(5914), 1,
      sym_identifier,
    STATE(6186), 1,
      sym_global,
    STATE(6563), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192498] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7737), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(4665), 1,
      sym__preprocessor_call,
    STATE(4716), 1,
      sym_name_equals,
    STATE(5914), 1,
      sym_identifier,
    STATE(6186), 1,
      sym_global,
    STATE(6623), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192566] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2957), 1,
      sym__variable_designation,
    STATE(4666), 1,
      sym__preprocessor_call,
    ACTIONS(2807), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2809), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192630] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7739), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(4667), 1,
      sym__preprocessor_call,
    STATE(4697), 1,
      sym_name_equals,
    STATE(5914), 1,
      sym_identifier,
    STATE(6186), 1,
      sym_global,
    STATE(6500), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192698] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7741), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4668), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192766] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7743), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4669), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192834] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4670), 1,
      sym__preprocessor_call,
    ACTIONS(5293), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(5291), 34,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
      anon_sym_params,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192884] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7745), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4671), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [192952] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7747), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4672), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193020] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7749), 1,
      anon_sym_EQ,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4673), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 6,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193078] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7751), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4674), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193146] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7753), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4675), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4676), 1,
      sym__preprocessor_call,
    ACTIONS(5299), 2,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
    ACTIONS(5297), 34,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_ref,
      anon_sym_out,
      anon_sym_in,
      anon_sym_this,
      anon_sym_params,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_delegate,
      anon_sym_var,
      sym_predefined_type,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193264] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7755), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4677), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193332] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7757), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4678), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6281), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193400] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7759), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4679), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193468] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7761), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4680), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193536] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2729), 1,
      anon_sym_LT,
    ACTIONS(7763), 1,
      anon_sym_using,
    STATE(4681), 1,
      sym__preprocessor_call,
    ACTIONS(2847), 6,
      anon_sym_COLON_COLON,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2844), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_this,
      anon_sym_operator,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193590] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2879), 1,
      sym__variable_designation,
    STATE(4682), 1,
      sym__preprocessor_call,
    ACTIONS(2811), 2,
      anon_sym_COLON,
      anon_sym_EQ_GT,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(2813), 3,
      anon_sym_and,
      anon_sym_or,
      anon_sym_when,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193654] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    ACTIONS(7765), 1,
      anon_sym_RBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4683), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193722] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4684), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6276), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(4685), 1,
      sym__preprocessor_call,
    ACTIONS(2729), 3,
      anon_sym_EQ,
      anon_sym_LT,
      anon_sym_RPAREN,
    ACTIONS(2847), 6,
      anon_sym_COLON_COLON,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2844), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193838] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2767), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4686), 1,
      sym__preprocessor_call,
    STATE(5184), 1,
      sym_explicit_interface_specifier,
    STATE(5764), 1,
      sym_identifier,
    STATE(6654), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193903] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4687), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6447), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [193968] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4688), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6328), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194033] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_DOT,
    ACTIONS(7769), 1,
      anon_sym_LPAREN,
    STATE(4689), 1,
      sym__preprocessor_call,
    STATE(6528), 1,
      sym_attribute_argument_list,
    ACTIONS(2894), 2,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(7767), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194094] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4690), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6346), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194159] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2767), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4691), 1,
      sym__preprocessor_call,
    STATE(5223), 1,
      sym_explicit_interface_specifier,
    STATE(5878), 1,
      sym_identifier,
    STATE(6654), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194224] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4692), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6436), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194289] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2767), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4693), 1,
      sym__preprocessor_call,
    STATE(5229), 1,
      sym_explicit_interface_specifier,
    STATE(5847), 1,
      sym_identifier,
    STATE(6654), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194354] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4694), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6046), 1,
      sym__name,
    STATE(6510), 1,
      sym_attribute,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194419] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7771), 1,
      anon_sym_COMMA,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4695), 1,
      sym__preprocessor_call,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(5913), 1,
      sym_identifier,
    STATE(6126), 1,
      sym_variable_declarator,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194486] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4696), 1,
      sym__preprocessor_call,
    STATE(4730), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6485), 1,
      sym_identifier,
    STATE(6568), 1,
      sym_type_parameter,
    ACTIONS(5763), 2,
      anon_sym_out,
      anon_sym_in,
    ACTIONS(2667), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194548] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4697), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6546), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194610] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4698), 1,
      sym__preprocessor_call,
    STATE(5573), 1,
      sym_identifier,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(6126), 1,
      sym_variable_declarator,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194674] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    ACTIONS(7773), 1,
      anon_sym_COMMA,
    ACTIONS(7775), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4699), 1,
      sym__preprocessor_call,
    STATE(4904), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6279), 1,
      sym_identifier,
    STATE(6362), 1,
      sym_enum_member_declaration,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194738] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4700), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6623), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194800] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4701), 1,
      sym__preprocessor_call,
    STATE(4730), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6231), 1,
      sym_type_parameter,
    STATE(6485), 1,
      sym_identifier,
    ACTIONS(5763), 2,
      anon_sym_out,
      anon_sym_in,
    ACTIONS(2667), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194862] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4702), 1,
      sym__preprocessor_call,
    STATE(5571), 1,
      sym_identifier,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(6126), 1,
      sym_variable_declarator,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194926] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4703), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6196), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [194988] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    STATE(4704), 1,
      sym__preprocessor_call,
    ACTIONS(3184), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2894), 5,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195040] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4705), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6572), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195102] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4706), 1,
      sym__preprocessor_call,
    STATE(5569), 1,
      sym_identifier,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(6126), 1,
      sym_variable_declarator,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195166] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2969), 1,
      anon_sym_EQ_GT,
    ACTIONS(5400), 1,
      anon_sym_RPAREN,
    STATE(4707), 1,
      sym__preprocessor_call,
    ACTIONS(2967), 3,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
    ACTIONS(2965), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195218] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7749), 1,
      anon_sym_EQ,
    STATE(4708), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 6,
      anon_sym_SEMI,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195270] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4709), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6303), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195332] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4710), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6345), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195394] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4711), 1,
      sym__preprocessor_call,
    STATE(6126), 1,
      sym_variable_declarator,
    STATE(5767), 2,
      sym_tuple_pattern,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195456] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7777), 1,
      anon_sym_in,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4712), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195512] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    ACTIONS(7779), 1,
      anon_sym_COMMA,
    ACTIONS(7781), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4713), 1,
      sym__preprocessor_call,
    STATE(4904), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6278), 1,
      sym_enum_member_declaration,
    STATE(6279), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195576] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2969), 1,
      anon_sym_EQ_GT,
    STATE(4714), 1,
      sym__preprocessor_call,
    ACTIONS(2967), 4,
      anon_sym_COMMA,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      anon_sym_LBRACE,
    ACTIONS(2965), 29,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_and,
      anon_sym_or,
      sym_discard,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195626] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    ACTIONS(7783), 1,
      anon_sym_in,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(4715), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
    ACTIONS(2827), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195682] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1784), 1,
      sym_generic_name,
    STATE(2641), 1,
      sym_global,
    STATE(4716), 1,
      sym__preprocessor_call,
    STATE(5626), 1,
      sym_identifier,
    STATE(6524), 1,
      sym__name,
    STATE(4513), 3,
      sym_alias_qualified_name,
      sym__simple_name,
      sym_qualified_name,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195744] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4717), 1,
      sym__preprocessor_call,
    STATE(5570), 1,
      sym_identifier,
    STATE(5767), 1,
      sym_tuple_pattern,
    STATE(6126), 1,
      sym_variable_declarator,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195808] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4718), 1,
      sym__preprocessor_call,
    STATE(6939), 2,
      sym_tuple_pattern,
      sym_identifier,
    ACTIONS(951), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195867] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    ACTIONS(7785), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4719), 1,
      sym__preprocessor_call,
    STATE(4904), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6279), 1,
      sym_identifier,
    STATE(6599), 1,
      sym_enum_member_declaration,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195928] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7787), 1,
      anon_sym_DOT,
    STATE(4720), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [195981] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    ACTIONS(7789), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4721), 1,
      sym__preprocessor_call,
    STATE(6422), 1,
      sym__variable_designation,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196040] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7771), 1,
      anon_sym_COMMA,
    ACTIONS(7791), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4722), 1,
      sym__preprocessor_call,
    STATE(6188), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196101] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4723), 1,
      sym__preprocessor_call,
    STATE(6444), 1,
      sym_function_pointer_unmanaged_calling_convention,
    STATE(6529), 1,
      sym_identifier,
    ACTIONS(7793), 4,
      anon_sym_Cdecl,
      anon_sym_Stdcall,
      anon_sym_Thiscall,
      anon_sym_Fastcall,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196156] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4724), 1,
      sym__preprocessor_call,
    STATE(6659), 2,
      sym_tuple_pattern,
      sym_identifier,
    ACTIONS(951), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196215] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    ACTIONS(7795), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4725), 1,
      sym__preprocessor_call,
    STATE(4904), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6279), 1,
      sym_identifier,
    STATE(6599), 1,
      sym_enum_member_declaration,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196276] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    ACTIONS(7797), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4726), 1,
      sym__preprocessor_call,
    STATE(4904), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6279), 1,
      sym_identifier,
    STATE(6599), 1,
      sym_enum_member_declaration,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196337] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4727), 1,
      sym__preprocessor_call,
    STATE(6899), 2,
      sym_tuple_pattern,
      sym_identifier,
    ACTIONS(951), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196396] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    ACTIONS(7799), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4728), 1,
      sym__preprocessor_call,
    STATE(6459), 1,
      sym__variable_designation,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196455] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4729), 1,
      sym__preprocessor_call,
    STATE(6887), 2,
      sym_tuple_pattern,
      sym_identifier,
    ACTIONS(951), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196514] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4730), 1,
      sym__preprocessor_call,
    STATE(4887), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6603), 1,
      sym_identifier,
    ACTIONS(7801), 2,
      anon_sym_out,
      anon_sym_in,
    ACTIONS(2667), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196573] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    ACTIONS(7803), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4731), 1,
      sym__preprocessor_call,
    STATE(6305), 1,
      sym__variable_designation,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196632] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7771), 1,
      anon_sym_COMMA,
    ACTIONS(7805), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4732), 1,
      sym__preprocessor_call,
    STATE(6188), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196693] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4733), 1,
      sym__preprocessor_call,
    STATE(6677), 2,
      sym_tuple_pattern,
      sym_identifier,
    ACTIONS(951), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196752] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4734), 1,
      sym__preprocessor_call,
    STATE(6529), 1,
      sym_identifier,
    STATE(6547), 1,
      sym_function_pointer_unmanaged_calling_convention,
    ACTIONS(7793), 4,
      anon_sym_Cdecl,
      anon_sym_Stdcall,
      anon_sym_Thiscall,
      anon_sym_Fastcall,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196807] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    ACTIONS(7807), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4735), 1,
      sym__preprocessor_call,
    STATE(6393), 1,
      sym__variable_designation,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196866] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4736), 1,
      sym__preprocessor_call,
    STATE(6937), 2,
      sym_tuple_pattern,
      sym_identifier,
    ACTIONS(951), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196925] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7771), 1,
      anon_sym_COMMA,
    ACTIONS(7809), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4737), 1,
      sym__preprocessor_call,
    STATE(6188), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [196986] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    ACTIONS(7811), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4738), 1,
      sym__preprocessor_call,
    STATE(4904), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6279), 1,
      sym_identifier,
    STATE(6599), 1,
      sym_enum_member_declaration,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197047] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4739), 1,
      sym__preprocessor_call,
    STATE(6536), 1,
      sym_identifier,
    ACTIONS(7771), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197106] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7813), 1,
      anon_sym_DOT,
    STATE(4740), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 4,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197159] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7815), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4741), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197217] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7817), 1,
      anon_sym_static,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7821), 1,
      anon_sym_delegate,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4742), 1,
      sym__preprocessor_call,
    STATE(6669), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197273] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7823), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4743), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197331] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7689), 1,
      anon_sym_DOT,
    ACTIONS(7825), 1,
      anon_sym_SEMI,
    STATE(4744), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197383] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7640), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4745), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197441] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7827), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4746), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197499] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7829), 1,
      sym__identifier_token,
    ACTIONS(7835), 1,
      anon_sym_global,
    ACTIONS(7838), 1,
      anon_sym_this,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4610), 1,
      sym__simple_name,
    STATE(4747), 1,
      sym__preprocessor_call,
    STATE(5680), 1,
      sym_identifier,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(7832), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197557] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7840), 1,
      anon_sym_static,
    ACTIONS(7842), 1,
      anon_sym_delegate,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4748), 1,
      sym__preprocessor_call,
    STATE(6843), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197613] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7771), 1,
      anon_sym_COMMA,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4749), 1,
      sym__preprocessor_call,
    STATE(6110), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197671] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7805), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4750), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197729] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7618), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4751), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197787] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7844), 1,
      anon_sym_static,
    ACTIONS(7846), 1,
      anon_sym_delegate,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4752), 1,
      sym__preprocessor_call,
    STATE(6675), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197843] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7848), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4753), 1,
      sym__preprocessor_call,
    STATE(6633), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197899] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7606), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4754), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [197957] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7821), 1,
      anon_sym_delegate,
    ACTIONS(7850), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4755), 1,
      sym__preprocessor_call,
    STATE(6732), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198013] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7852), 1,
      anon_sym_static,
    ACTIONS(7854), 1,
      anon_sym_delegate,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4756), 1,
      sym__preprocessor_call,
    STATE(6774), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198069] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7842), 1,
      anon_sym_delegate,
    ACTIONS(7856), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4757), 1,
      sym__preprocessor_call,
    STATE(6893), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198125] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7854), 1,
      anon_sym_delegate,
    ACTIONS(7858), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4758), 1,
      sym__preprocessor_call,
    STATE(6756), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198181] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7854), 1,
      anon_sym_delegate,
    ACTIONS(7860), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4759), 1,
      sym__preprocessor_call,
    STATE(6758), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198237] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7862), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4760), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198295] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7821), 1,
      anon_sym_delegate,
    ACTIONS(7864), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4761), 1,
      sym__preprocessor_call,
    STATE(6795), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198351] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7866), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4762), 1,
      sym__preprocessor_call,
    STATE(6662), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198407] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7821), 1,
      anon_sym_delegate,
    ACTIONS(7868), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4763), 1,
      sym__preprocessor_call,
    STATE(6875), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198463] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7608), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4764), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198521] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7644), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4765), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198579] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7870), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4766), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198637] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7821), 1,
      anon_sym_delegate,
    ACTIONS(7872), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4767), 1,
      sym__preprocessor_call,
    STATE(6716), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198693] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7842), 1,
      anon_sym_delegate,
    ACTIONS(7874), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4768), 1,
      sym__preprocessor_call,
    STATE(6748), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198749] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_DOT,
    STATE(4769), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198801] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7620), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4770), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198859] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7632), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4771), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198917] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7876), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4772), 1,
      sym__preprocessor_call,
    STATE(6702), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [198973] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7821), 1,
      anon_sym_delegate,
    ACTIONS(7878), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4773), 1,
      sym__preprocessor_call,
    STATE(6720), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199029] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7642), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4774), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199087] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7854), 1,
      anon_sym_delegate,
    ACTIONS(7880), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4775), 1,
      sym__preprocessor_call,
    STATE(6865), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199143] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7854), 1,
      anon_sym_delegate,
    ACTIONS(7882), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4776), 1,
      sym__preprocessor_call,
    STATE(6840), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199199] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7884), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4777), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199257] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7846), 1,
      anon_sym_delegate,
    ACTIONS(7886), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4778), 1,
      sym__preprocessor_call,
    STATE(6881), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199313] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7846), 1,
      anon_sym_delegate,
    ACTIONS(7888), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4779), 1,
      sym__preprocessor_call,
    STATE(6940), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199369] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7890), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4780), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199427] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7892), 1,
      anon_sym_DOT,
    STATE(4781), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 3,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199479] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7821), 1,
      anon_sym_delegate,
    ACTIONS(7894), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4782), 1,
      sym__preprocessor_call,
    STATE(6870), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199535] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7896), 1,
      anon_sym_DOT,
    STATE(4783), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199587] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7634), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4784), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199645] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7898), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4785), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199703] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7842), 1,
      anon_sym_delegate,
    ACTIONS(7900), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4786), 1,
      sym__preprocessor_call,
    STATE(6680), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199759] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7604), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4787), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199817] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7902), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4788), 1,
      sym__preprocessor_call,
    STATE(6923), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199873] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7638), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4789), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199931] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7842), 1,
      anon_sym_delegate,
    ACTIONS(7904), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4790), 1,
      sym__preprocessor_call,
    STATE(6896), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [199987] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7616), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4791), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200045] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7821), 1,
      anon_sym_delegate,
    ACTIONS(7906), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4792), 1,
      sym__preprocessor_call,
    STATE(6687), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200101] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7628), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4793), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200159] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7908), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4794), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200217] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7636), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4795), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200275] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7910), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4796), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200333] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7626), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4797), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200391] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7624), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4798), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200449] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7842), 1,
      anon_sym_delegate,
    ACTIONS(7912), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4799), 1,
      sym__preprocessor_call,
    STATE(6888), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200505] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7612), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4800), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200563] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7914), 1,
      anon_sym_DOT,
    STATE(4801), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 3,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200615] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7916), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4802), 1,
      sym__preprocessor_call,
    STATE(6686), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200671] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7842), 1,
      anon_sym_delegate,
    ACTIONS(7918), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4803), 1,
      sym__preprocessor_call,
    STATE(6651), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200727] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7920), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4804), 1,
      sym__preprocessor_call,
    STATE(6625), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200783] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7771), 1,
      anon_sym_COMMA,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4805), 1,
      sym__preprocessor_call,
    STATE(6477), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200841] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7922), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4806), 1,
      sym__preprocessor_call,
    STATE(6782), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200897] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7821), 1,
      anon_sym_delegate,
    ACTIONS(7924), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4807), 1,
      sym__preprocessor_call,
    STATE(6753), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [200953] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7610), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4808), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201011] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7926), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4809), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201069] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7791), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4810), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201127] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7928), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4811), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201185] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7809), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4812), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201243] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2802), 1,
      sym_discard,
    ACTIONS(2821), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4813), 1,
      sym__preprocessor_call,
    STATE(6483), 1,
      sym__variable_designation,
    STATE(2947), 2,
      sym_parenthesized_variable_designation,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201299] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7930), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4814), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201357] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7854), 1,
      anon_sym_delegate,
    ACTIONS(7932), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4815), 1,
      sym__preprocessor_call,
    STATE(6626), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201413] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7854), 1,
      anon_sym_delegate,
    ACTIONS(7934), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4816), 1,
      sym__preprocessor_call,
    STATE(6761), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201469] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7936), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4817), 1,
      sym__preprocessor_call,
    STATE(6919), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201525] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7842), 1,
      anon_sym_delegate,
    ACTIONS(7938), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4818), 1,
      sym__preprocessor_call,
    STATE(6648), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201581] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7940), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4819), 1,
      sym__preprocessor_call,
    STATE(6916), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201639] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7630), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4820), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201697] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    STATE(4821), 1,
      sym__preprocessor_call,
    ACTIONS(7017), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2894), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201747] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7846), 1,
      anon_sym_delegate,
    ACTIONS(7942), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4822), 1,
      sym__preprocessor_call,
    STATE(6769), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201803] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7614), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4823), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201861] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5484), 1,
      anon_sym_delegate,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7944), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4824), 1,
      sym__preprocessor_call,
    STATE(6929), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201917] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7946), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4825), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [201975] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7622), 1,
      anon_sym_RPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4826), 1,
      sym__preprocessor_call,
    STATE(6189), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202033] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7687), 1,
      anon_sym_DOT,
    STATE(4827), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 3,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202085] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4828), 1,
      sym__preprocessor_call,
    STATE(4904), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6279), 1,
      sym_identifier,
    STATE(6599), 1,
      sym_enum_member_declaration,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202143] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(7854), 1,
      anon_sym_delegate,
    ACTIONS(7948), 1,
      anon_sym_static,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4829), 1,
      sym__preprocessor_call,
    STATE(6811), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202199] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2064), 1,
      sym_identifier,
    STATE(2100), 1,
      sym__simple_name,
    STATE(4830), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202254] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7950), 1,
      sym__identifier_token,
    ACTIONS(7954), 1,
      anon_sym_global,
    STATE(1776), 1,
      sym_identifier,
    STATE(1833), 1,
      sym__simple_name,
    STATE(1911), 1,
      sym__contextual_keywords,
    STATE(4831), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(7952), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202309] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2064), 1,
      sym_identifier,
    STATE(2186), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4832), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202364] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2064), 1,
      sym_identifier,
    STATE(2085), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4833), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202419] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7950), 1,
      sym__identifier_token,
    ACTIONS(7954), 1,
      anon_sym_global,
    STATE(1776), 1,
      sym_identifier,
    STATE(1781), 1,
      sym__simple_name,
    STATE(1911), 1,
      sym__contextual_keywords,
    STATE(4834), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(7952), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202474] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2637), 1,
      sym_identifier,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2682), 1,
      sym__simple_name,
    STATE(4835), 1,
      sym__preprocessor_call,
    STATE(2702), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7958), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4836), 1,
      sym__preprocessor_call,
    STATE(6371), 1,
      sym_simple_assignment_expression,
    STATE(6709), 1,
      sym_identifier,
    STATE(6944), 1,
      sym_with_initializer_expression,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202584] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(803), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2865), 1,
      sym__simple_name,
    STATE(4463), 1,
      sym_identifier,
    STATE(4837), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202639] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2064), 1,
      sym_identifier,
    STATE(2083), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4838), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202694] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2105), 1,
      sym__simple_name,
    STATE(2180), 1,
      sym_identifier,
    STATE(4839), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202749] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4840), 1,
      sym__preprocessor_call,
    STATE(5980), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202804] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2180), 1,
      sym_identifier,
    STATE(2327), 1,
      sym__simple_name,
    STATE(4841), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202859] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4842), 1,
      sym__preprocessor_call,
    STATE(6160), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202914] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(1657), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1963), 1,
      sym__simple_name,
    STATE(4843), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [202969] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2113), 1,
      sym__simple_name,
    STATE(2180), 1,
      sym_identifier,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4844), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203024] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2064), 1,
      sym_identifier,
    STATE(2100), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4845), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203079] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2105), 1,
      sym__simple_name,
    STATE(2180), 1,
      sym_identifier,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4846), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203134] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2180), 1,
      sym_identifier,
    STATE(2276), 1,
      sym__simple_name,
    STATE(4847), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203189] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7950), 1,
      sym__identifier_token,
    ACTIONS(7954), 1,
      anon_sym_global,
    STATE(1776), 1,
      sym_identifier,
    STATE(1793), 1,
      sym__simple_name,
    STATE(1911), 1,
      sym__contextual_keywords,
    STATE(4848), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(7952), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203244] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4849), 1,
      sym__preprocessor_call,
    STATE(6109), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203299] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7960), 1,
      anon_sym_DOT,
    STATE(4850), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 2,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203350] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4851), 1,
      sym__preprocessor_call,
    STATE(5958), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203405] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2113), 1,
      sym__simple_name,
    STATE(2180), 1,
      sym_identifier,
    STATE(4852), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203460] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2105), 1,
      sym__simple_name,
    STATE(2180), 1,
      sym_identifier,
    STATE(4853), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203515] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(799), 1,
      sym__identifier_token,
    ACTIONS(803), 1,
      anon_sym_global,
    STATE(2645), 1,
      sym__contextual_keywords,
    STATE(2716), 1,
      sym_identifier,
    STATE(2823), 1,
      sym__simple_name,
    STATE(4854), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(801), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203570] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(1657), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1793), 1,
      sym__simple_name,
    STATE(4855), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203625] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2064), 1,
      sym_identifier,
    STATE(2085), 1,
      sym__simple_name,
    STATE(4856), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203680] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1996), 1,
      sym__simple_name,
    STATE(4857), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203735] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(803), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2113), 1,
      sym__simple_name,
    STATE(4463), 1,
      sym_identifier,
    STATE(4858), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203790] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7950), 1,
      sym__identifier_token,
    ACTIONS(7954), 1,
      anon_sym_global,
    STATE(1776), 1,
      sym_identifier,
    STATE(1911), 1,
      sym__contextual_keywords,
    STATE(2026), 1,
      sym__simple_name,
    STATE(4859), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(7952), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203845] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4860), 1,
      sym__preprocessor_call,
    STATE(6190), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203900] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4861), 1,
      sym__preprocessor_call,
    STATE(6157), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [203955] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1971), 1,
      sym__simple_name,
    STATE(4862), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204010] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4610), 1,
      sym__simple_name,
    STATE(4863), 1,
      sym__preprocessor_call,
    STATE(5680), 1,
      sym_identifier,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204065] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4864), 1,
      sym__preprocessor_call,
    STATE(6095), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204120] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4865), 1,
      sym__preprocessor_call,
    STATE(6171), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204175] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(3043), 1,
      sym__simple_name,
    STATE(4866), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204230] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4867), 1,
      sym__preprocessor_call,
    STATE(6108), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204285] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2716), 1,
      sym_identifier,
    STATE(2958), 1,
      sym__simple_name,
    STATE(4868), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204340] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7962), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4869), 1,
      sym__preprocessor_call,
    STATE(6371), 1,
      sym_simple_assignment_expression,
    STATE(6641), 1,
      sym_with_initializer_expression,
    STATE(6709), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204395] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4870), 1,
      sym__preprocessor_call,
    STATE(6388), 1,
      sym_identifier,
    ACTIONS(2894), 2,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204448] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1833), 1,
      sym__simple_name,
    STATE(4871), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204503] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(799), 1,
      sym__identifier_token,
    ACTIONS(803), 1,
      anon_sym_global,
    STATE(2645), 1,
      sym__contextual_keywords,
    STATE(2716), 1,
      sym_identifier,
    STATE(2865), 1,
      sym__simple_name,
    STATE(4872), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(801), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204558] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2100), 1,
      sym__simple_name,
    STATE(2180), 1,
      sym_identifier,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4873), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204613] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2637), 1,
      sym_identifier,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2857), 1,
      sym__simple_name,
    STATE(4874), 1,
      sym__preprocessor_call,
    STATE(2702), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204668] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4875), 1,
      sym__preprocessor_call,
    STATE(6218), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204723] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2716), 1,
      sym_identifier,
    STATE(2823), 1,
      sym__simple_name,
    STATE(4876), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204778] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7964), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4877), 1,
      sym__preprocessor_call,
    STATE(6371), 1,
      sym_simple_assignment_expression,
    STATE(6709), 1,
      sym_identifier,
    STATE(6718), 1,
      sym_with_initializer_expression,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204833] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4878), 1,
      sym__preprocessor_call,
    STATE(6156), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204888] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2180), 1,
      sym_identifier,
    STATE(2327), 1,
      sym__simple_name,
    STATE(4879), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204943] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1793), 1,
      sym__simple_name,
    STATE(4880), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [204998] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7966), 1,
      sym_discard,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4881), 1,
      sym__preprocessor_call,
    STATE(6505), 2,
      sym_tuple_pattern,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205051] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1781), 1,
      sym__simple_name,
    STATE(4882), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205106] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2006), 1,
      sym__simple_name,
    STATE(4883), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205161] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2180), 1,
      sym_identifier,
    STATE(2276), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4884), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205216] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(1657), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1808), 1,
      sym__simple_name,
    STATE(4885), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205271] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2014), 1,
      sym__simple_name,
    STATE(4886), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205326] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7968), 1,
      anon_sym_LBRACK,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(4887), 2,
      sym__preprocessor_call,
      aux_sym_event_field_declaration_repeat1,
    ACTIONS(5186), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_out,
      anon_sym_in,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205373] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2637), 1,
      sym_identifier,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2727), 1,
      sym__simple_name,
    STATE(4888), 1,
      sym__preprocessor_call,
    STATE(2702), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205428] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(1657), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1961), 1,
      sym__simple_name,
    STATE(4889), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205483] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2064), 1,
      sym_identifier,
    STATE(2083), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4890), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205538] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2907), 1,
      sym__simple_name,
    STATE(4891), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205593] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2637), 1,
      sym_identifier,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2721), 1,
      sym__simple_name,
    STATE(4892), 1,
      sym__preprocessor_call,
    STATE(2702), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205648] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2032), 1,
      sym__simple_name,
    STATE(4893), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205703] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2064), 1,
      sym_identifier,
    STATE(2139), 1,
      sym__simple_name,
    STATE(4894), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205758] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2064), 1,
      sym_identifier,
    STATE(2085), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4895), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205813] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1808), 1,
      sym__simple_name,
    STATE(4896), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205868] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2113), 1,
      sym__simple_name,
    STATE(2180), 1,
      sym_identifier,
    STATE(4897), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205923] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(799), 1,
      sym__identifier_token,
    ACTIONS(803), 1,
      anon_sym_global,
    STATE(2645), 1,
      sym__contextual_keywords,
    STATE(2716), 1,
      sym_identifier,
    STATE(2824), 1,
      sym__simple_name,
    STATE(4898), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(801), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [205978] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4899), 1,
      sym__preprocessor_call,
    STATE(5971), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206033] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2008), 1,
      sym__simple_name,
    STATE(4900), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206088] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4901), 1,
      sym__preprocessor_call,
    STATE(6258), 1,
      sym_identifier,
    ACTIONS(2894), 2,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206141] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4902), 1,
      sym__preprocessor_call,
    STATE(6081), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206196] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2064), 1,
      sym_identifier,
    STATE(2100), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4903), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206251] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(5761), 1,
      anon_sym_LBRACK,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4887), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(4904), 1,
      sym__preprocessor_call,
    STATE(5085), 1,
      sym_attribute_list,
    STATE(6463), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206306] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(803), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2327), 1,
      sym__simple_name,
    STATE(4463), 1,
      sym_identifier,
    STATE(4905), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206361] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2022), 1,
      sym__simple_name,
    STATE(4906), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206416] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2100), 1,
      sym__simple_name,
    STATE(2180), 1,
      sym_identifier,
    STATE(4907), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206471] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    ACTIONS(7971), 1,
      sym_discard,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4908), 1,
      sym__preprocessor_call,
    STATE(6372), 2,
      sym_tuple_pattern,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206524] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4198), 1,
      sym_identifier,
    STATE(4544), 1,
      sym__simple_name,
    STATE(4909), 1,
      sym__preprocessor_call,
    STATE(4512), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206579] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2637), 1,
      sym_identifier,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2684), 1,
      sym__simple_name,
    STATE(4910), 1,
      sym__preprocessor_call,
    STATE(2702), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206634] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7547), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4911), 1,
      sym__preprocessor_call,
    STATE(6327), 1,
      sym_variable_declarator,
    STATE(5767), 2,
      sym_tuple_pattern,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206687] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2663), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(4198), 1,
      sym_identifier,
    STATE(4610), 1,
      sym__simple_name,
    STATE(4912), 1,
      sym__preprocessor_call,
    STATE(4512), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2667), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206742] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7973), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4913), 1,
      sym__preprocessor_call,
    STATE(6371), 1,
      sym_simple_assignment_expression,
    STATE(6709), 1,
      sym_identifier,
    STATE(6778), 1,
      sym_with_initializer_expression,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206797] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(2765), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4544), 1,
      sym__simple_name,
    STATE(4914), 1,
      sym__preprocessor_call,
    STATE(5680), 1,
      sym_identifier,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206852] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2001), 1,
      sym__simple_name,
    STATE(4915), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206907] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(799), 1,
      sym__identifier_token,
    ACTIONS(803), 1,
      anon_sym_global,
    STATE(2645), 1,
      sym__contextual_keywords,
    STATE(2716), 1,
      sym_identifier,
    STATE(2958), 1,
      sym__simple_name,
    STATE(4916), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(801), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [206962] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2026), 1,
      sym__simple_name,
    STATE(4917), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207017] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2024), 1,
      sym__simple_name,
    STATE(4918), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207072] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2100), 1,
      sym__simple_name,
    STATE(2180), 1,
      sym_identifier,
    STATE(4919), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207127] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7950), 1,
      sym__identifier_token,
    ACTIONS(7954), 1,
      anon_sym_global,
    STATE(1776), 1,
      sym_identifier,
    STATE(1808), 1,
      sym__simple_name,
    STATE(1911), 1,
      sym__contextual_keywords,
    STATE(4920), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(7952), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207182] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2716), 1,
      sym_identifier,
    STATE(2939), 1,
      sym__simple_name,
    STATE(4921), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207237] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7975), 1,
      anon_sym_RBRACE,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4922), 1,
      sym__preprocessor_call,
    STATE(6371), 1,
      sym_simple_assignment_expression,
    STATE(6671), 1,
      sym_with_initializer_expression,
    STATE(6709), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207292] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2180), 1,
      sym_identifier,
    STATE(2327), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4923), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207347] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(3076), 1,
      sym__simple_name,
    STATE(4924), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207402] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4925), 1,
      sym__preprocessor_call,
    STATE(6754), 1,
      sym_identifier,
    ACTIONS(951), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207457] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2009), 1,
      sym__simple_name,
    STATE(4926), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207512] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(799), 1,
      sym__identifier_token,
    ACTIONS(803), 1,
      anon_sym_global,
    STATE(2645), 1,
      sym__contextual_keywords,
    STATE(2716), 1,
      sym_identifier,
    STATE(2939), 1,
      sym__simple_name,
    STATE(4927), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(801), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207567] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(949), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4928), 1,
      sym__preprocessor_call,
    STATE(6676), 1,
      sym_identifier,
    ACTIONS(951), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207622] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7977), 1,
      sym__identifier_token,
    ACTIONS(7981), 1,
      anon_sym_global,
    STATE(4198), 1,
      sym_identifier,
    STATE(4544), 1,
      sym__simple_name,
    STATE(4636), 1,
      sym__contextual_keywords,
    STATE(4929), 1,
      sym__preprocessor_call,
    STATE(4512), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(7979), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207677] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4930), 1,
      sym__preprocessor_call,
    STATE(6454), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207732] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2716), 1,
      sym_identifier,
    STATE(2865), 1,
      sym__simple_name,
    STATE(4931), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207787] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4932), 1,
      sym__preprocessor_call,
    STATE(6217), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207842] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1989), 1,
      sym__simple_name,
    STATE(4933), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207897] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7950), 1,
      sym__identifier_token,
    ACTIONS(7954), 1,
      anon_sym_global,
    STATE(1776), 1,
      sym_identifier,
    STATE(1911), 1,
      sym__contextual_keywords,
    STATE(1959), 1,
      sym__simple_name,
    STATE(4934), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(7952), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [207952] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2180), 1,
      sym_identifier,
    STATE(2276), 1,
      sym__simple_name,
    STATE(4935), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208007] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    STATE(4936), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 2,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(6160), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208056] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(2716), 1,
      sym_identifier,
    STATE(2824), 1,
      sym__simple_name,
    STATE(4937), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208111] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2064), 1,
      sym_identifier,
    STATE(2186), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4938), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208166] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2064), 1,
      sym_identifier,
    STATE(2186), 1,
      sym__simple_name,
    STATE(4939), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208221] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(1657), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1959), 1,
      sym__simple_name,
    STATE(4940), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208276] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(871), 1,
      anon_sym_global,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2064), 1,
      sym_identifier,
    STATE(2139), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4941), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208331] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1975), 1,
      sym__simple_name,
    STATE(4942), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208386] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2992), 1,
      sym__simple_name,
    STATE(4943), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208441] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7950), 1,
      sym__identifier_token,
    ACTIONS(7954), 1,
      anon_sym_global,
    STATE(1776), 1,
      sym_identifier,
    STATE(1911), 1,
      sym__contextual_keywords,
    STATE(1961), 1,
      sym__simple_name,
    STATE(4944), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(7952), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208496] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(4945), 1,
      sym__preprocessor_call,
    STATE(6206), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208551] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(7591), 1,
      anon_sym_QMARK,
    ACTIONS(7983), 1,
      anon_sym_DOT,
    STATE(4946), 1,
      sym__preprocessor_call,
    ACTIONS(2894), 2,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(2892), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208602] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2003), 1,
      sym__simple_name,
    STATE(4947), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208657] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2064), 1,
      sym_identifier,
    STATE(2139), 1,
      sym__simple_name,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(4948), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208712] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2031), 1,
      sym__simple_name,
    STATE(4949), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208767] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(643), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(2029), 1,
      sym__simple_name,
    STATE(4950), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208822] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(803), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2105), 1,
      sym__simple_name,
    STATE(4463), 1,
      sym_identifier,
    STATE(4951), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208877] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(867), 1,
      sym__identifier_token,
    ACTIONS(871), 1,
      anon_sym_global,
    STATE(2059), 1,
      sym__contextual_keywords,
    STATE(2064), 1,
      sym_identifier,
    STATE(2083), 1,
      sym__simple_name,
    STATE(4952), 1,
      sym__preprocessor_call,
    STATE(2096), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(869), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208932] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7950), 1,
      sym__identifier_token,
    ACTIONS(7954), 1,
      anon_sym_global,
    STATE(1776), 1,
      sym_identifier,
    STATE(1911), 1,
      sym__contextual_keywords,
    STATE(1963), 1,
      sym__simple_name,
    STATE(4953), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(7952), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [208987] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(1657), 1,
      anon_sym_global,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(1776), 1,
      sym_identifier,
    STATE(1781), 1,
      sym__simple_name,
    STATE(4954), 1,
      sym__preprocessor_call,
    STATE(1784), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(13), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209042] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(803), 1,
      anon_sym_global,
    ACTIONS(949), 1,
      sym__identifier_token,
    STATE(2091), 1,
      sym__contextual_keywords,
    STATE(2276), 1,
      sym__simple_name,
    STATE(4463), 1,
      sym_identifier,
    STATE(4955), 1,
      sym__preprocessor_call,
    STATE(2856), 2,
      sym_generic_name,
      sym_global,
    ACTIONS(951), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209097] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4956), 1,
      sym__preprocessor_call,
    STATE(6758), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209147] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4957), 1,
      sym__preprocessor_call,
    STATE(6889), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209197] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2673), 1,
      anon_sym_LBRACK,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7985), 1,
      anon_sym_class,
    ACTIONS(7987), 1,
      anon_sym_struct,
    ACTIONS(7989), 1,
      anon_sym_enum,
    ACTIONS(7991), 1,
      anon_sym_interface,
    ACTIONS(7993), 1,
      anon_sym_delegate,
    ACTIONS(7995), 1,
      anon_sym_record,
    STATE(2628), 1,
      aux_sym_event_field_declaration_repeat1,
    STATE(2669), 1,
      sym_attribute_list,
    STATE(2909), 1,
      sym_modifier,
    STATE(4958), 1,
      sym__preprocessor_call,
    STATE(5428), 1,
      aux_sym_event_field_declaration_repeat2,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [209263] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4959), 1,
      sym__preprocessor_call,
    STATE(6783), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209313] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4960), 1,
      sym__preprocessor_call,
    STATE(6720), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209363] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4961), 1,
      sym__preprocessor_call,
    STATE(6732), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209413] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4962), 1,
      sym__preprocessor_call,
    STATE(6675), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209463] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4963), 1,
      sym__preprocessor_call,
    STATE(6631), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4964), 1,
      sym__preprocessor_call,
    STATE(6748), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209563] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4965), 1,
      sym__preprocessor_call,
    STATE(6662), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4966), 1,
      sym__preprocessor_call,
    STATE(6636), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209663] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4967), 1,
      sym__preprocessor_call,
    STATE(6890), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209713] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4968), 1,
      sym__preprocessor_call,
    STATE(6388), 1,
      sym_identifier,
    ACTIONS(2894), 2,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209763] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4969), 1,
      sym__preprocessor_call,
    STATE(6840), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209813] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4970), 1,
      sym__preprocessor_call,
    STATE(6716), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209863] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4971), 1,
      sym__preprocessor_call,
    STATE(6870), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209913] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4972), 1,
      sym__preprocessor_call,
    STATE(6687), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [209963] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4973), 1,
      sym__preprocessor_call,
    STATE(6756), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210013] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4974), 1,
      sym__preprocessor_call,
    STATE(6774), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210063] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4975), 1,
      sym__preprocessor_call,
    STATE(6682), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210113] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4976), 1,
      sym__preprocessor_call,
    STATE(6878), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210163] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4977), 1,
      sym__preprocessor_call,
    STATE(6705), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210213] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4978), 1,
      sym__preprocessor_call,
    STATE(6717), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210263] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4979), 1,
      sym__preprocessor_call,
    STATE(6958), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210313] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4980), 1,
      sym__preprocessor_call,
    STATE(6625), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210363] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4981), 1,
      sym__preprocessor_call,
    STATE(6658), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210413] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4982), 1,
      sym__preprocessor_call,
    STATE(6771), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210463] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4983), 1,
      sym__preprocessor_call,
    STATE(6665), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210513] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4984), 1,
      sym__preprocessor_call,
    STATE(6702), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210563] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4985), 1,
      sym__preprocessor_call,
    STATE(6919), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210613] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4986), 1,
      sym__preprocessor_call,
    STATE(6923), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210663] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4987), 1,
      sym__preprocessor_call,
    STATE(6862), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210713] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4988), 1,
      sym__preprocessor_call,
    STATE(6795), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210763] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4989), 1,
      sym__preprocessor_call,
    STATE(6753), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210813] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4990), 1,
      sym__preprocessor_call,
    STATE(6841), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210863] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4991), 1,
      sym__preprocessor_call,
    STATE(6843), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210913] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4992), 1,
      sym__preprocessor_call,
    STATE(6865), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [210963] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7997), 1,
      anon_sym_case,
    ACTIONS(7999), 1,
      anon_sym_default,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4993), 1,
      sym__preprocessor_call,
    STATE(6728), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211015] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7691), 1,
      sym__identifier_token,
    ACTIONS(8001), 1,
      sym_preproc_integer_literal,
    ACTIONS(8003), 1,
      sym__preproc_directive_end,
    STATE(4994), 1,
      sym__preprocessor_call,
    STATE(5890), 1,
      sym__contextual_keywords,
    STATE(6378), 1,
      sym_identifier,
    ACTIONS(7693), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211067] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4995), 1,
      sym__preprocessor_call,
    STATE(6875), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211117] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4996), 1,
      sym__preprocessor_call,
    STATE(6656), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211167] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4997), 1,
      sym__preprocessor_call,
    STATE(6742), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4998), 1,
      sym__preprocessor_call,
    STATE(6761), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211267] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(4999), 1,
      sym__preprocessor_call,
    STATE(6669), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211317] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5000), 1,
      sym__preprocessor_call,
    STATE(6633), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211367] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5001), 1,
      sym__preprocessor_call,
    STATE(6811), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211417] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5002), 1,
      sym__preprocessor_call,
    STATE(6929), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211467] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5003), 1,
      sym__preprocessor_call,
    STATE(6769), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211517] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5004), 1,
      sym__preprocessor_call,
    STATE(6881), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211567] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5005), 1,
      sym__preprocessor_call,
    STATE(6683), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211617] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5006), 1,
      sym__preprocessor_call,
    STATE(6757), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211667] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5007), 1,
      sym__preprocessor_call,
    STATE(6648), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211717] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5008), 1,
      sym__preprocessor_call,
    STATE(6689), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211767] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5009), 1,
      sym__preprocessor_call,
    STATE(6897), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211817] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5010), 1,
      sym__preprocessor_call,
    STATE(6940), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211867] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5011), 1,
      sym__preprocessor_call,
    STATE(6893), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211917] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5012), 1,
      sym__preprocessor_call,
    STATE(6823), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [211967] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5013), 1,
      sym__preprocessor_call,
    STATE(6626), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212017] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5014), 1,
      sym__preprocessor_call,
    STATE(6932), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212067] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5015), 1,
      sym__preprocessor_call,
    STATE(6701), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212117] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5016), 1,
      sym__preprocessor_call,
    STATE(6782), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212167] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5017), 1,
      sym__preprocessor_call,
    STATE(6651), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212217] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5018), 1,
      sym__preprocessor_call,
    STATE(6739), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212267] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5019), 1,
      sym__preprocessor_call,
    STATE(6888), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212317] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5020), 1,
      sym__preprocessor_call,
    STATE(6779), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212367] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5021), 1,
      sym__preprocessor_call,
    STATE(6894), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212417] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5022), 1,
      sym__preprocessor_call,
    STATE(6686), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212467] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5023), 1,
      sym__preprocessor_call,
    STATE(6258), 1,
      sym_identifier,
    ACTIONS(2894), 2,
      anon_sym_LBRACK,
      anon_sym_STAR,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212517] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5024), 1,
      sym__preprocessor_call,
    STATE(6657), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212567] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5025), 1,
      sym__preprocessor_call,
    STATE(6892), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212617] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5026), 1,
      sym__preprocessor_call,
    STATE(6740), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212667] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5027), 1,
      sym__preprocessor_call,
    STATE(6752), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212717] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5028), 1,
      sym__preprocessor_call,
    STATE(6896), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212767] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5029), 1,
      sym__preprocessor_call,
    STATE(6680), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212817] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5030), 1,
      sym__preprocessor_call,
    STATE(6766), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212867] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5031), 1,
      sym__preprocessor_call,
    STATE(6762), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212917] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5032), 1,
      sym__preprocessor_call,
    STATE(6788), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [212967] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5033), 1,
      sym__preprocessor_call,
    STATE(6854), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [213017] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(8005), 1,
      anon_sym_case,
    ACTIONS(8007), 1,
      anon_sym_default,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5034), 1,
      sym__preprocessor_call,
    STATE(6933), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [213069] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5035), 1,
      sym__preprocessor_call,
    STATE(6773), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [213119] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5036), 1,
      sym__preprocessor_call,
    STATE(6871), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [213169] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5037), 1,
      sym__preprocessor_call,
    STATE(6951), 2,
      sym_parameter_list,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [213219] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8009), 1,
      anon_sym_SEMI,
    STATE(5038), 1,
      sym__preprocessor_call,
    ACTIONS(3668), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8011), 1,
      anon_sym_SEMI,
    STATE(5039), 1,
      sym__preprocessor_call,
    ACTIONS(3590), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213305] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8013), 1,
      anon_sym_SEMI,
    STATE(5040), 1,
      sym__preprocessor_call,
    ACTIONS(3964), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213348] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8015), 1,
      anon_sym_SEMI,
    STATE(5041), 1,
      sym__preprocessor_call,
    ACTIONS(3646), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8017), 1,
      anon_sym_SEMI,
    STATE(5042), 1,
      sym__preprocessor_call,
    ACTIONS(3680), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213434] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8019), 1,
      anon_sym_SEMI,
    STATE(5043), 1,
      sym__preprocessor_call,
    ACTIONS(3618), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8021), 1,
      anon_sym_SEMI,
    STATE(5044), 1,
      sym__preprocessor_call,
    ACTIONS(3634), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8023), 1,
      anon_sym_SEMI,
    STATE(5045), 1,
      sym__preprocessor_call,
    ACTIONS(3726), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8025), 1,
      anon_sym_SEMI,
    STATE(5046), 1,
      sym__preprocessor_call,
    ACTIONS(3924), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213606] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8027), 1,
      anon_sym_SEMI,
    STATE(5047), 1,
      sym__preprocessor_call,
    ACTIONS(3640), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8029), 1,
      anon_sym_SEMI,
    STATE(5048), 1,
      sym__preprocessor_call,
    ACTIONS(3912), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213692] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8031), 1,
      anon_sym_SEMI,
    STATE(5049), 1,
      sym__preprocessor_call,
    ACTIONS(3692), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213735] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8033), 1,
      anon_sym_SEMI,
    STATE(5050), 1,
      sym__preprocessor_call,
    ACTIONS(3906), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213778] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8035), 1,
      anon_sym_SEMI,
    STATE(5051), 1,
      sym__preprocessor_call,
    ACTIONS(3768), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213821] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8037), 1,
      anon_sym_SEMI,
    STATE(5052), 1,
      sym__preprocessor_call,
    ACTIONS(4078), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213864] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8039), 1,
      anon_sym_SEMI,
    STATE(5053), 1,
      sym__preprocessor_call,
    ACTIONS(3624), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213907] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8041), 1,
      anon_sym_SEMI,
    STATE(5054), 1,
      sym__preprocessor_call,
    ACTIONS(3900), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213950] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8043), 1,
      anon_sym_SEMI,
    STATE(5055), 1,
      sym__preprocessor_call,
    ACTIONS(4030), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [213993] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8045), 1,
      anon_sym_SEMI,
    STATE(5056), 1,
      sym__preprocessor_call,
    ACTIONS(4024), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214036] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8047), 1,
      anon_sym_SEMI,
    STATE(5057), 1,
      sym__preprocessor_call,
    ACTIONS(3894), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214079] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8049), 1,
      anon_sym_SEMI,
    STATE(5058), 1,
      sym__preprocessor_call,
    ACTIONS(3958), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8051), 1,
      anon_sym_SEMI,
    STATE(5059), 1,
      sym__preprocessor_call,
    ACTIONS(3798), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214165] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8053), 1,
      anon_sym_SEMI,
    STATE(5060), 1,
      sym__preprocessor_call,
    ACTIONS(3888), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214208] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8055), 1,
      anon_sym_SEMI,
    STATE(5061), 1,
      sym__preprocessor_call,
    ACTIONS(4006), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214251] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8057), 1,
      anon_sym_SEMI,
    STATE(5062), 1,
      sym__preprocessor_call,
    ACTIONS(4000), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214294] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8059), 1,
      anon_sym_SEMI,
    STATE(5063), 1,
      sym__preprocessor_call,
    ACTIONS(4018), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8061), 1,
      anon_sym_SEMI,
    STATE(5064), 1,
      sym__preprocessor_call,
    ACTIONS(3988), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5065), 1,
      sym__preprocessor_call,
    ACTIONS(3882), 29,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_SEMI,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214421] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(7956), 1,
      anon_sym_global,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5066), 1,
      sym__preprocessor_call,
    STATE(6915), 2,
      sym_identifier,
      sym_global,
    ACTIONS(2778), 24,
      anon_sym_alias,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [214470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8063), 1,
      anon_sym_SEMI,
    STATE(5067), 1,
      sym__preprocessor_call,
    ACTIONS(3704), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214513] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8065), 1,
      anon_sym_SEMI,
    STATE(5068), 1,
      sym__preprocessor_call,
    ACTIONS(3878), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214556] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(8067), 1,
      anon_sym_struct,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5069), 1,
      sym__preprocessor_call,
    STATE(5549), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [214605] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5070), 1,
      sym__preprocessor_call,
    ACTIONS(3650), 29,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_SEMI,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5071), 1,
      sym__preprocessor_call,
    ACTIONS(3628), 29,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_SEMI,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214687] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(8069), 1,
      anon_sym_struct,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5072), 1,
      sym__preprocessor_call,
    STATE(5544), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [214736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8071), 1,
      anon_sym_SEMI,
    STATE(5073), 1,
      sym__preprocessor_call,
    ACTIONS(3804), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214779] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(8073), 1,
      anon_sym_struct,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5074), 1,
      sym__preprocessor_call,
    STATE(5545), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [214828] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(8075), 1,
      anon_sym_this,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5075), 1,
      sym__preprocessor_call,
    STATE(5700), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [214877] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8077), 1,
      anon_sym_SEMI,
    STATE(5076), 1,
      sym__preprocessor_call,
    ACTIONS(3810), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214920] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8079), 1,
      anon_sym_SEMI,
    STATE(5077), 1,
      sym__preprocessor_call,
    ACTIONS(3716), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [214963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8081), 1,
      anon_sym_SEMI,
    STATE(5078), 1,
      sym__preprocessor_call,
    ACTIONS(3860), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215006] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8083), 1,
      anon_sym_SEMI,
    STATE(5079), 1,
      sym__preprocessor_call,
    ACTIONS(3836), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215049] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(8085), 1,
      anon_sym_struct,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5080), 1,
      sym__preprocessor_call,
    STATE(5547), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [215098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8087), 1,
      anon_sym_SEMI,
    STATE(5081), 1,
      sym__preprocessor_call,
    ACTIONS(3738), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8089), 1,
      anon_sym_SEMI,
    STATE(5082), 1,
      sym__preprocessor_call,
    ACTIONS(3830), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8091), 1,
      anon_sym_SEMI,
    STATE(5083), 1,
      sym__preprocessor_call,
    ACTIONS(3750), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215227] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8093), 1,
      anon_sym_SEMI,
    STATE(5084), 1,
      sym__preprocessor_call,
    ACTIONS(3762), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215270] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5293), 1,
      anon_sym_LBRACK,
    STATE(5085), 1,
      sym__preprocessor_call,
    ACTIONS(5291), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_out,
      anon_sym_in,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [215313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8095), 1,
      anon_sym_SEMI,
    STATE(5086), 1,
      sym__preprocessor_call,
    ACTIONS(4048), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215356] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8097), 1,
      anon_sym_SEMI,
    STATE(5087), 1,
      sym__preprocessor_call,
    ACTIONS(3774), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8099), 1,
      anon_sym_SEMI,
    STATE(5088), 1,
      sym__preprocessor_call,
    ACTIONS(3970), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8101), 1,
      anon_sym_SEMI,
    STATE(5089), 1,
      sym__preprocessor_call,
    ACTIONS(4054), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215485] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8103), 1,
      anon_sym_SEMI,
    STATE(5090), 1,
      sym__preprocessor_call,
    ACTIONS(3952), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215528] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8105), 1,
      anon_sym_SEMI,
    STATE(5091), 1,
      sym__preprocessor_call,
    ACTIONS(3780), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8107), 1,
      anon_sym_SEMI,
    STATE(5092), 1,
      sym__preprocessor_call,
    ACTIONS(3982), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215614] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(8109), 1,
      anon_sym_this,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5093), 1,
      sym__preprocessor_call,
    STATE(5703), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [215663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8111), 1,
      anon_sym_SEMI,
    STATE(5094), 1,
      sym__preprocessor_call,
    ACTIONS(3786), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215706] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8113), 1,
      anon_sym_SEMI,
    STATE(5095), 1,
      sym__preprocessor_call,
    ACTIONS(3792), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215749] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8115), 1,
      anon_sym_SEMI,
    STATE(5096), 1,
      sym__preprocessor_call,
    ACTIONS(3756), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215792] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8117), 1,
      anon_sym_SEMI,
    STATE(5097), 1,
      sym__preprocessor_call,
    ACTIONS(3744), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215835] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8119), 1,
      anon_sym_SEMI,
    STATE(5098), 1,
      sym__preprocessor_call,
    ACTIONS(3732), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215878] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7691), 1,
      sym__identifier_token,
    ACTIONS(8121), 1,
      sym_preproc_integer_literal,
    STATE(5099), 1,
      sym__preprocessor_call,
    STATE(5890), 1,
      sym__contextual_keywords,
    STATE(6605), 1,
      sym_identifier,
    ACTIONS(7693), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [215927] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8123), 1,
      anon_sym_SEMI,
    STATE(5100), 1,
      sym__preprocessor_call,
    ACTIONS(3994), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [215970] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5101), 1,
      sym__preprocessor_call,
    STATE(5719), 1,
      sym_identifier,
    STATE(6099), 1,
      sym_primary_constructor_base_type,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [216019] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8125), 1,
      anon_sym_SEMI,
    STATE(5102), 1,
      sym__preprocessor_call,
    ACTIONS(4012), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5276), 1,
      anon_sym_LBRACK,
    STATE(5103), 1,
      sym__preprocessor_call,
    ACTIONS(5274), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_out,
      anon_sym_in,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [216105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8127), 1,
      anon_sym_SEMI,
    STATE(5104), 1,
      sym__preprocessor_call,
    ACTIONS(4060), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216148] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(8129), 1,
      anon_sym_struct,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5105), 1,
      sym__preprocessor_call,
    STATE(5542), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [216197] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8131), 1,
      anon_sym_SEMI,
    STATE(5106), 1,
      sym__preprocessor_call,
    ACTIONS(3940), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216240] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8133), 1,
      anon_sym_SEMI,
    STATE(5107), 1,
      sym__preprocessor_call,
    ACTIONS(4066), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8135), 1,
      anon_sym_SEMI,
    STATE(5108), 1,
      sym__preprocessor_call,
    ACTIONS(3976), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5109), 1,
      sym__preprocessor_call,
    ACTIONS(3720), 29,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_SEMI,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216367] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8137), 1,
      anon_sym_SEMI,
    STATE(5110), 1,
      sym__preprocessor_call,
    ACTIONS(3612), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216410] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5299), 1,
      anon_sym_LBRACK,
    STATE(5111), 1,
      sym__preprocessor_call,
    ACTIONS(5297), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_out,
      anon_sym_in,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [216453] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5317), 1,
      anon_sym_LBRACK,
    STATE(5112), 1,
      sym__preprocessor_call,
    ACTIONS(5315), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_out,
      anon_sym_in,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [216496] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8139), 1,
      anon_sym_SEMI,
    STATE(5113), 1,
      sym__preprocessor_call,
    ACTIONS(3934), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216539] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5114), 1,
      sym__preprocessor_call,
    ACTIONS(3928), 29,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_SEMI,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216580] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8141), 1,
      anon_sym_SEMI,
    STATE(5115), 1,
      sym__preprocessor_call,
    ACTIONS(4072), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8143), 1,
      anon_sym_SEMI,
    STATE(5116), 1,
      sym__preprocessor_call,
    ACTIONS(3554), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216666] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8145), 1,
      anon_sym_SEMI,
    STATE(5117), 1,
      sym__preprocessor_call,
    ACTIONS(3606), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5343), 1,
      anon_sym_LBRACK,
    STATE(5118), 1,
      sym__preprocessor_call,
    ACTIONS(5341), 28,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_out,
      anon_sym_in,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [216752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8147), 1,
      anon_sym_SEMI,
    STATE(5119), 1,
      sym__preprocessor_call,
    ACTIONS(3600), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8149), 1,
      anon_sym_SEMI,
    STATE(5120), 1,
      sym__preprocessor_call,
    ACTIONS(3710), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216838] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    ACTIONS(8151), 1,
      anon_sym_this,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5121), 1,
      sym__preprocessor_call,
    STATE(5699), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [216887] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8153), 1,
      anon_sym_SEMI,
    STATE(5122), 1,
      sym__preprocessor_call,
    ACTIONS(3566), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216930] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8155), 1,
      anon_sym_SEMI,
    STATE(5123), 1,
      sym__preprocessor_call,
    ACTIONS(3560), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [216973] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8157), 1,
      anon_sym_SEMI,
    STATE(5124), 1,
      sym__preprocessor_call,
    ACTIONS(3842), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217016] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8159), 1,
      anon_sym_SEMI,
    STATE(5125), 1,
      sym__preprocessor_call,
    ACTIONS(3572), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8161), 1,
      anon_sym_SEMI,
    STATE(5126), 1,
      sym__preprocessor_call,
    ACTIONS(3698), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217102] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8163), 1,
      anon_sym_SEMI,
    STATE(5127), 1,
      sym__preprocessor_call,
    ACTIONS(3848), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8165), 1,
      anon_sym_SEMI,
    STATE(5128), 1,
      sym__preprocessor_call,
    ACTIONS(3854), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217188] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8167), 1,
      anon_sym_SEMI,
    STATE(5129), 1,
      sym__preprocessor_call,
    ACTIONS(3584), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217231] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8169), 1,
      anon_sym_SEMI,
    STATE(5130), 1,
      sym__preprocessor_call,
    ACTIONS(3686), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217274] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8171), 1,
      anon_sym_SEMI,
    STATE(5131), 1,
      sym__preprocessor_call,
    ACTIONS(3674), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8173), 1,
      anon_sym_SEMI,
    STATE(5132), 1,
      sym__preprocessor_call,
    ACTIONS(3866), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217360] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8175), 1,
      anon_sym_SEMI,
    STATE(5133), 1,
      sym__preprocessor_call,
    ACTIONS(3662), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8177), 1,
      anon_sym_SEMI,
    STATE(5134), 1,
      sym__preprocessor_call,
    ACTIONS(3872), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217446] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8179), 1,
      anon_sym_SEMI,
    STATE(5135), 1,
      sym__preprocessor_call,
    ACTIONS(4088), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217489] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5136), 1,
      sym__preprocessor_call,
    ACTIONS(4082), 29,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_SEMI,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217530] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5137), 1,
      sym__preprocessor_call,
    STATE(6521), 1,
      sym_simple_assignment_expression,
    STATE(6709), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [217579] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    ACTIONS(8181), 1,
      anon_sym_struct,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5138), 1,
      sym__preprocessor_call,
    STATE(5550), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [217628] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8183), 1,
      anon_sym_SEMI,
    STATE(5139), 1,
      sym__preprocessor_call,
    ACTIONS(3918), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8185), 1,
      anon_sym_SEMI,
    STATE(5140), 1,
      sym__preprocessor_call,
    ACTIONS(3656), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5141), 1,
      sym__preprocessor_call,
    ACTIONS(4414), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5142), 1,
      sym__preprocessor_call,
    ACTIONS(5008), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5143), 1,
      sym__preprocessor_call,
    ACTIONS(4596), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5144), 1,
      sym__preprocessor_call,
    ACTIONS(4600), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5145), 1,
      sym__preprocessor_call,
    ACTIONS(4130), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217914] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5146), 1,
      sym__preprocessor_call,
    ACTIONS(4098), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5147), 1,
      sym__preprocessor_call,
    ACTIONS(4604), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [217994] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5148), 1,
      sym__preprocessor_call,
    ACTIONS(4668), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5149), 1,
      sym__preprocessor_call,
    ACTIONS(4118), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218074] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5150), 1,
      sym__preprocessor_call,
    ACTIONS(4114), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218114] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2663), 1,
      sym__identifier_token,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(5151), 1,
      sym__preprocessor_call,
    STATE(6603), 1,
      sym_identifier,
    ACTIONS(2667), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [218160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5152), 1,
      sym__preprocessor_call,
    ACTIONS(4676), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5153), 1,
      sym__preprocessor_call,
    ACTIONS(4680), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5154), 1,
      sym__preprocessor_call,
    ACTIONS(4110), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218280] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5155), 1,
      sym__preprocessor_call,
    ACTIONS(4684), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218320] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5156), 1,
      sym__preprocessor_call,
    STATE(5610), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [218366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5157), 1,
      sym__preprocessor_call,
    STATE(6157), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [218412] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5158), 1,
      sym__preprocessor_call,
    STATE(5616), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [218458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5159), 1,
      sym__preprocessor_call,
    ACTIONS(4692), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218498] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5160), 1,
      sym__preprocessor_call,
    ACTIONS(4696), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218538] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5161), 1,
      sym__preprocessor_call,
    ACTIONS(4700), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218578] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5162), 1,
      sym__preprocessor_call,
    ACTIONS(4708), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5163), 1,
      sym__preprocessor_call,
    ACTIONS(4712), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218658] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5164), 1,
      sym__preprocessor_call,
    STATE(6610), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [218704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5165), 1,
      sym__preprocessor_call,
    ACTIONS(4716), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218744] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5166), 1,
      sym__preprocessor_call,
    STATE(6107), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [218790] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5167), 1,
      sym__preprocessor_call,
    STATE(6160), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [218836] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5168), 1,
      sym__preprocessor_call,
    STATE(5620), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [218882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5169), 1,
      sym__preprocessor_call,
    ACTIONS(4720), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5170), 1,
      sym__preprocessor_call,
    ACTIONS(4222), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [218962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5171), 1,
      sym__preprocessor_call,
    ACTIONS(4724), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5172), 1,
      sym__preprocessor_call,
    ACTIONS(4146), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5173), 1,
      sym__preprocessor_call,
    ACTIONS(4732), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219082] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5174), 1,
      sym__preprocessor_call,
    STATE(5435), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [219128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5175), 1,
      sym__preprocessor_call,
    ACTIONS(4740), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5176), 1,
      sym__preprocessor_call,
    ACTIONS(4150), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219208] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5177), 1,
      sym__preprocessor_call,
    STATE(5469), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [219254] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5178), 1,
      sym__preprocessor_call,
    ACTIONS(4748), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5179), 1,
      sym__preprocessor_call,
    ACTIONS(4158), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5180), 1,
      sym__preprocessor_call,
    ACTIONS(4162), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5181), 1,
      sym__preprocessor_call,
    ACTIONS(4756), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5182), 1,
      sym__preprocessor_call,
    ACTIONS(4760), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5183), 1,
      sym__preprocessor_call,
    ACTIONS(4166), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5184), 1,
      sym__preprocessor_call,
    STATE(6111), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [219540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5185), 1,
      sym__preprocessor_call,
    ACTIONS(4764), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5186), 1,
      sym__preprocessor_call,
    ACTIONS(4174), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5187), 1,
      sym__preprocessor_call,
    ACTIONS(4768), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219660] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5188), 1,
      sym__preprocessor_call,
    ACTIONS(4518), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5189), 1,
      sym__preprocessor_call,
    ACTIONS(4182), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219740] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5190), 1,
      sym__preprocessor_call,
    ACTIONS(4514), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5191), 1,
      sym__preprocessor_call,
    ACTIONS(4190), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5192), 1,
      sym__preprocessor_call,
    ACTIONS(4776), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5193), 1,
      sym__preprocessor_call,
    ACTIONS(4672), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5194), 1,
      sym__preprocessor_call,
    ACTIONS(4780), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219940] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5195), 1,
      sym__preprocessor_call,
    ACTIONS(4198), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [219980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5196), 1,
      sym__preprocessor_call,
    ACTIONS(4202), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220020] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5197), 1,
      sym__preprocessor_call,
    ACTIONS(4788), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5198), 1,
      sym__preprocessor_call,
    ACTIONS(4796), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220100] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5199), 1,
      sym__preprocessor_call,
    ACTIONS(4804), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5200), 1,
      sym__preprocessor_call,
    ACTIONS(4206), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5201), 1,
      sym__preprocessor_call,
    ACTIONS(4812), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220220] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5202), 1,
      sym__preprocessor_call,
    ACTIONS(4820), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5203), 1,
      sym__preprocessor_call,
    ACTIONS(4828), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5204), 1,
      sym__preprocessor_call,
    ACTIONS(4832), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5205), 1,
      sym__preprocessor_call,
    ACTIONS(4506), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5206), 1,
      sym__preprocessor_call,
    ACTIONS(4840), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5207), 1,
      sym__preprocessor_call,
    ACTIONS(4210), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220460] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5208), 1,
      sym__preprocessor_call,
    ACTIONS(4848), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5209), 1,
      sym__preprocessor_call,
    ACTIONS(4856), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5210), 1,
      sym__preprocessor_call,
    ACTIONS(4860), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5211), 1,
      sym__preprocessor_call,
    ACTIONS(4218), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220620] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5212), 1,
      sym__preprocessor_call,
    STATE(6299), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [220666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5213), 1,
      sym__preprocessor_call,
    ACTIONS(4302), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5214), 1,
      sym__preprocessor_call,
    ACTIONS(4908), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5215), 1,
      sym__preprocessor_call,
    ACTIONS(4502), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220786] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5216), 1,
      sym__preprocessor_call,
    STATE(6552), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [220832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5217), 1,
      sym__preprocessor_call,
    STATE(6218), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [220878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5218), 1,
      sym__preprocessor_call,
    ACTIONS(4498), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5219), 1,
      sym__preprocessor_call,
    ACTIONS(4896), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [220958] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5220), 1,
      sym__preprocessor_call,
    STATE(6171), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [221004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5221), 1,
      sym__preprocessor_call,
    ACTIONS(4868), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5222), 1,
      sym__preprocessor_call,
    ACTIONS(4494), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221084] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5223), 1,
      sym__preprocessor_call,
    STATE(6122), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [221130] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2663), 1,
      sym__identifier_token,
    STATE(3931), 1,
      sym__contextual_keywords,
    STATE(5224), 1,
      sym__preprocessor_call,
    STATE(6486), 1,
      sym_identifier,
    ACTIONS(2667), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [221176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5225), 1,
      sym__preprocessor_call,
    ACTIONS(4824), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5226), 1,
      sym__preprocessor_call,
    ACTIONS(4286), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5227), 1,
      sym__preprocessor_call,
    ACTIONS(4884), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221296] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5228), 1,
      sym__preprocessor_call,
    STATE(6714), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [221342] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5229), 1,
      sym__preprocessor_call,
    STATE(6149), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [221388] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5230), 1,
      sym__preprocessor_call,
    ACTIONS(4486), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5231), 1,
      sym__preprocessor_call,
    ACTIONS(4892), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5232), 1,
      sym__preprocessor_call,
    ACTIONS(4800), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5233), 1,
      sym__preprocessor_call,
    ACTIONS(4294), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221548] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5234), 1,
      sym__preprocessor_call,
    STATE(6191), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [221594] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5235), 1,
      sym__preprocessor_call,
    ACTIONS(4900), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221634] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5236), 1,
      sym__preprocessor_call,
    ACTIONS(4888), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5237), 1,
      sym__preprocessor_call,
    ACTIONS(5184), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221714] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5238), 1,
      sym__preprocessor_call,
    ACTIONS(4904), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5239), 1,
      sym__preprocessor_call,
    ACTIONS(4482), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5240), 1,
      sym__preprocessor_call,
    ACTIONS(4310), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5241), 1,
      sym__preprocessor_call,
    ACTIONS(4326), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5242), 1,
      sym__preprocessor_call,
    ACTIONS(4330), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [221914] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5243), 1,
      sym__preprocessor_call,
    STATE(5875), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [221960] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5244), 1,
      sym__preprocessor_call,
    STATE(5457), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [222006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5245), 1,
      sym__preprocessor_call,
    ACTIONS(4334), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5246), 1,
      sym__preprocessor_call,
    ACTIONS(4474), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5247), 1,
      sym__preprocessor_call,
    ACTIONS(4342), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5248), 1,
      sym__preprocessor_call,
    ACTIONS(4470), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5249), 1,
      sym__preprocessor_call,
    ACTIONS(4912), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5250), 1,
      sym__preprocessor_call,
    ACTIONS(4350), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5251), 1,
      sym__preprocessor_call,
    ACTIONS(4354), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5252), 1,
      sym__preprocessor_call,
    ACTIONS(4920), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5253), 1,
      sym__preprocessor_call,
    ACTIONS(4880), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5254), 1,
      sym__preprocessor_call,
    STATE(6615), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [222412] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5255), 1,
      sym__preprocessor_call,
    STATE(5546), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [222458] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5256), 1,
      sym__preprocessor_call,
    STATE(5502), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [222504] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5257), 1,
      sym__preprocessor_call,
    ACTIONS(4362), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222544] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5258), 1,
      sym__preprocessor_call,
    ACTIONS(4928), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222584] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5259), 1,
      sym__preprocessor_call,
    STATE(5447), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [222630] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5260), 1,
      sym__preprocessor_call,
    ACTIONS(4318), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5261), 1,
      sym__preprocessor_call,
    ACTIONS(4378), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222710] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5262), 1,
      sym__preprocessor_call,
    ACTIONS(4386), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222750] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5263), 1,
      sym__preprocessor_call,
    STATE(6206), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [222796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5264), 1,
      sym__preprocessor_call,
    ACTIONS(4936), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222836] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5265), 1,
      sym__preprocessor_call,
    STATE(5450), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [222882] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5266), 1,
      sym__preprocessor_call,
    STATE(6399), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [222928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5267), 1,
      sym__preprocessor_call,
    ACTIONS(4940), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [222968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5268), 1,
      sym__preprocessor_call,
    ACTIONS(4398), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5269), 1,
      sym__preprocessor_call,
    ACTIONS(4450), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5270), 1,
      sym__preprocessor_call,
    ACTIONS(4402), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5271), 1,
      sym__preprocessor_call,
    ACTIONS(4406), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5272), 1,
      sym__preprocessor_call,
    ACTIONS(5172), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5273), 1,
      sym__preprocessor_call,
    ACTIONS(4588), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5274), 1,
      sym__preprocessor_call,
    ACTIONS(5168), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5275), 1,
      sym__preprocessor_call,
    ACTIONS(5164), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223288] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5276), 1,
      sym__preprocessor_call,
    STATE(5453), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [223334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5277), 1,
      sym__preprocessor_call,
    ACTIONS(4876), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5278), 1,
      sym__preprocessor_call,
    ACTIONS(4422), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5279), 1,
      sym__preprocessor_call,
    ACTIONS(4426), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223454] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5280), 1,
      sym__preprocessor_call,
    STATE(5440), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [223500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5281), 1,
      sym__preprocessor_call,
    ACTIONS(4394), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5282), 1,
      sym__preprocessor_call,
    ACTIONS(4872), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5283), 1,
      sym__preprocessor_call,
    ACTIONS(4490), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223620] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5284), 1,
      sym__preprocessor_call,
    ACTIONS(5160), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223660] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5285), 1,
      sym__preprocessor_call,
    STATE(5642), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [223706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5286), 1,
      sym__preprocessor_call,
    ACTIONS(4852), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223746] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5287), 1,
      sym__preprocessor_call,
    STATE(5552), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [223792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5288), 1,
      sym__preprocessor_call,
    ACTIONS(5156), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5289), 1,
      sym__preprocessor_call,
    STATE(5695), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [223878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5290), 1,
      sym__preprocessor_call,
    ACTIONS(5152), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5291), 1,
      sym__preprocessor_call,
    ACTIONS(4580), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [223958] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5292), 1,
      sym__preprocessor_call,
    STATE(6208), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5293), 1,
      sym__preprocessor_call,
    ACTIONS(5148), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224044] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5294), 1,
      sym__preprocessor_call,
    STATE(5629), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5295), 1,
      sym__preprocessor_call,
    ACTIONS(4466), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224130] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5296), 1,
      sym__preprocessor_call,
    STATE(5595), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224176] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5297), 1,
      sym__preprocessor_call,
    ACTIONS(4478), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224216] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5298), 1,
      sym__preprocessor_call,
    STATE(5439), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5299), 1,
      sym__preprocessor_call,
    ACTIONS(4816), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224302] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5300), 1,
      sym__preprocessor_call,
    STATE(5641), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224348] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5301), 1,
      sym__preprocessor_call,
    STATE(6142), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5302), 1,
      sym__preprocessor_call,
    ACTIONS(5144), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224434] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5303), 1,
      sym__preprocessor_call,
    ACTIONS(4808), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5304), 1,
      sym__preprocessor_call,
    ACTIONS(5140), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5305), 1,
      sym__preprocessor_call,
    ACTIONS(4510), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5306), 1,
      sym__preprocessor_call,
    ACTIONS(4522), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224594] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5307), 1,
      sym__preprocessor_call,
    STATE(5636), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224640] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5308), 1,
      sym__preprocessor_call,
    STATE(5465), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224686] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5309), 1,
      sym__preprocessor_call,
    STATE(5543), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224732] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5310), 1,
      sym__preprocessor_call,
    STATE(5476), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5311), 1,
      sym__preprocessor_call,
    ACTIONS(4540), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224818] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5312), 1,
      sym__preprocessor_call,
    ACTIONS(4462), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224858] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5313), 1,
      sym__preprocessor_call,
    STATE(6109), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224904] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5314), 1,
      sym__preprocessor_call,
    STATE(5548), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [224950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5315), 1,
      sym__preprocessor_call,
    ACTIONS(4548), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [224990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5316), 1,
      sym__preprocessor_call,
    ACTIONS(4556), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [225030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5317), 1,
      sym__preprocessor_call,
    ACTIONS(4584), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [225070] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5318), 1,
      sym__preprocessor_call,
    STATE(6365), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225116] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5319), 1,
      sym__preprocessor_call,
    STATE(6156), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225162] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5320), 1,
      sym__preprocessor_call,
    STATE(5488), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225208] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5321), 1,
      sym__preprocessor_call,
    STATE(5551), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225254] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5322), 1,
      sym__preprocessor_call,
    STATE(6217), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5323), 1,
      sym__preprocessor_call,
    ACTIONS(4246), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [225340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5324), 1,
      sym__preprocessor_call,
    ACTIONS(4454), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [225380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5325), 1,
      sym__preprocessor_call,
    ACTIONS(4122), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [225420] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5326), 1,
      sym__preprocessor_call,
    STATE(5483), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225466] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5327), 1,
      sym__preprocessor_call,
    ACTIONS(4358), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [225506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5328), 1,
      sym__preprocessor_call,
    ACTIONS(4430), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [225546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5329), 1,
      sym__preprocessor_call,
    ACTIONS(5136), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [225586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5330), 1,
      sym__preprocessor_call,
    ACTIONS(4418), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [225626] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5331), 1,
      sym__preprocessor_call,
    STATE(5459), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225672] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5332), 1,
      sym__preprocessor_call,
    STATE(5489), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225718] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5333), 1,
      sym__preprocessor_call,
    STATE(5947), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225764] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5334), 1,
      sym__preprocessor_call,
    STATE(6179), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225810] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5335), 1,
      sym__preprocessor_call,
    STATE(6147), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225856] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5336), 1,
      sym__preprocessor_call,
    STATE(5445), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5337), 1,
      sym__preprocessor_call,
    ACTIONS(4632), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [225942] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5338), 1,
      sym__preprocessor_call,
    STATE(5501), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [225988] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5339), 1,
      sym__preprocessor_call,
    STATE(6095), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [226034] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5340), 1,
      sym__preprocessor_call,
    STATE(5635), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [226080] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5341), 1,
      sym__preprocessor_call,
    STATE(6138), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [226126] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5342), 1,
      sym__preprocessor_call,
    STATE(5634), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [226172] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5343), 1,
      sym__preprocessor_call,
    STATE(5475), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [226218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5344), 1,
      sym__preprocessor_call,
    ACTIONS(4956), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226258] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5345), 1,
      sym__preprocessor_call,
    ACTIONS(8187), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226298] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5346), 1,
      sym__preprocessor_call,
    STATE(5633), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [226344] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5347), 1,
      sym__preprocessor_call,
    STATE(5454), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [226390] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5348), 1,
      sym__preprocessor_call,
    STATE(5484), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [226436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5349), 1,
      sym__preprocessor_call,
    ACTIONS(8189), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5350), 1,
      sym__preprocessor_call,
    ACTIONS(4572), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226516] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5351), 1,
      sym__preprocessor_call,
    ACTIONS(4996), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226556] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5352), 1,
      sym__preprocessor_call,
    ACTIONS(4410), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5353), 1,
      sym__preprocessor_call,
    ACTIONS(5000), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5354), 1,
      sym__preprocessor_call,
    ACTIONS(5004), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5355), 1,
      sym__preprocessor_call,
    ACTIONS(4836), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226716] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5356), 1,
      sym__preprocessor_call,
    STATE(5456), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [226762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5357), 1,
      sym__preprocessor_call,
    ACTIONS(4134), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226802] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5358), 1,
      sym__preprocessor_call,
    ACTIONS(4390), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226842] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5359), 1,
      sym__preprocessor_call,
    STATE(5494), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [226888] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5360), 1,
      sym__preprocessor_call,
    ACTIONS(4564), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226928] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5361), 1,
      sym__preprocessor_call,
    ACTIONS(4106), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [226968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5362), 1,
      sym__preprocessor_call,
    ACTIONS(5012), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5363), 1,
      sym__preprocessor_call,
    ACTIONS(5016), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5364), 1,
      sym__preprocessor_call,
    ACTIONS(4194), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227088] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5365), 1,
      sym__preprocessor_call,
    ACTIONS(5020), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227128] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5366), 1,
      sym__preprocessor_call,
    ACTIONS(5024), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5367), 1,
      sym__preprocessor_call,
    ACTIONS(4568), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5368), 1,
      sym__preprocessor_call,
    ACTIONS(5028), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5369), 1,
      sym__preprocessor_call,
    ACTIONS(5032), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5370), 1,
      sym__preprocessor_call,
    ACTIONS(4374), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227328] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5371), 1,
      sym__preprocessor_call,
    STATE(6108), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [227374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5372), 1,
      sym__preprocessor_call,
    ACTIONS(5040), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227414] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5373), 1,
      sym__preprocessor_call,
    ACTIONS(5044), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5374), 1,
      sym__preprocessor_call,
    ACTIONS(5048), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227494] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5375), 1,
      sym__preprocessor_call,
    STATE(5618), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [227540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5376), 1,
      sym__preprocessor_call,
    ACTIONS(5056), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5377), 1,
      sym__preprocessor_call,
    ACTIONS(4370), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227620] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5378), 1,
      sym__preprocessor_call,
    STATE(6106), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [227666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5379), 1,
      sym__preprocessor_call,
    ACTIONS(5060), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5380), 1,
      sym__preprocessor_call,
    ACTIONS(5064), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227746] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5381), 1,
      sym__preprocessor_call,
    STATE(5617), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [227792] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5382), 1,
      sym__preprocessor_call,
    STATE(5614), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [227838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5383), 1,
      sym__preprocessor_call,
    ACTIONS(5072), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227878] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5384), 1,
      sym__preprocessor_call,
    STATE(5490), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [227924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5385), 1,
      sym__preprocessor_call,
    ACTIONS(5076), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [227964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5386), 1,
      sym__preprocessor_call,
    ACTIONS(4366), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5387), 1,
      sym__preprocessor_call,
    ACTIONS(5080), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228044] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5388), 1,
      sym__preprocessor_call,
    STATE(6855), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [228090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5389), 1,
      sym__preprocessor_call,
    ACTIONS(5084), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5390), 1,
      sym__preprocessor_call,
    ACTIONS(4250), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5391), 1,
      sym__preprocessor_call,
    ACTIONS(5088), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228210] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5392), 1,
      sym__preprocessor_call,
    STATE(5487), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [228256] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5393), 1,
      sym__preprocessor_call,
    ACTIONS(5092), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228296] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5394), 1,
      sym__preprocessor_call,
    STATE(5580), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [228342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5395), 1,
      sym__preprocessor_call,
    ACTIONS(5096), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228382] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5396), 1,
      sym__preprocessor_call,
    STATE(5482), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [228428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5397), 1,
      sym__preprocessor_call,
    ACTIONS(5100), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228468] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5398), 1,
      sym__preprocessor_call,
    STATE(5582), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [228514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5399), 1,
      sym__preprocessor_call,
    ACTIONS(4266), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5400), 1,
      sym__preprocessor_call,
    ACTIONS(5104), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228594] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5401), 1,
      sym__preprocessor_call,
    STATE(5491), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [228640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5402), 1,
      sym__preprocessor_call,
    ACTIONS(8191), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228680] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5403), 1,
      sym__preprocessor_call,
    STATE(6148), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [228726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5404), 1,
      sym__preprocessor_call,
    ACTIONS(5108), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5405), 1,
      sym__preprocessor_call,
    ACTIONS(5112), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5406), 1,
      sym__preprocessor_call,
    ACTIONS(5116), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5407), 1,
      sym__preprocessor_call,
    ACTIONS(4270), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5408), 1,
      sym__preprocessor_call,
    ACTIONS(4282), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [228926] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7691), 1,
      sym__identifier_token,
    STATE(5409), 1,
      sym__preprocessor_call,
    STATE(5890), 1,
      sym__contextual_keywords,
    STATE(6667), 1,
      sym_identifier,
    ACTIONS(7693), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [228972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5410), 1,
      sym__preprocessor_call,
    ACTIONS(5120), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [229012] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5411), 1,
      sym__preprocessor_call,
    ACTIONS(4138), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [229052] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5412), 1,
      sym__preprocessor_call,
    STATE(5468), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229098] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5413), 1,
      sym__preprocessor_call,
    STATE(5541), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5414), 1,
      sym__preprocessor_call,
    ACTIONS(5124), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [229184] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7691), 1,
      sym__identifier_token,
    STATE(5415), 1,
      sym__preprocessor_call,
    STATE(5890), 1,
      sym__contextual_keywords,
    STATE(6668), 1,
      sym_identifier,
    ACTIONS(7693), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229230] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2776), 1,
      sym__identifier_token,
    STATE(2643), 1,
      sym__contextual_keywords,
    STATE(5416), 1,
      sym__preprocessor_call,
    STATE(5583), 1,
      sym_identifier,
    ACTIONS(2778), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5417), 1,
      sym__preprocessor_call,
    ACTIONS(4290), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [229316] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5418), 1,
      sym__preprocessor_call,
    STATE(5474), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229362] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5419), 1,
      sym__preprocessor_call,
    STATE(5443), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229408] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5420), 1,
      sym__preprocessor_call,
    STATE(5473), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229454] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5421), 1,
      sym__preprocessor_call,
    STATE(5455), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229500] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5422), 1,
      sym__preprocessor_call,
    STATE(5458), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229546] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5423), 1,
      sym__preprocessor_call,
    STATE(5446), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229592] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9), 1,
      sym__identifier_token,
    STATE(1774), 1,
      sym__contextual_keywords,
    STATE(5424), 1,
      sym__preprocessor_call,
    STATE(5442), 1,
      sym_identifier,
    ACTIONS(13), 25,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5425), 1,
      sym__preprocessor_call,
    ACTIONS(4434), 28,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
      anon_sym_namespace,
  [229678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5426), 1,
      sym__preprocessor_call,
    ACTIONS(8193), 27,
      ts_builtin_sym_end,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_LBRACK,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_ref,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
      anon_sym_class,
      anon_sym_struct,
      anon_sym_enum,
      anon_sym_interface,
      anon_sym_delegate,
      anon_sym_record,
  [229717] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(7985), 1,
      anon_sym_class,
    ACTIONS(7987), 1,
      anon_sym_struct,
    ACTIONS(7989), 1,
      anon_sym_enum,
    ACTIONS(7991), 1,
      anon_sym_interface,
    ACTIONS(7993), 1,
      anon_sym_delegate,
    ACTIONS(7995), 1,
      anon_sym_record,
    STATE(2707), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(2909), 1,
      sym_modifier,
    STATE(5427), 1,
      sym__preprocessor_call,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [229774] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7509), 1,
      anon_sym_ref,
    ACTIONS(8195), 1,
      anon_sym_class,
    ACTIONS(8197), 1,
      anon_sym_struct,
    ACTIONS(8199), 1,
      anon_sym_enum,
    ACTIONS(8201), 1,
      anon_sym_interface,
    ACTIONS(8203), 1,
      anon_sym_delegate,
    ACTIONS(8205), 1,
      anon_sym_record,
    STATE(2707), 1,
      aux_sym_event_field_declaration_repeat2,
    STATE(2909), 1,
      sym_modifier,
    STATE(5428), 1,
      sym__preprocessor_call,
    ACTIONS(7507), 18,
      anon_sym_extern,
      anon_sym_static,
      anon_sym_abstract,
      anon_sym_async,
      anon_sym_const,
      anon_sym_fixed,
      anon_sym_internal,
      anon_sym_new,
      anon_sym_override,
      anon_sym_partial,
      anon_sym_private,
      anon_sym_protected,
      anon_sym_public,
      anon_sym_readonly,
      anon_sym_sealed,
      anon_sym_unsafe,
      anon_sym_virtual,
      anon_sym_volatile,
  [229831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5429), 1,
      sym__preprocessor_call,
    ACTIONS(8207), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5430), 1,
      sym__preprocessor_call,
    ACTIONS(3222), 26,
      anon_sym_alias,
      anon_sym_global,
      anon_sym_where,
      anon_sym_notnull,
      anon_sym_unmanaged,
      anon_sym_get,
      anon_sym_set,
      anon_sym_add,
      anon_sym_remove,
      anon_sym_when,
      anon_sym_yield,
      anon_sym_from,
      anon_sym_join,
      anon_sym_on,
      anon_sym_equals,
      anon_sym_into,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_ascending,
      anon_sym_descending,
      anon_sym_group,
      anon_sym_by,
      anon_sym_select,
      sym__identifier_token,
      anon_sym_dynamic,
      anon_sym_nameof,
  [229907] = 17,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8209), 1,
      anon_sym_if,
    ACTIONS(8211), 1,
      anon_sym_else,
    ACTIONS(8213), 1,
      anon_sym_nullable,
    ACTIONS(8215), 1,
      anon_sym_define,
    ACTIONS(8217), 1,
      anon_sym_undef,
    ACTIONS(8219), 1,
      anon_sym_elif,
    ACTIONS(8221), 1,
      sym_endif_directive,
    ACTIONS(8223), 1,
      anon_sym_region,
    ACTIONS(8225), 1,
      anon_sym_endregion,
    ACTIONS(8227), 1,
      anon_sym_error,
    ACTIONS(8229), 1,
      anon_sym_warning,
    ACTIONS(8231), 1,
      anon_sym_line,
    ACTIONS(8233), 1,
      anon_sym_pragma,
    STATE(5431), 1,
      sym__preprocessor_call,
    STATE(6703), 12,
      sym_nullable_directive,
      sym_define_directive,
      sym_undef_directive,
      sym_if_directive,
      sym_else_directive,
      sym_elif_directive,
      sym_region_directive,
      sym_endregion_directive,
      sym_error_directive,
      sym_warning_directive,
      sym_line_directive,
      sym_pragma_directive,
  [229970] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5432), 1,
      sym__preprocessor_call,
    STATE(6544), 1,
      sym__overloadable_operator,
    ACTIONS(8235), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(8237), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [230009] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5433), 1,
      sym__preprocessor_call,
    STATE(6617), 1,
      sym__overloadable_operator,
    ACTIONS(8235), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(8237), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [230048] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5434), 1,
      sym__preprocessor_call,
    STATE(6542), 1,
      sym__overloadable_operator,
    ACTIONS(8235), 6,
      anon_sym_LT,
      anon_sym_GT,
      anon_sym_BANG,
      anon_sym_PLUS,
      anon_sym_DASH,
      anon_sym_SLASH,
    ACTIONS(8237), 16,
      anon_sym_TILDE,
      anon_sym_PLUS_PLUS,
      anon_sym_DASH_DASH,
      anon_sym_true,
      anon_sym_false,
      anon_sym_STAR,
      anon_sym_PERCENT,
      anon_sym_CARET,
      anon_sym_PIPE,
      anon_sym_AMP,
      anon_sym_LT_LT,
      anon_sym_GT_GT,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_GT_EQ,
      anon_sym_LT_EQ,
  [230087] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8249), 1,
      anon_sym_group,
    ACTIONS(8251), 1,
      anon_sym_select,
    STATE(2297), 1,
      sym__query_body,
    STATE(4490), 1,
      sym__select_or_group_clause,
    STATE(5435), 1,
      sym__preprocessor_call,
    STATE(5528), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230141] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8253), 1,
      anon_sym_group,
    ACTIONS(8255), 1,
      anon_sym_select,
    STATE(2901), 1,
      sym__query_body,
    STATE(3286), 1,
      sym__select_or_group_clause,
    STATE(5436), 1,
      sym__preprocessor_call,
    STATE(5505), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230195] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8257), 1,
      anon_sym_group,
    ACTIONS(8259), 1,
      anon_sym_select,
    STATE(2752), 1,
      sym__query_body,
    STATE(4018), 1,
      sym__select_or_group_clause,
    STATE(5437), 1,
      sym__preprocessor_call,
    STATE(5515), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230249] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8261), 1,
      anon_sym_group,
    ACTIONS(8263), 1,
      anon_sym_select,
    STATE(2343), 1,
      sym__query_body,
    STATE(3473), 1,
      sym__select_or_group_clause,
    STATE(5438), 1,
      sym__preprocessor_call,
    STATE(5506), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230303] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8253), 1,
      anon_sym_group,
    ACTIONS(8255), 1,
      anon_sym_select,
    STATE(2925), 1,
      sym__query_body,
    STATE(3286), 1,
      sym__select_or_group_clause,
    STATE(5439), 1,
      sym__preprocessor_call,
    STATE(5505), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230357] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8265), 1,
      anon_sym_group,
    ACTIONS(8267), 1,
      anon_sym_select,
    STATE(2991), 1,
      sym__query_body,
    STATE(3148), 1,
      sym__select_or_group_clause,
    STATE(5440), 1,
      sym__preprocessor_call,
    STATE(5525), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230411] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8269), 1,
      anon_sym_group,
    ACTIONS(8271), 1,
      anon_sym_select,
    STATE(2118), 1,
      sym__query_body,
    STATE(4442), 1,
      sym__select_or_group_clause,
    STATE(5441), 1,
      sym__preprocessor_call,
    STATE(5520), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230465] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8273), 1,
      anon_sym_group,
    ACTIONS(8275), 1,
      anon_sym_select,
    STATE(2125), 1,
      sym__query_body,
    STATE(4491), 1,
      sym__select_or_group_clause,
    STATE(5442), 1,
      sym__preprocessor_call,
    STATE(5511), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230519] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8253), 1,
      anon_sym_group,
    ACTIONS(8255), 1,
      anon_sym_select,
    STATE(2774), 1,
      sym__query_body,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(5443), 1,
      sym__preprocessor_call,
    STATE(5527), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230573] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8277), 1,
      anon_sym_group,
    ACTIONS(8279), 1,
      anon_sym_select,
    STATE(2118), 1,
      sym__query_body,
    STATE(3386), 1,
      sym__select_or_group_clause,
    STATE(5444), 1,
      sym__preprocessor_call,
    STATE(5531), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230627] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8273), 1,
      anon_sym_group,
    ACTIONS(8275), 1,
      anon_sym_select,
    STATE(2297), 1,
      sym__query_body,
    STATE(4428), 1,
      sym__select_or_group_clause,
    STATE(5445), 1,
      sym__preprocessor_call,
    STATE(5508), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230681] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8261), 1,
      anon_sym_group,
    ACTIONS(8263), 1,
      anon_sym_select,
    STATE(2297), 1,
      sym__query_body,
    STATE(3473), 1,
      sym__select_or_group_clause,
    STATE(5446), 1,
      sym__preprocessor_call,
    STATE(5506), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230735] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8281), 1,
      anon_sym_group,
    ACTIONS(8283), 1,
      anon_sym_select,
    STATE(2774), 1,
      sym__query_body,
    STATE(4040), 1,
      sym__select_or_group_clause,
    STATE(5447), 1,
      sym__preprocessor_call,
    STATE(5532), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230789] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8281), 1,
      anon_sym_group,
    ACTIONS(8283), 1,
      anon_sym_select,
    STATE(2752), 1,
      sym__query_body,
    STATE(4040), 1,
      sym__select_or_group_clause,
    STATE(5448), 1,
      sym__preprocessor_call,
    STATE(5532), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230843] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8285), 1,
      anon_sym_group,
    ACTIONS(8287), 1,
      anon_sym_select,
    STATE(2901), 1,
      sym__query_body,
    STATE(3485), 1,
      sym__select_or_group_clause,
    STATE(5449), 1,
      sym__preprocessor_call,
    STATE(5514), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230897] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8289), 1,
      anon_sym_group,
    ACTIONS(8291), 1,
      anon_sym_select,
    STATE(2925), 1,
      sym__query_body,
    STATE(4045), 1,
      sym__select_or_group_clause,
    STATE(5450), 1,
      sym__preprocessor_call,
    STATE(5537), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [230951] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8265), 1,
      anon_sym_group,
    ACTIONS(8267), 1,
      anon_sym_select,
    STATE(3012), 1,
      sym__query_body,
    STATE(3148), 1,
      sym__select_or_group_clause,
    STATE(5451), 1,
      sym__preprocessor_call,
    STATE(5525), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231005] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8293), 1,
      anon_sym_group,
    ACTIONS(8295), 1,
      anon_sym_select,
    STATE(2118), 1,
      sym__query_body,
    STATE(3195), 1,
      sym__select_or_group_clause,
    STATE(5452), 1,
      sym__preprocessor_call,
    STATE(5535), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231059] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8257), 1,
      anon_sym_group,
    ACTIONS(8259), 1,
      anon_sym_select,
    STATE(2774), 1,
      sym__query_body,
    STATE(4018), 1,
      sym__select_or_group_clause,
    STATE(5453), 1,
      sym__preprocessor_call,
    STATE(5515), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231113] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8293), 1,
      anon_sym_group,
    ACTIONS(8295), 1,
      anon_sym_select,
    STATE(2297), 1,
      sym__query_body,
    STATE(3194), 1,
      sym__select_or_group_clause,
    STATE(5454), 1,
      sym__preprocessor_call,
    STATE(5503), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231167] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8269), 1,
      anon_sym_group,
    ACTIONS(8271), 1,
      anon_sym_select,
    STATE(2297), 1,
      sym__query_body,
    STATE(4448), 1,
      sym__select_or_group_clause,
    STATE(5455), 1,
      sym__preprocessor_call,
    STATE(5510), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231221] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8249), 1,
      anon_sym_group,
    ACTIONS(8251), 1,
      anon_sym_select,
    STATE(2125), 1,
      sym__query_body,
    STATE(4447), 1,
      sym__select_or_group_clause,
    STATE(5456), 1,
      sym__preprocessor_call,
    STATE(5521), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231275] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8261), 1,
      anon_sym_group,
    ACTIONS(8263), 1,
      anon_sym_select,
    STATE(2125), 1,
      sym__query_body,
    STATE(3513), 1,
      sym__select_or_group_clause,
    STATE(5457), 1,
      sym__preprocessor_call,
    STATE(5523), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231329] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8297), 1,
      anon_sym_group,
    ACTIONS(8299), 1,
      anon_sym_select,
    STATE(2297), 1,
      sym__query_body,
    STATE(4479), 1,
      sym__select_or_group_clause,
    STATE(5458), 1,
      sym__preprocessor_call,
    STATE(5536), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231383] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8293), 1,
      anon_sym_group,
    ACTIONS(8295), 1,
      anon_sym_select,
    STATE(2125), 1,
      sym__query_body,
    STATE(3195), 1,
      sym__select_or_group_clause,
    STATE(5459), 1,
      sym__preprocessor_call,
    STATE(5535), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231437] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8289), 1,
      anon_sym_group,
    ACTIONS(8291), 1,
      anon_sym_select,
    STATE(2752), 1,
      sym__query_body,
    STATE(4049), 1,
      sym__select_or_group_clause,
    STATE(5460), 1,
      sym__preprocessor_call,
    STATE(5513), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231491] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8293), 1,
      anon_sym_group,
    ACTIONS(8295), 1,
      anon_sym_select,
    STATE(2343), 1,
      sym__query_body,
    STATE(3194), 1,
      sym__select_or_group_clause,
    STATE(5461), 1,
      sym__preprocessor_call,
    STATE(5503), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231545] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8249), 1,
      anon_sym_group,
    ACTIONS(8251), 1,
      anon_sym_select,
    STATE(2343), 1,
      sym__query_body,
    STATE(4490), 1,
      sym__select_or_group_clause,
    STATE(5462), 1,
      sym__preprocessor_call,
    STATE(5528), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231599] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8297), 1,
      anon_sym_group,
    ACTIONS(8299), 1,
      anon_sym_select,
    STATE(2118), 1,
      sym__query_body,
    STATE(4443), 1,
      sym__select_or_group_clause,
    STATE(5463), 1,
      sym__preprocessor_call,
    STATE(5516), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231653] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8301), 1,
      anon_sym_group,
    ACTIONS(8303), 1,
      anon_sym_select,
    STATE(2901), 1,
      sym__query_body,
    STATE(3811), 1,
      sym__select_or_group_clause,
    STATE(5464), 1,
      sym__preprocessor_call,
    STATE(5534), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231707] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8281), 1,
      anon_sym_group,
    ACTIONS(8283), 1,
      anon_sym_select,
    STATE(2925), 1,
      sym__query_body,
    STATE(4023), 1,
      sym__select_or_group_clause,
    STATE(5465), 1,
      sym__preprocessor_call,
    STATE(5524), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231761] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8305), 1,
      anon_sym_group,
    ACTIONS(8307), 1,
      anon_sym_select,
    STATE(2752), 1,
      sym__query_body,
    STATE(3893), 1,
      sym__select_or_group_clause,
    STATE(5466), 1,
      sym__preprocessor_call,
    STATE(5526), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231815] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8273), 1,
      anon_sym_group,
    ACTIONS(8275), 1,
      anon_sym_select,
    STATE(2343), 1,
      sym__query_body,
    STATE(4428), 1,
      sym__select_or_group_clause,
    STATE(5467), 1,
      sym__preprocessor_call,
    STATE(5508), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231869] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8309), 1,
      anon_sym_group,
    ACTIONS(8311), 1,
      anon_sym_select,
    STATE(2925), 1,
      sym__query_body,
    STATE(4001), 1,
      sym__select_or_group_clause,
    STATE(5468), 1,
      sym__preprocessor_call,
    STATE(5507), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231923] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8313), 1,
      anon_sym_group,
    ACTIONS(8315), 1,
      anon_sym_select,
    STATE(2297), 1,
      sym__query_body,
    STATE(3772), 1,
      sym__select_or_group_clause,
    STATE(5469), 1,
      sym__preprocessor_call,
    STATE(5530), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [231977] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8289), 1,
      anon_sym_group,
    ACTIONS(8291), 1,
      anon_sym_select,
    STATE(2901), 1,
      sym__query_body,
    STATE(4045), 1,
      sym__select_or_group_clause,
    STATE(5470), 1,
      sym__preprocessor_call,
    STATE(5537), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232031] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8253), 1,
      anon_sym_group,
    ACTIONS(8255), 1,
      anon_sym_select,
    STATE(2752), 1,
      sym__query_body,
    STATE(3340), 1,
      sym__select_or_group_clause,
    STATE(5471), 1,
      sym__preprocessor_call,
    STATE(5527), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232085] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8277), 1,
      anon_sym_group,
    ACTIONS(8279), 1,
      anon_sym_select,
    STATE(2343), 1,
      sym__query_body,
    STATE(3363), 1,
      sym__select_or_group_clause,
    STATE(5472), 1,
      sym__preprocessor_call,
    STATE(5538), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232139] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8305), 1,
      anon_sym_group,
    ACTIONS(8307), 1,
      anon_sym_select,
    STATE(2774), 1,
      sym__query_body,
    STATE(3893), 1,
      sym__select_or_group_clause,
    STATE(5473), 1,
      sym__preprocessor_call,
    STATE(5526), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232193] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8285), 1,
      anon_sym_group,
    ACTIONS(8287), 1,
      anon_sym_select,
    STATE(2774), 1,
      sym__query_body,
    STATE(3494), 1,
      sym__select_or_group_clause,
    STATE(5474), 1,
      sym__preprocessor_call,
    STATE(5533), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232247] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8317), 1,
      anon_sym_group,
    ACTIONS(8319), 1,
      anon_sym_select,
    STATE(2867), 1,
      sym__select_or_group_clause,
    STATE(2991), 1,
      sym__query_body,
    STATE(5475), 1,
      sym__preprocessor_call,
    STATE(5539), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232301] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8269), 1,
      anon_sym_group,
    ACTIONS(8271), 1,
      anon_sym_select,
    STATE(2125), 1,
      sym__query_body,
    STATE(4442), 1,
      sym__select_or_group_clause,
    STATE(5476), 1,
      sym__preprocessor_call,
    STATE(5520), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232355] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8281), 1,
      anon_sym_group,
    ACTIONS(8283), 1,
      anon_sym_select,
    STATE(2901), 1,
      sym__query_body,
    STATE(4023), 1,
      sym__select_or_group_clause,
    STATE(5477), 1,
      sym__preprocessor_call,
    STATE(5524), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232409] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8261), 1,
      anon_sym_group,
    ACTIONS(8263), 1,
      anon_sym_select,
    STATE(2118), 1,
      sym__query_body,
    STATE(3513), 1,
      sym__select_or_group_clause,
    STATE(5478), 1,
      sym__preprocessor_call,
    STATE(5523), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232463] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8285), 1,
      anon_sym_group,
    ACTIONS(8287), 1,
      anon_sym_select,
    STATE(2752), 1,
      sym__query_body,
    STATE(3494), 1,
      sym__select_or_group_clause,
    STATE(5479), 1,
      sym__preprocessor_call,
    STATE(5533), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232517] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8269), 1,
      anon_sym_group,
    ACTIONS(8271), 1,
      anon_sym_select,
    STATE(2343), 1,
      sym__query_body,
    STATE(4448), 1,
      sym__select_or_group_clause,
    STATE(5480), 1,
      sym__preprocessor_call,
    STATE(5510), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232571] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8249), 1,
      anon_sym_group,
    ACTIONS(8251), 1,
      anon_sym_select,
    STATE(2118), 1,
      sym__query_body,
    STATE(4447), 1,
      sym__select_or_group_clause,
    STATE(5481), 1,
      sym__preprocessor_call,
    STATE(5521), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232625] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8285), 1,
      anon_sym_group,
    ACTIONS(8287), 1,
      anon_sym_select,
    STATE(2925), 1,
      sym__query_body,
    STATE(3485), 1,
      sym__select_or_group_clause,
    STATE(5482), 1,
      sym__preprocessor_call,
    STATE(5514), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232679] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8297), 1,
      anon_sym_group,
    ACTIONS(8299), 1,
      anon_sym_select,
    STATE(2125), 1,
      sym__query_body,
    STATE(4443), 1,
      sym__select_or_group_clause,
    STATE(5483), 1,
      sym__preprocessor_call,
    STATE(5516), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232733] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8277), 1,
      anon_sym_group,
    ACTIONS(8279), 1,
      anon_sym_select,
    STATE(2297), 1,
      sym__query_body,
    STATE(3363), 1,
      sym__select_or_group_clause,
    STATE(5484), 1,
      sym__preprocessor_call,
    STATE(5538), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232787] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8257), 1,
      anon_sym_group,
    ACTIONS(8259), 1,
      anon_sym_select,
    STATE(2901), 1,
      sym__query_body,
    STATE(4015), 1,
      sym__select_or_group_clause,
    STATE(5485), 1,
      sym__preprocessor_call,
    STATE(5529), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232841] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8309), 1,
      anon_sym_group,
    ACTIONS(8311), 1,
      anon_sym_select,
    STATE(2752), 1,
      sym__query_body,
    STATE(4006), 1,
      sym__select_or_group_clause,
    STATE(5486), 1,
      sym__preprocessor_call,
    STATE(5519), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232895] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8301), 1,
      anon_sym_group,
    ACTIONS(8303), 1,
      anon_sym_select,
    STATE(2774), 1,
      sym__query_body,
    STATE(3809), 1,
      sym__select_or_group_clause,
    STATE(5487), 1,
      sym__preprocessor_call,
    STATE(5512), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [232949] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8313), 1,
      anon_sym_group,
    ACTIONS(8315), 1,
      anon_sym_select,
    STATE(2125), 1,
      sym__query_body,
    STATE(3908), 1,
      sym__select_or_group_clause,
    STATE(5488), 1,
      sym__preprocessor_call,
    STATE(5509), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233003] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8277), 1,
      anon_sym_group,
    ACTIONS(8279), 1,
      anon_sym_select,
    STATE(2125), 1,
      sym__query_body,
    STATE(3386), 1,
      sym__select_or_group_clause,
    STATE(5489), 1,
      sym__preprocessor_call,
    STATE(5531), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233057] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8305), 1,
      anon_sym_group,
    ACTIONS(8307), 1,
      anon_sym_select,
    STATE(2925), 1,
      sym__query_body,
    STATE(3928), 1,
      sym__select_or_group_clause,
    STATE(5490), 1,
      sym__preprocessor_call,
    STATE(5522), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233111] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8301), 1,
      anon_sym_group,
    ACTIONS(8303), 1,
      anon_sym_select,
    STATE(2925), 1,
      sym__query_body,
    STATE(3811), 1,
      sym__select_or_group_clause,
    STATE(5491), 1,
      sym__preprocessor_call,
    STATE(5534), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233165] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8317), 1,
      anon_sym_group,
    ACTIONS(8319), 1,
      anon_sym_select,
    STATE(2867), 1,
      sym__select_or_group_clause,
    STATE(3012), 1,
      sym__query_body,
    STATE(5492), 1,
      sym__preprocessor_call,
    STATE(5539), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233219] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8313), 1,
      anon_sym_group,
    ACTIONS(8315), 1,
      anon_sym_select,
    STATE(2343), 1,
      sym__query_body,
    STATE(3772), 1,
      sym__select_or_group_clause,
    STATE(5493), 1,
      sym__preprocessor_call,
    STATE(5530), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233273] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8257), 1,
      anon_sym_group,
    ACTIONS(8259), 1,
      anon_sym_select,
    STATE(2925), 1,
      sym__query_body,
    STATE(4015), 1,
      sym__select_or_group_clause,
    STATE(5494), 1,
      sym__preprocessor_call,
    STATE(5529), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233327] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8305), 1,
      anon_sym_group,
    ACTIONS(8307), 1,
      anon_sym_select,
    STATE(2901), 1,
      sym__query_body,
    STATE(3928), 1,
      sym__select_or_group_clause,
    STATE(5495), 1,
      sym__preprocessor_call,
    STATE(5522), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233381] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8301), 1,
      anon_sym_group,
    ACTIONS(8303), 1,
      anon_sym_select,
    STATE(2752), 1,
      sym__query_body,
    STATE(3809), 1,
      sym__select_or_group_clause,
    STATE(5496), 1,
      sym__preprocessor_call,
    STATE(5512), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233435] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8297), 1,
      anon_sym_group,
    ACTIONS(8299), 1,
      anon_sym_select,
    STATE(2343), 1,
      sym__query_body,
    STATE(4479), 1,
      sym__select_or_group_clause,
    STATE(5497), 1,
      sym__preprocessor_call,
    STATE(5536), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233489] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8309), 1,
      anon_sym_group,
    ACTIONS(8311), 1,
      anon_sym_select,
    STATE(2901), 1,
      sym__query_body,
    STATE(4001), 1,
      sym__select_or_group_clause,
    STATE(5498), 1,
      sym__preprocessor_call,
    STATE(5507), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233543] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8313), 1,
      anon_sym_group,
    ACTIONS(8315), 1,
      anon_sym_select,
    STATE(2118), 1,
      sym__query_body,
    STATE(3908), 1,
      sym__select_or_group_clause,
    STATE(5499), 1,
      sym__preprocessor_call,
    STATE(5509), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233597] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8273), 1,
      anon_sym_group,
    ACTIONS(8275), 1,
      anon_sym_select,
    STATE(2118), 1,
      sym__query_body,
    STATE(4491), 1,
      sym__select_or_group_clause,
    STATE(5500), 1,
      sym__preprocessor_call,
    STATE(5511), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233651] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8309), 1,
      anon_sym_group,
    ACTIONS(8311), 1,
      anon_sym_select,
    STATE(2774), 1,
      sym__query_body,
    STATE(4006), 1,
      sym__select_or_group_clause,
    STATE(5501), 1,
      sym__preprocessor_call,
    STATE(5519), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233705] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8289), 1,
      anon_sym_group,
    ACTIONS(8291), 1,
      anon_sym_select,
    STATE(2774), 1,
      sym__query_body,
    STATE(4049), 1,
      sym__select_or_group_clause,
    STATE(5502), 1,
      sym__preprocessor_call,
    STATE(5513), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233759] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8293), 1,
      anon_sym_group,
    ACTIONS(8295), 1,
      anon_sym_select,
    STATE(3209), 1,
      sym__select_or_group_clause,
    STATE(5503), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233810] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2829), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8323), 1,
      anon_sym_EQ,
    ACTIONS(8325), 1,
      anon_sym_LT,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2326), 1,
      sym_accessor_list,
    STATE(5504), 1,
      sym__preprocessor_call,
    STATE(5632), 1,
      sym_parameter_list,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
    STATE(6619), 1,
      sym_type_parameter_list,
    STATE(6637), 1,
      sym_arrow_expression_clause,
    ACTIONS(8321), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [233869] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8253), 1,
      anon_sym_group,
    ACTIONS(8255), 1,
      anon_sym_select,
    STATE(3235), 1,
      sym__select_or_group_clause,
    STATE(5505), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233920] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8261), 1,
      anon_sym_group,
    ACTIONS(8263), 1,
      anon_sym_select,
    STATE(3426), 1,
      sym__select_or_group_clause,
    STATE(5506), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [233971] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8309), 1,
      anon_sym_group,
    ACTIONS(8311), 1,
      anon_sym_select,
    STATE(4004), 1,
      sym__select_or_group_clause,
    STATE(5507), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234022] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8273), 1,
      anon_sym_group,
    ACTIONS(8275), 1,
      anon_sym_select,
    STATE(4465), 1,
      sym__select_or_group_clause,
    STATE(5508), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234073] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8313), 1,
      anon_sym_group,
    ACTIONS(8315), 1,
      anon_sym_select,
    STATE(3905), 1,
      sym__select_or_group_clause,
    STATE(5509), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234124] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8269), 1,
      anon_sym_group,
    ACTIONS(8271), 1,
      anon_sym_select,
    STATE(4437), 1,
      sym__select_or_group_clause,
    STATE(5510), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234175] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8273), 1,
      anon_sym_group,
    ACTIONS(8275), 1,
      anon_sym_select,
    STATE(4489), 1,
      sym__select_or_group_clause,
    STATE(5511), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234226] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8301), 1,
      anon_sym_group,
    ACTIONS(8303), 1,
      anon_sym_select,
    STATE(3808), 1,
      sym__select_or_group_clause,
    STATE(5512), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234277] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8289), 1,
      anon_sym_group,
    ACTIONS(8291), 1,
      anon_sym_select,
    STATE(4051), 1,
      sym__select_or_group_clause,
    STATE(5513), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234328] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8285), 1,
      anon_sym_group,
    ACTIONS(8287), 1,
      anon_sym_select,
    STATE(3487), 1,
      sym__select_or_group_clause,
    STATE(5514), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234379] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8257), 1,
      anon_sym_group,
    ACTIONS(8259), 1,
      anon_sym_select,
    STATE(4019), 1,
      sym__select_or_group_clause,
    STATE(5515), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234430] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8297), 1,
      anon_sym_group,
    ACTIONS(8299), 1,
      anon_sym_select,
    STATE(4421), 1,
      sym__select_or_group_clause,
    STATE(5516), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234481] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2829), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8323), 1,
      anon_sym_EQ,
    ACTIONS(8325), 1,
      anon_sym_LT,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2264), 1,
      sym_accessor_list,
    STATE(5517), 1,
      sym__preprocessor_call,
    STATE(5644), 1,
      sym_parameter_list,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
    STATE(6540), 1,
      sym_type_parameter_list,
    STATE(6794), 1,
      sym_arrow_expression_clause,
    ACTIONS(8321), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [234540] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2829), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8323), 1,
      anon_sym_EQ,
    ACTIONS(8325), 1,
      anon_sym_LT,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2346), 1,
      sym_accessor_list,
    STATE(5518), 1,
      sym__preprocessor_call,
    STATE(5593), 1,
      sym_parameter_list,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
    STATE(6545), 1,
      sym_type_parameter_list,
    STATE(6726), 1,
      sym_arrow_expression_clause,
    ACTIONS(8321), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [234599] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8309), 1,
      anon_sym_group,
    ACTIONS(8311), 1,
      anon_sym_select,
    STATE(4011), 1,
      sym__select_or_group_clause,
    STATE(5519), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234650] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8269), 1,
      anon_sym_group,
    ACTIONS(8271), 1,
      anon_sym_select,
    STATE(4436), 1,
      sym__select_or_group_clause,
    STATE(5520), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234701] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8249), 1,
      anon_sym_group,
    ACTIONS(8251), 1,
      anon_sym_select,
    STATE(4453), 1,
      sym__select_or_group_clause,
    STATE(5521), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234752] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8305), 1,
      anon_sym_group,
    ACTIONS(8307), 1,
      anon_sym_select,
    STATE(3927), 1,
      sym__select_or_group_clause,
    STATE(5522), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234803] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8261), 1,
      anon_sym_group,
    ACTIONS(8263), 1,
      anon_sym_select,
    STATE(3466), 1,
      sym__select_or_group_clause,
    STATE(5523), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234854] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8281), 1,
      anon_sym_group,
    ACTIONS(8283), 1,
      anon_sym_select,
    STATE(4024), 1,
      sym__select_or_group_clause,
    STATE(5524), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234905] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8265), 1,
      anon_sym_group,
    ACTIONS(8267), 1,
      anon_sym_select,
    STATE(3179), 1,
      sym__select_or_group_clause,
    STATE(5525), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [234956] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8305), 1,
      anon_sym_group,
    ACTIONS(8307), 1,
      anon_sym_select,
    STATE(3892), 1,
      sym__select_or_group_clause,
    STATE(5526), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235007] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8253), 1,
      anon_sym_group,
    ACTIONS(8255), 1,
      anon_sym_select,
    STATE(3230), 1,
      sym__select_or_group_clause,
    STATE(5527), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235058] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8249), 1,
      anon_sym_group,
    ACTIONS(8251), 1,
      anon_sym_select,
    STATE(4480), 1,
      sym__select_or_group_clause,
    STATE(5528), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235109] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8257), 1,
      anon_sym_group,
    ACTIONS(8259), 1,
      anon_sym_select,
    STATE(4017), 1,
      sym__select_or_group_clause,
    STATE(5529), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235160] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8313), 1,
      anon_sym_group,
    ACTIONS(8315), 1,
      anon_sym_select,
    STATE(3800), 1,
      sym__select_or_group_clause,
    STATE(5530), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235211] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8277), 1,
      anon_sym_group,
    ACTIONS(8279), 1,
      anon_sym_select,
    STATE(3389), 1,
      sym__select_or_group_clause,
    STATE(5531), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235262] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8281), 1,
      anon_sym_group,
    ACTIONS(8283), 1,
      anon_sym_select,
    STATE(4042), 1,
      sym__select_or_group_clause,
    STATE(5532), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235313] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8285), 1,
      anon_sym_group,
    ACTIONS(8287), 1,
      anon_sym_select,
    STATE(3495), 1,
      sym__select_or_group_clause,
    STATE(5533), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235364] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8301), 1,
      anon_sym_group,
    ACTIONS(8303), 1,
      anon_sym_select,
    STATE(3810), 1,
      sym__select_or_group_clause,
    STATE(5534), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235415] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8293), 1,
      anon_sym_group,
    ACTIONS(8295), 1,
      anon_sym_select,
    STATE(3197), 1,
      sym__select_or_group_clause,
    STATE(5535), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235466] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8297), 1,
      anon_sym_group,
    ACTIONS(8299), 1,
      anon_sym_select,
    STATE(4482), 1,
      sym__select_or_group_clause,
    STATE(5536), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235517] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8289), 1,
      anon_sym_group,
    ACTIONS(8291), 1,
      anon_sym_select,
    STATE(4046), 1,
      sym__select_or_group_clause,
    STATE(5537), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2775), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235568] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8277), 1,
      anon_sym_group,
    ACTIONS(8279), 1,
      anon_sym_select,
    STATE(3355), 1,
      sym__select_or_group_clause,
    STATE(5538), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2159), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235619] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8239), 1,
      anon_sym_where,
    ACTIONS(8241), 1,
      anon_sym_from,
    ACTIONS(8243), 1,
      anon_sym_join,
    ACTIONS(8245), 1,
      anon_sym_let,
    ACTIONS(8247), 1,
      anon_sym_orderby,
    ACTIONS(8317), 1,
      anon_sym_group,
    ACTIONS(8319), 1,
      anon_sym_select,
    STATE(2866), 1,
      sym__select_or_group_clause,
    STATE(5539), 1,
      sym__preprocessor_call,
    STATE(5540), 1,
      aux_sym__query_body_repeat1,
    STATE(5851), 1,
      sym__query_clause,
    STATE(2988), 2,
      sym_group_clause,
      sym_select_clause,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235670] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8331), 1,
      anon_sym_where,
    ACTIONS(8334), 1,
      anon_sym_from,
    ACTIONS(8337), 1,
      anon_sym_join,
    ACTIONS(8340), 1,
      anon_sym_let,
    ACTIONS(8343), 1,
      anon_sym_orderby,
    STATE(5851), 1,
      sym__query_clause,
    ACTIONS(8346), 2,
      anon_sym_group,
      anon_sym_select,
    STATE(5540), 2,
      sym__preprocessor_call,
      aux_sym__query_body_repeat1,
    STATE(5863), 5,
      sym_from_clause,
      sym_join_clause,
      sym_let_clause,
      sym_order_by_clause,
      sym_where_clause,
  [235710] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2549), 1,
      sym__record_body,
    STATE(5541), 1,
      sym__preprocessor_call,
    STATE(5567), 1,
      sym_type_parameter_list,
    STATE(5590), 1,
      sym_parameter_list,
    STATE(5739), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5871), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [235759] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5325), 1,
      sym__record_body,
    STATE(5542), 1,
      sym__preprocessor_call,
    STATE(5563), 1,
      sym_type_parameter_list,
    STATE(5643), 1,
      sym_parameter_list,
    STATE(5811), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5821), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [235808] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5390), 1,
      sym__record_body,
    STATE(5543), 1,
      sym__preprocessor_call,
    STATE(5556), 1,
      sym_type_parameter_list,
    STATE(5670), 1,
      sym_parameter_list,
    STATE(5813), 1,
      sym_record_base,
    STATE(5816), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [235857] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2536), 1,
      sym__record_body,
    STATE(5544), 1,
      sym__preprocessor_call,
    STATE(5561), 1,
      sym_type_parameter_list,
    STATE(5607), 1,
      sym_parameter_list,
    STATE(5733), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5794), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [235906] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2353), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5545), 1,
      sym__preprocessor_call,
    STATE(5565), 1,
      sym_type_parameter_list,
    STATE(5679), 1,
      sym_parameter_list,
    STATE(5778), 1,
      sym_record_base,
    STATE(5779), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [235955] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5277), 1,
      sym__record_body,
    STATE(5546), 1,
      sym__preprocessor_call,
    STATE(5566), 1,
      sym_type_parameter_list,
    STATE(5603), 1,
      sym_parameter_list,
    STATE(5711), 1,
      sym_record_base,
    STATE(5716), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236004] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5225), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5547), 1,
      sym__preprocessor_call,
    STATE(5559), 1,
      sym_type_parameter_list,
    STATE(5654), 1,
      sym_parameter_list,
    STATE(5790), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5829), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236053] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5305), 1,
      sym__record_body,
    STATE(5548), 1,
      sym__preprocessor_call,
    STATE(5562), 1,
      sym_type_parameter_list,
    STATE(5621), 1,
      sym_parameter_list,
    STATE(5745), 1,
      sym_record_base,
    STATE(5747), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236102] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5337), 1,
      sym__record_body,
    STATE(5549), 1,
      sym__preprocessor_call,
    STATE(5557), 1,
      sym_type_parameter_list,
    STATE(5597), 1,
      sym_parameter_list,
    STATE(5831), 1,
      sym_record_base,
    STATE(5834), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236151] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2487), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5550), 1,
      sym__preprocessor_call,
    STATE(5560), 1,
      sym_type_parameter_list,
    STATE(5601), 1,
      sym_parameter_list,
    STATE(5718), 1,
      sym_record_base,
    STATE(5723), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236200] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2454), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5551), 1,
      sym__preprocessor_call,
    STATE(5564), 1,
      sym_type_parameter_list,
    STATE(5658), 1,
      sym_parameter_list,
    STATE(5874), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5879), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236249] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2386), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5552), 1,
      sym__preprocessor_call,
    STATE(5558), 1,
      sym_type_parameter_list,
    STATE(5639), 1,
      sym_parameter_list,
    STATE(5725), 1,
      sym_record_base,
    STATE(5741), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236298] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2829), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8321), 1,
      anon_sym_COMMA,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8362), 1,
      anon_sym_SEMI,
    ACTIONS(8365), 1,
      anon_sym_LT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2597), 1,
      sym_accessor_list,
    STATE(5553), 1,
      sym__preprocessor_call,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
  [236344] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2829), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8321), 1,
      anon_sym_COMMA,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8365), 1,
      anon_sym_LT,
    ACTIONS(8367), 1,
      anon_sym_SEMI,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2491), 1,
      sym_accessor_list,
    STATE(5554), 1,
      sym__preprocessor_call,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
  [236390] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(2829), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8321), 1,
      anon_sym_COMMA,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8365), 1,
      anon_sym_LT,
    ACTIONS(8370), 1,
      anon_sym_SEMI,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(2464), 1,
      sym_accessor_list,
    STATE(5555), 1,
      sym__preprocessor_call,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
  [236436] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5261), 1,
      sym__record_body,
    STATE(5556), 1,
      sym__preprocessor_call,
    STATE(5591), 1,
      sym_parameter_list,
    STATE(5721), 1,
      sym_record_base,
    STATE(5734), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236479] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5364), 1,
      sym__record_body,
    STATE(5557), 1,
      sym__preprocessor_call,
    STATE(5668), 1,
      sym_parameter_list,
    STATE(5833), 1,
      sym_record_base,
    STATE(5836), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236522] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2419), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5558), 1,
      sym__preprocessor_call,
    STATE(5669), 1,
      sym_parameter_list,
    STATE(5837), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5872), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236565] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5286), 1,
      sym__record_body,
    STATE(5559), 1,
      sym__preprocessor_call,
    STATE(5609), 1,
      sym_parameter_list,
    STATE(5736), 1,
      sym_record_base,
    STATE(5737), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236608] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2371), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5560), 1,
      sym__preprocessor_call,
    STATE(5691), 1,
      sym_parameter_list,
    STATE(5757), 1,
      sym_record_base,
    STATE(5761), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236651] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2543), 1,
      sym__record_body,
    STATE(5561), 1,
      sym__preprocessor_call,
    STATE(5598), 1,
      sym_parameter_list,
    STATE(5857), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5877), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236694] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5227), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5562), 1,
      sym__preprocessor_call,
    STATE(5578), 1,
      sym_parameter_list,
    STATE(5867), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5869), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236737] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5311), 1,
      sym__record_body,
    STATE(5563), 1,
      sym__preprocessor_call,
    STATE(5625), 1,
      sym_parameter_list,
    STATE(5760), 1,
      sym_record_base,
    STATE(5765), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236780] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2551), 1,
      sym__record_body,
    STATE(5564), 1,
      sym__preprocessor_call,
    STATE(5640), 1,
      sym_parameter_list,
    STATE(5810), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5818), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236823] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2461), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5565), 1,
      sym__preprocessor_call,
    STATE(5655), 1,
      sym_parameter_list,
    STATE(5707), 1,
      sym_record_base,
    STATE(5864), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236866] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5425), 1,
      sym__record_body,
    STATE(5566), 1,
      sym__preprocessor_call,
    STATE(5694), 1,
      sym_parameter_list,
    STATE(5751), 1,
      sym_record_base,
    STATE(5758), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236909] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2435), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5567), 1,
      sym__preprocessor_call,
    STATE(5648), 1,
      sym_parameter_list,
    STATE(5849), 1,
      sym_record_base,
    STATE(5853), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [236952] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5568), 1,
      sym__preprocessor_call,
    ACTIONS(8373), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
    ACTIONS(2729), 6,
      anon_sym_COLON_COLON,
      anon_sym_LT,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
  [236977] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5569), 1,
      sym__preprocessor_call,
    STATE(5596), 1,
      sym_parameter_list,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
    STATE(6590), 1,
      sym_type_parameter_list,
    ACTIONS(8321), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [237015] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5570), 1,
      sym__preprocessor_call,
    STATE(5606), 1,
      sym_parameter_list,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
    STATE(6557), 1,
      sym_type_parameter_list,
    ACTIONS(8321), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [237053] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5571), 1,
      sym__preprocessor_call,
    STATE(5611), 1,
      sym_parameter_list,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
    STATE(6606), 1,
      sym_type_parameter_list,
    ACTIONS(8321), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [237091] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2734), 1,
      anon_sym_EQ,
    STATE(5572), 1,
      sym__preprocessor_call,
    ACTIONS(2847), 2,
      anon_sym_COLON_COLON,
      anon_sym_DOT,
    ACTIONS(2729), 7,
      anon_sym_SEMI,
      anon_sym_LT,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [237117] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5573), 1,
      sym__preprocessor_call,
    STATE(5592), 1,
      sym_parameter_list,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
    STATE(6591), 1,
      sym_type_parameter_list,
    ACTIONS(8321), 2,
      anon_sym_SEMI,
      anon_sym_COMMA,
  [237155] = 10,
    ACTIONS(8376), 1,
      anon_sym_LBRACE,
    ACTIONS(8378), 1,
      anon_sym_DQUOTE,
    ACTIONS(8382), 1,
      sym__interpolated_verbatim_string_text_fragment,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    STATE(5574), 1,
      sym__preprocessor_call,
    STATE(5671), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8380), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [237188] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1713), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5575), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [237225] = 10,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8390), 1,
      anon_sym_LBRACE,
    ACTIONS(8392), 1,
      anon_sym_DQUOTE,
    ACTIONS(8396), 1,
      sym__interpolated_string_text_fragment,
    STATE(5576), 1,
      sym__preprocessor_call,
    STATE(5585), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8394), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [237258] = 10,
    ACTIONS(8376), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      sym__interpolated_verbatim_string_text_fragment,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8392), 1,
      anon_sym_DQUOTE,
    STATE(5577), 1,
      sym__preprocessor_call,
    STATE(5586), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8380), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [237291] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5395), 1,
      sym__record_body,
    STATE(5578), 1,
      sym__preprocessor_call,
    STATE(5809), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5812), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [237328] = 10,
    ACTIONS(8376), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      sym__interpolated_verbatim_string_text_fragment,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8398), 1,
      anon_sym_DQUOTE,
    STATE(5579), 1,
      sym__preprocessor_call,
    STATE(5671), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8380), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [237361] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2216), 1,
      sym_declaration_list,
    STATE(5580), 1,
      sym__preprocessor_call,
    STATE(5709), 1,
      sym_type_parameter_list,
    STATE(6088), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6089), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [237398] = 10,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8390), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      sym__interpolated_string_text_fragment,
    ACTIONS(8398), 1,
      anon_sym_DQUOTE,
    STATE(5581), 1,
      sym__preprocessor_call,
    STATE(5663), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8394), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [237431] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2200), 1,
      sym_declaration_list,
    STATE(5582), 1,
      sym__preprocessor_call,
    STATE(5710), 1,
      sym_type_parameter_list,
    STATE(6085), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6086), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [237468] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2221), 1,
      sym_declaration_list,
    STATE(5583), 1,
      sym__preprocessor_call,
    STATE(5712), 1,
      sym_type_parameter_list,
    STATE(6021), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6082), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [237505] = 10,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8390), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      sym__interpolated_string_text_fragment,
    ACTIONS(8402), 1,
      anon_sym_DQUOTE,
    STATE(5584), 1,
      sym__preprocessor_call,
    STATE(5653), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8394), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [237538] = 10,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8390), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      sym__interpolated_string_text_fragment,
    ACTIONS(8404), 1,
      anon_sym_DQUOTE,
    STATE(5585), 1,
      sym__preprocessor_call,
    STATE(5663), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8394), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [237571] = 10,
    ACTIONS(8376), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      sym__interpolated_verbatim_string_text_fragment,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8404), 1,
      anon_sym_DQUOTE,
    STATE(5586), 1,
      sym__preprocessor_call,
    STATE(5671), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8380), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [237604] = 10,
    ACTIONS(8376), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      sym__interpolated_verbatim_string_text_fragment,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8402), 1,
      anon_sym_DQUOTE,
    STATE(5587), 1,
      sym__preprocessor_call,
    STATE(5613), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8380), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [237637] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1661), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5588), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [237674] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1664), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5589), 1,
      sym__preprocessor_call,
    STATE(5666), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [237711] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2440), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5590), 1,
      sym__preprocessor_call,
    STATE(5820), 1,
      sym_record_base,
    STATE(5825), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [237748] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5175), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5591), 1,
      sym__preprocessor_call,
    STATE(5746), 1,
      sym_record_base,
    STATE(5748), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [237785] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1559), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5592), 1,
      sym__preprocessor_call,
    STATE(5662), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [237822] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2483), 1,
      sym__function_body,
    STATE(5593), 1,
      sym__preprocessor_call,
    STATE(5672), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [237859] = 10,
    ACTIONS(8376), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      sym__interpolated_verbatim_string_text_fragment,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8412), 1,
      anon_sym_DQUOTE,
    STATE(5579), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(5594), 1,
      sym__preprocessor_call,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8380), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [237892] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5086), 1,
      sym_declaration_list,
    STATE(5595), 1,
      sym__preprocessor_call,
    STATE(5855), 1,
      sym_type_parameter_list,
    STATE(5919), 1,
      sym_base_list,
    STATE(5993), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [237929] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1615), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5596), 1,
      sym__preprocessor_call,
    STATE(5645), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [237966] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5323), 1,
      sym__record_body,
    STATE(5597), 1,
      sym__preprocessor_call,
    STATE(5773), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5817), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238003] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2418), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5598), 1,
      sym__preprocessor_call,
    STATE(5805), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5827), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238040] = 10,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8390), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      sym__interpolated_string_text_fragment,
    ACTIONS(8412), 1,
      anon_sym_DQUOTE,
    STATE(5581), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(5599), 1,
      sym__preprocessor_call,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8394), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [238073] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1599), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5600), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [238110] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2385), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5601), 1,
      sym__preprocessor_call,
    STATE(5749), 1,
      sym_record_base,
    STATE(5753), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238147] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2348), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5602), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [238184] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5324), 1,
      sym__record_body,
    STATE(5603), 1,
      sym__preprocessor_call,
    STATE(5754), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5759), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238221] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8414), 1,
      anon_sym_RBRACE,
    ACTIONS(8416), 1,
      anon_sym_case,
    ACTIONS(8418), 1,
      anon_sym_default,
    STATE(13), 1,
      aux_sym_switch_section_repeat1,
    STATE(5604), 1,
      sym__preprocessor_call,
    STATE(5630), 1,
      aux_sym_switch_body_repeat1,
    STATE(6300), 1,
      sym_switch_section,
    STATE(1735), 3,
      sym_case_pattern_switch_label,
      sym_case_switch_label,
      sym_default_switch_label,
  [238254] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8416), 1,
      anon_sym_case,
    ACTIONS(8418), 1,
      anon_sym_default,
    ACTIONS(8420), 1,
      anon_sym_RBRACE,
    STATE(13), 1,
      aux_sym_switch_section_repeat1,
    STATE(5605), 1,
      sym__preprocessor_call,
    STATE(5624), 1,
      aux_sym_switch_body_repeat1,
    STATE(6300), 1,
      sym_switch_section,
    STATE(1735), 3,
      sym_case_pattern_switch_label,
      sym_case_switch_label,
      sym_default_switch_label,
  [238287] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1712), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5588), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5606), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [238324] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2548), 1,
      sym__record_body,
    STATE(5607), 1,
      sym__preprocessor_call,
    STATE(5763), 1,
      sym_record_base,
    STATE(5772), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238361] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1616), 1,
      sym_block,
    STATE(1618), 1,
      sym__function_body,
    STATE(5608), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [238398] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5370), 1,
      sym__record_body,
    STATE(5609), 1,
      sym__preprocessor_call,
    STATE(5720), 1,
      sym_record_base,
    STATE(5724), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238435] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5053), 1,
      sym_declaration_list,
    STATE(5610), 1,
      sym__preprocessor_call,
    STATE(5740), 1,
      sym_type_parameter_list,
    STATE(6050), 1,
      sym_base_list,
    STATE(6054), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238472] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1669), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5611), 1,
      sym__preprocessor_call,
    STATE(5684), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [238509] = 10,
    ACTIONS(8376), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      sym__interpolated_verbatim_string_text_fragment,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8422), 1,
      anon_sym_DQUOTE,
    STATE(5612), 1,
      sym__preprocessor_call,
    STATE(5671), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8380), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [238542] = 10,
    ACTIONS(8376), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      sym__interpolated_verbatim_string_text_fragment,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8424), 1,
      anon_sym_DQUOTE,
    STATE(5613), 1,
      sym__preprocessor_call,
    STATE(5671), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8380), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [238575] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2204), 1,
      sym_declaration_list,
    STATE(5614), 1,
      sym__preprocessor_call,
    STATE(5771), 1,
      sym_type_parameter_list,
    STATE(5990), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5991), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238612] = 10,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8390), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      sym__interpolated_string_text_fragment,
    ACTIONS(8422), 1,
      anon_sym_DQUOTE,
    STATE(5615), 1,
      sym__preprocessor_call,
    STATE(5663), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8394), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [238645] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5039), 1,
      sym_declaration_list,
    STATE(5616), 1,
      sym__preprocessor_call,
    STATE(5735), 1,
      sym_type_parameter_list,
    STATE(6059), 1,
      sym_base_list,
    STATE(6065), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238682] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2205), 1,
      sym_declaration_list,
    STATE(5617), 1,
      sym__preprocessor_call,
    STATE(5781), 1,
      sym_type_parameter_list,
    STATE(5982), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5983), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238719] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2207), 1,
      sym_declaration_list,
    STATE(5618), 1,
      sym__preprocessor_call,
    STATE(5785), 1,
      sym_type_parameter_list,
    STATE(5977), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5978), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238756] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2513), 1,
      sym__function_body,
    STATE(5619), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [238793] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5047), 1,
      sym_declaration_list,
    STATE(5620), 1,
      sym__preprocessor_call,
    STATE(5717), 1,
      sym_type_parameter_list,
    STATE(5976), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6080), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238830] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5221), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5621), 1,
      sym__preprocessor_call,
    STATE(5858), 1,
      sym_record_base,
    STATE(5876), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [238867] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2515), 1,
      sym__function_body,
    STATE(5622), 1,
      sym__preprocessor_call,
    STATE(5686), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [238904] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2492), 1,
      sym__function_body,
    STATE(5623), 1,
      sym__preprocessor_call,
    STATE(5681), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [238941] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8416), 1,
      anon_sym_case,
    ACTIONS(8418), 1,
      anon_sym_default,
    ACTIONS(8426), 1,
      anon_sym_RBRACE,
    STATE(13), 1,
      aux_sym_switch_section_repeat1,
    STATE(5624), 1,
      sym__preprocessor_call,
    STATE(5637), 1,
      aux_sym_switch_body_repeat1,
    STATE(6300), 1,
      sym_switch_section,
    STATE(1735), 3,
      sym_case_pattern_switch_label,
      sym_case_switch_label,
      sym_default_switch_label,
  [238974] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5252), 1,
      sym__record_body,
    STATE(5625), 1,
      sym__preprocessor_call,
    STATE(5766), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5768), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239011] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(8365), 1,
      anon_sym_LT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(5626), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 6,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
  [239038] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2490), 1,
      sym__function_body,
    STATE(5627), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [239075] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2477), 1,
      sym__function_body,
    STATE(5628), 1,
      sym__preprocessor_call,
    STATE(5685), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [239112] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5089), 1,
      sym_declaration_list,
    STATE(5629), 1,
      sym__preprocessor_call,
    STATE(5860), 1,
      sym_type_parameter_list,
    STATE(6003), 1,
      sym_base_list,
    STATE(6028), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239149] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8416), 1,
      anon_sym_case,
    ACTIONS(8418), 1,
      anon_sym_default,
    ACTIONS(8428), 1,
      anon_sym_RBRACE,
    STATE(13), 1,
      aux_sym_switch_section_repeat1,
    STATE(5630), 1,
      sym__preprocessor_call,
    STATE(5637), 1,
      aux_sym_switch_body_repeat1,
    STATE(6300), 1,
      sym_switch_section,
    STATE(1735), 3,
      sym_case_pattern_switch_label,
      sym_case_switch_label,
      sym_default_switch_label,
  [239182] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1572), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5631), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [239219] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2589), 1,
      sym__function_body,
    STATE(5627), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5632), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [239256] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2331), 1,
      sym_declaration_list,
    STATE(5633), 1,
      sym__preprocessor_call,
    STATE(5842), 1,
      sym_type_parameter_list,
    STATE(5932), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5933), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239293] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2332), 1,
      sym_declaration_list,
    STATE(5634), 1,
      sym__preprocessor_call,
    STATE(5845), 1,
      sym_type_parameter_list,
    STATE(5928), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5930), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239330] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2334), 1,
      sym_declaration_list,
    STATE(5635), 1,
      sym__preprocessor_call,
    STATE(5850), 1,
      sym_type_parameter_list,
    STATE(5920), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5924), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239367] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5110), 1,
      sym_declaration_list,
    STATE(5636), 1,
      sym__preprocessor_call,
    STATE(5732), 1,
      sym_type_parameter_list,
    STATE(6075), 1,
      sym_base_list,
    STATE(6078), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239404] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8430), 1,
      anon_sym_RBRACE,
    ACTIONS(8432), 1,
      anon_sym_case,
    ACTIONS(8435), 1,
      anon_sym_default,
    STATE(13), 1,
      aux_sym_switch_section_repeat1,
    STATE(6300), 1,
      sym_switch_section,
    STATE(5637), 2,
      sym__preprocessor_call,
      aux_sym_switch_body_repeat1,
    STATE(1735), 3,
      sym_case_pattern_switch_label,
      sym_case_switch_label,
      sym_default_switch_label,
  [239435] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1570), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5600), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5638), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [239472] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2415), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5639), 1,
      sym__preprocessor_call,
    STATE(5815), 1,
      sym_record_base,
    STATE(5819), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239509] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2604), 1,
      sym__record_body,
    STATE(5640), 1,
      sym__preprocessor_call,
    STATE(5782), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5783), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239546] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5117), 1,
      sym_declaration_list,
    STATE(5641), 1,
      sym__preprocessor_call,
    STATE(5726), 1,
      sym_type_parameter_list,
    STATE(6071), 1,
      sym_base_list,
    STATE(6073), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239583] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5119), 1,
      sym_declaration_list,
    STATE(5642), 1,
      sym__preprocessor_call,
    STATE(5731), 1,
      sym_type_parameter_list,
    STATE(5984), 1,
      sym_base_list,
    STATE(6067), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239620] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5306), 1,
      sym__record_body,
    STATE(5643), 1,
      sym__preprocessor_call,
    STATE(5750), 1,
      sym_record_base,
    STATE(5755), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239657] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2402), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5644), 1,
      sym__preprocessor_call,
    STATE(5693), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [239694] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1581), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5645), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [239731] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2541), 1,
      sym__function_body,
    STATE(5602), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5646), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [239768] = 10,
    ACTIONS(8376), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      sym__interpolated_verbatim_string_text_fragment,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8438), 1,
      anon_sym_DQUOTE,
    STATE(5612), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(5647), 1,
      sym__preprocessor_call,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8380), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [239801] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2368), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5648), 1,
      sym__preprocessor_call,
    STATE(5795), 1,
      sym_record_base,
    STATE(5797), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [239838] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2831), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7167), 1,
      anon_sym_LT,
    STATE(4537), 1,
      sym_type_argument_list,
    STATE(5649), 1,
      sym__preprocessor_call,
    ACTIONS(8440), 2,
      anon_sym_COMMA,
      anon_sym_GT,
    ACTIONS(2829), 4,
      anon_sym_DOT,
      anon_sym_LBRACK,
      anon_sym_QMARK,
      anon_sym_STAR,
  [239867] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1658), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5575), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5650), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [239904] = 10,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8390), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      sym__interpolated_string_text_fragment,
    ACTIONS(8438), 1,
      anon_sym_DQUOTE,
    STATE(5615), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(5651), 1,
      sym__preprocessor_call,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8394), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [239937] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1707), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5652), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [239974] = 10,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8390), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      sym__interpolated_string_text_fragment,
    ACTIONS(8424), 1,
      anon_sym_DQUOTE,
    STATE(5653), 1,
      sym__preprocessor_call,
    STATE(5663), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8394), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [240007] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5282), 1,
      sym__record_body,
    STATE(5654), 1,
      sym__preprocessor_call,
    STATE(5727), 1,
      sym_record_base,
    STATE(5730), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [240044] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2560), 1,
      sym__record_body,
    STATE(5655), 1,
      sym__preprocessor_call,
    STATE(5799), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5800), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [240081] = 10,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8390), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      sym__interpolated_string_text_fragment,
    ACTIONS(8443), 1,
      anon_sym_DQUOTE,
    STATE(5656), 1,
      sym__preprocessor_call,
    STATE(5677), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8394), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [240114] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1582), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5657), 1,
      sym__preprocessor_call,
    STATE(5692), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [240151] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2547), 1,
      sym__record_body,
    STATE(5658), 1,
      sym__preprocessor_call,
    STATE(5822), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5823), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [240188] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1610), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5631), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5659), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [240225] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1704), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5660), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [240262] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1584), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5608), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5661), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [240299] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1585), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5662), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [240336] = 9,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8445), 1,
      anon_sym_LBRACE,
    ACTIONS(8448), 1,
      anon_sym_DQUOTE,
    ACTIONS(8453), 1,
      sym__interpolated_string_text_fragment,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8450), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(5663), 2,
      sym__preprocessor_call,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [240367] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2578), 1,
      sym__function_body,
    STATE(5664), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [240404] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8456), 1,
      anon_sym_COMMA,
    STATE(5665), 1,
      sym__preprocessor_call,
    STATE(5687), 1,
      aux_sym_order_by_clause_repeat1,
    ACTIONS(8458), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [240429] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1679), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5666), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [240466] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2572), 1,
      sym__function_body,
    STATE(5667), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [240503] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5271), 1,
      sym__record_body,
    STATE(5668), 1,
      sym__preprocessor_call,
    STATE(5708), 1,
      sym_record_base,
    STATE(5868), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [240540] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2514), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5669), 1,
      sym__preprocessor_call,
    STATE(5832), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5846), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [240577] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5257), 1,
      sym__record_body,
    STATE(5670), 1,
      sym__preprocessor_call,
    STATE(5744), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5824), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [240614] = 9,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8460), 1,
      anon_sym_LBRACE,
    ACTIONS(8463), 1,
      anon_sym_DQUOTE,
    ACTIONS(8468), 1,
      sym__interpolated_verbatim_string_text_fragment,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8465), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(5671), 2,
      sym__preprocessor_call,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [240645] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2570), 1,
      sym__function_body,
    STATE(5672), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [240682] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2568), 1,
      sym__function_body,
    STATE(5664), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5673), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [240719] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2567), 1,
      sym__function_body,
    STATE(5674), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [240756] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2563), 1,
      sym__function_body,
    STATE(5675), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [240793] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2574), 1,
      sym__function_body,
    STATE(5619), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5676), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [240830] = 10,
    ACTIONS(8378), 1,
      anon_sym_DQUOTE,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8390), 1,
      anon_sym_LBRACE,
    ACTIONS(8396), 1,
      sym__interpolated_string_text_fragment,
    STATE(5663), 1,
      aux_sym_interpolated_string_expression_repeat1,
    STATE(5677), 1,
      sym__preprocessor_call,
    STATE(6048), 1,
      sym__interpolated_string_content,
    ACTIONS(8394), 2,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
    STATE(6058), 2,
      sym_interpolated_string_text,
      sym_interpolation,
  [240863] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1684), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5652), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5678), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [240900] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2457), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5679), 1,
      sym__preprocessor_call,
    STATE(5706), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5786), 1,
      sym_record_base,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [240937] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8365), 1,
      anon_sym_LT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(5680), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 7,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_DOT,
      anon_sym_RBRACK,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_DASH_GT,
  [240962] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2367), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5681), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [240999] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1682), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5660), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5682), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [241036] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2387), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5675), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5683), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [241073] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8388), 1,
      anon_sym_SEMI,
    STATE(1680), 1,
      sym__function_body,
    STATE(1723), 1,
      sym_block,
    STATE(5684), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6694), 1,
      sym_arrow_expression_clause,
  [241110] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2382), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5685), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [241147] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2400), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5686), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [241184] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8471), 1,
      anon_sym_COMMA,
    STATE(5687), 2,
      sym__preprocessor_call,
      aux_sym_order_by_clause_repeat1,
    ACTIONS(8474), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [241207] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2393), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5667), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5688), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [241244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8456), 1,
      anon_sym_COMMA,
    STATE(5665), 1,
      aux_sym_order_by_clause_repeat1,
    STATE(5689), 1,
      sym__preprocessor_call,
    ACTIONS(8476), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [241269] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2383), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5674), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5690), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [241306] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2428), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5691), 1,
      sym__preprocessor_call,
    STATE(5844), 1,
      sym_record_base,
    STATE(5859), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [241343] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8406), 1,
      anon_sym_SEMI,
    STATE(1601), 1,
      sym__function_body,
    STATE(1616), 1,
      sym_block,
    STATE(5692), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6803), 1,
      sym_arrow_expression_clause,
  [241380] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2392), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5693), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [241417] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8352), 1,
      anon_sym_COLON,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5189), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5694), 1,
      sym__preprocessor_call,
    STATE(5791), 1,
      sym_record_base,
    STATE(5804), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [241454] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8350), 1,
      anon_sym_LT,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5107), 1,
      sym_declaration_list,
    STATE(5695), 1,
      sym__preprocessor_call,
    STATE(5870), 1,
      sym_type_parameter_list,
    STATE(6010), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6013), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [241491] = 10,
    ACTIONS(8376), 1,
      anon_sym_LBRACE,
    ACTIONS(8382), 1,
      sym__interpolated_verbatim_string_text_fragment,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8443), 1,
      anon_sym_DQUOTE,
    STATE(5574), 1,
      aux_sym_interpolated_string_expression_repeat2,
    STATE(5696), 1,
      sym__preprocessor_call,
    STATE(6032), 1,
      sym__interpolated_verbatim_string_content,
    ACTIONS(8380), 2,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
    STATE(6047), 2,
      sym_interpolated_verbatim_string_text,
      sym_interpolation,
  [241524] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5697), 1,
      sym__preprocessor_call,
    ACTIONS(8474), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [241544] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    ACTIONS(8478), 1,
      anon_sym_COLON,
    STATE(2425), 1,
      sym_block,
    STATE(2546), 1,
      sym__function_body,
    STATE(5698), 1,
      sym__preprocessor_call,
    STATE(5885), 1,
      sym_constructor_initializer,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [241578] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(2265), 1,
      sym_accessor_list,
    STATE(5690), 1,
      sym_parameter_list,
    STATE(5699), 1,
      sym__preprocessor_call,
    STATE(6578), 1,
      sym_type_parameter_list,
    STATE(6692), 1,
      sym_arrow_expression_clause,
  [241612] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(2298), 1,
      sym_accessor_list,
    STATE(5623), 1,
      sym_parameter_list,
    STATE(5700), 1,
      sym__preprocessor_call,
    STATE(6532), 1,
      sym_type_parameter_list,
    STATE(6818), 1,
      sym_arrow_expression_clause,
  [241646] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5701), 1,
      sym__preprocessor_call,
    ACTIONS(8480), 8,
      anon_sym_COMMA,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [241666] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    ACTIONS(8478), 1,
      anon_sym_COLON,
    STATE(2369), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5702), 1,
      sym__preprocessor_call,
    STATE(5900), 1,
      sym_constructor_initializer,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [241700] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(2198), 1,
      sym_accessor_list,
    STATE(5646), 1,
      sym_parameter_list,
    STATE(5703), 1,
      sym__preprocessor_call,
    STATE(6598), 1,
      sym_type_parameter_list,
    STATE(6707), 1,
      sym_arrow_expression_clause,
  [241734] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    ACTIONS(8478), 1,
      anon_sym_COLON,
    STATE(2379), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5704), 1,
      sym__preprocessor_call,
    STATE(5910), 1,
      sym_constructor_initializer,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [241768] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5705), 1,
      sym__preprocessor_call,
    ACTIONS(8482), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [241794] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2558), 1,
      sym__record_body,
    STATE(5706), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [241825] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2562), 1,
      sym__record_body,
    STATE(5707), 1,
      sym__preprocessor_call,
    STATE(5796), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [241856] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5187), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5708), 1,
      sym__preprocessor_call,
    STATE(5803), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [241887] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2291), 1,
      sym_declaration_list,
    STATE(5709), 1,
      sym__preprocessor_call,
    STATE(6037), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6038), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [241918] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2287), 1,
      sym_declaration_list,
    STATE(5710), 1,
      sym__preprocessor_call,
    STATE(6034), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6035), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [241949] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5328), 1,
      sym__record_body,
    STATE(5711), 1,
      sym__preprocessor_call,
    STATE(5743), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [241980] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2277), 1,
      sym_declaration_list,
    STATE(5712), 1,
      sym__preprocessor_call,
    STATE(6027), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6030), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242011] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5194), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5713), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242042] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5200), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5714), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242073] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5715), 1,
      sym__preprocessor_call,
    STATE(6123), 1,
      aux_sym_type_argument_list_repeat2,
    ACTIONS(8486), 2,
      anon_sym_LBRACE,
      anon_sym_where,
  [242102] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5330), 1,
      sym__record_body,
    STATE(5716), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242133] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5078), 1,
      sym_declaration_list,
    STATE(5717), 1,
      sym__preprocessor_call,
    STATE(5961), 1,
      sym_base_list,
    STATE(5963), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242164] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2349), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5718), 1,
      sym__preprocessor_call,
    STATE(5826), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242195] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    ACTIONS(8490), 1,
      anon_sym_COMMA,
    STATE(5719), 1,
      sym__preprocessor_call,
    STATE(6083), 1,
      aux_sym_record_base_repeat1,
    STATE(6176), 1,
      sym_argument_list,
    ACTIONS(8488), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
  [242222] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5207), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5720), 1,
      sym__preprocessor_call,
    STATE(5838), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242253] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5178), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5721), 1,
      sym__preprocessor_call,
    STATE(5762), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242284] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5182), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5722), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242315] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2356), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5723), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242346] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5211), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5724), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242377] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2421), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5725), 1,
      sym__preprocessor_call,
    STATE(5839), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242408] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5092), 1,
      sym_declaration_list,
    STATE(5726), 1,
      sym__preprocessor_call,
    STATE(5970), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5979), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242439] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5352), 1,
      sym__record_body,
    STATE(5714), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5727), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242470] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5362), 1,
      sym__record_body,
    STATE(5728), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242501] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5170), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5729), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242532] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5358), 1,
      sym__record_body,
    STATE(5730), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242563] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5058), 1,
      sym_declaration_list,
    STATE(5731), 1,
      sym__preprocessor_call,
    STATE(5981), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5985), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242594] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5063), 1,
      sym_declaration_list,
    STATE(5732), 1,
      sym__preprocessor_call,
    STATE(5964), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5965), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242625] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2534), 1,
      sym__record_body,
    STATE(5733), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242656] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5181), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5734), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242687] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5054), 1,
      sym_declaration_list,
    STATE(5735), 1,
      sym__preprocessor_call,
    STATE(5921), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5926), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242718] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5377), 1,
      sym__record_body,
    STATE(5729), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5736), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242749] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5386), 1,
      sym__record_body,
    STATE(5737), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242780] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5327), 1,
      sym__record_body,
    STATE(5738), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242811] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2431), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5739), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242842] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5046), 1,
      sym_declaration_list,
    STATE(5740), 1,
      sym__preprocessor_call,
    STATE(5929), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5943), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242873] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2423), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5741), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242904] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2615), 1,
      sym__record_body,
    STATE(5742), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242935] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5196), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5743), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242966] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5173), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5744), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [242997] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5231), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5745), 1,
      sym__preprocessor_call,
    STATE(5835), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243028] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5363), 1,
      sym__record_body,
    STATE(5746), 1,
      sym__preprocessor_call,
    STATE(5802), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243059] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5235), 1,
      sym__record_body,
    STATE(5747), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243090] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5365), 1,
      sym__record_body,
    STATE(5748), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243121] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2424), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5749), 1,
      sym__preprocessor_call,
    STATE(5841), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243152] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5238), 1,
      sym__record_body,
    STATE(5750), 1,
      sym__preprocessor_call,
    STATE(5787), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243183] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5191), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5751), 1,
      sym__preprocessor_call,
    STATE(5866), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243214] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5414), 1,
      sym__record_body,
    STATE(5752), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243245] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2426), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5753), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243276] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5186), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5754), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243307] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5249), 1,
      sym__record_body,
    STATE(5755), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243338] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5185), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5756), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243369] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2430), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5757), 1,
      sym__preprocessor_call,
    STATE(5861), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243400] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5195), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5758), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243431] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5183), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5759), 1,
      sym__preprocessor_call,
    STATE(5777), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243462] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5258), 1,
      sym__record_body,
    STATE(5752), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5760), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243493] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2432), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5761), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243524] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5366), 1,
      sym__record_body,
    STATE(5762), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243555] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2429), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5763), 1,
      sym__preprocessor_call,
    STATE(5854), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243586] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2829), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8325), 1,
      anon_sym_LT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(5593), 1,
      sym_parameter_list,
    STATE(5764), 1,
      sym__preprocessor_call,
    STATE(6545), 1,
      sym_type_parameter_list,
  [243617] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5264), 1,
      sym__record_body,
    STATE(5765), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243648] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5410), 1,
      sym__record_body,
    STATE(5766), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243679] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(5767), 1,
      sym__preprocessor_call,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
    ACTIONS(8321), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [243706] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5406), 1,
      sym__record_body,
    STATE(5768), 1,
      sym__preprocessor_call,
    STATE(5793), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243737] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5267), 1,
      sym__record_body,
    STATE(5769), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243768] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2627), 1,
      sym__record_body,
    STATE(5770), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243799] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2302), 1,
      sym_declaration_list,
    STATE(5771), 1,
      sym__preprocessor_call,
    STATE(5941), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5942), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243830] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2422), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5772), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243861] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5270), 1,
      sym__record_body,
    STATE(5773), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243892] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2378), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5774), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243923] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2624), 1,
      sym__record_body,
    STATE(5775), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243954] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2623), 1,
      sym__record_body,
    STATE(5776), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [243985] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5317), 1,
      sym__record_body,
    STATE(5777), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244016] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2463), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5778), 1,
      sym__preprocessor_call,
    STATE(5862), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244047] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2465), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5779), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244078] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5780), 1,
      sym__preprocessor_call,
    ACTIONS(8492), 4,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_where,
  [244103] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2306), 1,
      sym_declaration_list,
    STATE(5781), 1,
      sym__preprocessor_call,
    STATE(5917), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5939), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244134] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2622), 1,
      sym__record_body,
    STATE(5782), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244165] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2621), 1,
      sym__record_body,
    STATE(5770), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5783), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244196] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2620), 1,
      sym__record_body,
    STATE(5784), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244227] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2312), 1,
      sym_declaration_list,
    STATE(5785), 1,
      sym__preprocessor_call,
    STATE(5935), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5936), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244258] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2556), 1,
      sym__record_body,
    STATE(5786), 1,
      sym__preprocessor_call,
    STATE(5806), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244289] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5405), 1,
      sym__record_body,
    STATE(5787), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244320] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5237), 1,
      sym__record_body,
    STATE(5788), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244351] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5344), 1,
      sym__record_body,
    STATE(5789), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244382] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5299), 1,
      sym__record_body,
    STATE(5790), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244413] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5273), 1,
      sym__record_body,
    STATE(5789), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5791), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244444] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2475), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5792), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244475] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5272), 1,
      sym__record_body,
    STATE(5793), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244506] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2539), 1,
      sym__record_body,
    STATE(5794), 1,
      sym__preprocessor_call,
    STATE(5856), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244537] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2476), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5795), 1,
      sym__preprocessor_call,
    STATE(5852), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244568] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2611), 1,
      sym__record_body,
    STATE(5796), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244599] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2478), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5797), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244630] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2479), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5798), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244661] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2610), 1,
      sym__record_body,
    STATE(5799), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244692] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2609), 1,
      sym__record_body,
    STATE(5775), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5800), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244723] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2480), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5801), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244754] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5329), 1,
      sym__record_body,
    STATE(5802), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244785] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5368), 1,
      sym__record_body,
    STATE(5803), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244816] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5143), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5804), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244847] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2377), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5805), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244878] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2608), 1,
      sym__record_body,
    STATE(5806), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244909] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5274), 1,
      sym__record_body,
    STATE(5807), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244940] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2607), 1,
      sym__record_body,
    STATE(5808), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [244971] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5275), 1,
      sym__record_body,
    STATE(5809), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245002] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2606), 1,
      sym__record_body,
    STATE(5810), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245033] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5316), 1,
      sym__record_body,
    STATE(5811), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245064] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5284), 1,
      sym__record_body,
    STATE(5788), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5812), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245095] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5262), 1,
      sym__record_body,
    STATE(5722), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5813), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245126] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5288), 1,
      sym__record_body,
    STATE(5814), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245157] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2510), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5815), 1,
      sym__preprocessor_call,
    STATE(5848), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245188] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5281), 1,
      sym__record_body,
    STATE(5816), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245219] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5268), 1,
      sym__record_body,
    STATE(5756), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5817), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245250] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2605), 1,
      sym__record_body,
    STATE(5776), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5818), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245281] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2512), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5819), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245312] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2364), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5792), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5820), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245343] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5315), 1,
      sym__record_body,
    STATE(5769), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5821), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245374] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2603), 1,
      sym__record_body,
    STATE(5822), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245405] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2602), 1,
      sym__record_body,
    STATE(5784), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5823), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245436] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5171), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5728), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5824), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245467] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2366), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5825), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245498] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2433), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5826), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245529] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2375), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5801), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5827), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245560] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2587), 1,
      sym__record_body,
    STATE(5828), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245591] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5355), 1,
      sym__record_body,
    STATE(5738), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5829), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245622] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2586), 1,
      sym__record_body,
    STATE(5830), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245653] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5361), 1,
      sym__record_body,
    STATE(5831), 1,
      sym__preprocessor_call,
    STATE(5840), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245684] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2585), 1,
      sym__record_body,
    STATE(5832), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245715] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5141), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5713), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5833), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245746] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5357), 1,
      sym__record_body,
    STATE(5834), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245777] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5404), 1,
      sym__record_body,
    STATE(5835), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245808] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5278), 1,
      sym__record_body,
    STATE(5836), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245839] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2518), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5837), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245870] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5147), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5838), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245901] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2519), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5839), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245932] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5279), 1,
      sym__record_body,
    STATE(5840), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245963] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2520), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5841), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [245994] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2256), 1,
      sym_declaration_list,
    STATE(5842), 1,
      sym__preprocessor_call,
    STATE(5938), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6077), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246025] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5843), 1,
      sym__preprocessor_call,
    ACTIONS(5689), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [246044] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2521), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5828), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5844), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246075] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2253), 1,
      sym_declaration_list,
    STATE(5845), 1,
      sym__preprocessor_call,
    STATE(5948), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6062), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246106] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2584), 1,
      sym__record_body,
    STATE(5742), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5846), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246137] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2829), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8325), 1,
      anon_sym_LT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(5644), 1,
      sym_parameter_list,
    STATE(5847), 1,
      sym__preprocessor_call,
    STATE(6540), 1,
      sym_type_parameter_list,
  [246168] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2583), 1,
      sym__record_body,
    STATE(5848), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246199] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2370), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5798), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5849), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246230] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(2245), 1,
      sym_declaration_list,
    STATE(5850), 1,
      sym__preprocessor_call,
    STATE(6022), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6023), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5851), 1,
      sym__preprocessor_call,
    ACTIONS(8494), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [246280] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2569), 1,
      sym__record_body,
    STATE(5852), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246311] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2372), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5853), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246342] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2374), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5854), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246373] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5095), 1,
      sym_declaration_list,
    STATE(5855), 1,
      sym__preprocessor_call,
    STATE(6069), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6070), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246404] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2414), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5856), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246435] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2416), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5857), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246466] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5391), 1,
      sym__record_body,
    STATE(5814), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5858), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246497] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2523), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5859), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246528] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5087), 1,
      sym_declaration_list,
    STATE(5860), 1,
      sym__preprocessor_call,
    STATE(6044), 1,
      sym_base_list,
    STATE(6063), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246559] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2524), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5861), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246590] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2565), 1,
      sym__record_body,
    STATE(5862), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5863), 1,
      sym__preprocessor_call,
    ACTIONS(8496), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [246640] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2564), 1,
      sym__record_body,
    STATE(5864), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246671] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2373), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5865), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246702] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5144), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5866), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246733] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5400), 1,
      sym__record_body,
    STATE(5867), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246764] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5192), 1,
      sym__record_body,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5868), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246795] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5397), 1,
      sym__record_body,
    STATE(5807), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5869), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246826] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    STATE(5045), 1,
      sym_declaration_list,
    STATE(5870), 1,
      sym__preprocessor_call,
    STATE(6043), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6045), 1,
      sym_base_list,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246857] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2434), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5865), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5871), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246888] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2516), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5830), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5872), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246919] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5873), 1,
      sym__preprocessor_call,
    ACTIONS(8498), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [246938] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2555), 1,
      sym__record_body,
    STATE(5874), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [246969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5875), 1,
      sym__preprocessor_call,
    ACTIONS(8500), 7,
      anon_sym_where,
      anon_sym_from,
      anon_sym_join,
      anon_sym_let,
      anon_sym_orderby,
      anon_sym_group,
      anon_sym_select,
  [246988] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8358), 1,
      anon_sym_SEMI,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5232), 1,
      sym_declaration_list,
    STATE(5393), 1,
      sym__record_body,
    STATE(5876), 1,
      sym__preprocessor_call,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [247019] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2417), 1,
      sym__record_body,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(5774), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5877), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [247050] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2829), 1,
      anon_sym_DOT,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8325), 1,
      anon_sym_LT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(5632), 1,
      sym_parameter_list,
    STATE(5878), 1,
      sym__preprocessor_call,
    STATE(6619), 1,
      sym_type_parameter_list,
  [247081] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8348), 1,
      anon_sym_SEMI,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2530), 1,
      sym_declaration_list,
    STATE(2553), 1,
      sym__record_body,
    STATE(5808), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5879), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [247112] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2526), 1,
      sym__function_body,
    STATE(5880), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247140] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8504), 1,
      anon_sym_COMMA,
    STATE(5881), 1,
      sym__preprocessor_call,
    STATE(5901), 1,
      aux_sym_type_parameter_constraints_clause_repeat1,
    ACTIONS(8502), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [247162] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8506), 1,
      anon_sym_LPAREN,
    ACTIONS(8508), 1,
      anon_sym_when,
    STATE(1646), 1,
      sym_block,
    STATE(5882), 1,
      sym__preprocessor_call,
    STATE(6117), 1,
      sym_catch_declaration,
    STATE(6582), 1,
      sym_catch_filter_clause,
  [247190] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    ACTIONS(8510), 1,
      anon_sym_GT,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5883), 1,
      sym__preprocessor_call,
    STATE(6386), 1,
      aux_sym_type_argument_list_repeat2,
  [247218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5884), 1,
      sym__preprocessor_call,
    ACTIONS(2729), 6,
      sym__preproc_directive_end,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [247236] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2404), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5885), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247264] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8506), 1,
      anon_sym_LPAREN,
    ACTIONS(8508), 1,
      anon_sym_when,
    STATE(1554), 1,
      sym_block,
    STATE(5886), 1,
      sym__preprocessor_call,
    STATE(6125), 1,
      sym_catch_declaration,
    STATE(6535), 1,
      sym_catch_filter_clause,
  [247292] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2481), 1,
      sym__function_body,
    STATE(5887), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8504), 1,
      anon_sym_COMMA,
    STATE(5881), 1,
      aux_sym_type_parameter_constraints_clause_repeat1,
    STATE(5888), 1,
      sym__preprocessor_call,
    ACTIONS(8512), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [247342] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2489), 1,
      sym__function_body,
    STATE(5889), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247370] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5890), 1,
      sym__preprocessor_call,
    ACTIONS(2835), 6,
      sym__preproc_directive_end,
      anon_sym_COMMA,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [247388] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8514), 1,
      anon_sym_SEMI,
    ACTIONS(8517), 1,
      anon_sym_LBRACE,
    ACTIONS(8520), 1,
      anon_sym_EQ_GT,
    STATE(4143), 1,
      sym_block,
    STATE(4154), 1,
      sym__function_body,
    STATE(5891), 1,
      sym__preprocessor_call,
    STATE(6772), 1,
      sym_arrow_expression_clause,
  [247416] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    ACTIONS(8523), 1,
      anon_sym_GT,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5892), 1,
      sym__preprocessor_call,
    STATE(6407), 1,
      aux_sym_type_argument_list_repeat2,
  [247444] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8525), 1,
      anon_sym_SEMI,
    ACTIONS(8527), 1,
      anon_sym_LBRACE,
    STATE(4143), 1,
      sym_block,
    STATE(4144), 1,
      sym__function_body,
    STATE(5893), 1,
      sym__preprocessor_call,
    STATE(6772), 1,
      sym_arrow_expression_clause,
  [247472] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2501), 1,
      sym__function_body,
    STATE(5894), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247500] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8531), 1,
      anon_sym_QMARK,
    STATE(5895), 1,
      sym__preprocessor_call,
    ACTIONS(8529), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [247520] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2493), 1,
      sym__function_body,
    STATE(5896), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247548] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    ACTIONS(8533), 1,
      anon_sym_GT,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5897), 1,
      sym__preprocessor_call,
    STATE(6240), 1,
      aux_sym_type_argument_list_repeat2,
  [247576] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2376), 1,
      sym__function_body,
    STATE(2425), 1,
      sym_block,
    STATE(5898), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247604] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5899), 1,
      sym__preprocessor_call,
    ACTIONS(8535), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_in,
  [247622] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2441), 1,
      sym__function_body,
    STATE(5900), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8539), 1,
      anon_sym_COMMA,
    STATE(5901), 2,
      sym__preprocessor_call,
      aux_sym_type_parameter_constraints_clause_repeat1,
    ACTIONS(8537), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [247670] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    ACTIONS(8542), 1,
      anon_sym_GT,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5902), 1,
      sym__preprocessor_call,
    STATE(6368), 1,
      aux_sym_type_argument_list_repeat2,
  [247698] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2486), 1,
      sym__function_body,
    STATE(5903), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247726] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2593), 1,
      sym__function_body,
    STATE(5904), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247754] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(5905), 1,
      sym__preprocessor_call,
    STATE(6256), 1,
      sym_equals_value_clause,
    ACTIONS(3000), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_and,
      anon_sym_or,
  [247776] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8514), 1,
      anon_sym_SEMI,
    ACTIONS(8517), 1,
      anon_sym_LBRACE,
    ACTIONS(8520), 1,
      anon_sym_EQ_GT,
    STATE(4143), 1,
      sym_block,
    STATE(4355), 1,
      sym__function_body,
    STATE(5906), 1,
      sym__preprocessor_call,
    STATE(6772), 1,
      sym_arrow_expression_clause,
  [247804] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8525), 1,
      anon_sym_SEMI,
    ACTIONS(8527), 1,
      anon_sym_LBRACE,
    STATE(4120), 1,
      sym__function_body,
    STATE(4143), 1,
      sym_block,
    STATE(5907), 1,
      sym__preprocessor_call,
    STATE(6772), 1,
      sym_arrow_expression_clause,
  [247832] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8546), 1,
      anon_sym_where,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(5908), 2,
      sym__preprocessor_call,
      aux_sym_method_declaration_repeat1,
    ACTIONS(8544), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [247854] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8525), 1,
      anon_sym_SEMI,
    ACTIONS(8527), 1,
      anon_sym_LBRACE,
    STATE(4143), 1,
      sym_block,
    STATE(4360), 1,
      sym__function_body,
    STATE(5909), 1,
      sym__preprocessor_call,
    STATE(6772), 1,
      sym_arrow_expression_clause,
  [247882] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2559), 1,
      sym__function_body,
    STATE(5910), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247910] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8514), 1,
      anon_sym_SEMI,
    ACTIONS(8517), 1,
      anon_sym_LBRACE,
    ACTIONS(8520), 1,
      anon_sym_EQ_GT,
    STATE(4118), 1,
      sym__function_body,
    STATE(4143), 1,
      sym_block,
    STATE(5911), 1,
      sym__preprocessor_call,
    STATE(6772), 1,
      sym_arrow_expression_clause,
  [247938] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    ACTIONS(8408), 1,
      anon_sym_SEMI,
    ACTIONS(8410), 1,
      anon_sym_LBRACE,
    STATE(2425), 1,
      sym_block,
    STATE(2466), 1,
      sym__function_body,
    STATE(5912), 1,
      sym__preprocessor_call,
    STATE(6801), 1,
      sym_arrow_expression_clause,
  [247966] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(955), 1,
      anon_sym_LBRACK,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8321), 1,
      anon_sym_RPAREN,
    ACTIONS(8549), 1,
      anon_sym_COMMA,
    STATE(5913), 1,
      sym__preprocessor_call,
    STATE(6020), 1,
      sym_bracketed_argument_list,
    STATE(6367), 1,
      sym_equals_value_clause,
  [247994] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7749), 1,
      anon_sym_EQ,
    ACTIONS(8365), 1,
      anon_sym_LT,
    STATE(1785), 1,
      sym_type_argument_list,
    STATE(5914), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
  [248020] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    ACTIONS(8552), 1,
      anon_sym_GT,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5915), 1,
      sym__preprocessor_call,
    STATE(6317), 1,
      aux_sym_type_argument_list_repeat2,
  [248048] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5916), 1,
      sym__preprocessor_call,
    ACTIONS(8554), 6,
      anon_sym_SEMI,
      anon_sym_EQ,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RPAREN,
      anon_sym_in,
  [248066] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2279), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5917), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5918), 1,
      sym__preprocessor_call,
    ACTIONS(8556), 5,
      sym__preproc_directive_end,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [248108] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5094), 1,
      sym_declaration_list,
    STATE(5919), 1,
      sym__preprocessor_call,
    STATE(6068), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248133] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2241), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5920), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248158] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5126), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5921), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248183] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2300), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5922), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248208] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2308), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5923), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248233] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2243), 1,
      sym_declaration_list,
    STATE(5924), 1,
      sym__preprocessor_call,
    STATE(6009), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248258] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2311), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5925), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248283] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5130), 1,
      sym_declaration_list,
    STATE(5926), 1,
      sym__preprocessor_call,
    STATE(6018), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248308] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5131), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5927), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248333] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2249), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5928), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248358] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5133), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5929), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248383] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2251), 1,
      sym_declaration_list,
    STATE(5930), 1,
      sym__preprocessor_call,
    STATE(6039), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248408] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8560), 1,
      sym__interpolated_string_text_fragment,
    STATE(5931), 1,
      sym__preprocessor_call,
    ACTIONS(8558), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
  [248427] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2254), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5932), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248452] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2255), 1,
      sym_declaration_list,
    STATE(5933), 1,
      sym__preprocessor_call,
    STATE(5988), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248477] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2273), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5934), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248502] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2274), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5935), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248527] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2275), 1,
      sym_declaration_list,
    STATE(5936), 1,
      sym__preprocessor_call,
    STATE(6060), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248552] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2278), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5937), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248577] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2222), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5938), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248602] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2290), 1,
      sym_declaration_list,
    STATE(5939), 1,
      sym__preprocessor_call,
    STATE(6053), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248627] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2293), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5940), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248652] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2294), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5941), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248677] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2304), 1,
      sym_declaration_list,
    STATE(5942), 1,
      sym__preprocessor_call,
    STATE(6051), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248702] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5140), 1,
      sym_declaration_list,
    STATE(5943), 1,
      sym__preprocessor_call,
    STATE(6079), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248727] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5102), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5944), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248752] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8564), 1,
      anon_sym_COMMA,
    STATE(5945), 2,
      sym__preprocessor_call,
      aux_sym_record_base_repeat1,
    ACTIONS(8562), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
  [248771] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5898), 1,
      sym_parameter_list,
    STATE(5946), 1,
      sym__preprocessor_call,
  [248796] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8490), 1,
      anon_sym_COMMA,
    STATE(5947), 1,
      sym__preprocessor_call,
    STATE(6091), 1,
      aux_sym_record_base_repeat1,
    ACTIONS(8567), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
  [248817] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2239), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5948), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248842] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5100), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5949), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5950), 1,
      sym__preprocessor_call,
    ACTIONS(8569), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [248884] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5090), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5951), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248909] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5113), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5952), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [248934] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6398), 1,
      anon_sym_LBRACE,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8571), 1,
      anon_sym_STAR,
    STATE(2260), 1,
      sym_block,
    STATE(5953), 1,
      sym__preprocessor_call,
    STATE(6551), 1,
      sym_parameter_list,
  [248959] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8575), 1,
      anon_sym_AMP_AMP,
    STATE(5954), 1,
      sym__preprocessor_call,
    ACTIONS(8556), 2,
      anon_sym_RPAREN,
      anon_sym_PIPE_PIPE,
    ACTIONS(8573), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [248980] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5955), 1,
      sym__preprocessor_call,
    ACTIONS(8577), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [249003] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8581), 1,
      sym__interpolated_verbatim_string_text_fragment,
    STATE(5956), 1,
      sym__preprocessor_call,
    ACTIONS(8579), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
  [249022] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5125), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5957), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249047] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(5958), 1,
      sym__preprocessor_call,
    STATE(6347), 1,
      sym_equals_value_clause,
    ACTIONS(8583), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [249068] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8585), 1,
      anon_sym_EQ_GT,
    ACTIONS(8587), 1,
      anon_sym_and,
    ACTIONS(8589), 1,
      anon_sym_or,
    ACTIONS(8591), 1,
      anon_sym_when,
    STATE(5959), 1,
      sym__preprocessor_call,
    STATE(6924), 1,
      sym_when_clause,
  [249093] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5124), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5960), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249118] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5098), 1,
      sym_declaration_list,
    STATE(5961), 1,
      sym__preprocessor_call,
    STATE(6084), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8595), 1,
      anon_sym_and,
    ACTIONS(8597), 1,
      anon_sym_or,
    STATE(5962), 1,
      sym__preprocessor_call,
    ACTIONS(8593), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [249164] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5097), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5963), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249189] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5127), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5964), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249214] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5128), 1,
      sym_declaration_list,
    STATE(5965), 1,
      sym__preprocessor_call,
    STATE(5974), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249239] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2345), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5966), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249264] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5132), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5967), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249289] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2342), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5968), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249314] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2341), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5969), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249339] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5134), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5970), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249364] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(5971), 1,
      sym__preprocessor_call,
    STATE(6256), 1,
      sym_equals_value_clause,
    ACTIONS(8599), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [249385] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8595), 1,
      anon_sym_and,
    ACTIONS(8597), 1,
      anon_sym_or,
    STATE(5972), 1,
      sym__preprocessor_call,
    ACTIONS(5570), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [249406] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5973), 1,
      sym__preprocessor_call,
    ACTIONS(8573), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8556), 3,
      anon_sym_RPAREN,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [249425] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5122), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5974), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249450] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8603), 1,
      sym__interpolated_verbatim_string_text_fragment,
    STATE(5975), 1,
      sym__preprocessor_call,
    ACTIONS(8601), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
  [249469] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5082), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5976), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249494] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2315), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5977), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249519] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2313), 1,
      sym_declaration_list,
    STATE(5934), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5978), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249544] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5139), 1,
      sym_declaration_list,
    STATE(5957), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5979), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249569] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(5980), 1,
      sym__preprocessor_call,
    STATE(6382), 1,
      sym_equals_value_clause,
    ACTIONS(8605), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [249590] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5106), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5981), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249615] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2309), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5982), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249640] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2307), 1,
      sym_declaration_list,
    STATE(5937), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5983), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249665] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5040), 1,
      sym_declaration_list,
    STATE(5952), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5984), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249690] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5088), 1,
      sym_declaration_list,
    STATE(5985), 1,
      sym__preprocessor_call,
    STATE(6055), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8607), 1,
      anon_sym_COMMA,
    STATE(5986), 2,
      sym__preprocessor_call,
      aux_sym_type_argument_list_repeat2,
    ACTIONS(8492), 3,
      anon_sym_GT,
      anon_sym_LBRACE,
      anon_sym_where,
  [249734] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8612), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8614), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8616), 1,
      sym__preproc_directive_end,
    STATE(5987), 1,
      sym__preprocessor_call,
    ACTIONS(8610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [249757] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2235), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5988), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249782] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8612), 1,
      anon_sym_AMP_AMP,
    STATE(5989), 1,
      sym__preprocessor_call,
    ACTIONS(8556), 2,
      sym__preproc_directive_end,
      anon_sym_PIPE_PIPE,
    ACTIONS(8610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [249803] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2305), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5990), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249828] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2303), 1,
      sym_declaration_list,
    STATE(5940), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5991), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249853] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5120), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5992), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249878] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5091), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(5993), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [249903] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5994), 1,
      sym__preprocessor_call,
    ACTIONS(8610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
    ACTIONS(8556), 3,
      sym__preproc_directive_end,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [249922] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8603), 1,
      sym__interpolated_string_text_fragment,
    STATE(5995), 1,
      sym__preprocessor_call,
    ACTIONS(8601), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
  [249941] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8612), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8614), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8618), 1,
      sym__preproc_directive_end,
    STATE(5996), 1,
      sym__preprocessor_call,
    ACTIONS(8610), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [249964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5997), 1,
      sym__preprocessor_call,
    ACTIONS(8620), 5,
      sym__preproc_directive_end,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [249981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5998), 1,
      sym__preprocessor_call,
    ACTIONS(8622), 5,
      sym__preproc_directive_end,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [249998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(5999), 1,
      sym__preprocessor_call,
    ACTIONS(8624), 5,
      sym__preproc_directive_end,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [250015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8595), 1,
      anon_sym_and,
    ACTIONS(8597), 1,
      anon_sym_or,
    STATE(6000), 1,
      sym__preprocessor_call,
    ACTIONS(8626), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [250036] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5096), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6001), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250061] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8630), 1,
      sym__interpolated_verbatim_string_text_fragment,
    STATE(6002), 1,
      sym__preprocessor_call,
    ACTIONS(8628), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
  [250080] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5084), 1,
      sym_declaration_list,
    STATE(6003), 1,
      sym__preprocessor_call,
    STATE(6061), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6004), 1,
      sym__preprocessor_call,
    ACTIONS(3390), 5,
      sym__preproc_directive_end,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [250122] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8581), 1,
      sym__interpolated_string_text_fragment,
    STATE(6005), 1,
      sym__preprocessor_call,
    ACTIONS(8579), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
  [250141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6006), 1,
      sym__preprocessor_call,
    ACTIONS(8632), 5,
      sym__preproc_directive_end,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [250158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6007), 1,
      sym__preprocessor_call,
    ACTIONS(8556), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [250175] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8634), 1,
      anon_sym_RPAREN,
    ACTIONS(8636), 1,
      anon_sym_PIPE_PIPE,
    STATE(6008), 1,
      sym__preprocessor_call,
    ACTIONS(8573), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [250198] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2263), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6009), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250223] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5067), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6010), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250248] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8640), 1,
      sym__interpolated_verbatim_string_text_fragment,
    STATE(6011), 1,
      sym__preprocessor_call,
    ACTIONS(8638), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
  [250267] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6012), 1,
      sym__preprocessor_call,
    ACTIONS(8537), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [250284] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5077), 1,
      sym_declaration_list,
    STATE(6013), 1,
      sym__preprocessor_call,
    STATE(6042), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6014), 1,
      sym__preprocessor_call,
    ACTIONS(8642), 5,
      sym__preproc_directive_end,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [250326] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6015), 1,
      sym__preprocessor_call,
    ACTIONS(8644), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [250349] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6016), 1,
      sym__preprocessor_call,
    ACTIONS(8646), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [250366] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5896), 1,
      sym_parameter_list,
    STATE(6017), 1,
      sym__preprocessor_call,
  [250391] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5052), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6018), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250416] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8640), 1,
      sym__interpolated_string_text_fragment,
    STATE(6019), 1,
      sym__preprocessor_call,
    ACTIONS(8638), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
  [250435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(6020), 1,
      sym__preprocessor_call,
    STATE(6333), 1,
      sym_equals_value_clause,
    ACTIONS(8648), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [250456] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2271), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6021), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250481] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2258), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6022), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250506] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2257), 1,
      sym_declaration_list,
    STATE(5925), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6023), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250531] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6024), 1,
      sym__preprocessor_call,
    ACTIONS(8529), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [250548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6025), 1,
      sym__preprocessor_call,
    ACTIONS(8632), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [250565] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2250), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6026), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250590] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2248), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6027), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250615] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5083), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6028), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6029), 1,
      sym__preprocessor_call,
    ACTIONS(8642), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [250657] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2246), 1,
      sym_declaration_list,
    STATE(5966), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6030), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6031), 1,
      sym__preprocessor_call,
    ACTIONS(2969), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [250699] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8652), 1,
      sym__interpolated_verbatim_string_text_fragment,
    STATE(6032), 1,
      sym__preprocessor_call,
    ACTIONS(8650), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
  [250718] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2242), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6033), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250743] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2240), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6034), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250768] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2238), 1,
      sym_declaration_list,
    STATE(5968), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6035), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250793] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2236), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6036), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250818] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2234), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6037), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250843] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2232), 1,
      sym_declaration_list,
    STATE(5969), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6038), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250868] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2252), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6039), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250893] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6398), 1,
      anon_sym_LBRACE,
    ACTIONS(6400), 1,
      anon_sym_STAR,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(2260), 1,
      sym_block,
    STATE(6040), 1,
      sym__preprocessor_call,
    STATE(6551), 1,
      sym_parameter_list,
  [250918] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8654), 1,
      anon_sym_COLON,
    ACTIONS(8656), 1,
      anon_sym_and,
    ACTIONS(8658), 1,
      anon_sym_or,
    ACTIONS(8660), 1,
      anon_sym_when,
    STATE(6041), 1,
      sym__preprocessor_call,
    STATE(6922), 1,
      sym_when_clause,
  [250943] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5076), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6042), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250968] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5073), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6043), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [250993] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5042), 1,
      sym_declaration_list,
    STATE(5949), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6044), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251018] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5059), 1,
      sym_declaration_list,
    STATE(5944), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6045), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251043] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7769), 1,
      anon_sym_LPAREN,
    ACTIONS(8662), 1,
      anon_sym_DOT,
    STATE(6046), 1,
      sym__preprocessor_call,
    STATE(6528), 1,
      sym_attribute_argument_list,
    ACTIONS(7767), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [251066] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8666), 1,
      sym__interpolated_verbatim_string_text_fragment,
    STATE(6047), 1,
      sym__preprocessor_call,
    ACTIONS(8664), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      anon_sym_DQUOTE_DQUOTE,
  [251085] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8670), 1,
      sym__interpolated_string_text_fragment,
    STATE(6048), 1,
      sym__preprocessor_call,
    ACTIONS(8668), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
  [251104] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8575), 1,
      anon_sym_AMP_AMP,
    ACTIONS(8636), 1,
      anon_sym_PIPE_PIPE,
    ACTIONS(8672), 1,
      anon_sym_RPAREN,
    STATE(6049), 1,
      sym__preprocessor_call,
    ACTIONS(8573), 2,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
  [251127] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5048), 1,
      sym_declaration_list,
    STATE(5927), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6050), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251152] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2199), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6051), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6052), 1,
      sym__preprocessor_call,
    ACTIONS(8624), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [251194] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2197), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6053), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251219] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5050), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6054), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251244] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5129), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6055), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251269] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(5880), 1,
      sym_parameter_list,
    STATE(6056), 1,
      sym__preprocessor_call,
  [251294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6057), 1,
      sym__preprocessor_call,
    ACTIONS(8622), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [251311] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8676), 1,
      sym__interpolated_string_text_fragment,
    STATE(6058), 1,
      sym__preprocessor_call,
    ACTIONS(8674), 4,
      anon_sym_LBRACE,
      anon_sym_DQUOTE,
      anon_sym_LBRACE_LBRACE,
      sym_escape_sequence,
  [251330] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5057), 1,
      sym_declaration_list,
    STATE(5992), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6059), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251355] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2194), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6060), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251380] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5051), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6061), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251405] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2237), 1,
      sym_declaration_list,
    STATE(5923), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6062), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251430] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5049), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6063), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6064), 1,
      sym__preprocessor_call,
    ACTIONS(8678), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
  [251472] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5060), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6065), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251497] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8595), 1,
      anon_sym_and,
    STATE(6066), 1,
      sym__preprocessor_call,
    ACTIONS(5396), 4,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
      anon_sym_or,
  [251516] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5108), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6067), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251541] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5038), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6068), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251566] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5041), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6069), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251591] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5043), 1,
      sym_declaration_list,
    STATE(5951), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6070), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251616] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5064), 1,
      sym_declaration_list,
    STATE(5967), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6071), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6072), 1,
      sym__preprocessor_call,
    ACTIONS(8620), 5,
      anon_sym_RPAREN,
      anon_sym_EQ_EQ,
      anon_sym_BANG_EQ,
      anon_sym_AMP_AMP,
      anon_sym_PIPE_PIPE,
  [251658] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5062), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6073), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6074), 1,
      sym__preprocessor_call,
    ACTIONS(8680), 5,
      anon_sym_SEMI,
      anon_sym_COLON,
      anon_sym_LPAREN,
      anon_sym_LBRACE,
      anon_sym_where,
  [251700] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5056), 1,
      sym_declaration_list,
    STATE(5960), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6075), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251725] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6076), 1,
      sym__preprocessor_call,
    ACTIONS(8682), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [251748] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2215), 1,
      sym_declaration_list,
    STATE(5922), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6077), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251773] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5055), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6078), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251798] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5115), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6079), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251823] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5079), 1,
      sym_declaration_list,
    STATE(6001), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6080), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251848] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    STATE(6081), 1,
      sym__preprocessor_call,
    STATE(6389), 1,
      sym_equals_value_clause,
    ACTIONS(8684), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [251869] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2272), 1,
      sym_declaration_list,
    STATE(6026), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6082), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251894] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8490), 1,
      anon_sym_COMMA,
    STATE(5945), 1,
      aux_sym_record_base_repeat1,
    STATE(6083), 1,
      sym__preprocessor_call,
    ACTIONS(8686), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
  [251915] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    STATE(5135), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6084), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251940] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2283), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6085), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251965] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2285), 1,
      sym_declaration_list,
    STATE(6033), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6086), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [251990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6087), 1,
      sym__preprocessor_call,
    ACTIONS(8688), 5,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [252007] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2288), 1,
      sym_declaration_list,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6088), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [252032] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8356), 1,
      anon_sym_where,
    STATE(2289), 1,
      sym_declaration_list,
    STATE(6036), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6089), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [252057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8690), 1,
      anon_sym_COMMA,
    STATE(6090), 2,
      sym__preprocessor_call,
      aux_sym_for_statement_repeat1,
    ACTIONS(6416), 3,
      anon_sym_SEMI,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [252076] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8490), 1,
      anon_sym_COMMA,
    STATE(5945), 1,
      aux_sym_record_base_repeat1,
    STATE(6091), 1,
      sym__preprocessor_call,
    ACTIONS(8693), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
  [252097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8697), 1,
      anon_sym_COMMA,
    ACTIONS(8695), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
    STATE(6092), 2,
      sym__preprocessor_call,
      aux_sym_variable_declaration_repeat1,
  [252115] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8700), 1,
      anon_sym_COMMA,
    ACTIONS(8703), 2,
      anon_sym_GT,
      anon_sym_RBRACK,
    STATE(6093), 2,
      sym__preprocessor_call,
      aux_sym_type_argument_list_repeat1,
  [252133] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8705), 1,
      anon_sym_SEMI,
    STATE(6094), 1,
      sym__preprocessor_call,
    STATE(6204), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [252155] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5678), 1,
      sym_parameter_list,
    STATE(6095), 1,
      sym__preprocessor_call,
    STATE(6479), 1,
      sym_type_parameter_list,
  [252177] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8707), 1,
      anon_sym_LT,
    ACTIONS(8709), 1,
      anon_sym_unmanaged,
    ACTIONS(8711), 1,
      anon_sym_managed,
    STATE(6096), 1,
      sym__preprocessor_call,
    STATE(6860), 1,
      sym_function_pointer_calling_convention,
  [252199] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8713), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6097), 1,
      sym__preprocessor_call,
  [252221] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8715), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6098), 1,
      sym__preprocessor_call,
  [252243] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8717), 1,
      anon_sym_COMMA,
    STATE(6099), 1,
      sym__preprocessor_call,
    ACTIONS(8488), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_where,
  [252261] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8719), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6100), 1,
      sym__preprocessor_call,
  [252283] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8721), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6101), 1,
      sym__preprocessor_call,
  [252305] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6398), 1,
      anon_sym_LBRACE,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(2193), 1,
      sym_block,
    STATE(6102), 1,
      sym__preprocessor_call,
    STATE(6573), 1,
      sym_parameter_list,
  [252327] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8723), 1,
      anon_sym_COMMA,
    STATE(6103), 1,
      sym__preprocessor_call,
    STATE(6187), 1,
      aux_sym__formal_parameter_list_repeat1,
    ACTIONS(8725), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [252347] = 7,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8727), 1,
      anon_sym_DQUOTE,
    ACTIONS(8729), 1,
      sym_escape_sequence,
    ACTIONS(8731), 1,
      sym__string_literal_fragment,
    STATE(6104), 1,
      sym__preprocessor_call,
    STATE(6183), 1,
      aux_sym_string_literal_repeat1,
  [252369] = 7,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8729), 1,
      sym_escape_sequence,
    ACTIONS(8731), 1,
      sym__string_literal_fragment,
    ACTIONS(8733), 1,
      anon_sym_DQUOTE,
    STATE(6105), 1,
      sym__preprocessor_call,
    STATE(6154), 1,
      aux_sym_string_literal_repeat1,
  [252391] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    ACTIONS(8735), 1,
      anon_sym_LBRACE,
    STATE(2189), 1,
      sym_enum_member_declaration_list,
    STATE(6106), 1,
      sym__preprocessor_call,
    STATE(6600), 1,
      sym_base_list,
  [252413] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    ACTIONS(8737), 1,
      anon_sym_LBRACE,
    STATE(5044), 1,
      sym_enum_member_declaration_list,
    STATE(6107), 1,
      sym__preprocessor_call,
    STATE(6514), 1,
      sym_base_list,
  [252435] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5611), 1,
      sym_parameter_list,
    STATE(6108), 1,
      sym__preprocessor_call,
    STATE(6606), 1,
      sym_type_parameter_list,
  [252457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5592), 1,
      sym_parameter_list,
    STATE(6109), 1,
      sym__preprocessor_call,
    STATE(6591), 1,
      sym_type_parameter_list,
  [252479] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8599), 1,
      anon_sym_RPAREN,
    ACTIONS(8739), 1,
      anon_sym_COMMA,
    STATE(6110), 1,
      sym__preprocessor_call,
    STATE(6256), 1,
      sym_equals_value_clause,
  [252501] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5646), 1,
      sym_parameter_list,
    STATE(6111), 1,
      sym__preprocessor_call,
    STATE(6598), 1,
      sym_type_parameter_list,
  [252523] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8742), 1,
      anon_sym_SEMI,
    STATE(6112), 1,
      sym__preprocessor_call,
    STATE(6175), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [252545] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    STATE(2625), 1,
      sym_accessor_list,
    STATE(6113), 1,
      sym__preprocessor_call,
    STATE(6844), 1,
      sym_arrow_expression_clause,
  [252567] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    STATE(2409), 1,
      sym_accessor_list,
    STATE(6114), 1,
      sym__preprocessor_call,
    STATE(6971), 1,
      sym_arrow_expression_clause,
  [252589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8709), 1,
      anon_sym_unmanaged,
    ACTIONS(8711), 1,
      anon_sym_managed,
    ACTIONS(8744), 1,
      anon_sym_LT,
    STATE(6115), 1,
      sym__preprocessor_call,
    STATE(6839), 1,
      sym_function_pointer_calling_convention,
  [252611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8746), 1,
      anon_sym_SEMI,
    STATE(6116), 1,
      sym__preprocessor_call,
    STATE(6140), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [252633] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8508), 1,
      anon_sym_when,
    STATE(1655), 1,
      sym_block,
    STATE(6117), 1,
      sym__preprocessor_call,
    STATE(6612), 1,
      sym_catch_filter_clause,
  [252655] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8709), 1,
      anon_sym_unmanaged,
    ACTIONS(8711), 1,
      anon_sym_managed,
    ACTIONS(8748), 1,
      anon_sym_LT,
    STATE(6118), 1,
      sym__preprocessor_call,
    STATE(6797), 1,
      sym_function_pointer_calling_convention,
  [252677] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8750), 1,
      anon_sym_SEMI,
    STATE(6119), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6214), 1,
      aux_sym_method_declaration_repeat1,
  [252699] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8752), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6120), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [252721] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8754), 1,
      anon_sym_LBRACE,
    STATE(2134), 1,
      sym_block,
    STATE(6121), 1,
      sym__preprocessor_call,
    STATE(6565), 1,
      sym_parameter_list,
  [252743] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5623), 1,
      sym_parameter_list,
    STATE(6122), 1,
      sym__preprocessor_call,
    STATE(6532), 1,
      sym_type_parameter_list,
  [252765] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    STATE(5986), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6123), 1,
      sym__preprocessor_call,
    ACTIONS(8756), 2,
      anon_sym_LBRACE,
      anon_sym_where,
  [252785] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    STATE(2482), 1,
      sym_accessor_list,
    STATE(6124), 1,
      sym__preprocessor_call,
    STATE(6715), 1,
      sym_arrow_expression_clause,
  [252807] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8508), 1,
      anon_sym_when,
    STATE(1550), 1,
      sym_block,
    STATE(6125), 1,
      sym__preprocessor_call,
    STATE(6512), 1,
      sym_catch_filter_clause,
  [252829] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6126), 1,
      sym__preprocessor_call,
    STATE(6131), 1,
      aux_sym_variable_declaration_repeat1,
    ACTIONS(8758), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [252849] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8593), 1,
      anon_sym_COMMA,
    ACTIONS(8595), 1,
      anon_sym_and,
    ACTIONS(8597), 1,
      anon_sym_or,
    ACTIONS(8762), 1,
      anon_sym_RPAREN,
    STATE(6127), 1,
      sym__preprocessor_call,
  [252871] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8587), 1,
      anon_sym_and,
    ACTIONS(8589), 1,
      anon_sym_or,
    STATE(6128), 1,
      sym__preprocessor_call,
    ACTIONS(5570), 2,
      anon_sym_EQ_GT,
      anon_sym_when,
  [252891] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    STATE(2571), 1,
      sym_accessor_list,
    STATE(6129), 1,
      sym__preprocessor_call,
    STATE(6821), 1,
      sym_arrow_expression_clause,
  [252913] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8709), 1,
      anon_sym_unmanaged,
    ACTIONS(8711), 1,
      anon_sym_managed,
    ACTIONS(8764), 1,
      anon_sym_LT,
    STATE(6130), 1,
      sym__preprocessor_call,
    STATE(6876), 1,
      sym_function_pointer_calling_convention,
  [252935] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8760), 1,
      anon_sym_COMMA,
    STATE(6092), 1,
      aux_sym_variable_declaration_repeat1,
    STATE(6131), 1,
      sym__preprocessor_call,
    ACTIONS(8766), 2,
      anon_sym_SEMI,
      anon_sym_RPAREN,
  [252955] = 7,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8729), 1,
      sym_escape_sequence,
    ACTIONS(8731), 1,
      sym__string_literal_fragment,
    ACTIONS(8768), 1,
      anon_sym_DQUOTE,
    STATE(6132), 1,
      sym__preprocessor_call,
    STATE(6183), 1,
      aux_sym_string_literal_repeat1,
  [252977] = 7,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8729), 1,
      sym_escape_sequence,
    ACTIONS(8731), 1,
      sym__string_literal_fragment,
    ACTIONS(8770), 1,
      anon_sym_DQUOTE,
    STATE(6133), 1,
      sym__preprocessor_call,
    STATE(6183), 1,
      aux_sym_string_literal_repeat1,
  [252999] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8709), 1,
      anon_sym_unmanaged,
    ACTIONS(8711), 1,
      anon_sym_managed,
    ACTIONS(8772), 1,
      anon_sym_LT,
    STATE(6134), 1,
      sym__preprocessor_call,
    STATE(6725), 1,
      sym_function_pointer_calling_convention,
  [253021] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8593), 1,
      anon_sym_COMMA,
    ACTIONS(8595), 1,
      anon_sym_and,
    ACTIONS(8597), 1,
      anon_sym_or,
    ACTIONS(8774), 1,
      anon_sym_RPAREN,
    STATE(6135), 1,
      sym__preprocessor_call,
  [253043] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8776), 1,
      anon_sym_LBRACE,
    STATE(2759), 1,
      sym_block,
    STATE(6136), 1,
      sym__preprocessor_call,
    STATE(6522), 1,
      sym_parameter_list,
  [253065] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8776), 1,
      anon_sym_LBRACE,
    STATE(2737), 1,
      sym_block,
    STATE(6137), 1,
      sym__preprocessor_call,
    STATE(6518), 1,
      sym_parameter_list,
  [253087] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    ACTIONS(8735), 1,
      anon_sym_LBRACE,
    STATE(2333), 1,
      sym_enum_member_declaration_list,
    STATE(6138), 1,
      sym__preprocessor_call,
    STATE(6601), 1,
      sym_base_list,
  [253109] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8709), 1,
      anon_sym_unmanaged,
    ACTIONS(8711), 1,
      anon_sym_managed,
    ACTIONS(8778), 1,
      anon_sym_LT,
    STATE(6139), 1,
      sym__preprocessor_call,
    STATE(6817), 1,
      sym_function_pointer_calling_convention,
  [253131] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8780), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6140), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253153] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8782), 1,
      anon_sym_SEMI,
    STATE(6141), 1,
      sym__preprocessor_call,
    STATE(6153), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253175] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    ACTIONS(8737), 1,
      anon_sym_LBRACE,
    STATE(5116), 1,
      sym_enum_member_declaration_list,
    STATE(6142), 1,
      sym__preprocessor_call,
    STATE(6586), 1,
      sym_base_list,
  [253197] = 7,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8729), 1,
      sym_escape_sequence,
    ACTIONS(8731), 1,
      sym__string_literal_fragment,
    ACTIONS(8784), 1,
      anon_sym_DQUOTE,
    STATE(6133), 1,
      aux_sym_string_literal_repeat1,
    STATE(6143), 1,
      sym__preprocessor_call,
  [253219] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8786), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6144), 1,
      sym__preprocessor_call,
  [253241] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8788), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6145), 1,
      sym__preprocessor_call,
  [253263] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8754), 1,
      anon_sym_LBRACE,
    STATE(2138), 1,
      sym_block,
    STATE(6146), 1,
      sym__preprocessor_call,
    STATE(6587), 1,
      sym_parameter_list,
  [253285] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5596), 1,
      sym_parameter_list,
    STATE(6147), 1,
      sym__preprocessor_call,
    STATE(6590), 1,
      sym_type_parameter_list,
  [253307] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    ACTIONS(8735), 1,
      anon_sym_LBRACE,
    STATE(2220), 1,
      sym_enum_member_declaration_list,
    STATE(6148), 1,
      sym__preprocessor_call,
    STATE(6553), 1,
      sym_base_list,
  [253329] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5690), 1,
      sym_parameter_list,
    STATE(6149), 1,
      sym__preprocessor_call,
    STATE(6578), 1,
      sym_type_parameter_list,
  [253351] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8790), 1,
      anon_sym_SEMI,
    STATE(6150), 1,
      sym__preprocessor_call,
    STATE(6161), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253373] = 7,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8729), 1,
      sym_escape_sequence,
    ACTIONS(8731), 1,
      sym__string_literal_fragment,
    ACTIONS(8792), 1,
      anon_sym_DQUOTE,
    STATE(6104), 1,
      aux_sym_string_literal_repeat1,
    STATE(6151), 1,
      sym__preprocessor_call,
  [253395] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    STATE(2438), 1,
      sym_accessor_list,
    STATE(6152), 1,
      sym__preprocessor_call,
    STATE(6695), 1,
      sym_arrow_expression_clause,
  [253417] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8794), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6153), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253439] = 7,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8729), 1,
      sym_escape_sequence,
    ACTIONS(8731), 1,
      sym__string_literal_fragment,
    ACTIONS(8796), 1,
      anon_sym_DQUOTE,
    STATE(6154), 1,
      sym__preprocessor_call,
    STATE(6183), 1,
      aux_sym_string_literal_repeat1,
  [253461] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8798), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6155), 1,
      sym__preprocessor_call,
  [253483] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(6112), 1,
      sym_parameter_list,
    STATE(6156), 1,
      sym__preprocessor_call,
    STATE(6576), 1,
      sym_type_parameter_list,
  [253505] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(6157), 1,
      sym__preprocessor_call,
    STATE(6166), 1,
      sym_parameter_list,
    STATE(6577), 1,
      sym_type_parameter_list,
  [253527] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8800), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6158), 1,
      sym__preprocessor_call,
  [253549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8802), 1,
      anon_sym_COMMA,
    ACTIONS(8805), 2,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
    STATE(6159), 2,
      sym__preprocessor_call,
      aux_sym_positional_pattern_clause_repeat1,
  [253567] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(6150), 1,
      sym_parameter_list,
    STATE(6160), 1,
      sym__preprocessor_call,
    STATE(6562), 1,
      sym_type_parameter_list,
  [253589] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8807), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6161), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253611] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8809), 1,
      anon_sym_SEMI,
    STATE(6162), 1,
      sym__preprocessor_call,
    STATE(6169), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253633] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8811), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_block,
    STATE(6163), 1,
      sym__preprocessor_call,
    STATE(6548), 1,
      sym_parameter_list,
  [253655] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8813), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6164), 1,
      sym__preprocessor_call,
  [253677] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8815), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6165), 1,
      sym__preprocessor_call,
  [253699] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8817), 1,
      anon_sym_SEMI,
    STATE(6166), 1,
      sym__preprocessor_call,
    STATE(6170), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253721] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8819), 1,
      anon_sym_SEMI,
    STATE(6167), 1,
      sym__preprocessor_call,
    STATE(6184), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253743] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8656), 1,
      anon_sym_and,
    ACTIONS(8658), 1,
      anon_sym_or,
    STATE(6168), 1,
      sym__preprocessor_call,
    ACTIONS(5570), 2,
      anon_sym_COLON,
      anon_sym_when,
  [253763] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8821), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6169), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253785] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8823), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6170), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253807] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(6116), 1,
      sym_parameter_list,
    STATE(6171), 1,
      sym__preprocessor_call,
    STATE(6498), 1,
      sym_type_parameter_list,
  [253829] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8825), 1,
      anon_sym_SEMI,
    STATE(6172), 1,
      sym__preprocessor_call,
    STATE(6177), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253851] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8593), 1,
      anon_sym_COMMA,
    ACTIONS(8595), 1,
      anon_sym_and,
    ACTIONS(8597), 1,
      anon_sym_or,
    ACTIONS(8827), 1,
      anon_sym_RPAREN,
    STATE(6173), 1,
      sym__preprocessor_call,
  [253873] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8811), 1,
      anon_sym_LBRACE,
    STATE(3096), 1,
      sym_block,
    STATE(6174), 1,
      sym__preprocessor_call,
    STATE(6523), 1,
      sym_parameter_list,
  [253895] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8829), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6175), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6176), 1,
      sym__preprocessor_call,
    ACTIONS(8831), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
  [253933] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8833), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6177), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [253955] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8835), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6178), 1,
      sym__preprocessor_call,
  [253977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6179), 1,
      sym__preprocessor_call,
    ACTIONS(8562), 4,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_LBRACE,
      anon_sym_where,
  [253993] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6398), 1,
      anon_sym_LBRACE,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(2260), 1,
      sym_block,
    STATE(6180), 1,
      sym__preprocessor_call,
    STATE(6551), 1,
      sym_parameter_list,
  [254015] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8837), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6181), 1,
      sym__preprocessor_call,
  [254037] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8839), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6182), 1,
      sym__preprocessor_call,
  [254059] = 6,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8841), 1,
      anon_sym_DQUOTE,
    ACTIONS(8843), 1,
      sym_escape_sequence,
    ACTIONS(8846), 1,
      sym__string_literal_fragment,
    STATE(6183), 2,
      sym__preprocessor_call,
      aux_sym_string_literal_repeat1,
  [254079] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8849), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6184), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [254101] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8851), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6185), 1,
      sym__preprocessor_call,
  [254123] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3314), 1,
      anon_sym_COLON_COLON,
    ACTIONS(7749), 1,
      anon_sym_EQ,
    STATE(6186), 1,
      sym__preprocessor_call,
    ACTIONS(2829), 2,
      anon_sym_SEMI,
      anon_sym_DOT,
  [254143] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8723), 1,
      anon_sym_COMMA,
    STATE(6187), 1,
      sym__preprocessor_call,
    STATE(6198), 1,
      aux_sym__formal_parameter_list_repeat1,
    ACTIONS(8853), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [254163] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8599), 1,
      anon_sym_RPAREN,
    ACTIONS(8855), 1,
      anon_sym_COMMA,
    STATE(6188), 1,
      sym__preprocessor_call,
    STATE(6256), 1,
      sym_equals_value_clause,
  [254185] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8599), 1,
      anon_sym_RPAREN,
    ACTIONS(8859), 1,
      anon_sym_COMMA,
    STATE(6189), 1,
      sym__preprocessor_call,
    STATE(6256), 1,
      sym_equals_value_clause,
  [254207] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7705), 1,
      anon_sym_EQ,
    ACTIONS(8605), 1,
      anon_sym_RPAREN,
    ACTIONS(8862), 1,
      anon_sym_COMMA,
    STATE(6190), 1,
      sym__preprocessor_call,
    STATE(6382), 1,
      sym_equals_value_clause,
  [254229] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5606), 1,
      sym_parameter_list,
    STATE(6191), 1,
      sym__preprocessor_call,
    STATE(6557), 1,
      sym_type_parameter_list,
  [254251] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8865), 1,
      anon_sym_SEMI,
    STATE(6120), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6192), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [254273] = 7,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8729), 1,
      sym_escape_sequence,
    ACTIONS(8731), 1,
      sym__string_literal_fragment,
    ACTIONS(8867), 1,
      anon_sym_DQUOTE,
    STATE(6183), 1,
      aux_sym_string_literal_repeat1,
    STATE(6193), 1,
      sym__preprocessor_call,
  [254295] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8869), 1,
      anon_sym_LBRACE,
    STATE(2929), 1,
      sym_block,
    STATE(6194), 1,
      sym__preprocessor_call,
    STATE(6570), 1,
      sym_parameter_list,
  [254317] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8869), 1,
      anon_sym_LBRACE,
    STATE(2892), 1,
      sym_block,
    STATE(6195), 1,
      sym__preprocessor_call,
    STATE(6574), 1,
      sym_parameter_list,
  [254339] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8662), 1,
      anon_sym_DOT,
    ACTIONS(8871), 1,
      anon_sym_SEMI,
    STATE(5123), 1,
      sym_declaration_list,
    STATE(6196), 1,
      sym__preprocessor_call,
  [254361] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8656), 1,
      anon_sym_and,
    STATE(6197), 1,
      sym__preprocessor_call,
    ACTIONS(5396), 3,
      anon_sym_COLON,
      anon_sym_or,
      anon_sym_when,
  [254379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8873), 1,
      anon_sym_COMMA,
    ACTIONS(8876), 2,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
    STATE(6198), 2,
      sym__preprocessor_call,
      aux_sym__formal_parameter_list_repeat1,
  [254397] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8878), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6199), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [254419] = 7,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8729), 1,
      sym_escape_sequence,
    ACTIONS(8731), 1,
      sym__string_literal_fragment,
    ACTIONS(8880), 1,
      anon_sym_DQUOTE,
    STATE(6132), 1,
      aux_sym_string_literal_repeat1,
    STATE(6200), 1,
      sym__preprocessor_call,
  [254441] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8882), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6201), 1,
      sym__preprocessor_call,
  [254463] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8884), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6202), 1,
      sym__preprocessor_call,
  [254485] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8886), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6203), 1,
      sym__preprocessor_call,
  [254507] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8888), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6204), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [254529] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8890), 1,
      anon_sym_SEMI,
    STATE(6199), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6205), 1,
      sym__preprocessor_call,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
  [254551] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(5659), 1,
      sym_parameter_list,
    STATE(6206), 1,
      sym__preprocessor_call,
    STATE(6567), 1,
      sym_type_parameter_list,
  [254573] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8892), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6207), 1,
      sym__preprocessor_call,
  [254595] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8400), 1,
      anon_sym_COLON,
    ACTIONS(8737), 1,
      anon_sym_LBRACE,
    STATE(5104), 1,
      sym_enum_member_declaration_list,
    STATE(6208), 1,
      sym__preprocessor_call,
    STATE(6530), 1,
      sym_base_list,
  [254617] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8587), 1,
      anon_sym_and,
    STATE(6209), 1,
      sym__preprocessor_call,
    ACTIONS(5396), 3,
      anon_sym_EQ_GT,
      anon_sym_or,
      anon_sym_when,
  [254635] = 7,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(8729), 1,
      sym_escape_sequence,
    ACTIONS(8731), 1,
      sym__string_literal_fragment,
    ACTIONS(8894), 1,
      anon_sym_DQUOTE,
    STATE(6193), 1,
      aux_sym_string_literal_repeat1,
    STATE(6210), 1,
      sym__preprocessor_call,
  [254657] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8896), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6211), 1,
      sym__preprocessor_call,
  [254679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6212), 1,
      sym__preprocessor_call,
    ACTIONS(8898), 4,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
      anon_sym_where,
  [254695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6213), 1,
      sym__preprocessor_call,
    ACTIONS(3000), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
    ACTIONS(5428), 2,
      anon_sym_and,
      anon_sym_or,
  [254713] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8356), 1,
      anon_sym_where,
    ACTIONS(8900), 1,
      anon_sym_SEMI,
    STATE(5908), 1,
      aux_sym_method_declaration_repeat1,
    STATE(6212), 1,
      sym_type_parameter_constraints_clause,
    STATE(6214), 1,
      sym__preprocessor_call,
  [254735] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    ACTIONS(8902), 1,
      anon_sym_RPAREN,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6215), 1,
      sym__preprocessor_call,
  [254757] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(8329), 1,
      anon_sym_EQ_GT,
    STATE(2484), 1,
      sym_accessor_list,
    STATE(6216), 1,
      sym__preprocessor_call,
    STATE(6661), 1,
      sym_arrow_expression_clause,
  [254779] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(6192), 1,
      sym_parameter_list,
    STATE(6217), 1,
      sym__preprocessor_call,
    STATE(6474), 1,
      sym_type_parameter_list,
  [254801] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    ACTIONS(8350), 1,
      anon_sym_LT,
    STATE(6094), 1,
      sym_parameter_list,
    STATE(6218), 1,
      sym__preprocessor_call,
    STATE(6526), 1,
      sym_type_parameter_list,
  [254823] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8593), 1,
      anon_sym_COMMA,
    ACTIONS(8595), 1,
      anon_sym_and,
    ACTIONS(8597), 1,
      anon_sym_or,
    ACTIONS(8904), 1,
      anon_sym_RPAREN,
    STATE(6219), 1,
      sym__preprocessor_call,
  [254845] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(8510), 1,
      anon_sym_GT,
    STATE(6093), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6220), 1,
      sym__preprocessor_call,
  [254864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6221), 1,
      sym__preprocessor_call,
    ACTIONS(8906), 3,
      anon_sym_COMMA,
      anon_sym_GT,
      anon_sym_RBRACK,
  [254879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8908), 1,
      anon_sym_COMMA,
    ACTIONS(8911), 1,
      anon_sym_RBRACE,
    STATE(6222), 2,
      sym__preprocessor_call,
      aux_sym_enum_member_declaration_list_repeat1,
  [254896] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(8915), 1,
      anon_sym_RPAREN,
    STATE(6223), 1,
      sym__preprocessor_call,
    STATE(6351), 1,
      aux_sym_bracketed_argument_list_repeat1,
  [254915] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2029), 1,
      anon_sym_RBRACE,
    ACTIONS(8917), 1,
      anon_sym_COMMA,
    STATE(6224), 1,
      sym__preprocessor_call,
    STATE(6390), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
  [254934] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    ACTIONS(8919), 1,
      anon_sym_LPAREN,
    STATE(1696), 1,
      sym_block,
    STATE(6225), 1,
      sym__preprocessor_call,
  [254953] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(8921), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6226), 1,
      sym__preprocessor_call,
  [254972] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(8923), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6227), 1,
      sym__preprocessor_call,
  [254991] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8925), 1,
      anon_sym_COMMA,
    ACTIONS(8927), 1,
      anon_sym_RPAREN,
    STATE(6159), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6228), 1,
      sym__preprocessor_call,
  [255010] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8929), 1,
      anon_sym_COMMA,
    ACTIONS(8932), 1,
      anon_sym_RPAREN,
    STATE(6229), 2,
      sym__preprocessor_call,
      aux_sym_parenthesized_variable_designation_repeat1,
  [255027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8934), 1,
      anon_sym_COMMA,
    ACTIONS(8937), 1,
      anon_sym_GT,
    STATE(6230), 2,
      sym__preprocessor_call,
      aux_sym_function_pointer_type_repeat1,
  [255044] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8939), 1,
      anon_sym_COMMA,
    ACTIONS(8941), 1,
      anon_sym_GT,
    STATE(6231), 1,
      sym__preprocessor_call,
    STATE(6408), 1,
      aux_sym_type_parameter_list_repeat1,
  [255063] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8943), 1,
      anon_sym_COMMA,
    ACTIONS(8945), 1,
      anon_sym_RBRACK,
    STATE(6232), 1,
      sym__preprocessor_call,
    STATE(6307), 1,
      aux_sym_function_pointer_unmanaged_calling_convention_list_repeat1,
  [255082] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(8949), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6233), 1,
      sym__preprocessor_call,
  [255101] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(8951), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6234), 1,
      sym__preprocessor_call,
  [255120] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(8953), 1,
      anon_sym_RBRACK,
    STATE(6093), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6235), 1,
      sym__preprocessor_call,
  [255139] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1713), 1,
      anon_sym_RBRACE,
    ACTIONS(8955), 1,
      anon_sym_COMMA,
    STATE(6236), 1,
      sym__preprocessor_call,
    STATE(6290), 1,
      aux_sym_switch_expression_repeat1,
  [255158] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(8957), 1,
      anon_sym_GT,
    STATE(6234), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6237), 1,
      sym__preprocessor_call,
  [255177] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(8957), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6238), 1,
      sym__preprocessor_call,
  [255196] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(8961), 1,
      anon_sym_RPAREN,
    STATE(6239), 1,
      sym__preprocessor_call,
    STATE(6355), 1,
      aux_sym_tuple_type_repeat1,
  [255215] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    ACTIONS(8963), 1,
      anon_sym_GT,
    STATE(5986), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6240), 1,
      sym__preprocessor_call,
  [255234] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8965), 1,
      anon_sym_COMMA,
    ACTIONS(8967), 1,
      anon_sym_RBRACE,
    STATE(6236), 1,
      aux_sym_switch_expression_repeat1,
    STATE(6241), 1,
      sym__preprocessor_call,
  [255253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(8969), 1,
      anon_sym_RBRACK,
    STATE(6242), 1,
      sym__preprocessor_call,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
  [255272] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(8971), 1,
      anon_sym_GT,
    STATE(6238), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6243), 1,
      sym__preprocessor_call,
  [255291] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2053), 1,
      anon_sym_RBRACE,
    ACTIONS(8973), 1,
      anon_sym_COMMA,
    STATE(6244), 1,
      sym__preprocessor_call,
    STATE(6390), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
  [255310] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(8975), 1,
      anon_sym_RPAREN,
    STATE(6245), 1,
      sym__preprocessor_call,
    STATE(6351), 1,
      aux_sym_bracketed_argument_list_repeat1,
  [255329] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(8977), 1,
      anon_sym_RBRACK,
    STATE(6235), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6246), 1,
      sym__preprocessor_call,
  [255348] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(8979), 1,
      anon_sym_SEMI,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6247), 1,
      sym__preprocessor_call,
  [255367] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(8981), 1,
      anon_sym_RPAREN,
    STATE(6239), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6248), 1,
      sym__preprocessor_call,
  [255386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7745), 1,
      anon_sym_RBRACK,
    ACTIONS(8983), 1,
      anon_sym_COMMA,
    STATE(6249), 1,
      sym__preprocessor_call,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
  [255405] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(8533), 1,
      anon_sym_GT,
    STATE(6093), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6250), 1,
      sym__preprocessor_call,
  [255424] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8985), 1,
      anon_sym_COMMA,
    ACTIONS(8987), 1,
      anon_sym_RBRACK,
    STATE(6251), 1,
      sym__preprocessor_call,
    STATE(6312), 1,
      aux_sym_attribute_list_repeat1,
  [255443] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(8991), 1,
      anon_sym_RBRACK,
    STATE(6252), 1,
      sym__preprocessor_call,
    STATE(6313), 1,
      aux_sym_bracketed_argument_list_repeat1,
  [255462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6253), 1,
      sym__preprocessor_call,
    ACTIONS(8876), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [255477] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(6580), 1,
      anon_sym_RBRACK,
    STATE(6254), 1,
      sym__preprocessor_call,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
  [255496] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(8993), 1,
      anon_sym_RPAREN,
    STATE(6255), 1,
      sym__preprocessor_call,
    STATE(6385), 1,
      aux_sym_tuple_type_repeat1,
  [255515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6256), 1,
      sym__preprocessor_call,
    ACTIONS(8995), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [255530] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(8997), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6257), 1,
      sym__preprocessor_call,
  [255549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6258), 1,
      sym__preprocessor_call,
    ACTIONS(8999), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [255564] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6259), 1,
      sym__preprocessor_call,
    ACTIONS(9001), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [255579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9003), 1,
      anon_sym_COMMA,
    ACTIONS(9006), 1,
      anon_sym_RBRACK,
    STATE(6260), 2,
      sym__preprocessor_call,
      aux_sym_bracketed_argument_list_repeat1,
  [255596] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6261), 1,
      sym__preprocessor_call,
    ACTIONS(9006), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [255611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2177), 1,
      anon_sym_RBRACE,
    ACTIONS(9008), 1,
      anon_sym_COMMA,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6262), 1,
      sym__preprocessor_call,
  [255630] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    ACTIONS(8919), 1,
      anon_sym_LPAREN,
    STATE(1562), 1,
      sym_block,
    STATE(6263), 1,
      sym__preprocessor_call,
  [255649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6264), 1,
      sym__preprocessor_call,
    ACTIONS(6584), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [255664] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9010), 1,
      anon_sym_COMMA,
    ACTIONS(9013), 1,
      anon_sym_RBRACK,
    STATE(6265), 2,
      sym__preprocessor_call,
      aux_sym_attribute_list_repeat1,
  [255681] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7723), 1,
      anon_sym_RBRACK,
    ACTIONS(9015), 1,
      anon_sym_COMMA,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6266), 1,
      sym__preprocessor_call,
  [255700] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9017), 1,
      anon_sym_COMMA,
    ACTIONS(9019), 1,
      anon_sym_RBRACE,
    STATE(6244), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6267), 1,
      sym__preprocessor_call,
  [255719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9021), 1,
      anon_sym_RPAREN,
    STATE(6245), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6268), 1,
      sym__preprocessor_call,
  [255738] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9023), 1,
      anon_sym_RPAREN,
    STATE(6269), 1,
      sym__preprocessor_call,
    STATE(6351), 1,
      aux_sym_bracketed_argument_list_repeat1,
  [255757] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8925), 1,
      anon_sym_COMMA,
    ACTIONS(9025), 1,
      anon_sym_RPAREN,
    STATE(6228), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6270), 1,
      sym__preprocessor_call,
  [255776] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(9027), 1,
      anon_sym_RBRACK,
    STATE(6260), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6271), 1,
      sym__preprocessor_call,
  [255795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6272), 1,
      sym__preprocessor_call,
    ACTIONS(8805), 3,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACE,
  [255810] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(9029), 1,
      anon_sym_RBRACK,
    STATE(6273), 1,
      sym__preprocessor_call,
    STATE(6292), 1,
      aux_sym_type_argument_list_repeat1,
  [255829] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7753), 1,
      anon_sym_RBRACK,
    ACTIONS(9031), 1,
      anon_sym_COMMA,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6274), 1,
      sym__preprocessor_call,
  [255848] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9033), 1,
      anon_sym_COMMA,
    ACTIONS(9035), 1,
      anon_sym_RPAREN,
    STATE(6229), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6275), 1,
      sym__preprocessor_call,
  [255867] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7753), 1,
      anon_sym_RBRACK,
    ACTIONS(9031), 1,
      anon_sym_COMMA,
    STATE(6249), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6276), 1,
      sym__preprocessor_call,
  [255886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9037), 1,
      anon_sym_COMMA,
    ACTIONS(9040), 1,
      anon_sym_RBRACE,
    STATE(6277), 2,
      sym__preprocessor_call,
      aux_sym_with_initializer_expression_repeat1,
  [255903] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9042), 1,
      anon_sym_COMMA,
    ACTIONS(9044), 1,
      anon_sym_RBRACE,
    STATE(6278), 1,
      sym__preprocessor_call,
    STATE(6442), 1,
      aux_sym_enum_member_declaration_list_repeat1,
  [255922] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9046), 1,
      anon_sym_EQ,
    STATE(6279), 1,
      sym__preprocessor_call,
    ACTIONS(9048), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [255939] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9050), 1,
      anon_sym_COMMA,
    ACTIONS(9052), 1,
      anon_sym_RPAREN,
    STATE(6280), 1,
      sym__preprocessor_call,
    STATE(6381), 1,
      aux_sym_attribute_argument_list_repeat1,
  [255958] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9054), 1,
      anon_sym_COMMA,
    ACTIONS(9056), 1,
      anon_sym_RBRACK,
    STATE(6281), 1,
      sym__preprocessor_call,
    STATE(6380), 1,
      aux_sym_attribute_list_repeat1,
  [255977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5200), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2753), 1,
      sym_array_rank_specifier,
    STATE(6282), 1,
      sym__preprocessor_call,
  [255996] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(4524), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2689), 1,
      sym_array_rank_specifier,
    STATE(6283), 1,
      sym__preprocessor_call,
  [256015] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(9058), 1,
      anon_sym_RBRACK,
    STATE(6271), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6284), 1,
      sym__preprocessor_call,
  [256034] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9060), 1,
      anon_sym_COMMA,
    ACTIONS(9062), 1,
      anon_sym_RBRACK,
    STATE(6274), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6285), 1,
      sym__preprocessor_call,
  [256053] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(6636), 1,
      anon_sym_RBRACK,
    STATE(6286), 1,
      sym__preprocessor_call,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
  [256072] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9064), 1,
      anon_sym_GT,
    STATE(6287), 1,
      sym__preprocessor_call,
    STATE(6443), 1,
      aux_sym_function_pointer_type_repeat1,
  [256091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6288), 1,
      sym__preprocessor_call,
    ACTIONS(9066), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [256106] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(9068), 1,
      anon_sym_RPAREN,
    STATE(6289), 1,
      sym__preprocessor_call,
    STATE(6293), 1,
      aux_sym_tuple_type_repeat1,
  [256125] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9070), 1,
      anon_sym_COMMA,
    ACTIONS(9073), 1,
      anon_sym_RBRACE,
    STATE(6290), 2,
      sym__preprocessor_call,
      aux_sym_switch_expression_repeat1,
  [256142] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(9075), 1,
      anon_sym_RBRACK,
    STATE(6291), 1,
      sym__preprocessor_call,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
  [256161] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(9077), 1,
      anon_sym_RBRACK,
    STATE(6093), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6292), 1,
      sym__preprocessor_call,
  [256180] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(9079), 1,
      anon_sym_RPAREN,
    STATE(6293), 1,
      sym__preprocessor_call,
    STATE(6355), 1,
      aux_sym_tuple_type_repeat1,
  [256199] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9081), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6294), 1,
      sym__preprocessor_call,
  [256218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9081), 1,
      anon_sym_GT,
    STATE(6295), 1,
      sym__preprocessor_call,
    STATE(6296), 1,
      aux_sym_function_pointer_type_repeat1,
  [256237] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9083), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6296), 1,
      sym__preprocessor_call,
  [256256] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7545), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(4576), 1,
      sym_array_rank_specifier,
    STATE(6297), 1,
      sym__preprocessor_call,
  [256275] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9085), 1,
      anon_sym_SEMI,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6298), 1,
      sym__preprocessor_call,
  [256294] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(9087), 1,
      anon_sym_SEMI,
    STATE(2494), 1,
      sym_accessor_list,
    STATE(6299), 1,
      sym__preprocessor_call,
  [256313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6300), 1,
      sym__preprocessor_call,
    ACTIONS(9089), 3,
      anon_sym_RBRACE,
      anon_sym_case,
      anon_sym_default,
  [256328] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6136), 1,
      anon_sym_COLON,
    ACTIONS(9091), 1,
      anon_sym_RBRACE,
    STATE(6301), 1,
      sym__preprocessor_call,
    STATE(6901), 1,
      sym_interpolation_format_clause,
  [256347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9033), 1,
      anon_sym_COMMA,
    ACTIONS(9093), 1,
      anon_sym_RPAREN,
    STATE(6229), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6302), 1,
      sym__preprocessor_call,
  [256366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8360), 1,
      anon_sym_LBRACE,
    ACTIONS(8662), 1,
      anon_sym_DOT,
    STATE(5123), 1,
      sym_declaration_list,
    STATE(6303), 1,
      sym__preprocessor_call,
  [256385] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9095), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6304), 1,
      sym__preprocessor_call,
  [256404] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9033), 1,
      anon_sym_COMMA,
    ACTIONS(9097), 1,
      anon_sym_RPAREN,
    STATE(6302), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6305), 1,
      sym__preprocessor_call,
  [256423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1717), 1,
      anon_sym_RBRACE,
    ACTIONS(9099), 1,
      anon_sym_COMMA,
    STATE(6290), 1,
      aux_sym_switch_expression_repeat1,
    STATE(6306), 1,
      sym__preprocessor_call,
  [256442] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9101), 1,
      anon_sym_COMMA,
    ACTIONS(9104), 1,
      anon_sym_RBRACK,
    STATE(6307), 2,
      sym__preprocessor_call,
      aux_sym_function_pointer_unmanaged_calling_convention_list_repeat1,
  [256459] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9106), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6308), 1,
      sym__preprocessor_call,
  [256478] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(8542), 1,
      anon_sym_GT,
    STATE(6093), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6309), 1,
      sym__preprocessor_call,
  [256497] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9108), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6310), 1,
      sym__preprocessor_call,
  [256516] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9110), 1,
      anon_sym_GT,
    STATE(6304), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6311), 1,
      sym__preprocessor_call,
  [256535] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7727), 1,
      anon_sym_RBRACK,
    ACTIONS(9112), 1,
      anon_sym_COMMA,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6312), 1,
      sym__preprocessor_call,
  [256554] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(9114), 1,
      anon_sym_RBRACK,
    STATE(6260), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6313), 1,
      sym__preprocessor_call,
  [256573] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9116), 1,
      anon_sym_RPAREN,
    STATE(6314), 1,
      sym__preprocessor_call,
    STATE(6351), 1,
      aux_sym_bracketed_argument_list_repeat1,
  [256592] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9110), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6315), 1,
      sym__preprocessor_call,
  [256611] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(9118), 1,
      anon_sym_RPAREN,
    STATE(6316), 1,
      sym__preprocessor_call,
    STATE(6355), 1,
      aux_sym_tuple_type_repeat1,
  [256630] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    ACTIONS(9120), 1,
      anon_sym_GT,
    STATE(5986), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6317), 1,
      sym__preprocessor_call,
  [256649] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(9122), 1,
      anon_sym_RBRACK,
    STATE(6318), 1,
      sym__preprocessor_call,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
  [256668] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9124), 1,
      anon_sym_RPAREN,
    STATE(6319), 1,
      sym__preprocessor_call,
    STATE(6357), 1,
      aux_sym_bracketed_argument_list_repeat1,
  [256687] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9126), 1,
      anon_sym_COMMA,
    ACTIONS(9128), 1,
      anon_sym_RBRACE,
    STATE(6306), 1,
      aux_sym_switch_expression_repeat1,
    STATE(6320), 1,
      sym__preprocessor_call,
  [256706] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9130), 1,
      anon_sym_COMMA,
    ACTIONS(9132), 1,
      anon_sym_RBRACE,
    STATE(6321), 1,
      sym__preprocessor_call,
    STATE(6338), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
  [256725] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(9134), 1,
      anon_sym_RBRACK,
    STATE(6322), 1,
      sym__preprocessor_call,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
  [256744] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9136), 1,
      anon_sym_GT,
    STATE(6315), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6323), 1,
      sym__preprocessor_call,
  [256763] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9138), 1,
      anon_sym_COMMA,
    ACTIONS(9140), 1,
      anon_sym_RPAREN,
    STATE(6324), 1,
      sym__preprocessor_call,
    STATE(6452), 1,
      aux_sym_tuple_pattern_repeat1,
  [256782] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2095), 1,
      anon_sym_RBRACE,
    ACTIONS(9142), 1,
      anon_sym_COMMA,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6325), 1,
      sym__preprocessor_call,
  [256801] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2045), 1,
      anon_sym_RBRACE,
    ACTIONS(9144), 1,
      anon_sym_COMMA,
    STATE(6326), 1,
      sym__preprocessor_call,
    STATE(6390), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
  [256820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6327), 1,
      sym__preprocessor_call,
    ACTIONS(8695), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [256835] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7727), 1,
      anon_sym_RBRACK,
    ACTIONS(9112), 1,
      anon_sym_COMMA,
    STATE(6328), 1,
      sym__preprocessor_call,
    STATE(6348), 1,
      aux_sym_attribute_list_repeat1,
  [256854] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9146), 1,
      anon_sym_RPAREN,
    STATE(6329), 1,
      sym__preprocessor_call,
    STATE(6351), 1,
      aux_sym_bracketed_argument_list_repeat1,
  [256873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(9148), 1,
      anon_sym_RPAREN,
    STATE(6316), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6330), 1,
      sym__preprocessor_call,
  [256892] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7733), 1,
      anon_sym_RBRACK,
    ACTIONS(9150), 1,
      anon_sym_COMMA,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6331), 1,
      sym__preprocessor_call,
  [256911] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(8552), 1,
      anon_sym_GT,
    STATE(6093), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6332), 1,
      sym__preprocessor_call,
  [256930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6333), 1,
      sym__preprocessor_call,
    ACTIONS(9152), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [256945] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(6590), 1,
      anon_sym_RBRACK,
    STATE(6334), 1,
      sym__preprocessor_call,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
  [256964] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(6676), 1,
      anon_sym_RBRACK,
    STATE(6335), 1,
      sym__preprocessor_call,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
  [256983] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2145), 1,
      anon_sym_RBRACE,
    ACTIONS(9154), 1,
      anon_sym_COMMA,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6336), 1,
      sym__preprocessor_call,
  [257002] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(9156), 1,
      anon_sym_RBRACK,
    STATE(6337), 1,
      sym__preprocessor_call,
    STATE(6354), 1,
      aux_sym_type_argument_list_repeat1,
  [257021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2039), 1,
      anon_sym_RBRACE,
    ACTIONS(9158), 1,
      anon_sym_COMMA,
    STATE(6338), 1,
      sym__preprocessor_call,
    STATE(6390), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
  [257040] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9160), 1,
      anon_sym_COMMA,
    ACTIONS(9162), 1,
      anon_sym_RBRACE,
    STATE(6326), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6339), 1,
      sym__preprocessor_call,
  [257059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9164), 1,
      anon_sym_COMMA,
    ACTIONS(9167), 1,
      anon_sym_GT,
    STATE(6340), 2,
      sym__preprocessor_call,
      aux_sym_type_parameter_list_repeat1,
  [257076] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9169), 1,
      anon_sym_RPAREN,
    STATE(6329), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6341), 1,
      sym__preprocessor_call,
  [257095] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9171), 1,
      anon_sym_RPAREN,
    STATE(6342), 1,
      sym__preprocessor_call,
    STATE(6351), 1,
      aux_sym_bracketed_argument_list_repeat1,
  [257114] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(9173), 1,
      anon_sym_RBRACK,
    STATE(6260), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6343), 1,
      sym__preprocessor_call,
  [257133] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7759), 1,
      anon_sym_RBRACK,
    ACTIONS(9175), 1,
      anon_sym_COMMA,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6344), 1,
      sym__preprocessor_call,
  [257152] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8354), 1,
      anon_sym_LBRACE,
    ACTIONS(8662), 1,
      anon_sym_DOT,
    STATE(2190), 1,
      sym_declaration_list,
    STATE(6345), 1,
      sym__preprocessor_call,
  [257171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7759), 1,
      anon_sym_RBRACK,
    ACTIONS(9175), 1,
      anon_sym_COMMA,
    STATE(6331), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6346), 1,
      sym__preprocessor_call,
  [257190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6347), 1,
      sym__preprocessor_call,
    ACTIONS(9177), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [257205] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7731), 1,
      anon_sym_RBRACK,
    ACTIONS(9179), 1,
      anon_sym_COMMA,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6348), 1,
      sym__preprocessor_call,
  [257224] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9181), 1,
      anon_sym_GT,
    STATE(6294), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6349), 1,
      sym__preprocessor_call,
  [257243] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9183), 1,
      anon_sym_COMMA,
    ACTIONS(9185), 1,
      anon_sym_RBRACE,
    STATE(6350), 1,
      sym__preprocessor_call,
    STATE(6455), 1,
      aux_sym_positional_pattern_clause_repeat1,
  [257262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9006), 1,
      anon_sym_RPAREN,
    ACTIONS(9187), 1,
      anon_sym_COMMA,
    STATE(6351), 2,
      sym__preprocessor_call,
      aux_sym_bracketed_argument_list_repeat1,
  [257279] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(9190), 1,
      anon_sym_RPAREN,
    STATE(6352), 1,
      sym__preprocessor_call,
    STATE(6400), 1,
      aux_sym_tuple_type_repeat1,
  [257298] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3238), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2090), 1,
      sym_array_rank_specifier,
    STATE(6353), 1,
      sym__preprocessor_call,
  [257317] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(9192), 1,
      anon_sym_RBRACK,
    STATE(6093), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6354), 1,
      sym__preprocessor_call,
  [257336] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9194), 1,
      anon_sym_COMMA,
    ACTIONS(9197), 1,
      anon_sym_RPAREN,
    STATE(6355), 2,
      sym__preprocessor_call,
      aux_sym_tuple_type_repeat1,
  [257353] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9199), 1,
      anon_sym_COMMA,
    ACTIONS(9201), 1,
      anon_sym_RBRACE,
    STATE(6356), 1,
      sym__preprocessor_call,
    STATE(6453), 1,
      aux_sym_switch_expression_repeat1,
  [257372] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9203), 1,
      anon_sym_RPAREN,
    STATE(6351), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6357), 1,
      sym__preprocessor_call,
  [257391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6358), 1,
      sym__preprocessor_call,
    ACTIONS(9205), 3,
      anon_sym_SEMI,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [257406] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(9207), 1,
      anon_sym_RBRACK,
    STATE(6343), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6359), 1,
      sym__preprocessor_call,
  [257425] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9209), 1,
      anon_sym_COMMA,
    ACTIONS(9211), 1,
      anon_sym_RBRACK,
    STATE(6344), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6360), 1,
      sym__preprocessor_call,
  [257444] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6766), 1,
      anon_sym_RBRACK,
    ACTIONS(9213), 1,
      anon_sym_COMMA,
    STATE(6361), 2,
      sym__preprocessor_call,
      aux_sym_array_rank_specifier_repeat1,
  [257461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9216), 1,
      anon_sym_COMMA,
    ACTIONS(9218), 1,
      anon_sym_RBRACE,
    STATE(6362), 1,
      sym__preprocessor_call,
    STATE(6401), 1,
      aux_sym_enum_member_declaration_list_repeat1,
  [257480] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9220), 1,
      anon_sym_GT,
    STATE(6363), 1,
      sym__preprocessor_call,
    STATE(6402), 1,
      aux_sym_function_pointer_type_repeat1,
  [257499] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9222), 1,
      anon_sym_COMMA,
    ACTIONS(9225), 1,
      anon_sym_RPAREN,
    STATE(6364), 2,
      sym__preprocessor_call,
      aux_sym_attribute_argument_list_repeat1,
  [257516] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(9227), 1,
      anon_sym_SEMI,
    STATE(2358), 1,
      sym_accessor_list,
    STATE(6365), 1,
      sym__preprocessor_call,
  [257535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6366), 1,
      sym__preprocessor_call,
    ACTIONS(9229), 3,
      anon_sym_disable,
      anon_sym_enable,
      anon_sym_restore,
  [257550] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6367), 1,
      sym__preprocessor_call,
    ACTIONS(8648), 3,
      anon_sym_SEMI,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [257565] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    ACTIONS(9231), 1,
      anon_sym_GT,
    STATE(5986), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6368), 1,
      sym__preprocessor_call,
  [257584] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9235), 1,
      sym_preproc_integer_literal,
    STATE(6369), 1,
      sym__preprocessor_call,
    ACTIONS(9233), 2,
      anon_sym_default,
      anon_sym_hidden,
  [257601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6136), 1,
      anon_sym_COLON,
    ACTIONS(9237), 1,
      anon_sym_RBRACE,
    STATE(6370), 1,
      sym__preprocessor_call,
    STATE(6635), 1,
      sym_interpolation_format_clause,
  [257620] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9239), 1,
      anon_sym_COMMA,
    ACTIONS(9241), 1,
      anon_sym_RBRACE,
    STATE(6371), 1,
      sym__preprocessor_call,
    STATE(6460), 1,
      aux_sym_with_initializer_expression_repeat1,
  [257639] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9138), 1,
      anon_sym_COMMA,
    ACTIONS(9243), 1,
      anon_sym_RPAREN,
    STATE(6324), 1,
      aux_sym_tuple_pattern_repeat1,
    STATE(6372), 1,
      sym__preprocessor_call,
  [257658] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(9245), 1,
      anon_sym_RBRACK,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6373), 1,
      sym__preprocessor_call,
  [257677] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(6684), 1,
      anon_sym_RBRACK,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6374), 1,
      sym__preprocessor_call,
  [257696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9247), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6375), 1,
      sym__preprocessor_call,
  [257715] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9249), 1,
      anon_sym_COMMA,
    ACTIONS(9251), 1,
      sym__preproc_directive_end,
    STATE(6376), 1,
      sym__preprocessor_call,
    STATE(6383), 1,
      aux_sym_pragma_directive_repeat1,
  [257734] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9249), 1,
      anon_sym_COMMA,
    ACTIONS(9253), 1,
      sym__preproc_directive_end,
    STATE(6377), 1,
      sym__preprocessor_call,
    STATE(6397), 1,
      aux_sym_pragma_directive_repeat1,
  [257753] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9249), 1,
      anon_sym_COMMA,
    ACTIONS(9255), 1,
      sym__preproc_directive_end,
    STATE(6377), 1,
      aux_sym_pragma_directive_repeat1,
    STATE(6378), 1,
      sym__preprocessor_call,
  [257772] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9257), 1,
      anon_sym_COMMA,
    ACTIONS(9259), 1,
      anon_sym_RBRACE,
    STATE(6379), 1,
      sym__preprocessor_call,
    STATE(6421), 1,
      aux_sym_switch_expression_repeat1,
  [257791] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9054), 1,
      anon_sym_COMMA,
    ACTIONS(9261), 1,
      anon_sym_RBRACK,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6380), 1,
      sym__preprocessor_call,
  [257810] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9050), 1,
      anon_sym_COMMA,
    ACTIONS(9263), 1,
      anon_sym_RPAREN,
    STATE(6364), 1,
      aux_sym_attribute_argument_list_repeat1,
    STATE(6381), 1,
      sym__preprocessor_call,
  [257829] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6382), 1,
      sym__preprocessor_call,
    ACTIONS(9265), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [257844] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9249), 1,
      anon_sym_COMMA,
    ACTIONS(9267), 1,
      sym__preproc_directive_end,
    STATE(6383), 1,
      sym__preprocessor_call,
    STATE(6397), 1,
      aux_sym_pragma_directive_repeat1,
  [257863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9271), 1,
      sym__preproc_directive_end,
    STATE(6384), 1,
      sym__preprocessor_call,
    ACTIONS(9269), 2,
      anon_sym_annotations,
      anon_sym_warnings,
  [257880] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(9273), 1,
      anon_sym_RPAREN,
    STATE(6355), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6385), 1,
      sym__preprocessor_call,
  [257899] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    ACTIONS(9275), 1,
      anon_sym_GT,
    STATE(5986), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6386), 1,
      sym__preprocessor_call,
  [257918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6387), 1,
      sym__preprocessor_call,
    ACTIONS(9277), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [257933] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6388), 1,
      sym__preprocessor_call,
    ACTIONS(9279), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [257948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6389), 1,
      sym__preprocessor_call,
    ACTIONS(9281), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [257963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9283), 1,
      anon_sym_COMMA,
    ACTIONS(9286), 1,
      anon_sym_RBRACE,
    STATE(6390), 2,
      sym__preprocessor_call,
      aux_sym_anonymous_object_creation_expression_repeat1,
  [257980] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9033), 1,
      anon_sym_COMMA,
    ACTIONS(9288), 1,
      anon_sym_RPAREN,
    STATE(6229), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6391), 1,
      sym__preprocessor_call,
  [257999] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9290), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6392), 1,
      sym__preprocessor_call,
  [258018] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9033), 1,
      anon_sym_COMMA,
    ACTIONS(9292), 1,
      anon_sym_RPAREN,
    STATE(6391), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6393), 1,
      sym__preprocessor_call,
  [258037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1703), 1,
      anon_sym_RBRACE,
    ACTIONS(9294), 1,
      anon_sym_COMMA,
    STATE(6290), 1,
      aux_sym_switch_expression_repeat1,
    STATE(6394), 1,
      sym__preprocessor_call,
  [258056] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9296), 1,
      anon_sym_GT,
    STATE(6392), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6395), 1,
      sym__preprocessor_call,
  [258075] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9296), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6396), 1,
      sym__preprocessor_call,
  [258094] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9298), 1,
      anon_sym_COMMA,
    ACTIONS(9301), 1,
      sym__preproc_directive_end,
    STATE(6397), 2,
      sym__preprocessor_call,
      aux_sym_pragma_directive_repeat1,
  [258111] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(9303), 1,
      anon_sym_RPAREN,
    STATE(6355), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6398), 1,
      sym__preprocessor_call,
  [258130] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8327), 1,
      anon_sym_LBRACE,
    ACTIONS(9305), 1,
      anon_sym_SEMI,
    STATE(2522), 1,
      sym_accessor_list,
    STATE(6399), 1,
      sym__preprocessor_call,
  [258149] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(9307), 1,
      anon_sym_RPAREN,
    STATE(6355), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6400), 1,
      sym__preprocessor_call,
  [258168] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7785), 1,
      anon_sym_RBRACE,
    ACTIONS(9309), 1,
      anon_sym_COMMA,
    STATE(6222), 1,
      aux_sym_enum_member_declaration_list_repeat1,
    STATE(6401), 1,
      sym__preprocessor_call,
  [258187] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9311), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6402), 1,
      sym__preprocessor_call,
  [258206] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9311), 1,
      anon_sym_GT,
    STATE(6403), 1,
      sym__preprocessor_call,
    STATE(6435), 1,
      aux_sym_function_pointer_type_repeat1,
  [258225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9313), 1,
      anon_sym_COMMA,
    ACTIONS(9315), 1,
      anon_sym_RBRACK,
    STATE(6404), 1,
      sym__preprocessor_call,
    STATE(6449), 1,
      aux_sym_attribute_list_repeat1,
  [258244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(9317), 1,
      anon_sym_RBRACK,
    STATE(6405), 1,
      sym__preprocessor_call,
    STATE(6451), 1,
      aux_sym_bracketed_argument_list_repeat1,
  [258263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6406), 1,
      sym__preprocessor_call,
    ACTIONS(6600), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [258278] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8484), 1,
      anon_sym_COMMA,
    ACTIONS(9319), 1,
      anon_sym_GT,
    STATE(5986), 1,
      aux_sym_type_argument_list_repeat2,
    STATE(6407), 1,
      sym__preprocessor_call,
  [258297] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8939), 1,
      anon_sym_COMMA,
    ACTIONS(9321), 1,
      anon_sym_GT,
    STATE(6340), 1,
      aux_sym_type_parameter_list_repeat1,
    STATE(6408), 1,
      sym__preprocessor_call,
  [258316] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9323), 1,
      anon_sym_COMMA,
    ACTIONS(9325), 1,
      anon_sym_RBRACE,
    STATE(6394), 1,
      aux_sym_switch_expression_repeat1,
    STATE(6409), 1,
      sym__preprocessor_call,
  [258335] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(9327), 1,
      anon_sym_RBRACK,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6410), 1,
      sym__preprocessor_call,
  [258354] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9329), 1,
      anon_sym_GT,
    STATE(6396), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6411), 1,
      sym__preprocessor_call,
  [258373] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2047), 1,
      anon_sym_RBRACE,
    ACTIONS(9331), 1,
      anon_sym_COMMA,
    STATE(6390), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6412), 1,
      sym__preprocessor_call,
  [258392] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(9335), 1,
      sym__string_literal_fragment,
    STATE(6413), 1,
      sym__preprocessor_call,
    ACTIONS(9333), 2,
      anon_sym_DQUOTE,
      sym_escape_sequence,
  [258409] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9337), 1,
      anon_sym_RPAREN,
    STATE(6351), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6414), 1,
      sym__preprocessor_call,
  [258428] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8959), 1,
      anon_sym_COMMA,
    ACTIONS(9339), 1,
      anon_sym_RPAREN,
    STATE(6398), 1,
      aux_sym_tuple_type_repeat1,
    STATE(6415), 1,
      sym__preprocessor_call,
  [258447] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7755), 1,
      anon_sym_RBRACK,
    ACTIONS(9341), 1,
      anon_sym_COMMA,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6416), 1,
      sym__preprocessor_call,
  [258466] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(8523), 1,
      anon_sym_GT,
    STATE(6093), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6417), 1,
      sym__preprocessor_call,
  [258485] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(9343), 1,
      anon_sym_RBRACK,
    STATE(6418), 1,
      sym__preprocessor_call,
    STATE(6469), 1,
      aux_sym_type_argument_list_repeat1,
  [258504] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2031), 1,
      anon_sym_COMMA,
    ACTIONS(6594), 1,
      anon_sym_RBRACK,
    STATE(6361), 1,
      aux_sym_array_rank_specifier_repeat1,
    STATE(6419), 1,
      sym__preprocessor_call,
  [258523] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2181), 1,
      anon_sym_RBRACE,
    ACTIONS(9345), 1,
      anon_sym_COMMA,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6420), 1,
      sym__preprocessor_call,
  [258542] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1715), 1,
      anon_sym_RBRACE,
    ACTIONS(9347), 1,
      anon_sym_COMMA,
    STATE(6290), 1,
      aux_sym_switch_expression_repeat1,
    STATE(6421), 1,
      sym__preprocessor_call,
  [258561] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9033), 1,
      anon_sym_COMMA,
    ACTIONS(9349), 1,
      anon_sym_RPAREN,
    STATE(6422), 1,
      sym__preprocessor_call,
    STATE(6446), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
  [258580] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9351), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6423), 1,
      sym__preprocessor_call,
  [258599] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9353), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6424), 1,
      sym__preprocessor_call,
  [258618] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9355), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6425), 1,
      sym__preprocessor_call,
  [258637] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9357), 1,
      anon_sym_COMMA,
    ACTIONS(9359), 1,
      anon_sym_RBRACE,
    STATE(6412), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6426), 1,
      sym__preprocessor_call,
  [258656] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9361), 1,
      anon_sym_SEMI,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6427), 1,
      sym__preprocessor_call,
  [258675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6428), 1,
      sym__preprocessor_call,
    ACTIONS(6458), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [258690] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9363), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6429), 1,
      sym__preprocessor_call,
  [258709] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9365), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6430), 1,
      sym__preprocessor_call,
  [258728] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9367), 1,
      anon_sym_RPAREN,
    STATE(6414), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6431), 1,
      sym__preprocessor_call,
  [258747] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9369), 1,
      anon_sym_RPAREN,
    STATE(6351), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6432), 1,
      sym__preprocessor_call,
  [258766] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(9371), 1,
      anon_sym_RBRACK,
    STATE(6260), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6433), 1,
      sym__preprocessor_call,
  [258785] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7751), 1,
      anon_sym_RBRACK,
    ACTIONS(9373), 1,
      anon_sym_COMMA,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6434), 1,
      sym__preprocessor_call,
  [258804] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9375), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6435), 1,
      sym__preprocessor_call,
  [258823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7751), 1,
      anon_sym_RBRACK,
    ACTIONS(9373), 1,
      anon_sym_COMMA,
    STATE(6416), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6436), 1,
      sym__preprocessor_call,
  [258842] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9377), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6437), 1,
      sym__preprocessor_call,
  [258861] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2784), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(1809), 1,
      sym_array_rank_specifier,
    STATE(6438), 1,
      sym__preprocessor_call,
  [258880] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(9379), 1,
      anon_sym_RBRACK,
    STATE(6433), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6439), 1,
      sym__preprocessor_call,
  [258899] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9381), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6440), 1,
      sym__preprocessor_call,
  [258918] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9383), 1,
      anon_sym_COMMA,
    ACTIONS(9385), 1,
      anon_sym_RBRACK,
    STATE(6434), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6441), 1,
      sym__preprocessor_call,
  [258937] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7797), 1,
      anon_sym_RBRACE,
    ACTIONS(9387), 1,
      anon_sym_COMMA,
    STATE(6222), 1,
      aux_sym_enum_member_declaration_list_repeat1,
    STATE(6442), 1,
      sym__preprocessor_call,
  [258956] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9389), 1,
      anon_sym_GT,
    STATE(6230), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6443), 1,
      sym__preprocessor_call,
  [258975] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8943), 1,
      anon_sym_COMMA,
    ACTIONS(9391), 1,
      anon_sym_RBRACK,
    STATE(6232), 1,
      aux_sym_function_pointer_unmanaged_calling_convention_list_repeat1,
    STATE(6444), 1,
      sym__preprocessor_call,
  [258994] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9393), 1,
      anon_sym_LT,
    ACTIONS(9395), 1,
      anon_sym_LBRACK,
    STATE(6445), 1,
      sym__preprocessor_call,
    STATE(6852), 1,
      sym_function_pointer_unmanaged_calling_convention_list,
  [259013] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9033), 1,
      anon_sym_COMMA,
    ACTIONS(9397), 1,
      anon_sym_RPAREN,
    STATE(6229), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6446), 1,
      sym__preprocessor_call,
  [259032] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7743), 1,
      anon_sym_RBRACK,
    ACTIONS(9399), 1,
      anon_sym_COMMA,
    STATE(6266), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6447), 1,
      sym__preprocessor_call,
  [259051] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8947), 1,
      anon_sym_COMMA,
    ACTIONS(9389), 1,
      anon_sym_GT,
    STATE(6233), 1,
      aux_sym_function_pointer_type_repeat1,
    STATE(6448), 1,
      sym__preprocessor_call,
  [259070] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7743), 1,
      anon_sym_RBRACK,
    ACTIONS(9399), 1,
      anon_sym_COMMA,
    STATE(6265), 1,
      aux_sym_attribute_list_repeat1,
    STATE(6449), 1,
      sym__preprocessor_call,
  [259089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2183), 1,
      anon_sym_RBRACE,
    ACTIONS(9401), 1,
      anon_sym_COMMA,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6450), 1,
      sym__preprocessor_call,
  [259108] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8989), 1,
      anon_sym_COMMA,
    ACTIONS(9403), 1,
      anon_sym_RBRACK,
    STATE(6260), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6451), 1,
      sym__preprocessor_call,
  [259127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9405), 1,
      anon_sym_COMMA,
    ACTIONS(9408), 1,
      anon_sym_RPAREN,
    STATE(6452), 2,
      sym__preprocessor_call,
      aux_sym_tuple_pattern_repeat1,
  [259144] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1691), 1,
      anon_sym_RBRACE,
    ACTIONS(9410), 1,
      anon_sym_COMMA,
    STATE(6290), 1,
      aux_sym_switch_expression_repeat1,
    STATE(6453), 1,
      sym__preprocessor_call,
  [259163] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6454), 1,
      sym__preprocessor_call,
    ACTIONS(9412), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [259178] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1679), 1,
      anon_sym_RBRACE,
    ACTIONS(9414), 1,
      anon_sym_COMMA,
    STATE(6159), 1,
      aux_sym_positional_pattern_clause_repeat1,
    STATE(6455), 1,
      sym__preprocessor_call,
  [259197] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9416), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6456), 1,
      sym__preprocessor_call,
  [259216] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9418), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6457), 1,
      sym__preprocessor_call,
  [259235] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(9420), 1,
      anon_sym_RBRACK,
    STATE(6093), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6458), 1,
      sym__preprocessor_call,
  [259254] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9033), 1,
      anon_sym_COMMA,
    ACTIONS(9422), 1,
      anon_sym_RPAREN,
    STATE(6275), 1,
      aux_sym_parenthesized_variable_designation_repeat1,
    STATE(6459), 1,
      sym__preprocessor_call,
  [259273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9239), 1,
      anon_sym_COMMA,
    ACTIONS(9424), 1,
      anon_sym_RBRACE,
    STATE(6277), 1,
      aux_sym_with_initializer_expression_repeat1,
    STATE(6460), 1,
      sym__preprocessor_call,
  [259292] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9426), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6461), 1,
      sym__preprocessor_call,
  [259311] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9428), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6462), 1,
      sym__preprocessor_call,
  [259330] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9430), 1,
      anon_sym_EQ,
    STATE(6463), 1,
      sym__preprocessor_call,
    ACTIONS(9432), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [259347] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9434), 1,
      anon_sym_COMMA,
    ACTIONS(9436), 1,
      anon_sym_RBRACE,
    STATE(6224), 1,
      aux_sym_anonymous_object_creation_expression_repeat1,
    STATE(6464), 1,
      sym__preprocessor_call,
  [259366] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(9438), 1,
      anon_sym_RBRACK,
    STATE(6458), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6465), 1,
      sym__preprocessor_call,
  [259385] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6460), 1,
      anon_sym_COMMA,
    ACTIONS(9440), 1,
      anon_sym_RPAREN,
    STATE(6090), 1,
      aux_sym_for_statement_repeat1,
    STATE(6466), 1,
      sym__preprocessor_call,
  [259404] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9442), 1,
      anon_sym_RPAREN,
    STATE(6351), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6467), 1,
      sym__preprocessor_call,
  [259423] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    ACTIONS(9444), 1,
      anon_sym_RPAREN,
    STATE(6223), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6468), 1,
      sym__preprocessor_call,
  [259442] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5757), 1,
      anon_sym_COMMA,
    ACTIONS(9446), 1,
      anon_sym_RBRACK,
    STATE(6093), 1,
      aux_sym_type_argument_list_repeat1,
    STATE(6469), 1,
      sym__preprocessor_call,
  [259461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3250), 1,
      anon_sym_LBRACK,
    ACTIONS(7553), 1,
      anon_sym_STAR,
    STATE(2148), 1,
      sym_array_rank_specifier,
    STATE(6470), 1,
      sym__preprocessor_call,
  [259480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6471), 1,
      sym__preprocessor_call,
    ACTIONS(9448), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_RPAREN,
  [259495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9450), 1,
      anon_sym_LBRACK,
    STATE(6114), 1,
      sym_bracketed_parameter_list,
    STATE(6472), 1,
      sym__preprocessor_call,
  [259511] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1023), 1,
      anon_sym_LBRACE,
    STATE(3089), 1,
      sym_initializer_expression,
    STATE(6473), 1,
      sym__preprocessor_call,
  [259527] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(6119), 1,
      sym_parameter_list,
    STATE(6474), 1,
      sym__preprocessor_call,
  [259543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(747), 1,
      anon_sym_LBRACE,
    STATE(2839), 1,
      sym_initializer_expression,
    STATE(6475), 1,
      sym__preprocessor_call,
  [259559] = 4,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    STATE(6476), 1,
      sym__preprocessor_call,
    ACTIONS(9452), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
  [259573] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9412), 1,
      anon_sym_RPAREN,
    ACTIONS(9454), 1,
      anon_sym_COMMA,
    STATE(6477), 1,
      sym__preprocessor_call,
  [259589] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6478), 1,
      sym__preprocessor_call,
    ACTIONS(8644), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [259603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5650), 1,
      sym_parameter_list,
    STATE(6479), 1,
      sym__preprocessor_call,
  [259619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6480), 1,
      sym__preprocessor_call,
    ACTIONS(9457), 2,
      anon_sym_LBRACE,
      anon_sym_when,
  [259633] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(965), 1,
      anon_sym_LBRACE,
    STATE(2219), 1,
      sym_initializer_expression,
    STATE(6481), 1,
      sym__preprocessor_call,
  [259649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6482), 1,
      sym__preprocessor_call,
    ACTIONS(8937), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [259663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6483), 1,
      sym__preprocessor_call,
    ACTIONS(8932), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [259677] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    STATE(1607), 1,
      sym_block,
    STATE(6484), 1,
      sym__preprocessor_call,
  [259693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6485), 1,
      sym__preprocessor_call,
    ACTIONS(9459), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [259707] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6486), 1,
      sym__preprocessor_call,
    ACTIONS(9461), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [259721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7027), 1,
      anon_sym_DASH_GT,
    ACTIONS(9463), 1,
      anon_sym_DOT,
    STATE(6487), 1,
      sym__preprocessor_call,
  [259737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9465), 1,
      anon_sym_LBRACE,
    STATE(1628), 1,
      sym_switch_body,
    STATE(6488), 1,
      sym__preprocessor_call,
  [259753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    STATE(6314), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6489), 1,
      sym__preprocessor_call,
  [259769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6490), 1,
      sym__preprocessor_call,
    ACTIONS(7027), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [259783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    STATE(6432), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6491), 1,
      sym__preprocessor_call,
  [259799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6160), 1,
      anon_sym_DASH_GT,
    ACTIONS(9467), 1,
      anon_sym_DOT,
    STATE(6492), 1,
      sym__preprocessor_call,
  [259815] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6493), 1,
      sym__preprocessor_call,
    ACTIONS(6160), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [259829] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(747), 1,
      anon_sym_LBRACE,
    STATE(2805), 1,
      sym_initializer_expression,
    STATE(6494), 1,
      sym__preprocessor_call,
  [259845] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5793), 1,
      anon_sym_DASH_GT,
    ACTIONS(9469), 1,
      anon_sym_DOT,
    STATE(6495), 1,
      sym__preprocessor_call,
  [259861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6496), 1,
      sym__preprocessor_call,
    ACTIONS(5793), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [259875] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6497), 1,
      sym__preprocessor_call,
    ACTIONS(3132), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [259889] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(6141), 1,
      sym_parameter_list,
    STATE(6498), 1,
      sym__preprocessor_call,
  [259905] = 4,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    STATE(6499), 1,
      sym__preprocessor_call,
    ACTIONS(9471), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
  [259919] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8662), 1,
      anon_sym_DOT,
    ACTIONS(9473), 1,
      anon_sym_SEMI,
    STATE(6500), 1,
      sym__preprocessor_call,
  [259935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6501), 1,
      sym__preprocessor_call,
    ACTIONS(9475), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [259949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2909), 1,
      anon_sym_DASH_GT,
    ACTIONS(9477), 1,
      anon_sym_DOT,
    STATE(6502), 1,
      sym__preprocessor_call,
  [259965] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3132), 1,
      anon_sym_DASH_GT,
    ACTIONS(9479), 1,
      anon_sym_DOT,
    STATE(6503), 1,
      sym__preprocessor_call,
  [259981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6504), 1,
      sym__preprocessor_call,
    ACTIONS(9481), 2,
      anon_sym_LBRACE,
      anon_sym_when,
  [259995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6505), 1,
      sym__preprocessor_call,
    ACTIONS(9408), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [260009] = 4,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    STATE(6506), 1,
      sym__preprocessor_call,
    ACTIONS(9483), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
  [260023] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6507), 1,
      sym__preprocessor_call,
    ACTIONS(2909), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [260037] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9485), 1,
      anon_sym_LPAREN,
    STATE(6508), 1,
      sym__preprocessor_call,
    STATE(6531), 1,
      sym_tuple_expression,
  [260053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6509), 1,
      sym__preprocessor_call,
    ACTIONS(9073), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [260067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6510), 1,
      sym__preprocessor_call,
    ACTIONS(9013), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [260081] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9450), 1,
      anon_sym_LBRACK,
    STATE(6129), 1,
      sym_bracketed_parameter_list,
    STATE(6511), 1,
      sym__preprocessor_call,
  [260097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(1549), 1,
      sym_block,
    STATE(6512), 1,
      sym__preprocessor_call,
  [260113] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6513), 1,
      sym__preprocessor_call,
    ACTIONS(7017), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [260127] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8737), 1,
      anon_sym_LBRACE,
    STATE(5068), 1,
      sym_enum_member_declaration_list,
    STATE(6514), 1,
      sym__preprocessor_call,
  [260143] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7017), 1,
      anon_sym_DASH_GT,
    ACTIONS(9487), 1,
      anon_sym_DOT,
    STATE(6515), 1,
      sym__preprocessor_call,
  [260159] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(747), 1,
      anon_sym_LBRACE,
    STATE(2830), 1,
      sym_initializer_expression,
    STATE(6516), 1,
      sym__preprocessor_call,
  [260175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9489), 1,
      anon_sym_LPAREN,
    STATE(6488), 1,
      sym_tuple_expression,
    STATE(6517), 1,
      sym__preprocessor_call,
  [260191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8776), 1,
      anon_sym_LBRACE,
    STATE(2829), 1,
      sym_block,
    STATE(6518), 1,
      sym__preprocessor_call,
  [260207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(1546), 1,
      sym_block,
    STATE(6519), 1,
      sym__preprocessor_call,
  [260223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    STATE(6342), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6520), 1,
      sym__preprocessor_call,
  [260239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6521), 1,
      sym__preprocessor_call,
    ACTIONS(9040), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [260253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8776), 1,
      anon_sym_LBRACE,
    STATE(2737), 1,
      sym_block,
    STATE(6522), 1,
      sym__preprocessor_call,
  [260269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8811), 1,
      anon_sym_LBRACE,
    STATE(2989), 1,
      sym_block,
    STATE(6523), 1,
      sym__preprocessor_call,
  [260285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8662), 1,
      anon_sym_DOT,
    ACTIONS(9491), 1,
      anon_sym_SEMI,
    STATE(6524), 1,
      sym__preprocessor_call,
  [260301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6525), 1,
      sym__preprocessor_call,
    ACTIONS(8682), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [260315] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(6205), 1,
      sym_parameter_list,
    STATE(6526), 1,
      sym__preprocessor_call,
  [260331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6527), 1,
      sym__preprocessor_call,
    ACTIONS(9493), 2,
      anon_sym_LBRACE,
      anon_sym_EQ_GT,
  [260345] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6528), 1,
      sym__preprocessor_call,
    ACTIONS(9495), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [260359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6529), 1,
      sym__preprocessor_call,
    ACTIONS(9497), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [260373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8737), 1,
      anon_sym_LBRACE,
    STATE(5081), 1,
      sym_enum_member_declaration_list,
    STATE(6530), 1,
      sym__preprocessor_call,
  [260389] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9499), 1,
      anon_sym_LBRACE,
    STATE(1667), 1,
      sym_switch_body,
    STATE(6531), 1,
      sym__preprocessor_call,
  [260405] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5683), 1,
      sym_parameter_list,
    STATE(6532), 1,
      sym__preprocessor_call,
  [260421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9465), 1,
      anon_sym_LBRACE,
    STATE(1592), 1,
      sym_switch_body,
    STATE(6533), 1,
      sym__preprocessor_call,
  [260437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6534), 1,
      sym__preprocessor_call,
    ACTIONS(8577), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [260451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(1550), 1,
      sym_block,
    STATE(6535), 1,
      sym__preprocessor_call,
  [260467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6536), 1,
      sym__preprocessor_call,
    ACTIONS(9501), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [260481] = 4,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    STATE(6537), 1,
      sym__preprocessor_call,
    ACTIONS(9503), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
  [260495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6538), 1,
      sym__preprocessor_call,
    ACTIONS(9505), 2,
      anon_sym_this,
      anon_sym_base,
  [260509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9450), 1,
      anon_sym_LBRACK,
    STATE(6113), 1,
      sym_bracketed_parameter_list,
    STATE(6539), 1,
      sym__preprocessor_call,
  [260525] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5688), 1,
      sym_parameter_list,
    STATE(6540), 1,
      sym__preprocessor_call,
  [260541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6541), 1,
      sym__preprocessor_call,
    ACTIONS(9507), 2,
      anon_sym_assembly,
      anon_sym_module,
  [260555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5887), 1,
      sym_parameter_list,
    STATE(6542), 1,
      sym__preprocessor_call,
  [260571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9450), 1,
      anon_sym_LBRACK,
    STATE(6216), 1,
      sym_bracketed_parameter_list,
    STATE(6543), 1,
      sym__preprocessor_call,
  [260587] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5904), 1,
      sym_parameter_list,
    STATE(6544), 1,
      sym__preprocessor_call,
  [260603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5676), 1,
      sym_parameter_list,
    STATE(6545), 1,
      sym__preprocessor_call,
  [260619] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8662), 1,
      anon_sym_DOT,
    ACTIONS(9509), 1,
      anon_sym_SEMI,
    STATE(6546), 1,
      sym__preprocessor_call,
  [260635] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6547), 1,
      sym__preprocessor_call,
    ACTIONS(9104), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [260649] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8811), 1,
      anon_sym_LBRACE,
    STATE(3082), 1,
      sym_block,
    STATE(6548), 1,
      sym__preprocessor_call,
  [260665] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1023), 1,
      anon_sym_LBRACE,
    STATE(3070), 1,
      sym_initializer_expression,
    STATE(6549), 1,
      sym__preprocessor_call,
  [260681] = 4,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    STATE(6550), 1,
      sym__preprocessor_call,
    ACTIONS(9511), 2,
      aux_sym_character_literal_token1,
      sym_escape_sequence,
  [260695] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6398), 1,
      anon_sym_LBRACE,
    STATE(2193), 1,
      sym_block,
    STATE(6551), 1,
      sym__preprocessor_call,
  [260711] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5912), 1,
      sym_parameter_list,
    STATE(6552), 1,
      sym__preprocessor_call,
  [260727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8735), 1,
      anon_sym_LBRACE,
    STATE(2281), 1,
      sym_enum_member_declaration_list,
    STATE(6553), 1,
      sym__preprocessor_call,
  [260743] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    STATE(1686), 1,
      sym_block,
    STATE(6554), 1,
      sym__preprocessor_call,
  [260759] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(1023), 1,
      anon_sym_LBRACE,
    STATE(3098), 1,
      sym_initializer_expression,
    STATE(6555), 1,
      sym__preprocessor_call,
  [260775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(821), 1,
      anon_sym_LBRACE,
    STATE(2936), 1,
      sym_initializer_expression,
    STATE(6556), 1,
      sym__preprocessor_call,
  [260791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5589), 1,
      sym_parameter_list,
    STATE(6557), 1,
      sym__preprocessor_call,
  [260807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6558), 1,
      sym__preprocessor_call,
    ACTIONS(3020), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [260821] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3020), 1,
      anon_sym_DASH_GT,
    ACTIONS(9513), 1,
      anon_sym_DOT,
    STATE(6559), 1,
      sym__preprocessor_call,
  [260837] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    STATE(6269), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6560), 1,
      sym__preprocessor_call,
  [260853] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2394), 1,
      anon_sym_while,
    ACTIONS(9515), 1,
      anon_sym_else,
    STATE(6561), 1,
      sym__preprocessor_call,
  [260869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(6162), 1,
      sym_parameter_list,
    STATE(6562), 1,
      sym__preprocessor_call,
  [260885] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7825), 1,
      anon_sym_SEMI,
    ACTIONS(8662), 1,
      anon_sym_DOT,
    STATE(6563), 1,
      sym__preprocessor_call,
  [260901] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(821), 1,
      anon_sym_LBRACE,
    STATE(2973), 1,
      sym_initializer_expression,
    STATE(6564), 1,
      sym__preprocessor_call,
  [260917] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8754), 1,
      anon_sym_LBRACE,
    STATE(2138), 1,
      sym_block,
    STATE(6565), 1,
      sym__preprocessor_call,
  [260933] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3138), 1,
      anon_sym_DASH_GT,
    ACTIONS(9517), 1,
      anon_sym_DOT,
    STATE(6566), 1,
      sym__preprocessor_call,
  [260949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5638), 1,
      sym_parameter_list,
    STATE(6567), 1,
      sym__preprocessor_call,
  [260965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6568), 1,
      sym__preprocessor_call,
    ACTIONS(9167), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [260979] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(821), 1,
      anon_sym_LBRACE,
    STATE(2985), 1,
      sym_initializer_expression,
    STATE(6569), 1,
      sym__preprocessor_call,
  [260995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8869), 1,
      anon_sym_LBRACE,
    STATE(2984), 1,
      sym_block,
    STATE(6570), 1,
      sym__preprocessor_call,
  [261011] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(965), 1,
      anon_sym_LBRACE,
    STATE(2226), 1,
      sym_initializer_expression,
    STATE(6571), 1,
      sym__preprocessor_call,
  [261027] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8662), 1,
      anon_sym_DOT,
    ACTIONS(9519), 1,
      anon_sym_SEMI,
    STATE(6572), 1,
      sym__preprocessor_call,
  [261043] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6398), 1,
      anon_sym_LBRACE,
    STATE(2329), 1,
      sym_block,
    STATE(6573), 1,
      sym__preprocessor_call,
  [261059] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8869), 1,
      anon_sym_LBRACE,
    STATE(2929), 1,
      sym_block,
    STATE(6574), 1,
      sym__preprocessor_call,
  [261075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6575), 1,
      sym__preprocessor_call,
    ACTIONS(9197), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [261089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(6167), 1,
      sym_parameter_list,
    STATE(6576), 1,
      sym__preprocessor_call,
  [261105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(6172), 1,
      sym_parameter_list,
    STATE(6577), 1,
      sym__preprocessor_call,
  [261121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5673), 1,
      sym_parameter_list,
    STATE(6578), 1,
      sym__preprocessor_call,
  [261137] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6579), 1,
      sym__preprocessor_call,
    ACTIONS(9225), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [261151] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9499), 1,
      anon_sym_LBRACE,
    STATE(1691), 1,
      sym_switch_body,
    STATE(6580), 1,
      sym__preprocessor_call,
  [261167] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6581), 1,
      sym__preprocessor_call,
    ACTIONS(3138), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [261181] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    STATE(1655), 1,
      sym_block,
    STATE(6582), 1,
      sym__preprocessor_call,
  [261197] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(9521), 1,
      sym_preproc_message,
    ACTIONS(9523), 1,
      sym__preproc_directive_end,
    STATE(6583), 1,
      sym__preprocessor_call,
  [261213] = 5,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(9525), 1,
      sym_preproc_message,
    ACTIONS(9527), 1,
      sym__preproc_directive_end,
    STATE(6584), 1,
      sym__preprocessor_call,
  [261229] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9529), 1,
      anon_sym_warning,
    ACTIONS(9531), 1,
      anon_sym_checksum,
    STATE(6585), 1,
      sym__preprocessor_call,
  [261245] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8737), 1,
      anon_sym_LBRACE,
    STATE(5061), 1,
      sym_enum_member_declaration_list,
    STATE(6586), 1,
      sym__preprocessor_call,
  [261261] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8754), 1,
      anon_sym_LBRACE,
    STATE(2163), 1,
      sym_block,
    STATE(6587), 1,
      sym__preprocessor_call,
  [261277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(889), 1,
      anon_sym_LBRACE,
    STATE(2160), 1,
      sym_initializer_expression,
    STATE(6588), 1,
      sym__preprocessor_call,
  [261293] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6589), 1,
      sym__preprocessor_call,
    ACTIONS(9533), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [261307] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5657), 1,
      sym_parameter_list,
    STATE(6590), 1,
      sym__preprocessor_call,
  [261323] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5661), 1,
      sym_parameter_list,
    STATE(6591), 1,
      sym__preprocessor_call,
  [261339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6592), 1,
      sym__preprocessor_call,
    ACTIONS(6020), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [261353] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6020), 1,
      anon_sym_DASH_GT,
    ACTIONS(9535), 1,
      anon_sym_DOT,
    STATE(6593), 1,
      sym__preprocessor_call,
  [261369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6594), 1,
      sym__preprocessor_call,
    ACTIONS(9537), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [261383] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3252), 1,
      anon_sym_LPAREN,
    STATE(6358), 1,
      sym_argument_list,
    STATE(6595), 1,
      sym__preprocessor_call,
  [261399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(965), 1,
      anon_sym_LBRACE,
    STATE(2259), 1,
      sym_initializer_expression,
    STATE(6596), 1,
      sym__preprocessor_call,
  [261415] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6597), 1,
      sym__preprocessor_call,
    ACTIONS(9286), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [261429] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5622), 1,
      sym_parameter_list,
    STATE(6598), 1,
      sym__preprocessor_call,
  [261445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6599), 1,
      sym__preprocessor_call,
    ACTIONS(8911), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [261459] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8735), 1,
      anon_sym_LBRACE,
    STATE(2310), 1,
      sym_enum_member_declaration_list,
    STATE(6600), 1,
      sym__preprocessor_call,
  [261475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8735), 1,
      anon_sym_LBRACE,
    STATE(2247), 1,
      sym_enum_member_declaration_list,
    STATE(6601), 1,
      sym__preprocessor_call,
  [261491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(889), 1,
      anon_sym_LBRACE,
    STATE(2153), 1,
      sym_initializer_expression,
    STATE(6602), 1,
      sym__preprocessor_call,
  [261507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6603), 1,
      sym__preprocessor_call,
    ACTIONS(9539), 2,
      anon_sym_COMMA,
      anon_sym_GT,
  [261521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6604), 1,
      sym__preprocessor_call,
    ACTIONS(9541), 2,
      sym__preproc_directive_end,
      anon_sym_COMMA,
  [261535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6605), 1,
      sym__preprocessor_call,
    ACTIONS(9301), 2,
      sym__preproc_directive_end,
      anon_sym_COMMA,
  [261549] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5682), 1,
      sym_parameter_list,
    STATE(6606), 1,
      sym__preprocessor_call,
  [261565] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9450), 1,
      anon_sym_LBRACK,
    STATE(6152), 1,
      sym_bracketed_parameter_list,
    STATE(6607), 1,
      sym__preprocessor_call,
  [261581] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9543), 1,
      sym_preproc_string_literal,
    ACTIONS(9545), 1,
      sym__preproc_directive_end,
    STATE(6608), 1,
      sym__preprocessor_call,
  [261597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6609), 1,
      sym__preprocessor_call,
    ACTIONS(9547), 2,
      anon_sym_disable,
      anon_sym_restore,
  [261611] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5889), 1,
      sym_parameter_list,
    STATE(6610), 1,
      sym__preprocessor_call,
  [261627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9450), 1,
      anon_sym_LBRACK,
    STATE(6124), 1,
      sym_bracketed_parameter_list,
    STATE(6611), 1,
      sym__preprocessor_call,
  [261643] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6124), 1,
      anon_sym_LBRACE,
    STATE(1649), 1,
      sym_block,
    STATE(6612), 1,
      sym__preprocessor_call,
  [261659] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6613), 1,
      sym__preprocessor_call,
    ACTIONS(3184), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [261673] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(889), 1,
      anon_sym_LBRACE,
    STATE(2104), 1,
      sym_initializer_expression,
    STATE(6614), 1,
      sym__preprocessor_call,
  [261689] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5894), 1,
      sym_parameter_list,
    STATE(6615), 1,
      sym__preprocessor_call,
  [261705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3184), 1,
      anon_sym_DASH_GT,
    ACTIONS(9549), 1,
      anon_sym_DOT,
    STATE(6616), 1,
      sym__preprocessor_call,
  [261721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5903), 1,
      sym_parameter_list,
    STATE(6617), 1,
      sym__preprocessor_call,
  [261737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3188), 1,
      anon_sym_DASH_GT,
    ACTIONS(9551), 1,
      anon_sym_DOT,
    STATE(6618), 1,
      sym__preprocessor_call,
  [261753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7819), 1,
      anon_sym_LPAREN,
    STATE(5628), 1,
      sym_parameter_list,
    STATE(6619), 1,
      sym__preprocessor_call,
  [261769] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8913), 1,
      anon_sym_COMMA,
    STATE(6467), 1,
      aux_sym_bracketed_argument_list_repeat1,
    STATE(6620), 1,
      sym__preprocessor_call,
  [261785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    STATE(6621), 1,
      sym__preprocessor_call,
    ACTIONS(3188), 2,
      anon_sym_DOT,
      anon_sym_DASH_GT,
  [261799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5584), 1,
      anon_sym_LBRACE,
    STATE(1614), 1,
      sym_block,
    STATE(6622), 1,
      sym__preprocessor_call,
  [261815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8662), 1,
      anon_sym_DOT,
    ACTIONS(9553), 1,
      anon_sym_SEMI,
    STATE(6623), 1,
      sym__preprocessor_call,
  [261831] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9555), 1,
      anon_sym_LPAREN,
    STATE(6624), 1,
      sym__preprocessor_call,
  [261844] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9557), 1,
      anon_sym_EQ_GT,
    STATE(6625), 1,
      sym__preprocessor_call,
  [261857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9559), 1,
      anon_sym_EQ_GT,
    STATE(6626), 1,
      sym__preprocessor_call,
  [261870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6854), 1,
      anon_sym_EQ_GT,
    STATE(6627), 1,
      sym__preprocessor_call,
  [261883] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7037), 1,
      anon_sym_RPAREN,
    STATE(6628), 1,
      sym__preprocessor_call,
  [261896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9561), 1,
      anon_sym_RPAREN,
    STATE(6629), 1,
      sym__preprocessor_call,
  [261909] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9325), 1,
      anon_sym_RBRACE,
    STATE(6630), 1,
      sym__preprocessor_call,
  [261922] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9563), 1,
      anon_sym_EQ_GT,
    STATE(6631), 1,
      sym__preprocessor_call,
  [261935] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9565), 1,
      anon_sym_COMMA,
    STATE(6632), 1,
      sym__preprocessor_call,
  [261948] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9567), 1,
      anon_sym_EQ_GT,
    STATE(6633), 1,
      sym__preprocessor_call,
  [261961] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7143), 1,
      anon_sym_RPAREN,
    STATE(6634), 1,
      sym__preprocessor_call,
  [261974] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9569), 1,
      anon_sym_RBRACE,
    STATE(6635), 1,
      sym__preprocessor_call,
  [261987] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9571), 1,
      anon_sym_EQ_GT,
    STATE(6636), 1,
      sym__preprocessor_call,
  [262000] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9573), 1,
      anon_sym_SEMI,
    STATE(6637), 1,
      sym__preprocessor_call,
  [262013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9575), 1,
      anon_sym_RBRACE,
    STATE(6638), 1,
      sym__preprocessor_call,
  [262026] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6332), 1,
      anon_sym_RBRACE,
    STATE(6639), 1,
      sym__preprocessor_call,
  [262039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9577), 1,
      anon_sym_EQ_GT,
    STATE(6640), 1,
      sym__preprocessor_call,
  [262052] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9579), 1,
      anon_sym_RBRACE,
    STATE(6641), 1,
      sym__preprocessor_call,
  [262065] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9581), 1,
      sym_preproc_string_literal,
    STATE(6642), 1,
      sym__preprocessor_call,
  [262078] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9583), 1,
      anon_sym_EQ_GT,
    STATE(6643), 1,
      sym__preprocessor_call,
  [262091] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9585), 1,
      anon_sym_RPAREN,
    STATE(6644), 1,
      sym__preprocessor_call,
  [262104] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9587), 1,
      anon_sym_SEMI,
    STATE(6645), 1,
      sym__preprocessor_call,
  [262117] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9545), 1,
      sym__preproc_directive_end,
    STATE(6646), 1,
      sym__preprocessor_call,
  [262130] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9589), 1,
      sym__preproc_directive_end,
    STATE(6647), 1,
      sym__preprocessor_call,
  [262143] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9591), 1,
      anon_sym_EQ_GT,
    STATE(6648), 1,
      sym__preprocessor_call,
  [262156] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8919), 1,
      anon_sym_LPAREN,
    STATE(6649), 1,
      sym__preprocessor_call,
  [262169] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5658), 1,
      anon_sym_EQ_GT,
    STATE(6650), 1,
      sym__preprocessor_call,
  [262182] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9593), 1,
      anon_sym_EQ_GT,
    STATE(6651), 1,
      sym__preprocessor_call,
  [262195] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9595), 1,
      sym__preproc_directive_end,
    STATE(6652), 1,
      sym__preprocessor_call,
  [262208] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9597), 1,
      anon_sym_COLON,
    STATE(6653), 1,
      sym__preprocessor_call,
  [262221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9599), 1,
      anon_sym_DOT,
    STATE(6654), 1,
      sym__preprocessor_call,
  [262234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9601), 1,
      sym__preproc_directive_end,
    STATE(6655), 1,
      sym__preprocessor_call,
  [262247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9603), 1,
      anon_sym_EQ_GT,
    STATE(6656), 1,
      sym__preprocessor_call,
  [262260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9605), 1,
      anon_sym_EQ_GT,
    STATE(6657), 1,
      sym__preprocessor_call,
  [262273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9607), 1,
      anon_sym_EQ_GT,
    STATE(6658), 1,
      sym__preprocessor_call,
  [262286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9609), 1,
      anon_sym_in,
    STATE(6659), 1,
      sym__preprocessor_call,
  [262299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9611), 1,
      anon_sym_SEMI,
    STATE(6660), 1,
      sym__preprocessor_call,
  [262312] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9613), 1,
      anon_sym_SEMI,
    STATE(6661), 1,
      sym__preprocessor_call,
  [262325] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9615), 1,
      anon_sym_EQ_GT,
    STATE(6662), 1,
      sym__preprocessor_call,
  [262338] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9617), 1,
      sym__preproc_directive_end,
    STATE(6663), 1,
      sym__preprocessor_call,
  [262351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9359), 1,
      anon_sym_RBRACE,
    STATE(6664), 1,
      sym__preprocessor_call,
  [262364] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9619), 1,
      anon_sym_EQ_GT,
    STATE(6665), 1,
      sym__preprocessor_call,
  [262377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9621), 1,
      anon_sym_LPAREN,
    STATE(6666), 1,
      sym__preprocessor_call,
  [262390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9623), 1,
      sym__preproc_directive_end,
    STATE(6667), 1,
      sym__preprocessor_call,
  [262403] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9625), 1,
      sym__preproc_directive_end,
    STATE(6668), 1,
      sym__preprocessor_call,
  [262416] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9627), 1,
      anon_sym_EQ_GT,
    STATE(6669), 1,
      sym__preprocessor_call,
  [262429] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6672), 1,
      anon_sym_EQ_GT,
    STATE(6670), 1,
      sym__preprocessor_call,
  [262442] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9629), 1,
      anon_sym_RBRACE,
    STATE(6671), 1,
      sym__preprocessor_call,
  [262455] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9631), 1,
      anon_sym_RBRACE,
    STATE(6672), 1,
      sym__preprocessor_call,
  [262468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5432), 1,
      anon_sym_EQ_GT,
    STATE(6673), 1,
      sym__preprocessor_call,
  [262481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9633), 1,
      anon_sym_COLON,
    STATE(6674), 1,
      sym__preprocessor_call,
  [262494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9635), 1,
      anon_sym_EQ_GT,
    STATE(6675), 1,
      sym__preprocessor_call,
  [262507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9637), 1,
      anon_sym_in,
    STATE(6676), 1,
      sym__preprocessor_call,
  [262520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9639), 1,
      anon_sym_in,
    STATE(6677), 1,
      sym__preprocessor_call,
  [262533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9641), 1,
      sym_preproc_string_literal,
    STATE(6678), 1,
      sym__preprocessor_call,
  [262546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9643), 1,
      anon_sym_SEMI,
    STATE(6679), 1,
      sym__preprocessor_call,
  [262559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9645), 1,
      anon_sym_EQ_GT,
    STATE(6680), 1,
      sym__preprocessor_call,
  [262572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9259), 1,
      anon_sym_RBRACE,
    STATE(6681), 1,
      sym__preprocessor_call,
  [262585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9647), 1,
      anon_sym_EQ_GT,
    STATE(6682), 1,
      sym__preprocessor_call,
  [262598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9649), 1,
      anon_sym_EQ_GT,
    STATE(6683), 1,
      sym__preprocessor_call,
  [262611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7407), 1,
      anon_sym_RPAREN,
    STATE(6684), 1,
      sym__preprocessor_call,
  [262624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6412), 1,
      anon_sym_RBRACE,
    STATE(6685), 1,
      sym__preprocessor_call,
  [262637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9651), 1,
      anon_sym_EQ_GT,
    STATE(6686), 1,
      sym__preprocessor_call,
  [262650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9653), 1,
      anon_sym_EQ_GT,
    STATE(6687), 1,
      sym__preprocessor_call,
  [262663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6308), 1,
      anon_sym_EQ_GT,
    STATE(6688), 1,
      sym__preprocessor_call,
  [262676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9655), 1,
      anon_sym_EQ_GT,
    STATE(6689), 1,
      sym__preprocessor_call,
  [262689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9253), 1,
      sym__preproc_directive_end,
    STATE(6690), 1,
      sym__preprocessor_call,
  [262702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6400), 1,
      anon_sym_STAR,
    STATE(6691), 1,
      sym__preprocessor_call,
  [262715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9657), 1,
      anon_sym_SEMI,
    STATE(6692), 1,
      sym__preprocessor_call,
  [262728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5747), 1,
      anon_sym_EQ_GT,
    STATE(6693), 1,
      sym__preprocessor_call,
  [262741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9659), 1,
      anon_sym_SEMI,
    STATE(6694), 1,
      sym__preprocessor_call,
  [262754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9661), 1,
      anon_sym_SEMI,
    STATE(6695), 1,
      sym__preprocessor_call,
  [262767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(147), 1,
      ts_builtin_sym_end,
    STATE(6696), 1,
      sym__preprocessor_call,
  [262780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7257), 1,
      anon_sym_EQ_GT,
    STATE(6697), 1,
      sym__preprocessor_call,
  [262793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9237), 1,
      anon_sym_RBRACE,
    STATE(6698), 1,
      sym__preprocessor_call,
  [262806] = 4,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(9663), 1,
      sym_preproc_message,
    STATE(6699), 1,
      sym__preprocessor_call,
  [262819] = 4,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(9665), 1,
      sym_preproc_message,
    STATE(6700), 1,
      sym__preprocessor_call,
  [262832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9667), 1,
      anon_sym_EQ_GT,
    STATE(6701), 1,
      sym__preprocessor_call,
  [262845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9669), 1,
      anon_sym_EQ_GT,
    STATE(6702), 1,
      sym__preprocessor_call,
  [262858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9671), 1,
      sym__preproc_directive_end,
    STATE(6703), 1,
      sym__preprocessor_call,
  [262871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9673), 1,
      anon_sym_SEMI,
    STATE(6704), 1,
      sym__preprocessor_call,
  [262884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9675), 1,
      anon_sym_EQ_GT,
    STATE(6705), 1,
      sym__preprocessor_call,
  [262897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9677), 1,
      anon_sym_operator,
    STATE(6706), 1,
      sym__preprocessor_call,
  [262910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9679), 1,
      anon_sym_SEMI,
    STATE(6707), 1,
      sym__preprocessor_call,
  [262923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9681), 1,
      sym__preproc_directive_end,
    STATE(6708), 1,
      sym__preprocessor_call,
  [262936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9683), 1,
      anon_sym_EQ,
    STATE(6709), 1,
      sym__preprocessor_call,
  [262949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6504), 1,
      anon_sym_EQ_GT,
    STATE(6710), 1,
      sym__preprocessor_call,
  [262962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5917), 1,
      anon_sym_EQ_GT,
    STATE(6711), 1,
      sym__preprocessor_call,
  [262975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9685), 1,
      anon_sym_QMARK,
    STATE(6712), 1,
      sym__preprocessor_call,
  [262988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9687), 1,
      anon_sym_SEMI,
    STATE(6713), 1,
      sym__preprocessor_call,
  [263001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9689), 1,
      anon_sym_EQ,
    STATE(6714), 1,
      sym__preprocessor_call,
  [263014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9691), 1,
      anon_sym_SEMI,
    STATE(6715), 1,
      sym__preprocessor_call,
  [263027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9693), 1,
      anon_sym_EQ_GT,
    STATE(6716), 1,
      sym__preprocessor_call,
  [263040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9695), 1,
      anon_sym_EQ_GT,
    STATE(6717), 1,
      sym__preprocessor_call,
  [263053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9697), 1,
      anon_sym_RBRACE,
    STATE(6718), 1,
      sym__preprocessor_call,
  [263066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9218), 1,
      anon_sym_RBRACE,
    STATE(6719), 1,
      sym__preprocessor_call,
  [263079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9699), 1,
      anon_sym_EQ_GT,
    STATE(6720), 1,
      sym__preprocessor_call,
  [263092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9701), 1,
      anon_sym_LPAREN,
    STATE(6721), 1,
      sym__preprocessor_call,
  [263105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9703), 1,
      anon_sym_SEMI,
    STATE(6722), 1,
      sym__preprocessor_call,
  [263118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6596), 1,
      anon_sym_SEMI,
    STATE(6723), 1,
      sym__preprocessor_call,
  [263131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6592), 1,
      anon_sym_SEMI,
    STATE(6724), 1,
      sym__preprocessor_call,
  [263144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9705), 1,
      anon_sym_LT,
    STATE(6725), 1,
      sym__preprocessor_call,
  [263157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9707), 1,
      anon_sym_SEMI,
    STATE(6726), 1,
      sym__preprocessor_call,
  [263170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9709), 1,
      anon_sym_QMARK,
    STATE(6727), 1,
      sym__preprocessor_call,
  [263183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9711), 1,
      anon_sym_SEMI,
    STATE(6728), 1,
      sym__preprocessor_call,
  [263196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9713), 1,
      anon_sym_RBRACE,
    STATE(6729), 1,
      sym__preprocessor_call,
  [263209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9715), 1,
      anon_sym_COMMA,
    STATE(6730), 1,
      sym__preprocessor_call,
  [263222] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(133), 1,
      ts_builtin_sym_end,
    STATE(6731), 1,
      sym__preprocessor_call,
  [263235] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9717), 1,
      anon_sym_EQ_GT,
    STATE(6732), 1,
      sym__preprocessor_call,
  [263248] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9719), 1,
      anon_sym_EQ_GT,
    STATE(6733), 1,
      sym__preprocessor_call,
  [263261] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2842), 1,
      anon_sym_EQ_GT,
    STATE(6734), 1,
      sym__preprocessor_call,
  [263274] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9721), 1,
      anon_sym_LBRACE,
    STATE(6735), 1,
      sym__preprocessor_call,
  [263287] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9723), 1,
      anon_sym_SEMI,
    STATE(6736), 1,
      sym__preprocessor_call,
  [263300] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9201), 1,
      anon_sym_RBRACE,
    STATE(6737), 1,
      sym__preprocessor_call,
  [263313] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9725), 1,
      anon_sym_LBRACE,
    STATE(6738), 1,
      sym__preprocessor_call,
  [263326] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9727), 1,
      anon_sym_EQ_GT,
    STATE(6739), 1,
      sym__preprocessor_call,
  [263339] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9729), 1,
      anon_sym_EQ_GT,
    STATE(6740), 1,
      sym__preprocessor_call,
  [263352] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9731), 1,
      anon_sym_RBRACK,
    STATE(6741), 1,
      sym__preprocessor_call,
  [263365] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9733), 1,
      anon_sym_EQ_GT,
    STATE(6742), 1,
      sym__preprocessor_call,
  [263378] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9735), 1,
      anon_sym_SQUOTE,
    STATE(6743), 1,
      sym__preprocessor_call,
  [263391] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    STATE(6744), 1,
      sym__preprocessor_call,
  [263404] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(135), 1,
      ts_builtin_sym_end,
    STATE(6745), 1,
      sym__preprocessor_call,
  [263417] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9162), 1,
      anon_sym_RBRACE,
    STATE(6746), 1,
      sym__preprocessor_call,
  [263430] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6426), 1,
      anon_sym_EQ_GT,
    STATE(6747), 1,
      sym__preprocessor_call,
  [263443] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9739), 1,
      anon_sym_EQ_GT,
    STATE(6748), 1,
      sym__preprocessor_call,
  [263456] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6408), 1,
      anon_sym_RBRACE,
    STATE(6749), 1,
      sym__preprocessor_call,
  [263469] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9741), 1,
      anon_sym_LBRACE,
    STATE(6750), 1,
      sym__preprocessor_call,
  [263482] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5978), 1,
      anon_sym_EQ_GT,
    STATE(6751), 1,
      sym__preprocessor_call,
  [263495] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9743), 1,
      anon_sym_EQ_GT,
    STATE(6752), 1,
      sym__preprocessor_call,
  [263508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9745), 1,
      anon_sym_EQ_GT,
    STATE(6753), 1,
      sym__preprocessor_call,
  [263521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9747), 1,
      anon_sym_in,
    STATE(6754), 1,
      sym__preprocessor_call,
  [263534] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9749), 1,
      anon_sym_EQ_GT,
    STATE(6755), 1,
      sym__preprocessor_call,
  [263547] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9751), 1,
      anon_sym_EQ_GT,
    STATE(6756), 1,
      sym__preprocessor_call,
  [263560] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9753), 1,
      anon_sym_EQ_GT,
    STATE(6757), 1,
      sym__preprocessor_call,
  [263573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9755), 1,
      anon_sym_EQ_GT,
    STATE(6758), 1,
      sym__preprocessor_call,
  [263586] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5578), 1,
      anon_sym_EQ_GT,
    STATE(6759), 1,
      sym__preprocessor_call,
  [263599] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9757), 1,
      anon_sym_QMARK,
    STATE(6760), 1,
      sym__preprocessor_call,
  [263612] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9759), 1,
      anon_sym_EQ_GT,
    STATE(6761), 1,
      sym__preprocessor_call,
  [263625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9761), 1,
      anon_sym_EQ_GT,
    STATE(6762), 1,
      sym__preprocessor_call,
  [263638] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5923), 1,
      anon_sym_EQ_GT,
    STATE(6763), 1,
      sym__preprocessor_call,
  [263651] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9763), 1,
      anon_sym_COMMA,
    STATE(6764), 1,
      sym__preprocessor_call,
  [263664] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6858), 1,
      anon_sym_EQ_GT,
    STATE(6765), 1,
      sym__preprocessor_call,
  [263677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9765), 1,
      anon_sym_EQ_GT,
    STATE(6766), 1,
      sym__preprocessor_call,
  [263690] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9767), 1,
      anon_sym_LPAREN,
    STATE(6767), 1,
      sym__preprocessor_call,
  [263703] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5295), 1,
      anon_sym_EQ_GT,
    STATE(6768), 1,
      sym__preprocessor_call,
  [263716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9769), 1,
      anon_sym_EQ_GT,
    STATE(6769), 1,
      sym__preprocessor_call,
  [263729] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7163), 1,
      anon_sym_EQ_GT,
    STATE(6770), 1,
      sym__preprocessor_call,
  [263742] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9771), 1,
      anon_sym_EQ_GT,
    STATE(6771), 1,
      sym__preprocessor_call,
  [263755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9773), 1,
      anon_sym_SEMI,
    STATE(6772), 1,
      sym__preprocessor_call,
  [263768] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9775), 1,
      anon_sym_EQ_GT,
    STATE(6773), 1,
      sym__preprocessor_call,
  [263781] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9777), 1,
      anon_sym_EQ_GT,
    STATE(6774), 1,
      sym__preprocessor_call,
  [263794] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9128), 1,
      anon_sym_RBRACE,
    STATE(6775), 1,
      sym__preprocessor_call,
  [263807] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9779), 1,
      anon_sym_LPAREN,
    STATE(6776), 1,
      sym__preprocessor_call,
  [263820] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9132), 1,
      anon_sym_RBRACE,
    STATE(6777), 1,
      sym__preprocessor_call,
  [263833] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9781), 1,
      anon_sym_RBRACE,
    STATE(6778), 1,
      sym__preprocessor_call,
  [263846] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9783), 1,
      anon_sym_EQ_GT,
    STATE(6779), 1,
      sym__preprocessor_call,
  [263859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9785), 1,
      anon_sym_RPAREN,
    STATE(6780), 1,
      sym__preprocessor_call,
  [263872] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6126), 1,
      anon_sym_EQ_GT,
    STATE(6781), 1,
      sym__preprocessor_call,
  [263885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9787), 1,
      anon_sym_EQ_GT,
    STATE(6782), 1,
      sym__preprocessor_call,
  [263898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9789), 1,
      anon_sym_EQ_GT,
    STATE(6783), 1,
      sym__preprocessor_call,
  [263911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9791), 1,
      anon_sym_SEMI,
    STATE(6784), 1,
      sym__preprocessor_call,
  [263924] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9793), 1,
      anon_sym_SEMI,
    STATE(6785), 1,
      sym__preprocessor_call,
  [263937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9795), 1,
      anon_sym_LT,
    STATE(6786), 1,
      sym__preprocessor_call,
  [263950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6999), 1,
      anon_sym_RPAREN,
    STATE(6787), 1,
      sym__preprocessor_call,
  [263963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9797), 1,
      anon_sym_EQ_GT,
    STATE(6788), 1,
      sym__preprocessor_call,
  [263976] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9799), 1,
      anon_sym_alias,
    STATE(6789), 1,
      sym__preprocessor_call,
  [263989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(141), 1,
      ts_builtin_sym_end,
    STATE(6790), 1,
      sym__preprocessor_call,
  [264002] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9801), 1,
      anon_sym_EQ_GT,
    STATE(6791), 1,
      sym__preprocessor_call,
  [264015] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9803), 1,
      anon_sym_using,
    STATE(6792), 1,
      sym__preprocessor_call,
  [264028] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9805), 1,
      anon_sym_LPAREN,
    STATE(6793), 1,
      sym__preprocessor_call,
  [264041] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9807), 1,
      anon_sym_SEMI,
    STATE(6794), 1,
      sym__preprocessor_call,
  [264054] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9809), 1,
      anon_sym_EQ_GT,
    STATE(6795), 1,
      sym__preprocessor_call,
  [264067] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(2981), 1,
      anon_sym_EQ_GT,
    STATE(6796), 1,
      sym__preprocessor_call,
  [264080] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9811), 1,
      anon_sym_LT,
    STATE(6797), 1,
      sym__preprocessor_call,
  [264093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9813), 1,
      anon_sym_LPAREN,
    STATE(6798), 1,
      sym__preprocessor_call,
  [264106] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9815), 1,
      ts_builtin_sym_end,
    STATE(6799), 1,
      sym__preprocessor_call,
  [264119] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6362), 1,
      anon_sym_RBRACE,
    STATE(6800), 1,
      sym__preprocessor_call,
  [264132] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9817), 1,
      anon_sym_SEMI,
    STATE(6801), 1,
      sym__preprocessor_call,
  [264145] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9819), 1,
      anon_sym_SQUOTE,
    STATE(6802), 1,
      sym__preprocessor_call,
  [264158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9821), 1,
      anon_sym_SEMI,
    STATE(6803), 1,
      sym__preprocessor_call,
  [264171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9823), 1,
      anon_sym_LPAREN,
    STATE(6804), 1,
      sym__preprocessor_call,
  [264184] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9825), 1,
      anon_sym_LPAREN,
    STATE(6805), 1,
      sym__preprocessor_call,
  [264197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9827), 1,
      anon_sym_LPAREN,
    STATE(6806), 1,
      sym__preprocessor_call,
  [264210] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9829), 1,
      anon_sym_LPAREN,
    STATE(6807), 1,
      sym__preprocessor_call,
  [264223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9831), 1,
      anon_sym_LPAREN,
    STATE(6808), 1,
      sym__preprocessor_call,
  [264236] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9091), 1,
      anon_sym_RBRACE,
    STATE(6809), 1,
      sym__preprocessor_call,
  [264249] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9833), 1,
      anon_sym_COMMA,
    STATE(6810), 1,
      sym__preprocessor_call,
  [264262] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9835), 1,
      anon_sym_EQ_GT,
    STATE(6811), 1,
      sym__preprocessor_call,
  [264275] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6714), 1,
      anon_sym_EQ_GT,
    STATE(6812), 1,
      sym__preprocessor_call,
  [264288] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9837), 1,
      anon_sym_LPAREN,
    STATE(6813), 1,
      sym__preprocessor_call,
  [264301] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9839), 1,
      anon_sym_LPAREN,
    STATE(6814), 1,
      sym__preprocessor_call,
  [264314] = 4,
    ACTIONS(8384), 1,
      sym_comment,
    ACTIONS(8386), 1,
      sym__preproc_directive_start,
    ACTIONS(9841), 1,
      aux_sym_interpolation_format_clause_token1,
    STATE(6815), 1,
      sym__preprocessor_call,
  [264327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9843), 1,
      anon_sym_LPAREN,
    STATE(6816), 1,
      sym__preprocessor_call,
  [264340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9845), 1,
      anon_sym_LT,
    STATE(6817), 1,
      sym__preprocessor_call,
  [264353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9847), 1,
      anon_sym_SEMI,
    STATE(6818), 1,
      sym__preprocessor_call,
  [264366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9849), 1,
      anon_sym_LPAREN,
    STATE(6819), 1,
      sym__preprocessor_call,
  [264379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9851), 1,
      anon_sym_LPAREN,
    STATE(6820), 1,
      sym__preprocessor_call,
  [264392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9853), 1,
      anon_sym_SEMI,
    STATE(6821), 1,
      sym__preprocessor_call,
  [264405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7525), 1,
      anon_sym_COLON,
    STATE(6822), 1,
      sym__preprocessor_call,
  [264418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9855), 1,
      anon_sym_EQ_GT,
    STATE(6823), 1,
      sym__preprocessor_call,
  [264431] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6414), 1,
      anon_sym_EQ_GT,
    STATE(6824), 1,
      sym__preprocessor_call,
  [264444] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9857), 1,
      anon_sym_SEMI,
    STATE(6825), 1,
      sym__preprocessor_call,
  [264457] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9859), 1,
      anon_sym_LPAREN,
    STATE(6826), 1,
      sym__preprocessor_call,
  [264470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9861), 1,
      anon_sym_LPAREN,
    STATE(6827), 1,
      sym__preprocessor_call,
  [264483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9863), 1,
      anon_sym_LPAREN,
    STATE(6828), 1,
      sym__preprocessor_call,
  [264496] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9865), 1,
      anon_sym_LPAREN,
    STATE(6829), 1,
      sym__preprocessor_call,
  [264509] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9867), 1,
      anon_sym_LPAREN,
    STATE(6830), 1,
      sym__preprocessor_call,
  [264522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9869), 1,
      anon_sym_LPAREN,
    STATE(6831), 1,
      sym__preprocessor_call,
  [264535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9871), 1,
      anon_sym_COMMA,
    STATE(6832), 1,
      sym__preprocessor_call,
  [264548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9873), 1,
      anon_sym_SEMI,
    STATE(6833), 1,
      sym__preprocessor_call,
  [264561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7435), 1,
      anon_sym_RPAREN,
    STATE(6834), 1,
      sym__preprocessor_call,
  [264574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9875), 1,
      anon_sym_SQUOTE,
    STATE(6835), 1,
      sym__preprocessor_call,
  [264587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9877), 1,
      anon_sym_LPAREN,
    STATE(6836), 1,
      sym__preprocessor_call,
  [264600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6184), 1,
      anon_sym_EQ_GT,
    STATE(6837), 1,
      sym__preprocessor_call,
  [264613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9879), 1,
      anon_sym_LPAREN,
    STATE(6838), 1,
      sym__preprocessor_call,
  [264626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9881), 1,
      anon_sym_LT,
    STATE(6839), 1,
      sym__preprocessor_call,
  [264639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9883), 1,
      anon_sym_EQ_GT,
    STATE(6840), 1,
      sym__preprocessor_call,
  [264652] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9885), 1,
      anon_sym_EQ_GT,
    STATE(6841), 1,
      sym__preprocessor_call,
  [264665] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9887), 1,
      anon_sym_SEMI,
    STATE(6842), 1,
      sym__preprocessor_call,
  [264678] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9889), 1,
      anon_sym_EQ_GT,
    STATE(6843), 1,
      sym__preprocessor_call,
  [264691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9891), 1,
      anon_sym_SEMI,
    STATE(6844), 1,
      sym__preprocessor_call,
  [264704] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9393), 1,
      anon_sym_LT,
    STATE(6845), 1,
      sym__preprocessor_call,
  [264717] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9893), 1,
      anon_sym_SEMI,
    STATE(6846), 1,
      sym__preprocessor_call,
  [264730] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9895), 1,
      anon_sym_LPAREN,
    STATE(6847), 1,
      sym__preprocessor_call,
  [264743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9897), 1,
      anon_sym_LPAREN,
    STATE(6848), 1,
      sym__preprocessor_call,
  [264756] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9899), 1,
      anon_sym_LPAREN,
    STATE(6849), 1,
      sym__preprocessor_call,
  [264769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9901), 1,
      anon_sym_LPAREN,
    STATE(6850), 1,
      sym__preprocessor_call,
  [264782] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9903), 1,
      anon_sym_LPAREN,
    STATE(6851), 1,
      sym__preprocessor_call,
  [264795] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9905), 1,
      anon_sym_LT,
    STATE(6852), 1,
      sym__preprocessor_call,
  [264808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9907), 1,
      anon_sym_COMMA,
    STATE(6853), 1,
      sym__preprocessor_call,
  [264821] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9909), 1,
      anon_sym_EQ_GT,
    STATE(6854), 1,
      sym__preprocessor_call,
  [264834] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9911), 1,
      anon_sym_SEMI,
    STATE(6855), 1,
      sym__preprocessor_call,
  [264847] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6582), 1,
      anon_sym_EQ_GT,
    STATE(6856), 1,
      sym__preprocessor_call,
  [264860] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9913), 1,
      anon_sym_LBRACE,
    STATE(6857), 1,
      sym__preprocessor_call,
  [264873] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7265), 1,
      anon_sym_RPAREN,
    STATE(6858), 1,
      sym__preprocessor_call,
  [264886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9915), 1,
      anon_sym_LPAREN,
    STATE(6859), 1,
      sym__preprocessor_call,
  [264899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9917), 1,
      anon_sym_LT,
    STATE(6860), 1,
      sym__preprocessor_call,
  [264912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9919), 1,
      anon_sym_LBRACE,
    STATE(6861), 1,
      sym__preprocessor_call,
  [264925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9921), 1,
      anon_sym_EQ_GT,
    STATE(6862), 1,
      sym__preprocessor_call,
  [264938] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5765), 1,
      anon_sym_EQ_GT,
    STATE(6863), 1,
      sym__preprocessor_call,
  [264951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9923), 1,
      anon_sym_QMARK,
    STATE(6864), 1,
      sym__preprocessor_call,
  [264964] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9925), 1,
      anon_sym_EQ_GT,
    STATE(6865), 1,
      sym__preprocessor_call,
  [264977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9927), 1,
      sym__preproc_directive_end,
    STATE(6866), 1,
      sym__preprocessor_call,
  [264990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9929), 1,
      sym__preproc_directive_end,
    STATE(6867), 1,
      sym__preprocessor_call,
  [265003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9931), 1,
      sym_preproc_string_literal,
    STATE(6868), 1,
      sym__preprocessor_call,
  [265016] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9933), 1,
      anon_sym_COMMA,
    STATE(6869), 1,
      sym__preprocessor_call,
  [265029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9935), 1,
      anon_sym_EQ_GT,
    STATE(6870), 1,
      sym__preprocessor_call,
  [265042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9937), 1,
      anon_sym_EQ_GT,
    STATE(6871), 1,
      sym__preprocessor_call,
  [265055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9939), 1,
      anon_sym_SEMI,
    STATE(6872), 1,
      sym__preprocessor_call,
  [265068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6666), 1,
      anon_sym_EQ_GT,
    STATE(6873), 1,
      sym__preprocessor_call,
  [265081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9941), 1,
      anon_sym_SEMI,
    STATE(6874), 1,
      sym__preprocessor_call,
  [265094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9943), 1,
      anon_sym_EQ_GT,
    STATE(6875), 1,
      sym__preprocessor_call,
  [265107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9945), 1,
      anon_sym_LT,
    STATE(6876), 1,
      sym__preprocessor_call,
  [265120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9947), 1,
      anon_sym_SQUOTE,
    STATE(6877), 1,
      sym__preprocessor_call,
  [265133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9949), 1,
      anon_sym_EQ_GT,
    STATE(6878), 1,
      sym__preprocessor_call,
  [265146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6422), 1,
      anon_sym_RBRACE,
    STATE(6879), 1,
      sym__preprocessor_call,
  [265159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9951), 1,
      anon_sym_SQUOTE,
    STATE(6880), 1,
      sym__preprocessor_call,
  [265172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9953), 1,
      anon_sym_EQ_GT,
    STATE(6881), 1,
      sym__preprocessor_call,
  [265185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9955), 1,
      anon_sym_RBRACK,
    STATE(6882), 1,
      sym__preprocessor_call,
  [265198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9957), 1,
      anon_sym_QMARK,
    STATE(6883), 1,
      sym__preprocessor_call,
  [265211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5450), 1,
      anon_sym_EQ_GT,
    STATE(6884), 1,
      sym__preprocessor_call,
  [265224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5885), 1,
      anon_sym_EQ_GT,
    STATE(6885), 1,
      sym__preprocessor_call,
  [265237] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9044), 1,
      anon_sym_RBRACE,
    STATE(6886), 1,
      sym__preprocessor_call,
  [265250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9959), 1,
      anon_sym_in,
    STATE(6887), 1,
      sym__preprocessor_call,
  [265263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9961), 1,
      anon_sym_EQ_GT,
    STATE(6888), 1,
      sym__preprocessor_call,
  [265276] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9963), 1,
      anon_sym_EQ_GT,
    STATE(6889), 1,
      sym__preprocessor_call,
  [265289] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9965), 1,
      anon_sym_EQ_GT,
    STATE(6890), 1,
      sym__preprocessor_call,
  [265302] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9967), 1,
      anon_sym_EQ_GT,
    STATE(6891), 1,
      sym__preprocessor_call,
  [265315] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9969), 1,
      anon_sym_EQ_GT,
    STATE(6892), 1,
      sym__preprocessor_call,
  [265328] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9971), 1,
      anon_sym_EQ_GT,
    STATE(6893), 1,
      sym__preprocessor_call,
  [265341] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9973), 1,
      anon_sym_EQ_GT,
    STATE(6894), 1,
      sym__preprocessor_call,
  [265354] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6418), 1,
      anon_sym_EQ_GT,
    STATE(6895), 1,
      sym__preprocessor_call,
  [265367] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9975), 1,
      anon_sym_EQ_GT,
    STATE(6896), 1,
      sym__preprocessor_call,
  [265380] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9977), 1,
      anon_sym_EQ_GT,
    STATE(6897), 1,
      sym__preprocessor_call,
  [265393] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9019), 1,
      anon_sym_RBRACE,
    STATE(6898), 1,
      sym__preprocessor_call,
  [265406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9979), 1,
      anon_sym_in,
    STATE(6899), 1,
      sym__preprocessor_call,
  [265419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9981), 1,
      anon_sym_RBRACE,
    STATE(6900), 1,
      sym__preprocessor_call,
  [265432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9983), 1,
      anon_sym_RBRACE,
    STATE(6901), 1,
      sym__preprocessor_call,
  [265445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9985), 1,
      anon_sym_LPAREN,
    STATE(6902), 1,
      sym__preprocessor_call,
  [265458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9987), 1,
      anon_sym_LPAREN,
    STATE(6903), 1,
      sym__preprocessor_call,
  [265471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9989), 1,
      anon_sym_while,
    STATE(6904), 1,
      sym__preprocessor_call,
  [265484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9991), 1,
      anon_sym_LBRACE,
    STATE(6905), 1,
      sym__preprocessor_call,
  [265497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9993), 1,
      anon_sym_LPAREN,
    STATE(6906), 1,
      sym__preprocessor_call,
  [265510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9995), 1,
      anon_sym_LPAREN,
    STATE(6907), 1,
      sym__preprocessor_call,
  [265523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9997), 1,
      anon_sym_LPAREN,
    STATE(6908), 1,
      sym__preprocessor_call,
  [265536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9999), 1,
      anon_sym_SEMI,
    STATE(6909), 1,
      sym__preprocessor_call,
  [265549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10001), 1,
      anon_sym_LPAREN,
    STATE(6910), 1,
      sym__preprocessor_call,
  [265562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10003), 1,
      anon_sym_LPAREN,
    STATE(6911), 1,
      sym__preprocessor_call,
  [265575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10005), 1,
      anon_sym_LPAREN,
    STATE(6912), 1,
      sym__preprocessor_call,
  [265588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10007), 1,
      anon_sym_LPAREN,
    STATE(6913), 1,
      sym__preprocessor_call,
  [265601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10009), 1,
      anon_sym_STAR,
    STATE(6914), 1,
      sym__preprocessor_call,
  [265614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10011), 1,
      anon_sym_COLON,
    STATE(6915), 1,
      sym__preprocessor_call,
  [265627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10013), 1,
      anon_sym_RPAREN,
    STATE(6916), 1,
      sym__preprocessor_call,
  [265640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(3160), 1,
      anon_sym_EQ_GT,
    STATE(6917), 1,
      sym__preprocessor_call,
  [265653] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10015), 1,
      anon_sym_SEMI,
    STATE(6918), 1,
      sym__preprocessor_call,
  [265666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10017), 1,
      anon_sym_EQ_GT,
    STATE(6919), 1,
      sym__preprocessor_call,
  [265679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10019), 1,
      anon_sym_LPAREN,
    STATE(6920), 1,
      sym__preprocessor_call,
  [265692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(7395), 1,
      anon_sym_EQ_GT,
    STATE(6921), 1,
      sym__preprocessor_call,
  [265705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10021), 1,
      anon_sym_COLON,
    STATE(6922), 1,
      sym__preprocessor_call,
  [265718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10023), 1,
      anon_sym_EQ_GT,
    STATE(6923), 1,
      sym__preprocessor_call,
  [265731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10025), 1,
      anon_sym_EQ_GT,
    STATE(6924), 1,
      sym__preprocessor_call,
  [265744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10027), 1,
      anon_sym_LPAREN,
    STATE(6925), 1,
      sym__preprocessor_call,
  [265757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(6576), 1,
      anon_sym_SEMI,
    STATE(6926), 1,
      sym__preprocessor_call,
  [265770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5929), 1,
      anon_sym_EQ_GT,
    STATE(6927), 1,
      sym__preprocessor_call,
  [265783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10029), 1,
      anon_sym_SEMI,
    STATE(6928), 1,
      sym__preprocessor_call,
  [265796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10031), 1,
      anon_sym_EQ_GT,
    STATE(6929), 1,
      sym__preprocessor_call,
  [265809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10033), 1,
      anon_sym_SEMI,
    STATE(6930), 1,
      sym__preprocessor_call,
  [265822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10035), 1,
      anon_sym_RPAREN,
    STATE(6931), 1,
      sym__preprocessor_call,
  [265835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10037), 1,
      anon_sym_EQ_GT,
    STATE(6932), 1,
      sym__preprocessor_call,
  [265848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10039), 1,
      anon_sym_SEMI,
    STATE(6933), 1,
      sym__preprocessor_call,
  [265861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9185), 1,
      anon_sym_RBRACE,
    STATE(6934), 1,
      sym__preprocessor_call,
  [265874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10041), 1,
      anon_sym_operator,
    STATE(6935), 1,
      sym__preprocessor_call,
  [265887] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10043), 1,
      anon_sym_SEMI,
    STATE(6936), 1,
      sym__preprocessor_call,
  [265900] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10045), 1,
      anon_sym_in,
    STATE(6937), 1,
      sym__preprocessor_call,
  [265913] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10047), 1,
      anon_sym_LBRACE,
    STATE(6938), 1,
      sym__preprocessor_call,
  [265926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10049), 1,
      anon_sym_in,
    STATE(6939), 1,
      sym__preprocessor_call,
  [265939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10051), 1,
      anon_sym_EQ_GT,
    STATE(6940), 1,
      sym__preprocessor_call,
  [265952] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10053), 1,
      anon_sym_SEMI,
    STATE(6941), 1,
      sym__preprocessor_call,
  [265965] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8967), 1,
      anon_sym_RBRACE,
    STATE(6942), 1,
      sym__preprocessor_call,
  [265978] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10055), 1,
      anon_sym_RBRACK,
    STATE(6943), 1,
      sym__preprocessor_call,
  [265991] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10057), 1,
      anon_sym_RBRACE,
    STATE(6944), 1,
      sym__preprocessor_call,
  [266004] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10059), 1,
      anon_sym_QMARK,
    STATE(6945), 1,
      sym__preprocessor_call,
  [266017] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(5516), 1,
      anon_sym_EQ_GT,
    STATE(6946), 1,
      sym__preprocessor_call,
  [266030] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10061), 1,
      anon_sym_operator,
    STATE(6947), 1,
      sym__preprocessor_call,
  [266043] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10063), 1,
      anon_sym_SEMI,
    STATE(6948), 1,
      sym__preprocessor_call,
  [266056] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10065), 1,
      anon_sym_LBRACE,
    STATE(6949), 1,
      sym__preprocessor_call,
  [266069] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10067), 1,
      anon_sym_LBRACE,
    STATE(6950), 1,
      sym__preprocessor_call,
  [266082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10069), 1,
      anon_sym_EQ_GT,
    STATE(6951), 1,
      sym__preprocessor_call,
  [266095] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(9436), 1,
      anon_sym_RBRACE,
    STATE(6952), 1,
      sym__preprocessor_call,
  [266108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10071), 1,
      anon_sym_LBRACE,
    STATE(6953), 1,
      sym__preprocessor_call,
  [266121] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10073), 1,
      anon_sym_LT,
    STATE(6954), 1,
      sym__preprocessor_call,
  [266134] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(8571), 1,
      anon_sym_STAR,
    STATE(6955), 1,
      sym__preprocessor_call,
  [266147] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10075), 1,
      anon_sym_RBRACK,
    STATE(6956), 1,
      sym__preprocessor_call,
  [266160] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10077), 1,
      anon_sym_STAR,
    STATE(6957), 1,
      sym__preprocessor_call,
  [266173] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10079), 1,
      anon_sym_EQ_GT,
    STATE(6958), 1,
      sym__preprocessor_call,
  [266186] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10081), 1,
      anon_sym_STAR,
    STATE(6959), 1,
      sym__preprocessor_call,
  [266199] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10083), 1,
      anon_sym_LBRACE,
    STATE(6960), 1,
      sym__preprocessor_call,
  [266212] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10085), 1,
      anon_sym_STAR,
    STATE(6961), 1,
      sym__preprocessor_call,
  [266225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10087), 1,
      anon_sym_LPAREN,
    STATE(6962), 1,
      sym__preprocessor_call,
  [266238] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10089), 1,
      anon_sym_SEMI,
    STATE(6963), 1,
      sym__preprocessor_call,
  [266251] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10091), 1,
      anon_sym_LPAREN,
    STATE(6964), 1,
      sym__preprocessor_call,
  [266264] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10093), 1,
      anon_sym_LPAREN,
    STATE(6965), 1,
      sym__preprocessor_call,
  [266277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10095), 1,
      anon_sym_while,
    STATE(6966), 1,
      sym__preprocessor_call,
  [266290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10097), 1,
      anon_sym_LPAREN,
    STATE(6967), 1,
      sym__preprocessor_call,
  [266303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10099), 1,
      anon_sym_LPAREN,
    STATE(6968), 1,
      sym__preprocessor_call,
  [266316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10101), 1,
      anon_sym_SEMI,
    STATE(6969), 1,
      sym__preprocessor_call,
  [266329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10103), 1,
      anon_sym_RPAREN,
    STATE(6970), 1,
      sym__preprocessor_call,
  [266342] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10105), 1,
      anon_sym_SEMI,
    STATE(6971), 1,
      sym__preprocessor_call,
  [266355] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10107), 1,
      anon_sym_RBRACK,
    STATE(6972), 1,
      sym__preprocessor_call,
  [266368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10109), 1,
      anon_sym_LPAREN,
    STATE(6973), 1,
      sym__preprocessor_call,
  [266381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10111), 1,
      anon_sym_LPAREN,
    STATE(6974), 1,
      sym__preprocessor_call,
  [266394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10113), 1,
      anon_sym_LPAREN,
    STATE(6975), 1,
      sym__preprocessor_call,
  [266407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10115), 1,
      anon_sym_RBRACK,
    STATE(6976), 1,
      sym__preprocessor_call,
  [266420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5), 1,
      sym__preproc_directive_start,
    ACTIONS(10117), 1,
      anon_sym_LPAREN,
    STATE(6977), 1,
      sym__preprocessor_call,
  [266433] = 1,
    ACTIONS(10119), 1,
      ts_builtin_sym_end,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(2632)] = 0,
  [SMALL_STATE(2633)] = 75,
  [SMALL_STATE(2634)] = 150,
  [SMALL_STATE(2635)] = 225,
  [SMALL_STATE(2636)] = 314,
  [SMALL_STATE(2637)] = 391,
  [SMALL_STATE(2638)] = 470,
  [SMALL_STATE(2639)] = 549,
  [SMALL_STATE(2640)] = 634,
  [SMALL_STATE(2641)] = 715,
  [SMALL_STATE(2642)] = 792,
  [SMALL_STATE(2643)] = 871,
  [SMALL_STATE(2644)] = 946,
  [SMALL_STATE(2645)] = 1021,
  [SMALL_STATE(2646)] = 1095,
  [SMALL_STATE(2647)] = 1171,
  [SMALL_STATE(2648)] = 1297,
  [SMALL_STATE(2649)] = 1377,
  [SMALL_STATE(2650)] = 1509,
  [SMALL_STATE(2651)] = 1641,
  [SMALL_STATE(2652)] = 1743,
  [SMALL_STATE(2653)] = 1863,
  [SMALL_STATE(2654)] = 1995,
  [SMALL_STATE(2655)] = 2093,
  [SMALL_STATE(2656)] = 2173,
  [SMALL_STATE(2657)] = 2305,
  [SMALL_STATE(2658)] = 2433,
  [SMALL_STATE(2659)] = 2507,
  [SMALL_STATE(2660)] = 2619,
  [SMALL_STATE(2661)] = 2711,
  [SMALL_STATE(2662)] = 2825,
  [SMALL_STATE(2663)] = 2943,
  [SMALL_STATE(2664)] = 3059,
  [SMALL_STATE(2665)] = 3151,
  [SMALL_STATE(2666)] = 3245,
  [SMALL_STATE(2667)] = 3323,
  [SMALL_STATE(2668)] = 3403,
  [SMALL_STATE(2669)] = 3487,
  [SMALL_STATE(2670)] = 3561,
  [SMALL_STATE(2671)] = 3635,
  [SMALL_STATE(2672)] = 3717,
  [SMALL_STATE(2673)] = 3791,
  [SMALL_STATE(2674)] = 3865,
  [SMALL_STATE(2675)] = 3943,
  [SMALL_STATE(2676)] = 4017,
  [SMALL_STATE(2677)] = 4091,
  [SMALL_STATE(2678)] = 4165,
  [SMALL_STATE(2679)] = 4239,
  [SMALL_STATE(2680)] = 4313,
  [SMALL_STATE(2681)] = 4387,
  [SMALL_STATE(2682)] = 4461,
  [SMALL_STATE(2683)] = 4535,
  [SMALL_STATE(2684)] = 4609,
  [SMALL_STATE(2685)] = 4683,
  [SMALL_STATE(2686)] = 4763,
  [SMALL_STATE(2687)] = 4837,
  [SMALL_STATE(2688)] = 4911,
  [SMALL_STATE(2689)] = 4985,
  [SMALL_STATE(2690)] = 5059,
  [SMALL_STATE(2691)] = 5133,
  [SMALL_STATE(2692)] = 5233,
  [SMALL_STATE(2693)] = 5365,
  [SMALL_STATE(2694)] = 5497,
  [SMALL_STATE(2695)] = 5601,
  [SMALL_STATE(2696)] = 5675,
  [SMALL_STATE(2697)] = 5753,
  [SMALL_STATE(2698)] = 5827,
  [SMALL_STATE(2699)] = 5903,
  [SMALL_STATE(2700)] = 6035,
  [SMALL_STATE(2701)] = 6111,
  [SMALL_STATE(2702)] = 6239,
  [SMALL_STATE(2703)] = 6313,
  [SMALL_STATE(2704)] = 6387,
  [SMALL_STATE(2705)] = 6461,
  [SMALL_STATE(2706)] = 6535,
  [SMALL_STATE(2707)] = 6627,
  [SMALL_STATE(2708)] = 6707,
  [SMALL_STATE(2709)] = 6783,
  [SMALL_STATE(2710)] = 6857,
  [SMALL_STATE(2711)] = 6951,
  [SMALL_STATE(2712)] = 7025,
  [SMALL_STATE(2713)] = 7157,
  [SMALL_STATE(2714)] = 7231,
  [SMALL_STATE(2715)] = 7305,
  [SMALL_STATE(2716)] = 7427,
  [SMALL_STATE(2717)] = 7505,
  [SMALL_STATE(2718)] = 7579,
  [SMALL_STATE(2719)] = 7652,
  [SMALL_STATE(2720)] = 7783,
  [SMALL_STATE(2721)] = 7862,
  [SMALL_STATE(2722)] = 7939,
  [SMALL_STATE(2723)] = 8012,
  [SMALL_STATE(2724)] = 8085,
  [SMALL_STATE(2725)] = 8158,
  [SMALL_STATE(2726)] = 8231,
  [SMALL_STATE(2727)] = 8306,
  [SMALL_STATE(2728)] = 8379,
  [SMALL_STATE(2729)] = 8472,
  [SMALL_STATE(2730)] = 8563,
  [SMALL_STATE(2731)] = 8654,
  [SMALL_STATE(2732)] = 8727,
  [SMALL_STATE(2733)] = 8800,
  [SMALL_STATE(2734)] = 8873,
  [SMALL_STATE(2735)] = 8946,
  [SMALL_STATE(2736)] = 9019,
  [SMALL_STATE(2737)] = 9092,
  [SMALL_STATE(2738)] = 9165,
  [SMALL_STATE(2739)] = 9238,
  [SMALL_STATE(2740)] = 9311,
  [SMALL_STATE(2741)] = 9384,
  [SMALL_STATE(2742)] = 9457,
  [SMALL_STATE(2743)] = 9530,
  [SMALL_STATE(2744)] = 9607,
  [SMALL_STATE(2745)] = 9680,
  [SMALL_STATE(2746)] = 9753,
  [SMALL_STATE(2747)] = 9826,
  [SMALL_STATE(2748)] = 9899,
  [SMALL_STATE(2749)] = 9972,
  [SMALL_STATE(2750)] = 10045,
  [SMALL_STATE(2751)] = 10118,
  [SMALL_STATE(2752)] = 10191,
  [SMALL_STATE(2753)] = 10264,
  [SMALL_STATE(2754)] = 10337,
  [SMALL_STATE(2755)] = 10410,
  [SMALL_STATE(2756)] = 10483,
  [SMALL_STATE(2757)] = 10556,
  [SMALL_STATE(2758)] = 10629,
  [SMALL_STATE(2759)] = 10702,
  [SMALL_STATE(2760)] = 10775,
  [SMALL_STATE(2761)] = 10848,
  [SMALL_STATE(2762)] = 10921,
  [SMALL_STATE(2763)] = 10996,
  [SMALL_STATE(2764)] = 11069,
  [SMALL_STATE(2765)] = 11144,
  [SMALL_STATE(2766)] = 11217,
  [SMALL_STATE(2767)] = 11290,
  [SMALL_STATE(2768)] = 11363,
  [SMALL_STATE(2769)] = 11436,
  [SMALL_STATE(2770)] = 11509,
  [SMALL_STATE(2771)] = 11582,
  [SMALL_STATE(2772)] = 11655,
  [SMALL_STATE(2773)] = 11728,
  [SMALL_STATE(2774)] = 11801,
  [SMALL_STATE(2775)] = 11874,
  [SMALL_STATE(2776)] = 11947,
  [SMALL_STATE(2777)] = 12030,
  [SMALL_STATE(2778)] = 12105,
  [SMALL_STATE(2779)] = 12178,
  [SMALL_STATE(2780)] = 12251,
  [SMALL_STATE(2781)] = 12324,
  [SMALL_STATE(2782)] = 12397,
  [SMALL_STATE(2783)] = 12470,
  [SMALL_STATE(2784)] = 12597,
  [SMALL_STATE(2785)] = 12670,
  [SMALL_STATE(2786)] = 12801,
  [SMALL_STATE(2787)] = 12874,
  [SMALL_STATE(2788)] = 12947,
  [SMALL_STATE(2789)] = 13078,
  [SMALL_STATE(2790)] = 13155,
  [SMALL_STATE(2791)] = 13280,
  [SMALL_STATE(2792)] = 13411,
  [SMALL_STATE(2793)] = 13532,
  [SMALL_STATE(2794)] = 13651,
  [SMALL_STATE(2795)] = 13724,
  [SMALL_STATE(2796)] = 13797,
  [SMALL_STATE(2797)] = 13870,
  [SMALL_STATE(2798)] = 13981,
  [SMALL_STATE(2799)] = 14054,
  [SMALL_STATE(2800)] = 14127,
  [SMALL_STATE(2801)] = 14200,
  [SMALL_STATE(2802)] = 14273,
  [SMALL_STATE(2803)] = 14346,
  [SMALL_STATE(2804)] = 14419,
  [SMALL_STATE(2805)] = 14532,
  [SMALL_STATE(2806)] = 14605,
  [SMALL_STATE(2807)] = 14678,
  [SMALL_STATE(2808)] = 14751,
  [SMALL_STATE(2809)] = 14824,
  [SMALL_STATE(2810)] = 14897,
  [SMALL_STATE(2811)] = 14970,
  [SMALL_STATE(2812)] = 15043,
  [SMALL_STATE(2813)] = 15170,
  [SMALL_STATE(2814)] = 15243,
  [SMALL_STATE(2815)] = 15316,
  [SMALL_STATE(2816)] = 15433,
  [SMALL_STATE(2817)] = 15506,
  [SMALL_STATE(2818)] = 15621,
  [SMALL_STATE(2819)] = 15700,
  [SMALL_STATE(2820)] = 15777,
  [SMALL_STATE(2821)] = 15852,
  [SMALL_STATE(2822)] = 15925,
  [SMALL_STATE(2823)] = 15998,
  [SMALL_STATE(2824)] = 16071,
  [SMALL_STATE(2825)] = 16144,
  [SMALL_STATE(2826)] = 16217,
  [SMALL_STATE(2827)] = 16290,
  [SMALL_STATE(2828)] = 16363,
  [SMALL_STATE(2829)] = 16460,
  [SMALL_STATE(2830)] = 16533,
  [SMALL_STATE(2831)] = 16606,
  [SMALL_STATE(2832)] = 16679,
  [SMALL_STATE(2833)] = 16752,
  [SMALL_STATE(2834)] = 16825,
  [SMALL_STATE(2835)] = 16898,
  [SMALL_STATE(2836)] = 16975,
  [SMALL_STATE(2837)] = 17048,
  [SMALL_STATE(2838)] = 17121,
  [SMALL_STATE(2839)] = 17194,
  [SMALL_STATE(2840)] = 17267,
  [SMALL_STATE(2841)] = 17366,
  [SMALL_STATE(2842)] = 17457,
  [SMALL_STATE(2843)] = 17530,
  [SMALL_STATE(2844)] = 17603,
  [SMALL_STATE(2845)] = 17734,
  [SMALL_STATE(2846)] = 17865,
  [SMALL_STATE(2847)] = 17938,
  [SMALL_STATE(2848)] = 18013,
  [SMALL_STATE(2849)] = 18086,
  [SMALL_STATE(2850)] = 18179,
  [SMALL_STATE(2851)] = 18252,
  [SMALL_STATE(2852)] = 18333,
  [SMALL_STATE(2853)] = 18406,
  [SMALL_STATE(2854)] = 18509,
  [SMALL_STATE(2855)] = 18610,
  [SMALL_STATE(2856)] = 18685,
  [SMALL_STATE(2857)] = 18758,
  [SMALL_STATE(2858)] = 18831,
  [SMALL_STATE(2859)] = 18952,
  [SMALL_STATE(2860)] = 19025,
  [SMALL_STATE(2861)] = 19097,
  [SMALL_STATE(2862)] = 19169,
  [SMALL_STATE(2863)] = 19241,
  [SMALL_STATE(2864)] = 19317,
  [SMALL_STATE(2865)] = 19389,
  [SMALL_STATE(2866)] = 19465,
  [SMALL_STATE(2867)] = 19541,
  [SMALL_STATE(2868)] = 19617,
  [SMALL_STATE(2869)] = 19697,
  [SMALL_STATE(2870)] = 19825,
  [SMALL_STATE(2871)] = 19897,
  [SMALL_STATE(2872)] = 19975,
  [SMALL_STATE(2873)] = 20047,
  [SMALL_STATE(2874)] = 20119,
  [SMALL_STATE(2875)] = 20211,
  [SMALL_STATE(2876)] = 20285,
  [SMALL_STATE(2877)] = 20375,
  [SMALL_STATE(2878)] = 20465,
  [SMALL_STATE(2879)] = 20537,
  [SMALL_STATE(2880)] = 20609,
  [SMALL_STATE(2881)] = 20681,
  [SMALL_STATE(2882)] = 20753,
  [SMALL_STATE(2883)] = 20881,
  [SMALL_STATE(2884)] = 21009,
  [SMALL_STATE(2885)] = 21081,
  [SMALL_STATE(2886)] = 21153,
  [SMALL_STATE(2887)] = 21281,
  [SMALL_STATE(2888)] = 21355,
  [SMALL_STATE(2889)] = 21469,
  [SMALL_STATE(2890)] = 21585,
  [SMALL_STATE(2891)] = 21697,
  [SMALL_STATE(2892)] = 21807,
  [SMALL_STATE(2893)] = 21879,
  [SMALL_STATE(2894)] = 21951,
  [SMALL_STATE(2895)] = 22023,
  [SMALL_STATE(2896)] = 22095,
  [SMALL_STATE(2897)] = 22169,
  [SMALL_STATE(2898)] = 22241,
  [SMALL_STATE(2899)] = 22359,
  [SMALL_STATE(2900)] = 22431,
  [SMALL_STATE(2901)] = 22551,
  [SMALL_STATE(2902)] = 22623,
  [SMALL_STATE(2903)] = 22747,
  [SMALL_STATE(2904)] = 22819,
  [SMALL_STATE(2905)] = 22947,
  [SMALL_STATE(2906)] = 23019,
  [SMALL_STATE(2907)] = 23147,
  [SMALL_STATE(2908)] = 23219,
  [SMALL_STATE(2909)] = 23297,
  [SMALL_STATE(2910)] = 23369,
  [SMALL_STATE(2911)] = 23459,
  [SMALL_STATE(2912)] = 23531,
  [SMALL_STATE(2913)] = 23603,
  [SMALL_STATE(2914)] = 23679,
  [SMALL_STATE(2915)] = 23751,
  [SMALL_STATE(2916)] = 23823,
  [SMALL_STATE(2917)] = 23895,
  [SMALL_STATE(2918)] = 23967,
  [SMALL_STATE(2919)] = 24039,
  [SMALL_STATE(2920)] = 24111,
  [SMALL_STATE(2921)] = 24187,
  [SMALL_STATE(2922)] = 24259,
  [SMALL_STATE(2923)] = 24331,
  [SMALL_STATE(2924)] = 24403,
  [SMALL_STATE(2925)] = 24475,
  [SMALL_STATE(2926)] = 24547,
  [SMALL_STATE(2927)] = 24619,
  [SMALL_STATE(2928)] = 24691,
  [SMALL_STATE(2929)] = 24763,
  [SMALL_STATE(2930)] = 24835,
  [SMALL_STATE(2931)] = 24907,
  [SMALL_STATE(2932)] = 24979,
  [SMALL_STATE(2933)] = 25051,
  [SMALL_STATE(2934)] = 25123,
  [SMALL_STATE(2935)] = 25195,
  [SMALL_STATE(2936)] = 25267,
  [SMALL_STATE(2937)] = 25339,
  [SMALL_STATE(2938)] = 25411,
  [SMALL_STATE(2939)] = 25503,
  [SMALL_STATE(2940)] = 25575,
  [SMALL_STATE(2941)] = 25647,
  [SMALL_STATE(2942)] = 25719,
  [SMALL_STATE(2943)] = 25791,
  [SMALL_STATE(2944)] = 25863,
  [SMALL_STATE(2945)] = 25935,
  [SMALL_STATE(2946)] = 26007,
  [SMALL_STATE(2947)] = 26079,
  [SMALL_STATE(2948)] = 26151,
  [SMALL_STATE(2949)] = 26223,
  [SMALL_STATE(2950)] = 26295,
  [SMALL_STATE(2951)] = 26367,
  [SMALL_STATE(2952)] = 26439,
  [SMALL_STATE(2953)] = 26511,
  [SMALL_STATE(2954)] = 26639,
  [SMALL_STATE(2955)] = 26711,
  [SMALL_STATE(2956)] = 26811,
  [SMALL_STATE(2957)] = 26883,
  [SMALL_STATE(2958)] = 26955,
  [SMALL_STATE(2959)] = 27027,
  [SMALL_STATE(2960)] = 27145,
  [SMALL_STATE(2961)] = 27217,
  [SMALL_STATE(2962)] = 27289,
  [SMALL_STATE(2963)] = 27361,
  [SMALL_STATE(2964)] = 27433,
  [SMALL_STATE(2965)] = 27505,
  [SMALL_STATE(2966)] = 27631,
  [SMALL_STATE(2967)] = 27703,
  [SMALL_STATE(2968)] = 27799,
  [SMALL_STATE(2969)] = 27871,
  [SMALL_STATE(2970)] = 27943,
  [SMALL_STATE(2971)] = 28015,
  [SMALL_STATE(2972)] = 28091,
  [SMALL_STATE(2973)] = 28165,
  [SMALL_STATE(2974)] = 28237,
  [SMALL_STATE(2975)] = 28309,
  [SMALL_STATE(2976)] = 28381,
  [SMALL_STATE(2977)] = 28509,
  [SMALL_STATE(2978)] = 28581,
  [SMALL_STATE(2979)] = 28653,
  [SMALL_STATE(2980)] = 28725,
  [SMALL_STATE(2981)] = 28797,
  [SMALL_STATE(2982)] = 28869,
  [SMALL_STATE(2983)] = 28971,
  [SMALL_STATE(2984)] = 29069,
  [SMALL_STATE(2985)] = 29141,
  [SMALL_STATE(2986)] = 29213,
  [SMALL_STATE(2987)] = 29285,
  [SMALL_STATE(2988)] = 29356,
  [SMALL_STATE(2989)] = 29427,
  [SMALL_STATE(2990)] = 29498,
  [SMALL_STATE(2991)] = 29607,
  [SMALL_STATE(2992)] = 29678,
  [SMALL_STATE(2993)] = 29753,
  [SMALL_STATE(2994)] = 29824,
  [SMALL_STATE(2995)] = 29903,
  [SMALL_STATE(2996)] = 30014,
  [SMALL_STATE(2997)] = 30085,
  [SMALL_STATE(2998)] = 30160,
  [SMALL_STATE(2999)] = 30231,
  [SMALL_STATE(3000)] = 30302,
  [SMALL_STATE(3001)] = 30373,
  [SMALL_STATE(3002)] = 30444,
  [SMALL_STATE(3003)] = 30515,
  [SMALL_STATE(3004)] = 30642,
  [SMALL_STATE(3005)] = 30761,
  [SMALL_STATE(3006)] = 30862,
  [SMALL_STATE(3007)] = 30933,
  [SMALL_STATE(3008)] = 31004,
  [SMALL_STATE(3009)] = 31075,
  [SMALL_STATE(3010)] = 31198,
  [SMALL_STATE(3011)] = 31271,
  [SMALL_STATE(3012)] = 31400,
  [SMALL_STATE(3013)] = 31471,
  [SMALL_STATE(3014)] = 31542,
  [SMALL_STATE(3015)] = 31671,
  [SMALL_STATE(3016)] = 31742,
  [SMALL_STATE(3017)] = 31813,
  [SMALL_STATE(3018)] = 31884,
  [SMALL_STATE(3019)] = 31955,
  [SMALL_STATE(3020)] = 32082,
  [SMALL_STATE(3021)] = 32153,
  [SMALL_STATE(3022)] = 32224,
  [SMALL_STATE(3023)] = 32353,
  [SMALL_STATE(3024)] = 32466,
  [SMALL_STATE(3025)] = 32581,
  [SMALL_STATE(3026)] = 32652,
  [SMALL_STATE(3027)] = 32777,
  [SMALL_STATE(3028)] = 32848,
  [SMALL_STATE(3029)] = 32973,
  [SMALL_STATE(3030)] = 33044,
  [SMALL_STATE(3031)] = 33115,
  [SMALL_STATE(3032)] = 33204,
  [SMALL_STATE(3033)] = 33293,
  [SMALL_STATE(3034)] = 33384,
  [SMALL_STATE(3035)] = 33481,
  [SMALL_STATE(3036)] = 33576,
  [SMALL_STATE(3037)] = 33675,
  [SMALL_STATE(3038)] = 33746,
  [SMALL_STATE(3039)] = 33817,
  [SMALL_STATE(3040)] = 33888,
  [SMALL_STATE(3041)] = 33959,
  [SMALL_STATE(3042)] = 34030,
  [SMALL_STATE(3043)] = 34105,
  [SMALL_STATE(3044)] = 34176,
  [SMALL_STATE(3045)] = 34247,
  [SMALL_STATE(3046)] = 34318,
  [SMALL_STATE(3047)] = 34389,
  [SMALL_STATE(3048)] = 34488,
  [SMALL_STATE(3049)] = 34559,
  [SMALL_STATE(3050)] = 34634,
  [SMALL_STATE(3051)] = 34705,
  [SMALL_STATE(3052)] = 34796,
  [SMALL_STATE(3053)] = 34923,
  [SMALL_STATE(3054)] = 35052,
  [SMALL_STATE(3055)] = 35181,
  [SMALL_STATE(3056)] = 35296,
  [SMALL_STATE(3057)] = 35413,
  [SMALL_STATE(3058)] = 35484,
  [SMALL_STATE(3059)] = 35607,
  [SMALL_STATE(3060)] = 35726,
  [SMALL_STATE(3061)] = 35843,
  [SMALL_STATE(3062)] = 35914,
  [SMALL_STATE(3063)] = 36003,
  [SMALL_STATE(3064)] = 36132,
  [SMALL_STATE(3065)] = 36233,
  [SMALL_STATE(3066)] = 36304,
  [SMALL_STATE(3067)] = 36401,
  [SMALL_STATE(3068)] = 36472,
  [SMALL_STATE(3069)] = 36561,
  [SMALL_STATE(3070)] = 36656,
  [SMALL_STATE(3071)] = 36727,
  [SMALL_STATE(3072)] = 36798,
  [SMALL_STATE(3073)] = 36889,
  [SMALL_STATE(3074)] = 36960,
  [SMALL_STATE(3075)] = 37031,
  [SMALL_STATE(3076)] = 37106,
  [SMALL_STATE(3077)] = 37177,
  [SMALL_STATE(3078)] = 37248,
  [SMALL_STATE(3079)] = 37325,
  [SMALL_STATE(3080)] = 37396,
  [SMALL_STATE(3081)] = 37505,
  [SMALL_STATE(3082)] = 37576,
  [SMALL_STATE(3083)] = 37647,
  [SMALL_STATE(3084)] = 37758,
  [SMALL_STATE(3085)] = 37873,
  [SMALL_STATE(3086)] = 37986,
  [SMALL_STATE(3087)] = 38075,
  [SMALL_STATE(3088)] = 38146,
  [SMALL_STATE(3089)] = 38217,
  [SMALL_STATE(3090)] = 38288,
  [SMALL_STATE(3091)] = 38377,
  [SMALL_STATE(3092)] = 38456,
  [SMALL_STATE(3093)] = 38527,
  [SMALL_STATE(3094)] = 38598,
  [SMALL_STATE(3095)] = 38727,
  [SMALL_STATE(3096)] = 38854,
  [SMALL_STATE(3097)] = 38925,
  [SMALL_STATE(3098)] = 38996,
  [SMALL_STATE(3099)] = 39067,
  [SMALL_STATE(3100)] = 39138,
  [SMALL_STATE(3101)] = 39211,
  [SMALL_STATE(3102)] = 39282,
  [SMALL_STATE(3103)] = 39353,
  [SMALL_STATE(3104)] = 39424,
  [SMALL_STATE(3105)] = 39513,
  [SMALL_STATE(3106)] = 39584,
  [SMALL_STATE(3107)] = 39655,
  [SMALL_STATE(3108)] = 39726,
  [SMALL_STATE(3109)] = 39797,
  [SMALL_STATE(3110)] = 39868,
  [SMALL_STATE(3111)] = 39939,
  [SMALL_STATE(3112)] = 40030,
  [SMALL_STATE(3113)] = 40157,
  [SMALL_STATE(3114)] = 40228,
  [SMALL_STATE(3115)] = 40299,
  [SMALL_STATE(3116)] = 40370,
  [SMALL_STATE(3117)] = 40495,
  [SMALL_STATE(3118)] = 40566,
  [SMALL_STATE(3119)] = 40695,
  [SMALL_STATE(3120)] = 40822,
  [SMALL_STATE(3121)] = 40899,
  [SMALL_STATE(3122)] = 41028,
  [SMALL_STATE(3123)] = 41103,
  [SMALL_STATE(3124)] = 41174,
  [SMALL_STATE(3125)] = 41245,
  [SMALL_STATE(3126)] = 41361,
  [SMALL_STATE(3127)] = 41433,
  [SMALL_STATE(3128)] = 41527,
  [SMALL_STATE(3129)] = 41655,
  [SMALL_STATE(3130)] = 41745,
  [SMALL_STATE(3131)] = 41823,
  [SMALL_STATE(3132)] = 41911,
  [SMALL_STATE(3133)] = 42007,
  [SMALL_STATE(3134)] = 42103,
  [SMALL_STATE(3135)] = 42231,
  [SMALL_STATE(3136)] = 42319,
  [SMALL_STATE(3137)] = 42393,
  [SMALL_STATE(3138)] = 42491,
  [SMALL_STATE(3139)] = 42621,
  [SMALL_STATE(3140)] = 42721,
  [SMALL_STATE(3141)] = 42809,
  [SMALL_STATE(3142)] = 42881,
  [SMALL_STATE(3143)] = 43005,
  [SMALL_STATE(3144)] = 43117,
  [SMALL_STATE(3145)] = 43245,
  [SMALL_STATE(3146)] = 43373,
  [SMALL_STATE(3147)] = 43463,
  [SMALL_STATE(3148)] = 43591,
  [SMALL_STATE(3149)] = 43665,
  [SMALL_STATE(3150)] = 43787,
  [SMALL_STATE(3151)] = 43911,
  [SMALL_STATE(3152)] = 44039,
  [SMALL_STATE(3153)] = 44129,
  [SMALL_STATE(3154)] = 44257,
  [SMALL_STATE(3155)] = 44385,
  [SMALL_STATE(3156)] = 44503,
  [SMALL_STATE(3157)] = 44625,
  [SMALL_STATE(3158)] = 44743,
  [SMALL_STATE(3159)] = 44867,
  [SMALL_STATE(3160)] = 44975,
  [SMALL_STATE(3161)] = 45091,
  [SMALL_STATE(3162)] = 45165,
  [SMALL_STATE(3163)] = 45263,
  [SMALL_STATE(3164)] = 45373,
  [SMALL_STATE(3165)] = 45487,
  [SMALL_STATE(3166)] = 45615,
  [SMALL_STATE(3167)] = 45745,
  [SMALL_STATE(3168)] = 45833,
  [SMALL_STATE(3169)] = 45941,
  [SMALL_STATE(3170)] = 46051,
  [SMALL_STATE(3171)] = 46179,
  [SMALL_STATE(3172)] = 46293,
  [SMALL_STATE(3173)] = 46421,
  [SMALL_STATE(3174)] = 46533,
  [SMALL_STATE(3175)] = 46657,
  [SMALL_STATE(3176)] = 46785,
  [SMALL_STATE(3177)] = 46883,
  [SMALL_STATE(3178)] = 47011,
  [SMALL_STATE(3179)] = 47123,
  [SMALL_STATE(3180)] = 47197,
  [SMALL_STATE(3181)] = 47275,
  [SMALL_STATE(3182)] = 47363,
  [SMALL_STATE(3183)] = 47463,
  [SMALL_STATE(3184)] = 47559,
  [SMALL_STATE(3185)] = 47653,
  [SMALL_STATE(3186)] = 47751,
  [SMALL_STATE(3187)] = 47841,
  [SMALL_STATE(3188)] = 47913,
  [SMALL_STATE(3189)] = 48041,
  [SMALL_STATE(3190)] = 48129,
  [SMALL_STATE(3191)] = 48254,
  [SMALL_STATE(3192)] = 48341,
  [SMALL_STATE(3193)] = 48464,
  [SMALL_STATE(3194)] = 48589,
  [SMALL_STATE(3195)] = 48662,
  [SMALL_STATE(3196)] = 48735,
  [SMALL_STATE(3197)] = 48860,
  [SMALL_STATE(3198)] = 48933,
  [SMALL_STATE(3199)] = 49020,
  [SMALL_STATE(3200)] = 49107,
  [SMALL_STATE(3201)] = 49196,
  [SMALL_STATE(3202)] = 49267,
  [SMALL_STATE(3203)] = 49340,
  [SMALL_STATE(3204)] = 49465,
  [SMALL_STATE(3205)] = 49580,
  [SMALL_STATE(3206)] = 49705,
  [SMALL_STATE(3207)] = 49826,
  [SMALL_STATE(3208)] = 49943,
  [SMALL_STATE(3209)] = 50020,
  [SMALL_STATE(3210)] = 50093,
  [SMALL_STATE(3211)] = 50218,
  [SMALL_STATE(3212)] = 50287,
  [SMALL_STATE(3213)] = 50402,
  [SMALL_STATE(3214)] = 50509,
  [SMALL_STATE(3215)] = 50618,
  [SMALL_STATE(3216)] = 50731,
  [SMALL_STATE(3217)] = 50842,
  [SMALL_STATE(3218)] = 50915,
  [SMALL_STATE(3219)] = 51040,
  [SMALL_STATE(3220)] = 51165,
  [SMALL_STATE(3221)] = 51254,
  [SMALL_STATE(3222)] = 51353,
  [SMALL_STATE(3223)] = 51448,
  [SMALL_STATE(3224)] = 51541,
  [SMALL_STATE(3225)] = 51638,
  [SMALL_STATE(3226)] = 51758,
  [SMALL_STATE(3227)] = 51866,
  [SMALL_STATE(3228)] = 51990,
  [SMALL_STATE(3229)] = 52114,
  [SMALL_STATE(3230)] = 52182,
  [SMALL_STATE(3231)] = 52254,
  [SMALL_STATE(3232)] = 52322,
  [SMALL_STATE(3233)] = 52448,
  [SMALL_STATE(3234)] = 52560,
  [SMALL_STATE(3235)] = 52648,
  [SMALL_STATE(3236)] = 52720,
  [SMALL_STATE(3237)] = 52818,
  [SMALL_STATE(3238)] = 52912,
  [SMALL_STATE(3239)] = 53004,
  [SMALL_STATE(3240)] = 53076,
  [SMALL_STATE(3241)] = 53172,
  [SMALL_STATE(3242)] = 53248,
  [SMALL_STATE(3243)] = 53372,
  [SMALL_STATE(3244)] = 53494,
  [SMALL_STATE(3245)] = 53570,
  [SMALL_STATE(3246)] = 53694,
  [SMALL_STATE(3247)] = 53816,
  [SMALL_STATE(3248)] = 53884,
  [SMALL_STATE(3249)] = 54006,
  [SMALL_STATE(3250)] = 54130,
  [SMALL_STATE(3251)] = 54240,
  [SMALL_STATE(3252)] = 54326,
  [SMALL_STATE(3253)] = 54434,
  [SMALL_STATE(3254)] = 54560,
  [SMALL_STATE(3255)] = 54684,
  [SMALL_STATE(3256)] = 54756,
  [SMALL_STATE(3257)] = 54872,
  [SMALL_STATE(3258)] = 54960,
  [SMALL_STATE(3259)] = 55082,
  [SMALL_STATE(3260)] = 55206,
  [SMALL_STATE(3261)] = 55292,
  [SMALL_STATE(3262)] = 55416,
  [SMALL_STATE(3263)] = 55488,
  [SMALL_STATE(3264)] = 55608,
  [SMALL_STATE(3265)] = 55724,
  [SMALL_STATE(3266)] = 55810,
  [SMALL_STATE(3267)] = 55934,
  [SMALL_STATE(3268)] = 56050,
  [SMALL_STATE(3269)] = 56136,
  [SMALL_STATE(3270)] = 56262,
  [SMALL_STATE(3271)] = 56376,
  [SMALL_STATE(3272)] = 56502,
  [SMALL_STATE(3273)] = 56590,
  [SMALL_STATE(3274)] = 56706,
  [SMALL_STATE(3275)] = 56820,
  [SMALL_STATE(3276)] = 56908,
  [SMALL_STATE(3277)] = 56978,
  [SMALL_STATE(3278)] = 57084,
  [SMALL_STATE(3279)] = 57192,
  [SMALL_STATE(3280)] = 57316,
  [SMALL_STATE(3281)] = 57428,
  [SMALL_STATE(3282)] = 57496,
  [SMALL_STATE(3283)] = 57606,
  [SMALL_STATE(3284)] = 57730,
  [SMALL_STATE(3285)] = 57828,
  [SMALL_STATE(3286)] = 57922,
  [SMALL_STATE(3287)] = 57994,
  [SMALL_STATE(3288)] = 58080,
  [SMALL_STATE(3289)] = 58166,
  [SMALL_STATE(3290)] = 58290,
  [SMALL_STATE(3291)] = 58414,
  [SMALL_STATE(3292)] = 58538,
  [SMALL_STATE(3293)] = 58662,
  [SMALL_STATE(3294)] = 58768,
  [SMALL_STATE(3295)] = 58878,
  [SMALL_STATE(3296)] = 58974,
  [SMALL_STATE(3297)] = 59082,
  [SMALL_STATE(3298)] = 59194,
  [SMALL_STATE(3299)] = 59286,
  [SMALL_STATE(3300)] = 59396,
  [SMALL_STATE(3301)] = 59492,
  [SMALL_STATE(3302)] = 59616,
  [SMALL_STATE(3303)] = 59704,
  [SMALL_STATE(3304)] = 59772,
  [SMALL_STATE(3305)] = 59864,
  [SMALL_STATE(3306)] = 59976,
  [SMALL_STATE(3307)] = 60070,
  [SMALL_STATE(3308)] = 60168,
  [SMALL_STATE(3309)] = 60236,
  [SMALL_STATE(3310)] = 60304,
  [SMALL_STATE(3311)] = 60410,
  [SMALL_STATE(3312)] = 60478,
  [SMALL_STATE(3313)] = 60604,
  [SMALL_STATE(3314)] = 60690,
  [SMALL_STATE(3315)] = 60778,
  [SMALL_STATE(3316)] = 60866,
  [SMALL_STATE(3317)] = 60988,
  [SMALL_STATE(3318)] = 61064,
  [SMALL_STATE(3319)] = 61190,
  [SMALL_STATE(3320)] = 61286,
  [SMALL_STATE(3321)] = 61378,
  [SMALL_STATE(3322)] = 61472,
  [SMALL_STATE(3323)] = 61570,
  [SMALL_STATE(3324)] = 61678,
  [SMALL_STATE(3325)] = 61784,
  [SMALL_STATE(3326)] = 61908,
  [SMALL_STATE(3327)] = 61994,
  [SMALL_STATE(3328)] = 62082,
  [SMALL_STATE(3329)] = 62168,
  [SMALL_STATE(3330)] = 62244,
  [SMALL_STATE(3331)] = 62364,
  [SMALL_STATE(3332)] = 62478,
  [SMALL_STATE(3333)] = 62546,
  [SMALL_STATE(3334)] = 62614,
  [SMALL_STATE(3335)] = 62700,
  [SMALL_STATE(3336)] = 62824,
  [SMALL_STATE(3337)] = 62892,
  [SMALL_STATE(3338)] = 63014,
  [SMALL_STATE(3339)] = 63082,
  [SMALL_STATE(3340)] = 63150,
  [SMALL_STATE(3341)] = 63222,
  [SMALL_STATE(3342)] = 63346,
  [SMALL_STATE(3343)] = 63472,
  [SMALL_STATE(3344)] = 63598,
  [SMALL_STATE(3345)] = 63722,
  [SMALL_STATE(3346)] = 63808,
  [SMALL_STATE(3347)] = 63928,
  [SMALL_STATE(3348)] = 64052,
  [SMALL_STATE(3349)] = 64176,
  [SMALL_STATE(3350)] = 64300,
  [SMALL_STATE(3351)] = 64414,
  [SMALL_STATE(3352)] = 64500,
  [SMALL_STATE(3353)] = 64624,
  [SMALL_STATE(3354)] = 64745,
  [SMALL_STATE(3355)] = 64850,
  [SMALL_STATE(3356)] = 64921,
  [SMALL_STATE(3357)] = 65044,
  [SMALL_STATE(3358)] = 65115,
  [SMALL_STATE(3359)] = 65234,
  [SMALL_STATE(3360)] = 65305,
  [SMALL_STATE(3361)] = 65390,
  [SMALL_STATE(3362)] = 65511,
  [SMALL_STATE(3363)] = 65624,
  [SMALL_STATE(3364)] = 65695,
  [SMALL_STATE(3365)] = 65782,
  [SMALL_STATE(3366)] = 65879,
  [SMALL_STATE(3367)] = 65948,
  [SMALL_STATE(3368)] = 66071,
  [SMALL_STATE(3369)] = 66142,
  [SMALL_STATE(3370)] = 66249,
  [SMALL_STATE(3371)] = 66320,
  [SMALL_STATE(3372)] = 66407,
  [SMALL_STATE(3373)] = 66530,
  [SMALL_STATE(3374)] = 66615,
  [SMALL_STATE(3375)] = 66700,
  [SMALL_STATE(3376)] = 66815,
  [SMALL_STATE(3377)] = 66888,
  [SMALL_STATE(3378)] = 67011,
  [SMALL_STATE(3379)] = 67086,
  [SMALL_STATE(3380)] = 67179,
  [SMALL_STATE(3381)] = 67250,
  [SMALL_STATE(3382)] = 67339,
  [SMALL_STATE(3383)] = 67450,
  [SMALL_STATE(3384)] = 67559,
  [SMALL_STATE(3385)] = 67682,
  [SMALL_STATE(3386)] = 67805,
  [SMALL_STATE(3387)] = 67876,
  [SMALL_STATE(3388)] = 67949,
  [SMALL_STATE(3389)] = 68018,
  [SMALL_STATE(3390)] = 68089,
  [SMALL_STATE(3391)] = 68184,
  [SMALL_STATE(3392)] = 68275,
  [SMALL_STATE(3393)] = 68346,
  [SMALL_STATE(3394)] = 68466,
  [SMALL_STATE(3395)] = 68550,
  [SMALL_STATE(3396)] = 68634,
  [SMALL_STATE(3397)] = 68720,
  [SMALL_STATE(3398)] = 68834,
  [SMALL_STATE(3399)] = 68954,
  [SMALL_STATE(3400)] = 69040,
  [SMALL_STATE(3401)] = 69124,
  [SMALL_STATE(3402)] = 69246,
  [SMALL_STATE(3403)] = 69332,
  [SMALL_STATE(3404)] = 69440,
  [SMALL_STATE(3405)] = 69536,
  [SMALL_STATE(3406)] = 69628,
  [SMALL_STATE(3407)] = 69718,
  [SMALL_STATE(3408)] = 69826,
  [SMALL_STATE(3409)] = 69910,
  [SMALL_STATE(3410)] = 70002,
  [SMALL_STATE(3411)] = 70122,
  [SMALL_STATE(3412)] = 70218,
  [SMALL_STATE(3413)] = 70340,
  [SMALL_STATE(3414)] = 70462,
  [SMALL_STATE(3415)] = 70546,
  [SMALL_STATE(3416)] = 70614,
  [SMALL_STATE(3417)] = 70736,
  [SMALL_STATE(3418)] = 70806,
  [SMALL_STATE(3419)] = 70910,
  [SMALL_STATE(3420)] = 71030,
  [SMALL_STATE(3421)] = 71152,
  [SMALL_STATE(3422)] = 71274,
  [SMALL_STATE(3423)] = 71396,
  [SMALL_STATE(3424)] = 71482,
  [SMALL_STATE(3425)] = 71600,
  [SMALL_STATE(3426)] = 71722,
  [SMALL_STATE(3427)] = 71792,
  [SMALL_STATE(3428)] = 71878,
  [SMALL_STATE(3429)] = 71962,
  [SMALL_STATE(3430)] = 72084,
  [SMALL_STATE(3431)] = 72194,
  [SMALL_STATE(3432)] = 72312,
  [SMALL_STATE(3433)] = 72426,
  [SMALL_STATE(3434)] = 72540,
  [SMALL_STATE(3435)] = 72652,
  [SMALL_STATE(3436)] = 72764,
  [SMALL_STATE(3437)] = 72868,
  [SMALL_STATE(3438)] = 72974,
  [SMALL_STATE(3439)] = 73068,
  [SMALL_STATE(3440)] = 73152,
  [SMALL_STATE(3441)] = 73262,
  [SMALL_STATE(3442)] = 73370,
  [SMALL_STATE(3443)] = 73464,
  [SMALL_STATE(3444)] = 73586,
  [SMALL_STATE(3445)] = 73708,
  [SMALL_STATE(3446)] = 73778,
  [SMALL_STATE(3447)] = 73864,
  [SMALL_STATE(3448)] = 73954,
  [SMALL_STATE(3449)] = 74076,
  [SMALL_STATE(3450)] = 74182,
  [SMALL_STATE(3451)] = 74304,
  [SMALL_STATE(3452)] = 74426,
  [SMALL_STATE(3453)] = 74548,
  [SMALL_STATE(3454)] = 74656,
  [SMALL_STATE(3455)] = 74726,
  [SMALL_STATE(3456)] = 74800,
  [SMALL_STATE(3457)] = 74922,
  [SMALL_STATE(3458)] = 75008,
  [SMALL_STATE(3459)] = 75130,
  [SMALL_STATE(3460)] = 75248,
  [SMALL_STATE(3461)] = 75370,
  [SMALL_STATE(3462)] = 75444,
  [SMALL_STATE(3463)] = 75540,
  [SMALL_STATE(3464)] = 75632,
  [SMALL_STATE(3465)] = 75718,
  [SMALL_STATE(3466)] = 75802,
  [SMALL_STATE(3467)] = 75872,
  [SMALL_STATE(3468)] = 76002,
  [SMALL_STATE(3469)] = 76112,
  [SMALL_STATE(3470)] = 76202,
  [SMALL_STATE(3471)] = 76324,
  [SMALL_STATE(3472)] = 76430,
  [SMALL_STATE(3473)] = 76552,
  [SMALL_STATE(3474)] = 76622,
  [SMALL_STATE(3475)] = 76712,
  [SMALL_STATE(3476)] = 76834,
  [SMALL_STATE(3477)] = 76956,
  [SMALL_STATE(3478)] = 77050,
  [SMALL_STATE(3479)] = 77144,
  [SMALL_STATE(3480)] = 77236,
  [SMALL_STATE(3481)] = 77358,
  [SMALL_STATE(3482)] = 77442,
  [SMALL_STATE(3483)] = 77564,
  [SMALL_STATE(3484)] = 77686,
  [SMALL_STATE(3485)] = 77794,
  [SMALL_STATE(3486)] = 77864,
  [SMALL_STATE(3487)] = 77960,
  [SMALL_STATE(3488)] = 78030,
  [SMALL_STATE(3489)] = 78152,
  [SMALL_STATE(3490)] = 78272,
  [SMALL_STATE(3491)] = 78344,
  [SMALL_STATE(3492)] = 78474,
  [SMALL_STATE(3493)] = 78596,
  [SMALL_STATE(3494)] = 78680,
  [SMALL_STATE(3495)] = 78750,
  [SMALL_STATE(3496)] = 78820,
  [SMALL_STATE(3497)] = 78886,
  [SMALL_STATE(3498)] = 79008,
  [SMALL_STATE(3499)] = 79092,
  [SMALL_STATE(3500)] = 79214,
  [SMALL_STATE(3501)] = 79336,
  [SMALL_STATE(3502)] = 79444,
  [SMALL_STATE(3503)] = 79548,
  [SMALL_STATE(3504)] = 79622,
  [SMALL_STATE(3505)] = 79732,
  [SMALL_STATE(3506)] = 79838,
  [SMALL_STATE(3507)] = 79942,
  [SMALL_STATE(3508)] = 80054,
  [SMALL_STATE(3509)] = 80174,
  [SMALL_STATE(3510)] = 80288,
  [SMALL_STATE(3511)] = 80406,
  [SMALL_STATE(3512)] = 80490,
  [SMALL_STATE(3513)] = 80602,
  [SMALL_STATE(3514)] = 80672,
  [SMALL_STATE(3515)] = 80794,
  [SMALL_STATE(3516)] = 80905,
  [SMALL_STATE(3517)] = 81010,
  [SMALL_STATE(3518)] = 81131,
  [SMALL_STATE(3519)] = 81240,
  [SMALL_STATE(3520)] = 81351,
  [SMALL_STATE(3521)] = 81464,
  [SMALL_STATE(3522)] = 81581,
  [SMALL_STATE(3523)] = 81664,
  [SMALL_STATE(3524)] = 81769,
  [SMALL_STATE(3525)] = 81838,
  [SMALL_STATE(3526)] = 81907,
  [SMALL_STATE(3527)] = 81998,
  [SMALL_STATE(3528)] = 82101,
  [SMALL_STATE(3529)] = 82208,
  [SMALL_STATE(3530)] = 82311,
  [SMALL_STATE(3531)] = 82394,
  [SMALL_STATE(3532)] = 82515,
  [SMALL_STATE(3533)] = 82604,
  [SMALL_STATE(3534)] = 82711,
  [SMALL_STATE(3535)] = 82820,
  [SMALL_STATE(3536)] = 82905,
  [SMALL_STATE(3537)] = 82978,
  [SMALL_STATE(3538)] = 83043,
  [SMALL_STATE(3539)] = 83146,
  [SMALL_STATE(3540)] = 83255,
  [SMALL_STATE(3541)] = 83338,
  [SMALL_STATE(3542)] = 83441,
  [SMALL_STATE(3543)] = 83536,
  [SMALL_STATE(3544)] = 83621,
  [SMALL_STATE(3545)] = 83704,
  [SMALL_STATE(3546)] = 83795,
  [SMALL_STATE(3547)] = 83888,
  [SMALL_STATE(3548)] = 84009,
  [SMALL_STATE(3549)] = 84130,
  [SMALL_STATE(3550)] = 84197,
  [SMALL_STATE(3551)] = 84318,
  [SMALL_STATE(3552)] = 84439,
  [SMALL_STATE(3553)] = 84566,
  [SMALL_STATE(3554)] = 84669,
  [SMALL_STATE(3555)] = 84782,
  [SMALL_STATE(3556)] = 84867,
  [SMALL_STATE(3557)] = 84984,
  [SMALL_STATE(3558)] = 85087,
  [SMALL_STATE(3559)] = 85208,
  [SMALL_STATE(3560)] = 85329,
  [SMALL_STATE(3561)] = 85436,
  [SMALL_STATE(3562)] = 85505,
  [SMALL_STATE(3563)] = 85614,
  [SMALL_STATE(3564)] = 85719,
  [SMALL_STATE(3565)] = 85822,
  [SMALL_STATE(3566)] = 85933,
  [SMALL_STATE(3567)] = 86046,
  [SMALL_STATE(3568)] = 86163,
  [SMALL_STATE(3569)] = 86284,
  [SMALL_STATE(3570)] = 86405,
  [SMALL_STATE(3571)] = 86526,
  [SMALL_STATE(3572)] = 86647,
  [SMALL_STATE(3573)] = 86768,
  [SMALL_STATE(3574)] = 86889,
  [SMALL_STATE(3575)] = 87008,
  [SMALL_STATE(3576)] = 87093,
  [SMALL_STATE(3577)] = 87176,
  [SMALL_STATE(3578)] = 87303,
  [SMALL_STATE(3579)] = 87422,
  [SMALL_STATE(3580)] = 87543,
  [SMALL_STATE(3581)] = 87664,
  [SMALL_STATE(3582)] = 87785,
  [SMALL_STATE(3583)] = 87902,
  [SMALL_STATE(3584)] = 87971,
  [SMALL_STATE(3585)] = 88084,
  [SMALL_STATE(3586)] = 88195,
  [SMALL_STATE(3587)] = 88298,
  [SMALL_STATE(3588)] = 88403,
  [SMALL_STATE(3589)] = 88512,
  [SMALL_STATE(3590)] = 88619,
  [SMALL_STATE(3591)] = 88740,
  [SMALL_STATE(3592)] = 88861,
  [SMALL_STATE(3593)] = 88954,
  [SMALL_STATE(3594)] = 89039,
  [SMALL_STATE(3595)] = 89160,
  [SMALL_STATE(3596)] = 89253,
  [SMALL_STATE(3597)] = 89372,
  [SMALL_STATE(3598)] = 89467,
  [SMALL_STATE(3599)] = 89588,
  [SMALL_STATE(3600)] = 89709,
  [SMALL_STATE(3601)] = 89830,
  [SMALL_STATE(3602)] = 89951,
  [SMALL_STATE(3603)] = 90072,
  [SMALL_STATE(3604)] = 90157,
  [SMALL_STATE(3605)] = 90262,
  [SMALL_STATE(3606)] = 90345,
  [SMALL_STATE(3607)] = 90466,
  [SMALL_STATE(3608)] = 90579,
  [SMALL_STATE(3609)] = 90672,
  [SMALL_STATE(3610)] = 90791,
  [SMALL_STATE(3611)] = 90856,
  [SMALL_STATE(3612)] = 90947,
  [SMALL_STATE(3613)] = 91012,
  [SMALL_STATE(3614)] = 91101,
  [SMALL_STATE(3615)] = 91192,
  [SMALL_STATE(3616)] = 91275,
  [SMALL_STATE(3617)] = 91370,
  [SMALL_STATE(3618)] = 91465,
  [SMALL_STATE(3619)] = 91586,
  [SMALL_STATE(3620)] = 91651,
  [SMALL_STATE(3621)] = 91722,
  [SMALL_STATE(3622)] = 91843,
  [SMALL_STATE(3623)] = 91946,
  [SMALL_STATE(3624)] = 92067,
  [SMALL_STATE(3625)] = 92134,
  [SMALL_STATE(3626)] = 92261,
  [SMALL_STATE(3627)] = 92364,
  [SMALL_STATE(3628)] = 92447,
  [SMALL_STATE(3629)] = 92530,
  [SMALL_STATE(3630)] = 92615,
  [SMALL_STATE(3631)] = 92698,
  [SMALL_STATE(3632)] = 92801,
  [SMALL_STATE(3633)] = 92886,
  [SMALL_STATE(3634)] = 93007,
  [SMALL_STATE(3635)] = 93128,
  [SMALL_STATE(3636)] = 93249,
  [SMALL_STATE(3637)] = 93370,
  [SMALL_STATE(3638)] = 93453,
  [SMALL_STATE(3639)] = 93538,
  [SMALL_STATE(3640)] = 93657,
  [SMALL_STATE(3641)] = 93746,
  [SMALL_STATE(3642)] = 93873,
  [SMALL_STATE(3643)] = 93946,
  [SMALL_STATE(3644)] = 94067,
  [SMALL_STATE(3645)] = 94186,
  [SMALL_STATE(3646)] = 94289,
  [SMALL_STATE(3647)] = 94392,
  [SMALL_STATE(3648)] = 94477,
  [SMALL_STATE(3649)] = 94560,
  [SMALL_STATE(3650)] = 94681,
  [SMALL_STATE(3651)] = 94764,
  [SMALL_STATE(3652)] = 94885,
  [SMALL_STATE(3653)] = 94968,
  [SMALL_STATE(3654)] = 95051,
  [SMALL_STATE(3655)] = 95146,
  [SMALL_STATE(3656)] = 95267,
  [SMALL_STATE(3657)] = 95370,
  [SMALL_STATE(3658)] = 95465,
  [SMALL_STATE(3659)] = 95550,
  [SMALL_STATE(3660)] = 95633,
  [SMALL_STATE(3661)] = 95716,
  [SMALL_STATE(3662)] = 95799,
  [SMALL_STATE(3663)] = 95890,
  [SMALL_STATE(3664)] = 95973,
  [SMALL_STATE(3665)] = 96094,
  [SMALL_STATE(3666)] = 96163,
  [SMALL_STATE(3667)] = 96284,
  [SMALL_STATE(3668)] = 96357,
  [SMALL_STATE(3669)] = 96476,
  [SMALL_STATE(3670)] = 96597,
  [SMALL_STATE(3671)] = 96686,
  [SMALL_STATE(3672)] = 96805,
  [SMALL_STATE(3673)] = 96926,
  [SMALL_STATE(3674)] = 97047,
  [SMALL_STATE(3675)] = 97168,
  [SMALL_STATE(3676)] = 97285,
  [SMALL_STATE(3677)] = 97398,
  [SMALL_STATE(3678)] = 97509,
  [SMALL_STATE(3679)] = 97630,
  [SMALL_STATE(3680)] = 97757,
  [SMALL_STATE(3681)] = 97878,
  [SMALL_STATE(3682)] = 97947,
  [SMALL_STATE(3683)] = 98074,
  [SMALL_STATE(3684)] = 98177,
  [SMALL_STATE(3685)] = 98282,
  [SMALL_STATE(3686)] = 98391,
  [SMALL_STATE(3687)] = 98498,
  [SMALL_STATE(3688)] = 98619,
  [SMALL_STATE(3689)] = 98740,
  [SMALL_STATE(3690)] = 98823,
  [SMALL_STATE(3691)] = 98942,
  [SMALL_STATE(3692)] = 99033,
  [SMALL_STATE(3693)] = 99154,
  [SMALL_STATE(3694)] = 99273,
  [SMALL_STATE(3695)] = 99362,
  [SMALL_STATE(3696)] = 99469,
  [SMALL_STATE(3697)] = 99578,
  [SMALL_STATE(3698)] = 99651,
  [SMALL_STATE(3699)] = 99756,
  [SMALL_STATE(3700)] = 99849,
  [SMALL_STATE(3701)] = 99952,
  [SMALL_STATE(3702)] = 100071,
  [SMALL_STATE(3703)] = 100160,
  [SMALL_STATE(3704)] = 100233,
  [SMALL_STATE(3705)] = 100344,
  [SMALL_STATE(3706)] = 100429,
  [SMALL_STATE(3707)] = 100550,
  [SMALL_STATE(3708)] = 100653,
  [SMALL_STATE(3709)] = 100724,
  [SMALL_STATE(3710)] = 100841,
  [SMALL_STATE(3711)] = 100952,
  [SMALL_STATE(3712)] = 101045,
  [SMALL_STATE(3713)] = 101158,
  [SMALL_STATE(3714)] = 101243,
  [SMALL_STATE(3715)] = 101338,
  [SMALL_STATE(3716)] = 101429,
  [SMALL_STATE(3717)] = 101512,
  [SMALL_STATE(3718)] = 101601,
  [SMALL_STATE(3719)] = 101694,
  [SMALL_STATE(3720)] = 101799,
  [SMALL_STATE(3721)] = 101902,
  [SMALL_STATE(3722)] = 102019,
  [SMALL_STATE(3723)] = 102140,
  [SMALL_STATE(3724)] = 102261,
  [SMALL_STATE(3725)] = 102326,
  [SMALL_STATE(3726)] = 102445,
  [SMALL_STATE(3727)] = 102530,
  [SMALL_STATE(3728)] = 102651,
  [SMALL_STATE(3729)] = 102772,
  [SMALL_STATE(3730)] = 102875,
  [SMALL_STATE(3731)] = 102996,
  [SMALL_STATE(3732)] = 103115,
  [SMALL_STATE(3733)] = 103222,
  [SMALL_STATE(3734)] = 103325,
  [SMALL_STATE(3735)] = 103445,
  [SMALL_STATE(3736)] = 103525,
  [SMALL_STATE(3737)] = 103647,
  [SMALL_STATE(3738)] = 103771,
  [SMALL_STATE(3739)] = 103895,
  [SMALL_STATE(3740)] = 103963,
  [SMALL_STATE(3741)] = 104081,
  [SMALL_STATE(3742)] = 104205,
  [SMALL_STATE(3743)] = 104325,
  [SMALL_STATE(3744)] = 104409,
  [SMALL_STATE(3745)] = 104491,
  [SMALL_STATE(3746)] = 104561,
  [SMALL_STATE(3747)] = 104631,
  [SMALL_STATE(3748)] = 104713,
  [SMALL_STATE(3749)] = 104807,
  [SMALL_STATE(3750)] = 104897,
  [SMALL_STATE(3751)] = 105017,
  [SMALL_STATE(3752)] = 105099,
  [SMALL_STATE(3753)] = 105171,
  [SMALL_STATE(3754)] = 105253,
  [SMALL_STATE(3755)] = 105337,
  [SMALL_STATE(3756)] = 105459,
  [SMALL_STATE(3757)] = 105547,
  [SMALL_STATE(3758)] = 105665,
  [SMALL_STATE(3759)] = 105785,
  [SMALL_STATE(3760)] = 105877,
  [SMALL_STATE(3761)] = 105961,
  [SMALL_STATE(3762)] = 106081,
  [SMALL_STATE(3763)] = 106175,
  [SMALL_STATE(3764)] = 106265,
  [SMALL_STATE(3765)] = 106385,
  [SMALL_STATE(3766)] = 106473,
  [SMALL_STATE(3767)] = 106565,
  [SMALL_STATE(3768)] = 106649,
  [SMALL_STATE(3769)] = 106731,
  [SMALL_STATE(3770)] = 106837,
  [SMALL_STATE(3771)] = 106945,
  [SMALL_STATE(3772)] = 107069,
  [SMALL_STATE(3773)] = 107137,
  [SMALL_STATE(3774)] = 107261,
  [SMALL_STATE(3775)] = 107365,
  [SMALL_STATE(3776)] = 107437,
  [SMALL_STATE(3777)] = 107557,
  [SMALL_STATE(3778)] = 107677,
  [SMALL_STATE(3779)] = 107779,
  [SMALL_STATE(3780)] = 107889,
  [SMALL_STATE(3781)] = 108001,
  [SMALL_STATE(3782)] = 108125,
  [SMALL_STATE(3783)] = 108241,
  [SMALL_STATE(3784)] = 108361,
  [SMALL_STATE(3785)] = 108481,
  [SMALL_STATE(3786)] = 108605,
  [SMALL_STATE(3787)] = 108723,
  [SMALL_STATE(3788)] = 108799,
  [SMALL_STATE(3789)] = 108923,
  [SMALL_STATE(3790)] = 109047,
  [SMALL_STATE(3791)] = 109171,
  [SMALL_STATE(3792)] = 109295,
  [SMALL_STATE(3793)] = 109419,
  [SMALL_STATE(3794)] = 109543,
  [SMALL_STATE(3795)] = 109661,
  [SMALL_STATE(3796)] = 109785,
  [SMALL_STATE(3797)] = 109909,
  [SMALL_STATE(3798)] = 109975,
  [SMALL_STATE(3799)] = 110041,
  [SMALL_STATE(3800)] = 110165,
  [SMALL_STATE(3801)] = 110233,
  [SMALL_STATE(3802)] = 110357,
  [SMALL_STATE(3803)] = 110477,
  [SMALL_STATE(3804)] = 110601,
  [SMALL_STATE(3805)] = 110725,
  [SMALL_STATE(3806)] = 110845,
  [SMALL_STATE(3807)] = 110951,
  [SMALL_STATE(3808)] = 111075,
  [SMALL_STATE(3809)] = 111143,
  [SMALL_STATE(3810)] = 111211,
  [SMALL_STATE(3811)] = 111279,
  [SMALL_STATE(3812)] = 111347,
  [SMALL_STATE(3813)] = 111465,
  [SMALL_STATE(3814)] = 111585,
  [SMALL_STATE(3815)] = 111665,
  [SMALL_STATE(3816)] = 111785,
  [SMALL_STATE(3817)] = 111905,
  [SMALL_STATE(3818)] = 112021,
  [SMALL_STATE(3819)] = 112133,
  [SMALL_STATE(3820)] = 112243,
  [SMALL_STATE(3821)] = 112345,
  [SMALL_STATE(3822)] = 112449,
  [SMALL_STATE(3823)] = 112557,
  [SMALL_STATE(3824)] = 112663,
  [SMALL_STATE(3825)] = 112783,
  [SMALL_STATE(3826)] = 112903,
  [SMALL_STATE(3827)] = 112987,
  [SMALL_STATE(3828)] = 113079,
  [SMALL_STATE(3829)] = 113183,
  [SMALL_STATE(3830)] = 113271,
  [SMALL_STATE(3831)] = 113361,
  [SMALL_STATE(3832)] = 113455,
  [SMALL_STATE(3833)] = 113563,
  [SMALL_STATE(3834)] = 113629,
  [SMALL_STATE(3835)] = 113749,
  [SMALL_STATE(3836)] = 113867,
  [SMALL_STATE(3837)] = 113961,
  [SMALL_STATE(3838)] = 114043,
  [SMALL_STATE(3839)] = 114133,
  [SMALL_STATE(3840)] = 114257,
  [SMALL_STATE(3841)] = 114345,
  [SMALL_STATE(3842)] = 114437,
  [SMALL_STATE(3843)] = 114547,
  [SMALL_STATE(3844)] = 114631,
  [SMALL_STATE(3845)] = 114755,
  [SMALL_STATE(3846)] = 114875,
  [SMALL_STATE(3847)] = 114999,
  [SMALL_STATE(3848)] = 115119,
  [SMALL_STATE(3849)] = 115243,
  [SMALL_STATE(3850)] = 115327,
  [SMALL_STATE(3851)] = 115409,
  [SMALL_STATE(3852)] = 115491,
  [SMALL_STATE(3853)] = 115611,
  [SMALL_STATE(3854)] = 115693,
  [SMALL_STATE(3855)] = 115775,
  [SMALL_STATE(3856)] = 115887,
  [SMALL_STATE(3857)] = 116011,
  [SMALL_STATE(3858)] = 116093,
  [SMALL_STATE(3859)] = 116217,
  [SMALL_STATE(3860)] = 116333,
  [SMALL_STATE(3861)] = 116453,
  [SMALL_STATE(3862)] = 116559,
  [SMALL_STATE(3863)] = 116667,
  [SMALL_STATE(3864)] = 116751,
  [SMALL_STATE(3865)] = 116873,
  [SMALL_STATE(3866)] = 116977,
  [SMALL_STATE(3867)] = 117069,
  [SMALL_STATE(3868)] = 117171,
  [SMALL_STATE(3869)] = 117295,
  [SMALL_STATE(3870)] = 117419,
  [SMALL_STATE(3871)] = 117529,
  [SMALL_STATE(3872)] = 117617,
  [SMALL_STATE(3873)] = 117707,
  [SMALL_STATE(3874)] = 117801,
  [SMALL_STATE(3875)] = 117925,
  [SMALL_STATE(3876)] = 117989,
  [SMALL_STATE(3877)] = 118109,
  [SMALL_STATE(3878)] = 118193,
  [SMALL_STATE(3879)] = 118257,
  [SMALL_STATE(3880)] = 118377,
  [SMALL_STATE(3881)] = 118489,
  [SMALL_STATE(3882)] = 118571,
  [SMALL_STATE(3883)] = 118689,
  [SMALL_STATE(3884)] = 118813,
  [SMALL_STATE(3885)] = 118885,
  [SMALL_STATE(3886)] = 119009,
  [SMALL_STATE(3887)] = 119129,
  [SMALL_STATE(3888)] = 119247,
  [SMALL_STATE(3889)] = 119365,
  [SMALL_STATE(3890)] = 119485,
  [SMALL_STATE(3891)] = 119609,
  [SMALL_STATE(3892)] = 119681,
  [SMALL_STATE(3893)] = 119749,
  [SMALL_STATE(3894)] = 119817,
  [SMALL_STATE(3895)] = 119937,
  [SMALL_STATE(3896)] = 120039,
  [SMALL_STATE(3897)] = 120159,
  [SMALL_STATE(3898)] = 120275,
  [SMALL_STATE(3899)] = 120391,
  [SMALL_STATE(3900)] = 120515,
  [SMALL_STATE(3901)] = 120635,
  [SMALL_STATE(3902)] = 120699,
  [SMALL_STATE(3903)] = 120767,
  [SMALL_STATE(3904)] = 120891,
  [SMALL_STATE(3905)] = 121011,
  [SMALL_STATE(3906)] = 121079,
  [SMALL_STATE(3907)] = 121161,
  [SMALL_STATE(3908)] = 121273,
  [SMALL_STATE(3909)] = 121341,
  [SMALL_STATE(3910)] = 121465,
  [SMALL_STATE(3911)] = 121585,
  [SMALL_STATE(3912)] = 121695,
  [SMALL_STATE(3913)] = 121797,
  [SMALL_STATE(3914)] = 121901,
  [SMALL_STATE(3915)] = 122019,
  [SMALL_STATE(3916)] = 122127,
  [SMALL_STATE(3917)] = 122191,
  [SMALL_STATE(3918)] = 122255,
  [SMALL_STATE(3919)] = 122361,
  [SMALL_STATE(3920)] = 122443,
  [SMALL_STATE(3921)] = 122567,
  [SMALL_STATE(3922)] = 122649,
  [SMALL_STATE(3923)] = 122733,
  [SMALL_STATE(3924)] = 122797,
  [SMALL_STATE(3925)] = 122917,
  [SMALL_STATE(3926)] = 123037,
  [SMALL_STATE(3927)] = 123161,
  [SMALL_STATE(3928)] = 123229,
  [SMALL_STATE(3929)] = 123297,
  [SMALL_STATE(3930)] = 123417,
  [SMALL_STATE(3931)] = 123518,
  [SMALL_STATE(3932)] = 123581,
  [SMALL_STATE(3933)] = 123682,
  [SMALL_STATE(3934)] = 123753,
  [SMALL_STATE(3935)] = 123872,
  [SMALL_STATE(3936)] = 123993,
  [SMALL_STATE(3937)] = 124056,
  [SMALL_STATE(3938)] = 124157,
  [SMALL_STATE(3939)] = 124222,
  [SMALL_STATE(3940)] = 124323,
  [SMALL_STATE(3941)] = 124444,
  [SMALL_STATE(3942)] = 124563,
  [SMALL_STATE(3943)] = 124662,
  [SMALL_STATE(3944)] = 124729,
  [SMALL_STATE(3945)] = 124822,
  [SMALL_STATE(3946)] = 124911,
  [SMALL_STATE(3947)] = 124998,
  [SMALL_STATE(3948)] = 125081,
  [SMALL_STATE(3949)] = 125200,
  [SMALL_STATE(3950)] = 125319,
  [SMALL_STATE(3951)] = 125420,
  [SMALL_STATE(3952)] = 125539,
  [SMALL_STATE(3953)] = 125658,
  [SMALL_STATE(3954)] = 125763,
  [SMALL_STATE(3955)] = 125870,
  [SMALL_STATE(3956)] = 125963,
  [SMALL_STATE(3957)] = 126066,
  [SMALL_STATE(3958)] = 126167,
  [SMALL_STATE(3959)] = 126276,
  [SMALL_STATE(3960)] = 126387,
  [SMALL_STATE(3961)] = 126502,
  [SMALL_STATE(3962)] = 126621,
  [SMALL_STATE(3963)] = 126710,
  [SMALL_STATE(3964)] = 126829,
  [SMALL_STATE(3965)] = 126948,
  [SMALL_STATE(3966)] = 127039,
  [SMALL_STATE(3967)] = 127126,
  [SMALL_STATE(3968)] = 127217,
  [SMALL_STATE(3969)] = 127300,
  [SMALL_STATE(3970)] = 127381,
  [SMALL_STATE(3971)] = 127498,
  [SMALL_STATE(3972)] = 127617,
  [SMALL_STATE(3973)] = 127736,
  [SMALL_STATE(3974)] = 127841,
  [SMALL_STATE(3975)] = 127948,
  [SMALL_STATE(3976)] = 128051,
  [SMALL_STATE(3977)] = 128152,
  [SMALL_STATE(3978)] = 128271,
  [SMALL_STATE(3979)] = 128372,
  [SMALL_STATE(3980)] = 128481,
  [SMALL_STATE(3981)] = 128592,
  [SMALL_STATE(3982)] = 128707,
  [SMALL_STATE(3983)] = 128826,
  [SMALL_STATE(3984)] = 128945,
  [SMALL_STATE(3985)] = 129064,
  [SMALL_STATE(3986)] = 129181,
  [SMALL_STATE(3987)] = 129298,
  [SMALL_STATE(3988)] = 129379,
  [SMALL_STATE(3989)] = 129498,
  [SMALL_STATE(3990)] = 129565,
  [SMALL_STATE(3991)] = 129684,
  [SMALL_STATE(3992)] = 129803,
  [SMALL_STATE(3993)] = 129904,
  [SMALL_STATE(3994)] = 130019,
  [SMALL_STATE(3995)] = 130130,
  [SMALL_STATE(3996)] = 130239,
  [SMALL_STATE(3997)] = 130340,
  [SMALL_STATE(3998)] = 130443,
  [SMALL_STATE(3999)] = 130550,
  [SMALL_STATE(4000)] = 130649,
  [SMALL_STATE(4001)] = 130754,
  [SMALL_STATE(4002)] = 130821,
  [SMALL_STATE(4003)] = 130940,
  [SMALL_STATE(4004)] = 131059,
  [SMALL_STATE(4005)] = 131126,
  [SMALL_STATE(4006)] = 131245,
  [SMALL_STATE(4007)] = 131312,
  [SMALL_STATE(4008)] = 131433,
  [SMALL_STATE(4009)] = 131514,
  [SMALL_STATE(4010)] = 131597,
  [SMALL_STATE(4011)] = 131688,
  [SMALL_STATE(4012)] = 131755,
  [SMALL_STATE(4013)] = 131842,
  [SMALL_STATE(4014)] = 131931,
  [SMALL_STATE(4015)] = 132024,
  [SMALL_STATE(4016)] = 132091,
  [SMALL_STATE(4017)] = 132192,
  [SMALL_STATE(4018)] = 132259,
  [SMALL_STATE(4019)] = 132326,
  [SMALL_STATE(4020)] = 132393,
  [SMALL_STATE(4021)] = 132494,
  [SMALL_STATE(4022)] = 132565,
  [SMALL_STATE(4023)] = 132686,
  [SMALL_STATE(4024)] = 132753,
  [SMALL_STATE(4025)] = 132820,
  [SMALL_STATE(4026)] = 132891,
  [SMALL_STATE(4027)] = 133012,
  [SMALL_STATE(4028)] = 133131,
  [SMALL_STATE(4029)] = 133232,
  [SMALL_STATE(4030)] = 133351,
  [SMALL_STATE(4031)] = 133450,
  [SMALL_STATE(4032)] = 133569,
  [SMALL_STATE(4033)] = 133690,
  [SMALL_STATE(4034)] = 133791,
  [SMALL_STATE(4035)] = 133910,
  [SMALL_STATE(4036)] = 134029,
  [SMALL_STATE(4037)] = 134148,
  [SMALL_STATE(4038)] = 134231,
  [SMALL_STATE(4039)] = 134312,
  [SMALL_STATE(4040)] = 134393,
  [SMALL_STATE(4041)] = 134460,
  [SMALL_STATE(4042)] = 134527,
  [SMALL_STATE(4043)] = 134594,
  [SMALL_STATE(4044)] = 134677,
  [SMALL_STATE(4045)] = 134758,
  [SMALL_STATE(4046)] = 134825,
  [SMALL_STATE(4047)] = 134892,
  [SMALL_STATE(4048)] = 134991,
  [SMALL_STATE(4049)] = 135110,
  [SMALL_STATE(4050)] = 135177,
  [SMALL_STATE(4051)] = 135298,
  [SMALL_STATE(4052)] = 135365,
  [SMALL_STATE(4053)] = 135446,
  [SMALL_STATE(4054)] = 135511,
  [SMALL_STATE(4055)] = 135628,
  [SMALL_STATE(4056)] = 135747,
  [SMALL_STATE(4057)] = 135866,
  [SMALL_STATE(4058)] = 135985,
  [SMALL_STATE(4059)] = 136104,
  [SMALL_STATE(4060)] = 136223,
  [SMALL_STATE(4061)] = 136338,
  [SMALL_STATE(4062)] = 136449,
  [SMALL_STATE(4063)] = 136558,
  [SMALL_STATE(4064)] = 136659,
  [SMALL_STATE(4065)] = 136762,
  [SMALL_STATE(4066)] = 136881,
  [SMALL_STATE(4067)] = 137000,
  [SMALL_STATE(4068)] = 137065,
  [SMALL_STATE(4069)] = 137132,
  [SMALL_STATE(4070)] = 137239,
  [SMALL_STATE(4071)] = 137344,
  [SMALL_STATE(4072)] = 137463,
  [SMALL_STATE(4073)] = 137582,
  [SMALL_STATE(4074)] = 137663,
  [SMALL_STATE(4075)] = 137782,
  [SMALL_STATE(4076)] = 137865,
  [SMALL_STATE(4077)] = 137984,
  [SMALL_STATE(4078)] = 138075,
  [SMALL_STATE(4079)] = 138174,
  [SMALL_STATE(4080)] = 138293,
  [SMALL_STATE(4081)] = 138380,
  [SMALL_STATE(4082)] = 138469,
  [SMALL_STATE(4083)] = 138570,
  [SMALL_STATE(4084)] = 138653,
  [SMALL_STATE(4085)] = 138734,
  [SMALL_STATE(4086)] = 138815,
  [SMALL_STATE(4087)] = 138934,
  [SMALL_STATE(4088)] = 139053,
  [SMALL_STATE(4089)] = 139146,
  [SMALL_STATE(4090)] = 139211,
  [SMALL_STATE(4091)] = 139330,
  [SMALL_STATE(4092)] = 139449,
  [SMALL_STATE(4093)] = 139530,
  [SMALL_STATE(4094)] = 139611,
  [SMALL_STATE(4095)] = 139694,
  [SMALL_STATE(4096)] = 139767,
  [SMALL_STATE(4097)] = 139855,
  [SMALL_STATE(4098)] = 139973,
  [SMALL_STATE(4099)] = 140091,
  [SMALL_STATE(4100)] = 140209,
  [SMALL_STATE(4101)] = 140325,
  [SMALL_STATE(4102)] = 140389,
  [SMALL_STATE(4103)] = 140507,
  [SMALL_STATE(4104)] = 140625,
  [SMALL_STATE(4105)] = 140743,
  [SMALL_STATE(4106)] = 140823,
  [SMALL_STATE(4107)] = 140941,
  [SMALL_STATE(4108)] = 141059,
  [SMALL_STATE(4109)] = 141177,
  [SMALL_STATE(4110)] = 141295,
  [SMALL_STATE(4111)] = 141413,
  [SMALL_STATE(4112)] = 141527,
  [SMALL_STATE(4113)] = 141645,
  [SMALL_STATE(4114)] = 141763,
  [SMALL_STATE(4115)] = 141881,
  [SMALL_STATE(4116)] = 141991,
  [SMALL_STATE(4117)] = 142099,
  [SMALL_STATE(4118)] = 142181,
  [SMALL_STATE(4119)] = 142243,
  [SMALL_STATE(4120)] = 142361,
  [SMALL_STATE(4121)] = 142423,
  [SMALL_STATE(4122)] = 142505,
  [SMALL_STATE(4123)] = 142623,
  [SMALL_STATE(4124)] = 142741,
  [SMALL_STATE(4125)] = 142859,
  [SMALL_STATE(4126)] = 142977,
  [SMALL_STATE(4127)] = 143095,
  [SMALL_STATE(4128)] = 143213,
  [SMALL_STATE(4129)] = 143329,
  [SMALL_STATE(4130)] = 143409,
  [SMALL_STATE(4131)] = 143475,
  [SMALL_STATE(4132)] = 143593,
  [SMALL_STATE(4133)] = 143711,
  [SMALL_STATE(4134)] = 143829,
  [SMALL_STATE(4135)] = 143947,
  [SMALL_STATE(4136)] = 144065,
  [SMALL_STATE(4137)] = 144133,
  [SMALL_STATE(4138)] = 144213,
  [SMALL_STATE(4139)] = 144275,
  [SMALL_STATE(4140)] = 144393,
  [SMALL_STATE(4141)] = 144511,
  [SMALL_STATE(4142)] = 144629,
  [SMALL_STATE(4143)] = 144693,
  [SMALL_STATE(4144)] = 144755,
  [SMALL_STATE(4145)] = 144817,
  [SMALL_STATE(4146)] = 144879,
  [SMALL_STATE(4147)] = 144945,
  [SMALL_STATE(4148)] = 145049,
  [SMALL_STATE(4149)] = 145167,
  [SMALL_STATE(4150)] = 145233,
  [SMALL_STATE(4151)] = 145329,
  [SMALL_STATE(4152)] = 145435,
  [SMALL_STATE(4153)] = 145553,
  [SMALL_STATE(4154)] = 145655,
  [SMALL_STATE(4155)] = 145717,
  [SMALL_STATE(4156)] = 145817,
  [SMALL_STATE(4157)] = 145935,
  [SMALL_STATE(4158)] = 146001,
  [SMALL_STATE(4159)] = 146119,
  [SMALL_STATE(4160)] = 146211,
  [SMALL_STATE(4161)] = 146329,
  [SMALL_STATE(4162)] = 146447,
  [SMALL_STATE(4163)] = 146565,
  [SMALL_STATE(4164)] = 146683,
  [SMALL_STATE(4165)] = 146779,
  [SMALL_STATE(4166)] = 146897,
  [SMALL_STATE(4167)] = 146977,
  [SMALL_STATE(4168)] = 147077,
  [SMALL_STATE(4169)] = 147195,
  [SMALL_STATE(4170)] = 147275,
  [SMALL_STATE(4171)] = 147393,
  [SMALL_STATE(4172)] = 147511,
  [SMALL_STATE(4173)] = 147599,
  [SMALL_STATE(4174)] = 147685,
  [SMALL_STATE(4175)] = 147803,
  [SMALL_STATE(4176)] = 147893,
  [SMALL_STATE(4177)] = 148011,
  [SMALL_STATE(4178)] = 148129,
  [SMALL_STATE(4179)] = 148237,
  [SMALL_STATE(4180)] = 148317,
  [SMALL_STATE(4181)] = 148397,
  [SMALL_STATE(4182)] = 148507,
  [SMALL_STATE(4183)] = 148621,
  [SMALL_STATE(4184)] = 148703,
  [SMALL_STATE(4185)] = 148783,
  [SMALL_STATE(4186)] = 148901,
  [SMALL_STATE(4187)] = 149019,
  [SMALL_STATE(4188)] = 149109,
  [SMALL_STATE(4189)] = 149211,
  [SMALL_STATE(4190)] = 149329,
  [SMALL_STATE(4191)] = 149443,
  [SMALL_STATE(4192)] = 149561,
  [SMALL_STATE(4193)] = 149627,
  [SMALL_STATE(4194)] = 149691,
  [SMALL_STATE(4195)] = 149797,
  [SMALL_STATE(4196)] = 149867,
  [SMALL_STATE(4197)] = 149985,
  [SMALL_STATE(4198)] = 150089,
  [SMALL_STATE(4199)] = 150155,
  [SMALL_STATE(4200)] = 150265,
  [SMALL_STATE(4201)] = 150373,
  [SMALL_STATE(4202)] = 150455,
  [SMALL_STATE(4203)] = 150521,
  [SMALL_STATE(4204)] = 150639,
  [SMALL_STATE(4205)] = 150757,
  [SMALL_STATE(4206)] = 150825,
  [SMALL_STATE(4207)] = 150943,
  [SMALL_STATE(4208)] = 151039,
  [SMALL_STATE(4209)] = 151157,
  [SMALL_STATE(4210)] = 151275,
  [SMALL_STATE(4211)] = 151375,
  [SMALL_STATE(4212)] = 151461,
  [SMALL_STATE(4213)] = 151551,
  [SMALL_STATE(4214)] = 151669,
  [SMALL_STATE(4215)] = 151787,
  [SMALL_STATE(4216)] = 151905,
  [SMALL_STATE(4217)] = 152007,
  [SMALL_STATE(4218)] = 152125,
  [SMALL_STATE(4219)] = 152231,
  [SMALL_STATE(4220)] = 152349,
  [SMALL_STATE(4221)] = 152411,
  [SMALL_STATE(4222)] = 152529,
  [SMALL_STATE(4223)] = 152591,
  [SMALL_STATE(4224)] = 152709,
  [SMALL_STATE(4225)] = 152813,
  [SMALL_STATE(4226)] = 152899,
  [SMALL_STATE(4227)] = 152987,
  [SMALL_STATE(4228)] = 153105,
  [SMALL_STATE(4229)] = 153197,
  [SMALL_STATE(4230)] = 153289,
  [SMALL_STATE(4231)] = 153407,
  [SMALL_STATE(4232)] = 153525,
  [SMALL_STATE(4233)] = 153643,
  [SMALL_STATE(4234)] = 153761,
  [SMALL_STATE(4235)] = 153879,
  [SMALL_STATE(4236)] = 153997,
  [SMALL_STATE(4237)] = 154063,
  [SMALL_STATE(4238)] = 154181,
  [SMALL_STATE(4239)] = 154299,
  [SMALL_STATE(4240)] = 154417,
  [SMALL_STATE(4241)] = 154535,
  [SMALL_STATE(4242)] = 154653,
  [SMALL_STATE(4243)] = 154771,
  [SMALL_STATE(4244)] = 154889,
  [SMALL_STATE(4245)] = 155007,
  [SMALL_STATE(4246)] = 155099,
  [SMALL_STATE(4247)] = 155217,
  [SMALL_STATE(4248)] = 155285,
  [SMALL_STATE(4249)] = 155373,
  [SMALL_STATE(4250)] = 155459,
  [SMALL_STATE(4251)] = 155549,
  [SMALL_STATE(4252)] = 155667,
  [SMALL_STATE(4253)] = 155785,
  [SMALL_STATE(4254)] = 155867,
  [SMALL_STATE(4255)] = 155937,
  [SMALL_STATE(4256)] = 156055,
  [SMALL_STATE(4257)] = 156173,
  [SMALL_STATE(4258)] = 156291,
  [SMALL_STATE(4259)] = 156371,
  [SMALL_STATE(4260)] = 156453,
  [SMALL_STATE(4261)] = 156533,
  [SMALL_STATE(4262)] = 156613,
  [SMALL_STATE(4263)] = 156731,
  [SMALL_STATE(4264)] = 156849,
  [SMALL_STATE(4265)] = 156967,
  [SMALL_STATE(4266)] = 157085,
  [SMALL_STATE(4267)] = 157151,
  [SMALL_STATE(4268)] = 157269,
  [SMALL_STATE(4269)] = 157385,
  [SMALL_STATE(4270)] = 157503,
  [SMALL_STATE(4271)] = 157621,
  [SMALL_STATE(4272)] = 157739,
  [SMALL_STATE(4273)] = 157857,
  [SMALL_STATE(4274)] = 157975,
  [SMALL_STATE(4275)] = 158093,
  [SMALL_STATE(4276)] = 158211,
  [SMALL_STATE(4277)] = 158329,
  [SMALL_STATE(4278)] = 158447,
  [SMALL_STATE(4279)] = 158565,
  [SMALL_STATE(4280)] = 158683,
  [SMALL_STATE(4281)] = 158801,
  [SMALL_STATE(4282)] = 158919,
  [SMALL_STATE(4283)] = 159037,
  [SMALL_STATE(4284)] = 159155,
  [SMALL_STATE(4285)] = 159223,
  [SMALL_STATE(4286)] = 159341,
  [SMALL_STATE(4287)] = 159459,
  [SMALL_STATE(4288)] = 159525,
  [SMALL_STATE(4289)] = 159643,
  [SMALL_STATE(4290)] = 159759,
  [SMALL_STATE(4291)] = 159877,
  [SMALL_STATE(4292)] = 159943,
  [SMALL_STATE(4293)] = 160061,
  [SMALL_STATE(4294)] = 160153,
  [SMALL_STATE(4295)] = 160271,
  [SMALL_STATE(4296)] = 160359,
  [SMALL_STATE(4297)] = 160477,
  [SMALL_STATE(4298)] = 160595,
  [SMALL_STATE(4299)] = 160713,
  [SMALL_STATE(4300)] = 160799,
  [SMALL_STATE(4301)] = 160917,
  [SMALL_STATE(4302)] = 161035,
  [SMALL_STATE(4303)] = 161139,
  [SMALL_STATE(4304)] = 161201,
  [SMALL_STATE(4305)] = 161319,
  [SMALL_STATE(4306)] = 161437,
  [SMALL_STATE(4307)] = 161555,
  [SMALL_STATE(4308)] = 161673,
  [SMALL_STATE(4309)] = 161791,
  [SMALL_STATE(4310)] = 161909,
  [SMALL_STATE(4311)] = 162027,
  [SMALL_STATE(4312)] = 162145,
  [SMALL_STATE(4313)] = 162241,
  [SMALL_STATE(4314)] = 162305,
  [SMALL_STATE(4315)] = 162411,
  [SMALL_STATE(4316)] = 162513,
  [SMALL_STATE(4317)] = 162631,
  [SMALL_STATE(4318)] = 162711,
  [SMALL_STATE(4319)] = 162801,
  [SMALL_STATE(4320)] = 162919,
  [SMALL_STATE(4321)] = 163037,
  [SMALL_STATE(4322)] = 163155,
  [SMALL_STATE(4323)] = 163273,
  [SMALL_STATE(4324)] = 163339,
  [SMALL_STATE(4325)] = 163457,
  [SMALL_STATE(4326)] = 163539,
  [SMALL_STATE(4327)] = 163657,
  [SMALL_STATE(4328)] = 163757,
  [SMALL_STATE(4329)] = 163853,
  [SMALL_STATE(4330)] = 163923,
  [SMALL_STATE(4331)] = 164041,
  [SMALL_STATE(4332)] = 164159,
  [SMALL_STATE(4333)] = 164277,
  [SMALL_STATE(4334)] = 164395,
  [SMALL_STATE(4335)] = 164513,
  [SMALL_STATE(4336)] = 164631,
  [SMALL_STATE(4337)] = 164749,
  [SMALL_STATE(4338)] = 164813,
  [SMALL_STATE(4339)] = 164931,
  [SMALL_STATE(4340)] = 165049,
  [SMALL_STATE(4341)] = 165167,
  [SMALL_STATE(4342)] = 165249,
  [SMALL_STATE(4343)] = 165329,
  [SMALL_STATE(4344)] = 165447,
  [SMALL_STATE(4345)] = 165527,
  [SMALL_STATE(4346)] = 165607,
  [SMALL_STATE(4347)] = 165725,
  [SMALL_STATE(4348)] = 165843,
  [SMALL_STATE(4349)] = 165961,
  [SMALL_STATE(4350)] = 166079,
  [SMALL_STATE(4351)] = 166197,
  [SMALL_STATE(4352)] = 166315,
  [SMALL_STATE(4353)] = 166433,
  [SMALL_STATE(4354)] = 166551,
  [SMALL_STATE(4355)] = 166621,
  [SMALL_STATE(4356)] = 166683,
  [SMALL_STATE(4357)] = 166801,
  [SMALL_STATE(4358)] = 166905,
  [SMALL_STATE(4359)] = 167011,
  [SMALL_STATE(4360)] = 167113,
  [SMALL_STATE(4361)] = 167175,
  [SMALL_STATE(4362)] = 167275,
  [SMALL_STATE(4363)] = 167371,
  [SMALL_STATE(4364)] = 167453,
  [SMALL_STATE(4365)] = 167561,
  [SMALL_STATE(4366)] = 167671,
  [SMALL_STATE(4367)] = 167785,
  [SMALL_STATE(4368)] = 167903,
  [SMALL_STATE(4369)] = 168021,
  [SMALL_STATE(4370)] = 168139,
  [SMALL_STATE(4371)] = 168205,
  [SMALL_STATE(4372)] = 168323,
  [SMALL_STATE(4373)] = 168441,
  [SMALL_STATE(4374)] = 168505,
  [SMALL_STATE(4375)] = 168587,
  [SMALL_STATE(4376)] = 168705,
  [SMALL_STATE(4377)] = 168823,
  [SMALL_STATE(4378)] = 168941,
  [SMALL_STATE(4379)] = 169049,
  [SMALL_STATE(4380)] = 169159,
  [SMALL_STATE(4381)] = 169273,
  [SMALL_STATE(4382)] = 169391,
  [SMALL_STATE(4383)] = 169509,
  [SMALL_STATE(4384)] = 169627,
  [SMALL_STATE(4385)] = 169745,
  [SMALL_STATE(4386)] = 169863,
  [SMALL_STATE(4387)] = 169981,
  [SMALL_STATE(4388)] = 170099,
  [SMALL_STATE(4389)] = 170217,
  [SMALL_STATE(4390)] = 170335,
  [SMALL_STATE(4391)] = 170451,
  [SMALL_STATE(4392)] = 170569,
  [SMALL_STATE(4393)] = 170687,
  [SMALL_STATE(4394)] = 170751,
  [SMALL_STATE(4395)] = 170869,
  [SMALL_STATE(4396)] = 170987,
  [SMALL_STATE(4397)] = 171105,
  [SMALL_STATE(4398)] = 171223,
  [SMALL_STATE(4399)] = 171341,
  [SMALL_STATE(4400)] = 171459,
  [SMALL_STATE(4401)] = 171577,
  [SMALL_STATE(4402)] = 171695,
  [SMALL_STATE(4403)] = 171788,
  [SMALL_STATE(4404)] = 171903,
  [SMALL_STATE(4405)] = 171966,
  [SMALL_STATE(4406)] = 172081,
  [SMALL_STATE(4407)] = 172174,
  [SMALL_STATE(4408)] = 172239,
  [SMALL_STATE(4409)] = 172354,
  [SMALL_STATE(4410)] = 172415,
  [SMALL_STATE(4411)] = 172480,
  [SMALL_STATE(4412)] = 172573,
  [SMALL_STATE(4413)] = 172636,
  [SMALL_STATE(4414)] = 172751,
  [SMALL_STATE(4415)] = 172814,
  [SMALL_STATE(4416)] = 172929,
  [SMALL_STATE(4417)] = 173022,
  [SMALL_STATE(4418)] = 173087,
  [SMALL_STATE(4419)] = 173150,
  [SMALL_STATE(4420)] = 173265,
  [SMALL_STATE(4421)] = 173380,
  [SMALL_STATE(4422)] = 173445,
  [SMALL_STATE(4423)] = 173506,
  [SMALL_STATE(4424)] = 173599,
  [SMALL_STATE(4425)] = 173714,
  [SMALL_STATE(4426)] = 173807,
  [SMALL_STATE(4427)] = 173922,
  [SMALL_STATE(4428)] = 174037,
  [SMALL_STATE(4429)] = 174102,
  [SMALL_STATE(4430)] = 174195,
  [SMALL_STATE(4431)] = 174310,
  [SMALL_STATE(4432)] = 174403,
  [SMALL_STATE(4433)] = 174466,
  [SMALL_STATE(4434)] = 174531,
  [SMALL_STATE(4435)] = 174646,
  [SMALL_STATE(4436)] = 174739,
  [SMALL_STATE(4437)] = 174804,
  [SMALL_STATE(4438)] = 174869,
  [SMALL_STATE(4439)] = 174962,
  [SMALL_STATE(4440)] = 175077,
  [SMALL_STATE(4441)] = 175142,
  [SMALL_STATE(4442)] = 175257,
  [SMALL_STATE(4443)] = 175322,
  [SMALL_STATE(4444)] = 175387,
  [SMALL_STATE(4445)] = 175480,
  [SMALL_STATE(4446)] = 175575,
  [SMALL_STATE(4447)] = 175668,
  [SMALL_STATE(4448)] = 175733,
  [SMALL_STATE(4449)] = 175798,
  [SMALL_STATE(4450)] = 175859,
  [SMALL_STATE(4451)] = 175922,
  [SMALL_STATE(4452)] = 175985,
  [SMALL_STATE(4453)] = 176078,
  [SMALL_STATE(4454)] = 176143,
  [SMALL_STATE(4455)] = 176236,
  [SMALL_STATE(4456)] = 176297,
  [SMALL_STATE(4457)] = 176390,
  [SMALL_STATE(4458)] = 176455,
  [SMALL_STATE(4459)] = 176520,
  [SMALL_STATE(4460)] = 176615,
  [SMALL_STATE(4461)] = 176680,
  [SMALL_STATE(4462)] = 176775,
  [SMALL_STATE(4463)] = 176890,
  [SMALL_STATE(4464)] = 176955,
  [SMALL_STATE(4465)] = 177048,
  [SMALL_STATE(4466)] = 177113,
  [SMALL_STATE(4467)] = 177208,
  [SMALL_STATE(4468)] = 177301,
  [SMALL_STATE(4469)] = 177394,
  [SMALL_STATE(4470)] = 177489,
  [SMALL_STATE(4471)] = 177604,
  [SMALL_STATE(4472)] = 177697,
  [SMALL_STATE(4473)] = 177790,
  [SMALL_STATE(4474)] = 177883,
  [SMALL_STATE(4475)] = 177946,
  [SMALL_STATE(4476)] = 178039,
  [SMALL_STATE(4477)] = 178104,
  [SMALL_STATE(4478)] = 178219,
  [SMALL_STATE(4479)] = 178334,
  [SMALL_STATE(4480)] = 178399,
  [SMALL_STATE(4481)] = 178464,
  [SMALL_STATE(4482)] = 178529,
  [SMALL_STATE(4483)] = 178594,
  [SMALL_STATE(4484)] = 178687,
  [SMALL_STATE(4485)] = 178802,
  [SMALL_STATE(4486)] = 178867,
  [SMALL_STATE(4487)] = 178982,
  [SMALL_STATE(4488)] = 179097,
  [SMALL_STATE(4489)] = 179190,
  [SMALL_STATE(4490)] = 179255,
  [SMALL_STATE(4491)] = 179320,
  [SMALL_STATE(4492)] = 179385,
  [SMALL_STATE(4493)] = 179446,
  [SMALL_STATE(4494)] = 179536,
  [SMALL_STATE(4495)] = 179640,
  [SMALL_STATE(4496)] = 179730,
  [SMALL_STATE(4497)] = 179834,
  [SMALL_STATE(4498)] = 179924,
  [SMALL_STATE(4499)] = 179984,
  [SMALL_STATE(4500)] = 180074,
  [SMALL_STATE(4501)] = 180164,
  [SMALL_STATE(4502)] = 180254,
  [SMALL_STATE(4503)] = 180318,
  [SMALL_STATE(4504)] = 180408,
  [SMALL_STATE(4505)] = 180498,
  [SMALL_STATE(4506)] = 180588,
  [SMALL_STATE(4507)] = 180678,
  [SMALL_STATE(4508)] = 180768,
  [SMALL_STATE(4509)] = 180858,
  [SMALL_STATE(4510)] = 180948,
  [SMALL_STATE(4511)] = 181038,
  [SMALL_STATE(4512)] = 181128,
  [SMALL_STATE(4513)] = 181188,
  [SMALL_STATE(4514)] = 181248,
  [SMALL_STATE(4515)] = 181306,
  [SMALL_STATE(4516)] = 181396,
  [SMALL_STATE(4517)] = 181486,
  [SMALL_STATE(4518)] = 181576,
  [SMALL_STATE(4519)] = 181666,
  [SMALL_STATE(4520)] = 181756,
  [SMALL_STATE(4521)] = 181846,
  [SMALL_STATE(4522)] = 181904,
  [SMALL_STATE(4523)] = 181994,
  [SMALL_STATE(4524)] = 182084,
  [SMALL_STATE(4525)] = 182174,
  [SMALL_STATE(4526)] = 182232,
  [SMALL_STATE(4527)] = 182322,
  [SMALL_STATE(4528)] = 182416,
  [SMALL_STATE(4529)] = 182506,
  [SMALL_STATE(4530)] = 182570,
  [SMALL_STATE(4531)] = 182660,
  [SMALL_STATE(4532)] = 182750,
  [SMALL_STATE(4533)] = 182840,
  [SMALL_STATE(4534)] = 182900,
  [SMALL_STATE(4535)] = 182990,
  [SMALL_STATE(4536)] = 183080,
  [SMALL_STATE(4537)] = 183170,
  [SMALL_STATE(4538)] = 183230,
  [SMALL_STATE(4539)] = 183320,
  [SMALL_STATE(4540)] = 183410,
  [SMALL_STATE(4541)] = 183500,
  [SMALL_STATE(4542)] = 183590,
  [SMALL_STATE(4543)] = 183650,
  [SMALL_STATE(4544)] = 183740,
  [SMALL_STATE(4545)] = 183800,
  [SMALL_STATE(4546)] = 183890,
  [SMALL_STATE(4547)] = 183980,
  [SMALL_STATE(4548)] = 184070,
  [SMALL_STATE(4549)] = 184134,
  [SMALL_STATE(4550)] = 184228,
  [SMALL_STATE(4551)] = 184318,
  [SMALL_STATE(4552)] = 184408,
  [SMALL_STATE(4553)] = 184504,
  [SMALL_STATE(4554)] = 184600,
  [SMALL_STATE(4555)] = 184657,
  [SMALL_STATE(4556)] = 184748,
  [SMALL_STATE(4557)] = 184805,
  [SMALL_STATE(4558)] = 184882,
  [SMALL_STATE(4559)] = 184939,
  [SMALL_STATE(4560)] = 185030,
  [SMALL_STATE(4561)] = 185119,
  [SMALL_STATE(4562)] = 185176,
  [SMALL_STATE(4563)] = 185233,
  [SMALL_STATE(4564)] = 185322,
  [SMALL_STATE(4565)] = 185411,
  [SMALL_STATE(4566)] = 185470,
  [SMALL_STATE(4567)] = 185527,
  [SMALL_STATE(4568)] = 185618,
  [SMALL_STATE(4569)] = 185695,
  [SMALL_STATE(4570)] = 185772,
  [SMALL_STATE(4571)] = 185829,
  [SMALL_STATE(4572)] = 185918,
  [SMALL_STATE(4573)] = 185995,
  [SMALL_STATE(4574)] = 186052,
  [SMALL_STATE(4575)] = 186135,
  [SMALL_STATE(4576)] = 186226,
  [SMALL_STATE(4577)] = 186283,
  [SMALL_STATE(4578)] = 186340,
  [SMALL_STATE(4579)] = 186417,
  [SMALL_STATE(4580)] = 186508,
  [SMALL_STATE(4581)] = 186594,
  [SMALL_STATE(4582)] = 186680,
  [SMALL_STATE(4583)] = 186766,
  [SMALL_STATE(4584)] = 186822,
  [SMALL_STATE(4585)] = 186908,
  [SMALL_STATE(4586)] = 186994,
  [SMALL_STATE(4587)] = 187080,
  [SMALL_STATE(4588)] = 187166,
  [SMALL_STATE(4589)] = 187252,
  [SMALL_STATE(4590)] = 187338,
  [SMALL_STATE(4591)] = 187424,
  [SMALL_STATE(4592)] = 187510,
  [SMALL_STATE(4593)] = 187596,
  [SMALL_STATE(4594)] = 187682,
  [SMALL_STATE(4595)] = 187738,
  [SMALL_STATE(4596)] = 187824,
  [SMALL_STATE(4597)] = 187910,
  [SMALL_STATE(4598)] = 187996,
  [SMALL_STATE(4599)] = 188082,
  [SMALL_STATE(4600)] = 188168,
  [SMALL_STATE(4601)] = 188254,
  [SMALL_STATE(4602)] = 188340,
  [SMALL_STATE(4603)] = 188426,
  [SMALL_STATE(4604)] = 188496,
  [SMALL_STATE(4605)] = 188580,
  [SMALL_STATE(4606)] = 188663,
  [SMALL_STATE(4607)] = 188746,
  [SMALL_STATE(4608)] = 188829,
  [SMALL_STATE(4609)] = 188888,
  [SMALL_STATE(4610)] = 188972,
  [SMALL_STATE(4611)] = 189026,
  [SMALL_STATE(4612)] = 189108,
  [SMALL_STATE(4613)] = 189192,
  [SMALL_STATE(4614)] = 189252,
  [SMALL_STATE(4615)] = 189308,
  [SMALL_STATE(4616)] = 189392,
  [SMALL_STATE(4617)] = 189461,
  [SMALL_STATE(4618)] = 189520,
  [SMALL_STATE(4619)] = 189579,
  [SMALL_STATE(4620)] = 189648,
  [SMALL_STATE(4621)] = 189705,
  [SMALL_STATE(4622)] = 189774,
  [SMALL_STATE(4623)] = 189843,
  [SMALL_STATE(4624)] = 189912,
  [SMALL_STATE(4625)] = 189981,
  [SMALL_STATE(4626)] = 190052,
  [SMALL_STATE(4627)] = 190121,
  [SMALL_STATE(4628)] = 190190,
  [SMALL_STATE(4629)] = 190259,
  [SMALL_STATE(4630)] = 190328,
  [SMALL_STATE(4631)] = 190397,
  [SMALL_STATE(4632)] = 190466,
  [SMALL_STATE(4633)] = 190537,
  [SMALL_STATE(4634)] = 190607,
  [SMALL_STATE(4635)] = 190671,
  [SMALL_STATE(4636)] = 190735,
  [SMALL_STATE(4637)] = 190787,
  [SMALL_STATE(4638)] = 190851,
  [SMALL_STATE(4639)] = 190915,
  [SMALL_STATE(4640)] = 190967,
  [SMALL_STATE(4641)] = 191023,
  [SMALL_STATE(4642)] = 191093,
  [SMALL_STATE(4643)] = 191147,
  [SMALL_STATE(4644)] = 191212,
  [SMALL_STATE(4645)] = 191277,
  [SMALL_STATE(4646)] = 191342,
  [SMALL_STATE(4647)] = 191403,
  [SMALL_STATE(4648)] = 191456,
  [SMALL_STATE(4649)] = 191513,
  [SMALL_STATE(4650)] = 191574,
  [SMALL_STATE(4651)] = 191635,
  [SMALL_STATE(4652)] = 191692,
  [SMALL_STATE(4653)] = 191757,
  [SMALL_STATE(4654)] = 191808,
  [SMALL_STATE(4655)] = 191858,
  [SMALL_STATE(4656)] = 191926,
  [SMALL_STATE(4657)] = 191994,
  [SMALL_STATE(4658)] = 192044,
  [SMALL_STATE(4659)] = 192112,
  [SMALL_STATE(4660)] = 192162,
  [SMALL_STATE(4661)] = 192230,
  [SMALL_STATE(4662)] = 192298,
  [SMALL_STATE(4663)] = 192366,
  [SMALL_STATE(4664)] = 192430,
  [SMALL_STATE(4665)] = 192498,
  [SMALL_STATE(4666)] = 192566,
  [SMALL_STATE(4667)] = 192630,
  [SMALL_STATE(4668)] = 192698,
  [SMALL_STATE(4669)] = 192766,
  [SMALL_STATE(4670)] = 192834,
  [SMALL_STATE(4671)] = 192884,
  [SMALL_STATE(4672)] = 192952,
  [SMALL_STATE(4673)] = 193020,
  [SMALL_STATE(4674)] = 193078,
  [SMALL_STATE(4675)] = 193146,
  [SMALL_STATE(4676)] = 193214,
  [SMALL_STATE(4677)] = 193264,
  [SMALL_STATE(4678)] = 193332,
  [SMALL_STATE(4679)] = 193400,
  [SMALL_STATE(4680)] = 193468,
  [SMALL_STATE(4681)] = 193536,
  [SMALL_STATE(4682)] = 193590,
  [SMALL_STATE(4683)] = 193654,
  [SMALL_STATE(4684)] = 193722,
  [SMALL_STATE(4685)] = 193787,
  [SMALL_STATE(4686)] = 193838,
  [SMALL_STATE(4687)] = 193903,
  [SMALL_STATE(4688)] = 193968,
  [SMALL_STATE(4689)] = 194033,
  [SMALL_STATE(4690)] = 194094,
  [SMALL_STATE(4691)] = 194159,
  [SMALL_STATE(4692)] = 194224,
  [SMALL_STATE(4693)] = 194289,
  [SMALL_STATE(4694)] = 194354,
  [SMALL_STATE(4695)] = 194419,
  [SMALL_STATE(4696)] = 194486,
  [SMALL_STATE(4697)] = 194548,
  [SMALL_STATE(4698)] = 194610,
  [SMALL_STATE(4699)] = 194674,
  [SMALL_STATE(4700)] = 194738,
  [SMALL_STATE(4701)] = 194800,
  [SMALL_STATE(4702)] = 194862,
  [SMALL_STATE(4703)] = 194926,
  [SMALL_STATE(4704)] = 194988,
  [SMALL_STATE(4705)] = 195040,
  [SMALL_STATE(4706)] = 195102,
  [SMALL_STATE(4707)] = 195166,
  [SMALL_STATE(4708)] = 195218,
  [SMALL_STATE(4709)] = 195270,
  [SMALL_STATE(4710)] = 195332,
  [SMALL_STATE(4711)] = 195394,
  [SMALL_STATE(4712)] = 195456,
  [SMALL_STATE(4713)] = 195512,
  [SMALL_STATE(4714)] = 195576,
  [SMALL_STATE(4715)] = 195626,
  [SMALL_STATE(4716)] = 195682,
  [SMALL_STATE(4717)] = 195744,
  [SMALL_STATE(4718)] = 195808,
  [SMALL_STATE(4719)] = 195867,
  [SMALL_STATE(4720)] = 195928,
  [SMALL_STATE(4721)] = 195981,
  [SMALL_STATE(4722)] = 196040,
  [SMALL_STATE(4723)] = 196101,
  [SMALL_STATE(4724)] = 196156,
  [SMALL_STATE(4725)] = 196215,
  [SMALL_STATE(4726)] = 196276,
  [SMALL_STATE(4727)] = 196337,
  [SMALL_STATE(4728)] = 196396,
  [SMALL_STATE(4729)] = 196455,
  [SMALL_STATE(4730)] = 196514,
  [SMALL_STATE(4731)] = 196573,
  [SMALL_STATE(4732)] = 196632,
  [SMALL_STATE(4733)] = 196693,
  [SMALL_STATE(4734)] = 196752,
  [SMALL_STATE(4735)] = 196807,
  [SMALL_STATE(4736)] = 196866,
  [SMALL_STATE(4737)] = 196925,
  [SMALL_STATE(4738)] = 196986,
  [SMALL_STATE(4739)] = 197047,
  [SMALL_STATE(4740)] = 197106,
  [SMALL_STATE(4741)] = 197159,
  [SMALL_STATE(4742)] = 197217,
  [SMALL_STATE(4743)] = 197273,
  [SMALL_STATE(4744)] = 197331,
  [SMALL_STATE(4745)] = 197383,
  [SMALL_STATE(4746)] = 197441,
  [SMALL_STATE(4747)] = 197499,
  [SMALL_STATE(4748)] = 197557,
  [SMALL_STATE(4749)] = 197613,
  [SMALL_STATE(4750)] = 197671,
  [SMALL_STATE(4751)] = 197729,
  [SMALL_STATE(4752)] = 197787,
  [SMALL_STATE(4753)] = 197843,
  [SMALL_STATE(4754)] = 197899,
  [SMALL_STATE(4755)] = 197957,
  [SMALL_STATE(4756)] = 198013,
  [SMALL_STATE(4757)] = 198069,
  [SMALL_STATE(4758)] = 198125,
  [SMALL_STATE(4759)] = 198181,
  [SMALL_STATE(4760)] = 198237,
  [SMALL_STATE(4761)] = 198295,
  [SMALL_STATE(4762)] = 198351,
  [SMALL_STATE(4763)] = 198407,
  [SMALL_STATE(4764)] = 198463,
  [SMALL_STATE(4765)] = 198521,
  [SMALL_STATE(4766)] = 198579,
  [SMALL_STATE(4767)] = 198637,
  [SMALL_STATE(4768)] = 198693,
  [SMALL_STATE(4769)] = 198749,
  [SMALL_STATE(4770)] = 198801,
  [SMALL_STATE(4771)] = 198859,
  [SMALL_STATE(4772)] = 198917,
  [SMALL_STATE(4773)] = 198973,
  [SMALL_STATE(4774)] = 199029,
  [SMALL_STATE(4775)] = 199087,
  [SMALL_STATE(4776)] = 199143,
  [SMALL_STATE(4777)] = 199199,
  [SMALL_STATE(4778)] = 199257,
  [SMALL_STATE(4779)] = 199313,
  [SMALL_STATE(4780)] = 199369,
  [SMALL_STATE(4781)] = 199427,
  [SMALL_STATE(4782)] = 199479,
  [SMALL_STATE(4783)] = 199535,
  [SMALL_STATE(4784)] = 199587,
  [SMALL_STATE(4785)] = 199645,
  [SMALL_STATE(4786)] = 199703,
  [SMALL_STATE(4787)] = 199759,
  [SMALL_STATE(4788)] = 199817,
  [SMALL_STATE(4789)] = 199873,
  [SMALL_STATE(4790)] = 199931,
  [SMALL_STATE(4791)] = 199987,
  [SMALL_STATE(4792)] = 200045,
  [SMALL_STATE(4793)] = 200101,
  [SMALL_STATE(4794)] = 200159,
  [SMALL_STATE(4795)] = 200217,
  [SMALL_STATE(4796)] = 200275,
  [SMALL_STATE(4797)] = 200333,
  [SMALL_STATE(4798)] = 200391,
  [SMALL_STATE(4799)] = 200449,
  [SMALL_STATE(4800)] = 200505,
  [SMALL_STATE(4801)] = 200563,
  [SMALL_STATE(4802)] = 200615,
  [SMALL_STATE(4803)] = 200671,
  [SMALL_STATE(4804)] = 200727,
  [SMALL_STATE(4805)] = 200783,
  [SMALL_STATE(4806)] = 200841,
  [SMALL_STATE(4807)] = 200897,
  [SMALL_STATE(4808)] = 200953,
  [SMALL_STATE(4809)] = 201011,
  [SMALL_STATE(4810)] = 201069,
  [SMALL_STATE(4811)] = 201127,
  [SMALL_STATE(4812)] = 201185,
  [SMALL_STATE(4813)] = 201243,
  [SMALL_STATE(4814)] = 201299,
  [SMALL_STATE(4815)] = 201357,
  [SMALL_STATE(4816)] = 201413,
  [SMALL_STATE(4817)] = 201469,
  [SMALL_STATE(4818)] = 201525,
  [SMALL_STATE(4819)] = 201581,
  [SMALL_STATE(4820)] = 201639,
  [SMALL_STATE(4821)] = 201697,
  [SMALL_STATE(4822)] = 201747,
  [SMALL_STATE(4823)] = 201803,
  [SMALL_STATE(4824)] = 201861,
  [SMALL_STATE(4825)] = 201917,
  [SMALL_STATE(4826)] = 201975,
  [SMALL_STATE(4827)] = 202033,
  [SMALL_STATE(4828)] = 202085,
  [SMALL_STATE(4829)] = 202143,
  [SMALL_STATE(4830)] = 202199,
  [SMALL_STATE(4831)] = 202254,
  [SMALL_STATE(4832)] = 202309,
  [SMALL_STATE(4833)] = 202364,
  [SMALL_STATE(4834)] = 202419,
  [SMALL_STATE(4835)] = 202474,
  [SMALL_STATE(4836)] = 202529,
  [SMALL_STATE(4837)] = 202584,
  [SMALL_STATE(4838)] = 202639,
  [SMALL_STATE(4839)] = 202694,
  [SMALL_STATE(4840)] = 202749,
  [SMALL_STATE(4841)] = 202804,
  [SMALL_STATE(4842)] = 202859,
  [SMALL_STATE(4843)] = 202914,
  [SMALL_STATE(4844)] = 202969,
  [SMALL_STATE(4845)] = 203024,
  [SMALL_STATE(4846)] = 203079,
  [SMALL_STATE(4847)] = 203134,
  [SMALL_STATE(4848)] = 203189,
  [SMALL_STATE(4849)] = 203244,
  [SMALL_STATE(4850)] = 203299,
  [SMALL_STATE(4851)] = 203350,
  [SMALL_STATE(4852)] = 203405,
  [SMALL_STATE(4853)] = 203460,
  [SMALL_STATE(4854)] = 203515,
  [SMALL_STATE(4855)] = 203570,
  [SMALL_STATE(4856)] = 203625,
  [SMALL_STATE(4857)] = 203680,
  [SMALL_STATE(4858)] = 203735,
  [SMALL_STATE(4859)] = 203790,
  [SMALL_STATE(4860)] = 203845,
  [SMALL_STATE(4861)] = 203900,
  [SMALL_STATE(4862)] = 203955,
  [SMALL_STATE(4863)] = 204010,
  [SMALL_STATE(4864)] = 204065,
  [SMALL_STATE(4865)] = 204120,
  [SMALL_STATE(4866)] = 204175,
  [SMALL_STATE(4867)] = 204230,
  [SMALL_STATE(4868)] = 204285,
  [SMALL_STATE(4869)] = 204340,
  [SMALL_STATE(4870)] = 204395,
  [SMALL_STATE(4871)] = 204448,
  [SMALL_STATE(4872)] = 204503,
  [SMALL_STATE(4873)] = 204558,
  [SMALL_STATE(4874)] = 204613,
  [SMALL_STATE(4875)] = 204668,
  [SMALL_STATE(4876)] = 204723,
  [SMALL_STATE(4877)] = 204778,
  [SMALL_STATE(4878)] = 204833,
  [SMALL_STATE(4879)] = 204888,
  [SMALL_STATE(4880)] = 204943,
  [SMALL_STATE(4881)] = 204998,
  [SMALL_STATE(4882)] = 205051,
  [SMALL_STATE(4883)] = 205106,
  [SMALL_STATE(4884)] = 205161,
  [SMALL_STATE(4885)] = 205216,
  [SMALL_STATE(4886)] = 205271,
  [SMALL_STATE(4887)] = 205326,
  [SMALL_STATE(4888)] = 205373,
  [SMALL_STATE(4889)] = 205428,
  [SMALL_STATE(4890)] = 205483,
  [SMALL_STATE(4891)] = 205538,
  [SMALL_STATE(4892)] = 205593,
  [SMALL_STATE(4893)] = 205648,
  [SMALL_STATE(4894)] = 205703,
  [SMALL_STATE(4895)] = 205758,
  [SMALL_STATE(4896)] = 205813,
  [SMALL_STATE(4897)] = 205868,
  [SMALL_STATE(4898)] = 205923,
  [SMALL_STATE(4899)] = 205978,
  [SMALL_STATE(4900)] = 206033,
  [SMALL_STATE(4901)] = 206088,
  [SMALL_STATE(4902)] = 206141,
  [SMALL_STATE(4903)] = 206196,
  [SMALL_STATE(4904)] = 206251,
  [SMALL_STATE(4905)] = 206306,
  [SMALL_STATE(4906)] = 206361,
  [SMALL_STATE(4907)] = 206416,
  [SMALL_STATE(4908)] = 206471,
  [SMALL_STATE(4909)] = 206524,
  [SMALL_STATE(4910)] = 206579,
  [SMALL_STATE(4911)] = 206634,
  [SMALL_STATE(4912)] = 206687,
  [SMALL_STATE(4913)] = 206742,
  [SMALL_STATE(4914)] = 206797,
  [SMALL_STATE(4915)] = 206852,
  [SMALL_STATE(4916)] = 206907,
  [SMALL_STATE(4917)] = 206962,
  [SMALL_STATE(4918)] = 207017,
  [SMALL_STATE(4919)] = 207072,
  [SMALL_STATE(4920)] = 207127,
  [SMALL_STATE(4921)] = 207182,
  [SMALL_STATE(4922)] = 207237,
  [SMALL_STATE(4923)] = 207292,
  [SMALL_STATE(4924)] = 207347,
  [SMALL_STATE(4925)] = 207402,
  [SMALL_STATE(4926)] = 207457,
  [SMALL_STATE(4927)] = 207512,
  [SMALL_STATE(4928)] = 207567,
  [SMALL_STATE(4929)] = 207622,
  [SMALL_STATE(4930)] = 207677,
  [SMALL_STATE(4931)] = 207732,
  [SMALL_STATE(4932)] = 207787,
  [SMALL_STATE(4933)] = 207842,
  [SMALL_STATE(4934)] = 207897,
  [SMALL_STATE(4935)] = 207952,
  [SMALL_STATE(4936)] = 208007,
  [SMALL_STATE(4937)] = 208056,
  [SMALL_STATE(4938)] = 208111,
  [SMALL_STATE(4939)] = 208166,
  [SMALL_STATE(4940)] = 208221,
  [SMALL_STATE(4941)] = 208276,
  [SMALL_STATE(4942)] = 208331,
  [SMALL_STATE(4943)] = 208386,
  [SMALL_STATE(4944)] = 208441,
  [SMALL_STATE(4945)] = 208496,
  [SMALL_STATE(4946)] = 208551,
  [SMALL_STATE(4947)] = 208602,
  [SMALL_STATE(4948)] = 208657,
  [SMALL_STATE(4949)] = 208712,
  [SMALL_STATE(4950)] = 208767,
  [SMALL_STATE(4951)] = 208822,
  [SMALL_STATE(4952)] = 208877,
  [SMALL_STATE(4953)] = 208932,
  [SMALL_STATE(4954)] = 208987,
  [SMALL_STATE(4955)] = 209042,
  [SMALL_STATE(4956)] = 209097,
  [SMALL_STATE(4957)] = 209147,
  [SMALL_STATE(4958)] = 209197,
  [SMALL_STATE(4959)] = 209263,
  [SMALL_STATE(4960)] = 209313,
  [SMALL_STATE(4961)] = 209363,
  [SMALL_STATE(4962)] = 209413,
  [SMALL_STATE(4963)] = 209463,
  [SMALL_STATE(4964)] = 209513,
  [SMALL_STATE(4965)] = 209563,
  [SMALL_STATE(4966)] = 209613,
  [SMALL_STATE(4967)] = 209663,
  [SMALL_STATE(4968)] = 209713,
  [SMALL_STATE(4969)] = 209763,
  [SMALL_STATE(4970)] = 209813,
  [SMALL_STATE(4971)] = 209863,
  [SMALL_STATE(4972)] = 209913,
  [SMALL_STATE(4973)] = 209963,
  [SMALL_STATE(4974)] = 210013,
  [SMALL_STATE(4975)] = 210063,
  [SMALL_STATE(4976)] = 210113,
  [SMALL_STATE(4977)] = 210163,
  [SMALL_STATE(4978)] = 210213,
  [SMALL_STATE(4979)] = 210263,
  [SMALL_STATE(4980)] = 210313,
  [SMALL_STATE(4981)] = 210363,
  [SMALL_STATE(4982)] = 210413,
  [SMALL_STATE(4983)] = 210463,
  [SMALL_STATE(4984)] = 210513,
  [SMALL_STATE(4985)] = 210563,
  [SMALL_STATE(4986)] = 210613,
  [SMALL_STATE(4987)] = 210663,
  [SMALL_STATE(4988)] = 210713,
  [SMALL_STATE(4989)] = 210763,
  [SMALL_STATE(4990)] = 210813,
  [SMALL_STATE(4991)] = 210863,
  [SMALL_STATE(4992)] = 210913,
  [SMALL_STATE(4993)] = 210963,
  [SMALL_STATE(4994)] = 211015,
  [SMALL_STATE(4995)] = 211067,
  [SMALL_STATE(4996)] = 211117,
  [SMALL_STATE(4997)] = 211167,
  [SMALL_STATE(4998)] = 211217,
  [SMALL_STATE(4999)] = 211267,
  [SMALL_STATE(5000)] = 211317,
  [SMALL_STATE(5001)] = 211367,
  [SMALL_STATE(5002)] = 211417,
  [SMALL_STATE(5003)] = 211467,
  [SMALL_STATE(5004)] = 211517,
  [SMALL_STATE(5005)] = 211567,
  [SMALL_STATE(5006)] = 211617,
  [SMALL_STATE(5007)] = 211667,
  [SMALL_STATE(5008)] = 211717,
  [SMALL_STATE(5009)] = 211767,
  [SMALL_STATE(5010)] = 211817,
  [SMALL_STATE(5011)] = 211867,
  [SMALL_STATE(5012)] = 211917,
  [SMALL_STATE(5013)] = 211967,
  [SMALL_STATE(5014)] = 212017,
  [SMALL_STATE(5015)] = 212067,
  [SMALL_STATE(5016)] = 212117,
  [SMALL_STATE(5017)] = 212167,
  [SMALL_STATE(5018)] = 212217,
  [SMALL_STATE(5019)] = 212267,
  [SMALL_STATE(5020)] = 212317,
  [SMALL_STATE(5021)] = 212367,
  [SMALL_STATE(5022)] = 212417,
  [SMALL_STATE(5023)] = 212467,
  [SMALL_STATE(5024)] = 212517,
  [SMALL_STATE(5025)] = 212567,
  [SMALL_STATE(5026)] = 212617,
  [SMALL_STATE(5027)] = 212667,
  [SMALL_STATE(5028)] = 212717,
  [SMALL_STATE(5029)] = 212767,
  [SMALL_STATE(5030)] = 212817,
  [SMALL_STATE(5031)] = 212867,
  [SMALL_STATE(5032)] = 212917,
  [SMALL_STATE(5033)] = 212967,
  [SMALL_STATE(5034)] = 213017,
  [SMALL_STATE(5035)] = 213069,
  [SMALL_STATE(5036)] = 213119,
  [SMALL_STATE(5037)] = 213169,
  [SMALL_STATE(5038)] = 213219,
  [SMALL_STATE(5039)] = 213262,
  [SMALL_STATE(5040)] = 213305,
  [SMALL_STATE(5041)] = 213348,
  [SMALL_STATE(5042)] = 213391,
  [SMALL_STATE(5043)] = 213434,
  [SMALL_STATE(5044)] = 213477,
  [SMALL_STATE(5045)] = 213520,
  [SMALL_STATE(5046)] = 213563,
  [SMALL_STATE(5047)] = 213606,
  [SMALL_STATE(5048)] = 213649,
  [SMALL_STATE(5049)] = 213692,
  [SMALL_STATE(5050)] = 213735,
  [SMALL_STATE(5051)] = 213778,
  [SMALL_STATE(5052)] = 213821,
  [SMALL_STATE(5053)] = 213864,
  [SMALL_STATE(5054)] = 213907,
  [SMALL_STATE(5055)] = 213950,
  [SMALL_STATE(5056)] = 213993,
  [SMALL_STATE(5057)] = 214036,
  [SMALL_STATE(5058)] = 214079,
  [SMALL_STATE(5059)] = 214122,
  [SMALL_STATE(5060)] = 214165,
  [SMALL_STATE(5061)] = 214208,
  [SMALL_STATE(5062)] = 214251,
  [SMALL_STATE(5063)] = 214294,
  [SMALL_STATE(5064)] = 214337,
  [SMALL_STATE(5065)] = 214380,
  [SMALL_STATE(5066)] = 214421,
  [SMALL_STATE(5067)] = 214470,
  [SMALL_STATE(5068)] = 214513,
  [SMALL_STATE(5069)] = 214556,
  [SMALL_STATE(5070)] = 214605,
  [SMALL_STATE(5071)] = 214646,
  [SMALL_STATE(5072)] = 214687,
  [SMALL_STATE(5073)] = 214736,
  [SMALL_STATE(5074)] = 214779,
  [SMALL_STATE(5075)] = 214828,
  [SMALL_STATE(5076)] = 214877,
  [SMALL_STATE(5077)] = 214920,
  [SMALL_STATE(5078)] = 214963,
  [SMALL_STATE(5079)] = 215006,
  [SMALL_STATE(5080)] = 215049,
  [SMALL_STATE(5081)] = 215098,
  [SMALL_STATE(5082)] = 215141,
  [SMALL_STATE(5083)] = 215184,
  [SMALL_STATE(5084)] = 215227,
  [SMALL_STATE(5085)] = 215270,
  [SMALL_STATE(5086)] = 215313,
  [SMALL_STATE(5087)] = 215356,
  [SMALL_STATE(5088)] = 215399,
  [SMALL_STATE(5089)] = 215442,
  [SMALL_STATE(5090)] = 215485,
  [SMALL_STATE(5091)] = 215528,
  [SMALL_STATE(5092)] = 215571,
  [SMALL_STATE(5093)] = 215614,
  [SMALL_STATE(5094)] = 215663,
  [SMALL_STATE(5095)] = 215706,
  [SMALL_STATE(5096)] = 215749,
  [SMALL_STATE(5097)] = 215792,
  [SMALL_STATE(5098)] = 215835,
  [SMALL_STATE(5099)] = 215878,
  [SMALL_STATE(5100)] = 215927,
  [SMALL_STATE(5101)] = 215970,
  [SMALL_STATE(5102)] = 216019,
  [SMALL_STATE(5103)] = 216062,
  [SMALL_STATE(5104)] = 216105,
  [SMALL_STATE(5105)] = 216148,
  [SMALL_STATE(5106)] = 216197,
  [SMALL_STATE(5107)] = 216240,
  [SMALL_STATE(5108)] = 216283,
  [SMALL_STATE(5109)] = 216326,
  [SMALL_STATE(5110)] = 216367,
  [SMALL_STATE(5111)] = 216410,
  [SMALL_STATE(5112)] = 216453,
  [SMALL_STATE(5113)] = 216496,
  [SMALL_STATE(5114)] = 216539,
  [SMALL_STATE(5115)] = 216580,
  [SMALL_STATE(5116)] = 216623,
  [SMALL_STATE(5117)] = 216666,
  [SMALL_STATE(5118)] = 216709,
  [SMALL_STATE(5119)] = 216752,
  [SMALL_STATE(5120)] = 216795,
  [SMALL_STATE(5121)] = 216838,
  [SMALL_STATE(5122)] = 216887,
  [SMALL_STATE(5123)] = 216930,
  [SMALL_STATE(5124)] = 216973,
  [SMALL_STATE(5125)] = 217016,
  [SMALL_STATE(5126)] = 217059,
  [SMALL_STATE(5127)] = 217102,
  [SMALL_STATE(5128)] = 217145,
  [SMALL_STATE(5129)] = 217188,
  [SMALL_STATE(5130)] = 217231,
  [SMALL_STATE(5131)] = 217274,
  [SMALL_STATE(5132)] = 217317,
  [SMALL_STATE(5133)] = 217360,
  [SMALL_STATE(5134)] = 217403,
  [SMALL_STATE(5135)] = 217446,
  [SMALL_STATE(5136)] = 217489,
  [SMALL_STATE(5137)] = 217530,
  [SMALL_STATE(5138)] = 217579,
  [SMALL_STATE(5139)] = 217628,
  [SMALL_STATE(5140)] = 217671,
  [SMALL_STATE(5141)] = 217714,
  [SMALL_STATE(5142)] = 217754,
  [SMALL_STATE(5143)] = 217794,
  [SMALL_STATE(5144)] = 217834,
  [SMALL_STATE(5145)] = 217874,
  [SMALL_STATE(5146)] = 217914,
  [SMALL_STATE(5147)] = 217954,
  [SMALL_STATE(5148)] = 217994,
  [SMALL_STATE(5149)] = 218034,
  [SMALL_STATE(5150)] = 218074,
  [SMALL_STATE(5151)] = 218114,
  [SMALL_STATE(5152)] = 218160,
  [SMALL_STATE(5153)] = 218200,
  [SMALL_STATE(5154)] = 218240,
  [SMALL_STATE(5155)] = 218280,
  [SMALL_STATE(5156)] = 218320,
  [SMALL_STATE(5157)] = 218366,
  [SMALL_STATE(5158)] = 218412,
  [SMALL_STATE(5159)] = 218458,
  [SMALL_STATE(5160)] = 218498,
  [SMALL_STATE(5161)] = 218538,
  [SMALL_STATE(5162)] = 218578,
  [SMALL_STATE(5163)] = 218618,
  [SMALL_STATE(5164)] = 218658,
  [SMALL_STATE(5165)] = 218704,
  [SMALL_STATE(5166)] = 218744,
  [SMALL_STATE(5167)] = 218790,
  [SMALL_STATE(5168)] = 218836,
  [SMALL_STATE(5169)] = 218882,
  [SMALL_STATE(5170)] = 218922,
  [SMALL_STATE(5171)] = 218962,
  [SMALL_STATE(5172)] = 219002,
  [SMALL_STATE(5173)] = 219042,
  [SMALL_STATE(5174)] = 219082,
  [SMALL_STATE(5175)] = 219128,
  [SMALL_STATE(5176)] = 219168,
  [SMALL_STATE(5177)] = 219208,
  [SMALL_STATE(5178)] = 219254,
  [SMALL_STATE(5179)] = 219294,
  [SMALL_STATE(5180)] = 219334,
  [SMALL_STATE(5181)] = 219374,
  [SMALL_STATE(5182)] = 219414,
  [SMALL_STATE(5183)] = 219454,
  [SMALL_STATE(5184)] = 219494,
  [SMALL_STATE(5185)] = 219540,
  [SMALL_STATE(5186)] = 219580,
  [SMALL_STATE(5187)] = 219620,
  [SMALL_STATE(5188)] = 219660,
  [SMALL_STATE(5189)] = 219700,
  [SMALL_STATE(5190)] = 219740,
  [SMALL_STATE(5191)] = 219780,
  [SMALL_STATE(5192)] = 219820,
  [SMALL_STATE(5193)] = 219860,
  [SMALL_STATE(5194)] = 219900,
  [SMALL_STATE(5195)] = 219940,
  [SMALL_STATE(5196)] = 219980,
  [SMALL_STATE(5197)] = 220020,
  [SMALL_STATE(5198)] = 220060,
  [SMALL_STATE(5199)] = 220100,
  [SMALL_STATE(5200)] = 220140,
  [SMALL_STATE(5201)] = 220180,
  [SMALL_STATE(5202)] = 220220,
  [SMALL_STATE(5203)] = 220260,
  [SMALL_STATE(5204)] = 220300,
  [SMALL_STATE(5205)] = 220340,
  [SMALL_STATE(5206)] = 220380,
  [SMALL_STATE(5207)] = 220420,
  [SMALL_STATE(5208)] = 220460,
  [SMALL_STATE(5209)] = 220500,
  [SMALL_STATE(5210)] = 220540,
  [SMALL_STATE(5211)] = 220580,
  [SMALL_STATE(5212)] = 220620,
  [SMALL_STATE(5213)] = 220666,
  [SMALL_STATE(5214)] = 220706,
  [SMALL_STATE(5215)] = 220746,
  [SMALL_STATE(5216)] = 220786,
  [SMALL_STATE(5217)] = 220832,
  [SMALL_STATE(5218)] = 220878,
  [SMALL_STATE(5219)] = 220918,
  [SMALL_STATE(5220)] = 220958,
  [SMALL_STATE(5221)] = 221004,
  [SMALL_STATE(5222)] = 221044,
  [SMALL_STATE(5223)] = 221084,
  [SMALL_STATE(5224)] = 221130,
  [SMALL_STATE(5225)] = 221176,
  [SMALL_STATE(5226)] = 221216,
  [SMALL_STATE(5227)] = 221256,
  [SMALL_STATE(5228)] = 221296,
  [SMALL_STATE(5229)] = 221342,
  [SMALL_STATE(5230)] = 221388,
  [SMALL_STATE(5231)] = 221428,
  [SMALL_STATE(5232)] = 221468,
  [SMALL_STATE(5233)] = 221508,
  [SMALL_STATE(5234)] = 221548,
  [SMALL_STATE(5235)] = 221594,
  [SMALL_STATE(5236)] = 221634,
  [SMALL_STATE(5237)] = 221674,
  [SMALL_STATE(5238)] = 221714,
  [SMALL_STATE(5239)] = 221754,
  [SMALL_STATE(5240)] = 221794,
  [SMALL_STATE(5241)] = 221834,
  [SMALL_STATE(5242)] = 221874,
  [SMALL_STATE(5243)] = 221914,
  [SMALL_STATE(5244)] = 221960,
  [SMALL_STATE(5245)] = 222006,
  [SMALL_STATE(5246)] = 222046,
  [SMALL_STATE(5247)] = 222086,
  [SMALL_STATE(5248)] = 222126,
  [SMALL_STATE(5249)] = 222166,
  [SMALL_STATE(5250)] = 222206,
  [SMALL_STATE(5251)] = 222246,
  [SMALL_STATE(5252)] = 222286,
  [SMALL_STATE(5253)] = 222326,
  [SMALL_STATE(5254)] = 222366,
  [SMALL_STATE(5255)] = 222412,
  [SMALL_STATE(5256)] = 222458,
  [SMALL_STATE(5257)] = 222504,
  [SMALL_STATE(5258)] = 222544,
  [SMALL_STATE(5259)] = 222584,
  [SMALL_STATE(5260)] = 222630,
  [SMALL_STATE(5261)] = 222670,
  [SMALL_STATE(5262)] = 222710,
  [SMALL_STATE(5263)] = 222750,
  [SMALL_STATE(5264)] = 222796,
  [SMALL_STATE(5265)] = 222836,
  [SMALL_STATE(5266)] = 222882,
  [SMALL_STATE(5267)] = 222928,
  [SMALL_STATE(5268)] = 222968,
  [SMALL_STATE(5269)] = 223008,
  [SMALL_STATE(5270)] = 223048,
  [SMALL_STATE(5271)] = 223088,
  [SMALL_STATE(5272)] = 223128,
  [SMALL_STATE(5273)] = 223168,
  [SMALL_STATE(5274)] = 223208,
  [SMALL_STATE(5275)] = 223248,
  [SMALL_STATE(5276)] = 223288,
  [SMALL_STATE(5277)] = 223334,
  [SMALL_STATE(5278)] = 223374,
  [SMALL_STATE(5279)] = 223414,
  [SMALL_STATE(5280)] = 223454,
  [SMALL_STATE(5281)] = 223500,
  [SMALL_STATE(5282)] = 223540,
  [SMALL_STATE(5283)] = 223580,
  [SMALL_STATE(5284)] = 223620,
  [SMALL_STATE(5285)] = 223660,
  [SMALL_STATE(5286)] = 223706,
  [SMALL_STATE(5287)] = 223746,
  [SMALL_STATE(5288)] = 223792,
  [SMALL_STATE(5289)] = 223832,
  [SMALL_STATE(5290)] = 223878,
  [SMALL_STATE(5291)] = 223918,
  [SMALL_STATE(5292)] = 223958,
  [SMALL_STATE(5293)] = 224004,
  [SMALL_STATE(5294)] = 224044,
  [SMALL_STATE(5295)] = 224090,
  [SMALL_STATE(5296)] = 224130,
  [SMALL_STATE(5297)] = 224176,
  [SMALL_STATE(5298)] = 224216,
  [SMALL_STATE(5299)] = 224262,
  [SMALL_STATE(5300)] = 224302,
  [SMALL_STATE(5301)] = 224348,
  [SMALL_STATE(5302)] = 224394,
  [SMALL_STATE(5303)] = 224434,
  [SMALL_STATE(5304)] = 224474,
  [SMALL_STATE(5305)] = 224514,
  [SMALL_STATE(5306)] = 224554,
  [SMALL_STATE(5307)] = 224594,
  [SMALL_STATE(5308)] = 224640,
  [SMALL_STATE(5309)] = 224686,
  [SMALL_STATE(5310)] = 224732,
  [SMALL_STATE(5311)] = 224778,
  [SMALL_STATE(5312)] = 224818,
  [SMALL_STATE(5313)] = 224858,
  [SMALL_STATE(5314)] = 224904,
  [SMALL_STATE(5315)] = 224950,
  [SMALL_STATE(5316)] = 224990,
  [SMALL_STATE(5317)] = 225030,
  [SMALL_STATE(5318)] = 225070,
  [SMALL_STATE(5319)] = 225116,
  [SMALL_STATE(5320)] = 225162,
  [SMALL_STATE(5321)] = 225208,
  [SMALL_STATE(5322)] = 225254,
  [SMALL_STATE(5323)] = 225300,
  [SMALL_STATE(5324)] = 225340,
  [SMALL_STATE(5325)] = 225380,
  [SMALL_STATE(5326)] = 225420,
  [SMALL_STATE(5327)] = 225466,
  [SMALL_STATE(5328)] = 225506,
  [SMALL_STATE(5329)] = 225546,
  [SMALL_STATE(5330)] = 225586,
  [SMALL_STATE(5331)] = 225626,
  [SMALL_STATE(5332)] = 225672,
  [SMALL_STATE(5333)] = 225718,
  [SMALL_STATE(5334)] = 225764,
  [SMALL_STATE(5335)] = 225810,
  [SMALL_STATE(5336)] = 225856,
  [SMALL_STATE(5337)] = 225902,
  [SMALL_STATE(5338)] = 225942,
  [SMALL_STATE(5339)] = 225988,
  [SMALL_STATE(5340)] = 226034,
  [SMALL_STATE(5341)] = 226080,
  [SMALL_STATE(5342)] = 226126,
  [SMALL_STATE(5343)] = 226172,
  [SMALL_STATE(5344)] = 226218,
  [SMALL_STATE(5345)] = 226258,
  [SMALL_STATE(5346)] = 226298,
  [SMALL_STATE(5347)] = 226344,
  [SMALL_STATE(5348)] = 226390,
  [SMALL_STATE(5349)] = 226436,
  [SMALL_STATE(5350)] = 226476,
  [SMALL_STATE(5351)] = 226516,
  [SMALL_STATE(5352)] = 226556,
  [SMALL_STATE(5353)] = 226596,
  [SMALL_STATE(5354)] = 226636,
  [SMALL_STATE(5355)] = 226676,
  [SMALL_STATE(5356)] = 226716,
  [SMALL_STATE(5357)] = 226762,
  [SMALL_STATE(5358)] = 226802,
  [SMALL_STATE(5359)] = 226842,
  [SMALL_STATE(5360)] = 226888,
  [SMALL_STATE(5361)] = 226928,
  [SMALL_STATE(5362)] = 226968,
  [SMALL_STATE(5363)] = 227008,
  [SMALL_STATE(5364)] = 227048,
  [SMALL_STATE(5365)] = 227088,
  [SMALL_STATE(5366)] = 227128,
  [SMALL_STATE(5367)] = 227168,
  [SMALL_STATE(5368)] = 227208,
  [SMALL_STATE(5369)] = 227248,
  [SMALL_STATE(5370)] = 227288,
  [SMALL_STATE(5371)] = 227328,
  [SMALL_STATE(5372)] = 227374,
  [SMALL_STATE(5373)] = 227414,
  [SMALL_STATE(5374)] = 227454,
  [SMALL_STATE(5375)] = 227494,
  [SMALL_STATE(5376)] = 227540,
  [SMALL_STATE(5377)] = 227580,
  [SMALL_STATE(5378)] = 227620,
  [SMALL_STATE(5379)] = 227666,
  [SMALL_STATE(5380)] = 227706,
  [SMALL_STATE(5381)] = 227746,
  [SMALL_STATE(5382)] = 227792,
  [SMALL_STATE(5383)] = 227838,
  [SMALL_STATE(5384)] = 227878,
  [SMALL_STATE(5385)] = 227924,
  [SMALL_STATE(5386)] = 227964,
  [SMALL_STATE(5387)] = 228004,
  [SMALL_STATE(5388)] = 228044,
  [SMALL_STATE(5389)] = 228090,
  [SMALL_STATE(5390)] = 228130,
  [SMALL_STATE(5391)] = 228170,
  [SMALL_STATE(5392)] = 228210,
  [SMALL_STATE(5393)] = 228256,
  [SMALL_STATE(5394)] = 228296,
  [SMALL_STATE(5395)] = 228342,
  [SMALL_STATE(5396)] = 228382,
  [SMALL_STATE(5397)] = 228428,
  [SMALL_STATE(5398)] = 228468,
  [SMALL_STATE(5399)] = 228514,
  [SMALL_STATE(5400)] = 228554,
  [SMALL_STATE(5401)] = 228594,
  [SMALL_STATE(5402)] = 228640,
  [SMALL_STATE(5403)] = 228680,
  [SMALL_STATE(5404)] = 228726,
  [SMALL_STATE(5405)] = 228766,
  [SMALL_STATE(5406)] = 228806,
  [SMALL_STATE(5407)] = 228846,
  [SMALL_STATE(5408)] = 228886,
  [SMALL_STATE(5409)] = 228926,
  [SMALL_STATE(5410)] = 228972,
  [SMALL_STATE(5411)] = 229012,
  [SMALL_STATE(5412)] = 229052,
  [SMALL_STATE(5413)] = 229098,
  [SMALL_STATE(5414)] = 229144,
  [SMALL_STATE(5415)] = 229184,
  [SMALL_STATE(5416)] = 229230,
  [SMALL_STATE(5417)] = 229276,
  [SMALL_STATE(5418)] = 229316,
  [SMALL_STATE(5419)] = 229362,
  [SMALL_STATE(5420)] = 229408,
  [SMALL_STATE(5421)] = 229454,
  [SMALL_STATE(5422)] = 229500,
  [SMALL_STATE(5423)] = 229546,
  [SMALL_STATE(5424)] = 229592,
  [SMALL_STATE(5425)] = 229638,
  [SMALL_STATE(5426)] = 229678,
  [SMALL_STATE(5427)] = 229717,
  [SMALL_STATE(5428)] = 229774,
  [SMALL_STATE(5429)] = 229831,
  [SMALL_STATE(5430)] = 229869,
  [SMALL_STATE(5431)] = 229907,
  [SMALL_STATE(5432)] = 229970,
  [SMALL_STATE(5433)] = 230009,
  [SMALL_STATE(5434)] = 230048,
  [SMALL_STATE(5435)] = 230087,
  [SMALL_STATE(5436)] = 230141,
  [SMALL_STATE(5437)] = 230195,
  [SMALL_STATE(5438)] = 230249,
  [SMALL_STATE(5439)] = 230303,
  [SMALL_STATE(5440)] = 230357,
  [SMALL_STATE(5441)] = 230411,
  [SMALL_STATE(5442)] = 230465,
  [SMALL_STATE(5443)] = 230519,
  [SMALL_STATE(5444)] = 230573,
  [SMALL_STATE(5445)] = 230627,
  [SMALL_STATE(5446)] = 230681,
  [SMALL_STATE(5447)] = 230735,
  [SMALL_STATE(5448)] = 230789,
  [SMALL_STATE(5449)] = 230843,
  [SMALL_STATE(5450)] = 230897,
  [SMALL_STATE(5451)] = 230951,
  [SMALL_STATE(5452)] = 231005,
  [SMALL_STATE(5453)] = 231059,
  [SMALL_STATE(5454)] = 231113,
  [SMALL_STATE(5455)] = 231167,
  [SMALL_STATE(5456)] = 231221,
  [SMALL_STATE(5457)] = 231275,
  [SMALL_STATE(5458)] = 231329,
  [SMALL_STATE(5459)] = 231383,
  [SMALL_STATE(5460)] = 231437,
  [SMALL_STATE(5461)] = 231491,
  [SMALL_STATE(5462)] = 231545,
  [SMALL_STATE(5463)] = 231599,
  [SMALL_STATE(5464)] = 231653,
  [SMALL_STATE(5465)] = 231707,
  [SMALL_STATE(5466)] = 231761,
  [SMALL_STATE(5467)] = 231815,
  [SMALL_STATE(5468)] = 231869,
  [SMALL_STATE(5469)] = 231923,
  [SMALL_STATE(5470)] = 231977,
  [SMALL_STATE(5471)] = 232031,
  [SMALL_STATE(5472)] = 232085,
  [SMALL_STATE(5473)] = 232139,
  [SMALL_STATE(5474)] = 232193,
  [SMALL_STATE(5475)] = 232247,
  [SMALL_STATE(5476)] = 232301,
  [SMALL_STATE(5477)] = 232355,
  [SMALL_STATE(5478)] = 232409,
  [SMALL_STATE(5479)] = 232463,
  [SMALL_STATE(5480)] = 232517,
  [SMALL_STATE(5481)] = 232571,
  [SMALL_STATE(5482)] = 232625,
  [SMALL_STATE(5483)] = 232679,
  [SMALL_STATE(5484)] = 232733,
  [SMALL_STATE(5485)] = 232787,
  [SMALL_STATE(5486)] = 232841,
  [SMALL_STATE(5487)] = 232895,
  [SMALL_STATE(5488)] = 232949,
  [SMALL_STATE(5489)] = 233003,
  [SMALL_STATE(5490)] = 233057,
  [SMALL_STATE(5491)] = 233111,
  [SMALL_STATE(5492)] = 233165,
  [SMALL_STATE(5493)] = 233219,
  [SMALL_STATE(5494)] = 233273,
  [SMALL_STATE(5495)] = 233327,
  [SMALL_STATE(5496)] = 233381,
  [SMALL_STATE(5497)] = 233435,
  [SMALL_STATE(5498)] = 233489,
  [SMALL_STATE(5499)] = 233543,
  [SMALL_STATE(5500)] = 233597,
  [SMALL_STATE(5501)] = 233651,
  [SMALL_STATE(5502)] = 233705,
  [SMALL_STATE(5503)] = 233759,
  [SMALL_STATE(5504)] = 233810,
  [SMALL_STATE(5505)] = 233869,
  [SMALL_STATE(5506)] = 233920,
  [SMALL_STATE(5507)] = 233971,
  [SMALL_STATE(5508)] = 234022,
  [SMALL_STATE(5509)] = 234073,
  [SMALL_STATE(5510)] = 234124,
  [SMALL_STATE(5511)] = 234175,
  [SMALL_STATE(5512)] = 234226,
  [SMALL_STATE(5513)] = 234277,
  [SMALL_STATE(5514)] = 234328,
  [SMALL_STATE(5515)] = 234379,
  [SMALL_STATE(5516)] = 234430,
  [SMALL_STATE(5517)] = 234481,
  [SMALL_STATE(5518)] = 234540,
  [SMALL_STATE(5519)] = 234599,
  [SMALL_STATE(5520)] = 234650,
  [SMALL_STATE(5521)] = 234701,
  [SMALL_STATE(5522)] = 234752,
  [SMALL_STATE(5523)] = 234803,
  [SMALL_STATE(5524)] = 234854,
  [SMALL_STATE(5525)] = 234905,
  [SMALL_STATE(5526)] = 234956,
  [SMALL_STATE(5527)] = 235007,
  [SMALL_STATE(5528)] = 235058,
  [SMALL_STATE(5529)] = 235109,
  [SMALL_STATE(5530)] = 235160,
  [SMALL_STATE(5531)] = 235211,
  [SMALL_STATE(5532)] = 235262,
  [SMALL_STATE(5533)] = 235313,
  [SMALL_STATE(5534)] = 235364,
  [SMALL_STATE(5535)] = 235415,
  [SMALL_STATE(5536)] = 235466,
  [SMALL_STATE(5537)] = 235517,
  [SMALL_STATE(5538)] = 235568,
  [SMALL_STATE(5539)] = 235619,
  [SMALL_STATE(5540)] = 235670,
  [SMALL_STATE(5541)] = 235710,
  [SMALL_STATE(5542)] = 235759,
  [SMALL_STATE(5543)] = 235808,
  [SMALL_STATE(5544)] = 235857,
  [SMALL_STATE(5545)] = 235906,
  [SMALL_STATE(5546)] = 235955,
  [SMALL_STATE(5547)] = 236004,
  [SMALL_STATE(5548)] = 236053,
  [SMALL_STATE(5549)] = 236102,
  [SMALL_STATE(5550)] = 236151,
  [SMALL_STATE(5551)] = 236200,
  [SMALL_STATE(5552)] = 236249,
  [SMALL_STATE(5553)] = 236298,
  [SMALL_STATE(5554)] = 236344,
  [SMALL_STATE(5555)] = 236390,
  [SMALL_STATE(5556)] = 236436,
  [SMALL_STATE(5557)] = 236479,
  [SMALL_STATE(5558)] = 236522,
  [SMALL_STATE(5559)] = 236565,
  [SMALL_STATE(5560)] = 236608,
  [SMALL_STATE(5561)] = 236651,
  [SMALL_STATE(5562)] = 236694,
  [SMALL_STATE(5563)] = 236737,
  [SMALL_STATE(5564)] = 236780,
  [SMALL_STATE(5565)] = 236823,
  [SMALL_STATE(5566)] = 236866,
  [SMALL_STATE(5567)] = 236909,
  [SMALL_STATE(5568)] = 236952,
  [SMALL_STATE(5569)] = 236977,
  [SMALL_STATE(5570)] = 237015,
  [SMALL_STATE(5571)] = 237053,
  [SMALL_STATE(5572)] = 237091,
  [SMALL_STATE(5573)] = 237117,
  [SMALL_STATE(5574)] = 237155,
  [SMALL_STATE(5575)] = 237188,
  [SMALL_STATE(5576)] = 237225,
  [SMALL_STATE(5577)] = 237258,
  [SMALL_STATE(5578)] = 237291,
  [SMALL_STATE(5579)] = 237328,
  [SMALL_STATE(5580)] = 237361,
  [SMALL_STATE(5581)] = 237398,
  [SMALL_STATE(5582)] = 237431,
  [SMALL_STATE(5583)] = 237468,
  [SMALL_STATE(5584)] = 237505,
  [SMALL_STATE(5585)] = 237538,
  [SMALL_STATE(5586)] = 237571,
  [SMALL_STATE(5587)] = 237604,
  [SMALL_STATE(5588)] = 237637,
  [SMALL_STATE(5589)] = 237674,
  [SMALL_STATE(5590)] = 237711,
  [SMALL_STATE(5591)] = 237748,
  [SMALL_STATE(5592)] = 237785,
  [SMALL_STATE(5593)] = 237822,
  [SMALL_STATE(5594)] = 237859,
  [SMALL_STATE(5595)] = 237892,
  [SMALL_STATE(5596)] = 237929,
  [SMALL_STATE(5597)] = 237966,
  [SMALL_STATE(5598)] = 238003,
  [SMALL_STATE(5599)] = 238040,
  [SMALL_STATE(5600)] = 238073,
  [SMALL_STATE(5601)] = 238110,
  [SMALL_STATE(5602)] = 238147,
  [SMALL_STATE(5603)] = 238184,
  [SMALL_STATE(5604)] = 238221,
  [SMALL_STATE(5605)] = 238254,
  [SMALL_STATE(5606)] = 238287,
  [SMALL_STATE(5607)] = 238324,
  [SMALL_STATE(5608)] = 238361,
  [SMALL_STATE(5609)] = 238398,
  [SMALL_STATE(5610)] = 238435,
  [SMALL_STATE(5611)] = 238472,
  [SMALL_STATE(5612)] = 238509,
  [SMALL_STATE(5613)] = 238542,
  [SMALL_STATE(5614)] = 238575,
  [SMALL_STATE(5615)] = 238612,
  [SMALL_STATE(5616)] = 238645,
  [SMALL_STATE(5617)] = 238682,
  [SMALL_STATE(5618)] = 238719,
  [SMALL_STATE(5619)] = 238756,
  [SMALL_STATE(5620)] = 238793,
  [SMALL_STATE(5621)] = 238830,
  [SMALL_STATE(5622)] = 238867,
  [SMALL_STATE(5623)] = 238904,
  [SMALL_STATE(5624)] = 238941,
  [SMALL_STATE(5625)] = 238974,
  [SMALL_STATE(5626)] = 239011,
  [SMALL_STATE(5627)] = 239038,
  [SMALL_STATE(5628)] = 239075,
  [SMALL_STATE(5629)] = 239112,
  [SMALL_STATE(5630)] = 239149,
  [SMALL_STATE(5631)] = 239182,
  [SMALL_STATE(5632)] = 239219,
  [SMALL_STATE(5633)] = 239256,
  [SMALL_STATE(5634)] = 239293,
  [SMALL_STATE(5635)] = 239330,
  [SMALL_STATE(5636)] = 239367,
  [SMALL_STATE(5637)] = 239404,
  [SMALL_STATE(5638)] = 239435,
  [SMALL_STATE(5639)] = 239472,
  [SMALL_STATE(5640)] = 239509,
  [SMALL_STATE(5641)] = 239546,
  [SMALL_STATE(5642)] = 239583,
  [SMALL_STATE(5643)] = 239620,
  [SMALL_STATE(5644)] = 239657,
  [SMALL_STATE(5645)] = 239694,
  [SMALL_STATE(5646)] = 239731,
  [SMALL_STATE(5647)] = 239768,
  [SMALL_STATE(5648)] = 239801,
  [SMALL_STATE(5649)] = 239838,
  [SMALL_STATE(5650)] = 239867,
  [SMALL_STATE(5651)] = 239904,
  [SMALL_STATE(5652)] = 239937,
  [SMALL_STATE(5653)] = 239974,
  [SMALL_STATE(5654)] = 240007,
  [SMALL_STATE(5655)] = 240044,
  [SMALL_STATE(5656)] = 240081,
  [SMALL_STATE(5657)] = 240114,
  [SMALL_STATE(5658)] = 240151,
  [SMALL_STATE(5659)] = 240188,
  [SMALL_STATE(5660)] = 240225,
  [SMALL_STATE(5661)] = 240262,
  [SMALL_STATE(5662)] = 240299,
  [SMALL_STATE(5663)] = 240336,
  [SMALL_STATE(5664)] = 240367,
  [SMALL_STATE(5665)] = 240404,
  [SMALL_STATE(5666)] = 240429,
  [SMALL_STATE(5667)] = 240466,
  [SMALL_STATE(5668)] = 240503,
  [SMALL_STATE(5669)] = 240540,
  [SMALL_STATE(5670)] = 240577,
  [SMALL_STATE(5671)] = 240614,
  [SMALL_STATE(5672)] = 240645,
  [SMALL_STATE(5673)] = 240682,
  [SMALL_STATE(5674)] = 240719,
  [SMALL_STATE(5675)] = 240756,
  [SMALL_STATE(5676)] = 240793,
  [SMALL_STATE(5677)] = 240830,
  [SMALL_STATE(5678)] = 240863,
  [SMALL_STATE(5679)] = 240900,
  [SMALL_STATE(5680)] = 240937,
  [SMALL_STATE(5681)] = 240962,
  [SMALL_STATE(5682)] = 240999,
  [SMALL_STATE(5683)] = 241036,
  [SMALL_STATE(5684)] = 241073,
  [SMALL_STATE(5685)] = 241110,
  [SMALL_STATE(5686)] = 241147,
  [SMALL_STATE(5687)] = 241184,
  [SMALL_STATE(5688)] = 241207,
  [SMALL_STATE(5689)] = 241244,
  [SMALL_STATE(5690)] = 241269,
  [SMALL_STATE(5691)] = 241306,
  [SMALL_STATE(5692)] = 241343,
  [SMALL_STATE(5693)] = 241380,
  [SMALL_STATE(5694)] = 241417,
  [SMALL_STATE(5695)] = 241454,
  [SMALL_STATE(5696)] = 241491,
  [SMALL_STATE(5697)] = 241524,
  [SMALL_STATE(5698)] = 241544,
  [SMALL_STATE(5699)] = 241578,
  [SMALL_STATE(5700)] = 241612,
  [SMALL_STATE(5701)] = 241646,
  [SMALL_STATE(5702)] = 241666,
  [SMALL_STATE(5703)] = 241700,
  [SMALL_STATE(5704)] = 241734,
  [SMALL_STATE(5705)] = 241768,
  [SMALL_STATE(5706)] = 241794,
  [SMALL_STATE(5707)] = 241825,
  [SMALL_STATE(5708)] = 241856,
  [SMALL_STATE(5709)] = 241887,
  [SMALL_STATE(5710)] = 241918,
  [SMALL_STATE(5711)] = 241949,
  [SMALL_STATE(5712)] = 241980,
  [SMALL_STATE(5713)] = 242011,
  [SMALL_STATE(5714)] = 242042,
  [SMALL_STATE(5715)] = 242073,
  [SMALL_STATE(5716)] = 242102,
  [SMALL_STATE(5717)] = 242133,
  [SMALL_STATE(5718)] = 242164,
  [SMALL_STATE(5719)] = 242195,
  [SMALL_STATE(5720)] = 242222,
  [SMALL_STATE(5721)] = 242253,
  [SMALL_STATE(5722)] = 242284,
  [SMALL_STATE(5723)] = 242315,
  [SMALL_STATE(5724)] = 242346,
  [SMALL_STATE(5725)] = 242377,
  [SMALL_STATE(5726)] = 242408,
  [SMALL_STATE(5727)] = 242439,
  [SMALL_STATE(5728)] = 242470,
  [SMALL_STATE(5729)] = 242501,
  [SMALL_STATE(5730)] = 242532,
  [SMALL_STATE(5731)] = 242563,
  [SMALL_STATE(5732)] = 242594,
  [SMALL_STATE(5733)] = 242625,
  [SMALL_STATE(5734)] = 242656,
  [SMALL_STATE(5735)] = 242687,
  [SMALL_STATE(5736)] = 242718,
  [SMALL_STATE(5737)] = 242749,
  [SMALL_STATE(5738)] = 242780,
  [SMALL_STATE(5739)] = 242811,
  [SMALL_STATE(5740)] = 242842,
  [SMALL_STATE(5741)] = 242873,
  [SMALL_STATE(5742)] = 242904,
  [SMALL_STATE(5743)] = 242935,
  [SMALL_STATE(5744)] = 242966,
  [SMALL_STATE(5745)] = 242997,
  [SMALL_STATE(5746)] = 243028,
  [SMALL_STATE(5747)] = 243059,
  [SMALL_STATE(5748)] = 243090,
  [SMALL_STATE(5749)] = 243121,
  [SMALL_STATE(5750)] = 243152,
  [SMALL_STATE(5751)] = 243183,
  [SMALL_STATE(5752)] = 243214,
  [SMALL_STATE(5753)] = 243245,
  [SMALL_STATE(5754)] = 243276,
  [SMALL_STATE(5755)] = 243307,
  [SMALL_STATE(5756)] = 243338,
  [SMALL_STATE(5757)] = 243369,
  [SMALL_STATE(5758)] = 243400,
  [SMALL_STATE(5759)] = 243431,
  [SMALL_STATE(5760)] = 243462,
  [SMALL_STATE(5761)] = 243493,
  [SMALL_STATE(5762)] = 243524,
  [SMALL_STATE(5763)] = 243555,
  [SMALL_STATE(5764)] = 243586,
  [SMALL_STATE(5765)] = 243617,
  [SMALL_STATE(5766)] = 243648,
  [SMALL_STATE(5767)] = 243679,
  [SMALL_STATE(5768)] = 243706,
  [SMALL_STATE(5769)] = 243737,
  [SMALL_STATE(5770)] = 243768,
  [SMALL_STATE(5771)] = 243799,
  [SMALL_STATE(5772)] = 243830,
  [SMALL_STATE(5773)] = 243861,
  [SMALL_STATE(5774)] = 243892,
  [SMALL_STATE(5775)] = 243923,
  [SMALL_STATE(5776)] = 243954,
  [SMALL_STATE(5777)] = 243985,
  [SMALL_STATE(5778)] = 244016,
  [SMALL_STATE(5779)] = 244047,
  [SMALL_STATE(5780)] = 244078,
  [SMALL_STATE(5781)] = 244103,
  [SMALL_STATE(5782)] = 244134,
  [SMALL_STATE(5783)] = 244165,
  [SMALL_STATE(5784)] = 244196,
  [SMALL_STATE(5785)] = 244227,
  [SMALL_STATE(5786)] = 244258,
  [SMALL_STATE(5787)] = 244289,
  [SMALL_STATE(5788)] = 244320,
  [SMALL_STATE(5789)] = 244351,
  [SMALL_STATE(5790)] = 244382,
  [SMALL_STATE(5791)] = 244413,
  [SMALL_STATE(5792)] = 244444,
  [SMALL_STATE(5793)] = 244475,
  [SMALL_STATE(5794)] = 244506,
  [SMALL_STATE(5795)] = 244537,
  [SMALL_STATE(5796)] = 244568,
  [SMALL_STATE(5797)] = 244599,
  [SMALL_STATE(5798)] = 244630,
  [SMALL_STATE(5799)] = 244661,
  [SMALL_STATE(5800)] = 244692,
  [SMALL_STATE(5801)] = 244723,
  [SMALL_STATE(5802)] = 244754,
  [SMALL_STATE(5803)] = 244785,
  [SMALL_STATE(5804)] = 244816,
  [SMALL_STATE(5805)] = 244847,
  [SMALL_STATE(5806)] = 244878,
  [SMALL_STATE(5807)] = 244909,
  [SMALL_STATE(5808)] = 244940,
  [SMALL_STATE(5809)] = 244971,
  [SMALL_STATE(5810)] = 245002,
  [SMALL_STATE(5811)] = 245033,
  [SMALL_STATE(5812)] = 245064,
  [SMALL_STATE(5813)] = 245095,
  [SMALL_STATE(5814)] = 245126,
  [SMALL_STATE(5815)] = 245157,
  [SMALL_STATE(5816)] = 245188,
  [SMALL_STATE(5817)] = 245219,
  [SMALL_STATE(5818)] = 245250,
  [SMALL_STATE(5819)] = 245281,
  [SMALL_STATE(5820)] = 245312,
  [SMALL_STATE(5821)] = 245343,
  [SMALL_STATE(5822)] = 245374,
  [SMALL_STATE(5823)] = 245405,
  [SMALL_STATE(5824)] = 245436,
  [SMALL_STATE(5825)] = 245467,
  [SMALL_STATE(5826)] = 245498,
  [SMALL_STATE(5827)] = 245529,
  [SMALL_STATE(5828)] = 245560,
  [SMALL_STATE(5829)] = 245591,
  [SMALL_STATE(5830)] = 245622,
  [SMALL_STATE(5831)] = 245653,
  [SMALL_STATE(5832)] = 245684,
  [SMALL_STATE(5833)] = 245715,
  [SMALL_STATE(5834)] = 245746,
  [SMALL_STATE(5835)] = 245777,
  [SMALL_STATE(5836)] = 245808,
  [SMALL_STATE(5837)] = 245839,
  [SMALL_STATE(5838)] = 245870,
  [SMALL_STATE(5839)] = 245901,
  [SMALL_STATE(5840)] = 245932,
  [SMALL_STATE(5841)] = 245963,
  [SMALL_STATE(5842)] = 245994,
  [SMALL_STATE(5843)] = 246025,
  [SMALL_STATE(5844)] = 246044,
  [SMALL_STATE(5845)] = 246075,
  [SMALL_STATE(5846)] = 246106,
  [SMALL_STATE(5847)] = 246137,
  [SMALL_STATE(5848)] = 246168,
  [SMALL_STATE(5849)] = 246199,
  [SMALL_STATE(5850)] = 246230,
  [SMALL_STATE(5851)] = 246261,
  [SMALL_STATE(5852)] = 246280,
  [SMALL_STATE(5853)] = 246311,
  [SMALL_STATE(5854)] = 246342,
  [SMALL_STATE(5855)] = 246373,
  [SMALL_STATE(5856)] = 246404,
  [SMALL_STATE(5857)] = 246435,
  [SMALL_STATE(5858)] = 246466,
  [SMALL_STATE(5859)] = 246497,
  [SMALL_STATE(5860)] = 246528,
  [SMALL_STATE(5861)] = 246559,
  [SMALL_STATE(5862)] = 246590,
  [SMALL_STATE(5863)] = 246621,
  [SMALL_STATE(5864)] = 246640,
  [SMALL_STATE(5865)] = 246671,
  [SMALL_STATE(5866)] = 246702,
  [SMALL_STATE(5867)] = 246733,
  [SMALL_STATE(5868)] = 246764,
  [SMALL_STATE(5869)] = 246795,
  [SMALL_STATE(5870)] = 246826,
  [SMALL_STATE(5871)] = 246857,
  [SMALL_STATE(5872)] = 246888,
  [SMALL_STATE(5873)] = 246919,
  [SMALL_STATE(5874)] = 246938,
  [SMALL_STATE(5875)] = 246969,
  [SMALL_STATE(5876)] = 246988,
  [SMALL_STATE(5877)] = 247019,
  [SMALL_STATE(5878)] = 247050,
  [SMALL_STATE(5879)] = 247081,
  [SMALL_STATE(5880)] = 247112,
  [SMALL_STATE(5881)] = 247140,
  [SMALL_STATE(5882)] = 247162,
  [SMALL_STATE(5883)] = 247190,
  [SMALL_STATE(5884)] = 247218,
  [SMALL_STATE(5885)] = 247236,
  [SMALL_STATE(5886)] = 247264,
  [SMALL_STATE(5887)] = 247292,
  [SMALL_STATE(5888)] = 247320,
  [SMALL_STATE(5889)] = 247342,
  [SMALL_STATE(5890)] = 247370,
  [SMALL_STATE(5891)] = 247388,
  [SMALL_STATE(5892)] = 247416,
  [SMALL_STATE(5893)] = 247444,
  [SMALL_STATE(5894)] = 247472,
  [SMALL_STATE(5895)] = 247500,
  [SMALL_STATE(5896)] = 247520,
  [SMALL_STATE(5897)] = 247548,
  [SMALL_STATE(5898)] = 247576,
  [SMALL_STATE(5899)] = 247604,
  [SMALL_STATE(5900)] = 247622,
  [SMALL_STATE(5901)] = 247650,
  [SMALL_STATE(5902)] = 247670,
  [SMALL_STATE(5903)] = 247698,
  [SMALL_STATE(5904)] = 247726,
  [SMALL_STATE(5905)] = 247754,
  [SMALL_STATE(5906)] = 247776,
  [SMALL_STATE(5907)] = 247804,
  [SMALL_STATE(5908)] = 247832,
  [SMALL_STATE(5909)] = 247854,
  [SMALL_STATE(5910)] = 247882,
  [SMALL_STATE(5911)] = 247910,
  [SMALL_STATE(5912)] = 247938,
  [SMALL_STATE(5913)] = 247966,
  [SMALL_STATE(5914)] = 247994,
  [SMALL_STATE(5915)] = 248020,
  [SMALL_STATE(5916)] = 248048,
  [SMALL_STATE(5917)] = 248066,
  [SMALL_STATE(5918)] = 248091,
  [SMALL_STATE(5919)] = 248108,
  [SMALL_STATE(5920)] = 248133,
  [SMALL_STATE(5921)] = 248158,
  [SMALL_STATE(5922)] = 248183,
  [SMALL_STATE(5923)] = 248208,
  [SMALL_STATE(5924)] = 248233,
  [SMALL_STATE(5925)] = 248258,
  [SMALL_STATE(5926)] = 248283,
  [SMALL_STATE(5927)] = 248308,
  [SMALL_STATE(5928)] = 248333,
  [SMALL_STATE(5929)] = 248358,
  [SMALL_STATE(5930)] = 248383,
  [SMALL_STATE(5931)] = 248408,
  [SMALL_STATE(5932)] = 248427,
  [SMALL_STATE(5933)] = 248452,
  [SMALL_STATE(5934)] = 248477,
  [SMALL_STATE(5935)] = 248502,
  [SMALL_STATE(5936)] = 248527,
  [SMALL_STATE(5937)] = 248552,
  [SMALL_STATE(5938)] = 248577,
  [SMALL_STATE(5939)] = 248602,
  [SMALL_STATE(5940)] = 248627,
  [SMALL_STATE(5941)] = 248652,
  [SMALL_STATE(5942)] = 248677,
  [SMALL_STATE(5943)] = 248702,
  [SMALL_STATE(5944)] = 248727,
  [SMALL_STATE(5945)] = 248752,
  [SMALL_STATE(5946)] = 248771,
  [SMALL_STATE(5947)] = 248796,
  [SMALL_STATE(5948)] = 248817,
  [SMALL_STATE(5949)] = 248842,
  [SMALL_STATE(5950)] = 248867,
  [SMALL_STATE(5951)] = 248884,
  [SMALL_STATE(5952)] = 248909,
  [SMALL_STATE(5953)] = 248934,
  [SMALL_STATE(5954)] = 248959,
  [SMALL_STATE(5955)] = 248980,
  [SMALL_STATE(5956)] = 249003,
  [SMALL_STATE(5957)] = 249022,
  [SMALL_STATE(5958)] = 249047,
  [SMALL_STATE(5959)] = 249068,
  [SMALL_STATE(5960)] = 249093,
  [SMALL_STATE(5961)] = 249118,
  [SMALL_STATE(5962)] = 249143,
  [SMALL_STATE(5963)] = 249164,
  [SMALL_STATE(5964)] = 249189,
  [SMALL_STATE(5965)] = 249214,
  [SMALL_STATE(5966)] = 249239,
  [SMALL_STATE(5967)] = 249264,
  [SMALL_STATE(5968)] = 249289,
  [SMALL_STATE(5969)] = 249314,
  [SMALL_STATE(5970)] = 249339,
  [SMALL_STATE(5971)] = 249364,
  [SMALL_STATE(5972)] = 249385,
  [SMALL_STATE(5973)] = 249406,
  [SMALL_STATE(5974)] = 249425,
  [SMALL_STATE(5975)] = 249450,
  [SMALL_STATE(5976)] = 249469,
  [SMALL_STATE(5977)] = 249494,
  [SMALL_STATE(5978)] = 249519,
  [SMALL_STATE(5979)] = 249544,
  [SMALL_STATE(5980)] = 249569,
  [SMALL_STATE(5981)] = 249590,
  [SMALL_STATE(5982)] = 249615,
  [SMALL_STATE(5983)] = 249640,
  [SMALL_STATE(5984)] = 249665,
  [SMALL_STATE(5985)] = 249690,
  [SMALL_STATE(5986)] = 249715,
  [SMALL_STATE(5987)] = 249734,
  [SMALL_STATE(5988)] = 249757,
  [SMALL_STATE(5989)] = 249782,
  [SMALL_STATE(5990)] = 249803,
  [SMALL_STATE(5991)] = 249828,
  [SMALL_STATE(5992)] = 249853,
  [SMALL_STATE(5993)] = 249878,
  [SMALL_STATE(5994)] = 249903,
  [SMALL_STATE(5995)] = 249922,
  [SMALL_STATE(5996)] = 249941,
  [SMALL_STATE(5997)] = 249964,
  [SMALL_STATE(5998)] = 249981,
  [SMALL_STATE(5999)] = 249998,
  [SMALL_STATE(6000)] = 250015,
  [SMALL_STATE(6001)] = 250036,
  [SMALL_STATE(6002)] = 250061,
  [SMALL_STATE(6003)] = 250080,
  [SMALL_STATE(6004)] = 250105,
  [SMALL_STATE(6005)] = 250122,
  [SMALL_STATE(6006)] = 250141,
  [SMALL_STATE(6007)] = 250158,
  [SMALL_STATE(6008)] = 250175,
  [SMALL_STATE(6009)] = 250198,
  [SMALL_STATE(6010)] = 250223,
  [SMALL_STATE(6011)] = 250248,
  [SMALL_STATE(6012)] = 250267,
  [SMALL_STATE(6013)] = 250284,
  [SMALL_STATE(6014)] = 250309,
  [SMALL_STATE(6015)] = 250326,
  [SMALL_STATE(6016)] = 250349,
  [SMALL_STATE(6017)] = 250366,
  [SMALL_STATE(6018)] = 250391,
  [SMALL_STATE(6019)] = 250416,
  [SMALL_STATE(6020)] = 250435,
  [SMALL_STATE(6021)] = 250456,
  [SMALL_STATE(6022)] = 250481,
  [SMALL_STATE(6023)] = 250506,
  [SMALL_STATE(6024)] = 250531,
  [SMALL_STATE(6025)] = 250548,
  [SMALL_STATE(6026)] = 250565,
  [SMALL_STATE(6027)] = 250590,
  [SMALL_STATE(6028)] = 250615,
  [SMALL_STATE(6029)] = 250640,
  [SMALL_STATE(6030)] = 250657,
  [SMALL_STATE(6031)] = 250682,
  [SMALL_STATE(6032)] = 250699,
  [SMALL_STATE(6033)] = 250718,
  [SMALL_STATE(6034)] = 250743,
  [SMALL_STATE(6035)] = 250768,
  [SMALL_STATE(6036)] = 250793,
  [SMALL_STATE(6037)] = 250818,
  [SMALL_STATE(6038)] = 250843,
  [SMALL_STATE(6039)] = 250868,
  [SMALL_STATE(6040)] = 250893,
  [SMALL_STATE(6041)] = 250918,
  [SMALL_STATE(6042)] = 250943,
  [SMALL_STATE(6043)] = 250968,
  [SMALL_STATE(6044)] = 250993,
  [SMALL_STATE(6045)] = 251018,
  [SMALL_STATE(6046)] = 251043,
  [SMALL_STATE(6047)] = 251066,
  [SMALL_STATE(6048)] = 251085,
  [SMALL_STATE(6049)] = 251104,
  [SMALL_STATE(6050)] = 251127,
  [SMALL_STATE(6051)] = 251152,
  [SMALL_STATE(6052)] = 251177,
  [SMALL_STATE(6053)] = 251194,
  [SMALL_STATE(6054)] = 251219,
  [SMALL_STATE(6055)] = 251244,
  [SMALL_STATE(6056)] = 251269,
  [SMALL_STATE(6057)] = 251294,
  [SMALL_STATE(6058)] = 251311,
  [SMALL_STATE(6059)] = 251330,
  [SMALL_STATE(6060)] = 251355,
  [SMALL_STATE(6061)] = 251380,
  [SMALL_STATE(6062)] = 251405,
  [SMALL_STATE(6063)] = 251430,
  [SMALL_STATE(6064)] = 251455,
  [SMALL_STATE(6065)] = 251472,
  [SMALL_STATE(6066)] = 251497,
  [SMALL_STATE(6067)] = 251516,
  [SMALL_STATE(6068)] = 251541,
  [SMALL_STATE(6069)] = 251566,
  [SMALL_STATE(6070)] = 251591,
  [SMALL_STATE(6071)] = 251616,
  [SMALL_STATE(6072)] = 251641,
  [SMALL_STATE(6073)] = 251658,
  [SMALL_STATE(6074)] = 251683,
  [SMALL_STATE(6075)] = 251700,
  [SMALL_STATE(6076)] = 251725,
  [SMALL_STATE(6077)] = 251748,
  [SMALL_STATE(6078)] = 251773,
  [SMALL_STATE(6079)] = 251798,
  [SMALL_STATE(6080)] = 251823,
  [SMALL_STATE(6081)] = 251848,
  [SMALL_STATE(6082)] = 251869,
  [SMALL_STATE(6083)] = 251894,
  [SMALL_STATE(6084)] = 251915,
  [SMALL_STATE(6085)] = 251940,
  [SMALL_STATE(6086)] = 251965,
  [SMALL_STATE(6087)] = 251990,
  [SMALL_STATE(6088)] = 252007,
  [SMALL_STATE(6089)] = 252032,
  [SMALL_STATE(6090)] = 252057,
  [SMALL_STATE(6091)] = 252076,
  [SMALL_STATE(6092)] = 252097,
  [SMALL_STATE(6093)] = 252115,
  [SMALL_STATE(6094)] = 252133,
  [SMALL_STATE(6095)] = 252155,
  [SMALL_STATE(6096)] = 252177,
  [SMALL_STATE(6097)] = 252199,
  [SMALL_STATE(6098)] = 252221,
  [SMALL_STATE(6099)] = 252243,
  [SMALL_STATE(6100)] = 252261,
  [SMALL_STATE(6101)] = 252283,
  [SMALL_STATE(6102)] = 252305,
  [SMALL_STATE(6103)] = 252327,
  [SMALL_STATE(6104)] = 252347,
  [SMALL_STATE(6105)] = 252369,
  [SMALL_STATE(6106)] = 252391,
  [SMALL_STATE(6107)] = 252413,
  [SMALL_STATE(6108)] = 252435,
  [SMALL_STATE(6109)] = 252457,
  [SMALL_STATE(6110)] = 252479,
  [SMALL_STATE(6111)] = 252501,
  [SMALL_STATE(6112)] = 252523,
  [SMALL_STATE(6113)] = 252545,
  [SMALL_STATE(6114)] = 252567,
  [SMALL_STATE(6115)] = 252589,
  [SMALL_STATE(6116)] = 252611,
  [SMALL_STATE(6117)] = 252633,
  [SMALL_STATE(6118)] = 252655,
  [SMALL_STATE(6119)] = 252677,
  [SMALL_STATE(6120)] = 252699,
  [SMALL_STATE(6121)] = 252721,
  [SMALL_STATE(6122)] = 252743,
  [SMALL_STATE(6123)] = 252765,
  [SMALL_STATE(6124)] = 252785,
  [SMALL_STATE(6125)] = 252807,
  [SMALL_STATE(6126)] = 252829,
  [SMALL_STATE(6127)] = 252849,
  [SMALL_STATE(6128)] = 252871,
  [SMALL_STATE(6129)] = 252891,
  [SMALL_STATE(6130)] = 252913,
  [SMALL_STATE(6131)] = 252935,
  [SMALL_STATE(6132)] = 252955,
  [SMALL_STATE(6133)] = 252977,
  [SMALL_STATE(6134)] = 252999,
  [SMALL_STATE(6135)] = 253021,
  [SMALL_STATE(6136)] = 253043,
  [SMALL_STATE(6137)] = 253065,
  [SMALL_STATE(6138)] = 253087,
  [SMALL_STATE(6139)] = 253109,
  [SMALL_STATE(6140)] = 253131,
  [SMALL_STATE(6141)] = 253153,
  [SMALL_STATE(6142)] = 253175,
  [SMALL_STATE(6143)] = 253197,
  [SMALL_STATE(6144)] = 253219,
  [SMALL_STATE(6145)] = 253241,
  [SMALL_STATE(6146)] = 253263,
  [SMALL_STATE(6147)] = 253285,
  [SMALL_STATE(6148)] = 253307,
  [SMALL_STATE(6149)] = 253329,
  [SMALL_STATE(6150)] = 253351,
  [SMALL_STATE(6151)] = 253373,
  [SMALL_STATE(6152)] = 253395,
  [SMALL_STATE(6153)] = 253417,
  [SMALL_STATE(6154)] = 253439,
  [SMALL_STATE(6155)] = 253461,
  [SMALL_STATE(6156)] = 253483,
  [SMALL_STATE(6157)] = 253505,
  [SMALL_STATE(6158)] = 253527,
  [SMALL_STATE(6159)] = 253549,
  [SMALL_STATE(6160)] = 253567,
  [SMALL_STATE(6161)] = 253589,
  [SMALL_STATE(6162)] = 253611,
  [SMALL_STATE(6163)] = 253633,
  [SMALL_STATE(6164)] = 253655,
  [SMALL_STATE(6165)] = 253677,
  [SMALL_STATE(6166)] = 253699,
  [SMALL_STATE(6167)] = 253721,
  [SMALL_STATE(6168)] = 253743,
  [SMALL_STATE(6169)] = 253763,
  [SMALL_STATE(6170)] = 253785,
  [SMALL_STATE(6171)] = 253807,
  [SMALL_STATE(6172)] = 253829,
  [SMALL_STATE(6173)] = 253851,
  [SMALL_STATE(6174)] = 253873,
  [SMALL_STATE(6175)] = 253895,
  [SMALL_STATE(6176)] = 253917,
  [SMALL_STATE(6177)] = 253933,
  [SMALL_STATE(6178)] = 253955,
  [SMALL_STATE(6179)] = 253977,
  [SMALL_STATE(6180)] = 253993,
  [SMALL_STATE(6181)] = 254015,
  [SMALL_STATE(6182)] = 254037,
  [SMALL_STATE(6183)] = 254059,
  [SMALL_STATE(6184)] = 254079,
  [SMALL_STATE(6185)] = 254101,
  [SMALL_STATE(6186)] = 254123,
  [SMALL_STATE(6187)] = 254143,
  [SMALL_STATE(6188)] = 254163,
  [SMALL_STATE(6189)] = 254185,
  [SMALL_STATE(6190)] = 254207,
  [SMALL_STATE(6191)] = 254229,
  [SMALL_STATE(6192)] = 254251,
  [SMALL_STATE(6193)] = 254273,
  [SMALL_STATE(6194)] = 254295,
  [SMALL_STATE(6195)] = 254317,
  [SMALL_STATE(6196)] = 254339,
  [SMALL_STATE(6197)] = 254361,
  [SMALL_STATE(6198)] = 254379,
  [SMALL_STATE(6199)] = 254397,
  [SMALL_STATE(6200)] = 254419,
  [SMALL_STATE(6201)] = 254441,
  [SMALL_STATE(6202)] = 254463,
  [SMALL_STATE(6203)] = 254485,
  [SMALL_STATE(6204)] = 254507,
  [SMALL_STATE(6205)] = 254529,
  [SMALL_STATE(6206)] = 254551,
  [SMALL_STATE(6207)] = 254573,
  [SMALL_STATE(6208)] = 254595,
  [SMALL_STATE(6209)] = 254617,
  [SMALL_STATE(6210)] = 254635,
  [SMALL_STATE(6211)] = 254657,
  [SMALL_STATE(6212)] = 254679,
  [SMALL_STATE(6213)] = 254695,
  [SMALL_STATE(6214)] = 254713,
  [SMALL_STATE(6215)] = 254735,
  [SMALL_STATE(6216)] = 254757,
  [SMALL_STATE(6217)] = 254779,
  [SMALL_STATE(6218)] = 254801,
  [SMALL_STATE(6219)] = 254823,
  [SMALL_STATE(6220)] = 254845,
  [SMALL_STATE(6221)] = 254864,
  [SMALL_STATE(6222)] = 254879,
  [SMALL_STATE(6223)] = 254896,
  [SMALL_STATE(6224)] = 254915,
  [SMALL_STATE(6225)] = 254934,
  [SMALL_STATE(6226)] = 254953,
  [SMALL_STATE(6227)] = 254972,
  [SMALL_STATE(6228)] = 254991,
  [SMALL_STATE(6229)] = 255010,
  [SMALL_STATE(6230)] = 255027,
  [SMALL_STATE(6231)] = 255044,
  [SMALL_STATE(6232)] = 255063,
  [SMALL_STATE(6233)] = 255082,
  [SMALL_STATE(6234)] = 255101,
  [SMALL_STATE(6235)] = 255120,
  [SMALL_STATE(6236)] = 255139,
  [SMALL_STATE(6237)] = 255158,
  [SMALL_STATE(6238)] = 255177,
  [SMALL_STATE(6239)] = 255196,
  [SMALL_STATE(6240)] = 255215,
  [SMALL_STATE(6241)] = 255234,
  [SMALL_STATE(6242)] = 255253,
  [SMALL_STATE(6243)] = 255272,
  [SMALL_STATE(6244)] = 255291,
  [SMALL_STATE(6245)] = 255310,
  [SMALL_STATE(6246)] = 255329,
  [SMALL_STATE(6247)] = 255348,
  [SMALL_STATE(6248)] = 255367,
  [SMALL_STATE(6249)] = 255386,
  [SMALL_STATE(6250)] = 255405,
  [SMALL_STATE(6251)] = 255424,
  [SMALL_STATE(6252)] = 255443,
  [SMALL_STATE(6253)] = 255462,
  [SMALL_STATE(6254)] = 255477,
  [SMALL_STATE(6255)] = 255496,
  [SMALL_STATE(6256)] = 255515,
  [SMALL_STATE(6257)] = 255530,
  [SMALL_STATE(6258)] = 255549,
  [SMALL_STATE(6259)] = 255564,
  [SMALL_STATE(6260)] = 255579,
  [SMALL_STATE(6261)] = 255596,
  [SMALL_STATE(6262)] = 255611,
  [SMALL_STATE(6263)] = 255630,
  [SMALL_STATE(6264)] = 255649,
  [SMALL_STATE(6265)] = 255664,
  [SMALL_STATE(6266)] = 255681,
  [SMALL_STATE(6267)] = 255700,
  [SMALL_STATE(6268)] = 255719,
  [SMALL_STATE(6269)] = 255738,
  [SMALL_STATE(6270)] = 255757,
  [SMALL_STATE(6271)] = 255776,
  [SMALL_STATE(6272)] = 255795,
  [SMALL_STATE(6273)] = 255810,
  [SMALL_STATE(6274)] = 255829,
  [SMALL_STATE(6275)] = 255848,
  [SMALL_STATE(6276)] = 255867,
  [SMALL_STATE(6277)] = 255886,
  [SMALL_STATE(6278)] = 255903,
  [SMALL_STATE(6279)] = 255922,
  [SMALL_STATE(6280)] = 255939,
  [SMALL_STATE(6281)] = 255958,
  [SMALL_STATE(6282)] = 255977,
  [SMALL_STATE(6283)] = 255996,
  [SMALL_STATE(6284)] = 256015,
  [SMALL_STATE(6285)] = 256034,
  [SMALL_STATE(6286)] = 256053,
  [SMALL_STATE(6287)] = 256072,
  [SMALL_STATE(6288)] = 256091,
  [SMALL_STATE(6289)] = 256106,
  [SMALL_STATE(6290)] = 256125,
  [SMALL_STATE(6291)] = 256142,
  [SMALL_STATE(6292)] = 256161,
  [SMALL_STATE(6293)] = 256180,
  [SMALL_STATE(6294)] = 256199,
  [SMALL_STATE(6295)] = 256218,
  [SMALL_STATE(6296)] = 256237,
  [SMALL_STATE(6297)] = 256256,
  [SMALL_STATE(6298)] = 256275,
  [SMALL_STATE(6299)] = 256294,
  [SMALL_STATE(6300)] = 256313,
  [SMALL_STATE(6301)] = 256328,
  [SMALL_STATE(6302)] = 256347,
  [SMALL_STATE(6303)] = 256366,
  [SMALL_STATE(6304)] = 256385,
  [SMALL_STATE(6305)] = 256404,
  [SMALL_STATE(6306)] = 256423,
  [SMALL_STATE(6307)] = 256442,
  [SMALL_STATE(6308)] = 256459,
  [SMALL_STATE(6309)] = 256478,
  [SMALL_STATE(6310)] = 256497,
  [SMALL_STATE(6311)] = 256516,
  [SMALL_STATE(6312)] = 256535,
  [SMALL_STATE(6313)] = 256554,
  [SMALL_STATE(6314)] = 256573,
  [SMALL_STATE(6315)] = 256592,
  [SMALL_STATE(6316)] = 256611,
  [SMALL_STATE(6317)] = 256630,
  [SMALL_STATE(6318)] = 256649,
  [SMALL_STATE(6319)] = 256668,
  [SMALL_STATE(6320)] = 256687,
  [SMALL_STATE(6321)] = 256706,
  [SMALL_STATE(6322)] = 256725,
  [SMALL_STATE(6323)] = 256744,
  [SMALL_STATE(6324)] = 256763,
  [SMALL_STATE(6325)] = 256782,
  [SMALL_STATE(6326)] = 256801,
  [SMALL_STATE(6327)] = 256820,
  [SMALL_STATE(6328)] = 256835,
  [SMALL_STATE(6329)] = 256854,
  [SMALL_STATE(6330)] = 256873,
  [SMALL_STATE(6331)] = 256892,
  [SMALL_STATE(6332)] = 256911,
  [SMALL_STATE(6333)] = 256930,
  [SMALL_STATE(6334)] = 256945,
  [SMALL_STATE(6335)] = 256964,
  [SMALL_STATE(6336)] = 256983,
  [SMALL_STATE(6337)] = 257002,
  [SMALL_STATE(6338)] = 257021,
  [SMALL_STATE(6339)] = 257040,
  [SMALL_STATE(6340)] = 257059,
  [SMALL_STATE(6341)] = 257076,
  [SMALL_STATE(6342)] = 257095,
  [SMALL_STATE(6343)] = 257114,
  [SMALL_STATE(6344)] = 257133,
  [SMALL_STATE(6345)] = 257152,
  [SMALL_STATE(6346)] = 257171,
  [SMALL_STATE(6347)] = 257190,
  [SMALL_STATE(6348)] = 257205,
  [SMALL_STATE(6349)] = 257224,
  [SMALL_STATE(6350)] = 257243,
  [SMALL_STATE(6351)] = 257262,
  [SMALL_STATE(6352)] = 257279,
  [SMALL_STATE(6353)] = 257298,
  [SMALL_STATE(6354)] = 257317,
  [SMALL_STATE(6355)] = 257336,
  [SMALL_STATE(6356)] = 257353,
  [SMALL_STATE(6357)] = 257372,
  [SMALL_STATE(6358)] = 257391,
  [SMALL_STATE(6359)] = 257406,
  [SMALL_STATE(6360)] = 257425,
  [SMALL_STATE(6361)] = 257444,
  [SMALL_STATE(6362)] = 257461,
  [SMALL_STATE(6363)] = 257480,
  [SMALL_STATE(6364)] = 257499,
  [SMALL_STATE(6365)] = 257516,
  [SMALL_STATE(6366)] = 257535,
  [SMALL_STATE(6367)] = 257550,
  [SMALL_STATE(6368)] = 257565,
  [SMALL_STATE(6369)] = 257584,
  [SMALL_STATE(6370)] = 257601,
  [SMALL_STATE(6371)] = 257620,
  [SMALL_STATE(6372)] = 257639,
  [SMALL_STATE(6373)] = 257658,
  [SMALL_STATE(6374)] = 257677,
  [SMALL_STATE(6375)] = 257696,
  [SMALL_STATE(6376)] = 257715,
  [SMALL_STATE(6377)] = 257734,
  [SMALL_STATE(6378)] = 257753,
  [SMALL_STATE(6379)] = 257772,
  [SMALL_STATE(6380)] = 257791,
  [SMALL_STATE(6381)] = 257810,
  [SMALL_STATE(6382)] = 257829,
  [SMALL_STATE(6383)] = 257844,
  [SMALL_STATE(6384)] = 257863,
  [SMALL_STATE(6385)] = 257880,
  [SMALL_STATE(6386)] = 257899,
  [SMALL_STATE(6387)] = 257918,
  [SMALL_STATE(6388)] = 257933,
  [SMALL_STATE(6389)] = 257948,
  [SMALL_STATE(6390)] = 257963,
  [SMALL_STATE(6391)] = 257980,
  [SMALL_STATE(6392)] = 257999,
  [SMALL_STATE(6393)] = 258018,
  [SMALL_STATE(6394)] = 258037,
  [SMALL_STATE(6395)] = 258056,
  [SMALL_STATE(6396)] = 258075,
  [SMALL_STATE(6397)] = 258094,
  [SMALL_STATE(6398)] = 258111,
  [SMALL_STATE(6399)] = 258130,
  [SMALL_STATE(6400)] = 258149,
  [SMALL_STATE(6401)] = 258168,
  [SMALL_STATE(6402)] = 258187,
  [SMALL_STATE(6403)] = 258206,
  [SMALL_STATE(6404)] = 258225,
  [SMALL_STATE(6405)] = 258244,
  [SMALL_STATE(6406)] = 258263,
  [SMALL_STATE(6407)] = 258278,
  [SMALL_STATE(6408)] = 258297,
  [SMALL_STATE(6409)] = 258316,
  [SMALL_STATE(6410)] = 258335,
  [SMALL_STATE(6411)] = 258354,
  [SMALL_STATE(6412)] = 258373,
  [SMALL_STATE(6413)] = 258392,
  [SMALL_STATE(6414)] = 258409,
  [SMALL_STATE(6415)] = 258428,
  [SMALL_STATE(6416)] = 258447,
  [SMALL_STATE(6417)] = 258466,
  [SMALL_STATE(6418)] = 258485,
  [SMALL_STATE(6419)] = 258504,
  [SMALL_STATE(6420)] = 258523,
  [SMALL_STATE(6421)] = 258542,
  [SMALL_STATE(6422)] = 258561,
  [SMALL_STATE(6423)] = 258580,
  [SMALL_STATE(6424)] = 258599,
  [SMALL_STATE(6425)] = 258618,
  [SMALL_STATE(6426)] = 258637,
  [SMALL_STATE(6427)] = 258656,
  [SMALL_STATE(6428)] = 258675,
  [SMALL_STATE(6429)] = 258690,
  [SMALL_STATE(6430)] = 258709,
  [SMALL_STATE(6431)] = 258728,
  [SMALL_STATE(6432)] = 258747,
  [SMALL_STATE(6433)] = 258766,
  [SMALL_STATE(6434)] = 258785,
  [SMALL_STATE(6435)] = 258804,
  [SMALL_STATE(6436)] = 258823,
  [SMALL_STATE(6437)] = 258842,
  [SMALL_STATE(6438)] = 258861,
  [SMALL_STATE(6439)] = 258880,
  [SMALL_STATE(6440)] = 258899,
  [SMALL_STATE(6441)] = 258918,
  [SMALL_STATE(6442)] = 258937,
  [SMALL_STATE(6443)] = 258956,
  [SMALL_STATE(6444)] = 258975,
  [SMALL_STATE(6445)] = 258994,
  [SMALL_STATE(6446)] = 259013,
  [SMALL_STATE(6447)] = 259032,
  [SMALL_STATE(6448)] = 259051,
  [SMALL_STATE(6449)] = 259070,
  [SMALL_STATE(6450)] = 259089,
  [SMALL_STATE(6451)] = 259108,
  [SMALL_STATE(6452)] = 259127,
  [SMALL_STATE(6453)] = 259144,
  [SMALL_STATE(6454)] = 259163,
  [SMALL_STATE(6455)] = 259178,
  [SMALL_STATE(6456)] = 259197,
  [SMALL_STATE(6457)] = 259216,
  [SMALL_STATE(6458)] = 259235,
  [SMALL_STATE(6459)] = 259254,
  [SMALL_STATE(6460)] = 259273,
  [SMALL_STATE(6461)] = 259292,
  [SMALL_STATE(6462)] = 259311,
  [SMALL_STATE(6463)] = 259330,
  [SMALL_STATE(6464)] = 259347,
  [SMALL_STATE(6465)] = 259366,
  [SMALL_STATE(6466)] = 259385,
  [SMALL_STATE(6467)] = 259404,
  [SMALL_STATE(6468)] = 259423,
  [SMALL_STATE(6469)] = 259442,
  [SMALL_STATE(6470)] = 259461,
  [SMALL_STATE(6471)] = 259480,
  [SMALL_STATE(6472)] = 259495,
  [SMALL_STATE(6473)] = 259511,
  [SMALL_STATE(6474)] = 259527,
  [SMALL_STATE(6475)] = 259543,
  [SMALL_STATE(6476)] = 259559,
  [SMALL_STATE(6477)] = 259573,
  [SMALL_STATE(6478)] = 259589,
  [SMALL_STATE(6479)] = 259603,
  [SMALL_STATE(6480)] = 259619,
  [SMALL_STATE(6481)] = 259633,
  [SMALL_STATE(6482)] = 259649,
  [SMALL_STATE(6483)] = 259663,
  [SMALL_STATE(6484)] = 259677,
  [SMALL_STATE(6485)] = 259693,
  [SMALL_STATE(6486)] = 259707,
  [SMALL_STATE(6487)] = 259721,
  [SMALL_STATE(6488)] = 259737,
  [SMALL_STATE(6489)] = 259753,
  [SMALL_STATE(6490)] = 259769,
  [SMALL_STATE(6491)] = 259783,
  [SMALL_STATE(6492)] = 259799,
  [SMALL_STATE(6493)] = 259815,
  [SMALL_STATE(6494)] = 259829,
  [SMALL_STATE(6495)] = 259845,
  [SMALL_STATE(6496)] = 259861,
  [SMALL_STATE(6497)] = 259875,
  [SMALL_STATE(6498)] = 259889,
  [SMALL_STATE(6499)] = 259905,
  [SMALL_STATE(6500)] = 259919,
  [SMALL_STATE(6501)] = 259935,
  [SMALL_STATE(6502)] = 259949,
  [SMALL_STATE(6503)] = 259965,
  [SMALL_STATE(6504)] = 259981,
  [SMALL_STATE(6505)] = 259995,
  [SMALL_STATE(6506)] = 260009,
  [SMALL_STATE(6507)] = 260023,
  [SMALL_STATE(6508)] = 260037,
  [SMALL_STATE(6509)] = 260053,
  [SMALL_STATE(6510)] = 260067,
  [SMALL_STATE(6511)] = 260081,
  [SMALL_STATE(6512)] = 260097,
  [SMALL_STATE(6513)] = 260113,
  [SMALL_STATE(6514)] = 260127,
  [SMALL_STATE(6515)] = 260143,
  [SMALL_STATE(6516)] = 260159,
  [SMALL_STATE(6517)] = 260175,
  [SMALL_STATE(6518)] = 260191,
  [SMALL_STATE(6519)] = 260207,
  [SMALL_STATE(6520)] = 260223,
  [SMALL_STATE(6521)] = 260239,
  [SMALL_STATE(6522)] = 260253,
  [SMALL_STATE(6523)] = 260269,
  [SMALL_STATE(6524)] = 260285,
  [SMALL_STATE(6525)] = 260301,
  [SMALL_STATE(6526)] = 260315,
  [SMALL_STATE(6527)] = 260331,
  [SMALL_STATE(6528)] = 260345,
  [SMALL_STATE(6529)] = 260359,
  [SMALL_STATE(6530)] = 260373,
  [SMALL_STATE(6531)] = 260389,
  [SMALL_STATE(6532)] = 260405,
  [SMALL_STATE(6533)] = 260421,
  [SMALL_STATE(6534)] = 260437,
  [SMALL_STATE(6535)] = 260451,
  [SMALL_STATE(6536)] = 260467,
  [SMALL_STATE(6537)] = 260481,
  [SMALL_STATE(6538)] = 260495,
  [SMALL_STATE(6539)] = 260509,
  [SMALL_STATE(6540)] = 260525,
  [SMALL_STATE(6541)] = 260541,
  [SMALL_STATE(6542)] = 260555,
  [SMALL_STATE(6543)] = 260571,
  [SMALL_STATE(6544)] = 260587,
  [SMALL_STATE(6545)] = 260603,
  [SMALL_STATE(6546)] = 260619,
  [SMALL_STATE(6547)] = 260635,
  [SMALL_STATE(6548)] = 260649,
  [SMALL_STATE(6549)] = 260665,
  [SMALL_STATE(6550)] = 260681,
  [SMALL_STATE(6551)] = 260695,
  [SMALL_STATE(6552)] = 260711,
  [SMALL_STATE(6553)] = 260727,
  [SMALL_STATE(6554)] = 260743,
  [SMALL_STATE(6555)] = 260759,
  [SMALL_STATE(6556)] = 260775,
  [SMALL_STATE(6557)] = 260791,
  [SMALL_STATE(6558)] = 260807,
  [SMALL_STATE(6559)] = 260821,
  [SMALL_STATE(6560)] = 260837,
  [SMALL_STATE(6561)] = 260853,
  [SMALL_STATE(6562)] = 260869,
  [SMALL_STATE(6563)] = 260885,
  [SMALL_STATE(6564)] = 260901,
  [SMALL_STATE(6565)] = 260917,
  [SMALL_STATE(6566)] = 260933,
  [SMALL_STATE(6567)] = 260949,
  [SMALL_STATE(6568)] = 260965,
  [SMALL_STATE(6569)] = 260979,
  [SMALL_STATE(6570)] = 260995,
  [SMALL_STATE(6571)] = 261011,
  [SMALL_STATE(6572)] = 261027,
  [SMALL_STATE(6573)] = 261043,
  [SMALL_STATE(6574)] = 261059,
  [SMALL_STATE(6575)] = 261075,
  [SMALL_STATE(6576)] = 261089,
  [SMALL_STATE(6577)] = 261105,
  [SMALL_STATE(6578)] = 261121,
  [SMALL_STATE(6579)] = 261137,
  [SMALL_STATE(6580)] = 261151,
  [SMALL_STATE(6581)] = 261167,
  [SMALL_STATE(6582)] = 261181,
  [SMALL_STATE(6583)] = 261197,
  [SMALL_STATE(6584)] = 261213,
  [SMALL_STATE(6585)] = 261229,
  [SMALL_STATE(6586)] = 261245,
  [SMALL_STATE(6587)] = 261261,
  [SMALL_STATE(6588)] = 261277,
  [SMALL_STATE(6589)] = 261293,
  [SMALL_STATE(6590)] = 261307,
  [SMALL_STATE(6591)] = 261323,
  [SMALL_STATE(6592)] = 261339,
  [SMALL_STATE(6593)] = 261353,
  [SMALL_STATE(6594)] = 261369,
  [SMALL_STATE(6595)] = 261383,
  [SMALL_STATE(6596)] = 261399,
  [SMALL_STATE(6597)] = 261415,
  [SMALL_STATE(6598)] = 261429,
  [SMALL_STATE(6599)] = 261445,
  [SMALL_STATE(6600)] = 261459,
  [SMALL_STATE(6601)] = 261475,
  [SMALL_STATE(6602)] = 261491,
  [SMALL_STATE(6603)] = 261507,
  [SMALL_STATE(6604)] = 261521,
  [SMALL_STATE(6605)] = 261535,
  [SMALL_STATE(6606)] = 261549,
  [SMALL_STATE(6607)] = 261565,
  [SMALL_STATE(6608)] = 261581,
  [SMALL_STATE(6609)] = 261597,
  [SMALL_STATE(6610)] = 261611,
  [SMALL_STATE(6611)] = 261627,
  [SMALL_STATE(6612)] = 261643,
  [SMALL_STATE(6613)] = 261659,
  [SMALL_STATE(6614)] = 261673,
  [SMALL_STATE(6615)] = 261689,
  [SMALL_STATE(6616)] = 261705,
  [SMALL_STATE(6617)] = 261721,
  [SMALL_STATE(6618)] = 261737,
  [SMALL_STATE(6619)] = 261753,
  [SMALL_STATE(6620)] = 261769,
  [SMALL_STATE(6621)] = 261785,
  [SMALL_STATE(6622)] = 261799,
  [SMALL_STATE(6623)] = 261815,
  [SMALL_STATE(6624)] = 261831,
  [SMALL_STATE(6625)] = 261844,
  [SMALL_STATE(6626)] = 261857,
  [SMALL_STATE(6627)] = 261870,
  [SMALL_STATE(6628)] = 261883,
  [SMALL_STATE(6629)] = 261896,
  [SMALL_STATE(6630)] = 261909,
  [SMALL_STATE(6631)] = 261922,
  [SMALL_STATE(6632)] = 261935,
  [SMALL_STATE(6633)] = 261948,
  [SMALL_STATE(6634)] = 261961,
  [SMALL_STATE(6635)] = 261974,
  [SMALL_STATE(6636)] = 261987,
  [SMALL_STATE(6637)] = 262000,
  [SMALL_STATE(6638)] = 262013,
  [SMALL_STATE(6639)] = 262026,
  [SMALL_STATE(6640)] = 262039,
  [SMALL_STATE(6641)] = 262052,
  [SMALL_STATE(6642)] = 262065,
  [SMALL_STATE(6643)] = 262078,
  [SMALL_STATE(6644)] = 262091,
  [SMALL_STATE(6645)] = 262104,
  [SMALL_STATE(6646)] = 262117,
  [SMALL_STATE(6647)] = 262130,
  [SMALL_STATE(6648)] = 262143,
  [SMALL_STATE(6649)] = 262156,
  [SMALL_STATE(6650)] = 262169,
  [SMALL_STATE(6651)] = 262182,
  [SMALL_STATE(6652)] = 262195,
  [SMALL_STATE(6653)] = 262208,
  [SMALL_STATE(6654)] = 262221,
  [SMALL_STATE(6655)] = 262234,
  [SMALL_STATE(6656)] = 262247,
  [SMALL_STATE(6657)] = 262260,
  [SMALL_STATE(6658)] = 262273,
  [SMALL_STATE(6659)] = 262286,
  [SMALL_STATE(6660)] = 262299,
  [SMALL_STATE(6661)] = 262312,
  [SMALL_STATE(6662)] = 262325,
  [SMALL_STATE(6663)] = 262338,
  [SMALL_STATE(6664)] = 262351,
  [SMALL_STATE(6665)] = 262364,
  [SMALL_STATE(6666)] = 262377,
  [SMALL_STATE(6667)] = 262390,
  [SMALL_STATE(6668)] = 262403,
  [SMALL_STATE(6669)] = 262416,
  [SMALL_STATE(6670)] = 262429,
  [SMALL_STATE(6671)] = 262442,
  [SMALL_STATE(6672)] = 262455,
  [SMALL_STATE(6673)] = 262468,
  [SMALL_STATE(6674)] = 262481,
  [SMALL_STATE(6675)] = 262494,
  [SMALL_STATE(6676)] = 262507,
  [SMALL_STATE(6677)] = 262520,
  [SMALL_STATE(6678)] = 262533,
  [SMALL_STATE(6679)] = 262546,
  [SMALL_STATE(6680)] = 262559,
  [SMALL_STATE(6681)] = 262572,
  [SMALL_STATE(6682)] = 262585,
  [SMALL_STATE(6683)] = 262598,
  [SMALL_STATE(6684)] = 262611,
  [SMALL_STATE(6685)] = 262624,
  [SMALL_STATE(6686)] = 262637,
  [SMALL_STATE(6687)] = 262650,
  [SMALL_STATE(6688)] = 262663,
  [SMALL_STATE(6689)] = 262676,
  [SMALL_STATE(6690)] = 262689,
  [SMALL_STATE(6691)] = 262702,
  [SMALL_STATE(6692)] = 262715,
  [SMALL_STATE(6693)] = 262728,
  [SMALL_STATE(6694)] = 262741,
  [SMALL_STATE(6695)] = 262754,
  [SMALL_STATE(6696)] = 262767,
  [SMALL_STATE(6697)] = 262780,
  [SMALL_STATE(6698)] = 262793,
  [SMALL_STATE(6699)] = 262806,
  [SMALL_STATE(6700)] = 262819,
  [SMALL_STATE(6701)] = 262832,
  [SMALL_STATE(6702)] = 262845,
  [SMALL_STATE(6703)] = 262858,
  [SMALL_STATE(6704)] = 262871,
  [SMALL_STATE(6705)] = 262884,
  [SMALL_STATE(6706)] = 262897,
  [SMALL_STATE(6707)] = 262910,
  [SMALL_STATE(6708)] = 262923,
  [SMALL_STATE(6709)] = 262936,
  [SMALL_STATE(6710)] = 262949,
  [SMALL_STATE(6711)] = 262962,
  [SMALL_STATE(6712)] = 262975,
  [SMALL_STATE(6713)] = 262988,
  [SMALL_STATE(6714)] = 263001,
  [SMALL_STATE(6715)] = 263014,
  [SMALL_STATE(6716)] = 263027,
  [SMALL_STATE(6717)] = 263040,
  [SMALL_STATE(6718)] = 263053,
  [SMALL_STATE(6719)] = 263066,
  [SMALL_STATE(6720)] = 263079,
  [SMALL_STATE(6721)] = 263092,
  [SMALL_STATE(6722)] = 263105,
  [SMALL_STATE(6723)] = 263118,
  [SMALL_STATE(6724)] = 263131,
  [SMALL_STATE(6725)] = 263144,
  [SMALL_STATE(6726)] = 263157,
  [SMALL_STATE(6727)] = 263170,
  [SMALL_STATE(6728)] = 263183,
  [SMALL_STATE(6729)] = 263196,
  [SMALL_STATE(6730)] = 263209,
  [SMALL_STATE(6731)] = 263222,
  [SMALL_STATE(6732)] = 263235,
  [SMALL_STATE(6733)] = 263248,
  [SMALL_STATE(6734)] = 263261,
  [SMALL_STATE(6735)] = 263274,
  [SMALL_STATE(6736)] = 263287,
  [SMALL_STATE(6737)] = 263300,
  [SMALL_STATE(6738)] = 263313,
  [SMALL_STATE(6739)] = 263326,
  [SMALL_STATE(6740)] = 263339,
  [SMALL_STATE(6741)] = 263352,
  [SMALL_STATE(6742)] = 263365,
  [SMALL_STATE(6743)] = 263378,
  [SMALL_STATE(6744)] = 263391,
  [SMALL_STATE(6745)] = 263404,
  [SMALL_STATE(6746)] = 263417,
  [SMALL_STATE(6747)] = 263430,
  [SMALL_STATE(6748)] = 263443,
  [SMALL_STATE(6749)] = 263456,
  [SMALL_STATE(6750)] = 263469,
  [SMALL_STATE(6751)] = 263482,
  [SMALL_STATE(6752)] = 263495,
  [SMALL_STATE(6753)] = 263508,
  [SMALL_STATE(6754)] = 263521,
  [SMALL_STATE(6755)] = 263534,
  [SMALL_STATE(6756)] = 263547,
  [SMALL_STATE(6757)] = 263560,
  [SMALL_STATE(6758)] = 263573,
  [SMALL_STATE(6759)] = 263586,
  [SMALL_STATE(6760)] = 263599,
  [SMALL_STATE(6761)] = 263612,
  [SMALL_STATE(6762)] = 263625,
  [SMALL_STATE(6763)] = 263638,
  [SMALL_STATE(6764)] = 263651,
  [SMALL_STATE(6765)] = 263664,
  [SMALL_STATE(6766)] = 263677,
  [SMALL_STATE(6767)] = 263690,
  [SMALL_STATE(6768)] = 263703,
  [SMALL_STATE(6769)] = 263716,
  [SMALL_STATE(6770)] = 263729,
  [SMALL_STATE(6771)] = 263742,
  [SMALL_STATE(6772)] = 263755,
  [SMALL_STATE(6773)] = 263768,
  [SMALL_STATE(6774)] = 263781,
  [SMALL_STATE(6775)] = 263794,
  [SMALL_STATE(6776)] = 263807,
  [SMALL_STATE(6777)] = 263820,
  [SMALL_STATE(6778)] = 263833,
  [SMALL_STATE(6779)] = 263846,
  [SMALL_STATE(6780)] = 263859,
  [SMALL_STATE(6781)] = 263872,
  [SMALL_STATE(6782)] = 263885,
  [SMALL_STATE(6783)] = 263898,
  [SMALL_STATE(6784)] = 263911,
  [SMALL_STATE(6785)] = 263924,
  [SMALL_STATE(6786)] = 263937,
  [SMALL_STATE(6787)] = 263950,
  [SMALL_STATE(6788)] = 263963,
  [SMALL_STATE(6789)] = 263976,
  [SMALL_STATE(6790)] = 263989,
  [SMALL_STATE(6791)] = 264002,
  [SMALL_STATE(6792)] = 264015,
  [SMALL_STATE(6793)] = 264028,
  [SMALL_STATE(6794)] = 264041,
  [SMALL_STATE(6795)] = 264054,
  [SMALL_STATE(6796)] = 264067,
  [SMALL_STATE(6797)] = 264080,
  [SMALL_STATE(6798)] = 264093,
  [SMALL_STATE(6799)] = 264106,
  [SMALL_STATE(6800)] = 264119,
  [SMALL_STATE(6801)] = 264132,
  [SMALL_STATE(6802)] = 264145,
  [SMALL_STATE(6803)] = 264158,
  [SMALL_STATE(6804)] = 264171,
  [SMALL_STATE(6805)] = 264184,
  [SMALL_STATE(6806)] = 264197,
  [SMALL_STATE(6807)] = 264210,
  [SMALL_STATE(6808)] = 264223,
  [SMALL_STATE(6809)] = 264236,
  [SMALL_STATE(6810)] = 264249,
  [SMALL_STATE(6811)] = 264262,
  [SMALL_STATE(6812)] = 264275,
  [SMALL_STATE(6813)] = 264288,
  [SMALL_STATE(6814)] = 264301,
  [SMALL_STATE(6815)] = 264314,
  [SMALL_STATE(6816)] = 264327,
  [SMALL_STATE(6817)] = 264340,
  [SMALL_STATE(6818)] = 264353,
  [SMALL_STATE(6819)] = 264366,
  [SMALL_STATE(6820)] = 264379,
  [SMALL_STATE(6821)] = 264392,
  [SMALL_STATE(6822)] = 264405,
  [SMALL_STATE(6823)] = 264418,
  [SMALL_STATE(6824)] = 264431,
  [SMALL_STATE(6825)] = 264444,
  [SMALL_STATE(6826)] = 264457,
  [SMALL_STATE(6827)] = 264470,
  [SMALL_STATE(6828)] = 264483,
  [SMALL_STATE(6829)] = 264496,
  [SMALL_STATE(6830)] = 264509,
  [SMALL_STATE(6831)] = 264522,
  [SMALL_STATE(6832)] = 264535,
  [SMALL_STATE(6833)] = 264548,
  [SMALL_STATE(6834)] = 264561,
  [SMALL_STATE(6835)] = 264574,
  [SMALL_STATE(6836)] = 264587,
  [SMALL_STATE(6837)] = 264600,
  [SMALL_STATE(6838)] = 264613,
  [SMALL_STATE(6839)] = 264626,
  [SMALL_STATE(6840)] = 264639,
  [SMALL_STATE(6841)] = 264652,
  [SMALL_STATE(6842)] = 264665,
  [SMALL_STATE(6843)] = 264678,
  [SMALL_STATE(6844)] = 264691,
  [SMALL_STATE(6845)] = 264704,
  [SMALL_STATE(6846)] = 264717,
  [SMALL_STATE(6847)] = 264730,
  [SMALL_STATE(6848)] = 264743,
  [SMALL_STATE(6849)] = 264756,
  [SMALL_STATE(6850)] = 264769,
  [SMALL_STATE(6851)] = 264782,
  [SMALL_STATE(6852)] = 264795,
  [SMALL_STATE(6853)] = 264808,
  [SMALL_STATE(6854)] = 264821,
  [SMALL_STATE(6855)] = 264834,
  [SMALL_STATE(6856)] = 264847,
  [SMALL_STATE(6857)] = 264860,
  [SMALL_STATE(6858)] = 264873,
  [SMALL_STATE(6859)] = 264886,
  [SMALL_STATE(6860)] = 264899,
  [SMALL_STATE(6861)] = 264912,
  [SMALL_STATE(6862)] = 264925,
  [SMALL_STATE(6863)] = 264938,
  [SMALL_STATE(6864)] = 264951,
  [SMALL_STATE(6865)] = 264964,
  [SMALL_STATE(6866)] = 264977,
  [SMALL_STATE(6867)] = 264990,
  [SMALL_STATE(6868)] = 265003,
  [SMALL_STATE(6869)] = 265016,
  [SMALL_STATE(6870)] = 265029,
  [SMALL_STATE(6871)] = 265042,
  [SMALL_STATE(6872)] = 265055,
  [SMALL_STATE(6873)] = 265068,
  [SMALL_STATE(6874)] = 265081,
  [SMALL_STATE(6875)] = 265094,
  [SMALL_STATE(6876)] = 265107,
  [SMALL_STATE(6877)] = 265120,
  [SMALL_STATE(6878)] = 265133,
  [SMALL_STATE(6879)] = 265146,
  [SMALL_STATE(6880)] = 265159,
  [SMALL_STATE(6881)] = 265172,
  [SMALL_STATE(6882)] = 265185,
  [SMALL_STATE(6883)] = 265198,
  [SMALL_STATE(6884)] = 265211,
  [SMALL_STATE(6885)] = 265224,
  [SMALL_STATE(6886)] = 265237,
  [SMALL_STATE(6887)] = 265250,
  [SMALL_STATE(6888)] = 265263,
  [SMALL_STATE(6889)] = 265276,
  [SMALL_STATE(6890)] = 265289,
  [SMALL_STATE(6891)] = 265302,
  [SMALL_STATE(6892)] = 265315,
  [SMALL_STATE(6893)] = 265328,
  [SMALL_STATE(6894)] = 265341,
  [SMALL_STATE(6895)] = 265354,
  [SMALL_STATE(6896)] = 265367,
  [SMALL_STATE(6897)] = 265380,
  [SMALL_STATE(6898)] = 265393,
  [SMALL_STATE(6899)] = 265406,
  [SMALL_STATE(6900)] = 265419,
  [SMALL_STATE(6901)] = 265432,
  [SMALL_STATE(6902)] = 265445,
  [SMALL_STATE(6903)] = 265458,
  [SMALL_STATE(6904)] = 265471,
  [SMALL_STATE(6905)] = 265484,
  [SMALL_STATE(6906)] = 265497,
  [SMALL_STATE(6907)] = 265510,
  [SMALL_STATE(6908)] = 265523,
  [SMALL_STATE(6909)] = 265536,
  [SMALL_STATE(6910)] = 265549,
  [SMALL_STATE(6911)] = 265562,
  [SMALL_STATE(6912)] = 265575,
  [SMALL_STATE(6913)] = 265588,
  [SMALL_STATE(6914)] = 265601,
  [SMALL_STATE(6915)] = 265614,
  [SMALL_STATE(6916)] = 265627,
  [SMALL_STATE(6917)] = 265640,
  [SMALL_STATE(6918)] = 265653,
  [SMALL_STATE(6919)] = 265666,
  [SMALL_STATE(6920)] = 265679,
  [SMALL_STATE(6921)] = 265692,
  [SMALL_STATE(6922)] = 265705,
  [SMALL_STATE(6923)] = 265718,
  [SMALL_STATE(6924)] = 265731,
  [SMALL_STATE(6925)] = 265744,
  [SMALL_STATE(6926)] = 265757,
  [SMALL_STATE(6927)] = 265770,
  [SMALL_STATE(6928)] = 265783,
  [SMALL_STATE(6929)] = 265796,
  [SMALL_STATE(6930)] = 265809,
  [SMALL_STATE(6931)] = 265822,
  [SMALL_STATE(6932)] = 265835,
  [SMALL_STATE(6933)] = 265848,
  [SMALL_STATE(6934)] = 265861,
  [SMALL_STATE(6935)] = 265874,
  [SMALL_STATE(6936)] = 265887,
  [SMALL_STATE(6937)] = 265900,
  [SMALL_STATE(6938)] = 265913,
  [SMALL_STATE(6939)] = 265926,
  [SMALL_STATE(6940)] = 265939,
  [SMALL_STATE(6941)] = 265952,
  [SMALL_STATE(6942)] = 265965,
  [SMALL_STATE(6943)] = 265978,
  [SMALL_STATE(6944)] = 265991,
  [SMALL_STATE(6945)] = 266004,
  [SMALL_STATE(6946)] = 266017,
  [SMALL_STATE(6947)] = 266030,
  [SMALL_STATE(6948)] = 266043,
  [SMALL_STATE(6949)] = 266056,
  [SMALL_STATE(6950)] = 266069,
  [SMALL_STATE(6951)] = 266082,
  [SMALL_STATE(6952)] = 266095,
  [SMALL_STATE(6953)] = 266108,
  [SMALL_STATE(6954)] = 266121,
  [SMALL_STATE(6955)] = 266134,
  [SMALL_STATE(6956)] = 266147,
  [SMALL_STATE(6957)] = 266160,
  [SMALL_STATE(6958)] = 266173,
  [SMALL_STATE(6959)] = 266186,
  [SMALL_STATE(6960)] = 266199,
  [SMALL_STATE(6961)] = 266212,
  [SMALL_STATE(6962)] = 266225,
  [SMALL_STATE(6963)] = 266238,
  [SMALL_STATE(6964)] = 266251,
  [SMALL_STATE(6965)] = 266264,
  [SMALL_STATE(6966)] = 266277,
  [SMALL_STATE(6967)] = 266290,
  [SMALL_STATE(6968)] = 266303,
  [SMALL_STATE(6969)] = 266316,
  [SMALL_STATE(6970)] = 266329,
  [SMALL_STATE(6971)] = 266342,
  [SMALL_STATE(6972)] = 266355,
  [SMALL_STATE(6973)] = 266368,
  [SMALL_STATE(6974)] = 266381,
  [SMALL_STATE(6975)] = 266394,
  [SMALL_STATE(6976)] = 266407,
  [SMALL_STATE(6977)] = 266420,
  [SMALL_STATE(6978)] = 266433,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5431),
  [7] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 0),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1774),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3201),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1775),
  [15] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1564),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1978),
  [19] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2039),
  [21] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2920),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(382),
  [25] = {.entry = {.count = 1, .reusable = false}}, SHIFT(604),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(386),
  [29] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2919),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2908),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3211),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1999),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(387),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3122),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2323),
  [43] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2322),
  [45] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [47] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5156),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5158),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2321),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1019),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5166),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5168),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3604),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5080),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4703),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4653),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4704),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6918),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6263),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6909),
  [77] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [79] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6908),
  [81] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6907),
  [83] = {.entry = {.count = 1, .reusable = false}}, SHIFT(268),
  [85] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6906),
  [87] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5034),
  [89] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2319),
  [91] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6903),
  [93] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6902),
  [95] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6517),
  [97] = {.entry = {.count = 1, .reusable = false}}, SHIFT(638),
  [99] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6519),
  [101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1960),
  [103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4459),
  [105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6143),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6859),
  [113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1731),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(173),
  [117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6721),
  [119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6838),
  [121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6836),
  [123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6831),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6537),
  [127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2267),
  [129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [131] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5335),
  [133] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 1),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 2),
  [137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1935),
  [139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2054),
  [141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 3),
  [143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(384),
  [145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4709),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 4),
  [149] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2),
  [151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(1774),
  [154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(3916),
  [157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(1775),
  [160] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(1564),
  [163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(1935),
  [166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(2054),
  [169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(3357),
  [172] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(383),
  [175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(604),
  [178] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(386),
  [181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(3376),
  [184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(3878),
  [187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(2042),
  [190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(428),
  [193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(3454),
  [196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(2323),
  [199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(2322),
  [202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(14),
  [205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(1019),
  [208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2),
  [210] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(2321),
  [213] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(1019),
  [216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6040),
  [219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(4653),
  [222] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(4704),
  [225] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6918),
  [228] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6263),
  [231] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6909),
  [234] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(52),
  [237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6908),
  [240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6907),
  [243] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(268),
  [246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6906),
  [249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(5034),
  [252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(2319),
  [255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6903),
  [258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6902),
  [261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6517),
  [264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(638),
  [267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6519),
  [270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(1960),
  [273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(4459),
  [276] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(5584),
  [279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6143),
  [282] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(5587),
  [285] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6859),
  [288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(1731),
  [291] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(173),
  [294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6721),
  [297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6838),
  [300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6836),
  [303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6831),
  [306] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(6537),
  [309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(2267),
  [312] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(2267),
  [315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 2), SHIFT_REPEAT(5335),
  [318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3916),
  [320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1672),
  [322] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2055),
  [324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3357),
  [326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(615),
  [330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3376),
  [332] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3917),
  [334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2042),
  [336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3445),
  [340] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6040),
  [344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6784),
  [346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6225),
  [348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6969),
  [350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6819),
  [354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6911),
  [356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [358] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6964),
  [360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4993),
  [362] = {.entry = {.count = 1, .reusable = false}}, SHIFT(342),
  [364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4502),
  [366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6816),
  [368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6814),
  [370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6508),
  [372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(611),
  [374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6484),
  [376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1898),
  [378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5234),
  [380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_section, 2),
  [390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_section, 2),
  [392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3039),
  [396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(479),
  [398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(478),
  [400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6639),
  [402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2870),
  [404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2174),
  [408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [414] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1774),
  [417] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(3916),
  [420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1775),
  [423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1672),
  [426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1935),
  [429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2055),
  [432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(3357),
  [435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(383),
  [438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(615),
  [441] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(386),
  [444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(3376),
  [447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(3917),
  [450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2042),
  [453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(428),
  [456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(3445),
  [459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2323),
  [462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2322),
  [465] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(18),
  [468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2),
  [470] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1019),
  [473] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2321),
  [476] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1019),
  [479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6040),
  [482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(4653),
  [485] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(4704),
  [488] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6784),
  [491] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6225),
  [494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6969),
  [497] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(69),
  [500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6819),
  [503] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6911),
  [506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(255),
  [509] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6964),
  [512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(4993),
  [515] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2),
  [517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2319),
  [520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6816),
  [523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6814),
  [526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6508),
  [529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(611),
  [532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6484),
  [535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1898),
  [538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(4459),
  [541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(5584),
  [544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6143),
  [547] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(5587),
  [550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6859),
  [553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(1731),
  [556] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(173),
  [559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6721),
  [562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6838),
  [565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6836),
  [568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6831),
  [571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(6537),
  [574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2267),
  [577] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(2267),
  [580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 2), SHIFT_REPEAT(5234),
  [583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2192),
  [587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2471),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2933),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1647),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1552),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1551),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2924),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2053),
  [623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3875),
  [625] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3454),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6910),
  [631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6962),
  [633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(256),
  [635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6977),
  [637] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [639] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6913),
  [641] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3878),
  [643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1780),
  [645] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5016),
  [647] = {.entry = {.count = 1, .reusable = false}}, SHIFT(977),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(136),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4707),
  [655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4806),
  [657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4082),
  [659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(460),
  [661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(469),
  [663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1752),
  [665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4527),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(242),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2860),
  [673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1089),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4603),
  [679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4608),
  [681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6649),
  [683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1024),
  [685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2875),
  [687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6213),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1033),
  [693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5656),
  [695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6210),
  [697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6828),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6829),
  [705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6499),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2878),
  [709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4714),
  [713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(143),
  [715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2899),
  [719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1974),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2634),
  [725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 2),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2646),
  [729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5007),
  [731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 2),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4818),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3939),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1353),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2780),
  [747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1386),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6136),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6507),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6851),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1356),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2777),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1355),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4466),
  [769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5599),
  [771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6105),
  [773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6847),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1738),
  [779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(163),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6848),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6975),
  [785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6849),
  [787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6850),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2770),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2770),
  [795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 1),
  [797] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 1),
  [799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2645),
  [801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2672),
  [803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4970),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4767),
  [813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3932),
  [815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2872),
  [819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1439),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6195),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6558),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6830),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4461),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6826),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1739),
  [843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6827),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6974),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5019),
  [851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(397),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4799),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1207),
  [857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1452),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1452),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1461),
  [863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1465),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2059),
  [869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2058),
  [871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2063),
  [873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4956),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4759),
  [881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4033),
  [883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2110),
  [887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2109),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1466),
  [893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1466),
  [895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2129),
  [897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6121),
  [899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6496),
  [901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6808),
  [903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1464),
  [905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2108),
  [907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4445),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5651),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6151),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5647),
  [917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6804),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6805),
  [923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6973),
  [925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6806),
  [927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6807),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6476),
  [931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2106),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4989),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4807),
  [941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1017),
  [945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(171),
  [949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2091),
  [951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2066),
  [953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4965),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(446),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(415),
  [959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4762),
  [961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3937),
  [963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6180),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6613),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1302),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1037),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1311),
  [981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1311),
  [983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6493),
  [985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4969),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4776),
  [991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4020),
  [993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1155),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1136),
  [999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6592),
  [1001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1141),
  [1003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1151),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(177),
  [1007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5003),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(445),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(413),
  [1013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4822),
  [1015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3930),
  [1017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1472),
  [1019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3071),
  [1021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3093),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [1027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1469),
  [1029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3123),
  [1031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6174),
  [1033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6497),
  [1035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6776),
  [1037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1470),
  [1039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3100),
  [1041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [1043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4469),
  [1045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5576),
  [1047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6200),
  [1049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5577),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6813),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(188),
  [1057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6767),
  [1059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6965),
  [1061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6624),
  [1063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6798),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6506),
  [1067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3027),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [1071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4972),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(398),
  [1075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4792),
  [1077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1094),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [1081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1098),
  [1083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1096),
  [1085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1095),
  [1087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [1091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5029),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [1095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4786),
  [1097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1034),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [1101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(772),
  [1103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1036),
  [1105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1035),
  [1107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1740),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(185),
  [1111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4971),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(406),
  [1115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4782),
  [1117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3950),
  [1119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1192),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1189),
  [1123] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1189),
  [1125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6581),
  [1127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1190),
  [1129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1191),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [1133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2632),
  [1135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4961),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [1139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4755),
  [1141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1412),
  [1145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [1147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [1149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [1153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4988),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [1157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4761),
  [1159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1121),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [1163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1127),
  [1165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1124),
  [1167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1122),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [1171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5011),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [1175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4757),
  [1177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1056),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [1181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(865),
  [1183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1058),
  [1185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1057),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(191),
  [1189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5017),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [1193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4803),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1321),
  [1197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(915),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1323),
  [1203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1322),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(193),
  [1207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4962),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(409),
  [1211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4752),
  [1213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1340),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1214),
  [1217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1214),
  [1219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1213),
  [1221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1339),
  [1223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1743),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [1227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4964),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [1231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4768),
  [1233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(909),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [1237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1062),
  [1239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [1241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [1243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1750),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [1247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4960),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(391),
  [1251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4773),
  [1253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(934),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(803),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(936),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [1263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1747),
  [1265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [1267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4998),
  [1269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [1271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4816),
  [1273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4028),
  [1275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1488),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [1279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(996),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6621),
  [1283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(995),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1749),
  [1289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(210),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4999),
  [1293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(425),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4742),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [1299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [1301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(938),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [1307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [1311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4995),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [1315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4763),
  [1317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(798),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [1321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(715),
  [1323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(801),
  [1325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(800),
  [1327] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1745),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [1331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5028),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [1335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4790),
  [1337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(711),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [1341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(914),
  [1343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(713),
  [1345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(712),
  [1347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1748),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(203),
  [1351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5022),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(422),
  [1355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4802),
  [1357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(815),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [1361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [1363] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1254),
  [1365] = {.entry = {.count = 1, .reusable = false}}, SHIFT(809),
  [1367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1744),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [1371] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4991),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(411),
  [1375] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4748),
  [1377] = {.entry = {.count = 1, .reusable = false}}, SHIFT(769),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(714),
  [1381] = {.entry = {.count = 1, .reusable = false}}, SHIFT(714),
  [1383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(771),
  [1385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(770),
  [1387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1746),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [1391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5004),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [1395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4778),
  [1397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1176),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1180),
  [1401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1180),
  [1403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1178),
  [1405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1177),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [1409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5000),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(400),
  [1413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4753),
  [1415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3976),
  [1417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(874),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(802),
  [1421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(802),
  [1423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6490),
  [1425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(806),
  [1427] = {.entry = {.count = 1, .reusable = false}}, SHIFT(873),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [1431] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5010),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [1435] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4779),
  [1437] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1528),
  [1441] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1528),
  [1443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1526),
  [1445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1525),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [1449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4986),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [1453] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4788),
  [1455] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3992),
  [1457] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1276),
  [1461] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [1463] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6513),
  [1465] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [1467] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1268),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [1471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4973),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(404),
  [1475] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4758),
  [1477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4016),
  [1479] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1298),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(733),
  [1483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(733),
  [1485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1300),
  [1487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1299),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(220),
  [1491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4980),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(424),
  [1495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4804),
  [1497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(751),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(754),
  [1503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(753),
  [1505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(752),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [1509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5002),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(420),
  [1513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4824),
  [1515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1005),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1011),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1007),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1006),
  [1525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4984),
  [1529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(799),
  [1535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(869),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(870),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [1543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4974),
  [1547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4756),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(730),
  [1553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(860),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(732),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(731),
  [1561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [1563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4985),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4817),
  [1569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(881),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(888),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(885),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(884),
  [1579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5001),
  [1583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(395),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4829),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(958),
  [1589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(963),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(960),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(959),
  [1597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(236),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5013),
  [1601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(393),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4815),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(827),
  [1607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(832),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(830),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(828),
  [1615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [1617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4992),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [1621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4775),
  [1623] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1152),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1156),
  [1627] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1156),
  [1629] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1154),
  [1631] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1153),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [1635] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1873),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6672),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6934),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1823),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6638),
  [1655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1997),
  [1657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [1659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1232),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2956),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1232),
  [1669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2284),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6630),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6681),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3041),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2859),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2195),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2911),
  [1695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2047),
  [1697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6967),
  [1699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2048),
  [1701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6666),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2325),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2749),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2130),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3097),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3001),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [1719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2050),
  [1721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6920),
  [1723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(987),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(158),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [1731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5953),
  [1733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1765),
  [1735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1851),
  [1737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(276),
  [1739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(899),
  [1745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1919),
  [1747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2011),
  [1749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [1751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3336),
  [1753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(979),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [1759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(327),
  [1761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1001),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(151),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [1767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(273),
  [1769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(968),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [1775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [1777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(736),
  [1779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [1781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [1783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(304),
  [1785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1328),
  [1787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [1789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1328),
  [1791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(347),
  [1793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1015),
  [1795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(140),
  [1797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [1799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1763),
  [1801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1799),
  [1803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(294),
  [1805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2821),
  [1807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1004),
  [1809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(148),
  [1811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [1813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(279),
  [1815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1046),
  [1817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(138),
  [1819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [1821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1883),
  [1823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1970),
  [1825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(308),
  [1827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1009),
  [1829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [1831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [1833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [1835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1010),
  [1837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [1839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [1841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(284),
  [1843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [1845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(155),
  [1847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1445),
  [1849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1885),
  [1851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [1853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [1855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3067),
  [1857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1012),
  [1859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(150),
  [1861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [1863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(286),
  [1865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [1867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1014),
  [1869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(156),
  [1871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [1873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [1875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(850),
  [1877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [1879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [1881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [1883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1261),
  [1885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [1887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [1889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [1891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1134),
  [1893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(146),
  [1895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [1897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(354),
  [1899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [1901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [1903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(913),
  [1905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [1907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(974),
  [1909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [1911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [1913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [1915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [1917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [1919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1503),
  [1921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1901),
  [1923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2018),
  [1925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(359),
  [1927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(845),
  [1929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [1931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(845),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [1937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6674),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6653),
  [1941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(462),
  [1943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6031),
  [1947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [1949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_modifier, 1),
  [1951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_modifier, 1),
  [1953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2711),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [1959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [1961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [1963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2966),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2832),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(471),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [1971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(465),
  [1973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(467),
  [1975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [1977] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 2),
  [1979] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 2),
  [1981] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_block, 2), REDUCE(sym_initializer_expression, 2),
  [1984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 2),
  [1986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_block, 2), REDUCE(sym_initializer_expression, 2),
  [1989] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 2),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(704),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4936),
  [2001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(388),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4821),
  [2005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6777),
  [2007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [2009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6746),
  [2011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2931),
  [2013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6898),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [2017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6664),
  [2019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6501),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6952),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2201),
  [2027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2209),
  [2031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2089),
  [2035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2330),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2761),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3079),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [2045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2930),
  [2047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2918),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2686),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2803),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3117),
  [2061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4868),
  [2063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4941),
  [2065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4935),
  [2067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4866),
  [2069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4894),
  [2071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2742),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2224),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [2077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4948),
  [2079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4955),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4874),
  [2083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3099),
  [2085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4847),
  [2087] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 1),
  [2089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4884),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4916),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2923),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(19),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(21),
  [2101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [2103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [2105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [2107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(68),
  [2109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [2111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [2113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [2115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(115),
  [2119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [2121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(110),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(103),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(101),
  [2129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [2133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [2135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3077),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(51),
  [2139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1608),
  [2143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1692),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1716),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [2153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(643),
  [2155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [2157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [2159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [2161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [2163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [2165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(49),
  [2167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [2171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2799),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2834),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [2187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 2, .production_id = 4),
  [2189] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 2, .production_id = 4),
  [2191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5886),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6622),
  [2195] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 3, .production_id = 4),
  [2197] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 3, .production_id = 4),
  [2199] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [2201] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [2203] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(5886),
  [2206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 4, .production_id = 26),
  [2208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 4, .production_id = 26),
  [2210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 3, .production_id = 19),
  [2212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 3, .production_id = 19),
  [2214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_block, 3),
  [2216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_block, 3),
  [2218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_try_statement_repeat1, 1),
  [2220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 1),
  [2222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_clause, 2, .production_id = 4),
  [2224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_catch_clause, 2, .production_id = 4),
  [2226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 2),
  [2228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2),
  [2230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 2), SHIFT_REPEAT(6789),
  [2233] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat2, 2),
  [2235] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat2, 2),
  [2237] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat2, 2), SHIFT_REPEAT(6792),
  [2240] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat2, 2), SHIFT_REPEAT(4664),
  [2243] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat3, 2),
  [2245] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat3, 2),
  [2247] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat3, 2), SHIFT_REPEAT(6541),
  [2250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_each_statement, 8, .production_id = 145),
  [2252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_each_statement, 8, .production_id = 145),
  [2254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 5, .production_id = 60),
  [2256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 5, .production_id = 60),
  [2258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 3),
  [2260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 3),
  [2262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3),
  [2264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3),
  [2266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checked_statement, 2),
  [2268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_checked_statement, 2),
  [2270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 3, .production_id = 17),
  [2272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 3, .production_id = 17),
  [2274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_empty_statement, 1),
  [2276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_empty_statement, 1),
  [2278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_do_statement, 7),
  [2280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_do_statement, 7),
  [2282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 103),
  [2284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 103),
  [2286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 104),
  [2288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 104),
  [2290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 5, .production_id = 41),
  [2292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_statement, 5, .production_id = 41),
  [2294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 7, .production_id = 105),
  [2296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 7, .production_id = 105),
  [2298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 7, .production_id = 122),
  [2300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 7, .production_id = 122),
  [2302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_break_statement, 2),
  [2304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_break_statement, 2),
  [2306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 7, .production_id = 121),
  [2308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 7, .production_id = 121),
  [2310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 205),
  [2312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 205),
  [2314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_each_statement, 7, .production_id = 106),
  [2316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_each_statement, 7, .production_id = 106),
  [2318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 7, .production_id = 107),
  [2320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 7, .production_id = 107),
  [2322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 204),
  [2324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 204),
  [2326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5882),
  [2328] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6554),
  [2330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 10, .production_id = 203),
  [2332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 10, .production_id = 203),
  [2334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 2, .production_id = 38),
  [2336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 2, .production_id = 38),
  [2338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 2),
  [2340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 2),
  [2342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 5, .production_id = 56),
  [2344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 5, .production_id = 56),
  [2346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 5, .production_id = 57),
  [2348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 5, .production_id = 57),
  [2350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_continue_statement, 2),
  [2352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_continue_statement, 2),
  [2354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, .production_id = 85),
  [2356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, .production_id = 85),
  [2358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, .production_id = 84),
  [2360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, .production_id = 84),
  [2362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_each_statement, 9, .production_id = 183),
  [2364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_each_statement, 9, .production_id = 183),
  [2366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 182),
  [2368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 182),
  [2370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 181),
  [2372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 181),
  [2374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 180),
  [2376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 180),
  [2378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 179),
  [2380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 179),
  [2382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 9, .production_id = 178),
  [2384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 9, .production_id = 178),
  [2386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 5, .production_id = 55),
  [2388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 5, .production_id = 55),
  [2390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lock_statement, 5),
  [2392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lock_statement, 5),
  [2394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_statement, 5, .production_id = 54),
  [2396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_if_statement, 5, .production_id = 54),
  [2398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(87),
  [2400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 11, .production_id = 213),
  [2402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 11, .production_id = 213),
  [2404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 2),
  [2406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 2),
  [2408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 5),
  [2410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 5),
  [2412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_while_statement, 5),
  [2414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_while_statement, 5),
  [2416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 8, .production_id = 158),
  [2418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 8, .production_id = 158),
  [2420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unsafe_statement, 2),
  [2422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unsafe_statement, 2),
  [2424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, .production_id = 78),
  [2426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, .production_id = 78),
  [2428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_goto_statement, 4),
  [2430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_goto_statement, 4),
  [2432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_fixed_statement, 5),
  [2434] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_fixed_statement, 5),
  [2436] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1),
  [2438] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1),
  [2440] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 4),
  [2442] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 4),
  [2444] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_statement, 6, .production_id = 76),
  [2446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_statement, 6, .production_id = 76),
  [2448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 2),
  [2450] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 2),
  [2452] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 6, .production_id = 76),
  [2454] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 6, .production_id = 76),
  [2456] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 6, .production_id = 87),
  [2458] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 6, .production_id = 87),
  [2460] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_body, 2),
  [2462] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_body, 2),
  [2464] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_return_statement, 3),
  [2466] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_return_statement, 3),
  [2468] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_labeled_statement, 3, .production_id = 24),
  [2470] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_labeled_statement, 3, .production_id = 24),
  [2472] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_finally_clause, 2),
  [2474] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_finally_clause, 2),
  [2476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 4, .production_id = 39),
  [2478] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 4, .production_id = 39),
  [2480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 1, .production_id = 38),
  [2482] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 1, .production_id = 38),
  [2484] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__function_body, 1),
  [2486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__function_body, 1),
  [2488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_function_statement, 7, .production_id = 115),
  [2490] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_function_statement, 7, .production_id = 115),
  [2492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_statement, 2),
  [2494] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_statement, 2),
  [2496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 3),
  [2498] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 3),
  [2500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_statement, 3),
  [2502] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_statement, 3),
  [2504] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_each_statement, 8, .production_id = 146),
  [2506] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_each_statement, 8, .production_id = 146),
  [2508] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_local_declaration_statement, 3),
  [2510] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_local_declaration_statement, 3),
  [2512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 144),
  [2514] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 144),
  [2516] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 143),
  [2518] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 143),
  [2520] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_yield_statement, 4),
  [2522] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_yield_statement, 4),
  [2524] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_statement, 3, .production_id = 18),
  [2526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_statement, 3, .production_id = 18),
  [2528] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 142),
  [2530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 142),
  [2532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_try_statement, 4, .production_id = 4),
  [2534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_try_statement, 4, .production_id = 4),
  [2536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 141),
  [2538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 141),
  [2540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_for_statement, 8, .production_id = 140),
  [2542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_for_statement, 8, .production_id = 140),
  [2544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute_list, 6),
  [2546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute_list, 6),
  [2548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 3),
  [2550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 3),
  [2552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat2, 1),
  [2554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat2, 1),
  [2556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat4, 1),
  [2558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat4, 1),
  [2560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat1, 1),
  [2562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat1, 1),
  [2564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 5),
  [2566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 5),
  [2568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(5882),
  [2571] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute_list, 5),
  [2573] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute_list, 5),
  [2575] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat3, 1),
  [2577] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_compilation_unit_repeat3, 1),
  [2579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_using_directive, 4),
  [2581] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_using_directive, 4),
  [2583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_statement, 1),
  [2585] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_statement, 1),
  [2587] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_extern_alias_directive, 4),
  [2589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_extern_alias_directive, 4),
  [2591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_global_attribute_list, 4),
  [2593] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_global_attribute_list, 4),
  [2595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3931),
  [2598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2726),
  [2601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(3936),
  [2604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(4681),
  [2607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(4667),
  [2610] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2919),
  [2613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(4568),
  [2616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(4472),
  [2619] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(4431),
  [2622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(2961),
  [2625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2),
  [2627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(6947),
  [2630] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(5164),
  [2633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(5394),
  [2636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(5398),
  [2639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(5403),
  [2642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(5416),
  [2645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(4150),
  [2648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(5072),
  [2651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(4710),
  [2654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(4653),
  [2657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(4565),
  [2660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 2), SHIFT_REPEAT(4686),
  [2663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3931),
  [2665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2726),
  [2667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3936),
  [2669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4681),
  [2671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4667),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [2675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4472),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [2679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2961),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5070),
  [2683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6947),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5164),
  [2687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5394),
  [2689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5398),
  [2691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5403),
  [2693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5416),
  [2695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4150),
  [2697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5072),
  [2699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4710),
  [2701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4565),
  [2703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4686),
  [2705] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_switch_section_repeat1, 2),
  [2707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_section_repeat1, 2),
  [2709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_section_repeat1, 2), SHIFT_REPEAT(342),
  [2712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_switch_section_repeat1, 2), SHIFT_REPEAT(6822),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2231),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5114),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [2721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [2723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__contextual_keywords, 1), SHIFT(3931),
  [2726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__contextual_keywords, 1), SHIFT(3936),
  [2729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__contextual_keywords, 1),
  [2731] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__contextual_keywords, 1), SHIFT(3943),
  [2734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__contextual_keywords, 1),
  [2736] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__contextual_keywords, 1), SHIFT(4431),
  [2739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6691),
  [2741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_block_repeat1, 1),
  [2743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_block_repeat1, 1),
  [2745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_switch_label, 2),
  [2747] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_switch_label, 2),
  [2749] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_pattern_switch_label, 4),
  [2751] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_pattern_switch_label, 4),
  [2753] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_switch_section_repeat1, 1),
  [2755] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_section_repeat1, 1),
  [2757] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_switch_label, 3),
  [2759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_switch_label, 3),
  [2761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_case_pattern_switch_label, 3),
  [2763] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_case_pattern_switch_label, 3),
  [2765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3943),
  [2767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4647),
  [2769] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_this_expression, 1),
  [2771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_this_expression, 1),
  [2773] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_this_expression, 1), SHIFT(4431),
  [2776] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2643),
  [2778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [2780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_expression, 3, .production_id = 20),
  [2782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_expression, 3, .production_id = 20),
  [2784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(500),
  [2786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [2788] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1801),
  [2790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_pattern, 1),
  [2792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2811),
  [2794] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_pattern, 1),
  [2796] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_pattern, 1), SHIFT(241),
  [2799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_pattern, 1), SHIFT(2644),
  [2802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2947),
  [2804] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_pattern, 1), SHIFT(240),
  [2807] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 1),
  [2809] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 1),
  [2811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 2),
  [2813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 2),
  [2815] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_type, 1),
  [2817] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_type, 1),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4731),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4728),
  [2823] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 3),
  [2825] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 3),
  [2827] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__simple_name, 1),
  [2829] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__simple_name, 1),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4909),
  [2833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_identifier, 1),
  [2835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_identifier, 1),
  [2837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1), SHIFT(3999),
  [2840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4880),
  [2842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [2844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_global, 1), REDUCE(sym__contextual_keywords, 1),
  [2847] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_global, 1), REDUCE(sym__contextual_keywords, 1),
  [2850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_qualified_name, 3),
  [2852] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_qualified_name, 3), REDUCE(sym_member_access_expression, 3, .production_id = 16),
  [2855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_qualified_name, 3), REDUCE(sym_member_access_expression, 3, .production_id = 16),
  [2858] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_qualified_name, 3),
  [2860] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 6),
  [2862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 6),
  [2864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3007),
  [2866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_generic_name, 2),
  [2868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_generic_name, 2),
  [2870] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_pattern, 1), SHIFT(238),
  [2873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_pattern, 1), SHIFT(1775),
  [2876] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 2),
  [2878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 2),
  [2880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_pattern_clause, 5),
  [2882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_pattern_clause, 5),
  [2884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_alias_qualified_name, 3),
  [2886] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_alias_qualified_name, 3),
  [2888] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__name, 1),
  [2890] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__name, 1),
  [2892] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type, 1),
  [2894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type, 1),
  [2896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type, 1), REDUCE(sym__nullable_base_type, 1),
  [2899] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 3),
  [2901] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 3),
  [2903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 5),
  [2905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 5),
  [2907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4888),
  [2909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4888),
  [2911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 3),
  [2913] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 3),
  [2915] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pointer_type, 2),
  [2917] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pointer_type, 2),
  [2919] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__name, 1), REDUCE(sym_constant_pattern, 1),
  [2922] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__name, 1), REDUCE(sym_constant_pattern, 1), REDUCE(sym__expression, 1),
  [2926] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym__name, 1), REDUCE(sym_constant_pattern, 1), REDUCE(sym__expression, 1),
  [2930] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__name, 1), REDUCE(sym_constant_pattern, 1),
  [2933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 5),
  [2935] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 5),
  [2937] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_rank_specifier, 4),
  [2939] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_rank_specifier, 4),
  [2941] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_type, 6),
  [2943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_type, 6),
  [2945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_function_pointer_type, 7),
  [2947] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_type, 7),
  [2949] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 2),
  [2951] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 2),
  [2953] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_type, 2, .production_id = 5),
  [2955] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_type, 2, .production_id = 5),
  [2957] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_argument_list, 4),
  [2959] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_argument_list, 4),
  [2961] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_nullable_type, 2),
  [2963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullable_type, 2),
  [2965] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_pattern_clause, 2),
  [2967] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_pattern_clause, 2),
  [2969] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 2),
  [2971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_positional_pattern_clause, 6),
  [2973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_positional_pattern_clause, 6),
  [2975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3309),
  [2977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 2),
  [2979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 2),
  [2981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [2983] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_pattern, 1), SHIFT(239),
  [2986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_pattern, 1), SHIFT(2066),
  [2989] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 3),
  [2991] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 3),
  [2993] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_access_expression, 3, .production_id = 16),
  [2995] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_access_expression, 3, .production_id = 16),
  [2997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1), SHIFT(1076),
  [3000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__variable_designation, 1),
  [3002] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1), SHIFT(2030),
  [3005] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 4),
  [3007] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 4),
  [3009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [3011] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_type_pattern, 1), SHIFT(2058),
  [3014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_pattern_clause, 5),
  [3016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_pattern_clause, 5),
  [3018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4921),
  [3020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [3022] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2855),
  [3024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4411),
  [3026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6706),
  [3028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5216),
  [3030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5382),
  [3032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5381),
  [3034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5378),
  [3036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5375),
  [3038] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4207),
  [3040] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5138),
  [3042] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4691),
  [3044] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1), REDUCE(sym_parameter, 1, .production_id = 1),
  [3047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4896),
  [3049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4882),
  [3051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4735),
  [3053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1061),
  [3055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6842),
  [3057] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 3),
  [3059] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 3),
  [3061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [3063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [3065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4920),
  [3067] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__expression, 1),
  [3069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__name, 1), REDUCE(sym__expression, 1),
  [3072] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__name, 1), REDUCE(sym__expression, 1),
  [3075] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__expression, 1),
  [3077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4834),
  [3079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4475),
  [3081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6935),
  [3083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5346),
  [3085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5342),
  [3087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5341),
  [3089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5340),
  [3091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4164),
  [3093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5074),
  [3095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4693),
  [3097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [3099] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1), REDUCE(sym_parameter, 2, .production_id = 11),
  [3102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [3104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2030),
  [3106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_expression_colon, 2),
  [3108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_expression_colon, 2),
  [3110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, .production_id = 11),
  [3112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [3114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6963),
  [3116] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5285),
  [3118] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5300),
  [3120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5301),
  [3122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5307),
  [3124] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4328),
  [3126] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5069),
  [3128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5313),
  [3130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4862),
  [3132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [3134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4889),
  [3136] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4927),
  [3138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4927),
  [3140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4944),
  [3142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4942),
  [3144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4940),
  [3146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4665),
  [3148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4954),
  [3150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(53),
  [3152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4934),
  [3154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4924),
  [3156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4885),
  [3158] = {.entry = {.count = 1, .reusable = false}}, SHIFT(59),
  [3160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [3162] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4883),
  [3164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6418),
  [3166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(430),
  [3168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [3170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6914),
  [3172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2107),
  [3174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2115),
  [3176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4886),
  [3178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4947),
  [3180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4926),
  [3182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4857),
  [3184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4879),
  [3186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4939),
  [3188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4939),
  [3190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4900),
  [3192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4915),
  [3194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4933),
  [3196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4879),
  [3198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5296),
  [3200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5294),
  [3202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5292),
  [3204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5289),
  [3206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4362),
  [3208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5105),
  [3210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5263),
  [3212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_name_colon, 2),
  [3214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_name_colon, 2),
  [3216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4569),
  [3218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3901),
  [3220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [3222] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_name_equals, 2),
  [3224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_name_equals, 2),
  [3226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3062),
  [3228] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [3230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_operator, 1),
  [3232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_operator, 1),
  [3234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 2, .production_id = 3),
  [3236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 2, .production_id = 3),
  [3238] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [3240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [3242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2097),
  [3244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [3246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(453),
  [3248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [3250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [3252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [3254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2149),
  [3256] = {.entry = {.count = 1, .reusable = true}}, SHIFT(454),
  [3258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(457),
  [3260] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5339),
  [3262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, .production_id = 13),
  [3264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, .production_id = 13),
  [3266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stack_alloc_array_creation_expression, 2),
  [3268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stack_alloc_array_creation_expression, 2),
  [3270] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym_stack_alloc_array_creation_expression, 2),
  [3273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__nullable_base_type, 1), REDUCE(sym_stack_alloc_array_creation_expression, 2),
  [3276] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type, 1), REDUCE(sym_stack_alloc_array_creation_expression, 2),
  [3279] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), REDUCE(sym_array_creation_expression, 2, .dynamic_precedence = 17),
  [3282] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type, 1), REDUCE(sym_array_creation_expression, 2, .dynamic_precedence = 17),
  [3285] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), SHIFT(520),
  [3288] = {.entry = {.count = 3, .reusable = false}}, REDUCE(sym__type, 1), REDUCE(sym__nullable_base_type, 1), REDUCE(sym_array_creation_expression, 2, .dynamic_precedence = 17),
  [3292] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_object_creation_expression, 2),
  [3294] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_object_creation_expression, 2),
  [3296] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1), SHIFT(4030),
  [3299] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), SHIFT(519),
  [3302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_as_expression, 3, .production_id = 20),
  [3304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_as_expression, 3, .production_id = 20),
  [3306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 3),
  [3308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 3),
  [3310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 2),
  [3312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 2),
  [3314] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [3316] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument_list, 4),
  [3318] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_argument_list, 4),
  [3320] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_expression, 4),
  [3322] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_expression, 4),
  [3324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 5),
  [3326] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 5),
  [3328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 5),
  [3330] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 5),
  [3332] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_array_creation_expression, 5),
  [3334] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_array_creation_expression, 5),
  [3336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__literal, 1),
  [3338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal, 1),
  [3340] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_expression, 1),
  [3342] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_expression, 1),
  [3344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [3346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_expression, 1),
  [3348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_base_expression, 1),
  [3350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 5, .production_id = 41),
  [3352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 5, .production_id = 41),
  [3354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_expression, 4),
  [3356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_expression, 4),
  [3358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_query_expression, 2),
  [3360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_query_expression, 2),
  [3362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_postfix_unary_expression, 2),
  [3364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_postfix_unary_expression, 2),
  [3366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_access_expression, 2, .production_id = 6),
  [3368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_access_expression, 2, .production_id = 6),
  [3370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_invocation_expression, 2, .production_id = 7),
  [3372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_invocation_expression, 2, .production_id = 7),
  [3374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_access_expression, 3, .production_id = 21),
  [3376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_access_expression, 3, .production_id = 21),
  [3378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_query_continuation, 3),
  [3380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_query_continuation, 3),
  [3382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 5),
  [3384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 5),
  [3386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_expression, 5),
  [3388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_with_expression, 5),
  [3390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_boolean_literal, 1),
  [3392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_boolean_literal, 1),
  [3394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 7),
  [3396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 7),
  [3398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_argument_list, 3),
  [3400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracketed_argument_list, 3),
  [3402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 6),
  [3404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 6),
  [3406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_value_expression, 6, .production_id = 77),
  [3408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_value_expression, 6, .production_id = 77),
  [3410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 2),
  [3412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 2),
  [3414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_expression, 3),
  [3416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_expression, 3),
  [3418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression, 4),
  [3420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_switch_expression, 4),
  [3422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 6),
  [3424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 6),
  [3426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 3),
  [3428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 3),
  [3430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_member_binding_expression, 2, .production_id = 12),
  [3432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_member_binding_expression, 2, .production_id = 12),
  [3434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_expression, 2),
  [3436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_expression, 2),
  [3438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 3),
  [3440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 3),
  [3442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 2),
  [3444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 2),
  [3446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_element_binding_expression, 1),
  [3448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_element_binding_expression, 1),
  [3450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_of_expression, 4),
  [3452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_of_expression, 4),
  [3454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 3),
  [3456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 3),
  [3458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_size_of_expression, 4),
  [3460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_size_of_expression, 4),
  [3462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_type_expression, 4),
  [3464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_type_expression, 4),
  [3466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_make_ref_expression, 4),
  [3468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_make_ref_expression, 4),
  [3470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_stack_alloc_array_creation_expression, 4),
  [3472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_stack_alloc_array_creation_expression, 4),
  [3474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_default_expression, 4, .production_id = 37),
  [3476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_default_expression, 4, .production_id = 37),
  [3478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_checked_expression, 4),
  [3480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_checked_expression, 4),
  [3482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_initializer_expression, 4),
  [3484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_initializer_expression, 4),
  [3486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 4, .production_id = 31),
  [3488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 4, .production_id = 31),
  [3490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_object_creation_expression, 4),
  [3492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_object_creation_expression, 4),
  [3494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__select_or_group_clause, 1),
  [3496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__select_or_group_clause, 1),
  [3498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_array_creation_expression, 4),
  [3500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_array_creation_expression, 4),
  [3502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_anonymous_method_expression, 4),
  [3504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_anonymous_method_expression, 4),
  [3506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_argument_list, 4),
  [3508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bracketed_argument_list, 4),
  [3510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 4, .production_id = 26),
  [3512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 4, .production_id = 26),
  [3514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 2),
  [3516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 2),
  [3518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_lambda_expression, 3, .production_id = 19),
  [3520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_lambda_expression, 3, .production_id = 19),
  [3522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_implicit_object_creation_expression, 3),
  [3524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_implicit_object_creation_expression, 3),
  [3526] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_character_literal, 3),
  [3528] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_character_literal, 3),
  [3530] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_string_literal, 3),
  [3532] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_string_literal, 3),
  [3534] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_expression, 3),
  [3536] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_expression, 3),
  [3538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_object_creation_expression, 3, .production_id = 14),
  [3540] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_object_creation_expression, 3, .production_id = 14),
  [3542] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_stack_alloc_array_creation_expression, 3),
  [3544] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_stack_alloc_array_creation_expression, 3),
  [3546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_array_creation_expression, 3, .dynamic_precedence = 17),
  [3548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_array_creation_expression, 3, .dynamic_precedence = 17),
  [3550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 35),
  [3552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [3554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 35),
  [3556] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 3, .production_id = 15),
  [3558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2532),
  [3560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 3, .production_id = 15),
  [3562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 101),
  [3564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2581),
  [3566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 101),
  [3568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 101),
  [3570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2580),
  [3572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 101),
  [3574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, .production_id = 92),
  [3576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [3578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 92),
  [3580] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 101),
  [3582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [3584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 101),
  [3586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 3, .production_id = 15),
  [3588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [3590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 3, .production_id = 15),
  [3592] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_list, 2),
  [3594] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_list, 2),
  [3596] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 35),
  [3598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [3600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 35),
  [3602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, .production_id = 35),
  [3604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [3606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, .production_id = 35),
  [3608] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 35),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [3612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 35),
  [3614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 112),
  [3616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2588),
  [3618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 112),
  [3620] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 3, .production_id = 15),
  [3622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2557),
  [3624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 3, .production_id = 15),
  [3626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_member_declaration_list, 5),
  [3628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 5),
  [3630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 3, .production_id = 15),
  [3632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [3634] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 3, .production_id = 15),
  [3636] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 3, .production_id = 15),
  [3638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2550),
  [3640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 3, .production_id = 15),
  [3642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 113),
  [3644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2590),
  [3646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 113),
  [3648] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 3),
  [3650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 3),
  [3652] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 43),
  [3654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [3656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 43),
  [3658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 44),
  [3660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2350),
  [3662] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 44),
  [3664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 114),
  [3666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2591),
  [3668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 114),
  [3670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 45),
  [3672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2351),
  [3674] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 45),
  [3676] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 112),
  [3678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2592),
  [3680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 112),
  [3682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 43),
  [3684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [3686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 43),
  [3688] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 113),
  [3690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2594),
  [3692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 113),
  [3694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 44),
  [3696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [3698] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 44),
  [3700] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 83),
  [3702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2544),
  [3704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 83),
  [3706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 45),
  [3708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [3710] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 45),
  [3712] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 82),
  [3714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [3716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 82),
  [3718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_member_declaration_list, 3),
  [3720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 3),
  [3722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 81),
  [3724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [3726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 81),
  [3728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 43),
  [3730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2357),
  [3732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 43),
  [3734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, .production_id = 82),
  [3736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2538),
  [3738] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, .production_id = 82),
  [3740] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 44),
  [3742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [3744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 44),
  [3746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 83),
  [3748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [3750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 83),
  [3752] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 45),
  [3754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2360),
  [3756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 45),
  [3758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 82),
  [3760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [3762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 82),
  [3764] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 114),
  [3766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2595),
  [3768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 114),
  [3770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 81),
  [3772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [3774] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 81),
  [3776] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 83),
  [3778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [3780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 83),
  [3782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 82),
  [3784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [3786] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 82),
  [3788] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 81),
  [3790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [3792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 81),
  [3794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 112),
  [3796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [3798] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 112),
  [3800] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 113),
  [3802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2598),
  [3804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 113),
  [3806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 114),
  [3808] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2599),
  [3810] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 114),
  [3812] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, .production_id = 134),
  [3814] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1536),
  [3816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 134),
  [3818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, .production_id = 166),
  [3820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1531),
  [3822] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 166),
  [3824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [3826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 34),
  [3828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2444),
  [3830] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 34),
  [3832] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 33),
  [3834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [3836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 33),
  [3838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 72),
  [3840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [3842] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 72),
  [3844] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 71),
  [3846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [3848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 71),
  [3850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 70),
  [3852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2504),
  [3854] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 70),
  [3856] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 32),
  [3858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2447),
  [3860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 32),
  [3862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 72),
  [3864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [3866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 72),
  [3868] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 71),
  [3870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [3872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 71),
  [3874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 33),
  [3876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [3878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 33),
  [3880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_member_declaration_list, 2),
  [3882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 2),
  [3884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, .production_id = 34),
  [3886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2450),
  [3888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, .production_id = 34),
  [3890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, .production_id = 33),
  [3892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2451),
  [3894] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, .production_id = 33),
  [3896] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, .production_id = 32),
  [3898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2452),
  [3900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, .production_id = 32),
  [3902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 34),
  [3904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [3906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 34),
  [3908] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 33),
  [3910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2455),
  [3912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 33),
  [3914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 70),
  [3916] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2500),
  [3918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 70),
  [3920] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 32),
  [3922] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [3924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 32),
  [3926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_list, 2),
  [3928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_list, 2),
  [3930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 72),
  [3932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [3934] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 72),
  [3936] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 71),
  [3938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [3940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 71),
  [3942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, .production_id = 125),
  [3944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [3946] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 125),
  [3948] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 150),
  [3950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2616),
  [3952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 150),
  [3954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 48),
  [3956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [3958] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 48),
  [3960] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 49),
  [3962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2397),
  [3964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 49),
  [3966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 70),
  [3968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2496),
  [3970] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 70),
  [3972] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 50),
  [3974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2399),
  [3976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 50),
  [3978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 48),
  [3980] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [3982] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 48),
  [3984] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 49),
  [3986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [3988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 49),
  [3990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, .production_id = 150),
  [3992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2617),
  [3994] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, .production_id = 150),
  [3996] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 50),
  [3998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2405),
  [4000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 50),
  [4002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 49),
  [4004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [4006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 49),
  [4008] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, .production_id = 150),
  [4010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2618),
  [4012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, .production_id = 150),
  [4014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 48),
  [4016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [4018] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 48),
  [4020] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 49),
  [4022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [4024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 49),
  [4026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 50),
  [4028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [4030] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 50),
  [4032] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_list, 3),
  [4034] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_list, 3),
  [4036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [4038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, .production_id = 89),
  [4040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1354),
  [4042] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 89),
  [4044] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 59),
  [4046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2439),
  [4048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 59),
  [4050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 59),
  [4052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [4054] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 59),
  [4056] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 59),
  [4058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [4060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 59),
  [4062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 59),
  [4064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [4066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 59),
  [4068] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 64),
  [4070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [4072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 64),
  [4074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 64),
  [4076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [4078] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 64),
  [4080] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_member_declaration_list, 4),
  [4082] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration_list, 4),
  [4084] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 64),
  [4086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2472),
  [4088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 64),
  [4090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 3, .production_id = 61),
  [4092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [4094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 3, .production_id = 61),
  [4096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 44),
  [4098] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 44),
  [4100] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 159),
  [4102] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 159),
  [4104] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 49),
  [4106] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 49),
  [4108] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 44),
  [4110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 44),
  [4112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 45),
  [4114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 45),
  [4116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 43),
  [4118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 43),
  [4120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 59),
  [4122] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 59),
  [4124] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 7, .production_id = 195),
  [4126] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 7, .production_id = 195),
  [4128] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 45),
  [4130] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 45),
  [4132] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 50),
  [4134] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 50),
  [4136] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 43),
  [4138] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 43),
  [4140] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 7, .production_id = 196),
  [4142] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 7, .production_id = 196),
  [4144] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 44),
  [4146] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 44),
  [4148] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 45),
  [4150] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 45),
  [4152] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, .production_id = 194),
  [4154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, .production_id = 194),
  [4156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 6, .production_id = 46),
  [4158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 6, .production_id = 46),
  [4160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 6, .production_id = 66),
  [4162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 6, .production_id = 66),
  [4164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 67),
  [4166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 67),
  [4168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 3, .dynamic_precedence = 1),
  [4170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 3, .dynamic_precedence = 1),
  [4172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 68),
  [4174] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 68),
  [4176] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, .production_id = 191),
  [4178] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 191),
  [4180] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 69),
  [4182] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 69),
  [4184] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 3, .production_id = 62),
  [4186] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 3, .production_id = 62),
  [4188] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 70),
  [4190] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 70),
  [4192] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 48),
  [4194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 48),
  [4196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 71),
  [4198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 71),
  [4200] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 72),
  [4202] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 72),
  [4204] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 73),
  [4206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 73),
  [4208] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 74),
  [4210] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 74),
  [4212] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 7, .production_id = 197),
  [4214] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 7, .production_id = 197),
  [4216] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 75),
  [4218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 75),
  [4220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 64),
  [4222] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 64),
  [4224] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 4, .production_id = 95),
  [4226] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 4, .production_id = 95),
  [4228] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 4, .production_id = 30),
  [4230] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 4, .production_id = 30),
  [4232] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, .production_id = 193),
  [4234] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, .production_id = 193),
  [4236] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, .production_id = 115),
  [4238] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 115),
  [4240] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, .production_id = 198),
  [4242] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 198),
  [4244] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 47),
  [4246] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 47),
  [4248] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 5, .production_id = 59),
  [4250] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 5, .production_id = 59),
  [4252] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, .production_id = 192),
  [4254] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 192),
  [4256] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 3),
  [4258] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 3),
  [4260] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, .production_id = 165),
  [4262] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, .production_id = 165),
  [4264] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 35),
  [4266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 35),
  [4268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 35),
  [4270] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 35),
  [4272] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, .production_id = 121),
  [4274] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 121),
  [4276] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, .production_id = 122),
  [4278] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 122),
  [4280] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 35),
  [4282] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 35),
  [4284] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 48),
  [4286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 48),
  [4288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 35),
  [4290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 35),
  [4292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 49),
  [4294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 49),
  [4296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, .production_id = 190),
  [4298] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, .production_id = 190),
  [4300] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 50),
  [4302] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 50),
  [4304] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 7, .production_id = 189),
  [4306] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 7, .production_id = 189),
  [4308] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 48),
  [4310] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 48),
  [4312] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 87),
  [4314] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 87),
  [4316] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 49),
  [4318] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 49),
  [4320] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 6, .production_id = 177),
  [4322] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 6, .production_id = 177),
  [4324] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 50),
  [4326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 50),
  [4328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, .production_id = 49),
  [4330] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, .production_id = 49),
  [4332] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 48),
  [4334] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 48),
  [4336] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 4, .production_id = 91),
  [4338] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 4, .production_id = 91),
  [4340] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 49),
  [4342] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 49),
  [4344] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, .production_id = 176),
  [4346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 176),
  [4348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 50),
  [4350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 50),
  [4352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 6, .production_id = 79),
  [4354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 6, .production_id = 79),
  [4356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 45),
  [4358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 45),
  [4360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 80),
  [4362] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 80),
  [4364] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 44),
  [4366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 44),
  [4368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 43),
  [4370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 43),
  [4372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 53),
  [4374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 53),
  [4376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 81),
  [4378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 81),
  [4380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, .production_id = 199),
  [4382] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, .production_id = 199),
  [4384] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 82),
  [4386] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 82),
  [4388] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 52),
  [4390] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 52),
  [4392] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 83),
  [4394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 83),
  [4396] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 67),
  [4398] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 67),
  [4400] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 68),
  [4402] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 68),
  [4404] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 69),
  [4406] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 69),
  [4408] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 5, .production_id = 51),
  [4410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 5, .production_id = 51),
  [4412] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 70),
  [4414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 70),
  [4416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 5, .production_id = 50),
  [4418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 5, .production_id = 50),
  [4420] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 71),
  [4422] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 71),
  [4424] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 72),
  [4426] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 72),
  [4428] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 5, .production_id = 49),
  [4430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 5, .production_id = 49),
  [4432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 5, .production_id = 48),
  [4434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 5, .production_id = 48),
  [4436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 2),
  [4438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 2),
  [4440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 4, .dynamic_precedence = 1),
  [4442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 4, .dynamic_precedence = 1),
  [4444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, .production_id = 175),
  [4446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, .production_id = 175),
  [4448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 59),
  [4450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 59),
  [4452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 5, .production_id = 47),
  [4454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 5, .production_id = 47),
  [4456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 4, .production_id = 94),
  [4458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 4, .production_id = 94),
  [4460] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 5, .production_id = 46),
  [4462] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 5, .production_id = 46),
  [4464] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 6, .production_id = 59),
  [4466] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 6, .production_id = 59),
  [4468] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 34),
  [4470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 34),
  [4472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 33),
  [4474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 33),
  [4476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 6, .production_id = 59),
  [4478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 6, .production_id = 59),
  [4480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 5, .production_id = 32),
  [4482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 5, .production_id = 32),
  [4484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 5, .production_id = 33),
  [4486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 5, .production_id = 33),
  [4488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 6, .production_id = 59),
  [4490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 6, .production_id = 59),
  [4492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 34),
  [4494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 34),
  [4496] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 33),
  [4498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 33),
  [4500] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 5, .production_id = 32),
  [4502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 5, .production_id = 32),
  [4504] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 34),
  [4506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 34),
  [4508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 86),
  [4510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 6, .production_id = 86),
  [4512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 33),
  [4514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 33),
  [4516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 5, .production_id = 32),
  [4518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 5, .production_id = 32),
  [4520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 80),
  [4522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 80),
  [4524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [4526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [4528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2695),
  [4530] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_declaration_list_repeat1, 1),
  [4532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_declaration_list_repeat1, 1),
  [4534] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__declaration, 1),
  [4536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__declaration, 1),
  [4538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 81),
  [4540] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 81),
  [4542] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, .production_id = 172),
  [4544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 172),
  [4546] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 82),
  [4548] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 82),
  [4550] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, .production_id = 174),
  [4552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, .production_id = 174),
  [4554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 6, .production_id = 83),
  [4556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 6, .production_id = 83),
  [4558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 5, .production_id = 123),
  [4560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 5, .production_id = 123),
  [4562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 64),
  [4564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 64),
  [4566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 64),
  [4568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 64),
  [4570] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 64),
  [4572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 64),
  [4574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, .production_id = 173),
  [4576] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, .production_id = 173),
  [4578] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, .production_id = 66),
  [4580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, .production_id = 66),
  [4582] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 98),
  [4584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 98),
  [4586] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 99),
  [4588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 99),
  [4590] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 85),
  [4592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 85),
  [4594] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 100),
  [4596] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 100),
  [4598] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 101),
  [4600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 101),
  [4602] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 102),
  [4604] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 102),
  [4606] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 7, .production_id = 200),
  [4608] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 7, .production_id = 200),
  [4610] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, .production_id = 171),
  [4612] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, .production_id = 171),
  [4614] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 4, .production_id = 39),
  [4616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 4, .production_id = 39),
  [4618] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 7, .production_id = 201),
  [4620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 7, .production_id = 201),
  [4622] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 7, .production_id = 202),
  [4624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 7, .production_id = 202),
  [4626] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 6, .production_id = 170),
  [4628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 6, .production_id = 170),
  [4630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, .production_id = 35),
  [4632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, .production_id = 35),
  [4634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, .production_id = 169),
  [4636] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, .production_id = 169),
  [4638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 4, .production_id = 90),
  [4640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 4, .production_id = 90),
  [4642] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 84),
  [4644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 84),
  [4646] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 4, .production_id = 89),
  [4648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 4, .production_id = 89),
  [4650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 168),
  [4652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 168),
  [4654] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 6, .production_id = 167),
  [4656] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 6, .production_id = 167),
  [4658] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 6, .production_id = 166),
  [4660] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 6, .production_id = 166),
  [4662] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, .production_id = 124),
  [4664] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, .production_id = 124),
  [4666] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 70),
  [4668] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 70),
  [4670] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 6, .production_id = 43),
  [4672] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 6, .production_id = 43),
  [4674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 71),
  [4676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 71),
  [4678] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 72),
  [4680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 72),
  [4682] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 70),
  [4684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 70),
  [4686] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructor_declaration, 6, .production_id = 164),
  [4688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructor_declaration, 6, .production_id = 164),
  [4690] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 71),
  [4692] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 71),
  [4694] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 72),
  [4696] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 72),
  [4698] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 70),
  [4700] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 70),
  [4702] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 6, .production_id = 163),
  [4704] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 6, .production_id = 163),
  [4706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 71),
  [4708] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 71),
  [4710] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 72),
  [4712] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 72),
  [4714] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, .production_id = 79),
  [4716] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, .production_id = 79),
  [4718] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, .production_id = 108),
  [4720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, .production_id = 108),
  [4722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 109),
  [4724] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 109),
  [4726] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 6, .production_id = 161),
  [4728] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 6, .production_id = 161),
  [4730] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 110),
  [4732] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 110),
  [4734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 78),
  [4736] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 78),
  [4738] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 111),
  [4740] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 111),
  [4742] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 6, .production_id = 160),
  [4744] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 6, .production_id = 160),
  [4746] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 112),
  [4748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 112),
  [4750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 9, .production_id = 215),
  [4752] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 9, .production_id = 215),
  [4754] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 113),
  [4756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 113),
  [4758] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 114),
  [4760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 114),
  [4762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 98),
  [4764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 98),
  [4766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 99),
  [4768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 99),
  [4770] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, .production_id = 125),
  [4772] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, .production_id = 125),
  [4774] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 100),
  [4776] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 100),
  [4778] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 101),
  [4780] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 101),
  [4782] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conversion_operator_declaration, 5, .production_id = 126),
  [4784] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conversion_operator_declaration, 5, .production_id = 126),
  [4786] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 81),
  [4788] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 81),
  [4790] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_field_declaration, 5, .dynamic_precedence = 1),
  [4792] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_field_declaration, 5, .dynamic_precedence = 1),
  [4794] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 82),
  [4796] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 82),
  [4798] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__record_body, 1),
  [4800] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_body, 1),
  [4802] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 7, .production_id = 83),
  [4804] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 7, .production_id = 83),
  [4806] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_namespace_declaration, 4, .production_id = 15),
  [4808] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_namespace_declaration, 4, .production_id = 15),
  [4810] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 81),
  [4812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 81),
  [4814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, .production_id = 34),
  [4816] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, .production_id = 34),
  [4818] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 82),
  [4820] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 82),
  [4822] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 3, .production_id = 15),
  [4824] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 3, .production_id = 15),
  [4826] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 7, .production_id = 83),
  [4828] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 7, .production_id = 83),
  [4830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 7, .production_id = 82),
  [4832] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 7, .production_id = 82),
  [4834] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, .production_id = 33),
  [4836] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, .production_id = 33),
  [4838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 81),
  [4840] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 81),
  [4842] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 127),
  [4844] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 127),
  [4846] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 82),
  [4848] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 82),
  [4850] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, .production_id = 32),
  [4852] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, .production_id = 32),
  [4854] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 7, .production_id = 83),
  [4856] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 7, .production_id = 83),
  [4858] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 7, .production_id = 116),
  [4860] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 7, .production_id = 116),
  [4862] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 5, .production_id = 138),
  [4864] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 5, .production_id = 138),
  [4866] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 117),
  [4868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 117),
  [4870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 4, .production_id = 36),
  [4872] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 4, .production_id = 36),
  [4874] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 4, .production_id = 35),
  [4876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 4, .production_id = 35),
  [4878] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 4, .production_id = 15),
  [4880] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 4, .production_id = 15),
  [4882] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 118),
  [4884] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 118),
  [4886] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_enum_declaration, 4, .production_id = 15),
  [4888] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_declaration, 4, .production_id = 15),
  [4890] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 119),
  [4892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 119),
  [4894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 4, .production_id = 15),
  [4896] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 4, .production_id = 15),
  [4898] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 120),
  [4900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 7, .production_id = 120),
  [4902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 109),
  [4904] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 109),
  [4906] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 4, .production_id = 15),
  [4908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 4, .production_id = 15),
  [4910] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 110),
  [4912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 110),
  [4914] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor_declaration, 5, .production_id = 137),
  [4916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_declaration, 5, .production_id = 137),
  [4918] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 111),
  [4920] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 111),
  [4922] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, .production_id = 136),
  [4924] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 136),
  [4926] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 112),
  [4928] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 112),
  [4930] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, .production_id = 207),
  [4932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, .production_id = 207),
  [4934] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 113),
  [4936] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 113),
  [4938] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 7, .production_id = 114),
  [4940] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 7, .production_id = 114),
  [4942] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 8, .production_id = 208),
  [4944] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 8, .production_id = 208),
  [4946] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, .production_id = 209),
  [4948] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, .production_id = 209),
  [4950] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, .production_id = 210),
  [4952] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, .production_id = 210),
  [4954] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 139),
  [4956] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 139),
  [4958] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 56),
  [4960] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 56),
  [4962] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, .production_id = 135),
  [4964] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, .production_id = 135),
  [4966] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 8, .production_id = 158),
  [4968] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 8, .production_id = 158),
  [4970] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 8, .production_id = 211),
  [4972] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 8, .production_id = 211),
  [4974] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 57),
  [4976] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 57),
  [4978] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_field_declaration, 4),
  [4980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_field_declaration, 4),
  [4982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, .production_id = 128),
  [4984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, .production_id = 128),
  [4986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 8, .production_id = 212),
  [4988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 8, .production_id = 212),
  [4990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 9, .production_id = 214),
  [4992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 9, .production_id = 214),
  [4994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 101),
  [4996] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 101),
  [4998] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, .production_id = 101),
  [5000] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, .production_id = 101),
  [5002] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, .production_id = 101),
  [5004] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, .production_id = 101),
  [5006] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 8, .production_id = 108),
  [5008] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 8, .production_id = 108),
  [5010] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 147),
  [5012] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 147),
  [5014] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 148),
  [5016] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 148),
  [5018] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 149),
  [5020] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 149),
  [5022] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 150),
  [5024] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 150),
  [5026] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, .production_id = 139),
  [5028] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, .production_id = 139),
  [5030] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 112),
  [5032] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 112),
  [5034] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_method_declaration, 5, .production_id = 60),
  [5036] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_method_declaration, 5, .production_id = 60),
  [5038] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 113),
  [5040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 113),
  [5042] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 8, .production_id = 114),
  [5044] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 8, .production_id = 114),
  [5046] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, .production_id = 112),
  [5048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, .production_id = 112),
  [5050] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_operator_declaration, 5, .production_id = 129),
  [5052] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_operator_declaration, 5, .production_id = 129),
  [5054] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, .production_id = 113),
  [5056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, .production_id = 113),
  [5058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 8, .production_id = 114),
  [5060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 8, .production_id = 114),
  [5062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, .production_id = 112),
  [5064] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, .production_id = 112),
  [5066] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, .production_id = 134),
  [5068] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, .production_id = 134),
  [5070] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, .production_id = 113),
  [5072] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, .production_id = 113),
  [5074] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 8, .production_id = 114),
  [5076] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 8, .production_id = 114),
  [5078] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 8, .production_id = 116),
  [5080] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 8, .production_id = 116),
  [5082] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 8, .production_id = 151),
  [5084] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 8, .production_id = 151),
  [5086] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 152),
  [5088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 152),
  [5090] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 153),
  [5092] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 153),
  [5094] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 154),
  [5096] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 154),
  [5098] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 155),
  [5100] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 155),
  [5102] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 156),
  [5104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 156),
  [5106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 157),
  [5108] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 8, .production_id = 157),
  [5110] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, .production_id = 147),
  [5112] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, .production_id = 147),
  [5114] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, .production_id = 148),
  [5116] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, .production_id = 148),
  [5118] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, .production_id = 149),
  [5120] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, .production_id = 149),
  [5122] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 8, .production_id = 150),
  [5124] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 8, .production_id = 150),
  [5126] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_event_declaration, 5, .production_id = 133),
  [5128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_event_declaration, 5, .production_id = 133),
  [5130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 5, .production_id = 131),
  [5132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 5, .production_id = 131),
  [5134] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 9, .production_id = 184),
  [5136] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 9, .production_id = 184),
  [5138] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_class_declaration, 9, .production_id = 150),
  [5140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_class_declaration, 9, .production_id = 150),
  [5142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_struct_declaration, 9, .production_id = 150),
  [5144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_struct_declaration, 9, .production_id = 150),
  [5146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interface_declaration, 9, .production_id = 150),
  [5148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interface_declaration, 9, .production_id = 150),
  [5150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delegate_declaration, 9, .production_id = 151),
  [5152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delegate_declaration, 9, .production_id = 151),
  [5154] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 9, .production_id = 185),
  [5156] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 9, .production_id = 185),
  [5158] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 9, .production_id = 186),
  [5160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 9, .production_id = 186),
  [5162] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 9, .production_id = 187),
  [5164] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 9, .production_id = 187),
  [5166] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 9, .production_id = 188),
  [5168] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 9, .production_id = 188),
  [5170] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_declaration, 9, .production_id = 184),
  [5172] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_declaration, 9, .production_id = 184),
  [5174] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_indexer_declaration, 5, .production_id = 130),
  [5176] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_indexer_declaration, 5, .production_id = 130),
  [5178] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_property_declaration, 4, .production_id = 93),
  [5180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_property_declaration, 4, .production_id = 93),
  [5182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record_struct_declaration, 10, .production_id = 206),
  [5184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_struct_declaration, 10, .production_id = 206),
  [5186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_event_field_declaration_repeat1, 2),
  [5188] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_event_field_declaration_repeat1, 2), SHIFT_REPEAT(4568),
  [5191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_event_field_declaration_repeat1, 2),
  [5193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4897),
  [5195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [5197] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1), SHIFT(4047),
  [5200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(490),
  [5202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(436),
  [5204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2754),
  [5206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(438),
  [5208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), SHIFT(518),
  [5211] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_expression, 3, .production_id = 20),
  [5213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1473),
  [5215] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_expression, 3, .production_id = 20),
  [5217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3038),
  [5219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3038),
  [5221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1474),
  [5223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1475),
  [5225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1476),
  [5227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1477),
  [5229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1478),
  [5231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1479),
  [5233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1480),
  [5235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [5237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6953),
  [5239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [5241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [5243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6938),
  [5245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1481),
  [5247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [5249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [5251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4493),
  [5253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2040),
  [5255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [5257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(514),
  [5259] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_assignment_expression, 3, .production_id = 23),
  [5261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [5263] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), SHIFT(544),
  [5266] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_group_clause, 4),
  [5268] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_group_clause, 4),
  [5270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_conditional_expression, 5, .production_id = 58),
  [5272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_conditional_expression, 5, .production_id = 58),
  [5274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 3),
  [5276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 3),
  [5278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_prefix_unary_expression, 2),
  [5280] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_prefix_unary_expression, 2),
  [5282] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_await_expression, 2),
  [5284] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_await_expression, 2),
  [5286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [5288] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__simple_name, 1), SHIFT(3942),
  [5291] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_event_field_declaration_repeat1, 1),
  [5293] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_event_field_declaration_repeat1, 1),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [5297] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 5),
  [5299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 5),
  [5301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_throw_expression, 2),
  [5303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_throw_expression, 2),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4835),
  [5307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_ref_expression, 2),
  [5309] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_ref_expression, 2),
  [5311] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_relational_pattern, 2),
  [5313] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_relational_pattern, 2),
  [5315] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 6),
  [5317] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 6),
  [5319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_cast_expression, 4, .production_id = 28),
  [5321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_cast_expression, 4, .production_id = 28),
  [5323] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_event_field_declaration_repeat2, 2),
  [5325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_event_field_declaration_repeat2, 2), SHIFT_REPEAT(2919),
  [5328] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_event_field_declaration_repeat2, 2),
  [5330] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_event_field_declaration_repeat2, 2), SHIFT_REPEAT(2961),
  [5333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_range_expression, 3),
  [5335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_range_expression, 3),
  [5337] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_select_clause, 2),
  [5339] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_select_clause, 2),
  [5341] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_list, 4),
  [5343] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_list, 4),
  [5345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1347),
  [5347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(517),
  [5349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1352),
  [5351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1357),
  [5353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1358),
  [5355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1360),
  [5357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1363),
  [5359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1365),
  [5361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1366),
  [5363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1347),
  [5365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [5367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [5369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1370),
  [5371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1372),
  [5373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [5375] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type, 1), SHIFT(529),
  [5378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_is_pattern_expression, 3, .production_id = 22),
  [5380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_is_pattern_expression, 3, .production_id = 22),
  [5382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [5384] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 4),
  [5386] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 4),
  [5388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_recursive_pattern, 4),
  [5390] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_recursive_pattern, 4),
  [5392] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 3),
  [5394] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 3),
  [5396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binary_pattern, 3, .production_id = 20),
  [5398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binary_pattern, 3, .production_id = 20),
  [5400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_variable_designation, 2),
  [5402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_variable_designation, 2),
  [5404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_pattern, 3),
  [5406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_pattern, 3),
  [5408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_pattern, 2, .production_id = 2),
  [5410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_declaration_pattern, 2, .production_id = 2),
  [5412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_pattern, 2),
  [5414] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_pattern, 2),
  [5416] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__variable_designation, 1),
  [5418] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constant_pattern, 1),
  [5420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_constant_pattern, 1), REDUCE(sym__expression, 1),
  [5423] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_constant_pattern, 1), REDUCE(sym__expression, 1),
  [5426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constant_pattern, 1),
  [5428] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern, 1),
  [5430] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern, 1),
  [5432] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5254),
  [5436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4685),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [5440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4538),
  [5442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4937),
  [5444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [5446] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__query_body, 1),
  [5448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_body, 1),
  [5450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [5452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1174),
  [5454] = {.entry = {.count = 1, .reusable = false}}, SHIFT(539),
  [5456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1173),
  [5458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1172),
  [5460] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1171),
  [5462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1170),
  [5464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1169),
  [5466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1168),
  [5468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [5470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [5472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(328),
  [5474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [5476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [5478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [5480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1162),
  [5482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [5484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6102),
  [5486] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_event_field_declaration_repeat2, 1),
  [5488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_event_field_declaration_repeat2, 1),
  [5490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4891),
  [5492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1489),
  [5494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2119),
  [5496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2119),
  [5498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1490),
  [5500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [5502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [5504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [5506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6949),
  [5508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [5512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6950),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [5516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(700),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1498),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1520),
  [5522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [5524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1519),
  [5526] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1518),
  [5528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1517),
  [5530] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1516),
  [5532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1515),
  [5534] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1514),
  [5536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1513),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [5540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(322),
  [5542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(218),
  [5544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1510),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1509),
  [5548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1508),
  [5550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [5552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1495),
  [5554] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1496),
  [5556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1501),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [5564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [5566] = {.entry = {.count = 1, .reusable = false}}, SHIFT(337),
  [5568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_negated_pattern, 2),
  [5570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_negated_pattern, 2),
  [5572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ordering, 1),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5701),
  [5576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [5580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [5582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4856),
  [5584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(38),
  [5586] = {.entry = {.count = 1, .reusable = false}}, SHIFT(749),
  [5588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2337),
  [5590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [5592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(748),
  [5594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(747),
  [5596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(746),
  [5598] = {.entry = {.count = 1, .reusable = false}}, SHIFT(745),
  [5600] = {.entry = {.count = 1, .reusable = false}}, SHIFT(744),
  [5602] = {.entry = {.count = 1, .reusable = false}}, SHIFT(743),
  [5604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [5606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(749),
  [5608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [5610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(363),
  [5612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [5614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6905),
  [5616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [5618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1351),
  [5620] = {.entry = {.count = 1, .reusable = false}}, SHIFT(540),
  [5622] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2751),
  [5624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2751),
  [5626] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1350),
  [5628] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1349),
  [5630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1348),
  [5632] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1345),
  [5634] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1344),
  [5636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1342),
  [5638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1341),
  [5640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1351),
  [5642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6738),
  [5644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [5646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [5648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6735),
  [5650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1336),
  [5652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1334),
  [5654] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1332),
  [5656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [5658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(644),
  [5660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2), SHIFT_REPEAT(1774),
  [5663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2), SHIFT_REPEAT(4525),
  [5666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2), SHIFT_REPEAT(1775),
  [5669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 2), SHIFT_REPEAT(4557),
  [5672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2), SHIFT_REPEAT(4514),
  [5675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 2),
  [5677] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2), SHIFT_REPEAT(5906),
  [5680] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 2), SHIFT_REPEAT(5909),
  [5683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [5685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(351),
  [5687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1150),
  [5689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_clause, 9),
  [5691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(545),
  [5693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1149),
  [5695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1148),
  [5697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1147),
  [5699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1146),
  [5701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1144),
  [5703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1143),
  [5705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [5707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1150),
  [5709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [5711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [5713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [5715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [5717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [5719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1138),
  [5721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(510),
  [5723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [5727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(739),
  [5729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5280),
  [5731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4525),
  [5733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [5735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4514),
  [5737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [5739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5906),
  [5741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5909),
  [5743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_clause, 8),
  [5745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5347),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5331),
  [5753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5388),
  [5755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4952),
  [5757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6221),
  [5759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [5761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4572),
  [5763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5151),
  [5765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [5767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [5769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4838),
  [5771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1460),
  [5773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4938),
  [5775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1459),
  [5777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1458),
  [5779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1457),
  [5781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1456),
  [5783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1455),
  [5785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1454),
  [5787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1453),
  [5789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1460),
  [5791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [5793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4938),
  [5795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [5797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1451),
  [5799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [5801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [5803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [5805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(997),
  [5807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(994),
  [5809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(993),
  [5811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(989),
  [5813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [5815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [5817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [5819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [5821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [5823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(516),
  [5825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2903),
  [5827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2903),
  [5829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1431),
  [5831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [5833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [5835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [5837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [5839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [5841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1425),
  [5843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [5845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6861),
  [5847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [5849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [5851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6857),
  [5853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1423),
  [5855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1422),
  [5857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [5859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4551),
  [5861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(525),
  [5863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(992),
  [5865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(991),
  [5867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(990),
  [5869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [5871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [5873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(983),
  [5875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5419),
  [5877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(538),
  [5879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5298),
  [5881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [5883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(329),
  [5885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [5887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1208),
  [5889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(535),
  [5891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1210),
  [5893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1211),
  [5895] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1212),
  [5897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1215),
  [5899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1219),
  [5901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1220),
  [5903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [5909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(167),
  [5911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1223),
  [5913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1224),
  [5915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1225),
  [5917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [5919] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_clause, 4),
  [5921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_where_clause, 2),
  [5923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(678),
  [5925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4543),
  [5927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4549),
  [5929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [5931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_let_clause, 4),
  [5933] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_from_clause, 5),
  [5935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [5937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(513),
  [5939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1411),
  [5941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [5943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [5945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [5947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [5949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [5951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1407),
  [5955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(277),
  [5957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(169),
  [5959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1438),
  [5961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [5963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [5965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5348),
  [5967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(340),
  [5969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [5971] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_event_field_declaration_repeat1, 2), SHIFT_REPEAT(4569),
  [5974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(358),
  [5976] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [5978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [5980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5891),
  [5982] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5893),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5332),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4895),
  [5988] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [5990] = {.entry = {.count = 1, .reusable = false}}, SHIFT(536),
  [5992] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [5994] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [5996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1236),
  [5998] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [6000] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1233),
  [6002] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [6004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [6006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [6008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(306),
  [6010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [6012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [6014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1227),
  [6016] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1226),
  [6018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4832),
  [6020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [6022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(175),
  [6024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(907),
  [6026] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [6028] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [6030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(904),
  [6032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [6034] = {.entry = {.count = 1, .reusable = false}}, SHIFT(902),
  [6036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(901),
  [6038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [6040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [6042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(301),
  [6044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(180),
  [6046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(898),
  [6048] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1158),
  [6050] = {.entry = {.count = 1, .reusable = false}}, SHIFT(522),
  [6052] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1160),
  [6054] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1165),
  [6056] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1166),
  [6058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1125),
  [6060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1179),
  [6062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1181),
  [6064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1182),
  [6066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [6068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(326),
  [6070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1183),
  [6072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1184),
  [6074] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1185),
  [6076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [6078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(189),
  [6080] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6968),
  [6082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5895),
  [6084] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6024),
  [6086] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5568),
  [6088] = {.entry = {.count = 1, .reusable = false}}, SHIFT(534),
  [6090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [6092] = {.entry = {.count = 1, .reusable = false}}, SHIFT(896),
  [6094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1032),
  [6096] = {.entry = {.count = 1, .reusable = false}}, SHIFT(524),
  [6098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1031),
  [6100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1030),
  [6102] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1029),
  [6104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1028),
  [6106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1027),
  [6108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1026),
  [6110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [6112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [6114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [6116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [6118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [6120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1021),
  [6122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5423),
  [6124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(26),
  [6126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [6128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5244),
  [6130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1069),
  [6132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [6134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4923),
  [6136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6815),
  [6138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5975),
  [6140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(537),
  [6142] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1070),
  [6144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1071),
  [6146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1072),
  [6148] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1081),
  [6150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1085),
  [6152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1093),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [6156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [6158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [6160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [6162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [6164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [6166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [6168] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1118),
  [6170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [6172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [6174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_event_field_declaration_repeat2, 2), SHIFT_REPEAT(3916),
  [6177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_event_field_declaration_repeat2, 2), SHIFT_REPEAT(3901),
  [6180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5995),
  [6182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [6184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [6186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1054),
  [6188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1053),
  [6190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1052),
  [6192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1051),
  [6194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1050),
  [6196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1049),
  [6198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1048),
  [6200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [6202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [6204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [6206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [6208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1319),
  [6210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1318),
  [6212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1317),
  [6214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1313),
  [6216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [6218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1319),
  [6220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [6222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(196),
  [6224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(710),
  [6226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(530),
  [6228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(709),
  [6230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(708),
  [6232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(707),
  [6234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1132),
  [6236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(778),
  [6238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(780),
  [6240] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [6242] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [6244] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [6246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [6248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [6250] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [6252] = {.entry = {.count = 1, .reusable = false}}, SHIFT(775),
  [6254] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1316),
  [6256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1315),
  [6258] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1314),
  [6260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [6262] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [6264] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1308),
  [6266] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4890),
  [6268] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [6270] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [6272] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4312),
  [6274] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4467),
  [6276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6525),
  [6278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1092),
  [6280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(507),
  [6282] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1091),
  [6284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1090),
  [6286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1087),
  [6288] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1086),
  [6290] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1084),
  [6292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1083),
  [6294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [6296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [6298] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [6300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [6302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [6304] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [6306] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1078),
  [6308] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [6310] = {.entry = {.count = 1, .reusable = false}}, SHIFT(767),
  [6312] = {.entry = {.count = 1, .reusable = false}}, SHIFT(766),
  [6314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(762),
  [6316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [6318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(547),
  [6320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [6322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [6324] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1043),
  [6326] = {.entry = {.count = 1, .reusable = false}}, SHIFT(532),
  [6328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [6330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [6332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2937),
  [6334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(768),
  [6336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(541),
  [6338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(765),
  [6340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(764),
  [6342] = {.entry = {.count = 1, .reusable = false}}, SHIFT(763),
  [6344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [6346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [6348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [6350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(760),
  [6352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [6354] = {.entry = {.count = 1, .reusable = false}}, SHIFT(758),
  [6356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [6358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [6360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [6362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2731),
  [6364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_equals_value_clause, 2),
  [6366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [6368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [6370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [6372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [6374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [6376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [6378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [6380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [6382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1399),
  [6384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1406),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(272),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(183),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1397),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1396),
  [6394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1395),
  [6396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2858),
  [6398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [6400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6118),
  [6402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5217),
  [6404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [6406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [6408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [6410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [6412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [6414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [6416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2),
  [6418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [6420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [6422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3048),
  [6424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1957),
  [6426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [6428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1119),
  [6430] = {.entry = {.count = 1, .reusable = false}}, SHIFT(521),
  [6432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1117),
  [6434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1114),
  [6436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1113),
  [6438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1112),
  [6440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1111),
  [6442] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1110),
  [6444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [6446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [6450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [6452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [6454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [6456] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1104),
  [6458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 2),
  [6460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(784),
  [6462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(61),
  [6464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [6466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(372),
  [6468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [6470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [6472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [6474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(932),
  [6476] = {.entry = {.count = 1, .reusable = false}}, SHIFT(528),
  [6478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [6480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(930),
  [6482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(929),
  [6484] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [6486] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [6488] = {.entry = {.count = 1, .reusable = false}}, SHIFT(926),
  [6490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [6492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [6494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(303),
  [6496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(199),
  [6498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [6500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [6502] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [6506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [6508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(794),
  [6510] = {.entry = {.count = 1, .reusable = false}}, SHIFT(526),
  [6512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(793),
  [6514] = {.entry = {.count = 1, .reusable = false}}, SHIFT(791),
  [6516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(790),
  [6518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(789),
  [6520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(788),
  [6522] = {.entry = {.count = 1, .reusable = false}}, SHIFT(787),
  [6524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(786),
  [6526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [6528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [6530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(782),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [6536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(777),
  [6538] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1193),
  [6540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(542),
  [6542] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1194),
  [6544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1195),
  [6546] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1196),
  [6548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1197),
  [6550] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1198),
  [6552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1199),
  [6554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1193),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [6560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1201),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1202),
  [6564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1203),
  [6566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [6568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [6570] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [6572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [6574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(209),
  [6576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(631),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5177),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2850),
  [6582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [6584] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 3),
  [6586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [6588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2037),
  [6590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2179),
  [6592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [6594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [6596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [6598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(117),
  [6600] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_argument, 1),
  [6602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2738),
  [6604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2212),
  [6606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [6608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [6610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [6612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(527),
  [6614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [6616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [6618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [6620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1373),
  [6622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1380),
  [6624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(289),
  [6626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1371),
  [6628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1369),
  [6630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [6632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [6634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(108),
  [6636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2681),
  [6638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5392),
  [6640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5401),
  [6642] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5911),
  [6644] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5907),
  [6646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [6648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [6650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [6652] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [6654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(102),
  [6656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(123),
  [6658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [6660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [6662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [6664] = {.entry = {.count = 1, .reusable = true}}, SHIFT(46),
  [6666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(647),
  [6668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3017),
  [6670] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2135),
  [6672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [6674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5420),
  [6676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [6678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5320),
  [6680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2928),
  [6682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [6684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4562),
  [6686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [6688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5384),
  [6690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6465),
  [6692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [6694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [6696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6955),
  [6698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2880),
  [6700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1796),
  [6702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6273),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(433),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [6708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6959),
  [6710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2778),
  [6712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2764),
  [6714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [6716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [6718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(543),
  [6720] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [6722] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [6724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1292),
  [6726] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1291),
  [6728] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1290),
  [6730] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [6732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1296),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [6738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1286),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1285),
  [6744] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [6748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [6750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6337),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [6756] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6961),
  [6758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2713),
  [6760] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2700),
  [6762] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 3, .production_id = 65),
  [6764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [6766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 2),
  [6768] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 4, .production_id = 97),
  [6770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(824),
  [6772] = {.entry = {.count = 1, .reusable = false}}, SHIFT(823),
  [6774] = {.entry = {.count = 1, .reusable = false}}, SHIFT(818),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [6778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(825),
  [6780] = {.entry = {.count = 1, .reusable = false}}, SHIFT(508),
  [6782] = {.entry = {.count = 1, .reusable = false}}, SHIFT(821),
  [6784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(820),
  [6786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(819),
  [6788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(817),
  [6790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [6792] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [6794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [6796] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [6798] = {.entry = {.count = 1, .reusable = false}}, SHIFT(811),
  [6800] = {.entry = {.count = 1, .reusable = false}}, SHIFT(956),
  [6802] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [6804] = {.entry = {.count = 1, .reusable = false}}, SHIFT(955),
  [6806] = {.entry = {.count = 1, .reusable = false}}, SHIFT(954),
  [6808] = {.entry = {.count = 1, .reusable = false}}, SHIFT(953),
  [6810] = {.entry = {.count = 1, .reusable = false}}, SHIFT(952),
  [6812] = {.entry = {.count = 1, .reusable = false}}, SHIFT(951),
  [6814] = {.entry = {.count = 1, .reusable = false}}, SHIFT(950),
  [6816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [6818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [6820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [6822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(229),
  [6824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [6826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [6828] = {.entry = {.count = 1, .reusable = false}}, SHIFT(945),
  [6830] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4844),
  [6832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5412),
  [6834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5338),
  [6836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [6838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [6840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6246),
  [6842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [6844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(483),
  [6846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6957),
  [6848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2068),
  [6850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [6852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5276),
  [6854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(634),
  [6856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5308),
  [6858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [6860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6533),
  [6862] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument, 2),
  [6864] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2072),
  [6866] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument, 1),
  [6868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(729),
  [6870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [6872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(728),
  [6874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(727),
  [6876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(726),
  [6878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(725),
  [6880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(724),
  [6882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(723),
  [6884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(722),
  [6886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(233),
  [6892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(721),
  [6894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(720),
  [6896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(719),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [6900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [6902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(374),
  [6904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5265),
  [6906] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [6908] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression_arm, 3),
  [6910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [6912] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_alignment_clause, 2),
  [6914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(283),
  [6916] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_simple_assignment_expression, 3),
  [6918] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_switch_expression_arm, 4),
  [6920] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4533),
  [6922] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__anonymous_object_member_declarator, 2, .dynamic_precedence = 1),
  [6924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_event_field_declaration_repeat1, 2), SHIFT_REPEAT(4557),
  [6927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__anonymous_object_member_declarator, 1),
  [6929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(834),
  [6931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(222),
  [6933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [6935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(871),
  [6937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [6939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(868),
  [6941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(867),
  [6943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(866),
  [6945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(864),
  [6947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(863),
  [6949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(862),
  [6951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [6953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [6955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [6957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [6959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [6961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(858),
  [6963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [6965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(856),
  [6967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(933),
  [6969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(505),
  [6971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [6973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(940),
  [6975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(942),
  [6977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(943),
  [6979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(948),
  [6981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [6983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [6985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [6987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [6989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [6991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [6993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [6995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(965),
  [6997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(270),
  [6999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(79),
  [7001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1390),
  [7003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [7005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2975),
  [7007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1388),
  [7009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2861),
  [7011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [7013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2970),
  [7015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4905),
  [7017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4905),
  [7019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(215),
  [7021] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 4, .production_id = 90),
  [7023] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 4, .production_id = 90),
  [7025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4841),
  [7027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [7029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(213),
  [7031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [7033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [7035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [7037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(89),
  [7039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [7041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(831),
  [7043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [7045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(833),
  [7047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(835),
  [7049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(836),
  [7051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(837),
  [7053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(840),
  [7055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [7057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [7059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [7061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(842),
  [7063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [7065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(844),
  [7067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4898),
  [7069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [7071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1188),
  [7073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [7075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [7077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2517),
  [7079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4853),
  [7081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1256),
  [7083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(523),
  [7085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [7087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1252),
  [7089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [7091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1250),
  [7093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1249),
  [7095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [7097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1247),
  [7099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [7101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [7103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [7105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [7107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1242),
  [7109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [7111] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 3, .production_id = 162),
  [7113] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 3, .production_id = 162),
  [7115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [7117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [7119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [7121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(332),
  [7123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(357),
  [7125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5220),
  [7127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1335),
  [7129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [7131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [7133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(366),
  [7135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [7137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(877),
  [7139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(878),
  [7141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(883),
  [7143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [7145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [7147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [7149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1612),
  [7151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5157),
  [7153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1359),
  [7155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [7157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1389),
  [7159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1676),
  [7161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1333),
  [7163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [7165] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_expression_clause, 2),
  [7167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [7169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_event_field_declaration_repeat2, 2), SHIFT_REPEAT(4525),
  [7172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_event_field_declaration_repeat2, 2), SHIFT_REPEAT(4514),
  [7175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(128),
  [7177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(119),
  [7179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [7181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [7183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5167),
  [7185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [7187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(84),
  [7189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [7191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [7193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [7195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [7197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [7199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [7201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [7203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(105),
  [7205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(86),
  [7207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [7209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(876),
  [7211] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_when_clause, 2),
  [7213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(531),
  [7215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(879),
  [7217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(880),
  [7219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(882),
  [7221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [7223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [7225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(295),
  [7227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [7229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [7231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(891),
  [7233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [7235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [7237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(287),
  [7239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [7241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2843),
  [7243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [7245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [7247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6704),
  [7249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [7251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [7253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [7255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2836),
  [7257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [7259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1705),
  [7261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [7263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6928),
  [7265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(66),
  [7267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [7269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [7271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [7273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1447),
  [7275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1217),
  [7277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [7279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(795),
  [7281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [7283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [7285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1245),
  [7287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [7289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [7291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [7293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [7295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [7297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [7299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [7301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [7303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(348),
  [7305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1494),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(57),
  [7311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [7313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1493),
  [7315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [7317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1511),
  [7319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1486),
  [7321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [7323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [7325] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_accessor_list_repeat1, 1),
  [7327] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_accessor_list_repeat1, 1),
  [7329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [7331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [7333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [7335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [7337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [7339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [7341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4464),
  [7343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6534),
  [7345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1258),
  [7347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6960),
  [7349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(912),
  [7351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1468),
  [7353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [7355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1361),
  [7357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(125),
  [7359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5322),
  [7361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [7363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [7365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [7367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [7369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1627),
  [7371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [7373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [7375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [7377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [7379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [7381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [7383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(919),
  [7385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1442),
  [7387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [7389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [7391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [7393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [7395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [7397] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_accessor_declaration, 2, .production_id = 132),
  [7399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_accessor_declaration, 2, .production_id = 132),
  [7401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1279),
  [7403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5319),
  [7405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [7407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(55),
  [7409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [7411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1622),
  [7413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [7415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [7417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [7419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [7421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [7423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(127),
  [7425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [7427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(71),
  [7429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [7431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [7433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [7435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [7437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [7439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1602),
  [7441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [7443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [7445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [7447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [7449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [7451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [7453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [7455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [7457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [7459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5326),
  [7461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [7463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [7465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5310),
  [7467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5421),
  [7469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6943),
  [7471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5356),
  [7473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [7475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(330),
  [7477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [7479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6972),
  [7481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [7483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6882),
  [7485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6478),
  [7487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6741),
  [7489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6956),
  [7491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [7493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [7495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5424),
  [7497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [7499] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_scoped_namespace_declaration, 3, .production_id = 12),
  [7501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3201),
  [7503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6792),
  [7505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4664),
  [7507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [7509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [7511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5156),
  [7513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [7515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [7517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [7519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [7521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [7523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_scoped_namespace_declaration, 4, .production_id = 12),
  [7525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1733),
  [7527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4473),
  [7529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [7531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [7533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [7535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4858),
  [7537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4852),
  [7539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_scoped_namespace_declaration, 5, .production_id = 12),
  [7541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4709),
  [7543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5572),
  [7545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [7547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4908),
  [7549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6511),
  [7551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5433),
  [7553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [7555] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2),
  [7557] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2), SHIFT_REPEAT(2919),
  [7560] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2), SHIFT_REPEAT(4568),
  [7563] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2), SHIFT_REPEAT(2961),
  [7566] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2), SHIFT_REPEAT(5156),
  [7569] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2), SHIFT_REPEAT(5158),
  [7572] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2), SHIFT_REPEAT(5166),
  [7575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2), SHIFT_REPEAT(5168),
  [7578] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2), SHIFT_REPEAT(4438),
  [7581] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2), SHIFT_REPEAT(5080),
  [7584] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 2), SHIFT_REPEAT(4709),
  [7587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6607),
  [7589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5434),
  [7591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__nullable_base_type, 1),
  [7593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6472),
  [7595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5432),
  [7597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [7599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_compilation_unit, 5),
  [7601] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_element, 1, .production_id = 2), REDUCE(sym_type_pattern, 1),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1444),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1485),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [7618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1387),
  [7620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1392),
  [7622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1506),
  [7624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [7626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(797),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1364),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [7640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1418),
  [7642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [7644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [7646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 2),
  [7648] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 2), SHIFT_REPEAT(2919),
  [7651] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 2), SHIFT_REPEAT(4568),
  [7654] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 2), SHIFT_REPEAT(2961),
  [7657] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 2), SHIFT_REPEAT(5156),
  [7660] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 2), SHIFT_REPEAT(5158),
  [7663] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 2), SHIFT_REPEAT(5166),
  [7666] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 2), SHIFT_REPEAT(5168),
  [7669] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 2), SHIFT_REPEAT(4438),
  [7672] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 2), SHIFT_REPEAT(5080),
  [7675] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_file_scoped_namespace_declaration, 6, .production_id = 12),
  [7677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [7679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4621),
  [7681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6052),
  [7683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6057),
  [7685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [7687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4871),
  [7689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [7691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5890),
  [7693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5884),
  [7695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4631),
  [7697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4626),
  [7699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6004),
  [7701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5999),
  [7703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5998),
  [7705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [7707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 1, .production_id = 1),
  [7709] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, .production_id = 12),
  [7711] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, .production_id = 29),
  [7713] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_event_field_declaration_repeat1, 2), SHIFT_REPEAT(4578),
  [7716] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1), SHIFT(2959),
  [7719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4843),
  [7721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4953),
  [7723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [7725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4705),
  [7727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4657),
  [7729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5112),
  [7731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4676),
  [7733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5111),
  [7735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4700),
  [7737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4716),
  [7739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4697),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2704),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4659),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5430),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3537),
  [7753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [7755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3612),
  [7757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1645),
  [7759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5118),
  [7761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3619),
  [7763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4656),
  [7765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4409),
  [7767] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 1, .production_id = 1),
  [7769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [7771] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_element, 1, .production_id = 2),
  [7773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6719),
  [7775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [7777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(846),
  [7779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6886),
  [7781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [7783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(975),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [7793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6529),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5071),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5136),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [7801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5224),
  [7803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2801),
  [7805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [7807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3040),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [7813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [7815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1281),
  [7817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4981),
  [7819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2959),
  [7821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6194),
  [7823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [7825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1634),
  [7827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1504),
  [7829] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2), SHIFT(1774),
  [7832] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2), SHIFT(1775),
  [7835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2), SHIFT(3943),
  [7838] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_explicit_interface_specifier, 2),
  [7840] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5036),
  [7842] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6137),
  [7844] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5005),
  [7846] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6163),
  [7848] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4996),
  [7850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4977),
  [7852] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5032),
  [7854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6146),
  [7856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5021),
  [7858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5031),
  [7860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5008),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1159),
  [7864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5012),
  [7866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4979),
  [7868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4957),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(894),
  [7872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4997),
  [7874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5027),
  [7876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5020),
  [7878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5018),
  [7880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5025),
  [7882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4990),
  [7884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(717),
  [7886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4987),
  [7888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4959),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [7894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4976),
  [7896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4918),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [7900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5015),
  [7902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5014),
  [7904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5009),
  [7906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4975),
  [7908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(941),
  [7910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [7912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4967),
  [7914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4906),
  [7916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4983),
  [7918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5024),
  [7920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4978),
  [7922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5026),
  [7924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5006),
  [7926] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [7928] = {.entry = {.count = 1, .reusable = true}}, SHIFT(808),
  [7930] = {.entry = {.count = 1, .reusable = true}}, SHIFT(849),
  [7932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4963),
  [7934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5030),
  [7936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5033),
  [7938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4966),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6504),
  [7942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5035),
  [7944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5037),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [7948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4982),
  [7950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1911),
  [7952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1910),
  [7954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1917),
  [7956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2670),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [7960] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4917),
  [7962] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [7964] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2324),
  [7966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6505),
  [7968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_event_field_declaration_repeat1, 2), SHIFT_REPEAT(4572),
  [7971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6372),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2950),
  [7975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2998),
  [7977] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4636),
  [7979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4639),
  [7981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4642),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5285),
  [7987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5300),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5301),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5307),
  [7993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [7997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1055),
  [7999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6872),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6376),
  [8003] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_directive, 3),
  [8005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [8007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6930),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [8011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5219),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5233),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5372),
  [8017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5374),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5369),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5236),
  [8023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5206),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [8029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5376),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5205),
  [8035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5379),
  [8037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5367),
  [8039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5214),
  [8041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5215),
  [8043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5250),
  [8045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5247),
  [8047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5226),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [8053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5242),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5241),
  [8059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5260),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [8067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5309),
  [8069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5413),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5383),
  [8073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5321),
  [8075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6611),
  [8077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [8081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5239),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5246),
  [8085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5255),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [8089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [8093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5269),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [8099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5295),
  [8103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5304),
  [8105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5199),
  [8107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5240),
  [8109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6539),
  [8111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [8113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [8115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [8117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5172),
  [8119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5411),
  [8121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6604),
  [8123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5302),
  [8125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5293),
  [8127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5297),
  [8129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5314),
  [8131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5152),
  [8133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5283),
  [8135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [8137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5399),
  [8139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [8141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [8143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [8145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [8147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5417),
  [8149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [8151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6543),
  [8153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [8155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5303),
  [8157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5163),
  [8159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [8161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [8163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [8165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5161),
  [8167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [8169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [8171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [8173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [8175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [8177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [8179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5350),
  [8181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5287),
  [8183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5155),
  [8185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5193),
  [8187] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_compilation_unit_repeat5, 1),
  [8189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__namespace_member_declaration, 1),
  [8191] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_declaration, 1),
  [8193] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_file_scoped_namespace_declaration_repeat1, 1),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5296),
  [8197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5294),
  [8199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5292),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5289),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [8205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [8207] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_attribute_target_specifier, 2),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6708),
  [8213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6366),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5415),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5409),
  [8219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4628),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6583),
  [8225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6584),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6700),
  [8229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6369),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6585),
  [8235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6793),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6793),
  [8239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4506),
  [8245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5228),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1522),
  [8251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1523),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [8257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1260),
  [8263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1259),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [8269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1527),
  [8275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [8277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [8279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [8281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1542),
  [8283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [8285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [8287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1255),
  [8289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1543),
  [8291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [8293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1534),
  [8295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [8297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [8299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [8301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1533),
  [8303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(875),
  [8305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [8307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(826),
  [8309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [8311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [8313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1545),
  [8315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [8317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [8319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1346),
  [8321] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 1),
  [8323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1076),
  [8325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3204),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3162),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(829),
  [8331] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2), SHIFT_REPEAT(1262),
  [8334] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2), SHIFT_REPEAT(4545),
  [8337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2), SHIFT_REPEAT(4506),
  [8340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2), SHIFT_REPEAT(5228),
  [8343] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2), SHIFT_REPEAT(606),
  [8346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 2),
  [8348] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [8350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [8352] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [8354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1657),
  [8356] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5066),
  [8358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5232),
  [8360] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1656),
  [8362] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1), SHIFT(2612),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3999),
  [8367] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1), SHIFT(2380),
  [8370] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1), SHIFT(2473),
  [8373] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1), REDUCE(sym__contextual_keywords, 1),
  [8376] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1063),
  [8378] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2942),
  [8380] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6002),
  [8382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6002),
  [8384] = {.entry = {.count = 1, .reusable = false}}, SHIFT_EXTRA(),
  [8386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5431),
  [8388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [8390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1280),
  [8392] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3018),
  [8394] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5931),
  [8396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5931),
  [8398] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2724),
  [8400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [8402] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2266),
  [8404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [8406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [8408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [8410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [8412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2758),
  [8414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [8416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [8418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6822),
  [8420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [8422] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2182),
  [8424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2191),
  [8426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [8428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1560),
  [8430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2),
  [8432] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(342),
  [8435] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 2), SHIFT_REPEAT(6822),
  [8438] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2140),
  [8440] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__simple_name, 1), REDUCE(sym_type_parameter, 1),
  [8443] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2894),
  [8445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2), SHIFT_REPEAT(1280),
  [8448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2),
  [8450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2), SHIFT_REPEAT(5931),
  [8453] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 2), SHIFT_REPEAT(5931),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [8458] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by_clause, 3),
  [8460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2), SHIFT_REPEAT(1063),
  [8463] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2),
  [8465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2), SHIFT_REPEAT(6002),
  [8468] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 2), SHIFT_REPEAT(6002),
  [8471] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_order_by_clause_repeat1, 2), SHIFT_REPEAT(617),
  [8474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_order_by_clause_repeat1, 2),
  [8476] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_order_by_clause, 2),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6538),
  [8480] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ordering, 2),
  [8482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_constraint, 1, .production_id = 2),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [8486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_list, 2),
  [8488] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 2),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [8492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat2, 2),
  [8494] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__query_body_repeat1, 1),
  [8496] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__query_clause, 1),
  [8498] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_clause, 10),
  [8500] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_join_into_clause, 2),
  [8502] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraints_clause, 5, .production_id = 96),
  [8504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [8506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [8508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6820),
  [8510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4498),
  [8512] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraints_clause, 4, .production_id = 63),
  [8514] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__contextual_keywords, 1), SHIFT(4145),
  [8517] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__contextual_keywords, 1), SHIFT(28),
  [8520] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__contextual_keywords, 1), SHIFT(829),
  [8523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [8525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [8527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(28),
  [8529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 1),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6087),
  [8533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2697),
  [8535] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 4),
  [8537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_constraints_clause_repeat1, 2),
  [8539] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_constraints_clause_repeat1, 2), SHIFT_REPEAT(3484),
  [8542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [8544] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_method_declaration_repeat1, 2),
  [8546] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_method_declaration_repeat1, 2), SHIFT_REPEAT(5066),
  [8549] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_variable_declarator, 1), REDUCE(sym_tuple_element, 2, .production_id = 10),
  [8552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2807),
  [8554] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_pattern, 3),
  [8556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_binary_expression, 3, .production_id = 20),
  [8558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_string_text, 1),
  [8560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_string_text, 1),
  [8562] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_record_base_repeat1, 2),
  [8564] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_record_base_repeat1, 2), SHIFT_REPEAT(5334),
  [8567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 4),
  [8569] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter_list, 3),
  [8571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6139),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4616),
  [8575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [8577] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_parameter, 2),
  [8579] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 5),
  [8581] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 5),
  [8583] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, .production_id = 42),
  [8585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [8587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [8589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(378),
  [8591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [8593] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subpattern, 1),
  [8595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [8597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [8599] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, .production_id = 10),
  [8601] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 3),
  [8603] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 3),
  [8605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, .production_id = 27),
  [8607] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat2, 2), SHIFT_REPEAT(4528),
  [8610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4630),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4629),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4627),
  [8616] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_elif_directive, 2),
  [8618] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_if_directive, 2),
  [8620] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1),
  [8622] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, .production_id = 9),
  [8624] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preproc_expression, 1, .production_id = 8),
  [8626] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_subpattern, 2),
  [8628] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolated_verbatim_string_text, 1),
  [8630] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolated_verbatim_string_text, 1),
  [8632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_unary_expression, 2, .production_id = 25),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6014),
  [8636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [8638] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_interpolation, 4),
  [8640] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation, 4),
  [8642] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_preproc_parenthesized_expression, 3),
  [8644] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_parameter, 3),
  [8646] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_constraint, 3),
  [8648] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 2),
  [8650] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 1),
  [8652] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat2, 1),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1737),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [8658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(381),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4863),
  [8664] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_verbatim_string_content, 1),
  [8666] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_verbatim_string_content, 1),
  [8668] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 1),
  [8670] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_interpolated_string_expression_repeat1, 1),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6029),
  [8674] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__interpolated_string_content, 1),
  [8676] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__interpolated_string_content, 1),
  [8678] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 4),
  [8680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_list, 3),
  [8682] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_parameter, 1),
  [8684] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, .production_id = 30),
  [8686] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 3),
  [8688] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter_constraint, 2),
  [8690] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_for_statement_repeat1, 2), SHIFT_REPEAT(784),
  [8693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_base, 5),
  [8695] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2),
  [8697] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_variable_declaration_repeat1, 2), SHIFT_REPEAT(4911),
  [8700] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 2), SHIFT_REPEAT(6221),
  [8703] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 2),
  [8705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5312),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3622),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6445),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3103),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3008),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3050),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [8725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter_list, 1),
  [8727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2181),
  [8729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6413),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6413),
  [8733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2757),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4699),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4713),
  [8739] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 2, .production_id = 10), REDUCE(sym_tuple_element, 2, .production_id = 10),
  [8742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5210),
  [8744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [8746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2442),
  [8748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3553),
  [8750] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [8752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [8754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(42),
  [8756] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_base_list, 3),
  [8758] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 2, .production_id = 2),
  [8760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [8762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [8764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [8766] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declaration, 3, .production_id = 2),
  [8768] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3106),
  [8770] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2208),
  [8772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3656),
  [8774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3030),
  [8776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [8778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [8780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2362),
  [8782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2363),
  [8784] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2210),
  [8786] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2314),
  [8788] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3015),
  [8790] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [8792] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2142),
  [8794] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [8796] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2723),
  [8798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [8800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [8802] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2), SHIFT_REPEAT(263),
  [8805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_positional_pattern_clause_repeat1, 2),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2508),
  [8809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2509),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(36),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [8815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5389),
  [8821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2601),
  [8827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2802),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [8831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_primary_constructor_base_type, 2),
  [8833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2619),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2968),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2974),
  [8841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2),
  [8843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(6413),
  [8846] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 2), SHIFT_REPEAT(6413),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5290),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2837),
  [8853] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__formal_parameter_list, 2),
  [8855] = {.entry = {.count = 3, .reusable = true}}, REDUCE(sym_parameter, 2, .production_id = 10), REDUCE(sym_tuple_element, 2, .production_id = 10), REDUCE(sym_declaration_expression, 2, .production_id = 10),
  [8859] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_parameter, 2, .production_id = 10), REDUCE(sym_declaration_expression, 2, .production_id = 10),
  [8862] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_declaration_expression, 2, .production_id = 10), REDUCE(sym_parameter, 3, .production_id = 27),
  [8865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [8867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2943),
  [8869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [8871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [8873] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__formal_parameter_list_repeat1, 2), SHIFT_REPEAT(3178),
  [8876] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__formal_parameter_list_repeat1, 2),
  [8878] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5291),
  [8880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2987),
  [8882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [8884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [8886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2848),
  [8888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [8890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [8892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2268),
  [8894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2895),
  [8896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [8898] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_method_declaration_repeat1, 1),
  [8900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [8902] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [8904] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2912),
  [8906] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_argument_list_repeat1, 1),
  [8908] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_enum_member_declaration_list_repeat1, 2), SHIFT_REPEAT(4828),
  [8911] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_enum_member_declaration_list_repeat1, 2),
  [8913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [8915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2177),
  [8917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(489),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [8921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [8923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [8925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [8929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2), SHIFT_REPEAT(4813),
  [8932] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_variable_designation_repeat1, 2),
  [8934] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2), SHIFT_REPEAT(3557),
  [8937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_pointer_type_repeat1, 2),
  [8939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4696),
  [8941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6074),
  [8943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4734),
  [8945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6786),
  [8947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3557),
  [8949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [8951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2748),
  [8953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6614),
  [8955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(260),
  [8957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [8959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [8961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [8963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2709),
  [8965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [8967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [8969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [8971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [8973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [8975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2690),
  [8977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [8979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(635),
  [8981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [8983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [8985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4658),
  [8987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [8989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(442),
  [8991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [8993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4573),
  [8995] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, .production_id = 10),
  [8997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [8999] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_array, 3),
  [9001] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, .production_id = 11),
  [9003] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bracketed_argument_list_repeat1, 2), SHIFT_REPEAT(442),
  [9006] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_bracketed_argument_list_repeat1, 2),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [9010] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2), SHIFT_REPEAT(4694),
  [9013] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_list_repeat1, 2),
  [9015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4668),
  [9017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [9019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2831),
  [9021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2676),
  [9023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2827),
  [9025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1791),
  [9027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2826),
  [9029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6569),
  [9031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4671),
  [9033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4813),
  [9035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2864),
  [9037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_with_initializer_expression_repeat1, 2), SHIFT_REPEAT(5137),
  [9040] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_with_initializer_expression_repeat1, 2),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4726),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5109),
  [9046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [9048] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 1, .production_id = 1),
  [9050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [9052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6594),
  [9054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4694),
  [9056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1640),
  [9058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2739),
  [9060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4675),
  [9062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [9064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [9066] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 3, .production_id = 12),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [9070] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_switch_expression_repeat1, 2), SHIFT_REPEAT(269),
  [9073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_expression_repeat1, 2),
  [9075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [9077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [9079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2677),
  [9081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2675),
  [9083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2673),
  [9085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(628),
  [9087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [9089] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_switch_body_repeat1, 1),
  [9091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6019),
  [9093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [9095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [9097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2787),
  [9099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [9101] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_function_pointer_unmanaged_calling_convention_list_repeat1, 2), SHIFT_REPEAT(4734),
  [9104] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_function_pointer_unmanaged_calling_convention_list_repeat1, 2),
  [9106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(45),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2076),
  [9112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4661),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2893),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3087),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [9120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2796),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2905),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(267),
  [9128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2922),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3065),
  [9134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4881),
  [9140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5899),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(497),
  [9146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [9152] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_variable_declarator, 3),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6516),
  [9158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(502),
  [9160] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [9164] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2), SHIFT_REPEAT(4696),
  [9167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_parameter_list_repeat1, 2),
  [9169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [9171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [9173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2980),
  [9175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4662),
  [9177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 5, .production_id = 42),
  [9179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4672),
  [9181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2679),
  [9183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [9185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [9187] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_bracketed_argument_list_repeat1, 2), SHIFT_REPEAT(439),
  [9190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [9192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6494),
  [9194] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2), SHIFT_REPEAT(4452),
  [9197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_type_repeat1, 2),
  [9199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [9201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2296),
  [9203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [9205] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor_initializer, 3),
  [9207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [9209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4679),
  [9211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [9213] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_array_rank_specifier_repeat1, 2), SHIFT_REPEAT(533),
  [9216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [9218] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [9220] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [9222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_attribute_argument_list_repeat1, 2), SHIFT_REPEAT(492),
  [9225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_attribute_argument_list_repeat1, 2),
  [9227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2354),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6384),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6646),
  [9235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6608),
  [9237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6011),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [9241] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_initializer_expression, 1),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5916),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2098),
  [9247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [9249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5099),
  [9251] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_directive, 4, .production_id = 40),
  [9253] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_directive, 5),
  [9255] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_directive, 4),
  [9257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(266),
  [9259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [9261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1633),
  [9263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6589),
  [9265] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, .production_id = 27),
  [9267] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pragma_directive, 5, .production_id = 40),
  [9269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6866),
  [9271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullable_directive, 2),
  [9273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [9275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [9277] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, .production_id = 29),
  [9279] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__parameter_array, 4),
  [9281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 4, .production_id = 30),
  [9283] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_anonymous_object_creation_expression_repeat1, 2), SHIFT_REPEAT(546),
  [9286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_anonymous_object_creation_expression_repeat1, 2),
  [9288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [9290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1806),
  [9292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [9294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [9296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [9298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_pragma_directive_repeat1, 2), SHIFT_REPEAT(5099),
  [9301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pragma_directive_repeat1, 2),
  [9303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [9305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [9309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4738),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2169),
  [9313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4669),
  [9315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [9319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2084),
  [9321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6064),
  [9323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [9325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2126),
  [9327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [9329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [9331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(486),
  [9333] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_string_literal_repeat1, 1),
  [9335] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_string_literal_repeat1, 1),
  [9337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [9339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [9341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4680),
  [9343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6481),
  [9345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [9347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [9349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [9351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(134),
  [9353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [9355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [9357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [9359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [9361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [9363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(121),
  [9365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [9367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [9369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [9371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [9373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4677),
  [9375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2167),
  [9377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(98),
  [9379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2131),
  [9381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(91),
  [9383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4674),
  [9385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3610),
  [9387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4725),
  [9389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4566),
  [9391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6954),
  [9393] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_calling_convention, 1),
  [9395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4723),
  [9397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3229),
  [9399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [9401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(693),
  [9403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2320),
  [9405] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2), SHIFT_REPEAT(4881),
  [9408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_pattern_repeat1, 2),
  [9410] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [9412] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_declaration_expression, 2, .production_id = 10),
  [9414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(251),
  [9416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [9418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [9420] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6473),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [9424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_with_initializer_expression, 2),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [9428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [9430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1295),
  [9432] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_enum_member_declaration, 2, .production_id = 12),
  [9434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(487),
  [9436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2340),
  [9438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [9440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [9442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [9444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [9446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6571),
  [9448] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parameter, 2, .production_id = 1),
  [9450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3024),
  [9452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6743),
  [9454] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_tuple_element, 2, .production_id = 10), REDUCE(sym_declaration_expression, 2, .production_id = 10),
  [9457] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_declaration, 4, .production_id = 30),
  [9459] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 1),
  [9461] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 3),
  [9463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [9465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5604),
  [9467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4873),
  [9469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [9471] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6802),
  [9473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [9475] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 2),
  [9477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4892),
  [9479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4943),
  [9481] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_declaration, 3, .production_id = 3),
  [9483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6835),
  [9485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(440),
  [9487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [9489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [9491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1638),
  [9493] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bracketed_parameter_list, 3),
  [9495] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute, 2, .production_id = 1),
  [9497] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_unmanaged_calling_convention, 1),
  [9499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5605),
  [9501] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_element, 2, .production_id = 10),
  [9503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6877),
  [9505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6595),
  [9507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [9509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [9511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6880),
  [9513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4931),
  [9515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [9517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4872),
  [9519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [9521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6663),
  [9523] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_region_directive, 1),
  [9525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6655),
  [9527] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endregion_directive, 1),
  [9529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6609),
  [9531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6642),
  [9533] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 4),
  [9535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4903),
  [9537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_attribute_argument_list, 3),
  [9539] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_parameter, 2),
  [9541] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_pragma_directive_repeat1, 2, .production_id = 88),
  [9543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6867),
  [9545] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_directive, 2),
  [9547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4994),
  [9549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [9551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [9553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1642),
  [9555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [9557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(673),
  [9559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [9561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5950),
  [9563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [9565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [9567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [9569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5956),
  [9571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [9573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [9575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [9577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [9579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [9581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6868),
  [9583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [9585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [9587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1605),
  [9589] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_warning_directive, 2),
  [9591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [9593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [9595] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_error_directive, 2),
  [9597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4678),
  [9599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4747),
  [9601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_endregion_directive, 2),
  [9603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [9605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [9607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [9609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [9611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2528),
  [9613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2573),
  [9615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [9617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_region_directive, 2),
  [9619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [9621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [9623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_undef_directive, 2),
  [9625] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_define_directive, 2),
  [9627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(646),
  [9629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [9631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [9633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5429),
  [9635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [9637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [9639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [9641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6690),
  [9643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [9645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [9647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [9649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [9651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(618),
  [9653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [9655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(670),
  [9657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [9659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [9661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [9663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6647),
  [9665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6652),
  [9667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [9669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [9671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6978),
  [9673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1687),
  [9675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [9677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [9679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2614),
  [9681] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_else_directive, 1),
  [9683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [9685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [9687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1726),
  [9689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(847),
  [9691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [9693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [9695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(662),
  [9697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [9699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [9701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [9703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2388),
  [9705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3646),
  [9707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2626),
  [9709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [9711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1668),
  [9713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [9715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [9717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [9719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [9721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [9723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1596),
  [9725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [9727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [9729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [9731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6475),
  [9733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [9735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [9737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [9739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [9741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [9743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [9745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(669),
  [9747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [9749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [9751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(619),
  [9753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(672),
  [9755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [9757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [9759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [9761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [9763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [9765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [9767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [9769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [9771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [9773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [9775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [9777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(676),
  [9779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1041),
  [9781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2921),
  [9783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [9785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [9787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [9789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(684),
  [9791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1697),
  [9793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1671),
  [9795] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_unmanaged_calling_convention_list, 4),
  [9797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [9799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [9801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [9803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4665),
  [9805] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__overloadable_operator, 1),
  [9807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [9809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [9811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [9813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [9815] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [9817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [9819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [9821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [9823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1264),
  [9825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1175),
  [9827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [9829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [9831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1263),
  [9833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [9835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [9837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [9839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [9841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6900),
  [9843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [9845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3529),
  [9847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [9849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [9851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [9853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [9855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [9857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [9859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [9861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1271),
  [9863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [9865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [9867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [9869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [9871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [9873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1597),
  [9875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3107),
  [9877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [9879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [9881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [9883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(579),
  [9885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [9887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1663),
  [9889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [9891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [9893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [9897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1278),
  [9899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4499),
  [9901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4495),
  [9903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [9905] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_calling_convention, 2),
  [9907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [9909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [9911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [9913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4913),
  [9915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1274),
  [9917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [9919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(246),
  [9921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [9923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2718),
  [9925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [9927] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_nullable_directive, 3),
  [9929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_line_directive, 3),
  [9931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6678),
  [9933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [9935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [9937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [9939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [9941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2365),
  [9943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [9945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3645),
  [9947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [9949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2722),
  [9953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [9955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6564),
  [9957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2688),
  [9959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [9961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [9963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(680),
  [9965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [9967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [9969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [9971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [9973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [9975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [9977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [9979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1343),
  [9981] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_interpolation_format_clause, 2),
  [9983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6005),
  [9985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1297),
  [9987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [9989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6744),
  [9991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4877),
  [9993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [9995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [9997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1304),
  [9999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [10001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [10003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [10005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [10007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [10009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6134),
  [10011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3403),
  [10013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6480),
  [10015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1571),
  [10017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(612),
  [10019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [10021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1734),
  [10023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [10025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1362),
  [10027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [10029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1565),
  [10031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [10033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1561),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(56),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [10043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [10045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1337),
  [10047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4922),
  [10049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1338),
  [10051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(689),
  [10053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1729),
  [10055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6602),
  [10057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2760),
  [10059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [10061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [10063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1683),
  [10065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(248),
  [10067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4869),
  [10069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [10071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [10073] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_function_pointer_unmanaged_calling_convention_list, 3),
  [10075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [10077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6115),
  [10079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [10081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6096),
  [10083] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_catch_filter_clause, 4),
  [10085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6130),
  [10087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [10089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [10091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [10093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1544),
  [10095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6925),
  [10097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [10099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [10101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1694),
  [10103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [10105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2576),
  [10107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6596),
  [10109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(812),
  [10111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [10113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [10115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6527),
  [10117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [10119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__preprocessor_call, 3),
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_c_sharp_external_scanner_create(void);
void tree_sitter_c_sharp_external_scanner_destroy(void *);
bool tree_sitter_c_sharp_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_c_sharp_external_scanner_serialize(void *, char *);
void tree_sitter_c_sharp_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_c_sharp(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym__identifier_token,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_c_sharp_external_scanner_create,
      tree_sitter_c_sharp_external_scanner_destroy,
      tree_sitter_c_sharp_external_scanner_scan,
      tree_sitter_c_sharp_external_scanner_serialize,
      tree_sitter_c_sharp_external_scanner_deserialize,
    },
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
